-- fileIn("s8/library/StandardLibrary.st");
smalltalk:addClass("LuaBasicFunctions",smalltalk.NativeObject,smalltalk:newArray({}),"StandardLibrary")

smalltalk:bind(smalltalk.Lua["$klass"],"basic",0
,function(self)
return ((smalltalk.LuaBasicFunctions):new())
;
end
,"accessing","basic\r\n\t\" Returns the wrapper to Lua basic functions. \"\r\n\r\n\t^LuaBasicFunctions new","function(self)\r\nreturn ((smalltalk.LuaBasicFunctions):new())\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"initializeHandle",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(function()
	local _s8_value=((smalltalk.Smalltalk):global())
	self['@handle']=_s8_value; return _s8_value
end)()
;
(function() if ((((((self['@handle']))==nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_("Missing access to Global scope"))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"initialization","initializeHandle\r\n\t\" Private - Initialize the native handle. \"\r\n\r\n\thandle := Smalltalk global.\r\n\thandle isNil ifTrue: [ ^self error: 'Missing access to Global scope' ].","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):global())\r\n\tself['@handle']=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((self['@handle']))==nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(\"Missing access to Global scope\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"assert:message:",0
,function(self,value,message)
return (assert(value,message))
;
end
,"assertions","assert: value message: message\r\n\t\" Trigger error if the value is false (i.e., nil or false); otherwise, returns all its arguments.\r\n\tIn case of error, message is the error object; when nil, it defaults to assertion failed\r\n\t\"\r\n\r\n\t^{lua'assert(value,message)'}","function(self,value,message)\r\nreturn (assert(value,message))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"collectgarbage:with:",0
,function(self,option,arg)
return (collectgarbage(option,arg))
;
end
,"gc","collectgarbage: option with: arg\r\n\t\" Interface to the garbage collector.\r\n\tIt performs different functions according to option.\r\n\t\"\r\n\r\n\t^{lua'collectgarbage(option,arg)'}","function(self,option,arg)\r\nreturn (collectgarbage(option,arg))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"collectgarbage:",0
,function(self,option)
return (collectgarbage(option))
;
end
,"gc","collectgarbage: option\r\n\t\" Interface to the garbage collector.\r\n\tIt performs different functions according to option.\r\n\t\"\r\n\r\n\t^{lua'collectgarbage(option)'}","function(self,option)\r\nreturn (collectgarbage(option))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"fullGC",0
,function(self)
return ((self):collectgarbage_("collect"))
;
end
,"gc","fullGC\r\n\t\" Performs a full garbage-collection cycle. \"\r\n\r\n\t^self collectgarbage: #collect","function(self)\r\nreturn ((self):collectgarbage_(\"collect\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"gc",0
,function(self)
return ((self):collectgarbage_("collect"))
;
end
,"gc","gc\r\n\t\" Performs a full garbage-collection cycle. \"\r\n\r\n\t^self collectgarbage: #collect","function(self)\r\nreturn ((self):collectgarbage_(\"collect\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"stopGC",0
,function(self)
return ((self):collectgarbage_("stop"))
;
end
,"gc","stopGC\r\n\t\" Stops automatic execution of the garbage collector.\r\n\tThe collector will run only when explicitly invoked, until a call to restart it.\r\n\t\"\r\n\r\n\t^self collectgarbage: #stop","function(self)\r\nreturn ((self):collectgarbage_(\"stop\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"restartGC",0
,function(self)
return ((self):collectgarbage_("restart"))
;
end
,"gc","restartGC\r\n\t\" Restarts automatic execution of the garbage collector. \"\r\n\r\n\t^self collectgarbage: #restart","function(self)\r\nreturn ((self):collectgarbage_(\"restart\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"countGC",0
,function(self)
return ((self):collectgarbage_("count"))
;
end
,"gc","countGC\r\n\t\" Returns the total memory in use by Lua in Kbytes.\r\n\tThe value has a fractional part, so that it multiplied by 1024 gives the exact number of bytes in use by Lua (except for overflows).\r\n\t\"\r\n\r\n\t^self collectgarbage: #count","function(self)\r\nreturn ((self):collectgarbage_(\"count\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"kBytesInUse",0
,function(self)
return ((self):collectgarbage_("count"))
;
end
,"gc","kBytesInUse\r\n\t\" Returns the total memory in use by Lua in Kbytes. \"\r\n\r\n\t^self collectgarbage: #count","function(self)\r\nreturn ((self):collectgarbage_(\"count\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"stepGC:",0
,function(self,size)
return ((self):collectgarbage_with_("step", size))
;
end
,"gc","stepGC: size\r\n\t\" Performs a garbage-collection step.\r\n\tThe step size is controlled by arg.\r\n\tWith a zero value, the collector will perform one basic (indivisible) step.\r\n\tFor non-zero values, the collector will perform as if that amount of memory (in KBytes) had been allocated by Lua.\r\n\tReturns true if the step finished a collection cycle.\r\n\t\"\r\n\r\n\t^self collectgarbage: #step with: size","function(self,size)\r\nreturn ((self):collectgarbage_with_(\"step\", size))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"pauseGC:",0
,function(self,value)
return ((self):collectgarbage_with_("setpause", value))
;
end
,"gc","pauseGC: value\r\n\t\" Sets the new value for the pause of the collector\r\n\tReturns the previous value for pause.\r\n\t\"\r\n\r\n\t^self collectgarbage: #setpause with: value","function(self,value)\r\nreturn ((self):collectgarbage_with_(\"setpause\", value))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"stepGC:",0
,function(self,value)
return ((self):collectgarbage_with_("setstepmul", value))
;
end
,"gc","stepGC: value\r\n\t\" Sets the new value for the step multiplier of the collector.\r\n\tReturns the previous value for step.\r\n\t\"\r\n\r\n\t^self collectgarbage: #setstepmul with: value","function(self,value)\r\nreturn ((self):collectgarbage_with_(\"setstepmul\", value))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"isRunningGC",0
,function(self)
return ((self):collectgarbage_("isrunning"))
;
end
,"gc","isRunningGC\r\n\t\" Returns a boolean that tells whether the collector is running (i.e., not stopped). \"\r\n\r\n\t^self collectgarbage: #isrunning","function(self)\r\nreturn ((self):collectgarbage_(\"isrunning\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"isCollecting",0
,function(self)
return ((self):collectgarbage_("isrunning"))
;
end
,"gc","isCollecting\r\n\t\" Returns a boolean that tells whether the collector is running (i.e., not stopped). \"\r\n\r\n\t^self collectgarbage: #isrunning","function(self)\r\nreturn ((self):collectgarbage_(\"isrunning\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"doFile:",0
,function(self,fileName)
return (dofile(fileName))
;
end
,"evaluating","doFile: fileName\r\n\t\" Opens the named file and executes its contents as a Lua chunk.\r\n\tWhen fileName isNil, dofile executes the contents of the standard input (stdin).\r\n\tReturns all values returned by the chunk.\r\n\tIn case of errors, dofile propagates the error (that is, dofile does not run in protected mode).\r\n\t\"\r\n\r\n\t^{lua'dofile(fileName)'}","function(self,fileName)\r\nreturn (dofile(fileName))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"error:level:",0
,function(self,message,level)
return (error(message,level))
;
end
,"error","error: message level: level\r\n\t\" Terminates the last protected function called and returns message as the error object.\r\n\tThis method never returns.\r\n\tUsually, error adds some information about the error position at the beginning of the message, if the message is a string.\r\n\tThe level specifies how to get the error position.\r\n\tWith level=1 (the default), the error position is where the error function was called.\r\n\tLevel=2 points the error to where the function that called error was called; and so on.\r\n\tPassing a level=0 avoids the addition of error position information to the message.\r\n\t\"\r\n\r\n\t^{lua'error(message,level)'}","function(self,message,level)\r\nreturn (error(message,level))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"getmetatable:",0
,function(self,object)
return (getmetatable(object))
;
end
,"utilities","getmetatable: object\r\n\t\" If object does not have a metatable, returns nil.\r\n\tOtherwise, if the object's metatable has a __metatable field, returns the associated value.\r\n\tOtherwise, returns the metatable of the given object.\r\n\t\"\r\n\r\n\t^{lua'getmetatable(object)'}","function(self,object)\r\nreturn (getmetatable(object))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"ipairs:",0
,function(self,t)
return (ipairs(t))
;
end
,"utilities","ipairs: t\r\n\t\" Returns three values (an iterator function, the table t, and 0) so that the construction\r\n\t\tfor i,v in ipairs(t) do body end\r\n\twill iterate over the keyvalue pairs (1,t[1]), (2,t[2]), ..., up to the first nil value.\r\n\t\"\r\n\r\n\t^{lua'ipairs(t)'}","function(self,t)\r\nreturn (ipairs(t))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"pairs:",0
,function(self,t)
return (pairs(t))
;
end
,"utilities","pairs: t\r\n\t\" Returns three values (the next function, the table t, and nil) so that the construction\r\n\t\tfor i,v in pairs(t) do body end\r\n\twill iterate over the keyvalue pairs of t\r\n\t\"\r\n\r\n\t^{lua'pairs(t)'}","function(self,t)\r\nreturn (pairs(t))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"load:chunkname:mode:env:",0
,function(self,chunk,chunkname,mode,env)
return (load(chunk,chunkname,mode,env))
;
end
,"utilities","load: chunk chunkname: chunkname mode: mode env: env\r\n\t\" Loads a chunk. \"\r\n\r\n\t^{lua'load(chunk,chunkname,mode,env)'}","function(self,chunk,chunkname,mode,env)\r\nreturn (load(chunk,chunkname,mode,env))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"load:chunkname:mode:",0
,function(self,chunk,chunkname,mode)
return (load(chunk,chunkname,mode))
;
end
,"utilities","load: chunk chunkname: chunkname mode: mode\r\n\t\" Loads a chunk. \"\r\n\r\n\t^{lua'load(chunk,chunkname,mode)'}","function(self,chunk,chunkname,mode)\r\nreturn (load(chunk,chunkname,mode))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"load:chunkname:",0
,function(self,chunk,chunkname)
return (load(chunk,chunkname))
;
end
,"utilities","load: chunk chunkname: chunkname\r\n\t\" Loads a chunk. \"\r\n\r\n\t^{lua'load(chunk,chunkname)'}","function(self,chunk,chunkname)\r\nreturn (load(chunk,chunkname))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"load:",0
,function(self,chunk)
return (load(chunk))
;
end
,"utilities","load: chunk\r\n\t\" Loads a chunk. \"\r\n\r\n\t^{lua'load(chunk)'}","function(self,chunk)\r\nreturn (load(chunk))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"loadfile:mode:env:",0
,function(self,filename,mode,env)
return (loadfile(filename,mode,env))
;
end
,"utilities","loadfile: filename mode: mode env: env\r\n\t\" Similar to load, but gets the chunk from file filename or from the standard input, if no filename is given. \"\r\n\r\n\t^{lua'loadfile(filename,mode,env)'}","function(self,filename,mode,env)\r\nreturn (loadfile(filename,mode,env))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"loadfile:mode:",0
,function(self,filename,mode)
return (loadfile(filename,mode))
;
end
,"utilities","loadfile: filename mode: mode\r\n\t\" Similar to load, but gets the chunk from file filename or from the standard input, if no filename is given. \"\r\n\r\n\t^{lua'loadfile(filename,mode)'}","function(self,filename,mode)\r\nreturn (loadfile(filename,mode))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"loadfile:",0
,function(self,filename)
return (loadfile(filename))
;
end
,"utilities","loadfile: filename\r\n\t\" Similar to load, but gets the chunk from file filename or from the standard input, if no filename is given. \"\r\n\r\n\t^{lua'loadfile(filename)'}","function(self,filename)\r\nreturn (loadfile(filename))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"next:index:",0
,function(self,table,index)
return (next(table,index))
;
end
,"utilities","next: table index: index\r\n\t\" Traverse a field of a table. \"\r\n\r\n\t^{lua'next(table,index)'}","function(self,table,index)\r\nreturn (next(table,index))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"next:",0
,function(self,table)
return (next(table))
;
end
,"utilities","next: table\r\n\t\" Returns an index to initial field of a table and its associated value. \"\r\n\r\n\t^{lua'next(table)'}","function(self,table)\r\nreturn (next(table))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"rawequal:to:",0
,function(self,v1,v2)
return (rawequal(v1,v2))
;
end
,"utilities","rawequal: v1 to: v2\r\n\t\" Checks whether v1 is equal to v2, without activating the __eq metamethod.\r\n\tReturns a boolean.\r\n\t\"\r\n\r\n\t^{lua'rawequal(v1,v2)'}","function(self,v1,v2)\r\nreturn (rawequal(v1,v2))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"rawget:index:",0
,function(self,table,index)
return (rawget(table,index))
;
end
,"utilities","rawget: table index: index\r\n\t\" Returns the value of table[index], without invoking the __index metamethod.\r\n\ttable must be a table; index may be any value. \"\r\n\r\n\t^{lua'rawget(table,index)'}","function(self,table,index)\r\nreturn (rawget(table,index))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"rawlen:",0
,function(self,v)
return (rawlen(v))
;
end
,"utilities","rawlen: v\r\n\t\" Returns the length of the object v, which must be a table or a string, without invoking the __len metamethod.\r\n\tReturns an integer. \"\r\n\r\n\t^{lua'rawlen(v)'}","function(self,v)\r\nreturn (rawlen(v))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"rawset:index:value:",0
,function(self,table,index,value)
return (rawset(table,index,value))
;
end
,"utilities","rawset: table index: index value: value\r\n\t\" Sets the value of table[index] to value, without invoking the __newindex metamethod.\r\n\ttable must be a table, index any value different from nil and NaN, and value any Lua value.\r\n\tReturns table. \"\r\n\r\n\t^{lua'rawset(table,index,value)'}","function(self,table,index,value)\r\nreturn (rawset(table,index,value))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"setmetatable:to:",0
,function(self,table,metatable)
return (setmetatable(table,metatable))
;
end
,"utilities","setmetatable: table to: metatable\r\n\t\" Sets the metatable for the given table.\r\n\t(To change the metatable of other types from Lua code, you must use the debug library)\r\n\tIf metatable is nil, removes the metatable of the given table.\r\n\tIf the original metatable has a __metatable field, raises an error.\r\n\tReturns table.\r\n\t\"\r\n\r\n\t^{lua'setmetatable(table,metatable)'}","function(self,table,metatable)\r\nreturn (setmetatable(table,metatable))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"tonumber:base:",0
,function(self,e,base)
return (tonumber(e,base))
;
end
,"utilities","tonumber: e base: base\r\n\r\n\t^{lua'tonumber(e,base)'}","function(self,e,base)\r\nreturn (tonumber(e,base))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"tonumber:",0
,function(self,e)
return (tonumber(e))
;
end
,"utilities","tonumber: e\r\n\r\n\t^{lua'tonumber(e)'}","function(self,e)\r\nreturn (tonumber(e))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"tostring:",0
,function(self,v)
return (tostring(v))
;
end
,"utilities","tostring: v\r\n\t\" Receives a value of any type and returns the result of converting to a string in a human-readable format. \"\r\n\r\n\t^{lua'tostring(v)'}","function(self,v)\r\nreturn (tostring(v))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"type:",0
,function(self,v)
return (type(v))
;
end
,"utilities","type: v\r\n\t\" Returns the type of v. \"\r\n\r\n\t^{lua'type(v)'}","function(self,v)\r\nreturn (type(v))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaBasicFunctions,"version",0
,function(self)
return ((((self):handle())["_VERSION"]))
;
end
,"utilities","version\r\n\t\" Returns a string containing the running Lua version. \"\r\n\r\n\t^self handle basicAt: #_VERSION","function(self)\r\nreturn ((((self):handle())[\"_VERSION\"]))\r\n;\r\nend")

smalltalk:addClass("Coroutine",smalltalk.NativeObject,smalltalk:newArray({}),"StandardLibrary")

smalltalk:bind(smalltalk.Lua["$klass"],"coroutine",0
,function(self)
return (smalltalk.Coroutine)
;
end
,"accessing","coroutine\r\n\t\" Returns the wrapper to library support (aClass). \"\r\n\r\n\t^Coroutine","function(self)\r\nreturn (smalltalk.Coroutine)\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine["$klass"],"nativeLibrary",0
,function(self)
return (coroutine)
;
end
,"accessing","nativeLibrary\r\n\t\" Private - returns the handle to the native module. \"\r\n\r\n\t^#{coroutine}","function(self)\r\nreturn (coroutine)\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine["$klass"],"new:",0
,function(self,aBlock)
local result=nil
	result = coroutine.create(aBlock) 
;
return ((self):_at(result))
;
end
,"instantiation","new: aBlock\r\n\t\" Returns an instance with body aBlock. \"\r\n\r\n\t| result |\r\n\t{lua'\tresult = coroutine.create(aBlock) '}.\r\n\t^self @ result","function(self,aBlock)\r\nlocal result=nil\r\n\tresult = coroutine.create(aBlock) \r\n;\r\nreturn ((self):_at(result))\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine["$klass"],"wrap:",0
,function(self,aBlock)
return (coroutine.wrap(aBlock))
;
end
,"instantiation","wrap: aBlock\r\n\t\" Returns a Block that resumes a created coroutine each time it is called. \"\r\n\r\n\t^{lua'coroutine.wrap(aBlock)'}","function(self,aBlock)\r\nreturn (coroutine.wrap(aBlock))\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine["$klass"],"isyieldable",0
,function(self)
return (coroutine.isyieldable())
;
end
,"query","isyieldable\r\n\t\" Returns true when the running coroutine can yield.\r\n\tA running coroutine is yieldable if it is not the main thread and it is not inside a non-yieldable C function.\r\n\t\"\r\n\r\n\t^{lua'coroutine.isyieldable()'}","function(self)\r\nreturn (coroutine.isyieldable())\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine["$klass"],"yieldable",0
,function(self)
return (coroutine.isyieldable())
;
end
,"query","yieldable\r\n\t\" Returns true when the running coroutine can yield.\r\n\tA running coroutine is yieldable if it is not the main thread and it is not inside a non-yieldable C function.\r\n\t\"\r\n\r\n\t^{lua'coroutine.isyieldable()'}","function(self)\r\nreturn (coroutine.isyieldable())\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine["$klass"],"running",0
,function(self)
local result=nil
 result = coroutine.running()
;
return ((self):_at(result))
;
end
,"accessing","running\r\n\t\" Returns the running instance. \"\r\n\r\n\t| result |\r\n\t{lua' result = coroutine.running()'}.\r\n\t^self @ result ","function(self)\r\nlocal result=nil\r\n result = coroutine.running()\r\n;\r\nreturn ((self):_at(result))\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine,"resume",0
,function(self)
return (coroutine.resume(self:handle()))
;
end
,"executing","resume\r\n\t\" Starts or continues the execution of the receiver. \"\r\n\r\n\t^{lua'coroutine.resume(self:handle())'}","function(self)\r\nreturn (coroutine.resume(self:handle()))\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine,"resume:",0
,function(self,arg1)
return (coroutine.resume(self:handle(),arg1))
;
end
,"executing","resume: arg1\r\n\t\" Starts or continues the execution of the receiver. \"\r\n\r\n\t^{lua'coroutine.resume(self:handle(),arg1)'}","function(self,arg1)\r\nreturn (coroutine.resume(self:handle(),arg1))\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine,"resume:with:",0
,function(self,arg1,arg2)
return (coroutine.resume(self:handle(),arg1,arg2))
;
end
,"executing","resume: arg1 with: arg2\r\n\t\" Starts or continues the execution of the receiver. \"\r\n\r\n\t^{lua'coroutine.resume(self:handle(),arg1,arg2)'}","function(self,arg1,arg2)\r\nreturn (coroutine.resume(self:handle(),arg1,arg2))\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine,"resume:with:with:",0
,function(self,arg1,arg2,arg3)
return (coroutine.resume(self:handle(),arg1,arg2,arg3))
;
end
,"executing","resume: arg1 with: arg2 with: arg3\r\n\t\" Starts or continues the execution of the receiver. \"\r\n\r\n\t^{lua'coroutine.resume(self:handle(),arg1,arg2,arg3)'}","function(self,arg1,arg2,arg3)\r\nreturn (coroutine.resume(self:handle(),arg1,arg2,arg3))\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine,"resume:with:with:with:",0
,function(self,arg1,arg2,arg3,arg4)
return (coroutine.resume(self:handle(),arg1,arg2,arg3,arg4))
;
end
,"executing","resume: arg1 with: arg2 with: arg3 with: arg4\r\n\t\" Starts or continues the execution of the receiver. \"\r\n\r\n\t^{lua'coroutine.resume(self:handle(),arg1,arg2,arg3,arg4)'}","function(self,arg1,arg2,arg3,arg4)\r\nreturn (coroutine.resume(self:handle(),arg1,arg2,arg3,arg4))\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine,"status",0
,function(self)
return (coroutine.status(self:handle()))
;
end
,"status","status\r\n\t\" returns the status of the receiver. \"\r\n\r\n\t^{lua'coroutine.status(self:handle())'}","function(self)\r\nreturn (coroutine.status(self:handle()))\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine["$klass"],"yield",0
,function(self)
return (coroutine.yield())
;
end
,"executing","yield\r\n\t\" Suspends the execution of the calling coroutine. \"\r\n\r\n\t^{lua'coroutine.yield()'}","function(self)\r\nreturn (coroutine.yield())\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine,"yield:",0
,function(self,arg1)
return (coroutine.yield(arg1))
;
end
,"executing","yield: arg1\r\n\t\" Suspends the execution of the calling coroutine.\r\n\tAny arguments to yield are passed as extra results to resume.\r\n\t\"\r\n\r\n\t^{lua'coroutine.yield(arg1)'}","function(self,arg1)\r\nreturn (coroutine.yield(arg1))\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine,"yield:with:",0
,function(self,arg1,arg2)
return (coroutine.yield(arg1,arg2))
;
end
,"executing","yield: arg1 with: arg2\r\n\t\" Suspends the execution of the calling coroutine.\r\n\tAny arguments to yield are passed as extra results to resume.\r\n\t\"\r\n\r\n\t^{lua'coroutine.yield(arg1,arg2)'}","function(self,arg1,arg2)\r\nreturn (coroutine.yield(arg1,arg2))\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine,"yield:with:with:",0
,function(self,arg1,arg2,arg3)
return (coroutine.yield(arg1,arg2,arg3))
;
end
,"executing","yield: arg1 with: arg2 with: arg3\r\n\t\" Suspends the execution of the calling coroutine.\r\n\tAny arguments to yield are passed as extra results to resume.\r\n\t\"\r\n\r\n\t^{lua'coroutine.yield(arg1,arg2,arg3)'}","function(self,arg1,arg2,arg3)\r\nreturn (coroutine.yield(arg1,arg2,arg3))\r\n;\r\nend")

smalltalk:bind(smalltalk.Coroutine,"yield:with:with:with:",0
,function(self,arg1,arg2,arg3,arg4)
return (coroutine.yield(arg1,arg2,arg3,arg4))
;
end
,"executing","yield: arg1 with: arg2 with: arg3 with: arg4\r\n\t\" Suspends the execution of the calling coroutine.\r\n\tAny arguments to yield are passed as extra results to resume.\r\n\t\"\r\n\r\n\t^{lua'coroutine.yield(arg1,arg2,arg3,arg4)'}","function(self,arg1,arg2,arg3,arg4)\r\nreturn (coroutine.yield(arg1,arg2,arg3,arg4))\r\n;\r\nend")

smalltalk:addClass("Package",smalltalk.NativeObject,smalltalk:newArray({}),"StandardLibrary")

smalltalk:bind(smalltalk.Lua["$klass"],"package",0
,function(self)
return (smalltalk.Package)
;
end
,"accessing","package\r\n\t\" Returns the wrapper to library support (aClass). \"\r\n\r\n\t^Package","function(self)\r\nreturn (smalltalk.Package)\r\n;\r\nend")

smalltalk:bind(smalltalk.Lua["$klass"],"require:",0
,function(self,moduleName)
return ((smalltalk.Package):require_(moduleName))
;
end
,"modules","require: moduleName\r\n\t\" Returns the package wrapper to a loaded module. \"\r\n\r\n\t^Package require: moduleName","function(self,moduleName)\r\nreturn ((smalltalk.Package):require_(moduleName))\r\n;\r\nend")

smalltalk:bind(smalltalk.Package["$klass"],"require:",0
,function(self,moduleName)
local module=nil
	module = require(moduleName) 
;
return ((self):_at(module))
;
end
,"loading","require: moduleName\r\n\t\" Returns the package wrapper to a loaded module. \"\r\n\r\n\t| module |\r\n\t{lua'\tmodule = require(moduleName) '}.\r\n\t^self @ module","function(self,moduleName)\r\nlocal module=nil\r\n\tmodule = require(moduleName) \r\n;\r\nreturn ((self):_at(module))\r\n;\r\nend")

smalltalk:bind(smalltalk.Package["$klass"],"config",0
,function(self)
return (package.config)
;
end
,"accessing","config\r\n\t\" Returns a string describing some compile-time configurations for packages. \"\r\n\r\n\t^{lua'package.config'}","function(self)\r\nreturn (package.config)\r\n;\r\nend")

smalltalk:bind(smalltalk.Package["$klass"],"cpath",0
,function(self)
return (package.cpath)
;
end
,"accessing","cpath\r\n\t\" Returns the path used by require to search for a C loader. \"\r\n\r\n\t^{lua'package.cpath'}","function(self)\r\nreturn (package.cpath)\r\n;\r\nend")

smalltalk:bind(smalltalk.Package["$klass"],"loaded",0
,function(self)
local copy=nil
 copy = package.loaded 
;
return ((smalltalk.PoolDictionary):_at_at(copy))
;
end
,"accessing","loaded\r\n\t\" Returns a PoolDictionary with the modules already loaded. \"\r\n\r\n\t| copy |\r\n\t{lua' copy = package.loaded '}.\r\n\t^PoolDictionary @@ copy","function(self)\r\nlocal copy=nil\r\n copy = package.loaded \r\n;\r\nreturn ((smalltalk.PoolDictionary):_at_at(copy))\r\n;\r\nend")

smalltalk:bind(smalltalk.Package["$klass"],"loadlib:funcname:",0
,function(self,libname,funcname)
return (package.loadlib(libname,funcname))
;
end
,"accessing","loadlib: libname funcname: funcname\r\n\t\" Dynamically links the host program with the C library libname. \"\r\n\r\n\t^{lua'package.loadlib(libname,funcname)'}","function(self,libname,funcname)\r\nreturn (package.loadlib(libname,funcname))\r\n;\r\nend")

smalltalk:bind(smalltalk.Package["$klass"],"path",0
,function(self)
return (package.path)
;
end
,"accessing","path\r\n\t\" Returns the path used by require to search for a Lua loader. \"\r\n\r\n\t^{lua'package.path'}","function(self)\r\nreturn (package.path)\r\n;\r\nend")

smalltalk:bind(smalltalk.Package["$klass"],"preload",0
,function(self)
local copy=nil
 copy = package.preload 
;
return ((smalltalk.PoolDictionary):_at_at(copy))
;
end
,"accessing","preload\r\n\t\" Returns a PoolDictionary with a copy of the table to store loaders for specific modules. \"\r\n\r\n\t| copy |\r\n\t{lua' copy = package.preload '}.\r\n\t^PoolDictionary @@ copy","function(self)\r\nlocal copy=nil\r\n copy = package.preload \r\n;\r\nreturn ((smalltalk.PoolDictionary):_at_at(copy))\r\n;\r\nend")

smalltalk:bind(smalltalk.Package["$klass"],"searchers",0
,function(self)
local array=nil
 array = package.searchers 
;
return ((function() if ((((((array))~=nil)))==true) then return ((function()
return ((smalltalk.Array):_at(array))
end))() else return nil end end)())
;
end
,"accessing","searchers\r\n\t\" Returns an Array with functions used by require to control how to load modules. \"\r\n\r\n\t| array |\r\n\t{lua' array = package.searchers '}.\r\n\t^array notNil ifTrue: [ Array @ array ]","function(self)\r\nlocal array=nil\r\n array = package.searchers \r\n;\r\nreturn ((function() if ((((((array))~=nil)))==true) then return ((function()\r\nreturn ((smalltalk.Array):_at(array))\r\nend))() else return nil end end)())\r\n;\r\nend")

smalltalk:bind(smalltalk.Package["$klass"],"searchers",0
,function(self)
local array=nil
 array = package.searchers 
;
return ((function() if ((((((array))~=nil)))==true) then return ((function()
return ((smalltalk.Array):_at(array))
end))() else return nil end end)())
;
end
,"accessing","searchers\r\n\t\" Returns an Array with functions used by require to control how to load modules. \"\r\n\r\n\t| array |\r\n\t{lua' array = package.searchers '}.\r\n\t^array notNil ifTrue: [ Array @ array ]","function(self)\r\nlocal array=nil\r\n array = package.searchers \r\n;\r\nreturn ((function() if ((((((array))~=nil)))==true) then return ((function()\r\nreturn ((smalltalk.Array):_at(array))\r\nend))() else return nil end end)())\r\n;\r\nend")

smalltalk:bind(smalltalk.Package["$klass"],"searchpath:in:with:with:",0
,function(self,name,path,sep,rep)
return ( package.searchpath (name,path,sep,rep) )
;
end
,"accessing","searchpath: name in: path with: sep with: rep\r\n\t\" Searches for the given name in the given path.\r\n\tReturns the resulting name of the first file that it can open in read mode (after closing the file), or nil plus an error message if none succeeds. \r\n\t\"\r\n\r\n\t^{lua' package.searchpath (name,path,sep,rep) '}","function(self,name,path,sep,rep)\r\nreturn ( package.searchpath (name,path,sep,rep) )\r\n;\r\nend")

smalltalk:bind(smalltalk.Package["$klass"],"searchpath:in:with:",0
,function(self,name,path,sep)
return ( package.searchpath (name,path,sep) )
;
end
,"accessing","searchpath: name in: path with: sep\r\n\t\" Searches for the given name in the given path.\r\n\tReturns the resulting name of the first file that it can open in read mode (after closing the file), or nil plus an error message if none succeeds. \r\n\t\"\r\n\r\n\t^{lua' package.searchpath (name,path,sep) '}","function(self,name,path,sep)\r\nreturn ( package.searchpath (name,path,sep) )\r\n;\r\nend")

smalltalk:bind(smalltalk.Package["$klass"],"searchpath:in:",0
,function(self,name,path)
return ( package.searchpath (name,path) )
;
end
,"accessing","searchpath: name in: path\r\n\t\" Searches for the given name in the given path.\r\n\tReturns the resulting name of the first file that it can open in read mode (after closing the file), or nil plus an error message if none succeeds. \r\n\t\"\r\n\r\n\t^{lua' package.searchpath (name,path) '}","function(self,name,path)\r\nreturn ( package.searchpath (name,path) )\r\n;\r\nend")

smalltalk:addClass("UTF8",smalltalk.NativeObject,smalltalk:newArray({}),"StandardLibrary")

smalltalk:bind(smalltalk.Lua["$klass"],"utf8",0
,function(self)
return (smalltalk.UTF8)
;
end
,"accessing","utf8\r\n\t\" Returns the wrapper to library support (aClass). \"\r\n\r\n\t^UTF8","function(self)\r\nreturn (smalltalk.UTF8)\r\n;\r\nend")

smalltalk:bind(smalltalk.UTF8["$klass"],"char:",0
,function(self,arg)
return ((function() if ((((arg):isNumber()))==true) then return ((function()
return (utf8.char(arg) )
end))() else return ((function()
return (utf8.char(unpack(arg)) )
end))() end end)())
;
end
,"converting","char: arg\r\n\t\" Receives an integer or Array (of integers), converts each one to its corresponding UTF-8 byte sequence and returns a string with the concatenation of all these sequences. \"\r\n\r\n\t^arg isNumber\r\n\tifTrue:  [ {lua'utf8.char(arg) '} ]\r\n\tifFalse: [ {lua'utf8.char(unpack(arg)) '} ]","function(self,arg)\r\nreturn ((function() if ((((arg):isNumber()))==true) then return ((function()\r\nreturn (utf8.char(arg) )\r\nend))() else return ((function()\r\nreturn (utf8.char(unpack(arg)) )\r\nend))() end end)())\r\n;\r\nend")

smalltalk:bind(smalltalk.UTF8["$klass"],"charpattern",0
,function(self)
return (utf8.charpattern)
;
end
,"constants","charpattern\r\n\t\" Returns the pattern [\\0-\\x7F\\xC2-\\xF4][\\x80-\\xBF]* which matches exactly one UTF-8 byte sequence, assuming that the subject is a valid UTF-8 string. \"\r\n\r\n\t^{lua'utf8.charpattern'}","function(self)\r\nreturn (utf8.charpattern)\r\n;\r\nend")

smalltalk:bind(smalltalk.UTF8["$klass"],"codes:",0
,function(self,s)
return (utf8.codes(s))
;
end
,"converting","codes: s\r\n\t^{lua'utf8.codes(s)'}","function(self,s)\r\nreturn (utf8.codes(s))\r\n;\r\nend")

smalltalk:bind(smalltalk.UTF8["$klass"],"codepoint:from:to:",0
,function(self,s,i,j)
return (utf8.codepoint(s,i,j))
;
end
,"converting","codepoint: s from: i to: j\r\n\t\" Returns the codepoints (as integers) from all characters in s. \"\r\n\r\n\t^{lua'utf8.codepoint(s,i,j)'}","function(self,s,i,j)\r\nreturn (utf8.codepoint(s,i,j))\r\n;\r\nend")

smalltalk:bind(smalltalk.UTF8["$klass"],"codepoint:from:",0
,function(self,s,i)
return (utf8.codepoint(s,i))
;
end
,"converting","\" Returns the codepoints (as integers) from all characters in s. \"\r\n\r\ncodepoint: s from: i\r\n\t^{lua'utf8.codepoint(s,i)'}","function(self,s,i)\r\nreturn (utf8.codepoint(s,i))\r\n;\r\nend")

smalltalk:bind(smalltalk.UTF8["$klass"],"codepoint:",0
,function(self,s)
return (utf8.codepoint(s))
;
end
,"converting","codepoint: s\r\n\t\" Returns the codepoints (as integers) from all characters in s. \"\r\n\r\n\t^{lua'utf8.codepoint(s)'}","function(self,s)\r\nreturn (utf8.codepoint(s))\r\n;\r\nend")

smalltalk:bind(smalltalk.UTF8["$klass"],"len:from:to:",0
,function(self,s,i,j)
return (utf8.len(s,i,j))
;
end
,"converting","len: s from: i to: j\r\n\t\" Returns the number of UTF-8 characters in string s. \"\r\n\r\n\t^{lua'utf8.len(s,i,j)'}","function(self,s,i,j)\r\nreturn (utf8.len(s,i,j))\r\n;\r\nend")

smalltalk:bind(smalltalk.UTF8["$klass"],"len:from:",0
,function(self,s,i)
return (utf8.len(s,i))
;
end
,"converting","len: s from: i\r\n\t\" Returns the number of UTF-8 characters in string s. \"\r\n\r\n\t^{lua'utf8.len(s,i)'}","function(self,s,i)\r\nreturn (utf8.len(s,i))\r\n;\r\nend")

smalltalk:bind(smalltalk.UTF8["$klass"],"len:",0
,function(self,s)
return (utf8.len(s))
;
end
,"converting","len: s\r\n\t\" Returns the number of UTF-8 characters in string s. \"\r\n\r\n\t^{lua'utf8.len(s)'}","function(self,s)\r\nreturn (utf8.len(s))\r\n;\r\nend")

smalltalk:bind(smalltalk.UTF8["$klass"],"offset:n:i:",0
,function(self,s,n,i)
return (utf8.offset(s,n,i))
;
end
,"converting","offset: s n: n i: i\r\n\t\" Returns the position (in bytes) where the encoding of the n-th character of s (counting from position i) starts. \"\r\n\r\n\t^{lua'utf8.offset(s,n,i)'}","function(self,s,n,i)\r\nreturn (utf8.offset(s,n,i))\r\n;\r\nend")

smalltalk:bind(smalltalk.UTF8["$klass"],"offset:n:",0
,function(self,s,n)
return (utf8.offset(s,n))
;
end
,"converting","offset: s n: n\r\n\t\" Returns the position (in bytes) where the encoding of the n-th character of s starts. \"\r\n\r\n\t^{lua'utf8.offset(s,n)'}","function(self,s,n)\r\nreturn (utf8.offset(s,n))\r\n;\r\nend")

smalltalk:addClass("LuaFile",smalltalk.NativeObject,smalltalk:newArray({}),"StandardLibrary")

smalltalk:bind(smalltalk.Lua["$klass"],"io",0
,function(self)
return (smalltalk.LuaFile)
;
end
,"accessing","io\r\n\t\" Returns the wrapper to library support (aClass). \"\r\n\r\n\t^LuaFile","function(self)\r\nreturn (smalltalk.LuaFile)\r\n;\r\nend")

smalltalk:bind(smalltalk.Lua["$klass"],"file",0
,function(self)
return (smalltalk.LuaFile)
;
end
,"accessing","file\r\n\t\" Returns the wrapper to library support (aClass). \"\r\n\r\n\t^LuaFile","function(self)\r\nreturn (smalltalk.LuaFile)\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile["$klass"],"close",0
,function(self)
return (io.close())
;
end
,"io","close\r\n\t\" Close the default output file. \"\r\n\r\n\t^{lua'io.close()'}","function(self)\r\nreturn (io.close())\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile["$klass"],"close:",0
,function(self,hFile)
return (io.close(hFile))
;
end
,"io","close: hFile\r\n\t\" Close the file. \"\r\n\r\n\t^{lua'io.close(hFile)'}","function(self,hFile)\r\nreturn (io.close(hFile))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile["$klass"],"flush",0
,function(self)
return (io.flush())
;
end
,"io","flush\r\n\t\" Flush the default output file. \"\r\n\r\n\t^{lua'io.flush()'}","function(self)\r\nreturn (io.flush())\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile["$klass"],"input:",0
,function(self,hFile)
local result=nil
 result = io.input(hFile)
;
return ((self):_at(result))
;
end
,"io","input: hFile\r\n\t\" When called with a file name, it opens the named file (in text mode), and sets its handle as the default input file.\r\n\tWhen called with a file handle, it simply sets this file handle as the default input file.\r\n\tWhen called without arguments, it returns the current default input file.\r\n\tIn case of errors this function raises the error, instead of returning an error code. \"\r\n\r\n\t| result |\r\n\t{lua' result = io.input(hFile)'}.\r\n\t^self @ result","function(self,hFile)\r\nlocal result=nil\r\n result = io.input(hFile)\r\n;\r\nreturn ((self):_at(result))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile["$klass"],"input",0
,function(self)
local result=nil
 result = io.input()
;
return ((self):_at(result))
;
end
,"io","input\r\n\t\" Returns the current default input file. \"\r\n\r\n\t| result |\r\n\t{lua' result = io.input()'}.\r\n\t^self @ result","function(self)\r\nlocal result=nil\r\n result = io.input()\r\n;\r\nreturn ((self):_at(result))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile["$klass"],"output:",0
,function(self,hFile)
local result=nil
 result = io.output(hFile)
;
return ((self):_at(result))
;
end
,"io","output: hFile\r\n\t\" When called with a file name, it opens the named file (in text mode), and sets its handle as the default output file.\r\n\tWhen called with a file handle, it simply sets this file handle as the default output file.\r\n\tWhen called without arguments, it returns the current default output file.\r\n\tIn case of errors this function raises the error, instead of returning an error code. \"\r\n\r\n\t| result |\r\n\t{lua' result = io.output(hFile)'}.\r\n\t^self @ result","function(self,hFile)\r\nlocal result=nil\r\n result = io.output(hFile)\r\n;\r\nreturn ((self):_at(result))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile["$klass"],"output",0
,function(self)
local result=nil
 result = io.output()
;
return ((self):_at(result))
;
end
,"io","output\r\n\t\" Returns the current default output file. \"\r\n\r\n\t| result |\r\n\t{lua' result = io.output()'}.\r\n\t^self @ result","function(self)\r\nlocal result=nil\r\n result = io.output()\r\n;\r\nreturn ((self):_at(result))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile["$klass"],"lines:withAll:",0
,function(self,filename,array)
local result=nil
 result = io.lines(filename,unpack(array))
;
return ((self):_at(result))
;
end
,"io","lines: filename withAll: array\r\n\t\" Opens the given file name in read mode and returns an iterator function that works like file:lines(...) over the opened file. \"\r\n\r\n\t| result |\r\n\t{lua' result = io.lines(filename,unpack(array))'}.\r\n\t^self @ result","function(self,filename,array)\r\nlocal result=nil\r\n result = io.lines(filename,unpack(array))\r\n;\r\nreturn ((self):_at(result))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile["$klass"],"lines",0
,function(self)
local result=nil
 result = io.lines()
;
return ((self):_at(result))
;
end
,"io","lines\r\n\t\" Returns an iterator over the lines of the default input file. \"\r\n\r\n\t| result |\r\n\t{lua' result = io.lines()'}.\r\n\t^self @ result","function(self)\r\nlocal result=nil\r\n result = io.lines()\r\n;\r\nreturn ((self):_at(result))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile["$klass"],"open:mode:",0
,function(self,filename,mode)
local result=nil
 result = io.open(filename,mode)
;
return ((self):_at(result))
;
end
,"io","open: filename mode: mode\r\n\t\" Returns an instance. Opens a file, in the mode specified in the string mode. \"\r\n\r\n\t| result |\r\n\t{lua' result = io.open(filename,mode)'}.\r\n\t^self @ result","function(self,filename,mode)\r\nlocal result=nil\r\n result = io.open(filename,mode)\r\n;\r\nreturn ((self):_at(result))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile["$klass"],"open:",0
,function(self,filename)
local result=nil
 result = io.open(filename)
;
return ((self):_at(result))
;
end
,"io","open: filename\r\n\t\" Returns an instance. Opens a file, in default(read) mode. \"\r\n\r\n\t| result |\r\n\t{lua' result = io.open(filename)'}.\r\n\t^self @ result","function(self,filename)\r\nlocal result=nil\r\n result = io.open(filename)\r\n;\r\nreturn ((self):_at(result))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile["$klass"],"popen:mode:",0
,function(self,program,mode)
local result=nil
 result = io.popen(program,mode)
;
return ((self):_at(result))
;
end
,"io","popen: program mode: mode\r\n\t\" Starts program in a separated process and returns a file that you can use to read data from this program (if mode is $r) or to write data to this program (if mode is $w).\r\n\tNote: System dependent and not available on all platforms.\r\n\t\"\r\n\r\n\t| result |\r\n\t{lua' result = io.popen(program,mode)'}.\r\n\t^self @ result","function(self,program,mode)\r\nlocal result=nil\r\n result = io.popen(program,mode)\r\n;\r\nreturn ((self):_at(result))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile["$klass"],"popen:",0
,function(self,program)
local result=nil
 result = io.popen(program)
;
return ((self):_at(result))
;
end
,"io","popen: program\r\n\t\" Starts program in a separated process and returns a file that you can use to read data from this program.\r\n\tNote: System dependent and not available on all platforms.\r\n\t\"\r\n\r\n\t| result |\r\n\t{lua' result = io.popen(program)'}.\r\n\t^self @ result","function(self,program)\r\nlocal result=nil\r\n result = io.popen(program)\r\n;\r\nreturn ((self):_at(result))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile["$klass"],"tmpfile",0
,function(self)
local result=nil
 result = io.tmpfile()
;
return ((self):_at(result))
;
end
,"io","tmpfile\r\n\t\" Returns a temporary file.\r\n\tThis file is opened in update mode and it is automatically removed when the program ends.\r\n\t\"\r\n\r\n\t| result |\r\n\t{lua' result = io.tmpfile()'}.\r\n\t^self @ result","function(self)\r\nlocal result=nil\r\n result = io.tmpfile()\r\n;\r\nreturn ((self):_at(result))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile["$klass"],"type:",0
,function(self,obj)
return (io.type(obj))
;
end
,"io","type: obj\r\n\t\" Checks whether obj is a valid file handle.\r\n\tReturns #file if obj is an open file handle, 'closed file' if obj is a closed file handle, or nil if obj is not a file handle.\r\n\t\"\r\n\r\n\t^{lua'io.type(obj)'}","function(self,obj)\r\nreturn (io.type(obj))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"state",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local state=nil
(function()
	local _s8_value=(((self)["$klass"]):type_((self):handle()))
	state=_s8_value; return _s8_value
end)()
;
(function() if ((((smalltalk:isObject_equalTo_(("file"),state))))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ("open")
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function() if ((((smalltalk:isObject_equalTo_(("closed file"),state))))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ("closed")
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (state)
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"state","state\r\n\t\" Returns the receiver's handle state.\r\n\tReturns #file if obj is an open file handle, 'closed file' if obj is a closed file handle, or nil if obj is not a file handle.\r\n\t\"\r\n\r\n\t| state |\r\n\tstate := self class type: self handle.\r\n\t#file = state ifTrue: [ ^#open ].\r\n\t#'closed file' = state ifTrue: [ ^#closed ].\r\n\t^state","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal state=nil\r\n(function()\r\n\tlocal _s8_value=(((self)[\"$klass\"]):type_((self):handle()))\r\n\tstate=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((smalltalk:isObject_equalTo_((\"file\"),state))))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (\"open\")\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((smalltalk:isObject_equalTo_((\"closed file\"),state))))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (\"closed\")\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (state)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.LuaFile,"lines:",0
,function(self,format)
return (((self):handle()):lines(format))
;
end
,"lines","lines: format\r\n\t\" Returns an iterator function that, each time it is called, reads the file according to the given format. \"\r\n\r\n\t^self handle #lines: format","function(self,format)\r\nreturn (((self):handle()):lines(format))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"linesWithAll:",0
,function(self,formats)
return (self:handle():lines(unpack(formats)))
;
end
,"lines","linesWithAll: formats\r\n\t\" Returns an iterator function that, each time it is called, reads the file according to the given formats. \"\r\n\r\n\t^{lua'self:handle():lines(unpack(formats))'}","function(self,formats)\r\nreturn (self:handle():lines(unpack(formats)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"readWithAll:",0
,function(self,formats)
return (self:handle():read(unpack(formats)))
;
end
,"reading","readWithAll: formats\r\n\t\" Reads the file file, according to the given formats, which specify what to read. \"\r\n\r\n\t^{lua'self:handle():read(unpack(formats))'}","function(self,formats)\r\nreturn (self:handle():read(unpack(formats)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"writeWithAll:",0
,function(self,values)
return (self:handle():write(unpack(values)))
;
end
,"reading","writeWithAll: values\r\n\t\" Writes the value of each of its arguments to file.\r\n\tThe values must be strings or numbers.\r\n\tIn case of success, this function returns the handle.\r\n\tOtherwise it returns nil plus a string describing the error.\r\n\t\"\r\n\r\n\t^{lua'self:handle():write(unpack(values))'}","function(self,values)\r\nreturn (self:handle():write(unpack(values)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"close",0
,function(self)
return (((self):handle()):close())
;
end
,"wrappers","close\r\n\t\" Delegate close to handle. \"\r\n\r\n\t^self handle #close","function(self)\r\nreturn (((self):handle()):close())\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"flush",0
,function(self)
return (((self):handle()):flush())
;
end
,"wrappers","flush\r\n\t\" Delegate flush to handle. \"\r\n\r\n\t^self handle #flush","function(self)\r\nreturn (((self):handle()):flush())\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"seek",0
,function(self)
return (((self):handle()):seek())
;
end
,"wrappers","seek\r\n\t\" Delegate seek to handle. \"\r\n\r\n\t^self handle #seek","function(self)\r\nreturn (((self):handle()):seek())\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"read",0
,function(self)
return (((self):handle()):read())
;
end
,"wrappers","read\r\n\t\" Delegate read to handle. \"\r\n\r\n\t^self handle #read","function(self)\r\nreturn (((self):handle()):read())\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"write",0
,function(self)
return (((self):handle()):write())
;
end
,"wrappers","write\r\n\t\" Delegate write to handle. \"\r\n\r\n\t^self handle #write","function(self)\r\nreturn (((self):handle()):write())\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"lines:",0
,function(self,format)
return (((self):handle()):lines(format))
;
end
,"wrappers","lines: format \r\n\t\" Delegate lines to handle. \"\r\n\r\n\t^self handle #lines: format ","function(self,format)\r\nreturn (((self):handle()):lines(format))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"read:",0
,function(self,format)
return (((self):handle()):read(format))
;
end
,"wrappers","read: format \r\n\t\" Delegate read to handle. \"\r\n\r\n\t^self handle #read: format ","function(self,format)\r\nreturn (((self):handle()):read(format))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"write:",0
,function(self,value)
return (((self):handle()):write(value))
;
end
,"wrappers","write: value \r\n\t\" Delegate write to handle. \"\r\n\r\n\t^self handle #write: value ","function(self,value)\r\nreturn (((self):handle()):write(value))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"seek:",0
,function(self,whence)
return (((self):handle()):seek(whence))
;
end
,"wrappers","seek: whence \r\n\t\" Delegate seek to handle. \"\r\n\r\n\t^self handle #seek: whence ","function(self,whence)\r\nreturn (((self):handle()):seek(whence))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"seek:offset:",0
,function(self,whence,offset)
return (((self):handle()):seek(whence, offset))
;
end
,"wrappers","seek: whence offset: offset \r\n\t\" Delegate seek to handle. \"\r\n\r\n\t^self handle #seek: whence offset: offset ","function(self,whence,offset)\r\nreturn (((self):handle()):seek(whence, offset))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"setvbuf:",0
,function(self,mode)
return (((self):handle()):setvbuf(mode))
;
end
,"wrappers","setvbuf: mode \r\n\t\" Delegate setvbuf to handle. \"\r\n\r\n\t^self handle #setvbuf: mode ","function(self,mode)\r\nreturn (((self):handle()):setvbuf(mode))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaFile,"setvbuf:size:",0
,function(self,mode,size)
return (((self):handle()):setvbuf(mode, size))
;
end
,"wrappers","setvbuf: mode size: size \r\n\t\" Delegate setvbuf to handle. \"\r\n\r\n\t^self handle #setvbuf: mode size: size ","function(self,mode,size)\r\nreturn (((self):handle()):setvbuf(mode, size))\r\n;\r\nend")

smalltalk:addClass("OS",smalltalk.NativeObject,smalltalk:newArray({}),"StandardLibrary")

smalltalk:bind(smalltalk.Lua["$klass"],"os",0
,function(self)
return (smalltalk.OS)
;
end
,"accessing","os\r\n\t\" Returns the wrapper to library support (aClass). \"\r\n\r\n\t^OS","function(self)\r\nreturn (smalltalk.OS)\r\n;\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"clock",0
,function(self)
return (os.clock())
;
end
,"accessing","clock\r\n\t\" Returns an approximation of the amount in seconds of CPU time used by the system. \"\r\n\r\n\t^{lua'os.clock()'}","function(self)\r\nreturn (os.clock())\r\n;\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"date:time:",0
,function(self,format,time)
return (os.date(format,time))
;
end
,"datetime","date: format time: time\r\n\t\" Returns a string or a table containing date and time, formatted according to the given string format. \"\r\n\r\n\t^{lua'os.date(format,time)'}","function(self,format,time)\r\nreturn (os.date(format,time))\r\n;\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"date:",0
,function(self,format)
return (os.date(format))
;
end
,"datetime","date: format\r\n\t\" Returns a string or a table containing date and time, formatted according to the given string format. \"\r\n\r\n\t^{lua'os.date(format)'}","function(self,format)\r\nreturn (os.date(format))\r\n;\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"date",0
,function(self)
return (os.date())
;
end
,"datetime","date\r\n\t\" Returns a string or a table containing date and time. \"\r\n\r\n\t^{lua'os.date()'}","function(self)\r\nreturn (os.date())\r\n;\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"difftime:from:",0
,function(self,t2,t1)
return (os.difftime(t2,t1))
;
end
,"datetime","difftime: t2 from: t1\r\n\t\" Returns the difference, in seconds, from time t1 to time t2. \"\r\n\r\n\t^{lua'os.difftime(t2,t1)'}","function(self,t2,t1)\r\nreturn (os.difftime(t2,t1))\r\n;\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"execute:",0
,function(self,command)
local result=nil
local string=nil
local number=nil
	result,string,number = os.execute(command)

;
return ((function() if (((((result)==true)))==true) then return ((function()
return ((smalltalk.Array):with_with_(string, number))
end))() else return nil end end)())
;
end
,"util","execute: command\r\n\t\" It passes command to be executed by an operating system shell.\r\n\tIts first result is true if the command terminated successfully, or nil otherwise.\r\n\t\"\r\n\r\n\t| result string number |\r\n{lua'\tresult,string,number = os.execute(command)\r\n'}.\t^result == true ifTrue: [ Array with: string with: number ]","function(self,command)\r\nlocal result=nil\r\nlocal string=nil\r\nlocal number=nil\r\n\tresult,string,number = os.execute(command)\r\n\r\n;\r\nreturn ((function() if (((((result)==true)))==true) then return ((function()\r\nreturn ((smalltalk.Array):with_with_(string, number))\r\nend))() else return nil end end)())\r\n;\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"exit:close:",0
,function(self,code,close)
os.exit(code,close)
;
return (self)
;
end
,"util","exit: code close: close\r\n\t\" Terminate the host program. \"\r\n\r\n\t{lua'os.exit(code,close)'}","function(self,code,close)\r\nos.exit(code,close)\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"exit:",0
,function(self,code)
os.exit(code)
;
return (self)
;
end
,"util","exit: code\r\n\t\" Terminate the host program. \"\r\n\r\n\t{lua'os.exit(code)'}","function(self,code)\r\nos.exit(code)\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"exit",0
,function(self)
os.exit()
;
return (self)
;
end
,"util","exit\r\n\t\" Terminate the host program. \"\r\n\r\n\t{lua'os.exit()'}","function(self)\r\nos.exit()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"getenv:",0
,function(self,varname)
return (os.getenv(varname))
;
end
,"util","getenv: varname\r\n\t\" Returns the value of the process environment variable varname, or nil if the variable is not defined. \"\r\n\r\n\t^{lua'os.getenv(varname)'}","function(self,varname)\r\nreturn (os.getenv(varname))\r\n;\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"remove:ifFailed:",0
,function(self,filename,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local success=nil
local description=nil
local code=nil
	success,description,code = os.remove(filename)
;
(function() if ((((not (smalltalk:isObject_equalTo_((success),true)))))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):value_value_(description, code))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (success)
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"files","remove: filename ifFailed: aBlock\r\n\t\" Deletes the file (or empty directory, on POSIX systems) with the given name. \"\r\n\r\n\t| success description code |\r\n{lua'\tsuccess,description,code = os.remove(filename)'}.\r\n\tsuccess ~= true ifTrue: [ ^aBlock value: description value: code ].\r\n\t^success","function(self,filename,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal success=nil\r\nlocal description=nil\r\nlocal code=nil\r\n\tsuccess,description,code = os.remove(filename)\r\n;\r\n(function() if ((((not (smalltalk:isObject_equalTo_((success),true)))))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):value_value_(description, code))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (success)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"rename:to:ifFailed:",0
,function(self,filename,newname,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local success=nil
local description=nil
local code=nil
	success,description,code = os.rename(filename,newname)
;
(function() if ((((not (smalltalk:isObject_equalTo_((success),true)))))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):value_value_(description, code))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (success)
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"files","rename: filename to: newname ifFailed: aBlock\r\n\t\" Renames the file to newname. \"\r\n\r\n\t| success description code |\r\n{lua'\tsuccess,description,code = os.rename(filename,newname)'}.\r\n\tsuccess ~= true ifTrue: [ ^aBlock value: description value: code ].\r\n\t^success","function(self,filename,newname,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal success=nil\r\nlocal description=nil\r\nlocal code=nil\r\n\tsuccess,description,code = os.rename(filename,newname)\r\n;\r\n(function() if ((((not (smalltalk:isObject_equalTo_((success),true)))))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):value_value_(description, code))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (success)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"setlocale:category:",0
,function(self,locale,category)
return (os.setlocale(locale,category))
;
end
,"util","setlocale: locale category: category\r\n\t\" Sets the current locale. \"\r\n\r\n\t^{lua'os.setlocale(locale,category)'}","function(self,locale,category)\r\nreturn (os.setlocale(locale,category))\r\n;\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"setlocale:",0
,function(self,locale)
return (os.setlocale(locale))
;
end
,"util","setlocale: locale\r\n\t\" Sets the current locale. \"\r\n\r\n\t^{lua'os.setlocale(locale)'}","function(self,locale)\r\nreturn (os.setlocale(locale))\r\n;\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"getlocale:",0
,function(self,category)
return (os.setlocale(nil,category))
;
end
,"util","getlocale: category\r\n\t\" Gets the current locale. \"\r\n\r\n\t^{lua'os.setlocale(nil,category)'}","function(self,category)\r\nreturn (os.setlocale(nil,category))\r\n;\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"time:",0
,function(self,table)
return (os.time(table))
;
end
,"datetime","time: table\r\n\t\" Returns a time from table containing values for year,month,day and optionally hour,min,sec. \"\r\n\r\n\t^{lua'os.time(table)'}","function(self,table)\r\nreturn (os.time(table))\r\n;\r\nend")

smalltalk:bind(smalltalk.OS["$klass"],"tmpname",0
,function(self)
return (os.tmpname())
;
end
,"files","tmpname\r\n\t\" Returns a string with a file name that can be used for a temporary file.\r\n\tThe file must be explicitly opened before its use and explicitly removed when no longer needed.\r\n\t\"\r\n\r\n\t^{lua'os.tmpname()'}","function(self)\r\nreturn (os.tmpname())\r\n;\r\nend")

smalltalk:addClass("Debug",smalltalk.NativeObject,smalltalk:newArray({}),"StandardLibrary")

smalltalk:bind(smalltalk.Lua["$klass"],"debug",0
,function(self)
return (smalltalk.Debug)
;
end
,"accessing","debug\r\n\t\" Returns the wrapper to library support (aClass). \"\r\n\r\n\t^Debug","function(self)\r\nreturn (smalltalk.Debug)\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"debug",0
,function(self)
return (debug.debug())
;
end
,"debug","debug\r\n\t\" Enters an interactive mode with the user, running each string that the user enters.\r\n\tUsing simple commands and other debug facilities, the user can inspect global and local variables, change their values, evaluate expressions, and so on.\r\n\tA line containing only the word cont finishes this function, so that the caller continues its execution.\r\n\t\"\r\n\r\n\t^{lua'debug.debug()'}","function(self)\r\nreturn (debug.debug())\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"gethook",0
,function(self)
local hook=nil
local mask=nil
local count=nil
	hook,mask,count  = debug.gethook()
;
return ((smalltalk.Array):with_with_with_(hook, mask, count))
;
end
,"accessing","gethook\r\n\t\" Returns the current hook settings of the thread. \"\r\n\r\n\t| hook mask count |\r\n{lua'\thook,mask,count  = debug.gethook()'}.\r\n\t^Array with: hook with: mask with: count","function(self)\r\nlocal hook=nil\r\nlocal mask=nil\r\nlocal count=nil\r\n\thook,mask,count  = debug.gethook()\r\n;\r\nreturn ((smalltalk.Array):with_with_with_(hook, mask, count))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"gethook:",0
,function(self,thread)
local hook=nil
local mask=nil
local count=nil
	hook,mask,count  = debug.gethook(thread)
;
return ((smalltalk.Array):with_with_with_(hook, mask, count))
;
end
,"accessing","gethook: thread\r\n\t\" Returns the current hook settings of the thread. \"\r\n\r\n\t| hook mask count |\r\n{lua'\thook,mask,count  = debug.gethook(thread)'}.\r\n\t^Array with: hook with: mask with: count","function(self,thread)\r\nlocal hook=nil\r\nlocal mask=nil\r\nlocal count=nil\r\n\thook,mask,count  = debug.gethook(thread)\r\n;\r\nreturn ((smalltalk.Array):with_with_with_(hook, mask, count))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"getinfo:f:what:",0
,function(self,thread,f,what)
return (debug.getinfo(thread,f,what))
;
end
,"accessing","getinfo: thread f: f what: what\r\n\t\" Returns a table with information about a function. \"\r\n\r\n\t^{lua'debug.getinfo(thread,f,what)'}","function(self,thread,f,what)\r\nreturn (debug.getinfo(thread,f,what))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"getinfo:f:",0
,function(self,thread,f)
return (debug.getinfo(thread,f))
;
end
,"accessing","getinfo: thread f: f\r\n\t\" Returns a table with information about a function. \"\r\n\r\n\t^{lua'debug.getinfo(thread,f)'}","function(self,thread,f)\r\nreturn (debug.getinfo(thread,f))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"getinfo:what:",0
,function(self,f,what)
return (debug.getinfo(f,what))
;
end
,"accessing","getinfo: f what: what\r\n\t\" Returns a table with information about a function. \"\r\n\r\n\t^{lua'debug.getinfo(f,what)'}","function(self,f,what)\r\nreturn (debug.getinfo(f,what))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"getinfo:",0
,function(self,f)
return (debug.getinfo(f))
;
end
,"accessing","getinfo: f\r\n\t\" Returns a table with information about a function. \"\r\n\r\n\t^{lua'debug.getinfo(f)'}","function(self,f)\r\nreturn (debug.getinfo(f))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"getlocal:f:local:",0
,function(self,thread,f,index)
return (debug.getlocal(thread,f,index))
;
end
,"accessing","getlocal: thread f: f local: index\r\n\t\" Returns the name and the value of the local variable at index of the function at level f (aNumber) of the stack.\r\n\tAccesses not only explicit local variables, but also parameters, temporaries, etc.\r\n\tThe first parameter or local variable has index 1, and so on, following the order that they are declared in the code, counting only the variables that are active in the current scope of the function.\r\n\tNegative indices refer to vararg arguments; -1 is the first vararg argument.\r\n\tReturns nil if there is no variable with the given index, and raises an error when called with a level out of range.\r\n\tVariable names starting with $( (open parenthesis) represent variables with no known names (internal variables such as loop control variables, and variables from chunks saved without debug information).\r\n\tf may also be a function. In that case, getlocal returns only the name of function parameters.\r\n\t\"\r\n\r\n\t^{lua'debug.getlocal(thread,f,index)'}","function(self,thread,f,index)\r\nreturn (debug.getlocal(thread,f,index))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"getlocal:f:",0
,function(self,thread,f)
return (debug.getlocal(thread,f))
;
end
,"accessing","getlocal: thread f: f\r\n\t\" Returns the name and the value of the local variable at index of the function at level f (aNumber) of the stack. \"\r\n\r\n\t^{lua'debug.getlocal(thread,f)'}","function(self,thread,f)\r\nreturn (debug.getlocal(thread,f))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"getlocal:local:",0
,function(self,f,index)
return (debug.getlocal(f,index))
;
end
,"accessing","getlocal: f local: index\r\n\t\" Returns the name and the value of the local variable at index of the function at level f (aNumber) of the stack. \"\r\n\r\n\t^{lua'debug.getlocal(f,index)'}","function(self,f,index)\r\nreturn (debug.getlocal(f,index))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"getlocal:",0
,function(self,f)
return (debug.getlocal(f))
;
end
,"accessing","getlocal: f\r\n\t\" Returns the name and the value of the local variable at index of the function at level f (aNumber) of the stack. \"\r\n\r\n\t^{lua'debug.getlocal(f)'}","function(self,f)\r\nreturn (debug.getlocal(f))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"getmetatable:",0
,function(self,value)
return (debug.getmetatable(value))
;
end
,"accessing","getmetatable: value\r\n\t\" Returns the metatable of the given value or nil if it does not have a metatable. \"\r\n\r\n\t^{lua'debug.getmetatable(value)'}","function(self,value)\r\nreturn (debug.getmetatable(value))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"setmetatable:to:",0
,function(self,value,table)
return (debug.setmetatable(value,table))
;
end
,"accessing","setmetatable: value to: table\r\n\t\" Set the metatable of the given value to a metatable (or nil). \"\r\n\r\n\t^{lua'debug.setmetatable(value,table)'}","function(self,value,table)\r\nreturn (debug.setmetatable(value,table))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"getregistry",0
,function(self)
return (debug.getregistry())
;
end
,"accessing","getregistry\r\n\t\" Returns the registry table. \"\r\n\r\n\t^{lua'debug.getregistry()'}","function(self)\r\nreturn (debug.getregistry())\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"getupvalue:at:",0
,function(self,f,up)
return (debug.getupvalue(f,up))
;
end
,"accessing","getupvalue: f at: up\r\n\t\" Returns  the name and the value of the upvalue with index up of the function f.\r\n\tReturns nil if there is no upvalue with the given index.\r\n\tVariable names starting with $( (open parenthesis) represent variables with no known names (variables from chunks saved without debug information).\r\n\t\"\r\n\r\n\t^{lua'debug.getupvalue(f,up)'}","function(self,f,up)\r\nreturn (debug.getupvalue(f,up))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"getuservalue:",0
,function(self,u)
return (debug.getuservalue(u))
;
end
,"accessing","getuservalue: u\r\n\t\" Returns the Lua value associated to u.\r\n\tIf u is not a full userdata, returns nil.\r\n\t\"\r\n\r\n\t^{lua'debug.getuservalue(u)'}","function(self,u)\r\nreturn (debug.getuservalue(u))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"sethook:hook:mask:count:",0
,function(self,thread,hook,mask,count)
return (debug.sethook(thread,hook,mask,count))
;
end
,"accessing","sethook: thread hook: hook mask: mask count: count\r\n\t\" Sets the given function as a hook. \"\r\n\r\n\t^{lua'debug.sethook(thread,hook,mask,count)'}","function(self,thread,hook,mask,count)\r\nreturn (debug.sethook(thread,hook,mask,count))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"sethook:mask:count:",0
,function(self,hook,mask,count)
return (debug.sethook(hook,mask,count))
;
end
,"accessing","sethook: hook mask: mask count: count\r\n\t\" Sets the given function as a hook. \"\r\n\r\n\t^{lua'debug.sethook(hook,mask,count)'}","function(self,hook,mask,count)\r\nreturn (debug.sethook(hook,mask,count))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"sethook:hook:mask:",0
,function(self,thread,hook,mask)
return (debug.sethook(thread,hook,mask))
;
end
,"accessing","sethook: thread hook: hook mask: mask\r\n\t\" Sets the given function as a hook. \"\r\n\r\n\t^{lua'debug.sethook(thread,hook,mask)'}","function(self,thread,hook,mask)\r\nreturn (debug.sethook(thread,hook,mask))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"sethook:mask:",0
,function(self,hook,mask)
return (debug.sethook(hook,mask))
;
end
,"accessing","sethook: hook mask: mask\r\n\t\" Sets the given function as a hook. \"\r\n\r\n\t^{lua'debug.sethook(hook,mask)'}","function(self,hook,mask)\r\nreturn (debug.sethook(hook,mask))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"setlocal:level:local:value:",0
,function(self,thread,level,index,value)
return (debug.setlocal(thread,level,index,value))
;
end
,"accessing","setlocal: thread level: level local: index value: value\r\n\t\" Assigns the value value to the local variable at index of the function at level level of the stack.\r\n\tReturns nil if there is no local variable with the given index, and raises an error when called with a level out of range.\r\n\t\"\r\n\r\n\t^{lua'debug.setlocal(thread,level,index,value)'}","function(self,thread,level,index,value)\r\nreturn (debug.setlocal(thread,level,index,value))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"setlocal:local:value:",0
,function(self,level,index,value)
return (debug.setlocal(level,index,value))
;
end
,"accessing","setlocal: level local: index value: value\r\n\t\" Assigns the value value to the local variable at index of the function at level level of the stack.\r\n\tReturns nil if there is no local variable with the given index, and raises an error when called with a level out of range.\r\n\t\"\r\n\r\n\t^{lua'debug.setlocal(level,index,value)'}","function(self,level,index,value)\r\nreturn (debug.setlocal(level,index,value))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"setupvalue:up:value:",0
,function(self,f,up,value)
return (debug.setupvalue(f,up,value))
;
end
,"accessing","setupvalue: f up: up value: value\r\n\t\" Assigns the value value to the upvalue with index up of the function f.\r\n\tReturns nil if there is no upvalue with the given index.\r\n\tOtherwise, it returns the name of the upvalue.\r\n\t\"\r\n\r\n\t^{lua'debug.setupvalue(f,up,value)'}","function(self,f,up,value)\r\nreturn (debug.setupvalue(f,up,value))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"setuservalue:to:",0
,function(self,udata,value)
return (debug.setuservalue(udata,value))
;
end
,"accessing","setuservalue: udata to: value\r\n\t\" Sets the given value as the Lua value associated to the given udata.\r\n\tudata must be a full userdata.\r\n\tReturns udata. \"\r\n\r\n\t^{lua'debug.setuservalue(udata,value)'}","function(self,udata,value)\r\nreturn (debug.setuservalue(udata,value))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"traceback:message:level:",0
,function(self,thread,message,level)
return (debug.traceback(thread,message,level))
;
end
,"accessing","traceback: thread message: message level: level\r\n\t\" If message is present but is neither a string nor nil, this function returns message without further processing.\r\n\tOtherwise, it returns a string with a traceback of the call stack.\r\n\tThe optional message string is appended at the beginning of the traceback.\r\n\tAn optional level number tells at which level to start the traceback\r\n\t\"\r\n\r\n\t^{lua'debug.traceback(thread,message,level)'}","function(self,thread,message,level)\r\nreturn (debug.traceback(thread,message,level))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"traceback:message:",0
,function(self,thread,message)
return (debug.traceback(thread,message))
;
end
,"accessing","traceback: thread message: message\r\n\r\n\t^{lua'debug.traceback(thread,message)'}","function(self,thread,message)\r\nreturn (debug.traceback(thread,message))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"traceback:",0
,function(self,thread)
return (debug.traceback(thread))
;
end
,"accessing","traceback: thread\r\n\r\n\t^{lua'debug.traceback(thread)'}","function(self,thread)\r\nreturn (debug.traceback(thread))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"traceback:level:",0
,function(self,message,level)
return (debug.traceback(message,level))
;
end
,"accessing","traceback: message level: level\r\n\r\n\t^{lua'debug.traceback(message,level)'}","function(self,message,level)\r\nreturn (debug.traceback(message,level))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"upvalueid:at:",0
,function(self,f,n)
return (debug.upvalueid(f,n))
;
end
,"accessing","upvalueid: f at: n\r\n\t\" Returns a unique identifier (as a light userdata) for the upvalue numbered n from the given function.\r\n\tThese unique identifiers allow to check whether different closures share upvalues.\r\n\tLua closures that share an upvalue (that is, that access a same external local variable) will return identical ids for those upvalue indices.\r\n\t\"\r\n\r\n\t^{lua'debug.upvalueid(f,n)'}","function(self,f,n)\r\nreturn (debug.upvalueid(f,n))\r\n;\r\nend")

smalltalk:bind(smalltalk.Debug["$klass"],"upvaluejoin:n1:f2:n2:",0
,function(self,f1,n1,f2,n2)
return (debug.upvaluejoin(f1,n1,f2,n2))
;
end
,"util","upvaluejoin: f1 n1: n1 f2: f2 n2: n2\r\n\t\" Make the n1-th upvalue of the Lua closure f1 refer to the n2-th upvalue of the Lua closure f2. \"\r\n\r\n\t^{lua'debug.upvaluejoin(f1,n1,f2,n2)'}","function(self,f1,n1,f2,n2)\r\nreturn (debug.upvaluejoin(f1,n1,f2,n2))\r\n;\r\nend")
