local origins = {
	"C:/C/lua",
	"~/Desktop",
	love.filesystem.getSaveDirectory( ),
	love.filesystem.getUserDirectory( ),
	love.filesystem.getWorkingDirectory( ),
	""
}

local m8n = nil
local useStd = true

function foundM8n(options,fileName)
	for i,path in ipairs(options) do
		m8n = path.."/m8n/"
		--print("--trying to load "..m8n..fileName)
		if love.filesystem.getInfo(m8n..fileName) then
			useStd = false
			--print("--File found at "..m8n)
			return m8n
		end
		if (io.open(m8n..fileName, "r")) then
			useStd = true
			--print("--File found at "..m8n)
			return m8n
		end
	end
	return nil
end

function doM8nFile(fileName)
	if foundM8n(origins,fileName)==nil then
		--error("Missing file "..fileName)
		print("--Missing file "..fileName)
		return
	end
	local pathName = m8n..fileName
	if useStd then return dofile(pathName) end
	local contents = love.filesystem.read(pathName)
	if contents then
		contents = loadstring(contents)
		if contents then return contents() end
	end
	error("Loading file "..pathName)
end

doM8nFile("s8.snapshot.lua")
print(("'3+4=',(3+4)"):evaluate())
--print(smalltalk.Object:selectors():sorted():asLiteral())

doM8nFile("s8/library/luasocket.st.lua")
doM8nFile("s8/library/SimpleHTTPServer.st.lua")
doM8nFile("s8/library/SimpleJson.st.lua")
doM8nFile("s8/library/systemServer/SystemServer.st.lua")
doM8nFile("s8/library/swiki/swiki.st.lua")
doM8nFile("s8/library/swiki/swikiLove.st.lua")
doM8nFile("library/love/love.st.lua")
doM8nFile("library/love/loveframes.st.lua")

doM8nFile("library/love/loveSamples.st.lua")
doM8nFile("library/love/WorkInProgress.st.lua")

smalltalk.Sample = "loaded"
code=[[
	SystemServer silent: true; start.
]]
code:fileIn()
