
self note: 'Saving default.snapshot for browsing/debugging'.
'function print(text) { return console.log(text); }
',Snapshot contents outputToFile: '../default.snapshot.js'!

| boot bootPathName bootName |
bootPathName := 'library/s8/boot.' ,#{targetLanguage}.
true ifTrue: [ ^self note: 'Boot file ' ,bootPathName printString ,' found' ].
self note: 'Generating Boot section for ' ,#{targetLanguage}.
bootName := 'S8_Boot_' ,#{targetLanguage}.
(Smalltalk includesKey: bootName) ifTrue: [ ^self ].
self note: 'Embedding the boot file into the system.'.
boot := # #read: bootPathName.
boot isNil ifTrue: [ ^self error: 'Missing Boot file ' ,bootPathName ].
self note: 'boot contents saved into global ' ,bootName.
Smalltalk	at: 'S8_Boot_' ,#{targetLanguage}
	put: boot!

| image tag source |
self note: 'Exporting the system image'.
image := LuaEncoder export: #all.
String doItSelector implementors do: [:each| each removeFromSystem ].
image outputToFile: '../s8.image.' ,#{targetLanguage}.

self note: 'Collecting methods with errors...'.
tag := 'NIY:' ,'#luaMethodBody: '.
self note: 'ToDo list for ',tag.
source := image stream.
[source atEnd] whileFalse: [
	source upTo: tag.
	source atEnd ifFalse: [
		self print: '	',(source upTo: $")
	].
].!

| boot image snapshot bootPathName |
self note: 'Writing the system snapshot'.
bootPathName := 'library/s8/boot.' ,#{targetLanguage}.
boot := # #read: bootPathName.
String doItSelector implementors do: [:each| each removeFromSystem ].
image := # #read: '../s8.image.' ,#{targetLanguage}.
snapshot := 'smalltalk = (function() -- Snapshot built on ' ,DateTime today,'
' ,boot ,'
end)()

' ,image.
snapshot outputToFile: '../s8.snapshot.' ,#{targetLanguage}!

self note: #done!
