
-- fileIn("s8/library/SimpleHTTPServer.st")
smalltalk:addClass("SimpleHTTPServer",smalltalk.EventManager,smalltalk:newArray({"host","port","socket","httpHandlers","callback","crlf"}),"SimpleHTTPServer")

smalltalk.SimpleHTTPServer["$comment"]="\r\n\tSimple, pluggable non-blocking HTTP server.\r\n\t@2019-today Alejandro Reimondo aleReimondo@smalltalking.net\r\n\tPublished under U8 license terms see http://u8.smalltalking.net\r\n\tSee rfc2616 for more information about this HTTP server implementation\r\n"

smalltalk.SimpleHTTPServer["$klass"]["$iVarNames"]=smalltalk:newArray({"current","socketSupport"})

smalltalk:bind(smalltalk.SimpleHTTPServer["$klass"],"initializeCurrent",0
,function(self)
(function()
	local _s8_value=((self):new())
	self["@current"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeCurrent\r\n\t\" Private - Initialize the current of the receiver. \"\r\n\r\n\tcurrent := self new","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):new())\r\n\tself[\"@current\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer["$klass"],"current",0
,function(self)
if (smalltalk:isNil_((self["@current"])))==true then (self):initializeCurrent(); end;
return (self["@current"]);
end
,"accessing","current\r\n\t\" Return the current of the receiver. \"\r\n\r\n\tcurrent isNil ifTrue: [ self initializeCurrent ].\r\n\t^current","function(self)\r\nif (smalltalk:isNil_((self[\"@current\"])))==true then (self):initializeCurrent(); end;\r\nreturn (self[\"@current\"]);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer["$klass"],"current:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@current"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","current: anObject\r\n\t\" Set the current of the receiver. \"\r\n\r\n\tcurrent := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@current\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer["$klass"],"initializeSocketSupport",0
,function(self)
(function()
	local _s8_value=((self):detectSocketSupport())
	self["@socketSupport"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeSocketSupport\r\n\t\" Private - Initialize the socketSupport of the receiver. \"\r\n\r\n\tsocketSupport := self detectSocketSupport","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):detectSocketSupport())\r\n\tself[\"@socketSupport\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer["$klass"],"socketSupport",0
,function(self)
if (smalltalk:isNil_((self["@socketSupport"])))==true then (self):initializeSocketSupport(); end;
return (self["@socketSupport"]);
end
,"accessing","socketSupport\r\n\t\" Return the socketSupport of the receiver. \"\r\n\r\n\tsocketSupport isNil ifTrue: [ self initializeSocketSupport ].\r\n\t^socketSupport","function(self)\r\nif (smalltalk:isNil_((self[\"@socketSupport\"])))==true then (self):initializeSocketSupport(); end;\r\nreturn (self[\"@socketSupport\"]);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer["$klass"],"socketSupport:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@socketSupport"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","socketSupport: anObject\r\n\t\" Set the socketSupport of the receiver. \"\r\n\r\n\tsocketSupport := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@socketSupport\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer["$klass"],"detectSocketSupport",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local api=nil
if ((smalltalk.Smalltalk):includesKey_("LuaStudioLibrary"))==true then return ("luaStudio"); end;
if ((smalltalk.Smalltalk):includesKey_("LuaSocket"))==true then ((function()
return ((function()
	local _s8_value=(((smalltalk.Lua):socket()):nativeClass())
	api=_s8_value
	return _s8_value
end)())
end)):on_do_(smalltalk.Error,(function()
return (nil)
end));
smalltalk:if_true_false_((smalltalk:notNil_((api))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ("luaSocket")
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"socketSupport","detectSocketSupport\r\n\t\" Private - Returns a valid socket implementation (or nil) \"\r\n\r\n\t| api |\r\n\t(Smalltalk includesKey: #LuaStudioLibrary) ifTrue: [ ^#luaStudio ].\r\n\t(Smalltalk includesKey: #LuaSocket) ifTrue: [\r\n\t\t[ api := Lua socket nativeClass ] on: Error do: [].\r\n\t\tapi notNil ifTrue: [ ^#luaSocket ].\r\n\t].\r\n\t^nil","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal api=nil\r\nif ((smalltalk.Smalltalk):includesKey_(\"LuaStudioLibrary\"))==true then return (\"luaStudio\"); end;\r\nif ((smalltalk.Smalltalk):includesKey_(\"LuaSocket\"))==true then ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(((smalltalk.Lua):socket()):nativeClass())\r\n\tapi=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):on_do_(smalltalk.Error,(function()\r\nreturn (nil)\r\nend));\r\nsmalltalk:if_true_false_((smalltalk:notNil_((api))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (\"luaSocket\")\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"support",0
,function(self)
local api=nil
(function()
	local _s8_value=(((self)["$klass"]):socketSupport())
	api=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((api)))==true then (self):error_("Missing socket support"); end;
return (api);
end
,"implementation","support\r\n\t\" Private - Returns the sockets support to run the server. \"\r\n\r\n\t| api |\r\n\tapi := self class socketSupport.\r\n\tapi isNil ifTrue: [ self error: 'Missing socket support' ].\r\n\t^api","function(self)\r\nlocal api=nil\r\n(function()\r\n\tlocal _s8_value=(((self)[\"$klass\"]):socketSupport())\r\n\tapi=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((api)))==true then (self):error_(\"Missing socket support\"); end;\r\nreturn (api);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"hostAt:",0
,function(self,address)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (smalltalk:isObject_equalTo_(((self):support()),"luaStudio"))==true then if ((address):isEmpty())==true then smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((smalltalk.System):systemName()),"windows")),nil,(function()
(self):note_("LuaStudio API is buggy in this version (under Android os), so we need to use localhost");return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.Host):_at((Lib["Sys"]["Net"]["Host"]).localhost()))
end
)()
error(_s8Ret_,0)
end)())
end)); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.Host):_at(address))
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((address),"")),(function()
return ("*")
end),(function()
return (address)
end)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"implementation","hostAt: address\r\n\t\" Private - Returns the host at address.\"\r\n\r\n\tself support = #luaStudio ifTrue: [\r\n\t\taddress isEmpty ifTrue: [\r\n\t\t\tSystem systemName = #windows ifFalse: [\r\n\t\t\t\tself note: 'LuaStudio API is buggy in this version (under Android os), so we need to use localhost'.\r\n\t\t\t\t^Host @ #{Lib}[#Sys][#Net][#Host] #_localhost\r\n\t\t\t].\r\n\t\t].\r\n\t\t^Host @ address\r\n\t].\r\n\t^address = '' ifTrue: [ $* ] ifFalse: [ address ]","function(self,address)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (smalltalk:isObject_equalTo_(((self):support()),\"luaStudio\"))==true then if ((address):isEmpty())==true then smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((smalltalk.System):systemName()),\"windows\")),nil,(function()\r\n(self):note_(\"LuaStudio API is buggy in this version (under Android os), so we need to use localhost\");return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.Host):_at((Lib[\"Sys\"][\"Net\"][\"Host\"]).localhost()))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.Host):_at(address))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((address),\"\")),(function()\r\nreturn (\"*\")\r\nend),(function()\r\nreturn (address)\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"bindSocket",0
,function(self)
if (smalltalk:isObject_equalTo_(((self):support()),"luaSocket"))==true then (function()
	local _s8_value=(((smalltalk.Lua):socket()):bind_port_((self):host(),(self):port()))
	self["@socket"]=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((self["@socket"])))==true then return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Binding socket to "),(self):host())),":")),(self):port()))); end;
return (true); end;
(function()
	local _s8_value=((smalltalk.Socket):new())
	self["@socket"]=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):bind_port_((self):host(),(self):port());
	(_s8_rec):listen_(30);
	return ((_s8_rec):setBlocking_(false))
end
)(self["@socket"]);
return (true);
end
,"implementation","bindSocket\r\n\t\" Private - Instantiate the socket and bind to host and port. \"\r\n\r\n\t(self support = #luaSocket) ifTrue: [\r\n\t\tsocket := Lua socket bind: self host port: self port.\r\n\t\tsocket isNil ifTrue: [\r\n\t\t\t^self error: 'Binding socket to ' ,self host ,$: ,self port\r\n\t\t].\r\n\t\t^true\r\n\t].\r\n\tsocket := Socket new.\r\n\tsocket\tbind: self host port: self port;\r\n\t\tlisten: 30; setBlocking: false.\r\n\t^true","function(self)\r\nif (smalltalk:isObject_equalTo_(((self):support()),\"luaSocket\"))==true then (function()\r\n\tlocal _s8_value=(((smalltalk.Lua):socket()):bind_port_((self):host(),(self):port()))\r\n\tself[\"@socket\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((self[\"@socket\"])))==true then return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Binding socket to \"),(self):host())),\":\")),(self):port()))); end;\r\nreturn (true); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Socket):new())\r\n\tself[\"@socket\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):bind_port_((self):host(),(self):port());\r\n\t(_s8_rec):listen_(30);\r\n\treturn ((_s8_rec):setBlocking_(false))\r\nend\r\n)(self[\"@socket\"]);\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"read:lineOr:",0
,function(self,client,result)
if (smalltalk:isObject_equalTo_(((self):support()),"luaSocket"))==true then local read=nil
(function()
	local _s8_value=(((client):receive()):first())
	read=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:isNil_((read))),(function()
return (result)
end),(function()
return (read)
end))); end;
return (((client):input()):readLineOr_(result));
end
,"implementation","read: client lineOr: result\r\n\t\" Private - Try to read a line on client input.\r\n\tReturns the line read or result in case of no input read.\r\n\t\"\r\n\r\n\t(self support = #luaSocket) ifTrue: [ | read |\r\n\t\tread := client receive first.\r\n\t\t^read isNil ifTrue: [ result ] ifFalse: [ read ]\r\n\t].\r\n\t^client input readLineOr: result","function(self,client,result)\r\nif (smalltalk:isObject_equalTo_(((self):support()),\"luaSocket\"))==true then local read=nil\r\n(function()\r\n\tlocal _s8_value=(((client):receive()):first())\r\n\tread=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((read))),(function()\r\nreturn (result)\r\nend),(function()\r\nreturn (read)\r\nend))); end;\r\nreturn (((client):input()):readLineOr_(result));\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"write:on:",0
,function(self,data,client)
if (smalltalk:isObject_equalTo_(((self):support()),"luaSocket"))==true then return ((client):send_(data)); end;
return ((client):write_(data));
end
,"implementation","write: data on: client\r\n\t\" Private - Send data to client output. \"\r\n\r\n\t(self support = #luaSocket) ifTrue: [\r\n\t\t^client send: data\r\n\t].\r\n\t^client write: data","function(self,data,client)\r\nif (smalltalk:isObject_equalTo_(((self):support()),\"luaSocket\"))==true then return ((client):send_(data)); end;\r\nreturn ((client):write_(data));\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"pumpRegistry",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(smalltalk.Smalltalk):at_ifAbsent_("View3D",(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:newArray({}))
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.View3D):preRenderActions())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"implementation","pumpRegistry\r\n\t\" Private - Returns a collection where the callback is added to listen for client requests.\r\n\tThe collection must be evaluated by the mail loop to maintain the receiver listening for clients.\r\n\tIn case of an empty collection, the application must send #listen frequently to maintain clients happy.\r\n\t\"\r\n\r\n\tSmalltalk at: #View3D ifAbsent: [ ^#() ].\r\n\t^View3D preRenderActions","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(smalltalk.Smalltalk):at_ifAbsent_(\"View3D\",(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:newArray({}))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.View3D):preRenderActions())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"initializeHost",0
,function(self)
(function()
	local _s8_value=((self):hostAt_((smalltalk.String):new()))
	self["@host"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeHost\r\n\t\" Private - Initialize the host of the receiver. \"\r\n\r\n\thost := (self hostAt: String new)","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):hostAt_((smalltalk.String):new()))\r\n\tself[\"@host\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"host",0
,function(self)
if (smalltalk:isNil_((self["@host"])))==true then (self):initializeHost(); end;
return (self["@host"]);
end
,"accessing","host\r\n\t\" Return the host of the receiver. \"\r\n\r\n\thost isNil ifTrue: [ self initializeHost ].\r\n\t^host","function(self)\r\nif (smalltalk:isNil_((self[\"@host\"])))==true then (self):initializeHost(); end;\r\nreturn (self[\"@host\"]);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"host:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@host"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","host: anObject\r\n\t\" Set the host of the receiver. \"\r\n\r\n\thost := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@host\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"initializePort",0
,function(self)
(function()
	local _s8_value=(8088)
	self["@port"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializePort\r\n\t\" Private - Initialize the port of the receiver. \"\r\n\r\n\tport := 8088","function(self)\r\n(function()\r\n\tlocal _s8_value=(8088)\r\n\tself[\"@port\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"port",0
,function(self)
if (smalltalk:isNil_((self["@port"])))==true then (self):initializePort(); end;
return (self["@port"]);
end
,"accessing","port\r\n\t\" Return the port of the receiver. \"\r\n\r\n\tport isNil ifTrue: [ self initializePort ].\r\n\t^port","function(self)\r\nif (smalltalk:isNil_((self[\"@port\"])))==true then (self):initializePort(); end;\r\nreturn (self[\"@port\"]);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"port:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@port"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","port: anObject\r\n\t\" Set the port of the receiver. \"\r\n\r\n\tport := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@port\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"initializeCallback",0
,function(self)
(function()
	local _s8_value=((function(ignored)
(self):listen();return (nil)
end))
	self["@callback"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeCallback\r\n\t\" Private - Initialize the callback of the receiver. \"\r\n\r\n\tcallback := [:ignored| self listen. nil ]","function(self)\r\n(function()\r\n\tlocal _s8_value=((function(ignored)\r\n(self):listen();return (nil)\r\nend))\r\n\tself[\"@callback\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"callback",0
,function(self)
if (smalltalk:isNil_((self["@callback"])))==true then (self):initializeCallback(); end;
return (self["@callback"]);
end
,"accessing","callback\r\n\t\" Return the callback of the receiver. \"\r\n\r\n\tcallback isNil ifTrue: [ self initializeCallback ].\r\n\t^callback","function(self)\r\nif (smalltalk:isNil_((self[\"@callback\"])))==true then (self):initializeCallback(); end;\r\nreturn (self[\"@callback\"]);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"callback:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@callback"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","callback: anObject\r\n\t\" Set the callback of the receiver. \"\r\n\r\n\tcallback := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@callback\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"initializeHttpHandlers",0
,function(self)
(function()
	local _s8_value=((self):needsHTTPHandlers())
	self["@httpHandlers"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeHttpHandlers\r\n\t\" Private - Initialize the httpHandlers of the receiver. \"\r\n\r\n\thttpHandlers := self needsHTTPHandlers","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):needsHTTPHandlers())\r\n\tself[\"@httpHandlers\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"httpHandlers",0
,function(self)
if (smalltalk:isNil_((self["@httpHandlers"])))==true then (self):initializeHttpHandlers(); end;
return (self["@httpHandlers"]);
end
,"accessing","httpHandlers\r\n\t\" Return the httpHandlers of the receiver. \"\r\n\r\n\thttpHandlers isNil ifTrue: [ self initializeHttpHandlers ].\r\n\t^httpHandlers","function(self)\r\nif (smalltalk:isNil_((self[\"@httpHandlers\"])))==true then (self):initializeHttpHandlers(); end;\r\nreturn (self[\"@httpHandlers\"]);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"httpHandlers:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@httpHandlers"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","httpHandlers: anObject\r\n\t\" Set the httpHandlers of the receiver. \"\r\n\r\n\thttpHandlers := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@httpHandlers\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"crlf",0
,function(self)
return (self["@crlf"]);
end
,"accessing","crlf\r\n\t\" Return the crlf of the receiver. \"\r\n\r\n\t^crlf","function(self)\r\nreturn (self[\"@crlf\"]);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer["$klass"],"constructEventsTriggered",0
,function(self)
return (smalltalk:object_comma_((smalltalk:newArray({"postProcess:with:", "send:response:with:", "needsRequestFor:with:", "needsHandlerFor:with:", "acceptVersion:", "getHttpHandlers", "getHttpHandlers:", "openResponseLines:at:with:", "needsResource:with:", "closeResponseLines:at:with:", "needsContents:with:", "needsAccessControlAllow:at:with:", "needsContentType:at:with:", "needsContentLength:at:with:"})),smalltalk:superImplementor(smalltalk.SimpleHTTPServer["$klass"],"constructEventsTriggered")(self)));
end
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^#(\t#postProcess:with:\r\n\t\t#send:response:with:\r\n\t\t#needsRequestFor:with:\r\n\t\t#needsHandlerFor:with:\r\n\t\t#acceptVersion:\r\n\t\t#getHttpHandlers #getHttpHandlers:\r\n\t\t#openResponseLines:at:with:\r\n\t\t#needsResource:with:\r\n\t\t#closeResponseLines:at:with:\r\n\t\t#needsContents:with:\r\n\t\t#needsAccessControlAllow:at:with:\r\n\t\t#needsContentType:at:with:\r\n\t\t#needsContentLength:at:with:\r\n\t) ,super constructEventsTriggered","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:newArray({\"postProcess:with:\", \"send:response:with:\", \"needsRequestFor:with:\", \"needsHandlerFor:with:\", \"acceptVersion:\", \"getHttpHandlers\", \"getHttpHandlers:\", \"openResponseLines:at:with:\", \"needsResource:with:\", \"closeResponseLines:at:with:\", \"needsContents:with:\", \"needsAccessControlAllow:at:with:\", \"needsContentType:at:with:\", \"needsContentLength:at:with:\"})),smalltalk:superImplementor(smalltalk.SimpleHTTPServer[\"$klass\"],\"constructEventsTriggered\")(self)));\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer["$klass"],"example",0
,function(self)
local server=nil
(function()
	local _s8_value=((self):current())
	server=_s8_value
	return _s8_value
end)();
(server):when_do_("needsContents:with:",(function(uri,headers)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("<html>\r\n<head><title>"),((self)["$klass"]):name()))," example</title></head>\r\n<body><h1>Hello from S8</h1>\r\n<hr>Headers:<br><pre>")),(((headers):keys()):sorted()):inject_into_("",(function(total,key)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),key))," : ")),((headers):at_(key)):asLiteral())),"<br>"))
end)))),"</pre>\r\n</body></html>"))
end));
(server):when_do_("postProcess:with:",(function(start,headers)
return (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((start))),(function()
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((start):first()),"GET")),(function()
return ((smalltalk:newArray({"/quit", "/exit", "/stop"})):includes_((start):second()))
end)))
end))),(function()
return ((server):stop())
end),nil))
end));
(server):start();
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("server started at "),smalltalk:toString_(((server):host())))),":")),(server):port()));
return (server);
end
,"sample","example\r\n\t\" server - Implements a simple (non-blocking) HTTP server \"\r\n\r\n\t| server |\r\n\tserver := self current.\r\n\tserver when: #needsContents:with: do: [:uri :headers|\r\n\t\t'<html>\r\n<head><title>' ,self class name,' example</title></head>\r\n<body><h1>Hello from S8</h1>\r\n<hr>Headers:<br><pre>' ,(headers keys sorted inject: '' into: [:total :key|\r\n\t\ttotal, key ,' : ' ,(headers at: key) asLiteral ,'<br>'\r\n]),'</pre>\r\n</body></html>'\r\n\t].\r\n\tserver when: #postProcess:with: do: [:start :headers|\r\n\t\t(start notNil\r\n\t\t\tand: [ start first = #GET\r\n\t\t\tand: [ #('/quit' '/exit' '/stop') includes: start second ]]) ifTrue: [\r\n\t\t\tserver stop.\r\n\t\t]\r\n\t].\r\n\tserver start.\r\n\tself note: 'server started at ' ,server host toString ,':' ,server port.\r\n\t^server","function(self)\r\nlocal server=nil\r\n(function()\r\n\tlocal _s8_value=((self):current())\r\n\tserver=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(server):when_do_(\"needsContents:with:\",(function(uri,headers)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"<html>\\r\\n<head><title>\"),((self)[\"$klass\"]):name())),\" example</title></head>\\r\\n<body><h1>Hello from S8</h1>\\r\\n<hr>Headers:<br><pre>\")),(((headers):keys()):sorted()):inject_into_(\"\",(function(total,key)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),key)),\" : \")),((headers):at_(key)):asLiteral())),\"<br>\"))\r\nend)))),\"</pre>\\r\\n</body></html>\"))\r\nend));\r\n(server):when_do_(\"postProcess:with:\",(function(start,headers)\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((start))),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((start):first()),\"GET\")),(function()\r\nreturn ((smalltalk:newArray({\"/quit\", \"/exit\", \"/stop\"})):includes_((start):second()))\r\nend)))\r\nend))),(function()\r\nreturn ((server):stop())\r\nend),nil))\r\nend));\r\n(server):start();\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"server started at \"),smalltalk:toString_(((server):host())))),\":\")),(server):port()));\r\nreturn (server);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"startListening",0
,function(self)
((self):pumpRegistry()):add_((self):callback());
return (self);
end
,"private","startListening\r\n\t\" Private - Start listening for clients. \"\r\n\r\n\tself pumpRegistry add: self callback.","function(self)\r\n((self):pumpRegistry()):add_((self):callback());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"stopListening",0
,function(self)
((self):pumpRegistry()):remove_ifAbsent_((self):callback(),(function()
return (nil)
end));
return (self);
end
,"private","stopListening\r\n\t\" Private - Stop listening for clients. \"\r\n\r\n\tself pumpRegistry remove: self callback ifAbsent: [].","function(self)\r\n((self):pumpRegistry()):remove_ifAbsent_((self):callback(),(function()\r\nreturn (nil)\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"ip:",0
,function(self,ipAddress)
(self):host_((self):hostAt_(ipAddress));
return (self);
end
,"configuration","ip: ipAddress\r\n\t\" Set the receiver's host at IP adress. \"\r\n\r\n\tself host: (self hostAt: ipAddress)","function(self,ipAddress)\r\n(self):host_((self):hostAt_(ipAddress));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"isRunning",0
,function(self)
return (smalltalk:notNil_((self["@socket"])));
end
,"query","isRunning\r\n\t\" Returns true if the receiver is runnning. \"\r\n\r\n\t^socket notNil","function(self)\r\nreturn (smalltalk:notNil_((self[\"@socket\"])));\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"run",0
,function(self)
while ((function()
return ((self):isRunning())
end))() do (self):listen(); end;
return (self);
end
,"running","run\r\n\t\" Run the receiver in a loop until stopped. \"\r\n\r\n\t[ self isRunning ] whileTrue: [ self listen ]","function(self)\r\nwhile ((function()\r\nreturn ((self):isRunning())\r\nend))() do (self):listen(); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"stop",0
,function(self)
if (smalltalk:isNil_((self["@socket"])))==true then return (self); end;
(self):stopListening();
(self["@socket"]):close();
(function()
	local _s8_value=(nil)
	self["@socket"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"running","stop\r\n\t\" Stop the receiver. \"\r\n\r\n\tsocket isNil ifTrue: [ ^self ].\r\n\tself stopListening.\r\n\tsocket close.\r\n\tsocket := nil.","function(self)\r\nif (smalltalk:isNil_((self[\"@socket\"])))==true then return (self); end;\r\n(self):stopListening();\r\n(self[\"@socket\"]):close();\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@socket\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"peek",0
,function(self)
return (smalltalk:if_true_false_((smalltalk:notNil_((self["@socket"]))),(function()
(self["@socket"]):settimeout_((1):_slash(1000));return ((self["@socket"]):acceptOrNil())
end),nil));
end
,"private","peek\r\n\t\" Private - Peek a client. \"\r\n\r\n\t^socket notNil ifTrue: [\r\n\t\tsocket settimeout: 1/1000.\r\n\t\tsocket acceptOrNil\r\n\t]","function(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((self[\"@socket\"]))),(function()\r\n(self[\"@socket\"]):settimeout_((1):_slash(1000));return ((self[\"@socket\"]):acceptOrNil())\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"start",0
,function(self)
if (smalltalk:notNil_((self["@socket"])))==true then (self):close(); end;
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:asCharacter_((13))),smalltalk:asCharacter_((10))))
	self["@crlf"]=_s8_value
	return _s8_value
end)();
(self):bindSocket();
if (smalltalk:notNil_((self["@socket"])))==true then (self):startListening(); end;
return (self);
end
,"running","start\r\n\t\" Start the receiver. \"\r\n\r\n\tsocket notNil ifTrue: [ self close ].\r\n\tcrlf := 13 asCharacter ,10 asCharacter.\r\n\tself bindSocket.\r\n\tsocket notNil ifTrue: [ self startListening ].","function(self)\r\nif (smalltalk:notNil_((self[\"@socket\"])))==true then (self):close(); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:asCharacter_((13))),smalltalk:asCharacter_((10))))\r\n\tself[\"@crlf\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):bindSocket();\r\nif (smalltalk:notNil_((self[\"@socket\"])))==true then (self):startListening(); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"step",0
,function(self)
local client=nil
if not (((self):isRunning()))==true then return (false); end;
(function()
	local _s8_value=((self):peek())
	client=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((client)))==true then return (false); end;
(client):setBlocking_(false);
return ((self):processMessageOn_(client));
end
,"private","step\r\n\t\" Private - Listen a client request. \"\r\n\r\n\t| client |\r\n\tself isRunning ifFalse: [ ^false ].\r\n\tclient := self peek.\r\n\tclient isNil ifTrue: [ ^false ].\r\n\tclient setBlocking: false.\r\n\t^self processMessageOn: client","function(self)\r\nlocal client=nil\r\nif not (((self):isRunning()))==true then return (false); end;\r\n(function()\r\n\tlocal _s8_value=((self):peek())\r\n\tclient=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((client)))==true then return (false); end;\r\n(client):setBlocking_(false);\r\nreturn ((self):processMessageOn_(client));\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"listen",0
,function(self)
while ((function()
return ((self):step())
end))() do end;
return (self);
end
,"private","listen\r\n\t\" Private - Listen client requests. \"\r\n\r\n\t[ self step ] whileTrue","function(self)\r\nwhile ((function()\r\nreturn ((self):step())\r\nend))() do end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"processMessageOn:",0
,function(self,client)
local start=nil
local line=nil
local headers=nil
while ((function()
(function()
	local _s8_value=((self):read_lineOr_(client,""))
	line=_s8_value
	return _s8_value
end)();return ((line):isEmpty())
end))() do (self):write_on_((self):badRequest(),client);
(client):close();
return (false); end;
(function()
	local _s8_value=((self):startLine_(line))
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	headers=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((self):read_lineOr_(client,"failed"))
	line=_s8_value
	return _s8_value
end)();return ((line):notEmpty())
end))() do smalltalk:if_true_false_((smalltalk:isObject_equalTo_((line),"failed")),(function()
return ((self):note_(smalltalk:object_comma_((((self)["$klass"]):name()),">>#processMessageOn: header - readLine failed")))
end),(function()
return ((self):addHeader_to_(line,headers))
end)); end;
(self):send_responseFor_with_(client,start,headers);
(self):postProcess_with_(start,headers);
return (true);
end
,"processing","processMessageOn: client\r\n\t\" Private - Process a client message.\r\n\thttps://tools.ietf.org/html/rfc2616#section-4\r\n\tHTTP messages consist of requests from client to server and responses from server to client.\r\n\tBoth types of message consist of a start-line, zero or more header fields (also known as headers), an empty line (i.e., a line with nothing preceding the CRLF) indicating the end of the header fields, and possibly a message-body.\r\n\t\"\r\n\r\n\t| start line headers |\r\n\t[\tline := self read: client lineOr: ''.\r\n\t\tline isEmpty ] whileTrue: [\r\n\"\t\tself note: self class name ,'>>#processMessageOn: start - readLine failed'.\r\n\"\t\tself write: self badRequest on: client.\r\n\t\tclient close. ^false\r\n\t].\r\n\tstart := self startLine: line.\r\n\theaders := PoolDictionary new.\r\n\t[\tline := self read: client lineOr: #failed.\r\n\t\tline notEmpty ] whileTrue: [\r\n\t\tline = #failed\r\n\t\tifTrue: [ self note: self class name ,'>>#processMessageOn: header - readLine failed' ]\r\n\t\tifFalse: [ self addHeader: line to: headers ]\r\n\t].\r\n\tself send: client responseFor: start with: headers.\r\n\tself postProcess: start with: headers.\r\n\t^true","function(self,client)\r\nlocal start=nil\r\nlocal line=nil\r\nlocal headers=nil\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((self):read_lineOr_(client,\"\"))\r\n\tline=_s8_value\r\n\treturn _s8_value\r\nend)();return ((line):isEmpty())\r\nend))() do (self):write_on_((self):badRequest(),client);\r\n(client):close();\r\nreturn (false); end;\r\n(function()\r\n\tlocal _s8_value=((self):startLine_(line))\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\theaders=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((self):read_lineOr_(client,\"failed\"))\r\n\tline=_s8_value\r\n\treturn _s8_value\r\nend)();return ((line):notEmpty())\r\nend))() do smalltalk:if_true_false_((smalltalk:isObject_equalTo_((line),\"failed\")),(function()\r\nreturn ((self):note_(smalltalk:object_comma_((((self)[\"$klass\"]):name()),\">>#processMessageOn: header - readLine failed\")))\r\nend),(function()\r\nreturn ((self):addHeader_to_(line,headers))\r\nend)); end;\r\n(self):send_responseFor_with_(client,start,headers);\r\n(self):postProcess_with_(start,headers);\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"send:responseFor:with:",0
,function(self,client,start,headers)
(self):triggerEvent_withArguments_ifNotHandled_("send:response:with:",(smalltalk.Array):with_with_with_(client,start,headers),(function()
(self):write_on_((self):responseFor_with_(start,headers),client);return ((client):close())
end));
return (self);
end
,"processing","send: client responseFor: start with: headers\r\n\t\" Private - Send the response to client for request start. \"\r\n\r\n\tself\ttriggerEvent: #send:response:with:\r\n\t\twithArguments: (Array with: client with: start with: headers)\r\n\t\tifNotHandled: [\r\n\t\t\tself write: (self responseFor: start with: headers) on: client.\r\n\t\t\tclient close\r\n\t\t]","function(self,client,start,headers)\r\n(self):triggerEvent_withArguments_ifNotHandled_(\"send:response:with:\",(smalltalk.Array):with_with_with_(client,start,headers),(function()\r\n(self):write_on_((self):responseFor_with_(start,headers),client);return ((client):close())\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"addHeader:to:",0
,function(self,line,headers)
local stream=nil
local key=nil
local value=nil
(function()
	local _s8_value=((line):stream())
	stream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((stream):upTo_(":")):trimBlanks())
	key=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((stream):upToEnd()):trimBlanks())
	value=_s8_value
	return _s8_value
end)();
if not (((headers):includesKey_(key)))==true then return ((headers):at_put_(key,value)); end;
if not ((((headers):at_(key)):isArray()))==true then (headers):at_put_(key,(smalltalk.Array):with_((headers):at_(key))); end;
return ((headers):at_put_(key,value));
end
,"processing","addHeader: line to: headers\r\n\t\" Private - Add a request header to headers.\r\n\thttps://tools.ietf.org/html/rfc2616#section-5.3\r\n\tThe request-header fields allow the client to pass additional information about the request, and about the client itself, to the server.\r\n\t\"\r\n\r\n\t| stream key value |\r\n\tstream := line stream.\r\n\tkey := (stream upTo: $:) trimBlanks.\r\n\tvalue := stream upToEnd trimBlanks.\r\n\t(headers includesKey: key) ifFalse: [\r\n\t\t^headers at: key put: value\r\n\t].\r\n\t(headers at: key) isArray ifFalse: [\r\n\t\theaders at: key put: (Array with: (headers at: key))\r\n\t].\r\n\t^headers at: key put: value","function(self,line,headers)\r\nlocal stream=nil\r\nlocal key=nil\r\nlocal value=nil\r\n(function()\r\n\tlocal _s8_value=((line):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((stream):upTo_(\":\")):trimBlanks())\r\n\tkey=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((stream):upToEnd()):trimBlanks())\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((headers):includesKey_(key)))==true then return ((headers):at_put_(key,value)); end;\r\nif not ((((headers):at_(key)):isArray()))==true then (headers):at_put_(key,(smalltalk.Array):with_((headers):at_(key))); end;\r\nreturn ((headers):at_put_(key,value));\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"startLine:",0
,function(self,line)
local stream=nil
local method=nil
local uri=nil
(function()
	local _s8_value=((line):stream())
	stream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((stream):upTo_(" "))
	method=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((stream):upTo_(" "))
	uri=_s8_value
	return _s8_value
end)();
if not ((smalltalk:isObject_equalTo_(((stream):upTo_("/")),"HTTP")))==true then return (nil); end;
return ((smalltalk.Array):with_with_with_(method,uri,(stream):upToEnd()));
end
,"processing","startLine: line\r\n\t\" Private - Returns the result of parsing a request start line.\r\n\tAn array containing:\r\n\t\tMethod\t\thttps://tools.ietf.org/html/rfc2616#section-5.1.1\r\n\t\tRequest-URI\thttps://tools.ietf.org/html/rfc2616#section-5.1.2\r\n\t\tversion\r\n\t\"\r\n\r\n\t| stream method uri |\r\n\tstream := line stream.\r\n\tmethod := stream upTo: $ .\r\n\turi := stream upTo: $ .\r\n\t(stream upTo: $/) = #HTTP ifFalse: [ ^nil ]. \"not a start request line\"\r\n\t^Array with: method with: uri with: stream upToEnd","function(self,line)\r\nlocal stream=nil\r\nlocal method=nil\r\nlocal uri=nil\r\n(function()\r\n\tlocal _s8_value=((line):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((stream):upTo_(\" \"))\r\n\tmethod=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((stream):upTo_(\" \"))\r\n\turi=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:isObject_equalTo_(((stream):upTo_(\"/\")),\"HTTP\")))==true then return (nil); end;\r\nreturn ((smalltalk.Array):with_with_with_(method,uri,(stream):upToEnd()));\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"postProcess:with:",0
,function(self,start,headers)
(self):triggerEvent_withArguments_("postProcess:with:",(smalltalk.Array):with_with_(start,headers));
return (self);
end
,"processing","postProcess: start with: headers\r\n\t\" Private - Post process a request. \"\r\n\r\n\"DEBUG- true ifTrue: [\r\n# #print: #DEBUG with: #postProcessing.\r\n^self stop\r\n].\"\r\n\r\n\tself\ttriggerEvent: #postProcess:with:\r\n\t\twithArguments: (Array with: start with: headers)","function(self,start,headers)\r\n(self):triggerEvent_withArguments_(\"postProcess:with:\",(smalltalk.Array):with_with_(start,headers));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"responseFor:with:",0
,function(self,start,headers)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (smalltalk:isNil_((start)))==true then return ((self):badRequest()); end;
if not ((smalltalk:isObject_equalTo_(((start):last()),"1.1")))==true then (self):triggerEvent_withArguments_ifNotHandled_("acceptVersion:",(smalltalk.Array):with_(start),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):versionNotSupported_((start):last()))
end
)()
error(_s8Ret_,0)
end)())
end)); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):triggerEvent_withArguments_ifNotHandled_("needsRequestFor:with:",(smalltalk.Array):with_with_(start,headers),(function()
return ((self):defaultResponseFor_with_(start,headers))
end)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"processing","responseFor: start with: headers\r\n\t\" Private - Returns the response string to be sent to a client requesting message with start and headers. \"\r\n\r\n\tstart isNil ifTrue: [ ^self badRequest ].\r\n\tstart last = '1.1' ifFalse: [\r\n\t\tself\ttriggerEvent: #acceptVersion:\r\n\t\t\twithArguments: (Array with: start)\r\n\t\t\tifNotHandled: [ ^self versionNotSupported: start last ]\r\n\t].\r\n\t^self\ttriggerEvent: #needsRequestFor:with:\r\n\t\twithArguments: (Array with: start with: headers)\r\n\t\tifNotHandled: [ self defaultResponseFor: start with: headers ]","function(self,start,headers)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (smalltalk:isNil_((start)))==true then return ((self):badRequest()); end;\r\nif not ((smalltalk:isObject_equalTo_(((start):last()),\"1.1\")))==true then (self):triggerEvent_withArguments_ifNotHandled_(\"acceptVersion:\",(smalltalk.Array):with_(start),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):versionNotSupported_((start):last()))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):triggerEvent_withArguments_ifNotHandled_(\"needsRequestFor:with:\",(smalltalk.Array):with_with_(start,headers),(function()\r\nreturn ((self):defaultResponseFor_with_(start,headers))\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"defaultResponseFor:with:",0
,function(self,start,headers)
local block=nil
(function()
	local _s8_value=((self):httpHandlerFor_and_ifAbsent_(start,headers,(function()
return ((function(s,h)
return ((self):methodNotImplemented())
end))
end)))
	block=_s8_value
	return _s8_value
end)();
return ((block):evaluateWithArguments_((smalltalk.Array):with_with_(start,headers)));
end
,"processing","defaultResponseFor: start with: headers\r\n\t\" Private - Returns the response string to be sent to a client requesting message with start and headers. \"\r\n\r\n\t| block |\r\n\tblock := self\r\n\t\thttpHandlerFor: start and: headers\r\n\t\tifAbsent: [ [:s :h| self methodNotImplemented ] ].\r\n\t^block evaluateWithArguments: (Array with: start with: headers)","function(self,start,headers)\r\nlocal block=nil\r\n(function()\r\n\tlocal _s8_value=((self):httpHandlerFor_and_ifAbsent_(start,headers,(function()\r\nreturn ((function(s,h)\r\nreturn ((self):methodNotImplemented())\r\nend))\r\nend)))\r\n\tblock=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((block):evaluateWithArguments_((smalltalk.Array):with_with_(start,headers)));\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"badRequest",0
,function(self)
return ("HTTP/1.1 400 Bad Request");
end
,"responses","badRequest\r\n\t\" Private - Returns the response string for a bad request.\r\n\thttps://tools.ietf.org/html/rfc2616#section-10.4.1\r\n\tThe request could not be understood by the server due to malformed syntax.\r\n\tThe client SHOULD NOT repeat the request without modifications.\r\n\t\"\r\n\r\n\t^'HTTP/1.1 400 Bad Request'","function(self)\r\nreturn (\"HTTP/1.1 400 Bad Request\");\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"methodNotImplemented",0
,function(self)
return ("HTTP/1.1 501 Not Implemented");
end
,"responses","methodNotImplemented\r\n\t\" Private - Returns the response string for an unimplemented request.\r\n\thttps://tools.ietf.org/html/rfc2616#section-10.5.2\r\n\tThe server does not support the functionality required to fulfill the request.\r\n\tThis is the appropriate response when the server does not recognize the request method and is not capable of supporting it for any resource.\r\n\t\"\r\n\r\n\t^'HTTP/1.1 501 Not Implemented'","function(self)\r\nreturn (\"HTTP/1.1 501 Not Implemented\");\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"versionNotSupported:",0
,function(self,version)
return (smalltalk:object_comma_(("HTTP/1.1 505 HTTP Version Not Supported : "),version));
end
,"responses","versionNotSupported:  version\r\n\t\" Private - Returns the response string for an unsupported HTTP version.\r\n\thttps://tools.ietf.org/html/rfc2616#section-10.5.6\r\n\t\"\r\n\r\n\t^'HTTP/1.1 505 HTTP Version Not Supported : ' ,version","function(self,version)\r\nreturn (smalltalk:object_comma_((\"HTTP/1.1 505 HTTP Version Not Supported : \"),version));\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"httpHandlerFor:and:ifAbsent:",0
,function(self,start,headers,aBlock)
return ((self):triggerEvent_withArguments_ifNotHandled_("needsHandlerFor:with:",(smalltalk.Array):with_with_(start,headers),(function()
return (((self):httpHandlers()):at_ifAbsent_((start):first(),aBlock))
end)));
end
,"configuration","httpHandlerFor: start and: headers ifAbsent: aBlock\r\n\t\" Private - Returns the handler of request messages with start and headers (or the result of evaluating aBlock). \"\r\n\r\n\t^self\ttriggerEvent: #needsHandlerFor:with:\r\n\t\twithArguments: (Array with: start with: headers)\r\n\t\tifNotHandled: [ self httpHandlers at: start first ifAbsent: aBlock ]","function(self,start,headers,aBlock)\r\nreturn ((self):triggerEvent_withArguments_ifNotHandled_(\"needsHandlerFor:with:\",(smalltalk.Array):with_with_(start,headers),(function()\r\nreturn (((self):httpHandlers()):at_ifAbsent_((start):first(),aBlock))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"needsHTTPHandlers",0
,function(self)
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	self["@httpHandlers"]=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):triggerEvent_ifNotHandled_("getHttpHandlers",(function()
return ((self):installDefaultHttpHandlers())
end));
	return ((_s8_rec):triggerEvent_with_("getHttpHandlers:",self["@httpHandlers"]))
end
)(self);
return (self["@httpHandlers"]);
end
,"configuration","needsHTTPHandlers\r\n\t\" Private - Returns the default HTTP handlers of the receiver. \"\r\n\r\n\thttpHandlers := PoolDictionary new.\r\n\tself\ttriggerEvent: #getHttpHandlers ifNotHandled: [ self installDefaultHttpHandlers ];\r\n\t\ttriggerEvent: #getHttpHandlers: with: httpHandlers.\r\n\t^httpHandlers","function(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tself[\"@httpHandlers\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):triggerEvent_ifNotHandled_(\"getHttpHandlers\",(function()\r\nreturn ((self):installDefaultHttpHandlers())\r\nend));\r\n\treturn ((_s8_rec):triggerEvent_with_(\"getHttpHandlers:\",self[\"@httpHandlers\"]))\r\nend\r\n)(self);\r\nreturn (self[\"@httpHandlers\"]);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"installDefaultHttpHandlers",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):at_put_("GET",(self):getHandler());
	(_s8_rec):at_put_("HEAD",(self):headHandler());
	return ((_s8_rec):yourself())
end
)(self["@httpHandlers"]);
return (self);
end
,"defaults","installDefaultHttpHandlers\r\n\t\" Private - Install the default handlers of the receiver. \"\r\n\r\n\thttpHandlers\r\n\t\tat: #GET put: self getHandler;\r\n\t\tat: #HEAD put: self headHandler;\r\n\t\tyourself","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):at_put_(\"GET\",(self):getHandler());\r\n\t(_s8_rec):at_put_(\"HEAD\",(self):headHandler());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(self[\"@httpHandlers\"]);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"headHandler",0
,function(self)
return ((function(start,headers)
local stream=nil
(function()
	local _s8_value=((""):stream())
	stream=_s8_value
	return _s8_value
end)();(self):get_into_headers_body_((start):second(),stream,headers,false);return ((stream):contents())
end));
end
,"handlers","headHandler\r\n\t\" Private - Returns the handler of HEAD request.\r\n\thttps://tools.ietf.org/html/rfc2616#section-9.4\r\n\t\"\r\n\r\n\t^[:start :headers| | stream |\r\n\t\tstream := '' stream.\r\n\t\tself get: start second into: stream headers: headers body: false.\r\n\t\tstream contents\r\n\t]","function(self)\r\nreturn ((function(start,headers)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();(self):get_into_headers_body_((start):second(),stream,headers,false);return ((stream):contents())\r\nend));\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"getHandler",0
,function(self)
return ((function(start,headers)
local stream=nil
(function()
	local _s8_value=((""):stream())
	stream=_s8_value
	return _s8_value
end)();(self):get_into_headers_body_((start):second(),stream,headers,true);return ((stream):contents())
end));
end
,"handlers","getHandler\r\n\t\" Private - Returns the handler of GET request.\r\n\thttps://tools.ietf.org/html/rfc2616#section-9.3\r\n\t\"\r\n\r\n\t^[:start :headers| | stream |\r\n\t\tstream := '' stream.\r\n\t\tself get: start second into: stream headers: headers body: true.\r\n\t\tstream contents\r\n\t]","function(self)\r\nreturn ((function(start,headers)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();(self):get_into_headers_body_((start):second(),stream,headers,true);return ((stream):contents())\r\nend));\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"get:into:headers:body:",0
,function(self,uri,stream,headers,includesBody)
local lines=nil
local statusLine=nil
local body=nil
(function()
	local _s8_value=((self):requestLinesFor_headers_withBody_(uri,headers,includesBody))
	lines=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((lines):removeFirst())
	statusLine=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_and_((includesBody),(function()
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((smalltalk:asString_(((statusLine):second()))):first()),"2")),(function()
return ((lines):notEmpty())
end)))
end)))==true then (function()
	local _s8_value=((lines):removeLast())
	body=_s8_value
	return _s8_value
end)(); end;
(statusLine):do_separatedBy_((function(each)
return ((stream):nextPutAll_(smalltalk:asString_((each))))
end),(function()
return ((stream):space())
end));
(stream):nextPutAll_(self["@crlf"]);
(lines):do_((function(assoc)
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_((assoc):key());
	(_s8_rec):space();
	(_s8_rec):nextPutAll_(":");
	(_s8_rec):space();
	(_s8_rec):nextPutAll_(smalltalk:toString_(((assoc):value())));
	return ((_s8_rec):nextPutAll_(self["@crlf"]))
end
)(stream))
end));
(stream):nextPutAll_(self["@crlf"]);
if (smalltalk:notNil_((body)))==true then (stream):nextPutAll_(body); end;
return (self);
end
,"get","get: uri into: stream headers: headers body: includesBody\r\n\t\" Private - Emmit the response of GET operation onto stream. \"\r\n\r\n\t| lines statusLine body |\r\n\tlines := self requestLinesFor: uri headers: headers withBody: includesBody.\r\n\tstatusLine := lines removeFirst.\r\n\t(includesBody and: [\r\n\t\tstatusLine second asString first = $2 and: [\r\n\t\tlines notEmpty ]]) ifTrue: [ \"status-code with shape 2xx: Success\"\r\n\t\tbody := lines removeLast\r\n\t].\r\n\r\n\tstatusLine \"Status-Line = HTTP-Version SP Status-Code SP Reason-Phrase CRLF\"\r\n\t\tdo: [:each| stream nextPutAll: each asString ]\r\n\t\tseparatedBy: [ stream space ].\r\n\tstream nextPutAll: crlf.\r\n\r\n\tlines do: [:assoc| \"entity-headers https://tools.ietf.org/html/rfc2616#section-7.1\"\r\n\t\tstream\tnextPutAll: assoc key;\r\n\t\t\tspace; nextPutAll: ':'; space;\r\n\t\t\tnextPutAll: assoc value toString;\r\n\t\t\tnextPutAll: crlf\r\n\t].\r\n\r\n\tstream nextPutAll: crlf. \"end of header\"\r\n\tbody notNil ifTrue: [ stream nextPutAll: body ]","function(self,uri,stream,headers,includesBody)\r\nlocal lines=nil\r\nlocal statusLine=nil\r\nlocal body=nil\r\n(function()\r\n\tlocal _s8_value=((self):requestLinesFor_headers_withBody_(uri,headers,includesBody))\r\n\tlines=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((lines):removeFirst())\r\n\tstatusLine=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_and_((includesBody),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((smalltalk:asString_(((statusLine):second()))):first()),\"2\")),(function()\r\nreturn ((lines):notEmpty())\r\nend)))\r\nend)))==true then (function()\r\n\tlocal _s8_value=((lines):removeLast())\r\n\tbody=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(statusLine):do_separatedBy_((function(each)\r\nreturn ((stream):nextPutAll_(smalltalk:asString_((each))))\r\nend),(function()\r\nreturn ((stream):space())\r\nend));\r\n(stream):nextPutAll_(self[\"@crlf\"]);\r\n(lines):do_((function(assoc)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((assoc):key());\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(\":\");\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(smalltalk:toString_(((assoc):value())));\r\n\treturn ((_s8_rec):nextPutAll_(self[\"@crlf\"]))\r\nend\r\n)(stream))\r\nend));\r\n(stream):nextPutAll_(self[\"@crlf\"]);\r\nif (smalltalk:notNil_((body)))==true then (stream):nextPutAll_(body); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"requestLinesFor:headers:withBody:",0
,function(self,uri,headers,includesBody)
local result=nil
local resource=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(self):triggerEvent_withArguments_("openResponseLines:at:with:",(smalltalk.Array):with_with_with_(result,uri,headers));
(function()
	local _s8_value=((self):triggerEvent_withArguments_ifNotHandled_("needsResource:with:",(smalltalk.Array):with_with_(uri,headers),(function()
return ((self):dynamicResource_headers_withBody_(uri,headers,includesBody))
end)))
	resource=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((resource)))==true then return (smalltalk:newArray({smalltalk:newArray({"HTTP/1.1", 404, "Not Found"})})); end;
(
function(_s8_rec)
	(_s8_rec):addAccessControlAllow_at_with_to_(resource,uri,headers,result);
	return ((_s8_rec):addContentTypeAndLength_at_with_to_(resource,uri,headers,result))
end
)(self);
(self):triggerEvent_withArguments_("closeResponseLines:at:with:",(smalltalk.Array):with_with_with_(result,uri,headers));
if (includesBody)==true then (result):add_((self):bodyOf_at_with_(resource,uri,headers)); end;
(result):addFirst_(smalltalk:newArray({"HTTP/1.1", 200, "OK"}));
return (result);
end
,"get","requestLinesFor: uri headers: headers withBody: includesBody\r\n\t\" Private - Returns the request lines of resource at uri. \"\r\n\r\n\t| result resource |\r\n\tresult := Array new.\r\n\tself\ttriggerEvent: #openResponseLines:at:with:\r\n\t\twithArguments: (Array with: result with: uri with: headers).\r\n\tresource := self\r\n\t\ttriggerEvent: #needsResource:with:\r\n\t\twithArguments: (Array with: uri with: headers)\r\n\t\tifNotHandled: [\r\n\t\t\tself dynamicResource: uri headers: headers withBody: includesBody\r\n\t\t].\r\n\tresource isNil ifTrue: [ ^#( #('HTTP/1.1' 404 'Not Found') ) ].\r\n\tself\taddAccessControlAllow: resource at: uri with: headers to: result;\r\n\t\taddContentTypeAndLength: resource at: uri with: headers to: result.\r\n\tself\ttriggerEvent: #closeResponseLines:at:with:\r\n\t\twithArguments: (Array with: result with: uri with: headers).\r\n\tincludesBody ifTrue: [\r\n\t\tresult add: (self bodyOf: resource at: uri with: headers)\r\n\t].\r\n\tresult addFirst: #('HTTP/1.1' 200 #OK). \"The request has succeeded.\"\r\n\t^result","function(self,uri,headers,includesBody)\r\nlocal result=nil\r\nlocal resource=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):triggerEvent_withArguments_(\"openResponseLines:at:with:\",(smalltalk.Array):with_with_with_(result,uri,headers));\r\n(function()\r\n\tlocal _s8_value=((self):triggerEvent_withArguments_ifNotHandled_(\"needsResource:with:\",(smalltalk.Array):with_with_(uri,headers),(function()\r\nreturn ((self):dynamicResource_headers_withBody_(uri,headers,includesBody))\r\nend)))\r\n\tresource=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((resource)))==true then return (smalltalk:newArray({smalltalk:newArray({\"HTTP/1.1\", 404, \"Not Found\"})})); end;\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAccessControlAllow_at_with_to_(resource,uri,headers,result);\r\n\treturn ((_s8_rec):addContentTypeAndLength_at_with_to_(resource,uri,headers,result))\r\nend\r\n)(self);\r\n(self):triggerEvent_withArguments_(\"closeResponseLines:at:with:\",(smalltalk.Array):with_with_with_(result,uri,headers));\r\nif (includesBody)==true then (result):add_((self):bodyOf_at_with_(resource,uri,headers)); end;\r\n(result):addFirst_(smalltalk:newArray({\"HTTP/1.1\", 200, \"OK\"}));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"dynamicResource:headers:withBody:",0
,function(self,uri,headers,includesBody)
return ((self):triggerEvent_withArguments_ifNotHandled_("needsContents:with:",(smalltalk.Array):with_with_(uri,headers),(function()
return (nil)
end)));
end
,"get","dynamicResource: uri headers: headers withBody: includesBody\r\n\t\" Private - Returns the resource computed for uri (or nil).\r\n\tThe result MUST be aString, nil or an Array with shape\r\n\t\t#( mime-type bodyString [Array of Associations] )\r\n\t\"\r\n\r\n\t^self\ttriggerEvent: #needsContents:with:\r\n\t\twithArguments: (Array with: uri with: headers)\r\n\t\tifNotHandled: [ nil ]","function(self,uri,headers,includesBody)\r\nreturn ((self):triggerEvent_withArguments_ifNotHandled_(\"needsContents:with:\",(smalltalk.Array):with_with_(uri,headers),(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"addAccessControlAllow:at:with:to:",0
,function(self,resource,uri,headers,result)
local tuples=nil
(function()
	local _s8_value=((self):triggerEvent_withArguments_ifNotHandled_("needsAccessControlAllow:at:with:",(smalltalk.Array):with_with_with_(resource,uri,headers),(function()
return ((smalltalk.Array):with_(("Access-Control-Allow-Origin"):_minus_gt("*")))
end)))
	tuples=_s8_value
	return _s8_value
end)();
(result):addAll_(tuples);
return (self);
end
,"get","addAccessControlAllow: resource at: uri with: headers to: result\r\n\t\" Private - Add this entity header fields of resource to result. \"\r\n\r\n\t| tuples |\r\n\ttuples := self\r\n\t\ttriggerEvent: #needsAccessControlAllow:at:with:\r\n\t\twithArguments: (Array with: resource with: uri with: headers)\r\n\t\tifNotHandled: [ Array with: #Access-Control-Allow-Origin -> $* ].\r\n\tresult addAll: tuples","function(self,resource,uri,headers,result)\r\nlocal tuples=nil\r\n(function()\r\n\tlocal _s8_value=((self):triggerEvent_withArguments_ifNotHandled_(\"needsAccessControlAllow:at:with:\",(smalltalk.Array):with_with_with_(resource,uri,headers),(function()\r\nreturn ((smalltalk.Array):with_((\"Access-Control-Allow-Origin\"):_minus_gt(\"*\")))\r\nend)))\r\n\ttuples=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(result):addAll_(tuples);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"addContentTypeAndLength:at:with:to:",0
,function(self,resource,uri,headers,result)
local tuples=nil
(function()
	local _s8_value=((self):triggerEvent_withArguments_ifNotHandled_("needsContentType:at:with:",(smalltalk.Array):with_with_with_(resource,uri,headers),(function()
return ((smalltalk.Array):with_(("Content-Type"):_minus_gt((self):contentTypeOf_at_with_(resource,uri,headers))))
end)))
	tuples=_s8_value
	return _s8_value
end)();
(result):addAll_(tuples);
(function()
	local _s8_value=((self):triggerEvent_withArguments_ifNotHandled_("needsContentLength:at:with:",(smalltalk.Array):with_with_with_(resource,uri,headers),(function()
return ((smalltalk.Array):with_(("Content-Length"):_minus_gt((self):contentLengthOf_at_with_(resource,uri,headers))))
end)))
	tuples=_s8_value
	return _s8_value
end)();
(result):addAll_(tuples);
return (self);
end
,"get","addContentTypeAndLength: resource at: uri with: headers to: result\r\n\t\" Private - Add this entity header fields of resource to result. \"\r\n\r\n\t| tuples |\r\n\ttuples := self\r\n\t\ttriggerEvent: #needsContentType:at:with:\r\n\t\twithArguments: (Array with: resource with: uri with: headers)\r\n\t\tifNotHandled: [ Array with: ('Content-Type' -> (self contentTypeOf: resource at: uri with: headers)) ].\r\n\tresult addAll: tuples.\r\n\ttuples := self\r\n\t\ttriggerEvent: #needsContentLength:at:with:\r\n\t\twithArguments: (Array with: resource with: uri with: headers)\r\n\t\tifNotHandled: [ Array with: ('Content-Length' -> (self contentLengthOf: resource at: uri with: headers)) ].\r\n\tresult addAll: tuples","function(self,resource,uri,headers,result)\r\nlocal tuples=nil\r\n(function()\r\n\tlocal _s8_value=((self):triggerEvent_withArguments_ifNotHandled_(\"needsContentType:at:with:\",(smalltalk.Array):with_with_with_(resource,uri,headers),(function()\r\nreturn ((smalltalk.Array):with_((\"Content-Type\"):_minus_gt((self):contentTypeOf_at_with_(resource,uri,headers))))\r\nend)))\r\n\ttuples=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(result):addAll_(tuples);\r\n(function()\r\n\tlocal _s8_value=((self):triggerEvent_withArguments_ifNotHandled_(\"needsContentLength:at:with:\",(smalltalk.Array):with_with_with_(resource,uri,headers),(function()\r\nreturn ((smalltalk.Array):with_((\"Content-Length\"):_minus_gt((self):contentLengthOf_at_with_(resource,uri,headers))))\r\nend)))\r\n\ttuples=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(result):addAll_(tuples);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"bodyOf:at:with:",0
,function(self,resource,uri,headers)
if ((resource):isString())==true then return (resource); end;
return ((resource):second());
end
,"get","bodyOf: resource at: uri with: headers\r\n\t\" Private - Returns the body of resource. \"\r\n\r\n\tresource isString ifTrue: [ ^resource ].\r\n\t^resource second","function(self,resource,uri,headers)\r\nif ((resource):isString())==true then return (resource); end;\r\nreturn ((resource):second());\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"contentLengthOf:at:with:",0
,function(self,resource,uri,headers)
local bytes=nil
(function()
	local _s8_value=(smalltalk:if_true_false_(((resource):isString()),(function()
return (resource)
end),(function()
return ((resource):second())
end)))
	bytes=_s8_value
	return _s8_value
end)();
return ((bytes):size());
end
,"get","contentLengthOf: resource at: uri with: headers\r\n\t\" Private - Returns this header field of resource. \"\r\n\r\n\t| bytes |\r\n\tbytes := resource isString ifTrue: [ resource ] ifFalse: [ resource second ].\r\n\t^bytes size ","function(self,resource,uri,headers)\r\nlocal bytes=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((resource):isString()),(function()\r\nreturn (resource)\r\nend),(function()\r\nreturn ((resource):second())\r\nend)))\r\n\tbytes=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((bytes):size());\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"contentTypeOf:at:with:",0
,function(self,resource,uri,headers)
if ((resource):isString())==true then return ((self):guessTypeOf_at_with_(resource,uri,headers)); end;
return ((resource):first());
end
,"get","contentTypeOf: resource at: uri with: headers\r\n\t\" Private - Returns this header field of resource. \"\r\n\r\n\tresource isString ifTrue: [\r\n\t\t^(self guessTypeOf: resource at: uri with: headers)\r\n\t].\r\n\t^resource first","function(self,resource,uri,headers)\r\nif ((resource):isString())==true then return ((self):guessTypeOf_at_with_(resource,uri,headers)); end;\r\nreturn ((resource):first());\r\nend")

smalltalk:bind(smalltalk.SimpleHTTPServer,"guessTypeOf:at:with:",0
,function(self,resource,uri,headers)
if ((resource):startsWith_("<"))==true then return ("text/html"); end;
return ("text/plain");
end
,"get","guessTypeOf: resource at: uri with: headers\r\n\t\" Private - Return the type of resource (a String). \"\r\n\r\n\t(resource startsWith: $<) ifTrue: [ ^'text/html' ].\r\n\t^'text/plain'","function(self,resource,uri,headers)\r\nif ((resource):startsWith_(\"<\"))==true then return (\"text/html\"); end;\r\nreturn (\"text/plain\");\r\nend")
