
-- fileIn("s8/library/eden/Eden.st")
smalltalk:addClass("BootSector",smalltalk.EventManager,smalltalk:newArray({"lang","stream","indentation"}),"Eden")

smalltalk.BootSector["$comment"]="\r\n\tNative representation of S8 boot section of an image (as a String).\r\n\tThe subclasses refine behavior to jump to other runtimes.\r\n\t@2023-today Alejandro Reimondo aleReimondo@smalltalking.net\r\n\r\n\t(BootSector for: #js) contents\r\n\r\n"

smalltalk:bind(smalltalk.BootSector,"lang",0
,function(self)
return (self["@lang"]);
end
,"accessing","lang\r\n\t\" Return the lang of the receiver. \"\r\n\r\n\t^lang","function(self)\r\nreturn (self[\"@lang\"]);\r\nend")

smalltalk:bind(smalltalk.BootSector,"lang:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@lang"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","lang: anObject\r\n\t\" Set the lang of the receiver. \"\r\n\r\n\tlang := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@lang\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector["$klass"],"encode:",0
,function(self,aSelector)
local tester=nil
(function()
	local _s8_value=((self):new())
	tester=_s8_value
	return _s8_value
end)();
return ((tester):encode_((function()
return ((tester):perform_(aSelector))
end)));
end
,"testing","encode: aSelector\r\n\t\" Private, testing - Retruns the encoding for implementation of aSelector. \"\r\n\r\n\t| tester |\r\n\ttester := self new.\r\n\t^tester encode: [ tester perform: aSelector ] ","function(self,aSelector)\r\nlocal tester=nil\r\n(function()\r\n\tlocal _s8_value=((self):new())\r\n\ttester=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((tester):encode_((function()\r\nreturn ((tester):perform_(aSelector))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.BootSector["$klass"],"for:",0
,function(self,nativeLanguage)
local implementor=nil
(function()
	local _s8_value=((self):supportFor_ifAbsent_(nativeLanguage,(function()
return ((self):error_(smalltalk:object_comma_(("Missing implementation for "),(nativeLanguage):asLiteral())))
end)))
	implementor=_s8_value
	return _s8_value
end)();
return ((
function(_s8_rec)
	(_s8_rec):lang_(nativeLanguage);
	return ((_s8_rec):yourself())
end
)((implementor):new()));
end
,"instantiation","for: nativeLanguage\r\n\t\" Returns an instance of the receiver encoding to nativeLanguage. \"\r\n\r\n\t| implementor |\r\n\timplementor := self\r\n\t\tsupportFor: nativeLanguage\r\n\t\tifAbsent: [ self error: 'Missing implementation for ' ,nativeLanguage asLiteral ].\r\n\t^implementor new\r\n\t\tlang: nativeLanguage;\r\n\t\tyourself","function(self,nativeLanguage)\r\nlocal implementor=nil\r\n(function()\r\n\tlocal _s8_value=((self):supportFor_ifAbsent_(nativeLanguage,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Missing implementation for \"),(nativeLanguage):asLiteral())))\r\nend)))\r\n\timplementor=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):lang_(nativeLanguage);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((implementor):new()));\r\nend")

smalltalk:bind(smalltalk.BootSector["$klass"],"supportFor:ifAbsent:",0
,function(self,nativeLanguage,aBlock)
return (((self):allSubclasses()):detect_ifNone_((function(one)
return ((one):supportsLanguage_(nativeLanguage))
end),aBlock));
end
,"private","supportFor: nativeLanguage ifAbsent: aBlock\r\n\t\" Private - Returns implementor for nativeLanguage. \"\r\n\r\n\t^self allSubclasses\r\n\t\tdetect: [:one| one supportsLanguage: nativeLanguage ]\r\n\t\tifNone: aBlock","function(self,nativeLanguage,aBlock)\r\nreturn (((self):allSubclasses()):detect_ifNone_((function(one)\r\nreturn ((one):supportsLanguage_(nativeLanguage))\r\nend),aBlock));\r\nend")

smalltalk:bind(smalltalk.BootSector["$klass"],"supportsLanguage:",0
,function(self,aLanguage)
return (false);
end
,"instantiation","supportsLanguage: aLanguage\r\n\t\" Private - Return true if instances of the receiver can encode to aLanguage. \"\r\n\r\n\t^false","function(self,aLanguage)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.BootSector["$klass"],"storages",0
,function(self)
return (smalltalk:newArray({}));
end
,"reading","storages\r\n\t\" Private - Return an Array of pathNames to external folders containing literal contents of instances.\r\n\tThe default action returns an empty collection.\r\n\tThis method can be refined by subclasses to support external repositories.\r\n\tSee also uses of #u8Storages \"\r\n\r\n\t^#()","function(self)\r\nreturn (smalltalk:newArray({}));\r\nend")

smalltalk:bind(smalltalk.BootSector,"u8Storages",0
,function(self)
return (smalltalk:newArray({"s8/start/", "u8:aleReimondo/s8/start/"}));
end
,"reading","u8Storages\r\n\t\" Private - Return an Array of pathNames to external folders containing literal contents of instances. \"\r\n\r\n\t^#(\t's8/start/'\r\n\t\t'u8:aleReimondo/s8/start/'\r\n\t)","function(self)\r\nreturn (smalltalk:newArray({\"s8/start/\", \"u8:aleReimondo/s8/start/\"}));\r\nend")

smalltalk:bind(smalltalk.BootSector,"contentsFromStorages:",0
,function(self,storages)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(storages):do_((function(folder)
local result=nil
local pathName=nil
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((folder),"boot.")),(self):lang()))
	pathName=_s8_value
	return _s8_value
end)();((function()
return ((function()
	local _s8_value=((pathName):fileContents())
	result=_s8_value
	return _s8_value
end)())
end)):on_do_(smalltalk.Exception,(function()
return (nil)
end));return (smalltalk:if_true_false_(((result):isString()),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"contents","contentsFromStorages: storages\r\n\t\" Private - Return the contents of the receiver read from external storage (or nil). \"\r\n\r\n\tstorages do: [:folder| | result pathName |\r\n\t\tpathName := folder ,'boot.' ,self lang.\r\n\t\t[ result := pathName fileContents ] on: Exception do: [\"ignore error reading contents\"].\r\n\t\tresult isString ifTrue: [ ^result ].\r\n\t].\r\n\t^nil","function(self,storages)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(storages):do_((function(folder)\r\nlocal result=nil\r\nlocal pathName=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((folder),\"boot.\")),(self):lang()))\r\n\tpathName=_s8_value\r\n\treturn _s8_value\r\nend)();((function()\r\nreturn ((function()\r\n\tlocal _s8_value=((pathName):fileContents())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):on_do_(smalltalk.Exception,(function()\r\nreturn (nil)\r\nend));return (smalltalk:if_true_false_(((result):isString()),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.BootSector,"contentsFromStorages",0
,function(self)
return ((self):contentsFromStorages_((self):u8Storages()));
end
,"contents","contentsFromStorages\r\n\t\" Private - Return the contents of the receiver read from external storage (or nil). \"\r\n\r\n\t^self contentsFromStorages: self u8Storages","function(self)\r\nreturn ((self):contentsFromStorages_((self):u8Storages()));\r\nend")

smalltalk:bind(smalltalk.BootSector,"contents",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(((self):header()),(self):definitions())),(self):startupExpression()));
end
,"contents","contents\r\n\t\" Return the contents (aString) to be dump as source of the receiver. \"\r\n\r\n\t^self header\r\n\t\t,self definitions\r\n\t\t,self startupExpression","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_(((self):header()),(self):definitions())),(self):startupExpression()));\r\nend")

smalltalk:bind(smalltalk.BootSector,"header",0
,function(self)
return ((self):multilineComment_((self):headerLines()));
end
,"contents","header\r\n\t\" Private - Return the header of the receiver. \"\r\n\r\n\t^self multilineComment: self headerLines","function(self)\r\nreturn ((self):multilineComment_((self):headerLines()));\r\nend")

smalltalk:bind(smalltalk.BootSector,"definitions",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(((self):initialDefinition()),(self):nilDefinition())),(self):smalltalkDefinition()));
end
,"contents","definitions\r\n\t\" Private - Return the encoding for global definitions of the receiver. \"\r\n\r\n\t^self initialDefinition\r\n\t,self nilDefinition\r\n\t,self smalltalkDefinition","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_(((self):initialDefinition()),(self):nilDefinition())),(self):smalltalkDefinition()));\r\nend")

smalltalk:bind(smalltalk.BootSector,"startupExpression",0
,function(self)
return ((self):encode_((function()
return ((
function(_s8_rec)
	(_s8_rec):send_to_("startup","smalltalk");
	return ((_s8_rec):cr())
end
)(self))
end)));
end
,"contents","startupExpression\r\n\t\" Private - Return the encoding for startup expression of the receiver. \"\r\n\r\n\t^self encode: [ self send: #startup to: #smalltalk;cr ]","function(self)\r\nreturn ((self):encode_((function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_(\"startup\",\"smalltalk\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.BootSector,"encode:",0
,function(self,aBlock)
local back=nil
local result=nil
(function()
	local _s8_value=(self["@stream"])
	back=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((""):writeStream())
	self["@stream"]=_s8_value
	return _s8_value
end)();
((function()
(aBlock):evaluate();return ((function()
	local _s8_value=((self["@stream"]):contents())
	result=_s8_value
	return _s8_value
end)())
end)):ensure_((function()
return ((function()
	local _s8_value=(back)
	self["@stream"]=_s8_value
	return _s8_value
end)())
end));
return (result);
end
,"private","encode: aBlock\r\n\t\" Private - Return the contents encoded in aBlock. \"\r\n\r\n\t| back result |\r\n\tback := stream.\r\n\tstream := '' writeStream.\r\n\t[\taBlock evaluate.\r\n\t\tresult := stream contents\r\n\t] ensure: [ stream := back ].\r\n\t^result ","function(self,aBlock)\r\nlocal back=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(self[\"@stream\"])\r\n\tback=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tself[\"@stream\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((function()\r\n(aBlock):evaluate();return ((function()\r\n\tlocal _s8_value=((self[\"@stream\"]):contents())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):ensure_((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(back)\r\n\tself[\"@stream\"]=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.BootSector,"indentation",0
,function(self)
if (smalltalk:isNil_((self["@indentation"])))==true then (function()
	local _s8_value=(0)
	self["@indentation"]=_s8_value
	return _s8_value
end)(); end;
return (self["@indentation"]);
end
,"indentation","indentation\r\n\t\" Private - Return the indentation of the receiver. \"\r\n\r\n\tindentation isNil ifTrue: [ indentation := 0 ].\r\n\t^indentation ","function(self)\r\nif (smalltalk:isNil_((self[\"@indentation\"])))==true then (function()\r\n\tlocal _s8_value=(0)\r\n\tself[\"@indentation\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@indentation\"]);\r\nend")

smalltalk:bind(smalltalk.BootSector,"indent",0
,function(self)
(function()
	local _s8_value=(((self):indentation()):_plus(1))
	self["@indentation"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"indentation","indent\r\n\t\" Private - Enter the next level of indentation. \"\r\n\r\n\tindentation := self indentation + 1","function(self)\r\n(function()\r\n\tlocal _s8_value=(((self):indentation()):_plus(1))\r\n\tself[\"@indentation\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"dedent",0
,function(self)
(function()
	local _s8_value=((((self):indentation()):_minus(1)):max_(0))
	self["@indentation"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"indentation","dedent\r\n\t\" Private - Exit the current level of indentation. \"\r\n\r\n\tindentation := self indentation - 1 max: 0","function(self)\r\n(function()\r\n\tlocal _s8_value=((((self):indentation()):_minus(1)):max_(0))\r\n\tself[\"@indentation\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"tab",0
,function(self)
(self["@stream"]):tab();
return (self);
end
,"dump","tab\r\n\t\" Private - Encode a tab character. \"\r\n\r\n\tstream tab ","function(self)\r\n(self[\"@stream\"]):tab();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"space",0
,function(self)
(self["@stream"]):space();
return (self);
end
,"dump","space\r\n\t\" Private - Encode a space character. \"\r\n\r\n\tstream space ","function(self)\r\n(self[\"@stream\"]):space();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"cr",0
,function(self)
(self["@stream"]):cr();
smalltalk:times_repeat_(((self):indentation()),(function()
return ((self):tab())
end));
return (self);
end
,"dump","cr\r\n\t\" Private - Encode a new line. \"\r\n\r\n\tstream cr.\r\n\tself indentation timesRepeat: [ self tab ]","function(self)\r\n(self[\"@stream\"]):cr();\r\nsmalltalk:times_repeat_(((self):indentation()),(function()\r\nreturn ((self):tab())\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"nextPutAll:",0
,function(self,aString)
if (smalltalk:isNil_((aString)))==true then return (self); end;
if ((aString):isArray())==true then (aString):do_separatedBy_((function(line)
return ((self):nextPutAll_(line))
end),(function()
return ((self):cr())
end));
return (self); end;
if ((aString):isString())==true then (self["@stream"]):nextPutAll_(aString);
return (self); end;
if ((aString):isValuable())==true then return ((aString):evaluate()); end;
return ((self):error_(smalltalk:object_comma_(("Invalid argument to encode - "),aString)));
end
,"dump","nextPutAll: aString\r\n\t\" Private - Encode aString to receiver's stream. \"\r\n\r\n\taString isNil ifTrue: [ ^self ].\r\n\taString isArray ifTrue: [\r\n\t\taString\r\n\t\t\tdo: [:line| self nextPutAll: line ]\r\n\t\t\tseparatedBy: [ self cr ].\r\n\t\t^self\r\n\t].\r\n\taString isString ifTrue: [\r\n\t\tstream nextPutAll: aString.\r\n\t\t^self\r\n\t].\r\n\taString isValuable ifTrue: [ ^aString evaluate ].\r\n\t^self error: 'Invalid argument to encode - ' ,aString ","function(self,aString)\r\nif (smalltalk:isNil_((aString)))==true then return (self); end;\r\nif ((aString):isArray())==true then (aString):do_separatedBy_((function(line)\r\nreturn ((self):nextPutAll_(line))\r\nend),(function()\r\nreturn ((self):cr())\r\nend));\r\nreturn (self); end;\r\nif ((aString):isString())==true then (self[\"@stream\"]):nextPutAll_(aString);\r\nreturn (self); end;\r\nif ((aString):isValuable())==true then return ((aString):evaluate()); end;\r\nreturn ((self):error_(smalltalk:object_comma_((\"Invalid argument to encode - \"),aString)));\r\nend")

smalltalk:bind(smalltalk.BootSector,"nextPutLines:",0
,function(self,lines)
local src=nil
if ((lines):isArray())==true then return ((lines):do_separatedBy_((function(each)
return ((self):nextPutAll_(each))
end),(function()
return ((self):cr())
end))); end;
(function()
	local _s8_value=((lines):stream())
	src=_s8_value
	return _s8_value
end)();
while not ((function()
return ((src):atEnd())
end))() do (self):nextPutAll_((src):nextLine());
smalltalk:if_true_false_(((src):atEnd()),nil,(function()
return ((self):cr())
end)); end;
return (self);
end
,"dump","nextPutLines: lines\r\n\t\" Private - Encode lines to receiver's stream. \"\r\n\r\n\t| src |\r\n\tlines isArray ifTrue: [ ^lines do: [:each| self nextPutAll: each ] separatedBy: [self cr] ].\r\n\tsrc := lines stream.\r\n\t[src atEnd] whileFalse: [\r\n\t\tself nextPutAll: src nextLine.\r\n\t\tsrc atEnd ifFalse: [ self cr ]\r\n\t] ","function(self,lines)\r\nlocal src=nil\r\nif ((lines):isArray())==true then return ((lines):do_separatedBy_((function(each)\r\nreturn ((self):nextPutAll_(each))\r\nend),(function()\r\nreturn ((self):cr())\r\nend))); end;\r\n(function()\r\n\tlocal _s8_value=((lines):stream())\r\n\tsrc=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((src):atEnd())\r\nend))() do (self):nextPutAll_((src):nextLine());\r\nsmalltalk:if_true_false_(((src):atEnd()),nil,(function()\r\nreturn ((self):cr())\r\nend)); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"lineComment:",0
,function(self,aString)
return ((self):implementedBySubclass_("lineComment:"));
end
,"encoding","lineComment: aString\r\n\t\" Private - Encode aString as line comment. \"\r\n\r\n\t^self implementedBySubclass: #lineComment: ","function(self,aString)\r\nreturn ((self):implementedBySubclass_(\"lineComment:\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"multilineComment:",0
,function(self,array)
return ((self):encode_((function()
return ((array):do_((function(line)
return ((self):lineComment_(line))
end)))
end)));
end
,"encoding","multilineComment: array\r\n\t\" Private - Encode an array as a multiline comment. \"\r\n\r\n\t^self encode: [ array do: [:line| self lineComment: line ] ]","function(self,array)\r\nreturn ((self):encode_((function()\r\nreturn ((array):do_((function(line)\r\nreturn ((self):lineComment_(line))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.BootSector,"comment:",0
,function(self,aString)
if (smalltalk:isNil_((aString)))==true then return (nil); end;
if not (((aString):isString()))==true then return ((self):lineComment_(aString)); end;
if ((aString):includes_((smalltalk.String):cr()))==true then return ((self):multilineComment_(aString)); end;
if ((aString):includes_((smalltalk.String):lf()))==true then return ((self):multilineComment_(aString)); end;
return ((self):lineComment_(aString));
end
,"encoding","comment: aString\r\n\t\" Private - Encode aString as comment. \"\r\n\r\n\taString isNil ifTrue: [ ^nil ].\r\n\taString isString ifFalse: [ ^self lineComment: aString ].\r\n\t(aString includes: String cr) ifTrue: [ ^self multilineComment: aString ].\r\n\t(aString includes: String lf) ifTrue: [ ^self multilineComment: aString ].\r\n\t^self lineComment: aString ","function(self,aString)\r\nif (smalltalk:isNil_((aString)))==true then return (nil); end;\r\nif not (((aString):isString()))==true then return ((self):lineComment_(aString)); end;\r\nif ((aString):includes_((smalltalk.String):cr()))==true then return ((self):multilineComment_(aString)); end;\r\nif ((aString):includes_((smalltalk.String):lf()))==true then return ((self):multilineComment_(aString)); end;\r\nreturn ((self):lineComment_(aString));\r\nend")

smalltalk:bind(smalltalk.BootSector,"headerLines",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(((smalltalk.Array):with_with_with_with_(smalltalk:object_comma_((smalltalk:object_comma_(((self):product())," - ")),(self):description()),(self):copyright(),(self):license(),"")),(smalltalk.Array):with_with_with_(smalltalk:object_comma_(("Version "),(self):version()),(self):versionDetail(),""))),smalltalk:newArray({"For questions and bug reports join us at S8 Facebook group", "https://www.facebook.com/groups/s8smalltalk/"})));
end
,"header","headerLines\r\n\t\" Private - Return an array of lines for header. \"\r\n\r\n\t^(Array\twith: self product ,' - ' ,self description\r\n\t\twith: self copyright with: self license with: '')\r\n\t,(Array\twith: 'Version ' ,self version\r\n\t\twith: self versionDetail with: '')\r\n\t,#(\r\n\t'For questions and bug reports join us at S8 Facebook group'\r\n\t'https://www.facebook.com/groups/s8smalltalk/'\r\n\t) ","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_(((smalltalk.Array):with_with_with_with_(smalltalk:object_comma_((smalltalk:object_comma_(((self):product()),\" - \")),(self):description()),(self):copyright(),(self):license(),\"\")),(smalltalk.Array):with_with_with_(smalltalk:object_comma_((\"Version \"),(self):version()),(self):versionDetail(),\"\"))),smalltalk:newArray({\"For questions and bug reports join us at S8 Facebook group\", \"https://www.facebook.com/groups/s8smalltalk/\"})));\r\nend")

smalltalk:bind(smalltalk.BootSector,"product",0
,function(self)
return (((smalltalk.Smalltalk):current()):product());
end
,"constants","product\r\n\t\" Private - Returns this value. \"\r\n\r\n\t^Smalltalk current product","function(self)\r\nreturn (((smalltalk.Smalltalk):current()):product());\r\nend")

smalltalk:bind(smalltalk.BootSector,"description",0
,function(self)
return ("A modern Smalltalk environment running on the \"invisible machine\".");
end
,"constants","description\r\n\t\" Private - Returns this value. \"\r\n\r\n\t^'A modern Smalltalk environment running on the \"invisible machine\".'","function(self)\r\nreturn (\"A modern Smalltalk environment running on the \\\"invisible machine\\\".\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"copyright",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(("Copyright (C) "),((smalltalk.Smalltalk):current()):licenseYear())),"-today Alejandro F. Reimondo <aleReimondo@smalltalking.net>"));
end
,"constants","copyright\r\n\t\" Private - Returns this value. \"\r\n\r\n\t^'Copyright (C) '\r\n\t\t,Smalltalk current licenseYear\r\n\t\t,'-today Alejandro F. Reimondo <aleReimondo@smalltalking.net>'","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"Copyright (C) \"),((smalltalk.Smalltalk):current()):licenseYear())),\"-today Alejandro F. Reimondo <aleReimondo@smalltalking.net>\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"license",0
,function(self)
return ("MIT License - See license.txt file");
end
,"constants","license\r\n\t\" Private - Returns this value. \"\r\n\r\n\t^'MIT License - See license.txt file'","function(self)\r\nreturn (\"MIT License - See license.txt file\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"version",0
,function(self)
return ((self):implementedBySubclass_("version"));
end
,"constants","version\r\n\t\" Private - Returns the version string (dotted number and date).\r\n\te.g.   ^'0.7 - Feb 2010'\r\n\t\"\r\n\r\n\t^self implementedBySubclass: #version","function(self)\r\nreturn ((self):implementedBySubclass_(\"version\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"versionDetail",0
,function(self)
return ("");
end
,"constants","versionDetail\r\n\t\" Private - Returns this value.\r\n\tThis method can be refined to give details of status of development.\r\n\te.g.\t^'Note that this is a pre-release of XX execution support under social development(20xx-today).'\r\n\t\"\r\n\r\n\t^''","function(self)\r\nreturn (\"\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"initialDefinition",0
,function(self)
return ("");
end
,"definitions","initialDefinition\r\n\t\" Private - Return the encoding for initializing execution environment.\r\n\tThe default result is an empty String.\r\n\tThis method can be refined to prepare global execution context for creation \"\r\n\r\n\t^'' ","function(self)\r\nreturn (\"\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"nilDefinition",0
,function(self)
return (smalltalk:object_comma_(((self):encode_((function()
(self):defineClass_doing_("UndefinedObject",(self):undefinedObjectInternals());return ((self):define_asInstanceOf_("nil","UndefinedObject"))
end))),(self):nilImplementation()));
end
,"definitions","nilDefinition\r\n\t\" Private - Return the encoding for nil. \"\r\n\r\n\t^(self encode: [\r\n\t\tself defineClass: #UndefinedObject doing: self undefinedObjectInternals.\r\n\t\tself define: #nil asInstanceOf: #UndefinedObject\r\n\t]) ,self nilImplementation ","function(self)\r\nreturn (smalltalk:object_comma_(((self):encode_((function()\r\n(self):defineClass_doing_(\"UndefinedObject\",(self):undefinedObjectInternals());return ((self):define_asInstanceOf_(\"nil\",\"UndefinedObject\"))\r\nend))),(self):nilImplementation()));\r\nend")

smalltalk:bind(smalltalk.BootSector,"smalltalkDefinition",0
,function(self)
return (smalltalk:object_comma_(((self):encode_((function()
(self):defineClass_doing_("SystemDictionary",(function()
return ((self):systemDictionaryInternals())
end));return ((self):define_asInstanceOf_("smalltalk","SystemDictionary"))
end))),(self):smalltalkImplementation()));
end
,"definitions","smalltalkDefinition\r\n\t\" Private - Return the encoding for smalltalk. \"\r\n\r\n\t^(self encode: [\r\n\t\tself defineClass: #SystemDictionary doing: [ self systemDictionaryInternals ].\r\n\t\tself define: #smalltalk asInstanceOf: #SystemDictionary\r\n\t]) ,self smalltalkImplementation ","function(self)\r\nreturn (smalltalk:object_comma_(((self):encode_((function()\r\n(self):defineClass_doing_(\"SystemDictionary\",(function()\r\nreturn ((self):systemDictionaryInternals())\r\nend));return ((self):define_asInstanceOf_(\"smalltalk\",\"SystemDictionary\"))\r\nend))),(self):smalltalkImplementation()));\r\nend")

smalltalk:bind(smalltalk.BootSector,"undefinedObjectInternals",0
,function(self)
return ((smalltalk.String):new());
end
,"implementations","undefinedObjectInternals\r\n\t\" Private - Return the internal encoding for UndefinedObject. \"\r\n\r\n\t^String new \"nothing to encode for UndefinedObject\" ","function(self)\r\nreturn ((smalltalk.String):new());\r\nend")

smalltalk:bind(smalltalk.BootSector,"systemDictionaryInternals",0
,function(self)
return ((self):implementedBySubclass_("systemDictionaryInternals"));
end
,"implementations","systemDictionaryInternals\r\n\t\" Private - Return the internal encoding for SystemDictionary. \"\r\n\r\n\t^self implementedBySubclass: #systemDictionaryInternals ","function(self)\r\nreturn ((self):implementedBySubclass_(\"systemDictionaryInternals\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"smalltalkImplementation",0
,function(self)
return ((self):implementedBySubclass_("smalltalkImplementation"));
end
,"implementations","smalltalkImplementation\r\n\t\" Private - Return the encoding for smalltalk implementation. \"\r\n\r\n\t^self implementedBySubclass: #smalltalkImplementation ","function(self)\r\nreturn ((self):implementedBySubclass_(\"smalltalkImplementation\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"smalltalkImplementation",0
,function(self)
return ((self):implementedBySubclass_("smalltalkImplementation"));
end
,"implementations","smalltalkImplementation\r\n\t\" Private - Return the encoding for smalltalk implementation. \"\r\n\r\n\t^self implementedBySubclass: #smalltalkImplementation ","function(self)\r\nreturn ((self):implementedBySubclass_(\"smalltalkImplementation\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"selfOP",0
,function(self)
return ("self");
end
,"asm-constants","selfOP\r\n\t\" Private - Encoding for self. \"\r\n\r\n\t^#self ","function(self)\r\nreturn (\"self\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"send:withArguments:",0
,function(self,msg,args)
return ((self):send_to_withArguments_(msg,(self):selfOP(),args));
end
,"encoding","send: msg withArguments: args\r\n\t\" Private - Return the encoding for self message sending. \"\r\n\r\n\t^self send: msg to: self selfOP withArguments: args","function(self,msg,args)\r\nreturn ((self):send_to_withArguments_(msg,(self):selfOP(),args));\r\nend")

smalltalk:bind(smalltalk.BootSector,"send:to:withArguments:",0
,function(self,msg,aName,args)
if ((msg):isString())==true then return ((self):sendMessage_((smalltalk.Message):receiver_selector_arguments_(aName,msg,args))); end;
return ((self):sendMessage_((smalltalk.Message):receiver_selector_arguments_(aName,(msg):selector(),args)));
end
,"encoding","send: msg to: aName withArguments: args\r\n\t\" Private - Return the encoding for sending msg to aName. \"\r\n\r\n\tmsg isString ifTrue: [\r\n\t\t^self sendMessage: (Message\r\n\t\t\treceiver: aName selector: msg\r\n\t\t\targuments: args)\r\n\t].\r\n\t^self sendMessage: (Message\r\n\t\treceiver: aName selector: msg selector\r\n\t\targuments: args)","function(self,msg,aName,args)\r\nif ((msg):isString())==true then return ((self):sendMessage_((smalltalk.Message):receiver_selector_arguments_(aName,msg,args))); end;\r\nreturn ((self):sendMessage_((smalltalk.Message):receiver_selector_arguments_(aName,(msg):selector(),args)));\r\nend")

smalltalk:bind(smalltalk.BootSector,"send:",0
,function(self,msg)
return ((self):send_to_withArguments_(msg,(self):selfOP(),smalltalk:newArray({})));
end
,"encoding","send: msg\r\n\t\" Private - Return the encoding for self message sending. \"\r\n\r\n\t^self send: msg to: self selfOP withArguments: #()","function(self,msg)\r\nreturn ((self):send_to_withArguments_(msg,(self):selfOP(),smalltalk:newArray({})));\r\nend")

smalltalk:bind(smalltalk.BootSector,"send:with:",0
,function(self,msg,arg1)
return ((self):send_to_with_(msg,(self):selfOP(),arg1));
end
,"encoding","send: msg with: arg1\r\n\t\" Private - Return the encoding for self message sending. \"\r\n\r\n\t^self send: msg to: self selfOP with: arg1","function(self,msg,arg1)\r\nreturn ((self):send_to_with_(msg,(self):selfOP(),arg1));\r\nend")

smalltalk:bind(smalltalk.BootSector,"send:with:with:",0
,function(self,msg,arg1,arg2)
return ((self):send_to_withArguments_(msg,(self):selfOP(),(smalltalk.Array):with_with_(arg1,arg2)));
end
,"encoding","send: msg with: arg1 with: arg2\r\n\t\" Private - Return the encoding for self message sending. \"\r\n\r\n\t^self send: msg to: self selfOP withArguments: (Array with: arg1 with: arg2)","function(self,msg,arg1,arg2)\r\nreturn ((self):send_to_withArguments_(msg,(self):selfOP(),(smalltalk.Array):with_with_(arg1,arg2)));\r\nend")

smalltalk:bind(smalltalk.BootSector,"send:to:with:",0
,function(self,msg,aName,arg1)
return ((self):send_to_withArguments_(msg,aName,(smalltalk.Array):with_(arg1)));
end
,"encoding","send: msg to: aName with: arg1\r\n\t\" Private - Return the encoding for sending msg to aName. \"\r\n\r\n\t^self send: msg to: aName withArguments: (Array with: arg1)","function(self,msg,aName,arg1)\r\nreturn ((self):send_to_withArguments_(msg,aName,(smalltalk.Array):with_(arg1)));\r\nend")

smalltalk:bind(smalltalk.BootSector,"send:to:",0
,function(self,msg,aName)
return ((self):send_to_withArguments_(msg,aName,smalltalk:newArray({})));
end
,"encoding","send: msg to: aName\r\n\t\" Private - Return the encoding for sending msg to aName. \"\r\n\r\n\t^self send: msg to: aName withArguments: #()","function(self,msg,aName)\r\nreturn ((self):send_to_withArguments_(msg,aName,smalltalk:newArray({})));\r\nend")

smalltalk:bind(smalltalk.BootSector,"sendMessageOP",0
,function(self)
return (".");
end
,"asm-constants","sendMessageOP\r\n\t\" Private - Encoding for send message OP \"\r\n\r\n\t^$. ","function(self)\r\nreturn (\".\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"expressionPars",0
,function(self)
return ("()");
end
,"asm-constants","expressionPars\r\n\t\" Private - Encoding for expression (or nil) \"\r\n\r\n\t^'()' ","function(self)\r\nreturn (\"()\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"argsPars",0
,function(self)
return ("()");
end
,"asm-constants","argsPars\r\n\t\" Private - Encoding for arguments (or nil) \"\r\n\r\n\t^'()' ","function(self)\r\nreturn (\"()\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"pars:",0
,function(self,expression)
return ((self):between_do_indent_((self):argsPars(),expression,false));
end
,"asm","pars: expression\r\n\t\" Private - Encoding for expression with parentesis. \"\r\n\r\n\t^self between: self argsPars do: expression indent: false ","function(self,expression)\r\nreturn ((self):between_do_indent_((self):argsPars(),expression,false));\r\nend")

smalltalk:bind(smalltalk.BootSector,"sendMessage:",0
,function(self,aMessage)
local rcv=nil
(function()
	local _s8_value=((aMessage):receiver())
	rcv=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_or_(((rcv):isString()),(function()
return ((rcv):isValuable())
end)))==true then (self):between_do_indent_(smalltalk:if_true_false_(((rcv):isString()),nil,(function()
return ((self):expressionPars())
end)),rcv,false); else if not (((rcv):isMessage()))==true then (self):error_("Receiver must be aMessage or aString"); end;
(self):between_do_indent_((self):expressionPars(),(function()
return ((self):sendMessage_(rcv))
end),false); end;
(self):nextPutAll_((self):sendMessageOP());
(self):nextPutAll_(((aMessage):selector()):asSelector());
(self):pars_((function()
return ((self):sendMessageArguments_((aMessage):arguments()))
end));
return (self);
end
,"encoding","sendMessage: aMessage\r\n\t\" Private - Return the encoding for sending aMessage. \"\r\n\r\n\t| rcv |\r\n\trcv := aMessage receiver.\r\n\t(rcv isString or: [rcv isValuable])\r\n\tifTrue: [ self between: (rcv isString ifFalse: [self expressionPars]) do: rcv indent: false ]\r\n\tifFalse: [\r\n\t\trcv isMessage ifFalse: [ self error: 'Receiver must be aMessage or aString' ].\r\n\t\tself between: self expressionPars do: [ self sendMessage: rcv ] indent: false\r\n\t].\r\n\tself nextPutAll: self sendMessageOP.\r\n\tself nextPutAll: aMessage selector asSelector.\r\n\tself pars: [ self sendMessageArguments: aMessage arguments ] ","function(self,aMessage)\r\nlocal rcv=nil\r\n(function()\r\n\tlocal _s8_value=((aMessage):receiver())\r\n\trcv=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_or_(((rcv):isString()),(function()\r\nreturn ((rcv):isValuable())\r\nend)))==true then (self):between_do_indent_(smalltalk:if_true_false_(((rcv):isString()),nil,(function()\r\nreturn ((self):expressionPars())\r\nend)),rcv,false); else if not (((rcv):isMessage()))==true then (self):error_(\"Receiver must be aMessage or aString\"); end;\r\n(self):between_do_indent_((self):expressionPars(),(function()\r\nreturn ((self):sendMessage_(rcv))\r\nend),false); end;\r\n(self):nextPutAll_((self):sendMessageOP());\r\n(self):nextPutAll_(((aMessage):selector()):asSelector());\r\n(self):pars_((function()\r\nreturn ((self):sendMessageArguments_((aMessage):arguments()))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"sendMessageArguments:",0
,function(self,args)
if (smalltalk:isObject_equalTo_(((args):size()),0))==true then return (self); end;
(self):nextPutArguments_(args);
return (self);
end
,"encoding","sendMessageArguments: args\r\n\t\" Private - Encoding for aMessage arguments. \"\r\n\r\n\targs size = 0 ifTrue: [ ^self ].\r\n\tself nextPutArguments: args ","function(self,args)\r\nif (smalltalk:isObject_equalTo_(((args):size()),0))==true then return (self); end;\r\n(self):nextPutArguments_(args);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"call:",0
,function(self,aFunction)
return ((self):call_withArguments_(aFunction,smalltalk:newArray({})));
end
,"encoding","call: aFunction\r\n\t\" Private - Return the encoding for calling aFunction. \"\r\n\r\n\t^self call: aFunction withArguments: #() ","function(self,aFunction)\r\nreturn ((self):call_withArguments_(aFunction,smalltalk:newArray({})));\r\nend")

smalltalk:bind(smalltalk.BootSector,"call:with:",0
,function(self,aFunction,arg1)
return ((self):call_withArguments_(aFunction,(smalltalk.Array):with_(arg1)));
end
,"encoding","call: aFunction with: arg1\r\n\t\" Private - Return the encoding for calling aFunction. \"\r\n\r\n\t^self call: aFunction withArguments: (Array with: arg1) ","function(self,aFunction,arg1)\r\nreturn ((self):call_withArguments_(aFunction,(smalltalk.Array):with_(arg1)));\r\nend")

smalltalk:bind(smalltalk.BootSector,"call:withArguments:",0
,function(self,aFunction,array)
if (smalltalk:isNil_((aFunction)))==true then (self):error_("Missing function to call"); end;
if ((aFunction):isString())==true then (self):nextPutAll_(aFunction); else (self):between_do_indent_((self):expressionPars(),aFunction,false); end;
(self):pars_((function()
return ((self):nextPutArguments_(array))
end));
return (self);
end
,"encoding","call: aFunction withArguments: array\r\n\t\" Private - Return the encoding for calling aFunction. \"\r\n\r\n\taFunction isNil ifTrue: [ self error: 'Missing function to call' ].\r\n\taFunction isString ifTrue: [\r\n\t\tself nextPutAll: aFunction\r\n\t] ifFalse: [\r\n\t\tself between: self expressionPars do: aFunction indent: false\r\n\t].\r\n\tself pars: [ self nextPutArguments: array ] ","function(self,aFunction,array)\r\nif (smalltalk:isNil_((aFunction)))==true then (self):error_(\"Missing function to call\"); end;\r\nif ((aFunction):isString())==true then (self):nextPutAll_(aFunction); else (self):between_do_indent_((self):expressionPars(),aFunction,false); end;\r\n(self):pars_((function()\r\nreturn ((self):nextPutArguments_(array))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"blockOPs",0
,function(self)
return ((self):implementedBySubclass_("blockOPs"));
end
,"asm-constants","blockOPs\r\n\t\" Private - Encoding for expression block OPs \"\r\n\r\n\t^self implementedBySubclass: #blockOPs ","function(self)\r\nreturn ((self):implementedBySubclass_(\"blockOPs\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"expressionsOPs",0
,function(self)
return ((self):blockOPs());
end
,"asm-constants","expressionsOPs\r\n\t\" Private - Encoding for expression list OPs \"\r\n\r\n\t^self blockOPs ","function(self)\r\nreturn ((self):blockOPs());\r\nend")

smalltalk:bind(smalltalk.BootSector,"implementFunction:arguments:doing:comment:",0
,function(self,aName,args,expression,aComment)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("function");
	(_s8_rec):space();
	(_s8_rec):nextPutAll_(aName);
	(_s8_rec):pars_((function()
return ((self):nextPutArguments_(args))
end));
	return ((_s8_rec):between_do_indent_comment_((self):expressionsOPs(),expression,true,aComment))
end
)(self);
return (self);
end
,"encoding","implementFunction: aName arguments: args doing: expression comment: aComment\r\n\t\" Private - Define the function named aName doing expression. \"\r\n\r\n\tself\tnextPutAll: #function; space; nextPutAll: aName;\r\n\t\tpars: [ self nextPutArguments: args ];\r\n\t\tbetween: self expressionsOPs do: expression indent: true comment: aComment","function(self,aName,args,expression,aComment)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"function\");\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(aName);\r\n\t(_s8_rec):pars_((function()\r\nreturn ((self):nextPutArguments_(args))\r\nend));\r\n\treturn ((_s8_rec):between_do_indent_comment_((self):expressionsOPs(),expression,true,aComment))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"implementFunction:arguments:doing:",0
,function(self,aName,args,expression)
return ((self):implementFunction_arguments_doing_comment_(aName,args,expression,nil));
end
,"encoding","implementFunction: aName arguments: args doing: expression\r\n\t\" Private - Define the function named aName doing expression. \"\r\n\r\n\t^self\timplementFunction: aName arguments: args\r\n\t\tdoing: expression comment: nil ","function(self,aName,args,expression)\r\nreturn ((self):implementFunction_arguments_doing_comment_(aName,args,expression,nil));\r\nend")

smalltalk:bind(smalltalk.BootSector,"implementFunction:doing:",0
,function(self,aName,expression)
return ((self):implementFunction_arguments_doing_(aName,smalltalk:newArray({}),expression));
end
,"encoding","implementFunction: aName doing: expression\r\n\t\" Private - Define the function named aName doing expression. \"\r\n\r\n\t^self implementFunction: aName arguments: #() doing: expression ","function(self,aName,expression)\r\nreturn ((self):implementFunction_arguments_doing_(aName,smalltalk:newArray({}),expression));\r\nend")

smalltalk:bind(smalltalk.BootSector,"implementFunction:",0
,function(self,aName)
return ((self):implementFunction_arguments_doing_(aName,smalltalk:newArray({}),""));
end
,"encoding","implementFunction: aName\r\n\t\" Private - Define the function named aName doing expression. \"\r\n\r\n\t^self implementFunction: aName arguments: #() doing: '' ","function(self,aName)\r\nreturn ((self):implementFunction_arguments_doing_(aName,smalltalk:newArray({}),\"\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"defineClass:doing:",0
,function(self,aName,expression)
return ((self):define_subclass_doing_("Object",aName,expression));
end
,"encoding","defineClass: aName doing: expression\r\n\t\" Private - Return the encoding for defining a new S8 class named aName. \"\r\n\r\n\t^self define: #Object subclass: aName doing: expression ","function(self,aName,expression)\r\nreturn ((self):define_subclass_doing_(\"Object\",aName,expression));\r\nend")

smalltalk:bind(smalltalk.BootSector,"define:subclass:doing:",0
,function(self,parentClass,aName,expression)
return ((self):implementedBySubclass_("define:subclass:doing:"));
end
,"encoding","define: parentClass subclass: aName doing: expression\r\n\t\" Private - Return the encoding for defining a new S8 class named aName. \"\r\n\r\n\t^self implementedBySubclass: #define:subclass:doing: ","function(self,parentClass,aName,expression)\r\nreturn ((self):implementedBySubclass_(\"define:subclass:doing:\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"define:asInstanceOf:",0
,function(self,aName,clsName)
return ((self):implementedBySubclass_("define:asInstanceOf:"));
end
,"encoding","define: aName asInstanceOf: clsName\r\n\t\" Private - Return the encoding for defining a variable named aName. \"\r\n\r\n\t^self implementedBySubclass: #define:asInstanceOf: ","function(self,aName,clsName)\r\nreturn ((self):implementedBySubclass_(\"define:asInstanceOf:\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"between:do:indent:comment:",0
,function(self,tags,aBlock,aBoolean,aComment)
if (smalltalk:isObject_equalTo_(((tags):size()),0))==true then return ((self):between_do_indent_comment_(smalltalk:newArray({"", ""}),aBlock,aBoolean,aComment)); end;
(self):nextPutAll_((tags):first());
(self):comment_(aComment);
if not ((smalltalk:boolean_and_(((aBlock):isString()),(function()
return ((aBlock):isEmpty())
end))))==true then if (aBoolean)==true then (
function(_s8_rec)
	(_s8_rec):indent();
	return ((_s8_rec):cr())
end
)(self); end;
(self):nextPutAll_(aBlock);
smalltalk:if_true_false_((aBoolean),(function()
return ((
function(_s8_rec)
	(_s8_rec):dedent();
	return ((_s8_rec):cr())
end
)(self))
end),nil); end;
(self):nextPutAll_((tags):last());
return (self);
end
,"encoding","between: tags do: aBlock indent: aBoolean comment: aComment\r\n\t\" Private - Encode aBlock expression between tags. \"\r\n\r\n\ttags size = 0 ifTrue: [\r\n\t\t^self\tbetween: #('' '') do: aBlock\r\n\t\t\tindent: aBoolean comment: aComment\r\n\t].\r\n\tself nextPutAll: tags first.\r\n\tself comment: aComment.\r\n\t(aBlock isString and: [aBlock isEmpty]) ifFalse: [\r\n\t\taBoolean ifTrue: [ self indent; cr ].\r\n\t\tself nextPutAll: aBlock.\r\n\t\taBoolean ifTrue: [ self dedent; cr ].\r\n\t].\r\n\tself nextPutAll: tags last.","function(self,tags,aBlock,aBoolean,aComment)\r\nif (smalltalk:isObject_equalTo_(((tags):size()),0))==true then return ((self):between_do_indent_comment_(smalltalk:newArray({\"\", \"\"}),aBlock,aBoolean,aComment)); end;\r\n(self):nextPutAll_((tags):first());\r\n(self):comment_(aComment);\r\nif not ((smalltalk:boolean_and_(((aBlock):isString()),(function()\r\nreturn ((aBlock):isEmpty())\r\nend))))==true then if (aBoolean)==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):indent();\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self); end;\r\n(self):nextPutAll_(aBlock);\r\nsmalltalk:if_true_false_((aBoolean),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):dedent();\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend),nil); end;\r\n(self):nextPutAll_((tags):last());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"between:do:indent:",0
,function(self,tags,aBlock,aBoolean)
return ((self):between_do_indent_comment_(tags,aBlock,aBoolean,nil));
end
,"encoding","between: tags do: aBlock indent: aBoolean\r\n\t\" Private - Encode aBlock expression between tags. \"\r\n\r\n\t^self between: tags do: aBlock indent: aBoolean comment: nil ","function(self,tags,aBlock,aBoolean)\r\nreturn ((self):between_do_indent_comment_(tags,aBlock,aBoolean,nil));\r\nend")

smalltalk:bind(smalltalk.BootSector,"conditionPars:",0
,function(self,expression)
return ((self):expressionPars());
end
,"asm-constants","conditionPars: expression\r\n\t\" Private - Encoding for condition expression(or nil) \"\r\n\r\n\t^self expressionPars ","function(self,expression)\r\nreturn ((self):expressionPars());\r\nend")

smalltalk:bind(smalltalk.BootSector,"opPars:",0
,function(self,expression)
return ("()");
end
,"asm-constants","opPars: expression\r\n\t\" Private - Encoding for expression in operation(or nil) \"\r\n\r\n\t^'()' ","function(self,expression)\r\nreturn (\"()\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"expr:op:with:pars:",0
,function(self,expr1,op,expr2,pars)
if (smalltalk:isNil_((pars)))==true then return ((self):expr_op_with_pars_(expr1,op,expr2,(smalltalk.Array):with_with_((self):opPars_(expr1),(self):opPars_(expr2)))); end;
if ((pars):isEmpty())==true then return ((self):expr_op_with_pars_(expr1,op,expr2,smalltalk:newArray({""}))); end;
if (smalltalk:isObject_equalTo_(((pars):size()),1))==true then return ((self):expr_op_with_pars_(expr1,op,expr2,(smalltalk.Array):with_with_(pars,pars))); end;
if not ((smalltalk:isObject_equalTo_(((pars):size()),2)))==true then return ((self):error_("Invalid paren sizes. Must be 2")); end;
(self):between_do_indent_((pars):first(),(function()
return ((self):nextPutAll_(expr1))
end),false);
(
function(_s8_rec)
	(_s8_rec):space();
	(_s8_rec):nextPutAll_(op);
	return ((_s8_rec):space())
end
)(self);
(self):between_do_indent_((pars):last(),(function()
return ((self):nextPutAll_(expr2))
end),false);
return (self);
end
,"asm","expr: expr1 op: op with: expr2 pars: pars\r\n\t\" Private - Encoding for OP expression. \"\r\n\r\n\tpars isNil ifTrue: [\r\n\t\t^self expr: expr1 op: op with: expr2 pars: (Array\r\n\t\t\twith: (self opPars: expr1)\r\n\t\t\twith: (self opPars: expr2))\r\n\t].\r\n\tpars isEmpty ifTrue: [ ^self expr: expr1 op: op with: expr2 pars: #('') ].\r\n\tpars size = 1 ifTrue: [ ^self expr: expr1 op: op with: expr2 pars: (Array with: pars with: pars) ].\r\n\tpars size = 2 ifFalse: [ ^self error: 'Invalid paren sizes. Must be 2' ].\r\n\tself between: pars first do: [ self nextPutAll: expr1 ] indent: false.\r\n\tself space; nextPutAll: op; space.\r\n\tself between: pars last do: [ self nextPutAll: expr2 ] indent: false.","function(self,expr1,op,expr2,pars)\r\nif (smalltalk:isNil_((pars)))==true then return ((self):expr_op_with_pars_(expr1,op,expr2,(smalltalk.Array):with_with_((self):opPars_(expr1),(self):opPars_(expr2)))); end;\r\nif ((pars):isEmpty())==true then return ((self):expr_op_with_pars_(expr1,op,expr2,smalltalk:newArray({\"\"}))); end;\r\nif (smalltalk:isObject_equalTo_(((pars):size()),1))==true then return ((self):expr_op_with_pars_(expr1,op,expr2,(smalltalk.Array):with_with_(pars,pars))); end;\r\nif not ((smalltalk:isObject_equalTo_(((pars):size()),2)))==true then return ((self):error_(\"Invalid paren sizes. Must be 2\")); end;\r\n(self):between_do_indent_((pars):first(),(function()\r\nreturn ((self):nextPutAll_(expr1))\r\nend),false);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(op);\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(self):between_do_indent_((pars):last(),(function()\r\nreturn ((self):nextPutAll_(expr2))\r\nend),false);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"expr:op:with:",0
,function(self,expr1,op,expr2)
(self):expr_op_with_pars_(expr1,op,expr2,nil);
return (self);
end
,"asm","expr: expr1 op: op with: expr2\r\n\t\" Private - Encoding for OP expression. \"\r\n\r\n\tself expr: expr1 op: op with: expr2 pars: nil ","function(self,expr1,op,expr2)\r\n(self):expr_op_with_pars_(expr1,op,expr2,nil);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"orOP",0
,function(self)
return ("||");
end
,"asm-constants","orOP\r\n\t\" Private - Encoding for operand. \"\r\n\r\n\t^#|| ","function(self)\r\nreturn (\"||\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"andOP",0
,function(self)
return ("&&");
end
,"asm-constants","andOP\r\n\t\" Private - Encoding for operand. \"\r\n\r\n\t^#&& ","function(self)\r\nreturn (\"&&\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"eqeqOP",0
,function(self)
return ("==");
end
,"asm-constants","eqeqOP\r\n\t\" Private - Encoding for operand. \"\r\n\r\n\t^#== ","function(self)\r\nreturn (\"==\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"noteqOP",0
,function(self)
return ("!=");
end
,"asm-constants","noteqOP\r\n\t\" Private - Encoding for operand. \"\r\n\r\n\t^#!= ","function(self)\r\nreturn (\"!=\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"eqeqeqOP",0
,function(self)
return ("===");
end
,"asm-constants","eqeqeqOP\r\n\t\" Private - Encoding for operand. \"\r\n\r\n\t^#=== ","function(self)\r\nreturn (\"===\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"noteqeqOP",0
,function(self)
return (smalltalk:object_comma_(((self):noteqOP()),"="));
end
,"asm-constants","noteqeqOP\r\n\t\" Private - Encoding for operand. \"\r\n\r\n\t^self noteqOP ,#= ","function(self)\r\nreturn (smalltalk:object_comma_(((self):noteqOP()),\"=\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"expr:or:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,(self):orOP(),expr2);
return (self);
end
,"asm","expr: expr1 or: expr2\r\n\t\" Private - Encoding for or expression. \"\r\n\r\n\tself expr: expr1 op: self orOP with: expr2","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,(self):orOP(),expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"expr:and:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,(self):andOP(),expr2);
return (self);
end
,"asm","expr: expr1 and: expr2\r\n\t\" Private - Encoding for and expression. \"\r\n\r\n\tself expr: expr1 op: self andOP with: expr2","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,(self):andOP(),expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"expr:eqeq:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,(self):eqeqOP(),expr2);
return (self);
end
,"asm","expr: expr1 eqeq: expr2\r\n\t\" Private - Encoding for == expression. \"\r\n\r\n\tself expr: expr1 op: self eqeqOP with: expr2","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,(self):eqeqOP(),expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"expr:noteq:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,(self):noteqOP(),expr2);
return (self);
end
,"asm","expr: expr1 noteq: expr2\r\n\t\" Private - Encoding for ~= expression. \"\r\n\r\n\tself expr: expr1 op: self noteqOP with: expr2","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,(self):noteqOP(),expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"expr:eqeqeq:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,(self):eqeqeqOP(),expr2);
return (self);
end
,"asm","expr: expr1 eqeqeq: expr2\r\n\t\" Private - Encoding for === expression. \"\r\n\r\n\tself expr: expr1 op: self eqeqeqOP with: expr2","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,(self):eqeqeqOP(),expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"expr:noteqeq:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,(self):noteqeqOP(),expr2);
return (self);
end
,"asm","expr: expr1 noteqeq: expr2\r\n\t\" Private - Encoding for ~== expression. \"\r\n\r\n\tself expr: expr1 op: self noteqeqOP with: expr2","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,(self):noteqeqOP(),expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"notOP",0
,function(self)
return ("!");
end
,"asm-constants","notOP\r\n\t\" Private - Return the OP for negation. \"\r\n\r\n\t^$! ","function(self)\r\nreturn (\"!\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"not:",0
,function(self,condition)
(self):nextPutAll_((self):notOP());
(self):between_do_indent_((self):conditionPars_(condition),condition,false);
return (self);
end
,"asm","not: condition\r\n\t\" Private - Encoding for negation of condition. \"\r\n\r\n\tself nextPutAll: self notOP.\r\n\tself between: (self conditionPars: condition) do: condition indent: false ","function(self,condition)\r\n(self):nextPutAll_((self):notOP());\r\n(self):between_do_indent_((self):conditionPars_(condition),condition,false);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"assign:to:",0
,function(self,assignee,expression)
(self):expr_op_with_pars_(assignee,"=",expression,smalltalk:newArray({smalltalk:newArray({"", ""}), smalltalk:newArray({"", ""})}));
return (self);
end
,"asm","assign: assignee to: expression\r\n\t\" Private - Assignment expression. \"\r\n\r\n\tself\texpr: assignee op: #= with: expression\r\n\t\tpars: #(#('' '') #('' ''))","function(self,assignee,expression)\r\n(self):expr_op_with_pars_(assignee,\"=\",expression,smalltalk:newArray({smalltalk:newArray({\"\", \"\"}), smalltalk:newArray({\"\", \"\"})}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"return:",0
,function(self,expression)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("return");
	return ((_s8_rec):space())
end
)(self);
(self):nextPutAll_(expression);
return (self);
end
,"asm","return: expression\r\n\t\" Private - Encoding for expression return. \"\r\n\r\n\tself nextPutAll: #return; space.\r\n\tself nextPutAll: expression","function(self,expression)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"return\");\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(self):nextPutAll_(expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"whileDoOPs",0
,function(self)
return ((smalltalk.Array):with_with_("while","do"));
end
,"asm-constants","whileDoOPs\r\n\t\" Private - Return the OPs for while-do expression. \"\r\n\r\n\t^Array with: #while with: #do ","function(self)\r\nreturn ((smalltalk.Array):with_with_(\"while\",\"do\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"doWhileOPs",0
,function(self)
return ((smalltalk.Array):with_with_("do","while"));
end
,"asm-constants","doWhileOPs\r\n\t\" Private - Return the OPs for do-while expression. \"\r\n\r\n\t^Array with: #do with: #while","function(self)\r\nreturn ((smalltalk.Array):with_with_(\"do\",\"while\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"while:do:",0
,function(self,test,expression)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(((self):whileDoOPs()):first());
	(_s8_rec):space();
	(_s8_rec):between_do_indent_((self):conditionPars_(test),test,false);
	(_s8_rec):space();
	(_s8_rec):nextPutAll_(((self):whileDoOPs()):last());
	return ((_s8_rec):between_do_indent_((self):expressionsOPs(),expression,true))
end
)(self);
return (self);
end
,"asm","while: test do: expression\r\n\t\" Private - Encoding for while loop. \"\r\n\r\n\tself\tnextPutAll: self whileDoOPs first;space;\r\n\t\tbetween: (self conditionPars: test) do: test indent: false;\r\n\t\tspace;nextPutAll: self whileDoOPs last;\r\n\t\tbetween: self expressionsOPs do: expression indent: true","function(self,test,expression)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(((self):whileDoOPs()):first());\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):between_do_indent_((self):conditionPars_(test),test,false);\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(((self):whileDoOPs()):last());\r\n\treturn ((_s8_rec):between_do_indent_((self):expressionsOPs(),expression,true))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"do:while:",0
,function(self,expression,test)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(((self):doWhileOPs()):first());
	(_s8_rec):space();
	(_s8_rec):between_do_indent_((self):expressionsOPs(),expression,true);
	(_s8_rec):space();
	(_s8_rec):nextPutAll_(((self):doWhileOPs()):last());
	(_s8_rec):space();
	return ((_s8_rec):between_do_indent_((self):conditionPars_(test),test,false))
end
)(self);
return (self);
end
,"asm","do: expression while: test\r\n\t\" Private - Encoding for while loop. \"\r\n\r\n\tself\tnextPutAll: self doWhileOPs first; space;\r\n\t\tbetween: self expressionsOPs do: expression indent: true;\r\n\t\tspace; nextPutAll: self doWhileOPs last; space;\r\n\t\tbetween: (self conditionPars: test) do: test indent: false","function(self,expression,test)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(((self):doWhileOPs()):first());\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):between_do_indent_((self):expressionsOPs(),expression,true);\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(((self):doWhileOPs()):last());\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):between_do_indent_((self):conditionPars_(test),test,false))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"repeatOPs",0
,function(self)
return ((smalltalk.Array):with_with_("repeat","until"));
end
,"asm-constants","repeatOPs\r\n\t\" Private - Return the OPs for repeat-until expression. \"\r\n\r\n\t^Array with: #repeat with: #until","function(self)\r\nreturn ((smalltalk.Array):with_with_(\"repeat\",\"until\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"repeat:until:",0
,function(self,expression,test)
(
function(_s8_rec)
	(_s8_rec):between_do_indent_((self):repeatOPs(),expression,true);
	(_s8_rec):space();
	return ((_s8_rec):between_do_indent_((self):conditionPars_(test),test,false))
end
)(self);
return (self);
end
,"asm","repeat: expression until: test\r\n\t\" Private - Encoding for repeat loop. \"\r\n\r\n\tself\tbetween: self repeatOPs do: expression indent: true;\r\n\t\tspace; between: (self conditionPars: test) do: test indent: false","function(self,expression,test)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):between_do_indent_((self):repeatOPs(),expression,true);\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):between_do_indent_((self):conditionPars_(test),test,false))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"forInDoOPs",0
,function(self)
return ((smalltalk.Array):with_with_with_("for","in","do"));
end
,"asm-constants","forInDoOPs\r\n\t\" Private - Return the OPs for for-in-do expression. \"\r\n\r\n\t^Array with: #for with: #in with: #do","function(self)\r\nreturn ((smalltalk.Array):with_with_with_(\"for\",\"in\",\"do\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"forInDoPars",0
,function(self)
return ((self):expressionPars());
end
,"asm-constants","forInDoPars\r\n\t\" Private - Return the parentesis for for-in-do expression. \"\r\n\r\n\t^self expressionPars","function(self)\r\nreturn ((self):expressionPars());\r\nend")

smalltalk:bind(smalltalk.BootSector,"for:in:do:",0
,function(self,aName,array,expression)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(((self):forInDoOPs()):first());
	(_s8_rec):space();
	(_s8_rec):between_do_indent_((self):forInDoPars(),(function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(aName);
	return ((_s8_rec):space())
end
)(self);(
function(_s8_rec)
	(_s8_rec):nextPutAll_(((self):forInDoOPs()):second());
	return ((_s8_rec):space())
end
)(self);return ((self):nextPutAll_(array))
end),false);
	(_s8_rec):space();
	(_s8_rec):nextPutAll_(((self):forInDoOPs()):last());
	return ((_s8_rec):between_do_indent_((self):expressionsOPs(),expression,true))
end
)(self);
return (self);
end
,"asm","for: aName in: array do: expression\r\n\t\" Private - Encoding for for(var...) loop. \"\r\n\r\n\tself\tnextPutAll: self forInDoOPs first; space;\r\n\t\tbetween: self forInDoPars do: [\r\n\t\t\tself nextPutAll: aName;space.\r\n\t\t\tself nextPutAll: self forInDoOPs second;space.\r\n\t\t\tself nextPutAll: array\r\n\t\t] indent: false;\r\n\t\tspace;nextPutAll: self forInDoOPs last;\r\n\t\tbetween: self expressionsOPs do: expression indent: true","function(self,aName,array,expression)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(((self):forInDoOPs()):first());\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):between_do_indent_((self):forInDoPars(),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(aName);\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(((self):forInDoOPs()):second());\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);return ((self):nextPutAll_(array))\r\nend),false);\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(((self):forInDoOPs()):last());\r\n\treturn ((_s8_rec):between_do_indent_((self):expressionsOPs(),expression,true))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"forDoOPs",0
,function(self)
return ((smalltalk.Array):with_with_("for","do"));
end
,"asm-constants","forDoOPs\r\n\t\" Private - Return the OPs for for-do expression. \"\r\n\r\n\t^Array with: #for with: #do","function(self)\r\nreturn ((smalltalk.Array):with_with_(\"for\",\"do\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"forDoPars",0
,function(self)
return ((self):expressionPars());
end
,"asm-constants","forDoPars\r\n\t\" Private - Return the parentesis for for-do expression. \"\r\n\r\n\t^self expressionPars","function(self)\r\nreturn ((self):expressionPars());\r\nend")

smalltalk:bind(smalltalk.BootSector,"for:do:",0
,function(self,counter,expression)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(((self):forDoOPs()):first());
	(_s8_rec):space();
	(_s8_rec):between_do_indent_((self):forDoPars(),(function()
return ((self):nextPutAll_(counter))
end),false);
	(_s8_rec):space();
	(_s8_rec):nextPutAll_(((self):forDoOPs()):last());
	return ((_s8_rec):between_do_indent_((self):expressionsOPs(),expression,true))
end
)(self);
return (self);
end
,"asm","for: counter do: expression\r\n\t\" Private - Encoding for for(var...) loop. \"\r\n\r\n\tself\tnextPutAll: self forDoOPs first; space;\r\n\t\tbetween: self forDoPars do: [ self nextPutAll: counter ] indent: false;\r\n\t\tspace;nextPutAll: self forDoOPs last;\r\n\t\tbetween: self expressionsOPs do: expression indent: true","function(self,counter,expression)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(((self):forDoOPs()):first());\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):between_do_indent_((self):forDoPars(),(function()\r\nreturn ((self):nextPutAll_(counter))\r\nend),false);\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(((self):forDoOPs()):last());\r\n\treturn ((_s8_rec):between_do_indent_((self):expressionsOPs(),expression,true))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"arrayOPs",0
,function(self)
return ("[]");
end
,"asm-constants","arrayOPs\r\n\t\" Private - Return the OPs for literal array definition. \"\r\n\r\n\t^'[]' ","function(self)\r\nreturn (\"[]\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"array:indent:",0
,function(self,array,indented)
local withCrs=nil
(function()
	local _s8_value=(smalltalk:boolean_and_((indented),(function()
return ((((array):size()) > 3))
end)))
	withCrs=_s8_value
	return _s8_value
end)();
return ((self):between_do_indent_((self):arrayOPs(),(function()
local first=nil
(function()
	local _s8_value=(true)
	first=_s8_value
	return _s8_value
end)();return ((self):nextPutArguments_((array):collect_((function(each)
return ((function()
if (withCrs)==true then smalltalk:if_true_false_((first),(function()
return ((function()
	local _s8_value=(false)
	first=_s8_value
	return _s8_value
end)())
end),(function()
return ((self):cr())
end)); end;return ((self):nextPutAll_(each))
end))
end))))
end),withCrs));
end
,"asm","array: array indent: indented\r\n\t\" Private - Encoding for array literal. \"\r\n\r\n\t| withCrs |\r\n\twithCrs := indented and: [array size > 3].\r\n\t^self between: self arrayOPs do: [|first|\r\n\t\tfirst := true.\r\n\t\t self nextPutArguments:\r\n\t\t\t(array collect: [:each| [\r\n\t\t\t\twithCrs ifTrue: [\r\n\t\t\t\t\tfirst ifTrue: [ first := false ] ifFalse: [ self cr ]\r\n\t\t\t\t].\r\n\t\t\t\tself nextPutAll: each\r\n\t\t\t]])\r\n\t] indent: withCrs ","function(self,array,indented)\r\nlocal withCrs=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:boolean_and_((indented),(function()\r\nreturn ((((array):size()) > 3))\r\nend)))\r\n\twithCrs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):between_do_indent_((self):arrayOPs(),(function()\r\nlocal first=nil\r\n(function()\r\n\tlocal _s8_value=(true)\r\n\tfirst=_s8_value\r\n\treturn _s8_value\r\nend)();return ((self):nextPutArguments_((array):collect_((function(each)\r\nreturn ((function()\r\nif (withCrs)==true then smalltalk:if_true_false_((first),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(false)\r\n\tfirst=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),(function()\r\nreturn ((self):cr())\r\nend)); end;return ((self):nextPutAll_(each))\r\nend))\r\nend))))\r\nend),withCrs));\r\nend")

smalltalk:bind(smalltalk.BootSector,"array:",0
,function(self,array)
return ((self):array_indent_(array,true));
end
,"asm","array: array\r\n\t\" Private - Encoding for array literal. \"\r\n\r\n\t^self array: array indent: true","function(self,array)\r\nreturn ((self):array_indent_(array,true));\r\nend")

smalltalk:bind(smalltalk.BootSector,"emptyArray",0
,function(self)
return ((self):array_indent_(smalltalk:newArray({}),false));
end
,"asm","emptyArray\r\n\t\" Private - Encoding for empty array literal. \"\r\n\r\n\t^self array: #() indent: false","function(self)\r\nreturn ((self):array_indent_(smalltalk:newArray({}),false));\r\nend")

smalltalk:bind(smalltalk.BootSector,"fieldOP",0
,function(self)
return ((self):implementedBySubclass_("fieldOP"));
end
,"asm-constants","fieldOP\r\n\t\" Private - Return the OP for tuple separator. \"\r\n\r\n\t^self implementedBySubclass: #fieldOP ","function(self)\r\nreturn ((self):implementedBySubclass_(\"fieldOP\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"objectOPs",0
,function(self)
return ((self):blockOPs());
end
,"asm-constants","objectOPs\r\n\t\" Private - Return the OPs for literal object definition. \"\r\n\r\n\t^self blockOPs ","function(self)\r\nreturn ((self):blockOPs());\r\nend")

smalltalk:bind(smalltalk.BootSector,"object:indent:",0
,function(self,associations,indented)
local array=nil
local withCrs=nil
if (smalltalk:is_kindOf_((associations),(smalltalk.Association)))==true then return ((self):object_indent_((smalltalk.Array):with_(associations),indented)); end;
(function()
	local _s8_value=((associations):asArray())
	array=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:boolean_and_((indented),(function()
return ((((array):size()) > 3))
end)))
	withCrs=_s8_value
	return _s8_value
end)();
return ((self):between_do_indent_((self):objectOPs(),(function()
local first=nil
(function()
	local _s8_value=(true)
	first=_s8_value
	return _s8_value
end)();return ((self):nextPutArguments_((array):collect_((function(assoc)
return ((function()
if (withCrs)==true then smalltalk:if_true_false_((first),(function()
return ((function()
	local _s8_value=(false)
	first=_s8_value
	return _s8_value
end)())
end),(function()
return ((self):cr())
end)); end;(self):nextPutAll_((assoc):key());(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):fieldOP());
	return ((_s8_rec):space())
end
)(self);return ((self):nextPutAll_((assoc):value()))
end))
end))))
end),withCrs));
end
,"asm","object: associations indent: indented\r\n\t\" Private - Encoding for object literal. \"\r\n\r\n\t| array withCrs |\r\n\t(associations isKindOf: Association) ifTrue: [\r\n\t\t^self object: (Array with: associations) indent: indented\r\n\t].\r\n\tarray := associations asArray.\r\n\twithCrs := indented and: [array size > 3].\r\n\t^self between: self objectOPs do: [|first|\r\n\t\tfirst := true.\r\n\t\t self nextPutArguments:\r\n\t\t\t(array collect: [:assoc| [\r\n\t\t\t\twithCrs ifTrue: [\r\n\t\t\t\t\tfirst ifTrue: [ first := false ] ifFalse: [ self cr ]\r\n\t\t\t\t].\r\n\t\t\t\tself nextPutAll: assoc key.\r\n\t\t\t\tself nextPutAll: self fieldOP; space.\r\n\t\t\t\tself nextPutAll: assoc value\r\n\t\t\t]])\r\n\t] indent: withCrs ","function(self,associations,indented)\r\nlocal array=nil\r\nlocal withCrs=nil\r\nif (smalltalk:is_kindOf_((associations),(smalltalk.Association)))==true then return ((self):object_indent_((smalltalk.Array):with_(associations),indented)); end;\r\n(function()\r\n\tlocal _s8_value=((associations):asArray())\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:boolean_and_((indented),(function()\r\nreturn ((((array):size()) > 3))\r\nend)))\r\n\twithCrs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):between_do_indent_((self):objectOPs(),(function()\r\nlocal first=nil\r\n(function()\r\n\tlocal _s8_value=(true)\r\n\tfirst=_s8_value\r\n\treturn _s8_value\r\nend)();return ((self):nextPutArguments_((array):collect_((function(assoc)\r\nreturn ((function()\r\nif (withCrs)==true then smalltalk:if_true_false_((first),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(false)\r\n\tfirst=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),(function()\r\nreturn ((self):cr())\r\nend)); end;(self):nextPutAll_((assoc):key());(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):fieldOP());\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);return ((self):nextPutAll_((assoc):value()))\r\nend))\r\nend))))\r\nend),withCrs));\r\nend")

smalltalk:bind(smalltalk.BootSector,"object:",0
,function(self,associations)
return ((self):object_indent_(associations,true));
end
,"asm","object: associations\r\n\t\" Private - Encoding for object literal. \"\r\n\r\n\t^self object: associations indent: true","function(self,associations)\r\nreturn ((self):object_indent_(associations,true));\r\nend")

smalltalk:bind(smalltalk.BootSector,"emptyObject",0
,function(self)
return ((self):object_indent_(smalltalk:newArray({}),false));
end
,"asm","emptyObject\r\n\t\" Private - Encoding for empty object literal. \"\r\n\r\n\t^self object: #() indent: false","function(self)\r\nreturn ((self):object_indent_(smalltalk:newArray({}),false));\r\nend")

smalltalk:bind(smalltalk.BootSector,"ifOP",0
,function(self)
return ("if ");
end
,"asm-constants","ifOP\r\n\t\" Private - Encoding for if OP (or nil) \"\r\n\r\n\t^'if ' ","function(self)\r\nreturn (\"if \");\r\nend")

smalltalk:bind(smalltalk.BootSector,"elseOP",0
,function(self)
return ("else");
end
,"asm-constants","elseOP\r\n\t\" Private - Encoding for else OP \"\r\n\r\n\t^#else ","function(self)\r\nreturn (\"else\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"if:",0
,function(self,condition)
if (smalltalk:notNil_(((self):ifOP())))==true then (self):nextPutAll_((self):ifOP()); end;
(self):between_do_indent_((self):conditionPars_(condition),condition,false);
return (self);
end
,"asm","if: condition\r\n\t\" Private - Encoding for conditional. \"\r\n\r\n\tself ifOP notNil ifTrue: [ self nextPutAll: self ifOP ].\r\n\tself between: (self conditionPars: condition) do: condition indent: false.","function(self,condition)\r\nif (smalltalk:notNil_(((self):ifOP())))==true then (self):nextPutAll_((self):ifOP()); end;\r\n(self):between_do_indent_((self):conditionPars_(condition),condition,false);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"if:do:",0
,function(self,condition,trueBlock)
(self):if_do_else_(condition,trueBlock,nil);
return (self);
end
,"asm","if: condition do: trueBlock\r\n\t\" Private - Encoding for conditional. \"\r\n\r\n\tself if: condition do: trueBlock else: nil","function(self,condition,trueBlock)\r\n(self):if_do_else_(condition,trueBlock,nil);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"if:do:else:",0
,function(self,condition,trueBlock,falseBlock)
(
function(_s8_rec)
	(_s8_rec):if_(condition);
	return ((_s8_rec):space())
end
)(self);
(self):between_do_indent_((self):blockOPs(),trueBlock,true);
if (smalltalk:notNil_((falseBlock)))==true then (self):nextPutAll_((self):elseOP());
(self):between_do_indent_((self):blockOPs(),falseBlock,true); end;
return (self);
end
,"asm","if: condition do: trueBlock else: falseBlock\r\n\t\" Private - Encoding for conditional. \"\r\n\r\n\tself if: condition; space.\r\n\tself between: self blockOPs do: trueBlock indent: true.\r\n\tfalseBlock notNil ifTrue: [\r\n\t\tself nextPutAll: self elseOP.\r\n\t\tself between: self blockOPs do: falseBlock indent: true.\r\n\t]","function(self,condition,trueBlock,falseBlock)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_(condition);\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(self):between_do_indent_((self):blockOPs(),trueBlock,true);\r\nif (smalltalk:notNil_((falseBlock)))==true then (self):nextPutAll_((self):elseOP());\r\n(self):between_do_indent_((self):blockOPs(),falseBlock,true); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"if:return:",0
,function(self,condition,expression)
(
function(_s8_rec)
	(_s8_rec):if_(condition);
	(_s8_rec):space();
	return ((_s8_rec):return_(expression))
end
)(self);
return (self);
end
,"asm","if: condition return: expression\r\n\t\" Private - Encoding for conditional expression return. \"\r\n\r\n\tself if: condition; space; return: expression","function(self,condition,expression)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_(condition);\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):return_(expression))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"if:or:return:",0
,function(self,expr1,expr2,expression)
(self):if_return_((function()
return ((self):expr_or_(expr1,expr2))
end),expression);
return (self);
end
,"asm","if: expr1 or: expr2 return: expression\r\n\t\" Private - Encoding for conditional expression return. \"\r\n\r\n\tself if: [ self expr: expr1 or: expr2 ] return: expression ","function(self,expr1,expr2,expression)\r\n(self):if_return_((function()\r\nreturn ((self):expr_or_(expr1,expr2))\r\nend),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"if:or:or:return:",0
,function(self,expr1,expr2,expr3,expression)
(self):if_return_((function()
return ((self):expr_or_(expr1,(function()
return ((self):expr_or_(expr2,expr3))
end)))
end),expression);
return (self);
end
,"asm","if: expr1 or: expr2 or: expr3 return: expression\r\n\t\" Private - Encoding for conditional expression return. \"\r\n\r\n\tself if: [ self expr: expr1 or: [self expr: expr2 or: expr3]] return: expression ","function(self,expr1,expr2,expr3,expression)\r\n(self):if_return_((function()\r\nreturn ((self):expr_or_(expr1,(function()\r\nreturn ((self):expr_or_(expr2,expr3))\r\nend)))\r\nend),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"if:and:return:",0
,function(self,expr1,expr2,expression)
(self):if_return_((function()
return ((self):expr_and_(expr1,expr2))
end),expression);
return (self);
end
,"asm","if: expr1 and: expr2 return: expression\r\n\t\" Private - Encoding for conditional expression return. \"\r\n\r\n\tself if: [ self expr: expr1 and: expr2 ] return: expression ","function(self,expr1,expr2,expression)\r\n(self):if_return_((function()\r\nreturn ((self):expr_and_(expr1,expr2))\r\nend),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"if:or:do:",0
,function(self,expr1,expr2,expression)
(self):if_do_((function()
return ((self):expr_or_(expr1,expr2))
end),expression);
return (self);
end
,"asm","if: expr1 or: expr2 do: expression\r\n\t\" Private - Encoding for conditional expression. \"\r\n\r\n\tself if: [ self expr: expr1 or: expr2 ] do: expression ","function(self,expr1,expr2,expression)\r\n(self):if_do_((function()\r\nreturn ((self):expr_or_(expr1,expr2))\r\nend),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"if:or:or:do:",0
,function(self,expr1,expr2,expr3,expression)
(self):if_do_((function()
return ((self):expr_or_(expr1,(function()
return ((self):expr_or_(expr2,expr3))
end)))
end),expression);
return (self);
end
,"asm","if: expr1 or: expr2 or: expr3 do: expression\r\n\t\" Private - Encoding for conditional expression. \"\r\n\r\n\tself if: [ self expr: expr1 or: [self expr: expr2 or: expr3]] do: expression ","function(self,expr1,expr2,expr3,expression)\r\n(self):if_do_((function()\r\nreturn ((self):expr_or_(expr1,(function()\r\nreturn ((self):expr_or_(expr2,expr3))\r\nend)))\r\nend),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"if:and:do:",0
,function(self,expr1,expr2,expression)
(self):if_do_((function()
return ((self):expr_and_(expr1,expr2))
end),expression);
return (self);
end
,"asm","if: expr1 and: expr2 do: expression\r\n\t\" Private - Encoding for conditional expression. \"\r\n\r\n\tself if: [ self expr: expr1 and: expr2 ] do: expression ","function(self,expr1,expr2,expression)\r\n(self):if_do_((function()\r\nreturn ((self):expr_and_(expr1,expr2))\r\nend),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"argumentsSeparatorOp",0
,function(self)
return (",");
end
,"asm-constants","argumentsSeparatorOp\r\n\t\" Private - Return the OP for separating arguments. \"\r\n\r\n\t^$, ","function(self)\r\nreturn (\",\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"nextPutArgument:",0
,function(self,arg)
if (smalltalk:boolean_or_(((arg):isString()),(function()
return ((arg):isValuable())
end)))==true then return ((self):nextPutAll_(arg)); end;
return ((self):error_(smalltalk:object_comma_(("Invalid argument "),(arg):asLiteral())));
end
,"asm","nextPutArgument: arg\r\n\t\" Private - Encode argument. \"\r\n\r\n\t(arg isString or: [arg isValuable]) ifTrue: [ ^self nextPutAll: arg ].\r\n\t^self error: 'Invalid argument ' ,arg asLiteral ","function(self,arg)\r\nif (smalltalk:boolean_or_(((arg):isString()),(function()\r\nreturn ((arg):isValuable())\r\nend)))==true then return ((self):nextPutAll_(arg)); end;\r\nreturn ((self):error_(smalltalk:object_comma_((\"Invalid argument \"),(arg):asLiteral())));\r\nend")

smalltalk:bind(smalltalk.BootSector,"nextPutArguments:",0
,function(self,args)
(args):do_separatedBy_((function(each)
return ((self):nextPutArgument_(each))
end),(function()
return ((self):nextPutAll_((self):argumentsSeparatorOp()))
end));
return (self);
end
,"asm","nextPutArguments: args\r\n\t\" Private - Encode arguments. \"\r\n\r\n\targs\r\n\t    do: [:each | self nextPutArgument: each ]\r\n\t    separatedBy: [ self nextPutAll: self argumentsSeparatorOp ]","function(self,args)\r\n(args):do_separatedBy_((function(each)\r\nreturn ((self):nextPutArgument_(each))\r\nend),(function()\r\nreturn ((self):nextPutAll_((self):argumentsSeparatorOp()))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"bind:arguments:doing:comment:",0
,function(self,selector,args,implementation,aComment)
return ((self):implementedBySubclass_("bind:arguments:doing:"));
end
,"asm","bind: selector arguments: args doing: implementation comment: aComment\r\n\t\" Private - Encoding for internal method implementation. \"\r\n\r\n\t^self implementedBySubclass: #bind:arguments:doing: ","function(self,selector,args,implementation,aComment)\r\nreturn ((self):implementedBySubclass_(\"bind:arguments:doing:\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"bind:arguments:doing:",0
,function(self,selector,args,implementation)
return ((self):bind_arguments_doing_comment_(selector,args,implementation,nil));
end
,"asm","bind: selector arguments: args doing: implementation\r\n\t\" Private - Encoding for internal method implementation. \"\r\n\r\n\t^self\tbind: selector arguments: args\r\n\t\tdoing: implementation comment: nil ","function(self,selector,args,implementation)\r\nreturn ((self):bind_arguments_doing_comment_(selector,args,implementation,nil));\r\nend")

smalltalk:bind(smalltalk.BootSector,"bind:arguments:private:",0
,function(self,selector,args,implementation)
return ((self):bind_arguments_doing_comment_(selector,args,implementation,"Private"));
end
,"asm","bind: selector arguments: args private: implementation\r\n\t\" Private - Encoding for internal method implementation. \"\r\n\r\n\t^self\tbind: selector arguments: args\r\n\t\tdoing: implementation comment: #Private ","function(self,selector,args,implementation)\r\nreturn ((self):bind_arguments_doing_comment_(selector,args,implementation,\"Private\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"localOP",0
,function(self)
return (nil);
end
,"asm-constants","localOP\r\n\t\" Private - Return the OP for defining new local variable (or nil). \"\r\n\r\n\t^nil ","function(self)\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.BootSector,"local:with:",0
,function(self,localName,expression)
if (smalltalk:notNil_(((self):localOP())))==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):localOP());
	return ((_s8_rec):space())
end
)(self); end;
if (smalltalk:isNil_((expression)))==true then (self):nextPutAll_(localName); else (self):assign_to_(localName,expression); end;
return (self);
end
,"asm","local: localName with: expression\r\n\t\" Private - Encoding for new local variable. \"\r\n\r\n\tself localOP notNil ifTrue: [\r\n\t\tself nextPutAll: self localOP; space\r\n\t].\r\n\texpression isNil\r\n\tifTrue: [ self nextPutAll: localName ]\r\n\tifFalse: [ self assign: localName to: expression ]","function(self,localName,expression)\r\nif (smalltalk:notNil_(((self):localOP())))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):localOP());\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self); end;\r\nif (smalltalk:isNil_((expression)))==true then (self):nextPutAll_(localName); else (self):assign_to_(localName,expression); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"local:",0
,function(self,localName)
(self):local_with_(localName,nil);
return (self);
end
,"asm","local: localName\r\n\t\" Private - Encoding for new local variable. \"\r\n\r\n\tself local: localName with: nil ","function(self,localName)\r\n(self):local_with_(localName,nil);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"stringOPs",0
,function(self)
return ("\"");
end
,"asm-constants","stringOPs\r\n\t\" Private - Return the OP for raw string. \"\r\n\r\n\t^$\" ","function(self)\r\nreturn (\"\\\"\");\r\nend")

smalltalk:bind(smalltalk.BootSector,"string:",0
,function(self,token)
(self):between_do_indent_((self):stringOPs(),token,false);
return (self);
end
,"asm","string: token\r\n\t\" Private - Encoding for raw string literal. \"\r\n\r\n\tself between: self stringOPs do: token indent: false","function(self,token)\r\n(self):between_do_indent_((self):stringOPs(),token,false);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"typeofOPs",0
,function(self)
return (smalltalk:newArray({"typeof ", ""}));
end
,"asm-constants","typeofOPs\r\n\t\" Private - Return the OP for typeOf expression. \"\r\n\r\n\t^#('typeof ' '') ","function(self)\r\nreturn (smalltalk:newArray({\"typeof \", \"\"}));\r\nend")

smalltalk:bind(smalltalk.BootSector,"typeofArg:",0
,function(self,token)
return ((function()
return ((self):string_(token))
end));
end
,"asm-constants","typeofArg: token\r\n\t\" Private - Return the OP for typeOf argument. \"\r\n\r\n\t^[self string: token] ","function(self,token)\r\nreturn ((function()\r\nreturn ((self):string_(token))\r\nend));\r\nend")

smalltalk:bind(smalltalk.BootSector,"typeOf:is:",0
,function(self,expression,token)
(self):expr_eqeq_((function()
return ((self):between_do_indent_((self):typeofOPs(),expression,false))
end),(self):typeofArg_(token));
return (self);
end
,"asm","typeOf: expression is: token\r\n\t\" Private - Encoding for testing typeof expression. \"\r\n\r\n\tself\texpr: [self between: self typeofOPs do: expression indent: false]\r\n\t\teqeq: (self typeofArg: token) ","function(self,expression,token)\r\n(self):expr_eqeq_((function()\r\nreturn ((self):between_do_indent_((self):typeofOPs(),expression,false))\r\nend),(self):typeofArg_(token));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BootSector,"typeOf:isNot:",0
,function(self,expression,token)
(self):expr_noteq_((function()
return ((self):between_do_indent_((self):typeofOPs(),expression,false))
end),(self):typeofArg_(token));
return (self);
end
,"asm","typeOf: expression isNot: token\r\n\t\" Private - Encoding for testing typeof expression. \"\r\n\r\n\tself\texpr: [self between: self typeofOPs do: expression indent: false]\r\n\t\tnoteq: (self typeofArg: token) ","function(self,expression,token)\r\n(self):expr_noteq_((function()\r\nreturn ((self):between_do_indent_((self):typeofOPs(),expression,false))\r\nend),(self):typeofArg_(token));\r\nreturn (self);\r\nend")
