
-- fileIn("s8/library/eden/jsBoot.st")
smalltalk:addClass("JSBoot",smalltalk.BootSector,smalltalk:newArray({}),"jsBoot")

smalltalk:bind(smalltalk.JSBoot["$klass"],"supportsLanguage:",0
,function(self,aLanguage)
return ((smalltalk.JSEncoder):supportsLanguage_(aLanguage));
end
,"instantiation","supportsLanguage: aLanguage\r\n\t\" Private - Return true if instances of the receiver can encode to aLanguage. \"\r\n\r\n\t^JSEncoder supportsLanguage: aLanguage","function(self,aLanguage)\r\nreturn ((smalltalk.JSEncoder):supportsLanguage_(aLanguage));\r\nend")

smalltalk:bind(smalltalk.JSBoot,"version",0
,function(self)
return ("1.7.0 - Stable");
end
,"constants","version\r\n\t\" Private - Returns the version string (dotted number and date). \"\r\n\r\n\t^'1.7.0 - Stable'","function(self)\r\nreturn (\"1.7.0 - Stable\");\r\nend")

smalltalk:bind(smalltalk.JSBoot,"lineComment:",0
,function(self,aString)
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:object_comma_(("// "),aString));
	return ((_s8_rec):cr())
end
)(self));
end
,"encoding","lineComment: aString\r\n\t\" Private - Encode aString as line comment. \"\r\n\r\n\t^self nextPutAll: '// ' ,aString;cr ","function(self,aString)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((\"// \"),aString));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self));\r\nend")

smalltalk:bind(smalltalk.JSBoot,"multilineComment:",0
,function(self,array)
return ((self):encode_((function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("/*");
	return ((_s8_rec):indent())
end
)(self);(array):do_((function(line)
return ((
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(line))
end
)(self))
end));return ((
function(_s8_rec)
	(_s8_rec):dedent();
	(_s8_rec):cr();
	(_s8_rec):nextPutAll_("*/");
	return ((_s8_rec):cr())
end
)(self))
end)));
end
,"encoding","multilineComment: array\r\n\t\" Private - Encode an array as a multiline comment. \"\r\n\r\n\t^self encode: [\r\n\t\tself nextPutAll: '/*' ;indent.\r\n\t\tarray do: [:line| self cr; nextPutAll: line ].\r\n\t\tself dedent; cr; nextPutAll: '*/'; cr\r\n\t]","function(self,array)\r\nreturn ((self):encode_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"/*\");\r\n\treturn ((_s8_rec):indent())\r\nend\r\n)(self);(array):do_((function(line)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(line))\r\nend\r\n)(self))\r\nend));return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):dedent();\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):nextPutAll_(\"*/\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.JSBoot,"bind:to:with:",0
,function(self,selector,object,expression)
(self):assign_to_(smalltalk:object_comma_((smalltalk:object_comma_((object),".")),(selector):asSelector()),expression);
return (self);
end
,"encoding","bind: selector to: object with: expression\r\n\t\" Private - Bind message selector to object to execute expression when the message is received. \"\r\n\r\n\tself assign: object ,$. ,selector asSelector to: expression ","function(self,selector,object,expression)\r\n(self):assign_to_(smalltalk:object_comma_((smalltalk:object_comma_((object),\".\")),(selector):asSelector()),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"bind:to:doing:",0
,function(self,selector,object,expression)
(
function(_s8_rec)
	(_s8_rec):bind_to_with_(selector,object,expression);
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"encoding","bind: selector to: object doing: expression\r\n\t\" Private - Bind message selector to object to execute expression when the message is received. \"\r\n\r\n\tself bind: selector to: object with: expression; cr ","function(self,selector,object,expression)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):bind_to_with_(selector,object,expression);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"initialDefinition",0
,function(self)
return ((self):encode_((function()
(smalltalk:newArray({"Object", "Behavior", "Class", "Method"})):do_((function(cls)
return ((
function(_s8_rec)
	(_s8_rec):implementFunction_(smalltalk:object_comma_(("St"),cls));
	return ((_s8_rec):cr())
end
)(self))
end));return ((
function(_s8_rec)
	(_s8_rec):implementFunction_doing_("StMetaclass","this.$meta = true;");
	return ((_s8_rec):cr())
end
)(self))
end)));
end
,"definitions","initialDefinition\r\n\t\" Private - Return the encoding for initializing execution environment. \"\r\n\r\n\t^self encode: [\r\n\t\t#(Object Behavior Class Method) do: [:cls|\r\n\t\t\tself implementFunction: #St ,cls;cr\r\n\t\t].\r\n\t\tself implementFunction: #StMetaclass doing: 'this.$meta = true;';cr\r\n\t] ","function(self)\r\nreturn ((self):encode_((function()\r\n(smalltalk:newArray({\"Object\", \"Behavior\", \"Class\", \"Method\"})):do_((function(cls)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_(smalltalk:object_comma_((\"St\"),cls));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_doing_(\"StMetaclass\",\"this.$meta = true;\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.JSBoot,"blockOPs",0
,function(self)
return ("{}");
end
,"asm-constants","blockOPs\r\n\t\" Private - Encoding for expression block OPs \"\r\n\r\n\t^'{}' ","function(self)\r\nreturn (\"{}\");\r\nend")

smalltalk:bind(smalltalk.JSBoot,"localOP",0
,function(self)
return ("var");
end
,"asm-constants","localOP\r\n\t\" Private - Return the OP for defining new local variable (or nil). \"\r\n\r\n\t^#var ","function(self)\r\nreturn (\"var\");\r\nend")

smalltalk:bind(smalltalk.JSBoot,"fieldOP",0
,function(self)
return (":");
end
,"asm-constants","fieldOP\r\n\t\" Private - Return the OP for tuple separator. \"\r\n\r\n\t^$: ","function(self)\r\nreturn (\":\");\r\nend")

smalltalk:bind(smalltalk.JSBoot,"cases:",0
,function(self,array)
(array):do_((function(assoc)
local options=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((((assoc):key()):isArray()),(function()
return ((assoc):key())
end),(function()
return ((smalltalk.Array):with_((assoc):key()))
end)))
	options=_s8_value
	return _s8_value
end)();(options):do_separatedBy_((function(each)
return (smalltalk:if_true_false_(((each):isString()),(function()
return ((self):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(("case \""),each)),"\": ")))
end),(function()
return ((each):do_((function(one)
return ((self):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(("case \""),one)),"\": ")))
end)))
end)))
end),(function()
return ((self):cr())
end));return ((
function(_s8_rec)
	(_s8_rec):indent();
	(_s8_rec):cr();
	(_s8_rec):nextPutAll_((assoc):value());
	(_s8_rec):dedent();
	return ((_s8_rec):cr())
end
)(self))
end));
return (self);
end
,"asm","cases: array\r\n\t\" Private - Encoding option cases. \"\r\n\r\n\tarray do: [:assoc| | options |\r\n\t\toptions := assoc key isArray\r\n\t\t\tifTrue: [ assoc key ]\r\n\t\t\tifFalse: [ Array with: assoc key].\r\n\t\toptions do: [:each|\r\n\t\t\teach isString\r\n\t\t\tifTrue: [ self nextPutAll: 'case \"', each ,'\": ' ]\r\n\t\t\tifFalse: [ each do: [:one| self nextPutAll: 'case \"', one ,'\": ' ] ].\r\n\t\t] separatedBy: [ self cr ].\r\n\t\tself\tindent;cr;\r\n\t\t\tnextPutAll: assoc value;\r\n\t\t\tdedent;cr\r\n\t]","function(self,array)\r\n(array):do_((function(assoc)\r\nlocal options=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((((assoc):key()):isArray()),(function()\r\nreturn ((assoc):key())\r\nend),(function()\r\nreturn ((smalltalk.Array):with_((assoc):key()))\r\nend)))\r\n\toptions=_s8_value\r\n\treturn _s8_value\r\nend)();(options):do_separatedBy_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):isString()),(function()\r\nreturn ((self):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\"case \\\"\"),each)),\"\\\": \")))\r\nend),(function()\r\nreturn ((each):do_((function(one)\r\nreturn ((self):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\"case \\\"\"),one)),\"\\\": \")))\r\nend)))\r\nend)))\r\nend),(function()\r\nreturn ((self):cr())\r\nend));return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):indent();\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):nextPutAll_((assoc):value());\r\n\t(_s8_rec):dedent();\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"emptyString",0
,function(self)
return ("\"\"");
end
,"asm-constants","emptyString\r\n\t\" Private - Encoding for empty string literal. \"\r\n\r\n\t^'\"\"' ","function(self)\r\nreturn (\"\\\"\\\"\");\r\nend")

smalltalk:bind(smalltalk.JSBoot,"emptyArray",0
,function(self)
return ("[]");
end
,"asm-constants","emptyArray\r\n\t\" Private - Encoding for empty Array literal. \"\r\n\r\n\t^'[]' ","function(self)\r\nreturn (\"[]\");\r\nend")

smalltalk:bind(smalltalk.JSBoot,"break","__break"
,function(self)
return ((
function(_s8_rec)
	(_s8_rec):space();
	return ((_s8_rec):nextPutAll_("break"))
end
)(self));
end
,"asm","break\r\n\t\" Private - Encoding for break expression. \"\r\n\r\n\t^self space; nextPutAll: #break ","function(self)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):nextPutAll_(\"break\"))\r\nend\r\n)(self));\r\nend")

smalltalk:bind(smalltalk.JSBoot,"whileDoOPs",0
,function(self)
return ((smalltalk.Array):with_with_("while",""));
end
,"asm-constants","whileDoOPs\r\n\t\" Private - Return the OPs for while-do expression. \"\r\n\r\n\t^Array with: #while with: '' ","function(self)\r\nreturn ((smalltalk.Array):with_with_(\"while\",\"\"));\r\nend")

smalltalk:bind(smalltalk.JSBoot,"forInDoOPs",0
,function(self)
return ((smalltalk.Array):with_with_with_("for","in",""));
end
,"asm-constants","forInDoOPs\r\n\t\" Private - Return the OPs for for-in-do expression. \"\r\n\r\n\t^Array with: #for with: #in with: ''","function(self)\r\nreturn ((smalltalk.Array):with_with_with_(\"for\",\"in\",\"\"));\r\nend")

smalltalk:bind(smalltalk.JSBoot,"forInDoPars",0
,function(self)
return ("()");
end
,"asm-constants","forInDoPars\r\n\t\" Private - Return the parentesis for for-in-do expression. \"\r\n\r\n\t^'()'","function(self)\r\nreturn (\"()\");\r\nend")

smalltalk:bind(smalltalk.JSBoot,"deleteOP",0
,function(self)
return ("delete");
end
,"asm-constants","deleteOP\r\n\t\" Private - Return the OP for delete operator. \"\r\n\r\n\t^#delete ","function(self)\r\nreturn (\"delete\");\r\nend")

smalltalk:bind(smalltalk.JSBoot,"delete:",0
,function(self,expression)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):deleteOP());
	(_s8_rec):space();
	return ((_s8_rec):nextPutAll_(expression))
end
)(self);
return (self);
end
,"asm","delete: expression\r\n\t\" Private - Encoding for delete expression. \"\r\n\r\n\tself nextPutAll: self deleteOP; space; nextPutAll: expression ","function(self,expression)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):deleteOP());\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):nextPutAll_(expression))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"switch:cases:",0
,function(self,condition,array)
(self):nextPutAll_("switch");
(
function(_s8_rec)
	(_s8_rec):between_do_indent_("()",condition,false);
	return ((_s8_rec):space())
end
)(self);
(self):between_do_indent_("{}",(function()
return ((self):cases_(array))
end),true);
return (self);
end
,"asm","switch: condition cases: array\r\n\t\" Private - Encoding for switch expression. \"\r\n\r\n\tself nextPutAll: #switch.\r\n\tself between: '()' do: condition indent: false; space.\r\n\tself between: '{}' do: [ self cases: array ] indent: true.","function(self,condition,array)\r\n(self):nextPutAll_(\"switch\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):between_do_indent_(\"()\",condition,false);\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(self):between_do_indent_(\"{}\",(function()\r\nreturn ((self):cases_(array))\r\nend),true);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"assign:property:to:",0
,function(self,obj,key,expression)
(self):assign_to_(smalltalk:object_comma_((smalltalk:object_comma_((obj),".")),key),expression);
return (self);
end
,"asm","assign: obj property: key to: expression\r\n\t\" Private - Encoding for assignment to object property. \"\r\n\r\n\tself assign: obj ,$. ,key to: expression ","function(self,obj,key,expression)\r\n(self):assign_to_(smalltalk:object_comma_((smalltalk:object_comma_((obj),\".\")),key),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"assign:iv:to:",0
,function(self,rcv,ivName,expression)
(self):assign_property_to_(rcv,smalltalk:object_comma_(("@"),ivName),expression);
return (self);
end
,"asm","assign: rcv iv: ivName to: expression\r\n\t\" Private - Encoding for assignment to object instance variable. \"\r\n\r\n\tself assign: rcv property: $@ ,ivName to: expression ","function(self,rcv,ivName,expression)\r\n(self):assign_property_to_(rcv,smalltalk:object_comma_((\"@\"),ivName),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"assign:pv:to:",0
,function(self,rcv,pvName,expression)
(self):assign_property_to_(rcv,smalltalk:object_comma_(("$"),pvName),expression);
return (self);
end
,"asm","assign: rcv pv: pvName to: expression\r\n\t\" Private - Encoding for assignment to object private variable. \"\r\n\r\n\tself assign: rcv property: $$ ,pvName to: expression ","function(self,rcv,pvName,expression)\r\n(self):assign_property_to_(rcv,smalltalk:object_comma_((\"$\"),pvName),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"selfOP",0
,function(self)
return ("this");
end
,"asm-constants","selfOP\r\n\t\" Private - Encoding for self. \"\r\n\r\n\t^#this ","function(self)\r\nreturn (\"this\");\r\nend")

smalltalk:bind(smalltalk.JSBoot,"bind:arguments:doing:comment:",0
,function(self,selector,args,implementation,aComment)
(self):bind_to_doing_(selector,"this",(function()
return ((self):implementFunction_arguments_doing_comment_("",args,implementation,aComment))
end));
return (self);
end
,"asm","bind: selector arguments: args doing: implementation comment: aComment\r\n\t\" Private - Encoding for internal method implementation. \"\r\n\r\n\tself bind: selector to: #this doing: [\r\n\t\tself\timplementFunction: '' arguments: args\r\n\t\t\tdoing: implementation comment: aComment\r\n\t]","function(self,selector,args,implementation,aComment)\r\n(self):bind_to_doing_(selector,\"this\",(function()\r\nreturn ((self):implementFunction_arguments_doing_comment_(\"\",args,implementation,aComment))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"bindAPI:",0
,function(self,spec)
local rcv=nil
local selector=nil
local action=nil
if ((spec):isString())==true then return ((self):bindAPI_((smalltalk.Array):with_with_(spec,smalltalk:newArray({})))); end;
if not ((((spec):last()):isArray()))==true then return ((self):error_(smalltalk:object_comma_(("Invalid/corrupt API spec "),(spec):asLiteral()))); end;
(function()
	local _s8_value=(smalltalk:object_comma_((((spec):first()):asSelector()),"Implementation"))
	selector=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((function()
return ((rcv):perform_(selector))
end))
	action=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:responds_to_((self),(selector))),(function()
return (self)
end),(function()
return (smalltalk:if_true_false_((smalltalk:responds_to_(((self)["$klass"]),(selector))),(function()
return ((self)["$klass"])
end),(function()
return ((function()
	local _s8_value=((function()
return ((self):comment_(smalltalk:object_comma_((smalltalk:object_comma_(("*ToDo* - API "),(selector):asLiteral()))," Not Implemented Yet.")))
end))
	action=_s8_value
	return _s8_value
end)())
end)))
end)))
	rcv=_s8_value
	return _s8_value
end)();
(self):bind_arguments_doing_((spec):first(),(spec):last(),action);
return (self);
end
,"private","bindAPI: spec\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\t| rcv selector action |\r\n\tspec isString ifTrue: [ ^self bindAPI: (Array with: spec with: #()) ].\r\n\tspec last isArray ifFalse: [\r\n\t\t^self error: 'Invalid/corrupt API spec ' ,spec asLiteral\r\n\t].\r\n\tselector := spec first asSelector ,#Implementation.\r\n\taction := [ rcv perform: selector ].\r\n\trcv := (self respondsTo: selector) ifTrue: [ self ] ifFalse: [\r\n\t\t(self class respondsTo: selector) ifTrue: [ self class ] ifFalse: [\r\n\t\t\t\" self error: 'Missing API implementation for ' ,selector asLiteral \"\r\n\t\t\taction := [ self comment: '*ToDo* - API ' ,selector asLiteral ,' Not Implemented Yet.' ]\r\n\t\t]\r\n\t].\r\n\tself bind: spec first arguments: spec last doing: action ","function(self,spec)\r\nlocal rcv=nil\r\nlocal selector=nil\r\nlocal action=nil\r\nif ((spec):isString())==true then return ((self):bindAPI_((smalltalk.Array):with_with_(spec,smalltalk:newArray({})))); end;\r\nif not ((((spec):last()):isArray()))==true then return ((self):error_(smalltalk:object_comma_((\"Invalid/corrupt API spec \"),(spec):asLiteral()))); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((((spec):first()):asSelector()),\"Implementation\"))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((function()\r\nreturn ((rcv):perform_(selector))\r\nend))\r\n\taction=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:responds_to_((self),(selector))),(function()\r\nreturn (self)\r\nend),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:responds_to_(((self)[\"$klass\"]),(selector))),(function()\r\nreturn ((self)[\"$klass\"])\r\nend),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=((function()\r\nreturn ((self):comment_(smalltalk:object_comma_((smalltalk:object_comma_((\"*ToDo* - API \"),(selector):asLiteral())),\" Not Implemented Yet.\")))\r\nend))\r\n\taction=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)))\r\nend)))\r\n\trcv=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):bind_arguments_doing_((spec):first(),(spec):last(),action);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"nilImplementation",0
,function(self)
return ((self):encode_((function()
return ((
function(_s8_rec)
	(_s8_rec):bind_to_doing_("toString","nil","function(){ return \"nil\" }");
	(_s8_rec):bind_to_doing_("isNil:","nil",(function()
return ((self):nilIsNilImplementation())
end));
	(_s8_rec):bind_to_doing_("is:eqeq:","nil",(function()
return ((self):nilIsEqeqImplementation())
end));
	return ((_s8_rec):yourself())
end
)(self))
end)));
end
,"implementations","nilImplementation\r\n\t\" Private - Return the encoding for nil implementation. \"\r\n\r\n\t^self encode: [\r\n\t\tself\r\n\t\t\tbind: #toString to: #nil doing: 'function(){ return \"nil\" }';\r\n\t\t\tbind: #isNil: to: #nil doing: [ self nilIsNilImplementation ];\r\n\t\t\tbind: #is:eqeq: to: #nil doing: [ self nilIsEqeqImplementation ];\r\n\t\t\tyourself\r\n\t] ","function(self)\r\nreturn ((self):encode_((function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):bind_to_doing_(\"toString\",\"nil\",\"function(){ return \\\"nil\\\" }\");\r\n\t(_s8_rec):bind_to_doing_(\"isNil:\",\"nil\",(function()\r\nreturn ((self):nilIsNilImplementation())\r\nend));\r\n\t(_s8_rec):bind_to_doing_(\"is:eqeq:\",\"nil\",(function()\r\nreturn ((self):nilIsEqeqImplementation())\r\nend));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(self))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.JSBoot,"nilIsNilImplementation",0
,function(self)
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"x"}),(function()
(
function(_s8_rec)
	(_s8_rec):switch_cases_("typeof x",(smalltalk:object_comma_((("undefined"):_minus_gt((function()
return ((self):return_("true"))
end))),(smalltalk:newArray({smalltalk:newArray({"string", "boolean"}), smalltalk:newArray({"number", "function"})})):_minus_gt((function()
return ((self):return_("false"))
end)))):asArray());
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_or_return_((function()
return ((self):expr_eqeqeq_("x","null"))
end),(function()
return ((self):expr_eqeqeq_("x","this"))
end),"true");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeqeq_("x","smalltalk"))
end),"false");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_and_return_("x.$klass",(function()
return ((self):typeOf_is_("x.isNil","function"))
end),(function()
return ((self):send_to_("isNil","x"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("false"))
end)));
end
,"implementations","nilIsNilImplementation\r\n\t\" Private - Encoding for #isNil: implementation. \"\r\n\r\n\t^self implementFunction: '' arguments: #(x) doing: [\r\n\t\tself switch: 'typeof x' cases: (\r\n\t\t\t#undefined -> [self return: #true]\r\n\t\t\t,(#( #(string boolean) #(number function)) -> [self return: #false] )\r\n\t\t\t) asArray;cr.\r\n\t\tself if: [self expr: #x eqeqeq: #null] or: [self expr: #x eqeqeq: #this] return: #true;cr.\r\n\t\tself if: [self expr: #x eqeqeq: #smalltalk] return: #false;cr.\r\n\t\tself if: 'x.$klass' and: [self typeOf: 'x.isNil' is: #function] return: [ self send: #isNil to: #x ];cr.\r\n\t\tself return: #false\r\n\t] ","function(self)\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"x\"}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):switch_cases_(\"typeof x\",(smalltalk:object_comma_(((\"undefined\"):_minus_gt((function()\r\nreturn ((self):return_(\"true\"))\r\nend))),(smalltalk:newArray({smalltalk:newArray({\"string\", \"boolean\"}), smalltalk:newArray({\"number\", \"function\"})})):_minus_gt((function()\r\nreturn ((self):return_(\"false\"))\r\nend)))):asArray());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_or_return_((function()\r\nreturn ((self):expr_eqeqeq_(\"x\",\"null\"))\r\nend),(function()\r\nreturn ((self):expr_eqeqeq_(\"x\",\"this\"))\r\nend),\"true\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeqeq_(\"x\",\"smalltalk\"))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_and_return_(\"x.$klass\",(function()\r\nreturn ((self):typeOf_is_(\"x.isNil\",\"function\"))\r\nend),(function()\r\nreturn ((self):send_to_(\"isNil\",\"x\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"false\"))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.JSBoot,"nilIsEqeqImplementation",0
,function(self)
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"a", "b"}),(function()
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeqeq_("a","b"))
end),"true");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_or_return_((function()
return ((self):send_with_("isNil:","a"))
end),(function()
return ((self):send_with_("isNil:","b"))
end),"false");
	return ((_s8_rec):cr())
end
)(self);return ((self):return_((function()
return ((self):expr_eqeqeq_((function()
return ((self):send_to_("valueOf","a"))
end),(function()
return ((self):send_to_("valueOf","b"))
end)))
end)))
end)));
end
,"implementations","nilIsEqeqImplementation\r\n\t\" Private - Encoding for #is:eqeq: implementation. \"\r\n\r\n\t^self implementFunction: '' arguments: #(a b) doing: [\r\n\t\tself if: [self expr: #a eqeqeq: #b] return: #true;cr.\r\n\t\tself\tif: [self send: #isNil: with: #a]\r\n\t\t\tor: [self send: #isNil: with: #b]\r\n\t\t\treturn: #false;cr.\r\n\t\tself return: [\r\n\t\t\tself\texpr: [ self send: #valueOf to: #a ]\r\n\t\t\t\teqeqeq: [ self send: #valueOf to: #b ]\r\n\t\t]\r\n\t] ","function(self)\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"a\", \"b\"}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeqeq_(\"a\",\"b\"))\r\nend),\"true\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_or_return_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"a\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"isNil:\",\"b\"))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_((function()\r\nreturn ((self):expr_eqeqeq_((function()\r\nreturn ((self):send_to_(\"valueOf\",\"a\"))\r\nend),(function()\r\nreturn ((self):send_to_(\"valueOf\",\"b\"))\r\nend)))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.JSBoot,"smalltalkImplementation",0
,function(self)
return ((self):encode_((function()
return ((self):bind_to_doing_("toString","smalltalk","function() { return \"smalltalk\" }"))
end)));
end
,"implementations","smalltalkImplementation\r\n\t\" Private - Return the encoding for smalltalk implementation. \"\r\n\r\n\t^self encode: [\r\n\t\tself bind: #toString to: #smalltalk doing: 'function() { return \"smalltalk\" }'\r\n\t] ","function(self)\r\nreturn ((self):encode_((function()\r\nreturn ((self):bind_to_doing_(\"toString\",\"smalltalk\",\"function() { return \\\"smalltalk\\\" }\"))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.JSBoot,"systemDictionaryPrivates",0
,function(self)
(self):bind_arguments_private_("klass",smalltalk:newArray({"spec"}),(function()
return ((self):klassImplementation())
end));
(self):bind_arguments_private_("setProtoOf:to:",smalltalk:newArray({"nativeObject", "proto"}),(function()
return ((self):assign_property_to_("nativeObject","__proto__","proto"))
end));
(self):bind_arguments_private_("bindRoots",smalltalk:newArray({"metaclass"}),(function()
return ((self):bindRootsImplementation())
end));
(self):bind_arguments_private_("setVarNames",smalltalk:newArray({"aClass", "iVarNames", "aValue"}),(function()
return ((self):setVarNamesImplementation())
end));
(self):bind_arguments_private_("setClass",smalltalk:newArray({"aClass", "spec"}),(function()
return ((self):setClassImplementation())
end));
(self):bind_arguments_private_("fnInSpec",smalltalk:newArray({"spec"}),(function()
return ((self):fnInSpecImplementation())
end));
return (self);
end
,"implementations","systemDictionaryPrivates\r\n\t\" Private - Private encoding for SystemDictionary. \"\r\n\r\n\tself bind: #klass arguments: #(spec) private: [\r\n\t\tself klassImplementation\r\n\t].\r\n\tself bind: #setProtoOf:to: arguments: #(nativeObject proto) private: [\r\n\t\tself assign: #nativeObject property: #__proto__ to: #proto\r\n\t].\r\n\tself bind: #bindRoots arguments: #(metaclass) private: [\r\n\t\tself bindRootsImplementation\r\n\t].\r\n\tself bind: #setVarNames arguments: #(aClass iVarNames aValue) private: [\r\n\t\tself setVarNamesImplementation\r\n\t].\r\n\tself bind: #setClass arguments: #(aClass spec) private: [\r\n\t\tself setClassImplementation\r\n\t].\r\n\tself bind: #fnInSpec arguments: #(spec) private: [\r\n\t\tself fnInSpecImplementation\r\n\t].","function(self)\r\n(self):bind_arguments_private_(\"klass\",smalltalk:newArray({\"spec\"}),(function()\r\nreturn ((self):klassImplementation())\r\nend));\r\n(self):bind_arguments_private_(\"setProtoOf:to:\",smalltalk:newArray({\"nativeObject\", \"proto\"}),(function()\r\nreturn ((self):assign_property_to_(\"nativeObject\",\"__proto__\",\"proto\"))\r\nend));\r\n(self):bind_arguments_private_(\"bindRoots\",smalltalk:newArray({\"metaclass\"}),(function()\r\nreturn ((self):bindRootsImplementation())\r\nend));\r\n(self):bind_arguments_private_(\"setVarNames\",smalltalk:newArray({\"aClass\", \"iVarNames\", \"aValue\"}),(function()\r\nreturn ((self):setVarNamesImplementation())\r\nend));\r\n(self):bind_arguments_private_(\"setClass\",smalltalk:newArray({\"aClass\", \"spec\"}),(function()\r\nreturn ((self):setClassImplementation())\r\nend));\r\n(self):bind_arguments_private_(\"fnInSpec\",smalltalk:newArray({\"spec\"}),(function()\r\nreturn ((self):fnInSpecImplementation())\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"klassImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_("aClass");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_("spec.meta",(function()
return ((self):assign_to_("aClass",(function()
return ((self):newInstanceOf_("Metaclass"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):local_with_("metaSpec","{meta:true}");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_property_to_("metaSpec","className","spec.className + \" class\"");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):send_with_("isNil","spec.superclass"))
end)))
end),(function()
return ((self):assign_property_to_("metaSpec","superclass","spec.superclass.$klass"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):local_with_("metaClass",(function()
return ((self):send_with_("klass","metaSpec"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("aClass",(function()
return ((self):call_("new metaClass.$fn"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setClass",smalltalk:newArray({"aClass", "spec"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("aClass.$fn.prototype","klass","aClass");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("aClass.$fn.prototype","methods","{}");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_eqeq_("aClass.$className","\"Metaclass\""))
end),(function()
return ((self):send_with_("bindRoots","aClass"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("aClass");
return (self);
end
,"implementations","klassImplementation\r\n\t\" Private - Implementation of private function klass. \"\r\n\r\n\tself local: #aClass; cr.\r\n\tself if: 'spec.meta'\r\n\t  do: [ self assign: #aClass to: [ self newInstanceOf: #Metaclass ] ]\r\n\t  else: [\r\n\t\tself local: #metaSpec with: '{meta:true}';cr.\r\n\t\tself assign: #metaSpec property: #className to: 'spec.className + \" class\"';cr.\r\n\t\tself\r\n\t\t\tif: [ self not: [ self send: #isNil with: 'spec.superclass'  ] ]\r\n\t\t\tdo: [ self assign: #metaSpec property: #superclass to: 'spec.superclass.$klass' ];cr.\r\n\t\tself local: #metaClass with: [ self send: #klass with: #metaSpec ];cr.\r\n\t\tself assign: #aClass to: [self call: 'new metaClass.$fn'].\r\n\t]; cr.\r\n\tself send: #setClass withArguments: #(aClass spec);cr.\r\n\tself assign: 'aClass.$fn.prototype' pv: #klass to: #aClass;cr.\r\n\tself assign: 'aClass.$fn.prototype' pv: #methods to: '{}';cr.\r\n\tself\tif: [ self expr: 'aClass.$className' eqeq: '\"Metaclass\"' ]\r\n\t\tdo: [ self send: #bindRoots with: #aClass ];cr.\r\n\tself return: #aClass","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_(\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_(\"spec.meta\",(function()\r\nreturn ((self):assign_to_(\"aClass\",(function()\r\nreturn ((self):newInstanceOf_(\"Metaclass\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"metaSpec\",\"{meta:true}\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_property_to_(\"metaSpec\",\"className\",\"spec.className + \\\" class\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_with_(\"isNil\",\"spec.superclass\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_property_to_(\"metaSpec\",\"superclass\",\"spec.superclass.$klass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"metaClass\",(function()\r\nreturn ((self):send_with_(\"klass\",\"metaSpec\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"aClass\",(function()\r\nreturn ((self):call_(\"new metaClass.$fn\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setClass\",smalltalk:newArray({\"aClass\", \"spec\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"aClass.$fn.prototype\",\"klass\",\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"aClass.$fn.prototype\",\"methods\",\"{}\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"aClass.$className\",\"\\\"Metaclass\\\"\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"bindRoots\",\"aClass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"aClass\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"bindRootsImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("objectClassPrototype ","this.Object.$klass.$fn.prototype");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setProtoOf:to:",smalltalk:newArray({"objectClassPrototype", "this.Class.$fn.prototype"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setProtoOf:to:",smalltalk:newArray({"this.Smalltalk.$klass.$fn.prototype", "objectClassPrototype"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setProtoOf:to:",smalltalk:newArray({"this.Behavior.$klass.$fn.prototype", "objectClassPrototype"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("this.Object.$klass.$superclass","this.Class");
	return ((_s8_rec):cr())
end
)(self);
(self):assign_to_("metaclass.$superclass","this.Behavior");
return (self);
end
,"implementations","bindRootsImplementation\r\n\t\" Private - Implementation of private function bindRoots. \"\r\n\r\n\tself local: 'objectClassPrototype ' with: 'this.Object.$klass.$fn.prototype';cr.\r\n\tself send: #setProtoOf:to: withArguments: #(objectClassPrototype 'this.Class.$fn.prototype');cr.\r\n\tself send: #setProtoOf:to: withArguments: #('this.Smalltalk.$klass.$fn.prototype' objectClassPrototype);cr.\r\n\tself send: #setProtoOf:to: withArguments: #('this.Behavior.$klass.$fn.prototype' objectClassPrototype);cr.\r\n\tself assign: 'this.Object.$klass.$superclass' to: 'this.Class';cr.\r\n\tself assign: 'metaclass.$superclass' to: 'this.Behavior'.","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"objectClassPrototype \",\"this.Object.$klass.$fn.prototype\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setProtoOf:to:\",smalltalk:newArray({\"objectClassPrototype\", \"this.Class.$fn.prototype\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setProtoOf:to:\",smalltalk:newArray({\"this.Smalltalk.$klass.$fn.prototype\", \"objectClassPrototype\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setProtoOf:to:\",smalltalk:newArray({\"this.Behavior.$klass.$fn.prototype\", \"objectClassPrototype\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"this.Object.$klass.$superclass\",\"this.Class\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):assign_to_(\"metaclass.$superclass\",\"this.Behavior\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"setVarNamesImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("aClass","iVarNames","iVarNames");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("i","iVarNames.length");
	return ((_s8_rec):cr())
end
)(self);
(self):while_do_("i--",(function()
return ((self):assign_to_("aClass.$fn.prototype[\"@\"+iVarNames[i]]","aValue"))
end));
return (self);
end
,"implementations","setVarNamesImplementation\r\n\t\" Private - Implementation of private function setVarNames. \"\r\n\r\n\tself assign: #aClass pv: #iVarNames to: #iVarNames;cr.\r\n\tself local: #i with: 'iVarNames.length';cr.\r\n\tself while: 'i--' do: [\r\n\t\tself assign: 'aClass.$fn.prototype[\"@\"+iVarNames[i]]' to: #aValue\r\n\t]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"aClass\",\"iVarNames\",\"iVarNames\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"i\",\"iVarNames.length\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):while_do_(\"i--\",(function()\r\nreturn ((self):assign_to_(\"aClass.$fn.prototype[\\\"@\\\"+iVarNames[i]]\",\"aValue\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"setClassImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("aClass","className","spec.className");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_("spec.meta"))
end),(function()
return ((self):assign_to_("aClass.$klass[\"@instanceClass\"]","aClass"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("aClass","category",(function()
return ((self):expr_or_("spec.category","\"\""))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("aClass","superclass",(function()
return ((self):expr_or_("spec.superclass","nil"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):send_with_("isNil","aClass.$superclass"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):delete_("aClass.$superclass[\"@subclasses\"]");
	return ((_s8_rec):cr())
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):send_with_("isNil","aClass.$klass"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_("spec.meta"))
end),(function()
return ((self):assign_pv_to_("aClass.$klass","superclass","aClass.$superclass.$klass"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):if_do_("aClass.$klass.$superclass",(function()
return ((self):delete_("aClass.$klass.$superclass[\"@subclasses\"]"))
end));
	return ((_s8_rec):cr())
end
)(self))
end));
	return ((_s8_rec):cr())
end
)(self))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("aClass","fn",(function()
return ((self):send_with_("fnInSpec","spec"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setVarNames",smalltalk:newArray({"aClass", "spec.iVarNames||[]", "nil"}));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("aClass");
return (self);
end
,"implementations","setClassImplementation\r\n\t\" Private - Implementation of private function setClass. \"\r\n\r\n\tself assign: #aClass pv: #className to: 'spec.className';cr.\r\n\tself if: [self not: 'spec.meta'] do: [ self assign: 'aClass.$klass[\"@instanceClass\"]' to: #aClass ];cr.\r\n\tself assign: #aClass pv: #category to: [ self expr: 'spec.category' or: '\"\"' ];cr.\r\n\tself assign: #aClass pv: #superclass to: [ self expr: 'spec.superclass' or: #nil ];cr.\r\n\tself\tif: [ self not: [self send: #isNil with: 'aClass.$superclass' ]]\r\n\t\tdo: [\tself delete: 'aClass.$superclass[\"@subclasses\"]';cr.\r\n\t\t\tself\tif: [self not: [ self send: #isNil with: 'aClass.$klass' ]]\r\n\t\t\t\tdo: [\r\n\t\t\t\t\tself if: [self not: 'spec.meta'] do: [\r\n\t\t\t\t\t\tself\tassign: 'aClass.$klass'\r\n\t\t\t\t\t\t\tpv: #superclass\r\n\t\t\t\t\t\t\tto: 'aClass.$superclass.$klass'\r\n\t\t\t\t\t];cr.\r\n\t\t\t\t\tself if: 'aClass.$klass.$superclass' do: [\r\n\t\t\t\t\t\tself delete: 'aClass.$klass.$superclass[\"@subclasses\"]'\r\n\t\t\t\t\t];cr\r\n\t\t\t\t];cr\r\n\t\t];cr.\r\n\tself assign: #aClass pv: #fn to: [self send: #fnInSpec with: #spec];cr.\r\n\tself send: #setVarNames withArguments: #(\r\n\t\taClass 'spec.iVarNames||[]' #nil\r\n\t);cr.\r\n\tself return: #aClass","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"aClass\",\"className\",\"spec.className\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_(\"spec.meta\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"aClass.$klass[\\\"@instanceClass\\\"]\",\"aClass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"aClass\",\"category\",(function()\r\nreturn ((self):expr_or_(\"spec.category\",\"\\\"\\\"\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"aClass\",\"superclass\",(function()\r\nreturn ((self):expr_or_(\"spec.superclass\",\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_with_(\"isNil\",\"aClass.$superclass\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):delete_(\"aClass.$superclass[\\\"@subclasses\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_with_(\"isNil\",\"aClass.$klass\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_(\"spec.meta\"))\r\nend),(function()\r\nreturn ((self):assign_pv_to_(\"aClass.$klass\",\"superclass\",\"aClass.$superclass.$klass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"aClass.$klass.$superclass\",(function()\r\nreturn ((self):delete_(\"aClass.$klass.$superclass[\\\"@subclasses\\\"]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"aClass\",\"fn\",(function()\r\nreturn ((self):send_with_(\"fnInSpec\",\"spec\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setVarNames\",smalltalk:newArray({\"aClass\", \"spec.iVarNames||[]\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"aClass\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"fnInSpecImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_and_do_("spec.meta",(function()
return ((self):send_with_("isNil","spec.superclass"))
end),(function()
return ((self):assign_property_to_("spec","superclass","this.Class"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("spec.fn",(function()
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):send_with_("isNil","spec.superclass"))
end)))
end),(function()
return ((self):send_to_withArguments_("setProtoOf:to:","this",smalltalk:newArray({"spec.fn.prototype", "spec.superclass.$fn.prototype"})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("spec.fn"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("$s8Constructor","function(){}");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):send_with_("isNil","spec.superclass"))
end)))
end),(function()
return ((self):assign_property_to_("$s8Constructor","prototype",(function()
return ((self):call_("new spec.superclass.$fn"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("$s8Constructor");
return (self);
end
,"implementations","fnInSpecImplementation\r\n\t\" Private - Implementation of private function fnInSpec. \"\r\n\r\n\tself if: 'spec.meta' and: [self send: #isNil with: 'spec.superclass'] do: [\r\n\t\tself assign: #spec property: #superclass to: 'this.Class'\r\n\t];cr.\r\n\tself if: 'spec.fn' do: [\r\n\t\tself\tif: [self not: [ self send: #isNil with: 'spec.superclass']]\r\n\t\t\tdo: [ self send: #setProtoOf:to: to: #this\r\n\t\t\t\twithArguments: #('spec.fn.prototype' 'spec.superclass.$fn.prototype')\r\n\t\t\t];cr.\r\n\t\tself return: 'spec.fn'\r\n\t];cr.\r\n\tself local: '$s8Constructor' with: 'function(){}';cr.\r\n\tself if: [ self not: [self send: #isNil with: 'spec.superclass' ]] do: [\r\n\t\tself assign: '$s8Constructor' property: #prototype to: [self call: 'new spec.superclass.$fn']\r\n\t];cr.\r\n\tself return: '$s8Constructor' ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_and_do_(\"spec.meta\",(function()\r\nreturn ((self):send_with_(\"isNil\",\"spec.superclass\"))\r\nend),(function()\r\nreturn ((self):assign_property_to_(\"spec\",\"superclass\",\"this.Class\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"spec.fn\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_with_(\"isNil\",\"spec.superclass\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_to_withArguments_(\"setProtoOf:to:\",\"this\",smalltalk:newArray({\"spec.fn.prototype\", \"spec.superclass.$fn.prototype\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"spec.fn\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"$s8Constructor\",\"function(){}\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_with_(\"isNil\",\"spec.superclass\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_property_to_(\"$s8Constructor\",\"prototype\",(function()\r\nreturn ((self):call_(\"new spec.superclass.$fn\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"$s8Constructor\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"classesImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("classes",(self):emptyArray());
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("var i","this",(function()
return ((
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_and_((function()
return ((self):send_with_("hasOwnProperty","i"))
end),(function()
return ((self):expr_noteq_("i","\"$klass\""))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):local_with_("cls","this[i]");
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):not_((function()
return ((self):send_with_("isNil","cls"))
end)))
end),(function()
return ((self):if_do_((function()
return ((self):expr_and_("cls.$klass","cls.$className"))
end),(function()
return ((self):send_to_with_("push","classes","cls"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("classes");
return (self);
end
,"implementations","classesImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself local: #classes with: self emptyArray;cr.\r\n\tself for: 'var i' in: #this do: [\r\n\t\tself if: [self expr: [self send: #hasOwnProperty with: #i]\r\n\t\t\tand: [self expr: #i noteq: '\"$klass\"']] do: [\r\n\t\t\tself local: #cls with: 'this[i]';cr.\r\n\t\t\tself if: [self not: [self send: #isNil with: #cls]] do: [\r\n\t\t\t\tself if: [self expr: 'cls.$klass' and: 'cls.$className'] do: [\r\n\t\t\t\t\tself send: #push to: #classes with: #cls\r\n\t\t\t\t]\r\n\t\t\t]\r\n\t\t];cr.\r\n\t];cr.\r\n\tself return: #classes ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"classes\",(self):emptyArray());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"var i\",\"this\",(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):send_with_(\"hasOwnProperty\",\"i\"))\r\nend),(function()\r\nreturn ((self):expr_noteq_(\"i\",\"\\\"$klass\\\"\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"cls\",\"this[i]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_with_(\"isNil\",\"cls\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):expr_and_(\"cls.$klass\",\"cls.$className\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"push\",\"classes\",\"cls\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"classes\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"subclassesImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):send_to_with_("hasOwnProperty","aClass","\"@subclasses\""))
end),"aClass[\"@subclasses\"]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("classes",(function()
return ((self):send_to_("classes","this"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("i","classes.length");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):while_do_("i--",(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("classes[i][\"@subclasses\"]",(self):emptyArray());
	return ((_s8_rec):cr())
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):assign_to_("classes[i].$klass[\"@subclasses\"]",(self):emptyArray());
	return ((_s8_rec):cr())
end
)(self))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("i","classes.length");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):while_do_("i--",(function()
(
function(_s8_rec)
	(_s8_rec):local_with_("cls","classes[i]");
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):not_((function()
return ((self):send_with_("isNil","cls.$superclass"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):send_to_with_("push","cls.$superclass[\"@subclasses\"]","cls");
	return ((_s8_rec):cr())
end
)(self);return ((self):send_to_with_("push","cls.$superclass.$klass[\"@subclasses\"]","cls.$klass"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("this.Class",(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("this.Class[\"@subclasses\"]","[]");
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("this.$klass[\"@subclasses\"]","[]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("aClass[\"@subclasses\"]");
return (self);
end
,"implementations","subclassesImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself\tif: [self send: #hasOwnProperty to: #aClass with: '\"@subclasses\"']\r\n\t\treturn: 'aClass[\"@subclasses\"]';cr.\r\n\tself local: #classes with: [self send: #classes to: #this];cr.\r\n\tself local: #i with: 'classes.length';cr.\r\n\tself while: 'i--' do: [\r\n\t\tself assign: 'classes[i][\"@subclasses\"]' to: self emptyArray;cr.\r\n\t\tself assign: 'classes[i].$klass[\"@subclasses\"]' to: self emptyArray;cr.\r\n\t];cr.\r\n\tself assign: #i to: 'classes.length';cr.\r\n\tself while: 'i--' do: [\r\n\t\tself local: #cls with: 'classes[i]';cr.\r\n\t\tself if: [self not: [self send: #isNil with: 'cls.$superclass']] do: [\r\n\t\t\tself send: #push to: 'cls.$superclass[\"@subclasses\"]' with: #cls;cr.\r\n\t\t\tself send: #push to: 'cls.$superclass.$klass[\"@subclasses\"]' with: 'cls.$klass'\r\n\t\t].\r\n\t];cr.\r\n\tself if: 'this.Class' do: [\r\n\t\tself assign: 'this.Class[\"@subclasses\"]' to: '[]';cr.\r\n\t\tself assign: 'this.$klass[\"@subclasses\"]' to: '[]'\r\n\t];cr.\r\n\tself return: 'aClass[\"@subclasses\"]'","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):send_to_with_(\"hasOwnProperty\",\"aClass\",\"\\\"@subclasses\\\"\"))\r\nend),\"aClass[\\\"@subclasses\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"classes\",(function()\r\nreturn ((self):send_to_(\"classes\",\"this\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"i\",\"classes.length\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):while_do_(\"i--\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"classes[i][\\\"@subclasses\\\"]\",(self):emptyArray());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"classes[i].$klass[\\\"@subclasses\\\"]\",(self):emptyArray());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"i\",\"classes.length\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):while_do_(\"i--\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"cls\",\"classes[i]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_with_(\"isNil\",\"cls.$superclass\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_with_(\"push\",\"cls.$superclass[\\\"@subclasses\\\"]\",\"cls\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_to_with_(\"push\",\"cls.$superclass.$klass[\\\"@subclasses\\\"]\",\"cls.$klass\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"this.Class\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"this.Class[\\\"@subclasses\\\"]\",\"[]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"this.$klass[\\\"@subclasses\\\"]\",\"[]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"aClass[\\\"@subclasses\\\"]\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"allSubclassesDoImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("subclasses",(function()
return ((self):send_with_("subclasses","aClass"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("i","subclasses.length");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):while_do_("i--",(function()
(
function(_s8_rec)
	(_s8_rec):local_with_("cls","subclasses[i]");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):call_with_("aBlock","cls");
	return ((_s8_rec):cr())
end
)(self);return ((self):send_withArguments_("allSubclassesDo",smalltalk:newArray({"cls", "aBlock"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("this");
return (self);
end
,"implementations","allSubclassesDoImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself local: #subclasses with: [self send: #subclasses with: #aClass];cr.\r\n\tself local: #i with: 'subclasses.length';cr.\r\n\tself while: 'i--' do: [\r\n\t\tself local: #cls with: 'subclasses[i]';cr.\r\n\t\tself call: #aBlock with: #cls;cr.\r\n\t\tself send: #allSubclassesDo withArguments: #(cls aBlock)\r\n\t];cr.\r\n\tself return: #this","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"subclasses\",(function()\r\nreturn ((self):send_with_(\"subclasses\",\"aClass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"i\",\"subclasses.length\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):while_do_(\"i--\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"cls\",\"subclasses[i]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"aBlock\",\"cls\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_withArguments_(\"allSubclassesDo\",smalltalk:newArray({\"cls\", \"aBlock\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"this\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"mapClassNameImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("spec",(function()
return ((self):object_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((("className"):_minus_gt("className")),("category"):_minus_gt("category"))),("superclass"):_minus_gt("superclass"))),("fn"):_minus_gt("fn"))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_("this[className]",(function()
return ((self):send_to_withArguments_("setClass","this",smalltalk:newArray({"this[className]", "spec"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("this[className]",(function()
return ((self):send_with_("klass","spec"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("this[className]");
return (self);
end
,"implementations","mapClassNameImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself local: #spec with: [\r\n\t\tself object: #className -> #className\r\n\t\t\t,(#category -> #category)\r\n\t\t\t,(#superclass -> #superclass)\r\n\t\t\t,(#fn -> #fn)\r\n\t];cr.\r\n\tself if: 'this[className]' return: [\r\n\t\tself\tsend: #setClass to: #this\r\n\t\t\twithArguments: #('this[className]' spec)\r\n\t];cr.\r\n\tself assign: 'this[className]' to: [self send: #klass with: #spec];cr.\r\n\tself return: 'this[className]'","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"spec\",(function()\r\nreturn ((self):object_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((\"className\"):_minus_gt(\"className\")),(\"category\"):_minus_gt(\"category\"))),(\"superclass\"):_minus_gt(\"superclass\"))),(\"fn\"):_minus_gt(\"fn\"))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_(\"this[className]\",(function()\r\nreturn ((self):send_to_withArguments_(\"setClass\",\"this\",smalltalk:newArray({\"this[className]\", \"spec\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"this[className]\",(function()\r\nreturn ((self):send_with_(\"klass\",\"spec\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"this[className]\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"sameIVContentsImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeq_("array1","array2"))
end),"true");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_eqeqeq_("array1.length","array2.length"))
end),(function()
return ((self):return_((function()
return ((self):send_to_with_("every","array1",(function()
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"element", "index"}),(function()
return ((self):return_((function()
return ((self):expr_eqeq_("element","array2[index]"))
end)))
end)))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("false");
return (self);
end
,"implementations","sameIVContentsImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself if: [ self expr: #array1 eqeq: #array2 ] return: #true;cr.\r\n\tself if: [ self expr: 'array1.length' eqeqeq: 'array2.length' ] do: [\r\n\t\tself return: [ self send:  #every to: #array1 with: [\r\n\t\t\tself implementFunction: '' arguments: #(element index) doing: [\r\n\t\t\t\tself return: [self expr: #element eqeq: 'array2[index]']\r\n\t\t\t]]\r\n\t\t]\r\n\t];cr.\r\n\tself return: #false","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"array1\",\"array2\"))\r\nend),\"true\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_eqeqeq_(\"array1.length\",\"array2.length\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_with_(\"every\",\"array1\",(function()\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"element\", \"index\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):expr_eqeq_(\"element\",\"array2[index]\"))\r\nend)))\r\nend)))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"false\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"addClassImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("debugAddClass",smalltalk:newArray({"className", "superclass", "iVarNames", "category"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_("this[className]",(function()
(
function(_s8_rec)
	(_s8_rec):local_with_("aClass","this[className]");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):local_with_("sameShape",(function()
return ((self):expr_and_((function()
return ((self):expr_eqeq_("aClass.$superclass","superclass"))
end),(function()
return ((self):send_to_withArguments_("sameIVContents","this",smalltalk:newArray({"aClass.$iVarNames", "iVarNames"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_and_("sameShape",(function()
return ((self):expr_eqeq_("aClass.$category","category"))
end)))
end),"aClass");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_to_withArguments_("aboutToChangeClass","this",smalltalk:newArray({"aClass", "superclass", "iVarNames", "category"}));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_("aClass.$superclass",(function()
(
function(_s8_rec)
	(_s8_rec):delete_("aClass.$superclass[\"@subclasses\"]");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):local_with_("aMeta","aClass.$klass");
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):expr_and_("aMeta","superclass"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):delete_("aMeta.$superclass[\"@subclasses\"]");
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_pv_to_("aMeta","superclass","superclass.$klass"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("aClass","superclass","superclass");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_and_("superclass","superclass[\"@subclasses\"]"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("isNil","superclass[\"@subclasses\"]"))
end),(function()
return ((self):assign_to_("superclass[\"@subclasses\"]",(self):emptyArray()))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):send_to_with_("push","superclass[\"@subclasses\"]","aClass"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setVarNames",smalltalk:newArray({"aClass", "iVarNames||[]", "nil"}));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("aClass","category",(function()
return ((self):expr_or_("category","aClass.$category"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):not_("sameShape"))
end),(function()
return ((self):send_with_("classShapeChanged","aClass"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("aboutToCreateClass",smalltalk:newArray({"className", "superclass", "iVarNames", "category"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("this[className]",(function()
(
function(_s8_rec)
	(_s8_rec):send_with_("klass",(function()
return ((self):object_(smalltalk:object_comma_((smalltalk:object_comma_((("className"):_minus_gt("className")),("iVarNames"):_minus_gt("iVarNames"))),("superclass"):_minus_gt("superclass"))))
end));
	return ((_s8_rec):cr())
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):assign_pv_to_("this[className]","category",(function()
return ((self):expr_or_("category",(self):emptyString()))
end));
	return ((_s8_rec):cr())
end
)(self))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("classChanged","this[className]");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("this[className]");
return (self);
end
,"implementations","addClassImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself send: #debugAddClass withArguments: #(\r\n\t\tclassName superclass iVarNames category\r\n\t);cr.\r\n\tself if: 'this[className]' do: [\r\n\t\tself local: #aClass with: 'this[className]';cr.\r\n\t\tself local: #sameShape with: [\r\n\t\t\tself expr: [\r\n\t\t\t\tself expr: 'aClass.$superclass' eqeq: #superclass\r\n\t\t\t\t] and: [ self send: #sameIVContents to: #this\r\n\t\t\t\t\twithArguments: #('aClass.$iVarNames' iVarNames)\r\n\t\t\t\t]\r\n\t\t];cr.\r\n\t\tself if: [self expr: #sameShape and: [\r\n\t\t\tself expr: 'aClass.$category' eqeq: #category\r\n\t\t]] return: #aClass;cr.\r\n\t\tself send: #aboutToChangeClass to: #this\r\n\t\t\twithArguments: #(aClass superclass iVarNames category);cr.\r\n\t\tself if: 'aClass.$superclass' do: [\r\n\t\t\tself delete: 'aClass.$superclass[\"@subclasses\"]';cr.\r\n\t\t\tself local: #aMeta with: 'aClass.$klass';cr.\r\n\t\t\tself if: [self expr: #aMeta and: #superclass] do: [\r\n\t\t\t\tself delete: 'aMeta.$superclass[\"@subclasses\"]';cr.\r\n\t\t\t\tself assign: #aMeta pv: #superclass to: 'superclass.$klass'\r\n\t\t\t].\r\n\t\t];cr.\r\n\t\tself assign: #aClass pv: #superclass to: #superclass;cr.\r\n\t\tself if: [self expr: #superclass and: 'superclass[\"@subclasses\"]'] do: [\r\n\t\t\tself if: [self send: #isNil with: 'superclass[\"@subclasses\"]'] do: [\r\n\t\t\t\tself assign: 'superclass[\"@subclasses\"]' to: self emptyArray\r\n\t\t\t];cr.\r\n\t\t\tself send: #push to: 'superclass[\"@subclasses\"]' with: #aClass\r\n\t\t];cr.\r\n\t\tself send: #setVarNames withArguments: #(\r\n\t\t\taClass 'iVarNames||[]' #nil\r\n\t\t);cr.\r\n\t\tself assign: #aClass pv: #category to: [\r\n\t\t\tself expr: #category or: 'aClass.$category'\r\n\t\t];cr.\r\n\t\tself if: [self not: #sameShape] do: [\r\n\t\t\tself send: #classShapeChanged with: #aClass\r\n\t\t].\r\n\t] else: [\r\n\t\tself send: #aboutToCreateClass withArguments: #(\r\n\t\t\tclassName superclass iVarNames category\r\n\t\t);cr.\r\n\t\tself assign: 'this[className]' to: [\r\n\t\t\tself send: #klass with: [\r\n\t\t\t\tself object: #className -> #className\r\n\t\t\t\t\t,(#iVarNames -> #iVarNames)\r\n\t\t\t\t\t,(#superclass -> #superclass)\r\n\t\t\t];cr.\r\n\t\t\tself assign: 'this[className]' pv: #category to: [\r\n\t\t\t\tself expr: #category or: self emptyString\r\n\t\t\t];cr\r\n\t\t]\r\n\t];cr.\r\n\tself send: #classChanged with: 'this[className]';cr.\r\n\tself return: 'this[className]'","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"debugAddClass\",smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_(\"this[className]\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"aClass\",\"this[className]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"sameShape\",(function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):expr_eqeq_(\"aClass.$superclass\",\"superclass\"))\r\nend),(function()\r\nreturn ((self):send_to_withArguments_(\"sameIVContents\",\"this\",smalltalk:newArray({\"aClass.$iVarNames\", \"iVarNames\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_and_(\"sameShape\",(function()\r\nreturn ((self):expr_eqeq_(\"aClass.$category\",\"category\"))\r\nend)))\r\nend),\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_withArguments_(\"aboutToChangeClass\",\"this\",smalltalk:newArray({\"aClass\", \"superclass\", \"iVarNames\", \"category\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"aClass.$superclass\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):delete_(\"aClass.$superclass[\\\"@subclasses\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"aMeta\",\"aClass.$klass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):expr_and_(\"aMeta\",\"superclass\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):delete_(\"aMeta.$superclass[\\\"@subclasses\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_pv_to_(\"aMeta\",\"superclass\",\"superclass.$klass\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"aClass\",\"superclass\",\"superclass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_and_(\"superclass\",\"superclass[\\\"@subclasses\\\"]\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"isNil\",\"superclass[\\\"@subclasses\\\"]\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"superclass[\\\"@subclasses\\\"]\",(self):emptyArray()))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_to_with_(\"push\",\"superclass[\\\"@subclasses\\\"]\",\"aClass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setVarNames\",smalltalk:newArray({\"aClass\", \"iVarNames||[]\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"aClass\",\"category\",(function()\r\nreturn ((self):expr_or_(\"category\",\"aClass.$category\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):not_(\"sameShape\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"classShapeChanged\",\"aClass\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"aboutToCreateClass\",smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"this[className]\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"klass\",(function()\r\nreturn ((self):object_(smalltalk:object_comma_((smalltalk:object_comma_(((\"className\"):_minus_gt(\"className\")),(\"iVarNames\"):_minus_gt(\"iVarNames\"))),(\"superclass\"):_minus_gt(\"superclass\"))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"this[className]\",\"category\",(function()\r\nreturn ((self):expr_or_(\"category\",(self):emptyString()))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"classChanged\",\"this[className]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"this[className]\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"renameClassImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):delete_("this[aClass.$className]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("aClass","className","aString");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("this[aString]","aClass");
	return ((_s8_rec):cr())
end
)(self);
(self):send_with_("classChanged","aClass");
return (self);
end
,"implementations","renameClassImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself delete: 'this[aClass.$className]';cr.\r\n\tself assign: #aClass pv: #className to: #aString;cr.\r\n\tself assign: 'this[aString]' to: #aClass;cr.\r\n\tself send: #classChanged with: #aClass","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):delete_(\"this[aClass.$className]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"aClass\",\"className\",\"aString\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"this[aString]\",\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):send_with_(\"classChanged\",\"aClass\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"removeClassImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("deleted","\"Deleted-\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("aClass.$superclass",(function()
return ((self):delete_("aClass.$superclass[\"@subclasses\"]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):delete_("this[aClass.$className]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("aClass","className","deleted + aClass.$className");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("aClass","klass.$className","deleted + aClass.$klass.$className");
	return ((_s8_rec):cr())
end
)(self);
(self):send_with_("classChanged","aClass");
return (self);
end
,"implementations","removeClassImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself local: #deleted with: '\"Deleted-\"';cr.\r\n\tself if: 'aClass.$superclass' do: [\r\n\t\tself delete: 'aClass.$superclass[\"@subclasses\"]'\r\n\t];cr.\r\n\tself delete: 'this[aClass.$className]';cr.\r\n\tself assign: #aClass pv: #className to: 'deleted + aClass.$className';cr.\r\n\tself assign: #aClass pv: 'klass.$className' to: 'deleted + aClass.$klass.$className';cr.\r\n\tself send: #classChanged with: #aClass","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"deleted\",\"\\\"Deleted-\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"aClass.$superclass\",(function()\r\nreturn ((self):delete_(\"aClass.$superclass[\\\"@subclasses\\\"]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):delete_(\"this[aClass.$className]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"aClass\",\"className\",\"deleted + aClass.$className\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"aClass\",\"klass.$className\",\"deleted + aClass.$klass.$className\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):send_with_(\"classChanged\",\"aClass\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"metaVarNamesImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):send_withArguments_("sameIVContents",smalltalk:newArray({"aMetaClass.$iVarNames", "iVarNames"})))
end),"false");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setVarNames",smalltalk:newArray({"aMetaClass", "iVarNames||[]", "nil"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("classShapeChanged","aMetaClass");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("classChanged","aMetaClass");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("true");
return (self);
end
,"implementations","metaVarNamesImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself if: [self send: #sameIVContents withArguments: #(\r\n\t\t'aMetaClass.$iVarNames' iVarNames\r\n\t\t) ] return: #false;cr.\r\n\tself send: #setVarNames withArguments: #(aMetaClass 'iVarNames||[]' #nil);cr.\r\n\tself send: #classShapeChanged with: #aMetaClass;cr.\r\n\tself send: #classChanged with: #aMetaClass;cr.\r\n\tself return: #true","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):send_withArguments_(\"sameIVContents\",smalltalk:newArray({\"aMetaClass.$iVarNames\", \"iVarNames\"})))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setVarNames\",smalltalk:newArray({\"aMetaClass\", \"iVarNames||[]\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"classShapeChanged\",\"aMetaClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"classChanged\",\"aMetaClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"true\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"smDoImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):not_("this.useManager"))
end),"nil");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):not_("this.SystemManager"))
end),"nil");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):not_("this.SystemManager.currentOrNil"))
end),"nil");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("sm",(function()
return ((self):send_to_("currentOrNil","this.SystemManager"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):not_((function()
return ((self):send_with_("isNil","sm"))
end)))
end),(function()
return ((self):call_with_("block","sm"))
end));
return (self);
end
,"implementations","smDoImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself if: [self not: 'this.useManager'] return: #nil;cr.\r\n\tself if: [self not: 'this.SystemManager'] return: #nil;cr.\r\n\tself if: [self not: 'this.SystemManager.currentOrNil'] return: #nil;cr.\r\n\tself local: #sm with: [ self send: #currentOrNil to: 'this.SystemManager' ];cr.\r\n\tself if: [self not: [self send: #isNil with: #sm]] return: [self call: #block with: #sm].","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):not_(\"this.useManager\"))\r\nend),\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):not_(\"this.SystemManager\"))\r\nend),\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):not_(\"this.SystemManager.currentOrNil\"))\r\nend),\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"sm\",(function()\r\nreturn ((self):send_to_(\"currentOrNil\",\"this.SystemManager\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_with_(\"isNil\",\"sm\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):call_with_(\"block\",\"sm\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"smDo:withArguments:",0
,function(self,selector,array)
(self):send_with_("smDo",(function()
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_withArguments_(selector,"sm",array))
end)))
end));
return (self);
end
,"implementations","smDo: selector withArguments: array\r\n\t\" Private - Encoding for smDo send expression. \"\r\n\r\n\tself send: #smDo with: [\r\n\t\tself implementFunction: '' arguments: #(sm) doing: [\r\n\t\t\tself send: selector to: #sm withArguments: array\r\n\t\t]\r\n\t]","function(self,selector,array)\r\n(self):send_with_(\"smDo\",(function()\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_withArguments_(selector,\"sm\",array))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"classChangedImplementation",0
,function(self)
(self):smDo_withArguments_("classChanged:",smalltalk:newArray({"aBehavior"}));
return (self);
end
,"implementations","classChangedImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself smDo: #classChanged: withArguments: #(aBehavior)","function(self)\r\n(self):smDo_withArguments_(\"classChanged:\",smalltalk:newArray({\"aBehavior\"}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"classShapeChangedImplementation",0
,function(self)
(self):smDo_withArguments_("classShapeChanged:",smalltalk:newArray({"aBehavior"}));
return (self);
end
,"implementations","classShapeChangedImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself smDo: #classShapeChanged: withArguments: #(aBehavior)","function(self)\r\n(self):smDo_withArguments_(\"classShapeChanged:\",smalltalk:newArray({\"aBehavior\"}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"aboutToCreateClassImplementation",0
,function(self)
(self):smDo_withArguments_("aboutToCreateClass:superclass:iVarNames:category:",smalltalk:newArray({"className", "superclass", "iVarNames", "category"}));
return (self);
end
,"implementations","aboutToCreateClassImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself\tsmDo: #aboutToCreateClass:superclass:iVarNames:category:\r\n\t\twithArguments: #(className superclass iVarNames category)","function(self)\r\n(self):smDo_withArguments_(\"aboutToCreateClass:superclass:iVarNames:category:\",smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"aboutToChangeClassImplementation",0
,function(self)
(self):smDo_withArguments_("aboutToChange:superclass:iVarNames:category:",smalltalk:newArray({"aClass", "superclass", "iVarNames", "category"}));
return (self);
end
,"implementations","aboutToChangeClassImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself\tsmDo: #aboutToChange:superclass:iVarNames:category:\r\n\t\twithArguments: #(aClass superclass iVarNames category)","function(self)\r\n(self):smDo_withArguments_(\"aboutToChange:superclass:iVarNames:category:\",smalltalk:newArray({\"aClass\", \"superclass\", \"iVarNames\", \"category\"}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"methodBoundToImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):smDo_withArguments_("methodBound:to:",smalltalk:newArray({"method", "klass"}));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"implementations","methodBoundToImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself\tsmDo: #methodBound:to:\r\n\t\twithArguments: #(method klass);cr.\r\n\tself return: #method","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):smDo_withArguments_(\"methodBound:to:\",smalltalk:newArray({\"method\", \"klass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"aboutToBindToImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):smDo_withArguments_("aboutToBind:to:",smalltalk:newArray({"method", "klass"}));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"implementations","aboutToBindToImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself\tsmDo: #aboutToBind:to:\r\n\t\twithArguments: #(method klass);cr.\r\n\tself return: #method","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):smDo_withArguments_(\"aboutToBind:to:\",smalltalk:newArray({\"method\", \"klass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"aboutToRemoveFromImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):smDo_withArguments_("aboutToRemove:from:",smalltalk:newArray({"method", "klass"}));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"implementations","aboutToRemoveFromImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself\tsmDo: #aboutToRemove:from:\r\n\t\twithArguments: #(method klass);cr.\r\n\tself return: #method","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):smDo_withArguments_(\"aboutToRemove:from:\",smalltalk:newArray({\"method\", \"klass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"methodRemovedFromImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):smDo_withArguments_("methodRemoved:from:",smalltalk:newArray({"method", "klass"}));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"implementations","methodRemovedFromImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself\tsmDo: #methodRemoved:from:\r\n\t\twithArguments: #(method klass);cr.\r\n\tself return: #method","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):smDo_withArguments_(\"methodRemoved:from:\",smalltalk:newArray({\"method\", \"klass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"objectNotFoundImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):smDo_withArguments_("object:at:notFoundIn:",smalltalk:newArray({"object", "indexOrKey", "collection"}));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("collection");
return (self);
end
,"implementations","objectNotFoundImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself\tsmDo: #object:at:notFoundIn:\r\n\t\twithArguments: #(object indexOrKey collection);cr.\r\n\tself return: #collection","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):smDo_withArguments_(\"object:at:notFoundIn:\",smalltalk:newArray({\"object\", \"indexOrKey\", \"collection\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"collection\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"whoImplementsImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("cls","klass");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):do_while_((function()
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):send_to_with_("hasOwnProperty","cls.$fn.prototype","jsSelector"))
end),"cls");
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("cls","cls.$superclass"))
end),"cls");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("nil");
return (self);
end
,"implementations","whoImplementsImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself local: #cls with: #klass;cr.\r\n\tself do: [\r\n\t\tself if: [self send: #hasOwnProperty to: 'cls.$fn.prototype' with: #jsSelector] return: #cls;cr.\r\n\t\tself assign: #cls to: 'cls.$superclass'\r\n\t] while: #cls;cr.\r\n\tself return: #nil ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"cls\",\"klass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):do_while_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):send_to_with_(\"hasOwnProperty\",\"cls.$fn.prototype\",\"jsSelector\"))\r\nend),\"cls\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"cls\",\"cls.$superclass\"))\r\nend),\"cls\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"nil\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"superImplementorImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_or_((function()
return ((self):send_with_("isNil","klass.$superclass"))
end),(function()
return ((self):send_with_("isNil","klass.$superclass.$fn"))
end)))
end),(function()
return ((self):send_to_with_("missingImplementorFor:","klass","jsSelector"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("cls",(function()
return ((self):send_to_withArguments_("whoImplements","this",smalltalk:newArray({"klass.$superclass", "jsSelector"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):send_with_("isNil","cls"))
end),(function()
return ((self):send_to_with_("missingImplementorFor:","klass.$superclass","jsSelector"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("cls.$fn.prototype[jsSelector]");
return (self);
end
,"implementations","superImplementorImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself \tif: [self expr: [self send: #isNil with: 'klass.$superclass']\r\n\t\tor: [self send: #isNil with: 'klass.$superclass.$fn']]\r\n\t\treturn: [self send: #missingImplementorFor: to: #klass with: #jsSelector];cr.\r\n\tself local: #cls with: [\r\n\t\tself send: #whoImplements to: #this\r\n\t\t\twithArguments: #('klass.$superclass' jsSelector)\r\n\t];cr.\r\n\tself\tif: [self send: #isNil with: #cls]\r\n\t\treturn: [self send: #missingImplementorFor: to: 'klass.$superclass' with: #jsSelector];cr.\r\n\tself return: 'cls.$fn.prototype[jsSelector]'","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):send_with_(\"isNil\",\"klass.$superclass\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"isNil\",\"klass.$superclass.$fn\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"missingImplementorFor:\",\"klass\",\"jsSelector\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"cls\",(function()\r\nreturn ((self):send_to_withArguments_(\"whoImplements\",\"this\",smalltalk:newArray({\"klass.$superclass\", \"jsSelector\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):send_with_(\"isNil\",\"cls\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"missingImplementorFor:\",\"klass.$superclass\",\"jsSelector\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"cls.$fn.prototype[jsSelector]\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"addMethodImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("aboutToBindTo",smalltalk:newArray({"method", "klass"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("klass.$fn.prototype[jsSelector]","method.$fn");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("klass.$fn.prototype.$methods[method.$selector]","method");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("method[\"@classField\"]","klass");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_withArguments_("methodBoundTo",smalltalk:newArray({"method", "klass"})))
end));
return (self);
end
,"implementations","addMethodImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself send: #aboutToBindTo withArguments: #(method klass);cr.\r\n\tself assign: 'klass.$fn.prototype[jsSelector]' to: 'method.$fn';cr.\r\n\tself assign: 'klass.$fn.prototype.$methods[method.$selector]' to: #method;cr.\r\n\tself assign: 'method[\"@classField\"]' to: #klass;cr.\r\n\tself return: [self send: #methodBoundTo withArguments: #(method klass)]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"aboutToBindTo\",smalltalk:newArray({\"method\", \"klass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"klass.$fn.prototype[jsSelector]\",\"method.$fn\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"klass.$fn.prototype.$methods[method.$selector]\",\"method\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"method[\\\"@classField\\\"]\",\"klass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"methodBoundTo\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"bindImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("debugBind",smalltalk:newArray({"klass", "stSelector", "jsSelector", "jsFunction", "category", "stSource", "stamp"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):define_asInstanceOf_("method","Method");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("method","selector","stSelector");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("method","fn","jsFunction");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("method","category","category");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("method","source","stSource");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):send_with_("isNil","stamp"))
end)))
end),(function()
return ((self):assign_pv_to_("method","stamp","stamp"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("method","generation","this.$state");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):send_with_("isNil","klass"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("isNil","jsSelector"))
end),(function()
return ((self):assign_to_("jsSelector",(function()
return ((self):send_to_with_("replace","stSelector","/\\:/g,\"_\""))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):send_withArguments_("addMethod",smalltalk:newArray({"jsSelector", "method", "klass"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"implementations","bindImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself send: #debugBind withArguments: #(\r\n\t\tklass stSelector jsSelector jsFunction category stSource stamp\r\n\t);cr.\r\n\tself define: #method asInstanceOf: #Method;cr.\r\n\tself assign: #method pv: #selector to: #stSelector;cr.\r\n\tself assign: #method pv: #fn to: #jsFunction;cr.\r\n\tself assign: #method pv: #category to: #category;cr.\r\n\tself assign: #method pv: #source to: #stSource;cr.\r\n\tself if: [self not: [self send: #isNil with: #stamp]] do: [\r\n\t\tself assign: #method pv: #stamp to: #stamp\r\n\t];cr.\r\n\tself assign: #method pv: #generation to: 'this.$state';cr.\r\n\tself if: [self not: [self send: #isNil with: #klass]] do: [\r\n\tself if: [self send: #isNil with: #jsSelector] do: [\r\n\t\tself assign: #jsSelector to: [\r\n\t\t\tself send: #replace to: #stSelector with: '/\\:/g,\"_\"'\r\n\t\t]\r\n\t];cr.\r\n\tself send: #addMethod withArguments: #(jsSelector method klass)\r\n\t];cr.\r\n\tself return: #method","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"debugBind\",smalltalk:newArray({\"klass\", \"stSelector\", \"jsSelector\", \"jsFunction\", \"category\", \"stSource\", \"stamp\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):define_asInstanceOf_(\"method\",\"Method\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"method\",\"selector\",\"stSelector\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"method\",\"fn\",\"jsFunction\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"method\",\"category\",\"category\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"method\",\"source\",\"stSource\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_with_(\"isNil\",\"stamp\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_pv_to_(\"method\",\"stamp\",\"stamp\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"method\",\"generation\",\"this.$state\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_with_(\"isNil\",\"klass\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"isNil\",\"jsSelector\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"jsSelector\",(function()\r\nreturn ((self):send_to_with_(\"replace\",\"stSelector\",\"/\\\\:/g,\\\"_\\\"\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_withArguments_(\"addMethod\",smalltalk:newArray({\"jsSelector\", \"method\", \"klass\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"removeMethodImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("aboutToRemoveFrom",smalltalk:newArray({"aMethod", "aClass"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):delete_("aClass.$fn.prototype[aMethod.$selector.asSelector()]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):delete_("aClass.$fn.prototype.$methods[aMethod.$selector]");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_withArguments_("methodRemovedFrom","this",smalltalk:newArray({"aMethod", "aClass"})))
end));
return (self);
end
,"implementations","removeMethodImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself send: #aboutToRemoveFrom withArguments: #(aMethod aClass);cr.\r\n\tself delete: 'aClass.$fn.prototype[aMethod.$selector.asSelector()]';cr.\r\n\tself delete: 'aClass.$fn.prototype.$methods[aMethod.$selector]';cr.\r\n\tself return: [ self\tsend: #methodRemovedFrom to: #this\r\n\t\t\twithArguments: #(aMethod aClass)\r\n\t]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"aboutToRemoveFrom\",smalltalk:newArray({\"aMethod\", \"aClass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):delete_(\"aClass.$fn.prototype[aMethod.$selector.asSelector()]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):delete_(\"aClass.$fn.prototype.$methods[aMethod.$selector]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_withArguments_(\"methodRemovedFrom\",\"this\",smalltalk:newArray({\"aMethod\", \"aClass\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"newMethodImplementation",0
,function(self)
(self):return_((function()
return ((self):send_to_withArguments_("bind","this",smalltalk:newArray({"nil", "selector", "nil", "fn", "nil", "source", "nil"})))
end));
return (self);
end
,"implementations","newMethodImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself return: [ self\tsend: #bind to: #this\r\n\t\t\twithArguments: #(#nil selector #nil fn #nil source #nil)\r\n\t]","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_to_withArguments_(\"bind\",\"this\",smalltalk:newArray({\"nil\", \"selector\", \"nil\", \"fn\", \"nil\", \"source\", \"nil\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"methodImplementation",0
,function(self)
(self):return_((function()
return ((self):send_to_withArguments_("bind","this",smalltalk:newArray({"nil", "spec.selector", "nil", "spec.fn", "spec.category", "spec.source", "spec.stamp"})))
end));
return (self);
end
,"implementations","methodImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself return: [ self\tsend: #bind to: #this\r\n\t\t\twithArguments: #(#nil 'spec.selector'\r\n\t\t\t\t#nil 'spec.fn' 'spec.category'\r\n\t\t\t\t'spec.source' 'spec.stamp')\r\n\t]","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_to_withArguments_(\"bind\",\"this\",smalltalk:newArray({\"nil\", \"spec.selector\", \"nil\", \"spec.fn\", \"spec.category\", \"spec.source\", \"spec.stamp\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"readJSObjectImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):not_("js"))
end),"nil");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("object","js");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("readObject",(function()
return ((self):expr_eqeqeq_("js.constructor","Object"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("readArray",(function()
return ((self):expr_eqeqeq_("js.constructor","Array"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("readObject",(function()
return ((self):assign_to_("object",(function()
return ((self):call_("this.PoolDictionary.$$new"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("var i","js",(function()
(self):if_((function()
return ((self):not_((function()
return ((self):send_to_with_("hasOwnProperty","js","i"))
end)))
end));(
function(_s8_rec)
	(_s8_rec):__break();
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_("readObject",(function()
return ((self):send_to_withArguments_("at:put:","object",(smalltalk.Array):with_with_("i",(function()
return ((self):send_with_("readJSObject","js[i]"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_("readArray",(function()
return ((self):assign_to_("object[i]",(function()
return ((self):send_with_("readJSObject","js[i]"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("object");
return (self);
end
,"implementations","readJSObjectImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself if: [self not: #js] return: #nil;cr.\r\n\tself local: #object with: #js;cr.\r\n\tself local: #readObject with: [self expr: 'js.constructor' eqeqeq: #Object];cr.\r\n\tself local: #readArray with: [self expr: 'js.constructor' eqeqeq: #Array];cr.\r\n\tself if: #readObject do: [\r\n\t\tself assign: #object to: [self call: 'this.PoolDictionary.$$new']\r\n\t];cr.\r\n\tself for: 'var i' in: #js do: [\r\n\t\tself if: [self not: [self send: #hasOwnProperty to: #js with: #i]].\r\n\t\tself break;cr.\r\n\t\tself if: #readObject do: [\r\n\t\t\tself send: #at:put: to: #object withArguments: (Array with: #i with: [\r\n\t\t\t\tself send: #readJSObject with: 'js[i]'\r\n\t\t\t])\r\n\t\t];cr.\r\n\t\tself if: #readArray do: [\r\n\t\t\tself assign: 'object[i]' to: [\r\n\t\t\t\tself send: #readJSObject with: 'js[i]'\r\n\t\t\t]\r\n\t\t].\r\n\t];cr.\r\n\tself return: #object","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):not_(\"js\"))\r\nend),\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"object\",\"js\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"readObject\",(function()\r\nreturn ((self):expr_eqeqeq_(\"js.constructor\",\"Object\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"readArray\",(function()\r\nreturn ((self):expr_eqeqeq_(\"js.constructor\",\"Array\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"readObject\",(function()\r\nreturn ((self):assign_to_(\"object\",(function()\r\nreturn ((self):call_(\"this.PoolDictionary.$$new\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"var i\",\"js\",(function()\r\n(self):if_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_to_with_(\"hasOwnProperty\",\"js\",\"i\"))\r\nend)))\r\nend));(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):__break();\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"readObject\",(function()\r\nreturn ((self):send_to_withArguments_(\"at:put:\",\"object\",(smalltalk.Array):with_with_(\"i\",(function()\r\nreturn ((self):send_with_(\"readJSObject\",\"js[i]\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_(\"readArray\",(function()\r\nreturn ((self):assign_to_(\"object[i]\",(function()\r\nreturn ((self):send_with_(\"readJSObject\",\"js[i]\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"object\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"globalsDoImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):for_in_do_("key","this",(function()
(
function(_s8_rec)
	(_s8_rec):if_((function()
return ((self):not_((function()
return ((self):send_with_("hasOwnProperty","key"))
end)))
end));
	(_s8_rec):__break();
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):local_with_("aValue","this[key]");
	return ((_s8_rec):cr())
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_and_((function()
return ((self):typeOf_isNot_("aValue","function"))
end),(function()
return ((self):expr_and_("aValue.isClass",(function()
return ((self):not_((function()
return ((self):send_to_("isClass","aValue"))
end)))
end)))
end)))
end),(function()
return ((self):call_with_("action","key"))
end));
	return ((_s8_rec):cr())
end
)(self))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("this");
return (self);
end
,"implementations","globalsDoImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself for: #key in: #this do: [\r\n\t\tself if: [self not: [self send: #hasOwnProperty with: #key]];break;cr.\r\n\t\tself local: #aValue with: 'this[key]';cr.\r\n\t\tself if: [\tself expr: [self typeOf: #aValue isNot: #function] and: [\r\n\t\t\tself expr: 'aValue.isClass' and: [\r\n\t\t\tself not: [self send: #isClass to: #aValue]]]\r\n\t\t] do: [ self call: #action with: #key ];cr.\r\n\t];cr.\r\n\tself return: #this","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"key\",\"this\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_with_(\"hasOwnProperty\",\"key\"))\r\nend)))\r\nend));\r\n\t(_s8_rec):__break();\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"aValue\",\"this[key]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):typeOf_isNot_(\"aValue\",\"function\"))\r\nend),(function()\r\nreturn ((self):expr_and_(\"aValue.isClass\",(function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_to_(\"isClass\",\"aValue\"))\r\nend)))\r\nend)))\r\nend)))\r\nend),(function()\r\nreturn ((self):call_with_(\"action\",\"key\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"this\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"mapClassName:",0
,function(self,args)
(self):send_withArguments_("mapClassName",args);
return (self);
end
,"asm","mapClassName: args\r\n\t\" Private - Encoding for mapClassName expression. \"\r\n\r\n\tself send: #mapClassName withArguments: args","function(self,args)\r\n(self):send_withArguments_(\"mapClassName\",args);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"startupImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("this","state","\"booting\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("this.OverwriteMethods",(function()
return ((self):expr_or_("this.OverwriteMethods","true"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("this.DumpOverwritenMethods",(function()
return ((self):expr_or_("this.DumpOverwritenMethods","false"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"Object\"", "\"Kernel\"", "StObject"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"Smalltalk\"", "\"Kernel\"", "StSystemDictionary", "this.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"Behavior\"", "\"Kernel\"", "StBehavior", "this.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"Class\"", "\"Kernel\"", "StClass", "this.Behavior"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"Metaclass\"", "\"Kernel\"", "StMetaclass", "this.Behavior"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"CompiledMethod\"", "\"Kernel\"", "StMethod", "this.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"Number\"", "\"Kernel\"", "Number", "this.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"BlockClosure\"", "\"Kernel\"", "Function", "this.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"Boolean\"", "\"Kernel\"", "Boolean", "this.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"DateTime\"", "\"Kernel\"", "Date", "this.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"UndefinedObject\"", "\"Kernel\"", "StUndefinedObject", "this.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"Collection\"", "\"Kernel\"", "undefined", "this.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"SequenceableCollection\"", "\"Kernel\"", "undefined", "this.Collection"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"String\"", "\"Kernel\"", "String", "this.SequenceableCollection"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"Array\"", "\"Kernel\"", "Array", "this.SequenceableCollection"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):mapClassName_(smalltalk:newArray({"\"RegularExpression\"", "\"Kernel\"", "RegExp", "this.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("this","state","\"startup\"");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("this");
return (self);
end
,"implementations","startupImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself assign: #this pv: #state to: '\"booting\"';cr.\r\n\tself assign: 'this.OverwriteMethods' to: [\r\n\t\tself expr: 'this.OverwriteMethods' or: #true\r\n\t];cr.\r\n\tself assign: 'this.DumpOverwritenMethods' to: [\r\n\t\tself expr: 'this.DumpOverwritenMethods' or: #false\r\n\t];cr.\r\n\tself mapClassName: #('\"Object\"' '\"Kernel\"' StObject);cr.\r\n\tself mapClassName: #('\"Smalltalk\"' '\"Kernel\"' StSystemDictionary 'this.Object');cr.\r\n\tself mapClassName: #('\"Behavior\"' '\"Kernel\"' StBehavior 'this.Object');cr.\r\n\tself mapClassName: #('\"Class\"' '\"Kernel\"' StClass 'this.Behavior');cr.\r\n\tself mapClassName: #('\"Metaclass\"' '\"Kernel\"' StMetaclass 'this.Behavior');cr.\r\n\tself mapClassName: #('\"CompiledMethod\"' '\"Kernel\"' StMethod 'this.Object');cr.\r\n\tself mapClassName: #('\"Number\"' '\"Kernel\"' Number 'this.Object');cr.\r\n\tself mapClassName: #('\"BlockClosure\"' '\"Kernel\"' Function 'this.Object');cr.\r\n\tself mapClassName: #('\"Boolean\"' '\"Kernel\"' Boolean 'this.Object');cr.\r\n\tself mapClassName: #('\"DateTime\"' '\"Kernel\"' Date 'this.Object');cr.\r\n\tself mapClassName: #('\"UndefinedObject\"' '\"Kernel\"' StUndefinedObject 'this.Object');cr.\r\n\tself mapClassName: #('\"Collection\"' '\"Kernel\"' undefined 'this.Object');cr.\r\n\tself mapClassName: #('\"SequenceableCollection\"' '\"Kernel\"' undefined 'this.Collection');cr.\r\n\tself mapClassName: #('\"String\"' '\"Kernel\"' String 'this.SequenceableCollection');cr.\r\n\tself mapClassName: #('\"Array\"' '\"Kernel\"' Array 'this.SequenceableCollection');cr.\r\n\tself mapClassName: #('\"RegularExpression\"' '\"Kernel\"' RegExp 'this.Object');cr.\r\n\tself assign: #this pv: #state to: '\"startup\"';cr.\r\n\tself return: #this","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"this\",\"state\",\"\\\"booting\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"this.OverwriteMethods\",(function()\r\nreturn ((self):expr_or_(\"this.OverwriteMethods\",\"true\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"this.DumpOverwritenMethods\",(function()\r\nreturn ((self):expr_or_(\"this.DumpOverwritenMethods\",\"false\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"Object\\\"\", \"\\\"Kernel\\\"\", \"StObject\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"Smalltalk\\\"\", \"\\\"Kernel\\\"\", \"StSystemDictionary\", \"this.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"Behavior\\\"\", \"\\\"Kernel\\\"\", \"StBehavior\", \"this.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"Class\\\"\", \"\\\"Kernel\\\"\", \"StClass\", \"this.Behavior\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"Metaclass\\\"\", \"\\\"Kernel\\\"\", \"StMetaclass\", \"this.Behavior\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"CompiledMethod\\\"\", \"\\\"Kernel\\\"\", \"StMethod\", \"this.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"Number\\\"\", \"\\\"Kernel\\\"\", \"Number\", \"this.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"BlockClosure\\\"\", \"\\\"Kernel\\\"\", \"Function\", \"this.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"Boolean\\\"\", \"\\\"Kernel\\\"\", \"Boolean\", \"this.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"DateTime\\\"\", \"\\\"Kernel\\\"\", \"Date\", \"this.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"UndefinedObject\\\"\", \"\\\"Kernel\\\"\", \"StUndefinedObject\", \"this.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"Collection\\\"\", \"\\\"Kernel\\\"\", \"undefined\", \"this.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"SequenceableCollection\\\"\", \"\\\"Kernel\\\"\", \"undefined\", \"this.Collection\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"String\\\"\", \"\\\"Kernel\\\"\", \"String\", \"this.SequenceableCollection\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"Array\\\"\", \"\\\"Kernel\\\"\", \"Array\", \"this.SequenceableCollection\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):mapClassName_(smalltalk:newArray({\"\\\"RegularExpression\\\"\", \"\\\"Kernel\\\"\", \"RegExp\", \"this.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"this\",\"state\",\"\\\"startup\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"this\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"launchImageImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_property_to_("this","useManager","true");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):send_with_("isNil","imageName"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("this","imageFileName","imageName");
	return ((_s8_rec):cr())
end
)(self);return ((self):call_with_("load","imageName"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("this","state","\"launching\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_and_("this.launch",(function()
return ((self):typeOf_is_("this.launch","function"))
end)))
end),(function()
return ((self):send_to_("launch","this"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("this","state","\"running\"");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("this");
return (self);
end
,"implementations","launchImageImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself assign: #this property: #useManager to: #true;cr.\r\n\tself if: [self not: [self send: #isNil with: #imageName]] do: [\r\n\t\tself assign: #this pv: #imageFileName to: #imageName;cr.\r\n\t\tself call: #load with: #imageName\r\n\t];cr.\r\n\tself assign: #this pv: #state to: '\"launching\"';cr.\r\n\tself if: [self expr: 'this.launch'\r\n\t\tand: [self typeOf: 'this.launch' is: #function]] do: [\r\n\t\tself send: #launch to: #this\r\n\t];cr.\r\n\tself assign: #this pv: #state to: '\"running\"';cr.\r\n\tself return: #this","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_property_to_(\"this\",\"useManager\",\"true\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_with_(\"isNil\",\"imageName\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"this\",\"imageFileName\",\"imageName\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):call_with_(\"load\",\"imageName\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"this\",\"state\",\"\\\"launching\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_and_(\"this.launch\",(function()\r\nreturn ((self):typeOf_is_(\"this.launch\",\"function\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_to_(\"launch\",\"this\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"this\",\"state\",\"\\\"running\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"this\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"is_kindOf_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_and_((function()
return ((self):send_to_with_("isNil:","nil","anObject"))
end),(function()
return ((self):expr_noteqeq_("nil","anObject"))
end)))
end),"false");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_is_("anObject.isKindOf_","undefined"))
end),"false");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_with_("isKindOf:","anObject","aClass"))
end));
return (self);
end
,"implementations","is_kindOf_Implementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself if: [self expr: [self\r\n\t\tsend:#isNil: to: #nil with: #anObject\r\n\t\t] and: [self expr: #nil noteqeq: #anObject]] return: #false;cr.\r\n\tself\tif: [self typeOf: 'anObject.isKindOf_' is: #undefined]\r\n\t\treturn: #false;cr.\r\n\tself return: [ self send: #isKindOf: to: #anObject with: #aClass ]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):send_to_with_(\"isNil:\",\"nil\",\"anObject\"))\r\nend),(function()\r\nreturn ((self):expr_noteqeq_(\"nil\",\"anObject\"))\r\nend)))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_is_(\"anObject.isKindOf_\",\"undefined\"))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"isKindOf:\",\"anObject\",\"aClass\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"responds_to_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_and_((function()
return ((self):send_to_with_("isNil:","nil","anObject"))
end),(function()
return ((self):expr_noteqeq_("nil","anObject"))
end)))
end),"false");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_is_("anObject.respondsTo_","undefined"))
end),"false");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_with_("respondsTo:","anObject","aSelector"))
end));
return (self);
end
,"implementations","responds_to_Implementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself if: [self expr: [self\r\n\t\tsend:#isNil: to: #nil with: #anObject\r\n\t\t] and: [self expr: #nil noteqeq: #anObject]] return: #false;cr.\r\n\tself\tif: [self typeOf: 'anObject.respondsTo_' is: #undefined]\r\n\t\treturn: #false;cr.\r\n\tself return: [ self send: #respondsTo: to: #anObject with: #aSelector ]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):send_to_with_(\"isNil:\",\"nil\",\"anObject\"))\r\nend),(function()\r\nreturn ((self):expr_noteqeq_(\"nil\",\"anObject\"))\r\nend)))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_is_(\"anObject.respondsTo_\",\"undefined\"))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"respondsTo:\",\"anObject\",\"aSelector\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"debugBindImplementation",0
,function(self)
(self):return_("this");
return (self);
end
,"implementations","debugBindImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself return: #this","function(self)\r\n(self):return_(\"this\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"debugAddClassImplementation",0
,function(self)
(self):return_("this");
return (self);
end
,"implementations","debugAddClassImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself return: #this","function(self)\r\n(self):return_(\"this\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"initWithSubclassesImplementation",0
,function(self)
(self):return_("aClass");
return (self);
end
,"implementations","initWithSubclassesImplementation\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\tself return: #aClass","function(self)\r\n(self):return_(\"aClass\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"systemDictionaryAPI",0
,function(self)
(smalltalk:newArray({"classes", smalltalk:newArray({"subclasses", smalltalk:newArray({"aClass"})}), smalltalk:newArray({"allSubclassesDo", smalltalk:newArray({"aClass", "aBlock"})}), smalltalk:newArray({"mapClassName", smalltalk:newArray({"className", "category", "fn", "superclass"})}), smalltalk:newArray({"sameIVContents", smalltalk:newArray({"array1", "array2"})}), smalltalk:newArray({"addClass", smalltalk:newArray({"className", "superclass", "iVarNames", "category"})}), smalltalk:newArray({"renameClass", smalltalk:newArray({"aClass", "aString"})}), smalltalk:newArray({"removeClass", smalltalk:newArray({"aClass"})}), smalltalk:newArray({"metaVarNames", smalltalk:newArray({"aMetaClass", "iVarNames"})}), smalltalk:newArray({"smDo", smalltalk:newArray({"block"})}), smalltalk:newArray({"classChanged", smalltalk:newArray({"aBehavior"})}), smalltalk:newArray({"classShapeChanged", smalltalk:newArray({"aBehavior"})}), smalltalk:newArray({"aboutToCreateClass", smalltalk:newArray({"className", "superclass", "iVarNames", "category"})}), smalltalk:newArray({"aboutToChangeClass", smalltalk:newArray({"aClass", "superclass", "iVarNames", "category"})}), smalltalk:newArray({"methodBoundTo", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"aboutToBindTo", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"aboutToRemoveFrom", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"methodRemovedFrom", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"objectNotFound", smalltalk:newArray({"object", "indexOrKey", "collection"})}), smalltalk:newArray({"whoImplements", smalltalk:newArray({"klass", "jsSelector"})}), smalltalk:newArray({"superImplementor", smalltalk:newArray({"klass", "jsSelector"})}), smalltalk:newArray({"addMethod", smalltalk:newArray({"jsSelector", "method", "klass"})}), smalltalk:newArray({"bind", smalltalk:newArray({"klass", "stSelector", "jsSelector", "jsFunction", "category", "stSource", "stamp"})}), smalltalk:newArray({"removeMethod", smalltalk:newArray({"aClass", "aMethod"})}), smalltalk:newArray({"newMethod", smalltalk:newArray({"currentClass", "selector", "fn", "source"})}), smalltalk:newArray({"readJSObject", smalltalk:newArray({"js"})}), smalltalk:newArray({"globalsDo", smalltalk:newArray({"action"})}), smalltalk:newArray({"startup", smalltalk:newArray({})}), smalltalk:newArray({"launchImage", smalltalk:newArray({"imageName"})}), smalltalk:newArray({"is:kindOf:", smalltalk:newArray({"anObject", "aClass"})}), smalltalk:newArray({"responds:to:", smalltalk:newArray({"anObject", "aSelector"})}), smalltalk:newArray({"debugBind", smalltalk:newArray({"klass", "stSelector", "jsSelector", "jsFunction", "category", "stSource", "stamp"})}), smalltalk:newArray({"debugAddClass", smalltalk:newArray({"className", "superclass", "iVarNames", "category"})}), smalltalk:newArray({"initWithSubclasses", smalltalk:newArray({"aClass"})})})):do_((function(tuple)
return ((self):bindAPI_(tuple))
end));
return (self);
end
,"implementations","systemDictionaryAPI\r\n\t\" Private - Internal encoding for basic SystemDictionary messages. \"\r\n\r\n\t#(\t#classes\r\n\t\t#(subclasses #(aClass))\r\n\t\t#(allSubclassesDo #(aClass aBlock))\r\n\t\t#(mapClassName #(className category fn superclass))\r\n\t\t#(sameIVContents #(array1 array2))\r\n\t\t#(addClass #(className superclass iVarNames category))\r\n\t\t#(renameClass #(aClass aString))\r\n\t\t#(removeClass #(aClass))\r\n\t\t#(metaVarNames #(aMetaClass iVarNames))\r\n\t\"Private\"\t#(smDo #(block))\r\n\t\"Private\"\t#(classChanged #(aBehavior))\r\n\t\"Private\"\t#(classShapeChanged #(aBehavior))\r\n\t\"Private\"\t#(aboutToCreateClass #(className superclass iVarNames category))\r\n\t\"Private\"\t#(aboutToChangeClass #(aClass superclass iVarNames category))\r\n\t\"Private\"\t#(methodBoundTo #(method klass))\r\n\t\"Private\"\t#(aboutToBindTo #(method klass))\r\n\t\"Private\"\t#(aboutToRemoveFrom #(method klass))\r\n\t\"Private\"\t#(methodRemovedFrom #(method klass))\r\n\t\"Private\"\t#(objectNotFound #(object indexOrKey collection))\r\n\t\t#(whoImplements #(klass jsSelector))\r\n\t\t#(superImplementor #(klass jsSelector))\r\n\t\t#(addMethod #(jsSelector method klass))\r\n\t\t#(bind #(klass stSelector jsSelector jsFunction category stSource stamp))\r\n\t\t#(removeMethod #(aClass aMethod))\r\n\t\t#(newMethod #(currentClass selector fn source))\r\n\"OBSOLETE\t#(method #(spec))\"\r\n\t\"js\"\t#(readJSObject #(js))\r\n\t\t#(globalsDo #(action))\r\n\t\t#(startup #())\r\n\t\t#(launchImage #(imageName))\r\n\t\t#(is:kindOf: #(anObject aClass))\r\n\t\t#(responds:to: #(anObject aSelector))\r\n\t\"DEBUG\"\t#(debugBind #(klass stSelector jsSelector jsFunction category stSource stamp))\r\n\t\"DEBUG\"\t#(debugAddClass #(className superclass iVarNames category))\r\n\t\t#(initWithSubclasses #(aClass))\r\n\t) do: [:tuple| self bindAPI: tuple ]","function(self)\r\n(smalltalk:newArray({\"classes\", smalltalk:newArray({\"subclasses\", smalltalk:newArray({\"aClass\"})}), smalltalk:newArray({\"allSubclassesDo\", smalltalk:newArray({\"aClass\", \"aBlock\"})}), smalltalk:newArray({\"mapClassName\", smalltalk:newArray({\"className\", \"category\", \"fn\", \"superclass\"})}), smalltalk:newArray({\"sameIVContents\", smalltalk:newArray({\"array1\", \"array2\"})}), smalltalk:newArray({\"addClass\", smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"})}), smalltalk:newArray({\"renameClass\", smalltalk:newArray({\"aClass\", \"aString\"})}), smalltalk:newArray({\"removeClass\", smalltalk:newArray({\"aClass\"})}), smalltalk:newArray({\"metaVarNames\", smalltalk:newArray({\"aMetaClass\", \"iVarNames\"})}), smalltalk:newArray({\"smDo\", smalltalk:newArray({\"block\"})}), smalltalk:newArray({\"classChanged\", smalltalk:newArray({\"aBehavior\"})}), smalltalk:newArray({\"classShapeChanged\", smalltalk:newArray({\"aBehavior\"})}), smalltalk:newArray({\"aboutToCreateClass\", smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"})}), smalltalk:newArray({\"aboutToChangeClass\", smalltalk:newArray({\"aClass\", \"superclass\", \"iVarNames\", \"category\"})}), smalltalk:newArray({\"methodBoundTo\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"aboutToBindTo\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"aboutToRemoveFrom\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"methodRemovedFrom\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"objectNotFound\", smalltalk:newArray({\"object\", \"indexOrKey\", \"collection\"})}), smalltalk:newArray({\"whoImplements\", smalltalk:newArray({\"klass\", \"jsSelector\"})}), smalltalk:newArray({\"superImplementor\", smalltalk:newArray({\"klass\", \"jsSelector\"})}), smalltalk:newArray({\"addMethod\", smalltalk:newArray({\"jsSelector\", \"method\", \"klass\"})}), smalltalk:newArray({\"bind\", smalltalk:newArray({\"klass\", \"stSelector\", \"jsSelector\", \"jsFunction\", \"category\", \"stSource\", \"stamp\"})}), smalltalk:newArray({\"removeMethod\", smalltalk:newArray({\"aClass\", \"aMethod\"})}), smalltalk:newArray({\"newMethod\", smalltalk:newArray({\"currentClass\", \"selector\", \"fn\", \"source\"})}), smalltalk:newArray({\"readJSObject\", smalltalk:newArray({\"js\"})}), smalltalk:newArray({\"globalsDo\", smalltalk:newArray({\"action\"})}), smalltalk:newArray({\"startup\", smalltalk:newArray({})}), smalltalk:newArray({\"launchImage\", smalltalk:newArray({\"imageName\"})}), smalltalk:newArray({\"is:kindOf:\", smalltalk:newArray({\"anObject\", \"aClass\"})}), smalltalk:newArray({\"responds:to:\", smalltalk:newArray({\"anObject\", \"aSelector\"})}), smalltalk:newArray({\"debugBind\", smalltalk:newArray({\"klass\", \"stSelector\", \"jsSelector\", \"jsFunction\", \"category\", \"stSource\", \"stamp\"})}), smalltalk:newArray({\"debugAddClass\", smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"})}), smalltalk:newArray({\"initWithSubclasses\", smalltalk:newArray({\"aClass\"})})})):do_((function(tuple)\r\nreturn ((self):bindAPI_(tuple))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"systemDictionaryInternals",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("this","imageFileName","\"s8.image.js\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("this","nativeLanguage","\"js\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_property_to_("this","useManager","false");
	return ((_s8_rec):cr())
end
)(self);
(self):bind_arguments_doing_("isNil",smalltalk:newArray({"x"}),(function()
return ((self):return_((function()
return ((self):expr_eqeqeq_((function()
return ((self):expr_or_("x","nil"))
end),"nil"))
end)))
end));
(self):nextPutAll_((function()
return ((self):systemDictionaryPrivates())
end));
(self):nextPutAll_((function()
return ((self):systemDictionaryAPI())
end));
return (self);
end
,"implementations","systemDictionaryInternals\r\n\t\" Private - Internal encoding for SystemDictionary. \"\r\n\r\n\tself assign: #this pv: #imageFileName to: '\"s8.image.js\"';cr.\r\n\tself assign: #this pv: #nativeLanguage to: '\"js\"';cr.\r\n\tself assign: #this property: #useManager to: #false;cr.\r\n\tself bind: #isNil arguments: #(x) doing: [\r\n\t\tself return: [self expr: [self expr: #x or: #nil ] eqeqeq: #nil ]\r\n\t].\r\n\tself nextPutAll: [ self systemDictionaryPrivates ].\r\n\tself nextPutAll: [ self systemDictionaryAPI ].","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"this\",\"imageFileName\",\"\\\"s8.image.js\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"this\",\"nativeLanguage\",\"\\\"js\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_property_to_(\"this\",\"useManager\",\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):bind_arguments_doing_(\"isNil\",smalltalk:newArray({\"x\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):expr_eqeqeq_((function()\r\nreturn ((self):expr_or_(\"x\",\"nil\"))\r\nend),\"nil\"))\r\nend)))\r\nend));\r\n(self):nextPutAll_((function()\r\nreturn ((self):systemDictionaryPrivates())\r\nend));\r\n(self):nextPutAll_((function()\r\nreturn ((self):systemDictionaryAPI())\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"define:subclass:doing:",0
,function(self,parentClass,aName,expression)
(
function(_s8_rec)
	(_s8_rec):implementFunction_doing_(smalltalk:object_comma_(("St"),aName),expression);
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"encoding","define: parentClass subclass: aName doing: expression\r\n\t\" Private - Return the encoding for defining a new S8 class named aName. \"\r\n\r\n\tself implementFunction: #St ,aName doing: expression;cr ","function(self,parentClass,aName,expression)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_doing_(smalltalk:object_comma_((\"St\"),aName),expression);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"newInstanceOf:",0
,function(self,clsName)
(self):call_(smalltalk:object_comma_(("new St"),clsName));
return (self);
end
,"encoding","newInstanceOf: clsName\r\n\t\" Private - Encoding for defining a variable named aName. \"\r\n\r\n\tself call: 'new St' ,clsName ","function(self,clsName)\r\n(self):call_(smalltalk:object_comma_((\"new St\"),clsName));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"define:asInstanceOf:",0
,function(self,aName,clsName)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("var");
	(_s8_rec):space();
	return ((_s8_rec):assign_to_(aName,(function()
return ((
function(_s8_rec)
	(_s8_rec):newInstanceOf_(clsName);
	return ((_s8_rec):cr())
end
)(self))
end)))
end
)(self);
return (self);
end
,"encoding","define: aName asInstanceOf: clsName\r\n\t\" Private - Return the encoding for defining a variable named aName. \"\r\n\r\n\tself\tnextPutAll: #var; space;\r\n\t\tassign: aName to: [ self newInstanceOf: clsName; cr ] ","function(self,aName,clsName)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"var\");\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):assign_to_(aName,(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):newInstanceOf_(clsName);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend)))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JSBoot,"sendMessageArguments:",0
,function(self,args)
if (smalltalk:isObject_equalTo_(((args):size()),0))==true then return (self); end;
(self):nextPutArguments_(args);
return (self);
end
,"encoding","sendMessageArguments: args\r\n\t\" Private - Encoding for aMessage arguments. \"\r\n\r\n\targs size = 0 ifTrue: [ ^self ].\r\n\tself nextPutArguments: args ","function(self,args)\r\nif (smalltalk:isObject_equalTo_(((args):size()),0))==true then return (self); end;\r\n(self):nextPutArguments_(args);\r\nreturn (self);\r\nend")
