
-- fileIn("s8/library/ffi.st")
smalltalk:addClass("FFI",smalltalk.NativeObject,smalltalk:newArray({}),"ffi")

smalltalk:addClass("CObject",smalltalk.Lua,smalltalk:newArray({}),"ffi")

smalltalk:addClass("CData",smalltalk.CObject,smalltalk:newArray({}),"ffi")

smalltalk:bind(smalltalk.CData,"toNumber",0
,function(self)
return (tonumber((self):handle()));
end
,"converting","toNumber\r\n\t^# #tonumber: self handle","function(self)\r\nreturn (tonumber((self):handle()));\r\nend")

smalltalk:bind(smalltalk.CData,"toString",0
,function(self)
return (tostring((self):handle()));
end
,"converting","toString\r\n\t^# #tostring: self handle","function(self)\r\nreturn (tostring((self):handle()));\r\nend")

smalltalk:addClass("CType",smalltalk.CData,smalltalk:newArray({}),"ffi")

smalltalk:bind(smalltalk.CType,"free",0
,function(self)
return (((self):handle()):free());
end
,"wrappers","free\r\n\t\" Delegate to handle. \"\r\n\r\n\t^self handle #free","function(self)\r\nreturn (((self):handle()):free());\r\nend")

smalltalk:bind(smalltalk.CType,"set:",0
,function(self,func)
return (((self):handle()):set(func));
end
,"wrappers","set: func \r\n\t\" Delegate to handle. \"\r\n\r\n\t^self handle #set: func ","function(self,func)\r\nreturn (((self):handle()):set(func));\r\nend")

smalltalk:addClass("CLib",smalltalk.CObject,smalltalk:newArray({}),"ffi")

smalltalk.FFI["$klass"]["$iVarNames"]=smalltalk:newArray({"nativeClass"})

smalltalk:bind(smalltalk.FFI["$klass"],"initializeNativeClass",0
,function(self)
(function()
	local _s8_value=((smalltalk.Lua):_at(require("ffi")))
	self["@nativeClass"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeNativeClass\r\n\t\" Private - Initialize the nativeClass of the receiver. \"\r\n\r\n\tnativeClass := Lua @ (# #require: #ffi)","function(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Lua):_at(require(\"ffi\")))\r\n\tself[\"@nativeClass\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"nativeClass",0
,function(self)
if (smalltalk:isNil_((self["@nativeClass"])))==true then (self):initializeNativeClass(); end;
return (self["@nativeClass"]);
end
,"accessing","nativeClass\r\n\t\" Return the nativeClass of the receiver. \"\r\n\r\n\tnativeClass isNil ifTrue: [ self initializeNativeClass ].\r\n\t^nativeClass","function(self)\r\nif (smalltalk:isNil_((self[\"@nativeClass\"])))==true then (self):initializeNativeClass(); end;\r\nreturn (self[\"@nativeClass\"]);\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"nativeClass:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@nativeClass"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","nativeClass: anObject\r\n\t\" Set the nativeClass of the receiver. \"\r\n\r\n\tnativeClass := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@nativeClass\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"cdef:",0
,function(self,source)
return ((((self):nativeClass()):handle()).cdef(source));
end
,"wrappers","cdef: source \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_cdef: source ","function(self,source)\r\nreturn ((((self):nativeClass()):handle()).cdef(source));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"load:global:",0
,function(self,libName,aBoolean)
return ((smalltalk.CLib):_at((((self):nativeClass()):handle()).load(libName,aBoolean)));
end
,"wrappers","load: libName global: aBoolean \r\n\t\" Delegated to native class. \"\r\n\r\n\t^CLib @ (self nativeClass handle #_load: libName global: aBoolean )","function(self,libName,aBoolean)\r\nreturn ((smalltalk.CLib):_at((((self):nativeClass()):handle()).load(libName,aBoolean)));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"load:",0
,function(self,libName)
return ((smalltalk.CLib):_at((((self):nativeClass()):handle()).load(libName)));
end
,"wrappers","load: libName \r\n\t\" Delegated to native class. \"\r\n\r\n\t^CLib @ (self nativeClass handle #_load: libName )","function(self,libName)\r\nreturn ((smalltalk.CLib):_at((((self):nativeClass()):handle()).load(libName)));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"new:",0
,function(self,ct)
return ((smalltalk.CData):_at((((self):nativeClass()):handle()).new((ct):json())));
end
,"wrappers","new: ct \r\n\t\" Delegated to native class. \"\r\n\r\n\t^CData @ (self nativeClass handle #_new: ct json )","function(self,ct)\r\nreturn ((smalltalk.CData):_at((((self):nativeClass()):handle()).new((ct):json())));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"new:count:",0
,function(self,ct,nelem)
return ((smalltalk.CData):_at((((self):nativeClass()):handle()).new((ct):json(),nelem)));
end
,"wrappers","new: ct count: nelem \r\n\t\" Delegated to native class. \"\r\n\r\n\t^CData @ (self nativeClass handle #_new: ct json count: nelem )","function(self,ct,nelem)\r\nreturn ((smalltalk.CData):_at((((self):nativeClass()):handle()).new((ct):json(),nelem)));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"new:count:with:",0
,function(self,ct,nelem,init1)
return ((smalltalk.CData):_at((((self):nativeClass()):handle()).new((ct):json(),nelem,init1)));
end
,"wrappers","new: ct count: nelem with: init1 \r\n\t\" Delegated to native class. \"\r\n\r\n\t^CData @ (self nativeClass handle #_new: ct json count: nelem with: init1 )","function(self,ct,nelem,init1)\r\nreturn ((smalltalk.CData):_at((((self):nativeClass()):handle()).new((ct):json(),nelem,init1)));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"new:count:with:with:",0
,function(self,ct,nelem,init1,init2)
return ((smalltalk.CData):_at((((self):nativeClass()):handle()).new((ct):json(),nelem,init1,init2)));
end
,"wrappers","new: ct count: nelem with: init1 with: init2 \r\n\t\" Delegated to native class. \"\r\n\r\n\t^CData @ (self nativeClass handle #_new: ct json count: nelem with: init1 with: init2 )","function(self,ct,nelem,init1,init2)\r\nreturn ((smalltalk.CData):_at((((self):nativeClass()):handle()).new((ct):json(),nelem,init1,init2)));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"new:count:with:with:with:",0
,function(self,ct,nelem,init1,init2,init3)
return ((smalltalk.CData):_at((((self):nativeClass()):handle()).new((ct):json(),nelem,init1,init2,init3)));
end
,"wrappers","new: ct count: nelem with: init1 with: init2 with: init3 \r\n\t\" Delegated to native class. \"\r\n\r\n\t^CData @ (self nativeClass handle #_new: ct json count: nelem with: init1 with: init2 with: init3 )","function(self,ct,nelem,init1,init2,init3)\r\nreturn ((smalltalk.CData):_at((((self):nativeClass()):handle()).new((ct):json(),nelem,init1,init2,init3)));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"new:count:with:with:with:with:",0
,function(self,ct,nelem,init1,init2,init3,init4)
return ((smalltalk.CData):_at((((self):nativeClass()):handle()).new((ct):json(),nelem,init1,init2,init3,init4)));
end
,"wrappers","new: ct count: nelem with: init1 with: init2 with: init3 with: init4 \r\n\t\" Delegated to native class. \"\r\n\r\n\t^CData @ (self nativeClass handle #_new: ct json count: nelem with: init1 with: init2 with: init3 with: init4 )","function(self,ct,nelem,init1,init2,init3,init4)\r\nreturn ((smalltalk.CData):_at((((self):nativeClass()):handle()).new((ct):json(),nelem,init1,init2,init3,init4)));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"typeof:",0
,function(self,ct)
return ((smalltalk.CType):_at((((self):nativeClass()):handle()).typeof((ct):json())));
end
,"wrappers","typeof: ct \r\n\t\" Delegated to native class. \"\r\n\r\n\t^CType @ (self nativeClass handle #_typeof: ct json )","function(self,ct)\r\nreturn ((smalltalk.CType):_at((((self):nativeClass()):handle()).typeof((ct):json())));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"cast:with:",0
,function(self,ct,with)
return ((smalltalk.CData):_at((((self):nativeClass()):handle()).cast((ct):json(),with)));
end
,"wrappers","cast: ct with: with \r\n\t\" Delegated to native class. \"\r\n\r\n\t^CData @ (self nativeClass handle #_cast: ct json with: with )","function(self,ct,with)\r\nreturn ((smalltalk.CData):_at((((self):nativeClass()):handle()).cast((ct):json(),with)));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"metatype:metatable:",0
,function(self,ct,metatable)
return ((smalltalk.CType):_at((((self):nativeClass()):handle()).metatype((ct):json(),(metatable):json())));
end
,"wrappers","metatype: ct metatable: metatable \r\n\t\" Delegated to native class. \"\r\n\r\n\t^CType @ (self nativeClass handle #_metatype: ct json metatable: metatable json )","function(self,ct,metatable)\r\nreturn ((smalltalk.CType):_at((((self):nativeClass()):handle()).metatype((ct):json(),(metatable):json())));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"gc:finalizer:",0
,function(self,cdata,finalizer)
return ((smalltalk.CData):_at((((self):nativeClass()):handle()).gc((cdata):json(),finalizer)));
end
,"wrappers","gc: cdata finalizer: finalizer \r\n\t\" Delegated to native class. \"\r\n\r\n\t^CData @ (self nativeClass handle #_gc: cdata json finalizer: finalizer )","function(self,cdata,finalizer)\r\nreturn ((smalltalk.CData):_at((((self):nativeClass()):handle()).gc((cdata):json(),finalizer)));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"sizeof:",0
,function(self,ct)
return ((((self):nativeClass()):handle()).sizeof((ct):json()));
end
,"wrappers","sizeof: ct \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_sizeof: ct json ","function(self,ct)\r\nreturn ((((self):nativeClass()):handle()).sizeof((ct):json()));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"sizeof:count:",0
,function(self,ct,count)
return ((((self):nativeClass()):handle()).sizeof((ct):json(),count));
end
,"wrappers","sizeof: ct count: count \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_sizeof: ct json count: count ","function(self,ct,count)\r\nreturn ((((self):nativeClass()):handle()).sizeof((ct):json(),count));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"alignof:",0
,function(self,ct)
return ((((self):nativeClass()):handle()).alignof((ct):json()));
end
,"wrappers","alignof: ct \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_alignof: ct json ","function(self,ct)\r\nreturn ((((self):nativeClass()):handle()).alignof((ct):json()));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"offsetof:field:",0
,function(self,ct,field)
return ((((self):nativeClass()):handle()).offsetof((ct):json(),field));
end
,"wrappers","offsetof: ct field: field \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_offsetof: ct json field: field ","function(self,ct,field)\r\nreturn ((((self):nativeClass()):handle()).offsetof((ct):json(),field));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"istype:obj:",0
,function(self,ct,obj)
return ((((self):nativeClass()):handle()).istype((ct):json(),(obj):json()));
end
,"wrappers","istype: ct obj: obj \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_istype: ct json obj: obj json ","function(self,ct,obj)\r\nreturn ((((self):nativeClass()):handle()).istype((ct):json(),(obj):json()));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"errno",0
,function(self)
return ((((self):nativeClass()):handle()).errno());
end
,"wrappers","errno\r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_errno","function(self)\r\nreturn ((((self):nativeClass()):handle()).errno());\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"errno:",0
,function(self,newerr)
return ((((self):nativeClass()):handle()).errno(newerr));
end
,"wrappers","errno: newerr \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_errno: newerr ","function(self,newerr)\r\nreturn ((((self):nativeClass()):handle()).errno(newerr));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"string:",0
,function(self,ptr)
return ((((self):nativeClass()):handle()).string((ptr):json()));
end
,"wrappers","string: ptr \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_string: ptr json ","function(self,ptr)\r\nreturn ((((self):nativeClass()):handle()).string((ptr):json()));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"string:len:",0
,function(self,ptr,len)
return ((((self):nativeClass()):handle()).string((ptr):json(),len));
end
,"wrappers","string: ptr len: len \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_string: ptr json len: len ","function(self,ptr,len)\r\nreturn ((((self):nativeClass()):handle()).string((ptr):json(),len));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"copy:src:len:",0
,function(self,dst,src,len)
return ((((self):nativeClass()):handle()).copy((dst):json(),(src):json(),len));
end
,"wrappers","copy: dst src: src len: len \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_copy: dst json src: src json len: len ","function(self,dst,src,len)\r\nreturn ((((self):nativeClass()):handle()).copy((dst):json(),(src):json(),len));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"copy:str:",0
,function(self,dst,str)
return ((((self):nativeClass()):handle()).copy((dst):json(),(str):json()));
end
,"wrappers","copy: dst str: str \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_copy: dst json str: str json ","function(self,dst,str)\r\nreturn ((((self):nativeClass()):handle()).copy((dst):json(),(str):json()));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"fill:len:",0
,function(self,dst,len)
return ((((self):nativeClass()):handle()).fill((dst):json(),len));
end
,"wrappers","fill: dst len: len \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_fill: dst json len: len ","function(self,dst,len)\r\nreturn ((((self):nativeClass()):handle()).fill((dst):json(),len));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"fill:len:c:",0
,function(self,dst,len,c)
return ((((self):nativeClass()):handle()).fill((dst):json(),len,c));
end
,"wrappers","fill: dst len: len c: c \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_fill: dst json len: len c: c ","function(self,dst,len,c)\r\nreturn ((((self):nativeClass()):handle()).fill((dst):json(),len,c));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"abi:",0
,function(self,param)
return ((((self):nativeClass()):handle()).abi(param));
end
,"wrappers","abi: param \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_abi: param ","function(self,param)\r\nreturn ((((self):nativeClass()):handle()).abi(param));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"load:cdef:",0
,function(self,libraryFileName,source)
(self):cdef_(source);
return ((self):load_(libraryFileName));
end
,"loading","load: libraryFileName cdef: source\r\n\t\" Returns the result of loading the C library at libraryFileName. \"\r\n\r\n\tself cdef: source.\r\n\t^self load: libraryFileName ","function(self,libraryFileName,source)\r\n(self):cdef_(source);\r\nreturn ((self):load_(libraryFileName));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"c",0
,function(self)
return ((smalltalk.Lua):_at(((self):nativeClass()):_at("C")));
end
,"accessing","c\r\n\t\" Returns the default C library namespace (ffi.C).\r\n\tIt binds to the default set of symbols or libraries on the target system.\r\n\tThese are more or less the same as a C compiler would offer by default, without specifying extra link libraries.\r\n\t\"\r\n\r\n\t^Lua @ (self nativeClass @ #C) ","function(self)\r\nreturn ((smalltalk.Lua):_at(((self):nativeClass()):_at(\"C\")));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"os",0
,function(self)
return (((self):nativeClass()):_at("os"));
end
,"accessing","os\r\n\t\" Returns the target OS name. \"\r\n\r\n\t^self nativeClass @ #os ","function(self)\r\nreturn (((self):nativeClass()):_at(\"os\"));\r\nend")

smalltalk:bind(smalltalk.FFI["$klass"],"arch",0
,function(self)
return (((self):nativeClass()):_at("arch"));
end
,"accessing","arch\r\n\t\" Returns the target architecture name. \"\r\n\r\n\t^self nativeClass @ #arch ","function(self)\r\nreturn (((self):nativeClass()):_at(\"arch\"));\r\nend")
