
-- fileIn("s8/library/scripting/Bindings.st")
smalltalk:addClass("S8BindingObject",smalltalk.Object,smalltalk:newArray({}),"Bindings")

smalltalk:addClass("S8Binding",smalltalk.S8BindingObject,smalltalk:newArray({"key","source"}),"Bindings")

smalltalk:addClass("S8LiteralBinding",smalltalk.S8Binding,smalltalk:newArray({}),"Bindings")

smalltalk:addClass("S8CopyBinding",smalltalk.S8LiteralBinding,smalltalk:newArray({}),"Bindings")

smalltalk:addClass("S8Context",smalltalk.S8BindingObject,smalltalk:newArray({"parent","locals","home"}),"Bindings")

smalltalk:addClass("S8Block",smalltalk.S8BindingObject,smalltalk:newArray({"node","context"}),"Bindings")
smalltalk.S8Block["$classVariableNames"]="Optimizations"

smalltalk:bind(smalltalk.S8Context["$klass"],"in:",0
,function(self,aContext)
return (((self):basicNew()):initialize_with_(aContext,(smalltalk.PoolDictionary):new()));
end
,"instantiation","in: aContext\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^self basicNew\r\n\t\tinitialize: aContext\r\n\t\twith: PoolDictionary new","function(self,aContext)\r\nreturn (((self):basicNew()):initialize_with_(aContext,(smalltalk.PoolDictionary):new()));\r\nend")

smalltalk:bind(smalltalk.S8Context["$klass"],"in:clear:do:",0
,function(self,aContext,array,aBlock)
local ctx=nil
(function()
	local _s8_value=((self):in_(aContext))
	ctx=_s8_value
	return _s8_value
end)();
(array):do_((function(each)
return ((each):clear_(ctx))
end));
return ((aBlock):value_(ctx));
end
,"activation","in: aContext clear: array do: aBlock\r\n\t\" Activates a new context in aContext and evaluate aBlock clearing temporaries array. \"\r\n\r\n\t| ctx |\r\n\tctx := self in: aContext.\r\n\tarray do: [:each| each clear: ctx ].\r\n\t^aBlock value: ctx ","function(self,aContext,array,aBlock)\r\nlocal ctx=nil\r\n(function()\r\n\tlocal _s8_value=((self):in_(aContext))\r\n\tctx=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(array):do_((function(each)\r\nreturn ((each):clear_(ctx))\r\nend));\r\nreturn ((aBlock):value_(ctx));\r\nend")

smalltalk:bind(smalltalk.S8Context["$klass"],"for:",0
,function(self,aReceiver)
return ((
function(_s8_rec)
	(_s8_rec):self_(aReceiver);
	return ((_s8_rec):yourself())
end
)((self):in_(nil)));
end
,"instantiation","for: aReceiver\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^(self in: nil)\r\n\t\tself: aReceiver;\r\n\t\tyourself","function(self,aReceiver)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):self_(aReceiver);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):in_(nil)));\r\nend")

smalltalk:bind(smalltalk.S8Context,"initialize:with:",0
,function(self,aContext,aPoolDictionary)
(function()
	local _s8_value=(aContext)
	self["@parent"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(aPoolDictionary)
	self["@locals"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initialize: aContext with: aPoolDictionary\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tparent := aContext.\r\n\tlocals := aPoolDictionary.","function(self,aContext,aPoolDictionary)\r\n(function()\r\n\tlocal _s8_value=(aContext)\r\n\tself[\"@parent\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(aPoolDictionary)\r\n\tself[\"@locals\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Context,"clear:",0
,function(self,aBinding)
return ((self["@locals"]):at_put_((aBinding):key(),nil));
end
,"setup","clear: aBinding\r\n\t\" Clear the local value for aBinding. \"\r\n\r\n\t^locals at: aBinding key put: nil ","function(self,aBinding)\r\nreturn ((self[\"@locals\"]):at_put_((aBinding):key(),nil));\r\nend")

smalltalk:bind(smalltalk.S8Context,"home",0
,function(self)
if (smalltalk:notNil_((self["@home"])))==true then return (self["@home"]); end;
return (smalltalk:if_true_false_((smalltalk:notNil_((self["@parent"]))),(function()
return ((self["@parent"]):home())
end),nil));
end
,"accessing","home\r\n\t\" Returns the home context of the receiver (or nil). \"\r\n\r\n\thome notNil ifTrue: [ ^home ].\r\n\t^parent notNil ifTrue: [ parent  home ] ","function(self)\r\nif (smalltalk:notNil_((self[\"@home\"])))==true then return (self[\"@home\"]); end;\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((self[\"@parent\"]))),(function()\r\nreturn ((self[\"@parent\"]):home())\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.S8Context,"home:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@home"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","home: anObject\r\n\t\" Set the home context of the receiver. \"\r\n\r\n\thome := anObject ","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@home\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Context,"at:",0
,function(self,aKey)
return ((self["@locals"]):at_ifAbsent_(aKey,(function()
return (smalltalk:if_true_false_((smalltalk:notNil_((self["@parent"]))),(function()
return ((self["@parent"]):at_(aKey))
end),nil))
end)));
end
,"accessing","at: aKey\r\n\t\" Returns the value for aKey in the receiver (or nil). \"\r\n\r\n\t^locals at: aKey ifAbsent: [\r\n\t\tparent notNil ifTrue: [\r\n\t\t\tparent at: aKey\r\n\t\t]\r\n\t]","function(self,aKey)\r\nreturn ((self[\"@locals\"]):at_ifAbsent_(aKey,(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((self[\"@parent\"]))),(function()\r\nreturn ((self[\"@parent\"]):at_(aKey))\r\nend),nil))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Context,"set:to:",0
,function(self,aKey,aValue)
if ((self["@locals"]):includesKey_(aKey))==true then (self["@locals"]):at_put_(aKey,aValue);
return (true); end;
return (smalltalk:boolean_and_((smalltalk:notNil_((self["@parent"]))),(function()
return ((self["@parent"]):set_to_(aKey,aValue))
end)));
end
,"private","set: aKey to: aValue\r\n\t\" Private - Returns true if the receiver change the value for aKey to aValue. \"\r\n\r\n\t(locals includesKey: aKey) ifTrue: [\r\n\t\tlocals at: aKey put: aValue.\r\n\t\t^true\r\n\t].\r\n\t^parent notNil and: [ parent set: aKey to: aValue ] ","function(self,aKey,aValue)\r\nif ((self[\"@locals\"]):includesKey_(aKey))==true then (self[\"@locals\"]):at_put_(aKey,aValue);\r\nreturn (true); end;\r\nreturn (smalltalk:boolean_and_((smalltalk:notNil_((self[\"@parent\"]))),(function()\r\nreturn ((self[\"@parent\"]):set_to_(aKey,aValue))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Context,"at:put:",0
,function(self,aKey,aValue)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if not (((self["@locals"]):includesKey_(aKey)))==true then smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((self["@parent"]))),(function()
return ((self["@parent"]):set_to_(aKey,aValue))
end))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (aValue)
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self["@locals"]):at_put_(aKey,aValue))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","at: aKey put: aValue\r\n\t\" Set the value for aKey in the receiver to aValue. \"\r\n\r\n\t(locals includesKey: aKey) ifFalse: [\r\n\t\t(parent notNil and: [ parent set: aKey to: aValue ])\r\n\t\tifTrue: [ ^aValue ].\r\n\t].\r\n\t^locals at: aKey put: aValue ","function(self,aKey,aValue)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif not (((self[\"@locals\"]):includesKey_(aKey)))==true then smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((self[\"@parent\"]))),(function()\r\nreturn ((self[\"@parent\"]):set_to_(aKey,aValue))\r\nend))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (aValue)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self[\"@locals\"]):at_put_(aKey,aValue))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.S8Context,"self:",0
,function(self,anObject)
return ((self):at_put_("self",anObject));
end
,"accessing","self: anObject\r\n\t\" Set the object bound to self in the receiver. \"\r\n\r\n\t^self at: #self put: anObject ","function(self,anObject)\r\nreturn ((self):at_put_(\"self\",anObject));\r\nend")

smalltalk:bind(smalltalk.S8Context,"self",0
,function(self)
return ((self):at_("self"));
end
,"accessing","self\r\n\t\" Returns the object bound to self in the receiver. \"\r\n\r\n\t^self at: #self ","function(self)\r\nreturn ((self):at_(\"self\"));\r\nend")

smalltalk:bind(smalltalk.S8Context,"associationsDo:",0
,function(self,aBlock)
if (smalltalk:notNil_((self["@parent"])))==true then (self["@parent"]):associationsDo_(aBlock); end;
if (smalltalk:notNil_((self["@locals"])))==true then (self["@locals"]):associationsDo_(aBlock); end;
return (self);
end
,"accessing","associationsDo: aBlock\r\n\t\" Evaluates aBlock on each association in the receiver. \"\r\n\r\n\tparent notNil ifTrue: [\r\n\t\tparent associationsDo: aBlock\r\n\t].\r\n\tlocals notNil ifTrue: [\r\n\t\tlocals associationsDo: aBlock\r\n\t].","function(self,aBlock)\r\nif (smalltalk:notNil_((self[\"@parent\"])))==true then (self[\"@parent\"]):associationsDo_(aBlock); end;\r\nif (smalltalk:notNil_((self[\"@locals\"])))==true then (self[\"@locals\"]):associationsDo_(aBlock); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Binding["$klass"],"key:",0
,function(self,aKey)
return (((self):basicNew()):initialize_source_(aKey,nil));
end
,"instantiating","key: aKey\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew initialize: aKey source: nil ","function(self,aKey)\r\nreturn (((self):basicNew()):initialize_source_(aKey,nil));\r\nend")

smalltalk:bind(smalltalk.S8Binding["$klass"],"key:in:",0
,function(self,aKey,aDictionary)
return (((self):basicNew()):initialize_source_(aKey,aDictionary));
end
,"instantiating","key: aKey in: aDictionary\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew initialize: aKey source: aDictionary ","function(self,aKey,aDictionary)\r\nreturn (((self):basicNew()):initialize_source_(aKey,aDictionary));\r\nend")

smalltalk:bind(smalltalk.S8Binding["$klass"],"key:evaluate:assign:",0
,function(self,aKey,oneArgumentBlock,threeArgumentBlock)
local aBlock=nil
local pool=nil
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	pool=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):at_put_("key",(function()
return (aKey)
end));
	(_s8_rec):at_put_("evaluateIn:",oneArgumentBlock);
	(_s8_rec):at_put_("assign:to:in:",threeArgumentBlock);
	return ((_s8_rec):yourself())
end
)(pool);
(function()
	local _s8_value=((function(what,arg1,arg2,arg3)
return (((pool):at_(what)):evaluateWithArguments_((smalltalk.Array):with_with_with_(arg1,arg2,arg3)))
end))
	aBlock=_s8_value
	return _s8_value
end)();
return (((self):basicNew()):initialize_source_(aBlock,nil));
end
,"instantiating","key: aKey evaluate: oneArgumentBlock assign: threeArgumentBlock\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t| aBlock pool |\r\n\tpool := PoolDictionary new.\r\n\tpool\tat: #key put: [ aKey ];\r\n\t\tat: #evaluateIn: put: oneArgumentBlock;\r\n\t\tat: #assign:to:in: put: threeArgumentBlock;\r\n\t\tyourself.\r\n\taBlock := [:what :arg1 :arg2 :arg3 |\r\n\t\t(pool at: what) evaluateWithArguments: (Array with: arg1 with: arg2 with: arg3)\r\n\t].\r\n\t^self basicNew initialize: aBlock source: nil ","function(self,aKey,oneArgumentBlock,threeArgumentBlock)\r\nlocal aBlock=nil\r\nlocal pool=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tpool=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):at_put_(\"key\",(function()\r\nreturn (aKey)\r\nend));\r\n\t(_s8_rec):at_put_(\"evaluateIn:\",oneArgumentBlock);\r\n\t(_s8_rec):at_put_(\"assign:to:in:\",threeArgumentBlock);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(pool);\r\n(function()\r\n\tlocal _s8_value=((function(what,arg1,arg2,arg3)\r\nreturn (((pool):at_(what)):evaluateWithArguments_((smalltalk.Array):with_with_with_(arg1,arg2,arg3)))\r\nend))\r\n\taBlock=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((self):basicNew()):initialize_source_(aBlock,nil));\r\nend")

smalltalk:bind(smalltalk.S8Binding["$klass"],"toInstanceVariable:",0
,function(self,key)
local getter=nil
(function()
	local _s8_value=((function(ctx)
return (((ctx):self()):instVarAt_(key))
end))
	getter=_s8_value
	return _s8_value
end)();
return ((self):key_evaluate_assign_(key,getter,(function(ndx,value,ctx)
return (smalltalk:if_true_false_((smalltalk:isNil_((ndx))),(function()
return (((ctx):self()):instVarAt_put_(key,value))
end),(function()
local target=nil
(function()
	local _s8_value=((ndx):value_((getter):value_(ctx)))
	target=_s8_value
	return _s8_value
end)();return (smalltalk:basic_at_put_(((target):first()),(target):last(),value))
end)))
end)));
end
,"instantiating","toInstanceVariable: key\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t| getter |\r\n\tgetter := [:ctx| ctx self instVarAt: key ].\r\n\t^self\tkey: key evaluate: getter\r\n\t\tassign: [:ndx :value :ctx|\r\n\t\t\tndx isNil\r\n\t\t\tifTrue: [ ctx self instVarAt: key put: value ]\r\n\t\t\tifFalse: [ | target |\r\n\t\t\t\ttarget := ndx value: (getter value: ctx).\r\n\t\t\t\ttarget first basicAt: target last put: value\r\n\t\t\t]\r\n\t\t] ","function(self,key)\r\nlocal getter=nil\r\n(function()\r\n\tlocal _s8_value=((function(ctx)\r\nreturn (((ctx):self()):instVarAt_(key))\r\nend))\r\n\tgetter=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):key_evaluate_assign_(key,getter,(function(ndx,value,ctx)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((ndx))),(function()\r\nreturn (((ctx):self()):instVarAt_put_(key,value))\r\nend),(function()\r\nlocal target=nil\r\n(function()\r\n\tlocal _s8_value=((ndx):value_((getter):value_(ctx)))\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:basic_at_put_(((target):first()),(target):last(),value))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Binding,"initialize:source:",0
,function(self,aKeyOrBlock,aSource)
(function()
	local _s8_value=(aKeyOrBlock)
	self["@key"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(aSource)
	self["@source"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initialize: aKeyOrBlock source: aSource\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tkey := aKeyOrBlock.\r\n\tsource := aSource. ","function(self,aKeyOrBlock,aSource)\r\n(function()\r\n\tlocal _s8_value=(aKeyOrBlock)\r\n\tself[\"@key\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(aSource)\r\n\tself[\"@source\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Binding,"key",0
,function(self)
if not (((self["@key"]):isString()))==true then return ((self["@key"]):evaluateWith_("key")); end;
return (self["@key"]);
end
,"accessing","key\r\n\t\" Return the key of the receiver. \"\r\n\r\n\tkey isString ifFalse: [ ^key evaluateWith: #key ].\r\n\t^key ","function(self)\r\nif not (((self[\"@key\"]):isString()))==true then return ((self[\"@key\"]):evaluateWith_(\"key\")); end;\r\nreturn (self[\"@key\"]);\r\nend")

smalltalk:bind(smalltalk.S8Binding,"source",0
,function(self)
return (self["@source"]);
end
,"accessing","source\r\n\t\" Private - Return the source of the receiver. \"\r\n\r\n\t^source ","function(self)\r\nreturn (self[\"@source\"]);\r\nend")

smalltalk:bind(smalltalk.S8Binding,"local","__local"
,function(self)
(function()
	local _s8_value=(nil)
	self["@source"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"scope","local\r\n\t\" Returns the receiver acting on runtime context scope. \"\r\n\r\n\tsource := nil ","function(self)\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@source\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Binding,"evaluateIn:",0
,function(self,aContext)
if not (((self["@key"]):isString()))==true then return ((self["@key"]):evaluateWithArguments_((smalltalk.Array):with_with_("evaluateIn:",aContext))); end;
if (smalltalk:notNil_((self["@source"])))==true then return ((self["@source"]):at_ifAbsent_(self["@key"],(function()
return (nil)
end))); end;
return ((aContext):at_(self["@key"]));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\tkey isString ifFalse: [\r\n\t\t^key evaluateWithArguments: (Array with: #evaluateIn: with: aContext)\r\n\t].\r\n\tsource notNil ifTrue: [ ^source at: key ifAbsent: [] ].\r\n\t^aContext at: key ","function(self,aContext)\r\nif not (((self[\"@key\"]):isString()))==true then return ((self[\"@key\"]):evaluateWithArguments_((smalltalk.Array):with_with_(\"evaluateIn:\",aContext))); end;\r\nif (smalltalk:notNil_((self[\"@source\"])))==true then return ((self[\"@source\"]):at_ifAbsent_(self[\"@key\"],(function()\r\nreturn (nil)\r\nend))); end;\r\nreturn ((aContext):at_(self[\"@key\"]));\r\nend")

smalltalk:bind(smalltalk.S8Binding,"assign:to:in:",0
,function(self,indexBlock,aValue,aContext)
local target=nil
if not (((self["@key"]):isString()))==true then return ((self["@key"]):evaluateWithArguments_((smalltalk.Array):with_with_with_with_("assign:to:in:",indexBlock,aValue,aContext))); end;
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((self["@source"]))),(function()
return (aContext)
end),(function()
return (self["@source"])
end)))
	target=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((indexBlock)))==true then return ((target):at_put_(self["@key"],aValue)); end;
(function()
	local _s8_value=((indexBlock):value_((target):at_(self["@key"])))
	target=_s8_value
	return _s8_value
end)();
return (smalltalk:basic_at_put_(((target):first()),(target):last(),aValue));
end
,"evaluating","assign: indexBlock to: aValue in: aContext\r\n\t\" Set the value for the receiver in aContext. \"\r\n\r\n\t| target |\r\n\tkey isString ifFalse: [\r\n\t\t^key evaluateWithArguments: (Array\r\n\t\t\twith: #assign:to:in:\r\n\t\t\twith: indexBlock with: aValue\r\n\t\t\twith: aContext)\r\n\t].\r\n\ttarget := source isNil ifTrue: [aContext] ifFalse: [source].\r\n\tindexBlock isNil ifTrue: [ ^target at: key put: aValue ].\r\n\ttarget := indexBlock value: (target at: key).\r\n\t^target first basicAt: target last put: aValue ","function(self,indexBlock,aValue,aContext)\r\nlocal target=nil\r\nif not (((self[\"@key\"]):isString()))==true then return ((self[\"@key\"]):evaluateWithArguments_((smalltalk.Array):with_with_with_with_(\"assign:to:in:\",indexBlock,aValue,aContext))); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((self[\"@source\"]))),(function()\r\nreturn (aContext)\r\nend),(function()\r\nreturn (self[\"@source\"])\r\nend)))\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((indexBlock)))==true then return ((target):at_put_(self[\"@key\"],aValue)); end;\r\n(function()\r\n\tlocal _s8_value=((indexBlock):value_((target):at_(self[\"@key\"])))\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:basic_at_put_(((target):first()),(target):last(),aValue));\r\nend")

smalltalk:bind(smalltalk.S8LiteralBinding["$klass"],"value:",0
,function(self,aValue)
return (((self):basicNew()):initialize_source_("constant",aValue));
end
,"instantiating","value: aValue\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew initialize: #constant source: aValue ","function(self,aValue)\r\nreturn (((self):basicNew()):initialize_source_(\"constant\",aValue));\r\nend")

smalltalk:bind(smalltalk.S8LiteralBinding,"assign:to:in:",0
,function(self,indexBlock,aValue,aContext)
return ((self):invalidMessage_("assign:to:in:"));
end
,"evaluating","assign: indexBlock to: aValue in: aContext\r\n\t\" Set the value for the receiver in aContext. \"\r\n\r\n\t^self invalidMessage: #assign:to:in: ","function(self,indexBlock,aValue,aContext)\r\nreturn ((self):invalidMessage_(\"assign:to:in:\"));\r\nend")

smalltalk:bind(smalltalk.S8LiteralBinding,"evaluateIn:",0
,function(self,aContext)
return (self["@source"]);
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t^source ","function(self,aContext)\r\nreturn (self[\"@source\"]);\r\nend")

smalltalk:bind(smalltalk.S8CopyBinding,"evaluateIn:",0
,function(self,aContext)
return ((self["@source"]):shallowCopy());
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t^source shallowCopy ","function(self,aContext)\r\nreturn ((self[\"@source\"]):shallowCopy());\r\nend")

smalltalk:bind(smalltalk.S8Block["$klass"],"defaultOptimizations",0
,function(self)
return ((
function(_s8_rec)
	(_s8_rec):at_put_("class",(function(receiver,msg,values,context)
return ((receiver)["$klass"])
end));
	(_s8_rec):at_put_("isNil",(function(receiver,msg,values,context)
return (smalltalk:isNil_((receiver)))
end));
	(_s8_rec):at_put_("notNil",(function(receiver,msg,values,context)
return (smalltalk:notNil_((receiver)))
end));
	(_s8_rec):at_put_("==",(function(receiver,msg,values,context)
return (((receiver)==(values):first()))
end));
	(_s8_rec):at_put_("===",(function(receiver,msg,values,context)
return (((receiver) == (values):first()))
end));
	(_s8_rec):at_put_("basicAt:",(function(receiver,msg,values,context)
return ((receiver)[(values):first()])
end));
	(_s8_rec):at_put_("basicAt:ifAbsent:",(function(receiver,msg,values,context)
return (smalltalk:basic_at_ifAbsent_((receiver),(values):first(),(function()
return (((values):second()):value())
end)))
end));
	(_s8_rec):at_put_("basicAt:put:",(function(receiver,msg,values,context)
return (smalltalk:basic_at_put_((receiver),(values):first(),(values):second()))
end));
	(_s8_rec):at_put_("orNil",(function(receiver,msg,values,context)
return (smalltalk:orNil_((receiver)))
end));
	(_s8_rec):at_put_("respondsTo:",(function(receiver,msg,values,context)
return (smalltalk:responds_to_((receiver),((values):first())))
end));
	return ((_s8_rec):yourself())
end
)((smalltalk.PoolDictionary):new()));
end
,"actions","defaultOptimizations\r\n\t\" Private - Returns the default pool of optimized actions. \"\r\n\r\n\t^PoolDictionary new\r\n\t\tat: #class put: [:receiver :msg :values :context| receiver class ];\r\n\t\tat: #isNil put: [:receiver :msg :values :context| receiver isNil ];\r\n\t\tat: #notNil put: [:receiver :msg :values :context| receiver notNil ];\r\n\t\tat: #== put: [:receiver :msg :values :context| receiver == values first ];\r\n\t\tat: #=== put: [:receiver :msg :values :context| receiver === values first ];\r\n\t\tat: #basicAt: put: [:receiver :msg :values :context| receiver basicAt: values first ];\r\n\t\tat: #basicAt:ifAbsent: put: [:receiver :msg :values :context|\r\n\t\t\treceiver basicAt: values first ifAbsent: [ values second value ] ];\r\n\t\tat: #basicAt:put: put: [:receiver :msg :values :context|\r\n\t\t\treceiver basicAt: values first put: values second ];\r\n\t\tat: #orNil put: [:receiver :msg :values :context| receiver orNil ];\r\n\t\tat: #respondsTo: put: [:receiver :msg :values :context|\r\n\t\t\treceiver respondsTo: values first ];\r\n\t\tyourself ","function(self)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):at_put_(\"class\",(function(receiver,msg,values,context)\r\nreturn ((receiver)[\"$klass\"])\r\nend));\r\n\t(_s8_rec):at_put_(\"isNil\",(function(receiver,msg,values,context)\r\nreturn (smalltalk:isNil_((receiver)))\r\nend));\r\n\t(_s8_rec):at_put_(\"notNil\",(function(receiver,msg,values,context)\r\nreturn (smalltalk:notNil_((receiver)))\r\nend));\r\n\t(_s8_rec):at_put_(\"==\",(function(receiver,msg,values,context)\r\nreturn (((receiver)==(values):first()))\r\nend));\r\n\t(_s8_rec):at_put_(\"===\",(function(receiver,msg,values,context)\r\nreturn (((receiver) == (values):first()))\r\nend));\r\n\t(_s8_rec):at_put_(\"basicAt:\",(function(receiver,msg,values,context)\r\nreturn ((receiver)[(values):first()])\r\nend));\r\n\t(_s8_rec):at_put_(\"basicAt:ifAbsent:\",(function(receiver,msg,values,context)\r\nreturn (smalltalk:basic_at_ifAbsent_((receiver),(values):first(),(function()\r\nreturn (((values):second()):value())\r\nend)))\r\nend));\r\n\t(_s8_rec):at_put_(\"basicAt:put:\",(function(receiver,msg,values,context)\r\nreturn (smalltalk:basic_at_put_((receiver),(values):first(),(values):second()))\r\nend));\r\n\t(_s8_rec):at_put_(\"orNil\",(function(receiver,msg,values,context)\r\nreturn (smalltalk:orNil_((receiver)))\r\nend));\r\n\t(_s8_rec):at_put_(\"respondsTo:\",(function(receiver,msg,values,context)\r\nreturn (smalltalk:responds_to_((receiver),((values):first())))\r\nend));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.PoolDictionary):new()));\r\nend")

smalltalk:bind(smalltalk.S8Block["$klass"],"optimizations",0
,function(self)
if (smalltalk:isNil_((smalltalk.S8Block:classVariableAt_("Optimizations"))))==true then smalltalk.S8Block:classVariableAt_put_("Optimizations",(self):defaultOptimizations()); end;
return (smalltalk.S8Block:classVariableAt_("Optimizations"));
end
,"actions","optimizations\r\n\t\" Private - Returns the pool of optimized actions. \"\r\n\r\n\tOptimizations isNil ifTrue: [ Optimizations := self defaultOptimizations ].\r\n\t^Optimizations","function(self)\r\nif (smalltalk:isNil_((smalltalk.S8Block:classVariableAt_(\"Optimizations\"))))==true then smalltalk.S8Block:classVariableAt_put_(\"Optimizations\",(self):defaultOptimizations()); end;\r\nreturn (smalltalk.S8Block:classVariableAt_(\"Optimizations\"));\r\nend")

smalltalk:bind(smalltalk.S8Block["$klass"],"for:in:",0
,function(self,aNode,aContext)
return ((
function(_s8_rec)
	(_s8_rec):node_(aNode);
	(_s8_rec):context_(aContext);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","for: aNode in: aContext\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tnode: aNode;\r\n\t\tcontext: aContext;\r\n\t\tyourself ","function(self,aNode,aContext)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):node_(aNode);\r\n\t(_s8_rec):context_(aContext);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.S8Block,"node:",0
,function(self,aNode)
(function()
	local _s8_value=(aNode)
	self["@node"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","node: aNode\r\n\t\" Sets the receiver's parent node. \"\r\n\r\n\tnode := aNode ","function(self,aNode)\r\n(function()\r\n\tlocal _s8_value=(aNode)\r\n\tself[\"@node\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Block,"statements",0
,function(self)
return ((self["@node"]):statements());
end
,"evaluating","statements\r\n\t\" Returns the receiver's statements. \"\r\n\r\n\t^node statements ","function(self)\r\nreturn ((self[\"@node\"]):statements());\r\nend")

smalltalk:bind(smalltalk.S8Block,"args",0
,function(self)
return ((self["@node"]):arguments());
end
,"accessing","args\r\n\t\" Returns the receiver's arguments. \"\r\n\r\n\t^node arguments ","function(self)\r\nreturn ((self[\"@node\"]):arguments());\r\nend")

smalltalk:bind(smalltalk.S8Block,"arguments",0
,function(self)
return ((self["@node"]):arguments());
end
,"accessing","arguments\r\n\t\" Returns the receiver's arguments. \"\r\n\r\n\t^node arguments ","function(self)\r\nreturn ((self[\"@node\"]):arguments());\r\nend")

smalltalk:bind(smalltalk.S8Block,"temporaries",0
,function(self)
return ((self["@node"]):temporaries());
end
,"accessing","temporaries\r\n\t\" Returns the receiver's temporaries. \"\r\n\r\n\t^node temporaries ","function(self)\r\nreturn ((self[\"@node\"]):temporaries());\r\nend")

smalltalk:bind(smalltalk.S8Block,"argumentCount",0
,function(self)
return (((self):arguments()):size());
end
,"accessing","argumentCount\r\n\t\" Returns the number of arguments of the receiver. \"\r\n\r\n\t^self arguments size ","function(self)\r\nreturn (((self):arguments()):size());\r\nend")

smalltalk:bind(smalltalk.S8Block,"context:",0
,function(self,aContext)
(function()
	local _s8_value=(aContext)
	self["@context"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","context: aContext\r\n\t\" Sets the receiver's context. \"\r\n\r\n\tcontext := aContext ","function(self,aContext)\r\n(function()\r\n\tlocal _s8_value=(aContext)\r\n\tself[\"@context\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Block,"bindTo:in:",0
,function(self,anArray,aContext)
local args=nil
local stream=nil
(function()
	local _s8_value=((self):arguments())
	args=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((args):size()),0))==true then return (self); end;
if not ((smalltalk:isObject_equalTo_(((args):size()),(anArray):size())))==true then  end;
(function()
	local _s8_value=((anArray):stream())
	stream=_s8_value
	return _s8_value
end)();
(args):do_((function(each)
return ((each):assignValue_in_(smalltalk:if_true_false_(((stream):atEnd()),nil,(function()
return ((stream):next())
end)),aContext))
end));
((self):temporaries()):do_((function(each)
return ((each):assignValue_in_(nil,aContext))
end));
return (self);
end
,"binding","bindTo: anArray in: aContext\r\n\t\" Private - Bind the arguments to values in anArray. \"\r\n\r\n\t| args stream |\r\n\targs := self arguments.\r\n\targs size = 0 ifTrue: [ ^self ].\r\n\targs size = anArray size ifFalse: [\r\n\"\t\t^self error: 'Invalid number of arguments.'\t\r\nDEBUG-\t\tself note: 'Invalid number of arguments (' ,anArray size ,') must be ' ,args size\r\n\"\t].\r\n\r\n\tstream := anArray stream.\r\n\targs do: [:each| each assignValue: (stream atEnd ifFalse: [ stream next ]) in: aContext ].\r\n\tself temporaries do: [:each| each assignValue: nil in: aContext ]. ","function(self,anArray,aContext)\r\nlocal args=nil\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((self):arguments())\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((args):size()),0))==true then return (self); end;\r\nif not ((smalltalk:isObject_equalTo_(((args):size()),(anArray):size())))==true then  end;\r\n(function()\r\n\tlocal _s8_value=((anArray):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(args):do_((function(each)\r\nreturn ((each):assignValue_in_(smalltalk:if_true_false_(((stream):atEnd()),nil,(function()\r\nreturn ((stream):next())\r\nend)),aContext))\r\nend));\r\n((self):temporaries()):do_((function(each)\r\nreturn ((each):assignValue_in_(nil,aContext))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Block,"asActionSequence",0
,function(self)
return ((smalltalk.ActionSequence):with_(self));
end
,"converting","asActionSequence\r\n\t\" Return an ActionSequence from the receiver. \"\r\n\r\n\t^ActionSequence with: self ","function(self)\r\nreturn ((smalltalk.ActionSequence):with_(self));\r\nend")

smalltalk:bind(smalltalk.S8Block,"valueBlock",0
,function(self)
return ((function()
return ((self):value())
end));
end
,"converting","valueBlock\r\n\t\" Private - Return the receiver as a native block to compute value. \"\r\n\r\n\t^[ self value ] ","function(self)\r\nreturn ((function()\r\nreturn ((self):value())\r\nend));\r\nend")

smalltalk:bind(smalltalk.S8Block,"ensure:",0
,function(self,aBlock)
return (((self):valueBlock()):ensure_(aBlock));
end
,"evaluating","ensure: aBlock\r\n\t\" Return the result of evaluating the receiver.\r\n\tExecute aBlock after the receiver is executed.\r\n\t\"\r\n\r\n\t^self valueBlock ensure: aBlock ","function(self,aBlock)\r\nreturn (((self):valueBlock()):ensure_(aBlock));\r\nend")

smalltalk:bind(smalltalk.S8Block,"evaluate",0
,function(self)
return ((self):value());
end
,"evaluating","evaluate\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self value ","function(self)\r\nreturn ((self):value());\r\nend")

smalltalk:bind(smalltalk.S8Block,"evaluateFor:",0
,function(self,anObject)
return ((self):evaluateWithArguments_((smalltalk.Array):with_(anObject)));
end
,"evaluating","evaluateFor: anObject\r\n\t\" Return the result of evaluating the receiver with anObject. \"\r\n\r\n\t^self evaluateWithArguments: (Array with: anObject) ","function(self,anObject)\r\nreturn ((self):evaluateWithArguments_((smalltalk.Array):with_(anObject)));\r\nend")

smalltalk:bind(smalltalk.S8Block,"evaluateWithArguments:",0
,function(self,anArray)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):argumentCount()),0)),(function()
return ((self):value())
end),(function()
return ((self):valueWithArguments_(anArray))
end)));
end
,"evaluating","evaluateWithArguments: anArray\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self argumentCount = 0\r\n\t\tifTrue: [ self value ]\r\n\t\tifFalse: [ self valueWithArguments: anArray ] ","function(self,anArray)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):argumentCount()),0)),(function()\r\nreturn ((self):value())\r\nend),(function()\r\nreturn ((self):valueWithArguments_(anArray))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Block,"evaluateWithoutInterrupts",0
,function(self)
return (((self):valueBlock()):evaluateWithoutInterrupts());
end
,"evaluating","evaluateWithoutInterrupts\r\n\t\" OBSOLETE - Disable interrupts, evaluate the receiver, enable interrupts, and answer the result of the evaluation. \"\r\n\r\n\t^self valueBlock evaluateWithoutInterrupts ","function(self)\r\nreturn (((self):valueBlock()):evaluateWithoutInterrupts());\r\nend")

smalltalk:bind(smalltalk.S8Block,"ifCurtailed:",0
,function(self,exceptionBlock)
return (((self):valueBlock()):ifCurtailed_(exceptionBlock));
end
,"evaluating","ifCurtailed: exceptionBlock\r\n\t\" Return the result of evaluating the receiver.\r\n\tIf evaluation is limited by exiting before completion, the exception block is evaluated.\r\n\t\"\r\n\r\n\t^self valueBlock ifCurtailed: exceptionBlock ","function(self,exceptionBlock)\r\nreturn (((self):valueBlock()):ifCurtailed_(exceptionBlock));\r\nend")

smalltalk:bind(smalltalk.S8Block,"on:do:",0
,function(self,anExceptionType,aBlock)
return (((self):valueBlock()):on_do_(anExceptionType,aBlock));
end
,"evaluating","on: anExceptionType do: aBlock\r\n\t\" Return the result of evaluating the receiver catching exceptions. \"\r\n\r\n\t^self valueBlock on: anExceptionType do: aBlock ","function(self,anExceptionType,aBlock)\r\nreturn (((self):valueBlock()):on_do_(anExceptionType,aBlock));\r\nend")

smalltalk:bind(smalltalk.S8Block,"repeat","__repeat"
,function(self)
return (((self):valueBlock()):__repeat());
end
,"evaluating","repeat\r\n\t\" OBSOLETE - Evaluate the receiver repeatedly, ending only if the block forces some stopping condition. \"\r\n\r\n\t^self valueBlock repeat ","function(self)\r\nreturn (((self):valueBlock()):__repeat());\r\nend")

smalltalk:bind(smalltalk.S8Block,"value",0
,function(self)
return ((self):valueWithArguments_(smalltalk:newArray({})));
end
,"evaluating","value\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self valueWithArguments: #() ","function(self)\r\nreturn ((self):valueWithArguments_(smalltalk:newArray({})));\r\nend")

smalltalk:bind(smalltalk.S8Block,"value:",0
,function(self,argument)
return ((self):valueWithArguments_((smalltalk.Array):with_(argument)));
end
,"evaluating","value: argument\r\n\t\" Return the result of evaluating the receiver with anObject. \"\r\n\r\n\t^self valueWithArguments: (Array with: argument) ","function(self,argument)\r\nreturn ((self):valueWithArguments_((smalltalk.Array):with_(argument)));\r\nend")

smalltalk:bind(smalltalk.S8Block,"value:value:",0
,function(self,anObject,anotherObject)
return ((self):valueWithArguments_((smalltalk.Array):with_with_(anObject,anotherObject)));
end
,"evaluating","value: anObject value: anotherObject\r\n\t\" Return the result of evaluating the receiver with arguments. \"\r\n\r\n\t^self valueWithArguments: (Array with: anObject with: anotherObject) ","function(self,anObject,anotherObject)\r\nreturn ((self):valueWithArguments_((smalltalk.Array):with_with_(anObject,anotherObject)));\r\nend")

smalltalk:bind(smalltalk.S8Block,"value:value:value:",0
,function(self,anObject,anotherObject,thirdObject)
return ((self):valueWithArguments_((smalltalk.Array):with_with_with_(anObject,anotherObject,thirdObject)));
end
,"evaluating","value: anObject value: anotherObject value: thirdObject\r\n\t\" Return the result of evaluating the receiver with arguments. \"\r\n\r\n\t^self valueWithArguments: (Array with: anObject with: anotherObject with: thirdObject) ","function(self,anObject,anotherObject,thirdObject)\r\nreturn ((self):valueWithArguments_((smalltalk.Array):with_with_with_(anObject,anotherObject,thirdObject)));\r\nend")

smalltalk:bind(smalltalk.S8Block,"value:value:value:value:",0
,function(self,firstArgument,secondArgument,thirdArgument,fourthArgument)
return ((self):valueWithArguments_((smalltalk.Array):with_with_with_with_(firstArgument,secondArgument,thirdArgument,fourthArgument)));
end
,"evaluating","value: firstArgument value: secondArgument value: thirdArgument value: fourthArgument\r\n\t\" Return the result of evaluating the receiver with arguments. \"\r\n\r\n\t^self valueWithArguments: (Array\r\n\t\twith: firstArgument with: secondArgument\r\n\t\twith: thirdArgument with: fourthArgument) ","function(self,firstArgument,secondArgument,thirdArgument,fourthArgument)\r\nreturn ((self):valueWithArguments_((smalltalk.Array):with_with_with_with_(firstArgument,secondArgument,thirdArgument,fourthArgument)));\r\nend")

smalltalk:bind(smalltalk.S8Block,"valueWithArguments:",0
,function(self,anArray)
return ((smalltalk.S8Context):in_clear_do_(self["@context"],smalltalk:object_comma_(((self):arguments()),(self):temporaries()),(function(ctx)
(self):bindTo_in_(anArray,ctx);return (((self["@node"]):statements()):inject_into_(nil,(function(total,each)
return ((each):evaluateIn_(ctx))
end)))
end)));
end
,"evaluating","valueWithArguments: anArray\r\n\t\" Return the result of evaluating the receiver with arguments. \"\r\n\r\n\t^S8Context\r\n\t\tin: context clear: self arguments ,self temporaries\r\n\t\tdo: [:ctx|\r\n\t\t\tself bindTo: anArray in: ctx.\r\n\t\t\tnode statements inject: nil\r\n\t\t\t\tinto: [:total :each| each evaluateIn: ctx ]\r\n\t] ","function(self,anArray)\r\nreturn ((smalltalk.S8Context):in_clear_do_(self[\"@context\"],smalltalk:object_comma_(((self):arguments()),(self):temporaries()),(function(ctx)\r\n(self):bindTo_in_(anArray,ctx);return (((self[\"@node\"]):statements()):inject_into_(nil,(function(total,each)\r\nreturn ((each):evaluateIn_(ctx))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Block,"valueDeferred",0
,function(self)
(self):valueDeferred_(0);
return (self);
end
,"evaluating","valueDeferred\r\n\t\" Evaluate the receiver deferred in time.\r\n\tReturn the receiver.\r\n\t\"\r\n\r\n\tself valueDeferred: 0","function(self)\r\n(self):valueDeferred_(0);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Block,"valueDeferred:",0
,function(self,milliseconds)
(self):valueWithTimeout_(milliseconds);
return (self);
end
,"evaluating","valueDeferred: milliseconds\r\n\t\" Evaluate the receiver deferred in time.\r\n\tReturn the receiver.\r\n\t\"\r\n\r\n\tself valueWithTimeout: milliseconds","function(self,milliseconds)\r\n(self):valueWithTimeout_(milliseconds);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Block,"valueWithTimeout:",0
,function(self,aNumber)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(self))
	fn=_s8_value
	return _s8_value
end)();
return (self:notImplementedYet_("valueWithTimeout:"));
end
,"timeout","valueWithTimeout: aNumber\r\n\t\" Evaluate the receiver with time out. \"\r\n\r\n\t| fn | fn := self callableOf: self.\r\n\t^{''js'setTimeout(fn,aNumber)'\r\n\tlua'self:notImplementedYet_(\"valueWithTimeout:\")'\r\n\tpy'self.notImplementedYet_(smalltalk.String(\"valueWithTimeout:\"))'}","function(self,aNumber)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(self))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self:notImplementedYet_(\"valueWithTimeout:\"));\r\nend")

smalltalk:bind(smalltalk.S8Block,"whileFalse",0
,function(self)
return ((self):whileFalse_((function()
return (nil)
end)));
end
,"evaluating","whileFalse\r\n\t\" Evaluate the receiver until the result is true. \"\r\n\r\n\t^self whileFalse: [] ","function(self)\r\nreturn ((self):whileFalse_((function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Block,"whileFalse:",0
,function(self,aBlock)
((self):valueBlock()):whileFalse_((function()
return ((aBlock):value())
end));
return (nil);
end
,"evaluating","whileFalse: aBlock\r\n\t\" Evaluate aBlock while the result of evaluating the receiver is false. \"\r\n\r\n\tself valueBlock whileFalse: [ aBlock value ].\r\n\t^nil ","function(self,aBlock)\r\n((self):valueBlock()):whileFalse_((function()\r\nreturn ((aBlock):value())\r\nend));\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.S8Block,"whileTrue",0
,function(self)
return ((self):whileTrue_((function()
return (nil)
end)));
end
,"evaluating","whileTrue\r\n\t\" Evaluate the receiver until the result is false. \"\r\n\r\n\t^self whileTrue: [] ","function(self)\r\nreturn ((self):whileTrue_((function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Block,"whileTrue:",0
,function(self,aBlock)
((self):valueBlock()):whileTrue_((function()
return ((aBlock):value())
end));
return (nil);
end
,"evaluating","whileTrue: aBlock\r\n\t\" Evaluate aBlock while the result of evaluating the receiver is true. \"\r\n\r\n\tself valueBlock whileTrue: [ aBlock value ].\r\n\t^nil ","function(self,aBlock)\r\n((self):valueBlock()):whileTrue_((function()\r\nreturn ((aBlock):value())\r\nend));\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"bindingAt:",0
,function(self,aKey)
return ((self):bindingAt_ifAbsent_(aKey,(function()
return ((self):error_(smalltalk:object_comma_(("Missing key "),(aKey):asLiteral())))
end)));
end
,"bindings","bindingAt: aKey\r\n\t\" Private - Return the binding at aKey, or generates an error if key is not present. \"\r\n\r\n\t^self bindingAt: aKey ifAbsent: [ self error: 'Missing key ' ,aKey asLiteral ]","function(self,aKey)\r\nreturn ((self):bindingAt_ifAbsent_(aKey,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Missing key \"),(aKey):asLiteral())))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"bindingAt:ifAbsent:",0
,function(self,aKey,aBlock)
if not (((self):includesKey_(aKey)))==true then return ((aBlock):value()); end;
return ((smalltalk.S8Binding):key_in_(aKey,self));
end
,"bindings","bindingAt: aKey ifAbsent: aBlock\r\n\t\" Private - Return the binding at aKey, or the result of evaluating aBlock. \"\r\n\r\n\t(self includesKey: aKey) ifFalse: [ ^aBlock value ].\r\n\t^S8Binding key: aKey in: self","function(self,aKey,aBlock)\r\nif not (((self):includesKey_(aKey)))==true then return ((aBlock):value()); end;\r\nreturn ((smalltalk.S8Binding):key_in_(aKey,self));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"bindingAt:ifAbsent:",0
,function(self,aKey,aBlock)
if not (((self):includesKey_(aKey)))==true then return ((aBlock):value()); end;
return ((smalltalk.S8Binding):key_in_(aKey,self));
end
,"bindings","bindingAt: aKey ifAbsent: aBlock\r\n\t\" Private - Return the binding at aKey, or the result of evaluating aBlock. \"\r\n\r\n\t(self includesKey: aKey) ifFalse: [ ^aBlock value ].\r\n\t^S8Binding key: aKey in: self","function(self,aKey,aBlock)\r\nif not (((self):includesKey_(aKey)))==true then return ((aBlock):value()); end;\r\nreturn ((smalltalk.S8Binding):key_in_(aKey,self));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"bindingAt:",0
,function(self,aKey)
return ((self):bindingAt_ifAbsent_(aKey,(function()
return ((self):error_(smalltalk:object_comma_(("Missing key "),(aKey):asLiteral())))
end)));
end
,"bindings","bindingAt: aKey\r\n\t\" Private - Return the binding at aKey, or generates an error if key is not present. \"\r\n\r\n\t^self bindingAt: aKey ifAbsent: [ self error: 'Missing key ' ,aKey asLiteral ]","function(self,aKey)\r\nreturn ((self):bindingAt_ifAbsent_(aKey,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Missing key \"),(aKey):asLiteral())))\r\nend)));\r\nend")
