
-- fileIn("s8/library/scripting/S8Steps.st")
smalltalk:addClass("StepOverNode",smalltalk.MethodNode,smalltalk:newArray({"action"}),"S8Steps")

smalltalk:bind(smalltalk.Compiler["$klass"],"evaluationScript",0
,function(self)
return (smalltalk.StepOverNode);
end
,"S8Steps-private","evaluationScript\r\n\t\" Return the support for skipping method execution. \"\r\n\r\n\t^StepOverNode ","function(self)\r\nreturn (smalltalk.StepOverNode);\r\nend")

smalltalk:bind(smalltalk.Compiler,"isSourcecode:",0
,function(self,string)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local input=nil
(function()
	local _s8_value=((string):stream())
	input=_s8_value
	return _s8_value
end)();
while not ((function()
return ((input):atEnd())
end))() do smalltalk:if_true_false_((((input):upTo_((smalltalk.String):crlf())):includes_((smalltalk.String):lf())),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"S8Steps-private","isSourcecode: string\r\n\t\" Private - Returns true if a string is formated as sourcecode. \"\r\n\r\n\t| input |\r\n\tinput := string stream.\r\n\t[input atEnd] whileFalse: [\r\n\t\t((input upTo: String crlf) includes: String lf) ifTrue: [ ^false ]\r\n\t].\r\n\t^true","function(self,string)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal input=nil\r\n(function()\r\n\tlocal _s8_value=((string):stream())\r\n\tinput=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((input):atEnd())\r\nend))() do smalltalk:if_true_false_((((input):upTo_((smalltalk.String):crlf())):includes_((smalltalk.String):lf())),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Compiler,"sourcecode:",0
,function(self,string)
local input=nil
local output=nil
if ((self):isSourcecode_(string))==true then return (string); end;
(function()
	local _s8_value=((string):stream())
	input=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((""):writeStream())
	output=_s8_value
	return _s8_value
end)();
while not ((function()
return ((input):atEnd())
end))() do (output):nextPutAll_((input):nextLine());
smalltalk:if_true_false_(((input):atEnd()),nil,(function()
return ((output):cr())
end)); end;
return ((output):contents());
end
,"S8Steps-private","sourcecode: string\r\n\t\" Private - Returns a string formated as sourcecode. \"\r\n\r\n\t| input output |\r\n\t(self isSourcecode: string) ifTrue: [ ^string ].\r\n\tinput := string stream.\r\n\toutput := '' writeStream.\r\n\t[input atEnd] whileFalse: [\r\n\t\toutput nextPutAll: input nextLine.\r\n\t\tinput atEnd ifFalse: [ output cr ]\r\n\t].\r\n\t^output contents","function(self,string)\r\nlocal input=nil\r\nlocal output=nil\r\nif ((self):isSourcecode_(string))==true then return (string); end;\r\n(function()\r\n\tlocal _s8_value=((string):stream())\r\n\tinput=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\toutput=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((input):atEnd())\r\nend))() do (output):nextPutAll_((input):nextLine());\r\nsmalltalk:if_true_false_(((input):atEnd()),nil,(function()\r\nreturn ((output):cr())\r\nend)); end;\r\nreturn ((output):contents());\r\nend")

smalltalk:bind(smalltalk.Compiler,"scriptForMethod:onError:",0
,function(self,source,aBlock)
local node=nil
return (((function()
(function()
	local _s8_value=((self):parseMethod_((self):sourcecode_(source)))
	node=_s8_value
	return _s8_value
end)();if ((node):isParseFailure())==true then (self):error_(smalltalk:toString_((node))); end;return (node)
end)):on_do_(smalltalk.Error,(function(ex)
return ((aBlock):value_(ex))
end)));
end
,"S8Steps-scripting","scriptForMethod: source onError: aBlock\r\n\t\" Return the compiled script for method with source code or the result of evaluating aBlock with error. \"\r\n\r\n\t| node |\r\n\t^[\tnode := self parseMethod: (self sourcecode: source).\r\n\t\tnode isParseFailure ifTrue: [ self error: node toString ].\r\n\t\tnode\r\n\t] on: Error do: [:ex| aBlock value: ex ] ","function(self,source,aBlock)\r\nlocal node=nil\r\nreturn (((function()\r\n(function()\r\n\tlocal _s8_value=((self):parseMethod_((self):sourcecode_(source)))\r\n\tnode=_s8_value\r\n\treturn _s8_value\r\nend)();if ((node):isParseFailure())==true then (self):error_(smalltalk:toString_((node))); end;return (node)\r\nend)):on_do_(smalltalk.Error,(function(ex)\r\nreturn ((aBlock):value_(ex))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Compiler,"scriptForMethod:",0
,function(self,source)
return ((self):scriptForMethod_onError_(source,(function()
return (nil)
end)));
end
,"S8Steps-scripting","scriptForMethod: source\r\n\t\" Return the compiled script for method with source code (or nil). \"\r\n\r\n\t^self scriptForMethod: source onError: [ nil ] ","function(self,source)\r\nreturn ((self):scriptForMethod_onError_(source,(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.CompilerNode,"isMessageNode",0
,function(self)
return (false);
end
,"S8Steps-testing","isMessageNode\r\n\t\" Returns true if the receiver is a message send. \"\r\n\r\n\t^false ","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.CompilerNode,"isValid",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if not (((self):isEmpty()))==true then (self["@nodes"]):do_((function(each)
return (smalltalk:if_true_false_(((each):isValid()),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end)); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"S8Steps-testing","isValid\r\n\t\" Returns true if the receiver is valid (for simulation). \"\r\n\r\n\tself isEmpty ifFalse: [\r\n\t\tnodes do: [:each| each isValid ifFalse: [ ^false ] ]\r\n\t].\r\n\t^true ","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif not (((self):isEmpty()))==true then (self[\"@nodes\"]):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):isValid()),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend)); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.CompilerNode,"emptyActions:",0
,function(self,actions)
return ((self):note_(smalltalk:object_comma_(("WARNING: Empty actions for "),self)));
end
,"S8Steps-simulating","emptyActions: actions\r\n\t\" The actions taken to evaluate the receiver are empty. \"\r\n\r\n\t^self note: 'WARNING: Empty actions for ' ,self ","function(self,actions)\r\nreturn ((self):note_(smalltalk:object_comma_((\"WARNING: Empty actions for \"),self)));\r\nend")

smalltalk:bind(smalltalk.CompilerNode,"actionsIn:",0
,function(self,aContext)
local result=nil
(function()
	local _s8_value=(((self):nodes()):inject_into_(smalltalk:newArray({}),(function(total,each)
return ((
function(_s8_rec)
	(_s8_rec):addAll_((each):actionsIn_(aContext));
	return ((_s8_rec):yourself())
end
)(total))
end)))
	result=_s8_value
	return _s8_value
end)();
if ((result):isEmpty())==true then (self):emptyActions_(result); end;
return (result);
end
,"S8Steps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext.\r\n\tThe default implementation returns the actions to evaluate the contents of receiver.\r\n\tThis method can be refined by the subclasses.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := self nodes inject: #() into: [:total :each|\r\n\t\ttotal addAll: (each actionsIn: aContext); yourself\r\n\t].\r\n\tresult isEmpty ifTrue: [ self emptyActions: result ].\r\n\t^result","function(self,aContext)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):nodes()):inject_into_(smalltalk:newArray({}),(function(total,each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAll_((each):actionsIn_(aContext));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(total))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((result):isEmpty())==true then (self):emptyActions_(result); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.AssignmentNode,"actionsIn:",0
,function(self,aContext)
return ((smalltalk.Array):with_with_((function(simulator)
return ((simulator):add_in_((self):right(),aContext))
end),(function(simulator)
return (((self):left()):bind_in_((simulator):value(),aContext))
end)));
end
,"S8Steps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext. \"\r\n\r\n\t^Array\r\n\t\twith: [:simulator| simulator add: self right in: aContext ]\r\n\t\twith: [:simulator| self left bind: simulator value in: aContext ] ","function(self,aContext)\r\nreturn ((smalltalk.Array):with_with_((function(simulator)\r\nreturn ((simulator):add_in_((self):right(),aContext))\r\nend),(function(simulator)\r\nreturn (((self):left()):bind_in_((simulator):value(),aContext))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.AssignmentNode,"isValid",0
,function(self)
return (smalltalk:boolean_and_((((self):right()):isValid()),(function()
return (((self):left()):isValid())
end)));
end
,"S8Steps-test","isValid\r\n\t\" Returns true if the receiver is valid (for simulation). \"\r\n\r\n\t^self right isValid and: [ self left isValid ] ","function(self)\r\nreturn (smalltalk:boolean_and_((((self):right()):isValid()),(function()\r\nreturn (((self):left()):isValid())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.DirectiveNode,"isValid",0
,function(self)
return (false);
end
,"S8Steps-test","isValid\r\n\t\" Returns true if the receiver is valid (for simulation). \"\r\n\r\n\t^false ","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.InlineNode,"isValid",0
,function(self)
return (smalltalk:notNil_((self["@nodes"])));
end
,"S8Steps-test","isValid\r\n\t\" Returns true if the receiver is valid (for simulation).\r\n\tActually we do NOT simulate methods with inlined code if not encoded for #s8.\r\n\t\"\r\n\r\n\t^nodes notNil ","function(self)\r\nreturn (smalltalk:notNil_((self[\"@nodes\"])));\r\nend")

smalltalk:bind(smalltalk.MethodNode,"script",0
,function(self)
return (smalltalk:if_true_false_(((self):isValid()),(function()
return (self)
end),nil));
end
,"S8Steps-converting","script\r\n\t\" Returns the receiver capable to be evaluated as a script. \"\r\n\r\n\t^self isValid ifTrue: [ self ]","function(self)\r\nreturn (smalltalk:if_true_false_(((self):isValid()),(function()\r\nreturn (self)\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.MethodNode,"actionsIn:",0
,function(self,aContext)
local result=nil
(function()
	local _s8_value=(smalltalk:superImplementor(smalltalk.MethodNode,"actionsIn_")(self,aContext))
	result=_s8_value
	return _s8_value
end)();
(result):addFirst_((function(simulator)
return ((self):exitBlock_((function(value)
return ((simulator):exit_(value))
end)))
end));
return (result);
end
,"S8Steps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext. \"\r\n\r\n\t| result |\r\n\tresult := super actionsIn: aContext.\r\n\tresult addFirst: [:simulator|\r\n\t\tself exitBlock: [:value| simulator exit: value ].\r\n\t].\r\n\t^result ","function(self,aContext)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:superImplementor(smalltalk.MethodNode,\"actionsIn_\")(self,aContext))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(result):addFirst_((function(simulator)\r\nreturn ((self):exitBlock_((function(value)\r\nreturn ((simulator):exit_(value))\r\nend)))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.MethodNode,"argsIn:",0
,function(self,mth)
return ((mth):arguments());
end
,"S8Steps-native","argsIn: mth\r\n\t\" Private - Return the arguments bound to mth. \"\r\n\r\n\t^mth arguments ","function(self,mth)\r\nreturn ((mth):arguments());\r\nend")

smalltalk:bind(smalltalk.MethodNode,"contextFor:binding:to:",0
,function(self,aReceiver,args,array)
local result=nil
local count=nil
(function()
	local _s8_value=((smalltalk.S8Context):for_(aReceiver))
	result=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((args):size()):min_((array):size()))
	count=_s8_value
	return _s8_value
end)();
(1):to_do_(count,(function(i)
local key=nil
(function()
	local _s8_value=(((args):at_(i)):value())
	key=_s8_value
	return _s8_value
end)();return ((result):at_put_(key,(array):at_(i)))
end));
return (result);
end
,"S8Steps-evaluating","contextFor: aReceiver binding: args to: array\r\n\t\" Private - Returns the context to evaluate the receiver on aReceiver with parameters. \"\r\n\r\n\t| result count |\r\n\tresult := S8Context for: aReceiver.\r\n\tcount := args size min: array size.\r\n\t1 to: count do: [:i| | key |\r\n\t\tkey := (args at: i) value.\r\n\t\tresult at: key put: (array at: i)\r\n\t].\r\n\t^result ","function(self,aReceiver,args,array)\r\nlocal result=nil\r\nlocal count=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.S8Context):for_(aReceiver))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((args):size()):min_((array):size()))\r\n\tcount=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(1):to_do_(count,(function(i)\r\nlocal key=nil\r\n(function()\r\n\tlocal _s8_value=(((args):at_(i)):value())\r\n\tkey=_s8_value\r\n\treturn _s8_value\r\nend)();return ((result):at_put_(key,(array):at_(i)))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.MethodNode,"stepsFor:entering:withArguments:",0
,function(self,aReceiver,aMethod,array)
local ctx=nil
(function()
	local _s8_value=((self):contextFor_binding_to_(aReceiver,(self):argsIn_(aMethod),array))
	ctx=_s8_value
	return _s8_value
end)();
return (((self):actionsIn_(ctx)):collect_((function(each)
return ((smalltalk.SimulationStep):for_doing_in_(self,each,ctx))
end)));
end
,"S8Steps-simulating","stepsFor: aReceiver entering: aMethod withArguments: array\r\n\t\" Returns the steps to evaluate execution of the receiver activating aMethod. \"\r\n\r\n\t| ctx |\r\n\tctx := self contextFor: aReceiver binding: (self argsIn: aMethod) to: array.\r\n\t^(self actionsIn: ctx) collect: [:each|\r\n\t\tSimulationStep for: self doing: each in: ctx\r\n\t]","function(self,aReceiver,aMethod,array)\r\nlocal ctx=nil\r\n(function()\r\n\tlocal _s8_value=((self):contextFor_binding_to_(aReceiver,(self):argsIn_(aMethod),array))\r\n\tctx=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((self):actionsIn_(ctx)):collect_((function(each)\r\nreturn ((smalltalk.SimulationStep):for_doing_in_(self,each,ctx))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.StepOverNode["$klass"],"doing:",0
,function(self,aBlock)
return (((self):new()):initialize_(aBlock));
end
,"instantiation","doing: aBlock\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^self new initialize: aBlock ","function(self,aBlock)\r\nreturn (((self):new()):initialize_(aBlock));\r\nend")

smalltalk:bind(smalltalk.StepOverNode,"initialize:",0
,function(self,anAction)
(function()
	local _s8_value=(anAction)
	self["@action"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initialize: anAction\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\taction := anAction ","function(self,anAction)\r\n(function()\r\n\tlocal _s8_value=(anAction)\r\n\tself[\"@action\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.StepOverNode,"stepsFor:entering:withArguments:",0
,function(self,aReceiver,aMethod,array)
(self):sourceRange_((0):to_((((aMethod):source()):size()):_minus(1)));
return (smalltalk:superImplementor(smalltalk.StepOverNode,"stepsFor_entering_withArguments_")(self,aReceiver,aMethod,array));
end
,"simulating","stepsFor: aReceiver entering: aMethod withArguments: array\r\n\t\" Returns the steps to evaluate execution of the receiver activating aMethod. \"\r\n\r\n\tself sourceRange: (0 to: aMethod source size - 1).\r\n\t^super stepsFor: aReceiver entering: aMethod withArguments: array ","function(self,aReceiver,aMethod,array)\r\n(self):sourceRange_((0):to_((((aMethod):source()):size()):_minus(1)));\r\nreturn (smalltalk:superImplementor(smalltalk.StepOverNode,\"stepsFor_entering_withArguments_\")(self,aReceiver,aMethod,array));\r\nend")

smalltalk:bind(smalltalk.StepOverNode,"contextFor:binding:to:",0
,function(self,aReceiver,args,array)
local result=nil
local count=nil
(function()
	local _s8_value=((smalltalk.S8Context):for_(aReceiver))
	result=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((args):size()):min_((array):size()))
	count=_s8_value
	return _s8_value
end)();
(1):to_do_(count,(function(i)
return ((result):at_put_((args):at_(i),(array):at_(i)))
end));
return (result);
end
,"evaluating","contextFor: aReceiver binding: args to: array\r\n\t\" Returns the context to evaluate the receiver on aReceiver with parameters. \"\r\n\r\n\t| result count |\r\n\tresult := S8Context for: aReceiver.\r\n\tcount := args size min: array size.\r\n\t1 to: count do: [:i| result at: (args at: i) put: (array at: i) ].\r\n\t^result ","function(self,aReceiver,args,array)\r\nlocal result=nil\r\nlocal count=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.S8Context):for_(aReceiver))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((args):size()):min_((array):size()))\r\n\tcount=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(1):to_do_(count,(function(i)\r\nreturn ((result):at_put_((args):at_(i),(array):at_(i)))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.StepOverNode,"argsIn:",0
,function(self,aMethod)
local i=nil
(function()
	local _s8_value=(0)
	i=_s8_value
	return _s8_value
end)();
return ((((aMethod):selector()):asArrayOfSubstringsSeparatedBy_(":")):collect_((function(each)
(function()
	local _s8_value=((i):_plus(1))
	i=_s8_value
	return _s8_value
end)();return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("("),i)),")")),each))
end)));
end
,"native","argsIn: aMethod\r\n\t\" Private - Return the arguments bound to aMethod. \"\r\n\r\n\t| i | i := 0.\r\n\t^(aMethod selector asArrayOfSubstringsSeparatedBy: $:) collect: [:each|\r\n\t\ti := i + 1. $( ,i ,$) ,each\r\n\t] ","function(self,aMethod)\r\nlocal i=nil\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((((aMethod):selector()):asArrayOfSubstringsSeparatedBy_(\":\")):collect_((function(each)\r\n(function()\r\n\tlocal _s8_value=((i):_plus(1))\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"(\"),i)),\")\")),each))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.StepOverNode,"evaluateContentsIn:",0
,function(self,localContext)
if ((self):isEmpty())==true then return ((self["@action"]):evaluateWith_(nil)); end;
return ((self):invalidMessage_("evaluateContentsIn:"));
end
,"evaluating","evaluateContentsIn: localContext\r\n\t\" Private - Returns the result of evaluating the contents of the receiver in local context. \"\r\n\r\n\tself isEmpty ifTrue: [ ^action evaluateWith: nil ].\r\n\t^self invalidMessage: #evaluateContentsIn: ","function(self,localContext)\r\nif ((self):isEmpty())==true then return ((self[\"@action\"]):evaluateWith_(nil)); end;\r\nreturn ((self):invalidMessage_(\"evaluateContentsIn:\"));\r\nend")

smalltalk:bind(smalltalk.StepOverNode,"inject:in:",0
,function(self,simulator,aContext)
if ((self):isEmpty())==true then return ((simulator):add_step_in_(self,(function(simulator)
return ((simulator):value_((self["@action"]):evaluateWith_(simulator)))
end),aContext)); end;
return ((self):invalidMessage_("inject:in:"));
end
,"internal","inject: simulator in: aContext\r\n\t\" Private - Add the steps for evaluation of contents of the receiver in aContext. \"\r\n\r\n\tself isEmpty ifTrue: [\r\n\t\t^simulator add: self\r\n\t\t\tstep: [:simulator| simulator value: (action evaluateWith: simulator) ]\r\n\t\t\tin: aContext\r\n\t].\r\n\t^self invalidMessage: #inject:in: ","function(self,simulator,aContext)\r\nif ((self):isEmpty())==true then return ((simulator):add_step_in_(self,(function(simulator)\r\nreturn ((simulator):value_((self[\"@action\"]):evaluateWith_(simulator)))\r\nend),aContext)); end;\r\nreturn ((self):invalidMessage_(\"inject:in:\"));\r\nend")

smalltalk:bind(smalltalk.StepOverNode,"actionsIn:",0
,function(self,aContext)
return ((smalltalk.Array):with_((function(simulator)
return ((simulator):value_((self["@action"]):value_(simulator)))
end)));
end
,"S8Steps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext. \"\r\n\r\n\t^Array with: [:simulator| simulator value: (action value: simulator) ] ","function(self,aContext)\r\nreturn ((smalltalk.Array):with_((function(simulator)\r\nreturn ((simulator):value_((self[\"@action\"]):value_(simulator)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ReturnNode,"actionsIn:",0
,function(self,aContext)
return ((
function(_s8_rec)
	(_s8_rec):add_((function(simulator)
return ((simulator):return_in_then_(self,aContext,(function()
return ((self["@exitBlock"]):value_((simulator):value()))
end)))
end));
	return ((_s8_rec):yourself())
end
)(smalltalk:superImplementor(smalltalk.ReturnNode,"actionsIn_")(self,aContext)));
end
,"S8Steps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext. \"\r\n\r\n\t^(super actionsIn: aContext)\r\n\t\tadd: [:simulator|\r\n\t\t\tsimulator return: self in: aContext then: [\r\n\t\t\t\texitBlock value: simulator value\r\n\t\t\t]\r\n\t\t];\r\n\t\tyourself ","function(self,aContext)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_((function(simulator)\r\nreturn ((simulator):return_in_then_(self,aContext,(function()\r\nreturn ((self[\"@exitBlock\"]):value_((simulator):value()))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(smalltalk:superImplementor(smalltalk.ReturnNode,\"actionsIn_\")(self,aContext)));\r\nend")

smalltalk:bind(smalltalk.ScopedNode,"inject:in:",0
,function(self,simulator,aContext)
return ((self):inject_in_catch_curtail_finally_(simulator,aContext,nil,nil,nil));
end
,"S8Steps-internal","inject: simulator in: aContext\r\n\t\" Private - Add the steps for evaluation of contents of the receiver in aContext. \"\r\n\r\n\t^self\tinject: simulator in: aContext\r\n\t\tcatch: nil curtail: nil finally: nil ","function(self,simulator,aContext)\r\nreturn ((self):inject_in_catch_curtail_finally_(simulator,aContext,nil,nil,nil));\r\nend")

smalltalk:bind(smalltalk.ScopedNode,"inject:in:catch:curtail:finally:",0
,function(self,simulator,aContext,catcher,curtail,final)
(simulator):addBlock_contents_in_catch_curtail_finally_(self,(self):nodes(),aContext,catcher,curtail,final);
if ((self):isEmpty())==true then return ((simulator):add_step_in_(self,(function()
return ((simulator):value_(nil))
end),aContext)); end;
return (self);
end
,"S8Steps-internal","inject: simulator in: aContext catch: catcher curtail: curtail finally: final\r\n\t\" Private - Add the steps for evaluation of contents of the receiver in aContext. \"\r\n\r\n\tsimulator\r\n\t\taddBlock: self contents: self nodes in: aContext\r\n\t\tcatch: catcher curtail: curtail finally: final.\r\n\tself isEmpty ifTrue: [\r\n\t\t^simulator add: self step: [ simulator value: nil ] in: aContext\r\n\t].","function(self,simulator,aContext,catcher,curtail,final)\r\n(simulator):addBlock_contents_in_catch_curtail_finally_(self,(self):nodes(),aContext,catcher,curtail,final);\r\nif ((self):isEmpty())==true then return ((simulator):add_step_in_(self,(function()\r\nreturn ((simulator):value_(nil))\r\nend),aContext)); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScopedNode,"contextVariables",0
,function(self)
return ((self):implementedBySubclass_("contextVariables"));
end
,"S8Steps-activation","contextVariables\r\n\t\" Private - Returns the variables involved in activation of the receiver. \"\r\n\r\n\t^self implementedBySubclass: #contextVariables ","function(self)\r\nreturn ((self):implementedBySubclass_(\"contextVariables\"));\r\nend")

smalltalk:bind(smalltalk.ScopedNode,"content:actionsIn:",0
,function(self,simulator,aContext)
return ((self):implementedBySubclass_("content:actionsIn:"));
end
,"S8Steps-internal","content: simulator actionsIn: aContext\r\n\t\" Private - Add the steps for evaluation of contents of the receiver in aContext. \"\r\n\r\n\t^self implementedBySubclass: #content:actionsIn: ","function(self,simulator,aContext)\r\nreturn ((self):implementedBySubclass_(\"content:actionsIn:\"));\r\nend")

smalltalk:bind(smalltalk.ScopedNode,"actionsIn:",0
,function(self,aContext)
if ((self):isEmpty())==true then return ((smalltalk.Array):with_((function(simulator)
return ((self):content_actionsIn_(simulator,aContext))
end))); end;
return ((smalltalk.Array):with_((function(simulator)
return ((smalltalk.S8Context):in_clear_do_(aContext,(self):contextVariables(),(function(ctx)
return ((self):content_actionsIn_(simulator,ctx))
end)))
end)));
end
,"S8Steps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext. \"\r\n\r\n\tself isEmpty ifTrue: [\r\n\t\t^Array with: [:simulator| self content: simulator actionsIn: aContext ]\r\n\t].\r\n\t^Array with: [:simulator|\r\n\t\tS8Context\r\n\t\t\tin: aContext clear: self contextVariables\r\n\t\t\tdo: [:ctx| self content: simulator actionsIn: ctx ]\r\n\t] ","function(self,aContext)\r\nif ((self):isEmpty())==true then return ((smalltalk.Array):with_((function(simulator)\r\nreturn ((self):content_actionsIn_(simulator,aContext))\r\nend))); end;\r\nreturn ((smalltalk.Array):with_((function(simulator)\r\nreturn ((smalltalk.S8Context):in_clear_do_(aContext,(self):contextVariables(),(function(ctx)\r\nreturn ((self):content_actionsIn_(simulator,ctx))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.BlockNode,"contextVariables",0
,function(self)
return ((self):parameters());
end
,"bindings","contextVariables\r\n\t\" Private - Returns the variables involved in activation of the receiver. \"\r\n\r\n\t^self parameters ","function(self)\r\nreturn ((self):parameters());\r\nend")

smalltalk:bind(smalltalk.BlockNode,"content:actionsIn:",0
,function(self,simulator,aContext)
local block=nil
(function()
	local _s8_value=((smalltalk.SimulationBlock):for_in_(self,aContext))
	block=_s8_value
	return _s8_value
end)();
return ((simulator):add_step_in_(self,(function()
(block):simulator_(simulator);return ((simulator):value_(block))
end),aContext));
end
,"S8Steps-internal","content: simulator actionsIn: aContext\r\n\t\" Private - Add the steps for evaluation of contents of the receiver in aContext. \"\r\n\r\n\t| block |\r\n\tblock := SimulationBlock for: self in: aContext.\r\n\t^simulator add: self step: [\r\n\t\tblock simulator: simulator.\t\t\r\n\t\tsimulator value: block\r\n\t] in: aContext ","function(self,simulator,aContext)\r\nlocal block=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.SimulationBlock):for_in_(self,aContext))\r\n\tblock=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((simulator):add_step_in_(self,(function()\r\n(block):simulator_(simulator);return ((simulator):value_(block))\r\nend),aContext));\r\nend")

smalltalk:bind(smalltalk.CascadeNode,"isMessageNode",0
,function(self)
return (true);
end
,"S8Steps-query","isMessageNode\r\n\t\" Returns true if the receiver is a message send. \"\r\n\r\n\t^true ","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.CascadeNode,"isValid",0
,function(self)
return (smalltalk:boolean_and_((smalltalk:superImplementor(smalltalk.CascadeNode,"isValid")(self)),(function()
return (((self):receiver()):isValid())
end)));
end
,"S8Steps-test","isValid\r\n\t\" Returns true if the receiver is valid (for simulation). \"\r\n\r\n\t^super isValid and: [ self receiver isValid ] ","function(self)\r\nreturn (smalltalk:boolean_and_((smalltalk:superImplementor(smalltalk.CascadeNode,\"isValid\")(self)),(function()\r\nreturn (((self):receiver()):isValid())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.CascadeNode,"contextVariables",0
,function(self)
return (smalltalk:newArray({}));
end
,"bindings","contextVariables\r\n\t\" Private - Returns the variables involved in activation of the receiver. \"\r\n\r\n\t^#() ","function(self)\r\nreturn (smalltalk:newArray({}));\r\nend")

smalltalk:bind(smalltalk.CascadeNode,"content:actionsIn:",0
,function(self,simulator,aContext)
local head=nil
local tail=nil
(function()
	local _s8_value=(((self):nodes()):collect_((function(each)
return ((each):shallowCopy())
end)))
	tail=_s8_value
	return _s8_value
end)();
if ((tail):isEmpty())==true then return ((self):error_("Empty cascade - Should not happen")); end;
(function()
	local _s8_value=((self):receiver())
	head=_s8_value
	return _s8_value
end)();
return ((simulator):add_steps_in_(self,(smalltalk.Array):with_with_((function()
return ((simulator):add_in_(head,aContext))
end),(function()
local value=nil
local literal=nil
(function()
	local _s8_value=((simulator):value())
	value=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((smalltalk.ValueNode):literal_value_("$rec",value))
	literal=_s8_value
	return _s8_value
end)();(literal):sourceRange_((head):sourceRange());(tail):do_((function(each)
return ((each):receiver_(literal))
end));return ((simulator):addAll_in_(tail,aContext))
end)),aContext));
end
,"S8Steps-internal","content: simulator actionsIn: aContext\r\n\t\" Private - Add the steps for evaluation of contents of the receiver in aContext. \"\r\n\r\n\t| head tail |\r\n\ttail := self nodes collect: [:each| each shallowCopy ].\r\n\ttail isEmpty ifTrue: [\r\n\t\t^self error: 'Empty cascade - Should not happen'\r\n\t].\r\n\thead := self receiver.\r\n\t^simulator add: self steps: (Array\r\n\t\twith: [ simulator add: head in: aContext ]\r\n\t\twith: [ | value literal |\r\n\t\t\tvalue := simulator value.\r\n\t\t\tliteral := ValueNode literal: '$rec' value: value.\r\n\t\t\tliteral sourceRange: head sourceRange.\r\n\t\t\ttail do: [:each| each receiver: literal ].\r\n\t\t\t\" aContext at: '$rec' put: value. \"\r\n\t\t\tsimulator addAll: tail in: aContext\r\n\t\t]) in: aContext ","function(self,simulator,aContext)\r\nlocal head=nil\r\nlocal tail=nil\r\n(function()\r\n\tlocal _s8_value=(((self):nodes()):collect_((function(each)\r\nreturn ((each):shallowCopy())\r\nend)))\r\n\ttail=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((tail):isEmpty())==true then return ((self):error_(\"Empty cascade - Should not happen\")); end;\r\n(function()\r\n\tlocal _s8_value=((self):receiver())\r\n\thead=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((simulator):add_steps_in_(self,(smalltalk.Array):with_with_((function()\r\nreturn ((simulator):add_in_(head,aContext))\r\nend),(function()\r\nlocal value=nil\r\nlocal literal=nil\r\n(function()\r\n\tlocal _s8_value=((simulator):value())\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((smalltalk.ValueNode):literal_value_(\"$rec\",value))\r\n\tliteral=_s8_value\r\n\treturn _s8_value\r\nend)();(literal):sourceRange_((head):sourceRange());(tail):do_((function(each)\r\nreturn ((each):receiver_(literal))\r\nend));return ((simulator):addAll_in_(tail,aContext))\r\nend)),aContext));\r\nend")

smalltalk:bind(smalltalk.SequenceNode,"contextVariables",0
,function(self)
return ((self):temps());
end
,"bindings","contextVariables\r\n\t\" Private - Returns the variables involved in activation of the receiver. \"\r\n\r\n\t^self temps ","function(self)\r\nreturn ((self):temps());\r\nend")

smalltalk:bind(smalltalk.SequenceNode,"content:actionsIn:",0
,function(self,simulator,aContext)
return ((self):inject_in_(simulator,aContext));
end
,"S8Steps-internal","content: simulator actionsIn: aContext\r\n\t\" Private - Add the steps for evaluation of contents of the receiver in aContext. \"\r\n\r\n\t^self inject: simulator in: aContext ","function(self,simulator,aContext)\r\nreturn ((self):inject_in_(simulator,aContext));\r\nend")

smalltalk:bind(smalltalk.ExtendedSequenceNode,"actionsIn:",0
,function(self,aContext)
local result=nil
(function()
	local _s8_value=(((self):directives()):inject_into_(smalltalk:newArray({}),(function(total,each)
return ((
function(_s8_rec)
	(_s8_rec):addAll_((each):actionsIn_(aContext));
	return ((_s8_rec):yourself())
end
)(total))
end)))
	result=_s8_value
	return _s8_value
end)();
(result):addAll_(smalltalk:superImplementor(smalltalk.ExtendedSequenceNode,"actionsIn_")(self,aContext));
return (result);
end
,"S8Steps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext. \"\r\n\r\n\t| result |\r\n\tresult := self directives inject: #() into: [:total :each|\r\n\t\ttotal addAll: (each actionsIn: aContext); yourself\r\n\t].\r\n\tresult addAll: (super actionsIn: aContext).\r\n\t^result","function(self,aContext)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):directives()):inject_into_(smalltalk:newArray({}),(function(total,each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAll_((each):actionsIn_(aContext));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(total))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(result):addAll_(smalltalk:superImplementor(smalltalk.ExtendedSequenceNode,\"actionsIn_\")(self,aContext));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.SendNode,"actionsIn:",0
,function(self,aContext)
return ((smalltalk.Array):with_with_((function(simulator)
return ((simulator):add_in_((self):receiver(),aContext))
end),(function(simulator)
return ((simulator):add_steps_in_(self,(self):steps_in_((simulator):value(),aContext),aContext))
end)));
end
,"S8Steps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext. \"\r\n\r\n\t^Array\r\n\t\twith: [:simulator| simulator add: self receiver in: aContext ]\r\n\t\twith: [:simulator| simulator add: self steps: (self steps: simulator value in: aContext) in: aContext ] ","function(self,aContext)\r\nreturn ((smalltalk.Array):with_with_((function(simulator)\r\nreturn ((simulator):add_in_((self):receiver(),aContext))\r\nend),(function(simulator)\r\nreturn ((simulator):add_steps_in_(self,(self):steps_in_((simulator):value(),aContext),aContext))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SendNode,"steps:in:",0
,function(self,anObject,aContext)
local type=nil
if (((self):receiver()):isOO())==true then (function()
	local _s8_value=("message")
	type=_s8_value
	return _s8_value
end)(); end;
if (((self):receiver()):isSuper())==true then (function()
	local _s8_value=("super")
	type=_s8_value
	return _s8_value
end)(); end;
return ((smalltalk.Array):with_with_((function(simulator)
return ((simulator):collect_all_in_(self,(self):arguments(),aContext))
end),(function(simulator)
local send=nil
(function()
	local _s8_value=((self):steps_toSend_to_withArguments_in_(type,(self):selector(),anObject,(simulator):value(),aContext))
	send=_s8_value
	return _s8_value
end)();return ((simulator):add_steps_in_(self,send,aContext))
end)));
end
,"S8Steps-simulating","steps: anObject in: aContext\r\n\t\" Private - Returns the steps to simulate message sent to anObject in aContext. \"\r\n\r\n\t| type |\r\n\tself receiver isOO ifTrue: [ type := #message ].\r\n\tself receiver isSuper ifTrue: [ type := #super ].\r\n\t^Array\twith: [:simulator| simulator collect: self all: self arguments in: aContext ]\r\n\t\twith: [:simulator| | send |\r\n\t\t\tsend := self\r\n\t\t\t\tsteps: type toSend: self selector\r\n\t\t\t\tto: anObject withArguments: simulator value\r\n\t\t\t\tin: aContext.\r\n\t\t\tsimulator add: self steps: send in: aContext \r\n\t\t] ","function(self,anObject,aContext)\r\nlocal type=nil\r\nif (((self):receiver()):isOO())==true then (function()\r\n\tlocal _s8_value=(\"message\")\r\n\ttype=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif (((self):receiver()):isSuper())==true then (function()\r\n\tlocal _s8_value=(\"super\")\r\n\ttype=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((smalltalk.Array):with_with_((function(simulator)\r\nreturn ((simulator):collect_all_in_(self,(self):arguments(),aContext))\r\nend),(function(simulator)\r\nlocal send=nil\r\n(function()\r\n\tlocal _s8_value=((self):steps_toSend_to_withArguments_in_(type,(self):selector(),anObject,(simulator):value(),aContext))\r\n\tsend=_s8_value\r\n\treturn _s8_value\r\nend)();return ((simulator):add_steps_in_(self,send,aContext))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SendNode,"valuesToSend:to:withArguments:in:",0
,function(self,msg,anObject,values,aContext)
if not (((msg):startsWith_("#")))==true then return (values); end;
return ((values):collect_((function(each)
return (smalltalk:if_true_false_((smalltalk:is_kindOf_((each),(smalltalk.SimulationBlock))),(function()
return ((self):callableOf_(each))
end),(function()
return (each)
end)))
end)));
end
,"S8Steps-sending","valuesToSend: msg to: anObject withArguments: values in: aContext\r\n\t\" Private - Returns the arguments to send msg to anObject. \"\r\n\r\n\t(msg startsWith: $#) ifFalse: [ ^values ].\r\n\t^values collect: [:each|\r\n\t\t(each isKindOf: SimulationBlock)\r\n\t\tifTrue: [ self callableOf: each ]\r\n\t\tifFalse: [ each ]\r\n\t] ","function(self,msg,anObject,values,aContext)\r\nif not (((msg):startsWith_(\"#\")))==true then return (values); end;\r\nreturn ((values):collect_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:is_kindOf_((each),(smalltalk.SimulationBlock))),(function()\r\nreturn ((self):callableOf_(each))\r\nend),(function()\r\nreturn (each)\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SendNode,"steps:toSend:to:withArguments:in:",0
,function(self,type,msg,anObject,objects,aContext)
if (smalltalk:notNil_((((self)["$klass"]):actionToSend_ifAbsent_(msg,(function()
return (nil)
end)))))==true then return ((smalltalk.Array):with_((function(simulator)
return ((simulator):value_((self):send_to_withArguments_in_(msg,anObject,objects,aContext)))
end))); end;
return ((smalltalk.Array):with_((function(simulator)
local cls=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((type),"super")),(function()
return (((((simulator):topFrame()):method()):classField()):superclass())
end),(function()
return ((anObject)["$klass"])
end)))
	cls=_s8_value
	return _s8_value
end)();return ((simulator):activate_message_for_withArguments_(cls,((self)["$klass"]):selectorToSend_(msg),anObject,(self):valuesToSend_to_withArguments_in_(msg,anObject,objects,aContext)))
end)));
end
,"S8Steps-simulating","steps: type toSend: msg to: anObject withArguments: objects in: aContext\r\n\t\" Private - Returns the steps to simulate message sent to anObject in aContext. \"\r\n\r\n\t(self class actionToSend: msg ifAbsent: []) notNil ifTrue: [ \"optimized/native message sent\"\r\n\t\t^Array with: [:simulator|\r\n\t\t\tsimulator value: (self send: msg to: anObject withArguments: objects in: aContext)\r\n\t\t]\r\n\t].\r\n\t^Array with: [:simulator| | cls |\r\n\t\tcls := type = #super\r\n\t\t\tifTrue: [ simulator topFrame method classField superclass ]\r\n\t\t\tifFalse: [ anObject class ].\r\n\t\tsimulator\r\n\t\t\tactivate: cls message: (self class selectorToSend: msg)\r\n\t\t\tfor: anObject withArguments: (self\r\n\t\t\t\tvaluesToSend: msg to: anObject\r\n\t\t\t\twithArguments: objects in: aContext)\r\n\t] ","function(self,type,msg,anObject,objects,aContext)\r\nif (smalltalk:notNil_((((self)[\"$klass\"]):actionToSend_ifAbsent_(msg,(function()\r\nreturn (nil)\r\nend)))))==true then return ((smalltalk.Array):with_((function(simulator)\r\nreturn ((simulator):value_((self):send_to_withArguments_in_(msg,anObject,objects,aContext)))\r\nend))); end;\r\nreturn ((smalltalk.Array):with_((function(simulator)\r\nlocal cls=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((type),\"super\")),(function()\r\nreturn (((((simulator):topFrame()):method()):classField()):superclass())\r\nend),(function()\r\nreturn ((anObject)[\"$klass\"])\r\nend)))\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();return ((simulator):activate_message_for_withArguments_(cls,((self)[\"$klass\"]):selectorToSend_(msg),anObject,(self):valuesToSend_to_withArguments_in_(msg,anObject,objects,aContext)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SendNode,"isMessageNode",0
,function(self)
return (true);
end
,"S8Steps-query","isMessageNode\r\n\t\" Returns true if the receiver is a message send. \"\r\n\r\n\t^true ","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.SendNode,"isValid",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (smalltalk:notNil_(((self):receiver())))==true then smalltalk:if_true_false_(((self["@receiver"]):isValid()),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)); end;
((self):arguments()):do_((function(each)
return (smalltalk:if_true_false_(((each):isValid()),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:superImplementor(smalltalk.SendNode,"isValid")(self))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"S8Steps-test","isValid\r\n\t\" Returns true if the receiver is valid (for simulation). \"\r\n\r\n\tself receiver notNil ifTrue: [ receiver isValid ifFalse: [ ^false ] ].\r\n\tself arguments do: [:each| each isValid ifFalse: [ ^false ] ].\r\n\t^super isValid ","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (smalltalk:notNil_(((self):receiver())))==true then smalltalk:if_true_false_(((self[\"@receiver\"]):isValid()),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)); end;\r\n((self):arguments()):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):isValid()),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:superImplementor(smalltalk.SendNode,\"isValid\")(self))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ValueNode,"actionsIn:",0
,function(self,aContext)
return ((smalltalk.Array):with_((function(simulator)
return ((simulator):value_((self):evaluateIn_(aContext)))
end)));
end
,"S8Steps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext. \"\r\n\r\n\t^Array with: [:simulator|\r\n\t\tsimulator value: (self evaluateIn: aContext)\r\n\t] ","function(self,aContext)\r\nreturn ((smalltalk.Array):with_((function(simulator)\r\nreturn ((simulator):value_((self):evaluateIn_(aContext)))\r\nend)));\r\nend")
