
-- fileIn("s8/library/scripting/ScriptCompiler.st")
smalltalk:addClass("ScriptCompiler",smalltalk.Compiler,smalltalk:newArray({"cache"}),"ScriptCompiler")

smalltalk:addClass("CompiledScript",smalltalk.CompiledMethod,smalltalk:newArray({"args","script","source"}),"ScriptCompiler")

smalltalk:bind(smalltalk.CompiledScript,"args",0
,function(self)
return (self["@args"]);
end
,"accessing","args\r\n\t\" Return the args of the receiver. \"\r\n\r\n\t^args","function(self)\r\nreturn (self[\"@args\"]);\r\nend")

smalltalk:bind(smalltalk.CompiledScript,"args:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@args"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","args: anObject\r\n\t\" Set the args of the receiver. \"\r\n\r\n\targs := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@args\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompiledScript,"script",0
,function(self)
return (self["@script"]);
end
,"accessing","script\r\n\t\" Return the script of the receiver. \"\r\n\r\n\t^script","function(self)\r\nreturn (self[\"@script\"]);\r\nend")

smalltalk:bind(smalltalk.CompiledScript,"script:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@script"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","script: anObject\r\n\t\" Set the script of the receiver. \"\r\n\r\n\tscript := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@script\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompiledScript,"source",0
,function(self)
return (self["@source"]);
end
,"accessing","source\r\n\t\" Return the source of the receiver. \"\r\n\r\n\t^source","function(self)\r\nreturn (self[\"@source\"]);\r\nend")

smalltalk:bind(smalltalk.CompiledScript,"source:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@source"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","source: anObject\r\n\t\" Set the source of the receiver. \"\r\n\r\n\tsource := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@source\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler["$klass"],"constructEventsTriggered",0
,function(self)
return (smalltalk:object_comma_((smalltalk:newArray({"needsScriptFor:", "codeGenerated:", "eval:"})),smalltalk:superImplementor(smalltalk.ScriptCompiler["$klass"],"constructEventsTriggered")(self)));
end
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^#(\t#needsScriptFor:\r\n\t\t#codeGenerated:\r\n\t\t#eval:\r\n\t) ,super constructEventsTriggered","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:newArray({\"needsScriptFor:\", \"codeGenerated:\", \"eval:\"})),smalltalk:superImplementor(smalltalk.ScriptCompiler[\"$klass\"],\"constructEventsTriggered\")(self)));\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler["$klass"],"install",0
,function(self)
(self):install_((self):_gt_gt("scriptCompilerSupport"));
return (self);
end
,"installation","install\r\n\t\" Install the receiver as default Compiler support.\r\n\tNote that effect of changing the compiler is inmediate.\r\n\tDO NOT install if you don't know what you are doing.\r\n\t\"\r\n\r\n\tself install: self >> #scriptCompilerSupport ","function(self)\r\n(self):install_((self):_gt_gt(\"scriptCompilerSupport\"));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler["$klass"],"isInstalled",0
,function(self)
return (smalltalk:isObject_equalTo_((((self):_gt_gt("scriptCompilerSupport")):fn()),((smalltalk.Smalltalk):_gt_gt("compilerSupport")):fn()));
end
,"testing","isInstalled\r\n\t\" Returns true if the receiver is installed as default Compiler support. \"\r\n\r\n\t^(self >> #scriptCompilerSupport) fn = (Smalltalk >> #compilerSupport) fn ","function(self)\r\nreturn (smalltalk:isObject_equalTo_((((self):_gt_gt(\"scriptCompilerSupport\")):fn()),((smalltalk.Smalltalk):_gt_gt(\"compilerSupport\")):fn()));\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler["$klass"],"uninstall",0
,function(self)
(self):install_((self):_gt_gt("s8CompilerSupport"));
return (self);
end
,"installation","uninstall\r\n\t\" Install the default Compiler support. \"\r\n\r\n\tself install: self >> #s8CompilerSupport ","function(self)\r\n(self):install_((self):_gt_gt(\"s8CompilerSupport\"));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler["$klass"],"install:",0
,function(self,support)
local selector=nil
local cm=nil
local code=nil
local src=nil
(function()
	local _s8_value=("compilerSupport")
	selector=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((""):writeStream())
	code=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((support):source()):stream())
	src=_s8_value
	return _s8_value
end)();
(src):nextLine();
if not (((src):atEnd()))==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_(selector);
	return ((_s8_rec):cr())
end
)(code);
(code):nextPutAll_((src):upToEnd()); end;
(function()
	local _s8_value=((smalltalk.Smalltalk):_gt_gt(selector))
	cm=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):source_((code):contents());
	return ((_s8_rec):fn_((support):fn()))
end
)(cm);
((cm):classField()):addCompiledMethod_(cm);
return (self);
end
,"private","install: support\r\n\t\" Private - Install the given compiler support as default Compiler. \"\r\n\r\n\t| selector cm code src |\r\n\tselector := #compilerSupport.\r\n\tcode := '' writeStream.\r\n\tsrc := support source stream.\r\n\tsrc nextLine.\r\n\tsrc atEnd ifFalse: [\r\n\t\tcode nextPutAll: selector; cr.\r\n\t\tcode nextPutAll: src upToEnd\r\n\t].\r\n\r\n\tcm := Smalltalk >> selector.\r\n\tcm source: code contents; fn: support fn.\r\n\tcm classField addCompiledMethod: cm ","function(self,support)\r\nlocal selector=nil\r\nlocal cm=nil\r\nlocal code=nil\r\nlocal src=nil\r\n(function()\r\n\tlocal _s8_value=(\"compilerSupport\")\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((support):source()):stream())\r\n\tsrc=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(src):nextLine();\r\nif not (((src):atEnd()))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(selector);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(code);\r\n(code):nextPutAll_((src):upToEnd()); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):_gt_gt(selector))\r\n\tcm=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):source_((code):contents());\r\n\treturn ((_s8_rec):fn_((support):fn()))\r\nend\r\n)(cm);\r\n((cm):classField()):addCompiledMethod_(cm);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler["$klass"],"evaluationScript",0
,function(self)
return (smalltalk.StepOverScript);
end
,"private","evaluationScript\r\n\t\" Return the support for skipping method execution. \"\r\n\r\n\t^StepOverScript ","function(self)\r\nreturn (smalltalk.StepOverScript);\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler,"s8CompilerSupport",0
,function(self)
return (smalltalk.Compiler);
end
,"installation","s8CompilerSupport\r\n\t\" Return the compiler support for the receiver. \"\r\n\r\n\t^Compiler ","function(self)\r\nreturn (smalltalk.Compiler);\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler,"scriptCompilerSupport",0
,function(self)
return (smalltalk.ScriptCompiler);
end
,"installation","scriptCompilerSupport\r\n\t\" Return the compiler support for the receiver. \"\r\n\r\n\t^ScriptCompiler ","function(self)\r\nreturn (smalltalk.ScriptCompiler);\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler,"cache",0
,function(self)
if (smalltalk:isNil_((self["@cache"])))==true then (function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	self["@cache"]=_s8_value
	return _s8_value
end)(); end;
return (self["@cache"]);
end
,"accessing","cache\r\n\t\" Private - Returns the internal cache. \"\r\n\r\n\tcache isNil ifTrue: [ cache := PoolDictionary new ].\r\n\t^cache","function(self)\r\nif (smalltalk:isNil_((self[\"@cache\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tself[\"@cache\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@cache\"]);\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler,"scriptFor:",0
,function(self,smalltalkExpression)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
(function()
	local _s8_value=(((smalltalk.ScriptParser):for_((self):currentClass())):parse_onError_(smalltalkExpression,(function(ex)
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_((ex):description()))
end
)()
error(_s8Ret_,0)
end)())
end)))
	result=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"private","scriptFor: smalltalkExpression\r\n\t\" Private - Return the script result of parsing expression to be evaluated. \"\r\n\r\n\t| result |\r\n\tresult := (ScriptParser for: self currentClass)\r\n\t\tparse: smalltalkExpression onError: [:ex|\r\n\t\t\t^self error: ex description\r\n\t\t].\r\n\t^result","function(self,smalltalkExpression)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.ScriptParser):for_((self):currentClass())):parse_onError_(smalltalkExpression,(function(ex)\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_((ex):description()))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler,"isSourcecode:",0
,function(self,string)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local input=nil
(function()
	local _s8_value=((string):stream())
	input=_s8_value
	return _s8_value
end)();
while not ((function()
return ((input):atEnd())
end))() do smalltalk:if_true_false_((((input):upTo_((smalltalk.String):crlf())):includes_((smalltalk.String):lf())),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"private","isSourcecode: string\r\n\t\" Private - Returns true if a string is formated as sourcecode. \"\r\n\r\n\t| input |\r\n\tinput := string stream.\r\n\t[input atEnd] whileFalse: [\r\n\t\t((input upTo: String crlf) includes: String lf) ifTrue: [ ^false ]\r\n\t].\r\n\t^true","function(self,string)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal input=nil\r\n(function()\r\n\tlocal _s8_value=((string):stream())\r\n\tinput=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((input):atEnd())\r\nend))() do smalltalk:if_true_false_((((input):upTo_((smalltalk.String):crlf())):includes_((smalltalk.String):lf())),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler,"sourcecode:",0
,function(self,string)
local input=nil
local output=nil
if ((self):isSourcecode_(string))==true then return (string); end;
(function()
	local _s8_value=((string):stream())
	input=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((""):writeStream())
	output=_s8_value
	return _s8_value
end)();
while not ((function()
return ((input):atEnd())
end))() do (output):nextPutAll_((input):nextLine());
smalltalk:if_true_false_(((input):atEnd()),nil,(function()
return ((output):cr())
end)); end;
return ((output):contents());
end
,"private","sourcecode: string\r\n\t\" Private - Returns a string formated as sourcecode. \"\r\n\r\n\t| input output |\r\n\t(self isSourcecode: string) ifTrue: [ ^string ].\r\n\tinput := string stream.\r\n\toutput := '' writeStream.\r\n\t[input atEnd] whileFalse: [\r\n\t\toutput nextPutAll: input nextLine.\r\n\t\tinput atEnd ifFalse: [ output cr ]\r\n\t].\r\n\t^output contents","function(self,string)\r\nlocal input=nil\r\nlocal output=nil\r\nif ((self):isSourcecode_(string))==true then return (string); end;\r\n(function()\r\n\tlocal _s8_value=((string):stream())\r\n\tinput=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\toutput=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((input):atEnd())\r\nend))() do (output):nextPutAll_((input):nextLine());\r\nsmalltalk:if_true_false_(((input):atEnd()),nil,(function()\r\nreturn ((output):cr())\r\nend)); end;\r\nreturn ((output):contents());\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler,"scriptForMethod:onError:",0
,function(self,source,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local method=nil
(function()
	local _s8_value=((smalltalk.CompiledScript):new())
	method=_s8_value
	return _s8_value
end)();
(method):classField_((self):currentClass());
((smalltalk.ScriptParser):for_((self):currentClass())):parse_method_onError_((self):sourcecode_(source),method,(function(ex)
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):value_(ex))
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (method)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"scripting","scriptForMethod: source onError: aBlock\r\n\t\" Return the compiled script for method with source code or the result of evaluating aBlock with error. \"\r\n\r\n\t| method |\r\n\tmethod := CompiledScript new.\r\n\tmethod classField: self currentClass.\r\n\t(ScriptParser for: self currentClass)\r\n\t\tparse: (self sourcecode: source) method: method\r\n\t\tonError: [:ex| ^aBlock value: ex ].\r\n\t^method","function(self,source,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal method=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.CompiledScript):new())\r\n\tmethod=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(method):classField_((self):currentClass());\r\n((smalltalk.ScriptParser):for_((self):currentClass())):parse_method_onError_((self):sourcecode_(source),method,(function(ex)\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):value_(ex))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (method)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler,"scriptForMethod:",0
,function(self,source)
return ((self):scriptForMethod_onError_(source,(function()
return (nil)
end)));
end
,"scripting","scriptForMethod: source\r\n\t\" Return the compiled script for method with source code (or nil). \"\r\n\r\n\t^self scriptForMethod: source onError: [ nil ]","function(self,source)\r\nreturn ((self):scriptForMethod_onError_(source,(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler,"evaluate:in:to:",0
,function(self,smalltalkExpression,aClass,aReceiver)
(self):currentClass_(aClass);
return (((self):scriptFor_(smalltalkExpression)):evaluate_(aReceiver));
end
,"evaluation","evaluate: smalltalkExpression in: aClass to: aReceiver\r\n\t\" Return the result of evaluating the smalltalk expression with aReceiver. \"\r\n\r\n\tself currentClass: aClass.\r\n\t^(self scriptFor: smalltalkExpression)\r\n\t\tevaluate: aReceiver","function(self,smalltalkExpression,aClass,aReceiver)\r\n(self):currentClass_(aClass);\r\nreturn (((self):scriptFor_(smalltalkExpression)):evaluate_(aReceiver));\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler,"compile:",0
,function(self,aString)
local code=nil
(function()
	local _s8_value=(smalltalk:superImplementor(smalltalk.ScriptCompiler,"compile_")(self,aString))
	code=_s8_value
	return _s8_value
end)();
((self):cache()):at_put_("code",code);
(self):triggerEvent_with_("codeGenerated:",code);
return (code);
end
,"private","compile: aString\r\n\t\" Return the native code result of compiling aString for currentClass. \"\r\n\r\n\t| code |\r\n\tcode := super compile: aString.\r\n\tself cache at: #code put: code.\r\n\tself triggerEvent: #codeGenerated: with: code.\r\n\t^code","function(self,aString)\r\nlocal code=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:superImplementor(smalltalk.ScriptCompiler,\"compile_\")(self,aString))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):cache()):at_put_(\"code\",code);\r\n(self):triggerEvent_with_(\"codeGenerated:\",code);\r\nreturn (code);\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler,"basicEval:",0
,function(self,expression)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local default=nil
local script=nil
local code=nil
(function()
	local _s8_value=((function()
return (smalltalk:superImplementor(smalltalk.ScriptCompiler,"eval_")(self,expression))
end))
	default=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((self):cache()):at_ifAbsent_("compiledScript",(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((default):value())
end
)()
error(_s8Ret_,0)
end)())
end)))
	script=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((self):cache()):at_ifAbsent_("code",(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((default):value())
end
)()
error(_s8Ret_,0)
end)())
end)))
	code=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((code),expression))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (script)
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((default):value())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"evaluation","basicEval: expression\r\n\t\" Private - Return the result of evaluating a native expression in global context.\r\n\tNote that we do NOT evaluate the code in case we parsed to a compiled script.\r\n\t\"\r\n\r\n\t| default script code |\r\n\tdefault := [ super eval: expression ].\r\n\tscript := self cache at: #compiledScript ifAbsent: [ ^default value ].\r\n\tcode := self cache at: #code ifAbsent: [ ^default value ].\r\n\tcode = expression ifTrue: [ ^script ].\r\n\t^default value","function(self,expression)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal default=nil\r\nlocal script=nil\r\nlocal code=nil\r\n(function()\r\n\tlocal _s8_value=((function()\r\nreturn (smalltalk:superImplementor(smalltalk.ScriptCompiler,\"eval_\")(self,expression))\r\nend))\r\n\tdefault=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((self):cache()):at_ifAbsent_(\"compiledScript\",(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((default):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tscript=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((self):cache()):at_ifAbsent_(\"code\",(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((default):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((code),expression))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (script)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((default):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler,"eval:",0
,function(self,nativeExpression)
return ((self):triggerEvent_with_ifNotHandled_("eval:",nativeExpression,(function()
return ((self):basicEval_(nativeExpression))
end)));
end
,"evaluation","eval: nativeExpression\r\n\t\" Return the result of evaluating a native expression in global context. \"\r\n\r\n\t^self\ttriggerEvent: #eval: with: nativeExpression\r\n\t\tifNotHandled: [ self basicEval: nativeExpression ]","function(self,nativeExpression)\r\nreturn ((self):triggerEvent_with_ifNotHandled_(\"eval:\",nativeExpression,(function()\r\nreturn ((self):basicEval_(nativeExpression))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ScriptCompiler,"parseMethod:",0
,function(self,aString)
local script=nil
(function()
	local _s8_value=((self):triggerEvent_with_ifNotHandled_("needsScriptFor:",aString,(function()
return ((self):scriptForMethod_(aString))
end)))
	script=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((script)))==true then ((self):cache()):at_put_("compiledScript",script); end;
return (smalltalk:superImplementor(smalltalk.ScriptCompiler,"parseMethod_")(self,aString));
end
,"parsing","parseMethod: aString\r\n\t\" Return the result of parsing aString as a method source code. \"\r\n\r\n\t| script |\r\n\tscript := self\r\n\t\ttriggerEvent: #needsScriptFor: with: aString\r\n\t\tifNotHandled: [ self scriptForMethod: aString ].\r\n\tscript notNil ifTrue: [ self cache at: #compiledScript put: script ].\r\n\t^super parseMethod: aString","function(self,aString)\r\nlocal script=nil\r\n(function()\r\n\tlocal _s8_value=((self):triggerEvent_with_ifNotHandled_(\"needsScriptFor:\",aString,(function()\r\nreturn ((self):scriptForMethod_(aString))\r\nend)))\r\n\tscript=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((script)))==true then ((self):cache()):at_put_(\"compiledScript\",script); end;\r\nreturn (smalltalk:superImplementor(smalltalk.ScriptCompiler,\"parseMethod_\")(self,aString));\r\nend")

smalltalk:bind(smalltalk.CompiledScript,"fn",0
,function(self)
local fn=nil
(function()
	local _s8_value=(smalltalk:superImplementor(smalltalk.CompiledScript,"fn")(self))
	fn=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((fn)))==true then (function()
	local _s8_value=((self["@script"]):nativeImplementationFor_(self))
	fn=_s8_value
	return _s8_value
end)();
(self):fn_(fn); end;
return (fn);
end
,"accessing","fn\r\n\t\" Return the native implementation of the receiver. \"\r\n\r\n\t| fn |\r\n\tfn := super fn.\r\n\tfn isNil ifTrue: [\r\n\t\tfn := script nativeImplementationFor: self.\r\n\t\tself fn: fn.\r\n\t].\r\n\t^fn ","function(self)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:superImplementor(smalltalk.CompiledScript,\"fn\")(self))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((fn)))==true then (function()\r\n\tlocal _s8_value=((self[\"@script\"]):nativeImplementationFor_(self))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):fn_(fn); end;\r\nreturn (fn);\r\nend")

smalltalk:bind(smalltalk.CompiledScript,"exportFor:on:",0
,function(self,anExporter,aStream)
local encoder=nil
local cls=nil
local nClassName=nil
if (smalltalk:isNil_(((self):compiledSource())))==true then return (false); end;
(function()
	local _s8_value=((self):classField())
	cls=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((anExporter):encoderFor_(cls))
	encoder=_s8_value
	return _s8_value
end)();
return ((encoder):export_method_on_(cls,self,aStream));
end
,"export","exportFor: anExporter on: aStream\r\n\t\" Export the native representation of the receiver on to aStream. \"\r\n\r\n\t| encoder cls nClassName |\r\nself compiledSource isNil ifTrue: [\"NIY\" ^false ].\r\n\tcls := self classField.\r\n\tencoder := anExporter encoderFor: cls.\r\n\"ToDo - encode to recompile on first run, with native source equivalent to:\r\n\t[ self recompile. #{this} basicPerform: self selector withArguments: #{arguments} ]\r\n\"\t^encoder export: cls method: self on: aStream ","function(self,anExporter,aStream)\r\nlocal encoder=nil\r\nlocal cls=nil\r\nlocal nClassName=nil\r\nif (smalltalk:isNil_(((self):compiledSource())))==true then return (false); end;\r\n(function()\r\n\tlocal _s8_value=((self):classField())\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((anExporter):encoderFor_(cls))\r\n\tencoder=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((encoder):export_method_on_(cls,self,aStream));\r\nend")
