
-- fileIn("s8/library/scripting/ScriptSteps.st")
smalltalk:bind(smalltalk.CompiledScript,"compiledScript",0
,function(self)
return (self);
end
,"ScriptSteps-simulating","compiledScript\r\n\t\" Returns the (compiled)script to execute when simulating the receiver. \"\r\n\r\n\t^self ","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Script,"stepsFor:entering:withArguments:",0
,function(self,aReceiver,aMethod,array)
local ctx=nil
(function()
	local _s8_value=((self):contextFor_binding_to_(aReceiver,(self):argsIn_(aMethod),array))
	ctx=_s8_value
	return _s8_value
end)();
return (((self):actionsIn_(ctx)):collect_((function(each)
return ((smalltalk.SimulationStep):for_doing_in_(self,each,ctx))
end)));
end
,"ScriptSteps-simulating","stepsFor: aReceiver entering: aMethod withArguments: array\r\n\t\" Returns the steps to evaluate execution of the receiver activating aMethod. \"\r\n\r\n\t| ctx |\r\n\tctx := self contextFor: aReceiver binding: (self argsIn: aMethod) to: array.\r\n\t^(self actionsIn: ctx) collect: [:each|\r\n\t\tSimulationStep for: self doing: each in: ctx\r\n\t]","function(self,aReceiver,aMethod,array)\r\nlocal ctx=nil\r\n(function()\r\n\tlocal _s8_value=((self):contextFor_binding_to_(aReceiver,(self):argsIn_(aMethod),array))\r\n\tctx=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((self):actionsIn_(ctx)):collect_((function(each)\r\nreturn ((smalltalk.SimulationStep):for_doing_in_(self,each,ctx))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ParseNode,"actionsIn:",0
,function(self,aContext)
return ((smalltalk.Array):with_((function()
return ((self):evaluateIn_(aContext))
end)));
end
,"ScriptSteps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext.\r\n\tThe default implementation will evaluate the receiver in a single step.\r\n\tThis method can be refined by the subclasses.\r\n\t\"\r\n\r\n\t^Array with: [ self evaluateIn: aContext ] ","function(self,aContext)\r\nreturn ((smalltalk.Array):with_((function()\r\nreturn ((self):evaluateIn_(aContext))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Script,"actionsIn:",0
,function(self,aContext)
local result=nil
(function()
	local _s8_value=(smalltalk:superImplementor(smalltalk.Script,"actionsIn_")(self,aContext))
	result=_s8_value
	return _s8_value
end)();
(result):addFirst_((function(simulator)
return ((self):exitBlock_((function(value)
return ((simulator):exit_(value))
end)))
end));
return (result);
end
,"ScriptSteps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext. \"\r\n\r\n\t| result |\r\n\tresult := super actionsIn: aContext.\r\n\tresult addFirst: [:simulator|\r\n\t\tself exitBlock: [:value| simulator exit: value ]\r\n\t].\r\n\t^result ","function(self,aContext)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:superImplementor(smalltalk.Script,\"actionsIn_\")(self,aContext))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(result):addFirst_((function(simulator)\r\nreturn ((self):exitBlock_((function(value)\r\nreturn ((simulator):exit_(value))\r\nend)))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"inject:in:",0
,function(self,simulator,aContext)
return ((self):inject_in_catch_curtail_finally_(simulator,aContext,nil,nil,nil));
end
,"ScriptSteps-internal","inject: simulator in: aContext\r\n\t\" Private - Add the steps for evaluation of contents of the receiver in aContext. \"\r\n\r\n\t^self\tinject: simulator in: aContext\r\n\t\tcatch: nil curtail: nil finally: nil ","function(self,simulator,aContext)\r\nreturn ((self):inject_in_catch_curtail_finally_(simulator,aContext,nil,nil,nil));\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"inject:in:catch:curtail:finally:",0
,function(self,simulator,aContext,catcher,curtail,final)
(simulator):addBlock_contents_in_catch_curtail_finally_(self,(self):statements(),aContext,catcher,curtail,final);
if ((self):isEmpty())==true then return ((simulator):add_step_in_(self,(function()
return ((simulator):value_(nil))
end),aContext)); end;
return (self);
end
,"ScriptSteps-internal","inject: simulator in: aContext catch: catcher curtail: curtail finally: final\r\n\t\" Private - Add the steps for evaluation of contents of the receiver in aContext. \"\r\n\r\n\tsimulator\r\n\t\taddBlock: self contents: self statements in: aContext\r\n\t\tcatch: catcher curtail: curtail finally: final.\r\n\tself isEmpty ifTrue: [\r\n\t\t^simulator add: self step: [ simulator value: nil ] in: aContext\r\n\t].","function(self,simulator,aContext,catcher,curtail,final)\r\n(simulator):addBlock_contents_in_catch_curtail_finally_(self,(self):statements(),aContext,catcher,curtail,final);\r\nif ((self):isEmpty())==true then return ((simulator):add_step_in_(self,(function()\r\nreturn ((simulator):value_(nil))\r\nend),aContext)); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"content:actionsIn:",0
,function(self,simulator,aContext)
return ((self):inject_in_(simulator,aContext));
end
,"ScriptSteps-internal","content: simulator actionsIn: aContext\r\n\t\" Private - Add the steps for evaluation of contents of the receiver in aContext. \"\r\n\r\n\t^self inject: simulator in: aContext ","function(self,simulator,aContext)\r\nreturn ((self):inject_in_(simulator,aContext));\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"actionsIn:",0
,function(self,aContext)
if ((self):isEmpty())==true then return ((smalltalk.Array):with_((function(simulator)
return ((self):content_actionsIn_(simulator,aContext))
end))); end;
return ((smalltalk.Array):with_((function(simulator)
return ((smalltalk.S8Context):in_clear_do_(aContext,(self):contextVariables(),(function(ctx)
return ((self):content_actionsIn_(simulator,ctx))
end)))
end)));
end
,"ScriptSteps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext. \"\r\n\r\n\tself isEmpty ifTrue: [\r\n\t\t^Array with: [:simulator| self content: simulator actionsIn: aContext ]\r\n\t].\r\n\t^Array\twith: [:simulator|\r\n\t\t\tS8Context\r\n\t\t\t\tin: aContext clear: self contextVariables\r\n\t\t\t\tdo: [:ctx| self content: simulator actionsIn: ctx ]\r\n\t\t] ","function(self,aContext)\r\nif ((self):isEmpty())==true then return ((smalltalk.Array):with_((function(simulator)\r\nreturn ((self):content_actionsIn_(simulator,aContext))\r\nend))); end;\r\nreturn ((smalltalk.Array):with_((function(simulator)\r\nreturn ((smalltalk.S8Context):in_clear_do_(aContext,(self):contextVariables(),(function(ctx)\r\nreturn ((self):content_actionsIn_(simulator,ctx))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.BlockClosureNode,"content:actionsIn:",0
,function(self,simulator,aContext)
local block=nil
(function()
	local _s8_value=((smalltalk.SimulationBlock):for_in_(self,aContext))
	block=_s8_value
	return _s8_value
end)();
return ((simulator):add_step_in_(self,(function()
(block):simulator_(simulator);return ((simulator):value_(block))
end),aContext));
end
,"ScriptSteps-internal","content: simulator actionsIn: aContext\r\n\t\" Private - Add the steps for evaluation of contents of the receiver in aContext. \"\r\n\r\n\t| block |\r\n\tblock := SimulationBlock for: self in: aContext.\r\n\t^simulator add: self step: [\r\n\t\tblock simulator: simulator.\t\t\r\n\t\tsimulator value: block\r\n\t] in: aContext ","function(self,simulator,aContext)\r\nlocal block=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.SimulationBlock):for_in_(self,aContext))\r\n\tblock=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((simulator):add_step_in_(self,(function()\r\n(block):simulator_(simulator);return ((simulator):value_(block))\r\nend),aContext));\r\nend")

smalltalk:bind(smalltalk.CascadedMessageNode,"content:actionsIn:",0
,function(self,simulator,aContext)
local head=nil
local tail=nil
(function()
	local _s8_value=(((self):statements()):collect_((function(each)
return ((each):shallowCopy())
end)))
	tail=_s8_value
	return _s8_value
end)();
if ((tail):isEmpty())==true then return ((self):error_("Empty cascade - Should not happen")); end;
(function()
	local _s8_value=(((tail):first()):receiver())
	head=_s8_value
	return _s8_value
end)();
return ((simulator):add_steps_in_(self,(smalltalk.Array):with_with_((function()
return ((simulator):add_in_(head,aContext))
end),(function()
local value=nil
local literal=nil
(function()
	local _s8_value=((simulator):value())
	value=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((smalltalk.ParseLiteral):sourceRange_value_((head):sourceRange(),value))
	literal=_s8_value
	return _s8_value
end)();(tail):do_((function(each)
return ((each):receiver_(literal))
end));return ((simulator):addAll_in_(tail,aContext))
end)),aContext));
end
,"ScriptSteps-internal","content: simulator actionsIn: aContext\r\n\t\" Private - Add the steps for evaluation of contents of the receiver in aContext. \"\r\n\r\n\t| head tail |\r\n\ttail := self statements collect: [:each| each shallowCopy ].\r\n\ttail isEmpty ifTrue: [\r\n\t\t^self error: 'Empty cascade - Should not happen'\r\n\t].\r\n\thead := tail first receiver.\r\n\t^simulator add: self steps: (Array\r\n\t\twith: [ simulator add: head in: aContext ]\r\n\t\twith: [ | value literal |\r\n\t\t\tvalue := simulator value.\r\n\t\t\tliteral := ParseLiteral\r\n\t\t\t\tsourceRange: head sourceRange\r\n\t\t\t\tvalue: value.\r\n\t\t\ttail do: [:each| each receiver: literal ].\r\n\t\t\t\" aContext at: '$rec' put: value. \"\r\n\t\t\tsimulator addAll: tail in: aContext\r\n\t\t]) in: aContext ","function(self,simulator,aContext)\r\nlocal head=nil\r\nlocal tail=nil\r\n(function()\r\n\tlocal _s8_value=(((self):statements()):collect_((function(each)\r\nreturn ((each):shallowCopy())\r\nend)))\r\n\ttail=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((tail):isEmpty())==true then return ((self):error_(\"Empty cascade - Should not happen\")); end;\r\n(function()\r\n\tlocal _s8_value=(((tail):first()):receiver())\r\n\thead=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((simulator):add_steps_in_(self,(smalltalk.Array):with_with_((function()\r\nreturn ((simulator):add_in_(head,aContext))\r\nend),(function()\r\nlocal value=nil\r\nlocal literal=nil\r\n(function()\r\n\tlocal _s8_value=((simulator):value())\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((smalltalk.ParseLiteral):sourceRange_value_((head):sourceRange(),value))\r\n\tliteral=_s8_value\r\n\treturn _s8_value\r\nend)();(tail):do_((function(each)\r\nreturn ((each):receiver_(literal))\r\nend));return ((simulator):addAll_in_(tail,aContext))\r\nend)),aContext));\r\nend")

smalltalk:bind(smalltalk.ParseVariable,"actionsIn:",0
,function(self,aContext)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):with_((function(simulator)
return ((simulator):value_((self):valueIn_(aContext)))
end)))
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((self["@indices"])))==true then (result):add_((function(simulator)
return ((simulator):value_((self):index_in_((simulator):value(),aContext)))
end)); end;
return (result);
end
,"ScriptSteps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext. \"\r\n\r\n\t| result |\r\n\tresult := Array with: [:simulator| simulator value: (self valueIn: aContext) ].\r\n\tindices notNil ifTrue: [\r\n\t\tresult add: [:simulator| simulator value: (self index: simulator value in: aContext) ]\r\n\t].\r\n\t^result ","function(self,aContext)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_((function(simulator)\r\nreturn ((simulator):value_((self):valueIn_(aContext)))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((self[\"@indices\"])))==true then (result):add_((function(simulator)\r\nreturn ((simulator):value_((self):index_in_((simulator):value(),aContext)))\r\nend)); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.MethodReturnNode,"actionsIn:",0
,function(self,aContext)
return ((smalltalk.Array):with_with_((function(simulator)
return ((simulator):add_in_((self):expression(),aContext))
end),(function(simulator)
return ((simulator):return_in_then_(self,aContext,(function()
return ((self["@exitBlock"]):value_((simulator):value()))
end)))
end)));
end
,"ScriptSteps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext. \"\r\n\r\n\t^Array\r\n\t\twith: [:simulator| simulator add: self expression in: aContext ]\r\n\t\twith: [:simulator|\r\n\t\t\tsimulator return: self in: aContext then: [\r\n\t\t\t\texitBlock value: simulator value\r\n\t\t\t]\r\n\t\t] ","function(self,aContext)\r\nreturn ((smalltalk.Array):with_with_((function(simulator)\r\nreturn ((simulator):add_in_((self):expression(),aContext))\r\nend),(function(simulator)\r\nreturn ((simulator):return_in_then_(self,aContext,(function()\r\nreturn ((self[\"@exitBlock\"]):value_((simulator):value()))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.AssignNode,"actionsIn:",0
,function(self,aContext)
return ((smalltalk.Array):with_with_((function(simulator)
return ((simulator):add_in_((self):expression(),aContext))
end),(function(simulator)
return (((self):variable()):bind_in_((simulator):value(),aContext))
end)));
end
,"ScriptSteps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext. \"\r\n\r\n\t^Array\r\n\t\twith: [:simulator| simulator add: self expression in: aContext ]\r\n\t\twith: [:simulator| self variable bind: simulator value in: aContext ] ","function(self,aContext)\r\nreturn ((smalltalk.Array):with_with_((function(simulator)\r\nreturn ((simulator):add_in_((self):expression(),aContext))\r\nend),(function(simulator)\r\nreturn (((self):variable()):bind_in_((simulator):value(),aContext))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.MessageNode,"actionsIn:",0
,function(self,aContext)
return ((smalltalk.Array):with_with_((function(simulator)
return ((simulator):add_in_((self):receiver(),aContext))
end),(function(simulator)
return ((simulator):add_steps_in_(self,(self):steps_in_((simulator):value(),aContext),aContext))
end)));
end
,"ScriptSteps-simulating","actionsIn: aContext\r\n\t\" Returns the steps to evaluate while simulating execution of the receiver in aContext. \"\r\n\r\n\t^Array\r\n\t\twith: [:simulator| simulator add: self receiver in: aContext ]\r\n\t\twith: [:simulator| simulator add: self steps: (self steps: simulator value in: aContext) in: aContext ] ","function(self,aContext)\r\nreturn ((smalltalk.Array):with_with_((function(simulator)\r\nreturn ((simulator):add_in_((self):receiver(),aContext))\r\nend),(function(simulator)\r\nreturn ((simulator):add_steps_in_(self,(self):steps_in_((simulator):value(),aContext),aContext))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.MessageNode,"steps:in:",0
,function(self,anObject,aContext)
local sender=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:boolean_or_((((self):receiver()):isSuper()),(function()
return (smalltalk:booleanNot_((((self):receiver()):isOO())))
end))),(function()
return ((self):receiver())
end),(function()
return (self)
end)))
	sender=_s8_value
	return _s8_value
end)();
return ((smalltalk.Array):with_with_((function(simulator)
return ((simulator):collect_all_in_(self,(self):args(),aContext))
end),(function(simulator)
local send=nil
(function()
	local _s8_value=((sender):stepsToSend_to_withArguments_in_((self):selector(),anObject,(simulator):value(),aContext))
	send=_s8_value
	return _s8_value
end)();return ((simulator):add_steps_in_(self,send,aContext))
end)));
end
,"ScriptSteps-simulating","steps: anObject in: aContext\r\n\t\" Private - Returns the steps to simulate message sent to anObject in aContext. \"\r\n\r\n\t| sender |\r\n\tsender := (self receiver isSuper or: [ self receiver isOO not ])\r\n\t\tifTrue: [ self receiver ] ifFalse: [ self ].\r\n\t^Array\twith: [:simulator| simulator collect: self all: self args in: aContext ]\r\n\t\twith: [:simulator| | send |\r\n\t\t\tsend := sender\r\n\t\t\t\tstepsToSend: self selector\r\n\t\t\t\tto: anObject withArguments: simulator value\r\n\t\t\t\tin: aContext.\r\n\t\t\tsimulator add: self steps: send in: aContext \r\n\t\t] ","function(self,anObject,aContext)\r\nlocal sender=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:boolean_or_((((self):receiver()):isSuper()),(function()\r\nreturn (smalltalk:booleanNot_((((self):receiver()):isOO())))\r\nend))),(function()\r\nreturn ((self):receiver())\r\nend),(function()\r\nreturn (self)\r\nend)))\r\n\tsender=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((smalltalk.Array):with_with_((function(simulator)\r\nreturn ((simulator):collect_all_in_(self,(self):args(),aContext))\r\nend),(function(simulator)\r\nlocal send=nil\r\n(function()\r\n\tlocal _s8_value=((sender):stepsToSend_to_withArguments_in_((self):selector(),anObject,(simulator):value(),aContext))\r\n\tsend=_s8_value\r\n\treturn _s8_value\r\nend)();return ((simulator):add_steps_in_(self,send,aContext))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.MessageNode,"stepsToSend:to:withArguments:in:",0
,function(self,msg,anObject,objects,aContext)
if (smalltalk:notNil_((((self)["$klass"]):actionToSend_ifAbsent_(msg,(function()
return (nil)
end)))))==true then return ((smalltalk.Array):with_((function(simulator)
return ((simulator):value_((self):send_to_withArguments_in_(msg,anObject,objects,aContext)))
end))); end;
return ((smalltalk.Array):with_((function(simulator)
return ((simulator):activate_message_for_withArguments_((anObject)["$klass"],msg,anObject,objects))
end)));
end
,"ScriptSteps-simulating","stepsToSend: msg to: anObject withArguments: objects in: aContext\r\n\t\" Private - Returns the steps to simulate message sent to anObject in aContext. \"\r\n\r\n\t(self class actionToSend: msg ifAbsent: []) notNil ifTrue: [ \"optimized/native message sent\"\r\n\t\t^Array with: [:simulator|\r\n\t\t\tsimulator value: (self send: msg to: anObject withArguments: objects in: aContext)\r\n\t\t]\r\n\t].\r\n\t^Array with: [:simulator|\r\n\t\tsimulator\r\n\t\t\tactivate: anObject class message: msg\r\n\t\t\tfor: anObject withArguments: objects\r\n\t] ","function(self,msg,anObject,objects,aContext)\r\nif (smalltalk:notNil_((((self)[\"$klass\"]):actionToSend_ifAbsent_(msg,(function()\r\nreturn (nil)\r\nend)))))==true then return ((smalltalk.Array):with_((function(simulator)\r\nreturn ((simulator):value_((self):send_to_withArguments_in_(msg,anObject,objects,aContext)))\r\nend))); end;\r\nreturn ((smalltalk.Array):with_((function(simulator)\r\nreturn ((simulator):activate_message_for_withArguments_((anObject)[\"$klass\"],msg,anObject,objects))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeMessageNode,"stepsToSend:to:withArguments:in:",0
,function(self,msg,anObject,values,aContext)
return ((smalltalk.Array):with_((function(simulator)
return ((simulator):value_((self):send_to_withArguments_in_(msg,anObject,values,aContext)))
end)));
end
,"ScriptSteps-simulating","stepsToSend: msg to: anObject withArguments: values in: aContext\r\n\t\" Private - Returns the steps to simulate message sent to anObject in aContext. \"\r\n\r\n\t^Array with: [:simulator|\r\n\t\tsimulator value: (self\r\n\t\t\tsend: msg to: anObject\r\n\t\t\twithArguments: values in: aContext)\r\n\t] ","function(self,msg,anObject,values,aContext)\r\nreturn ((smalltalk.Array):with_((function(simulator)\r\nreturn ((simulator):value_((self):send_to_withArguments_in_(msg,anObject,values,aContext)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ParseSuper,"stepsToSend:to:withArguments:in:",0
,function(self,msg,anObject,values,aContext)
return ((smalltalk.Array):with_((function(simulator)
local mth=nil
local cls=nil
(function()
	local _s8_value=((self["@implementor"]):superclass())
	cls=_s8_value
	return _s8_value
end)();if (smalltalk:notNil_((cls)))==true then (function()
	local _s8_value=((cls):_gt_gt_gt(msg))
	mth=_s8_value
	return _s8_value
end)(); end;return (smalltalk:if_true_false_((smalltalk:isNil_((mth))),(function()
return ((simulator):activate_message_for_withArguments_((self["@implementor"])["$klass"],"missingImplementorFor:",self["@implementor"],(smalltalk.Array):with_(msg)))
end),(function()
return ((simulator):activate_message_for_withArguments_(cls,msg,anObject,values))
end)))
end)));
end
,"ScriptSteps-simulating","stepsToSend: msg to: anObject withArguments: values in: aContext\r\n\t\" Private - Returns the steps to simulate message sent to anObject in aContext. \"\r\n\r\n\t^Array with: [:simulator| | mth cls |\r\n\t\tcls := implementor superclass.\r\n\t\tcls notNil ifTrue: [ mth := cls >>> msg ].\r\n\t\tmth isNil ifTrue: [\r\n\t\t\tsimulator\r\n\t\t\t\tactivate: implementor class message: #missingImplementorFor:\r\n\t\t\t\tfor: implementor withArguments: (Array with: msg)\r\n\t\t] ifFalse: [\r\n\t\t\tsimulator\r\n\t\t\t\tactivate: cls message: msg\r\n\t\t\t\tfor: anObject withArguments: values\r\n\t\t]\r\n\t] ","function(self,msg,anObject,values,aContext)\r\nreturn ((smalltalk.Array):with_((function(simulator)\r\nlocal mth=nil\r\nlocal cls=nil\r\n(function()\r\n\tlocal _s8_value=((self[\"@implementor\"]):superclass())\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:notNil_((cls)))==true then (function()\r\n\tlocal _s8_value=((cls):_gt_gt_gt(msg))\r\n\tmth=_s8_value\r\n\treturn _s8_value\r\nend)(); end;return (smalltalk:if_true_false_((smalltalk:isNil_((mth))),(function()\r\nreturn ((simulator):activate_message_for_withArguments_((self[\"@implementor\"])[\"$klass\"],\"missingImplementorFor:\",self[\"@implementor\"],(smalltalk.Array):with_(msg)))\r\nend),(function()\r\nreturn ((simulator):activate_message_for_withArguments_(cls,msg,anObject,values))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ParseNoReceiver,"stepsToSend:to:withArguments:in:",0
,function(self,msg,anObject,values,aContext)
return ((smalltalk.Array):with_((function(simulator)
return ((simulator):value_((self):send_to_withArguments_in_(msg,anObject,values,aContext)))
end)));
end
,"ScriptSteps-simulating","stepsToSend: msg to: anObject withArguments: values in: aContext\r\n\t\" Private - Returns the steps to simulate message sent to anObject in aContext. \"\r\n\r\n\t^Array with: [:simulator|\r\n\t\tsimulator value: (self send: msg to: anObject withArguments: values in: aContext)\r\n\t] ","function(self,msg,anObject,values,aContext)\r\nreturn ((smalltalk.Array):with_((function(simulator)\r\nreturn ((simulator):value_((self):send_to_withArguments_in_(msg,anObject,values,aContext)))\r\nend)));\r\nend")
