
-- fileIn("s8/library/swiki/swiki.st")
smalltalk:addClass("SwikiCodeRobot",smalltalk.EventManager,smalltalk:newArray({"options","categories","loader","verbose","deferred","aborted","currentPages","chunkStream"}),"swiki")
smalltalk.SwikiCodeRobot["$classVariableNames"]="Fetch"

smalltalk.SwikiCodeRobot["$comment"]="\r\n\tA robot walking swiki pages.\r\n\tThe default behavior will select pages in the swiki by category,\r\n\t sort the pages and evaluate/process code chunks in the pages.\r\n\tIt can be used for testing, API validation, etc.\r\n\tSee pages in s8-media swiki for more information.\r\n\tUse cases:\r\n\t\t(SwikiCodeRobot @ #test) process: #s8-media tagged: #metatest\r\n\t\t(SwikiCodeRobot @ #api) process: #s8-media tagged: #( #apple #WebKit )\r\n"

smalltalk:bind(smalltalk.SwikiCodeRobot,"initializeOptions",0
,function(self)
(function()
	local _s8_value=((self):defaultOptions())
	self["@options"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeOptions\r\n\t\" Private - Initialize the options of the receiver. \"\r\n\r\n\toptions := self defaultOptions","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):defaultOptions())\r\n\tself[\"@options\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"options",0
,function(self)
if (smalltalk:isNil_((self["@options"])))==true then (self):initializeOptions(); end;
return (self["@options"]);
end
,"accessing","options\r\n\t\" Return the options of the receiver. \"\r\n\r\n\toptions isNil ifTrue: [ self initializeOptions ].\r\n\t^options","function(self)\r\nif (smalltalk:isNil_((self[\"@options\"])))==true then (self):initializeOptions(); end;\r\nreturn (self[\"@options\"]);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"options:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@options"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","options: anObject\r\n\t\" Set the options of the receiver. \"\r\n\r\n\toptions := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@options\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"initializeCategories",0
,function(self)
(function()
	local _s8_value=((self):defaultCategories())
	self["@categories"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeCategories\r\n\t\" Private - Initialize the categories of the receiver. \"\r\n\r\n\tcategories := self defaultCategories","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):defaultCategories())\r\n\tself[\"@categories\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"categories",0
,function(self)
if (smalltalk:isNil_((self["@categories"])))==true then (self):initializeCategories(); end;
return (self["@categories"]);
end
,"accessing","categories\r\n\t\" Return the categories of the receiver. \"\r\n\r\n\tcategories isNil ifTrue: [ self initializeCategories ].\r\n\t^categories","function(self)\r\nif (smalltalk:isNil_((self[\"@categories\"])))==true then (self):initializeCategories(); end;\r\nreturn (self[\"@categories\"]);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"categories:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@categories"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","categories: anObject\r\n\t\" Set the categories of the receiver. \"\r\n\r\n\tcategories := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@categories\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"initializeVerbose",0
,function(self)
(function()
	local _s8_value=(true)
	self["@verbose"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeVerbose\r\n\t\" Private - Initialize the verbose of the receiver. \"\r\n\r\n\tverbose := true","function(self)\r\n(function()\r\n\tlocal _s8_value=(true)\r\n\tself[\"@verbose\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"verbose",0
,function(self)
if (smalltalk:isNil_((self["@verbose"])))==true then (self):initializeVerbose(); end;
return (self["@verbose"]);
end
,"accessing","verbose\r\n\t\" Return the verbose of the receiver. \"\r\n\r\n\tverbose isNil ifTrue: [ self initializeVerbose ].\r\n\t^verbose","function(self)\r\nif (smalltalk:isNil_((self[\"@verbose\"])))==true then (self):initializeVerbose(); end;\r\nreturn (self[\"@verbose\"]);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"verbose:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@verbose"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","verbose: anObject\r\n\t\" Set the verbose of the receiver. \"\r\n\r\n\tverbose := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@verbose\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"initializeDeferred",0
,function(self)
(function()
	local _s8_value=((self):defaultDeferred())
	self["@deferred"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeDeferred\r\n\t\" Private - Initialize the deferred of the receiver. \"\r\n\r\n\tdeferred := self defaultDeferred","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):defaultDeferred())\r\n\tself[\"@deferred\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"deferred",0
,function(self)
if (smalltalk:isNil_((self["@deferred"])))==true then (self):initializeDeferred(); end;
return (self["@deferred"]);
end
,"accessing","deferred\r\n\t\" Return the deferred of the receiver. \"\r\n\r\n\tdeferred isNil ifTrue: [ self initializeDeferred ].\r\n\t^deferred","function(self)\r\nif (smalltalk:isNil_((self[\"@deferred\"])))==true then (self):initializeDeferred(); end;\r\nreturn (self[\"@deferred\"]);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"deferred:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@deferred"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","deferred: anObject\r\n\t\" Set the deferred of the receiver. \"\r\n\r\n\tdeferred := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@deferred\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"initializeAborted",0
,function(self)
(function()
	local _s8_value=(false)
	self["@aborted"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeAborted\r\n\t\" Private - Initialize the aborted of the receiver. \"\r\n\r\n\taborted := false","function(self)\r\n(function()\r\n\tlocal _s8_value=(false)\r\n\tself[\"@aborted\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"aborted",0
,function(self)
if (smalltalk:isNil_((self["@aborted"])))==true then (self):initializeAborted(); end;
return (self["@aborted"]);
end
,"accessing","aborted\r\n\t\" Return the aborted of the receiver. \"\r\n\r\n\taborted isNil ifTrue: [ self initializeAborted ].\r\n\t^aborted","function(self)\r\nif (smalltalk:isNil_((self[\"@aborted\"])))==true then (self):initializeAborted(); end;\r\nreturn (self[\"@aborted\"]);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"aborted:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@aborted"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","aborted: anObject\r\n\t\" Set the aborted of the receiver. \"\r\n\r\n\taborted := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@aborted\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot["$klass"],"fetch:",0
,function(self,aBlock)
smalltalk.SwikiCodeRobot:classVariableAt_put_("Fetch",aBlock);
return (self);
end
,"constants","fetch: aBlock\r\n\t\" Set the fetch block to get contents.\r\n\taBlock will be a 2 arguments block:\r\n\t\t- the URL to access\r\n\t\t- the action to perform whith contents)\r\n\tNote that fetch block will set the robot to deferred mode.\r\n\t\"\r\n\r\n\tFetch := aBlock","function(self,aBlock)\r\nsmalltalk.SwikiCodeRobot:classVariableAt_put_(\"Fetch\",aBlock);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot["$klass"],"fetch",0
,function(self)
return (smalltalk.SwikiCodeRobot:classVariableAt_("Fetch"));
end
,"constants","fetch\r\n\t\" Returns the fetch block (or nil). \"\r\n\r\n\t^Fetch","function(self)\r\nreturn (smalltalk.SwikiCodeRobot:classVariableAt_(\"Fetch\"));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot["$klass"],"@","_at"
,function(self,what)
return ((
function(_s8_rec)
	(_s8_rec):when_do_("needsCategories",(function()
return (smalltalk:if_true_false_(((what):isString()),(function()
return ((what):asArrayOfSubstrings())
end),(function()
return ((what):asArray())
end)))
end));
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","@ what\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\twhen: #needsCategories do: [\r\n\t\t\twhat isString\r\n\t\t\tifTrue: [ what asArrayOfSubstrings ]\r\n\t\t\tifFalse: [ what asArray ]\r\n\t\t];\r\n\t\tyourself","function(self,what)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):when_do_(\"needsCategories\",(function()\r\nreturn (smalltalk:if_true_false_(((what):isString()),(function()\r\nreturn ((what):asArrayOfSubstrings())\r\nend),(function()\r\nreturn ((what):asArray())\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot["$klass"],"for:",0
,function(self,what)
return ((self):_at(what));
end
,"instantiation","for: what\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self @ what","function(self,what)\r\nreturn ((self):_at(what));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot["$klass"],"process:",0
,function(self,where)
return ((self):_at_gt(where));
end
,"process","process: where\r\n\t\" Process the contents at where. \"\r\n\r\n\t^self @> where","function(self,where)\r\nreturn ((self):_at_gt(where));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot["$klass"],"@>","_at_gt"
,function(self,where)
return (((self):new()):_at_gt(where));
end
,"process","@> where\r\n\t\" Process the contents at where.\r\n\tSee instance side comment.\r\n\t\"\r\n\r\n\t^self new @> where","function(self,where)\r\nreturn (((self):new()):_at_gt(where));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"@>","_at_gt"
,function(self,where)
if (smalltalk:boolean_or_(((where):isNumber()),(function()
return ((where):isString())
end)))==true then return ((self):processPageAt_(where)); end;
if not (((where):isArray()))==true then return ((self):error_("Invalid argument.")); end;
if (smalltalk:isObject_equalTo_(((where):size()),1))==true then return ((self):processPageAt_((where):first())); end;
if (smalltalk:isObject_equalTo_(((where):size()),2))==true then return ((self):_at_gt(smalltalk:object_comma_(((smalltalk.Array):with_((self):defaultSwiki())),where))); end;
return ((((self)["$klass"]):_at((where):second())):process_tagged_((where):first(),(where):last()));
end
,"process","@> where\r\n\t\" Process the contents at where.\r\n\twhere can be:\r\n\t\taNumber or aString pointing to a page to process.\r\n\t\tanArray as\r\n\t\t\t#(swikiName category tag)\r\n\t\t\t#(category tag)\r\n\t\t\t#(page)\r\n\t\"\r\n\r\n\t(where isNumber or: [ where isString ]) ifTrue: [\r\n\t\t^self processPageAt: where\r\n\t].\r\n\twhere isArray ifFalse: [ ^self error: 'Invalid argument.' ].\r\n\twhere size = 1 ifTrue: [ ^self processPageAt: where first ].\r\n\twhere size = 2 ifTrue: [ ^self @> ((Array with: self defaultSwiki),where) ].\r\n\t^(self class @ where second) process: where first tagged: where last","function(self,where)\r\nif (smalltalk:boolean_or_(((where):isNumber()),(function()\r\nreturn ((where):isString())\r\nend)))==true then return ((self):processPageAt_(where)); end;\r\nif not (((where):isArray()))==true then return ((self):error_(\"Invalid argument.\")); end;\r\nif (smalltalk:isObject_equalTo_(((where):size()),1))==true then return ((self):processPageAt_((where):first())); end;\r\nif (smalltalk:isObject_equalTo_(((where):size()),2))==true then return ((self):_at_gt(smalltalk:object_comma_(((smalltalk.Array):with_((self):defaultSwiki())),where))); end;\r\nreturn ((((self)[\"$klass\"]):_at((where):second())):process_tagged_((where):first(),(where):last()));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot["$klass"],"constructEventsTriggered",0
,function(self)
return (smalltalk:object_comma_((smalltalk:newArray({"evaluate:", "running:", "testLine:", "needsActionLine:", "endLines", "startTimes:", "endTimes:", "needsOptions", "needsCategories", "sortPages:", "needsCommandsIn:", "load:", "needsFileContents:", "startPages:", "startPage:stream:", "endPage:"})),smalltalk:superImplementor(smalltalk.SwikiCodeRobot["$klass"],"constructEventsTriggered")(self)));
end
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^#(\t#evaluate: #running:\r\n\t\t#testLine: #needsActionLine: #endLines\r\n\t\t#startTimes: #endTimes: \r\n\t\t#needsOptions #needsCategories\r\n\t\t#sortPages: #needsCommandsIn:\r\n\t\t#load: #needsFileContents:\r\n\t\t#startPages: #startPage:stream: #endPage:\r\n\t) , super constructEventsTriggered","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:newArray({\"evaluate:\", \"running:\", \"testLine:\", \"needsActionLine:\", \"endLines\", \"startTimes:\", \"endTimes:\", \"needsOptions\", \"needsCategories\", \"sortPages:\", \"needsCommandsIn:\", \"load:\", \"needsFileContents:\", \"startPages:\", \"startPage:stream:\", \"endPage:\"})),smalltalk:superImplementor(smalltalk.SwikiCodeRobot[\"$klass\"],\"constructEventsTriggered\")(self)));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"defaultSwikiOptions",0
,function(self)
local swikiHost=nil
local swikiPort=nil
(function()
	local _s8_value=(80)
	swikiPort=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=("swiki.smalltalking.net")
	swikiHost=_s8_value
	return _s8_value
end)();
if ((smalltalk.Smalltalk):includesKey_("U8Object"))==true then local home=nil
(function()
	local _s8_value=((((smalltalk.U8Object):swikiHostURL()):fromLast_("://")):upTo_("/"))
	home=_s8_value
	return _s8_value
end)();
if ((home):includes_(":"))==true then (function()
	local _s8_value=(((home):fromLast_(":")):asNumber())
	swikiPort=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=((home):upTo_(":"))
	swikiHost=_s8_value
	return _s8_value
end)(); end;
return (smalltalk:object_comma_((("host"):_minus_gt(swikiHost)),("port"):_minus_gt(swikiPort)));
end
,"defaults","defaultSwikiOptions\r\n\t\" Private - Return the literals used for swiki configuration. \"\r\n\r\n\t| swikiHost swikiPort |\r\n\tswikiPort := 80.\r\n\tswikiHost := 'swiki.smalltalking.net'.\r\n\t(Smalltalk includesKey: #U8Object) ifTrue: [ | home |\r\n\t\thome := (U8Object swikiHostURL fromLast: '://') upTo: $/.\r\n\t\t(home includes: $:) ifTrue: [\r\n\t\t\tswikiPort := (home fromLast: $:) asNumber.\r\n\t\t].\r\n\t\tswikiHost := home upTo: $:\r\n\t].\r\n\t^(#host -> swikiHost) ,(#port -> swikiPort)","function(self)\r\nlocal swikiHost=nil\r\nlocal swikiPort=nil\r\n(function()\r\n\tlocal _s8_value=(80)\r\n\tswikiPort=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(\"swiki.smalltalking.net\")\r\n\tswikiHost=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((smalltalk.Smalltalk):includesKey_(\"U8Object\"))==true then local home=nil\r\n(function()\r\n\tlocal _s8_value=((((smalltalk.U8Object):swikiHostURL()):fromLast_(\"://\")):upTo_(\"/\"))\r\n\thome=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((home):includes_(\":\"))==true then (function()\r\n\tlocal _s8_value=(((home):fromLast_(\":\")):asNumber())\r\n\tswikiPort=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((home):upTo_(\":\"))\r\n\tswikiHost=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (smalltalk:object_comma_(((\"host\"):_minus_gt(swikiHost)),(\"port\"):_minus_gt(swikiPort)));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"defaultOptions",0
,function(self)
return ((self):triggerEvent_ifNotHandled_("needsOptions",(function()
return ((self):defaultSwikiOptions())
end)));
end
,"defaults","defaultOptions\r\n\t\" Private - Return the literals used for default configuration. \"\r\n\r\n\t^self triggerEvent: #needsOptions ifNotHandled: [\r\n\t\tself defaultSwikiOptions\r\n\t]","function(self)\r\nreturn ((self):triggerEvent_ifNotHandled_(\"needsOptions\",(function()\r\nreturn ((self):defaultSwikiOptions())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"defaultSwiki",0
,function(self)
return ("s8-media");
end
,"defaults","defaultSwiki\r\n\t\" Private - Return the default swiki name. \"\r\n\r\n\t^#s8-media","function(self)\r\nreturn (\"s8-media\");\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"defaultDeferred",0
,function(self)
return (smalltalk:boolean_or_(((self):hasFetch()),(function()
return ((self):hasNodeJS())
end)));
end
,"defaults","defaultDeferred\r\n\t\" Private - Return true if the receiver run in deferred mode. \"\r\n\r\n\t^self hasFetch or: [ self hasNodeJS ]","function(self)\r\nreturn (smalltalk:boolean_or_(((self):hasFetch()),(function()\r\nreturn ((self):hasNodeJS())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"defaultCategories",0
,function(self)
return ((self):triggerEvent_ifNotHandled_("needsCategories",(function()
return ((smalltalk.Array):new())
end)));
end
,"defaults","defaultCategories\r\n\t\" Private - Return the literals used to filter pages of interest.\r\n\tThe default answer is an empty array (all pages starting with [ are of interest).\r\n\tThe subclasses can refine the result to select pages marked with a category before the [ (tag) field.\r\n\t\"\r\n\r\n\t^self triggerEvent: #needsCategories ifNotHandled: [ Array new ]","function(self)\r\nreturn ((self):triggerEvent_ifNotHandled_(\"needsCategories\",(function()\r\nreturn ((smalltalk.Array):new())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"hasFetch",0
,function(self)
return (smalltalk:notNil_((((self)["$klass"]):fetch())));
end
,"testing","hasFetch\r\n\t\" Private - Returns true if the execution environment provides a fetch function. \"\r\n\r\n\t^self class fetch notNil","function(self)\r\nreturn (smalltalk:notNil_((((self)[\"$klass\"]):fetch())));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"hasNodeJS",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local sentinel=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_("process",(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
	sentinel=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_(((sentinel)["version"])))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"testing","hasNodeJS\r\n\t\" Private - Returns true if the execution environment is running NodeJS. \"\r\n\r\n\t| sentinel |\r\n\tsentinel := Smalltalk nativeObjectAt: #process ifAbsent: [ ^false ].\r\n\t(sentinel basicAt: #version) isNil ifTrue: [ ^false ].\r\n\t^true","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal sentinel=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(\"process\",(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tsentinel=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_(((sentinel)[\"version\"])))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"http:do:ifAbsent:",0
,function(self,httpOptions,dataBlock,aBlock)
local request=nil
local http=nil
if ((self):hasFetch())==true then return ((((self)["$klass"]):fetch()):value_value_((self):urlFromOptions_(httpOptions),dataBlock)); end;
if not (((self):hasNodeJS()))==true then return ((aBlock):evaluate()); end;
(function()
	local _s8_value=(require("http"))
	http=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((http)))==true then return ((aBlock):evaluate()); end;
(function()
	local _s8_value=((http):request((httpOptions):json(),(function(response)
local content=nil
(function()
	local _s8_value=("")
	content=_s8_value
	return _s8_value
end)();(
function(_s8_rec)
	(_s8_rec):setEncoding("utf8");
	return ((_s8_rec):on("data",(function(chunk)
return ((function()
	local _s8_value=(smalltalk:object_comma_((content),chunk))
	content=_s8_value
	return _s8_value
end)())
end)))
end
)(response);return ((response):on("end",(function()
return ((dataBlock):evaluateWith_(content))
end)))
end)))
	request=_s8_value
	return _s8_value
end)();
(request):on("error",(function(ex)
return ((self):error_(ex["stack"]))
end));
self:invalidMessage();
return (nil);
end
,"http","http: httpOptions do: dataBlock ifAbsent: aBlock\r\n\t\" Private - Evaluates the dataBlock with data obtained accessing server options. \"\r\n\r\n\t| request http |\r\n\tself hasFetch ifTrue: [\r\n\t\t^self class fetch\r\n\t\t\tvalue: (self urlFromOptions: httpOptions)\r\n\t\t\tvalue: dataBlock\r\n\t].\r\n\tself hasNodeJS ifFalse: [ ^aBlock evaluate ].\r\n\thttp := # #require: #http. \r\n\thttp isNil ifTrue: [ ^aBlock evaluate ].\r\n\trequest := http #request: httpOptions json doing: [:response| | content |\r\n\t\tcontent := ''.\r\n\t\tresponse\r\n\t\t\t#setEncoding: #utf8;\r\n\t\t\t#on: #data do: [:chunk| content := content, chunk ].\r\n\t\tresponse #on: #end do: [ dataBlock evaluateWith: content ].\r\n\t].\r\n\trequest #on: #error do: [:ex| self error: \"ex#message ,\" ex#stack ].\r\n\t{'request.end()' lua'self:invalidMessage()'}.\r\n\t^nil","function(self,httpOptions,dataBlock,aBlock)\r\nlocal request=nil\r\nlocal http=nil\r\nif ((self):hasFetch())==true then return ((((self)[\"$klass\"]):fetch()):value_value_((self):urlFromOptions_(httpOptions),dataBlock)); end;\r\nif not (((self):hasNodeJS()))==true then return ((aBlock):evaluate()); end;\r\n(function()\r\n\tlocal _s8_value=(require(\"http\"))\r\n\thttp=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((http)))==true then return ((aBlock):evaluate()); end;\r\n(function()\r\n\tlocal _s8_value=((http):request((httpOptions):json(),(function(response)\r\nlocal content=nil\r\n(function()\r\n\tlocal _s8_value=(\"\")\r\n\tcontent=_s8_value\r\n\treturn _s8_value\r\nend)();(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):setEncoding(\"utf8\");\r\n\treturn ((_s8_rec):on(\"data\",(function(chunk)\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((content),chunk))\r\n\tcontent=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)))\r\nend\r\n)(response);return ((response):on(\"end\",(function()\r\nreturn ((dataBlock):evaluateWith_(content))\r\nend)))\r\nend)))\r\n\trequest=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(request):on(\"error\",(function(ex)\r\nreturn ((self):error_(ex[\"stack\"]))\r\nend));\r\nself:invalidMessage();\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"withHttp:do:",0
,function(self,httpOptions,dataBlock)
local request=nil
local http=nil
if ((self):hasFetch())==true then return ((((self)["$klass"]):fetch()):value_value_((self):urlFromOptions_(httpOptions),dataBlock)); end;
if not (((self):hasNodeJS()))==true then return ((self):error_("Accessing swiki using HTTP - Require Node.js execution environment.")); end;
(function()
	local _s8_value=(require("http"))
	http=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((http):request((httpOptions):json(),(function(response)
local content=nil
(function()
	local _s8_value=("")
	content=_s8_value
	return _s8_value
end)();(
function(_s8_rec)
	(_s8_rec):setEncoding("utf8");
	return ((_s8_rec):on("data",(function(chunk)
return ((function()
	local _s8_value=(smalltalk:object_comma_((content),chunk))
	content=_s8_value
	return _s8_value
end)())
end)))
end
)(response);return ((response):on("end",(function()
return ((dataBlock):evaluateWith_(content))
end)))
end)))
	request=_s8_value
	return _s8_value
end)();
(request):on("error",(function(ex)
return ((self):error_(ex["stack"]))
end));
self:invalidMessage();
return (nil);
end
,"http","withHttp: httpOptions do: dataBlock\r\n\t\" Private - Evaluates the dataBlock with data obtained accessing server options. \"\r\n\r\n\t| request http |\r\n\tself hasFetch ifTrue: [\r\n\t\t^self class fetch\r\n\t\t\tvalue: (self urlFromOptions: httpOptions)\r\n\t\t\tvalue: dataBlock\r\n\t].\r\n\tself hasNodeJS ifFalse: [\r\n\t\t^self error: 'Accessing swiki using HTTP - Require Node.js execution environment.'\r\n\t].\r\n\thttp := # #require: #http.\r\n\trequest := http #request: httpOptions json doing: [:response| | content |\t\t\r\n\t\tcontent := ''.\r\n\t\tresponse\r\n\t\t\t#setEncoding: #utf8;\r\n\t\t\t#on: #data do: [:chunk| content := content, chunk ].\r\n\t\tresponse #on: #end do: [ dataBlock evaluateWith: content ].\r\n\t].\r\n\trequest #on: #error do: [:ex| self error: \"ex#message ,\" ex#stack ].\t\r\n\t{'request.end()' lua'self:invalidMessage()'}.\r\n\t^nil","function(self,httpOptions,dataBlock)\r\nlocal request=nil\r\nlocal http=nil\r\nif ((self):hasFetch())==true then return ((((self)[\"$klass\"]):fetch()):value_value_((self):urlFromOptions_(httpOptions),dataBlock)); end;\r\nif not (((self):hasNodeJS()))==true then return ((self):error_(\"Accessing swiki using HTTP - Require Node.js execution environment.\")); end;\r\n(function()\r\n\tlocal _s8_value=(require(\"http\"))\r\n\thttp=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((http):request((httpOptions):json(),(function(response)\r\nlocal content=nil\r\n(function()\r\n\tlocal _s8_value=(\"\")\r\n\tcontent=_s8_value\r\n\treturn _s8_value\r\nend)();(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):setEncoding(\"utf8\");\r\n\treturn ((_s8_rec):on(\"data\",(function(chunk)\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((content),chunk))\r\n\tcontent=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)))\r\nend\r\n)(response);return ((response):on(\"end\",(function()\r\nreturn ((dataBlock):evaluateWith_(content))\r\nend)))\r\nend)))\r\n\trequest=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(request):on(\"error\",(function(ex)\r\nreturn ((self):error_(ex[\"stack\"]))\r\nend));\r\nself:invalidMessage();\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"urlFromOptions:",0
,function(self,theOptions)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("http://"),(theOptions):_at("host"))),":")),(theOptions):_at("port"))),"/")),(theOptions):_at("path")));
end
,"utilities","urlFromOptions: theOptions\r\n\t\" Private - Returns the url set in theOptions. \"\r\n\r\n\t^'http://'\r\n\t\t,(theOptions @ #host)\r\n\t\t,':' ,(theOptions @ #port)\r\n\t\t,'/' ,(theOptions @ #path)","function(self,theOptions)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"http://\"),(theOptions):_at(\"host\"))),\":\")),(theOptions):_at(\"port\"))),\"/\")),(theOptions):_at(\"path\")));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"withOptions:do:",0
,function(self,theOptions,dataBlock)
(self):http_do_ifAbsent_(theOptions,dataBlock,(function()
local text=nil
(function()
	local _s8_value=((self):fileContentsAt_((self):urlFromOptions_(theOptions)))
	text=_s8_value
	return _s8_value
end)();return ((dataBlock):value_(text))
end));
return (self);
end
,"utilities","withOptions: theOptions do: dataBlock\r\n\t\" Private - Evaluates the dataBlock with data obtained accessing server options. \"\r\n\r\n\tself http: theOptions do: dataBlock ifAbsent: [\r\n\t\t| text |\r\n\t\ttext := self fileContentsAt: (self urlFromOptions: theOptions).\r\n\t\tdataBlock value: text\r\n\t]","function(self,theOptions,dataBlock)\r\n(self):http_do_ifAbsent_(theOptions,dataBlock,(function()\r\nlocal text=nil\r\n(function()\r\n\tlocal _s8_value=((self):fileContentsAt_((self):urlFromOptions_(theOptions)))\r\n\ttext=_s8_value\r\n\treturn _s8_value\r\nend)();return ((dataBlock):value_(text))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"withSwiki:page:do:",0
,function(self,swikiName,pageNumber,dataBlock)
if ((self):aborted())==true then return (nil); end;
(self):withOptions_do_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):options()),("method"):_minus_gt("GET"))),("path"):_minus_gt(smalltalk:object_comma_((smalltalk:object_comma_((swikiName),"/")),pageNumber)))),("agent"):_minus_gt(false)),dataBlock);
return (self);
end
,"utilities","withSwiki: swikiName page: pageNumber do: dataBlock\r\n\t\" Private - Evaluates the dataBlock with data obtained from swikipage. \"\r\n\r\n\tself aborted ifTrue: [ ^nil ].\r\n\tself\twithOptions: self options\r\n\t\t\t,(#method -> 'GET')\r\n\t\t\t,(#path -> (swikiName,'/',pageNumber))\r\n\t\t\t,(#agent ->false)\r\n\t\tdo: dataBlock","function(self,swikiName,pageNumber,dataBlock)\r\nif ((self):aborted())==true then return (nil); end;\r\n(self):withOptions_do_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):options()),(\"method\"):_minus_gt(\"GET\"))),(\"path\"):_minus_gt(smalltalk:object_comma_((smalltalk:object_comma_((swikiName),\"/\")),pageNumber)))),(\"agent\"):_minus_gt(false)),dataBlock);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"is:includedIn:",0
,function(self,tag,tags)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if ((tag):isArray())==true then (tag):detect_ifNone_((function(one)
return (smalltalk:booleanNot_(((self):is_includedIn_(one,tags))))
end),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((tags):includes_(tag))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"tags","is: tag includedIn: tags\r\n\t\" Private - Return true if the tag matches tags. \"\r\n\r\n\ttag isArray ifTrue: [\r\n\t\ttag\tdetect: [:one| (self is: one includedIn: tags) not ]\r\n\t\t\tifNone: [ ^true ].\r\n\t\t^false\r\n\t].\r\n\t^tags includes: tag","function(self,tag,tags)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif ((tag):isArray())==true then (tag):detect_ifNone_((function(one)\r\nreturn (smalltalk:booleanNot_(((self):is_includedIn_(one,tags))))\r\nend),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((tags):includes_(tag))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"tagSeparator",0
,function(self)
return (",");
end
,"tags","tagSeparator\r\n\t\" Private - Return the tags separator. \"\r\n\r\n\t^$,","function(self)\r\nreturn (\",\");\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"tagsFrom:",0
,function(self,aStream)
return (((self):categoryAndTagsFrom_(aStream)):last());
end
,"tags","tagsFrom: aStream\r\n\t\" Private - Return the tags read from title stream. \"\r\n\r\n\t^(self categoryAndTagsFrom: aStream) last","function(self,aStream)\r\nreturn (((self):categoryAndTagsFrom_(aStream)):last());\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"tagsInTitle:",0
,function(self,title)
return (((self):categoryAndTagsInTitle_(title)):last());
end
,"tags","tagsInTitle: title\r\n\t\" Private - Return the tags read from title string. \"\r\n\r\n\t^(self categoryAndTagsInTitle: title) last","function(self,title)\r\nreturn (((self):categoryAndTagsInTitle_(title)):last());\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"categoryAndTagsFrom:",0
,function(self,aStream)
local category=nil
(function()
	local _s8_value=(((aStream):upTo_("[")):trimBlanks())
	category=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_and_((((self):categories()):notEmpty()),(function()
return (smalltalk:booleanNot_((((self):categories()):includes_(category))))
end)))==true then return ((smalltalk.Array):with_with_(category,smalltalk:newArray({}))); end;
return ((smalltalk.Array):with_with_(category,((((aStream):upTo_("]")):asArrayOfSubstringsSeparatedBy_((self):tagSeparator())):collect_((function(each)
return ((each):trimBlanks())
end))):select_((function(each)
return ((each):notEmpty())
end))));
end
,"tags","categoryAndTagsFrom: aStream\r\n\t\" Private - Return the tags read from title stream. \"\r\n\r\n\t| category |\r\n\tcategory := (aStream upTo: $[) trimBlanks.\r\n\t(self categories notEmpty\r\n\t\tand: [ (self categories includes: category) not])\r\n\t\tifTrue: [ ^Array with: category with: #() ].\r\n\t^Array\twith: category\r\n\t\twith: ((((aStream upTo: $])\r\n\t\t\tasArrayOfSubstringsSeparatedBy: self tagSeparator)\r\n\t\t\tcollect: [:each| each trimBlanks ])\r\n\t\t\tselect: [:each| each notEmpty ])","function(self,aStream)\r\nlocal category=nil\r\n(function()\r\n\tlocal _s8_value=(((aStream):upTo_(\"[\")):trimBlanks())\r\n\tcategory=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_and_((((self):categories()):notEmpty()),(function()\r\nreturn (smalltalk:booleanNot_((((self):categories()):includes_(category))))\r\nend)))==true then return ((smalltalk.Array):with_with_(category,smalltalk:newArray({}))); end;\r\nreturn ((smalltalk.Array):with_with_(category,((((aStream):upTo_(\"]\")):asArrayOfSubstringsSeparatedBy_((self):tagSeparator())):collect_((function(each)\r\nreturn ((each):trimBlanks())\r\nend))):select_((function(each)\r\nreturn ((each):notEmpty())\r\nend))));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"categoryAndTagsInTitle:",0
,function(self,title)
return ((self):categoryAndTagsFrom_((title):stream()));
end
,"tags","categoryAndTagsInTitle: title\r\n\t\" Private - Return an array with category and the tags read from title string. \"\r\n\r\n\t^self categoryAndTagsFrom: title stream","function(self,title)\r\nreturn ((self):categoryAndTagsFrom_((title):stream()));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"title:matches:",0
,function(self,indexEntry,tag)
local tags=nil
(function()
	local _s8_value=((self):tagsInTitle_((indexEntry):last()))
	tags=_s8_value
	return _s8_value
end)();
if ((tags):isEmpty())==true then return (false); end;
if (smalltalk:isNil_((tag)))==true then return (true); end;
return ((self):is_includedIn_(tag,tags));
end
,"tags","title: indexEntry matches: tag\r\n\t\" Private - Return true if the indexEntry matches tag. \"\r\n\r\n\t| tags |\r\n\ttags := self tagsInTitle: indexEntry last.\r\n\ttags isEmpty ifTrue: [ ^false ].\r\n\ttag isNil ifTrue: [ ^true ].\r\n\t^self is: tag includedIn: tags","function(self,indexEntry,tag)\r\nlocal tags=nil\r\n(function()\r\n\tlocal _s8_value=((self):tagsInTitle_((indexEntry):last()))\r\n\ttags=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((tags):isEmpty())==true then return (false); end;\r\nif (smalltalk:isNil_((tag)))==true then return (true); end;\r\nreturn ((self):is_includedIn_(tag,tags));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"pagesIn:matching:",0
,function(self,stream,tag)
local result=nil
local line=nil
local pageNumber=nil
local boolean=nil
local title=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
while not ((function()
return ((stream):atEnd())
end))() do (function()
	local _s8_value=(((stream):upTo_((smalltalk.String):tab())):asNumber())
	pageNumber=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((stream):upTo_((smalltalk.String):tab()))
	boolean=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((stream):nextLine()):trimBlanks())
	title=_s8_value
	return _s8_value
end)();
(result):add_((smalltalk.Array):with_with_(pageNumber,title)); end;
return ((self):sortedPages_((result):select_((function(entry)
return ((self):title_matches_(entry,tag))
end))));
end
,"tags","pagesIn: stream matching: tag\r\n\t\" Private - Returns the pages defined in index stream matching tag.\r\n\tThe default implementation parse index stream selecting pages matching tag field.\r\n\t\"\r\n\r\n\t| result line pageNumber boolean title |\r\n\tresult := Array new.\r\n\t[stream atEnd] whileFalse: [\r\n\t\tpageNumber := (stream upTo: String tab) asNumber.\r\n\t\tboolean := stream upTo: String tab.\r\n\t\ttitle := stream nextLine trimBlanks.\r\n\t\tresult add: (Array with: pageNumber with: title)\r\n\t].\r\n\t^self sortedPages: (result select: [:entry| self title: entry matches: tag ])","function(self,stream,tag)\r\nlocal result=nil\r\nlocal line=nil\r\nlocal pageNumber=nil\r\nlocal boolean=nil\r\nlocal title=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((stream):atEnd())\r\nend))() do (function()\r\n\tlocal _s8_value=(((stream):upTo_((smalltalk.String):tab())):asNumber())\r\n\tpageNumber=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((stream):upTo_((smalltalk.String):tab()))\r\n\tboolean=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((stream):nextLine()):trimBlanks())\r\n\ttitle=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(result):add_((smalltalk.Array):with_with_(pageNumber,title)); end;\r\nreturn ((self):sortedPages_((result):select_((function(entry)\r\nreturn ((self):title_matches_(entry,tag))\r\nend))));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"htmlEncodings",0
,function(self)
return (smalltalk:newArray({smalltalk:newArray({"&lt;", "<"}), smalltalk:newArray({"&gt;", ">"}), smalltalk:newArray({"&amp;", "&"})}));
end
,"private","htmlEncodings\r\n\t\" Private - Return the encoded characters table. \"\r\n\r\n\t^#(\r\n\t\t#( '&lt;' #< )\r\n\t\t#( '&gt;' #> )\r\n\t\t#( '&amp;' #& )\r\n\t)","function(self)\r\nreturn (smalltalk:newArray({smalltalk:newArray({\"&lt;\", \"<\"}), smalltalk:newArray({\"&gt;\", \">\"}), smalltalk:newArray({\"&amp;\", \"&\"})}));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"nextChunkIn:",0
,function(self,stream)
local open=nil
local tag=nil
local close=nil
local bar=nil
local code=nil
(function()
	local _s8_value=("<")
	open=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(">")
	close=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=("/")
	bar=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=("pre")
	tag=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((
function(_s8_rec)
	(_s8_rec):upTo_(smalltalk:object_comma_((smalltalk:object_comma_((open),tag)),close));
	return ((_s8_rec):upTo_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((open),bar)),tag)),close)))
end
)(stream))
	code=_s8_value
	return _s8_value
end)();
return (((self):htmlEncodings()):inject_into_(code,(function(total,each)
return ((total):replace_with_((each):first(),(each):second()))
end)));
end
,"private","nextChunkIn: stream\r\n\t\" Return the next chunk of code in stream. \"\r\n\r\n\t| open tag close bar code |\r\n\topen := #<. close := #>. bar := #/. tag := #pre.\r\n\tcode := stream upTo: open,tag,close; upTo: open,bar,tag,close.\r\n\t^self htmlEncodings inject: code\r\n\t\tinto: [:total :each| total replace: each first with: each second ]","function(self,stream)\r\nlocal open=nil\r\nlocal tag=nil\r\nlocal close=nil\r\nlocal bar=nil\r\nlocal code=nil\r\n(function()\r\n\tlocal _s8_value=(\"<\")\r\n\topen=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(\">\")\r\n\tclose=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(\"/\")\r\n\tbar=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(\"pre\")\r\n\ttag=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):upTo_(smalltalk:object_comma_((smalltalk:object_comma_((open),tag)),close));\r\n\treturn ((_s8_rec):upTo_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((open),bar)),tag)),close)))\r\nend\r\n)(stream))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((self):htmlEncodings()):inject_into_(code,(function(total,each)\r\nreturn ((total):replace_with_((each):first(),(each):second()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"lineTest:",0
,function(self,expression)
local result=nil
(function()
	local _s8_value=(((expression):stream()):fileInto_(self))
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((true),result))==true then return ("ok"); end;
if (smalltalk:isObject_equalTo_((false),result))==true then return ((self):note_(smalltalk:object_comma_(("FAILED - "),expression))); end;
return (result);
end
,"lineTests","lineTest: expression\r\n\t\" Private - Evaluate the test expression. \"\r\n\r\n\t| result |\r\n\tresult := expression stream fileInto: self.\r\n\ttrue = result ifTrue: [ ^#ok ].\r\n\tfalse = result ifTrue: [ ^self note: 'FAILED - ' ,expression ].\r\n\t^result","function(self,expression)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((expression):stream()):fileInto_(self))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((true),result))==true then return (\"ok\"); end;\r\nif (smalltalk:isObject_equalTo_((false),result))==true then return ((self):note_(smalltalk:object_comma_((\"FAILED - \"),expression))); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"running:",0
,function(self,aTitle)
(self):triggerEvent_with_ifNotHandled_("running:",aTitle,(function()
return ((self):note_(aTitle))
end));
return (true);
end
,"lineTests","running: aTitle\r\n\t\" Test - Notify we are running test aTitle. \"\r\n\r\n\tself triggerEvent: #running: with: aTitle ifNotHandled: [\r\n\t\tself note: aTitle.\r\n\t].\r\n\t^true","function(self,aTitle)\r\n(self):triggerEvent_with_ifNotHandled_(\"running:\",aTitle,(function()\r\nreturn ((self):note_(aTitle))\r\nend));\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"testLine:",0
,function(self,expression)
(self):triggerEvent_with_ifNotHandled_("testLine:",expression,(function()
return ((self):lineTest_(expression))
end));
return (self);
end
,"lineTests","testLine: expression\r\n\t\" Private - Evaluate the test expression. \"\r\n\r\n\tself triggerEvent: #testLine: with: expression ifNotHandled: [\r\n\t\tself lineTest: expression\r\n\t]","function(self,expression)\r\n(self):triggerEvent_with_ifNotHandled_(\"testLine:\",expression,(function()\r\nreturn ((self):lineTest_(expression))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"startTimes:",0
,function(self,code)
(self):triggerEvent_with_("startTimes:",(self):savedTimes());
return (self);
end
,"timeTests","startTimes: code\r\n\t\" Private - Start tracking time evaluating line tests. \"\r\n\r\n\tself triggerEvent: #startTimes: with: self savedTimes ","function(self,code)\r\n(self):triggerEvent_with_(\"startTimes:\",(self):savedTimes());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"endTimes:",0
,function(self,code)
(self):triggerEvent_with_("endTimes:",(self):savedTimes());
return (self);
end
,"timeTests","endTimes: code\r\n\t\" Private - Finish tracking time evaluating line tests. \"\r\n\r\n\tself triggerEvent: #endTimes: with: self savedTimes ","function(self,code)\r\n(self):triggerEvent_with_(\"endTimes:\",(self):savedTimes());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"resetTimes",0
,function(self)
return (((self):savedTimes()):removeAll());
end
,"timeTests","resetTimes\r\n\t\" Reset the times collected. \"\r\n\r\n\t^self savedTimes removeAll ","function(self)\r\nreturn (((self):savedTimes()):removeAll());\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"savedTimes",0
,function(self)
return ((self):basicAt_ifAbsentPut_("$savedTimes",(function()
return ((smalltalk.PoolDictionary):new())
end)));
end
,"timeTests","savedTimes\r\n\t\" Return the collected times spent evaluating line tests. \"\r\n\r\n\t^self basicAt: '$savedTimes' ifAbsentPut: [PoolDictionary new] ","function(self)\r\nreturn ((self):basicAt_ifAbsentPut_(\"$savedTimes\",(function()\r\nreturn ((smalltalk.PoolDictionary):new())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"jlTime:count:",0
,function(self,action,count)
local blk=nil
(function()
	local _s8_value=((self):callableOf_(action))
	blk=_s8_value
	return _s8_value
end)();
(function() self:invalidMessage_("jlTime:count:") end)();
(smalltalk.Smalltalk):gc();
return (((function()
return (smalltalk:times_repeat_((count),(function()
return ((function() self:invalidMessage_("jlTime:count:") end)())
end)))
end)):ms());
end
,"timeTests","jlTime: action count: count\r\n\t\" Private - Returns the time spent evaluating expression in a loop (count times). \"\r\n\r\n\t| blk |\r\n\tblk := self callableOf: action.\r\n\t{''jl' Base.invokelatest(blk) '}.\r\n\tSmalltalk gc.\r\n\t^[ count timesRepeat: [\r\n\t\t{''jl' Base.invokelatest(blk) '}.\r\n\t] ] ms ","function(self,action,count)\r\nlocal blk=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(action))\r\n\tblk=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function() self:invalidMessage_(\"jlTime:count:\") end)();\r\n(smalltalk.Smalltalk):gc();\r\nreturn (((function()\r\nreturn (smalltalk:times_repeat_((count),(function()\r\nreturn ((function() self:invalidMessage_(\"jlTime:count:\") end)())\r\nend)))\r\nend)):ms());\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"ms:count:",0
,function(self,expression,count)
local nativeSelector=nil
(function()
	local _s8_value=((smalltalk:object_comma_(((self):nativeLanguage()),"Time:count:")):asSymbol())
	nativeSelector=_s8_value
	return _s8_value
end)();
if (smalltalk:responds_to_((self),(nativeSelector)))==true then local action=nil
(function()
	local _s8_value=((smalltalk:object_comma_((smalltalk:object_comma_(("[ "),expression))," ]")):doIt())
	action=_s8_value
	return _s8_value
end)();
return ((self):perform_withArguments_(nativeSelector,(smalltalk.Array):with_with_(action,count))); end;
return ((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Smalltalk gc. ["),count))," timesRepeat: [")),expression)),"]\r\n\t]ms rounded")):doIt());
end
,"timeTests","ms: expression count: count\r\n\t\" Private - Returns the time spent evaluating expression in a loop (count times).\r\n\tNote expression must be a valid statements expression.\r\n\t\"\r\n\r\n\t| nativeSelector |\r\n\tnativeSelector := (self nativeLanguage ,'Time:count:') asSymbol.\r\n\t(self respondsTo: nativeSelector) ifTrue: [ | action |\r\n\t\taction := ('[ ' ,expression ,' ]') doIt.\r\n\t\t^self perform: nativeSelector withArguments: (Array\r\n\t\t\twith: action with: count)\r\n\t].\r\n\t^('Smalltalk gc. ['\r\n\t,count ,' timesRepeat: [' ,expression ,']\r\n\t]ms rounded') doIt","function(self,expression,count)\r\nlocal nativeSelector=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk:object_comma_(((self):nativeLanguage()),\"Time:count:\")):asSymbol())\r\n\tnativeSelector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:responds_to_((self),(nativeSelector)))==true then local action=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk:object_comma_((smalltalk:object_comma_((\"[ \"),expression)),\" ]\")):doIt())\r\n\taction=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):perform_withArguments_(nativeSelector,(smalltalk.Array):with_with_(action,count))); end;\r\nreturn ((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Smalltalk gc. [\"),count)),\" timesRepeat: [\")),expression)),\"]\\r\\n\\t]ms rounded\")):doIt());\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"saveTime:",0
,function(self,expression)
local count=nil
local stream=nil
(function()
	local _s8_value=(1000)
	count=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((expression):stream())
	stream=_s8_value
	return _s8_value
end)();
if ((stream):peekForAll_("##"))==true then (function()
	local _s8_value=((smalltalk.Number):readFrom_(stream))
	count=_s8_value
	return _s8_value
end)(); end;
(stream):skipSeparators();
if ((stream):atEnd())==true then return (nil); end;
((self):savedTimes()):at_put_(expression,(self):ms_count_((stream):upToEnd(),count));
return (self);
end
,"timeTests","saveTime: expression\r\n\t\" Private - Track time evaluating expression. \"\r\n\r\n\t| count stream |\r\n\tcount := 1000.\r\n\tstream := expression stream.\r\n\t(stream peekForAll: '##') ifTrue: [ count := Number readFrom: stream ].\r\n\tstream skipSeparators.\r\n\tstream atEnd ifTrue: [ ^nil ].\r\n\tself savedTimes at: expression put: (self ms: stream upToEnd count: count) ","function(self,expression)\r\nlocal count=nil\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=(1000)\r\n\tcount=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((expression):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((stream):peekForAll_(\"##\"))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Number):readFrom_(stream))\r\n\tcount=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(stream):skipSeparators();\r\nif ((stream):atEnd())==true then return (nil); end;\r\n((self):savedTimes()):at_put_(expression,(self):ms_count_((stream):upToEnd(),count));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"timesAction:",0
,function(self,code)
(self):startTimes_(code);
return ((function(expression)
return (smalltalk:if_true_false_((smalltalk:isNil_((expression))),(function()
return ((self):endTimes_(code))
end),(function()
return ((self):saveTime_(expression))
end)))
end));
end
,"timeTests","timesAction: code\r\n\t\" Private - Return the action to evaluate to track time spent evaluating line tests. \"\r\n\r\n\tself startTimes: code.\r\n\t^[:expression|\r\n\t\texpression isNil\r\n\t\tifTrue: [ self endTimes: code ]\r\n\t\tifFalse: [ self saveTime: expression ]\r\n\t]","function(self,code)\r\n(self):startTimes_(code);\r\nreturn ((function(expression)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((expression))),(function()\r\nreturn ((self):endTimes_(code))\r\nend),(function()\r\nreturn ((self):saveTime_(expression))\r\nend)))\r\nend));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"testLines:in:",0
,function(self,code,page)
local action=nil
(function()
	local _s8_value=((self):triggerEvent_with_ifNotHandled_("needsActionLine:",code,(function()
return (smalltalk:if_true_false_(((code):peekForAll_("times")),(function()
return ((self):timesAction_(code))
end),nil))
end)))
	action=_s8_value
	return _s8_value
end)();
while not ((function()
return ((code):atEnd())
end))() do local line=nil
(code):skipSeparators();
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((code):peek()),"!")),(function()
return ((
function(_s8_rec)
	(_s8_rec):next();
	return ((_s8_rec):nextChunk())
end
)(code))
end),(function()
return (((code):nextLine()):upTo_("\""))
end)))
	line=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((((line):trimBlanks()):notEmpty()),(function()
return (smalltalk:if_true_false_((smalltalk:isNil_((action))),(function()
return ((self):testLine_(line))
end),(function()
return ((action):evaluateWith_(line))
end)))
end),nil); end;
if (smalltalk:notNil_((action)))==true then (action):evaluateWith_(nil); end;
(self):triggerEvent_("endLines");
return (self);
end
,"lineTests","testLines: code in: page\r\n\t\" Private - Evaluate the test lines in code stream. \"\r\n\r\n\t| action |\r\n\taction := self triggerEvent: #needsActionLine: with: code ifNotHandled: [\r\n\t\t(code peekForAll: #times) ifTrue: [ self timesAction: code]\r\n\t].\r\n\t[code atEnd] whileFalse: [ | line |\r\n\t\tcode skipSeparators.\r\n\t\tline := code peek = $!\r\n\t\t\tifTrue: [ code next; nextChunk ]\r\n\t\t\tifFalse: [ code nextLine upTo: $\" ].\r\n\t\tline trimBlanks notEmpty ifTrue: [\r\n\t\t\taction isNil\r\n\t\t\tifTrue: [ self testLine: line ]\r\n\t\t\tifFalse: [ action evaluateWith: line ]\r\n\t\t]\r\n\t].\r\n\taction notNil ifTrue: [ action evaluateWith: nil ].\r\n\tself triggerEvent: #endLines","function(self,code,page)\r\nlocal action=nil\r\n(function()\r\n\tlocal _s8_value=((self):triggerEvent_with_ifNotHandled_(\"needsActionLine:\",code,(function()\r\nreturn (smalltalk:if_true_false_(((code):peekForAll_(\"times\")),(function()\r\nreturn ((self):timesAction_(code))\r\nend),nil))\r\nend)))\r\n\taction=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((code):atEnd())\r\nend))() do local line=nil\r\n(code):skipSeparators();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((code):peek()),\"!\")),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):next();\r\n\treturn ((_s8_rec):nextChunk())\r\nend\r\n)(code))\r\nend),(function()\r\nreturn (((code):nextLine()):upTo_(\"\\\"\"))\r\nend)))\r\n\tline=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((((line):trimBlanks()):notEmpty()),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((action))),(function()\r\nreturn ((self):testLine_(line))\r\nend),(function()\r\nreturn ((action):evaluateWith_(line))\r\nend)))\r\nend),nil); end;\r\nif (smalltalk:notNil_((action)))==true then (action):evaluateWith_(nil); end;\r\n(self):triggerEvent_(\"endLines\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"fileInCode:in:",0
,function(self,code,page)
local codeStream=nil
local commentStart=nil
(function()
	local _s8_value=((code):stream())
	codeStream=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((codeStream):peek()),"."))==true then (codeStream):next();
return ((self):testLines_in_(codeStream,page)); end;
(function()
	local _s8_value=(((" "):asComment()):upTo_(" "))
	commentStart=_s8_value
	return _s8_value
end)();
if ((codeStream):peekForAll_(commentStart))==true then (self):note_((codeStream):nextLine());
return (((smalltalk.Smalltalk):current()):eval_((codeStream):upToEnd())); end;
if (smalltalk:isObject_equalTo_(((codeStream):peek()),"\""))==true then (self):note_((
function(_s8_rec)
	(_s8_rec):next();
	return ((_s8_rec):upTo_("\""))
end
)(codeStream)); end;
return ((codeStream):fileInto_(self));
end
,"private","fileInCode: code in: page\r\n\t\" Private - FileIn the code in code string. \"\r\n\r\n\t| codeStream commentStart |\r\n\tcodeStream := code stream.\r\n\tcodeStream peek = $. ifTrue: [ \"code starting with $. enter line mode\"\r\n\t\tcodeStream next.\r\n\t\t^self testLines: codeStream in: page\r\n\t].\r\n\r\n\tcommentStart := $  asComment upTo: $ .\r\n\t(codeStream peekForAll: commentStart) ifTrue: [ \"native eval mode\"\r\n\t\tself note: codeStream nextLine.\r\n\t\t^Smalltalk current eval: codeStream upToEnd\r\n\t].\r\n\r\n\tcodeStream peek = $\" ifTrue: [\r\n\t\tself note: (codeStream next; upTo: $\")\r\n\t].\r\n\t^codeStream fileInto: self","function(self,code,page)\r\nlocal codeStream=nil\r\nlocal commentStart=nil\r\n(function()\r\n\tlocal _s8_value=((code):stream())\r\n\tcodeStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((codeStream):peek()),\".\"))==true then (codeStream):next();\r\nreturn ((self):testLines_in_(codeStream,page)); end;\r\n(function()\r\n\tlocal _s8_value=(((\" \"):asComment()):upTo_(\" \"))\r\n\tcommentStart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((codeStream):peekForAll_(commentStart))==true then (self):note_((codeStream):nextLine());\r\nreturn (((smalltalk.Smalltalk):current()):eval_((codeStream):upToEnd())); end;\r\nif (smalltalk:isObject_equalTo_(((codeStream):peek()),\"\\\"\"))==true then (self):note_((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):next();\r\n\treturn ((_s8_rec):upTo_(\"\\\"\"))\r\nend\r\n)(codeStream)); end;\r\nreturn ((codeStream):fileInto_(self));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"evaluateCode:in:",0
,function(self,code,page)
((function()
return ((self):triggerEvent_with_ifNotHandled_("evaluate:",code,(function()
return ((self):fileInCode_in_(code,page))
end)))
end)):on_do_(smalltalk.Error,(function(ex)
return ((self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Error evaluating code in "),smalltalk:printString_((page)))),":")),(ex):messageText())))
end));
return (self);
end
,"private","evaluateCode: code in: page\r\n\t\" Private - Evaluate the code in code string.\r\n\tThe default action fileIn the code.\r\n\t\"\r\n\r\n\t[\tself\ttriggerEvent: #evaluate: with: code\r\n\t\t\tifNotHandled: [ self fileInCode: code in: page ]\r\n\t] on: Error do: [:ex|\r\n\t\tself note: 'Error evaluating code in '\r\n\t\t\t,page printString ,':'\r\n\t\t\t,ex messageText\r\n\t]","function(self,code,page)\r\n((function()\r\nreturn ((self):triggerEvent_with_ifNotHandled_(\"evaluate:\",code,(function()\r\nreturn ((self):fileInCode_in_(code,page))\r\nend)))\r\nend)):on_do_(smalltalk.Error,(function(ex)\r\nreturn ((self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Error evaluating code in \"),smalltalk:printString_((page)))),\":\")),(ex):messageText())))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"processPage:contents:",0
,function(self,page,stream)
(function()
	local _s8_value=(stream)
	self["@chunkStream"]=_s8_value
	return _s8_value
end)();
(self):triggerEvent_withArguments_("startPage:stream:",(smalltalk.Array):with_with_(page,self["@chunkStream"]));
while not ((function()
return ((stream):atEnd())
end))() do local chunk=nil
(function()
	local _s8_value=((self):nextChunkIn_(stream))
	chunk=_s8_value
	return _s8_value
end)();
(self):evaluateCode_in_(chunk,page); end;
(self):triggerEvent_with_("endPage:",page);
return (self);
end
,"private","processPage: page contents: stream\r\n\t\" Private - Process the page contents (in stream). \"\r\n\r\n\tchunkStream := stream.\r\n\tself\ttriggerEvent: #startPage:stream:\r\n\t\twithArguments: (Array with: page with: chunkStream).\r\n\t[stream atEnd] whileFalse: [ | chunk |\r\n\t\tchunk := self nextChunkIn: stream.\r\n\t\tself evaluateCode: chunk in: page.\r\n\t].\r\n\tself triggerEvent: #endPage: with: page","function(self,page,stream)\r\n(function()\r\n\tlocal _s8_value=(stream)\r\n\tself[\"@chunkStream\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):triggerEvent_withArguments_(\"startPage:stream:\",(smalltalk.Array):with_with_(page,self[\"@chunkStream\"]));\r\nwhile not ((function()\r\nreturn ((stream):atEnd())\r\nend))() do local chunk=nil\r\n(function()\r\n\tlocal _s8_value=((self):nextChunkIn_(stream))\r\n\tchunk=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):evaluateCode_in_(chunk,page); end;\r\n(self):triggerEvent_with_(\"endPage:\",page);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"processPagesDeferred:in:",0
,function(self,pages,swikiName)
local current=nil
if ((pages):isEmpty())==true then return (self); end;
if not (((self):deferred()))==true then return ((self):processPages_in_(pages,swikiName)); end;
(function()
	local _s8_value=((pages):removeFirst())
	current=_s8_value
	return _s8_value
end)();
(self):withSwiki_page_do_(swikiName,(current):first(),(function(data)
if ((self):verbose())==true then (self):note_(smalltalk:printString_(((current):last()))); end;if (smalltalk:isNil_((data)))==true then (self):error_(smalltalk:object_comma_(("Can't read contents at "),smalltalk:printString_(((current):last())))); end;(self):processPage_contents_(current,(data):stream());return (((function()
return ((self):processPages_in_(pages,swikiName))
end)):valueDeferred_(300))
end));
return (self);
end
,"private","processPagesDeferred: pages in: swikiName\r\n\t\" Private - Process the pages found in swiki swikiName. \"\r\n\r\n\t| current |\r\n\tpages isEmpty ifTrue: [ ^self ].\r\n\tself deferred ifFalse: [ ^self processPages: pages in: swikiName ].\r\n\tcurrent := pages removeFirst.\r\n\tself withSwiki: swikiName page: current first do: [:data|\r\n\t\tself verbose ifTrue: [ self note: current last printString ].\r\n\t\tdata isNil ifTrue: [ self error: 'Can''t read contents at ',current last printString ].\r\n\t\tself processPage: current contents: data stream.\r\n\t\t[ self processPages: pages in: swikiName ] valueDeferred: 300\r\n\t]","function(self,pages,swikiName)\r\nlocal current=nil\r\nif ((pages):isEmpty())==true then return (self); end;\r\nif not (((self):deferred()))==true then return ((self):processPages_in_(pages,swikiName)); end;\r\n(function()\r\n\tlocal _s8_value=((pages):removeFirst())\r\n\tcurrent=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):withSwiki_page_do_(swikiName,(current):first(),(function(data)\r\nif ((self):verbose())==true then (self):note_(smalltalk:printString_(((current):last()))); end;if (smalltalk:isNil_((data)))==true then (self):error_(smalltalk:object_comma_((\"Can't read contents at \"),smalltalk:printString_(((current):last())))); end;(self):processPage_contents_(current,(data):stream());return (((function()\r\nreturn ((self):processPages_in_(pages,swikiName))\r\nend)):valueDeferred_(300))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"processPagesIterative:in:",0
,function(self,pages,swikiName)
local current=nil
while ((function()
return (smalltalk:boolean_and_(((pages):notEmpty()),(function()
return (smalltalk:booleanNot_(((self):deferred())))
end)))
end))() do (function()
	local _s8_value=((pages):removeFirst())
	current=_s8_value
	return _s8_value
end)();
(self):withSwiki_page_do_(swikiName,(current):first(),(function(data)
if ((self):verbose())==true then (self):note_(smalltalk:printString_(((current):last()))); end;if (smalltalk:isNil_((data)))==true then (self):error_(smalltalk:object_comma_(("Can't read contents at "),smalltalk:printString_(((current):last())))); end;return ((self):processPage_contents_(current,(data):stream()))
end)); end;
if ((pages):notEmpty())==true then (self):processPages_in_(pages,swikiName); end;
return (self);
end
,"private","processPagesIterative: pages in: swikiName\r\n\t\" Private - Process the pages found in swiki swikiName. \"\r\n\r\n\t| current |\r\n\t[pages notEmpty and: [ self deferred not ]] whileTrue: [\r\n\t\tcurrent := pages removeFirst.\r\n\t\tself withSwiki: swikiName page: current first do: [:data|\r\n\t\t\tself verbose ifTrue: [ self note: current last printString ].\r\n\t\t\tdata isNil ifTrue: [ self error: 'Can''t read contents at ',current last printString ].\r\n\t\t\tself processPage: current contents: data stream.\r\n\t\t].\r\n\t].\r\n\tpages notEmpty ifTrue: [\r\n\t\tself processPages: pages in: swikiName\r\n\t]","function(self,pages,swikiName)\r\nlocal current=nil\r\nwhile ((function()\r\nreturn (smalltalk:boolean_and_(((pages):notEmpty()),(function()\r\nreturn (smalltalk:booleanNot_(((self):deferred())))\r\nend)))\r\nend))() do (function()\r\n\tlocal _s8_value=((pages):removeFirst())\r\n\tcurrent=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):withSwiki_page_do_(swikiName,(current):first(),(function(data)\r\nif ((self):verbose())==true then (self):note_(smalltalk:printString_(((current):last()))); end;if (smalltalk:isNil_((data)))==true then (self):error_(smalltalk:object_comma_((\"Can't read contents at \"),smalltalk:printString_(((current):last())))); end;return ((self):processPage_contents_(current,(data):stream()))\r\nend)); end;\r\nif ((pages):notEmpty())==true then (self):processPages_in_(pages,swikiName); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"processPages:in:",0
,function(self,pages,swikiName)
(function()
	local _s8_value=(pages)
	self["@currentPages"]=_s8_value
	return _s8_value
end)();
(self):triggerEvent_with_("startPages:",self["@currentPages"]);
return (smalltalk:if_true_false_(((self):deferred()),(function()
return ((self):processPagesDeferred_in_(pages,swikiName))
end),(function()
return ((self):processPagesIterative_in_(pages,swikiName))
end)));
end
,"private","processPages: pages in: swikiName\r\n\t\" Private - Process the pages found in swiki swikiName. \"\r\n\r\n\tcurrentPages := pages.\r\n\tself triggerEvent: #startPages: with: currentPages.\r\n\t^self deferred\r\n\t\tifTrue: [ self processPagesDeferred: pages in: swikiName ]\r\n\t\tifFalse: [ self processPagesIterative: pages in: swikiName ]","function(self,pages,swikiName)\r\n(function()\r\n\tlocal _s8_value=(pages)\r\n\tself[\"@currentPages\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):triggerEvent_with_(\"startPages:\",self[\"@currentPages\"]);\r\nreturn (smalltalk:if_true_false_(((self):deferred()),(function()\r\nreturn ((self):processPagesDeferred_in_(pages,swikiName))\r\nend),(function()\r\nreturn ((self):processPagesIterative_in_(pages,swikiName))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"sortedPages:",0
,function(self,entries)
return ((self):triggerEvent_with_ifNotHandled_("sortPages:",entries,(function()
return ((self):defaultSortedPages_(entries))
end)));
end
,"sorting","sortedPages: entries\r\n\t\" Private - Return the page entries sorted by scanning precedence. \"\r\n\r\n\t^self\ttriggerEvent: #sortPages: with: entries\r\n\t\tifNotHandled: [ self defaultSortedPages: entries ]","function(self,entries)\r\nreturn ((self):triggerEvent_with_ifNotHandled_(\"sortPages:\",entries,(function()\r\nreturn ((self):defaultSortedPages_(entries))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"commandsIn:",0
,function(self,title)
return ((self):triggerEvent_with_ifNotHandled_("needsCommandsIn:",title,(function()
return ((self):defaultCommandsIn_(title))
end)));
end
,"commands","commandsIn: title\r\n\t\" Private - Return the commands obtained from title. \"\r\n\r\n\t^self triggerEvent: #needsCommandsIn: with: title ifNotHandled: [\r\n\t\tself defaultCommandsIn: title\r\n\t]","function(self,title)\r\nreturn ((self):triggerEvent_with_ifNotHandled_(\"needsCommandsIn:\",title,(function()\r\nreturn ((self):defaultCommandsIn_(title))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"defaultCommandsIn:",0
,function(self,title)
return ((((title):asArrayOfSubstrings()):inject_into_("",(function(total,each)
return (smalltalk:object_comma_((smalltalk:object_comma_((total),each))," "))
end))):trimBlanks());
end
,"commands","defaultCommandsIn: title\r\n\t\" Private - Return the commands obtained from title. \"\r\n\r\n\t^(title asArrayOfSubstrings inject: ''\r\n\t\tinto: [:total :each| total ,each ,' ' ]) trimBlanks","function(self,title)\r\nreturn ((((title):asArrayOfSubstrings()):inject_into_(\"\",(function(total,each)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((total),each)),\" \"))\r\nend))):trimBlanks());\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"prologueKeys",0
,function(self)
return (smalltalk:newArray({"prologue", "home", "index", "definitions", "definition"}));
end
,"sorting","prologueKeys\r\n\t\" Private - Return the commands used to sort pages. \"\r\n\r\n\t^#(\tprologue\r\n\t\thome index\r\n\t\tdefinitions definition\r\n\t)","function(self)\r\nreturn (smalltalk:newArray({\"prologue\", \"home\", \"index\", \"definitions\", \"definition\"}));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"epilogueKeys",0
,function(self)
return (smalltalk:newArray({"body", "methods", "code", "doIt", "evaluate", "fail", "epilogue"}));
end
,"sorting","epilogueKeys\r\n\t\" Private - Return the commands used to sort pages. \"\r\n\r\n\t^#(\tbody methods\r\n\t\tcode doIt evaluate\r\n\t\tfail epilogue\r\n\t)","function(self)\r\nreturn (smalltalk:newArray({\"body\", \"methods\", \"code\", \"doIt\", \"evaluate\", \"fail\", \"epilogue\"}));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"defaultSortedPages:",0
,function(self,entries)
local map=nil
local result=nil
local add=nil
local addResult=nil
local epilogue=nil
local addEpilogue=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.Array):new())
	epilogue=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.Dictionary):new())
	map=_s8_value
	return _s8_value
end)();
(entries):do_((function(tuple)
local title=nil
(function()
	local _s8_value=((
function(_s8_rec)
	(_s8_rec):upTo_("]");
	return ((_s8_rec):upToEnd())
end
)(((tuple):last()):stream()))
	title=_s8_value
	return _s8_value
end)();return ((map):at_put_((self):commandsIn_(title),tuple))
end));
(function()
	local _s8_value=((function(key,where)
return (smalltalk:if_true_false_(((map):includesKey_(key)),(function()
(where):add_((map):at_(key));return ((map):removeKey_(key))
end),nil))
end))
	add=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((function(key)
return ((add):value_value_(key,result))
end))
	addResult=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((function(key)
return ((add):value_value_(key,epilogue))
end))
	addEpilogue=_s8_value
	return _s8_value
end)();
((self):prologueKeys()):do_((function(each)
return ((addResult):value_(each))
end));
((self):epilogueKeys()):do_((function(each)
return ((addEpilogue):value_(each))
end));
(((map):keys()):sorted()):do_((function(key)
return ((result):add_((map):at_(key)))
end));
(function()
	local _s8_value=(smalltalk:object_comma_((result),epilogue))
	result=_s8_value
	return _s8_value
end)();
return (result);
end
,"sorting","defaultSortedPages: entries\r\n\t\" Private - Return the page entries sorted by default scanning precedence. \"\r\n\r\n\t| map result add addResult epilogue addEpilogue |\r\n\tresult := Array new.\r\n\tepilogue := Array new. \r\n\tmap := Dictionary new.\r\n\tentries do: [:tuple| | title |\r\n\t\ttitle := tuple last stream upTo: $]; upToEnd.\r\n\t\tmap at: (self commandsIn: title) put: tuple\r\n\t].\r\n\tadd := [:key :where| (map includesKey: key) ifTrue: [\r\n\t\t\twhere add: (map at: key).\r\n\t\t\tmap removeKey: key\r\n\t\t].\r\n\t].\r\n\taddResult := [:key| add value: key value: result ].\r\n\taddEpilogue := [:key| add value: key value: epilogue ].\r\n\r\n\tself prologueKeys do: [:each| addResult value: each ].\r\n\tself epilogueKeys do: [:each| addEpilogue value: each ].\r\n\r\n\tmap keys sorted do: [:key| result add: (map at: key) ].\r\n\tresult := result ,epilogue.\r\n\r\n\t\"self note: 'Sorted pages = ' ,result printString.\"\r\n\t^result","function(self,entries)\r\nlocal map=nil\r\nlocal result=nil\r\nlocal add=nil\r\nlocal addResult=nil\r\nlocal epilogue=nil\r\nlocal addEpilogue=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tepilogue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Dictionary):new())\r\n\tmap=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(entries):do_((function(tuple)\r\nlocal title=nil\r\n(function()\r\n\tlocal _s8_value=((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):upTo_(\"]\");\r\n\treturn ((_s8_rec):upToEnd())\r\nend\r\n)(((tuple):last()):stream()))\r\n\ttitle=_s8_value\r\n\treturn _s8_value\r\nend)();return ((map):at_put_((self):commandsIn_(title),tuple))\r\nend));\r\n(function()\r\n\tlocal _s8_value=((function(key,where)\r\nreturn (smalltalk:if_true_false_(((map):includesKey_(key)),(function()\r\n(where):add_((map):at_(key));return ((map):removeKey_(key))\r\nend),nil))\r\nend))\r\n\tadd=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((function(key)\r\nreturn ((add):value_value_(key,result))\r\nend))\r\n\taddResult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((function(key)\r\nreturn ((add):value_value_(key,epilogue))\r\nend))\r\n\taddEpilogue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):prologueKeys()):do_((function(each)\r\nreturn ((addResult):value_(each))\r\nend));\r\n((self):epilogueKeys()):do_((function(each)\r\nreturn ((addEpilogue):value_(each))\r\nend));\r\n(((map):keys()):sorted()):do_((function(key)\r\nreturn ((result):add_((map):at_(key)))\r\nend));\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((result),epilogue))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"processPageAt:",0
,function(self,url)
if ((url):isNumber())==true then return ((self):processPageAt_(smalltalk:printString_((url)))); end;
if not (((url):includes_("/")))==true then local swikiName=nil
local page=nil
(function()
	local _s8_value=((self):defaultSwiki())
	swikiName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.Array):with_with_(url,url))
	page=_s8_value
	return _s8_value
end)();
return ((self):withSwiki_page_do_(swikiName,(page):first(),(function(data)
local pages=nil
(function()
	local _s8_value=((smalltalk.Array):with_(page))
	pages=_s8_value
	return _s8_value
end)();return ((self):processPages_in_(pages,swikiName))
end))); end;
return ((self):processPage_contents_((smalltalk.Array):with_(url),(((self):fileNameAt_(url)):fileContents()):stream()));
end
,"executing","processPageAt: url\r\n\t\" Process code in the swiki page at url. \"\r\n\r\n\turl isNumber ifTrue: [ ^self processPageAt: url printString ].\r\n\t(url includes: $/) ifFalse: [ | swikiName page |\r\n\t\tswikiName := self defaultSwiki.\r\n\t\tpage := Array with: url with: url.\r\n\t\t^self\twithSwiki: swikiName page: page first\r\n\t\t\tdo: [:data| | pages |\r\n\t\t\t\tpages := Array with: page.\r\n\t\t\t\tself processPages: pages in: swikiName\r\n\t\t\t]\r\n\t].\r\n\r\n\t^self\tprocessPage: (Array with: url)\r\n\t\tcontents: (self fileNameAt: url) fileContents stream","function(self,url)\r\nif ((url):isNumber())==true then return ((self):processPageAt_(smalltalk:printString_((url)))); end;\r\nif not (((url):includes_(\"/\")))==true then local swikiName=nil\r\nlocal page=nil\r\n(function()\r\n\tlocal _s8_value=((self):defaultSwiki())\r\n\tswikiName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_with_(url,url))\r\n\tpage=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):withSwiki_page_do_(swikiName,(page):first(),(function(data)\r\nlocal pages=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_(page))\r\n\tpages=_s8_value\r\n\treturn _s8_value\r\nend)();return ((self):processPages_in_(pages,swikiName))\r\nend))); end;\r\nreturn ((self):processPage_contents_((smalltalk.Array):with_(url),(((self):fileNameAt_(url)):fileContents()):stream()));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"process:",0
,function(self,swikiName)
return ((self):process_tagged_(swikiName,nil));
end
,"executing","process: swikiName\r\n\t\" Access the swiki to process code from pages. \"\r\n\r\n\t^self process: swikiName tagged: nil","function(self,swikiName)\r\nreturn ((self):process_tagged_(swikiName,nil));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"process:tagged:",0
,function(self,swikiName,tag)
(self):withPagesIn_tagged_do_(swikiName,tag,(function(pages)
return ((self):processPages_in_(pages,swikiName))
end));
return ("Ok");
end
,"executing","process: swikiName tagged: tag\r\n\t\" Access swiki to run code from pages matching tag. \"\r\n\r\n\tself\twithPagesIn: swikiName tagged: tag\r\n\t\tdo: [:pages| self processPages: pages in: swikiName ].\r\n\t^#Ok","function(self,swikiName,tag)\r\n(self):withPagesIn_tagged_do_(swikiName,tag,(function(pages)\r\nreturn ((self):processPages_in_(pages,swikiName))\r\nend));\r\nreturn (\"Ok\");\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"withPagesIn:tagged:do:",0
,function(self,swikiName,tag,aBlock)
(self):withSwiki_page_do_(swikiName,".pages",(function(data)
local pages=nil
if (smalltalk:isNil_((data)))==true then (self):error_(smalltalk:object_comma_(("Can't read pages of "),swikiName)); end;(function()
	local _s8_value=((self):pagesIn_matching_((data):stream(),tag))
	pages=_s8_value
	return _s8_value
end)();return ((aBlock):evaluateWith_(pages))
end));
return (self);
end
,"executing","withPagesIn: swikiName tagged: tag do: aBlock\r\n\t\" Evaluate aBlock with the pages matching tag in swikiName. \"\r\n\r\n\tself withSwiki: swikiName page: '.pages' do: [:data| | pages |\r\n\t\tdata isNil ifTrue: [ self error: 'Can''t read pages of ',swikiName ].\r\n\t\tpages := self pagesIn: data stream matching: tag.\r\n\t\taBlock evaluateWith: pages\r\n\t]","function(self,swikiName,tag,aBlock)\r\n(self):withSwiki_page_do_(swikiName,\".pages\",(function(data)\r\nlocal pages=nil\r\nif (smalltalk:isNil_((data)))==true then (self):error_(smalltalk:object_comma_((\"Can't read pages of \"),swikiName)); end;(function()\r\n\tlocal _s8_value=((self):pagesIn_matching_((data):stream(),tag))\r\n\tpages=_s8_value\r\n\treturn _s8_value\r\nend)();return ((aBlock):evaluateWith_(pages))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"withPagesIn:category:do:",0
,function(self,swikiName,categ,aBlock)
(self):withSwiki_page_do_(swikiName,".pages",(function(data)
local pages=nil
if (smalltalk:isNil_((data)))==true then (self):error_(smalltalk:object_comma_(("Can't read pages of "),swikiName)); end;(function()
	local _s8_value=((self):pagesIn_matchingCategory_((data):stream(),categ))
	pages=_s8_value
	return _s8_value
end)();return ((aBlock):evaluateWith_(pages))
end));
return (self);
end
,"executing","withPagesIn: swikiName category: categ do: aBlock\r\n\t\" Evaluate aBlock with the pages matching category in swikiName. \"\r\n\r\n\tself withSwiki: swikiName page: '.pages' do: [:data| | pages |\r\n\t\tdata isNil ifTrue: [ self error: 'Can''t read pages of ',swikiName ].\r\n\t\tpages := self pagesIn: data stream matchingCategory: categ.\t\t\r\n\t\taBlock evaluateWith: pages\r\n\t]","function(self,swikiName,categ,aBlock)\r\n(self):withSwiki_page_do_(swikiName,\".pages\",(function(data)\r\nlocal pages=nil\r\nif (smalltalk:isNil_((data)))==true then (self):error_(smalltalk:object_comma_((\"Can't read pages of \"),swikiName)); end;(function()\r\n\tlocal _s8_value=((self):pagesIn_matchingCategory_((data):stream(),categ))\r\n\tpages=_s8_value\r\n\treturn _s8_value\r\nend)();return ((aBlock):evaluateWith_(pages))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"pagesIn:matchingCategory:",0
,function(self,stream,categ)
local result=nil
local cat=nil
local pageNumber=nil
local boolean=nil
local title=nil
local tuple=nil
local tag=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
while not ((function()
return ((stream):atEnd())
end))() do (function()
	local _s8_value=(((stream):upTo_((smalltalk.String):tab())):asNumber())
	pageNumber=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((stream):upTo_((smalltalk.String):tab()))
	boolean=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((stream):nextLine()):trimBlanks())
	title=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):categoryAndTagsFrom_((title):stream()))
	tuple=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((tuple):first())
	cat=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((tuple):second())
	tag=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:isObject_equalTo_((cat),categ)),(function()
return ((result):add_((smalltalk.Array):with_with_with_(pageNumber,cat,tag)))
end),nil); end;
return (result);
end
,"tags","pagesIn: stream matchingCategory: categ\r\n\t\" Private - Returns the pages defined in index stream matching category.\r\n\tThe default implementation parse index stream selecting pages matching category field.\r\n\t\"\r\n\r\n\t| result cat pageNumber boolean title tuple tag |\r\n\tresult := Array new.\r\n\t[stream atEnd] whileFalse: [ \r\n\t\tpageNumber := (stream upTo: String tab) asNumber.\r\n\t\tboolean := stream upTo: String tab.\r\n\t\ttitle := stream nextLine trimBlanks.\r\n\t\ttuple := self categoryAndTagsFrom:  title stream.\r\n\t\tcat := tuple first.\r\n\t\ttag := tuple second.\r\n\t\tcat = categ ifTrue:[\r\n\t\t\tresult add: (Array with: pageNumber with: cat with: tag)\r\n\t\t]\r\n\t].\r\n\t^result","function(self,stream,categ)\r\nlocal result=nil\r\nlocal cat=nil\r\nlocal pageNumber=nil\r\nlocal boolean=nil\r\nlocal title=nil\r\nlocal tuple=nil\r\nlocal tag=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((stream):atEnd())\r\nend))() do (function()\r\n\tlocal _s8_value=(((stream):upTo_((smalltalk.String):tab())):asNumber())\r\n\tpageNumber=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((stream):upTo_((smalltalk.String):tab()))\r\n\tboolean=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((stream):nextLine()):trimBlanks())\r\n\ttitle=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):categoryAndTagsFrom_((title):stream()))\r\n\ttuple=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((tuple):first())\r\n\tcat=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((tuple):second())\r\n\ttag=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:isObject_equalTo_((cat),categ)),(function()\r\nreturn ((result):add_((smalltalk.Array):with_with_with_(pageNumber,cat,tag)))\r\nend),nil); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"do:withPagesIn:tagged:",0
,function(self,aBlock,swikiName,tag)
return ((self):withPagesIn_tagged_do_(swikiName,tag,aBlock));
end
,"obsolete","do: aBlock withPagesIn: swikiName tagged: tag\r\n\t\" Evaluate aBlock with the pages matching tag in swikiName. \"\r\n\r\n\t^self withPagesIn: swikiName tagged: tag do: aBlock","function(self,aBlock,swikiName,tag)\r\nreturn ((self):withPagesIn_tagged_do_(swikiName,tag,aBlock));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"u8ServicePathName",0
,function(self)
if ((smalltalk.Smalltalk):includesKey_("U8Object"))==true then return (smalltalk:object_comma_(((smalltalk.U8Object):home()),"/profile/")); end;
return ("http://u8.smalltalking.net/profile/");
end
,"filenames","u8ServicePathName\r\n\t\" Private - Returns the root path name for U8 service files. \"\r\n\r\n\t(Smalltalk includesKey: #U8Object) ifTrue: [\r\n\t\t^U8Object home ,'/profile/'\r\n\t].\r\n\t^'http://u8.smalltalking.net/profile/'","function(self)\r\nif ((smalltalk.Smalltalk):includesKey_(\"U8Object\"))==true then return (smalltalk:object_comma_(((smalltalk.U8Object):home()),\"/profile/\")); end;\r\nreturn (\"http://u8.smalltalking.net/profile/\");\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"swikiServicePathName",0
,function(self)
return (smalltalk:if_true_false_(((smalltalk.Smalltalk):includesKey_("U8Object")),(function()
return ((smalltalk.U8Object):swikiHostURL())
end),(function()
return ("http://swiki.smalltalking.net/")
end)));
end
,"filenames","swikiServicePathName\r\n\t\" Private - Returns the root path name for swiki service files. \"\r\n\r\n\t^(Smalltalk includesKey: #U8Object)\r\n\tifTrue: [ U8Object swikiHostURL ]\r\n\tifFalse: [ 'http://swiki.smalltalking.net/' ]","function(self)\r\nreturn (smalltalk:if_true_false_(((smalltalk.Smalltalk):includesKey_(\"U8Object\")),(function()\r\nreturn ((smalltalk.U8Object):swikiHostURL())\r\nend),(function()\r\nreturn (\"http://swiki.smalltalking.net/\")\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"fileNameAt:",0
,function(self,aPlace)
if (smalltalk:isObject_equalTo_(((aPlace):indexOf_("u8:")),1))==true then return (smalltalk:object_comma_(((self):u8ServicePathName()),(aPlace):copyFrom_to_(4,(aPlace):size()))); end;
if (smalltalk:isObject_equalTo_(((aPlace):indexOf_("swiki:")),1))==true then return (smalltalk:object_comma_(((self):swikiServicePathName()),((aPlace):copyFrom_to_(7,(aPlace):size())):copyWithout_(" "))); end;
return (aPlace);
end
,"filenames","fileNameAt: aPlace\r\n\t\" Private - Return the complete path for file at aPlace. \"\r\n\r\n\t(aPlace indexOf: #u8:) = 1 ifTrue: [\r\n\t\t^self u8ServicePathName\r\n\t\t\t,(aPlace copyFrom: 4 to: aPlace size)\r\n\t].\r\n\t(aPlace indexOf: #swiki:) = 1 ifTrue: [\r\n\t\t^self swikiServicePathName\r\n\t\t\t,((aPlace copyFrom: 7 to: aPlace size)\r\n\t\t\t\tcopyWithout: $ )\r\n\t].\r\n\t^aPlace","function(self,aPlace)\r\nif (smalltalk:isObject_equalTo_(((aPlace):indexOf_(\"u8:\")),1))==true then return (smalltalk:object_comma_(((self):u8ServicePathName()),(aPlace):copyFrom_to_(4,(aPlace):size()))); end;\r\nif (smalltalk:isObject_equalTo_(((aPlace):indexOf_(\"swiki:\")),1))==true then return (smalltalk:object_comma_(((self):swikiServicePathName()),((aPlace):copyFrom_to_(7,(aPlace):size())):copyWithout_(\" \"))); end;\r\nreturn (aPlace);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"load:",0
,function(self,fileName)
local index=nil
(function()
	local _s8_value=((fileName):lastIndexOf_("."))
	index=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((index),0))==true then return ((self):load_(smalltalk:object_comma_((fileName),".st.js"))); end;
return ((self):triggerEvent_with_ifNotHandled_("load:",fileName,(function()
return ((self):basicLoad_((self):fileNameAt_(fileName)))
end)));
end
,"loading","load: fileName\r\n\t\" Private - Load the file at fileName. \"\r\n\r\n\t| index |\r\n\tindex := fileName lastIndexOf: $. .\r\n\tindex = 0 ifTrue: [ ^self load: fileName ,'.st.js' ].\r\n\t^self triggerEvent: #load: with: fileName ifNotHandled: [\r\n\t\tself basicLoad: (self fileNameAt: fileName)\r\n\t]","function(self,fileName)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((fileName):lastIndexOf_(\".\"))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((index),0))==true then return ((self):load_(smalltalk:object_comma_((fileName),\".st.js\"))); end;\r\nreturn ((self):triggerEvent_with_ifNotHandled_(\"load:\",fileName,(function()\r\nreturn ((self):basicLoad_((self):fileNameAt_(fileName)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"fileContentsAt:",0
,function(self,fileName)
return ((self):triggerEvent_with_ifNotHandled_("needsFileContents:",fileName,(function()
return ((fileName):fileContents())
end)));
end
,"loading","fileContentsAt: fileName\r\n\t\" Private - Return the contents of the file at fileName. \"\r\n\r\n\t^self\r\n\t\ttriggerEvent: #needsFileContents:\r\n\t\twith: fileName\r\n\t\tifNotHandled: [ fileName fileContents ]","function(self,fileName)\r\nreturn ((self):triggerEvent_with_ifNotHandled_(\"needsFileContents:\",fileName,(function()\r\nreturn ((fileName):fileContents())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"loadedWithConfiguration:",0
,function(self,fileName)
if not (((smalltalk.Smalltalk):includesKey_("U8Configuration")))==true then return (false); end;
if not ((smalltalk:responds_to_((smalltalk.U8Configuration),("default"))))==true then return (false); end;
return (((smalltalk.U8Configuration):default()):loadFile_(fileName));
end
,"loading","loadedWithConfiguration: fileName\r\n\t\" Private - Return true if the file at fileName has been loaded with U8Configuration. \"\r\n\r\n\t(Smalltalk includesKey: #U8Configuration) ifFalse: [ ^false ].\r\n\t(U8Configuration respondsTo: #default) ifFalse: [ ^false ].\r\n\t^U8Configuration default loadFile: fileName","function(self,fileName)\r\nif not (((smalltalk.Smalltalk):includesKey_(\"U8Configuration\")))==true then return (false); end;\r\nif not ((smalltalk:responds_to_((smalltalk.U8Configuration),(\"default\"))))==true then return (false); end;\r\nreturn (((smalltalk.U8Configuration):default()):loadFile_(fileName));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"basicLoad:",0
,function(self,fileName)
local ext=nil
local index=nil
local code=nil
if ((self):loadedWithConfiguration_(fileName))==true then return (self); end;
(function()
	local _s8_value=((self):fileContentsAt_(fileName))
	code=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((code)))==true then return ((self):error_(smalltalk:object_comma_(("Code not found at "),fileName))); end;
(function()
	local _s8_value=((fileName):lastIndexOf_("."))
	index=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((fileName):copyFrom_to_((index):_plus(1),(fileName):size())):asLowercase())
	ext=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((ext),"st"))==true then return (((code):stream()):fileIn()); end;
if (smalltalk:isObject_equalTo_((ext),"js"))==true then return (((smalltalk.Compiler):new()):eval_(code)); end;
return ((self):error_(smalltalk:object_comma_(("Invalid file extension "),(ext):asLiteral())));
end
,"loading","basicLoad: fileName\r\n\t\" Private - Load the file at fileName. \"\r\n\r\n\t| ext index code |\r\n\t(self loadedWithConfiguration: fileName) ifTrue: [ ^self ].\r\n\tcode := self fileContentsAt: fileName.\r\n\tcode isNil ifTrue: [\r\n\t\t^self error: 'Code not found at ', fileName\r\n\t].\r\n\tindex := fileName lastIndexOf: $..\r\n\text := (fileName copyFrom: index + 1 to: fileName size) asLowercase.\r\n\text = #st ifTrue: [ ^code stream fileIn ].\r\n\text = #js ifTrue: [ ^Compiler new eval: code ].\r\n\t^self error: 'Invalid file extension ',ext asLiteral","function(self,fileName)\r\nlocal ext=nil\r\nlocal index=nil\r\nlocal code=nil\r\nif ((self):loadedWithConfiguration_(fileName))==true then return (self); end;\r\n(function()\r\n\tlocal _s8_value=((self):fileContentsAt_(fileName))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((code)))==true then return ((self):error_(smalltalk:object_comma_((\"Code not found at \"),fileName))); end;\r\n(function()\r\n\tlocal _s8_value=((fileName):lastIndexOf_(\".\"))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((fileName):copyFrom_to_((index):_plus(1),(fileName):size())):asLowercase())\r\n\text=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((ext),\"st\"))==true then return (((code):stream()):fileIn()); end;\r\nif (smalltalk:isObject_equalTo_((ext),\"js\"))==true then return (((smalltalk.Compiler):new()):eval_(code)); end;\r\nreturn ((self):error_(smalltalk:object_comma_((\"Invalid file extension \"),(ext):asLiteral())));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"require:in:ifAbsent:",0
,function(self,names,places,errorBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local what=nil
local result=nil
local remaining=nil
if ((names):isString())==true then (function()
	local _s8_value=((names):asArrayOfSubstrings())
	what=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):require_in_ifAbsent_(what,places,errorBlock))
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_and_((smalltalk:notNil_((result))),(function()
return (smalltalk:isObject_equalTo_(((what):size()),1))
end)))==true then return ((result):first()); end;
return (result); end;
if ((places):isString())==true then return ((self):require_in_ifAbsent_(names,(smalltalk.Array):with_(places),errorBlock)); end;
(function()
	local _s8_value=(((names):asArray()):copy())
	what=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((places):collect_((function(each)
return ((self):fileNameAt_(each))
end)))
	remaining=_s8_value
	return _s8_value
end)();
while ((function()
return (smalltalk:boolean_and_(((what):notEmpty()),(function()
return ((remaining):notEmpty())
end)))
end))() do (function()
	local _s8_value=((what):reject_((function(each)
return ((smalltalk.Smalltalk):includesKey_(each))
end)))
	what=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_(((what):notEmpty()),(function()
return ((self):load_((remaining):removeFirst()))
end),nil); end;
(function()
	local _s8_value=((names):collect_((function(each)
return ((smalltalk.Smalltalk):at_ifAbsent_(each,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((errorBlock):evaluateWith_(each))
end
)()
error(_s8Ret_,0)
end)())
end)))
end)))
	result=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"tools","require: names in: places ifAbsent: errorBlock\r\n\t\" Ensure the globals in names are present.\r\n\tIf there is a name missing, will try to load code from places\r\n\t until all the names are present.\r\n\tReturn the objects with that names or the result of evaluating errorBlock.\r\n\t\"\r\n\r\n\t| what result remaining |\r\n\tnames isString ifTrue: [\r\n\t\twhat := names asArrayOfSubstrings.\r\n\t\tresult := self require: what in: places ifAbsent: errorBlock.\r\n\t\t(result notNil and: [ what size = 1 ]) ifTrue: [ ^result first ].\r\n\t\t^result\r\n\t].\r\n\tplaces isString ifTrue: [\r\n\t\t^self\r\n\t\t\trequire: names\r\n\t\t\tin: (Array with: places)\r\n\t\t\tifAbsent: errorBlock\r\n\t].\r\n\twhat := names asArray copy.\r\n\tremaining := places collect: [:each| self fileNameAt: each ].\r\n\t[what notEmpty and: [remaining notEmpty]] whileTrue: [\r\n\t\twhat := what reject: [:each| Smalltalk includesKey: each ].\r\n\t\twhat notEmpty ifTrue: [ self load: remaining removeFirst ].\r\n\t].\r\n\tresult := names collect: [:each|\r\n\t\tSmalltalk at: each ifAbsent: [ ^errorBlock evaluateWith: each ]\r\n\t].\r\n\t^result","function(self,names,places,errorBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal what=nil\r\nlocal result=nil\r\nlocal remaining=nil\r\nif ((names):isString())==true then (function()\r\n\tlocal _s8_value=((names):asArrayOfSubstrings())\r\n\twhat=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):require_in_ifAbsent_(what,places,errorBlock))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((result))),(function()\r\nreturn (smalltalk:isObject_equalTo_(((what):size()),1))\r\nend)))==true then return ((result):first()); end;\r\nreturn (result); end;\r\nif ((places):isString())==true then return ((self):require_in_ifAbsent_(names,(smalltalk.Array):with_(places),errorBlock)); end;\r\n(function()\r\n\tlocal _s8_value=(((names):asArray()):copy())\r\n\twhat=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((places):collect_((function(each)\r\nreturn ((self):fileNameAt_(each))\r\nend)))\r\n\tremaining=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (smalltalk:boolean_and_(((what):notEmpty()),(function()\r\nreturn ((remaining):notEmpty())\r\nend)))\r\nend))() do (function()\r\n\tlocal _s8_value=((what):reject_((function(each)\r\nreturn ((smalltalk.Smalltalk):includesKey_(each))\r\nend)))\r\n\twhat=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_(((what):notEmpty()),(function()\r\nreturn ((self):load_((remaining):removeFirst()))\r\nend),nil); end;\r\n(function()\r\n\tlocal _s8_value=((names):collect_((function(each)\r\nreturn ((smalltalk.Smalltalk):at_ifAbsent_(each,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((errorBlock):evaluateWith_(each))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"require:ifAbsent:",0
,function(self,names,aBlock)
return ((self):require_in_ifAbsent_(names,smalltalk:newArray({}),aBlock));
end
,"tools","require: names ifAbsent: aBlock\r\n\t\" Ensure the globals in names are present.\r\n\tIf a name do not exist returns the result of evaluating aBlock\r\n\t\"\r\n\r\n\t^self require: names in: #() ifAbsent: aBlock","function(self,names,aBlock)\r\nreturn ((self):require_in_ifAbsent_(names,smalltalk:newArray({}),aBlock));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"require:in:",0
,function(self,names,places)
return ((self):require_in_ifAbsent_(names,places,(function(aName)
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_(("Missing global #"),aName)),smalltalk:if_true_false_(((places):notEmpty()),(function()
return (smalltalk:object_comma_((" in "),smalltalk:printString_((places))))
end),(function()
return ("")
end)))))
end)));
end
,"tools","require: names in: places\r\n\t\" Ensure the globals in names are present. \"\r\n\r\n\t^self require: names in: places ifAbsent: [:aName|\r\n\t\tself error: 'Missing global #' ,aName\r\n\t\t\t,(places notEmpty\r\n\t\t\t\tifTrue: [' in ',places printString]\r\n\t\t\t\tifFalse: [''])\r\n\t]","function(self,names,places)\r\nreturn ((self):require_in_ifAbsent_(names,places,(function(aName)\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((\"Missing global #\"),aName)),smalltalk:if_true_false_(((places):notEmpty()),(function()\r\nreturn (smalltalk:object_comma_((\" in \"),smalltalk:printString_((places))))\r\nend),(function()\r\nreturn (\"\")\r\nend)))))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"require:",0
,function(self,names)
return ((self):require_in_(names,smalltalk:newArray({})));
end
,"tools","require: names\r\n\t\" Ensure the globals in names are present. \"\r\n\r\n\t^self require: names in: #()","function(self,names)\r\nreturn ((self):require_in_(names,smalltalk:newArray({})));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"abort",0
,function(self)
(self):aborted_(true);
return ((self):cancelFileIn());
end
,"executing","abort\r\n\t\" Abort current execution. \"\r\n\r\n\tself aborted: true.\r\n\t^self cancelFileIn","function(self)\r\n(self):aborted_(true);\r\nreturn ((self):cancelFileIn());\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"abortPage",0
,function(self)
if (smalltalk:notNil_((self["@chunkStream"])))==true then (self["@chunkStream"]):upToEnd(); end;
return ((self):error_("Page execution aborted"));
end
,"executing","abortPage\r\n\t\" Abort execution of the page. \"\r\n\r\n\tchunkStream notNil ifTrue: [ chunkStream upToEnd ].\r\n\t^self error: 'Page execution aborted'","function(self)\r\nif (smalltalk:notNil_((self[\"@chunkStream\"])))==true then (self[\"@chunkStream\"]):upToEnd(); end;\r\nreturn ((self):error_(\"Page execution aborted\"));\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"selectPages:",0
,function(self,aBlock)
if ((aBlock):isString())==true then return ((self):selectPages_((function(page)
return (((page):last()):includes_(aBlock))
end))); end;
if (smalltalk:isNil_((self["@currentPages"])))==true then return (self); end;
(self["@currentPages"]):removeAll_((self["@currentPages"]):reject_(aBlock));
return (self);
end
,"pages","selectPages: aBlock\r\n\t\" Set the pages of the receiver with the pages selected with aBlock. \"\r\n\r\n\taBlock isString ifTrue: [\r\n\t\t^self selectPages: [:page| page last includes: aBlock ]\r\n\t].\r\n\tcurrentPages isNil ifTrue: [ ^self ].\r\n\tcurrentPages removeAll: (currentPages reject: aBlock)","function(self,aBlock)\r\nif ((aBlock):isString())==true then return ((self):selectPages_((function(page)\r\nreturn (((page):last()):includes_(aBlock))\r\nend))); end;\r\nif (smalltalk:isNil_((self[\"@currentPages\"])))==true then return (self); end;\r\n(self[\"@currentPages\"]):removeAll_((self[\"@currentPages\"]):reject_(aBlock));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SwikiCodeRobot,"rejectPages:",0
,function(self,aBlock)
if ((aBlock):isString())==true then return ((self):rejectPages_((function(page)
return (((page):last()):includes_(aBlock))
end))); end;
if (smalltalk:isNil_((self["@currentPages"])))==true then return (self); end;
(self["@currentPages"]):removeAll_((self["@currentPages"]):select_(aBlock));
return (self);
end
,"pages","rejectPages: aBlock\r\n\t\" Set the pages of the receiver with the pages rejected with aBlock. \"\r\n\r\n\taBlock isString ifTrue: [\r\n\t\t^self rejectPages: [:page| page last includes: aBlock ]\r\n\t].\r\n\tcurrentPages isNil ifTrue: [ ^self ].\r\n\tcurrentPages removeAll: (currentPages select: aBlock)","function(self,aBlock)\r\nif ((aBlock):isString())==true then return ((self):rejectPages_((function(page)\r\nreturn (((page):last()):includes_(aBlock))\r\nend))); end;\r\nif (smalltalk:isNil_((self[\"@currentPages\"])))==true then return (self); end;\r\n(self[\"@currentPages\"]):removeAll_((self[\"@currentPages\"]):select_(aBlock));\r\nreturn (self);\r\nend")
