
-- fileIn("s8/library/systemServer/SystemServer.st")
smalltalk:addClass("SystemChangesManager",smalltalk.EventManager,smalltalk:newArray({"systemChanges"}),"SystemServer")

smalltalk:bind(smalltalk.SystemChangesManager,"classChanged:",0
,function(self,aBehavior)
return ((self):systemHasChanged_((smalltalk.Array):with_with_("classChanged:",aBehavior)));
end
,"tracking-classes","classChanged: aBehavior\r\n\t\" Private - aBehavior has been changed. \"\r\n\r\n\t^self systemHasChanged: (Array with: #classChanged: with: aBehavior)","function(self,aBehavior)\r\nreturn ((self):systemHasChanged_((smalltalk.Array):with_with_(\"classChanged:\",aBehavior)));\r\nend")

smalltalk:bind(smalltalk.SystemChangesManager,"methodBound:to:",0
,function(self,aMethod,aClass)
if (smalltalk:boolean_or_((smalltalk:isNil_((aMethod))),(function()
return (smalltalk:isObject_equalTo_(((aMethod):selector()),(smalltalk.String):doItSelector()))
end)))==true then return (self); end;
return ((self):systemHasChanged_((smalltalk.Array):with_with_with_("methodBound:to:",aMethod,aClass)));
end
,"tracking-methods","methodBound: aMethod to: aClass\r\n\t\" Private - The method has been bound to aClass. \"\r\n\r\n\t(aMethod isNil or: [ aMethod selector = String doItSelector ]) ifTrue: [ ^self \"ignored\" ].\r\n\t^self systemHasChanged: (Array with: #methodBound:to: with: aMethod with: aClass)","function(self,aMethod,aClass)\r\nif (smalltalk:boolean_or_((smalltalk:isNil_((aMethod))),(function()\r\nreturn (smalltalk:isObject_equalTo_(((aMethod):selector()),(smalltalk.String):doItSelector()))\r\nend)))==true then return (self); end;\r\nreturn ((self):systemHasChanged_((smalltalk.Array):with_with_with_(\"methodBound:to:\",aMethod,aClass)));\r\nend")

smalltalk:bind(smalltalk.SystemChangesManager,"methodRemoved:from:",0
,function(self,aMethod,aClass)
if (smalltalk:boolean_or_((smalltalk:isNil_((aMethod))),(function()
return (smalltalk:isObject_equalTo_(((aMethod):selector()),(smalltalk.String):doItSelector()))
end)))==true then return (self); end;
return ((self):systemHasChanged_((smalltalk.Array):with_with_with_("methodRemoved:from:",aMethod,aClass)));
end
,"tracking-methods","methodRemoved: aMethod from: aClass\r\n\t\" Private - The method has been removed from aClass. \"\r\n\r\n\t(aMethod isNil or: [ aMethod selector = String doItSelector ]) ifTrue: [ ^self \"ignored\" ].\r\n\t^self systemHasChanged: (Array with: #methodRemoved:from: with: aMethod with: aClass)","function(self,aMethod,aClass)\r\nif (smalltalk:boolean_or_((smalltalk:isNil_((aMethod))),(function()\r\nreturn (smalltalk:isObject_equalTo_(((aMethod):selector()),(smalltalk.String):doItSelector()))\r\nend)))==true then return (self); end;\r\nreturn ((self):systemHasChanged_((smalltalk.Array):with_with_with_(\"methodRemoved:from:\",aMethod,aClass)));\r\nend")

smalltalk:bind(smalltalk.SystemChangesManager,"memoryWarning:",0
,function(self,anArgument)
return ((self):systemHasChanged_((smalltalk.Array):with_with_("memoryWarning:",anArgument)));
end
,"tracking-methods","memoryWarning: anArgument\r\n\t\" Private - A memory warning event has been thrown. \"\r\n\r\n\t^self systemHasChanged: (Array with: #memoryWarning: with: anArgument)","function(self,anArgument)\r\nreturn ((self):systemHasChanged_((smalltalk.Array):with_with_(\"memoryWarning:\",anArgument)));\r\nend")

smalltalk:bind(smalltalk.SystemChangesManager,"processSystemChanges:",0
,function(self,changes)
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("processSystemChanges:")," ")),smalltalk:asString_((changes))))," MUST be implemented at ")),((self)["$klass"]):name()));
return (self);
end
,"system changes","processSystemChanges: changes\r\n\t\" Private - Update reflecting system changes. \"\r\n\r\n\tself note: #processSystemChanges:\r\n\t\t,' ', changes asString\r\n\t\t,' MUST be implemented at '\r\n\t\t,self class name","function(self,changes)\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"processSystemChanges:\"),\" \")),smalltalk:asString_((changes)))),\" MUST be implemented at \")),((self)[\"$klass\"]):name()));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemChangesManager,"changesDo:",0
,function(self,aOneArgumentBlock)
local changes=nil
(function()
	local _s8_value=(self["@systemChanges"])
	changes=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_and_((smalltalk:notNil_((changes))),(function()
return ((changes):notEmpty())
end)))==true then (function()
	local _s8_value=(nil)
	self["@systemChanges"]=_s8_value
	return _s8_value
end)();
(aOneArgumentBlock):value_(changes); end;
return (self);
end
,"changes","changesDo: aOneArgumentBlock\r\n\t\" Private - Process the changes with aOneArgumentBlock. \"\r\n\t\r\n\t| changes |\r\n\tchanges := systemChanges.\r\n\t(changes notNil and: [changes notEmpty]) ifTrue: [\r\n\t\tsystemChanges := nil.\r\n\t\taOneArgumentBlock value: changes\r\n\t].","function(self,aOneArgumentBlock)\r\nlocal changes=nil\r\n(function()\r\n\tlocal _s8_value=(self[\"@systemChanges\"])\r\n\tchanges=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((changes))),(function()\r\nreturn ((changes):notEmpty())\r\nend)))==true then (function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@systemChanges\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aOneArgumentBlock):value_(changes); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemChangesManager,"processTheChanges",0
,function(self)
return ((self):changesDo_((function(changes)
return ((self):processSystemChanges_(changes))
end)));
end
,"changes","processTheChanges\r\n\t\" Private - Process the changes. \"\r\n\t\r\n\t^self changesDo: [:changes| self processSystemChanges: changes ]","function(self)\r\nreturn ((self):changesDo_((function(changes)\r\nreturn ((self):processSystemChanges_(changes))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SystemChangesManager,"processSystemChanges",0
,function(self)
((function()
return ((self):processTheChanges())
end)):valueDeferred_(750);
return (self);
end
,"system changes","processSystemChanges\r\n\t\" Private - The receiver has changes to be processed.\r\n\tThe default action is to defer proccessing of the changes.\r\n\tThis method can be overwritten/refined by subclasses to implement alternatives of change management.\r\n\t\"\r\n\t\r\n\t[ self processTheChanges ] valueDeferred: 750.","function(self)\r\n((function()\r\nreturn ((self):processTheChanges())\r\nend)):valueDeferred_(750);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemChangesManager,"systemHasChanged:",0
,function(self,aSystemChange)
if (smalltalk:notNil_((self["@systemChanges"])))==true then return ((self["@systemChanges"]):add_(aSystemChange)); end;
(function()
	local _s8_value=((smalltalk.Array):with_(aSystemChange))
	self["@systemChanges"]=_s8_value
	return _s8_value
end)();
(self):processSystemChanges();
return (self);
end
,"system changes","systemHasChanged: aSystemChange\r\n\t\" Private - Signal a event of system change to be resolved in the future. \"\r\n\r\n\tsystemChanges notNil ifTrue: [\r\n\t\t^systemChanges add: aSystemChange\r\n\t].\r\n\tsystemChanges := Array with: aSystemChange.\r\n\tself processSystemChanges.","function(self,aSystemChange)\r\nif (smalltalk:notNil_((self[\"@systemChanges\"])))==true then return ((self[\"@systemChanges\"]):add_(aSystemChange)); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_(aSystemChange))\r\n\tself[\"@systemChanges\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):processSystemChanges();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemChangesManager,"bindSystemManager",0
,function(self)
(((smalltalk.SystemManager):eventsTriggered()):copyWithout_("changed")):do_((function(each)
return (smalltalk:if_true_false_((smalltalk:responds_to_((self),(each))),(function()
return (((smalltalk.SystemManager):current()):when_send_to_(each,each,self))
end),nil))
end));
return (self);
end
,"system changes","bindSystemManager\r\n\t\" Private - Set the receiver to start listening current system changes.\r\n\tNote: Only the events implemented by the receiver will be hooked.\r\n\t\"\r\n\r\n\t(SystemManager eventsTriggered copyWithout: #changed) do: [:each|\r\n\t\t(self respondsTo: each) ifTrue: [\r\n\t\t\tSystemManager current when: each send: each to: self\r\n\t\t]\r\n\t]","function(self)\r\n(((smalltalk.SystemManager):eventsTriggered()):copyWithout_(\"changed\")):do_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:responds_to_((self),(each))),(function()\r\nreturn (((smalltalk.SystemManager):current()):when_send_to_(each,each,self))\r\nend),nil))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemChangesManager,"unbindSystemManager",0
,function(self)
local aManager=nil
(function()
	local _s8_value=((smalltalk.SystemManager):currentOrNil())
	aManager=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((aManager)))==true then (aManager):removeAllActionsWithReceiver_(self); end;
return (self);
end
,"system changes","unbindSystemManager\r\n\t\" Private - rest the link from the receiver to system changes. \"\r\n\r\n\t| aManager |\r\n\taManager := SystemManager currentOrNil.\r\n\taManager notNil ifTrue: [ aManager removeAllActionsWithReceiver: self ]","function(self)\r\nlocal aManager=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.SystemManager):currentOrNil())\r\n\taManager=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((aManager)))==true then (aManager):removeAllActionsWithReceiver_(self); end;\r\nreturn (self);\r\nend")

smalltalk:addClass("SystemServer",smalltalk.SystemChangesManager,smalltalk:newArray({"server","port","methodReferences","cache"}),"SystemServer")

smalltalk.SystemServer["$klass"]["$iVarNames"]=smalltalk:newArray({"current","silent","platform","port"})

smalltalk:bind(smalltalk.SystemServer["$klass"],"initializeCurrent",0
,function(self)
(function()
	local _s8_value=((self):new())
	self["@current"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeCurrent\r\n\t\" Private - Initialize the current of the receiver. \"\r\n\r\n\tcurrent := self new","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):new())\r\n\tself[\"@current\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"current",0
,function(self)
if (smalltalk:isNil_((self["@current"])))==true then (self):initializeCurrent(); end;
return (self["@current"]);
end
,"accessing","current\r\n\t\" Return the current of the receiver. \"\r\n\r\n\tcurrent isNil ifTrue: [ self initializeCurrent ].\r\n\t^current","function(self)\r\nif (smalltalk:isNil_((self[\"@current\"])))==true then (self):initializeCurrent(); end;\r\nreturn (self[\"@current\"]);\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"current:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@current"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","current: anObject\r\n\t\" Set the current of the receiver. \"\r\n\r\n\tcurrent := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@current\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"initializeSilent",0
,function(self)
(function()
	local _s8_value=(true)
	self["@silent"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeSilent\r\n\t\" Private - Initialize the silent of the receiver. \"\r\n\r\n\tsilent := true","function(self)\r\n(function()\r\n\tlocal _s8_value=(true)\r\n\tself[\"@silent\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"silent",0
,function(self)
if (smalltalk:isNil_((self["@silent"])))==true then (self):initializeSilent(); end;
return (self["@silent"]);
end
,"accessing","silent\r\n\t\" Return the silent of the receiver. \"\r\n\r\n\tsilent isNil ifTrue: [ self initializeSilent ].\r\n\t^silent","function(self)\r\nif (smalltalk:isNil_((self[\"@silent\"])))==true then (self):initializeSilent(); end;\r\nreturn (self[\"@silent\"]);\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"silent:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@silent"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","silent: anObject\r\n\t\" Set the silent of the receiver. \"\r\n\r\n\tsilent := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@silent\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"initializePlatform",0
,function(self)
(function()
	local _s8_value=((self):detectedPlatform())
	self["@platform"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializePlatform\r\n\t\" Private - Initialize the platform of the receiver. \"\r\n\r\n\tplatform := self detectedPlatform","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):detectedPlatform())\r\n\tself[\"@platform\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"platform",0
,function(self)
if (smalltalk:isNil_((self["@platform"])))==true then (self):initializePlatform(); end;
return (self["@platform"]);
end
,"accessing","platform\r\n\t\" Return the platform of the receiver. \"\r\n\r\n\tplatform isNil ifTrue: [ self initializePlatform ].\r\n\t^platform","function(self)\r\nif (smalltalk:isNil_((self[\"@platform\"])))==true then (self):initializePlatform(); end;\r\nreturn (self[\"@platform\"]);\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"platform:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@platform"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","platform: anObject\r\n\t\" Set the platform of the receiver. \"\r\n\r\n\tplatform := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@platform\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"initializePort",0
,function(self)
(function()
	local _s8_value=(8088)
	self["@port"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializePort\r\n\t\" Private - Initialize the port of the receiver. \"\r\n\r\n\tport := 8088","function(self)\r\n(function()\r\n\tlocal _s8_value=(8088)\r\n\tself[\"@port\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"port",0
,function(self)
if (smalltalk:isNil_((self["@port"])))==true then (self):initializePort(); end;
return (self["@port"]);
end
,"accessing","port\r\n\t\" Return the port of the receiver. \"\r\n\r\n\tport isNil ifTrue: [ self initializePort ].\r\n\t^port","function(self)\r\nif (smalltalk:isNil_((self[\"@port\"])))==true then (self):initializePort(); end;\r\nreturn (self[\"@port\"]);\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"port:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@port"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","port: anObject\r\n\t\" Set the port of the receiver. \"\r\n\r\n\tport := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@port\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"initializePort",0
,function(self)
(function()
	local _s8_value=(((self)["$klass"]):port())
	self["@port"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializePort\r\n\t\" Private - Initialize the port of the receiver. \"\r\n\r\n\tport := self class port","function(self)\r\n(function()\r\n\tlocal _s8_value=(((self)[\"$klass\"]):port())\r\n\tself[\"@port\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"port",0
,function(self)
if (smalltalk:isNil_((self["@port"])))==true then (self):initializePort(); end;
return (self["@port"]);
end
,"accessing","port\r\n\t\" Return the port of the receiver. \"\r\n\r\n\tport isNil ifTrue: [ self initializePort ].\r\n\t^port","function(self)\r\nif (smalltalk:isNil_((self[\"@port\"])))==true then (self):initializePort(); end;\r\nreturn (self[\"@port\"]);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"port:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@port"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","port: anObject\r\n\t\" Set the port of the receiver. \"\r\n\r\n\tport := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@port\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"initializeMethodReferences",0
,function(self)
(function()
	local _s8_value=(((smalltalk.Smalltalk):current()):methodReferences())
	self["@methodReferences"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeMethodReferences\r\n\t\" Private - Initialize the methodReferences of the receiver. \"\r\n\r\n\tmethodReferences := Smalltalk current methodReferences","function(self)\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.Smalltalk):current()):methodReferences())\r\n\tself[\"@methodReferences\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"methodReferences",0
,function(self)
if (smalltalk:isNil_((self["@methodReferences"])))==true then (self):initializeMethodReferences(); end;
return (self["@methodReferences"]);
end
,"accessing","methodReferences\r\n\t\" Return the methodReferences of the receiver. \"\r\n\r\n\tmethodReferences isNil ifTrue: [ self initializeMethodReferences ].\r\n\t^methodReferences","function(self)\r\nif (smalltalk:isNil_((self[\"@methodReferences\"])))==true then (self):initializeMethodReferences(); end;\r\nreturn (self[\"@methodReferences\"]);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"methodReferences:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@methodReferences"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","methodReferences: anObject\r\n\t\" Set the methodReferences of the receiver. \"\r\n\r\n\tmethodReferences := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@methodReferences\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"initializeCache",0
,function(self)
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	self["@cache"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeCache\r\n\t\" Private - Initialize the cache of the receiver. \"\r\n\r\n\tcache := PoolDictionary new","function(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tself[\"@cache\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"cache",0
,function(self)
if (smalltalk:isNil_((self["@cache"])))==true then (self):initializeCache(); end;
return (self["@cache"]);
end
,"accessing","cache\r\n\t\" Return the cache of the receiver. \"\r\n\r\n\tcache isNil ifTrue: [ self initializeCache ].\r\n\t^cache","function(self)\r\nif (smalltalk:isNil_((self[\"@cache\"])))==true then (self):initializeCache(); end;\r\nreturn (self[\"@cache\"]);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"cache:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@cache"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","cache: anObject\r\n\t\" Set the cache of the receiver. \"\r\n\r\n\tcache := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@cache\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"detectedPlatform",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(smalltalk:newArray({smalltalk:newArray({"NodeJS", "node"}), smalltalk:newArray({"GCDWebServer", "gcd"}), smalltalk:newArray({"Turbo", "turbo"}), smalltalk:newArray({"SimpleHTTPServer", "luaSimple"})})):do_((function(tuple)
return (smalltalk:if_true_false_(((smalltalk.Smalltalk):includesKey_((tuple):first())),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((tuple):last())
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):nativePlatform())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"platform","detectedPlatform\r\n\t\" Private - Returns the platform we are running (or nil).\r\n\tNote that the platform will be used to solve transport functionality and the associated messages MUST be implemented by the receiver.\r\n\t\"\r\n\r\n\t#(\t#(NodeJS node)\r\n\t\t#(GCDWebServer gcd)\r\n\t\t#(Turbo turbo)\r\n\t\t#(SimpleHTTPServer luaSimple)\r\n\t) do: [:tuple| (Smalltalk includesKey: tuple first) ifTrue: [ ^tuple last ] ].\r\n\t^self nativePlatform","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(smalltalk:newArray({smalltalk:newArray({\"NodeJS\", \"node\"}), smalltalk:newArray({\"GCDWebServer\", \"gcd\"}), smalltalk:newArray({\"Turbo\", \"turbo\"}), smalltalk:newArray({\"SimpleHTTPServer\", \"luaSimple\"})})):do_((function(tuple)\r\nreturn (smalltalk:if_true_false_(((smalltalk.Smalltalk):includesKey_((tuple):first())),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((tuple):last())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):nativePlatform())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"nativePlatform",0
,function(self)
local prefix=nil
(function()
	local _s8_value=((self):nativeLanguage())
	prefix=_s8_value
	return _s8_value
end)();
if ((self):implements_(smalltalk:object_comma_((prefix),"RequestBlock")))==true then return (prefix); end;
(function()
	local _s8_value=(smalltalk:object_comma_((prefix),"Simple"))
	prefix=_s8_value
	return _s8_value
end)();
if ((self):implements_(smalltalk:object_comma_((prefix),"RequestBlock")))==true then return (prefix); end;
return (nil);
end
,"platform","nativePlatform\r\n\t\" Private - Returns the name of platform based on native language support (or nil).\r\n\tNote: detect implementor support prefixed by [nativeLanguage] or [nativeLanguage]Simple\r\n\te.g. luaSimple* messages.\r\n\t\"\r\n\r\n\t| prefix |\r\n\tprefix := self nativeLanguage.\r\n\t(self implements: prefix ,#RequestBlock) ifTrue: [ ^prefix ].\r\n\tprefix := prefix ,#Simple.\r\n\t(self implements: prefix ,#RequestBlock) ifTrue: [ ^prefix ].\r\n\t^nil","function(self)\r\nlocal prefix=nil\r\n(function()\r\n\tlocal _s8_value=((self):nativeLanguage())\r\n\tprefix=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((self):implements_(smalltalk:object_comma_((prefix),\"RequestBlock\")))==true then return (prefix); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((prefix),\"Simple\"))\r\n\tprefix=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((self):implements_(smalltalk:object_comma_((prefix),\"RequestBlock\")))==true then return (prefix); end;\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"platformSend:withArguments:",0
,function(self,message,anArray)
local token=nil
local msg=nil
(function()
	local _s8_value=(((self)["$klass"]):platform())
	token=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((token)))==true then (function()
	local _s8_value=("default")
	token=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=(smalltalk:object_comma_((token),message))
	msg=_s8_value
	return _s8_value
end)();
return ((self):perform_withArguments_(msg,anArray));
end
,"platform","platformSend: message withArguments: anArray\r\n\t\" Private - Returns the result of sending message (platform dependent) to receiver.\r\n\tTrigger an error if the message is not implemented.\r\n\t\"\r\n\r\n\t| token msg |\r\n\ttoken := self class platform.\r\n\ttoken isNil ifTrue: [ token := #default ].\r\n\tmsg := token , message.\r\n\"\t(self respondsTo: msg) ifFalse: [ ^self error: 'Missing server support for ' ,msg ]. \"\r\n\t^self perform: msg withArguments: anArray","function(self,message,anArray)\r\nlocal token=nil\r\nlocal msg=nil\r\n(function()\r\n\tlocal _s8_value=(((self)[\"$klass\"]):platform())\r\n\ttoken=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((token)))==true then (function()\r\n\tlocal _s8_value=(\"default\")\r\n\ttoken=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((token),message))\r\n\tmsg=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):perform_withArguments_(msg,anArray));\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"currentOrNil",0
,function(self)
return (self["@current"]);
end
,"singleton","currentOrNil\r\n\t\" Returns the current instance (or nil). \"\r\n\r\n\t^current","function(self)\r\nreturn (self[\"@current\"]);\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"start",0
,function(self)
return (((self):current()):start());
end
,"server","start\r\n\t\" Start the server. \"\r\n\r\n\t^self current start","function(self)\r\nreturn (((self):current()):start());\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"close",0
,function(self)
return (smalltalk:if_true_false_((smalltalk:notNil_((self["@current"]))),(function()
return ((self["@current"]):close())
end),nil));
end
,"server","close\r\n\t\" Close the current server. \"\r\n\r\n\t^current notNil ifTrue: [ current close ]","function(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((self[\"@current\"]))),(function()\r\nreturn ((self[\"@current\"]):close())\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"stop",0
,function(self)
return ((self):close());
end
,"server","stop\r\n\t\" Stop the current server. \"\r\n\r\n\t^self close","function(self)\r\nreturn ((self):close());\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"restart",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):close();
	return ((_s8_rec):current_(nil))
end
)(self);
return ((self):start());
end
,"server","restart\r\n\t\" Close the current the server and start a new. \"\r\n\r\n\tself close; current: nil.\r\n\t^self start","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):close();\r\n\treturn ((_s8_rec):current_(nil))\r\nend\r\n)(self);\r\nreturn ((self):start());\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"htmlSelectorsFor:",0
,function(self,className)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local stream=nil
local aClass=nil
local classDef=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(className,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ("")
end
)()
error(_s8Ret_,0)
end)())
end)))
	aClass=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((""):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("<BR><BR><a href="),"'")),"/SystemServer/htmlHierarchy")),"'")),"><< S8 Hierarchy</a><BR>"));
(function()
	local _s8_value=(((smalltalk.Exporter):new()):fileOutDefinitionOf_(aClass))
	classDef=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((classDef):replace_with_("\\r\\n","<BR>"))
	classDef=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((classDef):replace_with_("\\t","&nbsp;&nbsp;&nbsp;"))
	classDef=_s8_value
	return _s8_value
end)();
(stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("<BR>"),classDef)),"<H4>")),className))," class methods</H4>"));
(((aClass)["$klass"]):selectors()):do_((function(each)
return ((stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("<a href="),"'")),"/SystemServer/htmlFileOut:selector:side:/")),(aClass):name())),"/")),each)),"/class")),"'")),">")),each)),"</a><BR>")))
end));
(stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(("<H4>"),className))," instance methods</H4>"));
((aClass):selectors()):do_((function(each)
return ((stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("<a href="),"'")),"/SystemServer/htmlFileOut:selector:/")),(aClass):name())),"/")),each)),"'")),">")),each)),"</a><BR>")))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((stream):contents())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"html","htmlSelectorsFor: className\r\n\t\" Return an html fragment containing the selectors implemented by className. \"\r\n\r\n\t| stream aClass classDef |\r\n\taClass := Smalltalk at: className ifAbsent:[ ^'' ].\r\n\tstream := '' writeStream.\t\r\n\tstream nextPutAll: '<BR><BR><a href=',$'\r\n\t\t,'/SystemServer/htmlHierarchy',$'\r\n\t\t,'><< S8 Hierarchy</a><BR>'.\r\n\tclassDef := Exporter new fileOutDefinitionOf: aClass.\r\n\tclassDef := classDef replace:'\\r\\n' with:'<BR>'.\r\n\tclassDef := classDef replace:'\\t' with:'&nbsp;&nbsp;&nbsp;'.\r\n\tstream nextPutAll: '<BR>' ,classDef ,'<H4>' ,className ,' class methods</H4>'.\r\n\taClass class selectors do: [:each| \r\n\t\tstream nextPutAll: '<a href=',$'\r\n\t\t\t,'/SystemServer/htmlFileOut:selector:side:/', aClass name\r\n\t\t\t,'/',each,'/class', $', '>', each, '</a><BR>'\r\n\t].\t\r\n\tstream nextPutAll: '<H4>', className,' instance methods</H4>'.\r\n\taClass selectors do:[:each| \r\n\t\tstream nextPutAll: '<a href=',$'\r\n\t\t\t,'/SystemServer/htmlFileOut:selector:/', aClass name\r\n\t\t\t,'/',each,$', '>', each, '</a><BR>'\r\n\t].\r\n\t^stream contents","function(self,className)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal stream=nil\r\nlocal aClass=nil\r\nlocal classDef=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(className,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (\"\")\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\taClass=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"<BR><BR><a href=\"),\"'\")),\"/SystemServer/htmlHierarchy\")),\"'\")),\"><< S8 Hierarchy</a><BR>\"));\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.Exporter):new()):fileOutDefinitionOf_(aClass))\r\n\tclassDef=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((classDef):replace_with_(\"\\\\r\\\\n\",\"<BR>\"))\r\n\tclassDef=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((classDef):replace_with_(\"\\\\t\",\"&nbsp;&nbsp;&nbsp;\"))\r\n\tclassDef=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"<BR>\"),classDef)),\"<H4>\")),className)),\" class methods</H4>\"));\r\n(((aClass)[\"$klass\"]):selectors()):do_((function(each)\r\nreturn ((stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"<a href=\"),\"'\")),\"/SystemServer/htmlFileOut:selector:side:/\")),(aClass):name())),\"/\")),each)),\"/class\")),\"'\")),\">\")),each)),\"</a><BR>\")))\r\nend));\r\n(stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\"<H4>\"),className)),\" instance methods</H4>\"));\r\n((aClass):selectors()):do_((function(each)\r\nreturn ((stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"<a href=\"),\"'\")),\"/SystemServer/htmlFileOut:selector:/\")),(aClass):name())),\"/\")),each)),\"'\")),\">\")),each)),\"</a><BR>\")))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((stream):contents())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"htmlFileOut:selector:side:",0
,function(self,className,selector,side)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local stream=nil
local aClass=nil
local mth=nil
local source=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(className,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ("")
end
)()
error(_s8Ret_,0)
end)())
end)))
	aClass=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((side),"class")),(function()
return (((aClass)["$klass"]):_gt_gt(selector))
end),(function()
return ((aClass):_gt_gt(selector))
end)))
	mth=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk.Exporter):new()):fileOutMethod_of_(mth,aClass))
	source=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((source):replace_with_("\\r\\n","<BR>"))
	source=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((source):replace_with_("\\t","&nbsp;&nbsp;&nbsp;"))
	source=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((source):replace_with_(smalltalk:object_comma_(("\\"),"\""),"&quot;"))
	source=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("<BR><BR><a href="),"/SystemServer/htmlSelectorsFor:/")),className)),"><< ")),className))," methods</a><BR>")),source)),"<BR>"))
	source=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (source)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"html","htmlFileOut: className selector: selector side: side\r\n\t\" Return an html fragment of selector source code. \"\r\n\r\n\t| stream aClass mth source |\r\n\taClass := Smalltalk at: className ifAbsent:[ ^'' ].\r\n\tmth := (side = #class) ifTrue:[ aClass class >> selector \r\n\t] ifFalse: [ aClass >> selector ].\r\n\tsource := Exporter new fileOutMethod: mth of: aClass.\r\n\tsource := source replace:'\\r\\n' with:'<BR>'.\r\n\tsource := source replace:'\\t' with:'&nbsp;&nbsp;&nbsp;'.\r\n\tsource := source replace: $\\,$\" with: '&quot;'.\r\n\tsource := '<BR><BR><a href='\r\n\t\t,'/SystemServer/htmlSelectorsFor:/'\r\n\t\t,className ,'><< ' ,className\r\n\t\t,' methods</a><BR>',source\r\n\t\t,'<BR>'.\r\n\t^source","function(self,className,selector,side)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal stream=nil\r\nlocal aClass=nil\r\nlocal mth=nil\r\nlocal source=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(className,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (\"\")\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\taClass=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((side),\"class\")),(function()\r\nreturn (((aClass)[\"$klass\"]):_gt_gt(selector))\r\nend),(function()\r\nreturn ((aClass):_gt_gt(selector))\r\nend)))\r\n\tmth=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.Exporter):new()):fileOutMethod_of_(mth,aClass))\r\n\tsource=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((source):replace_with_(\"\\\\r\\\\n\",\"<BR>\"))\r\n\tsource=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((source):replace_with_(\"\\\\t\",\"&nbsp;&nbsp;&nbsp;\"))\r\n\tsource=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((source):replace_with_(smalltalk:object_comma_((\"\\\\\"),\"\\\"\"),\"&quot;\"))\r\n\tsource=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"<BR><BR><a href=\"),\"/SystemServer/htmlSelectorsFor:/\")),className)),\"><< \")),className)),\" methods</a><BR>\")),source)),\"<BR>\"))\r\n\tsource=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (source)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"htmlFileOut:selector:",0
,function(self,className,selector)
return ((self):htmlFileOut_selector_side_(className,selector,"instance"));
end
,"html","htmlFileOut: className selector: selector\r\n\t\" Return an html fragment of selector source code. \"\r\n\r\n\t^self htmlFileOut: className \r\n\t\tselector: selector \r\n\t\tside: #instance","function(self,className,selector)\r\nreturn ((self):htmlFileOut_selector_side_(className,selector,\"instance\"));\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"htmlHierarchy",0
,function(self)
local stream=nil
(function()
	local _s8_value=((""):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(stream):nextPutAll_("<H2>S8 Hierarchy</H2>");
((smalltalk.Smalltalk):rootClasses()):do_((function(cls)
return ((self):htmlWalk_blanks_into_(cls,0,stream))
end));
return ((stream):contents());
end
,"html","htmlHierarchy\r\n\t\" Returns the system hierarchy in html fasion. \"\r\n\r\n\t| stream |\r\n\tstream := '' writeStream.\r\n\tstream nextPutAll:'<H2>S8 Hierarchy</H2>'.\r\n\tSmalltalk rootClasses do: [:cls|\r\n\t\tself htmlWalk: cls blanks: 0 into: stream\r\n\t].\r\n\t^stream contents","function(self)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(stream):nextPutAll_(\"<H2>S8 Hierarchy</H2>\");\r\n((smalltalk.Smalltalk):rootClasses()):do_((function(cls)\r\nreturn ((self):htmlWalk_blanks_into_(cls,0,stream))\r\nend));\r\nreturn ((stream):contents());\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"htmlWalk:blanks:into:",0
,function(self,aClass,blanks,stream)
(stream):nextPutAll_("<BR>");
smalltalk:times_repeat_((blanks),(function()
return ((stream):nextPutAll_("&nbsp;&nbsp;"))
end));
(stream):nextPutAll_((self):htmlDescriptionForClass_(aClass));
((aClass):subclasses()):do_((function(cls)
return ((self):htmlWalk_blanks_into_(cls,(blanks):_plus(1),stream))
end));
return (self);
end
,"html","htmlWalk: aClass blanks: blanks into: stream\r\n\t\" Private - Returns the description for hierarchy level @ blanks. \"\r\n\r\n\tstream nextPutAll:'<BR>'. \r\n\tblanks timesRepeat: [ stream nextPutAll: '&nbsp;&nbsp;' ].\r\n\tstream nextPutAll: (self htmlDescriptionForClass: aClass).\r\n\taClass subclasses do: [:cls|\r\n\t\tself htmlWalk: cls blanks: blanks + 1 into: stream\r\n\t].","function(self,aClass,blanks,stream)\r\n(stream):nextPutAll_(\"<BR>\");\r\nsmalltalk:times_repeat_((blanks),(function()\r\nreturn ((stream):nextPutAll_(\"&nbsp;&nbsp;\"))\r\nend));\r\n(stream):nextPutAll_((self):htmlDescriptionForClass_(aClass));\r\n((aClass):subclasses()):do_((function(cls)\r\nreturn ((self):htmlWalk_blanks_into_(cls,(blanks):_plus(1),stream))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer["$klass"],"htmlDescriptionForClass:",0
,function(self,aClass)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("<a href="),"'")),"/SystemServer/htmlSelectorsFor:/")),(aClass):name())),"'")),">")),(aClass):name())),"</a> [")),(aClass):category())),"]"));
end
,"html","htmlDescriptionForClass: aClass\r\n\t\" Private - Returns the contents to show for aClass. \"\r\n\r\n\t^'<a href=', $', '/SystemServer/htmlSelectorsFor:/', aClass name, $' ,$>, aClass name,'</a> [',aClass category, ']'","function(self,aClass)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"<a href=\"),\"'\")),\"/SystemServer/htmlSelectorsFor:/\")),(aClass):name())),\"'\")),\">\")),(aClass):name())),\"</a> [\")),(aClass):category())),\"]\"));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"isRunning",0
,function(self)
return (smalltalk:notNil_((self["@server"])));
end
,"query","isRunning\r\n\t\" Returns true if the receiver is online. \"\r\n\r\n\t^server notNil","function(self)\r\nreturn (smalltalk:notNil_((self[\"@server\"])));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"step",0
,function(self)
return (smalltalk:if_true_false_(((self):isRunning()),(function()
return ((self["@server"]):step())
end),nil));
end
,"runnning","step\r\n\t\" Run a server step. \"\r\n\r\n\t^self isRunning ifTrue: [ server step ]","function(self)\r\nreturn (smalltalk:if_true_false_(((self):isRunning()),(function()\r\nreturn ((self[\"@server\"]):step())\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"listen",0
,function(self)
return ((self["@server"]):listen());
end
,"runnning","listen\r\n\t\" Run a server step. \"\r\n\r\n\t^server listen","function(self)\r\nreturn ((self[\"@server\"]):listen());\r\nend")

smalltalk:bind(smalltalk.SystemServer,"run",0
,function(self)
while ((function()
return ((self):isRunning())
end))() do (self):listen(); end;
return (self);
end
,"runnning","run\r\n\t\" Run the receiver in a loop until stopped. \"\r\n\r\n\t[self isRunning] whileTrue: [ self listen ]","function(self)\r\nwhile ((function()\r\nreturn ((self):isRunning())\r\nend))() do (self):listen(); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"online",0
,function(self)
return (smalltalk:notNil_((self["@server"])));
end
,"server","online\r\n\t\" Returns true if the receiver is online. \"\r\n\r\n\t^server notNil","function(self)\r\nreturn (smalltalk:notNil_((self[\"@server\"])));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"start",0
,function(self)
return ((self):startServer());
end
,"server","start\r\n\t\" Start the receiver. \"\r\n\r\n\t^self startServer","function(self)\r\nreturn ((self):startServer());\r\nend")

smalltalk:bind(smalltalk.SystemServer,"close",0
,function(self)
(self):server_(nil);
return (self);
end
,"server","close\r\n\t\" Close the receiver. \"\r\n\r\n\tself server: nil","function(self)\r\n(self):server_(nil);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"server:",0
,function(self,aServer)
if (((self["@server"])==aServer))==true then return (self); end;
(self):unbindSystemManager();
if (smalltalk:responds_to_((self["@server"]),("close")))==true then (self["@server"]):close(); end;
(function()
	local _s8_value=(aServer)
	self["@server"]=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((self["@server"])))==true then (self):bindSystemManager(); end;
return (self);
end
,"private","server: aServer\r\n\t\" Private - Set the server of the receiver. \"\r\n\r\n\tserver == aServer ifTrue: [ ^self ].\r\n\tself unbindSystemManager.\r\n\t(server respondsTo: #close) ifTrue: [ server close ].\r\n\tserver := aServer.\r\n\tserver notNil ifTrue: [ self bindSystemManager ]","function(self,aServer)\r\nif (((self[\"@server\"])==aServer))==true then return (self); end;\r\n(self):unbindSystemManager();\r\nif (smalltalk:responds_to_((self[\"@server\"]),(\"close\")))==true then (self[\"@server\"]):close(); end;\r\n(function()\r\n\tlocal _s8_value=(aServer)\r\n\tself[\"@server\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((self[\"@server\"])))==true then (self):bindSystemManager(); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"startServer",0
,function(self)
return ((self):startServerOn_((self):port()));
end
,"server","startServer\r\n\t\" Start the server. \"\r\n\r\n\t^self startServerOn: self port","function(self)\r\nreturn ((self):startServerOn_((self):port()));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"startServerOn:",0
,function(self,aPort)
local query=nil
(function()
	local _s8_value=((self):systemRequestBlock())
	query=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((query)))==true then return (false); end;
return ((self):startWith_on_((function(req,resp)
return (smalltalk:object_comma_((smalltalk:object_comma_(("<html><body><pre>"),(query):value_value_(req,resp))),"</pre></body></html>"))
end),aPort));
end
,"server","startServerOn: aPort\r\n\t\" Start the server. \"\r\n\r\n\t| query |\r\n\tquery := self systemRequestBlock.\r\n\tquery isNil ifTrue: [ ^false ].\r\n\t^self startWith: [:req :resp|\r\n\t\t'<html><body><pre>'\r\n\t\t,(query value: req value: resp)\r\n\t\t,'</pre></body></html>'.\t\t\r\n\t] on: aPort","function(self,aPort)\r\nlocal query=nil\r\n(function()\r\n\tlocal _s8_value=((self):systemRequestBlock())\r\n\tquery=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((query)))==true then return (false); end;\r\nreturn ((self):startWith_on_((function(req,resp)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"<html><body><pre>\"),(query):value_value_(req,resp))),\"</pre></body></html>\"))\r\nend),aPort));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"startWith:on:",0
,function(self,processBlock,aPort)
return ((self):startBlock_port_(processBlock,aPort));
end
,"server","startWith: processBlock on: aPort\r\n\t\r\n\t^self\tstartBlock: processBlock \r\n\t\tport: aPort","function(self,processBlock,aPort)\r\nreturn ((self):startBlock_port_(processBlock,aPort));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"startBlock:port:",0
,function(self,aBlock,aPort)
(function()
	local _s8_value=((self):start_processBlock_port_(self,aBlock,aPort))
	self["@server"]=_s8_value
	return _s8_value
end)();
return (smalltalk:notNil_((self["@server"])));
end
,"server","startBlock: aBlock port: aPort\r\n\t\" Private - Start the server. \"\r\n\r\n\tserver := self\r\n\t\tstart: self\r\n\t\tprocessBlock: aBlock\r\n\t\tport: aPort.\r\n\t^server notNil","function(self,aBlock,aPort)\r\n(function()\r\n\tlocal _s8_value=((self):start_processBlock_port_(self,aBlock,aPort))\r\n\tself[\"@server\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:notNil_((self[\"@server\"])));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"aboutToStart",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):unbindSystemManager();
	return ((_s8_rec):bindSystemManager())
end
)(self);
return (self);
end
,"preparation","aboutToStart\r\n\t\" Private - Prepare the environment to start the receiver. \"\r\n\r\n\tself\tunbindSystemManager;\r\n\t\tbindSystemManager","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):unbindSystemManager();\r\n\treturn ((_s8_rec):bindSystemManager())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"start:processBlock:port:",0
,function(self,aServer,aBlock,aPort)
(self):aboutToStart();
return ((self):platformSend_withArguments_("Start:processBlock:port:",(smalltalk.Array):with_with_with_(aServer,aBlock,aPort)));
end
,"server","start: aServer processBlock: aBlock port: aPort\r\n\t\" Private - Start the server. \"\r\n\r\n\tself aboutToStart.\r\n\t^self\tplatformSend: #Start:processBlock:port:\r\n\t\twithArguments: (Array with: aServer with: aBlock with: aPort)","function(self,aServer,aBlock,aPort)\r\n(self):aboutToStart();\r\nreturn ((self):platformSend_withArguments_(\"Start:processBlock:port:\",(smalltalk.Array):with_with_with_(aServer,aBlock,aPort)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"systemRequestBlock",0
,function(self)
return ((self):platformSend_withArguments_("RequestBlock",smalltalk:newArray({})));
end
,"server","systemRequestBlock\r\n\t\" Private - Return the request processing block used for remote system tools.\r\n\tNote that the block is evaluated for each request and must return the code of the body of HTML formated result.\r\n\t\"\r\n\r\n\t^self platformSend: #RequestBlock withArguments: #()","function(self)\r\nreturn ((self):platformSend_withArguments_(\"RequestBlock\",smalltalk:newArray({})));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"jsonParse:",0
,function(self,string)
return ((self):platformSend_withArguments_("Parse:",(smalltalk.Array):with_(string)));
end
,"server","jsonParse: string\r\n\t\" Private - Return the result of parsing JSON string. \"\r\n\r\n\t^self platformSend: #Parse: withArguments: (Array with: string)","function(self,string)\r\nreturn ((self):platformSend_withArguments_(\"Parse:\",(smalltalk.Array):with_(string)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"jsonStringify:",0
,function(self,literal)
return ((self):platformSend_withArguments_("Stringify:",(smalltalk.Array):with_(literal)));
end
,"server","jsonStringify: literal\r\n\t\" Private - Return the result of JSON string. \"\r\n\r\n\t^self platformSend: #Stringify: withArguments: (Array with: literal)","function(self,literal)\r\nreturn ((self):platformSend_withArguments_(\"Stringify:\",(smalltalk.Array):with_(literal)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"serverStartedAt:",0
,function(self,url)
local string=nil
(function()
	local _s8_value=(smalltalk:object_comma_(("Server started at "),url))
	string=_s8_value
	return _s8_value
end)();
if (smalltalk:responds_to_((self),("alert:")))==true then return ((self):alert_(string)); end;
return ((self):note_(string));
end
,"ui","serverStartedAt: url\r\n\t\" Private - Show a notification to the user; the server has been started. \"\r\n\r\n\t| string |\r\n\tstring := 'Server started at ' ,url.\r\n\t(self respondsTo: #alert:) ifTrue: [ ^self alert: string ].\r\n\t^self note: string","function(self,url)\r\nlocal string=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((\"Server started at \"),url))\r\n\tstring=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:responds_to_((self),(\"alert:\")))==true then return ((self):alert_(string)); end;\r\nreturn ((self):note_(string));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"defaultRequestBlock",0
,function(self)
return ((self):error_("Missing support for server request"));
end
,"defaults","defaultRequestBlock\r\n\t\" Private - Return the request processing block used for remote system tools. \"\r\n\r\n\t^self error: 'Missing support for server request'","function(self)\r\nreturn ((self):error_(\"Missing support for server request\"));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"defaultStart:processBlock:port:",0
,function(self,aServer,aBlock,aPort)
return ((self):error_("Missing support for server start"));
end
,"defaults","defaultStart: aServer processBlock: aBlock port: aPort\r\n\t\" Private - Start the server. \"\r\n\r\n\t^self error: 'Missing support for server start'","function(self,aServer,aBlock,aPort)\r\nreturn ((self):error_(\"Missing support for server start\"));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"defaultParse:",0
,function(self,string)
return (((smalltalk.NativeHandle):support()):_at((JSON):parse(string)));
end
,"defaults","defaultParse: string\r\n\t\" Private - Return the result of parsing JSON string. \"\r\n\r\n\t^NativeHandle support @ (#{JSON} #parse: string)","function(self,string)\r\nreturn (((smalltalk.NativeHandle):support()):_at((JSON):parse(string)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"defaultStringify:",0
,function(self,literal)
return ((JSON):stringify(literal));
end
,"defaults","defaultStringify: literal\r\n\t\" Private - Return the result of JSON string. \"\r\n\r\n\t^#{JSON} #stringify: literal","function(self,literal)\r\nreturn ((JSON):stringify(literal));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"checkArrays:",0
,function(self,aHandle)
local remaining=nil
(function()
	local _s8_value=((smalltalk.Array):with_(aHandle))
	remaining=_s8_value
	return _s8_value
end)();
while ((function()
return ((remaining):notEmpty())
end))() do local literal=nil
smalltalk:if_true_false_((smalltalk:notNil_((((function()
	local _s8_value=((remaining):removeFirst())
	literal=_s8_value
	return _s8_value
end)())))),(function()
return (smalltalk:if_true_false_((smalltalk:notNil_((smalltalk:basic_at_ifAbsent_((literal),1,(function()
return (nil)
end))))),(function()
smalltalk:newArray(literal);return ((remaining):addAll_(literal))
end),(function()
return (smalltalk:if_true_false_(((self):isObject_(literal)),nil,(function()
return ((((smalltalk.NativeHandle):support()):_at(literal)):propertiesDo_((function(key,value)
return (smalltalk:if_true_false_((smalltalk:notNil_((smalltalk:basic_at_ifAbsent_((value),1,(function()
return (nil)
end))))),(function()
smalltalk:newArray(value);return ((remaining):addAll_(value))
end),(function()
return ((remaining):add_(value))
end)))
end)))
end)))
end)))
end),nil); end;
return (self);
end
,"json","checkArrays: aHandle\r\n\t\" Private,Lua - Scan native handle values for arrayed contents recursivelly.\r\n\tNote that JSON data is hierarchical non-recursive structures we walk the structure descending recursivelly in the structure mutating array candidates.\r\n\t\"\r\n\r\n\t| remaining |\r\n\tremaining := Array with: aHandle.\r\n\t[remaining notEmpty] whileTrue: [ | literal |\r\n\t\t(literal := remaining removeFirst) notNil ifTrue: [\r\n\t\t\t(literal basicAt: 1 ifAbsent: []) notNil \"mutate to Array\"\r\n\t\t\tifTrue: [ {'literal' lua'smalltalk:newArray(literal)'}. remaining addAll: literal ]\r\n\t\t\tifFalse: [ \"walk normal object contents\"\r\n\t\t\t\t(self isObject: literal) ifFalse: [\r\n\t\t\t\t\tNativeHandle support @ literal propertiesDo: [:key :value|\r\n\t\t\t\t\t\t(value basicAt: 1 ifAbsent: []) notNil ifTrue: [\r\n\t\t\t\t\t\t\t{'value' lua'smalltalk:newArray(value)'}. remaining addAll: value\r\n\t\t\t\t\t\t] ifFalse: [ remaining add: value ]\r\n\t\t\t\t\t]\r\n\t\t\t\t]\r\n\t\t\t]\r\n\t\t]\r\n\t].","function(self,aHandle)\r\nlocal remaining=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_(aHandle))\r\n\tremaining=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn ((remaining):notEmpty())\r\nend))() do local literal=nil\r\nsmalltalk:if_true_false_((smalltalk:notNil_((((function()\r\n\tlocal _s8_value=((remaining):removeFirst())\r\n\tliteral=_s8_value\r\n\treturn _s8_value\r\nend)())))),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((smalltalk:basic_at_ifAbsent_((literal),1,(function()\r\nreturn (nil)\r\nend))))),(function()\r\nsmalltalk:newArray(literal);return ((remaining):addAll_(literal))\r\nend),(function()\r\nreturn (smalltalk:if_true_false_(((self):isObject_(literal)),nil,(function()\r\nreturn ((((smalltalk.NativeHandle):support()):_at(literal)):propertiesDo_((function(key,value)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((smalltalk:basic_at_ifAbsent_((value),1,(function()\r\nreturn (nil)\r\nend))))),(function()\r\nsmalltalk:newArray(value);return ((remaining):addAll_(value))\r\nend),(function()\r\nreturn ((remaining):add_(value))\r\nend)))\r\nend)))\r\nend)))\r\nend)))\r\nend),nil); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"say:",0
,function(self,text)
if (((self)["$klass"]):silent())==true then return (self); end;
if ((text):isArray())==true then (text):do_((function(line)
return ((self):say_(line))
end)); end;
(self):note_(text);
return (self);
end
,"notification","say: text\r\n\t\" Show text to the user. \"\r\n\r\n\tself class silent ifTrue: [ ^self ].\r\n\ttext isArray ifTrue: [ text do: [:line| self say: line ] ].\r\n\tself note: text","function(self,text)\r\nif (((self)[\"$klass\"]):silent())==true then return (self); end;\r\nif ((text):isArray())==true then (text):do_((function(line)\r\nreturn ((self):say_(line))\r\nend)); end;\r\n(self):note_(text);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"getCommand:",0
,function(self,command)
if (smalltalk:boolean_or_(((command):isEmpty()),(function()
return (((command):first()):isEmpty())
end)))==true then return ((self):systemHomePage()); end;
if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((command):size()),1)),(function()
return (smalltalk:responds_to_((self),((command):first())))
end)))==true then return ((self):perform_((command):first())); end;
return ((self):resultForCommand_((command):stream()));
end
,"private","getCommand: command\r\n\t\" Private - Return the result of evaluating the command. \"\r\n\r\n\t(command isEmpty or: [command first isEmpty]) ifTrue:  [\r\n\t\t^self systemHomePage\r\n\t].\r\n\t(command size = 1 and: [ self respondsTo: command first ]) ifTrue: [\r\n\t\t^self perform: command first\r\n\t].\r\n\t^self resultForCommand: command stream","function(self,command)\r\nif (smalltalk:boolean_or_(((command):isEmpty()),(function()\r\nreturn (((command):first()):isEmpty())\r\nend)))==true then return ((self):systemHomePage()); end;\r\nif (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((command):size()),1)),(function()\r\nreturn (smalltalk:responds_to_((self),((command):first())))\r\nend)))==true then return ((self):perform_((command):first())); end;\r\nreturn ((self):resultForCommand_((command):stream()));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"postCommand:stream:",0
,function(self,command,stream)
(stream):upTo_("=");
return (smalltalk:if_true_false_((smalltalk:boolean_or_(((command):isEmpty()),(function()
return (((command):first()):isEmpty())
end))),(function()
return ((self):note_((stream):upToEnd()))
end),(function()
(command):add_((stream):upToEnd());return ((self):resultForCommand_((command):stream()))
end)));
end
,"private","postCommand: command stream: stream\r\n\t\" Private - Return the result of evaluating the command. \"\r\n\r\n\tstream upTo: $=.\r\n\t^(command isEmpty or: [command first isEmpty])\r\n\tifTrue:  [ self note: stream upToEnd ]\r\n\tifFalse: [\r\n\t\tcommand add: stream upToEnd.\r\n\t\tself resultForCommand: command stream.\r\n\t]","function(self,command,stream)\r\n(stream):upTo_(\"=\");\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_or_(((command):isEmpty()),(function()\r\nreturn (((command):first()):isEmpty())\r\nend))),(function()\r\nreturn ((self):note_((stream):upToEnd()))\r\nend),(function()\r\n(command):add_((stream):upToEnd());return ((self):resultForCommand_((command):stream()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"requestBlockFor:method:post:",0
,function(self,urlBlock,methodBlock,postBlock)
return ((function(arg1,arg2)
local command=nil
local method=nil
return ((self):jsonValue_((function()
(function()
	local _s8_value=((urlBlock):value_value_(arg1,arg2))
	command=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((methodBlock):value_value_(arg1,arg2))
	method=_s8_value
	return _s8_value
end)();(self):say_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((""),method))," ")),command));(function()
	local _s8_value=((command):asArrayOfSubstringsSeparatedBy_("/"))
	command=_s8_value
	return _s8_value
end)();(command):removeFirst();return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((method),"GET")),(function()
return ((self):getCommand_(command))
end),(function()
return ((postBlock):value_value_(arg1,(function(stream)
return ((self):postCommand_stream_(command,stream))
end)))
end)))
end)))
end));
end
,"private","requestBlockFor: urlBlock method: methodBlock post: postBlock\r\n\t\" Private - Return the request processing block used for remote system tools. \"\r\n\r\n\t^[:arg1 :arg2| | command method | self jsonValue: [\r\n\t\tcommand := urlBlock value: arg1 value: arg2.\r\n\t\tmethod := methodBlock value: arg1 value: arg2.\r\n\t\tself say: '' ,method ,' ' ,command.\r\n\t\tcommand := command asArrayOfSubstringsSeparatedBy: $/.\r\n\t\tcommand removeFirst.\r\n\t\tmethod = #GET ifTrue: [ self getCommand: command ]\r\n\t\tifFalse: [\r\n\t\t\tpostBlock value: arg1 value: [:stream|\r\n\t\t\t\tself postCommand: command stream: stream\r\n\t\t\t]\r\n\t\t]\r\n\t]]","function(self,urlBlock,methodBlock,postBlock)\r\nreturn ((function(arg1,arg2)\r\nlocal command=nil\r\nlocal method=nil\r\nreturn ((self):jsonValue_((function()\r\n(function()\r\n\tlocal _s8_value=((urlBlock):value_value_(arg1,arg2))\r\n\tcommand=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((methodBlock):value_value_(arg1,arg2))\r\n\tmethod=_s8_value\r\n\treturn _s8_value\r\nend)();(self):say_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"\"),method)),\" \")),command));(function()\r\n\tlocal _s8_value=((command):asArrayOfSubstringsSeparatedBy_(\"/\"))\r\n\tcommand=_s8_value\r\n\treturn _s8_value\r\nend)();(command):removeFirst();return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((method),\"GET\")),(function()\r\nreturn ((self):getCommand_(command))\r\nend),(function()\r\nreturn ((postBlock):value_value_(arg1,(function(stream)\r\nreturn ((self):postCommand_stream_(command,stream))\r\nend)))\r\nend)))\r\nend)))\r\nend));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"systemHomePage",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("<h1>S8 System server</h1>"),"Try commands like <a href=")),"'")),"/SystemServer/htmlHierarchy")),"'")),">hierarchy</a>&nbsp;")),"or more complex expressions: <a href=")),"'")),"/Object/htmlSelectors")),"'")),">Object selectors</a>"));
end
,"#commands","systemHomePage\r\n\t\" Private - Returns the contents for system home page. \"\r\n\r\n\t^'<h1>S8 System server</h1>'\r\n\t,'Try commands like <a href=',$' ,'/SystemServer/htmlHierarchy', $', '>hierarchy</a>&nbsp;'\r\n\t,'or more complex expressions: <a href=', $', '/Object/htmlSelectors', $', '>Object selectors</a>'","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"<h1>S8 System server</h1>\"),\"Try commands like <a href=\")),\"'\")),\"/SystemServer/htmlHierarchy\")),\"'\")),\">hierarchy</a>&nbsp;\")),\"or more complex expressions: <a href=\")),\"'\")),\"/Object/htmlSelectors\")),\"'\")),\">Object selectors</a>\"));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"objectFromStream:",0
,function(self,stream)
if not ((smalltalk:isObject_equalTo_(((stream):next()),"!")))==true then (self):error_("Invalid code stream"); end;
if (smalltalk:isObject_equalTo_(((stream):peek()),"@"))==true then (stream):next();
return ((self):at_((stream):upToEnd())); end;
return ((stream):fileIn());
end
,"private","objectFromStream: stream\r\n\t\" Private - Return the object received from client. \"\r\n\r\n\tstream next = $! ifFalse: [ self error: 'Invalid code stream' ].\r\n\tstream peek = $@ ifTrue: [\r\n\t\tstream next.\r\n\t\t^self at: stream upToEnd\r\n\t].\r\n\t^stream fileIn","function(self,stream)\r\nif not ((smalltalk:isObject_equalTo_(((stream):next()),\"!\")))==true then (self):error_(\"Invalid code stream\"); end;\r\nif (smalltalk:isObject_equalTo_(((stream):peek()),\"@\"))==true then (stream):next();\r\nreturn ((self):at_((stream):upToEnd())); end;\r\nreturn ((stream):fileIn());\r\nend")

smalltalk:bind(smalltalk.SystemServer,"objectsFromArguments:",0
,function(self,array)
return ((array):collect_((function(each)
return (smalltalk:if_true_false_((smalltalk:notNil_((each))),(function()
return (smalltalk:if_true_false_(((each):isArray()),(function()
return ((self):objectsFromArguments_(each))
end),(function()
return (smalltalk:if_true_false_((smalltalk:boolean_and_(((each):isString()),(function()
return ((each):startsWith_("!"))
end))),(function()
return ((self):objectFromStream_((each):stream()))
end),(function()
return (each)
end)))
end)))
end),nil))
end)));
end
,"private","objectsFromArguments: array\r\n\t\" Private - Return the objects to use as arguments received from client. \"\r\n\r\n\t^array collect: [:each|\r\n\t\teach notNil ifTrue: [\r\n\t\teach isArray ifTrue: [ self objectsFromArguments: each ]\r\n\t\tifFalse: [ (each isString and: [ each startsWith: $! ])\r\n\t\tifTrue: [ self objectFromStream: each stream ]\r\n\t\tifFalse: [ each ]]]\r\n\t]","function(self,array)\r\nreturn ((array):collect_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((each))),(function()\r\nreturn (smalltalk:if_true_false_(((each):isArray()),(function()\r\nreturn ((self):objectsFromArguments_(each))\r\nend),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_(((each):isString()),(function()\r\nreturn ((each):startsWith_(\"!\"))\r\nend))),(function()\r\nreturn ((self):objectFromStream_((each):stream()))\r\nend),(function()\r\nreturn (each)\r\nend)))\r\nend)))\r\nend),nil))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"perform:on:",0
,function(self,stream,receiver)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
(function()
	local _s8_value=(receiver)
	result=_s8_value
	return _s8_value
end)();
while not ((function()
return ((stream):atEnd())
end))() do local selector=nil
(function()
	local _s8_value=((stream):next())
	selector=_s8_value
	return _s8_value
end)();
if ((selector):isEmpty())==true then (function()
	local _s8_value=("/")
	selector=_s8_value
	return _s8_value
end)(); end;
smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((selector):first()),"{")),(function()
local json=nil
while not ((function()
return (smalltalk:isObject_equalTo_(((selector):last()),"}"))
end))() do if ((stream):atEnd())==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_(("Corrupted message "),selector)))
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((selector),"/")),(stream):next()))
	selector=_s8_value
	return _s8_value
end)(); end;(function()
	local _s8_value=((self):jsonParse_(selector))
	json=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((json):_at("selector"))
	selector=_s8_value
	return _s8_value
end)();if (smalltalk:isNil_((selector)))==true then (self):error_("Missing selector"); end;return ((function()
	local _s8_value=(((smalltalk.Message):receiver_selector_arguments_(result,smalltalk:toString_((selector)),(self):objectsFromArguments_((json):_at("arguments")))):perform())
	result=_s8_value
	return _s8_value
end)())
end),(function()
local args=nil
local argCount=nil
(function()
	local _s8_value=((selector):argumentCount())
	argCount=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=(((1):to_(argCount)):collect_((function(i)
return (smalltalk:if_true_false_(((stream):atEnd()),nil,(function()
return ((stream):next())
end)))
end)))
	args=_s8_value
	return _s8_value
end)();return ((function()
	local _s8_value=((result):perform_withArguments_(selector,(self):objectsFromArguments_(args)))
	result=_s8_value
	return _s8_value
end)())
end)); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"private","perform: stream on: receiver\r\n\t\" Private - Returns the result of performing messages in stream on receiver. \"\r\n\r\n\t| result |\r\n\tresult := receiver.\r\n\t[stream atEnd] whileFalse: [ | selector |\r\n\t\tselector := stream next.\r\n\t\tselector isEmpty ifTrue: [ selector := $/ ].\r\n\t\tselector first = ${ ifTrue: [ | json |\r\n\t\t\t[selector last = $}] whileFalse: [\r\n\t\t\t\tstream atEnd ifTrue: [ ^self error: 'Corrupted message ' ,selector ].\r\n\t\t\t\tselector := selector ,$/ ,stream next.\r\n\t\t\t].\r\n\t\t\tjson := self jsonParse: selector.\r\n\t\t\tselector := json @ #selector.\r\n\t\t\tselector isNil ifTrue: [ self error: 'Missing selector' ].\r\n\t\t\tresult := (Message\r\n\t\t\t\treceiver: result selector: selector toString\r\n\t\t\t\targuments: (self objectsFromArguments: json @ #arguments)\r\n\t\t\t\t) perform\r\n\t\t] ifFalse: [ | args argCount |\r\n\t\t\targCount := selector argumentCount.\r\n\t\t\targs := (1 to: argCount) collect: [:i|\r\n\t\t\t\tstream atEnd ifFalse: [ stream next ]\r\n\t\t\t].\r\n\t\t\tresult := result perform: selector withArguments:\r\n\t\t\t\t(self objectsFromArguments: args)\r\n\t\t]\r\n\t].\r\n\t^result","function(self,stream,receiver)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(receiver)\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((stream):atEnd())\r\nend))() do local selector=nil\r\n(function()\r\n\tlocal _s8_value=((stream):next())\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((selector):isEmpty())==true then (function()\r\n\tlocal _s8_value=(\"/\")\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nsmalltalk:if_true_false_((smalltalk:isObject_equalTo_(((selector):first()),\"{\")),(function()\r\nlocal json=nil\r\nwhile not ((function()\r\nreturn (smalltalk:isObject_equalTo_(((selector):last()),\"}\"))\r\nend))() do if ((stream):atEnd())==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Corrupted message \"),selector)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((selector),\"/\")),(stream):next()))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)(); end;(function()\r\n\tlocal _s8_value=((self):jsonParse_(selector))\r\n\tjson=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((json):_at(\"selector\"))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isNil_((selector)))==true then (self):error_(\"Missing selector\"); end;return ((function()\r\n\tlocal _s8_value=(((smalltalk.Message):receiver_selector_arguments_(result,smalltalk:toString_((selector)),(self):objectsFromArguments_((json):_at(\"arguments\")))):perform())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),(function()\r\nlocal args=nil\r\nlocal argCount=nil\r\n(function()\r\n\tlocal _s8_value=((selector):argumentCount())\r\n\targCount=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=(((1):to_(argCount)):collect_((function(i)\r\nreturn (smalltalk:if_true_false_(((stream):atEnd()),nil,(function()\r\nreturn ((stream):next())\r\nend)))\r\nend)))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();return ((function()\r\n\tlocal _s8_value=((result):perform_withArguments_(selector,(self):objectsFromArguments_(args)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SystemServer,"evalNative:",0
,function(self,stream)
local source=nil
local lang=nil
local target=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):current())
	target=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((stream):next())
	source=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((stream):peek())
	lang=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_and_((smalltalk:notNil_((lang))),(function()
return ((not smalltalk:isObject_equalTo_((lang),(target):nativeLanguage())))
end)))==true then return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Invalid native language #"),lang))," must be #")),(target):nativeLanguage()))); end;
return ((target):eval_(source));
end
,"commands","evalNative: stream\r\n\t\" Private - Returns the result of evaluating native command in stream. \"\r\n\r\n\t| source lang target |\r\n\ttarget := Smalltalk current.\r\n\tsource := stream next.\r\n\tlang := stream peek.\r\n\t(lang notNil and: [ lang ~= target nativeLanguage ]) ifTrue: [\r\n\t\t^self error:\r\n\t\t\t 'Invalid native language #' ,lang\r\n\t\t\t,' must be #' ,target nativeLanguage\r\n\t].\r\n\t^target eval: source","function(self,stream)\r\nlocal source=nil\r\nlocal lang=nil\r\nlocal target=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):current())\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((stream):next())\r\n\tsource=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((stream):peek())\r\n\tlang=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((lang))),(function()\r\nreturn ((not smalltalk:isObject_equalTo_((lang),(target):nativeLanguage())))\r\nend)))==true then return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Invalid native language #\"),lang)),\" must be #\")),(target):nativeLanguage()))); end;\r\nreturn ((target):eval_(source));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"at:put:",0
,function(self,key,anObject)
if (smalltalk:isNil_((anObject)))==true then return (((self):cache()):removeKey_ifAbsent_(key,(function()
return (nil)
end))); end;
return (((self):cache()):at_put_(key,anObject));
end
,"cache","at: key put: anObject\r\n\t\" Register anObject in the cache. \"\r\n\r\n\tanObject isNil ifTrue: [\r\n\t\t^self cache removeKey: key ifAbsent: []\r\n\t].\r\n\t^self cache at: key put: anObject","function(self,key,anObject)\r\nif (smalltalk:isNil_((anObject)))==true then return (((self):cache()):removeKey_ifAbsent_(key,(function()\r\nreturn (nil)\r\nend))); end;\r\nreturn (((self):cache()):at_put_(key,anObject));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"at:",0
,function(self,key)
return (((self):cache()):at_ifAbsent_(key,(function()
return (nil)
end)));
end
,"cache","at: key\r\n\t\" Returns the registered object at key in the cache (or nil). \"\r\n\r\n\t^self cache at: key ifAbsent: [ nil ]","function(self,key)\r\nreturn (((self):cache()):at_ifAbsent_(key,(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"clearCache",0
,function(self)
local persistent=nil
(function()
	local _s8_value=((self):at_("persistent"))
	persistent=_s8_value
	return _s8_value
end)();
(self):initializeCache();
if (smalltalk:notNil_((persistent)))==true then (self):at_put_("persistent",persistent); end;
return (self);
end
,"cache","clearCache\r\n\t\" Reset the cache.\r\n\tNote that #persistent pool is retained in the cache.\r\n\t\"\r\n\r\n\t| persistent |\r\n\tpersistent := self at: #persistent.\r\n\tself initializeCache.\r\n\tpersistent notNil ifTrue: [ self at: #persistent put: persistent ]","function(self)\r\nlocal persistent=nil\r\n(function()\r\n\tlocal _s8_value=((self):at_(\"persistent\"))\r\n\tpersistent=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):initializeCache();\r\nif (smalltalk:notNil_((persistent)))==true then (self):at_put_(\"persistent\",persistent); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"cacheIt:to:",0
,function(self,smalltalkExpression,aReceiver)
local object=nil
local id=nil
local key=nil
(function()
	local _s8_value=((smalltalk.Compiler):doIt_to_(smalltalkExpression,aReceiver))
	object=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):at_("lastID"))
	id=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((id)))==true then (function()
	local _s8_value=(0)
	id=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=(smalltalk:toString_((id)))
	key=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):at_put_("lastID",(id):_plus(1));
	return ((_s8_rec):at_put_(key,object))
end
)(self);
return (key);
end
,"cache","cacheIt: smalltalkExpression to: aReceiver\r\n\t\" Returns the id of cached result of evaluating smalltalkExpression on aReceiver. \"\r\n\r\n\t| object id key |\r\n\tobject := Compiler\r\n\t\tdoIt: smalltalkExpression\r\n\t\tto: aReceiver.\r\n\tid := self at: #lastID.\r\n\tid isNil ifTrue: [ id := 0 ].\r\n\tkey := id toString.\r\n\tself\r\n\t\tat: #lastID put: id + 1;\r\n\t\tat: key put: object.\r\n\t^key","function(self,smalltalkExpression,aReceiver)\r\nlocal object=nil\r\nlocal id=nil\r\nlocal key=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Compiler):doIt_to_(smalltalkExpression,aReceiver))\r\n\tobject=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):at_(\"lastID\"))\r\n\tid=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((id)))==true then (function()\r\n\tlocal _s8_value=(0)\r\n\tid=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:toString_((id)))\r\n\tkey=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):at_put_(\"lastID\",(id):_plus(1));\r\n\treturn ((_s8_rec):at_put_(key,object))\r\nend\r\n)(self);\r\nreturn (key);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"@","_at"
,function(self,path)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
if ((path):isEmpty())==true then return (self); end;
if ((path):isString())==true then return ((self):_at((path):asArrayOfSubstringsSeparatedBy_((self):rootStart()))); end;
if (((self):cache()):includesKey_((path):first()))==true then return (((self):cache()):_at(path)); end;
(function()
	local _s8_value=((smalltalk.Smalltalk):at_ifAbsent_((path):removeFirst(),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end)))
	result=_s8_value
	return _s8_value
end)();
(path):do_((function(each)
(function()
	local _s8_value=((result):_at(each))
	result=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:isNil_((result))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"cache","@ path\r\n\t\" Returns the object at path (or nil). \"\r\n\r\n\t| result |\r\n\tpath isEmpty ifTrue: [ ^self ].\r\n\tpath isString ifTrue: [\r\n\t\t^self @ (path asArrayOfSubstringsSeparatedBy: self rootStart)\r\n\t].\r\n\t(self cache includesKey: path first) ifTrue: [ ^self cache @ path ].\r\n\tresult := Smalltalk at: path removeFirst ifAbsent: [ ^nil ].\r\n\tpath do: [:each|\r\n\t\tresult := result @ each.\r\n\t\tresult isNil ifTrue: [ ^nil ].\r\n\t].\r\n\t^result","function(self,path)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\nif ((path):isEmpty())==true then return (self); end;\r\nif ((path):isString())==true then return ((self):_at((path):asArrayOfSubstringsSeparatedBy_((self):rootStart()))); end;\r\nif (((self):cache()):includesKey_((path):first()))==true then return (((self):cache()):_at(path)); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_ifAbsent_((path):removeFirst(),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(path):do_((function(each)\r\n(function()\r\n\tlocal _s8_value=((result):_at(each))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:isNil_((result))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SystemServer,"rootStart",0
,function(self)
return ("@");
end
,"roots","rootStart\r\n\t\" Private - Returns the tag to start root \"\r\n\r\n\t^$@","function(self)\r\nreturn (\"@\");\r\nend")

smalltalk:bind(smalltalk.SystemServer,"root:stream:ifAbsent:",0
,function(self,command,stream,aBlock)
if ((command):isEmpty())==true then return (self); end;
if (smalltalk:isObject_equalTo_(((command):first()),(self):rootStart()))==true then return ((self):_at((command):copyFrom_to_(2,(command):size()))); end;
if (smalltalk:isObject_equalTo_((command),"self"))==true then return (self); end;
if (smalltalk:isObject_equalTo_((command),"smalltalk"))==true then return ((self):smalltalk()); end;
return ((smalltalk.Smalltalk):at_ifAbsent_(command,aBlock));
end
,"roots","root: command stream: stream ifAbsent: aBlock\r\n\t\" Private - Returns the root of path in command stream (or the result of evaluating aBlock). \"\r\n\r\n\tcommand isEmpty ifTrue: [ ^self ].\r\n\tcommand first = self rootStart ifTrue: [\r\n\t\t^self @ (command copyFrom: 2 to: command size)\r\n\t].\r\n\tcommand = #self ifTrue: [ ^self ].\r\n\tcommand = #smalltalk ifTrue: [ ^self smalltalk ].\r\n\t^Smalltalk at: command ifAbsent: aBlock","function(self,command,stream,aBlock)\r\nif ((command):isEmpty())==true then return (self); end;\r\nif (smalltalk:isObject_equalTo_(((command):first()),(self):rootStart()))==true then return ((self):_at((command):copyFrom_to_(2,(command):size()))); end;\r\nif (smalltalk:isObject_equalTo_((command),\"self\"))==true then return (self); end;\r\nif (smalltalk:isObject_equalTo_((command),\"smalltalk\"))==true then return ((self):smalltalk()); end;\r\nreturn ((smalltalk.Smalltalk):at_ifAbsent_(command,aBlock));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"resultForCommand:",0
,function(self,stream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local command=nil
local origin=nil
(function()
	local _s8_value=((stream):next())
	command=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((command),"doIt"))==true then return (((stream):next()):doIt()); end;
if (smalltalk:isObject_equalTo_((command),"fileIn"))==true then return (((stream):next()):fileIn()); end;
if (smalltalk:isObject_equalTo_((command),"eval"))==true then return ((self):evalNative_(stream)); end;
if (smalltalk:isObject_equalTo_((command),"fileOut"))==true then return (((stream):next()):fileOut()); end;
if ((smalltalk:newArray({"fileOut", "category"})):includes_(command))==true then return (((stream):next()):fileOut()); end;
(function()
	local _s8_value=((self):root_stream_ifAbsent_(command,stream,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_(("Unknown command "),command))
end
)()
error(_s8Ret_,0)
end)())
end)))
	origin=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):perform_on_(stream,origin))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"commands","resultForCommand: stream\r\n\t\" Private - Return the result of processing the command in stream. \"\r\n\r\n\t| command origin |\r\n\tcommand := stream next.\r\n\tcommand = #doIt\t\tifTrue: [ ^stream next doIt ].\r\n\tcommand = #fileIn\t\tifTrue: [ ^stream next fileIn ].\r\n\tcommand = #eval\t\tifTrue: [ ^self evalNative: stream ].\r\n\tcommand = #fileOut\tifTrue: [ ^stream next fileOut ].\r\n\t(#(fileOut category) includes: command) ifTrue: [ ^stream next fileOut ].\r\n\torigin := self root: command stream: stream ifAbsent: [\r\n\t\t^'Unknown command ',command\r\n\t].\r\n\t^self perform: stream on: origin","function(self,stream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal command=nil\r\nlocal origin=nil\r\n(function()\r\n\tlocal _s8_value=((stream):next())\r\n\tcommand=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((command),\"doIt\"))==true then return (((stream):next()):doIt()); end;\r\nif (smalltalk:isObject_equalTo_((command),\"fileIn\"))==true then return (((stream):next()):fileIn()); end;\r\nif (smalltalk:isObject_equalTo_((command),\"eval\"))==true then return ((self):evalNative_(stream)); end;\r\nif (smalltalk:isObject_equalTo_((command),\"fileOut\"))==true then return (((stream):next()):fileOut()); end;\r\nif ((smalltalk:newArray({\"fileOut\", \"category\"})):includes_(command))==true then return (((stream):next()):fileOut()); end;\r\n(function()\r\n\tlocal _s8_value=((self):root_stream_ifAbsent_(command,stream,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((\"Unknown command \"),command))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\torigin=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):perform_on_(stream,origin))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SystemServer,"categories",0
,function(self)
return (smalltalk:printString_((((smalltalk.Class):categories()):sorted())));
end
,"commands","categories\r\n\t\" Private - Returns the categories in the system. \"\r\n\r\n\t^Class categories sorted printString","function(self)\r\nreturn (smalltalk:printString_((((smalltalk.Class):categories()):sorted())));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"classes",0
,function(self)
return (((smalltalk.Smalltalk):classes()):inject_into_("",(function(total,cls)
return (smalltalk:object_comma_((smalltalk:object_comma_((total),"\r\n")),(self):shortDescriptionForClass_(cls)))
end)));
end
,"commands","classes\r\n\t\" Private - Returns the contents for this command. \"\r\n\r\n\t^Smalltalk classes inject: '' into: [:total :cls|\r\n\t\ttotal,'\r\n',(self shortDescriptionForClass: cls)\r\n\t]","function(self)\r\nreturn (((smalltalk.Smalltalk):classes()):inject_into_(\"\",(function(total,cls)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((total),\"\\r\\n\")),(self):shortDescriptionForClass_(cls)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"hierarchy",0
,function(self)
local stream=nil
(function()
	local _s8_value=((""):writeStream())
	stream=_s8_value
	return _s8_value
end)();
((smalltalk.Smalltalk):rootClasses()):do_((function(cls)
return ((self):walk_blanks_into_(cls,0,stream))
end));
return ((stream):contents());
end
,"commands","hierarchy\r\n\t\" Private - Returns the contents for this command. \"\r\n\r\n\t| stream |\r\n\tstream := '' writeStream.\r\n\tSmalltalk rootClasses do: [:cls|\r\n\t\tself walk: cls blanks: 0 into: stream\r\n\t].\r\n\t^stream contents","function(self)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((smalltalk.Smalltalk):rootClasses()):do_((function(cls)\r\nreturn ((self):walk_blanks_into_(cls,0,stream))\r\nend));\r\nreturn ((stream):contents());\r\nend")

smalltalk:bind(smalltalk.SystemServer,"walk:blanks:into:",0
,function(self,aClass,blanks,stream)
(stream):cr();
smalltalk:times_repeat_((blanks),(function()
return ((stream):nextPut_(" "))
end));
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):shortDescriptionForClass_(aClass));
	return ((_s8_rec):cr())
end
)(stream);
((aClass):subclasses()):do_((function(cls)
return ((self):walk_blanks_into_(cls,(blanks):_plus(1),stream))
end));
return (self);
end
,"commands","walk: aClass blanks: blanks into: stream\r\n\t\" Private - Returns the description for hierarchy level @ blanks. \"\r\n\r\n\tstream cr. blanks timesRepeat: [ stream nextPut: $ ].\r\n\tstream nextPutAll: (self shortDescriptionForClass: aClass);cr.\r\n\taClass subclasses do: [:cls|\r\n\t\tself walk: cls blanks: blanks + 1 into: stream\r\n\t].","function(self,aClass,blanks,stream)\r\n(stream):cr();\r\nsmalltalk:times_repeat_((blanks),(function()\r\nreturn ((stream):nextPut_(\" \"))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):shortDescriptionForClass_(aClass));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream);\r\n((aClass):subclasses()):do_((function(cls)\r\nreturn ((self):walk_blanks_into_(cls,(blanks):_plus(1),stream))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"shortDescriptionForClass:",0
,function(self,aClass)
return (smalltalk:object_comma_((smalltalk:object_comma_(((aClass):name())," ")),(aClass):category()));
end
,"private","shortDescriptionForClass: aClass\r\n\t\" Private - Returns the contents to show for aClass. \"\r\n\r\n\t^aClass name,' ',aClass category","function(self,aClass)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_(((aClass):name()),\" \")),(aClass):category()));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"jsonValue:",0
,function(self,aBlock)
local response=nil
local jResult=nil
((function()
local result=nil
(function()
	local _s8_value=((self):literalFor_((aBlock):evaluate()))
	result=_s8_value
	return _s8_value
end)();return ((function()
	local _s8_value=((self):changesWith_(("result"):_minus_gt(result)))
	response=_s8_value
	return _s8_value
end)())
end)):on_do_(smalltalk.Exception,(function(ex)
(function()
	local _s8_value=(("error"):_minus_gt(ex))
	response=_s8_value
	return _s8_value
end)();(self):say_(("error"):_minus_gt((ex):description()));return (smalltalk:if_true_false_((((((ex):stack()):size()) > 0)),(function()
return ((self):say_((ex):stack()))
end),nil))
end));
return (((function()
(function()
	local _s8_value=((response):json())
	jResult=_s8_value
	return _s8_value
end)();return ((self):jsonStringify_(jResult))
end)):on_do_(smalltalk.Exception,(function(ignored)
return (smalltalk:toString_((jResult)))
end)));
end
,"output","jsonValue: aBlock\r\n\t\" Private - Returns a JSON package string with result of evaluating aBlock. \"\r\n\r\n\t| response jResult |\r\n\t[ | result |\r\n\t\tresult := self literalFor: aBlock evaluate.\r\n\t\tresponse := self changesWith: #result -> result\r\n\t] on: Exception do: [:ex|\r\n\t\tresponse := #error -> ex.\r\n\t\tself say: #error -> ex description.\r\n\t\tex stack size > 0 ifTrue: [ self say: ex stack ]\r\n\t].\r\n\t^[\tjResult := response json.\r\n\t\tself jsonStringify: jResult\r\n\t] on: Exception do: [:ignored| jResult toString ]","function(self,aBlock)\r\nlocal response=nil\r\nlocal jResult=nil\r\n((function()\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):literalFor_((aBlock):evaluate()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();return ((function()\r\n\tlocal _s8_value=((self):changesWith_((\"result\"):_minus_gt(result)))\r\n\tresponse=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\n(function()\r\n\tlocal _s8_value=((\"error\"):_minus_gt(ex))\r\n\tresponse=_s8_value\r\n\treturn _s8_value\r\nend)();(self):say_((\"error\"):_minus_gt((ex):description()));return (smalltalk:if_true_false_((((((ex):stack()):size()) > 0)),(function()\r\nreturn ((self):say_((ex):stack()))\r\nend),nil))\r\nend));\r\nreturn (((function()\r\n(function()\r\n\tlocal _s8_value=((response):json())\r\n\tjResult=_s8_value\r\n\treturn _s8_value\r\nend)();return ((self):jsonStringify_(jResult))\r\nend)):on_do_(smalltalk.Exception,(function(ignored)\r\nreturn (smalltalk:toString_((jResult)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"escape",0
,function(self)
return ("!");
end
,"output","escape\r\n\t\" Private - Returns the escape token. \"\r\n\r\n\t^$! ","function(self)\r\nreturn (\"!\");\r\nend")

smalltalk:bind(smalltalk.SystemServer,"referenceTo:",0
,function(self,anObject)
if (smalltalk:responds_to_((anObject),("systemServerReferenceIn:")))==true then return (smalltalk:object_comma_((smalltalk:object_comma_(((self):escape()),"@")),smalltalk:toString_(((anObject):systemServerReferenceIn_(self))))); end;
return (smalltalk:printString_((anObject)));
end
,"output","referenceTo: anObject\r\n\t\" Private - Returns the reference to link anObject on the client side. \"\r\n\r\n\t(anObject respondsTo: #systemServerReferenceIn:) ifTrue: [\r\n\t\t^self escape ,$@ ,(anObject systemServerReferenceIn: self) toString\r\n\t].\r\n\t^anObject printString","function(self,anObject)\r\nif (smalltalk:responds_to_((anObject),(\"systemServerReferenceIn:\")))==true then return (smalltalk:object_comma_((smalltalk:object_comma_(((self):escape()),\"@\")),smalltalk:toString_(((anObject):systemServerReferenceIn_(self))))); end;\r\nreturn (smalltalk:printString_((anObject)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"literalFor:",0
,function(self,anObject)
if (smalltalk:isNil_((anObject)))==true then return (smalltalk:object_comma_(((self):escape()),"nil")); end;
if ((self):isObject_(anObject))==true then if (smalltalk:boolean_or_(((anObject):isNumber()),(function()
return ((anObject):isMemberOf_(smalltalk.Boolean))
end)))==true then return (smalltalk:object_comma_(((self):escape()),anObject)); end;
if ((anObject):isString())==true then if ((anObject):startsWith_((self):escape()))==true then return (smalltalk:object_comma_(((self):escape()),anObject)); end;
return (anObject); end;
if ((anObject):isArray())==true then return ((anObject):collect_((function(each)
return ((self):literalFor_(each))
end))); end;
if (smalltalk:boolean_or_(((anObject):isClass()),(function()
return (smalltalk:boolean_or_(((anObject):isMetaclass()),(function()
return (smalltalk:is_kindOf_((anObject),(smalltalk.CompiledMethod)))
end)))
end)))==true then return (smalltalk:object_comma_(((self):escape()),smalltalk:printString_((anObject)))); end;
return ((self):referenceTo_(anObject)); end;
return (anObject);
end
,"output","literalFor: anObject\r\n\t\" Private - Returns the literal to use as reference to anObject on client side. \"\r\n\r\n\tanObject isNil ifTrue: [ ^self escape ,#nil ].\r\n\t(self isObject: anObject) ifTrue: [\r\n\t\t(anObject isNumber or: [ anObject isMemberOf: Boolean ]) ifTrue: [ ^self escape ,anObject ].\r\n\t\tanObject isString ifTrue: [\r\n\t\t\t(anObject startsWith: self escape) ifTrue: [ ^self escape ,anObject ].\r\n\t\t\t^anObject\r\n\t\t].\r\n\t\tanObject isArray ifTrue: [ ^anObject collect: [:each| self literalFor: each ] ].\r\n\t\t(anObject isClass or: [ anObject isMetaclass\r\n\t\tor: [anObject isKindOf: CompiledMethod]])\r\n\t\tifTrue: [ ^self escape ,anObject printString ].\r\n\t\t^self referenceTo: anObject\r\n\t].\r\n\t^anObject","function(self,anObject)\r\nif (smalltalk:isNil_((anObject)))==true then return (smalltalk:object_comma_(((self):escape()),\"nil\")); end;\r\nif ((self):isObject_(anObject))==true then if (smalltalk:boolean_or_(((anObject):isNumber()),(function()\r\nreturn ((anObject):isMemberOf_(smalltalk.Boolean))\r\nend)))==true then return (smalltalk:object_comma_(((self):escape()),anObject)); end;\r\nif ((anObject):isString())==true then if ((anObject):startsWith_((self):escape()))==true then return (smalltalk:object_comma_(((self):escape()),anObject)); end;\r\nreturn (anObject); end;\r\nif ((anObject):isArray())==true then return ((anObject):collect_((function(each)\r\nreturn ((self):literalFor_(each))\r\nend))); end;\r\nif (smalltalk:boolean_or_(((anObject):isClass()),(function()\r\nreturn (smalltalk:boolean_or_(((anObject):isMetaclass()),(function()\r\nreturn (smalltalk:is_kindOf_((anObject),(smalltalk.CompiledMethod)))\r\nend)))\r\nend)))==true then return (smalltalk:object_comma_(((self):escape()),smalltalk:printString_((anObject)))); end;\r\nreturn ((self):referenceTo_(anObject)); end;\r\nreturn (anObject);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"changesWith:",0
,function(self,results)
local changes=nil
(function()
	local _s8_value=(self["@systemChanges"])
	changes=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(nil)
	self["@systemChanges"]=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_or_((smalltalk:isNil_((changes))),(function()
return ((changes):isEmpty())
end)))==true then return (results); end;
(function()
	local _s8_value=((self):literalFor_(changes))
	changes=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((results),("changes"):_minus_gt(changes)));
end
,"output","changesWith: results\r\n\t\" Private - Returns the results with logged changes. \"\r\n\r\n\t| changes |\r\n\tchanges := systemChanges.\r\n\tsystemChanges := nil.\r\n\t(changes isNil or: [changes isEmpty]) ifTrue: [ ^results ].\r\n\tchanges := self literalFor: changes.\r\n\t^results ,(#changes -> changes)","function(self,results)\r\nlocal changes=nil\r\n(function()\r\n\tlocal _s8_value=(self[\"@systemChanges\"])\r\n\tchanges=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@systemChanges\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_or_((smalltalk:isNil_((changes))),(function()\r\nreturn ((changes):isEmpty())\r\nend)))==true then return (results); end;\r\n(function()\r\n\tlocal _s8_value=((self):literalFor_(changes))\r\n\tchanges=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((results),(\"changes\"):_minus_gt(changes)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"processSystemChanges",0
,function(self)
return (self);
end
,"system changes","processSystemChanges\r\n\t\" Private - The receiver has changes to be processed.\r\n\tWe do nothing, the changes will be sent to client(s?) on demmand.\r\n\t\"","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"nodeStart:processBlock:port:",0
,function(self,aServer,aBlock,aPort)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local localIP=nil
local http=nil
local httpServer=nil
((function()
return ((function()
	local _s8_value=((smalltalk.NodeJS):http())
	http=_s8_value
	return _s8_value
end)())
end)):on_do_(smalltalk.Error,(function(ignored)
(self):note_(smalltalk:object_comma_((((self)["$klass"]):name())," missing HTTP interface."));return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
	local _s8_value=(((smalltalk.NodeJS):os()):localIP())
	localIP=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((localIP)))==true then (self):note_(smalltalk:object_comma_((((self)["$klass"]):name())," missing network connection. (localIP is nil, check network connection)"));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
	local _s8_value=((http):createServer_((function(req,resp)
local request=nil
local response=nil
(function()
	local _s8_value=((smalltalk.NodeIncomingMessage):_at(req))
	request=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((smalltalk.NodeHTTPServerResponse):_at(resp))
	response=_s8_value
	return _s8_value
end)();return ((
function(_s8_rec)
	(_s8_rec):setHeader_value_("Access-Control-Allow-Origin","*");
	(_s8_rec):writeHead_(200);
	return ((_s8_rec):end_((aBlock):value_value_(request,response)))
end
)(response))
end)))
	httpServer=_s8_value
	return _s8_value
end)();
((function()
(httpServer):listen_hostname_(aPort,(nil):json());return ((self):serverStartedAt_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("http://"),localIP)),":")),aPort)))
end)):on_do_(smalltalk.Exception,(function(ex)
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((((self)["$klass"]):name())," ")),smalltalk:toString_((ex))));return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (httpServer)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"node","nodeStart: aServer processBlock: aBlock port: aPort\r\n\t\" Private - Start the server. \"\r\n\r\n\t| localIP http httpServer |\r\n\t[ http := NodeJS http ] on: Error do: [:ignored|\r\n\t\tself note: self class name ,' missing HTTP interface.'.\r\n\t\t^nil\r\n\t].\r\n\tlocalIP := NodeJS os localIP.\r\n\tlocalIP isNil ifTrue: [\r\n\t\tself note: self class name ,' missing network connection. (localIP is nil, check network connection)'.\r\n\t\t^nil\r\n\t].\r\n\thttpServer := http createServer: [:req :resp| | request response |\r\n\t\trequest  := NodeIncomingMessage @ req.\r\n\t\tresponse := NodeHTTPServerResponse @ resp.\r\n\t\tresponse \r\n\t\t\tsetHeader:'Access-Control-Allow-Origin' value:'*';\r\n\t\t\twriteHead: 200;\r\n\t\t\tend: (aBlock value: request value: response).\r\n\t].\r\n\t[\thttpServer listen: aPort hostname: nil json.\r\n\t\tself serverStartedAt: 'http://' ,localIP ,':' ,aPort\r\n\t ] on: Exception do: [:ex|\r\n\t\tself note: self class name ,' ' ,ex toString.\r\n\t\t^nil\r\n\t].\r\n\t^httpServer","function(self,aServer,aBlock,aPort)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal localIP=nil\r\nlocal http=nil\r\nlocal httpServer=nil\r\n((function()\r\nreturn ((function()\r\n\tlocal _s8_value=((smalltalk.NodeJS):http())\r\n\thttp=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):on_do_(smalltalk.Error,(function(ignored)\r\n(self):note_(smalltalk:object_comma_((((self)[\"$klass\"]):name()),\" missing HTTP interface.\"));return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.NodeJS):os()):localIP())\r\n\tlocalIP=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((localIP)))==true then (self):note_(smalltalk:object_comma_((((self)[\"$klass\"]):name()),\" missing network connection. (localIP is nil, check network connection)\"));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((http):createServer_((function(req,resp)\r\nlocal request=nil\r\nlocal response=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.NodeIncomingMessage):_at(req))\r\n\trequest=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((smalltalk.NodeHTTPServerResponse):_at(resp))\r\n\tresponse=_s8_value\r\n\treturn _s8_value\r\nend)();return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):setHeader_value_(\"Access-Control-Allow-Origin\",\"*\");\r\n\t(_s8_rec):writeHead_(200);\r\n\treturn ((_s8_rec):end_((aBlock):value_value_(request,response)))\r\nend\r\n)(response))\r\nend)))\r\n\thttpServer=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((function()\r\n(httpServer):listen_hostname_(aPort,(nil):json());return ((self):serverStartedAt_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"http://\"),localIP)),\":\")),aPort)))\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((((self)[\"$klass\"]):name()),\" \")),smalltalk:toString_((ex))));return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (httpServer)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SystemServer,"nodeRequestBlock",0
,function(self)
return ((self):requestBlockFor_method_post_((function(req)
return (((req):url()):asDecodedURI())
end),(function(req)
return ((req):method())
end),(function(req,action)
local body=nil
(function()
	local _s8_value=("")
	body=_s8_value
	return _s8_value
end)();(
function(_s8_rec)
	(_s8_rec):on_do_("data",(function(data)
return ((function()
	local _s8_value=(smalltalk:object_comma_((body),data))
	body=_s8_value
	return _s8_value
end)())
end));
	return ((_s8_rec):on_do_("end",(function()
return ((action):value_(((body):asDecodedURI()):stream()))
end)))
end
)(req);return ("ok")
end)));
end
,"node","nodeRequestBlock\r\n\t\" Private - Return the request processing block used for remote system tools. \"\r\n\r\n\t^self\r\n\t\trequestBlockFor: [:req| req url asDecodedURI ]\r\n\t\tmethod: [:req| req method ]\r\n\t\tpost: [:req :action| | body |\r\n\t\t\tbody := ''.\r\n\t\t\treq\r\n\t\t\t\ton: #data do: [:data| body := body ,data ];\r\n\t\t\t\ton: #end do: [ action value: body asDecodedURI stream ].\r\n\t\t\t#ok\r\n\t\t] ","function(self)\r\nreturn ((self):requestBlockFor_method_post_((function(req)\r\nreturn (((req):url()):asDecodedURI())\r\nend),(function(req)\r\nreturn ((req):method())\r\nend),(function(req,action)\r\nlocal body=nil\r\n(function()\r\n\tlocal _s8_value=(\"\")\r\n\tbody=_s8_value\r\n\treturn _s8_value\r\nend)();(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):on_do_(\"data\",(function(data)\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((body),data))\r\n\tbody=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\n\treturn ((_s8_rec):on_do_(\"end\",(function()\r\nreturn ((action):value_(((body):asDecodedURI()):stream()))\r\nend)))\r\nend\r\n)(req);return (\"ok\")\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"nodeParse:",0
,function(self,string)
return ((self):defaultParse_(string));
end
,"node","nodeParse: string\r\n\t\" Private - Return the result of parsing JSON string. \"\r\n\r\n\t^self defaultParse: string","function(self,string)\r\nreturn ((self):defaultParse_(string));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"nodeStringify:",0
,function(self,literal)
return ((self):defaultStringify_(literal));
end
,"node","nodeStringify: literal\r\n\t\" Private - Return the result of JSON string. \"\r\n\r\n\t^self defaultStringify: literal","function(self,literal)\r\nreturn ((self):defaultStringify_(literal));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"gcdStart:processBlock:port:",0
,function(self,aServer,aBlock,aPort)
local instance=nil
(function()
	local _s8_value=((smalltalk.GCDWebServer):startHTML_withPort_(aBlock,aPort))
	instance=_s8_value
	return _s8_value
end)();
return (self);
end
,"gcd","gcdStart: aServer processBlock: aBlock port: aPort\r\n\t\" Private - Start the server. \"\r\n\r\n\t| instance |\r\n\tinstance := GCDWebServer startHTML: aBlock withPort: aPort.\r\n\t\"self serverStartedAt: instance serverURL absoluteString\" ","function(self,aServer,aBlock,aPort)\r\nlocal instance=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.GCDWebServer):startHTML_withPort_(aBlock,aPort))\r\n\tinstance=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"gcdRequestBlock",0
,function(self)
return ((self):requestBlockFor_method_post_((function(req)
return ((req):path())
end),(function(req)
return ("GET")
end),(function(req,action)
local body=nil
(function()
	local _s8_value=("")
	body=_s8_value
	return _s8_value
end)();(
function(_s8_rec)
	(_s8_rec):notImplementedYet_(smalltalk:object_comma_(("gcdRequestBlock")," (POST)"));
	(_s8_rec):on_do_("data",(function(data)
return ((function()
	local _s8_value=(smalltalk:object_comma_((body),data))
	body=_s8_value
	return _s8_value
end)())
end));
	return ((_s8_rec):on_do_("end",(function()
return ((action):value_(((body):asDecodedURI()):stream()))
end)))
end
)(req);return ("ok")
end)));
end
,"gcd","gcdRequestBlock\r\n\t\" Private - Return the request processing block used for remote system tools. \"\r\n\r\n\t^self\r\n\t\trequestBlockFor: [:req| req path ]\r\n\t\tmethod: [:req| #GET ]\r\n\t\tpost: [:req :action| | body |\r\n\t\t\tbody := ''.\r\n\t\t\treq\tnotImplementedYet: #gcdRequestBlock ,' (POST)';\r\n\t\t\t\ton: #data do: [:data| body := body ,data ];\r\n\t\t\t\ton: #end do: [ action value: body asDecodedURI stream ].\r\n\t\t\t#ok\r\n\t\t]","function(self)\r\nreturn ((self):requestBlockFor_method_post_((function(req)\r\nreturn ((req):path())\r\nend),(function(req)\r\nreturn (\"GET\")\r\nend),(function(req,action)\r\nlocal body=nil\r\n(function()\r\n\tlocal _s8_value=(\"\")\r\n\tbody=_s8_value\r\n\treturn _s8_value\r\nend)();(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):notImplementedYet_(smalltalk:object_comma_((\"gcdRequestBlock\"),\" (POST)\"));\r\n\t(_s8_rec):on_do_(\"data\",(function(data)\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((body),data))\r\n\tbody=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\n\treturn ((_s8_rec):on_do_(\"end\",(function()\r\nreturn ((action):value_(((body):asDecodedURI()):stream()))\r\nend)))\r\nend\r\n)(req);return (\"ok\")\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"gcdParse:",0
,function(self,string)
return ((self):defaultParse_(string));
end
,"gcd","gcdParse: string\r\n\t\" Private - Return the result of parsing JSON string. \"\r\n\r\n\t^self defaultParse: string","function(self,string)\r\nreturn ((self):defaultParse_(string));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"gcdStringify:",0
,function(self,literal)
return ((self):defaultStringify_(literal));
end
,"gcd","gcdStringify: literal\r\n\t\" Private - Return the result of JSON string. \"\r\n\r\n\t^self defaultStringify: literal","function(self,literal)\r\nreturn ((self):defaultStringify_(literal));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"turboStart:processBlock:port:",0
,function(self,aServer,aBlock,aPort)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local http=nil
(function()
	local _s8_value=((smalltalk.HTTPServer):new_((function(hRequest)
local hdr=nil
local request=nil
local msg=nil
local buf=nil
local crlf=nil
(function()
	local _s8_value=((smalltalk.String):crlf())
	crlf=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((smalltalk.HTTPRequest):_at(hRequest))
	request=_s8_value
	return _s8_value
end)();smalltalk:basic_at_put_((request),"path",(request):path());(function()
	local _s8_value=((aBlock):value_(request))
	msg=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((smalltalk.HTTPHeaders):new())
	hdr=_s8_value
	return _s8_value
end)();(
function(_s8_rec)
	(_s8_rec):add_value_("Content-Length",smalltalk:object_comma_((""),(msg):size()));
	(_s8_rec):add_value_("Connection","Keep-Alive");
	(_s8_rec):add_value_("Access-Control-Allow-Origin","*");
	(_s8_rec):setStatusCode_(200);
	(_s8_rec):setVersion_("HTTP/1.1");
	return ((_s8_rec):yourself())
end
)(hdr);(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((hdr):stringifyAsResponse()),crlf)),msg))
	buf=_s8_value
	return _s8_value
end)();return ((
function(_s8_rec)
	(_s8_rec):write_(buf);
	return ((_s8_rec):finish())
end
)(request))
end)))
	http=_s8_value
	return _s8_value
end)();
((function()
(http):listen_(aPort);return ((self):serverStartedAt_(smalltalk:object_comma_(("port "),aPort)))
end)):on_do_(smalltalk.Exception,(function(ex)
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((((self)["$klass"]):name())," ")),smalltalk:toString_((ex))));return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (http)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"turbo","turboStart: aServer processBlock: aBlock port: aPort\r\n\t\" Private - Start the server. \"\r\n\r\n\t| http |\r\n\thttp := HTTPServer new: [:hRequest| | hdr request msg buf crlf |\r\n\t\tcrlf := String crlf.\r\n\t\trequest := HTTPRequest @ hRequest.\r\n\t\trequest basicAt: #path put: request path.\r\n\t\tmsg := aBlock value: request.\r\n\t\thdr := HTTPHeaders new.\r\n\t\thdr\r\n\t\t\tadd: 'Content-Length' value: '',msg size;\r\n\t\t\tadd: 'Connection' value: 'Keep-Alive';\r\n\t\t\tadd: 'Access-Control-Allow-Origin' value: $*;\r\n\t\t\tsetStatusCode: 200;\r\n\t\t\tsetVersion: 'HTTP/1.1';\r\n\t\t\tyourself.\r\n\t\tbuf := hdr stringifyAsResponse ,crlf ,msg.\r\n\t\trequest write: buf; finish\r\n\t].\r\n\t[\thttp listen: aPort.\r\n\t\tself serverStartedAt: 'port ',aPort.\r\n\t\t\"Ioloop instance start\"\r\n\t ] on: Exception do: [:ex|\r\n\t\tself note: self class name ,' ' ,ex toString.\r\n\t\t^nil\r\n\t].\r\n\t^http","function(self,aServer,aBlock,aPort)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal http=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.HTTPServer):new_((function(hRequest)\r\nlocal hdr=nil\r\nlocal request=nil\r\nlocal msg=nil\r\nlocal buf=nil\r\nlocal crlf=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.String):crlf())\r\n\tcrlf=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((smalltalk.HTTPRequest):_at(hRequest))\r\n\trequest=_s8_value\r\n\treturn _s8_value\r\nend)();smalltalk:basic_at_put_((request),\"path\",(request):path());(function()\r\n\tlocal _s8_value=((aBlock):value_(request))\r\n\tmsg=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((smalltalk.HTTPHeaders):new())\r\n\thdr=_s8_value\r\n\treturn _s8_value\r\nend)();(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_value_(\"Content-Length\",smalltalk:object_comma_((\"\"),(msg):size()));\r\n\t(_s8_rec):add_value_(\"Connection\",\"Keep-Alive\");\r\n\t(_s8_rec):add_value_(\"Access-Control-Allow-Origin\",\"*\");\r\n\t(_s8_rec):setStatusCode_(200);\r\n\t(_s8_rec):setVersion_(\"HTTP/1.1\");\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(hdr);(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((hdr):stringifyAsResponse()),crlf)),msg))\r\n\tbuf=_s8_value\r\n\treturn _s8_value\r\nend)();return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):write_(buf);\r\n\treturn ((_s8_rec):finish())\r\nend\r\n)(request))\r\nend)))\r\n\thttp=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((function()\r\n(http):listen_(aPort);return ((self):serverStartedAt_(smalltalk:object_comma_((\"port \"),aPort)))\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((((self)[\"$klass\"]):name()),\" \")),smalltalk:toString_((ex))));return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (http)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SystemServer,"turboRequestBlock",0
,function(self)
return ((self):requestBlockFor_method_post_((function(req)
return (((smalltalk.Escape):new()):unescape_(req["path"]))
end),(function(req)
return ("GET")
end),(function(req,action)
(req):notImplementedYet_(smalltalk:object_comma_(("gcdRequestBlock")," (POST)"));return ("ok")
end)));
end
,"turbo","turboRequestBlock\r\n\t\" Private - Return the request processing block used for remote system tools. \"\r\n\r\n\t^self\r\n\t\trequestBlockFor: [:req| Escape new unescape: req#path ]\r\n\t\tmethod: [:req| #GET ]\r\n\t\tpost: [:req :action|\r\n\t\t\treq notImplementedYet: #gcdRequestBlock ,' (POST)'.\r\n\t\t\t#ok\r\n\t\t]","function(self)\r\nreturn ((self):requestBlockFor_method_post_((function(req)\r\nreturn (((smalltalk.Escape):new()):unescape_(req[\"path\"]))\r\nend),(function(req)\r\nreturn (\"GET\")\r\nend),(function(req,action)\r\n(req):notImplementedYet_(smalltalk:object_comma_((\"gcdRequestBlock\"),\" (POST)\"));return (\"ok\")\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"turboParse:",0
,function(self,string)
local result=nil
(function()
	local _s8_value=(((smalltalk.NativeHandle):support()):_at(((smalltalk.Escape):new()):jsonDecode_(string)))
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((result)))==true then (self):checkArrays_((result):handle()); end;
return (result);
end
,"turbo","turboParse: string\r\n\t\" Private - Return the result of parsing JSON string. \"\r\n\r\n\t| result |\r\n\tresult := NativeHandle support @ (Escape new jsonDecode: string).\r\n\tresult notNil ifTrue: [ self checkArrays: result handle ].\r\n\t^result","function(self,string)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.NativeHandle):support()):_at(((smalltalk.Escape):new()):jsonDecode_(string)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((result)))==true then (self):checkArrays_((result):handle()); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.SystemServer,"turboStringify:",0
,function(self,literal)
return (((smalltalk.Escape):new()):jsonEncode_(((smalltalk.NativeHandle):support()):_at(literal)));
end
,"turbo","turboStringify: literal\r\n\t\" Private - Return the result of JSON string. \"\r\n\r\n\t^Escape new jsonEncode: NativeHandle support @ literal","function(self,literal)\r\nreturn (((smalltalk.Escape):new()):jsonEncode_(((smalltalk.NativeHandle):support()):_at(literal)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"luaSimpleStart:processBlock:port:",0
,function(self,aServer,aBlock,aPort)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local http=nil
if not (((smalltalk.Smalltalk):includesKey_("Json")))==true then (self):note_("Missing Json support (SimpleJson.st required)");
return ((self):error_("Missing Json support (SimpleJson.st required)")); end;
(function()
	local _s8_value=((smalltalk.SimpleHTTPServer):new())
	http=_s8_value
	return _s8_value
end)();
((function()
(
function(_s8_rec)
	(_s8_rec):port_(aPort);
	(_s8_rec):when_do_("needsContents:with:",(function(uri,headers)
return ((aBlock):value_value_(uri,headers))
end));
	return ((_s8_rec):start())
end
)(http);return ((self):serverStartedAt_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:toString_(((http):host()))),":")),(http):port())))
end)):on_do_(smalltalk.Exception,(function(ex)
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((((self)["$klass"]):name())," ")),smalltalk:toString_((ex))));return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (http)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"luaSimple","luaSimpleStart: aServer processBlock: aBlock port: aPort\r\n\t\" Private - Start the server. \"\r\n\r\n\t| http |\r\n\t(Smalltalk includesKey: #Json) ifFalse: [\r\n\t\tself note: 'Missing Json support (SimpleJson.st required)'.\r\n\t\t^self error: 'Missing Json support (SimpleJson.st required)'\r\n\t].\r\n\thttp := SimpleHTTPServer new.\r\n\t[  http\tport: aPort;\r\n\t\twhen: #needsContents:with: do: [:uri :headers|\r\n\t\t\taBlock value: uri value: headers\r\n\t\t]; start.\r\n\t  self serverStartedAt: http host toString ,':' ,http port.\r\n\t ] on: Exception do: [:ex|\r\n\t\tself note: self class name ,' ' ,ex toString.\r\n\t\t^nil\r\n\t].\r\n\t^http","function(self,aServer,aBlock,aPort)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal http=nil\r\nif not (((smalltalk.Smalltalk):includesKey_(\"Json\")))==true then (self):note_(\"Missing Json support (SimpleJson.st required)\");\r\nreturn ((self):error_(\"Missing Json support (SimpleJson.st required)\")); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.SimpleHTTPServer):new())\r\n\thttp=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):port_(aPort);\r\n\t(_s8_rec):when_do_(\"needsContents:with:\",(function(uri,headers)\r\nreturn ((aBlock):value_value_(uri,headers))\r\nend));\r\n\treturn ((_s8_rec):start())\r\nend\r\n)(http);return ((self):serverStartedAt_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:toString_(((http):host()))),\":\")),(http):port())))\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((((self)[\"$klass\"]):name()),\" \")),smalltalk:toString_((ex))));return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (http)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SystemServer,"luaSimpleRequestBlock",0
,function(self)
return ((self):requestBlockFor_method_post_((function(uri,headers)
return ((uri):unescaped())
end),(function(uri,headers)
return ("GET")
end),(function(req,action)
(req):notImplementedYet_(smalltalk:object_comma_(("luaSimpleRequestBlock")," (POST)"));return ("ok")
end)));
end
,"luaSimple","luaSimpleRequestBlock\r\n\t\" Private - Return the request processing block used for remote system tools. \"\r\n\r\n\t^self\r\n\t\trequestBlockFor: [:uri :headers| uri unescaped ]\r\n\t\tmethod: [:uri :headers| #GET ]\r\n\t\tpost: [:req :action|\r\n\t\t\treq notImplementedYet: #luaSimpleRequestBlock ,' (POST)'.\r\n\t\t\t#ok\r\n\t\t]","function(self)\r\nreturn ((self):requestBlockFor_method_post_((function(uri,headers)\r\nreturn ((uri):unescaped())\r\nend),(function(uri,headers)\r\nreturn (\"GET\")\r\nend),(function(req,action)\r\n(req):notImplementedYet_(smalltalk:object_comma_((\"luaSimpleRequestBlock\"),\" (POST)\"));return (\"ok\")\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"luaSimpleParse:",0
,function(self,string)
local json=nil
local js=nil
local args=nil
(function()
	local _s8_value=((smalltalk.Json):parse_(string))
	js=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((js)))==true then return ((self):error_(smalltalk:object_comma_(("Broken Json :"),string))); end;
(function()
	local _s8_value=((js):_at("arguments"))
	args=_s8_value
	return _s8_value
end)();
smalltalk:newArray(args);
(function()
	local _s8_value=((smalltalk:object_comma_((("selector"):_minus_gt(smalltalk:toString_(((js):_at("selector"))))),("arguments"):_minus_gt(args))):json())
	json=_s8_value
	return _s8_value
end)();
return (((smalltalk.NativeHandle):support()):_at(json));
end
,"luaSimple","luaSimpleParse: string\r\n\t\" Private - Return the result of parsing JSON string. \"\r\n\r\n\t| json js args |\r\n\tjs := Json parse: string.\r\n\tjs isNil ifTrue: [ ^self error: 'Broken Json :',string ].\r\n\targs := js @ #arguments.\r\n\t{'args' lua'smalltalk:newArray(args)'}.\r\n\tjson := ((#selector -> (js @ #selector) toString)\r\n\t\t,(#arguments -> args)) json.\r\n\t^NativeHandle support @ json","function(self,string)\r\nlocal json=nil\r\nlocal js=nil\r\nlocal args=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Json):parse_(string))\r\n\tjs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((js)))==true then return ((self):error_(smalltalk:object_comma_((\"Broken Json :\"),string))); end;\r\n(function()\r\n\tlocal _s8_value=((js):_at(\"arguments\"))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:newArray(args);\r\n(function()\r\n\tlocal _s8_value=((smalltalk:object_comma_(((\"selector\"):_minus_gt(smalltalk:toString_(((js):_at(\"selector\"))))),(\"arguments\"):_minus_gt(args))):json())\r\n\tjson=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((smalltalk.NativeHandle):support()):_at(json));\r\nend")

smalltalk:bind(smalltalk.SystemServer,"luaSimpleStringify:",0
,function(self,literal)
return ((smalltalk.Json):stringify_(((smalltalk.NativeHandle):support()):_at(literal)));
end
,"luaSimple","luaSimpleStringify: literal\r\n\t\" Private - Return the result of JSON string. \"\r\n\r\n\t^Json stringify: NativeHandle support @ literal","function(self,literal)\r\nreturn ((smalltalk.Json):stringify_(((smalltalk.NativeHandle):support()):_at(literal)));\r\nend")
