
-- fileIn("s8/start/Builders.st")
smalltalk:addClass("APIBuilder",smalltalk.Object,smalltalk:newArray({"parents","token","bound"}),"Builders")

smalltalk.APIBuilder["$klass"]["$iVarNames"]=smalltalk:newArray({"default","saveBuilders"})

smalltalk:bind(smalltalk.APIBuilder["$klass"],"default",0
,function(self)
if (smalltalk:isNil_((self["@default"])))==true then (function()
	local _s8_value=((self):new())
	self["@default"]=_s8_value
	return _s8_value
end)(); end;
return (self["@default"]);
end
,"accessing","default\r\n\t\" Return the default instance of the receiver. \"\r\n\r\n\tdefault isNil ifTrue: [ default := self new ].\r\n\t^default","function(self)\r\nif (smalltalk:isNil_((self[\"@default\"])))==true then (function()\r\n\tlocal _s8_value=((self):new())\r\n\tself[\"@default\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@default\"]);\r\nend")

smalltalk:bind(smalltalk.APIBuilder["$klass"],"saveBuilders",0
,function(self)
return (((self["@saveBuilders"])==true));
end
,"accessing","saveBuilders\r\n\t\" Return true if the receiver is set to save builders in snapshot. \"\r\n\r\n\t^saveBuilders == true","function(self)\r\nreturn (((self[\"@saveBuilders\"])==true));\r\nend")

smalltalk:bind(smalltalk.APIBuilder["$klass"],"saveBuilders:",0
,function(self,aBoolean)
(function()
	local _s8_value=(aBoolean)
	self["@saveBuilders"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","saveBuilders: aBoolean\r\n\t\" Set to true if the receiver save builders in snapshot. \"\r\n\r\n\tsaveBuilders := aBoolean","function(self,aBoolean)\r\n(function()\r\n\tlocal _s8_value=(aBoolean)\r\n\tself[\"@saveBuilders\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.APIBuilder["$klass"],"build:doing:",0
,function(self,token,aBlock)
local builder=nil
local result=nil
local success=nil
(function()
	local _s8_value=((self):default())
	builder=_s8_value
	return _s8_value
end)();
(builder):open_(token);
(function()
	local _s8_value=(false)
	success=_s8_value
	return _s8_value
end)();
((function()
(function()
	local _s8_value=((aBlock):value())
	result=_s8_value
	return _s8_value
end)();return ((function()
	local _s8_value=(true)
	success=_s8_value
	return _s8_value
end)())
end)):ensure_((function()
return ((builder):close_success_(token,success))
end));
return (result);
end
,"building","build: token doing: aBlock\r\n\t\" Process a (build...: spec) definition marking methods generated while evaluating aBlock.\r\n\tReturn the result of evaluating aBlock. \"\r\n\r\n\t| builder result success |\r\n\tbuilder := self default.\r\n\tbuilder open: token.\r\n\tsuccess := false.\r\n\t[\tresult := aBlock value.\r\n\t\tsuccess := true.\r\n\t] ensure: [ builder close: token success: success ].\r\n\t^result","function(self,token,aBlock)\r\nlocal builder=nil\r\nlocal result=nil\r\nlocal success=nil\r\n(function()\r\n\tlocal _s8_value=((self):default())\r\n\tbuilder=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(builder):open_(token);\r\n(function()\r\n\tlocal _s8_value=(false)\r\n\tsuccess=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((function()\r\n(function()\r\n\tlocal _s8_value=((aBlock):value())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();return ((function()\r\n\tlocal _s8_value=(true)\r\n\tsuccess=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):ensure_((function()\r\nreturn ((builder):close_success_(token,success))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.APIBuilder["$klass"],"register:",0
,function(self,aMethod)
return (smalltalk:boolean_and_((smalltalk:notNil_((self["@default"]))),(function()
return ((self["@default"]):register_(aMethod))
end)));
end
,"building","register: aMethod\r\n\t\" Register aMethod as related to current builder. \"\r\n\r\n\t^default notNil and: [ default register: aMethod ]","function(self,aMethod)\r\nreturn (smalltalk:boolean_and_((smalltalk:notNil_((self[\"@default\"]))),(function()\r\nreturn ((self[\"@default\"]):register_(aMethod))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.APIBuilder["$klass"],"imageSaved:on:",0
,function(self,snapshot,stream)
local code=nil
if (smalltalk:boolean_and_(((self):saveBuilders()),(function()
return ((((function()
	local _s8_value=((self):codeForBuilders())
	code=_s8_value
	return _s8_value
end)())):notEmpty())
end)))==true then (
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(code))
end
)(stream); end;
return (smalltalk:superImplementor(smalltalk.APIBuilder["$klass"],"imageSaved_on_")(self,snapshot,stream));
end
,"snapshot","imageSaved: snapshot on: stream\r\n\t\" Private - A system snapshot has been taken, the receiver can restore state. \"\r\n\r\n\t| code |\r\n\t(self saveBuilders and: [\r\n\t\t(code := self codeForBuilders) notEmpty ])\r\n\t\tifTrue: [ stream cr;nextPutAll: code ].\r\n\t^super imageSaved: snapshot on: stream","function(self,snapshot,stream)\r\nlocal code=nil\r\nif (smalltalk:boolean_and_(((self):saveBuilders()),(function()\r\nreturn ((((function()\r\n\tlocal _s8_value=((self):codeForBuilders())\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)())):notEmpty())\r\nend)))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(code))\r\nend\r\n)(stream); end;\r\nreturn (smalltalk:superImplementor(smalltalk.APIBuilder[\"$klass\"],\"imageSaved_on_\")(self,snapshot,stream));\r\nend")

smalltalk:bind(smalltalk.APIBuilder["$klass"],"codeForBuilders",0
,function(self)
return ((self):codeFor_((smalltalk.Smalltalk):classes()));
end
,"code","codeForBuilders\r\n\t\" Return the (native) code to export the builders of the system. \"\r\n\r\n\t^self codeFor: Smalltalk classes","function(self)\r\nreturn ((self):codeFor_((smalltalk.Smalltalk):classes()));\r\nend")

smalltalk:bind(smalltalk.APIBuilder["$klass"],"codeFor:",0
,function(self,classes)
local builders=nil
(function()
	local _s8_value=((self):buildersFor_(classes))
	builders=_s8_value
	return _s8_value
end)();
if ((builders):isEmpty())==true then return (""); end;
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),(self):name())),".builders_(\r\n")),((smalltalk.Exporter):new()):exportObject_(builders))),"\r\n);"));
end
,"code","codeFor: classes\r\n\t\" Return the (native) code to export the builders defined by a collection of classes. \"\r\n\r\n\t| builders |\r\n\tbuilders := self buildersFor: classes.\r\n\tbuilders isEmpty ifTrue: [ ^'' ].\r\n\t^'smalltalk.', self name ,'.builders_(\r\n'\t,(Exporter new exportObject: builders) ,'\r\n);'","function(self,classes)\r\nlocal builders=nil\r\n(function()\r\n\tlocal _s8_value=((self):buildersFor_(classes))\r\n\tbuilders=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((builders):isEmpty())==true then return (\"\"); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),(self):name())),\".builders_(\\r\\n\")),((smalltalk.Exporter):new()):exportObject_(builders))),\"\\r\\n);\"));\r\nend")

smalltalk:bind(smalltalk.APIBuilder["$klass"],"buildersFor:",0
,function(self,classes)
return (((classes):collect_((function(cls)
return ((smalltalk.Array):with_with_with_((cls):name(),(self):buildersIn_((cls)["$klass"]),(self):buildersIn_(cls)))
end))):reject_((function(tuple)
return (smalltalk:boolean_and_((((tuple):second()):isEmpty()),(function()
return (((tuple):third()):isEmpty())
end)))
end)));
end
,"private","buildersFor: classes\r\n\t\" Private - Return the builders defined by a collection of classes.\r\n\t#( className #(--classbuilders--) #(--instanceBuilders---))\r\n\t\"\r\n\r\n\t^(classes collect: [:cls|\r\n\t\tArray\r\n\t\t\twith: cls name\r\n\t\t\twith: (self buildersIn: cls class)\r\n\t\t\twith: (self buildersIn: cls)\r\n\t]) reject: [:tuple|\r\n\t\ttuple second isEmpty and: [tuple third isEmpty]\r\n\t]","function(self,classes)\r\nreturn (((classes):collect_((function(cls)\r\nreturn ((smalltalk.Array):with_with_with_((cls):name(),(self):buildersIn_((cls)[\"$klass\"]),(self):buildersIn_(cls)))\r\nend))):reject_((function(tuple)\r\nreturn (smalltalk:boolean_and_((((tuple):second()):isEmpty()),(function()\r\nreturn (((tuple):third()):isEmpty())\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.APIBuilder["$klass"],"builders",0
,function(self)
return ((self):buildersFor_((smalltalk.Smalltalk):classes()));
end
,"private","builders\r\n\t\" Private - Return the builders defined in this system. \"\r\n\r\n\t^self buildersFor: Smalltalk classes","function(self)\r\nreturn ((self):buildersFor_((smalltalk.Smalltalk):classes()));\r\nend")

smalltalk:bind(smalltalk.APIBuilder["$klass"],"buildersIn:",0
,function(self,aClass)
local map=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	map=_s8_value
	return _s8_value
end)();
(aClass):methodsDo_((function(mth)
local assoc=nil
(function()
	local _s8_value=((mth):builder())
	assoc=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((assoc))),(function()
return ((((map):detect_ifNone_((function(tuple)
return (smalltalk:isObject_equalTo_(((tuple):first()),assoc))
end),(function()
return ((map):add_((smalltalk.Array):with_with_(assoc,(smalltalk.Array):new())))
end))):second()):add_((mth):selector()))
end),nil))
end));
return ((map):collect_((function(tuple)
return ((smalltalk.Array):with_with_with_(((tuple):first()):key(),((tuple):first()):value(),(tuple):last()))
end)));
end
,"private","buildersIn: aClass\r\n\t\" Private - Return the builders used in aClass.\r\n\t#( builderType builderSpec #( selectors ) )\r\n\t\"\r\n\r\n\t| map |\r\n\tmap := Array new.\r\n\taClass methodsDo: [:mth| | assoc |\r\n\t\tassoc := mth builder.\r\n\t\tassoc notNil ifTrue: [\r\n\t\t\t(map\tdetect: [:tuple| tuple first = assoc ]\r\n\t\t\t\tifNone: [ map add: (Array with: assoc with: Array new) ])\r\n\t\t\t\tsecond add: mth selector\r\n\t\t]\r\n\t].\r\n\t^map collect: [:tuple| Array\r\n\t\twith: tuple first key\r\n\t\twith: tuple first value\r\n\t\twith: tuple last\r\n\t]","function(self,aClass)\r\nlocal map=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tmap=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aClass):methodsDo_((function(mth)\r\nlocal assoc=nil\r\n(function()\r\n\tlocal _s8_value=((mth):builder())\r\n\tassoc=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((assoc))),(function()\r\nreturn ((((map):detect_ifNone_((function(tuple)\r\nreturn (smalltalk:isObject_equalTo_(((tuple):first()),assoc))\r\nend),(function()\r\nreturn ((map):add_((smalltalk.Array):with_with_(assoc,(smalltalk.Array):new())))\r\nend))):second()):add_((mth):selector()))\r\nend),nil))\r\nend));\r\nreturn ((map):collect_((function(tuple)\r\nreturn ((smalltalk.Array):with_with_with_(((tuple):first()):key(),((tuple):first()):value(),(tuple):last()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.APIBuilder["$klass"],"builders:",0
,function(self,spec)
(spec):do_((function(builder)
local cls=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):at_ifAbsent_((builder):first(),(function()
return (nil)
end)))
	cls=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((cls))),(function()
(self):setBuilders_in_((builder):second(),(cls)["$klass"]);return ((self):setBuilders_in_((builder):third(),cls))
end),nil))
end));
return (self);
end
,"private","builders: spec\r\n\t\" Private - Set the builders on this system according to bindings defined in spec.\r\n\tNote that missing bindings will be ignored and no check is done to ensure the bindings are in sync with target.\r\n\t\"\r\n\r\n\tspec do: [:builder| | cls |\r\n\t\tcls := Smalltalk at: builder first ifAbsent: [].\r\n\t\tcls notNil ifTrue: [\r\n\t\t\tself setBuilders: builder second in: cls class.\r\n\t\t\tself setBuilders: builder third in: cls.\r\n\t\t].\r\n\t]","function(self,spec)\r\n(spec):do_((function(builder)\r\nlocal cls=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_ifAbsent_((builder):first(),(function()\r\nreturn (nil)\r\nend)))\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((cls))),(function()\r\n(self):setBuilders_in_((builder):second(),(cls)[\"$klass\"]);return ((self):setBuilders_in_((builder):third(),cls))\r\nend),nil))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.APIBuilder["$klass"],"setBuilders:in:",0
,function(self,array,aClass)
local builder=nil
(array):do_((function(map)
(function()
	local _s8_value=((smalltalk.Association):key_value_((map):first(),(map):second()))
	builder=_s8_value
	return _s8_value
end)();return (((map):last()):do_((function(selector)
local mth=nil
(function()
	local _s8_value=((aClass):compiledMethodAt_(selector))
	mth=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((mth))),(function()
return ((mth):builder_(builder))
end),nil))
end)))
end));
return (self);
end
,"private","setBuilders: array in: aClass\r\n\t\" Private - Set the builders in array on aClass. \"\r\n\r\n\t| builder |\r\n\tarray do: [:map|\r\n\t\tbuilder := Association key: map first value: map second.\r\n\t\tmap last do: [:selector| | mth |\r\n\t\t\tmth := aClass compiledMethodAt: selector.\r\n\t\t\tmth notNil ifTrue: [ mth builder: builder ].\r\n\t\t]\r\n\t]","function(self,array,aClass)\r\nlocal builder=nil\r\n(array):do_((function(map)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Association):key_value_((map):first(),(map):second()))\r\n\tbuilder=_s8_value\r\n\treturn _s8_value\r\nend)();return (((map):last()):do_((function(selector)\r\nlocal mth=nil\r\n(function()\r\n\tlocal _s8_value=((aClass):compiledMethodAt_(selector))\r\n\tmth=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((mth))),(function()\r\nreturn ((mth):builder_(builder))\r\nend),nil))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.APIBuilder,"register:",0
,function(self,aMethod)
if (smalltalk:isNil_((self["@token"])))==true then return (false); end;
if (smalltalk:isNil_((self["@bound"])))==true then (function()
	local _s8_value=((smalltalk.Array):new())
	self["@bound"]=_s8_value
	return _s8_value
end)(); end;
(self["@bound"]):add_(aMethod);
return (true);
end
,"private","register: aMethod\r\n\t\" Private - Register aMethod as related to the receiver. \"\r\n\r\n\ttoken isNil ifTrue: [ ^false ].\r\n\tbound isNil ifTrue: [ bound := Array new ].\r\n\tbound add: aMethod.\r\n\t^true","function(self,aMethod)\r\nif (smalltalk:isNil_((self[\"@token\"])))==true then return (false); end;\r\nif (smalltalk:isNil_((self[\"@bound\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@bound\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(self[\"@bound\"]):add_(aMethod);\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.APIBuilder,"open:",0
,function(self,spec)
if (smalltalk:isNil_((self["@parents"])))==true then (function()
	local _s8_value=((smalltalk.Array):new())
	self["@parents"]=_s8_value
	return _s8_value
end)(); end;
if (smalltalk:notNil_((self["@token"])))==true then (self["@parents"]):addLast_(self["@token"]); end;
(function()
	local _s8_value=(spec)
	self["@token"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"private","open: spec\r\n\t\" Private - The spec will be generated.\r\n\tPrepare the receiver to track generated methods while building spec.\r\n\t\"\r\n\r\n\tparents isNil ifTrue: [ parents := Array new ].\r\n\ttoken notNil ifTrue: [ parents addLast: token ].\r\n\ttoken := spec.","function(self,spec)\r\nif (smalltalk:isNil_((self[\"@parents\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@parents\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif (smalltalk:notNil_((self[\"@token\"])))==true then (self[\"@parents\"]):addLast_(self[\"@token\"]); end;\r\n(function()\r\n\tlocal _s8_value=(spec)\r\n\tself[\"@token\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.APIBuilder,"close:success:",0
,function(self,spec,success)
if not ((smalltalk:isObject_equalTo_((self["@token"]),spec)))==true then return ((self):error_("Builders out of sync.")); end;
if (smalltalk:boolean_and_((smalltalk:notNil_((self["@parents"]))),(function()
return ((self["@parents"]):notEmpty())
end)))==true then (function()
	local _s8_value=((self["@parents"]):removeLast())
	self["@token"]=_s8_value
	return _s8_value
end)();
return (success); end;
if (smalltalk:notNil_((self["@bound"])))==true then (self["@bound"]):do_((function(each)
return ((self):mark_(each))
end));
(function()
	local _s8_value=((function()
	local _s8_value=((function()
	local _s8_value=(nil)
	self["@bound"]=_s8_value
	return _s8_value
end)())
	self["@parents"]=_s8_value
	return _s8_value
end)())
	self["@token"]=_s8_value
	return _s8_value
end)(); end;
return (success);
end
,"private","close: spec success: success\r\n\t\" Private - The spec has been implemented, backtrack to parent or mark collected methods. \"\r\n\r\n\ttoken = spec ifFalse: [ ^self error: 'Builders out of sync.' ].\r\n\t(parents notNil and: [ parents notEmpty ]) ifTrue: [\r\n\t\ttoken := parents removeLast.\r\n\t\t^success\r\n\t].\r\n\tbound notNil ifTrue: [\r\n\t\tbound do: [:each| self mark: each ].\r\n\t\ttoken := parents := bound := nil.\r\n\t].\r\n\t^success","function(self,spec,success)\r\nif not ((smalltalk:isObject_equalTo_((self[\"@token\"]),spec)))==true then return ((self):error_(\"Builders out of sync.\")); end;\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((self[\"@parents\"]))),(function()\r\nreturn ((self[\"@parents\"]):notEmpty())\r\nend)))==true then (function()\r\n\tlocal _s8_value=((self[\"@parents\"]):removeLast())\r\n\tself[\"@token\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (success); end;\r\nif (smalltalk:notNil_((self[\"@bound\"])))==true then (self[\"@bound\"]):do_((function(each)\r\nreturn ((self):mark_(each))\r\nend));\r\n(function()\r\n\tlocal _s8_value=((function()\r\n\tlocal _s8_value=((function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@bound\"]=_s8_value\r\n\treturn _s8_value\r\nend)())\r\n\tself[\"@parents\"]=_s8_value\r\n\treturn _s8_value\r\nend)())\r\n\tself[\"@token\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (success);\r\nend")

smalltalk:bind(smalltalk.APIBuilder,"mark:",0
,function(self,aMethod)
(aMethod):builder_(self["@token"]);
return (self);
end
,"private","mark: aMethod\r\n\t\" Private - Mark aMethod as dependent of current token. \"\r\n\r\n\taMethod builder: token","function(self,aMethod)\r\n(aMethod):builder_(self[\"@token\"]);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.APIBuilder,"fileOut:selectors:of:on:",0
,function(self,exporter,selectors,aClass,stream)
local specs=nil
(function()
	local _s8_value=((smalltalk.Set):new())
	specs=_s8_value
	return _s8_value
end)();
((selectors):copy()):do_((function(selector)
local assoc=nil
(function()
	local _s8_value=(((aClass):compiledMethodAt_(selector)):builder())
	assoc=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((assoc))),(function()
(specs):add_(assoc);return ((selectors):remove_(selector))
end),nil))
end));
(((specs):asArray()):sorted_((function(a,b)
return ((((a):key()) <= (b):key()))
end))):do_((function(assoc)
(stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(((aClass):name())," build")),(assoc):key()));if (((assoc):value()):notEmpty())==true then (stream):nextPut_(":");
(self):fileOutSpec_on_((assoc):value(),stream); end;return ((
function(_s8_rec)
	(_s8_rec):nextChunkPut_(" ");
	return ((_s8_rec):cr())
end
)(stream))
end));
return (self);
end
,"fileOut","fileOut: exporter selectors: selectors of: aClass on: stream\r\n\t\" Fileout clustered sources for selectors onto stream.\r\n\tNote: Remove the clustered message selectors from selectors collection while fileOut.\r\n\t\"\r\n\r\n\t| specs |\r\n\tspecs := Set new.\r\n\tselectors copy do: [:selector| | assoc |\r\n\t\tassoc := (aClass compiledMethodAt: selector) builder.\r\n\t\tassoc notNil ifTrue: [\r\n\t\t\tspecs add: assoc.\r\n\t\t\tselectors remove: selector.\r\n\t\t]\r\n\t].\r\n\t(specs asArray sorted: [:a :b| a key <= b key ]) do: [:assoc|\r\n\t\tstream nextPutAll: aClass name ,' build' ,assoc key.\r\n\t\tassoc value notEmpty ifTrue: [\r\n\t\t\tstream nextPut: $:.\r\n\t\t\tself fileOutSpec: assoc value on: stream\r\n\t\t].\r\n\t\tstream nextChunkPut: $ ;cr\r\n\t].","function(self,exporter,selectors,aClass,stream)\r\nlocal specs=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Set):new())\r\n\tspecs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((selectors):copy()):do_((function(selector)\r\nlocal assoc=nil\r\n(function()\r\n\tlocal _s8_value=(((aClass):compiledMethodAt_(selector)):builder())\r\n\tassoc=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((assoc))),(function()\r\n(specs):add_(assoc);return ((selectors):remove_(selector))\r\nend),nil))\r\nend));\r\n(((specs):asArray()):sorted_((function(a,b)\r\nreturn ((((a):key()) <= (b):key()))\r\nend))):do_((function(assoc)\r\n(stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(((aClass):name()),\" build\")),(assoc):key()));if (((assoc):value()):notEmpty())==true then (stream):nextPut_(\":\");\r\n(self):fileOutSpec_on_((assoc):value(),stream); end;return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextChunkPut_(\" \");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.APIBuilder,"fileOutSpec:on:",0
,function(self,array,stream)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(" #(");
	return ((_s8_rec):cr())
end
)(stream);
(array):do_((function(each)
return ((
function(_s8_rec)
	(_s8_rec):tab();
	(_s8_rec):nextPutAll_((each):asLiteral());
	return ((_s8_rec):cr())
end
)(stream))
end));
(stream):nextPut_(")");
return (self);
end
,"fileOut","fileOutSpec: array on: stream\r\n\t\" Private - Fileout API spec in array onto stream. \"\r\n\r\n\tstream nextPutAll: ' #(';cr.\r\n\tarray do: [:each| stream tab; nextPutAll: each asLiteral;cr ].\r\n\tstream nextPut: $).","function(self,array,stream)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\" #(\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream);\r\n(array):do_((function(each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):tab();\r\n\t(_s8_rec):nextPutAll_((each):asLiteral());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream))\r\nend));\r\n(stream):nextPut_(\")\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"builder:",0
,function(self,cookie)
smalltalk:basic_at_put_((self),"$builder",cookie);
return (self);
end
,"Builders-accessing","builder: cookie\r\n\t\" Private - Set the builder cookie of the receiver. \"\r\n\r\n\tself basicAt: '$builder' put: cookie","function(self,cookie)\r\nsmalltalk:basic_at_put_((self),\"$builder\",cookie);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"builder",0
,function(self)
return ((self)["$builder"]);
end
,"Builders-accessing","builder\r\n\t\" Private - Return the builder cookie of the receiver (or nil). \"\r\n\r\n\t^self basicAt: '$builder'","function(self)\r\nreturn ((self)[\"$builder\"]);\r\nend")

smalltalk:bind(smalltalk.Behavior,"aboutToAdd:",0
,function(self,aMethod)
(smalltalk.APIBuilder):register_(aMethod);
return (self);
end
,"private","aboutToAdd: aMethod\r\n\t\" Private - Prepare aMethod to be added onto the receiver. \"\r\n\r\n\tAPIBuilder register: aMethod. ","function(self,aMethod)\r\n(smalltalk.APIBuilder):register_(aMethod);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"removeSources",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):source_("");
	(_s8_rec):category_("s8");
	return ((_s8_rec):builder_(nil))
end
)(self);
return (self);
end
,"Builders-tools","removeSources\r\n\t\" Remove all development sources of the receiver. \"\r\n\r\n\tself source: ''; category: #s8; builder: nil","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):source_(\"\");\r\n\t(_s8_rec):category_(\"s8\");\r\n\treturn ((_s8_rec):builder_(nil))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"implement:comment:as:category:",0
,function(self,messageHeader,aComment,sourceCode,aCategory)
local code=nil
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("! "),(self):name())),smalltalk:if_true_false_((smalltalk:isNil_((aCategory))),(function()
return (" methods")
end),(function()
return (smalltalk:object_comma_((" methodsFor: "),(aCategory):asLiteral()))
end))))," !\r\n")),messageHeader)),smalltalk:if_true_false_((smalltalk:isNil_((aComment))),(function()
return ("")
end),(function()
return (smalltalk:object_comma_((smalltalk:object_comma_(("\r\n\t\" "),aComment))," \""))
end)))),"\r\n\r\n\t")),sourceCode)),"! !\r\n\r\n"))
	code=_s8_value
	return _s8_value
end)();
return ((
function(_s8_rec)
	(_s8_rec):fileIn();
	return ((_s8_rec):yourself())
end
)(code));
end
,"Builders-implementing","implement: messageHeader\r\n\tcomment: aComment\r\n\tas: sourceCode\r\n\tcategory: aCategory\r\n\t\" Private - Implement a method in the receiver.\r\n\tNote: sourceCode must be the source code in chunk format.\r\n\t\"\r\n\r\n\t| code |\r\n\tcode := '! ',self name,\r\n\t\t(aCategory isNil\r\n\t\t\tifTrue: [ ' methods' ]\r\n\t\t\tifFalse: [ ' methodsFor: ', aCategory asLiteral ])\r\n,' !\r\n',messageHeader, (aComment isNil ifTrue: [ '' ] ifFalse: ['\r\n\t\" ', aComment, ' \"']),'\r\n\r\n\t',sourceCode ,'! !\r\n\r\n'.\t^code fileIn; yourself","function(self,messageHeader,aComment,sourceCode,aCategory)\r\nlocal code=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"! \"),(self):name())),smalltalk:if_true_false_((smalltalk:isNil_((aCategory))),(function()\r\nreturn (\" methods\")\r\nend),(function()\r\nreturn (smalltalk:object_comma_((\" methodsFor: \"),(aCategory):asLiteral()))\r\nend)))),\" !\\r\\n\")),messageHeader)),smalltalk:if_true_false_((smalltalk:isNil_((aComment))),(function()\r\nreturn (\"\")\r\nend),(function()\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"\\r\\n\\t\\\" \"),aComment)),\" \\\"\"))\r\nend)))),\"\\r\\n\\r\\n\\t\")),sourceCode)),\"! !\\r\\n\\r\\n\"))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):fileIn();\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(code));\r\nend")

smalltalk:bind(smalltalk.Behavior,"implement:comment:as:",0
,function(self,messageHeader,aComment,sourceCode)
return ((self):implement_comment_as_category_(messageHeader,aComment,sourceCode,nil));
end
,"Builders-implementing","implement: messageHeader comment: aComment as: sourceCode\r\n\t\" Private - Implement a method in the receiver. \"\r\n\r\n\t^self\r\n\t\timplement: messageHeader\r\n\t\tcomment: aComment\r\n\t\tas: sourceCode\r\n\t\tcategory: nil","function(self,messageHeader,aComment,sourceCode)\r\nreturn ((self):implement_comment_as_category_(messageHeader,aComment,sourceCode,nil));\r\nend")

smalltalk:bind(smalltalk.Behavior,"implement:as:",0
,function(self,messageHeader,sourceCode)
return ((self):implement_comment_as_category_(messageHeader,nil,sourceCode,nil));
end
,"Builders-implementing","implement: messageHeader as: sourceCode\r\n\t\" Private - Implement a method in the receiver. \"\r\n\r\n\t^self\r\n\t\timplement: messageHeader\r\n\t\tcomment: nil\r\n\t\tas: sourceCode\r\n\t\tcategory: nil","function(self,messageHeader,sourceCode)\r\nreturn ((self):implement_comment_as_category_(messageHeader,nil,sourceCode,nil));\r\nend")

smalltalk:bind(smalltalk.Behavior,"implement:as:category:",0
,function(self,messageHeader,sourceCode,aCategory)
return ((self):implement_comment_as_category_(messageHeader,nil,sourceCode,aCategory));
end
,"Builders-implementing","implement: messageHeader as: sourceCode category: aCategory\r\n\t\" Private - Implement a method in the receiver. \"\r\n\r\n\t^self\r\n\t\timplement: messageHeader\r\n\t\tcomment: nil\r\n\t\tas: sourceCode\r\n\t\tcategory: aCategory","function(self,messageHeader,sourceCode,aCategory)\r\nreturn ((self):implement_comment_as_category_(messageHeader,nil,sourceCode,aCategory));\r\nend")

smalltalk:bind(smalltalk.Behavior,"class:implement:comment:as:category:",0
,function(self,aClass,message,aComment,sourceCode,aCategory)
if ((aClass):isString())==true then return ((self):class_implement_comment_as_category_((aClass):evaluateIn_(nil),message,aComment,sourceCode,aCategory)); end;
return ((aClass):implement_comment_as_category_(message,aComment,sourceCode,aCategory));
end
,"Builders-implementing","class: aClass implement: message\r\n\tcomment: aComment as: sourceCode\r\n\tcategory: aCategory\r\n\t\" Private - Implement a method in aClass. \"\r\n\r\n\taClass isString ifTrue: [\r\n\t\t^self\r\n\t\t\tclass: (aClass evaluateIn: nil)\r\n\t\t\timplement: message\r\n\t\t\tcomment: aComment\r\n\t\t\tas: sourceCode\r\n\t\t\tcategory: aCategory\r\n\t].\r\n\t^aClass\r\n\t\timplement: message\r\n\t\tcomment: aComment\r\n\t\tas: sourceCode\r\n\t\tcategory: aCategory","function(self,aClass,message,aComment,sourceCode,aCategory)\r\nif ((aClass):isString())==true then return ((self):class_implement_comment_as_category_((aClass):evaluateIn_(nil),message,aComment,sourceCode,aCategory)); end;\r\nreturn ((aClass):implement_comment_as_category_(message,aComment,sourceCode,aCategory));\r\nend")

smalltalk:bind(smalltalk.Behavior,"build:doing:",0
,function(self,token,aBlock)
return ((smalltalk.APIBuilder):build_doing_(token,aBlock));
end
,"Builders-private","build: token doing: aBlock\r\n\t\" Process a (build...: spec) definition marking methods generated while evaluating aBlock.\r\n\tReturn the result of evaluating aBlock. \"\r\n\r\n\t^APIBuilder build: token doing: aBlock","function(self,token,aBlock)\r\nreturn ((smalltalk.APIBuilder):build_doing_(token,aBlock));\r\nend")

smalltalk:bind(smalltalk.Behavior,"buildAPI:",0
,function(self,specs)
(specs):do_((function(spec)
return (smalltalk:if_true_false_(((spec):isString()),(function()
return ((spec):evaluateIn_(self))
end),(function()
return ((self):perform_withArguments_((spec):first(),(spec):copyFrom_to_(2,(spec):size())))
end)))
end));
return (self);
end
,"Builders-obsolete","buildAPI: specs\r\n\t\" Generate code to implement API protocoll defined by specs.\r\n\tWARNING: OBSOLETE - this builder generate changes that will not be filedOut to builder code.\r\n\tspecs must be an array of :\r\n\t\t- string : it will be considered as an evaluable expression to be executed in the context of the receiver.\r\n\t\t- anArray : of #( selector arg1 arg2 arg3 arg4... ) to be performed for code generation/setup of the receiver\r\n\t\t\twhere selector is frequently a build...: selector.\r\n\t\"\r\n\r\n\tspecs do: [:spec|\r\n\t\tspec isString\r\n\t\tifTrue: [ spec evaluateIn: self ]\r\n\t\tifFalse: [\r\n\t\t\tself\tperform: spec first\r\n\t\t\t\twithArguments: (spec copyFrom: 2 to: spec size)\r\n\t\t]\r\n\t]","function(self,specs)\r\n(specs):do_((function(spec)\r\nreturn (smalltalk:if_true_false_(((spec):isString()),(function()\r\nreturn ((spec):evaluateIn_(self))\r\nend),(function()\r\nreturn ((self):perform_withArguments_((spec):first(),(spec):copyFrom_to_(2,(spec):size())))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"stMessageHeader:",0
,function(self,msgHeader)
return (msgHeader);
end
,"Builders-private","stMessageHeader: msgHeader\r\n\t\" Private - Return a message header string with nice smalltalk looking.\r\n\tDefault implementation leave the message header as is.\r\n\tThis method can be refined by subclasses to transform message pattern for better code generation.\r\n\t\"\r\n\r\n\t^msgHeader","function(self,msgHeader)\r\nreturn (msgHeader);\r\nend")

smalltalk:bind(smalltalk.Behavior,"buildAccessor:",0
,function(self,accessor)
return ((self):build_doing_(("Accessor"):_minus_gt(accessor),(function()
return (smalltalk:if_true_false_((smalltalk:boolean_or_(((accessor):isString()),(function()
return (smalltalk:boolean_and_(((accessor):isArray()),(function()
return (smalltalk:boolean_and_(((((accessor):size()) > 1)),(function()
return (smalltalk:isObject_equalTo_(((accessor):second()),"initialize"))
end)))
end)))
end))),(function()
return (smalltalk:object_comma_(((self):buildGetter_(accessor)),(self):buildSetter_(accessor)))
end),(function()
return ((accessor):compose_((function(tuple)
return ((self):implement_comment_as_category_((tuple):first(),(tuple):at_(2),(tuple):at_(3),"accessing"))
end)))
end)))
end)));
end
,"Builders-api","buildAccessor: accessor\r\n\t\" Build (instance) method to access native property. \"\r\n\r\n\t^self build: #Accessor -> accessor doing: [\r\n\t\t(accessor isString or: [\r\n\t\t\taccessor isArray and: [\r\n\t\t\taccessor size > 1 and: [\r\n\t\t\taccessor second = #initialize ] ]\r\n\t\t]) ifTrue: [\r\n\t\t\t(self buildGetter: accessor)\r\n\t\t\t,(self buildSetter: accessor)\r\n\t\t] ifFalse: [\r\n\t\t\taccessor compose: [:tuple|\r\n\t\t\t\tself implement: tuple first comment: (tuple at: 2)\r\n\t\t\t\t      as: (tuple at: 3) category: #accessing\r\n\t\t\t]\r\n\t\t]\r\n\t]","function(self,accessor)\r\nreturn ((self):build_doing_((\"Accessor\"):_minus_gt(accessor),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_or_(((accessor):isString()),(function()\r\nreturn (smalltalk:boolean_and_(((accessor):isArray()),(function()\r\nreturn (smalltalk:boolean_and_(((((accessor):size()) > 1)),(function()\r\nreturn (smalltalk:isObject_equalTo_(((accessor):second()),\"initialize\"))\r\nend)))\r\nend)))\r\nend))),(function()\r\nreturn (smalltalk:object_comma_(((self):buildGetter_(accessor)),(self):buildSetter_(accessor)))\r\nend),(function()\r\nreturn ((accessor):compose_((function(tuple)\r\nreturn ((self):implement_comment_as_category_((tuple):first(),(tuple):at_(2),(tuple):at_(3),\"accessing\"))\r\nend)))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Behavior,"buildGetterCode:",0
,function(self,aSelector)
return (smalltalk:object_comma_(("^"),aSelector));
end
,"Builders-private","buildGetterCode: aSelector\r\n\t\" Private - Return source code to get aSelector. \"\r\n\r\n\t^'^' ,aSelector","function(self,aSelector)\r\nreturn (smalltalk:object_comma_((\"^\"),aSelector));\r\nend")

smalltalk:bind(smalltalk.Behavior,"buildGetter:",0
,function(self,spec)
return ((self):build_doing_(("Getter"):_minus_gt(spec),(function()
return (smalltalk:if_true_false_((smalltalk:boolean_and_(((spec):isArray()),(function()
return (smalltalk:boolean_and_(((((spec):size()) > 1)),(function()
return (smalltalk:isObject_equalTo_(((spec):second()),"initialize"))
end)))
end))),(function()
return ((self):buildGetter_initialize_((spec):first(),(spec):last()))
end),(function()
return ((self):implement_comment_as_category_((self):stMessageHeader_(spec),smalltalk:object_comma_((smalltalk:object_comma_(("Return the "),spec))," of the receiver."),(self):buildGetterCode_(spec),"accessing"))
end)))
end)));
end
,"Builders-api","buildGetter: spec\r\n\t\" Build method for getter. \"\r\n\r\n\t^self build: #Getter -> spec doing: [\r\n\t\t(spec isArray and: [ spec size > 1 and: [\r\n\t\t spec second = #initialize ]]) ifTrue: [\r\n\t\t\tself buildGetter: spec first initialize: spec last\r\n\t\t] ifFalse: [\r\n\t\t\tself\r\n\t\t\t\timplement: (self stMessageHeader: spec)\r\n\t\t\t\tcomment: 'Return the ' ,spec ,' of the receiver.'\r\n\t\t\t\tas: (self buildGetterCode: spec) category: #accessing\r\n\t\t]\r\n\t]","function(self,spec)\r\nreturn ((self):build_doing_((\"Getter\"):_minus_gt(spec),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_(((spec):isArray()),(function()\r\nreturn (smalltalk:boolean_and_(((((spec):size()) > 1)),(function()\r\nreturn (smalltalk:isObject_equalTo_(((spec):second()),\"initialize\"))\r\nend)))\r\nend))),(function()\r\nreturn ((self):buildGetter_initialize_((spec):first(),(spec):last()))\r\nend),(function()\r\nreturn ((self):implement_comment_as_category_((self):stMessageHeader_(spec),smalltalk:object_comma_((smalltalk:object_comma_((\"Return the \"),spec)),\" of the receiver.\"),(self):buildGetterCode_(spec),\"accessing\"))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Behavior,"buildInitialize:with:",0
,function(self,aSelector,initializer)
return ((self):implement_comment_as_category_(smalltalk:object_comma_(("initialize"),(aSelector):asSmalltalkName_(true)),smalltalk:object_comma_((smalltalk:object_comma_(("Private - Initialize the "),aSelector))," of the receiver."),initializer,"initialize"));
end
,"Builders-private","buildInitialize: aSelector with: initializer\r\n\t\" Private - Build method to initialize instance variable aSelector. \"\r\n\r\n\t^self\r\n\t\timplement: #initialize ,(aSelector asSmalltalkName: true)\r\n\t\tcomment: 'Private - Initialize the ' ,aSelector ,' of the receiver.'\r\n\t\tas: initializer\r\n\t\tcategory: #initialize","function(self,aSelector,initializer)\r\nreturn ((self):implement_comment_as_category_(smalltalk:object_comma_((\"initialize\"),(aSelector):asSmalltalkName_(true)),smalltalk:object_comma_((smalltalk:object_comma_((\"Private - Initialize the \"),aSelector)),\" of the receiver.\"),initializer,\"initialize\"));\r\nend")

smalltalk:bind(smalltalk.Behavior,"buildGetter:initialize:",0
,function(self,aSelector,initializer)
local code=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((initializer),"initialize")),(function()
return ("^self implementedBySubclass: #initialize")
end),(function()
return (smalltalk:if_true_false_(((initializer):notEmpty()),(function()
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((initializer):first()),".")),(function()
return ((initializer):copyFrom_to_(2,(initializer):size()))
end),(function()
return (smalltalk:object_comma_((smalltalk:object_comma_((aSelector)," := ")),smalltalk:if_true_false_((smalltalk:boolean_and_((((initializer):first()):isUppercase()),(function()
return (smalltalk:isObject_equalTo_((((initializer):asArrayOfSubstrings()):size()),1))
end))),(function()
return (smalltalk:object_comma_((initializer)," new"))
end),(function()
return (initializer)
end))))
end)))
end),nil))
end)))
	code=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:if_true_false_((smalltalk:notNil_((code))),(function()
return ((self):buildInitialize_with_(aSelector,code))
end),(function()
return ("")
end))),(self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_(("Return the "),aSelector))," of the receiver."),smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((aSelector)," isNil ifTrue: [ self ")),"initialize")),(aSelector):asSmalltalkName_(true)))," ].\r\n\t^")),aSelector),"accessing")));
end
,"Builders-private","buildGetter: aSelector initialize: initializer\r\n\t\" Private - Build method to get instance aSelector w/deferred initialization mode.\r\n\tNote: #initializer can be:\r\n\t\t#initialize to generate default/deferred implementation.\r\n\t\tempty string to do NOT generate #initialize... method.\r\n\t\tsmalltalk code starting with $. to use that code as method implementation.\r\n\t\tsmalltalk expression for asignment (to be used as assignment to instance).\r\n\t\tGlobalName if code do not have blanks and start with uppercase, it will be used as class to instantiate during initialization.\r\n\t\"\r\n\r\n\t| code |\r\n\tcode := initializer = #initialize\r\n\t  ifTrue: [ '^self implementedBySubclass: #initialize' ] ifFalse: [\r\n\t\tinitializer notEmpty ifTrue: [\r\n\t\t\tinitializer first = $.\r\n\t\t\tifTrue: [ initializer copyFrom: 2 to: initializer size ] ifFalse: [\r\n\t\t\t\taSelector ,' := ' ,(\r\n\t\t\t\t\t(initializer first isUppercase and: [ initializer asArrayOfSubstrings size = 1 ])\r\n\t\t\t\t\tifTrue: [ initializer ,' new' ]\r\n\t\t\t\t\tifFalse: [ initializer ])\r\n\t\t\t]\r\n\t\t]\r\n\t  ].\r\n\t^(code notNil ifTrue: [ self buildInitialize: aSelector with: code ] ifFalse: [ '' ])\r\n\t,(self\r\n\t\timplement: (self stMessageHeader: aSelector)\r\n\t\tcomment: 'Return the ' ,aSelector ,' of the receiver.'\r\n\t\tas: aSelector,' isNil ifTrue: [ self ' , #initialize ,(aSelector asSmalltalkName: true) ,' ].\r\n\t^' ,aSelector category: #accessing)","function(self,aSelector,initializer)\r\nlocal code=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((initializer),\"initialize\")),(function()\r\nreturn (\"^self implementedBySubclass: #initialize\")\r\nend),(function()\r\nreturn (smalltalk:if_true_false_(((initializer):notEmpty()),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((initializer):first()),\".\")),(function()\r\nreturn ((initializer):copyFrom_to_(2,(initializer):size()))\r\nend),(function()\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((aSelector),\" := \")),smalltalk:if_true_false_((smalltalk:boolean_and_((((initializer):first()):isUppercase()),(function()\r\nreturn (smalltalk:isObject_equalTo_((((initializer):asArrayOfSubstrings()):size()),1))\r\nend))),(function()\r\nreturn (smalltalk:object_comma_((initializer),\" new\"))\r\nend),(function()\r\nreturn (initializer)\r\nend))))\r\nend)))\r\nend),nil))\r\nend)))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:if_true_false_((smalltalk:notNil_((code))),(function()\r\nreturn ((self):buildInitialize_with_(aSelector,code))\r\nend),(function()\r\nreturn (\"\")\r\nend))),(self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_((\"Return the \"),aSelector)),\" of the receiver.\"),smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((aSelector),\" isNil ifTrue: [ self \")),\"initialize\")),(aSelector):asSmalltalkName_(true))),\" ].\\r\\n\\t^\")),aSelector),\"accessing\")));\r\nend")

smalltalk:bind(smalltalk.Behavior,"buildSetterCode:",0
,function(self,aSelector)
return (smalltalk:object_comma_((aSelector)," := anObject"));
end
,"Builders-private","buildSetterCode: aSelector\r\n\t\" Private - Return source code to set aSelector. \"\r\n\r\n\t^aSelector ,' := anObject'","function(self,aSelector)\r\nreturn (smalltalk:object_comma_((aSelector),\" := anObject\"));\r\nend")

smalltalk:bind(smalltalk.Behavior,"buildSetter:",0
,function(self,spec)
if (smalltalk:boolean_and_(((spec):isArray()),(function()
return (smalltalk:boolean_and_(((((spec):size()) > 1)),(function()
return (smalltalk:isObject_equalTo_(((spec):second()),"initialize"))
end)))
end)))==true then return ((self):buildSetter_((spec):first())); end;
return ((self):build_doing_(("Setter"):_minus_gt(spec),(function()
return ((self):implement_comment_as_category_(smalltalk:object_comma_(((self):stMessageHeader_(spec)),": anObject"),smalltalk:object_comma_((smalltalk:object_comma_(("Set the "),spec))," of the receiver."),(self):buildSetterCode_(spec),"accessing"))
end)));
end
,"Builders-api","buildSetter: spec\r\n\t\" Build method for setter. \"\r\n\r\n\t(spec isArray and: [ spec size > 1 and: [\r\n\t spec second = #initialize ]]) ifTrue: [\r\n\t\t^self buildSetter: spec first\r\n\t].\r\n\t^self build: #Setter -> spec doing: [\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: spec) ,': anObject'\r\n\t\t\tcomment: 'Set the ' ,spec ,' of the receiver.'\r\n\t\t\tas: (self buildSetterCode: spec)\r\n\t\t\tcategory: #accessing\r\n\t]","function(self,spec)\r\nif (smalltalk:boolean_and_(((spec):isArray()),(function()\r\nreturn (smalltalk:boolean_and_(((((spec):size()) > 1)),(function()\r\nreturn (smalltalk:isObject_equalTo_(((spec):second()),\"initialize\"))\r\nend)))\r\nend)))==true then return ((self):buildSetter_((spec):first())); end;\r\nreturn ((self):build_doing_((\"Setter\"):_minus_gt(spec),(function()\r\nreturn ((self):implement_comment_as_category_(smalltalk:object_comma_(((self):stMessageHeader_(spec)),\": anObject\"),smalltalk:object_comma_((smalltalk:object_comma_((\"Set the \"),spec)),\" of the receiver.\"),(self):buildSetterCode_(spec),\"accessing\"))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Behavior,"buildGetters:",0
,function(self,specs)
if ((specs):isString())==true then return ((self):buildGetters_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("Getters"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildGetter_(each))
end)))
end)));
end
,"Builders-api","buildGetters: specs\r\n\t\" Build methods to get instances. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildGetters: specs asArrayOfSubstrings ].\r\n\t^self build: #Getters -> specs doing: [\r\n\t\tspecs compose: [:each| self buildGetter: each ]\r\n\t]","function(self,specs)\r\nif ((specs):isString())==true then return ((self):buildGetters_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"Getters\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildGetter_(each))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Behavior,"buildSetters:",0
,function(self,specs)
if ((specs):isString())==true then return ((self):buildSetters_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("Setters"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildSetter_(each))
end)))
end)));
end
,"Builders-api","buildSetters: specs\r\n\t\" Build methods to set instances. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildSetters: specs asArrayOfSubstrings ].\r\n\t^self build: #Setters -> specs doing: [\r\n\t\tspecs compose: [:each| self buildSetter: each ]\r\n\t]","function(self,specs)\r\nif ((specs):isString())==true then return ((self):buildSetters_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"Setters\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildSetter_(each))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Behavior,"buildAccessors:",0
,function(self,specs)
if ((specs):isString())==true then return ((self):buildAccessors_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("Accessors"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildAccessor_(each))
end)))
end)));
end
,"Builders-api","buildAccessors: specs\r\n\t\" Build methods to access instances. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildAccessors: specs asArrayOfSubstrings ].\r\n\t^self build: #Accessors -> specs doing: [\r\n\t\tspecs compose: [:each| self buildAccessor: each ]\r\n\t]","function(self,specs)\r\nif ((specs):isString())==true then return ((self):buildAccessors_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"Accessors\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildAccessor_(each))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Behavior,"buildAccessors",0
,function(self)
return ((self):build_doing_(("Accessors"):_minus_gt(smalltalk:newArray({})),(function()
return ((self):buildAccessors_((self):instanceVariableNames()))
end)));
end
,"Builders-api","buildAccessors\r\n\t\" Private - Build methods to access all instance variables. \"\r\n\r\n\t^self build: #Accessors -> #() doing: [\r\n\t\tself buildAccessors: self instanceVariableNames\r\n\t]","function(self)\r\nreturn ((self):build_doing_((\"Accessors\"):_minus_gt(smalltalk:newArray({})),(function()\r\nreturn ((self):buildAccessors_((self):instanceVariableNames()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Behavior,"buildPool:with:",0
,function(self,poolName,spec)
return ((self):build_doing_(("Pool"):_minus_gt(spec),(function()
return ((
function(_s8_rec)
	(_s8_rec):definePool_with_(poolName,spec);
	(_s8_rec):printDefinePool_with_(poolName,spec);
	return ((_s8_rec):yourself())
end
)((smalltalk.Smalltalk):current()))
end)));
end
,"Builders-api","buildPool: poolName with: spec\r\n\t\" Private - Build a PoolDictionary with spec (and log definition in log stream). \"\r\n\r\n\t^self build: #Pool -> spec doing: [\r\n\t\tSmalltalk current\r\n\t\t\tdefinePool: poolName with: spec;\r\n\t\t\tprintDefinePool: poolName with: spec;\r\n\t\t\tyourself\r\n\t]","function(self,poolName,spec)\r\nreturn ((self):build_doing_((\"Pool\"):_minus_gt(spec),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):definePool_with_(poolName,spec);\r\n\t(_s8_rec):printDefinePool_with_(poolName,spec);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.Smalltalk):current()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"isFile:olderThan:",0
,function(self,fileName,referenceFileName)

if (smalltalk:isNil_((((smalltalk.Smalltalk):global())["isFileOlderThan"])))==true then return (false); end;
return (isFileOlderThan(fileName,referenceFileName));
end
,"Builders-emmiting","isFile: fileName olderThan: referenceFileName\r\n\t\" Private - Return true if the file at pathName is older than file at referenceFileName. \"\r\n\r\n\t{'self'}.\r\n\t(Smalltalk global basicAt: #isFileOlderThan) isNil ifTrue: [ ^false ].\r\n\t^# #isFileOlderThan: fileName with: referenceFileName","function(self,fileName,referenceFileName)\r\n\r\nif (smalltalk:isNil_((((smalltalk.Smalltalk):global())[\"isFileOlderThan\"])))==true then return (false); end;\r\nreturn (isFileOlderThan(fileName,referenceFileName));\r\nend")

smalltalk:bind(smalltalk.Object,"emmit:startingWith:",0
,function(self,fileName,initial)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local output=nil
local nativeFileName=nil
local text=nil
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((fileName),".")),(smalltalk.String):nativeFileExtension()))
	nativeFileName=_s8_value
	return _s8_value
end)();
if ((self):isFile_olderThan_(fileName,nativeFileName))==true then (self):fileInJS_(nativeFileName);
return (fileContents(nativeFileName)); end;
(function()
	local _s8_value=((""):writeStream())
	output=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((initial)))==true then (output):nextPutAll_(initial); end;
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_(("emmit('"),fileName)),"')"));
((function()
(self):printingWith_do_((function(what)
(function()
	local _s8_value=(smalltalk:object_comma_((""),what))
	text=_s8_value
	return _s8_value
end)();return ((
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(text))
end
)(output))
end),(function()
return ((self):fileIn_(fileName))
end));(function()
	local _s8_value=((output):contents())
	text=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_(((((text):size()) > 0)),(function()
return ((text):outputToFile_(nativeFileName))
end),nil))
end)):on_do_(smalltalk.Exception,(function(ex)
local reason=nil
(function()
	local _s8_value=(smalltalk:toString_((ex)))
	reason=_s8_value
	return _s8_value
end)();(((
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(reason))
end
)(output)):contents()):outputToFile_(smalltalk:object_comma_((fileName),".error.txt"));(self):print_(reason);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (reason)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (text)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"Builders-emmiting","emmit: fileName startingWith: initial\r\n\t\" FileIn the contents of file at fileName redirecting output(emmited code) to a native file. \"\r\n\r\n\t| output nativeFileName text |\r\n\tnativeFileName := fileName ,$. ,String nativeFileExtension.\r\n\t(self isFile: fileName olderThan: nativeFileName) ifTrue: [\r\n\t\tself fileInJS: nativeFileName.\r\n\t\t^# #fileContents: nativeFileName\r\n\t].\r\n\toutput := '' writeStream.\r\n\tinitial notNil ifTrue: [ output nextPutAll: initial ].\r\n\tself note: 'emmit(''' ,fileName ,''')'.\r\n[\tself\tprintingWith: [:what|\r\n\t\t\ttext := '' ,what.\r\n\t\t\toutput cr; nextPutAll: text\r\n\t\t] do: [ self fileIn: fileName ].\r\n\ttext := output contents.\r\n\ttext size > 0 ifTrue: [ text outputToFile: nativeFileName ].\r\n]\ton: Exception do: [:ex| | reason |\r\n\treason := ex toString.\r\n\t(output cr; nextPutAll: reason) contents outputToFile: fileName ,'.error.txt'.\r\n\tself print: reason.\r\n\t^reason\r\n].\t^text","function(self,fileName,initial)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal output=nil\r\nlocal nativeFileName=nil\r\nlocal text=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((fileName),\".\")),(smalltalk.String):nativeFileExtension()))\r\n\tnativeFileName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((self):isFile_olderThan_(fileName,nativeFileName))==true then (self):fileInJS_(nativeFileName);\r\nreturn (fileContents(nativeFileName)); end;\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\toutput=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((initial)))==true then (output):nextPutAll_(initial); end;\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((\"emmit('\"),fileName)),\"')\"));\r\n((function()\r\n(self):printingWith_do_((function(what)\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((\"\"),what))\r\n\ttext=_s8_value\r\n\treturn _s8_value\r\nend)();return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(text))\r\nend\r\n)(output))\r\nend),(function()\r\nreturn ((self):fileIn_(fileName))\r\nend));(function()\r\n\tlocal _s8_value=((output):contents())\r\n\ttext=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_(((((text):size()) > 0)),(function()\r\nreturn ((text):outputToFile_(nativeFileName))\r\nend),nil))\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\nlocal reason=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:toString_((ex)))\r\n\treason=_s8_value\r\n\treturn _s8_value\r\nend)();(((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(reason))\r\nend\r\n)(output)):contents()):outputToFile_(smalltalk:object_comma_((fileName),\".error.txt\"));(self):print_(reason);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (reason)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (text)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Object,"emmit:",0
,function(self,fileName)
if not (((fileName):isString()))==true then return (((fileName):asArray()):emmit()); end;
return ((self):emmit_startingWith_(fileName,nil));
end
,"Builders-emmiting","emmit: fileName\r\n\t\" FileIn the contents of file at fileName redirecting output(emmited code) to a native file. \"\r\n\r\n\tfileName isString ifFalse: [ ^fileName asArray emmit ].\r\n\t^self emmit: fileName startingWith: nil ","function(self,fileName)\r\nif not (((fileName):isString()))==true then return (((fileName):asArray()):emmit()); end;\r\nreturn ((self):emmit_startingWith_(fileName,nil));\r\nend")

smalltalk:bind(smalltalk.Collection,"emmit",0
,function(self)
return (((self):asArray()):compose_with_((function(each)
return ((self):emmit_(each))
end),"\r\n"));
end
,"Builders-emmiting","emmit\r\n\t\" Emmit (fileIn & save generated code of) the fileNames in the receiver. \"\r\n\r\n\t^self asArray compose: [:each| self emmit: each ] with: '\r\n'","function(self)\r\nreturn (((self):asArray()):compose_with_((function(each)\r\nreturn ((self):emmit_(each))\r\nend),\"\\r\\n\"));\r\nend")

smalltalk:bind(smalltalk.Collection,"emmitSt",0
,function(self)
return (((self):collect_((function(module)
return (smalltalk:object_comma_((smalltalk:object_comma_((module),".")),(smalltalk.String):sourceFileExtension()))
end))):emmit());
end
,"Builders-emmiting","emmitSt\r\n\t\" Emmit the code of source modules (st files) in the receiver. \"\r\n\r\n\t^(self collect: [:module| module ,$. ,String sourceFileExtension ]) emmit","function(self)\r\nreturn (((self):collect_((function(module)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((module),\".\")),(smalltalk.String):sourceFileExtension()))\r\nend))):emmit());\r\nend")

smalltalk:bind(smalltalk.Array,"emmitAllIn:",0
,function(self,folder)
return (((self):collect_((function(each)
return (smalltalk:object_comma_((folder),each))
end))):emmitAll());
end
,"Builders-emmiting","emmitAllIn: folder\r\n\t\" Emmit(fileIn & save generated code of) the fileNames in the receiver.\r\n\tNote the receiver MUST include the file separator at end\r\n\t\"\r\n\r\n\t^(self collect: [:each| folder , each ]) emmitAll","function(self,folder)\r\nreturn (((self):collect_((function(each)\r\nreturn (smalltalk:object_comma_((folder),each))\r\nend))):emmitAll());\r\nend")

smalltalk:bind(smalltalk.Array,"emmitAll",0
,function(self)
if ((self):isEmpty())==true then return (self); end;
((function()
(self):emmit_((smalltalk.Array):with_((self):removeFirst()));return ((self):emmitAll())
end)):valueDeferred_(500);
return (self);
end
,"Builders-emmiting","emmitAll\r\n\t\" Deferred (consuming) emmit of fileNames in the receiver. \"\r\n\r\n\tself isEmpty ifTrue: [ ^self ].\r\n\t[\tself emmit: (Array with: self removeFirst).\r\n\t\tself emmitAll\r\n\t] valueDeferred: 500","function(self)\r\nif ((self):isEmpty())==true then return (self); end;\r\n((function()\r\n(self):emmit_((smalltalk.Array):with_((self):removeFirst()));return ((self):emmitAll())\r\nend)):valueDeferred_(500);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"emmitFiles",0
,function(self)
local folder=nil
local fileNames=nil
local stream=nil
local line=nil
(function()
	local _s8_value=(self)
	folder=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:newArray({}))
	fileNames=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((folder),"emmit.txt")):fileContents()):stream())
	stream=_s8_value
	return _s8_value
end)();
while not ((function()
return ((stream):atEnd())
end))() do (function()
	local _s8_value=((((stream):nextLine()):upTo_(";")):trimBlanks())
	line=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_(((line):notEmpty()),(function()
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((line):first()),"@")),(function()
(function()
	local _s8_value=(((line):copyFrom_to_(2,(line):size())):trimBlanks())
	folder=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_(((folder):isEmpty()),(function()
return ((function()
	local _s8_value=(self)
	folder=_s8_value
	return _s8_value
end)())
end),nil))
end),(function()
return ((fileNames):add_(smalltalk:object_comma_((folder),line)))
end)))
end),nil); end;
(fileNames):emmitAll();
return (self);
end
,"Builders-emmiting","emmitFiles\r\n\t\" Emmit all the files listed in emmit.txt \"\r\n\r\n\t| folder fileNames stream line |\r\n\tfolder := self.\r\n\tfileNames := #().\r\n\tstream := (folder ,'emmit.txt') fileContents stream.\r\n\t[ stream atEnd ] whileFalse: [\r\n\t\tline := (stream nextLine upTo: $;) trimBlanks.\r\n\t\tline notEmpty ifTrue: [\r\n\t\t\tline first = $@ ifTrue: [\r\n\t\t\t\tfolder := (line copyFrom: 2 to: line size) trimBlanks.\r\n\t\t\t\tfolder isEmpty ifTrue: [ folder := self ]\r\n\t\t\t] ifFalse: [ fileNames add: folder ,line ]\r\n\t\t]\r\n\t].\r\n\tfileNames emmitAll","function(self)\r\nlocal folder=nil\r\nlocal fileNames=nil\r\nlocal stream=nil\r\nlocal line=nil\r\n(function()\r\n\tlocal _s8_value=(self)\r\n\tfolder=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tfileNames=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((folder),\"emmit.txt\")):fileContents()):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((stream):atEnd())\r\nend))() do (function()\r\n\tlocal _s8_value=((((stream):nextLine()):upTo_(\";\")):trimBlanks())\r\n\tline=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_(((line):notEmpty()),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((line):first()),\"@\")),(function()\r\n(function()\r\n\tlocal _s8_value=(((line):copyFrom_to_(2,(line):size())):trimBlanks())\r\n\tfolder=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_(((folder):isEmpty()),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(self)\r\n\tfolder=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),nil))\r\nend),(function()\r\nreturn ((fileNames):add_(smalltalk:object_comma_((folder),line)))\r\nend)))\r\nend),nil); end;\r\n(fileNames):emmitAll();\r\nreturn (self);\r\nend")
