
-- fileIn("s8/start/Snapshot.st")
smalltalk:addClass("Snapshot",smalltalk.Object,smalltalk:newArray({}),"Snapshot")
smalltalk.Snapshot["$comment"]="\r\n\tDump a binary representation of this S8 system onto an image (String).\r\n\tThe default implementation export full/runnable images containing boot sections.\r\n\tThe subclasses can refine behavior to select/customize exports and format.\r\n\t@2011-today Alejandro Reimondo aleReimondo@smalltalking.net"

smalltalk:bind(smalltalk.String,"outputToFile:",0
,function(self,fileName)
return (fileWrite(fileName,self,"wb"));
end
,"Snapshot-io","outputToFile: fileName\r\n\t\" Save the receiver's contents onto a file at fileName. \"\r\n\r\n\t^# #fileWrite: fileName string: self mode: #wb","function(self,fileName)\r\nreturn (fileWrite(fileName,self,\"wb\"));\r\nend")

smalltalk:bind(smalltalk.String,"appendToFile:",0
,function(self,fileName)
return (fileWrite(fileName,self,"ab"));
end
,"Snapshot-io","appendToFile: fileName\r\n\t\" Append the receiver's contents onto a file at fileName. \"\r\n\r\n\t^# #fileWrite: fileName string: self mode: #ab","function(self,fileName)\r\nreturn (fileWrite(fileName,self,\"ab\"));\r\nend")

smalltalk:bind(smalltalk.Class,"launch",0
,function(self)
return (self);
end
,"Snapshot-startup","launch\r\n\t\" Private - The system has been launched and start execution.\r\n\tThe default action is to do nothing.\r\n\tSubclasses can refine this method to execute actions on startup.\r\n\t\"","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Class,"aboutToSaveImage:on:",0
,function(self,snapshot,stream)
return (self);
end
,"Snapshot-snapshot","aboutToSaveImage: snapshot on: stream\r\n\t\" Private - A system snapshot will be taken, the receiver can prepare the contents to be stored on snapshot.\r\n\tMust return the receiver or a replacement to act as the receiver when persisting data.\r\n\tThe default action return the receiver.\r\n\t\"\r\n\r\n\t^self","function(self,snapshot,stream)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Class,"imageSaved:on:",0
,function(self,snapshot,stream)
return (self);
end
,"Snapshot-snapshot","imageSaved: snapshot on: stream\r\n\t\" Private - A system snapshot has been taken, the receiver can emmit code to restore state.\r\n\tThe default action do nothing.\r\n\tThis method can be refined by the subclasses.\r\n\t\"","function(self,snapshot,stream)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Class,"aboutToExit:",0
,function(self,aSystemDictionary)
return (self);
end
,"Snapshot-snapshot","aboutToExit: aSystemDictionary\r\n\t\" Private - A system will exit, and the receiver can act executing actions just before exiting.\r\n\tThe default action do nothing.\r\n\tThis method can be refined by the subclasses.\r\n\t\"","function(self,aSystemDictionary)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"saveImageAs:",0
,function(self,fileName)
((self):current()):saveImageAs_(fileName);
return (self);
end
,"Snapshot-snapshot","saveImageAs: fileName\r\n\t\" Dump the image contents onto file at fileName. \"\r\n\r\n\tself current saveImageAs: fileName","function(self,fileName)\r\n((self):current()):saveImageAs_(fileName);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"saveImage",0
,function(self)
((self):current()):saveImage();
return (self);
end
,"Snapshot-snapshot","saveImage\r\n\t\" Dump the image contents onto image file. \"\r\n\r\n\tself current saveImage","function(self)\r\n((self):current()):saveImage();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"exit",0
,function(self)
((self):current()):exit();
return (self);
end
,"Snapshot-exiting","exit\r\n\t\" Exit to OS system. \"\r\n\r\n\tself current exit","function(self)\r\n((self):current()):exit();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"exit",0
,function(self)
((self):classes()):do_((function(each)
return ((each):aboutToExit_(self))
end));
quit();
return (self);
end
,"Snapshot-exiting","exit\r\n\t\" Exit to OS system. \"\r\n\r\n\tself classes do: [:each| each aboutToExit: self ].\r\n\t{'' doc'quit to OS'}.","function(self)\r\n((self):classes()):do_((function(each)\r\nreturn ((each):aboutToExit_(self))\r\nend));\r\nquit();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"product",0
,function(self)
return ("S8");
end
,"Snapshot-accessing","product\r\n\t\" Private - Return the name of the system. \"\r\n\r\n\t^#S8","function(self)\r\nreturn (\"S8\");\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"description",0
,function(self)
return ("A modern Smalltalk environment running on the \"invisible machine\".");
end
,"Snapshot-accessing","description\r\n\t\" Return the description of the receiver. \"\r\n\r\n\t^'A modern Smalltalk environment running on the \"invisible machine\".'","function(self)\r\nreturn (\"A modern Smalltalk environment running on the \\\"invisible machine\\\".\");\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"licenseComment",0
,function(self)
return ("\r\nThe text you are reading here is the residue of something that has run before.\r\nKeep the system running with responsibility. Smalltalk is not the words,\r\n nor any definition, nor it current contents...\r\nSmalltalk include your feelings when you see it running.\r\nSmalltalk is what happens when time flows and you \"are\" here.\r\nStop reading/writing code (thinking you are outside the system),\r\n change your world with responsibility, one object at a time, with your hands,\r\n during all your life, in family.\r\n");
end
,"Snapshot-license","licenseComment\r\n\t\" Private - Comment note about license of this product. \"\r\n\r\n\t^'\r\nThe text you are reading here is the residue of something that has run before.\r\nKeep the system running with responsibility. Smalltalk is not the words,\r\n nor any definition, nor it current contents...\r\nSmalltalk include your feelings when you see it running.\r\nSmalltalk is what happens when time flows and you \"are\" here.\r\nStop reading/writing code (thinking you are outside the system),\r\n change your world with responsibility, one object at a time, with your hands,\r\n during all your life, in family.\r\n'","function(self)\r\nreturn (\"\\r\\nThe text you are reading here is the residue of something that has run before.\\r\\nKeep the system running with responsibility. Smalltalk is not the words,\\r\\n nor any definition, nor it current contents...\\r\\nSmalltalk include your feelings when you see it running.\\r\\nSmalltalk is what happens when time flows and you \\\"are\\\" here.\\r\\nStop reading/writing code (thinking you are outside the system),\\r\\n change your world with responsibility, one object at a time, with your hands,\\r\\n during all your life, in family.\\r\\n\");\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"licenseTerms",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):product())," - ")),(self):description())),"\r\n")),(self):licenseMoreHolders())),"\r\n")),(self):licenseHolders())),"\r\nPermission is hereby granted, free of charge, to any person obtaining\r\n a copy of this software and associated documentation files (the \"Software\"),\r\n to deal in the Software without restriction, including without limitation\r\n the rights to use, copy, modify, merge, publish, distribute, sublicense,\r\n and/or sell copies of the Software, and to permit persons to whom the\r\n Software is furnished to do so, subject to the following conditions:\r\n\r\nThe above copyright notice and this permission notice shall be included\r\n in all copies or substantial portions of the Software.\r\n\r\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\r\n EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES\r\n OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.\r\n IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY\r\n CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,\r\n TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE\r\n OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\r\n\r\n")),(self):licenseComment()));
end
,"Snapshot-license","licenseTerms\r\n\t\" Private - Return the license terms to use this system. \"\r\n\r\n\t^self product ,' - ' ,self description ,'\r\n' ,self licenseMoreHolders ,'\r\n' ,self licenseHolders ,'\r\nPermission is hereby granted, free of charge, to any person obtaining\r\n a copy of this software and associated documentation files (the \"Software\"),\r\n to deal in the Software without restriction, including without limitation\r\n the rights to use, copy, modify, merge, publish, distribute, sublicense,\r\n and/or sell copies of the Software, and to permit persons to whom the\r\n Software is furnished to do so, subject to the following conditions:\r\n\r\nThe above copyright notice and this permission notice shall be included\r\n in all copies or substantial portions of the Software.\r\n\r\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\r\n EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES\r\n OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.\r\n IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY\r\n CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,\r\n TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE\r\n OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\r\n\r\n' ,self licenseComment","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):product()),\" - \")),(self):description())),\"\\r\\n\")),(self):licenseMoreHolders())),\"\\r\\n\")),(self):licenseHolders())),\"\\r\\nPermission is hereby granted, free of charge, to any person obtaining\\r\\n a copy of this software and associated documentation files (the \\\"Software\\\"),\\r\\n to deal in the Software without restriction, including without limitation\\r\\n the rights to use, copy, modify, merge, publish, distribute, sublicense,\\r\\n and/or sell copies of the Software, and to permit persons to whom the\\r\\n Software is furnished to do so, subject to the following conditions:\\r\\n\\r\\nThe above copyright notice and this permission notice shall be included\\r\\n in all copies or substantial portions of the Software.\\r\\n\\r\\nTHE SOFTWARE IS PROVIDED \\\"AS IS\\\", WITHOUT WARRANTY OF ANY KIND,\\r\\n EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES\\r\\n OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.\\r\\n IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY\\r\\n CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,\\r\\n TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE\\r\\n OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\\r\\n\\r\\n\")),(self):licenseComment()));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"licenseYear",0
,function(self)
return (((function()
return (smalltalk:toString_((((smalltalk.DateTime):today()):year())))
end)):on_do_(smalltalk.Exception,(function()
return ("today")
end)));
end
,"Snapshot-license","licenseYear\r\n\t\" Private - Return the year license information. \"\r\n\r\n\t^[ DateTime today year toString\r\n\t] on: Exception do: [ #today ] ","function(self)\r\nreturn (((function()\r\nreturn (smalltalk:toString_((((smalltalk.DateTime):today()):year())))\r\nend)):on_do_(smalltalk.Exception,(function()\r\nreturn (\"today\")\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"licenseMoreHolders",0
,function(self)
return ("");
end
,"Snapshot-license","licenseMoreHolders\r\n\t\" Private - Return additional license holders information. \"\r\n\r\n\t^''","function(self)\r\nreturn (\"\");\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"licenseHolders",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Copyright (C) "),smalltalk:asString_(((self):licenseYear()))))," ")),"Alejandro F. Reimondo <aleReimondo@smalltalking.net>\r\n\r\nParts of source code written for Jtalk (Sept 2011),\r\nCopyright (C) 2011 by Nicolas Petton <petton.nicolas@gmail.com>\r\nCopyright (C) 2011 Jtalk contributors\r\n\tDavid Graham <dgraham@iphouse.com>\r\n\tGoran Krampe <goran@krampe.se>\r\nAlso code and ideas from Clamato (http://clamato.net), written by Avi Byrant.\r\nThe PetitParser library, published by Lukas Renggli (http://lukas-renggli.ch) and released under the MIT license.\r\nAnd people that contributed to Smalltalk on diverse media years(decades) before this license holders claimed ownership.\r\n"));
end
,"Snapshot-license","licenseHolders\r\n\t\" Private - Return the license holders information. \"\r\n\r\n\t^'Copyright (C) '\r\n\t,self licenseYear asString ,' '\r\n\t,'Alejandro F. Reimondo <aleReimondo@smalltalking.net>\r\n\r\nParts of source code written for Jtalk (Sept 2011),\r\nCopyright (C) 2011 by Nicolas Petton <petton.nicolas@gmail.com>\r\nCopyright (C) 2011 Jtalk contributors\r\n\tDavid Graham <dgraham@iphouse.com>\r\n\tGoran Krampe <goran@krampe.se>\r\nAlso code and ideas from Clamato (http://clamato.net), written by Avi Byrant.\r\nThe PetitParser library, published by Lukas Renggli (http://lukas-renggli.ch) and released under the MIT license.\r\nAnd people that contributed to Smalltalk on diverse media years(decades) before this license holders claimed ownership.\r\n'","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Copyright (C) \"),smalltalk:asString_(((self):licenseYear())))),\" \")),\"Alejandro F. Reimondo <aleReimondo@smalltalking.net>\\r\\n\\r\\nParts of source code written for Jtalk (Sept 2011),\\r\\nCopyright (C) 2011 by Nicolas Petton <petton.nicolas@gmail.com>\\r\\nCopyright (C) 2011 Jtalk contributors\\r\\n\\tDavid Graham <dgraham@iphouse.com>\\r\\n\\tGoran Krampe <goran@krampe.se>\\r\\nAlso code and ideas from Clamato (http://clamato.net), written by Avi Byrant.\\r\\nThe PetitParser library, published by Lukas Renggli (http://lukas-renggli.ch) and released under the MIT license.\\r\\nAnd people that contributed to Smalltalk on diverse media years(decades) before this license holders claimed ownership.\\r\\n\"));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"globalsDo:",0
,function(self,aBlock)
return ((self):globalsDo(aBlock));
end
,"Snapshot-evaluating","globalsDo: aBlock\r\n\t\" Private - Evaluates aBlock for each globals defined in the receiver. \"\r\n\r\n\t^self #globalsDo: aBlock","function(self,aBlock)\r\nreturn ((self):globalsDo(aBlock));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"globalsDo:separatedBy:",0
,function(self,aBlock,anotherBlock)
local first=nil
(function()
	local _s8_value=(true)
	first=_s8_value
	return _s8_value
end)();
return ((self):globalsDo((function(each)
if (first)==true then (function()
	local _s8_value=(false)
	first=_s8_value
	return _s8_value
end)(); else (anotherBlock):value(); end;return ((aBlock):value_(each))
end)));
end
,"Snapshot-evaluating","globalsDo: aBlock separatedBy: anotherBlock\r\n\t\" Private - Evaluates aBlock for each globals defined in the receiver. \"\r\n\r\n\t| first | first := true.\r\n\t^self #globalsDo: [:each|\r\n\t    first\r\n\t\tifTrue: [ first := false ]\r\n\t\tifFalse: [ anotherBlock value ].\r\n\t    aBlock value: each\r\n\t]","function(self,aBlock,anotherBlock)\r\nlocal first=nil\r\n(function()\r\n\tlocal _s8_value=(true)\r\n\tfirst=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):globalsDo((function(each)\r\nif (first)==true then (function()\r\n\tlocal _s8_value=(false)\r\n\tfirst=_s8_value\r\n\treturn _s8_value\r\nend)(); else (anotherBlock):value(); end;return ((aBlock):value_(each))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"saveImageOn:",0
,function(self,stream)
local exporter=nil
local allClasses=nil
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(((self):licenseTerms()):asComment());
	return ((_s8_rec):cr())
end
)(stream);
(function()
	local _s8_value=(((((self):rootClasses()):inject_into_(smalltalk:newArray({}),(function(total,each)
(total):addAll_((each):withAllSubclasses());return (total)
end))):collect_((function(each)
return ((each):aboutToSaveImage_on_(self,stream))
end))):select_((function(each)
return (smalltalk:notNil_((each)))
end)))
	allClasses=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.Exporter):new())
	exporter=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):cr();
	(_s8_rec):nextPutAll_(("Smalltalk Classes."):asComment());
	return ((_s8_rec):cr())
end
)(stream);
(exporter):exportClasses_on_(allClasses,stream);
(
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(("Smalltalk Globals set-up."):asComment()))
end
)(stream);
(self):globalsDo_((function(key)
return ((
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),key)),"=")),(exporter):exportObject_((self)[key]))))
end
)(stream))
end));
(allClasses):do_((function(each)
return ((each):imageSaved_on_(self,stream))
end));
return (self);
end
,"Snapshot-writing","saveImageOn: stream\r\n\t\" Dump the receiver's contents onto stream. \"\r\n\r\n\t| exporter allClasses |\r\n\tstream nextPutAll: self licenseTerms asComment; cr.\r\n\tallClasses := ((self rootClasses\r\n\t\tinject: #() into: [:total :each| total addAll: each withAllSubclasses. total ])\r\n\t\tcollect: [:each| each aboutToSaveImage: self on: stream ])\r\n\t\tselect: [:each| each notNil ].\r\n\texporter := Exporter new.\r\n\"\tstream nextPutAll: 'Smalltalk Globals (pre)definition.' asComment; cr.\r\n\tself\r\n\t\tglobalsDo: [:key| stream nextPutAll: 'smalltalk.',key ]\r\n\t\tseparatedBy: [ stream nextPutAll: ' , ' ].\r\n\tstream nextPutAll: '=nil'; cr.\r\n\"\tstream cr; nextPutAll: 'Smalltalk Classes.' asComment; cr.\r\n\texporter exportClasses: allClasses on: stream.\r\n\tstream cr; nextPutAll: 'Smalltalk Globals set-up.' asComment.\r\n\tself globalsDo: [:key|\r\n\t\tstream cr; nextPutAll: 'smalltalk.',key,'='\r\n\t\t\t,(exporter exportObject: (self basicAt: key))\r\n\t].\r\n\tallClasses do: [:each| each imageSaved: self on: stream ].","function(self,stream)\r\nlocal exporter=nil\r\nlocal allClasses=nil\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(((self):licenseTerms()):asComment());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream);\r\n(function()\r\n\tlocal _s8_value=(((((self):rootClasses()):inject_into_(smalltalk:newArray({}),(function(total,each)\r\n(total):addAll_((each):withAllSubclasses());return (total)\r\nend))):collect_((function(each)\r\nreturn ((each):aboutToSaveImage_on_(self,stream))\r\nend))):select_((function(each)\r\nreturn (smalltalk:notNil_((each)))\r\nend)))\r\n\tallClasses=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Exporter):new())\r\n\texporter=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):nextPutAll_((\"Smalltalk Classes.\"):asComment());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream);\r\n(exporter):exportClasses_on_(allClasses,stream);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_((\"Smalltalk Globals set-up.\"):asComment()))\r\nend\r\n)(stream);\r\n(self):globalsDo_((function(key)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),key)),\"=\")),(exporter):exportObject_((self)[key]))))\r\nend\r\n)(stream))\r\nend));\r\n(allClasses):do_((function(each)\r\nreturn ((each):imageSaved_on_(self,stream))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"imageContents",0
,function(self)
local stream=nil
(function()
	local _s8_value=(((smalltalk.String):new()):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):saveImageOn_(stream);
return ((stream):contents());
end
,"Snapshot-contents","imageContents\r\n\t\" Return a dump of the system contents. \"\r\n\r\n\t| stream |\r\n\tstream := String new writeStream.\r\n\tself saveImageOn: stream.\r\n\t^stream contents","function(self)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.String):new()):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):saveImageOn_(stream);\r\nreturn ((stream):contents());\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"snapshot",0
,function(self)
return ((smalltalk.Snapshot):contents());
end
,"Snapshot-contents","snapshot\r\n\t\" Return a system snapshot. \"\r\n\r\n\t^Snapshot contents","function(self)\r\nreturn ((smalltalk.Snapshot):contents());\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"imageFileName",0
,function(self)
return ((self)["$imageFileName"]);
end
,"Snapshot-fileName","imageFileName\r\n\t\" Return the image file name. \"\r\n\r\n\t^self basicAt: '$imageFileName'","function(self)\r\nreturn ((self)[\"$imageFileName\"]);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"imageFileName:",0
,function(self,fileName)
return (smalltalk:basic_at_put_((self),"$imageFileName",fileName));
end
,"Snapshot-fileName","imageFileName: fileName\r\n\t\" Set the image file name. \"\r\n\r\n\t^self basicAt: '$imageFileName' put: fileName","function(self,fileName)\r\nreturn (smalltalk:basic_at_put_((self),\"$imageFileName\",fileName));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"saveImage",0
,function(self)
(self):saveImageAs_((self):imageFileName());
return (self);
end
,"Snapshot-save","saveImage\r\n\t\" Dump the image contents onto default image file. \"\r\n\r\n\tself saveImageAs: self imageFileName","function(self)\r\n(self):saveImageAs_((self):imageFileName());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"saveImageAs:",0
,function(self,fileName)
(((smalltalk.String):doItSelector()):implementors()):do_((function(each)
return ((each):removeFromSystem())
end));
((self):imageContents()):outputToFile_(fileName);
(self):imageFileName_(fileName);
return (self);
end
,"Snapshot-save","saveImageAs: fileName\r\n\t\" Dump the image contents onto file at fileName. \"\r\n\r\n\tString doItSelector implementors do: [:each| each removeFromSystem ].\r\n\tself imageContents outputToFile: fileName.\r\n\tself imageFileName: fileName.","function(self,fileName)\r\n(((smalltalk.String):doItSelector()):implementors()):do_((function(each)\r\nreturn ((each):removeFromSystem())\r\nend));\r\n((self):imageContents()):outputToFile_(fileName);\r\n(self):imageFileName_(fileName);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"launch",0
,function(self)
((self):classes()):do_((function(each)
return ((each):launch())
end));
return (((smalltalk.Smalltalk):at_ifAbsent_("LaunchExpression",(function()
return (nil)
end))):evaluate());
end
,"Snapshot-startup","launch\r\n\t\" The system has been launched and start execution.\r\n\tThe default action is to propagate #launch to current classes and evaluate #LaunchExpression.\r\n\t\"\r\n\r\n\tself classes do: [:each| each launch ].\r\n\t^(Smalltalk at: #LaunchExpression ifAbsent: []) evaluate","function(self)\r\n((self):classes()):do_((function(each)\r\nreturn ((each):launch())\r\nend));\r\nreturn (((smalltalk.Smalltalk):at_ifAbsent_(\"LaunchExpression\",(function()\r\nreturn (nil)\r\nend))):evaluate());\r\nend")

smalltalk:bind(smalltalk.Snapshot["$klass"],"contents",0
,function(self)
return (((self):new()):contents());
end
,"accessing","contents\r\n\t\" Return a snapshot of current system contents. \"\r\n\r\n\t^self new contents","function(self)\r\nreturn (((self):new()):contents());\r\nend")

smalltalk:bind(smalltalk.Snapshot["$klass"],"outputToFile:",0
,function(self,fileName)
(((smalltalk.String):doItSelector()):implementors()):do_((function(each)
return ((each):removeFromSystem())
end));
((self):contents()):outputToFile_(fileName);
return (self);
end
,"saveImage","outputToFile: fileName\r\n\t\" Save a complete system snapshot in a file at fileName. \"\r\n\r\n\tString doItSelector implementors do: [:each| each removeFromSystem ].\r\n\tself contents outputToFile: fileName","function(self,fileName)\r\n(((smalltalk.String):doItSelector()):implementors()):do_((function(each)\r\nreturn ((each):removeFromSystem())\r\nend));\r\n((self):contents()):outputToFile_(fileName);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"contents",0
,function(self)
local stream=nil
(function()
	local _s8_value=(((smalltalk.String):new()):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):saveImageOn_(stream);
return ((stream):contents());
end
,"accessing","contents\r\n\t\" Return a snapshot of current system contents. \"\r\n\r\n\t| stream |\r\n\tstream := String new writeStream.\r\n\tself saveImageOn: stream.\r\n\t^stream contents","function(self)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.String):new()):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):saveImageOn_(stream);\r\nreturn ((stream):contents());\r\nend")

smalltalk:bind(smalltalk.Snapshot,"saveImageOn:",0
,function(self,stream)
return ((self):saveImage_on_((self):smalltalk(),stream));
end
,"saveImage","saveImageOn: stream\r\n\t\" Save the current system contents onto stream. \"\r\n\r\n\t^self saveImage: self smalltalk on: stream","function(self,stream)\r\nreturn ((self):saveImage_on_((self):smalltalk(),stream));\r\nend")

smalltalk:bind(smalltalk.Snapshot,"saveImage:on:",0
,function(self,aSmalltalk,stream)
(
function(_s8_rec)
	(_s8_rec):writeBoot_on_(aSmalltalk,stream);
	(_s8_rec):write_on_("Prologue",stream);
	(_s8_rec):writeContents_on_(aSmalltalk,stream);
	(_s8_rec):write_on_("Epilogue",stream);
	(_s8_rec):writeLaunchExpressionOn_(stream);
	return ((_s8_rec):yourself())
end
)(self);
return (self);
end
,"saveImage","saveImage: aSmalltalk on: stream\r\n\t\" Save aSmalltalk system contents onto stream. \"\r\n\r\n\tself\r\n\t\twriteBoot: aSmalltalk on: stream;\r\n\t\twrite: #Prologue on: stream;\r\n\t\twriteContents: aSmalltalk on: stream;\r\n\t\twrite: #Epilogue on: stream;\r\n\t\twriteLaunchExpressionOn: stream;\r\n\t\tyourself","function(self,aSmalltalk,stream)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):writeBoot_on_(aSmalltalk,stream);\r\n\t(_s8_rec):write_on_(\"Prologue\",stream);\r\n\t(_s8_rec):writeContents_on_(aSmalltalk,stream);\r\n\t(_s8_rec):write_on_(\"Epilogue\",stream);\r\n\t(_s8_rec):writeLaunchExpressionOn_(stream);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"writeLicense:on:",0
,function(self,aSmalltalk,aStream)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(((aSmalltalk):licenseTerms()):asComment());
	return ((_s8_rec):cr())
end
)(aStream);
return (self);
end
,"writing","writeLicense: aSmalltalk on: aStream\r\n\t\" Private - Write the license terms onto aStream. \"\r\n\r\n\taStream nextPutAll: aSmalltalk licenseTerms asComment; cr","function(self,aSmalltalk,aStream)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(((aSmalltalk):licenseTerms()):asComment());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"writeJSBootOn:",0
,function(self,aStream)
(self):writeLicense_on_((smalltalk.Smalltalk):current(),aStream);
(self):writeGlobals_on_(smalltalk:newArray({"StObject", "StBehavior", "StClass", "StMetaclass", "StMethod", "StUndefinedObject"}),aStream);
(self):writeNilDefinitionOn_(aStream);
(self):writeGlobals_on_(smalltalk:newArray({"StSystemDictionary"}),aStream);
(self):writeSystemDefinitionOn_(aStream);
return (self);
end
,"js","writeJSBootOn: aStream\r\n\t\" Private - Write the jsBoot section of the image onto aStream. \"\r\n\r\n\tself writeLicense: Smalltalk current on: aStream.\r\n\tself writeGlobals: #(\r\n\t\t#StObject #StBehavior #StClass #StMetaclass\r\n\t\t#StMethod\r\n\t\t#StUndefinedObject\r\n\t\t) on: aStream.\r\n\tself writeNilDefinitionOn: aStream.\r\n\tself writeGlobals: #( #StSystemDictionary ) on: aStream.\r\n\tself writeSystemDefinitionOn: aStream.","function(self,aStream)\r\n(self):writeLicense_on_((smalltalk.Smalltalk):current(),aStream);\r\n(self):writeGlobals_on_(smalltalk:newArray({\"StObject\", \"StBehavior\", \"StClass\", \"StMetaclass\", \"StMethod\", \"StUndefinedObject\"}),aStream);\r\n(self):writeNilDefinitionOn_(aStream);\r\n(self):writeGlobals_on_(smalltalk:newArray({\"StSystemDictionary\"}),aStream);\r\n(self):writeSystemDefinitionOn_(aStream);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"bootHeader",0
,function(self)
return ([[smalltalk = (function() 
]]);
end
,"encoding","bootHeader\r\n\t\" Private - Return the header for boot contents. \"\r\n\r\n\t^{''}","function(self)\r\nreturn ([[smalltalk = (function() \r\n]]);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"bootFooter",0
,function(self)
return ([[
end)()
]]);
end
,"encoding","bootFooter\r\n\t\" Private - Return the footer for boot contents. \"\r\n\r\n\t^{''}","function(self)\r\nreturn ([[\r\nend)()\r\n]]);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"writeBoot:on:",0
,function(self,aSmalltalk,aStream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local boot=nil
local bootName=nil
local save=nil
(function()
	local _s8_value=((function()
local text=nil
(self):writeLicense_on_(aSmalltalk,aStream);(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((self):bootHeader()),boot)),(self):bootFooter()))
	text=_s8_value
	return _s8_value
end)();(self):writeString_on_(text,aStream);return (text)
end))
	save=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aSmalltalk):at_ifAbsent_("BootSector",(function()
return (nil)
end)))
	boot=_s8_value
	return _s8_value
end)();
if (smalltalk:responds_to_((boot),("for:")))==true then (function()
	local _s8_value=(((boot):for_((self):nativeLanguage())):contents())
	boot=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:notNil_((boot))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):writeString_on_(boot,aStream))
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
	local _s8_value=(smalltalk:object_comma_(("S8_Boot_"),(smalltalk.String):nativeFileExtension()))
	bootName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aSmalltalk):at_ifAbsent_(bootName,(function()
return (nil)
end)))
	boot=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((boot)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((save):value())
end
)()
error(_s8Ret_,0)
end)(); end;
if ((self):write_on_("Boot",aStream))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
	local _s8_value=(smalltalk:object_comma_(("s8/start/boot."),(smalltalk.String):nativeFileExtension()))
	bootName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((bootName):fileContents())
	boot=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((boot)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aSmalltalk):at_put_(bootName,(save):value()))
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_("Missing boot resource"))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"writing","writeBoot: aSmalltalk on: aStream\r\n\t\" Private - Write the boot section of the image onto aStream. \"\r\n\r\n\t| boot bootName save |\r\n\tsave := [ | text |\r\n\t\tself writeLicense: aSmalltalk on: aStream.\r\n\t\ttext := self bootHeader ,boot ,self bootFooter.\r\n\t\tself writeString: text on: aStream.\r\n\t\ttext\r\n\t].\r\n\r\n\tboot := aSmalltalk at: #BootSector ifAbsent: [].\r\n\t(boot respondsTo: #for:) ifTrue: [\r\n\t\tboot := (boot for: self nativeLanguage) contents.\r\n\t\tboot notNil ifTrue: [\r\n\t\t\t^self writeString: boot on: aStream\r\n\t\t].\r\n\t].\r\n\r\n\tbootName := 'S8_Boot_' ,String nativeFileExtension.\r\n\tboot := aSmalltalk at: bootName ifAbsent: [].\r\n\tboot notNil ifTrue: [\r\n\t\t\"embedded boot sector\"\r\n\t\t^save value\r\n\t].\r\n\r\n\t(self write: #Boot on: aStream) ifTrue: [\r\n\t\t\"custom implementation by the receiver\"\r\n\t\t^self\r\n\t].\r\n\r\n\tbootName := 's8/start/boot.' ,String nativeFileExtension.\r\n\tboot := bootName fileContents.\r\n\tboot notNil ifTrue: [\r\n\t\t\"embedding from external boot file\"\r\n\t\t^aSmalltalk at: bootName put: save value\r\n\t].\r\n\t^self error: 'Missing boot resource'","function(self,aSmalltalk,aStream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal boot=nil\r\nlocal bootName=nil\r\nlocal save=nil\r\n(function()\r\n\tlocal _s8_value=((function()\r\nlocal text=nil\r\n(self):writeLicense_on_(aSmalltalk,aStream);(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((self):bootHeader()),boot)),(self):bootFooter()))\r\n\ttext=_s8_value\r\n\treturn _s8_value\r\nend)();(self):writeString_on_(text,aStream);return (text)\r\nend))\r\n\tsave=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aSmalltalk):at_ifAbsent_(\"BootSector\",(function()\r\nreturn (nil)\r\nend)))\r\n\tboot=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:responds_to_((boot),(\"for:\")))==true then (function()\r\n\tlocal _s8_value=(((boot):for_((self):nativeLanguage())):contents())\r\n\tboot=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:notNil_((boot))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):writeString_on_(boot,aStream))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((\"S8_Boot_\"),(smalltalk.String):nativeFileExtension()))\r\n\tbootName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aSmalltalk):at_ifAbsent_(bootName,(function()\r\nreturn (nil)\r\nend)))\r\n\tboot=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((boot)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((save):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\nif ((self):write_on_(\"Boot\",aStream))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((\"s8/start/boot.\"),(smalltalk.String):nativeFileExtension()))\r\n\tbootName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((bootName):fileContents())\r\n\tboot=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((boot)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aSmalltalk):at_put_(bootName,(save):value()))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(\"Missing boot resource\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Snapshot,"write:on:",0
,function(self,section,aStream)
local msg=nil
(aStream):cr();
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("write"),((self):nativeLanguage()):asUppercase())),section)),"On:"))
	msg=_s8_value
	return _s8_value
end)();
if (smalltalk:responds_to_((self),(msg)))==true then (self):perform_with_(msg,aStream);
return (true); end;
return (false);
end
,"writing","write: section on: aStream\r\n\t\" Private - Write the section of the image onto aStream. \"\r\n\r\n\t| msg |\r\n\taStream cr.\r\n\tmsg:= #write ,self nativeLanguage asUppercase ,section ,#On:.\r\n\t(self respondsTo: msg) ifTrue: [\r\n\t\tself perform: msg with: aStream.\r\n\t\t^true\r\n\t].\r\n\t^false","function(self,section,aStream)\r\nlocal msg=nil\r\n(aStream):cr();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"write\"),((self):nativeLanguage()):asUppercase())),section)),\"On:\"))\r\n\tmsg=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:responds_to_((self),(msg)))==true then (self):perform_with_(msg,aStream);\r\nreturn (true); end;\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"writeJSPrologueOn:",0
,function(self,aStream)
(self):writeString_on_("smalltalk.$state = \"js-toolset\"",aStream);
(self):writeGlobals_on_(smalltalk:newArray({"smalltalk.st", "smalltalk.doIt", "fileIn", "fileInJS", "doit", "exportCategory", "saveImage", "saveImageAs"}),aStream);
(self):writeString_on_("smalltalk.$state = \"initialized\"",aStream);
(aStream):cr();
return (self);
end
,"js","writeJSPrologueOn: aStream\r\n\t\" Private - Write the js prologue section of the image onto aStream. \"\r\n\r\n\tself writeString: 'smalltalk.$state = \"js-toolset\"' on: aStream.\r\n\tself writeGlobals: #(\r\n\t\t'smalltalk.st' 'smalltalk.doIt'\r\n\t\t#fileIn #fileInJS\r\n\t\t#doit #exportCategory\r\n\t\t#saveImage #saveImageAs\r\n\t\t) on: aStream.\r\n\tself writeString: 'smalltalk.$state = \"initialized\"' on: aStream.\r\n\taStream cr.","function(self,aStream)\r\n(self):writeString_on_(\"smalltalk.$state = \\\"js-toolset\\\"\",aStream);\r\n(self):writeGlobals_on_(smalltalk:newArray({\"smalltalk.st\", \"smalltalk.doIt\", \"fileIn\", \"fileInJS\", \"doit\", \"exportCategory\", \"saveImage\", \"saveImageAs\"}),aStream);\r\n(self):writeString_on_(\"smalltalk.$state = \\\"initialized\\\"\",aStream);\r\n(aStream):cr();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"launchExpression",0
,function(self)
return ("smalltalk:launchImage()");
end
,"encoding","launchExpression\r\n\t\" Private - Return the native launch expression. \"\r\n\r\n\t^{''}","function(self)\r\nreturn (\"smalltalk:launchImage()\");\r\nend")

smalltalk:bind(smalltalk.Snapshot,"writeLaunchExpressionOn:",0
,function(self,aStream)
local launch=nil
(function()
	local _s8_value=((self):launchExpression())
	launch=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((launch)))==true then (self):writeString_on_(launch,aStream); end;
return (self);
end
,"writing","writeLaunchExpressionOn: aStream\r\n\t\" Private - Write the epilogue section of the image onto aStream. \"\r\n\r\n\t| launch |\r\n\tlaunch := self launchExpression.\r\n\tlaunch notNil ifTrue: [ self writeString: launch on: aStream ].","function(self,aStream)\r\nlocal launch=nil\r\n(function()\r\n\tlocal _s8_value=((self):launchExpression())\r\n\tlaunch=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((launch)))==true then (self):writeString_on_(launch,aStream); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"writeString:on:",0
,function(self,aString,aStream)
(
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(aString))
end
)(aStream);
return (self);
end
,"writing","writeString: aString on: aStream\r\n\t\" Private - Write aString onto aStream. \"\r\n\r\n\taStream cr; nextPutAll: aString","function(self,aString,aStream)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(aString))\r\nend\r\n)(aStream);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"globalNotFound:",0
,function(self,aGlobal)
return ((self):error_(smalltalk:object_comma_(("Global not found: "),aGlobal)));
end
,"error","globalNotFound: aGlobal\r\n\t\" Private - A global at native level has not been found. \"\r\n\r\n\t^self error: 'Global not found: ',aGlobal","function(self,aGlobal)\r\nreturn ((self):error_(smalltalk:object_comma_((\"Global not found: \"),aGlobal)));\r\nend")

smalltalk:bind(smalltalk.Snapshot,"writeGlobals:on:",0
,function(self,globals,aStream)
local object=nil
local varName=nil
(globals):do_((function(each)
(function()
	local _s8_value=(((smalltalk.Smalltalk):current()):eval_(each))
	object=_s8_value
	return _s8_value
end)();if (smalltalk:isNil_((object)))==true then (function()
	local _s8_value=((self):globalNotFound_(each))
	object=_s8_value
	return _s8_value
end)(); end;return (smalltalk:if_true_false_((smalltalk:notNil_((object))),(function()
(function()
	local _s8_value=(smalltalk:if_true_false_(((each):includes_(".")),(function()
return (each)
end),(function()
return (smalltalk:object_comma_(("var "),each))
end)))
	varName=_s8_value
	return _s8_value
end)();return ((self):writeString_on_(smalltalk:object_comma_((smalltalk:object_comma_((varName)," = ")),smalltalk:toString_((object))),aStream))
end),nil))
end));
return (self);
end
,"writing","writeGlobals: globals on: aStream\r\n\t\" Private - Write the prologue section of the image onto aStream. \"\r\n\r\n\t| object varName |\r\n\tglobals do: [:each|\r\n\t\tobject := Smalltalk current eval: each.\r\n\t\tobject isNil ifTrue: [ object := self globalNotFound: each ].\r\n\t\tobject notNil ifTrue: [\r\n\t\t\tvarName := (each includes: $.) ifTrue: [ each ] ifFalse: [ 'var ',each ].\r\n\t\t\tself writeString: varName,' = ', object toString on: aStream.\r\n\t\t]\r\n\t]","function(self,globals,aStream)\r\nlocal object=nil\r\nlocal varName=nil\r\n(globals):do_((function(each)\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.Smalltalk):current()):eval_(each))\r\n\tobject=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isNil_((object)))==true then (function()\r\n\tlocal _s8_value=((self):globalNotFound_(each))\r\n\tobject=_s8_value\r\n\treturn _s8_value\r\nend)(); end;return (smalltalk:if_true_false_((smalltalk:notNil_((object))),(function()\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((each):includes_(\".\")),(function()\r\nreturn (each)\r\nend),(function()\r\nreturn (smalltalk:object_comma_((\"var \"),each))\r\nend)))\r\n\tvarName=_s8_value\r\n\treturn _s8_value\r\nend)();return ((self):writeString_on_(smalltalk:object_comma_((smalltalk:object_comma_((varName),\" = \")),smalltalk:toString_((object))),aStream))\r\nend),nil))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"writeNilDefinitionOn:",0
,function(self,aStream)
local sample=nil
(function()
	local _s8_value=(nil)
	sample=_s8_value
	return _s8_value
end)();
(self):writeString_on_("var nil = new StUndefinedObject()",aStream);
(self):writeString_on_(smalltalk:object_comma_(("nil.toString = "),smalltalk:toString_((sample["toString"]))),aStream);
(self):writeString_on_(smalltalk:object_comma_(("nil.isNil_ = "),smalltalk:toString_((sample["isNil_"]))),aStream);
(self):writeString_on_(smalltalk:object_comma_(("nil.is_eqeq_ = "),smalltalk:toString_((sample["is_eqeq_"]))),aStream);
return (self);
end
,"js","writeNilDefinitionOn: aStream\r\n\t\" Private - Write the definition of nil object onto aStream. \"\r\n\r\n\t| sample |\r\n\tsample := nil.\r\n\tself writeString: 'var nil = new StUndefinedObject()' on: aStream.\r\n\tself writeString: 'nil.toString = ', sample#toString toString on: aStream.\r\n\tself writeString: 'nil.isNil_ = ', sample#isNil_ toString on: aStream.\r\n\tself writeString: 'nil.is_eqeq_ = ', sample#is_eqeq_ toString on: aStream.","function(self,aStream)\r\nlocal sample=nil\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tsample=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):writeString_on_(\"var nil = new StUndefinedObject()\",aStream);\r\n(self):writeString_on_(smalltalk:object_comma_((\"nil.toString = \"),smalltalk:toString_((sample[\"toString\"]))),aStream);\r\n(self):writeString_on_(smalltalk:object_comma_((\"nil.isNil_ = \"),smalltalk:toString_((sample[\"isNil_\"]))),aStream);\r\n(self):writeString_on_(smalltalk:object_comma_((\"nil.is_eqeq_ = \"),smalltalk:toString_((sample[\"is_eqeq_\"]))),aStream);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"writeSystemDefinitionOn:",0
,function(self,aStream)
(self):writeString_on_("var smalltalk = new StSystemDictionary()",aStream);
(self):writeString_on_("smalltalk.toString = function() { return \"smalltalk\" }",aStream);
(self):writeString_on_("smalltalk.startup();",aStream);
return (self);
end
,"js","writeSystemDefinitionOn: aStream\r\n\t\" Private - Write the definition of smalltalk object onto aStream. \"\r\n\r\n\tself writeString: 'var smalltalk = new StSystemDictionary()' on: aStream.\r\n\tself writeString: 'smalltalk.toString = function() { return \"smalltalk\" }' on: aStream.\r\n\tself writeString: 'smalltalk.startup();' on: aStream.","function(self,aStream)\r\n(self):writeString_on_(\"var smalltalk = new StSystemDictionary()\",aStream);\r\n(self):writeString_on_(\"smalltalk.toString = function() { return \\\"smalltalk\\\" }\",aStream);\r\n(self):writeString_on_(\"smalltalk.startup();\",aStream);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"writeContents:on:",0
,function(self,aSmalltalk,aStream)
local exporter=nil
local globals=nil
local classes=nil
(aStream):cr();
(function()
	local _s8_value=((self):exporterFor_(aSmalltalk))
	exporter=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):globalsIn_(aSmalltalk))
	globals=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((self):classesToExportFrom_with_(aSmalltalk,exporter)):collect_((function(each)
return ((each):aboutToSaveImage_on_(self,aStream))
end))):select_((function(each)
return (smalltalk:notNil_((each)))
end)))
	classes=_s8_value
	return _s8_value
end)();
(exporter):exportClasses_on_(classes,aStream);
(self):exportGlobals_with_on_(globals,exporter,aStream);
(classes):do_((function(each)
return ((each):imageSaved_on_(self,aStream))
end));
return (self);
end
,"writing","writeContents: aSmalltalk on: aStream\r\n\t\" Private - Write the image section of aSmalltalk system onto aStream. \"\r\n\r\n\t| exporter globals classes |\r\n\taStream cr.\r\n\texporter := self exporterFor: aSmalltalk.\r\n\tglobals := self globalsIn: aSmalltalk.\r\n\tclasses := ((self classesToExportFrom: aSmalltalk with: exporter)\r\n\t\tcollect: [:each| each aboutToSaveImage: self on: aStream ])\r\n\t\tselect: [:each| each notNil ].\r\n\"\tself exportGlobalNames: globals keys sorted in: aSmalltalk on: aStream.\r\n\"\texporter exportClasses: classes on: aStream.\r\n\tself exportGlobals: globals with: exporter on: aStream.\r\n\tclasses do: [:each| each imageSaved: self on: aStream ].","function(self,aSmalltalk,aStream)\r\nlocal exporter=nil\r\nlocal globals=nil\r\nlocal classes=nil\r\n(aStream):cr();\r\n(function()\r\n\tlocal _s8_value=((self):exporterFor_(aSmalltalk))\r\n\texporter=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):globalsIn_(aSmalltalk))\r\n\tglobals=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((self):classesToExportFrom_with_(aSmalltalk,exporter)):collect_((function(each)\r\nreturn ((each):aboutToSaveImage_on_(self,aStream))\r\nend))):select_((function(each)\r\nreturn (smalltalk:notNil_((each)))\r\nend)))\r\n\tclasses=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(exporter):exportClasses_on_(classes,aStream);\r\n(self):exportGlobals_with_on_(globals,exporter,aStream);\r\n(classes):do_((function(each)\r\nreturn ((each):imageSaved_on_(self,aStream))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"exporterFor:",0
,function(self,aSmalltalk)
return ((smalltalk.Exporter):new());
end
,"exporting","exporterFor: aSmalltalk\r\n\t\" Private - Return the exporter to use to write contents of aSmalltalk system. \"\r\n\r\n\t^Exporter new","function(self,aSmalltalk)\r\nreturn ((smalltalk.Exporter):new());\r\nend")

smalltalk:bind(smalltalk.Snapshot,"globalsIn:",0
,function(self,aSmalltalk)
local result=nil
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	result=_s8_value
	return _s8_value
end)();
(aSmalltalk):globalsDo_((function(key)
return ((result):at_put_(key,(aSmalltalk)[key]))
end));
return (result);
end
,"exporting","globalsIn: aSmalltalk\r\n\t\" Private - Return the globals defined in aSmalltalk system. \"\r\n\r\n\t| result |\r\n\tresult := PoolDictionary new.\r\n\taSmalltalk globalsDo: [:key| result at: key put: (aSmalltalk basicAt: key) ].\r\n\t^result","function(self,aSmalltalk)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aSmalltalk):globalsDo_((function(key)\r\nreturn ((result):at_put_(key,(aSmalltalk)[key]))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"classesToExportFrom:with:",0
,function(self,aSmalltalk,exporter)
return (((aSmalltalk):rootClasses()):inject_into_(smalltalk:newArray({}),(function(total,each)
(total):addAll_((each):withAllSubclasses());return (total)
end)));
end
,"exporting","classesToExportFrom: aSmalltalk with: exporter\r\n\t\" Private - Return the classes to export from aSmalltalk system. \"\r\n\r\n\t^aSmalltalk rootClasses\r\n\t\tinject: #() into: [:total :each| total addAll: each withAllSubclasses. total ]","function(self,aSmalltalk,exporter)\r\nreturn (((aSmalltalk):rootClasses()):inject_into_(smalltalk:newArray({}),(function(total,each)\r\n(total):addAll_((each):withAllSubclasses());return (total)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Snapshot,"exportGlobalNames:in:on:",0
,function(self,names,aSmalltalk,aStream)
(names):do_separatedBy_((function(key)
return ((aStream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk[\""),key)),"\"]")))
end),(function()
return ((aStream):nextPutAll_(" , "))
end));
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("=nil");
	return ((_s8_rec):cr())
end
)(aStream);
return (self);
end
,"exporting","exportGlobalNames: names in: aSmalltalk on: aStream\r\n\t\" Private - Export global names in aSmalltalk system. \"\r\n\r\n\tnames\r\n\t\tdo: [:key| aStream nextPutAll: 'smalltalk[\"',key,'\"]' ]\r\n\t\tseparatedBy: [ aStream nextPutAll: ' , ' ].\r\n\taStream nextPutAll: '=nil'; cr.","function(self,names,aSmalltalk,aStream)\r\n(names):do_separatedBy_((function(key)\r\nreturn ((aStream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk[\\\"\"),key)),\"\\\"]\")))\r\nend),(function()\r\nreturn ((aStream):nextPutAll_(\" , \"))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"=nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Snapshot,"exportGlobals:with:on:",0
,function(self,globals,exporter,aStream)
(globals):associationsDo_((function(binding)
return ((self):writeString_on_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk[\""),(binding):key())),"\"]=")),(exporter):exportObject_((binding):value())),aStream))
end));
return (self);
end
,"exporting","exportGlobals: globals with: exporter on: aStream\r\n\t\" Private - Export global objects onto aStream. \"\r\n\r\n\tglobals associationsDo: [:binding|\r\n\t\tself writeString: 'smalltalk[\"',binding key,'\"]='\r\n\t\t\t,(exporter exportObject: binding value)\r\n\t\t\ton: aStream\r\n\t]","function(self,globals,exporter,aStream)\r\n(globals):associationsDo_((function(binding)\r\nreturn ((self):writeString_on_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk[\\\"\"),(binding):key())),\"\\\"]=\")),(exporter):exportObject_((binding):value())),aStream))\r\nend));\r\nreturn (self);\r\nend")

-- WARNING: class REdefinition for SystemManager
smalltalk:addClass("SystemManager",smalltalk.EventManager,smalltalk:newArray({}),"Snapshot")
smalltalk.SystemManager["$classVariableNames"]="Current"

smalltalk:bind(smalltalk.SystemManager["$klass"],"constructEventsTriggered",0
,function(self)
return (smalltalk:object_comma_((smalltalk:superImplementor(smalltalk.SystemManager["$klass"],"constructEventsTriggered")(self)),smalltalk:newArray({"aboutToBind:to:", "methodBound:to:", "aboutToRemove:from:", "methodRemoved:from:", "aboutToChange:to:", "aboutToCreateClass:with:", "classChanged:", "classShapeChanged:", "object:at:notFoundIn:", "log:", "memoryWarning:"})));
end
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^super constructEventsTriggered ,#(\r\n\t\t#aboutToBind:to:\r\n\t\t#methodBound:to:\r\n\t\t#aboutToRemove:from:\r\n\t\t#methodRemoved:from:\r\n\t\t#aboutToChange:to:\r\n\t\t#aboutToCreateClass:with:\r\n\t\t#classChanged:\r\n\t\t#classShapeChanged:\r\n\t\t#object:at:notFoundIn:\r\n\t\t#log:\r\n\t\t#memoryWarning:\r\n\t)","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:superImplementor(smalltalk.SystemManager[\"$klass\"],\"constructEventsTriggered\")(self)),smalltalk:newArray({\"aboutToBind:to:\", \"methodBound:to:\", \"aboutToRemove:from:\", \"methodRemoved:from:\", \"aboutToChange:to:\", \"aboutToCreateClass:with:\", \"classChanged:\", \"classShapeChanged:\", \"object:at:notFoundIn:\", \"log:\", \"memoryWarning:\"})));\r\nend")

smalltalk:bind(smalltalk.SystemManager["$klass"],"currentOrNil",0
,function(self)
return ((self):classVariableAt_ifAbsent_("Current",(function()
return (nil)
end)));
end
,"singleton","currentOrNil\r\n\t\" Return the current instance of the receiver. \"\r\n\r\n\t^self classVariableAt: #Current ifAbsent: [ nil ]","function(self)\r\nreturn ((self):classVariableAt_ifAbsent_(\"Current\",(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SystemManager["$klass"],"current",0
,function(self)
if (smalltalk:isNil_((smalltalk.SystemManager:classVariableAt_("Current"))))==true then (self):current_((self):new()); end;
return (smalltalk.SystemManager:classVariableAt_("Current"));
end
,"singleton","current\r\n\t\" Return the current instance of the receiver. \"\r\n\r\n\tCurrent isNil ifTrue: [ self current: self new ].\r\n\t^Current","function(self)\r\nif (smalltalk:isNil_((smalltalk.SystemManager:classVariableAt_(\"Current\"))))==true then (self):current_((self):new()); end;\r\nreturn (smalltalk.SystemManager:classVariableAt_(\"Current\"));\r\nend")

smalltalk:bind(smalltalk.SystemManager["$klass"],"current:",0
,function(self,aSystemManager)
smalltalk.SystemManager:classVariableAt_put_("Current",aSystemManager);
(aSystemManager):install();
return (self);
end
,"singleton","current: aSystemManager\r\n\t\" Set the current instance of the receiver. \"\r\n\r\n\tCurrent := aSystemManager.\r\n\taSystemManager install.","function(self,aSystemManager)\r\nsmalltalk.SystemManager:classVariableAt_put_(\"Current\",aSystemManager);\r\n(aSystemManager):install();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemManager["$klass"],"log:",0
,function(self,aString)
if (smalltalk:notNil_((smalltalk.SystemManager:classVariableAt_("Current"))))==true then (smalltalk.SystemManager:classVariableAt_("Current")):log_(aString); end;
return (self);
end
,"log","log: aString\r\n\t\" Log aString onto loggin stream. \"\r\n\r\n\tCurrent notNil ifTrue: [ Current log: aString ]","function(self,aString)\r\nif (smalltalk:notNil_((smalltalk.SystemManager:classVariableAt_(\"Current\"))))==true then (smalltalk.SystemManager:classVariableAt_(\"Current\")):log_(aString); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemManager["$klass"],"memoryWarning:",0
,function(self,anArgument)
if (smalltalk:notNil_((smalltalk.SystemManager:classVariableAt_("Current"))))==true then (smalltalk.SystemManager:classVariableAt_("Current")):memoryWarning_(anArgument); end;
return (self);
end
,"memory","memoryWarning: anArgument\r\n\t\" Trigger a memory warning event. \"\r\n\r\n\tCurrent notNil ifTrue: [ Current memoryWarning: anArgument ]","function(self,anArgument)\r\nif (smalltalk:notNil_((smalltalk.SystemManager:classVariableAt_(\"Current\"))))==true then (smalltalk.SystemManager:classVariableAt_(\"Current\")):memoryWarning_(anArgument); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemManager,"install",0
,function(self)
return (self);
end
,"install","install\r\n\t\" Private - Install the receiver as the source manager of the system.\r\n\tThe default action is to do nothing.\r\n\tThis method can be refined by subclasses.\r\n\t\"","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemManager,"aboutToBind:to:",0
,function(self,aMethod,aClass)
return ((self):triggerEvent_with_with_("aboutToBind:to:",aMethod,aClass));
end
,"tracking-methods","aboutToBind: aMethod to: aClass\r\n\t\" Private - The method will be bound to aClass. \"\r\n\r\n\t^self triggerEvent: #aboutToBind:to: with: aMethod with: aClass ","function(self,aMethod,aClass)\r\nreturn ((self):triggerEvent_with_with_(\"aboutToBind:to:\",aMethod,aClass));\r\nend")

smalltalk:bind(smalltalk.SystemManager,"methodBound:to:",0
,function(self,aMethod,aClass)
return ((self):triggerEvent_with_with_("methodBound:to:",aMethod,aClass));
end
,"tracking-methods","methodBound: aMethod to: aClass\r\n\t\" Private - The method has been bound to aClass. \"\r\n\r\n\t^self triggerEvent: #methodBound:to: with: aMethod with: aClass ","function(self,aMethod,aClass)\r\nreturn ((self):triggerEvent_with_with_(\"methodBound:to:\",aMethod,aClass));\r\nend")

smalltalk:bind(smalltalk.SystemManager,"aboutToRemove:from:",0
,function(self,aMethod,aClass)
return ((self):triggerEvent_with_with_("aboutToRemove:from:",aMethod,aClass));
end
,"tracking-methods","aboutToRemove: aMethod from: aClass\r\n\t\" Private - The method will be removed from aClass. \"\r\n\r\n\t^self triggerEvent: #aboutToRemove:from: with: aMethod with: aClass ","function(self,aMethod,aClass)\r\nreturn ((self):triggerEvent_with_with_(\"aboutToRemove:from:\",aMethod,aClass));\r\nend")

smalltalk:bind(smalltalk.SystemManager,"methodRemoved:from:",0
,function(self,aMethod,aClass)
return ((self):triggerEvent_with_with_("methodRemoved:from:",aMethod,aClass));
end
,"tracking-methods","methodRemoved: aMethod from: aClass\r\n\t\" Private - The method has been removed from aClass. \"\r\n\r\n\t^self triggerEvent: #methodRemoved:from: with: aMethod with: aClass ","function(self,aMethod,aClass)\r\nreturn ((self):triggerEvent_with_with_(\"methodRemoved:from:\",aMethod,aClass));\r\nend")

smalltalk:bind(smalltalk.SystemManager,"aboutToChange:superclass:iVarNames:category:",0
,function(self,aClass,superclass,iVarNames,category)
return ((self):triggerEvent_with_with_("aboutToChange:to:",aClass,(smalltalk.Array):with_with_with_(superclass,iVarNames,category)));
end
,"tracking-classes","aboutToChange: aClass superclass: superclass iVarNames: iVarNames category: category\r\n\t\" Private - aClass is about to be changed. \"\r\n\r\n\t^self\ttriggerEvent: #aboutToChange:to:\r\n\t\twith: aClass\r\n\t\twith: (Array with: superclass with: iVarNames with: category)","function(self,aClass,superclass,iVarNames,category)\r\nreturn ((self):triggerEvent_with_with_(\"aboutToChange:to:\",aClass,(smalltalk.Array):with_with_with_(superclass,iVarNames,category)));\r\nend")

smalltalk:bind(smalltalk.SystemManager,"aboutToCreateClass:superclass:iVarNames:category:",0
,function(self,globalName,superclass,iVarNames,category)
return ((self):triggerEvent_with_with_("aboutToCreateClass:with:",globalName,(smalltalk.Array):with_with_with_(superclass,iVarNames,category)));
end
,"tracking-classes","aboutToCreateClass: globalName superclass: superclass iVarNames: iVarNames category: category\r\n\t\" Private - Attemp to create Class with name globalName. \"\r\n\r\n\t^self\ttriggerEvent: #aboutToCreateClass:with:\r\n\t\twith: globalName\r\n\t\twith: (Array with: superclass with: iVarNames with: category)","function(self,globalName,superclass,iVarNames,category)\r\nreturn ((self):triggerEvent_with_with_(\"aboutToCreateClass:with:\",globalName,(smalltalk.Array):with_with_with_(superclass,iVarNames,category)));\r\nend")

smalltalk:bind(smalltalk.SystemManager,"classChanged:",0
,function(self,aBehavior)
return ((self):triggerEvent_with_("classChanged:",aBehavior));
end
,"tracking-classes","classChanged: aBehavior\r\n\t\" Private - aBehavior has been changed. \"\r\n\r\n\t^self triggerEvent: #classChanged: with: aBehavior ","function(self,aBehavior)\r\nreturn ((self):triggerEvent_with_(\"classChanged:\",aBehavior));\r\nend")

smalltalk:bind(smalltalk.SystemManager,"classShapeChanged:",0
,function(self,aBehavior)
return ((self):triggerEvent_with_ifNotHandled_("classShapeChanged:",aBehavior,(function()
return ((aBehavior):recompileAll())
end)));
end
,"tracking-classes","classShapeChanged: aBehavior\r\n\t\" Private - aBehavior has changed shape. \"\r\n\r\n\t^self\ttriggerEvent: #classShapeChanged:\r\n\t\twith: aBehavior\r\n\t\tifNotHandled: [ aBehavior recompileAll ]","function(self,aBehavior)\r\nreturn ((self):triggerEvent_with_ifNotHandled_(\"classShapeChanged:\",aBehavior,(function()\r\nreturn ((aBehavior):recompileAll())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SystemManager,"log:",0
,function(self,aString)
return ((self):triggerEvent_with_("log:",aString));
end
,"log","log: aString\r\n\t\" Private - Log aString onto loggin device. \"\r\n\r\n\t^self triggerEvent: #log: with: aString","function(self,aString)\r\nreturn ((self):triggerEvent_with_(\"log:\",aString));\r\nend")

smalltalk:bind(smalltalk.SystemManager,"nextPutAll:",0
,function(self,aString)
return ((self):log_(aString));
end
,"streaming","nextPutAll: aString\r\n\t\" Log aString when streaming. \"\r\n\r\n\t^self log: aString","function(self,aString)\r\nreturn ((self):log_(aString));\r\nend")

smalltalk:bind(smalltalk.SystemManager,"cr",0
,function(self)
return (self);
end
,"streaming","cr\r\n\t\" Ignore the output, we log as line oriented streaming service. \"","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SystemManager,"memoryWarning:",0
,function(self,anArgument)
return ((self):triggerEvent_with_("memoryWarning:",anArgument));
end
,"memory","memoryWarning: anArgument\r\n\t\" Trigger a memory warning event.\r\n\tThe execution environment can signal memory warning/low conditions, we trigger an event to be handled at application level.\r\n\tNote: It is frequent procedure to clean cached resources that can be reconstructed later, if required.\r\n\t\"\r\n\r\n\t^self triggerEvent: #memoryWarning: with: anArgument","function(self,anArgument)\r\nreturn ((self):triggerEvent_with_(\"memoryWarning:\",anArgument));\r\nend")

smalltalk:bind(smalltalk.SystemManager,"object:at:notFoundIn:",0
,function(self,anObject,indexOrKey,aCollection)
return ((self):triggerEvent_withArguments_ifNotHandled_("object:at:notFoundIn:",(smalltalk.Array):with_with_with_(anObject,indexOrKey,aCollection),(function()
return ((self):print_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Object/key("),smalltalk:toString_((smalltalk:if_true_false_((smalltalk:isNil_((indexOrKey))),(function()
return (anObject)
end),(function()
return (indexOrKey)
end)))))),") not found in ")),smalltalk:printString_((aCollection)))))
end)));
end
,"failures","object: anObject at: indexOrKey notFoundIn: aCollection\r\n\t\" Trigger a missing object event. \"\r\n\r\n\t^self triggerEvent: #object:at:notFoundIn:\r\n\t\twithArguments: (Array with: anObject with: indexOrKey with: aCollection)\r\n\t\tifNotHandled: [\r\n\t\t\tself print: 'Object/key('\r\n\t\t\t\t,(indexOrKey isNil ifTrue: [anObject] ifFalse: [indexOrKey]) toString\r\n\t\t\t\t,') not found in ',aCollection printString\r\n\t\t]","function(self,anObject,indexOrKey,aCollection)\r\nreturn ((self):triggerEvent_withArguments_ifNotHandled_(\"object:at:notFoundIn:\",(smalltalk.Array):with_with_with_(anObject,indexOrKey,aCollection),(function()\r\nreturn ((self):print_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Object/key(\"),smalltalk:toString_((smalltalk:if_true_false_((smalltalk:isNil_((indexOrKey))),(function()\r\nreturn (anObject)\r\nend),(function()\r\nreturn (indexOrKey)\r\nend)))))),\") not found in \")),smalltalk:printString_((aCollection)))))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"logEvaluate:",0
,function(self,source)
local result=nil
(function()
	local _s8_value=((self):evaluate())
	result=_s8_value
	return _s8_value
end)();
(smalltalk.SystemManager):log_(source);
return (result);
end
,"evaluating","logEvaluate: source\r\n\t\" Return the result of evaluating the receiver.\r\n\tLog the source expression as reference of evaluation.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := self evaluate.\r\n\tSystemManager log: source.\r\n\t^result","function(self,source)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):evaluate())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(smalltalk.SystemManager):log_(source);\r\nreturn (result);\r\nend")
