
Object
 subclass: #Transcript
 instanceVariableNames: #streams
 classVariableNames: #Current
 category: #Transcript!
Transcript comment: '
	Implement Transcript streamming.
	This implementation emmit output delegating onto stream instances.
	The streams must understand #cr and #nextPutAll:
'!
Transcript buildAccessors: #(
	#(streams initialize Array)
)!

! Transcript class methodsFor: #singleton !
current
	" Return the current instance of the receiver. "

	Current isNil ifTrue: [ self current: self new ].
	^Current! !

! Transcript class methodsFor: #singleton !
current: aTranscript
	" Set the current instance of the receiver. "

	Current := aTranscript! !

! Transcript class methodsFor: #io !
cr
	" Output a line break onto the current instance. "

	^self current cr!

nextPutAll: aString
	" Output aString onto the current instance. "

	^self current nextPutAll: aString!

show: aString
	" Output aString onto the current instance (ensure result is shown). "

	^self current show: aString! !

! Transcript methodsFor: #io !
cr
	" Output a line break onto the receiver. "

	self streams do: [:each| each cr ]!

nextPutAll: aString
	" Output aString onto the receiver. "

	self streams do: [:each| each nextPutAll: aString asString ]!

show: aString
	" Output aString onto the receiver (ensure result is shown). "

	self nextPutAll: aString! !

! Transcript methodsFor: #io !
flush
	" Flush the receiver. "

	self streams do: [:each|
		(each respondsTo: #flush) ifTrue: [ each flush ]
	]! !

! Transcript methodsFor: #query !
inUse
	" Return true if the receiver is in use. "

	^streams notNil and: [streams notEmpty]! !