
-- fileIn("s8/start/Transcript.st")
-- WARNING: class REdefinition for Transcript
smalltalk:addClass("Transcript",smalltalk.Object,smalltalk:newArray({"streams"}),"Transcript")
smalltalk.Transcript["$classVariableNames"]="Current"
smalltalk.Transcript["$comment"]="\r\n\tImplement Transcript streamming.\r\n\tThis implementation emmit output delegating onto stream instances.\r\n\tThe streams must understand #cr and #nextPutAll:\r\n"

smalltalk:bind(smalltalk.Transcript,"initializeStreams",0
,function(self)
(function()
	local _s8_value=((smalltalk.Array):new())
	self["@streams"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeStreams\r\n\t\" Private - Initialize the streams of the receiver. \"\r\n\r\n\tstreams := Array new","function(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@streams\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Transcript,"streams",0
,function(self)
if (smalltalk:isNil_((self["@streams"])))==true then (self):initializeStreams(); end;
return (self["@streams"]);
end
,"accessing","streams\r\n\t\" Return the streams of the receiver. \"\r\n\r\n\tstreams isNil ifTrue: [ self initializeStreams ].\r\n\t^streams","function(self)\r\nif (smalltalk:isNil_((self[\"@streams\"])))==true then (self):initializeStreams(); end;\r\nreturn (self[\"@streams\"]);\r\nend")

smalltalk:bind(smalltalk.Transcript,"streams:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@streams"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","streams: anObject\r\n\t\" Set the streams of the receiver. \"\r\n\r\n\tstreams := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@streams\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Transcript["$klass"],"current",0
,function(self)
if (smalltalk:isNil_((smalltalk.Transcript:classVariableAt_("Current"))))==true then (self):current_((self):new()); end;
return (smalltalk.Transcript:classVariableAt_("Current"));
end
,"singleton","current\r\n\t\" Return the current instance of the receiver. \"\r\n\r\n\tCurrent isNil ifTrue: [ self current: self new ].\r\n\t^Current","function(self)\r\nif (smalltalk:isNil_((smalltalk.Transcript:classVariableAt_(\"Current\"))))==true then (self):current_((self):new()); end;\r\nreturn (smalltalk.Transcript:classVariableAt_(\"Current\"));\r\nend")

smalltalk:bind(smalltalk.Transcript["$klass"],"current:",0
,function(self,aTranscript)
smalltalk.Transcript:classVariableAt_put_("Current",aTranscript);
return (self);
end
,"singleton","current: aTranscript\r\n\t\" Set the current instance of the receiver. \"\r\n\r\n\tCurrent := aTranscript","function(self,aTranscript)\r\nsmalltalk.Transcript:classVariableAt_put_(\"Current\",aTranscript);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Transcript["$klass"],"cr",0
,function(self)
return (((self):current()):cr());
end
,"io","cr\r\n\t\" Output a line break onto the current instance. \"\r\n\r\n\t^self current cr","function(self)\r\nreturn (((self):current()):cr());\r\nend")

smalltalk:bind(smalltalk.Transcript["$klass"],"nextPutAll:",0
,function(self,aString)
return (((self):current()):nextPutAll_(aString));
end
,"io","nextPutAll: aString\r\n\t\" Output aString onto the current instance. \"\r\n\r\n\t^self current nextPutAll: aString","function(self,aString)\r\nreturn (((self):current()):nextPutAll_(aString));\r\nend")

smalltalk:bind(smalltalk.Transcript["$klass"],"show:",0
,function(self,aString)
return (((self):current()):show_(aString));
end
,"io","show: aString\r\n\t\" Output aString onto the current instance (ensure result is shown). \"\r\n\r\n\t^self current show: aString","function(self,aString)\r\nreturn (((self):current()):show_(aString));\r\nend")

smalltalk:bind(smalltalk.Transcript,"cr",0
,function(self)
((self):streams()):do_((function(each)
return ((each):cr())
end));
return (self);
end
,"io","cr\r\n\t\" Output a line break onto the receiver. \"\r\n\r\n\tself streams do: [:each| each cr ]","function(self)\r\n((self):streams()):do_((function(each)\r\nreturn ((each):cr())\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Transcript,"nextPutAll:",0
,function(self,aString)
((self):streams()):do_((function(each)
return ((each):nextPutAll_(smalltalk:asString_((aString))))
end));
return (self);
end
,"io","nextPutAll: aString\r\n\t\" Output aString onto the receiver. \"\r\n\r\n\tself streams do: [:each| each nextPutAll: aString asString ]","function(self,aString)\r\n((self):streams()):do_((function(each)\r\nreturn ((each):nextPutAll_(smalltalk:asString_((aString))))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Transcript,"show:",0
,function(self,aString)
(self):nextPutAll_(aString);
return (self);
end
,"io","show: aString\r\n\t\" Output aString onto the receiver (ensure result is shown). \"\r\n\r\n\tself nextPutAll: aString","function(self,aString)\r\n(self):nextPutAll_(aString);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Transcript,"flush",0
,function(self)
((self):streams()):do_((function(each)
return (smalltalk:if_true_false_((smalltalk:responds_to_((each),("flush"))),(function()
return ((each):flush())
end),nil))
end));
return (self);
end
,"io","flush\r\n\t\" Flush the receiver. \"\r\n\r\n\tself streams do: [:each|\r\n\t\t(each respondsTo: #flush) ifTrue: [ each flush ]\r\n\t]","function(self)\r\n((self):streams()):do_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:responds_to_((each),(\"flush\"))),(function()\r\nreturn ((each):flush())\r\nend),nil))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Transcript,"inUse",0
,function(self)
return (smalltalk:boolean_and_((smalltalk:notNil_((self["@streams"]))),(function()
return ((self["@streams"]):notEmpty())
end)));
end
,"query","inUse\r\n\t\" Return true if the receiver is in use. \"\r\n\r\n\t^streams notNil and: [streams notEmpty]","function(self)\r\nreturn (smalltalk:boolean_and_((smalltalk:notNil_((self[\"@streams\"]))),(function()\r\nreturn ((self[\"@streams\"]):notEmpty())\r\nend)));\r\nend")
