
// fileIn("DOM.st")
smalltalk.addClass("DOM",smalltalk.NativeObject,[],"DOM");

smalltalk.DOM.$comment=unescape("%0D%0A%09Root%20of%20DOM%20framework%20w/HTML%20API.%0D%0A%09@2012%20Alejandro%20F.%20Reimondo%20-%20aleReimondo@smalltalking.net%0D%0A");

smalltalk.bind(smalltalk.DOM,"numberToPixel:",0
,function(aNumber){var self=this;
if (aNumber.isString()){return aNumber;};;
return aNumber.toString()._comma("px");}
,"converting",unescape("numberToPixel%3A%20aNumber%0D%0A%09%22%20Private%20-%20Return%20the%20pixels%20representation%20of%20aNumber.%20%22%0D%0A%0D%0A%09aNumber%20isString%20ifTrue%3A%20%5B%20%5EaNumber%20%5D.%0D%0A%09%5EaNumber%20toString%20%2C%23px"));

smalltalk.bind(smalltalk.DOM,"pixelToNumber:",0
,function(pixels){var self=this;
return (pixels.upTo_("px") || (0)).asNumber();}
,"converting",unescape("pixelToNumber%3A%20pixels%0D%0A%09%22%20Private%20-%20Return%20the%20pixels%20as%20aNumber.%20%22%0D%0A%0D%0A%09%5E%28%28pixels%20upTo%3A%20%23px%29%20%7C%7C%200%29%20asNumber"));

smalltalk.bind(smalltalk.DOM.$klass,"buildPixelSetter:",0
,function(aSelector){var self=this;
return self.build_doing_("PixelGetter"._minus_gt(aSelector),(function(){return self.implement_comment_as_category_(self.stMessageHeader_(aSelector)._comma(": aNumber"),"Set the "._comma(aSelector)._comma(" of the receiver."),"self handle basicAt: "._comma(self.nativeNameFromSelector_(aSelector).asLiteral())._comma(unescape("%20put%3A%20%28self%20numberToPixel%3A%20aNumber%29")),"accessing");}));}
,"builders",unescape("buildPixelSetter%3A%20aSelector%0D%0A%09%22%20Build%20%28instance%29%20method%20to%20get%20native%20property.%20%22%0D%0A%0D%0A%09%5Eself%20build%3A%20%23PixelGetter%20-%3E%20aSelector%20doing%3A%20%5B%0D%0A%09%09self%0D%0A%09%09%09implement%3A%20%28self%20stMessageHeader%3A%20aSelector%29%20%2C%27%3A%20aNumber%27%0D%0A%09%09%09comment%3A%20%27Set%20the%20%27%20%2CaSelector%20%2C%27%20of%20the%20receiver.%27%0D%0A%09%09%09as%3A%20%27self%20handle%20basicAt%3A%20%27%0D%0A%09%09%09%09%2C%28self%20nativeNameFromSelector%3A%20aSelector%29%20asLiteral%0D%0A%09%09%09%09%2C%20%27%20put%3A%20%28self%20numberToPixel%3A%20aNumber%29%27%0D%0A%09%09%09category%3A%20%23accessing%0D%0A%09%5D"));

smalltalk.bind(smalltalk.DOM.$klass,"buildPixelGetter:",0
,function(aSelector){var self=this;
return self.build_doing_("PixelGetter"._minus_gt(aSelector),(function(){return self.implement_comment_as_category_(self.stMessageHeader_(aSelector),"Return the "._comma(aSelector)._comma(" of the receiver."),unescape("%5Eself%20pixelToNumber%3A%20handle%23")._comma(self.nativeNameFromSelector_(aSelector)),"accessing");}));}
,"builders",unescape("buildPixelGetter%3A%20aSelector%0D%0A%09%22%20Build%20%28instance%29%20method%20to%20get%20native%20property.%20%22%0D%0A%0D%0A%09%5Eself%20build%3A%20%23PixelGetter%20-%3E%20aSelector%20doing%3A%20%5B%0D%0A%09%09self%0D%0A%09%09%09implement%3A%20%28self%20stMessageHeader%3A%20aSelector%29%0D%0A%09%09%09comment%3A%20%27Return%20the%20%27%20%2CaSelector%20%2C%27%20of%20the%20receiver.%27%0D%0A%09%09%09as%3A%20%27%5Eself%20pixelToNumber%3A%20handle%23%27%20%2C%28self%20nativeNameFromSelector%3A%20aSelector%29%0D%0A%09%09%09category%3A%20%23accessing%0D%0A%09%5D"));

smalltalk.bind(smalltalk.DOM.$klass,"buildPixelAccessor:",0
,function(accessor){var self=this;
if (accessor.isString()){return self.build_doing_("PixelAccessor"._minus_gt(accessor),(function(){return self.buildPixelGetter_(accessor)._comma(self.buildPixelSetter_(accessor));}));};;
return self.error_(unescape("Invalid%20%28Pixel%29accessors."));}
,"builders",unescape("buildPixelAccessor%3A%20accessor%0D%0A%09%22%20Build%20%28instance%29%20method%20to%20access%20native%20property.%20%22%0D%0A%0D%0A%09accessor%20isString%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20build%3A%20%23PixelAccessor%20-%3E%20accessor%20doing%3A%20%5B%0D%0A%09%09%09%28self%20buildPixelGetter%3A%20accessor%29%0D%0A%09%09%09%2C%28self%20buildPixelSetter%3A%20accessor%29%0D%0A%09%09%5D%0D%0A%09%5D.%0D%0A%09%5Eself%20error%3A%20%27Invalid%20%28Pixel%29accessors.%27"));

smalltalk.bind(smalltalk.DOM.$klass,"buildPixelGetters:",0
,function(specs){var self=this;
if (specs.isString()){return self.buildPixelGetters_(specs.asArrayOfSubstrings());};;
return self.build_doing_("PixelGetters"._minus_gt(specs),(function(){return specs.compose_((function(each){return self.buildPixelGetter_(each);}));}));}
,"builders",unescape("buildPixelGetters%3A%20specs%0D%0A%09%22%20Build%20methods%20to%20get%20properties.%20%22%0D%0A%0D%0A%09specs%20isString%20ifTrue%3A%20%5B%20%5Eself%20buildPixelGetters%3A%20specs%20asArrayOfSubstrings%20%5D.%0D%0A%09%5Eself%20build%3A%20%23PixelGetters%20-%3E%20specs%20doing%3A%20%5B%0D%0A%09%09specs%20compose%3A%20%5B%3Aeach%7C%20self%20buildPixelGetter%3A%20each%20%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.DOM.$klass,"buildPixelSetters:",0
,function(specs){var self=this;
if (specs.isString()){return self.buildPixelSetters_(specs.asArrayOfSubstrings());};;
return self.build_doing_("PixelSetters"._minus_gt(specs),(function(){return specs.compose_((function(each){return self.buildPixelSetter_(each);}));}));}
,"builders",unescape("buildPixelSetters%3A%20specs%0D%0A%09%22%20Build%20methods%20to%20set%20instances.%20%22%0D%0A%0D%0A%09specs%20isString%20ifTrue%3A%20%5B%20%5Eself%20buildPixelSetters%3A%20specs%20asArrayOfSubstrings%20%5D.%0D%0A%09%5Eself%20build%3A%20%23PixelSetters%20-%3E%20specs%20doing%3A%20%5B%0D%0A%09%09specs%20compose%3A%20%5B%3Aeach%7C%20self%20buildPixelSetter%3A%20each%20%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.DOM.$klass,"buildPixelAccessors:",0
,function(specs){var self=this;
if (specs.isString()){return self.buildPixelAccessors_(specs.asArrayOfSubstrings());};;
return self.build_doing_("PixelAccessors"._minus_gt(specs),(function(){return specs.compose_((function(each){return self.buildPixelAccessor_(each);}));}));}
,"builders",unescape("buildPixelAccessors%3A%20specs%0D%0A%09%22%20Build%20methods%20to%20access%20properties.%20%22%0D%0A%0D%0A%09specs%20isString%20ifTrue%3A%20%5B%20%5Eself%20buildPixelAccessors%3A%20specs%20asArrayOfSubstrings%20%5D.%0D%0A%09%5Eself%20build%3A%20%23PixelAccessors%20-%3E%20specs%20doing%3A%20%5B%0D%0A%09%09specs%20compose%3A%20%5B%3Aeach%7C%20self%20buildPixelAccessor%3A%20each%20%5D%0D%0A%09%5D"));

smalltalk.addClass("HTML5",smalltalk.DOM,[],"DOM-HTML5");

smalltalk.DOM.$comment=unescape("%0D%0A%09Root%20of%20HTML%20framework.%0D%0A%09http%3A//www.w3.org/TR/html5/webappapis.html%0D%0A%09http%3A//dev.w3.org/html5%0D%0A%09http%3A//www.w3.org/TR/html5/single-page.html%0D%0A%09@2012%20Alejandro%20F.%20Reimondo%20-%20aleReimondo@smalltalking.net%0D%0A");

smalltalk.addClass("BrowserObject",smalltalk.DOM,[],"DOM-Browser");

smalltalk.addClass("BrowserWindow",smalltalk.BrowserObject,[],"DOM-Browser");

smalltalk.addClass("BrowserHistory",smalltalk.BrowserObject,[],"DOM-Browser");

smalltalk.addClass("BrowserLocation",smalltalk.BrowserObject,[],"DOM-Browser");

smalltalk.addClass("BrowserNavigator",smalltalk.BrowserObject,[],"DOM-Browser");

smalltalk.addClass("BrowserScreen",smalltalk.BrowserObject,[],"DOM-Browser");

smalltalk.addClass("DOMDocument",smalltalk.DOM,[],"DOM");

smalltalk.addClass("DOMNode",smalltalk.DOM,[],"DOM");

smalltalk.addClass("DOMCharacterData",smalltalk.DOMNode,[],"DOM");

smalltalk.addClass("DOMText",smalltalk.DOMCharacterData,[],"DOM");

smalltalk.addClass("DOMElement",smalltalk.DOMNode,[],"DOM");
smalltalk.DOMElement.$classVariableNames="TagMap";

smalltalk.addClass("HTMLDocument",smalltalk.DOMDocument,[],"DOM-HTML");

smalltalk.addClass("DOMAttribute",smalltalk.DOMNode,[],"DOM-HTML");

smalltalk.addClass("HTMLElement",smalltalk.DOMElement,[],"DOM-HTML");

smalltalk.addClass("HTMLAnchor",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLAnchor.$klass,"tagName",0
,function(){var self=this;
return "A";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27A%27"));

smalltalk.addClass("HTMLApplet",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLApplet.$klass,"tagName",0
,function(){var self=this;
return "APPLET";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27APPLET%27"));

smalltalk.addClass("HTMLArea",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLArea.$klass,"tagName",0
,function(){var self=this;
return "AREA";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27AREA%27"));

smalltalk.addClass("HTMLBase",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLBase.$klass,"tagName",0
,function(){var self=this;
return "BASE";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27BASE%27"));

smalltalk.addClass("HTMLBaseFont",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLBaseFont.$klass,"tagName",0
,function(){var self=this;
return "BASEFONT";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27BASEFONT%27"));

smalltalk.addClass("HTMLBlockquote",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLBlockquote.$klass,"tagName",0
,function(){var self=this;
return "BLOCKQUOTE";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27BLOCKQUOTE%27"));

smalltalk.addClass("HTMLBody",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLBody.$klass,"tagName",0
,function(){var self=this;
return "BODY";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27BODY%27"));

smalltalk.addClass("HTMLBR",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLBR.$klass,"tagName",0
,function(){var self=this;
return "BR";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27BR%27"));

smalltalk.addClass("HTMLButton",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLButton.$klass,"tagName",0
,function(){var self=this;
return "BUTTON";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27BUTTON%27"));

smalltalk.addClass("HTMLCanvas",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLCanvas.$klass,"tagName",0
,function(){var self=this;
return "CANVAS";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27CANVAS%27"));

smalltalk.addClass("HTMLDirectory",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLDirectory.$klass,"tagName",0
,function(){var self=this;
return "DIR";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27DIR%27"));

smalltalk.addClass("HTMLDList",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLDList.$klass,"tagName",0
,function(){var self=this;
return "DL";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27DL%27"));

smalltalk.addClass("HTMLDiv",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLDiv.$klass,"tagName",0
,function(){var self=this;
return "DIV";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27DIV%27"));

smalltalk.addClass("HTMLFieldSet",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLFieldSet.$klass,"tagName",0
,function(){var self=this;
return "FIELDSET";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27FIELDSET%27"));

smalltalk.addClass("HTMLFont",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLFont.$klass,"tagName",0
,function(){var self=this;
return "FONT";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27FONT%27"));

smalltalk.addClass("HTMLForm",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLForm.$klass,"tagName",0
,function(){var self=this;
return "FORM";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27FORM%27"));

smalltalk.addClass("HTMLFrame",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLFrame.$klass,"tagName",0
,function(){var self=this;
return "FRAME";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27FRAME%27"));

smalltalk.addClass("HTMLFrameset",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLFrameset.$klass,"tagName",0
,function(){var self=this;
return "FRAMESET";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27FRAMESET%27"));

smalltalk.addClass("HTMLHeading",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLHeading.$klass,"tagName",0
,function(){var self=this;
return "HEADING";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27HEADING%27"));

smalltalk.addClass("HTMLHead",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLHead.$klass,"tagName",0
,function(){var self=this;
return "HEAD";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27HEAD%27"));

smalltalk.addClass("HTMLHR",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLHR.$klass,"tagName",0
,function(){var self=this;
return "HR";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27HR%27"));

smalltalk.addClass("HTMLPage",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLPage.$klass,"tagName",0
,function(){var self=this;
return "HTML";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27HTML%27"));

smalltalk.addClass("HTMLIFrame",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLIFrame.$klass,"tagName",0
,function(){var self=this;
return "IFRAME";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27IFRAME%27"));

smalltalk.addClass("HTMLImage",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLImage.$klass,"tagName",0
,function(){var self=this;
return "IMG";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27IMG%27"));

smalltalk.addClass("HTMLInput",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLInput.$klass,"tagName",0
,function(){var self=this;
return "INPUT";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27INPUT%27"));

smalltalk.addClass("HTMLIsIndex",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLIsIndex.$klass,"tagName",0
,function(){var self=this;
return "ISINDEX";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27ISINDEX%27"));

smalltalk.addClass("HTMLLabel",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLLabel.$klass,"tagName",0
,function(){var self=this;
return "LABEL";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27LABEL%27"));

smalltalk.addClass("HTMLLayer",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLLayer.$klass,"tagName",0
,function(){var self=this;
return "LAYER";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27LAYER%27"));

smalltalk.addClass("HTMLILayer",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLILayer.$klass,"tagName",0
,function(){var self=this;
return "ILAYER";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27ILAYER%27"));

smalltalk.addClass("HTMLLegend",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLLegend.$klass,"tagName",0
,function(){var self=this;
return "LEGEND";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27LEGEND%27"));

smalltalk.addClass("HTMLLI",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLLI.$klass,"tagName",0
,function(){var self=this;
return "LI";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27LI%27"));

smalltalk.addClass("HTMLLink",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLLink.$klass,"tagName",0
,function(){var self=this;
return "LINK";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27LINK%27"));

smalltalk.addClass("HTMLMap",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLMap.$klass,"tagName",0
,function(){var self=this;
return "MAP";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27MAP%27"));

smalltalk.addClass("HTMLMenu",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLMenu.$klass,"tagName",0
,function(){var self=this;
return "MENU";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27MENU%27"));

smalltalk.addClass("HTMLMeta",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLMeta.$klass,"tagName",0
,function(){var self=this;
return "META";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27META%27"));

smalltalk.addClass("HTMLMod",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLMod.$klass,"tagName",0
,function(){var self=this;
return "MOD";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27MOD%27"));

smalltalk.addClass("HTMLObject",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLObject.$klass,"tagName",0
,function(){var self=this;
return "OBJECT";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27OBJECT%27"));

smalltalk.addClass("HTMLOList",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLOList.$klass,"tagName",0
,function(){var self=this;
return "OL";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27OL%27"));

smalltalk.addClass("HTMLOptGroup",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLOptGroup.$klass,"tagName",0
,function(){var self=this;
return "OPTGROUP";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27OPTGROUP%27"));

smalltalk.addClass("HTMLOption",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLOption.$klass,"tagName",0
,function(){var self=this;
return "OPTION";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27OPTION%27"));

smalltalk.addClass("HTMLParagraph",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLParagraph.$klass,"tagName",0
,function(){var self=this;
return "P";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27P%27"));

smalltalk.addClass("HTMLParam",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLParam.$klass,"tagName",0
,function(){var self=this;
return "PARAM";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27PARAM%27"));

smalltalk.addClass("HTMLPre",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLPre.$klass,"tagName",0
,function(){var self=this;
return "PRE";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27PRE%27"));

smalltalk.addClass("HTMLQuote",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLQuote.$klass,"tagName",0
,function(){var self=this;
return "Q";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27Q%27"));

smalltalk.addClass("HTMLScript",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLScript.$klass,"tagName",0
,function(){var self=this;
return "SCRIPT";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27SCRIPT%27"));

smalltalk.addClass("HTMLSelect",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLSelect.$klass,"tagName",0
,function(){var self=this;
return "SELECT";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27SELECT%27"));

smalltalk.addClass("HTMLStyle",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLStyle.$klass,"tagName",0
,function(){var self=this;
return "STYLE";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27STYLE%27"));

smalltalk.addClass("HTMLSpan",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLSpan.$klass,"tagName",0
,function(){var self=this;
return "SPAN";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27SPAN%27"));

smalltalk.addClass("HTMLTable",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLTable.$klass,"tagName",0
,function(){var self=this;
return "TABLE";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27TABLE%27"));

smalltalk.addClass("HTMLTableCaption",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLTableCaption.$klass,"tagName",0
,function(){var self=this;
return "CAPTION";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27CAPTION%27"));

smalltalk.addClass("HTMLTableCell",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLTableCell.$klass,"tagName",0
,function(){var self=this;
return "TD";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27TD%27"));

smalltalk.addClass("HTMLTableCol",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLTableCol.$klass,"tagName",0
,function(){var self=this;
return "COL";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27COL%27"));

smalltalk.addClass("HTMLTableRow",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLTableRow.$klass,"tagName",0
,function(){var self=this;
return "TR";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27TR%27"));

smalltalk.addClass("HTMLTbody",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLTbody.$klass,"tagName",0
,function(){var self=this;
return "TBODY";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27TBODY%27"));

smalltalk.addClass("HTMLTfoot",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLTfoot.$klass,"tagName",0
,function(){var self=this;
return "TFOOT";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27TFOOT%27"));

smalltalk.addClass("HTMLThead",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLThead.$klass,"tagName",0
,function(){var self=this;
return "THEAD";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27THEAD%27"));

smalltalk.addClass("HTMLTextarea",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLTextarea.$klass,"tagName",0
,function(){var self=this;
return "TEXTAREA";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27TEXTAREA%27"));

smalltalk.addClass("HTMLTitle",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLTitle.$klass,"tagName",0
,function(){var self=this;
return "TITLE";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27TITLE%27"));

smalltalk.addClass("HTMLUList",smalltalk.HTMLElement,[],"DOM-HTML");

smalltalk.bind(smalltalk.HTMLUList.$klass,"tagName",0
,function(){var self=this;
return "UL";}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%27UL%27"));

smalltalk.addClass("HTMLInputButton",smalltalk.HTMLInput,[],"DOM-HTML");

smalltalk.addClass("HTMLInputCheckbox",smalltalk.HTMLInput,[],"DOM-HTML");

smalltalk.addClass("HTMLInputFile",smalltalk.HTMLInput,[],"DOM-HTML");

smalltalk.addClass("HTMLInputHidden",smalltalk.HTMLInput,[],"DOM-HTML");

smalltalk.addClass("HTMLInputRadio",smalltalk.HTMLInput,[],"DOM-HTML");

smalltalk.addClass("HTMLInputText",smalltalk.HTMLInput,[],"DOM-HTML");

smalltalk.addClass("HTMLInputReset",smalltalk.HTMLInputButton,[],"DOM-HTML");

smalltalk.addClass("HTMLInputSubmit",smalltalk.HTMLInputButton,[],"DOM-HTML");

smalltalk.addClass("HTMLInputPassword",smalltalk.HTMLInputText,[],"DOM-HTML");

smalltalk.bind(smalltalk.BrowserWindow,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.BrowserWindow,"name:",0
,function(anObject){var self=this;
(self.handle()["name"]=(anObject));
return self;}
,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23name%20put%3A%20anObject"));

smalltalk.bind(smalltalk.BrowserWindow,"outerHeight",0
,function(){var self=this;
return (self["@handle"].outerHeight || (0));}
,"accessing",unescape("outerHeight%0D%0A%09%22%20Return%20the%20outerHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outerHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"outerHeight:",0
,function(anObject){var self=this;
(self.handle()["outerHeight"]=(anObject));
return self;}
,"accessing",unescape("outerHeight%3A%20anObject%0D%0A%09%22%20Set%20the%20outerHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23outerHeight%20put%3A%20anObject"));

smalltalk.bind(smalltalk.BrowserWindow,"outerWidth",0
,function(){var self=this;
return (self["@handle"].outerWidth || (0));}
,"accessing",unescape("outerWidth%0D%0A%09%22%20Return%20the%20outerWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outerWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"outerWidth:",0
,function(anObject){var self=this;
(self.handle()["outerWidth"]=(anObject));
return self;}
,"accessing",unescape("outerWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20outerWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23outerWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.BrowserWindow,"innerHeight",0
,function(){var self=this;
return (self["@handle"].innerHeight || (0));}
,"accessing",unescape("innerHeight%0D%0A%09%22%20Return%20the%20innerHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23innerHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"innerHeight:",0
,function(anObject){var self=this;
(self.handle()["innerHeight"]=(anObject));
return self;}
,"accessing",unescape("innerHeight%3A%20anObject%0D%0A%09%22%20Set%20the%20innerHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23innerHeight%20put%3A%20anObject"));

smalltalk.bind(smalltalk.BrowserWindow,"innerWidth",0
,function(){var self=this;
return (self["@handle"].innerWidth || (0));}
,"accessing",unescape("innerWidth%0D%0A%09%22%20Return%20the%20innerWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23innerWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"innerWidth:",0
,function(anObject){var self=this;
(self.handle()["innerWidth"]=(anObject));
return self;}
,"accessing",unescape("innerWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20innerWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23innerWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.BrowserWindow,"pageXOffset",0
,function(){var self=this;
return (self["@handle"].pageXOffset || (0));}
,"accessing",unescape("pageXOffset%0D%0A%09%22%20Return%20the%20pageXOffset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pageXOffset%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"pageYOffset",0
,function(){var self=this;
return (self["@handle"].pageYOffset || (0));}
,"accessing",unescape("pageYOffset%0D%0A%09%22%20Return%20the%20pageYOffset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pageYOffset%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"screenLeft",0
,function(){var self=this;
return (self["@handle"].screenLeft || (0));}
,"accessing",unescape("screenLeft%0D%0A%09%22%20Return%20the%20screenLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23screenLeft%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"screenTop",0
,function(){var self=this;
return (self["@handle"].screenTop || (0));}
,"accessing",unescape("screenTop%0D%0A%09%22%20Return%20the%20screenTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23screenTop%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"screenX",0
,function(){var self=this;
return (self["@handle"].screenX || (0));}
,"accessing",unescape("screenX%0D%0A%09%22%20Return%20the%20screenX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23screenX%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"screenY",0
,function(){var self=this;
return (self["@handle"].screenY || (0));}
,"accessing",unescape("screenY%0D%0A%09%22%20Return%20the%20screenY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23screenY%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"scrollX",0
,function(){var self=this;
return (self["@handle"].scrollX || (0));}
,"accessing",unescape("scrollX%0D%0A%09%22%20Return%20the%20scrollX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23scrollX%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserWindow,"scrollY",0
,function(){var self=this;
return (self["@handle"].scrollY || (0));}
,"accessing",unescape("scrollY%0D%0A%09%22%20Return%20the%20scrollY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23scrollY%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserLocation,"hash",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["hash"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("hash%0D%0A%09%22%20Return%20the%20hash%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23hash"));

smalltalk.bind(smalltalk.BrowserLocation,"host",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["host"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("host%0D%0A%09%22%20Return%20the%20host%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23host"));

smalltalk.bind(smalltalk.BrowserLocation,"hostname",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["hostname"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("hostname%0D%0A%09%22%20Return%20the%20hostname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23hostname"));

smalltalk.bind(smalltalk.BrowserLocation,"href",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["href"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("href%0D%0A%09%22%20Return%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23href"));

smalltalk.bind(smalltalk.BrowserLocation,"pathname",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["pathname"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("pathname%0D%0A%09%22%20Return%20the%20pathname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23pathname"));

smalltalk.bind(smalltalk.BrowserLocation,"port",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["port"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("port%0D%0A%09%22%20Return%20the%20port%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23port"));

smalltalk.bind(smalltalk.BrowserLocation,"protocol",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["protocol"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("protocol%0D%0A%09%22%20Return%20the%20protocol%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23protocol"));

smalltalk.bind(smalltalk.BrowserLocation,"search",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["search"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("search%0D%0A%09%22%20Return%20the%20search%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23search"));

smalltalk.bind(smalltalk.BrowserNavigator,"appCodeName",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["appCodeName"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("appCodeName%0D%0A%09%22%20Return%20the%20appCodeName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23appCodeName"));

smalltalk.bind(smalltalk.BrowserNavigator,"appName",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["appName"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("appName%0D%0A%09%22%20Return%20the%20appName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23appName"));

smalltalk.bind(smalltalk.BrowserNavigator,"appVersion",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["appVersion"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("appVersion%0D%0A%09%22%20Return%20the%20appVersion%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23appVersion"));

smalltalk.bind(smalltalk.BrowserNavigator,"platform",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["platform"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("platform%0D%0A%09%22%20Return%20the%20platform%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23platform"));

smalltalk.bind(smalltalk.BrowserNavigator,"userAgent",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["userAgent"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("userAgent%0D%0A%09%22%20Return%20the%20userAgent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23userAgent"));

smalltalk.bind(smalltalk.BrowserNavigator,"cookieEnabled",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["cookieEnabled"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("cookieEnabled%0D%0A%09%22%20Return%20the%20cookieEnabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23cookieEnabled"));

smalltalk.bind(smalltalk.BrowserScreen,"width",0
,function(){var self=this;
return (self["@handle"].width || (0));}
,"accessing",unescape("width%0D%0A%09%22%20Return%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23width%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserScreen,"height",0
,function(){var self=this;
return (self["@handle"].height || (0));}
,"accessing",unescape("height%0D%0A%09%22%20Return%20the%20height%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23height%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserScreen,"pixelDepth",0
,function(){var self=this;
return (self["@handle"].pixelDepth || (0));}
,"accessing",unescape("pixelDepth%0D%0A%09%22%20Return%20the%20pixelDepth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pixelDepth%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserScreen,"colorDepth",0
,function(){var self=this;
return (self["@handle"].colorDepth || (0));}
,"accessing",unescape("colorDepth%0D%0A%09%22%20Return%20the%20colorDepth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23colorDepth%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserScreen,"availWidth",0
,function(){var self=this;
return (self["@handle"].availWidth || (0));}
,"accessing",unescape("availWidth%0D%0A%09%22%20Return%20the%20availWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23availWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.BrowserScreen,"availHeight",0
,function(){var self=this;
return (self["@handle"].availHeight || (0));}
,"accessing",unescape("availHeight%0D%0A%09%22%20Return%20the%20availHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23availHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLDocument,"documentMode",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["documentMode"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("documentMode%0D%0A%09%22%20Return%20the%20documentMode%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23documentMode"));

smalltalk.bind(smalltalk.HTMLDocument,"domain",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["domain"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("domain%0D%0A%09%22%20Return%20the%20domain%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23domain"));

smalltalk.bind(smalltalk.HTMLDocument,"lastModified",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["lastModified"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("lastModified%0D%0A%09%22%20Return%20the%20lastModified%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23lastModified"));

smalltalk.bind(smalltalk.HTMLDocument,"readyState",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["readyState"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("readyState%0D%0A%09%22%20Return%20the%20readyState%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23readyState"));

smalltalk.bind(smalltalk.HTMLDocument,"referrer",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["referrer"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("referrer%0D%0A%09%22%20Return%20the%20referrer%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23referrer"));

smalltalk.bind(smalltalk.HTMLDocument,"title",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["title"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("title%0D%0A%09%22%20Return%20the%20title%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23title"));

smalltalk.bind(smalltalk.HTMLDocument,"title:",0
,function(anObject){var self=this;
(self.handle()["title"]=(anObject));
return self;}
,"accessing",unescape("title%3A%20anObject%0D%0A%09%22%20Set%20the%20title%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23title%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLDocument,"cookie",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["cookie"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("cookie%0D%0A%09%22%20Return%20the%20cookie%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23cookie"));

smalltalk.bind(smalltalk.HTMLDocument,"cookie:",0
,function(anObject){var self=this;
(self.handle()["cookie"]=(anObject));
return self;}
,"accessing",unescape("cookie%3A%20anObject%0D%0A%09%22%20Set%20the%20cookie%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23cookie%20put%3A%20anObject"));

smalltalk.bind(smalltalk.DOMNode,"firstChild",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["firstChild"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("firstChild%0D%0A%09%22%20Return%20the%20firstChild%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23firstChild"));

smalltalk.bind(smalltalk.DOMNode,"lastChild",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["lastChild"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("lastChild%0D%0A%09%22%20Return%20the%20lastChild%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23lastChild"));

smalltalk.bind(smalltalk.DOMNode,"nodeName",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["nodeName"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("nodeName%0D%0A%09%22%20Return%20the%20nodeName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23nodeName"));

smalltalk.bind(smalltalk.DOMNode,"nodeType",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["nodeType"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("nodeType%0D%0A%09%22%20Return%20the%20nodeType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23nodeType"));

smalltalk.bind(smalltalk.DOMNode,"nodeValue",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["nodeValue"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("nodeValue%0D%0A%09%22%20Return%20the%20nodeValue%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23nodeValue"));

smalltalk.bind(smalltalk.DOMAttribute,"baseURI",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["baseURI"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("baseURI%0D%0A%09%22%20Return%20the%20baseURI%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23baseURI"));

smalltalk.bind(smalltalk.DOMAttribute,"isId",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["isId"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("isId%0D%0A%09%22%20Return%20the%20isId%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23isId"));

smalltalk.bind(smalltalk.DOMAttribute,"localName",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["localName"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("localName%0D%0A%09%22%20Return%20the%20localName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23localName"));

smalltalk.bind(smalltalk.DOMAttribute,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.DOMAttribute,"namespaceURI",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["namespaceURI"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("namespaceURI%0D%0A%09%22%20Return%20the%20namespaceURI%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23namespaceURI"));

smalltalk.bind(smalltalk.DOMAttribute,"ownerDocument",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["ownerDocument"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("ownerDocument%0D%0A%09%22%20Return%20the%20ownerDocument%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23ownerDocument"));

smalltalk.bind(smalltalk.DOMAttribute,"ownerElement",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["ownerElement"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("ownerElement%0D%0A%09%22%20Return%20the%20ownerElement%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23ownerElement"));

smalltalk.bind(smalltalk.DOMAttribute,"prefix",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["prefix"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("prefix%0D%0A%09%22%20Return%20the%20prefix%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23prefix"));

smalltalk.bind(smalltalk.DOMAttribute,"specified",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["specified"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("specified%0D%0A%09%22%20Return%20the%20specified%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23specified"));

smalltalk.bind(smalltalk.DOMAttribute,"textContent",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["textContent"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("textContent%0D%0A%09%22%20Return%20the%20textContent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23textContent"));

smalltalk.bind(smalltalk.DOMAttribute,"value",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["value"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23value"));

smalltalk.bind(smalltalk.DOMCharacterData,"data",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["data"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("data%0D%0A%09%22%20Return%20the%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23data"));

smalltalk.bind(smalltalk.DOMCharacterData,"length",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["length"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("length%0D%0A%09%22%20Return%20the%20length%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23length"));

smalltalk.bind(smalltalk.DOMElement,"tagName",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["tagName"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("tagName%0D%0A%09%22%20Return%20the%20tagName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23tagName"));

smalltalk.bind(smalltalk.HTMLElement,"accessKey",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["accessKey"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("accessKey%0D%0A%09%22%20Return%20the%20accessKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23accessKey"));

smalltalk.bind(smalltalk.HTMLElement,"accessKey:",0
,function(anObject){var self=this;
(self.handle()["accessKey"]=(anObject));
return self;}
,"accessing",unescape("accessKey%3A%20anObject%0D%0A%09%22%20Set%20the%20accessKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23accessKey%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"className",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["className"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("className%0D%0A%09%22%20Return%20the%20className%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23className"));

smalltalk.bind(smalltalk.HTMLElement,"className:",0
,function(anObject){var self=this;
(self.handle()["className"]=(anObject));
return self;}
,"accessing",unescape("className%3A%20anObject%0D%0A%09%22%20Set%20the%20className%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23className%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"dir",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["dir"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("dir%0D%0A%09%22%20Return%20the%20dir%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23dir"));

smalltalk.bind(smalltalk.HTMLElement,"dir:",0
,function(anObject){var self=this;
(self.handle()["dir"]=(anObject));
return self;}
,"accessing",unescape("dir%3A%20anObject%0D%0A%09%22%20Set%20the%20dir%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23dir%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"id",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["id"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("id%0D%0A%09%22%20Return%20the%20id%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23id"));

smalltalk.bind(smalltalk.HTMLElement,"id:",0
,function(anObject){var self=this;
(self.handle()["id"]=(anObject));
return self;}
,"accessing",unescape("id%3A%20anObject%0D%0A%09%22%20Set%20the%20id%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23id%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"innerHTML",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["innerHTML"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("innerHTML%0D%0A%09%22%20Return%20the%20innerHTML%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23innerHTML"));

smalltalk.bind(smalltalk.HTMLElement,"innerHTML:",0
,function(anObject){var self=this;
(self.handle()["innerHTML"]=(anObject));
return self;}
,"accessing",unescape("innerHTML%3A%20anObject%0D%0A%09%22%20Set%20the%20innerHTML%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23innerHTML%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"lang",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["lang"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("lang%0D%0A%09%22%20Return%20the%20lang%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23lang"));

smalltalk.bind(smalltalk.HTMLElement,"lang:",0
,function(anObject){var self=this;
(self.handle()["lang"]=(anObject));
return self;}
,"accessing",unescape("lang%3A%20anObject%0D%0A%09%22%20Set%20the%20lang%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23lang%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"title",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["title"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("title%0D%0A%09%22%20Return%20the%20title%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23title"));

smalltalk.bind(smalltalk.HTMLElement,"title:",0
,function(anObject){var self=this;
(self.handle()["title"]=(anObject));
return self;}
,"accessing",unescape("title%3A%20anObject%0D%0A%09%22%20Set%20the%20title%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23title%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"uniqueID",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["uniqueID"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("uniqueID%0D%0A%09%22%20Return%20the%20uniqueID%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23uniqueID"));

smalltalk.bind(smalltalk.HTMLElement,"uniqueID:",0
,function(anObject){var self=this;
(self.handle()["uniqueID"]=(anObject));
return self;}
,"accessing",unescape("uniqueID%3A%20anObject%0D%0A%09%22%20Set%20the%20uniqueID%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23uniqueID%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"draggable",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["draggable"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("draggable%0D%0A%09%22%20Return%20the%20draggable%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23draggable"));

smalltalk.bind(smalltalk.HTMLElement,"draggable:",0
,function(anObject){var self=this;
(self.handle()["draggable"]=(anObject));
return self;}
,"accessing",unescape("draggable%3A%20anObject%0D%0A%09%22%20Set%20the%20draggable%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23draggable%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"contentEditable",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["contentEditable"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("contentEditable%0D%0A%09%22%20Return%20the%20contentEditable%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23contentEditable"));

smalltalk.bind(smalltalk.HTMLElement,"contentEditable:",0
,function(anObject){var self=this;
(self.handle()["contentEditable"]=(anObject));
return self;}
,"accessing",unescape("contentEditable%3A%20anObject%0D%0A%09%22%20Set%20the%20contentEditable%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23contentEditable%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"spellcheck",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["spellcheck"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("spellcheck%0D%0A%09%22%20Return%20the%20spellcheck%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23spellcheck"));

smalltalk.bind(smalltalk.HTMLElement,"spellcheck:",0
,function(anObject){var self=this;
(self.handle()["spellcheck"]=(anObject));
return self;}
,"accessing",unescape("spellcheck%3A%20anObject%0D%0A%09%22%20Set%20the%20spellcheck%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23spellcheck%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"disabled",0
,function(){var self=this;
return (nil.is_eqeq_(true,self["@handle"].disabled));}
,"accessing",unescape("disabled%0D%0A%09%22%20Return%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Etrue%20%3D%3D%20handle%23disabled"));

smalltalk.bind(smalltalk.HTMLElement,"disabled:",0
,function(anObject){var self=this;
(self.handle()["disabled"]=(anObject));
return self;}
,"accessing",unescape("disabled%3A%20anObject%0D%0A%09%22%20Set%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23disabled%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"hidden",0
,function(){var self=this;
return (nil.is_eqeq_(true,self["@handle"].hidden));}
,"accessing",unescape("hidden%0D%0A%09%22%20Return%20the%20hidden%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Etrue%20%3D%3D%20handle%23hidden"));

smalltalk.bind(smalltalk.HTMLElement,"hidden:",0
,function(anObject){var self=this;
(self.handle()["hidden"]=(anObject));
return self;}
,"accessing",unescape("hidden%3A%20anObject%0D%0A%09%22%20Set%20the%20hidden%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23hidden%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"clientWidth",0
,function(){var self=this;
return (self["@handle"].clientWidth || (0));}
,"accessing",unescape("clientWidth%0D%0A%09%22%20Return%20the%20clientWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23clientWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"clientWidth:",0
,function(anObject){var self=this;
(self.handle()["clientWidth"]=(anObject));
return self;}
,"accessing",unescape("clientWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20clientWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23clientWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"clientHeight",0
,function(){var self=this;
return (self["@handle"].clientHeight || (0));}
,"accessing",unescape("clientHeight%0D%0A%09%22%20Return%20the%20clientHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23clientHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"clientHeight:",0
,function(anObject){var self=this;
(self.handle()["clientHeight"]=(anObject));
return self;}
,"accessing",unescape("clientHeight%3A%20anObject%0D%0A%09%22%20Set%20the%20clientHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23clientHeight%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"height",0
,function(){var self=this;
return (self["@handle"].height || (0));}
,"accessing",unescape("height%0D%0A%09%22%20Return%20the%20height%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23height%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"height:",0
,function(anObject){var self=this;
(self.handle()["height"]=(anObject));
return self;}
,"accessing",unescape("height%3A%20anObject%0D%0A%09%22%20Set%20the%20height%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23height%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"width",0
,function(){var self=this;
return (self["@handle"].width || (0));}
,"accessing",unescape("width%0D%0A%09%22%20Return%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23width%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"width:",0
,function(anObject){var self=this;
(self.handle()["width"]=(anObject));
return self;}
,"accessing",unescape("width%3A%20anObject%0D%0A%09%22%20Set%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23width%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"tabIndex",0
,function(){var self=this;
return (self["@handle"].tabIndex || (0));}
,"accessing",unescape("tabIndex%0D%0A%09%22%20Return%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23tabIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"tabIndex:",0
,function(anObject){var self=this;
(self.handle()["tabIndex"]=(anObject));
return self;}
,"accessing",unescape("tabIndex%3A%20anObject%0D%0A%09%22%20Set%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23tabIndex%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLElement,"length",0
,function(){var self=this;
return (self["@handle"].length || (0));}
,"accessing",unescape("length%0D%0A%09%22%20Return%20the%20length%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23length%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"offsetParent",0
,function(){var self=this;
return (self["@handle"].offsetParent || (0));}
,"accessing",unescape("offsetParent%0D%0A%09%22%20Return%20the%20offsetParent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23offsetParent%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"offsetLeft",0
,function(){var self=this;
return (self["@handle"].offsetLeft || (0));}
,"accessing",unescape("offsetLeft%0D%0A%09%22%20Return%20the%20offsetLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23offsetLeft%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"offsetTop",0
,function(){var self=this;
return (self["@handle"].offsetTop || (0));}
,"accessing",unescape("offsetTop%0D%0A%09%22%20Return%20the%20offsetTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23offsetTop%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"offsetWidth",0
,function(){var self=this;
return (self["@handle"].offsetWidth || (0));}
,"accessing",unescape("offsetWidth%0D%0A%09%22%20Return%20the%20offsetWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23offsetWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"offsetHeight",0
,function(){var self=this;
return (self["@handle"].offsetHeight || (0));}
,"accessing",unescape("offsetHeight%0D%0A%09%22%20Return%20the%20offsetHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23offsetHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"scrollLeft",0
,function(){var self=this;
return (self["@handle"].scrollLeft || (0));}
,"accessing",unescape("scrollLeft%0D%0A%09%22%20Return%20the%20scrollLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23scrollLeft%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"scrollTop",0
,function(){var self=this;
return (self["@handle"].scrollTop || (0));}
,"accessing",unescape("scrollTop%0D%0A%09%22%20Return%20the%20scrollTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23scrollTop%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"scrollWidth",0
,function(){var self=this;
return (self["@handle"].scrollWidth || (0));}
,"accessing",unescape("scrollWidth%0D%0A%09%22%20Return%20the%20scrollWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23scrollWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLElement,"scrollHeight",0
,function(){var self=this;
return (self["@handle"].scrollHeight || (0));}
,"accessing",unescape("scrollHeight%0D%0A%09%22%20Return%20the%20scrollHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23scrollHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLAnchor,"charset",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["charset"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("charset%0D%0A%09%22%20Return%20the%20charset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23charset"));

smalltalk.bind(smalltalk.HTMLAnchor,"charset:",0
,function(anObject){var self=this;
(self.handle()["charset"]=(anObject));
return self;}
,"accessing",unescape("charset%3A%20anObject%0D%0A%09%22%20Set%20the%20charset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23charset%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"coords",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["coords"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("coords%0D%0A%09%22%20Return%20the%20coords%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23coords"));

smalltalk.bind(smalltalk.HTMLAnchor,"coords:",0
,function(anObject){var self=this;
(self.handle()["coords"]=(anObject));
return self;}
,"accessing",unescape("coords%3A%20anObject%0D%0A%09%22%20Set%20the%20coords%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23coords%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"href",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["href"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("href%0D%0A%09%22%20Return%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23href"));

smalltalk.bind(smalltalk.HTMLAnchor,"href:",0
,function(anObject){var self=this;
(self.handle()["href"]=(anObject));
return self;}
,"accessing",unescape("href%3A%20anObject%0D%0A%09%22%20Set%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23href%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"hreflang",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["hreflang"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("hreflang%0D%0A%09%22%20Return%20the%20hreflang%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23hreflang"));

smalltalk.bind(smalltalk.HTMLAnchor,"hreflang:",0
,function(anObject){var self=this;
(self.handle()["hreflang"]=(anObject));
return self;}
,"accessing",unescape("hreflang%3A%20anObject%0D%0A%09%22%20Set%20the%20hreflang%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23hreflang%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.HTMLAnchor,"name:",0
,function(anObject){var self=this;
(self.handle()["name"]=(anObject));
return self;}
,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23name%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"rel",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["rel"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("rel%0D%0A%09%22%20Return%20the%20rel%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23rel"));

smalltalk.bind(smalltalk.HTMLAnchor,"rel:",0
,function(anObject){var self=this;
(self.handle()["rel"]=(anObject));
return self;}
,"accessing",unescape("rel%3A%20anObject%0D%0A%09%22%20Set%20the%20rel%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23rel%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"rev",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["rev"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("rev%0D%0A%09%22%20Return%20the%20rev%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23rev"));

smalltalk.bind(smalltalk.HTMLAnchor,"rev:",0
,function(anObject){var self=this;
(self.handle()["rev"]=(anObject));
return self;}
,"accessing",unescape("rev%3A%20anObject%0D%0A%09%22%20Set%20the%20rev%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23rev%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"shape",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["shape"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("shape%0D%0A%09%22%20Return%20the%20shape%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23shape"));

smalltalk.bind(smalltalk.HTMLAnchor,"shape:",0
,function(anObject){var self=this;
(self.handle()["shape"]=(anObject));
return self;}
,"accessing",unescape("shape%3A%20anObject%0D%0A%09%22%20Set%20the%20shape%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23shape%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"target",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["target"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23target"));

smalltalk.bind(smalltalk.HTMLAnchor,"target:",0
,function(anObject){var self=this;
(self.handle()["target"]=(anObject));
return self;}
,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23target%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"text",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["text"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("text%0D%0A%09%22%20Return%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23text"));

smalltalk.bind(smalltalk.HTMLAnchor,"text:",0
,function(anObject){var self=this;
(self.handle()["text"]=(anObject));
return self;}
,"accessing",unescape("text%3A%20anObject%0D%0A%09%22%20Set%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23text%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"type",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["type"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23type"));

smalltalk.bind(smalltalk.HTMLAnchor,"type:",0
,function(anObject){var self=this;
(self.handle()["type"]=(anObject));
return self;}
,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23type%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLAnchor,"tabIndex",0
,function(){var self=this;
return (self["@handle"].tabIndex || (0));}
,"accessing",unescape("tabIndex%0D%0A%09%22%20Return%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23tabIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLAnchor,"tabIndex:",0
,function(anObject){var self=this;
(self.handle()["tabIndex"]=(anObject));
return self;}
,"accessing",unescape("tabIndex%3A%20anObject%0D%0A%09%22%20Set%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23tabIndex%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"align",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["align"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23align"));

smalltalk.bind(smalltalk.HTMLApplet,"align:",0
,function(anObject){var self=this;
(self.handle()["align"]=(anObject));
return self;}
,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23align%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"alt",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["alt"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("alt%0D%0A%09%22%20Return%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23alt"));

smalltalk.bind(smalltalk.HTMLApplet,"alt:",0
,function(anObject){var self=this;
(self.handle()["alt"]=(anObject));
return self;}
,"accessing",unescape("alt%3A%20anObject%0D%0A%09%22%20Set%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23alt%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"archive",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["archive"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("archive%0D%0A%09%22%20Return%20the%20archive%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23archive"));

smalltalk.bind(smalltalk.HTMLApplet,"archive:",0
,function(anObject){var self=this;
(self.handle()["archive"]=(anObject));
return self;}
,"accessing",unescape("archive%3A%20anObject%0D%0A%09%22%20Set%20the%20archive%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23archive%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"code",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["code"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("code%0D%0A%09%22%20Return%20the%20code%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23code"));

smalltalk.bind(smalltalk.HTMLApplet,"code:",0
,function(anObject){var self=this;
(self.handle()["code"]=(anObject));
return self;}
,"accessing",unescape("code%3A%20anObject%0D%0A%09%22%20Set%20the%20code%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23code%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"codeBase",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["codeBase"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("codeBase%0D%0A%09%22%20Return%20the%20codeBase%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23codeBase"));

smalltalk.bind(smalltalk.HTMLApplet,"codeBase:",0
,function(anObject){var self=this;
(self.handle()["codeBase"]=(anObject));
return self;}
,"accessing",unescape("codeBase%3A%20anObject%0D%0A%09%22%20Set%20the%20codeBase%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23codeBase%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"hspace",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["hspace"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("hspace%0D%0A%09%22%20Return%20the%20hspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23hspace"));

smalltalk.bind(smalltalk.HTMLApplet,"hspace:",0
,function(anObject){var self=this;
(self.handle()["hspace"]=(anObject));
return self;}
,"accessing",unescape("hspace%3A%20anObject%0D%0A%09%22%20Set%20the%20hspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23hspace%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.HTMLApplet,"name:",0
,function(anObject){var self=this;
(self.handle()["name"]=(anObject));
return self;}
,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23name%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"object",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["object"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("object%0D%0A%09%22%20Return%20the%20object%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23object"));

smalltalk.bind(smalltalk.HTMLApplet,"object:",0
,function(anObject){var self=this;
(self.handle()["object"]=(anObject));
return self;}
,"accessing",unescape("object%3A%20anObject%0D%0A%09%22%20Set%20the%20object%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23object%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLApplet,"vspace",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["vspace"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("vspace%0D%0A%09%22%20Return%20the%20vspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23vspace"));

smalltalk.bind(smalltalk.HTMLApplet,"vspace:",0
,function(anObject){var self=this;
(self.handle()["vspace"]=(anObject));
return self;}
,"accessing",unescape("vspace%3A%20anObject%0D%0A%09%22%20Set%20the%20vspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23vspace%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"alt",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["alt"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("alt%0D%0A%09%22%20Return%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23alt"));

smalltalk.bind(smalltalk.HTMLArea,"alt:",0
,function(anObject){var self=this;
(self.handle()["alt"]=(anObject));
return self;}
,"accessing",unescape("alt%3A%20anObject%0D%0A%09%22%20Set%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23alt%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"coords",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["coords"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("coords%0D%0A%09%22%20Return%20the%20coords%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23coords"));

smalltalk.bind(smalltalk.HTMLArea,"coords:",0
,function(anObject){var self=this;
(self.handle()["coords"]=(anObject));
return self;}
,"accessing",unescape("coords%3A%20anObject%0D%0A%09%22%20Set%20the%20coords%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23coords%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"hash",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["hash"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("hash%0D%0A%09%22%20Return%20the%20hash%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23hash"));

smalltalk.bind(smalltalk.HTMLArea,"hash:",0
,function(anObject){var self=this;
(self.handle()["hash"]=(anObject));
return self;}
,"accessing",unescape("hash%3A%20anObject%0D%0A%09%22%20Set%20the%20hash%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23hash%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"host",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["host"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("host%0D%0A%09%22%20Return%20the%20host%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23host"));

smalltalk.bind(smalltalk.HTMLArea,"host:",0
,function(anObject){var self=this;
(self.handle()["host"]=(anObject));
return self;}
,"accessing",unescape("host%3A%20anObject%0D%0A%09%22%20Set%20the%20host%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23host%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"hostname",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["hostname"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("hostname%0D%0A%09%22%20Return%20the%20hostname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23hostname"));

smalltalk.bind(smalltalk.HTMLArea,"hostname:",0
,function(anObject){var self=this;
(self.handle()["hostname"]=(anObject));
return self;}
,"accessing",unescape("hostname%3A%20anObject%0D%0A%09%22%20Set%20the%20hostname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23hostname%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"href",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["href"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("href%0D%0A%09%22%20Return%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23href"));

smalltalk.bind(smalltalk.HTMLArea,"href:",0
,function(anObject){var self=this;
(self.handle()["href"]=(anObject));
return self;}
,"accessing",unescape("href%3A%20anObject%0D%0A%09%22%20Set%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23href%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"noHref",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["noHref"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("noHref%0D%0A%09%22%20Return%20the%20noHref%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23noHref"));

smalltalk.bind(smalltalk.HTMLArea,"noHref:",0
,function(anObject){var self=this;
(self.handle()["noHref"]=(anObject));
return self;}
,"accessing",unescape("noHref%3A%20anObject%0D%0A%09%22%20Set%20the%20noHref%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23noHref%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"pathname",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["pathname"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("pathname%0D%0A%09%22%20Return%20the%20pathname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23pathname"));

smalltalk.bind(smalltalk.HTMLArea,"pathname:",0
,function(anObject){var self=this;
(self.handle()["pathname"]=(anObject));
return self;}
,"accessing",unescape("pathname%3A%20anObject%0D%0A%09%22%20Set%20the%20pathname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23pathname%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"port",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["port"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("port%0D%0A%09%22%20Return%20the%20port%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23port"));

smalltalk.bind(smalltalk.HTMLArea,"port:",0
,function(anObject){var self=this;
(self.handle()["port"]=(anObject));
return self;}
,"accessing",unescape("port%3A%20anObject%0D%0A%09%22%20Set%20the%20port%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23port%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"protocol",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["protocol"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("protocol%0D%0A%09%22%20Return%20the%20protocol%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23protocol"));

smalltalk.bind(smalltalk.HTMLArea,"protocol:",0
,function(anObject){var self=this;
(self.handle()["protocol"]=(anObject));
return self;}
,"accessing",unescape("protocol%3A%20anObject%0D%0A%09%22%20Set%20the%20protocol%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23protocol%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"search",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["search"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("search%0D%0A%09%22%20Return%20the%20search%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23search"));

smalltalk.bind(smalltalk.HTMLArea,"search:",0
,function(anObject){var self=this;
(self.handle()["search"]=(anObject));
return self;}
,"accessing",unescape("search%3A%20anObject%0D%0A%09%22%20Set%20the%20search%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23search%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"shape",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["shape"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("shape%0D%0A%09%22%20Return%20the%20shape%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23shape"));

smalltalk.bind(smalltalk.HTMLArea,"shape:",0
,function(anObject){var self=this;
(self.handle()["shape"]=(anObject));
return self;}
,"accessing",unescape("shape%3A%20anObject%0D%0A%09%22%20Set%20the%20shape%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23shape%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"target",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["target"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23target"));

smalltalk.bind(smalltalk.HTMLArea,"target:",0
,function(anObject){var self=this;
(self.handle()["target"]=(anObject));
return self;}
,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23target%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLArea,"tabIndex",0
,function(){var self=this;
return (self["@handle"].tabIndex || (0));}
,"accessing",unescape("tabIndex%0D%0A%09%22%20Return%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23tabIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLArea,"tabIndex:",0
,function(anObject){var self=this;
(self.handle()["tabIndex"]=(anObject));
return self;}
,"accessing",unescape("tabIndex%3A%20anObject%0D%0A%09%22%20Set%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23tabIndex%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBase,"href",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["href"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("href%0D%0A%09%22%20Return%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23href"));

smalltalk.bind(smalltalk.HTMLBase,"href:",0
,function(anObject){var self=this;
(self.handle()["href"]=(anObject));
return self;}
,"accessing",unescape("href%3A%20anObject%0D%0A%09%22%20Set%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23href%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBase,"target",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["target"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23target"));

smalltalk.bind(smalltalk.HTMLBase,"target:",0
,function(anObject){var self=this;
(self.handle()["target"]=(anObject));
return self;}
,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23target%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBaseFont,"color",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["color"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("color%0D%0A%09%22%20Return%20the%20color%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23color"));

smalltalk.bind(smalltalk.HTMLBaseFont,"color:",0
,function(anObject){var self=this;
(self.handle()["color"]=(anObject));
return self;}
,"accessing",unescape("color%3A%20anObject%0D%0A%09%22%20Set%20the%20color%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23color%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBaseFont,"face",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["face"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("face%0D%0A%09%22%20Return%20the%20face%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23face"));

smalltalk.bind(smalltalk.HTMLBaseFont,"face:",0
,function(anObject){var self=this;
(self.handle()["face"]=(anObject));
return self;}
,"accessing",unescape("face%3A%20anObject%0D%0A%09%22%20Set%20the%20face%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23face%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBaseFont,"size",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["size"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23size"));

smalltalk.bind(smalltalk.HTMLBaseFont,"size:",0
,function(anObject){var self=this;
(self.handle()["size"]=(anObject));
return self;}
,"accessing",unescape("size%3A%20anObject%0D%0A%09%22%20Set%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23size%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBaseFont,"size",0
,function(){var self=this;
return (self["@handle"].size || (0));}
,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23size%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLBaseFont,"size:",0
,function(anObject){var self=this;
(self.handle()["size"]=(anObject));
return self;}
,"accessing",unescape("size%3A%20anObject%0D%0A%09%22%20Set%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23size%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBlockquote,"cite",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["cite"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("cite%0D%0A%09%22%20Return%20the%20cite%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23cite"));

smalltalk.bind(smalltalk.HTMLBlockquote,"cite:",0
,function(anObject){var self=this;
(self.handle()["cite"]=(anObject));
return self;}
,"accessing",unescape("cite%3A%20anObject%0D%0A%09%22%20Set%20the%20cite%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23cite%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBody,"aLink",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["aLink"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("aLink%0D%0A%09%22%20Return%20the%20aLink%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23aLink"));

smalltalk.bind(smalltalk.HTMLBody,"aLink:",0
,function(anObject){var self=this;
(self.handle()["aLink"]=(anObject));
return self;}
,"accessing",unescape("aLink%3A%20anObject%0D%0A%09%22%20Set%20the%20aLink%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23aLink%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBody,"background",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["background"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("background%0D%0A%09%22%20Return%20the%20background%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23background"));

smalltalk.bind(smalltalk.HTMLBody,"background:",0
,function(anObject){var self=this;
(self.handle()["background"]=(anObject));
return self;}
,"accessing",unescape("background%3A%20anObject%0D%0A%09%22%20Set%20the%20background%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23background%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBody,"bgColor",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["bgColor"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("bgColor%0D%0A%09%22%20Return%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23bgColor"));

smalltalk.bind(smalltalk.HTMLBody,"bgColor:",0
,function(anObject){var self=this;
(self.handle()["bgColor"]=(anObject));
return self;}
,"accessing",unescape("bgColor%3A%20anObject%0D%0A%09%22%20Set%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23bgColor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBody,"link",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["link"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("link%0D%0A%09%22%20Return%20the%20link%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23link"));

smalltalk.bind(smalltalk.HTMLBody,"link:",0
,function(anObject){var self=this;
(self.handle()["link"]=(anObject));
return self;}
,"accessing",unescape("link%3A%20anObject%0D%0A%09%22%20Set%20the%20link%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23link%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBody,"text",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["text"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("text%0D%0A%09%22%20Return%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23text"));

smalltalk.bind(smalltalk.HTMLBody,"text:",0
,function(anObject){var self=this;
(self.handle()["text"]=(anObject));
return self;}
,"accessing",unescape("text%3A%20anObject%0D%0A%09%22%20Set%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23text%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBody,"vLink",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["vLink"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("vLink%0D%0A%09%22%20Return%20the%20vLink%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23vLink"));

smalltalk.bind(smalltalk.HTMLBody,"vLink:",0
,function(anObject){var self=this;
(self.handle()["vLink"]=(anObject));
return self;}
,"accessing",unescape("vLink%3A%20anObject%0D%0A%09%22%20Set%20the%20vLink%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23vLink%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLBR,"clear",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["clear"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("clear%0D%0A%09%22%20Return%20the%20clear%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23clear"));

smalltalk.bind(smalltalk.HTMLBR,"clear:",0
,function(anObject){var self=this;
(self.handle()["clear"]=(anObject));
return self;}
,"accessing",unescape("clear%3A%20anObject%0D%0A%09%22%20Set%20the%20clear%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23clear%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLButton,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.HTMLButton,"name:",0
,function(anObject){var self=this;
(self.handle()["name"]=(anObject));
return self;}
,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23name%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLButton,"value",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["value"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23value"));

smalltalk.bind(smalltalk.HTMLButton,"value:",0
,function(anObject){var self=this;
(self.handle()["value"]=(anObject));
return self;}
,"accessing",unescape("value%3A%20anObject%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23value%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLButton,"autofocus",0
,function(){var self=this;
return (nil.is_eqeq_(true,self["@handle"].autofocus));}
,"accessing",unescape("autofocus%0D%0A%09%22%20Return%20the%20autofocus%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Etrue%20%3D%3D%20handle%23autofocus"));

smalltalk.bind(smalltalk.HTMLButton,"autofocus:",0
,function(anObject){var self=this;
(self.handle()["autofocus"]=(anObject));
return self;}
,"accessing",unescape("autofocus%3A%20anObject%0D%0A%09%22%20Set%20the%20autofocus%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23autofocus%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLButton,"tabIndex",0
,function(){var self=this;
return (self["@handle"].tabIndex || (0));}
,"accessing",unescape("tabIndex%0D%0A%09%22%20Return%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23tabIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLButton,"tabIndex:",0
,function(anObject){var self=this;
(self.handle()["tabIndex"]=(anObject));
return self;}
,"accessing",unescape("tabIndex%3A%20anObject%0D%0A%09%22%20Set%20the%20tabIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23tabIndex%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLButton,"form",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["form"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23form"));

smalltalk.bind(smalltalk.HTMLButton,"type",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["type"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23type"));

smalltalk.bind(smalltalk.HTMLCanvas,"height",0
,function(){var self=this;
return (self["@handle"].height || (0));}
,"accessing",unescape("height%0D%0A%09%22%20Return%20the%20height%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23height%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLCanvas,"height:",0
,function(anObject){var self=this;
(self.handle()["height"]=(anObject));
return self;}
,"accessing",unescape("height%3A%20anObject%0D%0A%09%22%20Set%20the%20height%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23height%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLCanvas,"width",0
,function(){var self=this;
return (self["@handle"].width || (0));}
,"accessing",unescape("width%0D%0A%09%22%20Return%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23width%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLCanvas,"width:",0
,function(anObject){var self=this;
(self.handle()["width"]=(anObject));
return self;}
,"accessing",unescape("width%3A%20anObject%0D%0A%09%22%20Set%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23width%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLDirectory,"compact",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["compact"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("compact%0D%0A%09%22%20Return%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23compact"));

smalltalk.bind(smalltalk.HTMLDirectory,"compact:",0
,function(anObject){var self=this;
(self.handle()["compact"]=(anObject));
return self;}
,"accessing",unescape("compact%3A%20anObject%0D%0A%09%22%20Set%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23compact%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLDiv,"align",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["align"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23align"));

smalltalk.bind(smalltalk.HTMLDiv,"align:",0
,function(anObject){var self=this;
(self.handle()["align"]=(anObject));
return self;}
,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23align%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLDList,"compact",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["compact"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("compact%0D%0A%09%22%20Return%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23compact"));

smalltalk.bind(smalltalk.HTMLDList,"compact:",0
,function(anObject){var self=this;
(self.handle()["compact"]=(anObject));
return self;}
,"accessing",unescape("compact%3A%20anObject%0D%0A%09%22%20Set%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23compact%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFieldSet,"form",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["form"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23form"));

smalltalk.bind(smalltalk.HTMLFont,"color",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["color"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("color%0D%0A%09%22%20Return%20the%20color%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23color"));

smalltalk.bind(smalltalk.HTMLFont,"color:",0
,function(anObject){var self=this;
(self.handle()["color"]=(anObject));
return self;}
,"accessing",unescape("color%3A%20anObject%0D%0A%09%22%20Set%20the%20color%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23color%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFont,"face",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["face"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("face%0D%0A%09%22%20Return%20the%20face%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23face"));

smalltalk.bind(smalltalk.HTMLFont,"face:",0
,function(anObject){var self=this;
(self.handle()["face"]=(anObject));
return self;}
,"accessing",unescape("face%3A%20anObject%0D%0A%09%22%20Set%20the%20face%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23face%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFont,"size",0
,function(){var self=this;
return (self["@handle"].size || (0));}
,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23size%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLFont,"size:",0
,function(anObject){var self=this;
(self.handle()["size"]=(anObject));
return self;}
,"accessing",unescape("size%3A%20anObject%0D%0A%09%22%20Set%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23size%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"acceptCharset",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["acceptCharset"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("acceptCharset%0D%0A%09%22%20Return%20the%20acceptCharset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23acceptCharset"));

smalltalk.bind(smalltalk.HTMLForm,"acceptCharset:",0
,function(anObject){var self=this;
(self.handle()["acceptCharset"]=(anObject));
return self;}
,"accessing",unescape("acceptCharset%3A%20anObject%0D%0A%09%22%20Set%20the%20acceptCharset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23acceptCharset%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"action",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["action"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("action%0D%0A%09%22%20Return%20the%20action%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23action"));

smalltalk.bind(smalltalk.HTMLForm,"action:",0
,function(anObject){var self=this;
(self.handle()["action"]=(anObject));
return self;}
,"accessing",unescape("action%3A%20anObject%0D%0A%09%22%20Set%20the%20action%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23action%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"behavior",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["behavior"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("behavior%0D%0A%09%22%20Return%20the%20behavior%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23behavior"));

smalltalk.bind(smalltalk.HTMLForm,"behavior:",0
,function(anObject){var self=this;
(self.handle()["behavior"]=(anObject));
return self;}
,"accessing",unescape("behavior%3A%20anObject%0D%0A%09%22%20Set%20the%20behavior%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23behavior%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"encoding",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["encoding"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("encoding%0D%0A%09%22%20Return%20the%20encoding%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23encoding"));

smalltalk.bind(smalltalk.HTMLForm,"encoding:",0
,function(anObject){var self=this;
(self.handle()["encoding"]=(anObject));
return self;}
,"accessing",unescape("encoding%3A%20anObject%0D%0A%09%22%20Set%20the%20encoding%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23encoding%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"enctype",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["enctype"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("enctype%0D%0A%09%22%20Return%20the%20enctype%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23enctype"));

smalltalk.bind(smalltalk.HTMLForm,"enctype:",0
,function(anObject){var self=this;
(self.handle()["enctype"]=(anObject));
return self;}
,"accessing",unescape("enctype%3A%20anObject%0D%0A%09%22%20Set%20the%20enctype%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23enctype%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"method",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["method"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("method%0D%0A%09%22%20Return%20the%20method%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23method"));

smalltalk.bind(smalltalk.HTMLForm,"method:",0
,function(anObject){var self=this;
(self.handle()["method"]=(anObject));
return self;}
,"accessing",unescape("method%3A%20anObject%0D%0A%09%22%20Set%20the%20method%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23method%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.HTMLForm,"name:",0
,function(anObject){var self=this;
(self.handle()["name"]=(anObject));
return self;}
,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23name%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"target",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["target"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23target"));

smalltalk.bind(smalltalk.HTMLForm,"target:",0
,function(anObject){var self=this;
(self.handle()["target"]=(anObject));
return self;}
,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23target%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLForm,"length",0
,function(){var self=this;
return (self["@handle"].length || (0));}
,"accessing",unescape("length%0D%0A%09%22%20Return%20the%20length%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23length%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLFrame,"align",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["align"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23align"));

smalltalk.bind(smalltalk.HTMLFrame,"align:",0
,function(anObject){var self=this;
(self.handle()["align"]=(anObject));
return self;}
,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23align%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"frameBorder",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["frameBorder"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("frameBorder%0D%0A%09%22%20Return%20the%20frameBorder%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23frameBorder"));

smalltalk.bind(smalltalk.HTMLFrame,"frameBorder:",0
,function(anObject){var self=this;
(self.handle()["frameBorder"]=(anObject));
return self;}
,"accessing",unescape("frameBorder%3A%20anObject%0D%0A%09%22%20Set%20the%20frameBorder%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23frameBorder%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"longDesc",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["longDesc"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("longDesc%0D%0A%09%22%20Return%20the%20longDesc%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23longDesc"));

smalltalk.bind(smalltalk.HTMLFrame,"longDesc:",0
,function(anObject){var self=this;
(self.handle()["longDesc"]=(anObject));
return self;}
,"accessing",unescape("longDesc%3A%20anObject%0D%0A%09%22%20Set%20the%20longDesc%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23longDesc%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.HTMLFrame,"name:",0
,function(anObject){var self=this;
(self.handle()["name"]=(anObject));
return self;}
,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23name%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"noResize",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["noResize"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("noResize%0D%0A%09%22%20Return%20the%20noResize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23noResize"));

smalltalk.bind(smalltalk.HTMLFrame,"noResize:",0
,function(anObject){var self=this;
(self.handle()["noResize"]=(anObject));
return self;}
,"accessing",unescape("noResize%3A%20anObject%0D%0A%09%22%20Set%20the%20noResize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23noResize%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"src",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["src"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("src%0D%0A%09%22%20Return%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23src"));

smalltalk.bind(smalltalk.HTMLFrame,"src:",0
,function(anObject){var self=this;
(self.handle()["src"]=(anObject));
return self;}
,"accessing",unescape("src%3A%20anObject%0D%0A%09%22%20Set%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23src%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"marginHeight",0
,function(){var self=this;
return (self["@handle"].marginHeight || (0));}
,"accessing",unescape("marginHeight%0D%0A%09%22%20Return%20the%20marginHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLFrame,"marginHeight:",0
,function(anObject){var self=this;
(self.handle()["marginHeight"]=(anObject));
return self;}
,"accessing",unescape("marginHeight%3A%20anObject%0D%0A%09%22%20Set%20the%20marginHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23marginHeight%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"marginWidth",0
,function(){var self=this;
return (self["@handle"].marginWidth || (0));}
,"accessing",unescape("marginWidth%0D%0A%09%22%20Return%20the%20marginWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLFrame,"marginWidth:",0
,function(anObject){var self=this;
(self.handle()["marginWidth"]=(anObject));
return self;}
,"accessing",unescape("marginWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20marginWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23marginWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrame,"scrolling",0
,function(){var self=this;
return (self["@handle"].scrolling || (0));}
,"accessing",unescape("scrolling%0D%0A%09%22%20Return%20the%20scrolling%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23scrolling%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLFrame,"scrolling:",0
,function(anObject){var self=this;
(self.handle()["scrolling"]=(anObject));
return self;}
,"accessing",unescape("scrolling%3A%20anObject%0D%0A%09%22%20Set%20the%20scrolling%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23scrolling%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrameset,"cols",0
,function(){var self=this;
return (self["@handle"].cols || (0));}
,"accessing",unescape("cols%0D%0A%09%22%20Return%20the%20cols%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cols%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLFrameset,"cols:",0
,function(anObject){var self=this;
(self.handle()["cols"]=(anObject));
return self;}
,"accessing",unescape("cols%3A%20anObject%0D%0A%09%22%20Set%20the%20cols%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23cols%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrameset,"rows",0
,function(){var self=this;
return (self["@handle"].rows || (0));}
,"accessing",unescape("rows%0D%0A%09%22%20Return%20the%20rows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23rows%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLFrameset,"rows:",0
,function(anObject){var self=this;
(self.handle()["rows"]=(anObject));
return self;}
,"accessing",unescape("rows%3A%20anObject%0D%0A%09%22%20Set%20the%20rows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23rows%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLFrameset,"complete",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["complete"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("complete%0D%0A%09%22%20Return%20the%20complete%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23complete"));

smalltalk.bind(smalltalk.HTMLHead,"profile",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["profile"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("profile%0D%0A%09%22%20Return%20the%20profile%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23profile"));

smalltalk.bind(smalltalk.HTMLHead,"profile:",0
,function(anObject){var self=this;
(self.handle()["profile"]=(anObject));
return self;}
,"accessing",unescape("profile%3A%20anObject%0D%0A%09%22%20Set%20the%20profile%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23profile%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLHeading,"align",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["align"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23align"));

smalltalk.bind(smalltalk.HTMLHeading,"align:",0
,function(anObject){var self=this;
(self.handle()["align"]=(anObject));
return self;}
,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23align%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLHR,"align",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["align"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23align"));

smalltalk.bind(smalltalk.HTMLHR,"align:",0
,function(anObject){var self=this;
(self.handle()["align"]=(anObject));
return self;}
,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23align%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLHR,"noShade",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["noShade"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("noShade%0D%0A%09%22%20Return%20the%20noShade%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23noShade"));

smalltalk.bind(smalltalk.HTMLHR,"noShade:",0
,function(anObject){var self=this;
(self.handle()["noShade"]=(anObject));
return self;}
,"accessing",unescape("noShade%3A%20anObject%0D%0A%09%22%20Set%20the%20noShade%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23noShade%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLHR,"size",0
,function(){var self=this;
return (self["@handle"].size || (0));}
,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23size%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLHR,"size:",0
,function(anObject){var self=this;
(self.handle()["size"]=(anObject));
return self;}
,"accessing",unescape("size%3A%20anObject%0D%0A%09%22%20Set%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23size%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLHR,"width",0
,function(){var self=this;
return (self["@handle"].width || (0));}
,"accessing",unescape("width%0D%0A%09%22%20Return%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23width%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLHR,"width:",0
,function(anObject){var self=this;
(self.handle()["width"]=(anObject));
return self;}
,"accessing",unescape("width%3A%20anObject%0D%0A%09%22%20Set%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23width%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLPage,"version",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["version"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("version%0D%0A%09%22%20Return%20the%20version%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23version"));

smalltalk.bind(smalltalk.HTMLPage,"version:",0
,function(anObject){var self=this;
(self.handle()["version"]=(anObject));
return self;}
,"accessing",unescape("version%3A%20anObject%0D%0A%09%22%20Set%20the%20version%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23version%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"align",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["align"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23align"));

smalltalk.bind(smalltalk.HTMLIFrame,"align:",0
,function(anObject){var self=this;
(self.handle()["align"]=(anObject));
return self;}
,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23align%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"frameBorder",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["frameBorder"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("frameBorder%0D%0A%09%22%20Return%20the%20frameBorder%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23frameBorder"));

smalltalk.bind(smalltalk.HTMLIFrame,"frameBorder:",0
,function(anObject){var self=this;
(self.handle()["frameBorder"]=(anObject));
return self;}
,"accessing",unescape("frameBorder%3A%20anObject%0D%0A%09%22%20Set%20the%20frameBorder%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23frameBorder%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"longDesc",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["longDesc"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("longDesc%0D%0A%09%22%20Return%20the%20longDesc%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23longDesc"));

smalltalk.bind(smalltalk.HTMLIFrame,"longDesc:",0
,function(anObject){var self=this;
(self.handle()["longDesc"]=(anObject));
return self;}
,"accessing",unescape("longDesc%3A%20anObject%0D%0A%09%22%20Set%20the%20longDesc%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23longDesc%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.HTMLIFrame,"name:",0
,function(anObject){var self=this;
(self.handle()["name"]=(anObject));
return self;}
,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23name%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"scrolling",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["scrolling"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("scrolling%0D%0A%09%22%20Return%20the%20scrolling%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23scrolling"));

smalltalk.bind(smalltalk.HTMLIFrame,"scrolling:",0
,function(anObject){var self=this;
(self.handle()["scrolling"]=(anObject));
return self;}
,"accessing",unescape("scrolling%3A%20anObject%0D%0A%09%22%20Set%20the%20scrolling%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23scrolling%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"src",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["src"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("src%0D%0A%09%22%20Return%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23src"));

smalltalk.bind(smalltalk.HTMLIFrame,"src:",0
,function(anObject){var self=this;
(self.handle()["src"]=(anObject));
return self;}
,"accessing",unescape("src%3A%20anObject%0D%0A%09%22%20Set%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23src%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"marginHeight",0
,function(){var self=this;
return (self["@handle"].marginHeight || (0));}
,"accessing",unescape("marginHeight%0D%0A%09%22%20Return%20the%20marginHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLIFrame,"marginHeight:",0
,function(anObject){var self=this;
(self.handle()["marginHeight"]=(anObject));
return self;}
,"accessing",unescape("marginHeight%3A%20anObject%0D%0A%09%22%20Set%20the%20marginHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23marginHeight%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIFrame,"marginWidth",0
,function(){var self=this;
return (self["@handle"].marginWidth || (0));}
,"accessing",unescape("marginWidth%0D%0A%09%22%20Return%20the%20marginWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLIFrame,"marginWidth:",0
,function(anObject){var self=this;
(self.handle()["marginWidth"]=(anObject));
return self;}
,"accessing",unescape("marginWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20marginWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23marginWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"align",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["align"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23align"));

smalltalk.bind(smalltalk.HTMLImage,"align:",0
,function(anObject){var self=this;
(self.handle()["align"]=(anObject));
return self;}
,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23align%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"alt",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["alt"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("alt%0D%0A%09%22%20Return%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23alt"));

smalltalk.bind(smalltalk.HTMLImage,"alt:",0
,function(anObject){var self=this;
(self.handle()["alt"]=(anObject));
return self;}
,"accessing",unescape("alt%3A%20anObject%0D%0A%09%22%20Set%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23alt%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"border",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["border"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("border%0D%0A%09%22%20Return%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23border"));

smalltalk.bind(smalltalk.HTMLImage,"border:",0
,function(anObject){var self=this;
(self.handle()["border"]=(anObject));
return self;}
,"accessing",unescape("border%3A%20anObject%0D%0A%09%22%20Set%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23border%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"complete",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["complete"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("complete%0D%0A%09%22%20Return%20the%20complete%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23complete"));

smalltalk.bind(smalltalk.HTMLImage,"complete:",0
,function(anObject){var self=this;
(self.handle()["complete"]=(anObject));
return self;}
,"accessing",unescape("complete%3A%20anObject%0D%0A%09%22%20Set%20the%20complete%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23complete%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"hspace",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["hspace"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("hspace%0D%0A%09%22%20Return%20the%20hspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23hspace"));

smalltalk.bind(smalltalk.HTMLImage,"hspace:",0
,function(anObject){var self=this;
(self.handle()["hspace"]=(anObject));
return self;}
,"accessing",unescape("hspace%3A%20anObject%0D%0A%09%22%20Set%20the%20hspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23hspace%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"isMap",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["isMap"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("isMap%0D%0A%09%22%20Return%20the%20isMap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23isMap"));

smalltalk.bind(smalltalk.HTMLImage,"isMap:",0
,function(anObject){var self=this;
(self.handle()["isMap"]=(anObject));
return self;}
,"accessing",unescape("isMap%3A%20anObject%0D%0A%09%22%20Set%20the%20isMap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23isMap%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"longDesc",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["longDesc"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("longDesc%0D%0A%09%22%20Return%20the%20longDesc%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23longDesc"));

smalltalk.bind(smalltalk.HTMLImage,"longDesc:",0
,function(anObject){var self=this;
(self.handle()["longDesc"]=(anObject));
return self;}
,"accessing",unescape("longDesc%3A%20anObject%0D%0A%09%22%20Set%20the%20longDesc%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23longDesc%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"lowscr",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["lowscr"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("lowscr%0D%0A%09%22%20Return%20the%20lowscr%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23lowscr"));

smalltalk.bind(smalltalk.HTMLImage,"lowscr:",0
,function(anObject){var self=this;
(self.handle()["lowscr"]=(anObject));
return self;}
,"accessing",unescape("lowscr%3A%20anObject%0D%0A%09%22%20Set%20the%20lowscr%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23lowscr%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.HTMLImage,"name:",0
,function(anObject){var self=this;
(self.handle()["name"]=(anObject));
return self;}
,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23name%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"src",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["src"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("src%0D%0A%09%22%20Return%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23src"));

smalltalk.bind(smalltalk.HTMLImage,"src:",0
,function(anObject){var self=this;
(self.handle()["src"]=(anObject));
return self;}
,"accessing",unescape("src%3A%20anObject%0D%0A%09%22%20Set%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23src%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"useMap",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["useMap"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("useMap%0D%0A%09%22%20Return%20the%20useMap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23useMap"));

smalltalk.bind(smalltalk.HTMLImage,"useMap:",0
,function(anObject){var self=this;
(self.handle()["useMap"]=(anObject));
return self;}
,"accessing",unescape("useMap%3A%20anObject%0D%0A%09%22%20Set%20the%20useMap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23useMap%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"vspace",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["vspace"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("vspace%0D%0A%09%22%20Return%20the%20vspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23vspace"));

smalltalk.bind(smalltalk.HTMLImage,"vspace:",0
,function(anObject){var self=this;
(self.handle()["vspace"]=(anObject));
return self;}
,"accessing",unescape("vspace%3A%20anObject%0D%0A%09%22%20Set%20the%20vspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23vspace%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"naturalWidth",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["naturalWidth"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("naturalWidth%0D%0A%09%22%20Return%20the%20naturalWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23naturalWidth"));

smalltalk.bind(smalltalk.HTMLImage,"naturalWidth:",0
,function(anObject){var self=this;
(self.handle()["naturalWidth"]=(anObject));
return self;}
,"accessing",unescape("naturalWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20naturalWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23naturalWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLImage,"naturalHeight",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["naturalHeight"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("naturalHeight%0D%0A%09%22%20Return%20the%20naturalHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23naturalHeight"));

smalltalk.bind(smalltalk.HTMLImage,"naturalHeight:",0
,function(anObject){var self=this;
(self.handle()["naturalHeight"]=(anObject));
return self;}
,"accessing",unescape("naturalHeight%3A%20anObject%0D%0A%09%22%20Set%20the%20naturalHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23naturalHeight%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInput,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.HTMLInput,"name:",0
,function(anObject){var self=this;
(self.handle()["name"]=(anObject));
return self;}
,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23name%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInput,"value",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["value"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23value"));

smalltalk.bind(smalltalk.HTMLInput,"value:",0
,function(anObject){var self=this;
(self.handle()["value"]=(anObject));
return self;}
,"accessing",unescape("value%3A%20anObject%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23value%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInput,"form",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["form"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23form"));

smalltalk.bind(smalltalk.HTMLInput,"type",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["type"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23type"));

smalltalk.bind(smalltalk.HTMLInputButton,"accept",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["accept"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("accept%0D%0A%09%22%20Return%20the%20accept%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23accept"));

smalltalk.bind(smalltalk.HTMLInputButton,"accept:",0
,function(anObject){var self=this;
(self.handle()["accept"]=(anObject));
return self;}
,"accessing",unescape("accept%3A%20anObject%0D%0A%09%22%20Set%20the%20accept%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23accept%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputButton,"align",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["align"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23align"));

smalltalk.bind(smalltalk.HTMLInputButton,"align:",0
,function(anObject){var self=this;
(self.handle()["align"]=(anObject));
return self;}
,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23align%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputButton,"alt",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["alt"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("alt%0D%0A%09%22%20Return%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23alt"));

smalltalk.bind(smalltalk.HTMLInputButton,"alt:",0
,function(anObject){var self=this;
(self.handle()["alt"]=(anObject));
return self;}
,"accessing",unescape("alt%3A%20anObject%0D%0A%09%22%20Set%20the%20alt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23alt%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputButton,"onclick",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["onclick"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("onclick%0D%0A%09%22%20Return%20the%20onclick%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23onclick"));

smalltalk.bind(smalltalk.HTMLInputButton,"onclick:",0
,function(anObject){var self=this;
(self.handle()["onclick"]=(anObject));
return self;}
,"accessing",unescape("onclick%3A%20anObject%0D%0A%09%22%20Set%20the%20onclick%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23onclick%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputCheckbox,"checked",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["checked"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("checked%0D%0A%09%22%20Return%20the%20checked%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23checked"));

smalltalk.bind(smalltalk.HTMLInputCheckbox,"checked:",0
,function(anObject){var self=this;
(self.handle()["checked"]=(anObject));
return self;}
,"accessing",unescape("checked%3A%20anObject%0D%0A%09%22%20Set%20the%20checked%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23checked%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputCheckbox,"onchange",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["onchange"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("onchange%0D%0A%09%22%20Return%20the%20onchange%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23onchange"));

smalltalk.bind(smalltalk.HTMLInputCheckbox,"onchange:",0
,function(anObject){var self=this;
(self.handle()["onchange"]=(anObject));
return self;}
,"accessing",unescape("onchange%3A%20anObject%0D%0A%09%22%20Set%20the%20onchange%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23onchange%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputCheckbox,"defaultChecked",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["defaultChecked"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("defaultChecked%0D%0A%09%22%20Return%20the%20defaultChecked%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23defaultChecked"));

smalltalk.bind(smalltalk.HTMLInputFile,"accept",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["accept"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("accept%0D%0A%09%22%20Return%20the%20accept%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23accept"));

smalltalk.bind(smalltalk.HTMLInputFile,"accept:",0
,function(anObject){var self=this;
(self.handle()["accept"]=(anObject));
return self;}
,"accessing",unescape("accept%3A%20anObject%0D%0A%09%22%20Set%20the%20accept%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23accept%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputText,"defaultValue",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["defaultValue"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("defaultValue%0D%0A%09%22%20Return%20the%20defaultValue%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23defaultValue"));

smalltalk.bind(smalltalk.HTMLInputText,"defaultValue:",0
,function(anObject){var self=this;
(self.handle()["defaultValue"]=(anObject));
return self;}
,"accessing",unescape("defaultValue%3A%20anObject%0D%0A%09%22%20Set%20the%20defaultValue%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23defaultValue%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputText,"readOnly",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["readOnly"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("readOnly%0D%0A%09%22%20Return%20the%20readOnly%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23readOnly"));

smalltalk.bind(smalltalk.HTMLInputText,"readOnly:",0
,function(anObject){var self=this;
(self.handle()["readOnly"]=(anObject));
return self;}
,"accessing",unescape("readOnly%3A%20anObject%0D%0A%09%22%20Set%20the%20readOnly%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23readOnly%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputText,"autocomplete",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["autocomplete"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("autocomplete%0D%0A%09%22%20Return%20the%20autocomplete%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23autocomplete"));

smalltalk.bind(smalltalk.HTMLInputText,"autocomplete:",0
,function(anObject){var self=this;
(self.handle()["autocomplete"]=(anObject));
return self;}
,"accessing",unescape("autocomplete%3A%20anObject%0D%0A%09%22%20Set%20the%20autocomplete%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23autocomplete%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputText,"autocorrect",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["autocorrect"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("autocorrect%0D%0A%09%22%20Return%20the%20autocorrect%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23autocorrect"));

smalltalk.bind(smalltalk.HTMLInputText,"autocorrect:",0
,function(anObject){var self=this;
(self.handle()["autocorrect"]=(anObject));
return self;}
,"accessing",unescape("autocorrect%3A%20anObject%0D%0A%09%22%20Set%20the%20autocorrect%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23autocorrect%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputText,"autocapitalize",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["autocapitalize"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("autocapitalize%0D%0A%09%22%20Return%20the%20autocapitalize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23autocapitalize"));

smalltalk.bind(smalltalk.HTMLInputText,"autocapitalize:",0
,function(anObject){var self=this;
(self.handle()["autocapitalize"]=(anObject));
return self;}
,"accessing",unescape("autocapitalize%3A%20anObject%0D%0A%09%22%20Set%20the%20autocapitalize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23autocapitalize%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputText,"spellcheck",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["spellcheck"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("spellcheck%0D%0A%09%22%20Return%20the%20spellcheck%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23spellcheck"));

smalltalk.bind(smalltalk.HTMLInputText,"spellcheck:",0
,function(anObject){var self=this;
(self.handle()["spellcheck"]=(anObject));
return self;}
,"accessing",unescape("spellcheck%3A%20anObject%0D%0A%09%22%20Set%20the%20spellcheck%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23spellcheck%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputText,"maxLength",0
,function(){var self=this;
return (self["@handle"].maxLength || (0));}
,"accessing",unescape("maxLength%0D%0A%09%22%20Return%20the%20maxLength%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23maxLength%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLInputText,"maxLength:",0
,function(anObject){var self=this;
(self.handle()["maxLength"]=(anObject));
return self;}
,"accessing",unescape("maxLength%3A%20anObject%0D%0A%09%22%20Set%20the%20maxLength%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23maxLength%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputText,"size",0
,function(){var self=this;
return (self["@handle"].size || (0));}
,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23size%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLInputText,"size:",0
,function(anObject){var self=this;
(self.handle()["size"]=(anObject));
return self;}
,"accessing",unescape("size%3A%20anObject%0D%0A%09%22%20Set%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23size%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputText,"onchange",0
,function(){var self=this;
return (self["@handle"].onchange || (0));}
,"accessing",unescape("onchange%0D%0A%09%22%20Return%20the%20onchange%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23onchange%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLInputText,"onchange:",0
,function(anObject){var self=this;
(self.handle()["onchange"]=(anObject));
return self;}
,"accessing",unescape("onchange%3A%20anObject%0D%0A%09%22%20Set%20the%20onchange%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23onchange%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputRadio,"checked",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["checked"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("checked%0D%0A%09%22%20Return%20the%20checked%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23checked"));

smalltalk.bind(smalltalk.HTMLInputRadio,"checked:",0
,function(anObject){var self=this;
(self.handle()["checked"]=(anObject));
return self;}
,"accessing",unescape("checked%3A%20anObject%0D%0A%09%22%20Set%20the%20checked%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23checked%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputRadio,"onclick",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["onclick"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("onclick%0D%0A%09%22%20Return%20the%20onclick%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23onclick"));

smalltalk.bind(smalltalk.HTMLInputRadio,"onclick:",0
,function(anObject){var self=this;
(self.handle()["onclick"]=(anObject));
return self;}
,"accessing",unescape("onclick%3A%20anObject%0D%0A%09%22%20Set%20the%20onclick%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23onclick%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLInputRadio,"defaultChecked",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["defaultChecked"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("defaultChecked%0D%0A%09%22%20Return%20the%20defaultChecked%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23defaultChecked"));

smalltalk.bind(smalltalk.HTMLIsIndex,"prompt",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["prompt"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("prompt%0D%0A%09%22%20Return%20the%20prompt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23prompt"));

smalltalk.bind(smalltalk.HTMLIsIndex,"prompt:",0
,function(anObject){var self=this;
(self.handle()["prompt"]=(anObject));
return self;}
,"accessing",unescape("prompt%3A%20anObject%0D%0A%09%22%20Set%20the%20prompt%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23prompt%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLIsIndex,"form",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["form"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23form"));

smalltalk.bind(smalltalk.HTMLLabel,"htmlFor",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["htmlFor"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("htmlFor%0D%0A%09%22%20Return%20the%20htmlFor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23htmlFor"));

smalltalk.bind(smalltalk.HTMLLabel,"htmlFor:",0
,function(anObject){var self=this;
(self.handle()["htmlFor"]=(anObject));
return self;}
,"accessing",unescape("htmlFor%3A%20anObject%0D%0A%09%22%20Set%20the%20htmlFor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23htmlFor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLabel,"form",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["form"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23form"));

smalltalk.bind(smalltalk.HTMLLayer,"bgColor",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["bgColor"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("bgColor%0D%0A%09%22%20Return%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23bgColor"));

smalltalk.bind(smalltalk.HTMLLayer,"bgColor:",0
,function(anObject){var self=this;
(self.handle()["bgColor"]=(anObject));
return self;}
,"accessing",unescape("bgColor%3A%20anObject%0D%0A%09%22%20Set%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23bgColor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLILayer,"bgColor",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["bgColor"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("bgColor%0D%0A%09%22%20Return%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23bgColor"));

smalltalk.bind(smalltalk.HTMLILayer,"bgColor:",0
,function(anObject){var self=this;
(self.handle()["bgColor"]=(anObject));
return self;}
,"accessing",unescape("bgColor%3A%20anObject%0D%0A%09%22%20Set%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23bgColor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLegend,"align",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["align"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23align"));

smalltalk.bind(smalltalk.HTMLLegend,"align:",0
,function(anObject){var self=this;
(self.handle()["align"]=(anObject));
return self;}
,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23align%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLegend,"form",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["form"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23form"));

smalltalk.bind(smalltalk.HTMLLI,"type",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["type"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23type"));

smalltalk.bind(smalltalk.HTMLLI,"type:",0
,function(anObject){var self=this;
(self.handle()["type"]=(anObject));
return self;}
,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23type%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLI,"value",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["value"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23value"));

smalltalk.bind(smalltalk.HTMLLI,"value:",0
,function(anObject){var self=this;
(self.handle()["value"]=(anObject));
return self;}
,"accessing",unescape("value%3A%20anObject%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23value%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"charset",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["charset"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("charset%0D%0A%09%22%20Return%20the%20charset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23charset"));

smalltalk.bind(smalltalk.HTMLLink,"charset:",0
,function(anObject){var self=this;
(self.handle()["charset"]=(anObject));
return self;}
,"accessing",unescape("charset%3A%20anObject%0D%0A%09%22%20Set%20the%20charset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23charset%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"href",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["href"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("href%0D%0A%09%22%20Return%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23href"));

smalltalk.bind(smalltalk.HTMLLink,"href:",0
,function(anObject){var self=this;
(self.handle()["href"]=(anObject));
return self;}
,"accessing",unescape("href%3A%20anObject%0D%0A%09%22%20Set%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23href%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"hreflang",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["hreflang"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("hreflang%0D%0A%09%22%20Return%20the%20hreflang%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23hreflang"));

smalltalk.bind(smalltalk.HTMLLink,"hreflang:",0
,function(anObject){var self=this;
(self.handle()["hreflang"]=(anObject));
return self;}
,"accessing",unescape("hreflang%3A%20anObject%0D%0A%09%22%20Set%20the%20hreflang%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23hreflang%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"media",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["media"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("media%0D%0A%09%22%20Return%20the%20media%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23media"));

smalltalk.bind(smalltalk.HTMLLink,"media:",0
,function(anObject){var self=this;
(self.handle()["media"]=(anObject));
return self;}
,"accessing",unescape("media%3A%20anObject%0D%0A%09%22%20Set%20the%20media%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23media%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"rel",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["rel"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("rel%0D%0A%09%22%20Return%20the%20rel%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23rel"));

smalltalk.bind(smalltalk.HTMLLink,"rel:",0
,function(anObject){var self=this;
(self.handle()["rel"]=(anObject));
return self;}
,"accessing",unescape("rel%3A%20anObject%0D%0A%09%22%20Set%20the%20rel%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23rel%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"rev",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["rev"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("rev%0D%0A%09%22%20Return%20the%20rev%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23rev"));

smalltalk.bind(smalltalk.HTMLLink,"rev:",0
,function(anObject){var self=this;
(self.handle()["rev"]=(anObject));
return self;}
,"accessing",unescape("rev%3A%20anObject%0D%0A%09%22%20Set%20the%20rev%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23rev%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"target",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["target"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23target"));

smalltalk.bind(smalltalk.HTMLLink,"target:",0
,function(anObject){var self=this;
(self.handle()["target"]=(anObject));
return self;}
,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23target%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLLink,"type",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["type"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23type"));

smalltalk.bind(smalltalk.HTMLLink,"type:",0
,function(anObject){var self=this;
(self.handle()["type"]=(anObject));
return self;}
,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23type%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMap,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.HTMLMap,"name:",0
,function(anObject){var self=this;
(self.handle()["name"]=(anObject));
return self;}
,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23name%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMap,"areas",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["areas"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("areas%0D%0A%09%22%20Return%20the%20areas%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23areas"));

smalltalk.bind(smalltalk.HTMLMenu,"compact",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["compact"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("compact%0D%0A%09%22%20Return%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23compact"));

smalltalk.bind(smalltalk.HTMLMenu,"compact:",0
,function(anObject){var self=this;
(self.handle()["compact"]=(anObject));
return self;}
,"accessing",unescape("compact%3A%20anObject%0D%0A%09%22%20Set%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23compact%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMeta,"content",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["content"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("content%0D%0A%09%22%20Return%20the%20content%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23content"));

smalltalk.bind(smalltalk.HTMLMeta,"content:",0
,function(anObject){var self=this;
(self.handle()["content"]=(anObject));
return self;}
,"accessing",unescape("content%3A%20anObject%0D%0A%09%22%20Set%20the%20content%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23content%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMeta,"httpEquiv",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["httpEquiv"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("httpEquiv%0D%0A%09%22%20Return%20the%20httpEquiv%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23httpEquiv"));

smalltalk.bind(smalltalk.HTMLMeta,"httpEquiv:",0
,function(anObject){var self=this;
(self.handle()["httpEquiv"]=(anObject));
return self;}
,"accessing",unescape("httpEquiv%3A%20anObject%0D%0A%09%22%20Set%20the%20httpEquiv%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23httpEquiv%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMeta,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.HTMLMeta,"name:",0
,function(anObject){var self=this;
(self.handle()["name"]=(anObject));
return self;}
,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23name%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMeta,"scheme",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["scheme"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("scheme%0D%0A%09%22%20Return%20the%20scheme%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23scheme"));

smalltalk.bind(smalltalk.HTMLMeta,"scheme:",0
,function(anObject){var self=this;
(self.handle()["scheme"]=(anObject));
return self;}
,"accessing",unescape("scheme%3A%20anObject%0D%0A%09%22%20Set%20the%20scheme%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23scheme%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMod,"cite",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["cite"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("cite%0D%0A%09%22%20Return%20the%20cite%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23cite"));

smalltalk.bind(smalltalk.HTMLMod,"cite:",0
,function(anObject){var self=this;
(self.handle()["cite"]=(anObject));
return self;}
,"accessing",unescape("cite%3A%20anObject%0D%0A%09%22%20Set%20the%20cite%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23cite%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLMod,"dateTime",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["dateTime"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("dateTime%0D%0A%09%22%20Return%20the%20dateTime%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23dateTime"));

smalltalk.bind(smalltalk.HTMLMod,"dateTime:",0
,function(anObject){var self=this;
(self.handle()["dateTime"]=(anObject));
return self;}
,"accessing",unescape("dateTime%3A%20anObject%0D%0A%09%22%20Set%20the%20dateTime%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23dateTime%20put%3A%20anObject"));

smalltalk.HTMLObject.$comment=unescape("%0D%0A%09The%20Object%20object%20represents%20an%20HTML%20object%20element.%0D%0A%09The%20%3Cobject%3E%20tag%20is%20used%20to%20include%20objects%20such%20as%20images%2C%20audio%2C%20videos%2C%20Java%20applets%2C%20ActiveX%2C%20PDF%2C%20and%20Flash%20into%20a%20webpage.%0D%0A");

smalltalk.bind(smalltalk.HTMLObject,"align",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["align"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23align"));

smalltalk.bind(smalltalk.HTMLObject,"align:",0
,function(anObject){var self=this;
(self.handle()["align"]=(anObject));
return self;}
,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23align%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"archive",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["archive"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("archive%0D%0A%09%22%20Return%20the%20archive%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23archive"));

smalltalk.bind(smalltalk.HTMLObject,"archive:",0
,function(anObject){var self=this;
(self.handle()["archive"]=(anObject));
return self;}
,"accessing",unescape("archive%3A%20anObject%0D%0A%09%22%20Set%20the%20archive%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23archive%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"code",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["code"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("code%0D%0A%09%22%20Return%20the%20code%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23code"));

smalltalk.bind(smalltalk.HTMLObject,"code:",0
,function(anObject){var self=this;
(self.handle()["code"]=(anObject));
return self;}
,"accessing",unescape("code%3A%20anObject%0D%0A%09%22%20Set%20the%20code%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23code%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"codeBase",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["codeBase"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("codeBase%0D%0A%09%22%20Return%20the%20codeBase%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23codeBase"));

smalltalk.bind(smalltalk.HTMLObject,"codeBase:",0
,function(anObject){var self=this;
(self.handle()["codeBase"]=(anObject));
return self;}
,"accessing",unescape("codeBase%3A%20anObject%0D%0A%09%22%20Set%20the%20codeBase%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23codeBase%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"codeType",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["codeType"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("codeType%0D%0A%09%22%20Return%20the%20codeType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23codeType"));

smalltalk.bind(smalltalk.HTMLObject,"codeType:",0
,function(anObject){var self=this;
(self.handle()["codeType"]=(anObject));
return self;}
,"accessing",unescape("codeType%3A%20anObject%0D%0A%09%22%20Set%20the%20codeType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23codeType%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"data",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["data"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("data%0D%0A%09%22%20Return%20the%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23data"));

smalltalk.bind(smalltalk.HTMLObject,"data:",0
,function(anObject){var self=this;
(self.handle()["data"]=(anObject));
return self;}
,"accessing",unescape("data%3A%20anObject%0D%0A%09%22%20Set%20the%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23data%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"declare",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["declare"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("declare%0D%0A%09%22%20Return%20the%20declare%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23declare"));

smalltalk.bind(smalltalk.HTMLObject,"declare:",0
,function(anObject){var self=this;
(self.handle()["declare"]=(anObject));
return self;}
,"accessing",unescape("declare%3A%20anObject%0D%0A%09%22%20Set%20the%20declare%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23declare%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.HTMLObject,"name:",0
,function(anObject){var self=this;
(self.handle()["name"]=(anObject));
return self;}
,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23name%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"standby",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["standby"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("standby%0D%0A%09%22%20Return%20the%20standby%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23standby"));

smalltalk.bind(smalltalk.HTMLObject,"standby:",0
,function(anObject){var self=this;
(self.handle()["standby"]=(anObject));
return self;}
,"accessing",unescape("standby%3A%20anObject%0D%0A%09%22%20Set%20the%20standby%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23standby%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"type",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["type"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23type"));

smalltalk.bind(smalltalk.HTMLObject,"type:",0
,function(anObject){var self=this;
(self.handle()["type"]=(anObject));
return self;}
,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23type%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"useMap",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["useMap"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("useMap%0D%0A%09%22%20Return%20the%20useMap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23useMap"));

smalltalk.bind(smalltalk.HTMLObject,"useMap:",0
,function(anObject){var self=this;
(self.handle()["useMap"]=(anObject));
return self;}
,"accessing",unescape("useMap%3A%20anObject%0D%0A%09%22%20Set%20the%20useMap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23useMap%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"border",0
,function(){var self=this;
return (self["@handle"].border || (0));}
,"accessing",unescape("border%0D%0A%09%22%20Return%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23border%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLObject,"border:",0
,function(anObject){var self=this;
(self.handle()["border"]=(anObject));
return self;}
,"accessing",unescape("border%3A%20anObject%0D%0A%09%22%20Set%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23border%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"hspace",0
,function(){var self=this;
return (self["@handle"].hspace || (0));}
,"accessing",unescape("hspace%0D%0A%09%22%20Return%20the%20hspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23hspace%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLObject,"hspace:",0
,function(anObject){var self=this;
(self.handle()["hspace"]=(anObject));
return self;}
,"accessing",unescape("hspace%3A%20anObject%0D%0A%09%22%20Set%20the%20hspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23hspace%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"vspace",0
,function(){var self=this;
return (self["@handle"].vspace || (0));}
,"accessing",unescape("vspace%0D%0A%09%22%20Return%20the%20vspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23vspace%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLObject,"vspace:",0
,function(anObject){var self=this;
(self.handle()["vspace"]=(anObject));
return self;}
,"accessing",unescape("vspace%3A%20anObject%0D%0A%09%22%20Set%20the%20vspace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23vspace%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLObject,"form",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["form"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23form"));

smalltalk.bind(smalltalk.HTMLOList,"compact",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["compact"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("compact%0D%0A%09%22%20Return%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23compact"));

smalltalk.bind(smalltalk.HTMLOList,"compact:",0
,function(anObject){var self=this;
(self.handle()["compact"]=(anObject));
return self;}
,"accessing",unescape("compact%3A%20anObject%0D%0A%09%22%20Set%20the%20compact%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23compact%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOList,"start",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["start"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("start%0D%0A%09%22%20Return%20the%20start%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23start"));

smalltalk.bind(smalltalk.HTMLOList,"start:",0
,function(anObject){var self=this;
(self.handle()["start"]=(anObject));
return self;}
,"accessing",unescape("start%3A%20anObject%0D%0A%09%22%20Set%20the%20start%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23start%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOList,"type",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["type"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23type"));

smalltalk.bind(smalltalk.HTMLOList,"type:",0
,function(anObject){var self=this;
(self.handle()["type"]=(anObject));
return self;}
,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23type%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOptGroup,"label",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["label"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("label%0D%0A%09%22%20Return%20the%20label%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23label"));

smalltalk.bind(smalltalk.HTMLOptGroup,"label:",0
,function(anObject){var self=this;
(self.handle()["label"]=(anObject));
return self;}
,"accessing",unescape("label%3A%20anObject%0D%0A%09%22%20Set%20the%20label%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23label%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption,"label",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["label"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("label%0D%0A%09%22%20Return%20the%20label%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23label"));

smalltalk.bind(smalltalk.HTMLOption,"label:",0
,function(anObject){var self=this;
(self.handle()["label"]=(anObject));
return self;}
,"accessing",unescape("label%3A%20anObject%0D%0A%09%22%20Set%20the%20label%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23label%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption,"onsubmit",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["onsubmit"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("onsubmit%0D%0A%09%22%20Return%20the%20onsubmit%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23onsubmit"));

smalltalk.bind(smalltalk.HTMLOption,"onsubmit:",0
,function(anObject){var self=this;
(self.handle()["onsubmit"]=(anObject));
return self;}
,"accessing",unescape("onsubmit%3A%20anObject%0D%0A%09%22%20Set%20the%20onsubmit%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23onsubmit%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption,"text",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["text"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("text%0D%0A%09%22%20Return%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23text"));

smalltalk.bind(smalltalk.HTMLOption,"text:",0
,function(anObject){var self=this;
(self.handle()["text"]=(anObject));
return self;}
,"accessing",unescape("text%3A%20anObject%0D%0A%09%22%20Set%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23text%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption,"value",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["value"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23value"));

smalltalk.bind(smalltalk.HTMLOption,"value:",0
,function(anObject){var self=this;
(self.handle()["value"]=(anObject));
return self;}
,"accessing",unescape("value%3A%20anObject%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23value%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption,"selected",0
,function(){var self=this;
return (nil.is_eqeq_(true,self["@handle"].selected));}
,"accessing",unescape("selected%0D%0A%09%22%20Return%20the%20selected%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Etrue%20%3D%3D%20handle%23selected"));

smalltalk.bind(smalltalk.HTMLOption,"selected:",0
,function(anObject){var self=this;
(self.handle()["selected"]=(anObject));
return self;}
,"accessing",unescape("selected%3A%20anObject%0D%0A%09%22%20Set%20the%20selected%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23selected%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption,"disabled",0
,function(){var self=this;
return (nil.is_eqeq_(true,self["@handle"].disabled));}
,"accessing",unescape("disabled%0D%0A%09%22%20Return%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Etrue%20%3D%3D%20handle%23disabled"));

smalltalk.bind(smalltalk.HTMLOption,"disabled:",0
,function(anObject){var self=this;
(self.handle()["disabled"]=(anObject));
return self;}
,"accessing",unescape("disabled%3A%20anObject%0D%0A%09%22%20Set%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23disabled%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption,"index",0
,function(){var self=this;
return (self["@handle"].index || (0));}
,"accessing",unescape("index%0D%0A%09%22%20Return%20the%20index%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23index%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLOption,"index:",0
,function(anObject){var self=this;
(self.handle()["index"]=(anObject));
return self;}
,"accessing",unescape("index%3A%20anObject%0D%0A%09%22%20Set%20the%20index%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23index%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLOption,"defaultSelected",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["defaultSelected"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("defaultSelected%0D%0A%09%22%20Return%20the%20defaultSelected%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23defaultSelected"));

smalltalk.bind(smalltalk.HTMLOption,"form",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["form"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23form"));

smalltalk.bind(smalltalk.HTMLParagraph,"align",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["align"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23align"));

smalltalk.bind(smalltalk.HTMLParagraph,"align:",0
,function(anObject){var self=this;
(self.handle()["align"]=(anObject));
return self;}
,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23align%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLParam,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.HTMLParam,"name:",0
,function(anObject){var self=this;
(self.handle()["name"]=(anObject));
return self;}
,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23name%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLParam,"type",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["type"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23type"));

smalltalk.bind(smalltalk.HTMLParam,"type:",0
,function(anObject){var self=this;
(self.handle()["type"]=(anObject));
return self;}
,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23type%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLParam,"value",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["value"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23value"));

smalltalk.bind(smalltalk.HTMLParam,"value:",0
,function(anObject){var self=this;
(self.handle()["value"]=(anObject));
return self;}
,"accessing",unescape("value%3A%20anObject%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23value%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLParam,"valueType",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["valueType"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("valueType%0D%0A%09%22%20Return%20the%20valueType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23valueType"));

smalltalk.bind(smalltalk.HTMLParam,"valueType:",0
,function(anObject){var self=this;
(self.handle()["valueType"]=(anObject));
return self;}
,"accessing",unescape("valueType%3A%20anObject%0D%0A%09%22%20Set%20the%20valueType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23valueType%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLQuote,"cite",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["cite"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("cite%0D%0A%09%22%20Return%20the%20cite%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23cite"));

smalltalk.bind(smalltalk.HTMLQuote,"cite:",0
,function(anObject){var self=this;
(self.handle()["cite"]=(anObject));
return self;}
,"accessing",unescape("cite%3A%20anObject%0D%0A%09%22%20Set%20the%20cite%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23cite%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLScript,"charset",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["charset"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("charset%0D%0A%09%22%20Return%20the%20charset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23charset"));

smalltalk.bind(smalltalk.HTMLScript,"charset:",0
,function(anObject){var self=this;
(self.handle()["charset"]=(anObject));
return self;}
,"accessing",unescape("charset%3A%20anObject%0D%0A%09%22%20Set%20the%20charset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23charset%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLScript,"defer",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["defer"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("defer%0D%0A%09%22%20Return%20the%20defer%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23defer"));

smalltalk.bind(smalltalk.HTMLScript,"defer:",0
,function(anObject){var self=this;
(self.handle()["defer"]=(anObject));
return self;}
,"accessing",unescape("defer%3A%20anObject%0D%0A%09%22%20Set%20the%20defer%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23defer%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLScript,"event",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["event"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("event%0D%0A%09%22%20Return%20the%20event%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23event"));

smalltalk.bind(smalltalk.HTMLScript,"event:",0
,function(anObject){var self=this;
(self.handle()["event"]=(anObject));
return self;}
,"accessing",unescape("event%3A%20anObject%0D%0A%09%22%20Set%20the%20event%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23event%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLScript,"htmlFor",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["htmlFor"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("htmlFor%0D%0A%09%22%20Return%20the%20htmlFor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23htmlFor"));

smalltalk.bind(smalltalk.HTMLScript,"htmlFor:",0
,function(anObject){var self=this;
(self.handle()["htmlFor"]=(anObject));
return self;}
,"accessing",unescape("htmlFor%3A%20anObject%0D%0A%09%22%20Set%20the%20htmlFor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23htmlFor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLScript,"src",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["src"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("src%0D%0A%09%22%20Return%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23src"));

smalltalk.bind(smalltalk.HTMLScript,"src:",0
,function(anObject){var self=this;
(self.handle()["src"]=(anObject));
return self;}
,"accessing",unescape("src%3A%20anObject%0D%0A%09%22%20Set%20the%20src%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23src%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLScript,"text",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["text"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("text%0D%0A%09%22%20Return%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23text"));

smalltalk.bind(smalltalk.HTMLScript,"text:",0
,function(anObject){var self=this;
(self.handle()["text"]=(anObject));
return self;}
,"accessing",unescape("text%3A%20anObject%0D%0A%09%22%20Set%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23text%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLScript,"type",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["type"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23type"));

smalltalk.bind(smalltalk.HTMLScript,"type:",0
,function(anObject){var self=this;
(self.handle()["type"]=(anObject));
return self;}
,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23type%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLSelect,"size",0
,function(){var self=this;
return (self["@handle"].size || (0));}
,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23size%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLSelect,"size:",0
,function(anObject){var self=this;
(self.handle()["size"]=(anObject));
return self;}
,"accessing",unescape("size%3A%20anObject%0D%0A%09%22%20Set%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23size%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLSelect,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.HTMLSelect,"name:",0
,function(anObject){var self=this;
(self.handle()["name"]=(anObject));
return self;}
,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23name%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLSelect,"value",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["value"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23value"));

smalltalk.bind(smalltalk.HTMLSelect,"value:",0
,function(anObject){var self=this;
(self.handle()["value"]=(anObject));
return self;}
,"accessing",unescape("value%3A%20anObject%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23value%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLSelect,"disabled",0
,function(){var self=this;
return (nil.is_eqeq_(true,self["@handle"].disabled));}
,"accessing",unescape("disabled%0D%0A%09%22%20Return%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Etrue%20%3D%3D%20handle%23disabled"));

smalltalk.bind(smalltalk.HTMLSelect,"disabled:",0
,function(anObject){var self=this;
(self.handle()["disabled"]=(anObject));
return self;}
,"accessing",unescape("disabled%3A%20anObject%0D%0A%09%22%20Set%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23disabled%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLSelect,"multiple",0
,function(){var self=this;
return (nil.is_eqeq_(true,self["@handle"].multiple));}
,"accessing",unescape("multiple%0D%0A%09%22%20Return%20the%20multiple%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Etrue%20%3D%3D%20handle%23multiple"));

smalltalk.bind(smalltalk.HTMLSelect,"multiple:",0
,function(anObject){var self=this;
(self.handle()["multiple"]=(anObject));
return self;}
,"accessing",unescape("multiple%3A%20anObject%0D%0A%09%22%20Set%20the%20multiple%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23multiple%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLSelect,"length",0
,function(){var self=this;
return (self["@handle"].length || (0));}
,"accessing",unescape("length%0D%0A%09%22%20Return%20the%20length%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23length%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLSelect,"form",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["form"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23form"));

smalltalk.bind(smalltalk.HTMLSelect,"type",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["type"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23type"));

smalltalk.bind(smalltalk.HTMLStyle,"bottom",0
,function(){var self=this;
return self.pixelToNumber_(self["@handle"].bottom);}
,"accessing",unescape("bottom%0D%0A%09%22%20Return%20the%20bottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20pixelToNumber%3A%20handle%23bottom"));

smalltalk.bind(smalltalk.HTMLStyle,"bottom:",0
,function(aNumber){var self=this;
(self.handle()["bottom"]=(self.numberToPixel_(aNumber)));
return self;}
,"accessing",unescape("bottom%3A%20aNumber%0D%0A%09%22%20Set%20the%20bottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23bottom%20put%3A%20%28self%20numberToPixel%3A%20aNumber%29"));

smalltalk.bind(smalltalk.HTMLStyle,"left",0
,function(){var self=this;
return self.pixelToNumber_(self["@handle"].left);}
,"accessing",unescape("left%0D%0A%09%22%20Return%20the%20left%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20pixelToNumber%3A%20handle%23left"));

smalltalk.bind(smalltalk.HTMLStyle,"left:",0
,function(aNumber){var self=this;
(self.handle()["left"]=(self.numberToPixel_(aNumber)));
return self;}
,"accessing",unescape("left%3A%20aNumber%0D%0A%09%22%20Set%20the%20left%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23left%20put%3A%20%28self%20numberToPixel%3A%20aNumber%29"));

smalltalk.bind(smalltalk.HTMLStyle,"right",0
,function(){var self=this;
return self.pixelToNumber_(self["@handle"].right);}
,"accessing",unescape("right%0D%0A%09%22%20Return%20the%20right%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20pixelToNumber%3A%20handle%23right"));

smalltalk.bind(smalltalk.HTMLStyle,"right:",0
,function(aNumber){var self=this;
(self.handle()["right"]=(self.numberToPixel_(aNumber)));
return self;}
,"accessing",unescape("right%3A%20aNumber%0D%0A%09%22%20Set%20the%20right%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23right%20put%3A%20%28self%20numberToPixel%3A%20aNumber%29"));

smalltalk.bind(smalltalk.HTMLStyle,"top",0
,function(){var self=this;
return self.pixelToNumber_(self["@handle"].top);}
,"accessing",unescape("top%0D%0A%09%22%20Return%20the%20top%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20pixelToNumber%3A%20handle%23top"));

smalltalk.bind(smalltalk.HTMLStyle,"top:",0
,function(aNumber){var self=this;
(self.handle()["top"]=(self.numberToPixel_(aNumber)));
return self;}
,"accessing",unescape("top%3A%20aNumber%0D%0A%09%22%20Set%20the%20top%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23top%20put%3A%20%28self%20numberToPixel%3A%20aNumber%29"));

smalltalk.bind(smalltalk.HTMLStyle,"height",0
,function(){var self=this;
return self.pixelToNumber_(self["@handle"].height);}
,"accessing",unescape("height%0D%0A%09%22%20Return%20the%20height%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20pixelToNumber%3A%20handle%23height"));

smalltalk.bind(smalltalk.HTMLStyle,"height:",0
,function(aNumber){var self=this;
(self.handle()["height"]=(self.numberToPixel_(aNumber)));
return self;}
,"accessing",unescape("height%3A%20aNumber%0D%0A%09%22%20Set%20the%20height%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23height%20put%3A%20%28self%20numberToPixel%3A%20aNumber%29"));

smalltalk.bind(smalltalk.HTMLStyle,"width",0
,function(){var self=this;
return self.pixelToNumber_(self["@handle"].width);}
,"accessing",unescape("width%0D%0A%09%22%20Return%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20pixelToNumber%3A%20handle%23width"));

smalltalk.bind(smalltalk.HTMLStyle,"width:",0
,function(aNumber){var self=this;
(self.handle()["width"]=(self.numberToPixel_(aNumber)));
return self;}
,"accessing",unescape("width%3A%20aNumber%0D%0A%09%22%20Set%20the%20width%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23width%20put%3A%20%28self%20numberToPixel%3A%20aNumber%29"));

smalltalk.bind(smalltalk.HTMLStyle,"minHeight",0
,function(){var self=this;
return self.pixelToNumber_(self["@handle"].minHeight);}
,"accessing",unescape("minHeight%0D%0A%09%22%20Return%20the%20minHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20pixelToNumber%3A%20handle%23minHeight"));

smalltalk.bind(smalltalk.HTMLStyle,"minHeight:",0
,function(aNumber){var self=this;
(self.handle()["minHeight"]=(self.numberToPixel_(aNumber)));
return self;}
,"accessing",unescape("minHeight%3A%20aNumber%0D%0A%09%22%20Set%20the%20minHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23minHeight%20put%3A%20%28self%20numberToPixel%3A%20aNumber%29"));

smalltalk.bind(smalltalk.HTMLStyle,"maxHeight",0
,function(){var self=this;
return self.pixelToNumber_(self["@handle"].maxHeight);}
,"accessing",unescape("maxHeight%0D%0A%09%22%20Return%20the%20maxHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20pixelToNumber%3A%20handle%23maxHeight"));

smalltalk.bind(smalltalk.HTMLStyle,"maxHeight:",0
,function(aNumber){var self=this;
(self.handle()["maxHeight"]=(self.numberToPixel_(aNumber)));
return self;}
,"accessing",unescape("maxHeight%3A%20aNumber%0D%0A%09%22%20Set%20the%20maxHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23maxHeight%20put%3A%20%28self%20numberToPixel%3A%20aNumber%29"));

smalltalk.bind(smalltalk.HTMLStyle,"minWidth",0
,function(){var self=this;
return self.pixelToNumber_(self["@handle"].minWidth);}
,"accessing",unescape("minWidth%0D%0A%09%22%20Return%20the%20minWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20pixelToNumber%3A%20handle%23minWidth"));

smalltalk.bind(smalltalk.HTMLStyle,"minWidth:",0
,function(aNumber){var self=this;
(self.handle()["minWidth"]=(self.numberToPixel_(aNumber)));
return self;}
,"accessing",unescape("minWidth%3A%20aNumber%0D%0A%09%22%20Set%20the%20minWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23minWidth%20put%3A%20%28self%20numberToPixel%3A%20aNumber%29"));

smalltalk.bind(smalltalk.HTMLStyle,"maxWidth",0
,function(){var self=this;
return self.pixelToNumber_(self["@handle"].maxWidth);}
,"accessing",unescape("maxWidth%0D%0A%09%22%20Return%20the%20maxWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20pixelToNumber%3A%20handle%23maxWidth"));

smalltalk.bind(smalltalk.HTMLStyle,"maxWidth:",0
,function(aNumber){var self=this;
(self.handle()["maxWidth"]=(self.numberToPixel_(aNumber)));
return self;}
,"accessing",unescape("maxWidth%3A%20aNumber%0D%0A%09%22%20Set%20the%20maxWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23maxWidth%20put%3A%20%28self%20numberToPixel%3A%20aNumber%29"));

smalltalk.bind(smalltalk.HTMLStyle,"wordBreak",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["wordBreak"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("wordBreak%0D%0A%09%22%20Return%20the%20wordBreak%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23wordBreak"));

smalltalk.bind(smalltalk.HTMLStyle,"wordBreak:",0
,function(anObject){var self=this;
(self.handle()["wordBreak"]=(anObject));
return self;}
,"accessing",unescape("wordBreak%3A%20anObject%0D%0A%09%22%20Set%20the%20wordBreak%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23wordBreak%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backfaceVisibility",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["backfaceVisibility"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("backfaceVisibility%0D%0A%09%22%20Return%20the%20backfaceVisibility%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23backfaceVisibility"));

smalltalk.bind(smalltalk.HTMLStyle,"backfaceVisibility:",0
,function(anObject){var self=this;
(self.handle()["backfaceVisibility"]=(anObject));
return self;}
,"accessing",unescape("backfaceVisibility%3A%20anObject%0D%0A%09%22%20Set%20the%20backfaceVisibility%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23backfaceVisibility%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"alignContent",0
,function(){var self=this;
return (self["@handle"].alignContent || (0));}
,"accessing",unescape("alignContent%0D%0A%09%22%20Return%20the%20alignContent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23alignContent%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"alignContent:",0
,function(anObject){var self=this;
(self.handle()["alignContent"]=(anObject));
return self;}
,"accessing",unescape("alignContent%3A%20anObject%0D%0A%09%22%20Set%20the%20alignContent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23alignContent%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"alignItems",0
,function(){var self=this;
return (self["@handle"].alignItems || (0));}
,"accessing",unescape("alignItems%0D%0A%09%22%20Return%20the%20alignItems%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23alignItems%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"alignItems:",0
,function(anObject){var self=this;
(self.handle()["alignItems"]=(anObject));
return self;}
,"accessing",unescape("alignItems%3A%20anObject%0D%0A%09%22%20Set%20the%20alignItems%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23alignItems%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"alignSelf",0
,function(){var self=this;
return (self["@handle"].alignSelf || (0));}
,"accessing",unescape("alignSelf%0D%0A%09%22%20Return%20the%20alignSelf%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23alignSelf%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"alignSelf:",0
,function(anObject){var self=this;
(self.handle()["alignSelf"]=(anObject));
return self;}
,"accessing",unescape("alignSelf%3A%20anObject%0D%0A%09%22%20Set%20the%20alignSelf%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23alignSelf%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"all",0
,function(){var self=this;
return (self["@handle"].all || (0));}
,"accessing",unescape("all%0D%0A%09%22%20Return%20the%20all%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23all%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"all:",0
,function(anObject){var self=this;
(self.handle()["all"]=(anObject));
return self;}
,"accessing",unescape("all%3A%20anObject%0D%0A%09%22%20Set%20the%20all%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23all%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animationFillMode",0
,function(){var self=this;
return (self["@handle"].animationFillMode || (0));}
,"accessing",unescape("animationFillMode%0D%0A%09%22%20Return%20the%20animationFillMode%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animationFillMode%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animationFillMode:",0
,function(anObject){var self=this;
(self.handle()["animationFillMode"]=(anObject));
return self;}
,"accessing",unescape("animationFillMode%3A%20anObject%0D%0A%09%22%20Set%20the%20animationFillMode%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23animationFillMode%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animationName",0
,function(){var self=this;
return (self["@handle"].animationName || (0));}
,"accessing",unescape("animationName%0D%0A%09%22%20Return%20the%20animationName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animationName%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animationName:",0
,function(anObject){var self=this;
(self.handle()["animationName"]=(anObject));
return self;}
,"accessing",unescape("animationName%3A%20anObject%0D%0A%09%22%20Set%20the%20animationName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23animationName%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animationPlayState",0
,function(){var self=this;
return (self["@handle"].animationPlayState || (0));}
,"accessing",unescape("animationPlayState%0D%0A%09%22%20Return%20the%20animationPlayState%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animationPlayState%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animationPlayState:",0
,function(anObject){var self=this;
(self.handle()["animationPlayState"]=(anObject));
return self;}
,"accessing",unescape("animationPlayState%3A%20anObject%0D%0A%09%22%20Set%20the%20animationPlayState%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23animationPlayState%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animationTimingFunction",0
,function(){var self=this;
return (self["@handle"].animationTimingFunction || (0));}
,"accessing",unescape("animationTimingFunction%0D%0A%09%22%20Return%20the%20animationTimingFunction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animationTimingFunction%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animationTimingFunction:",0
,function(anObject){var self=this;
(self.handle()["animationTimingFunction"]=(anObject));
return self;}
,"accessing",unescape("animationTimingFunction%3A%20anObject%0D%0A%09%22%20Set%20the%20animationTimingFunction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23animationTimingFunction%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animation",0
,function(){var self=this;
return (self["@handle"].animation || (0));}
,"accessing",unescape("animation%0D%0A%09%22%20Return%20the%20animation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animation%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animation:",0
,function(anObject){var self=this;
(self.handle()["animation"]=(anObject));
return self;}
,"accessing",unescape("animation%3A%20anObject%0D%0A%09%22%20Set%20the%20animation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23animation%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animationDuration",0
,function(){var self=this;
return (self["@handle"].animationDuration || (0));}
,"accessing",unescape("animationDuration%0D%0A%09%22%20Return%20the%20animationDuration%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animationDuration%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animationDuration:",0
,function(anObject){var self=this;
(self.handle()["animationDuration"]=(anObject));
return self;}
,"accessing",unescape("animationDuration%3A%20anObject%0D%0A%09%22%20Set%20the%20animationDuration%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23animationDuration%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animationDelay",0
,function(){var self=this;
return (self["@handle"].animationDelay || (0));}
,"accessing",unescape("animationDelay%0D%0A%09%22%20Return%20the%20animationDelay%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animationDelay%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animationDelay:",0
,function(anObject){var self=this;
(self.handle()["animationDelay"]=(anObject));
return self;}
,"accessing",unescape("animationDelay%3A%20anObject%0D%0A%09%22%20Set%20the%20animationDelay%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23animationDelay%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animationIterationCount",0
,function(){var self=this;
return (self["@handle"].animationIterationCount || (0));}
,"accessing",unescape("animationIterationCount%0D%0A%09%22%20Return%20the%20animationIterationCount%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animationIterationCount%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animationIterationCount:",0
,function(anObject){var self=this;
(self.handle()["animationIterationCount"]=(anObject));
return self;}
,"accessing",unescape("animationIterationCount%3A%20anObject%0D%0A%09%22%20Set%20the%20animationIterationCount%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23animationIterationCount%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"animationDirection",0
,function(){var self=this;
return (self["@handle"].animationDirection || (0));}
,"accessing",unescape("animationDirection%0D%0A%09%22%20Return%20the%20animationDirection%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23animationDirection%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"animationDirection:",0
,function(anObject){var self=this;
(self.handle()["animationDirection"]=(anObject));
return self;}
,"accessing",unescape("animationDirection%3A%20anObject%0D%0A%09%22%20Set%20the%20animationDirection%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23animationDirection%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"appearance",0
,function(){var self=this;
return (self["@handle"].appearance || (0));}
,"accessing",unescape("appearance%0D%0A%09%22%20Return%20the%20appearance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23appearance%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"appearance:",0
,function(anObject){var self=this;
(self.handle()["appearance"]=(anObject));
return self;}
,"accessing",unescape("appearance%3A%20anObject%0D%0A%09%22%20Set%20the%20appearance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23appearance%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundSize",0
,function(){var self=this;
return (self["@handle"].backgroundSize || (0));}
,"accessing",unescape("backgroundSize%0D%0A%09%22%20Return%20the%20backgroundSize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundSize%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundSize:",0
,function(anObject){var self=this;
(self.handle()["backgroundSize"]=(anObject));
return self;}
,"accessing",unescape("backgroundSize%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundSize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23backgroundSize%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"background",0
,function(){var self=this;
return (self["@handle"].background || (0));}
,"accessing",unescape("background%0D%0A%09%22%20Return%20the%20background%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23background%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"background:",0
,function(anObject){var self=this;
(self.handle()["background"]=(anObject));
return self;}
,"accessing",unescape("background%3A%20anObject%0D%0A%09%22%20Set%20the%20background%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23background%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundAttachment",0
,function(){var self=this;
return (self["@handle"].backgroundAttachment || (0));}
,"accessing",unescape("backgroundAttachment%0D%0A%09%22%20Return%20the%20backgroundAttachment%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundAttachment%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundAttachment:",0
,function(anObject){var self=this;
(self.handle()["backgroundAttachment"]=(anObject));
return self;}
,"accessing",unescape("backgroundAttachment%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundAttachment%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23backgroundAttachment%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundColor",0
,function(){var self=this;
return (self["@handle"].backgroundColor || (0));}
,"accessing",unescape("backgroundColor%0D%0A%09%22%20Return%20the%20backgroundColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundColor:",0
,function(anObject){var self=this;
(self.handle()["backgroundColor"]=(anObject));
return self;}
,"accessing",unescape("backgroundColor%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23backgroundColor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundImage",0
,function(){var self=this;
return (self["@handle"].backgroundImage || (0));}
,"accessing",unescape("backgroundImage%0D%0A%09%22%20Return%20the%20backgroundImage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundImage%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundImage:",0
,function(anObject){var self=this;
(self.handle()["backgroundImage"]=(anObject));
return self;}
,"accessing",unescape("backgroundImage%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundImage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23backgroundImage%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundPosition",0
,function(){var self=this;
return (self["@handle"].backgroundPosition || (0));}
,"accessing",unescape("backgroundPosition%0D%0A%09%22%20Return%20the%20backgroundPosition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundPosition%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundPosition:",0
,function(anObject){var self=this;
(self.handle()["backgroundPosition"]=(anObject));
return self;}
,"accessing",unescape("backgroundPosition%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundPosition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23backgroundPosition%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundRepeat",0
,function(){var self=this;
return (self["@handle"].backgroundRepeat || (0));}
,"accessing",unescape("backgroundRepeat%0D%0A%09%22%20Return%20the%20backgroundRepeat%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundRepeat%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundRepeat:",0
,function(anObject){var self=this;
(self.handle()["backgroundRepeat"]=(anObject));
return self;}
,"accessing",unescape("backgroundRepeat%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundRepeat%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23backgroundRepeat%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundClip",0
,function(){var self=this;
return (self["@handle"].backgroundClip || (0));}
,"accessing",unescape("backgroundClip%0D%0A%09%22%20Return%20the%20backgroundClip%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundClip%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundClip:",0
,function(anObject){var self=this;
(self.handle()["backgroundClip"]=(anObject));
return self;}
,"accessing",unescape("backgroundClip%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundClip%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23backgroundClip%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundOrigin",0
,function(){var self=this;
return (self["@handle"].backgroundOrigin || (0));}
,"accessing",unescape("backgroundOrigin%0D%0A%09%22%20Return%20the%20backgroundOrigin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23backgroundOrigin%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"backgroundOrigin:",0
,function(anObject){var self=this;
(self.handle()["backgroundOrigin"]=(anObject));
return self;}
,"accessing",unescape("backgroundOrigin%3A%20anObject%0D%0A%09%22%20Set%20the%20backgroundOrigin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23backgroundOrigin%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"border",0
,function(){var self=this;
return (self["@handle"].border || (0));}
,"accessing",unescape("border%0D%0A%09%22%20Return%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23border%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"border:",0
,function(anObject){var self=this;
(self.handle()["border"]=(anObject));
return self;}
,"accessing",unescape("border%3A%20anObject%0D%0A%09%22%20Set%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23border%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderCollapse",0
,function(){var self=this;
return (self["@handle"].borderCollapse || (0));}
,"accessing",unescape("borderCollapse%0D%0A%09%22%20Return%20the%20borderCollapse%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderCollapse%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderCollapse:",0
,function(anObject){var self=this;
(self.handle()["borderCollapse"]=(anObject));
return self;}
,"accessing",unescape("borderCollapse%3A%20anObject%0D%0A%09%22%20Set%20the%20borderCollapse%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderCollapse%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderColor",0
,function(){var self=this;
return (self["@handle"].borderColor || (0));}
,"accessing",unescape("borderColor%0D%0A%09%22%20Return%20the%20borderColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderColor:",0
,function(anObject){var self=this;
(self.handle()["borderColor"]=(anObject));
return self;}
,"accessing",unescape("borderColor%3A%20anObject%0D%0A%09%22%20Set%20the%20borderColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderColor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderStyle",0
,function(){var self=this;
return (self["@handle"].borderStyle || (0));}
,"accessing",unescape("borderStyle%0D%0A%09%22%20Return%20the%20borderStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderStyle:",0
,function(anObject){var self=this;
(self.handle()["borderStyle"]=(anObject));
return self;}
,"accessing",unescape("borderStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20borderStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderStyle%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderWidth",0
,function(){var self=this;
return (self["@handle"].borderWidth || (0));}
,"accessing",unescape("borderWidth%0D%0A%09%22%20Return%20the%20borderWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderWidth:",0
,function(anObject){var self=this;
(self.handle()["borderWidth"]=(anObject));
return self;}
,"accessing",unescape("borderWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20borderWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottom",0
,function(){var self=this;
return (self["@handle"].borderBottom || (0));}
,"accessing",unescape("borderBottom%0D%0A%09%22%20Return%20the%20borderBottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderBottom%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottom:",0
,function(anObject){var self=this;
(self.handle()["borderBottom"]=(anObject));
return self;}
,"accessing",unescape("borderBottom%3A%20anObject%0D%0A%09%22%20Set%20the%20borderBottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderBottom%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomColor",0
,function(){var self=this;
return (self["@handle"].borderBottomColor || (0));}
,"accessing",unescape("borderBottomColor%0D%0A%09%22%20Return%20the%20borderBottomColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderBottomColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomColor:",0
,function(anObject){var self=this;
(self.handle()["borderBottomColor"]=(anObject));
return self;}
,"accessing",unescape("borderBottomColor%3A%20anObject%0D%0A%09%22%20Set%20the%20borderBottomColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderBottomColor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomStyle",0
,function(){var self=this;
return (self["@handle"].borderBottomStyle || (0));}
,"accessing",unescape("borderBottomStyle%0D%0A%09%22%20Return%20the%20borderBottomStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderBottomStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomStyle:",0
,function(anObject){var self=this;
(self.handle()["borderBottomStyle"]=(anObject));
return self;}
,"accessing",unescape("borderBottomStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20borderBottomStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderBottomStyle%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomWidth",0
,function(){var self=this;
return (self["@handle"].borderBottomWidth || (0));}
,"accessing",unescape("borderBottomWidth%0D%0A%09%22%20Return%20the%20borderBottomWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderBottomWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomWidth:",0
,function(anObject){var self=this;
(self.handle()["borderBottomWidth"]=(anObject));
return self;}
,"accessing",unescape("borderBottomWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20borderBottomWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderBottomWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeft",0
,function(){var self=this;
return (self["@handle"].borderLeft || (0));}
,"accessing",unescape("borderLeft%0D%0A%09%22%20Return%20the%20borderLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderLeft%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeft:",0
,function(anObject){var self=this;
(self.handle()["borderLeft"]=(anObject));
return self;}
,"accessing",unescape("borderLeft%3A%20anObject%0D%0A%09%22%20Set%20the%20borderLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderLeft%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeftColor",0
,function(){var self=this;
return (self["@handle"].borderLeftColor || (0));}
,"accessing",unescape("borderLeftColor%0D%0A%09%22%20Return%20the%20borderLeftColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderLeftColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeftColor:",0
,function(anObject){var self=this;
(self.handle()["borderLeftColor"]=(anObject));
return self;}
,"accessing",unescape("borderLeftColor%3A%20anObject%0D%0A%09%22%20Set%20the%20borderLeftColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderLeftColor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeftStyle",0
,function(){var self=this;
return (self["@handle"].borderLeftStyle || (0));}
,"accessing",unescape("borderLeftStyle%0D%0A%09%22%20Return%20the%20borderLeftStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderLeftStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeftStyle:",0
,function(anObject){var self=this;
(self.handle()["borderLeftStyle"]=(anObject));
return self;}
,"accessing",unescape("borderLeftStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20borderLeftStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderLeftStyle%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeftWidth",0
,function(){var self=this;
return (self["@handle"].borderLeftWidth || (0));}
,"accessing",unescape("borderLeftWidth%0D%0A%09%22%20Return%20the%20borderLeftWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderLeftWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderLeftWidth:",0
,function(anObject){var self=this;
(self.handle()["borderLeftWidth"]=(anObject));
return self;}
,"accessing",unescape("borderLeftWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20borderLeftWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderLeftWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRight",0
,function(){var self=this;
return (self["@handle"].borderRight || (0));}
,"accessing",unescape("borderRight%0D%0A%09%22%20Return%20the%20borderRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderRight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRight:",0
,function(anObject){var self=this;
(self.handle()["borderRight"]=(anObject));
return self;}
,"accessing",unescape("borderRight%3A%20anObject%0D%0A%09%22%20Set%20the%20borderRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderRight%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRightColor",0
,function(){var self=this;
return (self["@handle"].borderRightColor || (0));}
,"accessing",unescape("borderRightColor%0D%0A%09%22%20Return%20the%20borderRightColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderRightColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRightColor:",0
,function(anObject){var self=this;
(self.handle()["borderRightColor"]=(anObject));
return self;}
,"accessing",unescape("borderRightColor%3A%20anObject%0D%0A%09%22%20Set%20the%20borderRightColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderRightColor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRightStyle",0
,function(){var self=this;
return (self["@handle"].borderRightStyle || (0));}
,"accessing",unescape("borderRightStyle%0D%0A%09%22%20Return%20the%20borderRightStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderRightStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRightStyle:",0
,function(anObject){var self=this;
(self.handle()["borderRightStyle"]=(anObject));
return self;}
,"accessing",unescape("borderRightStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20borderRightStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderRightStyle%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRightWidth",0
,function(){var self=this;
return (self["@handle"].borderRightWidth || (0));}
,"accessing",unescape("borderRightWidth%0D%0A%09%22%20Return%20the%20borderRightWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderRightWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRightWidth:",0
,function(anObject){var self=this;
(self.handle()["borderRightWidth"]=(anObject));
return self;}
,"accessing",unescape("borderRightWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20borderRightWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderRightWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderSpacing",0
,function(){var self=this;
return (self["@handle"].borderSpacing || (0));}
,"accessing",unescape("borderSpacing%0D%0A%09%22%20Return%20the%20borderSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderSpacing%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderSpacing:",0
,function(anObject){var self=this;
(self.handle()["borderSpacing"]=(anObject));
return self;}
,"accessing",unescape("borderSpacing%3A%20anObject%0D%0A%09%22%20Set%20the%20borderSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderSpacing%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderStyle",0
,function(){var self=this;
return (self["@handle"].borderStyle || (0));}
,"accessing",unescape("borderStyle%0D%0A%09%22%20Return%20the%20borderStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderStyle:",0
,function(anObject){var self=this;
(self.handle()["borderStyle"]=(anObject));
return self;}
,"accessing",unescape("borderStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20borderStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderStyle%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTop",0
,function(){var self=this;
return (self["@handle"].borderTop || (0));}
,"accessing",unescape("borderTop%0D%0A%09%22%20Return%20the%20borderTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderTop%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTop:",0
,function(anObject){var self=this;
(self.handle()["borderTop"]=(anObject));
return self;}
,"accessing",unescape("borderTop%3A%20anObject%0D%0A%09%22%20Set%20the%20borderTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderTop%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopColor",0
,function(){var self=this;
return (self["@handle"].borderTopColor || (0));}
,"accessing",unescape("borderTopColor%0D%0A%09%22%20Return%20the%20borderTopColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderTopColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopColor:",0
,function(anObject){var self=this;
(self.handle()["borderTopColor"]=(anObject));
return self;}
,"accessing",unescape("borderTopColor%3A%20anObject%0D%0A%09%22%20Set%20the%20borderTopColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderTopColor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopStyle",0
,function(){var self=this;
return (self["@handle"].borderTopStyle || (0));}
,"accessing",unescape("borderTopStyle%0D%0A%09%22%20Return%20the%20borderTopStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderTopStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopStyle:",0
,function(anObject){var self=this;
(self.handle()["borderTopStyle"]=(anObject));
return self;}
,"accessing",unescape("borderTopStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20borderTopStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderTopStyle%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopWidth",0
,function(){var self=this;
return (self["@handle"].borderTopWidth || (0));}
,"accessing",unescape("borderTopWidth%0D%0A%09%22%20Return%20the%20borderTopWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderTopWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopWidth:",0
,function(anObject){var self=this;
(self.handle()["borderTopWidth"]=(anObject));
return self;}
,"accessing",unescape("borderTopWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20borderTopWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderTopWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderWidth",0
,function(){var self=this;
return (self["@handle"].borderWidth || (0));}
,"accessing",unescape("borderWidth%0D%0A%09%22%20Return%20the%20borderWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderWidth:",0
,function(anObject){var self=this;
(self.handle()["borderWidth"]=(anObject));
return self;}
,"accessing",unescape("borderWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20borderWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomLeftRadius",0
,function(){var self=this;
return (self["@handle"].borderBottomLeftRadius || (0));}
,"accessing",unescape("borderBottomLeftRadius%0D%0A%09%22%20Return%20the%20borderBottomLeftRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderBottomLeftRadius%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomLeftRadius:",0
,function(anObject){var self=this;
(self.handle()["borderBottomLeftRadius"]=(anObject));
return self;}
,"accessing",unescape("borderBottomLeftRadius%3A%20anObject%0D%0A%09%22%20Set%20the%20borderBottomLeftRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderBottomLeftRadius%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomRightRadius",0
,function(){var self=this;
return (self["@handle"].borderBottomRightRadius || (0));}
,"accessing",unescape("borderBottomRightRadius%0D%0A%09%22%20Return%20the%20borderBottomRightRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderBottomRightRadius%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderBottomRightRadius:",0
,function(anObject){var self=this;
(self.handle()["borderBottomRightRadius"]=(anObject));
return self;}
,"accessing",unescape("borderBottomRightRadius%3A%20anObject%0D%0A%09%22%20Set%20the%20borderBottomRightRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderBottomRightRadius%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImage",0
,function(){var self=this;
return (self["@handle"].borderImage || (0));}
,"accessing",unescape("borderImage%0D%0A%09%22%20Return%20the%20borderImage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderImage%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImage:",0
,function(anObject){var self=this;
(self.handle()["borderImage"]=(anObject));
return self;}
,"accessing",unescape("borderImage%3A%20anObject%0D%0A%09%22%20Set%20the%20borderImage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderImage%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageOutset",0
,function(){var self=this;
return (self["@handle"].borderImageOutset || (0));}
,"accessing",unescape("borderImageOutset%0D%0A%09%22%20Return%20the%20borderImageOutset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderImageOutset%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageOutset:",0
,function(anObject){var self=this;
(self.handle()["borderImageOutset"]=(anObject));
return self;}
,"accessing",unescape("borderImageOutset%3A%20anObject%0D%0A%09%22%20Set%20the%20borderImageOutset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderImageOutset%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageRepeat",0
,function(){var self=this;
return (self["@handle"].borderImageRepeat || (0));}
,"accessing",unescape("borderImageRepeat%0D%0A%09%22%20Return%20the%20borderImageRepeat%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderImageRepeat%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageRepeat:",0
,function(anObject){var self=this;
(self.handle()["borderImageRepeat"]=(anObject));
return self;}
,"accessing",unescape("borderImageRepeat%3A%20anObject%0D%0A%09%22%20Set%20the%20borderImageRepeat%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderImageRepeat%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageSlice",0
,function(){var self=this;
return (self["@handle"].borderImageSlice || (0));}
,"accessing",unescape("borderImageSlice%0D%0A%09%22%20Return%20the%20borderImageSlice%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderImageSlice%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageSlice:",0
,function(anObject){var self=this;
(self.handle()["borderImageSlice"]=(anObject));
return self;}
,"accessing",unescape("borderImageSlice%3A%20anObject%0D%0A%09%22%20Set%20the%20borderImageSlice%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderImageSlice%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageSource",0
,function(){var self=this;
return (self["@handle"].borderImageSource || (0));}
,"accessing",unescape("borderImageSource%0D%0A%09%22%20Return%20the%20borderImageSource%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderImageSource%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageSource:",0
,function(anObject){var self=this;
(self.handle()["borderImageSource"]=(anObject));
return self;}
,"accessing",unescape("borderImageSource%3A%20anObject%0D%0A%09%22%20Set%20the%20borderImageSource%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderImageSource%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageWidth",0
,function(){var self=this;
return (self["@handle"].borderImageWidth || (0));}
,"accessing",unescape("borderImageWidth%0D%0A%09%22%20Return%20the%20borderImageWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderImageWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderImageWidth:",0
,function(anObject){var self=this;
(self.handle()["borderImageWidth"]=(anObject));
return self;}
,"accessing",unescape("borderImageWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20borderImageWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderImageWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRadius",0
,function(){var self=this;
return (self["@handle"].borderRadius || (0));}
,"accessing",unescape("borderRadius%0D%0A%09%22%20Return%20the%20borderRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderRadius%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderRadius:",0
,function(anObject){var self=this;
(self.handle()["borderRadius"]=(anObject));
return self;}
,"accessing",unescape("borderRadius%3A%20anObject%0D%0A%09%22%20Set%20the%20borderRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderRadius%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopLeftRadius",0
,function(){var self=this;
return (self["@handle"].borderTopLeftRadius || (0));}
,"accessing",unescape("borderTopLeftRadius%0D%0A%09%22%20Return%20the%20borderTopLeftRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderTopLeftRadius%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopLeftRadius:",0
,function(anObject){var self=this;
(self.handle()["borderTopLeftRadius"]=(anObject));
return self;}
,"accessing",unescape("borderTopLeftRadius%3A%20anObject%0D%0A%09%22%20Set%20the%20borderTopLeftRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderTopLeftRadius%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopRightRadius",0
,function(){var self=this;
return (self["@handle"].borderTopRightRadius || (0));}
,"accessing",unescape("borderTopRightRadius%0D%0A%09%22%20Return%20the%20borderTopRightRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderTopRightRadius%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderTopRightRadius:",0
,function(anObject){var self=this;
(self.handle()["borderTopRightRadius"]=(anObject));
return self;}
,"accessing",unescape("borderTopRightRadius%3A%20anObject%0D%0A%09%22%20Set%20the%20borderTopRightRadius%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderTopRightRadius%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxAlign",0
,function(){var self=this;
return (self["@handle"].boxAlign || (0));}
,"accessing",unescape("boxAlign%0D%0A%09%22%20Return%20the%20boxAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxAlign%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxAlign:",0
,function(anObject){var self=this;
(self.handle()["boxAlign"]=(anObject));
return self;}
,"accessing",unescape("boxAlign%3A%20anObject%0D%0A%09%22%20Set%20the%20boxAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23boxAlign%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxDirection",0
,function(){var self=this;
return (self["@handle"].boxDirection || (0));}
,"accessing",unescape("boxDirection%0D%0A%09%22%20Return%20the%20boxDirection%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxDirection%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxDirection:",0
,function(anObject){var self=this;
(self.handle()["boxDirection"]=(anObject));
return self;}
,"accessing",unescape("boxDirection%3A%20anObject%0D%0A%09%22%20Set%20the%20boxDirection%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23boxDirection%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxFlex",0
,function(){var self=this;
return (self["@handle"].boxFlex || (0));}
,"accessing",unescape("boxFlex%0D%0A%09%22%20Return%20the%20boxFlex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxFlex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxFlex:",0
,function(anObject){var self=this;
(self.handle()["boxFlex"]=(anObject));
return self;}
,"accessing",unescape("boxFlex%3A%20anObject%0D%0A%09%22%20Set%20the%20boxFlex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23boxFlex%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxFlexGroup",0
,function(){var self=this;
return (self["@handle"].boxFlexGroup || (0));}
,"accessing",unescape("boxFlexGroup%0D%0A%09%22%20Return%20the%20boxFlexGroup%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxFlexGroup%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxFlexGroup:",0
,function(anObject){var self=this;
(self.handle()["boxFlexGroup"]=(anObject));
return self;}
,"accessing",unescape("boxFlexGroup%3A%20anObject%0D%0A%09%22%20Set%20the%20boxFlexGroup%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23boxFlexGroup%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxLines",0
,function(){var self=this;
return (self["@handle"].boxLines || (0));}
,"accessing",unescape("boxLines%0D%0A%09%22%20Return%20the%20boxLines%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxLines%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxLines:",0
,function(anObject){var self=this;
(self.handle()["boxLines"]=(anObject));
return self;}
,"accessing",unescape("boxLines%3A%20anObject%0D%0A%09%22%20Set%20the%20boxLines%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23boxLines%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxOrdinalGroup",0
,function(){var self=this;
return (self["@handle"].boxOrdinalGroup || (0));}
,"accessing",unescape("boxOrdinalGroup%0D%0A%09%22%20Return%20the%20boxOrdinalGroup%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxOrdinalGroup%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxOrdinalGroup:",0
,function(anObject){var self=this;
(self.handle()["boxOrdinalGroup"]=(anObject));
return self;}
,"accessing",unescape("boxOrdinalGroup%3A%20anObject%0D%0A%09%22%20Set%20the%20boxOrdinalGroup%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23boxOrdinalGroup%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxOrient",0
,function(){var self=this;
return (self["@handle"].boxOrient || (0));}
,"accessing",unescape("boxOrient%0D%0A%09%22%20Return%20the%20boxOrient%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxOrient%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxOrient:",0
,function(anObject){var self=this;
(self.handle()["boxOrient"]=(anObject));
return self;}
,"accessing",unescape("boxOrient%3A%20anObject%0D%0A%09%22%20Set%20the%20boxOrient%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23boxOrient%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxPack",0
,function(){var self=this;
return (self["@handle"].boxPack || (0));}
,"accessing",unescape("boxPack%0D%0A%09%22%20Return%20the%20boxPack%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxPack%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxPack:",0
,function(anObject){var self=this;
(self.handle()["boxPack"]=(anObject));
return self;}
,"accessing",unescape("boxPack%3A%20anObject%0D%0A%09%22%20Set%20the%20boxPack%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23boxPack%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxSizing",0
,function(){var self=this;
return (self["@handle"].boxSizing || (0));}
,"accessing",unescape("boxSizing%0D%0A%09%22%20Return%20the%20boxSizing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxSizing%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxSizing:",0
,function(anObject){var self=this;
(self.handle()["boxSizing"]=(anObject));
return self;}
,"accessing",unescape("boxSizing%3A%20anObject%0D%0A%09%22%20Set%20the%20boxSizing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23boxSizing%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"boxShadow",0
,function(){var self=this;
return (self["@handle"].boxShadow || (0));}
,"accessing",unescape("boxShadow%0D%0A%09%22%20Return%20the%20boxShadow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23boxShadow%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"boxShadow:",0
,function(anObject){var self=this;
(self.handle()["boxShadow"]=(anObject));
return self;}
,"accessing",unescape("boxShadow%3A%20anObject%0D%0A%09%22%20Set%20the%20boxShadow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23boxShadow%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"caretColor",0
,function(){var self=this;
return (self["@handle"].caretColor || (0));}
,"accessing",unescape("caretColor%0D%0A%09%22%20Return%20the%20caretColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23caretColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"caretColor:",0
,function(anObject){var self=this;
(self.handle()["caretColor"]=(anObject));
return self;}
,"accessing",unescape("caretColor%3A%20anObject%0D%0A%09%22%20Set%20the%20caretColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23caretColor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnCount",0
,function(){var self=this;
return (self["@handle"].columnCount || (0));}
,"accessing",unescape("columnCount%0D%0A%09%22%20Return%20the%20columnCount%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnCount%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnCount:",0
,function(anObject){var self=this;
(self.handle()["columnCount"]=(anObject));
return self;}
,"accessing",unescape("columnCount%3A%20anObject%0D%0A%09%22%20Set%20the%20columnCount%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23columnCount%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnFill",0
,function(){var self=this;
return (self["@handle"].columnFill || (0));}
,"accessing",unescape("columnFill%0D%0A%09%22%20Return%20the%20columnFill%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnFill%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnFill:",0
,function(anObject){var self=this;
(self.handle()["columnFill"]=(anObject));
return self;}
,"accessing",unescape("columnFill%3A%20anObject%0D%0A%09%22%20Set%20the%20columnFill%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23columnFill%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnGap",0
,function(){var self=this;
return (self["@handle"].columnGap || (0));}
,"accessing",unescape("columnGap%0D%0A%09%22%20Return%20the%20columnGap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnGap%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnGap:",0
,function(anObject){var self=this;
(self.handle()["columnGap"]=(anObject));
return self;}
,"accessing",unescape("columnGap%3A%20anObject%0D%0A%09%22%20Set%20the%20columnGap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23columnGap%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRule",0
,function(){var self=this;
return (self["@handle"].columnRule || (0));}
,"accessing",unescape("columnRule%0D%0A%09%22%20Return%20the%20columnRule%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnRule%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRule:",0
,function(anObject){var self=this;
(self.handle()["columnRule"]=(anObject));
return self;}
,"accessing",unescape("columnRule%3A%20anObject%0D%0A%09%22%20Set%20the%20columnRule%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23columnRule%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRuleColor",0
,function(){var self=this;
return (self["@handle"].columnRuleColor || (0));}
,"accessing",unescape("columnRuleColor%0D%0A%09%22%20Return%20the%20columnRuleColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnRuleColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRuleColor:",0
,function(anObject){var self=this;
(self.handle()["columnRuleColor"]=(anObject));
return self;}
,"accessing",unescape("columnRuleColor%3A%20anObject%0D%0A%09%22%20Set%20the%20columnRuleColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23columnRuleColor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRuleStyle",0
,function(){var self=this;
return (self["@handle"].columnRuleStyle || (0));}
,"accessing",unescape("columnRuleStyle%0D%0A%09%22%20Return%20the%20columnRuleStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnRuleStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRuleStyle:",0
,function(anObject){var self=this;
(self.handle()["columnRuleStyle"]=(anObject));
return self;}
,"accessing",unescape("columnRuleStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20columnRuleStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23columnRuleStyle%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRuleWidth",0
,function(){var self=this;
return (self["@handle"].columnRuleWidth || (0));}
,"accessing",unescape("columnRuleWidth%0D%0A%09%22%20Return%20the%20columnRuleWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnRuleWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnRuleWidth:",0
,function(anObject){var self=this;
(self.handle()["columnRuleWidth"]=(anObject));
return self;}
,"accessing",unescape("columnRuleWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20columnRuleWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23columnRuleWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnSpan",0
,function(){var self=this;
return (self["@handle"].columnSpan || (0));}
,"accessing",unescape("columnSpan%0D%0A%09%22%20Return%20the%20columnSpan%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnSpan%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnSpan:",0
,function(anObject){var self=this;
(self.handle()["columnSpan"]=(anObject));
return self;}
,"accessing",unescape("columnSpan%3A%20anObject%0D%0A%09%22%20Set%20the%20columnSpan%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23columnSpan%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columnWidth",0
,function(){var self=this;
return (self["@handle"].columnWidth || (0));}
,"accessing",unescape("columnWidth%0D%0A%09%22%20Return%20the%20columnWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columnWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columnWidth:",0
,function(anObject){var self=this;
(self.handle()["columnWidth"]=(anObject));
return self;}
,"accessing",unescape("columnWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20columnWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23columnWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"columns",0
,function(){var self=this;
return (self["@handle"].columns || (0));}
,"accessing",unescape("columns%0D%0A%09%22%20Return%20the%20columns%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23columns%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"columns:",0
,function(anObject){var self=this;
(self.handle()["columns"]=(anObject));
return self;}
,"accessing",unescape("columns%3A%20anObject%0D%0A%09%22%20Set%20the%20columns%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23columns%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"content",0
,function(){var self=this;
return (self["@handle"].content || (0));}
,"accessing",unescape("content%0D%0A%09%22%20Return%20the%20content%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23content%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"content:",0
,function(anObject){var self=this;
(self.handle()["content"]=(anObject));
return self;}
,"accessing",unescape("content%3A%20anObject%0D%0A%09%22%20Set%20the%20content%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23content%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"counterIncrement",0
,function(){var self=this;
return (self["@handle"].counterIncrement || (0));}
,"accessing",unescape("counterIncrement%0D%0A%09%22%20Return%20the%20counterIncrement%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23counterIncrement%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"counterIncrement:",0
,function(anObject){var self=this;
(self.handle()["counterIncrement"]=(anObject));
return self;}
,"accessing",unescape("counterIncrement%3A%20anObject%0D%0A%09%22%20Set%20the%20counterIncrement%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23counterIncrement%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"counterReset",0
,function(){var self=this;
return (self["@handle"].counterReset || (0));}
,"accessing",unescape("counterReset%0D%0A%09%22%20Return%20the%20counterReset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23counterReset%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"counterReset:",0
,function(anObject){var self=this;
(self.handle()["counterReset"]=(anObject));
return self;}
,"accessing",unescape("counterReset%3A%20anObject%0D%0A%09%22%20Set%20the%20counterReset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23counterReset%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"cursor",0
,function(){var self=this;
return (self["@handle"].cursor || (0));}
,"accessing",unescape("cursor%0D%0A%09%22%20Return%20the%20cursor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cursor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"cursor:",0
,function(anObject){var self=this;
(self.handle()["cursor"]=(anObject));
return self;}
,"accessing",unescape("cursor%3A%20anObject%0D%0A%09%22%20Set%20the%20cursor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23cursor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"direction",0
,function(){var self=this;
return (self["@handle"].direction || (0));}
,"accessing",unescape("direction%0D%0A%09%22%20Return%20the%20direction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23direction%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"direction:",0
,function(anObject){var self=this;
(self.handle()["direction"]=(anObject));
return self;}
,"accessing",unescape("direction%3A%20anObject%0D%0A%09%22%20Set%20the%20direction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23direction%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"outline",0
,function(){var self=this;
return (self["@handle"].outline || (0));}
,"accessing",unescape("outline%0D%0A%09%22%20Return%20the%20outline%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outline%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"outline:",0
,function(anObject){var self=this;
(self.handle()["outline"]=(anObject));
return self;}
,"accessing",unescape("outline%3A%20anObject%0D%0A%09%22%20Set%20the%20outline%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23outline%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineColor",0
,function(){var self=this;
return (self["@handle"].outlineColor || (0));}
,"accessing",unescape("outlineColor%0D%0A%09%22%20Return%20the%20outlineColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outlineColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineColor:",0
,function(anObject){var self=this;
(self.handle()["outlineColor"]=(anObject));
return self;}
,"accessing",unescape("outlineColor%3A%20anObject%0D%0A%09%22%20Set%20the%20outlineColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23outlineColor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineStyle",0
,function(){var self=this;
return (self["@handle"].outlineStyle || (0));}
,"accessing",unescape("outlineStyle%0D%0A%09%22%20Return%20the%20outlineStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outlineStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineStyle:",0
,function(anObject){var self=this;
(self.handle()["outlineStyle"]=(anObject));
return self;}
,"accessing",unescape("outlineStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20outlineStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23outlineStyle%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineWidth",0
,function(){var self=this;
return (self["@handle"].outlineWidth || (0));}
,"accessing",unescape("outlineWidth%0D%0A%09%22%20Return%20the%20outlineWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outlineWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineWidth:",0
,function(anObject){var self=this;
(self.handle()["outlineWidth"]=(anObject));
return self;}
,"accessing",unescape("outlineWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20outlineWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23outlineWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyle",0
,function(){var self=this;
return (self["@handle"].listStyle || (0));}
,"accessing",unescape("listStyle%0D%0A%09%22%20Return%20the%20listStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23listStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyle:",0
,function(anObject){var self=this;
(self.handle()["listStyle"]=(anObject));
return self;}
,"accessing",unescape("listStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20listStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23listStyle%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyleImage",0
,function(){var self=this;
return (self["@handle"].listStyleImage || (0));}
,"accessing",unescape("listStyleImage%0D%0A%09%22%20Return%20the%20listStyleImage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23listStyleImage%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyleImage:",0
,function(anObject){var self=this;
(self.handle()["listStyleImage"]=(anObject));
return self;}
,"accessing",unescape("listStyleImage%3A%20anObject%0D%0A%09%22%20Set%20the%20listStyleImage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23listStyleImage%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"listStylePosition",0
,function(){var self=this;
return (self["@handle"].listStylePosition || (0));}
,"accessing",unescape("listStylePosition%0D%0A%09%22%20Return%20the%20listStylePosition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23listStylePosition%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"listStylePosition:",0
,function(anObject){var self=this;
(self.handle()["listStylePosition"]=(anObject));
return self;}
,"accessing",unescape("listStylePosition%3A%20anObject%0D%0A%09%22%20Set%20the%20listStylePosition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23listStylePosition%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyleType",0
,function(){var self=this;
return (self["@handle"].listStyleType || (0));}
,"accessing",unescape("listStyleType%0D%0A%09%22%20Return%20the%20listStyleType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23listStyleType%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyleType:",0
,function(anObject){var self=this;
(self.handle()["listStyleType"]=(anObject));
return self;}
,"accessing",unescape("listStyleType%3A%20anObject%0D%0A%09%22%20Set%20the%20listStyleType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23listStyleType%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"margin",0
,function(){var self=this;
return (self["@handle"].margin || (0));}
,"accessing",unescape("margin%0D%0A%09%22%20Return%20the%20margin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23margin%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"margin:",0
,function(anObject){var self=this;
(self.handle()["margin"]=(anObject));
return self;}
,"accessing",unescape("margin%3A%20anObject%0D%0A%09%22%20Set%20the%20margin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23margin%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"marginBottom",0
,function(){var self=this;
return (self["@handle"].marginBottom || (0));}
,"accessing",unescape("marginBottom%0D%0A%09%22%20Return%20the%20marginBottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginBottom%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"marginBottom:",0
,function(anObject){var self=this;
(self.handle()["marginBottom"]=(anObject));
return self;}
,"accessing",unescape("marginBottom%3A%20anObject%0D%0A%09%22%20Set%20the%20marginBottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23marginBottom%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"marginLeft",0
,function(){var self=this;
return (self["@handle"].marginLeft || (0));}
,"accessing",unescape("marginLeft%0D%0A%09%22%20Return%20the%20marginLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginLeft%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"marginLeft:",0
,function(anObject){var self=this;
(self.handle()["marginLeft"]=(anObject));
return self;}
,"accessing",unescape("marginLeft%3A%20anObject%0D%0A%09%22%20Set%20the%20marginLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23marginLeft%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"marginTop",0
,function(){var self=this;
return (self["@handle"].marginTop || (0));}
,"accessing",unescape("marginTop%0D%0A%09%22%20Return%20the%20marginTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginTop%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"marginTop:",0
,function(anObject){var self=this;
(self.handle()["marginTop"]=(anObject));
return self;}
,"accessing",unescape("marginTop%3A%20anObject%0D%0A%09%22%20Set%20the%20marginTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23marginTop%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"marginRight",0
,function(){var self=this;
return (self["@handle"].marginRight || (0));}
,"accessing",unescape("marginRight%0D%0A%09%22%20Return%20the%20marginRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23marginRight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"marginRight:",0
,function(anObject){var self=this;
(self.handle()["marginRight"]=(anObject));
return self;}
,"accessing",unescape("marginRight%3A%20anObject%0D%0A%09%22%20Set%20the%20marginRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23marginRight%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"padding",0
,function(){var self=this;
return (self["@handle"].padding || (0));}
,"accessing",unescape("padding%0D%0A%09%22%20Return%20the%20padding%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23padding%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"padding:",0
,function(anObject){var self=this;
(self.handle()["padding"]=(anObject));
return self;}
,"accessing",unescape("padding%3A%20anObject%0D%0A%09%22%20Set%20the%20padding%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23padding%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingBottom",0
,function(){var self=this;
return (self["@handle"].paddingBottom || (0));}
,"accessing",unescape("paddingBottom%0D%0A%09%22%20Return%20the%20paddingBottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23paddingBottom%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingBottom:",0
,function(anObject){var self=this;
(self.handle()["paddingBottom"]=(anObject));
return self;}
,"accessing",unescape("paddingBottom%3A%20anObject%0D%0A%09%22%20Set%20the%20paddingBottom%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23paddingBottom%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingLeft",0
,function(){var self=this;
return (self["@handle"].paddingLeft || (0));}
,"accessing",unescape("paddingLeft%0D%0A%09%22%20Return%20the%20paddingLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23paddingLeft%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingLeft:",0
,function(anObject){var self=this;
(self.handle()["paddingLeft"]=(anObject));
return self;}
,"accessing",unescape("paddingLeft%3A%20anObject%0D%0A%09%22%20Set%20the%20paddingLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23paddingLeft%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingTop",0
,function(){var self=this;
return (self["@handle"].paddingTop || (0));}
,"accessing",unescape("paddingTop%0D%0A%09%22%20Return%20the%20paddingTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23paddingTop%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingTop:",0
,function(anObject){var self=this;
(self.handle()["paddingTop"]=(anObject));
return self;}
,"accessing",unescape("paddingTop%3A%20anObject%0D%0A%09%22%20Set%20the%20paddingTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23paddingTop%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingRight",0
,function(){var self=this;
return (self["@handle"].paddingRight || (0));}
,"accessing",unescape("paddingRight%0D%0A%09%22%20Return%20the%20paddingRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23paddingRight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"paddingRight:",0
,function(anObject){var self=this;
(self.handle()["paddingRight"]=(anObject));
return self;}
,"accessing",unescape("paddingRight%3A%20anObject%0D%0A%09%22%20Set%20the%20paddingRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23paddingRight%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"cssText",0
,function(){var self=this;
return (self["@handle"].cssText || (0));}
,"accessing",unescape("cssText%0D%0A%09%22%20Return%20the%20cssText%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cssText%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"cssText:",0
,function(anObject){var self=this;
(self.handle()["cssText"]=(anObject));
return self;}
,"accessing",unescape("cssText%3A%20anObject%0D%0A%09%22%20Set%20the%20cssText%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23cssText%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"clear",0
,function(){var self=this;
return (self["@handle"].clear || (0));}
,"accessing",unescape("clear%0D%0A%09%22%20Return%20the%20clear%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23clear%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"clear:",0
,function(anObject){var self=this;
(self.handle()["clear"]=(anObject));
return self;}
,"accessing",unescape("clear%3A%20anObject%0D%0A%09%22%20Set%20the%20clear%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23clear%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"clip",0
,function(){var self=this;
return (self["@handle"].clip || (0));}
,"accessing",unescape("clip%0D%0A%09%22%20Return%20the%20clip%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23clip%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"clip:",0
,function(anObject){var self=this;
(self.handle()["clip"]=(anObject));
return self;}
,"accessing",unescape("clip%3A%20anObject%0D%0A%09%22%20Set%20the%20clip%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23clip%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"cssFloat",0
,function(){var self=this;
return (self["@handle"].cssFloat || (0));}
,"accessing",unescape("cssFloat%0D%0A%09%22%20Return%20the%20cssFloat%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cssFloat%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"cssFloat:",0
,function(anObject){var self=this;
(self.handle()["cssFloat"]=(anObject));
return self;}
,"accessing",unescape("cssFloat%3A%20anObject%0D%0A%09%22%20Set%20the%20cssFloat%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23cssFloat%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"cursor",0
,function(){var self=this;
return (self["@handle"].cursor || (0));}
,"accessing",unescape("cursor%0D%0A%09%22%20Return%20the%20cursor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cursor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"cursor:",0
,function(anObject){var self=this;
(self.handle()["cursor"]=(anObject));
return self;}
,"accessing",unescape("cursor%3A%20anObject%0D%0A%09%22%20Set%20the%20cursor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23cursor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"display",0
,function(){var self=this;
return (self["@handle"].display || (0));}
,"accessing",unescape("display%0D%0A%09%22%20Return%20the%20display%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23display%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"display:",0
,function(anObject){var self=this;
(self.handle()["display"]=(anObject));
return self;}
,"accessing",unescape("display%3A%20anObject%0D%0A%09%22%20Set%20the%20display%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23display%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"orphans",0
,function(){var self=this;
return (self["@handle"].orphans || (0));}
,"accessing",unescape("orphans%0D%0A%09%22%20Return%20the%20orphans%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23orphans%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"orphans:",0
,function(anObject){var self=this;
(self.handle()["orphans"]=(anObject));
return self;}
,"accessing",unescape("orphans%3A%20anObject%0D%0A%09%22%20Set%20the%20orphans%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23orphans%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakAfter",0
,function(){var self=this;
return (self["@handle"].pageBreakAfter || (0));}
,"accessing",unescape("pageBreakAfter%0D%0A%09%22%20Return%20the%20pageBreakAfter%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pageBreakAfter%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakAfter:",0
,function(anObject){var self=this;
(self.handle()["pageBreakAfter"]=(anObject));
return self;}
,"accessing",unescape("pageBreakAfter%3A%20anObject%0D%0A%09%22%20Set%20the%20pageBreakAfter%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23pageBreakAfter%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakBefore",0
,function(){var self=this;
return (self["@handle"].pageBreakBefore || (0));}
,"accessing",unescape("pageBreakBefore%0D%0A%09%22%20Return%20the%20pageBreakBefore%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pageBreakBefore%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakBefore:",0
,function(anObject){var self=this;
(self.handle()["pageBreakBefore"]=(anObject));
return self;}
,"accessing",unescape("pageBreakBefore%3A%20anObject%0D%0A%09%22%20Set%20the%20pageBreakBefore%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23pageBreakBefore%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakInside",0
,function(){var self=this;
return (self["@handle"].pageBreakInside || (0));}
,"accessing",unescape("pageBreakInside%0D%0A%09%22%20Return%20the%20pageBreakInside%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pageBreakInside%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakInside:",0
,function(anObject){var self=this;
(self.handle()["pageBreakInside"]=(anObject));
return self;}
,"accessing",unescape("pageBreakInside%3A%20anObject%0D%0A%09%22%20Set%20the%20pageBreakInside%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23pageBreakInside%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"windows",0
,function(){var self=this;
return (self["@handle"].windows || (0));}
,"accessing",unescape("windows%0D%0A%09%22%20Return%20the%20windows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23windows%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"windows:",0
,function(anObject){var self=this;
(self.handle()["windows"]=(anObject));
return self;}
,"accessing",unescape("windows%3A%20anObject%0D%0A%09%22%20Set%20the%20windows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23windows%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderCollapse",0
,function(){var self=this;
return (self["@handle"].borderCollapse || (0));}
,"accessing",unescape("borderCollapse%0D%0A%09%22%20Return%20the%20borderCollapse%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderCollapse%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderCollapse:",0
,function(anObject){var self=this;
(self.handle()["borderCollapse"]=(anObject));
return self;}
,"accessing",unescape("borderCollapse%3A%20anObject%0D%0A%09%22%20Set%20the%20borderCollapse%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderCollapse%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"borderSpacing",0
,function(){var self=this;
return (self["@handle"].borderSpacing || (0));}
,"accessing",unescape("borderSpacing%0D%0A%09%22%20Return%20the%20borderSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23borderSpacing%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"borderSpacing:",0
,function(anObject){var self=this;
(self.handle()["borderSpacing"]=(anObject));
return self;}
,"accessing",unescape("borderSpacing%3A%20anObject%0D%0A%09%22%20Set%20the%20borderSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23borderSpacing%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"captionSide",0
,function(){var self=this;
return (self["@handle"].captionSide || (0));}
,"accessing",unescape("captionSide%0D%0A%09%22%20Return%20the%20captionSide%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23captionSide%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"captionSide:",0
,function(anObject){var self=this;
(self.handle()["captionSide"]=(anObject));
return self;}
,"accessing",unescape("captionSide%3A%20anObject%0D%0A%09%22%20Set%20the%20captionSide%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23captionSide%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"emptyCells",0
,function(){var self=this;
return (self["@handle"].emptyCells || (0));}
,"accessing",unescape("emptyCells%0D%0A%09%22%20Return%20the%20emptyCells%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23emptyCells%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"emptyCells:",0
,function(anObject){var self=this;
(self.handle()["emptyCells"]=(anObject));
return self;}
,"accessing",unescape("emptyCells%3A%20anObject%0D%0A%09%22%20Set%20the%20emptyCells%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23emptyCells%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"tableLayout",0
,function(){var self=this;
return (self["@handle"].tableLayout || (0));}
,"accessing",unescape("tableLayout%0D%0A%09%22%20Return%20the%20tableLayout%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23tableLayout%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"tableLayout:",0
,function(anObject){var self=this;
(self.handle()["tableLayout"]=(anObject));
return self;}
,"accessing",unescape("tableLayout%3A%20anObject%0D%0A%09%22%20Set%20the%20tableLayout%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23tableLayout%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"color",0
,function(){var self=this;
return (self["@handle"].color || (0));}
,"accessing",unescape("color%0D%0A%09%22%20Return%20the%20color%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23color%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"color:",0
,function(anObject){var self=this;
(self.handle()["color"]=(anObject));
return self;}
,"accessing",unescape("color%3A%20anObject%0D%0A%09%22%20Set%20the%20color%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23color%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"direction",0
,function(){var self=this;
return (self["@handle"].direction || (0));}
,"accessing",unescape("direction%0D%0A%09%22%20Return%20the%20direction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23direction%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"direction:",0
,function(anObject){var self=this;
(self.handle()["direction"]=(anObject));
return self;}
,"accessing",unescape("direction%3A%20anObject%0D%0A%09%22%20Set%20the%20direction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23direction%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"flex",0
,function(){var self=this;
return (self["@handle"].flex || (0));}
,"accessing",unescape("flex%0D%0A%09%22%20Return%20the%20flex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23flex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"flex:",0
,function(anObject){var self=this;
(self.handle()["flex"]=(anObject));
return self;}
,"accessing",unescape("flex%3A%20anObject%0D%0A%09%22%20Set%20the%20flex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23flex%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"flexBasis",0
,function(){var self=this;
return (self["@handle"].flexBasis || (0));}
,"accessing",unescape("flexBasis%0D%0A%09%22%20Return%20the%20flexBasis%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23flexBasis%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"flexBasis:",0
,function(anObject){var self=this;
(self.handle()["flexBasis"]=(anObject));
return self;}
,"accessing",unescape("flexBasis%3A%20anObject%0D%0A%09%22%20Set%20the%20flexBasis%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23flexBasis%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"flexDirection",0
,function(){var self=this;
return (self["@handle"].flexDirection || (0));}
,"accessing",unescape("flexDirection%0D%0A%09%22%20Return%20the%20flexDirection%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23flexDirection%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"flexDirection:",0
,function(anObject){var self=this;
(self.handle()["flexDirection"]=(anObject));
return self;}
,"accessing",unescape("flexDirection%3A%20anObject%0D%0A%09%22%20Set%20the%20flexDirection%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23flexDirection%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"flexFlow",0
,function(){var self=this;
return (self["@handle"].flexFlow || (0));}
,"accessing",unescape("flexFlow%0D%0A%09%22%20Return%20the%20flexFlow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23flexFlow%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"flexFlow:",0
,function(anObject){var self=this;
(self.handle()["flexFlow"]=(anObject));
return self;}
,"accessing",unescape("flexFlow%3A%20anObject%0D%0A%09%22%20Set%20the%20flexFlow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23flexFlow%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"flexGrow",0
,function(){var self=this;
return (self["@handle"].flexGrow || (0));}
,"accessing",unescape("flexGrow%0D%0A%09%22%20Return%20the%20flexGrow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23flexGrow%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"flexGrow:",0
,function(anObject){var self=this;
(self.handle()["flexGrow"]=(anObject));
return self;}
,"accessing",unescape("flexGrow%3A%20anObject%0D%0A%09%22%20Set%20the%20flexGrow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23flexGrow%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"flexShrink",0
,function(){var self=this;
return (self["@handle"].flexShrink || (0));}
,"accessing",unescape("flexShrink%0D%0A%09%22%20Return%20the%20flexShrink%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23flexShrink%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"flexShrink:",0
,function(anObject){var self=this;
(self.handle()["flexShrink"]=(anObject));
return self;}
,"accessing",unescape("flexShrink%3A%20anObject%0D%0A%09%22%20Set%20the%20flexShrink%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23flexShrink%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"flexWrap",0
,function(){var self=this;
return (self["@handle"].flexWrap || (0));}
,"accessing",unescape("flexWrap%0D%0A%09%22%20Return%20the%20flexWrap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23flexWrap%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"flexWrap:",0
,function(anObject){var self=this;
(self.handle()["flexWrap"]=(anObject));
return self;}
,"accessing",unescape("flexWrap%3A%20anObject%0D%0A%09%22%20Set%20the%20flexWrap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23flexWrap%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"font",0
,function(){var self=this;
return (self["@handle"].font || (0));}
,"accessing",unescape("font%0D%0A%09%22%20Return%20the%20font%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23font%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"font:",0
,function(anObject){var self=this;
(self.handle()["font"]=(anObject));
return self;}
,"accessing",unescape("font%3A%20anObject%0D%0A%09%22%20Set%20the%20font%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23font%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"fontFamily",0
,function(){var self=this;
return (self["@handle"].fontFamily || (0));}
,"accessing",unescape("fontFamily%0D%0A%09%22%20Return%20the%20fontFamily%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23fontFamily%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"fontFamily:",0
,function(anObject){var self=this;
(self.handle()["fontFamily"]=(anObject));
return self;}
,"accessing",unescape("fontFamily%3A%20anObject%0D%0A%09%22%20Set%20the%20fontFamily%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23fontFamily%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"fontSize",0
,function(){var self=this;
return (self["@handle"].fontSize || (0));}
,"accessing",unescape("fontSize%0D%0A%09%22%20Return%20the%20fontSize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23fontSize%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"fontSize:",0
,function(anObject){var self=this;
(self.handle()["fontSize"]=(anObject));
return self;}
,"accessing",unescape("fontSize%3A%20anObject%0D%0A%09%22%20Set%20the%20fontSize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23fontSize%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"fontSizeAdjust",0
,function(){var self=this;
return (self["@handle"].fontSizeAdjust || (0));}
,"accessing",unescape("fontSizeAdjust%0D%0A%09%22%20Return%20the%20fontSizeAdjust%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23fontSizeAdjust%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"fontSizeAdjust:",0
,function(anObject){var self=this;
(self.handle()["fontSizeAdjust"]=(anObject));
return self;}
,"accessing",unescape("fontSizeAdjust%3A%20anObject%0D%0A%09%22%20Set%20the%20fontSizeAdjust%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23fontSizeAdjust%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"fontStyle",0
,function(){var self=this;
return (self["@handle"].fontStyle || (0));}
,"accessing",unescape("fontStyle%0D%0A%09%22%20Return%20the%20fontStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23fontStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"fontStyle:",0
,function(anObject){var self=this;
(self.handle()["fontStyle"]=(anObject));
return self;}
,"accessing",unescape("fontStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20fontStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23fontStyle%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"fontVariant",0
,function(){var self=this;
return (self["@handle"].fontVariant || (0));}
,"accessing",unescape("fontVariant%0D%0A%09%22%20Return%20the%20fontVariant%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23fontVariant%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"fontVariant:",0
,function(anObject){var self=this;
(self.handle()["fontVariant"]=(anObject));
return self;}
,"accessing",unescape("fontVariant%3A%20anObject%0D%0A%09%22%20Set%20the%20fontVariant%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23fontVariant%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"fontWeight",0
,function(){var self=this;
return (self["@handle"].fontWeight || (0));}
,"accessing",unescape("fontWeight%0D%0A%09%22%20Return%20the%20fontWeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23fontWeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"fontWeight:",0
,function(anObject){var self=this;
(self.handle()["fontWeight"]=(anObject));
return self;}
,"accessing",unescape("fontWeight%3A%20anObject%0D%0A%09%22%20Set%20the%20fontWeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23fontWeight%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"fontStretch",0
,function(){var self=this;
return (self["@handle"].fontStretch || (0));}
,"accessing",unescape("fontStretch%0D%0A%09%22%20Return%20the%20fontStretch%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23fontStretch%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"fontStretch:",0
,function(anObject){var self=this;
(self.handle()["fontStretch"]=(anObject));
return self;}
,"accessing",unescape("fontStretch%3A%20anObject%0D%0A%09%22%20Set%20the%20fontStretch%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23fontStretch%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"grid",0
,function(){var self=this;
return (self["@handle"].grid || (0));}
,"accessing",unescape("grid%0D%0A%09%22%20Return%20the%20grid%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23grid%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"grid:",0
,function(anObject){var self=this;
(self.handle()["grid"]=(anObject));
return self;}
,"accessing",unescape("grid%3A%20anObject%0D%0A%09%22%20Set%20the%20grid%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23grid%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridArea",0
,function(){var self=this;
return (self["@handle"].gridArea || (0));}
,"accessing",unescape("gridArea%0D%0A%09%22%20Return%20the%20gridArea%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridArea%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridArea:",0
,function(anObject){var self=this;
(self.handle()["gridArea"]=(anObject));
return self;}
,"accessing",unescape("gridArea%3A%20anObject%0D%0A%09%22%20Set%20the%20gridArea%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridArea%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridAutoColumns",0
,function(){var self=this;
return (self["@handle"].gridAutoColumns || (0));}
,"accessing",unescape("gridAutoColumns%0D%0A%09%22%20Return%20the%20gridAutoColumns%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridAutoColumns%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridAutoColumns:",0
,function(anObject){var self=this;
(self.handle()["gridAutoColumns"]=(anObject));
return self;}
,"accessing",unescape("gridAutoColumns%3A%20anObject%0D%0A%09%22%20Set%20the%20gridAutoColumns%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridAutoColumns%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridAutoFlow",0
,function(){var self=this;
return (self["@handle"].gridAutoFlow || (0));}
,"accessing",unescape("gridAutoFlow%0D%0A%09%22%20Return%20the%20gridAutoFlow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridAutoFlow%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridAutoFlow:",0
,function(anObject){var self=this;
(self.handle()["gridAutoFlow"]=(anObject));
return self;}
,"accessing",unescape("gridAutoFlow%3A%20anObject%0D%0A%09%22%20Set%20the%20gridAutoFlow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridAutoFlow%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridAutoRows",0
,function(){var self=this;
return (self["@handle"].gridAutoRows || (0));}
,"accessing",unescape("gridAutoRows%0D%0A%09%22%20Return%20the%20gridAutoRows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridAutoRows%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridAutoRows:",0
,function(anObject){var self=this;
(self.handle()["gridAutoRows"]=(anObject));
return self;}
,"accessing",unescape("gridAutoRows%3A%20anObject%0D%0A%09%22%20Set%20the%20gridAutoRows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridAutoRows%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridColumn",0
,function(){var self=this;
return (self["@handle"].gridColumn || (0));}
,"accessing",unescape("gridColumn%0D%0A%09%22%20Return%20the%20gridColumn%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridColumn%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridColumn:",0
,function(anObject){var self=this;
(self.handle()["gridColumn"]=(anObject));
return self;}
,"accessing",unescape("gridColumn%3A%20anObject%0D%0A%09%22%20Set%20the%20gridColumn%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridColumn%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridColumnEnd",0
,function(){var self=this;
return (self["@handle"].gridColumnEnd || (0));}
,"accessing",unescape("gridColumnEnd%0D%0A%09%22%20Return%20the%20gridColumnEnd%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridColumnEnd%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridColumnEnd:",0
,function(anObject){var self=this;
(self.handle()["gridColumnEnd"]=(anObject));
return self;}
,"accessing",unescape("gridColumnEnd%3A%20anObject%0D%0A%09%22%20Set%20the%20gridColumnEnd%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridColumnEnd%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridColumnGap",0
,function(){var self=this;
return (self["@handle"].gridColumnGap || (0));}
,"accessing",unescape("gridColumnGap%0D%0A%09%22%20Return%20the%20gridColumnGap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridColumnGap%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridColumnGap:",0
,function(anObject){var self=this;
(self.handle()["gridColumnGap"]=(anObject));
return self;}
,"accessing",unescape("gridColumnGap%3A%20anObject%0D%0A%09%22%20Set%20the%20gridColumnGap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridColumnGap%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridColumnStart",0
,function(){var self=this;
return (self["@handle"].gridColumnStart || (0));}
,"accessing",unescape("gridColumnStart%0D%0A%09%22%20Return%20the%20gridColumnStart%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridColumnStart%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridColumnStart:",0
,function(anObject){var self=this;
(self.handle()["gridColumnStart"]=(anObject));
return self;}
,"accessing",unescape("gridColumnStart%3A%20anObject%0D%0A%09%22%20Set%20the%20gridColumnStart%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridColumnStart%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridGap",0
,function(){var self=this;
return (self["@handle"].gridGap || (0));}
,"accessing",unescape("gridGap%0D%0A%09%22%20Return%20the%20gridGap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridGap%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridGap:",0
,function(anObject){var self=this;
(self.handle()["gridGap"]=(anObject));
return self;}
,"accessing",unescape("gridGap%3A%20anObject%0D%0A%09%22%20Set%20the%20gridGap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridGap%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridRow",0
,function(){var self=this;
return (self["@handle"].gridRow || (0));}
,"accessing",unescape("gridRow%0D%0A%09%22%20Return%20the%20gridRow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridRow%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridRow:",0
,function(anObject){var self=this;
(self.handle()["gridRow"]=(anObject));
return self;}
,"accessing",unescape("gridRow%3A%20anObject%0D%0A%09%22%20Set%20the%20gridRow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridRow%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridRowEnd",0
,function(){var self=this;
return (self["@handle"].gridRowEnd || (0));}
,"accessing",unescape("gridRowEnd%0D%0A%09%22%20Return%20the%20gridRowEnd%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridRowEnd%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridRowEnd:",0
,function(anObject){var self=this;
(self.handle()["gridRowEnd"]=(anObject));
return self;}
,"accessing",unescape("gridRowEnd%3A%20anObject%0D%0A%09%22%20Set%20the%20gridRowEnd%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridRowEnd%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridRowGap",0
,function(){var self=this;
return (self["@handle"].gridRowGap || (0));}
,"accessing",unescape("gridRowGap%0D%0A%09%22%20Return%20the%20gridRowGap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridRowGap%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridRowGap:",0
,function(anObject){var self=this;
(self.handle()["gridRowGap"]=(anObject));
return self;}
,"accessing",unescape("gridRowGap%3A%20anObject%0D%0A%09%22%20Set%20the%20gridRowGap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridRowGap%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridRowStart",0
,function(){var self=this;
return (self["@handle"].gridRowStart || (0));}
,"accessing",unescape("gridRowStart%0D%0A%09%22%20Return%20the%20gridRowStart%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridRowStart%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridRowStart:",0
,function(anObject){var self=this;
(self.handle()["gridRowStart"]=(anObject));
return self;}
,"accessing",unescape("gridRowStart%3A%20anObject%0D%0A%09%22%20Set%20the%20gridRowStart%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridRowStart%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridTemplate",0
,function(){var self=this;
return (self["@handle"].gridTemplate || (0));}
,"accessing",unescape("gridTemplate%0D%0A%09%22%20Return%20the%20gridTemplate%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridTemplate%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridTemplate:",0
,function(anObject){var self=this;
(self.handle()["gridTemplate"]=(anObject));
return self;}
,"accessing",unescape("gridTemplate%3A%20anObject%0D%0A%09%22%20Set%20the%20gridTemplate%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridTemplate%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridTemplateAreas",0
,function(){var self=this;
return (self["@handle"].gridTemplateAreas || (0));}
,"accessing",unescape("gridTemplateAreas%0D%0A%09%22%20Return%20the%20gridTemplateAreas%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridTemplateAreas%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridTemplateAreas:",0
,function(anObject){var self=this;
(self.handle()["gridTemplateAreas"]=(anObject));
return self;}
,"accessing",unescape("gridTemplateAreas%3A%20anObject%0D%0A%09%22%20Set%20the%20gridTemplateAreas%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridTemplateAreas%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridTemplateColumns",0
,function(){var self=this;
return (self["@handle"].gridTemplateColumns || (0));}
,"accessing",unescape("gridTemplateColumns%0D%0A%09%22%20Return%20the%20gridTemplateColumns%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridTemplateColumns%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridTemplateColumns:",0
,function(anObject){var self=this;
(self.handle()["gridTemplateColumns"]=(anObject));
return self;}
,"accessing",unescape("gridTemplateColumns%3A%20anObject%0D%0A%09%22%20Set%20the%20gridTemplateColumns%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridTemplateColumns%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridTemplateRows",0
,function(){var self=this;
return (self["@handle"].gridTemplateRows || (0));}
,"accessing",unescape("gridTemplateRows%0D%0A%09%22%20Return%20the%20gridTemplateRows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridTemplateRows%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridTemplateRows:",0
,function(anObject){var self=this;
(self.handle()["gridTemplateRows"]=(anObject));
return self;}
,"accessing",unescape("gridTemplateRows%3A%20anObject%0D%0A%09%22%20Set%20the%20gridTemplateRows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridTemplateRows%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridColumns",0
,function(){var self=this;
return (self["@handle"].gridColumns || (0));}
,"accessing",unescape("gridColumns%0D%0A%09%22%20Return%20the%20gridColumns%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridColumns%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridColumns:",0
,function(anObject){var self=this;
(self.handle()["gridColumns"]=(anObject));
return self;}
,"accessing",unescape("gridColumns%3A%20anObject%0D%0A%09%22%20Set%20the%20gridColumns%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridColumns%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"gridRows",0
,function(){var self=this;
return (self["@handle"].gridRows || (0));}
,"accessing",unescape("gridRows%0D%0A%09%22%20Return%20the%20gridRows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23gridRows%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"gridRows:",0
,function(anObject){var self=this;
(self.handle()["gridRows"]=(anObject));
return self;}
,"accessing",unescape("gridRows%3A%20anObject%0D%0A%09%22%20Set%20the%20gridRows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23gridRows%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"hangingPunctuation",0
,function(){var self=this;
return (self["@handle"].hangingPunctuation || (0));}
,"accessing",unescape("hangingPunctuation%0D%0A%09%22%20Return%20the%20hangingPunctuation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23hangingPunctuation%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"hangingPunctuation:",0
,function(anObject){var self=this;
(self.handle()["hangingPunctuation"]=(anObject));
return self;}
,"accessing",unescape("hangingPunctuation%3A%20anObject%0D%0A%09%22%20Set%20the%20hangingPunctuation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23hangingPunctuation%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"icon",0
,function(){var self=this;
return (self["@handle"].icon || (0));}
,"accessing",unescape("icon%0D%0A%09%22%20Return%20the%20icon%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23icon%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"icon:",0
,function(anObject){var self=this;
(self.handle()["icon"]=(anObject));
return self;}
,"accessing",unescape("icon%3A%20anObject%0D%0A%09%22%20Set%20the%20icon%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23icon%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"letterSpacing",0
,function(){var self=this;
return (self["@handle"].letterSpacing || (0));}
,"accessing",unescape("letterSpacing%0D%0A%09%22%20Return%20the%20letterSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23letterSpacing%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"letterSpacing:",0
,function(anObject){var self=this;
(self.handle()["letterSpacing"]=(anObject));
return self;}
,"accessing",unescape("letterSpacing%3A%20anObject%0D%0A%09%22%20Set%20the%20letterSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23letterSpacing%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"lineHeight",0
,function(){var self=this;
return (self["@handle"].lineHeight || (0));}
,"accessing",unescape("lineHeight%0D%0A%09%22%20Return%20the%20lineHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23lineHeight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"lineHeight:",0
,function(anObject){var self=this;
(self.handle()["lineHeight"]=(anObject));
return self;}
,"accessing",unescape("lineHeight%3A%20anObject%0D%0A%09%22%20Set%20the%20lineHeight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23lineHeight%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"justifyContent",0
,function(){var self=this;
return (self["@handle"].justifyContent || (0));}
,"accessing",unescape("justifyContent%0D%0A%09%22%20Return%20the%20justifyContent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23justifyContent%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"justifyContent:",0
,function(anObject){var self=this;
(self.handle()["justifyContent"]=(anObject));
return self;}
,"accessing",unescape("justifyContent%3A%20anObject%0D%0A%09%22%20Set%20the%20justifyContent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23justifyContent%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyle",0
,function(){var self=this;
return (self["@handle"].listStyle || (0));}
,"accessing",unescape("listStyle%0D%0A%09%22%20Return%20the%20listStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23listStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyle:",0
,function(anObject){var self=this;
(self.handle()["listStyle"]=(anObject));
return self;}
,"accessing",unescape("listStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20listStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23listStyle%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyleImage",0
,function(){var self=this;
return (self["@handle"].listStyleImage || (0));}
,"accessing",unescape("listStyleImage%0D%0A%09%22%20Return%20the%20listStyleImage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23listStyleImage%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyleImage:",0
,function(anObject){var self=this;
(self.handle()["listStyleImage"]=(anObject));
return self;}
,"accessing",unescape("listStyleImage%3A%20anObject%0D%0A%09%22%20Set%20the%20listStyleImage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23listStyleImage%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"listStylePosition",0
,function(){var self=this;
return (self["@handle"].listStylePosition || (0));}
,"accessing",unescape("listStylePosition%0D%0A%09%22%20Return%20the%20listStylePosition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23listStylePosition%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"listStylePosition:",0
,function(anObject){var self=this;
(self.handle()["listStylePosition"]=(anObject));
return self;}
,"accessing",unescape("listStylePosition%3A%20anObject%0D%0A%09%22%20Set%20the%20listStylePosition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23listStylePosition%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyleType",0
,function(){var self=this;
return (self["@handle"].listStyleType || (0));}
,"accessing",unescape("listStyleType%0D%0A%09%22%20Return%20the%20listStyleType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23listStyleType%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"listStyleType:",0
,function(anObject){var self=this;
(self.handle()["listStyleType"]=(anObject));
return self;}
,"accessing",unescape("listStyleType%3A%20anObject%0D%0A%09%22%20Set%20the%20listStyleType%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23listStyleType%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"navDown",0
,function(){var self=this;
return (self["@handle"].navDown || (0));}
,"accessing",unescape("navDown%0D%0A%09%22%20Return%20the%20navDown%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23navDown%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"navDown:",0
,function(anObject){var self=this;
(self.handle()["navDown"]=(anObject));
return self;}
,"accessing",unescape("navDown%3A%20anObject%0D%0A%09%22%20Set%20the%20navDown%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23navDown%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"navIndex",0
,function(){var self=this;
return (self["@handle"].navIndex || (0));}
,"accessing",unescape("navIndex%0D%0A%09%22%20Return%20the%20navIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23navIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"navIndex:",0
,function(anObject){var self=this;
(self.handle()["navIndex"]=(anObject));
return self;}
,"accessing",unescape("navIndex%3A%20anObject%0D%0A%09%22%20Set%20the%20navIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23navIndex%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"navLeft",0
,function(){var self=this;
return (self["@handle"].navLeft || (0));}
,"accessing",unescape("navLeft%0D%0A%09%22%20Return%20the%20navLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23navLeft%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"navLeft:",0
,function(anObject){var self=this;
(self.handle()["navLeft"]=(anObject));
return self;}
,"accessing",unescape("navLeft%3A%20anObject%0D%0A%09%22%20Set%20the%20navLeft%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23navLeft%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"navRight",0
,function(){var self=this;
return (self["@handle"].navRight || (0));}
,"accessing",unescape("navRight%0D%0A%09%22%20Return%20the%20navRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23navRight%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"navRight:",0
,function(anObject){var self=this;
(self.handle()["navRight"]=(anObject));
return self;}
,"accessing",unescape("navRight%3A%20anObject%0D%0A%09%22%20Set%20the%20navRight%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23navRight%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"navUp",0
,function(){var self=this;
return (self["@handle"].navUp || (0));}
,"accessing",unescape("navUp%0D%0A%09%22%20Return%20the%20navUp%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23navUp%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"navUp:",0
,function(anObject){var self=this;
(self.handle()["navUp"]=(anObject));
return self;}
,"accessing",unescape("navUp%3A%20anObject%0D%0A%09%22%20Set%20the%20navUp%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23navUp%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"objectFit",0
,function(){var self=this;
return (self["@handle"].objectFit || (0));}
,"accessing",unescape("objectFit%0D%0A%09%22%20Return%20the%20objectFit%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23objectFit%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"objectFit:",0
,function(anObject){var self=this;
(self.handle()["objectFit"]=(anObject));
return self;}
,"accessing",unescape("objectFit%3A%20anObject%0D%0A%09%22%20Set%20the%20objectFit%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23objectFit%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"order",0
,function(){var self=this;
return (self["@handle"].order || (0));}
,"accessing",unescape("order%0D%0A%09%22%20Return%20the%20order%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23order%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"order:",0
,function(anObject){var self=this;
(self.handle()["order"]=(anObject));
return self;}
,"accessing",unescape("order%3A%20anObject%0D%0A%09%22%20Set%20the%20order%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23order%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"opacity",0
,function(){var self=this;
return (self["@handle"].opacity || (0));}
,"accessing",unescape("opacity%0D%0A%09%22%20Return%20the%20opacity%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23opacity%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"opacity:",0
,function(anObject){var self=this;
(self.handle()["opacity"]=(anObject));
return self;}
,"accessing",unescape("opacity%3A%20anObject%0D%0A%09%22%20Set%20the%20opacity%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23opacity%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"outline",0
,function(){var self=this;
return (self["@handle"].outline || (0));}
,"accessing",unescape("outline%0D%0A%09%22%20Return%20the%20outline%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outline%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"outline:",0
,function(anObject){var self=this;
(self.handle()["outline"]=(anObject));
return self;}
,"accessing",unescape("outline%3A%20anObject%0D%0A%09%22%20Set%20the%20outline%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23outline%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineColor",0
,function(){var self=this;
return (self["@handle"].outlineColor || (0));}
,"accessing",unescape("outlineColor%0D%0A%09%22%20Return%20the%20outlineColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outlineColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineColor:",0
,function(anObject){var self=this;
(self.handle()["outlineColor"]=(anObject));
return self;}
,"accessing",unescape("outlineColor%3A%20anObject%0D%0A%09%22%20Set%20the%20outlineColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23outlineColor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineOffset",0
,function(){var self=this;
return (self["@handle"].outlineOffset || (0));}
,"accessing",unescape("outlineOffset%0D%0A%09%22%20Return%20the%20outlineOffset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outlineOffset%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineOffset:",0
,function(anObject){var self=this;
(self.handle()["outlineOffset"]=(anObject));
return self;}
,"accessing",unescape("outlineOffset%3A%20anObject%0D%0A%09%22%20Set%20the%20outlineOffset%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23outlineOffset%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineStyle",0
,function(){var self=this;
return (self["@handle"].outlineStyle || (0));}
,"accessing",unescape("outlineStyle%0D%0A%09%22%20Return%20the%20outlineStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outlineStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineStyle:",0
,function(anObject){var self=this;
(self.handle()["outlineStyle"]=(anObject));
return self;}
,"accessing",unescape("outlineStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20outlineStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23outlineStyle%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineWidth",0
,function(){var self=this;
return (self["@handle"].outlineWidth || (0));}
,"accessing",unescape("outlineWidth%0D%0A%09%22%20Return%20the%20outlineWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23outlineWidth%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"outlineWidth:",0
,function(anObject){var self=this;
(self.handle()["outlineWidth"]=(anObject));
return self;}
,"accessing",unescape("outlineWidth%3A%20anObject%0D%0A%09%22%20Set%20the%20outlineWidth%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23outlineWidth%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"overflow",0
,function(){var self=this;
return (self["@handle"].overflow || (0));}
,"accessing",unescape("overflow%0D%0A%09%22%20Return%20the%20overflow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23overflow%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"overflow:",0
,function(anObject){var self=this;
(self.handle()["overflow"]=(anObject));
return self;}
,"accessing",unescape("overflow%3A%20anObject%0D%0A%09%22%20Set%20the%20overflow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23overflow%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"overflowX",0
,function(){var self=this;
return (self["@handle"].overflowX || (0));}
,"accessing",unescape("overflowX%0D%0A%09%22%20Return%20the%20overflowX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23overflowX%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"overflowX:",0
,function(anObject){var self=this;
(self.handle()["overflowX"]=(anObject));
return self;}
,"accessing",unescape("overflowX%3A%20anObject%0D%0A%09%22%20Set%20the%20overflowX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23overflowX%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"overflowY",0
,function(){var self=this;
return (self["@handle"].overflowY || (0));}
,"accessing",unescape("overflowY%0D%0A%09%22%20Return%20the%20overflowY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23overflowY%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"overflowY:",0
,function(anObject){var self=this;
(self.handle()["overflowY"]=(anObject));
return self;}
,"accessing",unescape("overflowY%3A%20anObject%0D%0A%09%22%20Set%20the%20overflowY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23overflowY%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakAfter",0
,function(){var self=this;
return (self["@handle"].pageBreakAfter || (0));}
,"accessing",unescape("pageBreakAfter%0D%0A%09%22%20Return%20the%20pageBreakAfter%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pageBreakAfter%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakAfter:",0
,function(anObject){var self=this;
(self.handle()["pageBreakAfter"]=(anObject));
return self;}
,"accessing",unescape("pageBreakAfter%3A%20anObject%0D%0A%09%22%20Set%20the%20pageBreakAfter%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23pageBreakAfter%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakBefore",0
,function(){var self=this;
return (self["@handle"].pageBreakBefore || (0));}
,"accessing",unescape("pageBreakBefore%0D%0A%09%22%20Return%20the%20pageBreakBefore%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pageBreakBefore%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakBefore:",0
,function(anObject){var self=this;
(self.handle()["pageBreakBefore"]=(anObject));
return self;}
,"accessing",unescape("pageBreakBefore%3A%20anObject%0D%0A%09%22%20Set%20the%20pageBreakBefore%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23pageBreakBefore%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakInside",0
,function(){var self=this;
return (self["@handle"].pageBreakInside || (0));}
,"accessing",unescape("pageBreakInside%0D%0A%09%22%20Return%20the%20pageBreakInside%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pageBreakInside%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"pageBreakInside:",0
,function(anObject){var self=this;
(self.handle()["pageBreakInside"]=(anObject));
return self;}
,"accessing",unescape("pageBreakInside%3A%20anObject%0D%0A%09%22%20Set%20the%20pageBreakInside%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23pageBreakInside%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"perspective",0
,function(){var self=this;
return (self["@handle"].perspective || (0));}
,"accessing",unescape("perspective%0D%0A%09%22%20Return%20the%20perspective%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23perspective%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"perspective:",0
,function(anObject){var self=this;
(self.handle()["perspective"]=(anObject));
return self;}
,"accessing",unescape("perspective%3A%20anObject%0D%0A%09%22%20Set%20the%20perspective%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23perspective%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"perspectiveOrigin",0
,function(){var self=this;
return (self["@handle"].perspectiveOrigin || (0));}
,"accessing",unescape("perspectiveOrigin%0D%0A%09%22%20Return%20the%20perspectiveOrigin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23perspectiveOrigin%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"perspectiveOrigin:",0
,function(anObject){var self=this;
(self.handle()["perspectiveOrigin"]=(anObject));
return self;}
,"accessing",unescape("perspectiveOrigin%3A%20anObject%0D%0A%09%22%20Set%20the%20perspectiveOrigin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23perspectiveOrigin%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"position",0
,function(){var self=this;
return (self["@handle"].position || (0));}
,"accessing",unescape("position%0D%0A%09%22%20Return%20the%20position%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23position%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"position:",0
,function(anObject){var self=this;
(self.handle()["position"]=(anObject));
return self;}
,"accessing",unescape("position%3A%20anObject%0D%0A%09%22%20Set%20the%20position%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23position%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"punctuationTrim",0
,function(){var self=this;
return (self["@handle"].punctuationTrim || (0));}
,"accessing",unescape("punctuationTrim%0D%0A%09%22%20Return%20the%20punctuationTrim%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23punctuationTrim%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"punctuationTrim:",0
,function(anObject){var self=this;
(self.handle()["punctuationTrim"]=(anObject));
return self;}
,"accessing",unescape("punctuationTrim%3A%20anObject%0D%0A%09%22%20Set%20the%20punctuationTrim%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23punctuationTrim%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"pointerEvents",0
,function(){var self=this;
return (self["@handle"].pointerEvents || (0));}
,"accessing",unescape("pointerEvents%0D%0A%09%22%20Return%20the%20pointerEvents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23pointerEvents%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"pointerEvents:",0
,function(anObject){var self=this;
(self.handle()["pointerEvents"]=(anObject));
return self;}
,"accessing",unescape("pointerEvents%3A%20anObject%0D%0A%09%22%20Set%20the%20pointerEvents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23pointerEvents%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"quotes",0
,function(){var self=this;
return (self["@handle"].quotes || (0));}
,"accessing",unescape("quotes%0D%0A%09%22%20Return%20the%20quotes%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23quotes%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"quotes:",0
,function(anObject){var self=this;
(self.handle()["quotes"]=(anObject));
return self;}
,"accessing",unescape("quotes%3A%20anObject%0D%0A%09%22%20Set%20the%20quotes%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23quotes%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"resize",0
,function(){var self=this;
return (self["@handle"].resize || (0));}
,"accessing",unescape("resize%0D%0A%09%22%20Return%20the%20resize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23resize%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"resize:",0
,function(anObject){var self=this;
(self.handle()["resize"]=(anObject));
return self;}
,"accessing",unescape("resize%3A%20anObject%0D%0A%09%22%20Set%20the%20resize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23resize%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"rotation",0
,function(){var self=this;
return (self["@handle"].rotation || (0));}
,"accessing",unescape("rotation%0D%0A%09%22%20Return%20the%20rotation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23rotation%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"rotation:",0
,function(anObject){var self=this;
(self.handle()["rotation"]=(anObject));
return self;}
,"accessing",unescape("rotation%3A%20anObject%0D%0A%09%22%20Set%20the%20rotation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23rotation%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"rotationPoint",0
,function(){var self=this;
return (self["@handle"].rotationPoint || (0));}
,"accessing",unescape("rotationPoint%0D%0A%09%22%20Return%20the%20rotationPoint%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23rotationPoint%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"rotationPoint:",0
,function(anObject){var self=this;
(self.handle()["rotationPoint"]=(anObject));
return self;}
,"accessing",unescape("rotationPoint%3A%20anObject%0D%0A%09%22%20Set%20the%20rotationPoint%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23rotationPoint%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"tableLayout",0
,function(){var self=this;
return (self["@handle"].tableLayout || (0));}
,"accessing",unescape("tableLayout%0D%0A%09%22%20Return%20the%20tableLayout%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23tableLayout%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"tableLayout:",0
,function(anObject){var self=this;
(self.handle()["tableLayout"]=(anObject));
return self;}
,"accessing",unescape("tableLayout%3A%20anObject%0D%0A%09%22%20Set%20the%20tableLayout%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23tableLayout%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"tabSize",0
,function(){var self=this;
return (self["@handle"].tabSize || (0));}
,"accessing",unescape("tabSize%0D%0A%09%22%20Return%20the%20tabSize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23tabSize%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"tabSize:",0
,function(anObject){var self=this;
(self.handle()["tabSize"]=(anObject));
return self;}
,"accessing",unescape("tabSize%3A%20anObject%0D%0A%09%22%20Set%20the%20tabSize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23tabSize%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"target",0
,function(){var self=this;
return (self["@handle"].target || (0));}
,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23target%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"target:",0
,function(anObject){var self=this;
(self.handle()["target"]=(anObject));
return self;}
,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23target%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"targetName",0
,function(){var self=this;
return (self["@handle"].targetName || (0));}
,"accessing",unescape("targetName%0D%0A%09%22%20Return%20the%20targetName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23targetName%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"targetName:",0
,function(anObject){var self=this;
(self.handle()["targetName"]=(anObject));
return self;}
,"accessing",unescape("targetName%3A%20anObject%0D%0A%09%22%20Set%20the%20targetName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23targetName%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"targetNew",0
,function(){var self=this;
return (self["@handle"].targetNew || (0));}
,"accessing",unescape("targetNew%0D%0A%09%22%20Return%20the%20targetNew%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23targetNew%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"targetNew:",0
,function(anObject){var self=this;
(self.handle()["targetNew"]=(anObject));
return self;}
,"accessing",unescape("targetNew%3A%20anObject%0D%0A%09%22%20Set%20the%20targetNew%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23targetNew%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"targetPosition",0
,function(){var self=this;
return (self["@handle"].targetPosition || (0));}
,"accessing",unescape("targetPosition%0D%0A%09%22%20Return%20the%20targetPosition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23targetPosition%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"targetPosition:",0
,function(anObject){var self=this;
(self.handle()["targetPosition"]=(anObject));
return self;}
,"accessing",unescape("targetPosition%3A%20anObject%0D%0A%09%22%20Set%20the%20targetPosition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23targetPosition%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textAlign",0
,function(){var self=this;
return (self["@handle"].textAlign || (0));}
,"accessing",unescape("textAlign%0D%0A%09%22%20Return%20the%20textAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textAlign%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textAlign:",0
,function(anObject){var self=this;
(self.handle()["textAlign"]=(anObject));
return self;}
,"accessing",unescape("textAlign%3A%20anObject%0D%0A%09%22%20Set%20the%20textAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23textAlign%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textDecoration",0
,function(){var self=this;
return (self["@handle"].textDecoration || (0));}
,"accessing",unescape("textDecoration%0D%0A%09%22%20Return%20the%20textDecoration%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textDecoration%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textDecoration:",0
,function(anObject){var self=this;
(self.handle()["textDecoration"]=(anObject));
return self;}
,"accessing",unescape("textDecoration%3A%20anObject%0D%0A%09%22%20Set%20the%20textDecoration%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23textDecoration%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textIndent",0
,function(){var self=this;
return (self["@handle"].textIndent || (0));}
,"accessing",unescape("textIndent%0D%0A%09%22%20Return%20the%20textIndent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textIndent%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textIndent:",0
,function(anObject){var self=this;
(self.handle()["textIndent"]=(anObject));
return self;}
,"accessing",unescape("textIndent%3A%20anObject%0D%0A%09%22%20Set%20the%20textIndent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23textIndent%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textJustify",0
,function(){var self=this;
return (self["@handle"].textJustify || (0));}
,"accessing",unescape("textJustify%0D%0A%09%22%20Return%20the%20textJustify%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textJustify%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textJustify:",0
,function(anObject){var self=this;
(self.handle()["textJustify"]=(anObject));
return self;}
,"accessing",unescape("textJustify%3A%20anObject%0D%0A%09%22%20Set%20the%20textJustify%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23textJustify%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textDecorationColor",0
,function(){var self=this;
return (self["@handle"].textDecorationColor || (0));}
,"accessing",unescape("textDecorationColor%0D%0A%09%22%20Return%20the%20textDecorationColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textDecorationColor%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textDecorationColor:",0
,function(anObject){var self=this;
(self.handle()["textDecorationColor"]=(anObject));
return self;}
,"accessing",unescape("textDecorationColor%3A%20anObject%0D%0A%09%22%20Set%20the%20textDecorationColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23textDecorationColor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textDecorationLine",0
,function(){var self=this;
return (self["@handle"].textDecorationLine || (0));}
,"accessing",unescape("textDecorationLine%0D%0A%09%22%20Return%20the%20textDecorationLine%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textDecorationLine%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textDecorationLine:",0
,function(anObject){var self=this;
(self.handle()["textDecorationLine"]=(anObject));
return self;}
,"accessing",unescape("textDecorationLine%3A%20anObject%0D%0A%09%22%20Set%20the%20textDecorationLine%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23textDecorationLine%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textDecorationStyle",0
,function(){var self=this;
return (self["@handle"].textDecorationStyle || (0));}
,"accessing",unescape("textDecorationStyle%0D%0A%09%22%20Return%20the%20textDecorationStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textDecorationStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textDecorationStyle:",0
,function(anObject){var self=this;
(self.handle()["textDecorationStyle"]=(anObject));
return self;}
,"accessing",unescape("textDecorationStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20textDecorationStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23textDecorationStyle%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textOutline",0
,function(){var self=this;
return (self["@handle"].textOutline || (0));}
,"accessing",unescape("textOutline%0D%0A%09%22%20Return%20the%20textOutline%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textOutline%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textOutline:",0
,function(anObject){var self=this;
(self.handle()["textOutline"]=(anObject));
return self;}
,"accessing",unescape("textOutline%3A%20anObject%0D%0A%09%22%20Set%20the%20textOutline%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23textOutline%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textOverflow",0
,function(){var self=this;
return (self["@handle"].textOverflow || (0));}
,"accessing",unescape("textOverflow%0D%0A%09%22%20Return%20the%20textOverflow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textOverflow%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textOverflow:",0
,function(anObject){var self=this;
(self.handle()["textOverflow"]=(anObject));
return self;}
,"accessing",unescape("textOverflow%3A%20anObject%0D%0A%09%22%20Set%20the%20textOverflow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23textOverflow%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textShadow",0
,function(){var self=this;
return (self["@handle"].textShadow || (0));}
,"accessing",unescape("textShadow%0D%0A%09%22%20Return%20the%20textShadow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textShadow%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textShadow:",0
,function(anObject){var self=this;
(self.handle()["textShadow"]=(anObject));
return self;}
,"accessing",unescape("textShadow%3A%20anObject%0D%0A%09%22%20Set%20the%20textShadow%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23textShadow%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textTransform",0
,function(){var self=this;
return (self["@handle"].textTransform || (0));}
,"accessing",unescape("textTransform%0D%0A%09%22%20Return%20the%20textTransform%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textTransform%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textTransform:",0
,function(anObject){var self=this;
(self.handle()["textTransform"]=(anObject));
return self;}
,"accessing",unescape("textTransform%3A%20anObject%0D%0A%09%22%20Set%20the%20textTransform%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23textTransform%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"textWrap",0
,function(){var self=this;
return (self["@handle"].textWrap || (0));}
,"accessing",unescape("textWrap%0D%0A%09%22%20Return%20the%20textWrap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23textWrap%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"textWrap:",0
,function(anObject){var self=this;
(self.handle()["textWrap"]=(anObject));
return self;}
,"accessing",unescape("textWrap%3A%20anObject%0D%0A%09%22%20Set%20the%20textWrap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23textWrap%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transform",0
,function(){var self=this;
return (self["@handle"].transform || (0));}
,"accessing",unescape("transform%0D%0A%09%22%20Return%20the%20transform%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transform%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transform:",0
,function(anObject){var self=this;
(self.handle()["transform"]=(anObject));
return self;}
,"accessing",unescape("transform%3A%20anObject%0D%0A%09%22%20Set%20the%20transform%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23transform%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transformOrigin",0
,function(){var self=this;
return (self["@handle"].transformOrigin || (0));}
,"accessing",unescape("transformOrigin%0D%0A%09%22%20Return%20the%20transformOrigin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transformOrigin%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transformOrigin:",0
,function(anObject){var self=this;
(self.handle()["transformOrigin"]=(anObject));
return self;}
,"accessing",unescape("transformOrigin%3A%20anObject%0D%0A%09%22%20Set%20the%20transformOrigin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23transformOrigin%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transformStyle",0
,function(){var self=this;
return (self["@handle"].transformStyle || (0));}
,"accessing",unescape("transformStyle%0D%0A%09%22%20Return%20the%20transformStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transformStyle%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transformStyle:",0
,function(anObject){var self=this;
(self.handle()["transformStyle"]=(anObject));
return self;}
,"accessing",unescape("transformStyle%3A%20anObject%0D%0A%09%22%20Set%20the%20transformStyle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23transformStyle%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transition",0
,function(){var self=this;
return (self["@handle"].transition || (0));}
,"accessing",unescape("transition%0D%0A%09%22%20Return%20the%20transition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transition%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transition:",0
,function(anObject){var self=this;
(self.handle()["transition"]=(anObject));
return self;}
,"accessing",unescape("transition%3A%20anObject%0D%0A%09%22%20Set%20the%20transition%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23transition%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionProperty",0
,function(){var self=this;
return (self["@handle"].transitionProperty || (0));}
,"accessing",unescape("transitionProperty%0D%0A%09%22%20Return%20the%20transitionProperty%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transitionProperty%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionProperty:",0
,function(anObject){var self=this;
(self.handle()["transitionProperty"]=(anObject));
return self;}
,"accessing",unescape("transitionProperty%3A%20anObject%0D%0A%09%22%20Set%20the%20transitionProperty%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23transitionProperty%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionDuration",0
,function(){var self=this;
return (self["@handle"].transitionDuration || (0));}
,"accessing",unescape("transitionDuration%0D%0A%09%22%20Return%20the%20transitionDuration%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transitionDuration%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionDuration:",0
,function(anObject){var self=this;
(self.handle()["transitionDuration"]=(anObject));
return self;}
,"accessing",unescape("transitionDuration%3A%20anObject%0D%0A%09%22%20Set%20the%20transitionDuration%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23transitionDuration%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionTimingFunction",0
,function(){var self=this;
return (self["@handle"].transitionTimingFunction || (0));}
,"accessing",unescape("transitionTimingFunction%0D%0A%09%22%20Return%20the%20transitionTimingFunction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transitionTimingFunction%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionTimingFunction:",0
,function(anObject){var self=this;
(self.handle()["transitionTimingFunction"]=(anObject));
return self;}
,"accessing",unescape("transitionTimingFunction%3A%20anObject%0D%0A%09%22%20Set%20the%20transitionTimingFunction%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23transitionTimingFunction%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionDelay",0
,function(){var self=this;
return (self["@handle"].transitionDelay || (0));}
,"accessing",unescape("transitionDelay%0D%0A%09%22%20Return%20the%20transitionDelay%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23transitionDelay%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"transitionDelay:",0
,function(anObject){var self=this;
(self.handle()["transitionDelay"]=(anObject));
return self;}
,"accessing",unescape("transitionDelay%3A%20anObject%0D%0A%09%22%20Set%20the%20transitionDelay%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23transitionDelay%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"verticalAlign",0
,function(){var self=this;
return (self["@handle"].verticalAlign || (0));}
,"accessing",unescape("verticalAlign%0D%0A%09%22%20Return%20the%20verticalAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23verticalAlign%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"verticalAlign:",0
,function(anObject){var self=this;
(self.handle()["verticalAlign"]=(anObject));
return self;}
,"accessing",unescape("verticalAlign%3A%20anObject%0D%0A%09%22%20Set%20the%20verticalAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23verticalAlign%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"visibility",0
,function(){var self=this;
return (self["@handle"].visibility || (0));}
,"accessing",unescape("visibility%0D%0A%09%22%20Return%20the%20visibility%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23visibility%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"visibility:",0
,function(anObject){var self=this;
(self.handle()["visibility"]=(anObject));
return self;}
,"accessing",unescape("visibility%3A%20anObject%0D%0A%09%22%20Set%20the%20visibility%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23visibility%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"unicodeBidi",0
,function(){var self=this;
return (self["@handle"].unicodeBidi || (0));}
,"accessing",unescape("unicodeBidi%0D%0A%09%22%20Return%20the%20unicodeBidi%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23unicodeBidi%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"unicodeBidi:",0
,function(anObject){var self=this;
(self.handle()["unicodeBidi"]=(anObject));
return self;}
,"accessing",unescape("unicodeBidi%3A%20anObject%0D%0A%09%22%20Set%20the%20unicodeBidi%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23unicodeBidi%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"userSelect",0
,function(){var self=this;
return (self["@handle"].userSelect || (0));}
,"accessing",unescape("userSelect%0D%0A%09%22%20Return%20the%20userSelect%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23userSelect%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"userSelect:",0
,function(anObject){var self=this;
(self.handle()["userSelect"]=(anObject));
return self;}
,"accessing",unescape("userSelect%3A%20anObject%0D%0A%09%22%20Set%20the%20userSelect%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23userSelect%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"whiteSpace",0
,function(){var self=this;
return (self["@handle"].whiteSpace || (0));}
,"accessing",unescape("whiteSpace%0D%0A%09%22%20Return%20the%20whiteSpace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23whiteSpace%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"whiteSpace:",0
,function(anObject){var self=this;
(self.handle()["whiteSpace"]=(anObject));
return self;}
,"accessing",unescape("whiteSpace%3A%20anObject%0D%0A%09%22%20Set%20the%20whiteSpace%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23whiteSpace%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"wordSpacing",0
,function(){var self=this;
return (self["@handle"].wordSpacing || (0));}
,"accessing",unescape("wordSpacing%0D%0A%09%22%20Return%20the%20wordSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23wordSpacing%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"wordSpacing:",0
,function(anObject){var self=this;
(self.handle()["wordSpacing"]=(anObject));
return self;}
,"accessing",unescape("wordSpacing%3A%20anObject%0D%0A%09%22%20Set%20the%20wordSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23wordSpacing%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"wordWrap",0
,function(){var self=this;
return (self["@handle"].wordWrap || (0));}
,"accessing",unescape("wordWrap%0D%0A%09%22%20Return%20the%20wordWrap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23wordWrap%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"wordWrap:",0
,function(anObject){var self=this;
(self.handle()["wordWrap"]=(anObject));
return self;}
,"accessing",unescape("wordWrap%3A%20anObject%0D%0A%09%22%20Set%20the%20wordWrap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23wordWrap%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"zIndex",0
,function(){var self=this;
return (self["@handle"].zIndex || (0));}
,"accessing",unescape("zIndex%0D%0A%09%22%20Return%20the%20zIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23zIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLStyle,"zIndex:",0
,function(anObject){var self=this;
(self.handle()["zIndex"]=(anObject));
return self;}
,"accessing",unescape("zIndex%3A%20anObject%0D%0A%09%22%20Set%20the%20zIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23zIndex%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLStyle,"extent:",0
,function(extent){var self=this;
if (extent.isString()){return self.extent_(extent.asArrayOfSubstringsSeparatedBy_(unescape("%2C")));};;
if (extent.isArray()){(function($rec){$rec.width_(extent.first());return $rec.height_(extent.last());})(self);} else{(function($rec){$rec.width_(extent.x());return $rec.height_(extent.y());})(self);};;
return self;}
,"accessing",unescape("extent%3A%20extent%0D%0A%09%22%20Set%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09extent%20isString%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20extent%3A%20%28extent%20asArrayOfSubstringsSeparatedBy%3A%20%24%2C%29%0D%0A%09%5D.%0D%0A%09extent%20isArray%20ifTrue%3A%20%5B%0D%0A%09%09self%20width%3A%20extent%20first%3B%20height%3A%20extent%20last%0D%0A%09%5D%20ifFalse%3A%20%5B%0D%0A%09%09self%20width%3A%20extent%20x%3B%20height%3A%20extent%20y%0D%0A%09%5D"));

smalltalk.bind(smalltalk.HTMLTable,"border",0
,function(){var self=this;
return (self["@handle"].border || (0));}
,"accessing",unescape("border%0D%0A%09%22%20Return%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23border%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTable,"border:",0
,function(anObject){var self=this;
(self.handle()["border"]=(anObject));
return self;}
,"accessing",unescape("border%3A%20anObject%0D%0A%09%22%20Set%20the%20border%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23border%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTable,"cellPadding",0
,function(){var self=this;
return (self["@handle"].cellPadding || (0));}
,"accessing",unescape("cellPadding%0D%0A%09%22%20Return%20the%20cellPadding%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cellPadding%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTable,"cellPadding:",0
,function(anObject){var self=this;
(self.handle()["cellPadding"]=(anObject));
return self;}
,"accessing",unescape("cellPadding%3A%20anObject%0D%0A%09%22%20Set%20the%20cellPadding%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23cellPadding%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTable,"cellSpacing",0
,function(){var self=this;
return (self["@handle"].cellSpacing || (0));}
,"accessing",unescape("cellSpacing%0D%0A%09%22%20Return%20the%20cellSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cellSpacing%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTable,"cellSpacing:",0
,function(anObject){var self=this;
(self.handle()["cellSpacing"]=(anObject));
return self;}
,"accessing",unescape("cellSpacing%3A%20anObject%0D%0A%09%22%20Set%20the%20cellSpacing%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23cellSpacing%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTable,"frame",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["frame"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("frame%0D%0A%09%22%20Return%20the%20frame%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23frame"));

smalltalk.bind(smalltalk.HTMLTable,"frame:",0
,function(anObject){var self=this;
(self.handle()["frame"]=(anObject));
return self;}
,"accessing",unescape("frame%3A%20anObject%0D%0A%09%22%20Set%20the%20frame%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23frame%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTable,"rules",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["rules"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("rules%0D%0A%09%22%20Return%20the%20rules%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23rules"));

smalltalk.bind(smalltalk.HTMLTable,"rules:",0
,function(anObject){var self=this;
(self.handle()["rules"]=(anObject));
return self;}
,"accessing",unescape("rules%3A%20anObject%0D%0A%09%22%20Set%20the%20rules%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23rules%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTable,"summary",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["summary"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("summary%0D%0A%09%22%20Return%20the%20summary%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23summary"));

smalltalk.bind(smalltalk.HTMLTable,"summary:",0
,function(anObject){var self=this;
(self.handle()["summary"]=(anObject));
return self;}
,"accessing",unescape("summary%3A%20anObject%0D%0A%09%22%20Set%20the%20summary%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23summary%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTable,"caption",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["caption"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("caption%0D%0A%09%22%20Return%20the%20caption%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23caption"));

smalltalk.bind(smalltalk.HTMLTableCaption,"align",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["align"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23align"));

smalltalk.bind(smalltalk.HTMLTableCaption,"align:",0
,function(anObject){var self=this;
(self.handle()["align"]=(anObject));
return self;}
,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23align%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"abbr",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["abbr"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("abbr%0D%0A%09%22%20Return%20the%20abbr%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23abbr"));

smalltalk.bind(smalltalk.HTMLTableCell,"abbr:",0
,function(anObject){var self=this;
(self.handle()["abbr"]=(anObject));
return self;}
,"accessing",unescape("abbr%3A%20anObject%0D%0A%09%22%20Set%20the%20abbr%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23abbr%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"axis",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["axis"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("axis%0D%0A%09%22%20Return%20the%20axis%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23axis"));

smalltalk.bind(smalltalk.HTMLTableCell,"axis:",0
,function(anObject){var self=this;
(self.handle()["axis"]=(anObject));
return self;}
,"accessing",unescape("axis%3A%20anObject%0D%0A%09%22%20Set%20the%20axis%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23axis%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"align",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["align"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23align"));

smalltalk.bind(smalltalk.HTMLTableCell,"align:",0
,function(anObject){var self=this;
(self.handle()["align"]=(anObject));
return self;}
,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23align%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"bgColor",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["bgColor"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("bgColor%0D%0A%09%22%20Return%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23bgColor"));

smalltalk.bind(smalltalk.HTMLTableCell,"bgColor:",0
,function(anObject){var self=this;
(self.handle()["bgColor"]=(anObject));
return self;}
,"accessing",unescape("bgColor%3A%20anObject%0D%0A%09%22%20Set%20the%20bgColor%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23bgColor%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"char","$$char"
,function(){var self=this;
return ((function(){var $1$=(self.handle()["char"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("char%0D%0A%09%22%20Return%20the%20char%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23char"));

smalltalk.bind(smalltalk.HTMLTableCell,"char:",0
,function(anObject){var self=this;
(self.handle()["char"]=(anObject));
return self;}
,"accessing",unescape("char%3A%20anObject%0D%0A%09%22%20Set%20the%20char%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23char%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"headers",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["headers"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("headers%0D%0A%09%22%20Return%20the%20headers%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23headers"));

smalltalk.bind(smalltalk.HTMLTableCell,"headers:",0
,function(anObject){var self=this;
(self.handle()["headers"]=(anObject));
return self;}
,"accessing",unescape("headers%3A%20anObject%0D%0A%09%22%20Set%20the%20headers%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23headers%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"noWrap",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["noWrap"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("noWrap%0D%0A%09%22%20Return%20the%20noWrap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23noWrap"));

smalltalk.bind(smalltalk.HTMLTableCell,"noWrap:",0
,function(anObject){var self=this;
(self.handle()["noWrap"]=(anObject));
return self;}
,"accessing",unescape("noWrap%3A%20anObject%0D%0A%09%22%20Set%20the%20noWrap%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23noWrap%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"scope",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["scope"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("scope%0D%0A%09%22%20Return%20the%20scope%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23scope"));

smalltalk.bind(smalltalk.HTMLTableCell,"scope:",0
,function(anObject){var self=this;
(self.handle()["scope"]=(anObject));
return self;}
,"accessing",unescape("scope%3A%20anObject%0D%0A%09%22%20Set%20the%20scope%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23scope%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"vAlign",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["vAlign"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("vAlign%0D%0A%09%22%20Return%20the%20vAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23vAlign"));

smalltalk.bind(smalltalk.HTMLTableCell,"vAlign:",0
,function(anObject){var self=this;
(self.handle()["vAlign"]=(anObject));
return self;}
,"accessing",unescape("vAlign%3A%20anObject%0D%0A%09%22%20Set%20the%20vAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23vAlign%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"colspan",0
,function(){var self=this;
return (self["@handle"].colspan || (0));}
,"accessing",unescape("colspan%0D%0A%09%22%20Return%20the%20colspan%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23colspan%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTableCell,"colspan:",0
,function(anObject){var self=this;
(self.handle()["colspan"]=(anObject));
return self;}
,"accessing",unescape("colspan%3A%20anObject%0D%0A%09%22%20Set%20the%20colspan%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23colspan%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"rowspan",0
,function(){var self=this;
return (self["@handle"].rowspan || (0));}
,"accessing",unescape("rowspan%0D%0A%09%22%20Return%20the%20rowspan%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23rowspan%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTableCell,"rowspan:",0
,function(anObject){var self=this;
(self.handle()["rowspan"]=(anObject));
return self;}
,"accessing",unescape("rowspan%3A%20anObject%0D%0A%09%22%20Set%20the%20rowspan%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23rowspan%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCell,"cellIndex",0
,function(){var self=this;
return (self["@handle"].cellIndex || (0));}
,"accessing",unescape("cellIndex%0D%0A%09%22%20Return%20the%20cellIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cellIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTableCol,"align",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["align"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23align"));

smalltalk.bind(smalltalk.HTMLTableCol,"align:",0
,function(anObject){var self=this;
(self.handle()["align"]=(anObject));
return self;}
,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23align%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCol,"char","$$char"
,function(){var self=this;
return ((function(){var $1$=(self.handle()["char"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("char%0D%0A%09%22%20Return%20the%20char%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23char"));

smalltalk.bind(smalltalk.HTMLTableCol,"char:",0
,function(anObject){var self=this;
(self.handle()["char"]=(anObject));
return self;}
,"accessing",unescape("char%3A%20anObject%0D%0A%09%22%20Set%20the%20char%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23char%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCol,"span",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["span"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("span%0D%0A%09%22%20Return%20the%20span%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23span"));

smalltalk.bind(smalltalk.HTMLTableCol,"span:",0
,function(anObject){var self=this;
(self.handle()["span"]=(anObject));
return self;}
,"accessing",unescape("span%3A%20anObject%0D%0A%09%22%20Set%20the%20span%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23span%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableCol,"vAlign",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["vAlign"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("vAlign%0D%0A%09%22%20Return%20the%20vAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23vAlign"));

smalltalk.bind(smalltalk.HTMLTableCol,"vAlign:",0
,function(anObject){var self=this;
(self.handle()["vAlign"]=(anObject));
return self;}
,"accessing",unescape("vAlign%3A%20anObject%0D%0A%09%22%20Set%20the%20vAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23vAlign%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableRow,"align",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["align"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("align%0D%0A%09%22%20Return%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23align"));

smalltalk.bind(smalltalk.HTMLTableRow,"align:",0
,function(anObject){var self=this;
(self.handle()["align"]=(anObject));
return self;}
,"accessing",unescape("align%3A%20anObject%0D%0A%09%22%20Set%20the%20align%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23align%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableRow,"ch",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["ch"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("ch%0D%0A%09%22%20Return%20the%20ch%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23ch"));

smalltalk.bind(smalltalk.HTMLTableRow,"ch:",0
,function(anObject){var self=this;
(self.handle()["ch"]=(anObject));
return self;}
,"accessing",unescape("ch%3A%20anObject%0D%0A%09%22%20Set%20the%20ch%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23ch%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableRow,"vAlign",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["vAlign"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("vAlign%0D%0A%09%22%20Return%20the%20vAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23vAlign"));

smalltalk.bind(smalltalk.HTMLTableRow,"vAlign:",0
,function(anObject){var self=this;
(self.handle()["vAlign"]=(anObject));
return self;}
,"accessing",unescape("vAlign%3A%20anObject%0D%0A%09%22%20Set%20the%20vAlign%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23vAlign%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTableRow,"rowIndex",0
,function(){var self=this;
return (self["@handle"].rowIndex || (0));}
,"accessing",unescape("rowIndex%0D%0A%09%22%20Return%20the%20rowIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23rowIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTableRow,"sectionRowIndex",0
,function(){var self=this;
return (self["@handle"].sectionRowIndex || (0));}
,"accessing",unescape("sectionRowIndex%0D%0A%09%22%20Return%20the%20sectionRowIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23sectionRowIndex%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTextarea,"cols",0
,function(){var self=this;
return (self["@handle"].cols || (0));}
,"accessing",unescape("cols%0D%0A%09%22%20Return%20the%20cols%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23cols%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTextarea,"cols:",0
,function(anObject){var self=this;
(self.handle()["cols"]=(anObject));
return self;}
,"accessing",unescape("cols%3A%20anObject%0D%0A%09%22%20Set%20the%20cols%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23cols%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"rows",0
,function(){var self=this;
return (self["@handle"].rows || (0));}
,"accessing",unescape("rows%0D%0A%09%22%20Return%20the%20rows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23rows%20%7C%7C%200"));

smalltalk.bind(smalltalk.HTMLTextarea,"rows:",0
,function(anObject){var self=this;
(self.handle()["rows"]=(anObject));
return self;}
,"accessing",unescape("rows%3A%20anObject%0D%0A%09%22%20Set%20the%20rows%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23rows%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"hash",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["hash"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("hash%0D%0A%09%22%20Return%20the%20hash%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23hash"));

smalltalk.bind(smalltalk.HTMLTextarea,"hash:",0
,function(anObject){var self=this;
(self.handle()["hash"]=(anObject));
return self;}
,"accessing",unescape("hash%3A%20anObject%0D%0A%09%22%20Set%20the%20hash%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23hash%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"host",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["host"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("host%0D%0A%09%22%20Return%20the%20host%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23host"));

smalltalk.bind(smalltalk.HTMLTextarea,"host:",0
,function(anObject){var self=this;
(self.handle()["host"]=(anObject));
return self;}
,"accessing",unescape("host%3A%20anObject%0D%0A%09%22%20Set%20the%20host%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23host%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"hostname",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["hostname"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("hostname%0D%0A%09%22%20Return%20the%20hostname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23hostname"));

smalltalk.bind(smalltalk.HTMLTextarea,"hostname:",0
,function(anObject){var self=this;
(self.handle()["hostname"]=(anObject));
return self;}
,"accessing",unescape("hostname%3A%20anObject%0D%0A%09%22%20Set%20the%20hostname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23hostname%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"href",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["href"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("href%0D%0A%09%22%20Return%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23href"));

smalltalk.bind(smalltalk.HTMLTextarea,"href:",0
,function(anObject){var self=this;
(self.handle()["href"]=(anObject));
return self;}
,"accessing",unescape("href%3A%20anObject%0D%0A%09%22%20Set%20the%20href%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23href%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"pathname",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["pathname"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("pathname%0D%0A%09%22%20Return%20the%20pathname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23pathname"));

smalltalk.bind(smalltalk.HTMLTextarea,"pathname:",0
,function(anObject){var self=this;
(self.handle()["pathname"]=(anObject));
return self;}
,"accessing",unescape("pathname%3A%20anObject%0D%0A%09%22%20Set%20the%20pathname%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23pathname%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"port",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["port"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("port%0D%0A%09%22%20Return%20the%20port%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23port"));

smalltalk.bind(smalltalk.HTMLTextarea,"port:",0
,function(anObject){var self=this;
(self.handle()["port"]=(anObject));
return self;}
,"accessing",unescape("port%3A%20anObject%0D%0A%09%22%20Set%20the%20port%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23port%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"protocol",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["protocol"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("protocol%0D%0A%09%22%20Return%20the%20protocol%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23protocol"));

smalltalk.bind(smalltalk.HTMLTextarea,"protocol:",0
,function(anObject){var self=this;
(self.handle()["protocol"]=(anObject));
return self;}
,"accessing",unescape("protocol%3A%20anObject%0D%0A%09%22%20Set%20the%20protocol%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23protocol%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"defaultValue",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["defaultValue"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("defaultValue%0D%0A%09%22%20Return%20the%20defaultValue%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23defaultValue"));

smalltalk.bind(smalltalk.HTMLTextarea,"defaultValue:",0
,function(anObject){var self=this;
(self.handle()["defaultValue"]=(anObject));
return self;}
,"accessing",unescape("defaultValue%3A%20anObject%0D%0A%09%22%20Set%20the%20defaultValue%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23defaultValue%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.HTMLTextarea,"name:",0
,function(anObject){var self=this;
(self.handle()["name"]=(anObject));
return self;}
,"accessing",unescape("name%3A%20anObject%0D%0A%09%22%20Set%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23name%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"search",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["search"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("search%0D%0A%09%22%20Return%20the%20search%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23search"));

smalltalk.bind(smalltalk.HTMLTextarea,"search:",0
,function(anObject){var self=this;
(self.handle()["search"]=(anObject));
return self;}
,"accessing",unescape("search%3A%20anObject%0D%0A%09%22%20Set%20the%20search%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23search%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"type",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["type"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23type"));

smalltalk.bind(smalltalk.HTMLTextarea,"type:",0
,function(anObject){var self=this;
(self.handle()["type"]=(anObject));
return self;}
,"accessing",unescape("type%3A%20anObject%0D%0A%09%22%20Set%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23type%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"value",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["value"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23value"));

smalltalk.bind(smalltalk.HTMLTextarea,"value:",0
,function(anObject){var self=this;
(self.handle()["value"]=(anObject));
return self;}
,"accessing",unescape("value%3A%20anObject%0D%0A%09%22%20Set%20the%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23value%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"autocomplete",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["autocomplete"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("autocomplete%0D%0A%09%22%20Return%20the%20autocomplete%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23autocomplete"));

smalltalk.bind(smalltalk.HTMLTextarea,"autocomplete:",0
,function(anObject){var self=this;
(self.handle()["autocomplete"]=(anObject));
return self;}
,"accessing",unescape("autocomplete%3A%20anObject%0D%0A%09%22%20Set%20the%20autocomplete%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23autocomplete%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"autocorrect",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["autocorrect"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("autocorrect%0D%0A%09%22%20Return%20the%20autocorrect%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23autocorrect"));

smalltalk.bind(smalltalk.HTMLTextarea,"autocorrect:",0
,function(anObject){var self=this;
(self.handle()["autocorrect"]=(anObject));
return self;}
,"accessing",unescape("autocorrect%3A%20anObject%0D%0A%09%22%20Set%20the%20autocorrect%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23autocorrect%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"autocapitalize",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["autocapitalize"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("autocapitalize%0D%0A%09%22%20Return%20the%20autocapitalize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23autocapitalize"));

smalltalk.bind(smalltalk.HTMLTextarea,"autocapitalize:",0
,function(anObject){var self=this;
(self.handle()["autocapitalize"]=(anObject));
return self;}
,"accessing",unescape("autocapitalize%3A%20anObject%0D%0A%09%22%20Set%20the%20autocapitalize%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23autocapitalize%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"spellcheck",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["spellcheck"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("spellcheck%0D%0A%09%22%20Return%20the%20spellcheck%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23spellcheck"));

smalltalk.bind(smalltalk.HTMLTextarea,"spellcheck:",0
,function(anObject){var self=this;
(self.handle()["spellcheck"]=(anObject));
return self;}
,"accessing",unescape("spellcheck%3A%20anObject%0D%0A%09%22%20Set%20the%20spellcheck%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23spellcheck%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"autofocus",0
,function(){var self=this;
return (nil.is_eqeq_(true,self["@handle"].autofocus));}
,"accessing",unescape("autofocus%0D%0A%09%22%20Return%20the%20autofocus%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Etrue%20%3D%3D%20handle%23autofocus"));

smalltalk.bind(smalltalk.HTMLTextarea,"autofocus:",0
,function(anObject){var self=this;
(self.handle()["autofocus"]=(anObject));
return self;}
,"accessing",unescape("autofocus%3A%20anObject%0D%0A%09%22%20Set%20the%20autofocus%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23autofocus%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"disabled",0
,function(){var self=this;
return (nil.is_eqeq_(true,self["@handle"].disabled));}
,"accessing",unescape("disabled%0D%0A%09%22%20Return%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Etrue%20%3D%3D%20handle%23disabled"));

smalltalk.bind(smalltalk.HTMLTextarea,"disabled:",0
,function(anObject){var self=this;
(self.handle()["disabled"]=(anObject));
return self;}
,"accessing",unescape("disabled%3A%20anObject%0D%0A%09%22%20Set%20the%20disabled%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23disabled%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"readOnly",0
,function(){var self=this;
return (nil.is_eqeq_(true,self["@handle"].readOnly));}
,"accessing",unescape("readOnly%0D%0A%09%22%20Return%20the%20readOnly%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Etrue%20%3D%3D%20handle%23readOnly"));

smalltalk.bind(smalltalk.HTMLTextarea,"readOnly:",0
,function(anObject){var self=this;
(self.handle()["readOnly"]=(anObject));
return self;}
,"accessing",unescape("readOnly%3A%20anObject%0D%0A%09%22%20Set%20the%20readOnly%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23readOnly%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"required",0
,function(){var self=this;
return (nil.is_eqeq_(true,self["@handle"].required));}
,"accessing",unescape("required%0D%0A%09%22%20Return%20the%20required%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Etrue%20%3D%3D%20handle%23required"));

smalltalk.bind(smalltalk.HTMLTextarea,"required:",0
,function(anObject){var self=this;
(self.handle()["required"]=(anObject));
return self;}
,"accessing",unescape("required%3A%20anObject%0D%0A%09%22%20Set%20the%20required%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23required%20put%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLTextarea,"type",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["type"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23type"));

smalltalk.bind(smalltalk.HTMLTextarea,"form",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["form"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23form"));

smalltalk.bind(smalltalk.HTMLTitle,"text",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["text"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("text%0D%0A%09%22%20Return%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23text"));

smalltalk.bind(smalltalk.HTMLTitle,"text:",0
,function(anObject){var self=this;
(self.handle()["text"]=(anObject));
return self;}
,"accessing",unescape("text%3A%20anObject%0D%0A%09%22%20Set%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23text%20put%3A%20anObject"));

smalltalk.bind(smalltalk.DOM,"array:of:do:",0
,function(nativeArray,nativeClass,aBlock){var self=this;
return (((nil.isNil_(nativeArray)===false)).mustBeBoolean()==true ? (function(){return (0).to_(nativeArray.length._minus((1))).collect_((function(index){return aBlock.evaluateWith_(nativeClass._at(nativeArray[index]));}));})() : nil);}
,"private",unescape("array%3A%20nativeArray%20of%3A%20nativeClass%20do%3A%20aBlock%0D%0A%09%22%20Private%20-%20Return%20a%20copy%20of%20nativeArray%20as%20anArray%20of%20instances%20of%20nativeClass.%20%22%0D%0A%0D%0A%09%5EnativeArray%20notNil%20ifTrue%3A%20%5B%0D%0A%09%09%280%20to%3A%20nativeArray%23length%20-%201%29%20collect%3A%20%5B%3Aindex%7C%0D%0A%09%09%09aBlock%20evaluateWith%3A%20nativeClass%20@%20nativeArray%5Bindex%5D%0D%0A%09%09%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.DOM,"array:of:at:",0
,function(nativeArray,nativeClass,index){var self=this;
return (((nil.isNil_(nativeArray)===false)).mustBeBoolean()==true ? (function(){return nativeClass._at(nativeArray[index._minus((1))]);})() : nil);}
,"private",unescape("array%3A%20nativeArray%20of%3A%20nativeClass%20at%3A%20index%0D%0A%09%22%20Private%20-%20Return%20the%20element%20at%20index%20%28ONE%20indexed%29%20of%20nativeArray%20of%20instances%20of%20nativeClass.%20%22%0D%0A%0D%0A%09%5EnativeArray%20notNil%20ifTrue%3A%20%5B%20nativeClass%20@%20nativeArray%5Bindex-1%5D%20%5D"));

smalltalk.bind(smalltalk.DOM,"array:of:",0
,function(nativeArray,nativeClass){var self=this;
return self.array_of_do_(nativeArray,nativeClass,(function(each){return each;}));}
,"private",unescape("array%3A%20nativeArray%20of%3A%20nativeClass%0D%0A%09%22%20Private%20-%20Return%20a%20copy%20of%20nativeArray%20as%20anArray%20of%20instances%20of%20nativeClass.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20nativeArray%20of%3A%20nativeClass%20do%3A%20%5B%3Aeach%7C%20each%20%5D"));

smalltalk.bind(smalltalk.DOM,"array:of:at:",0
,function(nativeArray,nativeClass,indexOrName){var self=this;
return nativeClass._at(nativeArray[indexOrName]);}
,"private",unescape("array%3A%20nativeArray%20of%3A%20nativeClass%20at%3A%20indexOrName%0D%0A%09%22%20Private%20-%20Return%20the%20element%20of%20class%20nativeClass%20at%20index%28or%20name%29%20position%20of%20nativeArray.%0D%0A%09WARNING%3A%20in%20case%20of%20using%20integer%20index%2C%20it%20must%20be%20zero%20indexed%20value.%0D%0A%09%22%0D%0A%0D%0A%09%5EnativeClass%20@%20nativeArray%5BindexOrName%5D"));

smalltalk.bind(smalltalk.DOM,"vendorPrefixes",0
,function(){var self=this;
return ["webkit", "ms", "moz", "o"];}
,"private",unescape("vendorPrefixes%0D%0A%09%22%20Private%20-%20Return%20the%20collection%20of%20%28browser%29%20vendors%20that%20used%20force%20the%20use%20of%20prefixes%20for%20selectors%20for%20their%20experimental%20stuff.%20%22%0D%0A%0D%0A%09%5E%23%28%20webkit%20ms%20moz%20o%20%29"));

smalltalk.bind(smalltalk.DOM,"vendors:prefix:dash:ifAbsent:",0
,function(vendors,selector,dash,aBlock){var $s8Ret$={name:"stReturn"};try{var self=this;
var result=nil;
result=((function(){var $1$=(self["@handle"][selector]);if(nil.isNil_($1$))return ((function(){var epilogue=nil;
epilogue=((dash).mustBeBoolean()==true ? (function(){return unescape("-")._comma(selector);})() : (function(){return selector.first().asUppercase()._comma(selector.copyFrom_to_((2),selector.size()));})());vendors.do_((function(vendor){result=((function(){var $1$=(self["@handle"][vendor._comma(epilogue)]);if(nil.isNil_($1$))return ((function(){return "none";}).value());return $1$;})());return ((result._eq("none")).mustBeBoolean()==true ? nil : (function(){(function(){return (self["@handle"][selector]=(result));}).on_do_(smalltalk.Error,(function(ignored){return nil;}));return (function(){$s8Ret$.result=(function(){return result})();throw($s8Ret$)})();})());}));return (function(){$s8Ret$.result=(function(){return aBlock.value()})();throw($s8Ret$)})();}).value());return $1$;})());
(function(){$s8Ret$.result=(function(){return result})();throw($s8Ret$)})();} catch($$ex) {if($$ex === $s8Ret$){return $$ex.result} throw($$ex);}}
,"private",unescape("vendors%3A%20vendors%20prefix%3A%20selector%20dash%3A%20dash%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Private%20-%20Return%20the%20%28potentially%20prefixed%29%20property%20of%20the%20receiver%2C%20or%20evaluate%20aBlock%20if%20it%20is%20not%20present.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20handle%20basicAt%3A%20selector%20ifAbsent%3A%20%5B%20%7C%20epilogue%20%7C%0D%0A%09%09epilogue%20%3A%3D%20dash%20ifTrue%3A%20%5B%20%24-%20%2C%20selector%20%5D%20ifFalse%3A%20%5B%0D%0A%09%09%09selector%20first%20asUppercase%20%2C%20%28selector%20copyFrom%3A%202%20to%3A%20selector%20size%29%0D%0A%09%09%5D.%0D%0A%09%09vendors%20do%3A%20%5B%3Avendor%7C%0D%0A%09%09%09result%20%3A%3D%20handle%20basicAt%3A%20vendor%20%2C%20epilogue%20ifAbsent%3A%20%5B%20%23none%20%5D.%0D%0A%09%09%09result%20%3D%20%23none%20ifFalse%3A%20%5B%0D%0A%09%09%09%09%5B%20handle%20basicAt%3A%20selector%20put%3A%20result%20%5D%20on%3A%20Error%20do%3A%20%5B%3Aignored%7C%20%5D.%0D%0A%09%09%09%09%5Eresult%0D%0A%09%09%09%5D.%0D%0A%09%09%5D.%0D%0A%09%09%5EaBlock%20value%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.DOM,"prefix:dash:ifAbsent:",0
,function(selector,dash,aBlock){var self=this;
return self.vendors_prefix_dash_ifAbsent_(self.vendorPrefixes(),selector,dash,aBlock);}
,"private",unescape("prefix%3A%20selector%20dash%3A%20dash%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Private%20-%20Return%20the%20%28potentially%20prefixed%29%20property%20of%20the%20receiver%2C%20or%20evaluate%20aBlock%20if%20it%20is%20not%20present.%20%22%0D%0A%0D%0A%09%5Eself%20vendors%3A%20self%20vendorPrefixes%20prefix%3A%20selector%20dash%3A%20dash%20ifAbsent%3A%20aBlock"));

smalltalk.bind(smalltalk.DOM,"prefix:ifAbsent:",0
,function(selector,aBlock){var self=this;
return self.vendors_prefix_dash_ifAbsent_(self.vendorPrefixes(),selector,false,aBlock);}
,"private",unescape("prefix%3A%20selector%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Private%20-%20Return%20the%20%28potentially%20prefixed%29%20property%20of%20the%20receiver%2C%20or%20evaluate%20aBlock%20if%20it%20is%20not%20present.%20%22%0D%0A%0D%0A%09%5Eself%20vendors%3A%20self%20vendorPrefixes%20prefix%3A%20selector%20dash%3A%20false%20ifAbsent%3A%20aBlock"));

smalltalk.bind(smalltalk.DOM,"prefix:ifAbsentPut:",0
,function(selector,aBlock){var self=this;
return self.vendors_prefix_dash_ifAbsent_(self.vendorPrefixes(),selector,false,(function(){return (self["@handle"][selector]=(aBlock.evaluate()));}));}
,"private",unescape("prefix%3A%20selector%20ifAbsentPut%3A%20aBlock%0D%0A%09%22%20Private%20-%20Return%20the%20%28potentially%20prefixed%29%20property%20of%20the%20receiver%2C%20or%20return%26store%20the%20result%20of%20evaluating%20aBlock.%20%22%0D%0A%0D%0A%09%5Eself%20vendors%3A%20self%20vendorPrefixes%20prefix%3A%20selector%20dash%3A%20false%20ifAbsent%3A%20%5B%0D%0A%09%09handle%20basicAt%3A%20selector%20put%3A%20aBlock%20evaluate%0D%0A%09%5D"));

smalltalk.bind(smalltalk.DOM,"elementSupport",0
,function(){var self=this;
return self.$klass.elementSupport();}
,"private-mapping",unescape("elementSupport%0D%0A%09%22%20Private%20-%20Return%20the%20support%20to%20map%20node%20instances.%20%22%0D%0A%0D%0A%09%5Eself%20class%20elementSupport"));

smalltalk.bind(smalltalk.DOM.$klass,"elementSupport",0
,function(){var self=this;
return smalltalk.DOMNode;}
,"private-mapping",unescape("elementSupport%0D%0A%09%22%20Private%20-%20Return%20the%20support%20to%20map%20node%20instances.%0D%0A%09The%20default%20answer%20is%20the%20top%20node%20support.%0D%0A%09This%20method%20can%20be%20refined%20by%20concrete%20instantiation%20schemas%20%28see%20subclasses%29.%0D%0A%09%22%0D%0A%0D%0A%09%5EDOMNode"));

smalltalk.bind(smalltalk.DOM.$klass,"window",0
,function(){var self=this;
return smalltalk.BrowserWindow.$$default();}
,"accessing",unescape("window%0D%0A%09%22%20Return%20the%20browser%20window.%20%22%0D%0A%0D%0A%09%5EBrowserWindow%20default"));

smalltalk.bind(smalltalk.DOM.$klass,"document",0
,function(){var self=this;
return ((function(){var $1$=(self["$document"]);if(nil.isNil_($1$))return ((function(){return smalltalk.HTMLDocument.$$default();}).value());return $1$;})());}
,"accessing",unescape("document%0D%0A%09%22%20Return%20the%20browser%20document.%20%22%0D%0A%0D%0A%09%5Eself%20basicAt%3A%20%27%24document%27%20ifAbsent%3A%20%5B%20HTMLDocument%20default%20%5D%20"));

smalltalk.bind(smalltalk.DOM.$klass,"document:",0
,function(aDocument){var self=this;
if ((nil.isNil_(aDocument))){return self.basicDelete_("$document");};;
(self["$document"]=(aDocument));
return self;}
,"accessing",unescape("document%3A%20aDocument%0D%0A%09%22%20Set%20the%20browser%20document.%20%22%0D%0A%0D%0A%09aDocument%20isNil%20ifTrue%3A%20%5B%20%5Eself%20basicDelete%3A%20%27%24document%27%20%5D.%0D%0A%09self%20basicAt%3A%20%27%24document%27%20put%3A%20aDocument%20"));

smalltalk.bind(smalltalk.DOM.$klass,"history",0
,function(){var self=this;
return smalltalk.BrowserHistory.$$default();}
,"accessing",unescape("history%0D%0A%09%22%20Return%20the%20browser%20history.%20%22%0D%0A%0D%0A%09%5EBrowserHistory%20default"));

smalltalk.bind(smalltalk.DOM.$klass,"navigator",0
,function(){var self=this;
return smalltalk.BrowserNavigator.$$default();}
,"accessing",unescape("navigator%0D%0A%09%22%20Return%20the%20browser%20navigator.%20%22%0D%0A%0D%0A%09%5EBrowserNavigator%20default"));

smalltalk.bind(smalltalk.DOM.$klass,"screen",0
,function(){var self=this;
return smalltalk.BrowserScreen.$$default();}
,"accessing",unescape("screen%0D%0A%09%22%20Return%20the%20browser%20history.%20%22%0D%0A%0D%0A%09%5EBrowserScreen%20default"));

smalltalk.bind(smalltalk.DOM.$klass,"location",0
,function(){var self=this;
return smalltalk.BrowserLocation.$$default();}
,"accessing",unescape("location%0D%0A%09%22%20Return%20the%20browser%20location.%20%22%0D%0A%0D%0A%09%5EBrowserLocation%20default"));

smalltalk.bind(smalltalk.DOM,"window",0
,function(){var self=this;
return self.$klass.window();}
,"accessing",unescape("window%0D%0A%09%22%20Return%20the%20browser%20window.%20%22%0D%0A%0D%0A%09%5Eself%20class%20window"));

smalltalk.bind(smalltalk.DOM,"document",0
,function(){var self=this;
return self.$klass.document();}
,"accessing",unescape("document%0D%0A%09%22%20Return%20the%20browser%20document.%20%22%0D%0A%0D%0A%09%5Eself%20class%20document"));

smalltalk.bind(smalltalk.DOM,"history",0
,function(){var self=this;
return self.$klass.history();}
,"accessing",unescape("history%0D%0A%09%22%20Return%20the%20browser%20history.%20%22%0D%0A%0D%0A%09%5Eself%20class%20history"));

smalltalk.bind(smalltalk.DOM,"location",0
,function(){var self=this;
return self.$klass.location();}
,"accessing",unescape("location%0D%0A%09%22%20Return%20the%20browser%20location.%20%22%0D%0A%0D%0A%09%5Eself%20class%20location"));

smalltalk.bind(smalltalk.DOM,"screen",0
,function(){var self=this;
return self.$klass.screen();}
,"accessing",unescape("screen%0D%0A%09%22%20Return%20the%20browser%20screen.%20%22%0D%0A%0D%0A%09%5Eself%20class%20screen"));

smalltalk.bind(smalltalk.DOM,"navigator",0
,function(){var self=this;
return self.$klass.navigator();}
,"accessing",unescape("navigator%0D%0A%09%22%20Return%20the%20browser%20navigator.%20%22%0D%0A%0D%0A%09%5Eself%20class%20navigator"));

smalltalk.bind(smalltalk.BrowserWindow.$klass,"default","$$default"
,function(){var self=this;
return self._at(window);}
,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bwindow%7D"));

smalltalk.bind(smalltalk.HTMLDocument.$klass,"default","$$default"
,function(){var self=this;
return self._at(document);}
,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bdocument%7D"));

smalltalk.bind(smalltalk.BrowserHistory.$klass,"default","$$default"
,function(){var self=this;
return self._at(history);}
,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bhistory%7D"));

smalltalk.bind(smalltalk.BrowserNavigator.$klass,"default","$$default"
,function(){var self=this;
return self._at(navigator);}
,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bnavigator%7D"));

smalltalk.bind(smalltalk.BrowserScreen.$klass,"default","$$default"
,function(){var self=this;
return self._at(screen);}
,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Bscreen%7D"));

smalltalk.bind(smalltalk.BrowserLocation.$klass,"default","$$default"
,function(){var self=this;
return self._at(location);}
,"accessing",unescape("default%0D%0A%09%22%20Return%20the%20default/global%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20@%20%23%7Blocation%7D"));

smalltalk.bind(smalltalk.BrowserWindow,"closed",0
,function(){var self=this;
return self["@handle"].closed;}
,"query",unescape("closed%0D%0A%09%22%20Return%20a%20Boolean%20value%20indicating%20whether%20a%20window%20has%20been%20closed%20or%20not.%20%22%0D%0A%0D%0A%09%5Ehandle%23closed"));

smalltalk.bind(smalltalk.BrowserWindow,"defaultStatus",0
,function(){var self=this;
return self["@handle"].defaultStatus;}
,"accessing",unescape("defaultStatus%0D%0A%09%22%20Return%20the%20default%20text%20in%20the%20statusbar%20of%20a%20window.%20%22%0D%0A%0D%0A%09%5Ehandle%23defaultStatus"));

smalltalk.bind(smalltalk.BrowserWindow,"defaultStatus:",0
,function(status){var self=this;
return self["@handle"].defaultStatus=status;}
,"accessing",unescape("defaultStatus%3A%20status%0D%0A%09%22%20Set%20the%20default%20text%20in%20the%20statusbar%20of%20a%20window.%20%22%0D%0A%0D%0A%09%5Ehandle%23defaultStatus%20%3A%3D%20status"));

smalltalk.bind(smalltalk.BrowserWindow,"document",0
,function(){var self=this;
return smalltalk.HTMLDocument.for_(self["@handle"].document);}
,"accessing",unescape("document%0D%0A%09%22%20Return%20the%20Document%20object%20of%20the%20window.%20%22%0D%0A%0D%0A%09%5EHTMLDocument%20for%3A%20handle%23document"));

smalltalk.bind(smalltalk.BrowserWindow,"screen",0
,function(){var self=this;
return smalltalk.BrowserScreen._at(self["@handle"].screen);}
,"accessing",unescape("screen%0D%0A%09%22%20Return%20the%20screen%20information.%20%22%0D%0A%0D%0A%09%5EBrowserScreen%20@%20handle%23screen"));

smalltalk.bind(smalltalk.BrowserWindow,"frames",0
,function(){var self=this;
return self.array_of_(self["@handle"].frames,smalltalk.HTMLFrame);}
,"accessing",unescape("frames%0D%0A%09%22%20Return%20the%20frames%20%28including%20iframes%29%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23frames%20of%3A%20HTMLFrame"));

smalltalk.bind(smalltalk.BrowserWindow,"frameAt:",0
,function(index){var self=this;
return self.array_of_at_(self["@handle"].frames,smalltalk.HTMLFrame,index);}
,"accessing",unescape("frameAt%3A%20index%0D%0A%09%22%20Return%20the%20frame%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23frames%20of%3A%20HTMLFrame%20at%3A%20index"));

smalltalk.bind(smalltalk.BrowserWindow,"framesDo:",0
,function(aBlock){var self=this;
return self.array_of_do_(self["@handle"].frames,smalltalk.HTMLFrame,aBlock);}
,"accessing",unescape("framesDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20frames%20%28including%20iframes%29%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23frames%20of%3A%20HTMLFrame%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.BrowserWindow,"requestAnimationFrame:",0
,function(callbackBlock){var self=this;
var aFunction=nil;
aFunction=self.prefix_ifAbsentPut_("requestAnimationFrame",(function(){return (function(callback){return self["@handle"].setTimeout(callback,(1000)._slash((60)));});}));
return aFunction.value_(callbackBlock);}
,"animating",unescape("requestAnimationFrame%3A%20callbackBlock%0D%0A%09%22%20Schedule%20a%20repaint%20of%20the%20window%20for%20the%20next%20animation%20frame.%20%22%0D%0A%0D%0A%09%7C%20aFunction%20%7C%0D%0A%09aFunction%20%3A%3D%20self%20prefix%3A%20%23requestAnimationFrame%20ifAbsentPut%3A%20%5B%0D%0A%09%09%5B%3Acallback%7C%20handle%20%23setTimeout%3A%20callback%20with%3A%201000%20/%2060%20%5D%0D%0A%09%5D.%0D%0A%09%5EaFunction%20value%3A%20callbackBlock"));

smalltalk.bind(smalltalk.BrowserWindow,"cancelAnimationFrame:",0
,function(requestID){var self=this;
var aFunction=nil;
aFunction=self.prefix_ifAbsentPut_("cancelAnimationFrame",(function(){return (function(id){return self["@handle"].clearTimeout(id);});}));
return aFunction.value_(requestID);}
,"animating",unescape("cancelAnimationFrame%3A%20requestID%0D%0A%09%22%20Cancels%20an%20animation%20frame%20request%20previously%20scheduled.%20%22%0D%0A%0D%0A%09%7C%20aFunction%20%7C%0D%0A%09aFunction%20%3A%3D%20self%20prefix%3A%20%23cancelAnimationFrame%20ifAbsentPut%3A%20%5B%0D%0A%09%09%5B%3Aid%7C%20handle%20%23clearTimeout%3A%20id%20%5D%0D%0A%09%5D.%0D%0A%09%5EaFunction%20value%3A%20requestID"));

smalltalk.bind(smalltalk.BrowserWindow,"length",0
,function(){var self=this;
return self["@handle"].length;}
,"accessing",unescape("length%0D%0A%09%22%20Return%20the%20number%20of%20frames%20%28including%20iframes%29%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23length"));

smalltalk.bind(smalltalk.BrowserWindow,"size",0
,function(){var self=this;
return self.length();}
,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20number%20of%20frames%20%28including%20iframes%29%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20length"));

smalltalk.bind(smalltalk.BrowserWindow,"history",0
,function(){var self=this;
return smalltalk.BrowserHistory._at(self["@handle"].history);}
,"accessing",unescape("history%0D%0A%09%22%20Return%20the%20history%20of%20URLs%20visited%20by%20the%20user%20%28within%20a%20browser%20window%29.%20%22%0D%0A%0D%0A%09%5EBrowserHistory%20@%20handle%23history"));

smalltalk.bind(smalltalk.BrowserWindow,"screen",0
,function(){var self=this;
return smalltalk.BrowserScreen._at(self["@handle"].screen);}
,"accessing",unescape("screen%0D%0A%09%22%20Return%20the%20screen%20information.%20%22%0D%0A%0D%0A%09%5EBrowserScreen%20@%20handle%23screen"));

smalltalk.bind(smalltalk.BrowserWindow,"navigator",0
,function(){var self=this;
return smalltalk.BrowserNavigator._at(self["@handle"].navigator);}
,"accessing",unescape("navigator%0D%0A%09%22%20Return%20information%20about%20the%20browser.%20%22%0D%0A%0D%0A%09%5EBrowserNavigator%20@%20handle%23navigator"));

smalltalk.bind(smalltalk.BrowserWindow,"inner",0
,function(){var self=this;
return self.innerWidth()._at(self.innerHeight());}
,"accessing",unescape("inner%0D%0A%09%22%20Return%20the%20inner%20extent%20of%20the%20receiver%27s%20content%20area%20%28in%20pixels%29.%20%22%0D%0A%0D%0A%09%5Eself%20innerWidth%20@%20self%20innerHeight"));

smalltalk.bind(smalltalk.BrowserWindow,"inner:",0
,function(aPoint){var self=this;
(function($rec){$rec.innerWidth_(aPoint.x());return $rec.innerHeight_(aPoint.y());})(self);
return self;}
,"accessing",unescape("inner%3A%20aPoint%0D%0A%09%22%20Set%20the%20inner%20extent%20of%20the%20receiver%27s%20content%20area%20%28in%20pixels%29.%20%22%0D%0A%0D%0A%09self%20innerWidth%3A%20aPoint%20x%3B%20innerHeight%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"outer",0
,function(){var self=this;
return self.outerWidth()._at(self.outerHeight());}
,"accessing",unescape("outer%0D%0A%09%22%20Return%20the%20outer%20extent%20of%20the%20receiver%27s%20content%20area%20%28in%20pixels%29.%20%22%0D%0A%0D%0A%09%5Eself%20outerWidth%20@%20self%20outerHeight"));

smalltalk.bind(smalltalk.BrowserWindow,"outer:",0
,function(aPoint){var self=this;
(function($rec){$rec.outerWidth_(aPoint.x());return $rec.outerHeight_(aPoint.y());})(self);
return self;}
,"accessing",unescape("outer%3A%20aPoint%0D%0A%09%22%20Set%20the%20outer%20extent%20of%20the%20receiver%27s%20content%20area%20%28in%20pixels%29.%20%22%0D%0A%0D%0A%09self%20outerWidth%3A%20aPoint%20x%3B%20outerHeight%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"pageOffset",0
,function(){var self=this;
return self.pageXOffset()._at(self.pageYOffset());}
,"accessing",unescape("pageOffset%0D%0A%09%22%20Return%20the%20amount%20pixels%20the%20current%20document%20has%20been%20scrolled%20from%20the%20upper%20left%20corner%20of%20the%20window.%20%22%0D%0A%0D%0A%09%5Eself%20pageXOffset%20@%20self%20pageYOffset"));

smalltalk.bind(smalltalk.BrowserWindow,"screenExtent",0
,function(){var self=this;
return self.screenX()._at(self.screenY());}
,"accessing",unescape("screenExtent%0D%0A%09%22%20Return%20the%20screen%20extent%20in%20pixels.%20%22%0D%0A%0D%0A%09%5Eself%20screenX%20@%20self%20screenY"));

smalltalk.bind(smalltalk.BrowserWindow,"screenLeftTop",0
,function(){var self=this;
return self.screenLeft()._at(self.screenTop());}
,"accessing",unescape("screenLeftTop%0D%0A%09%22%20Return%20the%20screen%20leftTop%20in%20pixels.%20%22%0D%0A%0D%0A%09%5Eself%20screenLeft%20@%20self%20screenTop"));

smalltalk.bind(smalltalk.BrowserWindow,"boundingBox",0
,function(){var self=this;
return self.screenLeftTop().extent_(self.screenExtent());}
,"accessing",unescape("boundingBox%0D%0A%09%22%20Return%20the%20screen%20bounds%20in%20pixels.%20%22%0D%0A%0D%0A%09%5Eself%20screenLeftTop%20extent%3A%20self%20screenExtent"));

smalltalk.bind(smalltalk.BrowserWindow,"location",0
,function(){var self=this;
return smalltalk.BrowserLocation._at(self["@handle"].location);}
,"accessing",unescape("location%0D%0A%09%22%20Return%20the%20Location%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EBrowserLocation%20@%20handle%23location"));

smalltalk.bind(smalltalk.BrowserWindow,"opener",0
,function(){var self=this;
return smalltalk.BrowserWindow._at(self["@handle"].opener);}
,"accessing",unescape("opener%0D%0A%09%22%20Return%20the%20window%20that%20created%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20handle%23opener"));

smalltalk.bind(smalltalk.BrowserWindow,"parent",0
,function(){var self=this;
return smalltalk.BrowserWindow._at(self["@handle"].parent);}
,"accessing",unescape("parent%0D%0A%09%22%20Return%20the%20parent%20window%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20handle%23parent"));

smalltalk.bind(smalltalk.BrowserWindow,"top",0
,function(){var self=this;
return smalltalk.BrowserWindow._at(self["@handle"].top);}
,"accessing",unescape("top%0D%0A%09%22%20Return%20the%20topmost%20window%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20handle%23top"));

smalltalk.bind(smalltalk.BrowserWindow,"status:",0
,function(aStatus){var self=this;
self["@handle"].status=aStatus;
return self;}
,"accessing",unescape("status%3A%20aStatus%0D%0A%09%22%20Set%20the%20text%20in%20the%20status%20bar%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%23status%20%3A%3D%20aStatus"));

smalltalk.bind(smalltalk.BrowserWindow,"alert:",0
,function(message){var self=this;
return self["@handle"].alert(message);}
,"navigating",unescape("alert%3A%20message%0D%0A%09%22%20Display%20an%20alert%20box%20with%20a%20specified%20message%20and%20an%20OK%20button.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23alert%3A%20message"));

smalltalk.bind(smalltalk.BrowserWindow,"blur",0
,function(){var self=this;
return self["@handle"].blur();}
,"navigating",unescape("blur%0D%0A%09%22%20Remove%20focus%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20blur"));

smalltalk.bind(smalltalk.BrowserWindow,"clearInterval:",0
,function(id){var self=this;
return self["@handle"].clearInterval(id);}
,"navigating",unescape("clearInterval%3A%20id%0D%0A%09%22%20Clear%20the%20timer%20interval.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23clearInterval%3A%20id"));

smalltalk.bind(smalltalk.BrowserWindow,"clearTimeout:",0
,function(id){var self=this;
return self["@handle"].clearTimeout(id);}
,"navigating",unescape("clearTimeout%3A%20id%0D%0A%09%22%20Clear%20the%20timer%20interval.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23clearTimeout%3A%20id"));

smalltalk.bind(smalltalk.BrowserWindow,"setInterval:with:lang:",0
,function(code,milliseconds,lang){var self=this;
return self["@handle"].setInterval(code,milliseconds,lang);}
,"navigating",unescape("setInterval%3A%20code%20with%3A%20milliseconds%20lang%3A%20lang%0D%0A%09%22%20Set%20the%20timer%20interval.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23setInterval%3A%20code%20with%3A%20milliseconds%20with%3A%20lang"));

smalltalk.bind(smalltalk.BrowserWindow,"setInterval:with:",0
,function(code,milliseconds){var self=this;
return self["@handle"].setInterval(code,milliseconds);}
,"navigating",unescape("setInterval%3A%20code%20with%3A%20milliseconds%0D%0A%09%22%20Set%20the%20timer%20interval.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23setInterval%3A%20code%20with%3A%20milliseconds"));

smalltalk.bind(smalltalk.BrowserWindow,"setTimeout:with:lang:",0
,function(code,milliseconds,lang){var self=this;
return self["@handle"].setTimeout(code,milliseconds,lang);}
,"navigating",unescape("setTimeout%3A%20code%20with%3A%20milliseconds%20lang%3A%20lang%0D%0A%09%22%20Set%20the%20timer%20interval.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23setTimeout%3A%20code%20with%3A%20milliseconds%20with%3A%20lang"));

smalltalk.bind(smalltalk.BrowserWindow,"setTimeout:with:",0
,function(code,milliseconds){var self=this;
return self["@handle"].setTimeout(code,milliseconds);}
,"navigating",unescape("setTimeout%3A%20code%20with%3A%20milliseconds%0D%0A%09%22%20Set%20the%20timer%20interval.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23setTimeout%3A%20code%20with%3A%20milliseconds"));

smalltalk.bind(smalltalk.BrowserWindow,"close",0
,function(){var self=this;
return self["@handle"].close();}
,"navigating",unescape("close%0D%0A%09%22%20Close%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20close"));

smalltalk.bind(smalltalk.BrowserWindow,"confirm:",0
,function(message){var self=this;
return self["@handle"].confirm(message);}
,"navigating",unescape("confirm%3A%20message%0D%0A%09%22%20Open%20a%20confirmation%20box.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23confirm%3A%20message"));

smalltalk.bind(smalltalk.BrowserWindow,"focus",0
,function(){var self=this;
return self["@handle"].focus();}
,"navigating",unescape("focus%0D%0A%09%22%20Set%20the%20focus%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20focus"));

smalltalk.bind(smalltalk.BrowserWindow,"moveBy:y:",0
,function(x,y){var self=this;
return self["@handle"].moveBy(x,y);}
,"navigating",unescape("moveBy%3A%20x%20y%3A%20y%0D%0A%09%22%20Move%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23moveBy%3A%20x%20y%3A%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"moveTo:y:",0
,function(x,y){var self=this;
return self["@handle"].moveTo(x,y);}
,"navigating",unescape("moveTo%3A%20x%20y%3A%20y%0D%0A%09%22%20Move%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23moveTo%3A%20x%20y%3A%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"resizeBy:y:",0
,function(x,y){var self=this;
return self["@handle"].resizeBy(x,y);}
,"navigating",unescape("resizeBy%3A%20x%20y%3A%20y%0D%0A%09%22%20Resize%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23resizeBy%3A%20x%20y%3A%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"resizeTo:y:",0
,function(x,y){var self=this;
return self["@handle"].resizeTo(x,y);}
,"navigating",unescape("resizeTo%3A%20x%20y%3A%20y%0D%0A%09%22%20Resize%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23resizeTo%3A%20x%20y%3A%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"scroll",0
,function(){var self=this;
return self.scrollX()._at(self.scrollY());}
,"navigating",unescape("scroll%0D%0A%09%22%20Return%20the%20scroll%20%28aPoint%29%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20scrollX%20@%20self%20scrollY"));

smalltalk.bind(smalltalk.BrowserWindow,"scroll:",0
,function(aPoint){var self=this;
return self["@handle"].scroll(aPoint.x(),aPoint.y());}
,"navigating",unescape("scroll%3A%20aPoint%0D%0A%09%22%20Set%20the%20scroll%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23scroll%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"scrollTo:y:",0
,function(x,y){var self=this;
return self["@handle"].scrollTo(x,y);}
,"navigating",unescape("scrollTo%3A%20x%20y%3A%20y%0D%0A%09%22%20Scroll%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23scrollTo%3A%20x%20y%3A%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"scrollBy:y:",0
,function(x,y){var self=this;
return self["@handle"].scrollBy(x,y);}
,"navigating",unescape("scrollBy%3A%20x%20y%3A%20y%0D%0A%09%22%20Scroll%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23scrollBy%3A%20x%20y%3A%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"scrollTo:",0
,function(aPoint){var self=this;
return self.scrollTo_y_(aPoint.x(),aPoint.y());}
,"navigating",unescape("scrollTo%3A%20aPoint%0D%0A%09%22%20Scroll%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20scrollTo%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"scrollBy:",0
,function(aPoint){var self=this;
return self.scrollBy_y_(aPoint.x(),aPoint.y());}
,"navigating",unescape("scrollBy%3A%20aPoint%0D%0A%09%22%20Scroll%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20scrollBy%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"moveBy:",0
,function(aPoint){var self=this;
return self["@handle"].moveBy(aPoint.x(),aPoint.y());}
,"navigating",unescape("moveBy%3A%20aPoint%0D%0A%09%22%20Move%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23moveBy%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"moveTo:",0
,function(aPoint){var self=this;
return self["@handle"].moveTo(aPoint.x(),aPoint.y());}
,"navigating",unescape("moveTo%3A%20aPoint%0D%0A%09%22%20Move%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23moveTo%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"resizeBy:",0
,function(aPoint){var self=this;
return self["@handle"].resizeBy(aPoint.x(),aPoint.y());}
,"navigating",unescape("resizeBy%3A%20aPoint%0D%0A%09%22%20Resize%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23resizeBy%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"resizeTo:",0
,function(aPoint){var self=this;
return self["@handle"].resizeTo(aPoint.x(),aPoint.y());}
,"navigating",unescape("resizeTo%3A%20aPoint%0D%0A%09%22%20Resize%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23resizeTo%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"scrollBy:",0
,function(aPoint){var self=this;
return self["@handle"].scrollBy(aPoint.x(),aPoint.y());}
,"navigating",unescape("scrollBy%3A%20aPoint%0D%0A%09%22%20Scroll%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23scrollBy%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"scrollTo:",0
,function(aPoint){var self=this;
return self["@handle"].scrollTo(aPoint.x(),aPoint.y());}
,"navigating",unescape("scrollTo%3A%20aPoint%0D%0A%09%22%20Scroll%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23scrollTo%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.BrowserWindow,"open:name:specs:replace:",0
,function(url,name,specs,replace){var self=this;
return smalltalk.BrowserWindow._at(self["@handle"].open(url,name,specs,replace));}
,"navigating",unescape("open%3A%20url%20name%3A%20name%20specs%3A%20specs%20replace%3A%20replace%0D%0A%09%22%20Opens%20a%20new%20browser%20window.%0D%0A%09More%20information%20at%20http%3A//www.w3schools.com/jsref/met_win_open.asp%0D%0A%09%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20%28handle%20%23open%3A%20url%20name%3A%20name%20specs%3A%20specs%20replace%3A%20replace%29"));

smalltalk.bind(smalltalk.BrowserWindow,"open:name:specs:",0
,function(url,name,specs){var self=this;
return smalltalk.BrowserWindow._at(self["@handle"].open(url,name,specs));}
,"navigating",unescape("open%3A%20url%20name%3A%20name%20specs%3A%20specs%0D%0A%09%22%20Opens%20a%20new%20browser%20window.%0D%0A%09More%20information%20at%20http%3A//www.w3schools.com/jsref/met_win_open.asp%0D%0A%09%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20%28handle%20%23open%3A%20url%20name%3A%20name%20specs%3A%20specs%29"));

smalltalk.bind(smalltalk.BrowserWindow,"open:name:",0
,function(url,name){var self=this;
return smalltalk.BrowserWindow._at(self["@handle"].open(url,name));}
,"navigating",unescape("open%3A%20url%20name%3A%20name%0D%0A%09%22%20Opens%20a%20new%20browser%20window.%0D%0A%09More%20information%20at%20http%3A//www.w3schools.com/jsref/met_win_open.asp%0D%0A%09%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20%28handle%20%23open%3A%20url%20name%3A%20name%29"));

smalltalk.bind(smalltalk.BrowserWindow,"open:",0
,function(url){var self=this;
return smalltalk.BrowserWindow._at(self["@handle"].open(url));}
,"navigating",unescape("open%3A%20url%0D%0A%09%22%20Opens%20a%20new%20browser%20window.%0D%0A%09More%20information%20at%20http%3A//www.w3schools.com/jsref/met_win_open.asp%0D%0A%09%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20%28handle%20%23open%3A%20url%29"));

smalltalk.bind(smalltalk.BrowserWindow,"open",0
,function(){var self=this;
return smalltalk.BrowserWindow._at(self["@handle"].open());}
,"navigating",unescape("open%0D%0A%09%22%20Opens%20a%20new%20browser%20window.%0D%0A%09More%20information%20at%20http%3A//www.w3schools.com/jsref/met_win_open.asp%0D%0A%09%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20handle%20open"));

smalltalk.bind(smalltalk.BrowserWindow,"print",0
,function(){var self=this;
return self["@handle"].print();}
,"navigating",unescape("print%0D%0A%09%22%20Print%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20print"));

smalltalk.bind(smalltalk.BrowserWindow,"prompt:defaultText:",0
,function(message,text){var self=this;
return self["@handle"].prompt(message,text);}
,"navigating",unescape("prompt%3A%20message%20defaultText%3A%20text%0D%0A%09%22%20Open%20a%20Prompter.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23prompt%3A%20message%20defaultText%3A%20text"));

smalltalk.bind(smalltalk.BrowserWindow,"prompt:",0
,function(message){var self=this;
return self["@handle"].prompt(message);}
,"navigating",unescape("prompt%3A%20message%0D%0A%09%22%20Open%20a%20Prompter.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23prompt%3A%20message"));

smalltalk.bind(smalltalk.BrowserLocation,"assign:",0
,function(url){var self=this;
return self["@handle"].assign(url);}
,"navigating",unescape("assign%3A%20url%0D%0A%09%22%20Loads%20a%20new%20document.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23assign%3A%20url"));

smalltalk.bind(smalltalk.BrowserLocation,"reload",0
,function(){var self=this;
return self["@handle"].reload();}
,"navigating",unescape("reload%0D%0A%09%22%20Reload%20current%20document.%20%22%0D%0A%0D%0A%09%5Ehandle%20reload"));

smalltalk.bind(smalltalk.BrowserLocation,"replace:",0
,function(url){var self=this;
return self["@handle"].replace(url);}
,"navigating",unescape("replace%3A%20url%0D%0A%09%22%20Replace%20with%20new%20document.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23replace%3A%20url"));

smalltalk.bind(smalltalk.BrowserNavigator,"javaEnabled",0
,function(){var self=this;
return self["@handle"].javaEnabled();}
,"navigating",unescape("javaEnabled%0D%0A%09%22%20Specifies%20whether%20or%20not%20the%20browser%20has%20Java%20enabled.%20%22%0D%0A%0D%0A%09%5Ehandle%20javaEnabled"));

smalltalk.bind(smalltalk.BrowserNavigator,"taintEnabled",0
,function(){var self=this;
return self["@handle"].taintEnabled();}
,"navigating",unescape("taintEnabled%0D%0A%09%22%20Specifies%20whether%20or%20not%20the%20browser%20hashas%20data%20tainting%20enabled.%20%22%0D%0A%0D%0A%09%5Ehandle%20taintEnabled"));

smalltalk.bind(smalltalk.BrowserHistory,"length",0
,function(){var self=this;
return self["@handle"].length;}
,"accessing",unescape("length%0D%0A%09%22%20Returns%20the%20number%20of%20URLs%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23length"));

smalltalk.bind(smalltalk.BrowserHistory,"size",0
,function(){var self=this;
return self.length();}
,"accessing",unescape("size%0D%0A%09%22%20Returns%20the%20number%20of%20URLs%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20length"));

smalltalk.bind(smalltalk.BrowserHistory,"back",0
,function(){var self=this;
return self["@handle"].back();}
,"navigating",unescape("back%0D%0A%09%22%20Load%20the%20previous%20URL%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20back"));

smalltalk.bind(smalltalk.BrowserHistory,"forward",0
,function(){var self=this;
return self["@handle"].forward();}
,"navigating",unescape("forward%0D%0A%09%22%20Load%20the%20next%20URL%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20forward"));

smalltalk.bind(smalltalk.BrowserHistory,"next",0
,function(){var self=this;
return self.forward();}
,"navigating",unescape("next%0D%0A%09%22%20Load%20the%20next%20URL%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20forward"));

smalltalk.bind(smalltalk.BrowserHistory,"go:",0
,function(location){var self=this;
return self["@handle"].go(location);}
,"navigating",unescape("go%3A%20location%0D%0A%09%22%20Load%20the%20page%20in%20the%20receiver.%0D%0A%09The%20parameter%20can%20either%20be%20a%20number%20which%20goes%20to%20the%20URL%20within%20the%20specific%20position%20%28-1%20goes%20back%20one%20page%2C%201%20goes%20forward%20one%20page%29%2C%20or%20a%20string.%0D%0A%09The%20string%20must%20be%20a%20partial%20or%20full%20URL%2C%20and%20it%20will%20go%20to%20the%20first%20URL%20that%20matches%20the%20string.%0D%0A%09%22%0D%0A%0D%0A%09%5Ehandle%20%23go%3A%20location"));

smalltalk.bind(smalltalk.BrowserScreen,"avail",0
,function(){var self=this;
return self.availWidth()._at(self.availHeight());}
,"measuring",unescape("avail%0D%0A%09%22%20Return%20the%20extent%20of%20the%20receiver%20%28excluding%20taskbar%29.%20%22%0D%0A%0D%0A%09%5Eself%20availWidth%20@%20self%20availHeight"));

smalltalk.bind(smalltalk.BrowserScreen,"extent",0
,function(){var self=this;
return self.width()._at(self.height());}
,"measuring",unescape("extent%0D%0A%09%22%20Return%20the%20extent%20of%20the%20receiver%20%28excluding%20taskbar%29.%20%22%0D%0A%0D%0A%09%5Eself%20width%20@%20self%20height"));

smalltalk.bind(smalltalk.DOMElement.$klass,"elementSupport",0
,function(){var self=this;
return smalltalk.DOMElement;}
,"private-mapping",unescape("elementSupport%0D%0A%09%22%20Private%20-%20Return%20the%20support%20to%20map%20node%20instances.%20%22%0D%0A%0D%0A%09%5EDOMElement"));

smalltalk.bind(smalltalk.DOMDocument.$klass,"elementSupport",0
,function(){var self=this;
return smalltalk.DOMElement;}
,"private-mapping",unescape("elementSupport%0D%0A%09%22%20Private%20-%20Return%20the%20support%20to%20map%20node%20instances.%20%22%0D%0A%0D%0A%09%5EDOMElement"));

smalltalk.bind(smalltalk.HTMLDocument.$klass,"elementSupport",0
,function(){var self=this;
return smalltalk.HTMLElement;}
,"private-mapping",unescape("elementSupport%0D%0A%09%22%20Private%20-%20Return%20the%20support%20to%20map%20node%20instances.%20%22%0D%0A%0D%0A%09%5EHTMLElement"));

smalltalk.bind(smalltalk.HTMLElement.$klass,"elementSupport",0
,function(){var self=this;
return smalltalk.HTMLElement;}
,"private-mapping",unescape("elementSupport%0D%0A%09%22%20Private%20-%20Return%20the%20support%20to%20map%20node%20instances.%20%22%0D%0A%0D%0A%09%5EHTMLElement"));

smalltalk.bind(smalltalk.DOMElement.$klass,"supportFor:tagged:",0
,function(handle,tagName){var self=this;
var support=nil;
support=self.elementSupport();
if ((nil.isNil_(tagName))){return support;};;
return self.tagMap().at_ifAbsentPut_(tagName,(function(){return support.allSubclasses().detect_ifNone_((function(one){return one.canHandle_tagged_(handle,tagName);}),(function(){return support;}));}));}
,"private-mapping",unescape("supportFor%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Private%20-%20Return%20the%20support%20for%20element%20tagged%20with%20tagName.%0D%0A%09We%20use%20internal%20map%20cache%20to%20make%20concrete%20instantiation%20faster.%0D%0A%09Return%20a%20concrete%20class%20to%20wrap%20handle%2C%20or%20DOMElement%20in%20case%20of%20unknown%20tagName.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20support%20%7C%0D%0A%09support%20%3A%3D%20self%20elementSupport.%0D%0A%09tagName%20isNil%20ifTrue%3A%20%5B%20%5Esupport%20%5D.%0D%0A%09%5Eself%20tagMap%20at%3A%20tagName%20ifAbsentPut%3A%20%5B%0D%0A%09%09support%20allSubclasses%0D%0A%09%09%09detect%3A%20%5B%3Aone%7C%20one%20canHandle%3A%20handle%20tagged%3A%20tagName%20%5D%0D%0A%09%09%09ifNone%3A%20%5B%20support%20%5D%0D%0A%09%5D"));

smalltalk.bind(smalltalk.DOMElement.$klass,"isTagged",0
,function(){var self=this;
return (nil.isNil_(self.tagName())===false);}
,"HTML",unescape("isTagged%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20handle%20tagged%20elements.%20%22%0D%0A%0D%0A%09%5Eself%20tagName%20notNil"));

smalltalk.bind(smalltalk.DOMElement.$klass,"tagName",0
,function(){var self=this;
return nil;}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver%20%28or%20nil%29.%0D%0A%09Return%20nil%20by%20default.%0D%0A%09This%20method%20must%20be%20refined%20by%20concrete%20subclasses.%0D%0A%09%22%0D%0A%0D%0A%09%5Enil"));

smalltalk.bind(smalltalk.DOMElement.$klass,"canHandle:tagged:",0
,function(handle,tagName){var self=this;
return self.isTagged().and_((function(){return tagName._eq(self.tagName());}));}
,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%0D%0A%09This%20method%20can%20be%20refined%20in%20concrete%20subclasses%20to%20implement%20custom%20handling%20of%20HTML%20elements.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20isTagged%20and%3A%20%5B%20tagName%20%3D%20self%20tagName%20%5D"));

smalltalk.bind(smalltalk.HTMLInputButton.$klass,"canHandle:tagged:",0
,function(handle,tagName){var self=this;
return tagName._eq("INPUT").and_((function(){return handle.type._eq("button");}));}
,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5EtagName%20%3D%20%27INPUT%27%20and%3A%20%5B%20handle%23type%20%3D%20%27button%27%20%5D"));

smalltalk.bind(smalltalk.HTMLInputCheckbox.$klass,"canHandle:tagged:",0
,function(handle,tagName){var self=this;
return tagName._eq("INPUT").and_((function(){return handle.type._eq("checkbox");}));}
,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5EtagName%20%3D%20%27INPUT%27%20and%3A%20%5B%20handle%23type%20%3D%20%27checkbox%27%20%5D"));

smalltalk.bind(smalltalk.HTMLInputFile.$klass,"canHandle:tagged:",0
,function(handle,tagName){var self=this;
return tagName._eq("INPUT").and_((function(){return handle.type._eq("file");}));}
,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5EtagName%20%3D%20%27INPUT%27%20and%3A%20%5B%20handle%23type%20%3D%20%27file%27%20%5D"));

smalltalk.bind(smalltalk.HTMLInputHidden.$klass,"canHandle:tagged:",0
,function(handle,tagName){var self=this;
return tagName._eq("INPUT").and_((function(){return handle.type._eq("hidden");}));}
,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5EtagName%20%3D%20%27INPUT%27%20and%3A%20%5B%20handle%23type%20%3D%20%27hidden%27%20%5D"));

smalltalk.bind(smalltalk.HTMLInputRadio.$klass,"canHandle:tagged:",0
,function(handle,tagName){var self=this;
return tagName._eq("INPUT").and_((function(){return handle.type._eq("radio");}));}
,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5EtagName%20%3D%20%27INPUT%27%20and%3A%20%5B%20handle%23type%20%3D%20%27radio%27%20%5D"));

smalltalk.bind(smalltalk.HTMLInputText.$klass,"canHandle:tagged:",0
,function(handle,tagName){var self=this;
return tagName._eq("INPUT").and_((function(){return handle.type._eq("text");}));}
,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5EtagName%20%3D%20%27INPUT%27%20and%3A%20%5B%20handle%23type%20%3D%20%27text%27%20%5D"));

smalltalk.bind(smalltalk.HTMLElement.$klass,"@","_at"
,function(handle){var $s8Ret$={name:"stReturn"};try{var self=this;
var tagName=nil;
var support=nil;
if ((nil.isNil_(handle))){return nil;};;
tagName=handle.tagName;
if ((nil.isNil_(tagName))){return self.for_(handle);};;
if (!((nil.is_eqeq_(self,smalltalk.DOMElement)).or_((function(){return (nil.is_eqeq_(self,smalltalk.HTMLElement));})))){return self.for_(handle);};;
support=self.supportFor_tagged_(handle,tagName);
if ((nil.is_eqeq_(support,smalltalk.HTMLInput))){support.allSubclasses().do_((function(each){return ((each.canHandle_tagged_(handle,tagName)).mustBeBoolean()==true ? (function(){return (function(){$s8Ret$.result=(function(){return each.for_(handle)})();throw($s8Ret$)})();})() : nil);}));};;
(function(){$s8Ret$.result=(function(){return support.for_(handle)})();throw($s8Ret$)})();} catch($$ex) {if($$ex === $s8Ret$){return $$ex.result} throw($$ex);}}
,"instantiation",unescape("@%20handle%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%0D%0A%09A%20concrete%20implementation%20for%20tag%20%28in%20handle%29%20will%20be%20used%20if%20appropiate.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20tagName%20support%20%7C%0D%0A%09handle%20isNil%20ifTrue%3A%20%5B%20%5Enil%20%5D.%0D%0A%09tagName%20%3A%3D%20handle%23tagName.%0D%0A%09tagName%20isNil%20ifTrue%3A%20%5B%20%5Eself%20for%3A%20handle%20%5D.%0D%0A%09%28self%20%3D%3D%20DOMElement%20or%3A%20%5B%20self%20%3D%3D%20HTMLElement%20%5D%29%20ifFalse%3A%20%5B%20%5Eself%20for%3A%20handle%20%5D.%0D%0A%09support%20%3A%3D%20self%20supportFor%3A%20handle%20tagged%3A%20tagName.%0D%0A%09support%20%3D%3D%20HTMLInput%20ifTrue%3A%20%5B%20%22we%20need%20more%20concrete%20instance%22%0D%0A%09%09support%20allSubclasses%20do%3A%20%5B%3Aeach%7C%0D%0A%09%09%09%28each%20canHandle%3A%20handle%20tagged%3A%20tagName%29%20ifTrue%3A%20%5B%0D%0A%09%09%09%09%5Eeach%20for%3A%20handle%0D%0A%09%09%09%5D.%0D%0A%09%09%5D.%0D%0A%09%5D.%0D%0A%09%5Esupport%20for%3A%20handle"));

smalltalk.bind(smalltalk.DOMNode,"attributes",0
,function(){var self=this;
return self.array_of_(self["@handle"].attributes,smalltalk.DOMAttribute);}
,"accessing",unescape("attributes%0D%0A%09%22%20Return%20the%20attributes%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23attributes%20of%3A%20DOMAttribute"));

smalltalk.bind(smalltalk.DOMNode,"attributeAt:",0
,function(index){var self=this;
return self.array_of_at_(self["@handle"].attributes,smalltalk.DOMAttribute,index);}
,"accessing",unescape("attributeAt%3A%20index%0D%0A%09%22%20Return%20the%20attribute%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23attributes%20of%3A%20DOMAttribute%20at%3A%20index"));

smalltalk.bind(smalltalk.DOMNode,"attributesDo:",0
,function(aBlock){var self=this;
return self.array_of_do_(self["@handle"].attributes,smalltalk.DOMAttribute,aBlock);}
,"accessing",unescape("attributesDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20attributes%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23attributes%20of%3A%20DOMAttribute%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.DOMNode,"childNodes",0
,function(){var self=this;
return self.array_of_(self["@handle"].childNodes,self.elementSupport());}
,"accessing",unescape("childNodes%0D%0A%09%22%20Return%20the%20childNodes%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23childNodes%20of%3A%20self%20elementSupport"));

smalltalk.bind(smalltalk.DOMNode,"childNodesDo:",0
,function(aBlock){var self=this;
return self.array_of_do_(self["@handle"].childNodes,self.elementSupport(),aBlock);}
,"accessing",unescape("childNodesDo%3A%20aBlock%0D%0A%09%22%20Evaluates%20aBlock%20with%20the%20childNodes%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23childNodes%20of%3A%20self%20elementSupport%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.DOMNode,"childNodeAt:",0
,function(index){var self=this;
return self.array_of_at_(self["@handle"].childNodes,self.elementSupport(),index);}
,"accessing",unescape("childNodeAt%3A%20index%0D%0A%09%22%20Return%20the%20childNode%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23childNodes%20of%3A%20self%20elementSupport%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLElement,"clientExtent",0
,function(){var self=this;
return self.clientWidth()._at(self.clientHeight());}
,"accessing",unescape("clientExtent%0D%0A%09%22%20Return%20the%20viewable%20extent%20of%20the%20receiver%20on%20a%20page%20%28not%20including%20borders%2C%20margins%2C%20or%20scrollbars%29.%20%22%0D%0A%0D%0A%09%5Eself%20clientWidth%20@%20self%20clientHeight"));

smalltalk.bind(smalltalk.HTMLElement,"scroll",0
,function(){var self=this;
return self.scrollLeftTop().extent_(self.scrollExtent());}
,"accessing",unescape("scroll%0D%0A%09%22%20Return%20the%20scroll%20rectangle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20scrollLeftTop%20extent%3A%20self%20scrollExtent"));

smalltalk.bind(smalltalk.HTMLElement,"scrollLeftTop",0
,function(){var self=this;
return self.scrollLeft()._at(self.scrollTop());}
,"accessing",unescape("scrollLeftTop%0D%0A%09%22%20Return%20the%20scroll%20leftTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20scrollLeft%20@%20self%20scrollTop"));

smalltalk.bind(smalltalk.HTMLElement,"scrollExtent",0
,function(){var self=this;
return self.scrollWidth()._at(self.scrollHeight());}
,"accessing",unescape("scrollExtent%0D%0A%09%22%20Return%20the%20scroll%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20scrollWidth%20@%20self%20scrollHeight"));

smalltalk.bind(smalltalk.HTMLElement,"extent",0
,function(){var self=this;
return self.width()._at(self.height());}
,"accessing",unescape("extent%0D%0A%09%22%20Return%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20width%20@%20self%20height"));

smalltalk.bind(smalltalk.HTMLElement,"offset",0
,function(){var self=this;
return self.offsetLeftTop().extent_(self.offsetExtent());}
,"accessing",unescape("offset%0D%0A%09%22%20Return%20the%20offset%20rectangle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20offsetLeftTop%20extent%3A%20self%20offsetExtent"));

smalltalk.bind(smalltalk.HTMLElement,"offsetLeftTop",0
,function(){var self=this;
return self.offsetLeft()._at(self.offsetTop());}
,"accessing",unescape("offsetLeftTop%0D%0A%09%22%20Return%20the%20offset%20leftTop%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20offsetLeft%20@%20self%20offsetTop"));

smalltalk.bind(smalltalk.HTMLElement,"offsetExtent",0
,function(){var self=this;
return self.offsetWidth()._at(self.offsetHeight());}
,"accessing",unescape("offsetExtent%0D%0A%09%22%20Return%20the%20offset%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20offsetWidth%20@%20self%20offsetHeight"));

smalltalk.bind(smalltalk.HTMLElement,"scrollIntoView:",0
,function(aBoolean){var self=this;
return self.handle().scrollIntoView(aBoolean);}
,"scrolling",unescape("scrollIntoView%3A%20aBoolean%0D%0A%09%22%20Scroll%20the%20view%20to%20show%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23scrollIntoView%3A%20aBoolean"));

smalltalk.bind(smalltalk.HTMLElement,"getClientRects",0
,function(){var self=this;
return self.handle().getClientRects();}
,"bounds",unescape("getClientRects%0D%0A%09%22%20Return%20a%20LIST%20with%20the%20position%20of%20the%20border%20box%20edges%20relative%20to%20the%20viewport.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20getClientRects"));

smalltalk.bind(smalltalk.HTMLElement,"clientRects",0
,function(){var self=this;
var list=nil;
var result=nil;
var item=nil;
list=self.getClientRects();
result=smalltalk.Array.$$new();
if ((nil.isNil_(list)===false)){(0).to_do_(list.length._minus((1)),(function(index){item=list.item(index);return result.at_put_(index,item.left._at(item.top).rightBottom_(item.right._at(item.bottom)));}));};;
return result;}
,"bounds",unescape("clientRects%0D%0A%09%22%20Return%20an%20array%20of%20rectangles%20with%20the%20position%20of%20the%20border%20box%20edges%20relative%20to%20the%20viewport.%20%22%0D%0A%0D%0A%09%7C%20list%20result%20item%20%7C%0D%0A%09list%20%3A%3D%20self%20getClientRects.%0D%0A%09result%20%3A%3D%20Array%20new.%0D%0A%09list%20notNil%20ifTrue%3A%20%5B%0D%0A%09%090%20to%3A%20list%23length%20-%201%20do%3A%20%5B%3Aindex%7C%0D%0A%09%09%09item%20%3A%3D%20list%20%23item%3A%20index.%0D%0A%09%09%09result%20at%3A%20index%20put%3A%20%28item%23left%20@%20item%23top%20rightBottom%3A%20item%23right%20@%20item%23bottom%29%0D%0A%09%09%5D%0D%0A%09%5D.%0D%0A%09%5Eresult"));

smalltalk.bind(smalltalk.HTMLElement,"getBoundingClientRect",0
,function(){var self=this;
return self.handle().getBoundingClientRect();}
,"bounds",unescape("getBoundingClientRect%0D%0A%09%22%20Return%20the%20position%20of%20the%20border%20box%20edges%20relative%20to%20the%20viewport.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20getBoundingClientRect"));

smalltalk.bind(smalltalk.HTMLElement,"boundingClientRect",0
,function(){var self=this;
var item=nil;
item=self.getBoundingClientRect();
return item.left._at(item.top).rightBottom_(item.right._at(item.bottom));}
,"bounds",unescape("boundingClientRect%0D%0A%09%22%20Return%20the%20rectangle%20of%20the%20border%20box%20edges%20relative%20to%20the%20viewport.%20%22%0D%0A%0D%0A%09%7C%20item%20%7C%0D%0A%09item%20%3A%3D%20self%20getBoundingClientRect.%0D%0A%09%5Eitem%23left%20@%20item%23top%20rightBottom%3A%20item%23right%20@%20item%23bottom"));

smalltalk.bind(smalltalk.HTMLElement,"boundingBox",0
,function(){var self=this;
return self.boundingClientRect();}
,"bounds",unescape("boundingBox%0D%0A%09%22%20Return%20the%20bounds%20of%20the%20receiver%20relative%20to%20the%20viewport.%20%22%0D%0A%0D%0A%09%5Eself%20boundingClientRect"));

smalltalk.bind(smalltalk.DOMElement.$klass,"tagMap",0
,function(){var self=this;
if ((nil.isNil_(smalltalk.DOMElement.classVariableAt_("TagMap")))){smalltalk.DOMElement.classVariableAt_put_("TagMap",smalltalk.PoolDictionary.$$new());};;
return smalltalk.DOMElement.classVariableAt_("TagMap");}
,"private-mapping",unescape("tagMap%0D%0A%09%22%20Private%20-%20Return%20the%20map%20to%20use%20to%20create%20concrete%20instances%20from%20handles.%20%22%0D%0A%0D%0A%09TagMap%20isNil%20ifTrue%3A%20%5B%20TagMap%20%3A%3D%20PoolDictionary%20new%20%5D.%0D%0A%09%5ETagMap"));

smalltalk.bind(smalltalk.DOMElement,"firstChild",0
,function(){var self=this;
return self.elementSupport()._at(self["@handle"].firstChild);}
,"accessing",unescape("firstChild%0D%0A%09%22%20Return%20the%20first%20child%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20handle%23firstChild"));

smalltalk.bind(smalltalk.DOMElement,"lastChild",0
,function(){var self=this;
return self.elementSupport()._at(self["@handle"].lastChild);}
,"accessing",unescape("lastChild%0D%0A%09%22%20Return%20the%20last%20child%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20handle%23lastChild"));

smalltalk.bind(smalltalk.DOMElement,"nextSibling",0
,function(){var self=this;
return self.elementSupport()._at(self["@handle"].nextSibling);}
,"accessing",unescape("nextSibling%0D%0A%09%22%20Return%20the%20next%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20handle%23nextSibling"));

smalltalk.bind(smalltalk.DOMElement,"previousSibling",0
,function(){var self=this;
return self.elementSupport()._at(self["@handle"].previousSibling);}
,"accessing",unescape("previousSibling%0D%0A%09%22%20Return%20the%20previous%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20handle%23previousSibling"));

smalltalk.bind(smalltalk.DOMElement,"parentNode",0
,function(){var self=this;
return self.elementSupport()._at(self["@handle"].parentNode);}
,"accessing",unescape("parentNode%0D%0A%09%22%20Return%20the%20parent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20handle%23parentNode"));

smalltalk.bind(smalltalk.DOMElement,"ownerDocument",0
,function(){var self=this;
return smalltalk.HTMLDocument._at(self["@handle"].ownerDocument);}
,"accessing",unescape("ownerDocument%0D%0A%09%22%20Return%20the%20root%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EHTMLDocument%20@%20handle%23ownerDocument"));

smalltalk.bind(smalltalk.HTMLElement,"insertAdjacentHTML:text:",0
,function(where,htmlText){var self=this;
return self.handle().insertAdjacentHTML_text_(where,htmlText);}
,"inserting",unescape("insertAdjacentHTML%3A%20where%20text%3A%20htmlText%0D%0A%09%22%20Insert%20a%20HTML%20text.%0D%0A%09where%20can%20be%20one%20of%0D%0A%09%09%23BeforeBegin%20%23AfterBegin%0D%0A%09%09%23BeforeEnd%20%23AfterEnd%0D%0A%09%22%0D%0A%09%5Eself%20handle%20insertAdjacentHTML%3A%20where%20text%3A%20htmlText"));

smalltalk.bind(smalltalk.HTMLElement,"innerHtml:",0
,function(text){var self=this;
return self.innerHTML_(text);}
,"inserting",unescape("innerHtml%3A%20text%0D%0A%09%22%20Set%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20innerHTML%3A%20text"));

smalltalk.bind(smalltalk.HTMLElement,"innerHtml",0
,function(){var self=this;
return self.innerHTML();}
,"inserting",unescape("innerHtml%0D%0A%09%22%20Return%20the%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20innerHTML"));

smalltalk.bind(smalltalk.HTMLElement,"classNames",0
,function(){var self=this;
var names=nil;
names=self.className();
if ((nil.isNil_(names)).or_((function(){return names.toString().isEmpty();}))){return [];};;
return names.asArrayOfSubstrings();}
,"classNames",unescape("classNames%0D%0A%09%22%20Return%20the%20classNames%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20names%20%7C%0D%0A%09names%20%3A%3D%20self%20className.%0D%0A%09%28names%20isNil%20or%3A%20%5Bnames%20toString%20isEmpty%5D%29%20ifTrue%3A%20%5B%20%5E%23%28%29%20%5D.%0D%0A%09%5Enames%20asArrayOfSubstrings"));

smalltalk.bind(smalltalk.HTMLElement,"classNames:",0
,function(anArray){var self=this;
return self.className_(anArray.inject_into_("",(function(total,each){return total._comma(" ")._comma(each);})));}
,"classNames",unescape("classNames%3A%20anArray%0D%0A%09%22%20Set%20the%20classNames%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20className%3A%20%28anArray%20inject%3A%20%27%27%20into%3A%20%5B%3Atotal%20%3Aeach%7C%20total%20%2C%27%20%27%20%2Ceach%20%5D%29"));

smalltalk.bind(smalltalk.HTMLElement,"addClassName:",0
,function(aClassName){var self=this;
return self.classNames_((function($rec){$rec.add_(aClassName);return $rec.yourself();})(self.classNames().asSet()));}
,"classNames",unescape("addClassName%3A%20aClassName%0D%0A%09%22%20Add%20aClassName%20to%20the%20classNames%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20classNames%3A%20%28self%20classNames%20asSet%20add%3A%20aClassName%3B%20yourself%29"));

smalltalk.bind(smalltalk.HTMLElement,"addClassNames:",0
,function(anArray){var self=this;
return self.classNames_((function($rec){$rec.addAll_(anArray);return $rec.yourself();})(self.classNames().asSet()));}
,"classNames",unescape("addClassNames%3A%20anArray%0D%0A%09%22%20Add%20anArray%20to%20the%20classNames%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20classNames%3A%20%28self%20classNames%20asSet%20addAll%3A%20anArray%3B%20yourself%29"));

smalltalk.bind(smalltalk.HTMLElement,"removeClassName:ifAbsent:",0
,function(aClassName,aBlock){var self=this;
return self.classNames_((function($rec){$rec.remove_ifAbsent_(aClassName,aBlock);return $rec.yourself();})(self.classNames().asSet()));}
,"classNames",unescape("removeClassName%3A%20aClassName%20ifAbsent%3A%20aBlock%0D%0A%09%22%20Remove%20aClassName%20from%20the%20classNames%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20classNames%3A%20%28self%20classNames%20asSet%20remove%3A%20aClassName%20ifAbsent%3A%20aBlock%3B%20yourself%29"));

smalltalk.bind(smalltalk.HTMLElement,"removeClassName:",0
,function(aClassName){var self=this;
return self.removeClassName_ifAbsent_(aClassName,(function(){return nil;}));}
,"classNames",unescape("removeClassName%3A%20aClassName%0D%0A%09%22%20Remove%20aClassName%20from%20the%20classNames%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20removeClassName%3A%20aClassName%20ifAbsent%3A%20%5B%20%5D"));

smalltalk.bind(smalltalk.HTMLElement,"removeClassNames:",0
,function(anArray){var self=this;
return self.classNames_((function($rec){$rec.removeAll_(anArray);return $rec.yourself();})(self.classNames().asSet()));}
,"classNames",unescape("removeClassNames%3A%20anArray%0D%0A%09%22%20Remove%20anArray%20from%20the%20classNames%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20classNames%3A%20%28self%20classNames%20asSet%20removeAll%3A%20anArray%3B%20yourself%29"));

smalltalk.bind(smalltalk.DOMElement,"toString",0
,function(){var self=this;
return self.$klass.name()._comma(unescape("@"))._comma(self["@handle"].toString());}
,"converting",unescape("toString%0D%0A%09%22%20Return%20a%20string%20representation%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20class%20name%2C%27@%27%2Chandle%20toString"));

smalltalk.bind(smalltalk.HTMLAnchor,"blur",0
,function(){var self=this;
return self["@handle"].blur();}
,"actions",unescape("blur%0D%0A%09%22%20Removes%20focus%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20blur"));

smalltalk.bind(smalltalk.HTMLIFrame,"contentDocument",0
,function(){var self=this;
return smalltalk.HTMLDocument._at(self["@handle"].contentDocument);}
,"accessing",unescape("contentDocument%0D%0A%0D%0A%09%5EHTMLDocument%20@%20handle%23contentDocument"));

smalltalk.bind(smalltalk.HTMLAnchor,"focus",0
,function(){var self=this;
return self["@handle"].focus();}
,"actions",unescape("focus%0D%0A%09%22%20Gives%20focus%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20focus"));

smalltalk.bind(smalltalk.HTMLAnchor,"click",0
,function(){var self=this;
return self["@handle"].click();}
,"actions",unescape("click%0D%0A%09%22%20Executes%20a%20click%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20click"));

smalltalk.bind(smalltalk.HTMLArea,"click",0
,function(){var self=this;
return self["@handle"].click();}
,"actions",unescape("click%0D%0A%09%22%20Executes%20a%20click%20on%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20click"));

smalltalk.bind(smalltalk.DOMNode,"appendChild:",0
,function(aDOMNode){var self=this;
return self["@handle"].appendChild(self.asJson_(aDOMNode));}
,"actions",unescape("appendChild%3A%20aDOMNode%0D%0A%09%22%20Adds%20a%20new%20element%20to%20the%20end%20of%20the%20children%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23appendChild%3A%20%28self%20asJson%3A%20aDOMNode%29"));

smalltalk.bind(smalltalk.DOMNode,"cloneNode:",0
,function(includeAll){var self=this;
return self.$klass._at(self["@handle"].cloneNode(includeAll));}
,"actions",unescape("cloneNode%3A%20includeAll%0D%0A%09%22%20If%20the%20Boolean%20parameter%20is%20set%20to%20true%2C%20the%20cloned%20node%20clones%20all%20the%20child%20nodes%20of%20the%20original%20node%20as%20well.%20%22%0D%0A%0D%0A%09%5Eself%20class%20@%20%28handle%20%23cloneNode%3A%20includeAll%29"));

smalltalk.bind(smalltalk.DOMElement,"get:byTagName:do:",0
,function(aDOMElementClass,tagName,aBlock){var self=this;
return self.array_of_do_(self["@handle"].getElementsByTagName(tagName),aDOMElementClass,aBlock);}
,"accessing",unescape("get%3A%20aDOMElementClass%20byTagName%3A%20tagName%20do%3A%20aBlock%0D%0A%09%22%20Private%20-%20Return%20the%20elements%20collection%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09array%3A%20%28handle%20%23getElementsByTagName%3A%20tagName%29%0D%0A%09%09of%3A%20aDOMElementClass%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.DOMElement,"get:byTagName:",0
,function(aDOMElementClass,tagName){var self=this;
return self.array_of_(self["@handle"].getElementsByTagName(tagName),aDOMElementClass);}
,"accessing",unescape("get%3A%20aDOMElementClass%20byTagName%3A%20tagName%0D%0A%09%22%20Private%20-%20Return%20the%20elements%20collection%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09array%3A%20%28handle%20%23getElementsByTagName%3A%20tagName%29%0D%0A%09%09of%3A%20aDOMElementClass"));

smalltalk.bind(smalltalk.DOMElement,"getElementsByTagName:",0
,function(tagName){var self=this;
return self.get_byTagName_(self.elementSupport(),tagName);}
,"accessing",unescape("getElementsByTagName%3A%20tagName%0D%0A%09%22%20Return%20anArray%20with%20the%20elements%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%20get%3A%20self%20elementSupport%20byTagName%3A%20tagName"));

smalltalk.bind(smalltalk.DOMElement,"withElementsTagged:do:",0
,function(tagName,aBlock){var self=this;
return self.get_byTagName_do_(self.elementSupport(),tagName,aBlock);}
,"accessing",unescape("withElementsTagged%3A%20tagName%20do%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20the%20elements%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%20get%3A%20self%20elementSupport%20byTagName%3A%20tagName%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLElement,"style",0
,function(){var self=this;
return smalltalk.HTMLStyle._at(self["@handle"].style);}
,"accessing",unescape("style%0D%0A%09%22%20Return%20the%20style%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EHTMLStyle%20@%20handle%23style"));

smalltalk.bind(smalltalk.HTMLElement,"style:",0
,function(aDOMStyle){var self=this;
if ((nil.isNil_(aDOMStyle)).or_((function(){return aDOMStyle.toString().isEmpty();}))){return self.removeAttribute_("style");};;
self["@handle"].style=aDOMStyle.handle();
return self;}
,"accessing",unescape("style%3A%20aDOMStyle%0D%0A%09%22%20Set%20the%20style%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%28aDOMStyle%20isNil%20or%3A%20%5BaDOMStyle%20toString%20isEmpty%5D%29%20ifTrue%3A%20%5B%20%5Eself%20removeAttribute%3A%20%23style%20%5D.%0D%0A%09handle%23style%20%3A%3D%20aDOMStyle%20handle"));

smalltalk.bind(smalltalk.DOMNode,"hasChildNodes",0
,function(){var self=this;
return self["@handle"].hasChildNodes();}
,"accessing",unescape("hasChildNodes%0D%0A%09%22%20Return%20true%20if%20the%20receiver%20hasChildNodes.%20%22%0D%0A%0D%0A%09%5Ehandle%20hasChildNodes"));

smalltalk.bind(smalltalk.DOMNode,"insert:before:",0
,function(newChild,refChild){var self=this;
self["@handle"].insertBefore(self.asJson_(newChild),self.asJson_(refChild));
return self;}
,"actions",unescape("insert%3A%20newChild%20before%3A%20refChild%0D%0A%09%22%20Insert%20new%20child%20element%20in%20the%20receiver%20just%20before%20reference.%20%22%0D%0A%0D%0A%09handle%0D%0A%09%09%23insertBefore%3A%20%28self%20asJson%3A%20newChild%29%0D%0A%09%09with%3A%20%28self%20asJson%3A%20refChild%29"));

smalltalk.bind(smalltalk.DOMElement,"item:",0
,function(index){var self=this;
return self.elementSupport()._at(self["@handle"].item(index));}
,"accessing",unescape("item%3A%20index%0D%0A%09%22%20Return%20item%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20%28handle%20%23item%3A%20index%29"));

smalltalk.bind(smalltalk.DOMElement,"item:as:",0
,function(index,aDOMElementClass){var self=this;
return aDOMElementClass._at(self["@handle"].item(index));}
,"accessing",unescape("item%3A%20index%20as%3A%20aDOMElementClass%0D%0A%09%22%20Return%20item%20at%20index%20in%20the%20receiver%20as%20an%20instance%20of%20aDOMElementClass.%20%22%0D%0A%0D%0A%09%5EaDOMElementClass%20@%20%28handle%20%23item%3A%20index%29"));

smalltalk.bind(smalltalk.DOMElement,"normalize",0
,function(){var self=this;
self["@handle"].normalize();
return self;}
,"actions",unescape("normalize%0D%0A%09%22%20Puts%20all%20text%20nodes%20underneath%20this%20element%20%28including%20attributes%29%20into%20a%20normal%20form%20where%20only%20structure%20%28e.g.%2C%20elements%2C%20comments%2C%20processing%20instructions%2C%20CDATA%20sections%2C%20and%20entity%20references%29%20separates%20Text%20nodes%2C%20i.e.%2C%20there%20are%20neither%20adjacent%20Text%20nodes%20nor%20empty%20Text%20nodes.%20%22%0D%0A%0D%0A%09handle%20normalize"));

smalltalk.bind(smalltalk.DOMElement,"getAttribute:",0
,function(aName){var self=this;
return self["@handle"].getAttribute(aName);}
,"accessing",unescape("getAttribute%3A%20aName%0D%0A%09%22%20Return%20the%20value%20of%20an%20attribute.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23getAttribute%3A%20aName"));

smalltalk.bind(smalltalk.DOMElement,"setAttribute:to:",0
,function(aName,value){var self=this;
return self["@handle"].setAttribute(aName,value);}
,"accessing",unescape("setAttribute%3A%20aName%20to%3A%20value%0D%0A%09%22%20Set%20the%20value%20of%20an%20attribute.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23setAttribute%3A%20aName%20to%3A%20value"));

smalltalk.bind(smalltalk.DOMElement,"removeAttribute:",0
,function(aName){var self=this;
return self["@handle"].removeAttribute(aName);}
,"accessing",unescape("removeAttribute%3A%20aName%0D%0A%09%22%20Remove%20the%20attribute%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23removeAttribute%3A%20aName"));

smalltalk.bind(smalltalk.DOMCharacterData,"appendData:",0
,function(aString){var self=this;
self["@handle"].appendData(aString);
return self;}
,"actions",unescape("appendData%3A%20aString%0D%0A%0D%0A%09handle%20%23appendData%3A%20aString"));

smalltalk.bind(smalltalk.DOMCharacterData,"deleteData:count:",0
,function(offset,count){var self=this;
self["@handle"].deleteData(offset,count);
return self;}
,"actions",unescape("deleteData%3A%20offset%20count%3A%20count%0D%0A%0D%0A%09handle%20%23deleteData%3A%20offset%20count%3A%20count"));

smalltalk.bind(smalltalk.DOMCharacterData,"insert:data:",0
,function(offset,aString){var self=this;
self["@handle"].insertData(offset,aString);
return self;}
,"actions",unescape("insert%3A%20offset%20data%3A%20aString%0D%0A%0D%0A%09handle%20%23insertData%3A%20offset%20data%3A%20aString"));

smalltalk.bind(smalltalk.DOMCharacterData,"replace:count:data:",0
,function(offset,count,aString){var self=this;
self["@handle"].replaceData(offset,count,aString);
return self;}
,"actions",unescape("replace%3A%20offset%20count%3A%20count%20data%3A%20aString%0D%0A%0D%0A%09handle%20%23replaceData%3A%20offset%20count%3A%20count%20data%3A%20aString"));

smalltalk.bind(smalltalk.DOMCharacterData,"substringData:count:",0
,function(offset,count){var self=this;
return self["@handle"].substringData(offset,count);}
,"actions",unescape("substringData%3A%20offset%20count%3A%20count%0D%0A%09%22%20Return%20a%20String%20from%20offset%20of%20size%20count.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23substringData%3A%20offset%20count%3A%20count"));

smalltalk.bind(smalltalk.DOMText,"splitText:",0
,function(offset){var self=this;
return self.$klass._at(self["@handle"].splitText(offset));}
,"actions",unescape("splitText%3A%20offset%0D%0A%0D%0A%09%5Eself%20class%20@%20%28handle%20%23splitText%3A%20offset%29"));

smalltalk.bind(smalltalk.DOMText,"value:",0
,function(aString){var self=this;
return (self.handle()["nodeValue"]=(aString));}
,"accessing",unescape("value%3A%20aString%0D%0A%09%22%20Set%20the%20text%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23nodeValue%20put%3A%20aString"));

smalltalk.bind(smalltalk.DOMText,"value",0
,function(){var self=this;
return self.nodeValue();}
,"accessing",unescape("value%0D%0A%09%22%20Return%20the%20text%20value%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20nodeValue"));

smalltalk.bind(smalltalk.DOMNode,"removeChild:",0
,function(aDOMNode){var self=this;
return self["@handle"].removeChild(self.asJson_(aDOMNode));}
,"accessing",unescape("removeChild%3A%20aDOMNode%0D%0A%09%22%20Remove%20the%20node%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23removeChild%3A%20%28self%20asJson%3A%20aDOMNode%29"));

smalltalk.bind(smalltalk.DOMNode,"removeNode:",0
,function(aDOMNode){var self=this;
return self["@handle"].removeNode(self.asJson_(aDOMNode));}
,"accessing",unescape("removeNode%3A%20aDOMNode%0D%0A%09%22%20Remove%20the%20node%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23removeNode%3A%20%28self%20asJson%3A%20aDOMNode%29"));

smalltalk.bind(smalltalk.DOMNode,"replace:child:",0
,function(newNode,oldNode){var self=this;
return self["@handle"].replaceChild(self.asJson_(newNode),self.asJson_(oldNode));}
,"accessing",unescape("replace%3A%20newNode%20child%3A%20oldNode%0D%0A%09%22%20Replace%20the%20node%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%0D%0A%09%09%23replaceChild%3A%20%28self%20asJson%3A%20newNode%29%0D%0A%09%09old%3A%20%28self%20asJson%3A%20oldNode%29"));

smalltalk.bind(smalltalk.DOMNode,"replace:with:",0
,function(oldNode,newNode){var self=this;
return self["@handle"].replaceChild(self.asJson_(newNode),self.asJson_(oldNode));}
,"accessing",unescape("replace%3A%20oldNode%20with%3A%20newNode%0D%0A%09%22%20Replace%20the%20node%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%0D%0A%09%09%23replaceChild%3A%20%28self%20asJson%3A%20newNode%29%0D%0A%09%09old%3A%20%28self%20asJson%3A%20oldNode%29"));

smalltalk.bind(smalltalk.HTMLDocument,"anchors",0
,function(){var self=this;
return self.array_of_(self["@handle"].anchors,smalltalk.HTMLAnchor);}
,"accessing",unescape("anchors%0D%0A%09%22%20Return%20the%20anchors%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23anchors%20of%3A%20HTMLAnchor"));

smalltalk.bind(smalltalk.HTMLDocument,"anchorsDo:",0
,function(aBlock){var self=this;
return self.array_of_do_(self["@handle"].anchors,smalltalk.HTMLAnchor,aBlock);}
,"accessing",unescape("anchorsDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20anchors%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23anchors%20of%3A%20HTMLAnchor%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLDocument,"anchorAt:",0
,function(index){var self=this;
return self.array_of_at_(self["@handle"].anchors,smalltalk.HTMLAnchor,index);}
,"accessing",unescape("anchorAt%3A%20index%0D%0A%09%22%20Return%20the%20anchor%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23anchors%20of%3A%20HTMLAnchor%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLDocument,"forms",0
,function(){var self=this;
return self.array_of_(self["@handle"].forms,smalltalk.HTMLForm);}
,"accessing",unescape("forms%0D%0A%09%22%20Return%20the%20forms%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23forms%20of%3A%20HTMLForm"));

smalltalk.bind(smalltalk.HTMLDocument,"formAt:",0
,function(index){var self=this;
return self.array_of_at_(self["@handle"].forms,smalltalk.HTMLForm,index);}
,"accessing",unescape("formAt%3A%20index%0D%0A%09%22%20Return%20the%20form%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23forms%20of%3A%20HTMLForm%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLDocument,"formsDo:",0
,function(aBlock){var self=this;
return self.array_of_do_(self["@handle"].forms,smalltalk.HTMLForm,aBlock);}
,"accessing",unescape("formsDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20forms%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23forms%20of%3A%20HTMLForm%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLDocument,"images",0
,function(){var self=this;
return self.array_of_(self["@handle"].images,smalltalk.HTMLImage);}
,"accessing",unescape("images%0D%0A%09%22%20Return%20the%20images%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23images%20of%3A%20HTMLImage"));

smalltalk.bind(smalltalk.HTMLDocument,"imagesDo:",0
,function(aBlock){var self=this;
return self.array_of_do_(self["@handle"].images,smalltalk.HTMLImage,aBlock);}
,"accessing",unescape("imagesDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20images%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23images%20of%3A%20HTMLImage%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLDocument,"imageAt:",0
,function(index){var self=this;
return self.array_of_at_(self["@handle"].images,smalltalk.HTMLImage,index);}
,"accessing",unescape("imageAt%3A%20index%0D%0A%09%22%20Return%20the%20image%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23images%20of%3A%20HTMLImage%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLDocument,"links",0
,function(){var self=this;
return self.array_of_(self["@handle"].links,smalltalk.HTMLLink);}
,"accessing",unescape("links%0D%0A%09%22%20Return%20the%20links%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23links%20of%3A%20HTMLLink"));

smalltalk.bind(smalltalk.HTMLDocument,"linksDo:",0
,function(aBlock){var self=this;
return self.array_of_do_(self["@handle"].links,smalltalk.HTMLLink,aBlock);}
,"accessing",unescape("linksDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20links%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23links%20of%3A%20HTMLLink%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLDocument,"linkAt:",0
,function(index){var self=this;
return self.array_of_at_(self["@handle"].links,smalltalk.HTMLLink,index);}
,"accessing",unescape("linkAt%3A%20index%0D%0A%09%22%20Return%20the%20link%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23links%20of%3A%20HTMLLink%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLDocument,"head",0
,function(){var self=this;
return self.getElementsByTagName_("head").first();}
,"accessing",unescape("head%0D%0A%09%22%20Return%20the%20first%20head%20element%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%28self%20getElementsByTagName%3A%20%23head%29%20first"));

smalltalk.bind(smalltalk.HTMLDocument,"body",0
,function(){var self=this;
return self.getElementsByTagName_("body").first();}
,"accessing",unescape("body%0D%0A%09%22%20Return%20the%20first%20head%20element%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%28self%20getElementsByTagName%3A%20%23body%29%20first"));

smalltalk.bind(smalltalk.HTMLDocument,"add:script:onLoad:",0
,function(type,anURL,aBlock){var self=this;
var script=nil;
script=self.createElement_("script").handle();
script.type=type;
if (((function(){var $1$=(script["readyState"]);if(nil.isNil_($1$))return ((function(){return "missing";}).value());return $1$;})())._eq("missing")){script.onload=aBlock;} else{script.onreadystatechange=(function(){return ((script.readyState._eq("loaded").or_((function(){return script.readyState._eq("complete");}))).mustBeBoolean()==true ? (function(){script.onreadystatechange=nil.json();return aBlock.evaluate();})() : nil);});};;
script.src=anURL;
self.head().appendChild_(self.elementSupport()._at(script));
return self;}
,"adding",unescape("add%3A%20type%20script%3A%20anURL%20onLoad%3A%20aBlock%0D%0A%09%22%20Append%20a%20script%20of%20specified%20type%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20script%20%7C%0D%0A%09script%20%3A%3D%20%28self%20createElement%3A%20%23script%29%20handle.%0D%0A%09script%23type%20%20%20%3A%3D%20type.%0A%0D%0A%09%28script%20basicAt%3A%20%23readyState%20ifAbsent%3A%20%5B%23missing%5D%29%20%3D%20%23missing%0D%0A%09ifTrue%3A%20%5B%20script%23onload%20%3A%3D%20aBlock%20%5D%0D%0A%09ifFalse%3A%20%5B%20%22IE%22%0D%0A%09%09script%23onreadystatechange%20%3A%3D%20%5B%0D%0A%09%09%09%28script%23readyState%20%3D%20%23loaded%20or%3A%20%5B%0D%0A%09%09%09%20script%23readyState%20%3D%20%23complete%20%5D%29%0D%0A%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%09ifTrue%3A%20%5B%0D%0A%09%09%09%09script%23onreadystatechange%20%3A%3D%20nil%20json.%0D%0A%09%09%09%09aBlock%20evaluate.%0D%0A%09%09%09%5D%0D%0A%09%09%5D%0D%0A%09%5D.%0D%0A%09script%23src%20%3A%3D%20anURL.%0D%0A%09self%20head%20appendChild%3A%20self%20elementSupport%20@%20script."));

smalltalk.bind(smalltalk.HTMLDocument,"addJavascript:onLoad:",0
,function(jsURL,aBlock){var self=this;
return self.add_script_onLoad_(unescape("text/javascript"),jsURL,aBlock);}
,"adding",unescape("addJavascript%3A%20jsURL%20onLoad%3A%20aBlock%0D%0A%09%22%20Append%20a%20javascript%20script%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20add%3A%20%27text/javascript%27%20script%3A%20jsURL%20onLoad%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLDocument,"load:onLoad:",0
,function(jsURL,action){var self=this;
return self.addJavascript_onLoad_(jsURL,(function(){return action.evaluate();}));}
,"loading",unescape("load%3A%20jsURL%20onLoad%3A%20action%0D%0A%09%22%20Load%20a%20javascript%20library%20to%20the%20system%20from%20jsURL%20and%20evaluate%20action%20when%20loading%20has%20finished.%20%22%0D%0A%0D%0A%09%5Eself%20addJavascript%3A%20jsURL%20onLoad%3A%20%5B%20action%20evaluate%20%5D"));

smalltalk.bind(smalltalk.HTMLDocument,"headjsURL",0
,function(){var self=this;
return unescape("http%3A//u8.smalltalking.net/profile/aleReimondo/Head/Head.st.js");}
,"private",unescape("headjsURL%0D%0A%09%22%20Private%20-%20Return%20the%20URL%20to%20download%20Head.js%20support.%20%22%0D%0A%0D%0A%09%5E%27http%3A//u8.smalltalking.net/profile/aleReimondo/Head/Head.st.js%27"));

smalltalk.bind(smalltalk.HTMLDocument,"loadAll:onLoad:",0
,function(urls,action){var self=this;
var head=nil;
if (urls.isEmpty()){return action.evaluate();};;
head=smalltalk.Smalltalk.at_ifAbsent_("Head",(function(){return nil;}));
if ((nil.isNil_(head)===false)){return head.loadAll_onLoad_(urls,action);};;
if (smalltalk.DOM.navigator().appName()._eq("Microsoft Internet Explorer")){return self.load_onLoad_(self.headjsURL(),(function(){return smalltalk.Smalltalk.at_("Head").loadAll_onLoad_(urls,action);}));};;
self.load_onLoad_(urls.removeFirst(),(function(){return self.loadAll_onLoad_(urls,action);}));
return self;}
,"loading",unescape("loadAll%3A%20urls%20onLoad%3A%20action%0D%0A%09%22%20Load%20a%20collection%20of%20javascript%20libraries%20to%20the%20system%20from%20URLs%20and%20evaluate%20action%20when%20loading%20has%20finished.%20%22%0D%0A%0D%0A%09%7C%20head%20%7C%0D%0A%09urls%20isEmpty%20ifTrue%3A%20%5B%20%5Eaction%20evaluate%20%5D.%0D%0A%09head%20%3A%3D%20Smalltalk%20at%3A%20%23Head%20ifAbsent%3A%20%5B%5D.%0D%0A%09head%20notNil%20ifTrue%3A%20%5B%20%5Ehead%20loadAll%3A%20urls%20onLoad%3A%20action%20%5D.%0D%0A%0D%0A%09DOM%20navigator%20appName%20%3D%20%27Microsoft%20Internet%20Explorer%27%20ifTrue%3A%20%5B%20%22we%20use%20Head.js%20support%20on%20this%20browser%22%0D%0A%09%09%5Eself%0D%0A%09%09%09load%3A%20self%20headjsURL%0D%0A%09%09%09onLoad%3A%20%5B%20%28Smalltalk%20at%3A%20%23Head%29%20loadAll%3A%20urls%20onLoad%3A%20action%20%5D%0D%0A%09%5D.%0D%0A%0D%0A%09self%20load%3A%20urls%20removeFirst%20onLoad%3A%20%5B%20self%20loadAll%3A%20urls%20onLoad%3A%20action%20%5D"));

smalltalk.bind(smalltalk.HTMLDocument,"load:from:onLoad:",0
,function(globalName,jsURL,action){var self=this;
var global=nil;
return self.load_onLoad_(jsURL,(function(){global=smalltalk.Smalltalk.at_(globalName);return ((action.isString()).mustBeBoolean()==true ? (function(){return action.evaluate();})() : (function(){return action.evaluateWith_(global);})());}));}
,"loading",unescape("load%3A%20globalName%20from%3A%20jsURL%20onLoad%3A%20action%0D%0A%09%22%20Load%20a%20javascript%20library%20to%20the%20system%20from%20jsURL.%0D%0A%09After%20loading%20evaluate%20action%20with%20the%20global%20object%20at%20globalName.%0D%0A%09Generates%20an%20error%20if%20the%20global%20is%20not%20defined%20after%20loading%20the%20library.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20global%20%7C%0D%0A%09%5Eself%20load%3A%20jsURL%20onLoad%3A%20%5B%0D%0A%09%09global%20%3A%3D%20Smalltalk%20at%3A%20globalName.%0D%0A%09%09action%20isString%20ifTrue%3A%20%5B%20action%20evaluate%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20action%20evaluateWith%3A%20global%20%5D.%0D%0A%09%5D"));

smalltalk.bind(smalltalk.HTMLDocument,"addCSS:",0
,function(cssURL){var self=this;
var node=nil;
node=self.createElement_("link");
(function($rec){$rec.type_(unescape("text/css"));$rec.rel_("stylesheet");$rec.href_(cssURL);return $rec.media_("screen");})(node);
self.head().appendChild_(node);
return self;}
,"adding",unescape("addCSS%3A%20cssURL%0D%0A%09%22%20Append%20a%20cascading%20style%20sheet%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20node%20%7C%0D%0A%09node%20%3A%3D%20self%20createElement%3A%20%23link.%0D%0A%09node%0A%0D%0A%09%09type%3A%20%27text/css%27%3B%0A%0D%0A%09%09rel%3A%20%23stylesheet%3B%0A%0D%0A%09%09href%3A%20cssURL%3B%0D%0A%09%09media%3A%20%27screen%27.%0D%0A%09self%20head%20appendChild%3A%20node.%0A"));

smalltalk.bind(smalltalk.HTMLDocument,"url",0
,function(){var self=this;
return ((function(){var $1$=(self["@handle"]["URL"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("url%0D%0A%09%22%20Return%20the%20URL%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20basicAt%3A%20%23URL"));

smalltalk.bind(smalltalk.HTMLDocument,"open:replace:",0
,function(mimeType,replace){var self=this;
return self.$klass._at(self["@handle"].open(mimeType,replace));}
,"io",unescape("open%3A%20mimeType%20replace%3A%20replace%0D%0A%09%22%20Opens%20an%20output%20stream%20to%20collect%20the%20output%20from%20%23write%3A%20or%20%23writeln%3A.%0D%0A%09Once%20all%20the%20writes%20are%20performed%2C%20%23close%20causes%20any%20output%20written%20to%20the%20output%20stream%20to%20be%20displayed.%0D%0A%09Note%3A%20If%20a%20document%20already%20exists%20in%20the%20target%2C%20it%20will%20be%20cleared.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20class%20@%20%28handle%20%23open%3A%20mimeType%20replace%3A%20replace%29"));

smalltalk.bind(smalltalk.HTMLDocument,"open:",0
,function(mimeType){var self=this;
return self.$klass._at(self["@handle"].open(mimeType));}
,"io",unescape("open%3A%20mimeType%0D%0A%09%22%20Opens%20an%20output%20stream%20to%20collect%20the%20output%20from%20%23write%3A%20or%20%23writeln%3A.%0D%0A%09Once%20all%20the%20writes%20are%20performed%2C%20%23close%20causes%20any%20output%20written%20to%20the%20output%20stream%20to%20be%20displayed.%0D%0A%09Note%3A%20If%20a%20document%20already%20exists%20in%20the%20target%2C%20it%20will%20be%20cleared.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20class%20@%20%28handle%20%23open%3A%20mimeType%29"));

smalltalk.bind(smalltalk.HTMLDocument,"open",0
,function(){var self=this;
return self.$klass._at(self["@handle"].open());}
,"io",unescape("open%0D%0A%09%22%20A%20new%20window%20%28about%3Ablank%29%20is%20displayed.%20%22%0D%0A%0D%0A%09%5Eself%20class%20@%20handle%20open"));

smalltalk.bind(smalltalk.HTMLDocument,"close",0
,function(){var self=this;
return self["@handle"].close();}
,"io",unescape("close%0D%0A%09%22%20Close%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20close"));

smalltalk.bind(smalltalk.HTMLDocument,"write:",0
,function(anObject){var self=this;
return self["@handle"].write(anObject);}
,"io",unescape("write%3A%20anObject%0D%0A%09%22%20Output%20anObject%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23write%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLDocument,"writeln:",0
,function(anObject){var self=this;
return self["@handle"].writeln(anObject);}
,"io",unescape("writeln%3A%20anObject%0D%0A%09%22%20Output%20anObject%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23writeln%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLDocument,"nextPut:",0
,function(anObject){var self=this;
return self.write_(anObject);}
,"io",unescape("nextPut%3A%20anObject%0D%0A%09%22%20Output%20anObject%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20write%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLDocument,"nextPutAll:",0
,function(anObject){var self=this;
return self.write_(anObject);}
,"io",unescape("nextPutAll%3A%20anObject%0D%0A%09%22%20Output%20anObject%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20write%3A%20anObject"));

smalltalk.bind(smalltalk.HTMLDocument,"cr",0
,function(){var self=this;
return self.writeln_(unescape("%3Cbr/%3E"));}
,"io",unescape("cr%0D%0A%09%22%20Output%20a%20new%20line%20onto%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20writeln%3A%20%27%3Cbr/%3E%27"));

smalltalk.bind(smalltalk.HTMLDocument,"flush",0
,function(){var self=this;
return self;}
,"io",unescape("flush%0D%0A%09%22%20OBSOLETE%20-%20Flush%20the%20receiver.%20%22"));

smalltalk.bind(smalltalk.DOMDocument,"get:byId:",0
,function(aDOMElementClass,id){var self=this;
return aDOMElementClass._at(self["@handle"].getElementById(id));}
,"accessing",unescape("get%3A%20aDOMElementClass%20byId%3A%20id%0D%0A%09%22%20Return%20the%20first%20element%20in%20the%20receiver%20with%20id%20as%20an%20instance%20of%20aDOMElementClass.%20%22%0D%0A%0D%0A%09%5EaDOMElementClass%20@%20%28handle%20%23getElementById%3A%20id%29"));

smalltalk.bind(smalltalk.DOMDocument,"getElementById:",0
,function(id){var self=this;
return self.get_byId_(self.elementSupport(),id);}
,"accessing",unescape("getElementById%3A%20id%0D%0A%09%22%20Return%20the%20first%20element%20in%20the%20receiver%20with%20id.%20%22%0D%0A%0D%0A%09%5Eself%20get%3A%20self%20elementSupport%20byId%3A%20id"));

smalltalk.bind(smalltalk.DOMDocument,"@","_at"
,function(id){var self=this;
return self.getElementById_(id);}
,"accessing",unescape("@%20id%0D%0A%09%22%20Return%20the%20element%20in%20the%20receiver%20with%20id.%20%22%0D%0A%0D%0A%09%5Eself%20getElementById%3A%20id"));

smalltalk.bind(smalltalk.DOMDocument,"get:byName:",0
,function(aDOMElementClass,aName){var self=this;
return aDOMElementClass._at(self["@handle"].getElementByName(aName));}
,"accessing",unescape("get%3A%20aDOMElementClass%20byName%3A%20aName%0D%0A%09%22%20Return%20the%20first%20element%20in%20the%20receiver%20with%20name%20aName%20as%20an%20instance%20of%20aDOMElementClass.%20%22%0D%0A%0D%0A%09%5EaDOMElementClass%20@%20%28handle%20%23getElementByName%3A%20aName%29"));

smalltalk.bind(smalltalk.DOMDocument,"get:byTagName:do:",0
,function(aDOMElementClass,tagName,aBlock){var self=this;
return self.array_of_do_(self["@handle"].getElementsByTagName(tagName),aDOMElementClass,aBlock);}
,"accessing",unescape("get%3A%20aDOMElementClass%20byTagName%3A%20tagName%20do%3A%20aBlock%0D%0A%09%22%20Private%20-%20Return%20the%20elements%20collection%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09array%3A%20%28handle%20%23getElementsByTagName%3A%20tagName%29%0D%0A%09%09of%3A%20aDOMElementClass%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.DOMDocument,"get:byTagName:",0
,function(aDOMElementClass,tagName){var self=this;
return self.array_of_(self["@handle"].getElementsByTagName(tagName),aDOMElementClass);}
,"accessing",unescape("get%3A%20aDOMElementClass%20byTagName%3A%20tagName%0D%0A%09%22%20Private%20-%20Return%20the%20elements%20collection%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%0D%0A%09%09array%3A%20%28handle%20%23getElementsByTagName%3A%20tagName%29%0D%0A%09%09of%3A%20aDOMElementClass"));

smalltalk.bind(smalltalk.DOMDocument,"getElementsByTagName:",0
,function(tagName){var self=this;
return self.get_byTagName_(self.elementSupport(),tagName);}
,"accessing",unescape("getElementsByTagName%3A%20tagName%0D%0A%09%22%20Return%20anArray%20with%20the%20elements%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%20get%3A%20self%20elementSupport%20byTagName%3A%20tagName"));

smalltalk.bind(smalltalk.DOMDocument,"withElementsTagged:do:",0
,function(tagName,aBlock){var self=this;
return self.get_byTagName_do_(self.elementSupport(),tagName,aBlock);}
,"accessing",unescape("withElementsTagged%3A%20tagName%20do%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20the%20elements%20matching%20tag%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%20get%3A%20self%20elementSupport%20byTagName%3A%20tagName%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.DOMDocument,"createAttribute:",0
,function(aName){var self=this;
return smalltalk.DOMAttribute._at(self["@handle"].createAttribute(aName));}
,"creation",unescape("createAttribute%3A%20aName%0D%0A%09%22%20Return%20a%20DOMAttribute%20of%20given%20name%20aName.%20%22%0D%0A%0D%0A%09%5EDOMAttribute%20@%20%28handle%20%23createAttribute%3A%20aName%29"));

smalltalk.bind(smalltalk.DOMDocument,"createCDATASection:",0
,function(data){var self=this;
return self.elementSupport()._at(self["@handle"].createCDATASection(data));}
,"creation",unescape("createCDATASection%3A%20data%0D%0A%09%22%20Return%20a%20data%20section%20with%20data.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20%28handle%20%23createCDATASection%3A%20data%29"));

smalltalk.bind(smalltalk.DOMDocument,"createComment:",0
,function(data){var self=this;
return self.elementSupport()._at(self["@handle"].createComment(data));}
,"creation",unescape("createComment%3A%20data%0D%0A%09%22%20Return%20a%20comment%20with%20data.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20%28handle%20%23createComment%3A%20data%29"));

smalltalk.bind(smalltalk.DOMDocument,"createDocumentFragment",0
,function(){var self=this;
return self.elementSupport()._at(self["@handle"].createDocumentFragment());}
,"creation",unescape("createDocumentFragment%0D%0A%09%22%20Return%20a%20new%20document%20fragment.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20handle%20createDocumentFragment"));

smalltalk.bind(smalltalk.DOMDocument,"createElement:",0
,function(tagName){var self=this;
return self.elementSupport()._at(self.createElementHandle_(tagName));}
,"creation",unescape("createElement%3A%20tagName%0D%0A%09%22%20Return%20a%20DOMElement%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20%28self%20createElementHandle%3A%20tagName%29"));

smalltalk.bind(smalltalk.DOMDocument,"createTextElement:",0
,function(aString){var self=this;
return smalltalk.DOMText._at(self.handle().createTextNode(aString));}
,"creation",unescape("createTextElement%3A%20aString%0D%0A%09%22%20Return%20a%20DOMText%20with%20aString.%20%22%0D%0A%0D%0A%09%5EDOMText%20@%20%28self%20handle%20%23createTextNode%3A%20aString%29"));

smalltalk.bind(smalltalk.DOMDocument,"createElementHandle:",0
,function(tagName){var self=this;
return self["@handle"].createElement(tagName);}
,"creation",unescape("createElementHandle%3A%20tagName%0D%0A%09%22%20Private%20-%20Return%20a%20DOMElement%20handle%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5Ehandle%20%23createElement%3A%20tagName"));

smalltalk.bind(smalltalk.DOMDocument,"elementFromPoint:y:",0
,function(x,y){var self=this;
return self.elementSupport()._at(self["@handle"].elementFromPoint(x,y));}
,"accessing",unescape("elementFromPoint%3A%20x%20y%3A%20y%0D%0A%09%22%20Return%20a%20DOMElement%20at%20coordinates%20x%2Cy%20in%20the%20viewport%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20%28handle%20%23elementFromPoint%3A%20x%20y%3A%20y%29"));

smalltalk.bind(smalltalk.DOMDocument,"elementFromPoint:",0
,function(aPoint){var self=this;
return self.elementFromPoint_y_(aPoint.x(),aPoint.y());}
,"accessing",unescape("elementFromPoint%3A%20aPoint%0D%0A%09%22%20Return%20a%20DOMElement%20at%20coordinates%20x%2Cy%20in%20the%20viewport%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Eself%20elementFromPoint%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.DOMDocument,"caretPositionFromPoint:y:",0
,function(x,y){var self=this;
return self["@handle"].caretPositionFromPoint(x,y);}
,"accessing",unescape("caretPositionFromPoint%3A%20x%20y%3A%20y%0D%0A%09%22%20Return%20a%20caret%20position%20with%20the%20position%20of%20a%20text%20insertion%20point%20indicator%20%28or%20nil%29.%0D%0A%09It%20always%20has%20an%20associated%20caret%23offsetNode%20and%20caret%23offset.%0D%0A%09%22%0D%0A%0D%0A%09%5Ehandle%20%23caretPositionFromPoint%3A%20x%20y%3A%20y"));

smalltalk.bind(smalltalk.DOMDocument,"caretPositionFromPoint:",0
,function(aPoint){var self=this;
return self.caretPositionFromPoint_y_(aPoint.x(),aPoint.y());}
,"accessing",unescape("caretPositionFromPoint%3A%20aPoint%0D%0A%09%22%20Return%20a%20caret%20position%20with%20the%20position%20of%20a%20text%20insertion%20point%20indicator%20%28or%20nil%29.%0D%0A%09It%20always%20has%20an%20associated%20caret%23offsetNode%20and%20caret%23offset.%0D%0A%09%22%0D%0A%0D%0A%09%5Eself%20caretPositionFromPoint%3A%20aPoint%20x%20y%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.HTMLHeading.$klass,"tagName",0
,function(){var self=this;
return nil;}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Enil"));

smalltalk.bind(smalltalk.HTMLHeading.$klass,"canHandle:tagged:",0
,function(handle,tagName){var self=this;
return ["H1", "H2", "H3", "H4", "H5", "H6"].includes_(tagName);}
,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5E%23%28%20%23H1%20%23H2%20%23H3%20%23H4%20%23H5%20%23H6%20%29%20includes%3A%20tagName"));

smalltalk.bind(smalltalk.HTMLMod.$klass,"tagName",0
,function(){var self=this;
return nil;}
,"HTML",unescape("tagName%0D%0A%09%22%20Return%20the%20tag%20of%20the%20receiver%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%5Enil"));

smalltalk.bind(smalltalk.HTMLMod.$klass,"canHandle:tagged:",0
,function(handle,tagName){var self=this;
return ["DEL", "INS"].includes_(tagName);}
,"private-mapping",unescape("canHandle%3A%20handle%20tagged%3A%20tagName%0D%0A%09%22%20Return%20true%20if%20instances%20of%20the%20receiver%20can%20handle%20elements%20tagged%20with%20tagName.%20%22%0D%0A%0D%0A%09%5E%23%28%20%23DEL%20%23INS%20%29%20includes%3A%20tagName"));

smalltalk.bind(smalltalk.HTMLForm,"elements",0
,function(){var self=this;
return self.array_of_(self["@handle"].elements,smalltalk.HTMLElement);}
,"accessing",unescape("elements%0D%0A%09%22%20Return%20the%20elements%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23elements%20of%3A%20HTMLElement"));

smalltalk.bind(smalltalk.HTMLForm,"elementAt:",0
,function(index){var self=this;
return self.array_of_at_(self["@handle"].elements,smalltalk.HTMLElement,index);}
,"accessing",unescape("elementAt%3A%20index%0D%0A%09%22%20Return%20the%20element%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23elements%20of%3A%20HTMLElement%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLForm,"elementsDo:",0
,function(aBlock){var self=this;
return self.array_of_do_(self["@handle"].elements,smalltalk.HTMLElement,aBlock);}
,"accessing",unescape("elementsDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20elements%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23elements%20of%3A%20HTMLElement%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLForm,"reset",0
,function(){var self=this;
return self["@handle"].reset();}
,"accessing",unescape("reset%0D%0A%09%22%20Reset%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20reset"));

smalltalk.bind(smalltalk.HTMLForm,"submit",0
,function(){var self=this;
return self["@handle"].submit();}
,"accessing",unescape("submit%0D%0A%09%22%20Submit%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20submit"));

smalltalk.bind(smalltalk.HTMLFrame,"extent",0
,function(){var self=this;
return self.width()._at(self.height());}
,"accessing",unescape("extent%0D%0A%09%22%20Returns%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20width%20@%20self%20height"));

smalltalk.bind(smalltalk.HTMLFrame,"extent:",0
,function(extent){var self=this;
if (extent.isString()){return self.extent_(extent.asArrayOfSubstringsSeparatedBy_(unescape("%2C")));};;
if (extent.isArray()){(function($rec){$rec.width_(extent.first());return $rec.height_(extent.last());})(self);} else{(function($rec){$rec.width_(extent.x());return $rec.height_(extent.y());})(self);};;
return self;}
,"accessing",unescape("extent%3A%20extent%0D%0A%09%22%20Set%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09extent%20isString%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20extent%3A%20%28extent%20asArrayOfSubstringsSeparatedBy%3A%20%24%2C%29%0D%0A%09%5D.%0D%0A%09extent%20isArray%20ifTrue%3A%20%5B%0D%0A%09%09self%20width%3A%20extent%20first%3B%20height%3A%20extent%20last%0D%0A%09%5D%20ifFalse%3A%20%5B%0D%0A%09%09self%20width%3A%20extent%20x%3B%20height%3A%20extent%20y%0D%0A%09%5D"));

smalltalk.bind(smalltalk.HTMLFrame,"marginExtent",0
,function(){var self=this;
return self.marginWidth()._at(self.marginHeight());}
,"accessing",unescape("marginExtent%0D%0A%09%22%20Returns%20the%20extent%20of%20margin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20marginWidth%20@%20self%20marginHeight"));

smalltalk.bind(smalltalk.HTMLFrame,"marginExtent:",0
,function(aPoint){var self=this;
(function($rec){$rec.marginWidth_(aPoint.x());return $rec.marginHeight_(aPoint.y());})(self);
return self;}
,"accessing",unescape("marginExtent%3A%20aPoint%0D%0A%09%22%20Set%20the%20extent%20of%20margin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20marginWidth%3A%20aPoint%20x%3B%20marginHeight%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.HTMLFrame,"contentDocument",0
,function(){var self=this;
return smalltalk.HTMLDocument._at(self["@handle"].contentDocument);}
,"accessing",unescape("contentDocument%0D%0A%09%22%20Returns%20the%20document%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EHTMLDocument%20@%20handle%23contentDocument"));

smalltalk.bind(smalltalk.HTMLFrame,"contentWindow",0
,function(){var self=this;
return smalltalk.BrowserWindow._at(self["@handle"].contentWindow);}
,"accessing",unescape("contentWindow%0D%0A%09%22%20Returns%20the%20window%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EBrowserWindow%20@%20handle%23contentWindow"));

smalltalk.bind(smalltalk.HTMLImage,"extent",0
,function(){var self=this;
return self.width()._at(self.height());}
,"accessing",unescape("extent%0D%0A%09%22%20Returns%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20width%20@%20self%20height"));

smalltalk.bind(smalltalk.HTMLImage,"naturalExtent",0
,function(){var self=this;
return self.naturalWidth()._at(self.naturalHeight());}
,"accessing",unescape("naturalExtent%0D%0A%09%22%20Returns%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20naturalWidth%20@%20self%20naturalHeight"));

smalltalk.bind(smalltalk.HTMLImage,"extent:",0
,function(extent){var self=this;
if (extent.isString()){return self.extent_(extent.asArrayOfSubstringsSeparatedBy_(unescape("%2C")));};;
if (extent.isArray()){(function($rec){$rec.width_(extent.first());return $rec.height_(extent.last());})(self);} else{(function($rec){$rec.width_(extent.x());return $rec.height_(extent.y());})(self);};;
return self;}
,"accessing",unescape("extent%3A%20extent%0D%0A%09%22%20Set%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09extent%20isString%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20extent%3A%20%28extent%20asArrayOfSubstringsSeparatedBy%3A%20%24%2C%29%0D%0A%09%5D.%0D%0A%09extent%20isArray%20ifTrue%3A%20%5B%0D%0A%09%09self%20width%3A%20extent%20first%3B%20height%3A%20extent%20last%0D%0A%09%5D%20ifFalse%3A%20%5B%0D%0A%09%09self%20width%3A%20extent%20x%3B%20height%3A%20extent%20y%0D%0A%09%5D"));

smalltalk.bind(smalltalk.HTMLImage,"spaceExtent",0
,function(){var self=this;
return self.hspace()._at(self.vspace());}
,"accessing",unescape("spaceExtent%0D%0A%09%22%20Returns%20the%20space%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20hspace%20@%20self%20vspace"));

smalltalk.bind(smalltalk.HTMLImage,"spaceExtent:",0
,function(aPoint){var self=this;
(function($rec){$rec.hspace_(aPoint.x());return $rec.vspace_(aPoint.y());})(self);
return self;}
,"accessing",unescape("spaceExtent%3A%20aPoint%0D%0A%09%22%20Set%20the%20space%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20hspace%3A%20aPoint%20x%3B%20vspace%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.HTMLInputText,"select",0
,function(){var self=this;
self["@handle"].select();
return self;}
,"actions",unescape("select%0D%0A%09%22%20Select%20the%20text%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20select"));

smalltalk.bind(smalltalk.HTMLObject,"extent",0
,function(){var self=this;
return self.width()._at(self.height());}
,"accessing",unescape("extent%0D%0A%09%22%20Returns%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20width%20@%20self%20height"));

smalltalk.bind(smalltalk.HTMLObject,"extent:",0
,function(extent){var self=this;
if (extent.isString()){return self.extent_(extent.asArrayOfSubstringsSeparatedBy_(unescape("%2C")));};;
if (extent.isArray()){(function($rec){$rec.width_(extent.first());return $rec.height_(extent.last());})(self);} else{(function($rec){$rec.width_(extent.x());return $rec.height_(extent.y());})(self);};;
return self;}
,"accessing",unescape("extent%3A%20extent%0D%0A%09%22%20Set%20the%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09extent%20isString%20ifTrue%3A%20%5B%0D%0A%09%09%5Eself%20extent%3A%20%28extent%20asArrayOfSubstringsSeparatedBy%3A%20%24%2C%29%0D%0A%09%5D.%0D%0A%09extent%20isArray%20ifTrue%3A%20%5B%0D%0A%09%09self%20width%3A%20extent%20first%3B%20height%3A%20extent%20last%0D%0A%09%5D%20ifFalse%3A%20%5B%0D%0A%09%09self%20width%3A%20extent%20x%3B%20height%3A%20extent%20y%0D%0A%09%5D"));

smalltalk.bind(smalltalk.HTMLObject,"spaceExtent",0
,function(){var self=this;
return self.hspace()._at(self.vspace());}
,"accessing",unescape("spaceExtent%0D%0A%09%22%20Returns%20the%20space%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20hspace%20@%20self%20vspace"));

smalltalk.bind(smalltalk.HTMLObject,"spaceExtent:",0
,function(aPoint){var self=this;
(function($rec){$rec.hspace_(aPoint.x());return $rec.vspace_(aPoint.y());})(self);
return self;}
,"accessing",unescape("spaceExtent%3A%20aPoint%0D%0A%09%22%20Set%20the%20space%20extent%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20hspace%3A%20aPoint%20x%3B%20vspace%3A%20aPoint%20y"));

smalltalk.bind(smalltalk.HTMLOption.$klass,"text:value:",0
,function(text,value){var self=this;
return self.$$new().text_value_(text,value);}
,"instantiation",unescape("text%3A%20text%20value%3A%20value%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%20text%3A%20text%20value%3A%20value%20"));

smalltalk.bind(smalltalk.HTMLOption,"text:value:",0
,function(text,value){var self=this;
self.handle();
(function($rec){$rec.text_(text);return $rec.value_(value);})(self);
return self;}
,"accessing",unescape("text%3A%20text%20value%3A%20value%0D%0A%09%22%20Set%20the%20receiver%27s%20text%20and%20value.%20%22%0D%0A%0D%0A%09self%20handle.%20%22ensure%20valid%20handle%22%0D%0A%09self%20text%3A%20text%3B%20value%3A%20value."));

smalltalk.bind(smalltalk.HTMLOption,"initializeHandle",0
,function(){var self=this;
self["@handle"]= new Option(); ;
return self;}
,"initialize",unescape("initializeHandle%0D%0A%09%22%20Private%20-%20Initialize%20the%20native%20handle.%20%22%0D%0A%0D%0A%09handle%20%3A%3D%20%7B%27%20new%20Option%28%29%3B%20%27%7D."));

smalltalk.bind(smalltalk.HTMLSelect,"selectedIndex",0
,function(){var self=this;
return self["@handle"].selectedIndex._plus((1));}
,"accessing",unescape("selectedIndex%0D%0A%09%22%20Return%20the%20%28ONE%20indexed%29%20selectedIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23selectedIndex%20+%201"));

smalltalk.bind(smalltalk.HTMLSelect,"selectedIndex:",0
,function(index){var self=this;
self["@handle"].selectedIndex=index._minus((1));
return self;}
,"accessing",unescape("selectedIndex%3A%20index%0D%0A%09%22%20Set%20the%20%28ONE%20indexed%29%20selectedIndex%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%23selectedIndex%20%3A%3D%20index%20-%201"));

smalltalk.bind(smalltalk.HTMLSelect,"selectedIndexes:",0
,function(aCollectionOfIndexes){var self=this;
aCollectionOfIndexes.do_((function(index){return self.optionAt_(index).setSelected();}));
return self;}
,"accessing",unescape("selectedIndexes%3A%20aCollectionOfIndexes%0D%0A%09%22%20Set%20the%20selected%20options%20of%20the%20receiver%20%22%0D%0A%0D%0A%09aCollectionOfIndexes%20do%3A%20%5B%3Aindex%20%7C%20%28self%20optionAt%3A%20index%29%20setSelected%20%5D"));

smalltalk.bind(smalltalk.HTMLSelect,"options",0
,function(){var self=this;
return self.array_of_(self["@handle"].options,smalltalk.HTMLOption);}
,"accessing",unescape("options%0D%0A%09%22%20Return%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23options%20of%3A%20HTMLOption"));

smalltalk.bind(smalltalk.HTMLSelect,"selectedOptions",0
,function(){var self=this;
return self.array_of_(self["@handle"].selectedOptions,smalltalk.HTMLOption);}
,"accessing",unescape("selectedOptions%0D%0A%09%22%20Return%20the%20selected%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23selectedOptions%20of%3A%20HTMLOption"));

smalltalk.bind(smalltalk.HTMLSelect,"optionsDo:",0
,function(aBlock){var self=this;
return self.array_of_do_(self["@handle"].options,smalltalk.HTMLOption,aBlock);}
,"accessing",unescape("optionsDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23options%20of%3A%20HTMLOption%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLSelect,"optionAt:",0
,function(index){var self=this;
return self.array_of_at_(self["@handle"].options,smalltalk.HTMLOption,index);}
,"accessing",unescape("optionAt%3A%20index%0D%0A%09%22%20Return%20the%20option%20of%20the%20receiver%20at%20index%20position%20%28ONE%20indexed%29.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23options%20of%3A%20HTMLOption%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLSelect,"selectedOption",0
,function(){var self=this;
var offset=nil;
offset=self.selectedIndex()._minus((1));
return ((offset._gt_eq((0))).mustBeBoolean()==true ? (function(){return self.optionAt_(offset);})() : nil);}
,"accessing",unescape("selectedOption%0D%0A%09%22%20Return%20the%20selected%20option%20of%20the%20receiver%20%28or%20nil%29.%20%22%0D%0A%0D%0A%09%7C%20offset%20%7C%0D%0A%09offset%20%3A%3D%20self%20selectedIndex%20-%201.%0D%0A%09%5Eoffset%20%3E%3D%200%20ifTrue%3A%20%5B%20self%20optionAt%3A%20offset%20%5D"));

smalltalk.bind(smalltalk.HTMLSelect,"add:before:",0
,function(anOption,another){var self=this;
self["@handle"].add(anOption.handle(),another);
return self;}
,"accessing",unescape("add%3A%20anOption%20before%3A%20another%0D%0A%09%22%20Add%20an%20option%20to%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20%23add%3A%20anOption%20handle%20before%3A%20another"));

smalltalk.bind(smalltalk.HTMLSelect,"add:",0
,function(anOption){var self=this;
return self.addLast_(anOption);}
,"accessing",unescape("add%3A%20anOption%0D%0A%09%22%20Add%20an%20option%20at%20end%20of%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20addLast%3A%20anOption"));

smalltalk.bind(smalltalk.HTMLSelect,"addItems:",0
,function(textsAndValues){var self=this;
var options=nil;
options=textsAndValues.collect_((function(tuple){return ((tuple.isArray()).mustBeBoolean()==true ? (function(){return smalltalk.HTMLOption.text_value_(tuple.first(),tuple.last());})() : (function(){return smalltalk.HTMLOption.text_value_(tuple,tuple);})());}));
options.do_((function(each){return self.add_(each);}));
return options;}
,"accessing",unescape("addItems%3A%20textsAndValues%0D%0A%09%22%20Add%20options%20to%20the%20receiver%20from%20textsAndValues%20array.%0D%0A%09Return%20the%20added%20options.%0D%0A%09%22%0D%0A%0D%0A%09%7C%20options%20%7C%0D%0A%09options%20%3A%3D%20textsAndValues%20collect%3A%20%5B%3Atuple%7C%0D%0A%09%09tuple%20isArray%0D%0A%09%09ifTrue%3A%20%5B%20HTMLOption%20text%3A%20tuple%20first%20value%3A%20tuple%20last%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20HTMLOption%20text%3A%20tuple%20value%3A%20tuple%20%5D%0D%0A%09%5D.%0D%0A%09options%20do%3A%20%5B%3Aeach%7C%20self%20add%3A%20each%20%5D.%0D%0A%09%5Eoptions"));

smalltalk.bind(smalltalk.HTMLSelect,"items:",0
,function(textsAndValues){var self=this;
(function($rec){$rec.removeAll();return $rec.addItems_(textsAndValues);})(self);
return self;}
,"accessing",unescape("items%3A%20textsAndValues%0D%0A%09%22%20Set%20the%20items%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20removeAll%3B%20addItems%3A%20textsAndValues"));

smalltalk.bind(smalltalk.HTMLSelect,"addItem:",0
,function(item){var self=this;
return self.addItem_value_(item,item);}
,"accessing",unescape("addItem%3A%20item%0D%0A%09%22%20Add%20option%20to%20the%20receiver%20%28at%20end%29.%20%22%0D%0A%0D%0A%09%5Eself%20addItem%3A%20item%20value%3A%20item"));

smalltalk.bind(smalltalk.HTMLSelect,"addItem:value:",0
,function(text,value){var self=this;
return self.add_(smalltalk.HTMLOption.text_value_(text,value));}
,"accessing",unescape("addItem%3A%20text%20value%3A%20value%0D%0A%09%22%20Add%20option%20to%20the%20receiver%20%28at%20end%29.%20%22%0D%0A%0D%0A%09%5Eself%20add%3A%20%28HTMLOption%20text%3A%20text%20value%3A%20value%29"));

smalltalk.bind(smalltalk.HTMLSelect,"addLast:",0
,function(anOption){var self=this;
self["@handle"].add(anOption.handle());
return self;}
,"accessing",unescape("addLast%3A%20anOption%0D%0A%09%22%20Add%20an%20option%20at%20end%20of%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20%23add%3A%20anOption%20handle"));

smalltalk.bind(smalltalk.HTMLSelect,"remove:",0
,function(index){var self=this;
self["@handle"].remove(index);
return self;}
,"accessing",unescape("remove%3A%20index%0D%0A%09%22%20Remove%20option%20at%20index%20%28zero%20indexed%29%20from%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20%23remove%3A%20index"));

smalltalk.bind(smalltalk.HTMLSelect,"removeAll",0
,function(){var self=this;
while((function(){return self.notEmpty();})()){self.remove_((0));};;
return self;}
,"accessing",unescape("removeAll%0D%0A%09%22%20Remove%20all%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Bself%20notEmpty%5D%20whileTrue%3A%20%5B%20self%20remove%3A%200%20%5D"));

smalltalk.bind(smalltalk.HTMLSelect,"isEmpty",0
,function(){var $s8Ret$={name:"stReturn"};try{var self=this;
self.optionsDo_((function(option){return (function(){$s8Ret$.result=(function(){return false})();throw($s8Ret$)})();}));
(function(){$s8Ret$.result=(function(){return true})();throw($s8Ret$)})();} catch($$ex) {if($$ex === $s8Ret$){return $$ex.result} throw($$ex);}}
,"accessing",unescape("isEmpty%0D%0A%09%22%20Returns%20true%20if%20the%20receiver%20is%20empty.%20%22%0D%0A%0D%0A%09self%20optionsDo%3A%20%5B%3Aoption%7C%20%5Efalse%20%5D.%0D%0A%09%5Etrue"));

smalltalk.bind(smalltalk.HTMLSelect,"notEmpty",0
,function(){var self=this;
return self.isEmpty().not();}
,"accessing",unescape("notEmpty%0D%0A%09%22%20Returns%20true%20if%20the%20receiver%20has%20at%20least%20one%20option.%20%22%0D%0A%0D%0A%09%5Eself%20isEmpty%20not"));

smalltalk.bind(smalltalk.HTMLSelect,"removeIndex:",0
,function(index){var self=this;
return self.remove_(index._minus((1)));}
,"accessing",unescape("removeIndex%3A%20index%0D%0A%09%22%20Remove%20option%20at%20index%20%28ONE%20indexed%29%20from%20the%20options%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20remove%3A%20index%20-%201"));

smalltalk.bind(smalltalk.HTMLTable,"cells",0
,function(){var self=this;
return self.array_of_(self["@handle"].cells,smalltalk.HTMLTableCell);}
,"accessing",unescape("cells%0D%0A%09%22%20Return%20the%20cells%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23cells%20of%3A%20HTMLTableCell"));

smalltalk.bind(smalltalk.HTMLTable,"cellsDo:",0
,function(aBlock){var self=this;
return self.array_of_do_(self["@handle"].cells,smalltalk.HTMLTableCell,aBlock);}
,"accessing",unescape("cellsDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20cells%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23cells%20of%3A%20HTMLTableCell%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLTable,"cellAt:",0
,function(index){var self=this;
return self.array_of_at_(self["@handle"].cells,smalltalk.HTMLTableCell,index);}
,"accessing",unescape("cellAt%3A%20index%0D%0A%09%22%20Return%20the%20cell%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23cells%20of%3A%20HTMLTableCell%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLTable,"rows",0
,function(){var self=this;
return self.array_of_(self["@handle"].rows,smalltalk.HTMLTableRow);}
,"accessing",unescape("rows%0D%0A%09%22%20Return%20the%20rows%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23rows%20of%3A%20HTMLTableRow"));

smalltalk.bind(smalltalk.HTMLTable,"rowsDo:",0
,function(aBlock){var self=this;
return self.array_of_do_(self["@handle"].rows,smalltalk.HTMLTableRow,aBlock);}
,"accessing",unescape("rowsDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20rows%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23rows%20of%3A%20HTMLTableRow%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLTable,"rowAt:",0
,function(index){var self=this;
return self.array_of_at_(self["@handle"].rows,smalltalk.HTMLTableRow,index);}
,"accessing",unescape("rowAt%3A%20index%0D%0A%09%22%20Return%20the%20row%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23rows%20of%3A%20HTMLTableRow%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLTable,"tBodies",0
,function(){var self=this;
return self.array_of_(self["@handle"].tBodies,smalltalk.HTMLTbody);}
,"accessing",unescape("tBodies%0D%0A%09%22%20Return%20the%20tBodies%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23tBodies%20of%3A%20HTMLTbody"));

smalltalk.bind(smalltalk.HTMLTable,"tBodiesDo:",0
,function(aBlock){var self=this;
return self.array_of_do_(self["@handle"].tBodies,smalltalk.HTMLTbody,aBlock);}
,"accessing",unescape("tBodiesDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20tBodies%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23tBodies%20of%3A%20HTMLTbody%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLTable,"tBodyAt:",0
,function(index){var self=this;
return self.array_of_at_(self["@handle"].tBodies,smalltalk.HTMLTbody,index);}
,"accessing",unescape("tBodyAt%3A%20index%0D%0A%09%22%20Return%20the%20tBody%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23tBodies%20of%3A%20HTMLTbody%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLTable,"tFoot",0
,function(){var self=this;
return smalltalk.HTMLElement._at(self["@handle"].tFoot);}
,"accessing",unescape("tFoot%0D%0A%09%22%20Return%20the%20tFoot%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EHTMLElement%20@%20handle%23tFoot"));

smalltalk.bind(smalltalk.HTMLTable,"tHead",0
,function(){var self=this;
return smalltalk.HTMLElement._at(self["@handle"].tHead);}
,"accessing",unescape("tHead%0D%0A%09%22%20Return%20the%20tHead%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EHTMLElement%20@%20handle%23tHead"));

smalltalk.bind(smalltalk.HTMLTable,"createCaption",0
,function(){var self=this;
return smalltalk.HTMLElement._at(self["@handle"].createCaption);}
,"accessing",unescape("createCaption%0D%0A%09%22%20Return%20the%20caption%20of%20the%20receiver%20%28create%20a%20new%20element%20if%20needed%29.%20%22%0D%0A%0D%0A%09%5EHTMLElement%20@%20handle%23createCaption"));

smalltalk.bind(smalltalk.HTMLTable,"createTFoot",0
,function(){var self=this;
return smalltalk.HTMLElement._at(self["@handle"].createTFoot);}
,"accessing",unescape("createTFoot%0D%0A%09%22%20Return%20the%20foot%20of%20the%20receiver%20%28create%20a%20new%20element%20if%20needed%29.%20%22%0D%0A%0D%0A%09%5EHTMLElement%20@%20handle%23createTFoot"));

smalltalk.bind(smalltalk.HTMLTable,"createTHead",0
,function(){var self=this;
return smalltalk.HTMLElement._at(self["@handle"].createTHead);}
,"accessing",unescape("createTHead%0D%0A%09%22%20Return%20the%20head%20of%20the%20receiver%20%28create%20a%20new%20element%20if%20needed%29.%20%22%0D%0A%0D%0A%09%5EHTMLElement%20@%20handle%23createTHead"));

smalltalk.bind(smalltalk.HTMLTable,"deleteCaption",0
,function(){var self=this;
self["@handle"].deleteCaption();
return self;}
,"accessing",unescape("deleteCaption%0D%0A%09%22%20Delete%20the%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20deleteCaption"));

smalltalk.bind(smalltalk.HTMLTable,"deleteTFoot",0
,function(){var self=this;
self["@handle"].deleteTFoot();
return self;}
,"accessing",unescape("deleteTFoot%0D%0A%09%22%20Delete%20the%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20deleteTFoot"));

smalltalk.bind(smalltalk.HTMLTable,"deleteTHead",0
,function(){var self=this;
self["@handle"].deleteTHead();
return self;}
,"accessing",unescape("deleteTHead%0D%0A%09%22%20Delete%20the%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20deleteTHead"));

smalltalk.bind(smalltalk.HTMLTable,"insertRow:",0
,function(index){var self=this;
return smalltalk.HTMLTableRow._at(self["@handle"].insertRow(index));}
,"accessing",unescape("insertRow%3A%20index%0D%0A%09%22%20Insert%20a%20row%20in%20the%20receiver%20at%20index%28zero%20indexed%29%20position.%0D%0A%09index%20specifies%20the%20position%20of%20the%20row%20to%20insert%20%28starts%20at%200%29.%0D%0A%09The%20value%20of%20-1%20can%20also%20be%20used%3B%20which%20result%20in%20that%20the%20new%20row%20will%20be%20inserted%20at%20the%20last%20position.%0D%0A%09%22%0D%0A%0D%0A%09%5EHTMLTableRow%20@%20%28handle%20%23insertRow%3A%20index%29"));

smalltalk.bind(smalltalk.HTMLTable,"insertRowAt:",0
,function(index){var self=this;
return smalltalk.HTMLTableRow._at(self["@handle"].insertRow(index._minus((1))));}
,"accessing",unescape("insertRowAt%3A%20index%0D%0A%09%22%20Insert%20a%20row%20in%20the%20receiver%20at%20index%28ONE%20indexed%29%20position.%20%22%0D%0A%0D%0A%09%5EHTMLTableRow%20@%20%28handle%20%23insertRow%3A%20index%20-%201%29"));

smalltalk.bind(smalltalk.HTMLTableRow,"cells",0
,function(){var self=this;
return self.array_of_(self["@handle"].cells,smalltalk.HTMLTableCell);}
,"accessing",unescape("cells%0D%0A%09%22%20Return%20the%20cells%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23cells%20of%3A%20HTMLTableCell"));

smalltalk.bind(smalltalk.HTMLTableRow,"cellsDo:",0
,function(aBlock){var self=this;
return self.array_of_do_(self["@handle"].cells,smalltalk.HTMLTableCell,aBlock);}
,"accessing",unescape("cellsDo%3A%20aBlock%0D%0A%09%22%20Return%20the%20cells%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23cells%20of%3A%20HTMLTableCell%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.HTMLTableRow,"cellAt:",0
,function(index){var self=this;
return self.array_of_at_(self["@handle"].cells,smalltalk.HTMLTableCell,index);}
,"accessing",unescape("cellAt%3A%20index%0D%0A%09%22%20Return%20the%20cell%20at%20index%20in%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20handle%23cells%20of%3A%20HTMLTableCell%20at%3A%20index"));

smalltalk.bind(smalltalk.HTMLTableRow,"deleteCell:",0
,function(index){var self=this;
self["@handle"].deleteCell(index);
return self;}
,"insert/delete",unescape("deleteCell%3A%20index%0D%0A%09%22%20Delete%20the%20element%20of%20the%20receiver%20at%20index%28zero%20indexed%29%20position.%20%22%0D%0A%0D%0A%09handle%20%23deleteCell%3A%20index"));

smalltalk.bind(smalltalk.HTMLTableRow,"deleteCellAt:",0
,function(index){var self=this;
return self.deleteCell_(index._minus((1)));}
,"insert/delete",unescape("deleteCellAt%3A%20index%0D%0A%09%22%20Delete%20the%20element%20of%20the%20receiver%20at%20index%28ONE%20indexed%29%20position.%20%22%0D%0A%0D%0A%09%5Eself%20deleteCell%3A%20index%20-%201"));

smalltalk.bind(smalltalk.HTMLTableRow,"insertCell:",0
,function(index){var self=this;
return smalltalk.HTMLTableCell._at(self["@handle"].insertCell(index));}
,"accessing",unescape("insertCell%3A%20index%0D%0A%09%22%20Insert%20a%20cell%20in%20the%20receiver%20at%20index%28zero%20indexed%29%20position.%0D%0A%09index%20specifies%20the%20position%20of%20the%20row%20to%20insert%20%28starts%20at%200%29.%0D%0A%09The%20value%20of%20-1%20can%20also%20be%20used%3B%20which%20result%20in%20insertion%20at%20the%20last%20position.%0D%0A%09%22%0D%0A%0D%0A%09%5EHTMLTableCell%20@%20%28handle%20%23insertCell%3A%20index%29"));

smalltalk.bind(smalltalk.HTMLTableRow,"insertCellAt:",0
,function(index){var self=this;
return smalltalk.HTMLTableCell._at(self["@handle"].insertCell(index._minus((1))));}
,"accessing",unescape("insertCellAt%3A%20index%0D%0A%09%22%20Insert%20a%20cellin%20the%20receiver%20at%20index%28ONE%20indexed%29%20position.%20%22%0D%0A%0D%0A%09%5EHTMLTableCell%20@%20%28handle%20%23insertCell%3A%20index%20-%201%29"));

smalltalk.bind(smalltalk.HTMLTextarea,"form",0
,function(){var self=this;
return smalltalk.HTMLForm._at(self["@handle"].form);}
,"accessing",unescape("form%0D%0A%09%22%20Return%20the%20form%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EHTMLForm%20@%20handle%23form"));

smalltalk.bind(smalltalk.HTMLTextarea,"select",0
,function(){var self=this;
self["@handle"].select();
return self;}
,"actions",unescape("select%0D%0A%09%22%20Selects%20the%20entire%20contents%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20select"));

smalltalk.bind(smalltalk.HTMLTextarea,"focus",0
,function(){var self=this;
return self["@handle"].focus();}
,"actions",unescape("focus%0D%0A%09%22%20Gives%20focus%20to%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%20focus"));

smalltalk.bind(smalltalk.String,"anchor:",0
,function(aName){var self=this;
return (((nil.isNil_(aName)).or_((function(){return aName.toString().isEmpty();}))).mustBeBoolean()==true ? (function(){return self.anchor();})() : (function(){return self.anchor(aName);})());}
,"DOM-conversion",unescape("anchor%3A%20aName%0D%0A%09%22%20Return%20the%20string%20code%20for%20the%20HTML%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%28aName%20isNil%20or%3A%20%5BaName%20toString%20isEmpty%5D%29%0D%0A%09ifTrue%3A%20%5B%20self%20anchor%20%5D%0D%0A%09ifFalse%3A%20%5B%20self%20%23anchor%3A%20aName%20%5D"));

smalltalk.bind(smalltalk.String,"fontColor:",0
,function(aColor){var self=this;
return self.fontcolor(aColor);}
,"DOM-conversion",unescape("fontColor%3A%20aColor%0D%0A%09%22%20Return%20the%20string%20code%20for%20the%20HTML%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23fontcolor%3A%20aColor"));

smalltalk.bind(smalltalk.String,"fontSize:",0
,function(aSize){var self=this;
return self.fontsize(aSize);}
,"DOM-conversion",unescape("fontSize%3A%20aSize%0D%0A%09%22%20Return%20the%20string%20code%20for%20the%20HTML%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23fontsize%3A%20aSize"));

smalltalk.bind(smalltalk.String,"link:",0
,function(url){var self=this;
return self.link(url);}
,"DOM-conversion",unescape("link%3A%20url%0D%0A%09%22%20Return%20the%20string%20code%20for%20the%20HTML%20element%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20%23link%3A%20url"));

smalltalk.addClass("DOMEventModel",smalltalk.DOM,[],"DOM-Events");

smalltalk.DOMEventModel.$comment=unescape("%0D%0A%09DOM-Events%20framework%20w/%20Touch%20support.%0D%0A%09Document%20Object%20Model%20%28DOM%29%20Level%202%20Events%20Specification.%0D%0A%09http%3A//www.w3.org/TR/2000/REC-DOM-Level-2-Events-20001113/DOM2-Events.txt%0D%0A%09http%3A//www.w3.org/TR/touch-events/%23methods-1%0D%0A%09@2012%20Alejandro%20F.%20Reimondo%0D%0A");

smalltalk.addClass("HTML5EventModel",smalltalk.DOMEventModel,[],"DOM-HTML5");

smalltalk.addClass("DOMEvent",smalltalk.DOMEventModel,[],"DOM-Events");

smalltalk.addClass("DOMEventListener",smalltalk.DOMEventModel,[],"DOM-Events");

smalltalk.addClass("Touch",smalltalk.DOMEventModel,[],"DOM-Events");

smalltalk.addClass("TouchList",smalltalk.DOMEventModel,[],"DOM-Events");

smalltalk.addClass("MessagePort",smalltalk.HTML5EventModel,[],"DOM-HTML5");

smalltalk.addClass("DOMUIEvent",smalltalk.DOMEvent,[],"DOM-Events");

smalltalk.addClass("DOMMutationEvent",smalltalk.DOMEvent,[],"DOM-Events");

smalltalk.addClass("DOMMouseEvent",smalltalk.DOMEvent,[],"DOM-Events");

smalltalk.addClass("TouchEvent",smalltalk.DOMEvent,[],"DOM-Events");

smalltalk.addClass("MessageEvent",smalltalk.DOMEvent,[],"DOM-Events");

smalltalk.bind(smalltalk.DOMEvent,"type",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["type"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23type"));

smalltalk.bind(smalltalk.DOMEvent,"eventPhase",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["eventPhase"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("eventPhase%0D%0A%09%22%20Return%20the%20eventPhase%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23eventPhase"));

smalltalk.bind(smalltalk.DOMEvent,"bubbles",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["bubbles"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("bubbles%0D%0A%09%22%20Return%20the%20bubbles%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23bubbles"));

smalltalk.bind(smalltalk.DOMEvent,"cancelable",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["cancelable"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("cancelable%0D%0A%09%22%20Return%20the%20cancelable%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23cancelable"));

smalltalk.bind(smalltalk.DOMEvent,"timeStamp",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["timeStamp"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("timeStamp%0D%0A%09%22%20Return%20the%20timeStamp%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23timeStamp"));

smalltalk.bind(smalltalk.DOMEvent,"target",0
,function(){var self=this;
return smalltalk.DOMElement._at(((function(){var $1$=(self.handle()["target"]);if(nil.isNil_($1$))return nil;return $1$;})()));}
,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDOMElement%20@%20%28self%20handle%20basicAt%3A%20%23target%29"));

smalltalk.bind(smalltalk.DOMEvent,"target:",0
,function(anObject){var self=this;
(self.handle()["target"]=(anObject.handle()));
return self;}
,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23target%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.DOMEvent,"currentTarget",0
,function(){var self=this;
return smalltalk.DOMElement._at(((function(){var $1$=(self.handle()["currentTarget"]);if(nil.isNil_($1$))return nil;return $1$;})()));}
,"accessing",unescape("currentTarget%0D%0A%09%22%20Return%20the%20currentTarget%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDOMElement%20@%20%28self%20handle%20basicAt%3A%20%23currentTarget%29"));

smalltalk.bind(smalltalk.DOMEvent,"currentTarget:",0
,function(anObject){var self=this;
(self.handle()["currentTarget"]=(anObject.handle()));
return self;}
,"accessing",unescape("currentTarget%3A%20anObject%0D%0A%09%22%20Set%20the%20currentTarget%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23currentTarget%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.DOMEvent,"stopPropagation",0
,function(){var self=this;
return self.handle().stopPropagation();}
,"wrappers",unescape("stopPropagation%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23stopPropagation"));

smalltalk.bind(smalltalk.DOMEvent,"preventDefault",0
,function(){var self=this;
return self.handle().preventDefault();}
,"wrappers",unescape("preventDefault%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23preventDefault"));

smalltalk.bind(smalltalk.DOMEvent,"initEvent:canBubble:cancelable:",0
,function(type,canBubble,cancelable){var self=this;
return self.handle().initEvent(type,canBubble,cancelable);}
,"wrappers",unescape("initEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23initEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20"));

smalltalk.bind(smalltalk.DOMEventListener,"handleEvent:",0
,function(event){var self=this;
return self.handle().handleEvent(event);}
,"wrappers",unescape("handleEvent%3A%20event%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23handleEvent%3A%20event%20"));

smalltalk.bind(smalltalk.DOMUIEvent,"view",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["view"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("view%0D%0A%09%22%20Return%20the%20view%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23view"));

smalltalk.bind(smalltalk.DOMUIEvent,"detail",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["detail"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("detail%0D%0A%09%22%20Return%20the%20detail%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23detail"));

smalltalk.bind(smalltalk.DOMUIEvent,"initUIEvent:canBubble:cancelable:view:detail:",0
,function(type,canBubble,cancelable,view,detail){var self=this;
return self.handle().initUIEvent(type,canBubble,cancelable,view,detail);}
,"wrappers",unescape("initUIEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20view%3A%20view%20detail%3A%20detail%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23initUIEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20view%3A%20view%20detail%3A%20detail%20"));

smalltalk.bind(smalltalk.DOMMouseEvent,"screenX",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["screenX"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("screenX%0D%0A%09%22%20Return%20the%20screenX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23screenX"));

smalltalk.bind(smalltalk.DOMMouseEvent,"screenY",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["screenY"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("screenY%0D%0A%09%22%20Return%20the%20screenY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23screenY"));

smalltalk.bind(smalltalk.DOMMouseEvent,"clientX",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["clientX"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("clientX%0D%0A%09%22%20Return%20the%20clientX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23clientX"));

smalltalk.bind(smalltalk.DOMMouseEvent,"clientY",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["clientY"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("clientY%0D%0A%09%22%20Return%20the%20clientY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23clientY"));

smalltalk.bind(smalltalk.DOMMouseEvent,"button",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["button"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("button%0D%0A%09%22%20Return%20the%20button%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23button"));

smalltalk.bind(smalltalk.DOMMouseEvent,"relatedTarget",0
,function(){var self=this;
return smalltalk.DOMElement._at(((function(){var $1$=(self.handle()["relatedTarget"]);if(nil.isNil_($1$))return nil;return $1$;})()));}
,"accessing",unescape("relatedTarget%0D%0A%09%22%20Return%20the%20relatedTarget%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDOMElement%20@%20%28self%20handle%20basicAt%3A%20%23relatedTarget%29"));

smalltalk.bind(smalltalk.DOMMouseEvent,"relatedTarget:",0
,function(anObject){var self=this;
(self.handle()["relatedTarget"]=(anObject.handle()));
return self;}
,"accessing",unescape("relatedTarget%3A%20anObject%0D%0A%09%22%20Set%20the%20relatedTarget%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23relatedTarget%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.DOMMouseEvent,"initMouseEvent:canBubble:cancelable:view:detail:screenX:screenY:clientX:clientY:ctrlKey:shiftKey:altKey:metaKey:button:relatedTarget:",0
,function(type,canBubble,cancelable,view,detail,screenX,screenY,clientX,clientY,ctrlKey,shiftKey,altKey,metaKey,button,relatedTarget){var self=this;
return self.handle().initMouseEvent(type,canBubble,cancelable,view,detail,screenX,screenY,clientX,clientY,ctrlKey,shiftKey,altKey,metaKey,button,relatedTarget);}
,"wrappers",unescape("initMouseEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20view%3A%20view%20detail%3A%20detail%20screenX%3A%20screenX%20screenY%3A%20screenY%20clientX%3A%20clientX%20clientY%3A%20clientY%20ctrlKey%3A%20ctrlKey%20shiftKey%3A%20shiftKey%20altKey%3A%20altKey%20metaKey%3A%20metaKey%20button%3A%20button%20relatedTarget%3A%20relatedTarget%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23initMouseEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20view%3A%20view%20detail%3A%20detail%20screenX%3A%20screenX%20screenY%3A%20screenY%20clientX%3A%20clientX%20clientY%3A%20clientY%20ctrlKey%3A%20ctrlKey%20shiftKey%3A%20shiftKey%20altKey%3A%20altKey%20metaKey%3A%20metaKey%20button%3A%20button%20relatedTarget%3A%20relatedTarget%20"));

smalltalk.bind(smalltalk.DOMMutationEvent,"prevValue",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["prevValue"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("prevValue%0D%0A%09%22%20Return%20the%20prevValue%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23prevValue"));

smalltalk.bind(smalltalk.DOMMutationEvent,"newValue",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["newValue"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("newValue%0D%0A%09%22%20Return%20the%20newValue%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23newValue"));

smalltalk.bind(smalltalk.DOMMutationEvent,"attrName",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["attrName"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("attrName%0D%0A%09%22%20Return%20the%20attrName%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23attrName"));

smalltalk.bind(smalltalk.DOMMutationEvent,"attrChange",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["attrChange"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("attrChange%0D%0A%09%22%20Return%20the%20attrChange%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23attrChange"));

smalltalk.bind(smalltalk.DOMMutationEvent,"relatedNode",0
,function(){var self=this;
return smalltalk.DOMNode._at(((function(){var $1$=(self.handle()["relatedNode"]);if(nil.isNil_($1$))return nil;return $1$;})()));}
,"accessing",unescape("relatedNode%0D%0A%09%22%20Return%20the%20relatedNode%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDOMNode%20@%20%28self%20handle%20basicAt%3A%20%23relatedNode%29"));

smalltalk.bind(smalltalk.DOMMutationEvent,"relatedNode:",0
,function(anObject){var self=this;
(self.handle()["relatedNode"]=(anObject.handle()));
return self;}
,"accessing",unescape("relatedNode%3A%20anObject%0D%0A%09%22%20Set%20the%20relatedNode%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23relatedNode%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.DOMMutationEvent,"initMutationEvent:canBubble:cancelable:relatedNode:prevValue:newValue:attrName:attrChange:",0
,function(type,canBubble,cancelable,relatedNode,prevValue,newValue,attrName,attrChange){var self=this;
return self.handle().initMutationEvent(type,canBubble,cancelable,relatedNode,prevValue,newValue,attrName,attrChange);}
,"wrappers",unescape("initMutationEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20relatedNode%3A%20relatedNode%20prevValue%3A%20prevValue%20newValue%3A%20newValue%20attrName%3A%20attrName%20attrChange%3A%20attrChange%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23initMutationEvent%3A%20type%20canBubble%3A%20canBubble%20cancelable%3A%20cancelable%20relatedNode%3A%20relatedNode%20prevValue%3A%20prevValue%20newValue%3A%20newValue%20attrName%3A%20attrName%20attrChange%3A%20attrChange%20"));

smalltalk.bind(smalltalk.MessageEvent,"data",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["data"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("data%0D%0A%09%22%20Return%20the%20data%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23data"));

smalltalk.bind(smalltalk.MessageEvent,"origin",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["origin"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("origin%0D%0A%09%22%20Return%20the%20origin%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23origin"));

smalltalk.bind(smalltalk.MessageEvent,"lastEventId",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["lastEventId"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("lastEventId%0D%0A%09%22%20Return%20the%20lastEventId%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23lastEventId"));

smalltalk.bind(smalltalk.MessageEvent,"source",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["source"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("source%0D%0A%09%22%20Return%20the%20source%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23source"));

smalltalk.bind(smalltalk.MessageEvent,"ports",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["ports"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("ports%0D%0A%09%22%20Return%20the%20ports%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23ports"));

smalltalk.bind(smalltalk.DOMEvent.$klass,"capturingPhase",0
,function(){var self=this;
return (1);}
,"constants",unescape("capturingPhase%0D%0A%09%5E1"));

smalltalk.bind(smalltalk.DOMEvent.$klass,"atTarget",0
,function(){var self=this;
return (2);}
,"constants",unescape("atTarget%0D%0A%09%5E2"));

smalltalk.bind(smalltalk.DOMEvent.$klass,"bubblingPhase",0
,function(){var self=this;
return (3);}
,"constants",unescape("bubblingPhase%0D%0A%09%5E3"));

smalltalk.bind(smalltalk.DOMDocument,"createEvent:",0
,function(type){var self=this;
return smalltalk.DOMEvent._at(self.handle().createEvent(type));}
,"DOM-Events-creating",unescape("createEvent%3A%20type%0D%0A%09%5EDOMEvent%20@%20%28self%20handle%20%23createEvent%3A%20type%29"));

smalltalk.bind(smalltalk.DOM,"addEventListener:doing:useCapture:",0
,function(type,aBlock,aBoolean){var self=this;
return self.handle().addEventListener(type,aBlock,aBoolean);}
,"DOM-Events-binding",unescape("addEventListener%3A%20type%20doing%3A%20aBlock%20useCapture%3A%20aBoolean%0D%0A%09%5Eself%20handle%20%23addEventListener%3A%20type%20doing%3A%20aBlock%20useCapture%3A%20aBoolean"));

smalltalk.bind(smalltalk.DOM,"addEventListener:doing:",0
,function(type,aBlock){var self=this;
return self.handle().addEventListener(type,aBlock);}
,"DOM-Events-binding",unescape("addEventListener%3A%20type%20doing%3A%20aBlock%0D%0A%09%5Eself%20handle%20%23addEventListener%3A%20type%20doing%3A%20aBlock"));

smalltalk.bind(smalltalk.DOM,"removeEventListener:doing:useCapture:",0
,function(type,aBlock,aBoolean){var self=this;
return self.handle().removeEventListener(type,aBlock,aBoolean);}
,"DOM-Events-binding",unescape("removeEventListener%3A%20type%20doing%3A%20aBlock%20useCapture%3A%20aBoolean%0D%0A%09%5Eself%20handle%20%23removeEventListener%3A%20type%20doing%3A%20aBlock%20useCapture%3A%20aBoolean"));

smalltalk.bind(smalltalk.DOM,"removeEventListener:doing:",0
,function(type,aBlock){var self=this;
return self.handle().removeEventListener(type,aBlock);}
,"DOM-Events-binding",unescape("removeEventListener%3A%20type%20doing%3A%20aBlock%0D%0A%09%5Eself%20handle%20%23removeEventListener%3A%20type%20doing%3A%20aBlock"));

smalltalk.bind(smalltalk.DOM,"removeEventListener:",0
,function(type){var self=this;
return self.handle().removeEventListener(type);}
,"DOM-Events-binding",unescape("removeEventListener%3A%20type%0D%0A%09%5Eself%20handle%20%23removeEventListener%3A%20type"));

smalltalk.bind(smalltalk.DOM,"dispatchEvent:",0
,function(anEvent){var self=this;
return self.handle().dispatchEvent(anEvent.handle());}
,"DOM-Events-binding",unescape("dispatchEvent%3A%20anEvent%0D%0A%09%5Eself%20handle%20%23dispatchEvent%3A%20anEvent%20handle"));

smalltalk.bind(smalltalk.DOMMutationEvent.$klass,"modification",0
,function(){var self=this;
return (1);}
,"constants",unescape("modification%0D%0A%09%5E1"));

smalltalk.bind(smalltalk.DOMMutationEvent.$klass,"addition",0
,function(){var self=this;
return (2);}
,"constants",unescape("addition%0D%0A%09%5E2"));

smalltalk.bind(smalltalk.DOMMutationEvent.$klass,"removal",0
,function(){var self=this;
return (3);}
,"constants",unescape("removal%0D%0A%09%5E3"));

smalltalk.bind(smalltalk.DOMMouseEvent,"screen",0
,function(){var self=this;
return self.screenX()._at(self.screenY());}
,"accessing",unescape("screen%0D%0A%09%5Eself%20screenX%20@%20self%20screenY"));

smalltalk.bind(smalltalk.DOMMouseEvent,"client",0
,function(){var self=this;
return self.clientX()._at(self.clientY());}
,"accessing",unescape("client%0D%0A%09%5Eself%20clientX%20@%20self%20clientY"));

smalltalk.bind(smalltalk.DOMMouseEvent,"keys",0
,function(){var self=this;
return smalltalk.Array.with_with_with_with_(self.ctrlKey(),self.shiftKey(),self.altKey(),self.metaKey());}
,"accessing",unescape("keys%0D%0A%09%5EArray%09with%3A%20self%20ctrlKey%0D%0A%09%09with%3A%20self%20shiftKey%0D%0A%09%09with%3A%20self%20altKey%0D%0A%09%09with%3A%20self%20metaKey"));

smalltalk.bind(smalltalk.DOMMouseEvent,"ctrlKey",0
,function(){var self=this;
var result=nil;
result=((function(){var $1$=(self.handle()["ctrlKey"]);if(nil.isNil_($1$))return nil;return $1$;})());
return (nil.isNil_(result)===false).and_((function(){return result;}));}
,"accessing",unescape("ctrlKey%0D%0A%09%22%20Return%20the%20ctrlKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23ctrlKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.DOMMouseEvent,"shiftKey",0
,function(){var self=this;
var result=nil;
result=((function(){var $1$=(self.handle()["shiftKey"]);if(nil.isNil_($1$))return nil;return $1$;})());
return (nil.isNil_(result)===false).and_((function(){return result;}));}
,"accessing",unescape("shiftKey%0D%0A%09%22%20Return%20the%20shiftKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23shiftKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.DOMMouseEvent,"altKey",0
,function(){var self=this;
var result=nil;
result=((function(){var $1$=(self.handle()["altKey"]);if(nil.isNil_($1$))return nil;return $1$;})());
return (nil.isNil_(result)===false).and_((function(){return result;}));}
,"accessing",unescape("altKey%0D%0A%09%22%20Return%20the%20altKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23altKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.DOMMouseEvent,"metaKey",0
,function(){var self=this;
var result=nil;
result=((function(){var $1$=(self.handle()["metaKey"]);if(nil.isNil_($1$))return nil;return $1$;})());
return (nil.isNil_(result)===false).and_((function(){return result;}));}
,"accessing",unescape("metaKey%0D%0A%09%22%20Return%20the%20metaKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23metaKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.TouchEvent,"ctrlKey",0
,function(){var self=this;
var result=nil;
result=((function(){var $1$=(self.handle()["ctrlKey"]);if(nil.isNil_($1$))return nil;return $1$;})());
return (nil.isNil_(result)===false).and_((function(){return result;}));}
,"accessing",unescape("ctrlKey%0D%0A%09%22%20Return%20the%20ctrlKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23ctrlKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.TouchEvent,"shiftKey",0
,function(){var self=this;
var result=nil;
result=((function(){var $1$=(self.handle()["shiftKey"]);if(nil.isNil_($1$))return nil;return $1$;})());
return (nil.isNil_(result)===false).and_((function(){return result;}));}
,"accessing",unescape("shiftKey%0D%0A%09%22%20Return%20the%20shiftKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23shiftKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.TouchEvent,"altKey",0
,function(){var self=this;
var result=nil;
result=((function(){var $1$=(self.handle()["altKey"]);if(nil.isNil_($1$))return nil;return $1$;})());
return (nil.isNil_(result)===false).and_((function(){return result;}));}
,"accessing",unescape("altKey%0D%0A%09%22%20Return%20the%20altKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23altKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.TouchEvent,"metaKey",0
,function(){var self=this;
var result=nil;
result=((function(){var $1$=(self.handle()["metaKey"]);if(nil.isNil_($1$))return nil;return $1$;})());
return (nil.isNil_(result)===false).and_((function(){return result;}));}
,"accessing",unescape("metaKey%0D%0A%09%22%20Return%20the%20metaKey%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20handle%20basicAt%3A%20%23metaKey.%0D%0A%09%5Eresult%20notNil%20and%3A%20%5B%20result%20%5D"));

smalltalk.bind(smalltalk.TouchEvent,"touches",0
,function(){var self=this;
return smalltalk.TouchList._at(((function(){var $1$=(self.handle()["touches"]);if(nil.isNil_($1$))return nil;return $1$;})()));}
,"accessing",unescape("touches%0D%0A%09%22%20Return%20the%20touches%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5ETouchList%20@%20%28self%20handle%20basicAt%3A%20%23touches%29"));

smalltalk.bind(smalltalk.TouchEvent,"touches:",0
,function(anObject){var self=this;
(self.handle()["touches"]=(anObject.handle()));
return self;}
,"accessing",unescape("touches%3A%20anObject%0D%0A%09%22%20Set%20the%20touches%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23touches%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.TouchEvent,"targetTouches",0
,function(){var self=this;
return smalltalk.TouchList._at(((function(){var $1$=(self.handle()["targetTouches"]);if(nil.isNil_($1$))return nil;return $1$;})()));}
,"accessing",unescape("targetTouches%0D%0A%09%22%20Return%20the%20targetTouches%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5ETouchList%20@%20%28self%20handle%20basicAt%3A%20%23targetTouches%29"));

smalltalk.bind(smalltalk.TouchEvent,"targetTouches:",0
,function(anObject){var self=this;
(self.handle()["targetTouches"]=(anObject.handle()));
return self;}
,"accessing",unescape("targetTouches%3A%20anObject%0D%0A%09%22%20Set%20the%20targetTouches%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23targetTouches%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.TouchEvent,"changedTouches",0
,function(){var self=this;
return smalltalk.TouchList._at(((function(){var $1$=(self.handle()["changedTouches"]);if(nil.isNil_($1$))return nil;return $1$;})()));}
,"accessing",unescape("changedTouches%0D%0A%09%22%20Return%20the%20changedTouches%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5ETouchList%20@%20%28self%20handle%20basicAt%3A%20%23changedTouches%29"));

smalltalk.bind(smalltalk.TouchEvent,"changedTouches:",0
,function(anObject){var self=this;
(self.handle()["changedTouches"]=(anObject.handle()));
return self;}
,"accessing",unescape("changedTouches%3A%20anObject%0D%0A%09%22%20Set%20the%20changedTouches%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23changedTouches%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.Touch,"identifier",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["identifier"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("identifier%0D%0A%09%22%20Return%20the%20identifier%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23identifier"));

smalltalk.bind(smalltalk.Touch,"screenX",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["screenX"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("screenX%0D%0A%09%22%20Return%20the%20screenX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23screenX"));

smalltalk.bind(smalltalk.Touch,"screenY",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["screenY"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("screenY%0D%0A%09%22%20Return%20the%20screenY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23screenY"));

smalltalk.bind(smalltalk.Touch,"clientX",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["clientX"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("clientX%0D%0A%09%22%20Return%20the%20clientX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23clientX"));

smalltalk.bind(smalltalk.Touch,"clientY",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["clientY"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("clientY%0D%0A%09%22%20Return%20the%20clientY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23clientY"));

smalltalk.bind(smalltalk.Touch,"pageX",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["pageX"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("pageX%0D%0A%09%22%20Return%20the%20pageX%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23pageX"));

smalltalk.bind(smalltalk.Touch,"pageY",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["pageY"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("pageY%0D%0A%09%22%20Return%20the%20pageY%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23pageY"));

smalltalk.bind(smalltalk.Touch,"target",0
,function(){var self=this;
return smalltalk.DOMElement._at(((function(){var $1$=(self.handle()["target"]);if(nil.isNil_($1$))return nil;return $1$;})()));}
,"accessing",unescape("target%0D%0A%09%22%20Return%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EDOMElement%20@%20%28self%20handle%20basicAt%3A%20%23target%29"));

smalltalk.bind(smalltalk.Touch,"target:",0
,function(anObject){var self=this;
(self.handle()["target"]=(anObject.handle()));
return self;}
,"accessing",unescape("target%3A%20anObject%0D%0A%09%22%20Set%20the%20target%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23target%20put%3A%20anObject%20handle"));

smalltalk.bind(smalltalk.TouchList,"length",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["length"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("length%0D%0A%09%22%20Return%20the%20length%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23length"));

smalltalk.bind(smalltalk.TouchList,"item:",0
,function(offset){var self=this;
return smalltalk.Touch._at(self.handle().item(offset));}
,"wrappers",unescape("item%3A%20offset%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5ETouch%20@%20%28self%20handle%20%23item%3A%20offset%20%29"));

smalltalk.bind(smalltalk.TouchList,"identifiedTouch:",0
,function(identifier){var self=this;
return smalltalk.Touch._at(self.handle().identifiedTouch(identifier));}
,"wrappers",unescape("identifiedTouch%3A%20identifier%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5ETouch%20@%20%28self%20handle%20%23identifiedTouch%3A%20identifier%20%29"));

smalltalk.bind(smalltalk.DOMDocument,"createTouch:target:identifier:pageX:pageY:screenX:screenY:",0
,function(view,target,identifier,pageX,pageY,screenX,screenY){var self=this;
return smalltalk.Touch._at(self.handle().createTouch(view,target,identifier,pageX,pageY,screenX,screenY));}
,"DOM-Events-creating",unescape("createTouch%3A%20view%20target%3A%20target%20identifier%3A%20identifier%0D%0A%09pageX%3A%20pageX%20pageY%3A%20pageY%20screenX%3A%20screenX%20screenY%3A%20screenY%0D%0A%09%5ETouch%20@%20%28self%20handle%20%23createTouch%3A%20view%20target%3A%20target%20identifier%3A%20identifier%20pageX%3A%20pageX%20pageY%3A%20pageY%20screenX%3A%20screenX%20screenY%3A%20screenY%29"));

smalltalk.bind(smalltalk.DOMDocument,"createTouchList:",0
,function(touchOrTouchesArray){var self=this;
var arg=nil;
arg=((touchOrTouchesArray.isArray().or_((function(){return self.isObject_(touchOrTouchesArray).not();}))).mustBeBoolean()==true ? (function(){return touchOrTouchesArray;})() : (function(){return touchOrTouchesArray.handle();})());
return smalltalk.TouchList._at(self.handle().createTouchList(arg));}
,"DOM-Events-creating",unescape("createTouchList%3A%20touchOrTouchesArray%0D%0A%09%7C%20arg%20%7C%0D%0A%09arg%20%3A%3D%20%28touchOrTouchesArray%20isArray%20or%3A%20%5B%20%28self%20isObject%3A%20touchOrTouchesArray%29%20not%20%5D%29%0D%0A%09%09ifTrue%3A%20%5B%20touchOrTouchesArray%20%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20touchOrTouchesArray%20handle%20%5D.%0D%0A%09%5ETouchList%20@%20%28self%20handle%20%23createTouchList%3A%20arg%29"));

smalltalk.bind(smalltalk.Touch,"=","_eq"
,function(aTouch){var self=this;
return (nil.is_eqeq_(self.handle(),aTouch.handle()));}
,"comparing",unescape("%3D%20aTouch%0D%0A%09%5Eself%20handle%20%3D%3D%20aTouch%20handle"));

smalltalk.bind(smalltalk.TouchList,"size",0
,function(){var self=this;
return self.length();}
,"accessing",unescape("size%0D%0A%09%5Eself%20length"));

smalltalk.bind(smalltalk.TouchList,"at:",0
,function(index){var self=this;
return self.item_(index._plus((1)));}
,"accessing",unescape("at%3A%20index%0D%0A%09%5Eself%20item%3A%20index%20+%201"));

smalltalk.bind(smalltalk.TouchList,"id:",0
,function(identifier){var self=this;
return self.identifiedTouch_(identifier);}
,"accessing",unescape("id%3A%20identifier%0D%0A%09%5Eself%20identifiedTouch%3A%20identifier"));

smalltalk.bind(smalltalk.TouchList,"first",0
,function(){var self=this;
return self.item_((0));}
,"accessing",unescape("first%0D%0A%09%5Eself%20item%3A%200"));

smalltalk.bind(smalltalk.TouchList,"last",0
,function(){var self=this;
return self.at_(self.size());}
,"accessing",unescape("last%0D%0A%09%5Eself%20at%3A%20self%20size"));

smalltalk.bind(smalltalk.TouchList,"asArray",0
,function(){var self=this;
return (0).to_(self.length()._minus((1))).collect_((function(offset){return self.item_(offset);}));}
,"converting",unescape("asArray%0D%0A%09%5E%280%20to%3A%20self%20length%20-%201%29%20collect%3A%20%5B%3Aoffset%7C%20self%20item%3A%20offset%20%5D"));

smalltalk.bind(smalltalk.TouchList,"isEmpty",0
,function(){var self=this;
return self.length()._eq((0));}
,"query",unescape("isEmpty%0D%0A%09%5Eself%20length%20%3D%200"));

smalltalk.bind(smalltalk.TouchList,"notEmpty",0
,function(){var self=this;
return self.length()._gt((0));}
,"query",unescape("notEmpty%0D%0A%09%5Eself%20length%20%3E%200"));

smalltalk.bind(smalltalk.TouchList,"do:",0
,function(aBlock){var self=this;
return self.asArray().do_(aBlock);}
,"iteration",unescape("do%3A%20aBlock%0D%0A%09%5Eself%20asArray%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.Touch,"page",0
,function(){var self=this;
return self.pageX()._at(self.pageY());}
,"accessing",unescape("page%0D%0A%09%5Eself%20pageX%20@%20self%20pageY"));

smalltalk.bind(smalltalk.Touch,"screen",0
,function(){var self=this;
return self.screenX()._at(self.screenY());}
,"accessing",unescape("screen%0D%0A%09%5Eself%20screenX%20@%20self%20screenY"));

smalltalk.bind(smalltalk.Touch,"client",0
,function(){var self=this;
return self.clientX()._at(self.clientY());}
,"accessing",unescape("client%0D%0A%09%5Eself%20clientX%20@%20self%20clientY"));

smalltalk.addClass("HTML5Structure",smalltalk.HTML5,[],"DOM-HTML5");

smalltalk.HTML5Structure.$comment=unescape("%0D%0A%09HTML5%20Structures%20support.%0D%0A%09http%3A//www.w3.org/TR/html5/webappapis.html%0D%0A%09@2012%20Alejandro%20Reimondo%20-%20aleReimondo@smalltalking.net%0D%0A");

smalltalk.bind(smalltalk.DOM.$klass,"html5Structure",0
,function(){var self=this;
return smalltalk.HTML5Structure;}
,unescape("code%20generation"),unescape("html5Structure%0D%0A%09%22%20Private%20-%20Return%20the%20root%20support%20for%20IDL%20specs.%20%22%0D%0A%0D%0A%09%5EHTML5Structure"));

smalltalk.bind(smalltalk.DOM.$klass,"structurePrologue",0
,function(){var self=this;
return "HTML5_";}
,unescape("code%20generation"),unescape("structurePrologue%0D%0A%09%22%20Private%20-%20Return%20the%20prologue%20for%20structure%20names.%20%22%0D%0A%0D%0A%09%5E%23HTML5_"));

smalltalk.bind(smalltalk.DOM.$klass,"structure:is:",0
,function(structureName,apiSpecs){var self=this;
var support=nil;
var code=nil;
support=self.structurePrologue()._comma(structureName).asSmalltalkName_(true);
self.html5Structure().subclass_instanceVariableNames_category_(support,"",self.category());
support=smalltalk.Smalltalk.at_(support);
return support.buildAPI_(apiSpecs);}
,unescape("code%20generation"),unescape("structure%3A%20structureName%20is%3A%20apiSpecs%0D%0A%09%22%20Create%20support%20for%20html5%20structure%20named%20structureName.%20%22%0D%0A%0D%0A%09%7C%20support%20code%20%7C%0D%0A%09support%20%3A%3D%20%28self%20structurePrologue%20%2C%20structureName%29%20asSmalltalkName%3A%20true.%0D%0A%09self%20html5Structure%20subclass%3A%20support%20instanceVariableNames%3A%20%27%27%20category%3A%20self%20category.%0D%0A%09support%20%3A%3D%20Smalltalk%20at%3A%20support.%0D%0A%09%5Esupport%20buildAPI%3A%20apiSpecs"));

smalltalk.bind(smalltalk.HTML5.$klass,"selectorForHTML5Event:",0
,function(anEvent){var self=this;
return "on"._comma(anEvent.upTo_(":").asLowercase());}
,"events",unescape("selectorForHTML5Event%3A%20anEvent%0D%0A%09%22%20Private%20-%20Return%20the%20on...%20selector%20to%20use%20to%20register%20binding%20to%20anEvent.%20%22%0D%0A%0D%0A%09%5E%23on%20%2C%20%28anEvent%20upTo%3A%20%24%3A%29%20asLowercase"));

smalltalk.bind(smalltalk.HTML5EventModel.$klass,"selectorForHTML5Event:",0
,function(anEvent){var self=this;
return smalltalk.HTML5.selectorForHTML5Event_(anEvent);}
,"events",unescape("selectorForHTML5Event%3A%20anEvent%0D%0A%09%22%20Private%20-%20Return%20the%20on...%20selector%20to%20use%20to%20register%20binding%20to%20anEvent.%20%22%0D%0A%0D%0A%09%5EHTML5%20selectorForHTML5Event%3A%20anEvent"));

smalltalk.bind(smalltalk.MessagePort,"postMessage:transfer:",0
,function(contents,transfer){var self=this;
return self.handle().postMessage(contents,transfer);}
,"wrappers",unescape("postMessage%3A%20contents%20transfer%3A%20transfer%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23postMessage%3A%20contents%20transfer%3A%20transfer%20"));

smalltalk.bind(smalltalk.MessagePort,"postMessage:",0
,function(contents){var self=this;
return self.handle().postMessage(contents);}
,"wrappers",unescape("postMessage%3A%20contents%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23postMessage%3A%20contents%20"));

smalltalk.bind(smalltalk.MessagePort,"start",0
,function(){var self=this;
return self.handle().start();}
,"wrappers",unescape("start%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23start"));

smalltalk.bind(smalltalk.MessagePort,"close",0
,function(){var self=this;
return self.handle().close();}
,"wrappers",unescape("close%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23close"));

smalltalk.bind(smalltalk.MessagePort.$klass,"html5Events",0
,function(){var self=this;
return ["message:"]._comma(smalltalk.superImplementor(smalltalk.MessagePort.$klass,"html5Events").apply(self, []));}
,"events",unescape("html5Events%0D%0A%09%22%20Private%20-%20Return%20the%20html5%20events%20managed%20by%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%23%28%20%23message%3A%20%29%20%2C%20super%20html5Events"));

smalltalk.bind(smalltalk.MessagePort,"onmessage",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["onmessage"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("onmessage%0D%0A%09%22%20Return%20the%20onmessage%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23onmessage"));

smalltalk.bind(smalltalk.MessageEvent,"messagePorts",0
,function(){var self=this;
if ((nil.isNil_(self.ports()))){return [];};;
return self.ports().collect_((function(each){return smalltalk.MessagePort.at_(each);}));}
,"accessing",unescape("messagePorts%0D%0A%09%22%20Return%20the%20collection%20of%20MessagePorts%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20ports%20isNil%20ifTrue%3A%20%5B%20%5E%23%28%29%20%5D.%0D%0A%09%5Eself%20ports%20collect%3A%20%5B%3Aeach%7C%20MessagePort%20at%3A%20each%20%5D"));

smalltalk.bind(smalltalk.DOMDocument,"querySelector:",0
,function(selectors){var self=this;
return self.elementSupport()._at(self["@handle"].querySelectorAll_(selectors));}
,"accessing",unescape("querySelector%3A%20selectors%0D%0A%09%22%20Return%20the%20first%20matching%20node%20within%20the%20subtrees%20of%20the%20receiver%2C%20in%20tree%20order.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20%28handle%20querySelectorAll%3A%20selectors%29"));

smalltalk.bind(smalltalk.DOMDocument,"querySelectorAll:",0
,function(selectors){var self=this;
return self.array_of_(self["@handle"].querySelectorAll_(selectors),self.elementSupport());}
,"accessing",unescape("querySelectorAll%3A%20selectors%0D%0A%09%22%20Return%20all%20of%20the%20matching%20nodes%20within%20the%20subtrees%20of%20the%20receiver%2C%20in%20tree%20order.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20%28handle%20querySelectorAll%3A%20selectors%29%20of%3A%20self%20elementSupport"));

smalltalk.bind(smalltalk.DOMDocument,"querySelectorAll:doing:",0
,function(selectors,aBlock){var self=this;
return self.array_of_do_(self["@handle"].querySelectorAll_(selectors),self.elementSupport(),aBlock);}
,"accessing",unescape("querySelectorAll%3A%20selectors%20doing%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20all%20of%20the%20matching%20nodes%20within%20the%20subtrees%20of%20the%20receiver%2C%20in%20tree%20order.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20%28handle%20querySelectorAll%3A%20selectors%29%20of%3A%20self%20elementSupport%20do%3A%20aBlock"));

smalltalk.bind(smalltalk.DOMElement,"querySelector:",0
,function(selectors){var self=this;
return self.elementSupport()._at(self["@handle"].querySelectorAll_(selectors));}
,"accessing",unescape("querySelector%3A%20selectors%0D%0A%09%22%20Return%20the%20first%20matching%20node%20within%20the%20subtrees%20of%20the%20receiver%2C%20in%20tree%20order.%20%22%0D%0A%0D%0A%09%5Eself%20elementSupport%20@%20%28handle%20querySelectorAll%3A%20selectors%29"));

smalltalk.bind(smalltalk.DOMElement,"querySelectorAll:",0
,function(selectors){var self=this;
return self.array_of_(self["@handle"].querySelectorAll_(selectors),self.elementSupport());}
,"accessing",unescape("querySelectorAll%3A%20selectors%0D%0A%09%22%20Return%20all%20of%20the%20matching%20nodes%20within%20the%20subtrees%20of%20the%20receiver%2C%20in%20tree%20order.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20%28handle%20querySelectorAll%3A%20selectors%29%20of%3A%20self%20elementSupport"));

smalltalk.bind(smalltalk.DOMElement,"querySelectorAll:doing:",0
,function(selectors,aBlock){var self=this;
return self.array_of_do_(self["@handle"].querySelectorAll_(selectors),self.elementSupport(),aBlock);}
,"accessing",unescape("querySelectorAll%3A%20selectors%20doing%3A%20aBlock%0D%0A%09%22%20Evaluate%20aBlock%20with%20all%20of%20the%20matching%20nodes%20within%20the%20subtrees%20of%20the%20receiver%2C%20in%20tree%20order.%20%22%0D%0A%0D%0A%09%5Eself%20array%3A%20%28handle%20querySelectorAll%3A%20selectors%29%20of%3A%20self%20elementSupport%20do%3A%20aBlock"));

smalltalk.addClass("FileAPIObject",smalltalk.NativeObject,[],"DOM-FileAPI");

smalltalk.FileAPIObject.$comment=unescape("%0D%0A%09Provides%20an%20API%20for%20representing%20file%20objects%20in%20web%20applications%2C%20as%20well%20as%20programmatically%20selecting%20them%20and%20accessing%20their%20data.%20%0D%0A%09http%3A//www.w3.org/TR/FileAPI/%0D%0A%09@2013%20Alejandro%20Reimondo%20aleReimondo@smalltalking.net%0D%0A");

smalltalk.addClass("FileList",smalltalk.FileAPIObject,[],"DOM-FileAPI");

smalltalk.addClass("LineEndings",smalltalk.FileAPIObject,[],"DOM-FileAPI");

smalltalk.addClass("Blob",smalltalk.FileAPIObject,[],"DOM-FileAPI");

smalltalk.addClass("FileReaderSync",smalltalk.FileAPIObject,[],"DOM-FileAPI");

smalltalk.addClass("URL",smalltalk.FileAPIObject,[],"DOM-FileAPI");

smalltalk.addClass("DOMFile",smalltalk.Blob,[],"DOM-FileAPI");

smalltalk.addClass("FileReader",smalltalk.DOM,[],"DOM");

smalltalk.bind(smalltalk.BrowserWindow,"asLineEndings",0
,function(){var self=this;
return smalltalk.LineEndings._at(self.handle());}
,"DOM-FileAPI-converting",unescape("asLineEndings%0D%0A%09%22%20Return%20the%20receiver%20adapted%20to%20LineEndings%20interface.%20%20%22%0D%0A%0D%0A%09%5ELineEndings%20@%20self%20handle"));

smalltalk.bind(smalltalk.FileList,"length",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["length"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("length%0D%0A%09%22%20Return%20the%20length%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23length"));

smalltalk.bind(smalltalk.FileList,"item:",0
,function(offset){var self=this;
return smalltalk.DOMFile._at(self.handle().item(offset));}
,"wrappers",unescape("item%3A%20offset%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5EDOMFile%20@%20%28self%20handle%20%23item%3A%20offset%20%29"));

smalltalk.bind(smalltalk.FileList,"size",0
,function(){var self=this;
return self.length();}
,"size",unescape("size%0D%0A%09%22%20Returns%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20length"));

smalltalk.bind(smalltalk.FileList,"asArray",0
,function(){var self=this;
return (0).to_(self.length()._minus((1))).collect_((function(offset){return self.item_(offset);}));}
,"converting",unescape("asArray%0D%0A%09%22%20Returns%20the%20receiver%20converted%20to%20an%20array.%20%22%0D%0A%0D%0A%09%5E%280%20to%3A%20self%20length%20-%201%29%20collect%3A%20%5B%3Aoffset%7C%20self%20item%3A%20offset%20%5D"));

smalltalk.bind(smalltalk.FileList,"isEmpty",0
,function(){var self=this;
return self.length()._eq((0));}
,"query",unescape("isEmpty%0D%0A%09%22%20Returns%20true%20if%20the%20receiver%20is%20empty.%20%22%0D%0A%0D%0A%09%5Eself%20length%20%3D%200"));

smalltalk.bind(smalltalk.LineEndings,"toNativeLineEndings:",0
,function(string){var self=this;
return self.handle().toNativeLineEndings(string);}
,"wrappers",unescape("toNativeLineEndings%3A%20string%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23toNativeLineEndings%3A%20string%20"));

smalltalk.bind(smalltalk.Blob,"size",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["size"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("size%0D%0A%09%22%20Return%20the%20size%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23size"));

smalltalk.bind(smalltalk.Blob,"type",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["type"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("type%0D%0A%09%22%20Return%20the%20type%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23type"));

smalltalk.bind(smalltalk.Blob,"slice:end:contentType:",0
,function(start,end,contentType){var self=this;
return self.handle().slice(start,end,contentType);}
,"wrappers",unescape("slice%3A%20start%20end%3A%20end%20contentType%3A%20contentType%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23slice%3A%20start%20end%3A%20end%20contentType%3A%20contentType%20"));

smalltalk.bind(smalltalk.Blob,"slice:end:",0
,function(start,end){var self=this;
return self.handle().slice(start,end);}
,"wrappers",unescape("slice%3A%20start%20end%3A%20end%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23slice%3A%20start%20end%3A%20end%20"));

smalltalk.bind(smalltalk.Blob,"slice:",0
,function(start){var self=this;
return self.handle().slice(start);}
,"wrappers",unescape("slice%3A%20start%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23slice%3A%20start%20"));

smalltalk.bind(smalltalk.Blob,"slice",0
,function(){var self=this;
return self.handle().slice();}
,"wrappers",unescape("slice%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23slice"));

smalltalk.bind(smalltalk.Blob,"close",0
,function(){var self=this;
return self.handle().close();}
,"wrappers",unescape("close%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23close"));

smalltalk.bind(smalltalk.DOMFile,"name",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["name"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("name%0D%0A%09%22%20Return%20the%20name%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23name"));

smalltalk.bind(smalltalk.DOMFile,"lastModifiedDate",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["lastModifiedDate"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("lastModifiedDate%0D%0A%09%22%20Return%20the%20lastModifiedDate%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23lastModifiedDate"));

smalltalk.bind(smalltalk.FileReader,"onloadstart",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["onloadstart"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("onloadstart%0D%0A%09%22%20Return%20the%20onloadstart%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23onloadstart"));

smalltalk.bind(smalltalk.FileReader,"onloadstart:",0
,function(anObject){var self=this;
(self.handle()["onloadstart"]=(anObject));
return self;}
,"accessing",unescape("onloadstart%3A%20anObject%0D%0A%09%22%20Set%20the%20onloadstart%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23onloadstart%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileReader,"onprogress",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["onprogress"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("onprogress%0D%0A%09%22%20Return%20the%20onprogress%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23onprogress"));

smalltalk.bind(smalltalk.FileReader,"onprogress:",0
,function(anObject){var self=this;
(self.handle()["onprogress"]=(anObject));
return self;}
,"accessing",unescape("onprogress%3A%20anObject%0D%0A%09%22%20Set%20the%20onprogress%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23onprogress%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileReader,"onload",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["onload"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("onload%0D%0A%09%22%20Return%20the%20onload%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23onload"));

smalltalk.bind(smalltalk.FileReader,"onload:",0
,function(anObject){var self=this;
(self.handle()["onload"]=(anObject));
return self;}
,"accessing",unescape("onload%3A%20anObject%0D%0A%09%22%20Set%20the%20onload%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23onload%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileReader,"onabort",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["onabort"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("onabort%0D%0A%09%22%20Return%20the%20onabort%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23onabort"));

smalltalk.bind(smalltalk.FileReader,"onabort:",0
,function(anObject){var self=this;
(self.handle()["onabort"]=(anObject));
return self;}
,"accessing",unescape("onabort%3A%20anObject%0D%0A%09%22%20Set%20the%20onabort%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23onabort%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileReader,"onerror",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["onerror"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("onerror%0D%0A%09%22%20Return%20the%20onerror%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23onerror"));

smalltalk.bind(smalltalk.FileReader,"onerror:",0
,function(anObject){var self=this;
(self.handle()["onerror"]=(anObject));
return self;}
,"accessing",unescape("onerror%3A%20anObject%0D%0A%09%22%20Set%20the%20onerror%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23onerror%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileReader,"onloadend",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["onloadend"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("onloadend%0D%0A%09%22%20Return%20the%20onloadend%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23onloadend"));

smalltalk.bind(smalltalk.FileReader,"onloadend:",0
,function(anObject){var self=this;
(self.handle()["onloadend"]=(anObject));
return self;}
,"accessing",unescape("onloadend%3A%20anObject%0D%0A%09%22%20Set%20the%20onloadend%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09self%20handle%20basicAt%3A%20%23onloadend%20put%3A%20anObject"));

smalltalk.bind(smalltalk.FileReader,"readyState",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["readyState"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("readyState%0D%0A%09%22%20Return%20the%20readyState%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23readyState"));

smalltalk.bind(smalltalk.FileReader,"result",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["result"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("result%0D%0A%09%22%20Return%20the%20result%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23result"));

smalltalk.bind(smalltalk.FileReader,"error",0
,function(){var self=this;
return ((function(){var $1$=(self.handle()["error"]);if(nil.isNil_($1$))return nil;return $1$;})());}
,"accessing",unescape("error%0D%0A%09%22%20Return%20the%20error%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20basicAt%3A%20%23error"));

smalltalk.bind(smalltalk.FileReader,"readAsArrayBuffer:",0
,function(blob){var self=this;
return self.handle().readAsArrayBuffer(blob.handle());}
,"wrappers",unescape("readAsArrayBuffer%3A%20blob%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23readAsArrayBuffer%3A%20blob%20handle%20"));

smalltalk.bind(smalltalk.FileReader,"readAsText:encoding:",0
,function(blob,encoding){var self=this;
return self.handle().readAsText(blob.handle(),encoding);}
,"wrappers",unescape("readAsText%3A%20blob%20encoding%3A%20encoding%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23readAsText%3A%20blob%20handle%20encoding%3A%20encoding%20"));

smalltalk.bind(smalltalk.FileReader,"readAsDataURL:",0
,function(blob){var self=this;
return self.handle().readAsDataURL(blob.handle());}
,"wrappers",unescape("readAsDataURL%3A%20blob%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23readAsDataURL%3A%20blob%20handle%20"));

smalltalk.bind(smalltalk.FileReader,"abort",0
,function(){var self=this;
return self.handle().abort();}
,"wrappers",unescape("abort%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23abort"));

smalltalk.bind(smalltalk.FileReader.$klass,"empty",0
,function(){var self=this;
return (0);}
,"constants",unescape("empty%0D%0A%09%22%20Return%20the%20constant%20value%20EMPTY%20%22%0D%0A%0D%0A%09%5E0"));

smalltalk.bind(smalltalk.FileReader.$klass,"loading",0
,function(){var self=this;
return (1);}
,"constants",unescape("loading%0D%0A%09%22%20Return%20the%20constant%20value%20LOADING%20%22%0D%0A%0D%0A%09%5E1"));

smalltalk.bind(smalltalk.FileReader.$klass,"done",0
,function(){var self=this;
return (2);}
,"constants",unescape("done%0D%0A%09%22%20Return%20the%20constant%20value%20DONE%20%22%0D%0A%0D%0A%09%5E2"));

smalltalk.bind(smalltalk.FileReaderSync,"readAsArrayBuffer:",0
,function(blob){var self=this;
return self.handle().readAsArrayBuffer(blob.handle());}
,"wrappers",unescape("readAsArrayBuffer%3A%20blob%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23readAsArrayBuffer%3A%20blob%20handle%20"));

smalltalk.bind(smalltalk.FileReaderSync,"readAsText:encoding:",0
,function(blob,encoding){var self=this;
return self.handle().readAsText(blob.handle(),encoding);}
,"wrappers",unescape("readAsText%3A%20blob%20encoding%3A%20encoding%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23readAsText%3A%20blob%20handle%20encoding%3A%20encoding%20"));

smalltalk.bind(smalltalk.FileReaderSync,"readAsDataURL:",0
,function(blob){var self=this;
return self.handle().readAsDataURL(blob.handle());}
,"wrappers",unescape("readAsDataURL%3A%20blob%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23readAsDataURL%3A%20blob%20handle%20"));

smalltalk.bind(smalltalk.URL,"createObjectURL:options:",0
,function(blob,options){var self=this;
return self.handle().createObjectURL(blob.handle(),options);}
,"wrappers",unescape("createObjectURL%3A%20blob%20options%3A%20options%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23createObjectURL%3A%20blob%20handle%20options%3A%20options%20"));

smalltalk.bind(smalltalk.URL,"revokeObjectURL:",0
,function(blob){var self=this;
return self.handle().revokeObjectURL(blob.handle());}
,"wrappers",unescape("revokeObjectURL%3A%20blob%20%0D%0A%09%22%20Delegate%20to%20handle.%20%22%0D%0A%0D%0A%09%5Eself%20handle%20%23revokeObjectURL%3A%20blob%20handle%20"));

smalltalk.bind(smalltalk.Blob,"initializeHandle",0
,function(){var self=this;
self["@handle"]= new Blob() ;
return self;}
,"initialize",unescape("initializeHandle%0D%0A%09%22%20Initialize%20the%20handle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20%3A%3D%20%7B%27%20new%20Blob%28%29%20%27%7D."));

smalltalk.bind(smalltalk.Blob.$klass,"new:",0
,function(blobParts){var self=this;
var aHandle=nil;
aHandle= new Blob(blobParts) ;
return self._at(aHandle);}
,"instantiation",unescape("new%3A%20blobParts%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%0D%0A%09See%20http%3A//www.w3.org/TR/FileAPI/%23blob%0D%0A%09%22%0D%0A%0D%0A%09%7C%20aHandle%20%7C%0D%0A%09aHandle%20%3A%3D%20%7B%27%20new%20Blob%28blobParts%29%20%27%7D.%0D%0A%09%5Eself%20@%20aHandle"));

smalltalk.bind(smalltalk.Blob.$klass,"new:options:",0
,function(blobParts,aBlobPropertyBag){var self=this;
var aHandle=nil;
aHandle= new Blob(blobParts,aBlobPropertyBag) ;
return self._at(aHandle);}
,"instantiation",unescape("new%3A%20blobParts%20options%3A%20aBlobPropertyBag%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%0D%0A%09See%20http%3A//www.w3.org/TR/FileAPI/%23blob%0D%0A%09%22%0D%0A%0D%0A%09%7C%20aHandle%20%7C%0D%0A%09aHandle%20%3A%3D%20%7B%27%20new%20Blob%28blobParts%2CaBlobPropertyBag%29%20%27%7D.%0D%0A%09%5Eself%20@%20aHandle"));

smalltalk.bind(smalltalk.Blob.$klass,"utf8:",0
,function(aString){var self=this;
return self.new_options_(aString,"type"._minus_gt(unescape("text/plain%3Bcharset%3DUTF-8")).json());}
,"instantiation",unescape("utf8%3A%20aString%0D%0A%09%22%20Return%20an%20instance%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Eself%20new%3A%20aString%20options%3A%20%28%23type%20-%3E%20%27text/plain%3Bcharset%3DUTF-8%27%29%20json"));

smalltalk.bind(smalltalk.FileReader,"initializeHandle",0
,function(){var self=this;
self["@handle"]= new FileReader() ;
return self;}
,"initialize",unescape("initializeHandle%0D%0A%09%22%20Initialize%20the%20handle%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09handle%20%3A%3D%20%7B%27%20new%20FileReader%28%29%20%27%7D."));

smalltalk.bind(smalltalk.FileReader.$klass,"selectorForHTML5Event:",0
,function(anEvent){var self=this;
return "on"._comma(anEvent.upTo_(":").asLowercase());}
,"events",unescape("selectorForHTML5Event%3A%20anEvent%0D%0A%09%22%20Private%20-%20Return%20the%20on...%20selector%20to%20use%20to%20register%20binding%20to%20anEvent.%20%22%0D%0A%0D%0A%09%5E%23on%20%2C%20%28anEvent%20upTo%3A%20%24%3A%29%20asLowercase"));

smalltalk.bind(smalltalk.FileReader.$klass,"html5Events",0
,function(){var self=this;
return ["progress:", "load", "abort", "error", "loadstart", "loadend"]._comma(smalltalk.superImplementor(smalltalk.FileReader.$klass,"html5Events").apply(self, []));}
,"events",unescape("html5Events%0D%0A%09%22%20Private%20-%20Return%20the%20html5%20events%20managed%20by%20instances%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5E%23%28%0D%0A%09%23progress%3A%20%23load%0D%0A%09%23abort%20%23error%0D%0A%09%23loadstart%20%23loadend%0D%0A%09%29%20%2C%20super%20html5Events"));

smalltalk.bind(smalltalk.FileReader.$klass,"readAsText:encoding:onLoad:",0
,function(aBlob,encoding,aBlock){var self=this;
var reader=nil;
reader=self.$$new();
(function($rec){$rec.onload_((function(event){return aBlock.value_value_(reader.result(),event);}));return $rec.readAsText_encoding_(aBlob,encoding);})(reader);
return reader;}
,"reading",unescape("readAsText%3A%20aBlob%20encoding%3A%20encoding%20onLoad%3A%20aBlock%0D%0A%09%22%20Use%20an%20instance%20of%20the%20receiver%20to%20read%20blob%20contents%20as%20text%2C%20evaluates%20aBlock%20%28with%20the%20reader%20instance%20as%20first%20argument%29%20on%20loading.%20%22%0D%0A%0D%0A%09%7C%20reader%20%7C%0D%0A%09reader%20%3A%3D%20self%20new.%0D%0A%09reader%0D%0A%09%09onload%3A%20%5B%3Aevent%7C%20aBlock%20value%3A%20reader%20result%20value%3A%20event%20%5D%3B%0D%0A%09%09readAsText%3A%20aBlob%20encoding%3A%20encoding.%0D%0A%09%5Ereader"));

smalltalk.addClass("DataTransferItem",smalltalk.NativeObject,[],"DOM-HTML5");

smalltalk.bind(smalltalk.DataTransferItem,"kind",0
,function(){var self=this;
return self["@handle"].kind;}
,"accesing",unescape("kind%0D%0A%09%22%20Returns%20the%20drag%20data%20item%20kind%2C%20one%20of%20%23string%20%2C%20%23file%20%22%0D%0A%09%0D%0A%09%5Ehandle%23kind%20"));

smalltalk.bind(smalltalk.DataTransferItem,"type",0
,function(){var self=this;
return self["@handle"].type;}
,"accesing",unescape("type%0D%0A%09%22%20Returns%20the%20drag%20data%20item%20type%20string%0D%0A%09http%3A//w3c.github.io/html/editing.html%23item-type-string%0D%0A%09%22%0D%0A%09%0D%0A%09%5Ehandle%23type%20"));

smalltalk.bind(smalltalk.DataTransferItem,"getAsString:",0
,function(aBlock){var self=this;
return self.notImplementedYet();}
,"accesing",unescape("getAsString%3A%20aBlock%0D%0A%09%22Invokes%20the%20callback%20with%20the%20string%20data%20as%20the%20argument%2C%20%0D%0A%09if%20the%20drag%20data%20item%20kind%20is%20Plain%20Unicode%20string.%22%0D%0A%09%0D%0A%09%5Eself%20notImplementedYet"));

smalltalk.bind(smalltalk.DataTransferItem,"getAsFile",0
,function(){var self=this;
return smalltalk.DOMFile._at(self["@handle"].getAsFile());}
,"accesing",unescape("getAsFile%0D%0A%09%22Returns%20a%20File%20object%2C%20if%20the%20drag%20data%20item%20kind%20as%20DOMFile.%22%0D%0A%09%0D%0A%09%5EDOMFile%20@%20handle%20%23getAsFile%20%20"));

smalltalk.addClass("DataTransfer",smalltalk.NativeObject,[],"DOM-HTML5");

smalltalk.bind(smalltalk.DataTransfer,"dropEffect",0
,function(){var self=this;
return self["@handle"].dropEffect;}
,"accesing",unescape("dropEffect%0D%0A%09%22Returns%20the%20kind%20of%20operation%20that%20is%20currently%20selected.%0D%0A%09If%20the%20kind%20of%20operation%20isn%uFFFDt%20one%20of%20those%20that%20is%20allowed%20by%20the%20effectAllowed%20attribute%2C%20then%20the%20operation%20will%20fail.%0D%0A%09Can%20be%20set%2C%20to%20change%20the%20selected%20operation.%0D%0A%09The%20possible%20values%20are%20%23none%20%23copy%20%23link%20%23move%0D%0A%09%22%0D%0A%09%0D%0A%09%5Ehandle%23dropEffect"));

smalltalk.bind(smalltalk.DataTransfer,"dropEffect:",0
,function(value){var self=this;
self["@handle"].dropEffect(value);
return self;}
,"accesing",unescape("dropEffect%3A%20value%0D%0A%09%22%20Sets%20dropEffect%20value.%20%22%0D%0A%09%0D%0A%09handle%20%23dropEffect%3A%20value"));

smalltalk.bind(smalltalk.DataTransfer,"effectAllowed",0
,function(){var self=this;
return self["@handle"].effectAllowed;}
,"accesing",unescape("effectAllowed%0D%0A%09%22%20Returns%20the%20kinds%20of%20operations%20that%20are%20to%20be%20allowed.%0D%0A%09Can%20be%20set%20%28during%20the%20dragstart%20event%29%2C%20to%20change%20the%20allowed%20operations.%0D%0A%09The%20possible%20values%20are%20%23none%20%23copy%20%23copyLink%20%23copyMove%20%23link%20%23linkMove%20%23move%20%23all%20%23uninitialized%0D%0A%09%22%0D%0A%0D%0A%09%5Ehandle%23effectAllowed%20"));

smalltalk.bind(smalltalk.DataTransfer,"effectAllowed:",0
,function(value){var self=this;
self["@handle"].effectAllowed(value);
return self;}
,"accesing",unescape("effectAllowed%3A%20value%0D%0A%09%22%20Sets%20effectAllowed%20value.%20%22%0D%0A%0D%0A%09handle%20%23effectAllowed%3A%20value"));

smalltalk.bind(smalltalk.DataTransfer,"items",0
,function(){var self=this;
return smalltalk.DataTransferItemList._at(self["@handle"].items);}
,"accesing",unescape("items%0D%0A%09%22%20Returns%20a%20DataTransferItemList%20object%2C%20with%20the%20drag%20data.%20%22%0D%0A%09%0D%0A%09%5EDataTransferItemList%20@%20handle%23items"));

smalltalk.bind(smalltalk.DataTransfer,"setDragImage:x:y:",0
,function(image,x,y){var self=this;
self["@handle"].setDragImage(image,x,y);
return self;}
,"dragging",unescape("setDragImage%3A%20image%20x%3A%20x%20y%3A%20y%0D%0A%09%22%20Uses%20the%20given%20element%20to%20update%20the%20drag%20feedback%2C%20replacing%20any%20previously%20specified%20feedback.%20%22%0D%0A%09%0D%0A%09handle%20%23setDragImage%3A%20image%20x%3A%20x%20y%3A%20y%20"));

smalltalk.bind(smalltalk.DataTransfer,"types",0
,function(){var self=this;
return self["@handle"].types;}
,"accesing",unescape("types%0D%0A%09%22%20Returns%20the%20types%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5Ehandle%23types"));

smalltalk.bind(smalltalk.DataTransfer,"getData",0
,function(){var self=this;
return self["@handle"].getData();}
,"accesing",unescape("getData%0D%0A%09%22%20Uses%20the%20given%20element%20to%20update%20the%20drag%20feedback%2C%20replacing%20any%20previously%20specified%20feedback.%20%22%0D%0A%0D%0A%09%5Ehandle%20getData"));

smalltalk.bind(smalltalk.DataTransfer,"setData:data:",0
,function(format,value){var self=this;
self["@handle"].setData(format,value);
return self;}
,"accesing",unescape("setData%3A%20format%20data%3A%20value%0D%0A%09%22%20Adds%20the%20specified%20data.%20%22%0D%0A%09%0D%0A%09handle%20%23setData%3A%20format%20data%3A%20value"));

smalltalk.bind(smalltalk.DataTransfer,"clearData:",0
,function(format){var self=this;
self["@handle"].clearData(format);
return self;}
,"accesing",unescape("clearData%3A%20format%20%0D%0A%09%22%20Clear%20the%20data.%20%22%0D%0A%0D%0A%09handle%20%23clearData%3A%20format"));

smalltalk.bind(smalltalk.DataTransfer,"files",0
,function(){var self=this;
return smalltalk.FileList._at(self["@handle"].files);}
,"accesing",unescape("files%0D%0A%09%22%20Returns%20the%20file%20list%20of%20the%20receiver.%20%22%0D%0A%0D%0A%09%5EFileList%20@%20handle%23files%20"));

smalltalk.addClass("DataTransferItemList",smalltalk.NativeObject,[],"DOM-HTML5");

smalltalk.bind(smalltalk.DataTransferItemList,"length",0
,function(){var self=this;
return self["@handle"].length;}
,"testing",unescape("length%0D%0A%09%22%20Returns%20the%20number%20of%20items%20in%20the%20drag%20data%20store.%20%22%0D%0A%0D%0A%09%5Ehandle%23length%20"));

smalltalk.bind(smalltalk.DataTransferItemList,"item:",0
,function(index){var self=this;
var value=nil;
(function(){return value=self["@handle"][index];}).on_do_(smalltalk.Exception,(function(){return self.error_(unescape("Index%28")._comma(index)._comma(unescape("%29%20is%20out%20of%20bounds")));}));
return smalltalk.DataTransferItem._at(value);}
,"accesing",unescape("item%3A%20index%0D%0A%09%22%20Returns%20the%20DataTransferItem%20object%20representing%20the%20indexth%20entry%20in%20the%20drag%20data%20store.%20%22%0D%0A%09%0D%0A%09%7C%20value%20%7C%0D%0A%09%5B%20value%20%3A%3D%20handle%5Bindex%5D%20%5D%0D%0A%09%09on%3A%20Exception%20%0D%0A%09%09do%3A%20%5B%20self%20error%3A%20%27Index%28%27%20%2Cindex%20%2C%27%29%20is%20out%20of%20bounds%27%20%5D.%0D%0A%09%5EDataTransferItem%20@%20value%20"));

smalltalk.bind(smalltalk.DataTransferItemList,"remove:",0
,function(index){var self=this;
(function(){return self["@handle"].remove(index);}).on_do_(smalltalk.Exception,(function(){return self.error_(unescape("Index%28")._comma(index)._comma(unescape("%29%20is%20out%20of%20bounds")));}));
return self;}
,"accesing",unescape("remove%3A%20index%0D%0A%09%22%20Removes%20the%20indexth%20entry%20in%20the%20drag%20data%20store.%20%22%0D%0A%09%09%0D%0A%09%5B%20handle%20%23remove%3A%20index%20%5D%0D%0A%09%09on%3A%20Exception%20%0D%0A%09%09do%3A%20%5B%20self%20error%3A%20%27Index%28%27%20%2Cindex%20%2C%27%29%20is%20out%20of%20bounds%27%20%5D%20"));

smalltalk.bind(smalltalk.DataTransferItemList,"clear",0
,function(){var self=this;
self["@handle"].clear();
return self;}
,"accesing",unescape("clear%0D%0A%09%22%20Clear%20the%20drag%20data%20store.%20%22%0D%0A%09%0D%0A%09handle%20%23clear"));

smalltalk.bind(smalltalk.DataTransferItemList,"add:",0
,function(aFile){var self=this;
self["@handle"].add_(aFile);
return self;}
,"accesing",unescape("add%3A%20aFile%0D%0A%09%22%20Adds%20a%20new%20entry%20for%20the%20given%20data%20to%20the%20drag%20data%20store.%20%0D%0A%09If%20the%20data%20is%20plain%20text%20then%20a%20type%20%28MIME%29string%20has%20to%20be%20provided%20also.%0D%0A%09%22%0D%0A%0D%0A%09handle%20add%3A%20aFile%20"));

smalltalk.bind(smalltalk.DataTransferItemList,"add:type:",0
,function(value,type){var self=this;
self["@handle"].add_type_(value,type);
return self;}
,"accesing",unescape("add%3A%20value%20type%3A%20type%0D%0A%09%22Adds%20a%20new%20entry%20for%20the%20given%20data%20to%20the%20drag%20data%20store.%20%0D%0A%09If%20the%20data%20is%20plain%20text%20then%20a%20type%20%28MIME%29string%20has%20to%20be%20provided%20also.%22%0D%0A%0D%0A%09handle%20add%3A%20value%20type%3A%20type%20"));

smalltalk.addClass("DragEvent",smalltalk.DOMMouseEvent,[],"DOM-Events");

smalltalk.bind(smalltalk.DragEvent,"dataTransfer",0
,function(){var self=this;
return smalltalk.DataTransfer._at(self["@handle"].dataTransfer);}
,"accesing",unescape("dataTransfer%0D%0A%09%22%20Returns%20the%20DataTransfer%20object%20for%20the%20event.%20%22%0D%0A%0D%0A%09%5EDataTransfer%20@%20handle%23dataTransfer"));

smalltalk.bind(smalltalk.DragEvent,"files",0
,function(){var self=this;
var result=nil;
result=self.dataTransfer();
if ((nil.isNil_(result)===false)){result=result.files();};;
return (((nil.isNil_(result))).mustBeBoolean()==true ? (function(){return [];})() : (function(){return result.asArray();})());}
,"accesing",unescape("files%0D%0A%09%22%20Returns%20aCollection%20with%20dragged%20files%20%28or%20an%20empty%20Array%29.%20%22%0D%0A%0D%0A%09%7C%20result%20%7C%0D%0A%09result%20%3A%3D%20self%20dataTransfer.%0D%0A%09result%20notNil%20ifTrue%3A%20%5B%20result%20%3A%3D%20result%20files%20%5D.%0D%0A%09%5Eresult%20isNil%0D%0A%09%09ifTrue%3A%20%5B%20%23%28%29%20%5D%0D%0A%09%09ifFalse%3A%20%5B%20result%20asArray%20%5D"));
