smalltalk:addClass("Object",nil,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("Smalltalk",smalltalk.Object,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("Behavior",smalltalk.Object,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("Class",smalltalk.Behavior,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("Metaclass",smalltalk.Behavior,smalltalk:newArray({"instanceClass"}),"Kernel")
smalltalk:addClass("CompiledMethod",smalltalk.Object,smalltalk:newArray({"classField"}),"Kernel")
smalltalk:addClass("Number",smalltalk.Object,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("BlockClosure",smalltalk.Object,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("Boolean",smalltalk.Object,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("DateTime",smalltalk.Object,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("UndefinedObject",smalltalk.Object,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("Collection",smalltalk.Object,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("SequenceableCollection",smalltalk.Collection,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("String",smalltalk.SequenceableCollection,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("Array",smalltalk.SequenceableCollection,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("ArrayedContents",smalltalk.SequenceableCollection,smalltalk:newArray({"contents"}),"Kernel")
smalltalk:addClass("ComposedAssociations",smalltalk.ArrayedContents,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("ComposedObjects",smalltalk.ArrayedContents,smalltalk:newArray({"species"}),"Kernel")
smalltalk:addClass("Interval",smalltalk.Collection,smalltalk:newArray({"start","end","step","value"}),"Kernel")
smalltalk:addClass("Set",smalltalk.Collection,smalltalk:newArray({"contents"}),"Kernel")
smalltalk:addClass("HashedSet",smalltalk.Set,smalltalk:newArray({"hash"}),"Kernel")
smalltalk:addClass("KeyedCollection",smalltalk.Collection,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("Dictionary",smalltalk.KeyedCollection,smalltalk:newArray({"keys","values"}),"Kernel")
smalltalk:addClass("PoolDictionary",smalltalk.KeyedCollection,smalltalk:newArray({"hash","size"}),"Kernel")
smalltalk:addClass("RegularExpression",smalltalk.Object,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("Exception",smalltalk.Object,smalltalk:newArray({"messageText"}),"Kernel")
smalltalk:addClass("Error",smalltalk.Exception,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("MessageNotUnderstood",smalltalk.Error,smalltalk:newArray({"message","receiver"}),"Kernel")
smalltalk:addClass("Association",smalltalk.Object,smalltalk:newArray({"key","value"}),"Kernel")
smalltalk:addClass("ClassBuilder",smalltalk.Object,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("Stream",smalltalk.Object,smalltalk:newArray({"collection","position","readLimit"}),"Kernel")
smalltalk:addClass("StringStream",smalltalk.Stream,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("StringWriteStream",smalltalk.Stream,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("Random",smalltalk.Object,smalltalk:newArray({}),"Kernel")
smalltalk:addClass("Point",smalltalk.Object,smalltalk:newArray({"x","y"}),"Kernel")
smalltalk:addClass("Rectangle",smalltalk.Object,smalltalk:newArray({"leftTop","rightBottom"}),"Kernel")
smalltalk:addClass("EvaluableAction",smalltalk.Object,smalltalk:newArray({}),"Kernel")
smalltalk.EvaluableAction["$comment"]="\r\n\tAction model, evaluable and composable actions are implemented to support evaluations.\r\n"
smalltalk:addClass("Message",smalltalk.EvaluableAction,smalltalk:newArray({"selector","arguments","receiver"}),"Kernel")
smalltalk:addClass("LinkMessage",smalltalk.Message,smalltalk:newArray({"resultAction"}),"Kernel")
smalltalk.LinkMessage["$comment"]="\r\n\tImplement evaluation cascading argument evaluations."
smalltalk:addClass("ActionSequence",smalltalk.Object,smalltalk:newArray({"contents"}),"Kernel")
smalltalk:addClass("EventManager",smalltalk.Object,smalltalk:newArray({"handlers"}),"Kernel")
smalltalk.EventManager["$comment"]="\r\n\tEvent system, properties and change/update/release mechanism.\r\n\tWe hook $properties and $handlers internal properties to manage properties and events at Object level.\r\n\tEventManager instances implement events handler as pure instance variable.\r\n"
smalltalk.EventManager["$klass"]["$iVarNames"]=smalltalk:newArray({"eventsTriggered"})
smalltalk:addClass("S8Encoder",smalltalk.EventManager,smalltalk:newArray({"compiler"}),"Compiler-Encoding")
smalltalk:addClass("OptimizingEncoder",smalltalk.S8Encoder,smalltalk:newArray({"optimizationMap","knownOptimizations","inlines"}),"Compiler-Encoding")
smalltalk.OptimizingEncoder["$klass"]["$iVarNames"]=smalltalk:newArray({"inlines"})
smalltalk:addClass("NativeEncoder",smalltalk.OptimizingEncoder,smalltalk:newArray({"stream","indentation","startOffset","nestedBlocks","earlyReturn","functionName"}),"Compiler-Encoding")
smalltalk:addClass("JSEncoder",smalltalk.NativeEncoder,smalltalk:newArray({}),"JS")
smalltalk:addClass("LuaEncoder",smalltalk.NativeEncoder,smalltalk:newArray({}),"Lua")
smalltalk:addClass("Compiler",smalltalk.EventManager,smalltalk:newArray({"currentClass","selector","encoder","unknownVariables","tempVariables","transformers","useTemplates"}),"Compiler")
smalltalk:addClass("SourceCodeParser",smalltalk.EventManager,smalltalk:newArray({}),"Compiler-Parsing")
smalltalk:addClass("SmalltalkParser",smalltalk.SourceCodeParser,smalltalk:newArray({}),"Compiler-Parsing")
smalltalk:addClass("Exporter",smalltalk.EventManager,smalltalk:newArray({"encoder"}),"Tools-fileOut")
smalltalk:addClass("MethodReferences",smalltalk.EventManager,smalltalk:newArray({"rootClasses","results"}),"Tools-references")
smalltalk:addClass("SystemManager",smalltalk.EventManager,smalltalk:newArray({}),"Snapshot")
smalltalk.SystemManager["$classVariableNames"]="Current"
smalltalk:addClass("CompilerNode",smalltalk.Object,smalltalk:newArray({"nodes","start","end","annotations","client"}),"Compiler-Nodes")
smalltalk:addClass("MethodNode",smalltalk.CompilerNode,smalltalk:newArray({"selector","arguments","source"}),"Compiler-Nodes")
smalltalk:addClass("SendNode",smalltalk.CompilerNode,smalltalk:newArray({"selector","arguments","receiver","action"}),"Compiler-Nodes")
smalltalk:addClass("ScopedNode",smalltalk.CompilerNode,smalltalk:newArray({}),"Compiler-Nodes")
smalltalk:addClass("CascadeNode",smalltalk.ScopedNode,smalltalk:newArray({"receiver"}),"Compiler-Nodes")
smalltalk:addClass("BlockNode",smalltalk.ScopedNode,smalltalk:newArray({"parameters"}),"Compiler-Nodes")
smalltalk:addClass("SequenceNode",smalltalk.ScopedNode,smalltalk:newArray({"temps"}),"Compiler-Nodes")
smalltalk:addClass("BlockSequenceNode",smalltalk.SequenceNode,smalltalk:newArray({}),"Compiler-Nodes")
smalltalk:addClass("ExtendedSequenceNode",smalltalk.SequenceNode,smalltalk:newArray({"directives"}),"Compiler-Nodes")
smalltalk:addClass("AssignmentNode",smalltalk.CompilerNode,smalltalk:newArray({"left","right"}),"Compiler-Nodes")
smalltalk:addClass("ReturnNode",smalltalk.CompilerNode,smalltalk:newArray({"exitBlock"}),"Compiler-Nodes")
smalltalk:addClass("ValueNode",smalltalk.CompilerNode,smalltalk:newArray({"value","binding"}),"Compiler-Nodes")
smalltalk:addClass("VariableNode",smalltalk.ValueNode,smalltalk:newArray({"indices"}),"Compiler-Nodes")
smalltalk:addClass("GlobalReferenceNode",smalltalk.VariableNode,smalltalk:newArray({}),"Compiler-Nodes")
smalltalk:addClass("NoReceiverNode",smalltalk.VariableNode,smalltalk:newArray({}),"Compiler-Nodes")
smalltalk:addClass("AlienNode",smalltalk.VariableNode,smalltalk:newArray({}),"Compiler-Nodes")
smalltalk:addClass("InlineNode",smalltalk.CompilerNode,smalltalk:newArray({"sources"}),"Compiler-Nodes")
smalltalk:addClass("DirectiveNode",smalltalk.CompilerNode,smalltalk:newArray({}),"Compiler-Nodes")
smalltalk:addClass("JSDirectiveNode",smalltalk.DirectiveNode,smalltalk:newArray({"code","protected"}),"Compiler-Nodes")
smalltalk:addClass("InlineOptimizationNode",smalltalk.DirectiveNode,smalltalk:newArray({"args","remove"}),"Compiler-Nodes")
smalltalk:addClass("PPFailure",smalltalk.Object,smalltalk:newArray({"position","reason"}),"Compiler-Parsing")
smalltalk:addClass("PPParser",smalltalk.Object,smalltalk:newArray({"memo"}),"Compiler-Parsing")
smalltalk:addClass("PPEOFParser",smalltalk.PPParser,smalltalk:newArray({}),"Compiler-Parsing")
smalltalk:addClass("PPAnyParser",smalltalk.PPParser,smalltalk:newArray({}),"Compiler-Parsing")
smalltalk:addClass("PPEpsilonParser",smalltalk.PPParser,smalltalk:newArray({}),"Compiler-Parsing")
smalltalk:addClass("PPStringParser",smalltalk.PPParser,smalltalk:newArray({"string"}),"Compiler-Parsing")
smalltalk:addClass("PPStStringParser",smalltalk.PPParser,smalltalk:newArray({}),"Compiler-Parsing")
smalltalk:addClass("PPCharacterParser",smalltalk.PPParser,smalltalk:newArray({"regexp","theString"}),"Compiler-Parsing")
smalltalk.PPCharacterParser["$classVariableNames"]="RegExpCache"
smalltalk:addClass("PPListParser",smalltalk.PPParser,smalltalk:newArray({"parsers"}),"Compiler-Parsing")
smalltalk:addClass("PPSequenceParser",smalltalk.PPListParser,smalltalk:newArray({}),"Compiler-Parsing")
smalltalk:addClass("PPChoiceParser",smalltalk.PPListParser,smalltalk:newArray({}),"Compiler-Parsing")
smalltalk:addClass("PPDelegateParser",smalltalk.PPParser,smalltalk:newArray({"parser"}),"Compiler-Parsing")
smalltalk:addClass("PPAndParser",smalltalk.PPDelegateParser,smalltalk:newArray({}),"Compiler-Parsing")
smalltalk:addClass("PPNotParser",smalltalk.PPAndParser,smalltalk:newArray({}),"Compiler-Parsing")
smalltalk:addClass("PPActionParser",smalltalk.PPDelegateParser,smalltalk:newArray({"block"}),"Compiler-Parsing")
smalltalk:addClass("PPFlattenParser",smalltalk.PPDelegateParser,smalltalk:newArray({}),"Compiler-Parsing")
smalltalk:addClass("PPSourceParser",smalltalk.PPDelegateParser,smalltalk:newArray({}),"Compiler-Parsing")
smalltalk:addClass("PPRepeatingParser",smalltalk.PPDelegateParser,smalltalk:newArray({"min"}),"Compiler-Parsing")
smalltalk:addClass("PPInlineParser",smalltalk.PPParser,smalltalk:newArray({"terminator"}),"Compiler-Parsing")
smalltalk:addClass("FileInReader",smalltalk.Object,smalltalk:newArray({}),"Tools-fileIn")
smalltalk.FileInReader["$comment"]="\r\n\tPerform sequential reading from aStream in chunk format.\r\n\tInstances implement #scanFrom: message, advancing aStream upto next reader instantiation chunk."
smalltalk:addClass("ChunkReader",smalltalk.FileInReader,smalltalk:newArray({"actionBlock","terminationBlock"}),"Tools-fileIn")
smalltalk.ChunkReader["$comment"]="\r\n\tPluggable FileInReader.\r\n\tactionBlock is evaluated with input stream as argument.\r\n\tRead chunks until empty chunk, terminationBlock is nil or evaluates to true."
smalltalk:addClass("ClassCategoryReader",smalltalk.FileInReader,smalltalk:newArray({"class","category","stamp"}),"Tools-fileIn")
smalltalk:addClass("ClassCommentReader",smalltalk.FileInReader,smalltalk:newArray({"class"}),"Tools-fileIn")
smalltalk:addClass("SkipFileInReader",smalltalk.FileInReader,smalltalk:newArray({"limit"}),"Tools-fileIn")
smalltalk:addClass("AssociationsReader",smalltalk.FileInReader,smalltalk:newArray({}),"Tools-fileIn")
smalltalk:addClass("PoolDictionaryReader",smalltalk.AssociationsReader,smalltalk:newArray({"scope"}),"Tools-fileIn")
smalltalk:addClass("NativeReader",smalltalk.AssociationsReader,smalltalk:newArray({"object"}),"Tools-fileIn")
smalltalk:addClass("APIBuilder",smalltalk.Object,smalltalk:newArray({"parents","token","bound"}),"Builders")
smalltalk.APIBuilder["$klass"]["$iVarNames"]=smalltalk:newArray({"default","saveBuilders"})
smalltalk:addClass("Snapshot",smalltalk.Object,smalltalk:newArray({}),"Snapshot")
smalltalk.Snapshot["$comment"]="\r\n\tDump a binary representation of this S8 system onto an image (String).\r\n\tThe default implementation export full/runnable images containing boot sections.\r\n\tThe subclasses can refine behavior to select/customize exports and format.\r\n\t@2011-today Alejandro Reimondo aleReimondo@smalltalking.net"
smalltalk:addClass("Transcript",smalltalk.Object,smalltalk:newArray({"streams"}),"Transcript")
smalltalk.Transcript["$classVariableNames"]="Current"
smalltalk.Transcript["$comment"]="\r\n\tImplement Transcript streamming.\r\n\tThis implementation emmit output delegating onto stream instances.\r\n\tThe streams must understand #cr and #nextPutAll:\r\n"
smalltalk:addClass("NativeObject",smalltalk.Object,smalltalk:newArray({"handle"}),"Natives")
smalltalk.NativeObject["$comment"]="\r\n\tWrapper to native object.\r\n\t@2011 Alejandro F. Reimondo\r\n\taleReimondo@smalltalking.net\r\n"
smalltalk:addClass("NativeHandle",smalltalk.NativeObject,smalltalk:newArray({}),"Natives")
smalltalk.NativeHandle["$classVariableNames"]="Support"
smalltalk.NativeHandle["$comment"]="\r\n\tWrapper for native objects.\r\n\t@2018 Alejandro F. Reimondo\r\n\taleReimondo@smalltalking.net\r\n"
smalltalk:addClass("JS",smalltalk.NativeHandle,smalltalk:newArray({}),"JS")
smalltalk.JS["$comment"]="\r\n\tImplementation of wrappers to native Javascript objects.\r\n\t@2011 Alejandro F. Reimondo\r\n\taleReimondo@smalltalking.net"
smalltalk:addClass("Lua",smalltalk.NativeHandle,smalltalk:newArray({}),"Lua")
smalltalk.Lua["$comment"]="\r\n\tImplementation of wrappers to native Lua objects.\r\n\t@2011 Alejandro F. Reimondo\r\n\taleReimondo@smalltalking.net"
smalltalk:addClass("NativeLibraryObject",smalltalk.NativeObject,smalltalk:newArray({}),"JS")
smalltalk.NativeLibraryObject["$classVariableNames"]="BindingListeners"
smalltalk.NativeLibraryObject["$comment"]="\r\n\tAbstract wrapper to javascript external library.\r\n\t@2012 Alejandro Reimondo - aleReimondo@smalltalking.net\r\n"

smalltalk:bind(smalltalk.Object["$klass"],"eventsTriggered",0
,(
function(self)
return ((self):constructEventsTriggered());
end
)
,"events","eventsTriggered\r\n\t\" Return all the events managed by instances of the receiver. \"\r\n\r\n\t^self constructEventsTriggered","(\r\nfunction(self)\r\nreturn ((self):constructEventsTriggered());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object["$klass"],"constructEventsTriggered",0
,(
function(self)
return (smalltalk:newArray({"changed"}));
end
)
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver.\r\n\tThe default implementation return support for MVC change/update mechanism.\r\n\tThis method can be refined by the subclasses to extend event support.\r\n\t\"\r\n\r\n\t^#( #changed )","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"changed\"}));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object["$klass"],"canTriggerEvent:",0
,(
function(self,selector)
return (((self):eventsTriggered()):includes_(selector));
end
)
,"events","canTriggerEvent: selector\r\n\t\" Return true if instances of the receiver can trigger event.\"\r\n\r\n\t^self eventsTriggered includes: selector ","(\r\nfunction(self,selector)\r\nreturn (((self):eventsTriggered()):includes_(selector));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"print:",0
,(
function(self,aString)
local aBlock=nil
(function()
	local _s8_value=((smalltalk.Object)["printBlock"])
	aBlock=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((aBlock)))==true then 
print(aString); else (aBlock):evaluateWith_(aString); end;
return (self);
end
)
,"s8-initialize-printing","print: aString\r\n\t\" Output a new line with aString onto output device. \"\r\n\r\n\t| aBlock |\r\n\taBlock := Object basicAt: #printBlock.\r\n\taBlock isNil ifTrue: [\r\n\t\t{'self'}. # #print: aString\r\n\t] ifFalse: [\r\n\t\taBlock evaluateWith: aString\r\n\t]","(\r\nfunction(self,aString)\r\nlocal aBlock=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Object)[\"printBlock\"])\r\n\taBlock=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((aBlock)))==true then \r\nprint(aString); else (aBlock):evaluateWith_(aString); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"fileIn:",0
,(
function(self,fileName)
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_(("fileIn(\""),fileName)),"\")"));

return (fileIn(fileName));
end
)
,"s8-initialize-fileIn","fileIn: fileName\r\n\t\" FileIn smalltalk source at fileName. \"\r\n\r\n\tself note: 'fileIn(\"', fileName, '\")'.\r\n\t{'self'}. ^# #fileIn: fileName","(\r\nfunction(self,fileName)\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((\"fileIn(\\\"\"),fileName)),\"\\\")\"));\r\n\r\nreturn (fileIn(fileName));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"fileInJS:",0
,(
function(self,fileName)
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_(("fileInJS(\""),fileName)),"\")"));

return (fileInJS(fileName));
end
)
,"s8-initialize-fileIn","fileInJS: fileName\r\n\t\" Load native code from file at fileName. \"\r\n\r\n\tself note: 'fileInJS(\"', fileName, '\")'.\r\n\t{'self'}. ^# #fileInJS: fileName","(\r\nfunction(self,fileName)\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((\"fileInJS(\\\"\"),fileName)),\"\\\")\"));\r\n\r\nreturn (fileInJS(fileName));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"smalltalk",0
,(
function(self)
return (smalltalk:basic_at_ifAbsent_((self),"$smalltalk",(function()
return ((smalltalk.Smalltalk):current())
end)));
end
)
,"system","smalltalk\r\n\t\" Private - Return the hosting context of the receiver.\r\n\tThe smalltalk host is used for evaluations in the receiver. \"\r\n\r\n\t^self basicAt: '$smalltalk' ifAbsent: [ Smalltalk current ]","(\r\nfunction(self)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),\"$smalltalk\",(function()\r\nreturn ((smalltalk.Smalltalk):current())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"nativeLanguage",0
,(
function(self)
return (smalltalk:basic_at_ifAbsent_(((self):smalltalk()),"$nativeLanguage",(function()
return ("js")
end)));
end
)
,"environment","nativeLanguage\r\n\t\" Private - Return the native language of the host. \"\r\n\r\n\t^self smalltalk\r\n\t\tbasicAt: '$nativeLanguage'\r\n\t\tifAbsent: [ #js ]","(\r\nfunction(self)\r\nreturn (smalltalk:basic_at_ifAbsent_(((self):smalltalk()),\"$nativeLanguage\",(function()\r\nreturn (\"js\")\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"halt",0
,(
function(self)
debug.debug();
return (self);
end
)
,"debug","halt\r\n\t\" Private - Halt execution entering debugger. \"\r\n\r\n\t{'' doc'Enter lowlevel debugger (or do nothing)'}","(\r\nfunction(self)\r\ndebug.debug();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"note:",0
,(
function(self,aString)
(self):print_((smalltalk:asString_((aString))):asComment());
return (self);
end
)
,"development","note: aString\r\n\t\" Print a note (aString) to the user. \"\r\n\r\n\tself print: aString asString asComment","(\r\nfunction(self,aString)\r\n(self):print_((smalltalk:asString_((aString))):asComment());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"notImplementedYet",0
,(
function(self)
(self):error_(("Not implemented. Yet"):halt());
return (self);
end
)
,"development","notImplementedYet\r\n\t\" Private - Halt execution and/or generate an error reporting implementation incomplete. \"\r\n\r\n\tself error: 'Not implemented. Yet' halt","(\r\nfunction(self)\r\n(self):error_((\"Not implemented. Yet\"):halt());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"notImplementedYet:",0
,(
function(self,aSelector)
(self):error_((smalltalk:object_comma_(((aSelector):asLiteral())," Not implemented. Yet")):halt());
return (self);
end
)
,"development","notImplementedYet: aSelector\r\n\t\" Private - Halt execution and/or generate an error reporting implementation incomplete. \"\r\n\r\n\tself error: (aSelector asLiteral ,' Not implemented. Yet') halt","(\r\nfunction(self,aSelector)\r\n(self):error_((smalltalk:object_comma_(((aSelector):asLiteral()),\" Not implemented. Yet\")):halt());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"=","_eq"
,(
function(self,anObject)
return (((self)==anObject));
end
)
,"comparing","= anObject\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\t^self == anObject","(\r\nfunction(self,anObject)\r\nreturn (((self)==anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"~=","_no_eq"
,(
function(self,anObject)
return (((smalltalk:isObject_equalTo_((self),anObject))==false));
end
)
,"comparing","~= anObject\r\n\t\" Return true if the receiver is not equal to anObject. \"\r\n\r\n\t^(self = anObject) == false","(\r\nfunction(self,anObject)\r\nreturn (((smalltalk:isObject_equalTo_((self),anObject))==false));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"initialize",0
,(
function(self)
return (self);
end
)
,"initialize","initialize\r\n\t\" Private - Initialize the receiver.\r\n\tThe default implementation do nothing.\r\n\tThis method can be refined by subclasses to support creation time initialization of collaborators.\r\n\t\"","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"yourself",0
,(
function(self)
return (self);
end
)
,"identity","yourself\r\n\t\" Return the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"species",0
,(
function(self)
return ((self)["$klass"]);
end
)
,"species","species\r\n\t\" Return the species to instantiate objects like the receiver. \"\r\n\r\n\t^self class ","(\r\nfunction(self)\r\nreturn ((self)[\"$klass\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"class",0
,(
function(self)
return (smalltalk:basic_at_ifAbsent_((self),"$klass",(function()
return ((self):klass())
end)));
end
)
,"accessing","class\r\n\t\" Return the class of the receiver. \"\r\n\r\n\t^self basicAt: '$klass' ifAbsent: [ self klass ]","(\r\nfunction(self)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),\"$klass\",(function()\r\nreturn ((self):klass())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"size",0
,(
function(self)
return (0);
end
)
,"accessing","size\r\n\t\" Return the size of the receiver.\r\n\tThe default implementation return zero.\r\n\tThis method can be refined by subclasses to support indexed access.\r\n\t\"\r\n\r\n\t^0","(\r\nfunction(self)\r\nreturn (0);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"copy",0
,(
function(self)
return ((self):shallowCopy());
end
)
,"copying","copy\r\n\t\" Return a copy of the receiver. \"\r\n\r\n\t^self shallowCopy","(\r\nfunction(self)\r\nreturn ((self):shallowCopy());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"shallowCopy",0
,(
function(self)
local result=nil
(function()
	local _s8_value=(((self)["$klass"]):basicNew())
	result=_s8_value
	return _s8_value
end)();
((self)["$klass"]):allInstVarNamesDo_((function(iv)
local v=nil
(function()
	local _s8_value=((self)[smalltalk:object_comma_(("@"),iv)])
	v=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((v))),(function()
return (smalltalk:basic_at_put_((result),smalltalk:object_comma_(("@"),iv),v))
end),nil))
end));
return (result);
end
)
,"copying","shallowCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self class basicNew.\r\n\tself class allInstVarNamesDo: [:iv| | v |\r\n\t\tv := self basicAt: $@,iv.\r\n\t\tv notNil ifTrue: [ result basicAt: $@,iv put: v ]\r\n\t].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self)[\"$klass\"]):basicNew())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self)[\"$klass\"]):allInstVarNamesDo_((function(iv)\r\nlocal v=nil\r\n(function()\r\n\tlocal _s8_value=((self)[smalltalk:object_comma_((\"@\"),iv)])\r\n\tv=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((v))),(function()\r\nreturn (smalltalk:basic_at_put_((result),smalltalk:object_comma_((\"@\"),iv),v))\r\nend),nil))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"deepCopyOf:",0
,(
function(self,what)
if (smalltalk:isNil_((what)))==true then return (what); end;
if ((self):isObject_(what))==true then return ((what):deepCopy()); end;
return (what);
end
)
,"copying","deepCopyOf: what\r\n\t\" Private - Return a deep copy of what. \"\r\n\r\n\twhat isNil ifTrue: [ ^what ].\r\n\t(self isObject: what) ifTrue: [ ^what deepCopy ].\r\n\t^what","(\r\nfunction(self,what)\r\nif (smalltalk:isNil_((what)))==true then return (what); end;\r\nif ((self):isObject_(what))==true then return ((what):deepCopy()); end;\r\nreturn (what);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"deepCopy",0
,(
function(self)
local result=nil
(function()
	local _s8_value=(((self)["$klass"]):basicNew())
	result=_s8_value
	return _s8_value
end)();
((self)["$klass"]):allInstVarNamesDo_((function(iv)
local v=nil
(function()
	local _s8_value=((self):deepCopyOf_((self)[smalltalk:object_comma_(("@"),iv)]))
	v=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((v))),(function()
return (smalltalk:basic_at_put_((result),smalltalk:object_comma_(("@"),iv),v))
end),nil))
end));
return (result);
end
)
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self class basicNew.\r\n\tself class allInstVarNamesDo: [:iv| | v |\r\n\t\tv := self deepCopyOf: (self basicAt: $@,iv).\r\n\t\tv notNil ifTrue: [ result basicAt: $@,iv put: v ]\r\n\t].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self)[\"$klass\"]):basicNew())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self)[\"$klass\"]):allInstVarNamesDo_((function(iv)\r\nlocal v=nil\r\n(function()\r\n\tlocal _s8_value=((self):deepCopyOf_((self)[smalltalk:object_comma_((\"@\"),iv)]))\r\n\tv=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((v))),(function()\r\nreturn (smalltalk:basic_at_put_((result),smalltalk:object_comma_((\"@\"),iv),v))\r\nend),nil))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"->","_minus_gt"
,(
function(self,anObject)
return ((smalltalk.Association):key_value_(self,anObject));
end
)
,"converting","-> anObject\r\n\t\" Return an association of the receiver to anObject. \"\r\n\r\n\t^Association key: self value: anObject","(\r\nfunction(self,anObject)\r\nreturn ((smalltalk.Association):key_value_(self,anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"asString",0
,(
function(self)
return (smalltalk:printString_((self)));
end
)
,"converting","asString\r\n\t\" Return the receiver represented as String. \"\r\n\r\n\t^self printString","(\r\nfunction(self)\r\nreturn (smalltalk:printString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"toString",0
,(
function(self)

return (smalltalk:object_comma_((smalltalk:object_comma_(("{st:a"),((self)["$klass"]):name())),"}"));
end
)
,"converting","toString\r\n\t\" Return the receiver as a String. \"\r\n\r\n\t{'self'}.\r\n\t^'{st:a',self class name,$}","(\r\nfunction(self)\r\n\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"{st:a\"),((self)[\"$klass\"]):name())),\"}\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"toString:",0
,(
function(self,anObject)
if (smalltalk:isNil_((anObject)))==true then return ("nil"); end;
if ((self):isObject_(anObject))==true then return (smalltalk:toString_((anObject))); end;
return (tostring(anObject));
end
)
,"converting","toString: anObject\r\n\t\" Return anObject converted to a String. \"\r\n\r\n\tanObject isNil ifTrue: [ ^#nil ].\r\n\t(self isObject: anObject) ifTrue: [ ^anObject toString ].\r\n\t^{'' doc'Native conversion (default goes to error)'}","(\r\nfunction(self,anObject)\r\nif (smalltalk:isNil_((anObject)))==true then return (\"nil\"); end;\r\nif ((self):isObject_(anObject))==true then return (smalltalk:toString_((anObject))); end;\r\nreturn (tostring(anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"asNative:",0
,(
function(self,lang)
return (smalltalk:asString_((self)));
end
)
,"converting","asNative: lang\r\n\t\" Return the native representation of the receiver in target language lang.\r\n\tThe default implementation return the receiver as a String.\r\n\tThis method must be refined by subclasses implementing native literal representation.\r\n\t\"\r\n\r\n\t^self asString","(\r\nfunction(self,lang)\r\nreturn (smalltalk:asString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"asNative",0
,(
function(self)
return ((self):asNative_((self):nativeLanguage()));
end
)
,"converting","asNative\r\n\t\" Return the native representation of the receiver.\r\n\tThe default implementation return the receiver as a String.\r\n\tThis method must be refined by subclasses implementing native literal representation.\r\n\t\"\r\n\r\n\t^self asNative: self nativeLanguage","(\r\nfunction(self)\r\nreturn ((self):asNative_((self):nativeLanguage()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"asJSON",0
,(
function(self)
local json=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):nativeObjectAt_("JSON"))
	json=_s8_value
	return _s8_value
end)();
return ((json):stringify((self):asJSONObject()));
end
)
,"json","asJSON\r\n\t\" Return the JSON representation of the receiver. \"\r\n\r\n\t| json |\r\n\tjson := Smalltalk nativeObjectAt: #JSON.\r\n\t^json #stringify: self asJSONObject","(\r\nfunction(self)\r\nlocal json=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):nativeObjectAt_(\"JSON\"))\r\n\tjson=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((json):stringify((self):asJSONObject()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"escapedCode",0
,(
function(self)
return ((self):asNative());
end
)
,"converting","escapedCode\r\n\t\" Return the code to reproduce receiver from code. \"\r\n\r\n\t^self asNative","(\r\nfunction(self)\r\nreturn ((self):asNative());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"perform:",0
,(
function(self,aSymbol)
return ((self):perform_withArguments_(aSymbol,smalltalk:newArray({})));
end
)
,"perform","perform: aSymbol\r\n\t\" Return the result of sending message aSymbol to the receiver. \"\r\n\r\n\t^self perform: aSymbol withArguments: #()","(\r\nfunction(self,aSymbol)\r\nreturn ((self):perform_withArguments_(aSymbol,smalltalk:newArray({})));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"perform:with:",0
,(
function(self,aSymbol,argument)
return ((self):perform_withArguments_(aSymbol,(smalltalk.Array):with_(argument)));
end
)
,"perform","perform: aSymbol with: argument\r\n\t\" Return the result of sending message aSymbol to the receiver. \"\r\n\r\n\t^self perform: aSymbol withArguments: (Array with: argument)","(\r\nfunction(self,aSymbol,argument)\r\nreturn ((self):perform_withArguments_(aSymbol,(smalltalk.Array):with_(argument)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"perform:withArguments:",0
,(
function(self,aSymbol,aCollection)
return ((self):basicPerform_withArguments_((aSymbol):asSelector(),(aCollection):asArray()));
end
)
,"perform","perform: aSymbol withArguments: aCollection\r\n\t\" Return the result of sending message aSymbol to the receiver. \"\r\n\r\n\"\tWarning: To do NOT check arguments size is a feature\r\n\t\tif we do strict matching U8 tools will break because they are using the feature.\r\n\taSymbol numberOfArguments = aCollection size ifFalse: [\r\n\t\t^self error: 'Invalid arguments size'\r\n\t].\r\n\"\t^self basicPerform: aSymbol asSelector withArguments: aCollection asArray","(\r\nfunction(self,aSymbol,aCollection)\r\nreturn ((self):basicPerform_withArguments_((aSymbol):asSelector(),(aCollection):asArray()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isObject:",0
,(
function(self,anObject)

	local status, result = pcall(function() return type(anObject.yourself)=="function" end)
	if true then return status and result end;
return (self);
end
)
,"testing","isObject: anObject\r\n\t\" Return true if anObject is a smalltalk object.\r\n\tReturn false if the object is a native object.\r\n\t\"\r\n\r\n\t{'' doc'Native detection (default goes to error)'}","(\r\nfunction(self,anObject)\r\n\r\n\tlocal status, result = pcall(function() return type(anObject.yourself)==\"function\" end)\r\n\tif true then return status and result end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isNumber:",0
,(
function(self,anObject)
return (smalltalk:boolean_and_(((self):isObject_(anObject)),(function()
return ((anObject):isNumber())
end)));
end
)
,"testing","isNumber: anObject\r\n\t\" Return true if anObject is a number. \"\r\n\r\n\t^(self isObject: anObject) and: [ anObject isNumber ]","(\r\nfunction(self,anObject)\r\nreturn (smalltalk:boolean_and_(((self):isObject_(anObject)),(function()\r\nreturn ((anObject):isNumber())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"basicAt:",0
,(
function(self,aString)
local result=nil
(function()
	local _s8_value=(self[aString])
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((result)))==true then return (nil); end;
return (result);
end
)
,"accessing","basicAt: aString\r\n\t\" Return the property of the receiver known as aString (or nil). \"\r\n\r\n\t| result |\r\n\tresult := self[aString].\r\n\tresult isNil ifTrue: [ ^nil ].\r\n\t^result","(\r\nfunction(self,aString)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(self[aString])\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((result)))==true then return (nil); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"basicAt:ifAbsent:",0
,(
function(self,aString,aBlock)
return (smalltalk:ifUndefined_do_((self[aString]),(function()
return ((aBlock):value())
end)));
end
)
,"accessing","basicAt: aString ifAbsent: aBlock\r\n\t\" Return the property of the receiver known as aString (or the result of evaluating aBlock). \"\r\n\r\n\t^self[aString] ifUndefined: [ aBlock value ]","(\r\nfunction(self,aString,aBlock)\r\nreturn (smalltalk:ifUndefined_do_((self[aString]),(function()\r\nreturn ((aBlock):value())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"basicAt:ifAbsentPut:",0
,(
function(self,aString,aBlock)
return (smalltalk:basic_at_ifAbsent_((self),aString,(function()
return (smalltalk:basic_at_put_((self),aString,(aBlock):value()))
end)));
end
)
,"accessing","basicAt: aString ifAbsentPut: aBlock\r\n\t\" Return the property of the receiver known as aString (or set it with the result of evaluating aBlock). \"\r\n\r\n\t^self basicAt: aString ifAbsent: [ self basicAt: aString put: aBlock value ]","(\r\nfunction(self,aString,aBlock)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),aString,(function()\r\nreturn (smalltalk:basic_at_put_((self),aString,(aBlock):value()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"instVarAt:",0
,(
function(self,instVarName)
if ((self):isNumber_(instVarName))==true then return ((self):instVarAt_((((self)["$klass"]):allInstVarNames()):at_(instVarName))); end;
return ((self)[smalltalk:object_comma_(("@"),instVarName)]);
end
)
,"accessing","instVarAt: instVarName\r\n\t\" Return the internal collaborator of the receiver known as instVarName. \"\r\n\r\n\t(self isNumber: instVarName) ifTrue: [\r\n\t\t^self instVarAt: (self class allInstVarNames at: instVarName)\r\n\t].\r\n\t^self basicAt: $@ ,instVarName","(\r\nfunction(self,instVarName)\r\nif ((self):isNumber_(instVarName))==true then return ((self):instVarAt_((((self)[\"$klass\"]):allInstVarNames()):at_(instVarName))); end;\r\nreturn ((self)[smalltalk:object_comma_((\"@\"),instVarName)]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"instVarAt:put:",0
,(
function(self,instVarName,anObject)
if ((self):isNumber_(instVarName))==true then return ((self):instVarAt_put_((((self)["$klass"]):allInstVarNames()):at_(instVarName),anObject)); end;
return (smalltalk:basic_at_put_((self),smalltalk:object_comma_(("@"),instVarName),anObject));
end
)
,"accessing","instVarAt: instVarName put: anObject\r\n\t\" Set the internal collaborator of the receiver known as instVarName to anObject. \"\r\n\r\n\t(self isNumber: instVarName) ifTrue: [\r\n\t\t^self instVarAt: (self class allInstVarNames at: instVarName) put: anObject\r\n\t].\r\n\t^self basicAt: $@ ,instVarName put: anObject","(\r\nfunction(self,instVarName,anObject)\r\nif ((self):isNumber_(instVarName))==true then return ((self):instVarAt_put_((((self)[\"$klass\"]):allInstVarNames()):at_(instVarName),anObject)); end;\r\nreturn (smalltalk:basic_at_put_((self),smalltalk:object_comma_((\"@\"),instVarName),anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"basicAt:put:",0
,(
function(self,aString,anObject)
return ((function()
	local _s8_value=(anObject)
	self[aString]=_s8_value
	return _s8_value
end)());
end
)
,"accessing","basicAt: aString put: anObject\r\n\t\" Set the property of the receiver known as aString. \"\r\n\r\n\t^self[aString] := anObject","(\r\nfunction(self,aString,anObject)\r\nreturn ((function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[aString]=_s8_value\r\n\treturn _s8_value\r\nend)());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"error:",0
,(
function(self,aString)
return ((smalltalk.Error):signal_(aString));
end
)
,"error","error: aString\r\n\t\" Return the result of managing error(aString) in the receiver. \"\r\n\r\n\t^Error signal: aString","(\r\nfunction(self,aString)\r\nreturn ((smalltalk.Error):signal_(aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"subclassResponsibility",0
,(
function(self)
return ((self):subclassResponsibility_(nil));
end
)
,"error","subclassResponsibility\r\n\t\" Private - The concrete implementation on the receiver is not complete. \"\r\n\r\n\t^self subclassResponsibility: nil","(\r\nfunction(self)\r\nreturn ((self):subclassResponsibility_(nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"implementedBySubclass",0
,(
function(self)
return ((self):subclassResponsibility());
end
)
,"error","implementedBySubclass\r\n\t\" Private - The concrete implementation on the receiver is not complete. \"\r\n\r\n\t^self subclassResponsibility","(\r\nfunction(self)\r\nreturn ((self):subclassResponsibility());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"shouldNotImplement",0
,(
function(self)
return ((self):shouldNotImplement_(nil));
end
)
,"error","shouldNotImplement\r\n\t\" The receiver received a message that is not expected. \"\r\n\r\n\t^self shouldNotImplement: nil","(\r\nfunction(self)\r\nreturn ((self):shouldNotImplement_(nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"invalidMessage",0
,(
function(self)
return ((self):invalidMessage_(nil));
end
)
,"error","invalidMessage\r\n\t\" The receiver received a message that is invalid (not expected for this object). \"\r\n\r\n\t^self invalidMessage: nil","(\r\nfunction(self)\r\nreturn ((self):invalidMessage_(nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"subclassResponsibility:",0
,(
function(self,aSelector)
return (((self):halt()):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Implementation of"),smalltalk:if_true_false_((smalltalk:isNil_((aSelector))),(function()
return (" ")
end),(function()
return (smalltalk:object_comma_((" #"),aSelector))
end))))," is a responsibility of the subclass(")),((self)["$klass"]):name())),").")));
end
)
,"error","subclassResponsibility: aSelector\r\n\t\" Private - The concrete implementation on the receiver is not complete. \"\r\n\r\n\t^self halt error:\r\n\t\t 'Implementation of'\r\n\t\t,(aSelector isNil ifTrue: [' '] ifFalse: [' #',aSelector])\r\n\t\t,' is a responsibility of the subclass(',self class name,').'","(\r\nfunction(self,aSelector)\r\nreturn (((self):halt()):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Implementation of\"),smalltalk:if_true_false_((smalltalk:isNil_((aSelector))),(function()\r\nreturn (\" \")\r\nend),(function()\r\nreturn (smalltalk:object_comma_((\" #\"),aSelector))\r\nend)))),\" is a responsibility of the subclass(\")),((self)[\"$klass\"]):name())),\").\")));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"implementedBySubclass:",0
,(
function(self,aSelector)
return ((self):subclassResponsibility_(aSelector));
end
)
,"error","implementedBySubclass: aSelector\r\n\t\" Private - The concrete implementation on the receiver is not complete. \"\r\n\r\n\t^self subclassResponsibility: aSelector","(\r\nfunction(self,aSelector)\r\nreturn ((self):subclassResponsibility_(aSelector));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"shouldNotImplement:",0
,(
function(self,aSelector)
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Message"),smalltalk:if_true_false_((smalltalk:isNil_((aSelector))),(function()
return (" ")
end),(function()
return (smalltalk:object_comma_((" #"),aSelector))
end))))," should not be implemented for instances of ")),((self)["$klass"]):name())));
end
)
,"error","shouldNotImplement: aSelector\r\n\t\" The receiver received a message that is not expected. \"\r\n\r\n\t^self error:\r\n\t\t 'Message'\r\n\t\t,(aSelector isNil ifTrue: [' '] ifFalse: [' #',aSelector])\r\n\t\t,' should not be implemented for instances of ', self class name","(\r\nfunction(self,aSelector)\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Message\"),smalltalk:if_true_false_((smalltalk:isNil_((aSelector))),(function()\r\nreturn (\" \")\r\nend),(function()\r\nreturn (smalltalk:object_comma_((\" #\"),aSelector))\r\nend)))),\" should not be implemented for instances of \")),((self)[\"$klass\"]):name())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"invalidMessage:",0
,(
function(self,aSelector)
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Message"),smalltalk:if_true_false_((smalltalk:isNil_((aSelector))),(function()
return (" ")
end),(function()
return (smalltalk:object_comma_((" #"),aSelector))
end))))," should not be sent to instances of ")),((self)["$klass"]):name())));
end
)
,"error","invalidMessage: aSelector\r\n\t\" The receiver received a message that is invalid (not expected for this object). \"\r\n\r\n\t^self error: \r\n\t\t 'Message'\r\n\t\t,(aSelector isNil ifTrue: [' '] ifFalse: [' #',aSelector])\r\n\t\t,' should not be sent to instances of ', self class name","(\r\nfunction(self,aSelector)\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Message\"),smalltalk:if_true_false_((smalltalk:isNil_((aSelector))),(function()\r\nreturn (\" \")\r\nend),(function()\r\nreturn (smalltalk:object_comma_((\" #\"),aSelector))\r\nend)))),\" should not be sent to instances of \")),((self)[\"$klass\"]):name())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"smalltalkErrorOf:",0
,(
function(self,aNativeException)
local result=nil
if ((self):isObject_(aNativeException))==true then if (smalltalk:is_kindOf_((aNativeException),(smalltalk.Exception)))==true then return (aNativeException); end;
return (((smalltalk.Error):new()):messageText_(aNativeException)); end;
(function()
	local _s8_value=((aNativeException)["smalltalkError"])
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((result)))==true then return (result); end;
return ((
function(_s8_rec)
	(_s8_rec):messageText_(((aNativeException["description"]) or aNativeException["message"]));
	(_s8_rec):nativeException_(aNativeException);
	return ((_s8_rec):yourself())
end
)((smalltalk.Error):new()));
end
)
,"private","smalltalkErrorOf: aNativeException\r\n\t\" Private, Internal - Return anException associated with a native exception. \"\r\n\r\n\t| result |\r\n\t(self isObject: aNativeException) ifTrue: [\r\n\t\t(aNativeException isKindOf: Exception) ifTrue: [ ^aNativeException ].\r\n\t\t^Error new messageText: aNativeException\r\n\t].\r\n\tresult := aNativeException basicAt: #smalltalkError.\r\n\tresult notNil ifTrue: [ ^result ].\r\n\t^Error new\r\n\t\tmessageText: aNativeException#description || aNativeException#message;\r\n\t\tnativeException: aNativeException;\r\n\t\tyourself","(\r\nfunction(self,aNativeException)\r\nlocal result=nil\r\nif ((self):isObject_(aNativeException))==true then if (smalltalk:is_kindOf_((aNativeException),(smalltalk.Exception)))==true then return (aNativeException); end;\r\nreturn (((smalltalk.Error):new()):messageText_(aNativeException)); end;\r\n(function()\r\n\tlocal _s8_value=((aNativeException)[\"smalltalkError\"])\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((result)))==true then return (result); end;\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):messageText_(((aNativeException[\"description\"]) or aNativeException[\"message\"]));\r\n\t(_s8_rec):nativeException_(aNativeException);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.Error):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"inspect",0
,(
function(self)
return ((self):basicInspect());
end
)
,"inspection","inspect\r\n\t\" Open an inspector on the receiver. \"\r\n\r\n\t^self basicInspect","(\r\nfunction(self)\r\nreturn ((self):basicInspect());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"basicInspect",0
,(
function(self)
if (((self):smalltalk()):includesKey_("NativeHandle"))==true then return ((self):print_((smalltalk.NativeHandle):_at_gt(self))); end;
return (self);
end
)
,"inspection","basicInspect\r\n\t\" Private - Open an inspector on the receiver. \"\r\n\r\n\t(self smalltalk includesKey: #NativeHandle) ifTrue: [ \"print native representation\"\r\n\t\t^self print: NativeHandle @> self\r\n\t].\r\n\t^self","(\r\nfunction(self)\r\nif (((self):smalltalk()):includesKey_(\"NativeHandle\"))==true then return ((self):print_((smalltalk.NativeHandle):_at_gt(self))); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"printString",0
,(
function(self)
return (smalltalk:object_comma_(("a "),((self)["$klass"]):name()));
end
)
,"printing","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t^'a ', self class name","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((\"a \"),((self)[\"$klass\"]):name()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isKindOf:",0
,(
function(self,aClass)
return (((self)["$klass"]):inheritsFrom_(aClass));
end
)
,"testing","isKindOf: aClass\r\n\t\" Return true if the receiver is kind of aClass. \"\r\n\r\n\t^self class inheritsFrom: aClass","(\r\nfunction(self,aClass)\r\nreturn (((self)[\"$klass\"]):inheritsFrom_(aClass));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isMemberOf:",0
,(
function(self,aClass)
return ((((self)["$klass"])==aClass));
end
)
,"testing","isMemberOf: aClass\r\n\t\" Return true if the receiver is member of aClass. \"\r\n\r\n\t^self class == aClass","(\r\nfunction(self,aClass)\r\nreturn ((((self)[\"$klass\"])==aClass));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"ifNil:",0
,(
function(self,aBlock)
return (self);
end
)
,"testing","ifNil: aBlock\r\n\t\" Return the receiver if it is not nil, or the result of evaluating aBlock (if it is nil). \"\r\n\r\n\t^self","(\r\nfunction(self,aBlock)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"ifNil:ifNotNil:",0
,(
function(self,aBlock,anotherBlock)
return ((anotherBlock):value());
end
)
,"testing","ifNil: aBlock ifNotNil: anotherBlock\r\n\t\" Return the result of evaluating aBlock if the receiver is nil or the result of evaluating anotherBlock (if not nil). \"\r\n\r\n\t^anotherBlock value","(\r\nfunction(self,aBlock,anotherBlock)\r\nreturn ((anotherBlock):value());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"ifNotNil:",0
,(
function(self,aBlock)
return ((aBlock):value());
end
)
,"testing","ifNotNil: aBlock\r\n\t\" Return the result of evaluating aBlock if the receiver is not nil, or nil if it is nil. \"\r\n\r\n\t^aBlock value","(\r\nfunction(self,aBlock)\r\nreturn ((aBlock):value());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"ifNotNil:ifNil:",0
,(
function(self,aBlock,anotherBlock)
return ((aBlock):value());
end
)
,"testing","ifNotNil: aBlock ifNil: anotherBlock\r\n\t\" Return the result of evaluating aBlock if the receiver is not nil, or the result of evaluating anotherBlock if it is nil. \"\r\n\r\n\t^aBlock value","(\r\nfunction(self,aBlock,anotherBlock)\r\nreturn ((aBlock):value());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isNil",0
,(
function(self)
return (false);
end
)
,"testing","isNil\r\n\t\" Return true if the receiver is nil. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"notNil",0
,(
function(self)
return (smalltalk:booleanNot_((smalltalk:isNil_((self)))));
end
)
,"testing","notNil\r\n\t\" Return true if the receiver is not nil. \"\r\n\r\n\t^self isNil not","(\r\nfunction(self)\r\nreturn (smalltalk:booleanNot_((smalltalk:isNil_((self)))));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isClass",0
,(
function(self)
return (false);
end
)
,"testing","isClass\r\n\t\" Return true if the receiver is a Class. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isMetaclass",0
,(
function(self)
return (false);
end
)
,"testing","isMetaclass\r\n\t\" Return true if the receiver is a metaclass. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isNumber",0
,(
function(self)
return (false);
end
)
,"testing","isNumber\r\n\t\" Return true if the receiver is a Number. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isString",0
,(
function(self)
return (false);
end
)
,"testing","isString\r\n\t\" Return true if the receiver is a String. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isArray",0
,(
function(self)
return (false);
end
)
,"testing","isArray\r\n\t\" Return true if the receiver is an Array. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isValuable",0
,(
function(self)
return (false);
end
)
,"testing","isValuable\r\n\t\" Return true if the receiver can be evaluated. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"typeOf:",0
,(
function(self,anObject)
return (type(anObject));
end
)
,"native","typeOf: anObject\r\n\t\" Return the (native) type of anObject. \"\r\n\r\n\t^{'' doc'Get native type (default goes to error, use to be a String instance)'}","(\r\nfunction(self,anObject)\r\nreturn (type(anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"callableOf:",0
,(
function(self,aBlock)

if (smalltalk:isNil_((aBlock)))==true then return (aBlock); end;
if (smalltalk:isObject_equalTo_(((self):typeOf_(aBlock)),"function"))==true then return (aBlock); end;
return ((function(x,y,z)
return ((aBlock):value_value_value_(x,y,z))
end));
end
)
,"native","callableOf: aBlock\r\n\t\" Return a (native) callable object for evaluating aBlock. \"\r\n\r\n\t{'self' s8' ^aBlock '}.\r\n\taBlock isNil ifTrue: [ ^aBlock ].\r\n\t(self typeOf: aBlock) = #function ifTrue: [ ^aBlock ].\r\n\t^[:x :y :z| aBlock value: x value: y value: z ] ","(\r\nfunction(self,aBlock)\r\n\r\nif (smalltalk:isNil_((aBlock)))==true then return (aBlock); end;\r\nif (smalltalk:isObject_equalTo_(((self):typeOf_(aBlock)),\"function\"))==true then return (aBlock); end;\r\nreturn ((function(x,y,z)\r\nreturn ((aBlock):value_value_value_(x,y,z))\r\nend));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"methodFor:",0
,(
function(self,aSymbol)
return (((self)["$klass"]):compiledMethodFor_(aSymbol));
end
)
,"messages","methodFor: aSymbol \r\n\t\" Return the method implementing aSymbol (or nil). \"\r\n\r\n\t^self class compiledMethodFor: aSymbol","(\r\nfunction(self,aSymbol)\r\nreturn (((self)[\"$klass\"]):compiledMethodFor_(aSymbol));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"respondsTo:",0
,(
function(self,aSymbol)
return (smalltalk:notNil_(((self):methodFor_(aSymbol))));
end
)
,"messages","respondsTo: aSymbol \r\n\t\" Return true if the receiver respond to message aSymbol. \"\r\n\r\n\t^(self methodFor: aSymbol) notNil","(\r\nfunction(self,aSymbol)\r\nreturn (smalltalk:notNil_(((self):methodFor_(aSymbol))));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"basicDelete:",0
,(
function(self,aString)
if self==nil then return else self[aString]=nil end;
return (self);
end
)
,"accessing","basicDelete: aString\r\n\t\" Private - Basic implementation of deletion of property aString of the receiver. \"\r\n\r\n\t{'' doc'native deletion'}","(\r\nfunction(self,aString)\r\nif self==nil then return else self[aString]=nil end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"doesNotUnderstand:",0
,(
function(self,aMessage)
return ((
function(_s8_rec)
	(_s8_rec):receiver_(self);
	(_s8_rec):message_(aMessage);
	return ((_s8_rec):signal())
end
)((smalltalk.MessageNotUnderstood):new()));
end
)
,"dnu","doesNotUnderstand: aMessage\r\n\t\" Private - Basic implementation of a message sent and not understood by the receiver. \"\r\n\r\n\t^MessageNotUnderstood new\r\n\t\treceiver: self;\r\n\t\tmessage: aMessage;\r\n\t\tsignal","(\r\nfunction(self,aMessage)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):receiver_(self);\r\n\t(_s8_rec):message_(aMessage);\r\n\treturn ((_s8_rec):signal())\r\nend\r\n)((smalltalk.MessageNotUnderstood):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"dnu:withArguments:",0
,(
function(self,selector,anArray)
return ((self):doesNotUnderstand_((smalltalk.Message):selector_arguments_(selector,anArray)));
end
)
,"dnu","dnu: selector withArguments: anArray\r\n\t\" Private - Basic implementation of a message sent and not understood by the receiver. \"\r\n\r\n\t^self doesNotUnderstand: (Message selector: selector arguments: anArray)","(\r\nfunction(self,selector,anArray)\r\nreturn ((self):doesNotUnderstand_((smalltalk.Message):selector_arguments_(selector,anArray)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"basicPerform:withArguments:",0
,(
function(self,jsSelector,anArray)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local fn=nil

(function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((self),jsSelector,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):dnu_withArguments_((jsSelector):asNativeSelector(),anArray))
end
)()
error(_s8Ret_,0)
end)())
end)))
	fn=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (fn(self,(table.unpack or unpack)(anArray)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"private","basicPerform: jsSelector withArguments: anArray\r\n\t\" Private - Basic implementation of #perform... \"\r\n\r\n\t| fn |\r\n\t{'self'}.\r\n\tfn := self basicAt: jsSelector ifAbsent: [\r\n\t\t^self dnu: jsSelector asNativeSelector withArguments: anArray\r\n\t].\r\n\t^{'' doc'dynamic message send (fn can be native function to call)'}","(\r\nfunction(self,jsSelector,anArray)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal fn=nil\r\n\r\n(function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((self),jsSelector,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):dnu_withArguments_((jsSelector):asNativeSelector(),anArray))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (fn(self,(table.unpack or unpack)(anArray)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"json",0
,(
function(self)
return ((self):asJSONObject());
end
)
,"json","json\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t^self asJSONObject","(\r\nfunction(self)\r\nreturn ((self):asJSONObject());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"asJson:",0
,(
function(self,anObject)
if (smalltalk:isNil_((anObject)))==true then return ((nil):json()); end;
return (smalltalk:if_true_false_(((self):isObject_(anObject)),(function()
return ((anObject):json())
end),(function()
return (anObject)
end)));
end
)
,"json","asJson: anObject\r\n\t\" Return anObject as a hash object. \"\r\n\r\n\tanObject isNil ifTrue: [ ^nil json ].\r\n\t^(self isObject: anObject)\r\n\t\tifTrue: [ anObject json ]\r\n\t\tifFalse: [ anObject ]","(\r\nfunction(self,anObject)\r\nif (smalltalk:isNil_((anObject)))==true then return ((nil):json()); end;\r\nreturn (smalltalk:if_true_false_(((self):isObject_(anObject)),(function()\r\nreturn ((anObject):json())\r\nend),(function()\r\nreturn (anObject)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"asJSONObject",0
,(
function(self)
local result=nil
(function()
	local _s8_value=({})
	result=_s8_value
	return _s8_value
end)();
(self):jsonFieldsDo_ignoring_((function(field,value)
return (smalltalk:if_true_false_((smalltalk:boolean_or_((smalltalk:notNil_((value))),(function()
return ((self):jsonExportNil())
end))),(function()
return (smalltalk:basic_at_put_((result),field,(self):asJson_(value)))
end),nil))
end),(self):jsonHiddenNames());
return (result);
end
)
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t| result |\r\n\tresult := {'' doc'get empty JSON collector'}.\r\n\tself\tjsonFieldsDo: [:field :value|\r\n\t\t(value notNil or: [ self jsonExportNil ]) ifTrue: [\r\n\t\t\tresult basicAt: field put: (self asJson: value)\r\n\t\t].\r\n\t]\tignoring: self jsonHiddenNames.\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=({})\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):jsonFieldsDo_ignoring_((function(field,value)\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_or_((smalltalk:notNil_((value))),(function()\r\nreturn ((self):jsonExportNil())\r\nend))),(function()\r\nreturn (smalltalk:basic_at_put_((result),field,(self):asJson_(value)))\r\nend),nil))\r\nend),(self):jsonHiddenNames());\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"jsonHiddenNames",0
,(
function(self)
return (smalltalk:newArray({}));
end
)
,"converting","jsonHiddenNames\r\n\t\" Private - Return the names of the fields to skip when mapping the receiver to JSON structure. \"\r\n\r\n\t^#()","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({}));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"jsonFieldsDo:ignoring:",0
,(
function(self,aBlock,ignored)
return (((self)["$klass"]):allInstVarNamesDo_((function(each)
return (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((ignored))),(function()
return ((ignored):includes_(each))
end))),nil,(function()
return ((aBlock):value_value_(each,(self):instVarAt_(each)))
end)))
end)));
end
)
,"converting","jsonFieldsDo: aBlock ignoring: ignored\r\n\t\" Private - Evaluates a(TwoArguments)Block with the fields to map the receiver to JSON structure. \"\r\n\r\n\t^self class allInstVarNamesDo: [:each|\r\n\t\t(ignored notNil and: [ ignored includes: each ]) ifFalse: [\r\n\t\t\taBlock value: each value: (self instVarAt: each)\r\n\t\t].\r\n\t]","(\r\nfunction(self,aBlock,ignored)\r\nreturn (((self)[\"$klass\"]):allInstVarNamesDo_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((ignored))),(function()\r\nreturn ((ignored):includes_(each))\r\nend))),nil,(function()\r\nreturn ((aBlock):value_value_(each,(self):instVarAt_(each)))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"jsonExportNil",0
,(
function(self)
return (false);
end
)
,"converting","jsonExportNil\r\n\t\" Private - Return true if the receiver export nil values. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"mustBeBoolean",0
,(
function(self)
return ((self):error_("Must be boolean."));
end
)
,"testing","mustBeBoolean\r\n\t\" Signal an error if the receiver is not a Boolean. \"\r\n\r\n\t^self error: 'Must be boolean.'","(\r\nfunction(self)\r\nreturn ((self):error_(\"Must be boolean.\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isBoolean",0
,(
function(self)
return (false);
end
)
,"testing","isBoolean\r\n\t\" Return true if the receiver is a boolean. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"mustBeNumber",0
,(
function(self)
return ((self):error_("Must be a Number"));
end
)
,"testing","mustBeNumber\r\n\t\" Signal an error if the receiver is not a Number. \"\r\n\r\n\t^self error: 'Must be a Number'","(\r\nfunction(self)\r\nreturn ((self):error_(\"Must be a Number\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"asLiteral",0
,(
function(self)
return (smalltalk:printString_((self)));
end
)
,"converting","asLiteral\r\n\t\" Return the receiver in literal notation. \"\r\n\r\n\t^self printString","(\r\nfunction(self)\r\nreturn (smalltalk:printString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isCharacter",0
,(
function(self)
return (false);
end
)
,"testing","isCharacter\r\n\t\" Return true if the receiver is a character. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isAssociation",0
,(
function(self)
return (false);
end
)
,"testing","isAssociation\r\n\t\" Return true if the receiver is anAssociation. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isDictionary",0
,(
function(self)
return (false);
end
)
,"testing","isDictionary\r\n\t\" Return true if the receiver is a dictionary. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isRectangle",0
,(
function(self)
return (false);
end
)
,"testing","isRectangle\r\n\t\" Return true if receiver is a Rectangle. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isMessage",0
,(
function(self)
return (false);
end
)
,"testing","isMessage\r\n\t\" Return true if the receiver is a message. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"argumentCount",0
,(
function(self)
return (0);
end
)
,"evaluating","argumentCount\r\n\t\" Return the number of arguments of the receiver. \"\r\n\r\n\t^0","(\r\nfunction(self)\r\nreturn (0);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"numberOfArguments",0
,(
function(self)
return ((self):argumentCount());
end
)
,"evaluating","numberOfArguments\r\n\t\" Return the number of arguments of the receiver. \"\r\n\r\n\t^self argumentCount","(\r\nfunction(self)\r\nreturn ((self):argumentCount());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"evaluate",0
,(
function(self)
return (self);
end
)
,"evaluating","evaluate\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"evaluateDeferred",0
,(
function(self)
((function()
return ((self):evaluate())
end)):valueDeferred();
return (self);
end
)
,"evaluating","evaluateDeferred\r\n\t\" Evaluating the receiver deferred in time.\r\n\tReturn the receiver. \"\r\n\r\n\t[ self evaluate ] valueDeferred.","(\r\nfunction(self)\r\n((function()\r\nreturn ((self):evaluate())\r\nend)):valueDeferred();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"evaluateWithArguments:",0
,(
function(self,anArray)
return (self);
end
)
,"evaluating","evaluateWithArguments: anArray\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self,anArray)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"evaluateWith:",0
,(
function(self,anObject)
return ((self):evaluateWithArguments_((smalltalk.Array):with_(anObject)));
end
)
,"evaluating","evaluateWith: anObject\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self evaluateWithArguments: (Array with: anObject)","(\r\nfunction(self,anObject)\r\nreturn ((self):evaluateWithArguments_((smalltalk.Array):with_(anObject)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"logEvaluate:",0
,(
function(self,source)
local result=nil
(function()
	local _s8_value=((self):evaluate())
	result=_s8_value
	return _s8_value
end)();
(smalltalk.SystemManager):log_(source);
return (result);
end
)
,"evaluating","logEvaluate: source\r\n\t\" Return the result of evaluating the receiver.\r\n\tLog the source expression as reference of evaluation.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := self evaluate.\r\n\tSystemManager log: source.\r\n\t^result","(\r\nfunction(self,source)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):evaluate())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(smalltalk.SystemManager):log_(source);\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"asActionSequence",0
,(
function(self)
return ((smalltalk.ActionSequence):with_(self));
end
)
,"converting","asActionSequence\r\n\t\" Return an ActionSequence from the receiver. \"\r\n\r\n\t^ActionSequence with: self","(\r\nfunction(self)\r\nreturn ((smalltalk.ActionSequence):with_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"eventTable",0
,(
function(self)
return (smalltalk:basic_at_ifAbsent_((self),"@handlers",(function()
return ((self):eventTableCreate())
end)));
end
)
,"events","eventTable\r\n\t\" Private - Return the mapping event names to actions of the receiver. \"\r\n\r\n\t^self basicAt: '@handlers' ifAbsent: [ self eventTableCreate ]","(\r\nfunction(self)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),\"@handlers\",(function()\r\nreturn ((self):eventTableCreate())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"eventTableForEdit",0
,(
function(self)
return (smalltalk:basic_at_ifAbsent_((self),"@handlers",(function()
return (smalltalk:basic_at_put_((self),"@handlers",(self):eventTableCreate()))
end)));
end
)
,"events","eventTableForEdit\r\n\t\" Private - Return the mapping event names to actions of the receiver.\r\n\tSet the internal map if not present.\r\n\t\"\r\n\r\n\t^self basicAt: '@handlers' ifAbsent: [\r\n\t\tself basicAt: '@handlers' put: self eventTableCreate\r\n\t]","(\r\nfunction(self)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),\"@handlers\",(function()\r\nreturn (smalltalk:basic_at_put_((self),\"@handlers\",(self):eventTableCreate()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"releaseEventTable",0
,(
function(self)
(self):basicDelete_("@handlers");
return (self);
end
)
,"events","releaseEventTable\r\n\t\" Private - Release the event table. \"\r\n\r\n\tself basicDelete: '@handlers'","(\r\nfunction(self)\r\n(self):basicDelete_(\"@handlers\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"release",0
,(
function(self)
(self):releaseEventTable();
return (self);
end
)
,"release","release\r\n\t\" Release the receiver. \"\r\n\r\n\tself releaseEventTable ","(\r\nfunction(self)\r\n(self):releaseEventTable();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"eventTableCreate",0
,(
function(self)
return ((smalltalk.PoolDictionary):new());
end
)
,"events","eventTableCreate\r\n\t\" Private - Return a new mapping for the receiver. \"\r\n\r\n\t^PoolDictionary new","(\r\nfunction(self)\r\nreturn ((smalltalk.PoolDictionary):new());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"canTriggerEvent:",0
,(
function(self,selector)
return (((self)["$klass"]):canTriggerEvent_(selector));
end
)
,"events","canTriggerEvent: selector\r\n\t\" Return true if the receiver can trigger event.\"\r\n\r\n\t^self class canTriggerEvent: selector ","(\r\nfunction(self,selector)\r\nreturn (((self)[\"$klass\"]):canTriggerEvent_(selector));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"invalidEvent:",0
,(
function(self,selector)
return (self);
end
)
,"events","invalidEvent: selector\r\n\t\" Private - Notify the situation where an unknown event is registered.\r\n\tDefault implementation ignore error during unknown event registration.\r\n\t\"\r\n\r\n\t^self\r\n\"DEBUG-\t^self note: self class name,' invalidEvent: ' ,selector asLiteral \"","(\r\nfunction(self,selector)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"when:evaluate:",0
,(
function(self,selector,anAction)
local actions=nil
if not (((self):canTriggerEvent_(selector)))==true then (self):invalidEvent_(selector); end;
(function()
	local _s8_value=((self):actionListForEvent_(selector))
	actions=_s8_value
	return _s8_value
end)();
if ((actions):includes_(anAction))==true then return (self); end;
(self):setActionList_forEvent_((actions):copyWith_(anAction),selector);
return (self);
end
)
,"events","when: selector evaluate: anAction\r\n\t\" Register anAction to the be evaluated when the receiver triggers the event. \"\r\n\r\n\t| actions |\r\n\t(self canTriggerEvent: selector) ifFalse: [ self invalidEvent: selector ].\r\n\tactions := self actionListForEvent: selector.\r\n\t(actions includes: anAction) ifTrue: [ ^self ].\r\n\tself\r\n\t\tsetActionList: (actions copyWith: anAction)\r\n\t\tforEvent: selector","(\r\nfunction(self,selector,anAction)\r\nlocal actions=nil\r\nif not (((self):canTriggerEvent_(selector)))==true then (self):invalidEvent_(selector); end;\r\n(function()\r\n\tlocal _s8_value=((self):actionListForEvent_(selector))\r\n\tactions=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((actions):includes_(anAction))==true then return (self); end;\r\n(self):setActionList_forEvent_((actions):copyWith_(anAction),selector);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"actionListForEvent:",0
,(
function(self,selector)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
(function()
	local _s8_value=(((self):eventTable()):at_ifAbsent_(selector,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.ActionSequence):new())
end
)()
error(_s8Ret_,0)
end)())
end)))
	result=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((result):asActionSequence())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"events","actionListForEvent: selector\r\n\t\" Private - Return a collection of actions to evaluate when the event is triggered. \"\r\n\r\n\t| result |\r\n\tresult := self eventTable at: selector ifAbsent: [ ^ActionSequence new ].\r\n\t^result asActionSequence","(\r\nfunction(self,selector)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):eventTable()):at_ifAbsent_(selector,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.ActionSequence):new())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((result):asActionSequence())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"setActionList:forEvent:",0
,(
function(self,actionSequence,selector)
local action=nil
(function()
	local _s8_value=(((actionSequence):asActionSequence()):reduced())
	action=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((action)))==true then return ((self):removeActionsForEvent_(selector)); end;
((self):eventTableForEdit()):at_put_(selector,action);
return (self);
end
)
,"events","setActionList: actionSequence forEvent: selector\r\n\t\" Private - Set the list of actions to evaluate when the event is triggered by the receiver. \"\r\n\r\n\t| action |\r\n\taction := actionSequence asActionSequence reduced.\r\n\taction isNil ifTrue: [ ^self removeActionsForEvent: selector ].\r\n\tself eventTableForEdit at: selector put: action ","(\r\nfunction(self,actionSequence,selector)\r\nlocal action=nil\r\n(function()\r\n\tlocal _s8_value=(((actionSequence):asActionSequence()):reduced())\r\n\taction=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((action)))==true then return ((self):removeActionsForEvent_(selector)); end;\r\n((self):eventTableForEdit()):at_put_(selector,action);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"removeActionsSatisfying:forEvent:",0
,(
function(self,aBlock,selector)
(self):setActionList_forEvent_((((self):actionListForEvent_(selector)):asArray()):reject_(aBlock),selector);
return (self);
end
)
,"events","removeActionsSatisfying: aBlock forEvent: selector\r\n\t\" Private - Remove all actions for the event that evaluates aBlock to true.\"\r\n\r\n\tself\r\n\t\tsetActionList: ((self actionListForEvent: selector) asArray reject: aBlock)\r\n\t\tforEvent: selector ","(\r\nfunction(self,aBlock,selector)\r\n(self):setActionList_forEvent_((((self):actionListForEvent_(selector)):asArray()):reject_(aBlock),selector);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"removeActionsWithReceiver:forEvent:",0
,(
function(self,anObject,selector)
(self):removeActionsSatisfying_forEvent_((function(each)
return (smalltalk:boolean_and_((smalltalk:responds_to_((each),("receiver"))),(function()
return ((((each):receiver())==anObject))
end)))
end),selector);
return (self);
end
)
,"events","removeActionsWithReceiver: anObject forEvent: selector\r\n\t\" Remove all actions for the event in the receiver's event table which have anObject as receiver. \"\r\n\r\n\tself\r\n\t\tremoveActionsSatisfying: [:each| (each respondsTo: #receiver) and: [ each receiver == anObject ] ]\r\n\t\tforEvent: selector ","(\r\nfunction(self,anObject,selector)\r\n(self):removeActionsSatisfying_forEvent_((function(each)\r\nreturn (smalltalk:boolean_and_((smalltalk:responds_to_((each),(\"receiver\"))),(function()\r\nreturn ((((each):receiver())==anObject))\r\nend)))\r\nend),selector);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"removeAction:forEvent:",0
,(
function(self,anAction,selector)
(self):removeActionsSatisfying_forEvent_((function(each)
return (smalltalk:isObject_equalTo_((each),anAction))
end),selector);
return (self);
end
)
,"events","removeAction: anAction forEvent: selector\r\n\t\" Remove anAction for the event in the receiver's event table which have anObject as receiver. \"\r\n\r\n\tself\r\n\t\tremoveActionsSatisfying: [:each| each = anAction ]\r\n\t\tforEvent: selector ","(\r\nfunction(self,anAction,selector)\r\n(self):removeActionsSatisfying_forEvent_((function(each)\r\nreturn (smalltalk:isObject_equalTo_((each),anAction))\r\nend),selector);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"when:do:",0
,(
function(self,selector,aBlock)
(self):when_evaluate_(selector,aBlock);
return (self);
end
)
,"events","when: selector do: aBlock\r\n\t\" Evaluate aBlock when the receiver triggers the event. \"\r\n\r\n\tself when: selector evaluate: aBlock","(\r\nfunction(self,selector,aBlock)\r\n(self):when_evaluate_(selector,aBlock);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"when:send:to:withArguments:",0
,(
function(self,selector,message,anObject,array)
(self):when_evaluate_(selector,(smalltalk.LinkMessage):receiver_selector_arguments_(anObject,message,array));
return (self);
end
)
,"events","when: selector send: message to: anObject withArguments: array\r\n\t\" Send the message when the receiver triggers the event. \"\r\n\r\n\tself\r\n\t\twhen: selector\r\n\t\tevaluate: (LinkMessage\r\n\t\t\treceiver: anObject\r\n\t\t\tselector: message\r\n\t\t\targuments: array)","(\r\nfunction(self,selector,message,anObject,array)\r\n(self):when_evaluate_(selector,(smalltalk.LinkMessage):receiver_selector_arguments_(anObject,message,array));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"when:send:to:",0
,(
function(self,selector,message,anObject)
(self):when_evaluate_(selector,(smalltalk.Message):receiver_selector_arguments_(anObject,message,(smalltalk.Array):new_((message):argumentCount())));
return (self);
end
)
,"events","when: selector send: message to: anObject\r\n\t\" Send the message when the receiver triggers the event. \"\r\n\r\n\tself\r\n\t\twhen: selector\r\n\t\tevaluate: (Message\r\n\t\t\treceiver: anObject selector: message\r\n\t\t\targuments: (Array new: message argumentCount))","(\r\nfunction(self,selector,message,anObject)\r\n(self):when_evaluate_(selector,(smalltalk.Message):receiver_selector_arguments_(anObject,message,(smalltalk.Array):new_((message):argumentCount())));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"triggerEvent:ifNotHandled:",0
,(
function(self,selector,aBlock)
return ((((self):eventTable()):at_ifAbsent_(selector,(function()
return (aBlock)
end))):evaluate());
end
)
,"events","triggerEvent: selector ifNotHandled: aBlock\r\n\t\" Trigger the event.\r\n\tIf the event is not handled, return the value of evaluating aBlock,\r\n        or the value returned by the most recently defined event handler.\r\n\t\"\r\n\r\n\t^(self eventTable at: selector ifAbsent: [ aBlock ]) evaluate","(\r\nfunction(self,selector,aBlock)\r\nreturn ((((self):eventTable()):at_ifAbsent_(selector,(function()\r\nreturn (aBlock)\r\nend))):evaluate());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"actionForEvent:",0
,(
function(self,selector)
return (((self):eventTable()):at_ifAbsent_(selector,(function()
return (nil)
end)));
end
)
,"events","actionForEvent: selector\r\n\t\" Return the action to evaluate when the event is triggered by the receiver (or nil). \"\r\n\r\n\t^self eventTable at: selector ifAbsent: [ nil ]","(\r\nfunction(self,selector)\r\nreturn (((self):eventTable()):at_ifAbsent_(selector,(function()\r\nreturn (nil)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"triggerEvent:",0
,(
function(self,selector)
return (((self):actionForEvent_(selector)):evaluate());
end
)
,"events","triggerEvent: selector\r\n\t\" Return the result of triggering the event. \"\r\n\r\n\t^(self actionForEvent: selector) evaluate","(\r\nfunction(self,selector)\r\nreturn (((self):actionForEvent_(selector)):evaluate());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"triggerEvent:withArguments:",0
,(
function(self,selector,array)
return (((self):actionForEvent_(selector)):evaluateWithArguments_(array));
end
)
,"events","triggerEvent: selector withArguments: array\r\n\t\" Return the result of triggering the event. \"\r\n\r\n\t^(self actionForEvent: selector) evaluateWithArguments: array","(\r\nfunction(self,selector,array)\r\nreturn (((self):actionForEvent_(selector)):evaluateWithArguments_(array));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"triggerEvent:with:",0
,(
function(self,selector,anObject)
return ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_(anObject)));
end
)
,"events","triggerEvent: selector with: anObject\r\n\t\" Return the result of triggering the event. \"\r\n\r\n\t^self triggerEvent: selector withArguments: (Array with: anObject)","(\r\nfunction(self,selector,anObject)\r\nreturn ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_(anObject)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"triggerEvent:with:with:",0
,(
function(self,selector,anObject,anotherObject)
return ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_with_(anObject,anotherObject)));
end
)
,"events","triggerEvent: selector with: anObject with: anotherObject\r\n\t\" Return the result of triggering the event. \"\r\n\r\n\t^self triggerEvent: selector withArguments: (Array with: anObject with: anotherObject)","(\r\nfunction(self,selector,anObject,anotherObject)\r\nreturn ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_with_(anObject,anotherObject)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"triggerEvent:withArguments:ifNotHandled:",0
,(
function(self,selector,array,aBlock)
return ((((self):eventTable()):at_ifAbsent_(selector,(function()
return (aBlock)
end))):evaluateWithArguments_(array));
end
)
,"events","triggerEvent: selector withArguments: array ifNotHandled: aBlock\r\n\t\" Return the result of triggering the event with the arguments.\r\n\tIf the event is not handled, return the value of evaluating aBlock,\r\n\tor the value returned by the most recently defined event handler action.\r\n\t\"\r\n\r\n\t^(self eventTable at: selector ifAbsent: [ aBlock ]) evaluateWithArguments: array","(\r\nfunction(self,selector,array,aBlock)\r\nreturn ((((self):eventTable()):at_ifAbsent_(selector,(function()\r\nreturn (aBlock)\r\nend))):evaluateWithArguments_(array));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"triggerEvent:with:ifNotHandled:",0
,(
function(self,selector,anObject,aBlock)
return ((self):triggerEvent_withArguments_ifNotHandled_(selector,(smalltalk.Array):with_(anObject),aBlock));
end
)
,"events","triggerEvent: selector with: anObject ifNotHandled: aBlock\r\n\t\" Return the result of triggering the event with anObject. \"\r\n\r\n\t^self triggerEvent: selector withArguments: (Array with: anObject) ifNotHandled: aBlock","(\r\nfunction(self,selector,anObject,aBlock)\r\nreturn ((self):triggerEvent_withArguments_ifNotHandled_(selector,(smalltalk.Array):with_(anObject),aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"hasActionForEvent:",0
,(
function(self,selector)
return (((self):eventTable()):includesKey_(selector));
end
)
,"events","hasActionForEvent: selector\r\n\t\" Return true if the receiver has an action registered for the event. \"\r\n\r\n\t^self eventTable includesKey: selector ","(\r\nfunction(self,selector)\r\nreturn (((self):eventTable()):includesKey_(selector));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"eventsHandled",0
,(
function(self)
return (((self):eventTable()):keys());
end
)
,"events","eventsHandled\r\n\t\" Return the events for which there are actions registered in the receiver. \"\r\n\r\n\t^self eventTable keys","(\r\nfunction(self)\r\nreturn (((self):eventTable()):keys());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"removeAllActionsWithReceiver:",0
,(
function(self,anObject)
(((self):eventTable()):keys()):do_((function(each)
return ((self):removeActionsWithReceiver_forEvent_(anObject,each))
end));
return (self);
end
)
,"events","removeAllActionsWithReceiver: anObject\r\n\t\" Remove all actions for all events in the receiver's event table with anObject as receiver. \"\r\n\r\n\tself eventTable keys do: [:each|self removeActionsWithReceiver: anObject forEvent: each ]","(\r\nfunction(self,anObject)\r\n(((self):eventTable()):keys()):do_((function(each)\r\nreturn ((self):removeActionsWithReceiver_forEvent_(anObject,each))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"removeActionsForEvent:",0
,(
function(self,selector)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local actions=nil
(function()
	local _s8_value=((self):eventTable())
	actions=_s8_value
	return _s8_value
end)();
(actions):removeKey_ifAbsent_(selector,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end));
if ((actions):isEmpty())==true then (self):releaseEventTable(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"events","removeActionsForEvent: selector\r\n\t\" Remove all actions for the event. \"\r\n\r\n\t| actions |\r\n\tactions := self eventTable.\r\n\tactions removeKey: selector ifAbsent: [ ^self ].\r\n\tactions isEmpty ifTrue: [ self releaseEventTable ].","(\r\nfunction(self,selector)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal actions=nil\r\n(function()\r\n\tlocal _s8_value=((self):eventTable())\r\n\tactions=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(actions):removeKey_ifAbsent_(selector,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\nif ((actions):isEmpty())==true then (self):releaseEventTable(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"addDependent:",0
,(
function(self,anObject)
(self):when_send_to_("changed","update",anObject);
return (self);
end
)
,"changes","addDependent: anObject\r\n\t\" Make anObject dependent of the receiver. \"\r\n\r\n\tself when: #changed send: #update to: anObject","(\r\nfunction(self,anObject)\r\n(self):when_send_to_(\"changed\",\"update\",anObject);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"changed",0
,(
function(self)
(self):triggerEvent_("changed");
return (self);
end
)
,"changes","changed\r\n\t\" Update the dependents of the receiver. \"\r\n\r\n\tself triggerEvent: #changed","(\r\nfunction(self)\r\n(self):triggerEvent_(\"changed\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"updateEvent:selector:arguments:",0
,(
function(self,selector,message,array)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local action=nil
(function()
	local _s8_value=(((self):eventTable()):at_ifAbsent_(selector,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end)))
	action=_s8_value
	return _s8_value
end)();
((action):asActionSequence()):evaluateWithSelector_withArguments_(message,array);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"changes","updateEvent: selector selector: message arguments: array\r\n\t\" Private - Trigger the event with the message selector and the arguments. \"\r\n\r\n\t| action |\r\n\taction := self eventTable at: selector ifAbsent: [ ^nil ].\r\n\taction asActionSequence\r\n\t\tevaluateWithSelector: message\r\n\t\twithArguments: array ","(\r\nfunction(self,selector,message,array)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal action=nil\r\n(function()\r\n\tlocal _s8_value=(((self):eventTable()):at_ifAbsent_(selector,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\taction=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((action):asActionSequence()):evaluateWithSelector_withArguments_(message,array);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"changed:",0
,(
function(self,aspect)
(self):updateEvent_selector_arguments_("changed","update:",(smalltalk.Array):with_(aspect));
return (self);
end
)
,"changes","changed: aspect\r\n\t\" Update the dependents on aspect of the receiver. \"\r\n\r\n\tself\tupdateEvent: #changed selector: #update:\r\n\t\targuments: (Array with: aspect)","(\r\nfunction(self,aspect)\r\n(self):updateEvent_selector_arguments_(\"changed\",\"update:\",(smalltalk.Array):with_(aspect));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"changed:with:",0
,(
function(self,aspect,anObject)
(self):updateEvent_selector_arguments_("changed","update:with:",(smalltalk.Array):with_with_(aspect,anObject));
return (self);
end
)
,"changes","changed: aspect with: anObject\r\n\t\" Update the dependents on aspect of the receiver. \"\r\n\r\n\tself\tupdateEvent: #changed selector: #update:with:\r\n\t\targuments: (Array with: aspect with: anObject)","(\r\nfunction(self,aspect,anObject)\r\n(self):updateEvent_selector_arguments_(\"changed\",\"update:with:\",(smalltalk.Array):with_with_(aspect,anObject));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"changed:with:with:",0
,(
function(self,aspect,anObject,anotherObject)
(self):updateEvent_selector_arguments_("changed","update:with:with:",(smalltalk.Array):with_with_with_(aspect,anObject,anotherObject));
return (self);
end
)
,"changes","changed: aspect with: anObject with: anotherObject\r\n\t\" Update the dependents on aspect of the receiver. \"\r\n\r\n\tself\tupdateEvent: #changed selector: #update:with:with:\r\n\t\targuments: (Array with: aspect with: anObject with: anotherObject)","(\r\nfunction(self,aspect,anObject,anotherObject)\r\n(self):updateEvent_selector_arguments_(\"changed\",\"update:with:with:\",(smalltalk.Array):with_with_with_(aspect,anObject,anotherObject));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"dependents",0
,(
function(self)
return (((self):actionListForEvent_("changed")):collect_((function(each)
return ((each):receiver())
end)));
end
)
,"changes","dependents\r\n\t\" Return the dependents of the receiver. \"\r\n\r\n\t^(self actionListForEvent: #changed) collect: [:each | each receiver ]","(\r\nfunction(self)\r\nreturn (((self):actionListForEvent_(\"changed\")):collect_((function(each)\r\nreturn ((each):receiver())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"update:with:",0
,(
function(self,anObject,anotherObject)
return (self);
end
)
,"changes","update: anObject with: anotherObject\r\n\t\" Update the receiver.\r\n\tDefault implementation do nothing.\r\n\tThis method must be refined by subclasses to support change/update protocoll.\r\n\t\"","(\r\nfunction(self,anObject,anotherObject)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"update:",0
,(
function(self,anObject)
return (self);
end
)
,"changes","update: anObject\r\n\t\" Update the receiver.\r\n\tDefault implementation do nothing.\r\n\tThis method must be refined by subclasses to support change/update protocoll.\r\n\t\"","(\r\nfunction(self,anObject)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"printingWith:do:",0
,(
function(self,printing,aBlock)
local old=nil
local result=nil

((function()
(function()
	local _s8_value=((smalltalk.Smalltalk):install_as_(printing,"print"))
	old=_s8_value
	return _s8_value
end)();return ((function()
	local _s8_value=((aBlock):value())
	result=_s8_value
	return _s8_value
end)())
end)):ensure_((function()
return ((smalltalk.Smalltalk):install_as_(old,"print"))
end));
return (result);
end
)
,"printing","printingWith: printing do: aBlock\r\n\t\" Return the result of evaluating aBlock, redirecting output to printing block.\r\n\tNote: native print() will be overwritten with printing block and restored to original after aBlock is evaluated.\r\n\t\"\r\n\r\n\t| old result |\r\n\t{'self' doc'native printing'}.\r\n\t[\told := Smalltalk install: printing as: #print.\r\n\t\tresult := aBlock value.\r\n\t] ensure: [ Smalltalk install: old as: #print ].\r\n\t^result","(\r\nfunction(self,printing,aBlock)\r\nlocal old=nil\r\nlocal result=nil\r\n\r\n((function()\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):install_as_(printing,\"print\"))\r\n\told=_s8_value\r\n\treturn _s8_value\r\nend)();return ((function()\r\n\tlocal _s8_value=((aBlock):value())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):ensure_((function()\r\nreturn ((smalltalk.Smalltalk):install_as_(old,\"print\"))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isParseFailure",0
,(
function(self)
return (false);
end
)
,"Compiler-testing","isParseFailure\r\n\t\" Return true if the receiver is a parse failure. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"asParser",0
,(
function(self)
return ((self):subclassResponsibility_("asParser"));
end
)
,"Compiler-converting","asParser\r\n\t\" Return a parser on the receiver. \"\r\n\r\n\t^self subclassResponsibility: #asParser","(\r\nfunction(self)\r\nreturn ((self):subclassResponsibility_(\"asParser\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"ifUndefined:",0
,(
function(self,aBlock)
return (self);
end
)
,"Compiler-inlines","ifUndefined: aBlock\r\n\t\" Return the receiver or the result of evaluating aBlock if it is undefined.\r\n\tNotes:\t-this message is inlined by compiler (it is not sent)\r\n\t\t-aBlock is evaluated ONLY in case of undefined.\r\n\t\"\r\n\r\n\t^self","(\r\nfunction(self,aBlock)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"orNil",0
,(
function(self)
return (self);
end
)
,"Compiler-inlines","orNil\r\n\t\" Return the receiver or nil.\r\n\tNotes:\t-this message is inlined by compiler (it is not sent)\r\n\t\t-nil, null and undefined returns nil.\r\n\t\"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"accept:",0
,(
function(self,what)
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("[bug] "),smalltalk:asString_((self))))," accept: ")),(what):halt()));
return ((self):error_("#accept: out of control."));
end
)
,"Compiler-parser-bug","accept: what\r\n\t\" Private - Report buggy send by compiler. \"\r\n\r\n\tself note: '[bug] ' ,self asString ,' accept: ' ,what halt.\r\n\t^self error: '#accept: out of control.'","(\r\nfunction(self,what)\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"[bug] \"),smalltalk:asString_((self)))),\" accept: \")),(what):halt()));\r\nreturn ((self):error_(\"#accept: out of control.\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"compilerSupport",0
,(
function(self)
return (((self):smalltalk()):compilerSupport());
end
)
,"Compiler-accessing","compilerSupport\r\n\t\" Return the compiler of the receiver \"\r\n\r\n\t^self smalltalk compilerSupport","(\r\nfunction(self)\r\nreturn (((self):smalltalk()):compilerSupport());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"scanFrom:",0
,(
function(self,aStream)
local chunk=nil
(function()
	local _s8_value=((aStream):nextChunk())
	chunk=_s8_value
	return _s8_value
end)();
if ((chunk):isEmpty())==true then return (nil); end;
return ((chunk):evaluateIn_(self));
end
)
,"Tools-fileIn","scanFrom: aStream\r\n\t\" FileIn - Return the result of evaluating the next chunk of data from aStream.\r\n\tThe method can be refined by chunk readers to support custom fileIn features.\r\n\tMust return the next reader to use for reading remaining contents from aStream.\r\n\t\"\r\n\r\n\t| chunk |\r\n\tchunk := aStream nextChunk.\r\n\tchunk isEmpty ifTrue: [ ^nil ].\r\n\t^chunk evaluateIn: self","(\r\nfunction(self,aStream)\r\nlocal chunk=nil\r\n(function()\r\n\tlocal _s8_value=((aStream):nextChunk())\r\n\tchunk=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((chunk):isEmpty())==true then return (nil); end;\r\nreturn ((chunk):evaluateIn_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"javascriptCodeFollows",0
,(
function(self)
return ((self):nativeCodeFollows());
end
)
,"Tools-fileIn","javascriptCodeFollows\r\n\t\" Obsolete - use #nativeCodeFollows\"\r\n\r\n\t^self nativeCodeFollows","(\r\nfunction(self)\r\nreturn ((self):nativeCodeFollows());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"nativeCodeFollows",0
,(
function(self)
return ((smalltalk.ChunkReader):native());
end
)
,"Tools-fileIn","nativeCodeFollows\r\n\t\" FileIn - FileIn native code on current stream.\r\n\tConsume stream contents upto end of stream evaluating the contents as native code.\r\n\t\"\r\n\r\n\t^ChunkReader native","(\r\nfunction(self)\r\nreturn ((smalltalk.ChunkReader):native());\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"cancelFileIn",0
,(
function(self)
return ((self):ignoreFileInUpTo_(nil));
end
)
,"Tools-fileIn","cancelFileIn\r\n\t\" FileIn - Cancel fileIn on current stream. \"\r\n\r\n\t^self ignoreFileInUpTo: nil","(\r\nfunction(self)\r\nreturn ((self):ignoreFileInUpTo_(nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"ignoreFileInUpTo:",0
,(
function(self,aToken)
return ((smalltalk.SkipFileInReader):upTo_(aToken));
end
)
,"Tools-fileIn","ignoreFileInUpTo: aToken\r\n\t\" FileIn - Ignore fileIn on current stream upto token. \"\r\n\r\n\t^SkipFileInReader upTo: aToken","(\r\nfunction(self,aToken)\r\nreturn ((smalltalk.SkipFileInReader):upTo_(aToken));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"==","_eq_eq"
,(
function(self,anObject)
return (((anObject)==self));
end
)
,"Tools-comparing","== anObject\r\n\t^anObject == self","(\r\nfunction(self,anObject)\r\nreturn (((anObject)==self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"~~","_no_no"
,(
function(self,anObject)
return (((((self)==anObject))==false));
end
)
,"Tools-comparing","~~ anObject\r\n\t^(self == anObject) == false","(\r\nfunction(self,anObject)\r\nreturn (((((self)==anObject))==false));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"isFile:olderThan:",0
,(
function(self,fileName,referenceFileName)

if (smalltalk:isNil_((((smalltalk.Smalltalk):global())["isFileOlderThan"])))==true then return (false); end;
return (isFileOlderThan(fileName,referenceFileName));
end
)
,"Builders-emmiting","isFile: fileName olderThan: referenceFileName\r\n\t\" Private - Return true if the file at pathName is older than file at referenceFileName. \"\r\n\r\n\t{'self'}.\r\n\t(Smalltalk global basicAt: #isFileOlderThan) isNil ifTrue: [ ^false ].\r\n\t^# #isFileOlderThan: fileName with: referenceFileName","(\r\nfunction(self,fileName,referenceFileName)\r\n\r\nif (smalltalk:isNil_((((smalltalk.Smalltalk):global())[\"isFileOlderThan\"])))==true then return (false); end;\r\nreturn (isFileOlderThan(fileName,referenceFileName));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"emmit:startingWith:",0
,(
function(self,fileName,initial)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local output=nil
local nativeFileName=nil
local text=nil
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((fileName),".")),(smalltalk.String):nativeFileExtension()))
	nativeFileName=_s8_value
	return _s8_value
end)();
if ((self):isFile_olderThan_(fileName,nativeFileName))==true then (self):fileInJS_(nativeFileName);
return (fileContents(nativeFileName)); end;
(function()
	local _s8_value=((""):writeStream())
	output=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((initial)))==true then (output):nextPutAll_(initial); end;
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_(("emmit('"),fileName)),"')"));
((function()
(self):printingWith_do_((function(what)
(function()
	local _s8_value=(smalltalk:object_comma_((""),what))
	text=_s8_value
	return _s8_value
end)();return ((
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(text))
end
)(output))
end),(function()
return ((self):fileIn_(fileName))
end));(function()
	local _s8_value=((output):contents())
	text=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_(((((text):size()) > 0)),(function()
return ((text):outputToFile_(nativeFileName))
end),nil))
end)):on_do_(smalltalk.Exception,(function(ex)
local reason=nil
(function()
	local _s8_value=(smalltalk:toString_((ex)))
	reason=_s8_value
	return _s8_value
end)();(((
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(reason))
end
)(output)):contents()):outputToFile_(smalltalk:object_comma_((fileName),".error.txt"));(self):print_(reason);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (reason)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (text)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"Builders-emmiting","emmit: fileName startingWith: initial\r\n\t\" FileIn the contents of file at fileName redirecting output(emmited code) to a native file. \"\r\n\r\n\t| output nativeFileName text |\r\n\tnativeFileName := fileName ,$. ,String nativeFileExtension.\r\n\t(self isFile: fileName olderThan: nativeFileName) ifTrue: [\r\n\t\tself fileInJS: nativeFileName.\r\n\t\t^# #fileContents: nativeFileName\r\n\t].\r\n\toutput := '' writeStream.\r\n\tinitial notNil ifTrue: [ output nextPutAll: initial ].\r\n\tself note: 'emmit(''' ,fileName ,''')'.\r\n[\tself\tprintingWith: [:what|\r\n\t\t\ttext := '' ,what.\r\n\t\t\toutput cr; nextPutAll: text\r\n\t\t] do: [ self fileIn: fileName ].\r\n\ttext := output contents.\r\n\ttext size > 0 ifTrue: [ text outputToFile: nativeFileName ].\r\n]\ton: Exception do: [:ex| | reason |\r\n\treason := ex toString.\r\n\t(output cr; nextPutAll: reason) contents outputToFile: fileName ,'.error.txt'.\r\n\tself print: reason.\r\n\t^reason\r\n].\t^text","(\r\nfunction(self,fileName,initial)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal output=nil\r\nlocal nativeFileName=nil\r\nlocal text=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((fileName),\".\")),(smalltalk.String):nativeFileExtension()))\r\n\tnativeFileName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((self):isFile_olderThan_(fileName,nativeFileName))==true then (self):fileInJS_(nativeFileName);\r\nreturn (fileContents(nativeFileName)); end;\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\toutput=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((initial)))==true then (output):nextPutAll_(initial); end;\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((\"emmit('\"),fileName)),\"')\"));\r\n((function()\r\n(self):printingWith_do_((function(what)\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((\"\"),what))\r\n\ttext=_s8_value\r\n\treturn _s8_value\r\nend)();return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(text))\r\nend\r\n)(output))\r\nend),(function()\r\nreturn ((self):fileIn_(fileName))\r\nend));(function()\r\n\tlocal _s8_value=((output):contents())\r\n\ttext=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_(((((text):size()) > 0)),(function()\r\nreturn ((text):outputToFile_(nativeFileName))\r\nend),nil))\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\nlocal reason=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:toString_((ex)))\r\n\treason=_s8_value\r\n\treturn _s8_value\r\nend)();(((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(reason))\r\nend\r\n)(output)):contents()):outputToFile_(smalltalk:object_comma_((fileName),\".error.txt\"));(self):print_(reason);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (reason)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (text)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"emmit:",0
,(
function(self,fileName)
if not (((fileName):isString()))==true then return (((fileName):asArray()):emmit()); end;
return ((self):emmit_startingWith_(fileName,nil));
end
)
,"Builders-emmiting","emmit: fileName\r\n\t\" FileIn the contents of file at fileName redirecting output(emmited code) to a native file. \"\r\n\r\n\tfileName isString ifFalse: [ ^fileName asArray emmit ].\r\n\t^self emmit: fileName startingWith: nil ","(\r\nfunction(self,fileName)\r\nif not (((fileName):isString()))==true then return (((fileName):asArray()):emmit()); end;\r\nreturn ((self):emmit_startingWith_(fileName,nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"asJS",0
,(
function(self)
return ((smalltalk.NativeHandle):_at(self));
end
)
,"Natives-converting","asJS\r\n\t\" Convert the receiver to JS instance (for reflection). \"\r\n\r\n\t^NativeHandle @ self","(\r\nfunction(self)\r\nreturn ((smalltalk.NativeHandle):_at(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"asNativeHandle",0
,(
function(self)
return ((smalltalk.NativeHandle):_at(self));
end
)
,"Natives-converting","asNativeHandle\r\n\t\" Convert the receiver to NativeHandle instance (for reflection). \"\r\n\r\n\t^NativeHandle @ self","(\r\nfunction(self)\r\nreturn ((smalltalk.NativeHandle):_at(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"handleOf:",0
,(
function(self,nativeObject)
return (smalltalk:if_true_false_((smalltalk:notNil_((nativeObject))),(function()
return (smalltalk:if_true_false_((smalltalk:boolean_and_(((self):isObject_(nativeObject)),(function()
return (smalltalk:notNil_((nativeObject["handle"])))
end))),(function()
return ((nativeObject):handle())
end),(function()
return (nativeObject)
end)))
end),(function()
return ((smalltalk.NativeObject):undefined())
end)));
end
)
,"Natives-converting","handleOf: nativeObject\r\n\t\" Private - Return the handle of nativeObject (or the nativeObject). \"\r\n\r\n\t^nativeObject notNil ifTrue: [\r\n\t\t((self isObject: nativeObject)\r\n\t\tand: [ nativeObject[#handle] notNil ])\r\n\t\tifTrue: [ nativeObject handle ]\r\n\t\tifFalse: [ nativeObject ]\r\n\t] ifFalse: [ NativeObject undefined ]","(\r\nfunction(self,nativeObject)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((nativeObject))),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_(((self):isObject_(nativeObject)),(function()\r\nreturn (smalltalk:notNil_((nativeObject[\"handle\"])))\r\nend))),(function()\r\nreturn ((nativeObject):handle())\r\nend),(function()\r\nreturn (nativeObject)\r\nend)))\r\nend),(function()\r\nreturn ((smalltalk.NativeObject):undefined())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"asLua",0
,(
function(self)
return (smalltalk:asString_((self)));
end
)
,"Lua-lua","asLua\r\n\t\" Return the native representation of the receiver.\r\n\tThe default implementation return the receiver as a String.\r\n\tThis method must be refined by subclasses implementing native literal representation.\r\n\t\"\r\n\r\n\t^self asString","(\r\nfunction(self)\r\nreturn (smalltalk:asString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"__tostring",0
,(
function(self)
return (smalltalk:toString_((self)));
end
)
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","(\r\nfunction(self)\r\nreturn (smalltalk:toString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"fileInOBSOLETE:",0
,(
function(self,fileName)
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_(("fileIn(\""),fileName)),"\");"));
return (fileIn(fileName));
end
)
,"Lua-fileIn","fileInOBSOLETE: fileName\r\n\t\" FileIn contents of file at fileName. \"\r\n\r\n\tself note: 'fileIn(\"', fileName, '\");'.\r\n\t^# #fileIn: fileName","(\r\nfunction(self,fileName)\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((\"fileIn(\\\"\"),fileName)),\"\\\");\"));\r\nreturn (fileIn(fileName));\r\nend\r\n)")
smalltalk:bind(smalltalk.Object,"fileInJSOBSOLETE:",0
,(
function(self,fileName)
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_(("fileInJS(\""),fileName)),"\");"));
return (fileInJS(fileName));
end
)
,"Lua-fileIn","fileInJSOBSOLETE: fileName\r\n\t\" Load native code from file at fileName. \"\r\n\r\n\tself note: 'fileInJS(\"', fileName, '\");'.\r\n\t^# #fileInJS: fileName","(\r\nfunction(self,fileName)\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((\"fileInJS(\\\"\"),fileName)),\"\\\");\"));\r\nreturn (fileInJS(fileName));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"current",0
,(
function(self)
return (smalltalk);
end
)
,"accessing","current\r\n\t\" Return the current instance of the receiver. \"\r\n\r\n\t^#{smalltalk} ","(\r\nfunction(self)\r\nreturn (smalltalk);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"at:ifAbsent:",0
,(
function(self,aGlobalName,aBlock)
return (smalltalk:basic_at_ifAbsent_(((self):current()),aGlobalName,aBlock));
end
)
,"accessing","at: aGlobalName ifAbsent: aBlock\r\n\t\" Return the global known as aGlobalName in the receiver or the result of evaluating aBlock. \"\r\n\r\n\t^self current basicAt: aGlobalName ifAbsent: aBlock","(\r\nfunction(self,aGlobalName,aBlock)\r\nreturn (smalltalk:basic_at_ifAbsent_(((self):current()),aGlobalName,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"includesKey:",0
,(
function(self,aGlobalName)
return (((self):current()):includesKey_(aGlobalName));
end
)
,"testing","includesKey: aGlobalName\r\n\t\" Return true if the global aGlobalName is defined in the receiver. \"\r\n\r\n\t^self current includesKey: aGlobalName","(\r\nfunction(self,aGlobalName)\r\nreturn (((self):current()):includesKey_(aGlobalName));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"at:",0
,(
function(self,aGlobalName)
return (smalltalk:basic_at_ifAbsent_(((self):current()),aGlobalName,(function()
return (nil)
end)));
end
)
,"accessing","at: aGlobalName\r\n\t\" Return the global known as aGlobalName in the receiver (or nil). \"\r\n\r\n\t^self current basicAt: aGlobalName ifAbsent: [ nil ]","(\r\nfunction(self,aGlobalName)\r\nreturn (smalltalk:basic_at_ifAbsent_(((self):current()),aGlobalName,(function()\r\nreturn (nil)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"at:put:",0
,(
function(self,aGlobalName,anObject)
return (smalltalk:basic_at_put_(((self):current()),aGlobalName,anObject));
end
)
,"accessing","at: aGlobalName put: anObject\r\n\t\" Set the global known as aGlobalName in the receiver top anObject. \"\r\n\r\n\t^self current basicAt: aGlobalName put: anObject","(\r\nfunction(self,aGlobalName,anObject)\r\nreturn (smalltalk:basic_at_put_(((self):current()),aGlobalName,anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"at:ifAbsentPut:",0
,(
function(self,aGlobalName,aBlock)
return ((self):at_ifAbsent_(aGlobalName,(function()
return ((self):at_put_(aGlobalName,(aBlock):value()))
end)));
end
)
,"accessing","at: aGlobalName ifAbsentPut: aBlock\r\n\t\" Return the global known as aGlobalName in the receiver or the result of evaluating aBlock.\r\n\tSet the global to return value if was absent.\r\n\t\"\r\n\r\n\t^self at: aGlobalName ifAbsent: [\r\n\t\tself at: aGlobalName put: aBlock value\r\n\t]","(\r\nfunction(self,aGlobalName,aBlock)\r\nreturn ((self):at_ifAbsent_(aGlobalName,(function()\r\nreturn ((self):at_put_(aGlobalName,(aBlock):value()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"removeKey:ifAbsent:",0
,(
function(self,aKey,aBlock)
return (((self):current()):removeKey_ifAbsent_(aKey,aBlock));
end
)
,"removing","removeKey: aKey ifAbsent: aBlock\r\n\t\" Remove the binding at aKey. \"\r\n\r\n\t^self current removeKey: aKey ifAbsent: aBlock","(\r\nfunction(self,aKey,aBlock)\r\nreturn (((self):current()):removeKey_ifAbsent_(aKey,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"@","_at"
,(
function(self,aGlobalName)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local binding=nil
(function()
	local _s8_value=((self):at_ifAbsent_(aGlobalName,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.Array):new())
end
)()
error(_s8Ret_,0)
end)())
end)))
	binding=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.Array):with_(binding))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"accessing","@ aGlobalName\r\n\t\" Return a collection with the objects bound to aGlobalName (or an empty collection if global is not defined).\r\n\tIt is used in expressions like:\r\n\t\tSmalltalk @ #MyGlobal do: [:global| ... ]\r\n\t\"\r\n\r\n\t| binding |\r\n\tbinding := self at: aGlobalName ifAbsent: [ ^Array new ].\r\n\t^Array with: binding","(\r\nfunction(self,aGlobalName)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal binding=nil\r\n(function()\r\n\tlocal _s8_value=((self):at_ifAbsent_(aGlobalName,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.Array):new())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tbinding=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.Array):with_(binding))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"definePool:with:",0
,(
function(self,poolName,tuples)
return (((self):current()):definePool_with_(poolName,tuples));
end
)
,"accessing","definePool: poolName with: tuples\r\n\t\" Define the pool dictionary. \"\r\n\r\n\t^self current definePool: poolName with: tuples","(\r\nfunction(self,poolName,tuples)\r\nreturn (((self):current()):definePool_with_(poolName,tuples));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"poolDictionary:ifAbsent:",0
,(
function(self,aPoolName,aBlock)
return (((self):current()):poolDictionary_ifAbsent_(aPoolName,aBlock));
end
)
,"accessing","poolDictionary: aPoolName ifAbsent: aBlock\r\n\t\" Return the pool dictionary named aPoolName or the result of evaluating aBlock. \"\r\n\r\n\t^self current poolDictionary: aPoolName ifAbsent: aBlock","(\r\nfunction(self,aPoolName,aBlock)\r\nreturn (((self):current()):poolDictionary_ifAbsent_(aPoolName,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"objectAt:ifAbsent:",0
,(
function(self,aName,aBlock)
return (((self):current()):objectAt_ifAbsent_(aName,aBlock));
end
)
,"accessing","objectAt: aName ifAbsent: aBlock\r\n\t\" Return the (global scoped) smalltalk object at aName or the result of evaluating aBlock (if undefined or not an Object instance). \"\r\n\r\n\t^self current objectAt: aName ifAbsent: aBlock","(\r\nfunction(self,aName,aBlock)\r\nreturn (((self):current()):objectAt_ifAbsent_(aName,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"jsObjectAt:ifAbsent:",0
,(
function(self,aName,aBlock)
(self):note_(smalltalk:object_comma_(("OBSOLETE")," - jsObjectAt:ifAbsent: "));
return (((self):current()):nativeObjectAt_ifAbsent_(aName,aBlock));
end
)
,"accessing","jsObjectAt: aName ifAbsent: aBlock\r\n\t\" OBSOLETE - Return the (global) object at aName or the result of evaluating aBlock (if undefined). \"\r\n\r\nself note: #OBSOLETE ,' - jsObjectAt:ifAbsent: '.\r\n\t^self current nativeObjectAt: aName ifAbsent: aBlock","(\r\nfunction(self,aName,aBlock)\r\n(self):note_(smalltalk:object_comma_((\"OBSOLETE\"),\" - jsObjectAt:ifAbsent: \"));\r\nreturn (((self):current()):nativeObjectAt_ifAbsent_(aName,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"jsObjectAt:",0
,(
function(self,aName)
(self):note_(smalltalk:object_comma_(("OBSOLETE")," - jsObjectAt: "));
return ((self):nativeObjectAt_ifAbsent_(aName,(function()
return ((self):error_(smalltalk:object_comma_(("Undefined "),aName)))
end)));
end
)
,"accessing","jsObjectAt: aName\r\n\t\" OBSOLETE - Return the (global) object at aName. \"\r\n\r\nself note: #OBSOLETE ,' - jsObjectAt: '.\r\n\t^self nativeObjectAt: aName ifAbsent: [ self error: 'Undefined ',aName ]","(\r\nfunction(self,aName)\r\n(self):note_(smalltalk:object_comma_((\"OBSOLETE\"),\" - jsObjectAt: \"));\r\nreturn ((self):nativeObjectAt_ifAbsent_(aName,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Undefined \"),aName)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"nativeObjectAt:ifAbsent:",0
,(
function(self,aName,aBlock)
return (((self):current()):nativeObjectAt_ifAbsent_(aName,aBlock));
end
)
,"accessing","nativeObjectAt: aName ifAbsent: aBlock\r\n\t\" Return the (global) object at aName or the result of evaluating aBlock (if undefined). \"\r\n\r\n\t^self current nativeObjectAt: aName ifAbsent: aBlock","(\r\nfunction(self,aName,aBlock)\r\nreturn (((self):current()):nativeObjectAt_ifAbsent_(aName,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"nativeObjectAt:",0
,(
function(self,aName)
return ((self):nativeObjectAt_ifAbsent_(aName,(function()
return ((self):error_(smalltalk:object_comma_(("Undefined "),aName)))
end)));
end
)
,"accessing","nativeObjectAt: aName\r\n\t\" Return the (global) object at aName. \"\r\n\r\n\t^self nativeObjectAt: aName ifAbsent: [ self error: 'Undefined ',aName ]","(\r\nfunction(self,aName)\r\nreturn ((self):nativeObjectAt_ifAbsent_(aName,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Undefined \"),aName)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"global",0
,(
function(self)
return (_G);
end
)
,"accessing","global\r\n\t\" Return the global context object. \"\r\n\r\n\t^{'' doc'get the global context object'}","(\r\nfunction(self)\r\nreturn (_G);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"install:as:",0
,(
function(self,aBlockClosure,functionName)
local old=nil
(function()
	local _s8_value=(((self):global())[functionName])
	old=_s8_value
	return _s8_value
end)();
smalltalk:basic_at_put_(((self):global()),functionName,aBlockClosure);
return (old);
end
)
,"installing","install: aBlockClosure as: functionName\r\n\t\" Install the aBlockClosure as a function in global scope. \"\r\n\r\n\t| old |\r\n\told := self global basicAt: functionName.\r\n\tself global basicAt: functionName put: aBlockClosure.\r\n\t^old","(\r\nfunction(self,aBlockClosure,functionName)\r\nlocal old=nil\r\n(function()\r\n\tlocal _s8_value=(((self):global())[functionName])\r\n\told=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:basic_at_put_(((self):global()),functionName,aBlockClosure);\r\nreturn (old);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"classes",0
,(
function(self)
return (((self):current()):classes());
end
)
,"accessing","classes\r\n\t\" Return the classes defined in current instance. \"\r\n\r\n\t^self current classes","(\r\nfunction(self)\r\nreturn (((self):current()):classes());\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"rootClasses",0
,(
function(self)
return (((self):current()):rootClasses());
end
)
,"accessing","rootClasses\r\n\t\" Return the collection of topLevel classes in the receiver. \"\r\n\r\n\t^self current rootClasses","(\r\nfunction(self)\r\nreturn (((self):current()):rootClasses());\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"implementorsOf:",0
,(
function(self,aSymbol)
return (((self):current()):implementorsOf_(aSymbol));
end
)
,"tools","implementorsOf: aSymbol\r\n\t\" Return the implementors of aSymbol. \"\r\n\r\n\t^self current implementorsOf: aSymbol","(\r\nfunction(self,aSymbol)\r\nreturn (((self):current()):implementorsOf_(aSymbol));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"isRunningOn:",0
,(
function(self,lang)
return (smalltalk:isObject_equalTo_(((self):nativeLanguage()),lang));
end
)
,"environment","isRunningOn: lang\r\n\t\" Private - Return true when running hosted by native lang execution environment. \"\r\n\r\n\t^self nativeLanguage = lang","(\r\nfunction(self,lang)\r\nreturn (smalltalk:isObject_equalTo_(((self):nativeLanguage()),lang));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"gc",0
,(
function(self)
if collectgarbage() then return true end;
return (false);
end
)
,"tools","gc\r\n\t\" Collect garbage. \"\r\n\r\n\t{'' doc'forced full garbage collection'}.\r\n\t^false","(\r\nfunction(self)\r\nif collectgarbage() then return true end;\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"allMethodsDo:",0
,(
function(self,aBlock)
((self):classes()):do_((function(each)
(each):methodsDo_(aBlock);return (((each)["$klass"]):methodsDo_(aBlock))
end));
return (self);
end
)
,"iterating","allMethodsDo: aBlock\r\n\t\" Evaluates aBlock for all the methods in the current instance. \"\r\n\r\n\tself classes do: [:each|\r\n\t\teach methodsDo: aBlock.\r\n\t\teach class methodsDo: aBlock.\r\n\t]","(\r\nfunction(self,aBlock)\r\n((self):classes()):do_((function(each)\r\n(each):methodsDo_(aBlock);return (((each)[\"$klass\"]):methodsDo_(aBlock))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"allSelectorsDo:",0
,(
function(self,aBlock)
local found=nil
(function()
	local _s8_value=((smalltalk.HashedSet):new())
	found=_s8_value
	return _s8_value
end)();
(self):allMethodsDo_((function(mth)
local msg=nil
(function()
	local _s8_value=((mth):selector())
	msg=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_(((found):includes_(msg)),nil,(function()
if (smalltalk:notNil_((aBlock)))==true then (aBlock):value_(msg); end;return ((found):add_(msg))
end)))
end));
return (found);
end
)
,"iterating","allSelectorsDo: aBlock\r\n\t\" Evaluates aBlock for all the selectors defined in the current instance. \"\r\n\r\n\t| found |\r\n\tfound := HashedSet new.\r\n\tself allMethodsDo: [:mth| | msg |\r\n\t\tmsg := mth selector.\r\n\t\t(found includes: msg) ifFalse: [\r\n\t\t\taBlock notNil ifTrue: [\r\n\t\t\t\taBlock value: msg\r\n\t\t\t].\r\n\t\t\tfound add: msg\r\n\t\t]\r\n\t].\r\n\t^found","(\r\nfunction(self,aBlock)\r\nlocal found=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.HashedSet):new())\r\n\tfound=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):allMethodsDo_((function(mth)\r\nlocal msg=nil\r\n(function()\r\n\tlocal _s8_value=((mth):selector())\r\n\tmsg=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_(((found):includes_(msg)),nil,(function()\r\nif (smalltalk:notNil_((aBlock)))==true then (aBlock):value_(msg); end;return ((found):add_(msg))\r\nend)))\r\nend));\r\nreturn (found);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"allSelectors",0
,(
function(self)
return (((self):allSelectorsDo_(nil)):sorted());
end
)
,"iterating","allSelectors\r\n\t\" Return all the selectors (sorted) defined in the current instance. \"\r\n\r\n\t^(self allSelectorsDo: nil) sorted","(\r\nfunction(self)\r\nreturn (((self):allSelectorsDo_(nil)):sorted());\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"bindingsFor:",0
,(
function(self,aScope)
return (((smalltalk.PoolDictionaryReader):new()):scope_(aScope));
end
)
,"Tools-variables","bindingsFor: aScope\r\n\t\" FileIn - Return a reader to fileIn bindings in a (global) scope.\r\n\taScope can be a string or a dictionary.\r\n\tIn case of aScope been a String, it will be considered a PoolDictionaryName\r\n\tSee PoolDictionaryReader>>#scanFrom:\r\n\t\"\r\n\r\n\t^PoolDictionaryReader new scope: aScope","(\r\nfunction(self,aScope)\r\nreturn (((smalltalk.PoolDictionaryReader):new()):scope_(aScope));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"sendersOf:",0
,(
function(self,selector)
return (((self):current()):sendersOf_(selector));
end
)
,"Tools-query","sendersOf: selector\r\n\t\" Return the senders of message selector. \"\r\n\r\n\t^self current sendersOf: selector","(\r\nfunction(self,selector)\r\nreturn (((self):current()):sendersOf_(selector));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"saveImageAs:",0
,(
function(self,fileName)
((self):current()):saveImageAs_(fileName);
return (self);
end
)
,"Snapshot-snapshot","saveImageAs: fileName\r\n\t\" Dump the image contents onto file at fileName. \"\r\n\r\n\tself current saveImageAs: fileName","(\r\nfunction(self,fileName)\r\n((self):current()):saveImageAs_(fileName);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"saveImage",0
,(
function(self)
((self):current()):saveImage();
return (self);
end
)
,"Snapshot-snapshot","saveImage\r\n\t\" Dump the image contents onto image file. \"\r\n\r\n\tself current saveImage","(\r\nfunction(self)\r\n((self):current()):saveImage();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk["$klass"],"exit",0
,(
function(self)
((self):current()):exit();
return (self);
end
)
,"Snapshot-exiting","exit\r\n\t\" Exit to OS system. \"\r\n\r\n\tself current exit","(\r\nfunction(self)\r\n((self):current()):exit();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"globalAt:",0
,(
function(self,aKey)
return ((self)[aKey]);
end
)
,"accessing","globalAt: aKey\r\n\t\" Return the global at aKey (or nil). \"\r\n\r\n\t^self basicAt: aKey","(\r\nfunction(self,aKey)\r\nreturn ((self)[aKey]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"globalAt:ifAbsent:",0
,(
function(self,aKey,aBlock)
return (smalltalk:basic_at_ifAbsent_((self),aKey,aBlock));
end
)
,"accessing","globalAt: aKey ifAbsent: aBlock\r\n\t\" Return the global at aKey (or the result of evaluating aBlock). \"\r\n\r\n\t^self basicAt: aKey ifAbsent: aBlock","(\r\nfunction(self,aKey,aBlock)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),aKey,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"rootClasses",0
,(
function(self)
return (((self):classes()):select_((function(each)
return (smalltalk:isNil_(((each):superclass())))
end)));
end
)
,"accessing","rootClasses\r\n\t\" Return the collection of topLevel classes in the receiver. \"\r\n\r\n\t^self classes select: [:each| each superclass isNil ]","(\r\nfunction(self)\r\nreturn (((self):classes()):select_((function(each)\r\nreturn (smalltalk:isNil_(((each):superclass())))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"at:",0
,(
function(self,aGlobalName)
return (smalltalk:basic_at_ifAbsent_((self),aGlobalName,(function()
return (nil)
end)));
end
)
,"accessing","at: aGlobalName\r\n\t\" Return the global known as aGlobalName in the receiver (or nil). \"\r\n\r\n\t^self basicAt: aGlobalName ifAbsent: [ nil ]","(\r\nfunction(self,aGlobalName)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),aGlobalName,(function()\r\nreturn (nil)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"at:ifAbsent:",0
,(
function(self,aGlobalName,aBlock)
return (smalltalk:basic_at_ifAbsent_((self),aGlobalName,aBlock));
end
)
,"accessing","at: aGlobalName ifAbsent: aBlock\r\n\t\" Return the value at aKey or the result of evaluating aBlock. \"\r\n\r\n\t^self basicAt: aGlobalName ifAbsent: aBlock","(\r\nfunction(self,aGlobalName,aBlock)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),aGlobalName,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"at:ifAbsentPut:",0
,(
function(self,aGlobalName,aBlock)
return ((self):basicAt_ifAbsentPut_(aGlobalName,aBlock));
end
)
,"accessing","at: aGlobalName ifAbsentPut: aBlock\r\n\t\" Return the global known as aGlobalName in the receiver or the result of evaluating aBlock.\r\n\tSet the global to return value if was absent.\r\n\t\"\r\n\r\n\t^self basicAt: aGlobalName ifAbsentPut: aBlock","(\r\nfunction(self,aGlobalName,aBlock)\r\nreturn ((self):basicAt_ifAbsentPut_(aGlobalName,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"at:put:",0
,(
function(self,aGlobalName,anObject)
return (smalltalk:basic_at_put_((self),aGlobalName,anObject));
end
)
,"accessing","at: aGlobalName put: anObject\r\n\t\" Set the global known as aGlobalName in the receiver top anObject. \"\r\n\r\n\t^self basicAt: aGlobalName put: anObject","(\r\nfunction(self,aGlobalName,anObject)\r\nreturn (smalltalk:basic_at_put_((self),aGlobalName,anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"includesKey:",0
,(
function(self,aGlobalName)
local none=nil
(function()
	local _s8_value=({})
	none=_s8_value
	return _s8_value
end)();
return (smalltalk:booleanNot_((((smalltalk:basic_at_ifAbsent_((self),aGlobalName,(function()
return (none)
end)))==none))));
end
)
,"testing","includesKey: aGlobalName\r\n\t\" Return true if the global aGlobalName is defined in the receiver. \"\r\n\r\n\t| none |\r\n\tnone := {'' doc'absence sentinel'}.\r\n\t^((self\r\n\t\tbasicAt: aGlobalName ifAbsent: [none])\r\n\t\t== none) not","(\r\nfunction(self,aGlobalName)\r\nlocal none=nil\r\n(function()\r\n\tlocal _s8_value=({})\r\n\tnone=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:booleanNot_((((smalltalk:basic_at_ifAbsent_((self),aGlobalName,(function()\r\nreturn (none)\r\nend)))==none))));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"implementorsOf:",0
,(
function(self,aSymbol)
local result=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
((self):rootClasses()):do_((function(each)
return ((result):addAll_((each):implementorsOf_(aSymbol)))
end));
return (result);
end
)
,"accessing","implementorsOf: aSymbol\r\n\t\" Return the implementors of aSymbol. \"\r\n\r\n\t| result |\r\n\tresult := #().\r\n\tself rootClasses do: [:each|\r\n\t\tresult addAll: (each implementorsOf: aSymbol)\r\n\t].\r\n\t^result","(\r\nfunction(self,aSymbol)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):rootClasses()):do_((function(each)\r\nreturn ((result):addAll_((each):implementorsOf_(aSymbol)))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"objectAt:ifAbsent:",0
,(
function(self,aName,aBlock)
local result=nil
(function()
	local _s8_value=((self):nativeObjectAt_ifAbsent_(aName,aBlock))
	result=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((result["yourself"]))),(function()
return (result)
end),nil));
end
)
,"accessing","objectAt: aName ifAbsent: aBlock\r\n\t\" Return the (global scoped) smalltalk object at aName or the result of evaluating aBlock (if undefined or not an Object instance). \"\r\n\r\n\t| result |\r\n\tresult := self nativeObjectAt: aName ifAbsent: aBlock.\r\n\t^result#yourself notNil ifTrue: [ result ]","(\r\nfunction(self,aName,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):nativeObjectAt_ifAbsent_(aName,aBlock))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((result[\"yourself\"]))),(function()\r\nreturn (result)\r\nend),nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"jsObjectAt:ifAbsent:",0
,(
function(self,aName,aBlock)
(self):note_(smalltalk:object_comma_(("OBSOLETE")," - jsObjectAt:ifAbsent: "));
return ((self):nativeObjectAt_ifAbsent_(aName,aBlock));
end
)
,"accessing","jsObjectAt: aName ifAbsent: aBlock\r\n\t\" OBSOLETE - Return the (global) object at aName or the result of evaluating aBlock (if undefined). \"\r\n\r\nself note: #OBSOLETE ,' - jsObjectAt:ifAbsent: '.\r\n\t^self nativeObjectAt: aName ifAbsent: aBlock","(\r\nfunction(self,aName,aBlock)\r\n(self):note_(smalltalk:object_comma_((\"OBSOLETE\"),\" - jsObjectAt:ifAbsent: \"));\r\nreturn ((self):nativeObjectAt_ifAbsent_(aName,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"jsObjectAt:",0
,(
function(self,aName)
(self):note_(smalltalk:object_comma_(("OBSOLETE")," - jsObjectAt: "));
return ((self):nativeObjectAt_ifAbsent_(aName,(function()
return ((self):error_(smalltalk:object_comma_(("Undefined "),aName)))
end)));
end
)
,"accessing","jsObjectAt: aName\r\n\t\" OBSOLETE - Return the (global) object at aName. \"\r\n\r\nself note: #OBSOLETE ,' - jsObjectAt: '.\r\n\t^self nativeObjectAt: aName ifAbsent: [ self error: 'Undefined ',aName ]","(\r\nfunction(self,aName)\r\n(self):note_(smalltalk:object_comma_((\"OBSOLETE\"),\" - jsObjectAt: \"));\r\nreturn ((self):nativeObjectAt_ifAbsent_(aName,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Undefined \"),aName)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"nativeObjectAt:ifAbsent:",0
,(
function(self,aName,aBlock)
return (smalltalk:basic_at_ifAbsent_(((smalltalk.Smalltalk):global()),aName,aBlock));
end
)
,"accessing","nativeObjectAt: aName ifAbsent: aBlock\r\n\t\" Return the (global) object at aName or the result of evaluating aBlock (if undefined). \"\r\n\r\n\t^Smalltalk global basicAt: aName ifAbsent: aBlock","(\r\nfunction(self,aName,aBlock)\r\nreturn (smalltalk:basic_at_ifAbsent_(((smalltalk.Smalltalk):global()),aName,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"nativeObjectAt:",0
,(
function(self,aName)
return ((self):nativeObjectAt_ifAbsent_(aName,(function()
return ((self):error_(smalltalk:object_comma_(("Undefined "),aName)))
end)));
end
)
,"accessing","nativeObjectAt: aName\r\n\t\" Return the (global) object at aName. \"\r\n\r\n\t^self nativeObjectAt: aName ifAbsent: [ self error: 'Undefined ',aName ]","(\r\nfunction(self,aName)\r\nreturn ((self):nativeObjectAt_ifAbsent_(aName,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Undefined \"),aName)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"removeKey:ifAbsent:",0
,(
function(self,aKey,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
smalltalk:basic_at_ifAbsent_((self),aKey,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):value())
end
)()
error(_s8Ret_,0)
end)())
end));
(self):basicDelete_(aKey);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"removing","removeKey: aKey ifAbsent: aBlock\r\n\t\" Remove the binding at aKey. \"\r\n\r\n\tself basicAt: aKey ifAbsent: [ ^aBlock value ].\r\n\tself basicDelete: aKey","(\r\nfunction(self,aKey,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nsmalltalk:basic_at_ifAbsent_((self),aKey,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(self):basicDelete_(aKey);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"definePool:",0
,(
function(self,poolName)
return ((self):definePool_with_(poolName,(smalltalk.Array):new()));
end
)
,"accessing","definePool: poolName\r\n\t\" Define the pool dictionary (if it is not defined yet). \"\r\n\r\n\t^self definePool: poolName with: Array new","(\r\nfunction(self,poolName)\r\nreturn ((self):definePool_with_(poolName,(smalltalk.Array):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"poolDictionary:ifAbsent:",0
,(
function(self,aPoolName,aBlock)
return (smalltalk:basic_at_ifAbsent_((self),aPoolName,(function()
return ((aBlock):value())
end)));
end
)
,"accessing","poolDictionary: aPoolName ifAbsent: aBlock\r\n\t\" Return the pool dictionary named aPoolName or the result of evaluating aBlock. \"\r\n\r\n\t^self basicAt: aPoolName ifAbsent: [ aBlock value ]","(\r\nfunction(self,aPoolName,aBlock)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),aPoolName,(function()\r\nreturn ((aBlock):value())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"poolDictionary:",0
,(
function(self,aPoolName)
return ((self):poolDictionary_ifAbsent_(aPoolName,(function()
return ((self):definePool_(aPoolName))
end)));
end
)
,"accessing","poolDictionary: aPoolName\r\n\t\" Return the pool dictionary named aPoolName. \"\r\n\r\n\t^self poolDictionary: aPoolName ifAbsent: [\r\n\t\t\"self error: 'Missing Pool dictionary: ',aPoolName. \"\r\n\t\tself definePool: aPoolName\r\n\t]","(\r\nfunction(self,aPoolName)\r\nreturn ((self):poolDictionary_ifAbsent_(aPoolName,(function()\r\nreturn ((self):definePool_(aPoolName))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"printDefinePool:with:",0
,(
function(self,poolName,tuples)
(self):print_(smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk.definePool_with_(\""),poolName)),"\",["));
(tuples):do_((function(tuple)
return (smalltalk:if_true_false_(((tuple):isArray()),(function()
return ((self):print_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("\t["),smalltalk:printString_(((tuple):first())))),",")),((tuple):last()):asNative())),"],")))
end),(function()
return ((self):print_(smalltalk:object_comma_((smalltalk:object_comma_(("\t"),(tuple):asNative())),",")))
end)))
end));
(self):print_("\t]);");
return (self);
end
)
,"compiling","printDefinePool: poolName with: tuples\r\n\t\" DEBUG - Dump definition of the pool dictionary. \"\r\n\r\n\tself print: 'smalltalk.definePool_with_(\"',poolName,'\",['.\r\n\ttuples do: [:tuple|\r\n\t\ttuple isArray ifTrue: [\r\n\t\t\tself print: '\t[',tuple first printString,',',tuple last asNative,'],'\r\n\t\t] ifFalse: [\r\n\t\t\tself print: '\t',tuple asNative ,','\r\n\t\t]\r\n\t].\r\n\tself print: '\t]);'.","(\r\nfunction(self,poolName,tuples)\r\n(self):print_(smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.definePool_with_(\\\"\"),poolName)),\"\\\",[\"));\r\n(tuples):do_((function(tuple)\r\nreturn (smalltalk:if_true_false_(((tuple):isArray()),(function()\r\nreturn ((self):print_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"\\t[\"),smalltalk:printString_(((tuple):first())))),\",\")),((tuple):last()):asNative())),\"],\")))\r\nend),(function()\r\nreturn ((self):print_(smalltalk:object_comma_((smalltalk:object_comma_((\"\\t\"),(tuple):asNative())),\",\")))\r\nend)))\r\nend));\r\n(self):print_(\"\\t]);\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"definePool:with:",0
,(
function(self,poolName,tuples)
local dictionary=nil
local offset=nil
(function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((self),poolName,(function()
return (smalltalk:basic_at_put_((self),poolName,(smalltalk.PoolDictionary):new()))
end)))
	dictionary=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(0)
	offset=_s8_value
	return _s8_value
end)();
(tuples):do_((function(each)
return (smalltalk:if_true_false_(((each):isArray()),(function()
(dictionary):at_put_((each):first(),(each):last());return (smalltalk:if_true_false_((((each):last()):isNumber()),(function()
return ((function()
	local _s8_value=(((each):last()):_plus(1))
	offset=_s8_value
	return _s8_value
end)())
end),nil))
end),(function()
return (smalltalk:if_true_false_(((each):isNumber()),(function()
return ((function()
	local _s8_value=(each)
	offset=_s8_value
	return _s8_value
end)())
end),(function()
(dictionary):at_put_(each,offset);return ((function()
	local _s8_value=((offset):_plus(1))
	offset=_s8_value
	return _s8_value
end)())
end)))
end)))
end));
return (dictionary);
end
)
,"compiling","definePool: poolName with: tuples\r\n\t\" Define the pool dictionary. \"\r\n\r\n\t| dictionary offset |\r\n\tdictionary := self basicAt: poolName ifAbsent: [\r\n\t\tself basicAt: poolName put: PoolDictionary new\r\n\t].\r\n\toffset := 0.\r\n\ttuples do: [:each|\r\n\t\teach isArray ifTrue: [\r\n\t\t\tdictionary at: each first put: each last.\r\n\t\t\teach last isNumber ifTrue: [ offset := each last + 1 ].\r\n\t\t] ifFalse: [\r\n\t\t\teach isNumber ifTrue: [ offset := each ]\r\n\t\t\tifFalse: [\r\n\t\t\t\tdictionary at: each put: offset.\r\n\t\t\t\toffset := offset + 1.\r\n\t\t\t]\r\n\t\t]\r\n\t].\r\n\t^dictionary","(\r\nfunction(self,poolName,tuples)\r\nlocal dictionary=nil\r\nlocal offset=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((self),poolName,(function()\r\nreturn (smalltalk:basic_at_put_((self),poolName,(smalltalk.PoolDictionary):new()))\r\nend)))\r\n\tdictionary=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\toffset=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(tuples):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):isArray()),(function()\r\n(dictionary):at_put_((each):first(),(each):last());return (smalltalk:if_true_false_((((each):last()):isNumber()),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(((each):last()):_plus(1))\r\n\toffset=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),nil))\r\nend),(function()\r\nreturn (smalltalk:if_true_false_(((each):isNumber()),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(each)\r\n\toffset=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),(function()\r\n(dictionary):at_put_(each,offset);return ((function()\r\n\tlocal _s8_value=((offset):_plus(1))\r\n\toffset=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)))\r\nend)))\r\nend));\r\nreturn (dictionary);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"state",0
,(
function(self)
return ((self)["$state"]);
end
)
,"accessing","state\r\n\t\" Return the state of the receiver (or nil). \"\r\n\r\n\t^self basicAt: '$state'","(\r\nfunction(self)\r\nreturn ((self)[\"$state\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"state:",0
,(
function(self,aState)
smalltalk:basic_at_put_((self),"$state",aState);
return (self);
end
)
,"accessing","state: aState\r\n\t\" Set the state of the receiver. \"\r\n\r\n\tself basicAt: '$state' put: aState","(\r\nfunction(self,aState)\r\nsmalltalk:basic_at_put_((self),\"$state\",aState);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"withState:do:",0
,(
function(self,aState,aBlock)
local old=nil
(function()
	local _s8_value=((self):state())
	old=_s8_value
	return _s8_value
end)();
return (((function()
(self):state_(aState);return ((aBlock):value())
end)):ensure_((function()
return ((self):state_(old))
end)));
end
)
,"accessing","withState: aState do: aBlock\r\n\t\" Set the state of the receiver to aState during execution of aBlock. \"\r\n\r\n\t| old |\r\n\told := self state.\r\n\t^[\tself state: aState.\r\n\t\taBlock value\r\n\t] ensure: [\r\n\t\tself state: old\r\n\t]","(\r\nfunction(self,aState,aBlock)\r\nlocal old=nil\r\n(function()\r\n\tlocal _s8_value=((self):state())\r\n\told=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((function()\r\n(self):state_(aState);return ((aBlock):value())\r\nend)):ensure_((function()\r\nreturn ((self):state_(old))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"@","_at"
,(
function(self,keyOrPath)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
if not (((keyOrPath):isArray()))==true then return (((self)["$klass"]):at_ifAbsent_(keyOrPath,(function()
return (nil)
end))); end;
(function()
	local _s8_value=((keyOrPath):inject_into_(self,(function(pool,key)
local value=nil
if (smalltalk:isNil_((((function()
	local _s8_value=((pool):_at(key))
	value=_s8_value
	return _s8_value
end)()))))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)(); end;return (value)
end)))
	result=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"accessing","@ keyOrPath\r\n\t\" Return the result of accessing the receiver at key or path (or nil). \"\r\n\r\n\t| result |\r\n\tkeyOrPath isArray ifFalse: [ ^self class at: keyOrPath ifAbsent: [] ].\r\n\tresult := keyOrPath inject: self into: [:pool :key | | value |\r\n\t\t(value := pool @ key) isNil ifTrue: [ ^nil ].\r\n\t\tvalue\r\n\t].\r\n\t^result","(\r\nfunction(self,keyOrPath)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\nif not (((keyOrPath):isArray()))==true then return (((self)[\"$klass\"]):at_ifAbsent_(keyOrPath,(function()\r\nreturn (nil)\r\nend))); end;\r\n(function()\r\n\tlocal _s8_value=((keyOrPath):inject_into_(self,(function(pool,key)\r\nlocal value=nil\r\nif (smalltalk:isNil_((((function()\r\n\tlocal _s8_value=((pool):_at(key))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)()))))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return (value)\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"eval:",0
,(
function(self,anExpression)

	-- (req v5.3) local fn,err  = load(anExpression)
	function f() local r = anExpression; anExpression= ""; return r end -- (req v5.1)
	local fn,err  = load(f)
	if fn then return fn() else
		self:note_(" eval: Error "..err) --the expression must be a lua expression (including return)
		self:note_(" expression= "..anExpression)
		return nil
	end;
return (self);
end
)
,"eval","eval: anExpression\r\n\t\" Return the result of evaluating a native expression in global context. \"\r\n\r\n\t{'' doc'Native evaluation hook'}","(\r\nfunction(self,anExpression)\r\n\r\n\t-- (req v5.3) local fn,err  = load(anExpression)\r\n\tfunction f() local r = anExpression; anExpression= \"\"; return r end -- (req v5.1)\r\n\tlocal fn,err  = load(f)\r\n\tif fn then return fn() else\r\n\t\tself:note_(\" eval: Error \"..err) --the expression must be a lua expression (including return)\r\n\t\tself:note_(\" expression= \"..anExpression)\r\n\t\treturn nil\r\n\tend;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"eval:as:",0
,(
function(self,anExpression,aState)
return ((self):withState_do_(aState,(function()
return ((self):eval_(anExpression))
end)));
end
)
,"eval","eval: anExpression as: aState\r\n\t\" Return the result of evaluating a native expression in global context.\r\n\tThe state of the system change to state while evaluating the expression.\r\n\t\"\r\n\r\n\t^self withState: aState do: [ self eval: anExpression ]","(\r\nfunction(self,anExpression,aState)\r\nreturn ((self):withState_do_(aState,(function()\r\nreturn ((self):eval_(anExpression))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"capture:with:",0
,(
function(self,keyOrPath,aBlock)
if (smalltalk:isNil_((aBlock)))==true then return ((self):capture_with_(keyOrPath,(function(result)
return (result)
end))); end;
if (smalltalk:isNil_((keyOrPath)))==true then return ((aBlock):evaluateWith_(nil)); end;
if not (((keyOrPath):isString()))==true then return ((self):_at(keyOrPath)); end;
if ((keyOrPath):startsWith_("!"))==true then return ((aBlock):evaluateWith_((keyOrPath):fileIn())); end;
if ((keyOrPath):startsWith_("@"))==true then return ((self):_at((keyOrPath):asArrayOfSubstringsSeparatedBy_("@"))); end;
if ((keyOrPath):startsWith_("."))==true then return ((self):_at((keyOrPath):asArrayOfSubstringsSeparatedBy_("."))); end;
if not ((smalltalk:responds_to_((self),(keyOrPath))))==true then return ((aBlock):evaluateWith_(nil)); end;
if (smalltalk:isObject_equalTo_(((keyOrPath):argumentCount()),1))==true then return ((self):perform_with_(keyOrPath,aBlock)); end;
return ((aBlock):evaluateWith_((self):perform_(keyOrPath)));
end
)
,"tools","capture: keyOrPath with: aBlock\r\n\t\" Capture keyOrPath of the receiver and evaluate aBlock.\r\n\tDefault action will try to capture the object found and (potentially) evaluate aBlock with the result. \"\r\n\r\n\taBlock isNil ifTrue: [ ^self capture: keyOrPath with: [:result | result ] ].\r\n\tkeyOrPath isNil ifTrue: [ ^aBlock evaluateWith: nil ].\r\n\tkeyOrPath isString ifFalse: [ ^self @ keyOrPath ].\r\n\t(keyOrPath startsWith: $!) ifTrue: [ ^aBlock evaluateWith: keyOrPath fileIn ].\r\n\t(keyOrPath startsWith: $@) ifTrue: [ ^self @ (keyOrPath asArrayOfSubstringsSeparatedBy: $@) ].\r\n\t(keyOrPath startsWith: $.) ifTrue: [ ^self @ (keyOrPath asArrayOfSubstringsSeparatedBy: $.) ].\r\n\t(self respondsTo: keyOrPath) ifFalse: [ ^aBlock evaluateWith: nil ].\r\n\tkeyOrPath argumentCount = 1 ifTrue: [ ^self perform: keyOrPath with: aBlock ].\r\n\t^aBlock evaluateWith: (self perform: keyOrPath)","(\r\nfunction(self,keyOrPath,aBlock)\r\nif (smalltalk:isNil_((aBlock)))==true then return ((self):capture_with_(keyOrPath,(function(result)\r\nreturn (result)\r\nend))); end;\r\nif (smalltalk:isNil_((keyOrPath)))==true then return ((aBlock):evaluateWith_(nil)); end;\r\nif not (((keyOrPath):isString()))==true then return ((self):_at(keyOrPath)); end;\r\nif ((keyOrPath):startsWith_(\"!\"))==true then return ((aBlock):evaluateWith_((keyOrPath):fileIn())); end;\r\nif ((keyOrPath):startsWith_(\"@\"))==true then return ((self):_at((keyOrPath):asArrayOfSubstringsSeparatedBy_(\"@\"))); end;\r\nif ((keyOrPath):startsWith_(\".\"))==true then return ((self):_at((keyOrPath):asArrayOfSubstringsSeparatedBy_(\".\"))); end;\r\nif not ((smalltalk:responds_to_((self),(keyOrPath))))==true then return ((aBlock):evaluateWith_(nil)); end;\r\nif (smalltalk:isObject_equalTo_(((keyOrPath):argumentCount()),1))==true then return ((self):perform_with_(keyOrPath,aBlock)); end;\r\nreturn ((aBlock):evaluateWith_((self):perform_(keyOrPath)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"removeSources",0
,(
function(self)
((self):classes()):do_((function(each)
return ((each):removeSources())
end));
return (self);
end
)
,"tools","removeSources\r\n\t\" Remove all development sources of the receiver. \"\r\n\r\n\tself classes do: [:each | each removeSources ]","(\r\nfunction(self)\r\n((self):classes()):do_((function(each)\r\nreturn ((each):removeSources())\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"readJSON:",0
,(
function(self,anObject)
return ((self):readJSObject(anObject));
end
)
,"json","readJSON: anObject\r\n\t\" Return an object read from JSON map object anObject. \"\r\n\r\n\t^self #readJSObject: anObject","(\r\nfunction(self,anObject)\r\nreturn ((self):readJSObject(anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"shallowCopy",0
,(
function(self)
return (self);
end
)
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"deepCopy",0
,(
function(self)
return (self);
end
)
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"recompileAll",0
,(
function(self)
((self):classes()):do_((function(each)
return ((each):recompile())
end));
return (self);
end
)
,"Compiler-compiling","recompileAll\r\n\t\" Recompile all classes in the receiver. \"\r\n\r\n\tself classes do: [:each | each recompile ]","(\r\nfunction(self)\r\n((self):classes()):do_((function(each)\r\nreturn ((each):recompile())\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"compilerSupport",0
,(
function(self)
return (smalltalk.Compiler);
end
)
,"Compiler-accessing","compilerSupport\r\n\t\" Return the compiler support for the receiver. \"\r\n\r\n\t^Compiler","(\r\nfunction(self)\r\nreturn (smalltalk.Compiler);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"fileInCode:",0
,(
function(self,code)
return (smalltalk:if_true_false_((smalltalk:notNil_((code))),(function()
return (((code):stream()):fileIn())
end),nil));
end
)
,"Tools-fileIn","fileInCode: code\r\n\t\" FileIn the code into the receiver. \"\r\n\r\n\t^code notNil ifTrue: [ code stream fileIn ]","(\r\nfunction(self,code)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((code))),(function()\r\nreturn (((code):stream()):fileIn())\r\nend),nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"methodReferences",0
,(
function(self)
return ((smalltalk.MethodReferences):new());
end
)
,"Tools-accessing","methodReferences\r\n\t\" Return the methodReferences tool of the receiver. \"\r\n\r\n\t^MethodReferences new","(\r\nfunction(self)\r\nreturn ((smalltalk.MethodReferences):new());\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"sendersOf:",0
,(
function(self,selector)
return (((self):methodReferences()):sendersOf_(selector));
end
)
,"Tools-query","sendersOf: selector\r\n\t\" Return the senders of message selector. \"\r\n\r\n\t^self methodReferences sendersOf: selector","(\r\nfunction(self,selector)\r\nreturn (((self):methodReferences()):sendersOf_(selector));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"implementorsDo:",0
,(
function(self,aBlock)
return (((self):classes()):do_((function(each)
return ((each):implementorsDo_(aBlock))
end)));
end
)
,"Tools-iterating","implementorsDo: aBlock\r\n\t\" Evaluates aBlock for each implementor in the receiver. \"\r\n\r\n\t^self classes do: [:each| each implementorsDo: aBlock ]","(\r\nfunction(self,aBlock)\r\nreturn (((self):classes()):do_((function(each)\r\nreturn ((each):implementorsDo_(aBlock))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"implementors",0
,(
function(self)
local result=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
(self):implementorsDo_((function(each)
return ((result):add_(each))
end));
return (result);
end
)
,"Tools-implementors","implementors\r\n\t\" Return a collection with all implementors in the receiver. \"\r\n\r\n\t| result |\r\n\tresult := #().\r\n\tself implementorsDo: [:each| result add: each].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):implementorsDo_((function(each)\r\nreturn ((result):add_(each))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"exit",0
,(
function(self)
((self):classes()):do_((function(each)
return ((each):aboutToExit_(self))
end));
quit();
return (self);
end
)
,"Snapshot-exiting","exit\r\n\t\" Exit to OS system. \"\r\n\r\n\tself classes do: [:each| each aboutToExit: self ].\r\n\t{'' doc'quit to OS'}.","(\r\nfunction(self)\r\n((self):classes()):do_((function(each)\r\nreturn ((each):aboutToExit_(self))\r\nend));\r\nquit();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"product",0
,(
function(self)
return ("S8");
end
)
,"Snapshot-accessing","product\r\n\t\" Private - Return the name of the system. \"\r\n\r\n\t^#S8","(\r\nfunction(self)\r\nreturn (\"S8\");\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"description",0
,(
function(self)
return ("A modern Smalltalk environment running on the \"invisible machine\".");
end
)
,"Snapshot-accessing","description\r\n\t\" Return the description of the receiver. \"\r\n\r\n\t^'A modern Smalltalk environment running on the \"invisible machine\".'","(\r\nfunction(self)\r\nreturn (\"A modern Smalltalk environment running on the \\\"invisible machine\\\".\");\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"licenseComment",0
,(
function(self)
return ("\r\nThe text you are reading here is the residue of something that has run before.\r\nKeep the system running with responsibility. Smalltalk is not the words,\r\n nor any definition, nor it current contents...\r\nSmalltalk include your feelings when you see it running.\r\nSmalltalk is what happens when time flows and you \"are\" here.\r\nStop reading/writing code (thinking you are outside the system),\r\n change your world with responsibility, one object at a time, with your hands,\r\n during all your life, in family.\r\n");
end
)
,"Snapshot-license","licenseComment\r\n\t\" Private - Comment note about license of this product. \"\r\n\r\n\t^'\r\nThe text you are reading here is the residue of something that has run before.\r\nKeep the system running with responsibility. Smalltalk is not the words,\r\n nor any definition, nor it current contents...\r\nSmalltalk include your feelings when you see it running.\r\nSmalltalk is what happens when time flows and you \"are\" here.\r\nStop reading/writing code (thinking you are outside the system),\r\n change your world with responsibility, one object at a time, with your hands,\r\n during all your life, in family.\r\n'","(\r\nfunction(self)\r\nreturn (\"\\r\\nThe text you are reading here is the residue of something that has run before.\\r\\nKeep the system running with responsibility. Smalltalk is not the words,\\r\\n nor any definition, nor it current contents...\\r\\nSmalltalk include your feelings when you see it running.\\r\\nSmalltalk is what happens when time flows and you \\\"are\\\" here.\\r\\nStop reading/writing code (thinking you are outside the system),\\r\\n change your world with responsibility, one object at a time, with your hands,\\r\\n during all your life, in family.\\r\\n\");\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"licenseTerms",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):product())," - ")),(self):description())),"\r\n")),(self):licenseMoreHolders())),"\r\n")),(self):licenseHolders())),"\r\nPermission is hereby granted, free of charge, to any person obtaining\r\n a copy of this software and associated documentation files (the \"Software\"),\r\n to deal in the Software without restriction, including without limitation\r\n the rights to use, copy, modify, merge, publish, distribute, sublicense,\r\n and/or sell copies of the Software, and to permit persons to whom the\r\n Software is furnished to do so, subject to the following conditions:\r\n\r\nThe above copyright notice and this permission notice shall be included\r\n in all copies or substantial portions of the Software.\r\n\r\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\r\n EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES\r\n OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.\r\n IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY\r\n CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,\r\n TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE\r\n OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\r\n\r\n")),(self):licenseComment()));
end
)
,"Snapshot-license","licenseTerms\r\n\t\" Private - Return the license terms to use this system. \"\r\n\r\n\t^self product ,' - ' ,self description ,'\r\n' ,self licenseMoreHolders ,'\r\n' ,self licenseHolders ,'\r\nPermission is hereby granted, free of charge, to any person obtaining\r\n a copy of this software and associated documentation files (the \"Software\"),\r\n to deal in the Software without restriction, including without limitation\r\n the rights to use, copy, modify, merge, publish, distribute, sublicense,\r\n and/or sell copies of the Software, and to permit persons to whom the\r\n Software is furnished to do so, subject to the following conditions:\r\n\r\nThe above copyright notice and this permission notice shall be included\r\n in all copies or substantial portions of the Software.\r\n\r\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\r\n EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES\r\n OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.\r\n IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY\r\n CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,\r\n TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE\r\n OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\r\n\r\n' ,self licenseComment","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):product()),\" - \")),(self):description())),\"\\r\\n\")),(self):licenseMoreHolders())),\"\\r\\n\")),(self):licenseHolders())),\"\\r\\nPermission is hereby granted, free of charge, to any person obtaining\\r\\n a copy of this software and associated documentation files (the \\\"Software\\\"),\\r\\n to deal in the Software without restriction, including without limitation\\r\\n the rights to use, copy, modify, merge, publish, distribute, sublicense,\\r\\n and/or sell copies of the Software, and to permit persons to whom the\\r\\n Software is furnished to do so, subject to the following conditions:\\r\\n\\r\\nThe above copyright notice and this permission notice shall be included\\r\\n in all copies or substantial portions of the Software.\\r\\n\\r\\nTHE SOFTWARE IS PROVIDED \\\"AS IS\\\", WITHOUT WARRANTY OF ANY KIND,\\r\\n EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES\\r\\n OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.\\r\\n IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY\\r\\n CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,\\r\\n TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE\\r\\n OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\\r\\n\\r\\n\")),(self):licenseComment()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"licenseYear",0
,(
function(self)
return (((function()
return (smalltalk:toString_((((smalltalk.DateTime):today()):year())))
end)):on_do_(smalltalk.Exception,(function()
return ("today")
end)));
end
)
,"Snapshot-license","licenseYear\r\n\t\" Private - Return the year license information. \"\r\n\r\n\t^[ DateTime today year toString\r\n\t] on: Exception do: [ #today ] ","(\r\nfunction(self)\r\nreturn (((function()\r\nreturn (smalltalk:toString_((((smalltalk.DateTime):today()):year())))\r\nend)):on_do_(smalltalk.Exception,(function()\r\nreturn (\"today\")\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"licenseMoreHolders",0
,(
function(self)
return ("");
end
)
,"Snapshot-license","licenseMoreHolders\r\n\t\" Private - Return additional license holders information. \"\r\n\r\n\t^''","(\r\nfunction(self)\r\nreturn (\"\");\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"licenseHolders",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Copyright (C) "),smalltalk:asString_(((self):licenseYear()))))," ")),"Alejandro F. Reimondo <aleReimondo@smalltalking.net>\r\n\r\nParts of source code written for Jtalk (Sept 2011),\r\nCopyright (C) 2011 by Nicolas Petton <petton.nicolas@gmail.com>\r\nCopyright (C) 2011 Jtalk contributors\r\n\tDavid Graham <dgraham@iphouse.com>\r\n\tGoran Krampe <goran@krampe.se>\r\nAlso code and ideas from Clamato (http://clamato.net), written by Avi Byrant.\r\nThe PetitParser library, published by Lukas Renggli (http://lukas-renggli.ch) and released under the MIT license.\r\nAnd people that contributed to Smalltalk on diverse media years(decades) before this license holders claimed ownership.\r\n"));
end
)
,"Snapshot-license","licenseHolders\r\n\t\" Private - Return the license holders information. \"\r\n\r\n\t^'Copyright (C) '\r\n\t,self licenseYear asString ,' '\r\n\t,'Alejandro F. Reimondo <aleReimondo@smalltalking.net>\r\n\r\nParts of source code written for Jtalk (Sept 2011),\r\nCopyright (C) 2011 by Nicolas Petton <petton.nicolas@gmail.com>\r\nCopyright (C) 2011 Jtalk contributors\r\n\tDavid Graham <dgraham@iphouse.com>\r\n\tGoran Krampe <goran@krampe.se>\r\nAlso code and ideas from Clamato (http://clamato.net), written by Avi Byrant.\r\nThe PetitParser library, published by Lukas Renggli (http://lukas-renggli.ch) and released under the MIT license.\r\nAnd people that contributed to Smalltalk on diverse media years(decades) before this license holders claimed ownership.\r\n'","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Copyright (C) \"),smalltalk:asString_(((self):licenseYear())))),\" \")),\"Alejandro F. Reimondo <aleReimondo@smalltalking.net>\\r\\n\\r\\nParts of source code written for Jtalk (Sept 2011),\\r\\nCopyright (C) 2011 by Nicolas Petton <petton.nicolas@gmail.com>\\r\\nCopyright (C) 2011 Jtalk contributors\\r\\n\\tDavid Graham <dgraham@iphouse.com>\\r\\n\\tGoran Krampe <goran@krampe.se>\\r\\nAlso code and ideas from Clamato (http://clamato.net), written by Avi Byrant.\\r\\nThe PetitParser library, published by Lukas Renggli (http://lukas-renggli.ch) and released under the MIT license.\\r\\nAnd people that contributed to Smalltalk on diverse media years(decades) before this license holders claimed ownership.\\r\\n\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"globalsDo:",0
,(
function(self,aBlock)
return ((self):globalsDo(aBlock));
end
)
,"Snapshot-evaluating","globalsDo: aBlock\r\n\t\" Private - Evaluates aBlock for each globals defined in the receiver. \"\r\n\r\n\t^self #globalsDo: aBlock","(\r\nfunction(self,aBlock)\r\nreturn ((self):globalsDo(aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"globalsDo:separatedBy:",0
,(
function(self,aBlock,anotherBlock)
local first=nil
(function()
	local _s8_value=(true)
	first=_s8_value
	return _s8_value
end)();
return ((self):globalsDo((function(each)
if (first)==true then (function()
	local _s8_value=(false)
	first=_s8_value
	return _s8_value
end)(); else (anotherBlock):value(); end;return ((aBlock):value_(each))
end)));
end
)
,"Snapshot-evaluating","globalsDo: aBlock separatedBy: anotherBlock\r\n\t\" Private - Evaluates aBlock for each globals defined in the receiver. \"\r\n\r\n\t| first | first := true.\r\n\t^self #globalsDo: [:each|\r\n\t    first\r\n\t\tifTrue: [ first := false ]\r\n\t\tifFalse: [ anotherBlock value ].\r\n\t    aBlock value: each\r\n\t]","(\r\nfunction(self,aBlock,anotherBlock)\r\nlocal first=nil\r\n(function()\r\n\tlocal _s8_value=(true)\r\n\tfirst=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):globalsDo((function(each)\r\nif (first)==true then (function()\r\n\tlocal _s8_value=(false)\r\n\tfirst=_s8_value\r\n\treturn _s8_value\r\nend)(); else (anotherBlock):value(); end;return ((aBlock):value_(each))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"saveImageOn:",0
,(
function(self,stream)
local exporter=nil
local allClasses=nil
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(((self):licenseTerms()):asComment());
	return ((_s8_rec):cr())
end
)(stream);
(function()
	local _s8_value=(((((self):rootClasses()):inject_into_(smalltalk:newArray({}),(function(total,each)
(total):addAll_((each):withAllSubclasses());return (total)
end))):collect_((function(each)
return ((each):aboutToSaveImage_on_(self,stream))
end))):select_((function(each)
return (smalltalk:notNil_((each)))
end)))
	allClasses=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.Exporter):new())
	exporter=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):cr();
	(_s8_rec):nextPutAll_(("Smalltalk Classes."):asComment());
	return ((_s8_rec):cr())
end
)(stream);
(exporter):exportClasses_on_(allClasses,stream);
(
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(("Smalltalk Globals set-up."):asComment()))
end
)(stream);
(self):globalsDo_((function(key)
return ((
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),key)),"=")),(exporter):exportObject_((self)[key]))))
end
)(stream))
end));
(allClasses):do_((function(each)
return ((each):imageSaved_on_(self,stream))
end));
return (self);
end
)
,"Snapshot-writing","saveImageOn: stream\r\n\t\" Dump the receiver's contents onto stream. \"\r\n\r\n\t| exporter allClasses |\r\n\tstream nextPutAll: self licenseTerms asComment; cr.\r\n\tallClasses := ((self rootClasses\r\n\t\tinject: #() into: [:total :each| total addAll: each withAllSubclasses. total ])\r\n\t\tcollect: [:each| each aboutToSaveImage: self on: stream ])\r\n\t\tselect: [:each| each notNil ].\r\n\texporter := Exporter new.\r\n\"\tstream nextPutAll: 'Smalltalk Globals (pre)definition.' asComment; cr.\r\n\tself\r\n\t\tglobalsDo: [:key| stream nextPutAll: 'smalltalk.',key ]\r\n\t\tseparatedBy: [ stream nextPutAll: ' , ' ].\r\n\tstream nextPutAll: '=nil'; cr.\r\n\"\tstream cr; nextPutAll: 'Smalltalk Classes.' asComment; cr.\r\n\texporter exportClasses: allClasses on: stream.\r\n\tstream cr; nextPutAll: 'Smalltalk Globals set-up.' asComment.\r\n\tself globalsDo: [:key|\r\n\t\tstream cr; nextPutAll: 'smalltalk.',key,'='\r\n\t\t\t,(exporter exportObject: (self basicAt: key))\r\n\t].\r\n\tallClasses do: [:each| each imageSaved: self on: stream ].","(\r\nfunction(self,stream)\r\nlocal exporter=nil\r\nlocal allClasses=nil\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(((self):licenseTerms()):asComment());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream);\r\n(function()\r\n\tlocal _s8_value=(((((self):rootClasses()):inject_into_(smalltalk:newArray({}),(function(total,each)\r\n(total):addAll_((each):withAllSubclasses());return (total)\r\nend))):collect_((function(each)\r\nreturn ((each):aboutToSaveImage_on_(self,stream))\r\nend))):select_((function(each)\r\nreturn (smalltalk:notNil_((each)))\r\nend)))\r\n\tallClasses=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Exporter):new())\r\n\texporter=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):nextPutAll_((\"Smalltalk Classes.\"):asComment());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream);\r\n(exporter):exportClasses_on_(allClasses,stream);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_((\"Smalltalk Globals set-up.\"):asComment()))\r\nend\r\n)(stream);\r\n(self):globalsDo_((function(key)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),key)),\"=\")),(exporter):exportObject_((self)[key]))))\r\nend\r\n)(stream))\r\nend));\r\n(allClasses):do_((function(each)\r\nreturn ((each):imageSaved_on_(self,stream))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"imageContents",0
,(
function(self)
local stream=nil
(function()
	local _s8_value=(((smalltalk.String):new()):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):saveImageOn_(stream);
return ((stream):contents());
end
)
,"Snapshot-contents","imageContents\r\n\t\" Return a dump of the system contents. \"\r\n\r\n\t| stream |\r\n\tstream := String new writeStream.\r\n\tself saveImageOn: stream.\r\n\t^stream contents","(\r\nfunction(self)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.String):new()):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):saveImageOn_(stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"snapshot",0
,(
function(self)
return ((smalltalk.Snapshot):contents());
end
)
,"Snapshot-contents","snapshot\r\n\t\" Return a system snapshot. \"\r\n\r\n\t^Snapshot contents","(\r\nfunction(self)\r\nreturn ((smalltalk.Snapshot):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"imageFileName",0
,(
function(self)
return ((self)["$imageFileName"]);
end
)
,"Snapshot-fileName","imageFileName\r\n\t\" Return the image file name. \"\r\n\r\n\t^self basicAt: '$imageFileName'","(\r\nfunction(self)\r\nreturn ((self)[\"$imageFileName\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"imageFileName:",0
,(
function(self,fileName)
return (smalltalk:basic_at_put_((self),"$imageFileName",fileName));
end
)
,"Snapshot-fileName","imageFileName: fileName\r\n\t\" Set the image file name. \"\r\n\r\n\t^self basicAt: '$imageFileName' put: fileName","(\r\nfunction(self,fileName)\r\nreturn (smalltalk:basic_at_put_((self),\"$imageFileName\",fileName));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"saveImage",0
,(
function(self)
(self):saveImageAs_((self):imageFileName());
return (self);
end
)
,"Snapshot-save","saveImage\r\n\t\" Dump the image contents onto default image file. \"\r\n\r\n\tself saveImageAs: self imageFileName","(\r\nfunction(self)\r\n(self):saveImageAs_((self):imageFileName());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"saveImageAs:",0
,(
function(self,fileName)
(((smalltalk.String):doItSelector()):implementors()):do_((function(each)
return ((each):removeFromSystem())
end));
((self):imageContents()):outputToFile_(fileName);
(self):imageFileName_(fileName);
return (self);
end
)
,"Snapshot-save","saveImageAs: fileName\r\n\t\" Dump the image contents onto file at fileName. \"\r\n\r\n\tString doItSelector implementors do: [:each| each removeFromSystem ].\r\n\tself imageContents outputToFile: fileName.\r\n\tself imageFileName: fileName.","(\r\nfunction(self,fileName)\r\n(((smalltalk.String):doItSelector()):implementors()):do_((function(each)\r\nreturn ((each):removeFromSystem())\r\nend));\r\n((self):imageContents()):outputToFile_(fileName);\r\n(self):imageFileName_(fileName);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"launch",0
,(
function(self)
((self):classes()):do_((function(each)
return ((each):launch())
end));
return (((smalltalk.Smalltalk):at_ifAbsent_("LaunchExpression",(function()
return (nil)
end))):evaluate());
end
)
,"Snapshot-startup","launch\r\n\t\" The system has been launched and start execution.\r\n\tThe default action is to propagate #launch to current classes and evaluate #LaunchExpression.\r\n\t\"\r\n\r\n\tself classes do: [:each| each launch ].\r\n\t^(Smalltalk at: #LaunchExpression ifAbsent: []) evaluate","(\r\nfunction(self)\r\n((self):classes()):do_((function(each)\r\nreturn ((each):launch())\r\nend));\r\nreturn (((smalltalk.Smalltalk):at_ifAbsent_(\"LaunchExpression\",(function()\r\nreturn (nil)\r\nend))):evaluate());\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"buildString",0
,(
function(self)
return ("Tue Feb 13 2024 07:30:19 GMT-0300");
end
)
,"version","buildString\r\n\t\" Return the birth information of this system. \"\r\n\r\n\t^'Tue Feb 13 2024 07:30:19 GMT-0300'","(\r\nfunction(self)\r\nreturn (\"Tue Feb 13 2024 07:30:19 GMT-0300\");\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"defaultWorkspaceList",0
,(
function(self)
local result=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
if ((smalltalk.Smalltalk):includesKey_("WorkspaceList"))==true then (result):addAll_((smalltalk.Smalltalk):at_("WorkspaceList")); end;
if ((smalltalk.Smalltalk):includesKey_("U8"))==true then (result):addAll_((smalltalk.U8):commonExpressions()); end;
return (result);
end
)
,"platform-tools","defaultWorkspaceList\r\n\t\" Private - Return the (captured) workspace list of the receiver.\r\n\tReturn an array of tuples; each tuple is anArray of the form\r\n\t\t#( title code )\r\n\twhere:\r\n\t\ttitle is aString to be shown as a title of the workspace page.\r\n\t\tcode is the text to be shown as contents of workspace page.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := #().\r\n\t(Smalltalk includesKey: #WorkspaceList) ifTrue: [\r\n\t\tresult addAll: (Smalltalk at: #WorkspaceList)\r\n\t].\r\n\t(Smalltalk includesKey: #U8) ifTrue: [\r\n\t\tresult addAll: U8 commonExpressions\r\n\t].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((smalltalk.Smalltalk):includesKey_(\"WorkspaceList\"))==true then (result):addAll_((smalltalk.Smalltalk):at_(\"WorkspaceList\")); end;\r\nif ((smalltalk.Smalltalk):includesKey_(\"U8\"))==true then (result):addAll_((smalltalk.U8):commonExpressions()); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"workspaceList",0
,(
function(self)
return ((self):defaultWorkspaceList());
end
)
,"platform-tools","workspaceList\r\n\t\" Return the (captured) workspace list of the receiver. \"\r\n\r\n\t^self defaultWorkspaceList","(\r\nfunction(self)\r\nreturn ((self):defaultWorkspaceList());\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"defaultAppList",0
,(
function(self)
local result=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
if ((smalltalk.Smalltalk):includesKey_("AppList"))==true then (result):addAll_((smalltalk.Smalltalk):at_("AppList")); end;
if ((smalltalk.Smalltalk):includesKey_("U8Configuration"))==true then (result):addAll_((smalltalk.U8Configuration):appList()); end;
(result):addAll_((self):allClassMethodsList_(smalltalk:newArray({"sample", "samples"})));
return (result);
end
)
,"platform-tools","defaultAppList\r\n\t\" Private - Return the (captured) apps of the receiver.\r\n\tReturn an array of tuples; each tuple is anArray of the form\r\n\t\t#( title comment code )\r\n\twhere:\r\n\t\ttitle is aString that can include an icon name inside brackets.\r\n\t\tcomment is aString with short description of the app.\r\n\t\tcode is the code to evaluate to open the app.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := #().\r\n\t(Smalltalk includesKey: #AppList) ifTrue: [\r\n\t\tresult addAll: (Smalltalk at: #AppList)\r\n\t].\r\n\t(Smalltalk includesKey: #U8Configuration) ifTrue: [\r\n\t\tresult addAll: U8Configuration appList\r\n\t].\r\n\tresult addAll: (self allClassMethodsList: #(sample samples)).\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((smalltalk.Smalltalk):includesKey_(\"AppList\"))==true then (result):addAll_((smalltalk.Smalltalk):at_(\"AppList\")); end;\r\nif ((smalltalk.Smalltalk):includesKey_(\"U8Configuration\"))==true then (result):addAll_((smalltalk.U8Configuration):appList()); end;\r\n(result):addAll_((self):allClassMethodsList_(smalltalk:newArray({\"sample\", \"samples\"})));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"appList",0
,(
function(self)
return ((self):defaultAppList());
end
)
,"platform-tools","appList\r\n\t\" Return the (captured) apps of the receiver. \"\r\n\r\n\t^self defaultAppList","(\r\nfunction(self)\r\nreturn ((self):defaultAppList());\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"allClassMethodsList:",0
,(
function(self,choices)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
((self):classes()):do_((function(cls)
return (((cls)["$klass"]):methodsDo_((function(mth)
local comment=nil
return (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_((((mth):selector()):argumentCount()),0)),(function()
return (smalltalk:boolean_and_((smalltalk:boolean_or_(((choices):includes_((mth):category())),(function()
return ((choices):includes_((mth):selector()))
end))),(function()
(function()
	local _s8_value=((mth):comment())
	comment=_s8_value
	return _s8_value
end)();return (smalltalk:booleanNot_(((((smalltalk:asString_((comment))):upTo_("-")):asLowercase()):includes_("private"))))
end)))
end))),(function()
local title=nil
local code=nil
(function()
	local _s8_value=((function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((cls):name())," ")),(mth):selector()))
	code=_s8_value
	return _s8_value
end)())
	title=_s8_value
	return _s8_value
end)();return ((result):add_((smalltalk.Array):with_with_with_(title,(comment):upTo_("."),code)))
end),nil))
end)))
end));
return ((result):sorted_((function(a,b)
return ((((a):first()) < (b):first()))
end)));
end
)
,"platform-tools","allClassMethodsList: choices\r\n\t\" Private - Return the list of all (class) methods in the receiver matching choices. \"\r\n\r\n\t| result |\r\n\tresult := Array new.\r\n\tself classes do: [:cls|\r\n\t\tcls class methodsDo: [:mth| | comment |\r\n\t\t\t(mth selector argumentCount = 0 and: [\r\n\t\t\t((choices includes: mth category) or: [\r\n\t\t\t  choices includes: mth selector\r\n\t\t\t]) and: [ comment := mth comment.\r\n\t\t\t ((comment asString upTo: $-) asLowercase includes: #private) not\r\n\t\t\t]]) ifTrue: [ | title code |\r\n\t\t\t\ttitle := code := cls name ,$  ,mth selector.\r\n\t\t\t\tresult add: (Array\r\n\t\t\t\t\twith: title with: (comment upTo: $.)\r\n\t\t\t\t\twith: code)\r\n\t\t\t].\r\n\t\t].\r\n\t].\r\n\t^result sorted: [:a :b| a first < b first ]","(\r\nfunction(self,choices)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):classes()):do_((function(cls)\r\nreturn (((cls)[\"$klass\"]):methodsDo_((function(mth)\r\nlocal comment=nil\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_((((mth):selector()):argumentCount()),0)),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:boolean_or_(((choices):includes_((mth):category())),(function()\r\nreturn ((choices):includes_((mth):selector()))\r\nend))),(function()\r\n(function()\r\n\tlocal _s8_value=((mth):comment())\r\n\tcomment=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:booleanNot_(((((smalltalk:asString_((comment))):upTo_(\"-\")):asLowercase()):includes_(\"private\"))))\r\nend)))\r\nend))),(function()\r\nlocal title=nil\r\nlocal code=nil\r\n(function()\r\n\tlocal _s8_value=((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((cls):name()),\" \")),(mth):selector()))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)())\r\n\ttitle=_s8_value\r\n\treturn _s8_value\r\nend)();return ((result):add_((smalltalk.Array):with_with_with_(title,(comment):upTo_(\".\"),code)))\r\nend),nil))\r\nend)))\r\nend));\r\nreturn ((result):sorted_((function(a,b)\r\nreturn ((((a):first()) < (b):first()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"exampleList",0
,(
function(self)
return ((self):allClassMethodsList_(smalltalk:newArray({"example"})));
end
)
,"platform-tools","exampleList\r\n\t\" Return the (captured) examples of the receiver. \"\r\n\r\n\t^self allClassMethodsList: #(example)","(\r\nfunction(self)\r\nreturn ((self):allClassMethodsList_(smalltalk:newArray({\"example\"})));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"screen:",0
,(
function(self,aBlock)
return ("S8 system running as console application");
end
)
,"platform-tools","screen: aBlock\r\n\t\" Return the (captured) screen of the receiver. \"\r\n\r\n\t^'S8 system running as console application'","(\r\nfunction(self,aBlock)\r\nreturn (\"S8 system running as console application\");\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"fileContentsAt:",0
,(
function(self,pathName)
return (((function()
return ((pathName):fileContents())
end)):on_do_(smalltalk.Exception,(function(ex)
return (nil)
end)));
end
)
,"platform-tools","fileContentsAt: pathName\r\n\t\" Return the contents of file at pathName (or nil). \"\r\n\r\n\t^[ pathName fileContents ] on: Exception do: [:ex| nil ]","(\r\nfunction(self,pathName)\r\nreturn (((function()\r\nreturn ((pathName):fileContents())\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\nreturn (nil)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"output:toFile:",0
,(
function(self,aString,pathName)
return ((aString):outputToFile_(pathName));
end
)
,"platform-tools","output: aString toFile: pathName\r\n\t\" Save aString onto a file at pathName. \"\r\n\r\n\t^aString outputToFile: pathName","(\r\nfunction(self,aString,pathName)\r\nreturn ((aString):outputToFile_(pathName));\r\nend\r\n)")
smalltalk:bind(smalltalk.Smalltalk,"append:toFile:",0
,(
function(self,aString,pathName)
return ((aString):appendToFile_(pathName));
end
)
,"platform-tools","append: aString toFile: pathName\r\n\t\" Append aString onto a file contents at pathName. \"\r\n\r\n\t^aString appendToFile: pathName","(\r\nfunction(self,aString,pathName)\r\nreturn ((aString):appendToFile_(pathName));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"new",0
,(
function(self)
return (((self):basicNew()):initialize());
end
)
,"instantiation","new\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew initialize","(\r\nfunction(self)\r\nreturn (((self):basicNew()):initialize());\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"new:",0
,(
function(self,size)
return ((self):basicNew_(size));
end
)
,"instantiation","new: size\r\n\t\" Return an instance of the receiver of specified size. \"\r\n\r\n\t^self basicNew: size","(\r\nfunction(self,size)\r\nreturn ((self):basicNew_(size));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"basicNew:",0
,(
function(self,size)
return ((self):invalidMessage_("basicNew:"));
end
)
,"instantiation","basicNew: size\r\n\t\" Return an instance of the receiver of specified size. \"\r\n\r\n\t^self invalidMessage: #basicNew:","(\r\nfunction(self,size)\r\nreturn ((self):invalidMessage_(\"basicNew:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"basicNew",0
,(
function(self)
return (self["$fn"]());
end
)
,"instantiation","basicNew\r\n\t\" Return a new (non-initialized) instance of the receiver. \"\r\n\r\n\t^{'' doc'native instantiation of class'}","(\r\nfunction(self)\r\nreturn (self[\"$fn\"]());\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"name",0
,(
function(self)
return ((self)["$className"]);
end
)
,"accessing","name\r\n\t\" Return the name of the receiver. \"\r\n\r\n\t^self basicAt: '$className'","(\r\nfunction(self)\r\nreturn ((self)[\"$className\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"superclass",0
,(
function(self)
return ((self)["$superclass"]);
end
)
,"accessing","superclass\r\n\t\" Return the superclass of the receiver. \"\r\n\r\n\t^self basicAt: '$superclass'","(\r\nfunction(self)\r\nreturn ((self)[\"$superclass\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"subclasses",0
,(
function(self)
return (((self):smalltalk()):subclasses(self));
end
)
,"accessing","subclasses\r\n\t\" Return the subclasses of the receiver. \"\r\n\r\n\t^self smalltalk #subclasses: self","(\r\nfunction(self)\r\nreturn (((self):smalltalk()):subclasses(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"allSubclasses",0
,(
function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(self):allSubclassesDo_((function(each)
return ((result):add_(each))
end));
return (result);
end
)
,"testing","allSubclasses\r\n\t\" Return all the subclasses of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := Array new.\r\n\tself allSubclassesDo: [:each| result add: each ].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):allSubclassesDo_((function(each)\r\nreturn ((result):add_(each))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"allSubclassesDo:",0
,(
function(self,aBlock)
((self):smalltalk()):allSubclassesDo(self,aBlock);
return (self);
end
)
,"testing","allSubclassesDo: aBlock\r\n\t\" Evaluates aBlock with all the subclasses of the receiver. \"\r\n\r\n\tself smalltalk #allSubclassesDo: self value: aBlock","(\r\nfunction(self,aBlock)\r\n((self):smalltalk()):allSubclassesDo(self,aBlock);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"withAllSubclassesDo:",0
,(
function(self,aBlock)
(aBlock):value_(self);
(self):allSubclassesDo_(aBlock);
return (self);
end
)
,"testing","withAllSubclassesDo: aBlock\r\n\t\" Evaluates aBlock with the receiver and all the subclasses. \"\r\n\r\n\taBlock value: self.\r\n\tself allSubclassesDo: aBlock","(\r\nfunction(self,aBlock)\r\n(aBlock):value_(self);\r\n(self):allSubclassesDo_(aBlock);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"withAllSubclasses",0
,(
function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):with_(self))
	result=_s8_value
	return _s8_value
end)();
(self):allSubclassesDo_((function(each)
return ((result):add_(each))
end));
return (result);
end
)
,"accessing","withAllSubclasses\r\n\t\" Return a collection with the receiver and all subclasses. \"\r\n\r\n\t| result |\r\n\tresult := Array with: self.\r\n\tself allSubclassesDo: [:each| result add: each ].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_(self))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):allSubclassesDo_((function(each)\r\nreturn ((result):add_(each))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"allSuperclassesDo:",0
,(
function(self,aBlock)
local current=nil
(function()
	local _s8_value=((self):superclass())
	current=_s8_value
	return _s8_value
end)();
while ((function()
return (smalltalk:notNil_((current)))
end))() do (aBlock):value_(current);
(function()
	local _s8_value=((current):superclass())
	current=_s8_value
	return _s8_value
end)(); end;
return (self);
end
)
,"accessing","allSuperclassesDo: aBlock\r\n\t\" Evaluate aBlock with the superclasses of the receiver.\r\n\tThe superclasses are walked in inverse hierarchical order, i.e class Object is last.\r\n\t\"\r\n\r\n\t| current |\r\n\tcurrent := self superclass.\r\n\t[ current notNil ] whileTrue: [\r\n\t        aBlock value: current.\r\n\t\tcurrent := current superclass.\r\n\t]","(\r\nfunction(self,aBlock)\r\nlocal current=nil\r\n(function()\r\n\tlocal _s8_value=((self):superclass())\r\n\tcurrent=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (smalltalk:notNil_((current)))\r\nend))() do (aBlock):value_(current);\r\n(function()\r\n\tlocal _s8_value=((current):superclass())\r\n\tcurrent=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"withAllSuperclassesDo:",0
,(
function(self,aBlock)
(aBlock):value_(self);
return ((self):allSuperclassesDo_(aBlock));
end
)
,"accessing","withAllSuperclassesDo: aBlock\r\n\t\" Evaluate aBlock with the receiver and it's superclasses.\r\n\tThe superclasses are walked in inverse hierarchical order, i.e class Object is last.\r\n\t\"\r\n\r\n\taBlock value: self.\r\n\t^self allSuperclassesDo: aBlock","(\r\nfunction(self,aBlock)\r\n(aBlock):value_(self);\r\nreturn ((self):allSuperclassesDo_(aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"withAllSuperclasses",0
,(
function(self)
return (smalltalk:object_comma_(((smalltalk.Array):with_(self)),(self):allSuperclasses()));
end
)
,"accessing","withAllSuperclasses\r\n\t\" Return a collection with the receiver and all superclasses. \"\r\n\r\n\t^(Array with: self) , self allSuperclasses","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_(((smalltalk.Array):with_(self)),(self):allSuperclasses()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"allSuperclasses",0
,(
function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(self):allSuperclassesDo_((function(each)
return ((result):add_(each))
end));
return (result);
end
)
,"accessing","allSuperclasses\r\n\t\" Return a collection of all the superclasses of the receiver.\r\n\tThe superclasses are in inverse hierarchical order, i.e class Object is last.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := Array new.\r\n\tself allSuperclassesDo: [:each| result add: each ].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):allSuperclassesDo_((function(each)\r\nreturn ((result):add_(each))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"inheritsFrom:",0
,(
function(self,aClass)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (((self)==aClass))==true then return (true); end;
(self):allSuperclassesDo_((function(each)
return (smalltalk:if_true_false_((((aClass)==each)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"testing","inheritsFrom: aClass\r\n\t\" Return true if the receiver inherits from aClass. \"\r\n\r\n\tself == aClass ifTrue: [ ^true ].\r\n\tself allSuperclassesDo: [:each|\r\n\t\taClass == each ifTrue: [ ^true ]\r\n\t].\r\n\t^false","(\r\nfunction(self,aClass)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (((self)==aClass))==true then return (true); end;\r\n(self):allSuperclassesDo_((function(each)\r\nreturn (smalltalk:if_true_false_((((aClass)==each)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"fn",0
,(
function(self)

return ((self)["$fn"]);
end
)
,"accessing","fn\r\n\t\" Private - Return the internal function of the receiver (or nil). \"\r\n\r\n\t{'self'}.\r\n\t^self basicAt: '$fn' ","(\r\nfunction(self)\r\n\r\nreturn ((self)[\"$fn\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"prototype",0
,(
function(self)

return (((self):fn())["prototype"]);
end
)
,"accessing","prototype\r\n\t\" Private - Return the prototype of the receiver (or nil). \"\r\n\r\n\t{'self'}.\r\n\t^self fn basicAt: #prototype ","(\r\nfunction(self)\r\n\r\nreturn (((self):fn())[\"prototype\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"privateMethods",0
,(
function(self)

return (((self):prototype())["$methods"]);
end
)
,"accessing","privateMethods\r\n\t\" Private, Internal - Return all the methods defined by the receiver. \"\r\n\r\n\t{'self'}.\r\n\t^self prototype basicAt: '$methods' ","(\r\nfunction(self)\r\n\r\nreturn (((self):prototype())[\"$methods\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"constructorName",0
,(
function(self)
local result=nil
local fn=nil
(function()
	local _s8_value=((self):fn())
	fn=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((fn)["name"])
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((result)))==true then if ((result):isEmpty())==true then return (nil); end;
if (smalltalk:isObject_equalTo_((result),"$s8Constructor"))==true then return (nil); end;
return (result); end;
(function()
	local _s8_value=(((smalltalk:toString_((fn))):upTo_("(")):asArrayOfSubstrings())
	result=_s8_value
	return _s8_value
end)();
if not ((smalltalk:isObject_equalTo_(((result):size()),2)))==true then return (nil); end;
return ((result):last());
end
)
,"accessing","constructorName\r\n\t\" Private - Return the name of the constructor of the receiver (or nil). \"\r\n\r\n\t| result fn |\r\n\tfn := self fn.\r\n\tresult := fn basicAt: #name.\r\n\tresult notNil ifTrue: [\r\n\t\tresult isEmpty ifTrue: [ ^nil ].\r\n\t\tresult = '$s8Constructor' ifTrue: [ ^nil ].\r\n\t\t^result\r\n\t].\r\n\tresult := (fn toString upTo: $() asArrayOfSubstrings.\r\n\tresult size = 2 ifFalse: [ ^nil ].\r\n\t^result last","(\r\nfunction(self)\r\nlocal result=nil\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):fn())\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((fn)[\"name\"])\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((result)))==true then if ((result):isEmpty())==true then return (nil); end;\r\nif (smalltalk:isObject_equalTo_((result),\"$s8Constructor\"))==true then return (nil); end;\r\nreturn (result); end;\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:toString_((fn))):upTo_(\"(\")):asArrayOfSubstrings())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:isObject_equalTo_(((result):size()),2)))==true then return (nil); end;\r\nreturn ((result):last());\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"methodDictionary",0
,(
function(self)
return ((smalltalk.PoolDictionary):_at_at((self):privateMethods()));
end
)
,"accessing","methodDictionary\r\n\t\" Return a (pool)dictionary with the methods implemented by the receiver. \"\r\n\r\n\t^PoolDictionary @@ self privateMethods ","(\r\nfunction(self)\r\nreturn ((smalltalk.PoolDictionary):_at_at((self):privateMethods()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"methodsDo:",0
,(
function(self,aBlock)
((self):methodDictionary()):do_((function(mth)
return ((aBlock):value_(mth))
end));
return (self);
end
)
,"accessing","methodsDo: aBlock\r\n\t\" Evaluates aBlock for all the methods defined by the receiver. \"\r\n\r\n\tself methodDictionary do: [:mth| aBlock value: mth ]","(\r\nfunction(self,aBlock)\r\n((self):methodDictionary()):do_((function(mth)\r\nreturn ((aBlock):value_(mth))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"compiledMethods",0
,(
function(self)
return (((self):methodDictionary()):values());
end
)
,"accessing","compiledMethods\r\n\t\" Return a collection with all the methods defined by the receiver. \"\r\n\r\n\t^self methodDictionary values","(\r\nfunction(self)\r\nreturn (((self):methodDictionary()):values());\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"selectorsDo:",0
,(
function(self,aBlock)
return ((((self):methodDictionary()):keys()):do_(aBlock));
end
)
,"accessing","selectorsDo: aBlock\r\n\t\" Evaluate aBlock for all the selectors implemented by the receiver. \"\r\n\r\n\t^self methodDictionary keys do: aBlock ","(\r\nfunction(self,aBlock)\r\nreturn ((((self):methodDictionary()):keys()):do_(aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"selectors",0
,(
function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(self):selectorsDo_((function(each)
return ((result):add_(each))
end));
return (result);
end
)
,"accessing","selectors\r\n\t\" Return the selectors implemented by the receiver. \"\r\n\r\n\t| result |\r\n\tresult := Array new.\r\n\tself selectorsDo: [:each| result add: each ].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):selectorsDo_((function(each)\r\nreturn ((result):add_(each))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"categorizedSelectors",0
,(
function(self)
local pool=nil
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	pool=_s8_value
	return _s8_value
end)();
(self):methodsDo_((function(mth)
local category=nil
(function()
	local _s8_value=((mth):category())
	category=_s8_value
	return _s8_value
end)();if (smalltalk:isNil_((category)))==true then (function()
	local _s8_value=("undefined")
	category=_s8_value
	return _s8_value
end)(); end;return (((pool):at_ifAbsentPut_(category,(function()
return ((smalltalk.Array):new())
end))):add_((mth):selector()))
end));
return ((((pool):keys()):sorted()):collect_((function(key)
return ((smalltalk.Array):with_with_(key,((pool):at_(key)):sorted()))
end)));
end
)
,"accessing","categorizedSelectors\r\n\t\" Return the selectors classified by category. \"\r\n\r\n\t| pool |\r\n\tpool := PoolDictionary new.\r\n\tself methodsDo: [:mth| | category |\r\n\t\tcategory := mth category.\r\n\t\tcategory isNil ifTrue: [ category := #undefined ].\r\n\t\t(pool at: category ifAbsentPut: [Array new]) add: mth selector\r\n\t].\r\n\t^pool keys sorted collect: [:key|\r\n\t\tArray with: key with: (pool at: key) sorted\r\n\t]","(\r\nfunction(self)\r\nlocal pool=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tpool=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):methodsDo_((function(mth)\r\nlocal category=nil\r\n(function()\r\n\tlocal _s8_value=((mth):category())\r\n\tcategory=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isNil_((category)))==true then (function()\r\n\tlocal _s8_value=(\"undefined\")\r\n\tcategory=_s8_value\r\n\treturn _s8_value\r\nend)(); end;return (((pool):at_ifAbsentPut_(category,(function()\r\nreturn ((smalltalk.Array):new())\r\nend))):add_((mth):selector()))\r\nend));\r\nreturn ((((pool):keys()):sorted()):collect_((function(key)\r\nreturn ((smalltalk.Array):with_with_(key,((pool):at_(key)):sorted()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"implements:",0
,(
function(self,aSymbol)
return (((self):methodDictionary()):includesKey_(aSymbol));
end
)
,"testing","implements: aSymbol\r\n\t\" Return true if the receiver implements message aSymbol. \"\r\n\r\n\t^self methodDictionary includesKey: aSymbol ","(\r\nfunction(self,aSymbol)\r\nreturn (((self):methodDictionary()):includesKey_(aSymbol));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"compiledMethodAt:",0
,(
function(self,aSymbol)
return (((self):methodDictionary()):at_ifAbsent_(aSymbol,(function()
return (nil)
end)));
end
)
,"accessing","compiledMethodAt: aSymbol\r\n\t\" Return the compiled method at aSymbol implemented by the receiver (or nil). \"\r\n\r\n\t^self methodDictionary at: aSymbol ifAbsent: [] ","(\r\nfunction(self,aSymbol)\r\nreturn (((self):methodDictionary()):at_ifAbsent_(aSymbol,(function()\r\nreturn (nil)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,">>","_gt_gt"
,(
function(self,aSymbol)
return ((self):compiledMethodAt_(aSymbol));
end
)
,"accessing",">> aSymbol\r\n\t\" Return the method at aSymbol (or nil if not implemented by the receiver). \"\r\n\r\n\t^self compiledMethodAt: aSymbol","(\r\nfunction(self,aSymbol)\r\nreturn ((self):compiledMethodAt_(aSymbol));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"compiledMethodFor:",0
,(
function(self,aSymbol)
local current=nil
local mth=nil
(function()
	local _s8_value=(self)
	current=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((current):compiledMethodAt_(aSymbol))
	mth=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((current):superclass())
	current=_s8_value
	return _s8_value
end)();return (smalltalk:boolean_and_((smalltalk:isNil_((mth))),(function()
return (smalltalk:notNil_((current)))
end)))
end))() do end;
return (mth);
end
)
,"accessing","compiledMethodFor: aSymbol\r\n\t\" Return the method at aSymbol searching up in receiver's hierarchy (or nil). \"\r\n\r\n\t| current mth |\r\n\tcurrent := self.\r\n\t[\tmth := current compiledMethodAt: aSymbol.\r\n\t\tcurrent := current superclass.\r\n\t\tmth isNil and: [ current notNil ]\r\n\t] whileTrue.\r\n\t^mth ","(\r\nfunction(self,aSymbol)\r\nlocal current=nil\r\nlocal mth=nil\r\n(function()\r\n\tlocal _s8_value=(self)\r\n\tcurrent=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((current):compiledMethodAt_(aSymbol))\r\n\tmth=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((current):superclass())\r\n\tcurrent=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:boolean_and_((smalltalk:isNil_((mth))),(function()\r\nreturn (smalltalk:notNil_((current)))\r\nend)))\r\nend))() do end;\r\nreturn (mth);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,">>>","_gt_gt_gt"
,(
function(self,aSymbol)
return ((self):compiledMethodFor_(aSymbol));
end
)
,"accessing",">>> aSymbol\r\n\t\" OBSOLETE - Return the method at aSymbol searching up in receiver's hierarchy (or nil if not implemented by the receiver nor its superclasses). \"\r\n\r\n\t^self compiledMethodFor: aSymbol ","(\r\nfunction(self,aSymbol)\r\nreturn ((self):compiledMethodFor_(aSymbol));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"instVarNames",0
,(
function(self)
return ((self):basicAt_ifAbsentPut_("$iVarNames",(function()
return (smalltalk:newArray({}))
end)));
end
)
,"accessing","instVarNames\r\n\t\" Return the instance variable names of the receiver. \"\r\n\r\n\t^self basicAt: '$iVarNames' ifAbsentPut: [#()]","(\r\nfunction(self)\r\nreturn ((self):basicAt_ifAbsentPut_(\"$iVarNames\",(function()\r\nreturn (smalltalk:newArray({}))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"instVarNamesDo:",0
,(
function(self,aBlock)
local array=nil
(function()
	local _s8_value=((self)["$iVarNames"])
	array=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((array))),(function()
return ((array):do_(aBlock))
end),nil));
end
)
,"accessing","instVarNamesDo: aBlock\r\n\t\" Evaluate aBlock with the instance variable names of the receiver. \"\r\n\r\n\t| array |\r\n\tarray := self basicAt: '$iVarNames'.\r\n\t^array notNil ifTrue: [ array do: aBlock ]","(\r\nfunction(self,aBlock)\r\nlocal array=nil\r\n(function()\r\n\tlocal _s8_value=((self)[\"$iVarNames\"])\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((array))),(function()\r\nreturn ((array):do_(aBlock))\r\nend),nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"allInstVarNames",0
,(
function(self)
local result=nil
(function()
	local _s8_value=((self):instVarNames())
	result=_s8_value
	return _s8_value
end)();
(self):allSuperclassesDo_((function(each)
return ((function()
	local _s8_value=(smalltalk:object_comma_(((each):instVarNames()),result))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
)
,"accessing","allInstVarNames\r\n\t\" Return all of the instance variable names defined in the receiver and its superclasses. \"\r\n\r\n\t| result |\r\n\tresult := self instVarNames.\r\n\tself allSuperclassesDo: [ :each | result := each instVarNames , result ].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):instVarNames())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):allSuperclassesDo_((function(each)\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((each):instVarNames()),result))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"instanceVariableNames",0
,(
function(self)
return ((self):instVarNames());
end
)
,"accessing","instanceVariableNames\r\n\t\" Return the instance variable names defined by the receiver. \"\r\n\r\n\t^self instVarNames","(\r\nfunction(self)\r\nreturn ((self):instVarNames());\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"propertyNames",0
,(
function(self)
return (smalltalk:basic_at_ifAbsent_((self),"$propertyNames",(function()
return ((smalltalk.Array):new())
end)));
end
)
,"accessing","propertyNames\r\n\t\" Return the property names of the receiver. \"\r\n\r\n\t^self basicAt: '$propertyNames' ifAbsent: [ Array new ]","(\r\nfunction(self)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),\"$propertyNames\",(function()\r\nreturn ((smalltalk.Array):new())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"propertyNames:",0
,(
function(self,anArray)
if (smalltalk:isNil_((anArray)))==true then return ((self):basicDelete_("$propertyNames")); end;
return (smalltalk:basic_at_put_((self),"$propertyNames",anArray));
end
)
,"accessing","propertyNames: anArray\r\n\t\" Set the property names of the receiver. \"\r\n\r\n\tanArray isNil ifTrue: [ ^self basicDelete: '$propertyNames' ].\r\n\t^self basicAt: '$propertyNames' put: anArray","(\r\nfunction(self,anArray)\r\nif (smalltalk:isNil_((anArray)))==true then return ((self):basicDelete_(\"$propertyNames\")); end;\r\nreturn (smalltalk:basic_at_put_((self),\"$propertyNames\",anArray));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"allPropertyNamesDo:",0
,(
function(self,aBlock)
((self):propertyNames()):do_(aBlock);
(self):allSuperclassesDo_((function(each)
return (((each):propertyNames()):do_(aBlock))
end));
return (self);
end
)
,"accessing","allPropertyNamesDo: aBlock\r\n\t\" Evaluates aBlock for the property names defined in the receiver and its superclasses. \"\r\n\r\n\tself propertyNames do: aBlock.\r\n\tself allSuperclassesDo: [ :each | each propertyNames do: aBlock ].","(\r\nfunction(self,aBlock)\r\n((self):propertyNames()):do_(aBlock);\r\n(self):allSuperclassesDo_((function(each)\r\nreturn (((each):propertyNames()):do_(aBlock))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"allInstVarNamesDo:",0
,(
function(self,aBlock)
(self):instVarNamesDo_(aBlock);
(self):allSuperclassesDo_((function(each)
return ((each):instVarNamesDo_(aBlock))
end));
return (self);
end
)
,"accessing","allInstVarNamesDo: aBlock\r\n\t\" Evaluates aBlock for the instance variable names defined in the receiver and its superclasses. \"\r\n\r\n\tself instVarNamesDo: aBlock.\r\n\tself allSuperclassesDo: [ :each | each instVarNamesDo: aBlock ].","(\r\nfunction(self,aBlock)\r\n(self):instVarNamesDo_(aBlock);\r\n(self):allSuperclassesDo_((function(each)\r\nreturn ((each):instVarNamesDo_(aBlock))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"comment",0
,(
function(self)
return (smalltalk:basic_at_ifAbsent_(((self):instanceClass()),"$comment",(function()
return ("")
end)));
end
)
,"accessing","comment\r\n\t\" Return the comment of the receiver. \"\r\n\r\n\t^self instanceClass basicAt: '$comment' ifAbsent: [ '' ]","(\r\nfunction(self)\r\nreturn (smalltalk:basic_at_ifAbsent_(((self):instanceClass()),\"$comment\",(function()\r\nreturn (\"\")\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"basicComment:",0
,(
function(self,aString)
smalltalk:basic_at_put_(((self):instanceClass()),"$comment",aString);
return (self);
end
)
,"private","basicComment: aString\r\n\t\" Set the comment of the receiver. \"\r\n\r\n\tself instanceClass basicAt: '$comment' put: aString","(\r\nfunction(self,aString)\r\nsmalltalk:basic_at_put_(((self):instanceClass()),\"$comment\",aString);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"comment:",0
,(
function(self,aString)
((smalltalk.ClassBuilder):new()):class_comment_((self):instanceClass(),aString);
return (self);
end
)
,"accessing","comment: aString\r\n\t\" Set the comment of the receiver. \"\r\n\r\n\tClassBuilder new\r\n\t\tclass: self instanceClass\r\n\t\tcomment: aString","(\r\nfunction(self,aString)\r\n((smalltalk.ClassBuilder):new()):class_comment_((self):instanceClass(),aString);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"removeSources",0
,(
function(self)
((self):instanceClass()):removeSources();
return (self);
end
)
,"tools","removeSources\r\n\t\" Remove all development sources of the receiver. \"\r\n\r\n\tself instanceClass removeSources","(\r\nfunction(self)\r\n((self):instanceClass()):removeSources();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"poolDictionaries",0
,(
function(self)
return (((self):instanceClass()):poolDictionaries());
end
)
,"accessing","poolDictionaries\r\n\t\" Return the poolDictionaries of the receiver. \"\r\n\r\n\t^self instanceClass poolDictionaries","(\r\nfunction(self)\r\nreturn (((self):instanceClass()):poolDictionaries());\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"poolDictionaryNames",0
,(
function(self)
return (((self):instanceClass()):poolDictionaryNames());
end
)
,"accessing","poolDictionaryNames\r\n\t\" Return the shared pool names of the receiver. \"\r\n\r\n\t^self instanceClass poolDictionaryNames","(\r\nfunction(self)\r\nreturn (((self):instanceClass()):poolDictionaryNames());\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"sharedPoolsAndNamesDo:",0
,(
function(self,aBlock)
local pool=nil
((self):instanceClass()):withAllSuperclassesDo_((function(each)
return (((each):poolDictionaryNames()):do_((function(aName)
(function()
	local _s8_value=((smalltalk.Smalltalk):poolDictionary_ifAbsent_(aName,(function()
return (nil)
end)))
	pool=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((pool))),(function()
return ((aBlock):value_value_(aName,pool))
end),nil))
end)))
end));
return (self);
end
)
,"accessing","sharedPoolsAndNamesDo: aBlock\r\n\t\" Execute aBlock for the pool dictionaries known by the receiver. \"\r\n\r\n\t| pool |\r\n\tself instanceClass withAllSuperclassesDo: [:each|\r\n\t\teach poolDictionaryNames do: [:aName|\r\n\t\t\tpool := Smalltalk poolDictionary: aName ifAbsent: [ nil ].\r\n\t\t\tpool notNil ifTrue: [ aBlock value: aName value: pool ]\r\n\t\t].\r\n\t]","(\r\nfunction(self,aBlock)\r\nlocal pool=nil\r\n((self):instanceClass()):withAllSuperclassesDo_((function(each)\r\nreturn (((each):poolDictionaryNames()):do_((function(aName)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):poolDictionary_ifAbsent_(aName,(function()\r\nreturn (nil)\r\nend)))\r\n\tpool=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((pool))),(function()\r\nreturn ((aBlock):value_value_(aName,pool))\r\nend),nil))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"sharedPoolsDo:",0
,(
function(self,aBlock)
(self):sharedPoolsAndNamesDo_((function(aName,aPool)
return ((aBlock):value_(aPool))
end));
return (self);
end
)
,"accessing","sharedPoolsDo: aBlock\r\n\t\" Execute aBlock for the pool dictionaries known by the receiver. \"\r\n\r\n\tself sharedPoolsAndNamesDo: [:aName :aPool| aBlock value: aPool ]","(\r\nfunction(self,aBlock)\r\n(self):sharedPoolsAndNamesDo_((function(aName,aPool)\r\nreturn ((aBlock):value_(aPool))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"classVariablesDo:",0
,(
function(self,aBlock)
local bindings=nil
return (((self):instanceClass()):withAllSuperclassesDo_((function(each)
(function()
	local _s8_value=((each):classVariables())
	bindings=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((bindings))),(function()
return ((bindings):associationsDo_((function(assoc)
return ((aBlock):value_(assoc))
end)))
end),nil))
end)));
end
)
,"accessing","classVariablesDo: aBlock\r\n\t\" Execute aBlock for the classVariables bindings known by the receiver. \"\r\n\r\n\t| bindings |\r\n\t^self instanceClass withAllSuperclassesDo: [:each|\r\n\t\tbindings := each classVariables.\r\n\t\tbindings notNil ifTrue: [\r\n\t\t\tbindings associationsDo: [:assoc| aBlock value: assoc ]\r\n\t\t]\r\n\t]","(\r\nfunction(self,aBlock)\r\nlocal bindings=nil\r\nreturn (((self):instanceClass()):withAllSuperclassesDo_((function(each)\r\n(function()\r\n\tlocal _s8_value=((each):classVariables())\r\n\tbindings=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((bindings))),(function()\r\nreturn ((bindings):associationsDo_((function(assoc)\r\nreturn ((aBlock):value_(assoc))\r\nend)))\r\nend),nil))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"classVariableNamesDo:",0
,(
function(self,aBlock)
local bindings=nil
return (((self):instanceClass()):withAllSuperclassesDo_((function(each)
(function()
	local _s8_value=((each):classVariables())
	bindings=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((bindings))),(function()
return ((bindings):keysDo_((function(aName)
return ((aBlock):value_(aName))
end)))
end),nil))
end)));
end
)
,"accessing","classVariableNamesDo: aBlock\r\n\t\" Execute aBlock for the classVariable names known by the receiver. \"\r\n\r\n\t| bindings |\r\n\t^self instanceClass withAllSuperclassesDo: [:each|\r\n\t\tbindings := each classVariables.\r\n\t\tbindings notNil ifTrue: [\r\n\t\t\tbindings keysDo: [:aName| aBlock value: aName ]\r\n\t\t]\r\n\t]","(\r\nfunction(self,aBlock)\r\nlocal bindings=nil\r\nreturn (((self):instanceClass()):withAllSuperclassesDo_((function(each)\r\n(function()\r\n\tlocal _s8_value=((each):classVariables())\r\n\tbindings=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((bindings))),(function()\r\nreturn ((bindings):keysDo_((function(aName)\r\nreturn ((aBlock):value_(aName))\r\nend)))\r\nend),nil))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"classVariableAt:put:",0
,(
function(self,aName,anObject)
return ((((self):instanceClass()):classVariables()):at_put_(aName,anObject));
end
)
,"accessing","classVariableAt: aName put: anObject\r\n\t\" Set the classVariable of the receiver to anObject. \"\r\n\r\n\t^self instanceClass classVariables at: aName put: anObject","(\r\nfunction(self,aName,anObject)\r\nreturn ((((self):instanceClass()):classVariables()):at_put_(aName,anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"classVariableAt:ifAbsent:",0
,(
function(self,aName,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local bindings=nil
((self):instanceClass()):withAllSuperclassesDo_((function(each)
(function()
	local _s8_value=((each):classVariables())
	bindings=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((bindings))),(function()
return (smalltalk:if_true_false_(((bindings):includesKey_(aName)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((bindings):at_(aName))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):evaluate())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"accessing","classVariableAt: aName ifAbsent: aBlock\r\n\t\" Return the value of classVariable named aName. \"\r\n\r\n\t| bindings |\r\n\tself instanceClass withAllSuperclassesDo: [:each|\r\n\t\tbindings := each classVariables.\r\n\t\tbindings notNil ifTrue: [\r\n\t\t\t(bindings includesKey: aName) ifTrue: [\r\n\t\t\t\t^bindings at: aName\r\n\t\t\t]\r\n\t\t]\r\n\t].\r\n\t^aBlock evaluate","(\r\nfunction(self,aName,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal bindings=nil\r\n((self):instanceClass()):withAllSuperclassesDo_((function(each)\r\n(function()\r\n\tlocal _s8_value=((each):classVariables())\r\n\tbindings=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((bindings))),(function()\r\nreturn (smalltalk:if_true_false_(((bindings):includesKey_(aName)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((bindings):at_(aName))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):evaluate())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"classVariableAt:",0
,(
function(self,aName)
return ((self):classVariableAt_ifAbsent_(aName,(function()
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Undefined class variable "),aName))," in ")),(self):name())))
end)));
end
)
,"accessing","classVariableAt: aName\r\n\t\" Return the value of classVariable named aName or generates an error. \"\r\n\r\n\t^self classVariableAt: aName ifAbsent: [\r\n\t\tself error: 'Undefined class variable ',aName ,' in ' ,self name\r\n\t]","(\r\nfunction(self,aName)\r\nreturn ((self):classVariableAt_ifAbsent_(aName,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Undefined class variable \"),aName)),\" in \")),(self):name())))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"pool:variableAt:put:",0
,(
function(self,poolName,aName,anObject)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local pool=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):poolDictionary_ifAbsent_(poolName,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Undefined pool variable "),poolName))," in ")),(self):name())))
end
)()
error(_s8Ret_,0)
end)())
end)))
	pool=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((pool):at_put_(aName,anObject))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"accessing","pool: poolName variableAt: aName put: anObject\r\n\t\" Set the pool Variable of the receiver to anObject. \"\r\n\r\n\t| pool |\r\n\tpool := Smalltalk\r\n\t\tpoolDictionary: poolName\r\n\t\tifAbsent: [ ^self error: 'Undefined pool variable ',poolName ,' in ' ,self name ].\r\n\t^pool at: aName put: anObject","(\r\nfunction(self,poolName,aName,anObject)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal pool=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):poolDictionary_ifAbsent_(poolName,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Undefined pool variable \"),poolName)),\" in \")),(self):name())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tpool=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((pool):at_put_(aName,anObject))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"loadRequirementsInto:for:",0
,(
function(self,aCollection,anEncoder)
return (self);
end
)
,"loading","loadRequirementsInto: aCollection for: anEncoder\r\n\t\" Add the requirements to load the receiver from sources to aCollection.\r\n\tDefault action do nothing, this method can be refined by the subclasses.\r\n\t\"\r\n\r\n\t^self","(\r\nfunction(self,aCollection,anEncoder)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"removeSelectors:",0
,(
function(self,aCollection)
(aCollection):do_((function(each)
return ((self):removeSelector_(each))
end));
return (self);
end
)
,"methods","removeSelectors: aCollection\r\n\t\" Remove the methods for messages in aCollection, implemented by the receiver. \"\r\n\r\n\taCollection do: [:each| self removeSelector: each ]","(\r\nfunction(self,aCollection)\r\n(aCollection):do_((function(each)\r\nreturn ((self):removeSelector_(each))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"removeCompiledMethod:",0
,(
function(self,aMethod)
((self):smalltalk()):removeMethod(self,aMethod);
return (self);
end
)
,"private","removeCompiledMethod: aMethod\r\n\t\" Remove aMethod from the receiver. \"\r\n\r\n\tself smalltalk #removeMethod: self method: aMethod","(\r\nfunction(self,aMethod)\r\n((self):smalltalk()):removeMethod(self,aMethod);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"missingImplementorFor:",0
,(
function(self,jsSelector)
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Missing implementor for "),((jsSelector):asNativeSelector()):asLiteral()))," in ")),(self):name())));
end
)
,"private","missingImplementorFor: jsSelector\r\n\t\" Private - Handle the situation where there is no implementor for jsSelector.\r\n\tThis can happen when there is no implementation for jsSelector and the message\r\n\t has been dispatched through a superSend.\r\n\t\"\r\n\r\n\t^self error: 'Missing implementor for '\r\n\t\t, jsSelector asNativeSelector asLiteral\r\n\t\t,' in ',self name","(\r\nfunction(self,jsSelector)\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Missing implementor for \"),((jsSelector):asNativeSelector()):asLiteral())),\" in \")),(self):name())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"removeSelector:",0
,(
function(self,aSelector)
local method=nil
(function()
	local _s8_value=((self):compiledMethodAt_(aSelector))
	method=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((method)))==true then (self):removeCompiledMethod_(method); end;
return (self);
end
)
,"methods","removeSelector: aSelector\r\n\t\" Remove the method for message aSelector implemented by the receiver. \"\r\n\r\n\t| method |\r\n\tmethod := self compiledMethodAt: aSelector.\r\n\tmethod notNil ifTrue: [ self removeCompiledMethod: method ].","(\r\nfunction(self,aSelector)\r\nlocal method=nil\r\n(function()\r\n\tlocal _s8_value=((self):compiledMethodAt_(aSelector))\r\n\tmethod=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((method)))==true then (self):removeCompiledMethod_(method); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"removeFromSystem",0
,(
function(self)
return (((self):instanceClass()):removeFromSystem());
end
)
,"remove","removeFromSystem\r\n\t\" Remove the receiver from system. \"\r\n\r\n\t^self instanceClass removeFromSystem ","(\r\nfunction(self)\r\nreturn (((self):instanceClass()):removeFromSystem());\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"implementorsOf:",0
,(
function(self,aSymbol)
local result=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
(self):withAllSubclassesDo_((function(each)
local method=nil
(function()
	local _s8_value=((each):_gt_gt(aSymbol))
	method=_s8_value
	return _s8_value
end)();if (smalltalk:notNil_((method)))==true then (result):add_(method); end;(function()
	local _s8_value=(((each)["$klass"]):_gt_gt(aSymbol))
	method=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((method))),(function()
return ((result):add_(method))
end),nil))
end));
return (result);
end
)
,"testing","implementorsOf: aSymbol\r\n\t\" Return the implementors of aSymbol in the receiver and its subclasses. \"\r\n\r\n\t| result |\r\n\tresult := #().\r\n\tself withAllSubclassesDo: [:each | | method |\r\n\t\tmethod := each >> aSymbol.\r\n\t\tmethod notNil ifTrue: [ result add: method ].\r\n\t\tmethod := each class >> aSymbol.\r\n\t\tmethod notNil ifTrue: [ result add: method ].\r\n\t].\r\n\t^result","(\r\nfunction(self,aSymbol)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):withAllSubclassesDo_((function(each)\r\nlocal method=nil\r\n(function()\r\n\tlocal _s8_value=((each):_gt_gt(aSymbol))\r\n\tmethod=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:notNil_((method)))==true then (result):add_(method); end;(function()\r\n\tlocal _s8_value=(((each)[\"$klass\"]):_gt_gt(aSymbol))\r\n\tmethod=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((method))),(function()\r\nreturn ((result):add_(method))\r\nend),nil))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"asJSONObject",0
,(
function(self)
return (self);
end
)
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"shallowCopy",0
,(
function(self)
return (self);
end
)
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"deepCopy",0
,(
function(self)
return (self);
end
)
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"toString",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(("{st:"),(self):name())),"}"));
end
)
,"converting","toString\r\n\t\" Return the receiver as a String. \"\r\n\r\n\t^'{st:',self name,$}","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"{st:\"),(self):name())),\"}\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"aboutToAdd:",0
,(
function(self,aMethod)
(smalltalk.APIBuilder):register_(aMethod);
return (self);
end
)
,"private","aboutToAdd: aMethod\r\n\t\" Private - Prepare aMethod to be added onto the receiver. \"\r\n\r\n\tAPIBuilder register: aMethod. ","(\r\nfunction(self,aMethod)\r\n(smalltalk.APIBuilder):register_(aMethod);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"canAdd:method:",0
,(
function(self,isDoIt,aMethod)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if not ((smalltalk:boolean_and_((smalltalk:notNil_((smalltalk.OverwriteMethods))),(function()
return (smalltalk.OverwriteMethods)
end))))==true then smalltalk:if_true_false_(((self):implements_((aMethod):selector())),(function()
return (smalltalk:if_true_false_((isDoIt),nil,(function()
if (smalltalk:boolean_and_((smalltalk:notNil_((smalltalk.DumpOverwritenMethods))),(function()
return (smalltalk:boolean_and_((smalltalk.DumpOverwritenMethods),(function()
return (smalltalk:notNil_((smalltalk.Exporter)))
end)))
end)))==true then (self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("? "),(self):name())),">>#")),(aMethod):selector()));
(self):print_(((smalltalk.Exporter):new()):export_method_(self,aMethod)); else (self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("-Overwrite Conflict- "),(self):name())),">>#")),(aMethod):selector())); end;return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end),nil); end;
(self):aboutToAdd_(aMethod);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"private","canAdd: isDoIt method: aMethod\r\n\t\" Private - Returns true if aMethod be added onto the receiver. \"\r\n\r\n\t(OverwriteMethods notNil and: [ OverwriteMethods ]) ifFalse: [\r\n\t\t(self implements: aMethod selector) ifTrue: [\r\n\t\t\tisDoIt ifFalse: [\r\n\t\t\t\t(DumpOverwritenMethods notNil\r\n\t\t\t\tand: [ DumpOverwritenMethods\r\n\t\t\t\tand: [ Exporter notNil ]]) ifTrue: [\r\n\t\t\t\t\tself note: '? ',self name,'>>#',aMethod selector.\r\n\t\t\t\t\tself print: (Exporter new export: self method: aMethod).\r\n\t\t\t\t] ifFalse: [\r\n\t\t\t\t\tself note: '-Overwrite Conflict- ',self name,'>>#',aMethod selector.\r\n\t\t\t\t].\r\n\t\t\t\t^false\r\n\t\t\t].\r\n\t\t].\r\n\t].\r\n\tself aboutToAdd: aMethod.\r\n\t^true ","(\r\nfunction(self,isDoIt,aMethod)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif not ((smalltalk:boolean_and_((smalltalk:notNil_((smalltalk.OverwriteMethods))),(function()\r\nreturn (smalltalk.OverwriteMethods)\r\nend))))==true then smalltalk:if_true_false_(((self):implements_((aMethod):selector())),(function()\r\nreturn (smalltalk:if_true_false_((isDoIt),nil,(function()\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((smalltalk.DumpOverwritenMethods))),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk.DumpOverwritenMethods),(function()\r\nreturn (smalltalk:notNil_((smalltalk.Exporter)))\r\nend)))\r\nend)))==true then (self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"? \"),(self):name())),\">>#\")),(aMethod):selector()));\r\n(self):print_(((smalltalk.Exporter):new()):export_method_(self,aMethod)); else (self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"-Overwrite Conflict- \"),(self):name())),\">>#\")),(aMethod):selector())); end;return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend),nil); end;\r\n(self):aboutToAdd_(aMethod);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"basicAddCompiledMethod:",0
,(
function(self,aMethod)
((self):smalltalk()):addMethod(((aMethod):selector()):asSelector(),aMethod,self);
return (self);
end
)
,"private","basicAddCompiledMethod: aMethod\r\n\t\" Private - Register aMethod onto the receiver. \"\r\n\r\n\tself smalltalk\r\n\t\t#addMethod: aMethod selector asSelector\r\n\t\tmethod: aMethod to: self","(\r\nfunction(self,aMethod)\r\n((self):smalltalk()):addMethod(((aMethod):selector()):asSelector(),aMethod,self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"addCompiledMethod:",0
,(
function(self,aMethod)
local isDoIt=nil
(function()
	local _s8_value=(smalltalk:isObject_equalTo_(((aMethod):selector()),(smalltalk.String):doItSelector()))
	isDoIt=_s8_value
	return _s8_value
end)();
if not (((self):canAdd_method_(isDoIt,aMethod)))==true then return (nil); end;
if (smalltalk:boolean_and_((smalltalk:notNil_((smalltalk.Exporter))),(function()
return (smalltalk:booleanNot_((isDoIt)))
end)))==true then (self):print_(((smalltalk.Exporter):new()):export_method_(self,aMethod)); end;
return ((self):basicAddCompiledMethod_(aMethod));
end
)
,"methods","addCompiledMethod: aMethod\r\n\t\" Add the compiled method, if appropiate, and register the method in recent methods. \"\r\n\r\n\t| isDoIt |\r\n\tisDoIt := aMethod selector = String doItSelector.\r\n\t(self canAdd: isDoIt method: aMethod) ifFalse: [ ^nil ].\r\n\t(Exporter notNil and: [ isDoIt not ]) ifTrue: [\r\n\" DEBUG -\tself note: self name,'>>#',aMethod selector.\"\r\n\t\tself print: (Exporter new export: self method: aMethod).\r\n\t].\r\n\t^self basicAddCompiledMethod: aMethod","(\r\nfunction(self,aMethod)\r\nlocal isDoIt=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:isObject_equalTo_(((aMethod):selector()),(smalltalk.String):doItSelector()))\r\n\tisDoIt=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((self):canAdd_method_(isDoIt,aMethod)))==true then return (nil); end;\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((smalltalk.Exporter))),(function()\r\nreturn (smalltalk:booleanNot_((isDoIt)))\r\nend)))==true then (self):print_(((smalltalk.Exporter):new()):export_method_(self,aMethod)); end;\r\nreturn ((self):basicAddCompiledMethod_(aMethod));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"collection",0
,(
function(self)
return ((
function(_s8_rec)
	(_s8_rec):species_(self);
	return ((_s8_rec):yourself())
end
)((smalltalk.ComposedObjects):new()));
end
)
,"composing","collection\r\n\t\" Return a collection to compose instances of the receiver. \"\r\n\r\n\t^ComposedObjects new\r\n\t\tspecies: self;\r\n\t\tyourself","(\r\nfunction(self)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):species_(self);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.ComposedObjects):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"codeFor:accessing:",0
,(
function(self,anEncoder,aNode)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local aName=nil
(function()
	local _s8_value=((aNode):value())
	aName=_s8_value
	return _s8_value
end)();
(self):allInstVarNamesDo_((function(each)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((aName),each)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((anEncoder):codeToAccessInstanceVariable_in_(aName,aNode))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(self):allPropertyNamesDo_((function(each)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((aName),each)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((anEncoder):codeToAccessProperty_in_(aName,aNode))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"Compiler-generation","codeFor: anEncoder accessing: aNode\r\n\t\" Return the code to access variable in aNode (aVariableNode).\r\n\tReturn nil if the code to access variable can't be generated.\r\n\tThe default implementation return code to access instance variables.\r\n\t\"\r\n\r\n\t| aName |\r\n\taName := aNode value.\r\n\tself allInstVarNamesDo: [:each|\r\n\t\taName = each ifTrue: [\r\n\t\t\t^anEncoder codeToAccessInstanceVariable: aName in: aNode\r\n\t\t].\r\n\t].\r\n\tself allPropertyNamesDo: [:each|\r\n\t\taName = each ifTrue: [\r\n\t\t\t^anEncoder codeToAccessProperty: aName in: aNode\r\n\t\t].\r\n\t].\r\n\t^nil","(\r\nfunction(self,anEncoder,aNode)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal aName=nil\r\n(function()\r\n\tlocal _s8_value=((aNode):value())\r\n\taName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):allInstVarNamesDo_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((aName),each)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((anEncoder):codeToAccessInstanceVariable_in_(aName,aNode))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(self):allPropertyNamesDo_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((aName),each)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((anEncoder):codeToAccessProperty_in_(aName,aNode))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"compiler",0
,(
function(self)
return (((self):compilerSupport()):for_(self));
end
)
,"Compiler-compiling","compiler\r\n\t\" Return a compiler for receiver's source code. \"\r\n\r\n\t^self compilerSupport for: self","(\r\nfunction(self)\r\nreturn (((self):compilerSupport()):for_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"recompile",0
,(
function(self)
((self):compiler()):recompile_(self);
return (self);
end
)
,"Compiler-compiling","recompile\r\n\t\" Recompile all the methods of the receiver. \"\r\n\r\n\tself compiler recompile: self","(\r\nfunction(self)\r\n((self):compiler()):recompile_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"recompileAll",0
,(
function(self)
((self):instanceClass()):withAllSubclassesDo_((function(each)
return ((each):recompile())
end));
return (self);
end
)
,"Compiler-compiling","recompileAll\r\n\t\" Recompile all the methods of the receiver and its subclasses.\t\"\r\n\r\n\tself instanceClass withAllSubclassesDo: [:each| each recompile ]","(\r\nfunction(self)\r\n((self):instanceClass()):withAllSubclassesDo_((function(each)\r\nreturn ((each):recompile())\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"recompile:",0
,(
function(self,what)
if ((what):isString())==true then return ((self):recompile_((smalltalk.Array):with_(what))); end;
(what):do_((function(selector)
return (((self):_gt_gt(selector)):recompile())
end));
return (self);
end
)
,"Compiler-compiling","recompile: what\r\n\t\" Recompile the method(s) at selector(s) of the receiver.\t\"\r\n\r\n\twhat isString ifTrue: [ ^self recompile: (Array with: what) ].\r\n\twhat do: [:selector| (self >> selector) recompile ]","(\r\nfunction(self,what)\r\nif ((what):isString())==true then return ((self):recompile_((smalltalk.Array):with_(what))); end;\r\n(what):do_((function(selector)\r\nreturn (((self):_gt_gt(selector)):recompile())\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"templateFrom:doing:on:",0
,(
function(self,host,aBlock,methodBlock)
local template=nil
if (smalltalk:isNil_((host)))==true then return (nil); end;
(function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((host),"s8Template",(function()
return (nil)
end)))
	template=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_and_((smalltalk:isNil_((template))),(function()
return (smalltalk:is_kindOf_((host),(smalltalk.CompiledMethod)))
end)))==true then (function()
	local _s8_value=((
function(_s8_rec)
	(_s8_rec):useTemplates_(false);
	(_s8_rec):currentClass_((host):classField());
	return ((_s8_rec):parseMethod_((host):source()))
end
)((smalltalk.Compiler):new()))
	template=_s8_value
	return _s8_value
end)();
smalltalk:basic_at_put_((host),"s8Template",template); end;
return (smalltalk:if_true_false_((smalltalk:notNil_((template))),(function()
(function()
	local _s8_value=((template):deepCopy())
	template=_s8_value
	return _s8_value
end)();if (smalltalk:notNil_((aBlock)))==true then (template):do_(aBlock); end;return (smalltalk:if_true_false_((smalltalk:notNil_((methodBlock))),(function()
return ((methodBlock):value_(template))
end),(function()
return (template)
end)))
end),nil));
end
)
,"Compiler-templates","templateFrom: host doing: aBlock on: methodBlock\r\n\t\" Return the result of collecting mutations in template cached in host (or nil). \"\r\n\r\n\t| template |\r\n\thost isNil ifTrue: [ ^nil ].\r\n\ttemplate := host basicAt: #s8Template ifAbsent: [].\r\n\t(template isNil and: [host isKindOf: CompiledMethod]) ifTrue: [\r\n\t\ttemplate := Compiler new\r\n\t\t\tuseTemplates: false;\r\n\t\t\tcurrentClass: host classField;\r\n\t\t\tparseMethod: host source.\r\n\t\thost basicAt: #s8Template put: template.\r\n\t].\r\n\t^template notNil ifTrue: [\r\n\t\ttemplate := template deepCopy.\r\n\t\taBlock notNil ifTrue: [ template do: aBlock ].\r\n\t\tmethodBlock notNil\r\n\t\t\tifTrue: [ methodBlock value: template ]\r\n\t\t\tifFalse: [ template ]\r\n\t]","(\r\nfunction(self,host,aBlock,methodBlock)\r\nlocal template=nil\r\nif (smalltalk:isNil_((host)))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((host),\"s8Template\",(function()\r\nreturn (nil)\r\nend)))\r\n\ttemplate=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_and_((smalltalk:isNil_((template))),(function()\r\nreturn (smalltalk:is_kindOf_((host),(smalltalk.CompiledMethod)))\r\nend)))==true then (function()\r\n\tlocal _s8_value=((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):useTemplates_(false);\r\n\t(_s8_rec):currentClass_((host):classField());\r\n\treturn ((_s8_rec):parseMethod_((host):source()))\r\nend\r\n)((smalltalk.Compiler):new()))\r\n\ttemplate=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:basic_at_put_((host),\"s8Template\",template); end;\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((template))),(function()\r\n(function()\r\n\tlocal _s8_value=((template):deepCopy())\r\n\ttemplate=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:notNil_((aBlock)))==true then (template):do_(aBlock); end;return (smalltalk:if_true_false_((smalltalk:notNil_((methodBlock))),(function()\r\nreturn ((methodBlock):value_(template))\r\nend),(function()\r\nreturn (template)\r\nend)))\r\nend),nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"templateFrom:with:",0
,(
function(self,host,methodBlock)
return ((self):templateFrom_doing_on_(host,nil,methodBlock));
end
)
,"Compiler-templates","templateFrom: host with: methodBlock\r\n\t\" Return the template cached in host (or nil). \"\r\n\r\n\t^self templateFrom: host doing: nil on: methodBlock","(\r\nfunction(self,host,methodBlock)\r\nreturn ((self):templateFrom_doing_on_(host,nil,methodBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"methodsFor:",0
,(
function(self,aString)
return (((smalltalk.ClassCategoryReader):new()):class_category_(self,aString));
end
)
,"Tools-fileIn","methodsFor: aString\r\n\t\" FileIn - Return a chunk reader to fileIn methods onto the receiver. \"\r\n\r\n\t^ClassCategoryReader new class: self category: aString","(\r\nfunction(self,aString)\r\nreturn (((smalltalk.ClassCategoryReader):new()):class_category_(self,aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"methodsFor:stamp:",0
,(
function(self,aString,stamp)
return (((smalltalk.ClassCategoryReader):new()):class_category_stamp_(self,aString,stamp));
end
)
,"Tools-fileIn","methodsFor: aString stamp: stamp\r\n\t\" FileIn - Return a chunk reader to fileIn methods onto the receiver. \"\r\n\r\n\t^ClassCategoryReader new class: self category: aString stamp: stamp","(\r\nfunction(self,aString,stamp)\r\nreturn (((smalltalk.ClassCategoryReader):new()):class_category_stamp_(self,aString,stamp));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"methods",0
,(
function(self)
return ((self):methodsFor_("unclassified"));
end
)
,"Tools-fileIn","methods\r\n\t\" FileIn - Return a chunk reader to fileIn methods onto the receiver. \"\r\n\r\n\t^self methodsFor: #unclassified ","(\r\nfunction(self)\r\nreturn ((self):methodsFor_(\"unclassified\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"commentStamp",0
,(
function(self)
return (((smalltalk.ClassCommentReader):new()):class_(self));
end
)
,"Tools-fileIn","commentStamp\r\n\t\" Return a comment reader for the receiver. \"\r\n\r\n\t^ClassCommentReader new class: self","(\r\nfunction(self)\r\nreturn (((smalltalk.ClassCommentReader):new()):class_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"fileOut",0
,(
function(self)
return ((smalltalk.Exporter):fileOut_((self):instanceClass()));
end
)
,"Tools-fileOut","fileOut\r\n\t\" Return fileOut definition and code of a class. \"\r\n\r\n\t^Exporter fileOut: self instanceClass","(\r\nfunction(self)\r\nreturn ((smalltalk.Exporter):fileOut_((self):instanceClass()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"export",0
,(
function(self)
return ((smalltalk.Exporter):export_((self):instanceClass()));
end
)
,"Tools-export","export\r\n\t\" Return the result of exporting definition and source code of a class. \"\r\n\r\n\t^Exporter export: self instanceClass","(\r\nfunction(self)\r\nreturn ((smalltalk.Exporter):export_((self):instanceClass()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"references",0
,(
function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	result=_s8_value
	return _s8_value
end)();
(self):methodsDo_((function(mth)
local refs=nil
(function()
	local _s8_value=((mth):references())
	refs=_s8_value
	return _s8_value
end)();return (((refs):keys()):do_((function(key)
return (((result):at_ifAbsentPut_(key,(function()
return ((smalltalk.HashedSet):new())
end))):addAll_((refs):at_(key)))
end)))
end));
return ((result):collect_((function(each)
return ((each):asArray())
end)));
end
)
,"Tools-references","references\r\n\t\" Return all the references in the receiver. \"\r\n\r\n\t| result |\r\n\tresult := PoolDictionary new.\r\n\tself methodsDo: [:mth| | refs |\r\n\t\trefs := mth references.\r\n\t\trefs keys do: [:key|\r\n\t\t\t(result at: key ifAbsentPut: [HashedSet new])\r\n\t\t\t\taddAll: (refs at: key)\r\n\t\t]\r\n\t].\r\n\t^result collect: [:each| each asArray ]","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):methodsDo_((function(mth)\r\nlocal refs=nil\r\n(function()\r\n\tlocal _s8_value=((mth):references())\r\n\trefs=_s8_value\r\n\treturn _s8_value\r\nend)();return (((refs):keys()):do_((function(key)\r\nreturn (((result):at_ifAbsentPut_(key,(function()\r\nreturn ((smalltalk.HashedSet):new())\r\nend))):addAll_((refs):at_(key)))\r\nend)))\r\nend));\r\nreturn ((result):collect_((function(each)\r\nreturn ((each):asArray())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"messagesSent",0
,(
function(self)
local result=nil
local cls=nil
(function()
	local _s8_value=((smalltalk.HashedSet):new())
	result=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):instanceClass())
	cls=_s8_value
	return _s8_value
end)();
(cls):methodsDo_((function(each)
return ((result):addAll_((each):messages()))
end));
((cls)["$klass"]):methodsDo_((function(each)
return ((result):addAll_((each):messages()))
end));
return (result);
end
)
,"Tools-messages","messagesSent\r\n\t\" Return the messages sent by the receiver. \"\r\n\r\n\t| result cls |\r\n\tresult := HashedSet new.\r\n\tcls := self instanceClass.\r\n\tcls methodsDo: [:each| result addAll: each messages ].\r\n\tcls class methodsDo: [:each| result addAll: each messages ].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\nlocal cls=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.HashedSet):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):instanceClass())\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(cls):methodsDo_((function(each)\r\nreturn ((result):addAll_((each):messages()))\r\nend));\r\n((cls)[\"$klass\"]):methodsDo_((function(each)\r\nreturn ((result):addAll_((each):messages()))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"allMessagesSent",0
,(
function(self)
return (((self):allSubclasses()):inject_into_((self):messagesSent(),(function(total,each)
return ((
function(_s8_rec)
	(_s8_rec):addAll_((each):messagesSent());
	return ((_s8_rec):yourself())
end
)(total))
end)));
end
)
,"Tools-messages","allMessagesSent\r\n\t\" Return the messages sent by the receiver and its subclasses. \"\r\n\r\n\t^self allSubclasses\r\n\t\tinject: self messagesSent\r\n\t\tinto: [:total :each| total addAll: each messagesSent; yourself ]","(\r\nfunction(self)\r\nreturn (((self):allSubclasses()):inject_into_((self):messagesSent(),(function(total,each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAll_((each):messagesSent());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(total))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"implementedMessages",0
,(
function(self)
local result=nil
local cls=nil
(function()
	local _s8_value=((smalltalk.HashedSet):new())
	result=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):instanceClass())
	cls=_s8_value
	return _s8_value
end)();
(result):addAll_((cls):selectors());
(result):addAll_(((cls)["$klass"]):selectors());
return (result);
end
)
,"Tools-messages","implementedMessages\r\n\t\" Return the messages implemented by the receiver. \"\r\n\r\n\t| result cls |\r\n\tresult := HashedSet new.\r\n\tcls := self instanceClass.\r\n\tresult addAll: cls selectors.\r\n\tresult addAll: cls class selectors.\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\nlocal cls=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.HashedSet):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):instanceClass())\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(result):addAll_((cls):selectors());\r\n(result):addAll_(((cls)[\"$klass\"]):selectors());\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"allImplementedMessages",0
,(
function(self)
return (((self):allSubclasses()):inject_into_((self):implementedMessages(),(function(total,each)
return ((
function(_s8_rec)
	(_s8_rec):addAll_((each):implementedMessages());
	return ((_s8_rec):yourself())
end
)(total))
end)));
end
)
,"Tools-messages","allImplementedMessages\r\n\t\" Return the messages implemented by the receiver and its subclasses. \"\r\n\r\n\t^self allSubclasses\r\n\t\tinject: self implementedMessages\r\n\t\tinto: [:total :each| total addAll: each implementedMessages; yourself ]","(\r\nfunction(self)\r\nreturn (((self):allSubclasses()):inject_into_((self):implementedMessages(),(function(total,each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAll_((each):implementedMessages());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(total))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"implementorsDo:",0
,(
function(self,aBlock)
local cls=nil
(function()
	local _s8_value=((self):instanceClass())
	cls=_s8_value
	return _s8_value
end)();
((cls)["$klass"]):methodsDo_(aBlock);
(cls):methodsDo_(aBlock);
return (self);
end
)
,"Tools-iterating","implementorsDo: aBlock\r\n\t\" Evaluates aBlock for each implementor in the receiver. \"\r\n\r\n\t| cls |\r\n\tcls := self instanceClass.\r\n\tcls class methodsDo: aBlock.\r\n\tcls methodsDo: aBlock.","(\r\nfunction(self,aBlock)\r\nlocal cls=nil\r\n(function()\r\n\tlocal _s8_value=((self):instanceClass())\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((cls)[\"$klass\"]):methodsDo_(aBlock);\r\n(cls):methodsDo_(aBlock);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"implementors",0
,(
function(self)
local result=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
(self):implementorsDo_((function(each)
return ((result):add_(each))
end));
return (result);
end
)
,"Tools-implementors","implementors\r\n\t\" Return a collection with all implementors in the receiver. \"\r\n\r\n\t| result |\r\n\tresult := #().\r\n\tself implementorsDo: [:each| result add: each].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):implementorsDo_((function(each)\r\nreturn ((result):add_(each))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"implement:comment:as:category:",0
,(
function(self,messageHeader,aComment,sourceCode,aCategory)
local code=nil
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("! "),(self):name())),smalltalk:if_true_false_((smalltalk:isNil_((aCategory))),(function()
return (" methods")
end),(function()
return (smalltalk:object_comma_((" methodsFor: "),(aCategory):asLiteral()))
end))))," !\r\n")),messageHeader)),smalltalk:if_true_false_((smalltalk:isNil_((aComment))),(function()
return ("")
end),(function()
return (smalltalk:object_comma_((smalltalk:object_comma_(("\r\n\t\" "),aComment))," \""))
end)))),"\r\n\r\n\t")),sourceCode)),"! !\r\n\r\n"))
	code=_s8_value
	return _s8_value
end)();
return ((
function(_s8_rec)
	(_s8_rec):fileIn();
	return ((_s8_rec):yourself())
end
)(code));
end
)
,"Builders-implementing","implement: messageHeader\r\n\tcomment: aComment\r\n\tas: sourceCode\r\n\tcategory: aCategory\r\n\t\" Private - Implement a method in the receiver.\r\n\tNote: sourceCode must be the source code in chunk format.\r\n\t\"\r\n\r\n\t| code |\r\n\tcode := '! ',self name,\r\n\t\t(aCategory isNil\r\n\t\t\tifTrue: [ ' methods' ]\r\n\t\t\tifFalse: [ ' methodsFor: ', aCategory asLiteral ])\r\n,' !\r\n',messageHeader, (aComment isNil ifTrue: [ '' ] ifFalse: ['\r\n\t\" ', aComment, ' \"']),'\r\n\r\n\t',sourceCode ,'! !\r\n\r\n'.\t^code fileIn; yourself","(\r\nfunction(self,messageHeader,aComment,sourceCode,aCategory)\r\nlocal code=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"! \"),(self):name())),smalltalk:if_true_false_((smalltalk:isNil_((aCategory))),(function()\r\nreturn (\" methods\")\r\nend),(function()\r\nreturn (smalltalk:object_comma_((\" methodsFor: \"),(aCategory):asLiteral()))\r\nend)))),\" !\\r\\n\")),messageHeader)),smalltalk:if_true_false_((smalltalk:isNil_((aComment))),(function()\r\nreturn (\"\")\r\nend),(function()\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"\\r\\n\\t\\\" \"),aComment)),\" \\\"\"))\r\nend)))),\"\\r\\n\\r\\n\\t\")),sourceCode)),\"! !\\r\\n\\r\\n\"))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):fileIn();\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(code));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"implement:comment:as:",0
,(
function(self,messageHeader,aComment,sourceCode)
return ((self):implement_comment_as_category_(messageHeader,aComment,sourceCode,nil));
end
)
,"Builders-implementing","implement: messageHeader comment: aComment as: sourceCode\r\n\t\" Private - Implement a method in the receiver. \"\r\n\r\n\t^self\r\n\t\timplement: messageHeader\r\n\t\tcomment: aComment\r\n\t\tas: sourceCode\r\n\t\tcategory: nil","(\r\nfunction(self,messageHeader,aComment,sourceCode)\r\nreturn ((self):implement_comment_as_category_(messageHeader,aComment,sourceCode,nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"implement:as:",0
,(
function(self,messageHeader,sourceCode)
return ((self):implement_comment_as_category_(messageHeader,nil,sourceCode,nil));
end
)
,"Builders-implementing","implement: messageHeader as: sourceCode\r\n\t\" Private - Implement a method in the receiver. \"\r\n\r\n\t^self\r\n\t\timplement: messageHeader\r\n\t\tcomment: nil\r\n\t\tas: sourceCode\r\n\t\tcategory: nil","(\r\nfunction(self,messageHeader,sourceCode)\r\nreturn ((self):implement_comment_as_category_(messageHeader,nil,sourceCode,nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"implement:as:category:",0
,(
function(self,messageHeader,sourceCode,aCategory)
return ((self):implement_comment_as_category_(messageHeader,nil,sourceCode,aCategory));
end
)
,"Builders-implementing","implement: messageHeader as: sourceCode category: aCategory\r\n\t\" Private - Implement a method in the receiver. \"\r\n\r\n\t^self\r\n\t\timplement: messageHeader\r\n\t\tcomment: nil\r\n\t\tas: sourceCode\r\n\t\tcategory: aCategory","(\r\nfunction(self,messageHeader,sourceCode,aCategory)\r\nreturn ((self):implement_comment_as_category_(messageHeader,nil,sourceCode,aCategory));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"class:implement:comment:as:category:",0
,(
function(self,aClass,message,aComment,sourceCode,aCategory)
if ((aClass):isString())==true then return ((self):class_implement_comment_as_category_((aClass):evaluateIn_(nil),message,aComment,sourceCode,aCategory)); end;
return ((aClass):implement_comment_as_category_(message,aComment,sourceCode,aCategory));
end
)
,"Builders-implementing","class: aClass implement: message\r\n\tcomment: aComment as: sourceCode\r\n\tcategory: aCategory\r\n\t\" Private - Implement a method in aClass. \"\r\n\r\n\taClass isString ifTrue: [\r\n\t\t^self\r\n\t\t\tclass: (aClass evaluateIn: nil)\r\n\t\t\timplement: message\r\n\t\t\tcomment: aComment\r\n\t\t\tas: sourceCode\r\n\t\t\tcategory: aCategory\r\n\t].\r\n\t^aClass\r\n\t\timplement: message\r\n\t\tcomment: aComment\r\n\t\tas: sourceCode\r\n\t\tcategory: aCategory","(\r\nfunction(self,aClass,message,aComment,sourceCode,aCategory)\r\nif ((aClass):isString())==true then return ((self):class_implement_comment_as_category_((aClass):evaluateIn_(nil),message,aComment,sourceCode,aCategory)); end;\r\nreturn ((aClass):implement_comment_as_category_(message,aComment,sourceCode,aCategory));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"build:doing:",0
,(
function(self,token,aBlock)
return ((smalltalk.APIBuilder):build_doing_(token,aBlock));
end
)
,"Builders-private","build: token doing: aBlock\r\n\t\" Process a (build...: spec) definition marking methods generated while evaluating aBlock.\r\n\tReturn the result of evaluating aBlock. \"\r\n\r\n\t^APIBuilder build: token doing: aBlock","(\r\nfunction(self,token,aBlock)\r\nreturn ((smalltalk.APIBuilder):build_doing_(token,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"buildAPI:",0
,(
function(self,specs)
(specs):do_((function(spec)
return (smalltalk:if_true_false_(((spec):isString()),(function()
return ((spec):evaluateIn_(self))
end),(function()
return ((self):perform_withArguments_((spec):first(),(spec):copyFrom_to_(2,(spec):size())))
end)))
end));
return (self);
end
)
,"Builders-obsolete","buildAPI: specs\r\n\t\" Generate code to implement API protocoll defined by specs.\r\n\tWARNING: OBSOLETE - this builder generate changes that will not be filedOut to builder code.\r\n\tspecs must be an array of :\r\n\t\t- string : it will be considered as an evaluable expression to be executed in the context of the receiver.\r\n\t\t- anArray : of #( selector arg1 arg2 arg3 arg4... ) to be performed for code generation/setup of the receiver\r\n\t\t\twhere selector is frequently a build...: selector.\r\n\t\"\r\n\r\n\tspecs do: [:spec|\r\n\t\tspec isString\r\n\t\tifTrue: [ spec evaluateIn: self ]\r\n\t\tifFalse: [\r\n\t\t\tself\tperform: spec first\r\n\t\t\t\twithArguments: (spec copyFrom: 2 to: spec size)\r\n\t\t]\r\n\t]","(\r\nfunction(self,specs)\r\n(specs):do_((function(spec)\r\nreturn (smalltalk:if_true_false_(((spec):isString()),(function()\r\nreturn ((spec):evaluateIn_(self))\r\nend),(function()\r\nreturn ((self):perform_withArguments_((spec):first(),(spec):copyFrom_to_(2,(spec):size())))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"stMessageHeader:",0
,(
function(self,msgHeader)
return (msgHeader);
end
)
,"Builders-private","stMessageHeader: msgHeader\r\n\t\" Private - Return a message header string with nice smalltalk looking.\r\n\tDefault implementation leave the message header as is.\r\n\tThis method can be refined by subclasses to transform message pattern for better code generation.\r\n\t\"\r\n\r\n\t^msgHeader","(\r\nfunction(self,msgHeader)\r\nreturn (msgHeader);\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"buildAccessor:",0
,(
function(self,accessor)
return ((self):build_doing_(("Accessor"):_minus_gt(accessor),(function()
return (smalltalk:if_true_false_((smalltalk:boolean_or_(((accessor):isString()),(function()
return (smalltalk:boolean_and_(((accessor):isArray()),(function()
return (smalltalk:boolean_and_(((((accessor):size()) > 1)),(function()
return (smalltalk:isObject_equalTo_(((accessor):second()),"initialize"))
end)))
end)))
end))),(function()
return (smalltalk:object_comma_(((self):buildGetter_(accessor)),(self):buildSetter_(accessor)))
end),(function()
return ((accessor):compose_((function(tuple)
return ((self):implement_comment_as_category_((tuple):first(),(tuple):at_(2),(tuple):at_(3),"accessing"))
end)))
end)))
end)));
end
)
,"Builders-api","buildAccessor: accessor\r\n\t\" Build (instance) method to access native property. \"\r\n\r\n\t^self build: #Accessor -> accessor doing: [\r\n\t\t(accessor isString or: [\r\n\t\t\taccessor isArray and: [\r\n\t\t\taccessor size > 1 and: [\r\n\t\t\taccessor second = #initialize ] ]\r\n\t\t]) ifTrue: [\r\n\t\t\t(self buildGetter: accessor)\r\n\t\t\t,(self buildSetter: accessor)\r\n\t\t] ifFalse: [\r\n\t\t\taccessor compose: [:tuple|\r\n\t\t\t\tself implement: tuple first comment: (tuple at: 2)\r\n\t\t\t\t      as: (tuple at: 3) category: #accessing\r\n\t\t\t]\r\n\t\t]\r\n\t]","(\r\nfunction(self,accessor)\r\nreturn ((self):build_doing_((\"Accessor\"):_minus_gt(accessor),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_or_(((accessor):isString()),(function()\r\nreturn (smalltalk:boolean_and_(((accessor):isArray()),(function()\r\nreturn (smalltalk:boolean_and_(((((accessor):size()) > 1)),(function()\r\nreturn (smalltalk:isObject_equalTo_(((accessor):second()),\"initialize\"))\r\nend)))\r\nend)))\r\nend))),(function()\r\nreturn (smalltalk:object_comma_(((self):buildGetter_(accessor)),(self):buildSetter_(accessor)))\r\nend),(function()\r\nreturn ((accessor):compose_((function(tuple)\r\nreturn ((self):implement_comment_as_category_((tuple):first(),(tuple):at_(2),(tuple):at_(3),\"accessing\"))\r\nend)))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"buildGetterCode:",0
,(
function(self,aSelector)
return (smalltalk:object_comma_(("^"),aSelector));
end
)
,"Builders-private","buildGetterCode: aSelector\r\n\t\" Private - Return source code to get aSelector. \"\r\n\r\n\t^'^' ,aSelector","(\r\nfunction(self,aSelector)\r\nreturn (smalltalk:object_comma_((\"^\"),aSelector));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"buildGetter:",0
,(
function(self,spec)
return ((self):build_doing_(("Getter"):_minus_gt(spec),(function()
return (smalltalk:if_true_false_((smalltalk:boolean_and_(((spec):isArray()),(function()
return (smalltalk:boolean_and_(((((spec):size()) > 1)),(function()
return (smalltalk:isObject_equalTo_(((spec):second()),"initialize"))
end)))
end))),(function()
return ((self):buildGetter_initialize_((spec):first(),(spec):last()))
end),(function()
return ((self):implement_comment_as_category_((self):stMessageHeader_(spec),smalltalk:object_comma_((smalltalk:object_comma_(("Return the "),spec))," of the receiver."),(self):buildGetterCode_(spec),"accessing"))
end)))
end)));
end
)
,"Builders-api","buildGetter: spec\r\n\t\" Build method for getter. \"\r\n\r\n\t^self build: #Getter -> spec doing: [\r\n\t\t(spec isArray and: [ spec size > 1 and: [\r\n\t\t spec second = #initialize ]]) ifTrue: [\r\n\t\t\tself buildGetter: spec first initialize: spec last\r\n\t\t] ifFalse: [\r\n\t\t\tself\r\n\t\t\t\timplement: (self stMessageHeader: spec)\r\n\t\t\t\tcomment: 'Return the ' ,spec ,' of the receiver.'\r\n\t\t\t\tas: (self buildGetterCode: spec) category: #accessing\r\n\t\t]\r\n\t]","(\r\nfunction(self,spec)\r\nreturn ((self):build_doing_((\"Getter\"):_minus_gt(spec),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_(((spec):isArray()),(function()\r\nreturn (smalltalk:boolean_and_(((((spec):size()) > 1)),(function()\r\nreturn (smalltalk:isObject_equalTo_(((spec):second()),\"initialize\"))\r\nend)))\r\nend))),(function()\r\nreturn ((self):buildGetter_initialize_((spec):first(),(spec):last()))\r\nend),(function()\r\nreturn ((self):implement_comment_as_category_((self):stMessageHeader_(spec),smalltalk:object_comma_((smalltalk:object_comma_((\"Return the \"),spec)),\" of the receiver.\"),(self):buildGetterCode_(spec),\"accessing\"))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"buildInitialize:with:",0
,(
function(self,aSelector,initializer)
return ((self):implement_comment_as_category_(smalltalk:object_comma_(("initialize"),(aSelector):asSmalltalkName_(true)),smalltalk:object_comma_((smalltalk:object_comma_(("Private - Initialize the "),aSelector))," of the receiver."),initializer,"initialize"));
end
)
,"Builders-private","buildInitialize: aSelector with: initializer\r\n\t\" Private - Build method to initialize instance variable aSelector. \"\r\n\r\n\t^self\r\n\t\timplement: #initialize ,(aSelector asSmalltalkName: true)\r\n\t\tcomment: 'Private - Initialize the ' ,aSelector ,' of the receiver.'\r\n\t\tas: initializer\r\n\t\tcategory: #initialize","(\r\nfunction(self,aSelector,initializer)\r\nreturn ((self):implement_comment_as_category_(smalltalk:object_comma_((\"initialize\"),(aSelector):asSmalltalkName_(true)),smalltalk:object_comma_((smalltalk:object_comma_((\"Private - Initialize the \"),aSelector)),\" of the receiver.\"),initializer,\"initialize\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"buildGetter:initialize:",0
,(
function(self,aSelector,initializer)
local code=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((initializer),"initialize")),(function()
return ("^self implementedBySubclass: #initialize")
end),(function()
return (smalltalk:if_true_false_(((initializer):notEmpty()),(function()
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((initializer):first()),".")),(function()
return ((initializer):copyFrom_to_(2,(initializer):size()))
end),(function()
return (smalltalk:object_comma_((smalltalk:object_comma_((aSelector)," := ")),smalltalk:if_true_false_((smalltalk:boolean_and_((((initializer):first()):isUppercase()),(function()
return (smalltalk:isObject_equalTo_((((initializer):asArrayOfSubstrings()):size()),1))
end))),(function()
return (smalltalk:object_comma_((initializer)," new"))
end),(function()
return (initializer)
end))))
end)))
end),nil))
end)))
	code=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:if_true_false_((smalltalk:notNil_((code))),(function()
return ((self):buildInitialize_with_(aSelector,code))
end),(function()
return ("")
end))),(self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_(("Return the "),aSelector))," of the receiver."),smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((aSelector)," isNil ifTrue: [ self ")),"initialize")),(aSelector):asSmalltalkName_(true)))," ].\r\n\t^")),aSelector),"accessing")));
end
)
,"Builders-private","buildGetter: aSelector initialize: initializer\r\n\t\" Private - Build method to get instance aSelector w/deferred initialization mode.\r\n\tNote: #initializer can be:\r\n\t\t#initialize to generate default/deferred implementation.\r\n\t\tempty string to do NOT generate #initialize... method.\r\n\t\tsmalltalk code starting with $. to use that code as method implementation.\r\n\t\tsmalltalk expression for asignment (to be used as assignment to instance).\r\n\t\tGlobalName if code do not have blanks and start with uppercase, it will be used as class to instantiate during initialization.\r\n\t\"\r\n\r\n\t| code |\r\n\tcode := initializer = #initialize\r\n\t  ifTrue: [ '^self implementedBySubclass: #initialize' ] ifFalse: [\r\n\t\tinitializer notEmpty ifTrue: [\r\n\t\t\tinitializer first = $.\r\n\t\t\tifTrue: [ initializer copyFrom: 2 to: initializer size ] ifFalse: [\r\n\t\t\t\taSelector ,' := ' ,(\r\n\t\t\t\t\t(initializer first isUppercase and: [ initializer asArrayOfSubstrings size = 1 ])\r\n\t\t\t\t\tifTrue: [ initializer ,' new' ]\r\n\t\t\t\t\tifFalse: [ initializer ])\r\n\t\t\t]\r\n\t\t]\r\n\t  ].\r\n\t^(code notNil ifTrue: [ self buildInitialize: aSelector with: code ] ifFalse: [ '' ])\r\n\t,(self\r\n\t\timplement: (self stMessageHeader: aSelector)\r\n\t\tcomment: 'Return the ' ,aSelector ,' of the receiver.'\r\n\t\tas: aSelector,' isNil ifTrue: [ self ' , #initialize ,(aSelector asSmalltalkName: true) ,' ].\r\n\t^' ,aSelector category: #accessing)","(\r\nfunction(self,aSelector,initializer)\r\nlocal code=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((initializer),\"initialize\")),(function()\r\nreturn (\"^self implementedBySubclass: #initialize\")\r\nend),(function()\r\nreturn (smalltalk:if_true_false_(((initializer):notEmpty()),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((initializer):first()),\".\")),(function()\r\nreturn ((initializer):copyFrom_to_(2,(initializer):size()))\r\nend),(function()\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((aSelector),\" := \")),smalltalk:if_true_false_((smalltalk:boolean_and_((((initializer):first()):isUppercase()),(function()\r\nreturn (smalltalk:isObject_equalTo_((((initializer):asArrayOfSubstrings()):size()),1))\r\nend))),(function()\r\nreturn (smalltalk:object_comma_((initializer),\" new\"))\r\nend),(function()\r\nreturn (initializer)\r\nend))))\r\nend)))\r\nend),nil))\r\nend)))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:if_true_false_((smalltalk:notNil_((code))),(function()\r\nreturn ((self):buildInitialize_with_(aSelector,code))\r\nend),(function()\r\nreturn (\"\")\r\nend))),(self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_((\"Return the \"),aSelector)),\" of the receiver.\"),smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((aSelector),\" isNil ifTrue: [ self \")),\"initialize\")),(aSelector):asSmalltalkName_(true))),\" ].\\r\\n\\t^\")),aSelector),\"accessing\")));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"buildSetterCode:",0
,(
function(self,aSelector)
return (smalltalk:object_comma_((aSelector)," := anObject"));
end
)
,"Builders-private","buildSetterCode: aSelector\r\n\t\" Private - Return source code to set aSelector. \"\r\n\r\n\t^aSelector ,' := anObject'","(\r\nfunction(self,aSelector)\r\nreturn (smalltalk:object_comma_((aSelector),\" := anObject\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"buildSetter:",0
,(
function(self,spec)
if (smalltalk:boolean_and_(((spec):isArray()),(function()
return (smalltalk:boolean_and_(((((spec):size()) > 1)),(function()
return (smalltalk:isObject_equalTo_(((spec):second()),"initialize"))
end)))
end)))==true then return ((self):buildSetter_((spec):first())); end;
return ((self):build_doing_(("Setter"):_minus_gt(spec),(function()
return ((self):implement_comment_as_category_(smalltalk:object_comma_(((self):stMessageHeader_(spec)),": anObject"),smalltalk:object_comma_((smalltalk:object_comma_(("Set the "),spec))," of the receiver."),(self):buildSetterCode_(spec),"accessing"))
end)));
end
)
,"Builders-api","buildSetter: spec\r\n\t\" Build method for setter. \"\r\n\r\n\t(spec isArray and: [ spec size > 1 and: [\r\n\t spec second = #initialize ]]) ifTrue: [\r\n\t\t^self buildSetter: spec first\r\n\t].\r\n\t^self build: #Setter -> spec doing: [\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: spec) ,': anObject'\r\n\t\t\tcomment: 'Set the ' ,spec ,' of the receiver.'\r\n\t\t\tas: (self buildSetterCode: spec)\r\n\t\t\tcategory: #accessing\r\n\t]","(\r\nfunction(self,spec)\r\nif (smalltalk:boolean_and_(((spec):isArray()),(function()\r\nreturn (smalltalk:boolean_and_(((((spec):size()) > 1)),(function()\r\nreturn (smalltalk:isObject_equalTo_(((spec):second()),\"initialize\"))\r\nend)))\r\nend)))==true then return ((self):buildSetter_((spec):first())); end;\r\nreturn ((self):build_doing_((\"Setter\"):_minus_gt(spec),(function()\r\nreturn ((self):implement_comment_as_category_(smalltalk:object_comma_(((self):stMessageHeader_(spec)),\": anObject\"),smalltalk:object_comma_((smalltalk:object_comma_((\"Set the \"),spec)),\" of the receiver.\"),(self):buildSetterCode_(spec),\"accessing\"))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"buildGetters:",0
,(
function(self,specs)
if ((specs):isString())==true then return ((self):buildGetters_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("Getters"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildGetter_(each))
end)))
end)));
end
)
,"Builders-api","buildGetters: specs\r\n\t\" Build methods to get instances. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildGetters: specs asArrayOfSubstrings ].\r\n\t^self build: #Getters -> specs doing: [\r\n\t\tspecs compose: [:each| self buildGetter: each ]\r\n\t]","(\r\nfunction(self,specs)\r\nif ((specs):isString())==true then return ((self):buildGetters_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"Getters\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildGetter_(each))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"buildSetters:",0
,(
function(self,specs)
if ((specs):isString())==true then return ((self):buildSetters_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("Setters"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildSetter_(each))
end)))
end)));
end
)
,"Builders-api","buildSetters: specs\r\n\t\" Build methods to set instances. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildSetters: specs asArrayOfSubstrings ].\r\n\t^self build: #Setters -> specs doing: [\r\n\t\tspecs compose: [:each| self buildSetter: each ]\r\n\t]","(\r\nfunction(self,specs)\r\nif ((specs):isString())==true then return ((self):buildSetters_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"Setters\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildSetter_(each))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"buildAccessors:",0
,(
function(self,specs)
if ((specs):isString())==true then return ((self):buildAccessors_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("Accessors"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildAccessor_(each))
end)))
end)));
end
)
,"Builders-api","buildAccessors: specs\r\n\t\" Build methods to access instances. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildAccessors: specs asArrayOfSubstrings ].\r\n\t^self build: #Accessors -> specs doing: [\r\n\t\tspecs compose: [:each| self buildAccessor: each ]\r\n\t]","(\r\nfunction(self,specs)\r\nif ((specs):isString())==true then return ((self):buildAccessors_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"Accessors\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildAccessor_(each))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"buildAccessors",0
,(
function(self)
return ((self):build_doing_(("Accessors"):_minus_gt(smalltalk:newArray({})),(function()
return ((self):buildAccessors_((self):instanceVariableNames()))
end)));
end
)
,"Builders-api","buildAccessors\r\n\t\" Private - Build methods to access all instance variables. \"\r\n\r\n\t^self build: #Accessors -> #() doing: [\r\n\t\tself buildAccessors: self instanceVariableNames\r\n\t]","(\r\nfunction(self)\r\nreturn ((self):build_doing_((\"Accessors\"):_minus_gt(smalltalk:newArray({})),(function()\r\nreturn ((self):buildAccessors_((self):instanceVariableNames()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"buildPool:with:",0
,(
function(self,poolName,spec)
return ((self):build_doing_(("Pool"):_minus_gt(spec),(function()
return ((
function(_s8_rec)
	(_s8_rec):definePool_with_(poolName,spec);
	(_s8_rec):printDefinePool_with_(poolName,spec);
	return ((_s8_rec):yourself())
end
)((smalltalk.Smalltalk):current()))
end)));
end
)
,"Builders-api","buildPool: poolName with: spec\r\n\t\" Private - Build a PoolDictionary with spec (and log definition in log stream). \"\r\n\r\n\t^self build: #Pool -> spec doing: [\r\n\t\tSmalltalk current\r\n\t\t\tdefinePool: poolName with: spec;\r\n\t\t\tprintDefinePool: poolName with: spec;\r\n\t\t\tyourself\r\n\t]","(\r\nfunction(self,poolName,spec)\r\nreturn ((self):build_doing_((\"Pool\"):_minus_gt(spec),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):definePool_with_(poolName,spec);\r\n\t(_s8_rec):printDefinePool_with_(poolName,spec);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.Smalltalk):current()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Behavior,"__tostring",0
,(
function(self)
return (smalltalk:toString_((self)));
end
)
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","(\r\nfunction(self)\r\nreturn (smalltalk:toString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class["$klass"],"categories",0
,(
function(self)
return ((((smalltalk.Smalltalk):classes()):collect_((function(each)
return ((each):category())
end))):asHashedSet());
end
)
,"export","categories\r\n\t\" Return a collection with all defined categories. \"\r\n\r\n\t^(Smalltalk classes collect: [:each | each category ]) asHashedSet","(\r\nfunction(self)\r\nreturn ((((smalltalk.Smalltalk):classes()):collect_((function(each)\r\nreturn ((each):category())\r\nend))):asHashedSet());\r\nend\r\n)")
smalltalk:bind(smalltalk.Class["$klass"],"uncategorized",0
,(
function(self)
return (((smalltalk.Smalltalk):classes()):select_((function(each)
return (smalltalk:isObject_equalTo_(((each):category()),"unclassified"))
end)));
end
)
,"export","uncategorized\r\n\t\" Return a collection with classes without category. \"\r\n\r\n\t^Smalltalk classes select: [:each | each category = #unclassified ]","(\r\nfunction(self)\r\nreturn (((smalltalk.Smalltalk):classes()):select_((function(each)\r\nreturn (smalltalk:isObject_equalTo_(((each):category()),\"unclassified\"))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"category",0
,(
function(self)
return ((self)["$category"]);
end
)
,"accessing","category\r\n\t\" Return the category of the receiver. \"\r\n\r\n\t^self basicAt: '$category'","(\r\nfunction(self)\r\nreturn ((self)[\"$category\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"category:",0
,(
function(self,aString)
smalltalk:basic_at_put_((self),"$category",aString);
return (self);
end
)
,"accessing","category: aString\r\n\t\" Set the category of the receiver. \"\r\n\r\n\tself basicAt: '$category' put: aString","(\r\nfunction(self,aString)\r\nsmalltalk:basic_at_put_((self),\"$category\",aString);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"classVariables",0
,(
function(self)
local names=nil
(function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((self),"$classVariableNames",(function()
return (nil)
end)))
	names=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((names)))==true then return ((self)["$classVariables"]); end;
(self):basicDelete_("$classVariableNames");
(self):classVariableNames_(names);
return ((self)["$classVariables"]);
end
)
,"accessing","classVariables\r\n\t\" Return the class variables of the receiver. \"\r\n\r\n\t| names |\r\n\tnames := self basicAt: '$classVariableNames' ifAbsent: [].\r\n\tnames isNil ifTrue: [ ^self basicAt: '$classVariables' ].\r\n\tself basicDelete: '$classVariableNames'.\r\n\tself classVariableNames: names.\r\n\t^self basicAt: '$classVariables'","(\r\nfunction(self)\r\nlocal names=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((self),\"$classVariableNames\",(function()\r\nreturn (nil)\r\nend)))\r\n\tnames=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((names)))==true then return ((self)[\"$classVariables\"]); end;\r\n(self):basicDelete_(\"$classVariableNames\");\r\n(self):classVariableNames_(names);\r\nreturn ((self)[\"$classVariables\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"classVariables:",0
,(
function(self,aDictionary)
if (smalltalk:boolean_or_((smalltalk:isNil_((aDictionary))),(function()
return ((aDictionary):isEmpty())
end)))==true then return ((self):basicDelete_("$classVariables")); end;
return (smalltalk:basic_at_put_((self),"$classVariables",aDictionary));
end
)
,"accessing","classVariables: aDictionary\r\n\t\" Set the class variables of the receiver. \"\r\n\r\n\t(aDictionary isNil or: [ aDictionary isEmpty ]) ifTrue: [\r\n\t\t^self basicDelete: '$classVariables'\r\n\t].\r\n\t^self basicAt: '$classVariables' put: aDictionary","(\r\nfunction(self,aDictionary)\r\nif (smalltalk:boolean_or_((smalltalk:isNil_((aDictionary))),(function()\r\nreturn ((aDictionary):isEmpty())\r\nend)))==true then return ((self):basicDelete_(\"$classVariables\")); end;\r\nreturn (smalltalk:basic_at_put_((self),\"$classVariables\",aDictionary));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"poolDictionaries",0
,(
function(self)
return ((self)["$poolDictionaries"]);
end
)
,"accessing","poolDictionaries\r\n\t\" Return the poolDictionaries of the receiver (anArray or nil). \"\r\n\r\n\t^self basicAt: '$poolDictionaries'","(\r\nfunction(self)\r\nreturn ((self)[\"$poolDictionaries\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"poolDictionaries:",0
,(
function(self,anArray)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (smalltalk:notNil_((anArray)))==true then if ((anArray):isEmpty())==true then return ((self):poolDictionaries_(nil)); end;
smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((anArray):size()),((anArray):asSet()):size())),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_(("Invalid pool dictionary names "),(anArray):asLiteral())))
end
)()
error(_s8Ret_,0)
end)())
end)); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:basic_at_put_((self),"$poolDictionaries",anArray))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"accessing","poolDictionaries: anArray\r\n\t\" Set the poolDictionaries of the receiver. \"\r\n\r\n\tanArray notNil ifTrue: [\r\n\t\tanArray isEmpty ifTrue: [\r\n\t\t\t^self poolDictionaries: nil\r\n\t\t].\r\n\t\tanArray size = anArray asSet size ifFalse: [\r\n\t\t\t^self error: 'Invalid pool dictionary names ' ,anArray asLiteral\r\n\t\t].\r\n\t].\r\n\t^self basicAt: '$poolDictionaries' put: anArray","(\r\nfunction(self,anArray)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (smalltalk:notNil_((anArray)))==true then if ((anArray):isEmpty())==true then return ((self):poolDictionaries_(nil)); end;\r\nsmalltalk:if_true_false_((smalltalk:isObject_equalTo_(((anArray):size()),((anArray):asSet()):size())),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Invalid pool dictionary names \"),(anArray):asLiteral())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:basic_at_put_((self),\"$poolDictionaries\",anArray))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"classVariableNames",0
,(
function(self)
return (smalltalk:if_true_false_((smalltalk:isNil_(((self):classVariables()))),(function()
return ((smalltalk.Array):new())
end),(function()
return (((self):classVariables()):keys())
end)));
end
)
,"accessing","classVariableNames\r\n\t\" Return the class variable names of the receiver. \"\r\n\r\n\t^self classVariables isNil\r\n\t\tifTrue: [ Array new ]\r\n\t\tifFalse: [ self classVariables keys ]","(\r\nfunction(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_(((self):classVariables()))),(function()\r\nreturn ((smalltalk.Array):new())\r\nend),(function()\r\nreturn (((self):classVariables()):keys())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"classVariablesString",0
,(
function(self)
return (((self):classVariableNames()):join_(" "));
end
)
,"accessing","classVariablesString\r\n\t\" Return the class variable names of the receiver as aString. \"\r\n\r\n\t^self classVariableNames join: ' '","(\r\nfunction(self)\r\nreturn (((self):classVariableNames()):join_(\" \"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"poolDictionaryNames",0
,(
function(self)
return (smalltalk:if_true_false_((smalltalk:isNil_(((self):poolDictionaries()))),(function()
return ((smalltalk.Array):new())
end),(function()
return ((self):poolDictionaries())
end)));
end
)
,"accessing","poolDictionaryNames\r\n\t\" Return the pool dictionary names of the receiver. \"\r\n\r\n\t^self poolDictionaries isNil\r\n\t\tifTrue: [ Array new ]\r\n\t\tifFalse: [ self poolDictionaries ]","(\r\nfunction(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_(((self):poolDictionaries()))),(function()\r\nreturn ((smalltalk.Array):new())\r\nend),(function()\r\nreturn ((self):poolDictionaries())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"poolDictionariesString",0
,(
function(self)
return (((self):poolDictionaryNames()):join_(" "));
end
)
,"accessing","poolDictionariesString\r\n\t\" Return the poolDictionary names of the receiver as aString. \"\r\n\r\n\t^self poolDictionaryNames join: ' '","(\r\nfunction(self)\r\nreturn (((self):poolDictionaryNames()):join_(\" \"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"classVariableNames:",0
,(
function(self,classVarNames)
local names=nil
local dictionary=nil
local old=nil
if (smalltalk:isNil_((classVarNames)))==true then return ((self):classVariables_(nil)); end;
(function()
	local _s8_value=(smalltalk:if_true_false_(((classVarNames):isString()),(function()
return ((classVarNames):asArrayOfSubstrings())
end),(function()
return (classVarNames)
end)))
	names=_s8_value
	return _s8_value
end)();
if not ((smalltalk:isObject_equalTo_(((names):size()),((names):asSet()):size())))==true then return ((self):error_(smalltalk:object_comma_(("Invalid class variable names "),(names):asLiteral()))); end;
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	dictionary=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):classVariables())
	old=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((old)))==true then (function()
	local _s8_value=(dictionary)
	old=_s8_value
	return _s8_value
end)(); end;
(names):do_((function(each)
return ((dictionary):at_put_(each,(old):at_ifAbsent_(each,(function()
return (nil)
end))))
end));
(self):classVariables_(dictionary);
return (self);
end
)
,"accessing","classVariableNames: classVarNames\r\n\t\" Set the variable names defined in the receiver. \"\r\n\r\n\t| names dictionary old |\r\n\tclassVarNames isNil ifTrue: [ ^self classVariables: nil ].\r\n\tnames := classVarNames isString\r\n\t\tifTrue: [ classVarNames asArrayOfSubstrings ]\r\n\t\tifFalse: [ classVarNames ].\r\n\tnames size = names asSet size ifFalse: [\r\n\t\t^self error: 'Invalid class variable names ' ,names asLiteral\r\n\t].\r\n\tdictionary := PoolDictionary new.\r\n\told := self classVariables. old isNil ifTrue: [ old := dictionary ].\r\n\tnames do: [:each|\r\n\t\tdictionary at: each put: (old at: each ifAbsent: [ nil ])\r\n\t].\r\n\tself classVariables: dictionary.","(\r\nfunction(self,classVarNames)\r\nlocal names=nil\r\nlocal dictionary=nil\r\nlocal old=nil\r\nif (smalltalk:isNil_((classVarNames)))==true then return ((self):classVariables_(nil)); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((classVarNames):isString()),(function()\r\nreturn ((classVarNames):asArrayOfSubstrings())\r\nend),(function()\r\nreturn (classVarNames)\r\nend)))\r\n\tnames=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:isObject_equalTo_(((names):size()),((names):asSet()):size())))==true then return ((self):error_(smalltalk:object_comma_((\"Invalid class variable names \"),(names):asLiteral()))); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tdictionary=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):classVariables())\r\n\told=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((old)))==true then (function()\r\n\tlocal _s8_value=(dictionary)\r\n\told=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(names):do_((function(each)\r\nreturn ((dictionary):at_put_(each,(old):at_ifAbsent_(each,(function()\r\nreturn (nil)\r\nend))))\r\nend));\r\n(self):classVariables_(dictionary);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"poolDictionaryNames:",0
,(
function(self,poolVarNames)
(self):poolDictionaries_(smalltalk:if_true_false_(((poolVarNames):isString()),(function()
return ((poolVarNames):asArrayOfSubstrings())
end),(function()
return (poolVarNames)
end)));
return (self);
end
)
,"accessing","poolDictionaryNames: poolVarNames\r\n\t\" Set the pool dictionary names known to the receiver. \"\r\n\r\n\tself poolDictionaries: (poolVarNames isString\r\n\t\tifTrue: [ poolVarNames asArrayOfSubstrings ]\r\n\t\tifFalse: [ poolVarNames ]).","(\r\nfunction(self,poolVarNames)\r\n(self):poolDictionaries_(smalltalk:if_true_false_(((poolVarNames):isString()),(function()\r\nreturn ((poolVarNames):asArrayOfSubstrings())\r\nend),(function()\r\nreturn (poolVarNames)\r\nend)));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:",0
,(
function(self,aString,aString2)
return ((self):subclass_instanceVariableNames_classVariableNames_(aString,aString2,""));
end
)
,"instantiation","subclass: aString instanceVariableNames: aString2\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: ''","(\r\nfunction(self,aString,aString2)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_(aString,aString2,\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"subclass:category:",0
,(
function(self,aString,aCategory)
return ((self):subclass_instanceVariableNames_category_(aString,"",aCategory));
end
)
,"instantiation","subclass: aString category: aCategory\r\n\t\" Create a subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: ''\r\n\t\tcategory: aCategory","(\r\nfunction(self,aString,aCategory)\r\nreturn ((self):subclass_instanceVariableNames_category_(aString,\"\",aCategory));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:category:",0
,(
function(self,aString,aString2,aString3)
return (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_category_(self,aString,aString2,aString3));
end
)
,"instantiation","subclass: aString instanceVariableNames: aString2 category: aString3\r\n\t\" Create a subclass of the receiver. \"\r\n\r\n\t^ClassBuilder new\r\n\t\tsuperclass: self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tcategory: aString3","(\r\nfunction(self,aString,aString2,aString3)\r\nreturn (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_category_(self,aString,aString2,aString3));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"isClass",0
,(
function(self)
return (true);
end
)
,"testing","isClass\r\n\t\" Return true if the receiver is a Class. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"printString",0
,(
function(self)
return ((self):name());
end
)
,"printing","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t^self name","(\r\nfunction(self)\r\nreturn ((self):name());\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"instanceClass",0
,(
function(self)
return (self);
end
)
,"accessing","instanceClass\r\n\t\" Return the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"rename:",0
,(
function(self,aString)
((self):smalltalk()):renameClass(self,aString);
return (self);
end
)
,"renaming","rename: aString\r\n\t\" Rename the receiver to aString. \"\r\n\r\n\tself smalltalk #renameClass: self to: aString","(\r\nfunction(self,aString)\r\n((self):smalltalk()):renameClass(self,aString);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"removeFromSystem",0
,(
function(self)
((self):subclasses()):do_((function(each)
return ((each):removeFromSystem())
end));
((self):smalltalk()):removeClass(self);
return (true);
end
)
,"remove","removeFromSystem\r\n\t\" Remove the receiver from system. \"\r\n\r\n\tself subclasses do: [:each| each removeFromSystem ].\r\n\tself smalltalk #removeClass: self.\r\n\t^true","(\r\nfunction(self)\r\n((self):subclasses()):do_((function(each)\r\nreturn ((each):removeFromSystem())\r\nend));\r\n((self):smalltalk()):removeClass(self);\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"removeSources",0
,(
function(self)
((self)["$klass"]):methodsDo_((function(each)
return ((each):removeSources())
end));
(self):methodsDo_((function(each)
return ((each):removeSources())
end));
(
function(_s8_rec)
	(_s8_rec):comment_("");
	return ((_s8_rec):category_("s8"))
end
)(self);
return (self);
end
)
,"tools","removeSources\r\n\t\" Remove all development sources of the receiver. \"\r\n\r\n\tself class methodsDo: [:each | each removeSources ].\r\n\tself methodsDo: [:each | each removeSources ].\r\n\tself comment: ''; category: #s8","(\r\nfunction(self)\r\n((self)[\"$klass\"]):methodsDo_((function(each)\r\nreturn ((each):removeSources())\r\nend));\r\n(self):methodsDo_((function(each)\r\nreturn ((each):removeSources())\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"\");\r\n\treturn ((_s8_rec):category_(\"s8\"))\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"variableByteSubclass:classVariableNames:poolDictionaries:",0
,(
function(self,aString,classVarNames,poolVarNames)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,"",classVarNames,poolVarNames));
end
)
,"instantiation","variableByteSubclass: aString\r\n\tclassVariableNames: classVarNames\r\n\tpoolDictionaries: poolVarNames\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\"\tself note: 'WARNING: ',aString,' defined as variableByteSubclass:...'.\r\n\"\t^self \r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: ''\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: poolVarNames","(\r\nfunction(self,aString,classVarNames,poolVarNames)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,\"\",classVarNames,poolVarNames));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"variableSubclass:instanceVariableNames:classVariableNames:poolDictionaries:",0
,(
function(self,aString,aString2,classVarNames,poolVarNames)
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_(("WARNING: "),aString))," defined as variableSubclass:..."));
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,classVarNames,poolVarNames));
end
)
,"instantiation","variableSubclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\tpoolDictionaries: poolVarNames\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\tself note: 'WARNING: ',aString,' defined as variableSubclass:...'.\r\n\t^self \r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: poolVarNames","(\r\nfunction(self,aString,aString2,classVarNames,poolVarNames)\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((\"WARNING: \"),aString)),\" defined as variableSubclass:...\"));\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,classVarNames,poolVarNames));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:",0
,(
function(self,aString,aString2,classVarNames,poolVarNames,aCategory)
if (smalltalk:notNil_((((self):smalltalk()):globalAt_(aString))))==true then (self):note_(smalltalk:object_comma_(("WARNING: class REdefinition for "),aString)); end;
return (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(self,aString,aString2,classVarNames,poolVarNames,aCategory));
end
)
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\tpoolDictionaries: poolVarNames\r\n\tcategory: aCategory\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t(self smalltalk globalAt: aString) notNil ifTrue: [\r\n\t\tself note: 'WARNING: class REdefinition for ',aString.\r\n\t\t\"^self smalltalk globalAt: aString\"\r\n\t].\r\n\r\n\"\tself note: 'Creating ',aString.\"\r\n\t^ClassBuilder new\r\n\t\tsuperclass: self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: poolVarNames\r\n\t\tcategory: aCategory","(\r\nfunction(self,aString,aString2,classVarNames,poolVarNames,aCategory)\r\nif (smalltalk:notNil_((((self):smalltalk()):globalAt_(aString))))==true then (self):note_(smalltalk:object_comma_((\"WARNING: class REdefinition for \"),aString)); end;\r\nreturn (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(self,aString,aString2,classVarNames,poolVarNames,aCategory));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:classVariableNames:category:",0
,(
function(self,aString,aString2,classVarNames,aCategory)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,classVarNames,"",aCategory));
end
)
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\tcategory: aCategory\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self subclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: ''\r\n\t\tcategory: aCategory","(\r\nfunction(self,aString,aString2,classVarNames,aCategory)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,classVarNames,\"\",aCategory));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:",0
,(
function(self,aString,aString2,classVarNames,poolVarNames)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,classVarNames,poolVarNames,nil));
end
)
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\tpoolDictionaries: poolVarNames\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: poolVarNames\r\n\t\tcategory: nil","(\r\nfunction(self,aString,aString2,classVarNames,poolVarNames)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,classVarNames,poolVarNames,nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:poolDictionaries:category:",0
,(
function(self,aString,aString2,poolVarNames,aCategory)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,"",poolVarNames,aCategory));
end
)
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tpoolDictionaries: poolVarNames\r\n\tcategory: aCategory\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: ''\r\n\t\tpoolDictionaries: poolVarNames\r\n\t\tcategory: aCategory","(\r\nfunction(self,aString,aString2,poolVarNames,aCategory)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,\"\",poolVarNames,aCategory));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"variableByteSubclass:classVariableNames:",0
,(
function(self,aString,classVarNames)
return ((self):variableByteSubclass_classVariableNames_poolDictionaries_(aString,classVarNames,""));
end
)
,"instantiation","variableByteSubclass: aString classVariableNames: classVarNames\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tvariableByteSubclass: aString\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: ''","(\r\nfunction(self,aString,classVarNames)\r\nreturn ((self):variableByteSubclass_classVariableNames_poolDictionaries_(aString,classVarNames,\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"variableByteSubclass:poolDictionaries:",0
,(
function(self,aString,aString2)
return ((self):variableByteSubclass_classVariableNames_poolDictionaries_(aString,"",aString2));
end
)
,"instantiation","variableByteSubclass: aString poolDictionaries: aString2\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tvariableByteSubclass: aString\r\n\t\tclassVariableNames: ''\r\n\t\tpoolDictionaries: aString2","(\r\nfunction(self,aString,aString2)\r\nreturn ((self):variableByteSubclass_classVariableNames_poolDictionaries_(aString,\"\",aString2));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"variableByteSubclass:",0
,(
function(self,aString)
return ((self):variableByteSubclass_classVariableNames_(aString,""));
end
)
,"instantiation","variableByteSubclass: aString\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tvariableByteSubclass: aString\r\n\t\tclassVariableNames: ''","(\r\nfunction(self,aString)\r\nreturn ((self):variableByteSubclass_classVariableNames_(aString,\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"variableSubclass:instanceVariableNames:classVariableNames:",0
,(
function(self,aString,aString2,classVarNames)
return ((self):variableSubclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,classVarNames,""));
end
)
,"instantiation","variableSubclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self \r\n\t\tvariableSubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: ''","(\r\nfunction(self,aString,aString2,classVarNames)\r\nreturn ((self):variableSubclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,classVarNames,\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"variableSubclass:instanceVariableNames:",0
,(
function(self,aString,aString2)
return ((self):variableSubclass_instanceVariableNames_classVariableNames_(aString,aString2,""));
end
)
,"instantiation","variableSubclass: aString instanceVariableNames: aString2\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self \r\n\t\tvariableSubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: ''","(\r\nfunction(self,aString,aString2)\r\nreturn ((self):variableSubclass_instanceVariableNames_classVariableNames_(aString,aString2,\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"variableSubclass:classVariableNames:",0
,(
function(self,aString,aString2)
return ((self):variableSubclass_instanceVariableNames_classVariableNames_(aString,"",aString2));
end
)
,"instantiation","variableSubclass: aString classVariableNames: aString2\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self \r\n\t\tvariableSubclass: aString\r\n\t\tinstanceVariableNames: ''\r\n\t\tclassVariableNames: aString2","(\r\nfunction(self,aString,aString2)\r\nreturn ((self):variableSubclass_instanceVariableNames_classVariableNames_(aString,\"\",aString2));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"variableSubclass:poolDictionaries:",0
,(
function(self,aString,aString2)
return ((self):variableSubclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,"","",aString2));
end
)
,"instantiation","variableSubclass: aString poolDictionaries: aString2\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self \r\n\t\tvariableSubclass: aString\r\n\t\tinstanceVariableNames: ''\r\n\t\tclassVariableNames: ''\r\n\t\tpoolDictionaries: aString2","(\r\nfunction(self,aString,aString2)\r\nreturn ((self):variableSubclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,\"\",\"\",aString2));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"variableSubclass:",0
,(
function(self,aString)
return ((self):variableSubclass_instanceVariableNames_(aString,""));
end
)
,"instantiation","variableSubclass: aString\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self \r\n\t\tvariableSubclass: aString\r\n\t\tinstanceVariableNames: ''","(\r\nfunction(self,aString)\r\nreturn ((self):variableSubclass_instanceVariableNames_(aString,\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:classVariableNames:",0
,(
function(self,aString,aString2,classVarNames)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,classVarNames,""));
end
)
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: ''","(\r\nfunction(self,aString,aString2,classVarNames)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,classVarNames,\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:poolDictionaries:",0
,(
function(self,aString,aString2,aString3)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,"",aString3));
end
)
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tpoolDictionaries: aString3\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: ''\r\n\t\tpoolDictionaries: aString3","(\r\nfunction(self,aString,aString2,aString3)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,\"\",aString3));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"subclass:classVariableNames:",0
,(
function(self,aString,aString2)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,"",aString2,""));
end
)
,"instantiation","subclass: aString classVariableNames: aString2\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: ''\r\n\t\tclassVariableNames: aString2\r\n\t\tpoolDictionaries: ''","(\r\nfunction(self,aString,aString2)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,\"\",aString2,\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"subclass:poolDictionaries:",0
,(
function(self,aString,aString2)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,"","",aString2));
end
)
,"instantiation","subclass: aString poolDictionaries: aString2\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: ''\r\n\t\tclassVariableNames: ''\r\n\t\tpoolDictionaries: aString2","(\r\nfunction(self,aString,aString2)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,\"\",\"\",aString2));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"subclass:",0
,(
function(self,aString)
return ((self):subclass_instanceVariableNames_(aString,""));
end
)
,"instantiation","subclass: aString\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: ''","(\r\nfunction(self,aString)\r\nreturn ((self):subclass_instanceVariableNames_(aString,\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"hackDNU",0
,(
function(self)
local all=nil
(function()
	local _s8_value=((smalltalk.HashedSet):new())
	all=_s8_value
	return _s8_value
end)();
((smalltalk.Smalltalk):rootClasses()):do_((function(root)
return (((root):allSubclasses()):do_((function(each)
return ((
function(_s8_rec)
	(_s8_rec):addAll_((each):selectors());
	return ((_s8_rec):addAll_(((each)["$klass"]):selectors()))
end
)(all))
end)))
end));
((smalltalk.Smalltalk):rootClasses()):do_((function(root)
return (((root):selectors()):do_((function(each)
return ((all):remove_ifAbsent_(each,(function()
return (nil)
end)))
end)))
end));
(smalltalk:newArray({"handleOrNil", "start:end:"})):do_((function(each)
return ((all):remove_ifAbsent_(each,(function()
return (nil)
end)))
end));
(all):do_((function(selector)
local mth=nil
(function()
	local _s8_value=((smalltalk.CompiledMethod):new())
	mth=_s8_value
	return _s8_value
end)();(
function(_s8_rec)
	(_s8_rec):selector_(selector);
	(_s8_rec):classField_(self);
	(_s8_rec):category_("hackDNU");
	return ((_s8_rec):source_(smalltalk:object_comma_((selector),"(dnu)")))
end
)(mth);self:notImplementedYet_("hackDNU");return ((self):basicAddCompiledMethod_(mth))
end));
return (self);
end
)
,"Tools-hacking","hackDNU\r\n\t\" Catch DNU condition in the receiver and its subclasses.\r\n\tNote: hack will persist until #unhackDNU is sent to the receiver.\r\n\t\"\r\n\r\n\t| all |\r\n\tall := HashedSet new.\r\n\tSmalltalk rootClasses do: [:root|\r\n\t\troot allSubclasses do: [:each|\r\n\t\t\tall addAll: each selectors; addAll: each class selectors\r\n\t\t].\r\n\t].\r\n\tSmalltalk rootClasses do: [:root| root selectors do: [:each| all remove: each ifAbsent: []] ].\r\n\t#( #handleOrNil #start:end: ) do: [:each| all remove: each ifAbsent: []].\r\n\tall do: [:selector| | mth |\r\n\t\tmth := CompiledMethod new.\r\n\t\tmth selector: selector; classField: self; category: #hackDNU; source: selector,'(dnu)'.\r\n\t\t{''}.\r\n\t\tself basicAddCompiledMethod: mth.\r\n\t].","(\r\nfunction(self)\r\nlocal all=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.HashedSet):new())\r\n\tall=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((smalltalk.Smalltalk):rootClasses()):do_((function(root)\r\nreturn (((root):allSubclasses()):do_((function(each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAll_((each):selectors());\r\n\treturn ((_s8_rec):addAll_(((each)[\"$klass\"]):selectors()))\r\nend\r\n)(all))\r\nend)))\r\nend));\r\n((smalltalk.Smalltalk):rootClasses()):do_((function(root)\r\nreturn (((root):selectors()):do_((function(each)\r\nreturn ((all):remove_ifAbsent_(each,(function()\r\nreturn (nil)\r\nend)))\r\nend)))\r\nend));\r\n(smalltalk:newArray({\"handleOrNil\", \"start:end:\"})):do_((function(each)\r\nreturn ((all):remove_ifAbsent_(each,(function()\r\nreturn (nil)\r\nend)))\r\nend));\r\n(all):do_((function(selector)\r\nlocal mth=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.CompiledMethod):new())\r\n\tmth=_s8_value\r\n\treturn _s8_value\r\nend)();(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):selector_(selector);\r\n\t(_s8_rec):classField_(self);\r\n\t(_s8_rec):category_(\"hackDNU\");\r\n\treturn ((_s8_rec):source_(smalltalk:object_comma_((selector),\"(dnu)\")))\r\nend\r\n)(mth);self:notImplementedYet_(\"hackDNU\");return ((self):basicAddCompiledMethod_(mth))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"unhackDNU",0
,(
function(self)
(self):removeSelectors_(((self):selectors()):select_((function(each)
return (smalltalk:isObject_equalTo_((((smalltalk.Object):_gt_gt(each)):category()),"hackDNU"))
end)));
return (self);
end
)
,"Tools-hacking","unhackDNU\r\n\t\" Remove Catch DNU hacking on the receiver. \"\r\n\r\n\tself removeSelectors: (self selectors\r\n\t\tselect: [:each| (Object >> each) category = #hackDNU ])","(\r\nfunction(self)\r\n(self):removeSelectors_(((self):selectors()):select_((function(each)\r\nreturn (smalltalk:isObject_equalTo_((((smalltalk.Object):_gt_gt(each)):category()),\"hackDNU\"))\r\nend)));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"hackDNUWhile:",0
,(
function(self,aBlock)
local result=nil
((function()
(self):hackDNU();return ((function()
	local _s8_value=((aBlock):evaluate())
	result=_s8_value
	return _s8_value
end)())
end)):ensure_((function()
return ((self):unhackDNU())
end));
return (result);
end
)
,"Tools-hacking","hackDNUWhile: aBlock\r\n\t\" Catch DNU hacking on the receiver while evaluating aBlock. \"\r\n\r\n\t| result |\r\n\t[\tself hackDNU.\r\n\t\tresult := aBlock evaluate\r\n\t] ensure: [ self unhackDNU ].\r\n\t^result","(\r\nfunction(self,aBlock)\r\nlocal result=nil\r\n((function()\r\n(self):hackDNU();return ((function()\r\n\tlocal _s8_value=((aBlock):evaluate())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):ensure_((function()\r\nreturn ((self):unhackDNU())\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"launch",0
,(
function(self)
return (self);
end
)
,"Snapshot-startup","launch\r\n\t\" Private - The system has been launched and start execution.\r\n\tThe default action is to do nothing.\r\n\tSubclasses can refine this method to execute actions on startup.\r\n\t\"","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"aboutToSaveImage:on:",0
,(
function(self,snapshot,stream)
return (self);
end
)
,"Snapshot-snapshot","aboutToSaveImage: snapshot on: stream\r\n\t\" Private - A system snapshot will be taken, the receiver can prepare the contents to be stored on snapshot.\r\n\tMust return the receiver or a replacement to act as the receiver when persisting data.\r\n\tThe default action return the receiver.\r\n\t\"\r\n\r\n\t^self","(\r\nfunction(self,snapshot,stream)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"imageSaved:on:",0
,(
function(self,snapshot,stream)
return (self);
end
)
,"Snapshot-snapshot","imageSaved: snapshot on: stream\r\n\t\" Private - A system snapshot has been taken, the receiver can emmit code to restore state.\r\n\tThe default action do nothing.\r\n\tThis method can be refined by the subclasses.\r\n\t\"","(\r\nfunction(self,snapshot,stream)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Class,"aboutToExit:",0
,(
function(self,aSystemDictionary)
return (self);
end
)
,"Snapshot-snapshot","aboutToExit: aSystemDictionary\r\n\t\" Private - A system will exit, and the receiver can act executing actions just before exiting.\r\n\tThe default action do nothing.\r\n\tThis method can be refined by the subclasses.\r\n\t\"","(\r\nfunction(self,aSystemDictionary)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Metaclass,"instanceClass",0
,(
function(self)
return (self["@instanceClass"]);
end
)
,"accessing","instanceClass\r\n\t\" Return the instance class of receiver. \"\r\n\r\n\t^instanceClass","(\r\nfunction(self)\r\nreturn (self[\"@instanceClass\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Metaclass,"instanceVariableNames:",0
,(
function(self,aString)
((smalltalk.ClassBuilder):new()):class_instanceVariableNames_(self,aString);
return ((self):instanceVariableNames());
end
)
,"accessing","instanceVariableNames: aString\r\n\t\" Set the instance variable names of the receiver. \"\r\n\r\n\tClassBuilder new\r\n\t\tclass: self\r\n\t\tinstanceVariableNames: aString.\r\n\t^self instanceVariableNames ","(\r\nfunction(self,aString)\r\n((smalltalk.ClassBuilder):new()):class_instanceVariableNames_(self,aString);\r\nreturn ((self):instanceVariableNames());\r\nend\r\n)")
smalltalk:bind(smalltalk.Metaclass,"isMetaclass",0
,(
function(self)
return (true);
end
)
,"testing","isMetaclass\r\n\t\" Return true if the receiver is a metaclass. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.Metaclass,"printString",0
,(
function(self)
return (smalltalk:object_comma_((((self):instanceClass()):name())," class"));
end
)
,"printing","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t^self instanceClass name, ' class'","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((((self):instanceClass()):name()),\" class\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Metaclass,"classVariables",0
,(
function(self)
return (((self):instanceClass()):classVariables());
end
)
,"accessing","classVariables\r\n\t\" Return the class variables of the receiver. \"\r\n\r\n\t^self instanceClass classVariables","(\r\nfunction(self)\r\nreturn (((self):instanceClass()):classVariables());\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"source",0
,(
function(self)
return (smalltalk:basic_at_ifAbsent_((self),"$source",(function()
return ("")
end)));
end
)
,"accessing","source\r\n\t\" Return the source code of the receiver. \"\r\n\r\n\t^self basicAt: '$source' ifAbsent: ['']","(\r\nfunction(self)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),\"$source\",(function()\r\nreturn (\"\")\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"source:",0
,(
function(self,aString)
smalltalk:basic_at_put_((self),"$source",aString);
return (self);
end
)
,"accessing","source: aString\r\n\t\" Set the source code of the receiver. \"\r\n\r\n\tself basicAt: '$source' put: aString","(\r\nfunction(self,aString)\r\nsmalltalk:basic_at_put_((self),\"$source\",aString);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"category",0
,(
function(self)
return (smalltalk:basic_at_ifAbsent_((self),"$category",(function()
return ("")
end)));
end
)
,"accessing","category\r\n\t\" Return the category of the receiver. \"\r\n\r\n\t^self basicAt: '$category' ifAbsent: ['']","(\r\nfunction(self)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),\"$category\",(function()\r\nreturn (\"\")\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"category:",0
,(
function(self,aString)
smalltalk:basic_at_put_((self),"$category",aString);
return (self);
end
)
,"accessing","category: aString\r\n\t\" Set the category of the receiver. \"\r\n\r\n\tself basicAt: '$category' put: aString","(\r\nfunction(self,aString)\r\nsmalltalk:basic_at_put_((self),\"$category\",aString);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"stamp",0
,(
function(self)
return ((self)["$stamp"]);
end
)
,"accessing","stamp\r\n\t\" Return the stamp of the receiver. \"\r\n\r\n\t^self basicAt: '$stamp'","(\r\nfunction(self)\r\nreturn ((self)[\"$stamp\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"stamp:",0
,(
function(self,aString)
smalltalk:basic_at_put_((self),"$stamp",aString);
return (self);
end
)
,"accessing","stamp: aString\r\n\t\" Set the stamp of the receiver. \"\r\n\r\n\tself basicAt: '$stamp' put: aString","(\r\nfunction(self,aString)\r\nsmalltalk:basic_at_put_((self),\"$stamp\",aString);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"selector",0
,(
function(self)
return ((self)["$selector"]);
end
)
,"accessing","selector\r\n\t\" Return the selector of the receiver. \"\r\n\r\n\t^self basicAt: '$selector'","(\r\nfunction(self)\r\nreturn ((self)[\"$selector\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"selector:",0
,(
function(self,aString)
smalltalk:basic_at_put_((self),"$selector",aString);
return (self);
end
)
,"accessing","selector: aString\r\n\t\" Set the selector of the receiver. \"\r\n\r\n\tself basicAt: '$selector' put: aString","(\r\nfunction(self,aString)\r\nsmalltalk:basic_at_put_((self),\"$selector\",aString);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"fn",0
,(
function(self)
return ((self)["$fn"]);
end
)
,"accessing","fn\r\n\t\" Return the native implementation of the receiver (or nil). \"\r\n\r\n\t^self basicAt: '$fn'","(\r\nfunction(self)\r\nreturn ((self)[\"$fn\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"fn:",0
,(
function(self,aBlock)
smalltalk:basic_at_put_((self),"$fn",aBlock);
return (self);
end
)
,"accessing","fn: aBlock\r\n\t\" Set the native implementation of the receiver. \"\r\n\r\n\tself basicAt: '$fn' put: aBlock","(\r\nfunction(self,aBlock)\r\nsmalltalk:basic_at_put_((self),\"$fn\",aBlock);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"asClosure",0
,(
function(self)

return ((self):fn());
end
)
,"accessing","asClosure\r\n\t\" Private - Return the receiver as a native closure (or nil). \"\r\n\r\n\t{'self'}.\r\n\t^self fn","(\r\nfunction(self)\r\n\r\nreturn ((self):fn());\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"compiledSource",0
,(
function(self)
local closure=nil
(function()
	local _s8_value=((self):asClosure())
	closure=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((closure))),(function()
return ((closure):compiledSourceAt_(self))
end),nil));
end
)
,"accessing","compiledSource\r\n\t\" Return the native source code of the receiver (or nil). \"\r\n\r\n\t| closure |\r\n\tclosure := self asClosure.\r\n\t^closure notNil ifTrue: [ closure compiledSourceAt: self ]","(\r\nfunction(self)\r\nlocal closure=nil\r\n(function()\r\n\tlocal _s8_value=((self):asClosure())\r\n\tclosure=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((closure))),(function()\r\nreturn ((closure):compiledSourceAt_(self))\r\nend),nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"classField",0
,(
function(self)
return (self["@classField"]);
end
)
,"accessing","classField\r\n\t\" Return the implementor of the receiver. \"\r\n\r\n\t^classField","(\r\nfunction(self)\r\nreturn (self[\"@classField\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"classField:",0
,(
function(self,aClass)
(function()
	local _s8_value=(aClass)
	self["@classField"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","classField: aClass\r\n\t\" Set the implementor of the receiver. \"\r\n\r\n\tclassField := aClass","(\r\nfunction(self,aClass)\r\n(function()\r\n\tlocal _s8_value=(aClass)\r\n\tself[\"@classField\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"generation",0
,(
function(self)
return ((self)["$generation"]);
end
)
,"accessing","generation\r\n\t\" Return the generation of the receiver. \"\r\n\r\n\t^self basicAt: '$generation'","(\r\nfunction(self)\r\nreturn ((self)[\"$generation\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"comment",0
,(
function(self)
return (((
function(_s8_rec)
	(_s8_rec):upTo_("\"");
	return ((_s8_rec):upTo_("\""))
end
)(((self):source()):stream())):trimBlanks());
end
)
,"accessing","comment\r\n\t\" Return the comment of the receiver. \"\r\n\r\n\t^(self source stream upTo: $\"; upTo: $\") trimBlanks","(\r\nfunction(self)\r\nreturn (((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):upTo_(\"\\\"\");\r\n\treturn ((_s8_rec):upTo_(\"\\\"\"))\r\nend\r\n)(((self):source()):stream())):trimBlanks());\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"toString",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:if_true_false_((smalltalk:isNil_((self["@classField"]))),(function()
return (smalltalk:toString_((self["@classField"])))
end),(function()
return ((self["@classField"]):name())
end))),">>#")),smalltalk:toString_(((self):selector()))));
end
)
,"printing","toString\r\n\t\" Return the receiver as a String. \"\r\n\r\n\t^(classField isNil\r\n\t\tifTrue: [classField toString]\r\n\t\tifFalse: [classField name])\r\n\t\t,'>>#' ,self selector toString","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:if_true_false_((smalltalk:isNil_((self[\"@classField\"]))),(function()\r\nreturn (smalltalk:toString_((self[\"@classField\"])))\r\nend),(function()\r\nreturn ((self[\"@classField\"]):name())\r\nend))),\">>#\")),smalltalk:toString_(((self):selector()))));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"printString",0
,(
function(self)

return (smalltalk:toString_((self)));
end
)
,"printing","printString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t{'self'}.\r\n\t^self toString","(\r\nfunction(self)\r\n\r\nreturn (smalltalk:toString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"asJSONObject",0
,(
function(self)
return (self);
end
)
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"shallowCopy",0
,(
function(self)
return (self);
end
)
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"deepCopy",0
,(
function(self)
return (self);
end
)
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"removeSources",0
,(
function(self)
(
function(_s8_rec)
	(_s8_rec):source_("");
	(_s8_rec):category_("s8");
	return ((_s8_rec):builder_(nil))
end
)(self);
return (self);
end
)
,"Builders-tools","removeSources\r\n\t\" Remove all development sources of the receiver. \"\r\n\r\n\tself source: ''; category: #s8; builder: nil","(\r\nfunction(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):source_(\"\");\r\n\t(_s8_rec):category_(\"s8\");\r\n\treturn ((_s8_rec):builder_(nil))\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"removeFromSystem",0
,(
function(self)
if (smalltalk:isObject_equalTo_((((self):classField()):_gt_gt((self):selector())),self))==true then ((self):classField()):removeSelector_((self):selector()); end;
return (true);
end
)
,"remove","removeFromSystem\r\n\t\" Remove the receiver from system. \"\r\n\r\n\tself classField >> self selector = self ifTrue: [\r\n\t\tself classField removeSelector: self selector\r\n\t].\r\n\t^true","(\r\nfunction(self)\r\nif (smalltalk:isObject_equalTo_((((self):classField()):_gt_gt((self):selector())),self))==true then ((self):classField()):removeSelector_((self):selector()); end;\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"recompile",0
,(
function(self)
(((self):classField()):compiler()):compile_forClass_category_((self):source(),(self):classField(),(self):category());
return (self);
end
)
,"Compiler-compiling","recompile\r\n\t\" Recompile the source of the receiver and install the new compiled method. \"\r\n\r\n\tself classField compiler\r\n\t\tcompile: self source\r\n\t\tforClass: self classField\r\n\t\tcategory: self category","(\r\nfunction(self)\r\n(((self):classField()):compiler()):compile_forClass_category_((self):source(),(self):classField(),(self):category());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"parseNodes",0
,(
function(self)
return ((((self):classField()):compiler()):parseMethod_((self):source()));
end
)
,"Compiler-inspecting","parseNodes\r\n\t\" Return the result of parsing the source of the receiver. \"\r\n\r\n\t^self classField compiler parseMethod: self source","(\r\nfunction(self)\r\nreturn ((((self):classField()):compiler()):parseMethod_((self):source()));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"changeCommentWith:",0
,(
function(self,aBlock)
local stream=nil
local header=nil
local old=nil
local new=nil
local nl=nil
(function()
	local _s8_value=(((self):source()):stream())
	stream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((smalltalk.SmalltalkParser):new()):methodHeaderParser()):parse_(stream))
	header=_s8_value
	return _s8_value
end)();
if ((header):isParseFailure())==true then return (false); end;
(stream):skipSeparators();
(function()
	local _s8_value=(((stream):collection()):copyFrom_to_(1,(stream):position()))
	header=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((stream):peek()),"\""))==true then (stream):next();
(function()
	local _s8_value=((stream):upTo_("\""))
	old=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aBlock):evaluateWith_(old))
	new=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=((aBlock):evaluateWith_(""))
	new=_s8_value
	return _s8_value
end)(); end;
if (smalltalk:isNil_((new)))==true then return (false); end;
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((old))),(function()
return ("\r\n\t")
end),(function()
return ("")
end)))
	nl=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((nl),"\" ")),(new):trimBlanks()))," \"")),nl))
	new=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):source_(smalltalk:object_comma_((smalltalk:object_comma_((header),new)),(stream):upToEnd()));
	return ((_s8_rec):recompile())
end
)(self);
return (self);
end
)
,"Compiler-transforms","changeCommentWith: aBlock\r\n\t\" Private - Change the comment of the receiver with aBlock.\r\n\taBlock must be a one argument block to be evaluated with current comment.\r\n\taBlock must return the new/empty comment (or nil, to cancel change).\r\n\t\"\r\n\r\n\t| stream header old new nl |\r\n\tstream := self source stream.\r\n\theader := SmalltalkParser new methodHeaderParser parse: stream.\r\n\theader isParseFailure ifTrue: [ ^false ].\r\n\tstream skipSeparators.\r\n\theader := stream collection copyFrom: 1 to: stream position.\r\n\tstream peek = $\" ifTrue: [\r\n\t\tstream next.\r\n\t\told := stream upTo: $\".\r\n\t\tnew := aBlock evaluateWith: old.\r\n\t] ifFalse: [\r\n\t\tnew := aBlock evaluateWith: ''.\r\n\t].\r\n\tnew isNil ifTrue: [ ^false ].\r\n\tnl := old isNil ifTrue: [ '\r\n\t' ] ifFalse: [ '' ].\r\n\tnew := nl ,'\" ' ,new trimBlanks ,' \"' ,nl.\r\n\r\n\tself\r\n\t\tsource: header ,new ,stream upToEnd;\r\n\t\trecompile","(\r\nfunction(self,aBlock)\r\nlocal stream=nil\r\nlocal header=nil\r\nlocal old=nil\r\nlocal new=nil\r\nlocal nl=nil\r\n(function()\r\n\tlocal _s8_value=(((self):source()):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((smalltalk.SmalltalkParser):new()):methodHeaderParser()):parse_(stream))\r\n\theader=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((header):isParseFailure())==true then return (false); end;\r\n(stream):skipSeparators();\r\n(function()\r\n\tlocal _s8_value=(((stream):collection()):copyFrom_to_(1,(stream):position()))\r\n\theader=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((stream):peek()),\"\\\"\"))==true then (stream):next();\r\n(function()\r\n\tlocal _s8_value=((stream):upTo_(\"\\\"\"))\r\n\told=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aBlock):evaluateWith_(old))\r\n\tnew=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=((aBlock):evaluateWith_(\"\"))\r\n\tnew=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif (smalltalk:isNil_((new)))==true then return (false); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((old))),(function()\r\nreturn (\"\\r\\n\\t\")\r\nend),(function()\r\nreturn (\"\")\r\nend)))\r\n\tnl=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((nl),\"\\\" \")),(new):trimBlanks())),\" \\\"\")),nl))\r\n\tnew=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):source_(smalltalk:object_comma_((smalltalk:object_comma_((header),new)),(stream):upToEnd()));\r\n\treturn ((_s8_rec):recompile())\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"tags",0
,(
function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):changeCommentWith_((function(old)
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((((old):upTo_("-")):asArrayOfSubstringsSeparatedBy_(",")):collect_((function(tag)
return ((tag):trimBlanks())
end)))
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.Array):new())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"Compiler-tags","tags\r\n\t\" Development - Return the tags stored in the receiver's comment. \"\r\n\r\n\tself changeCommentWith: [:old|\r\n\t\t^((old upTo: $-)\r\n\t\t\tasArrayOfSubstringsSeparatedBy: $,)\r\n\t\t\tcollect: [:tag| tag trimBlanks ]\r\n\t].\r\n\t^Array new","(\r\nfunction(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):changeCommentWith_((function(old)\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((((old):upTo_(\"-\")):asArrayOfSubstringsSeparatedBy_(\",\")):collect_((function(tag)\r\nreturn ((tag):trimBlanks())\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.Array):new())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"comment:",0
,(
function(self,aString)
return ((self):changeCommentWith_((function(old)
return (aString)
end)));
end
)
,"Compiler-accessing","comment: aString\r\n\t\" Change the comment in the receiver to aString. \"\r\n\r\n\t^self changeCommentWith: [:old| aString ]","(\r\nfunction(self,aString)\r\nreturn ((self):changeCommentWith_((function(old)\r\nreturn (aString)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"messageComment",0
,(
function(self)
local line=nil
(function()
	local _s8_value=((((self):comment()):stream()):nextLine())
	line=_s8_value
	return _s8_value
end)();
if not (((line):includes_("-")))==true then return (line); end;
return (((
function(_s8_rec)
	(_s8_rec):upTo_("-");
	return ((_s8_rec):upToEnd())
end
)((line):stream())):trimBlanks());
end
)
,"Compiler-accessing","messageComment\r\n\t\" Return the comment of the message implemented by the receiver.\r\n\tThe messageComment is obtained from first line of comment of the receiver.\r\n\tNote: it is expected that all the methods implementing the same message in this system have the same messageComment.\r\n\t\"\r\n\r\n\t| line |\r\n\tline := self comment stream nextLine.\r\n\t(line includes: $-) ifFalse: [ ^line ].\r\n\t^(line stream upTo: $-; upToEnd) trimBlanks","(\r\nfunction(self)\r\nlocal line=nil\r\n(function()\r\n\tlocal _s8_value=((((self):comment()):stream()):nextLine())\r\n\tline=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((line):includes_(\"-\")))==true then return (line); end;\r\nreturn (((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):upTo_(\"-\");\r\n\treturn ((_s8_rec):upToEnd())\r\nend\r\n)((line):stream())):trimBlanks());\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"messageComment:",0
,(
function(self,aString)
return ((self):changeCommentWith_((function(old)
local line=nil
local tags=nil
local stream=nil
(function()
	local _s8_value=((old):stream())
	stream=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((stream):nextLine())
	line=_s8_value
	return _s8_value
end)();if ((line):includes_("-"))==true then (function()
	local _s8_value=(smalltalk:object_comma_(((line):upTo_("-")),"- "))
	tags=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=("")
	tags=_s8_value
	return _s8_value
end)(); end;return (smalltalk:object_comma_((smalltalk:object_comma_((tags),aString)),smalltalk:if_true_false_(((stream):atEnd()),(function()
return ("")
end),(function()
return (smalltalk:object_comma_(("\r\n"),(stream):upToEnd()))
end))))
end)));
end
)
,"Compiler-transforms","messageComment: aString\r\n\t\" Set the comment of the message implemented by the receiver. \"\r\n\r\n\t^self changeCommentWith: [:old| | line tags stream |\r\n\t\tstream := old stream.\r\n\t\tline := stream nextLine.\r\n\t\t(line includes: $-) ifTrue: [\r\n\t\t\ttags := (line upTo: $-) ,'- '\r\n\t\t] ifFalse: [ tags := '' ].\r\n\t\ttags\t,aString ,(stream atEnd ifTrue: [''] ifFalse: ['\r\n'\t\t\t,stream upToEnd])\r\n\t]","(\r\nfunction(self,aString)\r\nreturn ((self):changeCommentWith_((function(old)\r\nlocal line=nil\r\nlocal tags=nil\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((old):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((stream):nextLine())\r\n\tline=_s8_value\r\n\treturn _s8_value\r\nend)();if ((line):includes_(\"-\"))==true then (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((line):upTo_(\"-\")),\"- \"))\r\n\ttags=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=(\"\")\r\n\ttags=_s8_value\r\n\treturn _s8_value\r\nend)(); end;return (smalltalk:object_comma_((smalltalk:object_comma_((tags),aString)),smalltalk:if_true_false_(((stream):atEnd()),(function()\r\nreturn (\"\")\r\nend),(function()\r\nreturn (smalltalk:object_comma_((\"\\r\\n\"),(stream):upToEnd()))\r\nend))))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"messages",0
,(
function(self)
return ((((self):smalltalk()):methodReferences()):messagesOf_(self));
end
)
,"Tools-accessing","messages\r\n\t\" Return all the messages that can be sent during execution of the receiver. \"\r\n\r\n\t^self smalltalk methodReferences messagesOf: self","(\r\nfunction(self)\r\nreturn ((((self):smalltalk()):methodReferences()):messagesOf_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"globalReferences",0
,(
function(self)
return ((((self):smalltalk()):methodReferences()):globalReferencesOf_(self));
end
)
,"Tools-accessing","globalReferences\r\n\t\" Return all the global references in the receiver. \"\r\n\r\n\t^self smalltalk methodReferences globalReferencesOf: self","(\r\nfunction(self)\r\nreturn ((((self):smalltalk()):methodReferences()):globalReferencesOf_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"references",0
,(
function(self)
return ((
function(_s8_rec)
	(_s8_rec):at_put_("messages",(self):messages());
	(_s8_rec):at_put_("globalReferences",(self):globalReferences());
	return ((_s8_rec):yourself())
end
)((smalltalk.PoolDictionary):new()));
end
)
,"Tools-accessing","references\r\n\t\" Return all the references in the receiver. \"\r\n\r\n\t^PoolDictionary new\r\n\t\tat: #messages put: self messages;\r\n\t\tat: #globalReferences put: self globalReferences;\r\n\t\tyourself","(\r\nfunction(self)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):at_put_(\"messages\",(self):messages());\r\n\t(_s8_rec):at_put_(\"globalReferences\",(self):globalReferences());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.PoolDictionary):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"builder:",0
,(
function(self,cookie)
smalltalk:basic_at_put_((self),"$builder",cookie);
return (self);
end
)
,"Builders-accessing","builder: cookie\r\n\t\" Private - Set the builder cookie of the receiver. \"\r\n\r\n\tself basicAt: '$builder' put: cookie","(\r\nfunction(self,cookie)\r\nsmalltalk:basic_at_put_((self),\"$builder\",cookie);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"builder",0
,(
function(self)
return ((self)["$builder"]);
end
)
,"Builders-accessing","builder\r\n\t\" Private - Return the builder cookie of the receiver (or nil). \"\r\n\r\n\t^self basicAt: '$builder'","(\r\nfunction(self)\r\nreturn ((self)[\"$builder\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompiledMethod,"__tostring",0
,(
function(self)
return (smalltalk:toString_((self)));
end
)
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","(\r\nfunction(self)\r\nreturn (smalltalk:toString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number["$klass"],"pi",0
,(
function(self)
return (math.pi);
end
)
,"instantiation","pi\r\n\t\" Return the singular value PI. \"\r\n\r\n\t^{'' doc'native constant'}","(\r\nfunction(self)\r\nreturn (math.pi);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number["$klass"],"readFrom:radix:",0
,(
function(self,aStream,radix)
local value=nil
local char=nil
(function()
	local _s8_value=(0)
	value=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((aStream):peek())
	char=_s8_value
	return _s8_value
end)();return (smalltalk:boolean_and_((smalltalk:notNil_((char))),(function()
return (smalltalk:boolean_or_(((char):isDigit()),(function()
return ((char):isUpperCase())
end)))
end)))
end))() do if (((radix) < (char):digitValue()))==true then return (value); end;
(function()
	local _s8_value=(((value):_star(radix)):_plus((char):digitValue()))
	value=_s8_value
	return _s8_value
end)();
(aStream):next(); end;
return (value);
end
)
,"converting","readFrom: aStream radix: radix\r\n\t\" Private - Read an integer from <aStream> and return it. \"\r\n\r\n\t| value char |\r\n\tvalue := 0.\r\n\t[\tchar := aStream peek.\r\n\t\tchar notNil and: [ char isDigit or: [ char isUpperCase ] ]\r\n\t] whileTrue: [\r\n\t\tradix <  char digitValue ifTrue: [ ^value ].\r\n\t\tvalue := value * radix + char digitValue.\r\n\t\taStream next\r\n\t].\r\n\t^value","(\r\nfunction(self,aStream,radix)\r\nlocal value=nil\r\nlocal char=nil\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((aStream):peek())\r\n\tchar=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:boolean_and_((smalltalk:notNil_((char))),(function()\r\nreturn (smalltalk:boolean_or_(((char):isDigit()),(function()\r\nreturn ((char):isUpperCase())\r\nend)))\r\nend)))\r\nend))() do if (((radix) < (char):digitValue()))==true then return (value); end;\r\n(function()\r\n\tlocal _s8_value=(((value):_star(radix)):_plus((char):digitValue()))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aStream):next(); end;\r\nreturn (value);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number["$klass"],"readFrom:",0
,(
function(self,aStream)
local value=nil
local char=nil
(function()
	local _s8_value=(0)
	value=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((aStream):peek())
	char=_s8_value
	return _s8_value
end)();return (smalltalk:boolean_and_((smalltalk:notNil_((char))),(function()
return ((char):isDigit())
end)))
end))() do (function()
	local _s8_value=(((value):_star(10)):_plus((char):digitValue()))
	value=_s8_value
	return _s8_value
end)();
(aStream):next(); end;
if not ((smalltalk:isObject_equalTo_(("r"),char)))==true then return (value); end;
(aStream):next();
return ((self):readFrom_radix_(aStream,value));
end
)
,"converting","readFrom: aStream\r\n\t\" Private - Read an integer from <aStream> and return it. \"\r\n\r\n\t| value char |\r\n\tvalue := 0.\r\n\t[\tchar := aStream peek.\r\n\t\tchar notNil and: [ char isDigit ]\r\n\t] whileTrue: [\r\n\t\tvalue := value * 10 + char digitValue.\r\n\t\taStream next\r\n\t].\r\n\t$r = char ifFalse: [ ^value ].\r\n\taStream next.\r\n\t^self readFrom: aStream radix: value","(\r\nfunction(self,aStream)\r\nlocal value=nil\r\nlocal char=nil\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((aStream):peek())\r\n\tchar=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:boolean_and_((smalltalk:notNil_((char))),(function()\r\nreturn ((char):isDigit())\r\nend)))\r\nend))() do (function()\r\n\tlocal _s8_value=(((value):_star(10)):_plus((char):digitValue()))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aStream):next(); end;\r\nif not ((smalltalk:isObject_equalTo_((\"r\"),char)))==true then return (value); end;\r\n(aStream):next();\r\nreturn ((self):readFrom_radix_(aStream,value));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number["$klass"],"readFromOBSOLETE:",0
,(
function(self,aStream)
local value=nil
local char=nil
(function()
	local _s8_value=(0)
	value=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((aStream):peek())
	char=_s8_value
	return _s8_value
end)();return (smalltalk:boolean_and_((smalltalk:notNil_((char))),(function()
return ((char):isDigit())
end)))
end))() do (function()
	local _s8_value=(((value):_star(10)):_plus((char):digitValue()))
	value=_s8_value
	return _s8_value
end)();
(aStream):next(); end;
if not ((((char)=="r")))==true then return (value); end;
(aStream):next();
return ((self):readFrom_radix_(aStream,value));
end
)
,"converting","readFromOBSOLETE: aStream\r\n\t\" Private - Read an integer from <aStream> and return it. \"\r\n\r\n\t| value char |\r\n\tvalue := 0.\r\n\t[\tchar := aStream peek.\r\n\t\tchar notNil and: [ char isDigit ]\r\n\t] whileTrue: [\r\n\t\tvalue := value * 10 + char digitValue.\r\n\t\taStream next\r\n\t].\r\n\tchar == \"$r\"'r' ifFalse: [ ^value ].\r\n\taStream next. \"skip the r\"\r\n\t^self readFrom: aStream radix: value","(\r\nfunction(self,aStream)\r\nlocal value=nil\r\nlocal char=nil\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((aStream):peek())\r\n\tchar=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:boolean_and_((smalltalk:notNil_((char))),(function()\r\nreturn ((char):isDigit())\r\nend)))\r\nend))() do (function()\r\n\tlocal _s8_value=(((value):_star(10)):_plus((char):digitValue()))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aStream):next(); end;\r\nif not ((((char)==\"r\")))==true then return (value); end;\r\n(aStream):next();\r\nreturn ((self):readFrom_radix_(aStream,value));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number["$klass"],"@","_at"
,(
function(self,aHandle)
return (smalltalk:if_true_false_((smalltalk:notNil_((aHandle))),(function()
return ((aHandle):asNumber())
end),nil));
end
)
,"Natives-converting","@ aHandle\r\n\t\" Return an instance of the receiver from aHandle. \"\r\n\r\n\t^aHandle notNil ifTrue: [ aHandle asNumber ]","(\r\nfunction(self,aHandle)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((aHandle))),(function()\r\nreturn ((aHandle):asNumber())\r\nend),nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"=","_eq"
,(
function(self,anObject)

	if (type(anObject)=="number")
		then return self==anObject
		else return false
		end;
return (self);
end
)
,"comparing","= anObject\r\n    \" Return true if the receiver is equal to argument. \"\r\n\r\n\t{'' doc'number equality test'}","(\r\nfunction(self,anObject)\r\n\r\n\tif (type(anObject)==\"number\")\r\n\t\tthen return self==anObject\r\n\t\telse return false\r\n\t\tend;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"mustBeNumber",0
,(
function(self)
return (self);
end
)
,"testing","mustBeNumber\r\n\t\" Signal an error if the receiver is not a Number.\r\n\tWARNING: this check impose a severe loss of perfomance (five times slower).\r\n\tIf you are sure the operation/compare arguments are ok (a number),\r\n\t comment the implementation of this method making the code empty.\r\n\t\"\r\n\r\n\t\"(# #isNaN: self) ifTrue: [ super mustBeNumber ]\"","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,">","_gt"
,(
function(self,aNumber)
return (self > aNumber);
end
)
,"comparing","> aNumber\r\n\t\" Return true if the receiver is greater than argument. \"\r\n\r\n\t^{'' doc'number compare'}","(\r\nfunction(self,aNumber)\r\nreturn (self > aNumber);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"<","_lt"
,(
function(self,aNumber)
return (self < aNumber);
end
)
,"comparing","< aNumber\r\n\t\" Return true if the receiver is smaller than argument. \"\r\n\r\n\t^{'' doc'number compare'}","(\r\nfunction(self,aNumber)\r\nreturn (self < aNumber);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,">=","_gt_eq"
,(
function(self,aNumber)
return (self >= aNumber);
end
)
,"comparing",">= aNumber\r\n\t\" Return true if the receiver is greater or equal to argument. \"\r\n\r\n\t^{'' doc'number compare'}","(\r\nfunction(self,aNumber)\r\nreturn (self >= aNumber);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"<=","_lt_eq"
,(
function(self,aNumber)
return (self <= aNumber);
end
)
,"comparing","<= aNumber\r\n\t\" Return true if the receiver is smaller or equal to argument. \"\r\n\r\n\t^{'' doc'number compare'}","(\r\nfunction(self,aNumber)\r\nreturn (self <= aNumber);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"+","_plus"
,(
function(self,aNumber)
return (self + aNumber);
end
)
,"arithmetic","+ aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self,aNumber)\r\nreturn (self + aNumber);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"-","_minus"
,(
function(self,aNumber)
return (self - aNumber);
end
)
,"arithmetic","- aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self,aNumber)\r\nreturn (self - aNumber);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"*","_star"
,(
function(self,aNumber)
return (self * aNumber);
end
)
,"arithmetic","* aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self,aNumber)\r\nreturn (self * aNumber);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"/","_slash"
,(
function(self,aNumber)
return (self / aNumber);
end
)
,"arithmetic","/ aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self,aNumber)\r\nreturn (self / aNumber);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"divideByZero",0
,(
function(self)
return ((self):error_("Divide by Zero"));
end
)
,"signaling","divideByZero\r\n\t\" Signal divide by cero attempt. \"\r\n\r\n\t^self error: 'Divide by Zero'","(\r\nfunction(self)\r\nreturn ((self):error_(\"Divide by Zero\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"\\\\","_bk_bk"
,(
function(self,aNumber)
(aNumber):mustBeNumber();
if (smalltalk:isObject_equalTo_((aNumber),0))==true then (self):divideByZero(); end;
return ((self):_minus(((self):_slash_slash(aNumber)):_star(aNumber)));
end
)
,"arithmetic","\\\\\\\\ aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\taNumber mustBeNumber.\r\n\taNumber = 0 ifTrue: [ self divideByZero ].\r\n\t^self - (self // aNumber * aNumber)","(\r\nfunction(self,aNumber)\r\n(aNumber):mustBeNumber();\r\nif (smalltalk:isObject_equalTo_((aNumber),0))==true then (self):divideByZero(); end;\r\nreturn ((self):_minus(((self):_slash_slash(aNumber)):_star(aNumber)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"//","_slash_slash"
,(
function(self,aNumber)
(aNumber):mustBeNumber();
if (smalltalk:isObject_equalTo_((aNumber),0))==true then (self):divideByZero(); end;
return (((self):_slash(aNumber)):truncated());
end
)
,"arithmetic","// aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\taNumber mustBeNumber.\r\n\taNumber = 0 ifTrue: [ self divideByZero ].\r\n\t^(self / aNumber) truncated","(\r\nfunction(self,aNumber)\r\n(aNumber):mustBeNumber();\r\nif (smalltalk:isObject_equalTo_((aNumber),0))==true then (self):divideByZero(); end;\r\nreturn (((self):_slash(aNumber)):truncated());\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"sin",0
,(
function(self)
return (math.sin(self));
end
)
,"arithmetic","sin\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self)\r\nreturn (math.sin(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"cos",0
,(
function(self)
return (math.cos(self));
end
)
,"arithmetic","cos\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self)\r\nreturn (math.cos(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"tan",0
,(
function(self)
return (math.tan(self));
end
)
,"arithmetic","tan\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self)\r\nreturn (math.tan(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"arcCos",0
,(
function(self)
return (math.acos(self));
end
)
,"arithmetic","arcCos\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self)\r\nreturn (math.acos(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"arcSin",0
,(
function(self)
return (math.asin(self));
end
)
,"arithmetic","arcSin\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self)\r\nreturn (math.asin(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"arcTan",0
,(
function(self)
return (math.atan(self));
end
)
,"arithmetic","arcTan\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self)\r\nreturn (math.atan(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"atan2:",0
,(
function(self,aNumber)
return (math.atan2(self,aNumber));
end
)
,"arithmetic","atan2: aNumber\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self,aNumber)\r\nreturn (math.atan2(self,aNumber));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"negated",0
,(
function(self)
return ((-1):_star(self));
end
)
,"arithmetic","negated\r\n\t\" Return the receiver negated\"\r\n\r\n\t^-1 * self ","(\r\nfunction(self)\r\nreturn ((-1):_star(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"squared",0
,(
function(self)
return ((self):_star(self));
end
)
,"arithmetic","squared\r\n\t^self * self ","(\r\nfunction(self)\r\nreturn ((self):_star(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"sqrt",0
,(
function(self)
return (math.sqrt(self));
end
)
,"arithmetic","sqrt\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self)\r\nreturn (math.sqrt(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"<<","_lt_lt"
,(
function(self,aNumber)
return (bit.lshift(self,aNumber));
end
)
,"arithmetic","<< aNumber\r\n\t\" Return the receiver shifted aNumber of bits to the left. \"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self,aNumber)\r\nreturn (bit.lshift(self,aNumber));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,">>","_gt_gt"
,(
function(self,aNumber)
return (bit.rshift(self,aNumber));
end
)
,"arithmetic",">> aNumber\r\n\t\" Return the receiver shifted aNumber of bits to the right. \"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self,aNumber)\r\nreturn (bit.rshift(self,aNumber));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"bitShift:",0
,(
function(self,anInteger)
if (((anInteger) < 0))==true then return ((self):_gt_gt((anInteger):negated())); end;
return ((self):_lt_lt(anInteger));
end
)
,"arithmetic","bitShift: anInteger\r\n\t\" Return the receiver shifted left anInteger number of bits if anInteger is positive, or shifted right for anInteger negated number of bits if anInteger is negative.\"\r\n\r\n\tanInteger < 0 ifTrue: [ ^self >> anInteger negated ].\r\n\t^self << anInteger","(\r\nfunction(self,anInteger)\r\nif (((anInteger) < 0))==true then return ((self):_gt_gt((anInteger):negated())); end;\r\nreturn ((self):_lt_lt(anInteger));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"raisedTo:",0
,(
function(self,aNumber)
if (smalltalk:isObject_equalTo_((aNumber),0))==true then return (1); end;
if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((self),0)),(function()
return (((aNumber) > 0))
end)))==true then return (0); end;
return (math.pow(self,aNumber));
end
)
,"arithmetic","raisedTo: aNumber\r\n\t\" Return the receiver raised to the power of aNumber. \"\r\n\r\n\taNumber = 0 ifTrue: [ ^1.0 ].\r\n\t(self = 0 and: [aNumber > 0]) ifTrue: [ ^0.0 ].\r\n\t^{'' doc'number operation'}","(\r\nfunction(self,aNumber)\r\nif (smalltalk:isObject_equalTo_((aNumber),0))==true then return (1); end;\r\nif (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((self),0)),(function()\r\nreturn (((aNumber) > 0))\r\nend)))==true then return (0); end;\r\nreturn (math.pow(self,aNumber));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"max:",0
,(
function(self,aNumber)
return (math.max(self,aNumber));
end
)
,"arithmetic","max: aNumber\r\n\t\" Return the maximum between the receiver and argument. \"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self,aNumber)\r\nreturn (math.max(self,aNumber));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"min:",0
,(
function(self,aNumber)
return (math.min(self,aNumber));
end
)
,"arithmetic","min: aNumber\r\n\t\" Return the minimum between the receiver and argument. \"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self,aNumber)\r\nreturn (math.min(self,aNumber));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"asNumber",0
,(
function(self)
return ((self):_plus(0));
end
)
,"converting","asNumber\r\n\t\" Return the receiver as a Number. \"\r\n\r\n\t^self + 0","(\r\nfunction(self)\r\nreturn ((self):_plus(0));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"abs",0
,(
function(self)
if (((self) < 0))==true then return ((self):negated()); end;
return (self);
end
)
,"converting","abs\r\n\t\" Return the absolute value of the receiver. \"\r\n\r\n\tself < 0 ifTrue: [ ^self negated ].\r\n\t^self","(\r\nfunction(self)\r\nif (((self) < 0))==true then return ((self):negated()); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"rounded",0
,(
function(self)
return (self + 0.5 - (self + 0.5) % 1);
end
)
,"converting","rounded\r\n\t\" Return the receiver rounded. \"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self)\r\nreturn (self + 0.5 - (self + 0.5) % 1);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"truncated",0
,(
function(self)
return (math.floor(self));
end
)
,"converting","truncated\r\n\t\" Return the receiver truncated. \"\r\n\r\n\t^{'' doc'number operation'}","(\r\nfunction(self)\r\nreturn (math.floor(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"asCharacter",0
,(
function(self)
return ((smalltalk.String):fromCharCode_(self));
end
)
,"converting","asCharacter\r\n\t\" Return the character with the receiver's code. \"\r\n\r\n\t^String fromCharCode: self","(\r\nfunction(self)\r\nreturn ((smalltalk.String):fromCharCode_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"to:by:value:",0
,(
function(self,aNumber,increment,aBlock)
return ((smalltalk.Interval):from_to_by_value_(self,aNumber,increment,aBlock));
end
)
,"iterating","to: aNumber by: increment value: aBlock\r\n\t\" Private - Return an iterable to evaluate aBlock on each step of iteration. \"\r\n\r\n\t^Interval from: self to: aNumber by: increment value: aBlock ","(\r\nfunction(self,aNumber,increment,aBlock)\r\nreturn ((smalltalk.Interval):from_to_by_value_(self,aNumber,increment,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"to:by:",0
,(
function(self,__end,increment)
return ((self):to_by_value_(__end,increment,(function(index,block)
return ((block):value_(index))
end)));
end
)
,"iterating","to: end by: increment\r\n\t\" Return an iterable from the receiver to end. \"\r\n\r\n\t^self\tto: end by: increment\r\n\t\tvalue: [:index :block| block value: index ]","(\r\nfunction(self,__end,increment)\r\nreturn ((self):to_by_value_(__end,increment,(function(index,block)\r\nreturn ((block):value_(index))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"to:",0
,(
function(self,__end)
return ((self):to_by_(__end,1));
end
)
,"iterating","to: end\r\n\t\" Return an iterable from the receiver to end. \"\r\n\r\n\t^self to: end by: 1 \"to iterate like other smalltalks\r\n\t\t(self <= end ifTrue: [1] ifFalse: [-1])\"","(\r\nfunction(self,__end)\r\nreturn ((self):to_by_(__end,1));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"timesRepeat:",0
,(
function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
for i=1,self do fn(i) end;
return (self);
end
)
,"enumerating","timesRepeat: aBlock\r\n\t\" Evaluates aBlock a number of times given by the receiver.\r\n\tReturn the receiver.\r\n\t\"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{'' s8'(1 to: self) do: aBlock' doc'iteration'}","(\r\nfunction(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nfor i=1,self do fn(i) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"to:do:",0
,(
function(self,aNumber,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
for i=self,aNumber do fn(i) end;
return (self);
end
)
,"iterating","to: aNumber do: aBlock\r\n\t\" Evaluate aBlock from the receiver to aNumber.\r\n\tReturn the receiver.\r\n\t\"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8' (self to: aNumber) do: aBlock' doc'iteration'}","(\r\nfunction(self,aNumber,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nfor i=self,aNumber do fn(i) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"to:by:do:",0
,(
function(self,aNumber,increment,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
for i=self,aNumber,increment do fn(i) end;
return (self);
end
)
,"iterating","to: aNumber by: increment do: aBlock\r\n\t\" Evaluate aBlock for the numbers between the receiver and aNumber where each number is the previous number plus increment.\r\n\tReturn the receiver.\r\n\t\"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'(self to: aNumber by: increment) consume: aBlock' doc'iteration'}","(\r\nfunction(self,aNumber,increment,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nfor i=self,aNumber,increment do fn(i) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"asString",0
,(
function(self)
return (smalltalk:printString_((self)));
end
)
,"converting","asString\r\n\t\" Return the receiver as a String. \"\r\n\r\n\t^self printString","(\r\nfunction(self)\r\nreturn (smalltalk:printString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"asNative:",0
,(
function(self,lang)
return (smalltalk:object_comma_((smalltalk:object_comma_(("("),smalltalk:printString_((self)))),")"));
end
)
,"converting","asNative: lang\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t^'(', self printString, ')'","(\r\nfunction(self,lang)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"(\"),smalltalk:printString_((self)))),\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"printString",0
,(
function(self)
return (tostring(self));
end
)
,"printing","printString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^{'' doc'native conversion'}","(\r\nfunction(self)\r\nreturn (tostring(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"toString:",0
,(
function(self,radix)
if not (((radix):isNumber()))==true then return (("converting"):toString_(radix)); end;
return (smalltalk:basen(self,radix));
end
)
,"printing","toString: radix\r\n\t\" Return the ASCII representation of the receiver in base radix. \"\r\n\r\n\tradix isNumber ifFalse: [\r\n\t\t^#converting toString: radix\r\n\t].\r\n\t^{'' doc'native conversion'}","(\r\nfunction(self,radix)\r\nif not (((radix):isNumber()))==true then return ((\"converting\"):toString_(radix)); end;\r\nreturn (smalltalk:basen(self,radix));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"printPaddedWith:to:base:",0
,(
function(self,aCharacter,anInteger,aRadix)
local result=nil
(function()
	local _s8_value=((self):toString_(aRadix))
	result=_s8_value
	return _s8_value
end)();
while ((function()
return ((((result):size()) < anInteger))
end))() do (function()
	local _s8_value=(smalltalk:object_comma_((aCharacter),result))
	result=_s8_value
	return _s8_value
end)(); end;
return (result);
end
)
,"printing","printPaddedWith: aCharacter to: anInteger base: aRadix\r\n\t\" Return the ASCII representation of the receiver padded on the left with aCharacter to be at least anInteger characters. \"\r\n\r\n\t| result |\r\n\tresult := self toString: aRadix.\r\n\t[ result size < anInteger ] whileTrue: [\r\n\t\tresult := aCharacter ,result\r\n\t].\r\n\t^result","(\r\nfunction(self,aCharacter,anInteger,aRadix)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):toString_(aRadix))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn ((((result):size()) < anInteger))\r\nend))() do (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((aCharacter),result))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"isNumber",0
,(
function(self)
if (self~=self) then return false else return (self~=math.huge and self~=-math.huge) end;
return (self);
end
)
,"testing","isNumber\r\n\t\" Return true if the receiver is a Number. \"\r\n\r\n\t{'' doc'number testing'}","(\r\nfunction(self)\r\nif (self~=self) then return false else return (self~=math.huge and self~=-math.huge) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"atRandom",0
,(
function(self)
return ((((((smalltalk.Random):new()):next()):_star(self)):truncated()):_plus(1));
end
)
,"converting","atRandom\r\n\t\" Return a random integer in the interval from 1 to the receiver. \"\r\n\r\n\t^(Random new next * self) truncated + 1","(\r\nfunction(self)\r\nreturn ((((((smalltalk.Random):new()):next()):_star(self)):truncated()):_plus(1));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"@","_at"
,(
function(self,aNumber)
return ((smalltalk.Point):x_y_(self,smalltalk:if_true_false_((smalltalk:isNil_((aNumber))),(function()
return (0)
end),(function()
return (aNumber)
end))));
end
)
,"converting","@ aNumber\r\n\t\" Return a Point with coordinates given by the receiver and aNumber. \"\r\n\r\n\t^Point x: self y: (aNumber isNil ifTrue: [0] ifFalse: [aNumber])","(\r\nfunction(self,aNumber)\r\nreturn ((smalltalk.Point):x_y_(self,smalltalk:if_true_false_((smalltalk:isNil_((aNumber))),(function()\r\nreturn (0)\r\nend),(function()\r\nreturn (aNumber)\r\nend))));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"asPoint",0
,(
function(self)
return ((smalltalk.Point):x_y_(self,self));
end
)
,"converting","asPoint\r\n\t\" Return the receiver as a Point. \"\r\n\r\n\t^Point x: self y: self","(\r\nfunction(self)\r\nreturn ((smalltalk.Point):x_y_(self,self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"asJSONObject",0
,(
function(self)

return ((self):_plus(0));
end
)
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t{'self'}.\r\n\t^self + 0\r\n\"Note:\twe need to normalize result to do not destroy typeof checkings\r\n\tDo NOT modify this method if you do not know what you are doing.\r\n\tIf you remove the + 0 computation, the returned object will return 'object' and not 'number' as result of typeof operation.\r\n\"","(\r\nfunction(self)\r\n\r\nreturn ((self):_plus(0));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"between:and:",0
,(
function(self,min,max)
return (smalltalk:boolean_and_((((min) <= self)),(function()
return (((self) <= max))
end)));
end
)
,"testing","between: min and: max\r\n\t\" Return true if the receiver is between arguments. \"\r\n\r\n\t^min <= self and: [ self <= max ]","(\r\nfunction(self,min,max)\r\nreturn (smalltalk:boolean_and_((((min) <= self)),(function()\r\nreturn (((self) <= max))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"even",0
,(
function(self)
return (smalltalk:isObject_equalTo_(((self):_bk_bk(2)),0));
end
)
,"testing","even\r\n\t\" Return true if the receiver is an even number. \"\r\n\r\n\t^self \\\\ 2 = 0","(\r\nfunction(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):_bk_bk(2)),0));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"odd",0
,(
function(self)
return (smalltalk:isObject_equalTo_(((self):_bk_bk(2)),1));
end
)
,"testing","odd\r\n\t\" Return true if the receiver is an odd number. \"\r\n\r\n\t^self \\\\ 2 = 1","(\r\nfunction(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):_bk_bk(2)),1));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"clearInterval",0
,(
function(self)
if true then self:notImplementedYet_("clearInterval") end;
return (self);
end
)
,"intervals","clearInterval\r\n\r\n\t{'' doc'native timer cancelation'}","(\r\nfunction(self)\r\nif true then self:notImplementedYet_(\"clearInterval\") end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"clearTimeout",0
,(
function(self)
if true then self:notImplementedYet_("clearTimeout") end;
return (self);
end
)
,"intervals","clearTimeout\r\n\r\n\t{'' doc'native timer cancelation'}","(\r\nfunction(self)\r\nif true then self:notImplementedYet_(\"clearTimeout\") end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"shallowCopy",0
,(
function(self)
return (self);
end
)
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"deepCopy",0
,(
function(self)
return (self);
end
)
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"int32",0
,(
function(self)

return (self);
end
)
,"Natives-converting","int32\r\n\t\" Return the receiver to be passed to API call as 32 bits integer value. \"\r\n\r\n\t{'self'}.\r\n\t^self","(\r\nfunction(self)\r\n\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"int64",0
,(
function(self)

return (self);
end
)
,"Natives-converting","int64\r\n\t\" Return the receiver to be passed to API call as 64 bits integer value. \"\r\n\r\n\t{'self'}.\r\n\t^self","(\r\nfunction(self)\r\n\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"float32",0
,(
function(self)

return (self);
end
)
,"Natives-converting","float32\r\n\t\" Return the receiver to be passed to API call as 32 bits float value. \"\r\n\r\n\t{'self'}.\r\n\t^self","(\r\nfunction(self)\r\n\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"float64",0
,(
function(self)

return (self);
end
)
,"Natives-converting","float64\r\n\t\" Return the receiver to be passed to API call as 64 bits float value. \"\r\n\r\n\t{'self'}.\r\n\t^self","(\r\nfunction(self)\r\n\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"asLua",0
,(
function(self)
return (smalltalk:printString_((self)));
end
)
,"Lua-lua","asLua\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t^self printString ","(\r\nfunction(self)\r\nreturn (smalltalk:printString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Number,"s8DoIt",0
,(
function(self)
return (((function()
local image=nil
local tag=nil
local source=nil
(self):note_("Exporting the system image");(function()
	local _s8_value=((smalltalk.LuaEncoder):export_("all"))
	image=_s8_value
	return _s8_value
end)();(((smalltalk.String):doItSelector()):implementors()):do_((function(each)
return ((each):removeFromSystem())
end));(image):outputToFile_(smalltalk:object_comma_(("../s8.image."),targetLanguage));(self):note_("Collecting methods with errors...");(function()
	local _s8_value=(smalltalk:object_comma_(("NIY:"),"#luaMethodBody: "))
	tag=_s8_value
	return _s8_value
end)();(self):note_(smalltalk:object_comma_(("ToDo list for "),tag));(function()
	local _s8_value=((image):stream())
	source=_s8_value
	return _s8_value
end)();return (smalltalk:whileNot_do_(((function()
return ((source):atEnd())
end)),(function()
(source):upTo_(tag);return (smalltalk:if_true_false_(((source):atEnd()),nil,(function()
return ((self):print_(smalltalk:object_comma_(("\t"),(source):upTo_("\""))))
end)))
end)))
end)):value());
end
)
,"s8DoIt","s8DoIt ^[| image tag source |\r\nself note: 'Exporting the system image'.\r\nimage := LuaEncoder export: #all.\r\nString doItSelector implementors do: [:each| each removeFromSystem ].\r\nimage outputToFile: '../s8.image.' ,#{targetLanguage}.\r\n\r\nself note: 'Collecting methods with errors...'.\r\ntag := 'NIY:' ,'#luaMethodBody: '.\r\nself note: 'ToDo list for ',tag.\r\nsource := image stream.\r\n[source atEnd] whileFalse: [\r\n\tsource upTo: tag.\r\n\tsource atEnd ifFalse: [\r\n\t\tself print: '\t',(source upTo: $\")\r\n\t].\r\n].] value","(\r\nfunction(self)\r\nreturn (((function()\r\nlocal image=nil\r\nlocal tag=nil\r\nlocal source=nil\r\n(self):note_(\"Exporting the system image\");(function()\r\n\tlocal _s8_value=((smalltalk.LuaEncoder):export_(\"all\"))\r\n\timage=_s8_value\r\n\treturn _s8_value\r\nend)();(((smalltalk.String):doItSelector()):implementors()):do_((function(each)\r\nreturn ((each):removeFromSystem())\r\nend));(image):outputToFile_(smalltalk:object_comma_((\"../s8.image.\"),targetLanguage));(self):note_(\"Collecting methods with errors...\");(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((\"NIY:\"),\"#luaMethodBody: \"))\r\n\ttag=_s8_value\r\n\treturn _s8_value\r\nend)();(self):note_(smalltalk:object_comma_((\"ToDo list for \"),tag));(function()\r\n\tlocal _s8_value=((image):stream())\r\n\tsource=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:whileNot_do_(((function()\r\nreturn ((source):atEnd())\r\nend)),(function()\r\n(source):upTo_(tag);return (smalltalk:if_true_false_(((source):atEnd()),nil,(function()\r\nreturn ((self):print_(smalltalk:object_comma_((\"\\t\"),(source):upTo_(\"\\\"\"))))\r\nend)))\r\nend)))\r\nend)):value());\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure["$klass"],"empty",0
,(
function(self)
return ((function()
return (nil)
end));
end
)
,"instantiation","empty\r\n\t\" Return an empty block. \"\r\n\r\n\t^[]","(\r\nfunction(self)\r\nreturn ((function()\r\nreturn (nil)\r\nend));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure["$klass"],"defaultSortBlock",0
,(
function(self)

return ((function(a,b)
return (((function()
return (((a) < b))
end)):on_do_(smalltalk.Exception,(function()
return (((smalltalk:toString_((a))) < smalltalk:toString_((b))))
end)))
end));
end
)
,"instantiation","defaultSortBlock\r\n\t\" Private - Return the block used for default sort. \"\r\n\r\n\t{'self'}.\r\n\t^[:a :b| [ a < b ] on: Exception do: [ a toString < b toString ] ]","(\r\nfunction(self)\r\n\r\nreturn ((function(a,b)\r\nreturn (((function()\r\nreturn (((a) < b))\r\nend)):on_do_(smalltalk.Exception,(function()\r\nreturn (((smalltalk:toString_((a))) < smalltalk:toString_((b))))\r\nend)))\r\nend));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure["$klass"],"hasDeferredSupport",0
,(
function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
((function()
return (smalltalk:notNil_((setTimeout)))
end)):on_do_(smalltalk.Exception,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:notNil_((setTimeout)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"deferredEvaluation","hasDeferredSupport\r\n\t\" Return true if the platform can defer instance evaluation. \"\r\n\r\n\t[ #{setTimeout} notNil ] on: Exception do: [ ^false ].\r\n\t^#{setTimeout} notNil","(\r\nfunction(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n((function()\r\nreturn (smalltalk:notNil_((setTimeout)))\r\nend)):on_do_(smalltalk.Exception,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:notNil_((setTimeout)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"compiledSourceAt:",0
,(
function(self,aCompiledMethod)
local cached=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((aCompiledMethod))),(function()
return (smalltalk:basic_at_ifAbsent_((aCompiledMethod),"$nativeSource",(function()
return (nil)
end)))
end),nil))
	cached=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:isNil_((cached))),(function()
return ((self):compiledSource())
end),(function()
return (cached)
end)));
end
)
,"accessing","compiledSourceAt: aCompiledMethod\r\n\t\" Return the native source code of the receiver. \"\r\n\r\n\t| cached |\r\n\tcached := aCompiledMethod notNil ifTrue: [\r\n\t\taCompiledMethod basicAt: '$nativeSource' ifAbsent: []\r\n\t].\r\n\t^cached isNil ifTrue: [ self compiledSource ] ifFalse: [ cached ]","(\r\nfunction(self,aCompiledMethod)\r\nlocal cached=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((aCompiledMethod))),(function()\r\nreturn (smalltalk:basic_at_ifAbsent_((aCompiledMethod),\"$nativeSource\",(function()\r\nreturn (nil)\r\nend)))\r\nend),nil))\r\n\tcached=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((cached))),(function()\r\nreturn ((self):compiledSource())\r\nend),(function()\r\nreturn (cached)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"compiledSource",0
,(
function(self)

return (smalltalk:toString_((self)));
end
)
,"accessing","compiledSource\r\n\t\" Return the native source code of the receiver. \"\r\n\r\n\t{'self'}.\r\n\t^self toString","(\r\nfunction(self)\r\n\r\nreturn (smalltalk:toString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"whileTrue:",0
,(
function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
while self() do fn() end;
return (self);
end
)
,"iterating","whileTrue: aBlock\r\n\t\" Evaluate aBlock while the result of evaluating the receiver is true. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8' self value == true ifTrue: [\r\n\t\taBlock value.\r\n\t\tself whileTrue: aBlock\r\n\t]' doc'iteration'}","(\r\nfunction(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile self() do fn() end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"whileFalse:",0
,(
function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
while (self()==false) do fn() end;
return (self);
end
)
,"iterating","whileFalse: aBlock\r\n\t\" Evaluate aBlock while the result of evaluating the receiver is false. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'\tself value == false ifTrue: [\r\n\t\taBlock value.\r\n\t\tself whileFalse: aBlock\r\n\t]' doc'iteration'}","(\r\nfunction(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile (self()==false) do fn() end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"whileTrue",0
,(
function(self)
return ((self):whileTrue_((function()
return (nil)
end)));
end
)
,"iterating","whileTrue\r\n\t\" Evaluate the receiver while the result is true. \"\r\n\r\n\t^self whileTrue: []","(\r\nfunction(self)\r\nreturn ((self):whileTrue_((function()\r\nreturn (nil)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"whileFalse",0
,(
function(self)
return ((self):whileFalse_((function()
return (nil)
end)));
end
)
,"iterating","whileFalse\r\n\t\" Evaluate the receiver while the result is false. \"\r\n\r\n\t^self whileFalse: []","(\r\nfunction(self)\r\nreturn ((self):whileFalse_((function()\r\nreturn (nil)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"value",0
,(
function(self)
return (self());
end
)
,"evaluating","value\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^{'self()' doc'native activation'}","(\r\nfunction(self)\r\nreturn (self());\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"value:",0
,(
function(self,anObject)
return (self(anObject));
end
)
,"evaluating","value: anObject\r\n\t\" Return the result of evaluating the receiver with anObject. \"\r\n\r\n\t^{'self(anObject)' doc'native activation'}","(\r\nfunction(self,anObject)\r\nreturn (self(anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"value:value:",0
,(
function(self,arg1,arg2)
return (self(arg1,arg2));
end
)
,"evaluating","value: arg1 value: arg2\r\n\t\" Return the result of evaluating the receiver with arguments. \"\r\n\r\n\t^{'self(arg1,arg2)' doc'native activation'}","(\r\nfunction(self,arg1,arg2)\r\nreturn (self(arg1,arg2));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"value:value:value:",0
,(
function(self,arg1,arg2,arg3)
return (self(arg1,arg2,arg3));
end
)
,"evaluating","value: arg1 value: arg2 value: arg3\r\n\t\" Return the result of evaluating the receiver with arguments. \"\r\n\r\n\t^{'self(arg1,arg2,arg3)' doc'native activation'}","(\r\nfunction(self,arg1,arg2,arg3)\r\nreturn (self(arg1,arg2,arg3));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"value:value:value:value:",0
,(
function(self,arg1,arg2,arg3,arg4)
return (self(arg1,arg2,arg3,arg4));
end
)
,"evaluating","value: arg1 value: arg2 value: arg3 value: arg4\r\n\t\" Return the result of evaluating the receiver with arguments. \"\r\n\r\n\t^{'self(arg1,arg2,arg3,arg4)' doc'native activation'}","(\r\nfunction(self,arg1,arg2,arg3,arg4)\r\nreturn (self(arg1,arg2,arg3,arg4));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"valueWithPossibleArguments:",0
,(
function(self,array)
if not (((array):isArray()))==true then (self):error_(smalltalk:object_comma_(("Invalid arguments in #valueWithPossibleArguments: (must be anArray). receiver="),smalltalk:toString_((self)))); end;
return (self((table.unpack or unpack)(array)));
end
)
,"evaluating","valueWithPossibleArguments: array\r\n\t\" Return the result of evaluating the receiver with potential arguments. \"\r\n\r\n\tarray isArray ifFalse: [\r\n\t\tself error: 'Invalid arguments in #valueWithPossibleArguments: (must be anArray). receiver=' ,self toString\r\n\t].\r\n\t^{'' doc'native activation'}","(\r\nfunction(self,array)\r\nif not (((array):isArray()))==true then (self):error_(smalltalk:object_comma_((\"Invalid arguments in #valueWithPossibleArguments: (must be anArray). receiver=\"),smalltalk:toString_((self)))); end;\r\nreturn (self((table.unpack or unpack)(array)));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"exception:matches:",0
,(
function(self,anException,type)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (smalltalk:isNil_((type)))==true then return (true); end;
if not (((self):isObject_(type)))==true then return (smalltalk:isObject_equalTo_((type),anException)); end;
if ((type):isClass())==true then return (smalltalk:is_kindOf_((anException),(type))); end;
if (smalltalk:isObject_equalTo_((type),"all"))==true then return (true); end;
if ((type):isArray())==true then (type):detect_ifNone_((function(one)
return ((self):exception_matches_(anException,one))
end),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)(); end;
if ((type):isString())==true then local cls=nil
(function()
	local _s8_value=(((self):smalltalk()):at_ifAbsent_(cls,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
	cls=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):exception_matches_(anException,cls))
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((((type):evaluateWith_(anException))==true))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"private","exception: anException matches: type\r\n\t\" Private - Return true if anException is of specified type. \"\r\n\r\n\ttype isNil ifTrue: [ ^true ].\r\n\t(self isObject: type) ifFalse: [ ^type = anException ].\r\n\ttype isClass ifTrue: [ ^anException isKindOf: type ].\r\n\ttype = #all ifTrue: [ ^true ].\r\n\ttype isArray ifTrue: [\r\n\t\ttype\r\n\t\t\tdetect: [:one| self exception: anException matches: one ]\r\n\t\t\tifNone: [ ^false ].\r\n\t\t^true\r\n\t].\r\n\ttype isString ifTrue: [ | cls |\r\n\t\tcls := self smalltalk at: cls ifAbsent: [ ^false ].\r\n\t\t^self exception: anException matches: cls\r\n\t].\r\n\t^(type evaluateWith: anException) == true ","(\r\nfunction(self,anException,type)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (smalltalk:isNil_((type)))==true then return (true); end;\r\nif not (((self):isObject_(type)))==true then return (smalltalk:isObject_equalTo_((type),anException)); end;\r\nif ((type):isClass())==true then return (smalltalk:is_kindOf_((anException),(type))); end;\r\nif (smalltalk:isObject_equalTo_((type),\"all\"))==true then return (true); end;\r\nif ((type):isArray())==true then (type):detect_ifNone_((function(one)\r\nreturn ((self):exception_matches_(anException,one))\r\nend),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\nif ((type):isString())==true then local cls=nil\r\n(function()\r\n\tlocal _s8_value=(((self):smalltalk()):at_ifAbsent_(cls,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):exception_matches_(anException,cls))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((((type):evaluateWith_(anException))==true))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"on:do:",0
,(
function(self,type,aBlock)
return ((self):try_catch_(self,(function(anException)
return (smalltalk:if_true_false_(((self):exception_matches_(anException,type)),(function()
return ((aBlock):evaluateWith_(anException))
end),(function()
return ((anException):signal())
end)))
end)));
end
)
,"evaluating","on: type do: aBlock\r\n\t\" Return the result of evaluating the receiver catching exceptions of specified type. \"\r\n\r\n\t^self try: self catch: [:anException |\r\n\t\t(self exception: anException matches: type)\r\n\t\tifTrue: [ aBlock evaluateWith: anException ]\r\n\t\tifFalse: [ anException signal ]\r\n\t]","(\r\nfunction(self,type,aBlock)\r\nreturn ((self):try_catch_(self,(function(anException)\r\nreturn (smalltalk:if_true_false_(((self):exception_matches_(anException,type)),(function()\r\nreturn ((aBlock):evaluateWith_(anException))\r\nend),(function()\r\nreturn ((anException):signal())\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"try:catch:",0
,(
function(self,aBlock,anotherBlock)
local fn=nil
local ab=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):callableOf_(anotherBlock))
	ab=_s8_value
	return _s8_value
end)();

	local success, result = pcall(function() return fn() end)
	if success
		then return result
		else return ab( self:smalltalkErrorOf_(result) ) end;
return (self);
end
)
,"private","try: aBlock catch: anotherBlock\r\n\t\" Private - Try to evaluate aBlock catching exceptions with catchBlock. \"\r\n\r\n\t| fn ab |\r\n\tfn := self callableOf: aBlock.\r\n\tab := self callableOf: anotherBlock.\r\n\t{'' doc'secured activation'}","(\r\nfunction(self,aBlock,anotherBlock)\r\nlocal fn=nil\r\nlocal ab=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(anotherBlock))\r\n\tab=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\n\tlocal success, result = pcall(function() return fn() end)\r\n\tif success\r\n\t\tthen return result\r\n\t\telse return ab( self:smalltalkErrorOf_(result) ) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"valueDeferred:",0
,(
function(self,milliseconds)
(self):valueWithTimeout_(milliseconds);
return (self);
end
)
,"evaluating","valueDeferred: milliseconds\r\n\t\" Evaluate the receiver deferred in time.\r\n\tReturn the receiver.\r\n\t\"\r\n\r\n\tself valueWithTimeout: milliseconds","(\r\nfunction(self,milliseconds)\r\n(self):valueWithTimeout_(milliseconds);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"valueDeferred",0
,(
function(self)
(self):valueDeferred_(0);
return (self);
end
)
,"evaluating","valueDeferred\r\n\t\" Evaluate the receiver deferred in time.\r\n\tReturn the receiver.\r\n\t\"\r\n\r\n\tself valueDeferred: 0","(\r\nfunction(self)\r\n(self):valueDeferred_(0);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"valueWithTimeout:",0
,(
function(self,aNumber)
return (self:notImplementedYet_("valueWithTimeout:"));
end
)
,"timeout","valueWithTimeout: aNumber\r\n\t\" Evaluate the receiver with time out. \"\r\n\r\n\t^{'' doc'native timer activation'}","(\r\nfunction(self,aNumber)\r\nreturn (self:notImplementedYet_(\"valueWithTimeout:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"valueWithInterval:",0
,(
function(self,aNumber)
return (self:notImplementedYet_("valueWithInterval:"));
end
)
,"timeout","valueWithInterval: aNumber\r\n\t\" Evaluate the receiver with interval. \"\r\n\r\n\t^{'' doc'native timer activation'}","(\r\nfunction(self,aNumber)\r\nreturn (self:notImplementedYet_(\"valueWithInterval:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"ensure:",0
,(
function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();

	local success, result = pcall(function() return self() end)
	fn()
	if true then return result end;
return (self);
end
)
,"evaluating","ensure: aBlock\r\n\t\" Return the result of evaluating the receiver.\r\n\tExecute aBlock after the receiver is executed.\r\n\t\"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{'' doc'protected activation'}","(\r\nfunction(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\n\tlocal success, result = pcall(function() return self() end)\r\n\tfn()\r\n\tif true then return result end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"ifCurtailed:",0
,(
function(self,exceptionBlock)
local curtailed=nil
local result=nil
(function()
	local _s8_value=(true)
	curtailed=_s8_value
	return _s8_value
end)();

	local curtailed = true
	local success, result = pcall(function()
		local r = self()
		curtailed = false
		return r
	end)
	if (curtailed)
		then exceptionBlock:value()
		else return result
		end;
return (self);
end
)
,"evaluating","ifCurtailed: exceptionBlock\r\n\t\" Return the result of evaluating the receiver.\r\n\tIf evaluation is limited by exiting before completion, the exception block is evaluated.\r\n\t\"\r\n\r\n\t| curtailed result |\r\n\tcurtailed := true.\r\n\t{'' doc'protected activation'}","(\r\nfunction(self,exceptionBlock)\r\nlocal curtailed=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(true)\r\n\tcurtailed=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\n\tlocal curtailed = true\r\n\tlocal success, result = pcall(function()\r\n\t\tlocal r = self()\r\n\t\tcurtailed = false\r\n\t\treturn r\r\n\tend)\r\n\tif (curtailed)\r\n\t\tthen exceptionBlock:value()\r\n\t\telse return result\r\n\t\tend;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"argumentCount",0
,(
function(self)
return (self:notImplementedYet_("argumentCount"));
end
)
,"evaluating","argumentCount\r\n\t\" Return the number of arguments of the receiver. \"\r\n\r\n\t^{'' doc'activation constants'}","(\r\nfunction(self)\r\nreturn (self:notImplementedYet_(\"argumentCount\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"installAs:",0
,(
function(self,functionName)
return ((smalltalk.Smalltalk):install_as_(self,functionName));
end
)
,"installing","installAs: functionName\r\n\t\" Install the receiver as a function in global scope. \"\r\n\r\n\t^Smalltalk install: self as: functionName","(\r\nfunction(self,functionName)\r\nreturn ((smalltalk.Smalltalk):install_as_(self,functionName));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"asJSONObject",0
,(
function(self)
return (self);
end
)
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"shallowCopy",0
,(
function(self)
return (self);
end
)
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"deepCopy",0
,(
function(self)
return (self);
end
)
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"isValuable",0
,(
function(self)
return (true);
end
)
,"testing","isValuable\r\n\t\" Return true if the receiver can be evaluated. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"ms",0
,(
function(self)
return ((smalltalk.DateTime):millisecondsToRun_(self));
end
)
,"accessing","ms\r\n\t\" Return the milliseconds taken to evaluate the receiver. \"\r\n\r\n\t^DateTime millisecondsToRun: self","(\r\nfunction(self)\r\nreturn ((smalltalk.DateTime):millisecondsToRun_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"evaluateFor:",0
,(
function(self,anObject)
return (self(anObject));
end
)
,"evaluating","evaluateFor: anObject\r\n\t\" Return the result of evaluating the receiver with anObject. \"\r\n\r\n\t^# #self: anObject","(\r\nfunction(self,anObject)\r\nreturn (self(anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"evaluate",0
,(
function(self)
return (self());
end
)
,"evaluating","evaluate\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^# #self","(\r\nfunction(self)\r\nreturn (self());\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"evaluateWithArguments:",0
,(
function(self,anArray)
return ((self):valueWithPossibleArguments_(anArray));
end
)
,"evaluating","evaluateWithArguments: anArray\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self valueWithPossibleArguments: anArray","(\r\nfunction(self,anArray)\r\nreturn ((self):valueWithPossibleArguments_(anArray));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"valueWithArguments:",0
,(
function(self,anArray)
return ((self):valueWithPossibleArguments_(anArray));
end
)
,"evaluating","valueWithArguments: anArray\r\n\t\" Return the result of evaluating the receiver with arguments. \"\r\n\r\n\t^self valueWithPossibleArguments: anArray","(\r\nfunction(self,anArray)\r\nreturn ((self):valueWithPossibleArguments_(anArray));\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockClosure,"valueWithDNU",0
,(
function(self)
return ((smalltalk.Object):hackDNUWhile_(self));
end
)
,"Tools-hacking","valueWithDNU\r\n\t\" Catch DNU hacking while evaluating the receiver. \"\r\n\r\n\t^Object hackDNUWhile: self","(\r\nfunction(self)\r\nreturn ((smalltalk.Object):hackDNUWhile_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Boolean["$klass"],"@","_at"
,(
function(self,aBOOL)

	if (aBOOL==true) then return true end
	if (aBOOL==1) then return true end
	if (aBOOL==false) then return false end
	if (aBOOL+0==1) then return true end;
return (false);
end
)
,"Natives-converting","@ aBOOL\r\n\t\" Return aBOOL as a Boolean instance. \"\r\n\r\n\t{''}.\r\n\t^false","(\r\nfunction(self,aBOOL)\r\n\r\n\tif (aBOOL==true) then return true end\r\n\tif (aBOOL==1) then return true end\r\n\tif (aBOOL==false) then return false end\r\n\tif (aBOOL+0==1) then return true end;\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Boolean,"mustBeBoolean",0
,(
function(self)
return (self);
end
)
,"testing","mustBeBoolean\r\n\t\" Signal an error if the receiver is not a Boolean. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Boolean,"=","_eq"
,(
function(self,anObject)

	if anObject==nil then return false end
	if true then return self==anObject end;
return (self);
end
)
,"comparing","= anObject\r\n    \" Return true if the receiver is equal to argument. \"\r\n\r\n\t{'' doc'boolean test'}","(\r\nfunction(self,anObject)\r\n\r\n\tif anObject==nil then return false end\r\n\tif true then return self==anObject end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Boolean,"ifTrue:ifFalse:",0
,(
function(self,aBlock,anotherBlock)

	if (self==true)
		then return aBlock:value()
		else return anotherBlock:value() end;
return (self);
end
)
,"control","ifTrue: aBlock ifFalse: anotherBlock\r\n\t\" Return the result of evaluating aBlock if the receiver is true, else the result of evaluating anotherBlock. \"\r\n\r\n\t{'' doc'boolean switch'}","(\r\nfunction(self,aBlock,anotherBlock)\r\n\r\n\tif (self==true)\r\n\t\tthen return aBlock:value()\r\n\t\telse return anotherBlock:value() end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Boolean,"ifTrue:",0
,(
function(self,aBlock)
return (smalltalk:if_true_false_((self),(function()
return ((aBlock):value())
end),(function()
return (nil)
end)));
end
)
,"control","ifTrue: aBlock\r\n\t\" Return the result of evaluating aBlock if the receiver is true, else return nil. \"\r\n\r\n\t^self ifTrue: [ aBlock value ] ifFalse: []","(\r\nfunction(self,aBlock)\r\nreturn (smalltalk:if_true_false_((self),(function()\r\nreturn ((aBlock):value())\r\nend),(function()\r\nreturn (nil)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Boolean,"ifFalse:",0
,(
function(self,aBlock)
return (smalltalk:if_true_false_((self),(function()
return (nil)
end),(function()
return ((aBlock):value())
end)));
end
)
,"control","ifFalse: aBlock\r\n\t\" Return the result of evaluating aBlock if the receiver is false, else return nil. \"\r\n\r\n\t^self ifTrue: [] ifFalse: [ aBlock value ]","(\r\nfunction(self,aBlock)\r\nreturn (smalltalk:if_true_false_((self),(function()\r\nreturn (nil)\r\nend),(function()\r\nreturn ((aBlock):value())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Boolean,"ifFalse:ifTrue:",0
,(
function(self,aBlock,anotherBlock)
return ((self):ifTrue_ifFalse_(anotherBlock,(function()
return ((aBlock):value())
end)));
end
)
,"control","ifFalse: aBlock ifTrue: anotherBlock\r\n\t\" Return the result of evaluating aBlock if the receiver is false, else the result of evaluating anotherBlock. \"\r\n\r\n\t^self ifTrue: anotherBlock ifFalse: [ aBlock value ]","(\r\nfunction(self,aBlock,anotherBlock)\r\nreturn ((self):ifTrue_ifFalse_(anotherBlock,(function()\r\nreturn ((aBlock):value())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Boolean,"and:",0
,(
function(self,aBlock)
return (smalltalk:if_true_false_((self),(function()
return ((aBlock):value())
end),(function()
return (false)
end)));
end
)
,"control","and: aBlock\r\n\t\" Return true if the receiver is true and the result of evaluating aBlock is also true. \"\r\n\r\n\t^self ifTrue: [ aBlock value ] ifFalse: [false]","(\r\nfunction(self,aBlock)\r\nreturn (smalltalk:if_true_false_((self),(function()\r\nreturn ((aBlock):value())\r\nend),(function()\r\nreturn (false)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Boolean,"or:",0
,(
function(self,aBlock)
return (smalltalk:if_true_false_((self),(function()
return (true)
end),(function()
return ((aBlock):value())
end)));
end
)
,"control","or: aBlock\r\n\t\" Return true if the receiver is true or the result of evaluating aBlock is true. \"\r\n\r\n\t^self ifTrue: [true] ifFalse: [ aBlock value ]","(\r\nfunction(self,aBlock)\r\nreturn (smalltalk:if_true_false_((self),(function()\r\nreturn (true)\r\nend),(function()\r\nreturn ((aBlock):value())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Boolean,"not","__not"
,(
function(self)
return (self == false);
end
)
,"control","not\r\n\t\" Return true if the receiver is false. \"\r\n\r\n\t^{'' doc'boolean inversion'}","(\r\nfunction(self)\r\nreturn (self == false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Boolean,"printString",0
,(
function(self)
return (smalltalk:if_true_false_((self),(function()
return ("true")
end),(function()
return ("false")
end)));
end
)
,"printing","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t^self ifTrue: [ #true ] ifFalse: [ #false ]","(\r\nfunction(self)\r\nreturn (smalltalk:if_true_false_((self),(function()\r\nreturn (\"true\")\r\nend),(function()\r\nreturn (\"false\")\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Boolean,"asJSONObject",0
,(
function(self)

return (smalltalk:boolean_and_((self),(function()
return (true)
end)));
end
)
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t{'self'}.\r\n\t^self and: [ true ]","(\r\nfunction(self)\r\n\r\nreturn (smalltalk:boolean_and_((self),(function()\r\nreturn (true)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Boolean,"shallowCopy",0
,(
function(self)
return (self);
end
)
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Boolean,"deepCopy",0
,(
function(self)
return (self);
end
)
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Boolean,"isBoolean",0
,(
function(self)
return (true);
end
)
,"testing","isBoolean\r\n\t\" Return true if the receiver is a boolean. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime["$klass"],"new:",0
,(
function(self,anObject)
if true then return self:notImplementedYet_("new:") end;
return (self);
end
)
,"instantiation","new: anObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}","(\r\nfunction(self,anObject)\r\nif true then return self:notImplementedYet_(\"new:\") end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime["$klass"],"fromString:",0
,(
function(self,aString)
return ((self):new_(aString));
end
)
,"instantiation","fromString: aString\r\n\t\" Return an instance of the receiver.\r\n\tDateTime fromString: '1962/12/15 01:40:00'\r\n\t\"\r\n\r\n\t^self new: aString","(\r\nfunction(self,aString)\r\nreturn ((self):new_(aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime["$klass"],"fromSeconds:",0
,(
function(self,aNumber)
return ((self):fromMilliseconds_((aNumber):_star(1000)));
end
)
,"instantiation","fromSeconds: aNumber\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self fromMilliseconds: aNumber * 1000","(\r\nfunction(self,aNumber)\r\nreturn ((self):fromMilliseconds_((aNumber):_star(1000)));\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime["$klass"],"fromMilliseconds:",0
,(
function(self,aNumber)
return ((self):new_(aNumber));
end
)
,"instantiation","fromMilliseconds: aNumber\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new: aNumber","(\r\nfunction(self,aNumber)\r\nreturn ((self):new_(aNumber));\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime["$klass"],"today",0
,(
function(self)
if true then return self:new() end;
return ((self):new());
end
)
,"instantiation","today\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}.\r\n\t^self new","(\r\nfunction(self)\r\nif true then return self:new() end;\r\nreturn ((self):new());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime["$klass"],"now",0
,(
function(self)
if true then return self:today() end;
return ((self):today());
end
)
,"instantiation","now\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}.\r\n\t^self today","(\r\nfunction(self)\r\nif true then return self:today() end;\r\nreturn ((self):today());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime["$klass"],"msNow",0
,(
function(self)
if true then return os.clock()*1000 end;
return ((self):new());
end
)
,"instantiation","msNow\r\n\t\" Private - Return a magnitude to measure milliseconds. \"\r\n\r\n\t{'' doc'native instantiation'}.\r\n\t^self new","(\r\nfunction(self)\r\nif true then return os.clock()*1000 end;\r\nreturn ((self):new());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime["$klass"],"millisecondsToRun:",0
,(
function(self,aBlock)
local start=nil
(function()
	local _s8_value=((self):msNow())
	start=_s8_value
	return _s8_value
end)();
(aBlock):value();
return (((self):msNow()):_minus(start));
end
)
,"instantiation","millisecondsToRun: aBlock\r\n\t\" Return the time elapsed during evaluation of aBlock. \"\r\n\r\n\t| start |\r\n\tstart := self msNow.\r\n\taBlock value.\r\n\t^self msNow - start","(\r\nfunction(self,aBlock)\r\nlocal start=nil\r\n(function()\r\n\tlocal _s8_value=((self):msNow())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aBlock):value();\r\nreturn (((self):msNow()):_minus(start));\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"year",0
,(
function(self)
return ((function() self:invalidMessage_("year") end)());
end
)
,"accessing","year\r\n\t\" Return the year of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","(\r\nfunction(self)\r\nreturn ((function() self:invalidMessage_(\"year\") end)());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"month",0
,(
function(self)
return ((function() self:invalidMessage_("month") end)());
end
)
,"accessing","month\r\n\t\" Return the month of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","(\r\nfunction(self)\r\nreturn ((function() self:invalidMessage_(\"month\") end)());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"month:",0
,(
function(self,aNumber)
(function() self:invalidMessage_("month:") end)();
return (self);
end
)
,"accessing","month: aNumber\r\n\t\" Set the month of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","(\r\nfunction(self,aNumber)\r\n(function() self:invalidMessage_(\"month:\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"day",0
,(
function(self)
return ((function() self:invalidMessage_("day") end)());
end
)
,"accessing","day\r\n\t\" Return the day of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","(\r\nfunction(self)\r\nreturn ((function() self:invalidMessage_(\"day\") end)());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"dayOfWeek",0
,(
function(self)
(self):invalidMessage_("dayOfWeek");
return (self);
end
)
,"accessing","dayOfWeek\r\n\t\" Return the day of week of the receiver. \"\r\n\r\n\tself invalidMessage: #dayOfWeek.","(\r\nfunction(self)\r\n(self):invalidMessage_(\"dayOfWeek\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"dayOfWeek:",0
,(
function(self,aNumber)
(self):invalidMessage_("dayOfWeek:");
return (self);
end
)
,"accessing","dayOfWeek: aNumber\r\n\t\" Set the day of week of the receiver. \"\r\n\r\n\tself invalidMessage: #dayOfWeek:.","(\r\nfunction(self,aNumber)\r\n(self):invalidMessage_(\"dayOfWeek:\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"day:",0
,(
function(self,aNumber)
(function() self:invalidMessage_("day:") end)();
return (self);
end
)
,"accessing","day: aNumber\r\n\t\" Set the day of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","(\r\nfunction(self,aNumber)\r\n(function() self:invalidMessage_(\"day:\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"year:",0
,(
function(self,aNumber)
(function() self:invalidMessage_("year:") end)();
return (self);
end
)
,"accessing","year: aNumber\r\n\t\" Set the year of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","(\r\nfunction(self,aNumber)\r\n(function() self:invalidMessage_(\"year:\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"dayOfMonth",0
,(
function(self)
return ((function() self:invalidMessage_("dayOfMonth") end)());
end
)
,"accessing","dayOfMonth\r\n\t\" Return the day of month of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","(\r\nfunction(self)\r\nreturn ((function() self:invalidMessage_(\"dayOfMonth\") end)());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"dayOfMonth:",0
,(
function(self,aNumber)
(function() self:invalidMessage_("dayOfMonth:") end)();
return (self);
end
)
,"accessing","dayOfMonth: aNumber\r\n\t\" Set the day of month of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","(\r\nfunction(self,aNumber)\r\n(function() self:invalidMessage_(\"dayOfMonth:\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"asString",0
,(
function(self)

return (smalltalk:toString_((self)));
end
)
,"converting","asString\r\n\t\" Return the text representation of the receiver. \"\r\n\r\n\t{'self' doc'native conversion'}.\r\n\t^self toString","(\r\nfunction(self)\r\n\r\nreturn (smalltalk:toString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"printString",0
,(
function(self)
return (smalltalk:asString_((self)));
end
)
,"printing","printString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self asString","(\r\nfunction(self)\r\nreturn (smalltalk:asString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"asMilliseconds",0
,(
function(self)
return ((self):time());
end
)
,"converting","asMilliseconds\r\n\t\" Return the receiver as milliseconds. \"\r\n\r\n\t^self time","(\r\nfunction(self)\r\nreturn ((self):time());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"time",0
,(
function(self)
return ((function() self:invalidMessage_("time") end)());
end
)
,"accessing","time\r\n\t\" Return the time of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","(\r\nfunction(self)\r\nreturn ((function() self:invalidMessage_(\"time\") end)());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"time:",0
,(
function(self,aNumber)
(function() self:invalidMessage_("time:") end)();
return (self);
end
)
,"accessing","time: aNumber\r\n\t\" Set the time of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","(\r\nfunction(self,aNumber)\r\n(function() self:invalidMessage_(\"time:\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"asDateString",0
,(
function(self)
return ((function() self:invalidMessage_("asDateString") end)());
end
)
,"converting","asDateString\r\n\t\" Return the date string of the receiver. \"\r\n\r\n\t^{'' doc'native converting'}","(\r\nfunction(self)\r\nreturn ((function() self:invalidMessage_(\"asDateString\") end)());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"asTimeString",0
,(
function(self)
return ((function() self:invalidMessage_("asTimeString") end)());
end
)
,"converting","asTimeString\r\n\t\" Return the time string of the receiver. \"\r\n\r\n\t^{'' doc'native converting'}","(\r\nfunction(self)\r\nreturn ((function() self:invalidMessage_(\"asTimeString\") end)());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"asLocaleString",0
,(
function(self)
return ((function() self:invalidMessage_("asLocaleString") end)());
end
)
,"converting","asLocaleString\r\n\t\" Return the locale string of the receiver. \"\r\n\r\n\t^{'' doc'native converting'}","(\r\nfunction(self)\r\nreturn ((function() self:invalidMessage_(\"asLocaleString\") end)());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"asNumber",0
,(
function(self)
return ((self):asMilliseconds());
end
)
,"converting","asNumber\r\n\t\" Return the receiver as a Number. \"\r\n\r\n\t^self asMilliseconds","(\r\nfunction(self)\r\nreturn ((self):asMilliseconds());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"hours:",0
,(
function(self,aNumber)
(function() self:invalidMessage_("hours:") end)();
return (self);
end
)
,"accessing","hours: aNumber\r\n\t\" Set the hours of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","(\r\nfunction(self,aNumber)\r\n(function() self:invalidMessage_(\"hours:\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"minutes:",0
,(
function(self,aNumber)
(function() self:invalidMessage_("minutes:") end)();
return (self);
end
)
,"accessing","minutes: aNumber\r\n\t\" Set the minutes of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","(\r\nfunction(self,aNumber)\r\n(function() self:invalidMessage_(\"minutes:\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"seconds:",0
,(
function(self,aNumber)
(function() self:invalidMessage_("seconds:") end)();
return (self);
end
)
,"accessing","seconds: aNumber\r\n\t\" Set the seconds of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","(\r\nfunction(self,aNumber)\r\n(function() self:invalidMessage_(\"seconds:\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"milliseconds:",0
,(
function(self,aNumber)
(function() self:invalidMessage_("milliseconds:") end)();
return (self);
end
)
,"accessing","milliseconds: aNumber\r\n\t\" Set the milliseconds of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","(\r\nfunction(self,aNumber)\r\n(function() self:invalidMessage_(\"milliseconds:\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"hours",0
,(
function(self)
return ((function() self:invalidMessage_("hours") end)());
end
)
,"accessing","hours\r\n\t\" Return the hours of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","(\r\nfunction(self)\r\nreturn ((function() self:invalidMessage_(\"hours\") end)());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"minutes",0
,(
function(self)
return ((function() self:invalidMessage_("minutes") end)());
end
)
,"accessing","minutes\r\n\t\" Return the minutes of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","(\r\nfunction(self)\r\nreturn ((function() self:invalidMessage_(\"minutes\") end)());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"seconds",0
,(
function(self)
return ((function() self:invalidMessage_("seconds") end)());
end
)
,"accessing","seconds\r\n\t\" Return the seconds of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","(\r\nfunction(self)\r\nreturn ((function() self:invalidMessage_(\"seconds\") end)());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"milliseconds",0
,(
function(self)
return ((function() self:invalidMessage_("milliseconds") end)());
end
)
,"accessing","milliseconds\r\n\t\" Return the milliseconds of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","(\r\nfunction(self)\r\nreturn ((function() self:invalidMessage_(\"milliseconds\") end)());\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"<","_lt"
,(
function(self,aDateTime)
return (self:notImplementedYet_("<"));
end
)
,"comparing","< aDateTime\r\n\t\" Return true if the receiver is smaller than argument. \"\r\n\r\n\t^{'' doc'native compare'}","(\r\nfunction(self,aDateTime)\r\nreturn (self:notImplementedYet_(\"<\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,">","_gt"
,(
function(self,aDateTime)
return (self:notImplementedYet_(">"));
end
)
,"comparing","> aDateTime\r\n\t\" Return true if the receiver is greater than argument. \"\r\n\r\n\t^{'' doc'native compare'}","(\r\nfunction(self,aDateTime)\r\nreturn (self:notImplementedYet_(\">\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"<=","_lt_eq"
,(
function(self,aDateTime)
return (self:notImplementedYet_("<="));
end
)
,"comparing","<= aDateTime\r\n\t\" Return true if the receiver is smaller or equal to argument. \"\r\n\r\n\t^{'' doc'native compare'}","(\r\nfunction(self,aDateTime)\r\nreturn (self:notImplementedYet_(\"<=\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,">=","_gt_eq"
,(
function(self,aDateTime)
return (self:notImplementedYet_(">="));
end
)
,"comparing",">= aDateTime\r\n\t\" Return true if the receiver is greater or equal to argument. \"\r\n\r\n\t^{'' doc'native compare'}","(\r\nfunction(self,aDateTime)\r\nreturn (self:notImplementedYet_(\">=\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"-","_minus"
,(
function(self,aDateTime)
return (self:notImplementedYet_("-"));
end
)
,"arithmetic","- aDateTime\r\n\t\" Return the result of operation. \"\r\n\r\n\t^{'' doc'native operation'}","(\r\nfunction(self,aDateTime)\r\nreturn (self:notImplementedYet_(\"-\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"+","_plus"
,(
function(self,aDateTime)
return (self:notImplementedYet_("+"));
end
)
,"arithmetic","+ aDateTime\r\n\t\" Return the result of operation. \"\r\n\r\n\t^{'' doc'native operation'}","(\r\nfunction(self,aDateTime)\r\nreturn (self:notImplementedYet_(\"+\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"isValid",0
,(
function(self)
return (self:notImplementedYet_("isValid"));
end
)
,"testing","isValid\r\n\t\" Return true if the receiver is a valid instance. \"\r\n\r\n\t^{'' doc'native testing'}","(\r\nfunction(self)\r\nreturn (self:notImplementedYet_(\"isValid\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.DateTime,"asJSONObject",0
,(
function(self)

return (self);
end
)
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t{'self' doc'native converting'}.\r\n\t^self","(\r\nfunction(self)\r\n\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject["$klass"],"new",0
,(
function(self)
return ((self):error_("UndefinedObject can't be instantiated."));
end
)
,"instantiation","new\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self error: 'UndefinedObject can''t be instantiated.'","(\r\nfunction(self)\r\nreturn ((self):error_(\"UndefinedObject can't be instantiated.\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject["$klass"],"alias",0
,(
function(self)
return ((self):basicAt_ifAbsentPut_("@alias",(function()
return ((self):basicNew())
end)));
end
)
,"alias","alias\r\n\t\" Private - Return an alias of nil.\r\n\tNote that is is a hack used to wrap nil in an alias instance to make possible for Lua collections to contain nil\r\n\t\"\r\n\r\n\t^self basicAt: '@alias' ifAbsentPut: [ self basicNew ]","(\r\nfunction(self)\r\nreturn ((self):basicAt_ifAbsentPut_(\"@alias\",(function()\r\nreturn ((self):basicNew())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"ifNil:",0
,(
function(self,aBlock)
return ((aBlock):value());
end
)
,"testing","ifNil: aBlock\r\n\t\" Return the receiver if it is not nil, or the result of evaluating aBlock (if it is nil). \"\r\n\r\n\t^aBlock value","(\r\nfunction(self,aBlock)\r\nreturn ((aBlock):value());\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"ifNotNil:",0
,(
function(self,aBlock)
return (self);
end
)
,"testing","ifNotNil: aBlock\r\n\t\" Return the receiver if it is nil, or the result of evaluating aBlock. \"\r\n\r\n\t^self","(\r\nfunction(self,aBlock)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"ifNil:ifNotNil:",0
,(
function(self,aBlock,anotherBlock)
return ((aBlock):value());
end
)
,"testing","ifNil: aBlock ifNotNil: anotherBlock\r\n\t\" Return the receiver if it is nil, or the result of evaluating aBlock. \"\r\n\r\n\t^aBlock value","(\r\nfunction(self,aBlock,anotherBlock)\r\nreturn ((aBlock):value());\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"ifNotNil:ifNil:",0
,(
function(self,aBlock,anotherBlock)
return ((anotherBlock):value());
end
)
,"testing","ifNotNil: aBlock ifNil: anotherBlock\r\n\t\" Return the result of evaluating anotherBlock if teh receiver is nil, or the result of evaluating aBlock. \"\r\n\r\n\t^anotherBlock value","(\r\nfunction(self,aBlock,anotherBlock)\r\nreturn ((anotherBlock):value());\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"isNil",0
,(
function(self)
return (true);
end
)
,"testing","isNil\r\n\t\" Return true if the receiver is nil. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"notNil",0
,(
function(self)
return (false);
end
)
,"testing","notNil\r\n\t\" Return true if the receiver is not nil. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"printString",0
,(
function(self)
return ("nil");
end
)
,"printing","printString\r\n\t\" Return the text representation of the receiver. \"\r\n\r\n\t^#nil","(\r\nfunction(self)\r\nreturn (\"nil\");\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:",0
,(
function(self,aString,anotherString)
return ((self):subclass_instanceVariableNames_category_(aString,anotherString,nil));
end
)
,"instantiation","subclass: aString instanceVariableNames: anotherString\r\n\t\" Create a subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: anotherString\r\n\t\tcategory: nil","(\r\nfunction(self,aString,anotherString)\r\nreturn ((self):subclass_instanceVariableNames_category_(aString,anotherString,nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:category:",0
,(
function(self,aString,aString2,aString3)
return (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_category_(self,aString,aString2,aString3));
end
)
,"instantiation","subclass: aString instanceVariableNames: aString2 category: aString3\r\n\t\" Create a subclass of the receiver. \"\r\n\r\n\t^ClassBuilder new\r\n\t\tsuperclass: self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tcategory: aString3","(\r\nfunction(self,aString,aString2,aString3)\r\nreturn (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_category_(self,aString,aString2,aString3));\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"asJSONObject",0
,(
function(self)
return (nil);
end
)
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t^{'' doc'native constant'}","(\r\nfunction(self)\r\nreturn (nil);\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"shallowCopy",0
,(
function(self)
return (self);
end
)
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"deepCopy",0
,(
function(self)
return (self);
end
)
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"value",0
,(
function(self)
return (self);
end
)
,"evaluating","value\r\n\t\" Return the result of evaluating the receiver. \"","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"@","_at"
,(
function(self,aNumber)
return ((smalltalk.Point):x_y_(0,aNumber));
end
)
,"converting","@ aNumber\r\n\t\" Return a Point with coordinates given by the receiver and aNumber. \"\r\n\r\n\t^Point x: 0 y: aNumber","(\r\nfunction(self,aNumber)\r\nreturn ((smalltalk.Point):x_y_(0,aNumber));\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"=","_eq"
,(
function(self,anObject)
return (smalltalk:isNil_((anObject)));
end
)
,"comparing","= anObject\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\t^anObject isNil","(\r\nfunction(self,anObject)\r\nreturn (smalltalk:isNil_((anObject)));\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"~=","_no_eq"
,(
function(self,anObject)
return (smalltalk:notNil_((anObject)));
end
)
,"comparing","~= anObject\r\n\t\" Return true if the receiver is not equal to anObject. \"\r\n\r\n\t^anObject notNil","(\r\nfunction(self,anObject)\r\nreturn (smalltalk:notNil_((anObject)));\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"category:",0
,(
function(self,ignored)
return (self);
end
)
,"instantiation","category: ignored\r\n\t\" BUG - throw an error in ClassBuilder. \" ","(\r\nfunction(self,ignored)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:",0
,(
function(self,aString,aString2,classVarNames,poolVarNames,aCategory)
if (smalltalk:notNil_((((self):smalltalk()):globalAt_(aString))))==true then (self):note_(smalltalk:object_comma_(("WARNING: class REdefinition for "),aString)); end;
return (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(self,aString,aString2,classVarNames,poolVarNames,aCategory));
end
)
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\tpoolDictionaries: poolVarNames\r\n\tcategory: aCategory\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t(self smalltalk globalAt: aString) notNil ifTrue: [\r\n\t\tself note: 'WARNING: class REdefinition for ',aString.\r\n\t\t\"^self smalltalk globalAt: aString\"\r\n\t].\r\n\r\n\"\tself note: 'Creating ROOT class ',aString.\"\r\n\t^ClassBuilder new\r\n\t\tsuperclass: self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: poolVarNames\r\n\t\tcategory: aCategory","(\r\nfunction(self,aString,aString2,classVarNames,poolVarNames,aCategory)\r\nif (smalltalk:notNil_((((self):smalltalk()):globalAt_(aString))))==true then (self):note_(smalltalk:object_comma_((\"WARNING: class REdefinition for \"),aString)); end;\r\nreturn (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(self,aString,aString2,classVarNames,poolVarNames,aCategory));\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:",0
,(
function(self,aString,aString2,classVarNames,poolVarNames)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,classVarNames,poolVarNames,nil));
end
)
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\tpoolDictionaries: poolVarNames\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: poolVarNames\r\n\t\tcategory: nil","(\r\nfunction(self,aString,aString2,classVarNames,poolVarNames)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,classVarNames,poolVarNames,nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"compiler",0
,(
function(self)
return ((((self):smalltalk()):compilerSupport()):for_(nil));
end
)
,"Tools-printing","compiler\r\n\t\" Return the compiler of the receiver. \"\r\n\r\n\t^self smalltalk compilerSupport for: nil","(\r\nfunction(self)\r\nreturn ((((self):smalltalk()):compilerSupport()):for_(nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"==","_eq_eq"
,(
function(self,anObject)
return (smalltalk:isNil_((anObject)));
end
)
,"Tools-comparing","== anObject\r\n\t^anObject isNil","(\r\nfunction(self,anObject)\r\nreturn (smalltalk:isNil_((anObject)));\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"~~","_no_no"
,(
function(self,anObject)
return (smalltalk:notNil_((anObject)));
end
)
,"Tools-comparing","~~ anObject\r\n\t^anObject notNil","(\r\nfunction(self,anObject)\r\nreturn (smalltalk:notNil_((anObject)));\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"handles",0
,(
function(self)
return (self);
end
)
,"Natives-converting","handles\r\n\t\" Return the result of collecting the handles of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.UndefinedObject,"handle",0
,(
function(self)
return ((self):asJSONObject());
end
)
,"Natives-converting","handle\r\n\t\" Return the handle of the receiver. \"\r\n\r\n\t^self asJSONObject","(\r\nfunction(self)\r\nreturn ((self):asJSONObject());\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection["$klass"],"streamClass",0
,(
function(self)
return (smalltalk.Stream);
end
)
,"streams","streamClass\r\n\t\" Private - Return the support for streamming on the receiver's instances. \"\r\n\r\n\t^Stream","(\r\nfunction(self)\r\nreturn (smalltalk.Stream);\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection["$klass"],"with:",0
,(
function(self,anObject)
return ((
function(_s8_rec)
	(_s8_rec):add_(anObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","with: anObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tadd: anObject;\r\n\t\tyourself","(\r\nfunction(self,anObject)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(anObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection["$klass"],"with:with:",0
,(
function(self,anObject,anotherObject)
return ((
function(_s8_rec)
	(_s8_rec):add_(anObject);
	(_s8_rec):add_(anotherObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","with: anObject with: anotherObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tadd: anObject;\r\n\t\tadd: anotherObject;\r\n\t\tyourself","(\r\nfunction(self,anObject,anotherObject)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(anObject);\r\n\t(_s8_rec):add_(anotherObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection["$klass"],"with:with:with:",0
,(
function(self,firstObject,secondObject,thirdObject)
return ((
function(_s8_rec)
	(_s8_rec):add_(firstObject);
	(_s8_rec):add_(secondObject);
	(_s8_rec):add_(thirdObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","with: firstObject with: secondObject with: thirdObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tadd: firstObject;\r\n\t\tadd: secondObject;\r\n\t\tadd: thirdObject;\r\n\t\tyourself","(\r\nfunction(self,firstObject,secondObject,thirdObject)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(firstObject);\r\n\t(_s8_rec):add_(secondObject);\r\n\t(_s8_rec):add_(thirdObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection["$klass"],"with:with:with:with:",0
,(
function(self,firstObject,secondObject,thirdObject,fourthObject)
return ((
function(_s8_rec)
	(_s8_rec):add_(firstObject);
	(_s8_rec):add_(secondObject);
	(_s8_rec):add_(thirdObject);
	(_s8_rec):add_(fourthObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","with: firstObject with: secondObject with: thirdObject with: fourthObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tadd: firstObject;\r\n\t\tadd: secondObject;\r\n\t\tadd: thirdObject;\r\n\t\tadd: fourthObject;\r\n\t\tyourself","(\r\nfunction(self,firstObject,secondObject,thirdObject,fourthObject)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(firstObject);\r\n\t(_s8_rec):add_(secondObject);\r\n\t(_s8_rec):add_(thirdObject);\r\n\t(_s8_rec):add_(fourthObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection["$klass"],"withAll:",0
,(
function(self,aCollection)
return ((
function(_s8_rec)
	(_s8_rec):addAll_(aCollection);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","withAll: aCollection\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\taddAll: aCollection;\r\n\t\tyourself","(\r\nfunction(self,aCollection)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAll_(aCollection);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection["$klass"],"basicNew:",0
,(
function(self,size)
return ((self):subclassResponsibility_("basicNew:"));
end
)
,"instantiation","basicNew: size\r\n\t\" Return an instance of the receiver of specified size. \"\r\n\r\n\t^self subclassResponsibility: #basicNew:","(\r\nfunction(self,size)\r\nreturn ((self):subclassResponsibility_(\"basicNew:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection["$klass"],"of:withAll:",0
,(
function(self,aType,handles)
if ((aType):includes_(","))==true then local stream=nil
(function()
	local _s8_value=((aType):stream())
	stream=_s8_value
	return _s8_value
end)();
return ((handles):collect_((function(h)
local cls=nil
(function()
	local _s8_value=((stream):upTo_(","))
	cls=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_(((cls):isEmpty()),(function()
return (h)
end),(function()
(function()
	local _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(cls,(function()
return ((self):error_(smalltalk:object_comma_(("Missing global "),cls)))
end)))
	cls=_s8_value
	return _s8_value
end)();return ((cls):_at(h))
end)))
end))); end;
return ((self):withAll_(((smalltalk.Array):_at(handles)):collect_((function(each)
return ((aType):_at(each))
end))));
end
)
,"Natives-instantiation","of: aType withAll: handles\r\n\t\" Return an instance of the receiver wrapping handles with a type (or nil). \"\r\n\r\n\t(aType includes: $,) ifTrue: [ | stream |\r\n\t\tstream := aType stream.\r\n\t\t^handles collect: [:h| | cls |\r\n\t\t\tcls := stream upTo: $,.\r\n\t\t\tcls isEmpty ifTrue: [ h ] ifFalse: [\r\n\t\t\t\tcls := Smalltalk at: cls ifAbsent: [\r\n\t\t\t\t\tself error: 'Missing global ' ,cls\r\n\t\t\t\t].\r\n\t\t\t\tcls @ h\r\n\t\t\t]\r\n\t\t]\r\n\t].\r\n\t^self withAll: (Array @ handles collect: [:each| aType @ each ])","(\r\nfunction(self,aType,handles)\r\nif ((aType):includes_(\",\"))==true then local stream=nil\r\n(function()\r\n\tlocal _s8_value=((aType):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((handles):collect_((function(h)\r\nlocal cls=nil\r\n(function()\r\n\tlocal _s8_value=((stream):upTo_(\",\"))\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_(((cls):isEmpty()),(function()\r\nreturn (h)\r\nend),(function()\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(cls,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Missing global \"),cls)))\r\nend)))\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();return ((cls):_at(h))\r\nend)))\r\nend))); end;\r\nreturn ((self):withAll_(((smalltalk.Array):_at(handles)):collect_((function(each)\r\nreturn ((aType):_at(each))\r\nend))));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"wrap:",0
,(
function(self,anObject)
if smalltalk:isNil_(anObject) --anObject==nil
	then return smalltalk.UndefinedObject:alias()
	else return anObject end;
return (anObject);
end
)
,"alias","wrap: anObject\r\n\t\" Private - Return an element holding anObject. \"\r\n\r\n\t{'self'}.\r\n\t^anObject","(\r\nfunction(self,anObject)\r\nif smalltalk:isNil_(anObject) --anObject==nil\r\n\tthen return smalltalk.UndefinedObject:alias()\r\n\telse return anObject end;\r\nreturn (anObject);\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"unwrap:",0
,(
function(self,anObject)
--if anObject==nil then return nil end
	--if (type(anObject)=="table") and smalltalk:isNil_(anObject)
	if smalltalk:isNil_(anObject)
		then return nil
		else return anObject end;
return (anObject);
end
)
,"alias","unwrap: anObject\r\n\t\" Private - Return object held by anObject. \"\r\n\r\n\t{'self'}.\r\n\t^anObject","(\r\nfunction(self,anObject)\r\n--if anObject==nil then return nil end\r\n\t--if (type(anObject)==\"table\") and smalltalk:isNil_(anObject)\r\n\tif smalltalk:isNil_(anObject)\r\n\t\tthen return nil\r\n\t\telse return anObject end;\r\nreturn (anObject);\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"size",0
,(
function(self)
return ((self):subclassResponsibility_("size"));
end
)
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^self subclassResponsibility: #size","(\r\nfunction(self)\r\nreturn ((self):subclassResponsibility_(\"size\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"readStream",0
,(
function(self)
return ((self):stream());
end
)
,"streams","readStream\r\n\t\" Return a read stream on the receiver. \"\r\n\r\n\t^self stream","(\r\nfunction(self)\r\nreturn ((self):stream());\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"writeStream",0
,(
function(self)
return ((self):stream());
end
)
,"streams","writeStream\r\n\t\" Return a write stream on the receiver. \"\r\n\r\n\t^self stream","(\r\nfunction(self)\r\nreturn ((self):stream());\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"stream",0
,(
function(self)
return (((self):streamClass()):on_(self));
end
)
,"streams","stream\r\n\t\" Return a stream on the receiver. \"\r\n\r\n\t^self streamClass on: self","(\r\nfunction(self)\r\nreturn (((self):streamClass()):on_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"streamClass",0
,(
function(self)
return (((self)["$klass"]):streamClass());
end
)
,"streams","streamClass\r\n\t\" Private - Return the support for streamming on the receiver. \"\r\n\r\n\t^self class streamClass","(\r\nfunction(self)\r\nreturn (((self)[\"$klass\"]):streamClass());\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"objectNotFound",0
,(
function(self)
((self):smalltalk()):objectNotFound(nil,nil,self);
return ((self):error_("Object is not in the collection"));
end
)
,"error","objectNotFound\r\n\t\" Private - Generates an error.\r\n\tAn object was not found in the receiver's contents.\r\n\t\"\r\n\r\n\tself smalltalk #objectNotFound: nil at: nil in: self.\r\n\t^self error: 'Object is not in the collection'","(\r\nfunction(self)\r\n((self):smalltalk()):objectNotFound(nil,nil,self);\r\nreturn ((self):error_(\"Object is not in the collection\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"invalidIndex:",0
,(
function(self,anIndex)
return ((self):error_(smalltalk:object_comma_(("Invalid index "),anIndex)));
end
)
,"error","invalidIndex: anIndex\r\n\t\" Private - Generates an error.\r\n\tAn index to the receiver's contents is invalid/wrong.\r\n\t\"\r\n\r\n\t^self error: 'Invalid index ' ,anIndex ","(\r\nfunction(self,anIndex)\r\nreturn ((self):error_(smalltalk:object_comma_((\"Invalid index \"),anIndex)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"objectNotFound:",0
,(
function(self,anObject)
((self):smalltalk()):objectNotFound(anObject,nil,self);
return ((self):error_(smalltalk:object_comma_(("Object not found: "),(self):toString_(anObject))));
end
)
,"error","objectNotFound: anObject\r\n\t\" Private - Generates an error.\r\n\tanObject was not found in the receiver's contents.\r\n\t\"\r\n\r\n\tself smalltalk #objectNotFound: anObject at: nil in: self.\r\n\t^self error: 'Object not found: ' ,(self toString: anObject)","(\r\nfunction(self,anObject)\r\n((self):smalltalk()):objectNotFound(anObject,nil,self);\r\nreturn ((self):error_(smalltalk:object_comma_((\"Object not found: \"),(self):toString_(anObject))));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"objectNotFoundAt:",0
,(
function(self,indexOrKey)
((self):smalltalk()):objectNotFound(nil,indexOrKey,self);
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Object not found at "),(self):toString_(indexOrKey)))," in ")),(self):asLiteral())));
end
)
,"error","objectNotFoundAt: indexOrKey\r\n\t\" Private - Generates an error.\r\n\tThe object at key/index was not found in the receiver's contents.\r\n\t\"\r\n\r\n\tself smalltalk #objectNotFound: nil at: indexOrKey in: self.\r\n\t^self error: 'Object not found at '\r\n\t\t,(self toString: indexOrKey)\r\n\t\t,' in ' ,self asLiteral","(\r\nfunction(self,indexOrKey)\r\n((self):smalltalk()):objectNotFound(nil,indexOrKey,self);\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Object not found at \"),(self):toString_(indexOrKey))),\" in \")),(self):asLiteral())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"add:",0
,(
function(self,anObject)
return ((self):subclassResponsibility_("add:"));
end
)
,"adding","add: anObject\r\n\t\" Add anObject to the receiver. \"\r\n\r\n\t^self subclassResponsibility: #add:","(\r\nfunction(self,anObject)\r\nreturn ((self):subclassResponsibility_(\"add:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"addAll:",0
,(
function(self,aCollection)
(aCollection):do_((function(each)
return ((self):add_(each))
end));
return (aCollection);
end
)
,"adding","addAll: aCollection\r\n\t\" Add objects in aCollection to the receiver. \"\r\n\r\n\taCollection do: [:each | self add: each ].\r\n\t^aCollection","(\r\nfunction(self,aCollection)\r\n(aCollection):do_((function(each)\r\nreturn ((self):add_(each))\r\nend));\r\nreturn (aCollection);\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,",","_comma"
,(
function(self,aCollection)
return ((
function(_s8_rec)
	(_s8_rec):addAll_(aCollection);
	return ((_s8_rec):yourself())
end
)((self):copy()));
end
)
,"copying",", aCollection\r\n\t\" Return a copy of the receiver with all contents of aCollection. \"\r\n\r\n\t^self copy\r\n\t\taddAll: aCollection;\r\n\t\tyourself","(\r\nfunction(self,aCollection)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAll_(aCollection);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):copy()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"copyWith:",0
,(
function(self,anObject)
return ((
function(_s8_rec)
	(_s8_rec):add_(anObject);
	return ((_s8_rec):yourself())
end
)((self):copy()));
end
)
,"copying","copyWith: anObject\r\n\t\" Return a copy of the receiver with anObject. \"\r\n\r\n\t^self copy add: anObject; yourself","(\r\nfunction(self,anObject)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(anObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):copy()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"copyWithAll:",0
,(
function(self,aCollection)
return ((
function(_s8_rec)
	(_s8_rec):addAll_(aCollection);
	return ((_s8_rec):yourself())
end
)((self):copy()));
end
)
,"copying","copyWithAll: aCollection\r\n\t\" Return a copy of the receiver with all contents of aCollection. \"\r\n\r\n\t^self copy\r\n\t\taddAll: aCollection;\r\n\t\tyourself","(\r\nfunction(self,aCollection)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAll_(aCollection);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):copy()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"asArray",0
,(
function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(self):do_((function(each)
return ((result):add_(each))
end));
return (result);
end
)
,"converting","asArray\r\n\t\" Return an array with the contents of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := Array new.\r\n\tself do: [:each| result add: each ].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(each)\r\nreturn ((result):add_(each))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"do:",0
,(
function(self,aBlock)
return ((self):subclassResponsibility_("do:"));
end
)
,"enumerating","do: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver. \"\r\n\r\n\t^self subclassResponsibility: #do:","(\r\nfunction(self,aBlock)\r\nreturn ((self):subclassResponsibility_(\"do:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"detect:ifNone:",0
,(
function(self,aBlock,anotherBlock)
return ((self):subclassResponsibility_("detect:ifNone:"));
end
)
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. \"\r\n\r\n\t^self subclassResponsibility: #detect:ifNone:","(\r\nfunction(self,aBlock,anotherBlock)\r\nreturn ((self):subclassResponsibility_(\"detect:ifNone:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"reverseDo:",0
,(
function(self,aBlock)
return ((self):subclassResponsibility_("reverseDo:"));
end
)
,"enumerating","reverseDo: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver in reverse order of iteration. \"\r\n\r\n\t^self subclassResponsibility: #reverseDo:","(\r\nfunction(self,aBlock)\r\nreturn ((self):subclassResponsibility_(\"reverseDo:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"collect:",0
,(
function(self,aBlock)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(self):do_((function(each)
return ((result):add_((aBlock):value_(each)))
end));
return (result);
end
)
,"enumerating","collect: aBlock\r\n\t\" Return a collection with the result of evaluating aBlock with the contents of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tself do: [:each | result add: (aBlock value: each) ].\r\n\t^result","(\r\nfunction(self,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(each)\r\nreturn ((result):add_((aBlock):value_(each)))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"select:",0
,(
function(self,aBlock)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(self):do_((function(each)
return (smalltalk:if_true_false_(((aBlock):value_(each)),(function()
return ((result):add_(each))
end),nil))
end));
return (result);
end
)
,"enumerating","select: aBlock\r\n\t\" Return the contents of the receiver which evaluates aBlock to true. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tself do: [:each|\r\n\t    (aBlock value: each) ifTrue: [ result add: each ]\r\n\t].\r\n\t^result","(\r\nfunction(self,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((aBlock):value_(each)),(function()\r\nreturn ((result):add_(each))\r\nend),nil))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"detect:",0
,(
function(self,aBlock)
return ((self):detect_ifNone_(aBlock,(function()
return ((self):objectNotFound())
end)));
end
)
,"enumerating","detect: aBlock\r\n\t\" Return the object in the receiver that return true when evaluated with aBlock.\r\n\tGenerates an error if there is no object that evaluates aBlock to true.\r\n\t\"\r\n\r\n\t^self detect: aBlock ifNone: [ self objectNotFound ]","(\r\nfunction(self,aBlock)\r\nreturn ((self):detect_ifNone_(aBlock,(function()\r\nreturn ((self):objectNotFound())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"do:andBetweenDo:",0
,(
function(self,aBlock,separatorBlock)
return ((self):do_separatedBy_(aBlock,separatorBlock));
end
)
,"enumerating","do: aBlock andBetweenDo: separatorBlock\r\n\t\" For each element in the receiver, evaluate aBlock with that element as the argument.\r\n\tEvaluate the separatorBlock between successive elements of the receiver.\r\n\t\"\r\n\r\n\t^self do: aBlock separatedBy: separatorBlock","(\r\nfunction(self,aBlock,separatorBlock)\r\nreturn ((self):do_separatedBy_(aBlock,separatorBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"do:separatedBy:",0
,(
function(self,aBlock,anotherBlock)
local first=nil
(function()
	local _s8_value=(true)
	first=_s8_value
	return _s8_value
end)();
(self):do_((function(each)
if (first)==true then (function()
	local _s8_value=(false)
	first=_s8_value
	return _s8_value
end)(); else (anotherBlock):value(); end;return ((aBlock):value_(each))
end));
return (self);
end
)
,"enumerating","do: aBlock separatedBy: anotherBlock\r\n\t\" Evaluate aBlock for contents of the receiver evaluating anotherBlock inbetween aBlock evaluations. \"\r\n\r\n\t| first |\r\n\tfirst := true.\r\n\tself do: [:each |\r\n\t    first\r\n\t\tifTrue: [ first := false ]\r\n\t\tifFalse: [ anotherBlock value ].\r\n\t    aBlock value: each\r\n\t]","(\r\nfunction(self,aBlock,anotherBlock)\r\nlocal first=nil\r\n(function()\r\n\tlocal _s8_value=(true)\r\n\tfirst=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(each)\r\nif (first)==true then (function()\r\n\tlocal _s8_value=(false)\r\n\tfirst=_s8_value\r\n\treturn _s8_value\r\nend)(); else (anotherBlock):value(); end;return ((aBlock):value_(each))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"inject:into:",0
,(
function(self,anObject,aBlock)
local result=nil
(function()
	local _s8_value=(anObject)
	result=_s8_value
	return _s8_value
end)();
(self):do_((function(each)
return ((function()
	local _s8_value=((aBlock):value_value_(result,each))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
)
,"enumerating","inject: anObject into: aBlock\r\n\t\" Evaluate aBlock for result of previous evaluation and contents of the receiver.\r\n\tOn first evaluation anObject is used as first argument to evaluate aBlock.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := anObject.\r\n\tself do: [:each | result := aBlock value: result value: each ].\r\n\t^result","(\r\nfunction(self,anObject,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(each)\r\nreturn ((function()\r\n\tlocal _s8_value=((aBlock):value_value_(result,each))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"reject:",0
,(
function(self,aBlock)
return ((self):select_((function(each)
return (smalltalk:isObject_equalTo_(((aBlock):value_(each)),false))
end)));
end
)
,"enumerating","reject: aBlock\r\n\t\" Return the contents of the receiver wich evaluates aBlock to false. \"\r\n\r\n\t^self select: [:each | (aBlock value: each) = false]","(\r\nfunction(self,aBlock)\r\nreturn ((self):select_((function(each)\r\nreturn (smalltalk:isObject_equalTo_(((aBlock):value_(each)),false))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"select:thenCollect:",0
,(
function(self,selectBlock,collectBlock)
return (((self):select_(selectBlock)):collect_(collectBlock));
end
)
,"enumerating","select: selectBlock thenCollect: collectBlock\r\n\t\" Return a new collection with the result of evaluating collectBlock on the contents of the receiver wich evaluates selectBlock to true. \"\r\n\r\n\t^(self select: selectBlock) collect: collectBlock","(\r\nfunction(self,selectBlock,collectBlock)\r\nreturn (((self):select_(selectBlock)):collect_(collectBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"collect:thenSelect:",0
,(
function(self,collectBlock,selectBlock)
return (((self):collect_(collectBlock)):select_(selectBlock));
end
)
,"enumerating","collect: collectBlock thenSelect: selectBlock\r\n\t\" Return a new collection with the result of evaluating collectBlock on the contents of the receiver wich evaluates selectBlock to true. \"\r\n\r\n\t^(self collect: collectBlock) select: selectBlock","(\r\nfunction(self,collectBlock,selectBlock)\r\nreturn (((self):collect_(collectBlock)):select_(selectBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"reversed",0
,(
function(self)
return ((self):subclassResponsibility_("reversed"));
end
)
,"copying","reversed\r\n\t\" Return an array with the contents of the receiver in reverse order. \"\r\n\r\n\t^self subclassResponsibility: #reversed","(\r\nfunction(self)\r\nreturn ((self):subclassResponsibility_(\"reversed\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"includes:",0
,(
function(self,anObject)
return ((self):subclassResponsibility_("includes:"));
end
)
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t^self subclassResponsibility: #includes:","(\r\nfunction(self,anObject)\r\nreturn ((self):subclassResponsibility_(\"includes:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"notEmpty",0
,(
function(self)
return (smalltalk:booleanNot_(((self):isEmpty())));
end
)
,"testing","notEmpty\r\n\t\" Return true if the receiver is not empty. \"\r\n\r\n\t^self isEmpty not","(\r\nfunction(self)\r\nreturn (smalltalk:booleanNot_(((self):isEmpty())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"isEmpty",0
,(
function(self)
return ((((self):size())==0));
end
)
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^self size == 0","(\r\nfunction(self)\r\nreturn ((((self):size())==0));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"remove:",0
,(
function(self,anObject)
return ((self):remove_ifAbsent_(anObject,(function()
return ((self):objectNotFound_(anObject))
end)));
end
)
,"removing","remove: anObject\r\n\t\" Remove anObject from receiver, return the removed object. \"\r\n\r\n\t^self remove: anObject ifAbsent: [ self objectNotFound: anObject ]","(\r\nfunction(self,anObject)\r\nreturn ((self):remove_ifAbsent_(anObject,(function()\r\nreturn ((self):objectNotFound_(anObject))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"remove:ifAbsent:",0
,(
function(self,anObject,aBlock)
return ((self):subclassResponsibility_("remove:ifAbsent:"));
end
)
,"removing","remove: anObject ifAbsent: aBlock\r\n\t\" Remove anObject from receiver.\r\n\tReturn the removed object or the result of evaluating aBlock (if the object is not found).\r\n\t\"\r\n\r\n\t^self subclassResponsibility: #remove:ifAbsent:","(\r\nfunction(self,anObject,aBlock)\r\nreturn ((self):subclassResponsibility_(\"remove:ifAbsent:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"removeAll:",0
,(
function(self,aCollection)
(aCollection):do_((function(each)
return ((self):remove_(each))
end));
return (aCollection);
end
)
,"removing","removeAll: aCollection\r\n\t\" Remove aCollection from receiver. \"\r\n\r\n\taCollection do: [:each| self remove: each ].\r\n\t^aCollection","(\r\nfunction(self,aCollection)\r\n(aCollection):do_((function(each)\r\nreturn ((self):remove_(each))\r\nend));\r\nreturn (aCollection);\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"removeAll",0
,(
function(self)
(self):removeAll_((self):shallowCopy());
return (self);
end
)
,"removing","removeAll\r\n\t\" Remove all elements in the receiver. \"\r\n\r\n\tself removeAll: self shallowCopy","(\r\nfunction(self)\r\n(self):removeAll_((self):shallowCopy());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"occurrencesOf:",0
,(
function(self,anObject)
return ((self):inject_into_(0,(function(total,each)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((each),anObject)),(function()
return ((total):_plus(1))
end),(function()
return (total)
end)))
end)));
end
)
,"counting","occurrencesOf: anObject\r\n\t\" Return the occurrences of anObject in the receiver. \"\r\n\r\n\t^self inject: 0 into: [:total :each|\r\n\t\teach = anObject ifTrue: [ total + 1 ] ifFalse: [total]\r\n\t]","(\r\nfunction(self,anObject)\r\nreturn ((self):inject_into_(0,(function(total,each)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((each),anObject)),(function()\r\nreturn ((total):_plus(1))\r\nend),(function()\r\nreturn (total)\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"shallowCopy",0
,(
function(self)
return ((self):collect_((function(each)
return (each)
end)));
end
)
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self collect: [:each| each ]","(\r\nfunction(self)\r\nreturn ((self):collect_((function(each)\r\nreturn (each)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"deepCopy",0
,(
function(self)
return ((self):collect_((function(each)
return ((each):deepCopy())
end)));
end
)
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self collect: [:each| each deepCopy ]","(\r\nfunction(self)\r\nreturn ((self):collect_((function(each)\r\nreturn ((each):deepCopy())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"on:",0
,(
function(self,target)
local array=nil
(function()
	local _s8_value=((self):asArray())
	array=_s8_value
	return _s8_value
end)();
return ((1):to_by_value_((array):size(),1,(function(index,block)
return ((block):value_((target):at_ifAbsent_((array):at_(index),(function()
return (nil)
end))))
end)));
end
)
,"iterating","on: target\r\n\t\" Return an iterable on the target contents accessed by the receiver. \"\r\n\r\n\t| array |\r\n\tarray := self asArray.\r\n\t^1 to: array size by: 1 value: [:index :block|\r\n\t\tblock value: (target at: (array at: index) ifAbsent:[])\r\n\t]","(\r\nfunction(self,target)\r\nlocal array=nil\r\n(function()\r\n\tlocal _s8_value=((self):asArray())\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((1):to_by_value_((array):size(),1,(function(index,block)\r\nreturn ((block):value_((target):at_ifAbsent_((array):at_(index),(function()\r\nreturn (nil)\r\nend))))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"asSet",0
,(
function(self)
return ((smalltalk.Set):withAll_(self));
end
)
,"converting","asSet\r\n\t\" Return the receiver contents in a Set. \"\r\n\r\n\t^Set withAll: self","(\r\nfunction(self)\r\nreturn ((smalltalk.Set):withAll_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"asHashedSet",0
,(
function(self)
return ((smalltalk.HashedSet):withAll_(self));
end
)
,"converting","asHashedSet\r\n\t\" Return the receiver contents in a HashedSet. \"\r\n\r\n\t^HashedSet withAll: self","(\r\nfunction(self)\r\nreturn ((smalltalk.HashedSet):withAll_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"asParser",0
,(
function(self)
return ((smalltalk.PPChoiceParser):withAll_((self):asArray()));
end
)
,"Compiler-converting","asParser\r\n\t\" Return a parser on the receiver. \"\r\n\r\n\t^PPChoiceParser withAll: self asArray","(\r\nfunction(self)\r\nreturn ((smalltalk.PPChoiceParser):withAll_((self):asArray()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"fileOut",0
,(
function(self)
return ((smalltalk.Exporter):fileOut_(self));
end
)
,"Tools-fileOut","fileOut\r\n\t\" Return fileOut definition and code of classes in the receiver. \"\r\n\r\n\t^Exporter fileOut: self","(\r\nfunction(self)\r\nreturn ((smalltalk.Exporter):fileOut_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"export",0
,(
function(self)
return ((smalltalk.Exporter):export_(self));
end
)
,"Tools-export","export\r\n\t\" Return the result of exporting definition and source code of classes in the receiver. \"\r\n\r\n\t^Exporter export: self","(\r\nfunction(self)\r\nreturn ((smalltalk.Exporter):export_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"emmit",0
,(
function(self)
return (((self):asArray()):compose_with_((function(each)
return ((self):emmit_(each))
end),"\r\n"));
end
)
,"Builders-emmiting","emmit\r\n\t\" Emmit (fileIn & save generated code of) the fileNames in the receiver. \"\r\n\r\n\t^self asArray compose: [:each| self emmit: each ] with: '\r\n'","(\r\nfunction(self)\r\nreturn (((self):asArray()):compose_with_((function(each)\r\nreturn ((self):emmit_(each))\r\nend),\"\\r\\n\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"emmitSt",0
,(
function(self)
return (((self):collect_((function(module)
return (smalltalk:object_comma_((smalltalk:object_comma_((module),".")),(smalltalk.String):sourceFileExtension()))
end))):emmit());
end
)
,"Builders-emmiting","emmitSt\r\n\t\" Emmit the code of source modules (st files) in the receiver. \"\r\n\r\n\t^(self collect: [:module| module ,$. ,String sourceFileExtension ]) emmit","(\r\nfunction(self)\r\nreturn (((self):collect_((function(module)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((module),\".\")),(smalltalk.String):sourceFileExtension()))\r\nend))):emmit());\r\nend\r\n)")
smalltalk:bind(smalltalk.Collection,"handles",0
,(
function(self)
return (((self):asArray()):handles());
end
)
,"Natives-converting","handles\r\n\t\" Return an array with the handles of the receiver. \"\r\n\r\n\t^self asArray handles","(\r\nfunction(self)\r\nreturn (((self):asArray()):handles());\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"at:",0
,(
function(self,anIndex)
return ((self):at_ifAbsent_(anIndex,(function()
return ((self):objectNotFoundAt_(anIndex))
end)));
end
)
,"accessing","at: anIndex\r\n\t\" Return the object in the receiver at anIndex position. \"\r\n\r\n\t^self at: anIndex ifAbsent: [ self objectNotFoundAt: anIndex ]","(\r\nfunction(self,anIndex)\r\nreturn ((self):at_ifAbsent_(anIndex,(function()\r\nreturn ((self):objectNotFoundAt_(anIndex))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"at:ifAbsent:",0
,(
function(self,anIndex,aBlock)
return ((self):subclassResponsibility_("at:ifAbsent:"));
end
)
,"accessing","at: anIndex ifAbsent: aBlock\r\n\t\" Return the object in the receiver at anIndex position or the result of evaluating aBlock. \"\r\n\r\n\t^self subclassResponsibility: #at:ifAbsent:","(\r\nfunction(self,anIndex,aBlock)\r\nreturn ((self):subclassResponsibility_(\"at:ifAbsent:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"at:put:",0
,(
function(self,anIndex,anObject)
return ((self):subclassResponsibility_("at:put:"));
end
)
,"accessing","at: anIndex put: anObject\r\n\t\" Set the object in the receiver at anIndex position. \"\r\n\r\n\t^self subclassResponsibility: #at:put:","(\r\nfunction(self,anIndex,anObject)\r\nreturn ((self):subclassResponsibility_(\"at:put:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"at:ifAbsentPut:",0
,(
function(self,aKey,aBlock)
return ((self):at_ifAbsent_(aKey,(function()
return ((self):at_put_(aKey,(aBlock):value()))
end)));
end
)
,"accessing","at: aKey ifAbsentPut: aBlock\r\n\t\" Return the value at aKey, or add the result of evaluating aBlock to the receiver if it is absent. \"\r\n\r\n\t^self at: aKey ifAbsent: [ self at: aKey put: aBlock value ]","(\r\nfunction(self,aKey,aBlock)\r\nreturn ((self):at_ifAbsent_(aKey,(function()\r\nreturn ((self):at_put_(aKey,(aBlock):value()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"copyFrom:to:",0
,(
function(self,anIndex,anotherIndex)
return ((self):subclassResponsibility_("copyFrom:to:"));
end
)
,"copying","copyFrom: anIndex to: anotherIndex\r\n\t\" Return a copy of the receiver. \"\r\n\r\n\t^self subclassResponsibility: #copyFrom:to:","(\r\nfunction(self,anIndex,anotherIndex)\r\nreturn ((self):subclassResponsibility_(\"copyFrom:to:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"indexOf:",0
,(
function(self,anObject)
return ((self):indexOf_ifAbsent_(anObject,(function()
return (0)
end)));
end
)
,"testing","indexOf: anObject\r\n\t\" Return the position of anObject in the receiver, or 0. \"\r\n\r\n\t^self indexOf: anObject ifAbsent: [ 0 ]","(\r\nfunction(self,anObject)\r\nreturn ((self):indexOf_ifAbsent_(anObject,(function()\r\nreturn (0)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"indexOf:ifAbsent:",0
,(
function(self,anObject,aBlock)

	for i,value in ipairs(self) do
		if (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then return i end
	end
	if true then return aBlock:value() end;
return (self);
end
)
,"testing","indexOf: anObject ifAbsent: aBlock\r\n\t\" Return the position of anObject in the receiver, or the result of evaluating aBlock. \"\r\n\r\n\t{'' doc'detection'}","(\r\nfunction(self,anObject,aBlock)\r\n\r\n\tfor i,value in ipairs(self) do\r\n\t\tif (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then return i end\r\n\tend\r\n\tif true then return aBlock:value() end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"do:",0
,(
function(self,aBlock)
return ((self):implementedBySubclass_("do:"));
end
)
,"enumerating","do: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver. \"\r\n\r\n\t^self implementedBySubclass: #do: ","(\r\nfunction(self,aBlock)\r\nreturn ((self):implementedBySubclass_(\"do:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"detect:ifNone:",0
,(
function(self,aBlock,anotherBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();

	for _,value in ipairs(self) do
		local v=self:unwrap_(value)
		if (fn(v)) then return v end
	end
	if true then return anotherBlock:value() end;
return (self);
end
)
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'\tself do: [:each|\r\n\t\t(aBlock value: each) ifTrue: [ ^each ]\r\n\t].\r\n\t^anotherBlock value'\r\n\tdoc'detection'}","(\r\nfunction(self,aBlock,anotherBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\n\tfor _,value in ipairs(self) do\r\n\t\tlocal v=self:unwrap_(value)\r\n\t\tif (fn(v)) then return v end\r\n\tend\r\n\tif true then return anotherBlock:value() end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"reversed",0
,(
function(self)

	local result = smalltalk.Array:new()
	local top = #self + 1
	for i,v in ipairs(self) do result[top - i] = v end
	if true then return result end;
return (self);
end
)
,"copying","reversed\r\n\t\" Return an array with the contents of the receiver in reverse order. \"\r\n\r\n\t{'' doc'converting'}","(\r\nfunction(self)\r\n\r\n\tlocal result = smalltalk.Array:new()\r\n\tlocal top = #self + 1\r\n\tfor i,v in ipairs(self) do result[top - i] = v end\r\n\tif true then return result end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"isEmpty",0
,(
function(self)
return (#self==0);
end
)
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty.\r\n\tNote: ^self size = 0 is slower than inlined impl.\r\n\t\"\r\n\r\n\t^{'' doc'testing'}","(\r\nfunction(self)\r\nreturn (#self==0);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"reverseDo:",0
,(
function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
for i = #self,1,-1 do fn(self:unwrap_(self[i])) end;
return (self);
end
)
,"enumerating","reverseDo: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver in reverse order of iteration. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'\tself size to: 1 by: -1 do: [:i|\r\n\t\taBlock value: (self at: i)\r\n\t]' doc'(reversed) iteration'}","(\r\nfunction(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nfor i = #self,1,-1 do fn(self:unwrap_(self[i])) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"includes:",0
,(
function(self,anObject)

	for _,value in ipairs(self) do
		if (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then return true end
	end
	if true then return false end;
if not (((self):isObject_(anObject)))==true then return ((((self):indexOf(anObject)) > -1)); end;
if true then end;
return (self);
end
)
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t{'self'}.\r\n\t(self isObject: anObject) ifFalse: [ ^(self #indexOf: anObject) > -1 ].\r\n\t{'' doc'native detection'}","(\r\nfunction(self,anObject)\r\n\r\n\tfor _,value in ipairs(self) do\r\n\t\tif (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then return true end\r\n\tend\r\n\tif true then return false end;\r\nif not (((self):isObject_(anObject)))==true then return ((((self):indexOf(anObject)) > -1)); end;\r\nif true then end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"occurrencesOf:",0
,(
function(self,anObject)

	local count = 0
	for _,value in ipairs(self) do
		if (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then count = count + 1 end
	end
	if true then return count end;
return (self);
end
)
,"counting","occurrencesOf: anObject\r\n\t\" Return the occurrences of anObject in the receiver. \"\r\n\r\n\t{'' doc'native counting'}","(\r\nfunction(self,anObject)\r\n\r\n\tlocal count = 0\r\n\tfor _,value in ipairs(self) do\r\n\t\tif (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then count = count + 1 end\r\n\tend\r\n\tif true then return count end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"first",0
,(
function(self)
return ((self):at_(1));
end
)
,"accessing","first\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t^self at: 1","(\r\nfunction(self)\r\nreturn ((self):at_(1));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"fourth",0
,(
function(self)
return ((self):at_(4));
end
)
,"accessing","fourth\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t^self at: 4","(\r\nfunction(self)\r\nreturn ((self):at_(4));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"last",0
,(
function(self)
return ((self):at_((self):size()));
end
)
,"accessing","last\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t^self at: self size","(\r\nfunction(self)\r\nreturn ((self):at_((self):size()));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"second",0
,(
function(self)
return ((self):at_(2));
end
)
,"accessing","second\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t^self at: 2","(\r\nfunction(self)\r\nreturn ((self):at_(2));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"third",0
,(
function(self)
return ((self):at_(3));
end
)
,"accessing","third\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t^self at: 3","(\r\nfunction(self)\r\nreturn ((self):at_(3));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"removeLast",0
,(
function(self)
return ((self):remove_((self):last()));
end
)
,"removing","removeLast\r\n\t\" Remove the last object in the receiver. \"\r\n\r\n\t^self remove: self last","(\r\nfunction(self)\r\nreturn ((self):remove_((self):last()));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"removeFirst",0
,(
function(self)
return ((self):remove_((self):first()));
end
)
,"removing","removeFirst\r\n\t\" Remove the first object in the receiver. \"\r\n\r\n\t^self remove: self first","(\r\nfunction(self)\r\nreturn ((self):remove_((self):first()));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"addLast:",0
,(
function(self,anObject)
return ((self):add_(anObject));
end
)
,"adding","addLast: anObject\r\n\t\" Add anObject to the receiver (at end). \"\r\n\r\n\t^self add: anObject","(\r\nfunction(self,anObject)\r\nreturn ((self):add_(anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"atAll:put:",0
,(
function(self,indices,anObject)
(indices):do_((function(index)
return ((self):at_put_(index,anObject))
end));
return (self);
end
)
,"accessing","atAll: indices put: anObject\r\n\t\" Return the receiver after replacing those elements, indexed by the indices, with anObject. \"\r\n\r\n\tindices do: [ :index | self at: index put: anObject ]","(\r\nfunction(self,indices,anObject)\r\n(indices):do_((function(index)\r\nreturn ((self):at_put_(index,anObject))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"atAllPut:",0
,(
function(self,anObject)
((1):to_((self):size())):do_((function(index)
return ((self):at_put_(index,anObject))
end));
return (self);
end
)
,"accessing","atAllPut: anObject\r\n\t\" Replace all elements of the receiver with anObject. \"\r\n\r\n\t(1 to: self size) do: [ :index | self at: index put: anObject ]","(\r\nfunction(self,anObject)\r\n((1):to_((self):size())):do_((function(index)\r\nreturn ((self):at_put_(index,anObject))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"withIndexDo:",0
,(
function(self,aBlock)
((1):to_((self):size())):do_((function(index)
return ((aBlock):value_value_((self):at_(index),index))
end));
return (self);
end
)
,"enumerating","withIndexDo: aBlock\r\n\t\" Evaluate aBlock with all the index positions in the receiver. \"\r\n\r\n\t(1 to: self size) do: [ :index |\r\n\t\taBlock value: (self at: index) value: index\r\n\t]","(\r\nfunction(self,aBlock)\r\n((1):to_((self):size())):do_((function(index)\r\nreturn ((aBlock):value_value_((self):at_(index),index))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"=","_eq"
,(
function(self,aCollection)
local index=nil
if (((self)==aCollection))==true then return (true); end;
if not (((((self)["$klass"])==(aCollection)["$klass"])))==true then return (false); end;
(function()
	local _s8_value=((self):size())
	index=_s8_value
	return _s8_value
end)();
if ((not smalltalk:isObject_equalTo_((index),(aCollection):size())))==true then return (false); end;
while not ((function()
return (((index) <= 0))
end))() do if not ((smalltalk:isObject_equalTo_(((self):at_(index)),(aCollection):at_(index))))==true then return (false); end;
(function()
	local _s8_value=((index):_minus(1))
	index=_s8_value
	return _s8_value
end)(); end;
return (true);
end
)
,"testing","= aCollection\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\t| index |\r\n\tself == aCollection ifTrue: [ ^true ].\r\n\tself class == aCollection class ifFalse: [ ^false ].\r\n\tindex := self size.\r\n\tindex ~= aCollection size ifTrue: [ ^false ].\r\n\t[ index <= 0 ] whileFalse: [\r\n\t\t(self at: index) = (aCollection at: index) ifFalse: [ ^false ].\r\n\t\tindex := index - 1\r\n\t].\r\n\t^true","(\r\nfunction(self,aCollection)\r\nlocal index=nil\r\nif (((self)==aCollection))==true then return (true); end;\r\nif not (((((self)[\"$klass\"])==(aCollection)[\"$klass\"])))==true then return (false); end;\r\n(function()\r\n\tlocal _s8_value=((self):size())\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((not smalltalk:isObject_equalTo_((index),(aCollection):size())))==true then return (false); end;\r\nwhile not ((function()\r\nreturn (((index) <= 0))\r\nend))() do if not ((smalltalk:isObject_equalTo_(((self):at_(index)),(aCollection):at_(index))))==true then return (false); end;\r\n(function()\r\n\tlocal _s8_value=((index):_minus(1))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"beginsWith:",0
,(
function(self,aCollection)
if ((((self):size()) < (aCollection):size()))==true then return (false); end;
if (smalltalk:isObject_equalTo_(((self):size()),(aCollection):size()))==true then return (smalltalk:isObject_equalTo_((aCollection),self)); end;
return (smalltalk:isObject_equalTo_((aCollection),(self):copyFrom_to_(1,(aCollection):size())));
end
)
,"testing","beginsWith: aCollection\r\n\t\" Return true if the receiver begins with aCollection. \"\r\n\r\n\tself size < aCollection size ifTrue: [ ^false ].\r\n\tself size = aCollection size ifTrue: [ ^aCollection = self ].\r\n\t^aCollection = (self copyFrom: 1 to: aCollection size)","(\r\nfunction(self,aCollection)\r\nif ((((self):size()) < (aCollection):size()))==true then return (false); end;\r\nif (smalltalk:isObject_equalTo_(((self):size()),(aCollection):size()))==true then return (smalltalk:isObject_equalTo_((aCollection),self)); end;\r\nreturn (smalltalk:isObject_equalTo_((aCollection),(self):copyFrom_to_(1,(aCollection):size())));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"endsWith:",0
,(
function(self,aCollection)
if ((((self):size()) < (aCollection):size()))==true then return (false); end;
if (smalltalk:isObject_equalTo_(((self):size()),(aCollection):size()))==true then return (smalltalk:isObject_equalTo_((aCollection),self)); end;
return (smalltalk:isObject_equalTo_((aCollection),(self):copyFrom_to_((((self):size()):_minus((aCollection):size())):_plus(1),(self):size())));
end
)
,"testing","endsWith: aCollection\r\n\t\" Return true if the receiver ends with aCollection. \"\r\n\r\n\tself size < aCollection size ifTrue: [ ^false ].\r\n\tself size = aCollection size ifTrue: [ ^aCollection = self ].\r\n\t^aCollection = (self copyFrom: self size - aCollection size + 1 to: self size)","(\r\nfunction(self,aCollection)\r\nif ((((self):size()) < (aCollection):size()))==true then return (false); end;\r\nif (smalltalk:isObject_equalTo_(((self):size()),(aCollection):size()))==true then return (smalltalk:isObject_equalTo_((aCollection),self)); end;\r\nreturn (smalltalk:isObject_equalTo_((aCollection),(self):copyFrom_to_((((self):size()):_minus((aCollection):size())):_plus(1),(self):size())));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"copyReplaceFrom:to:with:",0
,(
function(self,start,stop,aCollection)
return (smalltalk:object_comma_((smalltalk:object_comma_(((self):copyFrom_to_(1,(start):_minus(1))),aCollection)),(self):copyFrom_to_((stop):_plus(1),(self):size())));
end
)
,"copying","copyReplaceFrom: start to: stop with: aCollection\r\n\t\" Return a collection containing a copy of the receiver with the elements at index positions from start through stop replaced with the elements of aCollection. \"\r\n\r\n\t^(self copyFrom: 1 to: start - 1)\r\n\t\t, aCollection\r\n\t\t, (self copyFrom: stop + 1 to: self size)","(\r\nfunction(self,start,stop,aCollection)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_(((self):copyFrom_to_(1,(start):_minus(1))),aCollection)),(self):copyFrom_to_((stop):_plus(1),(self):size())));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"copyWithout:",0
,(
function(self,anObject)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local index=nil
(function()
	local _s8_value=((self):indexOf_ifAbsent_(anObject,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):copy())
end
)()
error(_s8Ret_,0)
end)())
end)))
	index=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_(((self):copyFrom_to_(1,(index):_minus(1))),((self):copyFrom_to_((index):_plus(1),(self):size())):copyWithout_(anObject)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"copying","copyWithout: anObject\r\n\t\" Return a copy of the receiver excluding anObject, if any. \"\r\n\r\n\t| index |\r\n\tindex := self indexOf: anObject ifAbsent: [ ^self copy ].\r\n\t^(self copyFrom: 1 to: index - 1)\r\n\t\t,((self copyFrom: index + 1 to: self size)\r\n\t\t\tcopyWithout: anObject)","(\r\nfunction(self,anObject)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):indexOf_ifAbsent_(anObject,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):copy())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_(((self):copyFrom_to_(1,(index):_minus(1))),((self):copyFrom_to_((index):_plus(1),(self):size())):copyWithout_(anObject)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"copyWithAll:",0
,(
function(self,aCollection)
return (smalltalk:object_comma_((self),aCollection));
end
)
,"copying","copyWithAll: aCollection\r\n\t\" Return a copy of the receiver with all contents of aCollection. \"\r\n\r\n\t^self , aCollection ","(\r\nfunction(self,aCollection)\r\nreturn (smalltalk:object_comma_((self),aCollection));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"findFirst:",0
,(
function(self,aBlock)
return ((self):findFirst_ifAbsent_(aBlock,(function()
return ((self):errorAbsentObject())
end)));
end
)
,"searching","findFirst: aBlock\r\n\t\" Return the index of the first element of the receiver that causes aBlock to evaluate to true.\r\n         If no such element is found, report an error.\r\n\t\"\r\n\r\n\t^self findFirst: aBlock ifAbsent: [ self errorAbsentObject ]","(\r\nfunction(self,aBlock)\r\nreturn ((self):findFirst_ifAbsent_(aBlock,(function()\r\nreturn ((self):errorAbsentObject())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"findFirst:ifAbsent:",0
,(
function(self,aBlock,absentBlock)
local index=nil
local size=nil
(function()
	local _s8_value=((self):size())
	size=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(1)
	index=_s8_value
	return _s8_value
end)();
while ((function()
return (((index) <= size))
end))() do if ((aBlock):value_((self):at_(index)))==true then return (index); end;
(function()
	local _s8_value=((index):_plus(1))
	index=_s8_value
	return _s8_value
end)(); end;
return ((absentBlock):value());
end
)
,"searching","findFirst: aBlock ifAbsent: absentBlock\r\n\t\" Return the index of the first element of the receiver that causes aBlock to evaluate to true.\r\n\tIf no such element is found, return the result of evaluating the argument block.\r\n\t\"\r\n\r\n\t| index size |\r\n\tsize := self size.\r\n\tindex := 1.\r\n\t[ index <= size ] whileTrue: [\r\n\t\t(aBlock value: (self at: index)) ifTrue: [ ^index ].\r\n\t\tindex := index + 1\r\n\t].\r\n\t^absentBlock value","(\r\nfunction(self,aBlock,absentBlock)\r\nlocal index=nil\r\nlocal size=nil\r\n(function()\r\n\tlocal _s8_value=((self):size())\r\n\tsize=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(1)\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (((index) <= size))\r\nend))() do if ((aBlock):value_((self):at_(index)))==true then return (index); end;\r\n(function()\r\n\tlocal _s8_value=((index):_plus(1))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((absentBlock):value());\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"findLast:",0
,(
function(self,aBlock)
return ((self):findLast_ifAbsent_(aBlock,(function()
return ((self):errorAbsentObject())
end)));
end
)
,"searching","findLast: aBlock\r\n\t\" Return the index of the last element of the receiver that causes aBlock to evaluate to true.\r\n\tIf no such element is found, report an error.\r\n\t\"\r\n\r\n\t^self findLast: aBlock ifAbsent: [ self errorAbsentObject ]","(\r\nfunction(self,aBlock)\r\nreturn ((self):findLast_ifAbsent_(aBlock,(function()\r\nreturn ((self):errorAbsentObject())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"findLast:ifAbsent:",0
,(
function(self,aBlock,absentBlock)
local index=nil
(function()
	local _s8_value=((self):size())
	index=_s8_value
	return _s8_value
end)();
while ((function()
return (((index) > 0))
end))() do if ((aBlock):value_((self):at_(index)))==true then return (index); end;
(function()
	local _s8_value=((index):_minus(1))
	index=_s8_value
	return _s8_value
end)(); end;
return ((absentBlock):value());
end
)
,"searching","findLast: aBlock ifAbsent: absentBlock\r\n\t\" Return the index of the last element of the receiver that causes aBlock to evaluate to true.\r\n\tIf no such element is found, return the result of evaluating the argument block.\r\n\t\"\r\n\r\n\t| index |\r\n\tindex := self size.\r\n\t[ index > 0 ] whileTrue: [\r\n\t\t(aBlock value: (self at: index)) ifTrue: [ ^index ].\r\n\t\tindex := index - 1\r\n\t].\r\n\t^absentBlock value","(\r\nfunction(self,aBlock,absentBlock)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):size())\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (((index) > 0))\r\nend))() do if ((aBlock):value_((self):at_(index)))==true then return (index); end;\r\n(function()\r\n\tlocal _s8_value=((index):_minus(1))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((absentBlock):value());\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"replaceFrom:to:with:",0
,(
function(self,start,stop,aCollection)
if not ((smalltalk:isObject_equalTo_((((stop):_minus(start)):_plus(1)),(aCollection):size())))==true then return ((self):error_("Replacement has wrong size")); end;
(self):replaceFrom_to_with_startingAt_(start,stop,aCollection,1);
return (self);
end
)
,"replace","replaceFrom: start to: stop with: aCollection\r\n\t\" Return the receiver.\r\n\tReplace the elements of the receiver at index positions start through stop, with the elements of aCollection. \"\r\n\r\n\tstop - start + 1 = aCollection size ifFalse: [\r\n\t\t^self error: 'Replacement has wrong size'\r\n\t].\r\n\tself\r\n\t\treplaceFrom: start\r\n\t\tto: stop\r\n\t\twith: aCollection\r\n\t\tstartingAt: 1","(\r\nfunction(self,start,stop,aCollection)\r\nif not ((smalltalk:isObject_equalTo_((((stop):_minus(start)):_plus(1)),(aCollection):size())))==true then return ((self):error_(\"Replacement has wrong size\")); end;\r\n(self):replaceFrom_to_with_startingAt_(start,stop,aCollection,1);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"replaceFrom:to:with:startingAt:",0
,(
function(self,start,stop,aCollection,repStart)
local index1=nil
local index2=nil
if (smalltalk:boolean_and_((((self)==aCollection)),(function()
return (((repStart) < start))
end)))==true then (function()
	local _s8_value=(((repStart):_plus(stop)):_minus(start))
	index2=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(stop)
	index1=_s8_value
	return _s8_value
end)();
while ((function()
return (((start) <= index1))
end))() do (self):at_put_(index1,(aCollection):at_(index2));
(function()
	local _s8_value=((index1):_minus(1))
	index1=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((index2):_minus(1))
	index2=_s8_value
	return _s8_value
end)(); end;
return (self); end;
(function()
	local _s8_value=(repStart)
	index2=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(start)
	index1=_s8_value
	return _s8_value
end)();
while ((function()
return (((index1) <= stop))
end))() do (self):at_put_(index1,(aCollection):at_(index2));
(function()
	local _s8_value=((index1):_plus(1))
	index1=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((index2):_plus(1))
	index2=_s8_value
	return _s8_value
end)(); end;
return (self);
end
)
,"replace","replaceFrom: start\r\n    to: stop\r\n    with: aCollection\r\n    startingAt: repStart\r\n\t\" Return the receiver.\r\n\tReplace the elements of the receiver at index positions start through stop with consecutive\r\n         elements of aCollection beginning at index position repStart.\r\n\t\"\r\n\r\n\t| index1 index2 |\r\n\t(self == aCollection and: [ repStart < start ]) ifTrue: [ \"do backward move for same object\"\r\n\t\tindex2 := repStart + stop - start.\r\n\t\tindex1 := stop.\r\n\t\t[ start <= index1 ] whileTrue: [\r\n\t\t\tself at: index1 put: (aCollection at: index2).\r\n\t\t\tindex1 := index1 - 1.\r\n\t\t\tindex2 := index2 - 1\r\n\t\t].\r\n\t\t^self\r\n\t].\r\n\tindex2 := repStart.\r\n\tindex1 := start.\r\n\t[ index1 <= stop ] whileTrue: [\r\n\t\tself at: index1 put: (aCollection at: index2).\r\n\t\tindex1 := index1 + 1.\r\n\t\tindex2 := index2 + 1\r\n\t]","(\r\nfunction(self,start,stop,aCollection,repStart)\r\nlocal index1=nil\r\nlocal index2=nil\r\nif (smalltalk:boolean_and_((((self)==aCollection)),(function()\r\nreturn (((repStart) < start))\r\nend)))==true then (function()\r\n\tlocal _s8_value=(((repStart):_plus(stop)):_minus(start))\r\n\tindex2=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(stop)\r\n\tindex1=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (((start) <= index1))\r\nend))() do (self):at_put_(index1,(aCollection):at_(index2));\r\n(function()\r\n\tlocal _s8_value=((index1):_minus(1))\r\n\tindex1=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((index2):_minus(1))\r\n\tindex2=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self); end;\r\n(function()\r\n\tlocal _s8_value=(repStart)\r\n\tindex2=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(start)\r\n\tindex1=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (((index1) <= stop))\r\nend))() do (self):at_put_(index1,(aCollection):at_(index2));\r\n(function()\r\n\tlocal _s8_value=((index1):_plus(1))\r\n\tindex1=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((index2):_plus(1))\r\n\tindex2=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"replaceFrom:to:with:startingWith:",0
,(
function(self,start,stop,replacement,replacementStart)
return ((self):replaceFrom_to_with_startingAt_(start,stop,replacement,replacementStart));
end
)
,"replace","replaceFrom: start\r\n    to: stop\r\n    with: replacement\r\n    startingWith: replacementStart\r\n\t\" Replace the elements of the receiver. \"\r\n\r\n\t^self\r\n\t\treplaceFrom: start\r\n\t\tto: stop\r\n\t\twith: replacement\r\n\t\tstartingAt: replacementStart","(\r\nfunction(self,start,stop,replacement,replacementStart)\r\nreturn ((self):replaceFrom_to_with_startingAt_(start,stop,replacement,replacementStart));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"replaceFrom:to:withObject:",0
,(
function(self,start,stop,anObject)
local index=nil
(function()
	local _s8_value=(start)
	index=_s8_value
	return _s8_value
end)();
while ((function()
return (((index) <= stop))
end))() do (self):at_put_(index,anObject);
(function()
	local _s8_value=((index):_plus(1))
	index=_s8_value
	return _s8_value
end)(); end;
return (anObject);
end
)
,"replace","replaceFrom: start to: stop withObject: anObject\r\n\t\"Replace each of the elements of the receiver at index positions start through stop with anObject. \"\r\n\r\n\t| index |\r\n\tindex := start.\r\n\t[ index <= stop ] whileTrue: [\r\n\t\tself at: index put: anObject.\r\n\t\tindex := index + 1\r\n\t].\r\n\t^anObject","(\r\nfunction(self,start,stop,anObject)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=(start)\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (((index) <= stop))\r\nend))() do (self):at_put_(index,anObject);\r\n(function()\r\n\tlocal _s8_value=((index):_plus(1))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (anObject);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"with:do:",0
,(
function(self,aCollection,aBlock)
local first=nil
local second=nil
(function()
	local _s8_value=((self):stream())
	first=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aCollection):stream())
	second=_s8_value
	return _s8_value
end)();
while not ((function()
return (smalltalk:boolean_or_(((first):atEnd()),(function()
return ((second):atEnd())
end)))
end))() do (aBlock):value_value_((first):next(),(second):next()); end;
return (self);
end
)
,"iterating","with: aCollection do: aBlock\r\n\t\" For each pair of elements evaluate aBlock with those elements as the arguments. \"\r\n\r\n\t| first second |\r\n\tfirst\t:= self stream.\r\n\tsecond\t:= aCollection stream.\r\n\t[ first atEnd or: [ second atEnd ] ] whileFalse: [\r\n\t\taBlock value: first next value: second next\r\n\t].","(\r\nfunction(self,aCollection,aBlock)\r\nlocal first=nil\r\nlocal second=nil\r\n(function()\r\n\tlocal _s8_value=((self):stream())\r\n\tfirst=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aCollection):stream())\r\n\tsecond=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn (smalltalk:boolean_or_(((first):atEnd()),(function()\r\nreturn ((second):atEnd())\r\nend)))\r\nend))() do (aBlock):value_value_((first):next(),(second):next()); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"sort",0
,(
function(self)
(self):sort_(nil);
return (self);
end
)
,"sorting","sort\r\n\t\" Sort (inplace) the receiver's contents with default criteria. \"\r\n\r\n\tself sort: nil","(\r\nfunction(self)\r\n(self):sort_(nil);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"sort:",0
,(
function(self,aBlock)
(self):implementedBySubclass_("sort:");
return (self);
end
)
,"sorting","sort: aBlock\r\n\t\" Sort (inplace) the receiver's contents with aBlock. \"\r\n\r\n\tself implementedBySubclass: #sort:","(\r\nfunction(self,aBlock)\r\n(self):implementedBySubclass_(\"sort:\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"from:to:by:",0
,(
function(self,start,__end,increment)
return ((start):to_by_value_(__end,increment,(function(index,block)
return ((block):value_((self):at_(index)))
end)));
end
)
,"iterating","from: start to: end by: increment\r\n\t\" Return an iterable on the receiver's contents from start to end. \"\r\n\r\n\t^start to: end by: increment value: [:index :block|\r\n\t\tblock value: (self at: index)\r\n\t]","(\r\nfunction(self,start,__end,increment)\r\nreturn ((start):to_by_value_(__end,increment,(function(index,block)\r\nreturn ((block):value_((self):at_(index)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"from:to:",0
,(
function(self,start,__end)
return ((self):from_to_by_(start,__end,smalltalk:if_true_false_((((start) <= __end)),(function()
return (1)
end),(function()
return (-1)
end))));
end
)
,"iterating","from: start to: end\r\n\t\" Return an iterable on the receiver's contents from start to end. \"\r\n\r\n\t^self\tfrom: start to: end\r\n\t\tby: (start <= end ifTrue: [1] ifFalse: [-1]) ","(\r\nfunction(self,start,__end)\r\nreturn ((self):from_to_by_(start,__end,smalltalk:if_true_false_((((start) <= __end)),(function()\r\nreturn (1)\r\nend),(function()\r\nreturn (-1)\r\nend))));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceableCollection,"asActionSequence",0
,(
function(self)
return ((smalltalk.ActionSequence):withAll_(self));
end
)
,"converting","asActionSequence\r\n\t\" Return an ActionSequence from the receiver. \"\r\n\r\n\t^ActionSequence withAll: self","(\r\nfunction(self)\r\nreturn ((smalltalk.ActionSequence):withAll_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"fromString:",0
,(
function(self,aString)
if true then tostring(aString) end;
return (self);
end
)
,"instantiation","fromString: aString\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'instatiation'}","(\r\nfunction(self,aString)\r\nif true then tostring(aString) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"new",0
,(
function(self)
return ("");
end
)
,"instantiation","new\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^{'' doc'instantiation'}","(\r\nfunction(self)\r\nreturn (\"\");\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"cr",0
,(
function(self)
return ("\r");
end
)
,"constants","cr\r\n\t\" Return the singular instance. \"\r\n\r\n\t^{'' doc'native constant'}","(\r\nfunction(self)\r\nreturn (\"\\r\");\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"lf",0
,(
function(self)
return ("\n");
end
)
,"constants","lf\r\n\t\" Return the singular instance. \"\r\n\r\n\t^{'' doc'native constant'}","(\r\nfunction(self)\r\nreturn (\"\\n\");\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"crlf",0
,(
function(self)
return ("\r\n");
end
)
,"constants","crlf\r\n\t\" Return the singular instance. \"\r\n\r\n\t^{'' doc'native constant'}","(\r\nfunction(self)\r\nreturn (\"\\r\\n\");\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"space",0
,(
function(self)
return (" ");
end
)
,"constants","space\r\n\t\" Return the singular instance. \"\r\n\r\n\t^{'' doc'native constant'}","(\r\nfunction(self)\r\nreturn (\" \");\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"tab",0
,(
function(self)
return ("\t");
end
)
,"constants","tab\r\n\t\" Return the singular instance. \"\r\n\r\n\t^{'' doc'native constant'}","(\r\nfunction(self)\r\nreturn (\"\\t\");\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"zero",0
,(
function(self)
return (string.char(0));
end
)
,"constants","zero\r\n\t\" Return the singular instance. \"\r\n\r\n\t^{'' doc'native constant'}","(\r\nfunction(self)\r\nreturn (string.char(0));\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"with:",0
,(
function(self,aCharacter)
return (aCharacter);
end
)
,"instantiation","with: aCharacter\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^aCharacter","(\r\nfunction(self,aCharacter)\r\nreturn (aCharacter);\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"with:with:",0
,(
function(self,aCharacter,bCharacter)
return (smalltalk:object_comma_((aCharacter),bCharacter));
end
)
,"instantiation","with: aCharacter with: bCharacter\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^aCharacter , bCharacter","(\r\nfunction(self,aCharacter,bCharacter)\r\nreturn (smalltalk:object_comma_((aCharacter),bCharacter));\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"with:with:with:",0
,(
function(self,aCharacter,bCharacter,cCharacter)
return (smalltalk:object_comma_((smalltalk:object_comma_((aCharacter),bCharacter)),cCharacter));
end
)
,"instantiation","with: aCharacter with: bCharacter with: cCharacter\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^aCharacter , bCharacter , cCharacter","(\r\nfunction(self,aCharacter,bCharacter,cCharacter)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((aCharacter),bCharacter)),cCharacter));\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"with:with:with:with:",0
,(
function(self,aCharacter,bCharacter,cCharacter,dCharacter)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((aCharacter),bCharacter)),cCharacter)),dCharacter));
end
)
,"instantiation","with: aCharacter with: bCharacter\r\n\twith: cCharacter with: dCharacter\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^aCharacter , bCharacter , cCharacter , dCharacter","(\r\nfunction(self,aCharacter,bCharacter,cCharacter,dCharacter)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((aCharacter),bCharacter)),cCharacter)),dCharacter));\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"fromCharCode:",0
,(
function(self,anArrayOrNumber)

	if (type(anArrayOrNumber)=="number") then
		return string.char(anArrayOrNumber)
	end
	if true then
		local fup = table.unpack or unpack
		return (string.char(fup(anArrayOrNumber)))
	end;
return (self);
end
)
,"instantiation","fromCharCode: anArrayOrNumber\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native conversion'}","(\r\nfunction(self,anArrayOrNumber)\r\n\r\n\tif (type(anArrayOrNumber)==\"number\") then\r\n\t\treturn string.char(anArrayOrNumber)\r\n\tend\r\n\tif true then\r\n\t\tlocal fup = table.unpack or unpack\r\n\t\treturn (string.char(fup(anArrayOrNumber)))\r\n\tend;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"doItSelector",0
,(
function(self)
return ("s8DoIt");
end
)
,"constants","doItSelector\r\n\t\" Return the selector to use for doIt evaluations.\r\n\tWarning: this selector will not be dump on image nor change log expressions.\r\n\t\"\r\n\r\n\t^#s8DoIt","(\r\nfunction(self)\r\nreturn (\"s8DoIt\");\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"nativeFileExtension",0
,(
function(self)
return (smalltalk:toString_(((self):nativeLanguage())));
end
)
,"fileNames","nativeFileExtension\r\n\t\" Return the file extension to use for files with native code. \"\r\n\r\n\t^self nativeLanguage toString","(\r\nfunction(self)\r\nreturn (smalltalk:toString_(((self):nativeLanguage())));\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"sourceFileExtension",0
,(
function(self)
return ("st");
end
)
,"fileNames","sourceFileExtension\r\n\t\" Return the file extension to use for source files. \"\r\n\r\n\t^#st ","(\r\nfunction(self)\r\nreturn (\"st\");\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"nativeLibraryExtension",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(((self):sourceFileExtension()),".")),(self):nativeFileExtension()));
end
)
,"fileNames","nativeLibraryExtension\r\n\t\" Return the file extension to use for native library files. \"\r\n\r\n\t^self sourceFileExtension ,$. ,self nativeFileExtension ","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_(((self):sourceFileExtension()),\".\")),(self):nativeFileExtension()));\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"binarySelectorChars",0
,(
function(self)
return ("|&+/=><,@~!*-%\\?\\\\");
end
)
,"constants","binarySelectorChars\r\n\t\" Private - Return the characters that can be included in binary selectors. \"\r\n\r\n\t^'|&+/=><,@~!*-%\\?\\\\' ","(\r\nfunction(self)\r\nreturn (\"|&+/=><,@~!*-%\\\\?\\\\\\\\\");\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"isBinarySelector:",0
,(
function(self,aString)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local chars=nil
(function()
	local _s8_value=((self):binarySelectorChars())
	chars=_s8_value
	return _s8_value
end)();
(aString):do_((function(c)
return (smalltalk:if_true_false_(((chars):includes_(c)),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"private","isBinarySelector: aString\r\n\t\" Private - Return true if aString is a binary selector. \"\r\n\r\n\t| chars |\r\n\tchars := self binarySelectorChars.\r\n\taString do: [:c| (chars includes: c) ifFalse: [ ^false ] ].\r\n\t^true ","(\r\nfunction(self,aString)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal chars=nil\r\n(function()\r\n\tlocal _s8_value=((self):binarySelectorChars())\r\n\tchars=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aString):do_((function(c)\r\nreturn (smalltalk:if_true_false_(((chars):includes_(c)),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"isKeywordSelector:",0
,(
function(self,aString)
(function() self:invalidMessage_("isKeywordSelector:") end)();
return (smalltalk:isNil_((((smalltalk.RegularExpression):fromString_("[^a-zA-Z0-9_:]")):exec_(aString))));
end
)
,"private","isKeywordSelector: aString\r\n\t\" Private - Return true if aString is a keyword selector. \"\r\n\r\n\t{'' js'self' doc'native testing'}.\r\n\t^((RegularExpression fromString: '[^a-zA-Z0-9_:]') exec: aString) isNil ","(\r\nfunction(self,aString)\r\n(function() self:invalidMessage_(\"isKeywordSelector:\") end)();\r\nreturn (smalltalk:isNil_((((smalltalk.RegularExpression):fromString_(\"[^a-zA-Z0-9_:]\")):exec_(aString))));\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"isMessageSelector:",0
,(
function(self,aString)
return (smalltalk:boolean_or_(((self):isKeywordSelector_(aString)),(function()
return ((self):isBinarySelector_(aString))
end)));
end
)
,"private","isMessageSelector: aString\r\n\t\" Private - Return true if aString is a message selector. \"\r\n\r\n\t^(self isKeywordSelector: aString)\r\n\tor: [ self isBinarySelector: aString ] ","(\r\nfunction(self,aString)\r\nreturn (smalltalk:boolean_or_(((self):isKeywordSelector_(aString)),(function()\r\nreturn ((self):isBinarySelector_(aString))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"reservedArray",0
,(
function(self)
return (("abstract as boolean break byte case catch char class\r\n\tcontinue const debugger default delete do double else\r\n\tenum export extends false final finally float for function\r\n\tgoto if implements import in instanceof int interface is\r\n\tlong namespace native new null package private\r\n\tprotected public return short static super switch\r\n\tsynchronized this throw throws transient true try typeof\r\n\tuse var void volatile while with"):asArrayOfSubstrings());
end
)
,"js","reservedArray\r\n\t\" Private - Return the reserved names of native language. \"\r\n\r\n\t^'abstract as boolean break byte case catch char class\r\n\tcontinue const debugger default delete do double else\r\n\tenum export extends false final finally float for function\r\n\tgoto if implements import in instanceof int interface is\r\n\tlong namespace native new null package private\r\n\tprotected public return short static super switch\r\n\tsynchronized this throw throws transient true try typeof\r\n\tuse var void volatile while with' asArrayOfSubstrings","(\r\nfunction(self)\r\nreturn ((\"abstract as boolean break byte case catch char class\\r\\n\\tcontinue const debugger default delete do double else\\r\\n\\tenum export extends false final finally float for function\\r\\n\\tgoto if implements import in instanceof int interface is\\r\\n\\tlong namespace native new null package private\\r\\n\\tprotected public return short static super switch\\r\\n\\tsynchronized this throw throws transient true try typeof\\r\\n\\tuse var void volatile while with\"):asArrayOfSubstrings());\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"reservedWords",0
,(
function(self)
return ((self):basicAt_ifAbsentPut_("$reservedSet",(function()
return ((smalltalk.HashedSet):withAll_((self):reservedArray()))
end)));
end
)
,"js","reservedWords\r\n\t\" Private - Return the reserved names of native language. \"\r\n\r\n\t^self basicAt: '$reservedSet' ifAbsentPut: [\r\n\t\tHashedSet withAll: self reservedArray\r\n\t]","(\r\nfunction(self)\r\nreturn ((self):basicAt_ifAbsentPut_(\"$reservedSet\",(function()\r\nreturn ((smalltalk.HashedSet):withAll_((self):reservedArray()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"streamClass",0
,(
function(self)
return (smalltalk.StringStream);
end
)
,"streams","streamClass\r\n\t\" Return the streamming support for the receiver's instances. \"\r\n\r\n\t^StringStream","(\r\nfunction(self)\r\nreturn (smalltalk.StringStream);\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"@","_at"
,(
function(self,aHandle)
return (smalltalk:if_true_false_((smalltalk:notNil_((aHandle))),(function()
return ((self):toString_(aHandle))
end),nil));
end
)
,"Natives-converting","@ aHandle\r\n\t\" Return an instance of the receiver from aHandle. \"\r\n\r\n\t^aHandle notNil ifTrue: [ self toString: aHandle ]","(\r\nfunction(self,aHandle)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((aHandle))),(function()\r\nreturn ((self):toString_(aHandle))\r\nend),nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"reservedLuaWords",0
,(
function(self)
return (smalltalk:newArray({"and", "break", "do", "else", "elseif", "end", "false", "for", "function", "if", "in", "local", "nil", "not", "or", "repeat", "return", "then", "true", "until", "while"}));
end
)
,"Lua-lua","reservedLuaWords\r\n\t\" Private - Return the reserved names of Lua language. \"\r\n\r\n\t^#(\r\n\tand\tbreak\tdo\telse\telseif\r\n\tend\t#false\tfor\tfunction\tif\r\n\tin\tlocal\t#nil\tnot\tor\r\n\trepeat\treturn\tthen\t#true\tuntil\r\n\twhile\r\n\t)","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"and\", \"break\", \"do\", \"else\", \"elseif\", \"end\", \"false\", \"for\", \"function\", \"if\", \"in\", \"local\", \"nil\", \"not\", \"or\", \"repeat\", \"return\", \"then\", \"true\", \"until\", \"while\"}));\r\nend\r\n)")
smalltalk:bind(smalltalk.String["$klass"],"forbiddenLuaSelectors",0
,(
function(self)
return (smalltalk:newArray({}));
end
)
,"Lua-lua","forbiddenLuaSelectors\r\n\t\" Private - Return the platform forbidden selectors. \"\r\n\r\n\t^#( \"class new\" )","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({}));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"=","_eq"
,(
function(self,anObject)
if true then return self==anObject end;
return (self);
end
)
,"comparing","= anObject\r\n    \" Return true if the receiver is equal to argument. \"\r\n\r\n\t{'' doc'native testing'}","(\r\nfunction(self,anObject)\r\nif true then return self==anObject end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"size",0
,(
function(self)
return (#self);
end
)
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^{'' doc'native string size'}","(\r\nfunction(self)\r\nreturn (#self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"at:",0
,(
function(self,anIndex)
return (self:sub(anIndex,anIndex));
end
)
,"accessing","at: anIndex\r\n\t\" Return the receiver at anIndex. \"\r\n\r\n\t^{'' doc'native indexing'}","(\r\nfunction(self,anIndex)\r\nreturn (self:sub(anIndex,anIndex));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"at:put:",0
,(
function(self,anIndex,anObject)
return ((self):errorReadOnly_("at:put:"));
end
)
,"accessing","at: anIndex put: anObject\r\n\t\" Set the receiver at anIndex. \"\r\n\r\n\t^self errorReadOnly: #at:put:","(\r\nfunction(self,anIndex,anObject)\r\nreturn ((self):errorReadOnly_(\"at:put:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"at:ifAbsent:",0
,(
function(self,anIndex,aBlock)
return (smalltalk:if_nil_notNil_(((self):at_(anIndex)),aBlock,nil));
end
)
,"accessing","at: anIndex ifAbsent: aBlock\r\n\t\" Return the receiver at anIndex position or the result of evaluating aBlock. \"\r\n\r\n\t^(self at: anIndex) ifNil: aBlock","(\r\nfunction(self,anIndex,aBlock)\r\nreturn (smalltalk:if_nil_notNil_(((self):at_(anIndex)),aBlock,nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"do:",0
,(
function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
for c in self:gmatch(".") do fn(c) end;
return (self);
end
)
,"enumerating","do: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'\t1 to: self size do: [:i|\r\n\t\taBlock value: (self at: i)\r\n\t]' doc'native iteration'}","(\r\nfunction(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nfor c in self:gmatch(\".\") do fn(c) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"detect:ifNone:",0
,(
function(self,aBlock,anotherBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();

	for c in self:gmatch(".") do
		if (fn(c)) then return c end
	end
	if true then return anotherBlock:value() end;
return (self);
end
)
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'\tself do: [:each|\r\n\t\t(aBlock value: each) ifTrue: [ ^each ]\r\n\t].\r\n\t^anotherBlock value' doc'native detection'}","(\r\nfunction(self,aBlock,anotherBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (fn(c)) then return c end\r\n\tend\r\n\tif true then return anotherBlock:value() end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"includes:",0
,(
function(self,anObject)
local ignored;
return ((((self):indexOf_(anObject)) > 0));
end
)
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t{'self'}.\r\n\t^(self indexOf: anObject) > 0","(\r\nfunction(self,anObject)\r\nlocal ignored;\r\nreturn ((((self):indexOf_(anObject)) > 0));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"withIndexDo:",0
,(
function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
for i=1,#self do fn(self:sub(i,i),i) end;
return (self);
end
)
,"enumerating","withIndexDo: aBlock\r\n\t\" Evaluate aBlock with all the index positions in the receiver. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'\t1 to: self size do: [:i|\r\n\t\taBlock value: (self at: i) value: i\r\n\t]' doc'native iteration'}","(\r\nfunction(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nfor i=1,#self do fn(self:sub(i,i),i) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"copyWithout:",0
,(
function(self,anObject)
return ((self):replace_with_(anObject,""));
end
)
,"copying","copyWithout: anObject\r\n\t\" Return a copy of the receiver excluding anObject, if any. \"\r\n\r\n\t^self replace: anObject with: ''","(\r\nfunction(self,anObject)\r\nreturn ((self):replace_with_(anObject,\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asSymbol",0
,(
function(self)
return (self);
end
)
,"conversion","asSymbol\r\n\t\" Return a symbol with the same characters as the receiver. \"\r\n\r\n\t^self \"we do not discriminate singular strings\"","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"argumentCount",0
,(
function(self)
if ((self):isEmpty())==true then return (0); end;
if ((((self)["$klass"]):binarySelectorChars()):includes_((self):first()))==true then return (1); end;
return ((self):occurrencesOf_(":"));
end
)
,"evaluating","argumentCount\r\n\t\" Return the number of arguments of the receiver. \"\r\n\r\n\tself isEmpty ifTrue: [ ^0 ].\r\n\t(self class binarySelectorChars includes: self first) ifTrue: [ ^1 ].\r\n\t^self occurrencesOf: $:","(\r\nfunction(self)\r\nif ((self):isEmpty())==true then return (0); end;\r\nif ((((self)[\"$klass\"]):binarySelectorChars()):includes_((self):first()))==true then return (1); end;\r\nreturn ((self):occurrencesOf_(\":\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"isLiteral",0
,(
function(self)

	if #self==0 then return false end
	if smalltalk.String:isBinarySelector_(self) then return true end
	if true then return string.find(self,"[^a-zA-Z0-9_:]+")==nil end;
return (smalltalk:boolean_and_(((self):notEmpty()),(function()
return (((self)["$klass"]):isMessageSelector_(self))
end)));
end
)
,"testing","isLiteral\r\n\t\" Return true if the receiver can be output using literal notation. \"\r\n\r\n\t{'' js'self' doc'native testing'}.\r\n\t^self notEmpty and: [ self class isMessageSelector: self ]","(\r\nfunction(self)\r\n\r\n\tif #self==0 then return false end\r\n\tif smalltalk.String:isBinarySelector_(self) then return true end\r\n\tif true then return string.find(self,\"[^a-zA-Z0-9_:]+\")==nil end;\r\nreturn (smalltalk:boolean_and_(((self):notEmpty()),(function()\r\nreturn (((self)[\"$klass\"]):isMessageSelector_(self))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asLiteral",0
,(
function(self)
return (smalltalk:if_true_false_(((self):isLiteral()),(function()
return (smalltalk:object_comma_(("#"),self))
end),(function()
return (smalltalk:printString_((self)))
end)));
end
)
,"converting","asLiteral\r\n\t\" Return the receiver in literal notation. \"\r\n\r\n\t^self isLiteral ifTrue: [ $# ,self ] ifFalse: [ self printString ]","(\r\nfunction(self)\r\nreturn (smalltalk:if_true_false_(((self):isLiteral()),(function()\r\nreturn (smalltalk:object_comma_((\"#\"),self))\r\nend),(function()\r\nreturn (smalltalk:printString_((self)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"occurrencesOf:",0
,(
function(self,aString)
local result=nil
local index=nil

	local j
	local k,count = 0,0
	repeat	j, k = self:find(aString, k + 1, true)
		if (j~=nil) then count=count+1 end
	until j == nil
	if true then return count end;
if not (((aString):isString()))==true then (function()
	local _s8_value=((self):match(aString))
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((result)))==true then return (0); end;
return (result["length"]); end;
if (smalltalk:isObject_equalTo_(((aString):size()),1))==true then (function()
	local _s8_value=((self):match((smalltalk.RegularExpression):fromString_flag_(smalltalk:object_comma_((smalltalk:object_comma_(("["),aString)),"]"),"g")))
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((result)))==true then return (0); end;
return (result["length"]); end;
(function()
	local _s8_value=(0)
	result=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(0)
	index=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((self):indexOf_startingAt_(aString,(index):_plus(1)))
	index=_s8_value
	return _s8_value
end)();return (((index) > 1))
end))() do (function()
	local _s8_value=((result):_plus(1))
	result=_s8_value
	return _s8_value
end)(); end;
return (result);
end
)
,"testing","occurrencesOf: aString\r\n\t\" Return the times aString can be found in the receiver. \"\r\n\r\n\t| result index |\r\n\t{'' doc'native counting'}.\r\n\taString isString ifFalse: [\r\n\t\tresult := self #match: aString.\r\n\t\tresult isNil ifTrue: [ ^0 ].\r\n\t\t^result#length\r\n\t].\r\n\taString size = 1 ifTrue: [\r\n\t\tresult := self #match: (RegularExpression\r\n\t\t\t\tfromString: '[',aString,']'\r\n\t\t\t\tflag: 'g').\r\n\t\tresult isNil ifTrue: [ ^0 ].\r\n\t\t^result#length\r\n\t].\r\n\tresult := 0. index := 0.\r\n\t[\tindex := self indexOf: aString startingAt: index + 1.\r\n\t\tindex > 1 ] whileTrue: [ result := result + 1 ].\r\n\t^result","(\r\nfunction(self,aString)\r\nlocal result=nil\r\nlocal index=nil\r\n\r\n\tlocal j\r\n\tlocal k,count = 0,0\r\n\trepeat\tj, k = self:find(aString, k + 1, true)\r\n\t\tif (j~=nil) then count=count+1 end\r\n\tuntil j == nil\r\n\tif true then return count end;\r\nif not (((aString):isString()))==true then (function()\r\n\tlocal _s8_value=((self):match(aString))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((result)))==true then return (0); end;\r\nreturn (result[\"length\"]); end;\r\nif (smalltalk:isObject_equalTo_(((aString):size()),1))==true then (function()\r\n\tlocal _s8_value=((self):match((smalltalk.RegularExpression):fromString_flag_(smalltalk:object_comma_((smalltalk:object_comma_((\"[\"),aString)),\"]\"),\"g\")))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((result)))==true then return (0); end;\r\nreturn (result[\"length\"]); end;\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((self):indexOf_startingAt_(aString,(index):_plus(1)))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();return (((index) > 1))\r\nend))() do (function()\r\n\tlocal _s8_value=((result):_plus(1))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"startsWith:",0
,(
function(self,aString)
if true then return (self:sub(1, #aString) == aString) end;
return ((self):beginsWith_(aString));
end
)
,"testing","startsWith: aString\r\n\t\" Return true if the receiver begins with the characters of aString. \"\r\n\r\n\t{'' doc'native testing'}.\r\n\t^self beginsWith: aString","(\r\nfunction(self,aString)\r\nif true then return (self:sub(1, #aString) == aString) end;\r\nreturn ((self):beginsWith_(aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"escaped",0
,(
function(self)
self:notImplementedYet_("escaped");
return (self);
end
)
,"converting","escaped\r\n\t\" Return the receiver with escape codes. \"\r\n\r\n\t{'' doc'native conversion'}","(\r\nfunction(self)\r\nself:notImplementedYet_(\"escaped\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"unescaped",0
,(
function(self)

	local x16 = function(x) return string.char(tonumber(x, 16)) end
	if true then return self:gsub("%%(%x%x)", x16) end;
return (self);
end
)
,"converting","unescaped\r\n\t\" Return the receiver from encoded URI escape codes. \"\r\n\r\n\t{'' doc'native conversion'}","(\r\nfunction(self)\r\n\r\n\tlocal x16 = function(x) return string.char(tonumber(x, 16)) end\r\n\tif true then return self:gsub(\"%%(%x%x)\", x16) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"escapedCode",0
,(
function(self)
local escaped=nil
(function()
	local _s8_value=((self):escaped())
	escaped=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((escaped),self))==true then return (smalltalk:object_comma_((smalltalk:object_comma_(("\""),escaped)),"\"")); end;
return (smalltalk:object_comma_((smalltalk:object_comma_(("unescape(\""),escaped)),"\")"));
end
)
,"converting","escapedCode\r\n\t\" Return the code to reproduce receiver from code. \"\r\n\r\n\t| escaped |\r\n\tescaped := self escaped.\r\n\tescaped = self ifTrue: [ ^$\" ,escaped ,$\" ].\r\n\t^'unescape(\"' ,escaped ,'\")'","(\r\nfunction(self)\r\nlocal escaped=nil\r\n(function()\r\n\tlocal _s8_value=((self):escaped())\r\n\tescaped=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((escaped),self))==true then return (smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),escaped)),\"\\\"\")); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"unescape(\\\"\"),escaped)),\"\\\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asEncodedURI",0
,(
function(self)
self:notImplementedYet_("asEncodedURI");
return (self);
end
)
,"converting","asEncodedURI\r\n\t\" Return the receiver encoded as an URI component.\r\n\tEncodes special characters and it encodes the following characters: , / ? : @ & = + $ #\r\n\t\"\r\n\r\n\t{'' doc'native conversion'}","(\r\nfunction(self)\r\nself:notImplementedYet_(\"asEncodedURI\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asDecodedURI",0
,(
function(self)
self:notImplementedYet_("asDecodedURI");
return (self);
end
)
,"converting","asDecodedURI\r\n\t\" Return the receiver decoded as an URI component. \"\r\n\r\n\t{'' doc'native conversion'}","(\r\nfunction(self)\r\nself:notImplementedYet_(\"asDecodedURI\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"add:",0
,(
function(self,anObject)
return ((self):errorReadOnly_("add:"));
end
)
,"adding","add: anObject\r\n\t\" Add anObject to the receiver. \"\r\n\r\n\t^self errorReadOnly: #add:","(\r\nfunction(self,anObject)\r\nreturn ((self):errorReadOnly_(\"add:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"-->","_minus_minus_gt"
,(
function(self,anObject)
return ((smalltalk.Association):key_value_((self):asArrayOfSubstringsSeparatedBy_("."),anObject));
end
)
,"converting","--> anObject\r\n\t\" Return a far-association of the receiver to anObject. \"\r\n\r\n\t^Association key: (self asArrayOfSubstringsSeparatedBy: $.) value: anObject","(\r\nfunction(self,anObject)\r\nreturn ((smalltalk.Association):key_value_((self):asArrayOfSubstringsSeparatedBy_(\".\"),anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,",","_comma"
,(
function(self,aCollection)
if true then return self..(smalltalk:asString_(aCollection)) end;
return (self);
end
)
,"copying",", aCollection\r\n\t\" Return a copy of the receiver with all contents of aCollection. \"\r\n\r\n\t{'' doc'native composition'}","(\r\nfunction(self,aCollection)\r\nif true then return self..(smalltalk:asString_(aCollection)) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"copyWith:",0
,(
function(self,anObject)
return (self..(smalltalk:asString_(anObject)));
end
)
,"copying","copyWith: anObject\r\n\t\" Return a copy of the receiver with anObject. \"\r\n\r\n\t^{'' doc'native composition'}","(\r\nfunction(self,anObject)\r\nreturn (self..(smalltalk:asString_(anObject)));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"copyFrom:to:",0
,(
function(self,anIndex,anotherIndex)
return (self:sub(anIndex,anotherIndex));
end
)
,"copying","copyFrom: anIndex to: anotherIndex\r\n\t\" Return the receiver between limits. \"\r\n\r\n\t^{'' doc'native copy'}","(\r\nfunction(self,anIndex,anotherIndex)\r\nreturn (self:sub(anIndex,anotherIndex));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"shallowCopy",0
,(
function(self)
return (self);
end
)
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"deepCopy",0
,(
function(self)
return (self);
end
)
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"reversed",0
,(
function(self)
local result=nil
if true then return self:reverse() end;
(function()
	local _s8_value=("")
	result=_s8_value
	return _s8_value
end)();
(self):reverseDo_((function(c)
return ((function()
	local _s8_value=(smalltalk:object_comma_((result),c))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
)
,"copying","reversed\r\n\t\" Return a string with the contents of the receiver in reverse order. \"\r\n\r\n\t| result |\r\n\t{'self' doc'native conversion'}.\r\n\tresult := ''.\r\n\tself reverseDo: [:c| result := result , c ].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\nif true then return self:reverse() end;\r\n(function()\r\n\tlocal _s8_value=(\"\")\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):reverseDo_((function(c)\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((result),c))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"indexOf:",0
,(
function(self,aString)

	local index = self:find(aString,1,true)
	if not index
		then return 0
		else return index end;
return (self);
end
)
,"accessing","indexOf: aString\r\n\t\" Return the position of first occurrence of aString (or 0 if not present). \"\r\n\r\n\t{'' doc'native detection'}","(\r\nfunction(self,aString)\r\n\r\n\tlocal index = self:find(aString,1,true)\r\n\tif not index\r\n\t\tthen return 0\r\n\t\telse return index end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"indexOf:ifAbsent:",0
,(
function(self,aString,aBlock)
local result=nil
(function()
	local _s8_value=((self):indexOf_(aString))
	result=_s8_value
	return _s8_value
end)();
return ((smalltalk:isObject_equalTo_((result),0)):ifTrue_ifFalse_(aBlock,(function()
return (result)
end)));
end
)
,"accessing","indexOf: aString ifAbsent: aBlock\r\n\t\" Return the position of first occurrence of aString (or the result of evaluating aBlock). \"\r\n\r\n\t| result |\r\n\tresult := self indexOf: aString.\r\n\t^result = 0 ifTrue: aBlock ifFalse: [ result ]","(\r\nfunction(self,aString,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):indexOf_(aString))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((smalltalk:isObject_equalTo_((result),0)):ifTrue_ifFalse_(aBlock,(function()\r\nreturn (result)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"indexOf:startingAt:",0
,(
function(self,aString,position)

	local index = self:find(aString,position,true)
	if not index
		then return 0
		else return index end;
return (self);
end
)
,"accessing","indexOf: aString startingAt: position\r\n\t\" Return the position of first occurrence of aString after position (or 0 if not present). \"\r\n\r\n\t{'' doc'native detection'}","(\r\nfunction(self,aString,position)\r\n\r\n\tlocal index = self:find(aString,position,true)\r\n\tif not index\r\n\t\tthen return 0\r\n\t\telse return index end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"lastIndexOf:",0
,(
function(self,aString)

	local i = 0
	local j = 0
	local k = 0
	repeat	i = j
		j, k = self:find(aString, k + 1, true)
	until j == nil
	if true then return i end;
return (self);
end
)
,"accessing","lastIndexOf: aString\r\n\t\" Return the position of last occurrence of aString (or 0 if not present). \"\r\n\r\n\t{'' doc'native detection'}","(\r\nfunction(self,aString)\r\n\r\n\tlocal i = 0\r\n\tlocal j = 0\r\n\tlocal k = 0\r\n\trepeat\ti = j\r\n\t\tj, k = self:find(aString, k + 1, true)\r\n\tuntil j == nil\r\n\tif true then return i end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"lastIndexOf:ifAbsent:",0
,(
function(self,aString,aBlock)
local result=nil
(function()
	local _s8_value=((self):lastIndexOf_(aString))
	result=_s8_value
	return _s8_value
end)();
return ((smalltalk:isObject_equalTo_((result),0)):ifTrue_ifFalse_(aBlock,(function()
return (result)
end)));
end
)
,"accessing","lastIndexOf: aString ifAbsent: aBlock\r\n\t\" Return the position of last occurrence of aString (or the result of evaluating aBlock). \"\r\n\r\n\t| result |\r\n\tresult := self lastIndexOf: aString.\r\n\t^result = 0 ifTrue: aBlock ifFalse: [ result ]","(\r\nfunction(self,aString,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):lastIndexOf_(aString))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((smalltalk:isObject_equalTo_((result),0)):ifTrue_ifFalse_(aBlock,(function()\r\nreturn (result)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"lastIndexOf:startingAt:",0
,(
function(self,aString,position)

	local i, j
	local k = position
	repeat	i = j
		j, k = self:find(aString, k + 1, true)
	until j == nil
	if true then return i end;
return (self);
end
)
,"accessing","lastIndexOf: aString startingAt: position\r\n\t\" Return the position of last occurrence of aString before position (or 0 if not present). \"\r\n\r\n\t{'' doc'native detection'}","(\r\nfunction(self,aString,position)\r\n\r\n\tlocal i, j\r\n\tlocal k = position\r\n\trepeat\ti = j\r\n\t\tj, k = self:find(aString, k + 1, true)\r\n\tuntil j == nil\r\n\tif true then return i end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"upTo:startingAt:",0
,(
function(self,aString,position)
local index=nil
(function()
	local _s8_value=((self):indexOf_startingAt_(aString,position))
	index=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((index),0)),(function()
return ((self):size())
end),(function()
return ((index):_minus(1))
end)))
	index=_s8_value
	return _s8_value
end)();
return ((self):copyFrom_to_(position,index));
end
)
,"accessing","upTo: aString startingAt: position\r\n\t\" Return the receiver upto first occurrence of aString after position. \"\r\n\r\n\t| index |\r\n\tindex := self indexOf: aString startingAt: position.\r\n\tindex := index = 0 ifTrue: [ self size ] ifFalse: [ index - 1 ].\r\n\t^self copyFrom: position to: index","(\r\nfunction(self,aString,position)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):indexOf_startingAt_(aString,position))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((index),0)),(function()\r\nreturn ((self):size())\r\nend),(function()\r\nreturn ((index):_minus(1))\r\nend)))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):copyFrom_to_(position,index));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"upTo:",0
,(
function(self,aCharacter)
return ((self):upTo_startingAt_(aCharacter,1));
end
)
,"accessing","upTo: aCharacter\r\n\t\" Return the receiver upto first occurrence of aCharacter. \"\r\n\r\n\t^self upTo: aCharacter startingAt: 1","(\r\nfunction(self,aCharacter)\r\nreturn ((self):upTo_startingAt_(aCharacter,1));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"upToLast:",0
,(
function(self,aString)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local index=nil
(function()
	local _s8_value=((self):lastIndexOf_ifAbsent_(aString,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end)))
	index=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):copyFrom_to_(1,(index):_minus(1)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"accessing","upToLast: aString\r\n\t\" Return the receiver upto last occurrence of aString. \"\r\n\r\n\t| index |\r\n\tindex := self lastIndexOf: aString ifAbsent: [ ^self ].\r\n\t^self copyFrom: 1 to: index - 1","(\r\nfunction(self,aString)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):lastIndexOf_ifAbsent_(aString,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):copyFrom_to_(1,(index):_minus(1)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"fromLast:",0
,(
function(self,aString)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local index=nil
(function()
	local _s8_value=((self):lastIndexOf_ifAbsent_(aString,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end)))
	index=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):copyFrom_to_((index):_plus((aString):size()),(self):size()))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"accessing","fromLast: aString\r\n\t\" Return the receiver contents from last occurrence of aString. \"\r\n\r\n\t| index |\r\n\tindex := self lastIndexOf: aString ifAbsent: [ ^self ].\r\n\t^self copyFrom: index + aString size to: self size","(\r\nfunction(self,aString)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):lastIndexOf_ifAbsent_(aString,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):copyFrom_to_((index):_plus((aString):size()),(self):size()))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asJsName",0
,(
function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (((smalltalk.String):reservedWords()):includes_(self))==true then smalltalk:if_true_false_((smalltalk:isObject_equalTo_((self),"toString")),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_(("$$"),self))
end
)()
error(_s8Ret_,0)
end)())
end)); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"js","asJsName\r\n\t\" Private - Return the receiver as a valid native name. \"\r\n\r\n\t(String reservedWords includes: self) ifTrue: [\r\n\t\tself = #toString ifFalse: [ ^'$$' ,self ]\r\n\t].\r\n\t^self","(\r\nfunction(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (((smalltalk.String):reservedWords()):includes_(self))==true then smalltalk:if_true_false_((smalltalk:isObject_equalTo_((self),\"toString\")),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((\"$$\"),self))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asNativeName",0
,(
function(self)
return (self:asLuaName());
end
)
,"js","asNativeName\r\n\t\" Return the receiver as a valid native name. \"\r\n\r\n\t^{'' doc'native conversion'}","(\r\nfunction(self)\r\nreturn (self:asLuaName());\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asPrivateSelector",0
,(
function(self)
local result=nil
local map = {
		[":"]="_",
		["+"]="_plus",
		["-"]="_minus",
		["*"]="_star",
		["/"]="_slash",
		["|"]="_bar",
		["&"]="_amp",
		[">"]="_gt",
		["<"]="_lt",
		["="]="_eq",
		[","]="_comma",
		["@"]="_at",
		["~"]="_no",
		["\\"]="_bk"
	};
	result = self:gsub(".",function(c) return map[c] end);
return (result);
end
)
,"converting","asPrivateSelector\r\n\t\" Private - Return the receiver as an encoded selector. \"\r\n\r\n\t| result |\r\n\t{'' doc'native conversion'}.\r\n\t^result ","(\r\nfunction(self)\r\nlocal result=nil\r\nlocal map = {\r\n\t\t[\":\"]=\"_\",\r\n\t\t[\"+\"]=\"_plus\",\r\n\t\t[\"-\"]=\"_minus\",\r\n\t\t[\"*\"]=\"_star\",\r\n\t\t[\"/\"]=\"_slash\",\r\n\t\t[\"|\"]=\"_bar\",\r\n\t\t[\"&\"]=\"_amp\",\r\n\t\t[\">\"]=\"_gt\",\r\n\t\t[\"<\"]=\"_lt\",\r\n\t\t[\"=\"]=\"_eq\",\r\n\t\t[\",\"]=\"_comma\",\r\n\t\t[\"@\"]=\"_at\",\r\n\t\t[\"~\"]=\"_no\",\r\n\t\t[\"\\\\\"]=\"_bk\"\r\n\t};\r\n\tresult = self:gsub(\".\",function(c) return map[c] end);\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asSelector",0
,(
function(self)
if ((self):startsWith_("#"))==true then return ((self):upTo_startingAt_(":",2)); end;
return (((self):asPrivateSelector()):asNativeName());
end
)
,"converting","asSelector\r\n\t\" Private - Return the receiver as a valid native selector. \"\r\n\r\n\t(self startsWith: $#) ifTrue: [\r\n\t\t^self upTo: $: startingAt: 2\r\n\t].\r\n\t^self asPrivateSelector asNativeName ","(\r\nfunction(self)\r\nif ((self):startsWith_(\"#\"))==true then return ((self):upTo_startingAt_(\":\",2)); end;\r\nreturn (((self):asPrivateSelector()):asNativeName());\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asNativeSelector",0
,(
function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local operations=nil
if (smalltalk:isObject_equalTo_((self),"$"))==true then return (""); end;
if (smalltalk:isObject_equalTo_((self),"_bk"))==true then return (smalltalk:asCharacter_((92))); end;
if ((self):startsWith_("$$"))==true then return (((self):copyFrom_to_(3,(self):size())):asNativeSelector()); end;
(function()
	local _s8_value=(smalltalk:newArray({smalltalk:newArray({"+", "_plus"}), smalltalk:newArray({"-", "_minus"}), smalltalk:newArray({"*", "_star"}), smalltalk:newArray({"/", "_slash"}), smalltalk:newArray({"|", "_bar"}), smalltalk:newArray({"&", "_amp"}), smalltalk:newArray({">", "_gt"}), smalltalk:newArray({"<", "_lt"}), smalltalk:newArray({"=", "_eq"}), smalltalk:newArray({",", "_comma"}), smalltalk:newArray({"@", "_at"}), smalltalk:newArray({"~", "_no"})}))
	operations=_s8_value
	return _s8_value
end)();
(operations):add_((smalltalk.Array):with_with_(smalltalk:asCharacter_((92)),"_bk"));
(operations):do_((function(tuple)
return (smalltalk:if_true_false_(((self):startsWith_((tuple):last())),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (((operations):reversed()):inject_into_(self,(function(result,each)
return ((result):replace_with_((each):last(),(each):first()))
end)))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):replace_with_("_",":"))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"converting","asNativeSelector\r\n\t\" Return a smalltalk selector from a native function name.\r\n\tNote: it must be the reverse operation of #asSelector\r\n\t\"\r\n\r\n\t| operations |\r\n\tself = '$' ifTrue: [ ^'' ].\r\n\tself = #_bk ifTrue: [ ^92 asCharacter ].\r\n\t(self startsWith: '$$') ifTrue: [\r\n\t\t^(self copyFrom: 3 to: self size) asNativeSelector\r\n\t].\r\n\toperations := #(\r\n\t\t#( + _plus )\r\n\t\t#( - _minus )\r\n\t\t#( * _star )\r\n\t\t#( / _slash )\r\n\t\t#( | _bar )\r\n\t\t#( & _amp )\r\n\t\t#( > _gt )\r\n\t\t#( < _lt )\r\n\t\t#( = _eq )\r\n\t\t#( , _comma )\r\n\t\t#( @ _at )\r\n\t\t#( ~ _no )\r\n\t).\r\n\toperations add: (Array with: 92 asCharacter with: #_bk).\r\n\toperations do: [:tuple|\r\n\t\t(self startsWith: tuple last) ifTrue: [\r\n\t\t\t^operations reversed inject: self into: [:result :each|\r\n\t\t\t\tresult replace: each last with: each first\r\n\t\t\t]\r\n\t\t].\r\n\t].\r\n\t^self replace: $_ with: $:","(\r\nfunction(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal operations=nil\r\nif (smalltalk:isObject_equalTo_((self),\"$\"))==true then return (\"\"); end;\r\nif (smalltalk:isObject_equalTo_((self),\"_bk\"))==true then return (smalltalk:asCharacter_((92))); end;\r\nif ((self):startsWith_(\"$$\"))==true then return (((self):copyFrom_to_(3,(self):size())):asNativeSelector()); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({smalltalk:newArray({\"+\", \"_plus\"}), smalltalk:newArray({\"-\", \"_minus\"}), smalltalk:newArray({\"*\", \"_star\"}), smalltalk:newArray({\"/\", \"_slash\"}), smalltalk:newArray({\"|\", \"_bar\"}), smalltalk:newArray({\"&\", \"_amp\"}), smalltalk:newArray({\">\", \"_gt\"}), smalltalk:newArray({\"<\", \"_lt\"}), smalltalk:newArray({\"=\", \"_eq\"}), smalltalk:newArray({\",\", \"_comma\"}), smalltalk:newArray({\"@\", \"_at\"}), smalltalk:newArray({\"~\", \"_no\"})}))\r\n\toperations=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(operations):add_((smalltalk.Array):with_with_(smalltalk:asCharacter_((92)),\"_bk\"));\r\n(operations):do_((function(tuple)\r\nreturn (smalltalk:if_true_false_(((self):startsWith_((tuple):last())),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (((operations):reversed()):inject_into_(self,(function(result,each)\r\nreturn ((result):replace_with_((each):last(),(each):first()))\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):replace_with_(\"_\",\":\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asStSelector",0
,(
function(self)
(self):note_("OBSOLETE - #asStSelector (please use #asNativeSelector)");
return ((self):asNativeSelector());
end
)
,"converting","asStSelector\r\n\t\" OBSOLETE - Return a smalltalk selector from a native function name.\r\n\tNote: use #asNativeSelector\r\n\t\"\r\n\r\n\tself note: 'OBSOLETE - #asStSelector (please use #asNativeSelector)'.\r\n\t^self asNativeSelector","(\r\nfunction(self)\r\n(self):note_(\"OBSOLETE - #asStSelector (please use #asNativeSelector)\");\r\nreturn ((self):asNativeSelector());\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"slashEncoded",0
,(
function(self)
local encoded=nil
local bar=nil
(function()
	local _s8_value=(smalltalk:asCharacter_((92)))
	bar=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(self)
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_(bar,smalltalk:object_comma_((bar),bar)))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_((smalltalk.String):lf(),smalltalk:object_comma_((bar),"n")))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_((smalltalk.String):cr(),smalltalk:object_comma_((bar),"r")))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_((smalltalk.String):tab(),smalltalk:object_comma_((bar),"t")))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_("\"",smalltalk:object_comma_((bar),"\"")))
	encoded=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_(("\""),encoded)),"\""));
end
)
,"converting","slashEncoded\r\n\t\" Private - Return the native representation of the receiver slashed. \"\r\n\r\n\t| encoded bar |\r\n\tbar := 92 asCharacter.\r\n\tencoded := self.\r\n\tencoded := encoded replace: bar with: bar ,bar.\r\n\tencoded := encoded replace: String lf with: bar ,$n.\r\n\tencoded := encoded replace: String cr with: bar ,$r.\r\n\tencoded := encoded replace: String tab with: bar ,$t.\r\n\tencoded := encoded replace: $\" with: bar ,$\".\r\n\t^$\" ,encoded ,$\"","(\r\nfunction(self)\r\nlocal encoded=nil\r\nlocal bar=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:asCharacter_((92)))\r\n\tbar=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(self)\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_(bar,smalltalk:object_comma_((bar),bar)))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_((smalltalk.String):lf(),smalltalk:object_comma_((bar),\"n\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_((smalltalk.String):cr(),smalltalk:object_comma_((bar),\"r\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_((smalltalk.String):tab(),smalltalk:object_comma_((bar),\"t\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_(\"\\\"\",smalltalk:object_comma_((bar),\"\\\"\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),encoded)),\"\\\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asNative:",0
,(
function(self,lang)
if (smalltalk:isObject_equalTo_((lang),"lua"))==true then return ((self):slashEncoded()); end;
if true then return self:slashEncoded() end;
return (self);
end
)
,"converting","asNative: lang\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\tlang = #lua ifTrue: [ ^self slashEncoded ].\r\n\t{'' doc'native conversion'}","(\r\nfunction(self,lang)\r\nif (smalltalk:isObject_equalTo_((lang),\"lua\"))==true then return ((self):slashEncoded()); end;\r\nif true then return self:slashEncoded() end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"replace:with:",0
,(
function(self,aString,anotherString)

	local result=""
	local i,j
	local k = 0
	repeat	i=k+1
		j, k = self:find(aString, i, true)
		if (j==nil) then
			result=result..(self:sub(i))
		else
			result=result..(self:sub(i,j-1)..anotherString)
		end
	until j == nil
	if true then return result end;
if (((aString)=="\\"))==true then return ((self):replace_with_("\\\\",anotherString)); end;
return ((self):replaceRegexp_with_((smalltalk.RegularExpression):fromString_flag_(aString,"g"),anotherString));
end
)
,"regularExpressions","replace: aString with: anotherString\r\n\t\" Return the result of replacement of aString with anotherString in the receiver. \"\r\n\r\n\t{'self' doc'native conversion'}.\r\n\taString == $\\ ifTrue: [ ^self replace: '\\\\' with: anotherString ].\r\n\t^self\r\n\t\treplaceRegexp: (RegularExpression fromString: aString flag: 'g')\r\n\t\twith: anotherString","(\r\nfunction(self,aString,anotherString)\r\n\r\n\tlocal result=\"\"\r\n\tlocal i,j\r\n\tlocal k = 0\r\n\trepeat\ti=k+1\r\n\t\tj, k = self:find(aString, i, true)\r\n\t\tif (j==nil) then\r\n\t\t\tresult=result..(self:sub(i))\r\n\t\telse\r\n\t\t\tresult=result..(self:sub(i,j-1)..anotherString)\r\n\t\tend\r\n\tuntil j == nil\r\n\tif true then return result end;\r\nif (((aString)==\"\\\\\"))==true then return ((self):replace_with_(\"\\\\\\\\\",anotherString)); end;\r\nreturn ((self):replaceRegexp_with_((smalltalk.RegularExpression):fromString_flag_(aString,\"g\"),anotherString));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"replaceRegexp:with:",0
,(
function(self,aRegexp,aString)
return (self:notImplementedYet_("replaceRegexp:with:"));
end
)
,"regularExpressions","replaceRegexp: aRegexp with: aString\r\n\t\" Return the result of replacement of aRegexp with aString in the receiver. \"\r\n\r\n\t^{'' doc'native conversion'}","(\r\nfunction(self,aRegexp,aString)\r\nreturn (self:notImplementedYet_(\"replaceRegexp:with:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"tokenize:",0
,(
function(self,aString)

	local result=smalltalk.Array:new()
	local i,j
	local k = 0
	repeat	i=k+1
		j, k = self:find(aString, i, true)
		if (j==nil) then
			result:add_(self:sub(i))
		else
			result:add_(self:sub(i,j-#aString))
		end
	until j == nil
	if true then return result end;
return (self);
end
)
,"converting","tokenize: aString\r\n\t\" Return the split tokenization of the receiver. \"\r\n\r\n\t{'' doc'native conversion'}","(\r\nfunction(self,aString)\r\n\r\n\tlocal result=smalltalk.Array:new()\r\n\tlocal i,j\r\n\tlocal k = 0\r\n\trepeat\ti=k+1\r\n\t\tj, k = self:find(aString, i, true)\r\n\t\tif (j==nil) then\r\n\t\t\tresult:add_(self:sub(i))\r\n\t\telse\r\n\t\t\tresult:add_(self:sub(i,j-#aString))\r\n\t\tend\r\n\tuntil j == nil\r\n\tif true then return result end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asArrayOfSubstrings",0
,(
function(self)
local result=nil
local start=nil
local i=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(1)
	i=_s8_value
	return _s8_value
end)();
(self):do_((function(c)
if (smalltalk:isNil_((start)))==true then smalltalk:if_true_false_(((c):isSeparator()),nil,(function()
return ((function()
	local _s8_value=(i)
	start=_s8_value
	return _s8_value
end)())
end)); else smalltalk:if_true_false_(((c):isSeparator()),(function()
(result):add_((self):copyFrom_to_(start,(i):_minus(1)));return ((function()
	local _s8_value=(nil)
	start=_s8_value
	return _s8_value
end)())
end),nil); end;return ((function()
	local _s8_value=((i):_plus(1))
	i=_s8_value
	return _s8_value
end)())
end));
if (smalltalk:notNil_((start)))==true then (result):add_((self):copyFrom_to_(start,(self):size())); end;
return (result);
end
)
,"converting","asArrayOfSubstrings\r\n\t\" Return an array of substrings from the receiver.\r\n\tThe receiver is divided into substrings by one or more occurrences of separators.\r\n\t\"\r\n\r\n\t| result start i |\r\n\tresult := Array new. i := 1.\r\n\tself do: [:c|\r\n\t\tstart isNil ifTrue: [ \"in separator\"\r\n\t\t\tc isSeparator ifFalse: [ \"start of substring\"\r\n\t\t\t\tstart := i.\r\n\t\t\t]\r\n\t\t] ifFalse: [ \"in word\"\r\n\t\t\tc isSeparator ifTrue: [ \"end of substring\"\r\n\t\t\t\tresult add: (self copyFrom: start to: i - 1).\r\n\t\t\t\tstart := nil.\r\n\t\t\t].\r\n\t\t].\r\n\t\ti := i + 1.\r\n\t].\r\n\tstart notNil ifTrue: [\r\n\t\tresult add: (self copyFrom: start to: self size)\r\n\t].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\nlocal start=nil\r\nlocal i=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(1)\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(c)\r\nif (smalltalk:isNil_((start)))==true then smalltalk:if_true_false_(((c):isSeparator()),nil,(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(i)\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)); else smalltalk:if_true_false_(((c):isSeparator()),(function()\r\n(result):add_((self):copyFrom_to_(start,(i):_minus(1)));return ((function()\r\n\tlocal _s8_value=(nil)\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),nil); end;return ((function()\r\n\tlocal _s8_value=((i):_plus(1))\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nif (smalltalk:notNil_((start)))==true then (result):add_((self):copyFrom_to_(start,(self):size())); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asArrayOfSubstringsSeparatedBy:",0
,(
function(self,aCharacter)
return ((self):tokenize_(aCharacter));
end
)
,"converting","asArrayOfSubstringsSeparatedBy: aCharacter\r\n\t\" Return an array of substrings from the receiver.\r\n\tThe receiver is divided into substrings by one or more occurrences of aCharacter.\r\n\t\"\r\n\r\n\t^self tokenize: aCharacter","(\r\nfunction(self,aCharacter)\r\nreturn ((self):tokenize_(aCharacter));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"match:",0
,(
function(self,aRegexp)
return (self:notImplementedYet_("match:"));
end
)
,"regularExpressions","match: aRegexp\r\n\t\" Return the match index of aRegexp in the receiver. \"\r\n\r\n\t^{'' doc'native testing'}","(\r\nfunction(self,aRegexp)\r\nreturn (self:notImplementedYet_(\"match:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asString",0
,(
function(self)
return (self);
end
)
,"converting","asString\r\n\t\" Return the text representation of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"between:and:",0
,(
function(self,min,max)
return (smalltalk:boolean_and_((((min) <= self)),(function()
return (((self) <= max))
end)));
end
)
,"testing","between: min and: max\r\n\t\" Return true if the receiver is between arguments. \"\r\n\r\n\t^min <= self and: [ self <= max ]","(\r\nfunction(self,min,max)\r\nreturn (smalltalk:boolean_and_((((min) <= self)),(function()\r\nreturn (((self) <= max))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"isLetter",0
,(
function(self)
return (#self==1 and string.find(self,"%a")==1);
end
)
,"testing","isLetter\r\n\t\" Return true if the receiver is a one character letter. \"\r\n\r\n\t^{'' doc'native testing'}","(\r\nfunction(self)\r\nreturn (#self==1 and string.find(self,\"%a\")==1);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"isDigit",0
,(
function(self)
return (#self==1 and string.find(self,"%d")==1);
end
)
,"testing","isDigit\r\n\t\" Return true if the receiver is one character numeric digit. \"\r\n\r\n\t^{'' doc'native testing'}","(\r\nfunction(self)\r\nreturn (#self==1 and string.find(self,\"%d\")==1);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"isAlphaNumeric",0
,(
function(self)

return (smalltalk:boolean_or_(((self):isDigit()),(function()
return ((self):isLetter())
end)));
end
)
,"testing","isAlphaNumeric\r\n\t\" Return true if the receiver is an alphanumeric character. \"\r\n\r\n\t{'self' doc'native testing'}.\r\n\t^self isDigit or: [self isLetter]","(\r\nfunction(self)\r\n\r\nreturn (smalltalk:boolean_or_(((self):isDigit()),(function()\r\nreturn ((self):isLetter())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"isUppercase",0
,(
function(self)
return ((self):isUpperCase());
end
)
,"testing","isUppercase\r\n\t\" Return true if all the receiver characters are uppercase. \"\r\n\r\n\t^self isUpperCase","(\r\nfunction(self)\r\nreturn ((self):isUpperCase());\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"isUpperCase",0
,(
function(self)

	if (#self==0) then return false end
	for c in self:gmatch(".") do
		if (c<"A" or c>"Z") then return false end
	end
	if true then return true end;
return (smalltalk:booleanNot_(((self):match_("[^A-Z]"))));
end
)
,"testing","isUpperCase\r\n\t\" Return true if all the receiver characters are uppercase. \"\r\n\r\n\t{'self' doc'native testing'}.\r\n\t^(self match: '[^A-Z]') not","(\r\nfunction(self)\r\n\r\n\tif (#self==0) then return false end\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (c<\"A\" or c>\"Z\") then return false end\r\n\tend\r\n\tif true then return true end;\r\nreturn (smalltalk:booleanNot_(((self):match_(\"[^A-Z]\"))));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"isLowerCase",0
,(
function(self)

	if (#self==0) then return false end
	for c in self:gmatch(".") do
		if (c<"a" or c>"z") then return false end
	end
	if true then return true end;
return (smalltalk:booleanNot_(((self):match_("[^a-z]"))));
end
)
,"testing","isLowerCase\r\n\t\" Return true if all the receiver characters are lowercase. \"\r\n\r\n\t{'self' doc'native testing'}.\r\n\t^(self match: '[^a-z]') not","(\r\nfunction(self)\r\n\r\n\tif (#self==0) then return false end\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (c<\"a\" or c>\"z\") then return false end\r\n\tend\r\n\tif true then return true end;\r\nreturn (smalltalk:booleanNot_(((self):match_(\"[^a-z]\"))));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"isLowercase",0
,(
function(self)
return ((self):isLowerCase());
end
)
,"testing","isLowercase\r\n\t\" Return true if the receiver is one character lowercase. \"\r\n\r\n\t^self isLowerCase","(\r\nfunction(self)\r\nreturn ((self):isLowerCase());\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asUppercase",0
,(
function(self)
return (self:upper());
end
)
,"converting","asUppercase\r\n\t\" Return a copy of the receiver converted to uppercase. \"\r\n\r\n\t^{'' doc'native testing'}","(\r\nfunction(self)\r\nreturn (self:upper());\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asUpperCase",0
,(
function(self)
return ((self):asUppercase());
end
)
,"converting","asUpperCase\r\n\t\" Return a copy of the receiver converted to uppercase. \"\r\n\r\n\t^self asUppercase","(\r\nfunction(self)\r\nreturn ((self):asUppercase());\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asLowercase",0
,(
function(self)
return (self:lower());
end
)
,"converting","asLowercase\r\n\t\" Return a copy of the receiver converted to lowercase. \"\r\n\r\n\t^{'' doc'native testing'}","(\r\nfunction(self)\r\nreturn (self:lower());\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asLowerCase",0
,(
function(self)
return ((self):asLowercase());
end
)
,"converting","asLowerCase\r\n\t\" Return a copy of the receiver converted to lowercase. \"\r\n\r\n\t^self asLowercase","(\r\nfunction(self)\r\nreturn ((self):asLowercase());\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asSmalltalkName:",0
,(
function(self,upCase)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local up=nil
local result=nil
if (smalltalk:boolean_and_((smalltalk:booleanNot_((upCase))),(function()
return (smalltalk:isNil_(((self):detect_ifNone_((function(c)
return (((c) >= "a"))
end),(function()
return (nil)
end)))))
end)))==true then return (((self):asLowercase()):asSmalltalkName_(upCase)); end;
(function()
	local _s8_value=(upCase)
	up=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):inject_into_("",(function(s,each)
return (smalltalk:if_true_false_((("_:.&%$?"):includes_(each)),(function()
(function()
	local _s8_value=(true)
	up=_s8_value
	return _s8_value
end)();return (s)
end),(function()
return (smalltalk:object_comma_((s),smalltalk:if_true_false_((up),(function()
(function()
	local _s8_value=(false)
	up=_s8_value
	return _s8_value
end)();return ((each):asUppercase())
end),(function()
return (each)
end))))
end)))
end)))
	result=_s8_value
	return _s8_value
end)();
if ((result):isEmpty())==true then return ("_"); end;
if (((result):first()):isDigit())==true then return (smalltalk:object_comma_(("_"),result)); end;
if (upCase)==true then smalltalk:if_true_false_((((result):first()):isLowercase()),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((((result):first()):asUppercase()),(result):copyFrom_to_(2,(result):size())))
end
)()
error(_s8Ret_,0)
end)())
end),nil); else smalltalk:if_true_false_((((result):first()):isUppercase()),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((((result):first()):asLowercase()),(result):copyFrom_to_(2,(result):size())))
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"converting","asSmalltalkName: upCase\r\n\t\" Return a copy of the receiver converted to a smalltalk global name. \"\r\n\r\n\t| up result |\r\n\t(upCase not and: [\r\n\t\t(self detect: [:c| c >= $a ] ifNone: []) isNil\r\n\t]) ifTrue: [\r\n\t\t^self asLowercase asSmalltalkName: upCase\r\n\t].\r\n\tup := upCase.\r\n\tresult := self inject: '' into: [:s :each|\r\n\t\t('_:.&%$?' includes: each) ifTrue: [ up := true. s ]\r\n\t\tifFalse: [ s , (up\r\n\t\t\tifTrue: [  up := false. each asUppercase ]\r\n\t\t\tifFalse: [ each ])\r\n\t\t]\r\n\t].\r\n\tresult isEmpty ifTrue: [ ^$_ ].\r\n\tresult first isDigit ifTrue: [ ^$_ ,result ].\r\n\tupCase ifTrue: [\r\n\t\tresult first isLowercase ifTrue: [\r\n\t\t\t^result first asUppercase ,(result copyFrom: 2 to: result size)\r\n\t\t]\r\n\t] ifFalse: [\r\n\t\tresult first isUppercase ifTrue: [\r\n\t\t\t^result first asLowercase ,(result copyFrom: 2 to: result size)\r\n\t\t]\r\n\t].\r\n\t^result","(\r\nfunction(self,upCase)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal up=nil\r\nlocal result=nil\r\nif (smalltalk:boolean_and_((smalltalk:booleanNot_((upCase))),(function()\r\nreturn (smalltalk:isNil_(((self):detect_ifNone_((function(c)\r\nreturn (((c) >= \"a\"))\r\nend),(function()\r\nreturn (nil)\r\nend)))))\r\nend)))==true then return (((self):asLowercase()):asSmalltalkName_(upCase)); end;\r\n(function()\r\n\tlocal _s8_value=(upCase)\r\n\tup=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):inject_into_(\"\",(function(s,each)\r\nreturn (smalltalk:if_true_false_(((\"_:.&%$?\"):includes_(each)),(function()\r\n(function()\r\n\tlocal _s8_value=(true)\r\n\tup=_s8_value\r\n\treturn _s8_value\r\nend)();return (s)\r\nend),(function()\r\nreturn (smalltalk:object_comma_((s),smalltalk:if_true_false_((up),(function()\r\n(function()\r\n\tlocal _s8_value=(false)\r\n\tup=_s8_value\r\n\treturn _s8_value\r\nend)();return ((each):asUppercase())\r\nend),(function()\r\nreturn (each)\r\nend))))\r\nend)))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((result):isEmpty())==true then return (\"_\"); end;\r\nif (((result):first()):isDigit())==true then return (smalltalk:object_comma_((\"_\"),result)); end;\r\nif (upCase)==true then smalltalk:if_true_false_((((result):first()):isLowercase()),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((((result):first()):asUppercase()),(result):copyFrom_to_(2,(result):size())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); else smalltalk:if_true_false_((((result):first()):isUppercase()),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((((result):first()):asLowercase()),(result):copyFrom_to_(2,(result):size())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asGlobalName",0
,(
function(self)
return ((self):asSmalltalkName_(true));
end
)
,"converting","asGlobalName\r\n\t\" Return a copy of the receiver converted to a smalltalk global name. \"\r\n\r\n\t^self asSmalltalkName: true","(\r\nfunction(self)\r\nreturn ((self):asSmalltalkName_(true));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asLocalName",0
,(
function(self)
return ((self):asSmalltalkName_(false));
end
)
,"converting","asLocalName\r\n\t\" Return a copy of the receiver converted to a smalltalk local name. \"\r\n\r\n\t^self asSmalltalkName: false","(\r\nfunction(self)\r\nreturn ((self):asSmalltalkName_(false));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"digitValue",0
,(
function(self)
return (((("0123456789ABCDEF"):indexOf_(self)):_minus(1)):max_((0):_minus(1)));
end
)
,"converting","digitValue\r\n\t\" Return the digit value of the receiver (or -1). \"\r\n\r\n\t^('0123456789ABCDEF' indexOf: self) - 1 max: 0 - 1","(\r\nfunction(self)\r\nreturn ((((\"0123456789ABCDEF\"):indexOf_(self)):_minus(1)):max_((0):_minus(1)));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asNumber",0
,(
function(self)
if ((self):includes_("r"))==true then return ((smalltalk.Number):readFrom_((self):readStream())); end;
return (tonumber(self));
end
)
,"converting","asNumber\r\n\t\" Return the receiver as a Number. \"\r\n\r\n\t(self includes: $r) ifTrue: [\r\n\t\t^Number readFrom: self readStream\r\n\t].\r\n\t^{'' doc'native converting'}","(\r\nfunction(self)\r\nif ((self):includes_(\"r\"))==true then return ((smalltalk.Number):readFrom_((self):readStream())); end;\r\nreturn (tonumber(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"errorReadOnly",0
,(
function(self)
return ((self):error_(smalltalk:object_comma_(("Strings are inmutable. Attempt to change "),(self):asLiteral())));
end
)
,"error","errorReadOnly\r\n\t\" DEPRECATED, Private - The receiver is read-only instance. \"\r\n\r\n\t^self error: 'Strings are inmutable. Attempt to change ' ,self asLiteral","(\r\nfunction(self)\r\nreturn ((self):error_(smalltalk:object_comma_((\"Strings are inmutable. Attempt to change \"),(self):asLiteral())));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"errorReadOnly:",0
,(
function(self,selector)
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Strings are inmutable. "),(selector):asLiteral()))," sent to ")),(self):asLiteral())));
end
)
,"error","errorReadOnly: selector\r\n\t\" Private - The receiver is read-only instance. \"\r\n\r\n\t^self error: 'Strings are inmutable. '\r\n\t\t,selector asLiteral\r\n\t\t,' sent to ' ,self asLiteral","(\r\nfunction(self,selector)\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Strings are inmutable. \"),(selector):asLiteral())),\" sent to \")),(self):asLiteral())));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"printString",0
,(
function(self)
local body=nil
(function()
	local _s8_value=(smalltalk:if_true_false_(((self):includes_("'")),(function()
return (((self):asArrayOfSubstringsSeparatedBy_("'")):join_("''"))
end),(function()
return (self)
end)))
	body=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_(("'"),body)),"'"));
end
)
,"printing","printString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t| body |\r\n\tbody := (self includes: $') ifTrue: [\r\n\t\t(self asArrayOfSubstringsSeparatedBy: $') join: ''''''\r\n\t] ifFalse: [ self ].\r\n\t^$' ,body ,$'","(\r\nfunction(self)\r\nlocal body=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((self):includes_(\"'\")),(function()\r\nreturn (((self):asArrayOfSubstringsSeparatedBy_(\"'\")):join_(\"''\"))\r\nend),(function()\r\nreturn (self)\r\nend)))\r\n\tbody=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"'\"),body)),\"'\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"isString",0
,(
function(self)
return (true);
end
)
,"testing","isString\r\n\t\" Return true if the receiver is a String. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"isBackSlash",0
,(
function(self)
return (smalltalk:isObject_equalTo_(((self):asciiValue()),92));
end
)
,"testing","isBackSlash\r\n\t\" Return true if the receiver is a back-slash string. \"\r\n\r\n\t^self asciiValue = 92 ","(\r\nfunction(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):asciiValue()),92));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,">","_gt"
,(
function(self,aString)
return (self > aString);
end
)
,"comparing","> aString\r\n\t\" Return true if the receiver is greater than argument. \"\r\n\r\n\t^{'' doc'native compare'}","(\r\nfunction(self,aString)\r\nreturn (self > aString);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"<","_lt"
,(
function(self,aString)
return (self < aString);
end
)
,"comparing","< aString\r\n\t\" Return true if the receiver is smaller than argument. \"\r\n\r\n\t^{'' doc'native compare'}","(\r\nfunction(self,aString)\r\nreturn (self < aString);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,">=","_gt_eq"
,(
function(self,aString)
return (self >= aString);
end
)
,"comparing",">= aString\r\n\t\" Return true if the receiver is greater or equal to argument. \"\r\n\r\n\t^{'' doc'native compare'}","(\r\nfunction(self,aString)\r\nreturn (self >= aString);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"<=","_lt_eq"
,(
function(self,aString)
return (self <= aString);
end
)
,"comparing","<= aString\r\n\t\" Return true if the receiver is smaller or equal to argument. \"\r\n\r\n\t^{'' doc'native compare'}","(\r\nfunction(self,aString)\r\nreturn (self <= aString);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"remove:ifAbsent:",0
,(
function(self,anObject,aBlock)
return ((self):errorReadOnly_("remove:ifAbsent:"));
end
)
,"removing","remove: anObject ifAbsent: aBlock\r\n\t\" Remove anObject from the receiver. \"\r\n\r\n\t^self errorReadOnly: #remove:ifAbsent:","(\r\nfunction(self,anObject,aBlock)\r\nreturn ((self):errorReadOnly_(\"remove:ifAbsent:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"removeAll:",0
,(
function(self,aCollection)
return ((self):errorReadOnly_("removeAll:"));
end
)
,"removing","removeAll: aCollection\r\n\t\" Remove aCollection from receiver. \"\r\n\r\n\t^self errorReadOnly: #removeAll:","(\r\nfunction(self,aCollection)\r\nreturn ((self):errorReadOnly_(\"removeAll:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"removeAll",0
,(
function(self)
return ((self):errorReadOnly_("removeAll"));
end
)
,"removing","removeAll\r\n\t\" Remove all elements in the receiver. \"\r\n\r\n\t^self errorReadOnly: #removeAll","(\r\nfunction(self)\r\nreturn ((self):errorReadOnly_(\"removeAll\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asJSONObject",0
,(
function(self)

return (smalltalk:object_comma_((self),""));
end
)
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t{'self'}.\r\n\t^self , ''\r\n\"Note:\twe need to normalize result to do not destroy typeof checkings\r\n\tDo NOT modify this method if you do not know what you are doing.\r\n\tIf you remove the ,'' computation, the returned object will return 'object' and not 'string' as result of typeof operation.\r\n\"","(\r\nfunction(self)\r\n\r\nreturn (smalltalk:object_comma_((self),\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"isCharacter",0
,(
function(self)
return (#self == 1);
end
)
,"testing","isCharacter\r\n\t\" Implemented to support Character protocoll for one-character Strings. \"\r\n\r\n\t^{'' doc'native testing'}","(\r\nfunction(self)\r\nreturn (#self == 1);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asciiValue",0
,(
function(self)
return (string.byte(self));
end
)
,"testing","asciiValue\r\n\t\" Return the number corresponding to the ASCII encoding of the first character of the receiver. \"\r\n\r\n\t^{'' doc'native converting'}","(\r\nfunction(self)\r\nreturn (string.byte(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"isSeparator",0
,(
function(self)
return (#self==1 and self:find("%s")==1);
end
)
,"testing","isSeparator\r\n\t\" Return true if the receiver is either a space, tab, new-line, form-feed character, or double-byte space.\r\n\tNote that new-line has been extended to support NEL character.\r\n\tSee https://en.wikipedia.org/wiki/Newline\r\n\t\"\r\n\r\n\t^{'' doc'native testing'}","(\r\nfunction(self)\r\nreturn (#self==1 and self:find(\"%s\")==1);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asAsciiZ",0
,(
function(self)
return (smalltalk:object_comma_((self),((self)["$klass"]):zero()));
end
)
,"converting","asAsciiZ\r\n\t\" Return the receiver with ascii zero appended. \"\r\n\r\n\t^self , self class zero","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((self),((self)[\"$klass\"]):zero()));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"trimFirst:last:",0
,(
function(self,firstBlock,lastBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local start=nil
local stop=nil
(function()
	local _s8_value=(1)
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):size())
	stop=_s8_value
	return _s8_value
end)();
while ((function()
if (((start) > stop))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.String):new())
end
)()
error(_s8Ret_,0)
end)(); end;return ((firstBlock):value_((self):at_(start)))
end))() do (function()
	local _s8_value=((start):_plus(1))
	start=_s8_value
	return _s8_value
end)(); end;
while ((function()
if (((stop) < start))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.String):new())
end
)()
error(_s8Ret_,0)
end)(); end;return ((lastBlock):value_((self):at_(stop)))
end))() do (function()
	local _s8_value=((stop):_minus(1))
	stop=_s8_value
	return _s8_value
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):copyFrom_to_(start,stop))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"selecting","trimFirst: firstBlock last: lastBlock\r\n\t\" Return a String containing the result of trimming characters matching blocks from both sides of the receiver. \"\r\n\r\n\t| start stop |\r\n\tstart := 1. stop := self size.\r\n\t[\tstart > stop ifTrue: [ ^String new ].\r\n\t\tfirstBlock value: (self at: start)\r\n\t] whileTrue: [ start := start + 1 ].\r\n\t[\tstop < start ifTrue: [ ^String new ].\r\n\t\tlastBlock value: (self at: stop)\r\n\t] whileTrue: [ stop := stop - 1 ].\r\n\t^self copyFrom: start to: stop","(\r\nfunction(self,firstBlock,lastBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal start=nil\r\nlocal stop=nil\r\n(function()\r\n\tlocal _s8_value=(1)\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):size())\r\n\tstop=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nif (((start) > stop))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.String):new())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return ((firstBlock):value_((self):at_(start)))\r\nend))() do (function()\r\n\tlocal _s8_value=((start):_plus(1))\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nwhile ((function()\r\nif (((stop) < start))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.String):new())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return ((lastBlock):value_((self):at_(stop)))\r\nend))() do (function()\r\n\tlocal _s8_value=((stop):_minus(1))\r\n\tstop=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):copyFrom_to_(start,stop))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"trim:",0
,(
function(self,aBlock)
return ((self):trimFirst_last_(aBlock,aBlock));
end
)
,"selecting","trim: aBlock\r\n\t\" Return a String containing the result of trimming characters matching aBlock from both sides of the receiver. \"\r\n\r\n\t^self trimFirst: aBlock last: aBlock","(\r\nfunction(self,aBlock)\r\nreturn ((self):trimFirst_last_(aBlock,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"trimFirst:",0
,(
function(self,aBlock)
return ((self):trimFirst_last_(aBlock,(function(c)
return (false)
end)));
end
)
,"selecting","trimFirst: aBlock\r\n\t\" Return a String containing the result of trimming characters matching aBlock from start of the receiver. \"\r\n\r\n\t^self trimFirst: aBlock last: [:c| false ]","(\r\nfunction(self,aBlock)\r\nreturn ((self):trimFirst_last_(aBlock,(function(c)\r\nreturn (false)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"trimLast:",0
,(
function(self,aBlock)
return ((self):trimFirst_last_((function(c)
return (false)
end),aBlock));
end
)
,"selecting","trimLast: aBlock\r\n\t\" Return a String containing the result of trimming characters matching aBlock from end of the receiver. \"\r\n\r\n\t^self trimFirst: [:c| false ] last: aBlock","(\r\nfunction(self,aBlock)\r\nreturn ((self):trimFirst_last_((function(c)\r\nreturn (false)\r\nend),aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"trimBlanks",0
,(
function(self)
return ((self):trim_((function(c)
return ((c):isSeparator())
end)));
end
)
,"selecting","trimBlanks\r\n\t\" Return a String containing the receiver string with leading and trailing blanks removed. \"\r\n\r\n\t^self trim: [:c| c isSeparator ]","(\r\nfunction(self)\r\nreturn ((self):trim_((function(c)\r\nreturn ((c):isSeparator())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"to:",0
,(
function(self,__end)
return ((self):to_by_(__end,smalltalk:if_true_false_((((self) <= __end)),(function()
return (1)
end),(function()
return (-1)
end))));
end
)
,"iterating","to: end\r\n\t\" Return an iterable from the receiver to end. \"\r\n\r\n\t^self to: end by: (self <= end ifTrue: [1] ifFalse: [-1])","(\r\nfunction(self,__end)\r\nreturn ((self):to_by_(__end,smalltalk:if_true_false_((((self) <= __end)),(function()\r\nreturn (1)\r\nend),(function()\r\nreturn (-1)\r\nend))));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"to:by:",0
,(
function(self,__end,increment)
return (((self):asciiValue()):to_by_value_((__end):asciiValue(),increment,(function(index,block)
return ((block):value_(smalltalk:asCharacter_((index))))
end)));
end
)
,"iterating","to: end by: increment\r\n\t\" Return an iterable from the receiver to end. \"\r\n\r\n\t^self asciiValue\r\n\t\tto: end asciiValue\r\n\t\tby: increment\r\n\t\tvalue: [:index :block| block value: index asCharacter ]","(\r\nfunction(self,__end,increment)\r\nreturn (((self):asciiValue()):to_by_value_((__end):asciiValue(),increment,(function(index,block)\r\nreturn ((block):value_(smalltalk:asCharacter_((index))))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"writeStream",0
,(
function(self)
return ((smalltalk.StringWriteStream):on_(self));
end
)
,"streams","writeStream\r\n\t\" Return a write stream on the receiver. \"\r\n\r\n\t^StringWriteStream on: self","(\r\nfunction(self)\r\nreturn ((smalltalk.StringWriteStream):on_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"evaluateFor:",0
,(
function(self,anObject)
return ((anObject):perform_(self));
end
)
,"evaluating","evaluateFor: anObject\r\n\t\" Return the result of evaluating the receiver with anObject. \"\r\n\r\n\t^anObject perform: self","(\r\nfunction(self,anObject)\r\nreturn ((anObject):perform_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asParser",0
,(
function(self)
return (smalltalk:if_true_false_(((self):isCharacter()),(function()
return ((smalltalk.PPCharacterParser):in_(self))
end),(function()
return (((smalltalk.PPStringParser):new()):string_(self))
end)));
end
)
,"Compiler-converting","asParser\r\n\t\" Return a parser on the receiver. \"\r\n\r\n\t^self isCharacter\r\n\tifTrue:  [ PPCharacterParser in: self ]\r\n\tifFalse: [ PPStringParser new string: self ]","(\r\nfunction(self)\r\nreturn (smalltalk:if_true_false_(((self):isCharacter()),(function()\r\nreturn ((smalltalk.PPCharacterParser):in_(self))\r\nend),(function()\r\nreturn (((smalltalk.PPStringParser):new()):string_(self))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asChoiceParser",0
,(
function(self)
return ((smalltalk.PPChoiceParser):withAll_(((self):asArray()):collect_((function(each)
return ((each):asParser())
end))));
end
)
,"Compiler-converting","asChoiceParser\r\n\t\" Return a parser of choices for each character the receiver. \"\r\n\r\n\t^PPChoiceParser withAll: (self asArray collect: [:each | each asParser ])","(\r\nfunction(self)\r\nreturn ((smalltalk.PPChoiceParser):withAll_(((self):asArray()):collect_((function(each)\r\nreturn ((each):asParser())\r\nend))));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asCharacterParser",0
,(
function(self)
return (((smalltalk.PPCharacterParser):new()):string_(self));
end
)
,"Compiler-converting","asCharacterParser\r\n\t\" Return a parser on the characters of the receiver. \"\r\n\r\n\t^PPCharacterParser new string: self","(\r\nfunction(self)\r\nreturn (((smalltalk.PPCharacterParser):new()):string_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"showIt",0
,(
function(self)
return ((self):print_((self):logEvaluate()));
end
)
,"Tools-evaluating","showIt\r\n\t\" Show/Print the result of evaluating the receiver. \"\r\n\r\n\t^self print: self logEvaluate","(\r\nfunction(self)\r\nreturn ((self):print_((self):logEvaluate()));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"logEvaluate",0
,(
function(self)
return (((function()
return ((self):evaluate())
end)):logEvaluate_(self));
end
)
,"Tools-evaluating","logEvaluate\r\n\t\" Return the result of evaluating the receiver.\r\n\tThe source of evaluation will be logged.\r\n\t\"\r\n\r\n\t^[ self evaluate ] logEvaluate: self ","(\r\nfunction(self)\r\nreturn (((function()\r\nreturn ((self):evaluate())\r\nend)):logEvaluate_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"evaluate",0
,(
function(self)
return ((((self):smalltalk()):compilerSupport()):evaluate_(self));
end
)
,"Tools-evaluating","evaluate\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self smalltalk compilerSupport evaluate: self ","(\r\nfunction(self)\r\nreturn ((((self):smalltalk()):compilerSupport()):evaluate_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"evaluateIn:",0
,(
function(self,aReceiver)
local target=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:boolean_and_(((self):isObject_(aReceiver)),(function()
return (smalltalk:notNil_((aReceiver)))
end))),(function()
return (aReceiver)
end),nil))
	target=_s8_value
	return _s8_value
end)();
return ((((target):smalltalk()):compilerSupport()):evaluate_to_(self,target));
end
)
,"Tools-evaluating","evaluateIn: aReceiver\r\n\t\" Return the result of evaluating the receiver in the context of aReceiver. \"\r\n\r\n\t| target |\r\n\ttarget := ((self isObject: aReceiver) and: [aReceiver notNil]) ifTrue: [ aReceiver ].\r\n\t^target smalltalk compilerSupport evaluate: self to: target","(\r\nfunction(self,aReceiver)\r\nlocal target=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:boolean_and_(((self):isObject_(aReceiver)),(function()\r\nreturn (smalltalk:notNil_((aReceiver)))\r\nend))),(function()\r\nreturn (aReceiver)\r\nend),nil))\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((((target):smalltalk()):compilerSupport()):evaluate_to_(self,target));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"doIt",0
,(
function(self)
return ((((self):smalltalk()):compilerSupport()):doIt_(self));
end
)
,"Tools-evaluating","doIt\r\n\t\" Return the result of evaluating the receiver or the error occurred during compilation or evaluation. \"\r\n\r\n\t^self smalltalk compilerSupport doIt: self","(\r\nfunction(self)\r\nreturn ((((self):smalltalk()):compilerSupport()):doIt_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"fileIn",0
,(
function(self)
return (((self):stream()):fileIn());
end
)
,"Tools-fileIn","fileIn\r\n\t\" FileIn the contents of the receiver. \"\r\n\r\n\t^self stream fileIn","(\r\nfunction(self)\r\nreturn (((self):stream()):fileIn());\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"fileOut",0
,(
function(self)
return ((smalltalk.Exporter):fileOut_(self));
end
)
,"Tools-fileOut","fileOut\r\n\t\" FileOut the classes/categories in the receiver. \"\r\n\r\n\t^Exporter fileOut: self","(\r\nfunction(self)\r\nreturn ((smalltalk.Exporter):fileOut_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"export",0
,(
function(self)
return ((smalltalk.Exporter):export_(self));
end
)
,"Tools-fileOut","export\r\n\t\" Export the classes/categories in the receiver. \"\r\n\r\n\t^Exporter export: self","(\r\nfunction(self)\r\nreturn ((smalltalk.Exporter):export_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asComment",0
,(
function(self)
local prologue=nil
local epilogue=nil
if (smalltalk:boolean_or_(((self):includes_((smalltalk.String):cr())),(function()
return ((self):includes_((smalltalk.String):lf()))
end)))==true then (function()
	local _s8_value=("--[[ ")
	prologue=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(" --]]")
	epilogue=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=("-- ")
	prologue=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=("")
	epilogue=_s8_value
	return _s8_value
end)(); end;
return (smalltalk:object_comma_((smalltalk:object_comma_((prologue),self)),epilogue));
end
)
,"Tools-converting","asComment\r\n\t\" Return the receiver as a source code comment. \"\r\n\r\n\t| prologue epilogue |\r\n\t((self includes: String cr) or: [self includes: String lf]) ifTrue: [\r\n\t\tprologue := {''}.\r\n\t\tepilogue := {''}.\r\n\t] ifFalse: [\r\n\t\tprologue := {''}.\r\n\t\tepilogue := ''\r\n\t].\r\n\t^prologue ,self ,epilogue","(\r\nfunction(self)\r\nlocal prologue=nil\r\nlocal epilogue=nil\r\nif (smalltalk:boolean_or_(((self):includes_((smalltalk.String):cr())),(function()\r\nreturn ((self):includes_((smalltalk.String):lf()))\r\nend)))==true then (function()\r\n\tlocal _s8_value=(\"--[[ \")\r\n\tprologue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(\" --]]\")\r\n\tepilogue=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=(\"-- \")\r\n\tprologue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(\"\")\r\n\tepilogue=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((prologue),self)),epilogue));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"senders",0
,(
function(self)
return ((smalltalk.Smalltalk):sendersOf_(self));
end
)
,"Tools-query","senders\r\n\t\" Return the senders of the receiver. \"\r\n\r\n\t^Smalltalk sendersOf: self","(\r\nfunction(self)\r\nreturn ((smalltalk.Smalltalk):sendersOf_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"implementors",0
,(
function(self)
return ((smalltalk.Smalltalk):implementorsOf_(self));
end
)
,"Tools-query","implementors\r\n\t\" Return the implementors of the receiver. \"\r\n\r\n\t^Smalltalk implementorsOf: self","(\r\nfunction(self)\r\nreturn ((smalltalk.Smalltalk):implementorsOf_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"ms:",0
,(
function(self,aBlock)
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((self)," (")),(aBlock):ms())),"ms)"));
return (self);
end
)
,"Tools-debug","ms: aBlock\r\n\t\" Print the time spent evaluating aBlock titled with the receiver. \"\r\n\r\n\tself note: self ,' (' ,aBlock ms ,'ms)'","(\r\nfunction(self,aBlock)\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((self),\" (\")),(aBlock):ms())),\"ms)\"));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"emmitFiles",0
,(
function(self)
local folder=nil
local fileNames=nil
local stream=nil
local line=nil
(function()
	local _s8_value=(self)
	folder=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:newArray({}))
	fileNames=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((folder),"emmit.txt")):fileContents()):stream())
	stream=_s8_value
	return _s8_value
end)();
while not ((function()
return ((stream):atEnd())
end))() do (function()
	local _s8_value=((((stream):nextLine()):upTo_(";")):trimBlanks())
	line=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_(((line):notEmpty()),(function()
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((line):first()),"@")),(function()
(function()
	local _s8_value=(((line):copyFrom_to_(2,(line):size())):trimBlanks())
	folder=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_(((folder):isEmpty()),(function()
return ((function()
	local _s8_value=(self)
	folder=_s8_value
	return _s8_value
end)())
end),nil))
end),(function()
return ((fileNames):add_(smalltalk:object_comma_((folder),line)))
end)))
end),nil); end;
(fileNames):emmitAll();
return (self);
end
)
,"Builders-emmiting","emmitFiles\r\n\t\" Emmit all the files listed in emmit.txt \"\r\n\r\n\t| folder fileNames stream line |\r\n\tfolder := self.\r\n\tfileNames := #().\r\n\tstream := (folder ,'emmit.txt') fileContents stream.\r\n\t[ stream atEnd ] whileFalse: [\r\n\t\tline := (stream nextLine upTo: $;) trimBlanks.\r\n\t\tline notEmpty ifTrue: [\r\n\t\t\tline first = $@ ifTrue: [\r\n\t\t\t\tfolder := (line copyFrom: 2 to: line size) trimBlanks.\r\n\t\t\t\tfolder isEmpty ifTrue: [ folder := self ]\r\n\t\t\t] ifFalse: [ fileNames add: folder ,line ]\r\n\t\t]\r\n\t].\r\n\tfileNames emmitAll","(\r\nfunction(self)\r\nlocal folder=nil\r\nlocal fileNames=nil\r\nlocal stream=nil\r\nlocal line=nil\r\n(function()\r\n\tlocal _s8_value=(self)\r\n\tfolder=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tfileNames=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((folder),\"emmit.txt\")):fileContents()):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((stream):atEnd())\r\nend))() do (function()\r\n\tlocal _s8_value=((((stream):nextLine()):upTo_(\";\")):trimBlanks())\r\n\tline=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_(((line):notEmpty()),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((line):first()),\"@\")),(function()\r\n(function()\r\n\tlocal _s8_value=(((line):copyFrom_to_(2,(line):size())):trimBlanks())\r\n\tfolder=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_(((folder):isEmpty()),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(self)\r\n\tfolder=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),nil))\r\nend),(function()\r\nreturn ((fileNames):add_(smalltalk:object_comma_((folder),line)))\r\nend)))\r\nend),nil); end;\r\n(fileNames):emmitAll();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"outputToFile:",0
,(
function(self,fileName)
return (fileWrite(fileName,self,"wb"));
end
)
,"Snapshot-io","outputToFile: fileName\r\n\t\" Save the receiver's contents onto a file at fileName. \"\r\n\r\n\t^# #fileWrite: fileName string: self mode: #wb","(\r\nfunction(self,fileName)\r\nreturn (fileWrite(fileName,self,\"wb\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"appendToFile:",0
,(
function(self,fileName)
return (fileWrite(fileName,self,"ab"));
end
)
,"Snapshot-io","appendToFile: fileName\r\n\t\" Append the receiver's contents onto a file at fileName. \"\r\n\r\n\t^# #fileWrite: fileName string: self mode: #ab","(\r\nfunction(self,fileName)\r\nreturn (fileWrite(fileName,self,\"ab\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asLuaName",0
,(
function(self)
if (smalltalk:isObject_equalTo_(((self):first()),"_"))==true then return (self); end;
if (((smalltalk.String):reservedLuaWords()):includes_(self))==true then return (smalltalk:object_comma_(("__"),self)); end;
return (self);
end
)
,"Lua-lua","asLuaName\r\n\t\" Private - Return the receiver as a valid Lua name. \"\r\n\r\n\tself first = $_ ifTrue: [ ^self ].\r\n\t(String reservedLuaWords includes: self) ifTrue: [ ^'__',self ].\r\n\t^self","(\r\nfunction(self)\r\nif (smalltalk:isObject_equalTo_(((self):first()),\"_\"))==true then return (self); end;\r\nif (((smalltalk.String):reservedLuaWords()):includes_(self))==true then return (smalltalk:object_comma_((\"__\"),self)); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asLuaSelector",0
,(
function(self)
if (((smalltalk.String):forbiddenLuaSelectors()):includes_(self))==true then return (smalltalk:object_comma_(("_"),self)); end;
if ((self):startsWith_("#"))==true then return ((self):upTo_startingAt_(":",2)); end;
return (((self):asPrivateSelector()):asLuaName());
end
)
,"Lua-lua","asLuaSelector\r\n\t\" Private - Return the receiver as a valid native selector. \"\r\n\r\n\t(String forbiddenLuaSelectors includes: self) ifTrue: [ ^$_ ,self ].\r\n\t(self startsWith: $#) ifTrue: [\r\n\t\t^self upTo: $: startingAt: 2\r\n\t].\r\n\t^self asPrivateSelector asLuaName ","(\r\nfunction(self)\r\nif (((smalltalk.String):forbiddenLuaSelectors()):includes_(self))==true then return (smalltalk:object_comma_((\"_\"),self)); end;\r\nif ((self):startsWith_(\"#\"))==true then return ((self):upTo_startingAt_(\":\",2)); end;\r\nreturn (((self):asPrivateSelector()):asLuaName());\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"asLua",0
,(
function(self)
local encoded=nil
local bar=nil
(function()
	local _s8_value=(smalltalk:asCharacter_((92)))
	bar=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(self)
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_(bar,smalltalk:object_comma_((bar),bar)))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_((smalltalk.String):lf(),smalltalk:object_comma_((bar),"n")))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_((smalltalk.String):cr(),smalltalk:object_comma_((bar),"r")))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_((smalltalk.String):tab(),smalltalk:object_comma_((bar),"t")))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_("\"",smalltalk:object_comma_((bar),"\"")))
	encoded=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_(("\""),encoded)),"\""));
end
)
,"Lua-lua","asLua\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t| encoded bar |\r\n\tbar := 92 asCharacter.\r\n\tencoded := self.\r\n\tencoded := encoded replace: bar with: bar ,bar.\r\n\tencoded := encoded replace: String lf with: bar ,$n.\r\n\tencoded := encoded replace: String cr with: bar ,$r.\r\n\tencoded := encoded replace: String tab with: bar ,$t.\r\n\tencoded := encoded replace: $\" with: bar ,$\".\r\n\t^$\" ,encoded ,$\"","(\r\nfunction(self)\r\nlocal encoded=nil\r\nlocal bar=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:asCharacter_((92)))\r\n\tbar=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(self)\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_(bar,smalltalk:object_comma_((bar),bar)))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_((smalltalk.String):lf(),smalltalk:object_comma_((bar),\"n\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_((smalltalk.String):cr(),smalltalk:object_comma_((bar),\"r\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_((smalltalk.String):tab(),smalltalk:object_comma_((bar),\"t\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_(\"\\\"\",smalltalk:object_comma_((bar),\"\\\"\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),encoded)),\"\\\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.String,"fileContents",0
,(
function(self)
return (read(self));
end
)
,"io","fileContents\r\n\t\" Returns the contents of file at (fileName given by) the receiver.\r\n\tReturn nil if the file do not exist or contents can't be read.\r\n\t\"\r\n\r\n\t^# #read: self","(\r\nfunction(self)\r\nreturn (read(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array["$klass"],"new",0
,(
function(self)
return (smalltalk:newArray({}));
end
)
,"instantiation","new\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^#()","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({}));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array["$klass"],"basicNew:",0
,(
function(self,size)
return (smalltalk:newArray());
end
)
,"instantiation","basicNew: size\r\n\t\" Return an instance of the receiver of specified size. \"\r\n\r\n\t^{'' doc'native instantiation'}","(\r\nfunction(self,size)\r\nreturn (smalltalk:newArray());\r\nend\r\n)")
smalltalk:bind(smalltalk.Array["$klass"],"new:",0
,(
function(self,size)
return (((self):basicNew_(size)):atAllPut_(nil));
end
)
,"instantiation","new: size\r\n\t\" Return an instance of the receiver of specified size. \"\r\n\r\n\t^(self basicNew: size) atAllPut: nil","(\r\nfunction(self,size)\r\nreturn (((self):basicNew_(size)):atAllPut_(nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array["$klass"],"with:",0
,(
function(self,anObject)

return ((
function(_s8_rec)
	(_s8_rec):add_(anObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","with: anObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}.\r\n\t^self new\r\n\t\tadd: anObject;\r\n\t\tyourself","(\r\nfunction(self,anObject)\r\n\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(anObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array["$klass"],"with:with:",0
,(
function(self,firstObject,secondObject)

return ((
function(_s8_rec)
	(_s8_rec):add_(firstObject);
	(_s8_rec):add_(secondObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","with: firstObject with: secondObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}.\r\n\t^self new\r\n\t\tadd: firstObject;\r\n\t\tadd: secondObject;\r\n\t\tyourself","(\r\nfunction(self,firstObject,secondObject)\r\n\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(firstObject);\r\n\t(_s8_rec):add_(secondObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array["$klass"],"with:with:with:",0
,(
function(self,firstObject,secondObject,thirdObject)

return ((
function(_s8_rec)
	(_s8_rec):add_(firstObject);
	(_s8_rec):add_(secondObject);
	(_s8_rec):add_(thirdObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","with: firstObject with: secondObject with: thirdObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}.\r\n\t^self new\r\n\t\tadd: firstObject;\r\n\t\tadd: secondObject;\r\n\t\tadd: thirdObject;\r\n\t\tyourself","(\r\nfunction(self,firstObject,secondObject,thirdObject)\r\n\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(firstObject);\r\n\t(_s8_rec):add_(secondObject);\r\n\t(_s8_rec):add_(thirdObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array["$klass"],"with:with:with:with:",0
,(
function(self,firstObject,secondObject,thirdObject,fourthObject)

return ((
function(_s8_rec)
	(_s8_rec):add_(firstObject);
	(_s8_rec):add_(secondObject);
	(_s8_rec):add_(thirdObject);
	(_s8_rec):add_(fourthObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","with: firstObject with: secondObject with: thirdObject with: fourthObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}.\r\n\t^self new\r\n\t\tadd: firstObject;\r\n\t\tadd: secondObject;\r\n\t\tadd: thirdObject;\r\n\t\tadd: fourthObject;\r\n\t\tyourself","(\r\nfunction(self,firstObject,secondObject,thirdObject,fourthObject)\r\n\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(firstObject);\r\n\t(_s8_rec):add_(secondObject);\r\n\t(_s8_rec):add_(thirdObject);\r\n\t(_s8_rec):add_(fourthObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array["$klass"],"withAll:",0
,(
function(self,aCollection)

	local result = aCollection:asArray()
	if aCollection==result
		then return result:copy()
		else return result
	end;
return (self);
end
)
,"instantiation","withAll: aCollection\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}","(\r\nfunction(self,aCollection)\r\n\r\n\tlocal result = aCollection:asArray()\r\n\tif aCollection==result\r\n\t\tthen return result:copy()\r\n\t\telse return result\r\n\tend;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array["$klass"],"slice:",0
,(
function(self,anIterable)
return (self:notImplementedYet_("slice:"));
end
)
,"util","slice: anIterable\r\n\t\" Return an Array instance from contents of anIterable. \"\r\n\r\n\t^{'' doc'native instantiation'}","(\r\nfunction(self,anIterable)\r\nreturn (self:notImplementedYet_(\"slice:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array["$klass"],"@@","_at_at"
,(
function(self,hArray)

return (hArray);
end
)
,"Natives-instantiation","@@ hArray\r\n\t\" Return an instance of the receiver wrapping native handle. \"\r\n\r\n\t{''}.\r\n\t^hArray","(\r\nfunction(self,hArray)\r\n\r\nreturn (hArray);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array["$klass"],"@","_at"
,(
function(self,natives)
local result=nil
(function()
	local _s8_value=((self):new())
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((natives)))==true then return (result); end;
result:addAllLua_(natives);
return (result);
end
)
,"Natives-instantiation","@ natives\r\n\t\" Return an instance of the receiver containing the values in native object. \"\r\n\r\n\t| result |\r\n\tresult := self new.\r\n\tnatives isNil ifTrue: [ ^result ].\r\n\t{''}.\r\n\t^result","(\r\nfunction(self,natives)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((natives)))==true then return (result); end;\r\nresult:addAllLua_(natives);\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"size",0
,(
function(self)
return (#self);
end
)
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^{'' doc'native size'}","(\r\nfunction(self)\r\nreturn (#self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"at:",0
,(
function(self,anIndex)

	local value = self[anIndex]
	if value==nil then return self:objectNotFoundAt_(anIndex) end
	if true then return self:unwrap_(value) end;
return (self);
end
)
,"accessing","at: anIndex\r\n\t\" Return the contents of the receiver at anIndex. \"\r\n\r\n\t{'' doc'native indexing'}","(\r\nfunction(self,anIndex)\r\n\r\n\tlocal value = self[anIndex]\r\n\tif value==nil then return self:objectNotFoundAt_(anIndex) end\r\n\tif true then return self:unwrap_(value) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"at:ifAbsent:",0
,(
function(self,anIndex,aBlock)

	local value = self[anIndex]
	if (value==nil) then return aBlock:value() end
	if true then return self:unwrap_(value) end;
return (self);
end
)
,"accessing","at: anIndex ifAbsent: aBlock\r\n\t\" Return the contents of the receiver at anIndex or the result of evaluating aBlock. \"\r\n\r\n\t{'' doc'native indexing'}","(\r\nfunction(self,anIndex,aBlock)\r\n\r\n\tlocal value = self[anIndex]\r\n\tif (value==nil) then return aBlock:value() end\r\n\tif true then return self:unwrap_(value) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"at:put:",0
,(
function(self,anIndex,anObject)

	self[anIndex]=self:wrap_(anObject)
	if true then return anObject end;
return (self);
end
)
,"accessing","at: anIndex put: anObject\r\n\t\" Set the contents of the receiver at anIndex. \"\r\n\r\n\t{'' doc'native indexing'}","(\r\nfunction(self,anIndex,anObject)\r\n\r\n\tself[anIndex]=self:wrap_(anObject)\r\n\tif true then return anObject end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"do:",0
,(
function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();

	for _,value in ipairs(self) do
		fn(self:unwrap_(value))
	end;
return (self);
end
)
,"enumerating","do: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'\t1 to: self size do: [:i|\r\n\t\taBlock value: (self at: i)\r\n\t]' doc'native iteration'}","(\r\nfunction(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\n\tfor _,value in ipairs(self) do\r\n\t\tfn(self:unwrap_(value))\r\n\tend;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"isArray",0
,(
function(self)
return ((((self)["$klass"])==smalltalk.Array));
end
)
,"testing","isArray\r\n\t\" Return true if the receiver is an Array. \"\r\n\r\n\t^self class == Array","(\r\nfunction(self)\r\nreturn ((((self)[\"$klass\"])==smalltalk.Array));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"addAll:",0
,(
function(self,aCollection)

	local array = aCollection:asArray()
	for i=1,#array do self[#self+1]=self:wrap_(array[i]) end;
return (aCollection);
end
)
,"adding","addAll: aCollection\r\n\t\" Add objects in aCollection to the receiver. \"\r\n\r\n\t{'' doc'native composing'}.\r\n\t^aCollection","(\r\nfunction(self,aCollection)\r\n\r\n\tlocal array = aCollection:asArray()\r\n\tfor i=1,#array do self[#self+1]=self:wrap_(array[i]) end;\r\nreturn (aCollection);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"shallowCopy",0
,(
function(self)
local result=nil

	result = self:class():new()
	for i=1,#self do result[#result+1]=self[i] end;
return (result);
end
)
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t| result |\r\n\t{'' doc'native copy'}.\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n\r\n\tresult = self:class():new()\r\n\tfor i=1,#self do result[#result+1]=self[i] end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"deepCopy",0
,(
function(self)
return ((self):collect_((function(each)
return ((each):deepCopy())
end)));
end
)
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self collect: [:each | each deepCopy ]","(\r\nfunction(self)\r\nreturn ((self):collect_((function(each)\r\nreturn ((each):deepCopy())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"copyFrom:to:",0
,(
function(self,anIndex,anotherIndex)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(anIndex):to_do_(anotherIndex,(function(each)
return ((result):add_((self):at_(each)))
end));
return (result);
end
)
,"copying","copyFrom: anIndex to: anotherIndex\r\n\t\" Return the receiver contents in the interval. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tanIndex to: anotherIndex do: [:each | result add: (self at: each) ].\r\n\t^result","(\r\nfunction(self,anIndex,anotherIndex)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(anIndex):to_do_(anotherIndex,(function(each)\r\nreturn ((result):add_((self):at_(each)))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"copyWithAll:",0
,(
function(self,aCollection)

	local result = self:copy()
	result:addAll_(aCollection)
	if true then return result end;
return (self);
end
)
,"copying","copyWithAll: aCollection\r\n\t\" Return a copy of the receiver with all contents of aCollection. \"\r\n\r\n\t{'' doc'native composition'}","(\r\nfunction(self,aCollection)\r\n\r\n\tlocal result = self:copy()\r\n\tresult:addAll_(aCollection)\r\n\tif true then return result end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,",","_comma"
,(
function(self,aCollection)

	local result = self:copy()
	result:addAll_(aCollection)
	if true then return result end;
return (self);
end
)
,"copying",", aCollection\r\n\t\" Return a copy of the receiver with all contents of aCollection. \"\r\n\r\n\t{'' doc'native composition'}","(\r\nfunction(self,aCollection)\r\n\r\n\tlocal result = self:copy()\r\n\tresult:addAll_(aCollection)\r\n\tif true then return result end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"join:",0
,(
function(self,aString)
return (table.concat(self,aString));
end
)
,"composing","join: aString\r\n\t\" Return a string with the receiver's contents separated by aString. \"\r\n\r\n\t^{'' doc'native composition'}","(\r\nfunction(self,aString)\r\nreturn (table.concat(self,aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"compose:with:",0
,(
function(self,aBlock,aString)
return (((self):collect_thenSelect_(aBlock,(function(each)
return (smalltalk:notNil_((each)))
end))):join_(aString));
end
)
,"composing","compose: aBlock with: aString\r\n\t\" Return a string composed with the result of evaluating aBlock into receiver's contents. \"\r\n\r\n\t^(self\tcollect: aBlock\r\n\t\tthenSelect: [:each| each notNil ])\r\n\t\tjoin: aString","(\r\nfunction(self,aBlock,aString)\r\nreturn (((self):collect_thenSelect_(aBlock,(function(each)\r\nreturn (smalltalk:notNil_((each)))\r\nend))):join_(aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"compose:",0
,(
function(self,aBlock)
return ((self):compose_with_(aBlock,""));
end
)
,"composing","compose: aBlock\r\n\t\" Return a string composed with the result of evaluating aBlock into receiver's contents. \"\r\n\r\n\t^self compose: aBlock with: ''","(\r\nfunction(self,aBlock)\r\nreturn ((self):compose_with_(aBlock,\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"asNative:",0
,(
function(self,lang)
local list=nil
(function()
	local _s8_value=(((self):collect_((function(each)
return ((each):asNative_(lang))
end))):join_(", "))
	list=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((lang),"lua"))==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk:newArray"),"(")),"{")),list)),"}")),")")); end;
return (smalltalk:object_comma_((smalltalk:object_comma_(("["),list)),"]"));
end
)
,"converting","asNative: lang\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t| list |\r\n\tlist := (self collect: [:each | each asNative: lang ]) join: ', '.\r\n\tlang = #lua ifTrue: [ ^'smalltalk:newArray' ,$( ,${ ,list ,$} ,$) ].\r\n\t^$[ ,list ,$]","(\r\nfunction(self,lang)\r\nlocal list=nil\r\n(function()\r\n\tlocal _s8_value=(((self):collect_((function(each)\r\nreturn ((each):asNative_(lang))\r\nend))):join_(\", \"))\r\n\tlist=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((lang),\"lua\"))==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk:newArray\"),\"(\")),\"{\")),list)),\"}\")),\")\")); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"[\"),list)),\"]\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"sort:",0
,(
function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
table.sort(self,fn);
return (self);
end
)
,"sorting","sort: aBlock\r\n\t\" Sort (inplace) the receiver's contents with aBlock. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{'' doc'native sorting'}","(\r\nfunction(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\ntable.sort(self,fn);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"asArray",0
,(
function(self)
return (self);
end
)
,"converting","asArray\r\n\t\" Return an array with the contents of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"remove:ifAbsent:",0
,(
function(self,anObject,aBlock)

	for i,value in ipairs(self) do
		if (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then return table.remove(self,i) end
	end
	if true then return aBlock:value() end;
return (self);
end
)
,"removing","remove: anObject ifAbsent: aBlock\r\n\t\" Remove anObject from the receiver.\r\n\tReturn the result of evaluating aBlock if anObject is not in the receiver.\r\n\t\"\r\n\r\n\t{'' doc'native remotion'}","(\r\nfunction(self,anObject,aBlock)\r\n\r\n\tfor i,value in ipairs(self) do\r\n\t\tif (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then return table.remove(self,i) end\r\n\tend\r\n\tif true then return aBlock:value() end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"add:",0
,(
function(self,anObject)
self[#self+1]=self:wrap_(anObject);
return (anObject);
end
)
,"adding","add: anObject\r\n\t\" Add anObject to the receiver. \"\r\n\r\n\t{'' doc'native addition'}.\r\n\t^anObject","(\r\nfunction(self,anObject)\r\nself[#self+1]=self:wrap_(anObject);\r\nreturn (anObject);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"addFirst:",0
,(
function(self,anObject)
table.insert(self,1,self:wrap_(anObject));
return (anObject);
end
)
,"adding","addFirst: anObject\r\n\t\" Add anObject to the receiver. \"\r\n\r\n\t{'' doc'native addition'}.\r\n\t^anObject","(\r\nfunction(self,anObject)\r\ntable.insert(self,1,self:wrap_(anObject));\r\nreturn (anObject);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"addLast:",0
,(
function(self,anObject)
self[#self+1]=self:wrap_(anObject);
return (anObject);
end
)
,"adding","addLast: anObject\r\n\t\" Add anObject to the receiver (at end). \"\r\n\r\n\t{'' doc'native addition'}.\r\n\t^anObject","(\r\nfunction(self,anObject)\r\nself[#self+1]=self:wrap_(anObject);\r\nreturn (anObject);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"removeAll",0
,(
function(self)
for i=#self,1,-1 do self[i]=nil end;
return (self);
end
)
,"removing","removeAll\r\n\t\" Remove all the objects in the receiver. \"\r\n\r\n\t{'' doc'native remotion'}","(\r\nfunction(self)\r\nfor i=#self,1,-1 do self[i]=nil end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"removeFirst",0
,(
function(self)
local result=nil
(function()
	local _s8_value=((self):first())
	result=_s8_value
	return _s8_value
end)();
table.remove(self,1);
return (result);
end
)
,"removing","removeFirst\r\n\t\" Remove the first object in the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self first.\r\n\t{'' doc'native remotion'}.\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):first())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\ntable.remove(self,1);\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"removeIndex:",0
,(
function(self,index)
table.remove(self,index);
return (self);
end
)
,"removing","removeIndex: index\r\n\t\" Remove the element at index. \"\r\n\r\n\t{'' doc'native remotion'}","(\r\nfunction(self,index)\r\ntable.remove(self,index);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"removeLast",0
,(
function(self)
return (self:unwrap_(table.remove(self)));
end
)
,"removing","removeLast\r\n\t\" Remove the last object in the receiver. \"\r\n\r\n\t^{'' doc'native remotion'}","(\r\nfunction(self)\r\nreturn (self:unwrap_(table.remove(self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"sorted",0
,(
function(self)
return (((self):copy()):sort_(nil));
end
)
,"sorting","sorted\r\n\t\" Return a sorted copy of the receiver. \"\r\n\r\n\t^self copy sort: nil","(\r\nfunction(self)\r\nreturn (((self):copy()):sort_(nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"sorted:",0
,(
function(self,aBlock)
return (((self):copy()):sort_(aBlock));
end
)
,"sorting","sorted: aBlock\r\n\t\" Return a sorted copy of the receiver. \"\r\n\r\n\t^self copy sort: aBlock","(\r\nfunction(self,aBlock)\r\nreturn (((self):copy()):sort_(aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"atAllPut:",0
,(
function(self,anObject)

	local what=self:wrap_(anObject)
	for i=1,#self do self[i]=what end;
return (self);
end
)
,"accessing","atAllPut: anObject\r\n\t\" Replace all elements of the receiver with anObject. \"\r\n\r\n\t{'' doc'native operation'}","(\r\nfunction(self,anObject)\r\n\r\n\tlocal what=self:wrap_(anObject)\r\n\tfor i=1,#self do self[i]=what end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"first",0
,(
function(self)

	local value=self[1]
	if (value~=nil) then return self:unwrap_(value) end;
return ((self):at_(1));
end
)
,"accessing","first\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t{'' doc'native indexing'}.\r\n\t^self at: 1","(\r\nfunction(self)\r\n\r\n\tlocal value=self[1]\r\n\tif (value~=nil) then return self:unwrap_(value) end;\r\nreturn ((self):at_(1));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"second",0
,(
function(self)

	local value=self[2]
	if (value~=nil) then return self:unwrap_(value) end;
return ((self):at_(2));
end
)
,"accessing","second\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t{'' doc'native indexing'}.\r\n\t^self at: 2","(\r\nfunction(self)\r\n\r\n\tlocal value=self[2]\r\n\tif (value~=nil) then return self:unwrap_(value) end;\r\nreturn ((self):at_(2));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"third",0
,(
function(self)

	local value=self[3]
	if (value~=nil) then return self:unwrap_(value) end;
return ((self):at_(3));
end
)
,"accessing","third\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t{'' doc'native indexing'}.\r\n\t^self at: 3","(\r\nfunction(self)\r\n\r\n\tlocal value=self[3]\r\n\tif (value~=nil) then return self:unwrap_(value) end;\r\nreturn ((self):at_(3));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"fourth",0
,(
function(self)
	
	local value=self[4]
	if (value~=nil) then return self:unwrap_(value) end;
return ((self):at_(4));
end
)
,"accessing","fourth\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t{'' doc'native indexing'}.\r\n\t^self at: 4","(\r\nfunction(self)\r\n\t\r\n\tlocal value=self[4]\r\n\tif (value~=nil) then return self:unwrap_(value) end;\r\nreturn ((self):at_(4));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"fifth",0
,(
function(self)

	local value=self[5]
	if (value~=nil) then return self:unwrap_(value) end;
return ((self):at_(5));
end
)
,"accessing","fifth\r\n\t\" Return the fifth object in the receiver. \"\r\n\r\n\t{'' doc'native indexing'}.\r\n\t^self at: 5","(\r\nfunction(self)\r\n\r\n\tlocal value=self[5]\r\n\tif (value~=nil) then return self:unwrap_(value) end;\r\nreturn ((self):at_(5));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"sixth",0
,(
function(self)

	local value=self[6]
	if (value~=nil) then return self:unwrap_(value) end;
return ((self):at_(6));
end
)
,"accessing","sixth\r\n\t\" Return the sixth object in the receiver. \"\r\n\r\n\t{'' doc'native indexing'}.\r\n\t^self at: 6","(\r\nfunction(self)\r\n\r\n\tlocal value=self[6]\r\n\tif (value~=nil) then return self:unwrap_(value) end;\r\nreturn ((self):at_(6));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"withIndexDo:",0
,(
function(self,aBlock)
local index=nil
(function()
	local _s8_value=(1)
	index=_s8_value
	return _s8_value
end)();
(self):do_((function(each)
(aBlock):value_value_(each,index);return ((function()
	local _s8_value=((index):_plus(1))
	index=_s8_value
	return _s8_value
end)())
end));
return (self);
end
)
,"enumerating","withIndexDo: aBlock\r\n\t\" Evaluate aBlock with all the index positions in the receiver. \"\r\n\r\n\t| index |\r\n\tindex := 1.\r\n\tself do: [:each|\r\n\t\taBlock value: each value: index.\r\n\t\tindex := index + 1\r\n\t]","(\r\nfunction(self,aBlock)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=(1)\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(each)\r\n(aBlock):value_value_(each,index);return ((function()\r\n\tlocal _s8_value=((index):_plus(1))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"printString",0
,(
function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
if ((self):isEmpty())==true then return ("#()"); end;
(function()
	local _s8_value=("#( ")
	result=_s8_value
	return _s8_value
end)();
(self):do_((function(each)
if ((((result):size()) > 10000))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((result),"...)"))
end
)()
error(_s8Ret_,0)
end)(); end;return ((function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((result),smalltalk:if_true_false_(((self):isObject_(each)),(function()
return (smalltalk:printString_((each)))
end),(function()
return (each)
end))))," "))
	result=_s8_value
	return _s8_value
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((result),")"))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"printing","printString\r\n\t\" DEBUG - Temporary printing method (must check for recursion). \"\r\n\r\n\t| result |\r\n\tself isEmpty ifTrue: [ ^'#()' ].\r\n\tresult := '#( '.\r\n\tself do: [:each|\r\n\t\tresult size > 10000 ifTrue: [ ^result,'...)' ].\r\n\t\tresult := result , (\r\n\t\t\t(self isObject: each)\r\n\t\t\tifTrue: [ each printString ]\r\n\t\t\tifFalse: [ each ]) ,' '\r\n\t].\r\n\t^result,')'","(\r\nfunction(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\nif ((self):isEmpty())==true then return (\"#()\"); end;\r\n(function()\r\n\tlocal _s8_value=(\"#( \")\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(each)\r\nif ((((result):size()) > 10000))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((result),\"...)\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((result),smalltalk:if_true_false_(((self):isObject_(each)),(function()\r\nreturn (smalltalk:printString_((each)))\r\nend),(function()\r\nreturn (each)\r\nend)))),\" \"))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((result),\")\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"asLiteral",0
,(
function(self)
local literals=nil
(function()
	local _s8_value=((self):collect_((function(each)
return (smalltalk:if_true_false_(((self):isObject_(each)),(function()
return ((each):asLiteral())
end),(function()
return (smalltalk:toString_((each)))
end)))
end)))
	literals=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_(("#("),(literals):join_(" "))),")"));
end
)
,"converting","asLiteral\r\n\t\" Return the receiver in literal notation. \"\r\n\r\n\t| literals |\r\n\tliterals := self collect: [:each|\r\n\t\t(self isObject: each)\r\n\t\tifTrue: [ each asLiteral ]\r\n\t\tifFalse: [ each toString ]\r\n\t].\r\n\t^'#(' ,(literals join: $ ) ,$)","(\r\nfunction(self)\r\nlocal literals=nil\r\n(function()\r\n\tlocal _s8_value=((self):collect_((function(each)\r\nreturn (smalltalk:if_true_false_(((self):isObject_(each)),(function()\r\nreturn ((each):asLiteral())\r\nend),(function()\r\nreturn (smalltalk:toString_((each)))\r\nend)))\r\nend)))\r\n\tliterals=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"#(\"),(literals):join_(\" \"))),\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"asJSONObject",0
,(
function(self)
local result=nil

(function()
	local _s8_value=((self):collect_((function(each)
return (smalltalk:if_true_false_(((self):isObject_(each)),(function()
return ((each):asJSONObject())
end),(function()
return (each)
end)))
end)))
	result=_s8_value
	return _s8_value
end)();

return (result);
end
)
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t| result |\r\n\t{'self' doc'native conversion'}.\r\n\tresult := self collect: [:each| \r\n\t\t(self isObject: each)\r\n\t\tifTrue: [ each asJSONObject ]\r\n\t\tifFalse: [ each ]\r\n\t].\r\n\t{'self' doc'native closing'}.\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n\r\n(function()\r\n\tlocal _s8_value=((self):collect_((function(each)\r\nreturn (smalltalk:if_true_false_(((self):isObject_(each)),(function()\r\nreturn ((each):asJSONObject())\r\nend),(function()\r\nreturn (each)\r\nend)))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"json",0
,(
function(self)
local result=nil

(function()
	local _s8_value=((self):collect_((function(each)
return (smalltalk:if_true_false_(((self):isObject_(each)),(function()
return ((each):json())
end),(function()
return (each)
end)))
end)))
	result=_s8_value
	return _s8_value
end)();

return (result);
end
)
,"converting","json\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t| result |\r\n\t{'self' doc'native conversion'}.\r\n\tresult := self collect: [:each| \r\n\t\t(self isObject: each)\r\n\t\tifTrue: [ each json ]\r\n\t\tifFalse: [ each ]\r\n\t].\r\n\t{'self' doc'native closing'}.\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n\r\n(function()\r\n\tlocal _s8_value=((self):collect_((function(each)\r\nreturn (smalltalk:if_true_false_(((self):isObject_(each)),(function()\r\nreturn ((each):json())\r\nend),(function()\r\nreturn (each)\r\nend)))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"emmitAllIn:",0
,(
function(self,folder)
return (((self):collect_((function(each)
return (smalltalk:object_comma_((folder),each))
end))):emmitAll());
end
)
,"Builders-emmiting","emmitAllIn: folder\r\n\t\" Emmit(fileIn & save generated code of) the fileNames in the receiver.\r\n\tNote the receiver MUST include the file separator at end\r\n\t\"\r\n\r\n\t^(self collect: [:each| folder , each ]) emmitAll","(\r\nfunction(self,folder)\r\nreturn (((self):collect_((function(each)\r\nreturn (smalltalk:object_comma_((folder),each))\r\nend))):emmitAll());\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"emmitAll",0
,(
function(self)
if ((self):isEmpty())==true then return (self); end;
((function()
(self):emmit_((smalltalk.Array):with_((self):removeFirst()));return ((self):emmitAll())
end)):valueDeferred_(500);
return (self);
end
)
,"Builders-emmiting","emmitAll\r\n\t\" Deferred (consuming) emmit of fileNames in the receiver. \"\r\n\r\n\tself isEmpty ifTrue: [ ^self ].\r\n\t[\tself emmit: (Array with: self removeFirst).\r\n\t\tself emmitAll\r\n\t] valueDeferred: 500","(\r\nfunction(self)\r\nif ((self):isEmpty())==true then return (self); end;\r\n((function()\r\n(self):emmit_((smalltalk.Array):with_((self):removeFirst()));return ((self):emmitAll())\r\nend)):valueDeferred_(500);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"handles",0
,(
function(self)
return ((self):collect_((function(each)
return ((each):handle())
end)));
end
)
,"Natives-converting","handles\r\n\t\" Return the result of collecting the handles of the receiver. \"\r\n\r\n\t^self collect: [:each| each handle ]","(\r\nfunction(self)\r\nreturn ((self):collect_((function(each)\r\nreturn ((each):handle())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"asLua",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk:newArray"),"(")),"{")),((self):collect_((function(each)
return ((each):asLua())
end))):join_(", "))),"}")),")"));
end
)
,"Lua-lua","asLua\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t^'smalltalk:newArray' ,$( ,${\r\n\t\t,((self collect: [:each | each asLua ]) join: ', ')\r\n\t,$} ,$) ","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk:newArray\"),\"(\")),\"{\")),((self):collect_((function(each)\r\nreturn ((each):asLua())\r\nend))):join_(\", \"))),\"}\")),\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"__tostring",0
,(
function(self)
return ((self):asLiteral());
end
)
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self asLiteral","(\r\nfunction(self)\r\nreturn ((self):asLiteral());\r\nend\r\n)")
smalltalk:bind(smalltalk.Array,"addAllLua:",0
,(
function(self,natives)
if (smalltalk:isObject_equalTo_(((self):typeOf_(natives)),"userdata"))==true then local count=nil
(function()
	local _s8_value=((smalltalk.JavaArray):getLength_((smalltalk.Lua):_at(natives)))
	count=_s8_value
	return _s8_value
end)();
(1):to_do_(count,(function(i)
return ((self):add_((((smalltalk.JavaArray):nativeClass()):handle()):get(natives,(i):_minus(1))))
end));
return (self); end;
for _,value in pairs(natives) do self:add_(value) end;
return (self);
end
)
,"Lua-private","addAllLua: natives\r\n\t\" Private - Add the native values to the receiver. \"\r\n\r\n\t(self typeOf: natives) = #userdata ifTrue: [ | count |\r\n\t\tcount := JavaArray getLength: Lua@natives.\r\n\t\t1 to: count do: [:i|\r\n\t\t\tself add: (JavaArray nativeClass handle\r\n\t\t\t\t#get: natives index: i - 1).\r\n\t\t].\r\n\t\t^self\r\n\t].\r\n\t{''js'self.addAll_(natives)'}.\r\n\t^self","(\r\nfunction(self,natives)\r\nif (smalltalk:isObject_equalTo_(((self):typeOf_(natives)),\"userdata\"))==true then local count=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.JavaArray):getLength_((smalltalk.Lua):_at(natives)))\r\n\tcount=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(1):to_do_(count,(function(i)\r\nreturn ((self):add_((((smalltalk.JavaArray):nativeClass()):handle()):get(natives,(i):_minus(1))))\r\nend));\r\nreturn (self); end;\r\nfor _,value in pairs(natives) do self:add_(value) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"contents",0
,(
function(self)
if (smalltalk:isNil_((self["@contents"])))==true then (function()
	local _s8_value=((smalltalk.Array):new())
	self["@contents"]=_s8_value
	return _s8_value
end)(); end;
return (self["@contents"]);
end
)
,"private","contents\r\n\t\" Private - Return the contents of the receiver. \"\r\n\r\n\tcontents isNil ifTrue: [ contents := Array new ].\r\n\t^contents","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@contents\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@contents\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@contents\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"add:",0
,(
function(self,anObject)
return (((self):contents()):add_(anObject));
end
)
,"adding","add: anObject\r\n\t\" Add anObject to the receiver. \"\r\n\r\n\t^self contents add: anObject","(\r\nfunction(self,anObject)\r\nreturn (((self):contents()):add_(anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"at:ifAbsent:",0
,(
function(self,anIndex,aBlock)
return (((self):contents()):at_ifAbsent_(anIndex,aBlock));
end
)
,"accessing","at: anIndex ifAbsent: aBlock\r\n\t\" Return the contents of the receiver at anIndex or the result of evaluating aBlock. \"\r\n\r\n\t^self contents at: anIndex ifAbsent: aBlock","(\r\nfunction(self,anIndex,aBlock)\r\nreturn (((self):contents()):at_ifAbsent_(anIndex,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"at:put:",0
,(
function(self,anIndex,anObject)
return (((self):contents()):at_put_(anIndex,anObject));
end
)
,"accessing","at: anIndex put: anObject\r\n\t\" Set the contents of the receiver at anIndex. \"\r\n\r\n\t^self contents at: anIndex put: anObject","(\r\nfunction(self,anIndex,anObject)\r\nreturn (((self):contents()):at_put_(anIndex,anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"atAllPut:",0
,(
function(self,anObject)
return (((self):contents()):atAllPut_(anObject));
end
)
,"accessing","atAllPut: anObject\r\n\t\" Replace all elements of the receiver with anObject. \"\r\n\r\n\t^self contents atAllPut: anObject","(\r\nfunction(self,anObject)\r\nreturn (((self):contents()):atAllPut_(anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"copyFrom:to:",0
,(
function(self,anIndex,anotherIndex)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(anIndex):to_do_(anotherIndex,(function(each)
return ((result):add_((self):at_(each)))
end));
return (result);
end
)
,"copying","copyFrom: anIndex to: anotherIndex\r\n\t\" Return the receiver contents in the interval. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tanIndex to: anotherIndex do: [:each | result add: (self at: each) ].\r\n\t^result","(\r\nfunction(self,anIndex,anotherIndex)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(anIndex):to_do_(anotherIndex,(function(each)\r\nreturn ((result):add_((self):at_(each)))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"indexOf:ifAbsent:",0
,(
function(self,anObject,aBlock)
return (((self):contents()):indexOf_ifAbsent_(anObject,aBlock));
end
)
,"testing","indexOf: anObject ifAbsent: aBlock\r\n\t\" Return the position of anObject in the receiver, or the result of evaluating aBlock. \"\r\n\r\n\t^self contents indexOf: anObject ifAbsent: aBlock","(\r\nfunction(self,anObject,aBlock)\r\nreturn (((self):contents()):indexOf_ifAbsent_(anObject,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"detect:ifNone:",0
,(
function(self,aBlock,anotherBlock)
return (((self):contents()):detect_ifNone_(aBlock,anotherBlock));
end
)
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. \"\r\n\r\n\t^self contents detect: aBlock ifNone: anotherBlock","(\r\nfunction(self,aBlock,anotherBlock)\r\nreturn (((self):contents()):detect_ifNone_(aBlock,anotherBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"do:",0
,(
function(self,aBlock)
return (((self):contents()):do_(aBlock));
end
)
,"enumerating","do: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver. \"\r\n\r\n\t^self contents do: aBlock","(\r\nfunction(self,aBlock)\r\nreturn (((self):contents()):do_(aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"includes:",0
,(
function(self,anObject)
return (((self):contents()):includes_(anObject));
end
)
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t^self contents includes: anObject","(\r\nfunction(self,anObject)\r\nreturn (((self):contents()):includes_(anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"isEmpty",0
,(
function(self)
return (((self):contents()):isEmpty());
end
)
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^self contents isEmpty","(\r\nfunction(self)\r\nreturn (((self):contents()):isEmpty());\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"occurrencesOf:",0
,(
function(self,anObject)
return (((self):contents()):occurrencesOf_(anObject));
end
)
,"counting","occurrencesOf: anObject\r\n\t\" Return the occurrences of anObject in the receiver. \"\r\n\r\n\t^self contents occurrencesOf: anObject","(\r\nfunction(self,anObject)\r\nreturn (((self):contents()):occurrencesOf_(anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"reverseDo:",0
,(
function(self,aBlock)
return (((self):contents()):reverseDo_(aBlock));
end
)
,"enumerating","reverseDo: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver in reverse order of iteration. \"\r\n\r\n\t^self contents reverseDo: aBlock","(\r\nfunction(self,aBlock)\r\nreturn (((self):contents()):reverseDo_(aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"reversed",0
,(
function(self)
return (((self)["$klass"]):withAll_(((self):contents()):reversed()));
end
)
,"copying","reversed\r\n\t\" Return an array with the contents of the receiver in reverse order. \"\r\n\r\n\t^self class withAll: self contents reversed","(\r\nfunction(self)\r\nreturn (((self)[\"$klass\"]):withAll_(((self):contents()):reversed()));\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"remove:ifAbsent:",0
,(
function(self,anObject,aBlock)
return (((self):contents()):remove_ifAbsent_(anObject,aBlock));
end
)
,"removing","remove: anObject ifAbsent: aBlock\r\n\t\" Remove anObject from the receiver.\r\n\tReturn the result of evaluating aBlock if anObject is not in the receiver.\r\n\t\"\r\n\r\n\t^self contents remove: anObject ifAbsent: aBlock","(\r\nfunction(self,anObject,aBlock)\r\nreturn (((self):contents()):remove_ifAbsent_(anObject,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"removeAll",0
,(
function(self)
(function()
	local _s8_value=(nil)
	self["@contents"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"removing","removeAll\r\n\t\" Remove all the objects in the receiver. \"\r\n\r\n\tcontents := nil","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@contents\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"removeFirst",0
,(
function(self)
return (((self):contents()):removeFirst());
end
)
,"removing","removeFirst\r\n\t\" Remove the first object in the receiver. \"\r\n\r\n\t^self contents removeFirst","(\r\nfunction(self)\r\nreturn (((self):contents()):removeFirst());\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"removeLast",0
,(
function(self)
return (((self):contents()):removeLast());
end
)
,"removing","removeLast\r\n\t\" Remove the last object in the receiver. \"\r\n\r\n\t^self contents removeLast","(\r\nfunction(self)\r\nreturn (((self):contents()):removeLast());\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"removeIndex:",0
,(
function(self,index)
return (((self):contents()):removeIndex_(index));
end
)
,"removing","removeIndex: index\r\n\t\" Remove the element at index. \"\r\n\r\n\t^self contents removeIndex: index","(\r\nfunction(self,index)\r\nreturn (((self):contents()):removeIndex_(index));\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"size",0
,(
function(self)
return (((self):contents()):size());
end
)
,"accesing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^self contents size","(\r\nfunction(self)\r\nreturn (((self):contents()):size());\r\nend\r\n)")
smalltalk:bind(smalltalk.ArrayedContents,"withIndexDo:",0
,(
function(self,aBlock)
return (((self):contents()):withIndexDo_(aBlock));
end
)
,"enumerating","withIndexDo: aBlock\r\n\t\" Evaluate aBlock with all the index positions in the receiver. \"\r\n\r\n\t^self contents withIndexDo: aBlock","(\r\nfunction(self,aBlock)\r\nreturn (((self):contents()):withIndexDo_(aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.ComposedAssociations["$klass"],",","_comma"
,(
function(self,anObject)
return (smalltalk:object_comma_(((self):new()),anObject));
end
)
,"composing",", anObject\r\n\t\" Return an instance of the receiver with the argument. \"\r\n\r\n\t^self new ,anObject","(\r\nfunction(self,anObject)\r\nreturn (smalltalk:object_comma_(((self):new()),anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.ComposedAssociations,",","_comma"
,(
function(self,anObject)
if ((anObject):isAssociation())==true then return ((
function(_s8_rec)
	(_s8_rec):add_(anObject);
	return ((_s8_rec):yourself())
end
)(self)); end;
return (smalltalk:if_true_false_((smalltalk:isNil_((anObject))),(function()
return (self)
end),(function()
return (smalltalk:superImplementor(smalltalk.ComposedAssociations,"_comma")(self,anObject))
end)));
end
)
,"composing",", anObject\r\n\t\" Return the receiver composed with the argument. \"\r\n\r\n\tanObject isAssociation ifTrue: [\r\n\t\t^self add: anObject; yourself\r\n\t].\r\n\t^anObject isNil ifTrue: [ self ] ifFalse: [ super , anObject ]","(\r\nfunction(self,anObject)\r\nif ((anObject):isAssociation())==true then return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(anObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(self)); end;\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((anObject))),(function()\r\nreturn (self)\r\nend),(function()\r\nreturn (smalltalk:superImplementor(smalltalk.ComposedAssociations,\"_comma\")(self,anObject))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ComposedAssociations,"hashObject",0
,(
function(self)
return ({});
end
)
,"private","hashObject\r\n\t\" Private - Return an empty hash object. \"\r\n\r\n\t^{'' doc'native instantiation'}","(\r\nfunction(self)\r\nreturn ({});\r\nend\r\n)")
smalltalk:bind(smalltalk.ComposedAssociations,"install:value:into:",0
,(
function(self,key,value,jsObject)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (smalltalk:boolean_and_(((self):isObject_(key)),(function()
return ((key):isArray())
end)))==true then if (smalltalk:isObject_equalTo_(((key):size()),1))==true then return ((self):install_value_into_((key):first(),value,jsObject)); end;
smalltalk:if_true_false_(((((key):size()) > 1)),(function()
local target=nil
(function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((jsObject),(key):first(),(function()
return (smalltalk:basic_at_put_((jsObject),(self):toString_((key):first()),(self):hashObject()))
end)))
	target=_s8_value
	return _s8_value
end)();return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):install_value_into_((key):copyFrom_to_(2,(key):size()),value,target))
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:basic_at_put_((jsObject),(self):toString_(key),value))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"private","install: key value: value into: jsObject\r\n\t\" Private - Install a key/value pair into jsObject. \"\r\n\r\n\t((self isObject: key) and: [ key isArray ]) ifTrue: [\r\n\t\tkey size = 1 ifTrue: [ ^self install: key first value: value into: jsObject ].\r\n\t\tkey size > 1 ifTrue: [ | target |\r\n\t\t\ttarget := jsObject basicAt: key first ifAbsent: [\r\n\t\t\t\tjsObject basicAt: (self toString: key first) put: self hashObject\r\n\t\t\t].\r\n\t\t\t^self install: (key copyFrom: 2 to: key size) value: value into: target\r\n\t\t].\r\n\t].\r\n\t^jsObject\r\n\t\tbasicAt: (self toString: key) \"it is IMPORTANT to send #toString here (v8{4.7.0} bug will expose {object} instead of {string} Ale-14/oct/2015)\"\r\n\t\tput: value","(\r\nfunction(self,key,value,jsObject)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (smalltalk:boolean_and_(((self):isObject_(key)),(function()\r\nreturn ((key):isArray())\r\nend)))==true then if (smalltalk:isObject_equalTo_(((key):size()),1))==true then return ((self):install_value_into_((key):first(),value,jsObject)); end;\r\nsmalltalk:if_true_false_(((((key):size()) > 1)),(function()\r\nlocal target=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((jsObject),(key):first(),(function()\r\nreturn (smalltalk:basic_at_put_((jsObject),(self):toString_((key):first()),(self):hashObject()))\r\nend)))\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):install_value_into_((key):copyFrom_to_(2,(key):size()),value,target))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:basic_at_put_((jsObject),(self):toString_(key),value))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.ComposedAssociations,"asJSONObject",0
,(
function(self)
local result=nil
local aValue=nil
(function()
	local _s8_value=((self):hashObject())
	result=_s8_value
	return _s8_value
end)();
(self):do_((function(assoc)
(function()
	local _s8_value=(smalltalk:if_true_false_(((self):isObject_((assoc):value())),(function()
return (((assoc):value()):json())
end),(function()
return ((assoc):value())
end)))
	aValue=_s8_value
	return _s8_value
end)();return ((self):install_value_into_((assoc):key(),aValue,result))
end));
return (result);
end
)
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t| result aValue |\r\n\tresult := self hashObject.\r\n\tself do: [:assoc |\r\n\t\taValue := (self isObject: assoc value)\r\n\t\t\tifTrue: [ assoc value json ]\r\n\t\t\tifFalse: [ assoc value ].\r\n\t\tself install: assoc key value: aValue into: result\r\n\t].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\nlocal aValue=nil\r\n(function()\r\n\tlocal _s8_value=((self):hashObject())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(assoc)\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((self):isObject_((assoc):value())),(function()\r\nreturn (((assoc):value()):json())\r\nend),(function()\r\nreturn ((assoc):value())\r\nend)))\r\n\taValue=_s8_value\r\n\treturn _s8_value\r\nend)();return ((self):install_value_into_((assoc):key(),aValue,result))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.ComposedAssociations,"handle",0
,(
function(self)
return ((self):json());
end
)
,"converting","handle\r\n\t\" Return the receiver as a native object. \"\r\n\r\n\t^self json","(\r\nfunction(self)\r\nreturn ((self):json());\r\nend\r\n)")
smalltalk:bind(smalltalk.ComposedAssociations,"associationAt:ifAbsent:",0
,(
function(self,aKey,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):reverseDo_((function(assoc)
local value=nil
if (smalltalk:isObject_equalTo_(((assoc):key()),aKey))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (assoc)
end
)()
error(_s8Ret_,0)
end)(); end;(function()
	local _s8_value=((assoc):value())
	value=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:boolean_and_(((self):isObject_(value)),(function()
return (smalltalk:is_kindOf_((value),((self)["$klass"])))
end))),(function()
(function()
	local _s8_value=((value):associationAt_ifAbsent_(aKey,(function()
return (nil)
end)))
	value=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((value))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (value)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):evaluate())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"accessing","associationAt: aKey ifAbsent: aBlock\r\n\t\" Return the association at aKey (or the result of evaluating aBlock).\r\n\tNote: the search will introspect in case of composite values.\r\n\t\"\r\n\r\n\tself reverseDo: [:assoc| | value |\r\n\t\tassoc key = aKey ifTrue: [ ^assoc ].\r\n\t\tvalue := assoc value.\r\n\t\t((self isObject: value) and: [value isKindOf: self class]) ifTrue: [\r\n\t\t\tvalue := value associationAt: aKey ifAbsent: [].\r\n\t\t\tvalue notNil ifTrue: [ ^value ].\r\n\t\t]\r\n\t].\r\n\t^aBlock evaluate","(\r\nfunction(self,aKey,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):reverseDo_((function(assoc)\r\nlocal value=nil\r\nif (smalltalk:isObject_equalTo_(((assoc):key()),aKey))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (assoc)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;(function()\r\n\tlocal _s8_value=((assoc):value())\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:boolean_and_(((self):isObject_(value)),(function()\r\nreturn (smalltalk:is_kindOf_((value),((self)[\"$klass\"])))\r\nend))),(function()\r\n(function()\r\n\tlocal _s8_value=((value):associationAt_ifAbsent_(aKey,(function()\r\nreturn (nil)\r\nend)))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((value))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (value)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):evaluate())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.ComposedAssociations,"@","_at"
,(
function(self,aKey)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local assoc=nil
(function()
	local _s8_value=((self):associationAt_ifAbsent_(aKey,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end)))
	assoc=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((assoc):value())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"accessing","@ aKey\r\n\t\" Return the value at aKey (or nil).\r\n\tNote: the search will introspect in case of composite values.\r\n\t\"\r\n\r\n\t| assoc |\r\n\tassoc := self associationAt: aKey ifAbsent: [ ^nil ].\r\n\t^assoc value","(\r\nfunction(self,aKey)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal assoc=nil\r\n(function()\r\n\tlocal _s8_value=((self):associationAt_ifAbsent_(aKey,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tassoc=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((assoc):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.ComposedObjects,",","_comma"
,(
function(self,anObject)
if (smalltalk:isNil_((anObject)))==true then return (self); end;
if (smalltalk:boolean_or_(((anObject):isArray()),(function()
return (smalltalk:responds_to_((anObject),("asArray")))
end)))==true then ((anObject):asArray()):do_((function(each)
return (smalltalk:object_comma_((self),each))
end));
return (self); end;
if (smalltalk:boolean_and_((smalltalk:notNil_((self["@species"]))),(function()
return (smalltalk:booleanNot_((smalltalk:is_kindOf_((anObject),(self["@species"])))))
end)))==true then (self):error_("Invalid object to compose"); end;
(self):add_(anObject);
return (self);
end
)
,"composing",", anObject\r\n\t\" Return the receiver composed with the argument. \"\r\n\r\n\tanObject isNil ifTrue: [ ^self ].\r\n\t(anObject isArray or: [ anObject respondsTo: #asArray ]) ifTrue: [\r\n\t\tanObject asArray do: [:each| self , each ].\r\n\t\t^self\r\n\t].\r\n\r\n\t(species notNil and: [ (anObject isKindOf: species) not ]) ifTrue: [\r\n\t\tself error: 'Invalid object to compose'\r\n\t].\r\n\r\n\tself add: anObject.","(\r\nfunction(self,anObject)\r\nif (smalltalk:isNil_((anObject)))==true then return (self); end;\r\nif (smalltalk:boolean_or_(((anObject):isArray()),(function()\r\nreturn (smalltalk:responds_to_((anObject),(\"asArray\")))\r\nend)))==true then ((anObject):asArray()):do_((function(each)\r\nreturn (smalltalk:object_comma_((self),each))\r\nend));\r\nreturn (self); end;\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((self[\"@species\"]))),(function()\r\nreturn (smalltalk:booleanNot_((smalltalk:is_kindOf_((anObject),(self[\"@species\"])))))\r\nend)))==true then (self):error_(\"Invalid object to compose\"); end;\r\n(self):add_(anObject);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ComposedObjects,"species:",0
,(
function(self,aBehavior)
(function()
	local _s8_value=(aBehavior)
	self["@species"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","species: aBehavior\r\n\t\" Set the species to compose in the receiver. \"\r\n\r\n\tspecies := aBehavior","(\r\nfunction(self,aBehavior)\r\n(function()\r\n\tlocal _s8_value=(aBehavior)\r\n\tself[\"@species\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval["$klass"],"from:to:by:value:",0
,(
function(self,start,__end,step,aBlock)
return (((self):basicNew()):initialize_to_by_value_(start,__end,step,aBlock));
end
)
,"instantiation","from: start to: end by: step value: aBlock\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew initialize: start to: end by: step value: aBlock","(\r\nfunction(self,start,__end,step,aBlock)\r\nreturn (((self):basicNew()):initialize_to_by_value_(start,__end,step,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"initialize:to:by:value:",0
,(
function(self,from,to,increment,aBlock)
(function()
	local _s8_value=(from)
	self["@start"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(to)
	self["@end"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(increment)
	self["@step"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(aBlock)
	self["@value"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"initialize","initialize: from to: to by: increment value: aBlock\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tstart := from.\r\n\tend := to.\r\n\tstep := increment.\r\n\tvalue := aBlock","(\r\nfunction(self,from,to,increment,aBlock)\r\n(function()\r\n\tlocal _s8_value=(from)\r\n\tself[\"@start\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(to)\r\n\tself[\"@end\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(increment)\r\n\tself[\"@step\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(aBlock)\r\n\tself[\"@value\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"start",0
,(
function(self)
return (self["@start"]);
end
)
,"accessing","start\r\n\t\" Return the start of the receiver. \"\r\n\r\n\t^start ","(\r\nfunction(self)\r\nreturn (self[\"@start\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"end","__end"
,(
function(self)
return (self["@end"]);
end
)
,"accessing","end\r\n\t\" Return the end of the receiver. \"\r\n\r\n\t^end ","(\r\nfunction(self)\r\nreturn (self[\"@end\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"step",0
,(
function(self)
return (self["@step"]);
end
)
,"accessing","step\r\n\t\" Return the step of the receiver. \"\r\n\r\n\t^step ","(\r\nfunction(self)\r\nreturn (self[\"@step\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"start:",0
,(
function(self,from)
(function()
	local _s8_value=(from)
	self["@start"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","start: from\r\n\t\" Set the start of the receiver. \"\r\n\r\n\tstart := from ","(\r\nfunction(self,from)\r\n(function()\r\n\tlocal _s8_value=(from)\r\n\tself[\"@start\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"end:",0
,(
function(self,to)
(function()
	local _s8_value=(to)
	self["@end"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","end: to\r\n\t\" Set the end of the receiver. \"\r\n\r\n\tend := to ","(\r\nfunction(self,to)\r\n(function()\r\n\tlocal _s8_value=(to)\r\n\tself[\"@end\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"step:",0
,(
function(self,increment)
(function()
	local _s8_value=(increment)
	self["@step"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","step: increment\r\n\t\" Set the step of the receiver. \"\r\n\r\n\tstep := increment ","(\r\nfunction(self,increment)\r\n(function()\r\n\tlocal _s8_value=(increment)\r\n\tself[\"@step\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"species",0
,(
function(self)
return (smalltalk.Array);
end
)
,"species","species\r\n\t\" Return the species to instantiate objects like the receiver. \"\r\n\r\n\t^Array ","(\r\nfunction(self)\r\nreturn (smalltalk.Array);\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"subclassResponsibility:",0
,(
function(self,aSelector)
return ((self):invalidMessage_(aSelector));
end
)
,"error","subclassResponsibility: aSelector\r\n\t\" Private - The concrete implementation on the receiver is not complete.\r\n\tNote: Unimplemented methods handle invalid messages sent to the receiver.\r\n\t\"\r\n\r\n\t^self invalidMessage: aSelector","(\r\nfunction(self,aSelector)\r\nreturn ((self):invalidMessage_(aSelector));\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"size",0
,(
function(self)
return ((0):max_((((self["@end"]):_minus(self["@start"])):_slash_slash(self["@step"])):_plus(1)));
end
)
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^0 max: end - start // step + 1","(\r\nfunction(self)\r\nreturn ((0):max_((((self[\"@end\"]):_minus(self[\"@start\"])):_slash_slash(self[\"@step\"])):_plus(1)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"consume:",0
,(
function(self,aBlock)
while not ((function()
return ((self):isEmpty())
end))() do (aBlock):value_(self["@start"]);
(function()
	local _s8_value=((self["@start"]):_plus(self["@step"]))
	self["@start"]=_s8_value
	return _s8_value
end)(); end;
return (self);
end
)
,"iterating","consume: aBlock\r\n\t\" Private - Evaluates aBlock while the receiver is not empty. \"\r\n\r\n\t[ self isEmpty ] whileFalse: [\r\n\t\taBlock value: start.\r\n\t\tstart := start + step\r\n\t] ","(\r\nfunction(self,aBlock)\r\nwhile not ((function()\r\nreturn ((self):isEmpty())\r\nend))() do (aBlock):value_(self[\"@start\"]);\r\n(function()\r\n\tlocal _s8_value=((self[\"@start\"]):_plus(self[\"@step\"]))\r\n\tself[\"@start\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"atEnd",0
,(
function(self)
return (smalltalk:isObject_equalTo_(((self):size()),0));
end
)
,"testing","atEnd\r\n\t\" Return true if the receiver is at end. \"\r\n\r\n\t^self size = 0 ","(\r\nfunction(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):size()),0));\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"isEmpty",0
,(
function(self)
return (smalltalk:isObject_equalTo_(((self):size()),0));
end
)
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^self size = 0 ","(\r\nfunction(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):size()),0));\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"notEmpty",0
,(
function(self)
return (smalltalk:booleanNot_(((self):isEmpty())));
end
)
,"testing","notEmpty\r\n\t\" Return true if the receiver is not empty. \"\r\n\r\n\t^self isEmpty not","(\r\nfunction(self)\r\nreturn (smalltalk:booleanNot_(((self):isEmpty())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"reversed",0
,(
function(self)
return (((self)["$klass"]):from_to_by_value_(self["@end"],self["@start"],(self["@step"]):negated(),self["@value"]));
end
)
,"copying","reversed\r\n\t\" Return an Interval with the contents of the receiver in reverse order. \"\r\n\r\n\t^self class from: end to: start by: step negated value: value ","(\r\nfunction(self)\r\nreturn (((self)[\"$klass\"]):from_to_by_value_(self[\"@end\"],self[\"@start\"],(self[\"@step\"]):negated(),self[\"@value\"]));\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"reverseDo:",0
,(
function(self,aBlock)
return (((self):reversed()):do_(aBlock));
end
)
,"enumerating","reverseDo: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver in reverse order of iteration. \"\r\n\r\n\t^self reversed do: aBlock ","(\r\nfunction(self,aBlock)\r\nreturn (((self):reversed()):do_(aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"do:",0
,(
function(self,aBlock)
(self["@start"]):to_by_do_(self["@end"],self["@step"],(function(i)
return ((self["@value"]):value_value_(i,aBlock))
end));
return (self);
end
)
,"enumerating","do: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver. \"\r\n\r\n\tstart to: end by: step do: [:i|\r\n\t\tvalue value: i value: aBlock\r\n\t]","(\r\nfunction(self,aBlock)\r\n(self[\"@start\"]):to_by_do_(self[\"@end\"],self[\"@step\"],(function(i)\r\nreturn ((self[\"@value\"]):value_value_(i,aBlock))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"+","_plus"
,(
function(self,aNumber)
return (((self["@start"]):_plus(aNumber)):to_by_value_((self["@end"]):_plus(aNumber),self["@step"],self["@value"]));
end
)
,"arithmetic","+ aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\t^start + aNumber to: end + aNumber by: step value: value","(\r\nfunction(self,aNumber)\r\nreturn (((self[\"@start\"]):_plus(aNumber)):to_by_value_((self[\"@end\"]):_plus(aNumber),self[\"@step\"],self[\"@value\"]));\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"-","_minus"
,(
function(self,aNumber)
return (((self["@start"]):_minus(aNumber)):to_by_value_((self["@end"]):_minus(aNumber),self["@step"],self["@value"]));
end
)
,"arithmetic","- aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\t^start - aNumber to: end - aNumber by: step value: value","(\r\nfunction(self,aNumber)\r\nreturn (((self[\"@start\"]):_minus(aNumber)):to_by_value_((self[\"@end\"]):_minus(aNumber),self[\"@step\"],self[\"@value\"]));\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"printString",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("("),self["@start"])),"to:")),self["@end"])),")"));
end
)
,"printing","printString\r\n\t\" Return the string representation of the receiver. \"\r\n\r\n\t^$( ,start ,#to: ,end ,$) ","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"(\"),self[\"@start\"])),\"to:\")),self[\"@end\"])),\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"toString",0
,(
function(self)
if (smalltalk:boolean_or_((smalltalk:isNil_((self["@start"]))),(function()
return (smalltalk:isNil_((self["@end"])))
end)))==true then return (smalltalk:superImplementor(smalltalk.Interval,"toString")(self)); end;
return (smalltalk:printString_((self)));
end
)
,"converting","toString\r\n\t\" Return the receiver as a String. \"\r\n\r\n\t(start isNil or: [end isNil]) ifTrue: [ ^super toString ].\r\n\t^self printString ","(\r\nfunction(self)\r\nif (smalltalk:boolean_or_((smalltalk:isNil_((self[\"@start\"]))),(function()\r\nreturn (smalltalk:isNil_((self[\"@end\"])))\r\nend)))==true then return (smalltalk:superImplementor(smalltalk.Interval,\"toString\")(self)); end;\r\nreturn (smalltalk:printString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Interval,"__tostring",0
,(
function(self)
return (smalltalk:toString_((self)));
end
)
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","(\r\nfunction(self)\r\nreturn (smalltalk:toString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set["$klass"],"newContents:",0
,(
function(self,contents)
return (((self):basicNew()):initialize_(contents));
end
)
,"private","newContents: contents\r\n\t\" Return an instance of the receiver initialized from given contents. \"\r\n\r\n\t^self basicNew initialize: contents","(\r\nfunction(self,contents)\r\nreturn (((self):basicNew()):initialize_(contents));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set["$klass"],"basicNew:",0
,(
function(self,size)
return ((self):new());
end
)
,"instantiation","basicNew: size\r\n\t\" Return an instance of the receiver of specified size. \"\r\n\r\n\t^self new","(\r\nfunction(self,size)\r\nreturn ((self):new());\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"initialize",0
,(
function(self)
smalltalk:superImplementor(smalltalk.Set,"initialize")(self);
(function()
	local _s8_value=(smalltalk:newArray({}))
	self["@contents"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"initialize","initialize\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsuper initialize.\r\n\tcontents := #().","(\r\nfunction(self)\r\nsmalltalk:superImplementor(smalltalk.Set,\"initialize\")(self);\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tself[\"@contents\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"initialize:",0
,(
function(self,initializer)
(function()
	local _s8_value=(initializer)
	self["@contents"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"initialize","initialize: initializer\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tcontents := initializer.","(\r\nfunction(self,initializer)\r\n(function()\r\n\tlocal _s8_value=(initializer)\r\n\tself[\"@contents\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"size",0
,(
function(self)
return ((self["@contents"]):size());
end
)
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^contents size","(\r\nfunction(self)\r\nreturn ((self[\"@contents\"]):size());\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"basicAdd:",0
,(
function(self,anObject)
(self["@contents"]):add_(anObject);
return (anObject);
end
)
,"private","basicAdd: anObject\r\n\t\" Private - Add anObject to the receiver's contents. \"\r\n\r\n\tcontents add: anObject.\r\n\t^anObject","(\r\nfunction(self,anObject)\r\n(self[\"@contents\"]):add_(anObject);\r\nreturn (anObject);\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"includes:",0
,(
function(self,anObject)
return ((self["@contents"]):includes_(anObject));
end
)
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t^contents includes: anObject","(\r\nfunction(self,anObject)\r\nreturn ((self[\"@contents\"]):includes_(anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"add:",0
,(
function(self,anObject)
if ((self):includes_(anObject))==true then return (anObject); end;
return ((self):basicAdd_(anObject));
end
)
,"adding","add: anObject\r\n\t\" Add anObject to the receiver. \"\r\n\r\n\t(self includes: anObject) ifTrue: [ ^anObject ].\r\n\t^self basicAdd: anObject","(\r\nfunction(self,anObject)\r\nif ((self):includes_(anObject))==true then return (anObject); end;\r\nreturn ((self):basicAdd_(anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"remove:ifAbsent:",0
,(
function(self,anObject,aBlock)
return ((self["@contents"]):remove_ifAbsent_(anObject,aBlock));
end
)
,"removing","remove: anObject ifAbsent: aBlock\r\n\t\" Remove anObject from the receiver.\r\n\tReturn the result of evaluating aBlock if anObject is not in the receiver.\r\n\t\"\r\n\r\n\t^contents remove: anObject ifAbsent: aBlock","(\r\nfunction(self,anObject,aBlock)\r\nreturn ((self[\"@contents\"]):remove_ifAbsent_(anObject,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"copyFrom:to:",0
,(
function(self,anIndex,anotherIndex)
return ((self):shouldNotImplement_("copyFrom:to:"));
end
)
,"copying","copyFrom: anIndex to: anotherIndex\r\n\t\" Return a copy of the receiver from anIndex to anotherIndex. \"\r\n\r\n\t^self shouldNotImplement: #copyFrom:to:","(\r\nfunction(self,anIndex,anotherIndex)\r\nreturn ((self):shouldNotImplement_(\"copyFrom:to:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"asNative:",0
,(
function(self,lang)
local send=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((lang),"lua")),(function()
return (":")
end),(function()
return (".")
end)))
	send=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),((self)["$klass"]):name())),send)),"newContents_(")),(self["@contents"]):asNative_(lang))),")"));
end
)
,"converting","asNative: lang\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t| send |\r\n\tsend := lang = #lua ifTrue: [ $: ] ifFalse: [ $. ].\r\n\t^'smalltalk.' ,self class name\r\n\t\t,send ,'newContents_('\r\n\t\t,(contents asNative: lang)\r\n\t\t,')'","(\r\nfunction(self,lang)\r\nlocal send=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((lang),\"lua\")),(function()\r\nreturn (\":\")\r\nend),(function()\r\nreturn (\".\")\r\nend)))\r\n\tsend=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),((self)[\"$klass\"]):name())),send)),\"newContents_(\")),(self[\"@contents\"]):asNative_(lang))),\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"=","_eq"
,(
function(self,aSet)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if not ((smalltalk:isObject_equalTo_(((self)["$klass"]),(aSet)["$klass"])))==true then return (false); end;
if not ((smalltalk:isObject_equalTo_(((self):size()),(aSet):size())))==true then return (false); end;
(self):do_((function(each)
return (smalltalk:if_true_false_(((aSet):includes_(each)),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"comparing","= aSet\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\tself class = aSet class ifFalse: [^false].\r\n\tself size = aSet size ifFalse: [^false].\r\n\tself do: [:each | (aSet includes: each) ifFalse: [^false] ].\r\n\t^true","(\r\nfunction(self,aSet)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif not ((smalltalk:isObject_equalTo_(((self)[\"$klass\"]),(aSet)[\"$klass\"])))==true then return (false); end;\r\nif not ((smalltalk:isObject_equalTo_(((self):size()),(aSet):size())))==true then return (false); end;\r\n(self):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((aSet):includes_(each)),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"asArray",0
,(
function(self)
return ((self["@contents"]):copy());
end
)
,"converting","asArray\r\n\t\" Return an array with the contents of the receiver. \"\r\n\r\n\t^contents copy","(\r\nfunction(self)\r\nreturn ((self[\"@contents\"]):copy());\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"toString",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((((self)["$klass"]):name())," withAll: ")),smalltalk:printString_(((self):asArray()))));
end
)
,"converting","toString\r\n\t\" Convert the receiver to a String. \"\r\n\r\n\t^self class name,' withAll: ',self asArray printString","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((((self)[\"$klass\"]):name()),\" withAll: \")),smalltalk:printString_(((self):asArray()))));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"sorted",0
,(
function(self)
return (((self):asArray()):sort());
end
)
,"sorting","sorted\r\n\t\" Return the contents of the receiver sorted. \"\r\n\r\n\t^self asArray sort","(\r\nfunction(self)\r\nreturn (((self):asArray()):sort());\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"sorted:",0
,(
function(self,aBlock)
return (((self):asArray()):sort_(aBlock));
end
)
,"sorting","sorted: aBlock\r\n\t\" Return a sorted copy of the receiver. \"\r\n\r\n\t^self asArray sort: aBlock","(\r\nfunction(self,aBlock)\r\nreturn (((self):asArray()):sort_(aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"do:",0
,(
function(self,aBlock)
return ((self["@contents"]):do_(aBlock));
end
)
,"enumerating","do: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver. \"\r\n\r\n\t^contents do: aBlock","(\r\nfunction(self,aBlock)\r\nreturn ((self[\"@contents\"]):do_(aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"detect:ifNone:",0
,(
function(self,aBlock,anotherBlock)
return ((self["@contents"]):detect_ifNone_(aBlock,anotherBlock));
end
)
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. \"\r\n\r\n\t^contents detect: aBlock ifNone: anotherBlock","(\r\nfunction(self,aBlock,anotherBlock)\r\nreturn ((self[\"@contents\"]):detect_ifNone_(aBlock,anotherBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"reverseDo:",0
,(
function(self,aBlock)
return ((self["@contents"]):reverseDo_(aBlock));
end
)
,"enumerating","reverseDo: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver in reverse order of iteration. \"\r\n\r\n\t^contents reverseDo: aBlock","(\r\nfunction(self,aBlock)\r\nreturn ((self[\"@contents\"]):reverseDo_(aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"collect:",0
,(
function(self,aBlock)
return (((self)["$klass"]):withAll_((self["@contents"]):collect_(aBlock)));
end
)
,"enumerating","collect: aBlock\r\n\t\" Return a collection with the result of evaluating aBlock with the contents of the receiver. \"\r\n\r\n\t^self class withAll: (contents collect: aBlock)","(\r\nfunction(self,aBlock)\r\nreturn (((self)[\"$klass\"]):withAll_((self[\"@contents\"]):collect_(aBlock)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"do:separatedBy:",0
,(
function(self,aBlock,anotherBlock)
return ((self["@contents"]):do_separatedBy_(aBlock,anotherBlock));
end
)
,"enumerating","do: aBlock separatedBy: anotherBlock\r\n\t\" Evaluate aBlock for contents of the receiver evaluating anotherBlock inbetween aBlock evaluations. \"\r\n\r\n\t^contents do: aBlock separatedBy: anotherBlock","(\r\nfunction(self,aBlock,anotherBlock)\r\nreturn ((self[\"@contents\"]):do_separatedBy_(aBlock,anotherBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"inject:into:",0
,(
function(self,anObject,aBlock)
return ((self["@contents"]):inject_into_(anObject,aBlock));
end
)
,"enumerating","inject: anObject into: aBlock\r\n\t\" Evaluate aBlock for result of previous evaluation and contents of the receiver.\r\n\tOn first evaluation anObject is used as first argument to evaluate aBlock.\r\n\t\"\r\n\r\n\t^contents inject: anObject into: aBlock","(\r\nfunction(self,anObject,aBlock)\r\nreturn ((self[\"@contents\"]):inject_into_(anObject,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"select:",0
,(
function(self,aBlock)
return (((self)["$klass"]):withAll_((self["@contents"]):select_(aBlock)));
end
)
,"enumerating","select: aBlock\r\n\t\" Return a copy of the receiver with elements wich evaluates aBlock to true. \"\r\n\r\n\t^self class withAll: (contents select: aBlock)","(\r\nfunction(self,aBlock)\r\nreturn (((self)[\"$klass\"]):withAll_((self[\"@contents\"]):select_(aBlock)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"reject:",0
,(
function(self,aBlock)
return (((self)["$klass"]):withAll_((self["@contents"]):reject_(aBlock)));
end
)
,"enumerating","reject: aBlock\r\n\t\" Return the contents of the receiver wich evaluates aBlock to false. \"\r\n\r\n\t^self class withAll: (contents reject: aBlock)","(\r\nfunction(self,aBlock)\r\nreturn (((self)[\"$klass\"]):withAll_((self[\"@contents\"]):reject_(aBlock)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"reversed",0
,(
function(self)
return ((self["@contents"]):reversed());
end
)
,"copying","reversed\r\n\t\" Return an array with the contents of the receiver in reverse order. \"\r\n\r\n\t^contents reversed","(\r\nfunction(self)\r\nreturn ((self[\"@contents\"]):reversed());\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"notEmpty",0
,(
function(self)
return ((self["@contents"]):notEmpty());
end
)
,"testing","notEmpty\r\n\t\" Return true if the receiver is not empty. \"\r\n\r\n\t^contents notEmpty","(\r\nfunction(self)\r\nreturn ((self[\"@contents\"]):notEmpty());\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"isEmpty",0
,(
function(self)
return ((self["@contents"]):isEmpty());
end
)
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^contents isEmpty","(\r\nfunction(self)\r\nreturn ((self[\"@contents\"]):isEmpty());\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"occurrencesOf:",0
,(
function(self,anObject)
return (smalltalk:if_true_false_(((self):includes_(anObject)),(function()
return (1)
end),(function()
return (0)
end)));
end
)
,"counting","occurrencesOf: anObject\r\n\t\" Return the occurrences of anObject in the receiver. \"\r\n\r\n\t^(self includes: anObject) ifTrue: [ 1 ] ifFalse: [ 0 ]","(\r\nfunction(self,anObject)\r\nreturn (smalltalk:if_true_false_(((self):includes_(anObject)),(function()\r\nreturn (1)\r\nend),(function()\r\nreturn (0)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"asSet",0
,(
function(self)
return (self);
end
)
,"converting","asSet\r\n\t\" Return the receiver contents in a Set. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"shallowCopy",0
,(
function(self)
return (((self):species()):newContents_((self["@contents"]):copy()));
end
)
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self species newContents: contents copy","(\r\nfunction(self)\r\nreturn (((self):species()):newContents_((self[\"@contents\"]):copy()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"deepCopy",0
,(
function(self)
return (((self):species()):newContents_((self["@contents"]):deepCopy()));
end
)
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self species newContents: contents deepCopy","(\r\nfunction(self)\r\nreturn (((self):species()):newContents_((self[\"@contents\"]):deepCopy()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"asLua",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),((self)["$klass"]):name())),":newContents_(")),(self["@contents"]):asLua())),")"));
end
)
,"Lua-lua","asLua\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t^'smalltalk.' ,self class name\r\n\t, ':newContents_('\r\n\t\t, contents asLua\r\n\t,')'","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),((self)[\"$klass\"]):name())),\":newContents_(\")),(self[\"@contents\"]):asLua())),\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Set,"__tostring",0
,(
function(self)
return (smalltalk:toString_((self)));
end
)
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","(\r\nfunction(self)\r\nreturn (smalltalk:toString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.HashedSet,"initialize",0
,(
function(self)
smalltalk:superImplementor(smalltalk.HashedSet,"initialize")(self);
(self):initializeHash();
return (self);
end
)
,"initialize","initialize\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsuper initialize.\r\n\tself initializeHash.","(\r\nfunction(self)\r\nsmalltalk:superImplementor(smalltalk.HashedSet,\"initialize\")(self);\r\n(self):initializeHash();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.HashedSet,"initialize:",0
,(
function(self,initializer)
(function()
	local _s8_value=(initializer)
	self["@contents"]=_s8_value
	return _s8_value
end)();
(self):rehash();
return (self);
end
)
,"initialize","initialize: initializer\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tcontents := initializer.\r\n\tself rehash.","(\r\nfunction(self,initializer)\r\n(function()\r\n\tlocal _s8_value=(initializer)\r\n\tself[\"@contents\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):rehash();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.HashedSet,"initializeHash",0
,(
function(self)
(function()
	local _s8_value=({})
	self["@hash"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"private","initializeHash\r\n\t\" Private - Initialize the hash of the receiver. \"\r\n\r\n\thash := {'' doc'get native sentinel'}.","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=({})\r\n\tself[\"@hash\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.HashedSet,"rehash",0
,(
function(self)
(self):initializeHash();
(self["@contents"]):do_((function(each)
return ((self):privateAdd_((self):wrap_(each)))
end));
return (self);
end
)
,"private","rehash\r\n\t\" Private - Rehash the receiver contents. \"\r\n\r\n\tself initializeHash.\r\n\tcontents do: [:each|\r\n\t\tself privateAdd: (self wrap: each)\r\n\t]","(\r\nfunction(self)\r\n(self):initializeHash();\r\n(self[\"@contents\"]):do_((function(each)\r\nreturn ((self):privateAdd_((self):wrap_(each)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.HashedSet,"asHashedSet",0
,(
function(self)
return (self);
end
)
,"converting","asHashedSet\r\n\t\" Return the receiver contents in a HashedSet. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.HashedSet,"indexOf:ifAbsent:",0
,(
function(self,anObject,aBlock)
if not (((self):includes_(anObject)))==true then return ((aBlock):value()); end;
return ((self["@contents"]):indexOf_ifAbsent_(anObject,aBlock));
end
)
,"private","indexOf: anObject ifAbsent: aBlock\r\n\t\" Return the position of anObject in the receiver, or the result of evaluating aBlock. \"\r\n\r\n\t(self includes: anObject) ifFalse: [ ^aBlock value ].\r\n\t^contents indexOf: anObject ifAbsent: aBlock","(\r\nfunction(self,anObject,aBlock)\r\nif not (((self):includes_(anObject)))==true then return ((aBlock):value()); end;\r\nreturn ((self[\"@contents\"]):indexOf_ifAbsent_(anObject,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.HashedSet,"withIndexDo:",0
,(
function(self,aBlock)
return ((self["@contents"]):withIndexDo_(aBlock));
end
)
,"private","withIndexDo: aBlock\r\n\t\" Evaluate aBlock with all the index positions in the receiver. \"\r\n\r\n\t^contents withIndexDo: aBlock","(\r\nfunction(self,aBlock)\r\nreturn ((self[\"@contents\"]):withIndexDo_(aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.HashedSet,"removeIndex:",0
,(
function(self,index)
return ((self):remove_((self["@contents"]):at_(index)));
end
)
,"private","removeIndex: index\r\n\t\" Remove the element at index. \"\r\n\r\n\t^self remove: (contents at: index)","(\r\nfunction(self,index)\r\nreturn ((self):remove_((self[\"@contents\"]):at_(index)));\r\nend\r\n)")
smalltalk:bind(smalltalk.HashedSet,"privateAdd:",0
,(
function(self,cookie)

smalltalk:basic_at_put_((self["@hash"]),cookie,cookie);
return (self);
end
)
,"private","privateAdd: cookie\r\n\t\" Private - Register a cookie onto the receiver's hash. \"\r\n\r\n\t{'self'}.\r\n\thash basicAt: cookie put: cookie","(\r\nfunction(self,cookie)\r\n\r\nsmalltalk:basic_at_put_((self[\"@hash\"]),cookie,cookie);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.HashedSet,"privateRemove:",0
,(
function(self,cookie)
self["@hash"][cookie] = nil;
return (self);
end
)
,"private","privateRemove: cookie\r\n\t\" Private - Remove a cookie in the receiver's hash. \"\r\n\r\n\t{'' doc'native remotion'}","(\r\nfunction(self,cookie)\r\nself[\"@hash\"][cookie] = nil;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.HashedSet,"includes:",0
,(
function(self,anObject)
local cookie=nil
(function()
	local _s8_value=((self):wrap_(anObject))
	cookie=_s8_value
	return _s8_value
end)();
return ((self["@hash"][cookie])~=nil);
end
)
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t| cookie |\r\n\tcookie := self wrap: anObject.\r\n\t^{'' doc'testing'}","(\r\nfunction(self,anObject)\r\nlocal cookie=nil\r\n(function()\r\n\tlocal _s8_value=((self):wrap_(anObject))\r\n\tcookie=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self[\"@hash\"][cookie])~=nil);\r\nend\r\n)")
smalltalk:bind(smalltalk.HashedSet,"add:",0
,(
function(self,anObject)
if ((self):includes_(anObject))==true then return (anObject); end;
(self):privateAdd_((self):wrap_(anObject));
return ((self):basicAdd_(anObject));
end
)
,"adding","add: anObject\r\n\t\" Add anObject to the receiver. \"\r\n\r\n\t(self includes: anObject) ifTrue: [ ^anObject ].\r\n\tself privateAdd: (self wrap: anObject).\r\n\t^self basicAdd: anObject","(\r\nfunction(self,anObject)\r\nif ((self):includes_(anObject))==true then return (anObject); end;\r\n(self):privateAdd_((self):wrap_(anObject));\r\nreturn ((self):basicAdd_(anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.HashedSet,"remove:ifAbsent:",0
,(
function(self,anObject,aBlock)
if not (((self):includes_(anObject)))==true then return ((aBlock):value()); end;
(self["@contents"]):remove_ifAbsent_(anObject,(function()
return (nil)
end));
(self):privateRemove_((self):wrap_(anObject));
return (anObject);
end
)
,"removing","remove: anObject ifAbsent: aBlock\r\n\t\" Remove anObject from the receiver.\r\n\tReturn the result of evaluating aBlock if anObject is not in the receiver.\r\n\t\"\r\n\r\n\t(self includes: anObject) ifFalse: [ ^aBlock value ].\r\n\tcontents remove: anObject ifAbsent: [ ].\r\n\tself privateRemove: (self wrap: anObject).\r\n\t^anObject","(\r\nfunction(self,anObject,aBlock)\r\nif not (((self):includes_(anObject)))==true then return ((aBlock):value()); end;\r\n(self[\"@contents\"]):remove_ifAbsent_(anObject,(function()\r\nreturn (nil)\r\nend));\r\n(self):privateRemove_((self):wrap_(anObject));\r\nreturn (anObject);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection["$klass"],"basicNew:",0
,(
function(self,size)
return ((self):new());
end
)
,"instantiation","basicNew: size\r\n\t\" Return an instance of the receiver of specified size. \"\r\n\r\n\t^self new","(\r\nfunction(self,size)\r\nreturn ((self):new());\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection["$klass"],"@","_at"
,(
function(self,jsObject)
local result=nil
local parts=nil
if (smalltalk:isNil_((jsObject)))==true then return (nil); end;
(function()
	local _s8_value=((self):new())
	result=_s8_value
	return _s8_value
end)();

	parts = smalltalk.Array:new()
	for k,_ in pairs(jsObject) do parts:add_(k) end;
(parts):do_((function(key)
return ((result):at_put_(key,(jsObject)[key]))
end));
return (result);
end
)
,"instantiation","@ jsObject\r\n\t\" Return an instance of the receiver with the properties owned by jsObject (or nil). \"\r\n\r\n\t| result parts |\r\n\tjsObject isNil ifTrue: [ ^nil ].\r\n\tresult := self new.\r\n\t{'' doc'native accessing'}.\r\n\tparts do: [:key|\r\n\t\tresult at: key put: (jsObject basicAt: key)\r\n\t].\r\n\t^result","(\r\nfunction(self,jsObject)\r\nlocal result=nil\r\nlocal parts=nil\r\nif (smalltalk:isNil_((jsObject)))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((self):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\n\tparts = smalltalk.Array:new()\r\n\tfor k,_ in pairs(jsObject) do parts:add_(k) end;\r\n(parts):do_((function(key)\r\nreturn ((result):at_put_(key,(jsObject)[key]))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection["$klass"],"fromTuples:",0
,(
function(self,tuples)
local result=nil
(function()
	local _s8_value=((self):new())
	result=_s8_value
	return _s8_value
end)();
(tuples):do_((function(tuple)
return ((result):at_put_((tuple):first(),(tuple):last()))
end));
return (result);
end
)
,"instantiation","fromTuples: tuples\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self new.\r\n\ttuples do: [:tuple| result at: tuple first put: tuple last ].\r\n\t^result","(\r\nfunction(self,tuples)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(tuples):do_((function(tuple)\r\nreturn ((result):at_put_((tuple):first(),(tuple):last()))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,",","_comma"
,(
function(self,aCollection)
return ((self):shouldNotImplement_(","));
end
)
,"copying",", aCollection\r\n\t\" Return a copy of the receiver with all contents of aCollection. \"\r\n\r\n\t^self shouldNotImplement: #,","(\r\nfunction(self,aCollection)\r\nreturn ((self):shouldNotImplement_(\",\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"=","_eq"
,(
function(self,anObject)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if not ((smalltalk:isObject_equalTo_(((self)["$klass"]),(anObject)["$klass"])))==true then return (false); end;
if not ((smalltalk:isObject_equalTo_(((self):size()),(anObject):size())))==true then return (false); end;
(self):keysAndValuesDo_((function(key,value)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((anObject):at_ifAbsent_(key,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end))),value)),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"comparing","= anObject\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\tself class = anObject class ifFalse: [^false].\r\n\tself size = anObject size ifFalse: [^false].\r\n\tself keysAndValuesDo: [:key :value |\r\n\t\t(anObject at: key ifAbsent: [^false])\r\n\t\t\t= value ifFalse: [^false]\r\n\t].\r\n\t^true","(\r\nfunction(self,anObject)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif not ((smalltalk:isObject_equalTo_(((self)[\"$klass\"]),(anObject)[\"$klass\"])))==true then return (false); end;\r\nif not ((smalltalk:isObject_equalTo_(((self):size()),(anObject):size())))==true then return (false); end;\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((anObject):at_ifAbsent_(key,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))),value)),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"add:",0
,(
function(self,anAssociation)
(self):at_put_((anAssociation):key(),(anAssociation):value());
return (anAssociation);
end
)
,"adding","add: anAssociation\r\n\t\" Bind anAssociation to the receiver. \"\r\n\r\n\tself at: anAssociation key put: anAssociation value.\r\n\t^anAssociation","(\r\nfunction(self,anAssociation)\r\n(self):at_put_((anAssociation):key(),(anAssociation):value());\r\nreturn (anAssociation);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"addAll:",0
,(
function(self,aKeyedCollection)
smalltalk:superImplementor(smalltalk.KeyedCollection,"addAll_")(self,(aKeyedCollection):associations());
return (aKeyedCollection);
end
)
,"adding","addAll: aKeyedCollection\r\n\t\" Bind all associations in aKeyedCollection to the receiver. \"\r\n\r\n\tsuper addAll: aKeyedCollection associations.\r\n\t^aKeyedCollection","(\r\nfunction(self,aKeyedCollection)\r\nsmalltalk:superImplementor(smalltalk.KeyedCollection,\"addAll_\")(self,(aKeyedCollection):associations());\r\nreturn (aKeyedCollection);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"newHash",0
,(
function(self)
return ({});
end
)
,"private","newHash\r\n\t\" Private - Return a new hash object. \"\r\n\r\n\t^{'' doc'native instantiation'}","(\r\nfunction(self)\r\nreturn ({});\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"asJSONObject",0
,(
function(self)
local result=nil
local value=nil
(function()
	local _s8_value=((self):newHash())
	result=_s8_value
	return _s8_value
end)();
(self):keysAndValuesDo_((function(key,aValue)
(function()
	local _s8_value=(smalltalk:if_true_false_(((self):isObject_(aValue)),(function()
return ((aValue):asJSONObject())
end),(function()
return (aValue)
end)))
	value=_s8_value
	return _s8_value
end)();return (smalltalk:basic_at_put_((result),key,value))
end));
return (result);
end
)
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t| result value |\r\n\tresult := self newHash.\r\n\tself keysAndValuesDo: [:key :aValue |\r\n\t\tvalue := (self isObject: aValue)\r\n\t\t\tifTrue: [ aValue asJSONObject ]\r\n\t\t\tifFalse: [ aValue ].\r\n\t\tresult basicAt: key put: value\r\n\t].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\nlocal value=nil\r\n(function()\r\n\tlocal _s8_value=((self):newHash())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):keysAndValuesDo_((function(key,aValue)\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((self):isObject_(aValue)),(function()\r\nreturn ((aValue):asJSONObject())\r\nend),(function()\r\nreturn (aValue)\r\nend)))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:basic_at_put_((result),key,value))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"associations",0
,(
function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(self):associationsDo_((function(each)
return ((result):add_(each))
end));
return (result);
end
)
,"accessing","associations\r\n\t\" Return the associations of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := Array new.\r\n\tself associationsDo: [:each| result add: each ].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):associationsDo_((function(each)\r\nreturn ((result):add_(each))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"associationsDo:",0
,(
function(self,aBlock)
(self):keysAndValuesDo_((function(key,value)
return ((aBlock):value_((smalltalk.Association):key_value_(key,value)))
end));
return (self);
end
)
,"enumerating","associationsDo: aBlock\r\n\t\" Evaluate aBlock for all the receiver's associations. \"\r\n\r\n\tself keysAndValuesDo: [:key :value|\r\n\t\taBlock value: (Association key: key value: value)\r\n\t].","(\r\nfunction(self,aBlock)\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn ((aBlock):value_((smalltalk.Association):key_value_(key,value)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"at:",0
,(
function(self,aKey)
return ((self):at_ifAbsent_(aKey,(function()
return ((self):objectNotFoundAt_(aKey))
end)));
end
)
,"accessing","at: aKey\r\n\t\" Return the value at aKey.\r\n\tSignal an error if the key is not present.\r\n\t\"\r\n\r\n\t^self at: aKey ifAbsent: [ self objectNotFoundAt: aKey ]","(\r\nfunction(self,aKey)\r\nreturn ((self):at_ifAbsent_(aKey,(function()\r\nreturn ((self):objectNotFoundAt_(aKey))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"at:ifAbsent:",0
,(
function(self,aKey,aBlock)
return ((self):implementedBySubclass_("at:ifAbsent:"));
end
)
,"accessing","at: aKey ifAbsent: aBlock\r\n\t\" Return the value at aKey or the result of evaluating aBlock. \"\r\n\r\n\t^self implementedBySubclass: #at:ifAbsent:","(\r\nfunction(self,aKey,aBlock)\r\nreturn ((self):implementedBySubclass_(\"at:ifAbsent:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"values",0
,(
function(self)
return ((self):implementedBySubclass_("values"));
end
)
,"accessing","values\r\n\t\" Return the values of the receiver. \"\r\n\r\n\t^self implementedBySubclass: #values","(\r\nfunction(self)\r\nreturn ((self):implementedBySubclass_(\"values\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"at:ifAbsentPut:",0
,(
function(self,aKey,aBlock)
return ((self):at_ifAbsent_(aKey,(function()
return ((self):at_put_(aKey,(aBlock):value()))
end)));
end
)
,"accessing","at: aKey ifAbsentPut: aBlock\r\n\t\" Return the value at aKey, or add the result of evaluating aBlock to the receiver if it is absent. \"\r\n\r\n\t^self at: aKey ifAbsent: [ self at: aKey put: aBlock value ]","(\r\nfunction(self,aKey,aBlock)\r\nreturn ((self):at_ifAbsent_(aKey,(function()\r\nreturn ((self):at_put_(aKey,(aBlock):value()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"at:put:",0
,(
function(self,aKey,aValue)
return ((self):implementedBySubclass_("at:put:"));
end
)
,"accessing","at: aKey put: aValue\r\n\t\" Set the value at aKey of the receiver. \"\r\n\r\n\t^self implementedBySubclass: #at:put:","(\r\nfunction(self,aKey,aValue)\r\nreturn ((self):implementedBySubclass_(\"at:put:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"detect:ifNone:",0
,(
function(self,aBlock,anotherBlock)
return ((self):implementedBySubclass_("detect:ifNone:"));
end
)
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Detect the value who matches aBlock.\r\n\tReturn the result of evaluating aBlock if no value matches detection block.\r\n\t\"\r\n\r\n\t^self implementedBySubclass: #detect:ifNone:","(\r\nfunction(self,aBlock,anotherBlock)\r\nreturn ((self):implementedBySubclass_(\"detect:ifNone:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"do:",0
,(
function(self,aBlock)
return ((self):implementedBySubclass_("do:"));
end
)
,"enumerating","do: aBlock\r\n\t\" Evaluates aBlock for all values in the receiver. \"\r\n\r\n\t^self implementedBySubclass: #do:","(\r\nfunction(self,aBlock)\r\nreturn ((self):implementedBySubclass_(\"do:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"includes:",0
,(
function(self,anObject)
return ((self):implementedBySubclass_("includes:"));
end
)
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t^self implementedBySubclass: #includes:","(\r\nfunction(self,anObject)\r\nreturn ((self):implementedBySubclass_(\"includes:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"keyForValue:ifAbsent:",0
,(
function(self,anObject,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):keysAndValuesDo_((function(key,value)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((anObject),value)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (key)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):value())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"accessing","keyForValue: anObject ifAbsent: aBlock\r\n\t\" Return the key in the receiver for value anObject, or the result of evaluating aBlock. \"\r\n\r\n\tself keysAndValuesDo: [:key :value| anObject = value ifTrue: [ ^key ] ].\r\n\t^aBlock value","(\r\nfunction(self,anObject,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((anObject),value)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (key)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"keys",0
,(
function(self)
return ((self):implementedBySubclass_("keys"));
end
)
,"accessing","keys\r\n\t\" Return the keys of the receiver. \"\r\n\r\n\t^self implementedBySubclass: #keys","(\r\nfunction(self)\r\nreturn ((self):implementedBySubclass_(\"keys\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"keysAndValuesDo:",0
,(
function(self,aBlock)
return ((self):implementedBySubclass_("keysAndValuesDo:"));
end
)
,"enumerating","keysAndValuesDo: aBlock\r\n\t\" Evaluate aBlock for key/value pairs of the receiver. \"\r\n\r\n\t^self implementedBySubclass: #keysAndValuesDo:","(\r\nfunction(self,aBlock)\r\nreturn ((self):implementedBySubclass_(\"keysAndValuesDo:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"keysDo:",0
,(
function(self,aBlock)
return ((self):implementedBySubclass_("keysDo:"));
end
)
,"enumerating","keysDo: aBlock\r\n\t\" Evaluate aBlock with the keys of the receiver. \"\r\n\r\n\t^self implementedBySubclass: #keysDo:","(\r\nfunction(self,aBlock)\r\nreturn ((self):implementedBySubclass_(\"keysDo:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"includesKey:",0
,(
function(self,aKey)
return ((self):implementedBySubclass_("includesKey:"));
end
)
,"testing","includesKey: aKey\r\n\t\" Return true if the receiver's keys include aKey. \"\r\n\r\n\t^self implementedBySubclass: #includesKey:","(\r\nfunction(self,aKey)\r\nreturn ((self):implementedBySubclass_(\"includesKey:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"removeKey:ifAbsent:",0
,(
function(self,aKey,aBlock)
return ((self):implementedBySubclass_("removeKey:ifAbsent:"));
end
)
,"removing","removeKey: aKey ifAbsent: aBlock\r\n\t\" Remove the binding at aKey. \"\r\n\r\n\t^self implementedBySubclass: #removeKey:ifAbsent:","(\r\nfunction(self,aKey,aBlock)\r\nreturn ((self):implementedBySubclass_(\"removeKey:ifAbsent:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"removeKeys:",0
,(
function(self,aCollection)
(aCollection):do_((function(each)
return ((self):removeKey_ifAbsent_(each,(function()
return (nil)
end)))
end));
return (self);
end
)
,"removing","removeKeys: aCollection\r\n\t\" Remove aCollection of keys in the receiver. \"\r\n\r\n\taCollection do: [:each| self removeKey: each ifAbsent: [] ]","(\r\nfunction(self,aCollection)\r\n(aCollection):do_((function(each)\r\nreturn ((self):removeKey_ifAbsent_(each,(function()\r\nreturn (nil)\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"removeAll",0
,(
function(self)
(self):initialize();
return (self);
end
)
,"removing","removeAll\r\n\t\" Remove all elements in the receiver. \"\r\n\r\n\tself initialize","(\r\nfunction(self)\r\n(self):initialize();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"isEmpty",0
,(
function(self)
return (smalltalk:isObject_equalTo_(((self):size()),0));
end
)
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^self size = 0","(\r\nfunction(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):size()),0));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"at:ifPresent:",0
,(
function(self,aKey,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local aValue=nil
(function()
	local _s8_value=((self):at_ifAbsent_(aKey,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end)))
	aValue=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):value_(aValue))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"accessing","at: aKey ifPresent: aBlock\r\n\t\" Return the result of evaluating aBlock if there is a value at aKey (or nil). \"\r\n\r\n\t| aValue |\r\n\taValue := self at: aKey ifAbsent: [ ^nil ].\r\n\t^aBlock value: aValue","(\r\nfunction(self,aKey,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal aValue=nil\r\n(function()\r\n\tlocal _s8_value=((self):at_ifAbsent_(aKey,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\taValue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):value_(aValue))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"at:ifPresent:ifAbsent:",0
,(
function(self,aKey,aBlock,anotherBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local aValue=nil
(function()
	local _s8_value=((self):at_ifAbsent_(aKey,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((anotherBlock):value())
end
)()
error(_s8Ret_,0)
end)())
end)))
	aValue=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):value_(aValue))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"accessing","at: aKey ifPresent: aBlock ifAbsent: anotherBlock\r\n\t\" Return the result of evaluating aBlock if there is a value at aKey (or the result of evaluating anotherBlock). \"\r\n\r\n\t| aValue |\r\n\taValue := self at: aKey ifAbsent: [ ^anotherBlock value ].\r\n\t^aBlock value: aValue","(\r\nfunction(self,aKey,aBlock,anotherBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal aValue=nil\r\n(function()\r\n\tlocal _s8_value=((self):at_ifAbsent_(aKey,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((anotherBlock):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\taValue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):value_(aValue))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"collect:",0
,(
function(self,aBlock)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(self):keysAndValuesDo_((function(key,value)
return ((result):at_put_(key,(aBlock):value_(value)))
end));
return (result);
end
)
,"enumerating","collect: aBlock\r\n\t\" Return aKeyedCollection with keys and result of evaluating aBlock with value. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tself keysAndValuesDo: [:key :value |\r\n\t\tresult at: key put: (aBlock value: value)\r\n\t].\r\n\t^result","(\r\nfunction(self,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn ((result):at_put_(key,(aBlock):value_(value)))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"select:",0
,(
function(self,aBlock)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(self):keysAndValuesDo_((function(key,value)
return (smalltalk:if_true_false_(((aBlock):value_(value)),(function()
return ((result):at_put_(key,value))
end),nil))
end));
return (result);
end
)
,"enumerating","select: aBlock\r\n\t\" Return the contents of the receiver wich evaluates aBlock to true. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tself keysAndValuesDo: [:key :value |\r\n\t\t(aBlock value: value) ifTrue: [ result at: key put: value ]\r\n\t].\r\n\t^result","(\r\nfunction(self,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn (smalltalk:if_true_false_(((aBlock):value_(value)),(function()\r\nreturn ((result):at_put_(key,value))\r\nend),nil))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"shallowCopy",0
,(
function(self)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(self):keysAndValuesDo_((function(key,value)
return ((result):at_put_(key,value))
end));
return (result);
end
)
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tself keysAndValuesDo: [:key :value | result at: key put: value ].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn ((result):at_put_(key,value))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"tuples",0
,(
function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(self):keysAndValuesDo_((function(key,value)
return ((result):add_((smalltalk.Array):with_with_(key,value)))
end));
return (result);
end
)
,"accessing","tuples\r\n\t\" Return an array of tuples built from the receiver's contents. \"\r\n\r\n\t| result |\r\n\tresult := Array new.\r\n\tself keysAndValuesDo: [:key :value|\r\n\t\tresult add: (Array with: key with: value)\r\n\t].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn ((result):add_((smalltalk.Array):with_with_(key,value)))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"copyFrom:to:",0
,(
function(self,anIndex,anotherIndex)
return ((self):shouldNotImplement_("copyFrom:to:"));
end
)
,"copying","copyFrom: anIndex to: anotherIndex\r\n\t\" Return a copy of the receiver from anIndex to anotherIndex. \"\r\n\r\n\t^self shouldNotImplement: #copyFrom:to:","(\r\nfunction(self,anIndex,anotherIndex)\r\nreturn ((self):shouldNotImplement_(\"copyFrom:to:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"deepCopy",0
,(
function(self)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(self):keysAndValuesDo_((function(key,value)
return ((result):at_put_(key,(value):deepCopy()))
end));
return (result);
end
)
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tself keysAndValuesDo: [:key :value |\r\n\t\tresult at: key put: value deepCopy\r\n\t].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn ((result):at_put_(key,(value):deepCopy()))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"remove:",0
,(
function(self,aKey)
(self):removeKey_(aKey);
return (self);
end
)
,"removing","remove: aKey\r\n\t\" Remove the binding at aKey. \"\r\n\r\n\tself removeKey: aKey","(\r\nfunction(self,aKey)\r\n(self):removeKey_(aKey);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"removeKey:",0
,(
function(self,aKey)
return ((self):removeKey_ifAbsent_(aKey,(function()
return ((self):objectNotFoundAt_(aKey))
end)));
end
)
,"removing","removeKey: aKey\r\n\t\" Remove the binding at aKey.\r\n\tSignal an error if the key is not present.\r\n\t\"\r\n\r\n\t^self removeKey: aKey ifAbsent: [ self objectNotFoundAt: aKey ]","(\r\nfunction(self,aKey)\r\nreturn ((self):removeKey_ifAbsent_(aKey,(function()\r\nreturn ((self):objectNotFoundAt_(aKey))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"printString",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((((self)["$klass"]):name())," fromTuples: ")),((self):tuples()):asLiteral()));
end
)
,"converting","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t^self class name ,' fromTuples: ' ,self tuples asLiteral","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((((self)[\"$klass\"]):name()),\" fromTuples: \")),((self):tuples()):asLiteral()));\r\nend\r\n)")
smalltalk:bind(smalltalk.KeyedCollection,"isDictionary",0
,(
function(self)
return (true);
end
)
,"testing","isDictionary\r\n\t\" Return true if the receiver is a dictionary. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary["$klass"],"basicNew",0
,(
function(self)
if true then return smalltalk.PoolDictionary:new() end;
return (smalltalk:superImplementor(smalltalk.Dictionary["$klass"],"basicNew")(self));
end
)
,"instantiation","basicNew\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'self' doc'native instantiation'}.\r\n\t^super basicNew","(\r\nfunction(self)\r\nif true then return smalltalk.PoolDictionary:new() end;\r\nreturn (smalltalk:superImplementor(smalltalk.Dictionary[\"$klass\"],\"basicNew\")(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary["$klass"],"fromKeys:and:",0
,(
function(self,keys,values)
return (((self):basicNew()):initializeKeys_values_(keys,values));
end
)
,"instantiation","fromKeys: keys and: values\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew initializeKeys: keys values: values","(\r\nfunction(self,keys,values)\r\nreturn (((self):basicNew()):initializeKeys_values_(keys,values));\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"initialize",0
,(
function(self)
smalltalk:superImplementor(smalltalk.Dictionary,"initialize")(self);
(function()
	local _s8_value=((smalltalk.HashedSet):new())
	self["@keys"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:newArray({}))
	self["@values"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"initialize","initialize\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsuper initialize.\r\n\tkeys := HashedSet new.\r\n\tvalues := #().","(\r\nfunction(self)\r\nsmalltalk:superImplementor(smalltalk.Dictionary,\"initialize\")(self);\r\n(function()\r\n\tlocal _s8_value=((smalltalk.HashedSet):new())\r\n\tself[\"@keys\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tself[\"@values\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"initializeKeys:values:",0
,(
function(self,privateKeys,privateValues)
smalltalk:superImplementor(smalltalk.Dictionary,"initialize")(self);
(function()
	local _s8_value=((smalltalk.HashedSet):newContents_(privateKeys))
	self["@keys"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((privateValues):asArray())
	self["@values"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"initialize","initializeKeys: privateKeys values: privateValues\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsuper initialize.\r\n\tkeys := HashedSet newContents: privateKeys.\r\n\tvalues := privateValues asArray.","(\r\nfunction(self,privateKeys,privateValues)\r\nsmalltalk:superImplementor(smalltalk.Dictionary,\"initialize\")(self);\r\n(function()\r\n\tlocal _s8_value=((smalltalk.HashedSet):newContents_(privateKeys))\r\n\tself[\"@keys\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((privateValues):asArray())\r\n\tself[\"@values\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"size",0
,(
function(self)
return ((self["@keys"]):size());
end
)
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^keys size","(\r\nfunction(self)\r\nreturn ((self[\"@keys\"]):size());\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"isEmpty",0
,(
function(self)
return ((self["@keys"]):isEmpty());
end
)
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^keys isEmpty","(\r\nfunction(self)\r\nreturn ((self[\"@keys\"]):isEmpty());\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"lookUpKey:",0
,(
function(self,aKey)
return ((self["@keys"]):indexOf_ifAbsent_(aKey,(function()
return (nil)
end)));
end
)
,"private","lookUpKey: aKey\r\n\t\" Private - Return the index where aKey is found (or nil). \"\r\n\r\n\t^keys indexOf: aKey ifAbsent: [ nil ]","(\r\nfunction(self,aKey)\r\nreturn ((self[\"@keys\"]):indexOf_ifAbsent_(aKey,(function()\r\nreturn (nil)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"keysAndValuesDo:",0
,(
function(self,aBlock)
(self["@keys"]):withIndexDo_((function(aKey,index)
return ((aBlock):value_value_(aKey,(self["@values"]):at_(index)))
end));
return (self);
end
)
,"enumerating","keysAndValuesDo: aBlock\r\n\t\" Evaluate aBlock for key/value pairs of the receiver. \"\r\n\r\n\tkeys withIndexDo: [:aKey :index | aBlock value: aKey value: (values at: index) ]","(\r\nfunction(self,aBlock)\r\n(self[\"@keys\"]):withIndexDo_((function(aKey,index)\r\nreturn ((aBlock):value_value_(aKey,(self[\"@values\"]):at_(index)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"keys",0
,(
function(self)
return ((self["@keys"]):copy());
end
)
,"accessing","keys\r\n\t\" Return the keys of the receiver. \"\r\n\r\n\t^keys copy","(\r\nfunction(self)\r\nreturn ((self[\"@keys\"]):copy());\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"keysDo:",0
,(
function(self,aBlock)
(self["@keys"]):do_(aBlock);
return (self);
end
)
,"enumerating","keysDo: aBlock\r\n\t\" Evaluate aBlock with the keys of the receiver. \"\r\n\r\n\tkeys do: aBlock","(\r\nfunction(self,aBlock)\r\n(self[\"@keys\"]):do_(aBlock);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"values",0
,(
function(self)
return ((self["@values"]):copy());
end
)
,"accessing","values\r\n\t\" Return the values of the receiver. \"\r\n\r\n\t^values copy","(\r\nfunction(self)\r\nreturn ((self[\"@values\"]):copy());\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"at:put:",0
,(
function(self,aKey,aValue)
local index=nil
(function()
	local _s8_value=((self):lookUpKey_(aKey))
	index=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((index)))==true then (self["@keys"]):add_(aKey);
(self["@values"]):add_(aValue); else (self["@values"]):at_put_(index,aValue); end;
return (aValue);
end
)
,"accessing","at: aKey put: aValue\r\n\t\" Set the value at aKey of the receiver. \"\r\n\r\n\t| index |\r\n\tindex := self lookUpKey: aKey.\r\n\tindex isNil\r\n\t\tifTrue: [ keys add: aKey. values add: aValue.]\r\n\t\tifFalse: [ values at: index put: aValue ].\r\n\t^aValue","(\r\nfunction(self,aKey,aValue)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):lookUpKey_(aKey))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((index)))==true then (self[\"@keys\"]):add_(aKey);\r\n(self[\"@values\"]):add_(aValue); else (self[\"@values\"]):at_put_(index,aValue); end;\r\nreturn (aValue);\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"at:ifAbsent:",0
,(
function(self,aKey,aBlock)
local index=nil
(function()
	local _s8_value=((self):lookUpKey_(aKey))
	index=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((index)))==true then return ((aBlock):value()); end;
return ((self["@values"]):at_(index));
end
)
,"accessing","at: aKey ifAbsent: aBlock\r\n\t\" Return the value at aKey or the result of evaluating aBlock. \"\r\n\r\n\t| index |\r\n\tindex := self lookUpKey: aKey.\r\n\tindex isNil ifTrue: [ ^aBlock value ].\r\n\t^values at: index","(\r\nfunction(self,aKey,aBlock)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):lookUpKey_(aKey))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((index)))==true then return ((aBlock):value()); end;\r\nreturn ((self[\"@values\"]):at_(index));\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"at:ifAbsentPut:",0
,(
function(self,aKey,aBlock)
local index=nil
(function()
	local _s8_value=((self):lookUpKey_(aKey))
	index=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((index)))==true then return ((self):at_put_(aKey,(aBlock):value())); end;
return ((self["@values"]):at_(index));
end
)
,"accessing","at: aKey ifAbsentPut: aBlock\r\n\t\" Return the value at aKey, or add the result of evaluating aBlock to the receiver if it is absent. \"\r\n\r\n\t| index |\r\n\tindex := self lookUpKey: aKey.\r\n\tindex isNil ifTrue: [ ^self at: aKey put: aBlock value ].\r\n\t^values at: index","(\r\nfunction(self,aKey,aBlock)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):lookUpKey_(aKey))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((index)))==true then return ((self):at_put_(aKey,(aBlock):value())); end;\r\nreturn ((self[\"@values\"]):at_(index));\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"do:",0
,(
function(self,aBlock)
return ((self["@values"]):do_(aBlock));
end
)
,"enumerating","do: aBlock\r\n\t\" Evaluates aBlock for all values in the receiver. \"\r\n\r\n\t^values do: aBlock","(\r\nfunction(self,aBlock)\r\nreturn ((self[\"@values\"]):do_(aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"detect:ifNone:",0
,(
function(self,aBlock,anotherBlock)
return ((self["@values"]):detect_ifNone_(aBlock,anotherBlock));
end
)
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Detect the value who matches aBlock.\r\n\tReturn the result of evaluating aBlock if no value matches detection block.\r\n\t\"\r\n\r\n\t^values detect: aBlock ifNone: anotherBlock","(\r\nfunction(self,aBlock,anotherBlock)\r\nreturn ((self[\"@values\"]):detect_ifNone_(aBlock,anotherBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"includes:",0
,(
function(self,anObject)
return ((self["@values"]):includes_(anObject));
end
)
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t^values includes: anObject","(\r\nfunction(self,anObject)\r\nreturn ((self[\"@values\"]):includes_(anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"includesKey:",0
,(
function(self,aKey)
return ((self["@keys"]):includes_(aKey));
end
)
,"enumerating","includesKey: aKey\r\n\t\" Return true if the receiver's keys include aKey. \"\r\n\r\n\t^keys includes: aKey","(\r\nfunction(self,aKey)\r\nreturn ((self[\"@keys\"]):includes_(aKey));\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"removeKey:ifAbsent:",0
,(
function(self,aKey,aBlock)
local index=nil
(function()
	local _s8_value=((self):lookUpKey_(aKey))
	index=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((index)))==true then return ((aBlock):value()); end;
(self["@keys"]):removeIndex_(index);
(self["@values"]):removeIndex_(index);
return (self);
end
)
,"removing","removeKey: aKey ifAbsent: aBlock\r\n\t\" Remove the binding at aKey. \"\r\n\r\n\t| index |\r\n\tindex := self lookUpKey: aKey.\r\n\tindex isNil ifTrue: [ ^aBlock value ].\r\n\tkeys removeIndex: index.\r\n\tvalues removeIndex: index.","(\r\nfunction(self,aKey,aBlock)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):lookUpKey_(aKey))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((index)))==true then return ((aBlock):value()); end;\r\n(self[\"@keys\"]):removeIndex_(index);\r\n(self[\"@values\"]):removeIndex_(index);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"keyForValue:ifAbsent:",0
,(
function(self,anObject,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):keysAndValuesDo_((function(key,aValue)
return (smalltalk:if_true_false_((((anObject)==aValue)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (key)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):value())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"accessing","keyForValue: anObject ifAbsent: aBlock\r\n\t\" Return the key in the receiver for value anObject, or the result of evaluating aBlock. \"\r\n\r\n\tself keysAndValuesDo: [:key :aValue| anObject == aValue ifTrue: [ ^key ] ].\r\n\t^aBlock value","(\r\nfunction(self,anObject,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):keysAndValuesDo_((function(key,aValue)\r\nreturn (smalltalk:if_true_false_((((anObject)==aValue)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (key)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"asNative:",0
,(
function(self,lang)
local send=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((lang),"lua")),(function()
return (":")
end),(function()
return (".")
end)))
	send=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),((self)["$klass"]):name())),send)),"fromKeys_and_(")),((self["@keys"]):asArray()):asNative_(lang))),",")),(self["@values"]):asNative_(lang))),")"));
end
)
,"converting","asNative: lang\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t| send |\r\n\tsend := lang = #lua ifTrue: [$:] ifFalse: [$.].\r\n\t^'smalltalk.' ,self class name\r\n\t\t,send ,'fromKeys_and_('\r\n\t\t\t,(keys asArray asNative: lang)\r\n\t\t\t,',' ,(values asNative: lang)\r\n\t\t,')'","(\r\nfunction(self,lang)\r\nlocal send=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((lang),\"lua\")),(function()\r\nreturn (\":\")\r\nend),(function()\r\nreturn (\".\")\r\nend)))\r\n\tsend=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),((self)[\"$klass\"]):name())),send)),\"fromKeys_and_(\")),((self[\"@keys\"]):asArray()):asNative_(lang))),\",\")),(self[\"@values\"]):asNative_(lang))),\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Dictionary,"asLua",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),((self)["$klass"]):name())),":fromKeys_and_(")),((self["@keys"]):asArray()):asLua())),",")),(self["@values"]):asLua())),")"));
end
)
,"Lua-lua","asLua\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t^'smalltalk.' ,self class name\r\n\t, ':fromKeys_and_('\r\n\t\t, keys asArray asLua\r\n\t\t,',' ,values asLua\r\n\t,')'","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),((self)[\"$klass\"]):name())),\":fromKeys_and_(\")),((self[\"@keys\"]):asArray()):asLua())),\",\")),(self[\"@values\"]):asLua())),\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary["$klass"],"@@","_at_at"
,(
function(self,aHash)
return ((
function(_s8_rec)
	(_s8_rec):instVarAt_put_("hash",aHash);
	return ((_s8_rec):yourself())
end
)((self):basicNew()));
end
)
,"instantiation","@@ aHash\r\n\t\" Return an instance of the receiver. \"\r\n\t\" The instance will hack aHash violating encapsulation of aHash and instance.\r\n\t Both will share internal state. \"\r\n\r\n\t^self basicNew\r\n\t\tinstVarAt: #hash put: aHash;\r\n\t\tyourself","(\r\nfunction(self,aHash)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):instVarAt_put_(\"hash\",aHash);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):basicNew()));\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"initialize",0
,(
function(self)
smalltalk:superImplementor(smalltalk.PoolDictionary,"initialize")(self);
(function()
	local _s8_value=((self):newHash())
	self["@hash"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"initialize","initialize\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsuper initialize.\r\n\thash := self newHash.","(\r\nfunction(self)\r\nsmalltalk:superImplementor(smalltalk.PoolDictionary,\"initialize\")(self);\r\n(function()\r\n\tlocal _s8_value=((self):newHash())\r\n\tself[\"@hash\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"validKey:",0
,(
function(self,aKey)

return (aKey);
end
)
,"initialize","validKey: aKey\r\n\t\" Private - Returns a valid key to store a value in the receiver. \"\r\n\r\n\t{'self'}.\r\n\t\"(self typeOf: aKey) = #string ifFalse: [ ^self error: 'Invalid key (must be aString).' ].\"\r\n\t^aKey ","(\r\nfunction(self,aKey)\r\n\r\nreturn (aKey);\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"at:put:",0
,(
function(self,aKey,aValue)
(function()
	local _s8_value=(nil)
	self["@size"]=_s8_value
	return _s8_value
end)();

smalltalk:basic_at_put_((self["@hash"]),(self):validKey_(aKey),(self):wrap_(aValue));
return (aValue);
end
)
,"accessing","at: aKey put: aValue\r\n\t\" Set the value at aKey of the receiver. \"\r\n\r\n\tsize := nil.\r\n\t{'self'}.\r\n\thash\tbasicAt: (self validKey: aKey)\r\n\t\tput: (self wrap: aValue).\r\n\t^aValue","(\r\nfunction(self,aKey,aValue)\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@size\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\nsmalltalk:basic_at_put_((self[\"@hash\"]),(self):validKey_(aKey),(self):wrap_(aValue));\r\nreturn (aValue);\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"removeKey:ifAbsent:",0
,(
function(self,aKey,aBlock)
if not (((self):includesKey_(aKey)))==true then return ((aBlock):value()); end;
(function()
	local _s8_value=(nil)
	self["@size"]=_s8_value
	return _s8_value
end)();
self["@hash"][self:wrap_(aKey)]=nil;
return (self);
end
)
,"removing","removeKey: aKey ifAbsent: aBlock\r\n\t\" Remove the binding at aKey. \"\r\n\r\n\t(self includesKey: aKey) ifFalse: [ ^aBlock value ].\r\n\tsize := nil.\r\n\t{'' doc'native remotion'}","(\r\nfunction(self,aKey,aBlock)\r\nif not (((self):includesKey_(aKey)))==true then return ((aBlock):value()); end;\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@size\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nself[\"@hash\"][self:wrap_(aKey)]=nil;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"size",0
,(
function(self)
if (smalltalk:isNil_((self["@size"])))==true then (function()
	local _s8_value=(((self):keys()):size())
	self["@size"]=_s8_value
	return _s8_value
end)(); end;
return (self["@size"]);
end
)
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\tsize isNil ifTrue: [ size := self keys size ].\r\n\t^size","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@size\"])))==true then (function()\r\n\tlocal _s8_value=(((self):keys()):size())\r\n\tself[\"@size\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@size\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"at:ifAbsent:",0
,(
function(self,aKey,aBlock)

	local found = self["@hash"][self:wrap_(aKey)]
	if found~=nil
		then return self:unwrap_(found)
		else return aBlock:value()
	end;
return (self);
end
)
,"accessing","at: aKey ifAbsent: aBlock\r\n\t\" Return the value at aKey or the result of evaluating aBlock. \"\r\n\r\n\t{'' doc'native indexing'}","(\r\nfunction(self,aKey,aBlock)\r\n\r\n\tlocal found = self[\"@hash\"][self:wrap_(aKey)]\r\n\tif found~=nil\r\n\t\tthen return self:unwrap_(found)\r\n\t\telse return aBlock:value()\r\n\tend;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"includesKey:",0
,(
function(self,aKey)
return (self["@hash"][self:wrap_(aKey)]~=nil);
end
)
,"testing","includesKey: aKey\r\n\t\" Return true if the receiver's keys include aKey. \"\r\n\r\n\t^{'' doc'native testing'}","(\r\nfunction(self,aKey)\r\nreturn (self[\"@hash\"][self:wrap_(aKey)]~=nil);\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"keys",0
,(
function(self)

	local result=smalltalk.Array:new()
	for k,_ in pairs(self["@hash"]) do result:add_(k) end
	if true then return result end;
return (self);
end
)
,"accessing","keys\r\n\t\" Return the keys of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","(\r\nfunction(self)\r\n\r\n\tlocal result=smalltalk.Array:new()\r\n\tfor k,_ in pairs(self[\"@hash\"]) do result:add_(k) end\r\n\tif true then return result end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"keysAndValuesDo:",0
,(
function(self,aBlock)
(self):keysDo_((function(key)
return ((aBlock):value_value_(key,(self):at_(key)))
end));
return (self);
end
)
,"enumerating","keysAndValuesDo: aBlock\r\n\t\" Evaluate aBlock for key/value pairs of the receiver. \"\r\n\r\n\tself keysDo: [:key |\r\n\t\taBlock value: key value: (self at: key)\r\n\t]","(\r\nfunction(self,aBlock)\r\n(self):keysDo_((function(key)\r\nreturn ((aBlock):value_value_(key,(self):at_(key)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"values",0
,(
function(self)
return (((self):keys()):collect_((function(key)
return ((self):at_(key))
end)));
end
)
,"accessing","values\r\n\t\" Return the values of the receiver. \"\r\n\r\n\t^self keys collect: [:key| self at: key ]","(\r\nfunction(self)\r\nreturn (((self):keys()):collect_((function(key)\r\nreturn ((self):at_(key))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"asNative:",0
,(
function(self,lang)
local send=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((lang),"lua")),(function()
return (":")
end),(function()
return (".")
end)))
	send=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),((self)["$klass"]):name())),send)),"fromTuples_(")),((self):tuples()):asNative_(lang))),")"));
end
)
,"converting","asNative: lang\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t| send |\r\n\tsend := lang = #lua ifTrue: [$:] ifFalse: [$.].\r\n\t^'smalltalk.' ,self class name\r\n\t\t,send ,'fromTuples_('\r\n\t\t,(self tuples asNative: lang)\r\n\t\t,')'","(\r\nfunction(self,lang)\r\nlocal send=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((lang),\"lua\")),(function()\r\nreturn (\":\")\r\nend),(function()\r\nreturn (\".\")\r\nend)))\r\n\tsend=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),((self)[\"$klass\"]):name())),send)),\"fromTuples_(\")),((self):tuples()):asNative_(lang))),\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"detect:ifNone:",0
,(
function(self,aBlock,anotherBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):keysAndValuesDo_((function(key,value)
return (smalltalk:if_true_false_(((aBlock):value_(value)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (value)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((anotherBlock):value())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Detect the value who matches aBlock.\r\n\tReturn the result of evaluating aBlock if no value matches detection block.\r\n\t\"\r\n\r\n\tself keysAndValuesDo: [:key :value |\r\n\t\t(aBlock value: value) ifTrue: [ ^value ]\r\n\t].\r\n\t^anotherBlock value","(\r\nfunction(self,aBlock,anotherBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn (smalltalk:if_true_false_(((aBlock):value_(value)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (value)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((anotherBlock):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"do:",0
,(
function(self,aBlock)
(self):keysAndValuesDo_((function(key,value)
return ((aBlock):value_(value))
end));
return (self);
end
)
,"enumerating","do: aBlock\r\n\t\" Evaluates aBlock for all values in the receiver. \"\r\n\r\n\tself keysAndValuesDo: [:key :value | aBlock value: value ]","(\r\nfunction(self,aBlock)\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn ((aBlock):value_(value))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"includes:",0
,(
function(self,anObject)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):keysAndValuesDo_((function(key,value)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((anObject),value)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\tself keysAndValuesDo: [:key :value |\r\n\t\tanObject = value ifTrue: [ ^true ].\r\n\t].\r\n\t^false","(\r\nfunction(self,anObject)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((anObject),value)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"keysDo:",0
,(
function(self,aBlock)
((self):keys()):do_(aBlock);
return (self);
end
)
,"enumerating","keysDo: aBlock\r\n\t\" Evaluate aBlock with the keys of the receiver. \"\r\n\r\n\tself keys do: aBlock","(\r\nfunction(self,aBlock)\r\n((self):keys()):do_(aBlock);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"@","_at"
,(
function(self,keyOrPath)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
if not (((keyOrPath):isArray()))==true then return ((self):at_ifAbsent_(keyOrPath,(function()
return (nil)
end))); end;
(function()
	local _s8_value=((keyOrPath):inject_into_(self,(function(pool,key)
local value=nil
if (smalltalk:isNil_((((function()
	local _s8_value=((pool):_at(key))
	value=_s8_value
	return _s8_value
end)()))))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)(); end;return (value)
end)))
	result=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"accessing","@ keyOrPath\r\n\t\" Return the result of accessing the receiver at key or path (or nil). \"\r\n\r\n\t| result |\r\n\tkeyOrPath isArray ifFalse: [ ^self at: keyOrPath ifAbsent: [] ].\r\n\tresult := keyOrPath inject: self into: [:pool :key | | value |\r\n\t\t(value := pool @ key) isNil ifTrue: [ ^nil ].\r\n\t\tvalue\r\n\t].\r\n\t^result","(\r\nfunction(self,keyOrPath)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\nif not (((keyOrPath):isArray()))==true then return ((self):at_ifAbsent_(keyOrPath,(function()\r\nreturn (nil)\r\nend))); end;\r\n(function()\r\n\tlocal _s8_value=((keyOrPath):inject_into_(self,(function(pool,key)\r\nlocal value=nil\r\nif (smalltalk:isNil_((((function()\r\n\tlocal _s8_value=((pool):_at(key))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)()))))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return (value)\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionary,"asLua",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),((self)["$klass"]):name())),":fromTuples_(")),((self):tuples()):asLua())),")"));
end
)
,"Lua-lua","asLua\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t^'smalltalk.',self class name\r\n\t, ':fromTuples_('\r\n\t\t, self tuples asLua\r\n\t,')'","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),((self)[\"$klass\"]):name())),\":fromTuples_(\")),((self):tuples()):asLua())),\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.RegularExpression["$klass"],"fromString:flag:",0
,(
function(self,aString,anotherString)
return (self:notImplementedYet_("fromString:flag:"));
end
)
,"instantiation","fromString: aString flag: anotherString\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^{'' doc'native instantiation'}","(\r\nfunction(self,aString,anotherString)\r\nreturn (self:notImplementedYet_(\"fromString:flag:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.RegularExpression["$klass"],"fromString:",0
,(
function(self,aString)
return ((self):fromString_flag_(aString,""));
end
)
,"instantiation","fromString: aString\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t    ^self fromString: aString flag: ''","(\r\nfunction(self,aString)\r\nreturn ((self):fromString_flag_(aString,\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.RegularExpression,"compile:",0
,(
function(self,aString)
return ((self):compile(aString));
end
)
,"evaluating","compile: aString\r\n\t\" Return the result of compilation of aString. \"\r\n\r\n\t^self #compile: aString","(\r\nfunction(self,aString)\r\nreturn ((self):compile(aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.RegularExpression,"exec:",0
,(
function(self,aString)
return ((self):exec(aString));
end
)
,"evaluating","exec: aString\r\n\t\" Return the result of excecution of aString. \"\r\n\r\n\t^self #exec: aString","(\r\nfunction(self,aString)\r\nreturn ((self):exec(aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.RegularExpression,"test:",0
,(
function(self,aString)
return ((self):test(aString));
end
)
,"evaluating","test: aString\r\n\t\" Return the result of testing of aString. \"\r\n\r\n\t^self #test: aString","(\r\nfunction(self,aString)\r\nreturn ((self):test(aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.RegularExpression,"shallowCopy",0
,(
function(self)
return (self);
end
)
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.RegularExpression,"deepCopy",0
,(
function(self)
return (self);
end
)
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.RegularExpression,"asJSONObject",0
,(
function(self)
return (self);
end
)
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exception,"captureStack",0
,(
function(self)

return (self);
end
)
,"private","captureStack\r\n\t\" Private, Internal - Capture the native stack of the receiver. \"\r\n\r\n\t{'self' doc'Must return the native stack'}","(\r\nfunction(self)\r\n\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exception,"nativeStack",0
,(
function(self)
return ((self)["@stack"]);
end
)
,"private","nativeStack\r\n\t\" Private, Internal - Return the native stack of the receiver (or nil).\r\n\tNote that the native stack can be nativelly captured during signal.\r\n\t\"\r\n\r\n\t^self basicAt: '@stack'","(\r\nfunction(self)\r\nreturn ((self)[\"@stack\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exception,"nativeException",0
,(
function(self)
return ((self)["@nativeException"]);
end
)
,"private","nativeException\r\n\t\" Private, Internal - Return the native exception associated with the receiver (or nil). \"\r\n\r\n\t^self basicAt: '@nativeException'","(\r\nfunction(self)\r\nreturn ((self)[\"@nativeException\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exception,"nativeException:",0
,(
function(self,nex)
return (smalltalk:basic_at_put_((self),"@nativeException",nex));
end
)
,"private","nativeException: nex\r\n\t\" Private, Internal - Set the native exception associated with the receiver. \"\r\n\r\n\t^self basicAt: '@nativeException' put: nex","(\r\nfunction(self,nex)\r\nreturn (smalltalk:basic_at_put_((self),\"@nativeException\",nex));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exception,"stack",0
,(
function(self)
local nex=nil
local stk=nil
(function()
	local _s8_value=((self):nativeStack())
	stk=_s8_value
	return _s8_value
end)();
if ((((stk):size()) > 0))==true then return (stk); end;
(function()
	local _s8_value=((self):nativeException())
	nex=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((nex)))==true then return (""); end;
(function()
	local _s8_value=((nex)["stack"])
	stk=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:isNil_((stk))),(function()
return ("")
end),(function()
return (stk)
end)));
end
)
,"stack","stack\r\n\t\" Private - Return a stack trace string (or an empty string). \"\r\n\r\n\t| nex stk |\r\n\tstk := self nativeStack.\r\n\tstk size > 0 ifTrue: [ ^stk ].\r\n\tnex := self nativeException.\r\n\tnex isNil ifTrue: [ ^'' ].\r\n\tstk := nex basicAt: #stack.\r\n\t^stk isNil ifTrue: [''] ifFalse: [stk]","(\r\nfunction(self)\r\nlocal nex=nil\r\nlocal stk=nil\r\n(function()\r\n\tlocal _s8_value=((self):nativeStack())\r\n\tstk=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((((stk):size()) > 0))==true then return (stk); end;\r\n(function()\r\n\tlocal _s8_value=((self):nativeException())\r\n\tnex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((nex)))==true then return (\"\"); end;\r\n(function()\r\n\tlocal _s8_value=((nex)[\"stack\"])\r\n\tstk=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((stk))),(function()\r\nreturn (\"\")\r\nend),(function()\r\nreturn (stk)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exception,"toString",0
,(
function(self)
local txt=nil
local stk=nil
(function()
	local _s8_value=((self):messageText())
	txt=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((txt)))==true then (function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(("{st: "),(self):description())),"}"))
	txt=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=((self):stack())
	stk=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((stk):size()),0))==true then return (txt); end;
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_(txt);
	(_s8_rec):cr();
	(_s8_rec):nextPutAll_(stk);
	return ((_s8_rec):contents())
end
)((""):writeStream()));
end
)
,"converting","toString\r\n\t\" Return the receiver as a String. \"\r\n\r\n\t| txt stk |\r\n\ttxt := self messageText.\r\n\ttxt isNil ifTrue: [ txt := '{st: ' ,self description ,$} ].\r\n\tstk := self stack.\r\n\tstk size = 0 ifTrue: [ ^txt ].\r\n\t^'' writeStream\r\n\t\tnextPutAll: txt; cr;\r\n\t\tnextPutAll: stk;\r\n\t\tcontents","(\r\nfunction(self)\r\nlocal txt=nil\r\nlocal stk=nil\r\n(function()\r\n\tlocal _s8_value=((self):messageText())\r\n\ttxt=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((txt)))==true then (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((\"{st: \"),(self):description())),\"}\"))\r\n\ttxt=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((self):stack())\r\n\tstk=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((stk):size()),0))==true then return (txt); end;\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(txt);\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):nextPutAll_(stk);\r\n\treturn ((_s8_rec):contents())\r\nend\r\n)((\"\"):writeStream()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exception,"messageText",0
,(
function(self)
return (self["@messageText"]);
end
)
,"accessing","messageText\r\n\t\" Return the messageText of the receiver. \"\r\n\r\n\t^messageText","(\r\nfunction(self)\r\nreturn (self[\"@messageText\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exception,"description",0
,(
function(self)
local txt=nil
local ex=nil
(function()
	local _s8_value=((self):messageText())
	txt=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((txt)))==true then (function()
	local _s8_value=("")
	txt=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=((self):toString_(txt))
	txt=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):nativeException())
	ex=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((ex)))==true then (function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((txt)," [")),(self):typeOf_(ex))),"] ")),(self):toString_(ex)))
	txt=_s8_value
	return _s8_value
end)(); end;
return (smalltalk:object_comma_((smalltalk:object_comma_((((self)["$klass"]):name())," - ")),txt));
end
)
,"accessing","description\r\n\t\" Return the description of the receiver. \"\r\n\r\n\t| txt ex |\r\n\ttxt := self messageText.\r\n\ttxt isNil ifTrue: [ txt := '' ].\r\n\ttxt := self toString: txt.\r\n\tex := self nativeException.\r\n\tex notNil ifTrue: [\r\n\t\ttxt := txt\r\n\t\t\t,' [' ,(self typeOf: ex)\r\n\t\t\t,'] ' ,(self toString: ex)\r\n\t].\r\n\t^self class name ,' - ' ,txt ","(\r\nfunction(self)\r\nlocal txt=nil\r\nlocal ex=nil\r\n(function()\r\n\tlocal _s8_value=((self):messageText())\r\n\ttxt=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((txt)))==true then (function()\r\n\tlocal _s8_value=(\"\")\r\n\ttxt=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((self):toString_(txt))\r\n\ttxt=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):nativeException())\r\n\tex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((ex)))==true then (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((txt),\" [\")),(self):typeOf_(ex))),\"] \")),(self):toString_(ex)))\r\n\ttxt=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((((self)[\"$klass\"]):name()),\" - \")),txt));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exception,"messageText:",0
,(
function(self,aString)
(function()
	local _s8_value=(aString)
	self["@messageText"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","messageText: aString\r\n\t\" Set the messageText of the receiver. \"\r\n\r\n\tmessageText := aString","(\r\nfunction(self,aString)\r\n(function()\r\n\tlocal _s8_value=(aString)\r\n\tself[\"@messageText\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exception,"signal",0
,(
function(self)
(self):note_((self):description());
error(self);
return (self);
end
)
,"signaling","signal\r\n\t\" Signal/throw the receiver. \"\r\n\r\n\tself note: self description.\r\n\t{'' doc'jump into native exception'}","(\r\nfunction(self)\r\n(self):note_((self):description());\r\nerror(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exception,"__tostring",0
,(
function(self)
return (smalltalk:toString_((self)));
end
)
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","(\r\nfunction(self)\r\nreturn (smalltalk:toString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Error["$klass"],"signal:",0
,(
function(self,aString)
return ((
function(_s8_rec)
	(_s8_rec):messageText_(aString);
	(_s8_rec):captureStack();
	return ((_s8_rec):signal())
end
)((self):new()));
end
)
,"instantiation","signal: aString\r\n\t\" Signal an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tmessageText: aString;\r\n\t\tcaptureStack;\r\n\t\tsignal","(\r\nfunction(self,aString)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):messageText_(aString);\r\n\t(_s8_rec):captureStack();\r\n\treturn ((_s8_rec):signal())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.MessageNotUnderstood,"message",0
,(
function(self)
return (self["@message"]);
end
)
,"accessing","message\r\n\t\" Return the message of the receiver. \"\r\n\r\n\t^message","(\r\nfunction(self)\r\nreturn (self[\"@message\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.MessageNotUnderstood,"message:",0
,(
function(self,aMessage)
(function()
	local _s8_value=(aMessage)
	self["@message"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","message: aMessage\r\n\t\" Set the message of the receiver. \"\r\n\r\n\tmessage := aMessage","(\r\nfunction(self,aMessage)\r\n(function()\r\n\tlocal _s8_value=(aMessage)\r\n\tself[\"@message\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.MessageNotUnderstood,"receiver",0
,(
function(self)
return (self["@receiver"]);
end
)
,"accessing","receiver\r\n\t\" Return the receiver of the receiver. \"\r\n\r\n\t^receiver","(\r\nfunction(self)\r\nreturn (self[\"@receiver\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.MessageNotUnderstood,"receiver:",0
,(
function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@receiver"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","receiver: anObject\r\n\t\" Set the receiver of the receiver. \"\r\n\r\n\treceiver := anObject","(\r\nfunction(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@receiver\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.MessageNotUnderstood,"messageText",0
,(
function(self)
local type=nil
if (smalltalk:isNil_((self["@message"])))==true then return ("unknown"); end;
(function()
	local _s8_value=(smalltalk:if_true_false_(((self):isObject_(self["@receiver"])),(function()
return (smalltalk:object_comma_(("instance of "),((self["@receiver"])["$klass"]):name()))
end),(function()
return ("native object")
end)))
	type=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:if_true_false_(((self["@message"]):isString()),(function()
return ((self["@message"]):asLiteral())
end),(function()
return ((self["@message"]):selector())
end)))," not understood by ")),type));
end
)
,"accessing","messageText\r\n\t\" Return the message text of the receiver. \"\r\n\r\n\t| type |\r\n\tmessage isNil ifTrue: [ ^#unknown ].\r\n\ttype := (self isObject: receiver)\r\n\t\tifTrue: [ 'instance of ' ,receiver class name ]\r\n\t\tifFalse: [ 'native object' ].\r\n\t^(message isString\r\n\t\tifTrue: [ message asLiteral ]\r\n\t\tifFalse: [ message selector ])\r\n\t\t,' not understood by ' ,type","(\r\nfunction(self)\r\nlocal type=nil\r\nif (smalltalk:isNil_((self[\"@message\"])))==true then return (\"unknown\"); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((self):isObject_(self[\"@receiver\"])),(function()\r\nreturn (smalltalk:object_comma_((\"instance of \"),((self[\"@receiver\"])[\"$klass\"]):name()))\r\nend),(function()\r\nreturn (\"native object\")\r\nend)))\r\n\ttype=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:if_true_false_(((self[\"@message\"]):isString()),(function()\r\nreturn ((self[\"@message\"]):asLiteral())\r\nend),(function()\r\nreturn ((self[\"@message\"]):selector())\r\nend))),\" not understood by \")),type));\r\nend\r\n)")
smalltalk:bind(smalltalk.Association["$klass"],"key:",0
,(
function(self,aKey)
return (((self):new()):key_(aKey));
end
)
,"instantiation","key: aKey\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new key: aKey","(\r\nfunction(self,aKey)\r\nreturn (((self):new()):key_(aKey));\r\nend\r\n)")
smalltalk:bind(smalltalk.Association["$klass"],"key:value:",0
,(
function(self,aKey,aValue)
return (((self):key_(aKey)):value_(aValue));
end
)
,"instantiation","key: aKey value: aValue\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^(self key: aKey) value: aValue","(\r\nfunction(self,aKey,aValue)\r\nreturn (((self):key_(aKey)):value_(aValue));\r\nend\r\n)")
smalltalk:bind(smalltalk.Association,"=","_eq"
,(
function(self,anAssociation)
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((self)["$klass"]),(anAssociation)["$klass"])),(function()
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((self):key()),(anAssociation):key())),(function()
return (smalltalk:isObject_equalTo_(((self):value()),(anAssociation):value()))
end)))
end)));
end
)
,"comparing","= anAssociation\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\t^self class = anAssociation class and: [\r\n\t    self key = anAssociation key and: [\r\n\t\tself value = anAssociation value]]","(\r\nfunction(self,anAssociation)\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((self)[\"$klass\"]),(anAssociation)[\"$klass\"])),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((self):key()),(anAssociation):key())),(function()\r\nreturn (smalltalk:isObject_equalTo_(((self):value()),(anAssociation):value()))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Association,"key:",0
,(
function(self,aKey)
(function()
	local _s8_value=(aKey)
	self["@key"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","key: aKey\r\n\t\" Set the key of the receiver. \"\r\n\r\n\tkey := aKey","(\r\nfunction(self,aKey)\r\n(function()\r\n\tlocal _s8_value=(aKey)\r\n\tself[\"@key\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Association,"key",0
,(
function(self)
return (self["@key"]);
end
)
,"accessing","key\r\n\t\" Return the key of the receiver. \"\r\n\r\n\t^key","(\r\nfunction(self)\r\nreturn (self[\"@key\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Association,"value:",0
,(
function(self,aValue)
(function()
	local _s8_value=(aValue)
	self["@value"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","value: aValue\r\n\t\" Set the value of the receiver. \"\r\n\r\n\tvalue := aValue","(\r\nfunction(self,aValue)\r\n(function()\r\n\tlocal _s8_value=(aValue)\r\n\tself[\"@value\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Association,"value",0
,(
function(self)
return (self["@value"]);
end
)
,"accessing","value\r\n\t\" Return the value of the receiver. \"\r\n\r\n\t^value","(\r\nfunction(self)\r\nreturn (self[\"@value\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Association,",","_comma"
,(
function(self,anAssociation)
return ((smalltalk.ComposedAssociations):with_with_(self,anAssociation));
end
)
,"composing",", anAssociation\r\n\t\" Return the receiver composed with the argument. \"\r\n\r\n\t^ComposedAssociations with: self with: anAssociation","(\r\nfunction(self,anAssociation)\r\nreturn ((smalltalk.ComposedAssociations):with_with_(self,anAssociation));\r\nend\r\n)")
smalltalk:bind(smalltalk.Association,"asJSONObject",0
,(
function(self)
return (((smalltalk.ComposedAssociations):with_(self)):json());
end
)
,"converting","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t^(ComposedAssociations with: self) json","(\r\nfunction(self)\r\nreturn (((smalltalk.ComposedAssociations):with_(self)):json());\r\nend\r\n)")
smalltalk:bind(smalltalk.Association,"isAssociation",0
,(
function(self)
return (true);
end
)
,"testing","isAssociation\r\n\t\" Return true if the receiver is anAssociation. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.Association,"printString",0
,(
function(self)
return (smalltalk:toString_((self)));
end
)
,"printing","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t^self toString ","(\r\nfunction(self)\r\nreturn (smalltalk:toString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Association,"toString",0
,(
function(self)
local string=nil
(function()
	local _s8_value=((function(x)
return (((function()
return (smalltalk:if_true_false_((smalltalk:isNil_((x))),(function()
return ("nil")
end),(function()
return (smalltalk:if_true_false_(((self):isObject_(x)),(function()
return ((x):asLiteral())
end),(function()
return ((self):toString_(x))
end)))
end)))
end)):on_do_(smalltalk.Exception,(function(ex)
return (smalltalk:object_comma_(("??? "),(ex):description()))
end)))
end))
	string=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("("),(string):value_(self["@key"])))," -> ")),(string):value_(self["@value"]))),")"));
end
)
,"converting","toString\r\n\t\" Return the receiver as a String. \"\r\n\r\n\t| string |\r\n\tstring := [:x| [\r\n\t\tx isNil ifTrue: [ #nil ] ifFalse: [\r\n\t\t\t(self isObject: x) ifTrue: [ x asLiteral ]\r\n\t\t\tifFalse: [ self toString: x ] ]\r\n\t\t] on: Exception do: [:ex| '??? ' ,ex description ] ].\r\n\t^$( ,(string value: key) ,' -> ' ,(string value: value) ,$)","(\r\nfunction(self)\r\nlocal string=nil\r\n(function()\r\n\tlocal _s8_value=((function(x)\r\nreturn (((function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((x))),(function()\r\nreturn (\"nil\")\r\nend),(function()\r\nreturn (smalltalk:if_true_false_(((self):isObject_(x)),(function()\r\nreturn ((x):asLiteral())\r\nend),(function()\r\nreturn ((self):toString_(x))\r\nend)))\r\nend)))\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\nreturn (smalltalk:object_comma_((\"??? \"),(ex):description()))\r\nend)))\r\nend))\r\n\tstring=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"(\"),(string):value_(self[\"@key\"]))),\" -> \")),(string):value_(self[\"@value\"]))),\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Association,"__tostring",0
,(
function(self)
return (smalltalk:toString_((self)));
end
)
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","(\r\nfunction(self)\r\nreturn (smalltalk:toString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassBuilder,"superclass:subclass:",0
,(
function(self,aClass,aString)
return ((self):superclass_subclass_instanceVariableNames_category_(aClass,aString,"",nil));
end
)
,"instantiation","superclass: aClass subclass: aString\r\n\t\" Create/Register a new class in the system. \"\r\n\r\n\t^self\r\n\t\tsuperclass: aClass\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: ''\r\n\t\tcategory: nil","(\r\nfunction(self,aClass,aString)\r\nreturn ((self):superclass_subclass_instanceVariableNames_category_(aClass,aString,\"\",nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassBuilder,"superclass:subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:",0
,(
function(self,aClass,aString,aString2,classVarNames,poolVarNames,aString3)
local result=nil
local aCategory=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aString3))),(function()
return (smalltalk:if_true_false_((smalltalk:isNil_((aClass))),(function()
return ("unclassified")
end),(function()
return ((aClass):category())
end)))
end),(function()
return (aString3)
end)))
	aCategory=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):addSubclassOf_named_instanceVariableNames_(aClass,aString,(self):instanceVariableNamesFor_(aString2)))
	result=_s8_value
	return _s8_value
end)();
(self):setupClass_(result);
(
function(_s8_rec)
	(_s8_rec):classVariableNames_(classVarNames);
	(_s8_rec):poolDictionaryNames_(poolVarNames);
	return ((_s8_rec):category_(aCategory))
end
)(result);
if (smalltalk:boolean_and_((smalltalk:notNil_((aClass))),(function()
return ((smalltalk.Smalltalk):includesKey_("Exporter"))
end)))==true then (self):print_(((smalltalk.Exporter):new()):exportNew_(result)); end;
return (result);
end
)
,"instantiation","superclass: aClass\r\n\tsubclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\tpoolDictionaries: poolVarNames\r\n\tcategory: aString3\r\n\t\" Create/Register a new class in the system. \"\r\n\r\n\t| result aCategory |\r\n\taCategory := aString3 isNil ifTrue: [\r\n\t\t\taClass isNil ifTrue: [ #unclassified ]\r\n\t\t\tifFalse: [ aClass category ]\r\n\t\t] ifFalse: [ aString3 ].\r\n\tresult := self\r\n\t\taddSubclassOf: aClass named: aString\r\n\t\tinstanceVariableNames: (self instanceVariableNamesFor: aString2).\r\n\tself setupClass: result.\r\n\tresult \r\n\t\tclassVariableNames: classVarNames;\r\n\t\tpoolDictionaryNames: poolVarNames;\r\n\t\tcategory: aCategory.\r\n\t(aClass notNil and: [ Smalltalk includesKey: #Exporter ]) ifTrue: [\r\n\t\tself print: (Exporter new exportNew: result)\r\n\t].\r\n\t^result","(\r\nfunction(self,aClass,aString,aString2,classVarNames,poolVarNames,aString3)\r\nlocal result=nil\r\nlocal aCategory=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aString3))),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((aClass))),(function()\r\nreturn (\"unclassified\")\r\nend),(function()\r\nreturn ((aClass):category())\r\nend)))\r\nend),(function()\r\nreturn (aString3)\r\nend)))\r\n\taCategory=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):addSubclassOf_named_instanceVariableNames_(aClass,aString,(self):instanceVariableNamesFor_(aString2)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):setupClass_(result);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):classVariableNames_(classVarNames);\r\n\t(_s8_rec):poolDictionaryNames_(poolVarNames);\r\n\treturn ((_s8_rec):category_(aCategory))\r\nend\r\n)(result);\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((aClass))),(function()\r\nreturn ((smalltalk.Smalltalk):includesKey_(\"Exporter\"))\r\nend)))==true then (self):print_(((smalltalk.Exporter):new()):exportNew_(result)); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassBuilder,"superclass:subclass:instanceVariableNames:category:",0
,(
function(self,aClass,aString,aString2,aString3)
return ((self):superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aClass,aString,aString2,"","",aString3));
end
)
,"instantiation","superclass: aClass\r\n\tsubclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tcategory: aString3\r\n\t\" Create/Register a new class in the system. \"\r\n\r\n\t^self\r\n\t\tsuperclass: aClass\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: ''\r\n\t\tpoolDictionaries: ''\r\n\t\tcategory: aString3","(\r\nfunction(self,aClass,aString,aString2,aString3)\r\nreturn ((self):superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aClass,aString,aString2,\"\",\"\",aString3));\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassBuilder,"class:comment:",0
,(
function(self,aClass,aString)
if (smalltalk:boolean_or_((smalltalk:isNil_((aClass))),(function()
return (smalltalk:isObject_equalTo_(((aClass):comment()),aString))
end)))==true then return (self); end;
(aClass):basicComment_(aString);
if ((smalltalk.Smalltalk):includesKey_("Exporter"))==true then (self):print_(((smalltalk.Exporter):new()):exportCommentOf_(aClass)); end;
return (self);
end
)
,"edition","class: aClass comment: aString\r\n\t\" Set/Register the class comment in the system. \"\r\n\r\n\t(aClass isNil or: [ aClass comment = aString ]) ifTrue: [ ^self ].\r\n\taClass basicComment: aString.\r\n\t(Smalltalk includesKey: #Exporter) ifTrue: [\r\n\t\tself print: (Exporter new exportCommentOf: aClass)\r\n\t].","(\r\nfunction(self,aClass,aString)\r\nif (smalltalk:boolean_or_((smalltalk:isNil_((aClass))),(function()\r\nreturn (smalltalk:isObject_equalTo_(((aClass):comment()),aString))\r\nend)))==true then return (self); end;\r\n(aClass):basicComment_(aString);\r\nif ((smalltalk.Smalltalk):includesKey_(\"Exporter\"))==true then (self):print_(((smalltalk.Exporter):new()):exportCommentOf_(aClass)); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassBuilder,"basicClass:instanceVariableNames:",0
,(
function(self,aMetaClass,anArray)
return (((self):smalltalk()):metaVarNames(aMetaClass,anArray));
end
)
,"private","basicClass: aMetaClass instanceVariableNames: anArray\r\n\t\" Private - Register instance variables onto aMetaClass. \"\r\n\r\n\t^self smalltalk #metaVarNames: aMetaClass array: anArray","(\r\nfunction(self,aMetaClass,anArray)\r\nreturn (((self):smalltalk()):metaVarNames(aMetaClass,anArray));\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassBuilder,"class:instanceVariableNames:",0
,(
function(self,aMetaClass,aString)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local varNames=nil
if not (((aMetaClass):isMetaclass()))==true then return ((self):error_(smalltalk:object_comma_(((aMetaClass):name())," is not a metaclass"))); end;
(function()
	local _s8_value=((self):instanceVariableNamesFor_(aString))
	varNames=_s8_value
	return _s8_value
end)();
if not ((smalltalk:isObject_equalTo_((varNames),(aMetaClass):instanceVariableNames())))==true then smalltalk:if_true_false_(((self):basicClass_instanceVariableNames_(aMetaClass,varNames)),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)); end;
(self):setupClass_(aMetaClass);
if ((smalltalk.Smalltalk):includesKey_("Exporter"))==true then (self):print_(((smalltalk.Exporter):new()):exportMetaDefinitionOf_((aMetaClass):instanceClass())); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"metaclass","class: aMetaClass instanceVariableNames: aString\r\n\t\" Register instance variable names onto aMetaClass. \"\r\n\r\n\t| varNames |\r\n\taMetaClass isMetaclass ifFalse: [\r\n\t\t^self error: aMetaClass name, ' is not a metaclass'\r\n\t].\r\n\tvarNames := self instanceVariableNamesFor: aString.\r\n\tvarNames = aMetaClass instanceVariableNames ifFalse: [\r\n\t\t(self basicClass: aMetaClass instanceVariableNames: varNames) ifFalse: [ ^false ].\r\n\t].\r\n\tself setupClass: aMetaClass.\r\n\t(Smalltalk includesKey: #Exporter) ifTrue: [\r\n\t\tself print: (Exporter new exportMetaDefinitionOf: aMetaClass instanceClass)\r\n\t].\r\n\t^true ","(\r\nfunction(self,aMetaClass,aString)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal varNames=nil\r\nif not (((aMetaClass):isMetaclass()))==true then return ((self):error_(smalltalk:object_comma_(((aMetaClass):name()),\" is not a metaclass\"))); end;\r\n(function()\r\n\tlocal _s8_value=((self):instanceVariableNamesFor_(aString))\r\n\tvarNames=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:isObject_equalTo_((varNames),(aMetaClass):instanceVariableNames())))==true then smalltalk:if_true_false_(((self):basicClass_instanceVariableNames_(aMetaClass,varNames)),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)); end;\r\n(self):setupClass_(aMetaClass);\r\nif ((smalltalk.Smalltalk):includesKey_(\"Exporter\"))==true then (self):print_(((smalltalk.Exporter):new()):exportMetaDefinitionOf_((aMetaClass):instanceClass())); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassBuilder,"instanceVariableNamesFor:",0
,(
function(self,aString)
local result=nil
(function()
	local _s8_value=((aString):asArrayOfSubstrings())
	result=_s8_value
	return _s8_value
end)();
if not ((smalltalk:isObject_equalTo_(((result):size()),((result):asSet()):size())))==true then return ((self):error_(smalltalk:object_comma_(("Invalid instance variable names "),(result):asLiteral()))); end;
return (result);
end
)
,"private","instanceVariableNamesFor: aString\r\n\t\" Private - Return the instance variable names string. \"\r\n\r\n\t| result |\r\n\tresult := aString asArrayOfSubstrings.\r\n\tresult size = result asSet size ifFalse: [\r\n\t\t^self error: 'Invalid instance variable names ' ,result asLiteral\r\n\t].\r\n\t^result","(\r\nfunction(self,aString)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((aString):asArrayOfSubstrings())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:isObject_equalTo_(((result):size()),((result):asSet()):size())))==true then return ((self):error_(smalltalk:object_comma_((\"Invalid instance variable names \"),(result):asLiteral()))); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassBuilder,"addSubclassOf:named:instanceVariableNames:",0
,(
function(self,aClass,aString,aCollection)

	smalltalk:addClass(aString, aClass, aCollection)
	if true then return smalltalk[aString] end;
return (self);
end
)
,"private","addSubclassOf: aClass named: aString instanceVariableNames: aCollection\r\n\t\" Private - Add the subclass to system. \"\r\n\r\n\t{'' doc'native instantiation'}","(\r\nfunction(self,aClass,aString,aCollection)\r\n\r\n\tsmalltalk:addClass(aString, aClass, aCollection)\r\n\tif true then return smalltalk[aString] end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassBuilder,"setupClass:",0
,(
function(self,aClass)
return (self);
end
)
,"private","setupClass: aClass\r\n\t\" Private - Bind/initialize the class delegation chain. \"","(\r\nfunction(self,aClass)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream["$klass"],"on:",0
,(
function(self,aCollection)
return ((
function(_s8_rec)
	(_s8_rec):collection_(aCollection);
	(_s8_rec):readLimit_((aCollection):size());
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","on: aCollection\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new \r\n\t\tcollection: aCollection;\r\n\t\treadLimit: aCollection size;\r\n\t\tyourself","(\r\nfunction(self,aCollection)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):collection_(aCollection);\r\n\t(_s8_rec):readLimit_((aCollection):size());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"collection",0
,(
function(self)
return (self["@collection"]);
end
)
,"accessing","collection\r\n\t\" Private - Return the collection of the receiver. \"\r\n\r\n\t^collection","(\r\nfunction(self)\r\nreturn (self[\"@collection\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"collection:",0
,(
function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@collection"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","collection: aCollection\r\n\t\" Private - Set the collection of the receiver. \"\r\n\r\n\tcollection := aCollection","(\r\nfunction(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@collection\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"setCollection:",0
,(
function(self,aCollection)
(self):collection_(aCollection);
return (self);
end
)
,"accessing","setCollection: aCollection\r\n\t\" Private - Set the receiver stream collection to aCollection. \"\r\n\r\n\tself collection: aCollection","(\r\nfunction(self,aCollection)\r\n(self):collection_(aCollection);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"initialize",0
,(
function(self)
smalltalk:superImplementor(smalltalk.Stream,"initialize")(self);
(function()
	local _s8_value=(0)
	self["@position"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"initialize","initialize\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsuper initialize.\r\n\tposition := 0.","(\r\nfunction(self)\r\nsmalltalk:superImplementor(smalltalk.Stream,\"initialize\")(self);\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tself[\"@position\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"position",0
,(
function(self)
return (self["@position"]);
end
)
,"accessing","position\r\n\t\" Return the position of the receiver. \"\r\n\r\n\t^position","(\r\nfunction(self)\r\nreturn (self[\"@position\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"position:",0
,(
function(self,anInteger)
(function()
	local _s8_value=(anInteger)
	self["@position"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","position: anInteger\r\n\t\" Set the position of the receiver. \"\r\n\r\n\tposition := anInteger","(\r\nfunction(self,anInteger)\r\n(function()\r\n\tlocal _s8_value=(anInteger)\r\n\tself[\"@position\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"readLimit",0
,(
function(self)
if (((self["@readLimit"])==nil))==true then (function()
	local _s8_value=(((self):collection()):size())
	self["@readLimit"]=_s8_value
	return _s8_value
end)(); end;
return (self["@readLimit"]);
end
)
,"accessing","readLimit\r\n\t\" Private - Return the read limit of the receiver. \"\r\n\r\n\treadLimit == nil ifTrue: [ readLimit := self collection size ].\r\n\t^readLimit","(\r\nfunction(self)\r\nif (((self[\"@readLimit\"])==nil))==true then (function()\r\n\tlocal _s8_value=(((self):collection()):size())\r\n\tself[\"@readLimit\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@readLimit\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"readLimit:",0
,(
function(self,anInteger)
(function()
	local _s8_value=(anInteger)
	self["@readLimit"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","readLimit: anInteger\r\n\t\" Private - Set the stream size of the receiver. \"\r\n\r\n\treadLimit := anInteger","(\r\nfunction(self,anInteger)\r\n(function()\r\n\tlocal _s8_value=(anInteger)\r\n\tself[\"@readLimit\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"contents",0
,(
function(self)
local result=nil
(function()
	local _s8_value=((self):collection())
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((self):readLimit()),(result):size()))==true then return (result); end;
return ((result):copyFrom_to_(1,(self):readLimit()));
end
)
,"accessing","contents\r\n\t\" Return the contents of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self collection.\r\n\tself readLimit = result size ifTrue: [ ^result ].\r\n\t^result copyFrom: 1 to: self readLimit","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):collection())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((self):readLimit()),(result):size()))==true then return (result); end;\r\nreturn ((result):copyFrom_to_(1,(self):readLimit()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"size",0
,(
function(self)
return ((self):readLimit());
end
)
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^self readLimit","(\r\nfunction(self)\r\nreturn ((self):readLimit());\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"reset",0
,(
function(self)
(self):position_(0);
return (self);
end
)
,"actions","reset\r\n\t\" Reset the receiver. \"\r\n\r\n\tself position: 0","(\r\nfunction(self)\r\n(self):position_(0);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"close",0
,(
function(self)
return (self);
end
)
,"actions","close\r\n\t\" Close the receiver. \"","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"flush",0
,(
function(self)
return (self);
end
)
,"io","flush\r\n\t\" Flush the receiver. \"","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"resetContents",0
,(
function(self)
(
function(_s8_rec)
	(_s8_rec):reset();
	return ((_s8_rec):readLimit_(0))
end
)(self);
return (self);
end
)
,"actions","resetContents\r\n\t\" Reset the receiver contents. \"\r\n\r\n\tself reset; readLimit: 0","(\r\nfunction(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):reset();\r\n\treturn ((_s8_rec):readLimit_(0))\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"do:",0
,(
function(self,aBlock)
while not ((function()
return ((self):atEnd())
end))() do (aBlock):value_((self):next()); end;
return (self);
end
)
,"enumerating","do: aBlock\r\n\t\" Evaluates aBlock streaming on the receiver. \"\r\n\r\n\t[ self atEnd ] whileFalse: [ aBlock value: self next ]","(\r\nfunction(self,aBlock)\r\nwhile not ((function()\r\nreturn ((self):atEnd())\r\nend))() do (aBlock):value_((self):next()); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"setToEnd",0
,(
function(self)
(self):position_((self):size());
return (self);
end
)
,"positioning","setToEnd\r\n\t\" Position the receiver at end. \"\r\n\r\n\tself position: self size","(\r\nfunction(self)\r\n(self):position_((self):size());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"skip:",0
,(
function(self,anInteger)
(self):position_((((anInteger):_plus((self):position())):min_((self):size())):max_(0));
return (self);
end
)
,"positioning","skip: anInteger\r\n\t\" Skip next anInteger readable elements in the receiver. \"\r\n\r\n\tself position: ((anInteger + self position min: self size) max: 0)","(\r\nfunction(self,anInteger)\r\n(self):position_((((anInteger):_plus((self):position())):min_((self):size())):max_(0));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"next",0
,(
function(self)
(self):position_(((self):position()):_plus(1));
return ((self["@collection"]):at_((self):position()));
end
)
,"reading","next\r\n\t\" Return the next readable element in the receiver (or nil). \"\r\n\r\n\tself position: self position + 1. \r\n\t^collection at: self position","(\r\nfunction(self)\r\n(self):position_(((self):position()):_plus(1));\r\nreturn ((self[\"@collection\"]):at_((self):position()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"next:",0
,(
function(self,anInteger)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
(function()
	local _s8_value=((((self):collection()):species()):new())
	result=_s8_value
	return _s8_value
end)();
smalltalk:times_repeat_((anInteger),(function()
if ((self):atEnd())==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)(); end;return ((result):add_((self):next()))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"reading","next: anInteger\r\n\t\" Return the next anInteger elements read from the receiver.\r\n\tIf the receiver reach its end, the returned collection has less elements.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := self collection species new.\r\n\tanInteger timesRepeat: [\r\n\t\tself atEnd ifTrue: [ ^result ].\r\n\t\tresult add: self next.\r\n\t].\r\n\t^result","(\r\nfunction(self,anInteger)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((((self):collection()):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:times_repeat_((anInteger),(function()\r\nif ((self):atEnd())==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return ((result):add_((self):next()))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"nextPut:",0
,(
function(self,anObject)
(self):position_(((self):position()):_plus(1));
((self):collection()):at_put_(self["@position"],anObject);
(self):readLimit_(((self):readLimit()):max_(self["@position"]));
return (self);
end
)
,"writing","nextPut: anObject\r\n\t\" Put anObject onto the receiver. \"\r\n\r\n\tself position: self position + 1.\r\n\tself collection at: position put: anObject.\r\n\tself readLimit: (self readLimit max: position)","(\r\nfunction(self,anObject)\r\n(self):position_(((self):position()):_plus(1));\r\n((self):collection()):at_put_(self[\"@position\"],anObject);\r\n(self):readLimit_(((self):readLimit()):max_(self[\"@position\"]));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"nextPutAll:",0
,(
function(self,aCollection)
(aCollection):do_((function(each)
return ((self):nextPut_(each))
end));
return (self);
end
)
,"writing","nextPutAll: aCollection\r\n\t\" Put aCollection onto the receiver. \"\r\n\r\n\taCollection do: [:each | self nextPut: each ]","(\r\nfunction(self,aCollection)\r\n(aCollection):do_((function(each)\r\nreturn ((self):nextPut_(each))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"cr",0
,(
function(self)
(self):nextPutAll_((smalltalk.String):crlf());
return (self);
end
)
,"writing","cr\r\n\t\" Put a line break sequence onto the receiver.\r\n\tNote: this implementation MUST be consistent with #nextLine\r\n\t\"\r\n\r\n\tself nextPutAll: String crlf","(\r\nfunction(self)\r\n(self):nextPutAll_((smalltalk.String):crlf());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"space",0
,(
function(self)
(self):nextPutAll_((smalltalk.String):space());
return (self);
end
)
,"writing","space\r\n\t\" Put a space sequence onto the receiver. \"\r\n\r\n\tself nextPutAll: String space","(\r\nfunction(self)\r\n(self):nextPutAll_((smalltalk.String):space());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"tab",0
,(
function(self)
(self):nextPutAll_((smalltalk.String):tab());
return (self);
end
)
,"writing","tab\r\n\t\" Put a tab sequence onto the receiver. \"\r\n\r\n\tself nextPutAll: String tab","(\r\nfunction(self)\r\n(self):nextPutAll_((smalltalk.String):tab());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"peek",0
,(
function(self)
return (smalltalk:if_true_false_(((self):atEnd()),nil,(function()
return (((self):collection()):at_(((self):position()):_plus(1)))
end)));
end
)
,"reading","peek\r\n\t\" Return the next readable element from the receiver without advancing the receiver (or nil). \"\r\n\r\n\t^self atEnd ifFalse: [\r\n\t    self collection at: self position + 1\r\n\t]","(\r\nfunction(self)\r\nreturn (smalltalk:if_true_false_(((self):atEnd()),nil,(function()\r\nreturn (((self):collection()):at_(((self):position()):_plus(1)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"peekFor:",0
,(
function(self,anObject)
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((anObject),(self):peek())),(function()
if not (((self):atEnd()))==true then (self):next(); end;return (true)
end)));
end
)
,"reading","peekFor: anObject\r\n\t\" Return true if the next readable element from the receiver equals anObject.\r\n\tAdvance the receiver if the result is true.\r\n\t\"\r\n\r\n\t^anObject = self peek and: [\r\n\t\tself atEnd ifFalse: [ self next ].\r\n\t\ttrue\r\n\t]","(\r\nfunction(self,anObject)\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((anObject),(self):peek())),(function()\r\nif not (((self):atEnd()))==true then (self):next(); end;return (true)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"peekForAll:",0
,(
function(self,aCollection)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local back=nil
(function()
	local _s8_value=((self):position())
	back=_s8_value
	return _s8_value
end)();
(aCollection):do_((function(each)
return (smalltalk:if_true_false_(((self):peekFor_(each)),nil,(function()
(self):position_(back);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"reading","peekForAll: aCollection\r\n\t\" Return true if the next readable elements from the receiver matches aCollection.\r\n\tAdvance the receiver if the result is true.\r\n\t\"\r\n\r\n\t| back |\r\n\tback := self position.\r\n\taCollection do: [:each|\r\n\t\t(self peekFor: each) ifFalse: [\r\n\t\t\tself position: back.\r\n\t\t\t^false\r\n\t\t].\r\n\t].\r\n\t^true","(\r\nfunction(self,aCollection)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal back=nil\r\n(function()\r\n\tlocal _s8_value=((self):position())\r\n\tback=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aCollection):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((self):peekFor_(each)),nil,(function()\r\n(self):position_(back);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"atEnd",0
,(
function(self)
return ((((self):position()) >= (self):size()));
end
)
,"testing","atEnd\r\n\t\" Return true if the receiver is at end. \"\r\n\r\n\t^self position >= self size","(\r\nfunction(self)\r\nreturn ((((self):position()) >= (self):size()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"atStart",0
,(
function(self)
return (smalltalk:isObject_equalTo_(((self):position()),0));
end
)
,"testing","atStart\r\n\t\" Return true if the receiver is at start position. \"\r\n\r\n\t^self position = 0","(\r\nfunction(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):position()),0));\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"isEmpty",0
,(
function(self)
return (smalltalk:isObject_equalTo_(((self):size()),0));
end
)
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^self size = 0","(\r\nfunction(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):size()),0));\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"notEmpty",0
,(
function(self)
return (smalltalk:booleanNot_(((self):isEmpty())));
end
)
,"testing","notEmpty\r\n\t\" Return true if the receiver is not empty. \"\r\n\r\n\t^self isEmpty not","(\r\nfunction(self)\r\nreturn (smalltalk:booleanNot_(((self):isEmpty())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"upTo:",0
,(
function(self,anObject)
local result=nil
(function()
	local _s8_value=((((self):collection()):species()):new())
	result=_s8_value
	return _s8_value
end)();
while not ((function()
return (smalltalk:boolean_or_(((self):atEnd()),(function()
return (smalltalk:isObject_equalTo_(((self):peek()),anObject))
end)))
end))() do (result):add_((self):next()); end;
if not (((self):atEnd()))==true then (self):next(); end;
return (result);
end
)
,"reading","upTo: anObject\r\n\t\" Return the elements read from the receiver upto anObject (or end). \"\r\n\r\n\t| result |\r\n\tresult := self collection species new.\r\n\t[ self atEnd or: [ self peek = anObject ]] whileFalse: [\r\n\t\tresult add: self next\r\n\t].\r\n\tself atEnd ifFalse: [ self next ].\r\n\t^result","(\r\nfunction(self,anObject)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((((self):collection()):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn (smalltalk:boolean_or_(((self):atEnd()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((self):peek()),anObject))\r\nend)))\r\nend))() do (result):add_((self):next()); end;\r\nif not (((self):atEnd()))==true then (self):next(); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"upToEnd",0
,(
function(self)
local result=nil
(function()
	local _s8_value=(((self):collection()):copyFrom_to_(((self):position()):_plus(1),(self):readLimit()))
	result=_s8_value
	return _s8_value
end)();
(self):setToEnd();
return (result);
end
)
,"reading","upToEnd\r\n\t\" Return the contents of the receiver upto end. \"\r\n\r\n\t| result |\r\n\tresult := self collection copyFrom: self position + 1 to: self readLimit.\r\n\tself setToEnd.\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):collection()):copyFrom_to_(((self):position()):_plus(1),(self):readLimit()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):setToEnd();\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"nextLine",0
,(
function(self)
local result=nil
local start=nil
(function()
	local _s8_value=((self):position())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):upTo_((smalltalk.String):cr()))
	result=_s8_value
	return _s8_value
end)();
if ((result):includes_((smalltalk.String):lf()))==true then return ((
function(_s8_rec)
	(_s8_rec):position_(start);
	return ((_s8_rec):upTo_((smalltalk.String):lf()))
end
)(self)); end;
if (smalltalk:isObject_equalTo_(((self):peek()),(smalltalk.String):lf()))==true then (self):next(); end;
return (result);
end
)
,"reading","nextLine\r\n\t\" Return the characters read from the receiver up to the line delimiter. \"\r\n\r\n\t| result start |\r\n\tstart := self position.\r\n\tresult := self upTo: String cr.\r\n\t(result includes: String lf) ifTrue: [\r\n\t\t^self position: start; upTo: String lf\r\n\t].\r\n\t(self peek = String lf) ifTrue: [ self next ].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\nlocal start=nil\r\n(function()\r\n\tlocal _s8_value=((self):position())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):upTo_((smalltalk.String):cr()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((result):includes_((smalltalk.String):lf()))==true then return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):position_(start);\r\n\treturn ((_s8_rec):upTo_((smalltalk.String):lf()))\r\nend\r\n)(self)); end;\r\nif (smalltalk:isObject_equalTo_(((self):peek()),(smalltalk.String):lf()))==true then (self):next(); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"skipTo:",0
,(
function(self,anObject)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
while not ((function()
return ((self):atEnd())
end))() do smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):next()),anObject)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"reading","skipTo: anObject\r\n\t\" Advance the receiver upto anObject (or end). \"\r\n\r\n\t[ self atEnd ] whileFalse: [\r\n\t\tself next = anObject ifTrue: [ ^true ].\r\n\t].\r\n\t^false","(\r\nfunction(self,anObject)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nwhile not ((function()\r\nreturn ((self):atEnd())\r\nend))() do smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):next()),anObject)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"skipSeparators",0
,(
function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
while ((function()
if ((self):atEnd())==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)(); end;return (((self):peek()):isSeparator())
end))() do (self):next(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"reading","skipSeparators\r\n\t\" Advance the receiver upto a non-separator (or end).\r\n\tReturn true  if a non-separator contents is found,\r\n\treturn false if run upto end of stream.\r\n\t\"\r\n\r\n\t[ self atEnd ifTrue: [ ^false ].\r\n\t  self peek isSeparator\r\n\t] whileTrue: [ self next ].\r\n\t^true","(\r\nfunction(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nwhile ((function()\r\nif ((self):atEnd())==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return (((self):peek()):isSeparator())\r\nend))() do (self):next(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"nextChunk",0
,(
function(self)
local result=nil
(function()
	local _s8_value=((self):upTo_("!"))
	result=_s8_value
	return _s8_value
end)();
while ((function()
return (smalltalk:isObject_equalTo_(((self):peek()),"!"))
end))() do (self):next();
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((result),"!")),(self):upTo_("!")))
	result=_s8_value
	return _s8_value
end)(); end;
return ((result):trimFirst_((function(c)
return ((((c):asciiValue()) <= 32))
end)));
end
)
,"Tools-fileIn","nextChunk\r\n\t\" FileIn - Return the next chunk read from the receiver.\r\n\tTrailing non-printing characters are skipped. \"\r\n\r\n\t| result |\r\n\tresult := self upTo: $!.\r\n\t[ self peek = $! ] whileTrue: [\r\n\t\tself next.\r\n\t\tresult := result, '!', (self upTo: $!)\r\n\t].\r\n\t^result trimFirst: [:c| c asciiValue <= 32 ]","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):upTo_(\"!\"))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (smalltalk:isObject_equalTo_(((self):peek()),\"!\"))\r\nend))() do (self):next();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((result),\"!\")),(self):upTo_(\"!\")))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((result):trimFirst_((function(c)\r\nreturn ((((c):asciiValue()) <= 32))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"fileInto:",0
,(
function(self,aReceiver)
local scanner=nil
while not ((function()
return ((self):atEnd())
end))() do if (smalltalk:isNil_((scanner)))==true then (function()
	local _s8_value=(aReceiver)
	scanner=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=((scanner):scanFrom_(self))
	scanner=_s8_value
	return _s8_value
end)(); end;
return (scanner);
end
)
,"Tools-fileIn","fileInto: aReceiver\r\n\t\" FileIn - FileIn the receiver's contents (in chunk format) using aReceiver as default scanner. \"\r\n\r\n\t| scanner |\r\n\t[self atEnd] whileFalse: [\r\n\t\tscanner isNil ifTrue: [ scanner := aReceiver ].\r\n\t\tscanner := scanner scanFrom: self\r\n\t].\r\n\t^scanner","(\r\nfunction(self,aReceiver)\r\nlocal scanner=nil\r\nwhile not ((function()\r\nreturn ((self):atEnd())\r\nend))() do if (smalltalk:isNil_((scanner)))==true then (function()\r\n\tlocal _s8_value=(aReceiver)\r\n\tscanner=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((scanner):scanFrom_(self))\r\n\tscanner=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (scanner);\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"fileIn",0
,(
function(self)
return ((self):fileInto_(nil));
end
)
,"Tools-fileIn","fileIn\r\n\t\" FileIn - FileIn the receiver's contents (in chunk format). \"\r\n\r\n\t^self fileInto: nil","(\r\nfunction(self)\r\nreturn ((self):fileInto_(nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Stream,"nextChunkPut:",0
,(
function(self,aString)
local eoc=nil
local parts=nil
(function()
	local _s8_value=("!")
	eoc=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((aString)))==true then (self):nextPut_(eoc);
return (nil); end;
if ((aString):isEmpty())==true then (self):nextPut_(" "); end;
((aString):asArrayOfSubstringsSeparatedBy_(eoc)):do_separatedBy_((function(each)
return ((self):nextPutAll_(each))
end),(function()
return ((self):nextPutAll_(smalltalk:object_comma_((eoc),eoc)))
end));
(self):nextPut_(eoc);
return (aString);
end
)
,"Tools-fileOut","nextChunkPut: aString\r\n\t\" Output aString in chunk format. \"\r\n\r\n\t| eoc parts |\r\n\teoc := $!.\r\n\taString isNil ifTrue: [  self nextPut: eoc. ^nil ].\r\n\taString isEmpty ifTrue: [ self nextPut: $ ].\r\n\t(aString asArrayOfSubstringsSeparatedBy: eoc)\r\n\t\tdo: [:each| self nextPutAll: each ]\r\n\t\tseparatedBy: [ self nextPutAll: eoc,eoc ].\r\n\tself nextPut: eoc.\r\n\t^aString","(\r\nfunction(self,aString)\r\nlocal eoc=nil\r\nlocal parts=nil\r\n(function()\r\n\tlocal _s8_value=(\"!\")\r\n\teoc=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((aString)))==true then (self):nextPut_(eoc);\r\nreturn (nil); end;\r\nif ((aString):isEmpty())==true then (self):nextPut_(\" \"); end;\r\n((aString):asArrayOfSubstringsSeparatedBy_(eoc)):do_separatedBy_((function(each)\r\nreturn ((self):nextPutAll_(each))\r\nend),(function()\r\nreturn ((self):nextPutAll_(smalltalk:object_comma_((eoc),eoc)))\r\nend));\r\n(self):nextPut_(eoc);\r\nreturn (aString);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringStream,"next:",0
,(
function(self,anInteger)
local start=nil
local result=nil
local stop=nil
(function()
	local _s8_value=((self):position())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((start):_plus(anInteger)):min_((self):readLimit()))
	stop=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((self):collection()):copyFrom_to_((start):_plus(1),stop))
	result=_s8_value
	return _s8_value
end)();
(self):position_(stop);
return (result);
end
)
,"reading","next: anInteger\r\n\t\" Return the next anInteger elements read from the receiver.\r\n\tIf the receiver reach its end, the returned collection has less elements.\r\n\t\"\r\n\r\n\t| start result stop |\r\n\tstart := self position.\r\n\tstop := start + anInteger min: self readLimit.\r\n\tresult := self collection copyFrom: start + 1 to: stop.\r\n\tself position: stop.\r\n\t^result","(\r\nfunction(self,anInteger)\r\nlocal start=nil\r\nlocal result=nil\r\nlocal stop=nil\r\n(function()\r\n\tlocal _s8_value=((self):position())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((start):_plus(anInteger)):min_((self):readLimit()))\r\n\tstop=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((self):collection()):copyFrom_to_((start):_plus(1),stop))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):position_(stop);\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringStream,"nextPut:",0
,(
function(self,aString)
(self):nextPutAll_(aString);
return (self);
end
)
,"writing","nextPut: aString\r\n\t\" Put aString onto the receiver. \"\r\n\r\n\tself nextPutAll: aString","(\r\nfunction(self,aString)\r\n(self):nextPutAll_(aString);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringStream,"nextPutAll:",0
,(
function(self,aString)
local result=nil
if (smalltalk:isObject_equalTo_(((self):position()),((self):collection()):size()))==true then (function()
	local _s8_value=(smalltalk:object_comma_(((self):collection()),aString))
	result=_s8_value
	return _s8_value
end)(); else local substring=nil
(function()
	local _s8_value=(((self):collection()):copyFrom_to_(1,(self):position()))
	substring=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_(((substring):isEmpty()),(function()
return (aString)
end),(function()
return (smalltalk:object_comma_((substring),aString))
end)))
	result=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((self):collection()):copyFrom_to_((((self):position()):_plus(1)):_plus((aString):size()),((self):collection()):size()))
	substring=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_(((substring):isEmpty()),(function()
return (result)
end),(function()
return (smalltalk:object_comma_((result),substring))
end)))
	result=_s8_value
	return _s8_value
end)(); end;
(self):collection_(result);
(self):position_(((self):position()):_plus((aString):size()));
(self):readLimit_(((self):readLimit()):max_(self["@position"]));
return (self);
end
)
,"writing","nextPutAll: aString\r\n\t\" Put aString onto the receiver at current position; expanding internal contents. \"\r\n\r\n\t| result |\r\n\tself position = self collection size\r\n\tifTrue: [ result := self collection , aString ]\r\n\tifFalse: [ | substring |\r\n\t\tsubstring := self collection copyFrom: 1 to: self position.\r\n\t\tresult := substring isEmpty ifTrue: [ aString ] ifFalse: [ substring , aString ].\r\n\t\tsubstring := self collection\r\n\t\t\tcopyFrom: self position + 1 + aString size\r\n\t\t\tto: self collection size.\r\n\t\tresult := substring isEmpty ifTrue: [ result ] ifFalse: [ result , substring ].\r\n\t].\r\n\tself collection: result.\r\n\tself position: self position + aString size.\r\n\tself readLimit: (self readLimit max: position)","(\r\nfunction(self,aString)\r\nlocal result=nil\r\nif (smalltalk:isObject_equalTo_(((self):position()),((self):collection()):size()))==true then (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((self):collection()),aString))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)(); else local substring=nil\r\n(function()\r\n\tlocal _s8_value=(((self):collection()):copyFrom_to_(1,(self):position()))\r\n\tsubstring=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((substring):isEmpty()),(function()\r\nreturn (aString)\r\nend),(function()\r\nreturn (smalltalk:object_comma_((substring),aString))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((self):collection()):copyFrom_to_((((self):position()):_plus(1)):_plus((aString):size()),((self):collection()):size()))\r\n\tsubstring=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((substring):isEmpty()),(function()\r\nreturn (result)\r\nend),(function()\r\nreturn (smalltalk:object_comma_((result),substring))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(self):collection_(result);\r\n(self):position_(((self):position()):_plus((aString):size()));\r\n(self):readLimit_(((self):readLimit()):max_(self[\"@position\"]));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringStream,"skipTo:",0
,(
function(self,anObject)
local index=nil
if not (((anObject):isString()))==true then (self):setToEnd();
return (false); end;
(function()
	local _s8_value=(((self):collection()):indexOf_startingAt_(anObject,((self):position()):_plus(1)))
	index=_s8_value
	return _s8_value
end)();
if ((index):between_and_(((self):position()):_plus(1),(self):readLimit()))==true then (self):position_(((index):_plus((anObject):size())):_minus(1));
return (true); end;
(self):setToEnd();
return (false);
end
)
,"reading","skipTo: anObject\r\n\t\" Advance the receiver upto anObject (or end). \"\r\n\r\n\t| index |\r\n\tanObject isString ifFalse: [ self setToEnd. ^false ].\r\n\tindex := self collection indexOf: anObject startingAt: self position + 1.\r\n\t(index between: self position + 1 and: self readLimit) ifTrue: [\r\n\t\tself position: index + anObject size - 1.\r\n\t\t^true\r\n\t].\r\n\tself setToEnd.\r\n\t^false","(\r\nfunction(self,anObject)\r\nlocal index=nil\r\nif not (((anObject):isString()))==true then (self):setToEnd();\r\nreturn (false); end;\r\n(function()\r\n\tlocal _s8_value=(((self):collection()):indexOf_startingAt_(anObject,((self):position()):_plus(1)))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((index):between_and_(((self):position()):_plus(1),(self):readLimit()))==true then (self):position_(((index):_plus((anObject):size())):_minus(1));\r\nreturn (true); end;\r\n(self):setToEnd();\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringStream,"upTo:",0
,(
function(self,anObject)
local start=nil
local found=nil
if not (((anObject):isString()))==true then return ((self):upToEnd()); end;
(function()
	local _s8_value=(((self):position()):_plus(1))
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_(((self):skipTo_(anObject)),(function()
return ((anObject):size())
end),(function()
return (0)
end)))
	found=_s8_value
	return _s8_value
end)();
return (((self):collection()):copyFrom_to_(start,((self):position()):_minus(found)));
end
)
,"reading","upTo: anObject\r\n\t\" Return the elements read from the receiver upto anObject (or end). \"\r\n\r\n\t| start found |\r\n\tanObject isString ifFalse: [ ^self upToEnd ].\r\n\tstart := self position + 1.\r\n\tfound := (self skipTo: anObject) ifTrue: [ anObject size ] ifFalse: [ 0 ].\r\n\t^self collection copyFrom: start to: self position - found","(\r\nfunction(self,anObject)\r\nlocal start=nil\r\nlocal found=nil\r\nif not (((anObject):isString()))==true then return ((self):upToEnd()); end;\r\n(function()\r\n\tlocal _s8_value=(((self):position()):_plus(1))\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((self):skipTo_(anObject)),(function()\r\nreturn ((anObject):size())\r\nend),(function()\r\nreturn (0)\r\nend)))\r\n\tfound=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((self):collection()):copyFrom_to_(start,((self):position()):_minus(found)));\r\nend\r\n)")
smalltalk:bind(smalltalk.StringStream,"peek",0
,(
function(self)

	local c = self["@collection"]:at_(self:position()+1)
	if c=="" then return nil else return c end;
return (self);
end
)
,"reading","peek\r\n\t\" Return the next readable element from the receiver without advancing (or nil). \"\r\n\r\n\t{'' doc'native accessing'}","(\r\nfunction(self)\r\n\r\n\tlocal c = self[\"@collection\"]:at_(self:position()+1)\r\n\tif c==\"\" then return nil else return c end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringStream,"next",0
,(
function(self)
local result=nil
(function()
	local _s8_value=((self):peek())
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((result)))==true then (function()
	local _s8_value=((self["@position"]):_plus(1))
	self["@position"]=_s8_value
	return _s8_value
end)(); end;
return (result);
end
)
,"reading","next\r\n\t\" Return the next readable element in the receiver (or nil). \"\r\n\r\n\t| result |\r\n\tresult := self peek.\r\n\tresult notNil ifTrue: [ position := position + 1 ].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):peek())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((result)))==true then (function()\r\n\tlocal _s8_value=((self[\"@position\"]):_plus(1))\r\n\tself[\"@position\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringStream,"peekForAll:",0
,(
function(self,aCollection)
if not (((aCollection):isString()))==true then return (smalltalk:superImplementor(smalltalk.StringStream,"peekForAll_")(self,aCollection)); end;

	local start=self:position()
	if (self["@collection"]:sub(start+1,start+#aCollection)~=aCollection) then return false end;
(function()
	local _s8_value=((self["@position"]):_plus((aCollection):size()))
	self["@position"]=_s8_value
	return _s8_value
end)();
return (true);
end
)
,"reading","peekForAll: aCollection\r\n\t\" Return true if the next readable elements from the receiver matches aCollection.\r\n\tAdvance the receiver if the result is true.\r\n\t\"\r\n\r\n\taCollection isString ifFalse: [ ^super peekForAll: aCollection ].\r\n\t{'' doc'native accessing'}.\r\n\tposition := position + aCollection size.\r\n\t^true","(\r\nfunction(self,aCollection)\r\nif not (((aCollection):isString()))==true then return (smalltalk:superImplementor(smalltalk.StringStream,\"peekForAll_\")(self,aCollection)); end;\r\n\r\n\tlocal start=self:position()\r\n\tif (self[\"@collection\"]:sub(start+1,start+#aCollection)~=aCollection) then return false end;\r\n(function()\r\n\tlocal _s8_value=((self[\"@position\"]):_plus((aCollection):size()))\r\n\tself[\"@position\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringStream,"upToSeparator",0
,(
function(self)
local start=nil
(function()
	local _s8_value=(((self):position()):_plus(1))
	start=_s8_value
	return _s8_value
end)();
while ((function()
return (smalltalk:boolean_and_((smalltalk:booleanNot_(((self):atEnd()))),(function()
return (smalltalk:booleanNot_((((self):peek()):isSeparator())))
end)))
end))() do (self):next(); end;
return (((self):collection()):copyFrom_to_(start,(self):position()));
end
)
,"reading","upToSeparator\r\n\t\" Return the elements read from the receiver upto a separator (or end). \"\r\n\r\n\t| start |\r\n\tstart := self position + 1.\r\n\t[self atEnd not and: [self peek isSeparator not]] whileTrue: [\r\n\t\tself next\r\n\t].\r\n\t^self collection copyFrom: start to: self position","(\r\nfunction(self)\r\nlocal start=nil\r\n(function()\r\n\tlocal _s8_value=(((self):position()):_plus(1))\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (smalltalk:boolean_and_((smalltalk:booleanNot_(((self):atEnd()))),(function()\r\nreturn (smalltalk:booleanNot_((((self):peek()):isSeparator())))\r\nend)))\r\nend))() do (self):next(); end;\r\nreturn (((self):collection()):copyFrom_to_(start,(self):position()));\r\nend\r\n)")
smalltalk:bind(smalltalk.StringStream,"nextMessagePattern",0
,(
function(self)
local part=nil
local selector=nil
local args=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	args=_s8_value
	return _s8_value
end)();
(self):skipSeparators();
(function()
	local _s8_value=((self):upToSeparator())
	selector=_s8_value
	return _s8_value
end)();
if ((selector):isEmpty())==true then return (nil); end;
if ((((selector):argumentCount()) > 0))==true then smalltalk:while_do_(((function()
(self):skipSeparators();(args):add_((self):upToSeparator());(self):skipSeparators();(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):peek()),"\"")),(function()
return ("")
end),(function()
return ((self):upToSeparator())
end)))
	part=_s8_value
	return _s8_value
end)();return (smalltalk:boolean_and_(((part):notEmpty()),(function()
return (smalltalk:isObject_equalTo_(((part):last()),":"))
end)))
end)),(function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((selector),part))
	selector=_s8_value
	return _s8_value
end)())
end)); end;
(function()
	local _s8_value=((smalltalk.Message):selector_arguments_(selector,args))
	part=_s8_value
	return _s8_value
end)();
(self):skipSeparators();
if (smalltalk:isObject_equalTo_(((self):peek()),"\""))==true then (part):comment_(((
function(_s8_rec)
	(_s8_rec):next();
	return ((_s8_rec):upTo_("\""))
end
)(self)):trimBlanks()); end;
return (part);
end
)
,"tools","nextMessagePattern\r\n\t\" Return a message pattern read from the receiver (or nil).\r\n\tNote: it is assumed that there is a correct message header in the receiver.\r\n\t\"\r\n\r\n\t| part selector args |\r\n\targs := #().\r\n\tself skipSeparators.\r\n\tselector := self upToSeparator.\r\n\tselector isEmpty ifTrue: [ ^nil ].\r\n\tselector argumentCount > 0 ifTrue: [\r\n\t\t[ self skipSeparators.\r\n\t\t  args add: self upToSeparator.\r\n\t\t  self skipSeparators.\r\n\t\t  part := self peek = $\" ifTrue: [ '' ]\r\n\t\t\tifFalse: [ self upToSeparator ].\r\n\t\t  part notEmpty and: [ part last = $: ]\r\n\t\t] whileTrue: [\r\n\t\t  selector := selector , part\r\n\t\t].\r\n\t].\r\n\tpart := Message selector: selector arguments: args.\r\n\tself skipSeparators.\r\n\tself peek = $\" ifTrue: [\r\n\t\tpart comment: (self next; upTo: $\") trimBlanks\r\n\t].\r\n\t^part","(\r\nfunction(self)\r\nlocal part=nil\r\nlocal selector=nil\r\nlocal args=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):skipSeparators();\r\n(function()\r\n\tlocal _s8_value=((self):upToSeparator())\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((selector):isEmpty())==true then return (nil); end;\r\nif ((((selector):argumentCount()) > 0))==true then smalltalk:while_do_(((function()\r\n(self):skipSeparators();(args):add_((self):upToSeparator());(self):skipSeparators();(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):peek()),\"\\\"\")),(function()\r\nreturn (\"\")\r\nend),(function()\r\nreturn ((self):upToSeparator())\r\nend)))\r\n\tpart=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:boolean_and_(((part):notEmpty()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((part):last()),\":\"))\r\nend)))\r\nend)),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((selector),part))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Message):selector_arguments_(selector,args))\r\n\tpart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):skipSeparators();\r\nif (smalltalk:isObject_equalTo_(((self):peek()),\"\\\"\"))==true then (part):comment_(((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):next();\r\n\treturn ((_s8_rec):upTo_(\"\\\"\"))\r\nend\r\n)(self)):trimBlanks()); end;\r\nreturn (part);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"collection",0
,(
function(self)
return ((self):invalidMessage_("collection"));
end
)
,"accessing","collection\r\n\t\" Private - Return the collection of the receiver. \"\r\n\r\n\t^self invalidMessage: #collection","(\r\nfunction(self)\r\nreturn ((self):invalidMessage_(\"collection\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"collection:",0
,(
function(self,aCollection)
if not (((aCollection):isString()))==true then (self):error_("Collection must be a String"); end;
(function()
	local _s8_value=((smalltalk.Array):with_(aCollection))
	self["@collection"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","collection: aCollection\r\n\t\" Private - Set the collection of the receiver. \"\r\n\r\n\taCollection isString ifFalse: [ self error: 'Collection must be a String' ].\r\n\tcollection := Array with: aCollection","(\r\nfunction(self,aCollection)\r\nif not (((aCollection):isString()))==true then (self):error_(\"Collection must be a String\"); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_(aCollection))\r\n\tself[\"@collection\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"contents",0
,(
function(self)
return ((self["@collection"]):join_(""));
end
)
,"accessing","contents\r\n\t\" Return the contents of the receiver. \"\r\n\r\n\t^collection join: ''","(\r\nfunction(self)\r\nreturn ((self[\"@collection\"]):join_(\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"position",0
,(
function(self)
return ((self):readLimit());
end
)
,"accessing","position\r\n\t\" Return the position of the receiver. \"\r\n\r\n\t^self readLimit","(\r\nfunction(self)\r\nreturn ((self):readLimit());\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"position:",0
,(
function(self,anInteger)
return ((self):invalidMessage_("position:"));
end
)
,"accessing","position: anInteger\r\n\t\" Set the position of the receiver. \"\r\n\r\n\t^self invalidMessage: #position:","(\r\nfunction(self,anInteger)\r\nreturn ((self):invalidMessage_(\"position:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"readLimit",0
,(
function(self)
return (self["@readLimit"]);
end
)
,"accessing","readLimit\r\n\t\" Private - Return the read limit of the receiver. \"\r\n\r\n\t^readLimit","(\r\nfunction(self)\r\nreturn (self[\"@readLimit\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"readLimit:",0
,(
function(self,anInteger)
(function()
	local _s8_value=(anInteger)
	self["@readLimit"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","readLimit: anInteger\r\n\t\" Private - Set the stream size of the receiver. \"\r\n\r\n\treadLimit := anInteger","(\r\nfunction(self,anInteger)\r\n(function()\r\n\tlocal _s8_value=(anInteger)\r\n\tself[\"@readLimit\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"setCollection:",0
,(
function(self,aCollection)
return ((self):invalidMessage_("setCollection:"));
end
)
,"accessing","setCollection: aCollection\r\n\t\" Private - Set the receiver stream collection to aCollection. \"\r\n\r\n\t^self invalidMessage: #setCollection:","(\r\nfunction(self,aCollection)\r\nreturn ((self):invalidMessage_(\"setCollection:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"size",0
,(
function(self)
return ((self):readLimit());
end
)
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^self readLimit","(\r\nfunction(self)\r\nreturn ((self):readLimit());\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"close",0
,(
function(self)
return (self);
end
)
,"actions","close\r\n\t\" Close the receiver. \"","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"reset",0
,(
function(self)
(self):initialize();
return (self);
end
)
,"actions","reset\r\n\t\" Reset the receiver. \"\r\n\r\n\tself initialize","(\r\nfunction(self)\r\n(self):initialize();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"do:",0
,(
function(self,aBlock)
return ((self):invalidMessage_("do:"));
end
)
,"enumerating","do: aBlock\r\n\t\" Evaluates aBlock streaming on the receiver. \"\r\n\r\n\t^self invalidMessage: #do:","(\r\nfunction(self,aBlock)\r\nreturn ((self):invalidMessage_(\"do:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"initialize",0
,(
function(self)
smalltalk:superImplementor(smalltalk.StringWriteStream,"initialize")(self);
(function()
	local _s8_value=((smalltalk.Array):new())
	self["@collection"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((function()
	local _s8_value=(0)
	self["@position"]=_s8_value
	return _s8_value
end)())
	self["@readLimit"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"initialize","initialize\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsuper initialize.\r\n\tcollection := Array new.\r\n\treadLimit := position := 0.","(\r\nfunction(self)\r\nsmalltalk:superImplementor(smalltalk.StringWriteStream,\"initialize\")(self);\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@collection\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((function()\r\n\tlocal _s8_value=(0)\r\n\tself[\"@position\"]=_s8_value\r\n\treturn _s8_value\r\nend)())\r\n\tself[\"@readLimit\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"setToEnd",0
,(
function(self)
return (self);
end
)
,"positioning","setToEnd\r\n\t\" Position the receiver at end. \"","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"skip:",0
,(
function(self,anInteger)
return ((self):invalidMessage_("skip:"));
end
)
,"positioning","skip: anInteger\r\n\t\" Skip next anInteger readable elements in the receiver. \"\r\n\r\n\t^self invalidMessage: #skip:","(\r\nfunction(self,anInteger)\r\nreturn ((self):invalidMessage_(\"skip:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"next",0
,(
function(self)
return ((self):invalidMessage_("next"));
end
)
,"reading","next\r\n\t\" Return the next readable element in the receiver (or nil). \"\r\n\r\n\t^self invalidMessage: #next","(\r\nfunction(self)\r\nreturn ((self):invalidMessage_(\"next\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"next:",0
,(
function(self,anInteger)
return ((self):invalidMessage_("next"));
end
)
,"reading","next: anInteger\r\n\t\" Return the next anInteger elements read from the receiver. \"\r\n\r\n\t^self invalidMessage: #next","(\r\nfunction(self,anInteger)\r\nreturn ((self):invalidMessage_(\"next\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"nextLine",0
,(
function(self)
return ((self):invalidMessage_("nextLine"));
end
)
,"reading","nextLine\r\n\t\" Return the characters read from the receiver up to the line delimiter. \"\r\n\r\n\t^self invalidMessage: #nextLine","(\r\nfunction(self)\r\nreturn ((self):invalidMessage_(\"nextLine\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"peek",0
,(
function(self)
return ((self):invalidMessage_("peek"));
end
)
,"reading","peek\r\n\t\" Return the next readable element from the receiver without advancing the receiver (or nil). \"\r\n\r\n\t^self invalidMessage: #peek","(\r\nfunction(self)\r\nreturn ((self):invalidMessage_(\"peek\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"upTo:",0
,(
function(self,anObject)
return ((self):invalidMessage_("upTo:"));
end
)
,"reading","upTo: anObject\r\n\t\" Return the elements read from the receiver upto anObject (or end). \"\r\n\r\n\t^self invalidMessage: #upTo:","(\r\nfunction(self,anObject)\r\nreturn ((self):invalidMessage_(\"upTo:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"upToEnd",0
,(
function(self)
return ((self):invalidMessage_("upToEnd"));
end
)
,"reading","upToEnd\r\n\t\" Return the contents of the receiver upto end. \"\r\n\r\n\t^self invalidMessage: #upToEnd","(\r\nfunction(self)\r\nreturn ((self):invalidMessage_(\"upToEnd\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"atEnd",0
,(
function(self)
return (true);
end
)
,"testing","atEnd\r\n\t\" Return true if the receiver is at end. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"nextPut:",0
,(
function(self,anObject)
local string=nil
(function()
	local _s8_value=(smalltalk:asString_((anObject)))
	string=_s8_value
	return _s8_value
end)();
(self["@collection"]):add_(string);
(function()
	local _s8_value=((self["@readLimit"]):_plus((string):size()))
	self["@readLimit"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"writing","nextPut: anObject\r\n\t\" Put anObject onto the receiver. \"\r\n\r\n\t| string |\r\n\tstring :=  anObject asString.\r\n\tcollection add: string.\r\n\treadLimit := readLimit + string size","(\r\nfunction(self,anObject)\r\nlocal string=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:asString_((anObject)))\r\n\tstring=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self[\"@collection\"]):add_(string);\r\n(function()\r\n\tlocal _s8_value=((self[\"@readLimit\"]):_plus((string):size()))\r\n\tself[\"@readLimit\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"nextPutAll:",0
,(
function(self,aCollection)
(self):nextPut_(aCollection);
return (self);
end
)
,"writing","nextPutAll: aCollection\r\n\t\" Put aCollection onto the receiver. \"\r\n\r\n\tself nextPut: aCollection","(\r\nfunction(self,aCollection)\r\n(self):nextPut_(aCollection);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.StringWriteStream,"removeLastInput",0
,(
function(self)
(function()
	local _s8_value=((self["@readLimit"]):_minus(((self["@collection"]):removeLast()):size()))
	self["@readLimit"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"back","removeLastInput\r\n\t\" Remove last input recorded in the receiver. \"\r\n\r\n\treadLimit := readLimit - collection removeLast size","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=((self[\"@readLimit\"]):_minus(((self[\"@collection\"]):removeLast()):size()))\r\n\tself[\"@readLimit\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Random,"next",0
,(
function(self)
if true then return math.random() end;
return (self);
end
)
,"accessing","next\r\n\t\" Return the next random number. \"\r\n\r\n\t{'' doc'native accessing'}","(\r\nfunction(self)\r\nif true then return math.random() end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Random,"next:",0
,(
function(self,anInteger)
return (((1):to_(anInteger)):collect_((function(each)
return ((self):next())
end)));
end
)
,"accessing","next: anInteger\r\n\t\" Return the next anInteger random numbers. \"\r\n\r\n\t^(1 to: anInteger) collect: [:each | self next ]","(\r\nfunction(self,anInteger)\r\nreturn (((1):to_(anInteger)):collect_((function(each)\r\nreturn ((self):next())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point["$klass"],"x:y:",0
,(
function(self,x,y)
return ((
function(_s8_rec)
	(_s8_rec):x_(x);
	return ((_s8_rec):y_(y))
end
)((self):basicNew()));
end
)
,"instantiation","x: x y: y\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew x: x; y: y","(\r\nfunction(self,x,y)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):x_(x);\r\n\treturn ((_s8_rec):y_(y))\r\nend\r\n)((self):basicNew()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point["$klass"],"zero",0
,(
function(self)
return (((self):basicNew()):x_y_(0,0));
end
)
,"instantiation","zero\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew x: 0 y: 0","(\r\nfunction(self)\r\nreturn (((self):basicNew()):x_y_(0,0));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"x",0
,(
function(self)
return (self["@x"]);
end
)
,"accessing","x\r\n\t\" Return the x of the receiver. \"\r\n\r\n\t^x","(\r\nfunction(self)\r\nreturn (self[\"@x\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"y",0
,(
function(self)
return (self["@y"]);
end
)
,"accessing","y\r\n\t\" Return the y of the receiver. \"\r\n\r\n\t^y","(\r\nfunction(self)\r\nreturn (self[\"@y\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"x:y:",0
,(
function(self,xValue,yValue)
(function()
	local _s8_value=(xValue)
	self["@x"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(yValue)
	self["@y"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","x: xValue y: yValue\r\n\t\" Set the receiver's coordinates. \"\r\n\r\n\tx := xValue.\r\n\ty := yValue","(\r\nfunction(self,xValue,yValue)\r\n(function()\r\n\tlocal _s8_value=(xValue)\r\n\tself[\"@x\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(yValue)\r\n\tself[\"@y\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"y:",0
,(
function(self,aNumber)
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aNumber))),(function()
return (0)
end),(function()
return (aNumber)
end)))
	self["@y"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","y: aNumber\r\n\t\" Set the y of the receiver. \"\r\n\r\n\ty := aNumber isNil ifTrue: [ 0 ] ifFalse: [ aNumber ]","(\r\nfunction(self,aNumber)\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aNumber))),(function()\r\nreturn (0)\r\nend),(function()\r\nreturn (aNumber)\r\nend)))\r\n\tself[\"@y\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"x:",0
,(
function(self,aNumber)
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aNumber))),(function()
return (0)
end),(function()
return (aNumber)
end)))
	self["@x"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","x: aNumber\r\n\t\" Set the x of the receiver. \"\r\n\r\n\tx := aNumber isNil ifTrue: [ 0 ] ifFalse: [ aNumber ]","(\r\nfunction(self,aNumber)\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aNumber))),(function()\r\nreturn (0)\r\nend),(function()\r\nreturn (aNumber)\r\nend)))\r\n\tself[\"@x\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"*","_star"
,(
function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self["@x"]):_star(aPoint)):_at((self["@y"]):_star(aPoint))); end;
return ((smalltalk.Point):x_y_((self["@x"]):_star(((aPoint):asPoint()):x()),(self["@y"]):_star(((aPoint):asPoint()):y())));
end
)
,"arithmetic","* aPoint\r\n\t\" Return the result of operation. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^x * aPoint @ (y * aPoint) ].\r\n\t^Point\tx: x * aPoint asPoint x\r\n\t\ty: y * aPoint asPoint y","(\r\nfunction(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self[\"@x\"]):_star(aPoint)):_at((self[\"@y\"]):_star(aPoint))); end;\r\nreturn ((smalltalk.Point):x_y_((self[\"@x\"]):_star(((aPoint):asPoint()):x()),(self[\"@y\"]):_star(((aPoint):asPoint()):y())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"+","_plus"
,(
function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self["@x"]):_plus(aPoint)):_at((self["@y"]):_plus(aPoint))); end;
return ((smalltalk.Point):x_y_((self["@x"]):_plus(((aPoint):asPoint()):x()),(self["@y"]):_plus(((aPoint):asPoint()):y())));
end
)
,"arithmetic","+ aPoint\r\n\t\" Return the result of operation. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^x + aPoint @ (y + aPoint) ].\r\n\t^Point\tx: x + aPoint asPoint x\r\n\t\ty: y + aPoint asPoint y","(\r\nfunction(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self[\"@x\"]):_plus(aPoint)):_at((self[\"@y\"]):_plus(aPoint))); end;\r\nreturn ((smalltalk.Point):x_y_((self[\"@x\"]):_plus(((aPoint):asPoint()):x()),(self[\"@y\"]):_plus(((aPoint):asPoint()):y())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"-","_minus"
,(
function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self["@x"]):_minus(aPoint)):_at((self["@y"]):_minus(aPoint))); end;
return ((smalltalk.Point):x_y_((self["@x"]):_minus(((aPoint):asPoint()):x()),(self["@y"]):_minus(((aPoint):asPoint()):y())));
end
)
,"arithmetic","- aPoint\r\n\t\" Return the result of operation. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^x - aPoint @ (y - aPoint) ].\r\n\t^Point\tx: x - aPoint asPoint x\r\n\t\ty: y - aPoint asPoint y","(\r\nfunction(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self[\"@x\"]):_minus(aPoint)):_at((self[\"@y\"]):_minus(aPoint))); end;\r\nreturn ((smalltalk.Point):x_y_((self[\"@x\"]):_minus(((aPoint):asPoint()):x()),(self[\"@y\"]):_minus(((aPoint):asPoint()):y())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"/","_slash"
,(
function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self["@x"]):_slash(aPoint)):_at((self["@y"]):_slash(aPoint))); end;
return ((smalltalk.Point):x_y_((self["@x"]):_slash(((aPoint):asPoint()):x()),(self["@y"]):_slash(((aPoint):asPoint()):y())));
end
)
,"arithmetic","/ aPoint\r\n\t\" Return the result of operation. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^x / aPoint @ (y / aPoint) ].\r\n\t^Point\tx: x / aPoint asPoint x\r\n\t\ty: y / aPoint asPoint y","(\r\nfunction(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self[\"@x\"]):_slash(aPoint)):_at((self[\"@y\"]):_slash(aPoint))); end;\r\nreturn ((smalltalk.Point):x_y_((self[\"@x\"]):_slash(((aPoint):asPoint()):x()),(self[\"@y\"]):_slash(((aPoint):asPoint()):y())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"//","_slash_slash"
,(
function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self["@x"]):_slash_slash(aPoint)):_at((self["@y"]):_slash_slash(aPoint))); end;
return ((smalltalk.Point):x_y_((self["@x"]):_slash_slash(((aPoint):asPoint()):x()),(self["@y"]):_slash_slash(((aPoint):asPoint()):y())));
end
)
,"arithmetic","// aPoint\r\n\t\" Return the result of operation. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^x // aPoint @ (y // aPoint) ].\r\n\t^Point\tx: x // aPoint asPoint x\r\n\t\ty: y // aPoint asPoint y","(\r\nfunction(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self[\"@x\"]):_slash_slash(aPoint)):_at((self[\"@y\"]):_slash_slash(aPoint))); end;\r\nreturn ((smalltalk.Point):x_y_((self[\"@x\"]):_slash_slash(((aPoint):asPoint()):x()),(self[\"@y\"]):_slash_slash(((aPoint):asPoint()):y())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"\\\\","_bk_bk"
,(
function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self["@x"]):_bk_bk(aPoint)):_at((self["@y"]):_bk_bk(aPoint))); end;
return ((smalltalk.Point):x_y_((self["@x"]):_bk_bk(((aPoint):asPoint()):x()),(self["@y"]):_bk_bk(((aPoint):asPoint()):y())));
end
)
,"arithmetic","\\\\\\\\ aPoint\r\n\t\" Return the result of operation. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^x \\\\ aPoint @ (y \\\\ aPoint) ].\r\n\t^Point\tx: x \\\\ aPoint asPoint x\r\n\t\ty: y \\\\ aPoint asPoint y","(\r\nfunction(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self[\"@x\"]):_bk_bk(aPoint)):_at((self[\"@y\"]):_bk_bk(aPoint))); end;\r\nreturn ((smalltalk.Point):x_y_((self[\"@x\"]):_bk_bk(((aPoint):asPoint()):x()),(self[\"@y\"]):_bk_bk(((aPoint):asPoint()):y())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"<","_lt"
,(
function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self) < (aPoint):asPoint())); end;
return (smalltalk:boolean_and_((((self["@x"]) < (aPoint):x())),(function()
return (((self["@y"]) < (aPoint):y()))
end)));
end
)
,"comparing","< aPoint\r\n\t\" Return true if the receiver is smaller than argument. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^self < aPoint asPoint ].\r\n\t^x < aPoint x and: [ y < aPoint y ]","(\r\nfunction(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self) < (aPoint):asPoint())); end;\r\nreturn (smalltalk:boolean_and_((((self[\"@x\"]) < (aPoint):x())),(function()\r\nreturn (((self[\"@y\"]) < (aPoint):y()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"<=","_lt_eq"
,(
function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self) <= (aPoint):asPoint())); end;
return (smalltalk:boolean_and_((((self["@x"]) <= (aPoint):x())),(function()
return (((self["@y"]) <= (aPoint):y()))
end)));
end
)
,"comparing","<= aPoint\r\n\t\" Return true if the receiver is smaller or equal to argument. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^self <= aPoint asPoint ].\r\n\t^x <= aPoint x and: [ y <= aPoint y ]","(\r\nfunction(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self) <= (aPoint):asPoint())); end;\r\nreturn (smalltalk:boolean_and_((((self[\"@x\"]) <= (aPoint):x())),(function()\r\nreturn (((self[\"@y\"]) <= (aPoint):y()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,">","_gt"
,(
function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self) > (aPoint):asPoint())); end;
return (smalltalk:boolean_and_((((self["@x"]) > (aPoint):x())),(function()
return (((self["@y"]) > (aPoint):y()))
end)));
end
)
,"comparing","> aPoint\r\n\t\" Return true if the receiver is greater than argument. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^self > aPoint asPoint ].\r\n\t^x > aPoint x and: [ y > aPoint y ]","(\r\nfunction(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self) > (aPoint):asPoint())); end;\r\nreturn (smalltalk:boolean_and_((((self[\"@x\"]) > (aPoint):x())),(function()\r\nreturn (((self[\"@y\"]) > (aPoint):y()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,">=","_gt_eq"
,(
function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self) >= (aPoint):asPoint())); end;
return (smalltalk:boolean_and_((((self["@x"]) >= (aPoint):x())),(function()
return (((self["@y"]) >= (aPoint):y()))
end)));
end
)
,"comparing",">= aPoint\r\n\t\" Return true if the receiver is greater or equal to argument. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^self >= aPoint asPoint ].\r\n\t^x >= aPoint x and: [ y >= aPoint y ]","(\r\nfunction(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self) >= (aPoint):asPoint())); end;\r\nreturn (smalltalk:boolean_and_((((self[\"@x\"]) >= (aPoint):x())),(function()\r\nreturn (((self[\"@y\"]) >= (aPoint):y()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"rounded",0
,(
function(self)
return (((self["@x"]):rounded()):_at((self["@y"]):rounded()));
end
)
,"converting","rounded\r\n\t\" Return the receiver rounded. \"\r\n\r\n\t^x rounded @ y rounded","(\r\nfunction(self)\r\nreturn (((self[\"@x\"]):rounded()):_at((self[\"@y\"]):rounded()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"truncated",0
,(
function(self)
return (((self["@x"]):truncated()):_at((self["@y"]):truncated()));
end
)
,"converting","truncated\r\n\t\" Return the receiver truncated. \"\r\n\r\n\t^x truncated @ y truncated","(\r\nfunction(self)\r\nreturn (((self[\"@x\"]):truncated()):_at((self[\"@y\"]):truncated()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"asPoint",0
,(
function(self)
return (self);
end
)
,"converting","asPoint\r\n\t\" Return the receiver as a Point. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"printString",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:toString_((self["@x"])))," @ ")),smalltalk:toString_((self["@y"]))));
end
)
,"printing","printString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^x toString ,' @ ' ,y toString","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:toString_((self[\"@x\"]))),\" @ \")),smalltalk:toString_((self[\"@y\"]))));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"toString",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:toString_((self["@x"]))),"@")),smalltalk:toString_((self["@y"]))));
end
)
,"printing","toString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^x toString ,$@ ,y toString","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:toString_((self[\"@x\"]))),\"@\")),smalltalk:toString_((self[\"@y\"]))));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"asLiteral",0
,(
function(self)
local literal=nil
(function()
	local _s8_value=((function(v)
local string=nil
(function()
	local _s8_value=(smalltalk:if_true_false_(((self):isObject_(v)),(function()
return ((v):asLiteral())
end),(function()
return (smalltalk:toString_((v)))
end)))
	string=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:boolean_or_(((string):isEmpty()),(function()
return (smalltalk:boolean_or_((((string):first()):isDigit()),(function()
return (("#'-+"):includes_((string):first()))
end)))
end))),(function()
return (string)
end),(function()
return (smalltalk:object_comma_((smalltalk:object_comma_(("("),string)),")"))
end)))
end))
	literal=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_(((literal):value_(self["@x"])),"@")),(literal):value_(self["@y"])));
end
)
,"converting","asLiteral\r\n\t\" Return the receiver in literal notation. \"\r\n\r\n\t| literal |\r\n\tliteral := [:v| | string |\r\n\t\tstring := (self isObject: v) ifTrue: [v asLiteral] ifFalse: [v toString].\r\n\t\t(string isEmpty or: [string first isDigit or: ['#''-+' includes: string first]])\r\n\t\tifTrue: [string] ifFalse: [ $( ,string ,$) ]\r\n\t].\r\n\t^(literal value: x) ,$@ ,(literal value: y)","(\r\nfunction(self)\r\nlocal literal=nil\r\n(function()\r\n\tlocal _s8_value=((function(v)\r\nlocal string=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((self):isObject_(v)),(function()\r\nreturn ((v):asLiteral())\r\nend),(function()\r\nreturn (smalltalk:toString_((v)))\r\nend)))\r\n\tstring=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:boolean_or_(((string):isEmpty()),(function()\r\nreturn (smalltalk:boolean_or_((((string):first()):isDigit()),(function()\r\nreturn ((\"#'-+\"):includes_((string):first()))\r\nend)))\r\nend))),(function()\r\nreturn (string)\r\nend),(function()\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"(\"),string)),\")\"))\r\nend)))\r\nend))\r\n\tliteral=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_(((literal):value_(self[\"@x\"])),\"@\")),(literal):value_(self[\"@y\"])));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"shallowCopy",0
,(
function(self)
return ((((self)["$klass"]):basicNew()):x_y_((self):x(),(self):y()));
end
)
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self class basicNew\r\n\t\tx: self x y: self y","(\r\nfunction(self)\r\nreturn ((((self)[\"$klass\"]):basicNew()):x_y_((self):x(),(self):y()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"=","_eq"
,(
function(self,aPoint)
if (smalltalk:isNil_((aPoint)))==true then return (false); end;
if not (((aPoint):isMemberOf_((self)["$klass"])))==true then return (smalltalk:boolean_and_((smalltalk:responds_to_((aPoint),("asPoint"))),(function()
return (smalltalk:isObject_equalTo_(((aPoint):asPoint()),self))
end))); end;
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((self["@x"]),(aPoint):x())),(function()
return (smalltalk:isObject_equalTo_((self["@y"]),(aPoint):y()))
end)));
end
)
,"testing","= aPoint\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\taPoint isNil ifTrue: [ ^false ].\r\n\t(aPoint isMemberOf: self class) ifFalse: [\r\n\t\t^(aPoint respondsTo: #asPoint) and: [\r\n\t\t\taPoint asPoint = self\r\n\t\t]\r\n\t].\r\n\t^x = aPoint x and: [ y = aPoint y ]","(\r\nfunction(self,aPoint)\r\nif (smalltalk:isNil_((aPoint)))==true then return (false); end;\r\nif not (((aPoint):isMemberOf_((self)[\"$klass\"])))==true then return (smalltalk:boolean_and_((smalltalk:responds_to_((aPoint),(\"asPoint\"))),(function()\r\nreturn (smalltalk:isObject_equalTo_(((aPoint):asPoint()),self))\r\nend))); end;\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((self[\"@x\"]),(aPoint):x())),(function()\r\nreturn (smalltalk:isObject_equalTo_((self[\"@y\"]),(aPoint):y()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"min:",0
,(
function(self,aPoint)
return (((self["@x"]):min_((aPoint):x())):_at((self["@y"]):min_((aPoint):y())));
end
)
,"magnitude","min: aPoint\r\n\t\" Return the minimum of the receiver and aPoint. \"\r\n\r\n\t^(x min: aPoint x) @ (y min: aPoint y)","(\r\nfunction(self,aPoint)\r\nreturn (((self[\"@x\"]):min_((aPoint):x())):_at((self[\"@y\"]):min_((aPoint):y())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"max:",0
,(
function(self,aPoint)
return (((self["@x"]):max_((aPoint):x())):_at((self["@y"]):max_((aPoint):y())));
end
)
,"magnitude","max: aPoint\r\n\t\" Return the maximum of the receiver and aPoint. \"\r\n\r\n\t^(x max: aPoint x) @ (y max: aPoint y)","(\r\nfunction(self,aPoint)\r\nreturn (((self[\"@x\"]):max_((aPoint):x())):_at((self[\"@y\"]):max_((aPoint):y())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"extent:",0
,(
function(self,extent)
return ((smalltalk.Rectangle):leftTop_rightBottom_(self,(self):_plus(extent)));
end
)
,"converting","extent: extent\r\n\t\" Return a Rectangle from the receiver with specified extent. \"\r\n\r\n\t^Rectangle leftTop: self rightBottom: self + extent","(\r\nfunction(self,extent)\r\nreturn ((smalltalk.Rectangle):leftTop_rightBottom_(self,(self):_plus(extent)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"rightBottom:",0
,(
function(self,rightBottom)
return ((smalltalk.Rectangle):leftTop_rightBottom_(self,rightBottom));
end
)
,"converting","rightBottom: rightBottom\r\n\t\" Return a Rectangle from the receiver to rightBottom. \"\r\n\r\n\t^Rectangle leftTop: self rightBottom: rightBottom","(\r\nfunction(self,rightBottom)\r\nreturn ((smalltalk.Rectangle):leftTop_rightBottom_(self,rightBottom));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"to:",0
,(
function(self,rightBottom)
return ((smalltalk.Rectangle):leftTop_rightBottom_(self,rightBottom));
end
)
,"converting","to: rightBottom\r\n\t\" Return a Rectangle from the receiver to rightBottom. \"\r\n\r\n\t^Rectangle leftTop: self rightBottom: rightBottom","(\r\nfunction(self,rightBottom)\r\nreturn ((smalltalk.Rectangle):leftTop_rightBottom_(self,rightBottom));\r\nend\r\n)")
smalltalk:bind(smalltalk.Point,"__tostring",0
,(
function(self)
return (smalltalk:toString_((self)));
end
)
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","(\r\nfunction(self)\r\nreturn (smalltalk:toString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle["$klass"],"leftTop:extent:",0
,(
function(self,leftTop,extent)
return (((self):new()):leftTop_rightBottom_(leftTop,(leftTop):_plus(extent)));
end
)
,"instantiation","leftTop: leftTop extent: extent\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new leftTop: leftTop rightBottom: leftTop + extent","(\r\nfunction(self,leftTop,extent)\r\nreturn (((self):new()):leftTop_rightBottom_(leftTop,(leftTop):_plus(extent)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle["$klass"],"leftTop:rightBottom:",0
,(
function(self,leftTop,rightBottom)
return (((self):new()):leftTop_rightBottom_(leftTop,rightBottom));
end
)
,"instantiation","leftTop: leftTop rightBottom: rightBottom\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new leftTop: leftTop rightBottom: rightBottom","(\r\nfunction(self,leftTop,rightBottom)\r\nreturn (((self):new()):leftTop_rightBottom_(leftTop,rightBottom));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"=","_eq"
,(
function(self,aRectangle)
return (smalltalk:boolean_and_(((aRectangle):isRectangle()),(function()
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((self["@leftTop"]),(aRectangle):leftTop())),(function()
return (smalltalk:isObject_equalTo_((self["@rightBottom"]),(aRectangle):rightBottom()))
end)))
end)));
end
)
,"testing","= aRectangle\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\t^aRectangle isRectangle\r\n\tand: [ leftTop = aRectangle leftTop\r\n\tand: [ rightBottom = aRectangle rightBottom ]]","(\r\nfunction(self,aRectangle)\r\nreturn (smalltalk:boolean_and_(((aRectangle):isRectangle()),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((self[\"@leftTop\"]),(aRectangle):leftTop())),(function()\r\nreturn (smalltalk:isObject_equalTo_((self[\"@rightBottom\"]),(aRectangle):rightBottom()))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"area",0
,(
function(self)
return (((self):height()):_star((self):width()));
end
)
,"accessing","area\r\n\t\" Return the area of the receiver.\"\r\n\r\n\t^self height * self width","(\r\nfunction(self)\r\nreturn (((self):height()):_star((self):width()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"areasOutside:",0
,(
function(self,aRectangle)
if not (((self):intersects_(aRectangle)))==true then return ((smalltalk.Array):with_(self)); end;
if (smalltalk:boolean_and_(((aRectangle):containsPoint_((self):topLeft())),(function()
return ((aRectangle):containsPoint_((self):bottomRight()))
end)))==true then return (smalltalk:newArray({})); end;
return (((smalltalk.Array):with_with_with_with_(smalltalk:if_true_false_(((((aRectangle):top()) > (self):top())),(function()
return (((self):topLeft()):rightBottom_(((self):right()):_at((aRectangle):top())))
end),nil),smalltalk:if_true_false_(((((aRectangle):bottom()) < (self):bottom())),(function()
return ((((self):left()):_at((aRectangle):bottom())):rightBottom_((self):bottomRight()))
end),nil),smalltalk:if_true_false_(((((aRectangle):left()) > (self):left())),(function()
return ((((self):left()):_at(((self):top()):max_((aRectangle):top()))):rightBottom_(((aRectangle):left()):_at(((self):bottom()):min_((aRectangle):bottom()))))
end),nil),smalltalk:if_true_false_(((((aRectangle):right()) < (self):right())),(function()
return ((((aRectangle):right()):_at(((self):top()):max_((aRectangle):top()))):rightBottom_(((self):right()):_at(((self):bottom()):min_((aRectangle):bottom()))))
end),nil))):select_((function(each)
return (smalltalk:notNil_((each)))
end)));
end
)
,"accessing","areasOutside: aRectangle\r\n\t\"Return a collection of rectangles where the receiver do not intersect aRectangle. \"\r\n\r\n\t(self intersects: aRectangle) ifFalse: [ ^Array with: self ].\r\n\t((aRectangle containsPoint: self topLeft)\r\n\tand: [aRectangle containsPoint: self bottomRight])\r\n        ifTrue: [ ^#() ].\r\n\t^(Array\r\n\twith: (aRectangle top > self top ifTrue: [ self topLeft rightBottom: self right @ aRectangle top])\r\n\twith: (aRectangle bottom < self bottom ifTrue: [ self left @ aRectangle bottom rightBottom: self bottomRight])\r\n\twith: (aRectangle left > self left ifTrue: [ self left @ (self top max: aRectangle top) rightBottom: aRectangle left @ (self bottom min: aRectangle bottom) ])\r\n\twith: (aRectangle right < self right ifTrue: [ aRectangle right @ (self top max: aRectangle top) rightBottom: self right @ (self bottom min: aRectangle bottom) ])\r\n\t) select: [:each| each notNil ]","(\r\nfunction(self,aRectangle)\r\nif not (((self):intersects_(aRectangle)))==true then return ((smalltalk.Array):with_(self)); end;\r\nif (smalltalk:boolean_and_(((aRectangle):containsPoint_((self):topLeft())),(function()\r\nreturn ((aRectangle):containsPoint_((self):bottomRight()))\r\nend)))==true then return (smalltalk:newArray({})); end;\r\nreturn (((smalltalk.Array):with_with_with_with_(smalltalk:if_true_false_(((((aRectangle):top()) > (self):top())),(function()\r\nreturn (((self):topLeft()):rightBottom_(((self):right()):_at((aRectangle):top())))\r\nend),nil),smalltalk:if_true_false_(((((aRectangle):bottom()) < (self):bottom())),(function()\r\nreturn ((((self):left()):_at((aRectangle):bottom())):rightBottom_((self):bottomRight()))\r\nend),nil),smalltalk:if_true_false_(((((aRectangle):left()) > (self):left())),(function()\r\nreturn ((((self):left()):_at(((self):top()):max_((aRectangle):top()))):rightBottom_(((aRectangle):left()):_at(((self):bottom()):min_((aRectangle):bottom()))))\r\nend),nil),smalltalk:if_true_false_(((((aRectangle):right()) < (self):right())),(function()\r\nreturn ((((aRectangle):right()):_at(((self):top()):max_((aRectangle):top()))):rightBottom_(((self):right()):_at(((self):bottom()):min_((aRectangle):bottom()))))\r\nend),nil))):select_((function(each)\r\nreturn (smalltalk:notNil_((each)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"bottom",0
,(
function(self)
return ((self["@rightBottom"]):y());
end
)
,"accessing","bottom\r\n\t\" Return the bottom of the receiver.\"\r\n\r\n\t^rightBottom y","(\r\nfunction(self)\r\nreturn ((self[\"@rightBottom\"]):y());\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"bottomCenter",0
,(
function(self)
return ((((self):center()):x()):_at((self):bottom()));
end
)
,"accessing","bottomCenter\r\n\t\" Return the center of the bottom edge of the receiver. \"\r\n\r\n\t^self center x @ self bottom","(\r\nfunction(self)\r\nreturn ((((self):center()):x()):_at((self):bottom()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"bottomLeft",0
,(
function(self)
return (((self):left()):_at((self):bottom()));
end
)
,"accessing","bottomLeft\r\n\t\" Return the bottom-left corner of the receiver. \"\r\n\r\n\t^self left @ self bottom","(\r\nfunction(self)\r\nreturn (((self):left()):_at((self):bottom()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"bottomRight",0
,(
function(self)
return (self["@rightBottom"]);
end
)
,"accessing","bottomRight\r\n\t\" Return the bottom-right corner of the receiver. \"\r\n\r\n\t^rightBottom","(\r\nfunction(self)\r\nreturn (self[\"@rightBottom\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"center",0
,(
function(self)
return (((self["@leftTop"]):_plus(self["@rightBottom"])):_slash_slash(2));
end
)
,"accessing","center\r\n\t\" Return the center of the receiver. \"\r\n\r\n\t^leftTop + rightBottom // 2","(\r\nfunction(self)\r\nreturn (((self[\"@leftTop\"]):_plus(self[\"@rightBottom\"])):_slash_slash(2));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"centerTop",0
,(
function(self)
return (((((self):right()):_plus((self):left())):_slash_slash(2)):_at((self):top()));
end
)
,"accessing","centerTop\r\n\t\" Return the center top of the receiver. \"\r\n\r\n\t^self right + self left // 2 @ self top","(\r\nfunction(self)\r\nreturn (((((self):right()):_plus((self):left())):_slash_slash(2)):_at((self):top()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"contains:",0
,(
function(self,aRectangle)
return (smalltalk:boolean_and_(((((self):left()) <= (aRectangle):left())),(function()
return (smalltalk:boolean_and_(((((aRectangle):right()) <= (self):right())),(function()
return (smalltalk:boolean_and_(((((self):bottom()) >= (aRectangle):bottom())),(function()
return ((((aRectangle):top()) >= (self):top()))
end)))
end)))
end)));
end
)
,"testing","contains: aRectangle\r\n\t\" Return true if aRectangle lies completely within or on the edge of the receiver. \"\r\n\r\n\t^self left <= aRectangle left\r\n\tand: [ aRectangle right <= self right\r\n\tand: [ self bottom >= aRectangle bottom\r\n\tand: [ aRectangle top >= self top ]]]","(\r\nfunction(self,aRectangle)\r\nreturn (smalltalk:boolean_and_(((((self):left()) <= (aRectangle):left())),(function()\r\nreturn (smalltalk:boolean_and_(((((aRectangle):right()) <= (self):right())),(function()\r\nreturn (smalltalk:boolean_and_(((((self):bottom()) >= (aRectangle):bottom())),(function()\r\nreturn ((((aRectangle):top()) >= (self):top()))\r\nend)))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"containsPoint:",0
,(
function(self,aPoint)
return (smalltalk:boolean_and_(((((self):left()) <= (aPoint):x())),(function()
return (smalltalk:boolean_and_(((((aPoint):x()) < (self):right())),(function()
return (smalltalk:boolean_and_(((((self):bottom()) > (aPoint):y())),(function()
return ((((aPoint):y()) >= (self):top()))
end)))
end)))
end)));
end
)
,"testing","containsPoint: aPoint\r\n\t\" Return true if aPoint is contained within the receiver. \"\r\n\r\n\t^(self left <= aPoint x)\r\n\tand: [ aPoint x < self right\r\n\tand: [ self bottom > aPoint y\r\n\tand: [ aPoint y >= self top ]]]","(\r\nfunction(self,aPoint)\r\nreturn (smalltalk:boolean_and_(((((self):left()) <= (aPoint):x())),(function()\r\nreturn (smalltalk:boolean_and_(((((aPoint):x()) < (self):right())),(function()\r\nreturn (smalltalk:boolean_and_(((((self):bottom()) > (aPoint):y())),(function()\r\nreturn ((((aPoint):y()) >= (self):top()))\r\nend)))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"expandBy:",0
,(
function(self,delta)
if ((delta):isRectangle())==true then return (((self["@leftTop"]):_minus((delta):leftTop())):rightBottom_((self["@rightBottom"]):_plus((delta):rightBottom()))); end;
return (((self["@leftTop"]):_minus(delta)):rightBottom_((self["@rightBottom"]):_plus(delta)));
end
)
,"accessing","expandBy: delta\r\n\t\" Return a Rectangle obtained from the receiver expanded by delta. \"\r\n\r\n\tdelta isRectangle ifTrue: [\r\n            ^leftTop - delta leftTop rightBottom: rightBottom + delta rightBottom\r\n\t].\r\n\t^leftTop - delta rightBottom: rightBottom + delta","(\r\nfunction(self,delta)\r\nif ((delta):isRectangle())==true then return (((self[\"@leftTop\"]):_minus((delta):leftTop())):rightBottom_((self[\"@rightBottom\"]):_plus((delta):rightBottom()))); end;\r\nreturn (((self[\"@leftTop\"]):_minus(delta)):rightBottom_((self[\"@rightBottom\"]):_plus(delta)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"extent",0
,(
function(self)
return (((self):width()):_at((self):height()));
end
)
,"accessing","extent\r\n\t\" Return receiver's width and height.\"\r\n\r\n\t^self width @ self height","(\r\nfunction(self)\r\nreturn (((self):width()):_at((self):height()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"extent:",0
,(
function(self,aPoint)
(self):width_((aPoint):x());
(self):height_((aPoint):y());
return (self);
end
)
,"accessing","extent: aPoint\r\n\t\" Set the extent of receiver to aPoint. \"\r\n\r\n\tself width: aPoint x.\r\n\tself height: aPoint y","(\r\nfunction(self,aPoint)\r\n(self):width_((aPoint):x());\r\n(self):height_((aPoint):y());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"height",0
,(
function(self)
return ((((self["@leftTop"]):y()):_minus((self["@rightBottom"]):y())):abs());
end
)
,"accessing","height\r\n\t\" Return the height of the receiver. \"\r\n\r\n\t^(leftTop y - rightBottom y) abs","(\r\nfunction(self)\r\nreturn ((((self[\"@leftTop\"]):y()):_minus((self[\"@rightBottom\"]):y())):abs());\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"height:",0
,(
function(self,aNumber)
(self["@rightBottom"]):y_(((self["@leftTop"]):y()):_plus(aNumber));
return (self);
end
)
,"accessing","height: aNumber\r\n\t\" Change the height of the receiver. \"\r\n\r\n\trightBottom y: leftTop y + aNumber","(\r\nfunction(self,aNumber)\r\n(self[\"@rightBottom\"]):y_(((self[\"@leftTop\"]):y()):_plus(aNumber));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"insetBy:",0
,(
function(self,delta)
if ((delta):isRectangle())==true then return (((self["@leftTop"]):_plus((delta):leftTop())):rightBottom_((self["@rightBottom"]):_minus((delta):rightBottom()))); end;
return (((self["@leftTop"]):_plus(delta)):rightBottom_((self["@rightBottom"]):_minus(delta)));
end
)
,"accessing","insetBy: delta\r\n\t\" Return the receiver inset by delta. \"\r\n\r\n\tdelta isRectangle ifTrue: [\r\n            ^leftTop + delta leftTop rightBottom: rightBottom - delta rightBottom\r\n\t].\r\n\t^leftTop + delta rightBottom: rightBottom - delta","(\r\nfunction(self,delta)\r\nif ((delta):isRectangle())==true then return (((self[\"@leftTop\"]):_plus((delta):leftTop())):rightBottom_((self[\"@rightBottom\"]):_minus((delta):rightBottom()))); end;\r\nreturn (((self[\"@leftTop\"]):_plus(delta)):rightBottom_((self[\"@rightBottom\"]):_minus(delta)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"intersect:",0
,(
function(self,aRectangle)
if (smalltalk:isNil_((aRectangle)))==true then return (self); end;
return (((self["@leftTop"]):max_((aRectangle):leftTop())):rightBottom_((self["@rightBottom"]):min_((aRectangle):rightBottom())));
end
)
,"accessing","intersect: aRectangle\r\n\t\" Return the rectangle in which the receiver and aRectangle overlap. \"\r\n\r\n\taRectangle isNil ifTrue: [ ^self ].\r\n\t^(leftTop max: aRectangle leftTop)\r\n        rightBottom: (rightBottom min: aRectangle rightBottom)","(\r\nfunction(self,aRectangle)\r\nif (smalltalk:isNil_((aRectangle)))==true then return (self); end;\r\nreturn (((self[\"@leftTop\"]):max_((aRectangle):leftTop())):rightBottom_((self[\"@rightBottom\"]):min_((aRectangle):rightBottom())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"intersects:",0
,(
function(self,aRectangle)
return (smalltalk:boolean_and_((((self["@leftTop"]) < (aRectangle):rightBottom())),(function()
return ((((aRectangle):leftTop()) < self["@rightBottom"]))
end)));
end
)
,"accessing","intersects: aRectangle\r\n\t\" Return true if the receiver and aRectangle have any area in common. \"\r\n\r\n\t^leftTop < aRectangle rightBottom\r\n\tand: [ aRectangle leftTop < rightBottom ]","(\r\nfunction(self,aRectangle)\r\nreturn (smalltalk:boolean_and_((((self[\"@leftTop\"]) < (aRectangle):rightBottom())),(function()\r\nreturn ((((aRectangle):leftTop()) < self[\"@rightBottom\"]))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"isRectangle",0
,(
function(self)
return (true);
end
)
,"testing","isRectangle\r\n\t\" Return true if receiver is a Rectangle. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"left",0
,(
function(self)
return ((self["@leftTop"]):x());
end
)
,"accessing","left\r\n\t\" Return the left of the receiver. \"\r\n\r\n\t^leftTop x","(\r\nfunction(self)\r\nreturn ((self[\"@leftTop\"]):x());\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"leftBottom",0
,(
function(self)
return (((self):left()):_at((self):bottom()));
end
)
,"accessing","leftBottom\r\n\t\" Return the left bottom corner of the receiver. \"\r\n\r\n\t^self left @ self bottom","(\r\nfunction(self)\r\nreturn (((self):left()):_at((self):bottom()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"leftCenter",0
,(
function(self)
return (((self):left()):_at(((self):center()):y()));
end
)
,"accessing","leftCenter\r\n\t\" Return the center of the left edge of the receiver. \"\r\n\r\n\t^self left @ self center y","(\r\nfunction(self)\r\nreturn (((self):left()):_at(((self):center()):y()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"leftTop",0
,(
function(self)
return (self["@leftTop"]);
end
)
,"accessing","leftTop\r\n\t\" Return the left top of the receiver. \"\r\n\r\n\t^leftTop","(\r\nfunction(self)\r\nreturn (self[\"@leftTop\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"leftTop:",0
,(
function(self,aPoint)
(function()
	local _s8_value=(aPoint)
	self["@leftTop"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","leftTop: aPoint\r\n\t\" Set the leftTop of the receiver.\"\r\n\r\n\tleftTop := aPoint","(\r\nfunction(self,aPoint)\r\n(function()\r\n\tlocal _s8_value=(aPoint)\r\n\tself[\"@leftTop\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"leftTop:rightBottom:",0
,(
function(self,leftTopPoint,rightBottomPoint)
(function()
	local _s8_value=(leftTopPoint)
	self["@leftTop"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(rightBottomPoint)
	self["@rightBottom"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","leftTop: leftTopPoint rightBottom: rightBottomPoint\r\n\t\"Set the receiver's coordinates. \"\r\n\r\n\tleftTop := leftTopPoint.\r\n\trightBottom := rightBottomPoint.","(\r\nfunction(self,leftTopPoint,rightBottomPoint)\r\n(function()\r\n\tlocal _s8_value=(leftTopPoint)\r\n\tself[\"@leftTop\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(rightBottomPoint)\r\n\tself[\"@rightBottom\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"merge:",0
,(
function(self,aRectangle)
if (smalltalk:isNil_((aRectangle)))==true then return (self); end;
return (((self["@leftTop"]):min_((aRectangle):leftTop())):rightBottom_((self["@rightBottom"]):max_((aRectangle):rightBottom())));
end
)
,"accessing","merge: aRectangle\r\n\t\" Return a Rectangle representing the area in which the receiver and aRectangle merged together. \"\r\n\r\n\taRectangle isNil ifTrue: [ ^self ].\r\n\t^(leftTop min: aRectangle leftTop) rightBottom: (rightBottom max: aRectangle rightBottom)","(\r\nfunction(self,aRectangle)\r\nif (smalltalk:isNil_((aRectangle)))==true then return (self); end;\r\nreturn (((self[\"@leftTop\"]):min_((aRectangle):leftTop())):rightBottom_((self[\"@rightBottom\"]):max_((aRectangle):rightBottom())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"moveBy:",0
,(
function(self,aPoint)
(function()
	local _s8_value=((self["@leftTop"]):_plus(aPoint))
	self["@leftTop"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self["@rightBottom"]):_plus(aPoint))
	self["@rightBottom"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","moveBy: aPoint\r\n\t\" Move the receiver by aPoint. \"\r\n\r\n\tleftTop := leftTop + aPoint.\r\n\trightBottom := rightBottom + aPoint","(\r\nfunction(self,aPoint)\r\n(function()\r\n\tlocal _s8_value=((self[\"@leftTop\"]):_plus(aPoint))\r\n\tself[\"@leftTop\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self[\"@rightBottom\"]):_plus(aPoint))\r\n\tself[\"@rightBottom\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"moveTo:",0
,(
function(self,aPoint)
(self):moveBy_((aPoint):_minus(self["@leftTop"]));
return (self);
end
)
,"accessing","moveTo: aPoint\r\n\t\" Move the receiver to aPoint. \"\r\n\r\n\tself moveBy: aPoint - leftTop","(\r\nfunction(self,aPoint)\r\n(self):moveBy_((aPoint):_minus(self[\"@leftTop\"]));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"moveToLeftTop:",0
,(
function(self,aPoint)
(self):moveBy_((aPoint):_minus((self):leftTop()));
return (self);
end
)
,"accessing","moveToLeftTop: aPoint\r\n\t\" Move the receiver to leftTop. \"\r\n\r\n\tself moveBy: aPoint - self leftTop","(\r\nfunction(self,aPoint)\r\n(self):moveBy_((aPoint):_minus((self):leftTop()));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"nonIntersections:",0
,(
function(self,aRectangle)
local areas=nil
if not (((self):intersects_(aRectangle)))==true then return ((smalltalk.Array):with_(self)); end;
if (smalltalk:boolean_and_(((aRectangle):containsPoint_(self["@leftTop"])),(function()
return ((aRectangle):containsPoint_(self["@rightBottom"]))
end)))==true then return (smalltalk:newArray({})); end;
return (((smalltalk.Array):with_with_with_with_(smalltalk:if_true_false_(((((aRectangle):top()) > (self):top())),(function()
return ((self["@leftTop"]):rightBottom_(((self["@rightBottom"]):x()):_at((aRectangle):top())))
end),nil),smalltalk:if_true_false_(((((aRectangle):bottom()) < (self):bottom())),(function()
return ((((self["@leftTop"]):x()):_at((aRectangle):bottom())):rightBottom_(self["@rightBottom"]))
end),nil),smalltalk:if_true_false_(((((aRectangle):left()) > (self):left())),(function()
return ((((self["@leftTop"]):x()):_at(((self["@leftTop"]):y()):max_((aRectangle):top()))):rightBottom_(((aRectangle):left()):_at(((self["@rightBottom"]):y()):min_((aRectangle):bottom()))))
end),nil),smalltalk:if_true_false_(((((aRectangle):right()) < (self):right())),(function()
return ((((aRectangle):right()):_at(((self["@leftTop"]):y()):max_((aRectangle):top()))):rightBottom_(((self["@rightBottom"]):x()):_at(((self["@rightBottom"]):y()):min_((aRectangle):bottom()))))
end),nil))):select_((function(each)
return (smalltalk:notNil_((each)))
end)));
end
)
,"accessing","nonIntersections: aRectangle\r\n\t\" Return the rectangles describing areas of the receiver outside aRectangle. \"\r\n\r\n\t| areas |\r\n\t(self intersects: aRectangle) ifFalse: [ ^Array with: self ].\r\n\t((aRectangle containsPoint: leftTop)\r\n\t\tand: [ aRectangle containsPoint: rightBottom ])\r\n\t\tifTrue: [ ^#() ].\r\n\t^(Array\r\n\twith: (aRectangle top > self top ifTrue: [ leftTop rightBottom: rightBottom x @ aRectangle top ])\r\n\twith: (aRectangle bottom < self bottom ifTrue: [ leftTop x @ aRectangle bottom rightBottom: rightBottom ])\r\n\twith: (aRectangle left > self left ifTrue: [ leftTop x @ (leftTop y max: aRectangle top)\r\n                rightBottom: aRectangle left @ (rightBottom y min: aRectangle bottom) ])\r\n\twith: (aRectangle right < self right ifTrue: [ aRectangle right @ (leftTop y max: aRectangle top)\r\n                rightBottom: rightBottom x @ (rightBottom y min: aRectangle bottom) ])\r\n\t) select: [:each| each notNil ]","(\r\nfunction(self,aRectangle)\r\nlocal areas=nil\r\nif not (((self):intersects_(aRectangle)))==true then return ((smalltalk.Array):with_(self)); end;\r\nif (smalltalk:boolean_and_(((aRectangle):containsPoint_(self[\"@leftTop\"])),(function()\r\nreturn ((aRectangle):containsPoint_(self[\"@rightBottom\"]))\r\nend)))==true then return (smalltalk:newArray({})); end;\r\nreturn (((smalltalk.Array):with_with_with_with_(smalltalk:if_true_false_(((((aRectangle):top()) > (self):top())),(function()\r\nreturn ((self[\"@leftTop\"]):rightBottom_(((self[\"@rightBottom\"]):x()):_at((aRectangle):top())))\r\nend),nil),smalltalk:if_true_false_(((((aRectangle):bottom()) < (self):bottom())),(function()\r\nreturn ((((self[\"@leftTop\"]):x()):_at((aRectangle):bottom())):rightBottom_(self[\"@rightBottom\"]))\r\nend),nil),smalltalk:if_true_false_(((((aRectangle):left()) > (self):left())),(function()\r\nreturn ((((self[\"@leftTop\"]):x()):_at(((self[\"@leftTop\"]):y()):max_((aRectangle):top()))):rightBottom_(((aRectangle):left()):_at(((self[\"@rightBottom\"]):y()):min_((aRectangle):bottom()))))\r\nend),nil),smalltalk:if_true_false_(((((aRectangle):right()) < (self):right())),(function()\r\nreturn ((((aRectangle):right()):_at(((self[\"@leftTop\"]):y()):max_((aRectangle):top()))):rightBottom_(((self[\"@rightBottom\"]):x()):_at(((self[\"@rightBottom\"]):y()):min_((aRectangle):bottom()))))\r\nend),nil))):select_((function(each)\r\nreturn (smalltalk:notNil_((each)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"toString",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:toString_((self["@leftTop"])))," to: ")),smalltalk:toString_((self["@rightBottom"]))));
end
)
,"printing","toString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^leftTop toString ,' to: ' ,rightBottom toString ","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:toString_((self[\"@leftTop\"]))),\" to: \")),smalltalk:toString_((self[\"@rightBottom\"]))));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"printString",0
,(
function(self)

return (smalltalk:toString_((self)));
end
)
,"printing","printString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t{'self'}.\r\n\t^self toString","(\r\nfunction(self)\r\n\r\nreturn (smalltalk:toString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"relativeTo:",0
,(
function(self,aRectangle)
local extent=nil
(function()
	local _s8_value=((aRectangle):extent())
	extent=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_or_((smalltalk:isObject_equalTo_((((aRectangle):extent()):x()),0)),(function()
return (smalltalk:isObject_equalTo_((((aRectangle):extent()):y()),0))
end)))==true then return (self); end;
return ((((self["@leftTop"]):_minus((aRectangle):leftTop())):_slash(extent)):extent_(((self):extent()):_slash(extent)));
end
)
,"accessing","relativeTo: aRectangle\r\n\t\" Return a Rectangle proportionally relative to aRectangle. \"\r\n\r\n\t| extent |\r\n\textent := aRectangle extent.\r\n\t(aRectangle extent x = 0 or: [ aRectangle extent y = 0 ]) ifTrue: [ ^self ].\r\n\t^leftTop - aRectangle leftTop / extent extent: self extent / extent","(\r\nfunction(self,aRectangle)\r\nlocal extent=nil\r\n(function()\r\n\tlocal _s8_value=((aRectangle):extent())\r\n\textent=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_or_((smalltalk:isObject_equalTo_((((aRectangle):extent()):x()),0)),(function()\r\nreturn (smalltalk:isObject_equalTo_((((aRectangle):extent()):y()),0))\r\nend)))==true then return (self); end;\r\nreturn ((((self[\"@leftTop\"]):_minus((aRectangle):leftTop())):_slash(extent)):extent_(((self):extent()):_slash(extent)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"right",0
,(
function(self)
return ((self["@rightBottom"]):x());
end
)
,"accessing","right\r\n\t\" Return the receiver's right side. \"\r\n\r\n\t^rightBottom x","(\r\nfunction(self)\r\nreturn ((self[\"@rightBottom\"]):x());\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"rightBottom",0
,(
function(self)
return (self["@rightBottom"]);
end
)
,"accessing","rightBottom\r\n\t\" Return the right bottom corner. \"\r\n\r\n\t^rightBottom","(\r\nfunction(self)\r\nreturn (self[\"@rightBottom\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"rightBottom:",0
,(
function(self,aPoint)
(function()
	local _s8_value=(aPoint)
	self["@rightBottom"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","rightBottom: aPoint\r\n\t\" Set the right bottom corner of the receiver. \"\r\n\r\n\trightBottom := aPoint","(\r\nfunction(self,aPoint)\r\n(function()\r\n\tlocal _s8_value=(aPoint)\r\n\tself[\"@rightBottom\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"rightCenter",0
,(
function(self)
return (((self):right()):_at(((self):center()):y()));
end
)
,"accessing","rightCenter\r\n\t\" Return the center of the right edge of the receiver. \"\r\n\r\n\t^self right @ self center y","(\r\nfunction(self)\r\nreturn (((self):right()):_at(((self):center()):y()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"rightTop",0
,(
function(self)
return (((self):right()):_at((self):top()));
end
)
,"accessing","rightTop\r\n        \" Return the right top of the receiver. \"\r\n\r\n\t^self right @ self top","(\r\nfunction(self)\r\nreturn (((self):right()):_at((self):top()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"rounded",0
,(
function(self)
(function()
	local _s8_value=((self["@leftTop"]):rounded())
	self["@leftTop"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self["@rightBottom"]):rounded())
	self["@rightBottom"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","rounded\r\n\t\" Set the receiver with coordinates rounded to integers. \"\r\n\r\n\tleftTop := leftTop rounded.\r\n\trightBottom := rightBottom rounded.","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=((self[\"@leftTop\"]):rounded())\r\n\tself[\"@leftTop\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self[\"@rightBottom\"]):rounded())\r\n\tself[\"@rightBottom\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"scaleBy:",0
,(
function(self,delta)
return (((self["@leftTop"]):_star(delta)):rightBottom_((self["@rightBottom"]):_star(delta)));
end
)
,"accessing","scaleBy: delta\r\n\t\" Return the receiver multiplied by delta. \"\r\n\r\n\t^leftTop * delta rightBottom: rightBottom * delta","(\r\nfunction(self,delta)\r\nreturn (((self[\"@leftTop\"]):_star(delta)):rightBottom_((self[\"@rightBottom\"]):_star(delta)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"scaleTo:",0
,(
function(self,aRectangle)
return ((((aRectangle):scaleBy_((self):extent())):truncated()):moveBy_((self):leftTop()));
end
)
,"accessing","scaleTo: aRectangle\r\n\t\" Return a Rectangle whose size is proportional to the receiver with ratios specified by aRectangle. \"\r\n\r\n\t^(aRectangle scaleBy: self extent) truncated moveBy: self leftTop","(\r\nfunction(self,aRectangle)\r\nreturn ((((aRectangle):scaleBy_((self):extent())):truncated()):moveBy_((self):leftTop()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"top",0
,(
function(self)
return ((self["@leftTop"]):y());
end
)
,"accessing","top\r\n\t\" Return the top side of the receiver. \"\r\n\r\n\t^leftTop y","(\r\nfunction(self)\r\nreturn ((self[\"@leftTop\"]):y());\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"topCenter",0
,(
function(self)
return ((((self):center()):x()):_at((self):top()));
end
)
,"accessing","topCenter\r\n\t\" Return the center of the top edge of the receiver. \"\r\n\r\n\t^self center x @ self top","(\r\nfunction(self)\r\nreturn ((((self):center()):x()):_at((self):top()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"topLeft",0
,(
function(self)
return (self["@leftTop"]);
end
)
,"accessing","topLeft\r\n\t\" Return the top-left corner of the receiver. \"\r\n\r\n\t^leftTop","(\r\nfunction(self)\r\nreturn (self[\"@leftTop\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"topLeft:",0
,(
function(self,aPoint)
(function()
	local _s8_value=(aPoint)
	self["@leftTop"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","topLeft: aPoint\r\n\t\"Set the top left corner of the receiver. \"\r\n\r\n\tleftTop := aPoint","(\r\nfunction(self,aPoint)\r\n(function()\r\n\tlocal _s8_value=(aPoint)\r\n\tself[\"@leftTop\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"topRight",0
,(
function(self)
return (((self):right()):_at((self):top()));
end
)
,"accessing","topRight\r\n\t\" Return the top-right corner of the receiver. \"\r\n\r\n\t^self right @ self top","(\r\nfunction(self)\r\nreturn (((self):right()):_at((self):top()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"translateBy:",0
,(
function(self,delta)
return (((self["@leftTop"]):_plus(delta)):rightBottom_((self["@rightBottom"]):_plus(delta)));
end
)
,"accessing","translateBy: delta\r\n\t\" Return the receiver with position incremented by delta. \"\r\n\r\n\t^leftTop + delta rightBottom: rightBottom + delta","(\r\nfunction(self,delta)\r\nreturn (((self[\"@leftTop\"]):_plus(delta)):rightBottom_((self[\"@rightBottom\"]):_plus(delta)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"truncated",0
,(
function(self)
(function()
	local _s8_value=((self["@leftTop"]):truncated())
	self["@leftTop"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self["@rightBottom"]):truncated())
	self["@rightBottom"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","truncated\r\n\t\" Set the receiver with the coordinates truncated to integers. \"\r\n\r\n\tleftTop := leftTop truncated.\r\n\trightBottom := rightBottom truncated.","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=((self[\"@leftTop\"]):truncated())\r\n\tself[\"@leftTop\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self[\"@rightBottom\"]):truncated())\r\n\tself[\"@rightBottom\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"width",0
,(
function(self)
return ((((self["@rightBottom"]):x()):_minus((self["@leftTop"]):x())):abs());
end
)
,"accessing","width\r\n\t\" Return the width of the receiver. \"\r\n\r\n\t^(rightBottom x - leftTop x) abs","(\r\nfunction(self)\r\nreturn ((((self[\"@rightBottom\"]):x()):_minus((self[\"@leftTop\"]):x())):abs());\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"width:",0
,(
function(self,anInteger)
(self["@rightBottom"]):x_(((self["@leftTop"]):x()):_plus(anInteger));
return (self);
end
)
,"accessing","width: anInteger\r\n\t\" Set the width of the receiver. \"\r\n\r\n\trightBottom x: leftTop x + anInteger","(\r\nfunction(self,anInteger)\r\n(self[\"@rightBottom\"]):x_(((self[\"@leftTop\"]):x()):_plus(anInteger));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Rectangle,"__tostring",0
,(
function(self)
return (smalltalk:toString_((self)));
end
)
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","(\r\nfunction(self)\r\nreturn (smalltalk:toString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.EvaluableAction,",","_comma"
,(
function(self,anAction)
return ((smalltalk.ActionSequence):with_with_(self,anAction));
end
)
,"composing",", anAction\r\n\t\" Return the receiver composed with the argument. \"\r\n\r\n\t^ActionSequence with: self with: anAction","(\r\nfunction(self,anAction)\r\nreturn ((smalltalk.ActionSequence):with_with_(self,anAction));\r\nend\r\n)")
smalltalk:bind(smalltalk.Message["$klass"],"selector:arguments:",0
,(
function(self,aString,anArray)
return ((
function(_s8_rec)
	(_s8_rec):selector_(aString);
	(_s8_rec):arguments_(anArray);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","selector: aString arguments: anArray\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tselector: aString;\r\n\t\targuments: anArray;\r\n\t\tyourself","(\r\nfunction(self,aString,anArray)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):selector_(aString);\r\n\t(_s8_rec):arguments_(anArray);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Message["$klass"],"receiver:selector:arguments:",0
,(
function(self,anObject,aString,anArray)
return ((
function(_s8_rec)
	(_s8_rec):receiver_(anObject);
	(_s8_rec):selector_(aString);
	(_s8_rec):arguments_(anArray);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","receiver: anObject selector: aString arguments: anArray\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\treceiver: anObject;\r\n\t\tselector: aString;\r\n\t\targuments: anArray;\r\n\t\tyourself","(\r\nfunction(self,anObject,aString,anArray)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):receiver_(anObject);\r\n\t(_s8_rec):selector_(aString);\r\n\t(_s8_rec):arguments_(anArray);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"selector",0
,(
function(self)
return (self["@selector"]);
end
)
,"accessing","selector\r\n\t\" Return the selector of the receiver. \"\r\n\r\n\t^selector","(\r\nfunction(self)\r\nreturn (self[\"@selector\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"selector:",0
,(
function(self,aString)
(function()
	local _s8_value=(aString)
	self["@selector"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","selector: aString\r\n\t\" Set the selector of the receiver. \"\r\n\r\n\tselector := aString","(\r\nfunction(self,aString)\r\n(function()\r\n\tlocal _s8_value=(aString)\r\n\tself[\"@selector\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"arguments:",0
,(
function(self,anArray)
(function()
	local _s8_value=(anArray)
	self["@arguments"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","arguments: anArray\r\n\t\" Set the arguments of the receiver. \"\r\n\r\n\targuments := anArray","(\r\nfunction(self,anArray)\r\n(function()\r\n\tlocal _s8_value=(anArray)\r\n\tself[\"@arguments\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"arguments",0
,(
function(self)
return (self["@arguments"]);
end
)
,"accessing","arguments\r\n\t\" Return the arguments of the receiver. \"\r\n\r\n\t^arguments","(\r\nfunction(self)\r\nreturn (self[\"@arguments\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"receiver",0
,(
function(self)
return (self["@receiver"]);
end
)
,"accessing","receiver\r\n\t\" Return the receiver of the receiver. \"\r\n\r\n\t^receiver","(\r\nfunction(self)\r\nreturn (self[\"@receiver\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"receiver:",0
,(
function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@receiver"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","receiver: anObject\r\n\t\" Set the receiver of the receiver. \"\r\n\r\n\treceiver := anObject","(\r\nfunction(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@receiver\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"comment",0
,(
function(self)
return ((self)["@comment"]);
end
)
,"accessing","comment\r\n\t\" Return the comment of the receiver (or nil). \"\r\n\r\n\t^self basicAt: '@comment'","(\r\nfunction(self)\r\nreturn ((self)[\"@comment\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"comment:",0
,(
function(self,aString)
if (smalltalk:isNil_((aString)))==true then return ((self):basicDelete_("@comment")); end;
smalltalk:basic_at_put_((self),"@comment",aString);
return (self);
end
)
,"accessing","comment: aString\r\n\t\" Set the comment of the receiver. \"\r\n\r\n\taString isNil ifTrue: [ ^self basicDelete: '@comment' ].\r\n\tself basicAt: '@comment' put: aString","(\r\nfunction(self,aString)\r\nif (smalltalk:isNil_((aString)))==true then return ((self):basicDelete_(\"@comment\")); end;\r\nsmalltalk:basic_at_put_((self),\"@comment\",aString);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"perform",0
,(
function(self)
return (((self):receiver()):perform_withArguments_((self):selector(),(self):arguments()));
end
)
,"private","perform\r\n\t\" Return the result of sending the receiver. \"\r\n\r\n\t^self receiver\r\n\t\tperform: self selector\r\n\t\twithArguments: self arguments","(\r\nfunction(self)\r\nreturn (((self):receiver()):perform_withArguments_((self):selector(),(self):arguments()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"performDeferred",0
,(
function(self)
((function()
return ((self):perform())
end)):valueDeferred();
return (self);
end
)
,"evaluating","performDeferred\r\n\t\" Evaluate the receiver deferred in time.\r\n\tReturn the receiver.\r\n\t\"\r\n\r\n\t[ self perform ] valueDeferred.","(\r\nfunction(self)\r\n((function()\r\nreturn ((self):perform())\r\nend)):valueDeferred();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"evaluate",0
,(
function(self)
return ((self):perform());
end
)
,"evaluating","evaluate\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self perform","(\r\nfunction(self)\r\nreturn ((self):perform());\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"evaluateFor:",0
,(
function(self,anObject)
return ((self):evaluateWithArguments_((smalltalk.Array):with_(anObject)));
end
)
,"evaluating","evaluateFor: anObject\r\n\t\" Return the result of evaluating the receiver with anObject. \"\r\n\r\n\t^self evaluateWithArguments: (Array with: anObject)","(\r\nfunction(self,anObject)\r\nreturn ((self):evaluateWithArguments_((smalltalk.Array):with_(anObject)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"evaluateWithArguments:",0
,(
function(self,anArray)
return (((self):receiver()):perform_withArguments_((self):selector(),(self):collectArguments_(anArray)));
end
)
,"evaluating","evaluateWithArguments: anArray\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self receiver\r\n\t\tperform: self selector\r\n\t\twithArguments: (self collectArguments: anArray)","(\r\nfunction(self,anArray)\r\nreturn (((self):receiver()):perform_withArguments_((self):selector(),(self):collectArguments_(anArray)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"initializeArguments",0
,(
function(self)
(function()
	local _s8_value=((smalltalk.Array):new_(((self):selector()):argumentCount()))
	self["@arguments"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"private","initializeArguments\r\n\t\" Private - Initialize the arguments of the receiver. \"\r\n\r\n\targuments := Array new: self selector argumentCount","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new_(((self):selector()):argumentCount()))\r\n\tself[\"@arguments\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"argumentCount",0
,(
function(self)
if (smalltalk:isNil_((self["@arguments"])))==true then (self):initializeArguments(); end;
return ((self["@arguments"]):size());
end
)
,"private","argumentCount\r\n\t\" Return the number of arguments of the receiver. \"\r\n\r\n\targuments isNil ifTrue: [ self initializeArguments ].\r\n\t^arguments size","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@arguments\"])))==true then (self):initializeArguments(); end;\r\nreturn ((self[\"@arguments\"]):size());\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"collectArguments:",0
,(
function(self,evaluationArguments)
if (smalltalk:isObject_equalTo_(((self["@arguments"]):size()),(evaluationArguments):size()))==true then return (evaluationArguments); end;
return ((evaluationArguments):copyFrom_to_(1,((self):argumentCount()):min_((evaluationArguments):size())));
end
)
,"private","collectArguments: evaluationArguments\r\n\t\" Private - Return the arguments to evaluate the receiver. \"\r\n\r\n\targuments size = evaluationArguments size ifTrue: [ ^evaluationArguments ].\r\n\t^evaluationArguments copyFrom: 1 to: (self argumentCount min: evaluationArguments size)","(\r\nfunction(self,evaluationArguments)\r\nif (smalltalk:isObject_equalTo_(((self[\"@arguments\"]):size()),(evaluationArguments):size()))==true then return (evaluationArguments); end;\r\nreturn ((evaluationArguments):copyFrom_to_(1,((self):argumentCount()):min_((evaluationArguments):size())));\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"resolve:with:",0
,(
function(self,what,aPoolOrBlock)
if not (((aPoolOrBlock):isMemberOf_(smalltalk.PoolDictionary)))==true then return ((aPoolOrBlock):evaluateWith_(what)); end;
if (smalltalk:isNil_((what)))==true then return (what); end;
if not (((self):isObject_(what)))==true then return (what); end;
if ((what):isString())==true then return ((aPoolOrBlock):at_ifAbsent_(what,(function()
return (what)
end))); end;
return (what);
end
)
,"resolution","resolve: what with: aPoolOrBlock\r\n\t\" Private - Return the receiver to be evaluated with mappings given by aPoolOrBlock. \"\r\n\r\n\t(aPoolOrBlock isMemberOf: PoolDictionary) ifFalse: [\r\n\t\t^aPoolOrBlock evaluateWith: what\r\n\t].\r\n\twhat isNil ifTrue: [ ^what ].\r\n\t(self isObject: what) ifFalse: [ ^what ].\r\n\twhat isString ifTrue: [ ^aPoolOrBlock at: what ifAbsent: [ what ] ].\r\n\t^what","(\r\nfunction(self,what,aPoolOrBlock)\r\nif not (((aPoolOrBlock):isMemberOf_(smalltalk.PoolDictionary)))==true then return ((aPoolOrBlock):evaluateWith_(what)); end;\r\nif (smalltalk:isNil_((what)))==true then return (what); end;\r\nif not (((self):isObject_(what)))==true then return (what); end;\r\nif ((what):isString())==true then return ((aPoolOrBlock):at_ifAbsent_(what,(function()\r\nreturn (what)\r\nend))); end;\r\nreturn (what);\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"resolveWith:",0
,(
function(self,aPoolOrBlock)
local args=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((self["@arguments"]))),(function()
return ((self["@arguments"]):collect_((function(each)
return ((self):resolve_with_(each,aPoolOrBlock))
end)))
end),nil))
	args=_s8_value
	return _s8_value
end)();
return (((self)["$klass"]):receiver_selector_arguments_((self):resolve_with_(self["@receiver"],aPoolOrBlock),(self):selector(),args));
end
)
,"resolution","resolveWith: aPoolOrBlock\r\n\t\" Return a message set to be evaluated with mappings given by aPoolOrBlock. \"\r\n\r\n\t| args |\r\n\targs := arguments notNil ifTrue: [\r\n\t\targuments collect: [:each|\r\n\t\t\tself resolve: each with: aPoolOrBlock\r\n\t\t]\r\n\t].\r\n\t^self class\r\n\t\treceiver: (self resolve: receiver with: aPoolOrBlock)\r\n\t\tselector: self selector\r\n\t\targuments: args","(\r\nfunction(self,aPoolOrBlock)\r\nlocal args=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((self[\"@arguments\"]))),(function()\r\nreturn ((self[\"@arguments\"]):collect_((function(each)\r\nreturn ((self):resolve_with_(each,aPoolOrBlock))\r\nend)))\r\nend),nil))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((self)[\"$klass\"]):receiver_selector_arguments_((self):resolve_with_(self[\"@receiver\"],aPoolOrBlock),(self):selector(),args));\r\nend\r\n)")
smalltalk:bind(smalltalk.Message,"isMessage",0
,(
function(self)
return (true);
end
)
,"testing","isMessage\r\n\t\" Return true if the receiver is a message. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.LinkMessage,"resultAction",0
,(
function(self)
return (self["@resultAction"]);
end
)
,"accessing","resultAction\r\n\t\" Return the resultAction of the receiver. \"\r\n\r\n\t^resultAction","(\r\nfunction(self)\r\nreturn (self[\"@resultAction\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.LinkMessage,"resultAction:",0
,(
function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@resultAction"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","resultAction: anObject\r\n\t\" Set the resultAction of the receiver. \"\r\n\r\n\tresultAction := anObject","(\r\nfunction(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@resultAction\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LinkMessage,"evaluate",0
,(
function(self)
return ((self):evaluateWithArguments_(smalltalk:newArray({})));
end
)
,"evaluating","evaluate\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self evaluateWithArguments: #()","(\r\nfunction(self)\r\nreturn ((self):evaluateWithArguments_(smalltalk:newArray({})));\r\nend\r\n)")
smalltalk:bind(smalltalk.LinkMessage,"collectArguments:",0
,(
function(self,evaluationArguments)
return (((self):arguments()):collect_((function(each)
return ((each):evaluateWithArguments_(evaluationArguments))
end)));
end
)
,"evaluating","collectArguments: evaluationArguments\r\n\t\" Private - Return the arguments to evaluate the receiver. \"\r\n\r\n\t^self arguments collect: [:each| each evaluateWithArguments: evaluationArguments ]","(\r\nfunction(self,evaluationArguments)\r\nreturn (((self):arguments()):collect_((function(each)\r\nreturn ((each):evaluateWithArguments_(evaluationArguments))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence["$klass"],"withAll:",0
,(
function(self,aCollection)
return ((
function(_s8_rec)
	(_s8_rec):contents_(aCollection);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","withAll: aCollection\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tcontents: aCollection;\r\n\t\tyourself","(\r\nfunction(self,aCollection)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):contents_(aCollection);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence["$klass"],"with:",0
,(
function(self,anObject)
return ((self):withAll_((smalltalk.Array):with_(anObject)));
end
)
,"instantiation","with: anObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self withAll: (Array with: anObject)","(\r\nfunction(self,anObject)\r\nreturn ((self):withAll_((smalltalk.Array):with_(anObject)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence["$klass"],"with:with:",0
,(
function(self,anObject,bObject)
return ((self):withAll_((smalltalk.Array):with_with_(anObject,bObject)));
end
)
,"instantiation","with: anObject with: bObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self withAll: (Array with: anObject with: bObject)","(\r\nfunction(self,anObject,bObject)\r\nreturn ((self):withAll_((smalltalk.Array):with_with_(anObject,bObject)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence["$klass"],"with:with:with:",0
,(
function(self,anObject,bObject,cObject)
return ((self):withAll_((smalltalk.Array):with_with_with_(anObject,bObject,cObject)));
end
)
,"instantiation","with: anObject with: bObject with: cObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self withAll: (Array with: anObject with: bObject with: cObject)","(\r\nfunction(self,anObject,bObject,cObject)\r\nreturn ((self):withAll_((smalltalk.Array):with_with_with_(anObject,bObject,cObject)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"contents:",0
,(
function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@contents"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"private","contents: aCollection\r\n\t\" Private - Set the contents of the receiver. \"\r\n\r\n\tcontents := aCollection","(\r\nfunction(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@contents\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"contents",0
,(
function(self)
if (smalltalk:isNil_((self["@contents"])))==true then (function()
	local _s8_value=((smalltalk.Array):new())
	self["@contents"]=_s8_value
	return _s8_value
end)(); end;
return (self["@contents"]);
end
)
,"private","contents\r\n\t\" Private - Return the contents of the receiver. \"\r\n\r\n\tcontents isNil ifTrue: [ contents := Array new ].\r\n\t^contents","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@contents\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@contents\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@contents\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"isEmpty",0
,(
function(self)
return (smalltalk:boolean_or_((smalltalk:isNil_((self["@contents"]))),(function()
return ((self["@contents"]):isEmpty())
end)));
end
)
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^contents isNil or: [ contents isEmpty ]","(\r\nfunction(self)\r\nreturn (smalltalk:boolean_or_((smalltalk:isNil_((self[\"@contents\"]))),(function()\r\nreturn ((self[\"@contents\"]):isEmpty())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"notEmpty",0
,(
function(self)
return (smalltalk:boolean_and_((smalltalk:notNil_((self["@contents"]))),(function()
return ((self["@contents"]):notEmpty())
end)));
end
)
,"testing","notEmpty\r\n\t\" Return true if the receiver is not empty. \"\r\n\r\n\t^contents notNil and: [ contents notEmpty ]","(\r\nfunction(self)\r\nreturn (smalltalk:boolean_and_((smalltalk:notNil_((self[\"@contents\"]))),(function()\r\nreturn ((self[\"@contents\"]):notEmpty())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"asArray",0
,(
function(self)
if ((self):isEmpty())==true then return (smalltalk:newArray({})); end;
return ((self["@contents"]):asArray());
end
)
,"converting","asArray\r\n\t\" Return an array with the contents of the receiver. \"\r\n\r\n\tself isEmpty ifTrue: [ ^#() ].\r\n\t^contents asArray","(\r\nfunction(self)\r\nif ((self):isEmpty())==true then return (smalltalk:newArray({})); end;\r\nreturn ((self[\"@contents\"]):asArray());\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"asActionSequence",0
,(
function(self)
return (self);
end
)
,"converting","asActionSequence\r\n\t\" Return an ActionSequence from the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,",","_comma"
,(
function(self,anAction)
if ((self):isEmpty())==true then return ((anAction):asActionSequence()); end;
return (((self)["$klass"]):withAll_(smalltalk:object_comma_(((self):contents()),((anAction):asActionSequence()):contents())));
end
)
,"converting",", anAction\r\n\t\" Return an action composed with the receiver and anAction. \"\r\n\r\n\tself isEmpty ifTrue: [ ^anAction asActionSequence ].\r\n\t^self class withAll: self contents , anAction asActionSequence contents","(\r\nfunction(self,anAction)\r\nif ((self):isEmpty())==true then return ((anAction):asActionSequence()); end;\r\nreturn (((self)[\"$klass\"]):withAll_(smalltalk:object_comma_(((self):contents()),((anAction):asActionSequence()):contents())));\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"copyWith:",0
,(
function(self,anObject)
return (((self)["$klass"]):withAll_(((self):contents()):copyWith_(anObject)));
end
)
,"converting","copyWith: anObject\r\n\t\" Return an action composed with the receiver and anObject. \"\r\n\r\n\t^self class withAll: (self contents copyWith: anObject)","(\r\nfunction(self,anObject)\r\nreturn (((self)[\"$klass\"]):withAll_(((self):contents()):copyWith_(anObject)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"do:",0
,(
function(self,aBlock)
return (smalltalk:if_true_false_(((self):notEmpty()),(function()
return (((self):contents()):do_(aBlock))
end),nil));
end
)
,"converting","do: aBlock\r\n\t\" Evaluate aBlock for each object in the receiver's contents. \"\r\n\r\n\t^self notEmpty ifTrue: [ self contents do: aBlock ]","(\r\nfunction(self,aBlock)\r\nreturn (smalltalk:if_true_false_(((self):notEmpty()),(function()\r\nreturn (((self):contents()):do_(aBlock))\r\nend),nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"includes:",0
,(
function(self,anObject)
return (smalltalk:boolean_and_(((self):notEmpty()),(function()
return (((self):contents()):includes_(anObject))
end)));
end
)
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t^self notEmpty and: [ self contents includes: anObject ]","(\r\nfunction(self,anObject)\r\nreturn (smalltalk:boolean_and_(((self):notEmpty()),(function()\r\nreturn (((self):contents()):includes_(anObject))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"select:",0
,(
function(self,aBlock)
return (((self)["$klass"]):withAll_(((self):asArray()):select_(aBlock)));
end
)
,"enumerating","select: aBlock\r\n\t\" Return the a copy of the receiver with elements wich evaluates aBlock to true. \"\r\n\r\n\t^self class withAll: (self asArray select: aBlock)","(\r\nfunction(self,aBlock)\r\nreturn (((self)[\"$klass\"]):withAll_(((self):asArray()):select_(aBlock)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"reject:",0
,(
function(self,aBlock)
return (((self)["$klass"]):withAll_(((self):asArray()):reject_(aBlock)));
end
)
,"enumerating","reject: aBlock\r\n\t\" Return the a copy of the receiver with elements wich evaluates aBlock to false. \"\r\n\r\n\t^self class withAll: (self asArray reject: aBlock)","(\r\nfunction(self,aBlock)\r\nreturn (((self)[\"$klass\"]):withAll_(((self):asArray()):reject_(aBlock)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"evaluate",0
,(
function(self)
local result=nil
(self):do_((function(each)
return ((function()
	local _s8_value=((each):evaluate())
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
)
,"evaluating","evaluate\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t| result |\r\n\tself do: [:each| result := each evaluate ].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(self):do_((function(each)\r\nreturn ((function()\r\n\tlocal _s8_value=((each):evaluate())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"evaluateWithArguments:",0
,(
function(self,anArray)
local result=nil
(self):do_((function(each)
return ((function()
	local _s8_value=((each):evaluateWithArguments_(anArray))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
)
,"evaluating","evaluateWithArguments: anArray\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t| result |\r\n\tself do: [:each| result := each evaluateWithArguments: anArray ].\r\n\t^result","(\r\nfunction(self,anArray)\r\nlocal result=nil\r\n(self):do_((function(each)\r\nreturn ((function()\r\n\tlocal _s8_value=((each):evaluateWithArguments_(anArray))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"evaluateFor:",0
,(
function(self,anObject)
local result=nil
(self):do_((function(each)
return ((function()
	local _s8_value=((each):evaluateFor_(anObject))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
)
,"evaluating","evaluateFor: anObject\r\n\t\" Return the result of evaluating the receiver with anObject. \"\r\n\r\n\t| result |\r\n\tself do: [:each| result := each evaluateFor: anObject ].\r\n\t^result","(\r\nfunction(self,anObject)\r\nlocal result=nil\r\n(self):do_((function(each)\r\nreturn ((function()\r\n\tlocal _s8_value=((each):evaluateFor_(anObject))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"reduced",0
,(
function(self)
return (smalltalk:if_true_false_(((self):notEmpty()),(function()
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self["@contents"]):size()),1)),(function()
return ((self["@contents"]):first())
end),(function()
return (self)
end)))
end),nil));
end
)
,"events","reduced\r\n\t\" Return the receiver reduced to minimal evaluable expression. \"\r\n\r\n\t^self notEmpty ifTrue: [\r\n\t\tcontents size = 1\r\n\t\tifTrue: [ contents first ]\r\n\t\tifFalse: [ self ]\r\n\t]","(\r\nfunction(self)\r\nreturn (smalltalk:if_true_false_(((self):notEmpty()),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self[\"@contents\"]):size()),1)),(function()\r\nreturn ((self[\"@contents\"]):first())\r\nend),(function()\r\nreturn (self)\r\nend)))\r\nend),nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"evaluateWithSelector:withArguments:",0
,(
function(self,aSelector,array)
local result=nil
(self):do_((function(each)
return ((function()
	local _s8_value=(((each):receiver()):perform_withArguments_(aSelector,array))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
)
,"changes","evaluateWithSelector: aSelector withArguments: array\r\n\t\" Private - Return the result of evaluating the receiver with aSelector and arguments array. \"\r\n\r\n\t| result |\r\n\tself do: [:each| result := each receiver perform: aSelector withArguments: array ].\r\n\t^result","(\r\nfunction(self,aSelector,array)\r\nlocal result=nil\r\n(self):do_((function(each)\r\nreturn ((function()\r\n\tlocal _s8_value=(((each):receiver()):perform_withArguments_(aSelector,array))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.ActionSequence,"resolveWith:",0
,(
function(self,aPoolOrBlock)
return (((self)["$klass"]):withAll_(((self):asArray()):collect_((function(each)
return (smalltalk:if_true_false_((smalltalk:responds_to_((each),("resolveWith:"))),(function()
return ((each):resolveWith_(aPoolOrBlock))
end),(function()
return (each)
end)))
end))));
end
)
,"resolution","resolveWith: aPoolOrBlock\r\n\t\" Return an instance set to be evaluated with mappings given by aPoolOrBlock. \"\r\n\r\n\t^self class withAll: (self asArray collect: [:each|\r\n\t\t(each respondsTo: #resolveWith:)\r\n\t\tifTrue: [ each resolveWith: aPoolOrBlock ]\r\n\t\tifFalse: [ each ]\r\n\t])","(\r\nfunction(self,aPoolOrBlock)\r\nreturn (((self)[\"$klass\"]):withAll_(((self):asArray()):collect_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:responds_to_((each),(\"resolveWith:\"))),(function()\r\nreturn ((each):resolveWith_(aPoolOrBlock))\r\nend),(function()\r\nreturn (each)\r\nend)))\r\nend))));\r\nend\r\n)")
smalltalk:bind(smalltalk.EventManager["$klass"],"eventsTriggered",0
,(
function(self)
if (smalltalk:isNil_((self["@eventsTriggered"])))==true then (self):initializeEventsTriggered(); end;
return (self["@eventsTriggered"]);
end
)
,"events","eventsTriggered\r\n\t\" Return all the events managed by instances of the receiver. \"\r\n\r\n\teventsTriggered isNil ifTrue: [ self initializeEventsTriggered ].\r\n\t^eventsTriggered","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@eventsTriggered\"])))==true then (self):initializeEventsTriggered(); end;\r\nreturn (self[\"@eventsTriggered\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.EventManager["$klass"],"eventsTriggered:",0
,(
function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@eventsTriggered"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"events","eventsTriggered: aCollection\r\n\t\" Set all the events managed by instances of the receiver. \"\r\n\r\n\teventsTriggered := aCollection","(\r\nfunction(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@eventsTriggered\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.EventManager["$klass"],"initializeEventsTriggered",0
,(
function(self)
(self):eventsTriggered_((self):constructEventsTriggered());
return (self);
end
)
,"events","initializeEventsTriggered\r\n\t\" Private - Initialize all the events managed by instances of the receiver. \"\r\n\r\n\tself eventsTriggered: self constructEventsTriggered","(\r\nfunction(self)\r\n(self):eventsTriggered_((self):constructEventsTriggered());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.EventManager,"eventTable",0
,(
function(self)
return (smalltalk:if_true_false_((smalltalk:isNil_((self["@handlers"]))),(function()
return ((self):eventTableCreate())
end),(function()
return (self["@handlers"])
end)));
end
)
,"events","eventTable\r\n\t\" Private - Return the mapping event names to actions of the receiver. \"\r\n\r\n\t^handlers isNil\r\n\t\tifTrue: [ self eventTableCreate ]\r\n\t\tifFalse: [ handlers ]","(\r\nfunction(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((self[\"@handlers\"]))),(function()\r\nreturn ((self):eventTableCreate())\r\nend),(function()\r\nreturn (self[\"@handlers\"])\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.EventManager,"eventTableForEdit",0
,(
function(self)
if (smalltalk:isNil_((self["@handlers"])))==true then (function()
	local _s8_value=((self):eventTableCreate())
	self["@handlers"]=_s8_value
	return _s8_value
end)(); end;
return (self["@handlers"]);
end
)
,"events","eventTableForEdit\r\n\t\" Private - Return the mapping event names to actions of the receiver.\r\n\tSet the internal map if not present.\r\n\t\"\r\n\r\n\thandlers isNil ifTrue: [ handlers := self eventTableCreate ].\r\n\t^handlers","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@handlers\"])))==true then (function()\r\n\tlocal _s8_value=((self):eventTableCreate())\r\n\tself[\"@handlers\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@handlers\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.EventManager,"releaseEventTable",0
,(
function(self)
(function()
	local _s8_value=(nil)
	self["@handlers"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"events","releaseEventTable\r\n\t\" Private - Release the event table. \"\r\n\r\n\thandlers := nil","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@handlers\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder["$klass"],"for:",0
,(
function(self,aCompiler)
return ((((self):support()):new()):compiler_(aCompiler));
end
)
,"instantiation","for: aCompiler\r\n\t\" Private - Return an instance of the receiver. \"\r\n\r\n\t^self support new compiler: aCompiler","(\r\nfunction(self,aCompiler)\r\nreturn ((((self):support()):new()):compiler_(aCompiler));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder["$klass"],"support",0
,(
function(self)
local lang=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):nativeLanguage())
	lang=_s8_value
	return _s8_value
end)();
return (((self):allSubclasses()):detect_ifNone_((function(cls)
return ((cls):supportsLanguage_(lang))
end),(function()
return ((self):invalidMessage_("support"))
end)));
end
)
,"instantiation","support\r\n\t\" Private - Return the support to encode for native platform. \"\r\n\r\n\t| lang |\r\n\tlang := Smalltalk nativeLanguage.\r\n\t^self allSubclasses\r\n\t\tdetect: [:cls| cls supportsLanguage: lang ]\r\n\t\tifNone: [ self invalidMessage: #support ]","(\r\nfunction(self)\r\nlocal lang=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):nativeLanguage())\r\n\tlang=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((self):allSubclasses()):detect_ifNone_((function(cls)\r\nreturn ((cls):supportsLanguage_(lang))\r\nend),(function()\r\nreturn ((self):invalidMessage_(\"support\"))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder["$klass"],"supportsLanguage:",0
,(
function(self,aLanguage)
return (false);
end
)
,"instantiation","supportsLanguage: aLanguage\r\n\t\" Private - Return true if instances of the receiver can encode to aLanguage. \"\r\n\r\n\t^false","(\r\nfunction(self,aLanguage)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder["$klass"],"export:",0
,(
function(self,spec)
return (((self):new()):export_(spec));
end
)
,"Tools-export","export: spec\r\n\t\" Return the native code result of encoding spec. \"\r\n\r\n\t^self new export: spec","(\r\nfunction(self,spec)\r\nreturn (((self):new()):export_(spec));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"messageSendConnector",0
,(
function(self)
return ((self):implementedBySubclass_("messageSendConnector"));
end
)
,"encoding","messageSendConnector\r\n\t\" Private - Return the connector to use for sending a message. \"\r\n\r\n\t^self implementedBySubclass: #messageSendConnector ","(\r\nfunction(self)\r\nreturn ((self):implementedBySubclass_(\"messageSendConnector\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"propertyAccessConnector",0
,(
function(self)
return ((self):messageSendConnector());
end
)
,"encoding","propertyAccessConnector\r\n\t\" Private - Return the connector to use for accessing a native property. \"\r\n\r\n\t^self messageSendConnector ","(\r\nfunction(self)\r\nreturn ((self):messageSendConnector());\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"codeToGetGlobal:",0
,(
function(self,aName)
return (smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk"),(self):propertyAccessConnector())),aName));
end
)
,"encoding","codeToGetGlobal: aName\r\n\t\" Private - Return the native code to get global at aName. \"\r\n\r\n\t^#smalltalk ,self propertyAccessConnector ,aName ","(\r\nfunction(self,aName)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk\"),(self):propertyAccessConnector())),aName));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"nativeUndefined",0
,(
function(self)
return ((self):implementedBySubclass_("nativeUndefined"));
end
)
,"encoding","nativeUndefined\r\n\t\" Private - Return the code for undefined. \"\r\n\r\n\t^self implementedBySubclass: #nativeUndefined ","(\r\nfunction(self)\r\nreturn ((self):implementedBySubclass_(\"nativeUndefined\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"nativeNameOfMetaClass:",0
,(
function(self,aClass)
return ((self):implementedBySubclass_("nativeNameOfMetaClass:"));
end
)
,"encoding","nativeNameOfMetaClass: aClass\r\n\t\" Private - Return the native name for metaclass aClass. \"\r\n\r\n\t^self implementedBySubclass: #nativeNameOfMetaClass: ","(\r\nfunction(self,aClass)\r\nreturn ((self):implementedBySubclass_(\"nativeNameOfMetaClass:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"nativeNameOfClass:",0
,(
function(self,aClass)
if ((aClass):isMetaclass())==true then return ((self):nativeNameOfMetaClass_(aClass)); end;
return ((aClass):name());
end
)
,"encoding","nativeNameOfClass: aClass\r\n\t\" Private - Return the native name for aClass. \"\r\n\r\n\taClass isMetaclass ifTrue: [\r\n\t\t^self nativeNameOfMetaClass: aClass\r\n\t].\r\n\t^aClass name ","(\r\nfunction(self,aClass)\r\nif ((aClass):isMetaclass())==true then return ((self):nativeNameOfMetaClass_(aClass)); end;\r\nreturn ((aClass):name());\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"smalltalkNameFor:",0
,(
function(self,aClass)
if (smalltalk:isNil_((aClass)))==true then return ((self):nativeUndefined()); end;
return ((self):codeToGetGlobal_((self):nativeNameOfClass_(aClass)));
end
)
,"export","smalltalkNameFor: aClass\r\n\t\" Private - Return the global name of aClass (can be nil). \"\r\n\r\n\taClass isNil ifTrue: [ ^self nativeUndefined ].\r\n\t^self codeToGetGlobal: (self nativeNameOfClass: aClass) ","(\r\nfunction(self,aClass)\r\nif (smalltalk:isNil_((aClass)))==true then return ((self):nativeUndefined()); end;\r\nreturn ((self):codeToGetGlobal_((self):nativeNameOfClass_(aClass)));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"compiler",0
,(
function(self)
return (self["@compiler"]);
end
)
,"accessing","compiler\r\n\t\" Return the compiler of the receiver. \"\r\n\r\n\t^compiler","(\r\nfunction(self)\r\nreturn (self[\"@compiler\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"compiler:",0
,(
function(self,aCompiler)
(function()
	local _s8_value=(aCompiler)
	self["@compiler"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","compiler: aCompiler\r\n\t\" Set the compiler of the receiver. \"\r\n\r\n\tcompiler := aCompiler","(\r\nfunction(self,aCompiler)\r\n(function()\r\n\tlocal _s8_value=(aCompiler)\r\n\tself[\"@compiler\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"compilerEvent:",0
,(
function(self,selector)
return ((self["@compiler"]):triggerEvent_(selector));
end
)
,"events","compilerEvent: selector\r\n\t\" Return the result of triggering the compiler's event. \"\r\n\r\n\t^compiler triggerEvent: selector","(\r\nfunction(self,selector)\r\nreturn ((self[\"@compiler\"]):triggerEvent_(selector));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"compilerEvent:ifNotHandled:",0
,(
function(self,selector,aBlock)
return ((self["@compiler"]):triggerEvent_ifNotHandled_(selector,aBlock));
end
)
,"events","compilerEvent: selector ifNotHandled: aBlock\r\n\t\" Return the result of triggering the compiler's event. \"\r\n\r\n\t^compiler triggerEvent: selector ifNotHandled: aBlock","(\r\nfunction(self,selector,aBlock)\r\nreturn ((self[\"@compiler\"]):triggerEvent_ifNotHandled_(selector,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"compilerEvent:with:",0
,(
function(self,selector,anObject)
return ((self["@compiler"]):triggerEvent_with_(selector,anObject));
end
)
,"events","compilerEvent: selector with: anObject\r\n\t\" Return the result of triggering the compiler's event with anObject. \"\r\n\r\n\t^compiler\r\n\t\ttriggerEvent: selector\r\n\t\twith: anObject","(\r\nfunction(self,selector,anObject)\r\nreturn ((self[\"@compiler\"]):triggerEvent_with_(selector,anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"compilerEvent:with:ifNotHandled:",0
,(
function(self,selector,anObject,aBlock)
return ((self["@compiler"]):triggerEvent_with_ifNotHandled_(selector,anObject,aBlock));
end
)
,"events","compilerEvent: selector with: anObject ifNotHandled: aBlock\r\n\t\" Return the result of triggering the compiler's event with anObject. \"\r\n\r\n\t^compiler\r\n\t\ttriggerEvent: selector\r\n\t\twith: anObject\r\n\t\tifNotHandled: aBlock","(\r\nfunction(self,selector,anObject,aBlock)\r\nreturn ((self[\"@compiler\"]):triggerEvent_with_ifNotHandled_(selector,anObject,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"compilerEvent:withArguments:",0
,(
function(self,selector,array)
return ((self["@compiler"]):triggerEvent_withArguments_(selector,array));
end
)
,"events","compilerEvent: selector withArguments: array\r\n\t\" Return the result of triggering the compiler's event with the arguments. \"\r\n\r\n\t^compiler\r\n\t\ttriggerEvent: selector\r\n\t\twithArguments: array","(\r\nfunction(self,selector,array)\r\nreturn ((self[\"@compiler\"]):triggerEvent_withArguments_(selector,array));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"compilerEvent:withArguments:ifNotHandled:",0
,(
function(self,selector,array,aBlock)
return ((self["@compiler"]):triggerEvent_withArguments_ifNotHandled_(selector,array,aBlock));
end
)
,"events","compilerEvent: selector withArguments: array ifNotHandled: aBlock\r\n\t\" Return the result of triggering the compiler's event with the arguments. \"\r\n\r\n\t^compiler\r\n\t\ttriggerEvent: selector\r\n\t\twithArguments: array\r\n\t\tifNotHandled: aBlock","(\r\nfunction(self,selector,array,aBlock)\r\nreturn ((self[\"@compiler\"]):triggerEvent_withArguments_ifNotHandled_(selector,array,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"currentClass",0
,(
function(self)
return ((self["@compiler"]):currentClass());
end
)
,"accessing","currentClass\r\n\t\" Return the current class of the receiver. \"\r\n\r\n\t^compiler currentClass","(\r\nfunction(self)\r\nreturn ((self[\"@compiler\"]):currentClass());\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"ignore:",0
,(
function(self,aNode)
return (self);
end
)
,"visiting","ignore: aNode","(\r\nfunction(self,aNode)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"asSelector:",0
,(
function(self,aSelector)
return ((aSelector):asSelector());
end
)
,"converting","asSelector: aSelector\r\n\t\" Return the native representation of aSelector. \"\r\n\r\n\t^aSelector asSelector","(\r\nfunction(self,aSelector)\r\nreturn ((aSelector):asSelector());\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"knownVariables",0
,(
function(self)
return ((self["@compiler"]):knownVariables());
end
)
,"variables","knownVariables\r\n\t\" Return the knownVariables of the receiver. \"\r\n\r\n\t^compiler knownVariables","(\r\nfunction(self)\r\nreturn ((self[\"@compiler\"]):knownVariables());\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"localName:",0
,(
function(self,aName)
if (((self):pseudoVariables()):includes_(aName))==true then return (aName); end;
return ((self):asSelector_(aName));
end
)
,"private","localName: aName\r\n\t\" Private - Return a valid local name for aName. \"\r\n\r\n\t(self pseudoVariables includes: aName) ifTrue: [ ^aName ].\r\n\t^self asSelector: aName","(\r\nfunction(self,aName)\r\nif (((self):pseudoVariables()):includes_(aName))==true then return (aName); end;\r\nreturn ((self):asSelector_(aName));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"alienName:",0
,(
function(self,aName)
return (aName);
end
)
,"private","alienName: aName\r\n\t\" Private - Return a valid native/alien name for aName. \"\r\n\r\n\t^aName","(\r\nfunction(self,aName)\r\nreturn (aName);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"nativeLanguage",0
,(
function(self)
return (nil);
end
)
,"accessing","nativeLanguage\r\n\t\" Return the nativeLanguage of the receiver.\r\n\tThe default action return nil (the default native language).\r\n\t\"\r\n\r\n\t^nil","(\r\nfunction(self)\r\nreturn (nil);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"emmitedCode",0
,(
function(self)
return ((self):implementedBySubclass_("emmitedCode"));
end
)
,"results","emmitedCode\r\n\t\" Return the emmited code during compilation (or nil). \"\r\n\r\n\t^self implementedBySubclass: #emmitedCode","(\r\nfunction(self)\r\nreturn ((self):implementedBySubclass_(\"emmitedCode\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"endCompiling:",0
,(
function(self,aMethodNode)
return (self);
end
)
,"private","endCompiling: aMethodNode\r\n\t\" Private - Finish emmiting code for aMethodNode. \"","(\r\nfunction(self,aMethodNode)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"startCompiling:",0
,(
function(self,aNode)
return (self);
end
)
,"private","startCompiling: aNode\r\n\t\" Private - Set the receiver to start emmiting code for aNode. \"","(\r\nfunction(self,aNode)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"prepare:",0
,(
function(self,aNode)
if ((aNode):isParseFailure())==true then return (nil); end;
(aNode):do_((function(each,parent)
return ((each):prepareIn_for_(parent,self))
end));
return (self);
end
)
,"prepare","prepare: aNode\r\n\t\" Private - Prepare aNode for traversal. \"\r\n\r\n\taNode isParseFailure ifTrue: [ ^nil ].\r\n\taNode do: [:each :parent|\r\n\t\teach prepareIn: parent for: self\r\n\t]","(\r\nfunction(self,aNode)\r\nif ((aNode):isParseFailure())==true then return (nil); end;\r\n(aNode):do_((function(each,parent)\r\nreturn ((each):prepareIn_for_(parent,self))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"pseudoVariables",0
,(
function(self)
return ((self["@compiler"]):pseudoVariables());
end
)
,"variables","pseudoVariables\r\n\t\" Return the pseudoVariables of the receiver. \"\r\n\r\n\t^compiler pseudoVariables","(\r\nfunction(self)\r\nreturn ((self[\"@compiler\"]):pseudoVariables());\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"tempVariables",0
,(
function(self)
return ((self["@compiler"]):tempVariables());
end
)
,"variables","tempVariables\r\n\t\" Return the tempVariables of the receiver. \"\r\n\r\n\t^compiler tempVariables","(\r\nfunction(self)\r\nreturn ((self[\"@compiler\"]):tempVariables());\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"unknownVariables",0
,(
function(self)
return ((self["@compiler"]):unknownVariables());
end
)
,"variables","unknownVariables\r\n\t\" Return the unknownVariables of the receiver. \"\r\n\r\n\t^compiler unknownVariables","(\r\nfunction(self)\r\nreturn ((self[\"@compiler\"]):unknownVariables());\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"visit:",0
,(
function(self,aNode)
return ((aNode):accept_(self));
end
)
,"visiting","visit: aNode\r\n\t^aNode accept: self","(\r\nfunction(self,aNode)\r\nreturn ((aNode):accept_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"visitAssignmentNode:",0
,(
function(self,aNode)
(self):visitNode_(aNode);
return (self);
end
)
,"visiting","visitAssignmentNode: aNode\r\n\tself visitNode: aNode","(\r\nfunction(self,aNode)\r\n(self):visitNode_(aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"visitBlockNode:",0
,(
function(self,aNode)
(self):visitNode_(aNode);
return (self);
end
)
,"visiting","visitBlockNode: aNode\r\n\tself visitNode: aNode","(\r\nfunction(self,aNode)\r\n(self):visitNode_(aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"visitBlockSequenceNode:",0
,(
function(self,aNode)
(self):visitSequenceNode_(aNode);
return (self);
end
)
,"visiting","visitBlockSequenceNode: aNode\r\n\tself visitSequenceNode: aNode","(\r\nfunction(self,aNode)\r\n(self):visitSequenceNode_(aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"visitCascadeNode:",0
,(
function(self,aNode)
(self):visitNode_(aNode);
return (self);
end
)
,"visiting","visitCascadeNode: aNode\r\n\tself visitNode: aNode","(\r\nfunction(self,aNode)\r\n(self):visitNode_(aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"visitMacroAssignment:to:",0
,(
function(self,aVariableNode,anExpressionNode)
return (false);
end
)
,"visiting","visitMacroAssignment: aVariableNode to: anExpressionNode\r\n\t\" Return true if the receiver generated code to a macro assignment to aVariableNode. \"\r\n\r\n\t^false","(\r\nfunction(self,aVariableNode,anExpressionNode)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"visitMethodNode:",0
,(
function(self,aNode)
(self):visitNode_(aNode);
return (self);
end
)
,"visiting","visitMethodNode: aNode\r\n\t\" Visit a method node. \"\r\n\r\n\tself visitNode: aNode","(\r\nfunction(self,aNode)\r\n(self):visitNode_(aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"visitNode:",0
,(
function(self,aNode)
(self):ignore_(aNode);
return (self);
end
)
,"visiting","visitNode: aNode\r\n\tself ignore: aNode","(\r\nfunction(self,aNode)\r\n(self):ignore_(aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"visitReturnNode:",0
,(
function(self,aNode)
(self):visitNode_(aNode);
return (self);
end
)
,"visiting","visitReturnNode: aNode\r\n\tself visitNode: aNode","(\r\nfunction(self,aNode)\r\n(self):visitNode_(aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"visitSendNode:",0
,(
function(self,aNode)
(self):visitNode_(aNode);
return (self);
end
)
,"visiting","visitSendNode: aNode\r\n\tself visitNode: aNode","(\r\nfunction(self,aNode)\r\n(self):visitNode_(aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"visitSequenceNode:",0
,(
function(self,aNode)
(self):visitNode_(aNode);
return (self);
end
)
,"visiting","visitSequenceNode: aNode\r\n\tself visitNode: aNode","(\r\nfunction(self,aNode)\r\n(self):visitNode_(aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"visitValueNode:",0
,(
function(self,aNode)
(self):visitNode_(aNode);
return (self);
end
)
,"visiting","visitValueNode: aNode\r\n\tself visitNode: aNode","(\r\nfunction(self,aNode)\r\n(self):visitNode_(aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"visitVariableNode:",0
,(
function(self,aNode)
(self):ignore_(aNode);
return (self);
end
)
,"visiting","visitVariableNode: aNode\r\n\tself ignore: aNode","(\r\nfunction(self,aNode)\r\n(self):ignore_(aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"translate:by:",0
,(
function(self,aNode,delta)
if (smalltalk:isObject_equalTo_((delta),0))==true then return (self); end;
(self):compilerEvent_withArguments_("move:by:",(smalltalk.Array):with_with_(aNode,delta));
return (self);
end
)
,"private","translate: aNode by: delta\r\n\t\" Private - Translate the contents of aNode by delta characters in source code. \"\r\n\r\n\tdelta = 0 ifTrue: [ ^self ].\r\n\tself\tcompilerEvent: #move:by:\r\n\t\twithArguments: (Array with: aNode with: delta).","(\r\nfunction(self,aNode,delta)\r\nif (smalltalk:isObject_equalTo_((delta),0))==true then return (self); end;\r\n(self):compilerEvent_withArguments_(\"move:by:\",(smalltalk.Array):with_with_(aNode,delta));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"loadRequirementsOf:",0
,(
function(self,aClass)
return ((self):implementedBySubclass_("loadRequirementsOf:"));
end
)
,"export","loadRequirementsOf: aClass\r\n\t\" Private - Return the requirements to load aClass. \"\r\n\r\n\t^self implementedBySubclass: #loadRequirementsOf: ","(\r\nfunction(self,aClass)\r\nreturn ((self):implementedBySubclass_(\"loadRequirementsOf:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"exportDefinitionOf:on:",0
,(
function(self,aClass,aStream)
return ((self):implementedBySubclass_("exportDefinitionOf:on:"));
end
)
,"export","exportDefinitionOf: aClass on: aStream\r\n\t\" Export definition of aClass onto aStream. \"\r\n\r\n\t^self implementedBySubclass: #exportDefinitionOf:on: ","(\r\nfunction(self,aClass,aStream)\r\nreturn ((self):implementedBySubclass_(\"exportDefinitionOf:on:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"exportMetaDefinitionOf:on:",0
,(
function(self,aClass,aStream)
return ((self):implementedBySubclass_("exportMetaDefinitionOf:on:"));
end
)
,"export","exportMetaDefinitionOf: aClass on: aStream\r\n\t\" Export class side definition of aClass onto aStream. \"\r\n\r\n\t^self implementedBySubclass: #exportMetaDefinitionOf:on: ","(\r\nfunction(self,aClass,aStream)\r\nreturn ((self):implementedBySubclass_(\"exportMetaDefinitionOf:on:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"exportCommentOf:on:",0
,(
function(self,aClass,aStream)
return ((self):implementedBySubclass_("exportCommentOf:on:"));
end
)
,"export","exportCommentOf: aClass on: aStream\r\n\t\" Export the comment of aClass onto aStream. \"\r\n\r\n\t^self implementedBySubclass: #exportCommentOf:on: ","(\r\nfunction(self,aClass,aStream)\r\nreturn ((self):implementedBySubclass_(\"exportCommentOf:on:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"export:method:on:",0
,(
function(self,aClass,aMethod,aStream)
return ((self):implementedBySubclass_("export:method:on:"));
end
)
,"export","export: aClass method: aMethod on: aStream\r\n\t\" Export a method definition of aClass onto aStream. \"\r\n\r\n\t^self implementedBySubclass: #export:method:on: ","(\r\nfunction(self,aClass,aMethod,aStream)\r\nreturn ((self):implementedBySubclass_(\"export:method:on:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"arrayLiteralStart",0
,(
function(self)
return ((self):implementedBySubclass_("arrayLiteralStart"));
end
)
,"literals","arrayLiteralStart\r\n\t\" Private - Return the code string to start exporting an array literal. \"\r\n\r\n\t^self implementedBySubclass: #arrayLiteralStart","(\r\nfunction(self)\r\nreturn ((self):implementedBySubclass_(\"arrayLiteralStart\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"arrayLiteralEnd",0
,(
function(self)
return ((self):implementedBySubclass_("arrayLiteralEnd"));
end
)
,"literals","arrayLiteralEnd\r\n\t\" Private - Return the code string to end exporting an array literal. \"\r\n\r\n\t^self implementedBySubclass: #arrayLiteralEnd","(\r\nfunction(self)\r\nreturn ((self):implementedBySubclass_(\"arrayLiteralEnd\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"escaped:",0
,(
function(self,string)
return (smalltalk:object_comma_((smalltalk:object_comma_(("\""),string)),"\""));
end
)
,"literals","escaped: string\r\n\t\" Private - Return the code string to export string literal. \"\r\n\r\n\t^$\" ,string ,$\"","(\r\nfunction(self,string)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),string)),\"\\\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"argumentsSeparatorOp",0
,(
function(self)
return (",");
end
)
,"constants","argumentsSeparatorOp\r\n\t\" Private - Return the OP for separating arguments. \"\r\n\r\n\t^$, ","(\r\nfunction(self)\r\nreturn (\",\");\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"export:literals:on:",0
,(
function(self,tags,anArray,aStream)
if (smalltalk:notNil_((tags)))==true then (aStream):nextPutAll_((tags):first()); end;
(anArray):do_separatedBy_((function(each)
return ((aStream):nextPutAll_(smalltalk:if_true_false_(((each):isString()),(function()
return (smalltalk:object_comma_((smalltalk:object_comma_(("\""),each)),"\""))
end),(function()
return (smalltalk:printString_((each)))
end))))
end),(function()
return ((aStream):nextPutAll_((self):argumentsSeparatorOp()))
end));
if (smalltalk:notNil_((tags)))==true then (aStream):nextPutAll_((tags):last()); end;
return (self);
end
)
,"literals","export: tags literals: anArray on: aStream\r\n\t\" Private - Export the native code for elements in anArray between tags. \"\r\n\r\n\ttags notNil ifTrue: [ aStream nextPutAll: tags first ].\r\n\tanArray\r\n\t    do: [:each | aStream nextPutAll: (\r\n\t\teach isString ifTrue: [ $\" ,each ,$\" ] ifFalse: [ each printString ]\r\n\t    ) ] separatedBy: [ aStream nextPutAll: self argumentsSeparatorOp ].\r\n\ttags notNil ifTrue: [ aStream nextPutAll: tags last ]","(\r\nfunction(self,tags,anArray,aStream)\r\nif (smalltalk:notNil_((tags)))==true then (aStream):nextPutAll_((tags):first()); end;\r\n(anArray):do_separatedBy_((function(each)\r\nreturn ((aStream):nextPutAll_(smalltalk:if_true_false_(((each):isString()),(function()\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),each)),\"\\\"\"))\r\nend),(function()\r\nreturn (smalltalk:printString_((each)))\r\nend))))\r\nend),(function()\r\nreturn ((aStream):nextPutAll_((self):argumentsSeparatorOp()))\r\nend));\r\nif (smalltalk:notNil_((tags)))==true then (aStream):nextPutAll_((tags):last()); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"exportArrayLiteral:on:newLine:",0
,(
function(self,anArray,aStream,newLine)
(self):export_literals_on_((smalltalk.Array):with_with_((self):arrayLiteralStart(),(self):arrayLiteralEnd()),anArray,aStream);
if (newLine)==true then (aStream):cr(); end;
return (self);
end
)
,"literals","exportArrayLiteral: anArray on: aStream newLine: newLine\r\n\t\" Private - Export the native code for elements in anArray. \"\r\n\r\n\tself\texport: (Array\r\n\t\t\twith: self arrayLiteralStart\r\n\t\t\twith: self arrayLiteralEnd)\r\n\t\tliterals: anArray on: aStream.\r\n\tnewLine ifTrue: [ aStream cr ]","(\r\nfunction(self,anArray,aStream,newLine)\r\n(self):export_literals_on_((smalltalk.Array):with_with_((self):arrayLiteralStart(),(self):arrayLiteralEnd()),anArray,aStream);\r\nif (newLine)==true then (aStream):cr(); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"sourceToTry:",0
,(
function(self,sourceCode)
return (sourceCode);
end
)
,"directives","sourceToTry: sourceCode\r\n\t\" Return the code to emmit to try execution of sourceCode. \"\r\n\r\n\t^sourceCode ","(\r\nfunction(self,sourceCode)\r\nreturn (sourceCode);\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"sourceToDirectCall:with:",0
,(
function(self,nativeSelector,arg)
return ((self):implementedBySubclass_("sourceToDirectCall:with:"));
end
)
,"directives","sourceToDirectCall: nativeSelector with: arg\r\n\t\" Return the code to emmit to direct native call to selector with argument. \"\r\n\r\n\t^self implementedBySubclass: #sourceToDirectCall:with: ","(\r\nfunction(self,nativeSelector,arg)\r\nreturn ((self):implementedBySubclass_(\"sourceToDirectCall:with:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.S8Encoder,"export:",0
,(
function(self,spec)
local exporter=nil
(function()
	local _s8_value=((smalltalk.Exporter):new())
	exporter=_s8_value
	return _s8_value
end)();
(exporter):encoder_(self);
if (smalltalk:isObject_equalTo_((spec),"all"))==true then return ((exporter):exportAll()); end;
return ((exporter):export_(spec));
end
)
,"Tools-export","export: spec\r\n\t\" Return the native code result of encoding spec. \"\r\n\r\n\t| exporter |\r\n\texporter := Exporter new.\r\n\texporter encoder: self.\r\n\tspec = #all ifTrue: [ ^exporter exportAll ].\r\n\"OBSOLETE-\r\n\tspec isArray ifTrue: [ ^exporter exportAll: spec ].\r\n\t^exporter exportAll: (Array with: spec)\r\n\"\t^exporter export: spec","(\r\nfunction(self,spec)\r\nlocal exporter=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Exporter):new())\r\n\texporter=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(exporter):encoder_(self);\r\nif (smalltalk:isObject_equalTo_((spec),\"all\"))==true then return ((exporter):exportAll()); end;\r\nreturn ((exporter):export_(spec));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder["$klass"],"initializeInlines",0
,(
function(self)
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	self["@inlines"]=_s8_value
	return _s8_value
end)();
((((self)["$klass"]):selectors()):select_((function(msg)
return (smalltalk:boolean_and_(((msg):startsWith_("initialize")),(function()
return ((msg):endsWith_("Inlines:"))
end)))
end))):do_((function(each)
return ((self):perform_with_(each,self["@inlines"]))
end));
return (self["@inlines"]);
end
)
,"inlines","initializeInlines\r\n\t\" Private - Initialize the pool of inlines known by the receiver.\r\n\tNote that initialize defaults from methods implementing #initialize*Inlines: in the receiver\r\n\t\"\r\n\r\n\tinlines := PoolDictionary new.\r\n\t(self class selectors\r\n\t\tselect: [:msg| (msg startsWith: #initialize) and: [ msg endsWith: #Inlines: ] ])\r\n\t\tdo: [:each| self perform: each with: inlines ].\r\n\t^inlines ","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tself[\"@inlines\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((((self)[\"$klass\"]):selectors()):select_((function(msg)\r\nreturn (smalltalk:boolean_and_(((msg):startsWith_(\"initialize\")),(function()\r\nreturn ((msg):endsWith_(\"Inlines:\"))\r\nend)))\r\nend))):do_((function(each)\r\nreturn ((self):perform_with_(each,self[\"@inlines\"]))\r\nend));\r\nreturn (self[\"@inlines\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder["$klass"],"inlines",0
,(
function(self)
if (smalltalk:isNil_((self["@inlines"])))==true then (self):initializeInlines(); end;
return (self["@inlines"]);
end
)
,"inlines","inlines\r\n\t\" Private - Return the pool of inlines. \"\r\n\r\n\tinlines isNil ifTrue: [ self initializeInlines ].\r\n\t^inlines","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@inlines\"])))==true then (self):initializeInlines(); end;\r\nreturn (self[\"@inlines\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder["$klass"],"register:into:",0
,(
function(self,literals,pool)
(literals):do_((function(tuple)
local tokens=nil
local value=nil
if not (((tuple):isArray()))==true then (self):error_(smalltalk:object_comma_(("Must be array "),tuple)); end;if not ((smalltalk:isObject_equalTo_(((tuple):size()),2)))==true then (self):error_("Invalid tuple size (must be 2)"); end;(function()
	local _s8_value=((tuple):first())
	tokens=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((tuple):last())
	value=_s8_value
	return _s8_value
end)();if ((tokens):isString())==true then (function()
	local _s8_value=((smalltalk.Array):with_(tokens))
	tokens=_s8_value
	return _s8_value
end)(); end;return ((tokens):do_((function(token)
if not (((token):isString()))==true then (self):error_(smalltalk:object_comma_(("Must be string "),(token):asLiteral())); end;return (smalltalk:if_true_false_((smalltalk:boolean_or_(((token):isEmpty()),(function()
return (((token):first()):isLowercase())
end))),(function()
return ((pool):at_put_(token,value))
end),(function()
local options=nil
(function()
	local _s8_value=((pool):at_ifAbsentPut_(token,(function()
return ((smalltalk.PoolDictionary):new())
end)))
	options=_s8_value
	return _s8_value
end)();return ((value):do_((function(pair)
if not (((pair):isArray()))==true then (self):error_(smalltalk:object_comma_(("Must be array "),tuple)); end;if not ((smalltalk:isObject_equalTo_(((pair):size()),2)))==true then (self):error_(smalltalk:object_comma_(("Invalid pair size (must be 2) - "),(pair):asLiteral())); end;(function()
	local _s8_value=((pair):last())
	value=_s8_value
	return _s8_value
end)();return ((smalltalk:if_true_false_((((pair):first()):isString()),(function()
return ((smalltalk.Array):with_((pair):first()))
end),(function()
return ((pair):first())
end))):do_((function(selector)
if not (((selector):isString()))==true then (self):error_(smalltalk:object_comma_(("Must be string "),(selector):asLiteral())); end;return ((options):at_put_(selector,value))
end)))
end)))
end)))
end)))
end));
return (self);
end
)
,"inlines","register: literals into: pool\r\n\t\" Private - Register literals array onto pool dictionary.\r\n\tliterals must be a collection of arrays like:\r\n\t\t#(token inlines)\r\n\t\t#(ClassName #(\r\n\t\t\t#(selector inlines)\r\n\t\t))\r\n\tinlines can be a string or array of strings to be used to encode inlines in source\r\n\ttoken must be lowercase and ClassName must be uppercase names\r\n\ttoken & className can be arrays for multiple registrations\r\n\t\"\r\n\r\n\tliterals do: [:tuple| | tokens value |\r\n\t\ttuple isArray ifFalse: [ self error: 'Must be array ' ,tuple ].\r\n\t\ttuple size = 2 ifFalse: [ self error: 'Invalid tuple size (must be 2)' ].\r\n\t\ttokens := tuple first. value := tuple last.\r\n\t\ttokens isString ifTrue: [ tokens := Array with: tokens ].\r\n\t\ttokens do: [:token|\r\n\t\t\ttoken isString ifFalse: [ self error: 'Must be string ' ,token asLiteral ].\r\n\t\t\t(token isEmpty or: [ token first isLowercase ]) ifTrue: [ \"#(token inlines) \"\r\n\t\t\t\tpool at: token put: value\r\n\t\t\t] ifFalse: [ | options | \"#(ClassName pairs)\"\r\n\t\t\t\toptions := pool at: token ifAbsentPut: [PoolDictionary new].\r\n\t\t\t\tvalue do: [:pair| \"#(selector inlines)\"\r\n\t\t\t\t\tpair isArray ifFalse: [ self error: 'Must be array ' ,tuple ].\r\n\t\t\t\t\tpair size = 2 ifFalse: [ self error: 'Invalid pair size (must be 2) - ' ,pair asLiteral ].\r\n\t\t\t\t\tvalue := pair last.\r\n\t\t\t\t\t(pair first isString ifTrue: [Array with: pair first] ifFalse: [pair first]) do: [:selector|\r\n\t\t\t\t\t\tselector isString ifFalse: [ self error: 'Must be string ' ,selector asLiteral ].\r\n\t\t\t\t\t\toptions at: selector put: value\r\n\t\t\t\t\t]\r\n\t\t\t\t]\r\n\t\t\t]\r\n\t\t]\r\n\t] ","(\r\nfunction(self,literals,pool)\r\n(literals):do_((function(tuple)\r\nlocal tokens=nil\r\nlocal value=nil\r\nif not (((tuple):isArray()))==true then (self):error_(smalltalk:object_comma_((\"Must be array \"),tuple)); end;if not ((smalltalk:isObject_equalTo_(((tuple):size()),2)))==true then (self):error_(\"Invalid tuple size (must be 2)\"); end;(function()\r\n\tlocal _s8_value=((tuple):first())\r\n\ttokens=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((tuple):last())\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();if ((tokens):isString())==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):with_(tokens))\r\n\ttokens=_s8_value\r\n\treturn _s8_value\r\nend)(); end;return ((tokens):do_((function(token)\r\nif not (((token):isString()))==true then (self):error_(smalltalk:object_comma_((\"Must be string \"),(token):asLiteral())); end;return (smalltalk:if_true_false_((smalltalk:boolean_or_(((token):isEmpty()),(function()\r\nreturn (((token):first()):isLowercase())\r\nend))),(function()\r\nreturn ((pool):at_put_(token,value))\r\nend),(function()\r\nlocal options=nil\r\n(function()\r\n\tlocal _s8_value=((pool):at_ifAbsentPut_(token,(function()\r\nreturn ((smalltalk.PoolDictionary):new())\r\nend)))\r\n\toptions=_s8_value\r\n\treturn _s8_value\r\nend)();return ((value):do_((function(pair)\r\nif not (((pair):isArray()))==true then (self):error_(smalltalk:object_comma_((\"Must be array \"),tuple)); end;if not ((smalltalk:isObject_equalTo_(((pair):size()),2)))==true then (self):error_(smalltalk:object_comma_((\"Invalid pair size (must be 2) - \"),(pair):asLiteral())); end;(function()\r\n\tlocal _s8_value=((pair):last())\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();return ((smalltalk:if_true_false_((((pair):first()):isString()),(function()\r\nreturn ((smalltalk.Array):with_((pair):first()))\r\nend),(function()\r\nreturn ((pair):first())\r\nend))):do_((function(selector)\r\nif not (((selector):isString()))==true then (self):error_(smalltalk:object_comma_((\"Must be string \"),(selector):asLiteral())); end;return ((options):at_put_(selector,value))\r\nend)))\r\nend)))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder["$klass"],"inlinesFor:compiler:",0
,(
function(self,token,aCompiler)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
if (smalltalk:notNil_((token)))==true then (function()
	local _s8_value=(((self):inlines()):at_ifAbsent_(token,(function()
return (nil)
end)))
	result=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:notNil_((result))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (((self):inlines()):_at((smalltalk.Array):with_with_(((aCompiler):currentClass()):name(),(aCompiler):selector())))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"inlines","inlinesFor: token compiler: aCompiler\r\n\t\" Private - Return the inlines stream with native source chunks to inject while generating code. \"\r\n\r\n\t| result |\r\n\ttoken notNil ifTrue: [\r\n\t\tresult := self inlines at: token ifAbsent: [].\r\n\t\tresult notNil ifTrue: [ ^result ].\r\n\t].\r\n\t^self inlines @ (Array\r\n\t\twith: aCompiler currentClass name\r\n\t\twith: aCompiler selector) ","(\r\nfunction(self,token,aCompiler)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\nif (smalltalk:notNil_((token)))==true then (function()\r\n\tlocal _s8_value=(((self):inlines()):at_ifAbsent_(token,(function()\r\nreturn (nil)\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:notNil_((result))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (((self):inlines()):_at((smalltalk.Array):with_with_(((aCompiler):currentClass()):name(),(aCompiler):selector())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder["$klass"],"unknownVariable:in:",0
,(
function(self,aNode,anEncoder)
(self):note_(smalltalk:object_comma_(("Unknown variable "),smalltalk:asString_(((aNode):value()))));
return ((self):error_(smalltalk:object_comma_(("Unknown variable "),(aNode):value())));
end
)
,"variables","unknownVariable: aNode in: anEncoder\r\n\t\" Private - anEncoder has found an unknown name reference.\r\n\tThe default action will thrown an error (stop compilation),\r\n\t this method can be refined/changed to silently ignore the\r\n\t unknown to let the compiler produce code to refer code\r\n\t in outer native contexts.\r\n\tSee implementors of #visitVariableNode:\r\n\t\"\r\n\r\nself note: 'Unknown variable ' ,aNode value asString.\r\n\t^self error: 'Unknown variable ',aNode value","(\r\nfunction(self,aNode,anEncoder)\r\n(self):note_(smalltalk:object_comma_((\"Unknown variable \"),smalltalk:asString_(((aNode):value()))));\r\nreturn ((self):error_(smalltalk:object_comma_((\"Unknown variable \"),(aNode):value())));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder["$klass"],"bind:in:",0
,(
function(self,aName,anEncoder)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(aName):detect_ifNone_((function(c)
return ((not smalltalk:isObject_equalTo_((c),"_")))
end),(function()
(smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(aName,(function()
return (smalltalk:basic_at_put_(((smalltalk.Smalltalk):global()),aName,nil))
end));((anEncoder):knownVariables()):add_(aName);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"variables","bind: aName in: anEncoder\r\n\t\" Private - Return true if aName has been bound to anEncoder.\r\n\tNote that the process of binding must register aName onto knownVariables of encoder. \"\r\n\r\n\t\"we use underscores as native cookies\"\r\n\taName detect: [:c| c ~= #_ ] ifNone: [ \"all underscores\"\r\n\t\tSmalltalk nativeObjectAt: aName ifAbsent: [\r\n\t\t\tSmalltalk global basicAt: aName put: nil\r\n\t\t].\r\n\t\tanEncoder knownVariables add: aName.\r\n\t\t^true\r\n\t].\r\n\t^false","(\r\nfunction(self,aName,anEncoder)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(aName):detect_ifNone_((function(c)\r\nreturn ((not smalltalk:isObject_equalTo_((c),\"_\")))\r\nend),(function()\r\n(smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(aName,(function()\r\nreturn (smalltalk:basic_at_put_(((smalltalk.Smalltalk):global()),aName,nil))\r\nend));((anEncoder):knownVariables()):add_(aName);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"addOptimizations:",0
,(
function(self,array)
(array):do_((function(opt)
return (((self):optimizationMap()):addAll_((self):optimizationLiteralsFor_(opt)))
end));
return (self);
end
)
,"optimization","addOptimizations: array\r\n\t\" Private - Add an array of optimizations to the receiver. \"\r\n\r\n\tarray do: [:opt|\r\n\t\tself optimizationMap addAll:\r\n\t\t\t(self optimizationLiteralsFor: opt)\r\n\t]","(\r\nfunction(self,array)\r\n(array):do_((function(opt)\r\nreturn (((self):optimizationMap()):addAll_((self):optimizationLiteralsFor_(opt)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"allBlockNoArguments:",0
,(
function(self,aNode)
return (smalltalk:boolean_and_(((self):receiverIsBlockNoArguments_(aNode)),(function()
return ((self):hasBlockNoArguments_(aNode))
end)));
end
)
,"optimization","allBlockNoArguments: aNode\r\n\t\" Private - Return true if receiver and arguments of aNode are blocks with no arguments. \"\r\n\r\n\t^(self receiverIsBlockNoArguments: aNode) and: [\r\n\t\tself hasBlockNoArguments: aNode\r\n\t]","(\r\nfunction(self,aNode)\r\nreturn (smalltalk:boolean_and_(((self):receiverIsBlockNoArguments_(aNode)),(function()\r\nreturn ((self):hasBlockNoArguments_(aNode))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"arg1HasNumber:",0
,(
function(self,aNode)
return ((((aNode):arguments()):at_(1)):hasNumber());
end
)
,"optimization","arg1HasNumber: aNode\r\n\t\" Private - Return true if argument of aNode is a number literal. \"\r\n\r\n\t^(aNode arguments at: 1) hasNumber","(\r\nfunction(self,aNode)\r\nreturn ((((aNode):arguments()):at_(1)):hasNumber());\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"arg2HasNumber:",0
,(
function(self,aNode)
return ((((aNode):arguments()):at_(2)):hasNumber());
end
)
,"optimization","arg2HasNumber: aNode\r\n\t\" Private - Return true if argument of aNode is a number literal. \"\r\n\r\n\t^(aNode arguments at: 2) hasNumber","(\r\nfunction(self,aNode)\r\nreturn ((((aNode):arguments()):at_(2)):hasNumber());\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"arg3HasNumber:",0
,(
function(self,aNode)
return ((((aNode):arguments()):at_(3)):hasNumber());
end
)
,"optimization","arg3HasNumber: aNode\r\n\t\" Private - Return true if argument of aNode is a number literal. \"\r\n\r\n\t^(aNode arguments at: 3) hasNumber","(\r\nfunction(self,aNode)\r\nreturn ((((aNode):arguments()):at_(3)):hasNumber());\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"argumentsHasNumber:",0
,(
function(self,aNode)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
((aNode):arguments()):do_((function(each)
return (smalltalk:if_true_false_(((each):hasNumber()),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"optimization","argumentsHasNumber: aNode\r\n\t\" Private - Return true if any argument of aNode is a number literal. \"\r\n\r\n\taNode arguments do: [:each|\r\n\t\teach hasNumber ifTrue: [ ^true ]\r\n\t].\r\n\t^false","(\r\nfunction(self,aNode)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n((aNode):arguments()):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):hasNumber()),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"argumentsHasString:",0
,(
function(self,aNode)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
((aNode):arguments()):do_((function(each)
return (smalltalk:if_true_false_(((each):hasString()),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"optimization","argumentsHasString: aNode\r\n\t\" Private - Return true if any argument of aNode is a string literal. \"\r\n\r\n\taNode arguments do: [:each|\r\n\t\teach hasString ifTrue: [ ^true ]\r\n\t].\r\n\t^false","(\r\nfunction(self,aNode)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n((aNode):arguments()):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):hasString()),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"defaultKnownOptimizations",0
,(
function(self)
return (smalltalk:newArray({}));
end
)
,"defaults","defaultKnownOptimizations\r\n\t\" Private - Return the default knownOptimizations of the receiver. \"\r\n\r\n\t^#()","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({}));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"defaultOptimizations",0
,(
function(self)
return (smalltalk:newArray({}));
end
)
,"defaults","defaultOptimizations\r\n\t\" Private - Return the default optimizations of the receiver. \"\r\n\r\n\t^#()","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({}));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"hasBlockArguments:",0
,(
function(self,aNode)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
((aNode):arguments()):do_((function(each)
return (smalltalk:if_true_false_((smalltalk:is_kindOf_((each),(smalltalk.BlockNode))),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"optimization","hasBlockArguments: aNode\r\n\t\" Private - Return true if arguments of aNode are blocks. \"\r\n\r\n\taNode arguments do: [:each|\r\n\t\t(each isKindOf: BlockNode) ifFalse: [ ^false ].\r\n\t].\r\n\t^true","(\r\nfunction(self,aNode)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n((aNode):arguments()):do_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:is_kindOf_((each),(smalltalk.BlockNode))),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"hasBlockNoArguments:",0
,(
function(self,aNode)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if not (((self):hasBlockArguments_(aNode)))==true then return (false); end;
((aNode):arguments()):do_((function(each)
return (smalltalk:if_true_false_((((each):parameters()):isEmpty()),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"optimization","hasBlockNoArguments: aNode\r\n\t\" Private - Return true if arguments of aNode are blocks with no parameters. \"\r\n\r\n\t(self hasBlockArguments: aNode) ifFalse: [ ^false ].\r\n\taNode arguments do: [:each|\r\n\t\teach parameters isEmpty ifFalse: [ ^false ].\r\n\t].\r\n\t^true","(\r\nfunction(self,aNode)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif not (((self):hasBlockArguments_(aNode)))==true then return (false); end;\r\n((aNode):arguments()):do_((function(each)\r\nreturn (smalltalk:if_true_false_((((each):parameters()):isEmpty()),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"hasBlockOneArguments:",0
,(
function(self,aNode)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if not (((self):hasBlockArguments_(aNode)))==true then return (false); end;
((aNode):arguments()):do_((function(each)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((((each):parameters()):size()),1)),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"optimization","hasBlockOneArguments: aNode\r\n\t\" Private - Return true if arguments of aNode are blocks with ONE parameter. \"\r\n\r\n\t(self hasBlockArguments: aNode) ifFalse: [ ^false ].\r\n\taNode arguments do: [:each|\r\n\t\teach parameters size = 1 ifFalse: [ ^false ].\r\n\t].\r\n\t^true","(\r\nfunction(self,aNode)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif not (((self):hasBlockArguments_(aNode)))==true then return (false); end;\r\n((aNode):arguments()):do_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((((each):parameters()):size()),1)),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"hasNumber:",0
,(
function(self,aNode)
return (smalltalk:boolean_or_(((self):receiverHasNumber_(aNode)),(function()
return ((self):argumentsHasNumber_(aNode))
end)));
end
)
,"optimization","hasNumber: aNode\r\n\t\" Private - Return true if the receiver or arguments in aNode has numeric value. \"\r\n\r\n\t^(self receiverHasNumber: aNode) or: [\r\n\t\tself argumentsHasNumber: aNode\r\n\t]","(\r\nfunction(self,aNode)\r\nreturn (smalltalk:boolean_or_(((self):receiverHasNumber_(aNode)),(function()\r\nreturn ((self):argumentsHasNumber_(aNode))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"hasString:",0
,(
function(self,aNode)
return (smalltalk:boolean_or_(((self):receiverHasString_(aNode)),(function()
return ((self):argumentsHasString_(aNode))
end)));
end
)
,"optimization","hasString: aNode\r\n\t\" Private - Return true if the receiver or arguments in aNode has string value. \"\r\n\r\n\t^(self receiverHasString: aNode) or: [\r\n\t\tself argumentsHasString: aNode\r\n\t]","(\r\nfunction(self,aNode)\r\nreturn (smalltalk:boolean_or_(((self):receiverHasString_(aNode)),(function()\r\nreturn ((self):argumentsHasString_(aNode))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"noClient:",0
,(
function(self,aNode)
return (smalltalk:isObject_equalTo_(((aNode):client()),"none"));
end
)
,"optimization","noClient: aNode\r\n\t\" Private - Return true if aNode has no client. \"\r\n\r\n\t^aNode client = #none ","(\r\nfunction(self,aNode)\r\nreturn (smalltalk:isObject_equalTo_(((aNode):client()),\"none\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"hasClient:",0
,(
function(self,aNode)
local client=nil
(function()
	local _s8_value=((aNode):client())
	client=_s8_value
	return _s8_value
end)();
return (smalltalk:boolean_and_((smalltalk:notNil_((client))),(function()
return ((not smalltalk:isObject_equalTo_((client),"none")))
end)));
end
)
,"optimization","hasClient: aNode\r\n\t\" Private - Return true if aNode has a client. \"\r\n\r\n\t| client |\r\n\tclient := aNode client.\r\n\t^client notNil and: [ client ~= #none ] ","(\r\nfunction(self,aNode)\r\nlocal client=nil\r\n(function()\r\n\tlocal _s8_value=((aNode):client())\r\n\tclient=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:boolean_and_((smalltalk:notNil_((client))),(function()\r\nreturn ((not smalltalk:isObject_equalTo_((client),\"none\")))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"initializeKnownOptimizations",0
,(
function(self)
(function()
	local _s8_value=((self):defaultKnownOptimizations())
	self["@knownOptimizations"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"initialize","initializeKnownOptimizations\r\n\t\" Private - Initialize the knownOptimizations of the receiver. \"\r\n\r\n\tknownOptimizations := self defaultKnownOptimizations","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=((self):defaultKnownOptimizations())\r\n\tself[\"@knownOptimizations\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"initializeOptimizationMap",0
,(
function(self)
(function()
	local _s8_value=((self):compilerEvent_ifNotHandled_("needsOptimizationMap",(function()
return (smalltalk:newArray({}))
end)))
	self["@optimizationMap"]=_s8_value
	return _s8_value
end)();
(self):compilerEvent_ifNotHandled_("initializeOptimizations",(function()
return ((self):addOptimizations_((self):defaultOptimizations()))
end));
(self):compilerEvent_("customizeOptimizations");
return (self);
end
)
,"initialize","initializeOptimizationMap\r\n\t\" Private - Initialize the optimization map of the receiver. \"\r\n\r\n\toptimizationMap := self\r\n\t\tcompilerEvent: #needsOptimizationMap\r\n\t\tifNotHandled: [ #() ].\r\n\tself compilerEvent: #initializeOptimizations ifNotHandled: [\r\n\t\tself addOptimizations: self defaultOptimizations\r\n\t].\r\n\tself compilerEvent: #customizeOptimizations","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=((self):compilerEvent_ifNotHandled_(\"needsOptimizationMap\",(function()\r\nreturn (smalltalk:newArray({}))\r\nend)))\r\n\tself[\"@optimizationMap\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):compilerEvent_ifNotHandled_(\"initializeOptimizations\",(function()\r\nreturn ((self):addOptimizations_((self):defaultOptimizations()))\r\nend));\r\n(self):compilerEvent_(\"customizeOptimizations\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"knownOptimizations",0
,(
function(self)
if (smalltalk:isNil_((self["@knownOptimizations"])))==true then (self):initializeKnownOptimizations(); end;
return (self["@knownOptimizations"]);
end
)
,"accessing","knownOptimizations\r\n\t\" Return the knownOptimizations of the receiver. \"\r\n\r\n\tknownOptimizations isNil ifTrue: [ self initializeKnownOptimizations ].\r\n\t^knownOptimizations","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@knownOptimizations\"])))==true then (self):initializeKnownOptimizations(); end;\r\nreturn (self[\"@knownOptimizations\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"knownOptimizations:",0
,(
function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@knownOptimizations"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","knownOptimizations: anObject\r\n\t\" Set the knownOptimizations of the receiver. \"\r\n\r\n\tknownOptimizations := anObject","(\r\nfunction(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@knownOptimizations\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"matchOptimizedCondition:with:",0
,(
function(self,condition,aNode)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if ((smalltalk:newArray({"hasNumber:", "receiverHasNumber:", "argumentsHasNumber:", "hasString:", "receiverHasString:", "argumentsHasString:", "arg1HasNumber:", "arg2HasNumber:", "arg3HasNumber:", "hasBlockArguments:", "hasBlockNoArguments:", "hasBlockOneArguments:", "allBlockNoArguments:", "receiverIsBlockNoArguments:", "receiverIsBlock:", "noClient:", "hasClient:"})):includes_(condition))==true then return ((self):perform_withArguments_(condition,(smalltalk.Array):with_(aNode))); end;
if ((condition):isArray())==true then (condition):detect_ifNone_((function(one)
return (smalltalk:isObject_equalTo_((false),(self):matchOptimizedCondition_with_(one,aNode)))
end),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)(); end;
if (smalltalk:isObject_equalTo_((condition),"true"))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)(); end;
if (smalltalk:isObject_equalTo_((condition),"false"))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)(); end;
(self):note_(smalltalk:object_comma_(("Unknown optimize-condition: "),condition));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"optimization","matchOptimizedCondition: condition with: aNode\r\n\t\" Private - Return true if aNode matches the condition. \"\r\n\r\n\t(#(\r\n\thasNumber: receiverHasNumber: argumentsHasNumber:\r\n\thasString: receiverHasString: argumentsHasString:\r\n\targ1HasNumber: arg2HasNumber: arg3HasNumber:\r\n\thasBlockArguments: hasBlockNoArguments: hasBlockOneArguments:\r\n\tallBlockNoArguments: receiverIsBlockNoArguments: receiverIsBlock:\r\n\tnoClient: hasClient:\r\n\t) includes: condition) ifTrue: [\r\n\t\t^self perform: condition withArguments: (Array with: aNode)\r\n\t].\r\n\tcondition isArray ifTrue: [\r\n\t\tcondition detect: [:one|\r\n\t\t\tfalse = (self matchOptimizedCondition: one with: aNode)\r\n\t\t] ifNone: [ ^true ].\r\n\t\t^false\r\n\t].\r\n\tcondition = #true ifTrue: [ ^true ].\r\n\tcondition = #false ifTrue: [ ^false ].\r\n\tself note: 'Unknown optimize-condition: ',condition.\r\n\t^false","(\r\nfunction(self,condition,aNode)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif ((smalltalk:newArray({\"hasNumber:\", \"receiverHasNumber:\", \"argumentsHasNumber:\", \"hasString:\", \"receiverHasString:\", \"argumentsHasString:\", \"arg1HasNumber:\", \"arg2HasNumber:\", \"arg3HasNumber:\", \"hasBlockArguments:\", \"hasBlockNoArguments:\", \"hasBlockOneArguments:\", \"allBlockNoArguments:\", \"receiverIsBlockNoArguments:\", \"receiverIsBlock:\", \"noClient:\", \"hasClient:\"})):includes_(condition))==true then return ((self):perform_withArguments_(condition,(smalltalk.Array):with_(aNode))); end;\r\nif ((condition):isArray())==true then (condition):detect_ifNone_((function(one)\r\nreturn (smalltalk:isObject_equalTo_((false),(self):matchOptimizedCondition_with_(one,aNode)))\r\nend),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\nif (smalltalk:isObject_equalTo_((condition),\"true\"))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\nif (smalltalk:isObject_equalTo_((condition),\"false\"))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(self):note_(smalltalk:object_comma_((\"Unknown optimize-condition: \"),condition));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"optimizationLiteralsFor:",0
,(
function(self,opt)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local array=nil
if not (((opt):isString()))==true then return ((smalltalk.Array):with_(opt)); end;
(function()
	local _s8_value=((self):knownOptimizations())
	array=_s8_value
	return _s8_value
end)();
(array):do_((function(pair)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((pair):first()),opt)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (((pair):last()):inject_into_(smalltalk:newArray({}),(function(total,tuple)
return ((
function(_s8_rec)
	(_s8_rec):addAll_((self):optimizationLiteralsFor_(tuple));
	return ((_s8_rec):yourself())
end
)(total))
end)))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(array):do_((function(pair)
return (((pair):last()):do_((function(tuple)
return (smalltalk:if_true_false_((smalltalk:boolean_and_(((tuple):isArray()),(function()
return (smalltalk:isObject_equalTo_(((tuple):first()),opt))
end))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.Array):with_(tuple))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:newArray({}))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"optimization","optimizationLiteralsFor: opt\r\n\t\" Private - Return the optimization literals array defined for opt.\r\n\topt can be an optimization family or message selector\r\n\t\"\r\n\r\n\t| array |\r\n\topt isString ifFalse: [ ^Array with: opt ].\r\n\tarray := self knownOptimizations.\r\n\tarray do: [:pair|\r\n\t\tpair first = opt ifTrue: [\r\n\t\t\t^pair last inject: #() into: [:total :tuple|\r\n\t\t\t\ttotal addAll: (self optimizationLiteralsFor: tuple); yourself\r\n\t\t\t]\r\n\t\t].\r\n\t].\r\n\tarray do: [:pair|\r\n\t\tpair last do: [:tuple|\r\n\t\t\t(tuple isArray and: [tuple first = opt]) ifTrue: [ ^Array with: tuple ]\r\n\t\t].\r\n\t].\r\n\t^#()","(\r\nfunction(self,opt)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal array=nil\r\nif not (((opt):isString()))==true then return ((smalltalk.Array):with_(opt)); end;\r\n(function()\r\n\tlocal _s8_value=((self):knownOptimizations())\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(array):do_((function(pair)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((pair):first()),opt)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (((pair):last()):inject_into_(smalltalk:newArray({}),(function(total,tuple)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAll_((self):optimizationLiteralsFor_(tuple));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(total))\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(array):do_((function(pair)\r\nreturn (((pair):last()):do_((function(tuple)\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_(((tuple):isArray()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((tuple):first()),opt))\r\nend))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.Array):with_(tuple))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:newArray({}))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"optimizationMap",0
,(
function(self)
if (smalltalk:isNil_((self["@optimizationMap"])))==true then (self):initializeOptimizationMap(); end;
return (self["@optimizationMap"]);
end
)
,"accessing","optimizationMap\r\n\t\" Return the message send optimization map of the receiver. \"\r\n\r\n\toptimizationMap isNil ifTrue: [ self initializeOptimizationMap ].\r\n\t^optimizationMap","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@optimizationMap\"])))==true then (self):initializeOptimizationMap(); end;\r\nreturn (self[\"@optimizationMap\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"optimizationMap:",0
,(
function(self,aSpec)
(function()
	local _s8_value=(aSpec)
	self["@optimizationMap"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","optimizationMap: aSpec\r\n\t\" Set the current optimizationMap of the receiver. \"\r\n\r\n\toptimizationMap := aSpec","(\r\nfunction(self,aSpec)\r\n(function()\r\n\tlocal _s8_value=(aSpec)\r\n\tself[\"@optimizationMap\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"emmitCode:",0
,(
function(self,code)
return ((self):implementedBySubclass_("emmitCode:"));
end
)
,"generation","emmitCode: code\r\n\t\" Private - Emmit code onto output stream. \"\r\n\r\n\t^self implementedBySubclass: #emmitCode: ","(\r\nfunction(self,code)\r\nreturn ((self):implementedBySubclass_(\"emmitCode:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"emmitInlinedCode:",0
,(
function(self,code)
return ((self):emmitCode_(code));
end
)
,"generation","emmitInlinedCode: code\r\n\t\" Private - Emmit inlined code onto output stream. \"\r\n\r\n\t^self emmitCode: code ","(\r\nfunction(self,code)\r\nreturn ((self):emmitCode_(code));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"macroToken",0
,(
function(self)
return ("%");
end
)
,"macros","macroToken\r\n\t\" Private - Return the (default) macro token. \"\r\n\r\n\t^$% ","(\r\nfunction(self)\r\nreturn (\"%\");\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"macroStart",0
,(
function(self)
return ((self):macroToken());
end
)
,"macros","macroStart\r\n\t\" Private - Return the macro start token. \"\r\n\r\n\t^self macroToken ","(\r\nfunction(self)\r\nreturn ((self):macroToken());\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"macroEnd",0
,(
function(self)
return ((self):macroToken());
end
)
,"macros","macroEnd\r\n\t\" Private - Return the macro end token. \"\r\n\r\n\t^self macroToken ","(\r\nfunction(self)\r\nreturn ((self):macroToken());\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"macroStream:",0
,(
function(self,macro)
return ((macro):readStream());
end
)
,"macros","macroStream: macro\r\n\t\" Private - Return a code stream from macro string. \"\r\n\r\n\t^macro readStream ","(\r\nfunction(self,macro)\r\nreturn ((macro):readStream());\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"expandMacrosIn:with:",0
,(
function(self,input,aNode)
while not ((function()
return ((input):atEnd())
end))() do local code=nil
(function()
	local _s8_value=((input):upTo_((self):macroStart()))
	code=_s8_value
	return _s8_value
end)();
if ((((code):size()) > 0))==true then (self):emmitInlinedCode_(code); end;
smalltalk:if_true_false_(((input):atEnd()),nil,(function()
return ((self):visitMacroIn_with_(input,aNode))
end)); end;
return (self);
end
)
,"macros","expandMacrosIn: input with: aNode\r\n\t\" Private - Parse input expanding macros.\r\n\tExpandable macros are defined between macroToken\r\n\t\"\r\n\r\n\t[input atEnd] whileFalse: [ | code |\r\n\t\tcode := input upTo: self macroStart.\r\n\t\tcode size > 0 ifTrue: [ self emmitInlinedCode: code ].\r\n\t\tinput atEnd ifFalse: [ self visitMacroIn: input with: aNode ]\r\n\t] ","(\r\nfunction(self,input,aNode)\r\nwhile not ((function()\r\nreturn ((input):atEnd())\r\nend))() do local code=nil\r\n(function()\r\n\tlocal _s8_value=((input):upTo_((self):macroStart()))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((((code):size()) > 0))==true then (self):emmitInlinedCode_(code); end;\r\nsmalltalk:if_true_false_(((input):atEnd()),nil,(function()\r\nreturn ((self):visitMacroIn_with_(input,aNode))\r\nend)); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"optimize:macro:",0
,(
function(self,aNode,template)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if ((template):isArray())==true then (template):detect_ifNone_((function(one)
return ((self):visitOptimizedNode_as_(aNode,one))
end),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)(); end;
if not (((template):isString()))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:notNil_(((template):value_value_(aNode,self))))
end
)()
error(_s8Ret_,0)
end)(); end;
(self):expandMacrosIn_with_((self):macroStream_(template),aNode);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"macros","optimize: aNode macro: template\r\n\t\" Private - Generate the code for aNode using a macro template.\r\n\tReturn true if expanded the macro, or leave the receiver unchanged returning false\r\n\t\"\r\n\r\n\ttemplate isArray ifTrue: [ \"conditional templates\"\r\n\t\ttemplate detect: [:one| self visitOptimizedNode: aNode as: one ]\r\n\t\t\tifNone: [ ^false ].\r\n\t\t^true\r\n\t].\r\n\ttemplate isString ifFalse: [ \"an evaluable template (must return nil if failed to expand)\"\r\n\t\t^(template value: aNode value: self) notNil\r\n\t].\r\n\tself expandMacrosIn: (self macroStream: template) with: aNode.\r\n\t^true","(\r\nfunction(self,aNode,template)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif ((template):isArray())==true then (template):detect_ifNone_((function(one)\r\nreturn ((self):visitOptimizedNode_as_(aNode,one))\r\nend),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\nif not (((template):isString()))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:notNil_(((template):value_value_(aNode,self))))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(self):expandMacrosIn_with_((self):macroStream_(template),aNode);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"receiverHasNumber:",0
,(
function(self,aNode)
return (((aNode):receiver()):hasNumber());
end
)
,"optimization","receiverHasNumber: aNode\r\n\t\" Private - Return true if the receiver of aNode is a number literal. \"\r\n\r\n\t^aNode receiver hasNumber","(\r\nfunction(self,aNode)\r\nreturn (((aNode):receiver()):hasNumber());\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"receiverHasString:",0
,(
function(self,aNode)
return (((aNode):receiver()):hasString());
end
)
,"optimization","receiverHasString: aNode\r\n\t\" Private - Return true if the receiver of aNode is a string literal. \"\r\n\r\n\t^aNode receiver hasString","(\r\nfunction(self,aNode)\r\nreturn (((aNode):receiver()):hasString());\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"receiverIsBlock:",0
,(
function(self,aNode)
return (smalltalk:is_kindOf_(((aNode):receiver()),(smalltalk.BlockNode)));
end
)
,"optimization","receiverIsBlock: aNode\r\n\t\" Private - Return true if receiver of aNode is block.\"\r\n\r\n\t^aNode receiver isKindOf: BlockNode ","(\r\nfunction(self,aNode)\r\nreturn (smalltalk:is_kindOf_(((aNode):receiver()),(smalltalk.BlockNode)));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"receiverIsBlockNoArguments:",0
,(
function(self,aNode)
return (smalltalk:boolean_and_(((self):receiverIsBlock_(aNode)),(function()
return ((((aNode):receiver()):parameters()):isEmpty())
end)));
end
)
,"optimization","receiverIsBlockNoArguments: aNode\r\n\t\" Private - Return true if receiver of aNode is block with no arguments. \"\r\n\r\n\t^(self receiverIsBlock: aNode) and: [\r\n\t\taNode receiver parameters isEmpty\r\n\t]","(\r\nfunction(self,aNode)\r\nreturn (smalltalk:boolean_and_(((self):receiverIsBlock_(aNode)),(function()\r\nreturn ((((aNode):receiver()):parameters()):isEmpty())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"removeOptimizationLiteral:",0
,(
function(self,aLiteral)
((self):optimizationMap()):remove_(aLiteral);
return (self);
end
)
,"optimization","removeOptimizationLiteral: aLiteral\r\n\t\" Private - Remove the optimization from the receiver. \"\r\n\r\n\tself optimizationMap remove: aLiteral ","(\r\nfunction(self,aLiteral)\r\n((self):optimizationMap()):remove_(aLiteral);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"removeOptimizations:",0
,(
function(self,array)
(array):do_((function(opt)
return (((self):optimizationLiteralsFor_(opt)):do_((function(each)
return ((self):removeOptimizationLiteral_(each))
end)))
end));
return (self);
end
)
,"optimization","removeOptimizations: array\r\n\t\" Private - Remove an array of optimizations to the receiver. \"\r\n\r\n\tarray do: [:opt|\r\n\t\t(self optimizationLiteralsFor: opt) do: [:each|\r\n\t\t\tself removeOptimizationLiteral: each\r\n\t\t]\r\n\t]","(\r\nfunction(self,array)\r\n(array):do_((function(opt)\r\nreturn (((self):optimizationLiteralsFor_(opt)):do_((function(each)\r\nreturn ((self):removeOptimizationLiteral_(each))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"inlineToken:",0
,(
function(self,string)
return ((string):copyFrom_to_(2,(string):size()));
end
)
,"inlines","inlineToken: string\r\n\t\" Private - Return the inline key to search for contents (or nil). \"\r\n\r\n\t^string copyFrom: 2 to: string size ","(\r\nfunction(self,string)\r\nreturn ((string):copyFrom_to_(2,(string):size()));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"inlineKey:",0
,(
function(self,string)
if (smalltalk:isObject_equalTo_(((string):size()),0))==true then return (""); end;
if ((string):startsWith_("#"))==true then return ((self):inlineToken_(string)); end;
return (nil);
end
)
,"inlines","inlineKey: string\r\n\t\" Private - Return the inline key to search for inline contents (or nil). \"\r\n\r\n\tstring size = 0 ifTrue: [ ^'' ].\r\n\t(string startsWith: $#) ifTrue: [ ^self inlineToken: string ].\r\n\t^nil ","(\r\nfunction(self,string)\r\nif (smalltalk:isObject_equalTo_(((string):size()),0))==true then return (\"\"); end;\r\nif ((string):startsWith_(\"#\"))==true then return ((self):inlineToken_(string)); end;\r\nreturn (nil);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"inlinesFor:",0
,(
function(self,string)
local chunks=nil
if (smalltalk:notNil_((self["@inlines"])))==true then return (self["@inlines"]); end;
(function()
	local _s8_value=(((self)["$klass"]):inlinesFor_compiler_((self):inlineKey_(string),(self):compiler()))
	chunks=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((chunks)))==true then (function()
	local _s8_value=(smalltalk:newArray({}))
	chunks=_s8_value
	return _s8_value
end)(); end;
if ((chunks):isString())==true then (function()
	local _s8_value=((smalltalk.Array):with_(chunks))
	chunks=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=((chunks):stream())
	self["@inlines"]=_s8_value
	return _s8_value
end)();
return (self["@inlines"]);
end
)
,"inlines","inlinesFor: string\r\n\t\" Private - Return the inlines stream with native source chunks to inject while generating code. \"\r\n\r\n\t| chunks |\r\n\tinlines notNil ifTrue: [ ^inlines ].\r\n\tchunks := self class inlinesFor: (self inlineKey: string) compiler: self compiler.\r\n\tchunks isNil ifTrue: [ chunks := #() ].\r\n\tchunks isString ifTrue: [ chunks := Array with: chunks ].\r\n\tinlines := chunks stream.\r\n\t^inlines","(\r\nfunction(self,string)\r\nlocal chunks=nil\r\nif (smalltalk:notNil_((self[\"@inlines\"])))==true then return (self[\"@inlines\"]); end;\r\n(function()\r\n\tlocal _s8_value=(((self)[\"$klass\"]):inlinesFor_compiler_((self):inlineKey_(string),(self):compiler()))\r\n\tchunks=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((chunks)))==true then (function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tchunks=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif ((chunks):isString())==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):with_(chunks))\r\n\tchunks=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((chunks):stream())\r\n\tself[\"@inlines\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self[\"@inlines\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"missingNativeCodeFor:as:",0
,(
function(self,aNode,lang)
return ((self):error_(smalltalk:object_comma_(("Missing native code for language "),lang)));
end
)
,"inlines","missingNativeCodeFor: aNode as: lang\r\n\t\" Private - Return the native language code for missing expression (or nil). \"\r\n\r\n\t^self error: 'Missing native code for language ' ,lang ","(\r\nfunction(self,aNode,lang)\r\nreturn ((self):error_(smalltalk:object_comma_((\"Missing native code for language \"),lang)));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"inline:source:",0
,(
function(self,aNode,string)
local chunks=nil
(function()
	local _s8_value=((self):inlinesFor_(string))
	chunks=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_(((chunks):atEnd()),nil,(function()
return ((chunks):next())
end)));
end
)
,"inlines","inline: aNode source: string\r\n\t\" Return the string source for inline node. \"\r\n\r\n\t| chunks |\r\n\tchunks := self inlinesFor: string.\r\n\t^chunks atEnd ifFalse: [ chunks next ] ","(\r\nfunction(self,aNode,string)\r\nlocal chunks=nil\r\n(function()\r\n\tlocal _s8_value=((self):inlinesFor_(string))\r\n\tchunks=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_(((chunks):atEnd()),nil,(function()\r\nreturn ((chunks):next())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitInlineNode:",0
,(
function(self,aNode)
local string=nil
local lang=nil
(function()
	local _s8_value=((self):nativeLanguage())
	lang=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((lang)))==true then (function()
	local _s8_value=((smalltalk.Smalltalk):nativeLanguage())
	lang=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=((aNode):sourceFor_in_(lang,self))
	string=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((string),"self"))==true then return (nil); end;
if (smalltalk:isObject_equalTo_(((string):size()),0))==true then (function()
	local _s8_value=((self):missingNativeCodeFor_as_(aNode,lang))
	string=_s8_value
	return _s8_value
end)(); end;
return (smalltalk:if_true_false_((smalltalk:notNil_((string))),(function()
return ((self):optimize_macro_(aNode,string))
end),nil));
end
)
,"inlines","visitInlineNode: aNode\r\n\t\" Private - Encode an inline node containing native language code. \"\r\n\r\n\t| string lang |\r\n\tlang := self nativeLanguage.\r\n\tlang isNil ifTrue:  [ lang := Smalltalk nativeLanguage ].\r\n\tstring := aNode sourceFor: lang in: self.\r\n\tstring = #self ifTrue: [ ^nil ]. \"inlined 'self' is encoded a no-operation (optional inline)\"\r\n\tstring size = 0 ifTrue:  [ string := self missingNativeCodeFor: aNode as: lang ].\r\n\t^string notNil ifTrue: [ self optimize: aNode macro: string ] ","(\r\nfunction(self,aNode)\r\nlocal string=nil\r\nlocal lang=nil\r\n(function()\r\n\tlocal _s8_value=((self):nativeLanguage())\r\n\tlang=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((lang)))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):nativeLanguage())\r\n\tlang=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((aNode):sourceFor_in_(lang,self))\r\n\tstring=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((string),\"self\"))==true then return (nil); end;\r\nif (smalltalk:isObject_equalTo_(((string):size()),0))==true then (function()\r\n\tlocal _s8_value=((self):missingNativeCodeFor_as_(aNode,lang))\r\n\tstring=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((string))),(function()\r\nreturn ((self):optimize_macro_(aNode,string))\r\nend),nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"startCompiling:",0
,(
function(self,aNode)
(function()
	local _s8_value=(nil)
	self["@inlines"]=_s8_value
	return _s8_value
end)();
return (smalltalk:superImplementor(smalltalk.OptimizingEncoder,"startCompiling_")(self,aNode));
end
)
,"private","startCompiling: aNode\r\n\t\" Private - Set the receiver to start emmiting code for aNode. \"\r\n\r\n\tinlines := nil.\r\n\t^super startCompiling: aNode","(\r\nfunction(self,aNode)\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@inlines\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:superImplementor(smalltalk.OptimizingEncoder,\"startCompiling_\")(self,aNode));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitInlined:",0
,(
function(self,aNode)
if not ((smalltalk:is_kindOf_((aNode),(smalltalk.BlockNode))))==true then return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_(("Invalid block node ("),aNode)),")."))); end;
((aNode):nodes()):do_((function(each)
return ((self):visit_(each))
end));
return (self);
end
)
,"optimization","visitInlined: aNode\r\n\t\" Private - Encode aNode as inlined sequence of statements. \"\r\n\r\n\t(aNode isKindOf: BlockNode) ifFalse: [\r\n\t\t^self error: 'Invalid block node (' ,aNode ,').'\r\n\t].\r\n\taNode nodes do: [:each | self visit: each ].","(\r\nfunction(self,aNode)\r\nif not ((smalltalk:is_kindOf_((aNode),(smalltalk.BlockNode))))==true then return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((\"Invalid block node (\"),aNode)),\").\"))); end;\r\n((aNode):nodes()):do_((function(each)\r\nreturn ((self):visit_(each))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitInlinedMacro:in:with:",0
,(
function(self,macro,input,aNode)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (smalltalk:isObject_equalTo_((macro),"inlinedReceiver"))==true then return ((self):visitInlined_((aNode):receiver())); end;
if ((macro):startsWith_("inlined"))==true then local args=nil
(function()
	local _s8_value=((aNode):arguments())
	args=_s8_value
	return _s8_value
end)();
(1):to_do_((args):size(),(function(i)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((smalltalk:object_comma_(("inlined"),smalltalk:asString_((i)))),macro)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):visitInlined_((args):at_(i)))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end)); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_(("Invalid macro ["),macro)),"]")))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"optimizing","visitInlinedMacro: macro in: input with: aNode\r\n\t\" Private - Visit inlined macro in input. \"\r\n\r\n\tmacro = #inlinedReceiver ifTrue: [ ^self visitInlined: aNode receiver ].\r\n\t(macro startsWith: #inlined) ifTrue: [ | args |\r\n\t\targs := aNode arguments.\r\n\t\t1 to: args size do: [:i|\r\n\t\t\t#inlined ,i asString = macro ifTrue: [\r\n\t\t\t\t^self visitInlined: (args at: i)\r\n\t\t\t].\r\n\t\t].\r\n\t].\r\n\t^self error: 'Invalid macro [',macro,']' ","(\r\nfunction(self,macro,input,aNode)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (smalltalk:isObject_equalTo_((macro),\"inlinedReceiver\"))==true then return ((self):visitInlined_((aNode):receiver())); end;\r\nif ((macro):startsWith_(\"inlined\"))==true then local args=nil\r\n(function()\r\n\tlocal _s8_value=((aNode):arguments())\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(1):to_do_((args):size(),(function(i)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((smalltalk:object_comma_((\"inlined\"),smalltalk:asString_((i)))),macro)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):visitInlined_((args):at_(i)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend)); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((\"Invalid macro [\"),macro)),\"]\")))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitSeqMacro:in:with:",0
,(
function(self,macro,input,aNode)
local args=nil
local i=nil
if (smalltalk:isObject_equalTo_((macro),"sequence"))==true then return ((self):visitSequenceNode_(aNode)); end;
(function()
	local _s8_value=(((macro):copyFrom_to_(4,(macro):size())):asNumber())
	i=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aNode):arguments())
	args=_s8_value
	return _s8_value
end)();
if ((i):between_and_(1,(args):size()))==true then local block=nil
(function()
	local _s8_value=((args):at_(i))
	block=_s8_value
	return _s8_value
end)();
if not ((smalltalk:isObject_equalTo_((((block):parameters()):size()),0)))==true then (self):error_("Invalid block (has parameters)"); end;
return ((self):visitSequenceNode_(((block):nodes()):first())); end;
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_(("Invalid macro ["),macro)),"]")));
end
)
,"optimizing","visitSeqMacro: macro in: input with: aNode\r\n\t\" Private - Visit argument macro in input. \"\r\n\r\n\t| args i |\r\n\tmacro = #sequence ifTrue: [\r\n\t\t^self visitSequenceNode: aNode\r\n\t].\r\n\ti := (macro copyFrom: 4 to: macro size) asNumber.\r\n\targs := aNode arguments.\r\n\t(i between: 1 and: args size) ifTrue: [ | block |\r\n\t\tblock := args at: i.\r\n\t\tblock parameters size = 0 ifFalse: [\r\n\t\t\tself error: 'Invalid block (has parameters)'\r\n\t\t].\r\n\t\t^self visitSequenceNode: block nodes first\r\n\t].\r\n\t^self error: 'Invalid macro [',macro,']' ","(\r\nfunction(self,macro,input,aNode)\r\nlocal args=nil\r\nlocal i=nil\r\nif (smalltalk:isObject_equalTo_((macro),\"sequence\"))==true then return ((self):visitSequenceNode_(aNode)); end;\r\n(function()\r\n\tlocal _s8_value=(((macro):copyFrom_to_(4,(macro):size())):asNumber())\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aNode):arguments())\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((i):between_and_(1,(args):size()))==true then local block=nil\r\n(function()\r\n\tlocal _s8_value=((args):at_(i))\r\n\tblock=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:isObject_equalTo_((((block):parameters()):size()),0)))==true then (self):error_(\"Invalid block (has parameters)\"); end;\r\nreturn ((self):visitSequenceNode_(((block):nodes()):first())); end;\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((\"Invalid macro [\"),macro)),\"]\")));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitArgMacro:in:with:",0
,(
function(self,macro,input,aNode)
local args=nil
local i=nil
(function()
	local _s8_value=(((macro):copyFrom_to_(4,(macro):size())):asNumber())
	i=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aNode):arguments())
	args=_s8_value
	return _s8_value
end)();
if ((i):between_and_(1,(args):size()))==true then return ((self):visit_((args):at_(i))); end;
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_(("Invalid macro ["),macro)),"]")));
end
)
,"optimizing","visitArgMacro: macro in: input with: aNode\r\n\t\" Private - Visit argument macro in input. \"\r\n\r\n\t| args i |\r\n\ti := (macro copyFrom: 4 to: macro size) asNumber.\r\n\targs := aNode arguments.\r\n\t(i between: 1 and: args size) ifTrue: [\r\n\t\t^self visit: (args at: i)\r\n\t].\r\n\t^self error: 'Invalid macro [',macro,']' ","(\r\nfunction(self,macro,input,aNode)\r\nlocal args=nil\r\nlocal i=nil\r\n(function()\r\n\tlocal _s8_value=(((macro):copyFrom_to_(4,(macro):size())):asNumber())\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aNode):arguments())\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((i):between_and_(1,(args):size()))==true then return ((self):visit_((args):at_(i))); end;\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((\"Invalid macro [\"),macro)),\"]\")));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"basicMacro:in:with:",0
,(
function(self,macro,input,aNode)
if (smalltalk:isObject_equalTo_((macro),"lang"))==true then return ((self):nextPutAll_((self):nativeLanguage())); end;
if (smalltalk:isObject_equalTo_((macro),"receiver"))==true then return ((self):visitReceiver_((aNode):receiver())); end;
if ((macro):startsWith_("arg"))==true then return ((self):visitArgMacro_in_with_(macro,input,aNode)); end;
if ((macro):startsWith_("seq"))==true then return ((self):visitSeqMacro_in_with_(macro,input,aNode)); end;
if ((macro):startsWith_("!"))==true then return ((
function(_s8_rec)
	(_s8_rec):next();
	return ((_s8_rec):fileInto_(self))
end
)((macro):stream())); end;
if ((macro):startsWith_("inlined"))==true then return ((self):visitInlinedMacro_in_with_(macro,input,aNode)); end;
if (smalltalk:responds_to_((self),(macro)))==true then local args=nil
local count=nil
(function()
	local _s8_value=((macro):argumentCount())
	count=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((count),0))==true then return ((self):perform_(macro)); end;
(function()
	local _s8_value=(((smalltalk.Array):with_with_(aNode,input)):copyFrom_to_(1,(count):min_(2)))
	args=_s8_value
	return _s8_value
end)();
return ((self):perform_withArguments_(macro,args)); end;
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_(("Missing macro ["),macro)),"]")));
end
)
,"macros","basicMacro: macro in: input with: aNode\r\n\t\" Private - Visit aNode encoding/expanding basic macros in input. \"\r\n\r\n\tmacro = #lang ifTrue: [\r\n\t\t^self nextPutAll: self nativeLanguage\r\n\t].\r\n\tmacro = #receiver ifTrue: [\r\n\t\t^self visitReceiver: aNode receiver\r\n\t].\r\n\t(macro startsWith: #arg) ifTrue: [\r\n\t\t^self visitArgMacro: macro in: input with: aNode\r\n\t].\r\n\t(macro startsWith: #seq) ifTrue: [\r\n\t\t^self visitSeqMacro: macro in: input with: aNode\r\n\t].\r\n\t(macro startsWith: $!) ifTrue: [\r\n\t\t^macro stream next; fileInto: self\r\n\t].\r\n\t(macro startsWith: #inlined) ifTrue: [\r\n\t\t^self visitInlinedMacro: macro in: input with: aNode\r\n\t].\r\n\t(self respondsTo: macro) ifTrue: [ | args count |\r\n\t\tcount := macro argumentCount.\r\n\t\tcount = 0 ifTrue: [ ^self perform: macro ].\r\n\t\targs := (Array with: aNode with: input)\r\n\t\t\tcopyFrom: 1 to: (count min: 2).\r\n\t\t^self perform: macro withArguments: args\r\n\t].\r\n\t^self error: 'Missing macro [' ,macro ,$] ","(\r\nfunction(self,macro,input,aNode)\r\nif (smalltalk:isObject_equalTo_((macro),\"lang\"))==true then return ((self):nextPutAll_((self):nativeLanguage())); end;\r\nif (smalltalk:isObject_equalTo_((macro),\"receiver\"))==true then return ((self):visitReceiver_((aNode):receiver())); end;\r\nif ((macro):startsWith_(\"arg\"))==true then return ((self):visitArgMacro_in_with_(macro,input,aNode)); end;\r\nif ((macro):startsWith_(\"seq\"))==true then return ((self):visitSeqMacro_in_with_(macro,input,aNode)); end;\r\nif ((macro):startsWith_(\"!\"))==true then return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):next();\r\n\treturn ((_s8_rec):fileInto_(self))\r\nend\r\n)((macro):stream())); end;\r\nif ((macro):startsWith_(\"inlined\"))==true then return ((self):visitInlinedMacro_in_with_(macro,input,aNode)); end;\r\nif (smalltalk:responds_to_((self),(macro)))==true then local args=nil\r\nlocal count=nil\r\n(function()\r\n\tlocal _s8_value=((macro):argumentCount())\r\n\tcount=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((count),0))==true then return ((self):perform_(macro)); end;\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.Array):with_with_(aNode,input)):copyFrom_to_(1,(count):min_(2)))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):perform_withArguments_(macro,args)); end;\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((\"Missing macro [\"),macro)),\"]\")));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitUppercaseMacro:in:with:",0
,(
function(self,macro,input,aNode)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (smalltalk:isObject_equalTo_((macro),"Lang"))==true then return ((self):nextPutAll_(((self):nativeLanguage()):asGlobalName())); end;
(smalltalk.Smalltalk):at_ifAbsent_(macro,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):basicMacro_in_with_(macro,input,aNode))
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):nextPutAll_((self):codeToGetGlobal_(macro)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"optimizing","visitUppercaseMacro: macro in: input with: aNode\r\n\t\" Private - Expand global macro in input. \"\r\n\r\n\tmacro = #Lang ifTrue: [\r\n\t\t^self nextPutAll: self nativeLanguage asGlobalName\r\n\t].\r\n\tSmalltalk at: macro ifAbsent: [\r\n\t\t^self basicMacro: macro in: input with: aNode \r\n\t].\r\n\t^self nextPutAll: (self codeToGetGlobal: macro) ","(\r\nfunction(self,macro,input,aNode)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (smalltalk:isObject_equalTo_((macro),\"Lang\"))==true then return ((self):nextPutAll_(((self):nativeLanguage()):asGlobalName())); end;\r\n(smalltalk.Smalltalk):at_ifAbsent_(macro,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):basicMacro_in_with_(macro,input,aNode))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):nextPutAll_((self):codeToGetGlobal_(macro)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitMacroSend:in:with:",0
,(
function(self,macro,input,aNode)
return ((self):nextPutAll_(smalltalk:object_comma_(("smalltalk"),macro)));
end
)
,"optimizing","visitMacroSend: macro in: input with: aNode\r\n\t\" Private - Expand root macro in input. \"\r\n\r\n\t^self nextPutAll: #smalltalk ,macro ","(\r\nfunction(self,macro,input,aNode)\r\nreturn ((self):nextPutAll_(smalltalk:object_comma_((\"smalltalk\"),macro)));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitMacro:in:with:",0
,(
function(self,macro,input,aNode)
if ((macro):startsWith_((self):messageSendConnector()))==true then return ((self):visitMacroSend_in_with_(macro,input,aNode)); end;
if (((macro):first()):isUppercase())==true then return ((self):visitUppercaseMacro_in_with_(macro,input,aNode)); end;
return ((self):basicMacro_in_with_(macro,input,aNode));
end
)
,"optimizing","visitMacro: macro in: input with: aNode\r\n\t\" Private - Visit aNode encoding/expanding macro in input. \"\r\n\r\n\t(macro startsWith: self messageSendConnector) ifTrue: [ \" %.msgAPI% \"\r\n\t\t^self visitMacroSend: macro in: input with: aNode\r\n\t].\r\n\tmacro first isUppercase ifTrue: [ \" %GlobalName% \"\r\n\t\t^self visitUppercaseMacro: macro in: input with: aNode \r\n\t].\r\n\t^self basicMacro: macro in: input with: aNode ","(\r\nfunction(self,macro,input,aNode)\r\nif ((macro):startsWith_((self):messageSendConnector()))==true then return ((self):visitMacroSend_in_with_(macro,input,aNode)); end;\r\nif (((macro):first()):isUppercase())==true then return ((self):visitUppercaseMacro_in_with_(macro,input,aNode)); end;\r\nreturn ((self):basicMacro_in_with_(macro,input,aNode));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitMacroIn:with:",0
,(
function(self,input,aNode)
local macro=nil
(function()
	local _s8_value=((input):upTo_((self):macroEnd()))
	macro=_s8_value
	return _s8_value
end)();
if ((macro):isEmpty())==true then (self):emmitCode_((self):macroEnd()); else (self):visitMacro_in_with_(macro,input,aNode); end;
return (self);
end
)
,"optimizing","visitMacroIn: input with: aNode\r\n\t\" Private - Visit next macro in input. \"\r\n\r\n\t| macro |\r\n\tmacro := input upTo: self macroEnd.\r\n\tmacro isEmpty\r\n\t\tifTrue: [ self emmitCode: self macroEnd ]\r\n\t\tifFalse: [ self visitMacro: macro in: input with: aNode ] ","(\r\nfunction(self,input,aNode)\r\nlocal macro=nil\r\n(function()\r\n\tlocal _s8_value=((input):upTo_((self):macroEnd()))\r\n\tmacro=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((macro):isEmpty())==true then (self):emmitCode_((self):macroEnd()); else (self):visitMacro_in_with_(macro,input,aNode); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitOptimizedNode:as:",0
,(
function(self,aNode,mapping)
local macro=nil
(function()
	local _s8_value=((mapping):last())
	macro=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((mapping):size()),2))==true then return ((self):optimize_macro_(aNode,macro)); end;
if (smalltalk:isObject_equalTo_(((mapping):size()),3))==true then return (smalltalk:boolean_and_(((self):matchOptimizedCondition_with_((mapping):at_(2),aNode)),(function()
return ((self):optimize_macro_(aNode,macro))
end))); end;
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Compiler optimization")," for #")),(aNode):selector()))," - not implemented ")),(mapping):asLiteral()));
return (false);
end
)
,"visiting","visitOptimizedNode: aNode as: mapping\r\n\t\" Private - Generate the code for aNode using custom mapping.\r\n\tReturn true if the code can be generated.\r\n\tIf the optimization fails, the receiver remains intact.\r\n\t\"\r\n\r\n\t| macro |\r\n\tmacro := mapping last.\r\n\r\n\tmapping size = 2 ifTrue: [ \"(selector macro)\"\r\n\t\t^self optimize: aNode macro: macro\r\n\t].\r\n\tmapping size = 3 ifTrue: [\"(selector condition macro)\"\r\n\t\t^(self matchOptimizedCondition: (mapping at:2) with: aNode)\r\n\t\t\tand: [ self optimize: aNode macro: macro ]\r\n\t].\r\n\r\n\tself note: 'Compiler optimization'\r\n\t\t,' for #',aNode selector\r\n\t\t,' - not implemented '\r\n\t\t,mapping asLiteral.\r\n\t^false","(\r\nfunction(self,aNode,mapping)\r\nlocal macro=nil\r\n(function()\r\n\tlocal _s8_value=((mapping):last())\r\n\tmacro=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((mapping):size()),2))==true then return ((self):optimize_macro_(aNode,macro)); end;\r\nif (smalltalk:isObject_equalTo_(((mapping):size()),3))==true then return (smalltalk:boolean_and_(((self):matchOptimizedCondition_with_((mapping):at_(2),aNode)),(function()\r\nreturn ((self):optimize_macro_(aNode,macro))\r\nend))); end;\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Compiler optimization\"),\" for #\")),(aNode):selector())),\" - not implemented \")),(mapping):asLiteral()));\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitOptimizedSend:",0
,(
function(self,aNode)
return ((self):visitOptimizedSend_with_(aNode,(self):optimizationMap()));
end
)
,"visiting","visitOptimizedSend: aNode\r\n\t\" Private - Generate optimal code for aNode using optimization map.\r\n\tReturn true if optimization was successfull.\r\n\t\"\r\n\r\n\t^self visitOptimizedSend: aNode with: self optimizationMap","(\r\nfunction(self,aNode)\r\nreturn ((self):visitOptimizedSend_with_(aNode,(self):optimizationMap()));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitOptimizedSend:with:",0
,(
function(self,aNode,mapping)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local argCount=nil
(function()
	local _s8_value=(((aNode):arguments()):size())
	argCount=_s8_value
	return _s8_value
end)();
(mapping):do_((function(tuple)
return (smalltalk:if_true_false_((smalltalk:boolean_and_((((tuple):first()):isNumber()),(function()
return (smalltalk:isObject_equalTo_(((tuple):first()),argCount))
end))),(function()
return (smalltalk:if_true_false_(((self):visitOptimizedSend_with_(aNode,(tuple):last())),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end),(function()
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((tuple):first()),(aNode):selector())),(function()
return (smalltalk:if_true_false_(((self):visitOptimizedNode_as_(aNode,tuple)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end),nil))
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"visiting","visitOptimizedSend: aNode with: mapping\r\n\t\" Private - Generate optimal code for aNode using mapping.\r\n\tReturn true if the code has been generated.\r\n\tLeave the receiver intact if the optimization do not apply.\r\n\t\"\r\n\r\n\t| argCount |\r\n\targCount := aNode arguments size.\r\n\tmapping do: [:tuple|\r\n\t\t(tuple first isNumber and: [ tuple first = argCount ]) ifTrue: [ \"arguments size match\"\r\n\t\t\t(self visitOptimizedSend: aNode with: tuple last) ifTrue: [ ^true ].\r\n\t\t] ifFalse: [\r\n\t\t\ttuple first = aNode selector ifTrue: [ \"selector match\"\r\n\t\t\t\t(self visitOptimizedNode: aNode as: tuple) ifTrue: [ ^true ].\r\n\t\t\t].\r\n\t\t].\r\n\t].\r\n\t^false","(\r\nfunction(self,aNode,mapping)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal argCount=nil\r\n(function()\r\n\tlocal _s8_value=(((aNode):arguments()):size())\r\n\targCount=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(mapping):do_((function(tuple)\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_((((tuple):first()):isNumber()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((tuple):first()),argCount))\r\nend))),(function()\r\nreturn (smalltalk:if_true_false_(((self):visitOptimizedSend_with_(aNode,(tuple):last())),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((tuple):first()),(aNode):selector())),(function()\r\nreturn (smalltalk:if_true_false_(((self):visitOptimizedNode_as_(aNode,tuple)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend),nil))\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitReceiver:",0
,(
function(self,aNode)
return ((self):implementedBySubclass_("visitReceiver:"));
end
)
,"visiting","visitReceiver: aNode\r\n\t\" Private - Visit the node (as receiver) emmitting output. \"\r\n\r\n\t^self implementedBySubclass: #visitReceiver:","(\r\nfunction(self,aNode)\r\nreturn ((self):implementedBySubclass_(\"visitReceiver:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitSendNode:",0
,(
function(self,aNode)
return ((self):implementedBySubclass_("visitSendNode:"));
end
)
,"visiting","visitSendNode: aNode\r\n\t\" Private - Visit the node (message send node) emmitting output. \"\r\n\r\n\t^self implementedBySubclass: #visitSendNode:","(\r\nfunction(self,aNode)\r\nreturn ((self):implementedBySubclass_(\"visitSendNode:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitNode:index:",0
,(
function(self,aNode,index)
return ((self):implementedBySubclass_("visitNode:index:"));
end
)
,"visiting","visitNode: aNode index: index\r\n\t\" Private - Generate code for indexed access. \"\r\n\r\n\t^self implementedBySubclass: #visitNode:index: ","(\r\nfunction(self,aNode,index)\r\nreturn ((self):implementedBySubclass_(\"visitNode:index:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitNodeIndices:doing:",0
,(
function(self,aNode,aBlock)
(aBlock):evaluate();
((aNode):indices()):do_((function(each)
return ((self):visitNode_index_(aNode,each))
end));
return (self);
end
)
,"visiting","visitNodeIndices: aNode doing: aBlock\r\n\t\" Private - Generate code for indexed access. \"\r\n\r\n\taBlock evaluate.\r\n\taNode indices do: [:each| self visitNode: aNode index: each ].","(\r\nfunction(self,aNode,aBlock)\r\n(aBlock):evaluate();\r\n((aNode):indices()):do_((function(each)\r\nreturn ((self):visitNode_index_(aNode,each))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"missingVariable:",0
,(
function(self,aNode)
(self):compilerEvent_withArguments_ifNotHandled_("missingVariable:in:",(smalltalk.Array):with_with_(aNode,self),(function()
local unknown=nil
(function()
	local _s8_value=((aNode):value())
	unknown=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((((self)["$klass"]):bind_in_(unknown,self)),nil,(function()
((self):unknownVariables()):add_(unknown);return (((self)["$klass"]):unknownVariable_in_(aNode,self))
end)))
end));
return (self);
end
)
,"variables","missingVariable: aNode\r\n\t\" Private - Try to bind to access to variable in aNode. \"\r\n\r\n\tself\tcompilerEvent: #missingVariable:in:\r\n\t\twithArguments: (Array with: aNode with: self)\r\n\t\tifNotHandled: [ | unknown |\r\n\t\t\tunknown := aNode value.\r\n\t\t\t(self class bind: unknown in: self) ifFalse: [\r\n\t\t\t\tself unknownVariables add: unknown.\r\n\t\t\t\tself class unknownVariable: aNode in: self.\r\n\t\t\t]\r\n\t]","(\r\nfunction(self,aNode)\r\n(self):compilerEvent_withArguments_ifNotHandled_(\"missingVariable:in:\",(smalltalk.Array):with_with_(aNode,self),(function()\r\nlocal unknown=nil\r\n(function()\r\n\tlocal _s8_value=((aNode):value())\r\n\tunknown=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((((self)[\"$klass\"]):bind_in_(unknown,self)),nil,(function()\r\n((self):unknownVariables()):add_(unknown);return (((self)[\"$klass\"]):unknownVariable_in_(aNode,self))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"codeVisitingLocal:",0
,(
function(self,aNode)
return ((aNode):localNameIn_(self));
end
)
,"variables","codeVisitingLocal: aNode\r\n\t\" Private - Returns code to access local value. \"\r\n\r\n\t^aNode localNameIn: self","(\r\nfunction(self,aNode)\r\nreturn ((aNode):localNameIn_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"codeVisitingVariableNode:",0
,(
function(self,aNode)
local code=nil
(function()
	local _s8_value=(((self):currentClass()):codeFor_accessing_(self,aNode))
	code=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_and_((smalltalk:isNil_((code))),(function()
return ((aNode):needsVerification())
end)))==true then smalltalk:if_true_false_((((self):knownVariables()):includes_((aNode):value())),nil,(function()
return ((self):missingVariable_(aNode))
end)); end;
if (smalltalk:boolean_or_((smalltalk:isNil_((code))),(function()
return (((self):knownVariables()):includes_((aNode):value()))
end)))==true then (function()
	local _s8_value=((self):codeVisitingLocal_(aNode))
	code=_s8_value
	return _s8_value
end)(); end;
return (code);
end
)
,"variables","codeVisitingVariableNode: aNode\r\n\t\" Private - Returns code to access variable value. \"\r\n\r\n\t| code |\r\n\tcode := self currentClass codeFor: self accessing: aNode.\r\n\t(code isNil and: [aNode needsVerification]) ifTrue: [\r\n\t\t(self knownVariables includes: aNode value) ifFalse: [\r\n\t\t\tself missingVariable: aNode\r\n\t\t].\r\n\t].\r\n\t(code isNil or: [self knownVariables includes: aNode value]) ifTrue: [\r\n\t\tcode := self codeVisitingLocal: aNode\r\n\t].\r\n\t^code","(\r\nfunction(self,aNode)\r\nlocal code=nil\r\n(function()\r\n\tlocal _s8_value=(((self):currentClass()):codeFor_accessing_(self,aNode))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_and_((smalltalk:isNil_((code))),(function()\r\nreturn ((aNode):needsVerification())\r\nend)))==true then smalltalk:if_true_false_((((self):knownVariables()):includes_((aNode):value())),nil,(function()\r\nreturn ((self):missingVariable_(aNode))\r\nend)); end;\r\nif (smalltalk:boolean_or_((smalltalk:isNil_((code))),(function()\r\nreturn (((self):knownVariables()):includes_((aNode):value()))\r\nend)))==true then (function()\r\n\tlocal _s8_value=((self):codeVisitingLocal_(aNode))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (code);\r\nend\r\n)")
smalltalk:bind(smalltalk.OptimizingEncoder,"visitVariableNode:",0
,(
function(self,aNode)
(self):visitNodeIndices_doing_(aNode,(function()
return ((self):emmitCode_((self):codeVisitingVariableNode_(aNode)))
end));
return (self);
end
)
,"variables","visitVariableNode: aNode\r\n\t\" Private - Generate code to access variable aNode. \"\r\n\r\n\tself visitNodeIndices: aNode doing: [\r\n\t\tself emmitCode: (self codeVisitingVariableNode: aNode)\r\n\t]","(\r\nfunction(self,aNode)\r\n(self):visitNodeIndices_doing_(aNode,(function()\r\nreturn ((self):emmitCode_((self):codeVisitingVariableNode_(aNode)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"indentation",0
,(
function(self)
if (smalltalk:isNil_((self["@indentation"])))==true then (function()
	local _s8_value=(0)
	self["@indentation"]=_s8_value
	return _s8_value
end)(); end;
return (self["@indentation"]);
end
)
,"indentation","indentation\r\n\t\" Private - Return the indentation of the receiver. \"\r\n\r\n\tindentation isNil ifTrue: [ indentation := 0 ].\r\n\t^indentation ","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@indentation\"])))==true then (function()\r\n\tlocal _s8_value=(0)\r\n\tself[\"@indentation\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@indentation\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"indent",0
,(
function(self)
(function()
	local _s8_value=(((self):indentation()):_plus(1))
	self["@indentation"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"indentation","indent\r\n\t\" Private - Enter the next level of indentation. \"\r\n\r\n\tindentation := self indentation + 1","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=(((self):indentation()):_plus(1))\r\n\tself[\"@indentation\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"dedent",0
,(
function(self)
(function()
	local _s8_value=((((self):indentation()):_minus(1)):max_(0))
	self["@indentation"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"indentation","dedent\r\n\t\" Private - Exit the current level of indentation. \"\r\n\r\n\tindentation := self indentation - 1 max: 0","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=((((self):indentation()):_minus(1)):max_(0))\r\n\tself[\"@indentation\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"cr",0
,(
function(self)
(self["@stream"]):cr();
smalltalk:times_repeat_(((self):indentation()),(function()
return ((self):tab())
end));
return (self);
end
)
,"writing","cr\r\n\t\" Private - Emmit a new line onto output stream. \"\r\n\r\n\tstream cr.\r\n\tself indentation timesRepeat: [ self tab ]","(\r\nfunction(self)\r\n(self[\"@stream\"]):cr();\r\nsmalltalk:times_repeat_(((self):indentation()),(function()\r\nreturn ((self):tab())\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"tab",0
,(
function(self)
(self["@stream"]):tab();
return (self);
end
)
,"writing","tab\r\n\t\" Private - Emmit a tab onto output stream. \"\r\n\r\n\tstream tab","(\r\nfunction(self)\r\n(self[\"@stream\"]):tab();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"space",0
,(
function(self)
(self["@stream"]):space();
return (self);
end
)
,"writing","space\r\n\t\" Private - Emmit a space onto output stream. \"\r\n\r\n\tstream space","(\r\nfunction(self)\r\n(self[\"@stream\"]):space();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"nextPutAll:",0
,(
function(self,aString)
(self["@stream"]):nextPutAll_(aString);
return (self);
end
)
,"writing","nextPutAll: aString\r\n\t\" Private - Emmit aString onto output stream. \"\r\n\r\n\tstream nextPutAll: aString","(\r\nfunction(self,aString)\r\n(self[\"@stream\"]):nextPutAll_(aString);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"assignmentOp",0
,(
function(self)
return ("=");
end
)
,"constants","assignmentOp\r\n\t\" Private - Return the OP for encoding assignment. \"\r\n\r\n\t^$= ","(\r\nfunction(self)\r\nreturn (\"=\");\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"separatorOp",0
,(
function(self)
return (";");
end
)
,"constants","separatorOp\r\n\t\" Private - Return the OP for separating statements. \"\r\n\r\n\t^$; ","(\r\nfunction(self)\r\nreturn (\";\");\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"returnOpStart",0
,(
function(self)
return ("return ");
end
)
,"constants","returnOpStart\r\n\t\" Private - Return the OP for starting return expressions. \"\r\n\r\n\t^'return ' ","(\r\nfunction(self)\r\nreturn (\"return \");\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"returnOpEnd",0
,(
function(self)
return (nil);
end
)
,"constants","returnOpEnd\r\n\t\" Private - Return the OP for ending return expressions. \"\r\n\r\n\t^nil ","(\r\nfunction(self)\r\nreturn (nil);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"returnOps",0
,(
function(self)
return ((smalltalk.Array):with_with_((self):returnOpStart(),(self):returnOpEnd()));
end
)
,"constants","returnOps\r\n\t\" Private - Return the OPs for return expression. \"\r\n\r\n\t^Array\twith: self returnOpStart\r\n\t\twith: self returnOpEnd ","(\r\nfunction(self)\r\nreturn ((smalltalk.Array):with_with_((self):returnOpStart(),(self):returnOpEnd()));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"between:do:",0
,(
function(self,separators,aBlock)
if (smalltalk:notNil_(((separators):first())))==true then (self["@stream"]):nextPutAll_((separators):first()); end;
(aBlock):evaluate();
if (smalltalk:notNil_(((separators):last())))==true then (self["@stream"]):nextPutAll_((separators):last()); end;
return (self);
end
)
,"writing","between: separators do: aBlock\r\n\t\" Private - Emmit aBlock between separators onto output stream. \"\r\n\r\n\tseparators first notNil ifTrue: [ stream nextPutAll: separators first ].\r\n\taBlock evaluate.\r\n\tseparators last notNil ifTrue: [ stream nextPutAll: separators last ] ","(\r\nfunction(self,separators,aBlock)\r\nif (smalltalk:notNil_(((separators):first())))==true then (self[\"@stream\"]):nextPutAll_((separators):first()); end;\r\n(aBlock):evaluate();\r\nif (smalltalk:notNil_(((separators):last())))==true then (self[\"@stream\"]):nextPutAll_((separators):last()); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"nextArgumentsPut:",0
,(
function(self,aBlock)
(self):between_do_("()",aBlock);
return (self);
end
)
,"writing","nextArgumentsPut: aBlock\r\n\t\" Private - Emmit arguments list evaluating aBlock onto output stream. \"\r\n\r\n\tself between: '()' do: aBlock ","(\r\nfunction(self,aBlock)\r\n(self):between_do_(\"()\",aBlock);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"nextIndexPut:",0
,(
function(self,aBlock)
(self):between_do_("[]",aBlock);
return (self);
end
)
,"writing","nextIndexPut: aBlock\r\n\t\" Private - Emmit a series between indexing notation evaluating aBlock onto output stream. \"\r\n\r\n\tself between: '[]' do: aBlock ","(\r\nfunction(self,aBlock)\r\n(self):between_do_(\"[]\",aBlock);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"nextBlockPut:",0
,(
function(self,aBlock)
(
function(_s8_rec)
	(_s8_rec):indent();
	return ((_s8_rec):cr())
end
)(self);
(aBlock):evaluate();
(
function(_s8_rec)
	(_s8_rec):dedent();
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
)
,"writing","nextBlockPut: aBlock\r\n\t\" Private - Evaluates aBlock on the next level of indentation. \"\r\n\r\n\tself indent;cr.\r\n\taBlock evaluate.\r\n\tself dedent;cr ","(\r\nfunction(self,aBlock)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):indent();\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(aBlock):evaluate();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):dedent();\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"nextReturn:put:",0
,(
function(self,early,aBlock)
(self):between_do_((self):returnOps(),aBlock);
return (self);
end
)
,"writing","nextReturn: early put: aBlock\r\n\t\" Private - Emmit a return OP evaluating aBlock onto output stream. \"\r\n\r\n\tself between: self returnOps do: aBlock ","(\r\nfunction(self,early,aBlock)\r\n(self):between_do_((self):returnOps(),aBlock);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"emmitCode:",0
,(
function(self,code)
(self):nextPutAll_(code);
return (self);
end
)
,"generation","emmitCode: code\r\n\t\" Private - Emmit code onto output stream. \"\r\n\r\n\tself nextPutAll: code","(\r\nfunction(self,code)\r\n(self):nextPutAll_(code);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"codeToAccessProperty:in:",0
,(
function(self,aName,aNode)
return (smalltalk:object_comma_((smalltalk:object_comma_(("self[\""),aName)),"\"]"));
end
)
,"encoding","codeToAccessProperty: aName in: aNode\r\n\t\" Private - Return the source code to access property aName. \"\r\n\r\n\t^'self[\"',aName,'\"]'","(\r\nfunction(self,aName,aNode)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"self[\\\"\"),aName)),\"\\\"]\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"codeToAccessInstanceVariable:in:",0
,(
function(self,aName,aNode)
return ((self):codeToAccessProperty_in_(smalltalk:object_comma_(("@"),aName),aNode));
end
)
,"encoding","codeToAccessInstanceVariable: aName in: aNode\r\n\t\" Private - Return the source code to access instance variable aName. \"\r\n\r\n\t^self codeToAccessProperty: '@', aName in: aNode","(\r\nfunction(self,aName,aNode)\r\nreturn ((self):codeToAccessProperty_in_(smalltalk:object_comma_((\"@\"),aName),aNode));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"defaultRequirementsFor:",0
,(
function(self,aClass)
return (smalltalk:newArray({}));
end
)
,"export","defaultRequirementsFor: aClass\r\n\t\" Private - Return the default (collection of) requirements to load aClass.\r\n\tReturn an empty collection.\r\n\tThis method can be refined by subclasses.\r\n\t\"\r\n\r\n\t^#() ","(\r\nfunction(self,aClass)\r\nreturn (smalltalk:newArray({}));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"acceptAssignment:",0
,(
function(self,aNode)
return ((self):compilerEvent_with_ifNotHandled_("acceptAssignmentTo:",(aNode):left(),(function()
return (true)
end)));
end
)
,"assignment","acceptAssignment: aNode\r\n\t\" Private - Return true if assignment aNode can be accepted. \"\r\n\r\n\t^self\tcompilerEvent: #acceptAssignmentTo:\r\n\t\twith: aNode left\r\n\t\tifNotHandled: [ true ]","(\r\nfunction(self,aNode)\r\nreturn ((self):compilerEvent_with_ifNotHandled_(\"acceptAssignmentTo:\",(aNode):left(),(function()\r\nreturn (true)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"emmitFunctionStart:",0
,(
function(self,fName)
(self):nextPutAll_("function");
return (self);
end
)
,"generation","emmitFunctionStart: fName\r\n\t\" Private - Emmit the code of function start definition. \"\r\n\r\n\tself nextPutAll: #function ","(\r\nfunction(self,fName)\r\n(self):nextPutAll_(\"function\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"emmitFunctionArguments:",0
,(
function(self,argList)
(self):nextArgumentsPut_((function()
return ((self):nextPutAll_(argList))
end));
return (self);
end
)
,"generation","emmitFunctionArguments: argList\r\n\t\" Private - Emmit the code of function arguments. \"\r\n\r\n\tself nextArgumentsPut: [\r\n\t\tself nextPutAll: argList\r\n\t] ","(\r\nfunction(self,argList)\r\n(self):nextArgumentsPut_((function()\r\nreturn ((self):nextPutAll_(argList))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"emmitFunctionBody:",0
,(
function(self,aBlock)
return ((self):implementedBySubclass_("emmitFunctionBody:"));
end
)
,"generation","emmitFunctionBody: aBlock\r\n\t\" Private - Emmit the code of function body evaluating aBlock. \"\r\n\r\n\t^self implementedBySubclass: #emmitFunctionBody: ","(\r\nfunction(self,aBlock)\r\nreturn ((self):implementedBySubclass_(\"emmitFunctionBody:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"emmitFunction:arguments:doing:",0
,(
function(self,fName,argList,aBlock)
(self):compilerEvent_withArguments_ifNotHandled_("startFunction:with:",(smalltalk.Array):with_with_(fName,argList),(function()
(self):emmitFunctionStart_(fName);(self):compilerEvent_with_("startFunctionName:",fName);return ((self):emmitFunctionArguments_(argList))
end));
(self):emmitFunctionBody_((function()
(self):compilerEvent_withArguments_("startFunctionBody:with:",(smalltalk.Array):with_with_(fName,argList));return ((aBlock):evaluate())
end));
(self):compilerEvent_with_("endFunction:",fName);
return (self);
end
)
,"generation","emmitFunction: fName arguments: argList doing: aBlock\r\n\t\" Private - Emmit function on receiver's code stream. \"\r\n\r\n\tself\r\n\t\tcompilerEvent: #startFunction:with:\r\n\t\twithArguments: (Array with: fName with: argList)\r\n\t\tifNotHandled: [\r\n\t\t\tself emmitFunctionStart: fName.\r\n\t\t\tself compilerEvent: #startFunctionName: with: fName.\r\n\t\t\tself emmitFunctionArguments: argList\r\n\t\t].\r\n\tself emmitFunctionBody: [\r\n\t\tself\tcompilerEvent: #startFunctionBody:with:\r\n\t\t\twithArguments: (Array with: fName with: argList).\r\n\t\taBlock evaluate\r\n\t].\r\n\tself compilerEvent: #endFunction: with: fName.","(\r\nfunction(self,fName,argList,aBlock)\r\n(self):compilerEvent_withArguments_ifNotHandled_(\"startFunction:with:\",(smalltalk.Array):with_with_(fName,argList),(function()\r\n(self):emmitFunctionStart_(fName);(self):compilerEvent_with_(\"startFunctionName:\",fName);return ((self):emmitFunctionArguments_(argList))\r\nend));\r\n(self):emmitFunctionBody_((function()\r\n(self):compilerEvent_withArguments_(\"startFunctionBody:with:\",(smalltalk.Array):with_with_(fName,argList));return ((aBlock):evaluate())\r\nend));\r\n(self):compilerEvent_with_(\"endFunction:\",fName);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"emmitFunction:node:doing:",0
,(
function(self,fName,aNode,aBlock)
return ((self):emmitFunction_node_arguments_doing_(fName,aNode,(aNode):argumentNames(),aBlock));
end
)
,"generation","emmitFunction: fName node: aNode doing: aBlock\r\n\t\" Private - Generate function for aNode. \"\r\n\r\n\t^self\temmitFunction: fName\r\n\t\tnode: aNode arguments: aNode argumentNames\r\n\t\tdoing: aBlock","(\r\nfunction(self,fName,aNode,aBlock)\r\nreturn ((self):emmitFunction_node_arguments_doing_(fName,aNode,(aNode):argumentNames(),aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"emmitFunctionDoing:",0
,(
function(self,aBlock)
return ((self):emmitFunction_arguments_doing_("","",aBlock));
end
)
,"generation","emmitFunctionDoing: aBlock\r\n\t\" Private - Emmit function on receiver's code stream. \"\r\n\r\n\t^self emmitFunction: '' arguments: '' doing: aBlock","(\r\nfunction(self,aBlock)\r\nreturn ((self):emmitFunction_arguments_doing_(\"\",\"\",aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"emmitReturn:early:",0
,(
function(self,aBlockOrString,early)
(self):compilerEvent_with_("aboutReturn:",aBlockOrString);
(self):nextReturn_put_(early,(function()
(self):compilerEvent_with_("return:",aBlockOrString);return (smalltalk:if_true_false_(((aBlockOrString):isString()),(function()
return ((self):nextPutAll_(aBlockOrString))
end),(function()
return ((aBlockOrString):evaluate())
end)))
end));
if (smalltalk:notNil_((aBlockOrString)))==true then (self):compilerEvent_withArguments_("returned:early:",(smalltalk.Array):with_with_(aBlockOrString,early)); end;
return (self);
end
)
,"generation","emmitReturn: aBlockOrString early: early\r\n\t\" Private - Generate return code. \"\r\n\r\n\tself compilerEvent: #aboutReturn: with: aBlockOrString.\r\n\tself nextReturn: early put: [\r\n\t\tself compilerEvent: #return: with: aBlockOrString.\r\n\t\taBlockOrString isString\r\n\t\t\tifTrue: [ self nextPutAll: aBlockOrString ]\r\n\t\t\tifFalse: [ aBlockOrString evaluate ]\r\n\t].\r\n\taBlockOrString notNil ifTrue: [\r\n\t\tself\tcompilerEvent: #returned:early:\r\n\t\t\twithArguments: (Array with: aBlockOrString with: early).\r\n\t].","(\r\nfunction(self,aBlockOrString,early)\r\n(self):compilerEvent_with_(\"aboutReturn:\",aBlockOrString);\r\n(self):nextReturn_put_(early,(function()\r\n(self):compilerEvent_with_(\"return:\",aBlockOrString);return (smalltalk:if_true_false_(((aBlockOrString):isString()),(function()\r\nreturn ((self):nextPutAll_(aBlockOrString))\r\nend),(function()\r\nreturn ((aBlockOrString):evaluate())\r\nend)))\r\nend));\r\nif (smalltalk:notNil_((aBlockOrString)))==true then (self):compilerEvent_withArguments_(\"returned:early:\",(smalltalk.Array):with_with_(aBlockOrString,early)); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"emmitReturn:",0
,(
function(self,aBlockOrString)
return ((self):emmitReturn_early_(aBlockOrString,false));
end
)
,"generation","emmitReturn: aBlockOrString\r\n\t\" Private - Generate return code. \"\r\n\r\n\t^self emmitReturn: aBlockOrString early: false","(\r\nfunction(self,aBlockOrString)\r\nreturn ((self):emmitReturn_early_(aBlockOrString,false));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"defaultOptimizations",0
,(
function(self)
return (smalltalk:newArray({"s8"}));
end
)
,"defaults","defaultOptimizations\r\n\t\" Private - Return the default optimizations of the receiver.\r\n\tNote that returned optimizations MUST be provided by the subclasses. \"\r\n\r\n\t^#( s8 \"magnitude math\" )","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"s8\"}));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"emmitedCode",0
,(
function(self)
return (smalltalk:if_true_false_((smalltalk:notNil_((self["@stream"]))),(function()
return ((self["@stream"]):contents())
end),nil));
end
)
,"results","emmitedCode\r\n\t\" Return the emmited code during compilation (or nil). \"\r\n\r\n\t^stream notNil ifTrue: [ stream contents ]","(\r\nfunction(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((self[\"@stream\"]))),(function()\r\nreturn ((self[\"@stream\"]):contents())\r\nend),nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"arrayLiteralStart",0
,(
function(self)
return ("[");
end
)
,"literals","arrayLiteralStart\r\n\t\" Private - Return the code string to start exporting an array literal. \"\r\n\r\n\t^$[","(\r\nfunction(self)\r\nreturn (\"[\");\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"arrayLiteralEnd",0
,(
function(self)
return ("]");
end
)
,"literals","arrayLiteralEnd\r\n\t\" Private - Return the code string to end exporting an array literal. \"\r\n\r\n\t^$]","(\r\nfunction(self)\r\nreturn (\"]\");\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"escaped:",0
,(
function(self,string)
return ((string):escapedCode());
end
)
,"literals","escaped: string\r\n\t\" Private - Return the code string to export string literal. \"\r\n\r\n\t^string escapedCode","(\r\nfunction(self,string)\r\nreturn ((string):escapedCode());\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"nativeSourceFor:",0
,(
function(self,aMethod)
return ((aMethod):compiledSource());
end
)
,"private","nativeSourceFor: aMethod\r\n\t\" Private - Return the code of native function implementing aMethod. \"\r\n\r\n\t^aMethod compiledSource","(\r\nfunction(self,aMethod)\r\nreturn ((aMethod):compiledSource());\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"emmitMethodContents:",0
,(
function(self,aNode)
local code=nil
local delta=nil
(function()
	local _s8_value=((self):generatedCodeFor_while_(aNode,(function()
(self):compilerEvent_withArguments_ifNotHandled_("enterMethod:",(smalltalk.Array):with_(aNode),(function()
return ((self):emmitEnterMethod_(aNode))
end));return (((aNode):nodes()):do_((function(each)
return ((self):visit_(each))
end)))
end)))
	code=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):generate_early_return_(self["@functionName"],self["@earlyReturn"],code))
	delta=_s8_value
	return _s8_value
end)();
(self):translate_by_(aNode,delta);
return (self);
end
)
,"generation","emmitMethodContents: aNode\r\n\t\" Private - Generate code for contents of method aNode. \"\r\n\r\n\t| code delta |\r\n\tcode := self generatedCodeFor: aNode while: [\r\n\t\tself compilerEvent: #enterMethod: withArguments: (Array with: aNode)\r\n\t\t\tifNotHandled: [ self emmitEnterMethod: aNode ].\r\n\t\taNode nodes do: [:each | self visit: each ].\r\n\t].\r\n\tdelta := self generate: functionName early: earlyReturn return: code.\r\n\tself translate: aNode by: delta.","(\r\nfunction(self,aNode)\r\nlocal code=nil\r\nlocal delta=nil\r\n(function()\r\n\tlocal _s8_value=((self):generatedCodeFor_while_(aNode,(function()\r\n(self):compilerEvent_withArguments_ifNotHandled_(\"enterMethod:\",(smalltalk.Array):with_(aNode),(function()\r\nreturn ((self):emmitEnterMethod_(aNode))\r\nend));return (((aNode):nodes()):do_((function(each)\r\nreturn ((self):visit_(each))\r\nend)))\r\nend)))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):generate_early_return_(self[\"@functionName\"],self[\"@earlyReturn\"],code))\r\n\tdelta=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):translate_by_(aNode,delta);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"emmitMethod:",0
,(
function(self,aNode)
(function()
	local _s8_value=(0)
	self["@nestedBlocks"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(false)
	self["@earlyReturn"]=_s8_value
	return _s8_value
end)();
((self):compiler()):resetVariables();
(function()
	local _s8_value=((self):asSelector_((aNode):selector()))
	self["@functionName"]=_s8_value
	return _s8_value
end)();
(aNode):validateArguments();
(self):emmitFunction_node_doing_(self["@functionName"],aNode,(function()
(self):compilerEvent_with_("startMethod:",aNode);(self):emmitMethodContents_(aNode);return ((self):compilerEvent_with_("endMethod:",aNode))
end));
return (self);
end
)
,"generation","emmitMethod: aNode\r\n\t\" Private - Generate code of method aNode. \"\r\n\r\n\tnestedBlocks := 0.\r\n\tearlyReturn := false.\r\n\tself compiler resetVariables.\r\n\r\n\tfunctionName := self asSelector: aNode selector.\r\n\taNode validateArguments.\r\n\tself emmitFunction: functionName node: aNode doing: [\r\n\t\tself compilerEvent: #startMethod: with: aNode.\r\n\t\tself emmitMethodContents: aNode.\r\n\t\tself compilerEvent: #endMethod: with: aNode.\r\n\t]","(\r\nfunction(self,aNode)\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tself[\"@nestedBlocks\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(false)\r\n\tself[\"@earlyReturn\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):compiler()):resetVariables();\r\n(function()\r\n\tlocal _s8_value=((self):asSelector_((aNode):selector()))\r\n\tself[\"@functionName\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aNode):validateArguments();\r\n(self):emmitFunction_node_doing_(self[\"@functionName\"],aNode,(function()\r\n(self):compilerEvent_with_(\"startMethod:\",aNode);(self):emmitMethodContents_(aNode);return ((self):compilerEvent_with_(\"endMethod:\",aNode))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"saveState",0
,(
function(self)
return ((smalltalk.Array):with_with_with_(self["@stream"],self["@startOffset"],(self):indentation()));
end
)
,"state","saveState\r\n\t\" Private - Return the state of the receiver. \"\r\n\r\n\t^Array\twith: stream\r\n\t\twith: startOffset\r\n\t\twith: self indentation ","(\r\nfunction(self)\r\nreturn ((smalltalk.Array):with_with_with_(self[\"@stream\"],self[\"@startOffset\"],(self):indentation()));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"restoreState:",0
,(
function(self,array)
(function()
	local _s8_value=((array):first())
	self["@stream"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((array):second())
	self["@startOffset"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((array):third())
	self["@indentation"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"state","restoreState: array\r\n\t\" Private - Restore the state of the receiver. \"\r\n\r\n\tstream := array first.\r\n\tstartOffset := array second.\r\n\tindentation := array third. ","(\r\nfunction(self,array)\r\n(function()\r\n\tlocal _s8_value=((array):first())\r\n\tself[\"@stream\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((array):second())\r\n\tself[\"@startOffset\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((array):third())\r\n\tself[\"@indentation\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"generatedCodeFor:while:",0
,(
function(self,aNode,aBlock)
local backup=nil
local result=nil
(function()
	local _s8_value=((self):saveState())
	backup=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self["@stream"]):position())
	self["@startOffset"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((""):writeStream())
	self["@stream"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(0)
	self["@indentation"]=_s8_value
	return _s8_value
end)();
(self):visit_doing_(aNode,aBlock);
(function()
	local _s8_value=((self["@stream"]):contents())
	result=_s8_value
	return _s8_value
end)();
(self):restoreState_(backup);
return (result);
end
)
,"generation","generatedCodeFor: aNode while: aBlock\r\n\t\" Private - Return the code generated during evaluation of aBlock. \"\r\n\r\n\t| backup result |\r\n\tbackup := self saveState.\r\n\tstartOffset := stream position.\r\n\tstream := '' writeStream.\r\n\tindentation := 0.\r\n\tself visit: aNode doing: aBlock.\r\n\tresult := stream contents.\r\n\tself restoreState: backup.\r\n\t^result ","(\r\nfunction(self,aNode,aBlock)\r\nlocal backup=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):saveState())\r\n\tbackup=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self[\"@stream\"]):position())\r\n\tself[\"@startOffset\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tself[\"@stream\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tself[\"@indentation\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):visit_doing_(aNode,aBlock);\r\n(function()\r\n\tlocal _s8_value=((self[\"@stream\"]):contents())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):restoreState_(backup);\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"includeSourceCode",0
,(
function(self)
return (true);
end
)
,"generation","includeSourceCode\r\n\t\" Private - Return true if source code is included as method argument. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"isOperation:",0
,(
function(self,aNode)
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((((aNode):arguments()):size()),1)),(function()
return (smalltalk:boolean_and_((((((aNode):selector()):size()) > 1)),(function()
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((((aNode):selector()):first()),"#")),(function()
return (("|&\\\\+*/=><,@%~-"):includes_(((aNode):selector()):at_(2)))
end)))
end)))
end)));
end
)
,"operations","isOperation: aNode\r\n\t\" Private - Return true if aNode is an operation. \"\r\n\r\n\t^aNode arguments size = 1 and: [\r\n\t\taNode selector size > 1 and: [\r\n\t\taNode selector first = $# and: [\r\n\t\t'|&\\\\+*/=><,@%~-' includes: (aNode selector at: 2)\r\n\t\t]]]","(\r\nfunction(self,aNode)\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((((aNode):arguments()):size()),1)),(function()\r\nreturn (smalltalk:boolean_and_((((((aNode):selector()):size()) > 1)),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((((aNode):selector()):first()),\"#\")),(function()\r\nreturn ((\"|&\\\\\\\\+*/=><,@%~-\"):includes_(((aNode):selector()):at_(2)))\r\nend)))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"loadRequirementsOf:",0
,(
function(self,aClass)
local requirements=nil
(function()
	local _s8_value=((self):defaultRequirementsFor_(aClass))
	requirements=_s8_value
	return _s8_value
end)();
(aClass):loadRequirementsInto_for_(requirements,self);
return (requirements);
end
)
,"export","loadRequirementsOf: aClass\r\n\t\" Private - Return the requirements to load aClass.\r\n\tIt must be a collection of requirements.\r\n\taRequirement must implement #fileOutOn: or must be aString(native code) to execute just before defining aClass.\r\n\t\"\r\n\r\n\t| requirements |\r\n\trequirements := self defaultRequirementsFor: aClass.\r\n\taClass loadRequirementsInto: requirements for: self.\r\n\t^requirements","(\r\nfunction(self,aClass)\r\nlocal requirements=nil\r\n(function()\r\n\tlocal _s8_value=((self):defaultRequirementsFor_(aClass))\r\n\trequirements=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aClass):loadRequirementsInto_for_(requirements,self);\r\nreturn (requirements);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"position",0
,(
function(self)
return (((self["@stream"]):position()):_plus(self["@startOffset"]));
end
)
,"accessing","position\r\n\t\" Return the current position in output stream. \"\r\n\r\n\t^stream position + startOffset","(\r\nfunction(self)\r\nreturn (((self[\"@stream\"]):position()):_plus(self[\"@startOffset\"]));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"startCompiling:",0
,(
function(self,aNode)
smalltalk:superImplementor(smalltalk.NativeEncoder,"startCompiling_")(self,aNode);
(function()
	local _s8_value=((""):writeStream())
	self["@stream"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self["@stream"]):position())
	self["@startOffset"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(nil)
	self["@indentation"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"private","startCompiling: aNode\r\n\t\" Private - Set the receiver to start emmiting code for aNode. \"\r\n\r\n\tsuper startCompiling: aNode.\r\n\tstream := '' writeStream.\r\n\tstartOffset := stream position.\r\n\tindentation := nil. ","(\r\nfunction(self,aNode)\r\nsmalltalk:superImplementor(smalltalk.NativeEncoder,\"startCompiling_\")(self,aNode);\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tself[\"@stream\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self[\"@stream\"]):position())\r\n\tself[\"@startOffset\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@indentation\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"stream",0
,(
function(self)
return (self["@stream"]);
end
)
,"accessing","stream\r\n\t\" Return the current stream (or nil). \"\r\n\r\n\t^stream","(\r\nfunction(self)\r\nreturn (self[\"@stream\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visit:",0
,(
function(self,aNode)
return ((self):visit_doing_(aNode,(function()
return (smalltalk:superImplementor(smalltalk.NativeEncoder,"visit_")(self,aNode))
end)));
end
)
,"visiting","visit: aNode\r\n\t^self visit: aNode doing: [ super visit: aNode ]","(\r\nfunction(self,aNode)\r\nreturn ((self):visit_doing_(aNode,(function()\r\nreturn (smalltalk:superImplementor(smalltalk.NativeEncoder,\"visit_\")(self,aNode))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visit:doing:",0
,(
function(self,aNode,aBlock)
local cookie=nil
local result=nil
(function()
	local _s8_value=((self):compilerEvent_with_ifNotHandled_("needsCookie:",aNode,(function()
return (nil)
end)))
	cookie=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((cookie)))==true then (self):compilerEvent_with_("startVisit:",cookie); end;
(function()
	local _s8_value=((aBlock):evaluate())
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((cookie)))==true then (self):compilerEvent_with_("endVisit:",cookie); end;
return (result);
end
)
,"visiting","visit: aNode doing: aBlock\r\n\t| cookie result |\r\n\tcookie := self\r\n\t\tcompilerEvent: #needsCookie: with: aNode\r\n\t\tifNotHandled: [ nil ].\r\n\tcookie notNil ifTrue: [ self compilerEvent: #startVisit: with: cookie ].\r\n\tresult := aBlock evaluate.\r\n\tcookie notNil ifTrue: [ self compilerEvent: #endVisit: with: cookie ].\r\n\t^result","(\r\nfunction(self,aNode,aBlock)\r\nlocal cookie=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):compilerEvent_with_ifNotHandled_(\"needsCookie:\",aNode,(function()\r\nreturn (nil)\r\nend)))\r\n\tcookie=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((cookie)))==true then (self):compilerEvent_with_(\"startVisit:\",cookie); end;\r\n(function()\r\n\tlocal _s8_value=((aBlock):evaluate())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((cookie)))==true then (self):compilerEvent_with_(\"endVisit:\",cookie); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitArgument:",0
,(
function(self,aNode)
if ((aNode):isAssignment())==true then return ((self):visitLocalAssignment_(aNode)); end;
return ((self):visit_(aNode));
end
)
,"visiting","visitArgument: aNode\r\n\t\" Private - Visit the argument emmitting output. \"\r\n\r\n\taNode isAssignment ifTrue: [ ^self visitLocalAssignment: aNode ].\r\n\t^self visit: aNode","(\r\nfunction(self,aNode)\r\nif ((aNode):isAssignment())==true then return ((self):visitLocalAssignment_(aNode)); end;\r\nreturn ((self):visit_(aNode));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"emmitAssignment:",0
,(
function(self,aNode)
(
function(_s8_rec)
	(_s8_rec):visit_((aNode):left());
	(_s8_rec):nextPutAll_((self):assignmentOp());
	return ((_s8_rec):visit_((aNode):right()))
end
)(self);
return (self);
end
)
,"generation","emmitAssignment: aNode\r\n\t\" Private - Emmit the code for assignment. \"\r\n\r\n\tself\r\n\t\tvisit: aNode left;\r\n\t\tnextPutAll: self assignmentOp;\r\n\t\tvisit: aNode right","(\r\nfunction(self,aNode)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):visit_((aNode):left());\r\n\t(_s8_rec):nextPutAll_((self):assignmentOp());\r\n\treturn ((_s8_rec):visit_((aNode):right()))\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitAssignmentNode:",0
,(
function(self,aNode)
if ((self):visitMacroAssignment_(aNode))==true then return (self); end;
if ((self):acceptAssignment_(aNode))==true then (self):emmitAssignment_(aNode); else (self):compilerEvent_with_ifNotHandled_("invalidAssignment:",aNode,(function()
return ((self):error_(smalltalk:object_comma_(("Invalid assignment to "),((aNode):left()):value())))
end)); end;
return (self);
end
)
,"visiting","visitAssignmentNode: aNode\r\n\r\n\t(self visitMacroAssignment: aNode) ifTrue: [ ^self ].\r\n\t(self acceptAssignment: aNode) ifTrue: [\r\n\t\tself emmitAssignment: aNode\r\n\t] ifFalse: [\r\n\t\tself\tcompilerEvent: #invalidAssignment: with: aNode\r\n\t\t\tifNotHandled: [ self error: 'Invalid assignment to ' ,aNode left value ]\r\n\t]","(\r\nfunction(self,aNode)\r\nif ((self):visitMacroAssignment_(aNode))==true then return (self); end;\r\nif ((self):acceptAssignment_(aNode))==true then (self):emmitAssignment_(aNode); else (self):compilerEvent_with_ifNotHandled_(\"invalidAssignment:\",aNode,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Invalid assignment to \"),((aNode):left()):value())))\r\nend)); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitNode:in:cr:",0
,(
function(self,aNode,aParentNode,withCr)
if (smalltalk:notNil_(((self):visit_(aNode))))==true then (self):nextPutAll_((self):separatorOp());
smalltalk:if_true_false_((withCr),(function()
return ((self):cr())
end),nil); end;
return (self);
end
)
,"visiting","visitNode: aNode in: aParentNode cr: withCr\r\n\t\" Private - Visit aNode as part of sequence in aParentNode. \"\r\n\r\n\t(self visit: aNode) notNil ifTrue: [\r\n\t\tself nextPutAll: self separatorOp.\r\n\t\twithCr ifTrue: [ self cr ].\r\n\t]","(\r\nfunction(self,aNode,aParentNode,withCr)\r\nif (smalltalk:notNil_(((self):visit_(aNode))))==true then (self):nextPutAll_((self):separatorOp());\r\nsmalltalk:if_true_false_((withCr),(function()\r\nreturn ((self):cr())\r\nend),nil); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitEmptyNode:",0
,(
function(self,aNode)
return (self);
end
)
,"visiting","visitEmptyNode: aNode\r\n\t\" Private - Visit an empty node, aNode. \" ","(\r\nfunction(self,aNode)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitNodesIn:cr:",0
,(
function(self,aNode,withCr)
local array=nil
(function()
	local _s8_value=((aNode):nodes())
	array=_s8_value
	return _s8_value
end)();
if ((array):isEmpty())==true then return ((self):visitEmptyNode_(aNode)); end;
(array):do_separatedBy_((function(one)
return ((self):visitNode_in_cr_(one,aNode,false))
end),(function()
return (smalltalk:if_true_false_((withCr),(function()
return ((self):cr())
end),nil))
end));
return (self);
end
)
,"visiting","visitNodesIn: aNode cr: withCr\r\n\t\" Private - Visit the nodes contained in aNode. \"\r\n\r\n\t| array |\r\n\tarray := aNode nodes.\r\n\tarray isEmpty ifTrue: [ ^self visitEmptyNode: aNode ].\r\n\tarray do: [:one|\r\n\t\tself visitNode: one in: aNode cr: false\r\n\t] separatedBy: [ withCr ifTrue: [ self cr ] ]","(\r\nfunction(self,aNode,withCr)\r\nlocal array=nil\r\n(function()\r\n\tlocal _s8_value=((aNode):nodes())\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((array):isEmpty())==true then return ((self):visitEmptyNode_(aNode)); end;\r\n(array):do_separatedBy_((function(one)\r\nreturn ((self):visitNode_in_cr_(one,aNode,false))\r\nend),(function()\r\nreturn (smalltalk:if_true_false_((withCr),(function()\r\nreturn ((self):cr())\r\nend),nil))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitArgMacro:in:with:",0
,(
function(self,macro,input,aNode)
if (smalltalk:isObject_equalTo_((macro),"argList"))==true then return ((self):visitArguments_((aNode):arguments())); end;
return (smalltalk:superImplementor(smalltalk.NativeEncoder,"visitArgMacro_in_with_")(self,macro,input,aNode));
end
)
,"optimizing","visitArgMacro: macro in: input with: aNode\r\n\t\" Private - Visit argument macro in input. \"\r\n\r\n\tmacro = #argList ifTrue: [\r\n\t\t^self visitArguments: aNode arguments\r\n\t].\r\n\t^super visitArgMacro: macro in: input with: aNode","(\r\nfunction(self,macro,input,aNode)\r\nif (smalltalk:isObject_equalTo_((macro),\"argList\"))==true then return ((self):visitArguments_((aNode):arguments())); end;\r\nreturn (smalltalk:superImplementor(smalltalk.NativeEncoder,\"visitArgMacro_in_with_\")(self,macro,input,aNode));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"defineTemporary:",0
,(
function(self,aName)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(("var "),(self):localName_(aName))),"=nil;"));
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
)
,"encoding","defineTemporary: aName\r\n\t\" Private - Return the code for defining temporary variable with aName. \"\r\n\r\n\tself nextPutAll: 'var ' ,(self localName: aName) ,'=nil;' ;cr ","(\r\nfunction(self,aName)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\"var \"),(self):localName_(aName))),\"=nil;\"));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"withNodesIn:do:atEnd:",0
,(
function(self,aNode,aBlock,endBlock)
local array=nil
(function()
	local _s8_value=(((aNode):nodes()):asArray())
	array=_s8_value
	return _s8_value
end)();
(1):to_do_(((array):size()):_minus(1),(function(index)
return ((aBlock):evaluateWith_((array):at_(index)))
end));
return ((endBlock):evaluateWith_(smalltalk:if_true_false_(((array):notEmpty()),(function()
return ((array):last())
end),nil)));
end
)
,"visiting","withNodesIn: aNode do: aBlock atEnd: endBlock\r\n\t\" Evaluates aBlock for nodes in aNode (without last).\r\n\tReturn the result of evaluating lastBlock with the last node in aNode (or nil).\r\n\t\"\r\n\r\n\t| array |\r\n\tarray := aNode nodes asArray.\r\n\t1 to: array size - 1 do: [:index|\r\n\t\taBlock evaluateWith: (array at: index)\r\n\t].\r\n\t^endBlock evaluateWith: (array notEmpty ifTrue: [ array last ]) ","(\r\nfunction(self,aNode,aBlock,endBlock)\r\nlocal array=nil\r\n(function()\r\n\tlocal _s8_value=(((aNode):nodes()):asArray())\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(1):to_do_(((array):size()):_minus(1),(function(index)\r\nreturn ((aBlock):evaluateWith_((array):at_(index)))\r\nend));\r\nreturn ((endBlock):evaluateWith_(smalltalk:if_true_false_(((array):notEmpty()),(function()\r\nreturn ((array):last())\r\nend),nil)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitTemporaries:",0
,(
function(self,aNode)
((aNode):tempNames()):do_((function(aName)
((self):tempVariables()):add_(aName);return ((self):defineTemporary_(aName))
end));
return (self);
end
)
,"visiting","visitTemporaries: aNode\r\n\t\" Private - Emmit code for local variables in aNode. \"\r\n\r\n\taNode tempNames do: [:aName |\r\n\t\tself tempVariables add: aName.\r\n\t\tself defineTemporary: aName\r\n\t] ","(\r\nfunction(self,aNode)\r\n((aNode):tempNames()):do_((function(aName)\r\n((self):tempVariables()):add_(aName);return ((self):defineTemporary_(aName))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"startSequence:",0
,(
function(self,aNode)
return (self);
end
)
,"contexts","startSequence: aNode\r\n\t\" Private - Prepare context for sequence aNode. \" ","(\r\nfunction(self,aNode)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"endSequence:",0
,(
function(self,aNode)
return (self);
end
)
,"contexts","endSequence: aNode\r\n\t\" Private - Leave context for sequence aNode. \" ","(\r\nfunction(self,aNode)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"sequenceSpace:",0
,(
function(self,aNode)
return (self);
end
)
,"contexts","sequenceSpace: aNode\r\n\t\" Private - aNode has been visited in a sequence. \" ","(\r\nfunction(self,aNode)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"sequenceExit:",0
,(
function(self,aNode)
(self):emmitReturn_((function()
return ((self):visit_(aNode))
end));
return (self);
end
)
,"contexts","sequenceExit: aNode\r\n\t\" Private - A block sequence is exiting with aNode. \"\r\n\r\n\tself emmitReturn: [ self visit: aNode ] ","(\r\nfunction(self,aNode)\r\n(self):emmitReturn_((function()\r\nreturn ((self):visit_(aNode))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitBlockSequenceNode:",0
,(
function(self,aNode)
(function()
	local _s8_value=((self["@nestedBlocks"]):_plus(1))
	self["@nestedBlocks"]=_s8_value
	return _s8_value
end)();
if (((aNode):nodes()):isEmpty())==true then (self):emmitReturn_("nil"); else (
function(_s8_rec)
	(_s8_rec):startSequence_(aNode);
	(_s8_rec):visitTemporaries_(aNode);
	(_s8_rec):withNodesIn_do_atEnd_(aNode,(function(each)
(self):visitNode_in_cr_(each,aNode,false);return ((self):sequenceSpace_(each))
end),(function(last)
return ((self):sequenceExit_(last))
end));
	return ((_s8_rec):endSequence_(aNode))
end
)(self); end;
(function()
	local _s8_value=((self["@nestedBlocks"]):_minus(1))
	self["@nestedBlocks"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"visiting","visitBlockSequenceNode: aNode\r\n\t\" Private - Visit the block sequence emmitting output. \"\r\n\r\n\tnestedBlocks := nestedBlocks + 1.\r\n\taNode nodes isEmpty\r\n\tifTrue: [ self emmitReturn: #nil ]\r\n\tifFalse: [\r\n\t\tself\tstartSequence: aNode;\r\n\t\t\tvisitTemporaries: aNode;\r\n\t\t\twithNodesIn: aNode do: [:each|\r\n\t\t\t\tself visitNode: each in: aNode cr: false.\r\n\t\t\t\tself sequenceSpace: each\r\n\t\t\t] atEnd: [:last| self sequenceExit: last ];\r\n\t\t\tendSequence: aNode.\r\n\t].\r\n\tnestedBlocks := nestedBlocks - 1 ","(\r\nfunction(self,aNode)\r\n(function()\r\n\tlocal _s8_value=((self[\"@nestedBlocks\"]):_plus(1))\r\n\tself[\"@nestedBlocks\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (((aNode):nodes()):isEmpty())==true then (self):emmitReturn_(\"nil\"); else (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):startSequence_(aNode);\r\n\t(_s8_rec):visitTemporaries_(aNode);\r\n\t(_s8_rec):withNodesIn_do_atEnd_(aNode,(function(each)\r\n(self):visitNode_in_cr_(each,aNode,false);return ((self):sequenceSpace_(each))\r\nend),(function(last)\r\nreturn ((self):sequenceExit_(last))\r\nend));\r\n\treturn ((_s8_rec):endSequence_(aNode))\r\nend\r\n)(self); end;\r\n(function()\r\n\tlocal _s8_value=((self[\"@nestedBlocks\"]):_minus(1))\r\n\tself[\"@nestedBlocks\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitSequenceNode:",0
,(
function(self,aNode)
(
function(_s8_rec)
	(_s8_rec):startSequence_(aNode);
	(_s8_rec):visitTemporaries_(aNode);
	(_s8_rec):visitNodesIn_cr_(aNode,true);
	return ((_s8_rec):endSequence_(aNode))
end
)(self);
return (self);
end
)
,"visiting","visitSequenceNode: aNode\r\n\t\" Private - Visit the sequence emmitting output. \"\r\n\r\n\tself\tstartSequence: aNode;\r\n\t\tvisitTemporaries: aNode;\r\n\t\tvisitNodesIn: aNode cr: true;\r\n\t\tendSequence: aNode. ","(\r\nfunction(self,aNode)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):startSequence_(aNode);\r\n\t(_s8_rec):visitTemporaries_(aNode);\r\n\t(_s8_rec):visitNodesIn_cr_(aNode,true);\r\n\treturn ((_s8_rec):endSequence_(aNode))\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitExtendedSequenceNode:",0
,(
function(self,aNode)
((aNode):directives()):do_((function(each)
return ((self):visitDirectiveNode_(each))
end));
return ((self):visitSequenceNode_(aNode));
end
)
,"visiting","visitExtendedSequenceNode: aNode\r\n\t\" Private - Visit an extended sequence node. \"\r\n\r\n\taNode directives do: [:each|\r\n\t\tself visitDirectiveNode: each\r\n\t].\r\n\t^self visitSequenceNode: aNode","(\r\nfunction(self,aNode)\r\n((aNode):directives()):do_((function(each)\r\nreturn ((self):visitDirectiveNode_(each))\r\nend));\r\nreturn ((self):visitSequenceNode_(aNode));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitMacroAssignment:",0
,(
function(self,aNode)
return (((aNode):left()):acceptMacroAssignment_with_((aNode):right(),self));
end
)
,"visiting","visitMacroAssignment: aNode\r\n\t^aNode left acceptMacroAssignment: aNode right with: self","(\r\nfunction(self,aNode)\r\nreturn (((aNode):left()):acceptMacroAssignment_with_((aNode):right(),self));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitMacroAssignment:to:",0
,(
function(self,aVariableNode,anExpressionNode)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local aName=nil
local aClass=nil
if (((aVariableNode):indices()):notEmpty())==true then return (false); end;
(function()
	local _s8_value=((aVariableNode):value())
	aName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((self):currentClass()):instanceClass())
	aClass=_s8_value
	return _s8_value
end)();
(aClass):classVariableNamesDo_((function(each)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((each),aName)),(function()
(self):visitClassVariableAssignment_in_to_(each,aClass,anExpressionNode);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(aClass):sharedPoolsAndNamesDo_((function(poolName,pool)
return (smalltalk:if_true_false_(((pool):includesKey_(aName)),(function()
(self):visitPoolVariableAssignment_in_to_(aName,poolName,anExpressionNode);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"visiting","visitMacroAssignment: aVariableNode to: anExpressionNode\r\n\t\" Return true if the receiver generated code to a macro assignment to aVariableNode. \"\r\n\r\n\t| aName aClass |\r\n\taVariableNode indices notEmpty ifTrue: [ ^false ].\r\n\taName := aVariableNode value.\r\n\taClass := self currentClass instanceClass.\r\n\taClass classVariableNamesDo: [:each|\r\n\t\teach = aName ifTrue: [\r\n\t\t\tself visitClassVariableAssignment: each\r\n\t\t\t\tin: aClass\r\n\t\t\t\tto: anExpressionNode.\r\n\t\t\t^true\r\n\t\t]\r\n\t].\r\n\taClass sharedPoolsAndNamesDo: [:poolName :pool|\r\n\t\t(pool includesKey: aName) ifTrue: [\r\n\t\t\tself visitPoolVariableAssignment: aName\r\n\t\t\t\tin: poolName\r\n\t\t\t\tto: anExpressionNode.\r\n\t\t\t^true\r\n\t\t].\r\n\t].\r\n\t^false","(\r\nfunction(self,aVariableNode,anExpressionNode)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal aName=nil\r\nlocal aClass=nil\r\nif (((aVariableNode):indices()):notEmpty())==true then return (false); end;\r\n(function()\r\n\tlocal _s8_value=((aVariableNode):value())\r\n\taName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((self):currentClass()):instanceClass())\r\n\taClass=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aClass):classVariableNamesDo_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((each),aName)),(function()\r\n(self):visitClassVariableAssignment_in_to_(each,aClass,anExpressionNode);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(aClass):sharedPoolsAndNamesDo_((function(poolName,pool)\r\nreturn (smalltalk:if_true_false_(((pool):includesKey_(aName)),(function()\r\n(self):visitPoolVariableAssignment_in_to_(aName,poolName,anExpressionNode);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitReceiver:",0
,(
function(self,aNode)
if ((aNode):isAssignment())==true then return ((self):visitLocalAssignment_(aNode)); end;
return ((self):visit_(aNode));
end
)
,"visiting","visitReceiver: aNode\r\n\t\" Private - Visit the node (as receiver) emmitting output. \"\r\n\r\n\taNode isAssignment ifTrue: [ ^self visitLocalAssignment: aNode. ].\r\n\t^self visit: aNode","(\r\nfunction(self,aNode)\r\nif ((aNode):isAssignment())==true then return ((self):visitLocalAssignment_(aNode)); end;\r\nreturn ((self):visit_(aNode));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitLocalAssignment:",0
,(
function(self,aNode)
(self):nextArgumentsPut_((function()
return ((self):visit_(aNode))
end));
return (self);
end
)
,"visiting","visitLocalAssignment: aNode\r\n\t\" Private - Visit a node that is an assignment in a local expression. \"\r\n\r\n\tself nextArgumentsPut: [ self visit: aNode ] ","(\r\nfunction(self,aNode)\r\n(self):nextArgumentsPut_((function()\r\nreturn ((self):visit_(aNode))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitArguments:",0
,(
function(self,anArray)
(anArray):do_separatedBy_((function(each)
return ((self):visitArgument_(each))
end),(function()
return ((self):nextPutAll_((self):argumentsSeparatorOp()))
end));
return (self);
end
)
,"visiting","visitArguments: anArray\r\n\r\n\tanArray\r\n\t    do: [:each | self visitArgument: each ]\r\n\t    separatedBy: [ self nextPutAll: self argumentsSeparatorOp ] ","(\r\nfunction(self,anArray)\r\n(anArray):do_separatedBy_((function(each)\r\nreturn ((self):visitArgument_(each))\r\nend),(function()\r\nreturn ((self):nextPutAll_((self):argumentsSeparatorOp()))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitSendArguments:",0
,(
function(self,aSendNode)
(self):visitArguments_((aSendNode):arguments());
return (self);
end
)
,"visiting","visitSendArguments: aSendNode\r\n\r\n\tself visitArguments: aSendNode arguments ","(\r\nfunction(self,aSendNode)\r\n(self):visitArguments_((aSendNode):arguments());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitSendNode:",0
,(
function(self,aNode)
if (((aNode):receiver()):isSuper())==true then return ((self):visitSendToSuper_(aNode)); end;
if ((self):visitOptimizedSend_(aNode))==true then return (self); end;
if ((self):isOperation_(aNode))==true then return ((self):visitOperation_(aNode)); end;
return ((self):visitNormalSend_(aNode));
end
)
,"visiting","visitSendNode: aNode\r\n\t\" Private - Visit the node (message send node) emmitting output. \"\r\n\r\n\taNode receiver isSuper ifTrue: [ ^self visitSendToSuper: aNode ].\r\n\t(self visitOptimizedSend: aNode) ifTrue: [ ^self ].\r\n\t(self isOperation: aNode) ifTrue: [ ^self visitOperation: aNode ].\r\n\t^self visitNormalSend: aNode","(\r\nfunction(self,aNode)\r\nif (((aNode):receiver()):isSuper())==true then return ((self):visitSendToSuper_(aNode)); end;\r\nif ((self):visitOptimizedSend_(aNode))==true then return (self); end;\r\nif ((self):isOperation_(aNode))==true then return ((self):visitOperation_(aNode)); end;\r\nreturn ((self):visitNormalSend_(aNode));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitValueNode:",0
,(
function(self,aNode)
(self):nextPutAll_(((aNode):value()):asNative_((self):nativeLanguage()));
return (self);
end
)
,"visiting","visitValueNode: aNode\r\n\t\" Private - Visit the node emmitting output. \"\r\n\r\n\tself nextPutAll: (aNode value asNative: self nativeLanguage)","(\r\nfunction(self,aNode)\r\n(self):nextPutAll_(((aNode):value()):asNative_((self):nativeLanguage()));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"emmitEnterMethod:",0
,(
function(self,aMethodNode)
return ((self):implementedBySubclass_("emmitEnterMethod:"));
end
)
,"generation","emmitEnterMethod: aMethodNode\r\n\t\" Private - Generate home context definitions, entering aMethodNode. \"\r\n\r\n\t^self implementedBySubclass: #emmitEnterMethod: ","(\r\nfunction(self,aMethodNode)\r\nreturn ((self):implementedBySubclass_(\"emmitEnterMethod:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"emmitFunction:node:arguments:doing:",0
,(
function(self,fName,aNode,argumentNames,aBlock)
return ((self):implementedBySubclass_("emmitFunction:node:arguments:doing:"));
end
)
,"generation","emmitFunction: fName node: aNode arguments: argumentNames doing: aBlock\r\n\t\" Private - Generate function for aNode. \"\r\n\r\n\t^self implementedBySubclass: #emmitFunction:node:arguments:doing: ","(\r\nfunction(self,fName,aNode,argumentNames,aBlock)\r\nreturn ((self):implementedBySubclass_(\"emmitFunction:node:arguments:doing:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"generate:early:return:",0
,(
function(self,fName,early,code)
return ((self):implementedBySubclass_("generate:early:return:"));
end
)
,"generation","generate: fName early: early return: code\r\n\t\" Private - Generate code to catch early return of code expression in fName. \"\r\n\r\n\t^self implementedBySubclass: #generate:early:return: ","(\r\nfunction(self,fName,early,code)\r\nreturn ((self):implementedBySubclass_(\"generate:early:return:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitBlockNode:",0
,(
function(self,aNode)
return ((self):implementedBySubclass_("visitBlockNode:"));
end
)
,"visiting","visitBlockNode: aNode\r\n\r\n\t^self implementedBySubclass: #visitBlockNode: ","(\r\nfunction(self,aNode)\r\nreturn ((self):implementedBySubclass_(\"visitBlockNode:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitReturnNode:",0
,(
function(self,aNode)
return ((self):implementedBySubclass_("visitReturnNode:"));
end
)
,"visiting","visitReturnNode: aNode\r\n\r\n\t^self implementedBySubclass: #visitReturnNode: ","(\r\nfunction(self,aNode)\r\nreturn ((self):implementedBySubclass_(\"visitReturnNode:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitCascadeNode:",0
,(
function(self,aNode)
return ((self):implementedBySubclass_("visitCascadeNode:"));
end
)
,"visiting","visitCascadeNode: aNode\r\n\r\n\t^self implementedBySubclass: #visitCascadeNode: ","(\r\nfunction(self,aNode)\r\nreturn ((self):implementedBySubclass_(\"visitCascadeNode:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitClassVariableAssignment:in:to:",0
,(
function(self,aClassVariableName,aClass,anExpressionNode)
return ((self):implementedBySubclass_("visitClassVariableAssignment:in:to:"));
end
)
,"visiting","visitClassVariableAssignment: aClassVariableName in: aClass to: anExpressionNode\r\n\r\n\t^self implementedBySubclass: #visitClassVariableAssignment:in:to: ","(\r\nfunction(self,aClassVariableName,aClass,anExpressionNode)\r\nreturn ((self):implementedBySubclass_(\"visitClassVariableAssignment:in:to:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitPoolVariableAssignment:in:to:",0
,(
function(self,aName,poolName,anExpressionNode)
return ((self):implementedBySubclass_("visitPoolVariableAssignment:in:to:"));
end
)
,"visiting","visitPoolVariableAssignment: aName in: poolName to: anExpressionNode\r\n\r\n\t^self implementedBySubclass: #visitPoolVariableAssignment:in:to: ","(\r\nfunction(self,aName,poolName,anExpressionNode)\r\nreturn ((self):implementedBySubclass_(\"visitPoolVariableAssignment:in:to:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitDirectiveNode:",0
,(
function(self,aNode)
return ((self):implementedBySubclass_("visitDirectiveNode:"));
end
)
,"visiting","visitDirectiveNode: aNode\r\n\t\" Private - Visit a directive node. \"\r\n\r\n\t^self implementedBySubclass: #visitDirectiveNode: ","(\r\nfunction(self,aNode)\r\nreturn ((self):implementedBySubclass_(\"visitDirectiveNode:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitMethodNode:",0
,(
function(self,aMethodNode)
return ((self):implementedBySubclass_("visitMethodNode:"));
end
)
,"visiting","visitMethodNode: aMethodNode\r\n\t\" Visit a method node. \"\r\n\r\n\t^self implementedBySubclass: #visitMethodNode: ","(\r\nfunction(self,aMethodNode)\r\nreturn ((self):implementedBySubclass_(\"visitMethodNode:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitOperation:",0
,(
function(self,aNode)
return ((self):implementedBySubclass_("visitOperation:"));
end
)
,"visiting","visitOperation: aNode\r\n\t\" Private - aNode is an operation and selector is mapped to target operation. \"\r\n\r\n\t^self implementedBySubclass: #visitOperation: ","(\r\nfunction(self,aNode)\r\nreturn ((self):implementedBySubclass_(\"visitOperation:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"isNativeCall:",0
,(
function(self,aNode)
return (((aNode):selector()):startsWith_("#"));
end
)
,"query","isNativeCall: aNode\r\n\t\" Private - Return true if aNode is a send calling to native function. \"\r\n\r\n\t^aNode selector startsWith: $# ","(\r\nfunction(self,aNode)\r\nreturn (((aNode):selector()):startsWith_(\"#\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"encodeNormalSend:",0
,(
function(self,aNode)
return ((self):implementedBySubclass_("encodeNormalSend:"));
end
)
,"encoding","encodeNormalSend: aNode\r\n\t\" Private - Generate code for direct/inlined message send.\"\r\n\r\n\t^self implementedBySubclass: #encodeNormalSend: ","(\r\nfunction(self,aNode)\r\nreturn ((self):implementedBySubclass_(\"encodeNormalSend:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"encodeSuperSend:",0
,(
function(self,aNode)
return ((self):implementedBySubclass_("encodeSuperSend:"));
end
)
,"encoding","encodeSuperSend: aNode\r\n\t\" Private - Generate code for super message send.\"\r\n\r\n\t^self implementedBySubclass: #encodeSuperSend: ","(\r\nfunction(self,aNode)\r\nreturn ((self):implementedBySubclass_(\"encodeSuperSend:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitNormalSend:",0
,(
function(self,aNode)
(self):compilerEvent_with_("aboutSend:",aNode);
(self):encodeNormalSend_(aNode);
(self):compilerEvent_with_("send:",aNode);
return (self);
end
)
,"visiting","visitNormalSend: aNode\r\n\t\" Visit direct/inlined message send.\"\r\n\r\n\tself compilerEvent: #aboutSend: with: aNode.\r\n\tself encodeNormalSend: aNode.\r\n\tself compilerEvent: #send: with: aNode. ","(\r\nfunction(self,aNode)\r\n(self):compilerEvent_with_(\"aboutSend:\",aNode);\r\n(self):encodeNormalSend_(aNode);\r\n(self):compilerEvent_with_(\"send:\",aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"visitSendToSuper:",0
,(
function(self,aNode)
(self):compilerEvent_with_("aboutSend:",aNode);
(self):encodeSuperSend_(aNode);
(self):compilerEvent_with_("send:",aNode);
return (self);
end
)
,"visiting","visitSendToSuper: aNode\r\n\t\" Generate code for super message send.\"\r\n\r\n\tself compilerEvent: #aboutSend: with: aNode.\r\n\tself encodeSuperSend: aNode.\r\n\tself compilerEvent: #send: with: aNode. ","(\r\nfunction(self,aNode)\r\n(self):compilerEvent_with_(\"aboutSend:\",aNode);\r\n(self):encodeSuperSend_(aNode);\r\n(self):compilerEvent_with_(\"send:\",aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeEncoder,"currentMethodInfo",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(((((self):compiler()):currentClass()):name()),">>#")),((self):compiler()):selector()));
end
)
,"debug","currentMethodInfo\r\n\t\" Private - Returns the debug info for current method. \"\r\n\r\n\t^self compiler currentClass name \r\n\t\t,'>>#' ,self compiler selector","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_(((((self):compiler()):currentClass()):name()),\">>#\")),((self):compiler()):selector()));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder["$klass"],"supportsLanguage:",0
,(
function(self,aLanguage)
return (smalltalk:boolean_or_((smalltalk:isNil_((aLanguage))),(function()
return ((smalltalk:newArray({"js", "javascript"})):includes_(aLanguage))
end)));
end
)
,"instantiation","supportsLanguage: aLanguage\r\n\t\" Private - Return true if instances of the receiver can encode to aLanguage. \"\r\n\r\n\t^aLanguage isNil or: [ #(js javascript) includes: aLanguage ] ","(\r\nfunction(self,aLanguage)\r\nreturn (smalltalk:boolean_or_((smalltalk:isNil_((aLanguage))),(function()\r\nreturn ((smalltalk:newArray({\"js\", \"javascript\"})):includes_(aLanguage))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder["$klass"],"initializeKernelInlines:",0
,(
function(self,pool)
return ((self):register_into_((self):kernelInlines(),pool));
end
)
,"inlines","initializeKernelInlines: pool\r\n\t\" Private - Initialize the inlines for methods in the category. \"\r\n\r\n\t^self register: self kernelInlines into: pool ","(\r\nfunction(self,pool)\r\nreturn ((self):register_into_((self):kernelInlines(),pool));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder["$klass"],"kernelInlines",0
,(
function(self)
return (smalltalk:newArray({smalltalk:newArray({"Object", smalltalk:newArray({smalltalk:newArray({"print:", "self"}), smalltalk:newArray({"halt", "debugger"}), smalltalk:newArray({"toString", "self"}), smalltalk:newArray({"toString:", "\"\"+anObject"}), smalltalk:newArray({"isObject:", "return (anObject==0 || anObject && anObject.$klass)?true:false"}), smalltalk:newArray({"typeOf:", "typeof anObject"}), smalltalk:newArray({"callableOf:", "self"}), smalltalk:newArray({"basicDelete:", "delete self[aString]"}), smalltalk:newArray({"basicPerform:withArguments:", smalltalk:newArray({"self", "fn.apply(self,anArray)"})}), smalltalk:newArray({"asJSONObject", "{}"}), smalltalk:newArray({"printingWith:do:", "self"}), smalltalk:newArray({"isFile:olderThan:", "self"})})}), smalltalk:newArray({"Smalltalk", smalltalk:newArray({smalltalk:newArray({"includesKey:", "undefined"}), smalltalk:newArray({"eval:", "return eval(anExpression)"})})}), smalltalk:newArray({"Smalltalk class", smalltalk:newArray({smalltalk:newArray({"global", "(function(){return this;}).call(null)"}), smalltalk:newArray({"gc", "if(typeof gc!=\"undefined\"){gc(); return true}"})})}), smalltalk:newArray({"Behavior", smalltalk:newArray({smalltalk:newArray({"basicNew", "new self.$fn()"}), smalltalk:newArray({"fn", "self"}), smalltalk:newArray({"prototype", "self"}), smalltalk:newArray({"privateMethods", "self"})})}), smalltalk:newArray({"CompiledMethod", smalltalk:newArray({smalltalk:newArray({"asClosure", "self"}), smalltalk:newArray({"printString", "self"})})}), smalltalk:newArray({"Number", smalltalk:newArray({smalltalk:newArray({"=", "\r\n\tif (nil.isNil_(anObject)) return false;\r\n\tif (!(anObject.isNumber)) return false;\r\n\tif (!(anObject.isNumber())) return false;\r\n\tif (self == anObject) return true;\r\n\treturn ((0+self-anObject) == 0)"}), smalltalk:newArray({">", "self > aNumber.mustBeNumber()"}), smalltalk:newArray({"<", "self < aNumber.mustBeNumber()"}), smalltalk:newArray({">=", "self >= aNumber.mustBeNumber()"}), smalltalk:newArray({"<=", "self <= aNumber.mustBeNumber()"}), smalltalk:newArray({"+", "self + aNumber.mustBeNumber()"}), smalltalk:newArray({"-", "self - aNumber.mustBeNumber()"}), smalltalk:newArray({"*", "self * aNumber.mustBeNumber()"}), smalltalk:newArray({"/", "self / aNumber.mustBeNumber()"}), smalltalk:newArray({"sin", "Math.sin(self)"}), smalltalk:newArray({"cos", "Math.cos(self)"}), smalltalk:newArray({"tan", "Math.tan(self)"}), smalltalk:newArray({"arcCos", "Math.acos(self)"}), smalltalk:newArray({"arcSin", "Math.asin(self)"}), smalltalk:newArray({"arcTan", "Math.atan(self)"}), smalltalk:newArray({"atan2:", "Math.atan2(self,aNumber.mustBeNumber())"}), smalltalk:newArray({"sqrt", "Math.sqrt(self)"}), smalltalk:newArray({"<<", "self << aNumber.mustBeNumber()"}), smalltalk:newArray({">>", "self >> aNumber.mustBeNumber()"}), smalltalk:newArray({"raisedTo:", "Math.pow(self,aNumber.mustBeNumber())"}), smalltalk:newArray({"max:", "Math.max(self,aNumber)"}), smalltalk:newArray({"min:", "Math.min(self,aNumber)"}), smalltalk:newArray({"rounded", "Math.round(self)"}), smalltalk:newArray({"truncated", "Math.floor(self)"}), smalltalk:newArray({"timesRepeat:", "for(var i=1;i<=self;i++){fn(i);}"}), smalltalk:newArray({"to:do:", "for(var i=self;i<=aNumber;i++){fn(i);}"}), smalltalk:newArray({"to:by:do:", "if (increment>0) { for(var i=self;i<=aNumber;i=i+increment){fn(i);} }\r\n\telse { for(var i=self;aNumber<=i;i=i+increment){fn(i);} }"}), smalltalk:newArray({"printString", "String(self)"}), smalltalk:newArray({"toString:", "self.toString(radix)"}), smalltalk:newArray({"isNumber", "return isNaN(self).not()"}), smalltalk:newArray({"asJSONObject", "self"}), smalltalk:newArray({"clearInterval", "clearInterval(self)"}), smalltalk:newArray({"clearTimeout", "clearTimeout(self)"})})}), smalltalk:newArray({"Number class", smalltalk:newArray({smalltalk:newArray({"pi", "Math.PI"}), smalltalk:newArray({"basicNew", "self"})})}), smalltalk:newArray({"BlockClosure", smalltalk:newArray({smalltalk:newArray({"compiledSource", "self"}), smalltalk:newArray({"whileTrue:", "while(self()) {fn()}"}), smalltalk:newArray({"whileFalse:", "while(!self()) {fn()}"}), smalltalk:newArray({"value", "self()"}), smalltalk:newArray({"value:", "self(anObject)"}), smalltalk:newArray({"value:value:", "self(arg1,arg2)"}), smalltalk:newArray({"value:value:value:", "self(arg1,arg2,arg3)"}), smalltalk:newArray({"value:value:value:value:", "self(arg1,arg2,arg3,arg4)"}), smalltalk:newArray({"valueWithPossibleArguments:", "self.apply(null,array)"}), smalltalk:newArray({"try:catch:", "\r\n\tvar result;\r\n\ttry{ result = fn() } catch(e) {\r\n\t\tresult = ab( self.smalltalkErrorOf_(e) )\r\n\t};\r\n\treturn result"}), smalltalk:newArray({"valueWithTimeout:", "setTimeout(self,aNumber)"}), smalltalk:newArray({"valueWithInterval:", "setInterval(self,aNumber)"}), smalltalk:newArray({"ensure:", "try{return self();} finally {fn();}"}), smalltalk:newArray({"ifCurtailed:", "\r\n\ttry{\tresult = self.value();\r\n\t\tcurtailed = false;\r\n\t} finally {\r\n\t\tif (curtailed) exceptionBlock.value();\r\n\t};\r\n\treturn result"}), smalltalk:newArray({"argumentCount", "self.length"})})}), smalltalk:newArray({"BlockClosure class", smalltalk:newArray({smalltalk:newArray({"defaultSortBlock", "self"})})}), smalltalk:newArray({"Boolean", smalltalk:newArray({smalltalk:newArray({"=", "\r\n\tif (nil.isNil_(anObject)) return false;\r\n\tif (!(self.$klass === anObject.$klass)) return false;\r\n\treturn (self.valueOf() == anObject.valueOf())"}), smalltalk:newArray({"ifTrue:ifFalse:", "if(self == true) { return aBlock.value(); } else { return anotherBlock.value(); }"}), smalltalk:newArray({"not", "self == false"}), smalltalk:newArray({"asJSONObject", "self"})})}), smalltalk:newArray({"DateTime", smalltalk:newArray({smalltalk:newArray({"year", "self.getFullYear()"}), smalltalk:newArray({"month", "self.getMonth() + 1"}), smalltalk:newArray({"month:", "self.setMonth(aNumber - 1)"}), smalltalk:newArray({"day", "self.getDay() + 1"}), smalltalk:newArray({"day:", "self.setDay(aNumber - 1)"}), smalltalk:newArray({"year:", "self.setFullYear(aNumber)"}), smalltalk:newArray({"dayOfMonth", "self.getDate()"}), smalltalk:newArray({"dayOfMonth:", "self.setDate(aNumber)"}), smalltalk:newArray({"asString", "self"}), smalltalk:newArray({"time", "self.getTime()"}), smalltalk:newArray({"time:", "self.setTime(aNumber)"}), smalltalk:newArray({"asDateString", "self.toDateString()"}), smalltalk:newArray({"asTimeString", "self.toTimeString()"}), smalltalk:newArray({"asLocaleString", "self.toLocaleString()"}), smalltalk:newArray({"hours:", "self.setHours(aNumber)"}), smalltalk:newArray({"minutes:", "self.setMinutes(aNumber)"}), smalltalk:newArray({"seconds:", "self.setSeconds(aNumber)"}), smalltalk:newArray({"milliseconds:", "self.setMilliseconds(aNumber)"}), smalltalk:newArray({"hours", "self.getHours()"}), smalltalk:newArray({"minutes", "self.getMinutes()"}), smalltalk:newArray({"seconds", "self.getSeconds()"}), smalltalk:newArray({"milliseconds", "self.getMilliseconds()"}), smalltalk:newArray({"<", "self < aDateTime"}), smalltalk:newArray({">", "self > aDateTime"}), smalltalk:newArray({"<=", "self <= aDateTime"}), smalltalk:newArray({">=", "self >= aDateTime"}), smalltalk:newArray({"-", "self - aDateTime"}), smalltalk:newArray({"+", "self + aDateTime"}), smalltalk:newArray({"isValid", "isFinite(self)"}), smalltalk:newArray({"asJSONObject", "self"})})}), smalltalk:newArray({"DateTime class", smalltalk:newArray({smalltalk:newArray({"new:", "return new Date(anObject)"}), smalltalk:newArray({"today", "self"}), smalltalk:newArray({"now", "self"}), smalltalk:newArray({"msNow", "self"})})}), smalltalk:newArray({"UndefinedObject", smalltalk:newArray({smalltalk:newArray({"asJSONObject", "null"})})}), smalltalk:newArray({"Collection", smalltalk:newArray({smalltalk:newArray({"wrap:", "self"}), smalltalk:newArray({"unwrap:", "self"})})}), smalltalk:newArray({"SequenceableCollection", smalltalk:newArray({smalltalk:newArray({"indexOf:ifAbsent:", "\r\n\tfor(var i=0;i<self.length;i++){ if (self[i]._eq(anObject)) { return i + 1; } }\r\n\treturn aBlock.value()"}), smalltalk:newArray({"detect:ifNone:", "\r\n\tfor(var i = 0; i < self.length; i++) if(fn(self[i])) return self[i];\r\n\treturn anotherBlock.value()"}), smalltalk:newArray({"reversed", "\r\n\tvar result = new Array();\r\n\tvar len=self.length; var i=len;\r\n\twhile(i--){result[len-i-1]= self[i];}\r\n\treturn result"}), smalltalk:newArray({"isEmpty", "(this.length)?false:true"}), smalltalk:newArray({"reverseDo:", "var i=self.length;while(i--){fn(self[i]);}"}), smalltalk:newArray({"includes:", smalltalk:newArray({"self", "\r\n\tif (anObject.isNumber() && (self.indexOf(anObject) > -1)) return true;\r\n\tif (anObject.isString() && (self.indexOf(anObject) > -1)) return true;\r\n\tvar i = self.length;\r\n\twhile (i--) { if (anObject._eq(self[i])) { return true; } }\r\n\treturn false"})}), smalltalk:newArray({"occurrencesOf:", "\r\n\tvar i = self.length; var count = 0;\r\n\twhile (i--) { if (self[i]._eq(anObject)) { count++; } }\r\n\treturn count"})})}), smalltalk:newArray({"String", smalltalk:newArray({smalltalk:newArray({"=", "\r\n\tif (nil.isNil_(anObject)) return false;\r\n\tif (!(anObject.isString)) return false;\r\n\tif (!(anObject.isString())) return false;\r\n\tif (self == anObject) return true;\r\n\treturn ((\"\"+self) == (\"\"+anObject))"}), smalltalk:newArray({"size", "self.length"}), smalltalk:newArray({"at:", "self.charAt(anIndex - 1)"}), smalltalk:newArray({"do:", "for(var i=0;i<self.length;i++){fn(self.charAt(i));}"}), smalltalk:newArray({"detect:ifNone:", "for(var i = 0; i < self.length; i++)\r\n\t\tif(fn(self.charAt(i))) return self.charAt(i);\r\n\treturn anotherBlock.value()"}), smalltalk:newArray({"includes:", "self"}), smalltalk:newArray({"withIndexDo:", "for(var i=0;i<self.length;i++){fn(self.charAt(i), i+1);}"}), smalltalk:newArray({"isLiteral", "self"}), smalltalk:newArray({"occurrencesOf:", "self"}), smalltalk:newArray({"startsWith:", "if (self.startsWith) { return self.startsWith(aString) }"}), smalltalk:newArray({"escaped", "return escape(self)"}), smalltalk:newArray({"unescaped", "return unescape(self)"}), smalltalk:newArray({"asEncodedURI", "return encodeURIComponent(self)"}), smalltalk:newArray({"asDecodedURI", "return decodeURIComponent(self)"}), smalltalk:newArray({",", "\r\n\tif (nil.isNil_(aCollection)) return self+\"\"; // for JSC under iOS\r\n\treturn self + aCollection.toString()"}), smalltalk:newArray({"copyWith:", "self + anObject.toString()"}), smalltalk:newArray({"copyFrom:to:", "self.substring(anIndex - 1,anotherIndex)"}), smalltalk:newArray({"reversed", "self"}), smalltalk:newArray({"indexOf:", "return self.indexOf(aString) + 1"}), smalltalk:newArray({"indexOf:startingAt:", "return self.indexOf(aString,position-1) + 1"}), smalltalk:newArray({"lastIndexOf:", "return self.lastIndexOf(aString) + 1"}), smalltalk:newArray({"lastIndexOf:startingAt:", "return self.lastIndexOf(aString,position-1) + 1"}), smalltalk:newArray({"asNativeName", "self.asJsName()"}), smalltalk:newArray({"asPrivateSelector", "result = self\r\n\t.replace(/:/g,\"_\")\r\n\t.replace(/[+]/g,\"_plus\")\r\n\t.replace(/-/g,\"_minus\")\r\n\t.replace(/[*]/g,\"_star\")\r\n\t.replace(/[/]/g,\"_slash\")\r\n\t.replace(/[|]/g,\"_bar\")\r\n\t.replace(/[&]/g,\"_amp\")\r\n\t.replace(/>/g,\"_gt\")\r\n\t.replace(/</g,\"_lt\")\r\n\t.replace(/=/g,\"_eq\")\r\n\t.replace(/,/g,\"_comma\")\r\n\t.replace(/[@]/g,\"_at\")\r\n\t.replace(/~/g,\"_no\")\r\n\t.replace(/\\\\/g,\"_bk\")"}), smalltalk:newArray({"asNative:", "\r\n\tvar bar=unescape(\"%%22\");\r\n\tif(self.search(/^[a-zA-Z0-9_:.$ ]*$/) == -1)\r\n\t\treturn \"unescape(\" +bar +escape(self) +bar +\")\";\r\n\telse\r\n\t\treturn bar +self +bar"}), smalltalk:newArray({"replace:with:", "self"}), smalltalk:newArray({"replaceRegexp:with:", "self.replace(aRegexp,aString)"}), smalltalk:newArray({"tokenize:", "return self.split(aString)"}), smalltalk:newArray({"match:", "self.search(aRegexp) != -1"}), smalltalk:newArray({"isLetter", "self.search(\"[A-Za-z]$\")==0"}), smalltalk:newArray({"isDigit", "self.search(\"[0-9]$\")==0"}), smalltalk:newArray({"isAlphaNumeric", "self"}), smalltalk:newArray({"isUpperCase", "self"}), smalltalk:newArray({"isLowerCase", "self"}), smalltalk:newArray({"asUppercase", "self.toUpperCase()"}), smalltalk:newArray({"asLowercase", "self.toLowerCase()"}), smalltalk:newArray({"asNumber", "Number(self)"}), smalltalk:newArray({">", "String(self) > aString"}), smalltalk:newArray({"<", "String(self) < aString"}), smalltalk:newArray({">=", "String(self) >= aString"}), smalltalk:newArray({"<=", "String(self) <= aString"}), smalltalk:newArray({"asJSONObject", "self"}), smalltalk:newArray({"isCharacter", "self.length == 1"}), smalltalk:newArray({"asciiValue", "self.charCodeAt(0)"}), smalltalk:newArray({"isSeparator", "(new RegExp(\"\\\\s|\\\\u0085\")).test(self)"})})}), smalltalk:newArray({"String class", smalltalk:newArray({smalltalk:newArray({"fromString:", "return new self.$fn(aString)"}), smalltalk:newArray({"new", "\"\""}), smalltalk:newArray({"cr", "\"\\r\""}), smalltalk:newArray({"lf", "\"\\n\""}), smalltalk:newArray({"crlf", "\"\\r\\n\""}), smalltalk:newArray({"space", "\" \""}), smalltalk:newArray({"tab", "\"\\t\""}), smalltalk:newArray({"zero", "\"\\0\""}), smalltalk:newArray({"fromCharCode:", "\r\n\tif (anArrayOrNumber.isNumber()) return String.fromCharCode(anArrayOrNumber);\r\n\treturn String.fromCharCode.apply(null,anArrayOrNumber.asArray());"}), smalltalk:newArray({"basicNew", "self"})})}), smalltalk:newArray({"Array", smalltalk:newArray({smalltalk:newArray({"size", "self.length"}), smalltalk:newArray({"at:", "var value = self[anIndex - 1];\r\n\tif(value === undefined) { return self.objectNotFoundAt_(anIndex); }\r\n\treturn value"}), smalltalk:newArray({"at:ifAbsent:", "var value = self[anIndex - 1];\r\n\tif(value === undefined) { return aBlock.value(); }\r\n\treturn value"}), smalltalk:newArray({"at:put:", "return self[anIndex - 1] = anObject"}), smalltalk:newArray({"do:", "for(var i=0;i<self.length;i++){fn(self[i]);}"}), smalltalk:newArray({"addAll:", "self.push.apply(self, aCollection.asArray())"}), smalltalk:newArray({"shallowCopy", "result = self.slice(0)"}), smalltalk:newArray({"copyWithAll:", "return self.concat(aCollection.asArray())"}), smalltalk:newArray({",", "return self.concat(aCollection.asArray())"}), smalltalk:newArray({"join:", "self.join(aString)"}), smalltalk:newArray({"sort:", "if (nil.isNil_(aBlock)) { self.sort(); return self }\r\n\tvar criteria = function(a, b) {\r\n\t\tif(fn(a,b)) {return -1} else {return 1}\r\n\t}\r\n\tself.sort(criteria)"}), smalltalk:newArray({"remove:ifAbsent:", "for(var i=0;i<self.length;i++) {\r\n\t\tif(self[i] == anObject) {\r\n\t\t\tself.splice(i,1); return anObject;\r\n\t\t}\r\n\t}; return aBlock.value()"}), smalltalk:newArray({"add:", "self.push(anObject)"}), smalltalk:newArray({"addFirst:", "self.splice(0,0,anObject)"}), smalltalk:newArray({"addLast:", "self.push(anObject)"}), smalltalk:newArray({"removeAll", "self.splice(0,self.size())"}), smalltalk:newArray({"removeFirst", "self.splice(0,1)"}), smalltalk:newArray({"removeIndex:", "self.splice(index-1,1)"}), smalltalk:newArray({"removeLast", "self.pop()"}), smalltalk:newArray({"atAllPut:", "for(var i=0;i<self.length;i++){ self[i] = anObject; }"}), smalltalk:newArray({"first", "var result=self[0];\r\n\tif (typeof(result)!=\"undefined\") return result"}), smalltalk:newArray({"second", "var result=self[1];\r\n\tif (typeof(result)!=\"undefined\") return result"}), smalltalk:newArray({"third", "var result=self[2];\r\n\tif (typeof(result)!=\"undefined\") return result"}), smalltalk:newArray({"fourth", "\tvar result=self[3];\r\n\tif (typeof(result)!=\"undefined\") return result"}), smalltalk:newArray({"fifth", "var result=self[4];\r\n\tif (typeof(result)!=\"undefined\") return result"}), smalltalk:newArray({"sixth", "var result=self[5];\r\n\tif (typeof(result)!=\"undefined\") return result"}), smalltalk:newArray({"asJSONObject", smalltalk:newArray({"self", "self"})}), smalltalk:newArray({"json", smalltalk:newArray({"self", "self"})})})}), smalltalk:newArray({"Array class", smalltalk:newArray({smalltalk:newArray({"basicNew:", "new Array(size)"}), smalltalk:newArray({"with:", "return [ anObject ]"}), smalltalk:newArray({"with:with:", "return [ firstObject, secondObject ]"}), smalltalk:newArray({"with:with:with:", "return [ firstObject, secondObject, thirdObject ]"}), smalltalk:newArray({"with:with:with:with:", "return [ firstObject, secondObject, thirdObject, fourthObject ]"}), smalltalk:newArray({"withAll:", "return [].concat(aCollection.asArray())"}), smalltalk:newArray({"slice:", "Array.prototype.slice.call(anIterable)"})})}), smalltalk:newArray({"ComposedAssociations", smalltalk:newArray({smalltalk:newArray({"hashObject", "{}"})})}), smalltalk:newArray({"HashedSet", smalltalk:newArray({smalltalk:newArray({"initializeHash", "{}"}), smalltalk:newArray({"privateAdd:", "self"}), smalltalk:newArray({"privateRemove:", "delete self[\"@hash\"][cookie]"}), smalltalk:newArray({"includes:", "Object.prototype.hasOwnProperty.call(self[\"@hash\"],cookie)"})})}), smalltalk:newArray({"KeyedCollection", smalltalk:newArray({smalltalk:newArray({"newHash", "{}"})})}), smalltalk:newArray({"KeyedCollection class", smalltalk:newArray({smalltalk:newArray({"@", "parts=Object.getOwnPropertyNames(jsObject)"})})}), smalltalk:newArray({"Dictionary class", smalltalk:newArray({smalltalk:newArray({"basicNew", "self"})})}), smalltalk:newArray({"PoolDictionary", smalltalk:newArray({smalltalk:newArray({"validKey:", "self"}), smalltalk:newArray({"at:put:", "self"}), smalltalk:newArray({"removeKey:ifAbsent:", "delete self[\"@hash\"][aKey]"}), smalltalk:newArray({"at:ifAbsent:", "var found = Object.prototype.hasOwnProperty.call(self[\"@hash\"],aKey);\r\n\tif(found) return self[\"@hash\"][aKey];\r\n\treturn aBlock.value()"}), smalltalk:newArray({"includesKey:", "Object.prototype.hasOwnProperty.call(self[\"@hash\"],aKey)"}), smalltalk:newArray({"keys", "return Object.getOwnPropertyNames(self[\"@hash\"])"})})}), smalltalk:newArray({"RegularExpression class", smalltalk:newArray({smalltalk:newArray({"fromString:flag:", "new RegExp(aString, anotherString)"})})}), smalltalk:newArray({"Exception", smalltalk:newArray({smalltalk:newArray({"captureStack", "self"}), smalltalk:newArray({"signal", "throw(self)"})})}), smalltalk:newArray({"ClassBuilder", smalltalk:newArray({smalltalk:newArray({"addSubclassOf:named:instanceVariableNames:", "\r\n\tsmalltalk.addClass(aString, aClass, aCollection);\r\n\treturn smalltalk[aString]"})})}), smalltalk:newArray({"StringStream", smalltalk:newArray({smalltalk:newArray({"peek", "return self[\"@collection\"].charAt(self.position())||nil"}), smalltalk:newArray({"peekForAll:", "var start = self.position();\r\n\tfor (var i=0;i<aCollection.length; i++){\r\n\t\tif (self[\"@collection\"].charCodeAt(start+i) != aCollection.charCodeAt(i)) return false;\r\n\t}"})})}), smalltalk:newArray({"Random", smalltalk:newArray({smalltalk:newArray({"next", "return Math.random()"})})}), smalltalk:newArray({"Rectangle", smalltalk:newArray({smalltalk:newArray({"printString", "self"})})})}));
end
)
,"inlines","kernelInlines\r\n\t\" Private - Return the inlines for methods in the category. \"\r\n\r\n\t^#(\r\n#(Object #(\r\n#(print:\t\t'self')\r\n#(halt\t\t'debugger')\r\n#(toString\t'self')\r\n#(toString:\t'\"\"+anObject')\r\n#(isObject:\t'return (anObject==0 || anObject && anObject.$klass)?true:false')\r\n#(typeOf:\t'typeof anObject')\r\n#(callableOf:\t'self')\r\n#(basicDelete:\t'delete self[aString]')\r\n#(basicPerform:withArguments: #('self' 'fn.apply(self,anArray)'))\r\n#(asJSONObject\t'{}')\r\n#(printingWith:do:\t'self')\r\n#(isFile:olderThan: 'self')\r\n))\r\n#(Smalltalk #(\r\n#(includesKey:\t'undefined')\r\n#(eval:\t'return eval(anExpression)')\r\n))\r\n#('Smalltalk class' #(\r\n#(global\t'(function(){return this;}).call(null)')\r\n#(gc\t'if(typeof gc!=\"undefined\"){gc(); return true}')\r\n))\r\n#(Behavior #(\r\n#(basicNew\t'new self.$fn()')\r\n#(fn\t\t'self')\r\n#(prototype\t'self')\r\n#(privateMethods\t'self')\r\n))\r\n#(CompiledMethod #(\r\n#(asClosure\t'self')\r\n#(printString\t'self')\r\n))\r\n#(Number #(\r\n#(= '\r\n\tif (nil.isNil_(anObject)) return false;\r\n\tif (!(anObject.isNumber)) return false;\r\n\tif (!(anObject.isNumber())) return false;\r\n\tif (self == anObject) return true;\r\n\treturn ((0+self-anObject) == 0)')\r\n#(> 'self > aNumber.mustBeNumber()')\r\n#(< 'self < aNumber.mustBeNumber()')\r\n#(>= 'self >= aNumber.mustBeNumber()')\r\n#(<= 'self <= aNumber.mustBeNumber()')\r\n#(+ 'self + aNumber.mustBeNumber()')\r\n#(- 'self - aNumber.mustBeNumber()')\r\n#(* 'self * aNumber.mustBeNumber()')\r\n#(/ 'self / aNumber.mustBeNumber()')\r\n#(sin 'Math.sin(self)')\r\n#(cos 'Math.cos(self)')\r\n#(tan 'Math.tan(self)')\r\n#(arcCos 'Math.acos(self)')\r\n#(arcSin 'Math.asin(self)')\r\n#(arcTan 'Math.atan(self)')\r\n#(atan2: 'Math.atan2(self,aNumber.mustBeNumber())')\r\n#(sqrt 'Math.sqrt(self)')\r\n#(<< 'self << aNumber.mustBeNumber()')\r\n#(>> 'self >> aNumber.mustBeNumber()')\r\n#(raisedTo: 'Math.pow(self,aNumber.mustBeNumber())')\r\n#(max: 'Math.max(self,aNumber)')\r\n#(min: 'Math.min(self,aNumber)')\r\n#(rounded 'Math.round(self)')\r\n#(truncated 'Math.floor(self)')\r\n#(timesRepeat: 'for(var i=1;i<=self;i++){fn(i);}')\r\n#(to:do: 'for(var i=self;i<=aNumber;i++){fn(i);}')\r\n#(to:by:do: 'if (increment>0) { for(var i=self;i<=aNumber;i=i+increment){fn(i);} }\r\n\telse { for(var i=self;aNumber<=i;i=i+increment){fn(i);} }')\r\n#(printString 'String(self)')\r\n#(toString: 'self.toString(radix)')\r\n#(isNumber 'return isNaN(self).not()')\r\n#(asJSONObject 'self')\r\n#(clearInterval 'clearInterval(self)')\r\n#(clearTimeout 'clearTimeout(self)')\r\n))\r\n#('Number class' #(\r\n#(pi 'Math.PI')\r\n#(basicNew 'self')\r\n))\r\n#(BlockClosure #(\r\n#(compiledSource 'self')\r\n#(whileTrue: 'while(self()) {fn()}')\r\n#(whileFalse: 'while(!self()) {fn()}')\r\n#(value 'self()')\r\n#(value: 'self(anObject)')\r\n#(value:value: 'self(arg1,arg2)')\r\n#(value:value:value: 'self(arg1,arg2,arg3)')\r\n#(value:value:value:value: 'self(arg1,arg2,arg3,arg4)')\r\n#(valueWithPossibleArguments: 'self.apply(null,array)')\r\n#(try:catch: '\r\n\tvar result;\r\n\ttry{ result = fn() } catch(e) {\r\n\t\tresult = ab( self.smalltalkErrorOf_(e) )\r\n\t};\r\n\treturn result')\r\n#(valueWithTimeout: 'setTimeout(self,aNumber)')\r\n#(valueWithInterval: 'setInterval(self,aNumber)')\r\n#(ensure: 'try{return self();} finally {fn();}')\r\n#(ifCurtailed: '\r\n\ttry{\tresult = self.value();\r\n\t\tcurtailed = false;\r\n\t} finally {\r\n\t\tif (curtailed) exceptionBlock.value();\r\n\t};\r\n\treturn result')\r\n#(argumentCount 'self.length')\r\n))\r\n#('BlockClosure class' #(\r\n#(defaultSortBlock 'self')\r\n))\r\n#(Boolean #(\r\n#(=\t'\r\n\tif (nil.isNil_(anObject)) return false;\r\n\tif (!(self.$klass === anObject.$klass)) return false;\r\n\treturn (self.valueOf() == anObject.valueOf())')\r\n#(ifTrue:ifFalse: 'if(self == true) { return aBlock.value(); } else { return anotherBlock.value(); }')\r\n#(not \t'self == false')\r\n#(asJSONObject 'self')\r\n))\r\n#(DateTime #(\r\n#(year 'self.getFullYear()')\r\n#(month 'self.getMonth() + 1')\r\n#(month: 'self.setMonth(aNumber - 1)')\r\n#(day 'self.getDay() + 1')\r\n#(day: 'self.setDay(aNumber - 1)')\r\n#(year: 'self.setFullYear(aNumber)')\r\n#(dayOfMonth 'self.getDate()')\r\n#(dayOfMonth: 'self.setDate(aNumber)')\r\n#(asString 'self')\r\n#(time 'self.getTime()')\r\n#(time: 'self.setTime(aNumber)')\r\n#(asDateString 'self.toDateString()')\r\n#(asTimeString 'self.toTimeString()')\r\n#(asLocaleString 'self.toLocaleString()')\r\n#(hours: 'self.setHours(aNumber)')\r\n#(minutes: 'self.setMinutes(aNumber)')\r\n#(seconds: 'self.setSeconds(aNumber)')\r\n#(milliseconds: 'self.setMilliseconds(aNumber)')\r\n#(hours 'self.getHours()')\r\n#(minutes 'self.getMinutes()')\r\n#(seconds 'self.getSeconds()')\r\n#(milliseconds 'self.getMilliseconds()')\r\n#(< 'self < aDateTime')\r\n#(> 'self > aDateTime')\r\n#(<= 'self <= aDateTime')\r\n#(>= 'self >= aDateTime')\r\n#(- 'self - aDateTime')\r\n#(+ 'self + aDateTime')\r\n#(isValid 'isFinite(self)')\r\n#(asJSONObject 'self')\r\n))\r\n#('DateTime class' #(\r\n#(new: 'return new Date(anObject)')\r\n#(today 'self')\r\n#(now 'self')\r\n#(msNow 'self')\r\n))\r\n#(UndefinedObject  #(\r\n#(asJSONObject 'null')\r\n))\r\n#(Collection  #(\r\n#(wrap: 'self')\r\n#(unwrap: 'self')\r\n))\r\n#(SequenceableCollection #(\r\n#(indexOf:ifAbsent: '\r\n\tfor(var i=0;i<self.length;i++){ if (self[i]._eq(anObject)) { return i + 1; } }\r\n\treturn aBlock.value()')\r\n#(detect:ifNone: '\r\n\tfor(var i = 0; i < self.length; i++) if(fn(self[i])) return self[i];\r\n\treturn anotherBlock.value()')\r\n#(reversed '\r\n\tvar result = new Array();\r\n\tvar len=self.length; var i=len;\r\n\twhile(i--){result[len-i-1]= self[i];}\r\n\treturn result')\r\n#(isEmpty '(this.length)?false:true')\r\n#(reverseDo:  'var i=self.length;while(i--){fn(self[i]);}')\r\n#(includes: #('self' '\r\n\tif (anObject.isNumber() && (self.indexOf(anObject) > -1)) return true;\r\n\tif (anObject.isString() && (self.indexOf(anObject) > -1)) return true;\r\n\tvar i = self.length;\r\n\twhile (i--) { if (anObject._eq(self[i])) { return true; } }\r\n\treturn false'))\r\n#(occurrencesOf: '\r\n\tvar i = self.length; var count = 0;\r\n\twhile (i--) { if (self[i]._eq(anObject)) { count++; } }\r\n\treturn count')\r\n))\r\n#(String #(\r\n#(=\t'\r\n\tif (nil.isNil_(anObject)) return false;\r\n\tif (!(anObject.isString)) return false;\r\n\tif (!(anObject.isString())) return false;\r\n\tif (self == anObject) return true;\r\n\treturn ((\"\"+self) == (\"\"+anObject))')\r\n#(size\t'self.length')\r\n#(at:\t'self.charAt(anIndex - 1)')\r\n#(do: \t'for(var i=0;i<self.length;i++){fn(self.charAt(i));}')\r\n#(detect:ifNone: 'for(var i = 0; i < self.length; i++)\r\n\t\tif(fn(self.charAt(i))) return self.charAt(i);\r\n\treturn anotherBlock.value()')\r\n#(includes: 'self')\r\n#(withIndexDo: 'for(var i=0;i<self.length;i++){fn(self.charAt(i), i+1);}')\r\n#(isLiteral 'self')\r\n#(occurrencesOf: 'self')\r\n#(startsWith: 'if (self.startsWith) { return self.startsWith(aString) }')\r\n#(escaped 'return escape(self)')\r\n#(unescaped 'return unescape(self)')\r\n#(asEncodedURI 'return encodeURIComponent(self)')\r\n#(asDecodedURI 'return decodeURIComponent(self)')\r\n#(, '\r\n\tif (nil.isNil_(aCollection)) return self+\"\"; // for JSC under iOS\r\n\treturn self + aCollection.toString()')\r\n#(copyWith: 'self + anObject.toString()')\r\n#(copyFrom:to: 'self.substring(anIndex - 1,anotherIndex)')\r\n#(reversed 'self')\r\n#(indexOf: 'return self.indexOf(aString) + 1')\r\n#(indexOf:startingAt: 'return self.indexOf(aString,position-1) + 1')\r\n#(lastIndexOf: 'return self.lastIndexOf(aString) + 1')\r\n#(lastIndexOf:startingAt: 'return self.lastIndexOf(aString,position-1) + 1')\r\n#(asNativeName 'self.asJsName()')\r\n#(asPrivateSelector 'result = self\r\n\t.replace(/:/g,\"_\")\r\n\t.replace(/[+]/g,\"_plus\")\r\n\t.replace(/-/g,\"_minus\")\r\n\t.replace(/[*]/g,\"_star\")\r\n\t.replace(/[/]/g,\"_slash\")\r\n\t.replace(/[|]/g,\"_bar\")\r\n\t.replace(/[&]/g,\"_amp\")\r\n\t.replace(/>/g,\"_gt\")\r\n\t.replace(/</g,\"_lt\")\r\n\t.replace(/=/g,\"_eq\")\r\n\t.replace(/,/g,\"_comma\")\r\n\t.replace(/[@]/g,\"_at\")\r\n\t.replace(/~/g,\"_no\")\r\n\t.replace(/\\\\/g,\"_bk\")')\r\n#(asNative: '\r\n\tvar bar=unescape(\"%%22\");\r\n\tif(self.search(/^[a-zA-Z0-9_:.$ ]*$/) == -1)\r\n\t\treturn \"unescape(\" +bar +escape(self) +bar +\")\";\r\n\telse\r\n\t\treturn bar +self +bar')\r\n#(replace:with: 'self')\r\n#(replaceRegexp:with: 'self.replace(aRegexp,aString)')\r\n#(tokenize: 'return self.split(aString)')\r\n#(match: 'self.search(aRegexp) != -1')\r\n#(isLetter 'self.search(\"[A-Za-z]$\")==0')\r\n#(isDigit 'self.search(\"[0-9]$\")==0')\r\n#(isAlphaNumeric 'self')\r\n#(isUpperCase 'self')\r\n#(isLowerCase 'self')\r\n#(asUppercase 'self.toUpperCase()')\r\n#(asLowercase 'self.toLowerCase()')\r\n#(asNumber 'Number(self)')\r\n#(> 'String(self) > aString')\r\n#(< 'String(self) < aString')\r\n#(>= 'String(self) >= aString')\r\n#(<= 'String(self) <= aString')\r\n#(asJSONObject 'self')\r\n#(isCharacter 'self.length == 1')\r\n#(asciiValue 'self.charCodeAt(0)')\r\n#(isSeparator '(new RegExp(\"\\\\s|\\\\u0085\")).test(self)')\r\n))\r\n#('String class' #(\r\n#(fromString: 'return new self.$fn(aString)')\r\n#(new\t'\"\"')\r\n#(cr \t'\"\\r\"')\r\n#(lf \t'\"\\n\"')\r\n#(crlf \t'\"\\r\\n\"')\r\n#(space\t'\" \"')\r\n#(tab\t'\"\\t\"')\r\n#(zero\t'\"\\0\"')\r\n#(fromCharCode: '\r\n\tif (anArrayOrNumber.isNumber()) return String.fromCharCode(anArrayOrNumber);\r\n\treturn String.fromCharCode.apply(null,anArrayOrNumber.asArray());')\r\n#(basicNew 'self')\r\n))\r\n#(Array #(\r\n#(size 'self.length')\r\n#(at: 'var value = self[anIndex - 1];\r\n\tif(value === undefined) { return self.objectNotFoundAt_(anIndex); }\r\n\treturn value')\r\n#(at:ifAbsent: 'var value = self[anIndex - 1];\r\n\tif(value === undefined) { return aBlock.value(); }\r\n\treturn value')\r\n#(at:put: 'return self[anIndex - 1] = anObject')\r\n#(do: 'for(var i=0;i<self.length;i++){fn(self[i]);}')\r\n#(addAll: 'self.push.apply(self, aCollection.asArray())')\r\n#(shallowCopy 'result = self.slice(0)')\r\n#(copyWithAll: 'return self.concat(aCollection.asArray())')\r\n#(, 'return self.concat(aCollection.asArray())')\r\n#(join: 'self.join(aString)')\r\n#(sort: 'if (nil.isNil_(aBlock)) { self.sort(); return self }\r\n\tvar criteria = function(a, b) {\r\n\t\tif(fn(a,b)) {return -1} else {return 1}\r\n\t}\r\n\tself.sort(criteria)')\r\n#(remove:ifAbsent: 'for(var i=0;i<self.length;i++) {\r\n\t\tif(self[i] == anObject) {\r\n\t\t\tself.splice(i,1); return anObject;\r\n\t\t}\r\n\t}; return aBlock.value()')\r\n#(add: 'self.push(anObject)')\r\n#(addFirst: 'self.splice(0,0,anObject)')\r\n#(addLast: 'self.push(anObject)')\r\n#(removeAll 'self.splice(0,self.size())')\r\n#(removeFirst 'self.splice(0,1)')\r\n#(removeIndex: 'self.splice(index-1,1)')\r\n#(removeLast 'self.pop()')\r\n#(atAllPut: 'for(var i=0;i<self.length;i++){ self[i] = anObject; }')\r\n#(first 'var result=self[0];\r\n\tif (typeof(result)!=\"undefined\") return result')\r\n#(second 'var result=self[1];\r\n\tif (typeof(result)!=\"undefined\") return result')\r\n#(third 'var result=self[2];\r\n\tif (typeof(result)!=\"undefined\") return result')\r\n#(fourth '\tvar result=self[3];\r\n\tif (typeof(result)!=\"undefined\") return result')\r\n#(fifth 'var result=self[4];\r\n\tif (typeof(result)!=\"undefined\") return result')\r\n#(sixth 'var result=self[5];\r\n\tif (typeof(result)!=\"undefined\") return result')\r\n#(asJSONObject #('self' 'self'))\r\n#(json #('self' 'self'))\r\n))\r\n#('Array class' #(\r\n#(basicNew: 'new Array(size)')\r\n#(with: 'return [ anObject ]')\r\n#(with:with: 'return [ firstObject, secondObject ]')\r\n#(with:with:with: 'return [ firstObject, secondObject, thirdObject ]')\r\n#(with:with:with:with: 'return [ firstObject, secondObject, thirdObject, fourthObject ]')\r\n#(withAll: 'return [].concat(aCollection.asArray())')\r\n#(slice: 'Array.prototype.slice.call(anIterable)')\r\n))\r\n#(ComposedAssociations #(\r\n#(hashObject '{}')\r\n))\r\n#(HashedSet #(\r\n#(initializeHash '{}')\r\n#(privateAdd: 'self')\r\n#(privateRemove: 'delete self[\"@hash\"][cookie]')\r\n#(includes: 'Object.prototype.hasOwnProperty.call(self[\"@hash\"],cookie)')\r\n))\r\n#(KeyedCollection #(\r\n#(newHash '{}')\r\n))\r\n#('KeyedCollection class' #(\r\n#(@ 'parts=Object.getOwnPropertyNames(jsObject)')\r\n))\r\n#('Dictionary class' #(\r\n#(basicNew 'self')\r\n))\r\n#(PoolDictionary #(\r\n#(validKey: 'self')\r\n#(at:put: 'self')\r\n#(removeKey:ifAbsent: 'delete self[\"@hash\"][aKey]')\r\n#(at:ifAbsent: 'var found = Object.prototype.hasOwnProperty.call(self[\"@hash\"],aKey);\r\n\tif(found) return self[\"@hash\"][aKey];\r\n\treturn aBlock.value()')\r\n#(includesKey: 'Object.prototype.hasOwnProperty.call(self[\"@hash\"],aKey)')\r\n#(keys 'return Object.getOwnPropertyNames(self[\"@hash\"])')\r\n))\r\n#('RegularExpression class' #(\r\n#(fromString:flag: 'new RegExp(aString, anotherString)')\r\n))\r\n#(Exception #(\r\n#(captureStack 'self')\r\n#(signal 'throw(self)')\r\n))\r\n#(ClassBuilder #(\r\n#(addSubclassOf:named:instanceVariableNames: '\r\n\tsmalltalk.addClass(aString, aClass, aCollection);\r\n\treturn smalltalk[aString]')\r\n))\r\n#(StringStream #(\r\n#(peek 'return self[\"@collection\"].charAt(self.position())||nil')\r\n#(peekForAll: 'var start = self.position();\r\n\tfor (var i=0;i<aCollection.length; i++){\r\n\t\tif (self[\"@collection\"].charCodeAt(start+i) != aCollection.charCodeAt(i)) return false;\r\n\t}')\r\n))\r\n#(Random #(\r\n#(next 'return Math.random()')\r\n))\r\n#(Rectangle #(\r\n#(printString 'self')\r\n))\r\n\t) ","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({smalltalk:newArray({\"Object\", smalltalk:newArray({smalltalk:newArray({\"print:\", \"self\"}), smalltalk:newArray({\"halt\", \"debugger\"}), smalltalk:newArray({\"toString\", \"self\"}), smalltalk:newArray({\"toString:\", \"\\\"\\\"+anObject\"}), smalltalk:newArray({\"isObject:\", \"return (anObject==0 || anObject && anObject.$klass)?true:false\"}), smalltalk:newArray({\"typeOf:\", \"typeof anObject\"}), smalltalk:newArray({\"callableOf:\", \"self\"}), smalltalk:newArray({\"basicDelete:\", \"delete self[aString]\"}), smalltalk:newArray({\"basicPerform:withArguments:\", smalltalk:newArray({\"self\", \"fn.apply(self,anArray)\"})}), smalltalk:newArray({\"asJSONObject\", \"{}\"}), smalltalk:newArray({\"printingWith:do:\", \"self\"}), smalltalk:newArray({\"isFile:olderThan:\", \"self\"})})}), smalltalk:newArray({\"Smalltalk\", smalltalk:newArray({smalltalk:newArray({\"includesKey:\", \"undefined\"}), smalltalk:newArray({\"eval:\", \"return eval(anExpression)\"})})}), smalltalk:newArray({\"Smalltalk class\", smalltalk:newArray({smalltalk:newArray({\"global\", \"(function(){return this;}).call(null)\"}), smalltalk:newArray({\"gc\", \"if(typeof gc!=\\\"undefined\\\"){gc(); return true}\"})})}), smalltalk:newArray({\"Behavior\", smalltalk:newArray({smalltalk:newArray({\"basicNew\", \"new self.$fn()\"}), smalltalk:newArray({\"fn\", \"self\"}), smalltalk:newArray({\"prototype\", \"self\"}), smalltalk:newArray({\"privateMethods\", \"self\"})})}), smalltalk:newArray({\"CompiledMethod\", smalltalk:newArray({smalltalk:newArray({\"asClosure\", \"self\"}), smalltalk:newArray({\"printString\", \"self\"})})}), smalltalk:newArray({\"Number\", smalltalk:newArray({smalltalk:newArray({\"=\", \"\\r\\n\\tif (nil.isNil_(anObject)) return false;\\r\\n\\tif (!(anObject.isNumber)) return false;\\r\\n\\tif (!(anObject.isNumber())) return false;\\r\\n\\tif (self == anObject) return true;\\r\\n\\treturn ((0+self-anObject) == 0)\"}), smalltalk:newArray({\">\", \"self > aNumber.mustBeNumber()\"}), smalltalk:newArray({\"<\", \"self < aNumber.mustBeNumber()\"}), smalltalk:newArray({\">=\", \"self >= aNumber.mustBeNumber()\"}), smalltalk:newArray({\"<=\", \"self <= aNumber.mustBeNumber()\"}), smalltalk:newArray({\"+\", \"self + aNumber.mustBeNumber()\"}), smalltalk:newArray({\"-\", \"self - aNumber.mustBeNumber()\"}), smalltalk:newArray({\"*\", \"self * aNumber.mustBeNumber()\"}), smalltalk:newArray({\"/\", \"self / aNumber.mustBeNumber()\"}), smalltalk:newArray({\"sin\", \"Math.sin(self)\"}), smalltalk:newArray({\"cos\", \"Math.cos(self)\"}), smalltalk:newArray({\"tan\", \"Math.tan(self)\"}), smalltalk:newArray({\"arcCos\", \"Math.acos(self)\"}), smalltalk:newArray({\"arcSin\", \"Math.asin(self)\"}), smalltalk:newArray({\"arcTan\", \"Math.atan(self)\"}), smalltalk:newArray({\"atan2:\", \"Math.atan2(self,aNumber.mustBeNumber())\"}), smalltalk:newArray({\"sqrt\", \"Math.sqrt(self)\"}), smalltalk:newArray({\"<<\", \"self << aNumber.mustBeNumber()\"}), smalltalk:newArray({\">>\", \"self >> aNumber.mustBeNumber()\"}), smalltalk:newArray({\"raisedTo:\", \"Math.pow(self,aNumber.mustBeNumber())\"}), smalltalk:newArray({\"max:\", \"Math.max(self,aNumber)\"}), smalltalk:newArray({\"min:\", \"Math.min(self,aNumber)\"}), smalltalk:newArray({\"rounded\", \"Math.round(self)\"}), smalltalk:newArray({\"truncated\", \"Math.floor(self)\"}), smalltalk:newArray({\"timesRepeat:\", \"for(var i=1;i<=self;i++){fn(i);}\"}), smalltalk:newArray({\"to:do:\", \"for(var i=self;i<=aNumber;i++){fn(i);}\"}), smalltalk:newArray({\"to:by:do:\", \"if (increment>0) { for(var i=self;i<=aNumber;i=i+increment){fn(i);} }\\r\\n\\telse { for(var i=self;aNumber<=i;i=i+increment){fn(i);} }\"}), smalltalk:newArray({\"printString\", \"String(self)\"}), smalltalk:newArray({\"toString:\", \"self.toString(radix)\"}), smalltalk:newArray({\"isNumber\", \"return isNaN(self).not()\"}), smalltalk:newArray({\"asJSONObject\", \"self\"}), smalltalk:newArray({\"clearInterval\", \"clearInterval(self)\"}), smalltalk:newArray({\"clearTimeout\", \"clearTimeout(self)\"})})}), smalltalk:newArray({\"Number class\", smalltalk:newArray({smalltalk:newArray({\"pi\", \"Math.PI\"}), smalltalk:newArray({\"basicNew\", \"self\"})})}), smalltalk:newArray({\"BlockClosure\", smalltalk:newArray({smalltalk:newArray({\"compiledSource\", \"self\"}), smalltalk:newArray({\"whileTrue:\", \"while(self()) {fn()}\"}), smalltalk:newArray({\"whileFalse:\", \"while(!self()) {fn()}\"}), smalltalk:newArray({\"value\", \"self()\"}), smalltalk:newArray({\"value:\", \"self(anObject)\"}), smalltalk:newArray({\"value:value:\", \"self(arg1,arg2)\"}), smalltalk:newArray({\"value:value:value:\", \"self(arg1,arg2,arg3)\"}), smalltalk:newArray({\"value:value:value:value:\", \"self(arg1,arg2,arg3,arg4)\"}), smalltalk:newArray({\"valueWithPossibleArguments:\", \"self.apply(null,array)\"}), smalltalk:newArray({\"try:catch:\", \"\\r\\n\\tvar result;\\r\\n\\ttry{ result = fn() } catch(e) {\\r\\n\\t\\tresult = ab( self.smalltalkErrorOf_(e) )\\r\\n\\t};\\r\\n\\treturn result\"}), smalltalk:newArray({\"valueWithTimeout:\", \"setTimeout(self,aNumber)\"}), smalltalk:newArray({\"valueWithInterval:\", \"setInterval(self,aNumber)\"}), smalltalk:newArray({\"ensure:\", \"try{return self();} finally {fn();}\"}), smalltalk:newArray({\"ifCurtailed:\", \"\\r\\n\\ttry{\\tresult = self.value();\\r\\n\\t\\tcurtailed = false;\\r\\n\\t} finally {\\r\\n\\t\\tif (curtailed) exceptionBlock.value();\\r\\n\\t};\\r\\n\\treturn result\"}), smalltalk:newArray({\"argumentCount\", \"self.length\"})})}), smalltalk:newArray({\"BlockClosure class\", smalltalk:newArray({smalltalk:newArray({\"defaultSortBlock\", \"self\"})})}), smalltalk:newArray({\"Boolean\", smalltalk:newArray({smalltalk:newArray({\"=\", \"\\r\\n\\tif (nil.isNil_(anObject)) return false;\\r\\n\\tif (!(self.$klass === anObject.$klass)) return false;\\r\\n\\treturn (self.valueOf() == anObject.valueOf())\"}), smalltalk:newArray({\"ifTrue:ifFalse:\", \"if(self == true) { return aBlock.value(); } else { return anotherBlock.value(); }\"}), smalltalk:newArray({\"not\", \"self == false\"}), smalltalk:newArray({\"asJSONObject\", \"self\"})})}), smalltalk:newArray({\"DateTime\", smalltalk:newArray({smalltalk:newArray({\"year\", \"self.getFullYear()\"}), smalltalk:newArray({\"month\", \"self.getMonth() + 1\"}), smalltalk:newArray({\"month:\", \"self.setMonth(aNumber - 1)\"}), smalltalk:newArray({\"day\", \"self.getDay() + 1\"}), smalltalk:newArray({\"day:\", \"self.setDay(aNumber - 1)\"}), smalltalk:newArray({\"year:\", \"self.setFullYear(aNumber)\"}), smalltalk:newArray({\"dayOfMonth\", \"self.getDate()\"}), smalltalk:newArray({\"dayOfMonth:\", \"self.setDate(aNumber)\"}), smalltalk:newArray({\"asString\", \"self\"}), smalltalk:newArray({\"time\", \"self.getTime()\"}), smalltalk:newArray({\"time:\", \"self.setTime(aNumber)\"}), smalltalk:newArray({\"asDateString\", \"self.toDateString()\"}), smalltalk:newArray({\"asTimeString\", \"self.toTimeString()\"}), smalltalk:newArray({\"asLocaleString\", \"self.toLocaleString()\"}), smalltalk:newArray({\"hours:\", \"self.setHours(aNumber)\"}), smalltalk:newArray({\"minutes:\", \"self.setMinutes(aNumber)\"}), smalltalk:newArray({\"seconds:\", \"self.setSeconds(aNumber)\"}), smalltalk:newArray({\"milliseconds:\", \"self.setMilliseconds(aNumber)\"}), smalltalk:newArray({\"hours\", \"self.getHours()\"}), smalltalk:newArray({\"minutes\", \"self.getMinutes()\"}), smalltalk:newArray({\"seconds\", \"self.getSeconds()\"}), smalltalk:newArray({\"milliseconds\", \"self.getMilliseconds()\"}), smalltalk:newArray({\"<\", \"self < aDateTime\"}), smalltalk:newArray({\">\", \"self > aDateTime\"}), smalltalk:newArray({\"<=\", \"self <= aDateTime\"}), smalltalk:newArray({\">=\", \"self >= aDateTime\"}), smalltalk:newArray({\"-\", \"self - aDateTime\"}), smalltalk:newArray({\"+\", \"self + aDateTime\"}), smalltalk:newArray({\"isValid\", \"isFinite(self)\"}), smalltalk:newArray({\"asJSONObject\", \"self\"})})}), smalltalk:newArray({\"DateTime class\", smalltalk:newArray({smalltalk:newArray({\"new:\", \"return new Date(anObject)\"}), smalltalk:newArray({\"today\", \"self\"}), smalltalk:newArray({\"now\", \"self\"}), smalltalk:newArray({\"msNow\", \"self\"})})}), smalltalk:newArray({\"UndefinedObject\", smalltalk:newArray({smalltalk:newArray({\"asJSONObject\", \"null\"})})}), smalltalk:newArray({\"Collection\", smalltalk:newArray({smalltalk:newArray({\"wrap:\", \"self\"}), smalltalk:newArray({\"unwrap:\", \"self\"})})}), smalltalk:newArray({\"SequenceableCollection\", smalltalk:newArray({smalltalk:newArray({\"indexOf:ifAbsent:\", \"\\r\\n\\tfor(var i=0;i<self.length;i++){ if (self[i]._eq(anObject)) { return i + 1; } }\\r\\n\\treturn aBlock.value()\"}), smalltalk:newArray({\"detect:ifNone:\", \"\\r\\n\\tfor(var i = 0; i < self.length; i++) if(fn(self[i])) return self[i];\\r\\n\\treturn anotherBlock.value()\"}), smalltalk:newArray({\"reversed\", \"\\r\\n\\tvar result = new Array();\\r\\n\\tvar len=self.length; var i=len;\\r\\n\\twhile(i--){result[len-i-1]= self[i];}\\r\\n\\treturn result\"}), smalltalk:newArray({\"isEmpty\", \"(this.length)?false:true\"}), smalltalk:newArray({\"reverseDo:\", \"var i=self.length;while(i--){fn(self[i]);}\"}), smalltalk:newArray({\"includes:\", smalltalk:newArray({\"self\", \"\\r\\n\\tif (anObject.isNumber() && (self.indexOf(anObject) > -1)) return true;\\r\\n\\tif (anObject.isString() && (self.indexOf(anObject) > -1)) return true;\\r\\n\\tvar i = self.length;\\r\\n\\twhile (i--) { if (anObject._eq(self[i])) { return true; } }\\r\\n\\treturn false\"})}), smalltalk:newArray({\"occurrencesOf:\", \"\\r\\n\\tvar i = self.length; var count = 0;\\r\\n\\twhile (i--) { if (self[i]._eq(anObject)) { count++; } }\\r\\n\\treturn count\"})})}), smalltalk:newArray({\"String\", smalltalk:newArray({smalltalk:newArray({\"=\", \"\\r\\n\\tif (nil.isNil_(anObject)) return false;\\r\\n\\tif (!(anObject.isString)) return false;\\r\\n\\tif (!(anObject.isString())) return false;\\r\\n\\tif (self == anObject) return true;\\r\\n\\treturn ((\\\"\\\"+self) == (\\\"\\\"+anObject))\"}), smalltalk:newArray({\"size\", \"self.length\"}), smalltalk:newArray({\"at:\", \"self.charAt(anIndex - 1)\"}), smalltalk:newArray({\"do:\", \"for(var i=0;i<self.length;i++){fn(self.charAt(i));}\"}), smalltalk:newArray({\"detect:ifNone:\", \"for(var i = 0; i < self.length; i++)\\r\\n\\t\\tif(fn(self.charAt(i))) return self.charAt(i);\\r\\n\\treturn anotherBlock.value()\"}), smalltalk:newArray({\"includes:\", \"self\"}), smalltalk:newArray({\"withIndexDo:\", \"for(var i=0;i<self.length;i++){fn(self.charAt(i), i+1);}\"}), smalltalk:newArray({\"isLiteral\", \"self\"}), smalltalk:newArray({\"occurrencesOf:\", \"self\"}), smalltalk:newArray({\"startsWith:\", \"if (self.startsWith) { return self.startsWith(aString) }\"}), smalltalk:newArray({\"escaped\", \"return escape(self)\"}), smalltalk:newArray({\"unescaped\", \"return unescape(self)\"}), smalltalk:newArray({\"asEncodedURI\", \"return encodeURIComponent(self)\"}), smalltalk:newArray({\"asDecodedURI\", \"return decodeURIComponent(self)\"}), smalltalk:newArray({\",\", \"\\r\\n\\tif (nil.isNil_(aCollection)) return self+\\\"\\\"; // for JSC under iOS\\r\\n\\treturn self + aCollection.toString()\"}), smalltalk:newArray({\"copyWith:\", \"self + anObject.toString()\"}), smalltalk:newArray({\"copyFrom:to:\", \"self.substring(anIndex - 1,anotherIndex)\"}), smalltalk:newArray({\"reversed\", \"self\"}), smalltalk:newArray({\"indexOf:\", \"return self.indexOf(aString) + 1\"}), smalltalk:newArray({\"indexOf:startingAt:\", \"return self.indexOf(aString,position-1) + 1\"}), smalltalk:newArray({\"lastIndexOf:\", \"return self.lastIndexOf(aString) + 1\"}), smalltalk:newArray({\"lastIndexOf:startingAt:\", \"return self.lastIndexOf(aString,position-1) + 1\"}), smalltalk:newArray({\"asNativeName\", \"self.asJsName()\"}), smalltalk:newArray({\"asPrivateSelector\", \"result = self\\r\\n\\t.replace(/:/g,\\\"_\\\")\\r\\n\\t.replace(/[+]/g,\\\"_plus\\\")\\r\\n\\t.replace(/-/g,\\\"_minus\\\")\\r\\n\\t.replace(/[*]/g,\\\"_star\\\")\\r\\n\\t.replace(/[/]/g,\\\"_slash\\\")\\r\\n\\t.replace(/[|]/g,\\\"_bar\\\")\\r\\n\\t.replace(/[&]/g,\\\"_amp\\\")\\r\\n\\t.replace(/>/g,\\\"_gt\\\")\\r\\n\\t.replace(/</g,\\\"_lt\\\")\\r\\n\\t.replace(/=/g,\\\"_eq\\\")\\r\\n\\t.replace(/,/g,\\\"_comma\\\")\\r\\n\\t.replace(/[@]/g,\\\"_at\\\")\\r\\n\\t.replace(/~/g,\\\"_no\\\")\\r\\n\\t.replace(/\\\\\\\\/g,\\\"_bk\\\")\"}), smalltalk:newArray({\"asNative:\", \"\\r\\n\\tvar bar=unescape(\\\"%%22\\\");\\r\\n\\tif(self.search(/^[a-zA-Z0-9_:.$ ]*$/) == -1)\\r\\n\\t\\treturn \\\"unescape(\\\" +bar +escape(self) +bar +\\\")\\\";\\r\\n\\telse\\r\\n\\t\\treturn bar +self +bar\"}), smalltalk:newArray({\"replace:with:\", \"self\"}), smalltalk:newArray({\"replaceRegexp:with:\", \"self.replace(aRegexp,aString)\"}), smalltalk:newArray({\"tokenize:\", \"return self.split(aString)\"}), smalltalk:newArray({\"match:\", \"self.search(aRegexp) != -1\"}), smalltalk:newArray({\"isLetter\", \"self.search(\\\"[A-Za-z]$\\\")==0\"}), smalltalk:newArray({\"isDigit\", \"self.search(\\\"[0-9]$\\\")==0\"}), smalltalk:newArray({\"isAlphaNumeric\", \"self\"}), smalltalk:newArray({\"isUpperCase\", \"self\"}), smalltalk:newArray({\"isLowerCase\", \"self\"}), smalltalk:newArray({\"asUppercase\", \"self.toUpperCase()\"}), smalltalk:newArray({\"asLowercase\", \"self.toLowerCase()\"}), smalltalk:newArray({\"asNumber\", \"Number(self)\"}), smalltalk:newArray({\">\", \"String(self) > aString\"}), smalltalk:newArray({\"<\", \"String(self) < aString\"}), smalltalk:newArray({\">=\", \"String(self) >= aString\"}), smalltalk:newArray({\"<=\", \"String(self) <= aString\"}), smalltalk:newArray({\"asJSONObject\", \"self\"}), smalltalk:newArray({\"isCharacter\", \"self.length == 1\"}), smalltalk:newArray({\"asciiValue\", \"self.charCodeAt(0)\"}), smalltalk:newArray({\"isSeparator\", \"(new RegExp(\\\"\\\\\\\\s|\\\\\\\\u0085\\\")).test(self)\"})})}), smalltalk:newArray({\"String class\", smalltalk:newArray({smalltalk:newArray({\"fromString:\", \"return new self.$fn(aString)\"}), smalltalk:newArray({\"new\", \"\\\"\\\"\"}), smalltalk:newArray({\"cr\", \"\\\"\\\\r\\\"\"}), smalltalk:newArray({\"lf\", \"\\\"\\\\n\\\"\"}), smalltalk:newArray({\"crlf\", \"\\\"\\\\r\\\\n\\\"\"}), smalltalk:newArray({\"space\", \"\\\" \\\"\"}), smalltalk:newArray({\"tab\", \"\\\"\\\\t\\\"\"}), smalltalk:newArray({\"zero\", \"\\\"\\\\0\\\"\"}), smalltalk:newArray({\"fromCharCode:\", \"\\r\\n\\tif (anArrayOrNumber.isNumber()) return String.fromCharCode(anArrayOrNumber);\\r\\n\\treturn String.fromCharCode.apply(null,anArrayOrNumber.asArray());\"}), smalltalk:newArray({\"basicNew\", \"self\"})})}), smalltalk:newArray({\"Array\", smalltalk:newArray({smalltalk:newArray({\"size\", \"self.length\"}), smalltalk:newArray({\"at:\", \"var value = self[anIndex - 1];\\r\\n\\tif(value === undefined) { return self.objectNotFoundAt_(anIndex); }\\r\\n\\treturn value\"}), smalltalk:newArray({\"at:ifAbsent:\", \"var value = self[anIndex - 1];\\r\\n\\tif(value === undefined) { return aBlock.value(); }\\r\\n\\treturn value\"}), smalltalk:newArray({\"at:put:\", \"return self[anIndex - 1] = anObject\"}), smalltalk:newArray({\"do:\", \"for(var i=0;i<self.length;i++){fn(self[i]);}\"}), smalltalk:newArray({\"addAll:\", \"self.push.apply(self, aCollection.asArray())\"}), smalltalk:newArray({\"shallowCopy\", \"result = self.slice(0)\"}), smalltalk:newArray({\"copyWithAll:\", \"return self.concat(aCollection.asArray())\"}), smalltalk:newArray({\",\", \"return self.concat(aCollection.asArray())\"}), smalltalk:newArray({\"join:\", \"self.join(aString)\"}), smalltalk:newArray({\"sort:\", \"if (nil.isNil_(aBlock)) { self.sort(); return self }\\r\\n\\tvar criteria = function(a, b) {\\r\\n\\t\\tif(fn(a,b)) {return -1} else {return 1}\\r\\n\\t}\\r\\n\\tself.sort(criteria)\"}), smalltalk:newArray({\"remove:ifAbsent:\", \"for(var i=0;i<self.length;i++) {\\r\\n\\t\\tif(self[i] == anObject) {\\r\\n\\t\\t\\tself.splice(i,1); return anObject;\\r\\n\\t\\t}\\r\\n\\t}; return aBlock.value()\"}), smalltalk:newArray({\"add:\", \"self.push(anObject)\"}), smalltalk:newArray({\"addFirst:\", \"self.splice(0,0,anObject)\"}), smalltalk:newArray({\"addLast:\", \"self.push(anObject)\"}), smalltalk:newArray({\"removeAll\", \"self.splice(0,self.size())\"}), smalltalk:newArray({\"removeFirst\", \"self.splice(0,1)\"}), smalltalk:newArray({\"removeIndex:\", \"self.splice(index-1,1)\"}), smalltalk:newArray({\"removeLast\", \"self.pop()\"}), smalltalk:newArray({\"atAllPut:\", \"for(var i=0;i<self.length;i++){ self[i] = anObject; }\"}), smalltalk:newArray({\"first\", \"var result=self[0];\\r\\n\\tif (typeof(result)!=\\\"undefined\\\") return result\"}), smalltalk:newArray({\"second\", \"var result=self[1];\\r\\n\\tif (typeof(result)!=\\\"undefined\\\") return result\"}), smalltalk:newArray({\"third\", \"var result=self[2];\\r\\n\\tif (typeof(result)!=\\\"undefined\\\") return result\"}), smalltalk:newArray({\"fourth\", \"\\tvar result=self[3];\\r\\n\\tif (typeof(result)!=\\\"undefined\\\") return result\"}), smalltalk:newArray({\"fifth\", \"var result=self[4];\\r\\n\\tif (typeof(result)!=\\\"undefined\\\") return result\"}), smalltalk:newArray({\"sixth\", \"var result=self[5];\\r\\n\\tif (typeof(result)!=\\\"undefined\\\") return result\"}), smalltalk:newArray({\"asJSONObject\", smalltalk:newArray({\"self\", \"self\"})}), smalltalk:newArray({\"json\", smalltalk:newArray({\"self\", \"self\"})})})}), smalltalk:newArray({\"Array class\", smalltalk:newArray({smalltalk:newArray({\"basicNew:\", \"new Array(size)\"}), smalltalk:newArray({\"with:\", \"return [ anObject ]\"}), smalltalk:newArray({\"with:with:\", \"return [ firstObject, secondObject ]\"}), smalltalk:newArray({\"with:with:with:\", \"return [ firstObject, secondObject, thirdObject ]\"}), smalltalk:newArray({\"with:with:with:with:\", \"return [ firstObject, secondObject, thirdObject, fourthObject ]\"}), smalltalk:newArray({\"withAll:\", \"return [].concat(aCollection.asArray())\"}), smalltalk:newArray({\"slice:\", \"Array.prototype.slice.call(anIterable)\"})})}), smalltalk:newArray({\"ComposedAssociations\", smalltalk:newArray({smalltalk:newArray({\"hashObject\", \"{}\"})})}), smalltalk:newArray({\"HashedSet\", smalltalk:newArray({smalltalk:newArray({\"initializeHash\", \"{}\"}), smalltalk:newArray({\"privateAdd:\", \"self\"}), smalltalk:newArray({\"privateRemove:\", \"delete self[\\\"@hash\\\"][cookie]\"}), smalltalk:newArray({\"includes:\", \"Object.prototype.hasOwnProperty.call(self[\\\"@hash\\\"],cookie)\"})})}), smalltalk:newArray({\"KeyedCollection\", smalltalk:newArray({smalltalk:newArray({\"newHash\", \"{}\"})})}), smalltalk:newArray({\"KeyedCollection class\", smalltalk:newArray({smalltalk:newArray({\"@\", \"parts=Object.getOwnPropertyNames(jsObject)\"})})}), smalltalk:newArray({\"Dictionary class\", smalltalk:newArray({smalltalk:newArray({\"basicNew\", \"self\"})})}), smalltalk:newArray({\"PoolDictionary\", smalltalk:newArray({smalltalk:newArray({\"validKey:\", \"self\"}), smalltalk:newArray({\"at:put:\", \"self\"}), smalltalk:newArray({\"removeKey:ifAbsent:\", \"delete self[\\\"@hash\\\"][aKey]\"}), smalltalk:newArray({\"at:ifAbsent:\", \"var found = Object.prototype.hasOwnProperty.call(self[\\\"@hash\\\"],aKey);\\r\\n\\tif(found) return self[\\\"@hash\\\"][aKey];\\r\\n\\treturn aBlock.value()\"}), smalltalk:newArray({\"includesKey:\", \"Object.prototype.hasOwnProperty.call(self[\\\"@hash\\\"],aKey)\"}), smalltalk:newArray({\"keys\", \"return Object.getOwnPropertyNames(self[\\\"@hash\\\"])\"})})}), smalltalk:newArray({\"RegularExpression class\", smalltalk:newArray({smalltalk:newArray({\"fromString:flag:\", \"new RegExp(aString, anotherString)\"})})}), smalltalk:newArray({\"Exception\", smalltalk:newArray({smalltalk:newArray({\"captureStack\", \"self\"}), smalltalk:newArray({\"signal\", \"throw(self)\"})})}), smalltalk:newArray({\"ClassBuilder\", smalltalk:newArray({smalltalk:newArray({\"addSubclassOf:named:instanceVariableNames:\", \"\\r\\n\\tsmalltalk.addClass(aString, aClass, aCollection);\\r\\n\\treturn smalltalk[aString]\"})})}), smalltalk:newArray({\"StringStream\", smalltalk:newArray({smalltalk:newArray({\"peek\", \"return self[\\\"@collection\\\"].charAt(self.position())||nil\"}), smalltalk:newArray({\"peekForAll:\", \"var start = self.position();\\r\\n\\tfor (var i=0;i<aCollection.length; i++){\\r\\n\\t\\tif (self[\\\"@collection\\\"].charCodeAt(start+i) != aCollection.charCodeAt(i)) return false;\\r\\n\\t}\"})})}), smalltalk:newArray({\"Random\", smalltalk:newArray({smalltalk:newArray({\"next\", \"return Math.random()\"})})}), smalltalk:newArray({\"Rectangle\", smalltalk:newArray({smalltalk:newArray({\"printString\", \"self\"})})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder["$klass"],"initializeNativeInlines:",0
,(
function(self,pool)
return ((self):register_into_((self):nativeInlines(),pool));
end
)
,"inlines","initializeNativeInlines: pool\r\n\t\" Private - Initialize the inlines for methods in the category. \"\r\n\r\n\t^self register: self nativeInlines into: pool ","(\r\nfunction(self,pool)\r\nreturn ((self):register_into_((self):nativeInlines(),pool));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder["$klass"],"nativeInlines",0
,(
function(self)
return (smalltalk:newArray({smalltalk:newArray({"NativeObject", smalltalk:newArray({smalltalk:newArray({"jsObject", "Object"}), smalltalk:newArray({"ownPropertyNames", "return Object.getOwnPropertyNames(self[\"@handle\"])"})})}), smalltalk:newArray({"NativeObject class", smalltalk:newArray({smalltalk:newArray({"undefined", "undefined"}), smalltalk:newArray({"codeToNumber", "\" || 0\""}), smalltalk:newArray({"newInstanceOf:withAll:", "self"})})}), smalltalk:newArray({"NativeHandle", smalltalk:newArray({smalltalk:newArray({"hasOwnProperty:", "Object.prototype.hasOwnProperty.call(self[\"@handle\"],aName)"}), smalltalk:newArray({"delete:", "delete self[\"@handle\"][aName]"})})}), smalltalk:newArray({"NativeLibraryObject class", smalltalk:newArray({smalltalk:newArray({"basicLoad:", "load(url)"})})}), smalltalk:newArray({"NativeLibraryObject", smalltalk:newArray({smalltalk:newArray({"newHandleOf:", "result = new aConstructor()"}), smalltalk:newArray({"newHandleOf:with:", "result = new aConstructor(arg1)"}), smalltalk:newArray({"newHandleOf:with:with:", "result = new aConstructor(arg1,arg2)"}), smalltalk:newArray({"newHandleOf:with:with:with:", "result = new aConstructor(arg1,arg2,arg3)"}), smalltalk:newArray({"newHandleOf:with:with:with:with:", "result = new aConstructor(arg1,arg2,arg3,arg4)"}), smalltalk:newArray({"newHandleOf:with:with:with:with:with:", "result = new aConstructor(arg1,arg2,arg3,arg4,arg5)"}), smalltalk:newArray({"newHandleOf:with:with:with:with:with:with:", "result = new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6)"}), smalltalk:newArray({"newHandleOf:with:with:with:with:with:with:with:", "result = new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7)"}), smalltalk:newArray({"newHandleOf:with:with:with:with:with:with:with:with:", "result = new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)"})})}), smalltalk:newArray({"Array", smalltalk:newArray({smalltalk:newArray({"addAllLua:", "self.addAll_(natives)"})})}), smalltalk:newArray({"Array class", smalltalk:newArray({smalltalk:newArray({"@@", "self"}), smalltalk:newArray({"@", "result.addAll_(natives)"}), smalltalk:newArray({"basicNew", "self"})})}), smalltalk:newArray({"Boolean class", smalltalk:newArray({smalltalk:newArray({"@", "\r\n\tif (aBOOL === true) return true;\r\n\tif (aBOOL === 1) return true;\r\n\tif ((1 & aBOOL) + 0 == 1) return true"})})}), smalltalk:newArray({"Number", smalltalk:newArray({smalltalk:newArray({"int32", "self"}), smalltalk:newArray({"int64", "self"}), smalltalk:newArray({"float32", "self"}), smalltalk:newArray({"float64", "self"})})})}));
end
)
,"inlines","nativeInlines\r\n\t\" Private - Return the inlines for methods in the category. \"\r\n\r\n\t^#(\r\n#(NativeObject #(\r\n#(jsObject 'Object')\r\n#(ownPropertyNames 'return Object.getOwnPropertyNames(self[\"@handle\"])')\r\n))\r\n#('NativeObject class' #(\r\n#(undefined 'undefined')\r\n#(codeToNumber '\" || 0\"')\r\n#(newInstanceOf:withAll: 'self')\r\n))\r\n#(NativeHandle #(\r\n#(hasOwnProperty: 'Object.prototype.hasOwnProperty.call(self[\"@handle\"],aName)')\r\n#(delete: 'delete self[\"@handle\"][aName]')\r\n))\r\n#('NativeLibraryObject class' #(\r\n#(basicLoad: 'load(url)')\r\n))\r\n#(NativeLibraryObject  #(\r\n#(newHandleOf: 'result = new aConstructor()')\r\n#(newHandleOf:with: 'result = new aConstructor(arg1)')\r\n#(newHandleOf:with:with: 'result = new aConstructor(arg1,arg2)')\r\n#(newHandleOf:with:with:with: 'result = new aConstructor(arg1,arg2,arg3)')\r\n#(newHandleOf:with:with:with:with: 'result = new aConstructor(arg1,arg2,arg3,arg4)')\r\n#(newHandleOf:with:with:with:with:with: 'result = new aConstructor(arg1,arg2,arg3,arg4,arg5)')\r\n#(newHandleOf:with:with:with:with:with:with: 'result = new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6)')\r\n#(newHandleOf:with:with:with:with:with:with:with: 'result = new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7)')\r\n#(newHandleOf:with:with:with:with:with:with:with:with: 'result = new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)')\r\n))\r\n#(Array #(\r\n#(addAllLua: 'self.addAll_(natives)')\r\n))\r\n#('Array class' #(\r\n#(@@ 'self')\r\n#(@ 'result.addAll_(natives)')\r\n#(basicNew 'self')\r\n))\r\n#('Boolean class' #(\r\n#(@ '\r\n\tif (aBOOL === true) return true;\r\n\tif (aBOOL === 1) return true;\r\n\tif ((1 & aBOOL) + 0 == 1) return true')\r\n))\r\n#(Number #(\r\n#(int32 'self')\r\n#(int64 'self')\r\n#(float32 'self')\r\n#(float64 'self')\r\n))\r\n\t) ","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({smalltalk:newArray({\"NativeObject\", smalltalk:newArray({smalltalk:newArray({\"jsObject\", \"Object\"}), smalltalk:newArray({\"ownPropertyNames\", \"return Object.getOwnPropertyNames(self[\\\"@handle\\\"])\"})})}), smalltalk:newArray({\"NativeObject class\", smalltalk:newArray({smalltalk:newArray({\"undefined\", \"undefined\"}), smalltalk:newArray({\"codeToNumber\", \"\\\" || 0\\\"\"}), smalltalk:newArray({\"newInstanceOf:withAll:\", \"self\"})})}), smalltalk:newArray({\"NativeHandle\", smalltalk:newArray({smalltalk:newArray({\"hasOwnProperty:\", \"Object.prototype.hasOwnProperty.call(self[\\\"@handle\\\"],aName)\"}), smalltalk:newArray({\"delete:\", \"delete self[\\\"@handle\\\"][aName]\"})})}), smalltalk:newArray({\"NativeLibraryObject class\", smalltalk:newArray({smalltalk:newArray({\"basicLoad:\", \"load(url)\"})})}), smalltalk:newArray({\"NativeLibraryObject\", smalltalk:newArray({smalltalk:newArray({\"newHandleOf:\", \"result = new aConstructor()\"}), smalltalk:newArray({\"newHandleOf:with:\", \"result = new aConstructor(arg1)\"}), smalltalk:newArray({\"newHandleOf:with:with:\", \"result = new aConstructor(arg1,arg2)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:\", \"result = new aConstructor(arg1,arg2,arg3)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:with:\", \"result = new aConstructor(arg1,arg2,arg3,arg4)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:with:with:\", \"result = new aConstructor(arg1,arg2,arg3,arg4,arg5)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:with:with:with:\", \"result = new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:with:with:with:with:\", \"result = new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:with:with:with:with:with:\", \"result = new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)\"})})}), smalltalk:newArray({\"Array\", smalltalk:newArray({smalltalk:newArray({\"addAllLua:\", \"self.addAll_(natives)\"})})}), smalltalk:newArray({\"Array class\", smalltalk:newArray({smalltalk:newArray({\"@@\", \"self\"}), smalltalk:newArray({\"@\", \"result.addAll_(natives)\"}), smalltalk:newArray({\"basicNew\", \"self\"})})}), smalltalk:newArray({\"Boolean class\", smalltalk:newArray({smalltalk:newArray({\"@\", \"\\r\\n\\tif (aBOOL === true) return true;\\r\\n\\tif (aBOOL === 1) return true;\\r\\n\\tif ((1 & aBOOL) + 0 == 1) return true\"})})}), smalltalk:newArray({\"Number\", smalltalk:newArray({smalltalk:newArray({\"int32\", \"self\"}), smalltalk:newArray({\"int64\", \"self\"}), smalltalk:newArray({\"float32\", \"self\"}), smalltalk:newArray({\"float64\", \"self\"})})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder["$klass"],"initializeToolsInlines:",0
,(
function(self,pool)
return ((self):register_into_((self):toolsInlines(),pool));
end
)
,"inlines","initializeToolsInlines: pool\r\n\t\" Private - Initialize the inlines for methods in the category. \"\r\n\r\n\t^self register: self toolsInlines into: pool ","(\r\nfunction(self,pool)\r\nreturn ((self):register_into_((self):toolsInlines(),pool));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder["$klass"],"toolsInlines",0
,(
function(self)
return (smalltalk:newArray({smalltalk:newArray({"NativeReader", smalltalk:newArray({smalltalk:newArray({"initializeObject", "{}"})})}), smalltalk:newArray({"String", smalltalk:newArray({smalltalk:newArray({"asComment", smalltalk:newArray({"\"/* \"", "\"*/ \"", "\"// \""})})})}), smalltalk:newArray({"MethodReferences", smalltalk:newArray({smalltalk:newArray({"dot", "\".\""}), smalltalk:newArray({"localDef", "\"var \""}), smalltalk:newArray({"normalSendStarter:", "self"}), smalltalk:newArray({"superSendPatternOf:", "self.superJSSendPatternOf_(aSelector)"}), smalltalk:newArray({"compiledSourceStart", "\"{\""})})}), smalltalk:newArray({"Class", smalltalk:newArray({smalltalk:newArray({"hackDNU", "mth.fn_(function(){\r\n\t\tthis.print_(\"//DNU \"+selector);\r\n\t\tthis.doesNotUnderstand_(\r\n\t\t\tsmalltalk.Message.receiver_selector_arguments_\r\n\t\t\t\t(this,selector,[].slice.call(arguments)))}\r\n\t\t);"})})})}));
end
)
,"inlines","toolsInlines\r\n\t\" Private - Return the inlines for methods in the category. \"\r\n\r\n\t^#(\r\n#(NativeReader #(\r\n#(initializeObject '{}')\r\n))\r\n#(String  #(\r\n#(asComment #('\"/* \"' \t'\"*/ \"' \t'\"// \"'))\r\n))\r\n#(MethodReferences #(\r\n#(dot\t\t'\".\"')\r\n#(localDef\t'\"var \"')\r\n#(normalSendStarter:\t'self')\r\n#(superSendPatternOf:\t'self.superJSSendPatternOf_(aSelector)')\r\n#(compiledSourceStart\t'\"{\"')\r\n))\r\n#(Class #(\r\n#(hackDNU 'mth.fn_(function(){\r\n\t\tthis.print_(\"//DNU \"+selector);\r\n\t\tthis.doesNotUnderstand_(\r\n\t\t\tsmalltalk.Message.receiver_selector_arguments_\r\n\t\t\t\t(this,selector,[].slice.call(arguments)))}\r\n\t\t);')\r\n))\r\n\t) ","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({smalltalk:newArray({\"NativeReader\", smalltalk:newArray({smalltalk:newArray({\"initializeObject\", \"{}\"})})}), smalltalk:newArray({\"String\", smalltalk:newArray({smalltalk:newArray({\"asComment\", smalltalk:newArray({\"\\\"/* \\\"\", \"\\\"*/ \\\"\", \"\\\"// \\\"\"})})})}), smalltalk:newArray({\"MethodReferences\", smalltalk:newArray({smalltalk:newArray({\"dot\", \"\\\".\\\"\"}), smalltalk:newArray({\"localDef\", \"\\\"var \\\"\"}), smalltalk:newArray({\"normalSendStarter:\", \"self\"}), smalltalk:newArray({\"superSendPatternOf:\", \"self.superJSSendPatternOf_(aSelector)\"}), smalltalk:newArray({\"compiledSourceStart\", \"\\\"{\\\"\"})})}), smalltalk:newArray({\"Class\", smalltalk:newArray({smalltalk:newArray({\"hackDNU\", \"mth.fn_(function(){\\r\\n\\t\\tthis.print_(\\\"//DNU \\\"+selector);\\r\\n\\t\\tthis.doesNotUnderstand_(\\r\\n\\t\\t\\tsmalltalk.Message.receiver_selector_arguments_\\r\\n\\t\\t\\t\\t(this,selector,[].slice.call(arguments)))}\\r\\n\\t\\t);\"})})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder["$klass"],"initializeSnapshotInlines:",0
,(
function(self,pool)
return ((self):register_into_((self):snapshotInlines(),pool));
end
)
,"inlines","initializeSnapshotInlines: pool\r\n\t\" Private - Initialize the inlines for methods in the category. \"\r\n\r\n\t^self register: self snapshotInlines into: pool ","(\r\nfunction(self,pool)\r\nreturn ((self):register_into_((self):snapshotInlines(),pool));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder["$klass"],"snapshotInlines",0
,(
function(self)
return (smalltalk:newArray({smalltalk:newArray({"Smalltalk", smalltalk:newArray({smalltalk:newArray({"exit", "quit()"})})}), smalltalk:newArray({"Snapshot", smalltalk:newArray({smalltalk:newArray({"bootHeader", "\"\""}), smalltalk:newArray({"bootFooter", "\"\""}), smalltalk:newArray({"launchExpression", "\"smalltalk.launchImage()\""})})})}));
end
)
,"inlines","snapshotInlines\r\n\t\" Private - Return the inlines for methods in the category. \"\r\n\r\n\t^#(\r\n#(Smalltalk #(\r\n#(exit\t'quit()')\r\n))\r\n#(Snapshot #(\r\n#(bootHeader\t'\"\"')\r\n#(bootFooter\t'\"\"')\r\n#(launchExpression '\"smalltalk.launchImage()\"')\r\n))\r\n\t) ","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({smalltalk:newArray({\"Smalltalk\", smalltalk:newArray({smalltalk:newArray({\"exit\", \"quit()\"})})}), smalltalk:newArray({\"Snapshot\", smalltalk:newArray({smalltalk:newArray({\"bootHeader\", \"\\\"\\\"\"}), smalltalk:newArray({\"bootFooter\", \"\\\"\\\"\"}), smalltalk:newArray({\"launchExpression\", \"\\\"smalltalk.launchImage()\\\"\"})})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder["$klass"],"initializeOtherInlines:",0
,(
function(self,pool)
return ((self):register_into_((self):otherInlines(),pool));
end
)
,"inlines","initializeOtherInlines: pool\r\n\t\" Private - Initialize the inlines for methods in the category. \"\r\n\r\n\t^self register: self otherInlines into: pool ","(\r\nfunction(self,pool)\r\nreturn ((self):register_into_((self):otherInlines(),pool));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder["$klass"],"otherInlines",0
,(
function(self)
return (smalltalk:newArray({}));
end
)
,"inlines","otherInlines\r\n\t\" Private - Return the inlines for methods in the category. \"\r\n\r\n\t^#(\r\n\"#(ClassName #(\r\n#(selector '...')\r\n))\"\r\n\t) ","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({}));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"nativeLanguage",0
,(
function(self)
return ("js");
end
)
,"accessing","nativeLanguage\r\n\t\" Return the nativeLanguage of the receiver. \"\r\n\r\n\t^#js ","(\r\nfunction(self)\r\nreturn (\"js\");\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"nativeUndefined",0
,(
function(self)
return ("undefined");
end
)
,"encoding","nativeUndefined\r\n\t\" Private - Return the code for undefined. \"\r\n\r\n\t^#undefined ","(\r\nfunction(self)\r\nreturn (\"undefined\");\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"nativeNameOfMetaClass:",0
,(
function(self,aClass)
return (smalltalk:object_comma_((((aClass):instanceClass()):name()),".$klass"));
end
)
,"encoding","nativeNameOfMetaClass: aClass\r\n\t\" Private - Return the native name for metaclass aClass. \"\r\n\r\n\t^aClass instanceClass name ,'.$klass' ","(\r\nfunction(self,aClass)\r\nreturn (smalltalk:object_comma_((((aClass):instanceClass()):name()),\".$klass\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"missingNativeCodeFor:as:",0
,(
function(self,aNode,lang)
return (smalltalk:object_comma_((smalltalk:object_comma_(("(self.invalidMessage_(\""),(self["@compiler"]):selector())),"\"))"));
end
)
,"inlines","missingNativeCodeFor: aNode as: lang\r\n\t\" Private - Return the native language code for missing expression (or nil). \"\r\n\r\n\t^'(self.invalidMessage_(\"' ,compiler selector ,'\"))'","(\r\nfunction(self,aNode,lang)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"(self.invalidMessage_(\\\"\"),(self[\"@compiler\"]):selector())),\"\\\"))\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"defaultRequirementsFor:",0
,(
function(self,aClass)
local constructorName=nil
local code=nil
(function()
	local _s8_value=((aClass):constructorName())
	constructorName=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((constructorName)))==true then return (smalltalk:newArray({})); end;
return ((smalltalk.Array):with_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("if("),constructorName))," && !")),(self):smalltalkNameFor_(aClass))),") smalltalk.mapClassName(\"")),(aClass):name())),"\",\"")),(aClass):category())),"\",")),constructorName)),",")),(self):smalltalkNameFor_((aClass):superclass()))),");")));
end
)
,"export","defaultRequirementsFor: aClass\r\n\t\" Private - Return the default requirements to load aClass.\r\n\tDetect native bindings and generate code to rebind before class definition.\r\n\t\"\r\n\r\n\t| constructorName code |\r\n\tconstructorName := aClass constructorName.\r\n\tconstructorName isNil ifTrue: [ ^#() ].\r\n\t^Array with:\r\n\t\t'if(',constructorName,' && !'\r\n\t\t, (self smalltalkNameFor: aClass)\r\n\t\t,') smalltalk.mapClassName(\"'\r\n\t\t,aClass name ,'\",\"'\r\n\t\t,aClass category, '\",'\r\n\t\t,constructorName, ','\r\n\t\t,(self smalltalkNameFor: aClass superclass)\r\n\t\t,');'","(\r\nfunction(self,aClass)\r\nlocal constructorName=nil\r\nlocal code=nil\r\n(function()\r\n\tlocal _s8_value=((aClass):constructorName())\r\n\tconstructorName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((constructorName)))==true then return (smalltalk:newArray({})); end;\r\nreturn ((smalltalk.Array):with_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"if(\"),constructorName)),\" && !\")),(self):smalltalkNameFor_(aClass))),\") smalltalk.mapClassName(\\\"\")),(aClass):name())),\"\\\",\\\"\")),(aClass):category())),\"\\\",\")),constructorName)),\",\")),(self):smalltalkNameFor_((aClass):superclass()))),\");\")));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"emmitEnterMethod:",0
,(
function(self,aMethodNode)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("var self=this;");
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
)
,"generation","emmitEnterMethod: aMethodNode\r\n\t\" Private - Generate home context definitions, entering aMethodNode. \"\r\n\r\n\tself nextPutAll: 'var self=this;'; cr ","(\r\nfunction(self,aMethodNode)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"var self=this;\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"emmitFunctionBody:",0
,(
function(self,aBlock)
(self):nextPutAll_("{");
(aBlock):evaluate();
(self):nextPutAll_("}");
return (self);
end
)
,"generation","emmitFunctionBody: aBlock\r\n\t\" Private - Emmit the code of function body evaluating aBlock. \"\r\n\r\n\tself nextPutAll: ${.\r\n\taBlock evaluate.\r\n\tself nextPutAll: $}. ","(\r\nfunction(self,aBlock)\r\n(self):nextPutAll_(\"{\");\r\n(aBlock):evaluate();\r\n(self):nextPutAll_(\"}\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"emmitFunction:node:arguments:doing:",0
,(
function(self,fName,aNode,argumentNames,aBlock)
local aStream=nil
(function()
	local _s8_value=((""):writeStream())
	aStream=_s8_value
	return _s8_value
end)();
(argumentNames):do_separatedBy_((function(each)
((self):tempVariables()):add_(each);return ((aStream):nextPutAll_((self):localName_(each)))
end),(function()
return ((aStream):nextPutAll_(","))
end));
(self):emmitFunction_arguments_doing_(fName,(aStream):contents(),aBlock);
return (self);
end
)
,"generation","emmitFunction: fName node: aNode arguments: argumentNames doing: aBlock\r\n\t\" Private - Generate function for aNode. \"\r\n\r\n\t| aStream |\r\n\taStream := '' writeStream.\r\n\targumentNames do: [:each | \r\n\t\tself tempVariables add: each.\r\n\t\taStream nextPutAll: (self localName: each) ]\r\n\t    separatedBy: [ aStream nextPutAll: ',' ].\r\n\tself\temmitFunction: fName\r\n\t\targuments: aStream contents\r\n\t\tdoing: aBlock","(\r\nfunction(self,fName,aNode,argumentNames,aBlock)\r\nlocal aStream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\taStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(argumentNames):do_separatedBy_((function(each)\r\n((self):tempVariables()):add_(each);return ((aStream):nextPutAll_((self):localName_(each)))\r\nend),(function()\r\nreturn ((aStream):nextPutAll_(\",\"))\r\nend));\r\n(self):emmitFunction_arguments_doing_(fName,(aStream):contents(),aBlock);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"export:method:on:",0
,(
function(self,aClass,aMethod,aStream)
local fName=nil
local selectorName=nil
local bar=nil
local source=nil
(function()
	local _s8_value=((self):nativeSourceFor_(aMethod))
	source=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((source)))==true then return (false); end;
if (smalltalk:isNil_((aMethod)))==true then (self):error_("Method is missing"); end;
(function()
	local _s8_value=(smalltalk:asString_(("\"")))
	bar=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aMethod):selector())
	fName=_s8_value
	return _s8_value
end)();
if (((fName):first()):isBackSlash())==true then (function()
	local _s8_value=((self):escaped_((aMethod):selector()))
	selectorName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):escaped_((self):asSelector_(fName)))
	fName=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((bar),(aMethod):selector())),bar))
	selectorName=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):asSelector_(fName)),((aMethod):selector()):replace_with_(":","_"))),(function()
return ((function()
	local _s8_value=("0")
	fName=_s8_value
	return _s8_value
end)())
end),(function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((bar),(self):asSelector_(fName))),bar))
	fName=_s8_value
	return _s8_value
end)())
end)); end;
(aStream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk.bind("),(self):smalltalkNameFor_(aClass))),",")),selectorName)),",")),fName)),"\r\n,")),source));
if (smalltalk:boolean_and_((smalltalk:notNil_(((aMethod):source()))),(function()
return (((aMethod):source()):notEmpty())
end)))==true then (
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((","),(self):escaped_((aMethod):category()))),",")),(self):escaped_((aMethod):source()))))
end
)(aStream); end;
if (smalltalk:boolean_and_((smalltalk:responds_to_((aMethod),("stamp"))),(function()
return (smalltalk:notNil_(((aMethod):stamp())))
end)))==true then (aStream):nextPutAll_(smalltalk:object_comma_((","),(self):escaped_((aMethod):stamp()))); end;
(aStream):nextPutAll_(");\r\n");
return (self);
end
)
,"export","export: aClass method: aMethod on: aStream\r\n\t\" Export a method definition of aClass onto aStream. \"\r\n\r\n\t| fName selectorName bar source |\r\n\tsource := self nativeSourceFor: aMethod.\r\n\tsource isNil ifTrue: [ ^false ].\r\n\taMethod isNil ifTrue: [ self error: 'Method is missing' ].\r\n\tbar := $\" asString.\r\n\tfName := aMethod selector.\r\n\tfName first isBackSlash ifTrue: [\r\n\t\tselectorName := self escaped: aMethod selector.\r\n\t\tfName := self escaped: (self asSelector: fName).\r\n\t] ifFalse: [\r\n\t\tselectorName := bar ,aMethod selector, bar.\r\n\t\t(self asSelector: fName) = (aMethod selector replace: $: with: $_) ifTrue: [\r\n\t\t\tfName := '0' \"we exploit the fact that 0 isNil to signal a compact selector\"\r\n\t\t] ifFalse: [\r\n\t\t\tfName := bar ,(self asSelector: fName) ,bar\r\n\t\t].\r\n\t].\r\n\taStream\r\n\t\tnextPutAll: 'smalltalk.bind(' ,(self smalltalkNameFor: aClass)\r\n\t\t\t,',' ,selectorName ,',' ,fName ,'\r\n,'\t\t\t,source.\r\n\t(aMethod source notNil and: [ aMethod source notEmpty ]) ifTrue: [\r\n\t    aStream cr; \"warning: this cr is important for debugger\"\r\n\t\tnextPutAll: ',' ,(self escaped: aMethod category)\r\n\t\t\t,',' ,(self escaped: aMethod source).\r\n\t].\r\n\t((aMethod respondsTo: #stamp) and: [ aMethod stamp notNil ]) ifTrue: [\r\n\t\taStream nextPutAll: ',' ,(self escaped: aMethod stamp)\r\n\t].\r\n\taStream nextPutAll: ');\r\n'","(\r\nfunction(self,aClass,aMethod,aStream)\r\nlocal fName=nil\r\nlocal selectorName=nil\r\nlocal bar=nil\r\nlocal source=nil\r\n(function()\r\n\tlocal _s8_value=((self):nativeSourceFor_(aMethod))\r\n\tsource=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((source)))==true then return (false); end;\r\nif (smalltalk:isNil_((aMethod)))==true then (self):error_(\"Method is missing\"); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:asString_((\"\\\"\")))\r\n\tbar=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aMethod):selector())\r\n\tfName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (((fName):first()):isBackSlash())==true then (function()\r\n\tlocal _s8_value=((self):escaped_((aMethod):selector()))\r\n\tselectorName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):escaped_((self):asSelector_(fName)))\r\n\tfName=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((bar),(aMethod):selector())),bar))\r\n\tselectorName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):asSelector_(fName)),((aMethod):selector()):replace_with_(\":\",\"_\"))),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(\"0\")\r\n\tfName=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((bar),(self):asSelector_(fName))),bar))\r\n\tfName=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)); end;\r\n(aStream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.bind(\"),(self):smalltalkNameFor_(aClass))),\",\")),selectorName)),\",\")),fName)),\"\\r\\n,\")),source));\r\nif (smalltalk:boolean_and_((smalltalk:notNil_(((aMethod):source()))),(function()\r\nreturn (((aMethod):source()):notEmpty())\r\nend)))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\",\"),(self):escaped_((aMethod):category()))),\",\")),(self):escaped_((aMethod):source()))))\r\nend\r\n)(aStream); end;\r\nif (smalltalk:boolean_and_((smalltalk:responds_to_((aMethod),(\"stamp\"))),(function()\r\nreturn (smalltalk:notNil_(((aMethod):stamp())))\r\nend)))==true then (aStream):nextPutAll_(smalltalk:object_comma_((\",\"),(self):escaped_((aMethod):stamp()))); end;\r\n(aStream):nextPutAll_(\");\\r\\n\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"exportCommentOf:on:",0
,(
function(self,aClass,aStream)
if (((((aClass):comment()):size()) > 0))==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((".$comment="),(self):escaped_((aClass):comment())));
	(_s8_rec):nextPutAll_(";");
	return ((_s8_rec):cr())
end
)(aStream); end;
return (self);
end
)
,"export","exportCommentOf: aClass on: aStream\r\n\t\" Export the comment of aClass onto aStream. \"\r\n\r\n\taClass comment size > 0 ifTrue: [\r\n\t    aStream\r\n\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\tnextPutAll: '.$comment=' ,(self escaped: aClass comment);\r\n\t\tnextPutAll: ';'; cr\r\n\t]. ","(\r\nfunction(self,aClass,aStream)\r\nif (((((aClass):comment()):size()) > 0))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((\".$comment=\"),(self):escaped_((aClass):comment())));\r\n\t(_s8_rec):nextPutAll_(\";\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"exportDefinitionOf:on:",0
,(
function(self,aClass,aStream)
((self):loadRequirementsOf_(aClass)):do_((function(each)
return (smalltalk:if_true_false_(((each):isString()),(function()
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_(each);
	return ((_s8_rec):cr())
end
)(aStream))
end),(function()
return ((aStream):fileOutOn_(aStream))
end)))
end));
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk.addClass(\""),(aClass):name())),"\","));
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass):superclass()));
	return ((_s8_rec):nextPutAll_(","))
end
)(aStream);
(self):exportArrayLiteral_on_newLine_((aClass):instanceVariableNames(),aStream,false);
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((",\""),(aClass):category())),"\""));
	(_s8_rec):nextPutAll_(");");
	return ((_s8_rec):cr())
end
)(aStream);
if (smalltalk:notNil_(((aClass):classVariables())))==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((".$classVariableNames="),(self):escaped_((aClass):classVariablesString())));
	(_s8_rec):nextPutAll_(";");
	return ((_s8_rec):cr())
end
)(aStream); end;
if (smalltalk:notNil_(((aClass):poolDictionaries())))==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	return ((_s8_rec):nextPutAll_(".$poolDictionaries="))
end
)(aStream);
(self):exportArrayLiteral_on_newLine_((aClass):poolDictionaries(),aStream,true); end;
if (((aClass):propertyNames()):notEmpty())==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	return ((_s8_rec):nextPutAll_(".$propertyNames="))
end
)(aStream);
(self):exportArrayLiteral_on_newLine_((aClass):propertyNames(),aStream,true); end;
(self):exportCommentOf_on_(aClass,aStream);
return (self);
end
)
,"export","exportDefinitionOf: aClass on: aStream\r\n\t\" Export definition of aClass onto aStream. \"\r\n\r\n\t(self loadRequirementsOf: aClass) do: [:each|\r\n\t\teach isString\r\n\t\tifTrue: [ aStream nextPutAll: each;cr ]\r\n\t\tifFalse: [ aStream fileOutOn: aStream ].\r\n\t].\r\n\taStream \r\n\t    nextPutAll: 'smalltalk.addClass(\"', aClass name, '\",';\r\n\t    nextPutAll: (self smalltalkNameFor: aClass superclass);\r\n\t    nextPutAll: ','.\r\n\tself exportArrayLiteral: aClass instanceVariableNames on: aStream newLine: false.\r\n\taStream\r\n\t    nextPutAll: ',\"' ,aClass category, $\";\r\n\t    nextPutAll: ');'; cr.\r\n\taClass classVariables notNil ifTrue: [\r\n\t    aStream\r\n\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\tnextPutAll: '.$classVariableNames=' ,(self escaped: aClass classVariablesString);\r\n\t\tnextPutAll: ';'; cr\r\n\t].\r\n\taClass poolDictionaries notNil ifTrue: [\r\n\t    aStream\r\n\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\tnextPutAll: '.$poolDictionaries='.\r\n\t   self exportArrayLiteral: aClass poolDictionaries on: aStream newLine: true.\r\n\t].\r\n\taClass propertyNames notEmpty ifTrue: [\r\n\t    aStream\r\n\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\tnextPutAll: '.$propertyNames='.\r\n\t   self exportArrayLiteral: aClass propertyNames on: aStream newLine: true.\r\n\t].\r\n\tself exportCommentOf: aClass on: aStream.","(\r\nfunction(self,aClass,aStream)\r\n((self):loadRequirementsOf_(aClass)):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):isString()),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(each);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream))\r\nend),(function()\r\nreturn ((aStream):fileOutOn_(aStream))\r\nend)))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.addClass(\\\"\"),(aClass):name())),\"\\\",\"));\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass):superclass()));\r\n\treturn ((_s8_rec):nextPutAll_(\",\"))\r\nend\r\n)(aStream);\r\n(self):exportArrayLiteral_on_newLine_((aClass):instanceVariableNames(),aStream,false);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\",\\\"\"),(aClass):category())),\"\\\"\"));\r\n\t(_s8_rec):nextPutAll_(\");\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream);\r\nif (smalltalk:notNil_(((aClass):classVariables())))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((\".$classVariableNames=\"),(self):escaped_((aClass):classVariablesString())));\r\n\t(_s8_rec):nextPutAll_(\";\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream); end;\r\nif (smalltalk:notNil_(((aClass):poolDictionaries())))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\treturn ((_s8_rec):nextPutAll_(\".$poolDictionaries=\"))\r\nend\r\n)(aStream);\r\n(self):exportArrayLiteral_on_newLine_((aClass):poolDictionaries(),aStream,true); end;\r\nif (((aClass):propertyNames()):notEmpty())==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\treturn ((_s8_rec):nextPutAll_(\".$propertyNames=\"))\r\nend\r\n)(aStream);\r\n(self):exportArrayLiteral_on_newLine_((aClass):propertyNames(),aStream,true); end;\r\n(self):exportCommentOf_on_(aClass,aStream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"exportMetaDefinitionOf:on:",0
,(
function(self,aClass,aStream)
if ((((aClass)["$klass"]):instanceVariableNames()):notEmpty())==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass)["$klass"]));
	return ((_s8_rec):nextPutAll_(".$iVarNames="))
end
)(aStream);
(self):exportArrayLiteral_on_newLine_(((aClass)["$klass"]):instanceVariableNames(),aStream,true); end;
if ((((aClass)["$klass"]):propertyNames()):notEmpty())==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass)["$klass"]));
	return ((_s8_rec):nextPutAll_(".$propertyNames="))
end
)(aStream);
(self):exportArrayLiteral_on_newLine_(((aClass)["$klass"]):propertyNames(),aStream,true); end;
return (self);
end
)
,"export","exportMetaDefinitionOf: aClass on: aStream\r\n\t\" Export class side definition of aClass onto aStream. \"\r\n\r\n\taClass class instanceVariableNames notEmpty ifTrue: [\r\n\t\taStream \r\n\t\t\tnextPutAll: (self smalltalkNameFor: aClass class);\r\n\t\t\tnextPutAll: '.$iVarNames='.\r\n\t\tself exportArrayLiteral: aClass class instanceVariableNames on: aStream newLine: true.\r\n\t].\r\n\r\n\taClass class propertyNames notEmpty ifTrue: [\r\n\t\taStream \r\n\t\t\tnextPutAll: (self smalltalkNameFor: aClass class);\r\n\t\t\tnextPutAll: '.$propertyNames='.\r\n\t\tself exportArrayLiteral: aClass class propertyNames on: aStream newLine: true.\r\n\t].","(\r\nfunction(self,aClass,aStream)\r\nif ((((aClass)[\"$klass\"]):instanceVariableNames()):notEmpty())==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass)[\"$klass\"]));\r\n\treturn ((_s8_rec):nextPutAll_(\".$iVarNames=\"))\r\nend\r\n)(aStream);\r\n(self):exportArrayLiteral_on_newLine_(((aClass)[\"$klass\"]):instanceVariableNames(),aStream,true); end;\r\nif ((((aClass)[\"$klass\"]):propertyNames()):notEmpty())==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass)[\"$klass\"]));\r\n\treturn ((_s8_rec):nextPutAll_(\".$propertyNames=\"))\r\nend\r\n)(aStream);\r\n(self):exportArrayLiteral_on_newLine_(((aClass)[\"$klass\"]):propertyNames(),aStream,true); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"sourceToTry:",0
,(
function(self,sourceCode)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("try"),"{")),sourceCode)),"}"))," catch($$e) {\r\n\tif ($$e.directiveError) { return(this.error_($$e.directiveError)); }\r\n\tif (!$$e.directiveFailed) { throw($$e); } }"));
end
)
,"directives","sourceToTry: sourceCode\r\n\t\" Return the code to emmit to try execution of sourceCode. \"\r\n\r\n\t^'try' ,${ ,sourceCode ,$} ,' catch($$e) {\r\n\tif ($$e.directiveError) { return(this.error_($$e.directiveError)); }\r\n\tif (!$$e.directiveFailed) { throw($$e); } }'","(\r\nfunction(self,sourceCode)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"try\"),\"{\")),sourceCode)),\"}\")),\" catch($$e) {\\r\\n\\tif ($$e.directiveError) { return(this.error_($$e.directiveError)); }\\r\\n\\tif (!$$e.directiveFailed) { throw($$e); } }\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"sourceToDirectCall:with:",0
,(
function(self,nativeSelector,arg)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("return this."),nativeSelector)),"(")),arg)),",")),"arguments")),");"));
end
)
,"directives","sourceToDirectCall: nativeSelector with: arg\r\n\t\" Return the code to emmit to direct native call to selector with argument. \"\r\n\r\n\t^'return this.' ,nativeSelector ,'(' ,arg ,',' ,'arguments' ,');' ","(\r\nfunction(self,nativeSelector,arg)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"return this.\"),nativeSelector)),\"(\")),arg)),\",\")),\"arguments\")),\");\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"generate:early:return:",0
,(
function(self,fName,early,code)
local prev=nil
if not ((early))==true then (self):nextPutAll_(code);
return (0); end;
(function()
	local _s8_value=(smalltalk:object_comma_(("var $s8Ret$={name:\"stReturn\"};try"),"{"))
	prev=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(prev);
	(_s8_rec):nextPutAll_(code);
	return ((_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(("}")," catch($$ex) {if($$ex === $s8Ret$)")),"{")))
end
)(self);
(self):emmitReturn_early_("$$ex.result",true);
(self):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(("}")," throw($$ex);")),"}"));
return ((prev):size());
end
)
,"generation","generate: fName early: early return: code\r\n\t\" Private - Generate code to catch early return of code expression in fName. \"\r\n\r\n\t| prev |\r\n\tearly ifFalse: [ self nextPutAll: code. ^0 ].\r\n\tprev := 'var $s8Ret$={name:\"stReturn\"};try' ,${.\r\n\tself\tnextPutAll: prev;\r\n\t\tnextPutAll: code;\r\n\t\tnextPutAll: $} ,' catch($$ex) {if($$ex === $s8Ret$)' ,${.\r\n\tself emmitReturn: '$$ex.result' early: true.\r\n\tself nextPutAll: $} ,' throw($$ex);' ,$}.\r\n\t^prev size","(\r\nfunction(self,fName,early,code)\r\nlocal prev=nil\r\nif not ((early))==true then (self):nextPutAll_(code);\r\nreturn (0); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((\"var $s8Ret$={name:\\\"stReturn\\\"};try\"),\"{\"))\r\n\tprev=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(prev);\r\n\t(_s8_rec):nextPutAll_(code);\r\n\treturn ((_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\"}\"),\" catch($$ex) {if($$ex === $s8Ret$)\")),\"{\")))\r\nend\r\n)(self);\r\n(self):emmitReturn_early_(\"$$ex.result\",true);\r\n(self):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\"}\"),\" throw($$ex);\")),\"}\"));\r\nreturn ((prev):size());\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"newMethodFunctionName",0
,(
function(self)
return ("smalltalk.newMethod");
end
)
,"generation","newMethodFunctionName\r\n\t\" Private - Return the function to call when installing a new method. \"\r\n\r\n\t^'smalltalk.newMethod'","(\r\nfunction(self)\r\nreturn (\"smalltalk.newMethod\");\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"visitBlockNode:",0
,(
function(self,aNode)
(self):nextArgumentsPut_((function()
return ((self):emmitFunction_node_arguments_doing_("",aNode,(aNode):parameterNames(),(function()
return ((self):visitNodesIn_cr_(aNode,false))
end)))
end));
return (self);
end
)
,"visiting","visitBlockNode: aNode\r\n\r\n\tself nextArgumentsPut: [\r\n\t\tself\temmitFunction: '' node: aNode\r\n\t\t\targuments: aNode parameterNames\r\n\t\t\tdoing: [ self visitNodesIn: aNode cr: false ]\r\n\t] ","(\r\nfunction(self,aNode)\r\n(self):nextArgumentsPut_((function()\r\nreturn ((self):emmitFunction_node_arguments_doing_(\"\",aNode,(aNode):parameterNames(),(function()\r\nreturn ((self):visitNodesIn_cr_(aNode,false))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"visitCascadeNode:",0
,(
function(self,aNode)
if not ((((self):tempVariables()):includes_("$rec")))==true then ((self):tempVariables()):add_("$rec"); end;
(self):compilerEvent_with_("aboutCascade:",aNode);
(self):nextArgumentsPut_((function()
return ((self):emmitFunction_arguments_doing_("","$rec",(function()
local index=nil
local rec=nil
(function()
	local _s8_value=(0)
	index=_s8_value
	return _s8_value
end)();return (((aNode):nodes()):do_((function(each)
(function()
	local _s8_value=((index):_plus(1))
	index=_s8_value
	return _s8_value
end)();if (smalltalk:isObject_equalTo_((index),((aNode):nodes()):size()))==true then (self):emmitReturn_(nil); end;(function()
	local _s8_value=((smalltalk.VariableNode):new())
	rec=_s8_value
	return _s8_value
end)();(
function(_s8_rec)
	(_s8_rec):value_("$rec");
	return ((_s8_rec):start_end_((each):start(),(each):start()))
end
)(rec);(each):receiver_(rec);(self):visit_(each);if (smalltalk:isObject_equalTo_((index),((aNode):nodes()):size()))==true then (self):compilerEvent_withArguments_("returned:early:",(smalltalk.Array):with_with_(nil,false)); end;return ((self):nextPutAll_(";"))
end)))
end)))
end));
(self):nextArgumentsPut_((function()
return ((self):visit_((aNode):receiver()))
end));
(self):compilerEvent_with_("cascade:",aNode);
return (self);
end
)
,"visiting","visitCascadeNode: aNode\r\n\r\n\t(self tempVariables includes: '$rec') ifFalse: [ self tempVariables add: '$rec' ].\r\n\tself compilerEvent: #aboutCascade: with: aNode.\r\n\tself nextArgumentsPut: [\r\n\t\tself emmitFunction: '' arguments: '$rec' doing: [ | index rec |\r\n\t\t\tindex := 0.\r\n\t\t\taNode nodes do: [:each |\r\n\t\t\t    index := index + 1.\r\n\t\t\t    index = aNode nodes size ifTrue: [ self emmitReturn: nil ].\r\n\t\t\t    rec := VariableNode new.\r\n\t\t\t    rec value: '$rec'; start: each start end: each start.\r\n\t\t\t    each receiver: rec.\r\n\t\t\t    self visit: each.\r\n\t\t\t    index = aNode nodes size ifTrue: [\r\n\t\t\t\tself compilerEvent: #returned:early: withArguments: (Array with: nil with: false)\r\n\t\t\t    ].\r\n\t\t\t    self nextPutAll: ';'\r\n\t\t\t].\r\n\t\t]\r\n\t].\r\n\tself nextArgumentsPut: [ self visit: aNode receiver ].\r\n\tself compilerEvent: #cascade: with: aNode.","(\r\nfunction(self,aNode)\r\nif not ((((self):tempVariables()):includes_(\"$rec\")))==true then ((self):tempVariables()):add_(\"$rec\"); end;\r\n(self):compilerEvent_with_(\"aboutCascade:\",aNode);\r\n(self):nextArgumentsPut_((function()\r\nreturn ((self):emmitFunction_arguments_doing_(\"\",\"$rec\",(function()\r\nlocal index=nil\r\nlocal rec=nil\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();return (((aNode):nodes()):do_((function(each)\r\n(function()\r\n\tlocal _s8_value=((index):_plus(1))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isObject_equalTo_((index),((aNode):nodes()):size()))==true then (self):emmitReturn_(nil); end;(function()\r\n\tlocal _s8_value=((smalltalk.VariableNode):new())\r\n\trec=_s8_value\r\n\treturn _s8_value\r\nend)();(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):value_(\"$rec\");\r\n\treturn ((_s8_rec):start_end_((each):start(),(each):start()))\r\nend\r\n)(rec);(each):receiver_(rec);(self):visit_(each);if (smalltalk:isObject_equalTo_((index),((aNode):nodes()):size()))==true then (self):compilerEvent_withArguments_(\"returned:early:\",(smalltalk.Array):with_with_(nil,false)); end;return ((self):nextPutAll_(\";\"))\r\nend)))\r\nend)))\r\nend));\r\n(self):nextArgumentsPut_((function()\r\nreturn ((self):visit_((aNode):receiver()))\r\nend));\r\n(self):compilerEvent_with_(\"cascade:\",aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"visitClassVariableAssignment:in:to:",0
,(
function(self,aClassVariableName,aClass,anExpressionNode)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	(_s8_rec):nextPutAll_(".classVariableAt_put_(\"");
	(_s8_rec):nextPutAll_(aClassVariableName);
	return ((_s8_rec):nextPutAll_("\","))
end
)(self);
(self):visit_(anExpressionNode);
(self):nextPutAll_(")");
return (self);
end
)
,"visiting","visitClassVariableAssignment: aClassVariableName in: aClass to: anExpressionNode\r\n\r\n\tself\r\n\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\tnextPutAll: '.classVariableAt_put_(\"';\r\n\t\tnextPutAll: aClassVariableName;\r\n\t\tnextPutAll: '\",'.\r\n\tself visit: anExpressionNode.\r\n\tself\tnextPutAll: ')'","(\r\nfunction(self,aClassVariableName,aClass,anExpressionNode)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\t(_s8_rec):nextPutAll_(\".classVariableAt_put_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(aClassVariableName);\r\n\treturn ((_s8_rec):nextPutAll_(\"\\\",\"))\r\nend\r\n)(self);\r\n(self):visit_(anExpressionNode);\r\n(self):nextPutAll_(\")\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"visitDirectiveNode:",0
,(
function(self,aNode)
if (smalltalk:responds_to_((aNode),("asNative:for:on:")))==true then local code=nil
(function()
	local _s8_value=((aNode):asNative_for_on_(self["@functionName"],self,self["@stream"]))
	code=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((code))),(function()
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_(code);
	return ((_s8_rec):cr())
end
)(self))
end),nil)); end;
(self):visitNode_in_cr_(aNode,nil,true);
return (self);
end
)
,"visiting","visitDirectiveNode: aNode\r\n\t\" Private - Visit a directive node. \"\r\n\r\n\t(aNode respondsTo: #asNative:for:on:) ifTrue: [\r\n\t\t| code |\r\n\t\tcode := aNode\r\n\t\t\tasNative: functionName\r\n\t\t\tfor: self on: stream.\r\n\t\t^code notNil ifTrue: [\r\n\t\t\tself nextPutAll: code; cr\r\n\t\t]\r\n\t].\r\n\tself visitNode: aNode in: nil cr: true","(\r\nfunction(self,aNode)\r\nif (smalltalk:responds_to_((aNode),(\"asNative:for:on:\")))==true then local code=nil\r\n(function()\r\n\tlocal _s8_value=((aNode):asNative_for_on_(self[\"@functionName\"],self,self[\"@stream\"]))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((code))),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(code);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend),nil)); end;\r\n(self):visitNode_in_cr_(aNode,nil,true);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"visitGlobalReferenceNode:",0
,(
function(self,aNode)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local aName=nil
local aClass=nil
local lookupPools=nil
(function()
	local _s8_value=((aNode):value())
	aName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((self):currentClass()):instanceClass())
	aClass=_s8_value
	return _s8_value
end)();
(aClass):classVariableNamesDo_((function(each)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((each),aName)),(function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	(_s8_rec):nextPutAll_(".classVariableAt_(\"");
	(_s8_rec):nextPutAll_(aName);
	return ((_s8_rec):nextPutAll_("\")"))
end
)(self);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(aClass):sharedPoolsAndNamesDo_((function(poolName,pool)
return (smalltalk:if_true_false_(((pool):includesKey_(aName)),(function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("smalltalk.poolDictionary_(\"");
	(_s8_rec):nextPutAll_(poolName);
	(_s8_rec):nextPutAll_("\").at_(\"");
	(_s8_rec):nextPutAll_(aName);
	return ((_s8_rec):nextPutAll_("\")"))
end
)(self);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(self):nextPutAll_((self):codeToGetGlobal_((aNode):value()));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"visiting","visitGlobalReferenceNode: aNode\r\n\r\n\t| aName aClass lookupPools |\r\n\taName := aNode value.\r\n\taClass := self currentClass instanceClass.\r\n\taClass classVariableNamesDo: [:each|\r\n\t\teach = aName ifTrue: [\r\n\t\t\tself\r\n\t\t\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\t\t\tnextPutAll: '.classVariableAt_(\"';\r\n\t\t\t\tnextPutAll: aName;\r\n\t\t\t\tnextPutAll: '\")'.\r\n\t\t\t^self\r\n\t\t]\r\n\t].\r\n\taClass sharedPoolsAndNamesDo: [:poolName :pool|\r\n\t\t(pool includesKey: aName) ifTrue: [\r\n\t\t\tself\r\n\t\t\t\tnextPutAll: 'smalltalk.poolDictionary_(\"';\r\n\t\t\t\tnextPutAll: poolName;\r\n\t\t\t\tnextPutAll: '\").at_(\"';\r\n\t\t\t\tnextPutAll: aName;\r\n\t\t\t\tnextPutAll: '\")'.\r\n\t\t\t^self\r\n\t\t].\r\n\t].\r\n\tself nextPutAll: (self codeToGetGlobal: aNode value).","(\r\nfunction(self,aNode)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal aName=nil\r\nlocal aClass=nil\r\nlocal lookupPools=nil\r\n(function()\r\n\tlocal _s8_value=((aNode):value())\r\n\taName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((self):currentClass()):instanceClass())\r\n\taClass=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aClass):classVariableNamesDo_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((each),aName)),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\t(_s8_rec):nextPutAll_(\".classVariableAt_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(aName);\r\n\treturn ((_s8_rec):nextPutAll_(\"\\\")\"))\r\nend\r\n)(self);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(aClass):sharedPoolsAndNamesDo_((function(poolName,pool)\r\nreturn (smalltalk:if_true_false_(((pool):includesKey_(aName)),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"smalltalk.poolDictionary_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(poolName);\r\n\t(_s8_rec):nextPutAll_(\"\\\").at_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(aName);\r\n\treturn ((_s8_rec):nextPutAll_(\"\\\")\"))\r\nend\r\n)(self);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(self):nextPutAll_((self):codeToGetGlobal_((aNode):value()));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"visitMethodNode:",0
,(
function(self,aMethodNode)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:object_comma_(((self):newMethodFunctionName()),"("));
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_((self):currentClass()));
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((",\""),(aMethodNode):selector())),"\","));
	return ((_s8_rec):cr())
end
)(self);
(self):emmitMethod_(aMethodNode);
if ((self):includeSourceCode())==true then (
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(smalltalk:object_comma_((","),(self):escaped_((aMethodNode):source()))))
end
)(self); end;
(self):nextPutAll_(")");
return (self);
end
)
,"visiting","visitMethodNode: aMethodNode\r\n\t\" Visit a method node. \"\r\n\r\n\tself\r\n\t\tnextPutAll: self newMethodFunctionName, '(';\r\n\t\tnextPutAll: (self smalltalkNameFor: self currentClass);\r\n\t\tnextPutAll: ',\"', aMethodNode selector, '\",'; cr.\r\n\tself emmitMethod: aMethodNode.\r\n\tself includeSourceCode ifTrue: [\r\n\t\tself\tcr; \"warning: this cr is important for debugger\"\r\n\t\t\tnextPutAll: ',' ,(self escaped: aMethodNode source)\r\n\t].\r\n\tself nextPutAll: ')'","(\r\nfunction(self,aMethodNode)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_(((self):newMethodFunctionName()),\"(\"));\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_((self):currentClass()));\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\",\\\"\"),(aMethodNode):selector())),\"\\\",\"));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):emmitMethod_(aMethodNode);\r\nif ((self):includeSourceCode())==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(smalltalk:object_comma_((\",\"),(self):escaped_((aMethodNode):source()))))\r\nend\r\n)(self); end;\r\n(self):nextPutAll_(\")\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"visitNode:index:",0
,(
function(self,aNode,index)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local selector=nil
if (smalltalk:boolean_and_(((index):isMemberOf_(smalltalk.ValueNode)),(function()
return ((index):hasString())
end)))==true then (function()
	local _s8_value=((self):asSelector_((index):value()))
	selector=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:boolean_or_(((selector):includes_(" ")),(function()
return ((selector):includes_("_"))
end))),nil,(function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(".");
	return ((_s8_rec):nextPutAll_(selector))
end
)(self);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end)); end;
(self):nextIndexPut_((function()
return ((self):visit_(index))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"visiting","visitNode: aNode index: index\r\n\t\" Private - Generate code for indexed access. \"\r\n\r\n\t| selector |\r\n\t((index isMemberOf: ValueNode) and: [ index hasString ]) ifTrue: [\r\n\t\tselector := self asSelector: index value.\r\n\t\t((selector includes: $ ) or: [ selector includes: $_ ]) ifFalse: [\r\n\t\t\tself nextPutAll: $.; nextPutAll: selector.\r\n\t\t\t^self\r\n\t\t].\r\n\t].\r\n\tself nextIndexPut: [ self visit: index ] ","(\r\nfunction(self,aNode,index)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal selector=nil\r\nif (smalltalk:boolean_and_(((index):isMemberOf_(smalltalk.ValueNode)),(function()\r\nreturn ((index):hasString())\r\nend)))==true then (function()\r\n\tlocal _s8_value=((self):asSelector_((index):value()))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:boolean_or_(((selector):includes_(\" \")),(function()\r\nreturn ((selector):includes_(\"_\"))\r\nend))),nil,(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\".\");\r\n\treturn ((_s8_rec):nextPutAll_(selector))\r\nend\r\n)(self);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)); end;\r\n(self):nextIndexPut_((function()\r\nreturn ((self):visit_(index))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"messageSendConnector",0
,(
function(self)
return (".");
end
)
,"encoding","messageSendConnector\r\n\t\" Private - Return the connector to use for sending a message. \"\r\n\r\n\t^$. ","(\r\nfunction(self)\r\nreturn (\".\");\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"messageSendConnector:",0
,(
function(self,aNode)
if (smalltalk:isNil_((((aNode):receiver()):messageSendConnector())))==true then return (""); end;
return ((self):messageSendConnector());
end
)
,"encoding","messageSendConnector: aNode\r\n\t\" Private - Return the connector to use for sending message. \"\r\n\r\n\taNode receiver messageSendConnector isNil ifTrue: [ ^'' ].\r\n\t^self messageSendConnector ","(\r\nfunction(self,aNode)\r\nif (smalltalk:isNil_((((aNode):receiver()):messageSendConnector())))==true then return (\"\"); end;\r\nreturn ((self):messageSendConnector());\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"encodeNormalSend:",0
,(
function(self,aNode)
(
function(_s8_rec)
	(_s8_rec):visitReceiver_((aNode):receiver());
	(_s8_rec):nextPutAll_((self):messageSendConnector_(aNode));
	(_s8_rec):nextPutAll_((self):asSelector_((aNode):selector()));
	return ((_s8_rec):nextArgumentsPut_((function()
return ((self):visitSendArguments_(aNode))
end)))
end
)(self);
return (self);
end
)
,"encoding","encodeNormalSend: aNode\r\n\t\" Private - Generate code for message send. \"\r\n\r\n\tself\tvisitReceiver: aNode receiver;\r\n\t\tnextPutAll: (self messageSendConnector: aNode);\r\n\t\tnextPutAll: (self asSelector: aNode selector);\r\n\t\tnextArgumentsPut: [ self visitSendArguments: aNode ] ","(\r\nfunction(self,aNode)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):visitReceiver_((aNode):receiver());\r\n\t(_s8_rec):nextPutAll_((self):messageSendConnector_(aNode));\r\n\t(_s8_rec):nextPutAll_((self):asSelector_((aNode):selector()));\r\n\treturn ((_s8_rec):nextArgumentsPut_((function()\r\nreturn ((self):visitSendArguments_(aNode))\r\nend)))\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"visitOperation:",0
,(
function(self,aNode)
(self):compilerEvent_with_("aboutOperation:",aNode);
(self):nextArgumentsPut_((function()
return ((self):visitReceiver_((aNode):receiver()))
end));
(self):nextPutAll_((self):asSelector_((aNode):selector()));
(self):visitSendArguments_(aNode);
(self):compilerEvent_with_("operation:",aNode);
return (self);
end
)
,"visiting","visitOperation: aNode\r\n\t\" Private - aNode is an operation and selector is mapped to target operation. \"\r\n\r\n\tself compilerEvent: #aboutOperation: with: aNode.\r\n\tself nextArgumentsPut: [ self visitReceiver: aNode receiver ].\r\n\tself nextPutAll: (self asSelector: aNode selector).\r\n\tself visitSendArguments: aNode.\r\n\tself compilerEvent: #operation: with: aNode.","(\r\nfunction(self,aNode)\r\n(self):compilerEvent_with_(\"aboutOperation:\",aNode);\r\n(self):nextArgumentsPut_((function()\r\nreturn ((self):visitReceiver_((aNode):receiver()))\r\nend));\r\n(self):nextPutAll_((self):asSelector_((aNode):selector()));\r\n(self):visitSendArguments_(aNode);\r\n(self):compilerEvent_with_(\"operation:\",aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"visitPoolVariableAssignment:in:to:",0
,(
function(self,aName,poolName,anExpressionNode)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("smalltalk.poolDictionary_(\"");
	(_s8_rec):nextPutAll_(poolName);
	(_s8_rec):nextPutAll_("\").at_put_(\"");
	(_s8_rec):nextPutAll_(aName);
	return ((_s8_rec):nextPutAll_("\","))
end
)(self);
(self):visit_(anExpressionNode);
(self):nextPutAll_(")");
return (self);
end
)
,"visiting","visitPoolVariableAssignment: aName in: poolName to: anExpressionNode\r\n\r\n\tself\r\n\t\tnextPutAll: 'smalltalk.poolDictionary_(\"';\r\n\t\tnextPutAll: poolName; nextPutAll: '\").at_put_(\"';\r\n\t\tnextPutAll: aName; nextPutAll: '\",'.\r\n\tself visit: anExpressionNode.\r\n\tself\tnextPutAll: ')'","(\r\nfunction(self,aName,poolName,anExpressionNode)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"smalltalk.poolDictionary_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(poolName);\r\n\t(_s8_rec):nextPutAll_(\"\\\").at_put_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(aName);\r\n\treturn ((_s8_rec):nextPutAll_(\"\\\",\"))\r\nend\r\n)(self);\r\n(self):visit_(anExpressionNode);\r\n(self):nextPutAll_(\")\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"visitReturnNode:",0
,(
function(self,aNode)
local theReturn=nil
if (((self["@nestedBlocks"]) > 0))==true then (function()
	local _s8_value=(true)
	self["@earlyReturn"]=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=((function()
return ((self):emmitReturn_((function()
return (((aNode):nodes()):do_((function(each)
return ((self):visit_(each))
end)))
end)))
end))
	theReturn=_s8_value
	return _s8_value
end)();
if not ((self["@earlyReturn"]))==true then return ((theReturn):value()); end;
(
function(_s8_rec)
	(_s8_rec):nextArgumentsPut_((function()
return ((self):emmitFunctionDoing_((function()
(self):nextPutAll_("$s8Ret$.result=");(
function(_s8_rec)
	(_s8_rec):nextArgumentsPut_((function()
return ((self):emmitFunctionDoing_(theReturn))
end));
	return ((_s8_rec):nextArgumentsPut_((function()
return (nil)
end)))
end
)(self);return ((self):nextPutAll_(";throw($s8Ret$)"))
end)))
end));
	return ((_s8_rec):nextArgumentsPut_((function()
return (nil)
end)))
end
)(self);
return (self);
end
)
,"visiting","visitReturnNode: aNode\r\n\r\n\t| theReturn |\r\n\tnestedBlocks > 0 ifTrue: [ earlyReturn := true ].\r\n\ttheReturn := [ self emmitReturn: [\r\n\t\taNode nodes do: [:each | self visit: each ]\r\n\t] ].\r\n\tearlyReturn ifFalse: [ ^theReturn value ].\r\n\tself nextArgumentsPut: [\r\n\t\tself emmitFunctionDoing: [\r\n\t\t\tself nextPutAll: '$s8Ret$.result='.\r\n\t\t\tself nextArgumentsPut: [\r\n\t\t\t\tself emmitFunctionDoing: theReturn.\r\n\t\t\t]; nextArgumentsPut: [].\r\n\t\t\tself nextPutAll: ';throw($s8Ret$)'\r\n\t\t]\r\n\t]; nextArgumentsPut: [] ","(\r\nfunction(self,aNode)\r\nlocal theReturn=nil\r\nif (((self[\"@nestedBlocks\"]) > 0))==true then (function()\r\n\tlocal _s8_value=(true)\r\n\tself[\"@earlyReturn\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((function()\r\nreturn ((self):emmitReturn_((function()\r\nreturn (((aNode):nodes()):do_((function(each)\r\nreturn ((self):visit_(each))\r\nend)))\r\nend)))\r\nend))\r\n\ttheReturn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((self[\"@earlyReturn\"]))==true then return ((theReturn):value()); end;\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextArgumentsPut_((function()\r\nreturn ((self):emmitFunctionDoing_((function()\r\n(self):nextPutAll_(\"$s8Ret$.result=\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextArgumentsPut_((function()\r\nreturn ((self):emmitFunctionDoing_(theReturn))\r\nend));\r\n\treturn ((_s8_rec):nextArgumentsPut_((function()\r\nreturn (nil)\r\nend)))\r\nend\r\n)(self);return ((self):nextPutAll_(\";throw($s8Ret$)\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):nextArgumentsPut_((function()\r\nreturn (nil)\r\nend)))\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"encodeSuperSend:",0
,(
function(self,aNode)
(self):nextPutAll_("smalltalk.superImplementor");
(self):nextArgumentsPut_((function()
return ((self):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):smalltalkNameFor_((self):currentClass())),",\"")),(self):asSelector_((aNode):selector()))),"\"")))
end));
(self):nextPutAll_(".apply(self, ");
(self):nextIndexPut_((function()
return ((self):visitSendArguments_(aNode))
end));
(self):nextPutAll_(")");
return (self);
end
)
,"encoding","encodeSuperSend: aNode\r\n\t\" Private - Generate code for super message send.\"\r\n\r\n\tself nextPutAll: 'smalltalk.superImplementor'.\r\n\tself nextArgumentsPut: [\r\n\t\tself nextPutAll:\r\n\t\t\t(self smalltalkNameFor: self currentClass)\r\n\t\t\t,',\"',(self asSelector: aNode selector) ,$\"\r\n\t].\r\n\tself nextPutAll: '.apply(self, '.\r\n\tself nextIndexPut: [ self visitSendArguments: aNode ].\r\n\tself nextPutAll: ')'. ","(\r\nfunction(self,aNode)\r\n(self):nextPutAll_(\"smalltalk.superImplementor\");\r\n(self):nextArgumentsPut_((function()\r\nreturn ((self):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):smalltalkNameFor_((self):currentClass())),\",\\\"\")),(self):asSelector_((aNode):selector()))),\"\\\"\")))\r\nend));\r\n(self):nextPutAll_(\".apply(self, \");\r\n(self):nextIndexPut_((function()\r\nreturn ((self):visitSendArguments_(aNode))\r\nend));\r\n(self):nextPutAll_(\")\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"coreOptimizations",0
,(
function(self)
return (smalltalk:newArray({"core", smalltalk:newArray({smalltalk:newArray({"class", "%receiver%.$klass"}), smalltalk:newArray({"isNil", "(nil.isNil_(%receiver%))"}), smalltalk:newArray({"notNil", "(nil.isNil_(%receiver%)===false)"}), smalltalk:newArray({"==", "(nil.is_eqeq_(%receiver%,%arg1%))"}), smalltalk:newArray({"===", "(%receiver% === %arg1%)"}), smalltalk:newArray({"||", "(%receiver% || %arg1%)"}), smalltalk:newArray({"basicAt:", "((function(){var $1$=(%receiver%[%arg1%]);if(nil.isNil_($1$))return nil;return $1$;})())"}), smalltalk:newArray({"ifUndefined:", "hasBlockNoArguments:", "(function(){var $1$=(%receiver%);if (typeof($1$)==\"undefined\") return %arg1%();return $1$;})()"}), smalltalk:newArray({"basicAt:ifAbsent:", "((function(){var $1$=(%receiver%[%arg1%]);if(nil.isNil_($1$))return (%arg2%.value());return $1$;})())"}), smalltalk:newArray({"basicAt:put:", "(%receiver%[%arg1%]=(%arg2%))"})})}));
end
)
,"optimization","coreOptimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(core  #(\r\n\t\t#(class\t'%receiver%.$klass' )\r\n\t\t#(isNil\t'(nil.isNil_(%receiver%))' )\r\n\t\t#(notNil '(nil.isNil_(%receiver%)===false)' )\r\n\t\t#(==\t'(nil.is_eqeq_(%receiver%,%arg1%))' )\r\n\t\t#(===\t'(%receiver% === %arg1%)' )\r\n\t\t#(||\t'(%receiver% || %arg1%)' )\r\n\t\t#(basicAt: '((function(){var $1$=(%receiver%[%arg1%]);if(nil.isNil_($1$))return nil;return $1$;})())' )\r\n\t\t#(ifUndefined: hasBlockNoArguments: '(function(){var $1$=(%receiver%);if (typeof($1$)==\"undefined\") return %arg1%();return $1$;})()' )\r\n\t\t#(basicAt:ifAbsent: '((function(){var $1$=(%receiver%[%arg1%]);if(nil.isNil_($1$))return (%arg2%.value());return $1$;})())' )\r\n\t\t#(basicAt:put: '(%receiver%[%arg1%]=(%arg2%))' )\r\n\t))","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"core\", smalltalk:newArray({smalltalk:newArray({\"class\", \"%receiver%.$klass\"}), smalltalk:newArray({\"isNil\", \"(nil.isNil_(%receiver%))\"}), smalltalk:newArray({\"notNil\", \"(nil.isNil_(%receiver%)===false)\"}), smalltalk:newArray({\"==\", \"(nil.is_eqeq_(%receiver%,%arg1%))\"}), smalltalk:newArray({\"===\", \"(%receiver% === %arg1%)\"}), smalltalk:newArray({\"||\", \"(%receiver% || %arg1%)\"}), smalltalk:newArray({\"basicAt:\", \"((function(){var $1$=(%receiver%[%arg1%]);if(nil.isNil_($1$))return nil;return $1$;})())\"}), smalltalk:newArray({\"ifUndefined:\", \"hasBlockNoArguments:\", \"(function(){var $1$=(%receiver%);if (typeof($1$)==\\\"undefined\\\") return %arg1%();return $1$;})()\"}), smalltalk:newArray({\"basicAt:ifAbsent:\", \"((function(){var $1$=(%receiver%[%arg1%]);if(nil.isNil_($1$))return (%arg2%.value());return $1$;})())\"}), smalltalk:newArray({\"basicAt:put:\", \"(%receiver%[%arg1%]=(%arg2%))\"})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"s8Optimizations",0
,(
function(self)
return (smalltalk:newArray({"s8", smalltalk:newArray({"core", smalltalk:newArray({"ifTrue:", "hasBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"ifTrue:", "noClient:", "if (%receiver%){%seq1%};"}), smalltalk:newArray({"ifTrue:", "((%receiver%).mustBeBoolean()==true ? %arg1%() : nil)"})})}), smalltalk:newArray({"ifFalse:", "hasBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"ifFalse:", "noClient:", "if (!(%receiver%)){%seq1%};"}), smalltalk:newArray({"ifFalse:", "((%receiver%).mustBeBoolean()==true ? nil : %arg1%())"})})}), smalltalk:newArray({"ifTrue:ifFalse:", "hasBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"ifTrue:ifFalse:", "noClient:", "if (%receiver%){%seq1%} else{%seq2%};"}), smalltalk:newArray({"ifTrue:ifFalse:", "((%receiver%).mustBeBoolean()==true ? %arg1%() : %arg2%())"})})}), smalltalk:newArray({"ifFalse:ifTrue:", "hasBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"ifFalse:ifTrue:", "noClient:", "if (%receiver%){%seq2%} else{%seq1%};"}), smalltalk:newArray({"ifFalse:ifTrue:", "((%receiver%).mustBeBoolean()==true ? %arg2%() : %arg1%())"})})}), smalltalk:newArray({"whileTrue", "receiverIsBlockNoArguments:", "(function(){while(%receiver%()){};return nil})()"}), smalltalk:newArray({"whileFalse", "receiverIsBlockNoArguments:", "(function(){while(!%receiver%()){};return nil})()"}), smalltalk:newArray({"orNil", "(function(){var $1$=(%receiver%);return (nil.isNil_($1$)) ? nil : $1$;})()"}), smalltalk:newArray({"whileTrue:", "allBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"whileTrue:", "noClient:", "while(%receiver%()){%seq1%};"}), smalltalk:newArray({"whileTrue:", "(function(){while(%receiver%()){%arg1%()};return nil})()"})})}), smalltalk:newArray({"whileFalse:", "allBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"whileFalse:", "noClient:", "while(!%receiver%()){%seq1%};"}), smalltalk:newArray({"whileFalse:", "(function(){while(!%receiver%()){%arg1%()};return nil})()"})})}), smalltalk:newArray({"ifNil:", "hasBlockArguments:", "(function(){var $1$=(%receiver%);return (nil.isNil_($1$)) ? %arg1%() : $1$;})()"}), smalltalk:newArray({"ifNotNil:", "hasBlockArguments:", "(function(){var $1$=(%receiver%);return (nil.isNil_($1$)===false) ? %arg1%(%receiver%) : $1$;})()"}), smalltalk:newArray({"timesRepeat:", "hasBlockNoArguments:", "(function(){for(var $1$=(%receiver%);$1$>0;$1$--){%arg1%()};return nil})()"}), smalltalk:newArray({"isKindOf:", "smalltalk.is_kindOf_(%receiver%,(%arg1%))"}), smalltalk:newArray({"respondsTo:", "smalltalk.responds_to_(%receiver%,(%arg1%))"}), smalltalk:newArray({"ifNil:ifNotNil:", "hasBlockNoArguments:", "(nil.isNil_(%receiver%)) ? %arg1%() : %arg2%()"}), smalltalk:newArray({"ifNotNil:ifNil:", "hasBlockNoArguments:", "(nil.isNil_(%receiver%)===false) ? %arg1%() : %arg2%()"})})}));
end
)
,"optimization","s8Optimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(s8\t#(\r\n\t\tcore\r\n\t\t#(ifTrue: hasBlockNoArguments: #(\r\n\t\t\t#(ifTrue: noClient: 'if (%receiver%){%seq1%};' )\r\n\t\t\t#(ifTrue: '((%receiver%).mustBeBoolean()==true ? %arg1%() : nil)' )\r\n\t\t))\r\n\t\t#(ifFalse: hasBlockNoArguments:  #(\r\n\t\t\t#(ifFalse: noClient: 'if (!(%receiver%)){%seq1%};' )\r\n\t\t\t#(ifFalse: '((%receiver%).mustBeBoolean()==true ? nil : %arg1%())' )\r\n\t\t))\r\n\t\t#(ifTrue:ifFalse: hasBlockNoArguments: #(\r\n\t\t\t#(ifTrue:ifFalse: noClient: 'if (%receiver%){%seq1%} else{%seq2%};' )\r\n\t\t\t#(ifTrue:ifFalse: '((%receiver%).mustBeBoolean()==true ? %arg1%() : %arg2%())' )\r\n\t\t))\r\n\t\t#(ifFalse:ifTrue: hasBlockNoArguments: #(\r\n\t\t\t#(ifFalse:ifTrue: noClient: 'if (%receiver%){%seq2%} else{%seq1%};' )\r\n\t\t\t#(ifFalse:ifTrue: '((%receiver%).mustBeBoolean()==true ? %arg2%() : %arg1%())' )\r\n\t\t))\r\n\t\t#(whileTrue receiverIsBlockNoArguments: '(function(){while(%receiver%()){};return nil})()' )\r\n\t\t#(whileFalse receiverIsBlockNoArguments: '(function(){while(!%receiver%()){};return nil})()' )\r\n\t\t#(orNil '(function(){var $1$=(%receiver%);return (nil.isNil_($1$)) ? nil : $1$;})()' )\r\n\t\t#(whileTrue: allBlockNoArguments: #(\r\n\t\t\t#(whileTrue: noClient: 'while(%receiver%()){%seq1%};' )\r\n\t\t\t#(whileTrue: '(function(){while(%receiver%()){%arg1%()};return nil})()' )\r\n\t\t))\r\n\t\t#(whileFalse: allBlockNoArguments: #(\r\n\t\t\t#(whileFalse: noClient: 'while(!%receiver%()){%seq1%};' )\r\n\t\t\t#(whileFalse: '(function(){while(!%receiver%()){%arg1%()};return nil})()' )\r\n\t\t))\r\n\t\t#(ifNil: hasBlockArguments: '(function(){var $1$=(%receiver%);return (nil.isNil_($1$)) ? %arg1%() : $1$;})()' )\r\n\t\t#(ifNotNil: hasBlockArguments: '(function(){var $1$=(%receiver%);return (nil.isNil_($1$)===false) ? %arg1%(%receiver%) : $1$;})()' )\r\n\t\t#(timesRepeat: hasBlockNoArguments: '(function(){for(var $1$=(%receiver%);$1$>0;$1$--){%arg1%()};return nil})()' )\r\n\t\t#(isKindOf: 'smalltalk.is_kindOf_(%receiver%,(%arg1%))' )\r\n\t\t#(respondsTo: 'smalltalk.responds_to_(%receiver%,(%arg1%))' )\r\n\t\t#(ifNil:ifNotNil: hasBlockNoArguments: '(nil.isNil_(%receiver%)) ? %arg1%() : %arg2%()' )\r\n\t\t#(ifNotNil:ifNil: hasBlockNoArguments: '(nil.isNil_(%receiver%)===false) ? %arg1%() : %arg2%()' )\r\n\t)) ","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"s8\", smalltalk:newArray({\"core\", smalltalk:newArray({\"ifTrue:\", \"hasBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"ifTrue:\", \"noClient:\", \"if (%receiver%){%seq1%};\"}), smalltalk:newArray({\"ifTrue:\", \"((%receiver%).mustBeBoolean()==true ? %arg1%() : nil)\"})})}), smalltalk:newArray({\"ifFalse:\", \"hasBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"ifFalse:\", \"noClient:\", \"if (!(%receiver%)){%seq1%};\"}), smalltalk:newArray({\"ifFalse:\", \"((%receiver%).mustBeBoolean()==true ? nil : %arg1%())\"})})}), smalltalk:newArray({\"ifTrue:ifFalse:\", \"hasBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"ifTrue:ifFalse:\", \"noClient:\", \"if (%receiver%){%seq1%} else{%seq2%};\"}), smalltalk:newArray({\"ifTrue:ifFalse:\", \"((%receiver%).mustBeBoolean()==true ? %arg1%() : %arg2%())\"})})}), smalltalk:newArray({\"ifFalse:ifTrue:\", \"hasBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"ifFalse:ifTrue:\", \"noClient:\", \"if (%receiver%){%seq2%} else{%seq1%};\"}), smalltalk:newArray({\"ifFalse:ifTrue:\", \"((%receiver%).mustBeBoolean()==true ? %arg2%() : %arg1%())\"})})}), smalltalk:newArray({\"whileTrue\", \"receiverIsBlockNoArguments:\", \"(function(){while(%receiver%()){};return nil})()\"}), smalltalk:newArray({\"whileFalse\", \"receiverIsBlockNoArguments:\", \"(function(){while(!%receiver%()){};return nil})()\"}), smalltalk:newArray({\"orNil\", \"(function(){var $1$=(%receiver%);return (nil.isNil_($1$)) ? nil : $1$;})()\"}), smalltalk:newArray({\"whileTrue:\", \"allBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"whileTrue:\", \"noClient:\", \"while(%receiver%()){%seq1%};\"}), smalltalk:newArray({\"whileTrue:\", \"(function(){while(%receiver%()){%arg1%()};return nil})()\"})})}), smalltalk:newArray({\"whileFalse:\", \"allBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"whileFalse:\", \"noClient:\", \"while(!%receiver%()){%seq1%};\"}), smalltalk:newArray({\"whileFalse:\", \"(function(){while(!%receiver%()){%arg1%()};return nil})()\"})})}), smalltalk:newArray({\"ifNil:\", \"hasBlockArguments:\", \"(function(){var $1$=(%receiver%);return (nil.isNil_($1$)) ? %arg1%() : $1$;})()\"}), smalltalk:newArray({\"ifNotNil:\", \"hasBlockArguments:\", \"(function(){var $1$=(%receiver%);return (nil.isNil_($1$)===false) ? %arg1%(%receiver%) : $1$;})()\"}), smalltalk:newArray({\"timesRepeat:\", \"hasBlockNoArguments:\", \"(function(){for(var $1$=(%receiver%);$1$>0;$1$--){%arg1%()};return nil})()\"}), smalltalk:newArray({\"isKindOf:\", \"smalltalk.is_kindOf_(%receiver%,(%arg1%))\"}), smalltalk:newArray({\"respondsTo:\", \"smalltalk.responds_to_(%receiver%,(%arg1%))\"}), smalltalk:newArray({\"ifNil:ifNotNil:\", \"hasBlockNoArguments:\", \"(nil.isNil_(%receiver%)) ? %arg1%() : %arg2%()\"}), smalltalk:newArray({\"ifNotNil:ifNil:\", \"hasBlockNoArguments:\", \"(nil.isNil_(%receiver%)===false) ? %arg1%() : %arg2%()\"})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"magnitudeOptimizations",0
,(
function(self)
return (smalltalk:newArray({"magnitude", smalltalk:newArray({smalltalk:newArray({">", "hasNumber:", "(%receiver% > %arg1%)"}), smalltalk:newArray({"<", "hasNumber:", "(%receiver% < %arg1%)"}), smalltalk:newArray({">=", "hasNumber:", "(%receiver% >= %arg1%)"}), smalltalk:newArray({"<=", "hasNumber:", "(%receiver% <= %arg1%)"})})}));
end
)
,"optimization","magnitudeOptimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(magnitude #(\r\n\t\t#(>  hasNumber: '(%receiver% > %arg1%)' )\r\n\t\t#(<  hasNumber: '(%receiver% < %arg1%)' )\r\n\t\t#(>= hasNumber: '(%receiver% >= %arg1%)' )\r\n\t\t#(<= hasNumber: '(%receiver% <= %arg1%)' )\r\n\t))","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"magnitude\", smalltalk:newArray({smalltalk:newArray({\">\", \"hasNumber:\", \"(%receiver% > %arg1%)\"}), smalltalk:newArray({\"<\", \"hasNumber:\", \"(%receiver% < %arg1%)\"}), smalltalk:newArray({\">=\", \"hasNumber:\", \"(%receiver% >= %arg1%)\"}), smalltalk:newArray({\"<=\", \"hasNumber:\", \"(%receiver% <= %arg1%)\"})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"mathOptimizations",0
,(
function(self)
return (smalltalk:newArray({"math", smalltalk:newArray({smalltalk:newArray({"+", "hasNumber:", "(%receiver% + %arg1%)"}), smalltalk:newArray({"-", "hasNumber:", "(%receiver% - %arg1%)"}), smalltalk:newArray({"*", "hasNumber:", "(%receiver% * %arg1%)"}), smalltalk:newArray({"/", "hasNumber:", "(%receiver% / %arg1%)"}), smalltalk:newArray({"=", "hasNumber:", "(%receiver% == %arg1%)"})})}));
end
)
,"optimization","mathOptimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(math #(\r\n\t\t#(+ hasNumber: '(%receiver% + %arg1%)' )\r\n\t\t#(#- hasNumber: '(%receiver% - %arg1%)' )\r\n\t\t#(* hasNumber: '(%receiver% * %arg1%)' )\r\n\t\t#(/ hasNumber: '(%receiver% / %arg1%)' )\r\n\t\t#(= hasNumber: '(%receiver% == %arg1%)' )\r\n\t))","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"math\", smalltalk:newArray({smalltalk:newArray({\"+\", \"hasNumber:\", \"(%receiver% + %arg1%)\"}), smalltalk:newArray({\"-\", \"hasNumber:\", \"(%receiver% - %arg1%)\"}), smalltalk:newArray({\"*\", \"hasNumber:\", \"(%receiver% * %arg1%)\"}), smalltalk:newArray({\"/\", \"hasNumber:\", \"(%receiver% / %arg1%)\"}), smalltalk:newArray({\"=\", \"hasNumber:\", \"(%receiver% == %arg1%)\"})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSEncoder,"defaultKnownOptimizations",0
,(
function(self)
return ((
function(_s8_rec)
	(_s8_rec):add_((self):s8Optimizations());
	(_s8_rec):add_((self):magnitudeOptimizations());
	(_s8_rec):add_((self):mathOptimizations());
	return ((_s8_rec):yourself())
end
)((smalltalk.Array):with_((self):coreOptimizations())));
end
)
,"defaults","defaultKnownOptimizations\r\n\t\" Private - Return the default knownOptimizations of the receiver. \"\r\n\r\n\t^(Array\twith: self coreOptimizations)\r\n\t\tadd: self s8Optimizations;\r\n\t\tadd: self magnitudeOptimizations;\r\n\t\tadd: self mathOptimizations;\r\n\t\tyourself","(\r\nfunction(self)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_((self):s8Optimizations());\r\n\t(_s8_rec):add_((self):magnitudeOptimizations());\r\n\t(_s8_rec):add_((self):mathOptimizations());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.Array):with_((self):coreOptimizations())));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder["$klass"],"supportsLanguage:",0
,(
function(self,aLanguage)
return (smalltalk:isObject_equalTo_((aLanguage),"lua"));
end
)
,"instantiation","supportsLanguage: aLanguage\r\n\t\" Private - Return true if instances of the receiver can encode to aLanguage. \"\r\n\r\n\t^aLanguage = #lua ","(\r\nfunction(self,aLanguage)\r\nreturn (smalltalk:isObject_equalTo_((aLanguage),\"lua\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder["$klass"],"initializeKernelInlines:",0
,(
function(self,pool)
return ((self):register_into_((self):kernelInlines(),pool));
end
)
,"inlines","initializeKernelInlines: pool\r\n\t\" Private - Initialize the inlines for methods in the category. \"\r\n\r\n\t^self register: self kernelInlines into: pool ","(\r\nfunction(self,pool)\r\nreturn ((self):register_into_((self):kernelInlines(),pool));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder["$klass"],"kernelInlines",0
,(
function(self)
return (smalltalk:newArray({smalltalk:newArray({"Object", smalltalk:newArray({smalltalk:newArray({"halt", "debug.debug()"}), smalltalk:newArray({"toString:", "tostring(anObject)"}), smalltalk:newArray({"isObject:", "\r\n\tlocal status, result = pcall(function() return type(anObject.yourself)==\"function\" end)\r\n\tif true then return status and result end"}), smalltalk:newArray({"typeOf:", "type(anObject)"}), smalltalk:newArray({"basicDelete:", "if self==nil then return else self[aString]=nil end"}), smalltalk:newArray({"basicPerform:withArguments:", smalltalk:newArray({"self", "fn(self,(table.unpack or unpack)(anArray))"})}), smalltalk:newArray({"asJSONObject", "{}"})})}), smalltalk:newArray({"Smalltalk", smalltalk:newArray({smalltalk:newArray({"includesKey:", "{}"}), smalltalk:newArray({"eval:", "\r\n\t-- (req v5.3) local fn,err  = load(anExpression)\r\n\tfunction f() local r = anExpression; anExpression= \"\"; return r end -- (req v5.1)\r\n\tlocal fn,err  = load(f)\r\n\tif fn then return fn() else\r\n\t\tself:note_(\" eval: Error \"..err) --the expression must be a lua expression (including return)\r\n\t\tself:note_(\" expression= \"..anExpression)\r\n\t\treturn nil\r\n\tend"})})}), smalltalk:newArray({"Smalltalk class", smalltalk:newArray({smalltalk:newArray({"global", "_G"}), smalltalk:newArray({"gc", "if collectgarbage() then return true end"})})}), smalltalk:newArray({"Behavior", smalltalk:newArray({smalltalk:newArray({"basicNew", "self[\"$fn\"]()"})})}), smalltalk:newArray({"CompiledMethod", smalltalk:newArray({})}), smalltalk:newArray({"Boolean", smalltalk:newArray({smalltalk:newArray({"not", "self == false"}), smalltalk:newArray({"=", "\r\n\tif anObject==nil then return false end\r\n\tif true then return self==anObject end"}), smalltalk:newArray({"ifTrue:ifFalse:", "\r\n\tif (self==true)\r\n\t\tthen return aBlock:value()\r\n\t\telse return anotherBlock:value() end"})})}), smalltalk:newArray({"Number", smalltalk:newArray({smalltalk:newArray({"=", "\r\n\tif (type(anObject)==\"number\")\r\n\t\tthen return self==anObject\r\n\t\telse return false\r\n\t\tend"}), smalltalk:newArray({">", "self > aNumber"}), smalltalk:newArray({">=", "self >= aNumber"}), smalltalk:newArray({"<", "self < aNumber"}), smalltalk:newArray({"<=", "self <= aNumber"}), smalltalk:newArray({"+", "self + aNumber"}), smalltalk:newArray({"-", "self - aNumber"}), smalltalk:newArray({"*", "self * aNumber"}), smalltalk:newArray({"/", "self / aNumber"}), smalltalk:newArray({"sin", "math.sin(self)"}), smalltalk:newArray({"cos", "math.cos(self)"}), smalltalk:newArray({"tan", "math.tan(self)"}), smalltalk:newArray({"arcCos", "math.acos(self)"}), smalltalk:newArray({"arcSin", "math.asin(self)"}), smalltalk:newArray({"arcTan", "math.atan(self)"}), smalltalk:newArray({"atan2:", "math.atan2(self,aNumber)"}), smalltalk:newArray({"sqrt", "math.sqrt(self)"}), smalltalk:newArray({"<<", "bit.lshift(self,aNumber)"}), smalltalk:newArray({">>", "bit.rshift(self,aNumber)"}), smalltalk:newArray({"raisedTo:", "math.pow(self,aNumber)"}), smalltalk:newArray({"max:", "math.max(self,aNumber)"}), smalltalk:newArray({"min:", "math.min(self,aNumber)"}), smalltalk:newArray({"rounded", "self + 0.5 - (self + 0.5) %% 1"}), smalltalk:newArray({"truncated", "math.floor(self)"}), smalltalk:newArray({"timesRepeat:", "for i=1,self do fn(i) end"}), smalltalk:newArray({"to:do:", "for i=self,aNumber do fn(i) end"}), smalltalk:newArray({"to:by:do:", "for i=self,aNumber,increment do fn(i) end"}), smalltalk:newArray({"printString", "tostring(self)"}), smalltalk:newArray({"toString:", "%:basen%(self,radix)"}), smalltalk:newArray({"isNumber", "if (self~=self) then return false else return (self~=math.huge and self~=-math.huge) end"}), smalltalk:newArray({"clearInterval", "if true then self:notImplementedYet_(\"clearInterval\") end"}), smalltalk:newArray({"clearTimeout", "if true then self:notImplementedYet_(\"clearTimeout\") end"})})}), smalltalk:newArray({"Number class", smalltalk:newArray({smalltalk:newArray({"pi", "math.pi"})})}), smalltalk:newArray({"BlockClosure", smalltalk:newArray({smalltalk:newArray({"whileTrue:", "while self() do fn() end"}), smalltalk:newArray({"whileFalse:", "while (self()==false) do fn() end"}), smalltalk:newArray({"valueWithPossibleArguments:", "self((table.unpack or unpack)(array))"}), smalltalk:newArray({"try:catch:", "\r\n\tlocal success, result = pcall(function() return fn() end)\r\n\tif success\r\n\t\tthen return result\r\n\t\telse return ab( self:smalltalkErrorOf_(result) ) end"}), smalltalk:newArray({"valueWithTimeout:", "self:notImplementedYet_(\"valueWithTimeout:\")"}), smalltalk:newArray({"valueWithInterval:", "self:notImplementedYet_(\"valueWithInterval:\")"}), smalltalk:newArray({"ensure:", "\r\n\tlocal success, result = pcall(function() return self() end)\r\n\tfn()\r\n\tif true then return result end"}), smalltalk:newArray({"ifCurtailed:", "\r\n\tlocal curtailed = true\r\n\tlocal success, result = pcall(function()\r\n\t\tlocal r = self()\r\n\t\tcurtailed = false\r\n\t\treturn r\r\n\tend)\r\n\tif (curtailed)\r\n\t\tthen exceptionBlock:value()\r\n\t\telse return result\r\n\t\tend"}), smalltalk:newArray({"argumentCount", "self:notImplementedYet_(\"argumentCount\")"})})}), smalltalk:newArray({"UndefinedObject", smalltalk:newArray({smalltalk:newArray({"asJSONObject", "nil"})})}), smalltalk:newArray({"Collection", smalltalk:newArray({smalltalk:newArray({"wrap:", "if %:isNil_%(anObject) --anObject==nil\r\n\tthen return smalltalk.UndefinedObject:alias()\r\n\telse return anObject end"}), smalltalk:newArray({"unwrap:", "--if anObject==nil then return nil end\r\n\t--if (type(anObject)==\"table\") and %:isNil_%(anObject)\r\n\tif %:isNil_%(anObject)\r\n\t\tthen return nil\r\n\t\telse return anObject end"})})}), smalltalk:newArray({"HashedSet", smalltalk:newArray({smalltalk:newArray({"initializeHash", "{}"}), smalltalk:newArray({"includes:", "(self[\"@hash\"][cookie])~=nil"}), smalltalk:newArray({"privateRemove:", "self[\"@hash\"][cookie] = nil"})})}), smalltalk:newArray({"SequenceableCollection", smalltalk:newArray({smalltalk:newArray({"indexOf:ifAbsent:", "\r\n\tfor i,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return i end\r\n\tend\r\n\tif true then return aBlock:value() end"}), smalltalk:newArray({"do:", "\r\n\tfor _,value in ipairs(self) do\r\n\t\tfn(self:unwrap_(value))\r\n\tend"}), smalltalk:newArray({"detect:ifNone:", "\r\n\tfor _,value in ipairs(self) do\r\n\t\tlocal v=self:unwrap_(value)\r\n\t\tif (fn(v)) then return v end\r\n\tend\r\n\tif true then return anotherBlock:value() end"}), smalltalk:newArray({"reversed", "\r\n\tlocal result = smalltalk.Array:new()\r\n\tlocal top = #self + 1\r\n\tfor i,v in ipairs(self) do result[top - i] = v end\r\n\tif true then return result end"}), smalltalk:newArray({"isEmpty", "#self==0"}), smalltalk:newArray({"reverseDo:", "for i = #self,1,-1 do fn(self:unwrap_(self[i])) end"}), smalltalk:newArray({"includes:", smalltalk:newArray({"\r\n\tfor _,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return true end\r\n\tend\r\n\tif true then return false end", "if true then end"})}), smalltalk:newArray({"occurrencesOf:", "\r\n\tlocal count = 0\r\n\tfor _,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then count = count + 1 end\r\n\tend\r\n\tif true then return count end"})})}), smalltalk:newArray({"String class", smalltalk:newArray({smalltalk:newArray({"fromString:", "if true then tostring(aString) end"}), smalltalk:newArray({"new", "\"\""}), smalltalk:newArray({"cr", "\"\\r\""}), smalltalk:newArray({"lf", "\"\\n\""}), smalltalk:newArray({"crlf", "\"\\r\\n\""}), smalltalk:newArray({"space", "\" \""}), smalltalk:newArray({"tab", "\"\\t\""}), smalltalk:newArray({"zero", "string.char(0)"}), smalltalk:newArray({"fromCharCode:", "\r\n\tif (type(anArrayOrNumber)==\"number\") then\r\n\t\treturn string.char(anArrayOrNumber)\r\n\tend\r\n\tif true then\r\n\t\tlocal fup = table.unpack or unpack\r\n\t\treturn (string.char(fup(anArrayOrNumber)))\r\n\tend"})})}), smalltalk:newArray({"String", smalltalk:newArray({smalltalk:newArray({"=", "if true then return self==anObject end"}), smalltalk:newArray({"size", "#self"}), smalltalk:newArray({"at:", "self:sub(anIndex,anIndex)"}), smalltalk:newArray({"do:", "for c in self:gmatch(\".\") do fn(c) end"}), smalltalk:newArray({"withIndexDo:", "for i=1,#self do fn(self:sub(i,i),i) end"}), smalltalk:newArray({"detect:ifNone:", "\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (fn(c)) then return c end\r\n\tend\r\n\tif true then return anotherBlock:value() end"}), smalltalk:newArray({"isLiteral", "\r\n\tif #self==0 then return false end\r\n\tif smalltalk.String:isBinarySelector_(self) then return true end\r\n\tif true then return string.find(self,\"[^a-zA-Z0-9_:]+\")==nil end"}), smalltalk:newArray({"occurrencesOf:", "\r\n\tlocal j\r\n\tlocal k,count = 0,0\r\n\trepeat\tj, k = self:find(aString, k + 1, true)\r\n\t\tif (j~=nil) then count=count+1 end\r\n\tuntil j == nil\r\n\tif true then return count end"}), smalltalk:newArray({"startsWith:", "if true then return (self:sub(1, #aString) == aString) end"}), smalltalk:newArray({"escaped", "self:notImplementedYet_(\"escaped\")"}), smalltalk:newArray({"unescaped", "\r\n\tlocal x16 = function(x) return string.char(tonumber(x, 16)) end\r\n\tif true then return self:gsub(\"%%%%(%%x%%x)\", x16) end"}), smalltalk:newArray({"asEncodedURI", "self:notImplementedYet_(\"asEncodedURI\")"}), smalltalk:newArray({"asDecodedURI", "self:notImplementedYet_(\"asDecodedURI\")"}), smalltalk:newArray({",", "if true then return self..(%:asString_%(aCollection)) end"}), smalltalk:newArray({"copyWith:", "self..(%:asString_%(anObject))"}), smalltalk:newArray({"copyFrom:to:", "self:sub(anIndex,anotherIndex)"}), smalltalk:newArray({"reversed", "if true then return self:reverse() end"}), smalltalk:newArray({"includes:", "local ignored"}), smalltalk:newArray({"indexOf:", "\r\n\tlocal index = self:find(aString,1,true)\r\n\tif not index\r\n\t\tthen return 0\r\n\t\telse return index end"}), smalltalk:newArray({"indexOf:startingAt:", "\r\n\tlocal index = self:find(aString,position,true)\r\n\tif not index\r\n\t\tthen return 0\r\n\t\telse return index end"}), smalltalk:newArray({"lastIndexOf:", "\r\n\tlocal i = 0\r\n\tlocal j = 0\r\n\tlocal k = 0\r\n\trepeat\ti = j\r\n\t\tj, k = self:find(aString, k + 1, true)\r\n\tuntil j == nil\r\n\tif true then return i end"}), smalltalk:newArray({"lastIndexOf:startingAt:", "\r\n\tlocal i, j\r\n\tlocal k = position\r\n\trepeat\ti = j\r\n\t\tj, k = self:find(aString, k + 1, true)\r\n\tuntil j == nil\r\n\tif true then return i end"}), smalltalk:newArray({"asNativeName", "self:asLuaName()"}), smalltalk:newArray({"asPrivateSelector", "local map = {\r\n\t\t[\":\"]=\"_\",\r\n\t\t[\"+\"]=\"_plus\",\r\n\t\t[\"-\"]=\"_minus\",\r\n\t\t[\"*\"]=\"_star\",\r\n\t\t[\"/\"]=\"_slash\",\r\n\t\t[\"|\"]=\"_bar\",\r\n\t\t[\"&\"]=\"_amp\",\r\n\t\t[\">\"]=\"_gt\",\r\n\t\t[\"<\"]=\"_lt\",\r\n\t\t[\"=\"]=\"_eq\",\r\n\t\t[\",\"]=\"_comma\",\r\n\t\t[\"@\"]=\"_at\",\r\n\t\t[\"~\"]=\"_no\",\r\n\t\t[\"\\\\\"]=\"_bk\"\r\n\t};\r\n\tresult = self:gsub(\".\",function(c) return map[c] end)"}), smalltalk:newArray({"asNative:", "if true then return self:slashEncoded() end"}), smalltalk:newArray({"replace:with:", "\r\n\tlocal result=\"\"\r\n\tlocal i,j\r\n\tlocal k = 0\r\n\trepeat\ti=k+1\r\n\t\tj, k = self:find(aString, i, true)\r\n\t\tif (j==nil) then\r\n\t\t\tresult=result..(self:sub(i))\r\n\t\telse\r\n\t\t\tresult=result..(self:sub(i,j-1)..anotherString)\r\n\t\tend\r\n\tuntil j == nil\r\n\tif true then return result end"}), smalltalk:newArray({"replaceRegexp:with:", "self:notImplementedYet_(\"replaceRegexp:with:\")"}), smalltalk:newArray({"tokenize:", "\r\n\tlocal result=smalltalk.Array:new()\r\n\tlocal i,j\r\n\tlocal k = 0\r\n\trepeat\ti=k+1\r\n\t\tj, k = self:find(aString, i, true)\r\n\t\tif (j==nil) then\r\n\t\t\tresult:add_(self:sub(i))\r\n\t\telse\r\n\t\t\tresult:add_(self:sub(i,j-#aString))\r\n\t\tend\r\n\tuntil j == nil\r\n\tif true then return result end"}), smalltalk:newArray({"match:", "self:notImplementedYet_(\"match:\")"}), smalltalk:newArray({"isLetter", "#self==1 and string.find(self,\"%%a\")==1"}), smalltalk:newArray({"isDigit", "#self==1 and string.find(self,\"%%d\")==1"}), smalltalk:newArray({"isUpperCase", "\r\n\tif (#self==0) then return false end\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (c<\"A\" or c>\"Z\") then return false end\r\n\tend\r\n\tif true then return true end"}), smalltalk:newArray({"isLowerCase", "\r\n\tif (#self==0) then return false end\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (c<\"a\" or c>\"z\") then return false end\r\n\tend\r\n\tif true then return true end"}), smalltalk:newArray({"asUppercase", "self:upper()"}), smalltalk:newArray({"asLowercase", "self:lower()"}), smalltalk:newArray({"asNumber", "tonumber(self)"}), smalltalk:newArray({">", "self > aString"}), smalltalk:newArray({"<", "self < aString"}), smalltalk:newArray({">=", "self >= aString"}), smalltalk:newArray({"<=", "self <= aString"}), smalltalk:newArray({"isCharacter", "#self == 1"}), smalltalk:newArray({"asciiValue", "string.byte(self)"}), smalltalk:newArray({"isSeparator", "#self==1 and self:find(\"%%s\")==1"})})}), smalltalk:newArray({"Array class", smalltalk:newArray({smalltalk:newArray({"basicNew:", "%:newArray%()"}), smalltalk:newArray({"with:", "self"}), smalltalk:newArray({"with:with:", "self"}), smalltalk:newArray({"with:with:with:", "self"}), smalltalk:newArray({"with:with:with:with:", "self"}), smalltalk:newArray({"withAll:", "\r\n\tlocal result = aCollection:asArray()\r\n\tif aCollection==result\r\n\t\tthen return result:copy()\r\n\t\telse return result\r\n\tend"}), smalltalk:newArray({"slice:", "self:notImplementedYet_(\"slice:\")"})})}), smalltalk:newArray({"Array", smalltalk:newArray({smalltalk:newArray({"size", "#self"}), smalltalk:newArray({"at:", "\r\n\tlocal value = self[anIndex]\r\n\tif value==nil then return self:objectNotFoundAt_(anIndex) end\r\n\tif true then return self:unwrap_(value) end"}), smalltalk:newArray({"at:ifAbsent:", "\r\n\tlocal value = self[anIndex]\r\n\tif (value==nil) then return aBlock:value() end\r\n\tif true then return self:unwrap_(value) end"}), smalltalk:newArray({"at:put:", "\r\n\tself[anIndex]=self:wrap_(anObject)\r\n\tif true then return anObject end"}), smalltalk:newArray({"do:", "\r\n\tfor _,value in ipairs(self) do\r\n\t\tfn(self:unwrap_(value))\r\n\tend"}), smalltalk:newArray({"addAll:", "\r\n\tlocal array = aCollection:asArray()\r\n\tfor i=1,#array do self[#self+1]=self:wrap_(array[i]) end"}), smalltalk:newArray({"shallowCopy", "\r\n\tresult = self:class():new()\r\n\tfor i=1,#self do result[#result+1]=self[i] end"}), smalltalk:newArray({"copyWithAll:", "\r\n\tlocal result = self:copy()\r\n\tresult:addAll_(aCollection)\r\n\tif true then return result end"}), smalltalk:newArray({",", "\r\n\tlocal result = self:copy()\r\n\tresult:addAll_(aCollection)\r\n\tif true then return result end"}), smalltalk:newArray({"join:", "table.concat(self,aString)"}), smalltalk:newArray({"sort:", "table.sort(self,fn)"}), smalltalk:newArray({"remove:ifAbsent:", "\r\n\tfor i,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return table.remove(self,i) end\r\n\tend\r\n\tif true then return aBlock:value() end"}), smalltalk:newArray({"add:", "self[#self+1]=self:wrap_(anObject)"}), smalltalk:newArray({"addFirst:", "table.insert(self,1,self:wrap_(anObject))"}), smalltalk:newArray({"addLast:", "self[#self+1]=self:wrap_(anObject)"}), smalltalk:newArray({"removeAll", "for i=#self,1,-1 do self[i]=nil end"}), smalltalk:newArray({"removeFirst", "table.remove(self,1)"}), smalltalk:newArray({"removeIndex:", "table.remove(self,index)"}), smalltalk:newArray({"removeLast", "self:unwrap_(table.remove(self))"}), smalltalk:newArray({"atAllPut:", "\r\n\tlocal what=self:wrap_(anObject)\r\n\tfor i=1,#self do self[i]=what end"}), smalltalk:newArray({"first", "\r\n\tlocal value=self[1]\r\n\tif (value~=nil) then return self:unwrap_(value) end"}), smalltalk:newArray({"second", "\r\n\tlocal value=self[2]\r\n\tif (value~=nil) then return self:unwrap_(value) end"}), smalltalk:newArray({"third", "\r\n\tlocal value=self[3]\r\n\tif (value~=nil) then return self:unwrap_(value) end"}), smalltalk:newArray({"fourth", "\t\r\n\tlocal value=self[4]\r\n\tif (value~=nil) then return self:unwrap_(value) end"}), smalltalk:newArray({"fifth", "\r\n\tlocal value=self[5]\r\n\tif (value~=nil) then return self:unwrap_(value) end"}), smalltalk:newArray({"sixth", "\r\n\tlocal value=self[6]\r\n\tif (value~=nil) then return self:unwrap_(value) end"})})}), smalltalk:newArray({"RegularExpression class", smalltalk:newArray({smalltalk:newArray({"fromString:flag:", "self:notImplementedYet_(\"fromString:flag:\")"})})}), smalltalk:newArray({"Exception", smalltalk:newArray({smalltalk:newArray({"signal", "error(self)"})})}), smalltalk:newArray({"ComposedAssociations", smalltalk:newArray({smalltalk:newArray({"hashObject", "{}"})})}), smalltalk:newArray({"KeyedCollection class", smalltalk:newArray({smalltalk:newArray({"@", "\r\n\tparts = smalltalk.Array:new()\r\n\tfor k,_ in pairs(jsObject) do parts:add_(k) end"})})}), smalltalk:newArray({"KeyedCollection", smalltalk:newArray({smalltalk:newArray({"newHash", "{}"})})}), smalltalk:newArray({"Dictionary class", smalltalk:newArray({smalltalk:newArray({"basicNew", "if true then return smalltalk.PoolDictionary:new() end"})})}), smalltalk:newArray({"PoolDictionary", smalltalk:newArray({smalltalk:newArray({"removeKey:ifAbsent:", "self[\"@hash\"][self:wrap_(aKey)]=nil"}), smalltalk:newArray({"at:ifAbsent:", "\r\n\tlocal found = self[\"@hash\"][self:wrap_(aKey)]\r\n\tif found~=nil\r\n\t\tthen return self:unwrap_(found)\r\n\t\telse return aBlock:value()\r\n\tend"}), smalltalk:newArray({"includesKey:", "self[\"@hash\"][self:wrap_(aKey)]~=nil"}), smalltalk:newArray({"keys", "\r\n\tlocal result=smalltalk.Array:new()\r\n\tfor k,_ in pairs(self[\"@hash\"]) do result:add_(k) end\r\n\tif true then return result end"})})}), smalltalk:newArray({"ClassBuilder", smalltalk:newArray({smalltalk:newArray({"addSubclassOf:named:instanceVariableNames:", "\r\n\t%:addClass%(aString, aClass, aCollection)\r\n\tif true then return smalltalk[aString] end"})})}), smalltalk:newArray({"StringStream", smalltalk:newArray({smalltalk:newArray({"peek", "\r\n\tlocal c = self[\"@collection\"]:at_(self:position()+1)\r\n\tif c==\"\" then return nil else return c end"}), smalltalk:newArray({"peekForAll:", "\r\n\tlocal start=self:position()\r\n\tif (self[\"@collection\"]:sub(start+1,start+#aCollection)~=aCollection) then return false end"})})}), smalltalk:newArray({"Random", smalltalk:newArray({smalltalk:newArray({"next", "if true then return math.random() end"})})}), smalltalk:newArray({"DateTime class", smalltalk:newArray({smalltalk:newArray({"new:", "if true then return self:notImplementedYet_(\"new:\") end"}), smalltalk:newArray({"today", "if true then return self:new() end"}), smalltalk:newArray({"now", "if true then return self:today() end"}), smalltalk:newArray({"msNow", "if true then return os.clock()*1000 end"})})}), smalltalk:newArray({"DateTime", smalltalk:newArray({smalltalk:newArray({"<", "self:notImplementedYet_(\"<\")"}), smalltalk:newArray({">", "self:notImplementedYet_(\">\")"}), smalltalk:newArray({"<=", "self:notImplementedYet_(\"<=\")"}), smalltalk:newArray({">=", "self:notImplementedYet_(\">=\")"}), smalltalk:newArray({"-", "self:notImplementedYet_(\"-\")"}), smalltalk:newArray({"+", "self:notImplementedYet_(\"+\")"}), smalltalk:newArray({"isValid", "self:notImplementedYet_(\"isValid\")"})})})}));
end
)
,"inlines","kernelInlines\r\n\t\" Private - Return the inlines for methods in the category. \"\r\n\r\n\t^#(\r\n#(Object #(\r\n#(halt\t\t'debug.debug()')\r\n\"#(toString\t'local unused')\"\r\n#(toString:\t'tostring(anObject)')\r\n#(isObject:\t'\r\n\tlocal status, result = pcall(function() return type(anObject.yourself)==\"function\" end)\r\n\tif true then return status and result end')\r\n#(typeOf:\t'type(anObject)')\r\n\"#(callableOf:\t'local unused')\"\r\n#(basicDelete:\t'if self==nil then return else self[aString]=nil end')\r\n#(basicPerform:withArguments:\t#('self' 'fn(self,(table.unpack or unpack)(anArray))'))\r\n#(asJSONObject\t'{}')\r\n))\r\n#(Smalltalk #(\r\n#(includesKey:\t'{}')\r\n#(eval:\t'\r\n\t-- (req v5.3) local fn,err  = load(anExpression)\r\n\tfunction f() local r = anExpression; anExpression= \"\"; return r end -- (req v5.1)\r\n\tlocal fn,err  = load(f)\r\n\tif fn then return fn() else\r\n\t\tself:note_(\" eval: Error \"..err) --the expression must be a lua expression (including return)\r\n\t\tself:note_(\" expression= \"..anExpression)\r\n\t\treturn nil\r\n\tend')\r\n))\r\n#('Smalltalk class' #(\r\n#(global\t'_G')\r\n#(gc\t'if collectgarbage() then return true end')\r\n))\r\n#(Behavior #(\r\n#(basicNew\t'self[\"$fn\"]()')\r\n\"#(fn\t\t'local unused')\"\r\n\"#(prototype\t'local unused')\"\r\n\"#(privateMethods\t'local unused')\"\r\n))\r\n#(CompiledMethod #(\r\n\"#(asClosure\t'local unused')\"\r\n))\r\n#(Boolean #(\r\n#(not 'self == false')\r\n#(=\t'\r\n\tif anObject==nil then return false end\r\n\tif true then return self==anObject end')\r\n#(ifTrue:ifFalse: '\r\n\tif (self==true)\r\n\t\tthen return aBlock:value()\r\n\t\telse return anotherBlock:value() end')\r\n))\r\n#(Number #(\r\n#(= '\r\n\tif (type(anObject)==\"number\")\r\n\t\tthen return self==anObject\r\n\t\telse return false\r\n\t\tend')\r\n#(> 'self > aNumber')\r\n#(>= 'self >= aNumber')\r\n#(< 'self < aNumber')\r\n#(<= 'self <= aNumber')\r\n#(+ 'self + aNumber')\r\n#(- 'self - aNumber')\r\n#(* 'self * aNumber')\r\n#(/ 'self / aNumber')\r\n#(sin 'math.sin(self)')\r\n#(cos 'math.cos(self)')\r\n#(tan 'math.tan(self)')\r\n#(arcCos 'math.acos(self)')\r\n#(arcSin 'math.asin(self)')\r\n#(arcTan 'math.atan(self)')\r\n#(atan2: 'math.atan2(self,aNumber)')\r\n#(sqrt 'math.sqrt(self)')\r\n#(<< 'bit.lshift(self,aNumber)')\r\n#(>> 'bit.rshift(self,aNumber)')\r\n#(raisedTo: 'math.pow(self,aNumber)')\r\n#(max: 'math.max(self,aNumber)')\r\n#(min: 'math.min(self,aNumber)')\r\n#(rounded 'self + 0.5 - (self + 0.5) %% 1')\r\n#(truncated 'math.floor(self)')\r\n#(timesRepeat: 'for i=1,self do fn(i) end')\r\n#(to:do: 'for i=self,aNumber do fn(i) end')\r\n#(to:by:do: 'for i=self,aNumber,increment do fn(i) end')\r\n#(printString 'tostring(self)')\r\n#(toString: '%:basen%(self,radix)')\r\n#(isNumber 'if (self~=self) then return false else return (self~=math.huge and self~=-math.huge) end')\r\n#(clearInterval 'if true then self:notImplementedYet_(\"clearInterval\") end')\r\n#(clearTimeout 'if true then self:notImplementedYet_(\"clearTimeout\") end')\r\n))\r\n#('Number class' #(\r\n#(pi 'math.pi')\r\n))\r\n#(BlockClosure #(\r\n#(whileTrue: 'while self() do fn() end')\r\n#(whileFalse: 'while (self()==false) do fn() end')\r\n#(valueWithPossibleArguments: 'self((table.unpack or unpack)(array))')\r\n#(try:catch: '\r\n\tlocal success, result = pcall(function() return fn() end)\r\n\tif success\r\n\t\tthen return result\r\n\t\telse return ab( self:smalltalkErrorOf_(result) ) end')\r\n#(valueWithTimeout: 'self:notImplementedYet_(\"valueWithTimeout:\")')\r\n#(valueWithInterval: 'self:notImplementedYet_(\"valueWithInterval:\")')\r\n#(ensure: '\r\n\tlocal success, result = pcall(function() return self() end)\r\n\tfn()\r\n\tif true then return result end')\r\n#(ifCurtailed: '\r\n\tlocal curtailed = true\r\n\tlocal success, result = pcall(function()\r\n\t\tlocal r = self()\r\n\t\tcurtailed = false\r\n\t\treturn r\r\n\tend)\r\n\tif (curtailed)\r\n\t\tthen exceptionBlock:value()\r\n\t\telse return result\r\n\t\tend')\r\n#(argumentCount 'self:notImplementedYet_(\"argumentCount\")')\r\n))\r\n#(UndefinedObject  #(\r\n#(asJSONObject 'nil')\r\n))\r\n#(Collection  #(\r\n#(wrap: 'if %:isNil_%(anObject) --anObject==nil\r\n\tthen return smalltalk.UndefinedObject:alias()\r\n\telse return anObject end')\r\n#(unwrap: '--if anObject==nil then return nil end\r\n\t--if (type(anObject)==\"table\") and %:isNil_%(anObject)\r\n\tif %:isNil_%(anObject)\r\n\t\tthen return nil\r\n\t\telse return anObject end')\r\n))\r\n#(HashedSet #(\r\n#(initializeHash '{}')\r\n#(includes: '(self[\"@hash\"][cookie])~=nil')\r\n\"#(privateAdd: 'local unused')\"\r\n#(privateRemove: 'self[\"@hash\"][cookie] = nil')\r\n))\r\n#(SequenceableCollection #(\r\n#(indexOf:ifAbsent: '\r\n\tfor i,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return i end\r\n\tend\r\n\tif true then return aBlock:value() end')\r\n#(do: '\r\n\tfor _,value in ipairs(self) do\r\n\t\tfn(self:unwrap_(value))\r\n\tend')\r\n#(detect:ifNone: '\r\n\tfor _,value in ipairs(self) do\r\n\t\tlocal v=self:unwrap_(value)\r\n\t\tif (fn(v)) then return v end\r\n\tend\r\n\tif true then return anotherBlock:value() end')\r\n#(reversed '\r\n\tlocal result = smalltalk.Array:new()\r\n\tlocal top = #self + 1\r\n\tfor i,v in ipairs(self) do result[top - i] = v end\r\n\tif true then return result end')\r\n#(isEmpty '#self==0')\r\n#(reverseDo:  'for i = #self,1,-1 do fn(self:unwrap_(self[i])) end')\r\n#(includes: #('\r\n\tfor _,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return true end\r\n\tend\r\n\tif true then return false end' 'if true then end'))\r\n#(occurrencesOf: '\r\n\tlocal count = 0\r\n\tfor _,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then count = count + 1 end\r\n\tend\r\n\tif true then return count end')\r\n))\r\n#('String class' #(\r\n#(fromString: 'if true then tostring(aString) end')\r\n#(new\t'\"\"')\r\n#(cr \t'\"\\r\"')\r\n#(lf \t'\"\\n\"')\r\n#(crlf \t'\"\\r\\n\"')\r\n#(space\t'\" \"')\r\n#(tab\t'\"\\t\"')\r\n#(zero\t'string.char(0)')\r\n#(fromCharCode: '\r\n\tif (type(anArrayOrNumber)==\"number\") then\r\n\t\treturn string.char(anArrayOrNumber)\r\n\tend\r\n\tif true then\r\n\t\tlocal fup = table.unpack or unpack\r\n\t\treturn (string.char(fup(anArrayOrNumber)))\r\n\tend')\r\n))\r\n#(String #(\r\n#(=\t'if true then return self==anObject end')\r\n#(size\t'#self')\r\n#(at:\t'self:sub(anIndex,anIndex)')\r\n#(do: \t'for c in self:gmatch(\".\") do fn(c) end')\r\n#(withIndexDo: 'for i=1,#self do fn(self:sub(i,i),i) end')\r\n#(detect:ifNone: '\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (fn(c)) then return c end\r\n\tend\r\n\tif true then return anotherBlock:value() end')\r\n#(isLiteral '\r\n\tif #self==0 then return false end\r\n\tif smalltalk.String:isBinarySelector_(self) then return true end\r\n\tif true then return string.find(self,\"[^a-zA-Z0-9_:]+\")==nil end')\r\n#(occurrencesOf: '\r\n\tlocal j\r\n\tlocal k,count = 0,0\r\n\trepeat\tj, k = self:find(aString, k + 1, true)\r\n\t\tif (j~=nil) then count=count+1 end\r\n\tuntil j == nil\r\n\tif true then return count end')\r\n#(startsWith: 'if true then return (self:sub(1, #aString) == aString) end')\r\n#(escaped 'self:notImplementedYet_(\"escaped\")')\r\n#(unescaped '\r\n\tlocal x16 = function(x) return string.char(tonumber(x, 16)) end\r\n\tif true then return self:gsub(\"%%%%(%%x%%x)\", x16) end')\r\n#(asEncodedURI 'self:notImplementedYet_(\"asEncodedURI\")')\r\n#(asDecodedURI 'self:notImplementedYet_(\"asDecodedURI\")')\r\n#(, 'if true then return self..(%:asString_%(aCollection)) end')\r\n#(copyWith: 'self..(%:asString_%(anObject))')\r\n#(copyFrom:to: 'self:sub(anIndex,anotherIndex)')\r\n#(reversed 'if true then return self:reverse() end')\r\n#(includes: 'local ignored')\r\n#(indexOf: '\r\n\tlocal index = self:find(aString,1,true)\r\n\tif not index\r\n\t\tthen return 0\r\n\t\telse return index end')\r\n#(indexOf:startingAt: '\r\n\tlocal index = self:find(aString,position,true)\r\n\tif not index\r\n\t\tthen return 0\r\n\t\telse return index end')\r\n#(lastIndexOf: '\r\n\tlocal i = 0\r\n\tlocal j = 0\r\n\tlocal k = 0\r\n\trepeat\ti = j\r\n\t\tj, k = self:find(aString, k + 1, true)\r\n\tuntil j == nil\r\n\tif true then return i end')\r\n#(lastIndexOf:startingAt: '\r\n\tlocal i, j\r\n\tlocal k = position\r\n\trepeat\ti = j\r\n\t\tj, k = self:find(aString, k + 1, true)\r\n\tuntil j == nil\r\n\tif true then return i end')\r\n#(asNativeName 'self:asLuaName()')\r\n#(asPrivateSelector 'local map = {\r\n\t\t[\":\"]=\"_\",\r\n\t\t[\"+\"]=\"_plus\",\r\n\t\t[\"-\"]=\"_minus\",\r\n\t\t[\"*\"]=\"_star\",\r\n\t\t[\"/\"]=\"_slash\",\r\n\t\t[\"|\"]=\"_bar\",\r\n\t\t[\"&\"]=\"_amp\",\r\n\t\t[\">\"]=\"_gt\",\r\n\t\t[\"<\"]=\"_lt\",\r\n\t\t[\"=\"]=\"_eq\",\r\n\t\t[\",\"]=\"_comma\",\r\n\t\t[\"@\"]=\"_at\",\r\n\t\t[\"~\"]=\"_no\",\r\n\t\t[\"\\\\\"]=\"_bk\"\r\n\t};\r\n\tresult = self:gsub(\".\",function(c) return map[c] end)')\r\n#(asNative: 'if true then return self:slashEncoded() end')\r\n#(replace:with: '\r\n\tlocal result=\"\"\r\n\tlocal i,j\r\n\tlocal k = 0\r\n\trepeat\ti=k+1\r\n\t\tj, k = self:find(aString, i, true)\r\n\t\tif (j==nil) then\r\n\t\t\tresult=result..(self:sub(i))\r\n\t\telse\r\n\t\t\tresult=result..(self:sub(i,j-1)..anotherString)\r\n\t\tend\r\n\tuntil j == nil\r\n\tif true then return result end')\r\n#(replaceRegexp:with: 'self:notImplementedYet_(\"replaceRegexp:with:\")')\r\n#(tokenize: '\r\n\tlocal result=smalltalk.Array:new()\r\n\tlocal i,j\r\n\tlocal k = 0\r\n\trepeat\ti=k+1\r\n\t\tj, k = self:find(aString, i, true)\r\n\t\tif (j==nil) then\r\n\t\t\tresult:add_(self:sub(i))\r\n\t\telse\r\n\t\t\tresult:add_(self:sub(i,j-#aString))\r\n\t\tend\r\n\tuntil j == nil\r\n\tif true then return result end')\r\n#(match: 'self:notImplementedYet_(\"match:\")')\r\n#(isLetter '#self==1 and string.find(self,\"%%a\")==1')\r\n#(isDigit '#self==1 and string.find(self,\"%%d\")==1')\r\n\"#(isAlphaNumeric 'local unused')\"\r\n#(isUpperCase '\r\n\tif (#self==0) then return false end\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (c<\"A\" or c>\"Z\") then return false end\r\n\tend\r\n\tif true then return true end')\r\n#(isLowerCase '\r\n\tif (#self==0) then return false end\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (c<\"a\" or c>\"z\") then return false end\r\n\tend\r\n\tif true then return true end')\r\n#(asUppercase 'self:upper()')\r\n#(asLowercase 'self:lower()')\r\n#(asNumber 'tonumber(self)')\r\n#(> 'self > aString')\r\n#(< 'self < aString')\r\n#(>= 'self >= aString')\r\n#(<= 'self <= aString')\r\n#(isCharacter '#self == 1')\r\n#(asciiValue 'string.byte(self)')\r\n#(isSeparator '#self==1 and self:find(\"%%s\")==1')\r\n))\r\n#('Array class' #(\r\n#(basicNew: '%:newArray%()')\r\n#(with: 'self')\r\n#(with:with: 'self')\r\n#(with:with:with: 'self')\r\n#(with:with:with:with: 'self')\r\n#(withAll: '\r\n\tlocal result = aCollection:asArray()\r\n\tif aCollection==result\r\n\t\tthen return result:copy()\r\n\t\telse return result\r\n\tend')\r\n#(slice: 'self:notImplementedYet_(\"slice:\")')\r\n))\r\n#(Array #(\r\n#(size '#self')\r\n#(at: '\r\n\tlocal value = self[anIndex]\r\n\tif value==nil then return self:objectNotFoundAt_(anIndex) end\r\n\tif true then return self:unwrap_(value) end')\r\n#(at:ifAbsent: '\r\n\tlocal value = self[anIndex]\r\n\tif (value==nil) then return aBlock:value() end\r\n\tif true then return self:unwrap_(value) end')\r\n#(at:put: '\r\n\tself[anIndex]=self:wrap_(anObject)\r\n\tif true then return anObject end')\r\n#(do: '\r\n\tfor _,value in ipairs(self) do\r\n\t\tfn(self:unwrap_(value))\r\n\tend')\r\n#(addAll: '\r\n\tlocal array = aCollection:asArray()\r\n\tfor i=1,#array do self[#self+1]=self:wrap_(array[i]) end')\r\n#(shallowCopy '\r\n\tresult = self:class():new()\r\n\tfor i=1,#self do result[#result+1]=self[i] end')\r\n#(copyWithAll: '\r\n\tlocal result = self:copy()\r\n\tresult:addAll_(aCollection)\r\n\tif true then return result end')\r\n#(, '\r\n\tlocal result = self:copy()\r\n\tresult:addAll_(aCollection)\r\n\tif true then return result end')\r\n#(join: 'table.concat(self,aString)')\r\n#(sort: 'table.sort(self,fn)')\r\n#(remove:ifAbsent: '\r\n\tfor i,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return table.remove(self,i) end\r\n\tend\r\n\tif true then return aBlock:value() end')\r\n#(add: 'self[#self+1]=self:wrap_(anObject)')\r\n#(addFirst: 'table.insert(self,1,self:wrap_(anObject))')\r\n#(addLast: 'self[#self+1]=self:wrap_(anObject)')\r\n#(removeAll 'for i=#self,1,-1 do self[i]=nil end')\r\n#(removeFirst 'table.remove(self,1)')\r\n#(removeIndex: 'table.remove(self,index)')\r\n#(removeLast 'self:unwrap_(table.remove(self))')\r\n#(atAllPut: '\r\n\tlocal what=self:wrap_(anObject)\r\n\tfor i=1,#self do self[i]=what end')\r\n#(first '\r\n\tlocal value=self[1]\r\n\tif (value~=nil) then return self:unwrap_(value) end')\r\n#(second '\r\n\tlocal value=self[2]\r\n\tif (value~=nil) then return self:unwrap_(value) end')\r\n#(third '\r\n\tlocal value=self[3]\r\n\tif (value~=nil) then return self:unwrap_(value) end')\r\n#(fourth '\t\r\n\tlocal value=self[4]\r\n\tif (value~=nil) then return self:unwrap_(value) end')\r\n#(fifth '\r\n\tlocal value=self[5]\r\n\tif (value~=nil) then return self:unwrap_(value) end')\r\n#(sixth '\r\n\tlocal value=self[6]\r\n\tif (value~=nil) then return self:unwrap_(value) end')\r\n))\r\n#('RegularExpression class' #(\r\n#(fromString:flag: 'self:notImplementedYet_(\"fromString:flag:\")')\r\n))\r\n#(Exception #(\r\n#(signal 'error(self)')\r\n))\r\n#(ComposedAssociations #(\r\n#(hashObject '{}')\r\n))\r\n#('KeyedCollection class' #(\r\n#(@ '\r\n\tparts = smalltalk.Array:new()\r\n\tfor k,_ in pairs(jsObject) do parts:add_(k) end')\r\n))\r\n#(KeyedCollection #(\r\n#(newHash '{}')\r\n))\r\n#('Dictionary class' #(\r\n#(basicNew 'if true then return smalltalk.PoolDictionary:new() end')\r\n))\r\n#(PoolDictionary #(\r\n\"#(validKey: 'local unused')\"\r\n\"#(at:put: 'local unused')\"\r\n#(removeKey:ifAbsent: 'self[\"@hash\"][self:wrap_(aKey)]=nil')\r\n#(at:ifAbsent: '\r\n\tlocal found = self[\"@hash\"][self:wrap_(aKey)]\r\n\tif found~=nil\r\n\t\tthen return self:unwrap_(found)\r\n\t\telse return aBlock:value()\r\n\tend')\r\n#(includesKey: 'self[\"@hash\"][self:wrap_(aKey)]~=nil')\r\n#(keys '\r\n\tlocal result=smalltalk.Array:new()\r\n\tfor k,_ in pairs(self[\"@hash\"]) do result:add_(k) end\r\n\tif true then return result end')\r\n))\r\n#(ClassBuilder #(\r\n#(addSubclassOf:named:instanceVariableNames: '\r\n\t%:addClass%(aString, aClass, aCollection)\r\n\tif true then return smalltalk[aString] end')\r\n))\r\n#(StringStream #(\r\n#(peek '\r\n\tlocal c = self[\"@collection\"]:at_(self:position()+1)\r\n\tif c==\"\" then return nil else return c end')\r\n#(peekForAll: '\r\n\tlocal start=self:position()\r\n\tif (self[\"@collection\"]:sub(start+1,start+#aCollection)~=aCollection) then return false end')\r\n))\r\n#(Random #(\r\n#(next 'if true then return math.random() end')\r\n))\r\n#('DateTime class' #(\r\n#(new: 'if true then return self:notImplementedYet_(\"new:\") end')\r\n#(today 'if true then return self:new() end')\r\n#(now 'if true then return self:today() end')\r\n#(msNow 'if true then return os.clock()*1000 end')\r\n))\r\n#(DateTime #(\r\n#(< 'self:notImplementedYet_(\"<\")')\r\n#(> 'self:notImplementedYet_(\">\")')\r\n#(<= 'self:notImplementedYet_(\"<=\")')\r\n#(>= 'self:notImplementedYet_(\">=\")')\r\n#(- 'self:notImplementedYet_(\"-\")')\r\n#(+ 'self:notImplementedYet_(\"+\")')\r\n#(isValid 'self:notImplementedYet_(\"isValid\")')\r\n))\r\n\t) ","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({smalltalk:newArray({\"Object\", smalltalk:newArray({smalltalk:newArray({\"halt\", \"debug.debug()\"}), smalltalk:newArray({\"toString:\", \"tostring(anObject)\"}), smalltalk:newArray({\"isObject:\", \"\\r\\n\\tlocal status, result = pcall(function() return type(anObject.yourself)==\\\"function\\\" end)\\r\\n\\tif true then return status and result end\"}), smalltalk:newArray({\"typeOf:\", \"type(anObject)\"}), smalltalk:newArray({\"basicDelete:\", \"if self==nil then return else self[aString]=nil end\"}), smalltalk:newArray({\"basicPerform:withArguments:\", smalltalk:newArray({\"self\", \"fn(self,(table.unpack or unpack)(anArray))\"})}), smalltalk:newArray({\"asJSONObject\", \"{}\"})})}), smalltalk:newArray({\"Smalltalk\", smalltalk:newArray({smalltalk:newArray({\"includesKey:\", \"{}\"}), smalltalk:newArray({\"eval:\", \"\\r\\n\\t-- (req v5.3) local fn,err  = load(anExpression)\\r\\n\\tfunction f() local r = anExpression; anExpression= \\\"\\\"; return r end -- (req v5.1)\\r\\n\\tlocal fn,err  = load(f)\\r\\n\\tif fn then return fn() else\\r\\n\\t\\tself:note_(\\\" eval: Error \\\"..err) --the expression must be a lua expression (including return)\\r\\n\\t\\tself:note_(\\\" expression= \\\"..anExpression)\\r\\n\\t\\treturn nil\\r\\n\\tend\"})})}), smalltalk:newArray({\"Smalltalk class\", smalltalk:newArray({smalltalk:newArray({\"global\", \"_G\"}), smalltalk:newArray({\"gc\", \"if collectgarbage() then return true end\"})})}), smalltalk:newArray({\"Behavior\", smalltalk:newArray({smalltalk:newArray({\"basicNew\", \"self[\\\"$fn\\\"]()\"})})}), smalltalk:newArray({\"CompiledMethod\", smalltalk:newArray({})}), smalltalk:newArray({\"Boolean\", smalltalk:newArray({smalltalk:newArray({\"not\", \"self == false\"}), smalltalk:newArray({\"=\", \"\\r\\n\\tif anObject==nil then return false end\\r\\n\\tif true then return self==anObject end\"}), smalltalk:newArray({\"ifTrue:ifFalse:\", \"\\r\\n\\tif (self==true)\\r\\n\\t\\tthen return aBlock:value()\\r\\n\\t\\telse return anotherBlock:value() end\"})})}), smalltalk:newArray({\"Number\", smalltalk:newArray({smalltalk:newArray({\"=\", \"\\r\\n\\tif (type(anObject)==\\\"number\\\")\\r\\n\\t\\tthen return self==anObject\\r\\n\\t\\telse return false\\r\\n\\t\\tend\"}), smalltalk:newArray({\">\", \"self > aNumber\"}), smalltalk:newArray({\">=\", \"self >= aNumber\"}), smalltalk:newArray({\"<\", \"self < aNumber\"}), smalltalk:newArray({\"<=\", \"self <= aNumber\"}), smalltalk:newArray({\"+\", \"self + aNumber\"}), smalltalk:newArray({\"-\", \"self - aNumber\"}), smalltalk:newArray({\"*\", \"self * aNumber\"}), smalltalk:newArray({\"/\", \"self / aNumber\"}), smalltalk:newArray({\"sin\", \"math.sin(self)\"}), smalltalk:newArray({\"cos\", \"math.cos(self)\"}), smalltalk:newArray({\"tan\", \"math.tan(self)\"}), smalltalk:newArray({\"arcCos\", \"math.acos(self)\"}), smalltalk:newArray({\"arcSin\", \"math.asin(self)\"}), smalltalk:newArray({\"arcTan\", \"math.atan(self)\"}), smalltalk:newArray({\"atan2:\", \"math.atan2(self,aNumber)\"}), smalltalk:newArray({\"sqrt\", \"math.sqrt(self)\"}), smalltalk:newArray({\"<<\", \"bit.lshift(self,aNumber)\"}), smalltalk:newArray({\">>\", \"bit.rshift(self,aNumber)\"}), smalltalk:newArray({\"raisedTo:\", \"math.pow(self,aNumber)\"}), smalltalk:newArray({\"max:\", \"math.max(self,aNumber)\"}), smalltalk:newArray({\"min:\", \"math.min(self,aNumber)\"}), smalltalk:newArray({\"rounded\", \"self + 0.5 - (self + 0.5) %% 1\"}), smalltalk:newArray({\"truncated\", \"math.floor(self)\"}), smalltalk:newArray({\"timesRepeat:\", \"for i=1,self do fn(i) end\"}), smalltalk:newArray({\"to:do:\", \"for i=self,aNumber do fn(i) end\"}), smalltalk:newArray({\"to:by:do:\", \"for i=self,aNumber,increment do fn(i) end\"}), smalltalk:newArray({\"printString\", \"tostring(self)\"}), smalltalk:newArray({\"toString:\", \"%:basen%(self,radix)\"}), smalltalk:newArray({\"isNumber\", \"if (self~=self) then return false else return (self~=math.huge and self~=-math.huge) end\"}), smalltalk:newArray({\"clearInterval\", \"if true then self:notImplementedYet_(\\\"clearInterval\\\") end\"}), smalltalk:newArray({\"clearTimeout\", \"if true then self:notImplementedYet_(\\\"clearTimeout\\\") end\"})})}), smalltalk:newArray({\"Number class\", smalltalk:newArray({smalltalk:newArray({\"pi\", \"math.pi\"})})}), smalltalk:newArray({\"BlockClosure\", smalltalk:newArray({smalltalk:newArray({\"whileTrue:\", \"while self() do fn() end\"}), smalltalk:newArray({\"whileFalse:\", \"while (self()==false) do fn() end\"}), smalltalk:newArray({\"valueWithPossibleArguments:\", \"self((table.unpack or unpack)(array))\"}), smalltalk:newArray({\"try:catch:\", \"\\r\\n\\tlocal success, result = pcall(function() return fn() end)\\r\\n\\tif success\\r\\n\\t\\tthen return result\\r\\n\\t\\telse return ab( self:smalltalkErrorOf_(result) ) end\"}), smalltalk:newArray({\"valueWithTimeout:\", \"self:notImplementedYet_(\\\"valueWithTimeout:\\\")\"}), smalltalk:newArray({\"valueWithInterval:\", \"self:notImplementedYet_(\\\"valueWithInterval:\\\")\"}), smalltalk:newArray({\"ensure:\", \"\\r\\n\\tlocal success, result = pcall(function() return self() end)\\r\\n\\tfn()\\r\\n\\tif true then return result end\"}), smalltalk:newArray({\"ifCurtailed:\", \"\\r\\n\\tlocal curtailed = true\\r\\n\\tlocal success, result = pcall(function()\\r\\n\\t\\tlocal r = self()\\r\\n\\t\\tcurtailed = false\\r\\n\\t\\treturn r\\r\\n\\tend)\\r\\n\\tif (curtailed)\\r\\n\\t\\tthen exceptionBlock:value()\\r\\n\\t\\telse return result\\r\\n\\t\\tend\"}), smalltalk:newArray({\"argumentCount\", \"self:notImplementedYet_(\\\"argumentCount\\\")\"})})}), smalltalk:newArray({\"UndefinedObject\", smalltalk:newArray({smalltalk:newArray({\"asJSONObject\", \"nil\"})})}), smalltalk:newArray({\"Collection\", smalltalk:newArray({smalltalk:newArray({\"wrap:\", \"if %:isNil_%(anObject) --anObject==nil\\r\\n\\tthen return smalltalk.UndefinedObject:alias()\\r\\n\\telse return anObject end\"}), smalltalk:newArray({\"unwrap:\", \"--if anObject==nil then return nil end\\r\\n\\t--if (type(anObject)==\\\"table\\\") and %:isNil_%(anObject)\\r\\n\\tif %:isNil_%(anObject)\\r\\n\\t\\tthen return nil\\r\\n\\t\\telse return anObject end\"})})}), smalltalk:newArray({\"HashedSet\", smalltalk:newArray({smalltalk:newArray({\"initializeHash\", \"{}\"}), smalltalk:newArray({\"includes:\", \"(self[\\\"@hash\\\"][cookie])~=nil\"}), smalltalk:newArray({\"privateRemove:\", \"self[\\\"@hash\\\"][cookie] = nil\"})})}), smalltalk:newArray({\"SequenceableCollection\", smalltalk:newArray({smalltalk:newArray({\"indexOf:ifAbsent:\", \"\\r\\n\\tfor i,value in ipairs(self) do\\r\\n\\t\\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return i end\\r\\n\\tend\\r\\n\\tif true then return aBlock:value() end\"}), smalltalk:newArray({\"do:\", \"\\r\\n\\tfor _,value in ipairs(self) do\\r\\n\\t\\tfn(self:unwrap_(value))\\r\\n\\tend\"}), smalltalk:newArray({\"detect:ifNone:\", \"\\r\\n\\tfor _,value in ipairs(self) do\\r\\n\\t\\tlocal v=self:unwrap_(value)\\r\\n\\t\\tif (fn(v)) then return v end\\r\\n\\tend\\r\\n\\tif true then return anotherBlock:value() end\"}), smalltalk:newArray({\"reversed\", \"\\r\\n\\tlocal result = smalltalk.Array:new()\\r\\n\\tlocal top = #self + 1\\r\\n\\tfor i,v in ipairs(self) do result[top - i] = v end\\r\\n\\tif true then return result end\"}), smalltalk:newArray({\"isEmpty\", \"#self==0\"}), smalltalk:newArray({\"reverseDo:\", \"for i = #self,1,-1 do fn(self:unwrap_(self[i])) end\"}), smalltalk:newArray({\"includes:\", smalltalk:newArray({\"\\r\\n\\tfor _,value in ipairs(self) do\\r\\n\\t\\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return true end\\r\\n\\tend\\r\\n\\tif true then return false end\", \"if true then end\"})}), smalltalk:newArray({\"occurrencesOf:\", \"\\r\\n\\tlocal count = 0\\r\\n\\tfor _,value in ipairs(self) do\\r\\n\\t\\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then count = count + 1 end\\r\\n\\tend\\r\\n\\tif true then return count end\"})})}), smalltalk:newArray({\"String class\", smalltalk:newArray({smalltalk:newArray({\"fromString:\", \"if true then tostring(aString) end\"}), smalltalk:newArray({\"new\", \"\\\"\\\"\"}), smalltalk:newArray({\"cr\", \"\\\"\\\\r\\\"\"}), smalltalk:newArray({\"lf\", \"\\\"\\\\n\\\"\"}), smalltalk:newArray({\"crlf\", \"\\\"\\\\r\\\\n\\\"\"}), smalltalk:newArray({\"space\", \"\\\" \\\"\"}), smalltalk:newArray({\"tab\", \"\\\"\\\\t\\\"\"}), smalltalk:newArray({\"zero\", \"string.char(0)\"}), smalltalk:newArray({\"fromCharCode:\", \"\\r\\n\\tif (type(anArrayOrNumber)==\\\"number\\\") then\\r\\n\\t\\treturn string.char(anArrayOrNumber)\\r\\n\\tend\\r\\n\\tif true then\\r\\n\\t\\tlocal fup = table.unpack or unpack\\r\\n\\t\\treturn (string.char(fup(anArrayOrNumber)))\\r\\n\\tend\"})})}), smalltalk:newArray({\"String\", smalltalk:newArray({smalltalk:newArray({\"=\", \"if true then return self==anObject end\"}), smalltalk:newArray({\"size\", \"#self\"}), smalltalk:newArray({\"at:\", \"self:sub(anIndex,anIndex)\"}), smalltalk:newArray({\"do:\", \"for c in self:gmatch(\\\".\\\") do fn(c) end\"}), smalltalk:newArray({\"withIndexDo:\", \"for i=1,#self do fn(self:sub(i,i),i) end\"}), smalltalk:newArray({\"detect:ifNone:\", \"\\r\\n\\tfor c in self:gmatch(\\\".\\\") do\\r\\n\\t\\tif (fn(c)) then return c end\\r\\n\\tend\\r\\n\\tif true then return anotherBlock:value() end\"}), smalltalk:newArray({\"isLiteral\", \"\\r\\n\\tif #self==0 then return false end\\r\\n\\tif smalltalk.String:isBinarySelector_(self) then return true end\\r\\n\\tif true then return string.find(self,\\\"[^a-zA-Z0-9_:]+\\\")==nil end\"}), smalltalk:newArray({\"occurrencesOf:\", \"\\r\\n\\tlocal j\\r\\n\\tlocal k,count = 0,0\\r\\n\\trepeat\\tj, k = self:find(aString, k + 1, true)\\r\\n\\t\\tif (j~=nil) then count=count+1 end\\r\\n\\tuntil j == nil\\r\\n\\tif true then return count end\"}), smalltalk:newArray({\"startsWith:\", \"if true then return (self:sub(1, #aString) == aString) end\"}), smalltalk:newArray({\"escaped\", \"self:notImplementedYet_(\\\"escaped\\\")\"}), smalltalk:newArray({\"unescaped\", \"\\r\\n\\tlocal x16 = function(x) return string.char(tonumber(x, 16)) end\\r\\n\\tif true then return self:gsub(\\\"%%%%(%%x%%x)\\\", x16) end\"}), smalltalk:newArray({\"asEncodedURI\", \"self:notImplementedYet_(\\\"asEncodedURI\\\")\"}), smalltalk:newArray({\"asDecodedURI\", \"self:notImplementedYet_(\\\"asDecodedURI\\\")\"}), smalltalk:newArray({\",\", \"if true then return self..(%:asString_%(aCollection)) end\"}), smalltalk:newArray({\"copyWith:\", \"self..(%:asString_%(anObject))\"}), smalltalk:newArray({\"copyFrom:to:\", \"self:sub(anIndex,anotherIndex)\"}), smalltalk:newArray({\"reversed\", \"if true then return self:reverse() end\"}), smalltalk:newArray({\"includes:\", \"local ignored\"}), smalltalk:newArray({\"indexOf:\", \"\\r\\n\\tlocal index = self:find(aString,1,true)\\r\\n\\tif not index\\r\\n\\t\\tthen return 0\\r\\n\\t\\telse return index end\"}), smalltalk:newArray({\"indexOf:startingAt:\", \"\\r\\n\\tlocal index = self:find(aString,position,true)\\r\\n\\tif not index\\r\\n\\t\\tthen return 0\\r\\n\\t\\telse return index end\"}), smalltalk:newArray({\"lastIndexOf:\", \"\\r\\n\\tlocal i = 0\\r\\n\\tlocal j = 0\\r\\n\\tlocal k = 0\\r\\n\\trepeat\\ti = j\\r\\n\\t\\tj, k = self:find(aString, k + 1, true)\\r\\n\\tuntil j == nil\\r\\n\\tif true then return i end\"}), smalltalk:newArray({\"lastIndexOf:startingAt:\", \"\\r\\n\\tlocal i, j\\r\\n\\tlocal k = position\\r\\n\\trepeat\\ti = j\\r\\n\\t\\tj, k = self:find(aString, k + 1, true)\\r\\n\\tuntil j == nil\\r\\n\\tif true then return i end\"}), smalltalk:newArray({\"asNativeName\", \"self:asLuaName()\"}), smalltalk:newArray({\"asPrivateSelector\", \"local map = {\\r\\n\\t\\t[\\\":\\\"]=\\\"_\\\",\\r\\n\\t\\t[\\\"+\\\"]=\\\"_plus\\\",\\r\\n\\t\\t[\\\"-\\\"]=\\\"_minus\\\",\\r\\n\\t\\t[\\\"*\\\"]=\\\"_star\\\",\\r\\n\\t\\t[\\\"/\\\"]=\\\"_slash\\\",\\r\\n\\t\\t[\\\"|\\\"]=\\\"_bar\\\",\\r\\n\\t\\t[\\\"&\\\"]=\\\"_amp\\\",\\r\\n\\t\\t[\\\">\\\"]=\\\"_gt\\\",\\r\\n\\t\\t[\\\"<\\\"]=\\\"_lt\\\",\\r\\n\\t\\t[\\\"=\\\"]=\\\"_eq\\\",\\r\\n\\t\\t[\\\",\\\"]=\\\"_comma\\\",\\r\\n\\t\\t[\\\"@\\\"]=\\\"_at\\\",\\r\\n\\t\\t[\\\"~\\\"]=\\\"_no\\\",\\r\\n\\t\\t[\\\"\\\\\\\\\\\"]=\\\"_bk\\\"\\r\\n\\t};\\r\\n\\tresult = self:gsub(\\\".\\\",function(c) return map[c] end)\"}), smalltalk:newArray({\"asNative:\", \"if true then return self:slashEncoded() end\"}), smalltalk:newArray({\"replace:with:\", \"\\r\\n\\tlocal result=\\\"\\\"\\r\\n\\tlocal i,j\\r\\n\\tlocal k = 0\\r\\n\\trepeat\\ti=k+1\\r\\n\\t\\tj, k = self:find(aString, i, true)\\r\\n\\t\\tif (j==nil) then\\r\\n\\t\\t\\tresult=result..(self:sub(i))\\r\\n\\t\\telse\\r\\n\\t\\t\\tresult=result..(self:sub(i,j-1)..anotherString)\\r\\n\\t\\tend\\r\\n\\tuntil j == nil\\r\\n\\tif true then return result end\"}), smalltalk:newArray({\"replaceRegexp:with:\", \"self:notImplementedYet_(\\\"replaceRegexp:with:\\\")\"}), smalltalk:newArray({\"tokenize:\", \"\\r\\n\\tlocal result=smalltalk.Array:new()\\r\\n\\tlocal i,j\\r\\n\\tlocal k = 0\\r\\n\\trepeat\\ti=k+1\\r\\n\\t\\tj, k = self:find(aString, i, true)\\r\\n\\t\\tif (j==nil) then\\r\\n\\t\\t\\tresult:add_(self:sub(i))\\r\\n\\t\\telse\\r\\n\\t\\t\\tresult:add_(self:sub(i,j-#aString))\\r\\n\\t\\tend\\r\\n\\tuntil j == nil\\r\\n\\tif true then return result end\"}), smalltalk:newArray({\"match:\", \"self:notImplementedYet_(\\\"match:\\\")\"}), smalltalk:newArray({\"isLetter\", \"#self==1 and string.find(self,\\\"%%a\\\")==1\"}), smalltalk:newArray({\"isDigit\", \"#self==1 and string.find(self,\\\"%%d\\\")==1\"}), smalltalk:newArray({\"isUpperCase\", \"\\r\\n\\tif (#self==0) then return false end\\r\\n\\tfor c in self:gmatch(\\\".\\\") do\\r\\n\\t\\tif (c<\\\"A\\\" or c>\\\"Z\\\") then return false end\\r\\n\\tend\\r\\n\\tif true then return true end\"}), smalltalk:newArray({\"isLowerCase\", \"\\r\\n\\tif (#self==0) then return false end\\r\\n\\tfor c in self:gmatch(\\\".\\\") do\\r\\n\\t\\tif (c<\\\"a\\\" or c>\\\"z\\\") then return false end\\r\\n\\tend\\r\\n\\tif true then return true end\"}), smalltalk:newArray({\"asUppercase\", \"self:upper()\"}), smalltalk:newArray({\"asLowercase\", \"self:lower()\"}), smalltalk:newArray({\"asNumber\", \"tonumber(self)\"}), smalltalk:newArray({\">\", \"self > aString\"}), smalltalk:newArray({\"<\", \"self < aString\"}), smalltalk:newArray({\">=\", \"self >= aString\"}), smalltalk:newArray({\"<=\", \"self <= aString\"}), smalltalk:newArray({\"isCharacter\", \"#self == 1\"}), smalltalk:newArray({\"asciiValue\", \"string.byte(self)\"}), smalltalk:newArray({\"isSeparator\", \"#self==1 and self:find(\\\"%%s\\\")==1\"})})}), smalltalk:newArray({\"Array class\", smalltalk:newArray({smalltalk:newArray({\"basicNew:\", \"%:newArray%()\"}), smalltalk:newArray({\"with:\", \"self\"}), smalltalk:newArray({\"with:with:\", \"self\"}), smalltalk:newArray({\"with:with:with:\", \"self\"}), smalltalk:newArray({\"with:with:with:with:\", \"self\"}), smalltalk:newArray({\"withAll:\", \"\\r\\n\\tlocal result = aCollection:asArray()\\r\\n\\tif aCollection==result\\r\\n\\t\\tthen return result:copy()\\r\\n\\t\\telse return result\\r\\n\\tend\"}), smalltalk:newArray({\"slice:\", \"self:notImplementedYet_(\\\"slice:\\\")\"})})}), smalltalk:newArray({\"Array\", smalltalk:newArray({smalltalk:newArray({\"size\", \"#self\"}), smalltalk:newArray({\"at:\", \"\\r\\n\\tlocal value = self[anIndex]\\r\\n\\tif value==nil then return self:objectNotFoundAt_(anIndex) end\\r\\n\\tif true then return self:unwrap_(value) end\"}), smalltalk:newArray({\"at:ifAbsent:\", \"\\r\\n\\tlocal value = self[anIndex]\\r\\n\\tif (value==nil) then return aBlock:value() end\\r\\n\\tif true then return self:unwrap_(value) end\"}), smalltalk:newArray({\"at:put:\", \"\\r\\n\\tself[anIndex]=self:wrap_(anObject)\\r\\n\\tif true then return anObject end\"}), smalltalk:newArray({\"do:\", \"\\r\\n\\tfor _,value in ipairs(self) do\\r\\n\\t\\tfn(self:unwrap_(value))\\r\\n\\tend\"}), smalltalk:newArray({\"addAll:\", \"\\r\\n\\tlocal array = aCollection:asArray()\\r\\n\\tfor i=1,#array do self[#self+1]=self:wrap_(array[i]) end\"}), smalltalk:newArray({\"shallowCopy\", \"\\r\\n\\tresult = self:class():new()\\r\\n\\tfor i=1,#self do result[#result+1]=self[i] end\"}), smalltalk:newArray({\"copyWithAll:\", \"\\r\\n\\tlocal result = self:copy()\\r\\n\\tresult:addAll_(aCollection)\\r\\n\\tif true then return result end\"}), smalltalk:newArray({\",\", \"\\r\\n\\tlocal result = self:copy()\\r\\n\\tresult:addAll_(aCollection)\\r\\n\\tif true then return result end\"}), smalltalk:newArray({\"join:\", \"table.concat(self,aString)\"}), smalltalk:newArray({\"sort:\", \"table.sort(self,fn)\"}), smalltalk:newArray({\"remove:ifAbsent:\", \"\\r\\n\\tfor i,value in ipairs(self) do\\r\\n\\t\\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return table.remove(self,i) end\\r\\n\\tend\\r\\n\\tif true then return aBlock:value() end\"}), smalltalk:newArray({\"add:\", \"self[#self+1]=self:wrap_(anObject)\"}), smalltalk:newArray({\"addFirst:\", \"table.insert(self,1,self:wrap_(anObject))\"}), smalltalk:newArray({\"addLast:\", \"self[#self+1]=self:wrap_(anObject)\"}), smalltalk:newArray({\"removeAll\", \"for i=#self,1,-1 do self[i]=nil end\"}), smalltalk:newArray({\"removeFirst\", \"table.remove(self,1)\"}), smalltalk:newArray({\"removeIndex:\", \"table.remove(self,index)\"}), smalltalk:newArray({\"removeLast\", \"self:unwrap_(table.remove(self))\"}), smalltalk:newArray({\"atAllPut:\", \"\\r\\n\\tlocal what=self:wrap_(anObject)\\r\\n\\tfor i=1,#self do self[i]=what end\"}), smalltalk:newArray({\"first\", \"\\r\\n\\tlocal value=self[1]\\r\\n\\tif (value~=nil) then return self:unwrap_(value) end\"}), smalltalk:newArray({\"second\", \"\\r\\n\\tlocal value=self[2]\\r\\n\\tif (value~=nil) then return self:unwrap_(value) end\"}), smalltalk:newArray({\"third\", \"\\r\\n\\tlocal value=self[3]\\r\\n\\tif (value~=nil) then return self:unwrap_(value) end\"}), smalltalk:newArray({\"fourth\", \"\\t\\r\\n\\tlocal value=self[4]\\r\\n\\tif (value~=nil) then return self:unwrap_(value) end\"}), smalltalk:newArray({\"fifth\", \"\\r\\n\\tlocal value=self[5]\\r\\n\\tif (value~=nil) then return self:unwrap_(value) end\"}), smalltalk:newArray({\"sixth\", \"\\r\\n\\tlocal value=self[6]\\r\\n\\tif (value~=nil) then return self:unwrap_(value) end\"})})}), smalltalk:newArray({\"RegularExpression class\", smalltalk:newArray({smalltalk:newArray({\"fromString:flag:\", \"self:notImplementedYet_(\\\"fromString:flag:\\\")\"})})}), smalltalk:newArray({\"Exception\", smalltalk:newArray({smalltalk:newArray({\"signal\", \"error(self)\"})})}), smalltalk:newArray({\"ComposedAssociations\", smalltalk:newArray({smalltalk:newArray({\"hashObject\", \"{}\"})})}), smalltalk:newArray({\"KeyedCollection class\", smalltalk:newArray({smalltalk:newArray({\"@\", \"\\r\\n\\tparts = smalltalk.Array:new()\\r\\n\\tfor k,_ in pairs(jsObject) do parts:add_(k) end\"})})}), smalltalk:newArray({\"KeyedCollection\", smalltalk:newArray({smalltalk:newArray({\"newHash\", \"{}\"})})}), smalltalk:newArray({\"Dictionary class\", smalltalk:newArray({smalltalk:newArray({\"basicNew\", \"if true then return smalltalk.PoolDictionary:new() end\"})})}), smalltalk:newArray({\"PoolDictionary\", smalltalk:newArray({smalltalk:newArray({\"removeKey:ifAbsent:\", \"self[\\\"@hash\\\"][self:wrap_(aKey)]=nil\"}), smalltalk:newArray({\"at:ifAbsent:\", \"\\r\\n\\tlocal found = self[\\\"@hash\\\"][self:wrap_(aKey)]\\r\\n\\tif found~=nil\\r\\n\\t\\tthen return self:unwrap_(found)\\r\\n\\t\\telse return aBlock:value()\\r\\n\\tend\"}), smalltalk:newArray({\"includesKey:\", \"self[\\\"@hash\\\"][self:wrap_(aKey)]~=nil\"}), smalltalk:newArray({\"keys\", \"\\r\\n\\tlocal result=smalltalk.Array:new()\\r\\n\\tfor k,_ in pairs(self[\\\"@hash\\\"]) do result:add_(k) end\\r\\n\\tif true then return result end\"})})}), smalltalk:newArray({\"ClassBuilder\", smalltalk:newArray({smalltalk:newArray({\"addSubclassOf:named:instanceVariableNames:\", \"\\r\\n\\t%:addClass%(aString, aClass, aCollection)\\r\\n\\tif true then return smalltalk[aString] end\"})})}), smalltalk:newArray({\"StringStream\", smalltalk:newArray({smalltalk:newArray({\"peek\", \"\\r\\n\\tlocal c = self[\\\"@collection\\\"]:at_(self:position()+1)\\r\\n\\tif c==\\\"\\\" then return nil else return c end\"}), smalltalk:newArray({\"peekForAll:\", \"\\r\\n\\tlocal start=self:position()\\r\\n\\tif (self[\\\"@collection\\\"]:sub(start+1,start+#aCollection)~=aCollection) then return false end\"})})}), smalltalk:newArray({\"Random\", smalltalk:newArray({smalltalk:newArray({\"next\", \"if true then return math.random() end\"})})}), smalltalk:newArray({\"DateTime class\", smalltalk:newArray({smalltalk:newArray({\"new:\", \"if true then return self:notImplementedYet_(\\\"new:\\\") end\"}), smalltalk:newArray({\"today\", \"if true then return self:new() end\"}), smalltalk:newArray({\"now\", \"if true then return self:today() end\"}), smalltalk:newArray({\"msNow\", \"if true then return os.clock()*1000 end\"})})}), smalltalk:newArray({\"DateTime\", smalltalk:newArray({smalltalk:newArray({\"<\", \"self:notImplementedYet_(\\\"<\\\")\"}), smalltalk:newArray({\">\", \"self:notImplementedYet_(\\\">\\\")\"}), smalltalk:newArray({\"<=\", \"self:notImplementedYet_(\\\"<=\\\")\"}), smalltalk:newArray({\">=\", \"self:notImplementedYet_(\\\">=\\\")\"}), smalltalk:newArray({\"-\", \"self:notImplementedYet_(\\\"-\\\")\"}), smalltalk:newArray({\"+\", \"self:notImplementedYet_(\\\"+\\\")\"}), smalltalk:newArray({\"isValid\", \"self:notImplementedYet_(\\\"isValid\\\")\"})})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder["$klass"],"initializeNativeInlines:",0
,(
function(self,pool)
return ((self):register_into_((self):nativeInlines(),pool));
end
)
,"inlines","initializeNativeInlines: pool\r\n\t\" Private - Initialize the inlines for methods in the category. \"\r\n\r\n\t^self register: self nativeInlines into: pool ","(\r\nfunction(self,pool)\r\nreturn ((self):register_into_((self):nativeInlines(),pool));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder["$klass"],"nativeInlines",0
,(
function(self)
return (smalltalk:newArray({smalltalk:newArray({"NativeObject class", smalltalk:newArray({smalltalk:newArray({"undefined", "nil"}), smalltalk:newArray({"codeToNumber", "\" \""})})}), smalltalk:newArray({"NativeObject", smalltalk:newArray({smalltalk:newArray({"jsObject", "self:invalidMessage_(\"jsObject\")"}), smalltalk:newArray({"ownPropertyNames", "\r\n\tlocal result = smalltalk.Array:new()\r\n\tfor k,_ in pairs(self[\"@handle\"]) do\r\n\t\tresult:add_(k)\r\n\tend\r\n\tif true then return result end"})})}), smalltalk:newArray({"NativeHandle", smalltalk:newArray({smalltalk:newArray({"hasOwnProperty:", "rawget(self[\"@handle\"],aName)~=nil"}), smalltalk:newArray({"delete:", "self[\"@handle\"][aName]=nil"})})}), smalltalk:newArray({"NativeLibraryObject class", smalltalk:newArray({smalltalk:newArray({"basicLoad:", "require(url)"})})}), smalltalk:newArray({"NativeLibraryObject", smalltalk:newArray({smalltalk:newArray({"newHandleOf:", "result = aConstructor()"}), smalltalk:newArray({"newHandleOf:with:", "result = aConstructor(arg1)"}), smalltalk:newArray({"newHandleOf:with:with:", "result = aConstructor(arg1,arg2)"}), smalltalk:newArray({"newHandleOf:with:with:with:", "result = aConstructor(arg1,arg2,arg3)"}), smalltalk:newArray({"newHandleOf:with:with:with:with:", "result = aConstructor(arg1,arg2,arg3,arg4)"}), smalltalk:newArray({"newHandleOf:with:with:with:with:with:", "result = aConstructor(arg1,arg2,arg3,arg4,arg5)"}), smalltalk:newArray({"newHandleOf:with:with:with:with:with:with:", "result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6)"}), smalltalk:newArray({"newHandleOf:with:with:with:with:with:with:with:", "result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7)"}), smalltalk:newArray({"newHandleOf:with:with:with:with:with:with:with:with:", "result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)"})})}), smalltalk:newArray({"Array", smalltalk:newArray({smalltalk:newArray({"addAllLua:", "for _,value in pairs(natives) do self:add_(value) end"})})}), smalltalk:newArray({"Array class", smalltalk:newArray({smalltalk:newArray({"@@", "self"}), smalltalk:newArray({"@", "result:addAllLua_(natives)"})})}), smalltalk:newArray({"Boolean class", smalltalk:newArray({smalltalk:newArray({"@", "\r\n\tif (aBOOL==true) then return true end\r\n\tif (aBOOL==1) then return true end\r\n\tif (aBOOL==false) then return false end\r\n\tif (aBOOL+0==1) then return true end"})})})}));
end
)
,"inlines","nativeInlines\r\n\t\" Private - Return the inlines for methods in the category. \"\r\n\r\n\t^#(\r\n#('NativeObject class' #(\r\n#(undefined 'nil')\r\n#(codeToNumber '\" \"')\r\n))\r\n#(NativeObject #(\r\n#(jsObject 'self:invalidMessage_(\"jsObject\")')\r\n#(ownPropertyNames '\r\n\tlocal result = smalltalk.Array:new()\r\n\tfor k,_ in pairs(self[\"@handle\"]) do\r\n\t\tresult:add_(k)\r\n\tend\r\n\tif true then return result end')\r\n))\r\n#(NativeHandle #(\r\n#(hasOwnProperty: 'rawget(self[\"@handle\"],aName)~=nil')\r\n#(delete: 'self[\"@handle\"][aName]=nil')\r\n))\r\n#('NativeLibraryObject class' #(\r\n#(basicLoad: 'require(url)')\r\n))\r\n#(NativeLibraryObject  #(\r\n#(newHandleOf: 'result = aConstructor()')\r\n#(newHandleOf:with: 'result = aConstructor(arg1)')\r\n#(newHandleOf:with:with: 'result = aConstructor(arg1,arg2)')\r\n#(newHandleOf:with:with:with: 'result = aConstructor(arg1,arg2,arg3)')\r\n#(newHandleOf:with:with:with:with: 'result = aConstructor(arg1,arg2,arg3,arg4)')\r\n#(newHandleOf:with:with:with:with:with: 'result = aConstructor(arg1,arg2,arg3,arg4,arg5)')\r\n#(newHandleOf:with:with:with:with:with:with: 'result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6)')\r\n#(newHandleOf:with:with:with:with:with:with:with: 'result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7)')\r\n#(newHandleOf:with:with:with:with:with:with:with:with: 'result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)')\r\n))\r\n#(Array #(\r\n#(addAllLua: 'for _,value in pairs(natives) do self:add_(value) end')\r\n))\r\n#('Array class' #(\r\n#(@@ 'self')\r\n#(@ 'result:addAllLua_(natives)')\r\n))\r\n#('Boolean class' #(\r\n#(@ '\r\n\tif (aBOOL==true) then return true end\r\n\tif (aBOOL==1) then return true end\r\n\tif (aBOOL==false) then return false end\r\n\tif (aBOOL+0==1) then return true end')\r\n))\r\n\t) ","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({smalltalk:newArray({\"NativeObject class\", smalltalk:newArray({smalltalk:newArray({\"undefined\", \"nil\"}), smalltalk:newArray({\"codeToNumber\", \"\\\" \\\"\"})})}), smalltalk:newArray({\"NativeObject\", smalltalk:newArray({smalltalk:newArray({\"jsObject\", \"self:invalidMessage_(\\\"jsObject\\\")\"}), smalltalk:newArray({\"ownPropertyNames\", \"\\r\\n\\tlocal result = smalltalk.Array:new()\\r\\n\\tfor k,_ in pairs(self[\\\"@handle\\\"]) do\\r\\n\\t\\tresult:add_(k)\\r\\n\\tend\\r\\n\\tif true then return result end\"})})}), smalltalk:newArray({\"NativeHandle\", smalltalk:newArray({smalltalk:newArray({\"hasOwnProperty:\", \"rawget(self[\\\"@handle\\\"],aName)~=nil\"}), smalltalk:newArray({\"delete:\", \"self[\\\"@handle\\\"][aName]=nil\"})})}), smalltalk:newArray({\"NativeLibraryObject class\", smalltalk:newArray({smalltalk:newArray({\"basicLoad:\", \"require(url)\"})})}), smalltalk:newArray({\"NativeLibraryObject\", smalltalk:newArray({smalltalk:newArray({\"newHandleOf:\", \"result = aConstructor()\"}), smalltalk:newArray({\"newHandleOf:with:\", \"result = aConstructor(arg1)\"}), smalltalk:newArray({\"newHandleOf:with:with:\", \"result = aConstructor(arg1,arg2)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:\", \"result = aConstructor(arg1,arg2,arg3)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:with:\", \"result = aConstructor(arg1,arg2,arg3,arg4)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:with:with:\", \"result = aConstructor(arg1,arg2,arg3,arg4,arg5)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:with:with:with:\", \"result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:with:with:with:with:\", \"result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:with:with:with:with:with:\", \"result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)\"})})}), smalltalk:newArray({\"Array\", smalltalk:newArray({smalltalk:newArray({\"addAllLua:\", \"for _,value in pairs(natives) do self:add_(value) end\"})})}), smalltalk:newArray({\"Array class\", smalltalk:newArray({smalltalk:newArray({\"@@\", \"self\"}), smalltalk:newArray({\"@\", \"result:addAllLua_(natives)\"})})}), smalltalk:newArray({\"Boolean class\", smalltalk:newArray({smalltalk:newArray({\"@\", \"\\r\\n\\tif (aBOOL==true) then return true end\\r\\n\\tif (aBOOL==1) then return true end\\r\\n\\tif (aBOOL==false) then return false end\\r\\n\\tif (aBOOL+0==1) then return true end\"})})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder["$klass"],"initializeToolsInlines:",0
,(
function(self,pool)
return ((self):register_into_((self):toolsInlines(),pool));
end
)
,"inlines","initializeToolsInlines: pool\r\n\t\" Private - Initialize the inlines for methods in the category. \"\r\n\r\n\t^self register: self toolsInlines into: pool ","(\r\nfunction(self,pool)\r\nreturn ((self):register_into_((self):toolsInlines(),pool));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder["$klass"],"toolsInlines",0
,(
function(self)
return (smalltalk:newArray({smalltalk:newArray({"NativeReader", smalltalk:newArray({smalltalk:newArray({"initializeObject", "{}"})})}), smalltalk:newArray({"String", smalltalk:newArray({smalltalk:newArray({"asComment", smalltalk:newArray({"\"--[[ \"", "\" --]]\"", "\"-- \""})})})}), smalltalk:newArray({"MethodReferences", smalltalk:newArray({smalltalk:newArray({"dot", "\":\""}), smalltalk:newArray({"localDef", "\"local \""}), smalltalk:newArray({"superSendPatternOf:", "self:superLuaSendPatternOf_(aSelector)"}), smalltalk:newArray({"compiledSourceStart", "\"(\""})})}), smalltalk:newArray({"Class", smalltalk:newArray({smalltalk:newArray({"hackDNU", "self:notImplementedYet_(\"hackDNU\")"})})})}));
end
)
,"inlines","toolsInlines\r\n\t\" Private - Return the inlines for methods in the category. \"\r\n\r\n\t^#(\r\n#(NativeReader #(\r\n#(initializeObject '{}')\r\n))\r\n#(String  #(\r\n#(asComment #('\"--[[ \"' '\" --]]\"' '\"-- \"'))\r\n))\r\n#(MethodReferences #(\r\n#(dot\t\t'\":\"')\r\n#(localDef\t'\"local \"')\r\n#(superSendPatternOf:\t'self:superLuaSendPatternOf_(aSelector)')\r\n#(compiledSourceStart\t'\"(\"')\r\n))\r\n#(Class #(\r\n#(hackDNU 'self:notImplementedYet_(\"hackDNU\")')\r\n))\r\n\t) ","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({smalltalk:newArray({\"NativeReader\", smalltalk:newArray({smalltalk:newArray({\"initializeObject\", \"{}\"})})}), smalltalk:newArray({\"String\", smalltalk:newArray({smalltalk:newArray({\"asComment\", smalltalk:newArray({\"\\\"--[[ \\\"\", \"\\\" --]]\\\"\", \"\\\"-- \\\"\"})})})}), smalltalk:newArray({\"MethodReferences\", smalltalk:newArray({smalltalk:newArray({\"dot\", \"\\\":\\\"\"}), smalltalk:newArray({\"localDef\", \"\\\"local \\\"\"}), smalltalk:newArray({\"superSendPatternOf:\", \"self:superLuaSendPatternOf_(aSelector)\"}), smalltalk:newArray({\"compiledSourceStart\", \"\\\"(\\\"\"})})}), smalltalk:newArray({\"Class\", smalltalk:newArray({smalltalk:newArray({\"hackDNU\", \"self:notImplementedYet_(\\\"hackDNU\\\")\"})})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder["$klass"],"initializeSnapshotInlines:",0
,(
function(self,pool)
return ((self):register_into_((self):snapshotInlines(),pool));
end
)
,"inlines","initializeSnapshotInlines: pool\r\n\t\" Private - Initialize the inlines for methods in the category. \"\r\n\r\n\t^self register: self snapshotInlines into: pool ","(\r\nfunction(self,pool)\r\nreturn ((self):register_into_((self):snapshotInlines(),pool));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder["$klass"],"snapshotInlines",0
,(
function(self)
return (smalltalk:newArray({smalltalk:newArray({"Smalltalk", smalltalk:newArray({smalltalk:newArray({"exit", "quit()"})})}), smalltalk:newArray({"Snapshot", smalltalk:newArray({smalltalk:newArray({"bootHeader", "[[smalltalk = (function() \r\n]]"}), smalltalk:newArray({"bootFooter", "[[\r\nend)()\r\n]]"}), smalltalk:newArray({"launchExpression", "\"%:launchImage%()\""})})})}));
end
)
,"inlines","snapshotInlines\r\n\t\" Private - Return the inlines for methods in the category. \"\r\n\r\n\t^#(\r\n#(Smalltalk #(\r\n#(exit\t'quit()')\r\n))\r\n#(Snapshot #(\r\n#(bootHeader '[[smalltalk = (function() \r\n]]')\r\n#(bootFooter '[[\r\nend)()\r\n]]')\r\n#(launchExpression '\"%:launchImage%()\"')\r\n))\r\n\t) ","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({smalltalk:newArray({\"Smalltalk\", smalltalk:newArray({smalltalk:newArray({\"exit\", \"quit()\"})})}), smalltalk:newArray({\"Snapshot\", smalltalk:newArray({smalltalk:newArray({\"bootHeader\", \"[[smalltalk = (function() \\r\\n]]\"}), smalltalk:newArray({\"bootFooter\", \"[[\\r\\nend)()\\r\\n]]\"}), smalltalk:newArray({\"launchExpression\", \"\\\"%:launchImage%()\\\"\"})})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder["$klass"],"initializeOtherInlines:",0
,(
function(self,pool)
return ((self):register_into_((self):otherInlines(),pool));
end
)
,"inlines","initializeOtherInlines: pool\r\n\t\" Private - Initialize the inlines for methods in the category. \"\r\n\r\n\t^self register: self otherInlines into: pool ","(\r\nfunction(self,pool)\r\nreturn ((self):register_into_((self):otherInlines(),pool));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder["$klass"],"otherInlines",0
,(
function(self)
return (smalltalk:newArray({}));
end
)
,"inlines","otherInlines\r\n\t\" Private - Return the inlines for methods in the category. \"\r\n\r\n\t^#(\r\n\"#(ClassName #(\r\n#(selector '...')\r\n))\"\r\n\t) ","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({}));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"nativeLanguage",0
,(
function(self)
return ("lua");
end
)
,"accessing","nativeLanguage\r\n\t\" Return the nativeLanguage of the receiver. \"\r\n\r\n\t^#lua ","(\r\nfunction(self)\r\nreturn (\"lua\");\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"nativeUndefined",0
,(
function(self)
return ("nil");
end
)
,"encoding","nativeUndefined\r\n\t\" Private - Return the code for undefined. \"\r\n\r\n\t^#nil ","(\r\nfunction(self)\r\nreturn (\"nil\");\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"nativeNameOfMetaClass:",0
,(
function(self,aClass)
return (smalltalk:object_comma_((((aClass):instanceClass()):name()),"[\"$klass\"]"));
end
)
,"encoding","nativeNameOfMetaClass: aClass\r\n\t\" Private - Return the native name for metaclass aClass. \"\r\n\r\n\t^aClass instanceClass name ,'[\"$klass\"]' ","(\r\nfunction(self,aClass)\r\nreturn (smalltalk:object_comma_((((aClass):instanceClass()):name()),\"[\\\"$klass\\\"]\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"callEscape",0
,(
function(self)
return ("#_");
end
)
,"accessing","callEscape\r\n\t\" Private - Return the selector sequence to escape OO message send selector, and produce code for function call.\r\n\tNote that an alien selector starting with two $$ are understood as a function call to function starting with $\r\n\t\"\r\n\r\n\t^'#_'","(\r\nfunction(self)\r\nreturn (\"#_\");\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"missingNativeCodeFor:as:",0
,(
function(self,aNode,lang)
return (smalltalk:object_comma_((smalltalk:object_comma_(("(function() self:invalidMessage_(\""),(self["@compiler"]):selector())),"\") end)()"));
end
)
,"inlines","missingNativeCodeFor: aNode as: lang\r\n\t\" Private - Return the native language code for missing expression (or nil). \"\r\n\r\n\t^'(function() self:invalidMessage_(\"' ,compiler selector ,'\") end)()'","(\r\nfunction(self,aNode,lang)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"(function() self:invalidMessage_(\\\"\"),(self[\"@compiler\"]):selector())),\"\\\") end)()\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"canExportMethod:",0
,(
function(self,aMethod)
return (true);
end
)
,"private","canExportMethod: aMethod\r\n\t\" Private - Return true if the receiver can/want to export method aMethod. \"\r\n\r\n\t^true","(\r\nfunction(self,aMethod)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"asSelector:",0
,(
function(self,aSelector)
return ((aSelector):asLuaSelector());
end
)
,"converting","asSelector: aSelector\r\n\t\" Return the native representation of aSelector. \"\r\n\r\n\t^aSelector asLuaSelector","(\r\nfunction(self,aSelector)\r\nreturn ((aSelector):asLuaSelector());\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"nativeSourceFor:",0
,(
function(self,aMethod)
return (smalltalk:if_true_false_(((self):canExportMethod_(aMethod)),(function()
return ((self):privateSourceFor_(aMethod))
end),nil));
end
)
,"private","nativeSourceFor: aMethod\r\n\t\" Private - Return the code of native function implementing aMethod. \"\r\n\r\n\t^(self canExportMethod: aMethod) ifTrue: [\r\n\t\tself privateSourceFor: aMethod\r\n\t]","(\r\nfunction(self,aMethod)\r\nreturn (smalltalk:if_true_false_(((self):canExportMethod_(aMethod)),(function()\r\nreturn ((self):privateSourceFor_(aMethod))\r\nend),nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"export:method:on:",0
,(
function(self,aClass,aMethod,aStream)
local fName=nil
local selectorName=nil
local bar=nil
local source=nil
(function()
	local _s8_value=((self):nativeSourceFor_(aMethod))
	source=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((source)))==true then return (false); end;
if (smalltalk:isNil_((aMethod)))==true then (self):error_("Method is missing"); end;
(function()
	local _s8_value=("\"")
	bar=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aMethod):selector())
	fName=_s8_value
	return _s8_value
end)();
if (((fName):first()):isBackSlash())==true then (function()
	local _s8_value=((self):escaped_((aMethod):selector()))
	selectorName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):escaped_((self):asSelector_(fName)))
	fName=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((bar),(aMethod):selector())),bar))
	selectorName=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):asSelector_(fName)),((aMethod):selector()):replace_with_(":","_"))),(function()
return ((function()
	local _s8_value=(0)
	fName=_s8_value
	return _s8_value
end)())
end),(function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((bar),(self):asSelector_(fName))),bar))
	fName=_s8_value
	return _s8_value
end)())
end)); end;
(aStream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk:bind("),(self):smalltalkNameFor_(aClass))),",")),selectorName)),",")),fName)),"\r\n,")),source));
if (smalltalk:boolean_and_((smalltalk:notNil_(((aMethod):source()))),(function()
return (((aMethod):source()):notEmpty())
end)))==true then (
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((","),(self):escaped_((aMethod):category()))),",")),(self):escaped_((aMethod):source()))),",")),(self):escaped_(source))))
end
)(aStream); end;
if (smalltalk:boolean_and_((smalltalk:responds_to_((aMethod),("stamp"))),(function()
return (smalltalk:notNil_(((aMethod):stamp())))
end)))==true then (aStream):nextPutAll_(smalltalk:object_comma_((","),(self):escaped_((aMethod):stamp()))); end;
(aStream):nextPutAll_(")\r\n");
return (true);
end
)
,"export","export: aClass method: aMethod on: aStream\r\n\t\" Export a method definition of aClass onto aStream. \"\r\n\r\n\t| fName selectorName bar source |\r\n\tsource := self nativeSourceFor: aMethod.\r\n\tsource isNil ifTrue: [ ^false ].\r\n\taMethod isNil ifTrue: [ self error: 'Method is missing' ].\r\n\tbar := $\".\r\n\tfName := aMethod selector.\r\n\tfName first isBackSlash ifTrue: [\r\n\t\tselectorName := self escaped: aMethod selector.\r\n\t\tfName := self escaped: (self asSelector: fName).\r\n\t] ifFalse: [\r\n\t\tselectorName := bar ,aMethod selector, bar.\r\n\t\t(self asSelector: fName) = (aMethod selector replace: $: with: $_) ifTrue: [\r\n\t\t\tfName := 0\r\n\t\t] ifFalse: [\r\n\t\t\tfName := bar ,(self asSelector: fName) ,bar\r\n\t\t].\r\n\t].\r\n\taStream\r\n\t\tnextPutAll: 'smalltalk:bind(' ,(self smalltalkNameFor: aClass)\r\n\t\t\t,',' ,selectorName ,',' ,fName ,'\r\n,'\t\t\t,source.\r\n\t(aMethod source notNil and: [ aMethod source notEmpty ]) ifTrue: [\r\n\t    aStream cr; \"warning: this cr is important for debugger\"\r\n\t\tnextPutAll: ',' ,(self escaped: aMethod category)\r\n\t\t\t,',' ,(self escaped: aMethod source)\r\n\t\t\t,',' ,(self escaped: source).\r\n\t].\r\n\t((aMethod respondsTo: #stamp) and: [ aMethod stamp notNil ]) ifTrue: [\r\n\t\taStream nextPutAll: ',' ,(self escaped: aMethod stamp)\r\n\t].\r\n\taStream nextPutAll: ')\r\n'.\t^true","(\r\nfunction(self,aClass,aMethod,aStream)\r\nlocal fName=nil\r\nlocal selectorName=nil\r\nlocal bar=nil\r\nlocal source=nil\r\n(function()\r\n\tlocal _s8_value=((self):nativeSourceFor_(aMethod))\r\n\tsource=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((source)))==true then return (false); end;\r\nif (smalltalk:isNil_((aMethod)))==true then (self):error_(\"Method is missing\"); end;\r\n(function()\r\n\tlocal _s8_value=(\"\\\"\")\r\n\tbar=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aMethod):selector())\r\n\tfName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (((fName):first()):isBackSlash())==true then (function()\r\n\tlocal _s8_value=((self):escaped_((aMethod):selector()))\r\n\tselectorName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):escaped_((self):asSelector_(fName)))\r\n\tfName=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((bar),(aMethod):selector())),bar))\r\n\tselectorName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):asSelector_(fName)),((aMethod):selector()):replace_with_(\":\",\"_\"))),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(0)\r\n\tfName=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((bar),(self):asSelector_(fName))),bar))\r\n\tfName=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)); end;\r\n(aStream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk:bind(\"),(self):smalltalkNameFor_(aClass))),\",\")),selectorName)),\",\")),fName)),\"\\r\\n,\")),source));\r\nif (smalltalk:boolean_and_((smalltalk:notNil_(((aMethod):source()))),(function()\r\nreturn (((aMethod):source()):notEmpty())\r\nend)))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\",\"),(self):escaped_((aMethod):category()))),\",\")),(self):escaped_((aMethod):source()))),\",\")),(self):escaped_(source))))\r\nend\r\n)(aStream); end;\r\nif (smalltalk:boolean_and_((smalltalk:responds_to_((aMethod),(\"stamp\"))),(function()\r\nreturn (smalltalk:notNil_(((aMethod):stamp())))\r\nend)))==true then (aStream):nextPutAll_(smalltalk:object_comma_((\",\"),(self):escaped_((aMethod):stamp()))); end;\r\n(aStream):nextPutAll_(\")\\r\\n\");\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"arrayLiteralStart",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk:newArray"),"(")),"{"));
end
)
,"arrays","arrayLiteralStart\r\n\t\" Private - Return the code string to start exporting an array literal. \"\r\n\r\n\t^'smalltalk:newArray' ,$( ,${","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk:newArray\"),\"(\")),\"{\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"arrayLiteralEnd",0
,(
function(self)
return (smalltalk:object_comma_(("}"),")"));
end
)
,"arrays","arrayLiteralEnd\r\n\t\" Private - Return the code string to end exporting an array literal. \"\r\n\r\n\t^$} ,$)","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((\"}\"),\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"escaped:",0
,(
function(self,string)
return ((string):asLua());
end
)
,"literals","escaped: string\r\n\t\" Private - Return the code string to export string literal. \"\r\n\r\n\t^string asLua","(\r\nfunction(self,string)\r\nreturn ((string):asLua());\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"exportCommentOf:on:",0
,(
function(self,aClass,aStream)
if (((((aClass):comment()):size()) > 0))==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	(_s8_rec):nextPutAll_(smalltalk:object_comma_(("[\"$comment\"]="),(self):escaped_((aClass):comment())));
	return ((_s8_rec):cr())
end
)(aStream); end;
return (self);
end
)
,"export","exportCommentOf: aClass on: aStream\r\n\t\" Export the comment of aClass onto aStream. \"\r\n\r\n\taClass comment size > 0 ifTrue: [\r\n\t    aStream\r\n\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\tnextPutAll: '[\"$comment\"]=' ,(self escaped: aClass comment); cr\r\n\t]","(\r\nfunction(self,aClass,aStream)\r\nif (((((aClass):comment()):size()) > 0))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((\"[\\\"$comment\\\"]=\"),(self):escaped_((aClass):comment())));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"exportDefinitionOf:on:",0
,(
function(self,aClass,aStream)
((self):loadRequirementsOf_(aClass)):do_((function(each)
return (smalltalk:if_true_false_(((each):isString()),(function()
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_(each);
	return ((_s8_rec):cr())
end
)(aStream))
end),(function()
return ((aStream):fileOutOn_(aStream))
end)))
end));
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk:addClass(\""),(aClass):name())),"\","));
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass):superclass()));
	return ((_s8_rec):nextPutAll_(","))
end
)(aStream);
(self):exportArrayLiteral_on_newLine_((aClass):instanceVariableNames(),aStream,false);
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((",\""),(aClass):category())),"\""));
	(_s8_rec):nextPutAll_(")");
	return ((_s8_rec):cr())
end
)(aStream);
if (smalltalk:notNil_(((aClass):classVariables())))==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	(_s8_rec):nextPutAll_(smalltalk:object_comma_(("[\"$classVariableNames\"]="),(self):escaped_((aClass):classVariablesString())));
	return ((_s8_rec):cr())
end
)(aStream); end;
if (smalltalk:notNil_(((aClass):poolDictionaries())))==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	return ((_s8_rec):nextPutAll_("[\"$poolDictionaries\"]="))
end
)(aStream);
(self):exportArrayLiteral_on_newLine_((aClass):poolDictionaries(),aStream,true); end;
if (((aClass):propertyNames()):notEmpty())==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	return ((_s8_rec):nextPutAll_("[\"$propertyNames\"]="))
end
)(aStream);
(self):exportArrayLiteral_on_newLine_((aClass):propertyNames(),aStream,true); end;
(self):exportCommentOf_on_(aClass,aStream);
return (self);
end
)
,"export","exportDefinitionOf: aClass on: aStream\r\n\t\" Export definition of aClass onto aStream. \"\r\n\r\n\t(self loadRequirementsOf: aClass) do: [:each|\r\n\t\teach isString\r\n\t\tifTrue: [ aStream nextPutAll: each;cr ]\r\n\t\tifFalse: [ aStream fileOutOn: aStream ].\r\n\t].\r\n\taStream \r\n\t    nextPutAll: 'smalltalk:addClass(\"', aClass name, '\",';\r\n\t    nextPutAll: (self smalltalkNameFor: aClass superclass);\r\n\t    nextPutAll: ','.\r\n\tself exportArrayLiteral: aClass instanceVariableNames on: aStream newLine: false.\r\n\taStream\r\n\t    nextPutAll: ',\"' ,aClass category, $\";\r\n\t    nextPutAll: ')'; cr.\r\n\taClass classVariables notNil ifTrue: [\r\n\t    aStream\r\n\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\tnextPutAll: '[\"$classVariableNames\"]=' ,(self escaped: aClass classVariablesString); cr\r\n\t].\r\n\taClass poolDictionaries notNil ifTrue: [\r\n\t    aStream\r\n\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\tnextPutAll: '[\"$poolDictionaries\"]='.\r\n\t   self exportArrayLiteral: aClass poolDictionaries on: aStream newLine: true.\r\n\t].\r\n\taClass propertyNames notEmpty ifTrue: [\r\n\t    aStream\r\n\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\tnextPutAll: '[\"$propertyNames\"]='.\r\n\t   self exportArrayLiteral: aClass propertyNames on: aStream newLine: true.\r\n\t].\r\n\tself exportCommentOf: aClass on: aStream.","(\r\nfunction(self,aClass,aStream)\r\n((self):loadRequirementsOf_(aClass)):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):isString()),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(each);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream))\r\nend),(function()\r\nreturn ((aStream):fileOutOn_(aStream))\r\nend)))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk:addClass(\\\"\"),(aClass):name())),\"\\\",\"));\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass):superclass()));\r\n\treturn ((_s8_rec):nextPutAll_(\",\"))\r\nend\r\n)(aStream);\r\n(self):exportArrayLiteral_on_newLine_((aClass):instanceVariableNames(),aStream,false);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\",\\\"\"),(aClass):category())),\"\\\"\"));\r\n\t(_s8_rec):nextPutAll_(\")\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream);\r\nif (smalltalk:notNil_(((aClass):classVariables())))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((\"[\\\"$classVariableNames\\\"]=\"),(self):escaped_((aClass):classVariablesString())));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream); end;\r\nif (smalltalk:notNil_(((aClass):poolDictionaries())))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\treturn ((_s8_rec):nextPutAll_(\"[\\\"$poolDictionaries\\\"]=\"))\r\nend\r\n)(aStream);\r\n(self):exportArrayLiteral_on_newLine_((aClass):poolDictionaries(),aStream,true); end;\r\nif (((aClass):propertyNames()):notEmpty())==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\treturn ((_s8_rec):nextPutAll_(\"[\\\"$propertyNames\\\"]=\"))\r\nend\r\n)(aStream);\r\n(self):exportArrayLiteral_on_newLine_((aClass):propertyNames(),aStream,true); end;\r\n(self):exportCommentOf_on_(aClass,aStream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"exportMetaDefinitionOf:on:",0
,(
function(self,aClass,aStream)
if ((((aClass)["$klass"]):instanceVariableNames()):notEmpty())==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass)["$klass"]));
	return ((_s8_rec):nextPutAll_("[\"$iVarNames\"]="))
end
)(aStream);
(self):exportArrayLiteral_on_newLine_(((aClass)["$klass"]):instanceVariableNames(),aStream,true); end;
if ((((aClass)["$klass"]):propertyNames()):notEmpty())==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass)["$klass"]));
	return ((_s8_rec):nextPutAll_("[\"$propertyNames\"]="))
end
)(aStream);
(self):exportArrayLiteral_on_newLine_(((aClass)["$klass"]):propertyNames(),aStream,true); end;
return (self);
end
)
,"export","exportMetaDefinitionOf: aClass on: aStream\r\n\t\" Export class side definition of aClass onto aStream. \"\r\n\r\n\taClass class instanceVariableNames notEmpty ifTrue: [\r\n\t\taStream \r\n\t\t\tnextPutAll: (self smalltalkNameFor: aClass class);\r\n\t\t\tnextPutAll: '[\"$iVarNames\"]='.\r\n\t\tself exportArrayLiteral: aClass class instanceVariableNames on: aStream newLine: true.\r\n\t].\r\n\r\n\taClass class propertyNames notEmpty ifTrue: [\r\n\t\taStream \r\n\t\t\tnextPutAll: (self smalltalkNameFor: aClass class);\r\n\t\t\tnextPutAll: '[\"$propertyNames\"]='.\r\n\t\tself exportArrayLiteral: aClass class propertyNames on: aStream newLine: true.\r\n\t].","(\r\nfunction(self,aClass,aStream)\r\nif ((((aClass)[\"$klass\"]):instanceVariableNames()):notEmpty())==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass)[\"$klass\"]));\r\n\treturn ((_s8_rec):nextPutAll_(\"[\\\"$iVarNames\\\"]=\"))\r\nend\r\n)(aStream);\r\n(self):exportArrayLiteral_on_newLine_(((aClass)[\"$klass\"]):instanceVariableNames(),aStream,true); end;\r\nif ((((aClass)[\"$klass\"]):propertyNames()):notEmpty())==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass)[\"$klass\"]));\r\n\treturn ((_s8_rec):nextPutAll_(\"[\\\"$propertyNames\\\"]=\"))\r\nend\r\n)(aStream);\r\n(self):exportArrayLiteral_on_newLine_(((aClass)[\"$klass\"]):propertyNames(),aStream,true); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"privateSourceFor:",0
,(
function(self,aMethod)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local code=nil
if ((smalltalk.Smalltalk):isRunningOn_((self):nativeLanguage()))==true then (function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((aMethod),"$nativeSource",(function()
return (nil)
end)))
	code=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:notNil_((code))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (code)
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
	local _s8_value=(((function()
return ((self):privateCodeFor_(aMethod))
end)):on_do_(smalltalk.Exception,(function(ex)
(self):note_(aMethod);return ((self):privateNIYSourceFor_with_(aMethod,(ex):description()))
end)))
	code=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((smalltalk:object_comma_(("(\r\n"),code)),"\r\n)"))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"lua","privateSourceFor: aMethod\r\n\t\" Private - Return the native code implementing aMethod. \"\r\n\r\n\t| code |\r\n\t(Smalltalk isRunningOn: self nativeLanguage) ifTrue: [\r\n\t\tcode := aMethod basicAt: '$nativeSource' ifAbsent: [].\r\n\t\tcode notNil ifTrue: [ ^code ].\r\n\t].\r\n\r\n\tcode := [ self privateCodeFor: aMethod ] on: Exception do: [:ex|\r\n\t\tself note: aMethod.\r\n\t\tself privateNIYSourceFor: aMethod with: ex description\r\n\t].\r\n\t^'(\r\n'\t,code ,'\r\n)'","(\r\nfunction(self,aMethod)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal code=nil\r\nif ((smalltalk.Smalltalk):isRunningOn_((self):nativeLanguage()))==true then (function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((aMethod),\"$nativeSource\",(function()\r\nreturn (nil)\r\nend)))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:notNil_((code))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (code)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n\tlocal _s8_value=(((function()\r\nreturn ((self):privateCodeFor_(aMethod))\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\n(self):note_(aMethod);return ((self):privateNIYSourceFor_with_(aMethod,(ex):description()))\r\nend)))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"(\\r\\n\"),code)),\"\\r\\n)\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"privateNIYSourceFor:with:",0
,(
function(self,aMethod,description)
return (smalltalk:object_comma_(((self):privateMethodDefinition_(aMethod)),(self):privateMethodBody_with_(aMethod,description)));
end
)
,"niy","privateNIYSourceFor: aMethod with: description\r\n\t\" Private - Return the native code implementing aMethod. \"\r\n\r\n\t^(self privateMethodDefinition: aMethod)\r\n\t,(self privateMethodBody: aMethod with: description)","(\r\nfunction(self,aMethod,description)\r\nreturn (smalltalk:object_comma_(((self):privateMethodDefinition_(aMethod)),(self):privateMethodBody_with_(aMethod,description)));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"privateMethodDefinition:",0
,(
function(self,aMethod)
local args=nil
(function()
	local _s8_value=((
function(_s8_rec)
	(_s8_rec):upTo_("(");
	return ((_s8_rec):upTo_(")"))
end
)(((aMethod):compiledSource()):stream()))
	args=_s8_value
	return _s8_value
end)();
if ((args):notEmpty())==true then (function()
	local _s8_value=(((args):asArrayOfSubstringsSeparatedBy_(",")):inject_into_("",(function(total,each)
return (smalltalk:object_comma_((smalltalk:object_comma_((total),",")),(each):asLuaName()))
end)))
	args=_s8_value
	return _s8_value
end)(); end;
return (smalltalk:object_comma_((smalltalk:object_comma_(("function(self"),args)),")"));
end
)
,"niy","privateMethodDefinition: aMethod\r\n\t\" Private - Return the (Lua) method definition of aMethod. \"\r\n\r\n\t| args |\r\n\targs := aMethod compiledSource stream upTo: $(; upTo: $).\r\n\targs notEmpty ifTrue: [\r\n\t\targs := (args asArrayOfSubstringsSeparatedBy: $,)\r\n\t\t\tinject: '' into: [:total :each| total ,',' ,each asLuaName ].\r\n\t].\r\n\t^'function(self' ,args ,')'","(\r\nfunction(self,aMethod)\r\nlocal args=nil\r\n(function()\r\n\tlocal _s8_value=((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):upTo_(\"(\");\r\n\treturn ((_s8_rec):upTo_(\")\"))\r\nend\r\n)(((aMethod):compiledSource()):stream()))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((args):notEmpty())==true then (function()\r\n\tlocal _s8_value=(((args):asArrayOfSubstringsSeparatedBy_(\",\")):inject_into_(\"\",(function(total,each)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((total),\",\")),(each):asLuaName()))\r\nend)))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"function(self\"),args)),\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"privateMethodBody:with:",0
,(
function(self,aMethod,description)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("\r\n\tprint(\"NIY:#privateMethodBody: "),aMethod))," - ")),description)),"\")\r\n\treturn self\r\nend"));
end
)
,"niy","privateMethodBody: aMethod with: description\r\n\t\" Private - Return the (Lua) body of aMethod. \"\r\n\r\n\t^'\r\n\tprint(\"NIY:#privateMethodBody: ',aMethod,' - ',description,'\")\r\n\treturn self\r\nend'","(\r\nfunction(self,aMethod,description)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"\\r\\n\\tprint(\\\"NIY:#privateMethodBody: \"),aMethod)),\" - \")),description)),\"\\\")\\r\\n\\treturn self\\r\\nend\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"privateCodeFor:",0
,(
function(self,aMethod)
(self):compiler_(((aMethod):classField()):compiler());
return ((
function(_s8_rec)
	(_s8_rec):encoder_(self);
	return ((_s8_rec):compile_((aMethod):source()))
end
)((self):compiler()));
end
)
,"compiling","privateCodeFor: aMethod\r\n\t\" Private - Return the native code translated from sources of aMethod. \"\r\n\r\n\tself compiler: aMethod classField compiler.\r\n\t^self compiler\r\n\t\tencoder: self;\r\n\t\tcompile: aMethod source","(\r\nfunction(self,aMethod)\r\n(self):compiler_(((aMethod):classField()):compiler());\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):encoder_(self);\r\n\treturn ((_s8_rec):compile_((aMethod):source()))\r\nend\r\n)((self):compiler()));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"emmitEnterMethod:",0
,(
function(self,aMethodNode)
return (self);
end
)
,"generation","emmitEnterMethod: aMethodNode\r\n\t\" Private - Generate home context definitions, entering aMethodNode. \"","(\r\nfunction(self,aMethodNode)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"emmitFunctionBody:",0
,(
function(self,aBlock)
(self):cr();
(aBlock):evaluate();
(
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_("end"))
end
)(self);
return (self);
end
)
,"generation","emmitFunctionBody: aBlock\r\n\t\" Private - Emmit the code of function body evaluating aBlock. \"\r\n\r\n\tself cr.\r\n\taBlock evaluate.\r\n\tself cr; nextPutAll: #end ","(\r\nfunction(self,aBlock)\r\n(self):cr();\r\n(aBlock):evaluate();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(\"end\"))\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"newMethodFunctionName",0
,(
function(self)
return ("smalltalk:newMethod");
end
)
,"generation","newMethodFunctionName\r\n\t\" Private - Return the function to call when installing a new method. \"\r\n\r\n\t^'smalltalk:newMethod'","(\r\nfunction(self)\r\nreturn (\"smalltalk:newMethod\");\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"emmitFunction:node:withSelf:arguments:doing:",0
,(
function(self,fName,aNode,aBoolean,argumentNames,aBlock)
local aStream=nil
(function()
	local _s8_value=((""):writeStream())
	aStream=_s8_value
	return _s8_value
end)();
if (aBoolean)==true then (aStream):nextPutAll_("self");
smalltalk:if_true_false_(((argumentNames):notEmpty()),(function()
return ((aStream):nextPutAll_((self):argumentsSeparatorOp()))
end),nil); end;
(argumentNames):do_separatedBy_((function(each)
((self):tempVariables()):add_(each);return ((aStream):nextPutAll_((self):localName_(each)))
end),(function()
return ((aStream):nextPutAll_((self):argumentsSeparatorOp()))
end));
(self):emmitFunction_arguments_doing_(fName,(aStream):contents(),aBlock);
return (self);
end
)
,"generation","emmitFunction: fName node: aNode withSelf: aBoolean arguments: argumentNames doing: aBlock\r\n\t\" Private - Generate function for aNode. \"\r\n\r\n\t| aStream |\r\n\taStream := '' writeStream.\r\n\taBoolean ifTrue: [\r\n\t\taStream nextPutAll: #self.\r\n\t\targumentNames notEmpty ifTrue: [ aStream nextPutAll: self argumentsSeparatorOp ].\r\n\t].\r\n\targumentNames do: [:each | \r\n\t\tself tempVariables add: each.\r\n\t\taStream nextPutAll: (self localName: each) ]\r\n\t    separatedBy: [ aStream nextPutAll: self argumentsSeparatorOp ].\r\n\tself\temmitFunction: fName\r\n\t\targuments: aStream contents\r\n\t\tdoing: aBlock","(\r\nfunction(self,fName,aNode,aBoolean,argumentNames,aBlock)\r\nlocal aStream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\taStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (aBoolean)==true then (aStream):nextPutAll_(\"self\");\r\nsmalltalk:if_true_false_(((argumentNames):notEmpty()),(function()\r\nreturn ((aStream):nextPutAll_((self):argumentsSeparatorOp()))\r\nend),nil); end;\r\n(argumentNames):do_separatedBy_((function(each)\r\n((self):tempVariables()):add_(each);return ((aStream):nextPutAll_((self):localName_(each)))\r\nend),(function()\r\nreturn ((aStream):nextPutAll_((self):argumentsSeparatorOp()))\r\nend));\r\n(self):emmitFunction_arguments_doing_(fName,(aStream):contents(),aBlock);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"emmitFunction:node:arguments:doing:",0
,(
function(self,fName,aNode,argumentNames,aBlock)
return ((self):emmitFunction_node_withSelf_arguments_doing_(fName,aNode,false,argumentNames,aBlock));
end
)
,"generation","emmitFunction: fName node: aNode arguments: argumentNames doing: aBlock\r\n\t\" Private - Generate function for aNode. \"\r\n\r\n\t^self\temmitFunction: fName node: aNode\r\n\t\twithSelf: false arguments: argumentNames\r\n\t\tdoing: aBlock","(\r\nfunction(self,fName,aNode,argumentNames,aBlock)\r\nreturn ((self):emmitFunction_node_withSelf_arguments_doing_(fName,aNode,false,argumentNames,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"emmitFunction:node:doing:",0
,(
function(self,fName,aNode,aBlock)
return ((self):emmitFunction_node_withSelf_arguments_doing_(fName,aNode,true,(aNode):argumentNames(),aBlock));
end
)
,"generation","emmitFunction: fName node: aNode doing: aBlock\r\n\t\" Private - Generate function for aNode. \"\r\n\r\n\t^self\temmitFunction: fName node: aNode\r\n\t\twithSelf: true arguments: aNode argumentNames\r\n\t\tdoing: aBlock","(\r\nfunction(self,fName,aNode,aBlock)\r\nreturn ((self):emmitFunction_node_withSelf_arguments_doing_(fName,aNode,true,(aNode):argumentNames(),aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"visitMethodNode:",0
,(
function(self,aNode)
local fnStart=nil
local fnEnd=nil
local nativeSource=nil
if not (((smalltalk.Smalltalk):isRunningOn_((self):nativeLanguage())))==true then return ((self):emmitMethod_(aNode)); end;
(self):nextPutAll_((self):newMethodFunctionName());
(self):nextArgumentsPut_((function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_((self):currentClass()));
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((",\""),(aNode):selector())),"\","));
	return ((_s8_rec):cr())
end
)(self);(function()
	local _s8_value=((self["@stream"]):position())
	fnStart=_s8_value
	return _s8_value
end)();(self):emmitMethod_(aNode);(function()
	local _s8_value=((self["@stream"]):position())
	fnEnd=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_(((self):includeSourceCode()),(function()
(function()
	local _s8_value=(((self["@stream"]):contents()):copyFrom_to_((fnStart):_plus(1),(fnEnd):_plus(1)))
	nativeSource=_s8_value
	return _s8_value
end)();return ((
function(_s8_rec)
	(_s8_rec):cr();
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((","),(self):escaped_((aNode):source())));
	return ((_s8_rec):nextPutAll_(smalltalk:object_comma_((","),(self):escaped_(nativeSource))))
end
)(self))
end),nil))
end));
return (self);
end
)
,"visiting","visitMethodNode: aNode\r\n\t\" Visit a method node. \"\r\n\r\n\t| fnStart fnEnd nativeSource |\r\n\t(Smalltalk isRunningOn: self nativeLanguage) ifFalse: [ ^self emmitMethod: aNode ].\r\n\r\n\t\"return the code for method ready to be injected in the system\"\r\n\tself nextPutAll: self newMethodFunctionName.\r\n\tself nextArgumentsPut: [\r\n\t\tself\r\n\t\t\tnextPutAll: (self smalltalkNameFor: self currentClass);\r\n\t\t\tnextPutAll: ',\"', aNode selector, '\",'; cr.\r\n\t\tfnStart := stream position.\r\n\t\tself emmitMethod: aNode.\r\n\t\tfnEnd := stream position.\r\n\t\tself includeSourceCode ifTrue: [\r\n\t\t\tnativeSource := stream contents copyFrom: fnStart+1 to: fnEnd+1.\r\n\t\t\tself\tcr; \"warning: this cr is important for debugger\"\r\n\t\t\t\tnextPutAll: ',' ,(self escaped: aNode source)\r\n\t\t\t\t;nextPutAll: ',' ,(self escaped: nativeSource)\r\n\t\t]\r\n\t] ","(\r\nfunction(self,aNode)\r\nlocal fnStart=nil\r\nlocal fnEnd=nil\r\nlocal nativeSource=nil\r\nif not (((smalltalk.Smalltalk):isRunningOn_((self):nativeLanguage())))==true then return ((self):emmitMethod_(aNode)); end;\r\n(self):nextPutAll_((self):newMethodFunctionName());\r\n(self):nextArgumentsPut_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_((self):currentClass()));\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\",\\\"\"),(aNode):selector())),\"\\\",\"));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(function()\r\n\tlocal _s8_value=((self[\"@stream\"]):position())\r\n\tfnStart=_s8_value\r\n\treturn _s8_value\r\nend)();(self):emmitMethod_(aNode);(function()\r\n\tlocal _s8_value=((self[\"@stream\"]):position())\r\n\tfnEnd=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_(((self):includeSourceCode()),(function()\r\n(function()\r\n\tlocal _s8_value=(((self[\"@stream\"]):contents()):copyFrom_to_((fnStart):_plus(1),(fnEnd):_plus(1)))\r\n\tnativeSource=_s8_value\r\n\treturn _s8_value\r\nend)();return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((\",\"),(self):escaped_((aNode):source())));\r\n\treturn ((_s8_rec):nextPutAll_(smalltalk:object_comma_((\",\"),(self):escaped_(nativeSource))))\r\nend\r\n)(self))\r\nend),nil))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"visitDirectiveNode:",0
,(
function(self,aNode)
if (smalltalk:responds_to_((aNode),("asNative:for:on:")))==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((aNode):asNative_for_on_(self["@functionName"],self,self["@stream"]));
	return ((_s8_rec):cr())
end
)(self);
return (self); end;
(self):visit_(aNode);
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):separatorOp());
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
)
,"visiting","visitDirectiveNode: aNode\r\n\t\" Private - Visit a directive node. \"\r\n\r\n\t(aNode respondsTo: #asNative:for:on:) ifTrue: [\r\n\t\tself nextPutAll: (aNode\r\n\t\t\tasNative: functionName\r\n\t\t\tfor: self on: stream); cr.\r\n\t\t^self\r\n\t].\r\n\r\n\tself visit: aNode.\r\n\tself nextPutAll: self separatorOp; cr","(\r\nfunction(self,aNode)\r\nif (smalltalk:responds_to_((aNode),(\"asNative:for:on:\")))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((aNode):asNative_for_on_(self[\"@functionName\"],self,self[\"@stream\"]));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self); end;\r\n(self):visit_(aNode);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):separatorOp());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"emmitedCode",0
,(
function(self)
if (smalltalk:isNil_((self["@stream"])))==true then return (nil); end;
if ((smalltalk.Smalltalk):isRunningOn_((self):nativeLanguage()))==true then return (smalltalk:object_comma_(("return "),(self["@stream"]):contents())); end;
return ((self["@stream"]):contents());
end
)
,"results","emmitedCode\r\n\t\" Return the emmited code during compilation (or nil). \"\r\n\r\n\tstream isNil ifTrue: [ ^nil ].\r\n\t(Smalltalk isRunningOn: self nativeLanguage) ifTrue: [\r\n\t\t\"the code must be valid native code including return expression\"\r\n\t\t^'return ' ,stream contents\r\n\t].\r\n\t^stream contents","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@stream\"])))==true then return (nil); end;\r\nif ((smalltalk.Smalltalk):isRunningOn_((self):nativeLanguage()))==true then return (smalltalk:object_comma_((\"return \"),(self[\"@stream\"]):contents())); end;\r\nreturn ((self[\"@stream\"]):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"returnOpStart",0
,(
function(self)
return ("return (");
end
)
,"constants","returnOpStart\r\n\t\" Private - Return the OP for starting return expressions. \"\r\n\r\n\t^'return (' ","(\r\nfunction(self)\r\nreturn (\"return (\");\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"returnOpEnd",0
,(
function(self)
return (")");
end
)
,"constants","returnOpEnd\r\n\t\" Private - Return the OP for ending return expressions. \"\r\n\r\n\t^')' ","(\r\nfunction(self)\r\nreturn (\")\");\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"visitValueNode:",0
,(
function(self,aNode)
(self):nextPutAll_(((aNode):value()):asLua());
return (self);
end
)
,"visiting","visitValueNode: aNode\r\n\t\" Private - Visit the node emmitting output. \"\r\n\r\n\tself nextPutAll: aNode value asLua","(\r\nfunction(self,aNode)\r\n(self):nextPutAll_(((aNode):value()):asLua());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"visitNode:index:",0
,(
function(self,aNode,index)
(self):nextPutAll_("[");
(self):visit_(index);
(self):nextPutAll_("]");
return (self);
end
)
,"visiting","visitNode: aNode index: index\r\n\t\" Private - Generate code for indexed access. \"\r\n\r\n\"ToDo:\t((index isMemberOf: ValueNode) and: [ index hasString ]) ifTrue: [\r\n\t\t| selector |\r\n\t\tselector := self asSelector: index value.\r\n\t\t((selector includes: $ ) or: [ selector includes: $_ ]) ifFalse: [\r\n\t\t\tself nextPutAll: '.'; nextPutAll: selector.\r\n\t\t\t^self\r\n\t\t].\r\n\t].\r\n\"\tself nextPutAll: '['.\r\n\tself visit: index.\r\n\tself nextPutAll: ']'.","(\r\nfunction(self,aNode,index)\r\n(self):nextPutAll_(\"[\");\r\n(self):visit_(index);\r\n(self):nextPutAll_(\"]\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"propertyAccessConnector",0
,(
function(self)
return (".");
end
)
,"encoding","propertyAccessConnector\r\n\t\" Private - Return the connector to use for accessing a native property. \"\r\n\r\n\t^$. ","(\r\nfunction(self)\r\nreturn (\".\");\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"messageSendConnector",0
,(
function(self)
return (":");
end
)
,"encoding","messageSendConnector\r\n\t\" Private - Return the connector to use for sending a message. \"\r\n\r\n\t^$: ","(\r\nfunction(self)\r\nreturn (\":\");\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"functionCallConnector",0
,(
function(self)
return (".");
end
)
,"encoding","functionCallConnector\r\n\t\" Private - Return the connector to use for calling a function. \"\r\n\r\n\t^$. ","(\r\nfunction(self)\r\nreturn (\".\");\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"messageSendConnector:",0
,(
function(self,aNode)
if (smalltalk:isObject_equalTo_(((((aNode):receiver()):messageSendConnector()):size()),0))==true then return (""); end;
if ((self):isNativeCall_(aNode))==true then if (((aNode):selector()):startsWith_((self):callEscape()))==true then return ((self):functionCallConnector()); end;
return ((self):messageSendConnector()); end;
return ((self):messageSendConnector());
end
)
,"encoding","messageSendConnector: aNode\r\n\t\" Private - Return the connector to use for sending message. \"\r\n\r\n\taNode receiver messageSendConnector size = 0 ifTrue: [ ^'' ].\r\n\t(self isNativeCall: aNode) ifTrue: [ \"calling an alien\"\r\n\t\t(aNode selector startsWith: self callEscape) ifTrue: [\r\n\t\t\t^self functionCallConnector\r\n\t\t].\r\n\t\t^self messageSendConnector\r\n\t].\r\n\t^self messageSendConnector ","(\r\nfunction(self,aNode)\r\nif (smalltalk:isObject_equalTo_(((((aNode):receiver()):messageSendConnector()):size()),0))==true then return (\"\"); end;\r\nif ((self):isNativeCall_(aNode))==true then if (((aNode):selector()):startsWith_((self):callEscape()))==true then return ((self):functionCallConnector()); end;\r\nreturn ((self):messageSendConnector()); end;\r\nreturn ((self):messageSendConnector());\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"asPrivateSelector:",0
,(
function(self,aSelector)
local result=nil
(function()
	local _s8_value=((self):asSelector_(aSelector))
	result=_s8_value
	return _s8_value
end)();
if ((aSelector):startsWith_((self):callEscape()))==true then return ((result):copyFrom_to_(2,(result):size())); end;
return (result);
end
)
,"encoding","asPrivateSelector: aSelector\r\n\t\" Private - Validate and returns a valid native selector \"\r\n\r\n\t| result |\r\n\tresult := self asSelector: aSelector.\r\n\t(aSelector startsWith: self callEscape) ifTrue: [ \"call to an alien starting with _\"\r\n\t\t^result copyFrom: 2 to: result size\r\n\t].\r\n\t^result","(\r\nfunction(self,aSelector)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):asSelector_(aSelector))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((aSelector):startsWith_((self):callEscape()))==true then return ((result):copyFrom_to_(2,(result):size())); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"visitPrivateMessage:",0
,(
function(self,aNode)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):messageSendConnector_(aNode));
	return ((_s8_rec):nextPutAll_((self):asPrivateSelector_((aNode):selector())))
end
)(self);
return (self);
end
)
,"visiting","visitPrivateMessage: aNode\r\n\t\" Private - Generate code for native message send.\"\r\n\r\n\tself\r\n\t\tnextPutAll: (self messageSendConnector: aNode);\r\n\t\tnextPutAll: (self asPrivateSelector: aNode selector)","(\r\nfunction(self,aNode)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):messageSendConnector_(aNode));\r\n\treturn ((_s8_rec):nextPutAll_((self):asPrivateSelector_((aNode):selector())))\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"encodeNormalSend:",0
,(
function(self,aNode)
(self):visitReceiver_((aNode):receiver());
(self):visitPrivateMessage_(aNode);
(self):nextArgumentsPut_((function()
return ((self):visitSendArguments_(aNode))
end));
return (self);
end
)
,"encoding","encodeNormalSend: aNode\r\n\t\" Private - Generate code for direct/inlined message send.\"\r\n\r\n\tself visitReceiver: aNode receiver.\r\n\tself visitPrivateMessage: aNode.\r\n\tself nextArgumentsPut: [ self visitSendArguments: aNode ] ","(\r\nfunction(self,aNode)\r\n(self):visitReceiver_((aNode):receiver());\r\n(self):visitPrivateMessage_(aNode);\r\n(self):nextArgumentsPut_((function()\r\nreturn ((self):visitSendArguments_(aNode))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"visitReceiver:",0
,(
function(self,aNode)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):nextArgumentsPut_((function()
local last=nil
(function()
	local _s8_value=((self["@stream"]):position())
	last=_s8_value
	return _s8_value
end)();if ((aNode):isAssignment())==true then (self):visitLocalAssignment_(aNode); else (self):visit_(aNode); end;return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self["@stream"]):position()),last)),(function()
(self["@stream"]):removeLastInput();return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"visiting","visitReceiver: aNode\r\n\t\" Private - Visit the node (as receiver) emmitting output. \"\r\n\r\n\tself nextArgumentsPut: [ | last |\r\n\t\tlast := stream position.\r\n\t\taNode isAssignment\r\n\t\t\tifTrue: [ self visitLocalAssignment: aNode ]\r\n\t\t\tifFalse: [ self visit: aNode ].\r\n\t\tstream position = last ifTrue: [\r\n\t\t\tstream removeLastInput.\r\n\t\t\t^self\r\n\t\t]\r\n\t]","(\r\nfunction(self,aNode)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):nextArgumentsPut_((function()\r\nlocal last=nil\r\n(function()\r\n\tlocal _s8_value=((self[\"@stream\"]):position())\r\n\tlast=_s8_value\r\n\treturn _s8_value\r\nend)();if ((aNode):isAssignment())==true then (self):visitLocalAssignment_(aNode); else (self):visit_(aNode); end;return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self[\"@stream\"]):position()),last)),(function()\r\n(self[\"@stream\"]):removeLastInput();return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"localName:",0
,(
function(self,aName)
if (((self):pseudoVariables()):includes_(aName))==true then return (aName); end;
return ((self):asSelector_(aName));
end
)
,"private","localName: aName\r\n\t\" Private - Return a valid (native, local) name for aName. \"\r\n\r\n\t(self pseudoVariables includes: aName) ifTrue: [ ^aName ].\r\n\t^self asSelector: aName","(\r\nfunction(self,aName)\r\nif (((self):pseudoVariables()):includes_(aName))==true then return (aName); end;\r\nreturn ((self):asSelector_(aName));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"visitGlobalReferenceNode:",0
,(
function(self,aNode)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local aName=nil
local aClass=nil
local lookupPools=nil
(function()
	local _s8_value=((aNode):value())
	aName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((self):currentClass()):instanceClass())
	aClass=_s8_value
	return _s8_value
end)();
(aClass):classVariableNamesDo_((function(each)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((each),aName)),(function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	(_s8_rec):nextPutAll_(":classVariableAt_(\"");
	(_s8_rec):nextPutAll_(aName);
	return ((_s8_rec):nextPutAll_("\")"))
end
)(self);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(aClass):sharedPoolsAndNamesDo_((function(poolName,pool)
return (smalltalk:if_true_false_(((pool):includesKey_(aName)),(function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("(smalltalk:poolDictionary_(\"");
	(_s8_rec):nextPutAll_(poolName);
	(_s8_rec):nextPutAll_("\")):at_(\"");
	(_s8_rec):nextPutAll_(aName);
	return ((_s8_rec):nextPutAll_("\")"))
end
)(self);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("smalltalk.");
	return ((_s8_rec):nextPutAll_((aNode):value()))
end
)(self);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"visiting","visitGlobalReferenceNode: aNode\r\n\r\n\t| aName aClass lookupPools |\r\n\taName := aNode value.\r\n\taClass := self currentClass instanceClass.\r\n\taClass classVariableNamesDo: [:each|\r\n\t\teach = aName ifTrue: [\r\n\t\t\tself\r\n\t\t\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\t\t\tnextPutAll: ':classVariableAt_(\"';\r\n\t\t\t\tnextPutAll: aName;\r\n\t\t\t\tnextPutAll: '\")'.\r\n\t\t\t^self\r\n\t\t]\r\n\t].\r\n\taClass sharedPoolsAndNamesDo: [:poolName :pool|\r\n\t\t(pool includesKey: aName) ifTrue: [\r\n\t\t\tself\r\n\t\t\t\tnextPutAll: '(smalltalk:poolDictionary_(\"';\r\n\t\t\t\tnextPutAll: poolName;\r\n\t\t\t\tnextPutAll: '\")):at_(\"';\r\n\t\t\t\tnextPutAll: aName;\r\n\t\t\t\tnextPutAll: '\")'.\r\n\t\t\t^self\r\n\t\t].\r\n\t].\r\n\tself\r\n\t\tnextPutAll: 'smalltalk.';\r\n\t\tnextPutAll: aNode value.","(\r\nfunction(self,aNode)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal aName=nil\r\nlocal aClass=nil\r\nlocal lookupPools=nil\r\n(function()\r\n\tlocal _s8_value=((aNode):value())\r\n\taName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((self):currentClass()):instanceClass())\r\n\taClass=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aClass):classVariableNamesDo_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((each),aName)),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\t(_s8_rec):nextPutAll_(\":classVariableAt_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(aName);\r\n\treturn ((_s8_rec):nextPutAll_(\"\\\")\"))\r\nend\r\n)(self);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(aClass):sharedPoolsAndNamesDo_((function(poolName,pool)\r\nreturn (smalltalk:if_true_false_(((pool):includesKey_(aName)),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"(smalltalk:poolDictionary_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(poolName);\r\n\t(_s8_rec):nextPutAll_(\"\\\")):at_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(aName);\r\n\treturn ((_s8_rec):nextPutAll_(\"\\\")\"))\r\nend\r\n)(self);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"smalltalk.\");\r\n\treturn ((_s8_rec):nextPutAll_((aNode):value()))\r\nend\r\n)(self);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"visitBlockNode:",0
,(
function(self,aNode)
(self):nextArgumentsPut_((function()
return ((self):emmitFunction_node_arguments_doing_("",aNode,(aNode):parameterNames(),(function()
return (((aNode):nodes()):do_((function(each)
return ((self):visit_(each))
end)))
end)))
end));
return (self);
end
)
,"visiting","visitBlockNode: aNode\r\n\r\n\tself nextArgumentsPut: [\r\n\t\tself\temmitFunction: '' node: aNode\r\n\t\t\targuments: aNode parameterNames\r\n\t\t\tdoing: [ aNode nodes do: [:each | self visit: each ] ]\r\n\t] ","(\r\nfunction(self,aNode)\r\n(self):nextArgumentsPut_((function()\r\nreturn ((self):emmitFunction_node_arguments_doing_(\"\",aNode,(aNode):parameterNames(),(function()\r\nreturn (((aNode):nodes()):do_((function(each)\r\nreturn ((self):visit_(each))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"defineTemporary:",0
,(
function(self,aName)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(("local "),(self):localName_(aName))),"=nil"));
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
)
,"encoding","defineTemporary: aName\r\n\t\" Private - Return the code for defining temporary variable with aName. \"\r\n\r\n\tself nextPutAll: 'local ', (self localName: aName), '=nil' ;cr ","(\r\nfunction(self,aName)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\"local \"),(self):localName_(aName))),\"=nil\"));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"visitCascadeNode:",0
,(
function(self,aNode)
local target=nil
(function()
	local _s8_value=("_s8_rec")
	target=_s8_value
	return _s8_value
end)();
if not ((((self):tempVariables()):includes_(target)))==true then ((self):tempVariables()):add_(target); end;
(self):compilerEvent_with_("aboutCascade:",aNode);
(
function(_s8_rec)
	(_s8_rec):nextArgumentsPut_((function()
(self):cr();(self):emmitFunction_arguments_doing_("",target,(function()
local index=nil
local rec=nil
(function()
	local _s8_value=(0)
	index=_s8_value
	return _s8_value
end)();(self):tab();return (((aNode):nodes()):do_((function(each)
(function()
	local _s8_value=((index):_plus(1))
	index=_s8_value
	return _s8_value
end)();if (smalltalk:isObject_equalTo_((index),((aNode):nodes()):size()))==true then (self):nextPutAll_((self):returnOpStart()); end;(function()
	local _s8_value=((smalltalk.VariableNode):new())
	rec=_s8_value
	return _s8_value
end)();(
function(_s8_rec)
	(_s8_rec):value_(target);
	return ((_s8_rec):start_end_((each):start(),(each):start()))
end
)(rec);(each):receiver_(rec);(self):visit_(each);return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((index),((aNode):nodes()):size())),(function()
(self):compilerEvent_withArguments_("returned:early:",(smalltalk.Array):with_with_(nil,false));return ((self):nextPutAll_((self):returnOpEnd()))
end),(function()
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):separatorOp());
	(_s8_rec):cr();
	return ((_s8_rec):tab())
end
)(self))
end)))
end)))
end));return ((self):cr())
end));
	return ((_s8_rec):nextArgumentsPut_((function()
return ((self):visit_((aNode):receiver()))
end)))
end
)(self);
(self):compilerEvent_with_("cascade:",aNode);
return (self);
end
)
,"visiting","visitCascadeNode: aNode\r\n\r\n\t| target |\r\n\ttarget := #_s8_rec.\r\n\t(self tempVariables includes: target) ifFalse: [ self tempVariables add: target ].\r\n\tself compilerEvent: #aboutCascade: with: aNode.\r\n\tself nextArgumentsPut: [\r\n\t\tself cr.\r\n\t\tself emmitFunction: '' arguments: target doing: [ | index rec |\r\n\t\t\tindex := 0. self tab.\r\n\t\t\taNode nodes do: [:each |\r\n\t\t\t    index := index + 1.\r\n\t\t\t    index = aNode nodes size ifTrue: [ self nextPutAll: self returnOpStart ].\r\n\t\t\t    rec := VariableNode new.\r\n\t\t\t    rec value: target; start: each start end: each start.\r\n\t\t\t    each receiver: rec.\r\n\t\t\t    self visit: each.\r\n\t\t\t    index = aNode nodes size ifTrue: [\r\n\t\t\t\t\tself\tcompilerEvent: #returned:early:\r\n\t\t\t\t\t\twithArguments: (Array with: nil with: false).\r\n\t\t\t\t\tself nextPutAll: self returnOpEnd\r\n\t\t\t    \t] ifFalse: [ self nextPutAll: self separatorOp; cr;tab ]\r\n\t\t\t]\r\n\t\t].\r\n\t\tself cr\r\n\t]; nextArgumentsPut: [ self visit: aNode receiver ].\r\n\tself compilerEvent: #cascade: with: aNode.","(\r\nfunction(self,aNode)\r\nlocal target=nil\r\n(function()\r\n\tlocal _s8_value=(\"_s8_rec\")\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((((self):tempVariables()):includes_(target)))==true then ((self):tempVariables()):add_(target); end;\r\n(self):compilerEvent_with_(\"aboutCascade:\",aNode);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextArgumentsPut_((function()\r\n(self):cr();(self):emmitFunction_arguments_doing_(\"\",target,(function()\r\nlocal index=nil\r\nlocal rec=nil\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();(self):tab();return (((aNode):nodes()):do_((function(each)\r\n(function()\r\n\tlocal _s8_value=((index):_plus(1))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isObject_equalTo_((index),((aNode):nodes()):size()))==true then (self):nextPutAll_((self):returnOpStart()); end;(function()\r\n\tlocal _s8_value=((smalltalk.VariableNode):new())\r\n\trec=_s8_value\r\n\treturn _s8_value\r\nend)();(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):value_(target);\r\n\treturn ((_s8_rec):start_end_((each):start(),(each):start()))\r\nend\r\n)(rec);(each):receiver_(rec);(self):visit_(each);return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((index),((aNode):nodes()):size())),(function()\r\n(self):compilerEvent_withArguments_(\"returned:early:\",(smalltalk.Array):with_with_(nil,false));return ((self):nextPutAll_((self):returnOpEnd()))\r\nend),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):separatorOp());\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):tab())\r\nend\r\n)(self))\r\nend)))\r\nend)))\r\nend));return ((self):cr())\r\nend));\r\n\treturn ((_s8_rec):nextArgumentsPut_((function()\r\nreturn ((self):visit_((aNode):receiver()))\r\nend)))\r\nend\r\n)(self);\r\n(self):compilerEvent_with_(\"cascade:\",aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"emmitAssignment:",0
,(
function(self,aNode)
(
function(_s8_rec)
	(_s8_rec):nextArgumentsPut_((function()
local tab=nil
(function()
	local _s8_value=((smalltalk.String):tab())
	tab=_s8_value
	return _s8_value
end)();(
function(_s8_rec)
	(_s8_rec):nextPutAll_("function()");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):tab();
	return ((_s8_rec):nextPutAll_("local _s8_value="))
end
)(self);(self):nextArgumentsPut_((function()
return ((self):visit_((aNode):right()))
end));(
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):tab())
end
)(self);(self):visit_((aNode):left());(
function(_s8_rec)
	(_s8_rec):nextPutAll_("=_s8_value");
	(_s8_rec):cr();
	(_s8_rec):tab();
	(_s8_rec):nextPutAll_("return _s8_value");
	return ((_s8_rec):cr())
end
)(self);return ((self):nextPutAll_("end"))
end));
	return ((_s8_rec):nextArgumentsPut_((function()
return (nil)
end)))
end
)(self);
return (self);
end
)
,"generation","emmitAssignment: aNode\r\n\t\" Private - Emmit the code for assignment. \"\r\n\r\n\tself nextArgumentsPut: [ | tab |\r\n\t\ttab := String tab.\r\n\t\tself nextPutAll: 'function()'; cr.\r\n\t\tself tab;nextPutAll: 'local _s8_value='.\r\n\t\tself nextArgumentsPut: [ self visit: aNode right ].\r\n\t\tself cr; tab.\r\n\t\tself visit: aNode left.\r\n\t\tself\tnextPutAll: '=_s8_value' \"; '\";\r\n\t\t\t cr; tab;\r\n\t\t\tnextPutAll: 'return _s8_value'; cr.\r\n\t\tself nextPutAll: #end\r\n\t]; nextArgumentsPut: [] ","(\r\nfunction(self,aNode)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextArgumentsPut_((function()\r\nlocal tab=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.String):tab())\r\n\ttab=_s8_value\r\n\treturn _s8_value\r\nend)();(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"function()\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):tab();\r\n\treturn ((_s8_rec):nextPutAll_(\"local _s8_value=\"))\r\nend\r\n)(self);(self):nextArgumentsPut_((function()\r\nreturn ((self):visit_((aNode):right()))\r\nend));(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):tab())\r\nend\r\n)(self);(self):visit_((aNode):left());(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"=_s8_value\");\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):tab();\r\n\t(_s8_rec):nextPutAll_(\"return _s8_value\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):nextPutAll_(\"end\"))\r\nend));\r\n\treturn ((_s8_rec):nextArgumentsPut_((function()\r\nreturn (nil)\r\nend)))\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"visitClassVariableAssignment:in:to:",0
,(
function(self,aClassVariableName,aClass,anExpressionNode)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	(_s8_rec):nextPutAll_(":classVariableAt_put_(\"");
	(_s8_rec):nextPutAll_(aClassVariableName);
	return ((_s8_rec):nextPutAll_("\","))
end
)(self);
(self):visit_(anExpressionNode);
(self):nextPutAll_(")");
return (self);
end
)
,"visiting","visitClassVariableAssignment: aClassVariableName in: aClass to: anExpressionNode\r\n\r\n\tself\r\n\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\tnextPutAll: ':classVariableAt_put_(\"';\r\n\t\tnextPutAll: aClassVariableName; nextPutAll: '\",'.\r\n\tself visit: anExpressionNode.\r\n\tself\tnextPutAll: ')'","(\r\nfunction(self,aClassVariableName,aClass,anExpressionNode)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\t(_s8_rec):nextPutAll_(\":classVariableAt_put_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(aClassVariableName);\r\n\treturn ((_s8_rec):nextPutAll_(\"\\\",\"))\r\nend\r\n)(self);\r\n(self):visit_(anExpressionNode);\r\n(self):nextPutAll_(\")\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"visitPoolVariableAssignment:in:to:",0
,(
function(self,aName,poolName,anExpressionNode)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("smalltalk:poolDictionary_(\"");
	(_s8_rec):nextPutAll_(poolName);
	(_s8_rec):nextPutAll_("\"):at_put_(\"");
	(_s8_rec):nextPutAll_(aName);
	return ((_s8_rec):nextPutAll_("\","))
end
)(self);
(self):visit_(anExpressionNode);
(self):nextPutAll_(")");
return (self);
end
)
,"visiting","visitPoolVariableAssignment: aName in: poolName to: anExpressionNode\r\n\r\n\tself\r\n\t\tnextPutAll: 'smalltalk:poolDictionary_(\"';\r\n\t\tnextPutAll: poolName; nextPutAll: '\"):at_put_(\"';\r\n\t\tnextPutAll: aName; nextPutAll: '\",'.\r\n\tself visit: anExpressionNode.\r\n\tself\tnextPutAll: ')'","(\r\nfunction(self,aName,poolName,anExpressionNode)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"smalltalk:poolDictionary_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(poolName);\r\n\t(_s8_rec):nextPutAll_(\"\\\"):at_put_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(aName);\r\n\treturn ((_s8_rec):nextPutAll_(\"\\\",\"))\r\nend\r\n)(self);\r\n(self):visit_(anExpressionNode);\r\n(self):nextPutAll_(\")\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"visitOperation:",0
,(
function(self,aNode)
(self):compilerEvent_with_("aboutOperation:",aNode);
(self):nextArgumentsPut_((function()
return ((self):visitReceiver_((aNode):receiver()))
end));
(self):nextPutAll_((self):asPrivateSelector_((aNode):selector()));
(self):visitSendArguments_(aNode);
(self):compilerEvent_with_("operation:",aNode);
return (self);
end
)
,"visiting","visitOperation: aNode\r\n\t\" Private - aNode is an operation and selector is mapped to target operation. \"\r\n\r\n\tself compilerEvent: #aboutOperation: with: aNode.\r\n\tself nextArgumentsPut: [ self visitReceiver: aNode receiver ].\r\n\tself nextPutAll: (self asPrivateSelector: aNode selector).\r\n\tself visitSendArguments: aNode.\r\n\tself compilerEvent: #operation: with: aNode.","(\r\nfunction(self,aNode)\r\n(self):compilerEvent_with_(\"aboutOperation:\",aNode);\r\n(self):nextArgumentsPut_((function()\r\nreturn ((self):visitReceiver_((aNode):receiver()))\r\nend));\r\n(self):nextPutAll_((self):asPrivateSelector_((aNode):selector()));\r\n(self):visitSendArguments_(aNode);\r\n(self):compilerEvent_with_(\"operation:\",aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"encodeSuperSend:",0
,(
function(self,aNode)
(self):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk:superImplementor("),(self):smalltalkNameFor_((self):currentClass()))),",\"")),(self):asPrivateSelector_((aNode):selector()))),"\")(self"));
if (((aNode):arguments()):notEmpty())==true then (self):nextPutAll_((self):argumentsSeparatorOp());
(self):visitSendArguments_(aNode); end;
(self):nextPutAll_(")");
return (self);
end
)
,"encoding","encodeSuperSend: aNode\r\n\t\" Private - Generate code for super message send.\"\r\n\r\n\tself\r\n\t\tnextPutAll: 'smalltalk:superImplementor('\r\n\t\t\t,(self smalltalkNameFor: self currentClass)\r\n\t\t\t,',\"',(self asPrivateSelector: aNode selector)\r\n\t\t\t,'\")(self'.\r\n\taNode arguments notEmpty ifTrue: [\r\n\t\tself nextPutAll: self argumentsSeparatorOp.\r\n\t\tself visitSendArguments: aNode\r\n\t].\r\n\tself nextPutAll: ')'. ","(\r\nfunction(self,aNode)\r\n(self):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk:superImplementor(\"),(self):smalltalkNameFor_((self):currentClass()))),\",\\\"\")),(self):asPrivateSelector_((aNode):selector()))),\"\\\")(self\"));\r\nif (((aNode):arguments()):notEmpty())==true then (self):nextPutAll_((self):argumentsSeparatorOp());\r\n(self):visitSendArguments_(aNode); end;\r\n(self):nextPutAll_(\")\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"visitReturnNode:",0
,(
function(self,aNode)
local theReturn=nil
if (((self["@nestedBlocks"]) > 0))==true then (function()
	local _s8_value=(true)
	self["@earlyReturn"]=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=((function()
return ((self):emmitReturn_((function()
return (((aNode):nodes()):do_((function(each)
return ((self):visit_(each))
end)))
end)))
end))
	theReturn=_s8_value
	return _s8_value
end)();
if not ((self["@earlyReturn"]))==true then return ((theReturn):value()); end;
(
function(_s8_rec)
	(_s8_rec):nextArgumentsPut_((function()
return ((self):emmitFunctionDoing_((function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("_s8Ret_.hasResult=true");
	return ((_s8_rec):cr())
end
)(self);(self):nextPutAll_("_s8Ret_.result=");(
function(_s8_rec)
	(_s8_rec):nextArgumentsPut_((function()
return ((
function(_s8_rec)
	(_s8_rec):emmitFunctionDoing_(theReturn);
	return ((_s8_rec):cr())
end
)(self))
end));
	return ((_s8_rec):nextArgumentsPut_((function()
return (nil)
end)))
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_("error(_s8Ret_,0)"))
end
)(self))
end)))
end));
	return ((_s8_rec):nextArgumentsPut_((function()
return (nil)
end)))
end
)(self);
return (self);
end
)
,"visiting","visitReturnNode: aNode\r\n\r\n\t| theReturn |\r\n\tnestedBlocks > 0 ifTrue: [ earlyReturn := true ].\r\n\ttheReturn := [ self emmitReturn: [\r\n\t\taNode nodes do: [:each | self visit: each ]\r\n\t] ].\r\n\tearlyReturn ifFalse: [ ^theReturn value ].\r\n\r\n\tself nextArgumentsPut: [\r\n\t\tself emmitFunctionDoing: [\r\n\t\t\tself nextPutAll: '_s8Ret_.hasResult=true';cr.\r\n\t\t\tself nextPutAll: '_s8Ret_.result='.\r\n\t\t\tself nextArgumentsPut: [\r\n\t\t\t\tself emmitFunctionDoing: theReturn; cr\r\n\t\t\t]; nextArgumentsPut: [].\r\n\t\t\tself cr;nextPutAll: 'error(_s8Ret_,0)'\r\n\t\t]\r\n\t]; nextArgumentsPut: [] ","(\r\nfunction(self,aNode)\r\nlocal theReturn=nil\r\nif (((self[\"@nestedBlocks\"]) > 0))==true then (function()\r\n\tlocal _s8_value=(true)\r\n\tself[\"@earlyReturn\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((function()\r\nreturn ((self):emmitReturn_((function()\r\nreturn (((aNode):nodes()):do_((function(each)\r\nreturn ((self):visit_(each))\r\nend)))\r\nend)))\r\nend))\r\n\ttheReturn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((self[\"@earlyReturn\"]))==true then return ((theReturn):value()); end;\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextArgumentsPut_((function()\r\nreturn ((self):emmitFunctionDoing_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"_s8Ret_.hasResult=true\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):nextPutAll_(\"_s8Ret_.result=\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextArgumentsPut_((function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):emmitFunctionDoing_(theReturn);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));\r\n\treturn ((_s8_rec):nextArgumentsPut_((function()\r\nreturn (nil)\r\nend)))\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(\"error(_s8Ret_,0)\"))\r\nend\r\n)(self))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):nextArgumentsPut_((function()\r\nreturn (nil)\r\nend)))\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"generate:early:return:",0
,(
function(self,fName,early,code)
local prev=nil
if not ((early))==true then (self):nextPutAll_(code);
return (0); end;
(function()
	local _s8_value=("\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n")
	prev=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(prev);
	(_s8_rec):nextPutAll_(code);
	return ((_s8_rec):nextPutAll_("\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      "))
end
)(self);
(self):emmitReturn_early_("_s8Ret_.result",true);
(self):nextPutAll_("\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n");
return ((prev):size());
end
)
,"generation","generate: fName early: early return: code\r\n\t\" Private - Generate code to catch early return of code expression in fName. \"\r\n\r\n\t| prev |\r\n\tearly ifFalse: [ self nextPutAll: code. ^0 ].\r\n\tprev := '\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n'.\r\n\tself\tnextPutAll: prev;\r\n\t\tnextPutAll: code;\r\n\t\tnextPutAll: '\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      '.\tself emmitReturn: '_s8Ret_.result' early: true.\r\n\tself nextPutAll: '\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n'.\r\n\t^prev size","(\r\nfunction(self,fName,early,code)\r\nlocal prev=nil\r\nif not ((early))==true then (self):nextPutAll_(code);\r\nreturn (0); end;\r\n(function()\r\n\tlocal _s8_value=(\"\\r\\nlocal _s8Ret_={[\\\"name\\\"]=\\\"stReturn\\\"}\\r\\nlocal _s8_f = function()\\r\\n\")\r\n\tprev=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(prev);\r\n\t(_s8_rec):nextPutAll_(code);\r\n\treturn ((_s8_rec):nextPutAll_(\"\\r\\nend\\r\\nlocal _s8_status, _s8_result = pcall(_s8_f)\\r\\nif _s8_status then return _s8_result\\r\\nelse\\r\\n    if (_s8Ret_.hasResult) then\\r\\n      \"))\r\nend\r\n)(self);\r\n(self):emmitReturn_early_(\"_s8Ret_.result\",true);\r\n(self):nextPutAll_(\"\\r\\n    end\\r\\nend\\r\\nerror(_s8_result,0)\\r\\n\");\r\nreturn ((prev):size());\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"coreOptimizations",0
,(
function(self)
return (smalltalk:newArray({"core", smalltalk:newArray({smalltalk:newArray({"class", "%receiver%[\"$klass\"]"}), smalltalk:newArray({"isNil", "%:isNil_%(%receiver%)"}), smalltalk:newArray({"notNil", "%:notNil_%(%receiver%)"}), smalltalk:newArray({"=", "%:isObject_equalTo_%(%receiver%,%arg1%)"}), smalltalk:newArray({"~=", "(not %:isObject_equalTo_%(%receiver%,%arg1%))"}), smalltalk:newArray({"==", "(%receiver%==%arg1%)"}), smalltalk:newArray({"~~", "(%receiver%~=%arg1%)"}), smalltalk:newArray({"===", "(%receiver% == %arg1%)"}), smalltalk:newArray({"||", "(%receiver% or %arg1%)"}), smalltalk:newArray({",", "%:object_comma_%(%receiver%,%arg1%)"}), smalltalk:newArray({"basicAt:", "%receiver%[%arg1%]"}), smalltalk:newArray({"basicAt:ifAbsent:", "%:basic_at_ifAbsent_%(%receiver%,%arg1%,%arg2%)"}), smalltalk:newArray({"basicAt:put:", "%:basic_at_put_%(%receiver%,%arg1%,%arg2%)"}), smalltalk:newArray({"ifUndefined:", "%:ifUndefined_do_%(%receiver%,%arg1%)"})})}));
end
)
,"optimization","coreOptimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(core  #(\r\n\t\t#(class\t'%receiver%[\"$klass\"]' )\r\n\t\t#(isNil\t'%:isNil_%(%receiver%)' )\r\n\t\t#(notNil\t'%:notNil_%(%receiver%)' )\r\n\t\t#(=\t'%:isObject_equalTo_%(%receiver%,%arg1%)' )\r\n\t\t#(~=\t'(not %:isObject_equalTo_%(%receiver%,%arg1%))' )\r\n\t\t#(==\t'(%receiver%==%arg1%)' )\r\n\t\t#(~~\t'(%receiver%~=%arg1%)' )\r\n\t\t#(===\t'(%receiver% == %arg1%)' )\r\n\t\t#(||\t'(%receiver% or %arg1%)' )\r\n\t\t#(,\t'%:object_comma_%(%receiver%,%arg1%)' )\r\n\t\t#(basicAt:\t'%receiver%[%arg1%]' )\r\n\t\t#(basicAt:ifAbsent: '%:basic_at_ifAbsent_%(%receiver%,%arg1%,%arg2%)' )\r\n\t\t#(basicAt:put:\t'%:basic_at_put_%(%receiver%,%arg1%,%arg2%)' )\r\n\t\t#(ifUndefined:\t'%:ifUndefined_do_%(%receiver%,%arg1%)' )\r\n\t))","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"core\", smalltalk:newArray({smalltalk:newArray({\"class\", \"%receiver%[\\\"$klass\\\"]\"}), smalltalk:newArray({\"isNil\", \"%:isNil_%(%receiver%)\"}), smalltalk:newArray({\"notNil\", \"%:notNil_%(%receiver%)\"}), smalltalk:newArray({\"=\", \"%:isObject_equalTo_%(%receiver%,%arg1%)\"}), smalltalk:newArray({\"~=\", \"(not %:isObject_equalTo_%(%receiver%,%arg1%))\"}), smalltalk:newArray({\"==\", \"(%receiver%==%arg1%)\"}), smalltalk:newArray({\"~~\", \"(%receiver%~=%arg1%)\"}), smalltalk:newArray({\"===\", \"(%receiver% == %arg1%)\"}), smalltalk:newArray({\"||\", \"(%receiver% or %arg1%)\"}), smalltalk:newArray({\",\", \"%:object_comma_%(%receiver%,%arg1%)\"}), smalltalk:newArray({\"basicAt:\", \"%receiver%[%arg1%]\"}), smalltalk:newArray({\"basicAt:ifAbsent:\", \"%:basic_at_ifAbsent_%(%receiver%,%arg1%,%arg2%)\"}), smalltalk:newArray({\"basicAt:put:\", \"%:basic_at_put_%(%receiver%,%arg1%,%arg2%)\"}), smalltalk:newArray({\"ifUndefined:\", \"%:ifUndefined_do_%(%receiver%,%arg1%)\"})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"s8Optimizations",0
,(
function(self)
return (smalltalk:newArray({"s8", smalltalk:newArray({"core", smalltalk:newArray({"ifTrue:", "hasBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"ifTrue:", "noClient:", "if %receiver%==true then %seq1% end"}), smalltalk:newArray({"ifTrue:", "%:if_true_false_%(%receiver%,%arg1%,nil)"})})}), smalltalk:newArray({"ifFalse:", "hasBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"ifFalse:", "noClient:", "if not (%receiver%)==true then %seq1% end"}), smalltalk:newArray({"ifFalse:", "%:if_true_false_%(%receiver%,nil,%arg1%)"})})}), smalltalk:newArray({"ifTrue:ifFalse:", "hasBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"ifTrue:ifFalse:", "noClient:", "if %receiver%==true then %seq1% else %seq2% end"}), smalltalk:newArray({"ifTrue:ifFalse:", "%:if_true_false_%(%receiver%,%arg1%,%arg2%)"})})}), smalltalk:newArray({"ifFalse:ifTrue:", "hasBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"ifFalse:ifTrue:", "noClient:", "if %receiver%==true then %seq2% else %seq1% end"}), smalltalk:newArray({"ifFalse:ifTrue:", "%:if_true_false_%(%receiver%,%arg2%,%arg1%)"})})}), smalltalk:newArray({"whileTrue", "receiverIsBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"whileTrue", "noClient:", "while %receiver%() do end"}), smalltalk:newArray({"whileTrue", "%:while_do_%(%receiver%,nil)"})})}), smalltalk:newArray({"whileFalse", "receiverIsBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"whileFalse", "noClient:", "while not %receiver%() do end"}), smalltalk:newArray({"whileFalse", "%:whileNot_do_%(%receiver%,nil)"})})}), smalltalk:newArray({"whileTrue:", "receiverIsBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"whileTrue:", "noClient:", "while %receiver%() do %seq1% end"}), smalltalk:newArray({"whileTrue:", "%:while_do_%(%receiver%,%arg1%)"})})}), smalltalk:newArray({"whileFalse:", "receiverIsBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"whileFalse:", "noClient:", "while not %receiver%() do %seq1% end"}), smalltalk:newArray({"whileFalse:", "%:whileNot_do_%(%receiver%,%arg1%)"})})}), smalltalk:newArray({"orNil", "%:orNil_%(%receiver%)"}), smalltalk:newArray({"timesRepeat:", "%:times_repeat_%(%receiver%,%arg1%)"}), smalltalk:newArray({"isKindOf:", "%:is_kindOf_%(%receiver%,(%arg1%))"}), smalltalk:newArray({"respondsTo:", "%:responds_to_%(%receiver%,(%arg1%))"}), smalltalk:newArray({"ifNil:", "%:if_nil_notNil_%(%receiver%,%arg1%,nil)"}), smalltalk:newArray({"ifNotNil:", "%:if_nil_notNil_%(%receiver%,nil,%arg1%)"}), smalltalk:newArray({"ifNil:ifNotNil:", "%:if_nil_notNil_%(%receiver%,%arg1%,%arg2%)"}), smalltalk:newArray({"ifNotNil:ifNil:", "%:if_nil_notNil_%(%receiver%,%arg2%,%arg1%)"})})}));
end
)
,"optimization","s8Optimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(s8\t#(\r\n\t\tcore\r\n\t\t#(ifTrue: hasBlockNoArguments: #(\r\n\t\t\t#(ifTrue: noClient: 'if %receiver%==true then %seq1% end' )\r\n\t\t\t#(ifTrue: '%:if_true_false_%(%receiver%,%arg1%,nil)' )\r\n\t\t))\r\n\t\t#(ifFalse: hasBlockNoArguments: #(\r\n\t\t\t#(ifFalse: noClient: 'if not (%receiver%)==true then %seq1% end' )\r\n\t\t\t#(ifFalse: '%:if_true_false_%(%receiver%,nil,%arg1%)' )\r\n\t\t))\r\n\t\t#(ifTrue:ifFalse: hasBlockNoArguments: #(\r\n\t\t\t#(ifTrue:ifFalse: noClient: 'if %receiver%==true then %seq1% else %seq2% end' )\r\n\t\t\t#(ifTrue:ifFalse: '%:if_true_false_%(%receiver%,%arg1%,%arg2%)' )\r\n\t\t))\r\n\t\t#(ifFalse:ifTrue: hasBlockNoArguments: #(\r\n\t\t\t#(ifFalse:ifTrue: noClient: 'if %receiver%==true then %seq2% else %seq1% end' )\r\n\t\t\t#(ifFalse:ifTrue: '%:if_true_false_%(%receiver%,%arg2%,%arg1%)' )\r\n\t\t))\r\n\t\t#(whileTrue receiverIsBlockNoArguments: #(\r\n\t\t\t#(whileTrue noClient: 'while %receiver%() do end' )\r\n\t\t\t#(whileTrue '%:while_do_%(%receiver%,nil)' )\r\n\t\t))\r\n\t\t#(whileFalse receiverIsBlockNoArguments: #(\r\n\t\t\t#(whileFalse noClient: 'while not %receiver%() do end' )\r\n\t\t\t#(whileFalse '%:whileNot_do_%(%receiver%,nil)' )\r\n\t\t))\r\n\t\t#(whileTrue: receiverIsBlockNoArguments: #(\r\n\t\t\t#(whileTrue: noClient: 'while %receiver%() do %seq1% end' )\r\n\t\t\t#(whileTrue: '%:while_do_%(%receiver%,%arg1%)' )\r\n\t\t))\r\n\t\t#(whileFalse: receiverIsBlockNoArguments: #(\r\n\t\t\t#(whileFalse: noClient: 'while not %receiver%() do %seq1% end' )\r\n\t\t\t#(whileFalse: '%:whileNot_do_%(%receiver%,%arg1%)' )\r\n\t\t))\r\n\t\t#(orNil '%:orNil_%(%receiver%)' )\r\n\t\t#(timesRepeat: '%:times_repeat_%(%receiver%,%arg1%)' )\r\n\t\t#(isKindOf: '%:is_kindOf_%(%receiver%,(%arg1%))' )\r\n\t\t#(respondsTo: '%:responds_to_%(%receiver%,(%arg1%))' )\r\n\t\t#(ifNil: '%:if_nil_notNil_%(%receiver%,%arg1%,nil)' )\r\n\t\t#(ifNotNil: '%:if_nil_notNil_%(%receiver%,nil,%arg1%)' )\r\n\t\t#(ifNil:ifNotNil: '%:if_nil_notNil_%(%receiver%,%arg1%,%arg2%)' )\r\n\t\t#(ifNotNil:ifNil: '%:if_nil_notNil_%(%receiver%,%arg2%,%arg1%)' )\r\n\t))","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"s8\", smalltalk:newArray({\"core\", smalltalk:newArray({\"ifTrue:\", \"hasBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"ifTrue:\", \"noClient:\", \"if %receiver%==true then %seq1% end\"}), smalltalk:newArray({\"ifTrue:\", \"%:if_true_false_%(%receiver%,%arg1%,nil)\"})})}), smalltalk:newArray({\"ifFalse:\", \"hasBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"ifFalse:\", \"noClient:\", \"if not (%receiver%)==true then %seq1% end\"}), smalltalk:newArray({\"ifFalse:\", \"%:if_true_false_%(%receiver%,nil,%arg1%)\"})})}), smalltalk:newArray({\"ifTrue:ifFalse:\", \"hasBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"ifTrue:ifFalse:\", \"noClient:\", \"if %receiver%==true then %seq1% else %seq2% end\"}), smalltalk:newArray({\"ifTrue:ifFalse:\", \"%:if_true_false_%(%receiver%,%arg1%,%arg2%)\"})})}), smalltalk:newArray({\"ifFalse:ifTrue:\", \"hasBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"ifFalse:ifTrue:\", \"noClient:\", \"if %receiver%==true then %seq2% else %seq1% end\"}), smalltalk:newArray({\"ifFalse:ifTrue:\", \"%:if_true_false_%(%receiver%,%arg2%,%arg1%)\"})})}), smalltalk:newArray({\"whileTrue\", \"receiverIsBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"whileTrue\", \"noClient:\", \"while %receiver%() do end\"}), smalltalk:newArray({\"whileTrue\", \"%:while_do_%(%receiver%,nil)\"})})}), smalltalk:newArray({\"whileFalse\", \"receiverIsBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"whileFalse\", \"noClient:\", \"while not %receiver%() do end\"}), smalltalk:newArray({\"whileFalse\", \"%:whileNot_do_%(%receiver%,nil)\"})})}), smalltalk:newArray({\"whileTrue:\", \"receiverIsBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"whileTrue:\", \"noClient:\", \"while %receiver%() do %seq1% end\"}), smalltalk:newArray({\"whileTrue:\", \"%:while_do_%(%receiver%,%arg1%)\"})})}), smalltalk:newArray({\"whileFalse:\", \"receiverIsBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"whileFalse:\", \"noClient:\", \"while not %receiver%() do %seq1% end\"}), smalltalk:newArray({\"whileFalse:\", \"%:whileNot_do_%(%receiver%,%arg1%)\"})})}), smalltalk:newArray({\"orNil\", \"%:orNil_%(%receiver%)\"}), smalltalk:newArray({\"timesRepeat:\", \"%:times_repeat_%(%receiver%,%arg1%)\"}), smalltalk:newArray({\"isKindOf:\", \"%:is_kindOf_%(%receiver%,(%arg1%))\"}), smalltalk:newArray({\"respondsTo:\", \"%:responds_to_%(%receiver%,(%arg1%))\"}), smalltalk:newArray({\"ifNil:\", \"%:if_nil_notNil_%(%receiver%,%arg1%,nil)\"}), smalltalk:newArray({\"ifNotNil:\", \"%:if_nil_notNil_%(%receiver%,nil,%arg1%)\"}), smalltalk:newArray({\"ifNil:ifNotNil:\", \"%:if_nil_notNil_%(%receiver%,%arg1%,%arg2%)\"}), smalltalk:newArray({\"ifNotNil:ifNil:\", \"%:if_nil_notNil_%(%receiver%,%arg2%,%arg1%)\"})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"magnitudeOptimizations",0
,(
function(self)
return (smalltalk:newArray({"magnitude", smalltalk:newArray({smalltalk:newArray({">", "(%receiver% > %arg1%)"}), smalltalk:newArray({"<", "(%receiver% < %arg1%)"}), smalltalk:newArray({">=", "(%receiver% >= %arg1%)"}), smalltalk:newArray({"<=", "(%receiver% <= %arg1%)"})})}));
end
)
,"optimization","magnitudeOptimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(magnitude #(\r\n\t\t#(> \t'(%receiver% > %arg1%)' )\r\n\t\t#(< \t'(%receiver% < %arg1%)' )\r\n\t\t#(>=\t'(%receiver% >= %arg1%)' )\r\n\t\t#(<=\t'(%receiver% <= %arg1%)' )\r\n\t))","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"magnitude\", smalltalk:newArray({smalltalk:newArray({\">\", \"(%receiver% > %arg1%)\"}), smalltalk:newArray({\"<\", \"(%receiver% < %arg1%)\"}), smalltalk:newArray({\">=\", \"(%receiver% >= %arg1%)\"}), smalltalk:newArray({\"<=\", \"(%receiver% <= %arg1%)\"})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"mathOptimizations",0
,(
function(self)
return (smalltalk:newArray({"math", smalltalk:newArray({smalltalk:newArray({"max:", "%:math_max_%(%receiver%,%arg1%)"}), smalltalk:newArray({"min:", "%:math_min_%(%receiver%,%arg1%)"}), smalltalk:newArray({"mustBeNumber", "%:mustBeNumber_%(%receiver%)"}), smalltalk:newArray({"+", "(%receiver% + %arg1%)"}), smalltalk:newArray({"-", "(%receiver% - %arg1%)"}), smalltalk:newArray({"*", "(%receiver% * %arg1%)"}), smalltalk:newArray({"/", "(%receiver% / %arg1%)"})})}));
end
)
,"optimization","mathOptimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(math #(\r\n\t\t#(max:\t'%:math_max_%(%receiver%,%arg1%)' )\r\n\t\t#(min:\t'%:math_min_%(%receiver%,%arg1%)' )\r\n\t\t#(mustBeNumber\t'%:mustBeNumber_%(%receiver%)' )\r\n\t\t#(+\t'(%receiver% + %arg1%)' )\r\n\t\t#(#-\t'(%receiver% - %arg1%)' )\r\n\t\t#(*\t'(%receiver% * %arg1%)' )\r\n\t\t#(/\t'(%receiver% / %arg1%)' )\r\n\t))","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"math\", smalltalk:newArray({smalltalk:newArray({\"max:\", \"%:math_max_%(%receiver%,%arg1%)\"}), smalltalk:newArray({\"min:\", \"%:math_min_%(%receiver%,%arg1%)\"}), smalltalk:newArray({\"mustBeNumber\", \"%:mustBeNumber_%(%receiver%)\"}), smalltalk:newArray({\"+\", \"(%receiver% + %arg1%)\"}), smalltalk:newArray({\"-\", \"(%receiver% - %arg1%)\"}), smalltalk:newArray({\"*\", \"(%receiver% * %arg1%)\"}), smalltalk:newArray({\"/\", \"(%receiver% / %arg1%)\"})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"printingOptimizations",0
,(
function(self)
return (smalltalk:newArray({"printing", smalltalk:newArray({smalltalk:newArray({"toString", "%:toString_%(%receiver%)"}), smalltalk:newArray({"printString", "%:printString_%(%receiver%)"}), smalltalk:newArray({"asString", "%:asString_%(%receiver%)"}), smalltalk:newArray({"asCharacter", "%:asCharacter_%(%receiver%)"})})}));
end
)
,"optimization","printingOptimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(printing #(\r\n\t\t#(toString\t'%:toString_%(%receiver%)' )\r\n\t\t#(printString\t'%:printString_%(%receiver%)' )\r\n\t\t#(asString\t'%:asString_%(%receiver%)' )\r\n\t\t#(asCharacter\t'%:asCharacter_%(%receiver%)' )\r\n\t))","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"printing\", smalltalk:newArray({smalltalk:newArray({\"toString\", \"%:toString_%(%receiver%)\"}), smalltalk:newArray({\"printString\", \"%:printString_%(%receiver%)\"}), smalltalk:newArray({\"asString\", \"%:asString_%(%receiver%)\"}), smalltalk:newArray({\"asCharacter\", \"%:asCharacter_%(%receiver%)\"})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"booleanOptimizations",0
,(
function(self)
return (smalltalk:newArray({"boolean", smalltalk:newArray({smalltalk:newArray({"isBoolean", "(type(%receiver%)==\"boolean\")"}), smalltalk:newArray({"and:", "hasBlockNoArguments:", "%:boolean_and_%(%receiver%,%arg1%)"}), smalltalk:newArray({"or:", "hasBlockNoArguments:", "%:boolean_or_%(%receiver%,%arg1%)"}), smalltalk:newArray({"not", "%:booleanNot_%(%receiver%)"})})}));
end
)
,"optimization","booleanOptimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(boolean #(\r\n\t\t#(isBoolean '(type(%receiver%)==\"boolean\")' )\r\n\t\t#(and: hasBlockNoArguments: '%:boolean_and_%(%receiver%,%arg1%)' )\r\n\t\t#(or: hasBlockNoArguments:  '%:boolean_or_%(%receiver%,%arg1%)' )\r\n\t\t#(not '%:booleanNot_%(%receiver%)' )\r\n\t))","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"boolean\", smalltalk:newArray({smalltalk:newArray({\"isBoolean\", \"(type(%receiver%)==\\\"boolean\\\")\"}), smalltalk:newArray({\"and:\", \"hasBlockNoArguments:\", \"%:boolean_and_%(%receiver%,%arg1%)\"}), smalltalk:newArray({\"or:\", \"hasBlockNoArguments:\", \"%:boolean_or_%(%receiver%,%arg1%)\"}), smalltalk:newArray({\"not\", \"%:booleanNot_%(%receiver%)\"})})}));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"defaultKnownOptimizations",0
,(
function(self)
return ((
function(_s8_rec)
	(_s8_rec):add_((self):s8Optimizations());
	(_s8_rec):add_((self):magnitudeOptimizations());
	(_s8_rec):add_((self):booleanOptimizations());
	(_s8_rec):add_((self):printingOptimizations());
	return ((_s8_rec):yourself())
end
)((smalltalk.Array):with_((self):coreOptimizations())));
end
)
,"defaults","defaultKnownOptimizations\r\n\t\" Private - Return the default knownOptimizations of the receiver. \"\r\n\r\n\t^(Array\twith: self coreOptimizations)\r\n\t\tadd: self s8Optimizations;\r\n\t\tadd: self magnitudeOptimizations;\r\n\"\t\tadd: self mathOptimizations;\"\r\n\t\tadd: self booleanOptimizations;\r\n\t\tadd: self printingOptimizations;\r\n\t\tyourself","(\r\nfunction(self)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_((self):s8Optimizations());\r\n\t(_s8_rec):add_((self):magnitudeOptimizations());\r\n\t(_s8_rec):add_((self):booleanOptimizations());\r\n\t(_s8_rec):add_((self):printingOptimizations());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.Array):with_((self):coreOptimizations())));\r\nend\r\n)")
smalltalk:bind(smalltalk.LuaEncoder,"defaultOptimizations",0
,(
function(self)
return (smalltalk:newArray({"s8", "magnitude", "boolean", "printing"}));
end
)
,"defaults","defaultOptimizations\r\n\t\" Private - Return the default optimizations of the receiver. \"\r\n\r\n\t^#( s8 magnitude \"math\" boolean \"evaluation\" printing )","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"s8\", \"magnitude\", \"boolean\", \"printing\"}));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"constructEventsTriggered",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:newArray({"needsCookie:", "startVisit:", "endVisit:", "startMethod:", "enterMethod:", "endMethod:", "startFunction:with:", "startFunctionName:", "startFunctionBody:with:", "endFunction:", "aboutReturn:", "return:", "returned:early:", "aboutSend:", "send:", "aboutOperation:", "operation:", "aboutCascade:", "cascade:", "aboutToCompile:", "setTransformers:", "needsParser", "aboutToParse:", "needsEncoder", "aboutToEncode:", "aboutToRecompile:", "recompiled:", "startCompiling:", "endCompiling:", "needsOptimizationMap", "initializeOptimizations", "customizeOptimizations", "unknownVariable:", "acceptAssignmentTo:", "invalidAssignment:", "move:by:"})),smalltalk:superImplementor(smalltalk.Compiler["$klass"],"constructEventsTriggered")(self)));
end
)
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^#(\t#needsCookie: #startVisit: #endVisit:\r\n\t\t#startMethod: #enterMethod: #endMethod:\r\n\t\t#startFunction:with: #startFunctionName: #startFunctionBody:with: #endFunction:\r\n\t\t#aboutReturn: #return: #returned:early:\r\n\t\t#aboutSend: #send:\r\n\t\t#aboutOperation: #operation:\r\n\t\t#aboutCascade: #cascade:\r\n\t\t#aboutToCompile: #setTransformers:\r\n\t\t#needsParser #aboutToParse:\r\n\t\t#needsEncoder #aboutToEncode:\r\n\t\t#aboutToRecompile: #recompiled:\r\n\t\t#startCompiling: #endCompiling:\r\n\t\t#needsOptimizationMap #initializeOptimizations #customizeOptimizations\r\n\t\t#unknownVariable: #acceptAssignmentTo: #invalidAssignment:\r\n\t\t#move:by:\r\n\t) ,super constructEventsTriggered","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:newArray({\"needsCookie:\", \"startVisit:\", \"endVisit:\", \"startMethod:\", \"enterMethod:\", \"endMethod:\", \"startFunction:with:\", \"startFunctionName:\", \"startFunctionBody:with:\", \"endFunction:\", \"aboutReturn:\", \"return:\", \"returned:early:\", \"aboutSend:\", \"send:\", \"aboutOperation:\", \"operation:\", \"aboutCascade:\", \"cascade:\", \"aboutToCompile:\", \"setTransformers:\", \"needsParser\", \"aboutToParse:\", \"needsEncoder\", \"aboutToEncode:\", \"aboutToRecompile:\", \"recompiled:\", \"startCompiling:\", \"endCompiling:\", \"needsOptimizationMap\", \"initializeOptimizations\", \"customizeOptimizations\", \"unknownVariable:\", \"acceptAssignmentTo:\", \"invalidAssignment:\", \"move:by:\"})),smalltalk:superImplementor(smalltalk.Compiler[\"$klass\"],\"constructEventsTriggered\")(self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"debugCookieFrom:",0
,(
function(self,aStream)
local nextOffset=nil
(function()
	local _s8_value=((function()
return (((aStream):nextChunk()):asNumber())
end))
	nextOffset=_s8_value
	return _s8_value
end)();
return ((smalltalk.Array):with_with_with_with_((aStream):nextChunk(),((nextOffset):value()):_at((nextOffset):value()),((nextOffset):value()):_at((nextOffset):value()),((aStream):nextChunk()):asArrayOfSubstrings()));
end
)
,"private","debugCookieFrom: aStream\r\n\t\" Private - Return the next debug cookie encoded in aStream (or nil). \"\r\n\r\n\t| nextOffset |\r\n\tnextOffset := [ aStream nextChunk asNumber ].\r\n\t^Array\t\"ref. #debugInfo:forClass: \"\r\n\t\twith: aStream nextChunk\r\n\t\twith: nextOffset value @ nextOffset value\r\n\t\twith: nextOffset value @ nextOffset value\r\n\t\twith: aStream nextChunk asArrayOfSubstrings","(\r\nfunction(self,aStream)\r\nlocal nextOffset=nil\r\n(function()\r\n\tlocal _s8_value=((function()\r\nreturn (((aStream):nextChunk()):asNumber())\r\nend))\r\n\tnextOffset=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((smalltalk.Array):with_with_with_with_((aStream):nextChunk(),((nextOffset):value()):_at((nextOffset):value()),((nextOffset):value()):_at((nextOffset):value()),((aStream):nextChunk()):asArrayOfSubstrings()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"debugCookiesFrom:",0
,(
function(self,aStream)
local result=nil
local cookie=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
while not ((function()
return ((
function(_s8_rec)
	(_s8_rec):skipSeparators();
	return ((_s8_rec):atEnd())
end
)(aStream))
end))() do (function()
	local _s8_value=((self):debugCookieFrom_(aStream))
	cookie=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:notNil_((cookie))),(function()
return ((result):add_(cookie))
end),nil); end;
return (result);
end
)
,"private","debugCookiesFrom: aStream\r\n\t\" Private - Return the debug cookies encoded in aStream. \"\r\n\r\n\t| result cookie |\r\n\tresult := Array new.\r\n\t[ aStream skipSeparators; atEnd ] whileFalse: [\r\n\t\tcookie := self debugCookieFrom: aStream.\r\n\t\tcookie notNil ifTrue: [ result add: cookie ].\r\n\t].\r\n\t^result","(\r\nfunction(self,aStream)\r\nlocal result=nil\r\nlocal cookie=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):skipSeparators();\r\n\treturn ((_s8_rec):atEnd())\r\nend\r\n)(aStream))\r\nend))() do (function()\r\n\tlocal _s8_value=((self):debugCookieFrom_(aStream))\r\n\tcookie=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:notNil_((cookie))),(function()\r\nreturn ((result):add_(cookie))\r\nend),nil); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"debugInfo:",0
,(
function(self,aMethod)
return ((aMethod):basicAt_ifAbsentPut_("$debugInfo",(function()
return ((self):debugInfo_forClass_((aMethod):source(),(aMethod):classField()))
end)));
end
)
,"debug","debugInfo: aMethod\r\n\t\" Return the debug information of aMethod. \"\r\n\r\n\t^aMethod basicAt: '$debugInfo' ifAbsentPut: [\r\n\t\tself debugInfo: aMethod source forClass: aMethod classField\r\n\t]","(\r\nfunction(self,aMethod)\r\nreturn ((aMethod):basicAt_ifAbsentPut_(\"$debugInfo\",(function()\r\nreturn ((self):debugInfo_forClass_((aMethod):source(),(aMethod):classField()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"debugInfo:forClass:",0
,(
function(self,aString,aClass)
local compiler=nil
local output=nil
local cookies=nil
local aNode=nil
local delta=nil
(function()
	local _s8_value=((""):writeStream())
	output=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:newArray({}))
	cookies=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(0)
	delta=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):new())
	compiler=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):useTemplates_(false);
	(_s8_rec):when_do_("needsCookie:",(function(one)
return ((cookies):add_((smalltalk.Array):with_with_(one,((compiler):encoder()):position())))
end));
	(_s8_rec):when_do_("endVisit:",(function(cookie)
return ((cookie):add_(((compiler):encoder()):position()))
end));
	return ((_s8_rec):when_do_("move:by:",(function(one,distance)
return ((function()
	local _s8_value=((delta):_plus(distance))
	delta=_s8_value
	return _s8_value
end)())
end)))
end
)(compiler);
(
function(_s8_rec)
	(_s8_rec):nextChunkPut_((aClass):name());
	(_s8_rec):nextChunkPut_(aString);
	(_s8_rec):nextChunkPut_((compiler):compile_forClass_(aString,aClass));
	return ((_s8_rec):yourself())
end
)(output);
(cookies):do_((function(tuple)
(function()
	local _s8_value=((tuple):first())
	aNode=_s8_value
	return _s8_value
end)();(
function(_s8_rec)
	(_s8_rec):nextChunkPut_(((aNode)["$klass"]):name());
	(_s8_rec):nextChunkPut_(smalltalk:asString_(((aNode):start())));
	(_s8_rec):nextChunkPut_(smalltalk:asString_(((aNode):__end())));
	(_s8_rec):nextChunkPut_(smalltalk:asString_((((tuple):second()):_plus(delta))));
	(_s8_rec):nextChunkPut_(smalltalk:asString_((((tuple):third()):_plus(delta))));
	return ((_s8_rec):yourself())
end
)(output);((aNode):bindings()):do_((function(each)
return ((output):nextPutAll_(smalltalk:object_comma_((" "),each)))
end));return ((output):nextChunkPut_(" "))
end));
return ((output):contents());
end
)
,"debug","debugInfo: aString forClass: aClass\r\n\t\" Private - Return aString with information of compiling aString as a method implemented in aClass. \"\r\n\r\n\t| compiler output cookies aNode delta |\r\n\toutput := '' writeStream.\r\n\tcookies := #(). delta := 0.\r\n\tcompiler := self new.\r\n\tcompiler\r\n\t\tuseTemplates: false;\r\n\t\twhen: #needsCookie: do: [:one| cookies add: (Array with: one with: compiler encoder position) ];\r\n\t\twhen: #endVisit: do: [:cookie| cookie add: compiler encoder position ];\r\n\t\twhen: #move:by: do: [:one :distance| delta := delta + distance ].\r\n\toutput\r\n\t\tnextChunkPut: aClass name;\r\n\t\tnextChunkPut: aString;\r\n\t\tnextChunkPut: (compiler compile: aString forClass: aClass);\r\n\t\tyourself.\r\n\tcookies do: [:tuple|\r\n\t\taNode := tuple first.\r\n\t\toutput\r\n\t\t\tnextChunkPut: aNode class name;\r\n\t\t\tnextChunkPut: aNode start asString;\r\n\t\t\tnextChunkPut: aNode end asString;\r\n\t\t\tnextChunkPut: (tuple second + delta) asString;\r\n\t\t\tnextChunkPut: (tuple third + delta) asString;\r\n\t\t\tyourself.\r\n\t\taNode bindings do: [:each| output nextPutAll: ' ' ,each ].\r\n\t\toutput nextChunkPut: ' '.\r\n\t].\r\n\t^output contents","(\r\nfunction(self,aString,aClass)\r\nlocal compiler=nil\r\nlocal output=nil\r\nlocal cookies=nil\r\nlocal aNode=nil\r\nlocal delta=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\toutput=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tcookies=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tdelta=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):new())\r\n\tcompiler=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):useTemplates_(false);\r\n\t(_s8_rec):when_do_(\"needsCookie:\",(function(one)\r\nreturn ((cookies):add_((smalltalk.Array):with_with_(one,((compiler):encoder()):position())))\r\nend));\r\n\t(_s8_rec):when_do_(\"endVisit:\",(function(cookie)\r\nreturn ((cookie):add_(((compiler):encoder()):position()))\r\nend));\r\n\treturn ((_s8_rec):when_do_(\"move:by:\",(function(one,distance)\r\nreturn ((function()\r\n\tlocal _s8_value=((delta):_plus(distance))\r\n\tdelta=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)))\r\nend\r\n)(compiler);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextChunkPut_((aClass):name());\r\n\t(_s8_rec):nextChunkPut_(aString);\r\n\t(_s8_rec):nextChunkPut_((compiler):compile_forClass_(aString,aClass));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(output);\r\n(cookies):do_((function(tuple)\r\n(function()\r\n\tlocal _s8_value=((tuple):first())\r\n\taNode=_s8_value\r\n\treturn _s8_value\r\nend)();(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextChunkPut_(((aNode)[\"$klass\"]):name());\r\n\t(_s8_rec):nextChunkPut_(smalltalk:asString_(((aNode):start())));\r\n\t(_s8_rec):nextChunkPut_(smalltalk:asString_(((aNode):__end())));\r\n\t(_s8_rec):nextChunkPut_(smalltalk:asString_((((tuple):second()):_plus(delta))));\r\n\t(_s8_rec):nextChunkPut_(smalltalk:asString_((((tuple):third()):_plus(delta))));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(output);((aNode):bindings()):do_((function(each)\r\nreturn ((output):nextPutAll_(smalltalk:object_comma_((\" \"),each)))\r\nend));return ((output):nextChunkPut_(\" \"))\r\nend));\r\nreturn ((output):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"debugInfoFrom:",0
,(
function(self,aString)
return ((self):debugInfoFromStream_((aString):stream()));
end
)
,"debug","debugInfoFrom: aString\r\n\t\" Private - Return the debug information decoding aString contents.\r\n\tNote: aString must be result of sending #getInfo: to the receiver.\r\n\t\"\r\n\r\n\t^self debugInfoFromStream: aString stream","(\r\nfunction(self,aString)\r\nreturn ((self):debugInfoFromStream_((aString):stream()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"debugInfoFromStream:",0
,(
function(self,aStream)
return ((smalltalk.Array):with_with_with_with_((aStream):nextChunk(),(aStream):nextChunk(),(aStream):nextChunk(),(self):debugCookiesFrom_(aStream)));
end
)
,"private","debugInfoFromStream: aStream\r\n\t\" Private - Return the debug information encoded in aStream. \"\r\n\r\n\t^Array\t\"ref. #debugInfo:forClass: \"\r\n\t\twith: aStream nextChunk\r\n\t\twith: aStream nextChunk\r\n\t\twith: aStream nextChunk\r\n\t\twith: (self debugCookiesFrom: aStream)","(\r\nfunction(self,aStream)\r\nreturn ((smalltalk.Array):with_with_with_with_((aStream):nextChunk(),(aStream):nextChunk(),(aStream):nextChunk(),(self):debugCookiesFrom_(aStream)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"doIt:",0
,(
function(self,smalltalkExpression)
return ((self):doIt_to_(smalltalkExpression,nil));
end
)
,"evaluation","doIt: smalltalkExpression\r\n\t\" Return the result of evaluating the smalltalk expression in the global context or a description of an error situation occurred evaluating the code. \"\r\n\r\n\t^self doIt: smalltalkExpression to: nil","(\r\nfunction(self,smalltalkExpression)\r\nreturn ((self):doIt_to_(smalltalkExpression,nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"doItOBSOLETE:to:",0
,(
function(self,smalltalkExpression,aReceiver)
local result=nil
((function()
return ((function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aReceiver))),(function()
return ((self):evaluate_(smalltalkExpression))
end),(function()
return ((self):evaluate_to_(smalltalkExpression,aReceiver))
end)))
	result=_s8_value
	return _s8_value
end)())
end)):on_do_(smalltalk.Exception,(function(error)
(function()
	local _s8_value=(error)
	result=_s8_value
	return _s8_value
end)();if (smalltalk:boolean_and_(((self):isObject_(error)),(function()
return (smalltalk:booleanNot_(((error):isString())))
end)))==true then (function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((((error)["$klass"]):name()),": ")),(error):messageText()))
	result=_s8_value
	return _s8_value
end)(); end;return ((self):note_(result))
end));
return (result);
end
)
,"evaluation","doItOBSOLETE: smalltalkExpression to: aReceiver\r\n\t\" Return the result of evaluating the smalltalk expression in the context of aReceiver or a description of an error situation occurred evaluating the code. \"\r\n\r\n\t| result |\r\n\t[ result := aReceiver isNil\r\n\t\t\tifTrue:  [ self evaluate: smalltalkExpression ]\r\n\t\t\tifFalse: [ self evaluate: smalltalkExpression to: aReceiver ]\r\n\t] on: Exception do: [:error|\r\n\t\tresult := error.\r\n\t\t((self isObject: error) and: [ error isString not ])\r\n\t\tifTrue: [ result := error class name ,': ' ,error messageText ].\r\n\t\tself note: result\r\n\t].\r\n\t^result","(\r\nfunction(self,smalltalkExpression,aReceiver)\r\nlocal result=nil\r\n((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aReceiver))),(function()\r\nreturn ((self):evaluate_(smalltalkExpression))\r\nend),(function()\r\nreturn ((self):evaluate_to_(smalltalkExpression,aReceiver))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):on_do_(smalltalk.Exception,(function(error)\r\n(function()\r\n\tlocal _s8_value=(error)\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:boolean_and_(((self):isObject_(error)),(function()\r\nreturn (smalltalk:booleanNot_(((error):isString())))\r\nend)))==true then (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((((error)[\"$klass\"]):name()),\": \")),(error):messageText()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)(); end;return ((self):note_(result))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"doIt:to:",0
,(
function(self,smalltalkExpression,aReceiver)
local result=nil
((function()
return ((function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aReceiver))),(function()
return ((self):evaluate_(smalltalkExpression))
end),(function()
return ((self):evaluate_to_(smalltalkExpression,aReceiver))
end)))
	result=_s8_value
	return _s8_value
end)())
end)):on_do_(smalltalk.Exception,(function(error)
(function()
	local _s8_value=(error)
	result=_s8_value
	return _s8_value
end)();if (smalltalk:boolean_and_(((self):isObject_(error)),(function()
return (smalltalk:responds_to_((error),("description")))
end)))==true then (function()
	local _s8_value=((error):description())
	result=_s8_value
	return _s8_value
end)(); end;return ((self):note_(result))
end));
return (result);
end
)
,"evaluation","doIt: smalltalkExpression to: aReceiver\r\n\t\" Return the result of evaluating the smalltalk expression in the context of aReceiver or a description of an error situation occurred evaluating the code. \"\r\n\r\n\t| result |\r\n\t[ result := aReceiver isNil\r\n\t\t\tifTrue:  [ self evaluate: smalltalkExpression ]\r\n\t\t\tifFalse: [ self evaluate: smalltalkExpression to: aReceiver ]\r\n\t] on: Exception do: [:error|\r\n\t\tresult := error.\r\n\t\t((self isObject: error) and: [ error respondsTo: #description ])\r\n\t\tifTrue: [ result := error description ].\r\n\t\tself note: result\r\n\t].\r\n\t^result","(\r\nfunction(self,smalltalkExpression,aReceiver)\r\nlocal result=nil\r\n((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aReceiver))),(function()\r\nreturn ((self):evaluate_(smalltalkExpression))\r\nend),(function()\r\nreturn ((self):evaluate_to_(smalltalkExpression,aReceiver))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):on_do_(smalltalk.Exception,(function(error)\r\n(function()\r\n\tlocal _s8_value=(error)\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:boolean_and_(((self):isObject_(error)),(function()\r\nreturn (smalltalk:responds_to_((error),(\"description\")))\r\nend)))==true then (function()\r\n\tlocal _s8_value=((error):description())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)(); end;return ((self):note_(result))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"evaluate:",0
,(
function(self,smalltalkExpression)
return (((self):new()):evaluate_(smalltalkExpression));
end
)
,"evaluation","evaluate: smalltalkExpression\r\n\t\" Return the result of evaluating the smalltalk expression in a global context. \"\r\n\r\n\t^self new evaluate: smalltalkExpression","(\r\nfunction(self,smalltalkExpression)\r\nreturn (((self):new()):evaluate_(smalltalkExpression));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"evaluate:in:to:",0
,(
function(self,expression,aClass,aReceiver)
return (((aClass):compiler()):evaluate_in_to_(expression,aClass,aReceiver));
end
)
,"evaluation","evaluate: expression in: aClass to: aReceiver\r\n\t\" Return the result of evaluating the expression with aReceiver. \"\r\n\r\n\t^aClass compiler evaluate: expression in: aClass to: aReceiver","(\r\nfunction(self,expression,aClass,aReceiver)\r\nreturn (((aClass):compiler()):evaluate_in_to_(expression,aClass,aReceiver));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"targetFor:",0
,(
function(self,aReceiver)
return (smalltalk:if_true_false_(((self):isObject_(aReceiver)),(function()
return (aReceiver)
end),(function()
return (((smalltalk.NativeHandle):support()):_at(aReceiver))
end)));
end
)
,"evaluation","targetFor: aReceiver\r\n\t\" Return the object to use for compiling expressions to be evaluated in aReceiver. \"\r\n\r\n\t^(self isObject: aReceiver)\r\n\t\tifTrue: [ aReceiver ]\r\n\t\tifFalse: [ NativeHandle support @ aReceiver ] ","(\r\nfunction(self,aReceiver)\r\nreturn (smalltalk:if_true_false_(((self):isObject_(aReceiver)),(function()\r\nreturn (aReceiver)\r\nend),(function()\r\nreturn (((smalltalk.NativeHandle):support()):_at(aReceiver))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"evaluate:to:",0
,(
function(self,expression,aReceiver)
local target=nil
(function()
	local _s8_value=((self):targetFor_(aReceiver))
	target=_s8_value
	return _s8_value
end)();
return ((self):evaluate_in_to_(expression,(target)["$klass"],target));
end
)
,"evaluation","evaluate: expression to: aReceiver\r\n\t\" Return the result of evaluating the expression with aReceiver. \"\r\n\r\n\t| target |\r\n\ttarget := self targetFor: aReceiver.\r\n\t^self evaluate: expression in: target class to: target","(\r\nfunction(self,expression,aReceiver)\r\nlocal target=nil\r\n(function()\r\n\tlocal _s8_value=((self):targetFor_(aReceiver))\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):evaluate_in_to_(expression,(target)[\"$klass\"],target));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"for:",0
,(
function(self,aBehavior)
return ((
function(_s8_rec)
	(_s8_rec):currentClass_(aBehavior);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","for: aBehavior\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tcurrentClass: aBehavior;\r\n\t\tyourself","(\r\nfunction(self,aBehavior)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):currentClass_(aBehavior);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler["$klass"],"getInfo:",0
,(
function(self,aString)
local stream=nil
local aClass=nil
local selector=nil
local source=nil
local aMethod=nil
(function()
	local _s8_value=((aString):stream())
	stream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((stream):nextChunk()):doIt())
	aClass=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((stream):nextChunk())
	selector=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((stream):nextChunk())
	source=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aClass):_gt_gt(selector))
	aMethod=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_and_((smalltalk:notNil_((aMethod))),(function()
return (smalltalk:boolean_or_((((source):trimBlanks()):isEmpty()),(function()
return (smalltalk:isObject_equalTo_(((aMethod):source()),source))
end)))
end)))==true then return ((self):debugInfo_(aMethod)); end;
return ((self):debugInfo_forClass_(source,aClass));
end
)
,"debug","getInfo: aString\r\n\t\" Private - Return the information of compiling aString as a chunked spec. \"\r\n\r\n\t| stream aClass selector source aMethod |\r\n\tstream := aString stream.\r\n\taClass := stream nextChunk doIt.\r\n\tselector := stream nextChunk.\r\n\tsource := stream nextChunk.\r\n\taMethod := aClass >> selector.\r\n\t(aMethod notNil and: [ source trimBlanks isEmpty or: [\r\n\t\taMethod source = source ]]) ifTrue: [\r\n\t\t^self debugInfo: aMethod\r\n\t].\r\n\t^self debugInfo: source forClass: aClass","(\r\nfunction(self,aString)\r\nlocal stream=nil\r\nlocal aClass=nil\r\nlocal selector=nil\r\nlocal source=nil\r\nlocal aMethod=nil\r\n(function()\r\n\tlocal _s8_value=((aString):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((stream):nextChunk()):doIt())\r\n\taClass=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((stream):nextChunk())\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((stream):nextChunk())\r\n\tsource=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aClass):_gt_gt(selector))\r\n\taMethod=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((aMethod))),(function()\r\nreturn (smalltalk:boolean_or_((((source):trimBlanks()):isEmpty()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((aMethod):source()),source))\r\nend)))\r\nend)))==true then return ((self):debugInfo_(aMethod)); end;\r\nreturn ((self):debugInfo_forClass_(source,aClass));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"parseMethod:",0
,(
function(self,aString)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
(self):triggerEvent_with_ifNotHandled_("aboutToParse:",aString,(function()
(function()
	local _s8_value=((self):nodeFromTemplateIn_(aString))
	result=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((result))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
	local _s8_value=(((self):parser()):parse_((aString):readStream()))
	result=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"parsing","parseMethod: aString\r\n\t\" Return the result of parsing aString as a method source code. \"\r\n\r\n\t| result |\r\n\tself\ttriggerEvent: #aboutToParse:\r\n\t\twith: aString ifNotHandled: [\r\n\t\t\tresult := self nodeFromTemplateIn: aString.\r\n\t\t\tresult notNil ifTrue: [ ^result ]\r\n\t\t].\r\n\tresult := self parser parse: aString readStream.\r\n\t^result","(\r\nfunction(self,aString)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\n(self):triggerEvent_with_ifNotHandled_(\"aboutToParse:\",aString,(function()\r\n(function()\r\n\tlocal _s8_value=((self):nodeFromTemplateIn_(aString))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((result))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n\tlocal _s8_value=(((self):parser()):parse_((aString):readStream()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"parse:",0
,(
function(self,aString)
(self):error_(smalltalk:object_comma_(("OBSOLETE message #parse: "),smalltalk:printString_((aString))));
return ((self):parseMethod_(aString));
end
)
,"parsing","parse: aString\r\n\t\" OBSOLETE - Return the result of parsing aString. \"\r\n\r\n\tself error: 'OBSOLETE message #parse: ' ,aString printString.\r\n\t^self parseMethod: aString ","(\r\nfunction(self,aString)\r\n(self):error_(smalltalk:object_comma_((\"OBSOLETE message #parse: \"),smalltalk:printString_((aString))));\r\nreturn ((self):parseMethod_(aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"compile:",0
,(
function(self,methodSource)
local aNode=nil
(function()
	local _s8_value=((self):parseMethod_(methodSource))
	aNode=_s8_value
	return _s8_value
end)();
(self):triggerEvent_with_("aboutToCompile:",aNode);
return ((self):emmitNode_(aNode));
end
)
,"private","compile: methodSource\r\n\t\" Return the native code result of compiling methodSource for currentClass. \"\r\n\r\n\t| aNode |\r\n\taNode := self parseMethod: methodSource.\r\n\tself triggerEvent: #aboutToCompile: with: aNode.\r\n\t^self emmitNode: aNode","(\r\nfunction(self,methodSource)\r\nlocal aNode=nil\r\n(function()\r\n\tlocal _s8_value=((self):parseMethod_(methodSource))\r\n\taNode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):triggerEvent_with_(\"aboutToCompile:\",aNode);\r\nreturn ((self):emmitNode_(aNode));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"compile:forClass:",0
,(
function(self,methodSource,aClass)
(self):currentClass_(aClass);
return ((self):compile_(methodSource));
end
)
,"compiling","compile: methodSource forClass: aClass\r\n\t\" Return the native code result of compiling methodSource as a method implemented by aClass. \"\r\n\r\n\tself currentClass: aClass.\r\n\t^self compile: methodSource ","(\r\nfunction(self,methodSource,aClass)\r\n(self):currentClass_(aClass);\r\nreturn ((self):compile_(methodSource));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"compile:forClass:category:",0
,(
function(self,methodSource,aClass,category)
local method=nil
if (smalltalk:boolean_or_((smalltalk:isNil_((methodSource))),(function()
return ((methodSource):isEmpty())
end)))==true then return (nil); end;
(function()
	local _s8_value=((self):load_forClass_(methodSource,aClass))
	method=_s8_value
	return _s8_value
end)();
(method):category_(category);
(aClass):addCompiledMethod_(method);
return (method);
end
)
,"compiling","compile: methodSource forClass: aClass category: category\r\n\t\" Return the compiled method result of installing a new method compiled from methodSource in aClass. \"\r\n\r\n\t| method |\r\n\t(methodSource isNil or: [ methodSource isEmpty ]) ifTrue: [ ^nil ].\r\n\tmethod := self load: methodSource forClass: aClass.\r\n\tmethod category: category.\r\n\taClass addCompiledMethod: method.\r\n\t^method","(\r\nfunction(self,methodSource,aClass,category)\r\nlocal method=nil\r\nif (smalltalk:boolean_or_((smalltalk:isNil_((methodSource))),(function()\r\nreturn ((methodSource):isEmpty())\r\nend)))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((self):load_forClass_(methodSource,aClass))\r\n\tmethod=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(method):category_(category);\r\n(aClass):addCompiledMethod_(method);\r\nreturn (method);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"selector",0
,(
function(self)
return (self["@selector"]);
end
)
,"accessing","selector\r\n\t\" Return the selector of the receiver (or nil). \"\r\n\r\n\t^selector ","(\r\nfunction(self)\r\nreturn (self[\"@selector\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"currentClass",0
,(
function(self)
return (self["@currentClass"]);
end
)
,"accessing","currentClass\r\n\t\" Return the current class of the receiver. \"\r\n\r\n\t^currentClass","(\r\nfunction(self)\r\nreturn (self[\"@currentClass\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"currentClass:",0
,(
function(self,aClass)
(function()
	local _s8_value=(aClass)
	self["@currentClass"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","currentClass: aClass\r\n\t\" Set the current class of the receiver. \"\r\n\r\n\tcurrentClass := aClass","(\r\nfunction(self,aClass)\r\n(function()\r\n\tlocal _s8_value=(aClass)\r\n\tself[\"@currentClass\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"emmitNode:",0
,(
function(self,aNode)
(self):startCompiling_(aNode);
(self):prepare_(aNode);
(self):triggerEvent_with_("aboutToEncode:",aNode);
((self):encoder()):visit_(aNode);
(self):endCompiling_(aNode);
return (((self):encoder()):emmitedCode());
end
)
,"private","emmitNode: aNode\r\n\t\" Private - Return the native code for aNode. \"\r\n\r\n\tself startCompiling: aNode.\r\n\tself prepare: aNode.\r\n\tself triggerEvent: #aboutToEncode: with: aNode.\r\n\tself encoder visit: aNode.\r\n\tself endCompiling: aNode.\r\n\t^self encoder emmitedCode","(\r\nfunction(self,aNode)\r\n(self):startCompiling_(aNode);\r\n(self):prepare_(aNode);\r\n(self):triggerEvent_with_(\"aboutToEncode:\",aNode);\r\n((self):encoder()):visit_(aNode);\r\n(self):endCompiling_(aNode);\r\nreturn (((self):encoder()):emmitedCode());\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"encoder",0
,(
function(self)
if (smalltalk:isNil_((self["@encoder"])))==true then (self):initializeEncoder(); end;
return (self["@encoder"]);
end
)
,"accessing","encoder\r\n\t\" Return the encoder of the receiver. \"\r\n\r\n\tencoder isNil ifTrue: [ self initializeEncoder ].\r\n\t^encoder","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@encoder\"])))==true then (self):initializeEncoder(); end;\r\nreturn (self[\"@encoder\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"encoder:",0
,(
function(self,anEncoder)
(function()
	local _s8_value=(anEncoder)
	self["@encoder"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","encoder: anEncoder\r\n\t\" Set the encoder of the receiver. \"\r\n\r\n\tencoder := anEncoder","(\r\nfunction(self,anEncoder)\r\n(function()\r\n\tlocal _s8_value=(anEncoder)\r\n\tself[\"@encoder\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"endCompiling:",0
,(
function(self,aMethodNode)
((self):encoder()):endCompiling_(aMethodNode);
(self):triggerEvent_with_("endCompiling:",aMethodNode);
return (self);
end
)
,"private","endCompiling: aMethodNode\r\n\t\" Private - Finish emmiting code for aMethodNode. \"\r\n\r\n\tself encoder endCompiling: aMethodNode.\r\n\tself triggerEvent: #endCompiling: with: aMethodNode.","(\r\nfunction(self,aMethodNode)\r\n((self):encoder()):endCompiling_(aMethodNode);\r\n(self):triggerEvent_with_(\"endCompiling:\",aMethodNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"eval:",0
,(
function(self,nativeExpression)
return (((smalltalk.Smalltalk):current()):eval_(nativeExpression));
end
)
,"evaluation","eval: nativeExpression\r\n\t\" Return the result of evaluating a native expression in global context. \"\r\n\r\n\t^Smalltalk current eval: nativeExpression","(\r\nfunction(self,nativeExpression)\r\nreturn (((smalltalk.Smalltalk):current()):eval_(nativeExpression));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"eval:as:",0
,(
function(self,nativeExpression,aState)
return (((smalltalk.Smalltalk):current()):eval_as_(nativeExpression,aState));
end
)
,"evaluation","eval: nativeExpression as: aState\r\n\t\" Return the result of evaluating a native expression in global context.\r\n\tThe state of the system change to state while evaluating the expression.\r\n\t\"\r\n\r\n\t^Smalltalk current eval: nativeExpression as: aState","(\r\nfunction(self,nativeExpression,aState)\r\nreturn (((smalltalk.Smalltalk):current()):eval_as_(nativeExpression,aState));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"evaluate:",0
,(
function(self,smalltalkExpression)
return ((self):evaluate_in_to_(smalltalkExpression,(nil)["$klass"],nil));
end
)
,"doIt","evaluate: smalltalkExpression\r\n\t\" Return the result of evaluating the smalltalk expression in global context. \"\r\n\r\n\t^self evaluate: smalltalkExpression in: nil class to: nil","(\r\nfunction(self,smalltalkExpression)\r\nreturn ((self):evaluate_in_to_(smalltalkExpression,(nil)[\"$klass\"],nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"compiledMethodToEvaluate:in:",0
,(
function(self,smalltalkExpression,aClass)
local result=nil
local doIt=nil
local node=nil
local code=nil
(function()
	local _s8_value=((smalltalk.String):doItSelector())
	doIt=_s8_value
	return _s8_value
end)();
(self):currentClass_(aClass);
(function()
	local _s8_value=((self):parseMethod_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((doIt)," ^[")),smalltalkExpression)),"] value")))
	node=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):emmitNode_(node))
	code=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):eval_(code))
	result=_s8_value
	return _s8_value
end)();
(result):category_(doIt);
(aClass):addCompiledMethod_(result);
return (result);
end
)
,"evaluation","compiledMethodToEvaluate: smalltalkExpression in: aClass\r\n\t\" Return a compiled method to evaluate the smalltalk expression in aClass. \"\r\n\r\n\t| result doIt node code |\r\n\tdoIt := String doItSelector.\r\n\tself currentClass: aClass.\r\n\tnode := self parseMethod: doIt,' ^[', smalltalkExpression, '] value'.\r\n\tcode := self emmitNode: node.\r\n\tresult := self eval: code.\r\n\tresult category: doIt.\r\n\taClass addCompiledMethod: result.\r\n\t^result","(\r\nfunction(self,smalltalkExpression,aClass)\r\nlocal result=nil\r\nlocal doIt=nil\r\nlocal node=nil\r\nlocal code=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.String):doItSelector())\r\n\tdoIt=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):currentClass_(aClass);\r\n(function()\r\n\tlocal _s8_value=((self):parseMethod_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((doIt),\" ^[\")),smalltalkExpression)),\"] value\")))\r\n\tnode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):emmitNode_(node))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):eval_(code))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(result):category_(doIt);\r\n(aClass):addCompiledMethod_(result);\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"evaluate:in:to:",0
,(
function(self,smalltalkExpression,aClass,aReceiver)
local result=nil
local cm=nil
(function()
	local _s8_value=((self):compiledMethodToEvaluate_in_(smalltalkExpression,aClass))
	cm=_s8_value
	return _s8_value
end)();
((function()
return ((function()
	local _s8_value=((aReceiver):perform_((cm):selector()))
	result=_s8_value
	return _s8_value
end)())
end)):ensure_((function()
return ((cm):removeFromSystem())
end));
return (result);
end
)
,"evaluation","evaluate: smalltalkExpression in: aClass to: aReceiver\r\n\t\" Return the result of evaluating the smalltalk expression with aReceiver. \"\r\n\r\n\t| result cm |\r\n\tcm := self compiledMethodToEvaluate: smalltalkExpression in: aClass.\r\n\t[ result := aReceiver perform: cm selector.\r\n\t] ensure: [ cm removeFromSystem ].\r\n\t^result","(\r\nfunction(self,smalltalkExpression,aClass,aReceiver)\r\nlocal result=nil\r\nlocal cm=nil\r\n(function()\r\n\tlocal _s8_value=((self):compiledMethodToEvaluate_in_(smalltalkExpression,aClass))\r\n\tcm=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((function()\r\nreturn ((function()\r\n\tlocal _s8_value=((aReceiver):perform_((cm):selector()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):ensure_((function()\r\nreturn ((cm):removeFromSystem())\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"initialize",0
,(
function(self)
smalltalk:superImplementor(smalltalk.Compiler,"initialize")(self);
(self):resetVariables();
return (self);
end
)
,"initialize","initialize\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsuper initialize.\r\n\tself resetVariables.","(\r\nfunction(self)\r\nsmalltalk:superImplementor(smalltalk.Compiler,\"initialize\")(self);\r\n(self):resetVariables();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"initializeEncoder",0
,(
function(self)
(function()
	local _s8_value=((self):triggerEvent_ifNotHandled_("needsEncoder",(function()
return ((smalltalk.S8Encoder):for_(self))
end)))
	self["@encoder"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"private","initializeEncoder\r\n\t\" Private - Initialize the encoder of the receiver. \"\r\n\r\n\tencoder := self\r\n\t\ttriggerEvent: #needsEncoder\r\n\t\tifNotHandled: [ S8Encoder for: self ]","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=((self):triggerEvent_ifNotHandled_(\"needsEncoder\",(function()\r\nreturn ((smalltalk.S8Encoder):for_(self))\r\nend)))\r\n\tself[\"@encoder\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"knownVariables",0
,(
function(self)
return (smalltalk:object_comma_(((self):pseudoVariables()),(self):tempVariables()));
end
)
,"variables","knownVariables\r\n\t\" Return the knownVariables of the receiver. \"\r\n\r\n\t^self pseudoVariables , self tempVariables","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_(((self):pseudoVariables()),(self):tempVariables()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"load:forClass:",0
,(
function(self,aString,aClass)
local nativeCode=nil
(function()
	local _s8_value=((self):compile_forClass_(aString,aClass))
	nativeCode=_s8_value
	return _s8_value
end)();
return ((self):eval_(nativeCode));
end
)
,"compiling","load: aString forClass: aClass\r\n\t\" Return the CompiledMethod result of compiling aString as a method implemented in aClass. \"\r\n\r\n\t| nativeCode |\r\n\tnativeCode := self compile: aString forClass: aClass.\r\n\t^self eval: nativeCode","(\r\nfunction(self,aString,aClass)\r\nlocal nativeCode=nil\r\n(function()\r\n\tlocal _s8_value=((self):compile_forClass_(aString,aClass))\r\n\tnativeCode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):eval_(nativeCode));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"localName:",0
,(
function(self,aName)
return (((self):encoder()):localName_(aName));
end
)
,"private","localName: aName\r\n\t\" Private - Return a valid (native, local) name for aName. \"\r\n\r\n\t^self encoder localName: aName","(\r\nfunction(self,aName)\r\nreturn (((self):encoder()):localName_(aName));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"alienName:",0
,(
function(self,aName)
return (((self):encoder()):alienName_(aName));
end
)
,"private","alienName: aName\r\n\t\" Private - Return a valid native name for aName. \"\r\n\r\n\t^self encoder alienName: aName","(\r\nfunction(self,aName)\r\nreturn (((self):encoder()):alienName_(aName));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"nativeLanguage",0
,(
function(self)
return (((self):encoder()):nativeLanguage());
end
)
,"accessing","nativeLanguage\r\n\r\n\t^self encoder nativeLanguage","(\r\nfunction(self)\r\nreturn (((self):encoder()):nativeLanguage());\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"nodeFromTemplateIn:",0
,(
function(self,aString)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local src=nil
local driver=nil
local msg=nil
local count=nil
local found=nil
if (smalltalk:boolean_or_(((aString):isEmpty()),(function()
return (smalltalk:booleanNot_((smalltalk:isObject_equalTo_(((aString):last()),"\""))))
end)))==true then return (nil); end;
(function()
	local _s8_value=((((aString):upToLast_("\"")):fromLast_("\"")):stream())
	src=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((src):peek()),"#"))==true then (src):next(); else smalltalk:if_true_false_((smalltalk:isObject_equalTo_(("template"),((src):nextLine()):upTo_(" "))),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end)); end;
(function()
	local _s8_value=((src):upTo_(" "))
	driver=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((driver),"self"))==true then (function()
	local _s8_value=(self)
	driver=_s8_value
	return _s8_value
end)(); end;
if (smalltalk:isObject_equalTo_((driver),"class"))==true then (function()
	local _s8_value=((self):currentClass())
	driver=_s8_value
	return _s8_value
end)(); end;
if (smalltalk:isObject_equalTo_((driver),"encoder"))==true then (function()
	local _s8_value=((self):encoder())
	driver=_s8_value
	return _s8_value
end)(); end;
if (smalltalk:isObject_equalTo_((driver),"api"))==true then (function()
	local _s8_value=("APIBuilder")
	driver=_s8_value
	return _s8_value
end)(); end;
if ((driver):isString())==true then (function()
	local _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(driver,(function()
return (nil)
end)))
	driver=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=((src):upTo_(" "))
	msg=_s8_value
	return _s8_value
end)();
if not ((smalltalk:responds_to_((driver),(msg))))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
	local _s8_value=((msg):occurrencesOf_(":"))
	count=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((function(mth)
return (smalltalk:if_true_false_((smalltalk:notNil_((mth))),(function()
return ((
function(_s8_rec)
	(_s8_rec):source_(aString);
	return ((_s8_rec):yourself())
end
)(mth))
end),nil))
end))
	found=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((count),0))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((found):value_((driver):perform_(msg)))
end
)()
error(_s8Ret_,0)
end)(); end;
if (smalltalk:isObject_equalTo_((count),1))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((found):value_((driver):perform_with_(msg,(src):upToEnd())))
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"templates","nodeFromTemplateIn: aString\r\n\t\" Return the nodes syntetized from inlined templates in aString (or nil).\r\n\tInlined templates are detected from last comment in source.\r\n\t\"\r\n\r\n\t| src driver msg count found |\r\n\t(aString isEmpty or: [(aString last = $\") not]) ifTrue: [ ^nil ].\r\n\tsrc := ((aString upToLast: $\") fromLast: $\") stream.\r\n\tsrc peek = $# ifTrue: [ src next ] ifFalse: [\r\n\t\t#template = (src nextLine upTo: $ ) ifFalse: [ ^nil ]\r\n\t].\r\n\tdriver := src upTo: $ .\r\n\tdriver = #self  ifTrue: [ driver := self ].\r\n\tdriver = #class ifTrue: [ driver := self currentClass ].\r\n\tdriver = #encoder ifTrue: [ driver := self encoder ].\r\n\tdriver = #api   ifTrue: [ driver := #APIBuilder ].\r\n\tdriver isString ifTrue: [ driver := Smalltalk at: driver ifAbsent: [] ].\r\n\tmsg := src upTo: $ .\r\n\t(driver respondsTo: msg) ifFalse: [ ^nil ].\r\n\tcount := msg occurrencesOf: $:.\r\n\tfound := [:mth| mth notNil ifTrue: [ mth source: aString; yourself ] ].\r\n\tcount = 0 ifTrue: [ ^found value: (driver perform: msg) ].\r\n\tcount = 1 ifTrue: [ ^found value: (driver perform: msg with: src upToEnd) ].\r\n\t^nil","(\r\nfunction(self,aString)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal src=nil\r\nlocal driver=nil\r\nlocal msg=nil\r\nlocal count=nil\r\nlocal found=nil\r\nif (smalltalk:boolean_or_(((aString):isEmpty()),(function()\r\nreturn (smalltalk:booleanNot_((smalltalk:isObject_equalTo_(((aString):last()),\"\\\"\"))))\r\nend)))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((((aString):upToLast_(\"\\\"\")):fromLast_(\"\\\"\")):stream())\r\n\tsrc=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((src):peek()),\"#\"))==true then (src):next(); else smalltalk:if_true_false_((smalltalk:isObject_equalTo_((\"template\"),((src):nextLine()):upTo_(\" \"))),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)); end;\r\n(function()\r\n\tlocal _s8_value=((src):upTo_(\" \"))\r\n\tdriver=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((driver),\"self\"))==true then (function()\r\n\tlocal _s8_value=(self)\r\n\tdriver=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif (smalltalk:isObject_equalTo_((driver),\"class\"))==true then (function()\r\n\tlocal _s8_value=((self):currentClass())\r\n\tdriver=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif (smalltalk:isObject_equalTo_((driver),\"encoder\"))==true then (function()\r\n\tlocal _s8_value=((self):encoder())\r\n\tdriver=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif (smalltalk:isObject_equalTo_((driver),\"api\"))==true then (function()\r\n\tlocal _s8_value=(\"APIBuilder\")\r\n\tdriver=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif ((driver):isString())==true then (function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(driver,(function()\r\nreturn (nil)\r\nend)))\r\n\tdriver=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((src):upTo_(\" \"))\r\n\tmsg=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:responds_to_((driver),(msg))))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((msg):occurrencesOf_(\":\"))\r\n\tcount=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((function(mth)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((mth))),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):source_(aString);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(mth))\r\nend),nil))\r\nend))\r\n\tfound=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((count),0))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((found):value_((driver):perform_(msg)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\nif (smalltalk:isObject_equalTo_((count),1))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((found):value_((driver):perform_with_(msg,(src):upToEnd())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"parser",0
,(
function(self)
return ((self):triggerEvent_ifNotHandled_("needsParser",(function()
return ((smalltalk.SmalltalkParser):new())
end)));
end
)
,"private","parser\r\n\t\" Private - Return the parser of the receiver. \"\r\n\r\n\t^self\ttriggerEvent: #needsParser\r\n\t\tifNotHandled: [ SmalltalkParser new ]","(\r\nfunction(self)\r\nreturn ((self):triggerEvent_ifNotHandled_(\"needsParser\",(function()\r\nreturn ((smalltalk.SmalltalkParser):new())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"prepare:",0
,(
function(self,aMethodNode)
((self):encoder()):prepare_(aMethodNode);
((self):transformers()):do_((function(each)
return ((each):visit_(aMethodNode))
end));
return (self);
end
)
,"prepare","prepare: aMethodNode\r\n\t\" Private - Apply tranformations/optimization to aMethodNode. \"\r\n\r\n\tself encoder prepare: aMethodNode.\r\n\tself transformers do: [:each| each visit: aMethodNode ].","(\r\nfunction(self,aMethodNode)\r\n((self):encoder()):prepare_(aMethodNode);\r\n((self):transformers()):do_((function(each)\r\nreturn ((each):visit_(aMethodNode))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"pseudoVariables",0
,(
function(self)
return (smalltalk:newArray({"self", "super", "true", "false", "nil", "thisContext"}));
end
)
,"variables","pseudoVariables\r\n\t\" Return the pseudoVariables of the receiver. \"\r\n\r\n\t^#( #self #super #true #false #nil #thisContext )","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"self\", \"super\", \"true\", \"false\", \"nil\", \"thisContext\"}));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"recompile:",0
,(
function(self,aClass)
(self):triggerEvent_with_("aboutToRecompile:",aClass);
((aClass):methodDictionary()):do_((function(each)
return ((self):compile_forClass_category_((each):source(),aClass,(each):category()))
end));
(self):triggerEvent_with_("recompiled:",aClass);
if not (((aClass):isMetaclass()))==true then (self):recompile_((aClass)["$klass"]); end;
return (self);
end
)
,"compiling","recompile: aClass\r\n\t\" Re-compile all the methods defined by aClass. \"\r\n\r\n\tself triggerEvent: #aboutToRecompile: with: aClass.\r\n\taClass methodDictionary do: [:each |\r\n\"Debug\t\tself note: each.\"\r\n\t\tself compile: each source forClass: aClass category: each category\r\n\t].\r\n\tself triggerEvent: #recompiled: with: aClass.\r\n\taClass isMetaclass ifFalse: [ self recompile: aClass class ].","(\r\nfunction(self,aClass)\r\n(self):triggerEvent_with_(\"aboutToRecompile:\",aClass);\r\n((aClass):methodDictionary()):do_((function(each)\r\nreturn ((self):compile_forClass_category_((each):source(),aClass,(each):category()))\r\nend));\r\n(self):triggerEvent_with_(\"recompiled:\",aClass);\r\nif not (((aClass):isMetaclass()))==true then (self):recompile_((aClass)[\"$klass\"]); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"resetVariables",0
,(
function(self)
(function()
	local _s8_value=(smalltalk:newArray({}))
	self["@unknownVariables"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:newArray({}))
	self["@tempVariables"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"variables","resetVariables\r\n\t\" Reset the variables of the receiver. \"\r\n\r\n\tunknownVariables := #().\r\n\ttempVariables := #().","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tself[\"@unknownVariables\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tself[\"@tempVariables\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"smalltalkNameFor:",0
,(
function(self,aClass)
return (((self):encoder()):smalltalkNameFor_(aClass));
end
)
,"names","smalltalkNameFor: aClass\r\n\t\" Return the global name of aClass (can be nil). \"\r\n\r\n\t^self encoder smalltalkNameFor: aClass","(\r\nfunction(self,aClass)\r\nreturn (((self):encoder()):smalltalkNameFor_(aClass));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"startCompiling:",0
,(
function(self,aNode)
if not (((aNode):isParseFailure()))==true then (function()
	local _s8_value=((aNode):selector())
	self["@selector"]=_s8_value
	return _s8_value
end)(); end;
(self):triggerEvent_with_("startCompiling:",aNode);
((self):encoder()):startCompiling_(aNode);
return (self);
end
)
,"private","startCompiling: aNode\r\n\t\" Private - Set the receiver to start emmiting code for aNode. \"\r\n\r\n\taNode isParseFailure ifFalse: [\r\n\t\tselector := aNode selector\r\n\t].\r\n\tself triggerEvent: #startCompiling: with: aNode.\r\n\tself encoder startCompiling: aNode.","(\r\nfunction(self,aNode)\r\nif not (((aNode):isParseFailure()))==true then (function()\r\n\tlocal _s8_value=((aNode):selector())\r\n\tself[\"@selector\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(self):triggerEvent_with_(\"startCompiling:\",aNode);\r\n((self):encoder()):startCompiling_(aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"tempVariables",0
,(
function(self)
return (self["@tempVariables"]);
end
)
,"variables","tempVariables\r\n\t\" Return the tempVariables of the receiver. \"\r\n\r\n\t^tempVariables","(\r\nfunction(self)\r\nreturn (self[\"@tempVariables\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"transformers",0
,(
function(self)
if (smalltalk:isNil_((self["@transformers"])))==true then (function()
	local _s8_value=((smalltalk.Array):new())
	self["@transformers"]=_s8_value
	return _s8_value
end)();
(self):triggerEvent_with_("setTransformers:",self["@transformers"]); end;
return (self["@transformers"]);
end
)
,"accessing","transformers\r\n\t\" Return the node transformers installed in the receiver. \"\r\n\r\n\ttransformers isNil ifTrue: [\r\n\t\ttransformers := Array new.\r\n\t\tself triggerEvent: #setTransformers: with: transformers.\r\n\t].\r\n\t^transformers","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@transformers\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@transformers\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):triggerEvent_with_(\"setTransformers:\",self[\"@transformers\"]); end;\r\nreturn (self[\"@transformers\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"unknownVariables",0
,(
function(self)
return (self["@unknownVariables"]);
end
)
,"variables","unknownVariables\r\n\t\" Return the unknownVariables of the receiver. \"\r\n\r\n\t^unknownVariables","(\r\nfunction(self)\r\nreturn (self[\"@unknownVariables\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"useTemplates",0
,(
function(self)
return (smalltalk:boolean_and_((smalltalk:notNil_((self["@useTemplates"]))),(function()
return (self["@useTemplates"])
end)));
end
)
,"accessing","useTemplates\r\n\t\" Return true if the receiver use templates. \"\r\n\r\n\t^useTemplates notNil and: [ useTemplates ]","(\r\nfunction(self)\r\nreturn (smalltalk:boolean_and_((smalltalk:notNil_((self[\"@useTemplates\"]))),(function()\r\nreturn (self[\"@useTemplates\"])\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Compiler,"useTemplates:",0
,(
function(self,aBoolean)
(function()
	local _s8_value=(aBoolean)
	self["@useTemplates"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","useTemplates: aBoolean\r\n\t\" Set the receiver to consider inlined templates. \"\r\n\r\n\tuseTemplates := aBoolean","(\r\nfunction(self,aBoolean)\r\n(function()\r\n\tlocal _s8_value=(aBoolean)\r\n\tself[\"@useTemplates\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SourceCodeParser["$klass"],"parse:",0
,(
function(self,aStream)
return (((self):new()):parse_(aStream));
end
)
,"instantiation","parse: aStream\r\n\t\" Return the result of parsing contents in aStream. \"\r\n\r\n\t^self new parse: aStream ","(\r\nfunction(self,aStream)\r\nreturn (((self):new()):parse_(aStream));\r\nend\r\n)")
smalltalk:bind(smalltalk.SourceCodeParser["$klass"],"debug:",0
,(
function(self,aStream)
return ((smalltalk.PPParser):debugWhile_((function()
return ((self):parse_(aStream))
end)));
end
)
,"debug","debug: aStream\r\n\t^PPParser debugWhile: [\r\n\t\tself parse: aStream\r\n\t]","(\r\nfunction(self,aStream)\r\nreturn ((smalltalk.PPParser):debugWhile_((function()\r\nreturn ((self):parse_(aStream))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SourceCodeParser,"parse:",0
,(
function(self,aStream)
return (((self):parser()):parse_(aStream));
end
)
,"parsing","parse: aStream\r\n\t\" Return the result of parsing contents in aStream. \"\r\n\r\n\t^self parser parse: aStream","(\r\nfunction(self,aStream)\r\nreturn (((self):parser()):parse_(aStream));\r\nend\r\n)")
smalltalk:bind(smalltalk.SourceCodeParser,"gc",0
,(
function(self)
if ((smalltalk.Smalltalk):includesKey_("JSC"))==true then (smalltalk.Smalltalk):gc(); end;
return (self);
end
)
,"gc","gc\r\n\t\" Private - Perform (preventive) garbage collection.\r\n\tNote: JavascriptCore VM can crash reporting\r\n\t 'memory issues' if we do not GC asap.\r\n\t This issue will persist while Apple continue\r\n\t  distributing a version of JSC with issue reported\r\n\t\tswiki:U8/232\r\n\t\thttps://bugs.webkit.org/show_bug.cgi?id=160027\r\n\t\"\r\n\r\n\t(Smalltalk includesKey: #JSC) ifTrue: [ Smalltalk gc ].","(\r\nfunction(self)\r\nif ((smalltalk.Smalltalk):includesKey_(\"JSC\"))==true then (smalltalk.Smalltalk):gc(); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SourceCodeParser,"separator",0
,(
function(self)
return ((smalltalk.PPCharacterParser):separator());
end
)
,"parsers","separator\r\n\t\" Return the parser for separator. \"\r\n\r\n\t^PPCharacterParser separator","(\r\nfunction(self)\r\nreturn ((smalltalk.PPCharacterParser):separator());\r\nend\r\n)")
smalltalk:bind(smalltalk.SourceCodeParser,"parser",0
,(
function(self)
return ((self):implementedBySubclass_("parser"));
end
)
,"parsers","parser\r\n\t\" Return the method parser. \"\r\n\r\n\t^self implementedBySubclass: #parser","(\r\nfunction(self)\r\nreturn ((self):implementedBySubclass_(\"parser\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SourceCodeParser,"charParser:",0
,(
function(self,options)
return ((smalltalk.PPCharacterParser):for_doing_(smalltalk:object_comma_(("a-zA-Z0-9"),options),(function(c)
return (smalltalk:boolean_or_(((c):isAlphaNumeric()),(function()
return ((options):includes_(c))
end)))
end)));
end
)
,"parsers","charParser: options\r\n\t\" Private - Return the character parser. \"\r\n\r\n\t^PPCharacterParser for: 'a-zA-Z0-9',options doing: [:c|\r\n\t\tc isAlphaNumeric or: [ options includes: c ]\r\n\t]","(\r\nfunction(self,options)\r\nreturn ((smalltalk.PPCharacterParser):for_doing_(smalltalk:object_comma_((\"a-zA-Z0-9\"),options),(function(c)\r\nreturn (smalltalk:boolean_or_(((c):isAlphaNumeric()),(function()\r\nreturn ((options):includes_(c))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SourceCodeParser,"charParserOr:",0
,(
function(self,aCharacter)
return ((smalltalk.PPCharacterParser):for_doing_(smalltalk:object_comma_(("a-zA-Z0-9"),aCharacter),(function(c)
return (smalltalk:boolean_or_(((c):isAlphaNumeric()),(function()
return (smalltalk:isObject_equalTo_((c),aCharacter))
end)))
end)));
end
)
,"parsers","charParserOr: aCharacter\r\n\t\" Private - Return the character parser. \"\r\n\r\n\t^PPCharacterParser for: 'a-zA-Z0-9',aCharacter doing: [:c|\r\n\t\tc isAlphaNumeric or: [ c = aCharacter ]\r\n\t]","(\r\nfunction(self,aCharacter)\r\nreturn ((smalltalk.PPCharacterParser):for_doing_(smalltalk:object_comma_((\"a-zA-Z0-9\"),aCharacter),(function(c)\r\nreturn (smalltalk:boolean_or_(((c):isAlphaNumeric()),(function()\r\nreturn (smalltalk:isObject_equalTo_((c),aCharacter))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SourceCodeParser,",","_comma"
,(
function(self,anObject)
return (smalltalk:object_comma_((smalltalk.PPParser),anObject));
end
)
,"parsers",", anObject\r\n\t\" Private - Return the parser to start parsing anObject. \"\r\n\r\n\t^PPParser , anObject","(\r\nfunction(self,anObject)\r\nreturn (smalltalk:object_comma_((smalltalk.PPParser),anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.SourceCodeParser,"optional:",0
,(
function(self,anObject)
return ((smalltalk.PPParser):optional_(anObject));
end
)
,"parsers","optional: anObject\r\n\t\" Private - Return the parser to parse an optional element anObject. \"\r\n\r\n\t^PPParser optional: anObject","(\r\nfunction(self,anObject)\r\nreturn ((smalltalk.PPParser):optional_(anObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.SourceCodeParser,"gc:",0
,(
function(self,anObject)
return ((smalltalk:object_comma_((self),anObject)):_eq_eq_gt((function(node)
(self):gc();return (node)
end)));
end
)
,"parsers","gc: anObject\r\n\t\" Private - Return the parser to parse anObject. \"\r\n\r\n\t^(self ,anObject) ==> [:node| self gc. node ]","(\r\nfunction(self,anObject)\r\nreturn ((smalltalk:object_comma_((self),anObject)):_eq_eq_gt((function(node)\r\n(self):gc();return (node)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser["$klass"],"constructEventsTriggered",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:newArray({"needsDirectiveParser:ws:"})),smalltalk:superImplementor(smalltalk.SmalltalkParser["$klass"],"constructEventsTriggered")(self)));
end
)
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^#(\t#needsDirectiveParser:ws:\r\n\t) , super constructEventsTriggered","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:newArray({\"needsDirectiveParser:ws:\"})),smalltalk:superImplementor(smalltalk.SmalltalkParser[\"$klass\"],\"constructEventsTriggered\")(self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"missingDirective:ws:",0
,(
function(self,number,ws)
return (((smalltalk:object_comma_(((((smalltalk.PPCharacterParser):notIn_(">")):star()):flatten()),">")):_at_at("missingDirective")):_eq_eq_gt((function(node)
return ((self):error_(smalltalk:object_comma_(("Invalid directive - "),(node):first())))
end)));
end
)
,"directives","missingDirective: number ws: ws\r\n\t\" Private - Return the parser for missing support of directives. \"\r\n\r\n\t^(PPCharacterParser notIn: $>) star flatten\r\n\t, $> @@#missingDirective\r\n\t==> [:node| self error: 'Invalid directive - ' ,node first ]","(\r\nfunction(self,number,ws)\r\nreturn (((smalltalk:object_comma_(((((smalltalk.PPCharacterParser):notIn_(\">\")):star()):flatten()),\">\")):_at_at(\"missingDirective\")):_eq_eq_gt((function(node)\r\nreturn ((self):error_(smalltalk:object_comma_((\"Invalid directive - \"),(node):first())))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"jsDirective:ws:",0
,(
function(self,number,ws)
return (((smalltalk:object_comma_(((smalltalk:object_comma_((self),"js:")):_slash("javascript:")),(smalltalk.PPInlineParser):upTo_(":>"))):_at_at("jsDirective")):_eq_eq_gt((function(node)
return ((smalltalk.JSDirectiveNode):code_protected_((node):second(),smalltalk:isObject_equalTo_(((node):first()),"javascript:")))
end)));
end
)
,"directives","jsDirective: number ws: ws\r\n\t\" Private - Return the parser for native directives.\r\n\t\"\r\n\r\n\t^self\t, #js: / #javascript:\r\n\t\t, (PPInlineParser upTo: ':>')\r\n\t\t@@#jsDirective\r\n\t==> [:node| JSDirectiveNode\r\n\t\tcode: node second\r\n\t\tprotected: node first = #javascript:\r\n\t]","(\r\nfunction(self,number,ws)\r\nreturn (((smalltalk:object_comma_(((smalltalk:object_comma_((self),\"js:\")):_slash(\"javascript:\")),(smalltalk.PPInlineParser):upTo_(\":>\"))):_at_at(\"jsDirective\")):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.JSDirectiveNode):code_protected_((node):second(),smalltalk:isObject_equalTo_(((node):first()),\"javascript:\")))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"optDirective:ws:",0
,(
function(self,number,ws)
return (((smalltalk:object_comma_((((smalltalk:object_comma_((self),"opt:")):_slash("opt+:")):_slash("opt-:")),(smalltalk.PPInlineParser):upTo_(":>"))):_at_at("optDirective")):_eq_eq_gt((function(node)
return ((
function(_s8_rec)
	(_s8_rec):args_(((node):second()):asArrayOfSubstrings());
	(_s8_rec):remove_(smalltalk:isObject_equalTo_(((node):first()),"opt-:"));
	return ((_s8_rec):yourself())
end
)((smalltalk.InlineOptimizationNode):new()))
end)));
end
)
,"directives","optDirective: number ws: ws\r\n\t\" Private - Return the parser for compiler optimizations directive.\r\n\t\"\r\n\r\n\t^self\t, #opt: / #opt+: / #opt-:\r\n\t\t,(PPInlineParser upTo: ':>')\r\n\t\t@@#optDirective\r\n\t==> [:node| InlineOptimizationNode new\r\n\t\targs: node second asArrayOfSubstrings;\r\n\t\tremove: node first = #opt-:;\r\n\t\tyourself\r\n\t]","(\r\nfunction(self,number,ws)\r\nreturn (((smalltalk:object_comma_((((smalltalk:object_comma_((self),\"opt:\")):_slash(\"opt+:\")):_slash(\"opt-:\")),(smalltalk.PPInlineParser):upTo_(\":>\"))):_at_at(\"optDirective\")):_eq_eq_gt((function(node)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):args_(((node):second()):asArrayOfSubstrings());\r\n\t(_s8_rec):remove_(smalltalk:isObject_equalTo_(((node):first()),\"opt-:\"));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.InlineOptimizationNode):new()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"defaultDirective:ws:",0
,(
function(self,number,ws)
return ((((self):optDirective_ws_(number,ws)):_slash((self):jsDirective_ws_(number,ws))):_slash((self):missingDirective_ws_(number,ws)));
end
)
,"directives","defaultDirective: number ws: ws\r\n\t\" Private - Return the parser for default support of directives.\r\n\tWe support inlined native directives.\r\n\t\"\r\n\r\n\t^ (self optDirective: number ws: ws)\r\n\t/ (self jsDirective: number ws: ws)\r\n\t/ (self missingDirective: number ws: ws)","(\r\nfunction(self,number,ws)\r\nreturn ((((self):optDirective_ws_(number,ws)):_slash((self):jsDirective_ws_(number,ws))):_slash((self):missingDirective_ws_(number,ws)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"directive:ws:",0
,(
function(self,number,ws)
local parser=nil
(function()
	local _s8_value=((self):triggerEvent_withArguments_ifNotHandled_("needsDirectiveParser:ws:",(smalltalk.Array):with_with_(number,ws),(function()
return ((self):defaultDirective_ws_(number,ws))
end)))
	parser=_s8_value
	return _s8_value
end)();
return (((smalltalk:object_comma_((smalltalk:object_comma_((self),"<")),smalltalk:object_comma_((smalltalk:object_comma_((ws),parser)),ws))):_at_at("directive")):_eq_eq_gt((function(node)
return (((node):second()):second())
end)));
end
)
,"directives","directive: number ws: ws\r\n\t\" Private - Return the parser for directives. \"\r\n\r\n\t| parser |\r\n\tparser := self\r\n\t\ttriggerEvent: #needsDirectiveParser:ws:\r\n\t\twithArguments: (Array with: number with: ws)\r\n\t\tifNotHandled: [ self defaultDirective: number ws: ws ].\r\n\r\n\t^self\t, $< ,(ws, parser, ws) @@#directive\r\n\t\t==> [:node | node second second ]","(\r\nfunction(self,number,ws)\r\nlocal parser=nil\r\n(function()\r\n\tlocal _s8_value=((self):triggerEvent_withArguments_ifNotHandled_(\"needsDirectiveParser:ws:\",(smalltalk.Array):with_with_(number,ws),(function()\r\nreturn ((self):defaultDirective_ws_(number,ws))\r\nend)))\r\n\tparser=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((smalltalk:object_comma_((smalltalk:object_comma_((self),\"<\")),smalltalk:object_comma_((smalltalk:object_comma_((ws),parser)),ws))):_at_at(\"directive\")):_eq_eq_gt((function(node)\r\nreturn (((node):second()):second())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"binarySelectorChars",0
,(
function(self)
return ((smalltalk.String):binarySelectorChars());
end
)
,"constants","binarySelectorChars\r\n\t\" Return the binary selector characters mask. \"\r\n\r\n\t^String binarySelectorChars ","(\r\nfunction(self)\r\nreturn ((smalltalk.String):binarySelectorChars());\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"binaryCharParser",0
,(
function(self)
return (((smalltalk.PPCharacterParser):in_((self):binarySelectorChars())):_at_at("binaryChar"));
end
)
,"parsers","binaryCharParser\r\n\t\" Return the binary selector character parser. \"\r\n\r\n\t^(PPCharacterParser in: self binarySelectorChars) @@#binaryChar","(\r\nfunction(self)\r\nreturn (((smalltalk.PPCharacterParser):in_((self):binarySelectorChars())):_at_at(\"binaryChar\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"symbolCharParser",0
,(
function(self)
return (((self):charParserOr_("_")):_at_at("symbolChar"));
end
)
,"parsers","symbolCharParser\r\n\t\" Return the symbol character parser. \"\r\n\r\n\t^(self charParserOr: $_) @@#symbolChar","(\r\nfunction(self)\r\nreturn (((self):charParserOr_(\"_\")):_at_at(\"symbolChar\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"jsSymbolCharParser",0
,(
function(self)
return (((self):charParser_("_$")):_at_at("jsSymbolChar"));
end
)
,"parsers","jsSymbolCharParser\r\n\t\" Private - Return the js symbol character parser. \"\r\n\r\n\t^(self charParser: '_$') @@#jsSymbolChar","(\r\nfunction(self)\r\nreturn (((self):charParser_(\"_$\")):_at_at(\"jsSymbolChar\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"extendedSymbolCharParser",0
,(
function(self)
return (((self):charParser_(smalltalk:object_comma_(("_:"),(self):binarySelectorChars()))):_at_at("extendedSymbolChar"));
end
)
,"parsers","extendedSymbolCharParser\r\n\t\" Private - Return the extended symbol character parser. \"\r\n\r\n\t^(self charParser: '_:' , self binarySelectorChars) @@#extendedSymbolChar","(\r\nfunction(self)\r\nreturn (((self):charParser_(smalltalk:object_comma_((\"_:\"),(self):binarySelectorChars()))):_at_at(\"extendedSymbolChar\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"globalNameParser",0
,(
function(self)
return (((smalltalk:object_comma_(((smalltalk.PPCharacterParser):between_and_("A","Z")),((self):symbolCharParser()):star())):flatten()):_at_at("globalNameParser"));
end
)
,"parsers","globalNameParser\r\n\t\" Return the parser for global names. \"\r\n\r\n\t^((PPCharacterParser between: $A and: $Z)\r\n\t\t, self symbolCharParser star)\r\n\t\tflatten @@#globalNameParser","(\r\nfunction(self)\r\nreturn (((smalltalk:object_comma_(((smalltalk.PPCharacterParser):between_and_(\"A\",\"Z\")),((self):symbolCharParser()):star())):flatten()):_at_at(\"globalNameParser\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"comment",0
,(
function(self)
return ((((smalltalk:object_comma_((smalltalk:object_comma_((("\""):asParser()),(smalltalk:object_comma_((smalltalk:booleanNot_((("\""):asParser()))),(smalltalk.PPAnyParser):new())):star())),"\"")):_at_at("stComment")):flatten()):_at_at("comment"));
end
)
,"parsers","comment\r\n\t\" Return the parser for comment. \"\r\n\r\n\t^($\" asParser\r\n\t,($\" asParser not, PPAnyParser new) star\r\n\t, $\" @@#stComment) flatten\r\n\t@@#comment","(\r\nfunction(self)\r\nreturn ((((smalltalk:object_comma_((smalltalk:object_comma_(((\"\\\"\"):asParser()),(smalltalk:object_comma_((smalltalk:booleanNot_(((\"\\\"\"):asParser()))),(smalltalk.PPAnyParser):new())):star())),\"\\\"\")):_at_at(\"stComment\")):flatten()):_at_at(\"comment\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"nameStart",0
,(
function(self)
return (((smalltalk.PPCharacterParser):for_doing_("a-z_",(function(c)
return (smalltalk:boolean_or_(((c):between_and_("a","z")),(function()
return (smalltalk:isObject_equalTo_((c),"_"))
end)))
end))):_at_at("nameStart"));
end
)
,"parsers","nameStart\r\n\t\" Return the parser for name start.\"\r\n\r\n\t^(PPCharacterParser for: 'a-z_' doing: [:c|\r\n\t\t(c between: $a and: $z)\r\n\t\tor: [ c = $_ ]\r\n\t]) @@#nameStart","(\r\nfunction(self)\r\nreturn (((smalltalk.PPCharacterParser):for_doing_(\"a-z_\",(function(c)\r\nreturn (smalltalk:boolean_or_(((c):between_and_(\"a\",\"z\")),(function()\r\nreturn (smalltalk:isObject_equalTo_((c),\"_\"))\r\nend)))\r\nend))):_at_at(\"nameStart\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"upNameStart",0
,(
function(self)
return (((smalltalk.PPCharacterParser):for_doing_("A-Za-z_",(function(c)
return (smalltalk:boolean_or_(((c):isLetter()),(function()
return (smalltalk:isObject_equalTo_((c),"_"))
end)))
end))):_at_at("upNameStart"));
end
)
,"parsers","upNameStart\r\n\t\" Return the parser for name start (can be uppercase).\"\r\n\r\n\t^(PPCharacterParser for: 'A-Za-z_' doing: [:c|\r\n\t\tc isLetter or: [ c = $_ ]\r\n\t]) @@#upNameStart","(\r\nfunction(self)\r\nreturn (((smalltalk.PPCharacterParser):for_doing_(\"A-Za-z_\",(function(c)\r\nreturn (smalltalk:boolean_or_(((c):isLetter()),(function()\r\nreturn (smalltalk:isObject_equalTo_((c),\"_\"))\r\nend)))\r\nend))):_at_at(\"upNameStart\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"digits",0
,(
function(self)
return (((smalltalk.PPCharacterParser):between_and_("0","9")):plus());
end
)
,"parsers","digits\r\n\t\" Return the parser for numeric digits.\"\r\n\r\n\t^(PPCharacterParser between: $0 and: $9) plus","(\r\nfunction(self)\r\nreturn (((smalltalk.PPCharacterParser):between_and_(\"0\",\"9\")):plus());\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"decimals",0
,(
function(self)
return ((smalltalk:object_comma_((smalltalk:object_comma_((self),".")),(self):digits())):_at_at("decimals"));
end
)
,"parsers","decimals\r\n\t\" Return the parser for number decimals.\"\r\n\r\n\t^self\t, $.\r\n\t\t, self digits\r\n\t\t@@#decimals","(\r\nfunction(self)\r\nreturn ((smalltalk:object_comma_((smalltalk:object_comma_((self),\".\")),(self):digits())):_at_at(\"decimals\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"exponent",0
,(
function(self)
return ((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((self),"e")),(self):optional_("-"))),(self):digits())):_at_at("exponent"));
end
)
,"parsers","exponent\r\n\t\" Return the parser for number exponent.\"\r\n\r\n\t^self\t, $e\r\n\t\t, (self optional: $-)\r\n\t\t, self digits\r\n\t\t@@#exponent","(\r\nfunction(self)\r\nreturn ((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((self),\"e\")),(self):optional_(\"-\"))),(self):digits())):_at_at(\"exponent\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"radix",0
,(
function(self)
return ((smalltalk:object_comma_((smalltalk:object_comma_((self),"r")),((smalltalk.PPCharacterParser):for_doing_("0-9A-Z",(function(c)
return (smalltalk:boolean_or_(((c):between_and_("0","9")),(function()
return ((c):between_and_("A","Z"))
end)))
end))):plus())):_at_at("radix"));
end
)
,"parsers","radix\r\n\t\" Return the parser for number radix.\"\r\n\r\n\t^self\t, $r\r\n\t\t, (PPCharacterParser for: '0-9A-Z' doing: [:c|\r\n\t\t\t(c between: $0 and: $9)\r\n\t\t\tor: [ c between: $A and: $Z ]\r\n\t\t]) plus\r\n\t\t@@#radix","(\r\nfunction(self)\r\nreturn ((smalltalk:object_comma_((smalltalk:object_comma_((self),\"r\")),((smalltalk.PPCharacterParser):for_doing_(\"0-9A-Z\",(function(c)\r\nreturn (smalltalk:boolean_or_(((c):between_and_(\"0\",\"9\")),(function()\r\nreturn ((c):between_and_(\"A\",\"Z\"))\r\nend)))\r\nend))):plus())):_at_at(\"radix\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"number",0
,(
function(self)
return ((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):optional_("-")),(self):digits())),((self):decimals()):optional())),(((self):exponent()):_slash((self):radix())):optional())):_at_at("number"));
end
)
,"parsers","number\r\n\t\" Return the parser for number.\"\r\n\r\n\t^(self optional: $-)\r\n\t\t, self digits , self decimals optional\r\n\t\t, (self exponent / self radix) optional\r\n\t\t@@#number","(\r\nfunction(self)\r\nreturn ((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):optional_(\"-\")),(self):digits())),((self):decimals()):optional())),(((self):exponent()):_slash((self):radix())):optional())):_at_at(\"number\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"annotationStart",0
,(
function(self)
return (smalltalk:object_comma_((self),"::"));
end
)
,"private","annotationStart\r\n\t\" Private - Return the parser for starting annotations. \"\r\n\r\n\t^self ,#:: ","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((self),\"::\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"methodParserParts",0
,(
function(self)
local expression=nil
local separator=nil
local comment=nil
local ws=nil
local identifier=nil
local keyword=nil
local stSelectorPart=nil
local string=nil
local symbol=nil
local number=nil
local variable=nil
local reference=nil
local globalReference=nil
local literal=nil
local returnExpression=nil
local expressionParser=nil
local keyword=nil
local unarySelector=nil
local binarySelector=nil
local keywordPattern=nil
local unaryPattern=nil
local binaryPattern=nil
local assignment=nil
local temps=nil
local blockParamList=nil
local block=nil
local expression=nil
local expressions=nil
local subexpression=nil
local statements=nil
local sequence=nil
local operand=nil
local unaryMessage=nil
local unarySend=nil
local unaryTail=nil
local binaryMessage=nil
local binarySend=nil
local binaryTail=nil
local keywordMessage=nil
local keywordSend=nil
local keywordPair=nil
local cascade=nil
local message=nil
local inline=nil
local jsIndex=nil
local character=nil
local directive=nil
local arrayLiteral=nil
local arrayVariable=nil
local literalArray=nil
local aSymbol=nil
local stIdentifier=nil
local jsIdentifier=nil
local noReference=nil
local alienReference=nil
local alienIdentifier=nil
local emptyArray=nil
local hashedString=nil
local annotation=nil
local argument=nil
(function()
	local _s8_value=((self):separator())
	separator=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):comment())
	comment=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((((separator):_slash(comment)):_at_at("sp")):star()):_at_at("ws"))
	ws=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((self),"'")),(smalltalk.PPStStringParser):new())):_at_at("string")):_eq_eq_gt((function(node)
return ((smalltalk.ValueNode):with_((node):second()))
end)))
	string=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((self),smalltalk:object_comma_(("#"),"'"))),(smalltalk.PPStStringParser):new())):_at_at("hashedString")):_eq_eq_gt((function(node)
return ((smalltalk.ValueNode):with_((node):second()))
end)))
	hashedString=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((smalltalk:object_comma_(((self):nameStart()),((self):symbolCharParser()):star())):_at_at("stId")):flatten()):_at_at("stIdentifier"))
	stIdentifier=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((smalltalk:object_comma_(((self):upNameStart()),((self):symbolCharParser()):star())):_at_at("stSel")):flatten()):_at_at("stSelectorPart"))
	stSelectorPart=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((smalltalk:object_comma_((smalltalk:object_comma_((self),"#")),((self):jsSymbolCharParser()):plus())):_at_at("jsId")):flatten()):_at_at("jsIdentifier"))
	jsIdentifier=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((((self):jsSymbolCharParser()):plus()):flatten()):_at_at("alienIdentifier"))
	alienIdentifier=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((jsIdentifier):_slash(stIdentifier)):_at_at("identifier"))
	identifier=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_(((stSelectorPart):_slash(identifier)),":")):flatten()):_at_at("keyword"))
	keyword=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_(((self):annotationStart()),((string):_slash(stIdentifier)):_slash((self):globalNameParser()))):_at_at("annotation")):_eq_eq_gt((function(node)
return ((node):last())
end)))
	annotation=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk:object_comma_((identifier),(annotation):star())):_eq_eq_gt((function(node)
return (((smalltalk.ValueNode):with_((node):first())):annotations_((node):last()))
end)))
	argument=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((self),"#")),(((self):extendedSymbolCharParser()):plus()):flatten())):_at_at("symbol")):_eq_eq_gt((function(node)
return ((smalltalk.ValueNode):with_((node):second()))
end)))
	symbol=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((self):number()):flatten()):_eq_eq_gt((function(node)
return ((smalltalk.ValueNode):with_((node):asNumber()))
end)))
	number=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((self),"$")),(smalltalk.PPAnyParser):new())):_at_at("character")):_eq_eq_gt((function(node)
return ((smalltalk.ValueNode):with_((node):at_(2)))
end)))
	character=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):directive_ws_(number,ws))
	directive=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((identifier):_eq_eq_gt((function(token)
return (((smalltalk.VariableNode):new()):value_(token))
end)))
	variable=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((self),"#")):_at_at("noReference")):_eq_eq_gt((function(token)
return ((smalltalk.NoReceiverNode):new())
end)))
	noReference=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk.PPDelegateParser):new()):_at_at("literalDelegate"))
	literal=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk.PPDelegateParser):new()):_at_at("expressionDelegate"))
	expression=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((((smalltalk:object_comma_((self),"true")):_eq_eq_gt((function(node)
return ((smalltalk.ValueNode):with_(true))
end))):_slash((smalltalk:object_comma_((self),"false")):_eq_eq_gt((function(node)
return ((smalltalk.ValueNode):with_(false))
end)))):_slash((smalltalk:object_comma_((self),"nil")):_eq_eq_gt((function(node)
return ((smalltalk.ValueNode):with_(nil))
end)))):_at_at("arrayVariable"))
	arrayVariable=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((((self):extendedSymbolCharParser()):plus()):flatten()):_at_at("aSymbol")):_eq_eq_gt((function(node)
return ((smalltalk.ValueNode):with_(node))
end)))
	aSymbol=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((literal):_slash(arrayVariable)):_slash(aSymbol)):_slash(variable))
	arrayLiteral=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_(((self):gc_("#(")),(smalltalk:object_comma_((smalltalk:object_comma_((ws),arrayLiteral)),ws)):star())),")")):_at_at("literalArray")):_eq_eq_gt((function(node)
return ((smalltalk.ValueNode):with_((smalltalk.Array):withAll_(((node):second()):collect_((function(each)
return (((each):second()):value())
end)))))
end)))
	literalArray=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((self),"#(")),ws)),")")):_at_at("emptyArray")):_eq_eq_gt((function(node)
return ((smalltalk.ValueNode):with_((smalltalk.Array):new()))
end)))
	emptyArray=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((self):globalNameParser()):_at_at("globalReference")):_eq_eq_gt((function(token)
(self):gc();return (((smalltalk.GlobalReferenceNode):new()):value_(token))
end)))
	globalReference=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((self),smalltalk:object_comma_(("#"),"{"))),alienIdentifier)),"}")):_at_at("alienReference")):_eq_eq_gt((function(node)
return (((smalltalk.AlienNode):new()):value_((node):second()))
end)))
	alienReference=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk:object_comma_((smalltalk:object_comma_(((self):gc_("[")),expression)),"]")):_slash(smalltalk:object_comma_((smalltalk:object_comma_((self),"#")),alienIdentifier)))
	jsIndex=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_(((((variable):_slash(globalReference)):_slash(alienReference)):_at_at("ref")),(jsIndex):star())),(annotation):star())):_at_at("reference")):_eq_eq_gt((function(nodes)
return (((nodes):first()):reference_(nodes))
end)))
	reference=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_(((self):optional_("#")),((self):binaryCharParser()):plus())):flatten()):_at_at("binarySelector"))
	binarySelector=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((stSelectorPart):_slash(identifier)):_at_at("unarySelector"))
	unarySelector=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((((smalltalk:object_comma_((smalltalk:object_comma_(((smalltalk:object_comma_((ws),keyword)):_at_at("kw")),ws)),argument)):_at_at("kwId")):plus()):_at_at("keywordPattern")):_eq_eq_gt((function(nodes)
return ((smalltalk.Array):with_with_(((nodes):collect_((function(each)
return ((each):at_(2))
end))):join_(""),(nodes):collect_((function(each)
return ((each):at_(4))
end))))
end)))
	keywordPattern=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((ws),binarySelector)),ws)),argument)):_at_at("binaryPattern")):_eq_eq_gt((function(node)
return ((smalltalk.Array):with_with_((node):second(),(smalltalk.Array):with_((node):fourth())))
end)))
	binaryPattern=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((ws),unarySelector)):_at_at("unaryPattern")):_eq_eq_gt((function(node)
return ((smalltalk.Array):with_with_((node):second(),(smalltalk.Array):new()))
end)))
	unaryPattern=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((expression),(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((ws),".")),ws)),expression)):_at_at("anExpression")):_eq_eq_gt((function(node)
return ((node):fourth())
end))):star())):_at_at("expressions")):_eq_eq_gt((function(node)
return (smalltalk:object_comma_(((smalltalk.Array):with_((node):first())),(node):second()))
end)))
	expressions=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((reference),ws)),":=")),ws)),expression)):_at_at("assignment")):_eq_eq_gt((function(node)
return ((
function(_s8_rec)
	(_s8_rec):left_((node):first());
	return ((_s8_rec):right_((node):at_(5)))
end
)((smalltalk.AssignmentNode):new()))
end)))
	assignment=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((((self):gc_("^")):_at_at("caret")),ws)),expression)),(annotation):star())),ws)),(("."):asParser()):optional())):_at_at("returnExpression")):_eq_eq_gt((function(node)
return ((
function(_s8_rec)
	(_s8_rec):addNode_((node):at_(3));
	(_s8_rec):annotations_((node):at_(4));
	return ((_s8_rec):yourself())
end
)((smalltalk.ReturnNode):new()))
end)))
	returnExpression=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((self),"|")),(smalltalk:object_comma_((ws),argument)):star())),ws)),"|")):_at_at("temps")):_eq_eq_gt((function(node)
return (((node):second()):collect_((function(each)
return ((each):second())
end)))
end)))
	temps=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((self),":")),ws)),argument)),ws)):plus()),"|")):_at_at("blockParamList")):_eq_eq_gt((function(node)
return (((node):first()):collect_((function(each)
return ((each):third())
end)))
end)))
	blockParamList=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):gc_("(")),ws)),expression)),ws)),")")):_at_at("subexpression")):_eq_eq_gt((function(node)
return ((node):third())
end)))
	subexpression=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((((returnExpression):_at_at("stat1")):_eq_eq_gt((function(node)
return ((smalltalk.Array):with_(node))
end))):_slash(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((expressions),ws)),".")),ws)),returnExpression)):_at_at("stat2")):_eq_eq_gt((function(node)
return ((
function(_s8_rec)
	(_s8_rec):add_((node):at_(5));
	return ((_s8_rec):yourself())
end
)((node):first()))
end)))):_slash(((smalltalk:object_comma_((expressions),(self):optional_("."))):_at_at("stat3")):_eq_eq_gt((function(node)
return ((node):first())
end))))
	statements=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((((temps):optional()):_at_at("temps")),ws)),(directive):star())),ws)),(statements):optional())),ws)):_at_at("sequence")):_eq_eq_gt((function(node)
return ((
function(_s8_rec)
	(_s8_rec):temps_((node):first());
	(_s8_rec):directives_((node):third());
	(_s8_rec):nodes_((node):at_(5));
	return ((_s8_rec):yourself())
end
)((smalltalk.ExtendedSequenceNode):new()))
end)))
	sequence=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):gc_("[")),ws)),(blockParamList):optional())),ws)),(sequence):optional())),ws)),"]")):_at_at("block")):_eq_eq_gt((function(node)
return ((
function(_s8_rec)
	(_s8_rec):parameters_((node):third());
	return ((_s8_rec):addNode_(((node):at_(5)):asBlockSequenceNode()))
end
)((smalltalk.BlockNode):new()))
end)))
	block=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((((block):_slash(literal)):_slash(reference)):_slash(noReference)):_slash(subexpression)):_at_at("operand"))
	operand=_s8_value
	return _s8_value
end)();
(literal):parser_((((((((symbol):_slash(number)):_slash(string)):_slash(character)):_slash(emptyArray)):_slash(literalArray)):_slash(hashedString)):_at_at("literalDelegate"));
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((ws),unarySelector)),smalltalk:booleanNot_((smalltalk:object_comma_((self),":"))))):_at_at("unaryMessage")):_eq_eq_gt((function(node)
return (((smalltalk.SendNode):new()):selector_((node):second()))
end)))
	unaryMessage=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk.PPDelegateParser):new()):_at_at("unaryTailDelegate"))
	unaryTail=_s8_value
	return _s8_value
end)();
(unaryTail):parser_(((smalltalk:object_comma_((unaryMessage),(unaryTail):optional())):_at_at("unaryTailDelegate")):_eq_eq_gt((function(node)
return (smalltalk:if_true_false_((smalltalk:isNil_(((node):second()))),(function()
return ((node):first())
end),(function()
return (((node):second()):valueForReceiver_((node):first()))
end)))
end)));
(function()
	local _s8_value=(((smalltalk:object_comma_((operand),(unaryTail):optional())):_at_at("unarySend")):_eq_eq_gt((function(node)
return (smalltalk:if_true_false_((smalltalk:isNil_(((node):second()))),(function()
return ((node):first())
end),(function()
return (((node):second()):valueForReceiver_((node):first()))
end)))
end)))
	unarySend=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((ws),binarySelector)),ws)),(unarySend):_slash(operand))):_at_at("binaryMessage")):_eq_eq_gt((function(node)
return ((
function(_s8_rec)
	(_s8_rec):selector_((node):second());
	return ((_s8_rec):arguments_((smalltalk.Array):with_((node):fourth())))
end
)((smalltalk.SendNode):new()))
end)))
	binaryMessage=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk.PPDelegateParser):new()):_at_at("binaryTailDelegate"))
	binaryTail=_s8_value
	return _s8_value
end)();
(binaryTail):parser_((smalltalk:object_comma_((binaryMessage),(binaryTail):optional())):_eq_eq_gt((function(node)
return (smalltalk:if_true_false_((smalltalk:isNil_(((node):second()))),(function()
return ((node):first())
end),(function()
return (((node):second()):valueForReceiver_((node):first()))
end)))
end)));
(function()
	local _s8_value=(((smalltalk:object_comma_((unarySend),(binaryTail):optional())):_at_at("binarySend")):_eq_eq_gt((function(node)
return (smalltalk:if_true_false_((smalltalk:isNil_(((node):second()))),(function()
return ((node):first())
end),(function()
return (((node):second()):valueForReceiver_((node):first()))
end)))
end)))
	binarySend=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk:object_comma_((smalltalk:object_comma_((keyword),ws)),binarySend)):_at_at("keywordPair"))
	keywordPair=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((smalltalk:object_comma_((ws),keywordPair)):plus()):_at_at("keywordMessage")):_eq_eq_gt((function(nodes)
return ((
function(_s8_rec)
	(_s8_rec):selector_(((nodes):collect_((function(each)
return (((each):second()):first())
end))):join_(""));
	return ((_s8_rec):arguments_((nodes):collect_((function(each)
return (((each):second()):third())
end))))
end
)((smalltalk.SendNode):new()))
end)))
	keywordMessage=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((binarySend),keywordMessage)):_at_at("keywordSend")):_eq_eq_gt((function(node)
return (((node):second()):valueForReceiver_((node):first()))
end)))
	keywordSend=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((binaryMessage):_slash(unaryMessage)):_slash(keywordMessage)):_at_at("message"))
	message=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((((keywordSend):_slash(binarySend)):_at_at("head")),(smalltalk:object_comma_((smalltalk:object_comma_((ws),";")),message)):plus())):_at_at("cascade")):_eq_eq_gt((function(node)
return (((node):first()):cascadeNodeWithMessages_(((node):second()):collect_((function(each)
return ((each):third())
end))))
end)))
	cascade=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((self),"{")),(smalltalk:object_comma_((smalltalk:object_comma_(((stIdentifier):optional()),string)),ws)):plus())),"}")):_at_at("inline")):_eq_eq_gt((function(node)
return ((smalltalk.InlineNode):sources_parser_((node):second(),smalltalk:object_comma_((ws),(sequence):optional())))
end)))
	inline=_s8_value
	return _s8_value
end)();
(expression):parser_((((((assignment):_slash(cascade)):_slash(keywordSend)):_slash(binarySend)):_slash(inline)):_at_at("expression"));
return ((smalltalk.Array):with_with_with_(ws,(((keywordPattern):_slash(binaryPattern)):_slash(unaryPattern)):_at_at("header"),((sequence):optional()):_at_at("body")));
end
)
,"private","methodParserParts\r\n\t\" Private - Return a parser for parts of a method. \"\r\n\r\n | expression separator comment ws identifier keyword stSelectorPart\r\n  string symbol number variable reference globalReference\r\n  literal returnExpression expressionParser keyword unarySelector\r\n  binarySelector keywordPattern unaryPattern binaryPattern assignment\r\n  temps blockParamList block expression expressions subexpression\r\n  statements sequence operand unaryMessage unarySend unaryTail\r\n  binaryMessage binarySend binaryTail keywordMessage keywordSend\r\n  keywordPair cascade message inline jsIndex character directive\r\n  arrayLiteral arrayVariable literalArray aSymbol\r\n  stIdentifier jsIdentifier noReference alienReference\r\n  alienIdentifier emptyArray hashedString annotation argument\r\n |\r\n\r\n separator := self separator.\r\n comment := self comment.\r\n ws := (separator / comment @@#sp) star @@#ws.\r\n \r\n string := self ,$' ,PPStStringParser new @@#string\r\n  ==> [:node| ValueNode with: node second ].\r\n \r\n hashedString := self ,($#,$') ,PPStStringParser new @@#hashedString\r\n  ==> [:node| ValueNode with: node second ].\r\n\r\n stIdentifier := (self nameStart, self symbolCharParser star @@#stId) flatten @@#stIdentifier.\r\n stSelectorPart := (self upNameStart, self symbolCharParser star @@#stSel) flatten @@#stSelectorPart.\r\n jsIdentifier := (self ,$# ,self jsSymbolCharParser plus @@#jsId) flatten @@#jsIdentifier.\r\n alienIdentifier := self jsSymbolCharParser plus flatten @@#alienIdentifier.\r\n identifier := jsIdentifier / stIdentifier @@#identifier.\r\n\r\n keyword := (stSelectorPart / identifier, $:) flatten @@#keyword.\r\n\r\n annotation := self annotationStart\r\n\t,(string / stIdentifier / self globalNameParser) @@#annotation\r\n\t==>[:node| node last ].\r\n argument := identifier ,annotation star ==> [:node|\r\n\t(ValueNode with: node first) annotations: node last\r\n ].\r\n\r\n symbol := self ,$# ,self extendedSymbolCharParser plus flatten @@#symbol\r\n  ==> [:node | ValueNode with: node second ].\r\n\r\n number := self number flatten\r\n  ==> [:node | ValueNode with: node asNumber ].\r\n\r\n character := self ,$$ ,PPAnyParser new @@#character\r\n  ==> [:node | ValueNode with: (node at: 2) ].\r\n\r\n directive := self directive: number ws: ws.\r\n\r\n variable := identifier ==> [:token | VariableNode new value: token ].\r\n noReference := self ,$# @@#noReference ==> [:token | NoReceiverNode new ].\r\n literal := PPDelegateParser new @@#literalDelegate.\r\n expression := PPDelegateParser new @@#expressionDelegate.\r\n\r\n arrayVariable :=\r\n\t  (self ,#true  ==> [:node| ValueNode with: true ])\r\n\t/ (self ,#false ==> [:node| ValueNode with: false ])\r\n\t/ (self ,#nil   ==> [:node| ValueNode with: nil ])\r\n\t@@#arrayVariable.\r\n\r\n aSymbol := self extendedSymbolCharParser plus flatten @@#aSymbol\r\n  ==> [:node| ValueNode with: node ].\r\n\r\n arrayLiteral := literal / arrayVariable / aSymbol / variable.\r\n literalArray := (self gc: '#(')\r\n\t,(ws ,arrayLiteral ,ws) star ,$)\r\n\t@@#literalArray\r\n  ==> [:node | ValueNode with: (Array\r\n\twithAll: (node second\r\n\t\tcollect: [:each | each second value])) ].\r\n emptyArray := self ,'#(' ,ws ,$) @@#emptyArray\r\n  ==> [:node | ValueNode with: Array new ].\r\n\r\n globalReference := self globalNameParser @@#globalReference\r\n  ==> [:token | self gc. GlobalReferenceNode new value: token ].\r\n alienReference := self ,($# ,${) ,alienIdentifier, $} @@#alienReference\r\n  ==> [:node | AlienNode new value: node second ].\r\n\r\n jsIndex := (self gc: $[) ,expression, $] / (self ,$# ,alienIdentifier).\r\n reference := (variable / globalReference / alienReference @@#ref)\r\n\t,jsIndex star ,annotation star @@#reference\r\n  ==> [:nodes | nodes first reference: nodes ].\r\n\r\n binarySelector := (\r\n\t(self optional: $#)\r\n\t,self binaryCharParser plus\r\n\t) flatten @@#binarySelector.\r\n\r\n unarySelector := stSelectorPart / identifier @@#unarySelector.\r\n\r\n keywordPattern :=\r\n\t(ws, keyword  @@#kw ,\r\n\t ws, argument @@#kwId\r\n\t) plus @@#keywordPattern\r\n  ==> [:nodes | Array\r\n   with: ((nodes collect: [:each | each at: 2]) join: '')\r\n   with: (nodes collect: [:each | each at: 4]) ].\r\n\r\n binaryPattern := ws, binarySelector, ws, argument @@#binaryPattern\r\n  ==> [:node | Array with: node second with: (Array with: node fourth)].\r\n\r\n unaryPattern := ws, unarySelector @@#unaryPattern\r\n  ==> [:node | Array with: node second with: Array new].\r\n \r\n expressions := expression, ((ws, $., ws, expression) @@#anExpression\r\n  ==> [:node | node fourth]) star @@#expressions\r\n  ==> [:node | (Array with: node first) ,node second ].\r\n\r\n assignment := reference, ws, ':=', ws, expression @@#assignment\r\n  ==> [:node | AssignmentNode new left: node first; right: (node at: 5)].\r\n\r\nreturnExpression := (self gc: $^) @@#caret\r\n\t, ws, expression ,annotation star\r\n\t, ws, $. asParser optional\t@@#returnExpression\r\n     ==> [:node | ReturnNode new\r\n\taddNode: (node at: 3);\r\n\tannotations: (node at: 4);\r\n\tyourself ].\r\n\r\n temps := self, $|, (ws, argument) star, ws, $| @@#temps\r\n  ==> [:node | node second collect: [:each | each second ] ].\r\n\r\n blockParamList := (self ,$: ,ws ,argument ,ws) plus ,$| @@#blockParamList\r\n  ==> [:node | node first collect: [:each | each third ] ].\r\n\r\n subexpression := (self gc: $() ,ws ,expression ,ws ,$) @@#subexpression\r\n  ==> [:node | node third ].\r\n\r\n statements := (returnExpression @@#stat1 ==> [:node | Array with: node])\r\n  / (expressions ,ws ,$. ,ws ,returnExpression @@#stat2 ==> [:node | node first add: (node at: 5); yourself ])\r\n  / (expressions ,(self optional: $.) @@#stat3 ==> [:node | node first ]).\r\n\r\n sequence := temps optional @@#temps\r\n\t, ws, directive star\r\n\t, ws, statements optional\r\n\t, ws @@#sequence\r\n  ==> [:node | ExtendedSequenceNode new\r\n\ttemps: node first;\r\n\tdirectives: node third;\r\n\tnodes: (node at: 5);\r\n\tyourself ].\r\n\r\n block := (self gc: $[)\r\n\t,ws ,blockParamList optional\r\n\t,ws ,sequence optional\r\n\t,ws ,$] @@#block\r\n  ==> [:node | BlockNode new\r\n\tparameters: node third;\r\n\taddNode: (node at: 5) asBlockSequenceNode ].\r\n\r\n operand := block / literal / reference / noReference / subexpression @@#operand.\r\n\r\n literal parser: symbol / number / string / character\r\n\t/ emptyArray / literalArray / hashedString @@#literalDelegate.\r\n\r\n unaryMessage := ws ,unarySelector ,(self ,$:) not @@#unaryMessage\r\n  ==> [:node | SendNode new selector: node second ].\r\n\r\n unaryTail := PPDelegateParser new @@#unaryTailDelegate.\r\n unaryTail parser: (unaryMessage, unaryTail optional @@#unaryTailDelegate\r\n  ==> [:node | node second isNil ifTrue: [ node first ]\r\n\tifFalse: [ node second valueForReceiver: node first ] ]).\r\n\r\n unarySend := operand, unaryTail optional @@#unarySend\r\n  ==> [:node | node second isNil ifTrue: [ node first ]\r\n\tifFalse: [ node second valueForReceiver: node first ] ].\r\n\r\n binaryMessage := ws, binarySelector, ws, (unarySend / operand) @@#binaryMessage\r\n  ==> [:node | SendNode new\r\n\tselector: node second;\r\n\targuments: (Array with: node fourth) ].\r\n\r\n binaryTail := PPDelegateParser new @@#binaryTailDelegate.\r\n binaryTail parser: (binaryMessage, binaryTail optional\r\n  ==> [:node | node second isNil ifTrue: [ node first ]\r\n\tifFalse: [ node second valueForReceiver: node first ] ]).\r\n\r\n binarySend := unarySend, binaryTail optional @@#binarySend\r\n  ==> [:node | node second isNil ifTrue: [ node first ]\r\n\tifFalse: [ node second valueForReceiver: node first ] ].\r\n\r\n keywordPair := keyword, ws, binarySend @@#keywordPair.\r\n\r\n keywordMessage := (ws, keywordPair) plus @@#keywordMessage\r\n  ==> [:nodes | SendNode new\r\n\tselector: ((nodes collect: [:each | each second first]) join: '');\r\n\targuments: (nodes collect: [:each | each second third])].\r\n\r\n keywordSend := binarySend, keywordMessage @@#keywordSend\r\n  ==> [:node | node second valueForReceiver: node first].\r\n\r\n message := binaryMessage / unaryMessage / keywordMessage @@#message.\r\n\r\n cascade := (keywordSend / binarySend @@#head)\r\n\t,(ws, $;, message) plus @@#cascade\r\n  ==> [:node | node first cascadeNodeWithMessages: \r\n\t(node second collect: [:each | each third ])].\r\n\r\n inline := self ,${\r\n\t,(stIdentifier optional ,string ,ws) plus\r\n\t,$} @@#inline\r\n  ==> [:node | InlineNode sources: node second parser: ws ,sequence optional ].\r\n\r\n expression parser: assignment / cascade / keywordSend / binarySend / inline @@#expression.\r\n\r\n^Array\twith: ws\r\n\twith: keywordPattern / binaryPattern / unaryPattern @@#header\r\n\twith: sequence optional @@#body","(\r\nfunction(self)\r\nlocal expression=nil\r\nlocal separator=nil\r\nlocal comment=nil\r\nlocal ws=nil\r\nlocal identifier=nil\r\nlocal keyword=nil\r\nlocal stSelectorPart=nil\r\nlocal string=nil\r\nlocal symbol=nil\r\nlocal number=nil\r\nlocal variable=nil\r\nlocal reference=nil\r\nlocal globalReference=nil\r\nlocal literal=nil\r\nlocal returnExpression=nil\r\nlocal expressionParser=nil\r\nlocal keyword=nil\r\nlocal unarySelector=nil\r\nlocal binarySelector=nil\r\nlocal keywordPattern=nil\r\nlocal unaryPattern=nil\r\nlocal binaryPattern=nil\r\nlocal assignment=nil\r\nlocal temps=nil\r\nlocal blockParamList=nil\r\nlocal block=nil\r\nlocal expression=nil\r\nlocal expressions=nil\r\nlocal subexpression=nil\r\nlocal statements=nil\r\nlocal sequence=nil\r\nlocal operand=nil\r\nlocal unaryMessage=nil\r\nlocal unarySend=nil\r\nlocal unaryTail=nil\r\nlocal binaryMessage=nil\r\nlocal binarySend=nil\r\nlocal binaryTail=nil\r\nlocal keywordMessage=nil\r\nlocal keywordSend=nil\r\nlocal keywordPair=nil\r\nlocal cascade=nil\r\nlocal message=nil\r\nlocal inline=nil\r\nlocal jsIndex=nil\r\nlocal character=nil\r\nlocal directive=nil\r\nlocal arrayLiteral=nil\r\nlocal arrayVariable=nil\r\nlocal literalArray=nil\r\nlocal aSymbol=nil\r\nlocal stIdentifier=nil\r\nlocal jsIdentifier=nil\r\nlocal noReference=nil\r\nlocal alienReference=nil\r\nlocal alienIdentifier=nil\r\nlocal emptyArray=nil\r\nlocal hashedString=nil\r\nlocal annotation=nil\r\nlocal argument=nil\r\n(function()\r\n\tlocal _s8_value=((self):separator())\r\n\tseparator=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):comment())\r\n\tcomment=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((((separator):_slash(comment)):_at_at(\"sp\")):star()):_at_at(\"ws\"))\r\n\tws=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((self),\"'\")),(smalltalk.PPStStringParser):new())):_at_at(\"string\")):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.ValueNode):with_((node):second()))\r\nend)))\r\n\tstring=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((self),smalltalk:object_comma_((\"#\"),\"'\"))),(smalltalk.PPStStringParser):new())):_at_at(\"hashedString\")):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.ValueNode):with_((node):second()))\r\nend)))\r\n\thashedString=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((smalltalk:object_comma_(((self):nameStart()),((self):symbolCharParser()):star())):_at_at(\"stId\")):flatten()):_at_at(\"stIdentifier\"))\r\n\tstIdentifier=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((smalltalk:object_comma_(((self):upNameStart()),((self):symbolCharParser()):star())):_at_at(\"stSel\")):flatten()):_at_at(\"stSelectorPart\"))\r\n\tstSelectorPart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((smalltalk:object_comma_((smalltalk:object_comma_((self),\"#\")),((self):jsSymbolCharParser()):plus())):_at_at(\"jsId\")):flatten()):_at_at(\"jsIdentifier\"))\r\n\tjsIdentifier=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((((self):jsSymbolCharParser()):plus()):flatten()):_at_at(\"alienIdentifier\"))\r\n\talienIdentifier=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((jsIdentifier):_slash(stIdentifier)):_at_at(\"identifier\"))\r\n\tidentifier=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_(((stSelectorPart):_slash(identifier)),\":\")):flatten()):_at_at(\"keyword\"))\r\n\tkeyword=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_(((self):annotationStart()),((string):_slash(stIdentifier)):_slash((self):globalNameParser()))):_at_at(\"annotation\")):_eq_eq_gt((function(node)\r\nreturn ((node):last())\r\nend)))\r\n\tannotation=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk:object_comma_((identifier),(annotation):star())):_eq_eq_gt((function(node)\r\nreturn (((smalltalk.ValueNode):with_((node):first())):annotations_((node):last()))\r\nend)))\r\n\targument=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((self),\"#\")),(((self):extendedSymbolCharParser()):plus()):flatten())):_at_at(\"symbol\")):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.ValueNode):with_((node):second()))\r\nend)))\r\n\tsymbol=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((self):number()):flatten()):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.ValueNode):with_((node):asNumber()))\r\nend)))\r\n\tnumber=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((self),\"$\")),(smalltalk.PPAnyParser):new())):_at_at(\"character\")):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.ValueNode):with_((node):at_(2)))\r\nend)))\r\n\tcharacter=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):directive_ws_(number,ws))\r\n\tdirective=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((identifier):_eq_eq_gt((function(token)\r\nreturn (((smalltalk.VariableNode):new()):value_(token))\r\nend)))\r\n\tvariable=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((self),\"#\")):_at_at(\"noReference\")):_eq_eq_gt((function(token)\r\nreturn ((smalltalk.NoReceiverNode):new())\r\nend)))\r\n\tnoReference=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.PPDelegateParser):new()):_at_at(\"literalDelegate\"))\r\n\tliteral=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.PPDelegateParser):new()):_at_at(\"expressionDelegate\"))\r\n\texpression=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((((smalltalk:object_comma_((self),\"true\")):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.ValueNode):with_(true))\r\nend))):_slash((smalltalk:object_comma_((self),\"false\")):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.ValueNode):with_(false))\r\nend)))):_slash((smalltalk:object_comma_((self),\"nil\")):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.ValueNode):with_(nil))\r\nend)))):_at_at(\"arrayVariable\"))\r\n\tarrayVariable=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((((self):extendedSymbolCharParser()):plus()):flatten()):_at_at(\"aSymbol\")):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.ValueNode):with_(node))\r\nend)))\r\n\taSymbol=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((literal):_slash(arrayVariable)):_slash(aSymbol)):_slash(variable))\r\n\tarrayLiteral=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_(((self):gc_(\"#(\")),(smalltalk:object_comma_((smalltalk:object_comma_((ws),arrayLiteral)),ws)):star())),\")\")):_at_at(\"literalArray\")):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.ValueNode):with_((smalltalk.Array):withAll_(((node):second()):collect_((function(each)\r\nreturn (((each):second()):value())\r\nend)))))\r\nend)))\r\n\tliteralArray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((self),\"#(\")),ws)),\")\")):_at_at(\"emptyArray\")):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.ValueNode):with_((smalltalk.Array):new()))\r\nend)))\r\n\temptyArray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((self):globalNameParser()):_at_at(\"globalReference\")):_eq_eq_gt((function(token)\r\n(self):gc();return (((smalltalk.GlobalReferenceNode):new()):value_(token))\r\nend)))\r\n\tglobalReference=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((self),smalltalk:object_comma_((\"#\"),\"{\"))),alienIdentifier)),\"}\")):_at_at(\"alienReference\")):_eq_eq_gt((function(node)\r\nreturn (((smalltalk.AlienNode):new()):value_((node):second()))\r\nend)))\r\n\talienReference=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk:object_comma_((smalltalk:object_comma_(((self):gc_(\"[\")),expression)),\"]\")):_slash(smalltalk:object_comma_((smalltalk:object_comma_((self),\"#\")),alienIdentifier)))\r\n\tjsIndex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_(((((variable):_slash(globalReference)):_slash(alienReference)):_at_at(\"ref\")),(jsIndex):star())),(annotation):star())):_at_at(\"reference\")):_eq_eq_gt((function(nodes)\r\nreturn (((nodes):first()):reference_(nodes))\r\nend)))\r\n\treference=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_(((self):optional_(\"#\")),((self):binaryCharParser()):plus())):flatten()):_at_at(\"binarySelector\"))\r\n\tbinarySelector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((stSelectorPart):_slash(identifier)):_at_at(\"unarySelector\"))\r\n\tunarySelector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((((smalltalk:object_comma_((smalltalk:object_comma_(((smalltalk:object_comma_((ws),keyword)):_at_at(\"kw\")),ws)),argument)):_at_at(\"kwId\")):plus()):_at_at(\"keywordPattern\")):_eq_eq_gt((function(nodes)\r\nreturn ((smalltalk.Array):with_with_(((nodes):collect_((function(each)\r\nreturn ((each):at_(2))\r\nend))):join_(\"\"),(nodes):collect_((function(each)\r\nreturn ((each):at_(4))\r\nend))))\r\nend)))\r\n\tkeywordPattern=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((ws),binarySelector)),ws)),argument)):_at_at(\"binaryPattern\")):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.Array):with_with_((node):second(),(smalltalk.Array):with_((node):fourth())))\r\nend)))\r\n\tbinaryPattern=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((ws),unarySelector)):_at_at(\"unaryPattern\")):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.Array):with_with_((node):second(),(smalltalk.Array):new()))\r\nend)))\r\n\tunaryPattern=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((expression),(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((ws),\".\")),ws)),expression)):_at_at(\"anExpression\")):_eq_eq_gt((function(node)\r\nreturn ((node):fourth())\r\nend))):star())):_at_at(\"expressions\")):_eq_eq_gt((function(node)\r\nreturn (smalltalk:object_comma_(((smalltalk.Array):with_((node):first())),(node):second()))\r\nend)))\r\n\texpressions=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((reference),ws)),\":=\")),ws)),expression)):_at_at(\"assignment\")):_eq_eq_gt((function(node)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):left_((node):first());\r\n\treturn ((_s8_rec):right_((node):at_(5)))\r\nend\r\n)((smalltalk.AssignmentNode):new()))\r\nend)))\r\n\tassignment=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((((self):gc_(\"^\")):_at_at(\"caret\")),ws)),expression)),(annotation):star())),ws)),((\".\"):asParser()):optional())):_at_at(\"returnExpression\")):_eq_eq_gt((function(node)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addNode_((node):at_(3));\r\n\t(_s8_rec):annotations_((node):at_(4));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.ReturnNode):new()))\r\nend)))\r\n\treturnExpression=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((self),\"|\")),(smalltalk:object_comma_((ws),argument)):star())),ws)),\"|\")):_at_at(\"temps\")):_eq_eq_gt((function(node)\r\nreturn (((node):second()):collect_((function(each)\r\nreturn ((each):second())\r\nend)))\r\nend)))\r\n\ttemps=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((self),\":\")),ws)),argument)),ws)):plus()),\"|\")):_at_at(\"blockParamList\")):_eq_eq_gt((function(node)\r\nreturn (((node):first()):collect_((function(each)\r\nreturn ((each):third())\r\nend)))\r\nend)))\r\n\tblockParamList=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):gc_(\"(\")),ws)),expression)),ws)),\")\")):_at_at(\"subexpression\")):_eq_eq_gt((function(node)\r\nreturn ((node):third())\r\nend)))\r\n\tsubexpression=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((((returnExpression):_at_at(\"stat1\")):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.Array):with_(node))\r\nend))):_slash(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((expressions),ws)),\".\")),ws)),returnExpression)):_at_at(\"stat2\")):_eq_eq_gt((function(node)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_((node):at_(5));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((node):first()))\r\nend)))):_slash(((smalltalk:object_comma_((expressions),(self):optional_(\".\"))):_at_at(\"stat3\")):_eq_eq_gt((function(node)\r\nreturn ((node):first())\r\nend))))\r\n\tstatements=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((((temps):optional()):_at_at(\"temps\")),ws)),(directive):star())),ws)),(statements):optional())),ws)):_at_at(\"sequence\")):_eq_eq_gt((function(node)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):temps_((node):first());\r\n\t(_s8_rec):directives_((node):third());\r\n\t(_s8_rec):nodes_((node):at_(5));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.ExtendedSequenceNode):new()))\r\nend)))\r\n\tsequence=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):gc_(\"[\")),ws)),(blockParamList):optional())),ws)),(sequence):optional())),ws)),\"]\")):_at_at(\"block\")):_eq_eq_gt((function(node)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):parameters_((node):third());\r\n\treturn ((_s8_rec):addNode_(((node):at_(5)):asBlockSequenceNode()))\r\nend\r\n)((smalltalk.BlockNode):new()))\r\nend)))\r\n\tblock=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((((block):_slash(literal)):_slash(reference)):_slash(noReference)):_slash(subexpression)):_at_at(\"operand\"))\r\n\toperand=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(literal):parser_((((((((symbol):_slash(number)):_slash(string)):_slash(character)):_slash(emptyArray)):_slash(literalArray)):_slash(hashedString)):_at_at(\"literalDelegate\"));\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((ws),unarySelector)),smalltalk:booleanNot_((smalltalk:object_comma_((self),\":\"))))):_at_at(\"unaryMessage\")):_eq_eq_gt((function(node)\r\nreturn (((smalltalk.SendNode):new()):selector_((node):second()))\r\nend)))\r\n\tunaryMessage=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.PPDelegateParser):new()):_at_at(\"unaryTailDelegate\"))\r\n\tunaryTail=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(unaryTail):parser_(((smalltalk:object_comma_((unaryMessage),(unaryTail):optional())):_at_at(\"unaryTailDelegate\")):_eq_eq_gt((function(node)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_(((node):second()))),(function()\r\nreturn ((node):first())\r\nend),(function()\r\nreturn (((node):second()):valueForReceiver_((node):first()))\r\nend)))\r\nend)));\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((operand),(unaryTail):optional())):_at_at(\"unarySend\")):_eq_eq_gt((function(node)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_(((node):second()))),(function()\r\nreturn ((node):first())\r\nend),(function()\r\nreturn (((node):second()):valueForReceiver_((node):first()))\r\nend)))\r\nend)))\r\n\tunarySend=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((ws),binarySelector)),ws)),(unarySend):_slash(operand))):_at_at(\"binaryMessage\")):_eq_eq_gt((function(node)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):selector_((node):second());\r\n\treturn ((_s8_rec):arguments_((smalltalk.Array):with_((node):fourth())))\r\nend\r\n)((smalltalk.SendNode):new()))\r\nend)))\r\n\tbinaryMessage=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.PPDelegateParser):new()):_at_at(\"binaryTailDelegate\"))\r\n\tbinaryTail=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(binaryTail):parser_((smalltalk:object_comma_((binaryMessage),(binaryTail):optional())):_eq_eq_gt((function(node)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_(((node):second()))),(function()\r\nreturn ((node):first())\r\nend),(function()\r\nreturn (((node):second()):valueForReceiver_((node):first()))\r\nend)))\r\nend)));\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((unarySend),(binaryTail):optional())):_at_at(\"binarySend\")):_eq_eq_gt((function(node)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_(((node):second()))),(function()\r\nreturn ((node):first())\r\nend),(function()\r\nreturn (((node):second()):valueForReceiver_((node):first()))\r\nend)))\r\nend)))\r\n\tbinarySend=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk:object_comma_((smalltalk:object_comma_((keyword),ws)),binarySend)):_at_at(\"keywordPair\"))\r\n\tkeywordPair=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((smalltalk:object_comma_((ws),keywordPair)):plus()):_at_at(\"keywordMessage\")):_eq_eq_gt((function(nodes)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):selector_(((nodes):collect_((function(each)\r\nreturn (((each):second()):first())\r\nend))):join_(\"\"));\r\n\treturn ((_s8_rec):arguments_((nodes):collect_((function(each)\r\nreturn (((each):second()):third())\r\nend))))\r\nend\r\n)((smalltalk.SendNode):new()))\r\nend)))\r\n\tkeywordMessage=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((binarySend),keywordMessage)):_at_at(\"keywordSend\")):_eq_eq_gt((function(node)\r\nreturn (((node):second()):valueForReceiver_((node):first()))\r\nend)))\r\n\tkeywordSend=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((binaryMessage):_slash(unaryMessage)):_slash(keywordMessage)):_at_at(\"message\"))\r\n\tmessage=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((((keywordSend):_slash(binarySend)):_at_at(\"head\")),(smalltalk:object_comma_((smalltalk:object_comma_((ws),\";\")),message)):plus())):_at_at(\"cascade\")):_eq_eq_gt((function(node)\r\nreturn (((node):first()):cascadeNodeWithMessages_(((node):second()):collect_((function(each)\r\nreturn ((each):third())\r\nend))))\r\nend)))\r\n\tcascade=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((self),\"{\")),(smalltalk:object_comma_((smalltalk:object_comma_(((stIdentifier):optional()),string)),ws)):plus())),\"}\")):_at_at(\"inline\")):_eq_eq_gt((function(node)\r\nreturn ((smalltalk.InlineNode):sources_parser_((node):second(),smalltalk:object_comma_((ws),(sequence):optional())))\r\nend)))\r\n\tinline=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(expression):parser_((((((assignment):_slash(cascade)):_slash(keywordSend)):_slash(binarySend)):_slash(inline)):_at_at(\"expression\"));\r\nreturn ((smalltalk.Array):with_with_with_(ws,(((keywordPattern):_slash(binaryPattern)):_slash(unaryPattern)):_at_at(\"header\"),((sequence):optional()):_at_at(\"body\")));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"parser",0
,(
function(self)
local parts=nil
local ws=nil
local header=nil
local body=nil
local method=nil
(function()
	local _s8_value=((self):methodParserParts())
	parts=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((parts):first())
	ws=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((parts):second())
	header=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((parts):third())
	body=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((ws),header)),ws)),body)),ws)):_at_at("impl")):withSource()):_eq_eq_gt((function(node)
return ((
function(_s8_rec)
	(_s8_rec):selector_((((node):first()):second()):first());
	(_s8_rec):arguments_((((node):first()):second()):second());
	(_s8_rec):addNode_((((node):first()):fourth()):shouldReturn());
	(_s8_rec):source_((node):second());
	return ((_s8_rec):yourself())
end
)((smalltalk.MethodNode):new()))
end)))
	method=_s8_value
	return _s8_value
end)();
(self):gc();
return (((smalltalk:object_comma_((method),(smalltalk.PPEOFParser):new())):_at_at("method")):_eq_eq_gt((function(nodes)
return ((nodes):first())
end)));
end
)
,"parsers","parser\r\n\t\" Return the method parser. \"\r\n\r\n\t| parts ws header body method |\r\n\tparts := self methodParserParts.\r\n\tws := parts first.\r\n\theader := parts second.\r\n\tbody := parts third.\r\n\r\n\tmethod := (ws ,header\r\n\t\t,ws ,body\r\n\t\t,ws @@#impl) withSource\r\n\t  ==> [:node | MethodNode new\r\n\t\tselector: node first second first;\r\n\t\targuments: node first second second;\r\n\t\taddNode: node first fourth shouldReturn;\r\n\t\tsource: node second;\r\n\t\tyourself ].\r\n \r\n\tself gc.\r\n \t^method ,PPEOFParser new @@#method\r\n\t   ==> [:nodes | nodes first ]","(\r\nfunction(self)\r\nlocal parts=nil\r\nlocal ws=nil\r\nlocal header=nil\r\nlocal body=nil\r\nlocal method=nil\r\n(function()\r\n\tlocal _s8_value=((self):methodParserParts())\r\n\tparts=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((parts):first())\r\n\tws=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((parts):second())\r\n\theader=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((parts):third())\r\n\tbody=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((ws),header)),ws)),body)),ws)):_at_at(\"impl\")):withSource()):_eq_eq_gt((function(node)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):selector_((((node):first()):second()):first());\r\n\t(_s8_rec):arguments_((((node):first()):second()):second());\r\n\t(_s8_rec):addNode_((((node):first()):fourth()):shouldReturn());\r\n\t(_s8_rec):source_((node):second());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.MethodNode):new()))\r\nend)))\r\n\tmethod=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):gc();\r\nreturn (((smalltalk:object_comma_((method),(smalltalk.PPEOFParser):new())):_at_at(\"method\")):_eq_eq_gt((function(nodes)\r\nreturn ((nodes):first())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SmalltalkParser,"methodHeaderParser",0
,(
function(self)
local parts=nil
local ws=nil
local header=nil
(function()
	local _s8_value=((self):methodParserParts())
	parts=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((parts):first())
	ws=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((parts):second())
	header=_s8_value
	return _s8_value
end)();
return (((smalltalk:object_comma_((ws),header)):_at_at("methodHeader")):_eq_eq_gt((function(nodes)
return ((nodes):second())
end)));
end
)
,"parsers","methodHeaderParser\r\n\t\" Return a parser for method header. \"\r\n\r\n\t| parts ws header |\r\n\tparts := self methodParserParts.\r\n\tws := parts first.\r\n\theader := parts second.\r\n\t^ws ,header @@#methodHeader\r\n\t\t==> [:nodes| nodes second ]","(\r\nfunction(self)\r\nlocal parts=nil\r\nlocal ws=nil\r\nlocal header=nil\r\n(function()\r\n\tlocal _s8_value=((self):methodParserParts())\r\n\tparts=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((parts):first())\r\n\tws=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((parts):second())\r\n\theader=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((smalltalk:object_comma_((ws),header)):_at_at(\"methodHeader\")):_eq_eq_gt((function(nodes)\r\nreturn ((nodes):second())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter["$klass"],"constructEventsTriggered",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:newArray({"isBehavior:", "needsClasses", "needsRoots", "needsEncoderFor:"})),smalltalk:superImplementor(smalltalk.Exporter["$klass"],"constructEventsTriggered")(self)));
end
)
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^#(\t#isBehavior:\r\n\t\t#needsClasses #needsRoots\r\n\t\t#needsEncoderFor:\r\n\t) ,super constructEventsTriggered","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:newArray({\"isBehavior:\", \"needsClasses\", \"needsRoots\", \"needsEncoderFor:\"})),smalltalk:superImplementor(smalltalk.Exporter[\"$klass\"],\"constructEventsTriggered\")(self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter["$klass"],"fileOutCategories:",0
,(
function(self,categories)
return (((self):new()):fileOutCategories_(categories));
end
)
,"fileOut","fileOutCategories: categories\r\n\t\" Return the result of fileOut all the classes in categories. \"\r\n\r\n\t^self new fileOutCategories: categories","(\r\nfunction(self,categories)\r\nreturn (((self):new()):fileOutCategories_(categories));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter["$klass"],"fileOutCategory:",0
,(
function(self,aString)
return (((self):new()):fileOutCategory_(aString));
end
)
,"fileOut","fileOutCategory: aString\r\n\t\" Return the result of fileOut all the classes in category aString. \"\r\n\r\n\t^self new fileOutCategory: aString","(\r\nfunction(self,aString)\r\nreturn (((self):new()):fileOutCategory_(aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter["$klass"],"fileOutAll:",0
,(
function(self,elements)
return (((self):new()):fileOutAll_(elements));
end
)
,"fileOut","fileOutAll: elements\r\n\t\" Return the result of fileOut elements (classes, methods and/or categories). \"\r\n\r\n\t^self new fileOutAll: elements","(\r\nfunction(self,elements)\r\nreturn (((self):new()):fileOutAll_(elements));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter["$klass"],"fileOutAll",0
,(
function(self)
return (((self):new()):fileOutAll());
end
)
,"fileOut","fileOutAll\r\n\t\" Return the result of fileOut of all classes in the system. \"\r\n\r\n\t^self new fileOutAll ","(\r\nfunction(self)\r\nreturn (((self):new()):fileOutAll());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter["$klass"],"fileOut:",0
,(
function(self,spec)
return (((self):new()):fileOutSpec_(spec));
end
)
,"fileOut","fileOut: spec\r\n\t\" Return the result of fileOut of literals in spec. \"\r\n\r\n\t^self new fileOutSpec: spec","(\r\nfunction(self,spec)\r\nreturn (((self):new()):fileOutSpec_(spec));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter["$klass"],"exportCategories:",0
,(
function(self,categories)
return (((self):new()):exportCategories_(categories));
end
)
,"export","exportCategories: categories\r\n\t\" Return the result of exporting all the classes in categories. \"\r\n\r\n\t^self new exportCategories: categories","(\r\nfunction(self,categories)\r\nreturn (((self):new()):exportCategories_(categories));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter["$klass"],"exportCategory:",0
,(
function(self,aString)
return (((self):new()):exportCategory_(aString));
end
)
,"export","exportCategory: aString\r\n\t\" Return the result of exporting all the classes in category aString. \"\r\n\r\n\t^self new exportCategory: aString","(\r\nfunction(self,aString)\r\nreturn (((self):new()):exportCategory_(aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter["$klass"],"export:",0
,(
function(self,spec)
return (((self):new()):exportSpec_(spec));
end
)
,"export","export: spec\r\n\t\" Return the result of exporting literals in spec. \"\r\n\r\n\t^self new exportSpec: spec","(\r\nfunction(self,spec)\r\nreturn (((self):new()):exportSpec_(spec));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter["$klass"],"exportAll",0
,(
function(self)
return (((self):new()):exportAll());
end
)
,"export","exportAll\r\n\t\" Return the result of exporting all classes in the system. \"\r\n\r\n\t^self new exportAll","(\r\nfunction(self)\r\nreturn (((self):new()):exportAll());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter["$klass"],"exportAll:",0
,(
function(self,elements)
return (((self):new()):exportAll_(elements));
end
)
,"export","exportAll: elements\r\n\t\" Return the result of exporting all elements (classes, methods and/or categories). \"\r\n\r\n\t^self new exportAll: elements","(\r\nfunction(self,elements)\r\nreturn (((self):new()):exportAll_(elements));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter["$klass"],"allClasses",0
,(
function(self)
return (((self):new()):allClasses());
end
)
,"accessing","allClasses\r\n\t\" OBSOLETE, Private - Return all the classes in the system (in fileIn order). \"\r\n\r\n\t^self new allClasses","(\r\nfunction(self)\r\nreturn (((self):new()):allClasses());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"encoder:",0
,(
function(self,anEncoder)
(function()
	local _s8_value=(anEncoder)
	self["@encoder"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","encoder: anEncoder\r\n\t\" Set the encoder of the receiver. \"\r\n\r\n\tencoder := anEncoder","(\r\nfunction(self,anEncoder)\r\n(function()\r\n\tlocal _s8_value=(anEncoder)\r\n\tself[\"@encoder\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"setEncoderFor:",0
,(
function(self,aClass)
local anEncoder=nil
(function()
	local _s8_value=((self):triggerEvent_with_ifNotHandled_("needsEncoderFor:",aClass,(function()
return (((aClass):compiler()):encoder())
end)))
	anEncoder=_s8_value
	return _s8_value
end)();
(self):encoder_(anEncoder);
return (self);
end
)
,"accessing","setEncoderFor: aClass\r\n\t\" Set the encoder of the receiver to emmit code for aClass. \"\r\n\r\n\t| anEncoder |\r\n\tanEncoder := self triggerEvent: #needsEncoderFor: with: aClass ifNotHandled: [\r\n\t\taClass compiler encoder\r\n\t].\r\n\tself encoder: anEncoder ","(\r\nfunction(self,aClass)\r\nlocal anEncoder=nil\r\n(function()\r\n\tlocal _s8_value=((self):triggerEvent_with_ifNotHandled_(\"needsEncoderFor:\",aClass,(function()\r\nreturn (((aClass):compiler()):encoder())\r\nend)))\r\n\tanEncoder=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):encoder_(anEncoder);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"encoderFor:",0
,(
function(self,aClass)
if (smalltalk:isNil_((self["@encoder"])))==true then (self):setEncoderFor_(aClass); end;
return (self["@encoder"]);
end
)
,"accessing","encoderFor: aClass\r\n\t\" Return the encoder of the receiver.\r\n\tIf the encoder is nil, use the default encoder for aClass.\r\n\t\"\r\n\r\n\tencoder isNil ifTrue: [ self setEncoderFor: aClass ].\r\n\t^encoder","(\r\nfunction(self,aClass)\r\nif (smalltalk:isNil_((self[\"@encoder\"])))==true then (self):setEncoderFor_(aClass); end;\r\nreturn (self[\"@encoder\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"encoder",0
,(
function(self)
if (smalltalk:isNil_((self["@encoder"])))==true then (self):setEncoderFor_(smalltalk.Object); end;
return (self["@encoder"]);
end
)
,"accessing","encoder\r\n\t\" Return the encoder of the receiver. \"\r\n\r\n\tencoder isNil ifTrue: [ self setEncoderFor: Object ].\r\n\t^encoder","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@encoder\"])))==true then (self):setEncoderFor_(smalltalk.Object); end;\r\nreturn (self[\"@encoder\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutAll",0
,(
function(self)
return ((self):fileOutAll_((self):allClasses()));
end
)
,"fileOut","fileOutAll\r\n\t\" Return the result of fileOut of all classes in the system. \"\r\n\r\n\t^self fileOutAll: self allClasses","(\r\nfunction(self)\r\nreturn ((self):fileOutAll_((self):allClasses()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"isBehavior:",0
,(
function(self,anObject)
return ((self):triggerEvent_with_ifNotHandled_("isBehavior:",anObject,(function()
return (smalltalk:boolean_or_((smalltalk:is_kindOf_((anObject),(smalltalk.Behavior))),(function()
return ((anObject):isClass())
end)))
end)));
end
)
,"testing","isBehavior: anObject\r\n\t\" Private - Return true if anObject is a Behavior. \"\r\n\r\n\t^self triggerEvent: #isBehavior: with: anObject ifNotHandled: [\r\n\t\t(anObject isKindOf: Behavior) or: [ anObject isClass ]\r\n\t]","(\r\nfunction(self,anObject)\r\nreturn ((self):triggerEvent_with_ifNotHandled_(\"isBehavior:\",anObject,(function()\r\nreturn (smalltalk:boolean_or_((smalltalk:is_kindOf_((anObject),(smalltalk.Behavior))),(function()\r\nreturn ((anObject):isClass())\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutCollection:",0
,(
function(self,array)
local cr=nil
(function()
	local _s8_value=("\r\n")
	cr=_s8_value
	return _s8_value
end)();
return (((array):inject_into_(smalltalk:newArray({}),(function(total,each)
return ((
function(_s8_rec)
	(_s8_rec):add_(cr);
	(_s8_rec):add_((self):fileOutSpec_(each));
	return ((_s8_rec):yourself())
end
)(total))
end))):join_(""));
end
)
,"fileOut","fileOutCollection: array\r\n\t\" Return the result of fileOut of array contents. \"\r\n\r\n\t| cr |\r\n\tcr := '\r\n'.\t^(array inject: #() into: [:total :each|\r\n\t\ttotal add: cr; add: (self fileOutSpec: each); yourself\r\n\t\t]) join: ''","(\r\nfunction(self,array)\r\nlocal cr=nil\r\n(function()\r\n\tlocal _s8_value=(\"\\r\\n\")\r\n\tcr=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((array):inject_into_(smalltalk:newArray({}),(function(total,each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(cr);\r\n\t(_s8_rec):add_((self):fileOutSpec_(each));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(total))\r\nend))):join_(\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutSpec:",0
,(
function(self,spec)
local aName=nil
if (smalltalk:isNil_((spec)))==true then return (""); end;
if not (((spec):isString()))==true then if ((self):isBehavior_(spec))==true then return ((self):fileOut_(spec)); end;
return ((self):fileOutCollection_(spec)); end;
if ((spec):includes_(","))==true then return ((self):fileOutSpec_((spec):asArrayOfSubstringsSeparatedBy_(","))); end;
if ((spec):includes_(" "))==true then return ((self):fileOutSpec_((spec):asArrayOfSubstringsSeparatedBy_(" "))); end;
(function()
	local _s8_value=((spec):trimBlanks())
	aName=_s8_value
	return _s8_value
end)();
if ((smalltalk.Smalltalk):includesKey_(aName))==true then return ((self):fileOutSpec_((smalltalk.Smalltalk):at_(aName))); end;
return ((self):fileOutCategories_(aName));
end
)
,"fileOut","fileOutSpec: spec\r\n\t\" Return the result of fileOut of literals in spec. \"\r\n\r\n\t| aName |\r\n\tspec isNil ifTrue: [ ^'' ].\r\n\tspec isString ifFalse: [\r\n\t\t(self isBehavior: spec) ifTrue: [ ^self fileOut: spec ].\r\n\t\t^self fileOutCollection: spec\r\n\t].\r\n\t(spec includes: $,) ifTrue: [ ^self fileOutSpec: (spec asArrayOfSubstringsSeparatedBy: $,) ].\r\n\t(spec includes: $ ) ifTrue: [ ^self fileOutSpec: (spec asArrayOfSubstringsSeparatedBy: $ ) ].\r\n\taName := spec trimBlanks.\r\n\t(Smalltalk includesKey: aName) ifTrue: [ ^self fileOutSpec: (Smalltalk at: aName) ].\r\n\t^self fileOutCategories: aName","(\r\nfunction(self,spec)\r\nlocal aName=nil\r\nif (smalltalk:isNil_((spec)))==true then return (\"\"); end;\r\nif not (((spec):isString()))==true then if ((self):isBehavior_(spec))==true then return ((self):fileOut_(spec)); end;\r\nreturn ((self):fileOutCollection_(spec)); end;\r\nif ((spec):includes_(\",\"))==true then return ((self):fileOutSpec_((spec):asArrayOfSubstringsSeparatedBy_(\",\"))); end;\r\nif ((spec):includes_(\" \"))==true then return ((self):fileOutSpec_((spec):asArrayOfSubstringsSeparatedBy_(\" \"))); end;\r\n(function()\r\n\tlocal _s8_value=((spec):trimBlanks())\r\n\taName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((smalltalk.Smalltalk):includesKey_(aName))==true then return ((self):fileOutSpec_((smalltalk.Smalltalk):at_(aName))); end;\r\nreturn ((self):fileOutCategories_(aName));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportCollection:",0
,(
function(self,array)
local cr=nil
(function()
	local _s8_value=("\r\n")
	cr=_s8_value
	return _s8_value
end)();
return (((array):inject_into_(smalltalk:newArray({}),(function(total,each)
return ((
function(_s8_rec)
	(_s8_rec):add_(cr);
	(_s8_rec):add_((self):exportSpec_(each));
	return ((_s8_rec):yourself())
end
)(total))
end))):join_(""));
end
)
,"export","exportCollection: array\r\n\t\" Return the result of exporting array contents. \"\r\n\r\n\t| cr |\r\n\tcr := '\r\n'.\t^(array inject: #() into: [:total :each|\r\n\t\ttotal add: cr; add: (self exportSpec: each); yourself\r\n\t\t]) join: ''","(\r\nfunction(self,array)\r\nlocal cr=nil\r\n(function()\r\n\tlocal _s8_value=(\"\\r\\n\")\r\n\tcr=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((array):inject_into_(smalltalk:newArray({}),(function(total,each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(cr);\r\n\t(_s8_rec):add_((self):exportSpec_(each));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(total))\r\nend))):join_(\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportSpec:",0
,(
function(self,spec)
local aName=nil
if (smalltalk:isNil_((spec)))==true then return (""); end;
if not (((spec):isString()))==true then if ((self):isBehavior_(spec))==true then return ((self):export_(spec)); end;
return ((self):exportCollection_(spec)); end;
if ((spec):includes_(","))==true then return ((self):exportSpec_((spec):asArrayOfSubstringsSeparatedBy_(","))); end;
if ((spec):includes_(" "))==true then return ((self):exportSpec_((spec):asArrayOfSubstringsSeparatedBy_(" "))); end;
(function()
	local _s8_value=((spec):trimBlanks())
	aName=_s8_value
	return _s8_value
end)();
if ((smalltalk.Smalltalk):includesKey_(aName))==true then return ((self):export_((smalltalk.Smalltalk):at_(aName))); end;
return ((self):exportCategories_(aName));
end
)
,"export","exportSpec: spec\r\n\t\" Return the result of exporting literals in spec. \"\r\n\r\n\t| aName |\r\n\tspec isNil ifTrue: [ ^'' ].\r\n\tspec isString ifFalse: [\r\n\t\t(self isBehavior: spec) ifTrue: [ ^self export: spec ].\r\n\t\t^self exportCollection: spec\r\n\t].\r\n\t(spec includes: $,) ifTrue: [ ^self exportSpec: (spec asArrayOfSubstringsSeparatedBy: $,) ].\r\n\t(spec includes: $ ) ifTrue: [ ^self exportSpec: (spec asArrayOfSubstringsSeparatedBy: $ ) ].\r\n\taName := spec trimBlanks.\r\n\t(Smalltalk includesKey: aName) ifTrue: [ ^self export: (Smalltalk at: aName) ].\r\n\t^self exportCategories: aName","(\r\nfunction(self,spec)\r\nlocal aName=nil\r\nif (smalltalk:isNil_((spec)))==true then return (\"\"); end;\r\nif not (((spec):isString()))==true then if ((self):isBehavior_(spec))==true then return ((self):export_(spec)); end;\r\nreturn ((self):exportCollection_(spec)); end;\r\nif ((spec):includes_(\",\"))==true then return ((self):exportSpec_((spec):asArrayOfSubstringsSeparatedBy_(\",\"))); end;\r\nif ((spec):includes_(\" \"))==true then return ((self):exportSpec_((spec):asArrayOfSubstringsSeparatedBy_(\" \"))); end;\r\n(function()\r\n\tlocal _s8_value=((spec):trimBlanks())\r\n\taName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((smalltalk.Smalltalk):includesKey_(aName))==true then return ((self):export_((smalltalk.Smalltalk):at_(aName))); end;\r\nreturn ((self):exportCategories_(aName));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"rootClasses",0
,(
function(self)
return ((self):triggerEvent_ifNotHandled_("needsRoots",(function()
return ((smalltalk.Smalltalk):rootClasses())
end)));
end
)
,"accessing","rootClasses\r\n\t\" Private - Return all the root classes in the system (in fileIn order). \"\r\n\r\n\t^self triggerEvent: #needsRoots ifNotHandled: [\r\n\t\tSmalltalk rootClasses\r\n\t]","(\r\nfunction(self)\r\nreturn ((self):triggerEvent_ifNotHandled_(\"needsRoots\",(function()\r\nreturn ((smalltalk.Smalltalk):rootClasses())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"allClasses",0
,(
function(self)
return ((self):triggerEvent_ifNotHandled_("needsClasses",(function()
return (((self):rootClasses()):inject_into_(smalltalk:newArray({}),(function(total,each)
return ((
function(_s8_rec)
	(_s8_rec):addAll_((each):withAllSubclasses());
	return ((_s8_rec):yourself())
end
)(total))
end)))
end)));
end
)
,"accessing","allClasses\r\n\t\" Private - Return all the classes in the system (in fileIn order). \"\r\n\r\n\t^self triggerEvent: #needsClasses ifNotHandled: [\r\n\t\tself rootClasses inject: #() into: [:total :each|\r\n\t\t\ttotal addAll: each withAllSubclasses; yourself\r\n\t\t]\r\n\t]","(\r\nfunction(self)\r\nreturn ((self):triggerEvent_ifNotHandled_(\"needsClasses\",(function()\r\nreturn (((self):rootClasses()):inject_into_(smalltalk:newArray({}),(function(total,each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAll_((each):withAllSubclasses());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(total))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"matchCategory:",0
,(
function(self,aString)
return ((self):matchCategory_from_(aString,(smalltalk.Smalltalk):rootClasses()));
end
)
,"categories","matchCategory: aString\r\n\t\" Return the result of filtering all the classes (and orphan methods) in category aString. \"\r\n\r\n\t^self matchCategory: aString from: Smalltalk rootClasses","(\r\nfunction(self,aString)\r\nreturn ((self):matchCategory_from_(aString,(smalltalk.Smalltalk):rootClasses()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"matchCategory:from:",0
,(
function(self,aString,rootClasses)
local selection=nil
local selected=nil
local rejected=nil
local orphanMethods=nil
local fileOutMethods=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	selected=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.Array):new())
	rejected=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.Array):new())
	orphanMethods=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_(((aString):includes_("-")),(function()
return ((function(each)
return (smalltalk:isObject_equalTo_((smalltalk:asString_(((each):category()))),aString))
end))
end),(function()
return ((function(each)
return (smalltalk:isObject_equalTo_(((smalltalk:asString_(((each):category()))):upTo_("-")),aString))
end))
end)))
	selection=_s8_value
	return _s8_value
end)();
(rootClasses):do_((function(root)
return ((((root):instanceClass()):withAllSubclasses()):do_((function(each)
return ((smalltalk:if_true_false_(((selection):value_(each)),(function()
return (selected)
end),(function()
return (rejected)
end))):add_(each))
end)))
end));
(function()
	local _s8_value=((function(cls)
return ((cls):methodsDo_((function(aMethod)
return (smalltalk:if_true_false_(((selection):value_(aMethod)),(function()
return ((orphanMethods):add_(aMethod))
end),nil))
end)))
end))
	fileOutMethods=_s8_value
	return _s8_value
end)();
(rejected):do_((function(each)
return ((
function(_s8_rec)
	(_s8_rec):value_(each);
	return ((_s8_rec):value_((each)["$klass"]))
end
)(fileOutMethods))
end));
return ((smalltalk.Array):with_with_with_(selected,rejected,orphanMethods));
end
)
,"categories","matchCategory: aString from: rootClasses\r\n\t\" Return the result of filtering all the classes (and orphan methods) in category aString. \"\r\n\r\n\t| selection selected rejected orphanMethods fileOutMethods |\r\n\tselected := Array new.\r\n\trejected := Array new.\r\n\torphanMethods := Array new.\r\n\tselection := (aString includes: $-)\r\n\t\tifTrue: [ [:each| each category asString = aString ] ]\r\n\t\tifFalse: [ [:each| (each category asString upTo: $-) = aString ] ].\r\n\trootClasses do: [:root|\r\n\t\troot instanceClass withAllSubclasses do: [:each|\r\n\t\t\t((selection value: each)\r\n\t\t\t\tifTrue: [ selected ] ifFalse: [ rejected ])\r\n\t\t\t\tadd: each\r\n\t\t]\r\n\t].\r\n\tfileOutMethods := [:cls|\r\n\t\tcls methodsDo: [:aMethod |\r\n\t\t\t(selection value: aMethod) ifTrue: [ orphanMethods add: aMethod ]\r\n\t\t].\r\n\t].\r\n\trejected do: [:each| fileOutMethods value: each; value: each class ].\r\n\t^Array with: selected with: rejected with: orphanMethods","(\r\nfunction(self,aString,rootClasses)\r\nlocal selection=nil\r\nlocal selected=nil\r\nlocal rejected=nil\r\nlocal orphanMethods=nil\r\nlocal fileOutMethods=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tselected=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\trejected=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\torphanMethods=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((aString):includes_(\"-\")),(function()\r\nreturn ((function(each)\r\nreturn (smalltalk:isObject_equalTo_((smalltalk:asString_(((each):category()))),aString))\r\nend))\r\nend),(function()\r\nreturn ((function(each)\r\nreturn (smalltalk:isObject_equalTo_(((smalltalk:asString_(((each):category()))):upTo_(\"-\")),aString))\r\nend))\r\nend)))\r\n\tselection=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(rootClasses):do_((function(root)\r\nreturn ((((root):instanceClass()):withAllSubclasses()):do_((function(each)\r\nreturn ((smalltalk:if_true_false_(((selection):value_(each)),(function()\r\nreturn (selected)\r\nend),(function()\r\nreturn (rejected)\r\nend))):add_(each))\r\nend)))\r\nend));\r\n(function()\r\n\tlocal _s8_value=((function(cls)\r\nreturn ((cls):methodsDo_((function(aMethod)\r\nreturn (smalltalk:if_true_false_(((selection):value_(aMethod)),(function()\r\nreturn ((orphanMethods):add_(aMethod))\r\nend),nil))\r\nend)))\r\nend))\r\n\tfileOutMethods=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(rejected):do_((function(each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):value_(each);\r\n\treturn ((_s8_rec):value_((each)[\"$klass\"]))\r\nend\r\n)(fileOutMethods))\r\nend));\r\nreturn ((smalltalk.Array):with_with_with_(selected,rejected,orphanMethods));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutCategories:",0
,(
function(self,categories)
if ((categories):isString())==true then return ((self):fileOutCategories_((categories):asArrayOfSubstrings())); end;
return ((((categories):asArray()):inject_into_(smalltalk:newArray({}),(function(total,each)
return ((
function(_s8_rec)
	(_s8_rec):add_((self):fileOutCategory_(each));
	return ((_s8_rec):yourself())
end
)(total))
end))):join_(""));
end
)
,"fileOut","fileOutCategories: categories\r\n\t\" Return the result of fileOut all the classes in categories. \"\r\n\r\n\tcategories isString ifTrue: [ ^self fileOutCategories: categories asArrayOfSubstrings ].\r\n\t^(categories asArray inject: #() into: [:total :each|\r\n\t\ttotal add: (self fileOutCategory: each); yourself\r\n\t]) join: ''","(\r\nfunction(self,categories)\r\nif ((categories):isString())==true then return ((self):fileOutCategories_((categories):asArrayOfSubstrings())); end;\r\nreturn ((((categories):asArray()):inject_into_(smalltalk:newArray({}),(function(total,each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_((self):fileOutCategory_(each));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(total))\r\nend))):join_(\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutCategory:",0
,(
function(self,aString)
local stream=nil
local match=nil
(function()
	local _s8_value=((""):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):matchCategory_(aString))
	match=_s8_value
	return _s8_value
end)();
(self):fileOutAll_on_((match):first(),stream);
(self):fileOutMethods_on_((match):last(),stream);
return ((stream):contents());
end
)
,"fileOut","fileOutCategory: aString\r\n\t\" Return the result of fileOut all the classes in category aString. \"\r\n\r\n\t| stream match |\r\n\tstream := '' writeStream.\r\n\tmatch := self matchCategory: aString.\r\n\tself fileOutAll: match first on: stream.\r\n\tself fileOutMethods: match last on: stream.\r\n\t^stream contents","(\r\nfunction(self,aString)\r\nlocal stream=nil\r\nlocal match=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):matchCategory_(aString))\r\n\tmatch=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):fileOutAll_on_((match):first(),stream);\r\n(self):fileOutMethods_on_((match):last(),stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOut:",0
,(
function(self,aClass)
local stream=nil
(function()
	local _s8_value=((""):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):fileOut_on_(aClass,stream);
return ((stream):contents());
end
)
,"fileOut","fileOut: aClass\r\n\t\" Return fileOut definition and code of a class. \"\r\n\r\n\t| stream |\r\n\tstream := '' writeStream.\r\n\tself fileOut: aClass on: stream.\r\n\t^stream contents","(\r\nfunction(self,aClass)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):fileOut_on_(aClass,stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutClass:",0
,(
function(self,aClass)
return ((self):fileOut_(aClass));
end
)
,"fileOut","fileOutClass: aClass\r\n\t\" Return fileOut definition and code of a class. \"\r\n\r\n\t^self fileOut: aClass","(\r\nfunction(self,aClass)\r\nreturn ((self):fileOut_(aClass));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutAll:",0
,(
function(self,elements)
local stream=nil
(function()
	local _s8_value=((""):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):fileOutAll_on_(elements,stream);
return ((stream):contents());
end
)
,"fileOut","fileOutAll: elements\r\n\t\" Return fileOut definition and code of elements (classes, methods and/or categories). \"\r\n\r\n\t| stream |\r\n\tstream := '' writeStream.\r\n\tself fileOutAll: elements on: stream.\r\n\t^stream contents","(\r\nfunction(self,elements)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):fileOutAll_on_(elements,stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutMethod:of:",0
,(
function(self,aMethod,aClass)
local stream=nil
(function()
	local _s8_value=((""):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):fileOutMethod_of_on_(aMethod,aClass,stream);
return ((stream):contents());
end
)
,"fileOut","fileOutMethod: aMethod of: aClass\r\n\t\" Return fileOut method of a class. \"\r\n\r\n\t| stream |\r\n\tstream := '' writeStream.\r\n\tself fileOutMethod: aMethod of: aClass on: stream.\r\n\t^stream contents","(\r\nfunction(self,aMethod,aClass)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):fileOutMethod_of_on_(aMethod,aClass,stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutAllMethodsOf:on:",0
,(
function(self,aClass,stream)
(self):fileOutMethodsOf_on_((aClass)["$klass"],stream);
(self):fileOutMethodsOf_on_(aClass,stream);
return (self);
end
)
,"fileOut","fileOutAllMethodsOf: aClass on: stream\r\n\t\" FileOut all methods of aClass (and metaclass) onto stream. \"\r\n\r\n\tself fileOutMethodsOf: aClass class on: stream.\r\n\tself fileOutMethodsOf: aClass on: stream.","(\r\nfunction(self,aClass,stream)\r\n(self):fileOutMethodsOf_on_((aClass)[\"$klass\"],stream);\r\n(self):fileOutMethodsOf_on_(aClass,stream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutAll:on:",0
,(
function(self,elements,stream)
if ((elements):isString())==true then return ((self):fileOutAll_on_((elements):asArrayOfSubstrings(),stream)); end;
(elements):do_((function(each)
return (smalltalk:if_true_false_(((self):isBehavior_(each)),(function()
return ((self):fileOutDefinitionOfClass_on_(each,stream))
end),nil))
end));
(stream):cr();
(elements):do_((function(each)
return (smalltalk:if_true_false_(((self):isBehavior_(each)),(function()
return ((self):fileOutAllMethodsOf_on_(each,stream))
end),(function()
return (smalltalk:if_true_false_(((each):isString()),(function()
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):fileOutCategory_(each));
	return ((_s8_rec):cr())
end
)(stream))
end),(function()
return ((self):fileOutMethod_of_on_(each,(each):classField(),stream))
end)))
end)))
end));
return (self);
end
)
,"fileOut","fileOutAll: elements on: stream\r\n\t\" FileOut definition and code of elements (classes, methods and/or categories) onto stream. \"\r\n\r\n\telements isString ifTrue: [ ^self fileOutAll: elements asArrayOfSubstrings on: stream ].\r\n\telements do: [:each|\r\n\t\t(self isBehavior: each) ifTrue: [\r\n\t\t\tself fileOutDefinitionOfClass: each on: stream\r\n\t\t].\r\n\t].\tstream cr.\r\n\telements do: [:each|\r\n\t\t(self isBehavior: each) ifTrue: [\r\n\t\t\tself fileOutAllMethodsOf: each on: stream\r\n\t\t] ifFalse: [\r\n\t\t\teach isString\r\n\t\t\tifTrue: [ stream nextPutAll: (self fileOutCategory: each);cr ]\r\n\t\t\tifFalse: [ self fileOutMethod: each of: each classField on: stream ]\r\n\t\t]\r\n\t].","(\r\nfunction(self,elements,stream)\r\nif ((elements):isString())==true then return ((self):fileOutAll_on_((elements):asArrayOfSubstrings(),stream)); end;\r\n(elements):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((self):isBehavior_(each)),(function()\r\nreturn ((self):fileOutDefinitionOfClass_on_(each,stream))\r\nend),nil))\r\nend));\r\n(stream):cr();\r\n(elements):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((self):isBehavior_(each)),(function()\r\nreturn ((self):fileOutAllMethodsOf_on_(each,stream))\r\nend),(function()\r\nreturn (smalltalk:if_true_false_(((each):isString()),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):fileOutCategory_(each));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream))\r\nend),(function()\r\nreturn ((self):fileOutMethod_of_on_(each,(each):classField(),stream))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutDefinitionOfClass:on:",0
,(
function(self,aClass,stream)
(self):fileOutDefinitionOf_on_(aClass,stream);
(self):fileOutDefinitionOf_on_((aClass)["$klass"],stream);
return (self);
end
)
,"fileOut","fileOutDefinitionOfClass: aClass on: stream\r\n\t\" FileOut definition of aClass (and metaclass) onto stream. \"\r\n\r\n\tself fileOutDefinitionOf: aClass on: stream.\r\n\tself fileOutDefinitionOf: aClass class on: stream","(\r\nfunction(self,aClass,stream)\r\n(self):fileOutDefinitionOf_on_(aClass,stream);\r\n(self):fileOutDefinitionOf_on_((aClass)[\"$klass\"],stream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutDefinitionOf:",0
,(
function(self,aClass)
local stream=nil
(function()
	local _s8_value=((""):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):fileOutDefinitionOfClass_on_((aClass):instanceClass(),stream);
return ((stream):contents());
end
)
,"fileOut","fileOutDefinitionOf: aClass\r\n\t\" Return the definition of a class. \"\r\n\r\n\t| stream |\r\n\tstream := '' writeStream.\r\n\tself fileOutDefinitionOfClass: aClass instanceClass on: stream.\r\n\t^stream contents","(\r\nfunction(self,aClass)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):fileOutDefinitionOfClass_on_((aClass):instanceClass(),stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOut:on:",0
,(
function(self,aClass,stream)
(self):fileOutAll_on_((smalltalk.Array):with_(aClass),stream);
return (self);
end
)
,"fileOut","fileOut: aClass on: stream\r\n\t\" FileOut definition and code of a class onto stream. \"\r\n\r\n\tself fileOutAll: (Array with: aClass) on: stream.","(\r\nfunction(self,aClass,stream)\r\n(self):fileOutAll_on_((smalltalk.Array):with_(aClass),stream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutDefinitionOf:on:",0
,(
function(self,aClass,stream)
if ((aClass):isMetaclass())==true then if ((self):fileOutStrings_of_on_("instanceVariableNames",aClass,stream))==true then (
function(_s8_rec)
	(_s8_rec):nextChunkPut_("");
	return ((_s8_rec):cr())
end
)(stream); end;
if ((self):fileOutArray_of_on_("propertyNames",aClass,stream))==true then (
function(_s8_rec)
	(_s8_rec):nextChunkPut_("");
	return ((_s8_rec):cr())
end
)(stream); end;
return (self); end;
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:asString_(((aClass):superclass())));
	(_s8_rec):cr();
	(_s8_rec):tab();
	return ((_s8_rec):nextPutAll_("subclass: #"))
end
)(stream);
if not (((self):fileOutStrings_of_on_("instanceVariableNames",aClass,stream)))==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):globalNameFor_(aClass));
	(_s8_rec):cr();
	(_s8_rec):tab();
	(_s8_rec):nextPutAll_("instanceVariableNames: ");
	return ((_s8_rec):nextPutAll_(smalltalk:printString_((""))))
end
)(stream); end;
if (smalltalk:notNil_(((aClass):classVariables())))==true then (
function(_s8_rec)
	(_s8_rec):cr();
	(_s8_rec):tab();
	(_s8_rec):nextPutAll_("classVariableNames: ");
	return ((_s8_rec):nextPutAll_(smalltalk:printString_(((aClass):classVariablesString()))))
end
)(stream); end;
if (smalltalk:notNil_(((aClass):poolDictionaries())))==true then (
function(_s8_rec)
	(_s8_rec):cr();
	(_s8_rec):tab();
	(_s8_rec):nextPutAll_("poolDictionaries: ");
	return ((_s8_rec):nextPutAll_(smalltalk:printString_(((aClass):poolDictionariesString()))))
end
)(stream); end;
(
function(_s8_rec)
	(_s8_rec):cr();
	(_s8_rec):tab();
	(_s8_rec):nextPutAll_("category: ");
	return ((_s8_rec):nextPutAll_(((aClass):category()):asLiteral()))
end
)(stream);
(
function(_s8_rec)
	(_s8_rec):nextChunkPut_("");
	return ((_s8_rec):cr())
end
)(stream);
if ((self):fileOutArray_of_on_("propertyNames",aClass,stream))==true then (
function(_s8_rec)
	(_s8_rec):nextChunkPut_("");
	return ((_s8_rec):cr())
end
)(stream); end;
if (smalltalk:boolean_and_((smalltalk:notNil_(((aClass):comment()))),(function()
return (((aClass):comment()):notEmpty())
end)))==true then (stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(((self):globalNameFor_(aClass))," comment: ")),smalltalk:printString_(((aClass):comment()))));
(
function(_s8_rec)
	(_s8_rec):nextChunkPut_("");
	return ((_s8_rec):cr())
end
)(stream); end;
return (self);
end
)
,"fileOut","fileOutDefinitionOf: aClass on: stream\r\n\t\" FileOut definition of a class onto stream. \"\r\n\r\n\taClass isMetaclass ifTrue: [\r\n\t\t(self fileOutStrings: #instanceVariableNames of: aClass on: stream) ifTrue: [\r\n\t\t\tstream nextChunkPut: '';cr.\r\n\t\t].\r\n\t\t(self fileOutArray: #propertyNames of: aClass on: stream) ifTrue: [\r\n\t\t\tstream nextChunkPut: '';cr.\r\n\t\t].\r\n\t\t^self\r\n\t].\r\n\r\n\tstream\r\n\t\tnextPutAll: aClass superclass asString; cr;tab;\r\n\t\tnextPutAll: 'subclass: #'.\r\n\t(self fileOutStrings: #instanceVariableNames of: aClass on: stream) ifFalse: [\r\n\t\tstream\r\n\t\t\tnextPutAll: (self globalNameFor: aClass); cr;tab;\r\n\t\t\tnextPutAll: 'instanceVariableNames: ';\r\n\t\t\tnextPutAll: '' printString\r\n\t].\r\n\taClass classVariables notNil ifTrue: [\r\n\t    stream\t cr;tab;\r\n\t\tnextPutAll: 'classVariableNames: ';\r\n\t\tnextPutAll: aClass classVariablesString printString\r\n\t].\r\n\taClass poolDictionaries notNil ifTrue: [\r\n\t    stream\t cr;tab;\r\n\t\tnextPutAll: 'poolDictionaries: ';\r\n\t\tnextPutAll: aClass poolDictionariesString printString\r\n\t].\r\n\tstream cr;tab;\r\n\t\tnextPutAll: 'category: ';\r\n\t\tnextPutAll: aClass category asLiteral.\r\n\tstream nextChunkPut: '';cr.\r\n\t(self fileOutArray: #propertyNames of: aClass on: stream) ifTrue: [\r\n\t\tstream nextChunkPut: '';cr.\r\n\t].\r\n\t(aClass comment notNil and: [aClass comment notEmpty]) ifTrue: [\r\n\t\tstream nextPutAll: (self globalNameFor: aClass),' comment: ', aClass comment printString.\r\n\t\tstream nextChunkPut: '';cr.\r\n\t].","(\r\nfunction(self,aClass,stream)\r\nif ((aClass):isMetaclass())==true then if ((self):fileOutStrings_of_on_(\"instanceVariableNames\",aClass,stream))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextChunkPut_(\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream); end;\r\nif ((self):fileOutArray_of_on_(\"propertyNames\",aClass,stream))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextChunkPut_(\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream); end;\r\nreturn (self); end;\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:asString_(((aClass):superclass())));\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):tab();\r\n\treturn ((_s8_rec):nextPutAll_(\"subclass: #\"))\r\nend\r\n)(stream);\r\nif not (((self):fileOutStrings_of_on_(\"instanceVariableNames\",aClass,stream)))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):globalNameFor_(aClass));\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):tab();\r\n\t(_s8_rec):nextPutAll_(\"instanceVariableNames: \");\r\n\treturn ((_s8_rec):nextPutAll_(smalltalk:printString_((\"\"))))\r\nend\r\n)(stream); end;\r\nif (smalltalk:notNil_(((aClass):classVariables())))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):tab();\r\n\t(_s8_rec):nextPutAll_(\"classVariableNames: \");\r\n\treturn ((_s8_rec):nextPutAll_(smalltalk:printString_(((aClass):classVariablesString()))))\r\nend\r\n)(stream); end;\r\nif (smalltalk:notNil_(((aClass):poolDictionaries())))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):tab();\r\n\t(_s8_rec):nextPutAll_(\"poolDictionaries: \");\r\n\treturn ((_s8_rec):nextPutAll_(smalltalk:printString_(((aClass):poolDictionariesString()))))\r\nend\r\n)(stream); end;\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):tab();\r\n\t(_s8_rec):nextPutAll_(\"category: \");\r\n\treturn ((_s8_rec):nextPutAll_(((aClass):category()):asLiteral()))\r\nend\r\n)(stream);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextChunkPut_(\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream);\r\nif ((self):fileOutArray_of_on_(\"propertyNames\",aClass,stream))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextChunkPut_(\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream); end;\r\nif (smalltalk:boolean_and_((smalltalk:notNil_(((aClass):comment()))),(function()\r\nreturn (((aClass):comment()):notEmpty())\r\nend)))==true then (stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(((self):globalNameFor_(aClass)),\" comment: \")),smalltalk:printString_(((aClass):comment()))));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextChunkPut_(\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutStrings:of:on:",0
,(
function(self,selector,aClass,stream)
local strings=nil
(function()
	local _s8_value=((aClass):perform_(selector))
	strings=_s8_value
	return _s8_value
end)();
if ((strings):isEmpty())==true then return (false); end;
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):globalNameFor_(aClass));
	(_s8_rec):cr();
	(_s8_rec):tab();
	return ((_s8_rec):nextPutAll_(smalltalk:object_comma_((selector),": '")))
end
)(stream);
(strings):do_((function(each)
return ((stream):nextPutAll_(smalltalk:object_comma_((" "),each)))
end));
(stream):nextPutAll_(" '");
return (true);
end
)
,"fileOut","fileOutStrings: selector of: aClass on: stream\r\n\t\" Private - FileOut selector strings of a class onto stream.\r\n\tReturn true if code has been filedOut.\r\n\t\"\r\n\r\n\t| strings |\r\n\tstrings := aClass perform: selector.\r\n\tstrings isEmpty ifTrue: [ ^false ].\r\n\tstream\r\n\t\tnextPutAll: (self globalNameFor: aClass); cr;tab;\r\n\t\tnextPutAll: selector,': '''.\r\n\tstrings do: [:each| stream nextPutAll: ' ',each ].\r\n\tstream nextPutAll: ' '''.\r\n\t^true","(\r\nfunction(self,selector,aClass,stream)\r\nlocal strings=nil\r\n(function()\r\n\tlocal _s8_value=((aClass):perform_(selector))\r\n\tstrings=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((strings):isEmpty())==true then return (false); end;\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):globalNameFor_(aClass));\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):tab();\r\n\treturn ((_s8_rec):nextPutAll_(smalltalk:object_comma_((selector),\": '\")))\r\nend\r\n)(stream);\r\n(strings):do_((function(each)\r\nreturn ((stream):nextPutAll_(smalltalk:object_comma_((\" \"),each)))\r\nend));\r\n(stream):nextPutAll_(\" '\");\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutArray:of:on:",0
,(
function(self,selector,aClass,stream)
local strings=nil
(function()
	local _s8_value=((aClass):perform_(selector))
	strings=_s8_value
	return _s8_value
end)();
if ((strings):isEmpty())==true then return (false); end;
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):globalNameFor_(aClass));
	return ((_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((" "),selector)),": ")),(strings):asLiteral())))
end
)(stream);
return (true);
end
)
,"fileOut","fileOutArray: selector of: aClass on: stream\r\n\t\" Private - FileOut selector arrayed strings of a class onto stream.\r\n\tReturn true if code has been filedOut.\r\n\t\"\r\n\r\n\t| strings |\r\n\tstrings := aClass perform: selector.\r\n\tstrings isEmpty ifTrue: [ ^false ].\r\n\tstream\r\n\t\tnextPutAll: (self globalNameFor: aClass);\r\n\t\tnextPutAll: ' ',selector,': ', strings asLiteral.\r\n\t^true","(\r\nfunction(self,selector,aClass,stream)\r\nlocal strings=nil\r\n(function()\r\n\tlocal _s8_value=((aClass):perform_(selector))\r\n\tstrings=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((strings):isEmpty())==true then return (false); end;\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):globalNameFor_(aClass));\r\n\treturn ((_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\" \"),selector)),\": \")),(strings):asLiteral())))\r\nend\r\n)(stream);\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutMethodsOf:on:",0
,(
function(self,aClass,stream)
local selectors=nil
(function()
	local _s8_value=((aClass):selectors())
	selectors=_s8_value
	return _s8_value
end)();
if ((selectors):isEmpty())==true then return (self); end;
(stream):cr();
(self):fileOutSelectors_of_on_(selectors,aClass,stream);
return (self);
end
)
,"fileOut","fileOutMethodsOf: aClass on: stream\r\n\t\" FileOut methods of a class onto stream. \"\r\n\r\n\t| selectors |\r\n\tselectors := aClass selectors.\r\n\tselectors isEmpty ifTrue: [ ^self ].\r\n\tstream cr.\r\n\tself\r\n\t\tfileOutSelectors: selectors\r\n\t\tof: aClass on: stream","(\r\nfunction(self,aClass,stream)\r\nlocal selectors=nil\r\n(function()\r\n\tlocal _s8_value=((aClass):selectors())\r\n\tselectors=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((selectors):isEmpty())==true then return (self); end;\r\n(stream):cr();\r\n(self):fileOutSelectors_of_on_(selectors,aClass,stream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutClusters",0
,(
function(self)
return (((smalltalk:newArray({"APIBuilder"})):select_((function(key)
return ((smalltalk.Smalltalk):includesKey_(key))
end))):collect_((function(each)
return (((smalltalk.Smalltalk):at_(each)):default())
end)));
end
)
,"private","fileOutClusters\r\n\t\" Private - Return the fileOut chustering dumpers of the receiver.\r\n\tA fileOutCluster is an object that potentially dump clustered actions for selectors implemented by aClass.\r\n\tThe fileOut write (smalltalk)code for multiple selectors removing them from selectors collection.\r\n\tNote: the selectors collection is modified during fileOut.\r\n\tThe default answer is an empty collection of custed or a collection with default APIBuilder.\r\n\tThis method can be refined by the subclasses.\r\n\t\"\r\n\r\n\t^(#( #APIBuilder )\r\n\t\tselect: [:key| Smalltalk includesKey: key ])\r\n\t\tcollect: [:each| (Smalltalk at: each) default ]","(\r\nfunction(self)\r\nreturn (((smalltalk:newArray({\"APIBuilder\"})):select_((function(key)\r\nreturn ((smalltalk.Smalltalk):includesKey_(key))\r\nend))):collect_((function(each)\r\nreturn (((smalltalk.Smalltalk):at_(each)):default())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutSelectors:of:on:",0
,(
function(self,selectors,aClass,stream)
((self):fileOutClusters()):do_((function(each)
return ((each):fileOut_selectors_of_on_(self,selectors,aClass,stream))
end));
(self):fileOutMethods_on_((selectors):collect_((function(each)
return ((aClass):compiledMethodAt_(each))
end)),stream);
return (self);
end
)
,"fileOut","fileOutSelectors: selectors of: aClass on: stream\r\n\t\" FileOut methods implementing selectors of a class onto stream. \"\r\n\r\n\tself fileOutClusters do: [:each|\r\n\t\teach\r\n\t\t\tfileOut: self selectors: selectors\r\n\t\t\tof: aClass on: stream\r\n\t].\r\n\tself\tfileOutMethods: (selectors collect: [:each|\r\n\t\t\taClass compiledMethodAt: each ])\r\n\t\ton: stream","(\r\nfunction(self,selectors,aClass,stream)\r\n((self):fileOutClusters()):do_((function(each)\r\nreturn ((each):fileOut_selectors_of_on_(self,selectors,aClass,stream))\r\nend));\r\n(self):fileOutMethods_on_((selectors):collect_((function(each)\r\nreturn ((aClass):compiledMethodAt_(each))\r\nend)),stream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutMethods:on:",0
,(
function(self,array,stream)
local sorted=nil
(function()
	local _s8_value=((array):sorted_((function(a,b)
return (smalltalk:boolean_or_(((((a):category()) < (b):category())),(function()
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((a):category()),(b):category())),(function()
return ((((a):selector()) < (b):selector()))
end)))
end)))
end)))
	sorted=_s8_value
	return _s8_value
end)();
(sorted):do_((function(each)
return ((self):fileOutMethod_of_on_(each,(each):classField(),stream))
end));
return (self);
end
)
,"fileOut","fileOutMethods: array on: stream\r\n\t\" FileOut array of methods of a class onto stream. \"\r\n\r\n\t| sorted |\r\n\tsorted := array sorted: [:a :b|\r\n\t\ta category < b category\r\n\t\tor: [ a category = b category\r\n\t\tand: [ a selector < b selector ]]\r\n\t].\r\n\r\n\tsorted do: [:each|\r\n\t\tself\tfileOutMethod: each\r\n\t\t\tof: each classField on: stream\r\n\t].","(\r\nfunction(self,array,stream)\r\nlocal sorted=nil\r\n(function()\r\n\tlocal _s8_value=((array):sorted_((function(a,b)\r\nreturn (smalltalk:boolean_or_(((((a):category()) < (b):category())),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((a):category()),(b):category())),(function()\r\nreturn ((((a):selector()) < (b):selector()))\r\nend)))\r\nend)))\r\nend)))\r\n\tsorted=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(sorted):do_((function(each)\r\nreturn ((self):fileOutMethod_of_on_(each,(each):classField(),stream))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"isASymbol:",0
,(
function(self,aString)
return (smalltalk:isNil_((((smalltalk.RegularExpression):fromString_("[^a-zA-Z0-9_:]")):exec_(aString))));
end
)
,"private","isASymbol: aString\r\n\t\" Private - Return true if aString can be output with symbol notation. \"\r\n\r\n\t^((RegularExpression fromString: '[^a-zA-Z0-9_:]') exec: aString) isNil","(\r\nfunction(self,aString)\r\nreturn (smalltalk:isNil_((((smalltalk.RegularExpression):fromString_(\"[^a-zA-Z0-9_:]\")):exec_(aString))));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutMethod:on:",0
,(
function(self,aMethod,aStream)
return ((self):fileOutMethod_of_on_(aMethod,(aMethod):classField(),aStream));
end
)
,"fileOut","fileOutMethod: aMethod on: aStream\r\n\t\" Return the fileOut of aMethod. \"\r\n\r\n\t^self\r\n\t\tfileOutMethod: aMethod\r\n\t\tof: aMethod classField\r\n\t\ton: aStream","(\r\nfunction(self,aMethod,aStream)\r\nreturn ((self):fileOutMethod_of_on_(aMethod,(aMethod):classField(),aStream));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutMethod:",0
,(
function(self,aMethod)
local stream=nil
(function()
	local _s8_value=((""):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):fileOutMethod_on_(aMethod,stream);
return ((stream):contents());
end
)
,"fileOut","fileOutMethod: aMethod\r\n\t\" Return the fileOut of aMethod. \"\r\n\r\n\t| stream |\r\n\tstream := '' writeStream.\r\n\tself fileOutMethod: aMethod on: stream.\r\n\t^stream contents","(\r\nfunction(self,aMethod)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):fileOutMethod_on_(aMethod,stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"fileOutMethod:of:on:",0
,(
function(self,aMethod,aClass,stream)
local stamp=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((((((aMethod):stamp()):size()) > 0)),(function()
return (smalltalk:object_comma_((" stamp: "),((aMethod):stamp()):asLiteral()))
end),(function()
return ("")
end)))
	stamp=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):cr();
	(_s8_rec):nextChunkPut_(nil);
	(_s8_rec):nextChunkPut_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((" "),(self):globalNameFor_(aClass)))," methodsFor: ")),((aMethod):category()):asLiteral())),stamp))," "));
	(_s8_rec):cr();
	(_s8_rec):nextChunkPut_((aMethod):source());
	(_s8_rec):nextChunkPut_(" ");
	return ((_s8_rec):cr())
end
)(stream);
return (self);
end
)
,"fileOut","fileOutMethod: aMethod of: aClass on: stream\r\n\t\" FileOut method of a class onto stream. \"\r\n\r\n\t| stamp |\r\n\tstamp := aMethod stamp size > 0\r\n\t\tifTrue: [ ' stamp: ' , aMethod stamp asLiteral ]\r\n\t\tifFalse: [''].\r\n\tstream\tcr; nextChunkPut: nil;\r\n\t\tnextChunkPut: ' '\r\n\t\t\t,(self globalNameFor: aClass)\r\n\t\t\t,' methodsFor: ' ,aMethod category asLiteral\r\n\t\t\t,stamp ,' '; cr;\r\n\t\tnextChunkPut: aMethod source;\r\n\t\tnextChunkPut: ' '; cr","(\r\nfunction(self,aMethod,aClass,stream)\r\nlocal stamp=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((((((aMethod):stamp()):size()) > 0)),(function()\r\nreturn (smalltalk:object_comma_((\" stamp: \"),((aMethod):stamp()):asLiteral()))\r\nend),(function()\r\nreturn (\"\")\r\nend)))\r\n\tstamp=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):nextChunkPut_(nil);\r\n\t(_s8_rec):nextChunkPut_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\" \"),(self):globalNameFor_(aClass))),\" methodsFor: \")),((aMethod):category()):asLiteral())),stamp)),\" \"));\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):nextChunkPut_((aMethod):source());\r\n\t(_s8_rec):nextChunkPut_(\" \");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportCategory:",0
,(
function(self,aString)
local stream=nil
local match=nil
(function()
	local _s8_value=((""):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):matchCategory_(aString))
	match=_s8_value
	return _s8_value
end)();
((match):first()):do_((function(each)
return ((stream):nextPutAll_((self):export_(each)))
end));
((match):last()):do_((function(aMethod)
return ((self):export_method_on_((aMethod):classField(),aMethod,stream))
end));
return ((stream):contents());
end
)
,"export","exportCategory: aString\r\n\t\" Return the result of exporting all the classes in category aString. \"\r\n\r\n\t| stream match |\r\n\tstream := '' writeStream.\r\n\tmatch := self matchCategory: aString.\r\n\tmatch first do: [:each| stream nextPutAll: (self export: each) ].\r\n\tmatch last do: [:aMethod |\r\n\t\tself export: aMethod classField method: aMethod on: stream\r\n\t].\r\n\t^stream contents","(\r\nfunction(self,aString)\r\nlocal stream=nil\r\nlocal match=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):matchCategory_(aString))\r\n\tmatch=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((match):first()):do_((function(each)\r\nreturn ((stream):nextPutAll_((self):export_(each)))\r\nend));\r\n((match):last()):do_((function(aMethod)\r\nreturn ((self):export_method_on_((aMethod):classField(),aMethod,stream))\r\nend));\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportCategories:",0
,(
function(self,categories)
if ((categories):isString())==true then return ((self):exportCategories_((categories):asArrayOfSubstrings())); end;
return ((((categories):asArray()):inject_into_(smalltalk:newArray({}),(function(total,each)
return ((
function(_s8_rec)
	(_s8_rec):add_((self):exportCategory_(each));
	return ((_s8_rec):yourself())
end
)(total))
end))):join_(""));
end
)
,"export","exportCategories: categories\r\n\t\" Return the result of exporting all the classes in categories. \"\r\n\r\n\tcategories isString ifTrue: [ ^self exportCategories: categories asArrayOfSubstrings ].\r\n\t^(categories asArray inject: #() into: [:total :each|\r\n\t\ttotal add: (self exportCategory: each); yourself\r\n\t]) join: ''","(\r\nfunction(self,categories)\r\nif ((categories):isString())==true then return ((self):exportCategories_((categories):asArrayOfSubstrings())); end;\r\nreturn ((((categories):asArray()):inject_into_(smalltalk:newArray({}),(function(total,each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_((self):exportCategory_(each));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(total))\r\nend))):join_(\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportAllMethodsOf:on:",0
,(
function(self,aClass,stream)
(self):exportMethodsOf_on_((aClass)["$klass"],stream);
(self):exportMethodsOf_on_(aClass,stream);
return (self);
end
)
,"export","exportAllMethodsOf: aClass on: stream\r\n\t\" Export all methods of a class (and metaclass) onto stream. \"\r\n\r\n\tself exportMethodsOf: aClass class on: stream.\r\n\tself exportMethodsOf: aClass on: stream.","(\r\nfunction(self,aClass,stream)\r\n(self):exportMethodsOf_on_((aClass)[\"$klass\"],stream);\r\n(self):exportMethodsOf_on_(aClass,stream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportAllMethodsOn:",0
,(
function(self,stream)
((self):allClasses()):do_((function(aClass)
return ((self):exportAllMethodsOf_on_(aClass,stream))
end));
return (self);
end
)
,"export","exportAllMethodsOn: stream\r\n\t\" Export all methods in the system onto stream. \"\r\n\r\n\tself allClasses do: [:aClass|\r\n\t\tself exportAllMethodsOf: aClass on: stream\r\n\t]","(\r\nfunction(self,stream)\r\n((self):allClasses()):do_((function(aClass)\r\nreturn ((self):exportAllMethodsOf_on_(aClass,stream))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportAllMethods",0
,(
function(self)
local stream=nil
(function()
	local _s8_value=((""):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):exportAllMethodsOn_(stream);
return ((stream):contents());
end
)
,"export","exportAllMethods\r\n\t\" Return the result of exporting all methods in the system. \"\r\n\r\n\t| stream |\r\n\tstream := '' writeStream.\r\n\tself exportAllMethodsOn: stream.\r\n\t^stream contents","(\r\nfunction(self)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):exportAllMethodsOn_(stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportAllDefinitionsOn:",0
,(
function(self,stream)
((self):allClasses()):do_((function(aClass)
return ((self):exportDefinitionOfClass_on_(aClass,stream))
end));
return (self);
end
)
,"export","exportAllDefinitionsOn: stream\r\n\t\" Export all class definitions in the system onto stream. \"\r\n\r\n\tself allClasses do: [:aClass|\r\n\t\tself exportDefinitionOfClass: aClass on: stream\r\n\t]","(\r\nfunction(self,stream)\r\n((self):allClasses()):do_((function(aClass)\r\nreturn ((self):exportDefinitionOfClass_on_(aClass,stream))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportAllDefinitions",0
,(
function(self)
local stream=nil
(function()
	local _s8_value=((""):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):exportAllDefinitionsOn_(stream);
return ((stream):contents());
end
)
,"export","exportAllDefinitions\r\n\t\" Return the result of exporting all class definitions in the system. \"\r\n\r\n\t| stream |\r\n\tstream := '' writeStream.\r\n\tself exportAllDefinitionsOn: stream.\r\n\t^stream contents","(\r\nfunction(self)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):exportAllDefinitionsOn_(stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportDefinitionOfClass:on:",0
,(
function(self,aClass,stream)
(self):exportDefinitionOf_on_(aClass,stream);
(self):exportMetaDefinitionOf_on_(aClass,stream);
return (self);
end
)
,"export","exportDefinitionOfClass: aClass on: stream\r\n\t\" Export definition of aClass (and metaclass) onto stream. \"\r\n\r\n\tself exportDefinitionOf: aClass on: stream.\r\n\tself exportMetaDefinitionOf: aClass on: stream.","(\r\nfunction(self,aClass,stream)\r\n(self):exportDefinitionOf_on_(aClass,stream);\r\n(self):exportMetaDefinitionOf_on_(aClass,stream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"export:",0
,(
function(self,aClass)
local stream=nil
(function()
	local _s8_value=((""):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):exportDefinitionOfClass_on_(aClass,stream);
(self):exportAllMethodsOf_on_(aClass,stream);
return ((stream):contents());
end
)
,"export","export: aClass\r\n\t\" Return the result of exporting definition and source code of a class. \"\r\n\r\n\t| stream |\r\n\tstream := '' writeStream.\r\n\tself exportDefinitionOfClass: aClass on: stream.\r\n\tself exportAllMethodsOf: aClass on: stream.\r\n\t^stream contents","(\r\nfunction(self,aClass)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):exportDefinitionOfClass_on_(aClass,stream);\r\n(self):exportAllMethodsOf_on_(aClass,stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportNew:",0
,(
function(self,aClass)
return ((self):exportDefinitionOf_(aClass));
end
)
,"export","exportNew: aClass\r\n\t\" Return the result of exporting definition of aClass. \"\r\n\r\n\t^self exportDefinitionOf: aClass","(\r\nfunction(self,aClass)\r\nreturn ((self):exportDefinitionOf_(aClass));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportCommentOf:",0
,(
function(self,aClass)
local stream=nil
(function()
	local _s8_value=((""):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):exportCommentOf_on_(aClass,stream);
return ((stream):contents());
end
)
,"export","exportCommentOf: aClass\r\n\t\" Return the result of exporting comment of a class. \"\r\n\r\n\t| stream |\r\n\tstream := '' writeStream.\r\n\tself exportCommentOf: aClass on: stream.\r\n\t^stream contents","(\r\nfunction(self,aClass)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):exportCommentOf_on_(aClass,stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportCommentOf:on:",0
,(
function(self,aClass,aStream)
return (((self):encoderFor_(aClass)):exportCommentOf_on_(aClass,aStream));
end
)
,"private","exportCommentOf: aClass on: aStream\r\n\t\" Export comment of aClass onto aStream. \"\r\n\r\n\t^(self encoderFor: aClass) exportCommentOf: aClass on: aStream","(\r\nfunction(self,aClass,aStream)\r\nreturn (((self):encoderFor_(aClass)):exportCommentOf_on_(aClass,aStream));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportDefinitionOf:on:",0
,(
function(self,aClass,aStream)
return (((self):encoderFor_(aClass)):exportDefinitionOf_on_(aClass,aStream));
end
)
,"private","exportDefinitionOf: aClass on: aStream\r\n\t\" Export definition of aClass onto aStream. \"\r\n\r\n\t^(self encoderFor: aClass) exportDefinitionOf: aClass on: aStream","(\r\nfunction(self,aClass,aStream)\r\nreturn (((self):encoderFor_(aClass)):exportDefinitionOf_on_(aClass,aStream));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportMetaDefinitionOf:on:",0
,(
function(self,aClass,aStream)
return (((self):encoderFor_(aClass)):exportMetaDefinitionOf_on_(aClass,aStream));
end
)
,"private","exportMetaDefinitionOf: aClass on: aStream\r\n\t\" Export class side definition of aClass onto aStream. \"\r\n\r\n\t^(self encoderFor: aClass) exportMetaDefinitionOf: aClass on: aStream","(\r\nfunction(self,aClass,aStream)\r\nreturn (((self):encoderFor_(aClass)):exportMetaDefinitionOf_on_(aClass,aStream));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"smalltalkNameFor:",0
,(
function(self,aClass)
return (((self):encoderFor_(aClass)):smalltalkNameFor_(aClass));
end
)
,"private","smalltalkNameFor: aClass\r\n\t\" Private - Return the native reference expression of aClass (or nil). \"\r\n\r\n\t^(self encoderFor: aClass) smalltalkNameFor: aClass","(\r\nfunction(self,aClass)\r\nreturn (((self):encoderFor_(aClass)):smalltalkNameFor_(aClass));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"globalNameFor:",0
,(
function(self,aClass)
return (smalltalk:if_true_false_((smalltalk:isNil_((aClass))),(function()
return ("nil")
end),(function()
return ((aClass):name())
end)));
end
)
,"private","globalNameFor: aClass\r\n\t\" Private - Return the smalltalk name of aClass (or nil). \"\r\n\r\n\t^aClass isNil ifTrue: [ #nil ] ifFalse: [ aClass name ]","(\r\nfunction(self,aClass)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((aClass))),(function()\r\nreturn (\"nil\")\r\nend),(function()\r\nreturn ((aClass):name())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportAll",0
,(
function(self)
return ((self):exportClasses_((self):allClasses()));
end
)
,"export","exportAll\r\n\t\" Return the result of exporting all classes in the system. \"\r\n\r\n\t^self exportClasses: self allClasses","(\r\nfunction(self)\r\nreturn ((self):exportClasses_((self):allClasses()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportAllCategories",0
,(
function(self)
local categories=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	categories=_s8_value
	return _s8_value
end)();
((self):allClasses()):do_((function(each)
return (smalltalk:if_true_false_(((categories):includes_((each):category())),nil,(function()
return ((categories):add_((each):category()))
end)))
end));
return (((categories):inject_into_(smalltalk:newArray({}),(function(total,each)
return ((
function(_s8_rec)
	(_s8_rec):add_((self):exportCategory_(each));
	return ((_s8_rec):yourself())
end
)(total))
end))):join_(""));
end
)
,"export","exportAllCategories\r\n\t\" Return the result of exporting all categories in the system. \"\r\n\r\n\t| categories |\r\n\tcategories := Array new.\r\n\tself allClasses do: [:each |\r\n\t\t(categories includes: each category) ifFalse: [\r\n\t\t\tcategories add: each category\r\n\t\t]\r\n\t].\r\n\t^(categories inject: #() into: [:total :each | total add: (self exportCategory: each); yourself ]) join: ''","(\r\nfunction(self)\r\nlocal categories=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tcategories=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):allClasses()):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((categories):includes_((each):category())),nil,(function()\r\nreturn ((categories):add_((each):category()))\r\nend)))\r\nend));\r\nreturn (((categories):inject_into_(smalltalk:newArray({}),(function(total,each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_((self):exportCategory_(each));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(total))\r\nend))):join_(\"\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportDefinitionOf:",0
,(
function(self,aClass)
local stream=nil
(function()
	local _s8_value=(((smalltalk.String):new()):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):exportDefinitionOf_on_(aClass,stream);
return ((stream):contents());
end
)
,"export","exportDefinitionOf: aClass\r\n\t\" Return the result of exporting definition of aClass. \"\r\n\r\n\t| stream |\r\n\tstream := String new writeStream.\r\n\tself exportDefinitionOf: aClass on: stream.\r\n\t^stream contents","(\r\nfunction(self,aClass)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.String):new()):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):exportDefinitionOf_on_(aClass,stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportMetaDefinitionOf:",0
,(
function(self,aClass)
local stream=nil
(function()
	local _s8_value=(((smalltalk.String):new()):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):exportMetaDefinitionOf_on_(aClass,stream);
return ((stream):contents());
end
)
,"export","exportMetaDefinitionOf: aClass\r\n\t\" Return the result of exporting class side definition of aClass. \"\r\n\r\n\t| stream |\r\n\tstream := String new writeStream.\r\n\tself exportMetaDefinitionOf: aClass on: stream.\r\n\t^stream contents","(\r\nfunction(self,aClass)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.String):new()):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):exportMetaDefinitionOf_on_(aClass,stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportClasses:on:",0
,(
function(self,classes,stream)
return ((self):exportAll_on_(classes,stream));
end
)
,"export","exportClasses: classes on: stream\r\n\t\" Return the result of exporting class definitions onto stream. \"\r\n\r\n\t^self exportAll: classes on: stream","(\r\nfunction(self,classes,stream)\r\nreturn ((self):exportAll_on_(classes,stream));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportAll:on:",0
,(
function(self,elements,stream)
if ((elements):isString())==true then return ((self):exportAll_on_((elements):asArrayOfSubstrings(),stream)); end;
(elements):do_((function(each)
return (smalltalk:if_true_false_(((self):isBehavior_(each)),(function()
return ((self):exportDefinitionOfClass_on_(each,stream))
end),nil))
end));
(stream):cr();
(elements):do_((function(each)
return (smalltalk:if_true_false_(((self):isBehavior_(each)),(function()
return ((self):exportAllMethodsOf_on_(each,stream))
end),(function()
return (smalltalk:if_true_false_(((each):isString()),(function()
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):exportCategory_(each));
	return ((_s8_rec):cr())
end
)(stream))
end),(function()
return ((self):exportMethod_on_(each,stream))
end)))
end)))
end));
return (self);
end
)
,"export","exportAll: elements on: stream\r\n\t\" Return the result of exporting elements (classes, methods and/or categories) onto stream. \"\r\n\r\n\telements isString ifTrue: [ ^self exportAll: elements asArrayOfSubstrings on: stream ].\r\n\telements do: [:each|\r\n\t\t(self isBehavior: each) ifTrue: [\r\n\t\t\tself exportDefinitionOfClass: each on: stream\r\n\t\t].\r\n\t].\r\n\tstream cr.\r\n\telements do: [:each|\r\n\t\t(self isBehavior: each) ifTrue: [\r\n\t\t\tself exportAllMethodsOf: each on: stream\r\n\t\t] ifFalse: [\r\n\t\t\teach isString\r\n\t\t\tifTrue: [ stream nextPutAll: (self exportCategory: each);cr ]\r\n\t\t\tifFalse: [ self exportMethod: each on: stream ]\r\n\t\t]\r\n\t].","(\r\nfunction(self,elements,stream)\r\nif ((elements):isString())==true then return ((self):exportAll_on_((elements):asArrayOfSubstrings(),stream)); end;\r\n(elements):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((self):isBehavior_(each)),(function()\r\nreturn ((self):exportDefinitionOfClass_on_(each,stream))\r\nend),nil))\r\nend));\r\n(stream):cr();\r\n(elements):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((self):isBehavior_(each)),(function()\r\nreturn ((self):exportAllMethodsOf_on_(each,stream))\r\nend),(function()\r\nreturn (smalltalk:if_true_false_(((each):isString()),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):exportCategory_(each));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream))\r\nend),(function()\r\nreturn ((self):exportMethod_on_(each,stream))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportAll:",0
,(
function(self,elements)
local stream=nil
(function()
	local _s8_value=(((smalltalk.String):new()):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):exportAll_on_(elements,stream);
return ((stream):contents());
end
)
,"export","exportAll: elements\r\n\t\" Return the result of exporting elements (classes, methods and/or categories). \"\r\n\r\n\t| stream |\r\n\tstream := String new writeStream.\r\n\tself exportAll: elements on: stream.\r\n\t^stream contents","(\r\nfunction(self,elements)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.String):new()):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):exportAll_on_(elements,stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportClasses:",0
,(
function(self,classes)
local stream=nil
(function()
	local _s8_value=(((smalltalk.String):new()):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):exportClasses_on_(classes,stream);
return ((stream):contents());
end
)
,"export","exportClasses: classes\r\n\t\" Return the result of exporting classes. \"\r\n\r\n\t| stream |\r\n\tstream := String new writeStream.\r\n\tself exportClasses: classes on: stream.\r\n\t^stream contents","(\r\nfunction(self,classes)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.String):new()):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):exportClasses_on_(classes,stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportObject:on:",0
,(
function(self,anObject,stream)
(stream):nextPutAll_((anObject):asNative());
return (self);
end
)
,"export","exportObject: anObject on: stream\r\n\t\" Export a (native)literal representation of anObject onto stream. \"\r\n\r\n\tstream nextPutAll: anObject asNative","(\r\nfunction(self,anObject,stream)\r\n(stream):nextPutAll_((anObject):asNative());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportObject:",0
,(
function(self,anObject)
local stream=nil
(function()
	local _s8_value=(((smalltalk.String):new()):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):exportObject_on_(anObject,stream);
return ((stream):contents());
end
)
,"export","exportObject: anObject\r\n\t\" Return the result of exporting a literal representation of anObject. \"\r\n\r\n\t| stream |\r\n\tstream := String new writeStream.\r\n\tself exportObject: anObject on: stream.\r\n\t^stream contents","(\r\nfunction(self,anObject)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.String):new()):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):exportObject_on_(anObject,stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"export:method:",0
,(
function(self,aClass,aMethod)
local stream=nil
(function()
	local _s8_value=(((smalltalk.String):new()):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):export_method_on_(aClass,aMethod,stream);
return ((stream):contents());
end
)
,"export","export: aClass method: aMethod\r\n\t\" Return the result of exporting aClass method. \"\r\n\r\n\t| stream |\r\n\tstream := String new writeStream.\r\n\tself export: aClass method: aMethod on: stream.\r\n\t^stream contents","(\r\nfunction(self,aClass,aMethod)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.String):new()):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):export_method_on_(aClass,aMethod,stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportMethod:",0
,(
function(self,aMethod)
return ((self):export_method_((aMethod):classField(),aMethod));
end
)
,"export","exportMethod: aMethod\r\n\t\" Return the result of exporting aMethod. \"\r\n\r\n\t^self export: aMethod classField method: aMethod","(\r\nfunction(self,aMethod)\r\nreturn ((self):export_method_((aMethod):classField(),aMethod));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportMethod:on:",0
,(
function(self,aMethod,aStream)
return ((self):export_method_on_((aMethod):classField(),aMethod,aStream));
end
)
,"export","exportMethod: aMethod on: aStream\r\n\t\" Return the result of exporting aMethod on stream. \"\r\n\r\n\"\t(aMethod respondsTo: #classField) ifFalse: [ ^self note: 'Warning: broken method ',aMethod ].\r\n\"\t^self export: aMethod classField method: aMethod on: aStream","(\r\nfunction(self,aMethod,aStream)\r\nreturn ((self):export_method_on_((aMethod):classField(),aMethod,aStream));\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportMethods:on:",0
,(
function(self,aCollection,aStream)
(aCollection):do_((function(each)
return ((self):exportMethod_on_(each,aStream))
end));
return (self);
end
)
,"export","exportMethods: aCollection on: aStream\r\n\t\" Return the result of exporting aCollection of methods on stream. \"\r\n\r\n\taCollection do: [:each| self exportMethod: each on: aStream ]","(\r\nfunction(self,aCollection,aStream)\r\n(aCollection):do_((function(each)\r\nreturn ((self):exportMethod_on_(each,aStream))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportMethods:",0
,(
function(self,aCollection)
local stream=nil
(function()
	local _s8_value=(((smalltalk.String):new()):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):exportMethods_on_(aCollection,stream);
return ((stream):contents());
end
)
,"Tools-export","exportMethods: aCollection\r\n\t\" Return the result of exporting aCollection of methods. \"\r\n\r\n\t| stream |\r\n\tstream := String new writeStream.\r\n\tself exportMethods: aCollection on: stream.\r\n\t^stream contents","(\r\nfunction(self,aCollection)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.String):new()):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):exportMethods_on_(aCollection,stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"exportMethodsOf:on:",0
,(
function(self,aClass,aStream)
(aClass):methodsDo_((function(each)
return ((self):export_method_on_(aClass,each,aStream))
end));
return (self);
end
)
,"Tools-private","exportMethodsOf: aClass on: aStream\r\n\t\" Export methods of aClass onto aStream. \"\r\n\r\n\taClass methodsDo: [:each|\r\n\t\tself export: aClass method: each on: aStream\r\n\t]","(\r\nfunction(self,aClass,aStream)\r\n(aClass):methodsDo_((function(each)\r\nreturn ((self):export_method_on_(aClass,each,aStream))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Exporter,"export:method:on:",0
,(
function(self,aClass,aMethod,aStream)
if (smalltalk:responds_to_((aMethod),("exportFor:on:")))==true then return ((aMethod):exportFor_on_(self,aStream)); end;
return (((self):encoderFor_(aClass)):export_method_on_(aClass,aMethod,aStream));
end
)
,"Tools-export","export: aClass method: aMethod on: aStream\r\n\t\" Export a method definition of aClass onto aStream. \"\r\n\r\n\t(aMethod respondsTo: #exportFor:on:) ifTrue: [ ^aMethod exportFor: self on: aStream ].\r\n\t^(self encoderFor: aClass) export: aClass method: aMethod on: aStream","(\r\nfunction(self,aClass,aMethod,aStream)\r\nif (smalltalk:responds_to_((aMethod),(\"exportFor:on:\")))==true then return ((aMethod):exportFor_on_(self,aStream)); end;\r\nreturn (((self):encoderFor_(aClass)):export_method_on_(aClass,aMethod,aStream));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences["$klass"],"constructEventsTriggered",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:newArray({"found:", "found:pattern:in:", "needsMethods", "searchStarted", "searchFinished"})),smalltalk:superImplementor(smalltalk.MethodReferences["$klass"],"constructEventsTriggered")(self)));
end
)
,"Tools-events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^#(\t#found: #found:pattern:in:\r\n\t\t#needsMethods\r\n\t\t#searchStarted #searchFinished\r\n\t) , super constructEventsTriggered","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:newArray({\"found:\", \"found:pattern:in:\", \"needsMethods\", \"searchStarted\", \"searchFinished\"})),smalltalk:superImplementor(smalltalk.MethodReferences[\"$klass\"],\"constructEventsTriggered\")(self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences["$klass"],"of:",0
,(
function(self,selector)
return (((self):new()):referencesOf_(selector));
end
)
,"Tools-testing","of: selector\r\n\t\" Return the references to selector. \"\r\n\r\n\t^self new referencesOf: selector","(\r\nfunction(self,selector)\r\nreturn (((self):new()):referencesOf_(selector));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences["$klass"],"ofGlobal:",0
,(
function(self,globalName)
return (((self):new()):referencesOfGlobal_(globalName));
end
)
,"Tools-testing","ofGlobal: globalName\r\n\t\" Return the references to global globalName. \"\r\n\r\n\t^self new referencesOfGlobal: globalName","(\r\nfunction(self,globalName)\r\nreturn (((self):new()):referencesOfGlobal_(globalName));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences["$klass"],"findClasses:",0
,(
function(self,what)
return (((self):new()):findClasses_(what));
end
)
,"Tools-testing","findClasses: what\r\n\t\" Find classes in the system matching what. \"\r\n\r\n\t^self new findClasses: what","(\r\nfunction(self,what)\r\nreturn (((self):new()):findClasses_(what));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences["$klass"],"globals",0
,(
function(self)
local tool=nil
local result=nil
(function()
	local _s8_value=((self):new())
	tool=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	result=_s8_value
	return _s8_value
end)();
(tool):when_do_("found:pattern:in:",(function(mth,mask,stream)
local global=nil
(function()
	local _s8_value=((((smalltalk.SmalltalkParser):new()):globalNameParser()):parse_(stream))
	global=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_(((global):isParseFailure()),nil,(function()
return (((result):at_ifAbsentPut_(global,(function()
return ((smalltalk.Array):new())
end))):add_(mth))
end)))
end));
(tool):searchGlobalReferences();
return (result);
end
)
,"Tools-testing","globals\r\n\t\" Return the references to all global names. \"\r\n\r\n\t| tool result |\r\n\ttool := self new.\r\n\tresult := PoolDictionary new.\r\n\ttool when: #found:pattern:in: do: [:mth :mask :stream| | global |\r\n\t\tglobal := SmalltalkParser new globalNameParser parse: stream.\r\n\t\tglobal isParseFailure ifFalse: [\r\n\t\t\t(result at: global ifAbsentPut: [Array new]) add: mth\r\n\t\t].\r\n\t].\r\n\ttool searchGlobalReferences.\r\n\t^result","(\r\nfunction(self)\r\nlocal tool=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):new())\r\n\ttool=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(tool):when_do_(\"found:pattern:in:\",(function(mth,mask,stream)\r\nlocal global=nil\r\n(function()\r\n\tlocal _s8_value=((((smalltalk.SmalltalkParser):new()):globalNameParser()):parse_(stream))\r\n\tglobal=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_(((global):isParseFailure()),nil,(function()\r\nreturn (((result):at_ifAbsentPut_(global,(function()\r\nreturn ((smalltalk.Array):new())\r\nend))):add_(mth))\r\nend)))\r\nend));\r\n(tool):searchGlobalReferences();\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences["$klass"],"methodOverwrites",0
,(
function(self)
return (((self):new()):methodOverwrites());
end
)
,"Tools-testing","methodOverwrites\r\n\t\" Find the methods that are implemented/overwritten by subclasses. \"\r\n\r\n\t^self new methodOverwrites","(\r\nfunction(self)\r\nreturn (((self):new()):methodOverwrites());\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences["$klass"],"variableOverwrites",0
,(
function(self)
return (((self):new()):variableOverwrites());
end
)
,"Tools-testing","variableOverwrites\r\n\t\" Find the methods that has potential overwrite of variable names. \"\r\n\r\n\t^self new variableOverwrites","(\r\nfunction(self)\r\nreturn (((self):new()):variableOverwrites());\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences["$klass"],"findMessages:",0
,(
function(self,what)
return (((self):new()):findMessages_(what));
end
)
,"Tools-testing","findMessages: what\r\n\t\" Find messages in the system matching what. \"\r\n\r\n\t^self new findMessages: what","(\r\nfunction(self,what)\r\nreturn (((self):new()):findMessages_(what));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"initializeResults",0
,(
function(self)
(function()
	local _s8_value=((smalltalk.Array):new())
	self["@results"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"Tools-initialize","initializeResults\r\n\t\" Private - Initialize the results of the receiver. \"\r\n\r\n\tresults := Array new","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@results\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"reset",0
,(
function(self)
(self):results_(nil);
return (self);
end
)
,"Tools-initialize","reset\r\n\t\" Reset the receiver. \"\r\n\r\n\tself results: nil","(\r\nfunction(self)\r\n(self):results_(nil);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"rootClasses:",0
,(
function(self,array)
(function()
	local _s8_value=(array)
	self["@rootClasses"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"Tools-accessing","rootClasses: array\r\n\t\" Set the rootClasses of the receiver. \"\r\n\r\n\trootClasses := array","(\r\nfunction(self,array)\r\n(function()\r\n\tlocal _s8_value=(array)\r\n\tself[\"@rootClasses\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"results",0
,(
function(self)
if (smalltalk:isNil_((self["@results"])))==true then (self):initializeResults(); end;
return (self["@results"]);
end
)
,"accessing","results\r\n\t\" Return the results of the receiver. \"\r\n\r\n\tresults isNil ifTrue: [ self initializeResults ].\r\n\t^results","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@results\"])))==true then (self):initializeResults(); end;\r\nreturn (self[\"@results\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"results:",0
,(
function(self,array)
(function()
	local _s8_value=(array)
	self["@results"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"Tools-accessing","results: array\r\n\t\" Set the results of the receiver. \"\r\n\r\n\tresults := array","(\r\nfunction(self,array)\r\n(function()\r\n\tlocal _s8_value=(array)\r\n\tself[\"@results\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"rootClasses",0
,(
function(self)
if (smalltalk:isNil_((self["@rootClasses"])))==true then return ((smalltalk.Smalltalk):rootClasses()); end;
return (self["@rootClasses"]);
end
)
,"Tools-accessing","rootClasses\r\n\t\" Return the rootClasses of the receiver. \"\r\n\r\n\trootClasses isNil ifTrue: [ ^Smalltalk rootClasses ].\r\n\t^rootClasses","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@rootClasses\"])))==true then return ((smalltalk.Smalltalk):rootClasses()); end;\r\nreturn (self[\"@rootClasses\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"allMethodsIn:",0
,(
function(self,aCollection)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
((self):rootClasses()):do_((function(root)
return ((((root):instanceClass()):withAllSubclasses()):do_((function(cls)
(cls):methodsDo_((function(each)
return ((result):add_(each))
end));return (((cls)["$klass"]):methodsDo_((function(each)
return ((result):add_(each))
end)))
end)))
end));
return (result);
end
)
,"Tools-accessing","allMethodsIn: aCollection\r\n\t\" Return the methods defined by aCollection of classes. \"\r\n\r\n\t| result |\r\n\tresult := Array new.\r\n\tself rootClasses do: [:root|\r\n\t\troot instanceClass withAllSubclasses do: [:cls|\r\n\t\t\tcls methodsDo: [:each| result add: each ].\r\n\t\t\tcls class methodsDo: [:each| result add: each ].\r\n\t\t]\r\n\t].\r\n\t^result","(\r\nfunction(self,aCollection)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):rootClasses()):do_((function(root)\r\nreturn ((((root):instanceClass()):withAllSubclasses()):do_((function(cls)\r\n(cls):methodsDo_((function(each)\r\nreturn ((result):add_(each))\r\nend));return (((cls)[\"$klass\"]):methodsDo_((function(each)\r\nreturn ((result):add_(each))\r\nend)))\r\nend)))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"allMethods",0
,(
function(self)
return ((self):triggerEvent_ifNotHandled_("needsMethods",(function()
return ((self):allMethodsIn_((self):rootClasses()))
end)));
end
)
,"Tools-accessing","allMethods\r\n\t\" Return the methods to search the receiver. \"\r\n\r\n\t^self\ttriggerEvent: #needsMethods\r\n\t\tifNotHandled: [ self allMethodsIn: self rootClasses ]","(\r\nfunction(self)\r\nreturn ((self):triggerEvent_ifNotHandled_(\"needsMethods\",(function()\r\nreturn ((self):allMethodsIn_((self):rootClasses()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"search:with:",0
,(
function(self,what,targetBlock)
local atoms=nil
(function()
	local _s8_value=((self):allMethods())
	atoms=_s8_value
	return _s8_value
end)();
(self):triggerEvent_("searchStarted");
(function()
	local _s8_value=((atoms):select_((function(aMethod)
local source=nil
(function()
	local _s8_value=((targetBlock):value_(aMethod))
	source=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((source))),(function()
return ((smalltalk:toString_((source))):includes_(what))
end))),(function()
((self):results()):add_(aMethod);(self):triggerEvent_with_("found:",aMethod);if ((self):hasActionForEvent_("found:pattern:in:"))==true then local stream=nil
local args=nil
(function()
	local _s8_value=((smalltalk:toString_((source))):stream())
	stream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.Array):with_with_with_(aMethod,what,stream))
	args=_s8_value
	return _s8_value
end)();
smalltalk:whileNot_do_(((function()
return ((
function(_s8_rec)
	(_s8_rec):upTo_(what);
	return ((_s8_rec):atEnd())
end
)(stream))
end)),(function()
return ((self):triggerEvent_withArguments_("found:pattern:in:",args))
end)); end;return (true)
end),(function()
return (false)
end)))
end)))
	atoms=_s8_value
	return _s8_value
end)();
(self):triggerEvent_("searchFinished");
return (atoms);
end
)
,"Tools-searching","search: what with: targetBlock\r\n\t\" Find what on target of selected methods. \"\r\n\r\n\t| atoms |\r\n\tatoms := self allMethods.\r\n\tself triggerEvent: #searchStarted.\r\n\tatoms := atoms select: [:aMethod| | source |\r\n\t\tsource := targetBlock value: aMethod.\r\n\t\t(source notNil and: [source toString includes: what]) ifTrue: [\r\n\t\t\tself results add: aMethod.\r\n\t\t\tself triggerEvent: #found: with: aMethod.\r\n\t\t\t(self hasActionForEvent: #found:pattern:in:) ifTrue: [ | stream args |\r\n\t\t\t\tstream := source toString stream.\r\n\t\t\t\targs := Array with: aMethod with: what with: stream.\r\n\t\t\t\t[ stream upTo: what; atEnd ] whileFalse: [\r\n\t\t\t\t\tself triggerEvent: #found:pattern:in: withArguments: args\r\n\t\t\t\t]\r\n\t\t\t].\r\n\t\t\ttrue\r\n\t\t] ifFalse: [ false ]\r\n\t].\r\n\tself triggerEvent: #searchFinished.\r\n\t^atoms","(\r\nfunction(self,what,targetBlock)\r\nlocal atoms=nil\r\n(function()\r\n\tlocal _s8_value=((self):allMethods())\r\n\tatoms=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):triggerEvent_(\"searchStarted\");\r\n(function()\r\n\tlocal _s8_value=((atoms):select_((function(aMethod)\r\nlocal source=nil\r\n(function()\r\n\tlocal _s8_value=((targetBlock):value_(aMethod))\r\n\tsource=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((source))),(function()\r\nreturn ((smalltalk:toString_((source))):includes_(what))\r\nend))),(function()\r\n((self):results()):add_(aMethod);(self):triggerEvent_with_(\"found:\",aMethod);if ((self):hasActionForEvent_(\"found:pattern:in:\"))==true then local stream=nil\r\nlocal args=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk:toString_((source))):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_with_with_(aMethod,what,stream))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:whileNot_do_(((function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):upTo_(what);\r\n\treturn ((_s8_rec):atEnd())\r\nend\r\n)(stream))\r\nend)),(function()\r\nreturn ((self):triggerEvent_withArguments_(\"found:pattern:in:\",args))\r\nend)); end;return (true)\r\nend),(function()\r\nreturn (false)\r\nend)))\r\nend)))\r\n\tatoms=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):triggerEvent_(\"searchFinished\");\r\nreturn (atoms);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"search:",0
,(
function(self,what)
return ((self):search_with_(what,(function(aMethod)
return ((aMethod):compiledSource())
end)));
end
)
,"Tools-searching","search: what\r\n\t\" Find references to what in selected methods.\r\n\tNote: search is realized on native source of native code of methods.\r\n\t\"\r\n\r\n\t^self search: what with: [:aMethod| aMethod compiledSource ]","(\r\nfunction(self,what)\r\nreturn ((self):search_with_(what,(function(aMethod)\r\nreturn ((aMethod):compiledSource())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"searchSource:",0
,(
function(self,what)
return ((self):search_with_(what,(function(aMethod)
return ((aMethod):source())
end)));
end
)
,"Tools-searching","searchSource: what\r\n\t\" Find what in source of selected methods. \"\r\n\r\n\t^self search: what with: [:aMethod| aMethod source ]","(\r\nfunction(self,what)\r\nreturn ((self):search_with_(what,(function(aMethod)\r\nreturn ((aMethod):source())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"inlines",0
,(
function(self)
return ((self):searchSource_(smalltalk:object_comma_(("{"),"'")));
end
)
,"Tools-searching","inlines\r\n\t\" Find native inlines in selected methods. \"\r\n\r\n\t^self searchSource: ${ ,$' ","(\r\nfunction(self)\r\nreturn ((self):searchSource_(smalltalk:object_comma_((\"{\"),\"'\")));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"searchCategory:",0
,(
function(self,aName)
local found=nil
(self):triggerEvent_("searchStarted");
(function()
	local _s8_value=(((smalltalk.Exporter):new()):matchCategory_from_(aName,(self):rootClasses()))
	found=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:object_comma_(((found):first()),(found):last()))
	found=_s8_value
	return _s8_value
end)();
(found):do_((function(each)
((self):results()):add_(each);return ((self):triggerEvent_with_("found:",each))
end));
(self):triggerEvent_("searchFinished");
return (found);
end
)
,"Tools-searching","searchCategory: aName\r\n\t\" Find (source) references to category starting from root classes. \"\r\n\r\n\t| found |\r\n\tself triggerEvent: #searchStarted.\r\n\tfound := Exporter new matchCategory: aName from: self rootClasses.\r\n\tfound := found first , found last.\r\n\tfound do: [:each|\r\n\t\t\tself results add: each.\r\n\t\t\tself triggerEvent: #found: with: each.\r\n\t].\r\n\tself triggerEvent: #searchFinished.\r\n\t^found","(\r\nfunction(self,aName)\r\nlocal found=nil\r\n(self):triggerEvent_(\"searchStarted\");\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.Exporter):new()):matchCategory_from_(aName,(self):rootClasses()))\r\n\tfound=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((found):first()),(found):last()))\r\n\tfound=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(found):do_((function(each)\r\n((self):results()):add_(each);return ((self):triggerEvent_with_(\"found:\",each))\r\nend));\r\n(self):triggerEvent_(\"searchFinished\");\r\nreturn (found);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"sendPatternsOf:",0
,(
function(self,aSelector)
return ((smalltalk.Array):with_with_((self):normalSendPatternOf_(aSelector),(self):superSendPatternOf_(aSelector)));
end
)
,"Tools-patterns","sendPatternsOf: aSelector\r\n\t\" Private - Return the search patterns for references of aSelector. \"\r\n\r\n\t^Array\r\n\t\twith: (self normalSendPatternOf: aSelector)\r\n\t\twith: (self superSendPatternOf: aSelector)","(\r\nfunction(self,aSelector)\r\nreturn ((smalltalk.Array):with_with_((self):normalSendPatternOf_(aSelector),(self):superSendPatternOf_(aSelector)));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"dot",0
,(
function(self)
return (":");
end
)
,"Tools-patterns","dot\r\n\t\" Private - Return the message send pattern starter. \"\r\n\r\n\t^{''}","(\r\nfunction(self)\r\nreturn (\":\");\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"localDef",0
,(
function(self)
return ("local ");
end
)
,"Tools-patterns","localDef\r\n\t\" Private - Return the variable definition starter. \"\r\n\r\n\t^{''}","(\r\nfunction(self)\r\nreturn (\"local \");\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"normalSendStarter:",0
,(
function(self,aSelector)

return ((self):dot());
end
)
,"Tools-patterns","normalSendStarter: aSelector\r\n\t\" Private - Return the pattern for detecting normal senders of aSelector. \"\r\n\r\n\t{'self'}.\r\n\t^self dot","(\r\nfunction(self,aSelector)\r\n\r\nreturn ((self):dot());\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"normalSendPatternOf:",0
,(
function(self,aSelector)
return (smalltalk:object_comma_((smalltalk:object_comma_(((self):normalSendStarter_(aSelector)),(aSelector):asSelector())),"("));
end
)
,"Tools-patterns","normalSendPatternOf: aSelector\r\n\t\" Private - Return the search pattern for normal senders of aSelector. \"\r\n\r\n\t^(self normalSendStarter: aSelector)\r\n\t\t,aSelector asSelector\r\n\t\t,$( ","(\r\nfunction(self,aSelector)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_(((self):normalSendStarter_(aSelector)),(aSelector):asSelector())),\"(\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"superJSSendPatternOf:",0
,(
function(self,aSelector)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("\""),(aSelector):asSelector())),"\"")),").apply(self,"));
end
)
,"Tools-patterns","superJSSendPatternOf: aSelector\r\n\t\" Private - Return the search pattern for senders (to super) of aSelector. \"\r\n\r\n\t^$\" ,aSelector asSelector ,$\" ,').apply(self,'","(\r\nfunction(self,aSelector)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),(aSelector):asSelector())),\"\\\"\")),\").apply(self,\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"superSendPatternOf:",0
,(
function(self,aSelector)
return (self:superLuaSendPatternOf_(aSelector));
end
)
,"Tools-patterns","superSendPatternOf: aSelector\r\n\t\" Private - Return the search pattern for senders (to super) of aSelector. \"\r\n\r\n\t^{''}","(\r\nfunction(self,aSelector)\r\nreturn (self:superLuaSendPatternOf_(aSelector));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"instVarPatternOf:",0
,(
function(self,instVarName)
return (smalltalk:object_comma_((smalltalk:object_comma_(("self[\"@"),(instVarName):asNativeName())),"\"]"));
end
)
,"Tools-patterns","instVarPatternOf: instVarName\r\n\t\" Private - Return the search pattern for instance variable access. \"\r\n\r\n\t^'self[\"@' ,instVarName asNativeName ,'\"]'","(\r\nfunction(self,instVarName)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"self[\\\"@\"),(instVarName):asNativeName())),\"\\\"]\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"globalPatternOf:",0
,(
function(self,globalName)
return (smalltalk:object_comma_(("smalltalk."),globalName));
end
)
,"Tools-patterns","globalPatternOf: globalName\r\n\t\" Private - Return the search pattern for global variable access. \"\r\n\r\n\t^'smalltalk.' ,globalName","(\r\nfunction(self,globalName)\r\nreturn (smalltalk:object_comma_((\"smalltalk.\"),globalName));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"types",0
,(
function(self)
return (smalltalk:newArray({"referencesOf:", "referencesOfGlobal:", "referencesOfClassVariable:", "referencesOfInstanceVariable:", "findClasses:", "findMessages:", "searchCategory:", "search:", "searchSource:", "globalReferences", "missingGlobals", "inlines", "methodOverwrites", "variableOverwrites"}));
end
)
,"Tools-types","types\r\n\t\" Private - Return the types of search implemented by the receiver. \"\r\n\r\n\t^#(\t#referencesOf: #referencesOfGlobal:\r\n\t\t#referencesOfClassVariable: \r\n\t\t#referencesOfInstanceVariable:\r\n\t\t#findClasses: #findMessages:\r\n\t\t#searchCategory:\r\n\t\t#search: #searchSource:\r\n\t\t#globalReferences #missingGlobals #inlines\r\n\t\t#methodOverwrites #variableOverwrites\r\n\t)","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"referencesOf:\", \"referencesOfGlobal:\", \"referencesOfClassVariable:\", \"referencesOfInstanceVariable:\", \"findClasses:\", \"findMessages:\", \"searchCategory:\", \"search:\", \"searchSource:\", \"globalReferences\", \"missingGlobals\", \"inlines\", \"methodOverwrites\", \"variableOverwrites\"}));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"search:type:",0
,(
function(self,aName,typeSelector)
local selector=nil
(function()
	local _s8_value=(smalltalk:if_true_false_(((typeSelector):includes_(":")),(function()
return (smalltalk:object_comma_(((typeSelector):upTo_(":")),":"))
end),(function()
return ((typeSelector):upTo_(" "))
end)))
	selector=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:responds_to_((self),(selector))),(function()
return ((self):perform_with_(selector,(aName):trimBlanks()))
end),nil));
end
)
,"Tools-searching","search: aName type: typeSelector\r\n\t\" Return the result of searching for aName as a search of specified type (or nil). \"\r\n\r\n\t| selector |\r\n\tselector := (typeSelector includes: $:)\r\n\tifTrue: [ (typeSelector upTo: $:) ,$: ]\r\n\tifFalse: [ typeSelector upTo: $  ].\r\n\t^(self respondsTo: selector) ifTrue: [\r\n\t\tself perform: selector with: aName trimBlanks\r\n\t]","(\r\nfunction(self,aName,typeSelector)\r\nlocal selector=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((typeSelector):includes_(\":\")),(function()\r\nreturn (smalltalk:object_comma_(((typeSelector):upTo_(\":\")),\":\"))\r\nend),(function()\r\nreturn ((typeSelector):upTo_(\" \"))\r\nend)))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:responds_to_((self),(selector))),(function()\r\nreturn ((self):perform_with_(selector,(aName):trimBlanks()))\r\nend),nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"sendersOf:",0
,(
function(self,aSelector)
return (((self):sendPatternsOf_(aSelector)):inject_into_(smalltalk:newArray({}),(function(total,each)
return ((
function(_s8_rec)
	(_s8_rec):addAll_((self):search_(each));
	return ((_s8_rec):yourself())
end
)(total))
end)));
end
)
,"Tools-searching","sendersOf: aSelector\r\n\t\" Find the requested elements from root classes. \"\r\n\r\n\t^(self sendPatternsOf: aSelector) inject: #() into: [:total :each|\r\n\t\ttotal addAll: (self search: each); yourself\r\n\t]","(\r\nfunction(self,aSelector)\r\nreturn (((self):sendPatternsOf_(aSelector)):inject_into_(smalltalk:newArray({}),(function(total,each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAll_((self):search_(each));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(total))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"referencesOf:",0
,(
function(self,aSelector)
(
function(_s8_rec)
	(_s8_rec):add_(smalltalk:object_comma_((smalltalk:object_comma_(("--- Implementors of #"),aSelector))," ---"));
	(_s8_rec):addAll_((self):implementorsOf_(aSelector));
	return ((_s8_rec):add_(smalltalk:object_comma_((smalltalk:object_comma_(("--- Senders of #"),aSelector))," ---")))
end
)((self):results());
(self):sendersOf_(aSelector);
return (self["@results"]);
end
)
,"Tools-searching","referencesOf: aSelector\r\n\t\" Find the references to message (aSelector). \"\r\n\r\n\tself results\r\n\t\tadd: '--- Implementors of #' ,aSelector ,' ---';\r\n\t\taddAll: (self implementorsOf: aSelector);\r\n\t\tadd: '--- Senders of #' ,aSelector ,' ---'.\r\n\tself sendersOf: aSelector.\r\n\t^results","(\r\nfunction(self,aSelector)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(smalltalk:object_comma_((smalltalk:object_comma_((\"--- Implementors of #\"),aSelector)),\" ---\"));\r\n\t(_s8_rec):addAll_((self):implementorsOf_(aSelector));\r\n\treturn ((_s8_rec):add_(smalltalk:object_comma_((smalltalk:object_comma_((\"--- Senders of #\"),aSelector)),\" ---\")))\r\nend\r\n)((self):results());\r\n(self):sendersOf_(aSelector);\r\nreturn (self[\"@results\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"referencesOfInstanceVariable:",0
,(
function(self,instVarName)
return ((self):search_((self):instVarPatternOf_(instVarName)));
end
)
,"Tools-searching","referencesOfInstanceVariable: instVarName\r\n\t\" Find the requested elements from root classes. \"\r\n\r\n\t^self search: (self instVarPatternOf: instVarName)","(\r\nfunction(self,instVarName)\r\nreturn ((self):search_((self):instVarPatternOf_(instVarName)));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"settersOfInstanceVariable:",0
,(
function(self,instVarName)
return ((self):search_(smalltalk:object_comma_(((self):instVarPatternOf_(instVarName)),"=")));
end
)
,"Tools-searching","settersOfInstanceVariable: instVarName\r\n\t\" Find the requested elements from root classes. \"\r\n\r\n\t^self search: (self instVarPatternOf: instVarName) ,'='","(\r\nfunction(self,instVarName)\r\nreturn ((self):search_(smalltalk:object_comma_(((self):instVarPatternOf_(instVarName)),\"=\")));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"referencesOfGlobal:",0
,(
function(self,globalName)
return ((self):search_((self):globalPatternOf_(globalName)));
end
)
,"Tools-searching","referencesOfGlobal: globalName\r\n\t\" Find the requested elements from root classes. \"\r\n\r\n\t^self search: (self globalPatternOf: globalName)","(\r\nfunction(self,globalName)\r\nreturn ((self):search_((self):globalPatternOf_(globalName)));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"searchGlobalReferences",0
,(
function(self)
return ((self):search_((self):globalPatternOf_("")));
end
)
,"Tools-searching","searchGlobalReferences\r\n\t\" Find the requested elements from root classes. \"\r\n\r\n\t^self search: (self globalPatternOf: '')","(\r\nfunction(self)\r\nreturn ((self):search_((self):globalPatternOf_(\"\")));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"settersOfGlobalVariable:",0
,(
function(self,globalName)
return ((self):search_(smalltalk:object_comma_(((self):globalPatternOf_(globalName)),"=")));
end
)
,"Tools-searching","settersOfGlobalVariable: globalName\r\n\t\" Find the requested elements from root classes. \"\r\n\r\n\t^self search: (self globalPatternOf: globalName) ,'='","(\r\nfunction(self,globalName)\r\nreturn ((self):search_(smalltalk:object_comma_(((self):globalPatternOf_(globalName)),\"=\")));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"referencesOfClassVariable:",0
,(
function(self,classVarName)
return ((
function(_s8_rec)
	(_s8_rec):add_(smalltalk:object_comma_((smalltalk:object_comma_(("--- Getters of "),classVarName))," ---"));
	(_s8_rec):addAll_((self):gettersOfClassVariable_(classVarName));
	(_s8_rec):add_(smalltalk:object_comma_((smalltalk:object_comma_(("--- Setters of "),classVarName))," ---"));
	(_s8_rec):addAll_((self):settersOfClassVariable_(classVarName));
	return ((_s8_rec):yourself())
end
)((self):results()));
end
)
,"Tools-searching","referencesOfClassVariable: classVarName\r\n\t\" Find the requested elements from root classes. \"\r\n\r\n\t^self results\r\n\t\tadd: '--- Getters of ' ,classVarName ,' ---';\r\n\t\taddAll: (self gettersOfClassVariable: classVarName);\r\n\t\tadd: '--- Setters of ' ,classVarName ,' ---';\r\n\t\taddAll: (self settersOfClassVariable: classVarName);\r\n\t\tyourself","(\r\nfunction(self,classVarName)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(smalltalk:object_comma_((smalltalk:object_comma_((\"--- Getters of \"),classVarName)),\" ---\"));\r\n\t(_s8_rec):addAll_((self):gettersOfClassVariable_(classVarName));\r\n\t(_s8_rec):add_(smalltalk:object_comma_((smalltalk:object_comma_((\"--- Setters of \"),classVarName)),\" ---\"));\r\n\t(_s8_rec):addAll_((self):settersOfClassVariable_(classVarName));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):results()));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"gettersOfClassVariable:",0
,(
function(self,classVarName)
return ((self):search_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):dot()),"classVariableAt_(\"")),classVarName)),"\")")));
end
)
,"Tools-searching","gettersOfClassVariable: classVarName\r\n\t\" Find the requested elements from root classes. \"\r\n\r\n\t^self search: self dot,'classVariableAt_(\"',classVarName,'\")'","(\r\nfunction(self,classVarName)\r\nreturn ((self):search_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):dot()),\"classVariableAt_(\\\"\")),classVarName)),\"\\\")\")));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"settersOfClassVariable:",0
,(
function(self,classVarName)
return ((self):search_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):dot()),"classVariableAt_put_(\"")),classVarName)),"\",")));
end
)
,"Tools-searching","settersOfClassVariable: classVarName\r\n\t\" Find the requested elements from root classes. \"\r\n\r\n\t^self search: self dot,'classVariableAt_put_(\"',classVarName,'\",'","(\r\nfunction(self,classVarName)\r\nreturn ((self):search_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):dot()),\"classVariableAt_put_(\\\"\")),classVarName)),\"\\\",\")));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"globalReferences",0
,(
function(self)
local pool=nil
(function()
	local _s8_value=(((self)["$klass"]):globals())
	pool=_s8_value
	return _s8_value
end)();
(((pool):keys()):sorted()):do_((function(aName)
return ((
function(_s8_rec)
	(_s8_rec):add_(smalltalk:object_comma_((smalltalk:object_comma_(("--- References to: "),aName))," ---"));
	return ((_s8_rec):addAll_((pool):at_(aName)))
end
)((self):results()))
end));
return (self["@results"]);
end
)
,"Tools-searching","globalReferences\r\n\t\" Find the references to globals. \"\r\n\r\n\t| pool |\r\n\tpool := self class globals.\r\n\tpool keys sorted do: [:aName|\r\n\t\tself results\r\n\t\t\tadd: '--- References to: ',aName,' ---';\r\n\t\t\taddAll: (pool at: aName)\r\n\t].\r\n\t^results","(\r\nfunction(self)\r\nlocal pool=nil\r\n(function()\r\n\tlocal _s8_value=(((self)[\"$klass\"]):globals())\r\n\tpool=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(((pool):keys()):sorted()):do_((function(aName)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(smalltalk:object_comma_((smalltalk:object_comma_((\"--- References to: \"),aName)),\" ---\"));\r\n\treturn ((_s8_rec):addAll_((pool):at_(aName)))\r\nend\r\n)((self):results()))\r\nend));\r\nreturn (self[\"@results\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"missingGlobals",0
,(
function(self)
local pool=nil
(function()
	local _s8_value=(((self)["$klass"]):globals())
	pool=_s8_value
	return _s8_value
end)();
((((pool):keys()):sorted()):reject_((function(key)
return ((smalltalk.Smalltalk):includesKey_(key))
end))):do_((function(aName)
return ((
function(_s8_rec)
	(_s8_rec):add_(smalltalk:object_comma_((smalltalk:object_comma_(("--- Missing global: "),aName))," ---"));
	return ((_s8_rec):addAll_((pool):at_(aName)))
end
)((self):results()))
end));
if (((self):results()):isEmpty())==true then ((self):results()):add_("--- All global references are bound to Smalltalk ---"); end;
return (self["@results"]);
end
)
,"Tools-searching","missingGlobals\r\n\t\" Find the references to missing globals. \"\r\n\r\n\t| pool |\r\n\tpool := self class globals.\r\n\t(pool keys sorted\r\n\t\treject: [:key| (Smalltalk includesKey: key) ])\r\n\t\tdo: [:aName|\r\n\t\t\tself results\r\n\t\t\t\tadd: '--- Missing global: ',aName,' ---';\r\n\t\t\t\taddAll: (pool at: aName)\r\n\t\t].\r\n\tself results isEmpty ifTrue: [\r\n\t\tself results add: '--- All global references are bound to Smalltalk ---'\r\n\t].\r\n\t^results","(\r\nfunction(self)\r\nlocal pool=nil\r\n(function()\r\n\tlocal _s8_value=(((self)[\"$klass\"]):globals())\r\n\tpool=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((((pool):keys()):sorted()):reject_((function(key)\r\nreturn ((smalltalk.Smalltalk):includesKey_(key))\r\nend))):do_((function(aName)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(smalltalk:object_comma_((smalltalk:object_comma_((\"--- Missing global: \"),aName)),\" ---\"));\r\n\treturn ((_s8_rec):addAll_((pool):at_(aName)))\r\nend\r\n)((self):results()))\r\nend));\r\nif (((self):results()):isEmpty())==true then ((self):results()):add_(\"--- All global references are bound to Smalltalk ---\"); end;\r\nreturn (self[\"@results\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"implementorsOf:",0
,(
function(self,aSelector)
return (((smalltalk.Smalltalk):current()):implementorsOf_(aSelector));
end
)
,"Tools-private","implementorsOf: aSelector\r\n\t\" Private - Return the implementors of aSelector. \"\r\n\r\n\t^Smalltalk current implementorsOf: aSelector","(\r\nfunction(self,aSelector)\r\nreturn (((smalltalk.Smalltalk):current()):implementorsOf_(aSelector));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"compiledSourceStart",0
,(
function(self)
return ("(");
end
)
,"Tools-patterns","compiledSourceStart\r\n\t\" Private - Return the token for start of compiled code. \"\r\n\r\n\t^{''}","(\r\nfunction(self)\r\nreturn (\"(\");\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"messagesStreamOn:",0
,(
function(self,aCompiledMethod)
local stream=nil
local nativeMessage=nil
(function()
	local _s8_value=(smalltalk:object_comma_(((self):nativeLanguage()),"MessagesStreamOn:"))
	nativeMessage=_s8_value
	return _s8_value
end)();
if (smalltalk:responds_to_((self),(nativeMessage)))==true then return ((self):perform_with_(nativeMessage,aCompiledMethod)); end;
(function()
	local _s8_value=(((aCompiledMethod):compiledSource()):stream())
	stream=_s8_value
	return _s8_value
end)();
(stream):upTo_((self):compiledSourceStart());
return (stream);
end
)
,"Tools-patterns","messagesStreamOn: aCompiledMethod\r\n\t\" Private - Return the stream for reading messages on compiled code of aCompiledMethod. \"\r\n\r\n\t| stream nativeMessage |\r\n\tnativeMessage := self nativeLanguage ,#MessagesStreamOn:.\r\n\t(self respondsTo: nativeMessage) ifTrue: [\r\n\t\t^self perform: nativeMessage with: aCompiledMethod\r\n\t].\r\n\tstream := aCompiledMethod compiledSource stream.\r\n\tstream upTo: self compiledSourceStart.\r\n\t^stream ","(\r\nfunction(self,aCompiledMethod)\r\nlocal stream=nil\r\nlocal nativeMessage=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((self):nativeLanguage()),\"MessagesStreamOn:\"))\r\n\tnativeMessage=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:responds_to_((self),(nativeMessage)))==true then return ((self):perform_with_(nativeMessage,aCompiledMethod)); end;\r\n(function()\r\n\tlocal _s8_value=(((aCompiledMethod):compiledSource()):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(stream):upTo_((self):compiledSourceStart());\r\nreturn (stream);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"nextMessageIn:",0
,(
function(self,stream)
local dot=nil
(function()
	local _s8_value=((self):dot())
	dot=_s8_value
	return _s8_value
end)();
return (((((
function(_s8_rec)
	(_s8_rec):upTo_(dot);
	return ((_s8_rec):upTo_("("))
end
)(stream)):asArrayOfSubstringsSeparatedBy_(dot)):last()):asNativeSelector());
end
)
,"Tools-messages","nextMessageIn: stream\r\n\t\" Private - Return the next sent encoded in native source stream. \"\r\n\r\n\t| dot |\r\n\tdot := self dot.\r\n\t^((stream upTo: dot; upTo: $(\r\n\t) asArrayOfSubstringsSeparatedBy: dot)\r\n\tlast asNativeSelector","(\r\nfunction(self,stream)\r\nlocal dot=nil\r\n(function()\r\n\tlocal _s8_value=((self):dot())\r\n\tdot=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):upTo_(dot);\r\n\treturn ((_s8_rec):upTo_(\"(\"))\r\nend\r\n)(stream)):asArrayOfSubstringsSeparatedBy_(dot)):last()):asNativeSelector());\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"messagesOf:",0
,(
function(self,aCompiledMethod)
local stream=nil
local selectors=nil
local getMessage=nil
(function()
	local _s8_value=((self):messagesStreamOn_(aCompiledMethod))
	stream=_s8_value
	return _s8_value
end)();
if ((stream):atEnd())==true then return (smalltalk:newArray({})); end;
(function()
	local _s8_value=(smalltalk:object_comma_(((self):nativeLanguage()),"NextMessageIn:"))
	getMessage=_s8_value
	return _s8_value
end)();
if not ((smalltalk:responds_to_((self),(getMessage))))==true then (function()
	local _s8_value=("nextMessageIn:")
	getMessage=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=((smalltalk.HashedSet):new())
	selectors=_s8_value
	return _s8_value
end)();
while not ((function()
return ((stream):atEnd())
end))() do (selectors):add_((self):perform_with_(getMessage,stream)); end;
(selectors):remove_ifAbsent_("",(function()
return (nil)
end));
return ((((selectors):asArray()):select_((function(each)
return ((each):isLiteral())
end))):sorted());
end
)
,"Tools-accessing","messagesOf: aCompiledMethod\r\n\t\" Return all the messages that can be sent during execution of aCompiledMethod. \"\r\n\r\n\t| stream selectors getMessage |\r\n\tstream := self messagesStreamOn: aCompiledMethod.\r\n\tstream atEnd ifTrue: [ ^#() ].\r\n\tgetMessage := self nativeLanguage ,#NextMessageIn:.\r\n\t(self respondsTo: getMessage) ifFalse: [\r\n\t\tgetMessage := #nextMessageIn:\r\n\t].\r\n\tselectors := HashedSet new.\r\n\t[ stream atEnd ] whileFalse: [\r\n\t\tselectors add: (self perform: getMessage with: stream)\r\n\t].\r\n\tselectors remove: '' ifAbsent: [].\r\n\t^(selectors asArray select: [:each| each isLiteral ]) sorted","(\r\nfunction(self,aCompiledMethod)\r\nlocal stream=nil\r\nlocal selectors=nil\r\nlocal getMessage=nil\r\n(function()\r\n\tlocal _s8_value=((self):messagesStreamOn_(aCompiledMethod))\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((stream):atEnd())==true then return (smalltalk:newArray({})); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((self):nativeLanguage()),\"NextMessageIn:\"))\r\n\tgetMessage=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:responds_to_((self),(getMessage))))==true then (function()\r\n\tlocal _s8_value=(\"nextMessageIn:\")\r\n\tgetMessage=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.HashedSet):new())\r\n\tselectors=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((stream):atEnd())\r\nend))() do (selectors):add_((self):perform_with_(getMessage,stream)); end;\r\n(selectors):remove_ifAbsent_(\"\",(function()\r\nreturn (nil)\r\nend));\r\nreturn ((((selectors):asArray()):select_((function(each)\r\nreturn ((each):isLiteral())\r\nend))):sorted());\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"globalReferencesOf:",0
,(
function(self,aCompiledMethod)
local result=nil
(function()
	local _s8_value=((smalltalk.HashedSet):new())
	result=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):when_do_("needsMethods",(function()
return ((smalltalk.Array):with_(aCompiledMethod))
end));
	(_s8_rec):when_do_("found:pattern:in:",(function(mth,mask,stream)
local global=nil
(function()
	local _s8_value=((((smalltalk.SmalltalkParser):new()):globalNameParser()):parse_(stream))
	global=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_(((global):isParseFailure()),nil,(function()
return ((result):add_(global))
end)))
end));
	return ((_s8_rec):yourself())
end
)(self);
(self):searchGlobalReferences();
return (((result):asArray()):sorted());
end
)
,"Tools-accessing","globalReferencesOf: aCompiledMethod\r\n\t\" Return all the global reference names in aCompiledMethod. \"\r\n\r\n\t| result |\r\n\tresult := HashedSet new.\r\n\tself\r\n\t\twhen: #needsMethods do: [ Array with: aCompiledMethod ];\r\n\t\twhen: #found:pattern:in: do: [:mth :mask :stream| | global |\r\n\t\t\tglobal := SmalltalkParser new globalNameParser parse: stream.\r\n\t\t\tglobal isParseFailure ifFalse: [ result add: global ].\r\n\t\t];\r\n\t\tyourself.\r\n\tself searchGlobalReferences.\r\n\t^result asArray sorted","(\r\nfunction(self,aCompiledMethod)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.HashedSet):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):when_do_(\"needsMethods\",(function()\r\nreturn ((smalltalk.Array):with_(aCompiledMethod))\r\nend));\r\n\t(_s8_rec):when_do_(\"found:pattern:in:\",(function(mth,mask,stream)\r\nlocal global=nil\r\n(function()\r\n\tlocal _s8_value=((((smalltalk.SmalltalkParser):new()):globalNameParser()):parse_(stream))\r\n\tglobal=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_(((global):isParseFailure()),nil,(function()\r\nreturn ((result):add_(global))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(self);\r\n(self):searchGlobalReferences();\r\nreturn (((result):asArray()):sorted());\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"findClasses:",0
,(
function(self,what)
local keys=nil
local system=nil
if ((what):isString())==true then return ((self):findClasses_(((what):trimBlanks()):asArrayOfSubstrings())); end;
(self):triggerEvent_("searchStarted");
(function()
	local _s8_value=((what):collect_((function(each)
return ((smalltalk:asString_((each))):asLowercase())
end)))
	keys=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.Smalltalk):current())
	system=_s8_value
	return _s8_value
end)();
if ((keys):notEmpty())==true then ((system):classes()):do_((function(aClass)
local key=nil
(function()
	local _s8_value=(((aClass):name()):asLowercase())
	key=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_(((keys):detect_ifNone_((function(one)
return ((key):includes_(one))
end),(function()
return (nil)
end))))),(function()
((self):results()):add_(aClass);return ((self):triggerEvent_with_("found:",aClass))
end),nil))
end)); end;
(self):triggerEvent_("searchFinished");
return ((self):results());
end
)
,"Tools-searching","findClasses: what\r\n\t\" Find classes matching what. \"\r\n\r\n\t| keys system |\r\n\twhat isString ifTrue: [\r\n\t\t^self findClasses: what trimBlanks asArrayOfSubstrings\r\n\t].\r\n\tself triggerEvent: #searchStarted.\r\n\tkeys := what collect: [:each| each asString asLowercase ].\r\n\tsystem := Smalltalk current.\r\n\tkeys notEmpty ifTrue: [\r\n\t\tsystem classes do: [:aClass| | key |\r\n\t\t\tkey := aClass name asLowercase.\r\n\t\t\t(keys detect: [:one| key includes: one ] ifNone: []) notNil ifTrue: [\r\n\t\t\t\tself results add: aClass.\r\n\t\t\t\tself triggerEvent: #found: with: aClass.\r\n\t\t\t]\r\n\t\t].\r\n\t].\r\n\tself triggerEvent: #searchFinished.\r\n\t^self results","(\r\nfunction(self,what)\r\nlocal keys=nil\r\nlocal system=nil\r\nif ((what):isString())==true then return ((self):findClasses_(((what):trimBlanks()):asArrayOfSubstrings())); end;\r\n(self):triggerEvent_(\"searchStarted\");\r\n(function()\r\n\tlocal _s8_value=((what):collect_((function(each)\r\nreturn ((smalltalk:asString_((each))):asLowercase())\r\nend)))\r\n\tkeys=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):current())\r\n\tsystem=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((keys):notEmpty())==true then ((system):classes()):do_((function(aClass)\r\nlocal key=nil\r\n(function()\r\n\tlocal _s8_value=(((aClass):name()):asLowercase())\r\n\tkey=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_(((keys):detect_ifNone_((function(one)\r\nreturn ((key):includes_(one))\r\nend),(function()\r\nreturn (nil)\r\nend))))),(function()\r\n((self):results()):add_(aClass);return ((self):triggerEvent_with_(\"found:\",aClass))\r\nend),nil))\r\nend)); end;\r\n(self):triggerEvent_(\"searchFinished\");\r\nreturn ((self):results());\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"methodOverwritesOf:",0
,(
function(self,aClass)
local map=nil
local subclasses=nil
(function()
	local _s8_value=((aClass):allSubclasses())
	subclasses=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	map=_s8_value
	return _s8_value
end)();
if ((subclasses):isEmpty())==true then return (map); end;
(aClass):methodsDo_((function(mth)
local selector=nil
(function()
	local _s8_value=((mth):selector())
	selector=_s8_value
	return _s8_value
end)();(map):at_put_(selector,(smalltalk.Array):with_(mth));return ((subclasses):do_((function(each)
return (smalltalk:if_true_false_((((each):selectors()):includes_(selector)),(function()
return (((map):at_(selector)):add_((each):_gt_gt(selector)))
end),nil))
end)))
end));
(subclasses):do_((function(each)
return (((self):methodOverwritesOf_(each)):keysAndValuesDo_((function(key,value)
return (((map):at_ifAbsentPut_(key,(function()
return ((smalltalk.Array):new())
end))):addAll_(value))
end)))
end));
((((map):keys()):asArray()):select_((function(key)
return (((((map):at_(key)):size()) <= 1))
end))):do_((function(key)
return ((map):removeKey_(key))
end));
return (map);
end
)
,"Tools-private","methodOverwritesOf: aClass\r\n\t\" Private - Find the methods subimplemented by subclasses of aClass. \"\r\n\r\n\t| map subclasses |\r\n\tsubclasses := aClass allSubclasses.\r\n\tmap := PoolDictionary new.\r\n\tsubclasses isEmpty ifTrue: [ ^map ].\r\n\taClass methodsDo: [:mth| | selector |\r\n\t\tselector := mth selector.\r\n\t\tmap at: selector put: (Array with: mth).\r\n\t\tsubclasses do: [:each|\r\n\t\t\t(each selectors includes: selector) ifTrue: [\r\n\t\t\t\t(map at: selector) add: each >> selector\r\n\t\t\t].\r\n\t\t].\r\n\t].\r\n\tsubclasses do: [:each|\r\n\t\t(self methodOverwritesOf: each) keysAndValuesDo: [:key :value|\r\n\t\t\t(map at: key ifAbsentPut: [Array new]) addAll: value\r\n\t\t].\r\n\t].\r\n\t(map keys asArray\r\n\t\tselect: [:key| (map at: key) size <= 1 ]\r\n\t\t) do: [:key| map removeKey: key ].\r\n\t^map","(\r\nfunction(self,aClass)\r\nlocal map=nil\r\nlocal subclasses=nil\r\n(function()\r\n\tlocal _s8_value=((aClass):allSubclasses())\r\n\tsubclasses=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tmap=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((subclasses):isEmpty())==true then return (map); end;\r\n(aClass):methodsDo_((function(mth)\r\nlocal selector=nil\r\n(function()\r\n\tlocal _s8_value=((mth):selector())\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();(map):at_put_(selector,(smalltalk.Array):with_(mth));return ((subclasses):do_((function(each)\r\nreturn (smalltalk:if_true_false_((((each):selectors()):includes_(selector)),(function()\r\nreturn (((map):at_(selector)):add_((each):_gt_gt(selector)))\r\nend),nil))\r\nend)))\r\nend));\r\n(subclasses):do_((function(each)\r\nreturn (((self):methodOverwritesOf_(each)):keysAndValuesDo_((function(key,value)\r\nreturn (((map):at_ifAbsentPut_(key,(function()\r\nreturn ((smalltalk.Array):new())\r\nend))):addAll_(value))\r\nend)))\r\nend));\r\n((((map):keys()):asArray()):select_((function(key)\r\nreturn (((((map):at_(key)):size()) <= 1))\r\nend))):do_((function(key)\r\nreturn ((map):removeKey_(key))\r\nend));\r\nreturn (map);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"addMethodOverwrites:",0
,(
function(self,map)
(map):associationsDo_((function(assoc)
return (((assoc):value()):do_((function(each)
(self):triggerEvent_with_("found:",each);return (((self):results()):add_(each))
end)))
end));
return (self);
end
)
,"Tools-private","addMethodOverwrites: map\r\n\t\" Private - Register the methods overwrites in map. \"\r\n\r\n\tmap associationsDo: [:assoc|\r\n\t\tassoc value do: [:each|\r\n\t\t\tself triggerEvent: #found: with: each.\r\n\t\t\tself results add: each.\r\n\t\t]\r\n\t]","(\r\nfunction(self,map)\r\n(map):associationsDo_((function(assoc)\r\nreturn (((assoc):value()):do_((function(each)\r\n(self):triggerEvent_with_(\"found:\",each);return (((self):results()):add_(each))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"methodOverwrites",0
,(
function(self)
(self):triggerEvent_("searchStarted");
((smalltalk.Smalltalk):rootClasses()):do_((function(aClass)
(self):addMethodOverwrites_((self):methodOverwritesOf_(aClass));return ((self):addMethodOverwrites_((self):methodOverwritesOf_((aClass)["$klass"])))
end));
(self):triggerEvent_("searchFinished");
return ((self):results());
end
)
,"Tools-searching","methodOverwrites\r\n\t\" Find the methods that are implemented/overwritten by subclasses. \"\r\n\r\n\tself triggerEvent: #searchStarted.\r\n\tSmalltalk rootClasses do: [:aClass|\r\n\t\tself addMethodOverwrites: (self methodOverwritesOf: aClass).\r\n\t\tself addMethodOverwrites: (self methodOverwritesOf: aClass class).\r\n\t].\r\n\tself triggerEvent: #searchFinished.\r\n\t^self results","(\r\nfunction(self)\r\n(self):triggerEvent_(\"searchStarted\");\r\n((smalltalk.Smalltalk):rootClasses()):do_((function(aClass)\r\n(self):addMethodOverwrites_((self):methodOverwritesOf_(aClass));return ((self):addMethodOverwrites_((self):methodOverwritesOf_((aClass)[\"$klass\"])))\r\nend));\r\n(self):triggerEvent_(\"searchFinished\");\r\nreturn ((self):results());\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"hasArgumentOverwrites:in:",0
,(
function(self,names,stream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local args=nil
(function()
	local _s8_value=(((
function(_s8_rec)
	(_s8_rec):upTo_("(");
	return ((_s8_rec):upTo_(")"))
end
)(stream)):asArrayOfSubstringsSeparatedBy_(","))
	args=_s8_value
	return _s8_value
end)();
(args):do_((function(each)
return (smalltalk:if_true_false_(((names):includes_(each)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"Tools-private","hasArgumentOverwrites: names in: stream\r\n\t\" Private - Return true if stream of code has argument name conflicts. \"\r\n\r\n\t| args |\r\n\targs := (stream upTo: $(; upTo: $)) asArrayOfSubstringsSeparatedBy: $,.\r\n\targs do: [:each|\r\n\t\t(names includes: each) ifTrue: [ ^true ].\r\n\t].\r\n\t^false","(\r\nfunction(self,names,stream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal args=nil\r\n(function()\r\n\tlocal _s8_value=(((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):upTo_(\"(\");\r\n\treturn ((_s8_rec):upTo_(\")\"))\r\nend\r\n)(stream)):asArrayOfSubstringsSeparatedBy_(\",\"))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(args):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((names):includes_(each)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"hasLocalOverwrites:in:",0
,(
function(self,names,stream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local candidate=nil
while not ((function()
return ((stream):atEnd())
end))() do (function()
	local _s8_value=(((
function(_s8_rec)
	(_s8_rec):upTo_((self):localDef());
	return ((_s8_rec):upTo_("="))
end
)(stream)):trimBlanks())
	candidate=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_(((names):includes_(candidate)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"Tools-private","hasLocalOverwrites: names in: stream\r\n\t\" Private - Return true if stream of code has local name conflicts. \"\r\n\r\n\t| candidate |\r\n\t[stream atEnd] whileFalse: [\r\n\t\tcandidate := (stream upTo: self localDef; upTo: $=) trimBlanks.\r\n\t\t(names includes: candidate) ifTrue: [\r\n\t\t\t^true\r\n\t\t].\r\n\t].\r\n\t^false","(\r\nfunction(self,names,stream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal candidate=nil\r\nwhile not ((function()\r\nreturn ((stream):atEnd())\r\nend))() do (function()\r\n\tlocal _s8_value=(((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):upTo_((self):localDef());\r\n\treturn ((_s8_rec):upTo_(\"=\"))\r\nend\r\n)(stream)):trimBlanks())\r\n\tcandidate=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_(((names):includes_(candidate)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"addVariableOverwrites:in:",0
,(
function(self,names,mth)
local stream=nil
(function()
	local _s8_value=(((mth):compiledSource()):stream())
	stream=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_or_(((self):hasArgumentOverwrites_in_(names,stream)),(function()
return ((self):hasLocalOverwrites_in_(names,stream))
end)))==true then (self):triggerEvent_with_("found:",mth);
((self):results()):add_(mth); end;
return (self);
end
)
,"Tools-private","addVariableOverwrites: names in: mth\r\n\t\" Private - Register the methods that has name overwrites. \"\r\n\r\n\t| stream |\r\n\tstream := mth compiledSource stream.\r\n\t((self hasArgumentOverwrites: names in: stream)\r\n\tor: [ self hasLocalOverwrites: names in: stream ])\r\n\tifTrue: [\r\n\t\tself triggerEvent: #found: with: mth.\r\n\t\tself results add: mth.\r\n\t]","(\r\nfunction(self,names,mth)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=(((mth):compiledSource()):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_or_(((self):hasArgumentOverwrites_in_(names,stream)),(function()\r\nreturn ((self):hasLocalOverwrites_in_(names,stream))\r\nend)))==true then (self):triggerEvent_with_(\"found:\",mth);\r\n((self):results()):add_(mth); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"variableOverwrites",0
,(
function(self)
(self):triggerEvent_("searchStarted");
((smalltalk.Smalltalk):classes()):do_((function(aClass)
local names=nil
(function()
	local _s8_value=((aClass):allInstVarNames())
	names=_s8_value
	return _s8_value
end)();(aClass):methodsDo_((function(mth)
return ((self):addVariableOverwrites_in_(names,mth))
end));(function()
	local _s8_value=(((aClass)["$klass"]):allInstVarNames())
	names=_s8_value
	return _s8_value
end)();return (((aClass)["$klass"]):methodsDo_((function(mth)
return ((self):addVariableOverwrites_in_(names,mth))
end)))
end));
(self):triggerEvent_("searchFinished");
return ((self):results());
end
)
,"Tools-searching","variableOverwrites\r\n\t\" Find the methods that has potential overwrite of variable names. \"\r\n\r\n\tself triggerEvent: #searchStarted.\r\n\tSmalltalk classes do: [:aClass| | names |\r\n\t\tnames := aClass allInstVarNames.\r\n\t\taClass methodsDo: [:mth|\r\n\t\t\tself addVariableOverwrites: names in: mth.\r\n\t\t].\r\n\t\tnames := aClass class allInstVarNames.\r\n\t\taClass class methodsDo: [:mth|\r\n\t\t\tself addVariableOverwrites: names in: mth.\r\n\t\t].\r\n\t].\r\n\tself triggerEvent: #searchFinished.\r\n\t^self results","(\r\nfunction(self)\r\n(self):triggerEvent_(\"searchStarted\");\r\n((smalltalk.Smalltalk):classes()):do_((function(aClass)\r\nlocal names=nil\r\n(function()\r\n\tlocal _s8_value=((aClass):allInstVarNames())\r\n\tnames=_s8_value\r\n\treturn _s8_value\r\nend)();(aClass):methodsDo_((function(mth)\r\nreturn ((self):addVariableOverwrites_in_(names,mth))\r\nend));(function()\r\n\tlocal _s8_value=(((aClass)[\"$klass\"]):allInstVarNames())\r\n\tnames=_s8_value\r\n\treturn _s8_value\r\nend)();return (((aClass)[\"$klass\"]):methodsDo_((function(mth)\r\nreturn ((self):addVariableOverwrites_in_(names,mth))\r\nend)))\r\nend));\r\n(self):triggerEvent_(\"searchFinished\");\r\nreturn ((self):results());\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"findMessages:",0
,(
function(self,what)
local keys=nil
if ((what):isString())==true then return ((self):findMessages_(((what):trimBlanks()):asArrayOfSubstrings())); end;
(self):triggerEvent_("searchStarted");
(function()
	local _s8_value=((what):collect_((function(each)
return (smalltalk:asString_((each)))
end)))
	keys=_s8_value
	return _s8_value
end)();
if ((keys):notEmpty())==true then local all=nil
local collect=nil
(function()
	local _s8_value=((self):allMethods())
	all=_s8_value
	return _s8_value
end)();
(all):do_((function(mth)
local current=nil
(function()
	local _s8_value=((mth):selector())
	current=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_(((keys):detect_ifNone_((function(one)
return ((current):includes_(one))
end),(function()
return (nil)
end))))),(function()
((self):results()):add_(mth);return ((self):triggerEvent_with_("found:",mth))
end),nil))
end)); end;
(self):triggerEvent_("searchFinished");
return ((self):results());
end
)
,"Tools-searching","findMessages: what\r\n\t\" Find messages matching what. \"\r\n\r\n\t| keys |\r\n\twhat isString ifTrue: [\r\n\t\t^self findMessages: what trimBlanks asArrayOfSubstrings\r\n\t].\r\n\tself triggerEvent: #searchStarted.\r\n\tkeys := what collect: [:each| each asString ].\r\n\tkeys notEmpty ifTrue: [ | all collect |\r\n\t\tall := self allMethods.\r\n\t\tall do: [:mth| | current |\r\n\t\t\tcurrent := mth selector.\r\n\t\t\t(keys detect: [:one| current includes: one ] ifNone: []) notNil ifTrue: [\r\n\t\t\t\tself results add: mth.\r\n\t\t\t\tself triggerEvent: #found: with: mth.\r\n\t\t\t].\r\n\t\t].\r\n\t].\r\n\tself triggerEvent: #searchFinished.\r\n\t^self results","(\r\nfunction(self,what)\r\nlocal keys=nil\r\nif ((what):isString())==true then return ((self):findMessages_(((what):trimBlanks()):asArrayOfSubstrings())); end;\r\n(self):triggerEvent_(\"searchStarted\");\r\n(function()\r\n\tlocal _s8_value=((what):collect_((function(each)\r\nreturn (smalltalk:asString_((each)))\r\nend)))\r\n\tkeys=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((keys):notEmpty())==true then local all=nil\r\nlocal collect=nil\r\n(function()\r\n\tlocal _s8_value=((self):allMethods())\r\n\tall=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(all):do_((function(mth)\r\nlocal current=nil\r\n(function()\r\n\tlocal _s8_value=((mth):selector())\r\n\tcurrent=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_(((keys):detect_ifNone_((function(one)\r\nreturn ((current):includes_(one))\r\nend),(function()\r\nreturn (nil)\r\nend))))),(function()\r\n((self):results()):add_(mth);return ((self):triggerEvent_with_(\"found:\",mth))\r\nend),nil))\r\nend)); end;\r\n(self):triggerEvent_(\"searchFinished\");\r\nreturn ((self):results());\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodReferences,"superLuaSendPatternOf:",0
,(
function(self,aSelector)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("\""),(aSelector):asSelector())),"\"")),")(self"));
end
)
,"Tools-patterns","superLuaSendPatternOf: aSelector\r\n\t\" Private - Return the search pattern for senders (to super) of aSelector. \"\r\n\r\n\t^$\" ,aSelector asSelector ,$\" ,')(self'","(\r\nfunction(self,aSelector)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),(aSelector):asSelector())),\"\\\"\")),\")(self\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager["$klass"],"constructEventsTriggered",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:superImplementor(smalltalk.SystemManager["$klass"],"constructEventsTriggered")(self)),smalltalk:newArray({"aboutToBind:to:", "methodBound:to:", "aboutToRemove:from:", "methodRemoved:from:", "aboutToChange:to:", "aboutToCreateClass:with:", "classChanged:", "classShapeChanged:", "object:at:notFoundIn:", "log:", "memoryWarning:"})));
end
)
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^super constructEventsTriggered ,#(\r\n\t\t#aboutToBind:to:\r\n\t\t#methodBound:to:\r\n\t\t#aboutToRemove:from:\r\n\t\t#methodRemoved:from:\r\n\t\t#aboutToChange:to:\r\n\t\t#aboutToCreateClass:with:\r\n\t\t#classChanged:\r\n\t\t#classShapeChanged:\r\n\t\t#object:at:notFoundIn:\r\n\t\t#log:\r\n\t\t#memoryWarning:\r\n\t)","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:superImplementor(smalltalk.SystemManager[\"$klass\"],\"constructEventsTriggered\")(self)),smalltalk:newArray({\"aboutToBind:to:\", \"methodBound:to:\", \"aboutToRemove:from:\", \"methodRemoved:from:\", \"aboutToChange:to:\", \"aboutToCreateClass:with:\", \"classChanged:\", \"classShapeChanged:\", \"object:at:notFoundIn:\", \"log:\", \"memoryWarning:\"})));\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager["$klass"],"currentOrNil",0
,(
function(self)
return ((self):classVariableAt_ifAbsent_("Current",(function()
return (nil)
end)));
end
)
,"singleton","currentOrNil\r\n\t\" Return the current instance of the receiver. \"\r\n\r\n\t^self classVariableAt: #Current ifAbsent: [ nil ]","(\r\nfunction(self)\r\nreturn ((self):classVariableAt_ifAbsent_(\"Current\",(function()\r\nreturn (nil)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager["$klass"],"current",0
,(
function(self)
if (smalltalk:isNil_((smalltalk.SystemManager:classVariableAt_("Current"))))==true then (self):current_((self):new()); end;
return (smalltalk.SystemManager:classVariableAt_("Current"));
end
)
,"singleton","current\r\n\t\" Return the current instance of the receiver. \"\r\n\r\n\tCurrent isNil ifTrue: [ self current: self new ].\r\n\t^Current","(\r\nfunction(self)\r\nif (smalltalk:isNil_((smalltalk.SystemManager:classVariableAt_(\"Current\"))))==true then (self):current_((self):new()); end;\r\nreturn (smalltalk.SystemManager:classVariableAt_(\"Current\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager["$klass"],"current:",0
,(
function(self,aSystemManager)
smalltalk.SystemManager:classVariableAt_put_("Current",aSystemManager);
(aSystemManager):install();
return (self);
end
)
,"singleton","current: aSystemManager\r\n\t\" Set the current instance of the receiver. \"\r\n\r\n\tCurrent := aSystemManager.\r\n\taSystemManager install.","(\r\nfunction(self,aSystemManager)\r\nsmalltalk.SystemManager:classVariableAt_put_(\"Current\",aSystemManager);\r\n(aSystemManager):install();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager["$klass"],"log:",0
,(
function(self,aString)
if (smalltalk:notNil_((smalltalk.SystemManager:classVariableAt_("Current"))))==true then (smalltalk.SystemManager:classVariableAt_("Current")):log_(aString); end;
return (self);
end
)
,"log","log: aString\r\n\t\" Log aString onto loggin stream. \"\r\n\r\n\tCurrent notNil ifTrue: [ Current log: aString ]","(\r\nfunction(self,aString)\r\nif (smalltalk:notNil_((smalltalk.SystemManager:classVariableAt_(\"Current\"))))==true then (smalltalk.SystemManager:classVariableAt_(\"Current\")):log_(aString); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager["$klass"],"memoryWarning:",0
,(
function(self,anArgument)
if (smalltalk:notNil_((smalltalk.SystemManager:classVariableAt_("Current"))))==true then (smalltalk.SystemManager:classVariableAt_("Current")):memoryWarning_(anArgument); end;
return (self);
end
)
,"memory","memoryWarning: anArgument\r\n\t\" Trigger a memory warning event. \"\r\n\r\n\tCurrent notNil ifTrue: [ Current memoryWarning: anArgument ]","(\r\nfunction(self,anArgument)\r\nif (smalltalk:notNil_((smalltalk.SystemManager:classVariableAt_(\"Current\"))))==true then (smalltalk.SystemManager:classVariableAt_(\"Current\")):memoryWarning_(anArgument); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager,"install",0
,(
function(self)
return (self);
end
)
,"install","install\r\n\t\" Private - Install the receiver as the source manager of the system.\r\n\tThe default action is to do nothing.\r\n\tThis method can be refined by subclasses.\r\n\t\"","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager,"aboutToBind:to:",0
,(
function(self,aMethod,aClass)
return ((self):triggerEvent_with_with_("aboutToBind:to:",aMethod,aClass));
end
)
,"tracking-methods","aboutToBind: aMethod to: aClass\r\n\t\" Private - The method will be bound to aClass. \"\r\n\r\n\t^self triggerEvent: #aboutToBind:to: with: aMethod with: aClass ","(\r\nfunction(self,aMethod,aClass)\r\nreturn ((self):triggerEvent_with_with_(\"aboutToBind:to:\",aMethod,aClass));\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager,"methodBound:to:",0
,(
function(self,aMethod,aClass)
return ((self):triggerEvent_with_with_("methodBound:to:",aMethod,aClass));
end
)
,"tracking-methods","methodBound: aMethod to: aClass\r\n\t\" Private - The method has been bound to aClass. \"\r\n\r\n\t^self triggerEvent: #methodBound:to: with: aMethod with: aClass ","(\r\nfunction(self,aMethod,aClass)\r\nreturn ((self):triggerEvent_with_with_(\"methodBound:to:\",aMethod,aClass));\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager,"aboutToRemove:from:",0
,(
function(self,aMethod,aClass)
return ((self):triggerEvent_with_with_("aboutToRemove:from:",aMethod,aClass));
end
)
,"tracking-methods","aboutToRemove: aMethod from: aClass\r\n\t\" Private - The method will be removed from aClass. \"\r\n\r\n\t^self triggerEvent: #aboutToRemove:from: with: aMethod with: aClass ","(\r\nfunction(self,aMethod,aClass)\r\nreturn ((self):triggerEvent_with_with_(\"aboutToRemove:from:\",aMethod,aClass));\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager,"methodRemoved:from:",0
,(
function(self,aMethod,aClass)
return ((self):triggerEvent_with_with_("methodRemoved:from:",aMethod,aClass));
end
)
,"tracking-methods","methodRemoved: aMethod from: aClass\r\n\t\" Private - The method has been removed from aClass. \"\r\n\r\n\t^self triggerEvent: #methodRemoved:from: with: aMethod with: aClass ","(\r\nfunction(self,aMethod,aClass)\r\nreturn ((self):triggerEvent_with_with_(\"methodRemoved:from:\",aMethod,aClass));\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager,"aboutToChange:superclass:iVarNames:category:",0
,(
function(self,aClass,superclass,iVarNames,category)
return ((self):triggerEvent_with_with_("aboutToChange:to:",aClass,(smalltalk.Array):with_with_with_(superclass,iVarNames,category)));
end
)
,"tracking-classes","aboutToChange: aClass superclass: superclass iVarNames: iVarNames category: category\r\n\t\" Private - aClass is about to be changed. \"\r\n\r\n\t^self\ttriggerEvent: #aboutToChange:to:\r\n\t\twith: aClass\r\n\t\twith: (Array with: superclass with: iVarNames with: category)","(\r\nfunction(self,aClass,superclass,iVarNames,category)\r\nreturn ((self):triggerEvent_with_with_(\"aboutToChange:to:\",aClass,(smalltalk.Array):with_with_with_(superclass,iVarNames,category)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager,"aboutToCreateClass:superclass:iVarNames:category:",0
,(
function(self,globalName,superclass,iVarNames,category)
return ((self):triggerEvent_with_with_("aboutToCreateClass:with:",globalName,(smalltalk.Array):with_with_with_(superclass,iVarNames,category)));
end
)
,"tracking-classes","aboutToCreateClass: globalName superclass: superclass iVarNames: iVarNames category: category\r\n\t\" Private - Attemp to create Class with name globalName. \"\r\n\r\n\t^self\ttriggerEvent: #aboutToCreateClass:with:\r\n\t\twith: globalName\r\n\t\twith: (Array with: superclass with: iVarNames with: category)","(\r\nfunction(self,globalName,superclass,iVarNames,category)\r\nreturn ((self):triggerEvent_with_with_(\"aboutToCreateClass:with:\",globalName,(smalltalk.Array):with_with_with_(superclass,iVarNames,category)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager,"classChanged:",0
,(
function(self,aBehavior)
return ((self):triggerEvent_with_("classChanged:",aBehavior));
end
)
,"tracking-classes","classChanged: aBehavior\r\n\t\" Private - aBehavior has been changed. \"\r\n\r\n\t^self triggerEvent: #classChanged: with: aBehavior ","(\r\nfunction(self,aBehavior)\r\nreturn ((self):triggerEvent_with_(\"classChanged:\",aBehavior));\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager,"classShapeChanged:",0
,(
function(self,aBehavior)
return ((self):triggerEvent_with_ifNotHandled_("classShapeChanged:",aBehavior,(function()
return ((aBehavior):recompileAll())
end)));
end
)
,"tracking-classes","classShapeChanged: aBehavior\r\n\t\" Private - aBehavior has changed shape. \"\r\n\r\n\t^self\ttriggerEvent: #classShapeChanged:\r\n\t\twith: aBehavior\r\n\t\tifNotHandled: [ aBehavior recompileAll ]","(\r\nfunction(self,aBehavior)\r\nreturn ((self):triggerEvent_with_ifNotHandled_(\"classShapeChanged:\",aBehavior,(function()\r\nreturn ((aBehavior):recompileAll())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager,"log:",0
,(
function(self,aString)
return ((self):triggerEvent_with_("log:",aString));
end
)
,"log","log: aString\r\n\t\" Private - Log aString onto loggin device. \"\r\n\r\n\t^self triggerEvent: #log: with: aString","(\r\nfunction(self,aString)\r\nreturn ((self):triggerEvent_with_(\"log:\",aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager,"nextPutAll:",0
,(
function(self,aString)
return ((self):log_(aString));
end
)
,"streaming","nextPutAll: aString\r\n\t\" Log aString when streaming. \"\r\n\r\n\t^self log: aString","(\r\nfunction(self,aString)\r\nreturn ((self):log_(aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager,"cr",0
,(
function(self)
return (self);
end
)
,"streaming","cr\r\n\t\" Ignore the output, we log as line oriented streaming service. \"","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager,"memoryWarning:",0
,(
function(self,anArgument)
return ((self):triggerEvent_with_("memoryWarning:",anArgument));
end
)
,"memory","memoryWarning: anArgument\r\n\t\" Trigger a memory warning event.\r\n\tThe execution environment can signal memory warning/low conditions, we trigger an event to be handled at application level.\r\n\tNote: It is frequent procedure to clean cached resources that can be reconstructed later, if required.\r\n\t\"\r\n\r\n\t^self triggerEvent: #memoryWarning: with: anArgument","(\r\nfunction(self,anArgument)\r\nreturn ((self):triggerEvent_with_(\"memoryWarning:\",anArgument));\r\nend\r\n)")
smalltalk:bind(smalltalk.SystemManager,"object:at:notFoundIn:",0
,(
function(self,anObject,indexOrKey,aCollection)
return ((self):triggerEvent_withArguments_ifNotHandled_("object:at:notFoundIn:",(smalltalk.Array):with_with_with_(anObject,indexOrKey,aCollection),(function()
return ((self):print_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Object/key("),smalltalk:toString_((smalltalk:if_true_false_((smalltalk:isNil_((indexOrKey))),(function()
return (anObject)
end),(function()
return (indexOrKey)
end)))))),") not found in ")),smalltalk:printString_((aCollection)))))
end)));
end
)
,"failures","object: anObject at: indexOrKey notFoundIn: aCollection\r\n\t\" Trigger a missing object event. \"\r\n\r\n\t^self triggerEvent: #object:at:notFoundIn:\r\n\t\twithArguments: (Array with: anObject with: indexOrKey with: aCollection)\r\n\t\tifNotHandled: [\r\n\t\t\tself print: 'Object/key('\r\n\t\t\t\t,(indexOrKey isNil ifTrue: [anObject] ifFalse: [indexOrKey]) toString\r\n\t\t\t\t,') not found in ',aCollection printString\r\n\t\t]","(\r\nfunction(self,anObject,indexOrKey,aCollection)\r\nreturn ((self):triggerEvent_withArguments_ifNotHandled_(\"object:at:notFoundIn:\",(smalltalk.Array):with_with_with_(anObject,indexOrKey,aCollection),(function()\r\nreturn ((self):print_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Object/key(\"),smalltalk:toString_((smalltalk:if_true_false_((smalltalk:isNil_((indexOrKey))),(function()\r\nreturn (anObject)\r\nend),(function()\r\nreturn (indexOrKey)\r\nend)))))),\") not found in \")),smalltalk:printString_((aCollection)))))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode["$klass"],"with:",0
,(
function(self,aNode)
return ((
function(_s8_rec)
	(_s8_rec):addNode_(aNode);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","with: aNode\r\n\t^self new\r\n\t\taddNode: aNode;\r\n\t\tyourself","(\r\nfunction(self,aNode)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addNode_(aNode);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"nodes",0
,(
function(self)
if (smalltalk:isNil_((self["@nodes"])))==true then (function()
	local _s8_value=((smalltalk.Array):new())
	self["@nodes"]=_s8_value
	return _s8_value
end)(); end;
return (self["@nodes"]);
end
)
,"accessing","nodes\r\n\tnodes isNil ifTrue: [ nodes := Array new ].\r\n\t^nodes","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@nodes\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@nodes\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@nodes\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"nodes:",0
,(
function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@nodes"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","nodes: aCollection\r\n\tnodes := aCollection","(\r\nfunction(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@nodes\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"isEmpty",0
,(
function(self)
return (smalltalk:isObject_equalTo_(((self["@nodes"]):size()),0));
end
)
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^nodes size = 0 ","(\r\nfunction(self)\r\nreturn (smalltalk:isObject_equalTo_(((self[\"@nodes\"]):size()),0));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"annotations",0
,(
function(self)
if (smalltalk:isNil_((self["@annotations"])))==true then (function()
	local _s8_value=((smalltalk.Array):new())
	self["@annotations"]=_s8_value
	return _s8_value
end)(); end;
return (self["@annotations"]);
end
)
,"accessing","annotations\r\n\tannotations isNil ifTrue: [ annotations := Array new ].\r\n\t^annotations","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@annotations\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@annotations\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@annotations\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"annotations:",0
,(
function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@annotations"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","annotations: aCollection\r\n\tannotations := aCollection","(\r\nfunction(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@annotations\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"addNode:",0
,(
function(self,aNode)
((self):nodes()):add_(aNode);
return (self);
end
)
,"accessing","addNode: aNode\r\n\t\" Add a Node to the nodes of the receiver.\r\n\tReturn the receiver. \"\r\n\r\n\tself nodes add: aNode","(\r\nfunction(self,aNode)\r\n((self):nodes()):add_(aNode);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"start",0
,(
function(self)
return (self["@start"]);
end
)
,"accessing","start\r\n\t^start","(\r\nfunction(self)\r\nreturn (self[\"@start\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"end","__end"
,(
function(self)
return (self["@end"]);
end
)
,"accessing","end\r\n\t^end","(\r\nfunction(self)\r\nreturn (self[\"@end\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"start:end:",0
,(
function(self,startOffset,endOffset)
(function()
	local _s8_value=(startOffset)
	self["@start"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(endOffset)
	self["@end"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","start: startOffset end: endOffset\r\n\t\" Set the offsets of the receiver in source code. \"\r\n\r\n\tstart := startOffset.\r\n\tend := endOffset.","(\r\nfunction(self,startOffset,endOffset)\r\n(function()\r\n\tlocal _s8_value=(startOffset)\r\n\tself[\"@start\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(endOffset)\r\n\tself[\"@end\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"sourceRange",0
,(
function(self)
return ((self["@start"]):to_(self["@end"]));
end
)
,"accessing","sourceRange\r\n\t\" Return the receiver's sourceRange. \"\r\n\r\n\t^start to: end ","(\r\nfunction(self)\r\nreturn ((self[\"@start\"]):to_(self[\"@end\"]));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"client",0
,(
function(self)
return (self["@client"]);
end
)
,"accessing","client\r\n\t\" Private - Return an object that require the result of evaluation of the receiver.\r\n\tNote that client can be:\r\n\t\taNode that will demmand result on runtime\r\n\t\tnil in case of not known\r\n\t\t#none if granted that the result of evaluation of the receiver will be discarded/unused.\r\n\t\"\r\n\r\n\t^client ","(\r\nfunction(self)\r\nreturn (self[\"@client\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"client:",0
,(
function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@client"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","client: anObject\r\n\t\" Private - Set an object that require the result of evaluation of the receiver. \"\r\n\r\n\tclient := anObject ","(\r\nfunction(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@client\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"prepareIn:for:",0
,(
function(self,aNode,anEncoder)
if ((((self["@nodes"]):size()) < 1))==true then return (self); end;
(self["@nodes"]):do_((function(each)
return ((each):client_("none"))
end));
((self["@nodes"]):last()):client_(self);
return (self);
end
)
,"prepare","prepareIn: aNode for: anEncoder\r\n\t\" Prepare the receiver to be encoded by anEncoder in aNode. \"\r\n\r\n\tnodes size < 1 ifTrue: [ ^self ].\r\n\tnodes do: [:each| each client: #none ].\r\n\tnodes last client: self","(\r\nfunction(self,aNode,anEncoder)\r\nif ((((self[\"@nodes\"]):size()) < 1))==true then return (self); end;\r\n(self[\"@nodes\"]):do_((function(each)\r\nreturn ((each):client_(\"none\"))\r\nend));\r\n((self[\"@nodes\"]):last()):client_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"sourceRange:",0
,(
function(self,interval)
(self):start_end_((interval):start(),(interval):__end());
return (self);
end
)
,"accessing","sourceRange: interval\r\n\t\" Set the source range of the receiver. \"\r\n\r\n\tself start: interval start end: interval end ","(\r\nfunction(self,interval)\r\n(self):start_end_((interval):start(),(interval):__end());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"accept:",0
,(
function(self,aVisitor)
(aVisitor):visitNode_(self);
return (self);
end
)
,"visiting","accept: aVisitor\r\n\taVisitor visitNode: self","(\r\nfunction(self,aVisitor)\r\n(aVisitor):visitNode_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"acceptMacroAssignment:with:",0
,(
function(self,anExpressionNode,aVisitor)
return ((aVisitor):visitMacroAssignment_to_(self,anExpressionNode));
end
)
,"visiting","acceptMacroAssignment: anExpressionNode with: aVisitor\r\n\t\" Return true if the receiver can resolve assignment on aVisitor. \"\r\n\r\n\t^aVisitor visitMacroAssignment: self to: anExpressionNode","(\r\nfunction(self,anExpressionNode,aVisitor)\r\nreturn ((aVisitor):visitMacroAssignment_to_(self,anExpressionNode));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"isSuper",0
,(
function(self)
return (false);
end
)
,"testing","isSuper\r\n\t\" Return true if the receiver is super. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"hasNumber",0
,(
function(self)
return (false);
end
)
,"testing","hasNumber\r\n\t\" Return true if the receiver has a numeric literal value. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"hasString",0
,(
function(self)
return (false);
end
)
,"testing","hasString\r\n\t\" Return true if the receiver has a string literal value. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"isAssignment",0
,(
function(self)
return (false);
end
)
,"testing","isAssignment\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"isBlock",0
,(
function(self)
return (false);
end
)
,"testing","isBlock\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"isCascade",0
,(
function(self)
return (false);
end
)
,"testing","isCascade\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"isInline",0
,(
function(self)
return (false);
end
)
,"testing","isInline\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"isReturn",0
,(
function(self)
return (false);
end
)
,"testing","isReturn\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"isSend",0
,(
function(self)
return (false);
end
)
,"testing","isSend\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"isSequence",0
,(
function(self)
return (false);
end
)
,"testing","isSequence\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"isValue",0
,(
function(self)
return (false);
end
)
,"testing","isValue\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"isVariable",0
,(
function(self)
return (false);
end
)
,"testing","isVariable\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"bindings",0
,(
function(self)
return (smalltalk:newArray({}));
end
)
,"bindings","bindings\r\n\t\" Return the bindings of the receiver. \"\r\n\r\n\t^#()","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({}));\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"do:",0
,(
function(self,aBlock)
(self):do_in_(aBlock,nil);
return (self);
end
)
,"iteration","do: aBlock\r\n\t\" Evaluate aBlock for all contents of the receiver. \"\r\n\r\n\tself do: aBlock in: nil ","(\r\nfunction(self,aBlock)\r\n(self):do_in_(aBlock,nil);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"do:in:",0
,(
function(self,aBlock,aNode)
(aBlock):evaluateWithArguments_((smalltalk.Array):with_with_(self,aNode));
if (smalltalk:notNil_((self["@nodes"])))==true then (self["@nodes"]):do_((function(each)
return ((each):do_in_(aBlock,self))
end)); end;
return (self);
end
)
,"iteration","do: aBlock in: aNode\r\n\t\" Evaluate aBlock for all contents of the receiver. \"\r\n\r\n\taBlock evaluateWithArguments: (Array with: self with: aNode).\r\n\tnodes notNil ifTrue: [\r\n\t\tnodes do: [:each| each do: aBlock in: self ]\r\n\t] ","(\r\nfunction(self,aBlock,aNode)\r\n(aBlock):evaluateWithArguments_((smalltalk.Array):with_with_(self,aNode));\r\nif (smalltalk:notNil_((self[\"@nodes\"])))==true then (self[\"@nodes\"]):do_((function(each)\r\nreturn ((each):do_in_(aBlock,self))\r\nend)); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"with:except:do:",0
,(
function(self,testBlock,except,aBlock)
if ((((except):evaluateWith_(self))==true))==true then return (nil); end;
if (smalltalk:notNil_((self["@nodes"])))==true then (self["@nodes"]):do_((function(each)
return (smalltalk:if_true_false_(((testBlock):value_(each)),(function()
return ((aBlock):value_value_(each,self))
end),(function()
return ((each):with_except_do_(testBlock,except,aBlock))
end)))
end)); end;
return (self);
end
)
,"iteration","with: testBlock except: except do: aBlock\r\n\t\" Evaluate aBlock for all nodes (returning true when evaluated with testBlock) in the local context of receiver. \"\r\n\r\n\t(except evaluateWith: self) == true ifTrue: [ ^nil ].\r\n\tnodes notNil ifTrue: [\r\n\t\tnodes do: [:each|\r\n\t\t\t(testBlock value: each)\r\n\t\t\tifTrue: [ aBlock value: each value: self ]\r\n\t\t\tifFalse: [ each with: testBlock except: except do: aBlock ]\r\n\t\t]\r\n\t] ","(\r\nfunction(self,testBlock,except,aBlock)\r\nif ((((except):evaluateWith_(self))==true))==true then return (nil); end;\r\nif (smalltalk:notNil_((self[\"@nodes\"])))==true then (self[\"@nodes\"]):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((testBlock):value_(each)),(function()\r\nreturn ((aBlock):value_value_(each,self))\r\nend),(function()\r\nreturn ((each):with_except_do_(testBlock,except,aBlock))\r\nend)))\r\nend)); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"select:",0
,(
function(self,aBlock)
local result=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
(self):do_((function(each)
return (smalltalk:if_true_false_(((((aBlock):evaluateWith_(each))==true)),(function()
return ((result):add_(each))
end),nil))
end));
return (result);
end
)
,"enumerating","select: aBlock\r\n\t\" Returns the nodes in the receiver that returns true when evaluated with aBlock. \"\r\n\r\n\t| result |\r\n\tresult := #().\r\n\tself do: [:each|\r\n\t\t(aBlock evaluateWith: each) == true ifTrue: [\r\n\t\t\tresult add: each\r\n\t\t]\r\n\t].\r\n\t^result","(\r\nfunction(self,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((((aBlock):evaluateWith_(each))==true)),(function()\r\nreturn ((result):add_(each))\r\nend),nil))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.CompilerNode,"messageSendConnector",0
,(
function(self)
return (".");
end
)
,"accessing","messageSendConnector\r\n\t\" Return the connector used to encode message sent to the receiver (or nil). \"\r\n\r\n\t^$. ","(\r\nfunction(self)\r\nreturn (\".\");\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodNode,"selector",0
,(
function(self)
return (self["@selector"]);
end
)
,"accessing","selector\r\n\t^selector","(\r\nfunction(self)\r\nreturn (self[\"@selector\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodNode,"selector:",0
,(
function(self,aString)
(function()
	local _s8_value=(aString)
	self["@selector"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","selector: aString\r\n\tselector := aString","(\r\nfunction(self,aString)\r\n(function()\r\n\tlocal _s8_value=(aString)\r\n\tself[\"@selector\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodNode,"arguments",0
,(
function(self)
return (smalltalk:if_true_false_((smalltalk:isNil_((self["@arguments"]))),(function()
return (smalltalk:newArray({}))
end),(function()
return (self["@arguments"])
end)));
end
)
,"accessing","arguments\r\n\t^arguments isNil ifTrue: [ #() ] ifFalse: [ arguments ]","(\r\nfunction(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((self[\"@arguments\"]))),(function()\r\nreturn (smalltalk:newArray({}))\r\nend),(function()\r\nreturn (self[\"@arguments\"])\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodNode,"arguments:",0
,(
function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@arguments"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","arguments: aCollection\r\n\targuments := aCollection","(\r\nfunction(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@arguments\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodNode,"argumentNames",0
,(
function(self)
return (((self):arguments()):collect_((function(each)
return (smalltalk:if_true_false_(((each):isString()),(function()
return (each)
end),(function()
return ((each):value())
end)))
end)));
end
)
,"accessing","argumentNames\r\n\t\" Return the names of the arguments of the receiver. \"\r\n\r\n\t^self arguments collect: [:each|\r\n\t\teach isString\r\n\t\tifTrue: [each]\r\n\t\tifFalse: [each value]\r\n\t]","(\r\nfunction(self)\r\nreturn (((self):arguments()):collect_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):isString()),(function()\r\nreturn (each)\r\nend),(function()\r\nreturn ((each):value())\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodNode,"source",0
,(
function(self)
return (self["@source"]);
end
)
,"accessing","source\r\n\t^source","(\r\nfunction(self)\r\nreturn (self[\"@source\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodNode,"source:",0
,(
function(self,aString)
(function()
	local _s8_value=(aString)
	self["@source"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","source: aString\r\n\tsource := aString","(\r\nfunction(self,aString)\r\n(function()\r\n\tlocal _s8_value=(aString)\r\n\tself[\"@source\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodNode,"accept:",0
,(
function(self,aVisitor)
(aVisitor):visitMethodNode_(self);
return (self);
end
)
,"visiting","accept: aVisitor\r\n\taVisitor visitMethodNode: self","(\r\nfunction(self,aVisitor)\r\n(aVisitor):visitMethodNode_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodNode,"validateArguments",0
,(
function(self)
local names=nil
(function()
	local _s8_value=((smalltalk.HashedSet):withAll_((self):argumentNames()))
	names=_s8_value
	return _s8_value
end)();
if not ((smalltalk:isObject_equalTo_(((names):size()),((self):arguments()):size())))==true then return ((self):error_(smalltalk:object_comma_(("Invalid argument names "),((self):argumentNames()):asLiteral()))); end;
((self):nodes()):do_((function(each)
return ((each):validateNames_(names))
end));
return (self);
end
)
,"validation","validateArguments\r\n\t\" Ensure the nodes of the receiver can be emmited with the defined arguments. \"\r\n\r\n\t| names |\r\n\tnames := HashedSet withAll: self argumentNames.\r\n\tnames size = self arguments size ifFalse: [\r\n\t\t^self error: 'Invalid argument names ' ,self argumentNames asLiteral\r\n\t].\r\n\tself nodes do: [:each| each validateNames: names ]","(\r\nfunction(self)\r\nlocal names=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.HashedSet):withAll_((self):argumentNames()))\r\n\tnames=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:isObject_equalTo_(((names):size()),((self):arguments()):size())))==true then return ((self):error_(smalltalk:object_comma_((\"Invalid argument names \"),((self):argumentNames()):asLiteral()))); end;\r\n((self):nodes()):do_((function(each)\r\nreturn ((each):validateNames_(names))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodNode,"sendNodes",0
,(
function(self)
return ((self):select_((function(each)
return ((each):isSend())
end)));
end
)
,"accessing","sendNodes\r\n\t\" Returns the send nodes in the receiver. \"\r\n\r\n\t^self select: [:each| each isSend ]","(\r\nfunction(self)\r\nreturn ((self):select_((function(each)\r\nreturn ((each):isSend())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodNode,"messages",0
,(
function(self)
return (((((self):sendNodes()):collect_((function(each)
return ((each):selector())
end))):asSet()):sorted());
end
)
,"accessing","messages\r\n\t\" Returns the messages potentially sent when evaluating the receiver. \"\r\n\r\n\t^(self sendNodes\r\n\t\tcollect: [:each| each selector ])\r\n\t\tasSet sorted","(\r\nfunction(self)\r\nreturn (((((self):sendNodes()):collect_((function(each)\r\nreturn ((each):selector())\r\nend))):asSet()):sorted());\r\nend\r\n)")
smalltalk:bind(smalltalk.MethodNode,"values",0
,(
function(self)
local result=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
(result):addAll_((self):arguments());
(self):do_((function(each)
if ((each):isSequence())==true then (result):addAll_((each):temps()); end;return (smalltalk:if_true_false_(((each):isBlock()),(function()
return ((result):addAll_((each):parameters()))
end),nil))
end));
return (result);
end
)
,"accessing","values\r\n\t\" Returns the values bound in the receiver. \"\r\n\r\n\t| result |\r\n\tresult := #().\r\n\tresult addAll: self arguments.\r\n\tself do: [:each|\r\n\t\teach isSequence ifTrue: [ result addAll: each temps ].\r\n\t\teach isBlock ifTrue: [ result addAll: each parameters ].\r\n\t].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(result):addAll_((self):arguments());\r\n(self):do_((function(each)\r\nif ((each):isSequence())==true then (result):addAll_((each):temps()); end;return (smalltalk:if_true_false_(((each):isBlock()),(function()\r\nreturn ((result):addAll_((each):parameters()))\r\nend),nil))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.SendNode,"selector",0
,(
function(self)
return (self["@selector"]);
end
)
,"accessing","selector\r\n\t^selector","(\r\nfunction(self)\r\nreturn (self[\"@selector\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.SendNode,"selector:",0
,(
function(self,aString)
(function()
	local _s8_value=(aString)
	self["@selector"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","selector: aString\r\n\tselector := aString","(\r\nfunction(self,aString)\r\n(function()\r\n\tlocal _s8_value=(aString)\r\n\tself[\"@selector\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SendNode,"arguments",0
,(
function(self)
return (smalltalk:if_true_false_((smalltalk:isNil_((self["@arguments"]))),(function()
return (smalltalk:newArray({}))
end),(function()
return (self["@arguments"])
end)));
end
)
,"accessing","arguments\r\n\t^arguments isNil ifTrue: [ #() ] ifFalse: [ arguments ]","(\r\nfunction(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((self[\"@arguments\"]))),(function()\r\nreturn (smalltalk:newArray({}))\r\nend),(function()\r\nreturn (self[\"@arguments\"])\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SendNode,"arguments:",0
,(
function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@arguments"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","arguments: aCollection\r\n\targuments := aCollection","(\r\nfunction(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@arguments\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SendNode,"receiver",0
,(
function(self)
return (self["@receiver"]);
end
)
,"accessing","receiver\r\n\t^receiver","(\r\nfunction(self)\r\nreturn (self[\"@receiver\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.SendNode,"receiver:",0
,(
function(self,aNode)
(function()
	local _s8_value=(aNode)
	self["@receiver"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","receiver: aNode\r\n\treceiver := aNode","(\r\nfunction(self,aNode)\r\n(function()\r\n\tlocal _s8_value=(aNode)\r\n\tself[\"@receiver\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SendNode,"valueForReceiver:",0
,(
function(self,anObject)
return ((
function(_s8_rec)
	(_s8_rec):receiver_(smalltalk:if_true_false_((smalltalk:isNil_(((self):receiver()))),(function()
return (anObject)
end),(function()
return (((self):receiver()):valueForReceiver_(anObject))
end)));
	(_s8_rec):selector_((self):selector());
	(_s8_rec):arguments_((self):arguments());
	(_s8_rec):start_end_((self):start(),(self):__end());
	return ((_s8_rec):yourself())
end
)((smalltalk.SendNode):new()));
end
)
,"accessing","valueForReceiver: anObject\r\n\t^SendNode new\r\n\t    receiver: (self receiver isNil ifTrue: [anObject]\r\n\t\tifFalse: [self receiver valueForReceiver: anObject]);\r\n\t    selector: self selector;\r\n\t    arguments: self arguments;\r\n\t    start: self start end: self end;\r\n\t    yourself","(\r\nfunction(self,anObject)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):receiver_(smalltalk:if_true_false_((smalltalk:isNil_(((self):receiver()))),(function()\r\nreturn (anObject)\r\nend),(function()\r\nreturn (((self):receiver()):valueForReceiver_(anObject))\r\nend)));\r\n\t(_s8_rec):selector_((self):selector());\r\n\t(_s8_rec):arguments_((self):arguments());\r\n\t(_s8_rec):start_end_((self):start(),(self):__end());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.SendNode):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.SendNode,"cascadeNodeWithMessages:",0
,(
function(self,aCollection)
local first=nil
local sends=nil
(function()
	local _s8_value=((
function(_s8_rec)
	(_s8_rec):selector_((self):selector());
	(_s8_rec):arguments_((self):arguments());
	(_s8_rec):start_end_((self):start(),(self):__end());
	return ((_s8_rec):yourself())
end
)((smalltalk.SendNode):new()))
	first=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:object_comma_(((smalltalk.Array):with_(first)),aCollection))
	sends=_s8_value
	return _s8_value
end)();
return ((
function(_s8_rec)
	(_s8_rec):receiver_((self):receiver());
	(_s8_rec):nodes_(sends);
	(_s8_rec):start_end_(((sends):first()):start(),((sends):last()):__end());
	return ((_s8_rec):yourself())
end
)((smalltalk.CascadeNode):new()));
end
)
,"accessing","cascadeNodeWithMessages: aCollection\r\n\t| first sends |\r\n\tfirst := SendNode new\r\n\t    selector: self selector;\r\n\t    arguments: self arguments;\r\n\t    start: self start end: self end;\r\n\t    yourself.\r\n\tsends := (Array with: first), aCollection.\r\n\t^CascadeNode new\r\n\t    receiver: self receiver;\r\n\t    nodes: sends;\r\n\t    start: sends first start end: sends last end;\r\n\t    yourself","(\r\nfunction(self,aCollection)\r\nlocal first=nil\r\nlocal sends=nil\r\n(function()\r\n\tlocal _s8_value=((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):selector_((self):selector());\r\n\t(_s8_rec):arguments_((self):arguments());\r\n\t(_s8_rec):start_end_((self):start(),(self):__end());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.SendNode):new()))\r\n\tfirst=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((smalltalk.Array):with_(first)),aCollection))\r\n\tsends=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):receiver_((self):receiver());\r\n\t(_s8_rec):nodes_(sends);\r\n\t(_s8_rec):start_end_(((sends):first()):start(),((sends):last()):__end());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.CascadeNode):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.SendNode,"accept:",0
,(
function(self,aVisitor)
(aVisitor):visitSendNode_(self);
return (self);
end
)
,"visiting","accept: aVisitor\r\n\taVisitor visitSendNode: self","(\r\nfunction(self,aVisitor)\r\n(aVisitor):visitSendNode_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SendNode,"isSend",0
,(
function(self)
return (true);
end
)
,"testing","isSend\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.SendNode,"do:in:",0
,(
function(self,aBlock,aNode)
smalltalk:superImplementor(smalltalk.SendNode,"do_in_")(self,aBlock,aNode);
if (smalltalk:notNil_((self["@receiver"])))==true then (self["@receiver"]):do_in_(aBlock,self); end;
((self):arguments()):do_((function(each)
return ((each):do_in_(aBlock,self))
end));
return (self);
end
)
,"iteration","do: aBlock in: aNode\r\n\t\" Evaluate aBlock for all contents of the receiver. \"\r\n\r\n\tsuper do: aBlock in: aNode.\r\n\treceiver notNil ifTrue: [ receiver do: aBlock in: self ].\r\n\tself arguments do: [:each| each do: aBlock in: self ].","(\r\nfunction(self,aBlock,aNode)\r\nsmalltalk:superImplementor(smalltalk.SendNode,\"do_in_\")(self,aBlock,aNode);\r\nif (smalltalk:notNil_((self[\"@receiver\"])))==true then (self[\"@receiver\"]):do_in_(aBlock,self); end;\r\n((self):arguments()):do_((function(each)\r\nreturn ((each):do_in_(aBlock,self))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SendNode,"with:except:do:",0
,(
function(self,testBlock,except,aBlock)
if (smalltalk:isNil_((smalltalk:superImplementor(smalltalk.SendNode,"with_except_do_")(self,testBlock,except,aBlock))))==true then return (nil); end;
if (smalltalk:notNil_((self["@receiver"])))==true then smalltalk:if_true_false_(((testBlock):value_(self["@receiver"])),(function()
return ((aBlock):value_value_(self["@receiver"],self))
end),(function()
return ((self["@receiver"]):with_except_do_(testBlock,except,aBlock))
end)); end;
((self):arguments()):do_((function(each)
return (smalltalk:if_true_false_(((testBlock):value_(each)),(function()
return ((aBlock):value_value_(each,self))
end),(function()
return ((each):with_except_do_(testBlock,except,aBlock))
end)))
end));
return (self);
end
)
,"iteration","with: testBlock except: except do: aBlock\r\n\t\" Evaluate aBlock for all nodes (returning true when evaluated with testBlock) in the local context of receiver. \"\r\n\r\n\t(super with: testBlock except: except do: aBlock) isNil ifTrue: [ ^nil ].\r\n\treceiver notNil ifTrue: [\r\n\t\t(testBlock value: receiver)\r\n\t\tifTrue: [ aBlock value: receiver value: self ]\r\n\t\tifFalse: [ receiver with: testBlock except: except do: aBlock ]\r\n\t].\r\n\tself arguments do: [:each|\r\n\t\t(testBlock value: each)\r\n\t\tifTrue: [ aBlock value: each value: self ]\r\n\t\tifFalse: [ each with: testBlock except: except do: aBlock ]\r\n\t] ","(\r\nfunction(self,testBlock,except,aBlock)\r\nif (smalltalk:isNil_((smalltalk:superImplementor(smalltalk.SendNode,\"with_except_do_\")(self,testBlock,except,aBlock))))==true then return (nil); end;\r\nif (smalltalk:notNil_((self[\"@receiver\"])))==true then smalltalk:if_true_false_(((testBlock):value_(self[\"@receiver\"])),(function()\r\nreturn ((aBlock):value_value_(self[\"@receiver\"],self))\r\nend),(function()\r\nreturn ((self[\"@receiver\"]):with_except_do_(testBlock,except,aBlock))\r\nend)); end;\r\n((self):arguments()):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((testBlock):value_(each)),(function()\r\nreturn ((aBlock):value_value_(each,self))\r\nend),(function()\r\nreturn ((each):with_except_do_(testBlock,except,aBlock))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SendNode,"prepareIn:for:",0
,(
function(self,aNode,anEncoder)
smalltalk:superImplementor(smalltalk.SendNode,"prepareIn_for_")(self,aNode,anEncoder);
if (smalltalk:notNil_((self["@receiver"])))==true then (self["@receiver"]):client_(self); end;
((self):arguments()):do_((function(each)
return ((each):client_(self))
end));
return (self);
end
)
,"prepare","prepareIn: aNode for: anEncoder\r\n\t\" Prepare the receiver to be encoded by anEncoder in aNode. \"\r\n\r\n\tsuper prepareIn: aNode for: anEncoder.\r\n\treceiver notNil ifTrue: [ receiver client: self ].\r\n\tself arguments do: [:each| each client: self ] ","(\r\nfunction(self,aNode,anEncoder)\r\nsmalltalk:superImplementor(smalltalk.SendNode,\"prepareIn_for_\")(self,aNode,anEncoder);\r\nif (smalltalk:notNil_((self[\"@receiver\"])))==true then (self[\"@receiver\"]):client_(self); end;\r\n((self):arguments()):do_((function(each)\r\nreturn ((each):client_(self))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CascadeNode,"receiver",0
,(
function(self)
return (self["@receiver"]);
end
)
,"accessing","receiver\r\n\t^receiver","(\r\nfunction(self)\r\nreturn (self[\"@receiver\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.CascadeNode,"receiver:",0
,(
function(self,aNode)
(function()
	local _s8_value=(aNode)
	self["@receiver"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","receiver: aNode\r\n\treceiver := aNode","(\r\nfunction(self,aNode)\r\n(function()\r\n\tlocal _s8_value=(aNode)\r\n\tself[\"@receiver\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CascadeNode,"accept:",0
,(
function(self,aVisitor)
(aVisitor):visitCascadeNode_(self);
return (self);
end
)
,"visiting","accept: aVisitor\r\n\taVisitor visitCascadeNode: self","(\r\nfunction(self,aVisitor)\r\n(aVisitor):visitCascadeNode_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CascadeNode,"isCascade",0
,(
function(self)
return (true);
end
)
,"testing","isCascade\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.CascadeNode,"do:in:",0
,(
function(self,aBlock,aNode)
smalltalk:superImplementor(smalltalk.CascadeNode,"do_in_")(self,aBlock,aNode);
if (smalltalk:notNil_((self["@receiver"])))==true then (self["@receiver"]):do_in_(aBlock,self); end;
return (self);
end
)
,"iteration","do: aBlock in: aNode\r\n\t\" Evaluate aBlock for all contents of the receiver. \"\r\n\r\n\tsuper do: aBlock in: aNode.\r\n\treceiver notNil ifTrue: [ receiver do: aBlock in: self ].","(\r\nfunction(self,aBlock,aNode)\r\nsmalltalk:superImplementor(smalltalk.CascadeNode,\"do_in_\")(self,aBlock,aNode);\r\nif (smalltalk:notNil_((self[\"@receiver\"])))==true then (self[\"@receiver\"]):do_in_(aBlock,self); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.CascadeNode,"with:except:do:",0
,(
function(self,testBlock,except,aBlock)
if (smalltalk:isNil_((smalltalk:superImplementor(smalltalk.CascadeNode,"with_except_do_")(self,testBlock,except,aBlock))))==true then return (nil); end;
if (smalltalk:notNil_((self["@receiver"])))==true then smalltalk:if_true_false_(((testBlock):value_(self["@receiver"])),(function()
return ((aBlock):value_value_(self["@receiver"],self))
end),(function()
return ((self["@receiver"]):with_except_do_(testBlock,except,aBlock))
end)); end;
return (self);
end
)
,"iteration","with: testBlock except: except do: aBlock\r\n\t\" Evaluate aBlock for all nodes (returning true when evaluated with testBlock) in the local context of receiver. \"\r\n\r\n\t(super with: testBlock except: except do: aBlock) isNil ifTrue: [ ^nil ].\r\n\treceiver notNil ifTrue: [\r\n\t\t(testBlock value: receiver)\r\n\t\tifTrue: [ aBlock value: receiver value: self ]\r\n\t\tifFalse: [ receiver with: testBlock except: except do: aBlock ]\r\n\t] ","(\r\nfunction(self,testBlock,except,aBlock)\r\nif (smalltalk:isNil_((smalltalk:superImplementor(smalltalk.CascadeNode,\"with_except_do_\")(self,testBlock,except,aBlock))))==true then return (nil); end;\r\nif (smalltalk:notNil_((self[\"@receiver\"])))==true then smalltalk:if_true_false_(((testBlock):value_(self[\"@receiver\"])),(function()\r\nreturn ((aBlock):value_value_(self[\"@receiver\"],self))\r\nend),(function()\r\nreturn ((self[\"@receiver\"]):with_except_do_(testBlock,except,aBlock))\r\nend)); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockNode,"parameterNames",0
,(
function(self)
local result=nil
(function()
	local _s8_value=(((self):parameters()):collect_((function(each)
return (smalltalk:if_true_false_(((each):isString()),(function()
return (each)
end),(function()
return ((each):value())
end)))
end)))
	result=_s8_value
	return _s8_value
end)();
if not ((smalltalk:isObject_equalTo_((((result):asSet()):size()),(result):size())))==true then return ((self):error_(smalltalk:object_comma_(("Invalid names "),(result):asLiteral()))); end;
return (result);
end
)
,"accessing","parameterNames\r\n\t\" Return the names of the parameters of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self parameters collect: [:each|\r\n\t\teach isString\r\n\t\tifTrue: [each]\r\n\t\tifFalse: [each value]\r\n\t].\r\n\tresult asSet size = result size ifFalse: [\r\n\t\t^self error: 'Invalid names ' ,result asLiteral\r\n\t].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):parameters()):collect_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):isString()),(function()\r\nreturn (each)\r\nend),(function()\r\nreturn ((each):value())\r\nend)))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:isObject_equalTo_((((result):asSet()):size()),(result):size())))==true then return ((self):error_(smalltalk:object_comma_((\"Invalid names \"),(result):asLiteral()))); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockNode,"parameters",0
,(
function(self)
if (smalltalk:isNil_((self["@parameters"])))==true then (function()
	local _s8_value=((smalltalk.Array):new())
	self["@parameters"]=_s8_value
	return _s8_value
end)(); end;
return (self["@parameters"]);
end
)
,"accessing","parameters\r\n\tparameters isNil ifTrue: [ parameters := Array new ].\r\n\t^parameters","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@parameters\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@parameters\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@parameters\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockNode,"parameters:",0
,(
function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@parameters"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","parameters: aCollection\r\n\tparameters := aCollection","(\r\nfunction(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@parameters\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockNode,"accept:",0
,(
function(self,aVisitor)
(aVisitor):visitBlockNode_(self);
return (self);
end
)
,"visiting","accept: aVisitor\r\n\taVisitor visitBlockNode: self","(\r\nfunction(self,aVisitor)\r\n(aVisitor):visitBlockNode_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockNode,"bindings",0
,(
function(self)
return ((self):parameterNames());
end
)
,"bindings","bindings\r\n\t\" Return the bindings of the receiver. \"\r\n\r\n\t^self parameterNames","(\r\nfunction(self)\r\nreturn ((self):parameterNames());\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockNode,"isBlock",0
,(
function(self)
return (true);
end
)
,"testing","isBlock\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockNode,"do:in:",0
,(
function(self,aBlock,aNode)
smalltalk:superImplementor(smalltalk.BlockNode,"do_in_")(self,aBlock,aNode);
((self):parameters()):do_((function(each)
return ((each):do_in_(aBlock,self))
end));
return (self);
end
)
,"iteration","do: aBlock in: aNode\r\n\t\" Evaluate aBlock for all contents of the receiver. \"\r\n\r\n\tsuper do: aBlock in: aNode.\r\n\tself parameters do: [:each| each do: aBlock in: self ].","(\r\nfunction(self,aBlock,aNode)\r\nsmalltalk:superImplementor(smalltalk.BlockNode,\"do_in_\")(self,aBlock,aNode);\r\n((self):parameters()):do_((function(each)\r\nreturn ((each):do_in_(aBlock,self))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceNode,"tempNames",0
,(
function(self)
return (((self):temps()):collect_((function(each)
return (smalltalk:if_true_false_(((each):isString()),(function()
return (each)
end),(function()
return ((each):value())
end)))
end)));
end
)
,"accessing","tempNames\r\n\t\" Return the names of the temps in the receiver. \"\r\n\r\n\t^self temps collect: [:each|\r\n\t\teach isString\r\n\t\tifTrue: [each]\r\n\t\tifFalse: [each value]\r\n\t]","(\r\nfunction(self)\r\nreturn (((self):temps()):collect_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):isString()),(function()\r\nreturn (each)\r\nend),(function()\r\nreturn ((each):value())\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceNode,"temps",0
,(
function(self)
return (smalltalk:if_true_false_((smalltalk:isNil_((self["@temps"]))),(function()
return (smalltalk:newArray({}))
end),(function()
return (self["@temps"])
end)));
end
)
,"accessing","temps\r\n\t^temps isNil ifTrue: [ #() ] ifFalse: [ temps ]","(\r\nfunction(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((self[\"@temps\"]))),(function()\r\nreturn (smalltalk:newArray({}))\r\nend),(function()\r\nreturn (self[\"@temps\"])\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceNode,"temps:",0
,(
function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@temps"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","temps: aCollection\r\n\ttemps := aCollection","(\r\nfunction(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@temps\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceNode,"asBlockSequenceNode",0
,(
function(self)
return ((
function(_s8_rec)
	(_s8_rec):nodes_((self):nodes());
	(_s8_rec):temps_((self):temps());
	(_s8_rec):start_end_((self):start(),(self):__end());
	return ((_s8_rec):yourself())
end
)((smalltalk.BlockSequenceNode):new()));
end
)
,"converting","asBlockSequenceNode\r\n\t^BlockSequenceNode new\r\n\t    nodes: self nodes;\r\n\t    temps: self temps;\r\n\t    start: self start end: self end;\r\n\t    yourself","(\r\nfunction(self)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nodes_((self):nodes());\r\n\t(_s8_rec):temps_((self):temps());\r\n\t(_s8_rec):start_end_((self):start(),(self):__end());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.BlockSequenceNode):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceNode,"accept:",0
,(
function(self,aVisitor)
(aVisitor):visitSequenceNode_(self);
return (self);
end
)
,"visiting","accept: aVisitor\r\n\taVisitor visitSequenceNode: self","(\r\nfunction(self,aVisitor)\r\n(aVisitor):visitSequenceNode_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceNode,"bindings",0
,(
function(self)
return ((self):tempNames());
end
)
,"bindings","bindings\r\n\t\" Return the bindings of the receiver. \"\r\n\r\n\t^self tempNames","(\r\nfunction(self)\r\nreturn ((self):tempNames());\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceNode,"isSequence",0
,(
function(self)
return (true);
end
)
,"testing","isSequence\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceNode,"shouldReturn",0
,(
function(self)
if (smalltalk:boolean_and_((((self):nodes()):notEmpty()),(function()
return ((((self):nodes()):last()):isReturn())
end)))==true then return (self); end;
(self):addNode_((smalltalk.ReturnNode):variable_at_("self",(self):__end()));
return (self);
end
)
,"return","shouldReturn\r\n\t\" Ensure the receiver includes a return node. \"\r\n\r\n\t(self nodes notEmpty and: [\r\n\t\tself nodes last isReturn\r\n\t]) ifTrue: [ ^self].\r\n\r\n\tself addNode: (ReturnNode variable: #self at: self end).","(\r\nfunction(self)\r\nif (smalltalk:boolean_and_((((self):nodes()):notEmpty()),(function()\r\nreturn ((((self):nodes()):last()):isReturn())\r\nend)))==true then return (self); end;\r\n(self):addNode_((smalltalk.ReturnNode):variable_at_(\"self\",(self):__end()));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SequenceNode,"validateNames:",0
,(
function(self,names)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
((self):tempNames()):do_((function(temp)
return (smalltalk:if_true_false_(((names):includes_(temp)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_(("Invalid temp ("),temp)),")")))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"validation","validateNames: names\r\n\t\" Validate the receiver can be emmited in a context with names. \"\r\n\r\n\tself tempNames do: [:temp|\r\n\t\t(names includes: temp) ifTrue: [\r\n\t\t\t^self error: 'Invalid temp (',temp,')'\r\n\t\t].\r\n\t]","(\r\nfunction(self,names)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n((self):tempNames()):do_((function(temp)\r\nreturn (smalltalk:if_true_false_(((names):includes_(temp)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((\"Invalid temp (\"),temp)),\")\")))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.BlockSequenceNode,"accept:",0
,(
function(self,aVisitor)
(aVisitor):visitBlockSequenceNode_(self);
return (self);
end
)
,"visiting","accept: aVisitor\r\n\taVisitor visitBlockSequenceNode: self","(\r\nfunction(self,aVisitor)\r\n(aVisitor):visitBlockSequenceNode_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ExtendedSequenceNode,"accept:",0
,(
function(self,aVisitor)
(aVisitor):visitExtendedSequenceNode_(self);
return (self);
end
)
,"visiting","accept: aVisitor\r\n\taVisitor visitExtendedSequenceNode: self","(\r\nfunction(self,aVisitor)\r\n(aVisitor):visitExtendedSequenceNode_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ExtendedSequenceNode,"directives",0
,(
function(self)
return (smalltalk:if_true_false_((smalltalk:isNil_((self["@directives"]))),(function()
return (smalltalk:newArray({}))
end),(function()
return (self["@directives"])
end)));
end
)
,"accessing","directives\r\n\t\" Return the directives of the receiver. \"\r\n\r\n\t^directives isNil\r\n\t\tifTrue: [ #() ]\r\n\t\tifFalse: [directives]","(\r\nfunction(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((self[\"@directives\"]))),(function()\r\nreturn (smalltalk:newArray({}))\r\nend),(function()\r\nreturn (self[\"@directives\"])\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ExtendedSequenceNode,"directives:",0
,(
function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@directives"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","directives: aCollection\r\n\t\" Set the directives of the receiver. \"\r\n\r\n\tdirectives := aCollection","(\r\nfunction(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@directives\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.AssignmentNode,"left",0
,(
function(self)
return (self["@left"]);
end
)
,"accessing","left\r\n\t^left","(\r\nfunction(self)\r\nreturn (self[\"@left\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.AssignmentNode,"left:",0
,(
function(self,aNode)
(function()
	local _s8_value=(aNode)
	self["@left"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","left: aNode\r\n\tleft := aNode","(\r\nfunction(self,aNode)\r\n(function()\r\n\tlocal _s8_value=(aNode)\r\n\tself[\"@left\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.AssignmentNode,"right",0
,(
function(self)
return (self["@right"]);
end
)
,"accessing","right\r\n\t^right","(\r\nfunction(self)\r\nreturn (self[\"@right\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.AssignmentNode,"right:",0
,(
function(self,aNode)
(function()
	local _s8_value=(aNode)
	self["@right"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","right: aNode\r\n\tright := aNode","(\r\nfunction(self,aNode)\r\n(function()\r\n\tlocal _s8_value=(aNode)\r\n\tself[\"@right\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.AssignmentNode,"accept:",0
,(
function(self,aVisitor)
(aVisitor):visitAssignmentNode_(self);
return (self);
end
)
,"visiting","accept: aVisitor\r\n\taVisitor visitAssignmentNode: self","(\r\nfunction(self,aVisitor)\r\n(aVisitor):visitAssignmentNode_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.AssignmentNode,"isAssignment",0
,(
function(self)
return (true);
end
)
,"testing","isAssignment\r\n\t\" Return true if the receiver is an assignment node. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.AssignmentNode,"do:in:",0
,(
function(self,aBlock,aNode)
smalltalk:superImplementor(smalltalk.AssignmentNode,"do_in_")(self,aBlock,aNode);
if (smalltalk:notNil_((self["@left"])))==true then (self["@left"]):do_in_(aBlock,self); end;
if (smalltalk:notNil_((self["@right"])))==true then (self["@right"]):do_in_(aBlock,self); end;
return (self);
end
)
,"iteration","do: aBlock in: aNode\r\n\t\" Evaluate aBlock for all contents of the receiver. \"\r\n\r\n\tsuper do: aBlock in: aNode.\r\n\tleft  notNil ifTrue: [ left  do: aBlock in: self ].\r\n\tright notNil ifTrue: [ right do: aBlock in: self ].","(\r\nfunction(self,aBlock,aNode)\r\nsmalltalk:superImplementor(smalltalk.AssignmentNode,\"do_in_\")(self,aBlock,aNode);\r\nif (smalltalk:notNil_((self[\"@left\"])))==true then (self[\"@left\"]):do_in_(aBlock,self); end;\r\nif (smalltalk:notNil_((self[\"@right\"])))==true then (self[\"@right\"]):do_in_(aBlock,self); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.AssignmentNode,"with:except:do:",0
,(
function(self,testBlock,except,aBlock)
if (smalltalk:isNil_((smalltalk:superImplementor(smalltalk.AssignmentNode,"with_except_do_")(self,testBlock,except,aBlock))))==true then return (nil); end;
if (smalltalk:notNil_((self["@right"])))==true then smalltalk:if_true_false_(((testBlock):value_(self["@right"])),(function()
return ((aBlock):value_value_(self["@right"],self))
end),(function()
return ((self["@right"]):with_except_do_(testBlock,except,aBlock))
end)); end;
return (self);
end
)
,"iteration","with: testBlock except: except do: aBlock\r\n\t\" Evaluate aBlock for all nodes (returning true when evaluated with testBlock) in the local context of receiver. \"\r\n\r\n\t(super with: testBlock except: except do: aBlock) isNil ifTrue: [ ^nil ].\r\n\tright notNil ifTrue: [\r\n\t\t(testBlock value: right)\r\n\t\tifTrue: [ aBlock value: right value: self ]\r\n\t\tifFalse: [ right with: testBlock except: except do: aBlock ]\r\n\t] ","(\r\nfunction(self,testBlock,except,aBlock)\r\nif (smalltalk:isNil_((smalltalk:superImplementor(smalltalk.AssignmentNode,\"with_except_do_\")(self,testBlock,except,aBlock))))==true then return (nil); end;\r\nif (smalltalk:notNil_((self[\"@right\"])))==true then smalltalk:if_true_false_(((testBlock):value_(self[\"@right\"])),(function()\r\nreturn ((aBlock):value_value_(self[\"@right\"],self))\r\nend),(function()\r\nreturn ((self[\"@right\"]):with_except_do_(testBlock,except,aBlock))\r\nend)); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.AssignmentNode,"prepareIn:for:",0
,(
function(self,aNode,anEncoder)
smalltalk:superImplementor(smalltalk.AssignmentNode,"prepareIn_for_")(self,aNode,anEncoder);
(self["@right"]):client_(self);
return (self);
end
)
,"prepare","prepareIn: aNode for: anEncoder\r\n\t\" Prepare the receiver to be encoded by anEncoder in aNode. \"\r\n\r\n\tsuper prepareIn: aNode for: anEncoder.\r\n\tright client: self","(\r\nfunction(self,aNode,anEncoder)\r\nsmalltalk:superImplementor(smalltalk.AssignmentNode,\"prepareIn_for_\")(self,aNode,anEncoder);\r\n(self[\"@right\"]):client_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ReturnNode["$klass"],"variable:at:",0
,(
function(self,aName,offset)
return ((
function(_s8_rec)
	(_s8_rec):addNode_((
function(_s8_rec)
	(_s8_rec):value_(aName);
	(_s8_rec):start_end_(offset,offset);
	return ((_s8_rec):yourself())
end
)((smalltalk.VariableNode):new()));
	(_s8_rec):start_end_(offset,offset);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","variable: aName at: offset\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\taddNode: (VariableNode new\r\n\t\t\tvalue: aName;\r\n\t\t\tstart: offset end: offset;\r\n\t\t\tyourself);\r\n\t\tstart: offset end: offset;\r\n\t\tyourself","(\r\nfunction(self,aName,offset)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addNode_((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):value_(aName);\r\n\t(_s8_rec):start_end_(offset,offset);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.VariableNode):new()));\r\n\t(_s8_rec):start_end_(offset,offset);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.ReturnNode,"accept:",0
,(
function(self,aVisitor)
(aVisitor):visitReturnNode_(self);
return (self);
end
)
,"visiting","accept: aVisitor\r\n\taVisitor visitReturnNode: self","(\r\nfunction(self,aVisitor)\r\n(aVisitor):visitReturnNode_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ReturnNode,"isReturn",0
,(
function(self)
return (true);
end
)
,"testing","isReturn\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.ValueNode["$klass"],"with:",0
,(
function(self,aValue)
return (((self):new()):value_(aValue));
end
)
,"instantiation","with: aValue\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new value: aValue","(\r\nfunction(self,aValue)\r\nreturn (((self):new()):value_(aValue));\r\nend\r\n)")
smalltalk:bind(smalltalk.ValueNode,"value",0
,(
function(self)
return (self["@value"]);
end
)
,"accessing","value\r\n\t^value","(\r\nfunction(self)\r\nreturn (self[\"@value\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.ValueNode,"value:",0
,(
function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@value"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","value: anObject\r\n\tvalue := anObject","(\r\nfunction(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@value\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ValueNode,"accept:",0
,(
function(self,aVisitor)
(aVisitor):visitValueNode_(self);
return (self);
end
)
,"visiting","accept: aVisitor\r\n\taVisitor visitValueNode: self","(\r\nfunction(self,aVisitor)\r\n(aVisitor):visitValueNode_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ValueNode,"hasNumber",0
,(
function(self)
return ((self["@value"]):isNumber());
end
)
,"testing","hasNumber\r\n\t\" Return true if the receiver has a numeric literal value. \"\r\n\r\n\t^value isNumber","(\r\nfunction(self)\r\nreturn ((self[\"@value\"]):isNumber());\r\nend\r\n)")
smalltalk:bind(smalltalk.ValueNode,"hasString",0
,(
function(self)
return ((self["@value"]):isString());
end
)
,"testing","hasString\r\n\t\" Return true if the receiver has a string literal value. \"\r\n\r\n\t^value isString","(\r\nfunction(self)\r\nreturn ((self[\"@value\"]):isString());\r\nend\r\n)")
smalltalk:bind(smalltalk.ValueNode,"isValue",0
,(
function(self)
return (true);
end
)
,"testing","isValue\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.VariableNode,"localNameIn:",0
,(
function(self,aCompiler)
return ((aCompiler):localName_((self):value()));
end
)
,"accessing","localNameIn: aCompiler\r\n\t\" Return the name of the receiver to be used by aCompiler locally. \"\r\n\r\n\t^aCompiler localName: self value ","(\r\nfunction(self,aCompiler)\r\nreturn ((aCompiler):localName_((self):value()));\r\nend\r\n)")
smalltalk:bind(smalltalk.VariableNode,"needsVerification",0
,(
function(self)
return (true);
end
)
,"testing","needsVerification\r\n\t\" Return true if the receiver need verification. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.VariableNode,"accept:",0
,(
function(self,aVisitor)
(aVisitor):visitVariableNode_(self);
return (self);
end
)
,"visiting","accept: aVisitor\r\n\taVisitor visitVariableNode: self","(\r\nfunction(self,aVisitor)\r\n(aVisitor):visitVariableNode_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.VariableNode,"isSuper",0
,(
function(self)
return (smalltalk:isObject_equalTo_((self["@value"]),"super"));
end
)
,"testing","isSuper\r\n\t\" Return true if the receiver is super. \"\r\n\r\n\t^value = 'super'","(\r\nfunction(self)\r\nreturn (smalltalk:isObject_equalTo_((self[\"@value\"]),\"super\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.VariableNode,"indices",0
,(
function(self)
return (smalltalk:if_true_false_((smalltalk:isNil_((self["@indices"]))),(function()
return ((smalltalk.Array):new())
end),(function()
return (self["@indices"])
end)));
end
)
,"accessing","indices\r\n\t\" Return the indexing references of the receiver. \"\r\n\r\n\t^indices isNil ifTrue: [ Array new ] ifFalse: [ indices ]","(\r\nfunction(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((self[\"@indices\"]))),(function()\r\nreturn ((smalltalk.Array):new())\r\nend),(function()\r\nreturn (self[\"@indices\"])\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.VariableNode,"reference:",0
,(
function(self,chain)
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:boolean_and_(((((chain):size()) > 1)),(function()
return (((chain):second()):notEmpty())
end))),(function()
return (((chain):second()):collect_((function(tuple)
return (smalltalk:if_true_false_((((tuple):second()):isString()),(function()
return (((smalltalk.ValueNode):new()):value_((tuple):second()))
end),(function()
return ((tuple):second())
end)))
end)))
end),nil))
	self["@indices"]=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_and_(((((chain):size()) > 2)),(function()
return (((chain):third()):notEmpty())
end)))==true then (self):annotations_((chain):third()); end;
return (self);
end
)
,"visiting","reference: chain\r\n\t\" The receiver is a reference defined by chain. \"\r\n\r\n\tindices := (chain size > 1 and: [ chain second notEmpty ]) ifTrue: [\r\n\t\tchain second collect: [:tuple|\r\n\t\t\ttuple second isString\r\n\t\t\tifTrue: [ ValueNode new value: tuple second ]\r\n\t\t\tifFalse: [ tuple second ]\r\n\t\t]\r\n\t].\r\n\t(chain size > 2 and: [ chain third notEmpty ]) ifTrue: [\r\n\t\tself annotations: chain third\r\n\t].\r\n\t^self","(\r\nfunction(self,chain)\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:boolean_and_(((((chain):size()) > 1)),(function()\r\nreturn (((chain):second()):notEmpty())\r\nend))),(function()\r\nreturn (((chain):second()):collect_((function(tuple)\r\nreturn (smalltalk:if_true_false_((((tuple):second()):isString()),(function()\r\nreturn (((smalltalk.ValueNode):new()):value_((tuple):second()))\r\nend),(function()\r\nreturn ((tuple):second())\r\nend)))\r\nend)))\r\nend),nil))\r\n\tself[\"@indices\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_and_(((((chain):size()) > 2)),(function()\r\nreturn (((chain):third()):notEmpty())\r\nend)))==true then (self):annotations_((chain):third()); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.VariableNode,"isVariable",0
,(
function(self)
return (true);
end
)
,"testing","isVariable\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.GlobalReferenceNode,"accept:",0
,(
function(self,aVisitor)
(aVisitor):visitGlobalReferenceNode_(self);
return (self);
end
)
,"visiting","accept: aVisitor\r\n\taVisitor visitGlobalReferenceNode: self","(\r\nfunction(self,aVisitor)\r\n(aVisitor):visitGlobalReferenceNode_(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NoReceiverNode,"accept:",0
,(
function(self,aVisitor)
return (self);
end
)
,"visiting","accept: aVisitor","(\r\nfunction(self,aVisitor)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NoReceiverNode,"messageSendConnector",0
,(
function(self)
return (nil);
end
)
,"accessing","messageSendConnector\r\n\t\" Return the connector used to encode message sent to the receiver (or nil). \"\r\n\r\n\t^nil ","(\r\nfunction(self)\r\nreturn (nil);\r\nend\r\n)")
smalltalk:bind(smalltalk.AlienNode,"localNameIn:",0
,(
function(self,aCompiler)
return ((aCompiler):alienName_((self):value()));
end
)
,"accessing","localNameIn: aCompiler\r\n\t\" Return the name of the receiver to be used by aCompiler locally. \"\r\n\r\n\t^aCompiler alienName: self value ","(\r\nfunction(self,aCompiler)\r\nreturn ((aCompiler):alienName_((self):value()));\r\nend\r\n)")
smalltalk:bind(smalltalk.AlienNode,"needsVerification",0
,(
function(self)
return (false);
end
)
,"testing","needsVerification\r\n\t\" Return true if the receiver need verification. \"\r\n\r\n\t^false","(\r\nfunction(self)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.InlineNode["$klass"],"sources:parser:",0
,(
function(self,tuples,parser)
return (((self):basicNew()):initialize_parser_(tuples,parser));
end
)
,"instantiation","sources: tuples parser: parser\r\n\t^self basicNew\r\n\t\tinitialize: tuples\r\n\t\tparser: parser ","(\r\nfunction(self,tuples,parser)\r\nreturn (((self):basicNew()):initialize_parser_(tuples,parser));\r\nend\r\n)")
smalltalk:bind(smalltalk.InlineNode,"initialize:parser:",0
,(
function(self,tuples,parser)
(function()
	local _s8_value=(tuples)
	self["@sources"]=_s8_value
	return _s8_value
end)();
(self):capture_with_("s8",parser);
return (self);
end
)
,"initialize","initialize: tuples parser: parser\r\n\t\" Private - Initialize the receiver \"\r\n\r\n\tsources := tuples.\r\n\tself capture: #s8 with: parser. ","(\r\nfunction(self,tuples,parser)\r\n(function()\r\n\tlocal _s8_value=(tuples)\r\n\tself[\"@sources\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):capture_with_(\"s8\",parser);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.InlineNode,"sourceFor:in:",0
,(
function(self,lang,encoder)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local default=nil
(self["@sources"]):do_((function(tuple)
local code=nil
(function()
	local _s8_value=(((tuple):second()):value())
	code=_s8_value
	return _s8_value
end)();if (smalltalk:isObject_equalTo_(((tuple):first()),lang))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (code)
end
)()
error(_s8Ret_,0)
end)(); end;return (smalltalk:if_true_false_((smalltalk:isNil_(((tuple):first()))),(function()
return ((function()
	local _s8_value=(code)
	default=_s8_value
	return _s8_value
end)())
end),nil))
end));
if (smalltalk:notNil_((encoder)))==true then local result=nil
(function()
	local _s8_value=((encoder):inline_source_(self,default))
	result=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:notNil_((result))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (default)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"accessing","sourceFor: lang in: encoder\r\n\t\" Return the native source code to inline (or nil). \"\r\n\r\n\t| default |\r\n\tsources do: [:tuple| | code |\r\n\t\tcode := tuple second value.\r\n\t\ttuple first = lang ifTrue: [ ^code ].\r\n\t\ttuple first isNil ifTrue: [ default := code ].\r\n\t].\r\n\tencoder notNil ifTrue: [ | result |\r\n\t\tresult := encoder inline: self source: default.\r\n\t\tresult notNil ifTrue: [ ^result ]\r\n\t].\r\n\t^default","(\r\nfunction(self,lang,encoder)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal default=nil\r\n(self[\"@sources\"]):do_((function(tuple)\r\nlocal code=nil\r\n(function()\r\n\tlocal _s8_value=(((tuple):second()):value())\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isObject_equalTo_(((tuple):first()),lang))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (code)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return (smalltalk:if_true_false_((smalltalk:isNil_(((tuple):first()))),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(code)\r\n\tdefault=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),nil))\r\nend));\r\nif (smalltalk:notNil_((encoder)))==true then local result=nil\r\n(function()\r\n\tlocal _s8_value=((encoder):inline_source_(self,default))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:notNil_((result))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (default)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.InlineNode,"accept:",0
,(
function(self,aVisitor)
return ((aVisitor):visitInlineNode_(self));
end
)
,"visiting","accept: aVisitor\r\n\t^aVisitor visitInlineNode: self","(\r\nfunction(self,aVisitor)\r\nreturn ((aVisitor):visitInlineNode_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.InlineNode,"isInline",0
,(
function(self)
return (true);
end
)
,"testing","isInline\r\n\t\" Return true if the receiver is of this type. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.InlineNode,"capture:with:",0
,(
function(self,lang,parser)
(self["@sources"]):do_((function(tuple)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((tuple):first()),lang)),(function()
return ((self):parse_at_with_(((tuple):second()):value(),((tuple):second()):start(),parser))
end),nil))
end));
return (self);
end
)
,"internal","capture: lang with: parser\r\n\t\" Private - Capture internal contents from sources. \"\r\n\r\n\tsources do: [:tuple| tuple first = lang ifTrue: [\r\n\t\tself parse: tuple second value at: tuple second start with: parser\t\r\n\t]]","(\r\nfunction(self,lang,parser)\r\n(self[\"@sources\"]):do_((function(tuple)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((tuple):first()),lang)),(function()\r\nreturn ((self):parse_at_with_(((tuple):second()):value(),((tuple):second()):start(),parser))\r\nend),nil))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.InlineNode,"parse:at:with:",0
,(
function(self,code,offset,parser)
local stream=nil
local array=nil
(function()
	local _s8_value=((""):stream())
	stream=_s8_value
	return _s8_value
end)();
smalltalk:times_repeat_((offset),(function()
return ((stream):nextPut_(" "))
end));
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(code);
	return ((_s8_rec):position_(offset))
end
)(stream);
(function()
	local _s8_value=((smalltalk:object_comma_((parser),(smalltalk.PPEOFParser):new())):parse_(stream))
	array=_s8_value
	return _s8_value
end)();
if not ((smalltalk:boolean_and_(((array):isArray()),(function()
return ((((array):size()) > 1))
end))))==true then (self):error_(smalltalk:object_comma_(("Invalid inline code "),smalltalk:asString_((code)))); end;
(self):addNode_((array):second());
return (self);
end
)
,"internal","parse: code at: offset with: parser\r\n\t\" Private - Parse internal contents from code using parser. \"\r\n\r\n\t| stream array |\r\n\tstream := '' stream.\r\n\toffset timesRepeat: [ stream nextPut: $ ].\r\n\tstream nextPutAll: code; position: offset.\r\n\tarray := parser ,PPEOFParser new parse: stream.\r\n\t(array isArray and: [array size > 1]) ifFalse: [\r\n\t\tself error: 'Invalid inline code ' ,code asString\r\n\t].\r\n\tself addNode: array second","(\r\nfunction(self,code,offset,parser)\r\nlocal stream=nil\r\nlocal array=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:times_repeat_((offset),(function()\r\nreturn ((stream):nextPut_(\" \"))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(code);\r\n\treturn ((_s8_rec):position_(offset))\r\nend\r\n)(stream);\r\n(function()\r\n\tlocal _s8_value=((smalltalk:object_comma_((parser),(smalltalk.PPEOFParser):new())):parse_(stream))\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:boolean_and_(((array):isArray()),(function()\r\nreturn ((((array):size()) > 1))\r\nend))))==true then (self):error_(smalltalk:object_comma_((\"Invalid inline code \"),smalltalk:asString_((code)))); end;\r\n(self):addNode_((array):second());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.DirectiveNode,"description",0
,(
function(self)
return (((self)["$klass"]):name());
end
)
,"visiting","description\r\n\t\" Return the description of the receiver. \"\r\n\r\n\t^self class name","(\r\nfunction(self)\r\nreturn (((self)[\"$klass\"]):name());\r\nend\r\n)")
smalltalk:bind(smalltalk.DirectiveNode,"selector",0
,(
function(self)
return (("directive:arguments:"):asSelector());
end
)
,"visiting","selector\r\n\t\" Private - Return the internal selector used to execute directive. \"\r\n\r\n\t^#directive:arguments: asSelector","(\r\nfunction(self)\r\nreturn ((\"directive:arguments:\"):asSelector());\r\nend\r\n)")
smalltalk:bind(smalltalk.DirectiveNode,"literal",0
,(
function(self)
return ((self):implementedBySubclass());
end
)
,"visiting","literal\r\n\t\" Private - Return the literal to embedd in directive call. \"\r\n\r\n\t^self implementedBySubclass","(\r\nfunction(self)\r\nreturn ((self):implementedBySubclass());\r\nend\r\n)")
smalltalk:bind(smalltalk.DirectiveNode,"asNative:for:on:",0
,(
function(self,selector,anEncoder,aStream)
local call=nil
(function()
	local _s8_value=((anEncoder):sourceToDirectCall_with_((self):selector(),(self):literal()))
	call=_s8_value
	return _s8_value
end)();
return ((anEncoder):sourceToTry_(call));
end
)
,"code generation","asNative: selector for: anEncoder on: aStream\r\n\t\" Return the native code to emmit the receiver. \"\r\n\r\n\t| call |\r\n\tcall := anEncoder\r\n\t\tsourceToDirectCall: self selector\r\n\t\twith: self literal.\r\n\t^anEncoder sourceToTry: call ","(\r\nfunction(self,selector,anEncoder,aStream)\r\nlocal call=nil\r\n(function()\r\n\tlocal _s8_value=((anEncoder):sourceToDirectCall_with_((self):selector(),(self):literal()))\r\n\tcall=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((anEncoder):sourceToTry_(call));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSDirectiveNode["$klass"],"code:protected:",0
,(
function(self,aCode,useTry)
return ((
function(_s8_rec)
	(_s8_rec):code_(aCode);
	(_s8_rec):protected_(useTry);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","code: aCode protected: useTry\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tcode: aCode;\r\n\t\tprotected: useTry;\r\n\t\tyourself","(\r\nfunction(self,aCode,useTry)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):code_(aCode);\r\n\t(_s8_rec):protected_(useTry);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSDirectiveNode,"code:",0
,(
function(self,aCode)
(function()
	local _s8_value=(aCode)
	self["@code"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","code: aCode\r\n\t\" Set the code of the receiver. \"\r\n\r\n\tcode := aCode","(\r\nfunction(self,aCode)\r\n(function()\r\n\tlocal _s8_value=(aCode)\r\n\tself[\"@code\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSDirectiveNode,"nativeCodeFor:",0
,(
function(self,anEncoder)
if ((self["@code"]):isString())==true then return (self["@code"]); end;
return ((self["@code"]):evaluateWith_(anEncoder));
end
)
,"accessing","nativeCodeFor: anEncoder\r\n\t\" Private - Return the native code of the receiver. \"\r\n\r\n\tcode isString ifTrue: [ ^code ].\r\n\t^code evaluateWith: anEncoder ","(\r\nfunction(self,anEncoder)\r\nif ((self[\"@code\"]):isString())==true then return (self[\"@code\"]); end;\r\nreturn ((self[\"@code\"]):evaluateWith_(anEncoder));\r\nend\r\n)")
smalltalk:bind(smalltalk.JSDirectiveNode,"protected:",0
,(
function(self,aBoolean)
(function()
	local _s8_value=(aBoolean)
	self["@protected"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","protected: aBoolean\r\n\t\" Set the receiver to use try/catch to handle failure. \"\r\n\r\n\tprotected := aBoolean","(\r\nfunction(self,aBoolean)\r\n(function()\r\n\tlocal _s8_value=(aBoolean)\r\n\tself[\"@protected\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JSDirectiveNode,"asNative:for:on:",0
,(
function(self,selector,anEncoder,aStream)
local string=nil
(function()
	local _s8_value=((self):nativeCodeFor_(anEncoder))
	string=_s8_value
	return _s8_value
end)();
if (((self["@protected"])==true))==true then return ((anEncoder):sourceToTry_(string)); end;
return (string);
end
)
,"code generation","asNative: selector for: anEncoder on: aStream\r\n\t\" Return the native code to emmit the receiver. \"\r\n\r\n\t| string |\r\n\tstring := self nativeCodeFor: anEncoder.\r\n\tprotected == true ifTrue: [\r\n\t\t^anEncoder sourceToTry: string\r\n\t].\r\n\t^string ","(\r\nfunction(self,selector,anEncoder,aStream)\r\nlocal string=nil\r\n(function()\r\n\tlocal _s8_value=((self):nativeCodeFor_(anEncoder))\r\n\tstring=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (((self[\"@protected\"])==true))==true then return ((anEncoder):sourceToTry_(string)); end;\r\nreturn (string);\r\nend\r\n)")
smalltalk:bind(smalltalk.InlineOptimizationNode,"args",0
,(
function(self)
return (self["@args"]);
end
)
,"accessing","args\r\n\t\" Return the args of the receiver. \"\r\n\r\n\t^args","(\r\nfunction(self)\r\nreturn (self[\"@args\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.InlineOptimizationNode,"args:",0
,(
function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@args"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","args: anObject\r\n\t\" Set the args of the receiver. \"\r\n\r\n\targs := anObject","(\r\nfunction(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@args\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.InlineOptimizationNode,"remove",0
,(
function(self)
return (self["@remove"]);
end
)
,"accessing","remove\r\n\t\" Return the remove of the receiver. \"\r\n\r\n\t^remove","(\r\nfunction(self)\r\nreturn (self[\"@remove\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.InlineOptimizationNode,"remove:",0
,(
function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@remove"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","remove: anObject\r\n\t\" Set the remove of the receiver. \"\r\n\r\n\tremove := anObject","(\r\nfunction(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@remove\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.InlineOptimizationNode,"asNative:for:on:",0
,(
function(self,selector,anEncoder,aStream)
if ((self):remove())==true then (anEncoder):removeOptimizations_(self["@args"]); else (anEncoder):addOptimizations_(self["@args"]); end;
return (nil);
end
)
,"code generation","asNative: selector for: anEncoder on: aStream\r\n\t\" Return the native code to emmit the receiver. \"\r\n\r\n\tself remove\r\n\t\tifTrue: [ anEncoder removeOptimizations: args ]\r\n\t\tifFalse: [ anEncoder addOptimizations: args ].\r\n\t^nil ","(\r\nfunction(self,selector,anEncoder,aStream)\r\nif ((self):remove())==true then (anEncoder):removeOptimizations_(self[\"@args\"]); else (anEncoder):addOptimizations_(self[\"@args\"]); end;\r\nreturn (nil);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPFailure["$klass"],"reason:at:",0
,(
function(self,aString,anInteger)
return (((self):new()):reason_at_(aString,anInteger));
end
)
,"instantiation","reason: aString at: anInteger\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new reason: aString at: anInteger","(\r\nfunction(self,aString,anInteger)\r\nreturn (((self):new()):reason_at_(aString,anInteger));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPFailure,"position",0
,(
function(self)
if (smalltalk:isNil_((self["@position"])))==true then return (0); end;
return (self["@position"]);
end
)
,"accessing","position\r\n\t\" Return the position of the receiver. \"\r\n\r\n\tposition isNil ifTrue: [ ^0 ].\r\n\t^position","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@position\"])))==true then return (0); end;\r\nreturn (self[\"@position\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPFailure,"position:",0
,(
function(self,aNumber)
(function()
	local _s8_value=(aNumber)
	self["@position"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","position: aNumber\r\n\t\" Set the position of the receiver. \"\r\n\r\n\tposition := aNumber","(\r\nfunction(self,aNumber)\r\n(function()\r\n\tlocal _s8_value=(aNumber)\r\n\tself[\"@position\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPFailure,"toString",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Failure "),smalltalk:printString_(((self):reason())))),"(@")),(self):position())),")"));
end
)
,"printing","toString\r\n\t\" Return the receiver converted to String. \"\r\n\r\n\t^'Failure ',self reason printString ,'(@',self position,')'","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Failure \"),smalltalk:printString_(((self):reason())))),\"(@\")),(self):position())),\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPFailure,"reason",0
,(
function(self)
if (smalltalk:isNil_((self["@reason"])))==true then return ((smalltalk.String):new()); end;
return (self["@reason"]);
end
)
,"accessing","reason\r\n\t\" Return the reason of the receiver. \"\r\n\r\n\treason isNil ifTrue: [ ^String new ].\r\n\t^reason","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@reason\"])))==true then return ((smalltalk.String):new()); end;\r\nreturn (self[\"@reason\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPFailure,"reason:",0
,(
function(self,aString)
(function()
	local _s8_value=(smalltalk:object_comma_((""),aString))
	self["@reason"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","reason: aString\r\n\t\" Set the reason of the receiver. \"\r\n\r\n\treason := '' ,aString","(\r\nfunction(self,aString)\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((\"\"),aString))\r\n\tself[\"@reason\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPFailure,"reason:at:",0
,(
function(self,aString,anInteger)
(
function(_s8_rec)
	(_s8_rec):reason_(aString);
	return ((_s8_rec):position_(anInteger))
end
)(self);
return (self);
end
)
,"accessing","reason: aString at: anInteger\r\n\t\" Set the reason and position of the receiver. \"\r\n\r\n\tself\r\n\t\treason: aString; \r\n\t\tposition: anInteger","(\r\nfunction(self,aString,anInteger)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):reason_(aString);\r\n\treturn ((_s8_rec):position_(anInteger))\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPFailure,"isParseFailure",0
,(
function(self)
return (true);
end
)
,"testing","isParseFailure\r\n\t\" Return true if the receiver is a parse failure. \"\r\n\r\n\t^true","(\r\nfunction(self)\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPFailure,"accept:",0
,(
function(self,anEncoder)
local description=nil
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("PPFailure: "),(self):reason()))," at: ")),smalltalk:asString_(((self):position()))))," source: ")),((anEncoder):stream()):contents()))
	description=_s8_value
	return _s8_value
end)();
(self):print_(description);
(self):error_(description);
return (self);
end
)
,"bug","accept: anEncoder\r\n\t\" Report compilation failure and error. \"\r\n\r\n\t| description |\r\n\tdescription := 'PPFailure: ', self reason\r\n\t\t,' at: ' ,self position asString\r\n\t\t,' source: ' ,anEncoder stream contents.\r\n\tself print: description.\r\n\tself error: description","(\r\nfunction(self,anEncoder)\r\nlocal description=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"PPFailure: \"),(self):reason())),\" at: \")),smalltalk:asString_(((self):position())))),\" source: \")),((anEncoder):stream()):contents()))\r\n\tdescription=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):print_(description);\r\n(self):error_(description);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPFailure,"__tostring",0
,(
function(self)
return (smalltalk:toString_((self)));
end
)
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","(\r\nfunction(self)\r\nreturn (smalltalk:toString_((self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser["$klass"],",","_comma"
,(
function(self,anObject)
return ((anObject):asParser());
end
)
,"instantiation",", anObject\r\n\t\" Return the receiver composed with the argument. \"\r\n\r\n\t^anObject asParser","(\r\nfunction(self,anObject)\r\nreturn ((anObject):asParser());\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser["$klass"],"optional:",0
,(
function(self,anObject)
return ((smalltalk:object_comma_((self),anObject)):optional());
end
)
,"instantiation","optional: anObject\r\n\t\" Return an instance of the receiver to parse an optional element anObject. \"\r\n\r\n\t^(self ,anObject) optional","(\r\nfunction(self,anObject)\r\nreturn ((smalltalk:object_comma_((self),anObject)):optional());\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser["$klass"],"debug:or:",0
,(
function(self,action,aBlock)
local show=nil
local result=nil
(function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((smalltalk.PPParser),"debugOn",(function()
(function()
	local _s8_value=((aBlock):evaluate())
	result=_s8_value
	return _s8_value
end)();return (false)
end)))
	show=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((show),true))==true then (function()
	local _s8_value=((action):evaluate())
	result=_s8_value
	return _s8_value
end)(); end;
return (result);
end
)
,"debug","debug: action or: aBlock\r\n\t\" Log evaluation of action if in debugging mode,\r\n\t else returns the result of evaluation of aBlock.\r\n\t\"\r\n\r\n\t| show result |\r\n\tshow := PPParser basicAt: #debugOn ifAbsent:[ result := aBlock evaluate. false ].\r\n\tshow = true ifTrue: [ result := action evaluate ].\r\n\t^result","(\r\nfunction(self,action,aBlock)\r\nlocal show=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((smalltalk.PPParser),\"debugOn\",(function()\r\n(function()\r\n\tlocal _s8_value=((aBlock):evaluate())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();return (false)\r\nend)))\r\n\tshow=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((show),true))==true then (function()\r\n\tlocal _s8_value=((action):evaluate())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser["$klass"],"debugWhile:",0
,(
function(self,aBlock)
return (((function()
smalltalk:basic_at_put_((smalltalk.PPParser),"debugOn",true);return ((aBlock):evaluate())
end)):ensure_((function()
return (smalltalk:basic_at_put_((smalltalk.PPParser),"debugOn",false))
end)));
end
)
,"debug","debugWhile: aBlock\r\n\t^[\tPPParser basicAt: #debugOn put: true.\r\n\t\taBlock evaluate\r\n\t] ensure: [\r\n\t\tPPParser basicAt: #debugOn put: false\r\n\t]","(\r\nfunction(self,aBlock)\r\nreturn (((function()\r\nsmalltalk:basic_at_put_((smalltalk.PPParser),\"debugOn\",true);return ((aBlock):evaluate())\r\nend)):ensure_((function()\r\nreturn (smalltalk:basic_at_put_((smalltalk.PPParser),\"debugOn\",false))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"set:start:end:",0
,(
function(self,anElement,start,__end)
if (smalltalk:responds_to_((anElement),("start:end:")))==true then (anElement):start_end_(start,__end); end;
return (self);
end
)
,"private","set: anElement start: start end: end\r\n\t\" Private - Set start&end source offest of anElement. \"\r\n\r\n\t(anElement respondsTo: #start:end:) ifTrue: [\r\n\t\tanElement start: start end: end\r\n\t]","(\r\nfunction(self,anElement,start,__end)\r\nif (smalltalk:responds_to_((anElement),(\"start:end:\")))==true then (anElement):start_end_(start,__end); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"flatten",0
,(
function(self)
return ((smalltalk.PPFlattenParser):on_(self));
end
)
,"operations","flatten\r\n\t\" Return a flattened version of the receiver. \"\r\n\r\n\t^PPFlattenParser on: self","(\r\nfunction(self)\r\nreturn ((smalltalk.PPFlattenParser):on_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"withSource",0
,(
function(self)
return ((smalltalk.PPSourceParser):on_(self));
end
)
,"operations","withSource\r\n\t\" Return a source parser on the receiver. \"\r\n\r\n\t^PPSourceParser on: self","(\r\nfunction(self)\r\nreturn ((smalltalk.PPSourceParser):on_(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"==>","_eq_eq_gt"
,(
function(self,aBlock)
return ((smalltalk.PPActionParser):on_block_(self,aBlock));
end
)
,"operations","==> aBlock\r\n\t\" Return an action parser on the receiver. \"\r\n\r\n\t^PPActionParser on: self block: aBlock","(\r\nfunction(self,aBlock)\r\nreturn ((smalltalk.PPActionParser):on_block_(self,aBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,",","_comma"
,(
function(self,aParser)
return ((smalltalk.PPSequenceParser):with_with_(self,aParser));
end
)
,"operations",", aParser\r\n\t\" Return the receiver composed with the argument. \"\r\n\r\n\t^PPSequenceParser with: self with: aParser","(\r\nfunction(self,aParser)\r\nreturn ((smalltalk.PPSequenceParser):with_with_(self,aParser));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"/","_slash"
,(
function(self,aParser)
return ((smalltalk.PPChoiceParser):with_with_(self,aParser));
end
)
,"operations","/ aParser\r\n\t\" Return a choice composite version of the receiver and aParser. \"\r\n\r\n\t^PPChoiceParser with: self with: aParser","(\r\nfunction(self,aParser)\r\nreturn ((smalltalk.PPChoiceParser):with_with_(self,aParser));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"@","_at"
,(
function(self,tag)
smalltalk:basic_at_put_((self),"debugTag",tag);
return ((self):_eq_eq_gt((function(node)
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((tag),"==>")),smalltalk:printString_((node))));return (node)
end)));
end
)
,"debug","@ tag\r\n\t\" DEBUG - Return a notification wrapper of the receiver. \"\r\n\r\n\tself basicAt: #debugTag put: tag.\r\n\t^self ==> [:node| self note: tag ,'==>',node printString. node ]","(\r\nfunction(self,tag)\r\nsmalltalk:basic_at_put_((self),\"debugTag\",tag);\r\nreturn ((self):_eq_eq_gt((function(node)\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((tag),\"==>\")),smalltalk:printString_((node))));return (node)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"@@","_at_at"
,(
function(self,tag)
smalltalk:basic_at_put_((self),"debugTag",tag);
return (self);
end
)
,"debug","@@ tag\r\n\t\" DEBUG - Tag the receiver for debugging. \"\r\n\r\n\tself basicAt: #debugTag put: tag","(\r\nfunction(self,tag)\r\nsmalltalk:basic_at_put_((self),\"debugTag\",tag);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"plus",0
,(
function(self)
return (((smalltalk.PPRepeatingParser):on_min_(self,1)):_at_at("plus"));
end
)
,"operations","plus\r\n\t\" Return an iterative version of the receiver. \"\r\n\r\n\t^(PPRepeatingParser on: self min: 1) @@#plus","(\r\nfunction(self)\r\nreturn (((smalltalk.PPRepeatingParser):on_min_(self,1)):_at_at(\"plus\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"star",0
,(
function(self)
return (((smalltalk.PPRepeatingParser):on_min_(self,0)):_at_at("star"));
end
)
,"operations","star\r\n\t\" Return an iterative version of the receiver. \"\r\n\r\n\t^(PPRepeatingParser on: self min: 0) @@#star","(\r\nfunction(self)\r\nreturn (((smalltalk.PPRepeatingParser):on_min_(self,0)):_at_at(\"star\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"not","__not"
,(
function(self)
return (((smalltalk.PPNotParser):on_(self)):_at_at("not"));
end
)
,"operations","not\r\n\t\" Return the negation of the receiver. \"\r\n\r\n\t^(PPNotParser on: self) @@#not","(\r\nfunction(self)\r\nreturn (((smalltalk.PPNotParser):on_(self)):_at_at(\"not\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"optional",0
,(
function(self)
return (((self):_slash((smalltalk.PPEpsilonParser):new())):_at_at("opt"));
end
)
,"operations","optional\r\n\t\" Return an optional version of the receiver. \"\r\n\r\n\t^self / PPEpsilonParser new @@#opt","(\r\nfunction(self)\r\nreturn (((self):_slash((smalltalk.PPEpsilonParser):new())):_at_at(\"opt\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"isParseFailure:",0
,(
function(self,what)
return ((what):isParseFailure());
end
)
,"test","isParseFailure: what\r\n\t\" Private - Return true if what is a parsing failure. \"\r\n\r\n\t^what isParseFailure","(\r\nfunction(self,what)\r\nreturn ((what):isParseFailure());\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"valueToMemoize:start:",0
,(
function(self,aStream,start)
local __end=nil
local node=nil
(function()
	local _s8_value=((self):parse_(aStream))
	node=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aStream):position())
	__end=_s8_value
	return _s8_value
end)();
(self):set_start_end_(node,start,__end);
return ((smalltalk.Array):with_with_(node,__end));
end
)
,"memo","valueToMemoize: aStream start: start\r\n\t\" Private - Return the value to memoize as result of parsing en element in aStream. \"\r\n\r\n\t| end node |\r\n\tnode := self parse: aStream.\r\n\tend := aStream position.\r\n\tself set: node start: start end: end.\r\n\t^Array with: node with: end","(\r\nfunction(self,aStream,start)\r\nlocal __end=nil\r\nlocal node=nil\r\n(function()\r\n\tlocal _s8_value=((self):parse_(aStream))\r\n\tnode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aStream):position())\r\n\t__end=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):set_start_end_(node,start,__end);\r\nreturn ((smalltalk.Array):with_with_(node,__end));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"memoizedParse:",0
,(
function(self,aStream)
local start=nil
local value=nil
if (smalltalk:isNil_((self["@memo"])))==true then (function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	self["@memo"]=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=((aStream):position())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self["@memo"]):at_ifAbsentPut_(start,(function()
return ((self):valueToMemoize_start_(aStream,start))
end)))
	value=_s8_value
	return _s8_value
end)();
(aStream):position_((value):second());
return ((value):first());
end
)
,"memo","memoizedParse: aStream\r\n\t\" Private - Evaluate the receiver. \"\r\n\r\n\t| start value |\r\n\tmemo isNil ifTrue: [ memo := PoolDictionary new ].\r\n\tstart := aStream position.\r\n\tvalue := memo at: start ifAbsentPut: [\r\n\t\tself valueToMemoize: aStream start: start\r\n\t].\r\n\taStream position: value second.\r\n\t^value first","(\r\nfunction(self,aStream)\r\nlocal start=nil\r\nlocal value=nil\r\nif (smalltalk:isNil_((self[\"@memo\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tself[\"@memo\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((aStream):position())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self[\"@memo\"]):at_ifAbsentPut_(start,(function()\r\nreturn ((self):valueToMemoize_start_(aStream,start))\r\nend)))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aStream):position_((value):second());\r\nreturn ((value):first());\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"basicParse:",0
,(
function(self,aStream)
(self):subclassResponsibility_("basicParse:");
return (self);
end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\tself subclassResponsibility: #basicParse:","(\r\nfunction(self,aStream)\r\n(self):subclassResponsibility_(\"basicParse:\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"parseLog:",0
,(
function(self,aStream)
local result=nil
local old=nil
(function()
	local _s8_value=((aStream):position())
	old=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):basicParse_(aStream))
	result=_s8_value
	return _s8_value
end)();
if not (((self):isParseFailure_(result)))==true then (self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("["),old)),"-")),(aStream):position())),"] ")),smalltalk:printString_((self)))); end;
return (result);
end
)
,"parsing","parseLog: aStream\r\n\t\" Parse contents in aStream. \"\r\n\r\n\t| result old |\r\n\told := aStream position.\r\n\tresult := self basicParse: aStream.\r\n\t(self isParseFailure: result) ifFalse: [\r\n\t\tself note: $[ ,old ,$- ,aStream position ,'] ' ,self printString\r\n\t].\r\n\t^result","(\r\nfunction(self,aStream)\r\nlocal result=nil\r\nlocal old=nil\r\n(function()\r\n\tlocal _s8_value=((aStream):position())\r\n\told=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):basicParse_(aStream))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((self):isParseFailure_(result)))==true then (self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"[\"),old)),\"-\")),(aStream):position())),\"] \")),smalltalk:printString_((self)))); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"parse:",0
,(
function(self,aStream)
return ((smalltalk.PPParser):debug_or_((function()
return ((self):parseLog_(aStream))
end),(function()
return ((self):basicParse_(aStream))
end)));
end
)
,"parsing","parse: aStream\r\n\t\" Parse contents in aStream. \"\r\n\r\n\t^PPParser\r\n\t\tdebug: [self parseLog: aStream]\r\n\t\tor: [self basicParse: aStream]","(\r\nfunction(self,aStream)\r\nreturn ((smalltalk.PPParser):debug_or_((function()\r\nreturn ((self):parseLog_(aStream))\r\nend),(function()\r\nreturn ((self):basicParse_(aStream))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"parseAll:",0
,(
function(self,aStream)
local result=nil
(function()
	local _s8_value=(((smalltalk.PPSequenceParser):with_with_(self,(smalltalk.PPEOFParser):new())):memoizedParse_(aStream))
	result=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_(((self):isParseFailure_(result)),(function()
return ((self):error_((result):messageFor_((aStream):contents())))
end),(function()
return ((result):first())
end)));
end
)
,"parsing","parseAll: aStream\r\n\t\" Parse contents in aStream. \"\r\n\r\n\t| result |\r\n\tresult := (PPSequenceParser\r\n\t\twith: self with: PPEOFParser new)\r\n\t\tmemoizedParse: aStream.\r\n\t^(self isParseFailure: result)\r\n\t    ifTrue: [ self error: (result messageFor: aStream contents) ]\r\n\t    ifFalse: [ result first ]","(\r\nfunction(self,aStream)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.PPSequenceParser):with_with_(self,(smalltalk.PPEOFParser):new())):memoizedParse_(aStream))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_(((self):isParseFailure_(result)),(function()\r\nreturn ((self):error_((result):messageFor_((aStream):contents())))\r\nend),(function()\r\nreturn ((result):first())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"asParser",0
,(
function(self)
return (self);
end
)
,"converting","asParser\r\n\t\" Return a parser on the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"printStringDetail",0
,(
function(self)
return ("");
end
)
,"printing","printStringDetail\r\n\t\" Private - Return a printable detail of the receiver. \"\r\n\r\n\t^''","(\r\nfunction(self)\r\nreturn (\"\");\r\nend\r\n)")
smalltalk:bind(smalltalk.PPParser,"printString",0
,(
function(self)
local tag=nil
(function()
	local _s8_value=((self)["debugTag"])
	tag=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((tag)))==true then return (smalltalk:object_comma_((smalltalk:object_comma_(("@@"),tag)),"@@")); end;
return (smalltalk:object_comma_((smalltalk:object_comma_(("a"),((self)["$klass"]):name())),smalltalk:if_true_false_((smalltalk:isNil_((tag))),(function()
return ((self):printStringDetail())
end),(function()
return (smalltalk:object_comma_(("@@"),tag))
end))));
end
)
,"printing","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t| tag |\r\n\ttag := self basicAt: #debugTag.\r\n\ttag notNil ifTrue: [ ^#@@ ,tag ,#@@ ]. \"compact notation\"\r\n\r\n\t^#a ,self class name ,(tag isNil\r\n\t\tifTrue: [ self printStringDetail ]\r\n\t\tifFalse: [ '@@',tag ])","(\r\nfunction(self)\r\nlocal tag=nil\r\n(function()\r\n\tlocal _s8_value=((self)[\"debugTag\"])\r\n\ttag=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((tag)))==true then return (smalltalk:object_comma_((smalltalk:object_comma_((\"@@\"),tag)),\"@@\")); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"a\"),((self)[\"$klass\"]):name())),smalltalk:if_true_false_((smalltalk:isNil_((tag))),(function()\r\nreturn ((self):printStringDetail())\r\nend),(function()\r\nreturn (smalltalk:object_comma_((\"@@\"),tag))\r\nend))));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPEOFParser,"basicParse:",0
,(
function(self,aStream)
if ((aStream):atEnd())==true then return (nil); end;
return ((smalltalk.PPFailure):reason_at_("EOF expected (or invalid character in input)",(aStream):position()));
end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\taStream atEnd ifTrue: [ ^nil ] .\r\n\t^PPFailure reason: 'EOF expected (or invalid character in input)' at: aStream position","(\r\nfunction(self,aStream)\r\nif ((aStream):atEnd())==true then return (nil); end;\r\nreturn ((smalltalk.PPFailure):reason_at_(\"EOF expected (or invalid character in input)\",(aStream):position()));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPAnyParser,"basicParse:",0
,(
function(self,aStream)
if not (((aStream):atEnd()))==true then return ((aStream):next()); end;
return ((smalltalk.PPFailure):reason_at_("End of stream",(aStream):position()));
end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\taStream atEnd ifFalse: [ ^aStream next ].\r\n\t^PPFailure reason: 'End of stream' at: aStream position","(\r\nfunction(self,aStream)\r\nif not (((aStream):atEnd()))==true then return ((aStream):next()); end;\r\nreturn ((smalltalk.PPFailure):reason_at_(\"End of stream\",(aStream):position()));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPEpsilonParser,"basicParse:",0
,(
function(self,aStream)
return (nil);
end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\t^nil","(\r\nfunction(self,aStream)\r\nreturn (nil);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPStringParser,"string",0
,(
function(self)
return (self["@string"]);
end
)
,"accessing","string\r\n\t\" Return the string of the receiver. \"\r\n\r\n\t^string","(\r\nfunction(self)\r\nreturn (self[\"@string\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPStringParser,"string:",0
,(
function(self,aString)
(function()
	local _s8_value=(aString)
	self["@string"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","string: aString\r\n\t\" Set the string of the receiver. \"\r\n\r\n\tstring := aString","(\r\nfunction(self,aString)\r\n(function()\r\n\tlocal _s8_value=(aString)\r\n\tself[\"@string\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPStringParser,"basicParse:",0
,(
function(self,aStream)
local back=nil
local reason=nil
if ((self["@string"]):isEmpty())==true then return (self["@string"]); end;
(function()
	local _s8_value=((aStream):position())
	back=_s8_value
	return _s8_value
end)();
if ((aStream):peekForAll_(self["@string"]))==true then return (self["@string"]); end;
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Expecting "),smalltalk:printString_((self["@string"]))))," at ")),smalltalk:printString_((back))))," read ")),smalltalk:printString_(((aStream):next_((self["@string"]):size())))))
	reason=_s8_value
	return _s8_value
end)();
(aStream):position_(back);
return ((smalltalk.PPFailure):reason_at_(reason,back));
end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\t| back reason |\r\n\tstring isEmpty ifTrue: [ ^string ].\r\n\tback := aStream position.\r\n\t(aStream peekForAll: string) ifTrue: [ ^string ].\r\n\treason := 'Expecting ', string printString\r\n\t\t,' at ',back printString\r\n\t\t,' read ',(aStream next: string size) printString.\r\n\taStream position: back.\r\n\t^PPFailure reason: reason at: back","(\r\nfunction(self,aStream)\r\nlocal back=nil\r\nlocal reason=nil\r\nif ((self[\"@string\"]):isEmpty())==true then return (self[\"@string\"]); end;\r\n(function()\r\n\tlocal _s8_value=((aStream):position())\r\n\tback=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((aStream):peekForAll_(self[\"@string\"]))==true then return (self[\"@string\"]); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Expecting \"),smalltalk:printString_((self[\"@string\"])))),\" at \")),smalltalk:printString_((back)))),\" read \")),smalltalk:printString_(((aStream):next_((self[\"@string\"]):size())))))\r\n\treason=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aStream):position_(back);\r\nreturn ((smalltalk.PPFailure):reason_at_(reason,back));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPStringParser,"printStringDetail",0
,(
function(self)
return (smalltalk:printString_((self["@string"])));
end
)
,"printing","printStringDetail\r\n\t\" Private - Return a printable detail of the receiver. \"\r\n\r\n\t^string printString","(\r\nfunction(self)\r\nreturn (smalltalk:printString_((self[\"@string\"])));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPStStringParser,"basicParse:",0
,(
function(self,aStream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local position=nil
local result=nil
(function()
	local _s8_value=((aStream):position())
	position=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=("")
	result=_s8_value
	return _s8_value
end)();
while not ((function()
(function()
	local _s8_value=(smalltalk:object_comma_((result),(aStream):upTo_("'")))
	result=_s8_value
	return _s8_value
end)();return ((aStream):atEnd())
end))() do if not ((smalltalk:isObject_equalTo_(((aStream):peek()),"'")))==true then return (result); end;
(function()
	local _s8_value=(smalltalk:object_comma_((result),(aStream):next()))
	result=_s8_value
	return _s8_value
end)(); end;
if ((((aStream):position()) > position))==true then (aStream):position_(((aStream):position()):_minus(1));
smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((aStream):next()),"'")),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(aStream):position_(position);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.PPFailure):reason_at_("Unfinished String",position))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\t| position result |\r\n\tposition := aStream position.\r\n\tresult := ''.\r\n\t[ result := result , (aStream upTo: $').\r\n\t  aStream atEnd ] whileFalse: [\r\n\t\taStream peek = $' ifFalse: [ ^result ].\r\n\t\tresult := result ,aStream next.\r\n\t].\r\n\taStream position > position ifTrue: [\r\n\t\taStream position: aStream position - 1.\r\n\t\taStream next = $' ifTrue: [ ^result ].\r\n\t].\r\n\taStream position: position.\r\n\t^PPFailure reason: 'Unfinished String' at: position","(\r\nfunction(self,aStream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal position=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((aStream):position())\r\n\tposition=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(\"\")\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((result),(aStream):upTo_(\"'\")))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();return ((aStream):atEnd())\r\nend))() do if not ((smalltalk:isObject_equalTo_(((aStream):peek()),\"'\")))==true then return (result); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((result),(aStream):next()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif ((((aStream):position()) > position))==true then (aStream):position_(((aStream):position()):_minus(1));\r\nsmalltalk:if_true_false_((smalltalk:isObject_equalTo_(((aStream):next()),\"'\")),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(aStream):position_(position);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.PPFailure):reason_at_(\"Unfinished String\",position))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.PPCharacterParser["$klass"],"separator",0
,(
function(self)
return (((self):new()):separator());
end
)
,"constants","separator\r\n\t\" Return the parser for separator. \"\r\n\r\n\t^self new separator","(\r\nfunction(self)\r\nreturn (((self):new()):separator());\r\nend\r\n)")
smalltalk:bind(smalltalk.PPCharacterParser["$klass"],"in:",0
,(
function(self,aCollection)
local tag=nil
(function()
	local _s8_value=(smalltalk:asString_((aCollection)))
	tag=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((aCollection):size()),1))==true then (function()
	local _s8_value=((aCollection):first())
	tag=_s8_value
	return _s8_value
end)();
return ((self):for_doing_(smalltalk:asString_((tag)),(function(c)
return (smalltalk:isObject_equalTo_((tag),c))
end))); end;
return ((self):for_doing_(tag,(function(c)
return ((aCollection):includes_(c))
end)));
end
)
,"constants","in: aCollection\r\n\t\" Return the parser for input matching any element in aCollection. \"\r\n\r\n\t| tag |\r\n\ttag := aCollection asString.\r\n\taCollection size = 1 ifTrue: [\r\n\t\ttag := aCollection first.\r\n\t\t^self for: tag asString doing: [:c| tag = c ]\r\n\t].\r\n\t^self for: tag doing: [:c| aCollection includes: c ]","(\r\nfunction(self,aCollection)\r\nlocal tag=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:asString_((aCollection)))\r\n\ttag=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((aCollection):size()),1))==true then (function()\r\n\tlocal _s8_value=((aCollection):first())\r\n\ttag=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):for_doing_(smalltalk:asString_((tag)),(function(c)\r\nreturn (smalltalk:isObject_equalTo_((tag),c))\r\nend))); end;\r\nreturn ((self):for_doing_(tag,(function(c)\r\nreturn ((aCollection):includes_(c))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPCharacterParser["$klass"],"notIn:",0
,(
function(self,aCollection)
local tag=nil
(function()
	local _s8_value=(smalltalk:asString_((aCollection)))
	tag=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((aCollection):size()),1))==true then (function()
	local _s8_value=((aCollection):first())
	tag=_s8_value
	return _s8_value
end)();
return ((self):for_doing_(smalltalk:asString_((tag)),(function(c)
return ((not smalltalk:isObject_equalTo_((tag),c)))
end))); end;
return ((self):for_doing_(tag,(function(c)
return (smalltalk:booleanNot_(((aCollection):includes_(c))))
end)));
end
)
,"constants","notIn: aCollection\r\n\t\" Return the parser for input matching any element in aCollection. \"\r\n\r\n\t| tag |\r\n\ttag := aCollection asString.\r\n\taCollection size = 1 ifTrue: [\r\n\t\ttag := aCollection first.\r\n\t\t^self for: tag asString doing: [:c| tag ~= c ]\r\n\t].\r\n\t^self for: tag doing: [:c| (aCollection includes: c) not ]","(\r\nfunction(self,aCollection)\r\nlocal tag=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:asString_((aCollection)))\r\n\ttag=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((aCollection):size()),1))==true then (function()\r\n\tlocal _s8_value=((aCollection):first())\r\n\ttag=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):for_doing_(smalltalk:asString_((tag)),(function(c)\r\nreturn ((not smalltalk:isObject_equalTo_((tag),c)))\r\nend))); end;\r\nreturn ((self):for_doing_(tag,(function(c)\r\nreturn (smalltalk:booleanNot_(((aCollection):includes_(c))))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPCharacterParser["$klass"],"between:and:",0
,(
function(self,start,__end)
return ((self):for_doing_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((""),start)),"-")),__end),(function(c)
return ((c):between_and_(start,__end))
end)));
end
)
,"constants","between: start and: end\r\n\t\" Return the parser for input between start and end. \"\r\n\r\n\t^self\tfor: '',start,'-',end\r\n\t\tdoing: [:c| c between: start and: end ]","(\r\nfunction(self,start,__end)\r\nreturn ((self):for_doing_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"\"),start)),\"-\")),__end),(function(c)\r\nreturn ((c):between_and_(start,__end))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPCharacterParser["$klass"],"for:doing:",0
,(
function(self,label,aBlock)
return (((self):new()):do_for_(aBlock,label));
end
)
,"constants","for: label doing: aBlock\r\n\t\" Return a parser that evaluates aBlock to match label. \"\r\n\r\n\t^self new do: aBlock for: label","(\r\nfunction(self,label,aBlock)\r\nreturn (((self):new()):do_for_(aBlock,label));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPCharacterParser["$klass"],"regExpCache",0
,(
function(self)
if (smalltalk:isNil_((smalltalk.PPCharacterParser:classVariableAt_("RegExpCache"))))==true then smalltalk.PPCharacterParser:classVariableAt_put_("RegExpCache",(smalltalk.PoolDictionary):new()); end;
return (smalltalk.PPCharacterParser:classVariableAt_("RegExpCache"));
end
)
,"constants","regExpCache\r\n\t\" Private - Return the regexp cache. \"\r\n\r\n\tRegExpCache isNil ifTrue: [\r\n\t\tRegExpCache := PoolDictionary new\r\n\t].\r\n\t^RegExpCache","(\r\nfunction(self)\r\nif (smalltalk:isNil_((smalltalk.PPCharacterParser:classVariableAt_(\"RegExpCache\"))))==true then smalltalk.PPCharacterParser:classVariableAt_put_(\"RegExpCache\",(smalltalk.PoolDictionary):new()); end;\r\nreturn (smalltalk.PPCharacterParser:classVariableAt_(\"RegExpCache\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPCharacterParser,"do:for:",0
,(
function(self,aBlock,aString)
(function()
	local _s8_value=(aString)
	self["@theString"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(aBlock)
	self["@regexp"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","do: aBlock for: aString\r\n\t\" Set the receiver to match aString using aBlock. \"\r\n\r\n\ttheString := aString.\r\n\tregexp := aBlock","(\r\nfunction(self,aBlock,aString)\r\n(function()\r\n\tlocal _s8_value=(aString)\r\n\tself[\"@theString\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(aBlock)\r\n\tself[\"@regexp\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPCharacterParser,"string:",0
,(
function(self,aString)
(function()
	local _s8_value=(aString)
	self["@theString"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((self)["$klass"]):regExpCache()):at_ifAbsentPut_(aString,(function()
return ((smalltalk.RegularExpression):fromString_(smalltalk:object_comma_((smalltalk:object_comma_(("["),aString)),"]")))
end)))
	self["@regexp"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","string: aString\r\n\t\" Set the string of the receiver. \"\r\n\r\n\ttheString := aString.\r\n\tregexp := self class regExpCache at: aString ifAbsentPut: [\r\n\t\tRegularExpression fromString: '[', aString, ']'\r\n\t]","(\r\nfunction(self,aString)\r\n(function()\r\n\tlocal _s8_value=(aString)\r\n\tself[\"@theString\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((self)[\"$klass\"]):regExpCache()):at_ifAbsentPut_(aString,(function()\r\nreturn ((smalltalk.RegularExpression):fromString_(smalltalk:object_comma_((smalltalk:object_comma_((\"[\"),aString)),\"]\")))\r\nend)))\r\n\tself[\"@regexp\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPCharacterParser,"match:",0
,(
function(self,aString)
if (smalltalk:isNil_((aString)))==true then return (false); end;
if (smalltalk:isNil_((self["@regexp"])))==true then return ((aString):isSeparator()); end;
if ((self["@regexp"]):isValuable())==true then return ((self["@regexp"]):value_(aString)); end;
if (smalltalk:isObject_equalTo_((self["@theString"]),aString))==true then return (true); end;
return ((aString):match_(self["@regexp"]));
end
)
,"private","match: aString\r\n\t\" Private - Match the receiver to string. \"\r\n\r\n\taString isNil ifTrue: [ ^false ].\r\n\tregexp isNil ifTrue: [ ^aString isSeparator ].\r\n\tregexp isValuable ifTrue: [ ^regexp value: aString ].\r\n\ttheString = aString ifTrue: [ ^true ].\r\n\t^aString match: regexp","(\r\nfunction(self,aString)\r\nif (smalltalk:isNil_((aString)))==true then return (false); end;\r\nif (smalltalk:isNil_((self[\"@regexp\"])))==true then return ((aString):isSeparator()); end;\r\nif ((self[\"@regexp\"]):isValuable())==true then return ((self[\"@regexp\"]):value_(aString)); end;\r\nif (smalltalk:isObject_equalTo_((self[\"@theString\"]),aString))==true then return (true); end;\r\nreturn ((aString):match_(self[\"@regexp\"]));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPCharacterParser,"matchFailureReason",0
,(
function(self)
return (smalltalk:object_comma_(("Could not match "),smalltalk:if_true_false_((smalltalk:isNil_((self["@theString"]))),(function()
return ("separator")
end),(function()
return (smalltalk:printString_((self["@theString"])))
end))));
end
)
,"accessing","matchFailureReason\r\n\t\" Private - Return the reason for mismatch. \"\r\n\r\n\t^'Could not match ' ,(theString isNil\r\n\t\tifTrue: [#separator]\r\n\t\tifFalse: [theString printString])","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((\"Could not match \"),smalltalk:if_true_false_((smalltalk:isNil_((self[\"@theString\"]))),(function()\r\nreturn (\"separator\")\r\nend),(function()\r\nreturn (smalltalk:printString_((self[\"@theString\"])))\r\nend))));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPCharacterParser,"basicParse:",0
,(
function(self,aStream)
return (smalltalk:if_true_false_(((self):match_((aStream):peek())),(function()
return ((aStream):next())
end),(function()
return ((smalltalk.PPFailure):reason_at_((self):matchFailureReason(),(aStream):position()))
end)));
end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\t^(self match: aStream peek)\r\n\t ifTrue:  [ aStream next ]\r\n\t ifFalse: [ PPFailure\r\n\t\treason: self matchFailureReason\r\n\t\tat: aStream position\r\n\t]","(\r\nfunction(self,aStream)\r\nreturn (smalltalk:if_true_false_(((self):match_((aStream):peek())),(function()\r\nreturn ((aStream):next())\r\nend),(function()\r\nreturn ((smalltalk.PPFailure):reason_at_((self):matchFailureReason(),(aStream):position()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPCharacterParser,"separator",0
,(
function(self)
(function()
	local _s8_value=((function()
	local _s8_value=(nil)
	self["@regexp"]=_s8_value
	return _s8_value
end)())
	self["@theString"]=_s8_value
	return _s8_value
end)();
(self):_at_at("separator");
return (self);
end
)
,"separator","separator\r\n\t\" Set the receiver to parse separator. \"\r\n\r\n\ttheString := regexp := nil.\r\n\tself @@#separator","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=((function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@regexp\"]=_s8_value\r\n\treturn _s8_value\r\nend)())\r\n\tself[\"@theString\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):_at_at(\"separator\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPCharacterParser,"printStringDetail",0
,(
function(self)
if ((self["@theString"]):isCharacter())==true then if ((self["@theString"]):between_and_("0","z"))==true then return (smalltalk:object_comma_(("$"),self["@theString"])); end;
return (smalltalk:object_comma_(("#"),(self["@theString"]):asciiValue())); end;
return (smalltalk:printString_((self["@theString"])));
end
)
,"printing","printStringDetail\r\n\t\" Private - Return a printable detail of the receiver. \"\r\n\r\n\ttheString isCharacter ifTrue: [\r\n\t\t(theString between: $0 and: $z) ifTrue: [\r\n\t\t\t^$$ ,theString\r\n\t\t].\r\n\t\t^$# ,theString asciiValue\r\n\t].\r\n\t^theString printString","(\r\nfunction(self)\r\nif ((self[\"@theString\"]):isCharacter())==true then if ((self[\"@theString\"]):between_and_(\"0\",\"z\"))==true then return (smalltalk:object_comma_((\"$\"),self[\"@theString\"])); end;\r\nreturn (smalltalk:object_comma_((\"#\"),(self[\"@theString\"]):asciiValue())); end;\r\nreturn (smalltalk:printString_((self[\"@theString\"])));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPListParser["$klass"],"withAll:",0
,(
function(self,aCollection)
return ((
function(_s8_rec)
	(_s8_rec):parsers_(aCollection);
	return ((_s8_rec):yourself())
end
)((self):basicNew()));
end
)
,"instantiation","withAll: aCollection\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t    ^self basicNew\r\n\t\tparsers: aCollection;\r\n\t\tyourself","(\r\nfunction(self,aCollection)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):parsers_(aCollection);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):basicNew()));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPListParser["$klass"],"with:with:",0
,(
function(self,aParser,anotherParser)
return ((self):withAll_((smalltalk.Array):with_with_(aParser,anotherParser)));
end
)
,"instantiation","with: aParser with: anotherParser\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self withAll: (Array with: aParser with: anotherParser)","(\r\nfunction(self,aParser,anotherParser)\r\nreturn ((self):withAll_((smalltalk.Array):with_with_(aParser,anotherParser)));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPListParser,"parsers",0
,(
function(self)
if (smalltalk:isNil_((self["@parsers"])))==true then return (smalltalk:newArray({})); end;
return (self["@parsers"]);
end
)
,"accessing","parsers\r\n\t\" Return the parsers of the receiver. \"\r\n\r\n\tparsers isNil ifTrue: [ ^#() ].\r\n\t^parsers","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@parsers\"])))==true then return (smalltalk:newArray({})); end;\r\nreturn (self[\"@parsers\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPListParser,"parsers:",0
,(
function(self,aCollection)
(function()
	local _s8_value=((aCollection):collect_((function(each)
return ((each):asParser())
end)))
	self["@parsers"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","parsers: aCollection\r\n\t\" Set the parsers of the receiver. \"\r\n\r\n\tparsers := aCollection collect: [:each| each asParser ]","(\r\nfunction(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=((aCollection):collect_((function(each)\r\nreturn ((each):asParser())\r\nend)))\r\n\tself[\"@parsers\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPListParser,"copyWith:",0
,(
function(self,aParser)
return (((self)["$klass"]):withAll_(((self):parsers()):copyWith_(aParser)));
end
)
,"copying","copyWith: aParser\r\n\t\" Return a copy of the receiver with aParser. \"\r\n\r\n\t^self class withAll: (self parsers copyWith: aParser)","(\r\nfunction(self,aParser)\r\nreturn (((self)[\"$klass\"]):withAll_(((self):parsers()):copyWith_(aParser)));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPListParser,"op",0
,(
function(self)
return ("+");
end
)
,"printing","op\r\n\t\" Private - Return the operator of the receiver. \"\r\n\r\n\t^$+","(\r\nfunction(self)\r\nreturn (\"+\");\r\nend\r\n)")
smalltalk:bind(smalltalk.PPListParser,"printString",0
,(
function(self)
local stream=nil
if (smalltalk:notNil_(((self)["debugTag"])))==true then return (smalltalk:superImplementor(smalltalk.PPListParser,"printString")(self)); end;
(function()
	local _s8_value=(("{"):writeStream())
	stream=_s8_value
	return _s8_value
end)();
((self):parsers()):do_separatedBy_((function(each)
return ((stream):nextPutAll_(smalltalk:printString_((each))))
end),(function()
return ((stream):nextPutAll_((self):op()))
end));
return ((stream):contents());
end
)
,"printing","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t| stream |\r\n\t(self basicAt: #debugTag) notNil ifTrue: [ ^super printString ].\r\n\tstream := ${ writeStream.\r\n\tself parsers\r\n\t\tdo: [:each| stream nextPutAll: each printString ]\r\n\t\tseparatedBy: [stream nextPutAll: self op].\r\n\t^stream contents ","(\r\nfunction(self)\r\nlocal stream=nil\r\nif (smalltalk:notNil_(((self)[\"debugTag\"])))==true then return (smalltalk:superImplementor(smalltalk.PPListParser,\"printString\")(self)); end;\r\n(function()\r\n\tlocal _s8_value=((\"{\"):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):parsers()):do_separatedBy_((function(each)\r\nreturn ((stream):nextPutAll_(smalltalk:printString_((each))))\r\nend),(function()\r\nreturn ((stream):nextPutAll_((self):op()))\r\nend));\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.PPSequenceParser,",","_comma"
,(
function(self,aRule)
return ((self):copyWith_(aRule));
end
)
,"copying",", aRule\r\n\t\" Return the receiver composed with the argument. \"\r\n\r\n\t^self copyWith: aRule","(\r\nfunction(self,aRule)\r\nreturn ((self):copyWith_(aRule));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPSequenceParser,"basicParse:",0
,(
function(self,aStream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local start=nil
local result=nil
local element=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aStream):position())
	start=_s8_value
	return _s8_value
end)();
((self):parsers()):do_((function(each)
(function()
	local _s8_value=((each):memoizedParse_(aStream))
	element=_s8_value
	return _s8_value
end)();(result):add_(element);return (smalltalk:if_true_false_(((self):isParseFailure_(element)),(function()
(aStream):position_(start);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (element)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\t| start result element |\r\n\tresult := #().\r\n\tstart := aStream position.\r\n\tself parsers do: [:each |\r\n\t\telement := each memoizedParse: aStream.\r\n\t\tresult add: element.\r\n\t\t(self isParseFailure: element) ifTrue: [\r\n\t\t\taStream position: start.\r\n\t\t\t^element\r\n\t\t]\r\n\t].\r\n\t^result","(\r\nfunction(self,aStream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal start=nil\r\nlocal result=nil\r\nlocal element=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aStream):position())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):parsers()):do_((function(each)\r\n(function()\r\n\tlocal _s8_value=((each):memoizedParse_(aStream))\r\n\telement=_s8_value\r\n\treturn _s8_value\r\nend)();(result):add_(element);return (smalltalk:if_true_false_(((self):isParseFailure_(element)),(function()\r\n(aStream):position_(start);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (element)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.PPSequenceParser,"op",0
,(
function(self)
return (",");
end
)
,"printing","op\r\n\t\" Private - Return the operator of the receiver. \"\r\n\r\n\t^$,","(\r\nfunction(self)\r\nreturn (\",\");\r\nend\r\n)")
smalltalk:bind(smalltalk.PPChoiceParser,"/","_slash"
,(
function(self,aRule)
return ((self):copyWith_(aRule));
end
)
,"copying","/ aRule\r\n\t\" Return the receiver composed with aRule. \"\r\n\r\n\t^self copyWith: aRule","(\r\nfunction(self,aRule)\r\nreturn ((self):copyWith_(aRule));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPChoiceParser,"basicParse:",0
,(
function(self,aStream)
local result=nil
((self):parsers()):detect_ifNone_((function(each)
(function()
	local _s8_value=((each):memoizedParse_(aStream))
	result=_s8_value
	return _s8_value
end)();return (smalltalk:booleanNot_(((self):isParseFailure_(result))))
end),(function()
return (nil)
end));
return (result);
end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\t| result |\r\n\tself parsers detect: [:each |\r\n\t\tresult := each memoizedParse: aStream.\r\n\t\t(self isParseFailure: result) not\r\n\t] ifNone: [].\r\n\t^result","(\r\nfunction(self,aStream)\r\nlocal result=nil\r\n((self):parsers()):detect_ifNone_((function(each)\r\n(function()\r\n\tlocal _s8_value=((each):memoizedParse_(aStream))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:booleanNot_(((self):isParseFailure_(result))))\r\nend),(function()\r\nreturn (nil)\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPChoiceParser,"op",0
,(
function(self)
return ("/");
end
)
,"printing","op\r\n\t\" Private - Return the operator of the receiver. \"\r\n\r\n\t^$/","(\r\nfunction(self)\r\nreturn (\"/\");\r\nend\r\n)")
smalltalk:bind(smalltalk.PPDelegateParser["$klass"],"on:",0
,(
function(self,aParser)
return ((
function(_s8_rec)
	(_s8_rec):parser_(aParser);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","on: aParser\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t    ^self new\r\n\t\tparser: aParser;\r\n\t\tyourself","(\r\nfunction(self,aParser)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):parser_(aParser);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPDelegateParser,"parser",0
,(
function(self)
return (self["@parser"]);
end
)
,"accessing","parser\r\n\t\" Return the parser of the receiver. \"\r\n\r\n\t^parser","(\r\nfunction(self)\r\nreturn (self[\"@parser\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPDelegateParser,"parser:",0
,(
function(self,aParser)
(function()
	local _s8_value=(aParser)
	self["@parser"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","parser: aParser\r\n\t\" Set the parser of the receiver. \"\r\n\r\n\tparser := aParser","(\r\nfunction(self,aParser)\r\n(function()\r\n\tlocal _s8_value=(aParser)\r\n\tself[\"@parser\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPDelegateParser,"basicParse:",0
,(
function(self,aStream)
return (((self):parser()):memoizedParse_(aStream));
end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\t^self parser memoizedParse: aStream","(\r\nfunction(self,aStream)\r\nreturn (((self):parser()):memoizedParse_(aStream));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPDelegateParser,"printStringDetail",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(("["),smalltalk:printString_((self["@parser"])))),"]"));
end
)
,"printing","printStringDetail\r\n\t\" Private - Return a printable detail of the receiver. \"\r\n\r\n\t^'[' ,parser printString ,']'","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"[\"),smalltalk:printString_((self[\"@parser\"])))),\"]\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPAndParser,"opParse:",0
,(
function(self,aStream)
local element=nil
local position=nil
(function()
	local _s8_value=((aStream):position())
	position=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((self):parser()):memoizedParse_(aStream))
	element=_s8_value
	return _s8_value
end)();
(aStream):position_(position);
return (element);
end
)
,"parsing","opParse: aStream\r\n\t\" Parse contents in aStream. \"\r\n\r\n\t| element position |\r\n\tposition := aStream position.\r\n\telement := self parser memoizedParse: aStream.\r\n\taStream position: position.\r\n\t^element","(\r\nfunction(self,aStream)\r\nlocal element=nil\r\nlocal position=nil\r\n(function()\r\n\tlocal _s8_value=((aStream):position())\r\n\tposition=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((self):parser()):memoizedParse_(aStream))\r\n\telement=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aStream):position_(position);\r\nreturn (element);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPAndParser,"basicParse:",0
,(
function(self,aStream)
return ((self):opParse_(aStream));
end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\t^self opParse: aStream","(\r\nfunction(self,aStream)\r\nreturn ((self):opParse_(aStream));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPNotParser,"basicParse:",0
,(
function(self,aStream)
local element=nil
(function()
	local _s8_value=((self):opParse_(aStream))
	element=_s8_value
	return _s8_value
end)();
if ((self):isParseFailure_(element))==true then return (nil); end;
return ((smalltalk.PPFailure):reason_at_(element,(aStream):position()));
end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\t| element |\r\n\telement := self opParse: aStream.\r\n\t(self isParseFailure: element) ifTrue: [ ^nil ].\r\n\t^PPFailure reason: element at: aStream position","(\r\nfunction(self,aStream)\r\nlocal element=nil\r\n(function()\r\n\tlocal _s8_value=((self):opParse_(aStream))\r\n\telement=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((self):isParseFailure_(element))==true then return (nil); end;\r\nreturn ((smalltalk.PPFailure):reason_at_(element,(aStream):position()));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPActionParser["$klass"],"on:block:",0
,(
function(self,aParser,aBlock)
return ((
function(_s8_rec)
	(_s8_rec):parser_(aParser);
	(_s8_rec):block_(aBlock);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","on: aParser block: aBlock\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tparser: aParser;\r\n\t\tblock: aBlock;\r\n\t\tyourself","(\r\nfunction(self,aParser,aBlock)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):parser_(aParser);\r\n\t(_s8_rec):block_(aBlock);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPActionParser,"block",0
,(
function(self)
return (self["@block"]);
end
)
,"accessing","block\r\n\t\" Return the block of the receiver. \"\r\n\r\n\t^block","(\r\nfunction(self)\r\nreturn (self[\"@block\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPActionParser,"block:",0
,(
function(self,aBlock)
(function()
	local _s8_value=(aBlock)
	self["@block"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","block: aBlock\r\n\t\" Set the block of the receiver. \"\r\n\r\n\tblock := aBlock","(\r\nfunction(self,aBlock)\r\n(function()\r\n\tlocal _s8_value=(aBlock)\r\n\tself[\"@block\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPActionParser,"basicParse:",0
,(
function(self,aStream)
local element=nil
(function()
	local _s8_value=(((self):parser()):memoizedParse_(aStream))
	element=_s8_value
	return _s8_value
end)();
if ((self):isParseFailure_(element))==true then return (element); end;
return (((self):block()):value_(element));
end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\t| element |\r\n\telement := self parser memoizedParse: aStream.\r\n\t(self isParseFailure: element) ifTrue: [ ^element ].\r\n\t^self block value: element","(\r\nfunction(self,aStream)\r\nlocal element=nil\r\n(function()\r\n\tlocal _s8_value=(((self):parser()):memoizedParse_(aStream))\r\n\telement=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((self):isParseFailure_(element))==true then return (element); end;\r\nreturn (((self):block()):value_(element));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPActionParser,"printString",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(("{"),smalltalk:printString_((self["@parser"])))),"}"));
end
)
,"printing","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t^${ ,parser printString ,$} ","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"{\"),smalltalk:printString_((self[\"@parser\"])))),\"}\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPFlattenParser,"basicParse:",0
,(
function(self,aStream)
local start=nil
local element=nil
(function()
	local _s8_value=((aStream):position())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((self):parser()):memoizedParse_(aStream))
	element=_s8_value
	return _s8_value
end)();
if ((self):isParseFailure_(element))==true then return (element); end;
return (((aStream):collection()):copyFrom_to_((start):_plus(1),(aStream):position()));
end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\t| start element |\r\n\tstart := aStream position.\r\n\telement := self parser memoizedParse: aStream.\r\n\t(self isParseFailure: element) ifTrue: [ ^element ].\r\n\t^aStream collection \r\n\t\tcopyFrom: start + 1 \r\n\t\tto: aStream position","(\r\nfunction(self,aStream)\r\nlocal start=nil\r\nlocal element=nil\r\n(function()\r\n\tlocal _s8_value=((aStream):position())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((self):parser()):memoizedParse_(aStream))\r\n\telement=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((self):isParseFailure_(element))==true then return (element); end;\r\nreturn (((aStream):collection()):copyFrom_to_((start):_plus(1),(aStream):position()));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPSourceParser,"basicParse:",0
,(
function(self,aStream)
local start=nil
local element=nil
local result=nil
(function()
	local _s8_value=((aStream):position())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((self):parser()):memoizedParse_(aStream))
	element=_s8_value
	return _s8_value
end)();
if ((self):isParseFailure_(element))==true then return (element); end;
(function()
	local _s8_value=(((aStream):collection()):copyFrom_to_((start):_plus(1),(aStream):position()))
	result=_s8_value
	return _s8_value
end)();
return ((smalltalk.Array):with_with_(element,result));
end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\t| start element result |\r\n\tstart := aStream position.\r\n\telement := self parser memoizedParse: aStream.\r\n\t(self isParseFailure: element) ifTrue: [ ^element ].\r\n\tresult := aStream collection\r\n\t\tcopyFrom: start + 1\r\n\t\tto: aStream position.\r\n\t^Array with: element with: result","(\r\nfunction(self,aStream)\r\nlocal start=nil\r\nlocal element=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((aStream):position())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((self):parser()):memoizedParse_(aStream))\r\n\telement=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((self):isParseFailure_(element))==true then return (element); end;\r\n(function()\r\n\tlocal _s8_value=(((aStream):collection()):copyFrom_to_((start):_plus(1),(aStream):position()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((smalltalk.Array):with_with_(element,result));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPRepeatingParser["$klass"],"on:min:",0
,(
function(self,aParser,aNumber)
return ((
function(_s8_rec)
	(_s8_rec):parser_(aParser);
	(_s8_rec):min_(aNumber);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","on: aParser min: aNumber\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tparser: aParser;\r\n\t\tmin: aNumber;\r\n\t\tyourself","(\r\nfunction(self,aParser,aNumber)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):parser_(aParser);\r\n\t(_s8_rec):min_(aNumber);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPRepeatingParser,"min",0
,(
function(self)
return (self["@min"]);
end
)
,"accessing","min\r\n\t\" Return the min of the receiver. \"\r\n\r\n\t^min","(\r\nfunction(self)\r\nreturn (self[\"@min\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPRepeatingParser,"min:",0
,(
function(self,aNumber)
(function()
	local _s8_value=(aNumber)
	self["@min"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","min: aNumber\r\n\t\" Set the min of the receiver. \"\r\n\r\n\tmin := aNumber","(\r\nfunction(self,aNumber)\r\n(function()\r\n\tlocal _s8_value=(aNumber)\r\n\tself[\"@min\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPRepeatingParser,"basicParse:",0
,(
function(self,aStream)
local start=nil
local element=nil
local result=nil
local failure=nil
(function()
	local _s8_value=((aStream):position())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
while ((function()
return (smalltalk:boolean_and_(((((result):size()) < (self):min())),(function()
return (smalltalk:isNil_((failure)))
end)))
end))() do (function()
	local _s8_value=(((self):parser()):memoizedParse_(aStream))
	element=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_(((self):isParseFailure_(element)),(function()
(aStream):position_(start);return ((function()
	local _s8_value=(element)
	failure=_s8_value
	return _s8_value
end)())
end),(function()
return ((result):addLast_(element))
end)); end;
if (smalltalk:notNil_((failure)))==true then return (failure); end;
while ((function()
return (smalltalk:isNil_((failure)))
end))() do (function()
	local _s8_value=(((self):parser()):memoizedParse_(aStream))
	element=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_(((self):isParseFailure_(element)),(function()
return ((function()
	local _s8_value=(element)
	failure=_s8_value
	return _s8_value
end)())
end),(function()
return ((result):addLast_(element))
end)); end;
return (result);
end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\t| start element result failure |\r\n\tstart := aStream position.\r\n\tresult := Array new.\r\n\t[ (result size < self min) and: [ failure isNil ]\r\n\t] whileTrue: [\r\n\t    element := self parser memoizedParse: aStream.\r\n\t    (self isParseFailure: element)\r\n\t\tifFalse: [ result addLast: element ]\r\n\t\tifTrue: [ aStream position: start.\r\n\t\t\t  failure := element ]\r\n\t].\r\n\tfailure notNil ifTrue: [ ^failure ].\r\n\t[failure isNil] whileTrue: [\r\n\t\telement := self parser memoizedParse: aStream.\r\n\t \t(self isParseFailure: element)\r\n\t\t\tifTrue: [ failure := element ]\r\n\t\t\tifFalse: [ result addLast: element ]\r\n\t].\r\n\t^result","(\r\nfunction(self,aStream)\r\nlocal start=nil\r\nlocal element=nil\r\nlocal result=nil\r\nlocal failure=nil\r\n(function()\r\n\tlocal _s8_value=((aStream):position())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (smalltalk:boolean_and_(((((result):size()) < (self):min())),(function()\r\nreturn (smalltalk:isNil_((failure)))\r\nend)))\r\nend))() do (function()\r\n\tlocal _s8_value=(((self):parser()):memoizedParse_(aStream))\r\n\telement=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_(((self):isParseFailure_(element)),(function()\r\n(aStream):position_(start);return ((function()\r\n\tlocal _s8_value=(element)\r\n\tfailure=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),(function()\r\nreturn ((result):addLast_(element))\r\nend)); end;\r\nif (smalltalk:notNil_((failure)))==true then return (failure); end;\r\nwhile ((function()\r\nreturn (smalltalk:isNil_((failure)))\r\nend))() do (function()\r\n\tlocal _s8_value=(((self):parser()):memoizedParse_(aStream))\r\n\telement=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_(((self):isParseFailure_(element)),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(element)\r\n\tfailure=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),(function()\r\nreturn ((result):addLast_(element))\r\nend)); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPRepeatingParser,"printStringDetail",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(("[min="),self["@min"])),"]"));
end
)
,"printing","printStringDetail\r\n\t\" Private - Return a printable detail of the receiver. \"\r\n\r\n\t^'[min=' ,min ,']'","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"[min=\"),self[\"@min\"])),\"]\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPInlineParser["$klass"],"upTo:",0
,(
function(self,aString)
return ((
function(_s8_rec)
	(_s8_rec):terminator_(aString);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","upTo: aString\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new terminator: aString; yourself","(\r\nfunction(self,aString)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):terminator_(aString);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.PPInlineParser,"terminator:",0
,(
function(self,aString)
(function()
	local _s8_value=(aString)
	self["@terminator"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","terminator: aString\r\n\t\" Set terminator of the receiver. \"\r\n\r\n\tterminator := aString","(\r\nfunction(self,aString)\r\n(function()\r\n\tlocal _s8_value=(aString)\r\n\tself[\"@terminator\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PPInlineParser,"basicParse:",0
,(
function(self,aStream)
local result=nil
(function()
	local _s8_value=((aStream):upTo_(self["@terminator"]))
	result=_s8_value
	return _s8_value
end)();
if not (((aStream):atEnd()))==true then return (result); end;
return ((smalltalk.PPFailure):reason_at_(smalltalk:object_comma_((smalltalk:object_comma_(("Missing inline terminator ("),self["@terminator"])),")"),(aStream):position()));
end
)
,"parsing","basicParse: aStream\r\n\t\" Private - Parse contents in aStream. \"\r\n\r\n\t| result |\r\n\tresult := aStream upTo: terminator.\r\n\taStream atEnd ifFalse: [ ^result ].\r\n\t^PPFailure\r\n\t\treason: 'Missing inline terminator (',terminator,')'\r\n\t\tat: aStream position","(\r\nfunction(self,aStream)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((aStream):upTo_(self[\"@terminator\"]))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((aStream):atEnd()))==true then return (result); end;\r\nreturn ((smalltalk.PPFailure):reason_at_(smalltalk:object_comma_((smalltalk:object_comma_((\"Missing inline terminator (\"),self[\"@terminator\"])),\")\"),(aStream):position()));\r\nend\r\n)")
smalltalk:bind(smalltalk.FileInReader,"scanFrom:",0
,(
function(self,aStream)
return ((self):subclassResponsibility_("scanFrom:"));
end
)
,"fileIn","scanFrom: aStream\r\n\t\" FileIn - Return the result of evaluating the next chunk of data from aStream.\r\n\tThe method must be implemented by chunk readers to support custom fileIn features.\r\n\t\"\r\n\r\n\t^self subclassResponsibility: #scanFrom:","(\r\nfunction(self,aStream)\r\nreturn ((self):subclassResponsibility_(\"scanFrom:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.ChunkReader["$klass"],"doing:until:",0
,(
function(self,aBlock,terminationBlock)
return ((
function(_s8_rec)
	(_s8_rec):actionBlock_(aBlock);
	(_s8_rec):terminationBlock_(terminationBlock);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
)
,"instantiation","doing: aBlock until: terminationBlock\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tactionBlock: aBlock;\r\n\t\tterminationBlock: terminationBlock;\r\n\t\tyourself","(\r\nfunction(self,aBlock,terminationBlock)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):actionBlock_(aBlock);\r\n\t(_s8_rec):terminationBlock_(terminationBlock);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.ChunkReader["$klass"],"doing:",0
,(
function(self,aBlock)
return ((self):doing_until_(aBlock,(function()
return (true)
end)));
end
)
,"instantiation","doing: aBlock\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self doing: aBlock until: [ true ]","(\r\nfunction(self,aBlock)\r\nreturn ((self):doing_until_(aBlock,(function()\r\nreturn (true)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ChunkReader["$klass"],"until:",0
,(
function(self,terminationBlock)
return ((self):doing_until_(nil,terminationBlock));
end
)
,"instantiation","until: terminationBlock\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self doing: nil until: terminationBlock","(\r\nfunction(self,terminationBlock)\r\nreturn ((self):doing_until_(nil,terminationBlock));\r\nend\r\n)")
smalltalk:bind(smalltalk.ChunkReader["$klass"],"ignore",0
,(
function(self)
return ((self):new());
end
)
,"instantiation","ignore\r\n\t\" Return an instance of the receiver.\r\n\tThe returned reader will ignore/absorb next chunk.\r\n\t\"\r\n\r\n\t^self new","(\r\nfunction(self)\r\nreturn ((self):new());\r\nend\r\n)")
smalltalk:bind(smalltalk.ChunkReader["$klass"],"javascriptChunk",0
,(
function(self)
return ((self):nativeChunk());
end
)
,"instantiation","javascriptChunk\r\n\t\" Obsolete - use #nativeChunk \"\r\n\r\n\t^self nativeChunk ","(\r\nfunction(self)\r\nreturn ((self):nativeChunk());\r\nend\r\n)")
smalltalk:bind(smalltalk.ChunkReader["$klass"],"javascript",0
,(
function(self)
return ((self):native());
end
)
,"instantiation","javascript\r\n\t\" Obsolete - use #native \"\r\n\r\n\t^self native ","(\r\nfunction(self)\r\nreturn ((self):native());\r\nend\r\n)")
smalltalk:bind(smalltalk.ChunkReader["$klass"],"nativeChunk",0
,(
function(self)
return ((self):doing_((function(aStream)
return (((smalltalk.Smalltalk):current()):eval_((aStream):nextChunk()))
end)));
end
)
,"instantiation","nativeChunk\r\n\t\" Return an instance of the receiver.\r\n\tThe returned reader will evaluate next chunk as native code (in global context).\r\n\t\"\r\n\r\n\t^self doing: [:aStream| Smalltalk current eval: aStream nextChunk ]","(\r\nfunction(self)\r\nreturn ((self):doing_((function(aStream)\r\nreturn (((smalltalk.Smalltalk):current()):eval_((aStream):nextChunk()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ChunkReader["$klass"],"native",0
,(
function(self)
return ((self):doing_((function(aStream)
return (((smalltalk.Smalltalk):current()):eval_((aStream):upToEnd()))
end)));
end
)
,"instantiation","native\r\n\t\" Return an instance of the receiver.\r\n\tThe returned reader will evaluate following contents as native code (in global context).\r\n\tThe stream will be consumed up to end.\r\n\t\"\r\n\r\n\t^self doing: [:aStream| Smalltalk current eval: aStream upToEnd ]","(\r\nfunction(self)\r\nreturn ((self):doing_((function(aStream)\r\nreturn (((smalltalk.Smalltalk):current()):eval_((aStream):upToEnd()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.ChunkReader,"actionBlock",0
,(
function(self)
return (self["@actionBlock"]);
end
)
,"accessing","actionBlock\r\n\t\" Return the actionBlock of the receiver. \"\r\n\r\n\t^actionBlock","(\r\nfunction(self)\r\nreturn (self[\"@actionBlock\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.ChunkReader,"actionBlock:",0
,(
function(self,aBlock)
(function()
	local _s8_value=(aBlock)
	self["@actionBlock"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","actionBlock: aBlock\r\n\t\" Set the actionBlock of the receiver. \"\r\n\r\n\tactionBlock := aBlock","(\r\nfunction(self,aBlock)\r\n(function()\r\n\tlocal _s8_value=(aBlock)\r\n\tself[\"@actionBlock\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ChunkReader,"terminationBlock",0
,(
function(self)
return (self["@terminationBlock"]);
end
)
,"accessing","terminationBlock\r\n\t\" Return the terminationBlock of the receiver. \"\r\n\r\n\t^terminationBlock","(\r\nfunction(self)\r\nreturn (self[\"@terminationBlock\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.ChunkReader,"terminationBlock:",0
,(
function(self,aBlock)
(function()
	local _s8_value=(aBlock)
	self["@terminationBlock"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","terminationBlock: aBlock\r\n\t\" Set the terminationBlock of the receiver. \"\r\n\r\n\tterminationBlock := aBlock","(\r\nfunction(self,aBlock)\r\n(function()\r\n\tlocal _s8_value=(aBlock)\r\n\tself[\"@terminationBlock\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ChunkReader,"scanFrom:",0
,(
function(self,aStream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local chunk=nil
if (smalltalk:isNil_(((self):actionBlock())))==true then (function()
	local _s8_value=((aStream):nextChunk())
	chunk=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_(((chunk):isEmpty()),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end),nil); else ((self):actionBlock()):value_(aStream); end;
if (smalltalk:boolean_or_((smalltalk:isNil_(((self):terminationBlock()))),(function()
return (((true)==((self):terminationBlock()):value()))
end)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"fileIn","scanFrom: aStream\r\n\t\" Scan the next chunk of data from aStream. \"\r\n\r\n\t| chunk |\r\n\tself actionBlock isNil ifTrue: [\r\n\t\tchunk := aStream nextChunk.\r\n\t\tchunk isEmpty ifTrue: [ ^nil ].\r\n\t] ifFalse: [ self actionBlock value: aStream ].\r\n\t(self terminationBlock isNil\r\n\t\tor: [ true == self terminationBlock value ])\r\n\t\tifTrue: [ ^nil ].\r\n\t^self","(\r\nfunction(self,aStream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal chunk=nil\r\nif (smalltalk:isNil_(((self):actionBlock())))==true then (function()\r\n\tlocal _s8_value=((aStream):nextChunk())\r\n\tchunk=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_(((chunk):isEmpty()),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); else ((self):actionBlock()):value_(aStream); end;\r\nif (smalltalk:boolean_or_((smalltalk:isNil_(((self):terminationBlock()))),(function()\r\nreturn (((true)==((self):terminationBlock()):value()))\r\nend)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassCategoryReader,"class:category:",0
,(
function(self,aClass,aString)
(function()
	local _s8_value=(aClass)
	self["@class"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(aString)
	self["@category"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","class: aClass category: aString\r\n\t\" Private - Set the class and category of the receiver. \"\r\n\r\n\tclass := aClass.\r\n\tcategory := aString","(\r\nfunction(self,aClass,aString)\r\n(function()\r\n\tlocal _s8_value=(aClass)\r\n\tself[\"@class\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(aString)\r\n\tself[\"@category\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassCategoryReader,"class:category:stamp:",0
,(
function(self,aClass,aString,aStamp)
(self):class_category_(aClass,aString);
(function()
	local _s8_value=(aStamp)
	self["@stamp"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","class: aClass category: aString stamp: aStamp\r\n\t\" Private - Set the class and category of the receiver. \"\r\n\r\n\tself class: aClass category: aString.\r\n\tstamp := aStamp","(\r\nfunction(self,aClass,aString,aStamp)\r\n(self):class_category_(aClass,aString);\r\n(function()\r\n\tlocal _s8_value=(aStamp)\r\n\tself[\"@stamp\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassCategoryReader,"scanFrom:",0
,(
function(self,aStream)
local chunk=nil
(function()
	local _s8_value=((aStream):nextChunk())
	chunk=_s8_value
	return _s8_value
end)();
return (((function()
return (smalltalk:if_true_false_(((chunk):isEmpty()),nil,(function()
return ((self):compileMethod_(chunk))
end)))
end)):logEvaluate_(chunk));
end
)
,"fileIn","scanFrom: aStream\r\n\t\" Scan the next chunk of data from aStream. \"\r\n\r\n\t| chunk |\r\n\tchunk := aStream nextChunk.\r\n\t^[ chunk isEmpty ifFalse: [ self compileMethod: chunk ]\r\n\t] logEvaluate: chunk","(\r\nfunction(self,aStream)\r\nlocal chunk=nil\r\n(function()\r\n\tlocal _s8_value=((aStream):nextChunk())\r\n\tchunk=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((function()\r\nreturn (smalltalk:if_true_false_(((chunk):isEmpty()),nil,(function()\r\nreturn ((self):compileMethod_(chunk))\r\nend)))\r\nend)):logEvaluate_(chunk));\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassCategoryReader,"compileMethod:",0
,(
function(self,aString)
local aMethod=nil
(function()
	local _s8_value=(((self["@class"]):compiler()):compile_forClass_category_(aString,self["@class"],self["@category"]))
	aMethod=_s8_value
	return _s8_value
end)();
if ((((self["@stamp"]):size()) > 0))==true then (aMethod):stamp_(self["@stamp"]); end;
return (self);
end
)
,"private","compileMethod: aString\r\n\t\" Compile aString as a method source. \"\r\n\r\n\t| aMethod |\r\n\taMethod := class compiler\r\n\t\tcompile: aString\r\n\t\tforClass: class\r\n\t\tcategory: category.\r\n\tstamp size > 0 ifTrue: [ aMethod stamp: stamp ] ","(\r\nfunction(self,aString)\r\nlocal aMethod=nil\r\n(function()\r\n\tlocal _s8_value=(((self[\"@class\"]):compiler()):compile_forClass_category_(aString,self[\"@class\"],self[\"@category\"]))\r\n\taMethod=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((((self[\"@stamp\"]):size()) > 0))==true then (aMethod):stamp_(self[\"@stamp\"]); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassCommentReader,"class:",0
,(
function(self,aClass)
(function()
	local _s8_value=(aClass)
	self["@class"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","class: aClass\r\n\t\" Set the destination class of the receiver. \"\r\n\r\n\tclass := aClass","(\r\nfunction(self,aClass)\r\n(function()\r\n\tlocal _s8_value=(aClass)\r\n\tself[\"@class\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassCommentReader,"scanFrom:",0
,(
function(self,aStream)
(self):comment_((aStream):nextChunk());
return (nil);
end
)
,"fileIn","scanFrom: aStream\r\n\t\" FileIn - Parse next chunk in aStream as a comment for target class. \"\r\n\r\n\tself comment: aStream nextChunk.\r\n\t^nil","(\r\nfunction(self,aStream)\r\n(self):comment_((aStream):nextChunk());\r\nreturn (nil);\r\nend\r\n)")
smalltalk:bind(smalltalk.ClassCommentReader,"comment:",0
,(
function(self,aString)
(self["@class"]):comment_(smalltalk:if_true_false_(((aString):isEmpty()),nil,(function()
return (aString)
end)));
return (self);
end
)
,"private","comment: aString\r\n\t\" Set the comment of target class. \"\r\n\r\n\tclass comment: (aString isEmpty ifFalse: [ aString ])","(\r\nfunction(self,aString)\r\n(self[\"@class\"]):comment_(smalltalk:if_true_false_(((aString):isEmpty()),nil,(function()\r\nreturn (aString)\r\nend)));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.SkipFileInReader["$klass"],"upTo:",0
,(
function(self,aToken)
return (((self):new()):limit_(aToken));
end
)
,"instantiation","upTo: aToken\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new limit: aToken","(\r\nfunction(self,aToken)\r\nreturn (((self):new()):limit_(aToken));\r\nend\r\n)")
smalltalk:bind(smalltalk.SkipFileInReader,"scanFrom:",0
,(
function(self,aStream)
if (smalltalk:isNil_((self["@limit"])))==true then (aStream):setToEnd(); else (aStream):skipTo_(self["@limit"]); end;
return (nil);
end
)
,"fileIn","scanFrom: aStream\r\n\t\" Consume/Ignore contents in aStream. \"\r\n\r\n\tlimit isNil\r\n\t\tifTrue: [ aStream setToEnd ]\r\n\t\tifFalse: [ aStream skipTo: limit ].\r\n\t^nil","(\r\nfunction(self,aStream)\r\nif (smalltalk:isNil_((self[\"@limit\"])))==true then (aStream):setToEnd(); else (aStream):skipTo_(self[\"@limit\"]); end;\r\nreturn (nil);\r\nend\r\n)")
smalltalk:bind(smalltalk.SkipFileInReader,"limit:",0
,(
function(self,aToken)
(function()
	local _s8_value=(aToken)
	self["@limit"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","limit: aToken\r\n\t\" Set the token limit. \"\r\n\r\n\tlimit := aToken","(\r\nfunction(self,aToken)\r\n(function()\r\n\tlocal _s8_value=(aToken)\r\n\tself[\"@limit\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.AssociationsReader,"keyFrom:",0
,(
function(self,aStream)
if (smalltalk:isObject_equalTo_(((aStream):peek()),"#"))==true then return (((
function(_s8_rec)
	(_s8_rec):next();
	return ((_s8_rec):upTo_(" "))
end
)(aStream)):asSymbol()); end;
if (smalltalk:isObject_equalTo_(((aStream):peek()),"'"))==true then return ((
function(_s8_rec)
	(_s8_rec):next();
	return ((_s8_rec):upTo_("'"))
end
)(aStream)); end;
return ((aStream):upTo_(" "));
end
)
,"reading","keyFrom: aStream\r\n\t\" Private - Return the name of the current binding in aStream. \"\r\n\r\n\taStream peek = $# ifTrue: [ ^(aStream next; upTo: $ ) asSymbol ].\r\n\taStream peek = $' ifTrue: [ ^aStream next; upTo: $' ].\r\n\t^aStream upTo: $ ","(\r\nfunction(self,aStream)\r\nif (smalltalk:isObject_equalTo_(((aStream):peek()),\"#\"))==true then return (((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):next();\r\n\treturn ((_s8_rec):upTo_(\" \"))\r\nend\r\n)(aStream)):asSymbol()); end;\r\nif (smalltalk:isObject_equalTo_(((aStream):peek()),\"'\"))==true then return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):next();\r\n\treturn ((_s8_rec):upTo_(\"'\"))\r\nend\r\n)(aStream)); end;\r\nreturn ((aStream):upTo_(\" \"));\r\nend\r\n)")
smalltalk:bind(smalltalk.AssociationsReader,"valueFrom:",0
,(
function(self,aStream)
return (((self):compilerSupport()):evaluate_((aStream):upToEnd()));
end
)
,"reading","valueFrom: aStream\r\n\t\" Private - Return the value of the current binding in aStream. \"\r\n\r\n\t^self compilerSupport evaluate: aStream upToEnd ","(\r\nfunction(self,aStream)\r\nreturn (((self):compilerSupport()):evaluate_((aStream):upToEnd()));\r\nend\r\n)")
smalltalk:bind(smalltalk.AssociationsReader,"compilerSupport",0
,(
function(self)
return (((self):smalltalk()):compilerSupport());
end
)
,"evaluating","compilerSupport\r\n\t\" Private - Return compiler in use to get values from stream. \"\r\n\r\n\t^self smalltalk compilerSupport","(\r\nfunction(self)\r\nreturn (((self):smalltalk()):compilerSupport());\r\nend\r\n)")
smalltalk:bind(smalltalk.AssociationsReader,"bind:",0
,(
function(self,tuples)
return ((self):subclassResponsibility_("bind:"));
end
)
,"binding","bind: tuples\r\n\t\" Private - Bind the filedIn tuples to target.\r\n\tMust return the result of the fileIn/binding process.\r\n\t\"\r\n\r\n\t^self subclassResponsibility: #bind: ","(\r\nfunction(self,tuples)\r\nreturn ((self):subclassResponsibility_(\"bind:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.AssociationsReader,"scanFrom:",0
,(
function(self,aStream)
local chunk=nil
local tuples=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	tuples=_s8_value
	return _s8_value
end)();
while ((function()
return (smalltalk:boolean_and_((smalltalk:booleanNot_(((aStream):atEnd()))),(function()
(function()
	local _s8_value=(((aStream):nextChunk()):trimBlanks())
	chunk=_s8_value
	return _s8_value
end)();return ((chunk):notEmpty())
end)))
end))() do (function()
	local _s8_value=((chunk):stream())
	chunk=_s8_value
	return _s8_value
end)();
(tuples):add_((smalltalk.Array):with_with_((self):keyFrom_(chunk),(self):valueFrom_(chunk))); end;
return ((self):bind_(tuples));
end
)
,"fileIn","scanFrom: aStream\r\n\t\" Consume chunks in aStream until empty chunk.\r\n\tThe chunks are considered associative bindings with the syntax:\r\n\t\t<key> <expression>\r\n\tWhere\r\n\t\tkey is the keyword of the binding (name, string or symbol).\r\n\t\texpression is a valid smalltalk expression that will be evaluated to generate the value of the binding.\r\n\t\"\r\n\r\n\t| chunk tuples |\r\n\ttuples := Array new.\r\n\t[ aStream atEnd not and: [\r\n\t  chunk := aStream nextChunk trimBlanks.\r\n\t  chunk notEmpty ]] whileTrue: [\r\n\t  chunk := chunk stream.\r\n\t  tuples add: (Array\r\n\t\twith: (self keyFrom: chunk)\r\n\t\twith: (self valueFrom: chunk)).\r\n\t].\r\n\t^self bind: tuples","(\r\nfunction(self,aStream)\r\nlocal chunk=nil\r\nlocal tuples=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\ttuples=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (smalltalk:boolean_and_((smalltalk:booleanNot_(((aStream):atEnd()))),(function()\r\n(function()\r\n\tlocal _s8_value=(((aStream):nextChunk()):trimBlanks())\r\n\tchunk=_s8_value\r\n\treturn _s8_value\r\nend)();return ((chunk):notEmpty())\r\nend)))\r\nend))() do (function()\r\n\tlocal _s8_value=((chunk):stream())\r\n\tchunk=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(tuples):add_((smalltalk.Array):with_with_((self):keyFrom_(chunk),(self):valueFrom_(chunk))); end;\r\nreturn ((self):bind_(tuples));\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionaryReader,"scope:",0
,(
function(self,aScope)
(function()
	local _s8_value=(aScope)
	self["@scope"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","scope: aScope\r\n\t\" Set the scope of the receiver. \"\r\n\r\n\tscope := aScope","(\r\nfunction(self,aScope)\r\n(function()\r\n\tlocal _s8_value=(aScope)\r\n\tself[\"@scope\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionaryReader,"bind:",0
,(
function(self,tuples)
if ((self["@scope"]):isString())==true then return ((smalltalk.Smalltalk):definePool_with_(self["@scope"],tuples)); end;
if (smalltalk:isNil_((self["@scope"])))==true then (function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	self["@scope"]=_s8_value
	return _s8_value
end)(); end;
(tuples):do_((function(each)
return ((self["@scope"]):at_put_((each):first(),(each):last()))
end));
return (self["@scope"]);
end
)
,"binding","bind: tuples\r\n\t\" Private - Bind the filedIn tuples to target.\r\n\tMust return the result of the fileIn/binding process.\r\n\t\"\r\n\r\n\tscope isString ifTrue: [\r\n\t\t^Smalltalk definePool: scope with: tuples\r\n\t].\r\n\tscope isNil ifTrue: [ scope := PoolDictionary new ].\r\n\ttuples do: [:each| scope at: each first put: each last ].\r\n\t^scope","(\r\nfunction(self,tuples)\r\nif ((self[\"@scope\"]):isString())==true then return ((smalltalk.Smalltalk):definePool_with_(self[\"@scope\"],tuples)); end;\r\nif (smalltalk:isNil_((self[\"@scope\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tself[\"@scope\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(tuples):do_((function(each)\r\nreturn ((self[\"@scope\"]):at_put_((each):first(),(each):last()))\r\nend));\r\nreturn (self[\"@scope\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.PoolDictionaryReader,"valueFrom:",0
,(
function(self,aStream)
local code=nil
local result=nil
local word=nil
(function()
	local _s8_value=((aStream):upToEnd())
	code=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((code):trimBlanks())
	word=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_or_((smalltalk:isObject_equalTo_((word),"nil")),(function()
return ((word):isEmpty())
end)))==true then return (nil); end;
(function()
	local _s8_value=((word):asNumber())
	result=_s8_value
	return _s8_value
end)();
if ((result):isNumber())==true then return (result); end;
return (smalltalk:superImplementor(smalltalk.PoolDictionaryReader,"valueFrom_")(self,(code):stream()));
end
)
,"reading","valueFrom: aStream\r\n\t\" Private - Return the value of the current binding in aStream. \"\r\n\r\n\t| code result word |\r\n\tcode := aStream upToEnd.\r\n\tword := code trimBlanks.\r\n\t(word = #nil or: [ word isEmpty ]) ifTrue: [ ^nil ].\r\n\tresult := word asNumber.\r\n\tresult isNumber ifTrue: [ ^result ].\r\n\t^super valueFrom: code stream ","(\r\nfunction(self,aStream)\r\nlocal code=nil\r\nlocal result=nil\r\nlocal word=nil\r\n(function()\r\n\tlocal _s8_value=((aStream):upToEnd())\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((code):trimBlanks())\r\n\tword=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_or_((smalltalk:isObject_equalTo_((word),\"nil\")),(function()\r\nreturn ((word):isEmpty())\r\nend)))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((word):asNumber())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((result):isNumber())==true then return (result); end;\r\nreturn (smalltalk:superImplementor(smalltalk.PoolDictionaryReader,\"valueFrom_\")(self,(code):stream()));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeReader,"bind:",0
,(
function(self,tuples)
if (smalltalk:isNil_((self["@object"])))==true then (self):initializeObject(); end;
(tuples):do_((function(each)
return (smalltalk:basic_at_put_((self["@object"]),(each):first(),(each):last()))
end));
return (self["@object"]);
end
)
,"binding","bind: tuples\r\n\t\" Private - Bind the filedIn tuples to target.\r\n\tMust return the result of the fileIn/binding process.\r\n\t\"\r\n\r\n\tobject isNil ifTrue: [ self initializeObject ].\r\n\ttuples do: [:each| object basicAt: each first put: each last ].\r\n\t^object","(\r\nfunction(self,tuples)\r\nif (smalltalk:isNil_((self[\"@object\"])))==true then (self):initializeObject(); end;\r\n(tuples):do_((function(each)\r\nreturn (smalltalk:basic_at_put_((self[\"@object\"]),(each):first(),(each):last()))\r\nend));\r\nreturn (self[\"@object\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeReader,"object:",0
,(
function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@object"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","object: anObject\r\n\t\" Set the object where the bindings will be stored. \"\r\n\r\n\tobject := anObject","(\r\nfunction(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@object\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeReader,"initializeObject",0
,(
function(self)
(function()
	local _s8_value=({})
	self["@object"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"initialize","initializeObject\r\n\t\" Private - Initialize the object where the bindings will be stored. \"\r\n\r\n\tobject := {''}","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=({})\r\n\tself[\"@object\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder["$klass"],"default",0
,(
function(self)
if (smalltalk:isNil_((self["@default"])))==true then (function()
	local _s8_value=((self):new())
	self["@default"]=_s8_value
	return _s8_value
end)(); end;
return (self["@default"]);
end
)
,"accessing","default\r\n\t\" Return the default instance of the receiver. \"\r\n\r\n\tdefault isNil ifTrue: [ default := self new ].\r\n\t^default","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@default\"])))==true then (function()\r\n\tlocal _s8_value=((self):new())\r\n\tself[\"@default\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@default\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder["$klass"],"saveBuilders",0
,(
function(self)
return (((self["@saveBuilders"])==true));
end
)
,"accessing","saveBuilders\r\n\t\" Return true if the receiver is set to save builders in snapshot. \"\r\n\r\n\t^saveBuilders == true","(\r\nfunction(self)\r\nreturn (((self[\"@saveBuilders\"])==true));\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder["$klass"],"saveBuilders:",0
,(
function(self,aBoolean)
(function()
	local _s8_value=(aBoolean)
	self["@saveBuilders"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","saveBuilders: aBoolean\r\n\t\" Set to true if the receiver save builders in snapshot. \"\r\n\r\n\tsaveBuilders := aBoolean","(\r\nfunction(self,aBoolean)\r\n(function()\r\n\tlocal _s8_value=(aBoolean)\r\n\tself[\"@saveBuilders\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder["$klass"],"build:doing:",0
,(
function(self,token,aBlock)
local builder=nil
local result=nil
local success=nil
(function()
	local _s8_value=((self):default())
	builder=_s8_value
	return _s8_value
end)();
(builder):open_(token);
(function()
	local _s8_value=(false)
	success=_s8_value
	return _s8_value
end)();
((function()
(function()
	local _s8_value=((aBlock):value())
	result=_s8_value
	return _s8_value
end)();return ((function()
	local _s8_value=(true)
	success=_s8_value
	return _s8_value
end)())
end)):ensure_((function()
return ((builder):close_success_(token,success))
end));
return (result);
end
)
,"building","build: token doing: aBlock\r\n\t\" Process a (build...: spec) definition marking methods generated while evaluating aBlock.\r\n\tReturn the result of evaluating aBlock. \"\r\n\r\n\t| builder result success |\r\n\tbuilder := self default.\r\n\tbuilder open: token.\r\n\tsuccess := false.\r\n\t[\tresult := aBlock value.\r\n\t\tsuccess := true.\r\n\t] ensure: [ builder close: token success: success ].\r\n\t^result","(\r\nfunction(self,token,aBlock)\r\nlocal builder=nil\r\nlocal result=nil\r\nlocal success=nil\r\n(function()\r\n\tlocal _s8_value=((self):default())\r\n\tbuilder=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(builder):open_(token);\r\n(function()\r\n\tlocal _s8_value=(false)\r\n\tsuccess=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((function()\r\n(function()\r\n\tlocal _s8_value=((aBlock):value())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();return ((function()\r\n\tlocal _s8_value=(true)\r\n\tsuccess=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):ensure_((function()\r\nreturn ((builder):close_success_(token,success))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder["$klass"],"register:",0
,(
function(self,aMethod)
return (smalltalk:boolean_and_((smalltalk:notNil_((self["@default"]))),(function()
return ((self["@default"]):register_(aMethod))
end)));
end
)
,"building","register: aMethod\r\n\t\" Register aMethod as related to current builder. \"\r\n\r\n\t^default notNil and: [ default register: aMethod ]","(\r\nfunction(self,aMethod)\r\nreturn (smalltalk:boolean_and_((smalltalk:notNil_((self[\"@default\"]))),(function()\r\nreturn ((self[\"@default\"]):register_(aMethod))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder["$klass"],"imageSaved:on:",0
,(
function(self,snapshot,stream)
local code=nil
if (smalltalk:boolean_and_(((self):saveBuilders()),(function()
return ((((function()
	local _s8_value=((self):codeForBuilders())
	code=_s8_value
	return _s8_value
end)())):notEmpty())
end)))==true then (
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(code))
end
)(stream); end;
return (smalltalk:superImplementor(smalltalk.APIBuilder["$klass"],"imageSaved_on_")(self,snapshot,stream));
end
)
,"snapshot","imageSaved: snapshot on: stream\r\n\t\" Private - A system snapshot has been taken, the receiver can restore state. \"\r\n\r\n\t| code |\r\n\t(self saveBuilders and: [\r\n\t\t(code := self codeForBuilders) notEmpty ])\r\n\t\tifTrue: [ stream cr;nextPutAll: code ].\r\n\t^super imageSaved: snapshot on: stream","(\r\nfunction(self,snapshot,stream)\r\nlocal code=nil\r\nif (smalltalk:boolean_and_(((self):saveBuilders()),(function()\r\nreturn ((((function()\r\n\tlocal _s8_value=((self):codeForBuilders())\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)())):notEmpty())\r\nend)))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(code))\r\nend\r\n)(stream); end;\r\nreturn (smalltalk:superImplementor(smalltalk.APIBuilder[\"$klass\"],\"imageSaved_on_\")(self,snapshot,stream));\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder["$klass"],"codeForBuilders",0
,(
function(self)
return ((self):codeFor_((smalltalk.Smalltalk):classes()));
end
)
,"code","codeForBuilders\r\n\t\" Return the (native) code to export the builders of the system. \"\r\n\r\n\t^self codeFor: Smalltalk classes","(\r\nfunction(self)\r\nreturn ((self):codeFor_((smalltalk.Smalltalk):classes()));\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder["$klass"],"codeFor:",0
,(
function(self,classes)
local builders=nil
(function()
	local _s8_value=((self):buildersFor_(classes))
	builders=_s8_value
	return _s8_value
end)();
if ((builders):isEmpty())==true then return (""); end;
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),(self):name())),".builders_(\r\n")),((smalltalk.Exporter):new()):exportObject_(builders))),"\r\n);"));
end
)
,"code","codeFor: classes\r\n\t\" Return the (native) code to export the builders defined by a collection of classes. \"\r\n\r\n\t| builders |\r\n\tbuilders := self buildersFor: classes.\r\n\tbuilders isEmpty ifTrue: [ ^'' ].\r\n\t^'smalltalk.', self name ,'.builders_(\r\n'\t,(Exporter new exportObject: builders) ,'\r\n);'","(\r\nfunction(self,classes)\r\nlocal builders=nil\r\n(function()\r\n\tlocal _s8_value=((self):buildersFor_(classes))\r\n\tbuilders=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((builders):isEmpty())==true then return (\"\"); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),(self):name())),\".builders_(\\r\\n\")),((smalltalk.Exporter):new()):exportObject_(builders))),\"\\r\\n);\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder["$klass"],"buildersFor:",0
,(
function(self,classes)
return (((classes):collect_((function(cls)
return ((smalltalk.Array):with_with_with_((cls):name(),(self):buildersIn_((cls)["$klass"]),(self):buildersIn_(cls)))
end))):reject_((function(tuple)
return (smalltalk:boolean_and_((((tuple):second()):isEmpty()),(function()
return (((tuple):third()):isEmpty())
end)))
end)));
end
)
,"private","buildersFor: classes\r\n\t\" Private - Return the builders defined by a collection of classes.\r\n\t#( className #(--classbuilders--) #(--instanceBuilders---))\r\n\t\"\r\n\r\n\t^(classes collect: [:cls|\r\n\t\tArray\r\n\t\t\twith: cls name\r\n\t\t\twith: (self buildersIn: cls class)\r\n\t\t\twith: (self buildersIn: cls)\r\n\t]) reject: [:tuple|\r\n\t\ttuple second isEmpty and: [tuple third isEmpty]\r\n\t]","(\r\nfunction(self,classes)\r\nreturn (((classes):collect_((function(cls)\r\nreturn ((smalltalk.Array):with_with_with_((cls):name(),(self):buildersIn_((cls)[\"$klass\"]),(self):buildersIn_(cls)))\r\nend))):reject_((function(tuple)\r\nreturn (smalltalk:boolean_and_((((tuple):second()):isEmpty()),(function()\r\nreturn (((tuple):third()):isEmpty())\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder["$klass"],"builders",0
,(
function(self)
return ((self):buildersFor_((smalltalk.Smalltalk):classes()));
end
)
,"private","builders\r\n\t\" Private - Return the builders defined in this system. \"\r\n\r\n\t^self buildersFor: Smalltalk classes","(\r\nfunction(self)\r\nreturn ((self):buildersFor_((smalltalk.Smalltalk):classes()));\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder["$klass"],"buildersIn:",0
,(
function(self,aClass)
local map=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	map=_s8_value
	return _s8_value
end)();
(aClass):methodsDo_((function(mth)
local assoc=nil
(function()
	local _s8_value=((mth):builder())
	assoc=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((assoc))),(function()
return ((((map):detect_ifNone_((function(tuple)
return (smalltalk:isObject_equalTo_(((tuple):first()),assoc))
end),(function()
return ((map):add_((smalltalk.Array):with_with_(assoc,(smalltalk.Array):new())))
end))):second()):add_((mth):selector()))
end),nil))
end));
return ((map):collect_((function(tuple)
return ((smalltalk.Array):with_with_with_(((tuple):first()):key(),((tuple):first()):value(),(tuple):last()))
end)));
end
)
,"private","buildersIn: aClass\r\n\t\" Private - Return the builders used in aClass.\r\n\t#( builderType builderSpec #( selectors ) )\r\n\t\"\r\n\r\n\t| map |\r\n\tmap := Array new.\r\n\taClass methodsDo: [:mth| | assoc |\r\n\t\tassoc := mth builder.\r\n\t\tassoc notNil ifTrue: [\r\n\t\t\t(map\tdetect: [:tuple| tuple first = assoc ]\r\n\t\t\t\tifNone: [ map add: (Array with: assoc with: Array new) ])\r\n\t\t\t\tsecond add: mth selector\r\n\t\t]\r\n\t].\r\n\t^map collect: [:tuple| Array\r\n\t\twith: tuple first key\r\n\t\twith: tuple first value\r\n\t\twith: tuple last\r\n\t]","(\r\nfunction(self,aClass)\r\nlocal map=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tmap=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aClass):methodsDo_((function(mth)\r\nlocal assoc=nil\r\n(function()\r\n\tlocal _s8_value=((mth):builder())\r\n\tassoc=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((assoc))),(function()\r\nreturn ((((map):detect_ifNone_((function(tuple)\r\nreturn (smalltalk:isObject_equalTo_(((tuple):first()),assoc))\r\nend),(function()\r\nreturn ((map):add_((smalltalk.Array):with_with_(assoc,(smalltalk.Array):new())))\r\nend))):second()):add_((mth):selector()))\r\nend),nil))\r\nend));\r\nreturn ((map):collect_((function(tuple)\r\nreturn ((smalltalk.Array):with_with_with_(((tuple):first()):key(),((tuple):first()):value(),(tuple):last()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder["$klass"],"builders:",0
,(
function(self,spec)
(spec):do_((function(builder)
local cls=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):at_ifAbsent_((builder):first(),(function()
return (nil)
end)))
	cls=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((cls))),(function()
(self):setBuilders_in_((builder):second(),(cls)["$klass"]);return ((self):setBuilders_in_((builder):third(),cls))
end),nil))
end));
return (self);
end
)
,"private","builders: spec\r\n\t\" Private - Set the builders on this system according to bindings defined in spec.\r\n\tNote that missing bindings will be ignored and no check is done to ensure the bindings are in sync with target.\r\n\t\"\r\n\r\n\tspec do: [:builder| | cls |\r\n\t\tcls := Smalltalk at: builder first ifAbsent: [].\r\n\t\tcls notNil ifTrue: [\r\n\t\t\tself setBuilders: builder second in: cls class.\r\n\t\t\tself setBuilders: builder third in: cls.\r\n\t\t].\r\n\t]","(\r\nfunction(self,spec)\r\n(spec):do_((function(builder)\r\nlocal cls=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_ifAbsent_((builder):first(),(function()\r\nreturn (nil)\r\nend)))\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((cls))),(function()\r\n(self):setBuilders_in_((builder):second(),(cls)[\"$klass\"]);return ((self):setBuilders_in_((builder):third(),cls))\r\nend),nil))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder["$klass"],"setBuilders:in:",0
,(
function(self,array,aClass)
local builder=nil
(array):do_((function(map)
(function()
	local _s8_value=((smalltalk.Association):key_value_((map):first(),(map):second()))
	builder=_s8_value
	return _s8_value
end)();return (((map):last()):do_((function(selector)
local mth=nil
(function()
	local _s8_value=((aClass):compiledMethodAt_(selector))
	mth=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((mth))),(function()
return ((mth):builder_(builder))
end),nil))
end)))
end));
return (self);
end
)
,"private","setBuilders: array in: aClass\r\n\t\" Private - Set the builders in array on aClass. \"\r\n\r\n\t| builder |\r\n\tarray do: [:map|\r\n\t\tbuilder := Association key: map first value: map second.\r\n\t\tmap last do: [:selector| | mth |\r\n\t\t\tmth := aClass compiledMethodAt: selector.\r\n\t\t\tmth notNil ifTrue: [ mth builder: builder ].\r\n\t\t]\r\n\t]","(\r\nfunction(self,array,aClass)\r\nlocal builder=nil\r\n(array):do_((function(map)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Association):key_value_((map):first(),(map):second()))\r\n\tbuilder=_s8_value\r\n\treturn _s8_value\r\nend)();return (((map):last()):do_((function(selector)\r\nlocal mth=nil\r\n(function()\r\n\tlocal _s8_value=((aClass):compiledMethodAt_(selector))\r\n\tmth=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((mth))),(function()\r\nreturn ((mth):builder_(builder))\r\nend),nil))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder,"register:",0
,(
function(self,aMethod)
if (smalltalk:isNil_((self["@token"])))==true then return (false); end;
if (smalltalk:isNil_((self["@bound"])))==true then (function()
	local _s8_value=((smalltalk.Array):new())
	self["@bound"]=_s8_value
	return _s8_value
end)(); end;
(self["@bound"]):add_(aMethod);
return (true);
end
)
,"private","register: aMethod\r\n\t\" Private - Register aMethod as related to the receiver. \"\r\n\r\n\ttoken isNil ifTrue: [ ^false ].\r\n\tbound isNil ifTrue: [ bound := Array new ].\r\n\tbound add: aMethod.\r\n\t^true","(\r\nfunction(self,aMethod)\r\nif (smalltalk:isNil_((self[\"@token\"])))==true then return (false); end;\r\nif (smalltalk:isNil_((self[\"@bound\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@bound\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(self[\"@bound\"]):add_(aMethod);\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder,"open:",0
,(
function(self,spec)
if (smalltalk:isNil_((self["@parents"])))==true then (function()
	local _s8_value=((smalltalk.Array):new())
	self["@parents"]=_s8_value
	return _s8_value
end)(); end;
if (smalltalk:notNil_((self["@token"])))==true then (self["@parents"]):addLast_(self["@token"]); end;
(function()
	local _s8_value=(spec)
	self["@token"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"private","open: spec\r\n\t\" Private - The spec will be generated.\r\n\tPrepare the receiver to track generated methods while building spec.\r\n\t\"\r\n\r\n\tparents isNil ifTrue: [ parents := Array new ].\r\n\ttoken notNil ifTrue: [ parents addLast: token ].\r\n\ttoken := spec.","(\r\nfunction(self,spec)\r\nif (smalltalk:isNil_((self[\"@parents\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@parents\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif (smalltalk:notNil_((self[\"@token\"])))==true then (self[\"@parents\"]):addLast_(self[\"@token\"]); end;\r\n(function()\r\n\tlocal _s8_value=(spec)\r\n\tself[\"@token\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder,"close:success:",0
,(
function(self,spec,success)
if not ((smalltalk:isObject_equalTo_((self["@token"]),spec)))==true then return ((self):error_("Builders out of sync.")); end;
if (smalltalk:boolean_and_((smalltalk:notNil_((self["@parents"]))),(function()
return ((self["@parents"]):notEmpty())
end)))==true then (function()
	local _s8_value=((self["@parents"]):removeLast())
	self["@token"]=_s8_value
	return _s8_value
end)();
return (success); end;
if (smalltalk:notNil_((self["@bound"])))==true then (self["@bound"]):do_((function(each)
return ((self):mark_(each))
end));
(function()
	local _s8_value=((function()
	local _s8_value=((function()
	local _s8_value=(nil)
	self["@bound"]=_s8_value
	return _s8_value
end)())
	self["@parents"]=_s8_value
	return _s8_value
end)())
	self["@token"]=_s8_value
	return _s8_value
end)(); end;
return (success);
end
)
,"private","close: spec success: success\r\n\t\" Private - The spec has been implemented, backtrack to parent or mark collected methods. \"\r\n\r\n\ttoken = spec ifFalse: [ ^self error: 'Builders out of sync.' ].\r\n\t(parents notNil and: [ parents notEmpty ]) ifTrue: [\r\n\t\ttoken := parents removeLast.\r\n\t\t^success\r\n\t].\r\n\tbound notNil ifTrue: [\r\n\t\tbound do: [:each| self mark: each ].\r\n\t\ttoken := parents := bound := nil.\r\n\t].\r\n\t^success","(\r\nfunction(self,spec,success)\r\nif not ((smalltalk:isObject_equalTo_((self[\"@token\"]),spec)))==true then return ((self):error_(\"Builders out of sync.\")); end;\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((self[\"@parents\"]))),(function()\r\nreturn ((self[\"@parents\"]):notEmpty())\r\nend)))==true then (function()\r\n\tlocal _s8_value=((self[\"@parents\"]):removeLast())\r\n\tself[\"@token\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (success); end;\r\nif (smalltalk:notNil_((self[\"@bound\"])))==true then (self[\"@bound\"]):do_((function(each)\r\nreturn ((self):mark_(each))\r\nend));\r\n(function()\r\n\tlocal _s8_value=((function()\r\n\tlocal _s8_value=((function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@bound\"]=_s8_value\r\n\treturn _s8_value\r\nend)())\r\n\tself[\"@parents\"]=_s8_value\r\n\treturn _s8_value\r\nend)())\r\n\tself[\"@token\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (success);\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder,"mark:",0
,(
function(self,aMethod)
(aMethod):builder_(self["@token"]);
return (self);
end
)
,"private","mark: aMethod\r\n\t\" Private - Mark aMethod as dependent of current token. \"\r\n\r\n\taMethod builder: token","(\r\nfunction(self,aMethod)\r\n(aMethod):builder_(self[\"@token\"]);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder,"fileOut:selectors:of:on:",0
,(
function(self,exporter,selectors,aClass,stream)
local specs=nil
(function()
	local _s8_value=((smalltalk.Set):new())
	specs=_s8_value
	return _s8_value
end)();
((selectors):copy()):do_((function(selector)
local assoc=nil
(function()
	local _s8_value=(((aClass):compiledMethodAt_(selector)):builder())
	assoc=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((assoc))),(function()
(specs):add_(assoc);return ((selectors):remove_(selector))
end),nil))
end));
(((specs):asArray()):sorted_((function(a,b)
return ((((a):key()) <= (b):key()))
end))):do_((function(assoc)
(stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(((aClass):name())," build")),(assoc):key()));if (((assoc):value()):notEmpty())==true then (stream):nextPut_(":");
(self):fileOutSpec_on_((assoc):value(),stream); end;return ((
function(_s8_rec)
	(_s8_rec):nextChunkPut_(" ");
	return ((_s8_rec):cr())
end
)(stream))
end));
return (self);
end
)
,"fileOut","fileOut: exporter selectors: selectors of: aClass on: stream\r\n\t\" Fileout clustered sources for selectors onto stream.\r\n\tNote: Remove the clustered message selectors from selectors collection while fileOut.\r\n\t\"\r\n\r\n\t| specs |\r\n\tspecs := Set new.\r\n\tselectors copy do: [:selector| | assoc |\r\n\t\tassoc := (aClass compiledMethodAt: selector) builder.\r\n\t\tassoc notNil ifTrue: [\r\n\t\t\tspecs add: assoc.\r\n\t\t\tselectors remove: selector.\r\n\t\t]\r\n\t].\r\n\t(specs asArray sorted: [:a :b| a key <= b key ]) do: [:assoc|\r\n\t\tstream nextPutAll: aClass name ,' build' ,assoc key.\r\n\t\tassoc value notEmpty ifTrue: [\r\n\t\t\tstream nextPut: $:.\r\n\t\t\tself fileOutSpec: assoc value on: stream\r\n\t\t].\r\n\t\tstream nextChunkPut: $ ;cr\r\n\t].","(\r\nfunction(self,exporter,selectors,aClass,stream)\r\nlocal specs=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Set):new())\r\n\tspecs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((selectors):copy()):do_((function(selector)\r\nlocal assoc=nil\r\n(function()\r\n\tlocal _s8_value=(((aClass):compiledMethodAt_(selector)):builder())\r\n\tassoc=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((assoc))),(function()\r\n(specs):add_(assoc);return ((selectors):remove_(selector))\r\nend),nil))\r\nend));\r\n(((specs):asArray()):sorted_((function(a,b)\r\nreturn ((((a):key()) <= (b):key()))\r\nend))):do_((function(assoc)\r\n(stream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(((aClass):name()),\" build\")),(assoc):key()));if (((assoc):value()):notEmpty())==true then (stream):nextPut_(\":\");\r\n(self):fileOutSpec_on_((assoc):value(),stream); end;return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextChunkPut_(\" \");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.APIBuilder,"fileOutSpec:on:",0
,(
function(self,array,stream)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(" #(");
	return ((_s8_rec):cr())
end
)(stream);
(array):do_((function(each)
return ((
function(_s8_rec)
	(_s8_rec):tab();
	(_s8_rec):nextPutAll_((each):asLiteral());
	return ((_s8_rec):cr())
end
)(stream))
end));
(stream):nextPut_(")");
return (self);
end
)
,"fileOut","fileOutSpec: array on: stream\r\n\t\" Private - Fileout API spec in array onto stream. \"\r\n\r\n\tstream nextPutAll: ' #(';cr.\r\n\tarray do: [:each| stream tab; nextPutAll: each asLiteral;cr ].\r\n\tstream nextPut: $).","(\r\nfunction(self,array,stream)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\" #(\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream);\r\n(array):do_((function(each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):tab();\r\n\t(_s8_rec):nextPutAll_((each):asLiteral());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(stream))\r\nend));\r\n(stream):nextPut_(\")\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot["$klass"],"contents",0
,(
function(self)
return (((self):new()):contents());
end
)
,"accessing","contents\r\n\t\" Return a snapshot of current system contents. \"\r\n\r\n\t^self new contents","(\r\nfunction(self)\r\nreturn (((self):new()):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot["$klass"],"outputToFile:",0
,(
function(self,fileName)
(((smalltalk.String):doItSelector()):implementors()):do_((function(each)
return ((each):removeFromSystem())
end));
((self):contents()):outputToFile_(fileName);
return (self);
end
)
,"saveImage","outputToFile: fileName\r\n\t\" Save a complete system snapshot in a file at fileName. \"\r\n\r\n\tString doItSelector implementors do: [:each| each removeFromSystem ].\r\n\tself contents outputToFile: fileName","(\r\nfunction(self,fileName)\r\n(((smalltalk.String):doItSelector()):implementors()):do_((function(each)\r\nreturn ((each):removeFromSystem())\r\nend));\r\n((self):contents()):outputToFile_(fileName);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"contents",0
,(
function(self)
local stream=nil
(function()
	local _s8_value=(((smalltalk.String):new()):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):saveImageOn_(stream);
return ((stream):contents());
end
)
,"accessing","contents\r\n\t\" Return a snapshot of current system contents. \"\r\n\r\n\t| stream |\r\n\tstream := String new writeStream.\r\n\tself saveImageOn: stream.\r\n\t^stream contents","(\r\nfunction(self)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.String):new()):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):saveImageOn_(stream);\r\nreturn ((stream):contents());\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"saveImageOn:",0
,(
function(self,stream)
return ((self):saveImage_on_((self):smalltalk(),stream));
end
)
,"saveImage","saveImageOn: stream\r\n\t\" Save the current system contents onto stream. \"\r\n\r\n\t^self saveImage: self smalltalk on: stream","(\r\nfunction(self,stream)\r\nreturn ((self):saveImage_on_((self):smalltalk(),stream));\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"saveImage:on:",0
,(
function(self,aSmalltalk,stream)
(
function(_s8_rec)
	(_s8_rec):writeBoot_on_(aSmalltalk,stream);
	(_s8_rec):write_on_("Prologue",stream);
	(_s8_rec):writeContents_on_(aSmalltalk,stream);
	(_s8_rec):write_on_("Epilogue",stream);
	(_s8_rec):writeLaunchExpressionOn_(stream);
	return ((_s8_rec):yourself())
end
)(self);
return (self);
end
)
,"saveImage","saveImage: aSmalltalk on: stream\r\n\t\" Save aSmalltalk system contents onto stream. \"\r\n\r\n\tself\r\n\t\twriteBoot: aSmalltalk on: stream;\r\n\t\twrite: #Prologue on: stream;\r\n\t\twriteContents: aSmalltalk on: stream;\r\n\t\twrite: #Epilogue on: stream;\r\n\t\twriteLaunchExpressionOn: stream;\r\n\t\tyourself","(\r\nfunction(self,aSmalltalk,stream)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):writeBoot_on_(aSmalltalk,stream);\r\n\t(_s8_rec):write_on_(\"Prologue\",stream);\r\n\t(_s8_rec):writeContents_on_(aSmalltalk,stream);\r\n\t(_s8_rec):write_on_(\"Epilogue\",stream);\r\n\t(_s8_rec):writeLaunchExpressionOn_(stream);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"writeLicense:on:",0
,(
function(self,aSmalltalk,aStream)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(((aSmalltalk):licenseTerms()):asComment());
	return ((_s8_rec):cr())
end
)(aStream);
return (self);
end
)
,"writing","writeLicense: aSmalltalk on: aStream\r\n\t\" Private - Write the license terms onto aStream. \"\r\n\r\n\taStream nextPutAll: aSmalltalk licenseTerms asComment; cr","(\r\nfunction(self,aSmalltalk,aStream)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(((aSmalltalk):licenseTerms()):asComment());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"writeJSBootOn:",0
,(
function(self,aStream)
(self):writeLicense_on_((smalltalk.Smalltalk):current(),aStream);
(self):writeGlobals_on_(smalltalk:newArray({"StObject", "StBehavior", "StClass", "StMetaclass", "StMethod", "StUndefinedObject"}),aStream);
(self):writeNilDefinitionOn_(aStream);
(self):writeGlobals_on_(smalltalk:newArray({"StSystemDictionary"}),aStream);
(self):writeSystemDefinitionOn_(aStream);
return (self);
end
)
,"js","writeJSBootOn: aStream\r\n\t\" Private - Write the jsBoot section of the image onto aStream. \"\r\n\r\n\tself writeLicense: Smalltalk current on: aStream.\r\n\tself writeGlobals: #(\r\n\t\t#StObject #StBehavior #StClass #StMetaclass\r\n\t\t#StMethod\r\n\t\t#StUndefinedObject\r\n\t\t) on: aStream.\r\n\tself writeNilDefinitionOn: aStream.\r\n\tself writeGlobals: #( #StSystemDictionary ) on: aStream.\r\n\tself writeSystemDefinitionOn: aStream.","(\r\nfunction(self,aStream)\r\n(self):writeLicense_on_((smalltalk.Smalltalk):current(),aStream);\r\n(self):writeGlobals_on_(smalltalk:newArray({\"StObject\", \"StBehavior\", \"StClass\", \"StMetaclass\", \"StMethod\", \"StUndefinedObject\"}),aStream);\r\n(self):writeNilDefinitionOn_(aStream);\r\n(self):writeGlobals_on_(smalltalk:newArray({\"StSystemDictionary\"}),aStream);\r\n(self):writeSystemDefinitionOn_(aStream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"bootHeader",0
,(
function(self)
return ([[smalltalk = (function() 
]]);
end
)
,"encoding","bootHeader\r\n\t\" Private - Return the header for boot contents. \"\r\n\r\n\t^{''}","(\r\nfunction(self)\r\nreturn ([[smalltalk = (function() \r\n]]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"bootFooter",0
,(
function(self)
return ([[
end)()
]]);
end
)
,"encoding","bootFooter\r\n\t\" Private - Return the footer for boot contents. \"\r\n\r\n\t^{''}","(\r\nfunction(self)\r\nreturn ([[\r\nend)()\r\n]]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"writeBoot:on:",0
,(
function(self,aSmalltalk,aStream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local boot=nil
local bootName=nil
local save=nil
(function()
	local _s8_value=((function()
local text=nil
(self):writeLicense_on_(aSmalltalk,aStream);(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((self):bootHeader()),boot)),(self):bootFooter()))
	text=_s8_value
	return _s8_value
end)();(self):writeString_on_(text,aStream);return (text)
end))
	save=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aSmalltalk):at_ifAbsent_("BootSector",(function()
return (nil)
end)))
	boot=_s8_value
	return _s8_value
end)();
if (smalltalk:responds_to_((boot),("for:")))==true then (function()
	local _s8_value=(((boot):for_((self):nativeLanguage())):contents())
	boot=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:notNil_((boot))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):writeString_on_(boot,aStream))
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
	local _s8_value=(smalltalk:object_comma_(("S8_Boot_"),(smalltalk.String):nativeFileExtension()))
	bootName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aSmalltalk):at_ifAbsent_(bootName,(function()
return (nil)
end)))
	boot=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((boot)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((save):value())
end
)()
error(_s8Ret_,0)
end)(); end;
if ((self):write_on_("Boot",aStream))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
	local _s8_value=(smalltalk:object_comma_(("s8/start/boot."),(smalltalk.String):nativeFileExtension()))
	bootName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((bootName):fileContents())
	boot=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((boot)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aSmalltalk):at_put_(bootName,(save):value()))
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_("Missing boot resource"))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"writing","writeBoot: aSmalltalk on: aStream\r\n\t\" Private - Write the boot section of the image onto aStream. \"\r\n\r\n\t| boot bootName save |\r\n\tsave := [ | text |\r\n\t\tself writeLicense: aSmalltalk on: aStream.\r\n\t\ttext := self bootHeader ,boot ,self bootFooter.\r\n\t\tself writeString: text on: aStream.\r\n\t\ttext\r\n\t].\r\n\r\n\tboot := aSmalltalk at: #BootSector ifAbsent: [].\r\n\t(boot respondsTo: #for:) ifTrue: [\r\n\t\tboot := (boot for: self nativeLanguage) contents.\r\n\t\tboot notNil ifTrue: [\r\n\t\t\t^self writeString: boot on: aStream\r\n\t\t].\r\n\t].\r\n\r\n\tbootName := 'S8_Boot_' ,String nativeFileExtension.\r\n\tboot := aSmalltalk at: bootName ifAbsent: [].\r\n\tboot notNil ifTrue: [\r\n\t\t\"embedded boot sector\"\r\n\t\t^save value\r\n\t].\r\n\r\n\t(self write: #Boot on: aStream) ifTrue: [\r\n\t\t\"custom implementation by the receiver\"\r\n\t\t^self\r\n\t].\r\n\r\n\tbootName := 's8/start/boot.' ,String nativeFileExtension.\r\n\tboot := bootName fileContents.\r\n\tboot notNil ifTrue: [\r\n\t\t\"embedding from external boot file\"\r\n\t\t^aSmalltalk at: bootName put: save value\r\n\t].\r\n\t^self error: 'Missing boot resource'","(\r\nfunction(self,aSmalltalk,aStream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal boot=nil\r\nlocal bootName=nil\r\nlocal save=nil\r\n(function()\r\n\tlocal _s8_value=((function()\r\nlocal text=nil\r\n(self):writeLicense_on_(aSmalltalk,aStream);(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((self):bootHeader()),boot)),(self):bootFooter()))\r\n\ttext=_s8_value\r\n\treturn _s8_value\r\nend)();(self):writeString_on_(text,aStream);return (text)\r\nend))\r\n\tsave=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aSmalltalk):at_ifAbsent_(\"BootSector\",(function()\r\nreturn (nil)\r\nend)))\r\n\tboot=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:responds_to_((boot),(\"for:\")))==true then (function()\r\n\tlocal _s8_value=(((boot):for_((self):nativeLanguage())):contents())\r\n\tboot=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:notNil_((boot))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):writeString_on_(boot,aStream))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((\"S8_Boot_\"),(smalltalk.String):nativeFileExtension()))\r\n\tbootName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aSmalltalk):at_ifAbsent_(bootName,(function()\r\nreturn (nil)\r\nend)))\r\n\tboot=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((boot)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((save):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\nif ((self):write_on_(\"Boot\",aStream))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((\"s8/start/boot.\"),(smalltalk.String):nativeFileExtension()))\r\n\tbootName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((bootName):fileContents())\r\n\tboot=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((boot)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aSmalltalk):at_put_(bootName,(save):value()))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(\"Missing boot resource\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"write:on:",0
,(
function(self,section,aStream)
local msg=nil
(aStream):cr();
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("write"),((self):nativeLanguage()):asUppercase())),section)),"On:"))
	msg=_s8_value
	return _s8_value
end)();
if (smalltalk:responds_to_((self),(msg)))==true then (self):perform_with_(msg,aStream);
return (true); end;
return (false);
end
)
,"writing","write: section on: aStream\r\n\t\" Private - Write the section of the image onto aStream. \"\r\n\r\n\t| msg |\r\n\taStream cr.\r\n\tmsg:= #write ,self nativeLanguage asUppercase ,section ,#On:.\r\n\t(self respondsTo: msg) ifTrue: [\r\n\t\tself perform: msg with: aStream.\r\n\t\t^true\r\n\t].\r\n\t^false","(\r\nfunction(self,section,aStream)\r\nlocal msg=nil\r\n(aStream):cr();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"write\"),((self):nativeLanguage()):asUppercase())),section)),\"On:\"))\r\n\tmsg=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:responds_to_((self),(msg)))==true then (self):perform_with_(msg,aStream);\r\nreturn (true); end;\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"writeJSPrologueOn:",0
,(
function(self,aStream)
(self):writeString_on_("smalltalk.$state = \"js-toolset\"",aStream);
(self):writeGlobals_on_(smalltalk:newArray({"smalltalk.st", "smalltalk.doIt", "fileIn", "fileInJS", "doit", "exportCategory", "saveImage", "saveImageAs"}),aStream);
(self):writeString_on_("smalltalk.$state = \"initialized\"",aStream);
(aStream):cr();
return (self);
end
)
,"js","writeJSPrologueOn: aStream\r\n\t\" Private - Write the js prologue section of the image onto aStream. \"\r\n\r\n\tself writeString: 'smalltalk.$state = \"js-toolset\"' on: aStream.\r\n\tself writeGlobals: #(\r\n\t\t'smalltalk.st' 'smalltalk.doIt'\r\n\t\t#fileIn #fileInJS\r\n\t\t#doit #exportCategory\r\n\t\t#saveImage #saveImageAs\r\n\t\t) on: aStream.\r\n\tself writeString: 'smalltalk.$state = \"initialized\"' on: aStream.\r\n\taStream cr.","(\r\nfunction(self,aStream)\r\n(self):writeString_on_(\"smalltalk.$state = \\\"js-toolset\\\"\",aStream);\r\n(self):writeGlobals_on_(smalltalk:newArray({\"smalltalk.st\", \"smalltalk.doIt\", \"fileIn\", \"fileInJS\", \"doit\", \"exportCategory\", \"saveImage\", \"saveImageAs\"}),aStream);\r\n(self):writeString_on_(\"smalltalk.$state = \\\"initialized\\\"\",aStream);\r\n(aStream):cr();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"launchExpression",0
,(
function(self)
return ("smalltalk:launchImage()");
end
)
,"encoding","launchExpression\r\n\t\" Private - Return the native launch expression. \"\r\n\r\n\t^{''}","(\r\nfunction(self)\r\nreturn (\"smalltalk:launchImage()\");\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"writeLaunchExpressionOn:",0
,(
function(self,aStream)
local launch=nil
(function()
	local _s8_value=((self):launchExpression())
	launch=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((launch)))==true then (self):writeString_on_(launch,aStream); end;
return (self);
end
)
,"writing","writeLaunchExpressionOn: aStream\r\n\t\" Private - Write the epilogue section of the image onto aStream. \"\r\n\r\n\t| launch |\r\n\tlaunch := self launchExpression.\r\n\tlaunch notNil ifTrue: [ self writeString: launch on: aStream ].","(\r\nfunction(self,aStream)\r\nlocal launch=nil\r\n(function()\r\n\tlocal _s8_value=((self):launchExpression())\r\n\tlaunch=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((launch)))==true then (self):writeString_on_(launch,aStream); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"writeString:on:",0
,(
function(self,aString,aStream)
(
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(aString))
end
)(aStream);
return (self);
end
)
,"writing","writeString: aString on: aStream\r\n\t\" Private - Write aString onto aStream. \"\r\n\r\n\taStream cr; nextPutAll: aString","(\r\nfunction(self,aString,aStream)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(aString))\r\nend\r\n)(aStream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"globalNotFound:",0
,(
function(self,aGlobal)
return ((self):error_(smalltalk:object_comma_(("Global not found: "),aGlobal)));
end
)
,"error","globalNotFound: aGlobal\r\n\t\" Private - A global at native level has not been found. \"\r\n\r\n\t^self error: 'Global not found: ',aGlobal","(\r\nfunction(self,aGlobal)\r\nreturn ((self):error_(smalltalk:object_comma_((\"Global not found: \"),aGlobal)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"writeGlobals:on:",0
,(
function(self,globals,aStream)
local object=nil
local varName=nil
(globals):do_((function(each)
(function()
	local _s8_value=(((smalltalk.Smalltalk):current()):eval_(each))
	object=_s8_value
	return _s8_value
end)();if (smalltalk:isNil_((object)))==true then (function()
	local _s8_value=((self):globalNotFound_(each))
	object=_s8_value
	return _s8_value
end)(); end;return (smalltalk:if_true_false_((smalltalk:notNil_((object))),(function()
(function()
	local _s8_value=(smalltalk:if_true_false_(((each):includes_(".")),(function()
return (each)
end),(function()
return (smalltalk:object_comma_(("var "),each))
end)))
	varName=_s8_value
	return _s8_value
end)();return ((self):writeString_on_(smalltalk:object_comma_((smalltalk:object_comma_((varName)," = ")),smalltalk:toString_((object))),aStream))
end),nil))
end));
return (self);
end
)
,"writing","writeGlobals: globals on: aStream\r\n\t\" Private - Write the prologue section of the image onto aStream. \"\r\n\r\n\t| object varName |\r\n\tglobals do: [:each|\r\n\t\tobject := Smalltalk current eval: each.\r\n\t\tobject isNil ifTrue: [ object := self globalNotFound: each ].\r\n\t\tobject notNil ifTrue: [\r\n\t\t\tvarName := (each includes: $.) ifTrue: [ each ] ifFalse: [ 'var ',each ].\r\n\t\t\tself writeString: varName,' = ', object toString on: aStream.\r\n\t\t]\r\n\t]","(\r\nfunction(self,globals,aStream)\r\nlocal object=nil\r\nlocal varName=nil\r\n(globals):do_((function(each)\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.Smalltalk):current()):eval_(each))\r\n\tobject=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isNil_((object)))==true then (function()\r\n\tlocal _s8_value=((self):globalNotFound_(each))\r\n\tobject=_s8_value\r\n\treturn _s8_value\r\nend)(); end;return (smalltalk:if_true_false_((smalltalk:notNil_((object))),(function()\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((each):includes_(\".\")),(function()\r\nreturn (each)\r\nend),(function()\r\nreturn (smalltalk:object_comma_((\"var \"),each))\r\nend)))\r\n\tvarName=_s8_value\r\n\treturn _s8_value\r\nend)();return ((self):writeString_on_(smalltalk:object_comma_((smalltalk:object_comma_((varName),\" = \")),smalltalk:toString_((object))),aStream))\r\nend),nil))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"writeNilDefinitionOn:",0
,(
function(self,aStream)
local sample=nil
(function()
	local _s8_value=(nil)
	sample=_s8_value
	return _s8_value
end)();
(self):writeString_on_("var nil = new StUndefinedObject()",aStream);
(self):writeString_on_(smalltalk:object_comma_(("nil.toString = "),smalltalk:toString_((sample["toString"]))),aStream);
(self):writeString_on_(smalltalk:object_comma_(("nil.isNil_ = "),smalltalk:toString_((sample["isNil_"]))),aStream);
(self):writeString_on_(smalltalk:object_comma_(("nil.is_eqeq_ = "),smalltalk:toString_((sample["is_eqeq_"]))),aStream);
return (self);
end
)
,"js","writeNilDefinitionOn: aStream\r\n\t\" Private - Write the definition of nil object onto aStream. \"\r\n\r\n\t| sample |\r\n\tsample := nil.\r\n\tself writeString: 'var nil = new StUndefinedObject()' on: aStream.\r\n\tself writeString: 'nil.toString = ', sample#toString toString on: aStream.\r\n\tself writeString: 'nil.isNil_ = ', sample#isNil_ toString on: aStream.\r\n\tself writeString: 'nil.is_eqeq_ = ', sample#is_eqeq_ toString on: aStream.","(\r\nfunction(self,aStream)\r\nlocal sample=nil\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tsample=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):writeString_on_(\"var nil = new StUndefinedObject()\",aStream);\r\n(self):writeString_on_(smalltalk:object_comma_((\"nil.toString = \"),smalltalk:toString_((sample[\"toString\"]))),aStream);\r\n(self):writeString_on_(smalltalk:object_comma_((\"nil.isNil_ = \"),smalltalk:toString_((sample[\"isNil_\"]))),aStream);\r\n(self):writeString_on_(smalltalk:object_comma_((\"nil.is_eqeq_ = \"),smalltalk:toString_((sample[\"is_eqeq_\"]))),aStream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"writeSystemDefinitionOn:",0
,(
function(self,aStream)
(self):writeString_on_("var smalltalk = new StSystemDictionary()",aStream);
(self):writeString_on_("smalltalk.toString = function() { return \"smalltalk\" }",aStream);
(self):writeString_on_("smalltalk.startup();",aStream);
return (self);
end
)
,"js","writeSystemDefinitionOn: aStream\r\n\t\" Private - Write the definition of smalltalk object onto aStream. \"\r\n\r\n\tself writeString: 'var smalltalk = new StSystemDictionary()' on: aStream.\r\n\tself writeString: 'smalltalk.toString = function() { return \"smalltalk\" }' on: aStream.\r\n\tself writeString: 'smalltalk.startup();' on: aStream.","(\r\nfunction(self,aStream)\r\n(self):writeString_on_(\"var smalltalk = new StSystemDictionary()\",aStream);\r\n(self):writeString_on_(\"smalltalk.toString = function() { return \\\"smalltalk\\\" }\",aStream);\r\n(self):writeString_on_(\"smalltalk.startup();\",aStream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"writeContents:on:",0
,(
function(self,aSmalltalk,aStream)
local exporter=nil
local globals=nil
local classes=nil
(aStream):cr();
(function()
	local _s8_value=((self):exporterFor_(aSmalltalk))
	exporter=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):globalsIn_(aSmalltalk))
	globals=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((self):classesToExportFrom_with_(aSmalltalk,exporter)):collect_((function(each)
return ((each):aboutToSaveImage_on_(self,aStream))
end))):select_((function(each)
return (smalltalk:notNil_((each)))
end)))
	classes=_s8_value
	return _s8_value
end)();
(exporter):exportClasses_on_(classes,aStream);
(self):exportGlobals_with_on_(globals,exporter,aStream);
(classes):do_((function(each)
return ((each):imageSaved_on_(self,aStream))
end));
return (self);
end
)
,"writing","writeContents: aSmalltalk on: aStream\r\n\t\" Private - Write the image section of aSmalltalk system onto aStream. \"\r\n\r\n\t| exporter globals classes |\r\n\taStream cr.\r\n\texporter := self exporterFor: aSmalltalk.\r\n\tglobals := self globalsIn: aSmalltalk.\r\n\tclasses := ((self classesToExportFrom: aSmalltalk with: exporter)\r\n\t\tcollect: [:each| each aboutToSaveImage: self on: aStream ])\r\n\t\tselect: [:each| each notNil ].\r\n\"\tself exportGlobalNames: globals keys sorted in: aSmalltalk on: aStream.\r\n\"\texporter exportClasses: classes on: aStream.\r\n\tself exportGlobals: globals with: exporter on: aStream.\r\n\tclasses do: [:each| each imageSaved: self on: aStream ].","(\r\nfunction(self,aSmalltalk,aStream)\r\nlocal exporter=nil\r\nlocal globals=nil\r\nlocal classes=nil\r\n(aStream):cr();\r\n(function()\r\n\tlocal _s8_value=((self):exporterFor_(aSmalltalk))\r\n\texporter=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):globalsIn_(aSmalltalk))\r\n\tglobals=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((self):classesToExportFrom_with_(aSmalltalk,exporter)):collect_((function(each)\r\nreturn ((each):aboutToSaveImage_on_(self,aStream))\r\nend))):select_((function(each)\r\nreturn (smalltalk:notNil_((each)))\r\nend)))\r\n\tclasses=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(exporter):exportClasses_on_(classes,aStream);\r\n(self):exportGlobals_with_on_(globals,exporter,aStream);\r\n(classes):do_((function(each)\r\nreturn ((each):imageSaved_on_(self,aStream))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"exporterFor:",0
,(
function(self,aSmalltalk)
return ((smalltalk.Exporter):new());
end
)
,"exporting","exporterFor: aSmalltalk\r\n\t\" Private - Return the exporter to use to write contents of aSmalltalk system. \"\r\n\r\n\t^Exporter new","(\r\nfunction(self,aSmalltalk)\r\nreturn ((smalltalk.Exporter):new());\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"globalsIn:",0
,(
function(self,aSmalltalk)
local result=nil
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	result=_s8_value
	return _s8_value
end)();
(aSmalltalk):globalsDo_((function(key)
return ((result):at_put_(key,(aSmalltalk)[key]))
end));
return (result);
end
)
,"exporting","globalsIn: aSmalltalk\r\n\t\" Private - Return the globals defined in aSmalltalk system. \"\r\n\r\n\t| result |\r\n\tresult := PoolDictionary new.\r\n\taSmalltalk globalsDo: [:key| result at: key put: (aSmalltalk basicAt: key) ].\r\n\t^result","(\r\nfunction(self,aSmalltalk)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aSmalltalk):globalsDo_((function(key)\r\nreturn ((result):at_put_(key,(aSmalltalk)[key]))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"classesToExportFrom:with:",0
,(
function(self,aSmalltalk,exporter)
return (((aSmalltalk):rootClasses()):inject_into_(smalltalk:newArray({}),(function(total,each)
(total):addAll_((each):withAllSubclasses());return (total)
end)));
end
)
,"exporting","classesToExportFrom: aSmalltalk with: exporter\r\n\t\" Private - Return the classes to export from aSmalltalk system. \"\r\n\r\n\t^aSmalltalk rootClasses\r\n\t\tinject: #() into: [:total :each| total addAll: each withAllSubclasses. total ]","(\r\nfunction(self,aSmalltalk,exporter)\r\nreturn (((aSmalltalk):rootClasses()):inject_into_(smalltalk:newArray({}),(function(total,each)\r\n(total):addAll_((each):withAllSubclasses());return (total)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"exportGlobalNames:in:on:",0
,(
function(self,names,aSmalltalk,aStream)
(names):do_separatedBy_((function(key)
return ((aStream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk[\""),key)),"\"]")))
end),(function()
return ((aStream):nextPutAll_(" , "))
end));
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("=nil");
	return ((_s8_rec):cr())
end
)(aStream);
return (self);
end
)
,"exporting","exportGlobalNames: names in: aSmalltalk on: aStream\r\n\t\" Private - Export global names in aSmalltalk system. \"\r\n\r\n\tnames\r\n\t\tdo: [:key| aStream nextPutAll: 'smalltalk[\"',key,'\"]' ]\r\n\t\tseparatedBy: [ aStream nextPutAll: ' , ' ].\r\n\taStream nextPutAll: '=nil'; cr.","(\r\nfunction(self,names,aSmalltalk,aStream)\r\n(names):do_separatedBy_((function(key)\r\nreturn ((aStream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk[\\\"\"),key)),\"\\\"]\")))\r\nend),(function()\r\nreturn ((aStream):nextPutAll_(\" , \"))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"=nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Snapshot,"exportGlobals:with:on:",0
,(
function(self,globals,exporter,aStream)
(globals):associationsDo_((function(binding)
return ((self):writeString_on_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk[\""),(binding):key())),"\"]=")),(exporter):exportObject_((binding):value())),aStream))
end));
return (self);
end
)
,"exporting","exportGlobals: globals with: exporter on: aStream\r\n\t\" Private - Export global objects onto aStream. \"\r\n\r\n\tglobals associationsDo: [:binding|\r\n\t\tself writeString: 'smalltalk[\"',binding key,'\"]='\r\n\t\t\t,(exporter exportObject: binding value)\r\n\t\t\ton: aStream\r\n\t]","(\r\nfunction(self,globals,exporter,aStream)\r\n(globals):associationsDo_((function(binding)\r\nreturn ((self):writeString_on_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk[\\\"\"),(binding):key())),\"\\\"]=\")),(exporter):exportObject_((binding):value())),aStream))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Transcript["$klass"],"current",0
,(
function(self)
if (smalltalk:isNil_((smalltalk.Transcript:classVariableAt_("Current"))))==true then (self):current_((self):new()); end;
return (smalltalk.Transcript:classVariableAt_("Current"));
end
)
,"singleton","current\r\n\t\" Return the current instance of the receiver. \"\r\n\r\n\tCurrent isNil ifTrue: [ self current: self new ].\r\n\t^Current","(\r\nfunction(self)\r\nif (smalltalk:isNil_((smalltalk.Transcript:classVariableAt_(\"Current\"))))==true then (self):current_((self):new()); end;\r\nreturn (smalltalk.Transcript:classVariableAt_(\"Current\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Transcript["$klass"],"current:",0
,(
function(self,aTranscript)
smalltalk.Transcript:classVariableAt_put_("Current",aTranscript);
return (self);
end
)
,"singleton","current: aTranscript\r\n\t\" Set the current instance of the receiver. \"\r\n\r\n\tCurrent := aTranscript","(\r\nfunction(self,aTranscript)\r\nsmalltalk.Transcript:classVariableAt_put_(\"Current\",aTranscript);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Transcript["$klass"],"cr",0
,(
function(self)
return (((self):current()):cr());
end
)
,"io","cr\r\n\t\" Output a line break onto the current instance. \"\r\n\r\n\t^self current cr","(\r\nfunction(self)\r\nreturn (((self):current()):cr());\r\nend\r\n)")
smalltalk:bind(smalltalk.Transcript["$klass"],"nextPutAll:",0
,(
function(self,aString)
return (((self):current()):nextPutAll_(aString));
end
)
,"io","nextPutAll: aString\r\n\t\" Output aString onto the current instance. \"\r\n\r\n\t^self current nextPutAll: aString","(\r\nfunction(self,aString)\r\nreturn (((self):current()):nextPutAll_(aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.Transcript["$klass"],"show:",0
,(
function(self,aString)
return (((self):current()):show_(aString));
end
)
,"io","show: aString\r\n\t\" Output aString onto the current instance (ensure result is shown). \"\r\n\r\n\t^self current show: aString","(\r\nfunction(self,aString)\r\nreturn (((self):current()):show_(aString));\r\nend\r\n)")
smalltalk:bind(smalltalk.Transcript,"initializeStreams",0
,(
function(self)
(function()
	local _s8_value=((smalltalk.Array):new())
	self["@streams"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"initialize","initializeStreams\r\n\t\" Private - Initialize the streams of the receiver. \"\r\n\r\n\tstreams := Array new","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@streams\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Transcript,"streams",0
,(
function(self)
if (smalltalk:isNil_((self["@streams"])))==true then (self):initializeStreams(); end;
return (self["@streams"]);
end
)
,"accessing","streams\r\n\t\" Return the streams of the receiver. \"\r\n\r\n\tstreams isNil ifTrue: [ self initializeStreams ].\r\n\t^streams","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@streams\"])))==true then (self):initializeStreams(); end;\r\nreturn (self[\"@streams\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.Transcript,"streams:",0
,(
function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@streams"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"accessing","streams: anObject\r\n\t\" Set the streams of the receiver. \"\r\n\r\n\tstreams := anObject","(\r\nfunction(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@streams\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Transcript,"cr",0
,(
function(self)
((self):streams()):do_((function(each)
return ((each):cr())
end));
return (self);
end
)
,"io","cr\r\n\t\" Output a line break onto the receiver. \"\r\n\r\n\tself streams do: [:each| each cr ]","(\r\nfunction(self)\r\n((self):streams()):do_((function(each)\r\nreturn ((each):cr())\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Transcript,"nextPutAll:",0
,(
function(self,aString)
((self):streams()):do_((function(each)
return ((each):nextPutAll_(smalltalk:asString_((aString))))
end));
return (self);
end
)
,"io","nextPutAll: aString\r\n\t\" Output aString onto the receiver. \"\r\n\r\n\tself streams do: [:each| each nextPutAll: aString asString ]","(\r\nfunction(self,aString)\r\n((self):streams()):do_((function(each)\r\nreturn ((each):nextPutAll_(smalltalk:asString_((aString))))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Transcript,"show:",0
,(
function(self,aString)
(self):nextPutAll_(aString);
return (self);
end
)
,"io","show: aString\r\n\t\" Output aString onto the receiver (ensure result is shown). \"\r\n\r\n\tself nextPutAll: aString","(\r\nfunction(self,aString)\r\n(self):nextPutAll_(aString);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Transcript,"flush",0
,(
function(self)
((self):streams()):do_((function(each)
return (smalltalk:if_true_false_((smalltalk:responds_to_((each),("flush"))),(function()
return ((each):flush())
end),nil))
end));
return (self);
end
)
,"io","flush\r\n\t\" Flush the receiver. \"\r\n\r\n\tself streams do: [:each|\r\n\t\t(each respondsTo: #flush) ifTrue: [ each flush ]\r\n\t]","(\r\nfunction(self)\r\n((self):streams()):do_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:responds_to_((each),(\"flush\"))),(function()\r\nreturn ((each):flush())\r\nend),nil))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Transcript,"inUse",0
,(
function(self)
return (smalltalk:boolean_and_((smalltalk:notNil_((self["@streams"]))),(function()
return ((self["@streams"]):notEmpty())
end)));
end
)
,"query","inUse\r\n\t\" Return true if the receiver is in use. \"\r\n\r\n\t^streams notNil and: [streams notEmpty]","(\r\nfunction(self)\r\nreturn (smalltalk:boolean_and_((smalltalk:notNil_((self[\"@streams\"]))),(function()\r\nreturn ((self[\"@streams\"]):notEmpty())\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"undefined",0
,(
function(self)
return (nil);
end
)
,"constants","undefined\r\n\t\" Private - Return the native representation for undefined. \"\r\n\r\n\t^{''}","(\r\nfunction(self)\r\nreturn (nil);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"nativeNameFromSelector:",0
,(
function(self,aSymbol)
return (aSymbol);
end
)
,"builders","nativeNameFromSelector: aSymbol\r\n\t\" Private - Return the property name for selector aSymbol. \"\r\n\r\n\t^aSymbol","(\r\nfunction(self,aSymbol)\r\nreturn (aSymbol);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildGetterCode:",0
,(
function(self,aSelector)
if (((self):instanceVariableNames()):includes_(aSelector))==true then return (smalltalk:superImplementor(smalltalk.NativeObject["$klass"],"buildGetterCode_")(self,aSelector)); end;
return (smalltalk:object_comma_(("^self handle basicAt: "),((self):nativeNameFromSelector_(aSelector)):asLiteral()));
end
)
,"builders-private","buildGetterCode: aSelector\r\n\t\" Private - Return source code to get aSelector. \"\r\n\r\n\t(self instanceVariableNames includes: aSelector) ifTrue: [\r\n\t\t^super buildGetterCode: aSelector\r\n\t].\r\n\t^'^self handle basicAt: '\r\n\t\t,(self nativeNameFromSelector: aSelector) asLiteral","(\r\nfunction(self,aSelector)\r\nif (((self):instanceVariableNames()):includes_(aSelector))==true then return (smalltalk:superImplementor(smalltalk.NativeObject[\"$klass\"],\"buildGetterCode_\")(self,aSelector)); end;\r\nreturn (smalltalk:object_comma_((\"^self handle basicAt: \"),((self):nativeNameFromSelector_(aSelector)):asLiteral()));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildGetter:",0
,(
function(self,spec)
if (smalltalk:boolean_or_(((spec):isString()),(function()
return (smalltalk:boolean_and_(((spec):isArray()),(function()
return (smalltalk:isObject_equalTo_(((spec):second()),"initialize"))
end)))
end)))==true then return (smalltalk:superImplementor(smalltalk.NativeObject["$klass"],"buildGetter_")(self,spec)); end;
return ((self):buildTypedGetter_(spec));
end
)
,"builders","buildGetter: spec\r\n\t\" Build method for getter. \"\r\n\r\n\t(spec isString or: [\r\n\t\tspec isArray and: [\r\n\t\tspec second = #initialize ]]) ifTrue: [\r\n\t\t^super buildGetter: spec\r\n\t].\r\n\t^self buildTypedGetter: spec","(\r\nfunction(self,spec)\r\nif (smalltalk:boolean_or_(((spec):isString()),(function()\r\nreturn (smalltalk:boolean_and_(((spec):isArray()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((spec):second()),\"initialize\"))\r\nend)))\r\nend)))==true then return (smalltalk:superImplementor(smalltalk.NativeObject[\"$klass\"],\"buildGetter_\")(self,spec)); end;\r\nreturn ((self):buildTypedGetter_(spec));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSetterCode:",0
,(
function(self,aSelector)
if (((self):instanceVariableNames()):includes_(aSelector))==true then return (smalltalk:superImplementor(smalltalk.NativeObject["$klass"],"buildSetterCode_")(self,aSelector)); end;
return (smalltalk:object_comma_((smalltalk:object_comma_(("self handle basicAt: "),((self):nativeNameFromSelector_(aSelector)):asLiteral()))," put: anObject"));
end
)
,"builders-private","buildSetterCode: aSelector\r\n\t\" Private - Return source code to set aSelector. \"\r\n\r\n\t(self instanceVariableNames includes: aSelector) ifTrue: [\r\n\t\t^super buildSetterCode: aSelector\r\n\t].\r\n\t^'self handle basicAt: '\r\n\t\t,(self nativeNameFromSelector: aSelector) asLiteral\r\n\t\t, ' put: anObject'","(\r\nfunction(self,aSelector)\r\nif (((self):instanceVariableNames()):includes_(aSelector))==true then return (smalltalk:superImplementor(smalltalk.NativeObject[\"$klass\"],\"buildSetterCode_\")(self,aSelector)); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"self handle basicAt: \"),((self):nativeNameFromSelector_(aSelector)):asLiteral())),\" put: anObject\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSetter:",0
,(
function(self,spec)
if (smalltalk:boolean_or_(((spec):isString()),(function()
return (smalltalk:boolean_and_(((spec):isArray()),(function()
return (smalltalk:isObject_equalTo_(((spec):second()),"initialize"))
end)))
end)))==true then return (smalltalk:superImplementor(smalltalk.NativeObject["$klass"],"buildSetter_")(self,spec)); end;
return ((self):buildTypedSetter_(spec));
end
)
,"builders","buildSetter: spec\r\n\t\" Private - Return source code for setter. \"\r\n\r\n\t(spec isString or: [\r\n\t\tspec isArray and: [\r\n\t\tspec second = #initialize ]]) ifTrue: [\r\n\t\t^super buildSetter: spec\r\n\t].\r\n\t^self buildTypedSetter: spec","(\r\nfunction(self,spec)\r\nif (smalltalk:boolean_or_(((spec):isString()),(function()\r\nreturn (smalltalk:boolean_and_(((spec):isArray()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((spec):second()),\"initialize\"))\r\nend)))\r\nend)))==true then return (smalltalk:superImplementor(smalltalk.NativeObject[\"$klass\"],\"buildSetter_\")(self,spec)); end;\r\nreturn ((self):buildTypedSetter_(spec));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildTypedGetter:",0
,(
function(self,tuple)
if ((tuple):isString())==true then return ((self):buildGetter_(tuple)); end;
return ((self):build_doing_(("TypedGetter"):_minus_gt(tuple),(function()
return ((self):implement_comment_as_category_((self):stMessageHeader_((tuple):first()),smalltalk:object_comma_((smalltalk:object_comma_(("Return the "),(tuple):first()))," of the receiver."),smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):apiPrologueFor_((tuple):last())),"self handle basicAt: ")),((self):nativeNameFromSelector_((tuple):first())):asLiteral())),(self):apiEpilogueFor_((tuple):last())),"accessing"))
end)));
end
)
,"builders","buildTypedGetter: tuple\r\n\t\" Build (instance) method to get property from spec array. \"\r\n\r\n\ttuple isString ifTrue: [ ^self buildGetter: tuple ].\r\n\t^self build: #TypedGetter -> tuple doing: [\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: tuple first)\r\n\t\t\tcomment: 'Return the ' ,tuple first ,' of the receiver.'\r\n\t\t\tas: \t (self apiPrologueFor: tuple last)\r\n\t\t\t\t,'self handle basicAt: '\r\n\t\t\t\t,(self nativeNameFromSelector: tuple first) asLiteral\r\n\t\t\t\t,(self apiEpilogueFor: tuple last)\r\n\t\t\tcategory: #accessing\r\n\t]","(\r\nfunction(self,tuple)\r\nif ((tuple):isString())==true then return ((self):buildGetter_(tuple)); end;\r\nreturn ((self):build_doing_((\"TypedGetter\"):_minus_gt(tuple),(function()\r\nreturn ((self):implement_comment_as_category_((self):stMessageHeader_((tuple):first()),smalltalk:object_comma_((smalltalk:object_comma_((\"Return the \"),(tuple):first())),\" of the receiver.\"),smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):apiPrologueFor_((tuple):last())),\"self handle basicAt: \")),((self):nativeNameFromSelector_((tuple):first())):asLiteral())),(self):apiEpilogueFor_((tuple):last())),\"accessing\"))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildTypedSetter:",0
,(
function(self,tuple)
if ((tuple):isString())==true then return ((self):buildSetter_(tuple)); end;
return ((self):build_doing_(("TypedSetter"):_minus_gt(tuple),(function()
return ((self):implement_comment_as_category_((self):stMessageHeader_(smalltalk:object_comma_(((tuple):first()),": anObject")),smalltalk:object_comma_((smalltalk:object_comma_(("Set the "),(tuple):first()))," of the receiver."),smalltalk:object_comma_((smalltalk:object_comma_(("self handle basicAt: "),((self):nativeNameFromSelector_((tuple):first())):asLiteral()))," put: anObject handle"),"accessing"))
end)));
end
)
,"builders","buildTypedSetter: tuple\r\n\t\" Build (instance) method to set property to spec array. \"\r\n\r\n\ttuple isString ifTrue: [ ^self buildSetter: tuple ].\r\n\t^self build: #TypedSetter -> tuple doing: [\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: tuple first , ': anObject')\r\n\t\t\tcomment: 'Set the ' ,tuple first ,' of the receiver.'\r\n\t\t\tas: 'self handle basicAt: '\r\n\t\t\t\t,(self nativeNameFromSelector: tuple first) asLiteral\r\n\t\t\t\t,' put: anObject handle'\r\n\t\t\tcategory: #accessing\r\n\t]","(\r\nfunction(self,tuple)\r\nif ((tuple):isString())==true then return ((self):buildSetter_(tuple)); end;\r\nreturn ((self):build_doing_((\"TypedSetter\"):_minus_gt(tuple),(function()\r\nreturn ((self):implement_comment_as_category_((self):stMessageHeader_(smalltalk:object_comma_(((tuple):first()),\": anObject\")),smalltalk:object_comma_((smalltalk:object_comma_((\"Set the \"),(tuple):first())),\" of the receiver.\"),smalltalk:object_comma_((smalltalk:object_comma_((\"self handle basicAt: \"),((self):nativeNameFromSelector_((tuple):first())):asLiteral())),\" put: anObject handle\"),\"accessing\"))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildTypedGetters:",0
,(
function(self,specs)
return ((self):build_doing_(("TypedGetters"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildTypedGetter_(each))
end)))
end)));
end
)
,"builders","buildTypedGetters: specs\r\n\t\" Build (instance) methods to get properties. \"\r\n\r\n\t^self build: #TypedGetters -> specs doing: [\r\n\t\tspecs compose: [:each| self buildTypedGetter: each ]\r\n\t]","(\r\nfunction(self,specs)\r\nreturn ((self):build_doing_((\"TypedGetters\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildTypedGetter_(each))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildTypedAccessors:",0
,(
function(self,tuples)
return ((self):build_doing_(("TypedAccessors"):_minus_gt(tuples),(function()
return ((tuples):compose_((function(each)
return (smalltalk:object_comma_(((self):buildTypedGetter_(each)),(self):buildTypedSetter_(each)))
end)))
end)));
end
)
,"builders","buildTypedAccessors: tuples\r\n\t\" Build (instance) methods to get/set property from/to tuples. \"\r\n\t\r\n\t^self build: #TypedAccessors -> tuples doing: [\r\n\t\ttuples compose: [:each|\r\n\t\t\t(self buildTypedGetter: each)\r\n\t\t\t,(self buildTypedSetter: each)\r\n\t\t]\r\n\t]","(\r\nfunction(self,tuples)\r\nreturn ((self):build_doing_((\"TypedAccessors\"):_minus_gt(tuples),(function()\r\nreturn ((tuples):compose_((function(each)\r\nreturn (smalltalk:object_comma_(((self):buildTypedGetter_(each)),(self):buildTypedSetter_(each)))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFastGetter:",0
,(
function(self,aSelector)
local type=nil
local jsName=nil
if ((aSelector):isString())==true then (function()
	local _s8_value=("")
	type=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):nativeNameFromSelector_(aSelector))
	jsName=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=((aSelector):last())
	type=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):nativeNameFromSelector_((aSelector):first()))
	jsName=_s8_value
	return _s8_value
end)(); end;
return ((self):build_doing_(("FastGetter"):_minus_gt(aSelector),(function()
return ((self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_(("Return the "),aSelector))," of the receiver."),smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("^"),type)),"handle#")),jsName),"accessing"))
end)));
end
)
,"builders","buildFastGetter: aSelector\r\n\t\" Build (instance) method to get native property. \"\r\n\r\n\t| type jsName |\r\n\taSelector isString\r\n\t\tifTrue: [ type := ''. jsName := self nativeNameFromSelector: aSelector ]\r\n\t\tifFalse: [ type := aSelector last. jsName := self nativeNameFromSelector: aSelector first ].\r\n\t^self build: #FastGetter -> aSelector doing: [\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: aSelector)\r\n\t\t\tcomment: 'Return the ' ,aSelector ,' of the receiver.'\r\n\t\t\tas: '^' ,type ,'handle#' ,jsName category: #accessing\r\n\t]","(\r\nfunction(self,aSelector)\r\nlocal type=nil\r\nlocal jsName=nil\r\nif ((aSelector):isString())==true then (function()\r\n\tlocal _s8_value=(\"\")\r\n\ttype=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):nativeNameFromSelector_(aSelector))\r\n\tjsName=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=((aSelector):last())\r\n\ttype=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):nativeNameFromSelector_((aSelector):first()))\r\n\tjsName=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((self):build_doing_((\"FastGetter\"):_minus_gt(aSelector),(function()\r\nreturn ((self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_((\"Return the \"),aSelector)),\" of the receiver.\"),smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"^\"),type)),\"handle#\")),jsName),\"accessing\"))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFastSetter:",0
,(
function(self,aSelector)
local jsName=nil
if ((aSelector):isString())==true then (function()
	local _s8_value=((self):nativeNameFromSelector_(aSelector))
	jsName=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=((self):nativeNameFromSelector_((aSelector):first()))
	jsName=_s8_value
	return _s8_value
end)(); end;
return ((self):build_doing_(("FastSetter"):_minus_gt(aSelector),(function()
return ((self):implement_comment_as_category_(smalltalk:object_comma_(((self):stMessageHeader_(aSelector)),": anObject"),smalltalk:object_comma_((smalltalk:object_comma_(("Set the "),aSelector))," of the receiver."),smalltalk:object_comma_((smalltalk:object_comma_(("handle#"),jsName))," := anObject"),"accessing"))
end)));
end
)
,"builders","buildFastSetter: aSelector\r\n\t\" Build (instance) method to set native property. \"\r\n\r\n\t| jsName |\r\n\taSelector isString\r\n\t\tifTrue: [ jsName := self nativeNameFromSelector: aSelector ]\r\n\t\tifFalse: [ jsName := self nativeNameFromSelector: aSelector first ].\r\n\t^self build: #FastSetter -> aSelector doing: [\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: aSelector) ,': anObject'\r\n\t\t\tcomment: 'Set the ' ,aSelector ,' of the receiver.'\r\n\t\t\tas: 'handle#' ,jsName ,' := anObject' category: #accessing\r\n\t]","(\r\nfunction(self,aSelector)\r\nlocal jsName=nil\r\nif ((aSelector):isString())==true then (function()\r\n\tlocal _s8_value=((self):nativeNameFromSelector_(aSelector))\r\n\tjsName=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=((self):nativeNameFromSelector_((aSelector):first()))\r\n\tjsName=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((self):build_doing_((\"FastSetter\"):_minus_gt(aSelector),(function()\r\nreturn ((self):implement_comment_as_category_(smalltalk:object_comma_(((self):stMessageHeader_(aSelector)),\": anObject\"),smalltalk:object_comma_((smalltalk:object_comma_((\"Set the \"),aSelector)),\" of the receiver.\"),smalltalk:object_comma_((smalltalk:object_comma_((\"handle#\"),jsName)),\" := anObject\"),\"accessing\"))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFastAccessor:",0
,(
function(self,accessor)
if ((accessor):isString())==true then return ((self):build_doing_(("FastAccessor"):_minus_gt(accessor),(function()
return (smalltalk:object_comma_(((self):buildFastGetter_(accessor)),(self):buildFastSetter_(accessor)))
end))); end;
return ((self):error_("Invalid (Fast)accessors."));
end
)
,"builders","buildFastAccessor: accessor\r\n\t\" Build (instance) method to access native property. \"\r\n\r\n\taccessor isString ifTrue: [\r\n\t\t^self build: #FastAccessor -> accessor doing: [\r\n\t\t\t(self buildFastGetter: accessor)\r\n\t\t\t,(self buildFastSetter: accessor)\r\n\t\t]\r\n\t].\r\n\t^self error: 'Invalid (Fast)accessors.'","(\r\nfunction(self,accessor)\r\nif ((accessor):isString())==true then return ((self):build_doing_((\"FastAccessor\"):_minus_gt(accessor),(function()\r\nreturn (smalltalk:object_comma_(((self):buildFastGetter_(accessor)),(self):buildFastSetter_(accessor)))\r\nend))); end;\r\nreturn ((self):error_(\"Invalid (Fast)accessors.\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFastGetters:",0
,(
function(self,specs)
if ((specs):isString())==true then return ((self):buildFastGetters_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("FastGetters"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildFastGetter_(each))
end)))
end)));
end
)
,"builders","buildFastGetters: specs\r\n\t\" Build methods to get properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildFastGetters: specs asArrayOfSubstrings ].\r\n\t^self build: #FastGetters -> specs doing: [\r\n\t\tspecs compose: [:each| self buildFastGetter: each ]\r\n\t]","(\r\nfunction(self,specs)\r\nif ((specs):isString())==true then return ((self):buildFastGetters_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"FastGetters\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildFastGetter_(each))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFastAccessors:",0
,(
function(self,specs)
if ((specs):isString())==true then return ((self):buildFastAccessors_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("FastAccessors"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildFastAccessor_(each))
end)))
end)));
end
)
,"builders","buildFastAccessors: specs\r\n\t\" Build methods to access properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildFastAccessors: specs asArrayOfSubstrings ].\r\n\t^self build: #FastAccessors -> specs doing: [\r\n\t\tspecs compose: [:each| self buildFastAccessor: each ]\r\n\t]","(\r\nfunction(self,specs)\r\nif ((specs):isString())==true then return ((self):buildFastAccessors_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"FastAccessors\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildFastAccessor_(each))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"codeToNumber",0
,(
function(self)
return (" ");
end
)
,"constants","codeToNumber\r\n\t\" Private - Return the code to transform value to a number. \"\r\n\r\n\t^{''}","(\r\nfunction(self)\r\nreturn (\" \");\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"handleAt:",0
,(
function(self,aSelector)
return (smalltalk:object_comma_(("handle#"),(self):nativeNameFromSelector_(aSelector)));
end
)
,"constants","handleAt: aSelector\r\n\t\" Private - Return the code for accessing instance handle. \"\r\n\r\n\t^'handle#' ,(self nativeNameFromSelector: aSelector)","(\r\nfunction(self,aSelector)\r\nreturn (smalltalk:object_comma_((\"handle#\"),(self):nativeNameFromSelector_(aSelector)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildNumberGetter:",0
,(
function(self,aSelector)
return ((self):build_doing_(("NumberGetter"):_minus_gt(aSelector),(function()
return ((self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_(("Return the "),aSelector))," of the receiver."),smalltalk:object_comma_((smalltalk:object_comma_(("^"),(self):handleAt_(aSelector))),(self):codeToNumber()),"accessing"))
end)));
end
)
,"builders","buildNumberGetter: aSelector\r\n\t\" Build (instance) method to get native property. \"\r\n\r\n\t^self build: #NumberGetter -> aSelector doing: [\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: aSelector)\r\n\t\t\tcomment: 'Return the ' ,aSelector ,' of the receiver.'\r\n\t\t\tas: $^ ,(self handleAt: aSelector) ,self codeToNumber\r\n\t\t\tcategory: #accessing\r\n\t]","(\r\nfunction(self,aSelector)\r\nreturn ((self):build_doing_((\"NumberGetter\"):_minus_gt(aSelector),(function()\r\nreturn ((self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_((\"Return the \"),aSelector)),\" of the receiver.\"),smalltalk:object_comma_((smalltalk:object_comma_((\"^\"),(self):handleAt_(aSelector))),(self):codeToNumber()),\"accessing\"))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildNumberAccessor:",0
,(
function(self,accessor)
if ((accessor):isString())==true then return ((self):build_doing_(("NumberAccessor"):_minus_gt(accessor),(function()
return (smalltalk:object_comma_(((self):buildNumberGetter_(accessor)),(self):buildSetter_(accessor)))
end))); end;
return ((self):error_("Invalid (Number)accessors."));
end
)
,"builders","buildNumberAccessor: accessor\r\n\t\" Build (instance) method to access native property. \"\r\n\r\n\taccessor isString ifTrue: [\r\n\t\t^self build: #NumberAccessor -> accessor doing: [\r\n\t\t\t(self buildNumberGetter: accessor)\r\n\t\t\t,(self buildSetter: accessor)\r\n\t\t]\r\n\t].\r\n\t^self error: 'Invalid (Number)accessors.'","(\r\nfunction(self,accessor)\r\nif ((accessor):isString())==true then return ((self):build_doing_((\"NumberAccessor\"):_minus_gt(accessor),(function()\r\nreturn (smalltalk:object_comma_(((self):buildNumberGetter_(accessor)),(self):buildSetter_(accessor)))\r\nend))); end;\r\nreturn ((self):error_(\"Invalid (Number)accessors.\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildNumberGetters:",0
,(
function(self,specs)
if ((specs):isString())==true then return ((self):buildNumberGetters_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("NumberGetters"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildNumberGetter_(each))
end)))
end)));
end
)
,"builders","buildNumberGetters: specs\r\n\t\" Build methods to get properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildNumberGetters: specs asArrayOfSubstrings ].\r\n\t^self build: #NumberGetters -> specs doing: [\r\n\t\tspecs compose: [:each| self buildNumberGetter: each ]\r\n\t]","(\r\nfunction(self,specs)\r\nif ((specs):isString())==true then return ((self):buildNumberGetters_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"NumberGetters\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildNumberGetter_(each))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildNumberAccessors:",0
,(
function(self,specs)
if ((specs):isString())==true then return ((self):buildNumberAccessors_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("NumberAccessors"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildNumberAccessor_(each))
end)))
end)));
end
)
,"builders","buildNumberAccessors: specs\r\n\t\" Build methods to access properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildNumberAccessors: specs asArrayOfSubstrings ].\r\n\t^self build: #NumberAccessors -> specs doing: [\r\n\t\tspecs compose: [:each| self buildNumberAccessor: each ]\r\n\t]","(\r\nfunction(self,specs)\r\nif ((specs):isString())==true then return ((self):buildNumberAccessors_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"NumberAccessors\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildNumberAccessor_(each))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildBooleanGetter:",0
,(
function(self,aSelector)
return ((self):build_doing_(("BooleanGetter"):_minus_gt(aSelector),(function()
return ((self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_(("Return the "),aSelector))," of the receiver."),smalltalk:object_comma_(("^true == "),(self):handleAt_(aSelector)),"accessing"))
end)));
end
)
,"builders","buildBooleanGetter: aSelector\r\n\t\" Build (instance) method to get native property. \"\r\n\r\n\t^self build: #BooleanGetter -> aSelector doing: [\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: aSelector)\r\n\t\t\tcomment: 'Return the ' ,aSelector ,' of the receiver.'\r\n\t\t\tas: '^true == ' ,(self handleAt: aSelector)\r\n\t\t\tcategory: #accessing\r\n\t]","(\r\nfunction(self,aSelector)\r\nreturn ((self):build_doing_((\"BooleanGetter\"):_minus_gt(aSelector),(function()\r\nreturn ((self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_((\"Return the \"),aSelector)),\" of the receiver.\"),smalltalk:object_comma_((\"^true == \"),(self):handleAt_(aSelector)),\"accessing\"))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildBooleanAccessor:",0
,(
function(self,accessor)
if ((accessor):isString())==true then return ((self):build_doing_(("BooleanAccessor"):_minus_gt(accessor),(function()
return (smalltalk:object_comma_(((self):buildBooleanGetter_(accessor)),(self):buildSetter_(accessor)))
end))); end;
return ((self):error_("Invalid (Boolean)accessors."));
end
)
,"builders","buildBooleanAccessor: accessor\r\n\t\" Build (instance) method to access native property. \"\r\n\r\n\taccessor isString ifTrue: [\r\n\t\t^self build: #BooleanAccessor -> accessor doing: [\r\n\t\t\t(self buildBooleanGetter: accessor)\r\n\t\t\t,(self buildSetter: accessor)\r\n\t\t]\r\n\t].\r\n\t^self error: 'Invalid (Boolean)accessors.'","(\r\nfunction(self,accessor)\r\nif ((accessor):isString())==true then return ((self):build_doing_((\"BooleanAccessor\"):_minus_gt(accessor),(function()\r\nreturn (smalltalk:object_comma_(((self):buildBooleanGetter_(accessor)),(self):buildSetter_(accessor)))\r\nend))); end;\r\nreturn ((self):error_(\"Invalid (Boolean)accessors.\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildBooleanGetters:",0
,(
function(self,specs)
if ((specs):isString())==true then return ((self):buildBooleanGetters_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("BooleanGetters"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildBooleanGetter_(each))
end)))
end)));
end
)
,"builders","buildBooleanGetters: specs\r\n\t\" Build methods to get properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildBooleanGetters: specs asArrayOfSubstrings ].\r\n\t^self build: #BooleanGetters -> specs doing: [\r\n\t\tspecs compose: [:each| self buildBooleanGetter: each ]\r\n\t]","(\r\nfunction(self,specs)\r\nif ((specs):isString())==true then return ((self):buildBooleanGetters_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"BooleanGetters\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildBooleanGetter_(each))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildBooleanAccessors:",0
,(
function(self,specs)
if ((specs):isString())==true then return ((self):buildBooleanAccessors_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("BooleanAccessors"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildBooleanAccessor_(each))
end)))
end)));
end
)
,"builders","buildBooleanAccessors: specs\r\n\t\" Build methods to access properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildBooleanAccessors: specs asArrayOfSubstrings ].\r\n\t^self build: #BooleanAccessors -> specs doing: [\r\n\t\tspecs compose: [:each| self buildBooleanAccessor: each ]\r\n\t]","(\r\nfunction(self,specs)\r\nif ((specs):isString())==true then return ((self):buildBooleanAccessors_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"BooleanAccessors\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildBooleanAccessor_(each))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildIsBooleanGetter:",0
,(
function(self,aSelector)
return ((self):build_doing_(("IsBooleanGetter"):_minus_gt(aSelector),(function()
local isSelector=nil
(function()
	local _s8_value=(smalltalk:object_comma_(("is"),(aSelector):asGlobalName()))
	isSelector=_s8_value
	return _s8_value
end)();return ((self):implement_comment_as_category_((self):stMessageHeader_(isSelector),smalltalk:object_comma_((smalltalk:object_comma_(("Return the "),aSelector))," of the receiver."),smalltalk:object_comma_(("^true == handle#"),(self):nativeNameFromSelector_(isSelector)),"accessing"))
end)));
end
)
,"builders","buildIsBooleanGetter: aSelector\r\n\t\" Build (instance) method to get native property. \"\r\n\r\n\t^self build: #IsBooleanGetter -> aSelector doing: [ | isSelector |\r\n\t\tisSelector :=  #is ,aSelector asGlobalName.\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: isSelector)\r\n\t\t\tcomment: 'Return the ' ,aSelector ,' of the receiver.'\r\n\t\t\tas: '^true == handle#' ,(self nativeNameFromSelector: isSelector)\r\n\t\t\tcategory: #accessing\r\n\t]","(\r\nfunction(self,aSelector)\r\nreturn ((self):build_doing_((\"IsBooleanGetter\"):_minus_gt(aSelector),(function()\r\nlocal isSelector=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((\"is\"),(aSelector):asGlobalName()))\r\n\tisSelector=_s8_value\r\n\treturn _s8_value\r\nend)();return ((self):implement_comment_as_category_((self):stMessageHeader_(isSelector),smalltalk:object_comma_((smalltalk:object_comma_((\"Return the \"),aSelector)),\" of the receiver.\"),smalltalk:object_comma_((\"^true == handle#\"),(self):nativeNameFromSelector_(isSelector)),\"accessing\"))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildIsBooleanAccessor:",0
,(
function(self,accessor)
if ((accessor):isString())==true then return ((self):build_doing_(("IsBooleanAccessor"):_minus_gt(accessor),(function()
return (smalltalk:object_comma_(((self):buildIsBooleanGetter_(accessor)),(self):buildSetter_(accessor)))
end))); end;
return ((self):error_("Invalid (IsBoolean)accessors."));
end
)
,"builders","buildIsBooleanAccessor: accessor\r\n\t\" Build (instance) method to access native property. \"\r\n\r\n\taccessor isString ifTrue: [\r\n\t\t^self build: #IsBooleanAccessor -> accessor doing: [\r\n\t\t\t(self buildIsBooleanGetter: accessor)\r\n\t\t\t,(self buildSetter: accessor)\r\n\t\t]\r\n\t].\r\n\t^self error: 'Invalid (IsBoolean)accessors.'","(\r\nfunction(self,accessor)\r\nif ((accessor):isString())==true then return ((self):build_doing_((\"IsBooleanAccessor\"):_minus_gt(accessor),(function()\r\nreturn (smalltalk:object_comma_(((self):buildIsBooleanGetter_(accessor)),(self):buildSetter_(accessor)))\r\nend))); end;\r\nreturn ((self):error_(\"Invalid (IsBoolean)accessors.\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildIsBooleanGetters:",0
,(
function(self,specs)
if ((specs):isString())==true then return ((self):buildIsBooleanGetters_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("IsBooleanGetters"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildIsBooleanGetter_(each))
end)))
end)));
end
)
,"builders","buildIsBooleanGetters: specs\r\n\t\" Build methods to get properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildIsBooleanGetters: specs asArrayOfSubstrings ].\r\n\t^self build: #IsBooleanGetters -> specs doing: [\r\n\t\tspecs compose: [:each| self buildIsBooleanGetter: each ]\r\n\t]","(\r\nfunction(self,specs)\r\nif ((specs):isString())==true then return ((self):buildIsBooleanGetters_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"IsBooleanGetters\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildIsBooleanGetter_(each))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildIsBooleanAccessors:",0
,(
function(self,specs)
if ((specs):isString())==true then return ((self):buildIsBooleanAccessors_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("IsBooleanAccessors"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildIsBooleanAccessor_(each))
end)))
end)));
end
)
,"builders","buildIsBooleanAccessors: specs\r\n\t\" Build methods to access properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildIsBooleanAccessors: specs asArrayOfSubstrings ].\r\n\t^self build: #IsBooleanAccessors -> specs doing: [\r\n\t\tspecs compose: [:each| self buildIsBooleanAccessor: each ]\r\n\t]","(\r\nfunction(self,specs)\r\nif ((specs):isString())==true then return ((self):buildIsBooleanAccessors_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"IsBooleanAccessors\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildIsBooleanAccessor_(each))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSubclasses:",0
,(
function(self,aCollection)
local result=nil
(aCollection):do_((function(tuple)
return ((function()
	local _s8_value=(smalltalk:if_true_false_(((tuple):isString()),(function()
return ((self):buildSubclass_arguments_typed_(tuple,smalltalk:newArray({}),smalltalk:newArray({})))
end),(function()
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((tuple):size()),2)),(function()
return ((self):buildSubclass_arguments_typed_((tuple):first(),(tuple):second(),smalltalk:newArray({})))
end),(function()
return ((self):buildSubclass_arguments_typed_((tuple):first(),(tuple):second(),(tuple):last()))
end)))
end)))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
)
,"builder","buildSubclasses: aCollection\r\n\t\" Private - Build aCollection of subclasses of the receiver as wrappers to the library.\r\n\tReturn the last class created (or nil).\r\n\t\"\r\n\r\n\t| result |\r\n\taCollection do: [:tuple|\r\n\t\tresult := tuple isString\r\n\t\tifTrue: [ self buildSubclass: tuple arguments: #() typed: #() ]\r\n\t\tifFalse: [\r\n\t\t\ttuple size = 2\r\n\t\t\tifTrue: [ self buildSubclass: tuple first arguments: tuple second typed: #() ]\r\n\t\t\tifFalse: [ self buildSubclass: tuple first arguments: tuple second typed: tuple last ]\r\n\t\t ]\r\n\t].\r\n\t^result","(\r\nfunction(self,aCollection)\r\nlocal result=nil\r\n(aCollection):do_((function(tuple)\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((tuple):isString()),(function()\r\nreturn ((self):buildSubclass_arguments_typed_(tuple,smalltalk:newArray({}),smalltalk:newArray({})))\r\nend),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((tuple):size()),2)),(function()\r\nreturn ((self):buildSubclass_arguments_typed_((tuple):first(),(tuple):second(),smalltalk:newArray({})))\r\nend),(function()\r\nreturn ((self):buildSubclass_arguments_typed_((tuple):first(),(tuple):second(),(tuple):last()))\r\nend)))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildHierarchy:",0
,(
function(self,aCollection)
local stream=nil
local aClass=nil
(function()
	local _s8_value=((aCollection):stream())
	stream=_s8_value
	return _s8_value
end)();
while not ((function()
return ((stream):atEnd())
end))() do (function()
	local _s8_value=((self):buildSubclasses_((smalltalk.Array):with_((stream):next())))
	aClass=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((((stream):peek()):isArray()),(function()
return ((aClass):buildHierarchy_((stream):next()))
end),nil); end;
return (self);
end
)
,"builder","buildHierarchy: aCollection\r\n\t\" Private - Build aCollection of subclasses of the receiver as wrappers to the library. \"\r\n \r\n\t| stream aClass |\r\n\tstream := aCollection stream.\r\n\t[ stream atEnd ] whileFalse: [\r\n\t\taClass := self buildSubclasses: (Array with: stream next).\r\n\t\tstream peek isArray ifTrue: [\r\n\t\t\taClass buildHierarchy: stream next\r\n\t\t].\r\n\t]","(\r\nfunction(self,aCollection)\r\nlocal stream=nil\r\nlocal aClass=nil\r\n(function()\r\n\tlocal _s8_value=((aCollection):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((stream):atEnd())\r\nend))() do (function()\r\n\tlocal _s8_value=((self):buildSubclasses_((smalltalk.Array):with_((stream):next())))\r\n\taClass=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((((stream):peek()):isArray()),(function()\r\nreturn ((aClass):buildHierarchy_((stream):next()))\r\nend),nil); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSubclass:arguments:typed:",0
,(
function(self,globalClassName,argList,typedArguments)
local cls=nil
local clsName=nil
(function()
	local _s8_value=(smalltalk:object_comma_((((globalClassName):first()):asUppercase()),(globalClassName):copyFrom_to_(2,(globalClassName):size())))
	clsName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:object_comma_(((self):classToken()),clsName))
	clsName=_s8_value
	return _s8_value
end)();
(self):subclass_instanceVariableNames_category_(clsName,"",(self):category());
return ((smalltalk.Smalltalk):at_(clsName));
end
)
,"builder","buildSubclass: globalClassName arguments: argList typed: typedArguments\r\n\t\" Private - Build a subclass of the receiver implementing a wrapper to the library.\r\n\tNote: argList and typed arguments are ignored; see subclasses to find concrete implementors.\r\n\tReturn the created class.\r\n\t\"\r\n\r\n\t| cls clsName |\r\n\tclsName := globalClassName first asUppercase\r\n\t\t\t,(globalClassName copyFrom: 2 to: globalClassName size).\r\n\tclsName := self classToken ,clsName.\r\n\tself\r\n\t\tsubclass: clsName\r\n\t\tinstanceVariableNames: ''\r\n\t\tcategory: self category.\r\n\t^Smalltalk at: clsName","(\r\nfunction(self,globalClassName,argList,typedArguments)\r\nlocal cls=nil\r\nlocal clsName=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((((globalClassName):first()):asUppercase()),(globalClassName):copyFrom_to_(2,(globalClassName):size())))\r\n\tclsName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((self):classToken()),clsName))\r\n\tclsName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):subclass_instanceVariableNames_category_(clsName,\"\",(self):category());\r\nreturn ((smalltalk.Smalltalk):at_(clsName));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"classToken",0
,(
function(self)
return ("");
end
)
,"builder","classToken\r\n\t\" Private - Return the classToken to prepend/tag the receiver.\r\n\tThe default answer is empty.\r\n\tThe subclasses can subclass to build tagged subclasses.\r\n\t\"\r\n\r\n\t^''","(\r\nfunction(self)\r\nreturn (\"\");\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"classToken:",0
,(
function(self,aToken)
return ((self):buildClassToken_(aToken));
end
)
,"builder","classToken: aToken\r\n\t\" Private - Generate code to return the classToken of the receiver. \"\r\n\r\n\t^self buildClassToken: aToken","(\r\nfunction(self,aToken)\r\nreturn ((self):buildClassToken_(aToken));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildClassToken:",0
,(
function(self,aToken)
(self):build_doing_(("ClassToken"):_minus_gt(aToken),(function()
return ((self):implement_comment_as_category_("classToken","Private - Return the classToken to prepend/tag the receiver.",smalltalk:object_comma_(("^"),(aToken):asLiteral()),"builder"))
end));
return (self);
end
)
,"builder","buildClassToken: aToken\r\n\t\" Generate code to return the classToken of the receiver. \"\r\n\r\n\tself build: #ClassToken -> aToken doing: [\r\n\t\tself\r\n\t\t\timplement: #classToken\r\n\t\t\tcomment: 'Private - Return the classToken to prepend/tag the receiver.'\r\n\t\t\tas: $^ ,aToken asLiteral\r\n\t\t\tcategory: #builder\r\n\t]","(\r\nfunction(self,aToken)\r\n(self):build_doing_((\"ClassToken\"):_minus_gt(aToken),(function()\r\nreturn ((self):implement_comment_as_category_(\"classToken\",\"Private - Return the classToken to prepend/tag the receiver.\",smalltalk:object_comma_((\"^\"),(aToken):asLiteral()),\"builder\"))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFunctions:",0
,(
function(self,specs)
(self):build_doing_(("Functions"):_minus_gt(specs),(function()
return ((specs):do_((function(spec)
return ((self):buildFunction_(spec))
end)))
end));
return (self);
end
)
,"builders","buildFunctions: specs\r\n\t\" Generate code from specs as functions implemented by instance handle. \"\r\n\r\n\tself build: #Functions -> specs doing: [\r\n\t\tspecs do: [:spec| self buildFunction: spec ]\r\n\t]","(\r\nfunction(self,specs)\r\n(self):build_doing_((\"Functions\"):_minus_gt(specs),(function()\r\nreturn ((specs):do_((function(spec)\r\nreturn ((self):buildFunction_(spec))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildBooleanFunctions:",0
,(
function(self,specs)
if ((specs):isString())==true then return ((self):buildBooleanFunctions_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("BooleanFunctions"):_minus_gt(specs),(function()
return ((self):build_functions_("Boolean",specs))
end)));
end
)
,"builders","buildBooleanFunctions: specs\r\n\t\" Build methods to evaluate simple functions returning a Boolean. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildBooleanFunctions: specs asArrayOfSubstrings ].\r\n\t^self build: #BooleanFunctions -> specs doing: [\r\n\t\tself build: #Boolean functions: specs\r\n\t]","(\r\nfunction(self,specs)\r\nif ((specs):isString())==true then return ((self):buildBooleanFunctions_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"BooleanFunctions\"):_minus_gt(specs),(function()\r\nreturn ((self):build_functions_(\"Boolean\",specs))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"build:functions:",0
,(
function(self,aClassName,specs)
if ((specs):isString())==true then return ((self):build_functions_(aClassName,(specs):asArrayOfSubstrings())); end;
return ((self):buildFunctions_((specs):collect_((function(each)
return (smalltalk:if_true_false_(((each):isString()),(function()
return ((smalltalk.Array):with_with_with_(each,smalltalk:newArray({}),aClassName))
end),(function()
if not ((smalltalk:boolean_and_(((each):isArray()),(function()
return (smalltalk:isObject_equalTo_(((each):size()),2))
end))))==true then (self):error_(smalltalk:object_comma_(("Invalid literal spec "),each)); end;return ((each):copyWith_(aClassName))
end)))
end))));
end
)
,"builders","build: aClassName functions: specs\r\n\t\" Build methods to evaluate simple functions returning an instance of aClassName. \"\r\n\r\n\tspecs isString ifTrue: [ ^self build: aClassName functions: specs asArrayOfSubstrings ].\r\n\t^self buildFunctions: (specs collect: [:each|\r\n\t\teach isString\r\n\t\tifTrue: [ Array with: each with: #() with: aClassName ]\r\n\t\tifFalse: [\r\n\t\t\t(each isArray and: [each size = 2]) ifFalse: [\r\n\t\t\t\tself error: 'Invalid literal spec ' ,each\r\n\t\t\t].\r\n\t\t\teach copyWith: aClassName\r\n\t\t]\r\n\t])","(\r\nfunction(self,aClassName,specs)\r\nif ((specs):isString())==true then return ((self):build_functions_(aClassName,(specs):asArrayOfSubstrings())); end;\r\nreturn ((self):buildFunctions_((specs):collect_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):isString()),(function()\r\nreturn ((smalltalk.Array):with_with_with_(each,smalltalk:newArray({}),aClassName))\r\nend),(function()\r\nif not ((smalltalk:boolean_and_(((each):isArray()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((each):size()),2))\r\nend))))==true then (self):error_(smalltalk:object_comma_((\"Invalid literal spec \"),each)); end;return ((each):copyWith_(aClassName))\r\nend)))\r\nend))));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apiSupportFor:",0
,(
function(self,literal)
local support=nil
(function()
	local _s8_value=((smalltalk.NativeHandle):support())
	support=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_and_((smalltalk:responds_to_((support),("handleAPIFor:"))),(function()
return ((support):handleAPIFor_(literal))
end)))==true then return (support); end;
return (self);
end
)
,"api","apiSupportFor: literal\r\n\t\" Private - Return the support to encode literal as native api.\r\n\tNote: literal can be a String or Array of api annotation literals.\r\n\t\"\r\n\r\n\t| support |\r\n\tsupport := NativeHandle support.\r\n\t((support respondsTo: #handleAPIFor:)\r\n\t\tand: [support handleAPIFor: literal])\r\n\t\tifTrue: [ ^support ].\r\n\t^self","(\r\nfunction(self,literal)\r\nlocal support=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.NativeHandle):support())\r\n\tsupport=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_and_((smalltalk:responds_to_((support),(\"handleAPIFor:\"))),(function()\r\nreturn ((support):handleAPIFor_(literal))\r\nend)))==true then return (support); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apiEpilogueFor:",0
,(
function(self,aReturnType)
return (((self):apiSupportFor_(aReturnType)):nativeEpilogueFor_(aReturnType));
end
)
,"builders","apiEpilogueFor: aReturnType\r\n\t\" Private - Return the epilogue code to use to wrap a return. \"\r\n\r\n\t^(self apiSupportFor: aReturnType)\r\n\t\tnativeEpilogueFor: aReturnType","(\r\nfunction(self,aReturnType)\r\nreturn (((self):apiSupportFor_(aReturnType)):nativeEpilogueFor_(aReturnType));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apiPrologueFor:",0
,(
function(self,aReturnType)
return (((self):apiSupportFor_(aReturnType)):nativePrologueFor_(aReturnType));
end
)
,"builders","apiPrologueFor: aReturnType\r\n\t\" Private - Return the prologue to use to wrap a return. \"\r\n\r\n\t^(self apiSupportFor: aReturnType)\r\n\t\tnativePrologueFor: aReturnType","(\r\nfunction(self,aReturnType)\r\nreturn (((self):apiSupportFor_(aReturnType)):nativePrologueFor_(aReturnType));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"nativeEpilogueFor:",0
,(
function(self,aReturnType)
return (")");
end
)
,"builders","nativeEpilogueFor: aReturnType\r\n\t\" Private - Return the epilogue code to use to wrap a return. \"\r\n\r\n\t^$)","(\r\nfunction(self,aReturnType)\r\nreturn (\")\");\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"nativePrologueFor:",0
,(
function(self,aReturnType)
if ((aReturnType):isEmpty())==true then return ("^self ignoreReturn: ("); end;
if (smalltalk:isObject_equalTo_(((aReturnType):last()),"("))==true then return (smalltalk:object_comma_(("^"),aReturnType)); end;
if (smalltalk:isObject_equalTo_(((aReturnType):last()),"+"))==true then return ((self):apiPrologueFor_(smalltalk:object_comma_(((aReturnType):upTo_("+")),"[]"))); end;
if ((aReturnType):includes_("["))==true then return (smalltalk:object_comma_(("^"),(self):apiPrologueForArray_(aReturnType))); end;
if ((aReturnType):includes_("<"))==true then return (smalltalk:object_comma_(("^"),(self):apiPrologueForTuple_(aReturnType))); end;
return (smalltalk:object_comma_((smalltalk:object_comma_(("^"),(self):apiWrapperFor_(aReturnType)))," @ ("));
end
)
,"builders","nativePrologueFor: aReturnType\r\n\t\" Private - Return the prologue to use to wrap a return.\r\n\taReturnType can be:\r\n\t\t- empty string to ignore api return value (will return the receiver)\r\n\t\t- suffixed by [...] or + to return an arrayed result\r\n\t\t- suffixed by type spec GlobalName\r\n\t\t- smalltalk code ending with (\r\n\t\t- a global name understanding #@\r\n\t\"\r\n\r\n\taReturnType isEmpty ifTrue: [ ^'^self ignoreReturn: (' ].\r\n\taReturnType last = $( ifTrue: [ ^$^ ,aReturnType ].\r\n\taReturnType last = $+ ifTrue: [\r\n\t\t^self apiPrologueFor: (aReturnType upTo: $+) ,'[]'\r\n\t].\r\n\t(aReturnType includes: $[) ifTrue: [\r\n\t\t^$^ ,(self apiPrologueForArray: aReturnType)\r\n\t].\r\n\t(aReturnType includes: $<) ifTrue: [\r\n\t\t^$^ ,(self apiPrologueForTuple: aReturnType)\r\n\t].\r\n\r\n\t^$^ ,(self apiWrapperFor: aReturnType) ,' @ ('","(\r\nfunction(self,aReturnType)\r\nif ((aReturnType):isEmpty())==true then return (\"^self ignoreReturn: (\"); end;\r\nif (smalltalk:isObject_equalTo_(((aReturnType):last()),\"(\"))==true then return (smalltalk:object_comma_((\"^\"),aReturnType)); end;\r\nif (smalltalk:isObject_equalTo_(((aReturnType):last()),\"+\"))==true then return ((self):apiPrologueFor_(smalltalk:object_comma_(((aReturnType):upTo_(\"+\")),\"[]\"))); end;\r\nif ((aReturnType):includes_(\"[\"))==true then return (smalltalk:object_comma_((\"^\"),(self):apiPrologueForArray_(aReturnType))); end;\r\nif ((aReturnType):includes_(\"<\"))==true then return (smalltalk:object_comma_((\"^\"),(self):apiPrologueForTuple_(aReturnType))); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"^\"),(self):apiWrapperFor_(aReturnType))),\" @ (\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apiPrologueForArray:",0
,(
function(self,aReturnType)
local type=nil
local stream=nil
local kind=nil
(function()
	local _s8_value=((aReturnType):stream())
	stream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):apiWrapperFor_((stream):upTo_("[")))
	type=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((stream):upTo_("]"))
	kind=_s8_value
	return _s8_value
end)();
if not (((stream):atEnd()))==true then return ((self):error_("Invalid brackets for array")); end;
if ((kind):isEmpty())==true then return (smalltalk:object_comma_((type)," withAll: (")); end;
if not (((kind):includes_(",")))==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type)," of: ")),(self):apiWrapperFor_(kind)))," withAll: (")); end;
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type)," of: ")),smalltalk:printString_((kind))))," withAll: ("));
end
)
,"builders","apiPrologueForArray: aReturnType\r\n\t\" Private - Return the prologue to use to wrap an arrayed return.\r\n\tThe returned code will be like:\r\n\t\tGlobalName withAll: (\r\n\t\tGlobalName of: ElementClass withAll: (\r\n\t\tGlobalName of: 'Type1,Type2,Type3' withAll: (\r\n\t\"\r\n\r\n\t| type stream kind |\r\n\tstream := aReturnType stream.\r\n\ttype := self apiWrapperFor: (stream upTo: $[).\r\n\tkind := stream upTo: $].\r\n\tstream atEnd ifFalse: [ ^self error: 'Invalid brackets for array' ].\r\n\tkind isEmpty ifTrue: [ ^type ,' withAll: ('].\r\n\t(kind includes: $,) ifFalse: [\r\n\t\t^type ,' of: ' ,(self apiWrapperFor: kind) ,' withAll: ('\r\n\t].\t\r\n\t^type ,' of: ' ,kind printString ,' withAll: ('","(\r\nfunction(self,aReturnType)\r\nlocal type=nil\r\nlocal stream=nil\r\nlocal kind=nil\r\n(function()\r\n\tlocal _s8_value=((aReturnType):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):apiWrapperFor_((stream):upTo_(\"[\")))\r\n\ttype=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((stream):upTo_(\"]\"))\r\n\tkind=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((stream):atEnd()))==true then return ((self):error_(\"Invalid brackets for array\")); end;\r\nif ((kind):isEmpty())==true then return (smalltalk:object_comma_((type),\" withAll: (\")); end;\r\nif not (((kind):includes_(\",\")))==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type),\" of: \")),(self):apiWrapperFor_(kind))),\" withAll: (\")); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type),\" of: \")),smalltalk:printString_((kind)))),\" withAll: (\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apiPrologueForTuple:",0
,(
function(self,aReturnType)
local type=nil
local stream=nil
local kind=nil
(function()
	local _s8_value=((aReturnType):stream())
	stream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):apiWrapperFor_((stream):upTo_("<")))
	type=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((stream):upTo_(">"))
	kind=_s8_value
	return _s8_value
end)();
if not (((stream):atEnd()))==true then return ((self):error_("Invalid code for typle")); end;
if ((kind):isEmpty())==true then return ((self):error_("Empty types for tuple")); end;
if not (((kind):includes_(",")))==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type)," of: ")),(self):apiWrapperFor_(kind)))," with: (")); end;
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type)," of: ")),smalltalk:printString_((kind))))," with: ("));
end
)
,"builders","apiPrologueForTuple: aReturnType\r\n\t\" Private - Return the prologue to use to wrap a tuple return.\r\n\tThe returned code will be like:\r\n\t\tGlobalName of: 'Type1,Type2,Type3' with: (\r\n\t\"\r\n\r\n\t| type stream kind |\r\n\tstream := aReturnType stream.\r\n\ttype := self apiWrapperFor: (stream upTo: $<).\r\n\tkind := stream upTo: $>.\r\n\tstream atEnd ifFalse: [ ^self error: 'Invalid code for typle' ].\r\n\tkind isEmpty ifTrue:  [ ^self error: 'Empty types for tuple' ].\r\n\t(kind includes: $,) ifFalse: [\r\n\t\t^type ,' of: ' ,(self apiWrapperFor: kind) ,' with: ('\r\n\t].\t\r\n\t^type ,' of: ' ,kind printString ,' with: ('","(\r\nfunction(self,aReturnType)\r\nlocal type=nil\r\nlocal stream=nil\r\nlocal kind=nil\r\n(function()\r\n\tlocal _s8_value=((aReturnType):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):apiWrapperFor_((stream):upTo_(\"<\")))\r\n\ttype=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((stream):upTo_(\">\"))\r\n\tkind=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((stream):atEnd()))==true then return ((self):error_(\"Invalid code for typle\")); end;\r\nif ((kind):isEmpty())==true then return ((self):error_(\"Empty types for tuple\")); end;\r\nif not (((kind):includes_(\",\")))==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type),\" of: \")),(self):apiWrapperFor_(kind))),\" with: (\")); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type),\" of: \")),smalltalk:printString_((kind)))),\" with: (\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apiWrapperFor:",0
,(
function(self,aName)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(smalltalk.Smalltalk):at_ifAbsent_(aName,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):defaultAPIWrapperFor_(aName))
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (aName)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"builders","apiWrapperFor: aName\r\n\t\" Private - Return the name to use to wrap API structures of type aName. \"\r\n\r\n\tSmalltalk at: aName ifAbsent: [ ^self defaultAPIWrapperFor: aName ].\r\n\t^aName","(\r\nfunction(self,aName)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(smalltalk.Smalltalk):at_ifAbsent_(aName,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):defaultAPIWrapperFor_(aName))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (aName)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"defaultAPIWrapperFor:",0
,(
function(self,aName)
return (aName);
end
)
,"builders","defaultAPIWrapperFor: aName\r\n\t\" Private - Return the default name to use to wrap API structures of type aName.\r\n\tDefault implementation will defer lookup upto runtime.\r\n\t\"\r\n\r\n\t^aName","(\r\nfunction(self,aName)\r\nreturn (aName);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFunction:",0
,(
function(self,spec)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if ((spec):isArray())==true then if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),3)),(function()
return (((spec):last()):isString())
end)))==true then return ((self):buildFunction_((smalltalk.Array):with_with_((smalltalk.Array):with_with_((spec):first(),(spec):second()),(spec):last()))); end;
smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),2)),(function()
return (((spec):last()):isString())
end))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):buildFunction_prologue_epilogue_((spec):first(),(self):apiPrologueFor_((spec):second()),(self):apiEpilogueFor_((spec):second())))
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):buildFunction_prologue_epilogue_(spec,"^",""))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"builders","buildFunction: spec\r\n\t\" Private - Generate code from spec as functions on instance handle.\r\n\tspec can be:\r\n\t\taSymbol (e.g. any smalltalk message selector)\r\n\t\t#( selector #ReturnType )\r\n\t\t#( selector #( argumentNames ) #ReturnType )\r\n\t\t#( #( selector #( argumentNames ) ) #ReturnType )\r\n\t\t#( selector #( argumentNames ) )\r\n\targumentNames must match selector pattern\r\n\targumentNames can include kwargsStart to define keyword arguments\r\n\tif argumentNames is not given, it will be computed from selector pattern\r\n\tThe function will return the result of calling the handle, wrapped to a ReturnType\r\n\tSee implementation of #apiPrologueFor: for documentation on #ReturnType\r\n\t\"\r\n\r\n\tspec isArray ifTrue: [\r\n\t    (spec size = 3 and: [spec last isString]) ifTrue: [ \"#( selector #( argumentNames ) #ReturnType )\"\r\n\t\t^self buildFunction: (Array\r\n\t\t\twith: (Array with: spec first with: spec second)\r\n\t\t\twith: spec last)\r\n\t    ]. \r\n\t    (spec size = 2 and: [spec last isString]) ifTrue: [ \"#( selector #ReturnType )\"\r\n\t\t^self\r\n\t\t\tbuildFunction: spec first\r\n\t\t\tprologue: (self apiPrologueFor: spec second)\r\n\t\t\tepilogue: (self apiEpilogueFor: spec second)\r\n\t    ]. \r\n\t].\r\n\t^self buildFunction: spec prologue: $^ epilogue: ''","(\r\nfunction(self,spec)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif ((spec):isArray())==true then if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),3)),(function()\r\nreturn (((spec):last()):isString())\r\nend)))==true then return ((self):buildFunction_((smalltalk.Array):with_with_((smalltalk.Array):with_with_((spec):first(),(spec):second()),(spec):last()))); end;\r\nsmalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),2)),(function()\r\nreturn (((spec):last()):isString())\r\nend))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):buildFunction_prologue_epilogue_((spec):first(),(self):apiPrologueFor_((spec):second()),(self):apiEpilogueFor_((spec):second())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):buildFunction_prologue_epilogue_(spec,\"^\",\"\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFunction:prologue:epilogue:",0
,(
function(self,spec,prologue,epilogue)
local args=nil
if ((spec):isArray())==true then return ((self):buildFunction_arguments_prologue_epilogue_((spec):first(),(spec):last(),prologue,epilogue)); end;
(function()
	local _s8_value=(((1):to_((spec):occurrencesOf_(":"))):collect_((function(i)
return (smalltalk:object_comma_(("arg"),smalltalk:asString_((i))))
end)))
	args=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((args):size()),1))==true then (function()
	local _s8_value=(smalltalk:newArray({"anObject"}))
	args=_s8_value
	return _s8_value
end)(); end;
return ((self):buildFunction_arguments_prologue_epilogue_(spec,args,prologue,epilogue));
end
)
,"builders","buildFunction: spec prologue: prologue epilogue: epilogue \r\n\t\" Private - Generate code for spec to apply on instance handle. \"\r\n\r\n\t| args |\r\n\tspec isArray ifTrue: [ \"#( selector #(argumentNames) )\"\r\n\t\t^self\tbuildFunction: spec first arguments: spec last\r\n\t\t\tprologue: prologue epilogue: epilogue\r\n\t].\r\n\targs :=  (1 to: (spec occurrencesOf: $:)) collect: [:i| #arg , i asString ].\r\n\targs size = 1 ifTrue: [ args := #( #anObject ) ].\r\n\t^self\r\n\t\tbuildFunction: spec arguments: args\r\n\t\tprologue: prologue epilogue: epilogue  ","(\r\nfunction(self,spec,prologue,epilogue)\r\nlocal args=nil\r\nif ((spec):isArray())==true then return ((self):buildFunction_arguments_prologue_epilogue_((spec):first(),(spec):last(),prologue,epilogue)); end;\r\n(function()\r\n\tlocal _s8_value=(((1):to_((spec):occurrencesOf_(\":\"))):collect_((function(i)\r\nreturn (smalltalk:object_comma_((\"arg\"),smalltalk:asString_((i))))\r\nend)))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((args):size()),1))==true then (function()\r\n\tlocal _s8_value=(smalltalk:newArray({\"anObject\"}))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((self):buildFunction_arguments_prologue_epilogue_(spec,args,prologue,epilogue));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apiSelector:forArguments:",0
,(
function(self,callName,args)
local parts=nil
if (smalltalk:isObject_equalTo_(((args):size()),(callName):argumentCount()))==true then return (callName); end;
(function()
	local _s8_value=((callName):asArrayOfSubstringsSeparatedBy_(":"))
	parts=_s8_value
	return _s8_value
end)();
if (((parts):last()):isEmpty())==true then (parts):removeLast(); end;
(((parts):size()):_plus(1)):to_do_((args):size(),(function(i)
local argName=nil
(function()
	local _s8_value=((args):at_(i))
	argName=_s8_value
	return _s8_value
end)();if ((argName):isArray())==true then (function()
	local _s8_value=((argName):first())
	argName=_s8_value
	return _s8_value
end)(); end;return ((parts):add_((argName):asSmalltalkName_(false)))
end));
return ((parts):inject_into_("",(function(total,part)
return (smalltalk:object_comma_((smalltalk:object_comma_((total),part)),":"))
end)));
end
)
,"builders","apiSelector: callName forArguments: args\r\n\t\" Private - Return the api selector to implement a native call with arguments. \"\r\n\r\n\t| parts |\r\n\targs size = callName argumentCount ifTrue: [ ^callName ].\r\n\tparts := callName asArrayOfSubstringsSeparatedBy: $:.\r\n\tparts last isEmpty ifTrue: [ parts removeLast ].\r\n\tparts size + 1 to: args size do: [:i| | argName |\r\n\t\targName := args at: i.\r\n\t\targName isArray ifTrue: [ argName := argName first ].\r\n\t\tparts add: (argName asSmalltalkName: false)\r\n\t].\r\n\t^parts inject: '' into: [:total :part| total ,part ,$: ]","(\r\nfunction(self,callName,args)\r\nlocal parts=nil\r\nif (smalltalk:isObject_equalTo_(((args):size()),(callName):argumentCount()))==true then return (callName); end;\r\n(function()\r\n\tlocal _s8_value=((callName):asArrayOfSubstringsSeparatedBy_(\":\"))\r\n\tparts=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (((parts):last()):isEmpty())==true then (parts):removeLast(); end;\r\n(((parts):size()):_plus(1)):to_do_((args):size(),(function(i)\r\nlocal argName=nil\r\n(function()\r\n\tlocal _s8_value=((args):at_(i))\r\n\targName=_s8_value\r\n\treturn _s8_value\r\nend)();if ((argName):isArray())==true then (function()\r\n\tlocal _s8_value=((argName):first())\r\n\targName=_s8_value\r\n\treturn _s8_value\r\nend)(); end;return ((parts):add_((argName):asSmalltalkName_(false)))\r\nend));\r\nreturn ((parts):inject_into_(\"\",(function(total,part)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((total),part)),\":\"))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apiArgumentsFrom:",0
,(
function(self,array)
return (((self):apiSupportFor_(array)):nativeArgumentsFrom_(array));
end
)
,"api","apiArgumentsFrom: array\r\n\t\" Private - Return the arguments for API call. \"\r\n\r\n\t^(self apiSupportFor: array)\r\n\t\tnativeArgumentsFrom: array","(\r\nfunction(self,array)\r\nreturn (((self):apiSupportFor_(array)):nativeArgumentsFrom_(array));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"nativeArgumentsFrom:",0
,(
function(self,array)
local tag=nil
(function()
	local _s8_value=("_")
	tag=_s8_value
	return _s8_value
end)();
return ((array):collect_((function(each)
return (smalltalk:if_true_false_((smalltalk:boolean_and_(((each):isString()),(function()
return (smalltalk:isObject_equalTo_(((each):first()),tag))
end))),(function()
local varName=nil
(function()
	local _s8_value=((each):copyFrom_to_(2,(each):size()))
	varName=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((each):last()),tag)),(function()
return ((smalltalk.Array):with_with_((varName):copyFrom_to_(1,((varName):size()):_minus(1)),"handles"))
end),(function()
return ((smalltalk.Array):with_with_(varName,"json"))
end)))
end),(function()
return (each)
end)))
end)));
end
)
,"builders","nativeArgumentsFrom: array\r\n\t\" Private - Return the arguments for API call. \"\r\n\r\n\t| tag |\r\n\ttag := $_.\r\n\t^array collect: [:each|\r\n\t\t(each isString and: [ each first = tag ]) ifTrue: [ | varName |\r\n\t\t\tvarName := each copyFrom: 2 to: each size.\r\n\t\t\teach last = tag\r\n\t\t\tifTrue: [ Array with: (varName copyFrom: 1 to: varName size - 1) with: #handles ]\r\n\t\t\tifFalse: [ Array with: varName with: #json ]\r\n\t\t] ifFalse: [ each ]\r\n\t]","(\r\nfunction(self,array)\r\nlocal tag=nil\r\n(function()\r\n\tlocal _s8_value=(\"_\")\r\n\ttag=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((array):collect_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_(((each):isString()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((each):first()),tag))\r\nend))),(function()\r\nlocal varName=nil\r\n(function()\r\n\tlocal _s8_value=((each):copyFrom_to_(2,(each):size()))\r\n\tvarName=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((each):last()),tag)),(function()\r\nreturn ((smalltalk.Array):with_with_((varName):copyFrom_to_(1,((varName):size()):_minus(1)),\"handles\"))\r\nend),(function()\r\nreturn ((smalltalk.Array):with_with_(varName,\"json\"))\r\nend)))\r\nend),(function()\r\nreturn (each)\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apiSelectorAndFunctionName:forArguments:",0
,(
function(self,callName,args)
local msgSelector=nil
local apiSelector=nil
if not ((smalltalk:boolean_or_(((callName):isString()),(function()
return ((callName):isArray())
end))))==true then return ((self):error_("CallName must be aString or anArray")); end;
(function()
	local _s8_value=((self):apiSelector_forArguments_(smalltalk:if_true_false_(((callName):isString()),(function()
return ((self):apiMessage_for_(callName,args))
end),(function()
return ((self):apiMessage_for_((callName):first(),args))
end)),args))
	msgSelector=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):apiSelector_forArguments_(smalltalk:if_true_false_(((callName):isString()),(function()
return (callName)
end),(function()
return ((callName):last())
end)),args))
	apiSelector=_s8_value
	return _s8_value
end)();
return ((smalltalk.Array):with_with_(msgSelector,apiSelector));
end
)
,"builders","apiSelectorAndFunctionName: callName forArguments: args\r\n\t\" Private - Return the selector and api call to implement a native call with arguments. \"\r\n\r\n\t| msgSelector apiSelector |\r\n\t(callName isString or: [callName isArray]) ifFalse: [\r\n\t\t^self error: 'CallName must be aString or anArray'\r\n\t].\r\n\tmsgSelector := self apiSelector: (callName isString\r\n\t\tifTrue: [ self apiMessage: callName for: args ]\r\n\t\tifFalse: [ self apiMessage: callName first for: args ]) forArguments: args.\r\n\tapiSelector := self apiSelector: (callName isString\r\n\t\tifTrue: [ callName ] ifFalse: [ callName last ]) forArguments: args.\r\n\r\n\t^Array with: msgSelector with: apiSelector","(\r\nfunction(self,callName,args)\r\nlocal msgSelector=nil\r\nlocal apiSelector=nil\r\nif not ((smalltalk:boolean_or_(((callName):isString()),(function()\r\nreturn ((callName):isArray())\r\nend))))==true then return ((self):error_(\"CallName must be aString or anArray\")); end;\r\n(function()\r\n\tlocal _s8_value=((self):apiSelector_forArguments_(smalltalk:if_true_false_(((callName):isString()),(function()\r\nreturn ((self):apiMessage_for_(callName,args))\r\nend),(function()\r\nreturn ((self):apiMessage_for_((callName):first(),args))\r\nend)),args))\r\n\tmsgSelector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):apiSelector_forArguments_(smalltalk:if_true_false_(((callName):isString()),(function()\r\nreturn (callName)\r\nend),(function()\r\nreturn ((callName):last())\r\nend)),args))\r\n\tapiSelector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((smalltalk.Array):with_with_(msgSelector,apiSelector));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apiMessage:for:",0
,(
function(self,callName,args)
local result=nil
(function()
	local _s8_value=((callName):copyWithout_("!"))
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((self):nativeLanguage()),"lua"))==true then smalltalk:if_true_false_(((callName):startsWith_("_")),(function()
return ((function()
	local _s8_value=((callName):copyFrom_to_(2,(callName):size()))
	result=_s8_value
	return _s8_value
end)())
end),nil); end;
if ((((result):argumentCount()) > 0))==true then return (result); end;
return ((result):asLocalName());
end
)
,"builders","apiMessage: callName for: args\r\n\t\" Private - Return the message to implement for calling function callName.\r\n\tThe default action use the callName as local name.\r\n\tIt can be refined by subclasses to edit the name for better smalltalk looking of the message.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := callName copyWithout: $!.\r\n\tself nativeLanguage = #lua ifTrue: [\r\n\t\t(callName startsWith: $_) ifTrue: [ result := callName copyFrom: 2 to: callName size ].\r\n\t].\r\n\tresult argumentCount > 0 ifTrue: [ ^result ].\r\n\t^result asLocalName ","(\r\nfunction(self,callName,args)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((callName):copyWithout_(\"!\"))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((self):nativeLanguage()),\"lua\"))==true then smalltalk:if_true_false_(((callName):startsWith_(\"_\")),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=((callName):copyFrom_to_(2,(callName):size()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),nil); end;\r\nif ((((result):argumentCount()) > 0))==true then return (result); end;\r\nreturn ((result):asLocalName());\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apiEncode:call:args:on:header:",0
,(
function(self,delegate,aSelector,array,code,header)
local pair=nil
local args=nil
local msgStream=nil
local apiStream=nil
local argStream=nil
local msg=nil
local space=nil
(function()
	local _s8_value=((self):apiArgumentsFrom_(array))
	args=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):apiSelectorAndFunctionName_forArguments_(aSelector,args))
	pair=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((pair):first()):stream())
	msgStream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((((pair):first()):includes_(":")),(function()
return (": ")
end),(function()
return (" ")
end)))
	space=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((pair):last()):stream())
	apiStream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((args):stream())
	argStream=_s8_value
	return _s8_value
end)();
(code):nextPutAll_(delegate);
(code):nextPut_((apiStream):next());
(header):nextPut_((msgStream):next());
while not ((function()
return ((argStream):atEnd())
end))() do local param=nil
local expr=nil
if (((argStream):peek()):isString())==true then (function()
	local _s8_value=((argStream):next())
	param=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(param)
	expr=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=(((argStream):peek()):first())
	param=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((param)," ")),((argStream):next()):last()))
	expr=_s8_value
	return _s8_value
end)(); end;
(code):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((apiStream):upTo_(":")),": ")),expr))," "));
(header):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((msgStream):upTo_(":")),space)),param))," ")); end;
(code):nextPutAll_((apiStream):upToEnd());
(header):nextPutAll_((msgStream):upToEnd());
return (self);
end
)
,"builders","apiEncode: delegate\r\n\tcall: aSelector args: array\r\n\ton: code header: header\r\n\t\" Private - Generate code to call function onto code&header streams. \"\r\n\r\n\t| pair args msgStream apiStream argStream msg space |\r\n\targs := self apiArgumentsFrom: array.\r\n\tpair := self apiSelectorAndFunctionName: aSelector forArguments: args.\r\n\tmsgStream := pair first stream.\r\n\tspace := (pair first includes: $:) ifTrue: [ ': ' ] ifFalse: [ $ ].\r\n\tapiStream := pair last stream.\r\n\targStream := args stream.\r\n\r\n\tcode\tnextPutAll: delegate.\r\n\tcode\tnextPut: apiStream next.\r\n\theader\tnextPut: msgStream next.\r\n\r\n\t[ argStream atEnd ] whileFalse: [ | param expr |\r\n\t\targStream peek isString\r\n\t\tifTrue: [ param := argStream next. expr := param ]\r\n\t\tifFalse: [ param := argStream peek first. expr := param ,' ' ,argStream next last. ].\r\n\t\tcode nextPutAll: (apiStream upTo: $:) ,': ' ,expr ,' '.\r\n\t\theader nextPutAll: (msgStream upTo: $:) ,space ,param ,' '.\r\n\t].\r\n\r\n\tcode   nextPutAll: apiStream upToEnd.\r\n\theader nextPutAll: msgStream upToEnd.","(\r\nfunction(self,delegate,aSelector,array,code,header)\r\nlocal pair=nil\r\nlocal args=nil\r\nlocal msgStream=nil\r\nlocal apiStream=nil\r\nlocal argStream=nil\r\nlocal msg=nil\r\nlocal space=nil\r\n(function()\r\n\tlocal _s8_value=((self):apiArgumentsFrom_(array))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):apiSelectorAndFunctionName_forArguments_(aSelector,args))\r\n\tpair=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((pair):first()):stream())\r\n\tmsgStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((((pair):first()):includes_(\":\")),(function()\r\nreturn (\": \")\r\nend),(function()\r\nreturn (\" \")\r\nend)))\r\n\tspace=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((pair):last()):stream())\r\n\tapiStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((args):stream())\r\n\targStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(code):nextPutAll_(delegate);\r\n(code):nextPut_((apiStream):next());\r\n(header):nextPut_((msgStream):next());\r\nwhile not ((function()\r\nreturn ((argStream):atEnd())\r\nend))() do local param=nil\r\nlocal expr=nil\r\nif (((argStream):peek()):isString())==true then (function()\r\n\tlocal _s8_value=((argStream):next())\r\n\tparam=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(param)\r\n\texpr=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=(((argStream):peek()):first())\r\n\tparam=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((param),\" \")),((argStream):next()):last()))\r\n\texpr=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(code):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((apiStream):upTo_(\":\")),\": \")),expr)),\" \"));\r\n(header):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((msgStream):upTo_(\":\")),space)),param)),\" \")); end;\r\n(code):nextPutAll_((apiStream):upToEnd());\r\n(header):nextPutAll_((msgStream):upToEnd());\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apiEncode:call:args:kwargs:on:header:",0
,(
function(self,delegate,aSelector,array,kwarray,code,header)
local pair=nil
local args=nil
local kwargs=nil
local msgStream=nil
local argStream=nil
local msg=nil
local space=nil
(function()
	local _s8_value=((self):apiArgumentsFrom_(array))
	args=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):apiArgumentsFrom_(kwarray))
	kwargs=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):apiSelectorAndFunctionName_forArguments_(aSelector,smalltalk:object_comma_((args),kwargs)))
	pair=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((pair):first()):stream())
	msgStream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((((pair):first()):includes_(":")),(function()
return (": ")
end),(function()
return (" ")
end)))
	space=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk:object_comma_((args),kwargs)):stream())
	argStream=_s8_value
	return _s8_value
end)();
(header):nextPut_((msgStream):next());
while not ((function()
return ((argStream):atEnd())
end))() do local param=nil
if (((argStream):peek()):isString())==true then (function()
	local _s8_value=((argStream):next())
	param=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=(((argStream):next()):first())
	param=_s8_value
	return _s8_value
end)(); end;
(header):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((msgStream):upTo_(":")),space)),param))," ")); end;
(header):nextPutAll_((msgStream):upToEnd());
(code):nextPut_("(");
(code):nextPutAll_((self):apikw_call_args_kwargs_header_(delegate,(pair):last(),args,kwargs,header));
(code):nextPut_(")");
return (self);
end
)
,"builders","apiEncode: delegate\r\n\tcall: aSelector args: array kwargs: kwarray\r\n\ton: code header: header\r\n\t\" Private - Generate code to call function onto code&header streams. \"\r\n\r\n\t| pair args kwargs msgStream argStream msg space |\r\n\targs := self apiArgumentsFrom: array.\r\n\tkwargs := self apiArgumentsFrom: kwarray.\r\n\tpair := self apiSelectorAndFunctionName: aSelector forArguments: args ,kwargs.\r\n\tmsgStream := pair first stream.\r\n\tspace := (pair first includes: $:) ifTrue: [ ': ' ] ifFalse: [ $ ].\r\n\targStream := (args ,kwargs) stream.\r\n\r\n\theader\tnextPut: msgStream next.\r\n\t[ argStream atEnd ] whileFalse: [ | param |\r\n\t\targStream peek isString\r\n\t\tifTrue: [ param := argStream next ]\r\n\t\tifFalse: [ param := argStream next first ].\r\n\t\theader nextPutAll: (msgStream upTo: $:) ,space ,param ,' '.\r\n\t].\r\n\theader nextPutAll: msgStream upToEnd.\r\n\r\n\tcode nextPut: $(.\r\n\tcode nextPutAll: (self\r\n\t\tapikw: delegate call: pair last\r\n\t\targs: args kwargs: kwargs\r\n\t\theader: header).\r\n\tcode nextPut: $).","(\r\nfunction(self,delegate,aSelector,array,kwarray,code,header)\r\nlocal pair=nil\r\nlocal args=nil\r\nlocal kwargs=nil\r\nlocal msgStream=nil\r\nlocal argStream=nil\r\nlocal msg=nil\r\nlocal space=nil\r\n(function()\r\n\tlocal _s8_value=((self):apiArgumentsFrom_(array))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):apiArgumentsFrom_(kwarray))\r\n\tkwargs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):apiSelectorAndFunctionName_forArguments_(aSelector,smalltalk:object_comma_((args),kwargs)))\r\n\tpair=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((pair):first()):stream())\r\n\tmsgStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((((pair):first()):includes_(\":\")),(function()\r\nreturn (\": \")\r\nend),(function()\r\nreturn (\" \")\r\nend)))\r\n\tspace=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk:object_comma_((args),kwargs)):stream())\r\n\targStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(header):nextPut_((msgStream):next());\r\nwhile not ((function()\r\nreturn ((argStream):atEnd())\r\nend))() do local param=nil\r\nif (((argStream):peek()):isString())==true then (function()\r\n\tlocal _s8_value=((argStream):next())\r\n\tparam=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=(((argStream):next()):first())\r\n\tparam=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(header):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((msgStream):upTo_(\":\")),space)),param)),\" \")); end;\r\n(header):nextPutAll_((msgStream):upToEnd());\r\n(code):nextPut_(\"(\");\r\n(code):nextPutAll_((self):apikw_call_args_kwargs_header_(delegate,(pair):last(),args,kwargs,header));\r\n(code):nextPut_(\")\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apikw:call:args:kwargs:header:",0
,(
function(self,delegate,aSelector,array,kwarray,header)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local callArgs=nil
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("self call: "),(self):apikw_delegate_(aSelector,delegate))),"\r\n\targs: ")),(self):apikwArguments_named_(array,false)))
	callArgs=_s8_value
	return _s8_value
end)();
if ((kwarray):isEmpty())==true then smalltalk:if_true_false_(((aSelector):includes_("!")),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((callArgs)," kwargs: nil"))
end
)()
error(_s8Ret_,0)
end)())
end),(function()
if ((array):notEmpty())==true then (header):nextPutAll_("kwargs"); end;(header):nextPutAll_(": kwargs");return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((callArgs)," kwargs: kwargs"))
end
)()
error(_s8Ret_,0)
end)())
end)); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((smalltalk:object_comma_((callArgs)," kwargs: ")),(self):apikwArguments_named_(kwarray,true)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"builders","apikw: delegate call: aSelector args: array kwargs: kwarray header: header\r\n\t\" Private - Returns the code for a keyword function call. \"\r\n\r\n\t| callArgs |\r\n\tcallArgs := 'self call: ' ,(self apikw: aSelector delegate: delegate) ,'\r\n\targs: '     ,(self apikwArguments: array named: false).\r\n\tkwarray isEmpty ifTrue: [\r\n\t\t(aSelector includes: $!)\r\n\t\tifTrue: [ ^callArgs ,' kwargs: nil' ]\r\n\t\tifFalse: [\r\n\t\t\tarray notEmpty ifTrue: [ header nextPutAll: #kwargs ].\r\n\t\t\theader nextPutAll: ': kwargs'.\r\n\t\t\t^callArgs ,' kwargs: kwargs'\r\n\t\t]\r\n\t].\r\n\t^callArgs ,' kwargs: ' ,(self apikwArguments: kwarray named: true)","(\r\nfunction(self,delegate,aSelector,array,kwarray,header)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal callArgs=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"self call: \"),(self):apikw_delegate_(aSelector,delegate))),\"\\r\\n\\targs: \")),(self):apikwArguments_named_(array,false)))\r\n\tcallArgs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((kwarray):isEmpty())==true then smalltalk:if_true_false_(((aSelector):includes_(\"!\")),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((callArgs),\" kwargs: nil\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),(function()\r\nif ((array):notEmpty())==true then (header):nextPutAll_(\"kwargs\"); end;(header):nextPutAll_(\": kwargs\");return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((callArgs),\" kwargs: kwargs\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((callArgs),\" kwargs: \")),(self):apikwArguments_named_(kwarray,true)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apikw:delegate:",0
,(
function(self,aSelector,delegate)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("("),(delegate):upTo_("#"))),"basicAt: ")),((aSelector):upTo_(":")):asLiteral())),")"));
end
)
,"builders","apikw: aSelector delegate: delegate\r\n\t\" Private - Returns the code to access a keyword function. \"\r\n\r\n\t^$(\r\n\t,(delegate upTo: $#)\r\n\t,'basicAt: '\t,(aSelector upTo: #:) asLiteral\r\n\t,$)","(\r\nfunction(self,aSelector,delegate)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"(\"),(delegate):upTo_(\"#\"))),\"basicAt: \")),((aSelector):upTo_(\":\")):asLiteral())),\")\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"kwargsStart",0
,(
function(self)
return ("|");
end
)
,"builders","kwargsStart\r\n\t\" Private - Returns the tag used for keyword arguments. \"\r\n\r\n\t^#|","(\r\nfunction(self)\r\nreturn (\"|\");\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apikwArguments:named:",0
,(
function(self,array,named)
local element=nil
(function()
	local _s8_value=((function(arg)
local kw=nil
local v=nil
if ((arg):isArray())==true then (function()
	local _s8_value=((arg):first())
	kw=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((arg):first())," ")),(arg):last()))
	v=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=((function()
	local _s8_value=(arg)
	v=_s8_value
	return _s8_value
end)())
	kw=_s8_value
	return _s8_value
end)(); end;return (smalltalk:if_true_false_((named),(function()
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("(Array with: "),(kw):asLiteral()))," with: ")),v)),")"))
end),(function()
return (v)
end)))
end))
	element=_s8_value
	return _s8_value
end)();
if ((array):isEmpty())==true then return ("#()"); end;
if ((((array):size()) <= 3))==true then return (smalltalk:object_comma_(((array):inject_into_(smalltalk:object_comma_(("("),"Array"),(function(total,each)
return (smalltalk:object_comma_((smalltalk:object_comma_((total)," with: ")),(element):value_(each)))
end))),")")); end;
return (smalltalk:object_comma_((smalltalk:object_comma_(("(Array new"),(array):inject_into_("",(function(total,each)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total)," add: ")),(element):value_(each))),";"))
end))))," yourself)"));
end
)
,"builders","apikwArguments: array named: named\r\n\t\" Private - Returns the code to pass arguments to kw function call. \"\r\n\r\n\t| element |\r\n\telement := [:arg| | kw v |\r\n\t\targ isArray\r\n\t\tifTrue: [ kw := arg first. v := arg first ,' ',arg last ]\r\n\t\tifFalse: [ kw := v := arg ].\r\n\t\tnamed ifTrue: ['(Array with: ' ,kw asLiteral,' with: ' ,v ,$) ]\r\n\t\tifFalse: [ v ]\r\n\t].\r\n\tarray isEmpty ifTrue: [ ^'#()'].\r\n\tarray size <= 3 ifTrue: [\r\n\t\t^(array inject: $( ,#Array into: [:total :each|\r\n\t\t\ttotal,' with: ',(element value: each)\r\n\t\t]) ,$)\r\n\t].\r\n\t^'(Array new'\r\n\t,(array inject: '' into: [:total :each|\r\n\t\ttotal,' add: ',(element value: each) ,$;\r\n\t]) ,' yourself)' ","(\r\nfunction(self,array,named)\r\nlocal element=nil\r\n(function()\r\n\tlocal _s8_value=((function(arg)\r\nlocal kw=nil\r\nlocal v=nil\r\nif ((arg):isArray())==true then (function()\r\n\tlocal _s8_value=((arg):first())\r\n\tkw=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((arg):first()),\" \")),(arg):last()))\r\n\tv=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=((function()\r\n\tlocal _s8_value=(arg)\r\n\tv=_s8_value\r\n\treturn _s8_value\r\nend)())\r\n\tkw=_s8_value\r\n\treturn _s8_value\r\nend)(); end;return (smalltalk:if_true_false_((named),(function()\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"(Array with: \"),(kw):asLiteral())),\" with: \")),v)),\")\"))\r\nend),(function()\r\nreturn (v)\r\nend)))\r\nend))\r\n\telement=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((array):isEmpty())==true then return (\"#()\"); end;\r\nif ((((array):size()) <= 3))==true then return (smalltalk:object_comma_(((array):inject_into_(smalltalk:object_comma_((\"(\"),\"Array\"),(function(total,each)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((total),\" with: \")),(element):value_(each)))\r\nend))),\")\")); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"(Array new\"),(array):inject_into_(\"\",(function(total,each)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),\" add: \")),(element):value_(each))),\";\"))\r\nend)))),\" yourself)\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"apiEncode:call:arguments:on:header:",0
,(
function(self,delegate,aSelector,array,code,header)
if (smalltalk:boolean_or_(((aSelector):includes_("!")),(function()
return ((array):includes_((self):kwargsStart()))
end)))==true then local stream=nil
(function()
	local _s8_value=((array):readStream())
	stream=_s8_value
	return _s8_value
end)();
return ((self):apiEncode_call_args_kwargs_on_header_(delegate,aSelector,(stream):upTo_((self):kwargsStart()),(stream):upToEnd(),code,header)); end;
return ((self):apiEncode_call_args_on_header_(delegate,aSelector,array,code,header));
end
)
,"builders","apiEncode: delegate\r\n\tcall: aSelector arguments: array\r\n\ton: code header: header\r\n\t\" Private - Generate code to call function onto code&header streams. \"\r\n\r\n\t((aSelector includes: $!) or: [array includes: self kwargsStart]) ifTrue: [\r\n\t\t| stream | stream := array readStream.\r\n\t\t^self\tapiEncode: delegate call: aSelector\r\n\t\t\targs: (stream upTo: self kwargsStart) kwargs: stream upToEnd\r\n\t\t\ton: code header: header\r\n\t].\r\n\t^self\tapiEncode: delegate\r\n\t\tcall: aSelector args: array\r\n\t\ton: code header: header","(\r\nfunction(self,delegate,aSelector,array,code,header)\r\nif (smalltalk:boolean_or_(((aSelector):includes_(\"!\")),(function()\r\nreturn ((array):includes_((self):kwargsStart()))\r\nend)))==true then local stream=nil\r\n(function()\r\n\tlocal _s8_value=((array):readStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):apiEncode_call_args_kwargs_on_header_(delegate,aSelector,(stream):upTo_((self):kwargsStart()),(stream):upToEnd(),code,header)); end;\r\nreturn ((self):apiEncode_call_args_on_header_(delegate,aSelector,array,code,header));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"codeForInstanceReceiver",0
,(
function(self)
return ("self handle #");
end
)
,"private","codeForInstanceReceiver\r\n\t\" Private - Return the code for the receiver of instance function call.\r\n\tDefault answer asumes a wrapper calling with syntax sugar.\r\n\tThis method can be refined to adapt to custom platform calls.\r\n\t\"\r\n\r\n\t^'self handle #'","(\r\nfunction(self)\r\nreturn (\"self handle #\");\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFunction:arguments:prologue:epilogue:",0
,(
function(self,spec,args,prologue,epilogue)
local header=nil
local code=nil
if ((args):includes_((self):kwargsStart()))==true then local array=nil
(function()
	local _s8_value=(((args):stream()):upTo_((self):kwargsStart()))
	array=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((args):last()),(self):kwargsStart())),(function()
return ((self):buildFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))
end),(function()
(array):add_((self):kwargsStart());return ((self):buildFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))
end)); end;
(function()
	local _s8_value=((""):writeStream())
	header=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((""):writeStream())
	code=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):apiEncode_call_arguments_on_header_((self):codeForInstanceReceiver(),spec,args,code,header);
	return ((_s8_rec):implement_comment_as_category_((self):stMessageHeader_((header):contents()),"Delegate to handle.",(smalltalk:object_comma_((smalltalk:object_comma_((prologue),(code):contents())),epilogue)):replace_with_("!",smalltalk:object_comma_(("!"),"!")),"wrappers"))
end
)(self);
return (self);
end
)
,"builders","buildFunction: spec arguments: args prologue: prologue epilogue: epilogue \r\n\t\" Private - Generate code to delegate message on instance handle. \"\r\n\r\n\t| header code |\r\n\t(args includes: self kwargsStart) ifTrue: [ | array |\r\n\t\tarray := args stream upTo: self kwargsStart.\r\n\t\targs last = self kwargsStart\r\n\t\tifTrue: [ self\tbuildFunction: spec arguments: array\r\n\t\t\t\tprologue: prologue epilogue: epilogue ]\r\n\t\tifFalse: [\r\n\t\t\tarray add: self kwargsStart.\r\n\t\t\tself\tbuildFunction: spec arguments: array\r\n\t\t\t\tprologue: prologue epilogue: epilogue \r\n\t\t].\r\n\t].\r\n\theader := '' writeStream. code := '' writeStream.\r\n\tself\r\n\t  apiEncode: self codeForInstanceReceiver\r\n\t\tcall: spec arguments: args\r\n\t\ton: code header: header;\r\n\t  implement: (self stMessageHeader: header contents)\r\n\t\tcomment: 'Delegate to handle.'\r\n\t\tas:\t((prologue\r\n\t\t\t, code contents\r\n\t\t\t, epilogue) replace: $! with: $! ,$!)\r\n\t\tcategory: #wrappers","(\r\nfunction(self,spec,args,prologue,epilogue)\r\nlocal header=nil\r\nlocal code=nil\r\nif ((args):includes_((self):kwargsStart()))==true then local array=nil\r\n(function()\r\n\tlocal _s8_value=(((args):stream()):upTo_((self):kwargsStart()))\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:isObject_equalTo_(((args):last()),(self):kwargsStart())),(function()\r\nreturn ((self):buildFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))\r\nend),(function()\r\n(array):add_((self):kwargsStart());return ((self):buildFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))\r\nend)); end;\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\theader=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):apiEncode_call_arguments_on_header_((self):codeForInstanceReceiver(),spec,args,code,header);\r\n\treturn ((_s8_rec):implement_comment_as_category_((self):stMessageHeader_((header):contents()),\"Delegate to handle.\",(smalltalk:object_comma_((smalltalk:object_comma_((prologue),(code):contents())),epilogue)):replace_with_(\"!\",smalltalk:object_comma_((\"!\"),\"!\")),\"wrappers\"))\r\nend\r\n)(self);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"codeForStaticReceiver",0
,(
function(self)
return ("self nativeClass handle #");
end
)
,"private","codeForStaticReceiver\r\n\t\" Private - Return the code for the receiver of static function call.\r\n\tDefault answer asumes a nativeClass wrapper calling with syntax sugar.\r\n\tThis method can be refined to adapt to custom platform calls.\r\n\t\"\r\n\r\n\t^'self nativeClass handle #'","(\r\nfunction(self)\r\nreturn (\"self nativeClass handle #\");\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"nativeClass",0
,(
function(self)
return ((self):implementedBySubclass_("nativeClass"));
end
)
,"private","nativeClass\r\n\t\" Private - Return the wrapper for native binding of the receiver. \"\r\n\r\n\t^self implementedBySubclass: #nativeClass","(\r\nfunction(self)\r\nreturn ((self):implementedBySubclass_(\"nativeClass\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildConstants",0
,(
function(self)
return ((self):buildConstants_((self):constants()));
end
)
,"builders","buildConstants\r\n\t\" Build the methods for constants defined in the receiver's library. \"\r\n\r\n\t^self buildConstants: self constants","(\r\nfunction(self)\r\nreturn ((self):buildConstants_((self):constants()));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildConstants:",0
,(
function(self,constants)
return ((self):build_doing_(("Constants"):_minus_gt(constants),(function()
return (smalltalk:if_true_false_(((constants):isString()),(function()
local stream=nil
(function()
	local _s8_value=((constants):stream())
	stream=_s8_value
	return _s8_value
end)();return (smalltalk:whileNot_do_(((function()
return ((stream):atEnd())
end)),(function()
return ((self):buildConstant_(((stream):nextLine()):trimBlanks()))
end)))
end),(function()
return ((constants):do_((function(each)
return ((self):buildConstant_(each))
end)))
end)))
end)));
end
)
,"builders","buildConstants: constants\r\n\t\" Build the methods for constants. \"\r\n\r\n\t^self build: #Constants -> constants doing: [\r\n\t\tconstants isString ifTrue: [ | stream |\r\n\t\t\tstream := constants stream.\r\n\t\t\t[stream atEnd] whileFalse: [\r\n\t\t\t\tself buildConstant: stream nextLine trimBlanks\r\n\t\t\t]\r\n\t\t] ifFalse: [ constants do: [:each| self buildConstant: each ] ]\r\n\t]","(\r\nfunction(self,constants)\r\nreturn ((self):build_doing_((\"Constants\"):_minus_gt(constants),(function()\r\nreturn (smalltalk:if_true_false_(((constants):isString()),(function()\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((constants):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:whileNot_do_(((function()\r\nreturn ((stream):atEnd())\r\nend)),(function()\r\nreturn ((self):buildConstant_(((stream):nextLine()):trimBlanks()))\r\nend)))\r\nend),(function()\r\nreturn ((constants):do_((function(each)\r\nreturn ((self):buildConstant_(each))\r\nend)))\r\nend)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildConstant:",0
,(
function(self,spec)
local selector=nil
if ((spec):isEmpty())==true then return (self); end;
(function()
	local _s8_value=(((spec):fromLast_(".")):asSmalltalkName_(false))
	selector=_s8_value
	return _s8_value
end)();
((self)["$klass"]):implement_comment_as_category_(selector,smalltalk:object_comma_(("Return the constant value for "),spec),smalltalk:object_comma_(("^"),(self):codeToGetConstant_(spec)),"constants");
return (self);
end
)
,"builders","buildConstant: spec\r\n\t\" Private - Build the accessor for constant spec. \"\r\n\r\n\t| selector |\r\n\tspec isEmpty ifTrue: [ ^self ].\r\n\tselector := (spec fromLast: $.) asSmalltalkName: false.\r\n\tself class\r\n\t\timplement: selector\r\n\t\tcomment: 'Return the constant value for ' ,spec\r\n\t\tas: $^ ,(self codeToGetConstant: spec) category: #constants","(\r\nfunction(self,spec)\r\nlocal selector=nil\r\nif ((spec):isEmpty())==true then return (self); end;\r\n(function()\r\n\tlocal _s8_value=(((spec):fromLast_(\".\")):asSmalltalkName_(false))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self)[\"$klass\"]):implement_comment_as_category_(selector,smalltalk:object_comma_((\"Return the constant value for \"),spec),smalltalk:object_comma_((\"^\"),(self):codeToGetConstant_(spec)),\"constants\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"library",0
,(
function(self)
return ((self):new());
end
)
,"private","library\r\n\t\" Private - Returns the library of the receiver.\r\n\tA new instance is returned by default.\r\n\tThis method can be refined by subclasses (e.g. implementing singleton). \"\r\n\r\n\t^self new ","(\r\nfunction(self)\r\nreturn ((self):new());\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"codeToGetConstant:",0
,(
function(self,spec)
if ((spec):isArray())==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((spec):last())," @ (")),(self):codeToGetConstant_((spec):first()))),")")); end;
return (smalltalk:object_comma_(("self library @ "),(spec):asLiteral()));
end
)
,"builders","codeToGetConstant: spec\r\n\t\" Private - Returns the code to get the constant value for spec. \"\r\n\r\n\tspec isArray ifTrue: [\r\n\t\t^spec last ,' @ (' ,(self codeToGetConstant: spec first) ,$)\r\n\t].\r\n\t^'self library @ ' ,spec asLiteral ","(\r\nfunction(self,spec)\r\nif ((spec):isArray())==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((spec):last()),\" @ (\")),(self):codeToGetConstant_((spec):first()))),\")\")); end;\r\nreturn (smalltalk:object_comma_((\"self library @ \"),(spec):asLiteral()));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"constants",0
,(
function(self)
return ((self):constantsIn_((self):library()));
end
)
,"builders","constants\r\n\t\" Returns the constants implemented by receiver's library. \"\r\n\r\n\t^self constantsIn: self library","(\r\nfunction(self)\r\nreturn ((self):constantsIn_((self):library()));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"constantsIn:",0
,(
function(self,aNativeObject)
return (((((aNativeObject):keys()):select_((function(key)
return ((smalltalk:newArray({"Number", "String"})):includes_((self):typeOf_((aNativeObject):_at(key))))
end))):reject_((function(key)
return ((key):startsWith_("_"))
end))):sorted());
end
)
,"builders","constantsIn: aNativeObject\r\n\t\" Returns the constants implemented by aNativeObject. \"\r\n\r\n\t^((aNativeObject keys\r\n\t\tselect: [:key| #(Number String) includes: (self typeOf: aNativeObject@key) ])\r\n\t\treject: [:key| key startsWith: $_ ]) sorted","(\r\nfunction(self,aNativeObject)\r\nreturn (((((aNativeObject):keys()):select_((function(key)\r\nreturn ((smalltalk:newArray({\"Number\", \"String\"})):includes_((self):typeOf_((aNativeObject):_at(key))))\r\nend))):reject_((function(key)\r\nreturn ((key):startsWith_(\"_\"))\r\nend))):sorted());\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"newInstanceOf:withAll:",0
,(
function(self,aName,handlesArray)
local fn=nil
(function()
	local _s8_value=((self):instantiatorFor_(aName))
	fn=_s8_value
	return _s8_value
end)();

return ((fn):evaluateWithArguments_(handlesArray));
end
)
,"api","newInstanceOf: aName withAll: handlesArray\r\n\t\" Private - Returns the handle result of instatiating native object of type aName. \"\r\n\r\n\t| fn |\r\n\tfn := self instantiatorFor: aName.\r\n\t{'self'}.\r\n\t^fn evaluateWithArguments: handlesArray","(\r\nfunction(self,aName,handlesArray)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):instantiatorFor_(aName))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\nreturn ((fn):evaluateWithArguments_(handlesArray));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"instantiatorFor:",0
,(
function(self,aName)
return (((self):library()):_at(aName));
end
)
,"api","instantiatorFor: aName\r\n\t\" Private - Returns the function to evaluate when creating native instance. \"\r\n\r\n\t^self library @ aName","(\r\nfunction(self,aName)\r\nreturn (((self):library()):_at(aName));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"instantiate:withAll:",0
,(
function(self,aNativeObjectClass,handlesArray)
return ((aNativeObjectClass):_at((self):newInstanceOf_withAll_((aNativeObjectClass):name(),handlesArray)));
end
)
,"api","instantiate: aNativeObjectClass withAll: handlesArray\r\n\t\" Returns the result of instatiating aCVObjectClass. \"\r\n\r\n\t^aNativeObjectClass @ (self\r\n\t\tnewInstanceOf: aNativeObjectClass name\r\n\t\twithAll: handlesArray)","(\r\nfunction(self,aNativeObjectClass,handlesArray)\r\nreturn ((aNativeObjectClass):_at((self):newInstanceOf_withAll_((aNativeObjectClass):name(),handlesArray)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSubclasses:in:",0
,(
function(self,classNames,packageName)
return ((self):buildSubclasses_in_reference_(classNames,packageName,nil));
end
)
,"builders","buildSubclasses: classNames in: packageName\r\n\t\" Private - Generate subclasses of the receiver. \"\r\n\r\n\t^self buildSubclasses: classNames in: packageName reference: nil","(\r\nfunction(self,classNames,packageName)\r\nreturn ((self):buildSubclasses_in_reference_(classNames,packageName,nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSubclasses:in:reference:",0
,(
function(self,classSpecs,packageName,urlSite)
(classSpecs):do_((function(spec)
return ((self):buildSubclass_in_reference_(spec,packageName,urlSite))
end));
return (self);
end
)
,"builders","buildSubclasses: classSpecs in: packageName reference: urlSite\r\n\t\" Private - Generate subclasses of the receiver. \"\r\n\r\n\tclassSpecs do: [:spec|\r\n\t\tself buildSubclass: spec in: packageName reference: urlSite\r\n\t]","(\r\nfunction(self,classSpecs,packageName,urlSite)\r\n(classSpecs):do_((function(spec)\r\nreturn ((self):buildSubclass_in_reference_(spec,packageName,urlSite))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSubclass:in:",0
,(
function(self,spec,packageName)
return ((self):buildSubclass_in_reference_(spec,packageName,nil));
end
)
,"builders","buildSubclass: spec in: packageName\r\n\t\" Private - Generate a subclass of the receiver. \"\r\n\r\n\t^self buildSubclass: spec in: packageName reference: nil","(\r\nfunction(self,spec,packageName)\r\nreturn ((self):buildSubclass_in_reference_(spec,packageName,nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"urlReference",0
,(
function(self)
return ("none");
end
)
,"builders","urlReference\r\n\t\" Private - Returns the URL of package site. \"\r\n\r\n\t^#none ","(\r\nfunction(self)\r\nreturn (\"none\");\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"urlSelector",0
,(
function(self)
return (nil);
end
)
,"builders","urlSelector\r\n\t\" Private - Returns the selector for urlSite. \"\r\n\r\n\t^nil ","(\r\nfunction(self)\r\nreturn (nil);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"urlSelectors",0
,(
function(self)
return ((smalltalk.Array):with_((self):urlSelector()));
end
)
,"builders","urlSelectors\r\n\t\" Private - Returns the selector for urlSite. \"\r\n\r\n\t^Array with: self urlSelector ","(\r\nfunction(self)\r\nreturn ((smalltalk.Array):with_((self):urlSelector()));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"referenceTo:in:at:",0
,(
function(self,topic,packageName,urlSite)
if (smalltalk:isObject_equalTo_((urlSite),(self):urlSelector()))==true then return ((self):referenceTo_in_at_(topic,packageName,(self):urlReference())); end;
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((urlSite),"/")),smalltalk:if_true_false_((smalltalk:notNil_((packageName))),(function()
return (smalltalk:object_comma_(((packageName):replace_with_(".","/")),"/"))
end),(function()
return ("")
end)))),topic)),".html"));
end
)
,"builders","referenceTo: topic in: packageName at: urlSite\r\n\t\" Private - Returns the URL to find documentation on topic. \"\r\n\r\n\turlSite = self urlSelector ifTrue: [\r\n\t\t^self\treferenceTo: topic in: packageName\r\n\t\t\tat: self urlReference\r\n\t].\r\n\t^urlSite ,$/\r\n\t\t,(packageName notNil ifTrue: [ (packageName replace: $. with: $/) ,$/ ] ifFalse: [''])\r\n\t\t,topic ,'.html'","(\r\nfunction(self,topic,packageName,urlSite)\r\nif (smalltalk:isObject_equalTo_((urlSite),(self):urlSelector()))==true then return ((self):referenceTo_in_at_(topic,packageName,(self):urlReference())); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((urlSite),\"/\")),smalltalk:if_true_false_((smalltalk:notNil_((packageName))),(function()\r\nreturn (smalltalk:object_comma_(((packageName):replace_with_(\".\",\"/\")),\"/\"))\r\nend),(function()\r\nreturn (\"\")\r\nend)))),topic)),\".html\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSubclass:in:reference:",0
,(
function(self,spec,packageName,urlSite)
local cls=nil
local className=nil
if not (((spec):isString()))==true then (function()
	local _s8_value=((spec):first())
	cls=_s8_value
	return _s8_value
end)();
if ((cls):isString())==true then (function()
	local _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(cls,(function()
return ((self):buildSubclass_in_reference_(cls,packageName,urlSite))
end)))
	cls=_s8_value
	return _s8_value
end)(); else (self):error_(smalltalk:object_comma_(("Invalid superClass name: "),cls)); end;
return (((spec):copyFrom_to_(2,(spec):size())):collect_((function(each)
return ((cls):buildSubclass_in_reference_(each,packageName,urlSite))
end))); end;
(function()
	local _s8_value=(spec)
	className=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((packageName))),(function()
return ((self):subclass_category_(className,packageName))
end),(function()
return ((self):subclass_(className))
end)))
	cls=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_and_((smalltalk:isNil_((urlSite))),(function()
return (smalltalk:boolean_and_((smalltalk:notNil_((packageName))),(function()
return (((self):urlSelectors()):includes_((packageName):upTo_(".")))
end)))
end)))==true then (function()
	local _s8_value=((self):urlSelector())
	urlSite=_s8_value
	return _s8_value
end)(); end;
if (smalltalk:boolean_and_((smalltalk:notNil_((urlSite))),(function()
return ((not smalltalk:isObject_equalTo_((urlSite),"none")))
end)))==true then (cls):comment_(smalltalk:object_comma_(("See "),(self):referenceTo_in_at_(className,packageName,urlSite))); end;
if (smalltalk:responds_to_((cls),("packagePrefix:")))==true then (cls):packagePrefix_(packageName); end;
return (cls);
end
)
,"builders","buildSubclass: spec in: packageName reference: urlSite\r\n\t\" Private - Generate a subclass of the receiver. \"\r\n\r\n\t| cls className |\r\n\tspec isString ifFalse: [ \"spec can be #(superClassName className...) \"\r\n\t\tcls := spec first.\r\n\t\tcls isString ifTrue: [\r\n\t\t\tcls := Smalltalk at: cls ifAbsent: [\r\n\t\t\t\tself buildSubclass: cls in: packageName reference: urlSite\r\n\t\t\t]\r\n\t\t] ifFalse: [ self error: 'Invalid superClass name: ',cls ].\r\n\t\t^(spec copyFrom: 2 to: spec size) collect: [:each|\r\n\t\t\tcls buildSubclass: each in: packageName reference: urlSite\r\n\t\t]\r\n\t].\r\n\tclassName := spec.\r\n\tcls := packageName notNil\r\n\t\tifTrue: [ self subclass: className category: packageName ]\r\n\t\tifFalse: [ self subclass: className ].\r\n\t(urlSite isNil and: [packageName notNil and: [\r\n\t\tself urlSelectors includes: (packageName upTo: $.)\r\n\t\t]]) ifTrue: [ urlSite := self urlSelector ].\r\n\t(urlSite notNil and: [urlSite ~= #none]) ifTrue: [\r\n\t\tcls comment: 'See ' ,(self referenceTo: className in: packageName at: urlSite)\r\n\t].\r\n\t(cls respondsTo: #packagePrefix:) ifTrue: [\r\n\t\tcls packagePrefix: packageName\r\n\t].\r\n\t^cls","(\r\nfunction(self,spec,packageName,urlSite)\r\nlocal cls=nil\r\nlocal className=nil\r\nif not (((spec):isString()))==true then (function()\r\n\tlocal _s8_value=((spec):first())\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((cls):isString())==true then (function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(cls,(function()\r\nreturn ((self):buildSubclass_in_reference_(cls,packageName,urlSite))\r\nend)))\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)(); else (self):error_(smalltalk:object_comma_((\"Invalid superClass name: \"),cls)); end;\r\nreturn (((spec):copyFrom_to_(2,(spec):size())):collect_((function(each)\r\nreturn ((cls):buildSubclass_in_reference_(each,packageName,urlSite))\r\nend))); end;\r\n(function()\r\n\tlocal _s8_value=(spec)\r\n\tclassName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((packageName))),(function()\r\nreturn ((self):subclass_category_(className,packageName))\r\nend),(function()\r\nreturn ((self):subclass_(className))\r\nend)))\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_and_((smalltalk:isNil_((urlSite))),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:notNil_((packageName))),(function()\r\nreturn (((self):urlSelectors()):includes_((packageName):upTo_(\".\")))\r\nend)))\r\nend)))==true then (function()\r\n\tlocal _s8_value=((self):urlSelector())\r\n\turlSite=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((urlSite))),(function()\r\nreturn ((not smalltalk:isObject_equalTo_((urlSite),\"none\")))\r\nend)))==true then (cls):comment_(smalltalk:object_comma_((\"See \"),(self):referenceTo_in_at_(className,packageName,urlSite))); end;\r\nif (smalltalk:responds_to_((cls),(\"packagePrefix:\")))==true then (cls):packagePrefix_(packageName); end;\r\nreturn (cls);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildConstructors:",0
,(
function(self,selectors)
(self):build_doing_(("Constructors"):_minus_gt(selectors),(function()
return ((selectors):do_((function(each)
return ((self):buildConstructor_(each))
end)))
end));
return (self);
end
)
,"builders","buildConstructors: selectors\r\n\t\" Generate code for constructors implemented by native class. \"\r\n\r\n\tself build: #Constructors -> selectors doing: [\r\n\t\tselectors do: [:each| self buildConstructor: each ]\r\n\t]","(\r\nfunction(self,selectors)\r\n(self):build_doing_((\"Constructors\"):_minus_gt(selectors),(function()\r\nreturn ((selectors):do_((function(each)\r\nreturn ((self):buildConstructor_(each))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildConstructor:",0
,(
function(self,selector)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if ((selector):isArray())==true then if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((selector):size()),3)),(function()
return (((selector):last()):isString())
end)))==true then return ((self):buildStaticFunction_(selector)); end;
smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((selector):size()),2)),(function()
return (((selector):last()):isString())
end))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):buildStaticFunction_(selector))
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):buildConstructorFor_(selector))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"builders","buildConstructor: selector\r\n\t\" Private - Generate code for constructor of native class. \"\r\n\r\n\tselector isArray ifTrue: [\r\n\t    (selector size = 3 and: [selector last isString]) ifTrue: [ \"#( selector #( argumentNames ) #RETURNClass )\"\r\n\t\t^self buildStaticFunction: selector\r\n\t    ]. \r\n\t    (selector size = 2 and: [selector last isString]) ifTrue: [ \"#( selector #RETURNClass )\"\r\n\t\t^self buildStaticFunction: selector\r\n\t    ]. \r\n\t].\r\n\t^self buildConstructorFor: selector","(\r\nfunction(self,selector)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif ((selector):isArray())==true then if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((selector):size()),3)),(function()\r\nreturn (((selector):last()):isString())\r\nend)))==true then return ((self):buildStaticFunction_(selector)); end;\r\nsmalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((selector):size()),2)),(function()\r\nreturn (((selector):last()):isString())\r\nend))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):buildStaticFunction_(selector))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):buildConstructorFor_(selector))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildConstructorFor:",0
,(
function(self,selector)
local args=nil
if ((selector):isArray())==true then return ((self):buildConstructor_arguments_((selector):first(),(selector):last())); end;
(function()
	local _s8_value=(((1):to_((selector):occurrencesOf_(":"))):collect_((function(i)
return (smalltalk:object_comma_(("arg"),smalltalk:asString_((i))))
end)))
	args=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((args):size()),1))==true then (function()
	local _s8_value=(smalltalk:newArray({"anObject"}))
	args=_s8_value
	return _s8_value
end)(); end;
return ((self):buildConstructor_arguments_(selector,args));
end
)
,"builders","buildConstructorFor: selector\r\n\t\" Private - Generate code for constructor of native class. \"\r\n\r\n\t| args |\r\n\tselector isArray ifTrue: [ \"#( selector #(argumentNames) )\"\r\n\t\t^self\tbuildConstructor: selector first\r\n\t\t\targuments: selector last\r\n\t].\r\n\targs :=  (1 to: (selector occurrencesOf: $:)) collect: [:i| #arg , i asString ].\r\n\targs size = 1 ifTrue: [ args := #( #anObject ) ].\r\n\t^self buildConstructor: selector arguments: args","(\r\nfunction(self,selector)\r\nlocal args=nil\r\nif ((selector):isArray())==true then return ((self):buildConstructor_arguments_((selector):first(),(selector):last())); end;\r\n(function()\r\n\tlocal _s8_value=(((1):to_((selector):occurrencesOf_(\":\"))):collect_((function(i)\r\nreturn (smalltalk:object_comma_((\"arg\"),smalltalk:asString_((i))))\r\nend)))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((args):size()),1))==true then (function()\r\n\tlocal _s8_value=(smalltalk:newArray({\"anObject\"}))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((self):buildConstructor_arguments_(selector,args));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"constructorSupport",0
,(
function(self)
return ("self");
end
)
,"builders","constructorSupport\r\n\t\" Private - Returns the instantiation support for constructor. \"\r\n\r\n\t^#self","(\r\nfunction(self)\r\nreturn (\"self\");\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildConstructor:arguments:",0
,(
function(self,aSelector,array)
local selector=nil
local args=nil
local header=nil
local code=nil
local input=nil
local argStream=nil
local msg=nil
local long=nil
local adder=nil
local comma=nil
(function()
	local _s8_value=((self):apiArgumentsFrom_(array))
	args=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):apiSelector_forArguments_(aSelector,args))
	selector=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((args):size()) > 4))
	long=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((selector):stream())
	input=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((args):stream())
	argStream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((""):writeStream())
	header=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((""):writeStream())
	code=_s8_value
	return _s8_value
end)();
(code):nextPutAll_(smalltalk:if_true_false_((long),(function()
return ("#()")
end),(function()
return ("Array")
end)));
(function()
	local _s8_value=(smalltalk:if_true_false_((long),(function()
return (" add: ")
end),(function()
return (" with: ")
end)))
	adder=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((long),(function()
return (";")
end),(function()
return ("")
end)))
	comma=_s8_value
	return _s8_value
end)();
(header):nextPut_(((input):next()):asLowercase());
if ((argStream):atEnd())==true then (code):nextPutAll_(" new"); end;
while not ((function()
return ((argStream):atEnd())
end))() do local param=nil
local expr=nil
if (((argStream):peek()):isString())==true then (function()
	local _s8_value=((argStream):next())
	param=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(param)
	expr=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=(((argStream):peek()):first())
	param=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((param)," ")),((argStream):next()):last()))
	expr=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=(smalltalk:object_comma_(((input):upTo_(":")),": "))
	msg=_s8_value
	return _s8_value
end)();
(code):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((adder),expr)),comma));
(header):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((msg),param))," ")); end;
(code):nextPutAll_(smalltalk:if_true_false_((long),(function()
return (" yourself")
end),(function()
return ("")
end)));
(function()
	local _s8_value=((input):upToEnd())
	msg=_s8_value
	return _s8_value
end)();
(code):nextPutAll_(msg);
(header):nextPutAll_(msg);
((self)["$klass"]):implement_comment_as_category_((self):stMessageHeader_((header):contents()),"Returns an instance of the receiver.",smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("^"),(self):constructorSupport()))," instantiate: self withAll: (")),(code):contents())),")"),"instantiation");
return (self);
end
)
,"builders","buildConstructor: aSelector arguments: array\r\n\t\" Private - Generate code for constructor of native class. \"\r\n\r\n\t| selector args header code input argStream msg long adder comma |\r\n\targs := self apiArgumentsFrom: array.\r\n\tselector := self apiSelector: aSelector forArguments: args.\r\n\tlong := args size > 4.\r\n\tinput := selector stream.\r\n\targStream := args stream.\r\n\theader := '' writeStream. code := '' writeStream.\r\n\tcode nextPutAll: (long ifTrue: [ '#()' ] ifFalse: [ #Array ]).\r\n\tadder := long ifTrue: [' add: '] ifFalse: [' with: '].\r\n\tcomma := long ifTrue: [$;] ifFalse: [''].\r\n\theader nextPut: input next asLowercase.\r\n\targStream atEnd ifTrue: [ code nextPutAll: ' new' ].\r\n\t[ argStream atEnd ] whileFalse: [ | param expr |\r\n\t\targStream peek isString\r\n\t\tifTrue: [ param := argStream next. expr := param ]\r\n\t\tifFalse: [ param := argStream peek first. expr := param ,' ' ,argStream next last. ].\r\n\t\tmsg := (input upTo: $:) ,': '.\r\n\t\tcode   nextPutAll: adder ,expr ,comma.\r\n\t\theader nextPutAll: msg ,param ,' '.\r\n\t].\r\n\tcode nextPutAll: (long ifTrue: [ ' yourself' ] ifFalse: [ '' ]).\r\n\tmsg := input upToEnd.\r\n\tcode nextPutAll: msg.\r\n\theader nextPutAll: msg.\r\n\tself class\r\n\t\timplement: (self stMessageHeader: header contents)\r\n\t\t  comment: 'Returns an instance of the receiver.'\r\n\t\t  as: $^ ,self constructorSupport ,' instantiate: self withAll: (' ,code contents ,')'\r\n\t\t  category: #instantiation","(\r\nfunction(self,aSelector,array)\r\nlocal selector=nil\r\nlocal args=nil\r\nlocal header=nil\r\nlocal code=nil\r\nlocal input=nil\r\nlocal argStream=nil\r\nlocal msg=nil\r\nlocal long=nil\r\nlocal adder=nil\r\nlocal comma=nil\r\n(function()\r\n\tlocal _s8_value=((self):apiArgumentsFrom_(array))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):apiSelector_forArguments_(aSelector,args))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((args):size()) > 4))\r\n\tlong=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((selector):stream())\r\n\tinput=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((args):stream())\r\n\targStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\theader=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(code):nextPutAll_(smalltalk:if_true_false_((long),(function()\r\nreturn (\"#()\")\r\nend),(function()\r\nreturn (\"Array\")\r\nend)));\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((long),(function()\r\nreturn (\" add: \")\r\nend),(function()\r\nreturn (\" with: \")\r\nend)))\r\n\tadder=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((long),(function()\r\nreturn (\";\")\r\nend),(function()\r\nreturn (\"\")\r\nend)))\r\n\tcomma=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(header):nextPut_(((input):next()):asLowercase());\r\nif ((argStream):atEnd())==true then (code):nextPutAll_(\" new\"); end;\r\nwhile not ((function()\r\nreturn ((argStream):atEnd())\r\nend))() do local param=nil\r\nlocal expr=nil\r\nif (((argStream):peek()):isString())==true then (function()\r\n\tlocal _s8_value=((argStream):next())\r\n\tparam=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(param)\r\n\texpr=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=(((argStream):peek()):first())\r\n\tparam=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((param),\" \")),((argStream):next()):last()))\r\n\texpr=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((input):upTo_(\":\")),\": \"))\r\n\tmsg=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(code):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((adder),expr)),comma));\r\n(header):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((msg),param)),\" \")); end;\r\n(code):nextPutAll_(smalltalk:if_true_false_((long),(function()\r\nreturn (\" yourself\")\r\nend),(function()\r\nreturn (\"\")\r\nend)));\r\n(function()\r\n\tlocal _s8_value=((input):upToEnd())\r\n\tmsg=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(code):nextPutAll_(msg);\r\n(header):nextPutAll_(msg);\r\n((self)[\"$klass\"]):implement_comment_as_category_((self):stMessageHeader_((header):contents()),\"Returns an instance of the receiver.\",smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"^\"),(self):constructorSupport())),\" instantiate: self withAll: (\")),(code):contents())),\")\"),\"instantiation\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildStaticFunctions:",0
,(
function(self,specs)
(self):build_doing_(("StaticFunctions"):_minus_gt(specs),(function()
return ((specs):do_((function(each)
return ((self):buildStaticFunction_(each))
end)))
end));
return (self);
end
)
,"builders","buildStaticFunctions: specs\r\n\t\" Generate code from specs as functions implemented implemented by native class. \"\r\n\r\n\tself build: #StaticFunctions -> specs doing: [\r\n\t\tspecs do: [:each| self buildStaticFunction: each ]\r\n\t]","(\r\nfunction(self,specs)\r\n(self):build_doing_((\"StaticFunctions\"):_minus_gt(specs),(function()\r\nreturn ((specs):do_((function(each)\r\nreturn ((self):buildStaticFunction_(each))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildStaticFunction:",0
,(
function(self,spec)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if ((spec):isArray())==true then if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),3)),(function()
return (((spec):last()):isString())
end)))==true then return ((self):buildStaticFunction_((smalltalk.Array):with_with_((smalltalk.Array):with_with_((spec):first(),(spec):second()),(spec):last()))); end;
smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),2)),(function()
return (((spec):last()):isString())
end))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):buildStaticFunction_prologue_epilogue_((spec):first(),(self):apiPrologueFor_((spec):second()),(self):apiEpilogueFor_((spec):second())))
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):buildStaticFunction_prologue_epilogue_(spec,"^",""))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"builders","buildStaticFunction: spec\r\n\t\" Private - Generate code to delegate message implemented as functions on native class. \"\r\n\r\n\tspec isArray ifTrue: [\r\n\t    (spec size = 3 and: [spec last isString]) ifTrue: [ \"#( selector #( argumentNames ) #RETURNClass )\"\r\n\t\t^self buildStaticFunction: (Array\r\n\t\t\twith: (Array with: spec first with: spec second)\r\n\t\t\twith: spec last)\r\n\t    ]. \r\n\t    (spec size = 2 and: [spec last isString]) ifTrue: [ \"#( selector #RETURNClass )\"\r\n\t\t^self\r\n\t\t\tbuildStaticFunction: spec first\r\n\t\t\tprologue: (self apiPrologueFor: spec second)\r\n\t\t\tepilogue: (self apiEpilogueFor: spec second)\r\n\t    ].\r\n\t].\r\n\t^self buildStaticFunction: spec prologue: $^ epilogue: ''","(\r\nfunction(self,spec)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif ((spec):isArray())==true then if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),3)),(function()\r\nreturn (((spec):last()):isString())\r\nend)))==true then return ((self):buildStaticFunction_((smalltalk.Array):with_with_((smalltalk.Array):with_with_((spec):first(),(spec):second()),(spec):last()))); end;\r\nsmalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),2)),(function()\r\nreturn (((spec):last()):isString())\r\nend))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):buildStaticFunction_prologue_epilogue_((spec):first(),(self):apiPrologueFor_((spec):second()),(self):apiEpilogueFor_((spec):second())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):buildStaticFunction_prologue_epilogue_(spec,\"^\",\"\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildStaticFunction:prologue:epilogue:",0
,(
function(self,spec,prologue,epilogue)
local args=nil
if ((spec):isArray())==true then return ((self):buildStaticFunction_arguments_prologue_epilogue_((spec):first(),(spec):last(),prologue,epilogue)); end;
(function()
	local _s8_value=(((1):to_((spec):occurrencesOf_(":"))):collect_((function(i)
return (smalltalk:object_comma_(("arg"),smalltalk:asString_((i))))
end)))
	args=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((args):size()),1))==true then (function()
	local _s8_value=(smalltalk:newArray({"anObject"}))
	args=_s8_value
	return _s8_value
end)(); end;
return ((self):buildStaticFunction_arguments_prologue_epilogue_(spec,args,prologue,epilogue));
end
)
,"builders","buildStaticFunction: spec prologue: prologue epilogue: epilogue \r\n\t\" Private - Generate code to delegate message on native class. \"\r\n\r\n\t| args |\r\n\tspec isArray ifTrue: [ \"#( selector #(argumentNames) )\"\r\n\t\t^self\tbuildStaticFunction: spec first\r\n\t\t\targuments: spec last\r\n\t\t\tprologue: prologue epilogue: epilogue\r\n\t].\r\n\targs :=  (1 to: (spec occurrencesOf: $:)) collect: [:i| #arg , i asString ].\r\n\targs size = 1 ifTrue: [ args := #( #anObject ) ].\r\n\t^self\r\n\t\tbuildStaticFunction: spec arguments: args\r\n\t\tprologue: prologue epilogue: epilogue ","(\r\nfunction(self,spec,prologue,epilogue)\r\nlocal args=nil\r\nif ((spec):isArray())==true then return ((self):buildStaticFunction_arguments_prologue_epilogue_((spec):first(),(spec):last(),prologue,epilogue)); end;\r\n(function()\r\n\tlocal _s8_value=(((1):to_((spec):occurrencesOf_(\":\"))):collect_((function(i)\r\nreturn (smalltalk:object_comma_((\"arg\"),smalltalk:asString_((i))))\r\nend)))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((args):size()),1))==true then (function()\r\n\tlocal _s8_value=(smalltalk:newArray({\"anObject\"}))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((self):buildStaticFunction_arguments_prologue_epilogue_(spec,args,prologue,epilogue));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildStaticFunction:arguments:prologue:epilogue:",0
,(
function(self,spec,args,prologue,epilogue)
local header=nil
local code=nil
if ((args):includes_((self):kwargsStart()))==true then local array=nil
(function()
	local _s8_value=(((args):stream()):upTo_((self):kwargsStart()))
	array=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((args):last()),(self):kwargsStart())),(function()
return ((self):buildStaticFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))
end),(function()
(array):add_((self):kwargsStart());return ((self):buildStaticFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))
end)); end;
(function()
	local _s8_value=((""):writeStream())
	header=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((""):writeStream())
	code=_s8_value
	return _s8_value
end)();
(self):apiEncode_call_arguments_on_header_((self):codeForStaticReceiver(),spec,args,code,header);
((self)["$klass"]):implement_comment_as_category_((self):stMessageHeader_((header):contents()),"Delegated to native class.",(smalltalk:object_comma_((smalltalk:object_comma_((prologue),(code):contents())),epilogue)):replace_with_("!",smalltalk:object_comma_(("!"),"!")),"wrappers");
return (self);
end
)
,"builders","buildStaticFunction: spec arguments: args prologue: prologue epilogue: epilogue \r\n\t\" Private - Generate code to delegate message on native class. \"\r\n\r\n\t| header code |\r\n\t(args includes: self kwargsStart) ifTrue: [ | array |\r\n\t\tarray := args stream upTo: self kwargsStart.\r\n\t\targs last = self kwargsStart\r\n\t\tifTrue: [ self\tbuildStaticFunction: spec arguments: array\r\n\t\t\t\tprologue: prologue epilogue: epilogue ]\r\n\t\tifFalse: [\r\n\t\t\tarray add: self kwargsStart.\r\n\t\t\tself\tbuildStaticFunction: spec arguments: array\r\n\t\t\t\tprologue: prologue epilogue: epilogue \r\n\t\t].\r\n\t].\r\n\theader := '' writeStream. code := '' writeStream.\r\n\tself\r\n\t  apiEncode: self codeForStaticReceiver\r\n\t\tcall: spec arguments: args\r\n\t\ton: code header: header.\r\n\tself class\r\n\t\timplement: (self stMessageHeader: header contents)\r\n\t\t  comment: 'Delegated to native class.'\r\n\t\t  as:\t((prologue\r\n\t\t\t, code contents\r\n\t\t\t, epilogue) replace: $! with: $! ,$!)\r\n\t\t  category: #wrappers","(\r\nfunction(self,spec,args,prologue,epilogue)\r\nlocal header=nil\r\nlocal code=nil\r\nif ((args):includes_((self):kwargsStart()))==true then local array=nil\r\n(function()\r\n\tlocal _s8_value=(((args):stream()):upTo_((self):kwargsStart()))\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:isObject_equalTo_(((args):last()),(self):kwargsStart())),(function()\r\nreturn ((self):buildStaticFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))\r\nend),(function()\r\n(array):add_((self):kwargsStart());return ((self):buildStaticFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))\r\nend)); end;\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\theader=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):apiEncode_call_arguments_on_header_((self):codeForStaticReceiver(),spec,args,code,header);\r\n((self)[\"$klass\"]):implement_comment_as_category_((self):stMessageHeader_((header):contents()),\"Delegated to native class.\",(smalltalk:object_comma_((smalltalk:object_comma_((prologue),(code):contents())),epilogue)):replace_with_(\"!\",smalltalk:object_comma_((\"!\"),\"!\")),\"wrappers\");\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildNativeFunctions:",0
,(
function(self,specs)
(self):build_doing_(("NativeFunctions"):_minus_gt(specs),(function()
local tuples=nil
(function()
	local _s8_value=((specs):collect_((function(spec)
return (smalltalk:if_true_false_(((spec):isString()),(function()
return (smalltalk:object_comma_(("_"),spec))
end),(function()
local selector=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((((spec):first()):isString()),(function()
return (smalltalk:object_comma_(("_"),(spec):first()))
end),(function()
return ((
function(_s8_rec)
	(_s8_rec):at_put_(1,smalltalk:object_comma_(("_"),((spec):first()):first()));
	return ((_s8_rec):yourself())
end
)(((spec):first()):copy()))
end)))
	selector=_s8_value
	return _s8_value
end)();return (smalltalk:object_comma_(((smalltalk.Array):with_(selector)),(spec):copyFrom_to_(2,(spec):size())))
end)))
end)))
	tuples=_s8_value
	return _s8_value
end)();return ((tuples):do_((function(spec)
return ((self):buildFunction_(spec))
end)))
end));
return (self);
end
)
,"builders","buildNativeFunctions: specs\r\n\t\" Generate code from specs as raw functions implemented by instance handle. \"\r\n\r\n\tself build: #NativeFunctions -> specs doing: [ | tuples |\r\n\t\ttuples := specs collect: [:spec|\r\n\t\t\tspec isString ifTrue: [ $_ ,spec ] ifFalse: [ | selector |\r\n\t\t\t\tselector := spec first isString ifTrue: [$_ ,spec first] ifFalse: [\r\n\t\t\t\t\tspec first copy at: 1 put: ($_ ,spec first first); yourself\r\n\t\t\t\t].\r\n\t\t\t\t(Array with: selector), (spec copyFrom: 2 to: spec size)\r\n\t\t\t]\r\n\t\t].\r\n\t\ttuples do: [:spec| self buildFunction: spec ]\r\n\t]","(\r\nfunction(self,specs)\r\n(self):build_doing_((\"NativeFunctions\"):_minus_gt(specs),(function()\r\nlocal tuples=nil\r\n(function()\r\n\tlocal _s8_value=((specs):collect_((function(spec)\r\nreturn (smalltalk:if_true_false_(((spec):isString()),(function()\r\nreturn (smalltalk:object_comma_((\"_\"),spec))\r\nend),(function()\r\nlocal selector=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((((spec):first()):isString()),(function()\r\nreturn (smalltalk:object_comma_((\"_\"),(spec):first()))\r\nend),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):at_put_(1,smalltalk:object_comma_((\"_\"),((spec):first()):first()));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(((spec):first()):copy()))\r\nend)))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:object_comma_(((smalltalk.Array):with_(selector)),(spec):copyFrom_to_(2,(spec):size())))\r\nend)))\r\nend)))\r\n\ttuples=_s8_value\r\n\treturn _s8_value\r\nend)();return ((tuples):do_((function(spec)\r\nreturn ((self):buildFunction_(spec))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildNativeStaticFunctions:",0
,(
function(self,specs)
(self):build_doing_(("NativeStaticFunctions"):_minus_gt(specs),(function()
local tuples=nil
(function()
	local _s8_value=((specs):collect_((function(spec)
return (smalltalk:if_true_false_(((spec):isString()),(function()
return (smalltalk:object_comma_(("_"),spec))
end),(function()
local selector=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((((spec):first()):isString()),(function()
return (smalltalk:object_comma_(("_"),(spec):first()))
end),(function()
return ((
function(_s8_rec)
	(_s8_rec):at_put_(1,smalltalk:object_comma_(("_"),((spec):first()):first()));
	return ((_s8_rec):yourself())
end
)(((spec):first()):copy()))
end)))
	selector=_s8_value
	return _s8_value
end)();return (smalltalk:object_comma_(((smalltalk.Array):with_(selector)),(spec):copyFrom_to_(2,(spec):size())))
end)))
end)))
	tuples=_s8_value
	return _s8_value
end)();return ((tuples):do_((function(spec)
return ((self):buildStaticFunction_(spec))
end)))
end));
return (self);
end
)
,"builders","buildNativeStaticFunctions: specs\r\n\t\" Generate code from specs as raw functions implemented by class handle. \"\r\n\r\n\tself build: #NativeStaticFunctions -> specs doing: [ | tuples |\r\n\t\ttuples := specs collect: [:spec|\r\n\t\t\tspec isString ifTrue: [ $_ ,spec ] ifFalse: [ | selector |\r\n\t\t\t\tselector := spec first isString ifTrue: [$_ ,spec first] ifFalse: [\r\n\t\t\t\t\tspec first copy at: 1 put: ($_ ,spec first first); yourself\r\n\t\t\t\t].\r\n\t\t\t\t(Array with: selector), (spec copyFrom: 2 to: spec size)\r\n\t\t\t]\r\n\t\t].\r\n\t\ttuples do: [:spec| self buildStaticFunction: spec ]\r\n\t]","(\r\nfunction(self,specs)\r\n(self):build_doing_((\"NativeStaticFunctions\"):_minus_gt(specs),(function()\r\nlocal tuples=nil\r\n(function()\r\n\tlocal _s8_value=((specs):collect_((function(spec)\r\nreturn (smalltalk:if_true_false_(((spec):isString()),(function()\r\nreturn (smalltalk:object_comma_((\"_\"),spec))\r\nend),(function()\r\nlocal selector=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((((spec):first()):isString()),(function()\r\nreturn (smalltalk:object_comma_((\"_\"),(spec):first()))\r\nend),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):at_put_(1,smalltalk:object_comma_((\"_\"),((spec):first()):first()));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(((spec):first()):copy()))\r\nend)))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:object_comma_(((smalltalk.Array):with_(selector)),(spec):copyFrom_to_(2,(spec):size())))\r\nend)))\r\nend)))\r\n\ttuples=_s8_value\r\n\treturn _s8_value\r\nend)();return ((tuples):do_((function(spec)\r\nreturn ((self):buildStaticFunction_(spec))\r\nend)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildMethods:",0
,(
function(self,specs)
(self):build_doing_(("Methods"):_minus_gt(specs),(function()
return ((self):buildFunctions_(specs))
end));
return (self);
end
)
,"builders","buildMethods: specs\r\n\t\" Generate code from specs as OO methods implemented by instance handle. \"\r\n\r\n\tself build: #Methods -> specs doing: [\r\n\t\tself buildFunctions: specs\r\n\t]","(\r\nfunction(self,specs)\r\n(self):build_doing_((\"Methods\"):_minus_gt(specs),(function()\r\nreturn ((self):buildFunctions_(specs))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"@","_at"
,(
function(self,handle)
return (((self):basicNew()):handle_(handle));
end
)
,"instantiation","@ handle\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew handle: handle","(\r\nfunction(self,handle)\r\nreturn (((self):basicNew()):handle_(handle));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"empty",0
,(
function(self)
return ((self):_at(((smalltalk.Object):new()):json()));
end
)
,"instantiation","empty\r\n\t\" Return an empty instance of the receiver. \"\r\n\r\n\t^self @ Object new json","(\r\nfunction(self)\r\nreturn ((self):_at(((smalltalk.Object):new()):json()));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"for:",0
,(
function(self,handle)
return (((self):basicNew()):handle_(handle));
end
)
,"instantiation","for: handle\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew handle: handle","(\r\nfunction(self,handle)\r\nreturn (((self):basicNew()):handle_(handle));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"withAll:",0
,(
function(self,handles)
return (((smalltalk.Array):_at(handles)):collect_((function(each)
return ((self):_at(each))
end)));
end
)
,"instantiation","withAll: handles\r\n\t\" Return a collection of instance of the receiver with handles. \"\r\n\r\n\t^Array @ handles collect: [:each| self @ each ]","(\r\nfunction(self,handles)\r\nreturn (((smalltalk.Array):_at(handles)):collect_((function(each)\r\nreturn ((self):_at(each))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"of:withAll:",0
,(
function(self,aType,handles)
return ((self):withAll_((smalltalk.Array):_at(handles)));
end
)
,"instantiation","of: aType withAll: handles\r\n\t\" Return an instance of the receiver wrapping handles with a type (or nil).\r\n\tDefault implementation ignore the type.\r\n\tThis method can be refined by subclasses to support typed wrappers.\r\n\taType can be a class for type of elements or aString of comma separated type names.\r\n\t\"\r\n\r\n\t^self withAll: Array @ handles","(\r\nfunction(self,aType,handles)\r\nreturn ((self):withAll_((smalltalk.Array):_at(handles)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"of:with:",0
,(
function(self,aType,aHandle)
if (smalltalk:isNil_((aHandle)))==true then return (nil); end;
return ((self):basicOf_with_(aType,aHandle));
end
)
,"instantiation","of: aType with: aHandle\r\n\t\" Return an instance of the receiver wrapping aHandle with a type (or nil). \"\r\n\r\n\taHandle isNil ifTrue: [ ^nil ].\r\n\t^self basicOf: aType with: aHandle","(\r\nfunction(self,aType,aHandle)\r\nif (smalltalk:isNil_((aHandle)))==true then return (nil); end;\r\nreturn ((self):basicOf_with_(aType,aHandle));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"basicOf:with:",0
,(
function(self,aType,aHandle)
return ((self):implementedBySubclass_("basicOf:with:"));
end
)
,"instantiation","basicOf: aType with: aHandle\r\n\t\" Private - Return an instance of the receiver wrapping aHandle with a type.\r\n\taType can be a class for type of element or aString of comma separated type names.\r\n\t\"\r\n\r\n\t^self implementedBySubclass: #basicOf:with:","(\r\nfunction(self,aType,aHandle)\r\nreturn ((self):implementedBySubclass_(\"basicOf:with:\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"html5Events",0
,(
function(self)
return (smalltalk:newArray({}));
end
)
,"events","html5Events\r\n\t\" Private - Return the html5 events+notifications managed by instances of the receiver.\r\n\tDefault answer is empty, this method can be refined by subclasses to handle html5 events.\r\n\t\"\r\n\t^#()","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({}));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"localEvents",0
,(
function(self)
return (smalltalk:newArray({}));
end
)
,"events","localEvents\r\n\t\" Private - Return the smalltalk events managed by instances of the receiver. \"\r\n\r\n\t^#()","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({}));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"constructEventsTriggered",0
,(
function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(((self):html5Events()),(self):localEvents())),smalltalk:superImplementor(smalltalk.NativeObject["$klass"],"constructEventsTriggered")(self)));
end
)
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^self html5Events\r\n\t,self localEvents\r\n\t,super constructEventsTriggered","(\r\nfunction(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_(((self):html5Events()),(self):localEvents())),smalltalk:superImplementor(smalltalk.NativeObject[\"$klass\"],\"constructEventsTriggered\")(self)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildHTML5Events:",0
,(
function(self,selectors)
(self):build_doing_(("HTML5Events"):_minus_gt(selectors),(function()
((self)["$klass"]):implement_comment_as_category_("html5Events","Private - Return the html5 events managed by instances of the receiver.",smalltalk:object_comma_((smalltalk:object_comma_(("^#( "),(selectors):inject_into_("",(function(total,each)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),"#")),each))," "))
end)))),") , super html5Events"),"events");return ((self):buildGetters_((selectors):collect_((function(each)
return ((self):selectorForHTML5Event_(each))
end))))
end));
return (self);
end
)
,"builder","buildHTML5Events: selectors\r\n\t\" Private - Generate code to route events to handle. \"\r\n\r\n\tself build: #HTML5Events -> selectors doing: [\r\n\t\tself class\r\n\t\t\timplement: #html5Events\r\n\t\t\tcomment: 'Private - Return the html5 events managed by instances of the receiver.'\r\n\t\t\tas: '^#( ' ,(selectors inject: '' into: [:total :each|\r\n\t\t\t\ttotal ,'#',each ,' '\r\n\t\t\t\t]),') , super html5Events'\r\n\t\t\tcategory: #events.\r\n\t\tself buildGetters: (selectors collect: [:each|\r\n\t\t\tself selectorForHTML5Event: each\r\n\t\t]).\r\n\t]","(\r\nfunction(self,selectors)\r\n(self):build_doing_((\"HTML5Events\"):_minus_gt(selectors),(function()\r\n((self)[\"$klass\"]):implement_comment_as_category_(\"html5Events\",\"Private - Return the html5 events managed by instances of the receiver.\",smalltalk:object_comma_((smalltalk:object_comma_((\"^#( \"),(selectors):inject_into_(\"\",(function(total,each)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),\"#\")),each)),\" \"))\r\nend)))),\") , super html5Events\"),\"events\");return ((self):buildGetters_((selectors):collect_((function(each)\r\nreturn ((self):selectorForHTML5Event_(each))\r\nend))))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"selectorForEvent:",0
,(
function(self,selector)
if (((self):localEvents()):includes_(selector))==true then return (nil); end;
return (smalltalk:if_true_false_((((self):html5Events()):includes_(selector)),(function()
return ((self):selectorForHTML5Event_(selector))
end),nil));
end
)
,"events","selectorForEvent: selector\r\n\t\" Private - Return the on... selector to use to register binding to selector. \"\r\n\r\n\t(self localEvents includes: selector) ifTrue: [ ^nil ].\r\n\t^(self html5Events includes: selector) ifTrue: [\r\n\t\tself selectorForHTML5Event: selector\r\n\t]","(\r\nfunction(self,selector)\r\nif (((self):localEvents()):includes_(selector))==true then return (nil); end;\r\nreturn (smalltalk:if_true_false_((((self):html5Events()):includes_(selector)),(function()\r\nreturn ((self):selectorForHTML5Event_(selector))\r\nend),nil));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"selectorForHTML5Event:",0
,(
function(self,selector)
return (smalltalk:object_comma_(("on"),((selector):upTo_(":")):asSmalltalkName_(true)));
end
)
,"events","selectorForHTML5Event: selector\r\n\t\" Private - Return the on... selector to use to register binding to selector. \"\r\n\r\n\t^#on , ((selector upTo: $:) asSmalltalkName: true)","(\r\nfunction(self,selector)\r\nreturn (smalltalk:object_comma_((\"on\"),((selector):upTo_(\":\")):asSmalltalkName_(true)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildLuaFunctions:",0
,(
function(self,specs)
(self):buildNativeFunctions_(specs);
return (self);
end
)
,"Lua-builders","buildLuaFunctions: specs\r\n\t\" OBSOLETE - Generate code from specs as raw functions implemented by instance handle. \"\r\n\r\n\tself buildNativeFunctions: specs","(\r\nfunction(self,specs)\r\n(self):buildNativeFunctions_(specs);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject["$klass"],"buildLuaStaticFunctions:",0
,(
function(self,specs)
(self):buildNativeStaticFunctions_(specs);
return (self);
end
)
,"Lua-builders","buildLuaStaticFunctions: specs\r\n\t\" OBSOLETE - Generate code from specs as raw functions implemented by class handle. \"\r\n\r\n\tself buildNativeStaticFunctions: specs","(\r\nfunction(self,specs)\r\n(self):buildNativeStaticFunctions_(specs);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"eval:",0
,(
function(self,code)
return (((smalltalk.Smalltalk):current()):eval_(code));
end
)
,"eval","eval: code\r\n\t\" Private - Return the result of evaluating (native) code. \"\r\n\r\n\t^Smalltalk current eval: code","(\r\nfunction(self,code)\r\nreturn (((smalltalk.Smalltalk):current()):eval_(code));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"ignoreReturn:",0
,(
function(self,value)
return (self);
end
)
,"api","ignoreReturn: value\r\n\t\" Private - Ignore the argument value.\r\n\tReturn the receiver. \"","(\r\nfunction(self,value)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"@@","_at_at"
,(
function(self,path)
if ((path):isString())==true then return ((self):_at_at((path):asArrayOfSubstringsSeparatedBy_("."))); end;
return ((path):inject_into_((self):handle(),(function(h,each)
return (smalltalk:if_true_false_((smalltalk:notNil_((h))),(function()
return ((h)[each])
end),nil))
end)));
end
)
,"accessing","@@ path\r\n\t\" Return the property at path of the receiver (or nil). \"\r\n\r\n\tpath isString ifTrue: [\r\n\t\t^self @@ (path asArrayOfSubstringsSeparatedBy: $.)\r\n\t].\r\n\t^path inject: self handle into: [:h :each|\r\n\t\th notNil ifTrue: [ h basicAt: each ]\r\n\t]","(\r\nfunction(self,path)\r\nif ((path):isString())==true then return ((self):_at_at((path):asArrayOfSubstringsSeparatedBy_(\".\"))); end;\r\nreturn ((path):inject_into_((self):handle(),(function(h,each)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((h))),(function()\r\nreturn ((h)[each])\r\nend),nil))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"<@","_lt_at"
,(
function(self,path)
return ((smalltalk.NativeHandle):_at((self):_at_at(path)));
end
)
,"accessing","<@ path\r\n\t\" Return the native property at path of the receiver (or nil). \"\r\n\r\n\t^NativeHandle @ (self @@ path)","(\r\nfunction(self,path)\r\nreturn ((smalltalk.NativeHandle):_at((self):_at_at(path)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"as:",0
,(
function(self,aNativeObjectClass)
local result=nil
if (smalltalk:is_kindOf_((self),(aNativeObjectClass)))==true then return (self); end;
(function()
	local _s8_value=((aNativeObjectClass):_at((self):handle()))
	result=_s8_value
	return _s8_value
end)();
if (((result)==self))==true then return (self); end;
(result):copyPropertiesFrom_(self);
return (result);
end
)
,"converting","as: aNativeObjectClass\r\n\t\" Return the receiver casted to aNativeObjectClass. \"\r\n\r\n\t| result |\r\n\t(self isKindOf: aNativeObjectClass) ifTrue: [ ^self ].\r\n\tresult := aNativeObjectClass @ self handle.\r\n\tresult == self ifTrue: [ ^self ].\r\n\tresult copyPropertiesFrom: self.\r\n\t^result","(\r\nfunction(self,aNativeObjectClass)\r\nlocal result=nil\r\nif (smalltalk:is_kindOf_((self),(aNativeObjectClass)))==true then return (self); end;\r\n(function()\r\n\tlocal _s8_value=((aNativeObjectClass):_at((self):handle()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (((result)==self))==true then return (self); end;\r\n(result):copyPropertiesFrom_(self);\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"handle",0
,(
function(self)
if (smalltalk:isNil_((self["@handle"])))==true then (self):initializeHandle(); end;
return (self["@handle"]);
end
)
,"accessing","handle\r\n\t\" Return the native handle. \"\r\n\r\n\thandle isNil ifTrue: [ self initializeHandle ].\r\n\t^handle","(\r\nfunction(self)\r\nif (smalltalk:isNil_((self[\"@handle\"])))==true then (self):initializeHandle(); end;\r\nreturn (self[\"@handle\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"handleOrNil",0
,(
function(self)
return (self["@handle"]);
end
)
,"private","handleOrNil\r\n\t\" Return the native handle (or nil). \"\r\n\r\n\t^handle","(\r\nfunction(self)\r\nreturn (self[\"@handle\"]);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"=","_eq"
,(
function(self,anObject)
if (((self)==anObject))==true then return (true); end;
if not (((self):isObject_(anObject)))==true then return (false); end;
return (smalltalk:boolean_and_((smalltalk:responds_to_((anObject),("handleOrNil"))),(function()
return (((self["@handle"])==(anObject):handleOrNil()))
end)));
end
)
,"testing","= anObject\r\n\r\n\tself == anObject ifTrue: [ ^true ].\r\n\t(self isObject: anObject) ifFalse: [ ^false ].\r\n\t^(anObject respondsTo: #handleOrNil) and: [\r\n\t\thandle == anObject handleOrNil\r\n\t] ","(\r\nfunction(self,anObject)\r\nif (((self)==anObject))==true then return (true); end;\r\nif not (((self):isObject_(anObject)))==true then return (false); end;\r\nreturn (smalltalk:boolean_and_((smalltalk:responds_to_((anObject),(\"handleOrNil\"))),(function()\r\nreturn (((self[\"@handle\"])==(anObject):handleOrNil()))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"handle:",0
,(
function(self,anAlien)
(function()
	local _s8_value=(anAlien)
	self["@handle"]=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((self["@handle"])))==true then return (nil); end;
return (self);
end
)
,"accessing","handle: anAlien\r\n\t\" Set the native handle to a potentialy native(non-S8) object.\r\n\tReturn the receiver, or nil if the receiver is void.\r\n\t\"\r\n\r\n\thandle := anAlien.\r\n\thandle isNil ifTrue: [ ^nil ].","(\r\nfunction(self,anAlien)\r\n(function()\r\n\tlocal _s8_value=(anAlien)\r\n\tself[\"@handle\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((self[\"@handle\"])))==true then return (nil); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"jsonHiddenNames",0
,(
function(self)
return (smalltalk:newArray({"handle"}));
end
)
,"converting","jsonHiddenNames\r\n\t\" Private - Return the names of the instance variables to skip when mapping the receiver to JSON structure. \"\r\n\r\n\t^#( #handle )","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({\"handle\"}));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"basicJson",0
,(
function(self)
return (smalltalk:superImplementor(smalltalk.NativeObject,"json")(self));
end
)
,"converting","basicJson\r\n\t\" Convert the receiver to JSON structure. \"\r\n\r\n\t^super json","(\r\nfunction(self)\r\nreturn (smalltalk:superImplementor(smalltalk.NativeObject,\"json\")(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"json",0
,(
function(self)
return ((self):handle());
end
)
,"converting","json\r\n\t\" Convert the receiver to JSON structure. \"\r\n\r\n\t^self handle","(\r\nfunction(self)\r\nreturn ((self):handle());\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"jsObject",0
,(
function(self)
return (self:invalidMessage_("jsObject"));
end
)
,"private","jsObject\r\n\t\" Private - Return the (native)Object. \"\r\n\r\n\t^{''}","(\r\nfunction(self)\r\nreturn (self:invalidMessage_(\"jsObject\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"ownPropertyNames",0
,(
function(self)

	local result = smalltalk.Array:new()
	for k,_ in pairs(self["@handle"]) do
		result:add_(k)
	end
	if true then return result end;
return (self);
end
)
,"accessing","ownPropertyNames\r\n\t\" Return the owned property names of the receiver. \"\r\n\r\n\t{''}","(\r\nfunction(self)\r\n\r\n\tlocal result = smalltalk.Array:new()\r\n\tfor k,_ in pairs(self[\"@handle\"]) do\r\n\t\tresult:add_(k)\r\n\tend\r\n\tif true then return result end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"@","_at"
,(
function(self,propertyName)
return ((self):handleAt_(propertyName));
end
)
,"accessing","@ propertyName\r\n\t\" Return the property at propertyName of the receiver. \"\r\n\r\n\t^self handleAt: propertyName","(\r\nfunction(self,propertyName)\r\nreturn ((self):handleAt_(propertyName));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"handleAt:",0
,(
function(self,propertyName)
return (self["@handle"][propertyName]);
end
)
,"accessing","handleAt: propertyName\r\n\t\" Return the property at propertyName of the receiver. \"\r\n\r\n\t^handle[propertyName]","(\r\nfunction(self,propertyName)\r\nreturn (self[\"@handle\"][propertyName]);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"handleAt:put:",0
,(
function(self,propertyName,anObject)
return ((function()
	local _s8_value=(anObject)
	self["@handle"][propertyName]=_s8_value
	return _s8_value
end)());
end
)
,"accessing","handleAt: propertyName put: anObject\r\n\t\" Set the property at propertyName of the receiver. \"\r\n\r\n\t^handle[propertyName] := anObject","(\r\nfunction(self,propertyName,anObject)\r\nreturn ((function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@handle\"][propertyName]=_s8_value\r\n\treturn _s8_value\r\nend)());\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"initializeHandle",0
,(
function(self)
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_(("Missing "),((self)["$klass"]):name())),">>#initializeHandle")));
end
)
,"initialize","initializeHandle\r\n\t\" Private - Initialize the native handle.\r\n\tThis method must be implemented by subclasses.\r\n\t\"\r\n\r\n\t^self error: 'Missing '\r\n\t\t,self class name\r\n\t\t,'>>#initializeHandle'","(\r\nfunction(self)\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((\"Missing \"),((self)[\"$klass\"]):name())),\">>#initializeHandle\")));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"releaseHandle",0
,(
function(self)
(function()
	local _s8_value=(nil)
	self["@handle"]=_s8_value
	return _s8_value
end)();
return (self);
end
)
,"release","releaseHandle\r\n\t\" Private - Release the native handle.\r\n\tThe default implementation clear handle.\r\n\tThis method can be refined by subclasses to free external resources.\r\n\t\"\r\n\r\n\thandle := nil","(\r\nfunction(self)\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@handle\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"release",0
,(
function(self)
(self):releaseHandle();
return (smalltalk:superImplementor(smalltalk.NativeObject,"release")(self));
end
)
,"release","release\r\n\t\" Private - Release the receiver. \"\r\n\r\n\tself releaseHandle.\r\n\t^super release","(\r\nfunction(self)\r\n(self):releaseHandle();\r\nreturn (smalltalk:superImplementor(smalltalk.NativeObject,\"release\")(self));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"copyPropertiesFrom:",0
,(
function(self,aNativeObject)
((aNativeObject):ownPropertyNames()):do_((function(key)
return (smalltalk:basic_at_put_((self),key,(aNativeObject)[key]))
end));
return (self);
end
)
,"copying","copyPropertiesFrom: aNativeObject\r\n\t\" Private - Copy receiver's properties from aNativeObject. \"\r\n\r\n\taNativeObject ownPropertyNames do: [:key|\r\n\t\tself basicAt: key put: (aNativeObject basicAt: key)\r\n\t]","(\r\nfunction(self,aNativeObject)\r\n((aNativeObject):ownPropertyNames()):do_((function(key)\r\nreturn (smalltalk:basic_at_put_((self),key,(aNativeObject)[key]))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"shallowCopy",0
,(
function(self)
return (self);
end
)
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"deepCopy",0
,(
function(self)
return (self);
end
)
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","(\r\nfunction(self)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"closureForEvent:",0
,(
function(self,selector)
local argumentCount=nil
(function()
	local _s8_value=((selector):argumentCount())
	argumentCount=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((argumentCount),0))==true then return ((function()
return ((self):triggerEvent_(selector))
end)); end;
if (smalltalk:isObject_equalTo_((argumentCount),1))==true then return ((function(arg1)
return ((self):triggerEvent_with_(selector,arg1))
end)); end;
if (smalltalk:isObject_equalTo_((argumentCount),2))==true then return ((function(arg1,arg2)
return ((self):triggerEvent_with_with_(selector,arg1,arg2))
end)); end;
if (smalltalk:isObject_equalTo_((argumentCount),3))==true then return ((function(arg1,arg2,arg3)
return ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_with_with_(arg1,arg2,arg3)))
end)); end;
if (smalltalk:isObject_equalTo_((argumentCount),4))==true then return ((function(arg1,arg2,arg3,arg4)
return ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_with_with_with_(arg1,arg2,arg3,arg4)))
end)); end;
return ((self):error_("Invalid argument count"));
end
)
,"events","closureForEvent: selector\r\n\t\" Private - Return the closure to handle event selector. \"\r\n\r\n\t| argumentCount |\r\n\targumentCount := selector argumentCount.\r\n\targumentCount = 0 ifTrue: [ ^[ self triggerEvent: selector ] ].\r\n\targumentCount = 1 ifTrue: [ ^[:arg1| self triggerEvent: selector with: arg1 ] ].\r\n\targumentCount = 2 ifTrue: [ ^[:arg1 :arg2| self triggerEvent: selector with: arg1 with: arg2 ] ].\r\n\targumentCount = 3 ifTrue: [ ^[:arg1 :arg2 :arg3| self triggerEvent: selector withArguments: (Array with: arg1 with: arg2 with: arg3) ] ].\r\n\targumentCount = 4 ifTrue: [ ^[:arg1 :arg2 :arg3 :arg4| self triggerEvent: selector withArguments: (Array with: arg1 with: arg2 with: arg3 with: arg4) ] ].\r\n\t^self error: 'Invalid argument count'","(\r\nfunction(self,selector)\r\nlocal argumentCount=nil\r\n(function()\r\n\tlocal _s8_value=((selector):argumentCount())\r\n\targumentCount=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((argumentCount),0))==true then return ((function()\r\nreturn ((self):triggerEvent_(selector))\r\nend)); end;\r\nif (smalltalk:isObject_equalTo_((argumentCount),1))==true then return ((function(arg1)\r\nreturn ((self):triggerEvent_with_(selector,arg1))\r\nend)); end;\r\nif (smalltalk:isObject_equalTo_((argumentCount),2))==true then return ((function(arg1,arg2)\r\nreturn ((self):triggerEvent_with_with_(selector,arg1,arg2))\r\nend)); end;\r\nif (smalltalk:isObject_equalTo_((argumentCount),3))==true then return ((function(arg1,arg2,arg3)\r\nreturn ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_with_with_(arg1,arg2,arg3)))\r\nend)); end;\r\nif (smalltalk:isObject_equalTo_((argumentCount),4))==true then return ((function(arg1,arg2,arg3,arg4)\r\nreturn ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_with_with_with_(arg1,arg2,arg3,arg4)))\r\nend)); end;\r\nreturn ((self):error_(\"Invalid argument count\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"when:evaluate:",0
,(
function(self,selector,anAction)
local result=nil
local needsRegistration=nil
(function()
	local _s8_value=(smalltalk:isNil_((((self):eventTable()):at_ifAbsent_(selector,(function()
return (nil)
end)))))
	needsRegistration=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:superImplementor(smalltalk.NativeObject,"when_evaluate_")(self,selector,anAction))
	result=_s8_value
	return _s8_value
end)();
if (needsRegistration)==true then (self):registerEvent_doing_(selector,(self):closureForEvent_(selector)); end;
return (result);
end
)
,"events","when: selector evaluate: anAction\r\n\t\" Register anAction to the be evaluated when the receiver triggers the event. \"\r\n\r\n\t| result needsRegistration |\r\n\tneedsRegistration := (self eventTable at: selector ifAbsent: [nil]) isNil.\r\n\tresult := super when: selector evaluate: anAction.\r\n\tneedsRegistration ifTrue: [\r\n\t\tself\tregisterEvent: selector\r\n\t\t\tdoing: (self closureForEvent: selector).\r\n\t].\r\n\t^result","(\r\nfunction(self,selector,anAction)\r\nlocal result=nil\r\nlocal needsRegistration=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:isNil_((((self):eventTable()):at_ifAbsent_(selector,(function()\r\nreturn (nil)\r\nend)))))\r\n\tneedsRegistration=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:superImplementor(smalltalk.NativeObject,\"when_evaluate_\")(self,selector,anAction))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (needsRegistration)==true then (self):registerEvent_doing_(selector,(self):closureForEvent_(selector)); end;\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"registerEvent:doing:",0
,(
function(self,selector,closure)
local onSelector=nil
(function()
	local _s8_value=(((self)["$klass"]):selectorForEvent_(selector))
	onSelector=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((onSelector)))==true then return (self); end;
return ((self):bindEvent_doing_(onSelector,closure));
end
)
,"events","registerEvent: selector doing: closure\r\n\t\" Private - Register basic event handler. \"\r\n\r\n\t| onSelector |\r\n\tonSelector := self class selectorForEvent: selector.\r\n\tonSelector isNil ifTrue: [ ^self ]. \"local/smalltalk event\"\r\n\t^self bindEvent: onSelector doing: closure","(\r\nfunction(self,selector,closure)\r\nlocal onSelector=nil\r\n(function()\r\n\tlocal _s8_value=(((self)[\"$klass\"]):selectorForEvent_(selector))\r\n\tonSelector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((onSelector)))==true then return (self); end;\r\nreturn ((self):bindEvent_doing_(onSelector,closure));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"bindEvent:doing:",0
,(
function(self,onSelector,closure)
local native=nil
(function()
	local _s8_value=((self):handle())
	native=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((native[onSelector])))==true then (function()
	local _s8_value=(closure)
	native[onSelector]=_s8_value
	return _s8_value
end)(); else (native[onSelector]):addListener((closure):json()); end;
return (self);
end
)
,"events","bindEvent: onSelector doing: closure\r\n\t\" Private - Bind the event handler. \"\r\n\r\n\t| native |\r\n\tnative := self handle.\r\n\tnative[onSelector] isNil ifTrue: [\r\n\t\tnative[onSelector] := closure\r\n\t] ifFalse: [\r\n\t\tnative[onSelector] #addListener: closure json\r\n\t]","(\r\nfunction(self,onSelector,closure)\r\nlocal native=nil\r\n(function()\r\n\tlocal _s8_value=((self):handle())\r\n\tnative=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((native[onSelector])))==true then (function()\r\n\tlocal _s8_value=(closure)\r\n\tnative[onSelector]=_s8_value\r\n\treturn _s8_value\r\nend)(); else (native[onSelector]):addListener((closure):json()); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"description",0
,(
function(self)
return (((self):asNativeHandle()):description());
end
)
,"debugging","description\r\n\t\" Return a string description from receiver's properties. \"\r\n\r\n\t^self asNativeHandle description","(\r\nfunction(self)\r\nreturn (((self):asNativeHandle()):description());\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"asDictionary",0
,(
function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	result=_s8_value
	return _s8_value
end)();
((self):ownPropertyNames()):do_((function(key)
return ((result):at_put_(key,self["@handle"][key]))
end));
return (result);
end
)
,"converting","asDictionary\r\n\t\" Convert the receiver to a(Pool)Dictionary. \"\r\n\r\n\t| result |\r\n\tresult := PoolDictionary new.\r\n\tself ownPropertyNames do: [:key| result at: key put: handle[key] ].\r\n\t^result","(\r\nfunction(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):ownPropertyNames()):do_((function(key)\r\nreturn ((result):at_put_(key,self[\"@handle\"][key]))\r\nend));\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"asNativeHandle",0
,(
function(self)
return ((smalltalk.NativeHandle):_at((self):handle()));
end
)
,"converting","asNativeHandle\r\n\t\" Convert the receiver to NativeHandle instance (for reflection). \"\r\n\r\n\t^NativeHandle @ self handle","(\r\nfunction(self)\r\nreturn ((smalltalk.NativeHandle):_at((self):handle()));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeObject,"asJS",0
,(
function(self)
return ((smalltalk.NativeHandle):_at((self):handle()));
end
)
,"converting","asJS\r\n\t\" Convert the receiver to JS instance (for reflection). \"\r\n\r\n\t^NativeHandle @ self handle","(\r\nfunction(self)\r\nreturn ((smalltalk.NativeHandle):_at((self):handle()));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle["$klass"],"supportsLanguage:",0
,(
function(self,language)
return (false);
end
)
,"instantiation","supportsLanguage: language\r\n\t\" Private - Return true if instances of the receiver implement native wrappers for language.\r\n\tReturns false. This method may be refined by subclasses. \"\r\n\r\n\t^false","(\r\nfunction(self,language)\r\nreturn (false);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle["$klass"],"support",0
,(
function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local lang=nil
if (smalltalk:notNil_((smalltalk.NativeHandle:classVariableAt_("Support"))))==true then return (smalltalk.NativeHandle:classVariableAt_("Support")); end;
(function()
	local _s8_value=((self):nativeLanguage())
	lang=_s8_value
	return _s8_value
end)();
((smalltalk.NativeHandle):allSubclasses()):do_((function(cls)
return (smalltalk:if_true_false_(((cls):supportsLanguage_(lang)),(function()
smalltalk.NativeHandle:classVariableAt_put_("Support",cls);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk.NativeHandle:classVariableAt_("Support"))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_("Native handle support missing"))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"instantiation","support\r\n\t\" Private - Return the support for hosting execution environment. \"\r\n\r\n\t| lang |\r\n\tSupport notNil ifTrue: [ ^Support ].\r\n\tlang := self nativeLanguage.\r\n\tNativeHandle allSubclasses do: [:cls|\r\n\t\t(cls supportsLanguage: lang) ifTrue: [\r\n\t\t\tSupport := cls.\r\n\t\t\t^Support\r\n\t\t].\r\n\t].\r\n\t^self error: 'Native handle support missing'","(\r\nfunction(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal lang=nil\r\nif (smalltalk:notNil_((smalltalk.NativeHandle:classVariableAt_(\"Support\"))))==true then return (smalltalk.NativeHandle:classVariableAt_(\"Support\")); end;\r\n(function()\r\n\tlocal _s8_value=((self):nativeLanguage())\r\n\tlang=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((smalltalk.NativeHandle):allSubclasses()):do_((function(cls)\r\nreturn (smalltalk:if_true_false_(((cls):supportsLanguage_(lang)),(function()\r\nsmalltalk.NativeHandle:classVariableAt_put_(\"Support\",cls);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk.NativeHandle:classVariableAt_(\"Support\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(\"Native handle support missing\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle["$klass"],"@>","_at_gt"
,(
function(self,nativeObject)
local h=nil
(function()
	local _s8_value=((self):_at(nativeObject))
	h=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((h))),(function()
return ((h):description())
end),(function()
return ("nil")
end)));
end
)
,"converting","@> nativeObject\r\n\t\" Return the description of nativeObject. \"\r\n\r\n\t| h |\r\n\th := self @ nativeObject.\r\n\t^h notNil\r\n\t\tifTrue: [ h description ]\r\n\t\tifFalse: [ #nil ]","(\r\nfunction(self,nativeObject)\r\nlocal h=nil\r\n(function()\r\n\tlocal _s8_value=((self):_at(nativeObject))\r\n\th=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((h))),(function()\r\nreturn ((h):description())\r\nend),(function()\r\nreturn (\"nil\")\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle["$klass"],"instanceHandleFromString:",0
,(
function(self,aString)
return ((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(aString,(function()
return (nil)
end)));
end
)
,"private","instanceHandleFromString: aString\r\n\t\" Private - Return a (native)handle obtained from aString (or nil). \"\r\n\r\n\t^Smalltalk nativeObjectAt: aString ifAbsent: []","(\r\nfunction(self,aString)\r\nreturn ((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(aString,(function()\r\nreturn (nil)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle["$klass"],"@","_at"
,(
function(self,nativeObject)
if (((self)==smalltalk.NativeHandle))==true then return (((self):support()):_at(nativeObject)); end;
if (smalltalk:boolean_and_(((self):isObject_(nativeObject)),(function()
return ((nativeObject):isString())
end)))==true then return (smalltalk:superImplementor(smalltalk.NativeHandle["$klass"],"_at")(self,(self):instanceHandleFromString_(nativeObject))); end;
return (smalltalk:superImplementor(smalltalk.NativeHandle["$klass"],"_at")(self,nativeObject));
end
)
,"instantiation","@ nativeObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\tself == NativeHandle ifTrue: [ ^self support @ nativeObject ].\r\n\t((self isObject: nativeObject) and: [ nativeObject isString ]) ifTrue: [\r\n\t\t^super @ (self instanceHandleFromString: nativeObject)\r\n\t].\r\n\t^super @ nativeObject","(\r\nfunction(self,nativeObject)\r\nif (((self)==smalltalk.NativeHandle))==true then return (((self):support()):_at(nativeObject)); end;\r\nif (smalltalk:boolean_and_(((self):isObject_(nativeObject)),(function()\r\nreturn ((nativeObject):isString())\r\nend)))==true then return (smalltalk:superImplementor(smalltalk.NativeHandle[\"$klass\"],\"_at\")(self,(self):instanceHandleFromString_(nativeObject))); end;\r\nreturn (smalltalk:superImplementor(smalltalk.NativeHandle[\"$klass\"],\"_at\")(self,nativeObject));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle["$klass"],"chunks",0
,(
function(self)
return ((smalltalk.NativeReader):new());
end
)
,"utilities","chunks\r\n\t\" Return a NativeReader to fileIn properties in new native object. \"\r\n\r\n\t^NativeReader new","(\r\nfunction(self)\r\nreturn ((smalltalk.NativeReader):new());\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle["$klass"],"@>>","_at_gt_gt"
,(
function(self,nativeObject)
local h=nil
(function()
	local _s8_value=((self):_at(nativeObject))
	h=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((h))),(function()
return ((h):description_owned_(1,true))
end),(function()
return ("nil")
end)));
end
)
,"converting","@>> nativeObject\r\n\t\" Return the (owned) description of nativeObject. \"\r\n\r\n\t| h |\r\n\th := self @ nativeObject.\r\n\t^h notNil\r\n\t\tifTrue: [ h description: 1 owned: true ]\r\n\t\tifFalse: [ #nil ]","(\r\nfunction(self,nativeObject)\r\nlocal h=nil\r\n(function()\r\n\tlocal _s8_value=((self):_at(nativeObject))\r\n\th=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((h))),(function()\r\nreturn ((h):description_owned_(1,true))\r\nend),(function()\r\nreturn (\"nil\")\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle,"keys",0
,(
function(self)
return (((self):propertyNames()):sorted());
end
)
,"accessing","keys\r\n\t\" Return the sorted property names of the receiver. \"\r\n\r\n\t^self propertyNames sorted","(\r\nfunction(self)\r\nreturn (((self):propertyNames()):sorted());\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle,"properties",0
,(
function(self)
return (((self):keys()):collect_((function(each)
return ((smalltalk.Array):with_with_(each,(self):handleAt_(each)))
end)));
end
)
,"accessing","properties\r\n\t\" Return an array with property name and values. \"\r\n\r\n\t^self keys collect: [:each|\r\n\t\tArray with: each with: (self handleAt: each)\r\n\t]","(\r\nfunction(self)\r\nreturn (((self):keys()):collect_((function(each)\r\nreturn ((smalltalk.Array):with_with_(each,(self):handleAt_(each)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle,"propertiesDo:",0
,(
function(self,aBlock)
((self):propertyNames()):do_((function(each)
return ((aBlock):value_value_(each,(self):handleAt_(each)))
end));
return (self);
end
)
,"iterating","propertiesDo: aBlock\r\n\t\" Evaluate aTwoArgumentBlock with each property (name & value) of the receiver. \"\r\n\r\n\tself propertyNames do: [:each| aBlock value: each value: (self handleAt: each) ]","(\r\nfunction(self,aBlock)\r\n((self):propertyNames()):do_((function(each)\r\nreturn ((aBlock):value_value_(each,(self):handleAt_(each)))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle,"description:",0
,(
function(self,level)
return ((self):description_owned_(level,false));
end
)
,"debugging","description: level\r\n\t\" Return the description of the receiver. \"\r\n\r\n\t^self description: level owned: false ","(\r\nfunction(self,level)\r\nreturn ((self):description_owned_(level,false));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle,"description:owned:",0
,(
function(self,level,owned)
local text=nil
local data=nil
local cr=nil
(function()
	local _s8_value=((function(h)
return (smalltalk:if_true_false_((smalltalk:isNil_((h))),nil,(function()
return (smalltalk:if_true_false_(((self):isObject_(h)),(function()
return (smalltalk:if_true_false_(((((self):typeOf_(h))=="function")),(function()
return (smalltalk:object_comma_((smalltalk:object_comma_(("("),(smalltalk:toString_((h))):upTo_("{"))),"{...})"))
end),(function()
return (smalltalk:printString_((h)))
end)))
end),(function()
return (((function()
return (smalltalk:if_true_false_((((level) > 1)),(function()
return ((((self)["$klass"]):_at(h)):description_owned_((level):_minus(1),owned))
end),(function()
return ((self):toString_(h))
end)))
end)):on_do_(smalltalk.Exception,(function(err)
return ("???")
end)))
end)))
end)))
end))
	text=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((function(key)
local value=nil
((function()
return ((function()
	local _s8_value=((self["@handle"])[key])
	value=_s8_value
	return _s8_value
end)())
end)):on_do_(smalltalk.Exception,(function(ex)
return ((function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("["),key)),"] ")),(ex):description()))
	value=_s8_value
	return _s8_value
end)())
end));return (value)
end))
	data=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=("\r\n")
	cr=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_((((smalltalk:if_true_false_((owned),(function()
return ((self):ownPropertyNames())
end),(function()
return ((self):propertyNames())
end))):sorted()):inject_into_("{",(function(total,each)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),cr)),each)),": ")),(text):value_((data):value_(each)))),";"))
end))),cr)),"}"));
end
)
,"debugging","description: level owned: owned\r\n\t\" Return the description of the receiver. \"\r\n\r\n\t| text data cr | \r\n\ttext := [:h|\r\n\t\th isNil ifFalse: [\r\n\t\t\t(self isObject: h) ifTrue: [\r\n\t\t\t\t(self typeOf: h) == #function\r\n\t\t\t\tifTrue: [ $( ,(h toString upTo: ${) ,'{...})' ]\r\n\t\t\t\tifFalse: [ h printString ]\r\n\t\t\t] ifFalse: [\r\n\t\t\t\t[ level > 1\r\n\t\t\t\t\tifTrue: [ (self class @ h) description: level - 1 owned: owned ]\r\n\t\t\t\t\tifFalse: [ self toString: h ]\r\n\t\t\t\t] on: Exception do: [:err| '???' ]\r\n\t\t\t]\r\n\t\t]\r\n\t].\r\n\tdata := [:key| | value |\r\n\t\t[ value := handle basicAt: key ] on: Exception do: [:ex|\r\n\t\t\tvalue := '[',key,'] ' ,ex description\r\n\t\t]. value\r\n\t].\r\n\tcr := '\r\n'.\t^((owned\r\n\tifTrue: [self ownPropertyNames]\r\n\tifFalse: [self propertyNames]) sorted\r\n\t\tinject: ${ into: [:total :each| total ,cr\r\n \t\t\t,each ,': '\r\n\t\t\t,(text value: (data value:each))\r\n\t\t\t,';' ]\r\n\t\t)\t,cr ,$}","(\r\nfunction(self,level,owned)\r\nlocal text=nil\r\nlocal data=nil\r\nlocal cr=nil\r\n(function()\r\n\tlocal _s8_value=((function(h)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((h))),nil,(function()\r\nreturn (smalltalk:if_true_false_(((self):isObject_(h)),(function()\r\nreturn (smalltalk:if_true_false_(((((self):typeOf_(h))==\"function\")),(function()\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"(\"),(smalltalk:toString_((h))):upTo_(\"{\"))),\"{...})\"))\r\nend),(function()\r\nreturn (smalltalk:printString_((h)))\r\nend)))\r\nend),(function()\r\nreturn (((function()\r\nreturn (smalltalk:if_true_false_((((level) > 1)),(function()\r\nreturn ((((self)[\"$klass\"]):_at(h)):description_owned_((level):_minus(1),owned))\r\nend),(function()\r\nreturn ((self):toString_(h))\r\nend)))\r\nend)):on_do_(smalltalk.Exception,(function(err)\r\nreturn (\"???\")\r\nend)))\r\nend)))\r\nend)))\r\nend))\r\n\ttext=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((function(key)\r\nlocal value=nil\r\n((function()\r\nreturn ((function()\r\n\tlocal _s8_value=((self[\"@handle\"])[key])\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"[\"),key)),\"] \")),(ex):description()))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));return (value)\r\nend))\r\n\tdata=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(\"\\r\\n\")\r\n\tcr=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((((smalltalk:if_true_false_((owned),(function()\r\nreturn ((self):ownPropertyNames())\r\nend),(function()\r\nreturn ((self):propertyNames())\r\nend))):sorted()):inject_into_(\"{\",(function(total,each)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),cr)),each)),\": \")),(text):value_((data):value_(each)))),\";\"))\r\nend))),cr)),\"}\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle,"description",0
,(
function(self)
return ((self):description_(1));
end
)
,"debugging","description\r\n\t\" Return the description of the receiver. \"\r\n\r\n\t^self description: 1","(\r\nfunction(self)\r\nreturn ((self):description_(1));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle,"isFunction:",0
,(
function(self,aHandle)
return ((((self):typeOf_(aHandle))=="function"));
end
)
,"private","isFunction: aHandle\r\n\t\" Return true if aHandle is a function. \"\r\n\r\n\t^(self typeOf: aHandle) == #function","(\r\nfunction(self,aHandle)\r\nreturn ((((self):typeOf_(aHandle))==\"function\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle,"functionNames",0
,(
function(self)
return (((self):propertyNames()):select_((function(each)
return ((self):isFunction_((self):handleAt_(each)))
end)));
end
)
,"accessing","functionNames\r\n\t\" Return the names of property of the receiver of type function. \"\r\n\r\n\t^self propertyNames select: [:each| self isFunction: (self handleAt: each) ]","(\r\nfunction(self)\r\nreturn (((self):propertyNames()):select_((function(each)\r\nreturn ((self):isFunction_((self):handleAt_(each)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle,"functions",0
,(
function(self)
return (((self):functionNames()):collect_((function(each)
return ((smalltalk.Array):with_with_(each,(self):handleAt_(each)))
end)));
end
)
,"accessing","functions\r\n\t\" Return the functions of the receiver as a collection of tuples #(functionName aClosure). \"\r\n\r\n\t^self functionNames collect: [:each|\r\n\t\tArray with: each with: (self handleAt: each)\r\n\t]","(\r\nfunction(self)\r\nreturn (((self):functionNames()):collect_((function(each)\r\nreturn ((smalltalk.Array):with_with_(each,(self):handleAt_(each)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle,"ownFunctionNames",0
,(
function(self)
return (((self):ownPropertyNames()):select_((function(each)
return ((self):isFunction_((self):handleAt_(each)))
end)));
end
)
,"accessing","ownFunctionNames\r\n\t\" Return the names of functions owned/implemented by the receiver. \"\r\n\r\n\t^self ownPropertyNames select: [:each| self isFunction: (self handleAt: each) ]","(\r\nfunction(self)\r\nreturn (((self):ownPropertyNames()):select_((function(each)\r\nreturn ((self):isFunction_((self):handleAt_(each)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle,"hasOwnProperty:",0
,(
function(self,aName)
return (rawget(self["@handle"],aName)~=nil);
end
)
,"testing","hasOwnProperty: aName\r\n\t\" Return true if receiver own a property named aName. \"\r\n\r\n\t^{''}","(\r\nfunction(self,aName)\r\nreturn (rawget(self[\"@handle\"],aName)~=nil);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeHandle,"delete:",0
,(
function(self,aName)
self["@handle"][aName]=nil;
return (self);
end
)
,"actions","delete: aName\r\n\t\" Delete the property named aName in the receiver. \"\r\n\r\n\t{''}","(\r\nfunction(self,aName)\r\nself[\"@handle\"][aName]=nil;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JS["$klass"],"supportsLanguage:",0
,(
function(self,language)
return (smalltalk:isObject_equalTo_((language),"js"));
end
)
,"instantiation","supportsLanguage: language\r\n\t\" Private - Return true if instances of the receiver implement native wrappers for language. \"\r\n\r\n\t^language = #js","(\r\nfunction(self,language)\r\nreturn (smalltalk:isObject_equalTo_((language),\"js\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"propertyNames",0
,(
function(self)
(function() self:invalidMessage_("propertyNames") end)();
return (self);
end
)
,"accessing","propertyNames\r\n\t\" Return the property names of the receiver. \"\r\n\r\n\t{''js'return Object.keys(self.handle())'}","(\r\nfunction(self)\r\n(function() self:invalidMessage_(\"propertyNames\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"prototype",0
,(
function(self)
(function() self:invalidMessage_("prototype") end)();
return (self);
end
)
,"accessing","prototype\r\n\t\" Return the prototype of the receiver. \"\r\n\r\n\t{''js'return smalltalk.JS._at(Object.getPrototypeOf(self[\"@handle\"]))'}","(\r\nfunction(self)\r\n(function() self:invalidMessage_(\"prototype\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"functionNamesAndArguments",0
,(
function(self)
local argList=nil
(function()
	local _s8_value=((function(source)
return ((((
function(_s8_rec)
	(_s8_rec):upTo_("(");
	return ((_s8_rec):upTo_(")"))
end
)(source)):asArrayOfSubstringsSeparatedBy_(",")):collect_((function(arg)
return ((arg):trimBlanks())
end)))
end))
	argList=_s8_value
	return _s8_value
end)();
return (((self):functions()):collect_((function(tuple)
return ((smalltalk.Array):with_with_((tuple):first(),(argList):value_((smalltalk:toString_(((tuple):last()))):stream())))
end)));
end
)
,"accessing","functionNamesAndArguments\r\n\t\" Return the functions of the receiver as a collection of tuples #(functionName argumentsArray). \"\r\n\r\n\t| argList |\r\n\targList := [:source|\r\n\t\t((source upTo: $(; upTo: $)) asArrayOfSubstringsSeparatedBy: $,)\r\n\t\t\tcollect: [:arg| arg trimBlanks ]\r\n\t].\r\n\t^self functions collect: [:tuple| Array with: tuple first with: (argList value: tuple last toString stream) ]","(\r\nfunction(self)\r\nlocal argList=nil\r\n(function()\r\n\tlocal _s8_value=((function(source)\r\nreturn ((((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):upTo_(\"(\");\r\n\treturn ((_s8_rec):upTo_(\")\"))\r\nend\r\n)(source)):asArrayOfSubstringsSeparatedBy_(\",\")):collect_((function(arg)\r\nreturn ((arg):trimBlanks())\r\nend)))\r\nend))\r\n\targList=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((self):functions()):collect_((function(tuple)\r\nreturn ((smalltalk.Array):with_with_((tuple):first(),(argList):value_((smalltalk:toString_(((tuple):last()))):stream())))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"defineProperty:value:writable:enumerable:configurable:",0
,(
function(self,aName,aValue,writable,enumerable,configurable)
return ((self):defineProperty_as_(aName,(smalltalk.Array):with_with_with_with_((smalltalk.Array):with_with_("value",aValue),(smalltalk.Array):with_with_("writable",writable),(smalltalk.Array):with_with_("enumerable",enumerable),(smalltalk.Array):with_with_("configurable",configurable))));
end
)
,"properties","defineProperty: aName\r\n\tvalue: aValue\r\n\twritable: writable\r\n\tenumerable: enumerable\r\n\tconfigurable: configurable\r\n\t\" Define the property named aName in the receiver. \"\r\n\r\n\t^self defineProperty: aName as: ( Array\r\n\t\twith: (Array with: #value with: aValue)\r\n\t\twith: (Array with: #writable with: writable)\r\n\t\twith: (Array with: #enumerable with: enumerable)\r\n\t\twith: (Array with: #configurable with: configurable)\r\n\t)","(\r\nfunction(self,aName,aValue,writable,enumerable,configurable)\r\nreturn ((self):defineProperty_as_(aName,(smalltalk.Array):with_with_with_with_((smalltalk.Array):with_with_(\"value\",aValue),(smalltalk.Array):with_with_(\"writable\",writable),(smalltalk.Array):with_with_(\"enumerable\",enumerable),(smalltalk.Array):with_with_(\"configurable\",configurable))));\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"defineAccessor:get:set:enumerable:configurable:",0
,(
function(self,aName,aBlock,oneArgumentBlock,enumerable,configurable)
return ((self):defineProperty_as_(aName,(smalltalk.Array):with_with_with_with_((smalltalk.Array):with_with_("get",aBlock),(smalltalk.Array):with_with_("set",oneArgumentBlock),(smalltalk.Array):with_with_("enumerable",enumerable),(smalltalk.Array):with_with_("configurable",configurable))));
end
)
,"properties","defineAccessor: aName\r\n\tget: aBlock\r\n\tset: oneArgumentBlock\r\n\tenumerable: enumerable\r\n\tconfigurable: configurable\r\n\t\" Define the Accessor property named aName in the receiver. \"\r\n\r\n\t^self defineProperty: aName as: ( Array\r\n\t\twith: (Array with: #get with: aBlock)\r\n\t\twith: (Array with: #set with: oneArgumentBlock)\r\n\t\twith: (Array with: #enumerable with: enumerable)\r\n\t\twith: (Array with: #configurable with: configurable)\r\n\t)","(\r\nfunction(self,aName,aBlock,oneArgumentBlock,enumerable,configurable)\r\nreturn ((self):defineProperty_as_(aName,(smalltalk.Array):with_with_with_with_((smalltalk.Array):with_with_(\"get\",aBlock),(smalltalk.Array):with_with_(\"set\",oneArgumentBlock),(smalltalk.Array):with_with_(\"enumerable\",enumerable),(smalltalk.Array):with_with_(\"configurable\",configurable))));\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"defineProperty:value:writable:enumerable:",0
,(
function(self,aName,aValue,writable,enumerable)
return ((self):defineProperty_as_(aName,(smalltalk.Array):with_with_with_((smalltalk.Array):with_with_("value",aValue),(smalltalk.Array):with_with_("writable",writable),(smalltalk.Array):with_with_("enumerable",enumerable))));
end
)
,"properties","defineProperty: aName\r\n\tvalue: aValue\r\n\twritable: writable\r\n\tenumerable: enumerable\r\n\t\" Define the property named aName in the receiver. \"\r\n\r\n\t^self defineProperty: aName as: ( Array\r\n\t\twith: (Array with: #value with: aValue)\r\n\t\twith: (Array with: #writable with: writable)\r\n\t\twith: (Array with: #enumerable with: enumerable)\r\n\t)","(\r\nfunction(self,aName,aValue,writable,enumerable)\r\nreturn ((self):defineProperty_as_(aName,(smalltalk.Array):with_with_with_((smalltalk.Array):with_with_(\"value\",aValue),(smalltalk.Array):with_with_(\"writable\",writable),(smalltalk.Array):with_with_(\"enumerable\",enumerable))));\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"defineProperty:value:writable:",0
,(
function(self,aName,aValue,writable)
return ((self):defineProperty_as_(aName,(smalltalk.Array):with_with_((smalltalk.Array):with_with_("value",aValue),(smalltalk.Array):with_with_("writable",writable))));
end
)
,"properties","defineProperty: aName\r\n\tvalue: aValue\r\n\twritable: writable\r\n\t\" Define the property named aName in the receiver. \"\r\n\r\n\t^self defineProperty: aName as: ( Array\r\n\t\twith: (Array with: #value with: aValue)\r\n\t\twith: (Array with: #writable with: writable)\r\n\t)","(\r\nfunction(self,aName,aValue,writable)\r\nreturn ((self):defineProperty_as_(aName,(smalltalk.Array):with_with_((smalltalk.Array):with_with_(\"value\",aValue),(smalltalk.Array):with_with_(\"writable\",writable))));\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"defineProperty:value:",0
,(
function(self,aName,aValue)
return ((self):defineProperty_as_(aName,(smalltalk.Array):with_((smalltalk.Array):with_with_("value",aValue))));
end
)
,"properties","defineProperty: aName value: aValue\r\n\t\" Define the property named aName in the receiver. \"\r\n\r\n\t^self defineProperty: aName as: ( Array\r\n\t\twith: (Array with: #value with: aValue)\r\n\t)","(\r\nfunction(self,aName,aValue)\r\nreturn ((self):defineProperty_as_(aName,(smalltalk.Array):with_((smalltalk.Array):with_with_(\"value\",aValue))));\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"defineProperty:",0
,(
function(self,aName)
return ((self):defineProperty_as_(aName,(smalltalk.Object):new()));
end
)
,"properties","defineProperty: aName\r\n\t\" Define the property named aName in the receiver. \"\r\n\r\n\t^self defineProperty: aName as: Object new","(\r\nfunction(self,aName)\r\nreturn ((self):defineProperty_as_(aName,(smalltalk.Object):new()));\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"defineProperty:as:",0
,(
function(self,aName,descriptor)
if ((descriptor):isArray())==true then return ((self):defineProperty_as_(aName,(descriptor):inject_into_((smalltalk.Object):new(),(function(result,tuple)
if (smalltalk:notNil_(((tuple):last())))==true then smalltalk:basic_at_put_((result),(tuple):first(),(tuple):last()); end;return (result)
end)))); end;
(function() self:invalidMessage_("defineProperty:as:") end)();
return (self);
end
)
,"properties","defineProperty: aName as: descriptor\r\n\t\" Define the property named aName in the receiver. \"\r\n\r\n\tdescriptor isArray ifTrue: [\r\n\t\t^self defineProperty: aName as: (descriptor\r\n\t\t\tinject: Object new into: [:result :tuple|\r\n\t\t\t\ttuple last notNil ifTrue: [\r\n\t\t\t\t\tresult basicAt: tuple first put: tuple last\r\n\t\t\t\t].\r\n\t\t\t\tresult\r\n\t\t\t])\r\n\t].\r\n\r\n\t{''js'return Object.defineProperty(self[\"@handle\"],aName,descriptor)'}","(\r\nfunction(self,aName,descriptor)\r\nif ((descriptor):isArray())==true then return ((self):defineProperty_as_(aName,(descriptor):inject_into_((smalltalk.Object):new(),(function(result,tuple)\r\nif (smalltalk:notNil_(((tuple):last())))==true then smalltalk:basic_at_put_((result),(tuple):first(),(tuple):last()); end;return (result)\r\nend)))); end;\r\n(function() self:invalidMessage_(\"defineProperty:as:\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"defineProperties:",0
,(
function(self,descriptors)
(function() self:invalidMessage_("defineProperties:") end)();
return (self);
end
)
,"properties","defineProperties: descriptors\r\n\t\" Define the properties in the receiver. \"\r\n\r\n\t{''js'return Object.defineProperties(self[\"@handle\"],descriptors)'}","(\r\nfunction(self,descriptors)\r\n(function() self:invalidMessage_(\"defineProperties:\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"preventExtensions",0
,(
function(self)
(function() self:invalidMessage_("preventExtensions") end)();
return (self);
end
)
,"actions","preventExtensions\r\n\t\" Set the receiver as non-extensible. \"\r\n\r\n\t{''js'return Object.preventExtensions(self[\"@handle\"])'}","(\r\nfunction(self)\r\n(function() self:invalidMessage_(\"preventExtensions\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"freeze",0
,(
function(self)
(function() self:invalidMessage_("freeze") end)();
return (self);
end
)
,"actions","freeze\r\n\t\" Prevents the modification of existing property attributes and values, and prevents the addition of new properties. \"\r\n\r\n\t{''js'return Object.freeze(self[\"@handle\"])'}","(\r\nfunction(self)\r\n(function() self:invalidMessage_(\"freeze\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"seal",0
,(
function(self)
(function() self:invalidMessage_("seal") end)();
return (self);
end
)
,"actions","seal\r\n\t\" Prevents the modification of attributes of existing properties, and prevents the addition of new properties. \"\r\n\r\n\t{''js'return Object.seal(self[\"@handle\"])'}","(\r\nfunction(self)\r\n(function() self:invalidMessage_(\"seal\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"isExtensible",0
,(
function(self)
(function() self:invalidMessage_("isExtensible") end)();
return (self);
end
)
,"testing","isExtensible\r\n\t\" Return true if the receiver is extensible. \"\r\n\r\n\t{''js'return Object.isExtensible(self[\"@handle\"])'}","(\r\nfunction(self)\r\n(function() self:invalidMessage_(\"isExtensible\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"isFrozen",0
,(
function(self)
(function() self:invalidMessage_("isFrozen") end)();
return (self);
end
)
,"testing","isFrozen\r\n\t\" Return true if the receiver is frozen. \"\r\n\r\n\t{''js'return Object.isFrozen(self[\"@handle\"])'}","(\r\nfunction(self)\r\n(function() self:invalidMessage_(\"isFrozen\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"isSealed",0
,(
function(self)
(function() self:invalidMessage_("isSealed") end)();
return (self);
end
)
,"testing","isSealed\r\n\t\" Return true if the receiver is sealed. \"\r\n\r\n\t{''js'return Object.isSealed(self[\"@handle\"])'}","(\r\nfunction(self)\r\n(function() self:invalidMessage_(\"isSealed\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"create:with:",0
,(
function(self,prototype,descriptors)
(function() self:invalidMessage_("create:with:") end)();
return (self);
end
)
,"creation","create: prototype with: descriptors\r\n\t\" Return a JS object that has been created with the specified prototype, and that optionally contains specified properties. \"\r\n\r\n\t{''js'return smalltalk.JS._at(Object.create(prototype,descriptors))'}","(\r\nfunction(self,prototype,descriptors)\r\n(function() self:invalidMessage_(\"create:with:\") end)();\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.JS,"createWith:",0
,(
function(self,descriptors)
return ((self):create_with_(self["@handle"],descriptors));
end
)
,"creation","createWith: descriptors\r\n\t\" Return a JS object that has been created with the handle prototype, and that optionally contains specified properties. \"\r\n\r\n\t^self create: handle with: descriptors","(\r\nfunction(self,descriptors)\r\nreturn ((self):create_with_(self[\"@handle\"],descriptors));\r\nend\r\n)")
smalltalk:bind(smalltalk.Lua["$klass"],"supportsLanguage:",0
,(
function(self,language)
return (smalltalk:isObject_equalTo_((language),"lua"));
end
)
,"instantiation","supportsLanguage: language\r\n\t\" Private - Return true if instances of the receiver implement native wrappers for language. \"\r\n\r\n\t^language = #lua","(\r\nfunction(self,language)\r\nreturn (smalltalk:isObject_equalTo_((language),\"lua\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Lua["$klass"],"global",0
,(
function(self)
return ((self):_at((smalltalk.Smalltalk):global()));
end
)
,"accessing","global\r\n\t\" Return an instance wrapping global. \"\r\n\r\n\t^self @ Smalltalk global","(\r\nfunction(self)\r\nreturn ((self):_at((smalltalk.Smalltalk):global()));\r\nend\r\n)")
smalltalk:bind(smalltalk.Lua["$klass"],"version",0
,(
function(self)
return (((self):global()):_at("_VERSION"));
end
)
,"accessing","version\r\n\t\" Return the host version. \"\r\n\r\n\t^self global @ #_VERSION","(\r\nfunction(self)\r\nreturn (((self):global()):_at(\"_VERSION\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.Lua["$klass"],"arg",0
,(
function(self)
return ((smalltalk.Array):_at(((self):global()):_at("arg")));
end
)
,"accessing","arg\r\n\t\" Return the main arguments (anArray of strings). \"\r\n\r\n\t^Array @ (self global @ #arg)","(\r\nfunction(self)\r\nreturn ((smalltalk.Array):_at(((self):global()):_at(\"arg\")));\r\nend\r\n)")
smalltalk:bind(smalltalk.Lua["$klass"],"require:",0
,(
function(self,aName)
return ((self):_at(require(aName)));
end
)
,"modules","require: aName\r\n\t\" Return an instance of the receiver obtained from loading module aName. (or nil) \"\r\n\r\n\t^self @ (# #require: aName)","(\r\nfunction(self,aName)\r\nreturn ((self):_at(require(aName)));\r\nend\r\n)")
smalltalk:bind(smalltalk.Lua,"propertyNames",0
,(
function(self)
return ((self):ownPropertyNames());
end
)
,"accessing","propertyNames\r\n\t\" Return the property names of the receiver. \"\r\n\r\n\t^self ownPropertyNames","(\r\nfunction(self)\r\nreturn ((self):ownPropertyNames());\r\nend\r\n)")
smalltalk:bind(smalltalk.Lua,"do:",0
,(
function(self,aBlock)
	for item in self:handle() do aBlock(item) end;
return (self);
end
)
,"iteration","do: aBlock\r\n\t\" Evaluates aBlock on each element of the receiver. \"\r\n\r\n{''js'\tself.invalidMessage_(\"do:\")'\r\nlua'\tfor item in self:handle() do aBlock(item) end'}.","(\r\nfunction(self,aBlock)\r\n\tfor item in self:handle() do aBlock(item) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Lua,"pairsDo:",0
,(
function(self,aBlock)
	for k,v in pairs(self:handle()) do aBlock(k,v) end;
return (self);
end
)
,"iteration","pairsDo: aBlock\r\n\t\" Evaluates aBlock on each key/value pair of the receiver. \"\r\n\r\n{''js'\tself.invalidMessage_(\"pairsDo:\")'\r\nlua'\tfor k,v in pairs(self:handle()) do aBlock(k,v) end'}.","(\r\nfunction(self,aBlock)\r\n\tfor k,v in pairs(self:handle()) do aBlock(k,v) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Lua,"keysDo:",0
,(
function(self,aBlock)
	for k,_ in pairs(self:handle()) do aBlock(k) end;
return (self);
end
)
,"iteration","keysDo: aBlock\r\n\t\" Evaluates aBlock on each key of the receiver. \"\r\n\r\n{''js'\tself.invalidMessage_(\"keysDo:\")'\r\nlua'\tfor k,_ in pairs(self:handle()) do aBlock(k) end'}.","(\r\nfunction(self,aBlock)\r\n\tfor k,_ in pairs(self:handle()) do aBlock(k) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.Lua,"valuesDo:",0
,(
function(self,aBlock)
	for _,v in pairs(self:handle()) do aBlock(k,v) end;
return (self);
end
)
,"iteration","valuesDo: aBlock\r\n\t\" Evaluates aBlock on each value of the receiver. \"\r\n\r\n{''js'\tself.invalidMessage_(\"valuesDo:\")'\r\nlua'\tfor _,v in pairs(self:handle()) do aBlock(k,v) end'}.","(\r\nfunction(self,aBlock)\r\n\tfor _,v in pairs(self:handle()) do aBlock(k,v) end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"globalName",0
,(
function(self)
return ((self):subclassResponsibility_("globalName"));
end
)
,"private","globalName\r\n\t\" Private - Return the name of the global to detect/access the library of the receiver. \"\r\n\r\n\t^self subclassResponsibility: #globalName","(\r\nfunction(self)\r\nreturn ((self):subclassResponsibility_(\"globalName\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"topGlobal",0
,(
function(self)
return ((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_("window",(function()
return ((self):error_("Missing window support"))
end)));
end
)
,"private","topGlobal\r\n\t\" Private - Return the object to access the global during detection stage.\r\n\tThe default implementation return window global (present when running in a web browser).\r\n\tThis method must be refined by the subclasses requiring other root dependences.\r\n\tCan return nil to do not check dependents.\r\n\t\"\r\n\r\n\t^Smalltalk nativeObjectAt: #window ifAbsent: [ self error: 'Missing window support' ].","(\r\nfunction(self)\r\nreturn ((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(\"window\",(function()\r\nreturn ((self):error_(\"Missing window support\"))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"requiredFeatures",0
,(
function(self)
return (smalltalk:newArray({}));
end
)
,"private","requiredFeatures\r\n\t\" Private - Return the names of the required properties/features to execute the receiver.\r\n\tThe default implementation do not check dependents.\r\n\tThis method can be refined by subclasses to ensure features to run the receiver are present in this system.\r\n\t\"\r\n\r\n\t^#()","(\r\nfunction(self)\r\nreturn (smalltalk:newArray({}));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"classNamed:",0
,(
function(self,className)
local library=nil
(function()
	local _s8_value=((self):library())
	library=_s8_value
	return _s8_value
end)();
return (library[className]);
end
)
,"private","classNamed: className\r\n\t\" Private - Return the class named className in the receiver's library.\r\n\tThe default implementation get the class from library.\r\n\tSubclasses can refine to obtain classes from anywhere\r\n\t\te.g. global scope with: ^self global: className.\r\n\t\"\r\n\r\n\t| library |\r\n\tlibrary := self library.\r\n\t^library[className]","(\r\nfunction(self,className)\r\nlocal library=nil\r\n(function()\r\n\tlocal _s8_value=((self):library())\r\n\tlibrary=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (library[className]);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"sourceCode",0
,(
function(self)
return ((self):subclassResponsibility_("sourceCode"));
end
)
,"private","sourceCode\r\n\t\" Private - Return the (native) source code of the library as a String.\r\n\tThis method can be implemented by subclasses loading sources from external media or simply returning aString embedded in this method.\r\n\tA reference/link to source origin is appreciated by users.\r\n\tCAUTION: S8 is MIT, so you MUST embedd here MIT compatible sources.\r\n\t\"\r\n\r\n\t^self subclassResponsibility: #sourceCode","(\r\nfunction(self)\r\nreturn ((self):subclassResponsibility_(\"sourceCode\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"libraryBound:",0
,(
function(self,aClassName)
((self):bindingListeners()):do_((function(each)
return ((each):libraryBound_(aClassName))
end));
return (self);
end
)
,"binding","libraryBound: aClassName\r\n\t\" Private - The library of aClassName has just been bound to this system. \"\r\n\r\n\tself bindingListeners do: [:each| each libraryBound: aClassName ]","(\r\nfunction(self,aClassName)\r\n((self):bindingListeners()):do_((function(each)\r\nreturn ((each):libraryBound_(aClassName))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"bindingListeners",0
,(
function(self)
if (smalltalk:isNil_((smalltalk.NativeLibraryObject:classVariableAt_("BindingListeners"))))==true then smalltalk.NativeLibraryObject:classVariableAt_put_("BindingListeners",(smalltalk.Array):new()); end;
return (smalltalk.NativeLibraryObject:classVariableAt_("BindingListeners"));
end
)
,"binding","bindingListeners\r\n\t\" Private - Return the collection of listeners to library binding notifications of this system. \"\r\n\r\n\tBindingListeners isNil ifTrue: [ BindingListeners := Array new ].\r\n\t^BindingListeners","(\r\nfunction(self)\r\nif (smalltalk:isNil_((smalltalk.NativeLibraryObject:classVariableAt_(\"BindingListeners\"))))==true then smalltalk.NativeLibraryObject:classVariableAt_put_(\"BindingListeners\",(smalltalk.Array):new()); end;\r\nreturn (smalltalk.NativeLibraryObject:classVariableAt_(\"BindingListeners\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"globalName:",0
,(
function(self,aName)
return (((self)["$klass"]):implement_comment_as_category_("globalName","Private - Return the name of the global to detect/access the library of the receiver.",smalltalk:object_comma_(("^"),smalltalk:printString_((aName))),"private"));
end
)
,"builder","globalName: aName\r\n\t\" Generate code to return the name of the global to detect/access the library of the receiver. \"\r\n\r\n\t^self class\r\n\t\timplement: #globalName\r\n\t\tcomment: 'Private - Return the name of the global to detect/access the library of the receiver.'\r\n\t\tas: '^' ,aName printString\r\n\t\tcategory: #private","(\r\nfunction(self,aName)\r\nreturn (((self)[\"$klass\"]):implement_comment_as_category_(\"globalName\",\"Private - Return the name of the global to detect/access the library of the receiver.\",smalltalk:object_comma_((\"^\"),smalltalk:printString_((aName))),\"private\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"libraryURL:",0
,(
function(self,anURL)
return (((self)["$klass"]):implement_comment_as_category_("libraryURL","Private - Return the URL to use when loading library of the receiver.",smalltalk:object_comma_(("^"),smalltalk:printString_((anURL))),"private"));
end
)
,"builder","libraryURL: anURL\r\n\t\" Generate the method to return libraryURL. \"\r\n\r\n\t^self class\r\n\t\timplement: #libraryURL\r\n\t\tcomment: 'Private - Return the URL to use when loading library of the receiver.'\r\n\t\tas: '^' ,anURL printString\r\n\t\tcategory: #private","(\r\nfunction(self,anURL)\r\nreturn (((self)[\"$klass\"]):implement_comment_as_category_(\"libraryURL\",\"Private - Return the URL to use when loading library of the receiver.\",smalltalk:object_comma_((\"^\"),smalltalk:printString_((anURL))),\"private\"));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"globalClassNameFrom:",0
,(
function(self,globalClassName)
return (globalClassName);
end
)
,"private","globalClassNameFrom: globalClassName\r\n\t\" Private - Return the global class name for global globalClassName.\r\n\tIt must return the (global) name of the constructor used to instantiate instance handles.\r\n\tThe default action is to return the globalClassName.\r\n\tThis method can be refined by subclasses to adapt name to (case sensitive) library constructor names.\r\n\t\"\r\n\r\n\t^globalClassName","(\r\nfunction(self,globalClassName)\r\nreturn (globalClassName);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"selectorForConstantNamed:",0
,(
function(self,aName)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(aName):detect_ifNone_((function(c)
return ((c):isLowercase())
end),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (((aName):asLowercase()):asSmalltalkName_(false))
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aName):asSmalltalkName_(false))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"builder","selectorForConstantNamed: aName\r\n\t\" Private - Return the selector to use for constant aName. \"\r\n\r\n\taName detect: [:c| c isLowercase ] ifNone: [\r\n\t\t^aName asLowercase asSmalltalkName: false\r\n\t].\r\n\t^aName asSmalltalkName: false","(\r\nfunction(self,aName)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(aName):detect_ifNone_((function(c)\r\nreturn ((c):isLowercase())\r\nend),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (((aName):asLowercase()):asSmalltalkName_(false))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aName):asSmalltalkName_(false))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"constants:",0
,(
function(self,names)
(names):do_((function(each)
return (((self)["$klass"]):implement_comment_as_category_((self):selectorForConstantNamed_(each),smalltalk:object_comma_(("Return the value of "),each),smalltalk:object_comma_(("^self library basicAt: #"),each),"accessing"))
end));
return (self);
end
)
,"builder","constants: names\r\n\t\" Private - Build methods to access library globals. \"\r\n\r\n\tnames do: [:each|\r\n\t\tself class\r\n\t\t\timplement: (self selectorForConstantNamed: each)\r\n\t\t\tcomment: 'Return the value of ',each\r\n\t\t\tas: '^self library basicAt: #',each\r\n\t\t\tcategory: #accessing\r\n\t].","(\r\nfunction(self,names)\r\n(names):do_((function(each)\r\nreturn (((self)[\"$klass\"]):implement_comment_as_category_((self):selectorForConstantNamed_(each),smalltalk:object_comma_((\"Return the value of \"),each),smalltalk:object_comma_((\"^self library basicAt: #\"),each),\"accessing\"))\r\nend));\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"buildSubclass:arguments:typed:",0
,(
function(self,globalClassName,argList,typedArguments)
local cls=nil
local clsName=nil
(function()
	local _s8_value=(smalltalk:object_comma_((((globalClassName):first()):asUppercase()),(globalClassName):copyFrom_to_(2,(globalClassName):size())))
	clsName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:object_comma_(((self):classToken()),clsName))
	clsName=_s8_value
	return _s8_value
end)();
(self):subclass_instanceVariableNames_category_(clsName,"",(self):category());
if (smalltalk:boolean_or_((smalltalk:isNil_((argList))),(function()
return (smalltalk:isObject_equalTo_((argList),"nil"))
end)))==true then return (self); end;
(function()
	local _s8_value=((smalltalk.Smalltalk):at_(clsName))
	cls=_s8_value
	return _s8_value
end)();
((cls)["$klass"]):implement_comment_as_category_("globalClassName","Private - Return the internal class name.",smalltalk:object_comma_(("^self globalClassNameFrom: #"),globalClassName),"private");
if ((argList):isEmpty())==true then (cls):implement_comment_as_category_("initializeHandle","Private - Initialize the receiver's handle.","self handle: (self newHandleOf: self class globalClassName)","initialize"); else local selector=nil
local args=nil
local current=nil
(function()
	local _s8_value=((argList):inject_into_("",(function(total,each)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),each)),": ")),each))," "))
end)))
	selector=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((argList):inject_into_("",(function(total,each)
if (smalltalk:boolean_or_((smalltalk:isObject_equalTo_((typedArguments),"all")),(function()
return ((typedArguments):includes_(each))
end)))==true then (function()
	local _s8_value=(" handle ")
	current=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=(" ")
	current=_s8_value
	return _s8_value
end)(); end;return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),"with: ")),each)),current))
end)))
	args=_s8_value
	return _s8_value
end)();
((cls)["$klass"]):implement_comment_as_category_(selector,"Return an instance of the receiver.",smalltalk:object_comma_(("^self basicNew "),selector),"instantiation");
(cls):implement_comment_as_category_(selector,"Private - Initialize the receiver.",smalltalk:object_comma_((smalltalk:object_comma_(("self handle: (self newHandleOf: self class globalClassName "),args)),")"),"initialize"); end;
return (self);
end
)
,"builder","buildSubclass: globalClassName arguments: argList typed: typedArguments\r\n\t\" Private - Build a subclass of the receiver implementing a wrapper to the library. \"\r\n\r\n\t| cls clsName |\r\n\tclsName := globalClassName first asUppercase\r\n\t\t\t,(globalClassName copyFrom: 2 to: globalClassName size).\r\n\tclsName := self classToken ,clsName.\r\n\tself\r\n\t\tsubclass: clsName\r\n\t\tinstanceVariableNames: ''\r\n\t\tcategory: self category.\r\n\t(argList isNil or: [ argList = #nil ]) ifTrue: [ ^self ].\r\n\r\n\tcls := Smalltalk at: clsName.\r\n\tcls class\r\n\t\timplement: #globalClassName\r\n\t\tcomment: 'Private - Return the internal class name.'\r\n\t\tas: '^self globalClassNameFrom: #' ,globalClassName\r\n\t\tcategory: #private.\r\n\targList isEmpty ifTrue: [\r\n\t\tcls\r\n\t\t\timplement: #initializeHandle\r\n\t\t\tcomment: 'Private - Initialize the receiver''s handle.'\r\n\t\t\tas: 'self handle: (self newHandleOf: self class globalClassName)'\r\n\t\t\tcategory: #initialize.\r\n\t] ifFalse: [ | selector args current |\r\n\t\tselector := argList inject: '' into: [:total :each| total ,each,': ',each,' ' ].\r\n\t\targs := argList inject: '' into: [:total :each|\r\n\t\t\t(typedArguments = #all\r\n\t\t\t  or: [ typedArguments includes: each ])\r\n\t\t\t  ifTrue: [ current := ' handle ' ]\r\n\t\t\t  ifFalse: [ current := ' ' ].\r\n\t\t\ttotal ,'with: ',each, current\r\n\t\t].\r\n\t\tcls class\r\n\t\t\timplement: selector\r\n\t\t\tcomment: 'Return an instance of the receiver.'\r\n\t\t\tas: '^self basicNew ',selector\r\n\t\t\tcategory: #instantiation.\r\n\t\tcls\r\n\t\t\timplement: selector\r\n\t\t\tcomment: 'Private - Initialize the receiver.'\r\n\t\t\tas: 'self handle: (self newHandleOf: self class globalClassName ' ,args ,')'\r\n\t\t\tcategory: #initialize.\r\n\t].","(\r\nfunction(self,globalClassName,argList,typedArguments)\r\nlocal cls=nil\r\nlocal clsName=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((((globalClassName):first()):asUppercase()),(globalClassName):copyFrom_to_(2,(globalClassName):size())))\r\n\tclsName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((self):classToken()),clsName))\r\n\tclsName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):subclass_instanceVariableNames_category_(clsName,\"\",(self):category());\r\nif (smalltalk:boolean_or_((smalltalk:isNil_((argList))),(function()\r\nreturn (smalltalk:isObject_equalTo_((argList),\"nil\"))\r\nend)))==true then return (self); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_(clsName))\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((cls)[\"$klass\"]):implement_comment_as_category_(\"globalClassName\",\"Private - Return the internal class name.\",smalltalk:object_comma_((\"^self globalClassNameFrom: #\"),globalClassName),\"private\");\r\nif ((argList):isEmpty())==true then (cls):implement_comment_as_category_(\"initializeHandle\",\"Private - Initialize the receiver's handle.\",\"self handle: (self newHandleOf: self class globalClassName)\",\"initialize\"); else local selector=nil\r\nlocal args=nil\r\nlocal current=nil\r\n(function()\r\n\tlocal _s8_value=((argList):inject_into_(\"\",(function(total,each)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),each)),\": \")),each)),\" \"))\r\nend)))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((argList):inject_into_(\"\",(function(total,each)\r\nif (smalltalk:boolean_or_((smalltalk:isObject_equalTo_((typedArguments),\"all\")),(function()\r\nreturn ((typedArguments):includes_(each))\r\nend)))==true then (function()\r\n\tlocal _s8_value=(\" handle \")\r\n\tcurrent=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=(\" \")\r\n\tcurrent=_s8_value\r\n\treturn _s8_value\r\nend)(); end;return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),\"with: \")),each)),current))\r\nend)))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((cls)[\"$klass\"]):implement_comment_as_category_(selector,\"Return an instance of the receiver.\",smalltalk:object_comma_((\"^self basicNew \"),selector),\"instantiation\");\r\n(cls):implement_comment_as_category_(selector,\"Private - Initialize the receiver.\",smalltalk:object_comma_((smalltalk:object_comma_((\"self handle: (self newHandleOf: self class globalClassName \"),args)),\")\"),\"initialize\"); end;\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"global:",0
,(
function(self,globalName)
local result=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(globalName,(function()
return (nil)
end)))
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((result)))==true then return (result); end;
if not (((self):isValid()))==true then return (nil); end;
(self):libraryLoaded_((self):loadLibrary());
return ((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(globalName,(function()
return (nil)
end)));
end
)
,"accessing","global: globalName\r\n\t\" Private - Return the native library global object (or nil). \"\r\n\r\n\t| result |\r\n\tresult := Smalltalk nativeObjectAt: globalName ifAbsent: [ nil ].\r\n\tresult notNil ifTrue: [ ^result ].\r\n\tself isValid ifFalse: [ ^nil ].\r\n\tself libraryLoaded: self loadLibrary.\r\n\t^Smalltalk nativeObjectAt: globalName ifAbsent: [ nil ]","(\r\nfunction(self,globalName)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(globalName,(function()\r\nreturn (nil)\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((result)))==true then return (result); end;\r\nif not (((self):isValid()))==true then return (nil); end;\r\n(self):libraryLoaded_((self):loadLibrary());\r\nreturn ((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(globalName,(function()\r\nreturn (nil)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"library",0
,(
function(self)
return ((self):global_((self):globalName()));
end
)
,"validation","library\r\n\t\" Check support to run this framework and try to load the library implementation.\r\n\tReturn the native library object if success.\r\n\t\"\r\n\r\n\t^self global: self globalName","(\r\nfunction(self)\r\nreturn ((self):global_((self):globalName()));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"libraryOrNil",0
,(
function(self)
return ((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_((self):globalName(),(function()
return (nil)
end)));
end
)
,"validation","libraryOrNil\r\n\t\" Quick Check - Return true if the library is already bound. \"\r\n\r\n\t^Smalltalk nativeObjectAt: self globalName ifAbsent: [ nil ]","(\r\nfunction(self)\r\nreturn ((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_((self):globalName(),(function()\r\nreturn (nil)\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"nativeClass",0
,(
function(self)
return ((smalltalk.NativeHandle):_at((self):library()));
end
)
,"private","nativeClass\r\n\t\" Private - Return the wrapper for native binding of the receiver.\r\n\tThe default result is a NativeHandle instance wrapping the receiver's library,\r\n\t so static(class side) builders generate bindings accessing receiver's library.\r\n\t\"\r\n\r\n\t^NativeHandle @ self library","(\r\nfunction(self)\r\nreturn ((smalltalk.NativeHandle):_at((self):library()));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"libraryURLs",0
,(
function(self)
return (((smalltalk.Array):with_((self):libraryURL())):select_((function(each)
return (smalltalk:notNil_((each)))
end)));
end
)
,"private","libraryURLs\r\n\t\" Private - Return a collection of URL to load library of the receiver.\r\n\tReturn an empty collection, the subclasses can complement addresses to load library from external resources.\r\n\t\"\r\n\r\n\t^(Array with: self libraryURL) select: [:each| each notNil ]","(\r\nfunction(self)\r\nreturn (((smalltalk.Array):with_((self):libraryURL())):select_((function(each)\r\nreturn (smalltalk:notNil_((each)))\r\nend)));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"libraryURL",0
,(
function(self)
return (nil);
end
)
,"private","libraryURL\r\n\t\" Private - Return the URL to use when loading library of the receiver.\r\n\tDefault implementation do not provide support to load library.\r\n\t\"\r\n\r\n\t^nil","(\r\nfunction(self)\r\nreturn (nil);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"basicLoad:",0
,(
function(self,url)
require(url);
return (self);
end
)
,"loading","basicLoad: url\r\n\t\" Private - Try to load the library at url. \"\r\n\r\n\t{''js'load(url)'}","(\r\nfunction(self,url)\r\nrequire(url);\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"onLoad:",0
,(
function(self,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local dom=nil
local success=nil
if (smalltalk:notNil_(((self):libraryOrNil())))==true then return ((aBlock):value_((self):library())); end;
(function()
	local _s8_value=((function()
(smalltalk.NativeLibraryObject):libraryBound_((self):name());return ((aBlock):value_((self):library()))
end))
	success=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.Smalltalk):at_ifAbsent_("DOM",(function()
((self):libraryURLs()):do_((function(each)
return ((self):basicLoad_(each))
end));return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((success):value())
end
)()
error(_s8Ret_,0)
end)())
end)))
	dom=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (((dom):document()):loadAll_onLoad_((self):libraryURLs(),(function()
return ((success):value())
end)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
)
,"private","onLoad: aBlock\r\n\t\" Private - Load the library of the receiver and evaluates aBlock. \"\r\n\r\n\t| dom success |\r\n\tself libraryOrNil notNil ifTrue: [ ^aBlock value: self library ].\r\n\tsuccess := [\r\n\t\tNativeLibraryObject libraryBound: self name.\r\n\t\taBlock value: self library\r\n\t].\r\n\tdom := Smalltalk at: #DOM ifAbsent: [\r\n\t\tself libraryURLs do: [:each| self basicLoad: each ].\r\n\t\t^success value\r\n\t].\r\n\t^dom document\r\n\t\tloadAll: self libraryURLs\r\n\t\tonLoad: [ success value ]","(\r\nfunction(self,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal dom=nil\r\nlocal success=nil\r\nif (smalltalk:notNil_(((self):libraryOrNil())))==true then return ((aBlock):value_((self):library())); end;\r\n(function()\r\n\tlocal _s8_value=((function()\r\n(smalltalk.NativeLibraryObject):libraryBound_((self):name());return ((aBlock):value_((self):library()))\r\nend))\r\n\tsuccess=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(\"DOM\",(function()\r\n((self):libraryURLs()):do_((function(each)\r\nreturn ((self):basicLoad_(each))\r\nend));return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((success):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tdom=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (((dom):document()):loadAll_onLoad_((self):libraryURLs(),(function()\r\nreturn ((success):value())\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"loadLibrary",0
,(
function(self)
if (((self):libraryURLs()):notEmpty())==true then return ((self):onLoad_((function(ignored)
return (nil)
end))); end;
return (((smalltalk.Smalltalk):current()):eval_as_((self):sourceCode(),(smalltalk.Array):with_with_("loadLibrary",(self):name())));
end
)
,"private","loadLibrary\r\n\t\" Private - Load the library of the receiver.\r\n\tDefault implementation load the library from remote URL or sourceCode.\r\n\t\"\r\n\r\n\tself libraryURLs notEmpty ifTrue: [ ^self onLoad: [:ignored| ] ].\r\n\t^Smalltalk current\r\n\t\teval: self sourceCode\r\n\t\tas: (Array with: #loadLibrary with: self name)","(\r\nfunction(self)\r\nif (((self):libraryURLs()):notEmpty())==true then return ((self):onLoad_((function(ignored)\r\nreturn (nil)\r\nend))); end;\r\nreturn (((smalltalk.Smalltalk):current()):eval_as_((self):sourceCode(),(smalltalk.Array):with_with_(\"loadLibrary\",(self):name())));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"libraryLoaded:",0
,(
function(self,loadResult)
return (self);
end
)
,"private","libraryLoaded: loadResult\r\n\t\" Private - The library of the receiver has been loaded.\r\n\tDefault implementation do nothing.\r\n\tThis method can be refined by subclasses to perform postLoading actions.\r\n\tThe loadResult argument is the result of the just evaluated load process.\r\n\t\"","(\r\nfunction(self,loadResult)\r\nreturn (self);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject["$klass"],"isValid",0
,(
function(self)
local global=nil
(function()
	local _s8_value=((self):topGlobal())
	global=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((global)))==true then return (true); end;
((self):requiredFeatures()):do_((function(each)
return (smalltalk:if_true_false_((smalltalk:isNil_((global[each]))),(function()
return ((self):error_(smalltalk:object_comma_(("Missing support for "),each)))
end),nil))
end));
return (true);
end
)
,"validation","isValid\r\n\t\" Return true if the receiver is valid in this (browser) context.\r\n\tGenerate error if the minimum support to run the library is not available.\r\n\t\"\r\n\r\n\t| global |\r\n\tglobal := self topGlobal.\r\n\tglobal isNil ifTrue: [ ^true ]. \"always valid\"\r\n\tself requiredFeatures do: [:each|\r\n\t  global[each] isNil ifTrue: [\r\n\t    self error: 'Missing support for ',each\r\n\t  ].\r\n\t].\r\n\t^true","(\r\nfunction(self)\r\nlocal global=nil\r\n(function()\r\n\tlocal _s8_value=((self):topGlobal())\r\n\tglobal=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((global)))==true then return (true); end;\r\n((self):requiredFeatures()):do_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((global[each]))),(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Missing support for \"),each)))\r\nend),nil))\r\nend));\r\nreturn (true);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject,"library",0
,(
function(self)
return (((self)["$klass"]):library());
end
)
,"private","library\r\n\t\" Private - Return the library of the receiver. \"\r\n\r\n\t^self class library","(\r\nfunction(self)\r\nreturn (((self)[\"$klass\"]):library());\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject,"classNamed:",0
,(
function(self,className)
return (((self)["$klass"]):classNamed_(className));
end
)
,"private","classNamed: className\r\n\t\" Private - Return the class named className in the receiver's library. \"\r\n\r\n\t^self class classNamed: className","(\r\nfunction(self,className)\r\nreturn (((self)[\"$klass\"]):classNamed_(className));\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject,"newHandleOf:",0
,(
function(self,className)
local result=nil
local aConstructor=nil
(function()
	local _s8_value=((self):classNamed_(className))
	aConstructor=_s8_value
	return _s8_value
end)();
result = aConstructor();
return (result);
end
)
,"private","newHandleOf: className\r\n\t\" Private - Return a new instance of the class named className in the receiver's library. \"\r\n\r\n\t| result aConstructor |\r\n\taConstructor := self classNamed: className.\r\n\t{''js'result = new aConstructor()'}.\r\n\t^result","(\r\nfunction(self,className)\r\nlocal result=nil\r\nlocal aConstructor=nil\r\n(function()\r\n\tlocal _s8_value=((self):classNamed_(className))\r\n\taConstructor=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nresult = aConstructor();\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject,"newHandleOf:with:",0
,(
function(self,className,arg1)
local result=nil
local aConstructor=nil
(function()
	local _s8_value=((self):classNamed_(className))
	aConstructor=_s8_value
	return _s8_value
end)();
result = aConstructor(arg1);
return (result);
end
)
,"private","newHandleOf: className with: arg1\r\n\t\" Private - Return a new instance of the class named className in the receiver's library. \"\r\n\r\n\t| result aConstructor |\r\n\taConstructor := self classNamed: className.\r\n\t{''js'result = new aConstructor(arg1)'}.\r\n\t^result","(\r\nfunction(self,className,arg1)\r\nlocal result=nil\r\nlocal aConstructor=nil\r\n(function()\r\n\tlocal _s8_value=((self):classNamed_(className))\r\n\taConstructor=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nresult = aConstructor(arg1);\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:",0
,(
function(self,className,arg1,arg2)
local result=nil
local aConstructor=nil
(function()
	local _s8_value=((self):classNamed_(className))
	aConstructor=_s8_value
	return _s8_value
end)();
result = aConstructor(arg1,arg2);
return (result);
end
)
,"private","newHandleOf: className with: arg1 with: arg2\r\n\t\" Private - Return a new instance of the class named className in the receiver's library. \"\r\n\r\n\t| result aConstructor |\r\n\taConstructor := self classNamed: className.\r\n\t{''js'result = new aConstructor(arg1,arg2)'}.\r\n\t^result","(\r\nfunction(self,className,arg1,arg2)\r\nlocal result=nil\r\nlocal aConstructor=nil\r\n(function()\r\n\tlocal _s8_value=((self):classNamed_(className))\r\n\taConstructor=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nresult = aConstructor(arg1,arg2);\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:",0
,(
function(self,className,arg1,arg2,arg3)
local result=nil
local aConstructor=nil
(function()
	local _s8_value=((self):classNamed_(className))
	aConstructor=_s8_value
	return _s8_value
end)();
result = aConstructor(arg1,arg2,arg3);
return (result);
end
)
,"private","newHandleOf: className with: arg1 with: arg2 with: arg3\r\n\t\" Private - Return a new instance of the class named className in the receiver's library. \"\r\n\r\n\t| result aConstructor |\r\n\taConstructor := self classNamed: className.\r\n\t{''js'result = new aConstructor(arg1,arg2,arg3)'}.\r\n\t^result","(\r\nfunction(self,className,arg1,arg2,arg3)\r\nlocal result=nil\r\nlocal aConstructor=nil\r\n(function()\r\n\tlocal _s8_value=((self):classNamed_(className))\r\n\taConstructor=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nresult = aConstructor(arg1,arg2,arg3);\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:with:",0
,(
function(self,className,arg1,arg2,arg3,arg4)
local result=nil
local aConstructor=nil
(function()
	local _s8_value=((self):classNamed_(className))
	aConstructor=_s8_value
	return _s8_value
end)();
result = aConstructor(arg1,arg2,arg3,arg4);
return (result);
end
)
,"private","newHandleOf: className with: arg1 with: arg2 with: arg3 with: arg4\r\n\t\" Private - Return a new instance of the class named className in the receiver's library. \"\r\n\r\n\t| result aConstructor |\r\n\taConstructor := self classNamed: className.\r\n\t{''js'result = new aConstructor(arg1,arg2,arg3,arg4)'}.\r\n\t^result","(\r\nfunction(self,className,arg1,arg2,arg3,arg4)\r\nlocal result=nil\r\nlocal aConstructor=nil\r\n(function()\r\n\tlocal _s8_value=((self):classNamed_(className))\r\n\taConstructor=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nresult = aConstructor(arg1,arg2,arg3,arg4);\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:with:with:",0
,(
function(self,className,arg1,arg2,arg3,arg4,arg5)
local result=nil
local aConstructor=nil
(function()
	local _s8_value=((self):classNamed_(className))
	aConstructor=_s8_value
	return _s8_value
end)();
result = aConstructor(arg1,arg2,arg3,arg4,arg5);
return (result);
end
)
,"private","newHandleOf: className with: arg1 with: arg2 with: arg3 with: arg4 with: arg5\r\n\t\" Private - Return a new instance of the class named className in the receiver's library. \"\r\n\r\n\t| result aConstructor |\r\n\taConstructor := self classNamed: className.\r\n\t{''js'result = new aConstructor(arg1,arg2,arg3,arg4,arg5)'}.\r\n\t^result","(\r\nfunction(self,className,arg1,arg2,arg3,arg4,arg5)\r\nlocal result=nil\r\nlocal aConstructor=nil\r\n(function()\r\n\tlocal _s8_value=((self):classNamed_(className))\r\n\taConstructor=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nresult = aConstructor(arg1,arg2,arg3,arg4,arg5);\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:with:with:with:",0
,(
function(self,className,arg1,arg2,arg3,arg4,arg5,arg6)
local result=nil
local aConstructor=nil
(function()
	local _s8_value=((self):classNamed_(className))
	aConstructor=_s8_value
	return _s8_value
end)();
result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6);
return (result);
end
)
,"private","newHandleOf: className with: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6\r\n\t\" Private - Return a new instance of the class named className in the receiver's library. \"\r\n\r\n\t| result aConstructor |\r\n\taConstructor := self classNamed: className.\r\n\t{''js'result = new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6)'}.\r\n\t^result","(\r\nfunction(self,className,arg1,arg2,arg3,arg4,arg5,arg6)\r\nlocal result=nil\r\nlocal aConstructor=nil\r\n(function()\r\n\tlocal _s8_value=((self):classNamed_(className))\r\n\taConstructor=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nresult = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6);\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:with:with:with:with:",0
,(
function(self,className,arg1,arg2,arg3,arg4,arg5,arg6,arg7)
local result=nil
local aConstructor=nil
(function()
	local _s8_value=((self):classNamed_(className))
	aConstructor=_s8_value
	return _s8_value
end)();
result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7);
return (result);
end
)
,"private","newHandleOf: className with: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7\r\n\t\" Private - Return a new instance of the class named className in the receiver's library. \"\r\n\r\n\t| result aConstructor |\r\n\taConstructor := self classNamed: className.\r\n\t{''js'result = new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7)'}.\r\n\t^result","(\r\nfunction(self,className,arg1,arg2,arg3,arg4,arg5,arg6,arg7)\r\nlocal result=nil\r\nlocal aConstructor=nil\r\n(function()\r\n\tlocal _s8_value=((self):classNamed_(className))\r\n\taConstructor=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nresult = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7);\r\nreturn (result);\r\nend\r\n)")
smalltalk:bind(smalltalk.NativeLibraryObject,"newHandleOf:with:with:with:with:with:with:with:with:",0
,(
function(self,className,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)
local result=nil
local aConstructor=nil
(function()
	local _s8_value=((self):classNamed_(className))
	aConstructor=_s8_value
	return _s8_value
end)();
result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8);
return (result);
end
)
,"private","newHandleOf: className with: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7 with: arg8\r\n\t\" Private - Return a new instance of the class named className in the receiver's library. \"\r\n\r\n\t| result aConstructor |\r\n\taConstructor := self classNamed: className.\r\n\t{''js'result = new aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)'}.\r\n\t^result","(\r\nfunction(self,className,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)\r\nlocal result=nil\r\nlocal aConstructor=nil\r\n(function()\r\n\tlocal _s8_value=((self):classNamed_(className))\r\n\taConstructor=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nresult = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8);\r\nreturn (result);\r\nend\r\n)")
