
-- fileIn("s8/library/eden/jlBoot.st")
smalltalk:addClass("JuliaBoot",smalltalk.BootSector,smalltalk:newArray({}),"jlBoot")

smalltalk:bind(smalltalk.JuliaBoot["$klass"],"supportsLanguage:",0
,function(self,aLanguage)
return (smalltalk:isObject_equalTo_(("jl"),aLanguage));
end
,"instantiation","supportsLanguage: aLanguage\r\n\t\" Private - Return true if instances of the receiver can encode to aLanguage. \"\r\n\r\n\t^#jl = aLanguage","function(self,aLanguage)\r\nreturn (smalltalk:isObject_equalTo_((\"jl\"),aLanguage));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"contents",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:superImplementor(smalltalk.JuliaBoot,"contents")(self)),(self):testExpressions())),(self):notes()));
end
,"contents","contents\r\n\t\" Return the contents (aString) to be dump as source of the receiver. \"\r\n\r\n\t^super contents\r\n\t\t,self testExpressions\r\n\t\t,self notes","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:superImplementor(smalltalk.JuliaBoot,\"contents\")(self)),(self):testExpressions())),(self):notes()));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"version",0
,function(self)
return ("0.7.2023.11");
end
,"constants","version\r\n\t\" Private - Returns the version string (dotted number and date). \"\r\n\r\n\t^'0.7.2023.11' ","function(self)\r\nreturn (\"0.7.2023.11\");\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"versionDetail",0
,function(self)
return ("Note that this is a pre-release of Julia execution support under social development(2021-today).");
end
,"constants","versionDetail\r\n\t\" Private - Returns this value. \"\r\n\r\n\t^'Note that this is a pre-release of Julia execution support under social development(2021-today).'","function(self)\r\nreturn (\"Note that this is a pre-release of Julia execution support under social development(2021-today).\");\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"lineComment:",0
,function(self,aString)
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:object_comma_(("# "),aString));
	return ((_s8_rec):cr())
end
)(self));
end
,"encoding","lineComment: aString\r\n\t\" Private - Encode aString as line comment. \"\r\n\r\n\t^self nextPutAll: '# ' ,aString;cr ","function(self,aString)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((\"# \"),aString));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"multilineComment:",0
,function(self,array)
return ((self):encode_((function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("#=");
	return ((_s8_rec):indent())
end
)(self);(array):do_((function(line)
return ((
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(line))
end
)(self))
end));return ((
function(_s8_rec)
	(_s8_rec):dedent();
	(_s8_rec):cr();
	(_s8_rec):nextPutAll_("=#");
	return ((_s8_rec):cr())
end
)(self))
end)));
end
,"encoding","multilineComment: array\r\n\t\" Private - Encode an array as a multiline comment. \"\r\n\r\n\t^self encode: [\r\n\t\tself nextPutAll: '#=' ;indent.\r\n\t\tarray do: [:line| self cr; nextPutAll: line ].\r\n\t\tself dedent; cr; nextPutAll: '=#'; cr\r\n\t]","function(self,array)\r\nreturn ((self):encode_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"#=\");\r\n\treturn ((_s8_rec):indent())\r\nend\r\n)(self);(array):do_((function(line)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(line))\r\nend\r\n)(self))\r\nend));return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):dedent();\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):nextPutAll_(\"=#\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"notes",0
,function(self)
return ((self):encode_((function()
(self):comment_("-------------------------------------------------------------------------------------");(
function(_s8_rec)
	(_s8_rec):call_with_("println","\"This is a pre-release of Julia execution support for S8 (@2021-today).\"");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):call_with_("println","\"Join our S8 Facebook group https://www.facebook.com/groups/s8smalltalk/\"");
	return ((_s8_rec):cr())
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):call_with_("println","\"boot(.jl) ready to load image.\"");
	return ((_s8_rec):cr())
end
)(self))
end)));
end
,"contents","notes\r\n\t\" Private - Return the encoding for printing notes on this implementation. \"\r\n\r\n\t^self encode: [\r\n\t\tself comment: '-------------------------------------------------------------------------------------'.\r\n\t\tself call: #println with: '\"This is a pre-release of Julia execution support for S8 (@2021-today).\"';cr.\r\n\t\tself call: #println with: '\"Join our S8 Facebook group https://www.facebook.com/groups/s8smalltalk/\"';cr.\r\n\t\tself call: #println with: '\"boot(.jl) ready to load image.\"';cr.\r\n\t]","function(self)\r\nreturn ((self):encode_((function()\r\n(self):comment_(\"-------------------------------------------------------------------------------------\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"println\",\"\\\"This is a pre-release of Julia execution support for S8 (@2021-today).\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"println\",\"\\\"Join our S8 Facebook group https://www.facebook.com/groups/s8smalltalk/\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"println\",\"\\\"boot(.jl) ready to load image.\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"startupExpression",0
,function(self)
return ((self):encode_((function()
(self):define_asInstanceOf_("smalltalk","SystemDictionary");(
function(_s8_rec)
	(_s8_rec):send_to_("startup","smalltalk");
	return ((_s8_rec):cr())
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):assign_to_("nil",(function()
return ((self):send_to_("basicNewInstance_","smalltalk.UndefinedObject"))
end));
	return ((_s8_rec):cr())
end
)(self))
end)));
end
,"contents","startupExpression\r\n\t\" Private - Return the encoding for startup expression of the receiver. \"\r\n\r\n\t^self encode: [\r\n\t\tself define: #smalltalk asInstanceOf: #SystemDictionary.\r\n\t\tself send: #startup to: #smalltalk;cr.\r\n\t\tself assign: #nil to: [ self send: #basicNewInstance_ to: 'smalltalk.UndefinedObject' ];cr.\r\n\t]","function(self)\r\nreturn ((self):encode_((function()\r\n(self):define_asInstanceOf_(\"smalltalk\",\"SystemDictionary\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_(\"startup\",\"smalltalk\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"nil\",(function()\r\nreturn ((self):send_to_(\"basicNewInstance_\",\"smalltalk.UndefinedObject\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"initialDefinition",0
,function(self)
return (smalltalk:object_comma_((smalltalk:superImplementor(smalltalk.JuliaBoot,"initialDefinition")(self)),(self):encode_((function()
(
function(_s8_rec)
	(_s8_rec):import_("Base.string");
	return ((_s8_rec):cr())
end
)(self);(self):comment_("import Pkg; Pkg.add(\"HTTP\")");(self):comment_("import Pkg; Pkg.add(\"JSON3\")");(self):comment_("import Pkg; Pkg.add(\"Dates\")");(self):comment_("import Pkg; Pkg.add(\"Debugger\")");(self):comment_("using Debugger #uncomment for #halt inline");return ((self):comment_("using Dates # required by DateTime inlines"))
end))));
end
,"definitions","initialDefinition\r\n\t\" Private - Return the encoding for initializing execution environment. \"\r\n\r\n\t^super initialDefinition ,(self encode: [\r\n\t\tself import: 'Base.string';cr.\r\n\t\tself comment: 'import Pkg; Pkg.add(\"HTTP\")'.\r\n\t\tself comment: 'import Pkg; Pkg.add(\"JSON3\")'.\r\n\t\tself comment: 'import Pkg; Pkg.add(\"Dates\")'.\r\n\t\tself comment: 'import Pkg; Pkg.add(\"Debugger\")'.\r\n\t\tself comment: 'using Debugger #uncomment for #halt inline'.\r\n\t\tself comment: 'using Dates # required by DateTime inlines'.\r\n\t]) ","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:superImplementor(smalltalk.JuliaBoot,\"initialDefinition\")(self)),(self):encode_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):import_(\"Base.string\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"import Pkg; Pkg.add(\\\"HTTP\\\")\");(self):comment_(\"import Pkg; Pkg.add(\\\"JSON3\\\")\");(self):comment_(\"import Pkg; Pkg.add(\\\"Dates\\\")\");(self):comment_(\"import Pkg; Pkg.add(\\\"Debugger\\\")\");(self):comment_(\"using Debugger #uncomment for #halt inline\");return ((self):comment_(\"using Dates # required by DateTime inlines\"))\r\nend))));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"nilDefinition",0
,function(self)
return ((self):encode_((function()
return ((
function(_s8_rec)
	(_s8_rec):assign_to_("nil","nothing");
	return ((_s8_rec):cr())
end
)(self))
end)));
end
,"definitions","nilDefinition\r\n\t\" Private - Return the encoding for nil. \"\r\n\r\n\t^self encode: [\r\n\t\tself assign: #nil to: #nothing;cr.\r\n\t]","function(self)\r\nreturn ((self):encode_((function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"nil\",\"nothing\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"implementStObject",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):defineClass_implementing_("StObject",smalltalk:newArray({smalltalk:newArray({"Base.getproperty", smalltalk:newArray({"aSymbol::Symbol"})}), smalltalk:newArray({"Base.setproperty!", smalltalk:newArray({"aSymbol::Symbol", "object"})}), smalltalk:newArray({"Base.setindex!", smalltalk:newArray({"object", "aSymbol"})})}));
	return ((_s8_rec):cr())
end
)(self);
(self):bind_function_arguments_sending_("StObject","Base.getindex",smalltalk:newArray({"aName"}),"stObjectBaseGetindexName");
(self):bind_function_arguments_sending_("StObject","Base.getindex",smalltalk:newArray({"ind::Int"}),"stObjectBaseGetindexInt");
(self):implementClass_api_("Any",smalltalk:newArray({"handle(self::Any) = self", "asParameter(self::Any) = handle(self)"}));
(
function(_s8_rec)
	(_s8_rec):implementClass_api_("StObject",smalltalk:newArray({"handle(self::StObject) = self[\"@handle\"]", "#asParameter(self::StObject) = self[\"@handle\"]", smalltalk:newArray({"handleOr", smalltalk:newArray({"forcedHandle"})})}));
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"definitions","implementStObject\r\n\t\" Private - Implement support for StObject. \"\r\n\r\n\tself defineClass: #StObject implementing: #(\r\n\t\t#('Base.getproperty' #('aSymbol::Symbol'))\r\n\t\t#('Base.setproperty!' #('aSymbol::Symbol' object))\r\n\t\t#('Base.setindex!' #(object aSymbol))\r\n\t);cr.\r\n\tself\tbind: #StObject function: 'Base.getindex'\r\n\t\targuments: #(aName) sending: #stObjectBaseGetindexName.\r\n\tself\tbind: #StObject function: 'Base.getindex'\r\n\t\targuments: #('ind::Int') sending: #stObjectBaseGetindexInt.\r\n\tself implementClass: #Any api: #(\r\n\t\t'handle(self::Any) = self'\r\n\t\t'asParameter(self::Any) = handle(self)'\r\n\t).\r\n\tself implementClass: #StObject api: #(\r\n\t\t'handle(self::StObject) = self[\"@handle\"]'\r\n\t\t'#asParameter(self::StObject) = self[\"@handle\"]'\r\n\t\t#(handleOr #(forcedHandle))\r\n\t);cr. ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):defineClass_implementing_(\"StObject\",smalltalk:newArray({smalltalk:newArray({\"Base.getproperty\", smalltalk:newArray({\"aSymbol::Symbol\"})}), smalltalk:newArray({\"Base.setproperty!\", smalltalk:newArray({\"aSymbol::Symbol\", \"object\"})}), smalltalk:newArray({\"Base.setindex!\", smalltalk:newArray({\"object\", \"aSymbol\"})})}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):bind_function_arguments_sending_(\"StObject\",\"Base.getindex\",smalltalk:newArray({\"aName\"}),\"stObjectBaseGetindexName\");\r\n(self):bind_function_arguments_sending_(\"StObject\",\"Base.getindex\",smalltalk:newArray({\"ind::Int\"}),\"stObjectBaseGetindexInt\");\r\n(self):implementClass_api_(\"Any\",smalltalk:newArray({\"handle(self::Any) = self\", \"asParameter(self::Any) = handle(self)\"}));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementClass_api_(\"StObject\",smalltalk:newArray({\"handle(self::StObject) = self[\\\"@handle\\\"]\", \"#asParameter(self::StObject) = self[\\\"@handle\\\"]\", smalltalk:newArray({\"handleOr\", smalltalk:newArray({\"forcedHandle\"})})}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"implementStGlobalScope",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):defineClass_implementing_("StGlobalScope",smalltalk:newArray({smalltalk:newArray({"Base.getproperty", smalltalk:newArray({"aSymbol::Symbol"})}), smalltalk:newArray({"Base.getindex", smalltalk:newArray({"aName"})}), smalltalk:newArray({"Base.setproperty!", smalltalk:newArray({"aSymbol::Symbol", "object"})}), smalltalk:newArray({"Base.setindex!", smalltalk:newArray({"object", "aSymbol"})})}));
	return ((_s8_rec):cr())
end
)(self);
(self):define_struct_inheriting_("",smalltalk:newArray({"S8GlobalScope", smalltalk:newArray({smalltalk:newArray({"cookie", "Any"})})}),"StGlobalScope");
(
function(_s8_rec)
	(_s8_rec):assign_to_("S8GlobalScope()","S8GlobalScope(nil)");
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"definitions","implementStGlobalScope\r\n\t\" Private - Implement support for StObject. \"\r\n\r\n\tself defineClass: #StGlobalScope implementing: #(\r\n\t\t#('Base.getproperty' #('aSymbol::Symbol'))\r\n\t\t#('Base.getindex' #(aName))\r\n\t\t#('Base.setproperty!' #('aSymbol::Symbol' object))\r\n\t\t#('Base.setindex!' #(object aSymbol))\r\n\t);cr.\r\n\tself\tdefine: ''\r\n\t\tstruct: #(S8GlobalScope #(#(cookie Any)))\r\n\t\tinheriting: #StGlobalScope.\r\n\tself assign: 'S8GlobalScope()' to: 'S8GlobalScope(nil)'; cr","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):defineClass_implementing_(\"StGlobalScope\",smalltalk:newArray({smalltalk:newArray({\"Base.getproperty\", smalltalk:newArray({\"aSymbol::Symbol\"})}), smalltalk:newArray({\"Base.getindex\", smalltalk:newArray({\"aName\"})}), smalltalk:newArray({\"Base.setproperty!\", smalltalk:newArray({\"aSymbol::Symbol\", \"object\"})}), smalltalk:newArray({\"Base.setindex!\", smalltalk:newArray({\"object\", \"aSymbol\"})})}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):define_struct_inheriting_(\"\",smalltalk:newArray({\"S8GlobalScope\", smalltalk:newArray({smalltalk:newArray({\"cookie\", \"Any\"})})}),\"StGlobalScope\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"S8GlobalScope()\",\"S8GlobalScope(nil)\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"smalltalkDefinition",0
,function(self)
return ((self):encode_((function()
(
function(_s8_rec)
	(_s8_rec):bind_api_("Any",smalltalk:newArray({"klass", smalltalk:newArray({"aValue::Any"})}));
	return ((_s8_rec):cr())
end
)(self);(self):implementStObject();(smalltalk:newArray({smalltalk:newArray({smalltalk:newArray({"StBehavior", "StObject"}), smalltalk:newArray({smalltalk:newArray({"basicNewInstance_", smalltalk:newArray({"fields=Dict{String,Any}()"})}), smalltalk:newArray({"nativeNew_", smalltalk:newArray({"handle=nil"})}), smalltalk:newArray({">>", smalltalk:newArray({"selector"})}), smalltalk:newArray({">>>", smalltalk:newArray({"selector"})})})}), smalltalk:newArray({smalltalk:newArray({"StMetaclass", "StBehavior", smalltalk:newArray({"S8Metaclass", smalltalk:newArray({smalltalk:newArray({"dict", "Dict{String,Any}"})})})}), smalltalk:newArray({})}), smalltalk:newArray({smalltalk:newArray({"StClass", "StBehavior", smalltalk:newArray({"S8Class", smalltalk:newArray({smalltalk:newArray({"dict", "Dict{String,Any}"})})})}), smalltalk:newArray({})}), smalltalk:newArray({smalltalk:newArray({"StMethod", "StObject"}), smalltalk:newArray({})})})):do_((function(tuple)
return ((
function(_s8_rec)
	(_s8_rec):defineClass_implementing_((tuple):first(),(tuple):last());
	return ((_s8_rec):cr())
end
)(self))
end));(self):implementStGlobalScope();return ((self):implementSystemDictionary())
end)));
end
,"definitions","smalltalkDefinition\r\n\t\" Private - Return the encoding for smalltalk. \"\r\n\r\n\t^self encode: [\r\n\t\tself bind: #Any api: #(klass #('aValue::Any')); cr.\r\n\t\tself implementStObject.\r\n\t\t#(\t#(#(StBehavior StObject) #(\r\n\t\t\t\t#(basicNewInstance_ #('fields=Dict{String,Any}()'))\r\n\t\t\t\t#(nativeNew_ #('handle=nil'))\r\n\t\t\t\t#(>> #(selector))\r\n\t\t\t\t#(>>> #(selector))\r\n\t\t\t))\r\n\t\t\t#(#(StMetaclass StBehavior #(\r\n\t\t\t\tS8Metaclass #(\r\n\t\t\t\t\t#(dict 'Dict{String,Any}')\r\n\t\t\t\t))) #( \"empty api\" ))\r\n\t\t\t#(#(StClass StBehavior #(\r\n\t\t\t\tS8Class #(\r\n\t\t\t\t\t#(dict 'Dict{String,Any}')\r\n\t\t\t\t))) #( \"empty api\" ))\r\n\t\t\t#(#(StMethod StObject) #( \"empty api\" ))\r\n\t\t) do: [:tuple| self defineClass: tuple first implementing: tuple last;cr ].\r\n\t\tself implementStGlobalScope.\r\n\t\tself implementSystemDictionary.\r\n\t]","function(self)\r\nreturn ((self):encode_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):bind_api_(\"Any\",smalltalk:newArray({\"klass\", smalltalk:newArray({\"aValue::Any\"})}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):implementStObject();(smalltalk:newArray({smalltalk:newArray({smalltalk:newArray({\"StBehavior\", \"StObject\"}), smalltalk:newArray({smalltalk:newArray({\"basicNewInstance_\", smalltalk:newArray({\"fields=Dict{String,Any}()\"})}), smalltalk:newArray({\"nativeNew_\", smalltalk:newArray({\"handle=nil\"})}), smalltalk:newArray({\">>\", smalltalk:newArray({\"selector\"})}), smalltalk:newArray({\">>>\", smalltalk:newArray({\"selector\"})})})}), smalltalk:newArray({smalltalk:newArray({\"StMetaclass\", \"StBehavior\", smalltalk:newArray({\"S8Metaclass\", smalltalk:newArray({smalltalk:newArray({\"dict\", \"Dict{String,Any}\"})})})}), smalltalk:newArray({})}), smalltalk:newArray({smalltalk:newArray({\"StClass\", \"StBehavior\", smalltalk:newArray({\"S8Class\", smalltalk:newArray({smalltalk:newArray({\"dict\", \"Dict{String,Any}\"})})})}), smalltalk:newArray({})}), smalltalk:newArray({smalltalk:newArray({\"StMethod\", \"StObject\"}), smalltalk:newArray({})})})):do_((function(tuple)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):defineClass_implementing_((tuple):first(),(tuple):last());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));(self):implementStGlobalScope();return ((self):implementSystemDictionary())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"implementSystemDictionary",0
,function(self)
(self):define_struct_inheriting_("mutable",smalltalk:newArray({"StSystemDictionary", smalltalk:newArray({smalltalk:newArray({"dict", "Dict{String,Any}"}), smalltalk:newArray({"state", "String"}), smalltalk:newArray({"useManager", "Bool"})})}),"StObject");
(
function(_s8_rec)
	(_s8_rec):assign_to_("StSystemDictionary()","StSystemDictionary(Dict(),\"boot\",false)");
	return ((_s8_rec):cr())
end
)(self);
(self):implementClass_api_("io:IO",smalltalk:newArray({"Base.show(io::IO,st::StSystemDictionary) = print(io,\"smalltalk\")", "Base.show(io::IO,o::StObject) = print(io, tostring(o))"}));
(self):implementClass_api_("Any",smalltalk:newArray({"tostring(o::Any) = to_String(smalltalk,o)"}));
(self):implementClass_api_("StSystemDictionary",smalltalk:newArray({"state", smalltalk:newArray({"state:", smalltalk:newArray({"aState"})}), "isNil_(self::StSystemDictionary, aValue::Nothing) = true", "isNil_(self::StSystemDictionary, aValue::Any) = aValue === nil", "notNil_(self::StSystemDictionary, aValue::Nothing) = false", "notNil_(self::StSystemDictionary, aValue::Any) = aValue !== nil", "classOf_(self::StSystemDictionary, aValue) = klass(aValue)", smalltalk:newArray({"do:onError:", smalltalk:newArray({"aBlock", "errorBlock"})}), "basicAt_(self::StSystemDictionary, key) = basic_at_or_(self, self, key, nil)", smalltalk:newArray({"basic:at:or:", smalltalk:newArray({"object", "key", "default"})}), smalltalk:newArray({"basic:at:ifAbsent:", smalltalk:newArray({"object", "key", "aBlock"})}), "basic_at_(self::StSystemDictionary, object, key) = basic_at_or_(self, object, key, nil)", smalltalk:newArray({"basic:at:put:", smalltalk:newArray({"object", "key", "value"})}), smalltalk:newArray({"basic:delete:", smalltalk:newArray({"object", "key"})}), smalltalk:newArray({"ifUndefined:do:", smalltalk:newArray({"object", "aBlock"})}), smalltalk:newArray({"times:repeat:", smalltalk:newArray({"count", "aBlock"})}), smalltalk:newArray({"orNil:", smalltalk:newArray({"object"})}), smalltalk:newArray({"if:nil:notNil:", smalltalk:newArray({"anObject", "block1", "block2"})}), smalltalk:newArray({"if:true:false:", smalltalk:newArray({"aBoolean", "blk1", "blk2"})}), smalltalk:newArray({"while:do:", smalltalk:newArray({"condition", "aBlock"})}), smalltalk:newArray({"whileNot:do:", smalltalk:newArray({"condition", "aBlock"})}), smalltalk:newArray({"createType", smalltalk:newArray({"aName::Symbol", "superName"})})}));
(self):defineClass_implementing_(smalltalk:newArray({"StObject_class", "StClass", smalltalk:newArray({"S8Object_class", smalltalk:newArray({smalltalk:newArray({"dict", "Dict{String,Any}"})})})}),smalltalk:newArray({}));
(self):implementClass_api_("StSystemDictionary",smalltalk:newArray({smalltalk:newArray({"mapClassName", smalltalk:newArray({"className", "category", "native=nil", "superclass=nil"})}), smalltalk:newArray({"setVarNames", smalltalk:newArray({"aClass", "iVarNames", "aValue"})}), smalltalk:newArray({"setClass", smalltalk:newArray({"aClass", "spec"})}), smalltalk:newArray({"fnInSpec", smalltalk:newArray({"spec"})}), "nativeClasses", "classes", "computeSubclasses", smalltalk:newArray({"subclasses", smalltalk:newArray({"aClass"})}), smalltalk:newArray({"allSubclassesDo", smalltalk:newArray({"aClass", "aBlock"})}), smalltalk:newArray({"bindRoots", smalltalk:newArray({"ignored=nil"})}), smalltalk:newArray({"isArray:equalTo:", smalltalk:newArray({"table1", "table2"})}), smalltalk:newArray({"object:or:", smalltalk:newArray({"receiver", "option"})}), smalltalk:newArray({"isObject:equalTo:", smalltalk:newArray({"receiver", "anObject"})}), smalltalk:newArray({"object:comma:", smalltalk:newArray({"receiver", "anObject"})}), "object_comma_(self::StSystemDictionary, receiver::Symbol, anObject) = object_comma_(self, string(receiver), anObject)", smalltalk:newArray({"boolean:and:", smalltalk:newArray({"receiver", "option"})}), smalltalk:newArray({"boolean:or:", smalltalk:newArray({"receiver", "option"})}), smalltalk:newArray({"booleanNot:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"asCharacter:", smalltalk:newArray({"receiver"})}), "to_String(self::StSystemDictionary, receiver::Nothing) = \"nil\"", "to_String(self::StSystemDictionary, receiver::String) = receiver", "to_String(self::StSystemDictionary, receiver::Number) = string(receiver)", smalltalk:newArray({"to_String", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"printString:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"asString:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"mustBeNumber:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"math:max:", smalltalk:newArray({"receiver", "aNumber"})}), smalltalk:newArray({"math:min:", smalltalk:newArray({"receiver", "aNumber"})}), smalltalk:newArray({"addClass", smalltalk:newArray({"className", "superclass", "iVarNames", "category=nil"})}), smalltalk:newArray({"renameClass", smalltalk:newArray({"aClass", "aString"})}), smalltalk:newArray({"removeClass", smalltalk:newArray({"aClass"})}), smalltalk:newArray({"metaVarNames", smalltalk:newArray({"aMetaClass", "iVarNames"})}), smalltalk:newArray({"smDo", smalltalk:newArray({"block"})}), smalltalk:newArray({"classChanged", smalltalk:newArray({"aBehavior"})}), smalltalk:newArray({"classShapeChanged", smalltalk:newArray({"aBehavior"})}), smalltalk:newArray({"aboutToCreateClass", smalltalk:newArray({"className", "superclass", "iVarNames", "category"})}), smalltalk:newArray({"aboutToChangeClass", smalltalk:newArray({"aClass", "superclass", "iVarNames", "category"})}), smalltalk:newArray({"methodBoundTo", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"aboutToBindTo", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"aboutToRemoveFrom", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"methodRemovedFrom", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"objectNotFound", smalltalk:newArray({"object", "indexOrKey", "collection"})}), smalltalk:newArray({"whoImplements", smalltalk:newArray({"klass", "jsSelector"})}), smalltalk:newArray({"superImplementor", smalltalk:newArray({"klass", "jsSelector"})}), smalltalk:newArray({"instVarAt", smalltalk:newArray({"object", "ivName", "default=nil"})}), smalltalk:newArray({"addMethod", smalltalk:newArray({"jsSelector", "method", "klass", "stSelector=nil"})}), smalltalk:newArray({"bind", smalltalk:newArray({"klass", "stSelector", "jsSelector", "jsFunction", "category", "stSource", "nativeSource=nil", "stamp=nil"})}), smalltalk:newArray({"removeNativeFunction:for:", smalltalk:newArray({"fn", "aClass"})}), smalltalk:newArray({"removeMethod", smalltalk:newArray({"aClass", "aMethod"})}), smalltalk:newArray({"newMethod", smalltalk:newArray({"currentClass", "selector", "fn", "source", "nativeSource=nil", "stamp=nil"})}), smalltalk:newArray({"readJSObject", smalltalk:newArray({"js"})}), smalltalk:newArray({"basen", smalltalk:newArray({"n", "b"})}), smalltalk:newArray({"globalsDo", smalltalk:newArray({"action"})}), smalltalk:newArray({"launchImage", smalltalk:newArray({"imageName=nil"})}), smalltalk:newArray({"is:kindOf:", smalltalk:newArray({"anObject", "aClass"})}), "responds_to_(self::StSystemDictionary, anObject::Nothing, aSelector)=false", smalltalk:newArray({"responds:to:", smalltalk:newArray({"anObject", "aSelector"})}), smalltalk:newArray({"handleOf", smalltalk:newArray({"anObject"})}), "handleOf_or_(self::StSystemDictionary, anObject::Nothing, default)=default", smalltalk:newArray({"handleOf:or:", smalltalk:newArray({"anObject", "default"})}), "newHash", "stObject", smalltalk:newArray({"debugBind", smalltalk:newArray({"klass", "stSelector", "jsSelector", "jsFunction", "category", "stSource", "nativeSource=nil", "stamp=nil"})}), smalltalk:newArray({"debugAddClass", smalltalk:newArray({"className", "superclass", "iVarNames", "category"})}), "toString", "quit() = Base.exit()", "quit", "version", smalltalk:newArray({"folderContents", smalltalk:newArray({"fileName"})}), "httpSupport", smalltalk:newArray({"httpContents", smalltalk:newArray({"fileName"})}), smalltalk:newArray({"fileContents", smalltalk:newArray({"fileName"})})}));
(self):bind_arguments_doing_("fileWrite",smalltalk:newArray({"fileName::String", "contents", "mode"}),(function()
return ((self):perform_("fileWriteString"))
end));
(
function(_s8_rec)
	(_s8_rec):implementClass_api_("StSystemDictionary",smalltalk:newArray({smalltalk:newArray({"fileIn", smalltalk:newArray({"fileName"})}), smalltalk:newArray({"emmit", smalltalk:newArray({"fileName"})}), smalltalk:newArray({"fileInJS", smalltalk:newArray({"fileName"})}), smalltalk:newArray({"exportCategory", smalltalk:newArray({"aString"})}), "saveImage", smalltalk:newArray({"saveImageAs", smalltalk:newArray({"fileName"})}), smalltalk:newArray({"isFileOlderThan", smalltalk:newArray({"fileName", "referenceFileName"})}), "startup", "niy", smalltalk:newArray({"niy:", smalltalk:newArray({"msg"})}), "linkNatives", "bindCore", smalltalk:newArray({"invalidMessage:", smalltalk:newArray({"msg"})}), "obsolete", smalltalk:newArray({"linkNative:to:", smalltalk:newArray({"instance", "aClass"})}), smalltalk:newArray({"newConstructor", smalltalk:newArray({"superC"})}), smalltalk:newArray({"will:be:", smalltalk:newArray({"anObject", "className"})}), smalltalk:newArray({"newArray", smalltalk:newArray({"object=[]"})}), smalltalk:newArray({"newArrayOfSize", smalltalk:newArray({"size"})}), smalltalk:newArray({"arrayAdapt", smalltalk:newArray({"array", "cookie"})}), smalltalk:newArray({"arrayPack", smalltalk:newArray({"array"})}), smalltalk:newArray({"become:a:", smalltalk:newArray({"anObject", "aClass"})}), smalltalk:newArray({"setProtoOf:to:", smalltalk:newArray({"nativeObject", "proto"})}), smalltalk:newArray({"klass", smalltalk:newArray({"spec"})}), "globalScope", smalltalk:newArray({"__f__", smalltalk:newArray({"source"})}), smalltalk:newArray({"__b__", smalltalk:newArray({"sources", "locals"})}), "stacktrace", "datesSupport", smalltalk:newArray({"block:valueWithPossibleArguments:", smalltalk:newArray({"block", "args"})}), smalltalk:newArray({"block_argumentCount", smalltalk:newArray({"block"})}), smalltalk:newArray({"pool_key", smalltalk:newArray({"h", "k"})}), smalltalk:newArray({"pool:at:put:", smalltalk:newArray({"pool", "aKey", "aValue"})}), smalltalk:newArray({"pool:removeKey:", smalltalk:newArray({"pool", "aKey"})}), smalltalk:newArray({"pool:at:ifAbsent:", smalltalk:newArray({"pool", "aKey", "aBlock"})}), smalltalk:newArray({"pool:includesKey:", smalltalk:newArray({"pool", "aKey"})}), smalltalk:newArray({"pool_keys", smalltalk:newArray({"pool"})}), smalltalk:newArray({"string_toNumber", smalltalk:newArray({"aString"})}), smalltalk:newArray({"string:copyFrom:to:", smalltalk:newArray({"aString", "fromIndex", "toIndex"})})}));
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"definitions","implementSystemDictionary\r\n\t\" Private - Implement support for SystemDictionary. \"\r\n\r\n\r\n\tself\tdefine: #mutable struct: #(StSystemDictionary #(\r\n\t\t\t#(dict 'Dict{String,Any}')\r\n\t\t\t#(state String)\r\n\t\t\t#(useManager Bool)\r\n\t\t)) inheriting: #StObject.\r\n\tself assign: 'StSystemDictionary()' to: 'StSystemDictionary(Dict(),\"boot\",false)'; cr.\r\n\tself implementClass: 'io:IO' api: #(\r\n\t\t'Base.show(io::IO,st::StSystemDictionary) = print(io,\"smalltalk\")'\r\n\t\t'Base.show(io::IO,o::StObject) = print(io, tostring(o))'\r\n\t).\r\n\tself implementClass: #Any api: #(\r\n\t\t'tostring(o::Any) = to_String(smalltalk,o)'\r\n\t).\r\n\tself implementClass: #StSystemDictionary api: #(\r\n\t\tstate\r\n\t\t#(state: #(aState))\r\n\t\t'isNil_(self::StSystemDictionary, aValue::Nothing) = true'\r\n\t\t'isNil_(self::StSystemDictionary, aValue::Any) = aValue === nil'\r\n\t\t'notNil_(self::StSystemDictionary, aValue::Nothing) = false'\r\n\t\t'notNil_(self::StSystemDictionary, aValue::Any) = aValue !== nil'\r\n\t\t'classOf_(self::StSystemDictionary, aValue) = klass(aValue)'\r\n\t\t#(do:onError: #(aBlock errorBlock))\r\n\t\t'basicAt_(self::StSystemDictionary, key) = basic_at_or_(self, self, key, nil)'\r\n\t\t#(basic:at:or: #(object key default))\r\n\t\t#(basic:at:ifAbsent: #(object key aBlock))\r\n\t\t'basic_at_(self::StSystemDictionary, object, key) = basic_at_or_(self, object, key, nil)'\r\n\t\t#(basic:at:put: #(object key value))\r\n\t\t#(basic:delete: #(object key))\r\n\t\t#(ifUndefined:do: #(object aBlock))\r\n\t\t#(times:repeat: #(count aBlock))\r\n\t\t#(orNil: #(object))\r\n\t\t#(if:nil:notNil: #(anObject block1 block2))\r\n\t\t#(if:true:false: #(aBoolean blk1 blk2))\r\n\t\t#(while:do: #(condition aBlock))\r\n\t\t#(whileNot:do: #(condition aBlock))\r\n\t\t#(createType #('aName::Symbol' superName))\r\n\t).\r\n\tself\tdefineClass: #(StObject_class StClass #(S8Object_class #( #(dict 'Dict{String,Any}') )))\r\n\t\timplementing: #( \"empty api\" ).\r\n\tself implementClass: #StSystemDictionary api: #(\r\n\t\t#(mapClassName #(className category 'native=nil' 'superclass=nil'))\r\n\t\t#(setVarNames #(aClass iVarNames aValue))\r\n\t\t#(setClass #(aClass spec))\r\n\t\t#(fnInSpec #(spec))\r\n\t\tnativeClasses\r\n\t\tclasses computeSubclasses\r\n\t\t#(subclasses #(aClass))\r\n\t\t#(allSubclassesDo #(aClass aBlock))\r\n\t\t#(bindRoots #('ignored=nil'))\r\n\t\t#(isArray:equalTo: #(table1 table2))\r\n\t\t#(object:or: #(receiver option))\r\n\t\t#(isObject:equalTo: #(receiver anObject))\r\n\t\t#(object:comma: #(receiver anObject))\r\n\t\t'object_comma_(self::StSystemDictionary, receiver::Symbol, anObject) = object_comma_(self, string(receiver), anObject)'\r\n\t\t#(boolean:and: #(receiver option))\r\n\t\t#(boolean:or: #(receiver option))\r\n\t\t#(booleanNot: #(receiver))\r\n\t\t#(asCharacter: #(receiver))\r\n\t\t'to_String(self::StSystemDictionary, receiver::Nothing) = \"nil\"'\r\n\t\t'to_String(self::StSystemDictionary, receiver::String) = receiver'\r\n\t\t'to_String(self::StSystemDictionary, receiver::Number) = string(receiver)'\r\n\t\t#(to_String #(receiver))\r\n\t\t#(printString: #(receiver))\r\n\t\t#(asString: #(receiver))\r\n\t\t#(mustBeNumber: #(receiver))\r\n\t\t#(math:max: #(receiver aNumber))\r\n\t\t#(math:min: #(receiver aNumber))\r\n\t\t#(addClass #(className superclass iVarNames 'category=nil'))\r\n\t\t#(renameClass #(aClass aString))\r\n\t\t#(removeClass #(aClass))\r\n\t\t#(metaVarNames #(aMetaClass iVarNames))\r\n\t\t#(smDo #(block))\r\n\t\t#(classChanged #(aBehavior))\r\n\t\t#(classShapeChanged #(aBehavior))\r\n\t\t#(aboutToCreateClass #(className superclass iVarNames category))\r\n\t\t#(aboutToChangeClass #(aClass superclass iVarNames category))\r\n\t\t#(methodBoundTo #(method klass))\r\n\t\t#(aboutToBindTo #(method klass))\r\n\t\t#(aboutToRemoveFrom #(method klass))\r\n\t\t#(methodRemovedFrom #(method klass))\r\n\t\t#(objectNotFound #(object indexOrKey collection))\r\n\t\t#(whoImplements #( klass jsSelector))\r\n\t\t#(superImplementor #(klass jsSelector))\r\n\t\t#(instVarAt #(object ivName 'default=nil'))\r\n\t\t#(addMethod #(jsSelector method klass 'stSelector=nil'))\r\n\t\t#(bind #(klass stSelector jsSelector jsFunction category stSource 'nativeSource=nil' 'stamp=nil'))\r\n\t\t#(removeNativeFunction:for: #(fn aClass))\r\n\t\t#(removeMethod #(aClass aMethod))\r\n\t\t#(newMethod #(currentClass selector fn source 'nativeSource=nil' 'stamp=nil'))\r\n\"OBSOLETE\t#(method #(spec))\"\r\n\t\t#(readJSObject #(js))\r\n\t\t#(basen #(n b))\r\n\t\t#(globalsDo #(action))\r\n\t\t#(launchImage #('imageName=nil'))\r\n\t\t#(is:kindOf: #(anObject aClass))\r\n\t\t'responds_to_(self::StSystemDictionary, anObject::Nothing, aSelector)=false'\r\n\t\t#(responds:to: #(anObject aSelector))\r\n\t\t#(handleOf #(anObject))\r\n\t\t'handleOf_or_(self::StSystemDictionary, anObject::Nothing, default)=default'\r\n\t\t#(handleOf:or: #(anObject default))\r\n\t\tnewHash\r\n\t\tstObject\r\n\t\t#(debugBind #(klass stSelector jsSelector jsFunction category stSource 'nativeSource=nil' 'stamp=nil'))\r\n\t\t#(debugAddClass #(className superclass iVarNames category))\r\n\t\ttoString\r\n\t\t'quit() = Base.exit()'\r\n\t\tquit\r\n\t\tversion\r\n\t\t#(folderContents #(fileName))\r\n\t\thttpSupport\r\n\t\t#(httpContents #(fileName))\r\n\t\t#(fileContents #(fileName))\r\n\t).\r\n\tself\tbind: #fileWrite\r\n\t\targuments: #('fileName::String' contents mode)\r\n\t\tdoing: [ self perform: #fileWriteString ].\r\n\tself implementClass: #StSystemDictionary api: #(\r\n\t\t#(fileIn #(fileName))\r\n\t\t#(emmit #(fileName))\r\n\t\t#(fileInJS #(fileName))\r\n\t\t#(exportCategory #(aString))\r\n\t\tsaveImage\r\n\t\t#(saveImageAs #(fileName))\r\n\t\t#(isFileOlderThan #(fileName referenceFileName))\r\n\t\tstartup\r\n\t\tniy #(niy: #(msg))\r\n\t\tlinkNatives\r\n\t\tbindCore\r\n\t\t#(invalidMessage: #(msg))\r\n\t\tobsolete\r\n\t\t#(linkNative:to: #(instance aClass))\r\n\t\t#(newConstructor #(superC))\r\n\t\t#(will:be: #(anObject className))\r\n\t\t#(newArray #('object=[]'))\r\n\t\t#(newArrayOfSize #(size))\r\n\t\t#(arrayAdapt #(array cookie))\r\n\t\t#(arrayPack #(array))\r\n\t\t#(become:a: #(anObject aClass))\r\n\t\t#(setProtoOf:to: #(nativeObject proto))\r\n\t\t#(klass #(spec))\r\n\t\tglobalScope\r\n\t\t#(__f__ #(source))\r\n\t\t#(__b__ #(sources locals))\r\n\t\tstacktrace\r\n\t\tdatesSupport\r\n\t\t#(block:valueWithPossibleArguments: #(block args))\r\n\t\t#(block_argumentCount #(block))\r\n\t\t#(pool_key #(h k))\r\n\t\t#(pool:at:put: #(pool aKey aValue))\r\n\t\t#(pool:removeKey: #(pool aKey))\r\n\t\t#(pool:at:ifAbsent: #(pool aKey aBlock))\r\n\t\t#(pool:includesKey: #(pool aKey))\r\n\t\t#(pool_keys #(pool))\r\n\t\t#(string_toNumber #(aString))\r\n\t\t#(string:copyFrom:to: #(aString fromIndex toIndex))\r\n\t);cr. ","function(self)\r\n(self):define_struct_inheriting_(\"mutable\",smalltalk:newArray({\"StSystemDictionary\", smalltalk:newArray({smalltalk:newArray({\"dict\", \"Dict{String,Any}\"}), smalltalk:newArray({\"state\", \"String\"}), smalltalk:newArray({\"useManager\", \"Bool\"})})}),\"StObject\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"StSystemDictionary()\",\"StSystemDictionary(Dict(),\\\"boot\\\",false)\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):implementClass_api_(\"io:IO\",smalltalk:newArray({\"Base.show(io::IO,st::StSystemDictionary) = print(io,\\\"smalltalk\\\")\", \"Base.show(io::IO,o::StObject) = print(io, tostring(o))\"}));\r\n(self):implementClass_api_(\"Any\",smalltalk:newArray({\"tostring(o::Any) = to_String(smalltalk,o)\"}));\r\n(self):implementClass_api_(\"StSystemDictionary\",smalltalk:newArray({\"state\", smalltalk:newArray({\"state:\", smalltalk:newArray({\"aState\"})}), \"isNil_(self::StSystemDictionary, aValue::Nothing) = true\", \"isNil_(self::StSystemDictionary, aValue::Any) = aValue === nil\", \"notNil_(self::StSystemDictionary, aValue::Nothing) = false\", \"notNil_(self::StSystemDictionary, aValue::Any) = aValue !== nil\", \"classOf_(self::StSystemDictionary, aValue) = klass(aValue)\", smalltalk:newArray({\"do:onError:\", smalltalk:newArray({\"aBlock\", \"errorBlock\"})}), \"basicAt_(self::StSystemDictionary, key) = basic_at_or_(self, self, key, nil)\", smalltalk:newArray({\"basic:at:or:\", smalltalk:newArray({\"object\", \"key\", \"default\"})}), smalltalk:newArray({\"basic:at:ifAbsent:\", smalltalk:newArray({\"object\", \"key\", \"aBlock\"})}), \"basic_at_(self::StSystemDictionary, object, key) = basic_at_or_(self, object, key, nil)\", smalltalk:newArray({\"basic:at:put:\", smalltalk:newArray({\"object\", \"key\", \"value\"})}), smalltalk:newArray({\"basic:delete:\", smalltalk:newArray({\"object\", \"key\"})}), smalltalk:newArray({\"ifUndefined:do:\", smalltalk:newArray({\"object\", \"aBlock\"})}), smalltalk:newArray({\"times:repeat:\", smalltalk:newArray({\"count\", \"aBlock\"})}), smalltalk:newArray({\"orNil:\", smalltalk:newArray({\"object\"})}), smalltalk:newArray({\"if:nil:notNil:\", smalltalk:newArray({\"anObject\", \"block1\", \"block2\"})}), smalltalk:newArray({\"if:true:false:\", smalltalk:newArray({\"aBoolean\", \"blk1\", \"blk2\"})}), smalltalk:newArray({\"while:do:\", smalltalk:newArray({\"condition\", \"aBlock\"})}), smalltalk:newArray({\"whileNot:do:\", smalltalk:newArray({\"condition\", \"aBlock\"})}), smalltalk:newArray({\"createType\", smalltalk:newArray({\"aName::Symbol\", \"superName\"})})}));\r\n(self):defineClass_implementing_(smalltalk:newArray({\"StObject_class\", \"StClass\", smalltalk:newArray({\"S8Object_class\", smalltalk:newArray({smalltalk:newArray({\"dict\", \"Dict{String,Any}\"})})})}),smalltalk:newArray({}));\r\n(self):implementClass_api_(\"StSystemDictionary\",smalltalk:newArray({smalltalk:newArray({\"mapClassName\", smalltalk:newArray({\"className\", \"category\", \"native=nil\", \"superclass=nil\"})}), smalltalk:newArray({\"setVarNames\", smalltalk:newArray({\"aClass\", \"iVarNames\", \"aValue\"})}), smalltalk:newArray({\"setClass\", smalltalk:newArray({\"aClass\", \"spec\"})}), smalltalk:newArray({\"fnInSpec\", smalltalk:newArray({\"spec\"})}), \"nativeClasses\", \"classes\", \"computeSubclasses\", smalltalk:newArray({\"subclasses\", smalltalk:newArray({\"aClass\"})}), smalltalk:newArray({\"allSubclassesDo\", smalltalk:newArray({\"aClass\", \"aBlock\"})}), smalltalk:newArray({\"bindRoots\", smalltalk:newArray({\"ignored=nil\"})}), smalltalk:newArray({\"isArray:equalTo:\", smalltalk:newArray({\"table1\", \"table2\"})}), smalltalk:newArray({\"object:or:\", smalltalk:newArray({\"receiver\", \"option\"})}), smalltalk:newArray({\"isObject:equalTo:\", smalltalk:newArray({\"receiver\", \"anObject\"})}), smalltalk:newArray({\"object:comma:\", smalltalk:newArray({\"receiver\", \"anObject\"})}), \"object_comma_(self::StSystemDictionary, receiver::Symbol, anObject) = object_comma_(self, string(receiver), anObject)\", smalltalk:newArray({\"boolean:and:\", smalltalk:newArray({\"receiver\", \"option\"})}), smalltalk:newArray({\"boolean:or:\", smalltalk:newArray({\"receiver\", \"option\"})}), smalltalk:newArray({\"booleanNot:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"asCharacter:\", smalltalk:newArray({\"receiver\"})}), \"to_String(self::StSystemDictionary, receiver::Nothing) = \\\"nil\\\"\", \"to_String(self::StSystemDictionary, receiver::String) = receiver\", \"to_String(self::StSystemDictionary, receiver::Number) = string(receiver)\", smalltalk:newArray({\"to_String\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"printString:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"asString:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"mustBeNumber:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"math:max:\", smalltalk:newArray({\"receiver\", \"aNumber\"})}), smalltalk:newArray({\"math:min:\", smalltalk:newArray({\"receiver\", \"aNumber\"})}), smalltalk:newArray({\"addClass\", smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category=nil\"})}), smalltalk:newArray({\"renameClass\", smalltalk:newArray({\"aClass\", \"aString\"})}), smalltalk:newArray({\"removeClass\", smalltalk:newArray({\"aClass\"})}), smalltalk:newArray({\"metaVarNames\", smalltalk:newArray({\"aMetaClass\", \"iVarNames\"})}), smalltalk:newArray({\"smDo\", smalltalk:newArray({\"block\"})}), smalltalk:newArray({\"classChanged\", smalltalk:newArray({\"aBehavior\"})}), smalltalk:newArray({\"classShapeChanged\", smalltalk:newArray({\"aBehavior\"})}), smalltalk:newArray({\"aboutToCreateClass\", smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"})}), smalltalk:newArray({\"aboutToChangeClass\", smalltalk:newArray({\"aClass\", \"superclass\", \"iVarNames\", \"category\"})}), smalltalk:newArray({\"methodBoundTo\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"aboutToBindTo\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"aboutToRemoveFrom\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"methodRemovedFrom\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"objectNotFound\", smalltalk:newArray({\"object\", \"indexOrKey\", \"collection\"})}), smalltalk:newArray({\"whoImplements\", smalltalk:newArray({\"klass\", \"jsSelector\"})}), smalltalk:newArray({\"superImplementor\", smalltalk:newArray({\"klass\", \"jsSelector\"})}), smalltalk:newArray({\"instVarAt\", smalltalk:newArray({\"object\", \"ivName\", \"default=nil\"})}), smalltalk:newArray({\"addMethod\", smalltalk:newArray({\"jsSelector\", \"method\", \"klass\", \"stSelector=nil\"})}), smalltalk:newArray({\"bind\", smalltalk:newArray({\"klass\", \"stSelector\", \"jsSelector\", \"jsFunction\", \"category\", \"stSource\", \"nativeSource=nil\", \"stamp=nil\"})}), smalltalk:newArray({\"removeNativeFunction:for:\", smalltalk:newArray({\"fn\", \"aClass\"})}), smalltalk:newArray({\"removeMethod\", smalltalk:newArray({\"aClass\", \"aMethod\"})}), smalltalk:newArray({\"newMethod\", smalltalk:newArray({\"currentClass\", \"selector\", \"fn\", \"source\", \"nativeSource=nil\", \"stamp=nil\"})}), smalltalk:newArray({\"readJSObject\", smalltalk:newArray({\"js\"})}), smalltalk:newArray({\"basen\", smalltalk:newArray({\"n\", \"b\"})}), smalltalk:newArray({\"globalsDo\", smalltalk:newArray({\"action\"})}), smalltalk:newArray({\"launchImage\", smalltalk:newArray({\"imageName=nil\"})}), smalltalk:newArray({\"is:kindOf:\", smalltalk:newArray({\"anObject\", \"aClass\"})}), \"responds_to_(self::StSystemDictionary, anObject::Nothing, aSelector)=false\", smalltalk:newArray({\"responds:to:\", smalltalk:newArray({\"anObject\", \"aSelector\"})}), smalltalk:newArray({\"handleOf\", smalltalk:newArray({\"anObject\"})}), \"handleOf_or_(self::StSystemDictionary, anObject::Nothing, default)=default\", smalltalk:newArray({\"handleOf:or:\", smalltalk:newArray({\"anObject\", \"default\"})}), \"newHash\", \"stObject\", smalltalk:newArray({\"debugBind\", smalltalk:newArray({\"klass\", \"stSelector\", \"jsSelector\", \"jsFunction\", \"category\", \"stSource\", \"nativeSource=nil\", \"stamp=nil\"})}), smalltalk:newArray({\"debugAddClass\", smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"})}), \"toString\", \"quit() = Base.exit()\", \"quit\", \"version\", smalltalk:newArray({\"folderContents\", smalltalk:newArray({\"fileName\"})}), \"httpSupport\", smalltalk:newArray({\"httpContents\", smalltalk:newArray({\"fileName\"})}), smalltalk:newArray({\"fileContents\", smalltalk:newArray({\"fileName\"})})}));\r\n(self):bind_arguments_doing_(\"fileWrite\",smalltalk:newArray({\"fileName::String\", \"contents\", \"mode\"}),(function()\r\nreturn ((self):perform_(\"fileWriteString\"))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementClass_api_(\"StSystemDictionary\",smalltalk:newArray({smalltalk:newArray({\"fileIn\", smalltalk:newArray({\"fileName\"})}), smalltalk:newArray({\"emmit\", smalltalk:newArray({\"fileName\"})}), smalltalk:newArray({\"fileInJS\", smalltalk:newArray({\"fileName\"})}), smalltalk:newArray({\"exportCategory\", smalltalk:newArray({\"aString\"})}), \"saveImage\", smalltalk:newArray({\"saveImageAs\", smalltalk:newArray({\"fileName\"})}), smalltalk:newArray({\"isFileOlderThan\", smalltalk:newArray({\"fileName\", \"referenceFileName\"})}), \"startup\", \"niy\", smalltalk:newArray({\"niy:\", smalltalk:newArray({\"msg\"})}), \"linkNatives\", \"bindCore\", smalltalk:newArray({\"invalidMessage:\", smalltalk:newArray({\"msg\"})}), \"obsolete\", smalltalk:newArray({\"linkNative:to:\", smalltalk:newArray({\"instance\", \"aClass\"})}), smalltalk:newArray({\"newConstructor\", smalltalk:newArray({\"superC\"})}), smalltalk:newArray({\"will:be:\", smalltalk:newArray({\"anObject\", \"className\"})}), smalltalk:newArray({\"newArray\", smalltalk:newArray({\"object=[]\"})}), smalltalk:newArray({\"newArrayOfSize\", smalltalk:newArray({\"size\"})}), smalltalk:newArray({\"arrayAdapt\", smalltalk:newArray({\"array\", \"cookie\"})}), smalltalk:newArray({\"arrayPack\", smalltalk:newArray({\"array\"})}), smalltalk:newArray({\"become:a:\", smalltalk:newArray({\"anObject\", \"aClass\"})}), smalltalk:newArray({\"setProtoOf:to:\", smalltalk:newArray({\"nativeObject\", \"proto\"})}), smalltalk:newArray({\"klass\", smalltalk:newArray({\"spec\"})}), \"globalScope\", smalltalk:newArray({\"__f__\", smalltalk:newArray({\"source\"})}), smalltalk:newArray({\"__b__\", smalltalk:newArray({\"sources\", \"locals\"})}), \"stacktrace\", \"datesSupport\", smalltalk:newArray({\"block:valueWithPossibleArguments:\", smalltalk:newArray({\"block\", \"args\"})}), smalltalk:newArray({\"block_argumentCount\", smalltalk:newArray({\"block\"})}), smalltalk:newArray({\"pool_key\", smalltalk:newArray({\"h\", \"k\"})}), smalltalk:newArray({\"pool:at:put:\", smalltalk:newArray({\"pool\", \"aKey\", \"aValue\"})}), smalltalk:newArray({\"pool:removeKey:\", smalltalk:newArray({\"pool\", \"aKey\"})}), smalltalk:newArray({\"pool:at:ifAbsent:\", smalltalk:newArray({\"pool\", \"aKey\", \"aBlock\"})}), smalltalk:newArray({\"pool:includesKey:\", smalltalk:newArray({\"pool\", \"aKey\"})}), smalltalk:newArray({\"pool_keys\", smalltalk:newArray({\"pool\"})}), smalltalk:newArray({\"string_toNumber\", smalltalk:newArray({\"aString\"})}), smalltalk:newArray({\"string:copyFrom:to:\", smalltalk:newArray({\"aString\", \"fromIndex\", \"toIndex\"})})}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"define:asInstanceOf:",0
,function(self,aName,clsName)
(
function(_s8_rec)
	(_s8_rec):assign_to_(aName,smalltalk:object_comma_((smalltalk:object_comma_(("St"),clsName)),"()"));
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"encoding","define: aName asInstanceOf: clsName\r\n\t\" Private - Return the encoding for defining a variable named aName. \"\r\n\r\n\tself assign: aName to: #St ,clsName ,'()'; cr ","function(self,aName,clsName)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(aName,smalltalk:object_comma_((smalltalk:object_comma_((\"St\"),clsName)),\"()\"));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"implementClass:api:",0
,function(self,typeName,functions)
(functions):do_((function(spec)
return (smalltalk:if_true_false_((smalltalk:boolean_and_(((spec):isString()),(function()
return ((spec):includes_("="))
end))),(function()
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_(spec);
	return ((_s8_rec):cr())
end
)(self))
end),(function()
local mySpec=nil
(function()
	local _s8_value=(spec)
	mySpec=_s8_value
	return _s8_value
end)();if ((mySpec):isString())==true then (function()
	local _s8_value=((smalltalk.Array):with_with_(mySpec,smalltalk:newArray({})))
	mySpec=_s8_value
	return _s8_value
end)(); end;if (smalltalk:boolean_and_(((mySpec):isArray()),(function()
return (((mySpec):last()):isArray())
end)))==true then (function()
	local _s8_value=((smalltalk.Array):with_with_((mySpec):first(),smalltalk:object_comma_(((smalltalk.Array):with_(smalltalk:object_comma_(("self::"),typeName))),(mySpec):last())))
	mySpec=_s8_value
	return _s8_value
end)(); else (self):error_(smalltalk:object_comma_(("Unspected spec - "),(spec):asLiteral())); end;return ((self):bind_api_(typeName,mySpec))
end)))
end));
return (self);
end
,"encoding","implementClass: typeName api: functions\r\n\t\" Private - API functions. \"\r\n\r\n\tfunctions do: [:spec|\r\n\t\t(spec isString and: [spec includes: $=])\r\n\t\tifTrue: [ self nextPutAll: spec; cr ]\r\n\t\tifFalse: [ | mySpec |\r\n\t\t\tmySpec := spec.\r\n\t\t\tmySpec isString ifTrue: [ mySpec := Array with: mySpec with: #() ].\r\n\t\t\t(mySpec isArray and: [mySpec last isArray]) ifTrue: [\r\n\t\t\t\tmySpec := Array\r\n\t\t\t\t\twith: mySpec first\r\n\t\t\t\t\twith: (Array with: 'self::' ,typeName) ,mySpec last\r\n\t\t\t] ifFalse: [ self error: 'Unspected spec - ' ,spec asLiteral ].\r\n\t\t\tself bind: typeName api: mySpec\r\n\t\t]\r\n\t]","function(self,typeName,functions)\r\n(functions):do_((function(spec)\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_(((spec):isString()),(function()\r\nreturn ((spec):includes_(\"=\"))\r\nend))),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(spec);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend),(function()\r\nlocal mySpec=nil\r\n(function()\r\n\tlocal _s8_value=(spec)\r\n\tmySpec=_s8_value\r\n\treturn _s8_value\r\nend)();if ((mySpec):isString())==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):with_with_(mySpec,smalltalk:newArray({})))\r\n\tmySpec=_s8_value\r\n\treturn _s8_value\r\nend)(); end;if (smalltalk:boolean_and_(((mySpec):isArray()),(function()\r\nreturn (((mySpec):last()):isArray())\r\nend)))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):with_with_((mySpec):first(),smalltalk:object_comma_(((smalltalk.Array):with_(smalltalk:object_comma_((\"self::\"),typeName))),(mySpec):last())))\r\n\tmySpec=_s8_value\r\n\treturn _s8_value\r\nend)(); else (self):error_(smalltalk:object_comma_((\"Unspected spec - \"),(spec):asLiteral())); end;return ((self):bind_api_(typeName,mySpec))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"defineClass:implementing:",0
,function(self,header,functions)
if ((header):isString())==true then return ((self):defineClass_implementing_((smalltalk.Array):with_with_with_(header,smalltalk:newArray({}),smalltalk:newArray({})),functions)); end;
if not (((header):isArray()))==true then return ((self):error_(smalltalk:object_comma_(("Invalid/corrupt class spec - "),(header):asLiteral()))); end;
if (smalltalk:isObject_equalTo_(((header):size()),2))==true then return ((self):defineClass_implementing_(smalltalk:object_comma_((header),(smalltalk.Array):with_(smalltalk:newArray({}))),functions)); end;
if not ((smalltalk:isObject_equalTo_(((header):size()),3)))==true then return ((self):error_(smalltalk:object_comma_(("Invalid class spec size - "),(header):asLiteral()))); end;
(self):define_type_inheriting_("abstract",(header):first(),(header):second());
if (((header):third()):notEmpty())==true then (self):define_struct_inheriting_("mutable",(header):third(),(header):first()); end;
(self):implementClass_api_((header):first(),functions);
return (self);
end
,"encoding","defineClass: header implementing: functions\r\n\t\" Private - jlClass definition. \"\r\n\r\n\theader isString ifTrue: [\r\n\t\t^self\tdefineClass: (Array with: header with: #() with: #())\r\n\t\t\timplementing: functions\r\n\t].\r\n\theader isArray ifFalse: [\r\n\t\t^self error: 'Invalid/corrupt class spec - ' ,header asLiteral\r\n\t].\r\n\theader size = 2 ifTrue: [\r\n\t\t^self\tdefineClass: header ,(Array with: #())\r\n\t\t\timplementing: functions\r\n\t].\r\n\theader size = 3 ifFalse: [\r\n\t\t^self error: 'Invalid class spec size - ' ,header asLiteral\r\n\t].\r\n\r\n\tself define: #abstract type: header first inheriting: header second.\r\n\theader third notEmpty ifTrue: [\r\n\t\tself define: #mutable struct: header third inheriting: header first\r\n\t].\r\n\r\n\tself implementClass: header first api: functions","function(self,header,functions)\r\nif ((header):isString())==true then return ((self):defineClass_implementing_((smalltalk.Array):with_with_with_(header,smalltalk:newArray({}),smalltalk:newArray({})),functions)); end;\r\nif not (((header):isArray()))==true then return ((self):error_(smalltalk:object_comma_((\"Invalid/corrupt class spec - \"),(header):asLiteral()))); end;\r\nif (smalltalk:isObject_equalTo_(((header):size()),2))==true then return ((self):defineClass_implementing_(smalltalk:object_comma_((header),(smalltalk.Array):with_(smalltalk:newArray({}))),functions)); end;\r\nif not ((smalltalk:isObject_equalTo_(((header):size()),3)))==true then return ((self):error_(smalltalk:object_comma_((\"Invalid class spec size - \"),(header):asLiteral()))); end;\r\n(self):define_type_inheriting_(\"abstract\",(header):first(),(header):second());\r\nif (((header):third()):notEmpty())==true then (self):define_struct_inheriting_(\"mutable\",(header):third(),(header):first()); end;\r\n(self):implementClass_api_((header):first(),functions);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"defineStructFields:",0
,function(self,spec)
(spec):do_separatedBy_((function(tuple)
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_((tuple):first());
	(_s8_rec):nextPutAll_("::");
	return ((_s8_rec):nextPutAll_((tuple):last()))
end
)(self))
end),(function()
return ((self):cr())
end));
return (self);
end
,"api","defineStructFields: spec\r\n\t\" Private - Define fields in spec. \"\r\n\r\n\tspec do: [:tuple|\r\n\t\tself nextPutAll: tuple first; nextPutAll: '::'; nextPutAll: tuple last\r\n\t] separatedBy: [ self cr ]","function(self,spec)\r\n(spec):do_separatedBy_((function(tuple)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((tuple):first());\r\n\t(_s8_rec):nextPutAll_(\"::\");\r\n\treturn ((_s8_rec):nextPutAll_((tuple):last()))\r\nend\r\n)(self))\r\nend),(function()\r\nreturn ((self):cr())\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"define:struct:inheriting:",0
,function(self,kind,spec,parentSpec)
local def=nil
local fields=nil
local tags=nil
if not (((spec):isArray()))==true then return ((self):error_(smalltalk:object_comma_(("Invalid/corrupt struct spec - "),(spec):asLiteral()))); end;
if not ((smalltalk:isObject_equalTo_(((spec):size()),2)))==true then return ((self):error_(smalltalk:object_comma_(("Invalid struct spec size - "),(spec):asLiteral()))); end;
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((spec):first())," <: ")),parentSpec))
	def=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:if_true_false_(((kind):isEmpty()),(function()
return ("struct ")
end),(function()
return (smalltalk:object_comma_((kind)," struct "))
end))),def))
	def=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.Array):with_with_(def,"end"))
	tags=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):between_do_indent_(tags,(function()
return ((self):defineStructFields_((spec):last()))
end),true);
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"api","define: kind struct: spec inheriting: parentSpec\r\n\t\" Private - Define a new struct. \"\r\n\r\n\t| def fields tags |\r\n\tspec isArray ifFalse: [\r\n\t\t^self error: 'Invalid/corrupt struct spec - ' ,spec asLiteral\r\n\t].\r\n\tspec size = 2 ifFalse: [\r\n\t\t^self error: 'Invalid struct spec size - ' ,spec asLiteral\r\n\t].\r\n\tdef := spec first ,' <: ' ,parentSpec.\r\n\tdef := (kind isEmpty ifTrue: [ 'struct ' ] ifFalse: [ kind ,' struct ' ]) ,def.\r\n\ttags := Array with: def with: #end.\r\n\tself between: tags do: [ self defineStructFields: spec last ] indent: true; cr ","function(self,kind,spec,parentSpec)\r\nlocal def=nil\r\nlocal fields=nil\r\nlocal tags=nil\r\nif not (((spec):isArray()))==true then return ((self):error_(smalltalk:object_comma_((\"Invalid/corrupt struct spec - \"),(spec):asLiteral()))); end;\r\nif not ((smalltalk:isObject_equalTo_(((spec):size()),2)))==true then return ((self):error_(smalltalk:object_comma_((\"Invalid struct spec size - \"),(spec):asLiteral()))); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((spec):first()),\" <: \")),parentSpec))\r\n\tdef=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:if_true_false_(((kind):isEmpty()),(function()\r\nreturn (\"struct \")\r\nend),(function()\r\nreturn (smalltalk:object_comma_((kind),\" struct \"))\r\nend))),def))\r\n\tdef=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_with_(def,\"end\"))\r\n\ttags=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):between_do_indent_(tags,(function()\r\nreturn ((self):defineStructFields_((spec):last()))\r\nend),true);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"define:type:inheriting:",0
,function(self,kind,typeName,parentSpec)
local tags=nil
(function()
	local _s8_value=((smalltalk.Array):with_with_(smalltalk:object_comma_((kind)," type "),"end"))
	tags=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):between_do_indent_(tags,(function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(typeName);
	return ((_s8_rec):space())
end
)(self);return (smalltalk:if_true_false_(((parentSpec):notEmpty()),(function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("<:");
	return ((_s8_rec):space())
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_(parentSpec);
	return ((_s8_rec):space())
end
)(self))
end),nil))
end),false);
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"api","define: kind type: typeName inheriting: parentSpec\r\n\t\" Private - Define a new type. \"\r\n\r\n\t| tags |\r\n\ttags := Array with: kind ,' type ' with: #end.\r\n\tself between: tags do: [\r\n\t\tself nextPutAll: typeName; space.\r\n\t\tparentSpec notEmpty ifTrue: [\r\n\t\t\tself nextPutAll: #<:; space.\r\n\t\t\tself nextPutAll: parentSpec; space.\r\n\t\t]] indent: false; cr ","function(self,kind,typeName,parentSpec)\r\nlocal tags=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_with_(smalltalk:object_comma_((kind),\" type \"),\"end\"))\r\n\ttags=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):between_do_indent_(tags,(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(typeName);\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);return (smalltalk:if_true_false_(((parentSpec):notEmpty()),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"<:\");\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(parentSpec);\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self))\r\nend),nil))\r\nend),false);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"api:selector:",0
,function(self,typeName,functionName)
local input=nil
local output=nil
if not (((functionName):includes_(".")))==true then return (smalltalk:object_comma_(((functionName):asSelector()),typeName)); end;
(function()
	local _s8_value=((smalltalk:object_comma_((smalltalk:object_comma_((typeName),"_")),(functionName):asSelector())):readStream())
	input=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((""):writeStream())
	output=_s8_value
	return _s8_value
end)();
while not ((function()
return ((input):atEnd())
end))() do (output):nextPutAll_((input):upTo_("."));
smalltalk:if_true_false_(((input):atEnd()),nil,(function()
return ((output):nextPut_("_"))
end)); end;
return ((((output):contents()):asLocalName()):replace_with_("!","8"));
end
,"api","api: typeName selector: functionName\r\n\t\" Private - Returns the selector message to find implementation of function of typeName. \"\r\n\r\n\t| input output |\r\n\t(functionName includes: $.) ifFalse: [\r\n\t\t^functionName asSelector ,typeName\r\n\t].\r\n\tinput := (typeName ,$_ ,functionName asSelector) readStream.\r\n\toutput := '' writeStream.\r\n\t[input atEnd] whileFalse: [\r\n\t\toutput nextPutAll: (input upTo: $.).\r\n\t\tinput atEnd ifFalse: [ output nextPut: $_ ].\r\n\t].\r\n\t^output contents asLocalName\r\n\t\treplace: $! with: $8 ","function(self,typeName,functionName)\r\nlocal input=nil\r\nlocal output=nil\r\nif not (((functionName):includes_(\".\")))==true then return (smalltalk:object_comma_(((functionName):asSelector()),typeName)); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk:object_comma_((smalltalk:object_comma_((typeName),\"_\")),(functionName):asSelector())):readStream())\r\n\tinput=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\toutput=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((input):atEnd())\r\nend))() do (output):nextPutAll_((input):upTo_(\".\"));\r\nsmalltalk:if_true_false_(((input):atEnd()),nil,(function()\r\nreturn ((output):nextPut_(\"_\"))\r\nend)); end;\r\nreturn ((((output):contents()):asLocalName()):replace_with_(\"!\",\"8\"));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"bind:api:",0
,function(self,typeName,spec)
local rcv=nil
local selector=nil
local action=nil
if ((spec):isString())==true then return ((self):bind_api_(typeName,(smalltalk.Array):with_with_(spec,smalltalk:newArray({})))); end;
if not ((((spec):last()):isArray()))==true then return ((self):error_(smalltalk:object_comma_(("Invalid/corrupt API spec "),(spec):asLiteral()))); end;
(function()
	local _s8_value=((self):api_selector_(typeName,(spec):first()))
	selector=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((function()
return ((rcv):perform_(selector))
end))
	action=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:responds_to_((self),(selector))),(function()
return (self)
end),(function()
return (smalltalk:if_true_false_((smalltalk:responds_to_(((self)["$klass"]),(selector))),(function()
return ((self)["$klass"])
end),(function()
return ((function()
	local _s8_value=((function()
return ((self):comment_(smalltalk:object_comma_((smalltalk:object_comma_(("*ToDo* - API "),(selector):asLiteral()))," Not Implemented Yet.")))
end))
	action=_s8_value
	return _s8_value
end)())
end)))
end)))
	rcv=_s8_value
	return _s8_value
end)();
(self):bind_arguments_doing_((spec):first(),(spec):last(),action);
return (self);
end
,"api","bind: typeName api: spec\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\t| rcv selector action |\r\n\tspec isString ifTrue: [ ^self bind: typeName api: (Array with: spec with: #()) ].\r\n\tspec last isArray ifFalse: [\r\n\t\t^self error: 'Invalid/corrupt API spec ' ,spec asLiteral\r\n\t].\r\n\tselector := self api: typeName selector: spec first.\r\n\taction := [ rcv perform: selector ].\r\n\trcv := (self respondsTo: selector) ifTrue: [ self ] ifFalse: [\r\n\t\t(self class respondsTo: selector) ifTrue: [ self class ] ifFalse: [\r\n\t\t\t\" self error: 'Missing API implementation for ' ,selector asLiteral \"\r\n\t\t\taction := [ self comment: '*ToDo* - API ' ,selector asLiteral ,' Not Implemented Yet.' ]\r\n\t\t]\r\n\t].\r\n\tself bind: spec first arguments: spec last doing: action ","function(self,typeName,spec)\r\nlocal rcv=nil\r\nlocal selector=nil\r\nlocal action=nil\r\nif ((spec):isString())==true then return ((self):bind_api_(typeName,(smalltalk.Array):with_with_(spec,smalltalk:newArray({})))); end;\r\nif not ((((spec):last()):isArray()))==true then return ((self):error_(smalltalk:object_comma_((\"Invalid/corrupt API spec \"),(spec):asLiteral()))); end;\r\n(function()\r\n\tlocal _s8_value=((self):api_selector_(typeName,(spec):first()))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((function()\r\nreturn ((rcv):perform_(selector))\r\nend))\r\n\taction=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:responds_to_((self),(selector))),(function()\r\nreturn (self)\r\nend),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:responds_to_(((self)[\"$klass\"]),(selector))),(function()\r\nreturn ((self)[\"$klass\"])\r\nend),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=((function()\r\nreturn ((self):comment_(smalltalk:object_comma_((smalltalk:object_comma_((\"*ToDo* - API \"),(selector):asLiteral())),\" Not Implemented Yet.\")))\r\nend))\r\n\taction=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)))\r\nend)))\r\n\trcv=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):bind_arguments_doing_((spec):first(),(spec):last(),action);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"bind:function:arguments:sending:",0
,function(self,typeName,functionName,args,selector)
(self):bind_arguments_doing_(functionName,smalltalk:object_comma_(((smalltalk.Array):with_(smalltalk:object_comma_(("self::"),typeName))),args),(function()
return ((self):perform_(selector))
end));
return (self);
end
,"api","bind: typeName function: functionName arguments: args sending: selector\r\n\t\" Private - Encoding of custom API function implementation. \"\r\n\r\n\tself\tbind: functionName\r\n\t\targuments: (Array with: 'self::',typeName) ,args\r\n\t\tdoing: [ self perform: selector ] ","function(self,typeName,functionName,args,selector)\r\n(self):bind_arguments_doing_(functionName,smalltalk:object_comma_(((smalltalk.Array):with_(smalltalk:object_comma_((\"self::\"),typeName))),args),(function()\r\nreturn ((self):perform_(selector))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"bind:arguments:doing:comment:",0
,function(self,selector,args,implementation,aComment)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("function");
	return ((_s8_rec):space())
end
)(self);
(self):nextPutAll_(smalltalk:if_true_false_(((selector):startsWith_(">")),(function()
return (selector)
end),(function()
return ((selector):asSelector())
end)));
(self):pars_((function()
return ((self):nextPutArguments_(args))
end));
(self):between_do_indent_comment_(smalltalk:newArray({"", "end"}),implementation,true,aComment);
(self):cr();
return (self);
end
,"asm","bind: selector arguments: args doing: implementation comment: aComment\r\n\t\" Private - Encoding for internal method implementation. \"\r\n\r\n\tself nextPutAll: #function;space.\r\n\tself nextPutAll: ((selector startsWith: $>)\r\n\t\tifTrue: [ selector] ifFalse: [ selector asSelector ]).\r\n\tself pars: [ self nextPutArguments: args ].\r\n\tself between: #('' end) do: implementation indent: true comment: aComment.\r\n\tself cr","function(self,selector,args,implementation,aComment)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"function\");\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(self):nextPutAll_(smalltalk:if_true_false_(((selector):startsWith_(\">\")),(function()\r\nreturn (selector)\r\nend),(function()\r\nreturn ((selector):asSelector())\r\nend)));\r\n(self):pars_((function()\r\nreturn ((self):nextPutArguments_(args))\r\nend));\r\n(self):between_do_indent_comment_(smalltalk:newArray({\"\", \"end\"}),implementation,true,aComment);\r\n(self):cr();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"sendMessage:",0
,function(self,aMessage)
local rcv=nil
local args=nil
(function()
	local _s8_value=((aMessage):receiver())
	rcv=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_or_(((rcv):isString()),(function()
return ((rcv):isValuable())
end)))==true then (function()
	local _s8_value=(smalltalk:object_comma_(((smalltalk.Array):with_(rcv)),(aMessage):arguments()))
	args=_s8_value
	return _s8_value
end)(); else if not (((rcv):isMessage()))==true then (self):error_("Receiver must be aMessage or aString"); end;
(self):pars_((function()
return ((self):sendMessage_(rcv))
end));
(function()
	local _s8_value=(smalltalk:object_comma_(((smalltalk.Array):with_(rcv)),(aMessage):arguments()))
	args=_s8_value
	return _s8_value
end)(); end;
(self):nextPutAll_(((aMessage):selector()):asSelector());
(self):pars_((function()
return ((self):sendMessageArguments_(args))
end));
return (self);
end
,"encoding","sendMessage: aMessage\r\n\t\" Private - Return the encoding for sending aMessage. \"\r\n\r\n\t| rcv args |\r\n\trcv := aMessage receiver.\r\n\t(rcv isString or: [rcv isValuable])\r\n\tifTrue: [ args := (Array with: rcv) ,aMessage arguments ]\r\n\tifFalse: [\r\n\t\trcv isMessage ifFalse: [ self error: 'Receiver must be aMessage or aString' ].\r\n\t\tself pars: [ self sendMessage: rcv ].\r\n\t\targs := (Array with: rcv) ,aMessage arguments\r\n\t].\r\n\tself nextPutAll: aMessage selector asSelector.\r\n\tself pars: [ self sendMessageArguments: args ] ","function(self,aMessage)\r\nlocal rcv=nil\r\nlocal args=nil\r\n(function()\r\n\tlocal _s8_value=((aMessage):receiver())\r\n\trcv=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_or_(((rcv):isString()),(function()\r\nreturn ((rcv):isValuable())\r\nend)))==true then (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((smalltalk.Array):with_(rcv)),(aMessage):arguments()))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)(); else if not (((rcv):isMessage()))==true then (self):error_(\"Receiver must be aMessage or aString\"); end;\r\n(self):pars_((function()\r\nreturn ((self):sendMessage_(rcv))\r\nend));\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((smalltalk.Array):with_(rcv)),(aMessage):arguments()))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(self):nextPutAll_(((aMessage):selector()):asSelector());\r\n(self):pars_((function()\r\nreturn ((self):sendMessageArguments_(args))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"import:",0
,function(self,what)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("import");
	return ((_s8_rec):space())
end
)(self);
(self):nextPutAll_(what);
return (self);
end
,"asm","import: what\r\n\t\" Private - Encoding for import declaration. \"\r\n\r\n\tself nextPutAll: #import; space.\r\n\tself nextPutAll: what ","function(self,what)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"import\");\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(self):nextPutAll_(what);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"expr:is:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,"<:",expr2);
return (self);
end
,"asm","expr: expr1 is: expr2\r\n\t\" Private - Encoding for <: expression. \"\r\n\r\n\tself expr: expr1 op: #<: with: expr2","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,\"<:\",expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"expr:isa:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,"isa",expr2);
return (self);
end
,"asm","expr: expr1 isa: expr2\r\n\t\" Private - Encoding for isa expression. \"\r\n\r\n\tself expr: expr1 op: #isa with: expr2","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,\"isa\",expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"expr:eqgt:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,"=>",expr2);
return (self);
end
,"asm","expr: expr1 eqgt: expr2\r\n\t\" Private - Encoding for => expression. \"\r\n\r\n\tself expr: expr1 op: #=> with: expr2","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,\"=>\",expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"expr:gt:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,">",expr2);
return (self);
end
,"asm","expr: expr1 gt: expr2\r\n\t\" Private - Encoding for > expression. \"\r\n\r\n\tself expr: expr1 op: #> with: expr2","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,\">\",expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"expr:lt:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,"<",expr2);
return (self);
end
,"asm","expr: expr1 lt: expr2\r\n\t\" Private - Encoding for < expression. \"\r\n\r\n\tself expr: expr1 op: #< with: expr2","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,\"<\",expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"expr:dashgt:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,"->",expr2);
return (self);
end
,"asm","expr: expr1 dashgt: expr2\r\n\t\" Private - Encoding for -> expression. \"\r\n\r\n\tself expr: expr1 op: #-> with: expr2","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,\"->\",expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"expr:return:",0
,function(self,expr1,expr2)
(self):expr_and_(expr1,(function()
return ((self):return_(expr2))
end));
return (self);
end
,"asm","expr: expr1 return: expr2\r\n\t\" Private - Encoding for %% return expression. \"\r\n\r\n\tself expr: expr1 and: [self return: expr2] ","function(self,expr1,expr2)\r\n(self):expr_and_(expr1,(function()\r\nreturn ((self):return_(expr2))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"expr:and:return:",0
,function(self,expr1,expr2,expr3)
(self):expr_return_((function()
return ((self):expr_and_(expr1,expr2))
end),expr3);
return (self);
end
,"asm","expr: expr1 and: expr2 return: expr3\r\n\t\" Private - Encoding for &&..&& expression. \"\r\n\r\n\tself expr: [self expr: expr1 and: expr2] return: expr3 ","function(self,expr1,expr2,expr3)\r\n(self):expr_return_((function()\r\nreturn ((self):expr_and_(expr1,expr2))\r\nend),expr3);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"if:do:else:",0
,function(self,condition,trueBlock,falseBlock)
(
function(_s8_rec)
	(_s8_rec):if_(condition);
	return ((_s8_rec):space())
end
)(self);
(self):between_do_indent_(nil,trueBlock,true);
if (smalltalk:notNil_((falseBlock)))==true then (self):nextPutAll_((self):elseOP());
(self):between_do_indent_(nil,falseBlock,true); end;
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("end");
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"asm","if: condition do: trueBlock else: falseBlock\r\n\t\" Private - Encoding for conditional. \"\r\n\r\n\tself if: condition; space.\r\n\tself between: nil do: trueBlock indent: true.\r\n\tfalseBlock notNil ifTrue: [\r\n\t\tself nextPutAll: self elseOP.\r\n\t\tself between: nil do: falseBlock indent: true.\r\n\t].\r\n\tself nextPutAll: #end;cr","function(self,condition,trueBlock,falseBlock)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_(condition);\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(self):between_do_indent_(nil,trueBlock,true);\r\nif (smalltalk:notNil_((falseBlock)))==true then (self):nextPutAll_((self):elseOP());\r\n(self):between_do_indent_(nil,falseBlock,true); end;\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"end\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"succ:",0
,function(self,arg)
(self):expr_op_with_(arg,"+","1");
return (self);
end
,"asm-macros","succ: arg\r\n\t\" Private - Encoding for +1 expression. \"\r\n\r\n\tself expr: arg op: #+ with: #1 ","function(self,arg)\r\n(self):expr_op_with_(arg,\"+\",\"1\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"prev:",0
,function(self,arg)
(self):expr_op_with_(arg,"-","1");
return (self);
end
,"asm-macros","prev: arg\r\n\t\" Private - Encoding for -1 expression. \"\r\n\r\n\tself expr: arg op: #- with: #1 ","function(self,arg)\r\n(self):expr_op_with_(arg,\"-\",\"1\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"if:return:",0
,function(self,condition,expression)
(self):if_do_(condition,(function()
return ((self):return_(expression))
end));
return (self);
end
,"asm","if: condition return: expression\r\n\t\" Private - Encoding for conditional expression return. \"\r\n\r\n\tself if: condition do: [self return: expression]","function(self,condition,expression)\r\n(self):if_do_(condition,(function()\r\nreturn ((self):return_(expression))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"valueIf:do:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,"?",expr2);
return (self);
end
,"asm","valueIf: expr1 do: expr2\r\n\t\" Private - Encoding for (valueIf) expression. \"\r\n\r\n\tself expr: expr1 op: $? with: expr2 ","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,\"?\",expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"valueIf:do:else:",0
,function(self,expr1,expr2,expr3)
(self):expr_op_with_((function()
return ((self):valueIf_do_(expr1,expr2))
end),":",expr3);
return (self);
end
,"asm","valueIf: expr1 do: expr2 else: expr3\r\n\t\" Private - Encoding for (valueIf:else:) expression. \"\r\n\r\n\tself expr: [self valueIf: expr1 do: expr2] op: $: with: expr3 ","function(self,expr1,expr2,expr3)\r\n(self):expr_op_with_((function()\r\nreturn ((self):valueIf_do_(expr1,expr2))\r\nend),\":\",expr3);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"blockOPs",0
,function(self)
return (smalltalk:newArray({"", "end"}));
end
,"asm-constants","blockOPs\r\n\t\" Private - Encoding for expression block OPs \"\r\n\r\n\t^#('' end) ","function(self)\r\nreturn (smalltalk:newArray({\"\", \"end\"}));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"object:at:",0
,function(self,src,index)
(self):nextPutAll_(src);
(self):between_do_indent_("[]",index,false);
return (self);
end
,"asm-macros","object: src at: index\r\n\t\" Private - Encoding for brackets indexing. \"\r\n\r\n\tself nextPutAll: src.\r\n\tself between: '[]' do: index indent: false","function(self,src,index)\r\n(self):nextPutAll_(src);\r\n(self):between_do_indent_(\"[]\",index,false);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"try:catch:doing:",0
,function(self,block,varName,exBlock)
(self):between_do_indent_(smalltalk:newArray({"try", "catch"}),block,true);
if (smalltalk:notNil_((varName)))==true then (
function(_s8_rec)
	(_s8_rec):space();
	return ((_s8_rec):nextPutAll_(varName))
end
)(self); end;
(self):between_do_indent_((self):expressionsOPs(),exBlock,true);
return (self);
end
,"asm","try: block catch: varName doing: exBlock\r\n\t\" Private - Encoding for try/catch expression. \"\r\n\r\n\tself between: #(try catch) do: block indent: true.\r\n\tvarName notNil ifTrue: [\r\n\t\tself space; nextPutAll: varName\r\n\t].\r\n\tself between: self expressionsOPs do: exBlock indent: true","function(self,block,varName,exBlock)\r\n(self):between_do_indent_(smalltalk:newArray({\"try\", \"catch\"}),block,true);\r\nif (smalltalk:notNil_((varName)))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):nextPutAll_(varName))\r\nend\r\n)(self); end;\r\n(self):between_do_indent_((self):expressionsOPs(),exBlock,true);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"try:catch:",0
,function(self,block,exBlock)
(self):try_catch_doing_(block,nil,exBlock);
return (self);
end
,"asm","try: block catch: exBlock\r\n\t\" Private - Encoding for try/catch expression. \"\r\n\r\n\tself try: block catch: nil doing: exBlock","function(self,block,exBlock)\r\n(self):try_catch_doing_(block,nil,exBlock);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"concat:",0
,function(self,array)
(array):do_separatedBy_((function(each)
return ((self):nextPutAll_(each))
end),(function()
return ((self):nextPutAll_("*"))
end));
return (self);
end
,"asm-macros","concat: array\r\n\t\" Private - Encoding to concatenate expressions inlined. \"\r\n\r\n\tarray do: [:each| self nextPutAll: each ] separatedBy: [self nextPutAll: $*] ","function(self,array)\r\n(array):do_separatedBy_((function(each)\r\nreturn ((self):nextPutAll_(each))\r\nend),(function()\r\nreturn ((self):nextPutAll_(\"*\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"sum:",0
,function(self,array)
(array):do_separatedBy_((function(each)
return ((self):nextPutAll_(each))
end),(function()
return ((self):nextPutAll_("+"))
end));
return (self);
end
,"asm-macros","sum: array\r\n\t\" Private - Encoding to concatenate expressions inlined. \"\r\n\r\n\tarray do: [:each| self nextPutAll: each ] separatedBy: [self nextPutAll: $+] ","function(self,array)\r\n(array):do_separatedBy_((function(each)\r\nreturn ((self):nextPutAll_(each))\r\nend),(function()\r\nreturn ((self):nextPutAll_(\"+\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"conditionPars:",0
,function(self,expression)
return (nil);
end
,"asm-constants","conditionPars: expression\r\n\t\" Private - Encoding for condition expression(or nil) \"\r\n\r\n\t^nil ","function(self,expression)\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"opPars:",0
,function(self,expression)
return (nil);
end
,"asm-constants","opPars: expression\r\n\t\" Private - Encoding for expression in operation(or nil) \"\r\n\r\n\t^nil ","function(self,expression)\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"symbol:",0
,function(self,aName)
return ((self):call_with_("Symbol",aName));
end
,"asm-macros","symbol: aName\r\n\t\" Private - Encoding for returning a Symbol instance.\"\r\n\r\n\t^self call: #Symbol with: aName ","function(self,aName)\r\nreturn ((self):call_with_(\"Symbol\",aName));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"typeof:",0
,function(self,anObject)
return ((self):call_with_("typeof",anObject));
end
,"asm-macros","typeof: anObject\r\n\t\" Private - Encoding for returning the type of anObject instance.\"\r\n\r\n\t^self call: #typeof with: anObject ","function(self,anObject)\r\nreturn ((self):call_with_(\"typeof\",anObject));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"hasfield:",0
,function(self,args)
if (smalltalk:boolean_and_(((args):isArray()),(function()
return (smalltalk:isObject_equalTo_(((args):size()),2))
end)))==true then return ((self):call_withArguments_("hasfield",args)); end;
return ((self):error_("Invalid arguments for #hasfield"));
end
,"asm-macros","hasfield: args\r\n\t\" Private - Encoding for #hasfield expression. \"\r\n\r\n\t(args isArray and: [args size = 2]) ifTrue: [\r\n\t\t^self call: #hasfield withArguments: args\r\n\t].\r\n\t^self error: 'Invalid arguments for #hasfield' ","function(self,args)\r\nif (smalltalk:boolean_and_(((args):isArray()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((args):size()),2))\r\nend)))==true then return ((self):call_withArguments_(\"hasfield\",args)); end;\r\nreturn ((self):error_(\"Invalid arguments for #hasfield\"));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"hasfieldTypeof:with:",0
,function(self,src,key)
return ((self):hasfield_((smalltalk.Array):with_with_((function()
return ((self):typeof_(src))
end),key)));
end
,"asm-macros","hasfieldTypeof: src with: key\r\n\t\" Private - Encoding for #hasfield(typeof(src),key) expression. \"\r\n\r\n\t^self hasfield: (Array\r\n\t\twith: [self typeof: src]\r\n\t\twith: key) ","function(self,src,key)\r\nreturn ((self):hasfield_((smalltalk.Array):with_with_((function()\r\nreturn ((self):typeof_(src))\r\nend),key)));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"from:to:",0
,function(self,from,to)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(from);
	(_s8_rec):nextPutAll_(":");
	return ((_s8_rec):nextPutAll_(to))
end
)(self);
return (self);
end
,"asm-macros","from: from to: to\r\n\t\" Private - Encoding for from:to expression. \"\r\n\r\n\tself\tnextPutAll: from;\r\n\t\tnextPutAll: #:;\r\n\t\tnextPutAll: to ","function(self,from,to)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(from);\r\n\t(_s8_rec):nextPutAll_(\":\");\r\n\treturn ((_s8_rec):nextPutAll_(to))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"whileDoOPs",0
,function(self)
return ((smalltalk.Array):with_with_("while",""));
end
,"asm-constants","whileDoOPs\r\n\t\" Private - Return the OPs for while-do expression. \"\r\n\r\n\t^Array with: #while with: '' ","function(self)\r\nreturn ((smalltalk.Array):with_with_(\"while\",\"\"));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"forDoOPs",0
,function(self)
return ((smalltalk.Array):with_with_("for",""));
end
,"asm-constants","forDoOPs\r\n\t\" Private - Return the OPs for for-do expression. \"\r\n\r\n\t^Array with: #for with: '' ","function(self)\r\nreturn ((smalltalk.Array):with_with_(\"for\",\"\"));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"forDoPars",0
,function(self)
return (nil);
end
,"asm-constants","forDoPars\r\n\t\" Private - Return the parentesis for for-do expression. \"\r\n\r\n\t^nil ","function(self)\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"forInDoPars",0
,function(self)
return (nil);
end
,"asm-constants","forInDoPars\r\n\t\" Private - Return the parentesis for for-in-do expression. \"\r\n\r\n\t^nil","function(self)\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"forInDoOPs",0
,function(self)
return ((smalltalk.Array):with_with_with_("for","in",""));
end
,"asm-constants","forInDoOPs\r\n\t\" Private - Return the OPs for for-in-do expression. \"\r\n\r\n\t^Array with: #for with: #in with: '' ","function(self)\r\nreturn ((smalltalk.Array):with_with_with_(\"for\",\"in\",\"\"));\r\nend")

smalltalk:bind(smalltalk.BootSector,"forInDoPars",0
,function(self)
return (nil);
end
,"asm-constants","forInDoPars\r\n\t\" Private - Return the parentesis for for-in-do expression. \"\r\n\r\n\t^nil","function(self)\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"for:from:to:do:",0
,function(self,varName,from,to,aBlock)
return ((self):for_do_((function()
return ((self):assign_to_(varName,(function()
return ((self):from_to_(from,to))
end)))
end),aBlock));
end
,"asm-macros","for: varName from: from to: to do: aBlock\r\n\t\" Private - Encoding for #hasfield(typeof(src),key) expression. \"\r\n\r\n\t^self for: [self assign: varName\r\n\t\tto: [self from: from to: to]]\r\n\t\tdo: aBlock ","function(self,varName,from,to,aBlock)\r\nreturn ((self):for_do_((function()\r\nreturn ((self):assign_to_(varName,(function()\r\nreturn ((self):from_to_(from,to))\r\nend)))\r\nend),aBlock));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"fieldOP",0
,function(self)
return ("=>");
end
,"asm-constants","fieldOP\r\n\t\" Private - Return the OP for tuple separator. \"\r\n\r\n\t^#=> ","function(self)\r\nreturn (\"=>\");\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"objectOPs",0
,function(self)
return ("()");
end
,"asm-constants","objectOPs\r\n\t\" Private - Return the OPs for literal object definition. \"\r\n\r\n\t^'()' ","function(self)\r\nreturn (\"()\");\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"anyDict:object:",0
,function(self,keyType,array)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("Dict{");
	(_s8_rec):nextPutAll_(keyType);
	(_s8_rec):nextPutAll_(",Any}");
	return ((_s8_rec):object_(array))
end
)(self);
return (self);
end
,"asm-macros","anyDict: keyType object: array\r\n\t\" Private - Return the encoding for literal dictionary definition. \"\r\n\r\n\tself\tnextPutAll: 'Dict{';\r\n\t\tnextPutAll: keyType;\r\n\t\tnextPutAll: ',Any}';\r\n\t\tobject: array ","function(self,keyType,array)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"Dict{\");\r\n\t(_s8_rec):nextPutAll_(keyType);\r\n\t(_s8_rec):nextPutAll_(\",Any}\");\r\n\treturn ((_s8_rec):object_(array))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"on:with:do:",0
,function(self,expr,varName,aBlock)
(self):nextPutAll_(expr);
(
function(_s8_rec)
	(_s8_rec):space();
	return ((_s8_rec):nextPutAll_("do"))
end
)(self);
(
function(_s8_rec)
	(_s8_rec):space();
	return ((_s8_rec):nextPutAll_(varName))
end
)(self);
(self):between_do_indent_((self):expressionsOPs(),aBlock,true);
return (self);
end
,"asm-macros","on: expr with: varName do: aBlock\r\n\t\" Private - Encoding for 'expr do var blk' expression. \"\r\n\r\n\tself nextPutAll: expr.\r\n\tself space; nextPutAll: #do.\r\n\tself space; nextPutAll: varName.\r\n\tself between: self expressionsOPs do: aBlock indent: true","function(self,expr,varName,aBlock)\r\n(self):nextPutAll_(expr);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):nextPutAll_(\"do\"))\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):nextPutAll_(varName))\r\nend\r\n)(self);\r\n(self):between_do_indent_((self):expressionsOPs(),aBlock,true);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"klassAny",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("t",(function()
return ((self):typeof_("aValue"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_return_((function()
return ((self):hasfield_(smalltalk:newArray({"t", ":dict"})))
end),(function()
return ((self):call_withArguments_("haskey",smalltalk:newArray({"aValue.dict", "\"\\$klass\""})))
end),"aValue.dict[\"\\$klass\"]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_return_((function()
return ((self):expr_eqeqeq_("t","String"))
end),"smalltalk.String");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_return_((function()
return ((self):expr_eqeqeq_("t","Bool"))
end),"smalltalk.Boolean");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_return_((function()
return ((self):expr_is_("t","Function"))
end),"smalltalk.BlockClosure");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_return_((function()
return ((self):expr_is_("t","Number"))
end),"smalltalk.Number");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_return_((function()
return ((self):expr_eqeqeq_("t","StSystemDictionary"))
end),"smalltalk.Smalltalk");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("nil");
return (self);
end
,"api","klassAny\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #t to: [self typeof: #aValue];cr.\r\n\tself expr: [self hasfield: #(t :dict)]\r\n\t\tand: [self call: #haskey withArguments: #('aValue.dict' '\"\\$klass\"')]\r\n\t\treturn: 'aValue.dict[\"\\$klass\"]';cr.\r\n\tself expr: [self expr: #t eqeqeq: #String]\r\n\t\treturn: 'smalltalk.String';cr.\r\n\tself expr: [self expr: #t eqeqeq: #Bool] \r\n\t\treturn: 'smalltalk.Boolean';cr.\r\n\tself expr: [self expr: #t is: #Function] \r\n\t\treturn: 'smalltalk.BlockClosure';cr.\r\n\tself expr: [self expr: #t is: #Number] \r\n\t\treturn: 'smalltalk.Number';cr.\r\n\tself expr: [self expr: #t eqeqeq: #StSystemDictionary] \r\n\t\treturn: 'smalltalk.Smalltalk';cr.\r\n\tself return: #nil ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"t\",(function()\r\nreturn ((self):typeof_(\"aValue\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_return_((function()\r\nreturn ((self):hasfield_(smalltalk:newArray({\"t\", \":dict\"})))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"haskey\",smalltalk:newArray({\"aValue.dict\", \"\\\"\\\\$klass\\\"\"})))\r\nend),\"aValue.dict[\\\"\\\\$klass\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_return_((function()\r\nreturn ((self):expr_eqeqeq_(\"t\",\"String\"))\r\nend),\"smalltalk.String\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_return_((function()\r\nreturn ((self):expr_eqeqeq_(\"t\",\"Bool\"))\r\nend),\"smalltalk.Boolean\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_return_((function()\r\nreturn ((self):expr_is_(\"t\",\"Function\"))\r\nend),\"smalltalk.BlockClosure\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_return_((function()\r\nreturn ((self):expr_is_(\"t\",\"Number\"))\r\nend),\"smalltalk.Number\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_return_((function()\r\nreturn ((self):expr_eqeqeq_(\"t\",\"StSystemDictionary\"))\r\nend),\"smalltalk.Smalltalk\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"nil\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"stObjectBaseGetproperty",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):hasfieldTypeof_with_("self","aSymbol"))
end),(function()
return ((self):call_withArguments_("getfield",smalltalk:newArray({"self", "aSymbol"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):call_withArguments_("haskey",(smalltalk.Array):with_with_("self.dict",(function()
return ((self):call_with_("string","aSymbol"))
end))))
end),(function()
return ((self):call_withArguments_("get",(smalltalk.Array):with_with_with_("self.dict",(function()
return ((self):call_with_("string","aSymbol"))
end),"nil")))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_withArguments_("getfield",smalltalk:newArray({"self", "aSymbol"})))
end));
return (self);
end
,"api","stObjectBaseGetproperty\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self hasfieldTypeof: #self with: #aSymbol]\r\n\t\treturn: [self call: #getfield withArguments: #(self aSymbol)];cr.\r\n\tself if: [self call: #haskey withArguments: (Array\r\n\t\t\twith: 'self.dict'\r\n\t\t\twith: [self call: #string with: #aSymbol])]\r\n\t\treturn: [self call: #get withArguments: (Array\r\n\t\t\twith: 'self.dict'\r\n\t\t\twith: [self call: #string with: #aSymbol]\r\n\t\t\twith: #nil)];cr.\r\n\tself return: [self call: #getfield withArguments: #(self aSymbol)] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):hasfieldTypeof_with_(\"self\",\"aSymbol\"))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"getfield\",smalltalk:newArray({\"self\", \"aSymbol\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):call_withArguments_(\"haskey\",(smalltalk.Array):with_with_(\"self.dict\",(function()\r\nreturn ((self):call_with_(\"string\",\"aSymbol\"))\r\nend))))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"get\",(smalltalk.Array):with_with_with_(\"self.dict\",(function()\r\nreturn ((self):call_with_(\"string\",\"aSymbol\"))\r\nend),\"nil\")))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_withArguments_(\"getfield\",smalltalk:newArray({\"self\", \"aSymbol\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"stObjectBaseSetproperty8",0
,function(self)
(self):comment_("println(\"setproperty! [\",string(aSymbol),\"]=\",object)");
(self):if_do_else_((function()
return ((self):hasfieldTypeof_with_("self","aSymbol"))
end),(function()
return ((self):call_withArguments_("setfield!",smalltalk:newArray({"self", "aSymbol", "object"})))
end),(function()
return ((self):assign_to_("self.dict[string(aSymbol)]","object"))
end));
return (self);
end
,"api","stObjectBaseSetproperty8\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'println(\"setproperty! [\",string(aSymbol),\"]=\",object)'.\r\n\tself if: [self hasfieldTypeof: #self with: #aSymbol]\r\n\t\tdo: [ self call: 'setfield!' withArguments: #(self aSymbol object) ]\r\n\t\telse: [ self assign: 'self.dict[string(aSymbol)]' to: #object] ","function(self)\r\n(self):comment_(\"println(\\\"setproperty! [\\\",string(aSymbol),\\\"]=\\\",object)\");\r\n(self):if_do_else_((function()\r\nreturn ((self):hasfieldTypeof_with_(\"self\",\"aSymbol\"))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"setfield!\",smalltalk:newArray({\"self\", \"aSymbol\", \"object\"})))\r\nend),(function()\r\nreturn ((self):assign_to_(\"self.dict[string(aSymbol)]\",\"object\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"stObjectBaseSetindex8",0
,function(self)
(self):comment_("println(\"setindex! [\",string(aSymbol),\"]=\",object)");
(self):assign_to_("self.dict[string(aSymbol)]","object");
return (self);
end
,"api","stObjectBaseSetindex8\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'println(\"setindex! [\",string(aSymbol),\"]=\",object)'.\r\n\tself assign: 'self.dict[string(aSymbol)]' to: #object ","function(self)\r\n(self):comment_(\"println(\\\"setindex! [\\\",string(aSymbol),\\\"]=\\\",object)\");\r\n(self):assign_to_(\"self.dict[string(aSymbol)]\",\"object\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"stObjectBaseGetindexName",0
,function(self)
(self):return_((function()
return ((self):call_withArguments_("get",(smalltalk.Array):with_with_with_("self.dict",(function()
return ((self):call_with_("string","aName"))
end),"nil")))
end));
return (self);
end
,"api","stObjectBaseGetindexName \r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self call: #get withArguments: (Array\r\n\t\twith: 'self.dict'\r\n\t\twith: [self call: #string with: #aName]\r\n\t\twith: #nil)] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):call_withArguments_(\"get\",(smalltalk.Array):with_with_with_(\"self.dict\",(function()\r\nreturn ((self):call_with_(\"string\",\"aName\"))\r\nend),\"nil\")))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"stObjectBaseGetindexInt",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):call_withArguments_("haskey",smalltalk:newArray({"self.dict", "\"@handle\""})))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("h","self.dict[\"@handle\"]");
	return ((_s8_rec):cr())
end
)(self);return ((self):return_((function()
return ((self):call_withArguments_("Base.getindex",smalltalk:newArray({"h", "ind"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_withArguments_("Base.getindex",smalltalk:newArray({"self", "ind"})))
end));
return (self);
end
,"api","stObjectBaseGetindexInt\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self call: #haskey withArguments: #('self.dict' '\"@handle\"')] do: [\r\n\t\tself assign: #h to: 'self.dict[\"@handle\"]';cr.\r\n\t\tself return: [self call: 'Base.getindex' withArguments: #(h ind)]\r\n\t];cr.\r\n\tself return: [self call: 'Base.getindex' withArguments: #(self ind)] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):call_withArguments_(\"haskey\",smalltalk:newArray({\"self.dict\", \"\\\"@handle\\\"\"})))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",\"self.dict[\\\"@handle\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_((function()\r\nreturn ((self):call_withArguments_(\"Base.getindex\",smalltalk:newArray({\"h\", \"ind\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_withArguments_(\"Base.getindex\",smalltalk:newArray({\"self\", \"ind\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"handleOrStObject",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):call_with_("handle","self"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_to_with_("isNil:","smalltalk","result"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[\"@handle\"]","forcedHandle");
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("forcedHandle"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"api","handleOrStObject\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #result to: [self call: #handle with: #self];cr.\r\n\tself if: [self send: #isNil: to: #smalltalk with: #result] do: [\r\n\t\tself assign: 'self[\"@handle\"]' to: #forcedHandle;cr.\r\n\t\tself return: #forcedHandle\r\n\t];cr.\r\n\tself return: #result ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):call_with_(\"handle\",\"self\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_to_with_(\"isNil:\",\"smalltalk\",\"result\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[\\\"@handle\\\"]\",\"forcedHandle\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"forcedHandle\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"basicNewInstance_StBehavior",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):call_with_("self.dict[\"\\$constructor\"]","fields"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("result.dict[\"\\$klass\"]","self");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"api","basicNewInstance_StBehavior\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #result to: [self call: 'self.dict[\"\\$constructor\"]' with: #fields];cr.\r\n\tself assign: 'result.dict[\"\\$klass\"]' to: #self;cr.\r\n\tself return: #result ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):call_with_(\"self.dict[\\\"\\\\$constructor\\\"]\",\"fields\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result.dict[\\\"\\\\$klass\\\"]\",\"self\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"nativeNew_StBehavior",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("fields",(function()
return ((self):valueIf_do_else_((function()
return ((self):send_to_with_("isNil:","smalltalk","handle"))
end),(function()
return ((self):call_("Dict{String,Any}"))
end),(function()
return ((self):call_with_("Dict{String,Any}",(function()
return ((self):expr_eqgt_("\"@handle\"","handle"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_with_("basicNewInstance:","self","fields"))
end));
return (self);
end
,"api","nativeNew_StBehavior\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #fields to: [self\r\n\t\tvalueIf: [self send: #isNil: to: #smalltalk with: #handle]\r\n\t\tdo: [self call: 'Dict{String,Any}']\r\n\t\telse: [self call: 'Dict{String,Any}' with: [self expr: '\"@handle\"' eqgt: #handle]]\r\n\t];cr.\r\n\tself return: [self send: #basicNewInstance: to: #self with: #fields] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"fields\",(function()\r\nreturn ((self):valueIf_do_else_((function()\r\nreturn ((self):send_to_with_(\"isNil:\",\"smalltalk\",\"handle\"))\r\nend),(function()\r\nreturn ((self):call_(\"Dict{String,Any}\"))\r\nend),(function()\r\nreturn ((self):call_with_(\"Dict{String,Any}\",(function()\r\nreturn ((self):expr_eqgt_(\"\\\"@handle\\\"\",\"handle\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"basicNewInstance:\",\"self\",\"fields\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"_gt_gtStBehavior",0
,function(self)
(self):return_((function()
return ((self):send_to_with_("compiledMethodAt:","self","selector"))
end));
return (self);
end
,"api","_gt_gtStBehavior\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #compiledMethodAt: to: #self with: #selector] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"compiledMethodAt:\",\"self\",\"selector\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"_gt_gt_gtStBehavior",0
,function(self)
(self):return_((function()
return ((self):send_to_with_(">>>","self","selector"))
end));
return (self);
end
,"api","_gt_gt_gtStBehavior\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #>>> to: #self with: #selector] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\">>>\",\"self\",\"selector\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"stGlobalScopeBaseGetproperty",0
,function(self)
(self):try_catch_doing_((function()
return ((self):return_((function()
return ((self):call_with_("eval","aSymbol"))
end)))
end),"ex",(function()
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("println",smalltalk:newArray({"\"StGlobalScope getproperty[\"", "aSymbol", "\"] error=\"", "ex"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("nil"))
end));
return (self);
end
,"api","stGlobalScopeBaseGetproperty\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself try: [\r\n\t\tself return: [self call: #eval with: #aSymbol]\r\n\t] catch: #ex doing: [\r\n\t\tself call: #println withArguments: #('\"StGlobalScope getproperty[\"' aSymbol '\"] error=\"' ex);cr.\r\n\t\tself return: #nil\r\n\t] ","function(self)\r\n(self):try_catch_doing_((function()\r\nreturn ((self):return_((function()\r\nreturn ((self):call_with_(\"eval\",\"aSymbol\"))\r\nend)))\r\nend),\"ex\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"println\",smalltalk:newArray({\"\\\"StGlobalScope getproperty[\\\"\", \"aSymbol\", \"\\\"] error=\\\"\", \"ex\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"nil\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"stGlobalScopeBaseGetindex",0
,function(self)
(self):return_((function()
return ((self):send_with_("Base.getproperty",(function()
return ((self):symbol_("aName"))
end)))
end));
return (self);
end
,"api","stGlobalScopeBaseGetindex\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [ self send: 'Base.getproperty' with: [self symbol: #aName] ] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"Base.getproperty\",(function()\r\nreturn ((self):symbol_(\"aName\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"stGlobalScopeBaseSetproperty8",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("key",(function()
return ((self):call_with_("string","aSymbol"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):try_catch_doing_((function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("global cookie","object");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("code",(function()
return ((self):concat_((smalltalk.Array):with_with_with_("\"global \"",(function()
return ((self):call_with_("string","aSymbol"))
end),"\"=cookie\"")))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):call_with_("eval",(function()
return ((self):call_with_("Meta.parse","code"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("object"))
end),"ex",(function()
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("println",smalltalk:newArray({"\"StGlobalScope[set] error \"", "ex"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("nil"))
end));
return (self);
end
,"api","stGlobalScopeBaseSetproperty8\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #key to: [self call: #string with: #aSymbol];cr.\r\n\tself try: [\r\n\t\tself assign: 'global cookie' to: #object;cr.\r\n\t\tself assign: #code to: [self concat: (Array\r\n\t\t\twith: '\"global \"'\r\n\t\t\twith: [self call: #string with: #aSymbol]\r\n\t\t\twith: '\"=cookie\"')\r\n\t\t];cr.\r\n\t\tself call: #eval with: [self call: 'Meta.parse' with: #code];cr.\r\n\t\tself return: #object\r\n\t] catch: #ex doing: [\r\n\t\tself call: #println withArguments: #('\"StGlobalScope[set] error \"' ex);cr.\r\n\t\tself return: #nil\r\n\t] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"key\",(function()\r\nreturn ((self):call_with_(\"string\",\"aSymbol\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):try_catch_doing_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"global cookie\",\"object\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"code\",(function()\r\nreturn ((self):concat_((smalltalk.Array):with_with_with_(\"\\\"global \\\"\",(function()\r\nreturn ((self):call_with_(\"string\",\"aSymbol\"))\r\nend),\"\\\"=cookie\\\"\")))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"eval\",(function()\r\nreturn ((self):call_with_(\"Meta.parse\",\"code\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"object\"))\r\nend),\"ex\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"println\",smalltalk:newArray({\"\\\"StGlobalScope[set] error \\\"\", \"ex\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"nil\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"stGlobalScopeBaseSetindex8",0
,function(self)
(self):return_((function()
return ((self):send_to_withArguments_("Base.setproperty!","self",(smalltalk.Array):with_with_((function()
return ((self):symbol_("aSymbol"))
end),"object")))
end));
return (self);
end
,"api","stGlobalScopeBaseSetindex8\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: 'Base.setproperty!' to: #self withArguments: (Array\r\n\t\twith: [self symbol: #aSymbol]\r\n\t\twith: #object)] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_to_withArguments_(\"Base.setproperty!\",\"self\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):symbol_(\"aSymbol\"))\r\nend),\"object\")))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"stateStSystemDictionary",0
,function(self)
(self):return_("self.state");
return (self);
end
,"api","stateStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: 'self.state' ","function(self)\r\n(self):return_(\"self.state\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"state_StSystemDictionary",0
,function(self)
(self):assign_to_("self.state","aState");
return (self);
end
,"api","state_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: 'self.state' to: #aState ","function(self)\r\n(self):assign_to_(\"self.state\",\"aState\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"do_onError_StSystemDictionary",0
,function(self)
(self):send_with_("invalidMessage:","\"do:onError:\"");
return (self);
end
,"api","do_onError_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #invalidMessage: with: '\"do:onError:\"' ","function(self)\r\n(self):send_with_(\"invalidMessage:\",\"\\\"do:onError:\\\"\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"basic_at_or_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("skey",(function()
return ((self):symbol_("key"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):hasfieldTypeof_with_("object",":dict"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_noteq_((function()
return ((self):typeof_("object"))
end),"S8GlobalScope"))
end),(function()
return ((self):if_return_((function()
return ((self):not_((function()
return ((self):call_withArguments_("hasproperty",smalltalk:newArray({"object", "skey"})))
end)))
end),"default"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):try_catch_doing_((function()
return ((self):return_((function()
return ((self):call_withArguments_("getproperty",smalltalk:newArray({"object", "skey"})))
end)))
end),"ex",(function()
return ((self):return_("default"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("keyString",(function()
return ((self):call_with_("string","key"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_return_((function()
return ((self):call_withArguments_("haskey",smalltalk:newArray({"object.dict", "keyString"})))
end),"object.dict[keyString]");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("default");
return (self);
end
,"api","basic_at_or_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #skey to: [self symbol: #key];cr.\r\n\tself if: [self not: [self hasfieldTypeof: #object with: #:dict]] do: [\r\n\t\t\tself if: [self expr: [self typeof: #object] noteq: #S8GlobalScope] do: [\r\n\t\t\t\tself if: [self not: [self call: #hasproperty withArguments: #(object skey)]]\r\n\t\t\t\t\treturn: #default\r\n\t\t\t];cr.\r\n\t\t\tself try: [ self return: [self\r\n\t\t\t\tcall: #getproperty\r\n\t\t\t\twithArguments: #(object skey)]\r\n\t\t\t] catch: #ex doing: [ self return: #default ]\r\n\t];cr.\r\n\tself assign: #keyString to: [self call: #string with: #key];cr.\r\n\tself expr: [self call: #haskey withArguments: #('object.dict' keyString)]\r\n\t\treturn: 'object.dict[keyString]';cr.\r\n\tself return: #default ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"skey\",(function()\r\nreturn ((self):symbol_(\"key\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):hasfieldTypeof_with_(\"object\",\":dict\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_noteq_((function()\r\nreturn ((self):typeof_(\"object\"))\r\nend),\"S8GlobalScope\"))\r\nend),(function()\r\nreturn ((self):if_return_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):call_withArguments_(\"hasproperty\",smalltalk:newArray({\"object\", \"skey\"})))\r\nend)))\r\nend),\"default\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):try_catch_doing_((function()\r\nreturn ((self):return_((function()\r\nreturn ((self):call_withArguments_(\"getproperty\",smalltalk:newArray({\"object\", \"skey\"})))\r\nend)))\r\nend),\"ex\",(function()\r\nreturn ((self):return_(\"default\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"keyString\",(function()\r\nreturn ((self):call_with_(\"string\",\"key\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_return_((function()\r\nreturn ((self):call_withArguments_(\"haskey\",smalltalk:newArray({\"object.dict\", \"keyString\"})))\r\nend),\"object.dict[keyString]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"default\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"basic_at_ifAbsent_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("sentinel",(function()
return ((self):call_with_("newHash","self"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):send_withArguments_("basic:at:or:",smalltalk:newArray({"object", "key", "sentinel"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):expr_eqeq_("result",(function()
return ((self):valueIf_do_else_("sentinel",(function()
return ((self):call_with_("evaluate","aBlock"))
end),"result"))
end)))
end));
return (self);
end
,"api","basic_at_ifAbsent_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #sentinel to: [self call: #newHash with: #self];cr.\r\n\tself assign: #result to: [self\r\n\t\tsend: #basic:at:or:\r\n\t\twithArguments: #(object key sentinel)\r\n\t];cr.\r\n\tself return: [self expr: #result eqeq: [\r\n\t\tself valueIf: #sentinel do: [\r\n\t\t\tself call: #evaluate with: #aBlock\r\n\t\t\t] else: #result\r\n\t]]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"sentinel\",(function()\r\nreturn ((self):call_with_(\"newHash\",\"self\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:or:\",smalltalk:newArray({\"object\", \"key\", \"sentinel\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):expr_eqeq_(\"result\",(function()\r\nreturn ((self):valueIf_do_else_(\"sentinel\",(function()\r\nreturn ((self):call_with_(\"evaluate\",\"aBlock\"))\r\nend),\"result\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"basic_at_put_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("skey",(function()
return ((self):symbol_("key"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):hasfieldTypeof_with_("object",":dict"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setproperty!",smalltalk:newArray({"object", "skey", "value"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("value"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("keyString",(function()
return ((self):call_with_("string","key"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("object.dict[keyString]","value");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("value");
return (self);
end
,"api","basic_at_put_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #skey to: [self symbol: #key];cr.\r\n\tself if: [self not: [self hasfieldTypeof: #object with: #:dict]] do: [\r\n\t\tself call: 'setproperty!' withArguments: #(object skey value);cr.\r\n\t\tself return: #value\r\n\t];cr.\r\n\tself assign: #keyString to: [self call: #string with: #key];cr.\r\n\tself assign: 'object.dict[keyString]' to: #value;cr.\r\n\tself return: #value ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"skey\",(function()\r\nreturn ((self):symbol_(\"key\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):hasfieldTypeof_with_(\"object\",\":dict\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setproperty!\",smalltalk:newArray({\"object\", \"skey\", \"value\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"value\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"keyString\",(function()\r\nreturn ((self):call_with_(\"string\",\"key\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"object.dict[keyString]\",\"value\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"value\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"basic_delete_StSystemDictionary",0
,function(self)
(self):if_do_else_((function()
return ((self):not_((function()
return ((self):hasfieldTypeof_with_("object",":dict"))
end)))
end),(function()
return ((self):call_withArguments_("setproperty!",smalltalk:newArray({"object", "skey", "nil"})))
end),(function()
return ((self):call_withArguments_("delete!",(smalltalk.Array):with_with_("object.dict",(function()
return ((self):call_with_("string","key"))
end))))
end));
return (self);
end
,"api","basic_delete_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self not:  [self hasfieldTypeof: #object with: #:dict]] do: [\r\n\t\tself call: 'setproperty!' withArguments: #(object skey #nil).\r\n\t] else: [\r\n\t\tself call: 'delete!' withArguments: (Array\r\n\t\t\twith: 'object.dict'\r\n\t\t\twith: [self call: #string with: #key])\r\n\t] ","function(self)\r\n(self):if_do_else_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):hasfieldTypeof_with_(\"object\",\":dict\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"setproperty!\",smalltalk:newArray({\"object\", \"skey\", \"nil\"})))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"delete!\",(smalltalk.Array):with_with_(\"object.dict\",(function()\r\nreturn ((self):call_with_(\"string\",\"key\"))\r\nend))))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"ifUndefined_do_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_to_with_("isNil:","self","object"))
end),(function()
return ((self):return_("nil"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("object");
return (self);
end
,"api","ifUndefined_do_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self send: #isNil: to: #self with: #object] and: [self return: #nil];cr.\r\n\tself return: #object ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_to_with_(\"isNil:\",\"self\",\"object\"))\r\nend),(function()\r\nreturn ((self):return_(\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"object\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"times_repeat_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):for_from_to_do_("i","1","count",(function()
return ((self):send_to_with_("evaluateWith:","aBlock","i"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("count");
return (self);
end
,"api","times_repeat_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself for: #i from: #1 to: #count do: [\r\n\t\tself send: #evaluateWith: to: #aBlock with: #i\r\n\t];cr.\r\n\tself return: #count ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_from_to_do_(\"i\",\"1\",\"count\",(function()\r\nreturn ((self):send_to_with_(\"evaluateWith:\",\"aBlock\",\"i\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"count\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"orNil_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_to_with_("isNil:","self","object"))
end),(function()
return ((self):return_("nil"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("object");
return (self);
end
,"api","orNil_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self send: #isNil: to: #self with: #object] and: [self return: #nil];cr.\r\n\tself return: #object ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_to_with_(\"isNil:\",\"self\",\"object\"))\r\nend),(function()\r\nreturn ((self):return_(\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"object\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"if_nil_notNil_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_to_with_("isNil:","self","anObject"))
end),(function()
return ((self):return_((function()
return ((self):send_to_("evaluate","block1"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_("evaluate","block2"))
end));
return (self);
end
,"api","if_nil_notNil_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self send: #isNil: to: #self with: #anObject]\r\n\t\tand: [self return: [self send: #evaluate to: #block1]];cr.\r\n\tself return: [self send: #evaluate to: #block2] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_to_with_(\"isNil:\",\"self\",\"anObject\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_(\"evaluate\",\"block1\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_(\"evaluate\",\"block2\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"if_true_false_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_else_("aBoolean",(function()
return ((self):expr_and_((function()
return ((self):send_to_with_("notNil:","self","blk1"))
end),(function()
return ((self):return_((function()
return ((self):call_("blk1"))
end)))
end)))
end),(function()
return ((self):expr_and_((function()
return ((self):send_to_with_("notNil:","self","blk2"))
end),(function()
return ((self):return_((function()
return ((self):call_("blk2"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("nil");
return (self);
end
,"api","if_true_false_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: #aBoolean do: [\r\n\t\tself expr: [self send: #notNil: to: #self with: #blk1]\r\n\t\t\tand: [self return: [self call: #blk1]]\r\n\t] else: [\r\n\t\tself expr: [self send: #notNil: to: #self with: #blk2]\r\n\t\t\tand: [self return: [self call: #blk2]]\r\n\t];cr.\r\n\tself return: #nil ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_(\"aBoolean\",(function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):send_to_with_(\"notNil:\",\"self\",\"blk1\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):call_(\"blk1\"))\r\nend)))\r\nend)))\r\nend),(function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):send_to_with_(\"notNil:\",\"self\",\"blk2\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):call_(\"blk2\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"nil\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"while_do_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):while_do_((function()
return ((self):call_("condition"))
end),(function()
return ((self):expr_and_((function()
return ((self):send_to_with_("notNil:","self","aBlock"))
end),(function()
return ((self):send_to_("evaluate","aBlock"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("nil");
return (self);
end
,"api","while_do_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself while: [self call: #condition] do: [\r\n\t\tself expr: [self send: #notNil: to: #self with: #aBlock]\r\n\t\t\tand: [self send: #evaluate to: #aBlock]\r\n\t];cr.\r\n\tself return: #nil ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):while_do_((function()\r\nreturn ((self):call_(\"condition\"))\r\nend),(function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):send_to_with_(\"notNil:\",\"self\",\"aBlock\"))\r\nend),(function()\r\nreturn ((self):send_to_(\"evaluate\",\"aBlock\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"nil\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"whileNot_do_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):while_do_((function()
return ((self):not_((function()
return ((self):call_("condition"))
end)))
end),(function()
return ((self):expr_and_((function()
return ((self):send_to_with_("notNil:","self","aBlock"))
end),(function()
return ((self):send_to_("evaluate","aBlock"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("nil");
return (self);
end
,"api","whileNot_do_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself while: [self not: [self call: #condition]] do: [\r\n\t\tself expr: [self send: #notNil: to: #self with: #aBlock]\r\n\t\t\tand: [self send: #evaluate to: #aBlock]\r\n\t];cr.\r\n\tself return: #nil ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):while_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):call_(\"condition\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):send_to_with_(\"notNil:\",\"self\",\"aBlock\"))\r\nend),(function()\r\nreturn ((self):send_to_(\"evaluate\",\"aBlock\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"nil\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"createTypeStSystemDictionary",0
,function(self)
(self):comment_("println(\"createType \",aName,\"<:\",superName)");
(
function(_s8_rec)
	(_s8_rec):assign_to_("stName",(function()
return ((self):concat_((smalltalk.Array):with_with_("\"St\"",(function()
return ((self):call_with_("String","aName"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("s8Name",(function()
return ((self):concat_((smalltalk.Array):with_with_("\"S8\"",(function()
return ((self):call_with_("String","aName"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):try_catch_((function()
(
function(_s8_rec)
	(_s8_rec):call_with_("eval",(function()
return ((self):call_with_("Meta.parse","stName"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):comment_("println(\"FOUND \" ,stName)"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_gt_((function()
return ((self):call_with_("length","superName"))
end),"0"))
end),(function()
return ((self):assign_to_("superName",(function()
return ((self):concat_(smalltalk:newArray({"\" <: St\"", "superName"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("code",(function()
return ((self):concat_(smalltalk:newArray({"\"abstract type \"", "stName", "superName", "\" end\""})))
end));
	return ((_s8_rec):cr())
end
)(self);(self):comment_("println(code)");return ((
function(_s8_rec)
	(_s8_rec):call_with_("eval",(function()
return ((self):call_with_("Meta.parse","code"))
end));
	return ((_s8_rec):cr())
end
)(self))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):try_catch_((function()
(
function(_s8_rec)
	(_s8_rec):call_with_("eval",(function()
return ((self):call_with_("Meta.parse","s8Name"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):comment_("println(\"FOUND \" ,s8Name)"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("code",(function()
return ((self):concat_(smalltalk:newArray({"\"mutable struct \"", "s8Name", "\" <: \"", "stName"})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("code",(function()
return ((self):concat_(smalltalk:newArray({"code", "\"\\n\tdict::Dict{String,Any}\""})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("code",(function()
return ((self):concat_(smalltalk:newArray({"code", "\"\\nend\""})))
end));
	return ((_s8_rec):cr())
end
)(self);(self):comment_("println(code)");return ((
function(_s8_rec)
	(_s8_rec):call_with_("eval",(function()
return ((self):call_with_("Meta.parse","code"))
end));
	return ((_s8_rec):cr())
end
)(self))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_with_("eval",(function()
return ((self):call_with_("Meta.parse","s8Name"))
end)))
end));
return (self);
end
,"api","createTypeStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'println(\"createType \",aName,\"<:\",superName)'.\r\n\tself assign: #stName to: [self concat: (Array with: '\"St\"' with: [self call: #String with: #aName])];cr.\r\n\tself assign: #s8Name to: [self concat: (Array with: '\"S8\"' with: [self call: #String with: #aName])];cr.\r\n\tself try: [\r\n\t\tself call: #eval with: [self call: 'Meta.parse' with: #stName];cr.\r\n\t\tself comment: 'println(\"FOUND \" ,stName)'\r\n\t] catch: [\r\n\t\tself if: [self expr: [self call: #length with: #superName] gt: #0] do: [\r\n\t\t\tself assign: #superName to: [self concat: #('\" <: St\"' superName)]\r\n\t\t];cr.\r\n\t\tself assign: #code to: [self concat: #('\"abstract type \"' stName superName '\" end\"')];cr.\r\n\t\tself comment: 'println(code)'.\r\n\t\tself call: #eval with: [self call: 'Meta.parse' with: #code];cr.\r\n\t];cr.\r\n\tself try: [\r\n\t\tself call: #eval with: [self call: 'Meta.parse' with: #s8Name];cr.\r\n\t\tself comment: 'println(\"FOUND \" ,s8Name)'\r\n\t] catch: [\r\n\t\tself assign: #code to: [self concat: #('\"mutable struct \"' s8Name '\" <: \"' stName)];cr.\r\n\t\tself assign: #code to: [self concat: #(code '\"\\n\tdict::Dict{String,Any}\"')];cr.\r\n\t\tself assign: #code to: [self concat: #(code '\"\\nend\"')];cr.\r\n\t\tself comment: 'println(code)'.\r\n\t\tself call: #eval with: [self call: 'Meta.parse' with: #code];cr.\r\n\t];cr.\r\n\tself return: [self call: #eval with: [self call: 'Meta.parse' with: #s8Name]] ","function(self)\r\n(self):comment_(\"println(\\\"createType \\\",aName,\\\"<:\\\",superName)\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"stName\",(function()\r\nreturn ((self):concat_((smalltalk.Array):with_with_(\"\\\"St\\\"\",(function()\r\nreturn ((self):call_with_(\"String\",\"aName\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"s8Name\",(function()\r\nreturn ((self):concat_((smalltalk.Array):with_with_(\"\\\"S8\\\"\",(function()\r\nreturn ((self):call_with_(\"String\",\"aName\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):try_catch_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"eval\",(function()\r\nreturn ((self):call_with_(\"Meta.parse\",\"stName\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):comment_(\"println(\\\"FOUND \\\" ,stName)\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_gt_((function()\r\nreturn ((self):call_with_(\"length\",\"superName\"))\r\nend),\"0\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"superName\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"\\\" <: St\\\"\", \"superName\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"code\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"\\\"abstract type \\\"\", \"stName\", \"superName\", \"\\\" end\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"println(code)\");return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"eval\",(function()\r\nreturn ((self):call_with_(\"Meta.parse\",\"code\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):try_catch_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"eval\",(function()\r\nreturn ((self):call_with_(\"Meta.parse\",\"s8Name\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):comment_(\"println(\\\"FOUND \\\" ,s8Name)\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"code\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"\\\"mutable struct \\\"\", \"s8Name\", \"\\\" <: \\\"\", \"stName\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"code\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"code\", \"\\\"\\\\n\\tdict::Dict{String,Any}\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"code\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"code\", \"\\\"\\\\nend\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"println(code)\");return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"eval\",(function()\r\nreturn ((self):call_with_(\"Meta.parse\",\"code\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"eval\",(function()\r\nreturn ((self):call_with_(\"Meta.parse\",\"s8Name\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"mapClassNameStSystemDictionary",0
,function(self)
(self):comment_("println(\"mapClassName \",className ) #,\" <: \",superclass)");
(
function(_s8_rec)
	(_s8_rec):assign_to_("mcName",(function()
return ((self):symbol_((function()
return ((self):concat_(smalltalk:newArray({"className", "\"_class\""})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("mcDict",(function()
return ((self):anyDict_object_("String",smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((("\"\\$klassName\""):_minus_gt((function()
return ((self):call_with_("string","mcName"))
end))),("\"\\$className\""):_minus_gt((function()
return ((self):call_with_("string",(function()
return ((self):concat_(smalltalk:newArray({"className", "\" class\""})))
end)))
end)))),("\"\\$klass\""):_minus_gt("self[\"Metaclass\"]"))),("\"@subclasses\""):_minus_gt("nil"))),("\"\\$methods\""):_minus_gt((function()
return ((self):call_("Dict{String,Any}"))
end)))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):send_with_("isNil:","superclass"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("superCls","\"\"");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("mcDict[\"\\$superclass\"]","StClass");
	return ((_s8_rec):cr())
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):assign_to_("mcDict[\"\\$constructor\"]","S8Object_class");
	return ((_s8_rec):cr())
end
)(self))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("superclass[\"@subclasses\"]","nil");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("superCls",(function()
return ((self):send_withArguments_("basic:at:",smalltalk:newArray({"superclass", "\"\\$className\""})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("smc",(function()
return ((self):send_with_("classOf:","superclass"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("mcDict[\"\\$superclass\"]","smc");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("superMc",(function()
return ((self):send_withArguments_("basic:at:",smalltalk:newArray({"smc", "\"\\$klassName\""})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("mcType",(function()
return ((self):send_withArguments_("createType",smalltalk:newArray({"mcName", "superMc"})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("mcDict[\"\\$constructor\"]","mcType"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("mClass",(function()
return ((self):call_with_("S8Metaclass","mcDict"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("clsName",(function()
return ((self):symbol_("className"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("clsType",(function()
return ((self):send_withArguments_("createType",smalltalk:newArray({"clsName", "superCls"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("clsDict",(function()
return ((self):anyDict_object_("String",smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((("\"\\$klass\""):_minus_gt("mClass")),("\"\\$constructor\""):_minus_gt("clsType"))),("\"\\$className\""):_minus_gt((function()
return ((self):call_with_("string","clsName"))
end)))),("\"\\$category\""):_minus_gt("category"))),("\"\\$superclass\""):_minus_gt("superclass"))),("\"@subclasses\""):_minus_gt("nil"))),("\"\\$comment\""):_minus_gt("nil"))),("\"\\$methods\""):_minus_gt((function()
return ((self):call_("Dict{String,Any}"))
end)))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("notNil:","native"))
end),(function()
return ((self):assign_to_("clsDict[\"\\$native\"]","native"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("cls",(function()
return ((self):call_withArguments_("Base.invokelatest",smalltalk:newArray({"basicNewInstance_", "mClass", "clsDict"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("mClass[\"@instanceClass\"]","cls");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("cls[\"@instanceClass\"]","cls");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self.dict[string(clsName)]","cls");
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("println(\"Class created \",string(clsName))");
(self):return_("cls");
return (self);
end
,"api","mapClassNameStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'println(\"mapClassName \",className ) #,\" <: \",superclass)'.\r\n\tself assign: #mcName to: [self symbol: [self concat: #(className '\"_class\"')]];cr.\r\n\tself assign: #mcDict to: [self anyDict: #String object:\r\n\t\t'\"\\$klassName\"' -> [self call: #string with: #mcName]\r\n\t\t,('\"\\$className\"' -> [self call: #string with: [self concat: #(className '\" class\"')]])\r\n\t\t,('\"\\$klass\"' -> 'self[\"Metaclass\"]')\r\n\t\t,('\"@subclasses\"' -> #nil)\r\n\t\t,('\"\\$methods\"' -> [self call: 'Dict{String,Any}'])\r\n\t];cr.\r\n\tself if: [self send: #isNil: with: #superclass] do: [\r\n\t\tself assign: #superCls to: '\"\"';cr.\r\n\t\tself assign: 'mcDict[\"\\$superclass\"]' to: #StClass;cr.\r\n\t\tself assign: 'mcDict[\"\\$constructor\"]' to: #S8Object_class;cr.\r\n\t] else: [\r\n\t\tself assign: 'superclass[\"@subclasses\"]' to: #nil;cr.\r\n\t\tself assign: #superCls to: [self send: #basic:at: withArguments: #(superclass '\"\\$className\"')];cr.\r\n\t\tself assign: #smc to: [self send: #classOf: with: #superclass];cr.\r\n\t\tself assign: 'mcDict[\"\\$superclass\"]' to: #smc;cr.\r\n\t\tself assign: #superMc to: [self send: #basic:at: withArguments: #(smc '\"\\$klassName\"')];cr.\r\n\t\tself assign: #mcType to: [self send: #createType withArguments: #(mcName superMc)];cr.\r\n\t\tself assign: 'mcDict[\"\\$constructor\"]' to: #mcType\r\n\t];cr.\r\n\tself assign: #mClass to: [self call: #S8Metaclass with: #mcDict];cr.\r\n\tself assign: #clsName to: [self symbol: #className];cr.\r\n\tself assign: #clsType to: [self send: #createType withArguments: #(clsName superCls)];cr.\r\n\tself assign: #clsDict to: [self anyDict: #String object:\r\n\t\t'\"\\$klass\"' -> #mClass\r\n\t\t,('\"\\$constructor\"' -> #clsType)\r\n\t\t,('\"\\$className\"' -> [self call: #string with: #clsName])\r\n\t\t,('\"\\$category\"' -> #category)\r\n\t\t,('\"\\$superclass\"' -> #superclass)\r\n\t\t,('\"@subclasses\"' -> #nil)\r\n\t\t,('\"\\$comment\"' -> #nil)\r\n\t\t,('\"\\$methods\"' -> [self call: 'Dict{String,Any}'])\r\n\t];cr.\r\n\tself if: [self send: #notNil: with: #native] do: [\r\n\t\tself assign: 'clsDict[\"\\$native\"]' to: #native\r\n\t];cr.\r\n\tself assign: #cls to: [self call: 'Base.invokelatest' withArguments: #(basicNewInstance_ mClass clsDict)];cr.\r\n\tself assign: 'mClass[\"@instanceClass\"]' to: #cls;cr.\r\n\tself assign: 'cls[\"@instanceClass\"]' to: #cls;cr.\r\n\tself assign: 'self.dict[string(clsName)]' to: #cls;cr.\r\n\tself comment: 'println(\"Class created \",string(clsName))'.\r\n\tself return: #cls ","function(self)\r\n(self):comment_(\"println(\\\"mapClassName \\\",className ) #,\\\" <: \\\",superclass)\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"mcName\",(function()\r\nreturn ((self):symbol_((function()\r\nreturn ((self):concat_(smalltalk:newArray({\"className\", \"\\\"_class\\\"\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"mcDict\",(function()\r\nreturn ((self):anyDict_object_(\"String\",smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((\"\\\"\\\\$klassName\\\"\"):_minus_gt((function()\r\nreturn ((self):call_with_(\"string\",\"mcName\"))\r\nend))),(\"\\\"\\\\$className\\\"\"):_minus_gt((function()\r\nreturn ((self):call_with_(\"string\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"className\", \"\\\" class\\\"\"})))\r\nend)))\r\nend)))),(\"\\\"\\\\$klass\\\"\"):_minus_gt(\"self[\\\"Metaclass\\\"]\"))),(\"\\\"@subclasses\\\"\"):_minus_gt(\"nil\"))),(\"\\\"\\\\$methods\\\"\"):_minus_gt((function()\r\nreturn ((self):call_(\"Dict{String,Any}\"))\r\nend)))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"superclass\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"superCls\",\"\\\"\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"mcDict[\\\"\\\\$superclass\\\"]\",\"StClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"mcDict[\\\"\\\\$constructor\\\"]\",\"S8Object_class\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"superclass[\\\"@subclasses\\\"]\",\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"superCls\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:\",smalltalk:newArray({\"superclass\", \"\\\"\\\\$className\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"smc\",(function()\r\nreturn ((self):send_with_(\"classOf:\",\"superclass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"mcDict[\\\"\\\\$superclass\\\"]\",\"smc\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"superMc\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:\",smalltalk:newArray({\"smc\", \"\\\"\\\\$klassName\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"mcType\",(function()\r\nreturn ((self):send_withArguments_(\"createType\",smalltalk:newArray({\"mcName\", \"superMc\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"mcDict[\\\"\\\\$constructor\\\"]\",\"mcType\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"mClass\",(function()\r\nreturn ((self):call_with_(\"S8Metaclass\",\"mcDict\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"clsName\",(function()\r\nreturn ((self):symbol_(\"className\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"clsType\",(function()\r\nreturn ((self):send_withArguments_(\"createType\",smalltalk:newArray({\"clsName\", \"superCls\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"clsDict\",(function()\r\nreturn ((self):anyDict_object_(\"String\",smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((\"\\\"\\\\$klass\\\"\"):_minus_gt(\"mClass\")),(\"\\\"\\\\$constructor\\\"\"):_minus_gt(\"clsType\"))),(\"\\\"\\\\$className\\\"\"):_minus_gt((function()\r\nreturn ((self):call_with_(\"string\",\"clsName\"))\r\nend)))),(\"\\\"\\\\$category\\\"\"):_minus_gt(\"category\"))),(\"\\\"\\\\$superclass\\\"\"):_minus_gt(\"superclass\"))),(\"\\\"@subclasses\\\"\"):_minus_gt(\"nil\"))),(\"\\\"\\\\$comment\\\"\"):_minus_gt(\"nil\"))),(\"\\\"\\\\$methods\\\"\"):_minus_gt((function()\r\nreturn ((self):call_(\"Dict{String,Any}\"))\r\nend)))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"native\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"clsDict[\\\"\\\\$native\\\"]\",\"native\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"cls\",(function()\r\nreturn ((self):call_withArguments_(\"Base.invokelatest\",smalltalk:newArray({\"basicNewInstance_\", \"mClass\", \"clsDict\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"mClass[\\\"@instanceClass\\\"]\",\"cls\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"cls[\\\"@instanceClass\\\"]\",\"cls\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self.dict[string(clsName)]\",\"cls\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"println(\\\"Class created \\\",string(clsName))\");\r\n(self):return_(\"cls\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"setVarNamesStSystemDictionary",0
,function(self)
(self):comment_("println(\"setVarNames \",iVarNames)");
(
function(_s8_rec)
	(_s8_rec):assign_to_("hArray",(function()
return ((self):send_withArguments_("handleOf:or:",smalltalk:newArray({"iVarNames", "[]"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("basic:at:put:",(smalltalk.Array):with_with_with_("aClass","\"\\$iVarNames\"",(function()
return ((self):send_with_("newArray","hArray"))
end)));
	return ((_s8_rec):cr())
end
)(self);
(self):for_in_do_("iv","hArray",(function()
return ((self):send_withArguments_("basic:at:put:",(smalltalk.Array):with_with_with_("aClass",(function()
return ((self):concat_(smalltalk:newArray({"\"@\"", "iv"})))
end),"aValue")))
end));
return (self);
end
,"api","setVarNamesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'println(\"setVarNames \",iVarNames)'.\r\n\tself assign: #hArray to: [self send: #handleOf:or: withArguments: #(iVarNames '[]')];cr.\r\n\tself send: #basic:at:put: withArguments: (Array\r\n\t\twith: #aClass with: '\"\\$iVarNames\"'\r\n\t\twith: [self send: #newArray with: #hArray]);cr.\r\n\tself for: #iv in: #hArray do: [\r\n\t\tself send: #basic:at:put: withArguments: (Array\r\n\t\t\twith: #aClass\r\n\t\t\twith: [self concat: #('\"@\"' iv)]\r\n\t\t\twith: #aValue)\r\n\t] ","function(self)\r\n(self):comment_(\"println(\\\"setVarNames \\\",iVarNames)\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"hArray\",(function()\r\nreturn ((self):send_withArguments_(\"handleOf:or:\",smalltalk:newArray({\"iVarNames\", \"[]\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"basic:at:put:\",(smalltalk.Array):with_with_with_(\"aClass\",\"\\\"\\\\$iVarNames\\\"\",(function()\r\nreturn ((self):send_with_(\"newArray\",\"hArray\"))\r\nend)));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):for_in_do_(\"iv\",\"hArray\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:put:\",(smalltalk.Array):with_with_with_(\"aClass\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"\\\"@\\\"\", \"iv\"})))\r\nend),\"aValue\")))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"setClassStSystemDictionary",0
,function(self)
(self):send_("obsolete");
return (self);
end
,"api","setClassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #obsolete ","function(self)\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"fnInSpecStSystemDictionary",0
,function(self)
(self):send_("obsolete");
return (self);
end
,"api","fnInSpecStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #obsolete ","function(self)\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"nativeClassesStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("keys",(function()
return ((self):call_withArguments_("filter",(smalltalk.Array):with_with_((function()
return ((self):expr_dashgt_("k",(function()
return ((self):call_withArguments_("isa",smalltalk:newArray({"self[k]", "StBehavior"})))
end)))
end),(function()
return ((self):send_to_("Base.keys","self.dict"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):emptyArray())
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("k","keys",(function()
return ((self):send_to_with_("Base.push!","result","self[k]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"api","nativeClassesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #keys to: [self call: #filter withArguments: (Array\r\n\t\twith: [self expr: #k dashgt: [self call: #isa withArguments: #('self[k]' StBehavior)]]\r\n\t\twith: [self send: 'Base.keys' to: 'self.dict'])\r\n\t];cr.\r\n\tself assign: #result to: [self emptyArray];cr.\r\n\tself for: #k in: #keys do: [\r\n\t\tself send: 'Base.push!' to: #result with: 'self[k]'\r\n\t];cr.\r\n\tself return: #result ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"keys\",(function()\r\nreturn ((self):call_withArguments_(\"filter\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):expr_dashgt_(\"k\",(function()\r\nreturn ((self):call_withArguments_(\"isa\",smalltalk:newArray({\"self[k]\", \"StBehavior\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_to_(\"Base.keys\",\"self.dict\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):emptyArray())\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"k\",\"keys\",(function()\r\nreturn ((self):send_to_with_(\"Base.push!\",\"result\",\"self[k]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"classesStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("newArray",(function()
return ((self):send_("nativeClasses"))
end)))
end));
return (self);
end
,"api","classesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #newArray with: [self send: #nativeClasses]] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"newArray\",(function()\r\nreturn ((self):send_(\"nativeClasses\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"computeSubclassesStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("all",(function()
return ((self):send_with_("handleOf",(function()
return ((self):send_("classes"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("aClass","all",(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"@subclasses\"]",(function()
return ((self):send_with_("newArray",(function()
return ((self):emptyArray())
end)))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("class(aClass)[\"@subclasses\"]",(function()
return ((self):send_with_("newArray",(function()
return ((self):emptyArray())
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):for_in_do_("aClass","all",(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("parent","aClass[\"\\$superclass\"]");
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):send_with_("notNil:","parent"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):send_to_with_("add:","parent[\"@subclasses\"]","aClass");
	return ((_s8_rec):cr())
end
)(self);return ((self):send_to_with_("add:","class(parent)[\"@subclasses\"]",(function()
return ((self):call_with_("class","aClass"))
end)))
end)))
end));
return (self);
end
,"api","computeSubclassesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #all to: [self send: #handleOf with: [self send: #classes]];cr.\r\n\tself for: #aClass in: #all do: [\r\n\t\tself assign: 'aClass[\"@subclasses\"]' to: [self send: #newArray with: [self emptyArray]];cr.\r\n\t\tself assign: 'class(aClass)[\"@subclasses\"]' to: [self send: #newArray with: [self emptyArray]]\r\n\t];cr.\r\n\tself for: #aClass in: #all do: [\r\n\t\tself assign: #parent to: 'aClass[\"\\$superclass\"]';cr.\r\n\t\tself if: [self send: #notNil: with: #parent] do: [\r\n\t\t\tself send: #add: to: 'parent[\"@subclasses\"]' with: #aClass;cr.\r\n\t\t\tself send: #add: to: 'class(parent)[\"@subclasses\"]' with: [self call: #class with: #aClass]\r\n\t\t]\r\n\t] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"all\",(function()\r\nreturn ((self):send_with_(\"handleOf\",(function()\r\nreturn ((self):send_(\"classes\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"aClass\",\"all\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"@subclasses\\\"]\",(function()\r\nreturn ((self):send_with_(\"newArray\",(function()\r\nreturn ((self):emptyArray())\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"class(aClass)[\\\"@subclasses\\\"]\",(function()\r\nreturn ((self):send_with_(\"newArray\",(function()\r\nreturn ((self):emptyArray())\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):for_in_do_(\"aClass\",\"all\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"parent\",\"aClass[\\\"\\\\$superclass\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"parent\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_with_(\"add:\",\"parent[\\\"@subclasses\\\"]\",\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_to_with_(\"add:\",\"class(parent)[\\\"@subclasses\\\"]\",(function()\r\nreturn ((self):call_with_(\"class\",\"aClass\"))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"subclassesStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("result","aClass[\"@subclasses\"]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("isNil:","result"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):send_("computeSubclasses");
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("aClass[\"@subclasses\"]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"api","subclassesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #result to: 'aClass[\"@subclasses\"]';cr.\r\n\tself if: [self send: #isNil: with: #result] do: [\r\n\t\tself send: #computeSubclasses;cr.\r\n\t\tself return: 'aClass[\"@subclasses\"]'\r\n\t];cr.\r\n\tself return: #result ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",\"aClass[\\\"@subclasses\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"result\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_(\"computeSubclasses\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"aClass[\\\"@subclasses\\\"]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"allSubclassesDoStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_to_with_("do:",(function()
return ((self):send_to_("subclasses","aClass"))
end),(function()
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"cls"}),(function()
(
function(_s8_rec)
	(_s8_rec):send_to_with_("evaluateWith:","aBlock","cls");
	return ((_s8_rec):cr())
end
)(self);return ((self):send_withArguments_("allSubclassesDo",smalltalk:newArray({"cls", "aBlock"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("self");
return (self);
end
,"api","allSubclassesDoStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself\tsend: #do:\r\n\t\tto: [self send: #subclasses to: #aClass]\r\n\t\twith: [self implementFunction: '' arguments: #(cls) doing: [\r\n\t\t\tself send: #evaluateWith: to: #aBlock with: #cls;cr.\r\n\t\t\tself send: #allSubclassesDo withArguments: #(cls aBlock)\r\n\t\t]];cr.\r\n\tself return: #self ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_with_(\"do:\",(function()\r\nreturn ((self):send_to_(\"subclasses\",\"aClass\"))\r\nend),(function()\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"cls\"}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_with_(\"evaluateWith:\",\"aBlock\",\"cls\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_withArguments_(\"allSubclassesDo\",smalltalk:newArray({\"cls\", \"aBlock\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"bindRootsStSystemDictionary",0
,function(self)
(self):comment_("Private - Link the system roots to ensure proper delegation chains");
(self):send_with_("invalidMessage:","\"bindRoots\"");
return (self);
end
,"api","bindRootsStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Private - Link the system roots to ensure proper delegation chains'.\r\n\tself send: #invalidMessage: with: '\"bindRoots\"' ","function(self)\r\n(self):comment_(\"Private - Link the system roots to ensure proper delegation chains\");\r\n(self):send_with_(\"invalidMessage:\",\"\\\"bindRoots\\\"\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"isArray_equalTo_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):expr_eqeq_("table1","table2"))
end),(function()
return ((self):return_("true"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):expr_eqeq_((function()
return ((self):send_withArguments_("handleOf:or:",smalltalk:newArray({"table1", "1"})))
end),(function()
return ((self):send_withArguments_("handleOf:or:",smalltalk:newArray({"table2", "2"})))
end)))
end));
return (self);
end
,"api","isArray_equalTo_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self expr: #table1 eqeq: #table2] and: [self return: #true];cr.\r\n\tself return: [self\r\n\t\texpr: [self send: #handleOf:or: withArguments: #(table1 #1)]\r\n\t\teqeq: [self send: #handleOf:or: withArguments: #(table2 #2)]] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):expr_eqeq_(\"table1\",\"table2\"))\r\nend),(function()\r\nreturn ((self):return_(\"true\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):send_withArguments_(\"handleOf:or:\",smalltalk:newArray({\"table1\", \"1\"})))\r\nend),(function()\r\nreturn ((self):send_withArguments_(\"handleOf:or:\",smalltalk:newArray({\"table2\", \"2\"})))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"object_or_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_with_("isNil:","receiver"))
end),(function()
return ((self):return_("option"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):expr_eqeqeq_("receiver","false"))
end),(function()
return ((self):return_("option"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("receiver");
return (self);
end
,"api","object_or_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self send: #isNil: with: #receiver] and: [self return: #option];cr.\r\n\tself expr: [self expr: #receiver eqeqeq: #false] and: [self return: #option];cr.\r\n\tself return: #receiver ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"receiver\"))\r\nend),(function()\r\nreturn ((self):return_(\"option\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):expr_eqeqeq_(\"receiver\",\"false\"))\r\nend),(function()\r\nreturn ((self):return_(\"option\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"receiver\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"isObject_equalTo_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):expr_eqeqeq_("receiver","anObject"))
end),(function()
return ((self):return_("true"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("h1 = handleOf(self,receiver)");
(self):comment_("h2 = handleOf(self,anObject)");
(self):comment_("notNil_(self,h1) && return h1==h2");
(self):comment_("notNil_(self,h2) && return h1==h2");
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_withArguments_("responds:to:",smalltalk:newArray({"receiver", "\"=\""})))
end),(function()
return ((self):return_((function()
return ((self):send_to_with_("=","receiver","anObject"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_withArguments_("responds:to:",smalltalk:newArray({"anObject", "\"=\""})))
end),(function()
return ((self):return_((function()
return ((self):send_to_with_("=","anObject","receiver"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("false");
return (self);
end
,"api","isObject_equalTo_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self\r\n\t\texpr: #receiver eqeqeq: #anObject]\r\n\t\tand: [self return: #true];cr.\r\n\tself comment: 'h1 = handleOf(self,receiver)'.\r\n\tself comment: 'h2 = handleOf(self,anObject)'.\r\n\tself comment: 'notNil_(self,h1) && return h1==h2'.\r\n\tself comment: 'notNil_(self,h2) && return h1==h2'.\r\n\tself expr: [\r\n\t\tself send: #responds:to: withArguments: #(receiver '\"=\"')]\r\n\t\tand: [self return: [self send: #= to: #receiver with: #anObject]];cr.\r\n\tself expr: [\r\n\t\tself send: #responds:to: withArguments: #(anObject '\"=\"')]\r\n\t\tand: [self return: [self send: #= to: #anObject with: #receiver]];cr.\r\n\tself return: #false ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):expr_eqeqeq_(\"receiver\",\"anObject\"))\r\nend),(function()\r\nreturn ((self):return_(\"true\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"h1 = handleOf(self,receiver)\");\r\n(self):comment_(\"h2 = handleOf(self,anObject)\");\r\n(self):comment_(\"notNil_(self,h1) && return h1==h2\");\r\n(self):comment_(\"notNil_(self,h2) && return h1==h2\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_withArguments_(\"responds:to:\",smalltalk:newArray({\"receiver\", \"\\\"=\\\"\"})))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_with_(\"=\",\"receiver\",\"anObject\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_withArguments_(\"responds:to:\",smalltalk:newArray({\"anObject\", \"\\\"=\\\"\"})))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_with_(\"=\",\"anObject\",\"receiver\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"false\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"object_comma_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("h1",(function()
return ((self):send_with_("handleOf","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_eqeq_((function()
return ((self):call_with_("typeof","h1"))
end),"String"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_with_("isNil:","anObject"))
end),(function()
return ((self):return_("receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("h2",(function()
return ((self):send_with_("handleOf","anObject"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeq_((function()
return ((self):call_with_("typeof","h2"))
end),"String"))
end),(function()
return ((self):concat_(smalltalk:newArray({"h1", "h2"})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):call_withArguments_("isa",smalltalk:newArray({"anObject", "StObject"})))
end),(function()
return ((self):concat_((smalltalk.Array):with_with_("h1",(function()
return ((self):send_with_("handleOf",(function()
return ((self):send_with_("to_String","anObject"))
end)))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_((function()
return ((self):concat_((smalltalk.Array):with_with_("h1",(function()
return ((self):call_with_("string","h2"))
end))))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_to_with_("isa","receiver","StObject"))
end),(function()
return ((self):return_((function()
return ((self):send_to_with_(",","receiver","anObject"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_withArguments_("object:comma:",(smalltalk.Array):with_with_((function()
return ((self):call_with_("string","h1"))
end),"anObject")))
end));
return (self);
end
,"api","object_comma_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #h1 to:[self send: #handleOf with: #receiver];cr.\r\n\tself if: [self expr: [self call: #typeof with: #h1] eqeq: #String] do: [\r\n\t\tself expr: [self send: #isNil: with: #anObject] and: [self return: #receiver];cr.\r\n\t\tself assign: #h2 to: [self send: #handleOf with: #anObject];cr.\r\n\t\tself if: [self expr: [self call: #typeof with: #h2] eqeq: #String]\r\n\t\t\treturn: [self concat: #(h1 h2)];cr.\r\n\t\tself if: [self call: #isa withArguments: #(anObject StObject)]\r\n\t\t\treturn: [self concat: (Array with: #h1\r\n\t\t\t\twith: [self send: #handleOf with: [self\r\n\t\t\t\t\tsend: #to_String with: #anObject]])];cr.\r\n\t\tself return: [self concat: (Array with: #h1 with: [self call: #string with: #h2])]\r\n\t];cr.\r\n\tself expr: [\r\n\t\tself send: #isa to: #receiver with: #StObject]\r\n\t\tand: [self return: [self send: #, to: #receiver with: #anObject]];cr.\r\n\tself return: [self send: #object:comma: withArguments: (Array\r\n\t\twith: [self call: #string with: #h1]\r\n\t\twith: #anObject)] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h1\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):call_with_(\"typeof\",\"h1\"))\r\nend),\"String\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"anObject\"))\r\nend),(function()\r\nreturn ((self):return_(\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h2\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"anObject\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):call_with_(\"typeof\",\"h2\"))\r\nend),\"String\"))\r\nend),(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"h1\", \"h2\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):call_withArguments_(\"isa\",smalltalk:newArray({\"anObject\", \"StObject\"})))\r\nend),(function()\r\nreturn ((self):concat_((smalltalk.Array):with_with_(\"h1\",(function()\r\nreturn ((self):send_with_(\"handleOf\",(function()\r\nreturn ((self):send_with_(\"to_String\",\"anObject\"))\r\nend)))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_((function()\r\nreturn ((self):concat_((smalltalk.Array):with_with_(\"h1\",(function()\r\nreturn ((self):call_with_(\"string\",\"h2\"))\r\nend))))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_to_with_(\"isa\",\"receiver\",\"StObject\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_with_(\",\",\"receiver\",\"anObject\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"object:comma:\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):call_with_(\"string\",\"h1\"))\r\nend),\"anObject\")))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"boolean_and_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):expr_noteq_("receiver","true"))
end),(function()
return ((self):return_("false"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):expr_eqeq_((function()
return ((self):call_with_("typeof","option"))
end),"Bool"))
end),(function()
return ((self):return_("option"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):expr_eqeq_((function()
return ((self):send_to_("evaluate","option"))
end),"true"))
end));
return (self);
end
,"api","boolean_and_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self expr: #receiver noteq: #true] and: [self return: #false];cr.\r\n\tself expr: [self expr: [self call: #typeof with: #option] eqeq: #Bool] and: [self return: #option];cr.\r\n\tself return: [self expr: [self send: #evaluate to: #option] eqeq: #true] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):expr_noteq_(\"receiver\",\"true\"))\r\nend),(function()\r\nreturn ((self):return_(\"false\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):call_with_(\"typeof\",\"option\"))\r\nend),\"Bool\"))\r\nend),(function()\r\nreturn ((self):return_(\"option\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):send_to_(\"evaluate\",\"option\"))\r\nend),\"true\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"boolean_or_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):expr_eqeq_("receiver","true"))
end),(function()
return ((self):return_("true"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):expr_eqeq_((function()
return ((self):call_with_("typeof","option"))
end),"Bool"))
end),(function()
return ((self):return_("option"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):expr_eqeq_((function()
return ((self):send_to_("evaluate","option"))
end),"true"))
end));
return (self);
end
,"api","boolean_or_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self expr: #receiver eqeq: #true] and: [self return: #true];cr.\r\n\tself expr: [self expr: [self call: #typeof with: #option] eqeq: #Bool]\r\n\t\tand: [self return: #option];cr.\r\n\tself return: [self expr: [self send: #evaluate to: #option] eqeq: #true] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):expr_eqeq_(\"receiver\",\"true\"))\r\nend),(function()\r\nreturn ((self):return_(\"true\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):call_with_(\"typeof\",\"option\"))\r\nend),\"Bool\"))\r\nend),(function()\r\nreturn ((self):return_(\"option\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):send_to_(\"evaluate\",\"option\"))\r\nend),\"true\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"booleanNot_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):expr_eqeq_("receiver","true"))
end),(function()
return ((self):return_("false"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):expr_eqeq_("receiver","false"))
end),(function()
return ((self):return_("true"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_("not","receiver"))
end));
return (self);
end
,"api","booleanNot_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self expr: #receiver eqeq: #true] and: [self return: #false];cr.\r\n\tself expr: [self expr: #receiver eqeq: #false] and: [self return: #true];cr.\r\n\tself return: [self send: #not to: #receiver] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):expr_eqeq_(\"receiver\",\"true\"))\r\nend),(function()\r\nreturn ((self):return_(\"false\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):expr_eqeq_(\"receiver\",\"false\"))\r\nend),(function()\r\nreturn ((self):return_(\"true\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_(\"not\",\"receiver\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"asCharacter_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_to_with_("isa","receiver","Number"))
end),(function()
return ((self):return_((function()
return ((self):call_with_("string",(function()
return ((self):call_with_("Char","receiver"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_("asCharacter","receiver"))
end));
return (self);
end
,"api","asCharacter_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self send: #isa to: #receiver with: #Number]\r\n\t\tand: [self return: [self call: #string with: [self call: #Char with: #receiver]]];cr.\r\n\tself return: [self send: #asCharacter to: #receiver] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_to_with_(\"isa\",\"receiver\",\"Number\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):call_with_(\"string\",(function()\r\nreturn ((self):call_with_(\"Char\",\"receiver\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_(\"asCharacter\",\"receiver\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"to_StringStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_to_with_("isa","receiver","Bool"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):expr_and_("receiver",(function()
return ((self):return_("\"true\""))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("\"false\""))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_with_("isNil:","receiver"))
end),(function()
return ((self):return_("\"nil\""))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_to_with_("isa","receiver","StObject"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_with_("isNil:",(function()
return ((self):send_to_("klass","receiver"))
end)))
end),(function()
return ((self):return_((function()
return ((self):concat_((smalltalk.Array):with_with_with_("\"StObject(\"",(function()
return ((self):call_with_("string","receiver.dict"))
end),"\")\"")))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_((function()
return ((self):send_to_("toString","receiver"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_with_("toString:","smalltalk.Object","receiver"))
end));
return (self);
end
,"api","to_StringStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self send: #isa to: #receiver with: #Bool] do: [\r\n\t\tself expr: #receiver and: [self return: '\"true\"'];cr.\r\n\t\tself return: '\"false\"'\r\n\t];cr.\r\n\tself expr: [self send: #isNil: with: #receiver] and: [self return: '\"nil\"'];cr.\r\n\tself if: [self send: #isa to: #receiver with: #StObject] do: [\r\n\t\tself expr: [self send: #isNil: with: [self send: #klass to: #receiver]]\r\n\t\t\tand: [self return: [self concat: (Array\r\n\t\t\t\twith: '\"StObject(\"'\r\n\t\t\t\twith: [self call: #string with: 'receiver.dict']\r\n\t\t\t\twith: '\")\"')]];cr.\r\n\t\tself return: [self send: #toString to: #receiver]\r\n\t];cr.\r\n\tself return: [self send: #toString: to: 'smalltalk.Object' with: #receiver] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_to_with_(\"isa\",\"receiver\",\"Bool\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_(\"receiver\",(function()\r\nreturn ((self):return_(\"\\\"true\\\"\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"\\\"false\\\"\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"receiver\"))\r\nend),(function()\r\nreturn ((self):return_(\"\\\"nil\\\"\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_to_with_(\"isa\",\"receiver\",\"StObject\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_with_(\"isNil:\",(function()\r\nreturn ((self):send_to_(\"klass\",\"receiver\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):concat_((smalltalk.Array):with_with_with_(\"\\\"StObject(\\\"\",(function()\r\nreturn ((self):call_with_(\"string\",\"receiver.dict\"))\r\nend),\"\\\")\\\"\")))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_((function()\r\nreturn ((self):send_to_(\"toString\",\"receiver\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"toString:\",\"smalltalk.Object\",\"receiver\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"printString_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_withArguments_("responds:to:",smalltalk:newArray({"receiver", "\"printString\""})))
end),(function()
return ((self):return_((function()
return ((self):send_to_("printString","receiver"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_with_("string","receiver"))
end));
return (self);
end
,"api","printString_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self send: #responds:to: withArguments: #(receiver '\"printString\"')]\r\n\t\tand: [self return: [self send: #printString to: #receiver]];cr.\r\n\tself return: [self call: #string with: #receiver] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_withArguments_(\"responds:to:\",smalltalk:newArray({\"receiver\", \"\\\"printString\\\"\"})))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_(\"printString\",\"receiver\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"string\",\"receiver\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"asString_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_withArguments_("responds:to:",smalltalk:newArray({"receiver", "\"asString\""})))
end),(function()
return ((self):return_((function()
return ((self):send_to_("asString","receiver"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_with_("string","receiver"))
end));
return (self);
end
,"api","asString_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self send: #responds:to: withArguments: #(receiver '\"asString\"')]\r\n\t\tand: [self return: [self send: #asString to: #receiver]];cr.\r\n\tself return: [self call: #string with: #receiver] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_withArguments_(\"responds:to:\",smalltalk:newArray({\"receiver\", \"\\\"asString\\\"\"})))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_(\"asString\",\"receiver\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"string\",\"receiver\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"mustBeNumber_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_to_with_("isa","receiver","Number"))
end),(function()
return ((self):return_("receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_("mustBeNumber","receiver"))
end));
return (self);
end
,"api","mustBeNumber_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self send: #isa to: #receiver with: #Number]\r\n\t\tand: [self return: #receiver];cr.\r\n\tself return: [self send: #mustBeNumber to: #receiver] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_to_with_(\"isa\",\"receiver\",\"Number\"))\r\nend),(function()\r\nreturn ((self):return_(\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_(\"mustBeNumber\",\"receiver\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"math_max_StSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_("niy"))
end));
return (self);
end
,"api","math_max_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #niy] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_(\"niy\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"math_min_StSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_("niy"))
end));
return (self);
end
,"api","math_min_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #niy] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_(\"niy\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"addClassStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("debugAddClass",smalltalk:newArray({"className", "superclass", "iVarNames", "category"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass",(function()
return ((self):send_withArguments_("basic:at:or:",smalltalk:newArray({"self", "className", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("parent",(function()
return ((self):send_withArguments_("basic:at:or:",smalltalk:newArray({"aClass", "\"\\$superclass\"", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("isNil:","parent"))
end),(function()
return ((self):assign_to_("parent","nil"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("isNil:","iVarNames"))
end),(function()
return ((self):assign_to_("iVarNames",(function()
return ((self):emptyArray())
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):send_with_("notNil:","aClass"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_eqeq_("superclass","parent"))
end),(function()
return ((self):if_do_((function()
return ((self):send_withArguments_("isArray:equalTo:",(smalltalk.Array):with_with_((function()
return ((self):send_withArguments_("basic:at:or:",(smalltalk.Array):with_with_with_("aClass","\"\\$iVarNames\"",(function()
return ((self):emptyArray())
end))))
end),"iVarNames")))
end),(function()
return ((self):if_return_((function()
return ((self):expr_eqeq_("category",(function()
return ((self):send_withArguments_("basic:at:",smalltalk:newArray({"aClass", "\"\\$category\""})))
end)))
end),"aClass"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("sameShape","false");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_withArguments_("aboutToChangeClass",smalltalk:newArray({"aClass", "superclass", "iVarNames", "category"}));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_noteqeq_("parent","superclass"))
end),(function()
(self):comment_("move in hierarchy");(self):comment_("disconnect from parent");(
function(_s8_rec)
	(_s8_rec):send_withArguments_("basic:at:put:",smalltalk:newArray({"parent", "\"@subclasses\"", "nil"}));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_withArguments_("basic:at:put:",(smalltalk.Array):with_with_with_((function()
return ((self):call_with_("class","parent"))
end),"\"@subclasses\"","nil"));
	return ((_s8_rec):cr())
end
)(self);(self):comment_("link to new parent");(
function(_s8_rec)
	(_s8_rec):send_withArguments_("basic:at:put:",smalltalk:newArray({"aClass", "\"\\$superclass\"", "superclass"}));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("aMeta",(function()
return ((self):call_with_("class","aClass"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_and_((function()
return ((self):send_with_("notNil:","aMeta"))
end),(function()
return ((self):send_with_("notNil:","superclass"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("msuper",(function()
return ((self):send_withArguments_("basic:at:",smalltalk:newArray({"aMeta", "\"\\$superclass\""})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_withArguments_("basic_at_put_",smalltalk:newArray({"msuper", "\"@subclasses\"", "nil"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):send_withArguments_("basic_at_put_",(smalltalk.Array):with_with_with_("aMeta","\"\\$superclass\"",(function()
return ((self):call_with_("class","superclass"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);(self):comment_("add to subclasses of parent");(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("isNil:",(function()
return ((self):send_withArguments_("basic:at:or:",smalltalk:newArray({"superclass", "\"@subclasses\"", "nil"})))
end)))
end),(function()
return ((self):send_withArguments_("basic:at:put:",(smalltalk.Array):with_with_with_("superclass","\"@subclasses\"",(function()
return ((self):send_("newArray"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_to_with_("add:",(function()
return ((self):send_withArguments_("basic:at:",smalltalk:newArray({"superclass", "\"@subclasses\""})))
end),"aClass");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("isNil:",(function()
return ((self):send_withArguments_("basic:at:or:",(smalltalk.Array):with_with_with_((function()
return ((self):call_with_("class","superclass"))
end),"\"@subclasses\"","nil")))
end)))
end),(function()
return ((self):send_withArguments_("basic:at:put:",(smalltalk.Array):with_with_with_((function()
return ((self):call_with_("class","superclass"))
end),"\"@subclasses\"",(function()
return ((self):send_("newArray"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):send_to_with_("add:",(function()
return ((self):send_withArguments_("basic:at:",(smalltalk.Array):with_with_((function()
return ((self):call_with_("class","superclass"))
end),"\"@subclasses\"")))
end),(function()
return ((self):call_with_("class","aClass"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("isNil:","category"))
end),(function()
return ((self):assign_to_("category",(function()
return ((self):send_withArguments_("basic:at:or:",smalltalk:newArray({"aClass", "\"\\$category\"", "\"\""})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_withArguments_("basic:at:put:",smalltalk:newArray({"aClass", "\"\\$category\"", "category"}));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setVarNames",smalltalk:newArray({"aClass", "iVarNames", "nil"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):not_("sameShape"))
end),(function()
return ((self):send_with_("classShapeChanged","aClass"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("aboutToCreateClass",smalltalk:newArray({"className", "superclass", "iVarNames", "category"}));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"className", "category", "nil", "superclass"}));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass",(function()
return ((self):send_with_("basicAt:","className"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):send_withArguments_("setVarNames",smalltalk:newArray({"aClass", "iVarNames", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("classChanged","aClass");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("aClass");
return (self);
end
,"api","addClassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #debugAddClass withArguments: #(className superclass iVarNames category);cr.\r\n\tself assign: #aClass to: [self send: #basic:at:or: withArguments: #(self className #nil)];cr.\r\n\tself assign: #parent to: [self send: #basic:at:or: withArguments: #(aClass '\"\\$superclass\"' #nil)];cr.\r\n\tself if: [self send: #isNil: with: #parent] do: [\r\n\t\tself assign: #parent to: #nil\r\n\t];cr.\r\n\tself if: [self send: #isNil: with: #iVarNames] do: [\r\n\t\tself assign: #iVarNames to: [self emptyArray]\r\n\t];cr.\r\n\tself if: [self send: #notNil: with: #aClass] do: [\r\n\t\tself if: [self expr: #superclass eqeq: #parent] do: [\r\n\t\t\tself if: [self send: #isArray:equalTo: withArguments: (Array\r\n\t\t\t\twith: [self send: #basic:at:or:\r\n\t\t\t\t\twithArguments: (Array\r\n\t\t\t\t\t\twith: #aClass\r\n\t\t\t\t\t\twith: '\"\\$iVarNames\"'\r\n\t\t\t\t\t\twith: [self emptyArray])]\r\n\t\t\t\twith: #iVarNames)] do: [\r\n\t\t\t\tself if: [self expr: #category eqeq: [\r\n\t\t\t\t\tself send: #basic:at:\r\n\t\t\t\t\twithArguments: #(aClass '\"\\$category\"')]\r\n\t\t\t\t\t] return: #aClass\r\n\t\t\t]\r\n\t\t];cr.\r\n\tself assign: #sameShape to: #false;cr.\r\n\tself send: #aboutToChangeClass withArguments: #(aClass superclass iVarNames category);cr.\r\n\tself if: [self expr: #parent noteqeq: #superclass] do: [\r\n\t\tself comment: 'move in hierarchy'.\r\n\t\tself comment: 'disconnect from parent'.\r\n\t\tself send: #basic:at:put: withArguments: #(parent '\"@subclasses\"' #nil);cr.\r\n\t\tself send: #basic:at:put: withArguments: (Array\r\n\t\t\twith: [self call: #class with: #parent]\r\n\t\t\twith: '\"@subclasses\"' with: #nil);cr.\r\n\t\tself comment: 'link to new parent'.\r\n\t\tself send: #basic:at:put: withArguments: #(aClass '\"\\$superclass\"' superclass);cr.\r\n\t\tself assign: #aMeta to: [self call: #class with: #aClass];cr.\r\n\t\tself if: [self expr: [self send: #notNil: with: #aMeta]\r\n\t\t\tand: [self send: #notNil: with: #superclass]] do: [\r\n\t\t\tself assign: #msuper to: [self send: #basic:at:\r\n\t\t\t\twithArguments: #(aMeta '\"\\$superclass\"')];cr.\r\n\t\t\tself send: #basic_at_put_ withArguments: #(msuper '\"@subclasses\"' #nil);cr.\r\n\t\t\tself send: #basic_at_put_ withArguments: (Array\r\n\t\t\t\twith: #aMeta with: '\"\\$superclass\"'\r\n\t\t\t\twith: [self call: #class with: #superclass])\r\n\t\t];cr.\r\n\t\tself comment: 'add to subclasses of parent'.\r\n\t\tself if: [self send: #isNil: with: [self send: #basic:at:or:\r\n\t\t\twithArguments: #(superclass '\"@subclasses\"' #nil)]] do: [\r\n\t\t\t\tself send: #basic:at:put: withArguments: (Array\r\n\t\t\t\t\twith: #superclass with: '\"@subclasses\"'\r\n\t\t\t\t\twith: [self send: #newArray])\r\n\t\t];cr.\r\n\t\tself send: #add:\r\n\t\t\tto: [self send: #basic:at: withArguments: #(superclass '\"@subclasses\"')]\r\n\t\t\twith: #aClass;cr.\r\n\t\tself if: [self send:#isNil: with: [self send: #basic:at:or: withArguments: (Array\r\n\t\t\t\twith: [self call: #class with: #superclass]\r\n\t\t\t\twith: '\"@subclasses\"' with: #nil)\r\n\t\t\t]] do: [\r\n\t\t\tself send: #basic:at:put: withArguments: (Array\r\n\t\t\t\twith: [self call: #class with: #superclass]\r\n\t\t\t\twith: '\"@subclasses\"'\r\n\t\t\t\twith: [self send: #newArray])\r\n\t\t];cr.\r\n\t\tself send: #add: to: [self send: #basic:at: withArguments: (Array\r\n\t\t\t\twith: [self call: #class with: #superclass]\r\n\t\t\t\twith: '\"@subclasses\"')]\r\n\t\t\twith: [self call: #class with: #aClass]\r\n\t\t];cr.\r\n\t\tself if: [self send: #isNil: with: #category] do: [\r\n\t\t\tself assign: #category to: [self send: #basic:at:or:\r\n\t\t\t\twithArguments: #(aClass '\"\\$category\"' '\"\"')]\r\n\t\t];cr.\r\n\t\tself send: #basic:at:put: withArguments: #(aClass '\"\\$category\"' category);cr.\r\n\t\tself send: #setVarNames withArguments: #(aClass iVarNames #nil);cr.\r\n\t\tself if: [self not: #sameShape] do: [\r\n\t\t\tself send: #classShapeChanged with: #aClass\r\n\t\t]\r\n\t] else: [\r\n\t\tself send: #aboutToCreateClass withArguments: #(className superclass iVarNames category);cr.\r\n\t\tself send: #mapClassName withArguments: #(className category #nil superclass);cr.\r\n\t\tself assign: #aClass to: [self send: #basicAt: with: #className];cr.\r\n\t\tself send: #setVarNames withArguments: #(aClass iVarNames #nil)\r\n\t];cr.\r\n\tself send: #classChanged with: #aClass;cr.\r\n\tself return: #aClass ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"debugAddClass\",smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:or:\",smalltalk:newArray({\"self\", \"className\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"parent\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:or:\",smalltalk:newArray({\"aClass\", \"\\\"\\\\$superclass\\\"\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"parent\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"parent\",\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"iVarNames\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"iVarNames\",(function()\r\nreturn ((self):emptyArray())\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"aClass\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"superclass\",\"parent\"))\r\nend),(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):send_withArguments_(\"isArray:equalTo:\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):send_withArguments_(\"basic:at:or:\",(smalltalk.Array):with_with_with_(\"aClass\",\"\\\"\\\\$iVarNames\\\"\",(function()\r\nreturn ((self):emptyArray())\r\nend))))\r\nend),\"iVarNames\")))\r\nend),(function()\r\nreturn ((self):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"category\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:\",smalltalk:newArray({\"aClass\", \"\\\"\\\\$category\\\"\"})))\r\nend)))\r\nend),\"aClass\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"sameShape\",\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"aboutToChangeClass\",smalltalk:newArray({\"aClass\", \"superclass\", \"iVarNames\", \"category\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_noteqeq_(\"parent\",\"superclass\"))\r\nend),(function()\r\n(self):comment_(\"move in hierarchy\");(self):comment_(\"disconnect from parent\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"basic:at:put:\",smalltalk:newArray({\"parent\", \"\\\"@subclasses\\\"\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"basic:at:put:\",(smalltalk.Array):with_with_with_((function()\r\nreturn ((self):call_with_(\"class\",\"parent\"))\r\nend),\"\\\"@subclasses\\\"\",\"nil\"));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"link to new parent\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"basic:at:put:\",smalltalk:newArray({\"aClass\", \"\\\"\\\\$superclass\\\"\", \"superclass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aMeta\",(function()\r\nreturn ((self):call_with_(\"class\",\"aClass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"aMeta\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"notNil:\",\"superclass\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"msuper\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:\",smalltalk:newArray({\"aMeta\", \"\\\"\\\\$superclass\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"basic_at_put_\",smalltalk:newArray({\"msuper\", \"\\\"@subclasses\\\"\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_withArguments_(\"basic_at_put_\",(smalltalk.Array):with_with_with_(\"aMeta\",\"\\\"\\\\$superclass\\\"\",(function()\r\nreturn ((self):call_with_(\"class\",\"superclass\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"add to subclasses of parent\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"isNil:\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:or:\",smalltalk:newArray({\"superclass\", \"\\\"@subclasses\\\"\", \"nil\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_withArguments_(\"basic:at:put:\",(smalltalk.Array):with_with_with_(\"superclass\",\"\\\"@subclasses\\\"\",(function()\r\nreturn ((self):send_(\"newArray\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_with_(\"add:\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:\",smalltalk:newArray({\"superclass\", \"\\\"@subclasses\\\"\"})))\r\nend),\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"isNil:\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:or:\",(smalltalk.Array):with_with_with_((function()\r\nreturn ((self):call_with_(\"class\",\"superclass\"))\r\nend),\"\\\"@subclasses\\\"\",\"nil\")))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_withArguments_(\"basic:at:put:\",(smalltalk.Array):with_with_with_((function()\r\nreturn ((self):call_with_(\"class\",\"superclass\"))\r\nend),\"\\\"@subclasses\\\"\",(function()\r\nreturn ((self):send_(\"newArray\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_to_with_(\"add:\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):call_with_(\"class\",\"superclass\"))\r\nend),\"\\\"@subclasses\\\"\")))\r\nend),(function()\r\nreturn ((self):call_with_(\"class\",\"aClass\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"category\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"category\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:or:\",smalltalk:newArray({\"aClass\", \"\\\"\\\\$category\\\"\", \"\\\"\\\"\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"basic:at:put:\",smalltalk:newArray({\"aClass\", \"\\\"\\\\$category\\\"\", \"category\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setVarNames\",smalltalk:newArray({\"aClass\", \"iVarNames\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):not_(\"sameShape\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"classShapeChanged\",\"aClass\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"aboutToCreateClass\",smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"className\", \"category\", \"nil\", \"superclass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass\",(function()\r\nreturn ((self):send_with_(\"basicAt:\",\"className\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_withArguments_(\"setVarNames\",smalltalk:newArray({\"aClass\", \"iVarNames\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"classChanged\",\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"aClass\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"renameClassStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_("niy"))
end));
return (self);
end
,"api","renameClassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #niy] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_(\"niy\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"removeClassStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("aName",(function()
return ((self):send_to_("name","aClass"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("deleted",(function()
return ((self):concat_(smalltalk:newArray({"\"Deleted-\"", "aName"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("parent",(function()
return ((self):send_to_("superclass","aClass"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("notNil:","parent"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("children",(function()
return ((self):send_withArguments_("basic:at:or:",smalltalk:newArray({"parent", "\"@subclasses\"", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):expr_and_((function()
return ((self):send_with_("notNil:","children"))
end),(function()
return ((self):send_to_with_("remove:","children","aClass"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("basic:at:put:",(smalltalk.Array):with_with_with_((function()
return ((self):call_with_("class","aClass"))
end),"\"\\$className\"",(function()
return ((self):concat_(smalltalk:newArray({"deleted", "\" class\""})))
end)));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("basic:at:put:",smalltalk:newArray({"aClass", "\"\\$className\"", "deleted"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("basicDelete:","aName");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("classChanged","aClass");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("self");
return (self);
end
,"api","removeClassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #aName to: [self send: #name to: #aClass];cr.\r\n\tself assign: #deleted to: [self concat: #('\"Deleted-\"' aName)];cr.\r\n\tself assign: #parent to: [self send: #superclass to: #aClass];cr.\r\n\tself if: [self send: #notNil: with: #parent] do: [\r\n\t\tself assign: #children to: [self send: #basic:at:or: withArguments: #(parent '\"@subclasses\"' #nil)];cr.\r\n\t\tself expr: [self send: #notNil: with: #children]\r\n\t\t\tand: [self send: #remove: to: #children with: #aClass ]\r\n\t];cr.\r\n\tself send: #basic:at:put: withArguments: (Array\r\n\t\twith: [self call: #class with: #aClass]\r\n\t\twith: '\"\\$className\"'\r\n\t\twith: [self concat: #(deleted '\" class\"')]);cr.\r\n\tself send: #basic:at:put: withArguments: #(aClass '\"\\$className\"' deleted);cr.\r\n\tself send: #basicDelete: with: #aName;cr.\r\n\tself send: #classChanged with: #aClass;cr.\r\n\tself return: #self ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aName\",(function()\r\nreturn ((self):send_to_(\"name\",\"aClass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"deleted\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"\\\"Deleted-\\\"\", \"aName\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"parent\",(function()\r\nreturn ((self):send_to_(\"superclass\",\"aClass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"parent\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"children\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:or:\",smalltalk:newArray({\"parent\", \"\\\"@subclasses\\\"\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):expr_and_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"children\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"remove:\",\"children\",\"aClass\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"basic:at:put:\",(smalltalk.Array):with_with_with_((function()\r\nreturn ((self):call_with_(\"class\",\"aClass\"))\r\nend),\"\\\"\\\\$className\\\"\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"deleted\", \"\\\" class\\\"\"})))\r\nend)));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"basic:at:put:\",smalltalk:newArray({\"aClass\", \"\\\"\\\\$className\\\"\", \"deleted\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"basicDelete:\",\"aName\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"classChanged\",\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"metaVarNamesStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):comment_("Boot - Set the instance variables of aMetaclass");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setVarNames",smalltalk:newArray({"aMetaClass", "iVarNames", "nil"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("classShapeChanged","aMetaClass");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("classChanged","aMetaClass");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("true");
return (self);
end
,"api","metaVarNamesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Boot - Set the instance variables of aMetaclass';cr.\r\n\tself send: #setVarNames withArguments: #(aMetaClass iVarNames #nil);cr.\r\n\tself send: #classShapeChanged with: #aMetaClass;cr.\r\n\tself send: #classChanged with: #aMetaClass;cr.\r\n\tself return: #true ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"Boot - Set the instance variables of aMetaclass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setVarNames\",smalltalk:newArray({\"aMetaClass\", \"iVarNames\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"classShapeChanged\",\"aMetaClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"classChanged\",\"aMetaClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"true\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"smDoStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):comment_("println(\"in smDo: from \",string(Base.stacktrace()[2]))");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):not_("self.useManager"))
end),(function()
return ((self):return_("nil"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("sm",(function()
return ((self):send_with_("basicAt:","\"SystemManager\""))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_with_("notNil:","sm"))
end),(function()
return ((self):return_("nil"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):not_((function()
return ((self):send_to_withArguments_("responds:to:","smalltalk",smalltalk:newArray({"sm", ":currentOrNil"})))
end)))
end),(function()
return ((self):return_("nil"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("sm",(function()
return ((self):send_to_("currentOrNil","sm"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):expr_and_((function()
return ((self):send_with_("notNil:","sm"))
end),(function()
return ((self):return_((function()
return ((self):call_with_("block","sm"))
end)))
end));
return (self);
end
,"api","smDoStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'println(\"in smDo: from \",string(Base.stacktrace()[2]))';cr.\r\n\tself expr: [self not: 'self.useManager'] and: [self return: #nil];cr.\r\n\tself assign: #sm to: [self send: #basicAt: with: '\"SystemManager\"'];cr.\r\n\tself expr: [self send: #notNil: with: #sm] and: [self return: #nil];cr.\r\n\tself expr: [self not: [self send: #responds:to:\r\n\t\tto: #smalltalk withArguments: #(sm :currentOrNil)]]\r\n\t\tand: [self return: #nil];cr.\r\n\tself assign: #sm to: [self send: #currentOrNil to: #sm];cr.\r\n\tself expr: [self send: #notNil: with: #sm]\r\n\t\tand: [self return: [self call: #block with: #sm]] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"println(\\\"in smDo: from \\\",string(Base.stacktrace()[2]))\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):not_(\"self.useManager\"))\r\nend),(function()\r\nreturn ((self):return_(\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"sm\",(function()\r\nreturn ((self):send_with_(\"basicAt:\",\"\\\"SystemManager\\\"\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"sm\"))\r\nend),(function()\r\nreturn ((self):return_(\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_to_withArguments_(\"responds:to:\",\"smalltalk\",smalltalk:newArray({\"sm\", \":currentOrNil\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):return_(\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"sm\",(function()\r\nreturn ((self):send_to_(\"currentOrNil\",\"sm\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):expr_and_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"sm\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):call_with_(\"block\",\"sm\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"classChangedStSystemDictionary",0
,function(self)
(self):send_with_("smDo",(function()
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_with_("classChanged:","sm","aBehavior"))
end)))
end));
return (self);
end
,"api","classChangedStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self implementFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #classChanged: to: #sm with: #aBehavior\r\n\t]] ","function(self)\r\n(self):send_with_(\"smDo\",(function()\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_with_(\"classChanged:\",\"sm\",\"aBehavior\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"classShapeChangedStSystemDictionary",0
,function(self)
(self):send_with_("smDo",(function()
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_with_("classShapeChanged:","sm","aBehavior"))
end)))
end));
return (self);
end
,"api","classShapeChangedStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self implementFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #classShapeChanged: to: #sm with: #aBehavior\r\n\t]] ","function(self)\r\n(self):send_with_(\"smDo\",(function()\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_with_(\"classShapeChanged:\",\"sm\",\"aBehavior\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"aboutToCreateClassStSystemDictionary",0
,function(self)
(self):send_with_("smDo",(function()
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_withArguments_("aboutToCreateClass:superclass:iVarNames:category:","sm",smalltalk:newArray({"className", "superclass", "iVarNames", "category"})))
end)))
end));
return (self);
end
,"api","aboutToCreateClassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self implementFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #aboutToCreateClass:superclass:iVarNames:category: to: #sm\r\n\t\t\twithArguments: #(className superclass iVarNames category)\r\n\t]] ","function(self)\r\n(self):send_with_(\"smDo\",(function()\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_withArguments_(\"aboutToCreateClass:superclass:iVarNames:category:\",\"sm\",smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"})))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"aboutToChangeClassStSystemDictionary",0
,function(self)
(self):send_with_("smDo",(function()
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_withArguments_("aboutToChange:superclass:iVarNames:category:","sm",smalltalk:newArray({"aClass", "superclass", "iVarNames", "category"})))
end)))
end));
return (self);
end
,"api","aboutToChangeClassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self implementFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #aboutToChange:superclass:iVarNames:category: to: #sm\r\n\t\t\twithArguments: #(aClass superclass iVarNames category)\r\n\t]] ","function(self)\r\n(self):send_with_(\"smDo\",(function()\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_withArguments_(\"aboutToChange:superclass:iVarNames:category:\",\"sm\",smalltalk:newArray({\"aClass\", \"superclass\", \"iVarNames\", \"category\"})))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"methodBoundToStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_withArguments_("methodBound:to:","sm",smalltalk:newArray({"method", "klass"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"api","methodBoundToStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self implementFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #methodBound:to: to: #sm withArguments: #(method klass)\r\n\t]];cr.\r\n\tself return: #method ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_withArguments_(\"methodBound:to:\",\"sm\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"aboutToBindToStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_withArguments_("aboutToBind:to:","sm",smalltalk:newArray({"method", "klass"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"api","aboutToBindToStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self implementFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #aboutToBind:to: to: #sm withArguments: #(method klass)\r\n\t]];cr.\r\n\tself return: #method ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_withArguments_(\"aboutToBind:to:\",\"sm\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"aboutToRemoveFromStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_withArguments_("aboutToRemove:from:","sm",smalltalk:newArray({"method", "klass"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"api","aboutToRemoveFromStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self implementFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #aboutToRemove:from: to: #sm withArguments: #(method klass)\r\n\t]];cr.\r\n\tself return: #method ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_withArguments_(\"aboutToRemove:from:\",\"sm\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"methodRemovedFromStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_withArguments_("methodRemoved:from:","sm",smalltalk:newArray({"method", "klass"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"api","methodRemovedFromStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self implementFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #methodRemoved:from: to: #sm withArguments: #(method klass)\r\n\t]];cr.\r\n\tself return: #method ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_withArguments_(\"methodRemoved:from:\",\"sm\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"objectNotFoundStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_withArguments_("object:at:notFoundIn:","sm",smalltalk:newArray({"object", "indexOrKey", "collection"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("collection");
return (self);
end
,"api","objectNotFoundStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self implementFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #object:at:notFoundIn: to: #sm withArguments: #(object indexOrKey collection)\r\n\t]];cr.\r\n\tself return: #collection ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_withArguments_(\"object:at:notFoundIn:\",\"sm\",smalltalk:newArray({\"object\", \"indexOrKey\", \"collection\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"collection\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"whoImplementsStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_("niy"))
end));
return (self);
end
,"api","whoImplementsStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #niy] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_(\"niy\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"superImplementorStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):pars_((function()
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"aReceiver", "args..."}),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("ff",(function()
return ((self):pars_((function()
return ((self):implementFunction_arguments_doing_("",smalltalk:newArray({"i"}),(function()
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):expr_eqeq_("i","1"))
end),(function()
return ((self):return_((function()
return ((self):send_to_("basicNew",(function()
return ((self):send_to_("superclass","klass"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("args[i-1]"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("ikTypes",(function()
return ((self):call_with_("typeof",(function()
return ((self):call_withArguments_("Base.ntuple",(smalltalk.Array):with_with_("ff",(function()
return ((self):succ_((function()
return ((self):call_with_("length","args"))
end)))
end))))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("fun",(function()
return ((self):call_with_("fn",(function()
return ((self):send_to_with_(">>>",(function()
return ((self):send_to_("superclass","klass"))
end),"jsSelector"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):call_withArguments_("println",smalltalk:newArray({"\"###about to invoke \"", "aReceiver", "\" \"", "fun", "\" on \"", "ikTypes"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_((function()
return ((self):call_withArguments_("Base.invoke",smalltalk:newArray({"fun", "ikTypes", "aReceiver", "args..."})))
end)))
end)))
end)))
end));
return (self);
end
,"api","superImplementorStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self pars: [\r\n\t\tself implementFunction: '' arguments: #(aReceiver 'args...') doing: [\r\n\t\t\tself assign: #ff to: [self pars: [\r\n\t\t\t\tself implementFunction: '' arguments: #(i) doing: [\r\n\t\t\t\t\tself expr: [self expr: #i eqeq: #1]\r\n\t\t\t\t\t\tand: [self return: [self send: #basicNew to: [\r\n\t\t\t\t\t\t\tself send: #superclass to: #klass]]];cr.\r\n\t\t\t\t\tself return: 'args[i-1]'\r\n\t\t\t\t]]];cr.\r\n\t\tself assign: #ikTypes to: [self call: #typeof with: [\r\n\t\t\tself call: 'Base.ntuple' withArguments: (Array\r\n\t\t\t\twith: #ff with: [self succ: [self call: #length with: #args]])\r\n\t\t]];cr.\r\n\t\tself assign: #fun to: [self call: #fn with: [\r\n\t\t\tself send: #>>> to: [self send: #superclass to: #klass] with: #jsSelector\r\n\t\t]];cr.\r\n\t\tself call: #println withArguments: #('\"###about to invoke \"' aReceiver '\" \"' fun '\" on \"' ikTypes);cr.\r\n\t\tself return: [self call: 'Base.invoke' withArguments: #(fun ikTypes aReceiver 'args...')]\r\n\t]]] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):pars_((function()\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"aReceiver\", \"args...\"}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"ff\",(function()\r\nreturn ((self):pars_((function()\r\nreturn ((self):implementFunction_arguments_doing_(\"\",smalltalk:newArray({\"i\"}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):expr_eqeq_(\"i\",\"1\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_(\"basicNew\",(function()\r\nreturn ((self):send_to_(\"superclass\",\"klass\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"args[i-1]\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"ikTypes\",(function()\r\nreturn ((self):call_with_(\"typeof\",(function()\r\nreturn ((self):call_withArguments_(\"Base.ntuple\",(smalltalk.Array):with_with_(\"ff\",(function()\r\nreturn ((self):succ_((function()\r\nreturn ((self):call_with_(\"length\",\"args\"))\r\nend)))\r\nend))))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"fun\",(function()\r\nreturn ((self):call_with_(\"fn\",(function()\r\nreturn ((self):send_to_with_(\">>>\",(function()\r\nreturn ((self):send_to_(\"superclass\",\"klass\"))\r\nend),\"jsSelector\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"println\",smalltalk:newArray({\"\\\"###about to invoke \\\"\", \"aReceiver\", \"\\\" \\\"\", \"fun\", \"\\\" on \\\"\", \"ikTypes\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_((function()\r\nreturn ((self):call_withArguments_(\"Base.invoke\",smalltalk:newArray({\"fun\", \"ikTypes\", \"aReceiver\", \"args...\"})))\r\nend)))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"instVarAtStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("key",(function()
return ((self):concat_((smalltalk.Array):with_with_("\"\\$\"",(function()
return ((self):call_with_("string","ivName"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):comment_("println(\"instVarAt \",key ,\" in a \" ,typeof(object) ,\" object=\",object)");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):not_((function()
return ((self):call_withArguments_("hasfield",(smalltalk.Array):with_with_((function()
return ((self):call_with_("typeof","object"))
end),":dict")))
end)))
end),(function()
return ((self):return_("default"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):send_withArguments_("basic:at:or:",smalltalk:newArray({"object", "key", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_with_("notNil:","result"))
end),(function()
return ((self):return_("result"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):send_withArguments_("basic:at:or:",smalltalk:newArray({"object", "\"@handle\"", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("notNil:","result"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("println",smalltalk:newArray({"\"instVarAt \"", "key", "\" in @handle\""}));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_((function()
return ((self):send_withArguments_("basic:at:or:",smalltalk:newArray({"result", "key", "default"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("default");
return (self);
end
,"api","instVarAtStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #key to: [self concat: (Array with: '\"\\$\"' with: [self call: #string with: #ivName])];cr.\r\n\tself comment: 'println(\"instVarAt \",key ,\" in a \" ,typeof(object) ,\" object=\",object)';cr.\r\n\tself expr: [self not: [self call: #hasfield withArguments: (Array\r\n\t\twith: [self call: #typeof with: #object] with: #:dict)]]\r\n\t\tand: [self return: #default];cr.\r\n\tself assign: #result to: [self send: #basic:at:or: withArguments: #(object key #nil)];cr.\r\n\tself expr: [ self send: #notNil: with: #result] and: [self return: #result];cr.\r\n\tself assign: #result to: [self send: #basic:at:or:\r\n\t\twithArguments: #(object '\"@handle\"' #nil)];cr.\r\n\tself if: [self send: #notNil: with: #result] do: [\r\n\t\tself call: #println withArguments: #('\"instVarAt \"' key '\" in @handle\"');cr.\r\n\t\tself return: [self send: #basic:at:or: withArguments: #(result key default)]\r\n\t];cr.\r\n\tself return: #default ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"key\",(function()\r\nreturn ((self):concat_((smalltalk.Array):with_with_(\"\\\"\\\\$\\\"\",(function()\r\nreturn ((self):call_with_(\"string\",\"ivName\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"println(\\\"instVarAt \\\",key ,\\\" in a \\\" ,typeof(object) ,\\\" object=\\\",object)\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):call_withArguments_(\"hasfield\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):call_with_(\"typeof\",\"object\"))\r\nend),\":dict\")))\r\nend)))\r\nend),(function()\r\nreturn ((self):return_(\"default\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:or:\",smalltalk:newArray({\"object\", \"key\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"result\"))\r\nend),(function()\r\nreturn ((self):return_(\"result\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:or:\",smalltalk:newArray({\"object\", \"\\\"@handle\\\"\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"result\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"println\",smalltalk:newArray({\"\\\"instVarAt \\\"\", \"key\", \"\\\" in @handle\\\"\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_((function()\r\nreturn ((self):send_withArguments_(\"basic:at:or:\",smalltalk:newArray({\"result\", \"key\", \"default\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"default\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"addMethodStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("aboutToBindTo",smalltalk:newArray({"method", "klass"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("fn",(function()
return ((self):send_withArguments_("instVarAt",smalltalk:newArray({"method", "\"fn\""})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):comment_("basic_at_put_(self, fn, \"\\$s8-method\", method)");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("basic:at:put:",smalltalk:newArray({"klass", "jsSelector", "fn"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_or_((function()
return ((self):send_with_("isNil:","stSelector"))
end),(function()
return ((self):expr_eqeq_("stSelector","0"))
end)))
end),(function()
return ((self):assign_to_("stSelector",(function()
return ((self):send_to_("asNativeSelector","jsSelector"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_((function()
return ((self):object_at_((function()
return ((self):send_withArguments_("basic:at:",smalltalk:newArray({"klass", "\"\\$methods\""})))
end),(function()
return ((self):call_with_("string","stSelector"))
end)))
end),"method");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("basic:at:put:",smalltalk:newArray({"method", "\"@classField\"", "klass"}));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_withArguments_("methodBoundTo",smalltalk:newArray({"method", "klass"})))
end));
return (self);
end
,"api","addMethodStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #aboutToBindTo withArguments: #(method klass);cr.\r\n\tself assign: #fn to: [self send: #instVarAt withArguments: #(method '\"fn\"')];cr.\r\n\tself comment: 'basic_at_put_(self, fn, \"\\$s8-method\", method)';cr.\r\n\tself send: #basic:at:put: withArguments: #(klass jsSelector fn);cr.\r\n\tself if: [self expr: [self send: #isNil: with: #stSelector]\r\n\t\tor: [self expr: #stSelector eqeq: #0]] do: [\r\n\t\tself assign: #stSelector to: [self send: #asNativeSelector to: #jsSelector]\r\n\t];cr.\r\n\tself assign: [self\r\n\t\tobject: [self send: #basic:at: withArguments: #(klass '\"\\$methods\"')]\r\n\t\tat: [self call: #string with: #stSelector]]\r\n\t\tto: #method;cr.\r\n\tself send: #basic:at:put: withArguments: #(method '\"@classField\"' klass);cr.\r\n\tself return: [self send: #methodBoundTo withArguments: #(method klass)] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"aboutToBindTo\",smalltalk:newArray({\"method\", \"klass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"fn\",(function()\r\nreturn ((self):send_withArguments_(\"instVarAt\",smalltalk:newArray({\"method\", \"\\\"fn\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"basic_at_put_(self, fn, \\\"\\\\$s8-method\\\", method)\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"basic:at:put:\",smalltalk:newArray({\"klass\", \"jsSelector\", \"fn\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"stSelector\"))\r\nend),(function()\r\nreturn ((self):expr_eqeq_(\"stSelector\",\"0\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"stSelector\",(function()\r\nreturn ((self):send_to_(\"asNativeSelector\",\"jsSelector\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_((function()\r\nreturn ((self):object_at_((function()\r\nreturn ((self):send_withArguments_(\"basic:at:\",smalltalk:newArray({\"klass\", \"\\\"\\\\$methods\\\"\"})))\r\nend),(function()\r\nreturn ((self):call_with_(\"string\",\"stSelector\"))\r\nend)))\r\nend),\"method\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"basic:at:put:\",smalltalk:newArray({\"method\", \"\\\"@classField\\\"\", \"klass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"methodBoundTo\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"bindStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_or_((function()
return ((self):send_with_("isNil:","jsSelector"))
end),(function()
return ((self):expr_eqeq_("jsSelector","0"))
end)))
end),(function()
return ((self):assign_to_("jsSelector",(function()
return ((self):call_withArguments_("Base.replace",(smalltalk.Array):with_with_("stSelector",(function()
return ((self):expr_eqgt_("\":\"","\"_\""))
end))))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("debugBind",smalltalk:newArray({"klass", "stSelector", "jsSelector", "jsFunction", "category", "stSource", "nativeSource", "stamp"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):comment_("println(\"bind - \" ,stSelector )");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("spec",(function()
return ((self):anyDict_object_("String",smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((("\"\\$selector\""):_minus_gt("stSelector")),("\"\\$fn\""):_minus_gt("jsFunction"))),("\"\\$category\""):_minus_gt("category"))),("\"\\$source\""):_minus_gt("stSource"))),("\"\\$nativeSource\""):_minus_gt("nativeSource"))),("\"\\$stamp\""):_minus_gt("stamp"))),("\"\\$generation\""):_minus_gt((function()
return ((self):send_("state"))
end)))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):send_with_("notNil:",(function()
return ((self):send_withArguments_("basic:at:or:",smalltalk:newArray({"self", "\"CompiledMethod\"", "nil"})))
end)))
end),(function()
return ((self):assign_to_("method",(function()
return ((self):send_to_with_("basicNewInstance:","self.CompiledMethod","spec"))
end)))
end),(function()
return ((self):assign_to_("method","spec"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("notNil:","klass"))
end),(function()
return ((self):send_withArguments_("addMethod",smalltalk:newArray({"jsSelector", "method", "klass", "stSelector"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"api","bindStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: [self send: #isNil: with: #jsSelector]\r\n\t\tor: [self expr: #jsSelector eqeq: #0]] do: [\r\n\t\tself assign: #jsSelector to: [self call: 'Base.replace' withArguments: (Array\r\n\t\t\twith: #stSelector with: [self expr: '\":\"' eqgt: '\"_\"'])]\r\n\t];cr.\r\n\tself send: #debugBind withArguments: #(\r\n\t\tklass stSelector jsSelector jsFunction\r\n\t\tcategory stSource nativeSource stamp);cr.\r\n\tself comment: 'println(\"bind - \" ,stSelector )';cr.\r\n\tself assign: #spec to: [self anyDict: #String object:\r\n\t\t'\"\\$selector\"' -> #stSelector\r\n\t\t,('\"\\$fn\"' -> #jsFunction)\r\n\t\t,('\"\\$category\"' -> #category)\r\n\t\t,('\"\\$source\"' -> #stSource)\r\n\t\t,('\"\\$nativeSource\"' -> #nativeSource)\r\n\t\t,('\"\\$stamp\"' -> #stamp)\r\n\t\t,('\"\\$generation\"' -> [self send: #state])\r\n\t];cr.\r\n\tself if: [self send: #notNil: with: [\r\n\t\tself send: #basic:at:or: withArguments: #(self '\"CompiledMethod\"' #nil)\r\n\t\t]] do: [\r\n\t\tself assign: #method to: [self send: #basicNewInstance: to: 'self.CompiledMethod' with: #spec]\r\n\t\t] else: [ self assign: #method to: #spec ];cr.\r\n\tself if: [self send: #notNil: with: #klass] do: [\r\n\t\tself send: #addMethod withArguments: #(jsSelector method klass stSelector)\r\n\t];cr.\r\n\tself return: #method ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"jsSelector\"))\r\nend),(function()\r\nreturn ((self):expr_eqeq_(\"jsSelector\",\"0\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"jsSelector\",(function()\r\nreturn ((self):call_withArguments_(\"Base.replace\",(smalltalk.Array):with_with_(\"stSelector\",(function()\r\nreturn ((self):expr_eqgt_(\"\\\":\\\"\",\"\\\"_\\\"\"))\r\nend))))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"debugBind\",smalltalk:newArray({\"klass\", \"stSelector\", \"jsSelector\", \"jsFunction\", \"category\", \"stSource\", \"nativeSource\", \"stamp\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"println(\\\"bind - \\\" ,stSelector )\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"spec\",(function()\r\nreturn ((self):anyDict_object_(\"String\",smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((\"\\\"\\\\$selector\\\"\"):_minus_gt(\"stSelector\")),(\"\\\"\\\\$fn\\\"\"):_minus_gt(\"jsFunction\"))),(\"\\\"\\\\$category\\\"\"):_minus_gt(\"category\"))),(\"\\\"\\\\$source\\\"\"):_minus_gt(\"stSource\"))),(\"\\\"\\\\$nativeSource\\\"\"):_minus_gt(\"nativeSource\"))),(\"\\\"\\\\$stamp\\\"\"):_minus_gt(\"stamp\"))),(\"\\\"\\\\$generation\\\"\"):_minus_gt((function()\r\nreturn ((self):send_(\"state\"))\r\nend)))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):send_with_(\"notNil:\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:or:\",smalltalk:newArray({\"self\", \"\\\"CompiledMethod\\\"\", \"nil\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"method\",(function()\r\nreturn ((self):send_to_with_(\"basicNewInstance:\",\"self.CompiledMethod\",\"spec\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"method\",\"spec\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"klass\"))\r\nend),(function()\r\nreturn ((self):send_withArguments_(\"addMethod\",smalltalk:newArray({\"jsSelector\", \"method\", \"klass\", \"stSelector\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"removeNativeFunction_for_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_with_("isNil:","fn"))
end),(function()
return ((self):return_("false"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("done","false");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("stClass",(function()
return ((self):call_with_("supertype","aClass[\"\\$constructor\"]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("mmm it should be the encoding types to match here");
(self):comment_("e.g. Any for Object");
(self):comment_("see methods(yourself).ms[1].sig.types");
(
function(_s8_rec)
	(_s8_rec):for_in_do_("mth",(function()
return ((self):call_with_("methods","fn"))
end),(function()
(self):comment_("println(\"Walking method \",mth)");(
function(_s8_rec)
	(_s8_rec):assign_to_("rcvType","mth.sig.types[2]");
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):expr_eqeq_("rcvType","stClass"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):call_with_("Base.delete_method","mth");
	return ((_s8_rec):cr())
end
)(self);(self):comment_("println(\"Deleting method \",mth)");return ((self):assign_to_("done","true"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("done");
return (self);
end
,"api","removeNativeFunction_for_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self send: #isNil: with: #fn] and: [self return: #false];cr.\r\n\tself assign: #done to: #false;cr.\r\n\tself assign: #stClass to: [self call: #supertype with: 'aClass[\"\\$constructor\"]'];cr.\r\n\tself comment: 'mmm it should be the encoding types to match here'.\r\n\tself comment: 'e.g. Any for Object'.\r\n\tself comment: 'see methods(yourself).ms[1].sig.types'.\r\n\tself for: #mth in: [self call: #methods with: #fn] do: [\r\n\t\tself comment: 'println(\"Walking method \",mth)'.\r\n\t\tself assign: #rcvType to: 'mth.sig.types[2]';cr.\r\n\t\tself if: [self expr: #rcvType eqeq: #stClass] do: [\r\n\t\t\tself call: 'Base.delete_method' with: #mth;cr.\r\n\t\t\tself comment: 'println(\"Deleting method \",mth)'.\r\n\t\t\tself assign: #done to: #true\r\n\t\t]\r\n\t];cr.\r\n\tself return: #done ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"fn\"))\r\nend),(function()\r\nreturn ((self):return_(\"false\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"done\",\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"stClass\",(function()\r\nreturn ((self):call_with_(\"supertype\",\"aClass[\\\"\\\\$constructor\\\"]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"mmm it should be the encoding types to match here\");\r\n(self):comment_(\"e.g. Any for Object\");\r\n(self):comment_(\"see methods(yourself).ms[1].sig.types\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"mth\",(function()\r\nreturn ((self):call_with_(\"methods\",\"fn\"))\r\nend),(function()\r\n(self):comment_(\"println(\\\"Walking method \\\",mth)\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"rcvType\",\"mth.sig.types[2]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"rcvType\",\"stClass\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"Base.delete_method\",\"mth\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"println(\\\"Deleting method \\\",mth)\");return ((self):assign_to_(\"done\",\"true\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"done\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"removeMethodStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("aboutToRemoveFrom",smalltalk:newArray({"aMethod", "aClass"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("stSelector",(function()
return ((self):send_to_("selector","aMethod"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("basic:delete:",(smalltalk.Array):with_with_("aClass",(function()
return ((self):send_to_("asSelector","stSelector"))
end)));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_to_with_("delete!",(function()
return ((self):send_withArguments_("basic:at:",smalltalk:newArray({"aClass", "\"\\$methods\""})))
end),(function()
return ((self):call_with_("string","stSelector"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("removeNativeFunction:for:",(smalltalk.Array):with_with_((function()
return ((self):send_to_("fn","aMethod"))
end),"aClass"));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_withArguments_("methodRemovedFrom",smalltalk:newArray({"aMethod", "aClass"})))
end));
return (self);
end
,"api","removeMethodStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #aboutToRemoveFrom withArguments: #(aMethod aClass);cr.\r\n\tself assign: #stSelector to: [self send: #selector to: #aMethod];cr.\r\n\tself send: #basic:delete: withArguments: (Array\r\n\t\twith: #aClass\r\n\t\twith: [self send: #asSelector to: #stSelector]);cr.\r\n\tself send: 'delete!' to: [self send: #basic:at:\r\n\t\twithArguments: #(aClass '\"\\$methods\"')]\r\n\t\twith: [self call: #string with: #stSelector];cr.\r\n\tself send: #removeNativeFunction:for: withArguments: (Array\r\n\t\twith: [self send: #fn to: #aMethod]\r\n\t\twith: #aClass);cr.\r\n\tself return: [self send: #methodRemovedFrom withArguments: #(aMethod aClass)] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"aboutToRemoveFrom\",smalltalk:newArray({\"aMethod\", \"aClass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"stSelector\",(function()\r\nreturn ((self):send_to_(\"selector\",\"aMethod\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"basic:delete:\",(smalltalk.Array):with_with_(\"aClass\",(function()\r\nreturn ((self):send_to_(\"asSelector\",\"stSelector\"))\r\nend)));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_with_(\"delete!\",(function()\r\nreturn ((self):send_withArguments_(\"basic:at:\",smalltalk:newArray({\"aClass\", \"\\\"\\\\$methods\\\"\"})))\r\nend),(function()\r\nreturn ((self):call_with_(\"string\",\"stSelector\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"removeNativeFunction:for:\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):send_to_(\"fn\",\"aMethod\"))\r\nend),\"aClass\"));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"methodRemovedFrom\",smalltalk:newArray({\"aMethod\", \"aClass\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"newMethodStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_withArguments_("bind",smalltalk:newArray({"nil", "selector", "nil", "fn", "nil", "source", "nativeSource", "stamp"})))
end));
return (self);
end
,"api","newMethodStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #bind withArguments: #(\r\n\t\t#nil selector #nil fn\r\n\t\t#nil source nativeSource\r\n\t\tstamp)] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"bind\",smalltalk:newArray({\"nil\", \"selector\", \"nil\", \"fn\", \"nil\", \"source\", \"nativeSource\", \"stamp\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"methodStSystemDictionary",0
,function(self)
(self):comment_("OBSOLETE");
(self):return_((function()
return ((self):send_withArguments_("bind",smalltalk:newArray({"nil", "spec.selector", "nil", "spec.fn", "spec.category", "spec.source", "spec[\"\\$nativeSource\"]", "spec[\"\\$stamp\"]"})))
end));
return (self);
end
,"api","methodStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: #OBSOLETE.\r\n\tself return: [self send: #bind withArguments: #(\r\n\t\t#nil 'spec.selector'\r\n\t\t#nil 'spec.fn' 'spec.category'\r\n\t\t'spec.source' 'spec[\"\\$nativeSource\"]'\r\n\t\t'spec[\"\\$stamp\"]')] ","function(self)\r\n(self):comment_(\"OBSOLETE\");\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"bind\",smalltalk:newArray({\"nil\", \"spec.selector\", \"nil\", \"spec.fn\", \"spec.category\", \"spec.source\", \"spec[\\\"\\\\$nativeSource\\\"]\", \"spec[\\\"\\\\$stamp\\\"]\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"readJSObjectStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_("niy"))
end));
return (self);
end
,"api","readJSObjectStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #niy] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_(\"niy\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"basenStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_("niy"))
end));
return (self);
end
,"api","basenStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #niy] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_(\"niy\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"globalsDoStSystemDictionary",0
,function(self)
(self):for_in_do_("aPair","self.dict",(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("obj","aPair[2]");
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):send_with_("isObject:","obj"))
end),(function()
return ((self):expr_and_((function()
return ((self):expr_and_((function()
return ((self):send_to_with_("respondsTo:","obj","\"isClass\""))
end),(function()
return ((self):not_((function()
return ((self):send_to_("isClass","obj"))
end)))
end)))
end),(function()
return ((self):call_with_("action","aPair[1]"))
end)))
end)))
end));
return (self);
end
,"api","globalsDoStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself for: #aPair in: 'self.dict' do: [\r\n\t\tself assign: #obj to: 'aPair[2]';cr.\r\n\t\tself if: [self send: #isObject: with: #obj] do: [\r\n\t\t\tself expr: [self expr: [\r\n\t\t\t\tself send: #respondsTo: to: #obj with: '\"isClass\"'] \r\n\t\t\t\tand: [self not: [self send: #isClass to: #obj]]\r\n\t\t\t\t] and: [self call: #action with: 'aPair[1]']\r\n\t\t]\r\n\t] ","function(self)\r\n(self):for_in_do_(\"aPair\",\"self.dict\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"obj\",\"aPair[2]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):send_with_(\"isObject:\",\"obj\"))\r\nend),(function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):send_to_with_(\"respondsTo:\",\"obj\",\"\\\"isClass\\\"\"))\r\nend),(function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_to_(\"isClass\",\"obj\"))\r\nend)))\r\nend)))\r\nend),(function()\r\nreturn ((self):call_with_(\"action\",\"aPair[1]\"))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"launchImageStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("self.useManager","true");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("notNil:","imageName"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[\"\\$imageFileName\"]","imageName");
	return ((_s8_rec):cr())
end
)(self);return ((self):send_with_("load","imageName"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("state:","\"launching\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_with_("respondsTo:","\"launch\""))
end),(function()
return ((self):send_("launch"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("state:","\"running\"");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("self");
return (self);
end
,"api","launchImageStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: 'self.useManager' to: #true;cr.\r\n\tself if: [self send: #notNil: with: #imageName] do: [\r\n\t\tself assign: 'self[\"\\$imageFileName\"]' to: #imageName;cr.\r\n\t\tself send: #load with: #imageName\r\n\t];cr.\r\n\tself send: #state: with: '\"launching\"';cr.\r\n\tself expr: [self send: #respondsTo: with: '\"launch\"']\r\n\t\tand: [self send: #launch];cr.\r\n\tself send: #state: with: '\"running\"';cr.\r\n\tself return: #self ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self.useManager\",\"true\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"imageName\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[\\\"\\\\$imageFileName\\\"]\",\"imageName\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_with_(\"load\",\"imageName\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"state:\",\"\\\"launching\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_with_(\"respondsTo:\",\"\\\"launch\\\"\"))\r\nend),(function()\r\nreturn ((self):send_(\"launch\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"state:\",\"\\\"running\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"is_kindOf_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("cls",(function()
return ((self):send_with_("classOf:","anObject"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):while_do_("true",(function()
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):expr_eqeq_("cls","aClass"))
end),(function()
return ((self):return_("true"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_with_("isNil:","cls"))
end),(function()
return ((self):return_("false"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("cls",(function()
return ((self):send_to_("superclass","cls"))
end)))
end));
return (self);
end
,"api","is_kindOf_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #cls to: [self send: #classOf: with: #anObject];cr.\r\n\tself while: #true do: [\r\n\t\tself expr: [self expr: #cls eqeq: #aClass] and: [self return: #true];cr.\r\n\t\tself expr: [self send: #isNil: with: #cls] and: [self return: #false];cr.\r\n\t\tself assign: #cls to: [self send: #superclass to: #cls]\r\n\t] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"cls\",(function()\r\nreturn ((self):send_with_(\"classOf:\",\"anObject\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):while_do_(\"true\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):expr_eqeq_(\"cls\",\"aClass\"))\r\nend),(function()\r\nreturn ((self):return_(\"true\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"cls\"))\r\nend),(function()\r\nreturn ((self):return_(\"false\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"cls\",(function()\r\nreturn ((self):send_to_(\"superclass\",\"cls\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"responds_to_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("cls",(function()
return ((self):send_to_("klass","anObject"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):while_do_((function()
return ((self):send_with_("notNil:","cls"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_to_with_("implements:","cls","aSelector"))
end),(function()
return ((self):return_("true"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("cls",(function()
return ((self):send_to_("superclass","cls"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("false");
return (self);
end
,"api","responds_to_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #cls to: [self send: #klass to: #anObject];cr.\r\n\tself while: [self send: #notNil: with: #cls] do: [\r\n\t\tself expr: [self send: #implements: to: #cls with: #aSelector]\r\n\t\t\tand: [self return: #true];cr.\r\n\t\tself assign: #cls to: [self send: #superclass to: #cls]\r\n\t];cr.\r\n\tself return: #false ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"cls\",(function()\r\nreturn ((self):send_to_(\"klass\",\"anObject\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):while_do_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"cls\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_to_with_(\"implements:\",\"cls\",\"aSelector\"))\r\nend),(function()\r\nreturn ((self):return_(\"true\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"cls\",(function()\r\nreturn ((self):send_to_(\"superclass\",\"cls\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"false\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"handleOfStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_withArguments_("handleOf:or:",smalltalk:newArray({"anObject", "anObject"})))
end));
return (self);
end
,"api","handleOfStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #handleOf:or: withArguments: #(anObject anObject)] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"handleOf:or:\",smalltalk:newArray({\"anObject\", \"anObject\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"handleOf_or_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_isa_("anObject","StObject"))
end),(function()
return ((self):send_withArguments_("basic:at:or:",smalltalk:newArray({"anObject", "\"@handle\"", "default"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("default");
return (self);
end
,"api","handleOf_or_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: #anObject isa: #StObject] return: [\r\n\t\tself send: #basic:at:or: withArguments: #(anObject '\"@handle\"' default)\r\n\t];cr.\r\n\tself return: #default ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_isa_(\"anObject\",\"StObject\"))\r\nend),(function()\r\nreturn ((self):send_withArguments_(\"basic:at:or:\",smalltalk:newArray({\"anObject\", \"\\\"@handle\\\"\", \"default\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"default\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"newHashStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):call_with_("S8Object",(function()
return ((self):call_("Dict{String, Any}"))
end)))
end));
return (self);
end
,"api","newHashStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self call: #S8Object with: [self call: 'Dict{String, Any}']] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"S8Object\",(function()\r\nreturn ((self):call_(\"Dict{String, Any}\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"stObjectStSystemDictionary",0
,function(self)
(self):return_("StObject");
return (self);
end
,"api","stObjectStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: #StObject ","function(self)\r\n(self):return_(\"StObject\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"debugBindStSystemDictionary",0
,function(self)
(self):return_("self");
return (self);
end
,"api","debugBindStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: #self ","function(self)\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"debugAddClassStSystemDictionary",0
,function(self)
(self):return_("self");
return (self);
end
,"api","debugAddClassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: #self ","function(self)\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"toStringStSystemDictionary",0
,function(self)
(self):return_("\"smalltalk\"");
return (self);
end
,"api","toStringStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: '\"smalltalk\"' ","function(self)\r\n(self):return_(\"\\\"smalltalk\\\"\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"quitStSystemDictionary",0
,function(self)
(self):call_("Base.exit");
return (self);
end
,"api","quitStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself call: 'Base.exit' ","function(self)\r\n(self):call_(\"Base.exit\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"versionStSystemDictionary",0
,function(self)
(self):return_("VERSION");
return (self);
end
,"api","versionStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: #VERSION ","function(self)\r\n(self):return_(\"VERSION\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"folderContentsStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):emptyArray())
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("each",(function()
return ((self):call_with_("Base.Filesystem.readdir","fileName"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("pathName",(function()
return ((self):call_withArguments_("Base.Filesystem.joinpath",smalltalk:newArray({"fileName", "each"})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("entry",(function()
return ((self):emptyArray())
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):call_with_("Base.Filesystem.isdir","pathName"))
end),(function()
return ((self):assign_to_("entry",(function()
return ((self):array_(smalltalk:newArray({"\"folder\"", "0", "each"})))
end)))
end),(function()
return ((self):assign_to_("entry",(function()
return ((self):array_((smalltalk.Array):with_with_with_("\"file\"",(function()
return ((self):call_with_("Base.filesize","pathName"))
end),"each")))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):send_to_with_("Base.push!","result",(function()
return ((self):send_with_("newArray","entry"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_with_("newArray","result"))
end));
return (self);
end
,"api","folderContentsStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #result to: [self emptyArray];cr.\r\n\tself for: #each in: [self call: 'Base.Filesystem.readdir' with: #fileName] do: [\r\n\t\tself assign: #pathName to: [\r\n\t\t\tself call: 'Base.Filesystem.joinpath'\r\n\t\t\t\twithArguments: #(fileName each)\r\n\t\t];cr.\r\n\t\tself assign: #entry to: [self emptyArray];cr.\r\n\t\tself if: [self call: 'Base.Filesystem.isdir' with: #pathName] do: [\r\n\t\t\tself assign: #entry to: [self array: #('\"folder\"' #0 each)]\r\n\t\t] else: [\r\n\t\t\tself assign: #entry to: [self array: (Array\r\n\t\t\t\twith: '\"file\"'\r\n\t\t\t\twith: [self call: 'Base.filesize' with: #pathName]\r\n\t\t\t\twith: #each)]\r\n\t\t];cr.\r\n\t\tself send: 'Base.push!' to: #result with: [self send: #newArray with: #entry]\r\n\t];cr.\r\n\tself return: [self send: #newArray with: #result] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):emptyArray())\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"each\",(function()\r\nreturn ((self):call_with_(\"Base.Filesystem.readdir\",\"fileName\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"pathName\",(function()\r\nreturn ((self):call_withArguments_(\"Base.Filesystem.joinpath\",smalltalk:newArray({\"fileName\", \"each\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"entry\",(function()\r\nreturn ((self):emptyArray())\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):call_with_(\"Base.Filesystem.isdir\",\"pathName\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"entry\",(function()\r\nreturn ((self):array_(smalltalk:newArray({\"\\\"folder\\\"\", \"0\", \"each\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"entry\",(function()\r\nreturn ((self):array_((smalltalk.Array):with_with_with_(\"\\\"file\\\"\",(function()\r\nreturn ((self):call_with_(\"Base.filesize\",\"pathName\"))\r\nend),\"each\")))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_to_with_(\"Base.push!\",\"result\",(function()\r\nreturn ((self):send_with_(\"newArray\",\"entry\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"newArray\",\"result\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"httpSupportStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):call_with_("eval",(function()
return ((self):call_with_("Meta.parse","\"using HTTP; HTTP\""))
end)))
end));
return (self);
end
,"api","httpSupportStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self call: #eval with: [self call: 'Meta.parse' with: '\"using HTTP; HTTP\"']] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"eval\",(function()\r\nreturn ((self):call_with_(\"Meta.parse\",\"\\\"using HTTP; HTTP\\\"\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"httpContentsStSystemDictionary",0
,function(self)
(self):try_catch_doing_((function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("response",(function()
return ((self):call_withArguments_("httpSupport(self).request",smalltalk:newArray({"\"GET\"", "fileName"})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_((function()
return ((self):call_with_("String","response.body"))
end)))
end),"e",(function()
return ((self):return_("nil"))
end));
return (self);
end
,"api","httpContentsStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself try: [\r\n\t\tself assign: #response to: [\r\n\t\t\tself call: 'httpSupport(self).request'\r\n\t\t\t\twithArguments: #('\"GET\"' fileName)\r\n\t\t];cr.\r\n\t\tself return: [self call: #String with: 'response.body']\r\n\t] catch: #e doing: [ self return: #nil ] ","function(self)\r\n(self):try_catch_doing_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"response\",(function()\r\nreturn ((self):call_withArguments_(\"httpSupport(self).request\",smalltalk:newArray({\"\\\"GET\\\"\", \"fileName\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_((function()\r\nreturn ((self):call_with_(\"String\",\"response.body\"))\r\nend)))\r\nend),\"e\",(function()\r\nreturn ((self):return_(\"nil\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"fileContentsStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_gt_((function()
return ((self):call_with_("length","fileName"))
end),"3"))
end),(function()
return ((self):if_return_((function()
return ((self):expr_eqeq_((function()
return ((self):send_to_("lowercase","fileName[1:4]"))
end),"\"http\""))
end),(function()
return ((self):send_with_("httpContents","fileName"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):call_with_("Base.Filesystem.isdir","fileName"))
end),(function()
return ((self):return_((function()
return ((self):send_with_("folderContents","fileName"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):call_with_("Base.Filesystem.isfile","fileName"))
end),(function()
return ((self):return_((function()
return ((self):call_withArguments_("read",smalltalk:newArray({"fileName", "String"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("nil");
return (self);
end
,"api","fileContentsStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: [self call: #length with: #fileName] gt: #3] do: [\r\n\t\tself if: [self expr: [self send: #lowercase to: 'fileName[1:4]'] eqeq: '\"http\"']\r\n\t\t\treturn: [self send: #httpContents with: #fileName]\r\n\t];cr.\r\n\tself expr: [self call: 'Base.Filesystem.isdir' with: #fileName]\r\n\t\tand: [self return: [self send: #folderContents with: #fileName]];cr.\r\n\tself expr: [self call: 'Base.Filesystem.isfile' with: #fileName]\r\n\t\tand: [self return: [self call: #read withArguments: #(fileName String)]];cr.\r\n\tself return: #nil ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_gt_((function()\r\nreturn ((self):call_with_(\"length\",\"fileName\"))\r\nend),\"3\"))\r\nend),(function()\r\nreturn ((self):if_return_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):send_to_(\"lowercase\",\"fileName[1:4]\"))\r\nend),\"\\\"http\\\"\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"httpContents\",\"fileName\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):call_with_(\"Base.Filesystem.isdir\",\"fileName\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_with_(\"folderContents\",\"fileName\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):call_with_(\"Base.Filesystem.isfile\",\"fileName\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):call_withArguments_(\"read\",smalltalk:newArray({\"fileName\", \"String\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"nil\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"fileWriteString",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("jmode",(function()
return ((self):send_to_withArguments_("replace:with:","mode",smalltalk:newArray({"\"b\"", "\"\""})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):on_with_do_((function()
return ((self):call_withArguments_("open",smalltalk:newArray({"fileName", "jmode"})))
end),"f",(function()
return ((self):call_withArguments_("write",smalltalk:newArray({"f", "contents"})))
end));
return (self);
end
,"api","fileWriteString\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #jmode to: [\r\n\t\tself send: #replace:with: to: #mode\r\n\t\t\twithArguments: #('\"b\"' '\"\"')\r\n\t];cr.\r\n\tself\ton: [self call: #open withArguments: #(fileName jmode)]\r\n\t\twith: #f do: [ self call: #write withArguments: #(f contents)] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"jmode\",(function()\r\nreturn ((self):send_to_withArguments_(\"replace:with:\",\"mode\",smalltalk:newArray({\"\\\"b\\\"\", \"\\\"\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):on_with_do_((function()\r\nreturn ((self):call_withArguments_(\"open\",smalltalk:newArray({\"fileName\", \"jmode\"})))\r\nend),\"f\",(function()\r\nreturn ((self):call_withArguments_(\"write\",smalltalk:newArray({\"f\", \"contents\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"fileInStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("contents",(function()
return ((self):send_with_("fileContents","fileName"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):send_with_("isNil:","contents"))
end),(function()
return ((self):return_((function()
return ((self):send_with_("error:",(function()
return ((self):concat_(smalltalk:newArray({"\"Missing file \"", "fileName"})))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_("fileIn","contents"))
end));
return (self);
end
,"api","fileInStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #contents to: [self send: #fileContents with: #fileName];cr.\r\n\tself expr: [self send: #isNil: with: #contents]\r\n\t\tand: [self return: [self send: #error: with: [self concat: #('\"Missing file \"' fileName)]\r\n\t\t]];cr.\r\n\tself return: [self send: #fileIn to: #contents] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"contents\",(function()\r\nreturn ((self):send_with_(\"fileContents\",\"fileName\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"contents\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_with_(\"error:\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"\\\"Missing file \\\"\", \"fileName\"})))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_(\"fileIn\",\"contents\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"emmitStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("emmit:","fileName"))
end));
return (self);
end
,"api","emmitStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #emmit: with: #fileName] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"emmit:\",\"fileName\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"fileInJSStSystemDictionary",0
,function(self)
(self):comment_("contents = fileContents(self,fileName)");
(self):comment_("isNil_(self,contents) && return error_(self,\"Missing file \" * fileName)");
(self):comment_("return Base.include_string(Main,contents,fileName)");
(self):return_((function()
return ((self):send_to_with_("Base.include","Main","fileName"))
end));
return (self);
end
,"api","fileInJSStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'contents = fileContents(self,fileName)'.\r\n\tself comment: 'isNil_(self,contents) && return error_(self,\"Missing file \" * fileName)'.\r\n\tself comment: 'return Base.include_string(Main,contents,fileName)'.\r\n\tself return: [self send: 'Base.include' to: #Main with: #fileName] ","function(self)\r\n(self):comment_(\"contents = fileContents(self,fileName)\");\r\n(self):comment_(\"isNil_(self,contents) && return error_(self,\\\"Missing file \\\" * fileName)\");\r\n(self):comment_(\"return Base.include_string(Main,contents,fileName)\");\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"Base.include\",\"Main\",\"fileName\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"exportCategoryStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("exportCategory:","aString"))
end));
return (self);
end
,"api","exportCategoryStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #exportCategory: with: #aString] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"exportCategory:\",\"aString\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"saveImageStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_("saveImage"))
end));
return (self);
end
,"api","saveImageStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #saveImage] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_(\"saveImage\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"saveImageAsStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("saveImageAs:","fileName"))
end));
return (self);
end
,"api","saveImageAsStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #saveImageAs: with: #fileName] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"saveImageAs:\",\"fileName\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"isFileOlderThanStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):not_((function()
return ((self):call_with_("Base.Filesystem.isfile","fileName"))
end)))
end),"false");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):not_((function()
return ((self):call_with_("Base.Filesystem.isfile","referenceFileName"))
end)))
end),"false");
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("note_(self,\"File timestamp matching NIY\")");
(self):return_((function()
return ((self):expr_lt_((function()
return ((self):call_with_("Base.Filesystem.mtime","fileName"))
end),(function()
return ((self):call_with_("Base.Filesystem.mtime","referenceFileName"))
end)))
end));
return (self);
end
,"api","isFileOlderThanStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self not: [self call: 'Base.Filesystem.isfile' with: #fileName]] return: #false;cr.\r\n\tself if: [self not: [self call: 'Base.Filesystem.isfile' with: #referenceFileName]] return: #false;cr.\r\n\tself comment: 'note_(self,\"File timestamp matching NIY\")'.\r\n\tself return: [self expr: [self call: 'Base.Filesystem.mtime' with: #fileName]\r\n\t\tlt: [self call: 'Base.Filesystem.mtime' with: #referenceFileName]] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):call_with_(\"Base.Filesystem.isfile\",\"fileName\"))\r\nend)))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):call_with_(\"Base.Filesystem.isfile\",\"referenceFileName\"))\r\nend)))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"note_(self,\\\"File timestamp matching NIY\\\")\");\r\n(self):return_((function()\r\nreturn ((self):expr_lt_((function()\r\nreturn ((self):call_with_(\"Base.Filesystem.mtime\",\"fileName\"))\r\nend),(function()\r\nreturn ((self):call_with_(\"Base.Filesystem.mtime\",\"referenceFileName\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"startupStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("state:","\"booting\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[\"\\$nativeLanguage\"]","\"jl\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[\"OverwriteMethods\"]","true");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[\"DumpOverwritenMethods\"]","false");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("state:","\"singularity\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Object\"", "\"Kernel\"", "StObject"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Smalltalk\"", "\"Kernel\"", "StSystemDictionary", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Behavior\"", "\"Kernel\"", "StBehavior", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Class\"", "\"Kernel\"", "StClass", "self.Behavior"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Metaclass\"", "\"Kernel\"", "StMetaclass", "self.Behavior"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"CompiledMethod\"", "\"Kernel\"", "StMethod", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Number\"", "\"Kernel\"", "Number", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"BlockClosure\"", "\"Kernel\"", "Function", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Boolean\"", "\"Kernel\"", "Bool", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("mapClassName(self,\"DateTime\",\"Kernel\",Date,self.Object)");
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"UndefinedObject\"", "\"Kernel\"", "nil", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Collection\"", "\"Kernel\"", "nil", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"SequenceableCollection\"", "\"Kernel\"", "nil", "self.Collection"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"String\"", "\"Kernel\"", "String", "self.SequenceableCollection"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Array\"", "\"Kernel\"", "nil", "self.SequenceableCollection"}));
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("mapClassName(self,\"RegularExpression\",\"Kernel\",RegExp,self.Object)");
(
function(_s8_rec)
	(_s8_rec):send_with_("state:","\"whiteHole\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_("linkNatives");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("state:","\"wormHole\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_("bindCore");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("state:","\"startup\"");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("self");
return (self);
end
,"api","startupStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #state: with: '\"booting\"';cr.\r\n\tself assign: 'self[\"\\$nativeLanguage\"]' to: '\"jl\"';cr.\r\n\tself assign: 'self[\"OverwriteMethods\"]' to: #true;cr.\r\n\tself assign: 'self[\"DumpOverwritenMethods\"]' to: #false;cr.\r\n\tself send: #state: with: '\"singularity\"';cr.\r\n\tself send: #mapClassName withArguments: #('\"Object\"' '\"Kernel\"' StObject);cr.\r\n\tself send: #mapClassName withArguments: #('\"Smalltalk\"' '\"Kernel\"' StSystemDictionary 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"Behavior\"' '\"Kernel\"' StBehavior 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"Class\"' '\"Kernel\"' StClass 'self.Behavior');cr.\r\n\tself send: #mapClassName withArguments: #('\"Metaclass\"' '\"Kernel\"' StMetaclass 'self.Behavior');cr.\r\n\tself send: #mapClassName withArguments: #('\"CompiledMethod\"' '\"Kernel\"' StMethod 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"Number\"' '\"Kernel\"' Number 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"BlockClosure\"' '\"Kernel\"' Function 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"Boolean\"' '\"Kernel\"' Bool 'self.Object');cr.\r\n\tself comment: 'mapClassName(self,\"DateTime\",\"Kernel\",Date,self.Object)'.\r\n\tself send: #mapClassName withArguments: #('\"UndefinedObject\"' '\"Kernel\"' #nil 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"Collection\"' '\"Kernel\"' #nil 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"SequenceableCollection\"' '\"Kernel\"' #nil 'self.Collection');cr.\r\n\tself send: #mapClassName withArguments: #('\"String\"' '\"Kernel\"' String 'self.SequenceableCollection');cr.\r\n\tself send: #mapClassName withArguments: #('\"Array\"' '\"Kernel\"' #nil 'self.SequenceableCollection');cr.\r\n\tself comment: 'mapClassName(self,\"RegularExpression\",\"Kernel\",RegExp,self.Object)'.\r\n\tself send: #state: with: '\"whiteHole\"';cr.\r\n\tself send: #linkNatives;cr.\r\n\tself send: #state: with: '\"wormHole\"';cr.\r\n\tself send: #bindCore;cr.\r\n\tself send: #state: with: '\"startup\"';cr.\r\n\tself return: #self ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"state:\",\"\\\"booting\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[\\\"\\\\$nativeLanguage\\\"]\",\"\\\"jl\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[\\\"OverwriteMethods\\\"]\",\"true\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[\\\"DumpOverwritenMethods\\\"]\",\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"state:\",\"\\\"singularity\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Object\\\"\", \"\\\"Kernel\\\"\", \"StObject\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Smalltalk\\\"\", \"\\\"Kernel\\\"\", \"StSystemDictionary\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Behavior\\\"\", \"\\\"Kernel\\\"\", \"StBehavior\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Class\\\"\", \"\\\"Kernel\\\"\", \"StClass\", \"self.Behavior\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Metaclass\\\"\", \"\\\"Kernel\\\"\", \"StMetaclass\", \"self.Behavior\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"CompiledMethod\\\"\", \"\\\"Kernel\\\"\", \"StMethod\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Number\\\"\", \"\\\"Kernel\\\"\", \"Number\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"BlockClosure\\\"\", \"\\\"Kernel\\\"\", \"Function\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Boolean\\\"\", \"\\\"Kernel\\\"\", \"Bool\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"mapClassName(self,\\\"DateTime\\\",\\\"Kernel\\\",Date,self.Object)\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"UndefinedObject\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Collection\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"SequenceableCollection\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Collection\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"String\\\"\", \"\\\"Kernel\\\"\", \"String\", \"self.SequenceableCollection\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Array\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.SequenceableCollection\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"mapClassName(self,\\\"RegularExpression\\\",\\\"Kernel\\\",RegExp,self.Object)\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"state:\",\"\\\"whiteHole\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_(\"linkNatives\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"state:\",\"\\\"wormHole\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_(\"bindCore\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"state:\",\"\\\"startup\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"niyStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("text",(function()
return ((self):concat_(smalltalk:newArray({"\"NIY - \"", "string(Base.stacktrace()[2])"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_with_("println","text");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("text");
return (self);
end
,"api","niyStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #text to: [self concat: #('\"NIY - \"' 'string(Base.stacktrace()[2])')];cr.\r\n\tself call: #println with: #text;cr.\r\n\tself return: #text ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"text\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"\\\"NIY - \\\"\", \"string(Base.stacktrace()[2])\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"println\",\"text\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"text\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"niy_StSystemDictionary",0
,function(self)
(self):call_with_("println",(function()
return ((self):call_with_("string",(function()
return ((self):concat_(smalltalk:newArray({"\"NIY #\"", "msg"})))
end)))
end));
return (self);
end
,"api","niy_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself call: #println with: [self call: #string\r\n\t\twith: [self concat: #('\"NIY #\"'  msg)]] ","function(self)\r\n(self):call_with_(\"println\",(function()\r\nreturn ((self):call_with_(\"string\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"\\\"NIY #\\\"\", \"msg\"})))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"linkNativesStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("theMetaclass","self[\"Metaclass\"]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("cls",(function()
return ((self):send_("nativeClasses"))
end),(function()
return ((self):if_do_((function()
return ((self):expr_eqeq_((function()
return ((self):object_at_((function()
return ((self):send_with_("classOf:","cls"))
end),"\"\\$klass\""))
end),"nil"))
end),(function()
(self):comment_("println(\"Linking \",classOf_(self,cls)[\"\\$className\"])");return ((self):assign_to_((function()
return ((self):object_at_((function()
return ((self):send_with_("classOf:","cls"))
end),"\"\\$klass\""))
end),"theMetaclass"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_((function()
return ((self):object_at_((function()
return ((self):send_with_("classOf:","self.Object"))
end),"\"\\$superclass\""))
end),"self.Class");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("true");
return (self);
end
,"api","linkNativesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #theMetaclass to: 'self[\"Metaclass\"]';cr.\r\n\tself for: #cls in: [self send: #nativeClasses] do: [\r\n\t\tself if: [self expr: [self object: [self send: #classOf: with: #cls] at: '\"\\$klass\"'] eqeq: #nil] do: [\r\n\t\t\tself comment: 'println(\"Linking \",classOf_(self,cls)[\"\\$className\"])'.\r\n\t\t\tself assign: [self object: [self send: #classOf: with: #cls] at: '\"\\$klass\"'] to: #theMetaclass\r\n\t\t]\r\n\t];cr.\r\n\tself assign: [self object: [self send: #classOf: with: 'self.Object'] at: '\"\\$superclass\"'] to: 'self.Class';cr.\r\n\tself return: #true ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"theMetaclass\",\"self[\\\"Metaclass\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"cls\",(function()\r\nreturn ((self):send_(\"nativeClasses\"))\r\nend),(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):object_at_((function()\r\nreturn ((self):send_with_(\"classOf:\",\"cls\"))\r\nend),\"\\\"\\\\$klass\\\"\"))\r\nend),\"nil\"))\r\nend),(function()\r\n(self):comment_(\"println(\\\"Linking \\\",classOf_(self,cls)[\\\"\\\\$className\\\"])\");return ((self):assign_to_((function()\r\nreturn ((self):object_at_((function()\r\nreturn ((self):send_with_(\"classOf:\",\"cls\"))\r\nend),\"\\\"\\\\$klass\\\"\"))\r\nend),\"theMetaclass\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_((function()\r\nreturn ((self):object_at_((function()\r\nreturn ((self):send_with_(\"classOf:\",\"self.Object\"))\r\nend),\"\\\"\\\\$superclass\\\"\"))\r\nend),\"self.Class\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"true\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"bindCoreStSystemDictionary",0
,function(self)
(self):comment_("--bind the minimal functions(e.g i/o)");
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_eqeq_("self[\"\\$imageFileName\"]","nil"))
end),(function()
return ((self):assign_to_("self[\"\\$imageFileName\"]",(function()
return ((self):concat_(smalltalk:newArray({"\"s8.image.\"", "self[\"\\$nativeLanguage\"]"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("true");
return (self);
end
,"api","bindCoreStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: '--bind the minimal functions(e.g i/o)'.\r\n\tself if: [self expr: 'self[\"\\$imageFileName\"]' eqeq: #nil] do: [\r\n\t\tself assign: 'self[\"\\$imageFileName\"]' to: [self concat: #('\"s8.image.\"' 'self[\"\\$nativeLanguage\"]')]\r\n\t];cr.\r\n\tself return: #true ","function(self)\r\n(self):comment_(\"--bind the minimal functions(e.g i/o)\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"self[\\\"\\\\$imageFileName\\\"]\",\"nil\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"self[\\\"\\\\$imageFileName\\\"]\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"\\\"s8.image.\\\"\", \"self[\\\"\\\\$nativeLanguage\\\"]\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"true\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"invalidMessage_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):call_with_("error",(function()
return ((self):concat_(smalltalk:newArray({"\"Invalid message @\"", "string(Base.stacktrace()[2])"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):call_with_("error",(function()
return ((self):concat_(smalltalk:newArray({"\"Invalid message #\"", "msg"})))
end));
return (self);
end
,"api","invalidMessage_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself call: #error with: [self concat: #('\"Invalid message @\"' 'string(Base.stacktrace()[2])')];cr.\r\n\tself call: #error with: [self concat: #('\"Invalid message #\"' msg)] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"error\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"\\\"Invalid message @\\\"\", \"string(Base.stacktrace()[2])\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):call_with_(\"error\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"\\\"Invalid message #\\\"\", \"msg\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"obsoleteStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("text",(function()
return ((self):concat_(smalltalk:newArray({"\"OBSOLETE - \"", "string(Base.stacktrace()[2])"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_with_("println","text");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("text");
return (self);
end
,"api","obsoleteStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #text to: [self concat: #('\"OBSOLETE - \"' 'string(Base.stacktrace()[2])')];cr.\r\n\tself call: #println with: #text;cr.\r\n\tself return: #text ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"text\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"\\\"OBSOLETE - \\\"\", \"string(Base.stacktrace()[2])\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"println\",\"text\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"text\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"linkNative_to_StSystemDictionary",0
,function(self)
(self):comment_("link native species of instance to delegate to aClass implementation");
(self):send_("obsolete");
return (self);
end
,"api","linkNative_to_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'link native species of instance to delegate to aClass implementation'.\r\n\tself send: #obsolete ","function(self)\r\n(self):comment_(\"link native species of instance to delegate to aClass implementation\");\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"newConstructorStSystemDictionary",0
,function(self)
(self):send_("obsolete");
return (self);
end
,"api","newConstructorStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #obsolete ","function(self)\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"will_be_StSystemDictionary",0
,function(self)
(self):send_("obsolete");
return (self);
end
,"api","will_be_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #obsolete ","function(self)\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"newArrayStSystemDictionary",0
,function(self)
(self):comment_("return a new Array instance with contents in object");
(
function(_s8_rec)
	(_s8_rec):assign_to_("contents",(function()
return ((self):valueIf_do_else_((function()
return ((self):send_with_("isNil:","object"))
end),(function()
return ((self):emptyArray())
end),"object"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_with_("nativeNew:","self.Array","contents"))
end));
return (self);
end
,"api","newArrayStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'return a new Array instance with contents in object'.\r\n\tself assign: #contents to: [self\r\n\t\tvalueIf: [self send: #isNil: with: #object]\r\n\t\tdo: [self emptyArray]\r\n\t\telse: #object];cr.\r\n\tself return: [self send: #nativeNew: to: 'self.Array' with: #contents] ","function(self)\r\n(self):comment_(\"return a new Array instance with contents in object\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"contents\",(function()\r\nreturn ((self):valueIf_do_else_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"object\"))\r\nend),(function()\r\nreturn ((self):emptyArray())\r\nend),\"object\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"nativeNew:\",\"self.Array\",\"contents\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"newArrayOfSizeStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("newArray","Array{Any}(nothing,size)"))
end));
return (self);
end
,"api","newArrayOfSizeStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #newArray with: 'Array{Any}(nothing,size)'] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"newArray\",\"Array{Any}(nothing,size)\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"arrayAdaptStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_and_((function()
return ((self):expr_isa_("cookie",(function()
return ((self):call_with_("eltype",(function()
return ((self):send_to_("handle","array"))
end)))
end)))
end),(function()
return ((self):return_("array"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):assign_to_("array.dict[\"@handle\"]",(function()
return ((self):call_withArguments_("convert",(smalltalk.Array):with_with_("Array{Any,1}",(function()
return ((self):send_to_("handle","array"))
end))))
end));
return (self);
end
,"api","arrayAdaptStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self expr: #cookie isa: [\r\n\t\tself call: #eltype with: [self send: #handle to: #array]]]\r\n\t\tand: [self return: #array];cr.\r\n\tself assign: 'array.dict[\"@handle\"]' to: [self call: #convert withArguments: (Array\r\n\t\twith: 'Array{Any,1}' with: [self send: #handle to: #array])] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_and_((function()\r\nreturn ((self):expr_isa_(\"cookie\",(function()\r\nreturn ((self):call_with_(\"eltype\",(function()\r\nreturn ((self):send_to_(\"handle\",\"array\"))\r\nend)))\r\nend)))\r\nend),(function()\r\nreturn ((self):return_(\"array\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):assign_to_(\"array.dict[\\\"@handle\\\"]\",(function()\r\nreturn ((self):call_withArguments_(\"convert\",(smalltalk.Array):with_with_(\"Array{Any,1}\",(function()\r\nreturn ((self):send_to_(\"handle\",\"array\"))\r\nend))))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"arrayPackStSystemDictionary",0
,function(self)
(self):comment_("currently disabled to avoid issues adding objects of other types than contents");
(self):comment_("array.dict[\"@handle\"] = [ x for x in handle(array) ]");
return (self);
end
,"api","arrayPackStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'currently disabled to avoid issues adding objects of other types than contents'.\r\n\tself comment: 'array.dict[\"@handle\"] = [ x for x in handle(array) ]' ","function(self)\r\n(self):comment_(\"currently disabled to avoid issues adding objects of other types than contents\");\r\n(self):comment_(\"array.dict[\\\"@handle\\\"] = [ x for x in handle(array) ]\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"become_a_StSystemDictionary",0
,function(self)
(self):send_("obsolete");
return (self);
end
,"api","become_a_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #obsolete ","function(self)\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"setProtoOf_to_StSystemDictionary",0
,function(self)
(self):send_("obsolete");
return (self);
end
,"api","setProtoOf_to_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #obsolete ","function(self)\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"klassStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):call_with_("println",(function()
return ((self):sum_(smalltalk:newArray({"\"OBSOLETE - klass \"", "spec.className"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):send_("obsolete");
return (self);
end
,"api","klassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself call: #println with: [self sum: #('\"OBSOLETE - klass \"' 'spec.className')];cr.\r\n\tself send: #obsolete ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"println\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"\\\"OBSOLETE - klass \\\"\", \"spec.className\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"globalScopeStSystemDictionary",0
,function(self)
(self):comment_("Returns an object to access global scope");
(self):return_((function()
return ((self):call_("S8GlobalScope"))
end));
return (self);
end
,"api","globalScopeStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Returns an object to access global scope'.\r\n\tself return: [self call: #S8GlobalScope] ","function(self)\r\n(self):comment_(\"Returns an object to access global scope\");\r\n(self):return_((function()\r\nreturn ((self):call_(\"S8GlobalScope\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"__f__StSystemDictionary",0
,function(self)
(self):send_("obsolete");
return (self);
end
,"api","__f__StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #obsolete ","function(self)\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"__b__StSystemDictionary",0
,function(self)
(self):send_("obsolete");
return (self);
end
,"api","__b__StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #obsolete ","function(self)\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"stacktraceStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("newArray",(function()
return ((self):call_("Base.stacktrace"))
end)))
end));
return (self);
end
,"api","stacktraceStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #newArray with: [self call: 'Base.stacktrace']] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"newArray\",(function()\r\nreturn ((self):call_(\"Base.stacktrace\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"datesSupportStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):call_with_("eval",(function()
return ((self):call_with_("Meta.parse","\"using Dates; Dates\""))
end)))
end));
return (self);
end
,"api","datesSupportStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self call: #eval with: [self call: 'Meta.parse' with: '\"using Dates; Dates\"']] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"eval\",(function()\r\nreturn ((self):call_with_(\"Meta.parse\",\"\\\"using Dates; Dates\\\"\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"block_valueWithPossibleArguments_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("count",(function()
return ((self):send_to_("argumentCount","block"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeq_("count","0"))
end),(function()
return ((self):call_("block"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeq_("count",(function()
return ((self):send_to_("length","args"))
end)))
end),(function()
return ((self):call_with_("block","args..."))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):expr_gt_((function()
return ((self):send_to_("length","args"))
end),"count"))
end),(function()
return ((self):assign_to_("params","@view args[1:count]"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("params",(function()
return ((self):call_withArguments_("convert",smalltalk:newArray({"Array{Any,1}", "args"})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):while_do_((function()
return ((self):expr_lt_((function()
return ((self):send_to_("length","params"))
end),"count"))
end),(function()
return ((self):send_to_with_("push!","params","nil"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_with_("block","params..."))
end));
return (self);
end
,"api","block_valueWithPossibleArguments_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #count to: [self send: #argumentCount to: #block];cr.\r\n\tself if: [self expr: #count eqeq: #0] return: [self call: #block];cr.\r\n\tself if: [self expr: #count eqeq: [self send: #length to: #args]] return: [self call: #block with: 'args...'];cr.\r\n\tself if: [self expr: [self send: #length to: #args] gt: #count] do: [\r\n\t\tself assign: #params to: '@view args[1:count]'\r\n\t] else: [\r\n\t\tself assign: #params to: [self call: #convert withArguments: #('Array{Any,1}' args)];cr.\r\n\t\tself while: [self expr: [self send: #length to: #params] lt: #count]\r\n\t\t\tdo: [ self send: 'push!' to: #params with: #nil ]\r\n\t];cr.\r\n\tself return: [self call: #block with: 'params...'] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"count\",(function()\r\nreturn ((self):send_to_(\"argumentCount\",\"block\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"count\",\"0\"))\r\nend),(function()\r\nreturn ((self):call_(\"block\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"count\",(function()\r\nreturn ((self):send_to_(\"length\",\"args\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):call_with_(\"block\",\"args...\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):expr_gt_((function()\r\nreturn ((self):send_to_(\"length\",\"args\"))\r\nend),\"count\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"params\",\"@view args[1:count]\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"params\",(function()\r\nreturn ((self):call_withArguments_(\"convert\",smalltalk:newArray({\"Array{Any,1}\", \"args\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):while_do_((function()\r\nreturn ((self):expr_lt_((function()\r\nreturn ((self):send_to_(\"length\",\"params\"))\r\nend),\"count\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"push!\",\"params\",\"nil\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"block\",\"params...\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"block_argumentCountStSystemDictionary",0
,function(self)
(self):comment_("println(\"Block \",block,\" argumentCount=\",methods(block).ms[1].nargs - 1)");
(self):return_((function()
return ((self):prev_("methods(block).ms[1].nargs"))
end));
return (self);
end
,"api","block_argumentCountStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'println(\"Block \",block,\" argumentCount=\",methods(block).ms[1].nargs - 1)'.\r\n\tself return: [self prev: 'methods(block).ms[1].nargs'] ","function(self)\r\n(self):comment_(\"println(\\\"Block \\\",block,\\\" argumentCount=\\\",methods(block).ms[1].nargs - 1)\");\r\n(self):return_((function()\r\nreturn ((self):prev_(\"methods(block).ms[1].nargs\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"pool_keyStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_isa_("h","Dict"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_isa_("h","Dict{Symbol,Any}"))
end),(function()
return ((self):symbol_("k"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_return_((function()
return ((self):expr_isa_("h","Dict{String,Any}"))
end),(function()
return ((self):call_with_("string","k"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_with_("string","k"))
end));
return (self);
end
,"api","pool_keyStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: #h isa: #Dict] do: [\r\n\t\tself if: [self expr: #h isa: 'Dict{Symbol,Any}'] return: [self symbol: #k];cr.\r\n\t\tself if: [self expr: #h isa: 'Dict{String,Any}'] return: [self call: #string with: #k]\r\n\t];cr.\r\n\tself return: [self call: #string with: #k] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_isa_(\"h\",\"Dict\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_isa_(\"h\",\"Dict{Symbol,Any}\"))\r\nend),(function()\r\nreturn ((self):symbol_(\"k\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_return_((function()\r\nreturn ((self):expr_isa_(\"h\",\"Dict{String,Any}\"))\r\nend),(function()\r\nreturn ((self):call_with_(\"string\",\"k\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"string\",\"k\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"pool_at_put_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("h","pool[\"@hash\"]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("k",(function()
return ((self):send_withArguments_("pool_key",(smalltalk.Array):with_with_("h",(function()
return ((self):send_to_with_("wrap:","pool","aKey"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("v",(function()
return ((self):send_to_with_("wrap:","pool","aValue"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("h[k]","v");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("aValue");
return (self);
end
,"api","pool_at_put_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #h to: 'pool[\"@hash\"]';cr.\r\n\tself assign: #k to: [self send: #pool_key withArguments: (Array\r\n\t\twith: #h with: [self send: #wrap: to: #pool with: #aKey])];cr.\r\n\tself assign: #v to: [self send: #wrap: to: #pool with: #aValue];cr.\r\n\tself assign: 'h[k]' to: #v;cr.\r\n\tself return: #aValue ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",\"pool[\\\"@hash\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"k\",(function()\r\nreturn ((self):send_withArguments_(\"pool_key\",(smalltalk.Array):with_with_(\"h\",(function()\r\nreturn ((self):send_to_with_(\"wrap:\",\"pool\",\"aKey\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"v\",(function()\r\nreturn ((self):send_to_with_(\"wrap:\",\"pool\",\"aValue\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h[k]\",\"v\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"aValue\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"pool_removeKey_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("h","pool[\"@hash\"]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("k",(function()
return ((self):send_to_with_("wrap:","pool","aKey"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_isa_("h","StObject"))
end),(function()
return ((self):assign_to_("h","h.dict"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_do_else_((function()
return ((self):expr_isa_("h","Dict"))
end),(function()
return ((self):send_to_with_("delete!","h",(function()
return ((self):send_withArguments_("pool_key",smalltalk:newArray({"h", "k"})))
end)))
end),(function()
return ((self):assign_to_("h[k]","nil"))
end));
return (self);
end
,"api","pool_removeKey_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #h to: 'pool[\"@hash\"]';cr.\r\n\tself assign: #k to: [self send: #wrap: to: #pool with: #aKey];cr.\r\n\tself if: [self expr: #h isa: #StObject] do: [\r\n\t\tself assign: #h to: 'h.dict'\r\n\t];cr.\r\n\tself if: [self expr: #h isa: #Dict] do: [\r\n\t\tself send: 'delete!' to: #h with: [\r\n\t\t\tself send: #pool_key withArguments: #(h k)\r\n\t\t]\r\n\t] else: [\r\n\t\tself assign: 'h[k]' to: #nil\r\n\t] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",\"pool[\\\"@hash\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"k\",(function()\r\nreturn ((self):send_to_with_(\"wrap:\",\"pool\",\"aKey\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_isa_(\"h\",\"StObject\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"h\",\"h.dict\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_do_else_((function()\r\nreturn ((self):expr_isa_(\"h\",\"Dict\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"delete!\",\"h\",(function()\r\nreturn ((self):send_withArguments_(\"pool_key\",smalltalk:newArray({\"h\", \"k\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"h[k]\",\"nil\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"pool_at_ifAbsent_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("h","pool[\"@hash\"]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("k",(function()
return ((self):send_withArguments_("pool_key",(smalltalk.Array):with_with_("h",(function()
return ((self):send_to_with_("wrap:","pool","aKey"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("found","nil");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):try_catch_doing_((function()
return ((self):if_do_else_((function()
return ((self):expr_isa_("h","Dict"))
end),(function()
return ((self):assign_to_("found",(function()
return ((self):call_withArguments_("get",smalltalk:newArray({"h", "k", "nil"})))
end)))
end),(function()
return ((self):assign_to_("found","h[k]"))
end)))
end),"",(function()
return (nil)
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_do_else_((function()
return ((self):expr_noteq_("found","nil"))
end),(function()
return ((self):return_((function()
return ((self):send_to_with_("unwrap:","pool","found"))
end)))
end),(function()
return ((self):return_((function()
return ((self):send_to_("evaluate","aBlock"))
end)))
end));
return (self);
end
,"api","pool_at_ifAbsent_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #h to: 'pool[\"@hash\"]';cr.\r\n\tself assign: #k to: [self send: #pool_key withArguments: (Array\r\n\t\twith: #h with: [self send: #wrap: to: #pool with: #aKey])];cr.\r\n\tself assign: #found to: #nil;cr.\r\n\tself try: [\r\n\t\tself if: [self expr: #h isa: #Dict] do: [\r\n\t\t\tself assign: #found to: [self call: #get withArguments: #(h k #nil)]\r\n\t\t] else: [self assign: #found to: 'h[k]']\r\n\t] catch: '' doing: [];cr.\r\n\tself if: [self expr: #found noteq: #nil] do: [\r\n\t\tself return: [self send: #unwrap: to: #pool with: #found]\r\n\t] else: [self return: [self send: #evaluate to: #aBlock]] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",\"pool[\\\"@hash\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"k\",(function()\r\nreturn ((self):send_withArguments_(\"pool_key\",(smalltalk.Array):with_with_(\"h\",(function()\r\nreturn ((self):send_to_with_(\"wrap:\",\"pool\",\"aKey\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"found\",\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):try_catch_doing_((function()\r\nreturn ((self):if_do_else_((function()\r\nreturn ((self):expr_isa_(\"h\",\"Dict\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"found\",(function()\r\nreturn ((self):call_withArguments_(\"get\",smalltalk:newArray({\"h\", \"k\", \"nil\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"found\",\"h[k]\"))\r\nend)))\r\nend),\"\",(function()\r\nreturn (nil)\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_do_else_((function()\r\nreturn ((self):expr_noteq_(\"found\",\"nil\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_with_(\"unwrap:\",\"pool\",\"found\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_(\"evaluate\",\"aBlock\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"pool_includesKey_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("h","pool[\"@hash\"]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("k",(function()
return ((self):send_withArguments_("pool_key",(smalltalk.Array):with_with_("h",(function()
return ((self):send_to_with_("wrap:","pool","aKey"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_return_((function()
return ((self):expr_isa_("h","Dict"))
end),(function()
return ((self):call_withArguments_("haskey",smalltalk:newArray({"h", "k"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_return_((function()
return ((self):call_withArguments_("haskey",smalltalk:newArray({"h.dict", "k"})))
end),(function()
return ((self):expr_noteq_("h.dict[k]","nil"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("false");
return (self);
end
,"api","pool_includesKey_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #h to: 'pool[\"@hash\"]';cr.\r\n\tself assign: #k to: [self send: #pool_key withArguments: (Array\r\n\t\twith: #h with: [ self send: #wrap: to: #pool with: #aKey])];cr.\r\n\tself expr: [self expr: #h isa: #Dict]\r\n\t\treturn: [self call: #haskey withArguments: #(h k)];cr.\r\n\tself expr: [self call: #haskey withArguments: #('h.dict' k)]\r\n\t\treturn: [self expr: 'h.dict[k]' noteq: #nil];cr.\r\n\tself return: #false ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",\"pool[\\\"@hash\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"k\",(function()\r\nreturn ((self):send_withArguments_(\"pool_key\",(smalltalk.Array):with_with_(\"h\",(function()\r\nreturn ((self):send_to_with_(\"wrap:\",\"pool\",\"aKey\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_return_((function()\r\nreturn ((self):expr_isa_(\"h\",\"Dict\"))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"haskey\",smalltalk:newArray({\"h\", \"k\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_return_((function()\r\nreturn ((self):call_withArguments_(\"haskey\",smalltalk:newArray({\"h.dict\", \"k\"})))\r\nend),(function()\r\nreturn ((self):expr_noteq_(\"h.dict[k]\",\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"false\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"pool_keysStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("h","pool[\"@hash\"]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_isa_("h","StObject"))
end),(function()
return ((self):assign_to_("h","h.dict"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_with_("newArray","smalltalk",(function()
return ((self):call_with_("collect",(function()
return ((self):call_with_("Base.keys","h"))
end)))
end)))
end));
return (self);
end
,"api","pool_keysStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #h to: 'pool[\"@hash\"]';cr.\r\n\tself if: [self expr: #h isa: #StObject] do: [\r\n\t\tself assign: #h to: 'h.dict'\r\n\t];cr.\r\n\tself return: [self send: #newArray to: #smalltalk with: [\r\n\t\tself call: #collect with: [\r\n\t\tself call: 'Base.keys' with: #h]]] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",\"pool[\\\"@hash\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_isa_(\"h\",\"StObject\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"h\",\"h.dict\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"newArray\",\"smalltalk\",(function()\r\nreturn ((self):call_with_(\"collect\",(function()\r\nreturn ((self):call_with_(\"Base.keys\",\"h\"))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"string_toNumberStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_return_((function()
return ((self):expr_noteqeq_((function()
return ((self):call_withArguments_("findfirst",smalltalk:newArray({"\".\"", "aString"})))
end),"nothing"))
end),(function()
return ((self):call_withArguments_("parse",smalltalk:newArray({"Float64", "aString"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_withArguments_("parse",smalltalk:newArray({"Int64", "aString"})))
end));
return (self);
end
,"api","string_toNumberStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self expr: [self call: #findfirst withArguments: #('\".\"' aString)] noteqeq: #nothing]\r\n\t\treturn: [self call: #parse withArguments: #(Float64 aString)];cr.\r\n\tself return: [self call: #parse withArguments: #(Int64 aString)] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_return_((function()\r\nreturn ((self):expr_noteqeq_((function()\r\nreturn ((self):call_withArguments_(\"findfirst\",smalltalk:newArray({\"\\\".\\\"\", \"aString\"})))\r\nend),\"nothing\"))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"parse\",smalltalk:newArray({\"Float64\", \"aString\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_withArguments_(\"parse\",smalltalk:newArray({\"Int64\", \"aString\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"string_copyFrom_to_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):expr_return_((function()
return ((self):expr_gt_("fromIndex","toIndex"))
end),"\"\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("fromIndex",(function()
return ((self):call_withArguments_("Base.max",smalltalk:newArray({"fromIndex", "1"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("toIndex",(function()
return ((self):call_withArguments_("Base.min",(smalltalk.Array):with_with_("toIndex",(function()
return ((self):send_to_("size","aString"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):object_at_("aString",(function()
return ((self):from_to_("fromIndex","toIndex"))
end)))
end));
return (self);
end
,"api","string_copyFrom_to_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself expr: [self expr: #fromIndex gt: #toIndex]\r\n\t\treturn: '\"\"';cr.\r\n\tself assign: #fromIndex to: [self call: 'Base.max' withArguments: #(fromIndex #1)];cr.\r\n\tself assign: #toIndex to: [self call: 'Base.min' withArguments: (Array\r\n\t\twith: #toIndex with: [self send: #size to: #aString])];cr.\r\n\tself return: [self object: #aString at: [self from: #fromIndex to: #toIndex]] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_return_((function()\r\nreturn ((self):expr_gt_(\"fromIndex\",\"toIndex\"))\r\nend),\"\\\"\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"fromIndex\",(function()\r\nreturn ((self):call_withArguments_(\"Base.max\",smalltalk:newArray({\"fromIndex\", \"1\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"toIndex\",(function()\r\nreturn ((self):call_withArguments_(\"Base.min\",(smalltalk.Array):with_with_(\"toIndex\",(function()\r\nreturn ((self):send_to_(\"size\",\"aString\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):object_at_(\"aString\",(function()\r\nreturn ((self):from_to_(\"fromIndex\",\"toIndex\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"testExpressions",0
,function(self)
return ((self):encode_((function()
(self):comment_("-------------------------------------------------------------------------------------");(
function(_s8_rec)
	(_s8_rec):call_with_("println","\"boot(.jl) section for testing support - Installing...\"");
	return ((_s8_rec):cr())
end
)(self);(self):comment_("o = basicNewInstance_(smalltalk.Object)");(self):comment_("p = basicNewInstance_(smalltalk.Point); x_(p,3);y_(p,4); x(p)+y(p)==7");(self):implementClass_api_("StSystemDictionary",smalltalk:newArray({"halt() = halt(basicNewInstance_(smalltalk.Object))", "testAll() = testAll(smalltalk)", "test(i) = test(smalltalk,i)", "t() = testFrom(smalltalk,1)", "t(i) = t(smalltalk,i)", "testFrom(i) = testFrom(smalltalk,i)", "testFrom(i,j) = testFrom(smalltalk,i,j)", "testAll", smalltalk:newArray({"test", smalltalk:newArray({"what"})}), smalltalk:newArray({"testFrom", smalltalk:newArray({"first", "last=1000"})}), smalltalk:newArray({"t", smalltalk:newArray({"number"})})}));(self):bind_arguments_doing_("src",smalltalk:newArray({"aClass::StBehavior", "selector"}),(function()
return ((self):perform_("srcStBehavior"))
end));return ((self):cr())
end)));
end
,"contents","testExpressions\r\n\t\" Private - Return the encoding for testing expressions. \"\r\n\r\n\t^self encode: [\r\n\t\tself comment: '-------------------------------------------------------------------------------------'.\r\n\t\tself call: #println with: '\"boot(.jl) section for testing support - Installing...\"';cr.\r\n\t\tself comment: 'o = basicNewInstance_(smalltalk.Object)'.\r\n\t\tself comment: 'p = basicNewInstance_(smalltalk.Point); x_(p,3);y_(p,4); x(p)+y(p)==7'.\r\n\t\tself implementClass: #StSystemDictionary api: #(\r\n\t\t\t'halt() = halt(basicNewInstance_(smalltalk.Object))'\r\n\t\t\t'testAll() = testAll(smalltalk)'\r\n\t\t\t'test(i) = test(smalltalk,i)'\r\n\t\t\t't() = testFrom(smalltalk,1)'\r\n\t\t\t't(i) = t(smalltalk,i)'\r\n\t\t\t'testFrom(i) = testFrom(smalltalk,i)'\r\n\t\t\t'testFrom(i,j) = testFrom(smalltalk,i,j)'\r\n\t\t\ttestAll\r\n\t\t\t#(test #(what))\r\n\t\t\t#(testFrom #(first 'last=1000'))\r\n\t\t\t#(t #(number))\r\n\t\t).\r\n\t\tself\tbind: #src\r\n\t\t\targuments: #('aClass::StBehavior' selector)\r\n\t\t\tdoing: [ self perform: #srcStBehavior ].\r\n\t\tself cr.\r\n\t]","function(self)\r\nreturn ((self):encode_((function()\r\n(self):comment_(\"-------------------------------------------------------------------------------------\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"println\",\"\\\"boot(.jl) section for testing support - Installing...\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"o = basicNewInstance_(smalltalk.Object)\");(self):comment_(\"p = basicNewInstance_(smalltalk.Point); x_(p,3);y_(p,4); x(p)+y(p)==7\");(self):implementClass_api_(\"StSystemDictionary\",smalltalk:newArray({\"halt() = halt(basicNewInstance_(smalltalk.Object))\", \"testAll() = testAll(smalltalk)\", \"test(i) = test(smalltalk,i)\", \"t() = testFrom(smalltalk,1)\", \"t(i) = t(smalltalk,i)\", \"testFrom(i) = testFrom(smalltalk,i)\", \"testFrom(i,j) = testFrom(smalltalk,i,j)\", \"testAll\", smalltalk:newArray({\"test\", smalltalk:newArray({\"what\"})}), smalltalk:newArray({\"testFrom\", smalltalk:newArray({\"first\", \"last=1000\"})}), smalltalk:newArray({\"t\", smalltalk:newArray({\"number\"})})}));(self):bind_arguments_doing_(\"src\",smalltalk:newArray({\"aClass::StBehavior\", \"selector\"}),(function()\r\nreturn ((self):perform_(\"srcStBehavior\"))\r\nend));return ((self):cr())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"srcStBehavior",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("mth","aClass[\"\\$methods\"][string(selector)]");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("mth[\"\\$nativeSource\"]");
return (self);
end
,"api","srcStBehavior\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #mth to: 'aClass[\"\\$methods\"][string(selector)]';cr.\r\n\tself return: 'mth[\"\\$nativeSource\"]' ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"mth\",\"aClass[\\\"\\\\$methods\\\"][string(selector)]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"mth[\\\"\\\\$nativeSource\\\"]\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"testAllStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("o",(function()
return ((self):send_to_("basicNewInstance:","self.Object"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_("testAll","o"))
end));
return (self);
end
,"api","testAllStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #o to: [self send: #basicNewInstance: to: 'self.Object'];cr.\r\n\tself return: [self send: #testAll to: #o] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"o\",(function()\r\nreturn ((self):send_to_(\"basicNewInstance:\",\"self.Object\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_(\"testAll\",\"o\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"testStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("o",(function()
return ((self):send_to_("basicNewInstance:","self.Object"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("selector",(function()
return ((self):symbol_((function()
return ((self):concat_(smalltalk:newArray({"\"test\"", "string(what)"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("mth",(function()
return ((self):send_to_withArguments_("basic:at:","smalltalk",(smalltalk.Array):with_with_((function()
return ((self):call_with_("class","o"))
end),"selector")))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):expr_return_((function()
return ((self):send_with_("isNil:","mth"))
end),"false");
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("println(\"test\",what)");
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):send_to_("mth","o"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("println",smalltalk:newArray({"\"test\"", "what", "\"  FAILED\""}));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("true"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("true");
return (self);
end
,"api","testStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #o to: [self send: #basicNewInstance: to: 'self.Object'];cr.\r\n\tself assign: #selector to: [self symbol: [self concat: #('\"test\"' 'string(what)')]];cr.\r\n\tself assign: #mth to: [self send: #basic:at: to: #smalltalk withArguments: (Array\r\n\t\twith: [self call: #class with: #o] with: #selector)];cr.\r\n\tself expr: [self send: #isNil: with: #mth] return: #false;cr.\r\n\tself comment: 'println(\"test\",what)'.\r\n\tself if: [self not: [self send: #mth to: #o]] do: [\r\n\t\tself call: #println withArguments: #('\"test\"' what '\"  FAILED\"');cr.\r\n\t\tself return: #true\r\n\t];cr.\r\n\tself return: #true ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"o\",(function()\r\nreturn ((self):send_to_(\"basicNewInstance:\",\"self.Object\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"selector\",(function()\r\nreturn ((self):symbol_((function()\r\nreturn ((self):concat_(smalltalk:newArray({\"\\\"test\\\"\", \"string(what)\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"mth\",(function()\r\nreturn ((self):send_to_withArguments_(\"basic:at:\",\"smalltalk\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):call_with_(\"class\",\"o\"))\r\nend),\"selector\")))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expr_return_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"mth\"))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"println(\\\"test\\\",what)\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_to_(\"mth\",\"o\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"println\",smalltalk:newArray({\"\\\"test\\\"\", \"what\", \"\\\"  FAILED\\\"\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"true\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"true\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"testFromStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):for_from_to_do_("i","first","last",(function()
return ((self):try_catch_doing_((function()
return ((self):send_with_("test","i"))
end),"e",(function()
return ((self):call_withArguments_("println",smalltalk:newArray({"\"Error in test\"", "i", "\" - \"", "e"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):call_withArguments_("println",smalltalk:newArray({"\"testFrom\"", "first", "\" to \"", "last", "\" complete\""}));
return (self);
end
,"api","testFromStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself for: #i from: #first to: #last do: [\r\n\t\tself try: [\r\n\t\t\tself send: #test with: #i\r\n\t\t] catch: #e doing: [\r\n\t\t\tself call: #println withArguments: #('\"Error in test\"' i '\" - \"' e)\r\n\t\t]\r\n\t];cr.\r\n\tself call: #println withArguments: #('\"testFrom\"' first '\" to \"' last '\" complete\"') ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_from_to_do_(\"i\",\"first\",\"last\",(function()\r\nreturn ((self):try_catch_doing_((function()\r\nreturn ((self):send_with_(\"test\",\"i\"))\r\nend),\"e\",(function()\r\nreturn ((self):call_withArguments_(\"println\",smalltalk:newArray({\"\\\"Error in test\\\"\", \"i\", \"\\\" - \\\"\", \"e\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):call_withArguments_(\"println\",smalltalk:newArray({\"\\\"testFrom\\\"\", \"first\", \"\\\" to \\\"\", \"last\", \"\\\" complete\\\"\"}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.JuliaBoot,"tStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("o",(function()
return ((self):send_to_("basicNewInstance:","self.Object"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("selector",(function()
return ((self):concat_(smalltalk:newArray({"\"test\"", "string(number)"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("mth","class(o)[\"\\$methods\"][string(selector)]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_with_("println","mth[\"\\$source\"]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_with_("println","\"------------------------------------------------------\"");
	return ((_s8_rec):cr())
end
)(self);
(self):call_with_("println","mth[\"\\$nativeSource\"]");
return (self);
end
,"api","tStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #o to: [self send: #basicNewInstance: to: 'self.Object'];cr.\r\n\tself assign: #selector to: [self concat: #('\"test\"' 'string(number)')];cr.\r\n\tself assign: #mth to: 'class(o)[\"\\$methods\"][string(selector)]';cr.\r\n\tself call: #println with: 'mth[\"\\$source\"]';cr.\r\n\tself call: #println with: '\"------------------------------------------------------\"';cr.\r\n\tself call: #println with: 'mth[\"\\$nativeSource\"]' ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"o\",(function()\r\nreturn ((self):send_to_(\"basicNewInstance:\",\"self.Object\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"selector\",(function()\r\nreturn ((self):concat_(smalltalk:newArray({\"\\\"test\\\"\", \"string(number)\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"mth\",\"class(o)[\\\"\\\\$methods\\\"][string(selector)]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"println\",\"mth[\\\"\\\\$source\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"println\",\"\\\"------------------------------------------------------\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):call_with_(\"println\",\"mth[\\\"\\\\$nativeSource\\\"]\");\r\nreturn (self);\r\nend")
