
-- fileIn("s8/library/eden/luaBoot.st")
smalltalk:addClass("LuaBoot",smalltalk.BootSector,smalltalk:newArray({}),"luaBoot")

smalltalk:bind(smalltalk.LuaBoot["$klass"],"supportsLanguage:",0
,function(self,aLanguage)
return (smalltalk:isObject_equalTo_(("lua"),aLanguage));
end
,"instantiation","supportsLanguage: aLanguage\r\n\t\" Private - Return true if instances of the receiver can encode to aLanguage. \"\r\n\r\n\t^#lua = aLanguage","function(self,aLanguage)\r\nreturn (smalltalk:isObject_equalTo_((\"lua\"),aLanguage));\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"version",0
,function(self)
return ("1.0 - Stable");
end
,"constants","version\r\n\t\" Private - Returns the version string (dotted number and date). \"\r\n\r\n\t^'1.0 - Stable'","function(self)\r\nreturn (\"1.0 - Stable\");\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"lineComment:",0
,function(self,aString)
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:object_comma_(("-- "),aString));
	return ((_s8_rec):cr())
end
)(self));
end
,"encoding","lineComment: aString\r\n\t\" Private - Encode aString as line comment. \"\r\n\r\n\t^self nextPutAll: '-- ' ,aString;cr ","function(self,aString)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((\"-- \"),aString));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self));\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"multilineComment:",0
,function(self,array)
return ((self):encode_((function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("--[[");
	return ((_s8_rec):indent())
end
)(self);(array):do_((function(line)
return ((
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(line))
end
)(self))
end));return ((
function(_s8_rec)
	(_s8_rec):dedent();
	(_s8_rec):cr();
	(_s8_rec):nextPutAll_("--]]");
	return ((_s8_rec):cr())
end
)(self))
end)));
end
,"encoding","multilineComment: array\r\n\t\" Private - Encode an array as a multiline comment. \"\r\n\r\n\t^self encode: [\r\n\t\tself nextPutAll: '--[[' ;indent.\r\n\t\tarray do: [:line| self cr; nextPutAll: line ].\r\n\t\tself dedent; cr; nextPutAll: '--]]'; cr\r\n\t]","function(self,array)\r\nreturn ((self):encode_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"--[[\");\r\n\treturn ((_s8_rec):indent())\r\nend\r\n)(self);(array):do_((function(line)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(line))\r\nend\r\n)(self))\r\nend));return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):dedent();\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):nextPutAll_(\"--]]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"startupExpression",0
,function(self)
return ((self):encode_((function()
return ((self):return_((function()
return ((self):send_to_("startup","smalltalk"))
end)))
end)));
end
,"contents","startupExpression\r\n\t\" Private - Return the encoding for startup expression of the receiver. \"\r\n\r\n\t^self encode: [\r\n\t\tself return: [ self send: #startup to: #smalltalk ]\r\n\t]","function(self)\r\nreturn ((self):encode_((function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_(\"startup\",\"smalltalk\"))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"nilDefinition",0
,function(self)
return ("");
end
,"definitions","nilDefinition\r\n\t\" Private - Return the encoding for nil. \"\r\n\r\n\t^'' \"we share nil instance with Lua space\" ","function(self)\r\nreturn (\"\");\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"smalltalkDefinition",0
,function(self)
return (smalltalk:object_comma_(((self):encode_((function()
return ((self):define_as_("smalltalk","{}"))
end))),(self):smalltalkImplementation()));
end
,"definitions","smalltalkDefinition\r\n\t\" Private - Return the encoding for smalltalk. \"\r\n\r\n\t^(self encode: [\r\n\t\tself define: #smalltalk as: '{}'\r\n\t]) ,self smalltalkImplementation ","function(self)\r\nreturn (smalltalk:object_comma_(((self):encode_((function()\r\nreturn ((self):define_as_(\"smalltalk\",\"{}\"))\r\nend))),(self):smalltalkImplementation()));\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"define:as:",0
,function(self,aName,expression)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("local");
	(_s8_rec):space();
	(_s8_rec):assign_to_(aName,expression);
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"encoding","define: aName as: expression\r\n\t\" Private - Return the encoding for defining a variable named aName. \"\r\n\r\n\tself\tnextPutAll: #local; space;\r\n\t\tassign: aName to: expression; cr ","function(self,aName,expression)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"local\");\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):assign_to_(aName,expression);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"sendMessageOP",0
,function(self)
return (":");
end
,"asm-constants","sendMessageOP\r\n\t\" Private - Encoding for send message OP \"\r\n\r\n\t^$: ","function(self)\r\nreturn (\":\");\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"smalltalkImplementation",0
,function(self)
return ((self):encode_((function()
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("smalltalk","nativeLanguage","\"lua\"");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_property_to_("smalltalk","useManager","false");
	return ((_s8_rec):cr())
end
)(self);(self):systemDictionaryInternals();(self):rootDefinition();(self):systemDictionaryPrivates();return ((self):systemDictionaryAPI())
end)));
end
,"implementations","smalltalkImplementation\r\n\t\" Private - Return the encoding for smalltalk implementation. \"\r\n\r\n\t^self encode: [\r\n\t\tself assign: #smalltalk pv: #nativeLanguage to: '\"lua\"';cr.\r\n\t\tself assign: #smalltalk property: #useManager to: #false;cr.\r\n\t\tself systemDictionaryInternals.\r\n\t\tself rootDefinition.\r\n\t\tself systemDictionaryPrivates.\r\n\t\tself systemDictionaryAPI.\r\n\t] ","function(self)\r\nreturn ((self):encode_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"smalltalk\",\"nativeLanguage\",\"\\\"lua\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_property_to_(\"smalltalk\",\"useManager\",\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):systemDictionaryInternals();(self):rootDefinition();(self):systemDictionaryPrivates();return ((self):systemDictionaryAPI())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"rootDefinition",0
,function(self)
(self):define_as_("StObject",(function()
return ((self):send_to_("newConstructor","smalltalk"))
end));
(self):define_as_("StBehavior",(function()
return ((self):send_to_with_("newConstructor","smalltalk","StObject"))
end));
(self):define_as_("StClass",(function()
return ((self):send_to_with_("newConstructor","smalltalk","StBehavior"))
end));
(self):define_as_("StMetaclass",(function()
return ((self):send_to_with_("newConstructor","smalltalk","StBehavior"))
end));
(
function(_s8_rec)
	(_s8_rec):assign_pv_to_("StMetaclass.prototype","meta","true");
	return ((_s8_rec):cr())
end
)(self);
(self):define_as_("StMethod",(function()
return ((self):send_to_with_("newConstructor","smalltalk","StObject"))
end));
(self):define_as_("StSystemDictionary",(function()
return ((self):send_to_with_("newConstructor","smalltalk","StObject"))
end));
return (self);
end
,"definitions","rootDefinition\r\n\t\" Private - Return the encoding for root classes. \"\r\n\r\n\tself define: #StObject as: [ self send: #newConstructor to: #smalltalk ].\r\n\tself define: #StBehavior as: [ self send: #newConstructor to: #smalltalk with: #StObject ].\r\n\tself define: #StClass as: [ self send: #newConstructor to: #smalltalk with: #StBehavior ].\r\n\tself define: #StMetaclass as: [ self send: #newConstructor to: #smalltalk with: #StBehavior ].\r\n\tself assign: 'StMetaclass.prototype' pv: #meta to: 'true';cr.\r\n\tself define: #StMethod as: [ self send: #newConstructor to: #smalltalk with: #StObject ].\r\n\tself define: #StSystemDictionary as: [ self send: #newConstructor to: #smalltalk with: #StObject ]. ","function(self)\r\n(self):define_as_(\"StObject\",(function()\r\nreturn ((self):send_to_(\"newConstructor\",\"smalltalk\"))\r\nend));\r\n(self):define_as_(\"StBehavior\",(function()\r\nreturn ((self):send_to_with_(\"newConstructor\",\"smalltalk\",\"StObject\"))\r\nend));\r\n(self):define_as_(\"StClass\",(function()\r\nreturn ((self):send_to_with_(\"newConstructor\",\"smalltalk\",\"StBehavior\"))\r\nend));\r\n(self):define_as_(\"StMetaclass\",(function()\r\nreturn ((self):send_to_with_(\"newConstructor\",\"smalltalk\",\"StBehavior\"))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_pv_to_(\"StMetaclass.prototype\",\"meta\",\"true\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):define_as_(\"StMethod\",(function()\r\nreturn ((self):send_to_with_(\"newConstructor\",\"smalltalk\",\"StObject\"))\r\nend));\r\n(self):define_as_(\"StSystemDictionary\",(function()\r\nreturn ((self):send_to_with_(\"newConstructor\",\"smalltalk\",\"StObject\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"systemDictionaryInternals",0
,function(self)
(smalltalk:newArray({smalltalk:newArray({"do:onError:", smalltalk:newArray({"aBlock", "errorBlock"})}), smalltalk:newArray({"isNil:", smalltalk:newArray({"aValue"})}), smalltalk:newArray({"notNil:", smalltalk:newArray({"aValue"})}), smalltalk:newArray({"basic:at:ifAbsent:", smalltalk:newArray({"receiver", "key", "aBlock"})}), smalltalk:newArray({"basic:at:put:", smalltalk:newArray({"receiver", "key", "aValue"})}), smalltalk:newArray({"ifUndefined:do:", smalltalk:newArray({"receiver", "aBlock"})}), smalltalk:newArray({"orNil:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"newConstructor", smalltalk:newArray({"super"})})})):do_((function(tuple)
return ((self):bindAPI_(tuple))
end));
return (self);
end
,"implementations","systemDictionaryInternals\r\n\t\" Private - Internal encoding for smalltalk. \"\r\n\r\n\t#(\t#(do:onError: #(aBlock errorBlock))\r\n\t\t#(isNil: #(aValue))\r\n\t\t#(notNil: #(aValue))\r\n\t\t#(basic:at:ifAbsent: #(receiver key aBlock))\r\n\t\t#(basic:at:put: #(receiver key aValue))\r\n\t\t#(ifUndefined:do: #(receiver aBlock))\r\n\t\t#(orNil: #(receiver))\r\n\t\t#(newConstructor #(super))\r\n\t) do: [:tuple| self bindAPI: tuple ]","function(self)\r\n(smalltalk:newArray({smalltalk:newArray({\"do:onError:\", smalltalk:newArray({\"aBlock\", \"errorBlock\"})}), smalltalk:newArray({\"isNil:\", smalltalk:newArray({\"aValue\"})}), smalltalk:newArray({\"notNil:\", smalltalk:newArray({\"aValue\"})}), smalltalk:newArray({\"basic:at:ifAbsent:\", smalltalk:newArray({\"receiver\", \"key\", \"aBlock\"})}), smalltalk:newArray({\"basic:at:put:\", smalltalk:newArray({\"receiver\", \"key\", \"aValue\"})}), smalltalk:newArray({\"ifUndefined:do:\", smalltalk:newArray({\"receiver\", \"aBlock\"})}), smalltalk:newArray({\"orNil:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"newConstructor\", smalltalk:newArray({\"super\"})})})):do_((function(tuple)\r\nreturn ((self):bindAPI_(tuple))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"localOP",0
,function(self)
return ("local");
end
,"asm-constants","localOP\r\n\t\" Private - Return the OP for defining new local variable (or nil). \"\r\n\r\n\t^#local ","function(self)\r\nreturn (\"local\");\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"notOP",0
,function(self)
return ("not ");
end
,"asm-constants","notOP\r\n\t\" Private - Return the OP for negation. \"\r\n\r\n\t^'not ' ","function(self)\r\nreturn (\"not \");\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"orOP",0
,function(self)
return ("or");
end
,"asm-constants","orOP\r\n\t\" Private - Encoding for operand. \"\r\n\r\n\t^#or ","function(self)\r\nreturn (\"or\");\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"andOP",0
,function(self)
return ("and");
end
,"asm-constants","andOP\r\n\t\" Private - Encoding for operand. \"\r\n\r\n\t^#and ","function(self)\r\nreturn (\"and\");\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"noteqOP",0
,function(self)
return ("~=");
end
,"asm-constants","noteqOP\r\n\t\" Private - Encoding for operand. \"\r\n\r\n\t^#~= ","function(self)\r\nreturn (\"~=\");\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"blockOPs",0
,function(self)
return ("{}");
end
,"asm-constants","blockOPs\r\n\t\" Private - Encoding for expression block OPs \"\r\n\r\n\t^'{}' ","function(self)\r\nreturn (\"{}\");\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"expressionsOPs",0
,function(self)
return (smalltalk:newArray({"", "end"}));
end
,"asm-constants","expressionsOPs\r\n\t\" Private - Encoding for expression list OPs \"\r\n\r\n\t^#('' end) ","function(self)\r\nreturn (smalltalk:newArray({\"\", \"end\"}));\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"fieldOP",0
,function(self)
return ("=");
end
,"asm-constants","fieldOP\r\n\t\" Private - Return the OP for tuple separator. \"\r\n\r\n\t^$= ","function(self)\r\nreturn (\"=\");\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"emptyString",0
,function(self)
return ("\"\"");
end
,"asm-constants","emptyString\r\n\t\" Private - Encoding for empty string literal. \"\r\n\r\n\t^'\"\"' ","function(self)\r\nreturn (\"\\\"\\\"\");\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"forInDoPars",0
,function(self)
return ("");
end
,"asm-constants","forInDoPars\r\n\t\" Private - Return the parentesis for for-in-do expression. \"\r\n\r\n\t^''","function(self)\r\nreturn (\"\");\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"forDoPars",0
,function(self)
return ("");
end
,"asm-constants","forDoPars\r\n\t\" Private - Return the parentesis for for-do expression. \"\r\n\r\n\t^''","function(self)\r\nreturn (\"\");\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"typeofOPs",0
,function(self)
return (smalltalk:newArray({"type(", ")"}));
end
,"asm-constants","typeofOPs\r\n\t\" Private - Return the OP for typeOf expression. \"\r\n\r\n\t^#('type(' $)) ","function(self)\r\nreturn (smalltalk:newArray({\"type(\", \")\"}));\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"if:do:else:",0
,function(self,condition,trueBlock,falseBlock)
(
function(_s8_rec)
	(_s8_rec):if_(condition);
	return ((_s8_rec):space())
end
)(self);
(self):between_do_indent_((smalltalk.Array):with_with_("then",smalltalk:if_true_false_((smalltalk:isNil_((falseBlock))),(function()
return ("end")
end),(function()
return ("")
end))),trueBlock,true);
if (smalltalk:notNil_((falseBlock)))==true then (
function(_s8_rec)
	(_s8_rec):space();
	(_s8_rec):nextPutAll_((self):elseOP());
	return ((_s8_rec):space())
end
)(self);
(self):between_do_indent_(smalltalk:newArray({"", "end"}),falseBlock,true); end;
return (self);
end
,"asm","if: condition do: trueBlock else: falseBlock\r\n\t\" Private - Encoding for conditional. \"\r\n\r\n\tself if: condition; space.\r\n\tself between: (Array\r\n\t\twith: #then\r\n\t\twith: (falseBlock isNil ifTrue: [#end] ifFalse: ['']))\r\n\t\tdo: trueBlock indent: true.\r\n\tfalseBlock notNil ifTrue: [\r\n\t\tself space; nextPutAll: self elseOP; space.\r\n\t\tself between: #('' end) do: falseBlock indent: true.\r\n\t]","function(self,condition,trueBlock,falseBlock)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_(condition);\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(self):between_do_indent_((smalltalk.Array):with_with_(\"then\",smalltalk:if_true_false_((smalltalk:isNil_((falseBlock))),(function()\r\nreturn (\"end\")\r\nend),(function()\r\nreturn (\"\")\r\nend))),trueBlock,true);\r\nif (smalltalk:notNil_((falseBlock)))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_((self):elseOP());\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(self):between_do_indent_(smalltalk:newArray({\"\", \"end\"}),falseBlock,true); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"if:return:",0
,function(self,condition,expression)
(
function(_s8_rec)
	(_s8_rec):if_(condition);
	(_s8_rec):space();
	return ((_s8_rec):between_do_indent_(smalltalk:newArray({"then", "end"}),(function()
return ((
function(_s8_rec)
	(_s8_rec):space();
	(_s8_rec):return_(expression);
	return ((_s8_rec):space())
end
)(self))
end),false))
end
)(self);
return (self);
end
,"asm","if: condition return: expression\r\n\t\" Private - Encoding for conditional expression return. \"\r\n\r\n\tself\tif: condition; space;\r\n\t\tbetween: #(then end)\r\n\t\tdo: [ self space; return: expression; space ]\r\n\t\tindent: false","function(self,condition,expression)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_(condition);\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):between_do_indent_(smalltalk:newArray({\"then\", \"end\"}),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):return_(expression);\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self))\r\nend),false))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"assign:property:to:",0
,function(self,obj,key,expression)
(self):assign_to_(smalltalk:object_comma_((smalltalk:object_comma_((obj),".")),key),expression);
return (self);
end
,"asm","assign: obj property: key to: expression\r\n\t\" Private - Encoding for assignment to object property. \"\r\n\r\n\tself assign: obj ,$. ,key to: expression ","function(self,obj,key,expression)\r\n(self):assign_to_(smalltalk:object_comma_((smalltalk:object_comma_((obj),\".\")),key),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"assign:index:to:",0
,function(self,obj,key,expression)
(self):assign_to_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((obj),"[")),key)),"]"),expression);
return (self);
end
,"asm","assign: obj index: key to: expression\r\n\t\" Private - Encoding for assignment to indexed property. \"\r\n\r\n\tself assign: obj ,$[ ,key ,$] to: expression ","function(self,obj,key,expression)\r\n(self):assign_to_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((obj),\"[\")),key)),\"]\"),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"assign:iv:to:",0
,function(self,rcv,ivName,expression)
(self):assign_index_to_(rcv,smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("\""),"@")),ivName)),"\""),expression);
return (self);
end
,"asm","assign: rcv iv: ivName to: expression\r\n\t\" Private - Encoding for assignment to object instance variable. \"\r\n\r\n\tself assign: rcv index: $\" ,$@ ,ivName ,$\" to: expression ","function(self,rcv,ivName,expression)\r\n(self):assign_index_to_(rcv,smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),\"@\")),ivName)),\"\\\"\"),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"assign:pv:to:",0
,function(self,rcv,pvName,expression)
(self):assign_index_to_(rcv,smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("\""),"$")),pvName)),"\""),expression);
return (self);
end
,"asm","assign: rcv pv: pvName to: expression\r\n\t\" Private - Encoding for assignment to object private variable. \"\r\n\r\n\tself assign: rcv index: $\" ,$$ ,pvName ,$\" to: expression ","function(self,rcv,pvName,expression)\r\n(self):assign_index_to_(rcv,smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),\"$\")),pvName)),\"\\\"\"),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"rawFunction:arguments:doing:",0
,function(self,aName,args,implementation)
return (smalltalk:superImplementor(smalltalk.LuaBoot,"implementFunction_arguments_doing_comment_")(self,aName,args,implementation,nil));
end
,"asm","rawFunction: aName arguments: args doing: implementation\r\n\t\" Private - Encoding for function (w/o self definition) implementation. \"\r\n\r\n\t^super\timplementFunction: aName\r\n\t\targuments: args doing: implementation\r\n\t\tcomment: nil ","function(self,aName,args,implementation)\r\nreturn (smalltalk:superImplementor(smalltalk.LuaBoot,\"implementFunction_arguments_doing_comment_\")(self,aName,args,implementation,nil));\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"callPrint:",0
,function(self,arg1)
return ((self):call_with_("print",arg1));
end
,"encoding","callPrint: arg1\r\n\t\" Private - Encoding for print expression. \"\r\n\r\n\t^self call: #print with: arg1 ","function(self,arg1)\r\nreturn ((self):call_with_(\"print\",arg1));\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"concat:with:",0
,function(self,rcv,arg1)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(rcv);
	(_s8_rec):space();
	(_s8_rec):nextPutAll_("..");
	(_s8_rec):space();
	return ((_s8_rec):nextPutAll_(arg1))
end
)(self);
return (self);
end
,"encoding","concat: rcv with: arg1\r\n\t\" Private - Encoding for contatenation expression. \"\r\n\r\n\tself\tnextPutAll: rcv;\r\n\t\tspace; nextPutAll: '..';space;\r\n\t\tnextPutAll: arg1 ","function(self,rcv,arg1)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(rcv);\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(\"..\");\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):nextPutAll_(arg1))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"bind:arguments:doing:comment:",0
,function(self,selector,args,implementation,aComment)
(self):implementFunction_arguments_doing_comment_(smalltalk:object_comma_(("smalltalk."),(selector):asSelector()),args,implementation,aComment);
return (self);
end
,"asm","bind: selector arguments: args doing: implementation comment: aComment\r\n\t\" Private - Encoding for internal method implementation. \"\r\n\r\n\tself\timplementFunction: 'smalltalk.' ,selector asSelector\r\n\t\targuments: args doing: implementation\r\n\t\tcomment: aComment ","function(self,selector,args,implementation,aComment)\r\n(self):implementFunction_arguments_doing_comment_(smalltalk:object_comma_((\"smalltalk.\"),(selector):asSelector()),args,implementation,aComment);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"bind:to:with:",0
,function(self,selector,object,expression)
(self):assign_to_(smalltalk:object_comma_((smalltalk:object_comma_((object),".")),(selector):asSelector()),expression);
return (self);
end
,"encoding","bind: selector to: object with: expression\r\n\t\" Private - Bind message selector to object to execute expression when the message is received. \"\r\n\r\n\tself assign: object ,$. ,selector asSelector to: expression ","function(self,selector,object,expression)\r\n(self):assign_to_(smalltalk:object_comma_((smalltalk:object_comma_((object),\".\")),(selector):asSelector()),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"bind:to:doing:",0
,function(self,selector,object,expression)
(
function(_s8_rec)
	(_s8_rec):bind_to_with_(selector,object,expression);
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"encoding","bind: selector to: object doing: expression\r\n\t\" Private - Bind message selector to object to execute expression when the message is received. \"\r\n\r\n\tself bind: selector to: object with: expression; cr ","function(self,selector,object,expression)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):bind_to_with_(selector,object,expression);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"bindAPI:",0
,function(self,spec)
local rcv=nil
local selector=nil
local action=nil
if ((spec):isString())==true then return ((self):bindAPI_((smalltalk.Array):with_with_(spec,smalltalk:newArray({})))); end;
if not ((((spec):last()):isArray()))==true then return ((self):error_(smalltalk:object_comma_(("Invalid/corrupt API spec "),(spec):asLiteral()))); end;
(function()
	local _s8_value=(smalltalk:object_comma_((((spec):first()):asSelector()),"Implementation"))
	selector=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((function()
return ((rcv):perform_(selector))
end))
	action=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:responds_to_((self),(selector))),(function()
return (self)
end),(function()
return (smalltalk:if_true_false_((smalltalk:responds_to_(((self)["$klass"]),(selector))),(function()
return ((self)["$klass"])
end),(function()
return ((function()
	local _s8_value=((function()
return ((self):comment_(smalltalk:object_comma_((smalltalk:object_comma_(("*ToDo* - API "),(selector):asLiteral()))," Not Implemented Yet.")))
end))
	action=_s8_value
	return _s8_value
end)())
end)))
end)))
	rcv=_s8_value
	return _s8_value
end)();
(self):bind_arguments_doing_((spec):first(),(spec):last(),action);
return (self);
end
,"private","bindAPI: spec\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\t| rcv selector action |\r\n\tspec isString ifTrue: [ ^self bindAPI: (Array with: spec with: #()) ].\r\n\tspec last isArray ifFalse: [\r\n\t\t^self error: 'Invalid/corrupt API spec ' ,spec asLiteral\r\n\t].\r\n\tselector := spec first asSelector ,#Implementation.\r\n\taction := [ rcv perform: selector ].\r\n\trcv := (self respondsTo: selector) ifTrue: [ self ] ifFalse: [\r\n\t\t(self class respondsTo: selector) ifTrue: [ self class ] ifFalse: [\r\n\t\t\t\" self error: 'Missing API implementation for ' ,selector asLiteral \"\r\n\t\t\taction := [ self comment: '*ToDo* - API ' ,selector asLiteral ,' Not Implemented Yet.' ]\r\n\t\t]\r\n\t].\r\n\tself bind: spec first arguments: spec last doing: action ","function(self,spec)\r\nlocal rcv=nil\r\nlocal selector=nil\r\nlocal action=nil\r\nif ((spec):isString())==true then return ((self):bindAPI_((smalltalk.Array):with_with_(spec,smalltalk:newArray({})))); end;\r\nif not ((((spec):last()):isArray()))==true then return ((self):error_(smalltalk:object_comma_((\"Invalid/corrupt API spec \"),(spec):asLiteral()))); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((((spec):first()):asSelector()),\"Implementation\"))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((function()\r\nreturn ((rcv):perform_(selector))\r\nend))\r\n\taction=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:responds_to_((self),(selector))),(function()\r\nreturn (self)\r\nend),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:responds_to_(((self)[\"$klass\"]),(selector))),(function()\r\nreturn ((self)[\"$klass\"])\r\nend),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=((function()\r\nreturn ((self):comment_(smalltalk:object_comma_((smalltalk:object_comma_((\"*ToDo* - API \"),(selector):asLiteral())),\" Not Implemented Yet.\")))\r\nend))\r\n\taction=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)))\r\nend)))\r\n\trcv=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):bind_arguments_doing_((spec):first(),(spec):last(),action);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"implementFunction:arguments:doing:comment:",0
,function(self,aName,args,expression,aComment)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("function");
	(_s8_rec):space();
	(_s8_rec):nextPutAll_(aName);
	(_s8_rec):pars_((function()
return ((self):nextPutArguments_(smalltalk:object_comma_((smalltalk:newArray({"self"})),args)))
end));
	(_s8_rec):between_do_indent_comment_(smalltalk:newArray({"", "end"}),expression,true,aComment);
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"encoding","implementFunction: aName arguments: args doing: expression comment: aComment\r\n\t\" Private - Define the function named aName doing expression. \"\r\n\r\n\tself\tnextPutAll: #function; space; nextPutAll: aName;\r\n\t\tpars: [ self nextPutArguments: #(self) ,args ];\r\n\t\tbetween: #('' end) do: expression indent: true comment: aComment;\r\n\t\tcr","function(self,aName,args,expression,aComment)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"function\");\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(aName);\r\n\t(_s8_rec):pars_((function()\r\nreturn ((self):nextPutArguments_(smalltalk:object_comma_((smalltalk:newArray({\"self\"})),args)))\r\nend));\r\n\t(_s8_rec):between_do_indent_comment_(smalltalk:newArray({\"\", \"end\"}),expression,true,aComment);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"do_onError_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("status, result",(function()
return ((self):call_with_("pcall","aBlock"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_("status","result");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_with_("errorBlock","result"))
end));
return (self);
end
,"lua-internal","do_onError_Implementation\r\n\t\" Private - Implementation of internal function. \"\r\n\r\n\tself local: 'status, result' with: [self call: #pcall with: #aBlock];cr.\r\n\tself if: #status return: #result;cr.\r\n\tself return: [self call: #errorBlock with: #result] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"status, result\",(function()\r\nreturn ((self):call_with_(\"pcall\",\"aBlock\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_(\"status\",\"result\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"errorBlock\",\"result\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"isNil_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):not_("aValue"))
end),(function()
return ((self):expr_eqeq_("aValue","nil"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):typeOf_is_("aValue","table"))
end),(function()
return ((self):if_do_((function()
return ((self):typeOf_is_("aValue.isNil","function"))
end),(function()
return ((self):return_((function()
return ((self):send_to_("isNil","aValue"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("false");
return (self);
end
,"lua-internal","isNil_Implementation\r\n\t\" Private - Implementation of internal function. \"\r\n\r\n\tself if: [self not: #aValue] return: [self expr: #aValue eqeq: #nil];cr.\r\n\tself if: [self typeOf: #aValue is: #table] do: [\r\n\t\tself if: [self typeOf: 'aValue.isNil' is: #function] do: [\r\n\t\t\tself return: [self send: #isNil to: #aValue]\r\n\t\t]\r\n\t];cr.\r\n\tself return: #false","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):not_(\"aValue\"))\r\nend),(function()\r\nreturn ((self):expr_eqeq_(\"aValue\",\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):typeOf_is_(\"aValue\",\"table\"))\r\nend),(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):typeOf_is_(\"aValue.isNil\",\"function\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_(\"isNil\",\"aValue\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"false\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"notNil_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):not_("aValue"))
end),(function()
return ((self):expr_noteq_("aValue","nil"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):typeOf_is_("aValue","table"))
end),(function()
return ((self):if_do_((function()
return ((self):typeOf_is_("aValue.notNil","function"))
end),(function()
return ((self):return_((function()
return ((self):send_to_("notNil","aValue"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("true");
return (self);
end
,"lua-internal","notNil_Implementation\r\n\t\" Private - Implementation of internal function. \"\r\n\r\n\tself if: [self not: #aValue] return: [self expr: #aValue noteq: #nil];cr.\r\n\tself if: [self typeOf: #aValue is: #table] do: [\r\n\t\tself if: [self typeOf: 'aValue.notNil' is: #function] do: [\r\n\t\t\tself return: [self send: #notNil to: #aValue]\r\n\t\t]\r\n\t];cr.\r\n\tself return: #true","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):not_(\"aValue\"))\r\nend),(function()\r\nreturn ((self):expr_noteq_(\"aValue\",\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):typeOf_is_(\"aValue\",\"table\"))\r\nend),(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):typeOf_is_(\"aValue.notNil\",\"function\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_(\"notNil\",\"aValue\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"true\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"basic_at_ifAbsent_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("result","receiver[key]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("isNil:","result"))
end),(function()
return ((self):return_((function()
return ((self):send_to_("value","aBlock"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"lua-internal","basic_at_ifAbsent_Implementation\r\n\t\" Private - Implementation of internal function. \"\r\n\r\n\tself local: #result with: 'receiver[key]';cr.\r\n\tself if: [self send: #isNil: with: #result] do: [\r\n\t\tself return: [self send: #value to: #aBlock]\r\n\t];cr.\r\n\tself return: #result","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"result\",\"receiver[key]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"result\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_(\"value\",\"aBlock\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"basic_at_put_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("receiver[key]","aValue");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("aValue");
return (self);
end
,"lua-internal","basic_at_put_Implementation\r\n\t\" Private - Implementation of internal function. \"\r\n\r\n\tself assign: 'receiver[key]' to: #aValue;cr.\r\n\tself return: #aValue","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"receiver[key]\",\"aValue\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"aValue\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"ifUndefined_do_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("result","receiver");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("isNil:","result"))
end),(function()
return ((self):return_((function()
return ((self):send_to_("value","aBlock"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"lua-internal","ifUndefined_do_Implementation\r\n\t\" Private - Implementation of internal function. \"\r\n\r\n\tself local: #result with: #receiver;cr.\r\n\tself if: [self send: #isNil: with: #result] do: [\r\n\t\tself return: [self send: #value to: #aBlock]\r\n\t];cr.\r\n\tself return: #result","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"result\",\"receiver\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"result\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_(\"value\",\"aBlock\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"orNil_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("result","receiver");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):send_with_("isNil:","result"))
end),"nil");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"lua-internal","orNil_Implementation\r\n\t\" Private - Implementation of internal function. \"\r\n\r\n\tself local: #result with: #receiver;cr.\r\n\tself if: [self send: #isNil: with: #result] return: #nil;cr.\r\n\tself return: #result","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"result\",\"receiver\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"result\"))\r\nend),\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"inlineDebugDNU",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):comment_("DEBUG");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):callPrint_((function()
return ((self):concat_with_("\"--DNU \"",(function()
return ((self):call_with_("tostring","smalltalk.dnu"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):send_to_("isUppercase",(function()
return ((self):send_to_("first",(function()
return ((self):call_with_("tostring","smalltalk.dnu"))
end)))
end)))
end),"nil");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):comment_("DEBUG DNU detected dump stack trace");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("debug",(function()
(
function(_s8_rec)
	(_s8_rec):callPrint_((function()
return ((self):call_with_("debug.traceback","\"Stack trace\""))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):callPrint_((function()
return ((self):call_with_("debug.getinfo","1"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):callPrint_("\"Stack trace end\""))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):comment_("if smalltalk.dnu==\"arguments\" then error(\"DNU exiting...\") end");
	return ((_s8_rec):cr())
end
)(self);
(self):call_with_("error","\"DNU\"");
return (self);
end
,"lua-internal","inlineDebugDNU\r\n\t\" Private - Inline code to debug dump on DNU. \"\r\n\r\n\tself comment: 'DEBUG';cr.\r\n\tself callPrint: [self concat: '\"--DNU \"' with: [self call: #tostring with: 'smalltalk.dnu']];cr.\r\n\tself if: [self send: #isUppercase to: [\r\n\t\tself send: #first to: [self call: #tostring with: 'smalltalk.dnu']]]\r\n\t\treturn: #nil;cr.\r\n\tself comment: 'DEBUG DNU detected dump stack trace';cr.\r\n\tself if: #debug do: [\r\n\t\tself callPrint: [self call: 'debug.traceback' with: '\"Stack trace\"'];cr.\r\n\t\tself callPrint: [self call: 'debug.getinfo' with: #1];cr.\r\n\t\tself callPrint: '\"Stack trace end\"'\r\n\t];cr.\r\n\tself comment: 'if smalltalk.dnu==\"arguments\" then error(\"DNU exiting...\") end';cr.\r\n\tself call: #error with: '\"DNU\"' ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"DEBUG\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):callPrint_((function()\r\nreturn ((self):concat_with_(\"\\\"--DNU \\\"\",(function()\r\nreturn ((self):call_with_(\"tostring\",\"smalltalk.dnu\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):send_to_(\"isUppercase\",(function()\r\nreturn ((self):send_to_(\"first\",(function()\r\nreturn ((self):call_with_(\"tostring\",\"smalltalk.dnu\"))\r\nend)))\r\nend)))\r\nend),\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"DEBUG DNU detected dump stack trace\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"debug\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):callPrint_((function()\r\nreturn ((self):call_with_(\"debug.traceback\",\"\\\"Stack trace\\\"\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):callPrint_((function()\r\nreturn ((self):call_with_(\"debug.getinfo\",\"1\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):callPrint_(\"\\\"Stack trace end\\\"\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"if smalltalk.dnu==\\\"arguments\\\" then error(\\\"DNU exiting...\\\") end\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):call_with_(\"error\",\"\\\"DNU\\\"\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"newConstructorImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):comment_("return a new constructor of instances inheriting from super (constructor)");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):comment_("super can be nil to return a constructor for a root class");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("constructor",(function()
return ((self):emptyObject())
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("prototype",(function()
return ((self):emptyObject())
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_property_to_("prototype","__index","prototype");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_("super",(function()
return ((self):call_withArguments_("setmetatable",smalltalk:newArray({"prototype", "super.prototype"})))
end),(function()
(
function(_s8_rec)
	(_s8_rec):local_with_("dnu",(function()
return ((self):emptyObject())
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_property_to_("dnu","__index",(function()
return ((self):rawFunction_arguments_doing_("",smalltalk:newArray({"rootPrototype", "key"}),(function()
(
function(_s8_rec)
	(_s8_rec):comment_("print(\"--keyNotFound: \"..key)");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_property_to_("smalltalk","dnu","key");
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("nil"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):call_withArguments_("setmetatable",smalltalk:newArray({"prototype", "dnu"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setmetatable",smalltalk:newArray({"constructor", "prototype"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_property_to_("constructor","prototype","prototype");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_property_to_("prototype","__call",(function()
return ((self):rawFunction_arguments_doing_("",smalltalk:newArray({"f", "rcv", "..."}),(function()
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_and_((function()
return ((self):expr_eqeq_("f","nil"))
end),"smalltalk.dnu"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_noteq_((function()
return ((self):call_withArguments_("string.find",smalltalk:newArray({"smalltalk.dnu", "\"[%a_%+%-%/%*%|%&%=%<%>%,%~%\\\\]\""})))
end),"1"))
end),"nil");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):inlineDebugDNU();
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):comment_("Syntetize a doesNotUnderstand message send");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):local_with_("args",(function()
return ((self):call_with_((function()
return ((self):expr_or_("pack","table.pack"))
end),"..."))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):local_with_("msg",(function()
return ((self):send_to_withArguments_("receiver:selector:arguments:","smalltalk.Message",(smalltalk.Array):with_with_with_("rcv","smalltalk.dnu",(function()
return ((self):send_to_with_("newArray","smalltalk","args"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_property_to_("smalltalk","dnu","nil");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):local_with_("result","nil");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):send_to_with_("isObject:","smalltalk","rcv"))
end),(function()
return ((self):assign_to_("result",(function()
return ((self):send_to_with_("doesNotUnderstand:","rcv","msg"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):comment_("DNU goes to smalltalk for native objects");
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("result",(function()
return ((self):send_to_with_("doesNotUnderstand:","smalltalk","msg"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("result"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):local_with_("result",(function()
return ((self):emptyObject())
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setmetatable",smalltalk:newArray({"result", "prototype"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("result"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("constructor");
return (self);
end
,"lua-internal","newConstructorImplementation\r\n\t\" Private - Implementation of internal function. \"\r\n\r\n\tself comment: 'return a new constructor of instances inheriting from super (constructor)';cr.\r\n\tself comment: 'super can be nil to return a constructor for a root class';cr.\r\n\r\n\tself local: #constructor with: [self emptyObject];cr.\r\n\tself local: #prototype with: [self emptyObject];cr.\r\n\tself assign: #prototype property: #__index to: #prototype;cr.\r\n\tself if: #super\r\n\t do: [self call: #setmetatable withArguments: #(prototype 'super.prototype')]\r\n\t else: [\r\n\t\tself local: #dnu with: [self emptyObject];cr.\r\n\t\tself assign: #dnu property: #__index to: [\r\n\t\t\tself rawFunction: '' arguments: #(rootPrototype key) doing: [\r\n\t\t\t\tself comment: 'print(\"--keyNotFound: \"..key)';cr.\r\n\t\t\t\tself assign: #smalltalk property: #dnu to: #key;cr.\r\n\t\t\t\tself return: #nil\r\n\t\t\t]\r\n\t\t];cr.\r\n\t\tself call: #setmetatable withArguments: #(prototype dnu)\r\n\t];cr.\r\n\tself call: #setmetatable withArguments: #(constructor prototype);cr.\r\n\tself assign: #constructor property: #prototype to: #prototype;cr.\r\n\tself assign: #prototype property: #__call to: [\r\n\t\tself rawFunction: '' arguments: #(f rcv '...') doing: [\r\n\t\t\tself if: [self expr: [self expr: #f eqeq: #nil] and: 'smalltalk.dnu'] do: [\r\n\t\t\t\tself if: [self expr: [\r\n\t\t\t\t\tself call: 'string.find' withArguments: #(\r\n\t\t\t\t\t\t'smalltalk.dnu'\r\n\t\t\t\t\t\t'\"[%a_%+%-%/%*%|%&%=%<%>%,%~%\\\\]\"'\r\n\t\t\t\t\t)] noteq: #1]\r\n\t\t\t\t\treturn: #nil;cr.\r\n\t\t\t\tself inlineDebugDNU;cr.\r\n\t\t\t\tself comment: 'Syntetize a doesNotUnderstand message send';cr.\r\n\t\t\t\tself local: #args with: [\r\n\t\t\t\t\tself call: [self expr: #pack or: 'table.pack'] with: '...'\r\n\t\t\t\t];cr.\r\n\t\t\t\tself local: #msg with: [\r\n\t\t\t\t\tself send: #receiver:selector:arguments:\r\n\t\t\t\t\t\tto: 'smalltalk.Message'\r\n\t\t\t\t\t\twithArguments: (Array with: #rcv with: 'smalltalk.dnu'\r\n\t\t\t\t\t\t\twith: [self send: #newArray to: #smalltalk with: #args])\r\n\t\t\t\t];cr.\r\n\t\t\t\tself assign: #smalltalk property: #dnu to: #nil;cr.\r\n\t\t\t\tself local: #result with: #nil;cr.\r\n\t\t\t\tself if: [self send: #isObject: to: #smalltalk with: #rcv]\r\n\t\t\t\t\tdo: [ self assign: #result to: [self send: #doesNotUnderstand: to: #rcv with: #msg]]\r\n\t\t\t\t\telse: [\tself comment: 'DNU goes to smalltalk for native objects';cr.\r\n\t\t\t\t\t\tself assign: #result to: [self send: #doesNotUnderstand: to: #smalltalk with: #msg]\r\n\t\t\t\t];cr.\r\n\t\t\t\tself return: #result\r\n\t\t\t];cr.\r\n\t\t\tself local: #result with: [self emptyObject];cr.\r\n\t\t\tself call: #setmetatable withArguments: #(result prototype);cr.\r\n\t\t\tself return: #result\r\n\t\t]\r\n\t];cr.\r\n\tself return: #constructor","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"return a new constructor of instances inheriting from super (constructor)\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"super can be nil to return a constructor for a root class\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"constructor\",(function()\r\nreturn ((self):emptyObject())\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"prototype\",(function()\r\nreturn ((self):emptyObject())\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_property_to_(\"prototype\",\"__index\",\"prototype\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_(\"super\",(function()\r\nreturn ((self):call_withArguments_(\"setmetatable\",smalltalk:newArray({\"prototype\", \"super.prototype\"})))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"dnu\",(function()\r\nreturn ((self):emptyObject())\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_property_to_(\"dnu\",\"__index\",(function()\r\nreturn ((self):rawFunction_arguments_doing_(\"\",smalltalk:newArray({\"rootPrototype\", \"key\"}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"print(\\\"--keyNotFound: \\\"..key)\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_property_to_(\"smalltalk\",\"dnu\",\"key\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"nil\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):call_withArguments_(\"setmetatable\",smalltalk:newArray({\"prototype\", \"dnu\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setmetatable\",smalltalk:newArray({\"constructor\", \"prototype\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_property_to_(\"constructor\",\"prototype\",\"prototype\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_property_to_(\"prototype\",\"__call\",(function()\r\nreturn ((self):rawFunction_arguments_doing_(\"\",smalltalk:newArray({\"f\", \"rcv\", \"...\"}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):expr_eqeq_(\"f\",\"nil\"))\r\nend),\"smalltalk.dnu\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_noteq_((function()\r\nreturn ((self):call_withArguments_(\"string.find\",smalltalk:newArray({\"smalltalk.dnu\", \"\\\"[%a_%+%-%/%*%|%&%=%<%>%,%~%\\\\\\\\]\\\"\"})))\r\nend),\"1\"))\r\nend),\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):inlineDebugDNU();\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"Syntetize a doesNotUnderstand message send\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"args\",(function()\r\nreturn ((self):call_with_((function()\r\nreturn ((self):expr_or_(\"pack\",\"table.pack\"))\r\nend),\"...\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"msg\",(function()\r\nreturn ((self):send_to_withArguments_(\"receiver:selector:arguments:\",\"smalltalk.Message\",(smalltalk.Array):with_with_with_(\"rcv\",\"smalltalk.dnu\",(function()\r\nreturn ((self):send_to_with_(\"newArray\",\"smalltalk\",\"args\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_property_to_(\"smalltalk\",\"dnu\",\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"result\",\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):send_to_with_(\"isObject:\",\"smalltalk\",\"rcv\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"result\",(function()\r\nreturn ((self):send_to_with_(\"doesNotUnderstand:\",\"rcv\",\"msg\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"DNU goes to smalltalk for native objects\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"result\",(function()\r\nreturn ((self):send_to_with_(\"doesNotUnderstand:\",\"smalltalk\",\"msg\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"result\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"result\",(function()\r\nreturn ((self):emptyObject())\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setmetatable\",smalltalk:newArray({\"result\", \"prototype\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"result\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"constructor\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"systemDictionaryPrivates",0
,function(self)
(smalltalk:newArray({smalltalk:newArray({"will:be:", smalltalk:newArray({"anObject", "className"})}), smalltalk:newArray({"linkNative:to:", smalltalk:newArray({"instance", "aClass"})}), smalltalk:newArray({"newArray", smalltalk:newArray({"object"})}), smalltalk:newArray({"become:a:", smalltalk:newArray({"object", "aClass"})}), smalltalk:newArray({"setProtoOf:to:", smalltalk:newArray({"nativeObject", "proto"})}), smalltalk:newArray({"bindRoots", smalltalk:newArray({"metaclass"})}), smalltalk:newArray({"klass", smalltalk:newArray({"spec"})}), smalltalk:newArray({"setVarNames", smalltalk:newArray({"aClass", "iVarNames", "aValue"})}), smalltalk:newArray({"setClass", smalltalk:newArray({"aClass", "spec"})}), smalltalk:newArray({"fnInSpec", smalltalk:newArray({"spec"})})})):do_((function(tuple)
return ((self):bindAPI_(tuple))
end));
return (self);
end
,"implementations","systemDictionaryPrivates\r\n\t\" Private - Private encoding for SystemDictionary. \"\r\n\r\n\t#(\t#(will:be: #(anObject className))\r\n\t\t#(linkNative:to: #(instance aClass))\r\n\t\t#(newArray #(object))\r\n\t\t#(become:a: #(object aClass))\r\n\t\t#(setProtoOf:to: #(nativeObject proto))\r\n\t\t#(bindRoots #(metaclass))\r\n\t\t#(klass #(spec))\r\n\t\t#(setVarNames #(aClass iVarNames aValue))\r\n\t\t#(setClass #(aClass spec))\r\n\t\t#(fnInSpec #(spec))\r\n\t) do: [:tuple| self bindAPI: tuple ]","function(self)\r\n(smalltalk:newArray({smalltalk:newArray({\"will:be:\", smalltalk:newArray({\"anObject\", \"className\"})}), smalltalk:newArray({\"linkNative:to:\", smalltalk:newArray({\"instance\", \"aClass\"})}), smalltalk:newArray({\"newArray\", smalltalk:newArray({\"object\"})}), smalltalk:newArray({\"become:a:\", smalltalk:newArray({\"object\", \"aClass\"})}), smalltalk:newArray({\"setProtoOf:to:\", smalltalk:newArray({\"nativeObject\", \"proto\"})}), smalltalk:newArray({\"bindRoots\", smalltalk:newArray({\"metaclass\"})}), smalltalk:newArray({\"klass\", smalltalk:newArray({\"spec\"})}), smalltalk:newArray({\"setVarNames\", smalltalk:newArray({\"aClass\", \"iVarNames\", \"aValue\"})}), smalltalk:newArray({\"setClass\", smalltalk:newArray({\"aClass\", \"spec\"})}), smalltalk:newArray({\"fnInSpec\", smalltalk:newArray({\"spec\"})})})):do_((function(tuple)\r\nreturn ((self):bindAPI_(tuple))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"will_be_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):comment_("return an object that will become an instance of class (named className) when accessed");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("result","anObject");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("mt",(function()
return ((self):emptyObject())
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_property_to_("mt","__index",(function()
return ((self):rawFunction_arguments_doing_("",smalltalk:newArray({"table", "key"}),(function()
(
function(_s8_rec)
	(_s8_rec):if_do_("self[className]",(function()
return ((self):send_withArguments_("become:a:",smalltalk:newArray({"table", "self[className]"})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("table[key]"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setmetatable",smalltalk:newArray({"result", "mt"}));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"lua-private","will_be_Implementation\r\n\t\" Private - Implementation of private function. \"\r\n\r\n\tself comment: 'return an object that will become an instance of class (named className) when accessed';cr.\r\n\tself local: #result with: #anObject;cr.\r\n\tself local: #mt with: [self emptyObject];cr.\r\n\tself assign: #mt property: #__index to: [\r\n\t\tself rawFunction: '' arguments: #(table key) doing: [\r\n\t\t\tself if: 'self[className]' do: [\r\n\t\t\t\tself send: #become:a: withArguments: #(table 'self[className]')\r\n\t\t\t];cr.\r\n\t\t\tself return: 'table[key]'\r\n\t\t]\r\n\t];cr.\r\n\tself call: #setmetatable withArguments: #(result mt);cr.\r\n\tself return: #result","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"return an object that will become an instance of class (named className) when accessed\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"result\",\"anObject\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"mt\",(function()\r\nreturn ((self):emptyObject())\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_property_to_(\"mt\",\"__index\",(function()\r\nreturn ((self):rawFunction_arguments_doing_(\"\",smalltalk:newArray({\"table\", \"key\"}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"self[className]\",(function()\r\nreturn ((self):send_withArguments_(\"become:a:\",smalltalk:newArray({\"table\", \"self[className]\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"table[key]\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setmetatable\",smalltalk:newArray({\"result\", \"mt\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"linkNative_to_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):comment_("link native species of instance to delegate to aClass instance");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("mt",(function()
return ((self):call_with_("getmetatable","instance"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_do_else_("mt",(function()
(
function(_s8_rec)
	(_s8_rec):local_with_("index","mt[\"__index\"]");
	return ((_s8_rec):cr())
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):call_withArguments_("setmetatable",smalltalk:newArray({"index", "aClass[\"$fn\"].prototype"}));
	return ((_s8_rec):cr())
end
)(self))
end),(function()
return ((self):if_do_else_("debug",(function()
return ((self):send_withArguments_("do:onError:",(smalltalk.Array):with_with_((function()
return ((self):rawFunction_arguments_doing_("",smalltalk:newArray({}),(function()
return ((self):call_withArguments_("debug.setmetatable",smalltalk:newArray({"instance", "aClass[\"$fn\"].prototype"})))
end)))
end),(function()
return ((self):rawFunction_arguments_doing_("",smalltalk:newArray({}),(function()
return ((self):callPrint_((function()
return ((self):concat_with_("\"-- ERROR cant set metatable for \"",(function()
return ((self):call_with_("tostring","instance"))
end)))
end)))
end)))
end))))
end),(function()
return ((self):callPrint_("\"-- WARNING: debug support missing\""))
end)))
end));
return (self);
end
,"lua-private","linkNative_to_Implementation\r\n\t\" Private - Implementation of private function. \"\r\n\r\n\tself comment: 'link native species of instance to delegate to aClass instance';cr.\r\n\tself local: #mt with: [self call: #getmetatable with: #instance];cr.\r\n\tself if: #mt do: [\r\n\t\tself local: #index with: 'mt[\"__index\"]';cr.\r\n\t\tself call: #setmetatable withArguments: #(index 'aClass[\"$fn\"].prototype');cr.\r\n\t] else: [\r\n\t\tself if: #debug do: [\r\n\t\t\tself send: #do:onError: withArguments: (Array\r\n\t\t\t\twith: [self rawFunction: '' arguments: #() doing: [\r\n\t\t\t\t\tself\tcall: 'debug.setmetatable'\r\n\t\t\t\t\t\twithArguments: #(instance 'aClass[\"$fn\"].prototype')\r\n\t\t\t\t]]\r\n\t\t\t\twith: [self rawFunction: '' arguments: #() doing: [\r\n\t\t\t\t\tself callPrint: [self concat: '\"-- ERROR cant set metatable for \"'\r\n\t\t\t\t\t\twith: [self call: #tostring with: #instance]]\r\n\t\t\t\t]])\r\n\t\t] else: [ self callPrint: '\"-- WARNING: debug support missing\"' ]\r\n\t] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"link native species of instance to delegate to aClass instance\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"mt\",(function()\r\nreturn ((self):call_with_(\"getmetatable\",\"instance\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_do_else_(\"mt\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"index\",\"mt[\\\"__index\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setmetatable\",smalltalk:newArray({\"index\", \"aClass[\\\"$fn\\\"].prototype\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend),(function()\r\nreturn ((self):if_do_else_(\"debug\",(function()\r\nreturn ((self):send_withArguments_(\"do:onError:\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):rawFunction_arguments_doing_(\"\",smalltalk:newArray({}),(function()\r\nreturn ((self):call_withArguments_(\"debug.setmetatable\",smalltalk:newArray({\"instance\", \"aClass[\\\"$fn\\\"].prototype\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):rawFunction_arguments_doing_(\"\",smalltalk:newArray({}),(function()\r\nreturn ((self):callPrint_((function()\r\nreturn ((self):concat_with_(\"\\\"-- ERROR cant set metatable for \\\"\",(function()\r\nreturn ((self):call_with_(\"tostring\",\"instance\"))\r\nend)))\r\nend)))\r\nend)))\r\nend))))\r\nend),(function()\r\nreturn ((self):callPrint_(\"\\\"-- WARNING: debug support missing\\\"\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"newArrayImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):comment_("return a new Array instance mutating the provided object");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_withArguments_("will:be:",(smalltalk.Array):with_with_((function()
return ((self):expr_or_("object",(function()
return ((self):emptyObject())
end)))
end),"\"Array\"")))
end));
return (self);
end
,"lua-private","newArrayImplementation\r\n\t\" Private - Implementation of private function. \"\r\n\r\n\tself comment: 'return a new Array instance mutating the provided object';cr.\r\n\tself return: [ self send: #will:be: withArguments: (Array\r\n\t\twith: [self expr: #object or: [self emptyObject]]\r\n\t\twith: '\"Array\"')] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"return a new Array instance mutating the provided object\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"will:be:\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):expr_or_(\"object\",(function()\r\nreturn ((self):emptyObject())\r\nend)))\r\nend),\"\\\"Array\\\"\")))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"become_a_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):comment_("mutate object to an instance of aClass");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setmetatable",smalltalk:newArray({"object", "aClass[\"$fn\"].prototype"}));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("object");
return (self);
end
,"lua-private","become_a_Implementation\r\n\t\" Private - Implementation of private function. \"\r\n\r\n\tself comment: 'mutate object to an instance of aClass';cr.\r\n\tself call: #setmetatable withArguments: #(object 'aClass[\"$fn\"].prototype');cr.\r\n\tself return: #object ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"mutate object to an instance of aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setmetatable\",smalltalk:newArray({\"object\", \"aClass[\\\"$fn\\\"].prototype\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"object\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"setProtoOf_to_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("mt",(function()
return ((self):emptyObject())
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_property_to_("mt","__index","proto");
	return ((_s8_rec):cr())
end
)(self);
(self):call_withArguments_("setmetatable",smalltalk:newArray({"nativeObject", "mt"}));
return (self);
end
,"lua-private","setProtoOf_to_Implementation\r\n\t\" Private - Implementation of private function. \"\r\n\r\n\tself local: #mt with: [self emptyObject];cr.\r\n\tself assign: #mt property: #__index to: #proto;cr.\r\n\tself call: #setmetatable withArguments: #(nativeObject mt)","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"mt\",(function()\r\nreturn ((self):emptyObject())\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_property_to_(\"mt\",\"__index\",\"proto\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):call_withArguments_(\"setmetatable\",smalltalk:newArray({\"nativeObject\", \"mt\"}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"bindRootsImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):comment_("Private - Link the system roots to ensure proper delegation chains");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("objectClassPrototype","self.Object[\"$klass\"][\"$fn\"].prototype");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setProtoOf:to:",smalltalk:newArray({"objectClassPrototype", "self.Class[\"$fn\"].prototype"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setProtoOf:to:",smalltalk:newArray({"self.Smalltalk[\"$klass\"][\"$fn\"].prototype", "objectClassPrototype"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setProtoOf:to:",smalltalk:newArray({"self.Behavior[\"$klass\"][\"$fn\"].prototype", "objectClassPrototype"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self.Object[\"$klass\"][\"$superclass\"]","self.Class");
	return ((_s8_rec):cr())
end
)(self);
(self):send_withArguments_("become:a:",smalltalk:newArray({"smalltalk", "self.Smalltalk"}));
return (self);
end
,"lua-private","bindRootsImplementation\r\n\t\" Private - Implementation of private function. \"\r\n\r\n\tself comment: 'Private - Link the system roots to ensure proper delegation chains';cr.\r\n\tself local: #objectClassPrototype with: 'self.Object[\"$klass\"][\"$fn\"].prototype';cr.\r\n\tself send: #setProtoOf:to: withArguments: #(\r\n\t\tobjectClassPrototype\r\n\t\t'self.Class[\"$fn\"].prototype');cr.\r\n\tself send: #setProtoOf:to: withArguments: #(\r\n\t\t'self.Smalltalk[\"$klass\"][\"$fn\"].prototype'\r\n\t\tobjectClassPrototype);cr.\r\n\tself send: #setProtoOf:to: withArguments: #(\r\n\t\t'self.Behavior[\"$klass\"][\"$fn\"].prototype'\r\n\t\tobjectClassPrototype);cr.\r\n\tself assign: 'self.Object[\"$klass\"][\"$superclass\"]' to: 'self.Class';cr.\r\n\tself send: #become:a: withArguments: #(\r\n\t\tsmalltalk\r\n\t\t'self.Smalltalk')","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"Private - Link the system roots to ensure proper delegation chains\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"objectClassPrototype\",\"self.Object[\\\"$klass\\\"][\\\"$fn\\\"].prototype\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setProtoOf:to:\",smalltalk:newArray({\"objectClassPrototype\", \"self.Class[\\\"$fn\\\"].prototype\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setProtoOf:to:\",smalltalk:newArray({\"self.Smalltalk[\\\"$klass\\\"][\\\"$fn\\\"].prototype\", \"objectClassPrototype\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setProtoOf:to:\",smalltalk:newArray({\"self.Behavior[\\\"$klass\\\"][\\\"$fn\\\"].prototype\", \"objectClassPrototype\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self.Object[\\\"$klass\\\"][\\\"$superclass\\\"]\",\"self.Class\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):send_withArguments_(\"become:a:\",smalltalk:newArray({\"smalltalk\", \"self.Smalltalk\"}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"klassImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_("aClass");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_("spec.meta",(function()
return ((self):assign_to_("aClass",(function()
return ((self):call_("StMetaclass"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):local_with_("metaSpec",(function()
return ((self):object_((smalltalk.Array):with_(("meta"):_minus_gt("true"))))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_property_to_("metaSpec","className",(function()
return ((self):concat_with_("spec.className","\" class\""))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_("spec.superclass",(function()
return ((self):assign_property_to_("metaSpec","superclass","spec.superclass[\"$klass\"]"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):local_with_("metaclass",(function()
return ((self):send_with_("klass","metaSpec"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass",(function()
return ((self):call_("metaclass[\"$fn\"]"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):expr_noteq_("aClass[\"$klass\"]","metaclass"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):comment_("this should NOT happen");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):callPrint_("\"--! \"..(spec.className)..\" BROKEN metaclass=\"..tostring(aClass[\"$klass\"])");
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("aClass[\"$klass\"]","metaclass"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setClass",smalltalk:newArray({"aClass", "spec"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$fn\"].prototype[\"$klass\"]","aClass");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$fn\"].prototype[\"$methods\"]",(function()
return ((self):emptyObject())
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_eqeq_("aClass[\"$className\"]","\"Metaclass\""))
end),(function()
return ((self):send_with_("bindRoots","aClass"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("aClass");
return (self);
end
,"lua-private","klassImplementation\r\n\t\" Private - Implementation of private function. \"\r\n\r\n\tself local: #aClass;cr.\r\n\tself if: 'spec.meta' do: [\r\n\t\tself assign: #aClass to: [self call: #StMetaclass]\r\n\t] else: [\r\n\t\tself local: #metaSpec with: [self object: (Array with: #meta -> #true)];cr.\r\n\t\tself assign: #metaSpec property: #className to: [self concat: 'spec.className' with: '\" class\"'];cr.\r\n\t\tself if: 'spec.superclass' do: [\r\n\t\t\tself assign: #metaSpec property: #superclass to: 'spec.superclass[\"$klass\"]'\r\n\t\t];cr.\r\n\t\tself local: #metaclass with: [ self send: #klass with: #metaSpec];cr.\r\n\t\tself assign: #aClass to: [self call: 'metaclass[\"$fn\"]'];cr.\r\n\t\tself if: [self expr: 'aClass[\"$klass\"]' noteq: #metaclass] do: [\r\n\t\t\tself comment: 'this should NOT happen';cr.\r\n\t\t\tself callPrint: '\"--! \"..(spec.className)..\" BROKEN metaclass=\"..tostring(aClass[\"$klass\"])';cr.\r\n\t\t\tself assign: 'aClass[\"$klass\"]' to: #metaclass\r\n\t\t]\r\n\t];cr.\r\n\tself send: #setClass withArguments: #(aClass spec);cr.\r\n\tself assign: 'aClass[\"$fn\"].prototype[\"$klass\"]' to: #aClass;cr.\r\n\tself assign: 'aClass[\"$fn\"].prototype[\"$methods\"]' to: [self emptyObject];cr.\r\n\tself if: [self expr: 'aClass[\"$className\"]' eqeq: '\"Metaclass\"'] do: [\r\n\t\tself send: #bindRoots with: #aClass\r\n\t];cr.\r\n\tself return: #aClass ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_(\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_(\"spec.meta\",(function()\r\nreturn ((self):assign_to_(\"aClass\",(function()\r\nreturn ((self):call_(\"StMetaclass\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"metaSpec\",(function()\r\nreturn ((self):object_((smalltalk.Array):with_((\"meta\"):_minus_gt(\"true\"))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_property_to_(\"metaSpec\",\"className\",(function()\r\nreturn ((self):concat_with_(\"spec.className\",\"\\\" class\\\"\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"spec.superclass\",(function()\r\nreturn ((self):assign_property_to_(\"metaSpec\",\"superclass\",\"spec.superclass[\\\"$klass\\\"]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"metaclass\",(function()\r\nreturn ((self):send_with_(\"klass\",\"metaSpec\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass\",(function()\r\nreturn ((self):call_(\"metaclass[\\\"$fn\\\"]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):expr_noteq_(\"aClass[\\\"$klass\\\"]\",\"metaclass\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"this should NOT happen\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):callPrint_(\"\\\"--! \\\"..(spec.className)..\\\" BROKEN metaclass=\\\"..tostring(aClass[\\\"$klass\\\"])\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"aClass[\\\"$klass\\\"]\",\"metaclass\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setClass\",smalltalk:newArray({\"aClass\", \"spec\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$fn\\\"].prototype[\\\"$klass\\\"]\",\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$fn\\\"].prototype[\\\"$methods\\\"]\",(function()\r\nreturn ((self):emptyObject())\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"aClass[\\\"$className\\\"]\",\"\\\"Metaclass\\\"\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"bindRoots\",\"aClass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"aClass\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"setVarNamesImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_eqeq_("iVarNames","nil"))
end),(function()
return ((self):assign_to_("iVarNames",(function()
return ((self):send_("newArray"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$iVarNames\"]","iVarNames");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("i","#iVarNames");
	return ((_s8_rec):cr())
end
)(self);
(self):while_do_("i > 0",(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$fn\"].prototype[\"@\"..iVarNames[i]]","aValue");
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("i","i - 1"))
end));
return (self);
end
,"lua-private","setVarNamesImplementation\r\n\t\" Private - Implementation of private function. \"\r\n\r\n\tself if: [self expr: #iVarNames eqeq: #nil] do: [\r\n\t\tself assign: #iVarNames to: [self send: #newArray ]\r\n\t];cr.\r\n\tself assign: 'aClass[\"$iVarNames\"]' to: #iVarNames;cr.\r\n\tself local: #i with: '#iVarNames';cr.\r\n\tself while: 'i > 0' do: [\r\n\t\tself assign: 'aClass[\"$fn\"].prototype[\"@\"..iVarNames[i]]' to: #aValue;cr.\r\n\t\tself assign: #i to: 'i - 1'\r\n\t]. ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"iVarNames\",\"nil\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"iVarNames\",(function()\r\nreturn ((self):send_(\"newArray\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$iVarNames\\\"]\",\"iVarNames\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"i\",\"#iVarNames\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):while_do_(\"i > 0\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$fn\\\"].prototype[\\\"@\\\"..iVarNames[i]]\",\"aValue\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"i\",\"i - 1\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"setClassImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$className\"]","spec.className");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_eqeq_("spec.meta","nil"))
end),(function()
return ((self):assign_to_("aClass[\"$klass\"][\"@instanceClass\"]","aClass"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$category\"]",(function()
return ((self):expr_or_("spec.category",(self):emptyString()))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$superclass\"]","spec.superclass --or nil");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("aClass[\"$superclass\"]",(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$superclass\"][\"@subclasses\"]","nil");
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_("aClass[\"$klass\"]",(function()
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_and_("spec.meta",(function()
return ((self):expr_noteq_("aClass[\"$klass\"]","self.Metaclass"))
end)))
end),(function()
return ((self):assign_to_("aClass[\"$klass\"][\"$superclass\"]","aClass[\"$superclass\"][\"$klass\"]"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_noteq_("self.Metaclass","nil"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):comment_("OBSOLETE - Metaclass validation & repair");
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):expr_noteq_("self.Metaclass[\"$superclass\"]","self.Behavior"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):callPrint_("\"-- Warning broken Metaclass spec.meta=\"..tostring(spec.meta)..\" aClass=\"..aClass[\"$className\"]");
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("self.Metaclass[\"$superclass\"]","self.Behavior"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_("aClass[\"$klass\"][\"$superclass\"]",(function()
return ((self):assign_to_("aClass[\"$klass\"][\"$superclass\"][\"@subclasses\"]","nil"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$fn\"]",(function()
return ((self):send_with_("fnInSpec","spec"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setVarNames",smalltalk:newArray({"aClass", "spec.iVarNames", "nil"}));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("aClass");
return (self);
end
,"lua-private","setClassImplementation\r\n\t\" Private - Implementation of private function. \"\r\n\r\n\tself assign: 'aClass[\"$className\"]' to: 'spec.className';cr.\r\n\tself if: [self expr: 'spec.meta' eqeq: #nil] do: [\r\n\t\tself assign: 'aClass[\"$klass\"][\"@instanceClass\"]' to: #aClass\r\n\t];cr.\r\n\tself assign: 'aClass[\"$category\"]' to: [self expr: 'spec.category' or: self emptyString];cr.\r\n\tself assign: 'aClass[\"$superclass\"]' to: 'spec.superclass --or nil';cr.\r\n\tself if: 'aClass[\"$superclass\"]' do: [\r\n\t\tself assign: 'aClass[\"$superclass\"][\"@subclasses\"]' to: #nil;cr.\r\n\t\tself if: 'aClass[\"$klass\"]' do: [\r\n\t\t\tself if: [self expr: 'spec.meta'\r\n\t\t\t\tand: [self expr: 'aClass[\"$klass\"]' noteq: 'self.Metaclass']] do: [\r\n\t\t\t\tself assign: 'aClass[\"$klass\"][\"$superclass\"]' to: 'aClass[\"$superclass\"][\"$klass\"]'\r\n\t\t\t];cr.\r\n\t\t\tself if: [self expr: 'self.Metaclass' noteq: #nil] do: [ \r\n\t\t\t\tself comment: 'OBSOLETE - Metaclass validation & repair';cr.\r\n\t\t\t\tself if: [self expr: 'self.Metaclass[\"$superclass\"]' noteq: 'self.Behavior'] do: [\r\n\t\t\t\t\tself callPrint: '\"-- Warning broken Metaclass spec.meta=\"..tostring(spec.meta)..\" aClass=\"..aClass[\"$className\"]';cr.\r\n\t\t\t\t\tself assign: 'self.Metaclass[\"$superclass\"]' to: 'self.Behavior'\r\n\t\t\t\t].\r\n\t\t\t];cr.\r\n\t\t\tself if: 'aClass[\"$klass\"][\"$superclass\"]' do: [\r\n\t\t\t\tself assign: 'aClass[\"$klass\"][\"$superclass\"][\"@subclasses\"]' to: #nil\r\n\t\t\t].\r\n\t\t].\r\n\t];cr.\r\n\tself assign: 'aClass[\"$fn\"]' to: [self send: #fnInSpec with: #spec];cr.\r\n\tself send: #setVarNames withArguments: #(aClass 'spec.iVarNames' #nil);cr.\r\n\tself return: #aClass ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$className\\\"]\",\"spec.className\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"spec.meta\",\"nil\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"aClass[\\\"$klass\\\"][\\\"@instanceClass\\\"]\",\"aClass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$category\\\"]\",(function()\r\nreturn ((self):expr_or_(\"spec.category\",(self):emptyString()))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$superclass\\\"]\",\"spec.superclass --or nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"aClass[\\\"$superclass\\\"]\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$superclass\\\"][\\\"@subclasses\\\"]\",\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_(\"aClass[\\\"$klass\\\"]\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_and_(\"spec.meta\",(function()\r\nreturn ((self):expr_noteq_(\"aClass[\\\"$klass\\\"]\",\"self.Metaclass\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"aClass[\\\"$klass\\\"][\\\"$superclass\\\"]\",\"aClass[\\\"$superclass\\\"][\\\"$klass\\\"]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_noteq_(\"self.Metaclass\",\"nil\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"OBSOLETE - Metaclass validation & repair\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):expr_noteq_(\"self.Metaclass[\\\"$superclass\\\"]\",\"self.Behavior\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):callPrint_(\"\\\"-- Warning broken Metaclass spec.meta=\\\"..tostring(spec.meta)..\\\" aClass=\\\"..aClass[\\\"$className\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"self.Metaclass[\\\"$superclass\\\"]\",\"self.Behavior\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_(\"aClass[\\\"$klass\\\"][\\\"$superclass\\\"]\",(function()\r\nreturn ((self):assign_to_(\"aClass[\\\"$klass\\\"][\\\"$superclass\\\"][\\\"@subclasses\\\"]\",\"nil\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$fn\\\"]\",(function()\r\nreturn ((self):send_with_(\"fnInSpec\",\"spec\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setVarNames\",smalltalk:newArray({\"aClass\", \"spec.iVarNames\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"aClass\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"fnInSpecImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_and_("spec.meta",(function()
return ((self):expr_eqeq_("spec.superclass","nil"))
end)))
end),(function()
return ((self):assign_to_("spec.superclass","self.Class"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("spec.fn",(function()
(
function(_s8_rec)
	(_s8_rec):if_do_("spec.superclass",(function()
return ((self):send_withArguments_("setProtoOf:to:",smalltalk:newArray({"spec.fn.prototype", "spec.superclass[\"$fn\"].prototype"})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("spec.fn"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("superC","nil");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("spec.superclass",(function()
return ((self):assign_to_("superC","spec.superclass[\"$fn\"]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_with_("newConstructor","superC"))
end));
return (self);
end
,"lua-private","fnInSpecImplementation\r\n\t\" Private - Implementation of private function. \"\r\n\r\n\tself if: [self expr: 'spec.meta' and: [self expr: 'spec.superclass' eqeq: #nil]] do: [\r\n\t\tself assign: 'spec.superclass' to: 'self.Class'\r\n\t];cr.\r\n\tself if: 'spec.fn' do: [\r\n\t\tself if: 'spec.superclass' do: [\r\n\t\t\tself send: #setProtoOf:to: withArguments: #(\r\n\t\t\t\t'spec.fn.prototype' 'spec.superclass[\"$fn\"].prototype'\r\n\t\t\t)\r\n\t\t];cr.\r\n\t\tself return: 'spec.fn'\r\n\t];cr.\r\n\tself local: #superC with: #nil;cr.\r\n\tself if: 'spec.superclass' do: [\r\n\t\tself assign: #superC to: 'spec.superclass[\"$fn\"]'\r\n\t];cr.\r\n\tself return: [self send: #newConstructor with: #superC] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_and_(\"spec.meta\",(function()\r\nreturn ((self):expr_eqeq_(\"spec.superclass\",\"nil\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"spec.superclass\",\"self.Class\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"spec.fn\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"spec.superclass\",(function()\r\nreturn ((self):send_withArguments_(\"setProtoOf:to:\",smalltalk:newArray({\"spec.fn.prototype\", \"spec.superclass[\\\"$fn\\\"].prototype\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"spec.fn\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"superC\",\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"spec.superclass\",(function()\r\nreturn ((self):assign_to_(\"superC\",\"spec.superclass[\\\"$fn\\\"]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"newConstructor\",\"superC\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"systemDictionaryAPI",0
,function(self)
(smalltalk:newArray({"classes", "computeSubclasses", smalltalk:newArray({"subclasses", smalltalk:newArray({"aClass"})}), smalltalk:newArray({"allSubclassesDo", smalltalk:newArray({"aClass", "aBlock"})}), smalltalk:newArray({"mapClassName", smalltalk:newArray({"className", "category", "fn", "superclass"})}), smalltalk:newArray({"isArray:equalTo:", smalltalk:newArray({"table1", "table2"})}), smalltalk:newArray({"isObject:equalTo:", smalltalk:newArray({"receiver", "anObject"})}), smalltalk:newArray({"object:comma:", smalltalk:newArray({"receiver", "anObject"})}), smalltalk:newArray({"boolean:and:", smalltalk:newArray({"receiver", "option"})}), smalltalk:newArray({"boolean:or:", smalltalk:newArray({"receiver", "option"})}), smalltalk:newArray({"booleanNot:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"times:repeat:", smalltalk:newArray({"count", "aBlock"})}), smalltalk:newArray({"if:nil:notNil:", smalltalk:newArray({"anObject", "block1", "block2"})}), smalltalk:newArray({"if:true:false:", smalltalk:newArray({"aBoolean", "blk1", "blk2"})}), smalltalk:newArray({"while:do:", smalltalk:newArray({"condition", "aBlock"})}), smalltalk:newArray({"whileNot:do:", smalltalk:newArray({"condition", "aBlock"})}), smalltalk:newArray({"asCharacter:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"toString:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"printString:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"asString:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"mustBeNumber:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"math:max:", smalltalk:newArray({"receiver", "aNumber"})}), smalltalk:newArray({"math:min:", smalltalk:newArray({"receiver", "aNumber"})}), smalltalk:newArray({"addClass", smalltalk:newArray({"className", "superclass", "iVarNames", "category"})}), smalltalk:newArray({"renameClass", smalltalk:newArray({"aClass", "aString"})}), smalltalk:newArray({"removeClass", smalltalk:newArray({"aClass"})}), smalltalk:newArray({"metaVarNames", smalltalk:newArray({"aMetaClass", "iVarNames"})}), smalltalk:newArray({"smDo", smalltalk:newArray({"block"})}), smalltalk:newArray({"classChanged", smalltalk:newArray({"aBehavior"})}), smalltalk:newArray({"classShapeChanged", smalltalk:newArray({"aBehavior"})}), smalltalk:newArray({"aboutToCreateClass", smalltalk:newArray({"className", "superclass", "iVarNames", "category"})}), smalltalk:newArray({"aboutToChangeClass", smalltalk:newArray({"aClass", "superclass", "iVarNames", "category"})}), smalltalk:newArray({"methodBoundTo", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"aboutToBindTo", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"aboutToRemoveFrom", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"methodRemovedFrom", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"objectNotFound", smalltalk:newArray({"object", "indexOrKey", "collection"})}), smalltalk:newArray({"whoImplements", smalltalk:newArray({"klass", "jsSelector"})}), smalltalk:newArray({"superImplementor", smalltalk:newArray({"klass", "jsSelector"})}), smalltalk:newArray({"addMethod", smalltalk:newArray({"jsSelector", "method", "klass"})}), smalltalk:newArray({"bind", smalltalk:newArray({"klass", "stSelector", "jsSelector", "jsFunction", "category", "stSource", "nativeSource", "stamp"})}), smalltalk:newArray({"removeMethod", smalltalk:newArray({"aClass", "aMethod"})}), smalltalk:newArray({"newMethod", smalltalk:newArray({"currentClass", "selector", "fn", "source", "nativeSource", "stamp"})}), smalltalk:newArray({"readJSObject", smalltalk:newArray({"js"})}), smalltalk:newArray({"basen", smalltalk:newArray({"n", "b"})}), smalltalk:newArray({"globalsDo", smalltalk:newArray({"action"})}), smalltalk:newArray({"launchImage", smalltalk:newArray({"imageName"})}), smalltalk:newArray({"is:kindOf:", smalltalk:newArray({"anObject", "aClass"})}), smalltalk:newArray({"responds:to:", smalltalk:newArray({"anObject", "aSelector"})}), smalltalk:newArray({"debugBind", smalltalk:newArray({"klass", "stSelector", "jsSelector", "jsFunction", "category", "stSource", "nativeSource", "stamp"})}), smalltalk:newArray({"debugAddClass", smalltalk:newArray({"className", "superclass", "iVarNames", "category"})}), "toString", "bindCore", "startup"})):do_((function(tuple)
return ((self):bindAPI_(tuple))
end));
return (self);
end
,"implementations","systemDictionaryAPI\r\n\t\" Private - Internal encoding for SystemDictionary messages. \"\r\n\r\n\t#(\t#classes\r\n\t\t#computeSubclasses\r\n\t\t#(subclasses #(aClass))\r\n\t\t#(allSubclassesDo #(aClass aBlock))\r\n\t\t#(mapClassName #(className category fn superclass))\r\n\t\t#(isArray:equalTo: #(table1 table2))\r\n\t\t#(isObject:equalTo: #(receiver anObject))\r\n\t\t#(object:comma: #(receiver anObject))\r\n\t\t#(boolean:and: #(receiver option))\r\n\t\t#(boolean:or: #(receiver option))\r\n\t\t#(booleanNot: #(receiver))\r\n\t\t#(times:repeat: #(count aBlock))\r\n\t\t#(if:nil:notNil: #(anObject block1 block2))\r\n\t\t#(if:true:false: #(aBoolean blk1 blk2))\r\n\t\t#(while:do: #(condition aBlock))\r\n\t\t#(whileNot:do: #(condition aBlock))\r\n\t\t#(asCharacter: #(receiver))\r\n\t\t#(toString: #(receiver))\r\n\t\t#(printString: #(receiver))\r\n\t\t#(asString: #(receiver))\r\n\t\t#(mustBeNumber: #(receiver))\r\n\t\t#(math:max: #(receiver aNumber))\r\n\t\t#(math:min: #(receiver aNumber))\r\n\t\t#(addClass #(className superclass iVarNames category))\r\n\t\t#(renameClass #(aClass aString))\r\n\t\t#(removeClass #(aClass))\r\n\t\t#(metaVarNames #(aMetaClass iVarNames))\r\n\t\t#(smDo #(block))\r\n\t\t#(classChanged #(aBehavior))\r\n\t\t#(classShapeChanged #(aBehavior))\r\n\t\t#(aboutToCreateClass #(className superclass iVarNames category))\r\n\t\t#(aboutToChangeClass #(aClass superclass iVarNames category))\r\n\t\t#(methodBoundTo #(method klass))\r\n\t\t#(aboutToBindTo #(method klass))\r\n\t\t#(aboutToRemoveFrom #(method klass))\r\n\t\t#(methodRemovedFrom #(method klass))\r\n\t\t#(objectNotFound #(object indexOrKey collection))\r\n\t\t#(whoImplements #(klass jsSelector))\r\n\t\t#(superImplementor #(klass jsSelector))\r\n\t\t#(addMethod #(jsSelector method klass))\r\n\t\t#(bind #(klass stSelector jsSelector jsFunction category stSource nativeSource stamp))\r\n\t\t#(removeMethod #(aClass aMethod))\r\n\t\t#(newMethod #(currentClass selector fn source nativeSource stamp))\r\n\"OBSOLETE\t#(method #(spec))\"\r\n\t\t#(readJSObject #(js))\r\n\t\t#(basen #(n b))\r\n\t\t#(globalsDo #(action))\r\n\t\t#(launchImage #(imageName))\r\n\t\t#(is:kindOf: #(anObject aClass))\r\n\t\t#(responds:to: #(anObject aSelector))\r\n\t\t#(debugBind #(klass stSelector jsSelector jsFunction category stSource nativeSource stamp))\r\n\t\t#(debugAddClass #(className superclass iVarNames category))\r\n\t\t#toString\r\n\t\t#bindCore\r\n\t\t#startup\r\n\t) do: [:tuple| self bindAPI: tuple ]","function(self)\r\n(smalltalk:newArray({\"classes\", \"computeSubclasses\", smalltalk:newArray({\"subclasses\", smalltalk:newArray({\"aClass\"})}), smalltalk:newArray({\"allSubclassesDo\", smalltalk:newArray({\"aClass\", \"aBlock\"})}), smalltalk:newArray({\"mapClassName\", smalltalk:newArray({\"className\", \"category\", \"fn\", \"superclass\"})}), smalltalk:newArray({\"isArray:equalTo:\", smalltalk:newArray({\"table1\", \"table2\"})}), smalltalk:newArray({\"isObject:equalTo:\", smalltalk:newArray({\"receiver\", \"anObject\"})}), smalltalk:newArray({\"object:comma:\", smalltalk:newArray({\"receiver\", \"anObject\"})}), smalltalk:newArray({\"boolean:and:\", smalltalk:newArray({\"receiver\", \"option\"})}), smalltalk:newArray({\"boolean:or:\", smalltalk:newArray({\"receiver\", \"option\"})}), smalltalk:newArray({\"booleanNot:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"times:repeat:\", smalltalk:newArray({\"count\", \"aBlock\"})}), smalltalk:newArray({\"if:nil:notNil:\", smalltalk:newArray({\"anObject\", \"block1\", \"block2\"})}), smalltalk:newArray({\"if:true:false:\", smalltalk:newArray({\"aBoolean\", \"blk1\", \"blk2\"})}), smalltalk:newArray({\"while:do:\", smalltalk:newArray({\"condition\", \"aBlock\"})}), smalltalk:newArray({\"whileNot:do:\", smalltalk:newArray({\"condition\", \"aBlock\"})}), smalltalk:newArray({\"asCharacter:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"toString:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"printString:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"asString:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"mustBeNumber:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"math:max:\", smalltalk:newArray({\"receiver\", \"aNumber\"})}), smalltalk:newArray({\"math:min:\", smalltalk:newArray({\"receiver\", \"aNumber\"})}), smalltalk:newArray({\"addClass\", smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"})}), smalltalk:newArray({\"renameClass\", smalltalk:newArray({\"aClass\", \"aString\"})}), smalltalk:newArray({\"removeClass\", smalltalk:newArray({\"aClass\"})}), smalltalk:newArray({\"metaVarNames\", smalltalk:newArray({\"aMetaClass\", \"iVarNames\"})}), smalltalk:newArray({\"smDo\", smalltalk:newArray({\"block\"})}), smalltalk:newArray({\"classChanged\", smalltalk:newArray({\"aBehavior\"})}), smalltalk:newArray({\"classShapeChanged\", smalltalk:newArray({\"aBehavior\"})}), smalltalk:newArray({\"aboutToCreateClass\", smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"})}), smalltalk:newArray({\"aboutToChangeClass\", smalltalk:newArray({\"aClass\", \"superclass\", \"iVarNames\", \"category\"})}), smalltalk:newArray({\"methodBoundTo\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"aboutToBindTo\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"aboutToRemoveFrom\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"methodRemovedFrom\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"objectNotFound\", smalltalk:newArray({\"object\", \"indexOrKey\", \"collection\"})}), smalltalk:newArray({\"whoImplements\", smalltalk:newArray({\"klass\", \"jsSelector\"})}), smalltalk:newArray({\"superImplementor\", smalltalk:newArray({\"klass\", \"jsSelector\"})}), smalltalk:newArray({\"addMethod\", smalltalk:newArray({\"jsSelector\", \"method\", \"klass\"})}), smalltalk:newArray({\"bind\", smalltalk:newArray({\"klass\", \"stSelector\", \"jsSelector\", \"jsFunction\", \"category\", \"stSource\", \"nativeSource\", \"stamp\"})}), smalltalk:newArray({\"removeMethod\", smalltalk:newArray({\"aClass\", \"aMethod\"})}), smalltalk:newArray({\"newMethod\", smalltalk:newArray({\"currentClass\", \"selector\", \"fn\", \"source\", \"nativeSource\", \"stamp\"})}), smalltalk:newArray({\"readJSObject\", smalltalk:newArray({\"js\"})}), smalltalk:newArray({\"basen\", smalltalk:newArray({\"n\", \"b\"})}), smalltalk:newArray({\"globalsDo\", smalltalk:newArray({\"action\"})}), smalltalk:newArray({\"launchImage\", smalltalk:newArray({\"imageName\"})}), smalltalk:newArray({\"is:kindOf:\", smalltalk:newArray({\"anObject\", \"aClass\"})}), smalltalk:newArray({\"responds:to:\", smalltalk:newArray({\"anObject\", \"aSelector\"})}), smalltalk:newArray({\"debugBind\", smalltalk:newArray({\"klass\", \"stSelector\", \"jsSelector\", \"jsFunction\", \"category\", \"stSource\", \"nativeSource\", \"stamp\"})}), smalltalk:newArray({\"debugAddClass\", smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"})}), \"toString\", \"bindCore\", \"startup\"})):do_((function(tuple)\r\nreturn ((self):bindAPI_(tuple))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"classesImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("result",(function()
return ((self):send_("newArray"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("key, aClass",(function()
return ((self):call_with_("pairs","smalltalk"))
end),(function()
return ((self):if_do_((function()
return ((self):typeOf_is_("aClass","table"))
end),(function()
return ((self):if_do_((function()
return ((self):expr_and_("aClass.isClass",(function()
return ((self):send_to_("isClass","aClass"))
end)))
end),(function()
return ((self):assign_to_("result[#result+1]","aClass"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"api","classesImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself local: #result with: [self send: #newArray];cr.\r\n\tself for: 'key, aClass' in: [self call: #pairs with: #smalltalk] do: [\r\n\t\tself if: [self typeOf: #aClass is: #table] do: [\r\n\t\t\tself if: [self expr: 'aClass.isClass' and: [self send: #isClass to: #aClass]] do: [\r\n\t\t\t\tself assign: 'result[#result+1]' to: #aClass\r\n\t\t\t]\r\n\t\t]\r\n\t];cr.\r\n\tself return: #result ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"result\",(function()\r\nreturn ((self):send_(\"newArray\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"key, aClass\",(function()\r\nreturn ((self):call_with_(\"pairs\",\"smalltalk\"))\r\nend),(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):typeOf_is_(\"aClass\",\"table\"))\r\nend),(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):expr_and_(\"aClass.isClass\",(function()\r\nreturn ((self):send_to_(\"isClass\",\"aClass\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"result[#result+1]\",\"aClass\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"computeSubclassesImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_eqeq_("self.Metaclass","nil"))
end),(function()
return ((self):callPrint_("\"-- Warning system broken/incomplete\""))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_noteq_("self.Metaclass[\"$superclass\"]","self.Behavior"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):comment_("OBSOLETE - Metaclass validation & repair");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):callPrint_("\"-- Warning broken Metaclass\"");
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("self.Metaclass[\"$superclass\"]","self.Behavior"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("classes",(function()
return ((self):send_("classes"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("_,cls",(function()
return ((self):call_with_("pairs","classes"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("cls[\"@subclasses\"]",(function()
return ((self):send_("newArray"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):assign_to_("cls[\"$klass\"][\"@subclasses\"]",(function()
return ((self):send_("newArray"))
end));
	return ((_s8_rec):cr())
end
)(self))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("_,cls",(function()
return ((self):call_with_("pairs","classes"))
end),(function()
return ((self):if_do_((function()
return ((self):expr_noteq_("cls[\"$superclass\"]","nil"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):local_with_("array","cls[\"$superclass\"][\"@subclasses\"]");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("array[#array+1]","cls");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("array","cls[\"$superclass\"][\"$klass\"][\"@subclasses\"]");
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("array[#array+1]","cls[\"$klass\"]"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_do_("self.Class",(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("self.Class[\"@subclasses\"]",(function()
return ((self):send_("newArray"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):assign_to_("self.Class[\"$klass\"][\"@subclasses\"]",(function()
return ((self):send_("newArray"))
end));
	return ((_s8_rec):cr())
end
)(self))
end));
return (self);
end
,"api","computeSubclassesImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self expr: 'self.Metaclass' eqeq: #nil] do: [\r\n\t\tself callPrint: '\"-- Warning system broken/incomplete\"'\r\n\t];cr.\r\n\tself if: [self expr: 'self.Metaclass[\"$superclass\"]' noteq: 'self.Behavior'] do: [\r\n\t\tself comment: 'OBSOLETE - Metaclass validation & repair';cr.\r\n\t\tself callPrint: '\"-- Warning broken Metaclass\"';cr.\r\n\t\tself assign: 'self.Metaclass[\"$superclass\"]' to: 'self.Behavior'\r\n\t];cr.\r\n\tself local: #classes with: [self send: #classes];cr.\r\n\tself for: '_,cls' in: [self call: #pairs with: #classes] do: [\r\n\t\tself assign: 'cls[\"@subclasses\"]' to: [self send: #newArray];cr.\r\n\t\tself assign: 'cls[\"$klass\"][\"@subclasses\"]' to: [self send: #newArray];cr.\r\n\t];cr.\r\n\tself for: '_,cls' in: [self call: #pairs with: #classes] do: [\r\n\t\tself if: [self expr: 'cls[\"$superclass\"]' noteq: #nil] do: [\r\n\t\t\tself local: #array with: 'cls[\"$superclass\"][\"@subclasses\"]';cr.\r\n\t\t\tself assign: 'array[#array+1]' to: #cls;cr.\r\n\t\t\tself assign: #array to: 'cls[\"$superclass\"][\"$klass\"][\"@subclasses\"]';cr.\r\n\t\t\tself assign: 'array[#array+1]' to: 'cls[\"$klass\"]'\r\n\t\t]\r\n\t];cr.\r\n\tself if: 'self.Class' do: [\r\n\t\tself assign: 'self.Class[\"@subclasses\"]' to: [self send: #newArray];cr.\r\n\t\tself assign: 'self.Class[\"$klass\"][\"@subclasses\"]' to: [self send: #newArray];cr.\r\n\t] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"self.Metaclass\",\"nil\"))\r\nend),(function()\r\nreturn ((self):callPrint_(\"\\\"-- Warning system broken/incomplete\\\"\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_noteq_(\"self.Metaclass[\\\"$superclass\\\"]\",\"self.Behavior\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"OBSOLETE - Metaclass validation & repair\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):callPrint_(\"\\\"-- Warning broken Metaclass\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"self.Metaclass[\\\"$superclass\\\"]\",\"self.Behavior\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"classes\",(function()\r\nreturn ((self):send_(\"classes\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"_,cls\",(function()\r\nreturn ((self):call_with_(\"pairs\",\"classes\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"cls[\\\"@subclasses\\\"]\",(function()\r\nreturn ((self):send_(\"newArray\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"cls[\\\"$klass\\\"][\\\"@subclasses\\\"]\",(function()\r\nreturn ((self):send_(\"newArray\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"_,cls\",(function()\r\nreturn ((self):call_with_(\"pairs\",\"classes\"))\r\nend),(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):expr_noteq_(\"cls[\\\"$superclass\\\"]\",\"nil\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"array\",\"cls[\\\"$superclass\\\"][\\\"@subclasses\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"array[#array+1]\",\"cls\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"array\",\"cls[\\\"$superclass\\\"][\\\"$klass\\\"][\\\"@subclasses\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"array[#array+1]\",\"cls[\\\"$klass\\\"]\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_do_(\"self.Class\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self.Class[\\\"@subclasses\\\"]\",(function()\r\nreturn ((self):send_(\"newArray\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self.Class[\\\"$klass\\\"][\\\"@subclasses\\\"]\",(function()\r\nreturn ((self):send_(\"newArray\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"subclassesImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_eqeq_("aClass[\"@subclasses\"]","nil"))
end),(function()
return ((self):send_("computeSubclasses"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("aClass[\"@subclasses\"]");
return (self);
end
,"api","subclassesImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self expr: 'aClass[\"@subclasses\"]' eqeq: #nil] do: [\r\n\t\tself send: #computeSubclasses\r\n\t];cr.\r\n\tself return: 'aClass[\"@subclasses\"]' ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"aClass[\\\"@subclasses\\\"]\",\"nil\"))\r\nend),(function()\r\nreturn ((self):send_(\"computeSubclasses\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"aClass[\\\"@subclasses\\\"]\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"allSubclassesDoImplementation",0
,function(self)
(self):for_in_do_("_,cls",(function()
return ((self):call_with_("pairs",(function()
return ((self):send_with_("subclasses","aClass"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):call_with_("aBlock","cls");
	return ((_s8_rec):cr())
end
)(self);return ((self):send_withArguments_("allSubclassesDo",smalltalk:newArray({"cls", "aBlock"})))
end));
return (self);
end
,"api","allSubclassesDoImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself for: '_,cls' in: [self call: #pairs with: [self send: #subclasses with: #aClass]] do: [\r\n\t\tself call: #aBlock with: #cls;cr.\r\n\t\tself send: #allSubclassesDo withArguments: #(cls aBlock)\r\n\t]","function(self)\r\n(self):for_in_do_(\"_,cls\",(function()\r\nreturn ((self):call_with_(\"pairs\",(function()\r\nreturn ((self):send_with_(\"subclasses\",\"aClass\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"aBlock\",\"cls\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_withArguments_(\"allSubclassesDo\",smalltalk:newArray({\"cls\", \"aBlock\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"mapClassNameImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("spec",(function()
return ((self):object_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((("className"):_minus_gt("className")),("category"):_minus_gt("category"))),("superclass"):_minus_gt("superclass"))),("fn"):_minus_gt("fn"))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("self[className]",(function()
return ((self):return_((function()
return ((self):send_withArguments_("setClass",smalltalk:newArray({"self[className]", "spec"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[className]",(function()
return ((self):send_with_("klass","spec"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("self[className]");
return (self);
end
,"api","mapClassNameImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself local: #spec with: [self object:\r\n\t\t#className -> #className\r\n\t\t,(#category -> #category) \r\n\t\t,(#superclass -> #superclass)\r\n\t\t,(#fn -> #fn)];cr.\r\n\tself if: 'self[className]' do: [\r\n\t\tself return: [self send: #setClass withArguments: #('self[className]' spec)]\r\n\t];cr.\r\n\tself assign: 'self[className]' to: [self send: #klass with: #spec];cr.\r\n\tself return: 'self[className]'","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"spec\",(function()\r\nreturn ((self):object_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((\"className\"):_minus_gt(\"className\")),(\"category\"):_minus_gt(\"category\"))),(\"superclass\"):_minus_gt(\"superclass\"))),(\"fn\"):_minus_gt(\"fn\"))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"self[className]\",(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_withArguments_(\"setClass\",smalltalk:newArray({\"self[className]\", \"spec\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[className]\",(function()\r\nreturn ((self):send_with_(\"klass\",\"spec\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"self[className]\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"isArray_equalTo_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeq_("table1","table2"))
end),"true");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_noteq_("#table1","#table2"))
end),"false");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("i","#table1");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):while_do_("i > 0",(function()
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_noteq_("table1[i]","table2[i]"))
end),"false");
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("i","i - 1"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("true");
return (self);
end
,"api","isArray_equalTo_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self expr: #table1 eqeq: #table2] return: #true;cr.\r\n\tself if: [self expr: '#table1' noteq: '#table2'] return: #false;cr.\r\n\tself local: #i with: '#table1';cr.\r\n\tself while: 'i > 0' do: [\r\n\t\tself if: [self expr: 'table1[i]' noteq: 'table2[i]'] return: #false;cr.\r\n\t\tself assign: #i to: 'i - 1'\r\n\t];cr.\r\n\tself return: #true ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"table1\",\"table2\"))\r\nend),\"true\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_noteq_(\"#table1\",\"#table2\"))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"i\",\"#table1\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):while_do_(\"i > 0\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_noteq_(\"table1[i]\",\"table2[i]\"))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"i\",\"i - 1\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"true\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"isObject_equalTo_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeq_("receiver","anObject"))
end),"true");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_and_((function()
return ((self):typeOf_is_("receiver","table"))
end),(function()
return ((self):typeOf_is_("anObject","table"))
end)))
end),(function()
return ((self):if_do_("receiver[\"_eq\"]",(function()
return ((self):return_((function()
return ((self):send_to_with_("=","receiver","anObject"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("false");
return (self);
end
,"api","isObject_equalTo_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self expr: #receiver eqeq: #anObject] return: #true;cr.\r\n\tself if: [self expr: [self typeOf: #receiver is: #table]\r\n\t\t and: [ self typeOf: #anObject is: #table]] do: [\r\n\t\tself if: 'receiver[\"_eq\"]' do: [\r\n\t\t\tself return: [self send: #= to: #receiver with: #anObject]\r\n\t\t].\r\n\t];cr.\r\n\tself return: #false ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"receiver\",\"anObject\"))\r\nend),\"true\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):typeOf_is_(\"receiver\",\"table\"))\r\nend),(function()\r\nreturn ((self):typeOf_is_(\"anObject\",\"table\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):if_do_(\"receiver[\\\"_eq\\\"]\",(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_with_(\"=\",\"receiver\",\"anObject\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"false\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"object_comma_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):typeOf_is_("receiver","string"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_is_("anObject","string"))
end),(function()
return ((self):concat_with_("receiver","anObject"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_is_("anObject","number"))
end),(function()
return ((self):concat_with_("receiver",(function()
return ((self):call_with_("tostring","anObject"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_((function()
return ((self):send_withArguments_("object:comma:",(smalltalk.Array):with_with_("receiver",(function()
return ((self):send_to_with_("toString:","receiver","anObject"))
end))))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):typeOf_is_("receiver","number"))
end),(function()
return ((self):return_((function()
return ((self):send_withArguments_("object:comma:",(smalltalk.Array):with_with_((function()
return ((self):call_with_("tostring","receiver"))
end),"anObject")))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):typeOf_is_("receiver","table"))
end)))
end),(function()
return ((self):return_((function()
return ((self):send_withArguments_("object:comma:",(smalltalk.Array):with_with_((function()
return ((self):send_with_("toString:","receiver"))
end),"anObject")))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_with_(",","receiver","anObject"))
end));
return (self);
end
,"api","object_comma_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self typeOf: #receiver is: #string] do: [\r\n\t\tself if: [self typeOf: #anObject is: #string] return: [self concat: #receiver with: #anObject];cr.\r\n\t\tself if: [self typeOf: #anObject is: #number] return: [self concat: #receiver\r\n\t\t\twith: [self call: #tostring with: #anObject]];cr.\r\n\t\tself return: [self send: #object:comma: withArguments: (Array with: #receiver\r\n\t\t\twith: [self send: #toString: to: #receiver with: #anObject])]\r\n\t];cr.\r\n\tself if: [self typeOf: #receiver is: #number] do: [\r\n\t\tself return: [self send: #object:comma:\r\n\t\t\twithArguments: (Array with: [self call: #tostring with: #receiver] with: #anObject)]\r\n\t];cr.\r\n\tself if: [self not: [self typeOf: #receiver is: #table]] do: [\r\n\t\tself return: [self send: #object:comma: withArguments: (Array\r\n\t\t\t\twith: [self send: #toString: with: #receiver]\r\n\t\t\t\twith: #anObject)]\r\n\t];cr.\r\n\tself return: [self send: #, to: #receiver with: #anObject] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):typeOf_is_(\"receiver\",\"string\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_is_(\"anObject\",\"string\"))\r\nend),(function()\r\nreturn ((self):concat_with_(\"receiver\",\"anObject\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_is_(\"anObject\",\"number\"))\r\nend),(function()\r\nreturn ((self):concat_with_(\"receiver\",(function()\r\nreturn ((self):call_with_(\"tostring\",\"anObject\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_((function()\r\nreturn ((self):send_withArguments_(\"object:comma:\",(smalltalk.Array):with_with_(\"receiver\",(function()\r\nreturn ((self):send_to_with_(\"toString:\",\"receiver\",\"anObject\"))\r\nend))))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):typeOf_is_(\"receiver\",\"number\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_withArguments_(\"object:comma:\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):call_with_(\"tostring\",\"receiver\"))\r\nend),\"anObject\")))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):typeOf_is_(\"receiver\",\"table\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_withArguments_(\"object:comma:\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):send_with_(\"toString:\",\"receiver\"))\r\nend),\"anObject\")))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\",\",\"receiver\",\"anObject\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"boolean_and_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_noteq_("receiver","true"))
end),"false");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_is_("option","function"))
end),(function()
return ((self):call_("option"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_is_("option","boolean"))
end),"option");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):expr_eqeq_((function()
return ((self):send_to_("evaluate","option"))
end),"true"))
end));
return (self);
end
,"api","boolean_and_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self expr: #receiver noteq: #true] return: #false;cr.\r\n\tself if: [self typeOf: #option is: #function] return: [self call: #option];cr.\r\n\tself if: [self typeOf: #option is: #boolean] return: #option;cr.\r\n\tself return: [self expr: [self send: #evaluate to: #option] eqeq: #true]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_noteq_(\"receiver\",\"true\"))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_is_(\"option\",\"function\"))\r\nend),(function()\r\nreturn ((self):call_(\"option\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_is_(\"option\",\"boolean\"))\r\nend),\"option\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):send_to_(\"evaluate\",\"option\"))\r\nend),\"true\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"boolean_or_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeq_("receiver","true"))
end),"true");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_is_("option","function"))
end),(function()
return ((self):call_("option"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_is_("option","boolean"))
end),"option");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):expr_eqeq_((function()
return ((self):send_to_("evaluate","option"))
end),"true"))
end));
return (self);
end
,"api","boolean_or_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self expr: #receiver eqeq: #true] return: #true;cr.\r\n\tself if: [self typeOf: #option is: #function] return: [self call: #option];cr.\r\n\tself if: [self typeOf: #option is: #boolean] return: #option;cr.\r\n\tself return: [self expr: [self send: #evaluate to: #option] eqeq: #true]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"receiver\",\"true\"))\r\nend),\"true\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_is_(\"option\",\"function\"))\r\nend),(function()\r\nreturn ((self):call_(\"option\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_is_(\"option\",\"boolean\"))\r\nend),\"option\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):send_to_(\"evaluate\",\"option\"))\r\nend),\"true\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"booleanNot_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeq_("receiver","true"))
end),"false");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_isNot_("receiver","table"))
end),"not receiver");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_("__not","receiver"))
end));
return (self);
end
,"api","booleanNot_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self expr: #receiver eqeq: #true] return: #false;cr.\r\n\tself if: [self typeOf: #receiver isNot: #table] return: 'not receiver';cr.\r\n\tself return: [self send: '__not' to: #receiver]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"receiver\",\"true\"))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_isNot_(\"receiver\",\"table\"))\r\nend),\"not receiver\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_(\"__not\",\"receiver\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"times_repeat_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):for_do_("i=1,count",(function()
return ((self):call_with_("aBlock","i"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("count");
return (self);
end
,"api","times_repeat_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself for: 'i=1,count' do: [\r\n\t\tself call: #aBlock with: #i\r\n\t];cr.\r\n\tself return: #count","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_do_(\"i=1,count\",(function()\r\nreturn ((self):call_with_(\"aBlock\",\"i\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"count\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"if_nil_notNil_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("isNil:","anObject"))
end),(function()
return ((self):return_((function()
return ((self):send_to_("evaluate","block1"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_("evaluate","block2"))
end));
return (self);
end
,"api","if_nil_notNil_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self send: #isNil: with: #anObject] do: [\r\n\t\tself return: [self send: #evaluate to: #block1]\r\n\t];cr.\r\n\tself return: [self send: #evaluate to: #block2] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"anObject\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_(\"evaluate\",\"block1\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_(\"evaluate\",\"block2\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"if_true_false_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):expr_eqeq_("aBoolean","true"))
end),(function()
return ((self):if_return_("blk1",(function()
return ((self):call_("blk1"))
end)))
end),(function()
return ((self):if_return_("blk2",(function()
return ((self):call_("blk2"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("nil");
return (self);
end
,"api","if_true_false_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self expr: #aBoolean eqeq: #true] do: [\r\n\t\tself if: #blk1 return: [self call: #blk1]\r\n\t] else: [\r\n\t\tself if: #blk2 return: [self call: #blk2]\r\n\t];cr.\r\n\tself return: #nil ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):expr_eqeq_(\"aBoolean\",\"true\"))\r\nend),(function()\r\nreturn ((self):if_return_(\"blk1\",(function()\r\nreturn ((self):call_(\"blk1\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):if_return_(\"blk2\",(function()\r\nreturn ((self):call_(\"blk2\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"nil\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"while_do_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):while_do_((function()
return ((self):expr_eqeq_((function()
return ((self):call_("condition"))
end),"true"))
end),(function()
return ((self):if_do_("aBlock",(function()
return ((self):call_("aBlock"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("nil");
return (self);
end
,"api","while_do_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself while: [self expr: [self call: #condition] eqeq: #true] do: [\r\n\t\tself if: #aBlock do: [ self call: #aBlock ]\r\n\t];cr.\r\n\tself return: #nil ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):while_do_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):call_(\"condition\"))\r\nend),\"true\"))\r\nend),(function()\r\nreturn ((self):if_do_(\"aBlock\",(function()\r\nreturn ((self):call_(\"aBlock\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"nil\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"whileNot_do_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):while_do_((function()
return ((self):expr_eqeq_((function()
return ((self):call_("condition"))
end),"false"))
end),(function()
return ((self):if_do_("aBlock",(function()
return ((self):call_("aBlock"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("nil");
return (self);
end
,"api","whileNot_do_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself while: [self expr: [self call: #condition] eqeq: #false] do: [\r\n\t\tself if: #aBlock do: [ self call: #aBlock ]\r\n\t];cr.\r\n\tself return: #nil ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):while_do_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):call_(\"condition\"))\r\nend),\"false\"))\r\nend),(function()\r\nreturn ((self):if_do_(\"aBlock\",(function()\r\nreturn ((self):call_(\"aBlock\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"nil\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"asCharacter_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):typeOf_is_("receiver","number"))
end),(function()
return ((self):return_((function()
return ((self):call_with_("string.char","receiver"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_("asCharacter","receiver"))
end));
return (self);
end
,"api","asCharacter_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self typeOf: #receiver is: #number] do: [\r\n\t\tself return: [self call: 'string.char' with: #receiver]\r\n\t];cr.\r\n\tself return: [self send: #asCharacter to: #receiver]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):typeOf_is_(\"receiver\",\"number\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):call_with_(\"string.char\",\"receiver\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_(\"asCharacter\",\"receiver\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"toString_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("aType",(function()
return ((self):call_with_("type","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeq_("aType","\"string\""))
end),"receiver");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeq_("aType","\"number\""))
end),(function()
return ((self):call_with_("tostring","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_eqeq_("aType","\"boolean\""))
end),(function()
(
function(_s8_rec)
	(_s8_rec):if_return_("receiver","\"true\"");
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("\"false\""))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_is_("receiver.toString","function"))
end),(function()
return ((self):send_to_("toString","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_with_("tostring","receiver"))
end));
return (self);
end
,"api","toString_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself local: #aType with: [self call: #type with: #receiver];cr.\r\n\tself if: [self expr: #aType eqeq: '\"string\"'] return: #receiver;cr.\r\n\tself if: [self expr: #aType eqeq: '\"number\"'] return: [self call: #tostring with: #receiver];cr.\r\n\tself if: [self expr: #aType eqeq: '\"boolean\"'] do: [\r\n\t\tself if: #receiver return: '\"true\"';cr.\r\n\t\tself return: '\"false\"'\r\n\t];cr.\r\n\tself if: [self typeOf: 'receiver.toString' is: #function]\r\n\t\treturn: [self send: #toString to: #receiver ];cr.\r\n\tself return: [self call: #tostring with: #receiver] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"aType\",(function()\r\nreturn ((self):call_with_(\"type\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"aType\",\"\\\"string\\\"\"))\r\nend),\"receiver\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"aType\",\"\\\"number\\\"\"))\r\nend),(function()\r\nreturn ((self):call_with_(\"tostring\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"aType\",\"\\\"boolean\\\"\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_(\"receiver\",\"\\\"true\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"\\\"false\\\"\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_is_(\"receiver.toString\",\"function\"))\r\nend),(function()\r\nreturn ((self):send_to_(\"toString\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"tostring\",\"receiver\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"printString_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_is_("receiver","string"))
end),(function()
return ((self):send_to_("printString","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_and_((function()
return ((self):typeOf_is_("receiver","table"))
end),"receiver.printString"))
end),(function()
return ((self):send_to_("printString","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_with_("tostring","receiver"))
end));
return (self);
end
,"api","printString_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self typeOf: #receiver is: #string] return: [self send: #printString to: #receiver];cr.\r\n\tself if: [self expr: [self typeOf: #receiver is: #table]\r\n\t\tand: 'receiver.printString'] return: [self send: #printString to: #receiver];cr.\r\n\tself return: [self call: #tostring with: #receiver] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_is_(\"receiver\",\"string\"))\r\nend),(function()\r\nreturn ((self):send_to_(\"printString\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):typeOf_is_(\"receiver\",\"table\"))\r\nend),\"receiver.printString\"))\r\nend),(function()\r\nreturn ((self):send_to_(\"printString\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"tostring\",\"receiver\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"asString_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_and_((function()
return ((self):typeOf_is_("receiver","table"))
end),"receiver.asString"))
end),(function()
return ((self):send_to_("asString","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_with_("tostring","receiver"))
end));
return (self);
end
,"api","asString_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self expr: [self typeOf: #receiver is: #table]\r\n\t\tand: 'receiver.asString'] return: [self send: #asString to: #receiver];cr.\r\n\tself return: [self call: #tostring with: #receiver] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):typeOf_is_(\"receiver\",\"table\"))\r\nend),\"receiver.asString\"))\r\nend),(function()\r\nreturn ((self):send_to_(\"asString\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"tostring\",\"receiver\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"mustBeNumber_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_is_("receiver","number"))
end),"receiver");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_is_("receiver","table"))
end),(function()
return ((self):send_to_("mustBeNumber","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_with_("error:","\"Must be a Number\""))
end));
return (self);
end
,"api","mustBeNumber_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self typeOf: #receiver is: #number] return: #receiver;cr.\r\n\tself if: [self typeOf: #receiver is: #table] return: [self send: #mustBeNumber to: #receiver];cr.\r\n\tself return: [self send: #error: with: '\"Must be a Number\"'] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_is_(\"receiver\",\"number\"))\r\nend),\"receiver\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_is_(\"receiver\",\"table\"))\r\nend),(function()\r\nreturn ((self):send_to_(\"mustBeNumber\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"error:\",\"\\\"Must be a Number\\\"\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"math_max_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_isNot_("receiver","number"))
end),(function()
return ((self):send_to_with_("max:","receiver","aNumber"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_isNot_("aNumber","number"))
end),(function()
return ((self):send_to_with_("max:","aNumber","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_("receiver>aNumber","receiver");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("aNumber");
return (self);
end
,"api","math_max_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self typeOf: #receiver isNot: #number] return: [self send: #max: to: #receiver with: #aNumber];cr.\r\n\tself if: [self typeOf: #aNumber isNot: #number] return: [self send: #max: to: #aNumber with: #receiver];cr.\r\n\tself if: 'receiver>aNumber' return: #receiver;cr.\r\n\tself return: #aNumber ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_isNot_(\"receiver\",\"number\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"max:\",\"receiver\",\"aNumber\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_isNot_(\"aNumber\",\"number\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"max:\",\"aNumber\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_(\"receiver>aNumber\",\"receiver\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"aNumber\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"math_min_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_isNot_("receiver","number"))
end),(function()
return ((self):send_to_with_("min:","receiver","aNumber"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):typeOf_isNot_("aNumber","number"))
end),(function()
return ((self):send_to_with_("min:","aNumber","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_("receiver<aNumber","receiver");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("aNumber");
return (self);
end
,"api","math_min_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self typeOf: #receiver isNot: #number] return: [self send: #min: to: #receiver with: #aNumber];cr.\r\n\tself if: [self typeOf: #aNumber isNot: #number] return: [self send: #min: to: #aNumber with: #receiver];cr.\r\n\tself if: 'receiver<aNumber' return: #receiver;cr.\r\n\tself return: #aNumber ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_isNot_(\"receiver\",\"number\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"min:\",\"receiver\",\"aNumber\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):typeOf_isNot_(\"aNumber\",\"number\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"min:\",\"aNumber\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_(\"receiver<aNumber\",\"receiver\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"aNumber\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"addClassImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("debugAddClass",smalltalk:newArray({"className", "superclass", "iVarNames", "category"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_("self[className]",(function()
(
function(_s8_rec)
	(_s8_rec):local_with_("aClass","self[className]");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):local_with_("sameShape",(function()
return ((self):expr_and_((function()
return ((self):expr_eqeq_("aClass[\"$superclass\"]","superclass"))
end),(function()
return ((self):send_withArguments_("isArray:equalTo:",smalltalk:newArray({"aClass[\"$iVarNames\"]", "iVarNames"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_and_("sameShape",(function()
return ((self):expr_eqeq_("aClass[\"$category\"]","category"))
end)))
end),(function()
return ((self):return_("aClass"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_withArguments_("aboutToChangeClass",smalltalk:newArray({"aClass", "superclass", "iVarNames", "category"}));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_("aClass[\"$superclass\"]",(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$superclass\"][\"@subclasses\"]","nil");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):local_with_("aMeta","aClass[\"$klass\"]");
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):expr_and_("aMeta","superclass"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("aMeta[\"$superclass\"][\"@subclasses\"]","nil");
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("aMeta[\"$superclass\"]","superclass[\"$klass\"]"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$superclass\"]","superclass");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_and_("superclass","superclass[\"@subclasses\"]"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_eqeq_("superclass[\"@subclasses\"]","nil"))
end),(function()
return ((self):assign_to_("superclass[\"@subclasses\"]",(function()
return ((self):send_("newArray"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):call_with_("superclass[\"@subclasses\"].push","aClass"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setVarNames",smalltalk:newArray({"aClass", "iVarNames", "nil"}));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$category\"]",(function()
return ((self):expr_or_("category","aClass[\"$category\"]"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):expr_eqeq_("sameShape","nil"))
end),(function()
return ((self):send_with_("classShapeChanged","aClass"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("aboutToCreateClass",smalltalk:newArray({"className", "superclass", "iVarNames", "category"}));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("self[className]",(function()
return ((self):send_with_("klass",(function()
return ((self):object_(smalltalk:object_comma_((smalltalk:object_comma_((("className"):_minus_gt("className")),("iVarNames"):_minus_gt("iVarNames"))),("superclass"):_minus_gt("superclass"))))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("self[className][\"$category\"]",(function()
return ((self):expr_or_("category",(self):emptyString()))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("classChanged","self[className]");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("self[className]");
return (self);
end
,"api","addClassImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself send: #debugAddClass withArguments: #(className superclass iVarNames category);cr.\r\n\tself if: 'self[className]' do: [\r\n\t\tself local: #aClass with: 'self[className]';cr.\r\n\t\tself local: #sameShape with: [\r\n\t\t\tself expr: [self expr: 'aClass[\"$superclass\"]' eqeq: #superclass]\r\n\t\t\t      and: [ self send: #isArray:equalTo: withArguments: #('aClass[\"$iVarNames\"]' iVarNames)\r\n\t\t\t]];cr.\r\n\t\tself if: [self expr: #sameShape and: [\r\n\t\t\tself expr: 'aClass[\"$category\"]' eqeq: #category]] do: [\r\n\t\t\tself return: #aClass\r\n\t\t];cr.\r\n\t\tself send: #aboutToChangeClass withArguments: #(aClass superclass iVarNames category);cr.\r\n\t\tself if: 'aClass[\"$superclass\"]' do: [\r\n\t\t\tself assign: 'aClass[\"$superclass\"][\"@subclasses\"]' to: #nil;cr.\r\n\t\t\tself local: #aMeta with: 'aClass[\"$klass\"]';cr.\r\n\t\t\tself if: [self expr: #aMeta and: #superclass] do: [\r\n\t\t\t\tself assign: 'aMeta[\"$superclass\"][\"@subclasses\"]' to: #nil;cr.\r\n\t\t\t\tself assign: 'aMeta[\"$superclass\"]' to: 'superclass[\"$klass\"]'\r\n\t\t\t]\r\n\t\t];cr.\r\n\t\tself assign: 'aClass[\"$superclass\"]' to: #superclass;cr.\r\n\t\tself if: [self expr: #superclass and: 'superclass[\"@subclasses\"]'] do: [\r\n\t\t\tself if: [self expr: 'superclass[\"@subclasses\"]' eqeq: #nil] do: [\r\n\t\t\t\tself assign: 'superclass[\"@subclasses\"]' to: [self send: #newArray]\r\n\t\t\t];cr.\r\n\t\t\tself call: 'superclass[\"@subclasses\"].push' with: #aClass\r\n\t\t];cr.\r\n\t\tself send: #setVarNames withArguments: #(aClass iVarNames #nil);cr.\r\n\t\tself assign: 'aClass[\"$category\"]' to: [self expr: #category or: 'aClass[\"$category\"]'];cr.\r\n\t\tself if: [self expr: #sameShape eqeq: #nil] do: [\r\n\t\t\tself send: #classShapeChanged with: #aClass\r\n\t\t]\r\n\t] else: [\r\n\t\tself send: #aboutToCreateClass withArguments: #(className superclass iVarNames category);cr.\r\n\t\tself assign: 'self[className]' to: [ self send: #klass with: [\r\n\t\t\tself object: #className -> #className\r\n\t\t\t\t,(#iVarNames -> #iVarNames)\r\n\t\t\t\t,(#superclass -> #superclass)\r\n\t\t]];cr.\r\n\t\tself assign: 'self[className][\"$category\"]' to: [self expr: #category or: self emptyString]\r\n\t];cr.\r\n\tself send: #classChanged with: 'self[className]';cr.\r\n\tself return: 'self[className]' ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"debugAddClass\",smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_(\"self[className]\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"aClass\",\"self[className]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"sameShape\",(function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):expr_eqeq_(\"aClass[\\\"$superclass\\\"]\",\"superclass\"))\r\nend),(function()\r\nreturn ((self):send_withArguments_(\"isArray:equalTo:\",smalltalk:newArray({\"aClass[\\\"$iVarNames\\\"]\", \"iVarNames\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_and_(\"sameShape\",(function()\r\nreturn ((self):expr_eqeq_(\"aClass[\\\"$category\\\"]\",\"category\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):return_(\"aClass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"aboutToChangeClass\",smalltalk:newArray({\"aClass\", \"superclass\", \"iVarNames\", \"category\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"aClass[\\\"$superclass\\\"]\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$superclass\\\"][\\\"@subclasses\\\"]\",\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"aMeta\",\"aClass[\\\"$klass\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):expr_and_(\"aMeta\",\"superclass\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aMeta[\\\"$superclass\\\"][\\\"@subclasses\\\"]\",\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"aMeta[\\\"$superclass\\\"]\",\"superclass[\\\"$klass\\\"]\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$superclass\\\"]\",\"superclass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_and_(\"superclass\",\"superclass[\\\"@subclasses\\\"]\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"superclass[\\\"@subclasses\\\"]\",\"nil\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"superclass[\\\"@subclasses\\\"]\",(function()\r\nreturn ((self):send_(\"newArray\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):call_with_(\"superclass[\\\"@subclasses\\\"].push\",\"aClass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setVarNames\",smalltalk:newArray({\"aClass\", \"iVarNames\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$category\\\"]\",(function()\r\nreturn ((self):expr_or_(\"category\",\"aClass[\\\"$category\\\"]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"sameShape\",\"nil\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"classShapeChanged\",\"aClass\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"aboutToCreateClass\",smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[className]\",(function()\r\nreturn ((self):send_with_(\"klass\",(function()\r\nreturn ((self):object_(smalltalk:object_comma_((smalltalk:object_comma_(((\"className\"):_minus_gt(\"className\")),(\"iVarNames\"):_minus_gt(\"iVarNames\"))),(\"superclass\"):_minus_gt(\"superclass\"))))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"self[className][\\\"$category\\\"]\",(function()\r\nreturn ((self):expr_or_(\"category\",(self):emptyString()))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"classChanged\",\"self[className]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"self[className]\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"renameClassImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[aClass[\"$className\"]]","nil");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$className\"]","aString");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[aString]","aClass");
	return ((_s8_rec):cr())
end
)(self);
(self):send_with_("classChanged","aClass");
return (self);
end
,"api","renameClassImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself assign: 'self[aClass[\"$className\"]]' to: #nil;cr.\r\n\tself assign: 'aClass[\"$className\"]' to: #aString;cr.\r\n\tself assign: 'self[aString]' to: #aClass;cr.\r\n\tself send: #classChanged with: #aClass ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[aClass[\\\"$className\\\"]]\",\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$className\\\"]\",\"aString\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[aString]\",\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):send_with_(\"classChanged\",\"aClass\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"removeClassImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("deleted","\"Deleted-\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("aClass[\"$superclass\"]",(function()
return ((self):assign_to_("aClass[\"$superclass\"][\"@subclasses\"]","nil"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[aClass[\"$className\"]]","nil");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$className\"]",(function()
return ((self):concat_with_("deleted ","aClass[\"$className\"]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$klass\"][\"$className\"]",(function()
return ((self):concat_with_("deleted ","aClass[\"$klass\"][\"$className\"]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):send_with_("classChanged","aClass");
return (self);
end
,"api","removeClassImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself local: #deleted with: '\"Deleted-\"';cr.\r\n\tself if: 'aClass[\"$superclass\"]' do: [\r\n\t\tself assign: 'aClass[\"$superclass\"][\"@subclasses\"]' to: #nil\r\n\t];cr.\r\n\tself assign: 'self[aClass[\"$className\"]]' to: #nil;cr.\r\n\tself assign: 'aClass[\"$className\"]'\r\n\t\tto: [self concat: 'deleted ' with: 'aClass[\"$className\"]'];cr.\r\n\tself assign: 'aClass[\"$klass\"][\"$className\"]'\r\n\t\tto: [self concat: 'deleted ' with: 'aClass[\"$klass\"][\"$className\"]'];cr.\r\n\tself send: #classChanged with: #aClass ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"deleted\",\"\\\"Deleted-\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"aClass[\\\"$superclass\\\"]\",(function()\r\nreturn ((self):assign_to_(\"aClass[\\\"$superclass\\\"][\\\"@subclasses\\\"]\",\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[aClass[\\\"$className\\\"]]\",\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$className\\\"]\",(function()\r\nreturn ((self):concat_with_(\"deleted \",\"aClass[\\\"$className\\\"]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$klass\\\"][\\\"$className\\\"]\",(function()\r\nreturn ((self):concat_with_(\"deleted \",\"aClass[\\\"$klass\\\"][\\\"$className\\\"]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):send_with_(\"classChanged\",\"aClass\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"metaVarNamesImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):send_withArguments_("isArray:equalTo:",smalltalk:newArray({"aMetaClass[\"$iVarNames\"]", "iVarNames"})))
end),"false");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setVarNames",smalltalk:newArray({"aMetaClass", "iVarNames", "nil"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("classShapeChanged","aMetaClass");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("classChanged","aMetaClass");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("true");
return (self);
end
,"api","metaVarNamesImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self send: #isArray:equalTo: withArguments: #('aMetaClass[\"$iVarNames\"]' iVarNames)] return: #false;cr.\r\n\tself send: #setVarNames withArguments: #(aMetaClass iVarNames #nil);cr.\r\n\tself send: #classShapeChanged with: #aMetaClass;cr.\r\n\tself send: #classChanged with: #aMetaClass;cr.\r\n\tself return: #true ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):send_withArguments_(\"isArray:equalTo:\",smalltalk:newArray({\"aMetaClass[\\\"$iVarNames\\\"]\", \"iVarNames\"})))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setVarNames\",smalltalk:newArray({\"aMetaClass\", \"iVarNames\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"classShapeChanged\",\"aMetaClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"classChanged\",\"aMetaClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"true\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"smDoImplementation",0
,function(self)
(self):if_do_((function()
return ((self):expr_and_((function()
return ((self):expr_and_("self.useManager","self.SystemManager"))
end),"self.SystemManager.currentOrNil"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):local_with_("sm",(function()
return ((self):send_to_("currentOrNil","self.SystemManager"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_return_("sm",(function()
return ((self):call_with_("block","sm"))
end)))
end));
return (self);
end
,"api","smDoImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self expr: [self expr: 'self.useManager' and: 'self.SystemManager']\r\n\t\tand: 'self.SystemManager.currentOrNil'] do: [\r\n\t\tself local: #sm with: [self send: #currentOrNil to: 'self.SystemManager'];cr.\r\n\t\tself if: #sm return: [self call: #block with: #sm]\r\n\t]","function(self)\r\n(self):if_do_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):expr_and_(\"self.useManager\",\"self.SystemManager\"))\r\nend),\"self.SystemManager.currentOrNil\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"sm\",(function()\r\nreturn ((self):send_to_(\"currentOrNil\",\"self.SystemManager\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_return_(\"sm\",(function()\r\nreturn ((self):call_with_(\"block\",\"sm\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"classChangedImplementation",0
,function(self)
(self):send_with_("smDo",(function()
return ((self):rawFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_with_("classChanged:","sm","aBehavior"))
end)))
end));
return (self);
end
,"api","classChangedImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself send: #smDo with: [self rawFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #classChanged: to: #sm with: #aBehavior\r\n\t]]","function(self)\r\n(self):send_with_(\"smDo\",(function()\r\nreturn ((self):rawFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_with_(\"classChanged:\",\"sm\",\"aBehavior\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"classShapeChangedImplementation",0
,function(self)
(self):send_with_("smDo",(function()
return ((self):rawFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_with_("classShapeChanged:","sm","aBehavior"))
end)))
end));
return (self);
end
,"api","classShapeChangedImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself send: #smDo with: [self rawFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #classShapeChanged: to: #sm with: #aBehavior\r\n\t]]","function(self)\r\n(self):send_with_(\"smDo\",(function()\r\nreturn ((self):rawFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_with_(\"classShapeChanged:\",\"sm\",\"aBehavior\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"aboutToCreateClassImplementation",0
,function(self)
(self):send_with_("smDo",(function()
return ((self):rawFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_withArguments_("aboutToCreateClass:superclass:iVarNames:category:","sm",smalltalk:newArray({"className", "superclass", "iVarNames", "category"})))
end)))
end));
return (self);
end
,"api","aboutToCreateClassImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself send: #smDo with: [self rawFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #aboutToCreateClass:superclass:iVarNames:category:\r\n\t\t\tto: #sm withArguments: #(className superclass iVarNames category)\r\n\t]]","function(self)\r\n(self):send_with_(\"smDo\",(function()\r\nreturn ((self):rawFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_withArguments_(\"aboutToCreateClass:superclass:iVarNames:category:\",\"sm\",smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"})))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"aboutToChangeClassImplementation",0
,function(self)
(self):send_with_("smDo",(function()
return ((self):rawFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_withArguments_("aboutToChange:superclass:iVarNames:category:","sm",smalltalk:newArray({"aClass", "superclass", "iVarNames", "category"})))
end)))
end));
return (self);
end
,"api","aboutToChangeClassImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself send: #smDo with: [self rawFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #aboutToChange:superclass:iVarNames:category:\r\n\t\t\tto: #sm withArguments: #(aClass superclass iVarNames category)\r\n\t]]","function(self)\r\n(self):send_with_(\"smDo\",(function()\r\nreturn ((self):rawFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_withArguments_(\"aboutToChange:superclass:iVarNames:category:\",\"sm\",smalltalk:newArray({\"aClass\", \"superclass\", \"iVarNames\", \"category\"})))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"methodBoundToImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):rawFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_withArguments_("methodBound:to:","sm",smalltalk:newArray({"method", "klass"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"api","methodBoundToImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself send: #smDo with: [self rawFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #methodBound:to: to: #sm withArguments: #(method klass)\r\n\t]];cr.\r\n\tself return: #method","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):rawFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_withArguments_(\"methodBound:to:\",\"sm\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"aboutToBindToImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):rawFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_withArguments_("aboutToBind:to:","sm",smalltalk:newArray({"method", "klass"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"api","aboutToBindToImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself send: #smDo with: [self rawFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #aboutToBind:to: to: #sm withArguments: #(method klass)\r\n\t]];cr.\r\n\tself return: #method","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):rawFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_withArguments_(\"aboutToBind:to:\",\"sm\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"aboutToRemoveFromImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):rawFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_withArguments_("aboutToRemove:from:","sm",smalltalk:newArray({"method", "klass"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"api","aboutToRemoveFromImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself send: #smDo with: [self rawFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #aboutToRemove:from: to: #sm withArguments: #(method klass)\r\n\t]];cr.\r\n\tself return: #method","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):rawFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_withArguments_(\"aboutToRemove:from:\",\"sm\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"methodRemovedFromImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):rawFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_withArguments_("methodRemoved:from:","sm",smalltalk:newArray({"method", "klass"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"api","methodRemovedFromImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself send: #smDo with: [self rawFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #methodRemoved:from: to: #sm withArguments: #(method klass)\r\n\t]];cr.\r\n\tself return: #method","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):rawFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_withArguments_(\"methodRemoved:from:\",\"sm\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"objectNotFoundImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):rawFunction_arguments_doing_("",smalltalk:newArray({"sm"}),(function()
return ((self):send_to_withArguments_("object:at:notFoundIn:","sm",smalltalk:newArray({"object", "indexOrKey", "collection"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("collection");
return (self);
end
,"api","objectNotFoundImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself send: #smDo with: [self rawFunction: '' arguments: #(sm) doing: [\r\n\t\tself send: #object:at:notFoundIn: to: #sm withArguments: #(object indexOrKey collection)\r\n\t]];cr.\r\n\tself return: #collection","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):rawFunction_arguments_doing_(\"\",smalltalk:newArray({\"sm\"}),(function()\r\nreturn ((self):send_to_withArguments_(\"object:at:notFoundIn:\",\"sm\",smalltalk:newArray({\"object\", \"indexOrKey\", \"collection\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"collection\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"whoImplementsImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("cls","klass");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):repeat_until_((function()
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):call_withArguments_("rawget",smalltalk:newArray({"cls[\"$fn\"].prototype", "jsSelector"})))
end),"cls");
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("cls","cls[\"$superclass\"]"))
end),(function()
return ((self):expr_eqeq_("cls","nil"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("nil");
return (self);
end
,"api","whoImplementsImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself local: #cls with: #klass;cr.\r\n\tself repeat: [\r\n\t\tself if: [self call: #rawget withArguments: #('cls[\"$fn\"].prototype' jsSelector)] return: #cls;cr.\r\n\t\tself assign: #cls to: 'cls[\"$superclass\"]'\r\n\t] until: [self expr: #cls eqeq: #nil];cr.\r\n\tself return: #nil ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"cls\",\"klass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):repeat_until_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):call_withArguments_(\"rawget\",smalltalk:newArray({\"cls[\\\"$fn\\\"].prototype\", \"jsSelector\"})))\r\nend),\"cls\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"cls\",\"cls[\\\"$superclass\\\"]\"))\r\nend),(function()\r\nreturn ((self):expr_eqeq_(\"cls\",\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"nil\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"superImplementorImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_or_((function()
return ((self):send_with_("isNil:","klass[\"$superclass\"]"))
end),(function()
return ((self):send_with_("isNil:","klass[\"$superclass\"][\"$fn\"]"))
end)))
end),(function()
return ((self):return_((function()
return ((self):send_to_with_("missingImplementorFor:","klass","jsSelector"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("cls",(function()
return ((self):send_withArguments_("whoImplements",smalltalk:newArray({"klass[\"$superclass\"]", "jsSelector"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("isNil:","cls"))
end),(function()
return ((self):return_((function()
return ((self):send_to_with_("missingImplementorFor:","klass[\"$superclass\"]","jsSelector"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("cls[\"$fn\"].prototype[jsSelector]");
return (self);
end
,"api","superImplementorImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self expr: [self send: #isNil: with: 'klass[\"$superclass\"]']\r\n\t\tor: [ self send: #isNil: with: 'klass[\"$superclass\"][\"$fn\"]']] do: [\r\n\t\tself return: [self send: #missingImplementorFor: to: #klass with: #jsSelector]\r\n\t];cr.\r\n\tself local: #cls with: [self send: #whoImplements withArguments: #('klass[\"$superclass\"]' jsSelector)];cr.\r\n\tself if: [self send: #isNil: with: #cls] do: [\r\n\t\tself return: [self send: #missingImplementorFor: to: 'klass[\"$superclass\"]' with: #jsSelector]\r\n\t];cr.\r\n\tself return: 'cls[\"$fn\"].prototype[jsSelector]' ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"klass[\\\"$superclass\\\"]\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"isNil:\",\"klass[\\\"$superclass\\\"][\\\"$fn\\\"]\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_with_(\"missingImplementorFor:\",\"klass\",\"jsSelector\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"cls\",(function()\r\nreturn ((self):send_withArguments_(\"whoImplements\",smalltalk:newArray({\"klass[\\\"$superclass\\\"]\", \"jsSelector\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"cls\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_with_(\"missingImplementorFor:\",\"klass[\\\"$superclass\\\"]\",\"jsSelector\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"cls[\\\"$fn\\\"].prototype[jsSelector]\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"addMethodImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("aboutToBindTo",smalltalk:newArray({"method", "klass"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("klass[\"$fn\"].prototype[jsSelector]","method[\"$fn\"]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("klass[\"$fn\"].prototype[\"$methods\"][method[\"$selector\"]]","method");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("method[\"@classField\"]","klass");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_withArguments_("methodBoundTo",smalltalk:newArray({"method", "klass"})))
end));
return (self);
end
,"api","addMethodImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself send: #aboutToBindTo withArguments: #(method klass);cr.\r\n\tself assign: 'klass[\"$fn\"].prototype[jsSelector]' to: 'method[\"$fn\"]';cr.\r\n\tself assign: 'klass[\"$fn\"].prototype[\"$methods\"][method[\"$selector\"]]' to: #method;cr.\r\n\tself assign: 'method[\"@classField\"]' to: #klass;cr.\r\n\tself return: [self send: #methodBoundTo withArguments: #(method klass)] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"aboutToBindTo\",smalltalk:newArray({\"method\", \"klass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"klass[\\\"$fn\\\"].prototype[jsSelector]\",\"method[\\\"$fn\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"klass[\\\"$fn\\\"].prototype[\\\"$methods\\\"][method[\\\"$selector\\\"]]\",\"method\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"method[\\\"@classField\\\"]\",\"klass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"methodBoundTo\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"bindImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("debugBind",smalltalk:newArray({"klass", "stSelector", "jsSelector", "jsFunction", "category", "stSource", "nativeSource", "stamp"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("method",(function()
return ((self):call_("self.CompiledMethod[\"$fn\"]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("method[\"$selector\"]","stSelector");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("method[\"$fn\"]","jsFunction");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("method[\"$category\"]","category");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("method[\"$source\"]","stSource");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("method[\"$nativeSource\"]","nativeSource");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("notNil:","stamp"))
end),(function()
return ((self):assign_to_("method[\"$stamp\"]","stamp"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("method[\"$generation\"]","self[\"$state\"]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("notNil:","klass"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_eqeq_("jsSelector","0"))
end),(function()
return ((self):assign_to_("jsSelector",(function()
return ((self):call_withArguments_("string.gsub",smalltalk:newArray({"stSelector", "\":\"", "\"_\""})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):send_withArguments_("addMethod",smalltalk:newArray({"jsSelector", "method", "klass"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"api","bindImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself send: #debugBind withArguments: #(\r\n\t\tklass stSelector jsSelector jsFunction\r\n\t\tcategory stSource nativeSource\r\n\t\tstamp);cr.\r\n\tself local: #method with: [self call: 'self.CompiledMethod[\"$fn\"]'];cr.\r\n\tself assign: 'method[\"$selector\"]' to: #stSelector;cr.\r\n\tself assign: 'method[\"$fn\"]' to: #jsFunction;cr.\r\n\tself assign: 'method[\"$category\"]' to: #category;cr.\r\n\tself assign: 'method[\"$source\"]' to: #stSource;cr.\r\n\tself assign: 'method[\"$nativeSource\"]' to: #nativeSource;cr.\r\n\tself if: [self send: #notNil: with: #stamp] do: [\r\n\t\tself assign: 'method[\"$stamp\"]' to: #stamp\r\n\t];cr.\r\n\tself assign: 'method[\"$generation\"]' to: 'self[\"$state\"]';cr.\r\n\tself if: [self send: #notNil: with: #klass] do: [\r\n\t\tself if: [self expr: #jsSelector eqeq: #0] do: [\r\n\t\t\tself assign: #jsSelector to: [\r\n\t\t\t\tself\tcall: 'string.gsub'\r\n\t\t\t\t\twithArguments: #(stSelector '\":\"' '\"_\"') ]\r\n\t\t];cr.\r\n\t\tself send: #addMethod withArguments: #(jsSelector method klass)\r\n\t];cr.\r\n\tself return: #method ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"debugBind\",smalltalk:newArray({\"klass\", \"stSelector\", \"jsSelector\", \"jsFunction\", \"category\", \"stSource\", \"nativeSource\", \"stamp\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"method\",(function()\r\nreturn ((self):call_(\"self.CompiledMethod[\\\"$fn\\\"]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"method[\\\"$selector\\\"]\",\"stSelector\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"method[\\\"$fn\\\"]\",\"jsFunction\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"method[\\\"$category\\\"]\",\"category\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"method[\\\"$source\\\"]\",\"stSource\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"method[\\\"$nativeSource\\\"]\",\"nativeSource\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"stamp\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"method[\\\"$stamp\\\"]\",\"stamp\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"method[\\\"$generation\\\"]\",\"self[\\\"$state\\\"]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"klass\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"jsSelector\",\"0\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"jsSelector\",(function()\r\nreturn ((self):call_withArguments_(\"string.gsub\",smalltalk:newArray({\"stSelector\", \"\\\":\\\"\", \"\\\"_\\\"\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_withArguments_(\"addMethod\",smalltalk:newArray({\"jsSelector\", \"method\", \"klass\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"removeMethodImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("aboutToRemoveFrom",smalltalk:newArray({"aMethod", "aClass"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$fn\"].prototype[aMethod[\"$selector\"]:asSelector()]","nil");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass[\"$fn\"].prototype[\"$methods\"][aMethod[\"$selector\"]]","nil");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_withArguments_("methodRemovedFrom",smalltalk:newArray({"aMethod", "aClass"})))
end));
return (self);
end
,"api","removeMethodImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself send: #aboutToRemoveFrom withArguments: #(aMethod aClass);cr.\r\n\tself assign: 'aClass[\"$fn\"].prototype[aMethod[\"$selector\"]:asSelector()]' to: #nil;cr.\r\n\tself assign: 'aClass[\"$fn\"].prototype[\"$methods\"][aMethod[\"$selector\"]]' to: #nil;cr.\r\n\tself return: [self send: #methodRemovedFrom withArguments: #(aMethod aClass)] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"aboutToRemoveFrom\",smalltalk:newArray({\"aMethod\", \"aClass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$fn\\\"].prototype[aMethod[\\\"$selector\\\"]:asSelector()]\",\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass[\\\"$fn\\\"].prototype[\\\"$methods\\\"][aMethod[\\\"$selector\\\"]]\",\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"methodRemovedFrom\",smalltalk:newArray({\"aMethod\", \"aClass\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"newMethodImplementation",0
,function(self)
(self):return_((function()
return ((self):send_withArguments_("bind",smalltalk:newArray({"nil", "selector", "nil", "fn", "nil", "source", "nativeSource", "stamp"})))
end));
return (self);
end
,"api","newMethodImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself return: [self send: #bind withArguments: #(\r\n\t\t#nil selector #nil fn\r\n\t\t#nil source nativeSource stamp)] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"bind\",smalltalk:newArray({\"nil\", \"selector\", \"nil\", \"fn\", \"nil\", \"source\", \"nativeSource\", \"stamp\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"methodImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):comment_("OBSOLETE");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_withArguments_("bind",smalltalk:newArray({"nil", "spec.selector", "nil", "spec.fn", "spec.category", "spec.source", "spec.nativeSource", "spec.stamp"})))
end));
return (self);
end
,"api","methodImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself comment: #OBSOLETE;cr.\r\n\tself return: [self send: #bind withArguments: #(\r\n\t\t#nil 'spec.selector' #nil 'spec.fn' 'spec.category'\r\n\t\t'spec.source' 'spec.nativeSource' 'spec.stamp')] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"OBSOLETE\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"bind\",smalltalk:newArray({\"nil\", \"spec.selector\", \"nil\", \"spec.fn\", \"spec.category\", \"spec.source\", \"spec.nativeSource\", \"spec.stamp\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"readJSObjectImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):callPrint_("\"--[NIY] smalltalk:readJSObject()\"");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("nil");
return (self);
end
,"api","readJSObjectImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself callPrint: '\"--[NIY] smalltalk:readJSObject()\"';cr.\r\n\tself return: #nil ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):callPrint_(\"\\\"--[NIY] smalltalk:readJSObject()\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"nil\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"basenImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):local_with_("floor,insert","math.floor, table.insert");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("n",(function()
return ((self):call_with_("floor","n"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_("not b or b == 10",(function()
return ((self):call_with_("tostring","n"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("digits","\"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("t",(function()
return ((self):emptyObject())
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("sign",(self):emptyString());
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("n < 0",(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("sign","\"-\"");
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("n","-n"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):repeat_until_((function()
(
function(_s8_rec)
	(_s8_rec):local_with_("d","(n % b) + 1");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("n",(function()
return ((self):call_with_("floor","n / b"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):call_withArguments_("insert",smalltalk:newArray({"t", "1", "digits:sub(d,d)"}));
	return ((_s8_rec):cr())
end
)(self))
end),(function()
return ((self):expr_eqeq_("n","0"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):concat_with_("sign",(function()
return ((self):call_withArguments_("table.concat",smalltalk:newArray({"t", "\"\""})))
end)))
end));
return (self);
end
,"api","basenImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself local: 'floor,insert' with: 'math.floor, table.insert';cr.\r\n\tself assign: #n to: [self call: #floor with: #n];cr.\r\n\tself if: 'not b or b == 10' return: [self call: #tostring with: #n];cr.\r\n\tself local: #digits with: '\"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ\"';cr.\r\n\tself local: #t with: [self emptyObject];cr.\r\n\tself local: #sign with: self emptyString;cr.\r\n\tself if: 'n < 0' do: [\r\n\t\tself assign: #sign to: '\"-\"';cr.\r\n\t\tself assign: #n to: '-n'\r\n\t];cr.\r\n\tself repeat: [\r\n\t\tself local: #d with: '(n % b) + 1';cr.\r\n\t\tself assign: #n to: [self call: #floor with: 'n / b'];cr.\r\n\t\tself call: #insert withArguments: #(t #1 'digits:sub(d,d)');cr.\r\n\t] until: [self expr: #n eqeq: #0];cr.\r\n\tself return: [self concat: #sign with: [\r\n\t\tself call: 'table.concat' withArguments: #(t '\"\"')\r\n\t]]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"floor,insert\",\"math.floor, table.insert\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"n\",(function()\r\nreturn ((self):call_with_(\"floor\",\"n\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_(\"not b or b == 10\",(function()\r\nreturn ((self):call_with_(\"tostring\",\"n\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"digits\",\"\\\"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"t\",(function()\r\nreturn ((self):emptyObject())\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"sign\",(self):emptyString());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"n < 0\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"sign\",\"\\\"-\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"n\",\"-n\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):repeat_until_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"d\",\"(n % b) + 1\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"n\",(function()\r\nreturn ((self):call_with_(\"floor\",\"n / b\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"insert\",smalltalk:newArray({\"t\", \"1\", \"digits:sub(d,d)\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend),(function()\r\nreturn ((self):expr_eqeq_(\"n\",\"0\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):concat_with_(\"sign\",(function()\r\nreturn ((self):call_withArguments_(\"table.concat\",smalltalk:newArray({\"t\", \"\\\"\\\"\"})))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"globalsDoImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):for_in_do_("key, aValue",(function()
return ((self):call_with_("pairs","smalltalk"))
end),(function()
return ((
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):typeOf_is_("aValue","table"))
end),(function()
return ((self):if_do_((function()
return ((self):expr_and_("aValue.isClass",(function()
return ((self):not_((function()
return ((self):send_to_("isClass","aValue"))
end)))
end)))
end),(function()
return ((self):call_with_("action","key"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("smalltalk");
return (self);
end
,"api","globalsDoImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself for: 'key, aValue' in: [self call: #pairs with: #smalltalk] do: [\r\n\t\tself if: [self typeOf: #aValue is: #table] do: [\r\n\t\t\tself if: [self expr: 'aValue.isClass'\r\n\t\t\t\tand: [self not: [self send: #isClass to: #aValue]]]\r\n\t\t\t\tdo: [ self call: #action with: #key ]\r\n\t\t];cr.\r\n\t];cr.\r\n\tself return: #smalltalk ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"key, aValue\",(function()\r\nreturn ((self):call_with_(\"pairs\",\"smalltalk\"))\r\nend),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):typeOf_is_(\"aValue\",\"table\"))\r\nend),(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):expr_and_(\"aValue.isClass\",(function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_to_(\"isClass\",\"aValue\"))\r\nend)))\r\nend)))\r\nend),(function()\r\nreturn ((self):call_with_(\"action\",\"key\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"smalltalk\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"launchImageImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("self.useManager","true");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("notNil:","imageName"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[\"$imageFileName\"]","imageName");
	return ((_s8_rec):cr())
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):call_with_("dofile","imageName");
	return ((_s8_rec):comment_("load(imageName)"))
end
)(self))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[\"$state\"]","\"launching\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("self.launch",(function()
return ((self):send_("launch"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[\"$state\"]","\"running\"");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("smalltalk");
return (self);
end
,"api","launchImageImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself assign: 'self.useManager' to: #true;cr.\r\n\tself if: [self send: #notNil: with: #imageName] do: [\r\n\t\tself assign: 'self[\"$imageFileName\"]' to: #imageName;cr.\r\n\t\tself call: #dofile with: #imageName; comment: 'load(imageName)'\r\n\t];cr.\r\n\tself assign: 'self[\"$state\"]' to: '\"launching\"';cr.\r\n\tself if: 'self.launch' do: [\r\n\t\tself send: #launch\r\n\t];cr.\r\n\tself assign: 'self[\"$state\"]' to: '\"running\"';cr.\r\n\tself return: #smalltalk ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self.useManager\",\"true\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"notNil:\",\"imageName\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[\\\"$imageFileName\\\"]\",\"imageName\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"dofile\",\"imageName\");\r\n\treturn ((_s8_rec):comment_(\"load(imageName)\"))\r\nend\r\n)(self))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[\\\"$state\\\"]\",\"\\\"launching\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"self.launch\",(function()\r\nreturn ((self):send_(\"launch\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[\\\"$state\\\"]\",\"\\\"running\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"smalltalk\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"is_kindOf_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_or_((function()
return ((self):send_with_("isNil:","anObject"))
end),(function()
return ((self):send_with_("isNil:","anObject.isKindOf_"))
end)))
end),"false");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_with_("isKindOf:","anObject","aClass"))
end));
return (self);
end
,"api","is_kindOf_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self expr: [self send: #isNil: with: #anObject]\r\n\t\tor: [self send: #isNil: with: 'anObject.isKindOf_']] return: #false;cr.\r\n\tself return: [self send: #isKindOf: to: #anObject with: #aClass] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"anObject\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"isNil:\",\"anObject.isKindOf_\"))\r\nend)))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"isKindOf:\",\"anObject\",\"aClass\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"responds_to_Implementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_or_((function()
return ((self):send_with_("isNil:","anObject"))
end),(function()
return ((self):send_with_("isNil:","anObject.respondsTo_"))
end)))
end),"false");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_with_("respondsTo:","anObject","aSelector"))
end));
return (self);
end
,"api","responds_to_Implementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself if: [self expr: [self send: #isNil: with: #anObject]\r\n\t\tor: [self send: #isNil: with: 'anObject.respondsTo_']] return: #false;cr.\r\n\tself return: [self send: #respondsTo: to: #anObject with: #aSelector] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):send_with_(\"isNil:\",\"anObject\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"isNil:\",\"anObject.respondsTo_\"))\r\nend)))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"respondsTo:\",\"anObject\",\"aSelector\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"debugBindImplementation",0
,function(self)
(self):return_("self");
return (self);
end
,"api","debugBindImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself return: #self ","function(self)\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"debugAddClassImplementation",0
,function(self)
(self):return_("self");
return (self);
end
,"api","debugAddClassImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself return: #self ","function(self)\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"toStringImplementation",0
,function(self)
(self):return_("\"smalltalk\"");
return (self);
end
,"api","toStringImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself return: '\"smalltalk\"' ","function(self)\r\n(self):return_(\"\\\"smalltalk\\\"\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"bindCoreImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):comment_("bind the minimal functions (e.g i/o)");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):local_with_("global","_G");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeq_("global","nil"))
end),"false");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):rawFunction_arguments_doing_("global.quit",smalltalk:newArray({}),(function()
(
function(_s8_rec)
	(_s8_rec):call_("os.exit");
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("false"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):rawFunction_arguments_doing_("global.version",smalltalk:newArray({}),(function()
return ((self):return_("_VERSION"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):rawFunction_arguments_doing_("global.fileContents",smalltalk:newArray({"fileName"}),(function()
(
function(_s8_rec)
	(_s8_rec):local_with_("f,err",(function()
return ((self):call_withArguments_("io.open",smalltalk:newArray({"fileName", "\"rb\""})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeq_("f","nil"))
end),"nil");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):local_with_("content",(function()
return ((self):send_to_with_("read","f","\"*all\""))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_to_("close","f");
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("content"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("global.read","global.fileContents");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):rawFunction_arguments_doing_("global.fileWrite",smalltalk:newArray({"fileName", "contents", "mode"}),(function()
(
function(_s8_rec)
	(_s8_rec):local_with_("f",(function()
return ((self):call_with_("assert",(function()
return ((self):call_withArguments_("io.open",smalltalk:newArray({"fileName", "mode"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_to_with_("write","f","contents");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_to_("close","f");
	return ((_s8_rec):cr())
end
)(self);return ((self):return_((function()
return ((self):send_to_("size","contents"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):rawFunction_arguments_doing_("global.fileIn",smalltalk:newArray({"fileName"}),(function()
(
function(_s8_rec)
	(_s8_rec):local_with_("contents",(function()
return ((self):call_with_("read","fileName"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_eqeq_("contents","nil"))
end),(function()
return ((self):send_to_with_("error:","smalltalk",(function()
return ((self):concat_with_("\"Missing file \"",(function()
return ((self):call_with_("tostring","fileName"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_((function()
return ((self):send_to_("fileIn","contents"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):rawFunction_arguments_doing_("global.emmit",smalltalk:newArray({"fileName"}),(function()
return ((self):return_((function()
return ((self):send_to_with_("emmit:","smalltalk","fileName"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):rawFunction_arguments_doing_("global.fileInJS",smalltalk:newArray({"fileName"}),(function()
return ((self):return_((function()
return ((self):send_to_with_("eval:","smalltalk",(function()
return ((self):call_with_("read","fileName"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):rawFunction_arguments_doing_("global.exportCategory",smalltalk:newArray({"aString"}),(function()
return ((self):return_((function()
return ((self):send_to_with_("exportCategory:","smalltalk.Exporter","aString"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):rawFunction_arguments_doing_("global.saveImage",smalltalk:newArray({}),(function()
return ((self):return_((function()
return ((self):send_to_("saveImage","smalltalk"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):rawFunction_arguments_doing_("global.saveImageAs",smalltalk:newArray({"fileName"}),(function()
return ((self):return_((function()
return ((self):send_to_with_("saveImageAs:","smalltalk","fileName"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):rawFunction_arguments_doing_("global.isFileOlderThan",smalltalk:newArray({"fileName", "referenceFileName"}),(function()
(
function(_s8_rec)
	(_s8_rec):local_with_("f,err",(function()
return ((self):call_withArguments_("io.open",smalltalk:newArray({"fileName", "\"r\""})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeq_("f","nil"))
end),"false");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_to_("close","f");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("f,err",(function()
return ((self):call_withArguments_("io.open",smalltalk:newArray({"referenceFileName", "\"r\""})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_eqeq_("f","nil"))
end),"false");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_to_("close","f");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):comment_("there is NO way to get the datetime of a file in Lua");
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("true"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[\"$imageFileName\"]",(function()
return ((self):expr_or_("self[\"$imageFileName\"]","\"s8.image.lua\""))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("true");
return (self);
end
,"api","bindCoreImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself comment: 'bind the minimal functions (e.g i/o)';cr.\r\n\tself local: #global with: #_G;cr.\r\n\tself if: [self expr: #global eqeq: #nil] return: #false;cr.\r\n\tself rawFunction: 'global.quit' arguments: #() doing: [\r\n\t\tself call: 'os.exit';cr.\r\n\t\tself return: #false\r\n\t];cr.\r\n\tself rawFunction: 'global.version' arguments: #() doing: [\r\n\t\tself return: #_VERSION\r\n\t];cr.\r\n\tself rawFunction: 'global.fileContents' arguments: #(fileName) doing: [\r\n\t\tself local: 'f,err' with: [self call: 'io.open' withArguments: #(fileName '\"rb\"')];cr.\r\n\t\tself if: [self expr: #f eqeq: #nil] return: #nil;cr.\r\n\t\tself local: #content with: [self send: #read to: #f with: '\"*all\"'];cr.\r\n\t\tself send: #close to: #f;cr.\r\n\t\tself return: #content\r\n\t];cr.\r\n\tself assign: 'global.read' to: 'global.fileContents';cr.\r\n\tself rawFunction: 'global.fileWrite' arguments: #(fileName contents mode) doing: [\r\n\t\tself local: #f with: [self call: #assert with: [self call: 'io.open' withArguments: #(fileName mode)]];cr.\r\n\t\tself send: #write to: #f with: #contents;cr.\r\n\t\tself send: #close to: #f;cr.\r\n\t\tself return: [self send: #size to: #contents]\r\n\t];cr.\r\n\tself rawFunction: 'global.fileIn' arguments: #(fileName) doing: [\r\n\t\tself local: #contents with: [self call: #read with: #fileName];cr.\r\n\t\tself if: [self expr: #contents eqeq: #nil] do: [\r\n\t\t\tself send: #error: to: #smalltalk with: [\r\n\t\t\t\tself\tconcat: '\"Missing file \"'\r\n\t\t\t\t\twith: [self call: #tostring with: #fileName]\r\n\t\t\t]\r\n\t\t];cr.\r\n\t\tself return: [self send: #fileIn to: #contents]\r\n\t];cr.\r\n\tself rawFunction: 'global.emmit' arguments: #(fileName) doing: [\r\n\t\tself return: [self send: #emmit: to: #smalltalk with: #fileName]\r\n\t];cr.\r\n\tself rawFunction: 'global.fileInJS' arguments: #(fileName) doing: [\r\n\t\tself return: [self send: #eval: to: #smalltalk\r\n\t\t\twith: [self call: #read with: #fileName]]\r\n\t];cr.\r\n\tself rawFunction: 'global.exportCategory' arguments: #(aString) doing: [\r\n\t\tself return: [self send: #exportCategory: to: 'smalltalk.Exporter' with: #aString]\r\n\t];cr.\r\n\tself rawFunction: 'global.saveImage' arguments: #() doing: [\r\n\t\tself return: [self send: #saveImage to: #smalltalk ]\r\n\t];cr.\r\n\tself rawFunction: 'global.saveImageAs' arguments: #(fileName) doing: [\r\n\t\tself return: [self send: #saveImageAs: to: #smalltalk with: #fileName]\r\n\t];cr.\r\n\tself rawFunction: 'global.isFileOlderThan' arguments: #(fileName referenceFileName) doing: [\r\n\t\tself local: 'f,err' with: [self call: 'io.open' withArguments: #(fileName '\"r\"')];cr.\r\n\t\tself if: [self expr: #f eqeq: #nil] return: #false;cr.\r\n\t\tself send: #close to: #f;cr.\r\n\t\tself assign: 'f,err' to: [self call: 'io.open' withArguments: #(referenceFileName '\"r\"')];cr.\r\n\t\tself if: [self expr: #f eqeq: #nil] return: #false;cr.\r\n\t\tself send: #close to: #f;cr.\r\n\t\tself comment: 'there is NO way to get the datetime of a file in Lua';cr.\r\n\t\tself return: #true\r\n\t];cr.\r\n\tself assign: 'self[\"$imageFileName\"]' to: [self expr: 'self[\"$imageFileName\"]' or: '\"s8.image.lua\"'];cr.\r\n\tself return: #true ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"bind the minimal functions (e.g i/o)\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"global\",\"_G\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"global\",\"nil\"))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):rawFunction_arguments_doing_(\"global.quit\",smalltalk:newArray({}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_(\"os.exit\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"false\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):rawFunction_arguments_doing_(\"global.version\",smalltalk:newArray({}),(function()\r\nreturn ((self):return_(\"_VERSION\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):rawFunction_arguments_doing_(\"global.fileContents\",smalltalk:newArray({\"fileName\"}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"f,err\",(function()\r\nreturn ((self):call_withArguments_(\"io.open\",smalltalk:newArray({\"fileName\", \"\\\"rb\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"f\",\"nil\"))\r\nend),\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"content\",(function()\r\nreturn ((self):send_to_with_(\"read\",\"f\",\"\\\"*all\\\"\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_(\"close\",\"f\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"content\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"global.read\",\"global.fileContents\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):rawFunction_arguments_doing_(\"global.fileWrite\",smalltalk:newArray({\"fileName\", \"contents\", \"mode\"}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"f\",(function()\r\nreturn ((self):call_with_(\"assert\",(function()\r\nreturn ((self):call_withArguments_(\"io.open\",smalltalk:newArray({\"fileName\", \"mode\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_with_(\"write\",\"f\",\"contents\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_(\"close\",\"f\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_((function()\r\nreturn ((self):send_to_(\"size\",\"contents\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):rawFunction_arguments_doing_(\"global.fileIn\",smalltalk:newArray({\"fileName\"}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"contents\",(function()\r\nreturn ((self):call_with_(\"read\",\"fileName\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"contents\",\"nil\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"error:\",\"smalltalk\",(function()\r\nreturn ((self):concat_with_(\"\\\"Missing file \\\"\",(function()\r\nreturn ((self):call_with_(\"tostring\",\"fileName\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_((function()\r\nreturn ((self):send_to_(\"fileIn\",\"contents\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):rawFunction_arguments_doing_(\"global.emmit\",smalltalk:newArray({\"fileName\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_with_(\"emmit:\",\"smalltalk\",\"fileName\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):rawFunction_arguments_doing_(\"global.fileInJS\",smalltalk:newArray({\"fileName\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_with_(\"eval:\",\"smalltalk\",(function()\r\nreturn ((self):call_with_(\"read\",\"fileName\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):rawFunction_arguments_doing_(\"global.exportCategory\",smalltalk:newArray({\"aString\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_with_(\"exportCategory:\",\"smalltalk.Exporter\",\"aString\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):rawFunction_arguments_doing_(\"global.saveImage\",smalltalk:newArray({}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_(\"saveImage\",\"smalltalk\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):rawFunction_arguments_doing_(\"global.saveImageAs\",smalltalk:newArray({\"fileName\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_with_(\"saveImageAs:\",\"smalltalk\",\"fileName\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):rawFunction_arguments_doing_(\"global.isFileOlderThan\",smalltalk:newArray({\"fileName\", \"referenceFileName\"}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):local_with_(\"f,err\",(function()\r\nreturn ((self):call_withArguments_(\"io.open\",smalltalk:newArray({\"fileName\", \"\\\"r\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"f\",\"nil\"))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_(\"close\",\"f\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"f,err\",(function()\r\nreturn ((self):call_withArguments_(\"io.open\",smalltalk:newArray({\"referenceFileName\", \"\\\"r\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"f\",\"nil\"))\r\nend),\"false\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_(\"close\",\"f\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"there is NO way to get the datetime of a file in Lua\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"true\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[\\\"$imageFileName\\\"]\",(function()\r\nreturn ((self):expr_or_(\"self[\\\"$imageFileName\\\"]\",\"\\\"s8.image.lua\\\"\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"true\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaBoot,"startupImplementation",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[\"$state\"]","\"booting\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self.OverwriteMethods",(function()
return ((self):expr_or_("self.OverwriteMethods","true"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self.DumpOverwritenMethods",(function()
return ((self):expr_or_("self.DumpOverwritenMethods","false"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[\"$state\"]","\"singularity\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Object\"", "\"Kernel\"", "StObject"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Smalltalk\"", "\"Kernel\"", "StSystemDictionary", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Behavior\"", "\"Kernel\"", "StBehavior", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Class\"", "\"Kernel\"", "StClass", "self.Behavior"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Metaclass\"", "\"Kernel\"", "StMetaclass", "self.Behavior"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"CompiledMethod\"", "\"Kernel\"", "StMethod", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Number\"", "\"Kernel\"", "nil", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"BlockClosure\"", "\"Kernel\"", "nil", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Boolean\"", "\"Kernel\"", "nil", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):comment_("self:mapClassName(\"DateTime\",\"Kernel\",Date,self.Object)");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"UndefinedObject\"", "\"Kernel\"", "nil", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Collection\"", "\"Kernel\"", "nil", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"SequenceableCollection\"", "\"Kernel\"", "nil", "self.Collection"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"String\"", "\"Kernel\"", "nil", "self.SequenceableCollection"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Array\"", "\"Kernel\"", "nil", "self.SequenceableCollection"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):comment_("self:mapClassName(\"RegularExpression\",\"Kernel\",RegExp,self.Object)");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[\"$state\"]","\"whiteHole\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("linkNative:to:",(smalltalk.Array):with_with_((self):emptyString(),"self.String"));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("linkNative:to:",smalltalk:newArray({"function()end", "self.BlockClosure"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("linkNative:to:",smalltalk:newArray({"true", "self.Boolean"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("linkNative:to:",smalltalk:newArray({"nil", "self.UndefinedObject"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("linkNative:to:",smalltalk:newArray({"1", "self.Number"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[\"$state\"]","\"wormHole\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_("bindCore");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self[\"$state\"]","\"startup\"");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("self");
return (self);
end
,"api","startupImplementation\r\n\t\" Private - Implementation of API function. \"\r\n\r\n\tself assign: 'self[\"$state\"]' to: '\"booting\"';cr.\r\n\tself assign: 'self.OverwriteMethods' to: [self expr: 'self.OverwriteMethods' or: #true];cr.\r\n\tself assign: 'self.DumpOverwritenMethods' to: [self expr: 'self.DumpOverwritenMethods' or: #false];cr.\r\n\tself assign: 'self[\"$state\"]' to: '\"singularity\"';cr.\r\n\tself send: #mapClassName withArguments: #('\"Object\"' '\"Kernel\"' StObject);cr.\r\n\tself send: #mapClassName withArguments: #('\"Smalltalk\"' '\"Kernel\"' StSystemDictionary 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"Behavior\"' '\"Kernel\"' StBehavior 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"Class\"' '\"Kernel\"' StClass 'self.Behavior');cr.\r\n\tself send: #mapClassName withArguments: #('\"Metaclass\"' '\"Kernel\"' StMetaclass 'self.Behavior');cr.\r\n\tself send: #mapClassName withArguments: #('\"CompiledMethod\"' '\"Kernel\"' StMethod 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"Number\"' '\"Kernel\"' #nil 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"BlockClosure\"' '\"Kernel\"' #nil 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"Boolean\"' '\"Kernel\"' #nil 'self.Object');cr.\r\n\tself comment: 'self:mapClassName(\"DateTime\",\"Kernel\",Date,self.Object)';cr.\r\n\tself send: #mapClassName withArguments: #('\"UndefinedObject\"' '\"Kernel\"' #nil 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"Collection\"' '\"Kernel\"' #nil 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"SequenceableCollection\"' '\"Kernel\"' #nil 'self.Collection');cr.\r\n\tself send: #mapClassName withArguments: #('\"String\"' '\"Kernel\"' #nil 'self.SequenceableCollection');cr.\r\n\tself send: #mapClassName withArguments: #('\"Array\"' '\"Kernel\"' #nil 'self.SequenceableCollection');cr.\r\n\tself comment: 'self:mapClassName(\"RegularExpression\",\"Kernel\",RegExp,self.Object)';cr.\r\n\tself assign: 'self[\"$state\"]' to: '\"whiteHole\"';cr.\r\n\tself send: #linkNative:to: withArguments: (Array with: self emptyString with: 'self.String');cr.\r\n\tself send: #linkNative:to: withArguments: #('function()end' 'self.BlockClosure');cr.\r\n\tself send: #linkNative:to: withArguments: #(#true 'self.Boolean');cr.\r\n\tself send: #linkNative:to: withArguments: #(#nil 'self.UndefinedObject');cr.\r\n\tself send: #linkNative:to: withArguments: #(#1 'self.Number');cr.\r\n\tself assign: 'self[\"$state\"]' to: '\"wormHole\"';cr.\r\n\tself send: #bindCore;cr.\r\n\tself assign: 'self[\"$state\"]' to: '\"startup\"';cr.\r\n\tself return: #self","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[\\\"$state\\\"]\",\"\\\"booting\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self.OverwriteMethods\",(function()\r\nreturn ((self):expr_or_(\"self.OverwriteMethods\",\"true\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self.DumpOverwritenMethods\",(function()\r\nreturn ((self):expr_or_(\"self.DumpOverwritenMethods\",\"false\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[\\\"$state\\\"]\",\"\\\"singularity\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Object\\\"\", \"\\\"Kernel\\\"\", \"StObject\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Smalltalk\\\"\", \"\\\"Kernel\\\"\", \"StSystemDictionary\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Behavior\\\"\", \"\\\"Kernel\\\"\", \"StBehavior\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Class\\\"\", \"\\\"Kernel\\\"\", \"StClass\", \"self.Behavior\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Metaclass\\\"\", \"\\\"Kernel\\\"\", \"StMetaclass\", \"self.Behavior\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"CompiledMethod\\\"\", \"\\\"Kernel\\\"\", \"StMethod\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Number\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"BlockClosure\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Boolean\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"self:mapClassName(\\\"DateTime\\\",\\\"Kernel\\\",Date,self.Object)\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"UndefinedObject\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Collection\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"SequenceableCollection\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Collection\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"String\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.SequenceableCollection\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Array\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.SequenceableCollection\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"self:mapClassName(\\\"RegularExpression\\\",\\\"Kernel\\\",RegExp,self.Object)\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[\\\"$state\\\"]\",\"\\\"whiteHole\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"linkNative:to:\",(smalltalk.Array):with_with_((self):emptyString(),\"self.String\"));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"linkNative:to:\",smalltalk:newArray({\"function()end\", \"self.BlockClosure\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"linkNative:to:\",smalltalk:newArray({\"true\", \"self.Boolean\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"linkNative:to:\",smalltalk:newArray({\"nil\", \"self.UndefinedObject\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"linkNative:to:\",smalltalk:newArray({\"1\", \"self.Number\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[\\\"$state\\\"]\",\"\\\"wormHole\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_(\"bindCore\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self[\\\"$state\\\"]\",\"\\\"startup\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")
