
-- fileIn("s8/library/eden/pyBoot.st")
smalltalk:addClass("PythonBoot",smalltalk.BootSector,smalltalk:newArray({}),"pyBoot")

smalltalk:bind(smalltalk.PythonBoot["$klass"],"supportsLanguage:",0
,function(self,aLanguage)
return (smalltalk:isObject_equalTo_(("py"),aLanguage));
end
,"instantiation","supportsLanguage: aLanguage\r\n\t\" Private - Return true if instances of the receiver can encode to aLanguage. \"\r\n\r\n\t^#py = aLanguage","function(self,aLanguage)\r\nreturn (smalltalk:isObject_equalTo_((\"py\"),aLanguage));\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"version",0
,function(self)
return ("1.0 - Stable");
end
,"constants","version\r\n\t\" Private - Returns the version string (dotted number and date). \"\r\n\r\n\t^'1.0 - Stable'","function(self)\r\nreturn (\"1.0 - Stable\");\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"lineComment:",0
,function(self,aString)
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:object_comma_(("# "),aString));
	return ((_s8_rec):cr())
end
)(self));
end
,"encoding","lineComment: aString\r\n\t\" Private - Encode aString as line comment. \"\r\n\r\n\t^self nextPutAll: '# ' ,aString;cr ","function(self,aString)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((\"# \"),aString));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self));\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"multilineComment:",0
,function(self,array)
return ((self):encode_((function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("\"\"\"");
	return ((_s8_rec):indent())
end
)(self);(array):do_((function(line)
return ((
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(line))
end
)(self))
end));return ((
function(_s8_rec)
	(_s8_rec):dedent();
	(_s8_rec):cr();
	(_s8_rec):nextPutAll_("\"\"\"");
	return ((_s8_rec):cr())
end
)(self))
end)));
end
,"encoding","multilineComment: array\r\n\t\" Private - Encode an array as a multiline comment. \"\r\n\r\n\t^self encode: [\r\n\t\tself nextPutAll: '\"\"\"' ;indent.\r\n\t\tarray do: [:line| self cr; nextPutAll: line ].\r\n\t\tself dedent; cr; nextPutAll: '\"\"\"'; cr\r\n\t]","function(self,array)\r\nreturn ((self):encode_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"\\\"\\\"\\\"\");\r\n\treturn ((_s8_rec):indent())\r\nend\r\n)(self);(array):do_((function(line)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(line))\r\nend\r\n)(self))\r\nend));return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):dedent();\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):nextPutAll_(\"\\\"\\\"\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"startupExpression",0
,function(self)
return ((self):encode_((function()
return ((
function(_s8_rec)
	(_s8_rec):assign_to_("smalltalk, nil",(function()
return ((self):send_to_("startup","smalltalk"))
end));
	return ((_s8_rec):cr())
end
)(self))
end)));
end
,"contents","startupExpression\r\n\t\" Private - Return the encoding for startup expression of the receiver. \"\r\n\r\n\t^self encode: [\r\n\t\tself assign: 'smalltalk, nil' to: [ self send: #startup to: #smalltalk ] ;cr\r\n\t]","function(self)\r\nreturn ((self):encode_((function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"smalltalk, nil\",(function()\r\nreturn ((self):send_to_(\"startup\",\"smalltalk\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"nilDefinition",0
,function(self)
return ((self):encode_((function()
return ((
function(_s8_rec)
	(_s8_rec):assign_to_("nil","None");
	return ((_s8_rec):cr())
end
)(self))
end)));
end
,"definitions","nilDefinition\r\n\t\" Private - Return the encoding for nil. \"\r\n\r\n\t^self encode: [\r\n\t\tself assign: #nil to: #None ;cr\r\n\t]","function(self)\r\nreturn ((self):encode_((function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"nil\",\"None\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"smalltalkDefinition",0
,function(self)
return ((self):encode_((function()
(smalltalk:newArray({smalltalk:newArray({"StObject", smalltalk:newArray({smalltalk:newArray({"__init__", smalltalk:newArray({"aHandle=nil"})}), "asParameter", "handle", "halt", "klass", "toString", "__str__", "__repr__"})}), smalltalk:newArray({smalltalk:newArray({"SuperForClass", smalltalk:newArray({"object"})}), smalltalk:newArray({smalltalk:newArray({"__init__", smalltalk:newArray({"type", "obj=None"})}), smalltalk:newArray({"__get__", smalltalk:newArray({"obj", "type=None"})}), smalltalk:newArray({"__getattr__", smalltalk:newArray({"attr"})})})}), smalltalk:newArray({smalltalk:newArray({"StMetaType", smalltalk:newArray({"type"})}), smalltalk:newArray({smalltalk:newArray({"lookup:in:", smalltalk:newArray({"selector", "aClass"})}), smalltalk:newArray({"__getattribute__", smalltalk:newArray({"item"})})})}), smalltalk:newArray({"StSystemDictionary", smalltalk:newArray({"__init__", smalltalk:newArray({"__setitem__", smalltalk:newArray({"item", "value"})}), smalltalk:newArray({"superReceiver", smalltalk:newArray({"implementor", "receiver"})}), smalltalk:newArray({"linkRoute", smalltalk:newArray({"receiver", "parent"})}), smalltalk:newArray({"mapClassName", smalltalk:newArray({"className", "category", "native=nil", "superclass=nil"})}), smalltalk:newArray({"available", smalltalk:newArray({"*modules"})}), smalltalk:newArray({"moduleAt", smalltalk:newArray({"module", "field"})}), smalltalk:newArray({"state:", smalltalk:newArray({"aState"})}), smalltalk:newArray({"do:onError:", smalltalk:newArray({"aBlock", "errorBlock"})}), smalltalk:newArray({"is_Nil", smalltalk:newArray({"aValue"})}), smalltalk:newArray({"isNil:", smalltalk:newArray({"aValue"})}), smalltalk:newArray({"not_Nil", smalltalk:newArray({"aValue"})}), smalltalk:newArray({"notNil:", smalltalk:newArray({"aValue"})}), smalltalk:newArray({"stringOf", smalltalk:newArray({"nativeString"})}), smalltalk:newArray({"b", smalltalk:newArray({"aBoolean"})}), smalltalk:newArray({"b_", smalltalk:newArray({"aBool"})}), smalltalk:newArray({"asObject:", smalltalk:newArray({"aNativeObject"})}), smalltalk:newArray({"asNativeValue:", smalltalk:newArray({"anObject"})}), smalltalk:newArray({"nativeCall", smalltalk:newArray({"anObject", "selector", "*args"})}), smalltalk:newArray({"blk", smalltalk:newArray({"func", "argumentCount=nil", "info=nil"})}), smalltalk:newArray({"setVarNames", smalltalk:newArray({"aClass", "iVarNames", "aValue=nil"})}), smalltalk:newArray({"setPropertyNames", smalltalk:newArray({"aClass", "pNames", "aValue=nil"})}), smalltalk:newArray({"setClass", smalltalk:newArray({"aClass", "spec"})}), smalltalk:newArray({"fnInSpec", smalltalk:newArray({"spec"})}), "classes", smalltalk:newArray({"computeMetaSubclassesOf:", smalltalk:newArray({"aClass"})}), "computeSubclasses", smalltalk:newArray({"subclasses", smalltalk:newArray({"aClass=nil"})}), smalltalk:newArray({"allSubclassesDo", smalltalk:newArray({"aClass", "aBlock"})}), smalltalk:newArray({"bindRoots", smalltalk:newArray({"ignored=None"})}), smalltalk:newArray({"isArray_equalTo", smalltalk:newArray({"table1", "table2"})}), smalltalk:newArray({"is_Number", smalltalk:newArray({"x"})}), smalltalk:newArray({"isObject_equalTo", smalltalk:newArray({"receiver", "anObject"})}), smalltalk:newArray({"isObject:equalTo:", smalltalk:newArray({"receiver", "anObject"})}), smalltalk:newArray({"isObject_eqeq", smalltalk:newArray({"receiver", "anObject"})}), smalltalk:newArray({"isObject:eqeq:", smalltalk:newArray({"receiver", "anObject"})}), smalltalk:newArray({"object:comma:", smalltalk:newArray({"receiver", "anObject"})}), smalltalk:newArray({"basic_at_ifAbsent", smalltalk:newArray({"receiver", "key", "aBlock"})}), smalltalk:newArray({"basic:at:ifAbsent:", smalltalk:newArray({"receiver", "key", "aBlock"})}), smalltalk:newArray({"basic:at:", smalltalk:newArray({"receiver", "key"})}), smalltalk:newArray({"basic_at_put", smalltalk:newArray({"receiver", "key", "value"})}), smalltalk:newArray({"basic:at:put:", smalltalk:newArray({"receiver", "key", "value"})}), smalltalk:newArray({"callBlock0:", smalltalk:newArray({"aBlock", "noBlockValue=nil"})}), smalltalk:newArray({"ifUndefined:do:", smalltalk:newArray({"receiver", "aBlock"})}), smalltalk:newArray({"times:repeat:", smalltalk:newArray({"count", "aBlock"})}), smalltalk:newArray({"isBoolean:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"boolean:and:", smalltalk:newArray({"receiver", "option"})}), smalltalk:newArray({"boolean:or:", smalltalk:newArray({"receiver", "option"})}), smalltalk:newArray({"booleanNot:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"asCharacter:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"to_String", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"printString:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"asString:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"mustBeNumber:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"math:max:", smalltalk:newArray({"receiver", "aNumber"})}), smalltalk:newArray({"math:min:", smalltalk:newArray({"receiver", "aNumber"})}), smalltalk:newArray({"addClass", smalltalk:newArray({"className", "superclass", "iVarNames=[]", "category=\"\""})}), smalltalk:newArray({"renameClass", smalltalk:newArray({"aClass", "aString"})}), smalltalk:newArray({"removeClass", smalltalk:newArray({"aClass"})}), smalltalk:newArray({"metaVarNames", smalltalk:newArray({"aMetaClass", "iVarNames"})}), smalltalk:newArray({"smDo", smalltalk:newArray({"block"})}), smalltalk:newArray({"classChanged", smalltalk:newArray({"aBehavior"})}), smalltalk:newArray({"classShapeChanged", smalltalk:newArray({"aBehavior"})}), smalltalk:newArray({"aboutToCreateClass", smalltalk:newArray({"className", "superclass", "iVarNames", "category"})}), smalltalk:newArray({"aboutToChangeClass", smalltalk:newArray({"aClass", "superclass", "iVarNames", "category"})}), smalltalk:newArray({"methodBoundTo", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"aboutToBindTo", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"aboutToRemoveFrom", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"methodRemovedFrom", smalltalk:newArray({"method", "klass"})}), smalltalk:newArray({"objectNotFound", smalltalk:newArray({"object", "indexOrKey", "collection"})}), smalltalk:newArray({"whoImplements", smalltalk:newArray({"klass", "jsSelector"})}), smalltalk:newArray({"superImplementor", smalltalk:newArray({"klass", "jsSelector"})}), smalltalk:newArray({"instVarAt", smalltalk:newArray({"object", "ivName", "default=nil"})}), smalltalk:newArray({"fn_Of", smalltalk:newArray({"klass"})}), smalltalk:newArray({"prototype_Of", smalltalk:newArray({"klass"})}), smalltalk:newArray({"methods_Of", smalltalk:newArray({"klass"})}), smalltalk:newArray({"register:method:in:", smalltalk:newArray({"stSelector", "aMethod", "klass"})}), smalltalk:newArray({"unregister:in:", smalltalk:newArray({"stSelector", "klass"})}), smalltalk:newArray({"addMethod", smalltalk:newArray({"jsSelector", "method", "klass", "stSelector=nil"})}), smalltalk:newArray({"bind", smalltalk:newArray({"klass", "stSelector", "jsSelector", "jsFunction", "category", "stSource", "nativeSource=nil", "stamp=nil"})}), smalltalk:newArray({"removeMethod", smalltalk:newArray({"aClass", "aMethod"})}), smalltalk:newArray({"newMethod", smalltalk:newArray({"currentClass", "selector", "fn", "source", "nativeSource=nil", "stamp=nil"})}), smalltalk:newArray({"readJSObject", smalltalk:newArray({"js"})}), smalltalk:newArray({"basen", smalltalk:newArray({"n", "bas", "numerals=\"0123456789abcdefghijklmnopqrstuvwxyz\""})}), smalltalk:newArray({"globalsDo", smalltalk:newArray({"action"})}), smalltalk:newArray({"launchImage", smalltalk:newArray({"imageName=nil"})}), smalltalk:newArray({"is:kindOf:", smalltalk:newArray({"anObject", "aClass"})}), smalltalk:newArray({"responds_to", smalltalk:newArray({"anObject", "jsSelector"})}), smalltalk:newArray({"responds:to:", smalltalk:newArray({"anObject", "aSelector"})}), smalltalk:newArray({"isObject", smalltalk:newArray({"anObject"})}), smalltalk:newArray({"handleOf", smalltalk:newArray({"anObject"})}), smalltalk:newArray({"handleOf:or:", smalltalk:newArray({"anObject", "default"})}), "newHash", "newContext", "stObject", smalltalk:newArray({"debugBind", smalltalk:newArray({"klass", "stSelector", "jsSelector", "jsFunction", "category", "stSource", "nativeSource=nil", "stamp=nil"})}), smalltalk:newArray({"debugAddClass", smalltalk:newArray({"className", "superclass", "iVarNames", "category"})}), "toString", "quit", "version", smalltalk:newArray({"httpContents", smalltalk:newArray({"fileName"})}), smalltalk:newArray({"folderContents", smalltalk:newArray({"fileName"})}), smalltalk:newArray({"fileContents", smalltalk:newArray({"fileName"})}), smalltalk:newArray({"fileWrite", smalltalk:newArray({"fileName", "contents", "mode"})}), smalltalk:newArray({"fileIn", smalltalk:newArray({"fileName"})}), smalltalk:newArray({"emmit", smalltalk:newArray({"fileName"})}), smalltalk:newArray({"fileInJS", smalltalk:newArray({"fileName"})}), smalltalk:newArray({"exportCategory", smalltalk:newArray({"aString"})}), "saveImage", smalltalk:newArray({"saveImageAs", smalltalk:newArray({"fileName"})}), smalltalk:newArray({"isFileOlderThan", smalltalk:newArray({"fileName", "referenceFileName"})}), smalltalk:newArray({"copyTo", smalltalk:newArray({"anInstance"})}), "startup", "niy", smalltalk:newArray({"niy:", smalltalk:newArray({"msg"})}), smalltalk:newArray({"invalidMessage:", smalltalk:newArray({"msg"})}), "obsolete", smalltalk:newArray({"toObjects", smalltalk:newArray({"list"})}), smalltalk:newArray({"reshape:of:", smalltalk:newArray({"field", "anObject"})}), smalltalk:newArray({"reshapeClass:", smalltalk:newArray({"aClass"})}), "reshapeClasses", smalltalk:newArray({"linkNative:to:", smalltalk:newArray({"instance", "aClass"})}), smalltalk:newArray({"arguments:toCall:", smalltalk:newArray({"args", "aBlock"})}), smalltalk:newArray({"objects:toCall:", smalltalk:newArray({"anArray", "aBlock"})}), smalltalk:newArray({"makeCallable:", smalltalk:newArray({"aClass"})}), smalltalk:newArray({"makeStringable:", smalltalk:newArray({"aClass"})}), "linkNatives", "bindCore", smalltalk:newArray({"newArray", smalltalk:newArray({"object"})}), smalltalk:newArray({"newConstructor", smalltalk:newArray({"superC"})}), smalltalk:newArray({"will:be:", smalltalk:newArray({"anObject", "className"})}), smalltalk:newArray({"become:a:", smalltalk:newArray({"anObject", "aClass"})}), smalltalk:newArray({"setProtoOf:to:", smalltalk:newArray({"nativeObject", "proto"})}), smalltalk:newArray({"klass", smalltalk:newArray({"spec"})}), smalltalk:newArray({"__f__", smalltalk:newArray({"source", "tag=nil"})}), smalltalk:newArray({"import:", smalltalk:newArray({"libraryName"})}), smalltalk:newArray({"from:import:", smalltalk:newArray({"libraryName", "aName"})}), smalltalk:newArray({"if:nil:notNil:", smalltalk:newArray({"anObject", "block1", "block2"})}), smalltalk:newArray({"if:true:false:", smalltalk:newArray({"aBoolean", "blk1", "blk2"})}), smalltalk:newArray({"while:do:", smalltalk:newArray({"condition", "aBlock"})}), smalltalk:newArray({"whileNot:do:", smalltalk:newArray({"condition", "aBlock"})}), smalltalk:newArray({"raise:result:", smalltalk:newArray({"_s8Ret_", "result"})}), smalltalk:newArray({"exceptionResult:", smalltalk:newArray({"__ex"})}), smalltalk:newArray({"exception_at", smalltalk:newArray({"__ex", "target"})}), smalltalk:newArray({"value:withTimeout:", smalltalk:newArray({"aBlock", "aNumber"})}), smalltalk:newArray({"value:withInterval:", smalltalk:newArray({"aBlock", "aNumber"})}), smalltalk:newArray({"argumentCount:", smalltalk:newArray({"aCallable"})}), smalltalk:newArray({"pool:at:put:", smalltalk:newArray({"pool", "aKey", "aValue"})}), smalltalk:newArray({"pool:removeKey:", smalltalk:newArray({"pool", "aKey"})}), smalltalk:newArray({"pool:at:ifAbsent:", smalltalk:newArray({"pool", "aKey", "aBlock"})}), smalltalk:newArray({"pool:includesKey:", smalltalk:newArray({"pool", "aKey"})}), smalltalk:newArray({"pool_keys", smalltalk:newArray({"pool"})}), smalltalk:newArray({"arrayHasNativeContents", smalltalk:newArray({"anArray"})}), smalltalk:newArray({"arrayContents", smalltalk:newArray({"anArray"})}), smalltalk:newArray({"arrayHandles", smalltalk:newArray({"anArray"})}), smalltalk:newArray({"array:at:", smalltalk:newArray({"anArray", "anIndex"})}), smalltalk:newArray({"array:at:ifAbsent:", smalltalk:newArray({"anArray", "anIndex", "aBlock"})}), smalltalk:newArray({"array:at:put:", smalltalk:newArray({"anArray", "anIndex", "anObject"})}), smalltalk:newArray({"array:join:", smalltalk:newArray({"anArray", "aString"})}), smalltalk:newArray({"array:copyWithAll:", smalltalk:newArray({"receiver", "anArray"})}), smalltalk:newArray({"array:sort:", smalltalk:newArray({"anArray", "aBlock"})}), smalltalk:newArray({"array:remove:ifAbsent:", smalltalk:newArray({"receiver", "anObject", "aBlock"})}), smalltalk:newArray({"array:atAllPut:", smalltalk:newArray({"receiver", "anObject"})}), smalltalk:newArray({"hashedSet:privateAdd:", smalltalk:newArray({"aSet", "cookie"})}), smalltalk:newArray({"hashedSet:privateRemove:", smalltalk:newArray({"aSet", "cookie"})}), smalltalk:newArray({"string:isLiteral:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"string:match", smalltalk:newArray({"receiver", "aRegexp"})}), smalltalk:newArray({"string:occurrencesOf:", smalltalk:newArray({"receiver", "aString"})}), smalltalk:newArray({"string:startsWith:", smalltalk:newArray({"receiver", "aString"})}), smalltalk:newArray({"string:asNumber:", smalltalk:newArray({"receiver"})}), smalltalk:newArray({"string:asPrivateSelector:", smalltalk:newArray({"receiver"})}), "outerFramesCount", "asPoolDictionary", smalltalk:newArray({"debug:", smalltalk:newArray({"aBoolean"})}), "startDebug", "debug", "testAll", smalltalk:newArray({"test", smalltalk:newArray({"what"})}), smalltalk:newArray({"testFrom", smalltalk:newArray({"first", "last=1000"})}), smalltalk:newArray({"t", smalltalk:newArray({"number"})})})})})):do_((function(tuple)
return ((
function(_s8_rec)
	(_s8_rec):defineClass_implementing_((tuple):first(),(tuple):last());
	return ((_s8_rec):cr())
end
)(self))
end));return ((self):define_asInstanceOf_("smalltalk","SystemDictionary"))
end)));
end
,"definitions","smalltalkDefinition\r\n\t\" Private - Return the encoding for smalltalk. \"\r\n\r\n\t^self encode: [\r\n\t\t#(\t#(StObject #(\r\n\t\t\t\t#(__init__ #('aHandle=nil'))\r\n\t\t\t\tasParameter handle halt klass\r\n\t\t\t\ttoString __str__ __repr__\r\n\t\t\t))\r\n\t\t\t#(#(SuperForClass #(object)) #(\r\n\t\t\t\t#(__init__ #( type 'obj=None'))\r\n\t\t\t\t#(__get__ #( obj 'type=None'))\r\n\t\t\t\t#(__getattr__ #(attr))\r\n\t\t\t))\r\n\t\t\t#(#(StMetaType #(type)) #(\r\n\t\t\t\t#(lookup:in: #(selector aClass))\r\n\t\t\t\t#(__getattribute__ #(item))\r\n\t\t\t))\r\n\t\t\t#(StSystemDictionary #(\r\n\t\t\t\t__init__\r\n\t\t\t\t#(__setitem__ #(item value))\r\n\t\t\t\t#(superReceiver #(implementor receiver))\r\n\t\t\t\t#(linkRoute #(receiver parent))\r\n\t\t\t\t#(mapClassName #(className category 'native=nil' 'superclass=nil'))\r\n\t\t\t\t#(available #('*modules'))\r\n\t\t\t\t#(moduleAt #(module field))\r\n\t\t\t\t#(state: #(aState))\r\n\t\t\t\t#(do:onError: #(aBlock errorBlock))\r\n\t\t\t\t#(is_Nil #(aValue))\r\n\t\t\t\t#(isNil: #(aValue))\r\n\t\t\t\t#(not_Nil #(aValue))\r\n\t\t\t\t#(notNil: #(aValue))\r\n\t\t\t\t#(stringOf #(nativeString))\r\n\t\t\t\t#(b #(aBoolean))\r\n\t\t\t\t#(b_ #(aBool))\r\n\t\t\t\t#(asObject: #(aNativeObject))\r\n\t\t\t\t#(asNativeValue: #(anObject))\r\n\t\t\t\t#(nativeCall #(anObject selector '*args'))\r\n\t\t\t\t#(blk #(func 'argumentCount=nil' 'info=nil'))\r\n\t\t\t\t#(setVarNames #(aClass iVarNames 'aValue=nil'))\r\n\t\t\t\t#(setPropertyNames #(aClass pNames 'aValue=nil'))\r\n\t\t\t\t#(setClass #(aClass spec))\r\n\t\t\t\t#(fnInSpec #(spec))\r\n\t\t\t\tclasses\r\n\t\t\t\t#(computeMetaSubclassesOf: #(aClass))\r\n\t\t\t\tcomputeSubclasses\r\n\t\t\t\t#(subclasses #('aClass=nil'))\r\n\t\t\t\t#(allSubclassesDo #(aClass aBlock))\r\n\t\t\t\t#(bindRoots #('ignored=None'))\r\n\t\t\t\t#(isArray_equalTo #(table1 table2))\r\n\t\t\t\t#(is_Number #(x))\r\n\t\t\t\t#(isObject_equalTo #(receiver anObject))\r\n\t\t\t\t#(isObject:equalTo: #(receiver anObject))\r\n\t\t\t\t#(isObject_eqeq #(receiver anObject))\r\n\t\t\t\t#(isObject:eqeq: #(receiver anObject))\r\n\t\t\t\t#(object:comma: #(receiver anObject))\r\n\t\t\t\t#(basic_at_ifAbsent #(receiver key aBlock))\r\n\t\t\t\t#(basic:at:ifAbsent: #(receiver key aBlock))\r\n\t\t\t\t#(basic:at: #(receiver key))\r\n\t\t\t\t#(basic_at_put #(receiver key value))\r\n\t\t\t\t#(basic:at:put: #(receiver key value))\r\n\t\t\t\t#(callBlock0: #(aBlock 'noBlockValue=nil'))\r\n\t\t\t\t#(ifUndefined:do: #(receiver aBlock))\r\n\t\t\t\t#(times:repeat: #(count aBlock))\r\n\t\t\t\t#(isBoolean: #(receiver))\r\n\t\t\t\t #(boolean:and: #(receiver option))\r\n\t\t\t\t #(boolean:or: #(receiver option))\r\n\t\t\t\t#(booleanNot: #(receiver))\r\n\t\t\t\t#(asCharacter: #(receiver))\r\n\t\t\t\t#(to_String #(receiver))\r\n\t\t\t\t#(printString: #(receiver))\r\n\t\t\t\t#(asString: #(receiver))\r\n\t\t\t\t#(mustBeNumber: #(receiver))\r\n\t\t\t\t#(math:max: #(receiver aNumber))\r\n\t\t\t\t#(math:min: #(receiver aNumber))\r\n\t\t\t\t#(addClass #(className superclass 'iVarNames=[]' 'category=\"\"'))\r\n\t\t\t\t#(renameClass #(aClass aString))\r\n\t\t\t\t#(removeClass #(aClass))\r\n\t\t\t\t#(metaVarNames #(aMetaClass iVarNames))\r\n\t\t\t\t#(smDo #(block))\r\n\t\t\t\t#(classChanged #(aBehavior))\r\n\t\t\t\t#(classShapeChanged #(aBehavior))\r\n\t\t\t\t#(aboutToCreateClass #(className superclass iVarNames category))\r\n\t\t\t\t#(aboutToChangeClass #(aClass superclass iVarNames category))\r\n\t\t\t\t#(methodBoundTo #(method klass))\r\n\t\t\t\t#(aboutToBindTo #(method klass))\r\n\t\t\t\t#(aboutToRemoveFrom #(method klass))\r\n\t\t\t\t#(methodRemovedFrom #(method klass))\r\n\t\t\t\t#(objectNotFound #(object indexOrKey collection))\r\n\t\t\t\t#(whoImplements #(klass jsSelector))\r\n\t\t\t\t#(superImplementor #(klass jsSelector))\r\n\t\t\t\t#(instVarAt #(object ivName 'default=nil'))\r\n\t\t\t\t#(fn_Of #(klass))\r\n\t\t\t\t#(prototype_Of #(klass))\r\n\t\t\t\t#(methods_Of #(klass))\r\n\t\t\t\t#(register:method:in: #(stSelector aMethod klass))\r\n\t\t\t\t#(unregister:in: #(stSelector klass))\r\n\t\t\t\t#(addMethod #(jsSelector method klass 'stSelector=nil'))\r\n\t\t\t\t#(bind #(klass stSelector jsSelector jsFunction category stSource 'nativeSource=nil' 'stamp=nil'))\r\n\t\t\t\t#(removeMethod #(aClass aMethod))\r\n\t\t\t\t#(newMethod #(currentClass selector fn source 'nativeSource=nil' 'stamp=nil'))\r\n\"OBSOLETE\t\t\t#(method #(spec))\"\r\n\t\t\t\t#(readJSObject #(js))\r\n\t\t\t\t#(basen #(n bas 'numerals=\"0123456789abcdefghijklmnopqrstuvwxyz\"'))\r\n\t\t\t\t#(globalsDo #(action))\r\n\t\t\t\t#(launchImage #('imageName=nil'))\r\n\t\t\t\t#(is:kindOf: #(anObject aClass))\r\n\t\t\t\t#(responds_to #(anObject jsSelector))\r\n\t\t\t\t#(responds:to: #(anObject aSelector))\r\n\t\t\t\t#(isObject #(anObject))\r\n\t\t\t\t#(handleOf #(anObject))\r\n\t\t\t\t#(handleOf:or: #(anObject default))\r\n\t\t\t\tnewHash newContext stObject\r\n\t\t\t\t#(debugBind #(klass stSelector jsSelector jsFunction category stSource 'nativeSource=nil' 'stamp=nil'))\r\n\t\t\t\t#(debugAddClass #(className superclass iVarNames category))\r\n\t\t\t\ttoString quit version\r\n\t\t\t\t#(httpContents #(fileName))\r\n\t\t\t\t#(folderContents #(fileName))\r\n\t\t\t\t#(fileContents #(fileName))\r\n\t\t\t\t\"#(read #(fileName))\"\r\n\t\t\t\t#(fileWrite #(fileName contents mode))\r\n\t\t\t\t#(fileIn #(fileName))\r\n\t\t\t\t#(emmit #(fileName))\r\n\t\t\t\t#(fileInJS #(fileName))\r\n\t\t\t\t#(exportCategory #(aString))\r\n\t\t\t\tsaveImage\r\n\t\t\t\t#(saveImageAs #(fileName))\r\n\t\t\t\t#(isFileOlderThan #(fileName referenceFileName))\r\n\t\t\t\t#(copyTo #(anInstance))\r\n\t\t\t\tstartup\r\n\t\t\t\tniy\r\n\t\t\t\t#(niy: #(msg))\r\n\t\t\t\t#(invalidMessage: #(msg))\r\n\t\t\t\tobsolete\r\n\r\n\t\t\t\t#(toObjects #(list))\r\n\t\t\t\t#(reshape:of: #(field anObject))\r\n\t\t\t\t#(reshapeClass: #(aClass))\r\n\t\t\t\treshapeClasses\r\n\t\t\t\t#(linkNative:to: #(instance aClass))\r\n\t\t\t\t#(arguments:toCall: #(args aBlock))\r\n\t\t\t\t#(objects:toCall: #(anArray aBlock))\r\n\t\t\t\t#(makeCallable: #(aClass))\r\n\t\t\t\t#(makeStringable: #(aClass))\r\n\t\t\t\tlinkNatives\r\n\t\t\t\tbindCore\r\n\r\n\t\t\t\t#(newArray #(object))\r\n\t\t\t\t#(newConstructor #(superC))\r\n\t\t\t\t#(will:be: #(anObject className))\r\n\t\t\t\t#(become:a: #(anObject aClass))\r\n\t\t\t\t#(setProtoOf:to: #(nativeObject proto))\r\n\t\t\t\t#(klass #(spec))\r\n\t\t\t\t#(__f__ #(source 'tag=nil'))\r\n\t\t\t\t#(import: #(libraryName))\r\n\t\t\t\t#(from:import: #(libraryName aName))\r\n\"OBSOLETE\t\t\t#(__b__OBSOLETE #(source locals))\"\r\n\t\t\t\t#(if:nil:notNil: #(anObject block1 block2))\r\n\t\t\t\t#(if:true:false: #(aBoolean blk1 blk2))\r\n\t\t\t\t#(while:do: #(condition aBlock))\r\n\t\t\t\t#(whileNot:do: #(condition aBlock))\r\n\t\t\t\t#(raise:result: #(_s8Ret_ result))\r\n\t\t\t\t#(exceptionResult: #(__ex))\r\n\t\t\t\t#(exception_at #(__ex target))\r\n\r\n\t\t\t\t#(value:withTimeout: #(aBlock aNumber))\r\n\t\t\t\t#(value:withInterval: #(aBlock aNumber))\r\n\t\t\t\t#(argumentCount: #(aCallable))\r\n\t\t\t\t#(pool:at:put: #(pool aKey aValue))\r\n\t\t\t\t#(pool:removeKey: #(pool aKey))\r\n\t\t\t\t#(pool:at:ifAbsent: #(pool aKey aBlock))\r\n\t\t\t\t#(pool:includesKey: #(pool aKey))\r\n\t\t\t\t#(pool_keys #(pool))\r\n\t\t\t\t#(arrayHasNativeContents #(anArray))\r\n\t\t\t\t#(arrayContents #(anArray))\r\n\t\t\t\t#(arrayHandles #(anArray))\r\n\t\t\t\t#(array:at: #(anArray anIndex))\r\n\t\t\t\t#(array:at:ifAbsent: #(anArray anIndex aBlock))\r\n\t\t\t\t#(array:at:put: #(anArray anIndex anObject))\r\n\t\t\t\t#(array:join: #(anArray aString))\r\n\t\t\t\t#(array:copyWithAll: #(receiver anArray))\r\n\t\t\t\t#(array:sort: #(anArray aBlock))\r\n\t\t\t\t#(array:remove:ifAbsent: #(receiver anObject aBlock))\r\n\t\t\t\t#(array:atAllPut: #(receiver anObject))\r\n\t\t\t\t#(hashedSet:privateAdd: #(aSet cookie))\r\n\t\t\t\t#(hashedSet:privateRemove: #(aSet cookie))\r\n\t\t\t\t#(string:isLiteral: #(receiver))\r\n\t\t\t\t#(string:match #(receiver aRegexp))\r\n\t\t\t\t#(string:occurrencesOf: #(receiver aString))\r\n\t\t\t\t#(string:startsWith: #(receiver aString))\r\n\t\t\t\t#(string:asNumber: #(receiver))\r\n\t\t\t\t#(string:asPrivateSelector: #(receiver))\r\n\r\n\t\t\t\touterFramesCount\r\n\t\t\t\tasPoolDictionary\r\n\t\t\t\t#(debug: #(aBoolean))\r\n\t\t\t\tstartDebug\r\n\t\t\t\tdebug\r\n\r\n\t\t\t\ttestAll\r\n\t\t\t\t#(test #(what))\r\n\t\t\t\t#(testFrom #(first 'last=1000'))\r\n\t\t\t\t#(t #(number))\r\n\t\t\t))\r\n\t\t) do: [:tuple| self defineClass: tuple first implementing: tuple last;cr ].\r\n\t\tself define: #smalltalk asInstanceOf: #SystemDictionary\r\n\t]","function(self)\r\nreturn ((self):encode_((function()\r\n(smalltalk:newArray({smalltalk:newArray({\"StObject\", smalltalk:newArray({smalltalk:newArray({\"__init__\", smalltalk:newArray({\"aHandle=nil\"})}), \"asParameter\", \"handle\", \"halt\", \"klass\", \"toString\", \"__str__\", \"__repr__\"})}), smalltalk:newArray({smalltalk:newArray({\"SuperForClass\", smalltalk:newArray({\"object\"})}), smalltalk:newArray({smalltalk:newArray({\"__init__\", smalltalk:newArray({\"type\", \"obj=None\"})}), smalltalk:newArray({\"__get__\", smalltalk:newArray({\"obj\", \"type=None\"})}), smalltalk:newArray({\"__getattr__\", smalltalk:newArray({\"attr\"})})})}), smalltalk:newArray({smalltalk:newArray({\"StMetaType\", smalltalk:newArray({\"type\"})}), smalltalk:newArray({smalltalk:newArray({\"lookup:in:\", smalltalk:newArray({\"selector\", \"aClass\"})}), smalltalk:newArray({\"__getattribute__\", smalltalk:newArray({\"item\"})})})}), smalltalk:newArray({\"StSystemDictionary\", smalltalk:newArray({\"__init__\", smalltalk:newArray({\"__setitem__\", smalltalk:newArray({\"item\", \"value\"})}), smalltalk:newArray({\"superReceiver\", smalltalk:newArray({\"implementor\", \"receiver\"})}), smalltalk:newArray({\"linkRoute\", smalltalk:newArray({\"receiver\", \"parent\"})}), smalltalk:newArray({\"mapClassName\", smalltalk:newArray({\"className\", \"category\", \"native=nil\", \"superclass=nil\"})}), smalltalk:newArray({\"available\", smalltalk:newArray({\"*modules\"})}), smalltalk:newArray({\"moduleAt\", smalltalk:newArray({\"module\", \"field\"})}), smalltalk:newArray({\"state:\", smalltalk:newArray({\"aState\"})}), smalltalk:newArray({\"do:onError:\", smalltalk:newArray({\"aBlock\", \"errorBlock\"})}), smalltalk:newArray({\"is_Nil\", smalltalk:newArray({\"aValue\"})}), smalltalk:newArray({\"isNil:\", smalltalk:newArray({\"aValue\"})}), smalltalk:newArray({\"not_Nil\", smalltalk:newArray({\"aValue\"})}), smalltalk:newArray({\"notNil:\", smalltalk:newArray({\"aValue\"})}), smalltalk:newArray({\"stringOf\", smalltalk:newArray({\"nativeString\"})}), smalltalk:newArray({\"b\", smalltalk:newArray({\"aBoolean\"})}), smalltalk:newArray({\"b_\", smalltalk:newArray({\"aBool\"})}), smalltalk:newArray({\"asObject:\", smalltalk:newArray({\"aNativeObject\"})}), smalltalk:newArray({\"asNativeValue:\", smalltalk:newArray({\"anObject\"})}), smalltalk:newArray({\"nativeCall\", smalltalk:newArray({\"anObject\", \"selector\", \"*args\"})}), smalltalk:newArray({\"blk\", smalltalk:newArray({\"func\", \"argumentCount=nil\", \"info=nil\"})}), smalltalk:newArray({\"setVarNames\", smalltalk:newArray({\"aClass\", \"iVarNames\", \"aValue=nil\"})}), smalltalk:newArray({\"setPropertyNames\", smalltalk:newArray({\"aClass\", \"pNames\", \"aValue=nil\"})}), smalltalk:newArray({\"setClass\", smalltalk:newArray({\"aClass\", \"spec\"})}), smalltalk:newArray({\"fnInSpec\", smalltalk:newArray({\"spec\"})}), \"classes\", smalltalk:newArray({\"computeMetaSubclassesOf:\", smalltalk:newArray({\"aClass\"})}), \"computeSubclasses\", smalltalk:newArray({\"subclasses\", smalltalk:newArray({\"aClass=nil\"})}), smalltalk:newArray({\"allSubclassesDo\", smalltalk:newArray({\"aClass\", \"aBlock\"})}), smalltalk:newArray({\"bindRoots\", smalltalk:newArray({\"ignored=None\"})}), smalltalk:newArray({\"isArray_equalTo\", smalltalk:newArray({\"table1\", \"table2\"})}), smalltalk:newArray({\"is_Number\", smalltalk:newArray({\"x\"})}), smalltalk:newArray({\"isObject_equalTo\", smalltalk:newArray({\"receiver\", \"anObject\"})}), smalltalk:newArray({\"isObject:equalTo:\", smalltalk:newArray({\"receiver\", \"anObject\"})}), smalltalk:newArray({\"isObject_eqeq\", smalltalk:newArray({\"receiver\", \"anObject\"})}), smalltalk:newArray({\"isObject:eqeq:\", smalltalk:newArray({\"receiver\", \"anObject\"})}), smalltalk:newArray({\"object:comma:\", smalltalk:newArray({\"receiver\", \"anObject\"})}), smalltalk:newArray({\"basic_at_ifAbsent\", smalltalk:newArray({\"receiver\", \"key\", \"aBlock\"})}), smalltalk:newArray({\"basic:at:ifAbsent:\", smalltalk:newArray({\"receiver\", \"key\", \"aBlock\"})}), smalltalk:newArray({\"basic:at:\", smalltalk:newArray({\"receiver\", \"key\"})}), smalltalk:newArray({\"basic_at_put\", smalltalk:newArray({\"receiver\", \"key\", \"value\"})}), smalltalk:newArray({\"basic:at:put:\", smalltalk:newArray({\"receiver\", \"key\", \"value\"})}), smalltalk:newArray({\"callBlock0:\", smalltalk:newArray({\"aBlock\", \"noBlockValue=nil\"})}), smalltalk:newArray({\"ifUndefined:do:\", smalltalk:newArray({\"receiver\", \"aBlock\"})}), smalltalk:newArray({\"times:repeat:\", smalltalk:newArray({\"count\", \"aBlock\"})}), smalltalk:newArray({\"isBoolean:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"boolean:and:\", smalltalk:newArray({\"receiver\", \"option\"})}), smalltalk:newArray({\"boolean:or:\", smalltalk:newArray({\"receiver\", \"option\"})}), smalltalk:newArray({\"booleanNot:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"asCharacter:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"to_String\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"printString:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"asString:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"mustBeNumber:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"math:max:\", smalltalk:newArray({\"receiver\", \"aNumber\"})}), smalltalk:newArray({\"math:min:\", smalltalk:newArray({\"receiver\", \"aNumber\"})}), smalltalk:newArray({\"addClass\", smalltalk:newArray({\"className\", \"superclass\", \"iVarNames=[]\", \"category=\\\"\\\"\"})}), smalltalk:newArray({\"renameClass\", smalltalk:newArray({\"aClass\", \"aString\"})}), smalltalk:newArray({\"removeClass\", smalltalk:newArray({\"aClass\"})}), smalltalk:newArray({\"metaVarNames\", smalltalk:newArray({\"aMetaClass\", \"iVarNames\"})}), smalltalk:newArray({\"smDo\", smalltalk:newArray({\"block\"})}), smalltalk:newArray({\"classChanged\", smalltalk:newArray({\"aBehavior\"})}), smalltalk:newArray({\"classShapeChanged\", smalltalk:newArray({\"aBehavior\"})}), smalltalk:newArray({\"aboutToCreateClass\", smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"})}), smalltalk:newArray({\"aboutToChangeClass\", smalltalk:newArray({\"aClass\", \"superclass\", \"iVarNames\", \"category\"})}), smalltalk:newArray({\"methodBoundTo\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"aboutToBindTo\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"aboutToRemoveFrom\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"methodRemovedFrom\", smalltalk:newArray({\"method\", \"klass\"})}), smalltalk:newArray({\"objectNotFound\", smalltalk:newArray({\"object\", \"indexOrKey\", \"collection\"})}), smalltalk:newArray({\"whoImplements\", smalltalk:newArray({\"klass\", \"jsSelector\"})}), smalltalk:newArray({\"superImplementor\", smalltalk:newArray({\"klass\", \"jsSelector\"})}), smalltalk:newArray({\"instVarAt\", smalltalk:newArray({\"object\", \"ivName\", \"default=nil\"})}), smalltalk:newArray({\"fn_Of\", smalltalk:newArray({\"klass\"})}), smalltalk:newArray({\"prototype_Of\", smalltalk:newArray({\"klass\"})}), smalltalk:newArray({\"methods_Of\", smalltalk:newArray({\"klass\"})}), smalltalk:newArray({\"register:method:in:\", smalltalk:newArray({\"stSelector\", \"aMethod\", \"klass\"})}), smalltalk:newArray({\"unregister:in:\", smalltalk:newArray({\"stSelector\", \"klass\"})}), smalltalk:newArray({\"addMethod\", smalltalk:newArray({\"jsSelector\", \"method\", \"klass\", \"stSelector=nil\"})}), smalltalk:newArray({\"bind\", smalltalk:newArray({\"klass\", \"stSelector\", \"jsSelector\", \"jsFunction\", \"category\", \"stSource\", \"nativeSource=nil\", \"stamp=nil\"})}), smalltalk:newArray({\"removeMethod\", smalltalk:newArray({\"aClass\", \"aMethod\"})}), smalltalk:newArray({\"newMethod\", smalltalk:newArray({\"currentClass\", \"selector\", \"fn\", \"source\", \"nativeSource=nil\", \"stamp=nil\"})}), smalltalk:newArray({\"readJSObject\", smalltalk:newArray({\"js\"})}), smalltalk:newArray({\"basen\", smalltalk:newArray({\"n\", \"bas\", \"numerals=\\\"0123456789abcdefghijklmnopqrstuvwxyz\\\"\"})}), smalltalk:newArray({\"globalsDo\", smalltalk:newArray({\"action\"})}), smalltalk:newArray({\"launchImage\", smalltalk:newArray({\"imageName=nil\"})}), smalltalk:newArray({\"is:kindOf:\", smalltalk:newArray({\"anObject\", \"aClass\"})}), smalltalk:newArray({\"responds_to\", smalltalk:newArray({\"anObject\", \"jsSelector\"})}), smalltalk:newArray({\"responds:to:\", smalltalk:newArray({\"anObject\", \"aSelector\"})}), smalltalk:newArray({\"isObject\", smalltalk:newArray({\"anObject\"})}), smalltalk:newArray({\"handleOf\", smalltalk:newArray({\"anObject\"})}), smalltalk:newArray({\"handleOf:or:\", smalltalk:newArray({\"anObject\", \"default\"})}), \"newHash\", \"newContext\", \"stObject\", smalltalk:newArray({\"debugBind\", smalltalk:newArray({\"klass\", \"stSelector\", \"jsSelector\", \"jsFunction\", \"category\", \"stSource\", \"nativeSource=nil\", \"stamp=nil\"})}), smalltalk:newArray({\"debugAddClass\", smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"})}), \"toString\", \"quit\", \"version\", smalltalk:newArray({\"httpContents\", smalltalk:newArray({\"fileName\"})}), smalltalk:newArray({\"folderContents\", smalltalk:newArray({\"fileName\"})}), smalltalk:newArray({\"fileContents\", smalltalk:newArray({\"fileName\"})}), smalltalk:newArray({\"fileWrite\", smalltalk:newArray({\"fileName\", \"contents\", \"mode\"})}), smalltalk:newArray({\"fileIn\", smalltalk:newArray({\"fileName\"})}), smalltalk:newArray({\"emmit\", smalltalk:newArray({\"fileName\"})}), smalltalk:newArray({\"fileInJS\", smalltalk:newArray({\"fileName\"})}), smalltalk:newArray({\"exportCategory\", smalltalk:newArray({\"aString\"})}), \"saveImage\", smalltalk:newArray({\"saveImageAs\", smalltalk:newArray({\"fileName\"})}), smalltalk:newArray({\"isFileOlderThan\", smalltalk:newArray({\"fileName\", \"referenceFileName\"})}), smalltalk:newArray({\"copyTo\", smalltalk:newArray({\"anInstance\"})}), \"startup\", \"niy\", smalltalk:newArray({\"niy:\", smalltalk:newArray({\"msg\"})}), smalltalk:newArray({\"invalidMessage:\", smalltalk:newArray({\"msg\"})}), \"obsolete\", smalltalk:newArray({\"toObjects\", smalltalk:newArray({\"list\"})}), smalltalk:newArray({\"reshape:of:\", smalltalk:newArray({\"field\", \"anObject\"})}), smalltalk:newArray({\"reshapeClass:\", smalltalk:newArray({\"aClass\"})}), \"reshapeClasses\", smalltalk:newArray({\"linkNative:to:\", smalltalk:newArray({\"instance\", \"aClass\"})}), smalltalk:newArray({\"arguments:toCall:\", smalltalk:newArray({\"args\", \"aBlock\"})}), smalltalk:newArray({\"objects:toCall:\", smalltalk:newArray({\"anArray\", \"aBlock\"})}), smalltalk:newArray({\"makeCallable:\", smalltalk:newArray({\"aClass\"})}), smalltalk:newArray({\"makeStringable:\", smalltalk:newArray({\"aClass\"})}), \"linkNatives\", \"bindCore\", smalltalk:newArray({\"newArray\", smalltalk:newArray({\"object\"})}), smalltalk:newArray({\"newConstructor\", smalltalk:newArray({\"superC\"})}), smalltalk:newArray({\"will:be:\", smalltalk:newArray({\"anObject\", \"className\"})}), smalltalk:newArray({\"become:a:\", smalltalk:newArray({\"anObject\", \"aClass\"})}), smalltalk:newArray({\"setProtoOf:to:\", smalltalk:newArray({\"nativeObject\", \"proto\"})}), smalltalk:newArray({\"klass\", smalltalk:newArray({\"spec\"})}), smalltalk:newArray({\"__f__\", smalltalk:newArray({\"source\", \"tag=nil\"})}), smalltalk:newArray({\"import:\", smalltalk:newArray({\"libraryName\"})}), smalltalk:newArray({\"from:import:\", smalltalk:newArray({\"libraryName\", \"aName\"})}), smalltalk:newArray({\"if:nil:notNil:\", smalltalk:newArray({\"anObject\", \"block1\", \"block2\"})}), smalltalk:newArray({\"if:true:false:\", smalltalk:newArray({\"aBoolean\", \"blk1\", \"blk2\"})}), smalltalk:newArray({\"while:do:\", smalltalk:newArray({\"condition\", \"aBlock\"})}), smalltalk:newArray({\"whileNot:do:\", smalltalk:newArray({\"condition\", \"aBlock\"})}), smalltalk:newArray({\"raise:result:\", smalltalk:newArray({\"_s8Ret_\", \"result\"})}), smalltalk:newArray({\"exceptionResult:\", smalltalk:newArray({\"__ex\"})}), smalltalk:newArray({\"exception_at\", smalltalk:newArray({\"__ex\", \"target\"})}), smalltalk:newArray({\"value:withTimeout:\", smalltalk:newArray({\"aBlock\", \"aNumber\"})}), smalltalk:newArray({\"value:withInterval:\", smalltalk:newArray({\"aBlock\", \"aNumber\"})}), smalltalk:newArray({\"argumentCount:\", smalltalk:newArray({\"aCallable\"})}), smalltalk:newArray({\"pool:at:put:\", smalltalk:newArray({\"pool\", \"aKey\", \"aValue\"})}), smalltalk:newArray({\"pool:removeKey:\", smalltalk:newArray({\"pool\", \"aKey\"})}), smalltalk:newArray({\"pool:at:ifAbsent:\", smalltalk:newArray({\"pool\", \"aKey\", \"aBlock\"})}), smalltalk:newArray({\"pool:includesKey:\", smalltalk:newArray({\"pool\", \"aKey\"})}), smalltalk:newArray({\"pool_keys\", smalltalk:newArray({\"pool\"})}), smalltalk:newArray({\"arrayHasNativeContents\", smalltalk:newArray({\"anArray\"})}), smalltalk:newArray({\"arrayContents\", smalltalk:newArray({\"anArray\"})}), smalltalk:newArray({\"arrayHandles\", smalltalk:newArray({\"anArray\"})}), smalltalk:newArray({\"array:at:\", smalltalk:newArray({\"anArray\", \"anIndex\"})}), smalltalk:newArray({\"array:at:ifAbsent:\", smalltalk:newArray({\"anArray\", \"anIndex\", \"aBlock\"})}), smalltalk:newArray({\"array:at:put:\", smalltalk:newArray({\"anArray\", \"anIndex\", \"anObject\"})}), smalltalk:newArray({\"array:join:\", smalltalk:newArray({\"anArray\", \"aString\"})}), smalltalk:newArray({\"array:copyWithAll:\", smalltalk:newArray({\"receiver\", \"anArray\"})}), smalltalk:newArray({\"array:sort:\", smalltalk:newArray({\"anArray\", \"aBlock\"})}), smalltalk:newArray({\"array:remove:ifAbsent:\", smalltalk:newArray({\"receiver\", \"anObject\", \"aBlock\"})}), smalltalk:newArray({\"array:atAllPut:\", smalltalk:newArray({\"receiver\", \"anObject\"})}), smalltalk:newArray({\"hashedSet:privateAdd:\", smalltalk:newArray({\"aSet\", \"cookie\"})}), smalltalk:newArray({\"hashedSet:privateRemove:\", smalltalk:newArray({\"aSet\", \"cookie\"})}), smalltalk:newArray({\"string:isLiteral:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"string:match\", smalltalk:newArray({\"receiver\", \"aRegexp\"})}), smalltalk:newArray({\"string:occurrencesOf:\", smalltalk:newArray({\"receiver\", \"aString\"})}), smalltalk:newArray({\"string:startsWith:\", smalltalk:newArray({\"receiver\", \"aString\"})}), smalltalk:newArray({\"string:asNumber:\", smalltalk:newArray({\"receiver\"})}), smalltalk:newArray({\"string:asPrivateSelector:\", smalltalk:newArray({\"receiver\"})}), \"outerFramesCount\", \"asPoolDictionary\", smalltalk:newArray({\"debug:\", smalltalk:newArray({\"aBoolean\"})}), \"startDebug\", \"debug\", \"testAll\", smalltalk:newArray({\"test\", smalltalk:newArray({\"what\"})}), smalltalk:newArray({\"testFrom\", smalltalk:newArray({\"first\", \"last=1000\"})}), smalltalk:newArray({\"t\", smalltalk:newArray({\"number\"})})})})})):do_((function(tuple)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):defineClass_implementing_((tuple):first(),(tuple):last());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));return ((self):define_asInstanceOf_(\"smalltalk\",\"SystemDictionary\"))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"define:asInstanceOf:",0
,function(self,aName,clsName)
(
function(_s8_rec)
	(_s8_rec):assign_to_(aName,smalltalk:object_comma_((smalltalk:object_comma_(("St"),clsName)),"()"));
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"encoding","define: aName asInstanceOf: clsName\r\n\t\" Private - Return the encoding for defining a variable named aName. \"\r\n\r\n\tself assign: aName to: #St ,clsName ,'()'; cr ","function(self,aName,clsName)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(aName,smalltalk:object_comma_((smalltalk:object_comma_((\"St\"),clsName)),\"()\"));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"defineClass:implementing:",0
,function(self,header,functions)
if ((header):isString())==true then return ((self):defineClass_implementing_((smalltalk.Array):with_with_(header,smalltalk:newArray({})),functions)); end;
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("class");
	return ((_s8_rec):space())
end
)(self);
(self):nextPutAll_((header):first());
(self):pars_((function()
return ((self):nextPutArguments_((header):last()))
end));
(self):between_do_indent_(smalltalk:newArray({":", ""}),(function()
return ((functions):do_((function(spec)
return ((self):bind_api_((header):first(),spec))
end)))
end),true);
return (self);
end
,"encoding","defineClass: header implementing: functions\r\n\t\" Private - pyClasss definition. \"\r\n\r\n\theader isString ifTrue: [\r\n\t\t^self\tdefineClass: (Array with: header with: #())\r\n\t\t\timplementing: functions\r\n\t].\r\n\tself nextPutAll: #class; space.\r\n\tself nextPutAll: header first.\r\n\tself pars: [ self nextPutArguments: header last ].\r\n\tself between: #($: '') do: [\r\n\t\tfunctions do: [:spec| self bind: header first api: spec ]\r\n\t] indent: true","function(self,header,functions)\r\nif ((header):isString())==true then return ((self):defineClass_implementing_((smalltalk.Array):with_with_(header,smalltalk:newArray({})),functions)); end;\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"class\");\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(self):nextPutAll_((header):first());\r\n(self):pars_((function()\r\nreturn ((self):nextPutArguments_((header):last()))\r\nend));\r\n(self):between_do_indent_(smalltalk:newArray({\":\", \"\"}),(function()\r\nreturn ((functions):do_((function(spec)\r\nreturn ((self):bind_api_((header):first(),spec))\r\nend)))\r\nend),true);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"bind:api:",0
,function(self,className,spec)
local rcv=nil
local selector=nil
local action=nil
if ((spec):isString())==true then return ((self):bind_api_(className,(smalltalk.Array):with_with_(spec,smalltalk:newArray({})))); end;
if not ((((spec):last()):isArray()))==true then return ((self):error_(smalltalk:object_comma_(("Invalid/corrupt API spec "),(spec):asLiteral()))); end;
(function()
	local _s8_value=(smalltalk:object_comma_((((spec):first()):asSelector()),className))
	selector=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((function()
return ((rcv):perform_(selector))
end))
	action=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:responds_to_((self),(selector))),(function()
return (self)
end),(function()
return (smalltalk:if_true_false_((smalltalk:responds_to_(((self)["$klass"]),(selector))),(function()
return ((self)["$klass"])
end),(function()
return ((function()
	local _s8_value=((function()
return ((self):comment_(smalltalk:object_comma_((smalltalk:object_comma_(("*ToDo* - API "),(selector):asLiteral()))," Not Implemented Yet.")))
end))
	action=_s8_value
	return _s8_value
end)())
end)))
end)))
	rcv=_s8_value
	return _s8_value
end)();
(self):bind_arguments_doing_((spec):first(),(spec):last(),action);
return (self);
end
,"api","bind: className api: spec\r\n\t\" Private - Encoding for basic message implementation. \"\r\n\r\n\t| rcv selector action |\r\n\tspec isString ifTrue: [ ^self bind: className api: (Array with: spec with: #()) ].\r\n\tspec last isArray ifFalse: [\r\n\t\t^self error: 'Invalid/corrupt API spec ' ,spec asLiteral\r\n\t].\r\n\tselector := spec first asSelector ,className.\r\n\taction := [ rcv perform: selector ].\r\n\trcv := (self respondsTo: selector) ifTrue: [ self ] ifFalse: [\r\n\t\t(self class respondsTo: selector) ifTrue: [ self class ] ifFalse: [\r\n\t\t\t\" self error: 'Missing API implementation for ' ,selector asLiteral \"\r\n\t\t\taction := [ self comment: '*ToDo* - API ' ,selector asLiteral ,' Not Implemented Yet.' ]\r\n\t\t]\r\n\t].\r\n\tself bind: spec first arguments: spec last doing: action ","function(self,className,spec)\r\nlocal rcv=nil\r\nlocal selector=nil\r\nlocal action=nil\r\nif ((spec):isString())==true then return ((self):bind_api_(className,(smalltalk.Array):with_with_(spec,smalltalk:newArray({})))); end;\r\nif not ((((spec):last()):isArray()))==true then return ((self):error_(smalltalk:object_comma_((\"Invalid/corrupt API spec \"),(spec):asLiteral()))); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((((spec):first()):asSelector()),className))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((function()\r\nreturn ((rcv):perform_(selector))\r\nend))\r\n\taction=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:responds_to_((self),(selector))),(function()\r\nreturn (self)\r\nend),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:responds_to_(((self)[\"$klass\"]),(selector))),(function()\r\nreturn ((self)[\"$klass\"])\r\nend),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=((function()\r\nreturn ((self):comment_(smalltalk:object_comma_((smalltalk:object_comma_((\"*ToDo* - API \"),(selector):asLiteral())),\" Not Implemented Yet.\")))\r\nend))\r\n\taction=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)))\r\nend)))\r\n\trcv=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):bind_arguments_doing_((spec):first(),(spec):last(),action);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"implementFunction:arguments:doing:comment:",0
,function(self,selector,args,implementation,aComment)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("def");
	(_s8_rec):space();
	return ((_s8_rec):nextPutAll_((selector):asSelector()))
end
)(self);
(self):pars_((function()
return ((self):nextPutArguments_(args))
end));
(self):between_do_indent_comment_(smalltalk:newArray({":", ""}),implementation,true,aComment);
return (self);
end
,"asm","implementFunction: selector arguments: args doing: implementation comment: aComment\r\n\t\" Private - Encoding for internal method implementation. \"\r\n\r\n\tself nextPutAll: #def;space; nextPutAll: selector asSelector.\r\n\tself pars: [ self nextPutArguments: args ].\r\n\tself between: #($: '') do: implementation indent: true comment: aComment","function(self,selector,args,implementation,aComment)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"def\");\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):nextPutAll_((selector):asSelector()))\r\nend\r\n)(self);\r\n(self):pars_((function()\r\nreturn ((self):nextPutArguments_(args))\r\nend));\r\n(self):between_do_indent_comment_(smalltalk:newArray({\":\", \"\"}),implementation,true,aComment);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"bind:arguments:doing:comment:",0
,function(self,selector,args,implementation,aComment)
return ((self):implementFunction_arguments_doing_comment_(selector,smalltalk:object_comma_((smalltalk:newArray({"self"})),args),implementation,aComment));
end
,"asm","bind: selector arguments: args doing: implementation comment: aComment\r\n\t\" Private - Encoding for internal method implementation. \"\r\n\r\n\t^self\timplementFunction: selector arguments: #(self) ,args\r\n\t\tdoing: implementation comment: aComment ","function(self,selector,args,implementation,aComment)\r\nreturn ((self):implementFunction_arguments_doing_comment_(selector,smalltalk:object_comma_((smalltalk:newArray({\"self\"})),args),implementation,aComment));\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"with:as:do:",0
,function(self,expression,vars,aBlock)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("with");
	(_s8_rec):space();
	(_s8_rec):nextPutAll_(expression);
	(_s8_rec):space();
	(_s8_rec):nextPutAll_("as");
	(_s8_rec):space();
	(_s8_rec):nextPutAll_(vars);
	(_s8_rec):space();
	return ((_s8_rec):between_do_indent_((self):expressionsOPs(),aBlock,true))
end
)(self);
return (self);
end
,"asm","with: expression as: vars do: aBlock\r\n\t\" Private - Encoding for with expression. \"\r\n\r\n\tself\tnextPutAll: #with;space;\r\n\t\tnextPutAll: expression;space;\r\n\t\tnextPutAll: #as;space;\r\n\t\tnextPutAll: vars;space;\r\n\t\tbetween: self expressionsOPs do: aBlock indent: true","function(self,expression,vars,aBlock)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"with\");\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(expression);\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(\"as\");\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(vars);\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):between_do_indent_((self):expressionsOPs(),aBlock,true))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"blockOPs",0
,function(self)
return ((smalltalk.Array):with_with_(":",""));
end
,"asm-constants","blockOPs\r\n\t\" Private - Encoding for expression block OPs \"\r\n\r\n\t^Array with: $: with: '' ","function(self)\r\nreturn ((smalltalk.Array):with_with_(\":\",\"\"));\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"objectOPs",0
,function(self)
return ("{}");
end
,"asm-constants","objectOPs\r\n\t\" Private - Return the OPs for literal object definition. \"\r\n\r\n\t^'{}' ","function(self)\r\nreturn (\"{}\");\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"fieldOP",0
,function(self)
return (":");
end
,"asm-constants","fieldOP\r\n\t\" Private - Return the OP for tuple separator. \"\r\n\r\n\t^$: ","function(self)\r\nreturn (\":\");\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"andOP",0
,function(self)
return ("and");
end
,"asm-constants","andOP\r\n\t\" Private - Encoding for operand. \"\r\n\r\n\t^#and ","function(self)\r\nreturn (\"and\");\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"orOP",0
,function(self)
return ("or");
end
,"asm-constants","orOP\r\n\t\" Private - Encoding for operand. \"\r\n\r\n\t^#or ","function(self)\r\nreturn (\"or\");\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"notOP",0
,function(self)
return ("not ");
end
,"asm-constants","notOP\r\n\t\" Private - Return the OP for negation. \"\r\n\r\n\t^'not ' ","function(self)\r\nreturn (\"not \");\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"expressionPars",0
,function(self)
return (nil);
end
,"asm-constants","expressionPars\r\n\t\" Private - Encoding for expression (or nil) \"\r\n\r\n\t^nil ","function(self)\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"conditionPars:",0
,function(self,expression)
if ((expression):isString())==true then return (nil); end;
return ("()");
end
,"asm-constants","conditionPars: expression\r\n\t\" Private - Encoding for condition expression(or nil) \"\r\n\r\n\texpression isString ifTrue: [ ^nil ].\r\n\t^'()' \"self expressionPars\" ","function(self,expression)\r\nif ((expression):isString())==true then return (nil); end;\r\nreturn (\"()\");\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"opPars:",0
,function(self,expression)
return ("()");
end
,"asm-constants","opPars: expression\r\n\t\" Private - Encoding for expression in operation(or nil) \"\r\n\r\n\t^'()' ","function(self,expression)\r\nreturn (\"()\");\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"whileDoOPs",0
,function(self)
return ((smalltalk.Array):with_with_("while",""));
end
,"asm-constants","whileDoOPs\r\n\t\" Private - Return the OPs for while-do expression. \"\r\n\r\n\t^Array with: #while with: '' ","function(self)\r\nreturn ((smalltalk.Array):with_with_(\"while\",\"\"));\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"forDoOPs",0
,function(self)
return ((smalltalk.Array):with_with_("for",""));
end
,"asm-constants","forDoOPs\r\n\t\" Private - Return the OPs for for-do expression. \"\r\n\r\n\t^Array with: #for with: ''","function(self)\r\nreturn ((smalltalk.Array):with_with_(\"for\",\"\"));\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"forInDoOPs",0
,function(self)
return ((smalltalk.Array):with_with_with_("for","in",""));
end
,"asm-constants","forInDoOPs\r\n\t\" Private - Return the OPs for for-in-do expression. \"\r\n\r\n\t^Array with: #for with: #in with: ''","function(self)\r\nreturn ((smalltalk.Array):with_with_with_(\"for\",\"in\",\"\"));\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"forInDoPars",0
,function(self)
return ((smalltalk.Array):with_with_("",""));
end
,"asm-constants","forInDoPars\r\n\t\" Private - Return the parentesis for for-in-do expression. \"\r\n\r\n\t^Array with: '' with: ''","function(self)\r\nreturn ((smalltalk.Array):with_with_(\"\",\"\"));\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"assign:property:to:",0
,function(self,obj,key,expression)
(self):assign_to_(smalltalk:object_comma_((smalltalk:object_comma_((obj),".")),key),expression);
return (self);
end
,"asm","assign: obj property: key to: expression\r\n\t\" Private - Encoding for assignment to object property. \"\r\n\r\n\tself assign: obj ,$. ,key to: expression ","function(self,obj,key,expression)\r\n(self):assign_to_(smalltalk:object_comma_((smalltalk:object_comma_((obj),\".\")),key),expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"if:return:",0
,function(self,condition,expression)
(self):if_do_(condition,(function()
return ((self):return_(expression))
end));
return (self);
end
,"asm","if: condition return: expression\r\n\t\" Private - Encoding for conditional expression return. \"\r\n\r\n\tself if: condition do: [self return: expression]","function(self,condition,expression)\r\n(self):if_do_(condition,(function()\r\nreturn ((self):return_(expression))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"return:and:",0
,function(self,first,second)
(
function(_s8_rec)
	(_s8_rec):return_(first);
	(_s8_rec):space();
	(_s8_rec):nextPutAll_(",");
	return ((_s8_rec):nextPutAll_(second))
end
)(self);
return (self);
end
,"asm","return: first and: second\r\n\t\" Private - Encoding for returning two expressions. \"\r\n\r\n\tself return: first; space; nextPutAll: $,; nextPutAll: second ","function(self,first,second)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):return_(first);\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(\",\");\r\n\treturn ((_s8_rec):nextPutAll_(second))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"expressions:",0
,function(self,array)
(self):indent();
(array):do_separatedBy_((function(each)
return ((self):nextPutAll_(each))
end),(function()
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_("\\");
	return ((_s8_rec):cr())
end
)(self))
end));
(self):dedent();
return (self);
end
,"asm","expressions: array\r\n\t\" Private - Encoding for arrayed expressions. \"\r\n\r\n\tself indent.\r\n\tarray do: [:each| self nextPutAll: each ] separatedBy: [self nextPutAll: $\\;cr].\r\n\tself dedent.","function(self,array)\r\n(self):indent();\r\n(array):do_separatedBy_((function(each)\r\nreturn ((self):nextPutAll_(each))\r\nend),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"\\\\\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));\r\n(self):dedent();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"dot:",0
,function(self,expression)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(".");
	return ((_s8_rec):nextPutAll_(expression))
end
)(self);
return (self);
end
,"asm","dot: expression\r\n\t\" Private - Encoding for linked expression. \"\r\n\r\n\tself nextPutAll: $.; nextPutAll: expression","function(self,expression)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\".\");\r\n\treturn ((_s8_rec):nextPutAll_(expression))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"expr:cr:",0
,function(self,first,second)
(self):expressions_((smalltalk.Array):with_with_(first,second));
return (self);
end
,"asm","expr: first cr: second\r\n\t\" Private - Encoding for arrayed expressions. \"\r\n\r\n\tself expressions: (Array with: first with: second)","function(self,first,second)\r\n(self):expressions_((smalltalk.Array):with_with_(first,second));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"expr:cr:cr:",0
,function(self,first,second,third)
(self):expressions_((smalltalk.Array):with_with_with_(first,second,third));
return (self);
end
,"asm","expr: first cr: second cr: third\r\n\t\" Private - Encoding for arrayed expressions. \"\r\n\r\n\tself expressions: (Array with: first with: second with: third)","function(self,first,second,third)\r\n(self):expressions_((smalltalk.Array):with_with_with_(first,second,third));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"expr:plus:",0
,function(self,first,second)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(first);
	(_s8_rec):space();
	(_s8_rec):nextPutAll_("+");
	(_s8_rec):space();
	return ((_s8_rec):nextPutAll_(second))
end
)(self);
return (self);
end
,"asm","expr: first plus: second\r\n\t\" Private - Encoding for sum expression. \"\r\n\r\n\tself\tnextPutAll: first; space;\r\n\t\tnextPutAll: #+; space;\r\n\t\tnextPutAll: second ","function(self,first,second)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(first);\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(\"+\");\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):nextPutAll_(second))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"expr:plus:plus:",0
,function(self,first,second,third)
(self):expressions_((smalltalk.Array):with_with_with_(first,(function()
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_("+");
	return ((_s8_rec):nextPutAll_(second))
end
)(self))
end),(function()
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_("+");
	return ((_s8_rec):nextPutAll_(third))
end
)(self))
end)));
return (self);
end
,"asm","expr: first plus: second plus: third\r\n\t\" Private - Encoding for arrayed sum expressions. \"\r\n\r\n\tself expressions: (Array with: first\r\n\t\twith: [self nextPutAll: #+; nextPutAll: second]\r\n\t\twith: [self nextPutAll: #+; nextPutAll: third])","function(self,first,second,third)\r\n(self):expressions_((smalltalk.Array):with_with_with_(first,(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"+\");\r\n\treturn ((_s8_rec):nextPutAll_(second))\r\nend\r\n)(self))\r\nend),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"+\");\r\n\treturn ((_s8_rec):nextPutAll_(third))\r\nend\r\n)(self))\r\nend)));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"raise:",0
,function(self,what)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("raise");
	(_s8_rec):space();
	return ((_s8_rec):nextPutAll_(what))
end
)(self);
return (self);
end
,"asm","raise: what\r\n\t\" Private - Encoding for raising exceptions. \"\r\n\r\n\tself nextPutAll: #raise; space; nextPutAll: what ","function(self,what)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"raise\");\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):nextPutAll_(what))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"format:withArguments:",0
,function(self,aString,args)
(self):nextPutAll_(aString);
(
function(_s8_rec)
	(_s8_rec):space();
	(_s8_rec):nextPutAll_("%");
	return ((_s8_rec):space())
end
)(self);
(self):pars_((function()
return ((self):nextPutArguments_(args))
end));
return (self);
end
,"asm","format: aString withArguments: args\r\n\t\" Private - Encoding for traditional format string expressions. \"\r\n\r\n\tself nextPutAll: aString.\r\n\tself space; nextPutAll: #%; space.\r\n\tself pars: [ self nextPutArguments: args ] ","function(self,aString,args)\r\n(self):nextPutAll_(aString);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(\"%\");\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(self):pars_((function()\r\nreturn ((self):nextPutArguments_(args))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"sum:",0
,function(self,array)
(array):do_separatedBy_((function(each)
return ((self):nextPutAll_(each))
end),(function()
return ((self):nextPutAll_("+"))
end));
return (self);
end
,"asm","sum: array\r\n\t\" Private - Encoding for sum expressions inlined. \"\r\n\r\n\tarray do: [:each| self nextPutAll: each ] separatedBy: [self nextPutAll: $+] ","function(self,array)\r\n(array):do_separatedBy_((function(each)\r\nreturn ((self):nextPutAll_(each))\r\nend),(function()\r\nreturn ((self):nextPutAll_(\"+\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"property:of:",0
,function(self,aName,rcv)
(self):nextPutAll_(rcv);
(self):nextPutAll_(".");
(self):nextPutAll_(aName);
return (self);
end
,"asm","property: aName of: rcv\r\n\t\" Private - Encoding for accessing a property. \"\r\n\r\n\tself nextPutAll: rcv.\r\n\tself nextPutAll: $..\r\n\tself nextPutAll: aName ","function(self,aName,rcv)\r\n(self):nextPutAll_(rcv);\r\n(self):nextPutAll_(\".\");\r\n(self):nextPutAll_(aName);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"is:in:",0
,function(self,what,container)
(self):nextPutAll_(what);
(
function(_s8_rec)
	(_s8_rec):space();
	(_s8_rec):nextPutAll_("in");
	return ((_s8_rec):space())
end
)(self);
(self):nextPutAll_(container);
return (self);
end
,"asm","is: what in: container\r\n\t\" Private - Encoding for in expression. \"\r\n\r\n\tself nextPutAll: what.\r\n\tself space; nextPutAll: #in;space.\r\n\tself nextPutAll: container ","function(self,what,container)\r\n(self):nextPutAll_(what);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):space();\r\n\t(_s8_rec):nextPutAll_(\"in\");\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(self):nextPutAll_(container);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"pass",0
,function(self)
(self):nextPutAll_("pass");
return (self);
end
,"asm","pass\r\n\t\" Private - Encoding for pass. \"\r\n\r\n\tself nextPutAll: #pass ","function(self)\r\n(self):nextPutAll_(\"pass\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"import:",0
,function(self,what)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("import");
	return ((_s8_rec):space())
end
)(self);
(self):nextPutAll_(what);
return (self);
end
,"asm","import: what\r\n\t\" Private - Encoding for import declaration. \"\r\n\r\n\tself nextPutAll: #import; space.\r\n\tself nextPutAll: what ","function(self,what)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"import\");\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(self):nextPutAll_(what);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"from:import:",0
,function(self,library,what)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("from");
	return ((_s8_rec):space())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(library);
	return ((_s8_rec):space())
end
)(self);
(self):import_(what);
return (self);
end
,"asm","from: library import: what\r\n\t\" Private - Encoding for from-import declaration. \"\r\n\r\n\tself nextPutAll: #from; space.\r\n\tself nextPutAll: library; space.\r\n\tself import: what ","function(self,library,what)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"from\");\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(library);\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(self):import_(what);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"expr:lt:",0
,function(self,rcv,expression)
(self):expr_op_with_pars_(rcv,"<",expression,smalltalk:newArray({smalltalk:newArray({"", ""}), smalltalk:newArray({"", ""})}));
return (self);
end
,"asm","expr: rcv lt: expression\r\n\t\" Private - Compare expression. \"\r\n\r\n\tself\texpr: rcv op: #< with: expression\r\n\t\tpars: #(#('' '') #('' ''))","function(self,rcv,expression)\r\n(self):expr_op_with_pars_(rcv,\"<\",expression,smalltalk:newArray({smalltalk:newArray({\"\", \"\"}), smalltalk:newArray({\"\", \"\"})}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"expr:lteq:",0
,function(self,rcv,expression)
(self):expr_op_with_pars_(rcv,"<=",expression,smalltalk:newArray({smalltalk:newArray({"", ""}), smalltalk:newArray({"", ""})}));
return (self);
end
,"asm","expr: rcv lteq: expression\r\n\t\" Private - Compare expression. \"\r\n\r\n\tself\texpr: rcv op: #<= with: expression\r\n\t\tpars: #(#('' '') #('' ''))","function(self,rcv,expression)\r\n(self):expr_op_with_pars_(rcv,\"<=\",expression,smalltalk:newArray({smalltalk:newArray({\"\", \"\"}), smalltalk:newArray({\"\", \"\"})}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"expr:gt:",0
,function(self,rcv,expression)
(self):expr_op_with_pars_(rcv,">",expression,smalltalk:newArray({smalltalk:newArray({"", ""}), smalltalk:newArray({"", ""})}));
return (self);
end
,"asm","expr: rcv gt: expression\r\n\t\" Private - Compare expression. \"\r\n\r\n\tself\texpr: rcv op: #> with: expression\r\n\t\tpars: #(#('' '') #('' ''))","function(self,rcv,expression)\r\n(self):expr_op_with_pars_(rcv,\">\",expression,smalltalk:newArray({smalltalk:newArray({\"\", \"\"}), smalltalk:newArray({\"\", \"\"})}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"expr:less:",0
,function(self,rcv,expression)
(self):expr_op_with_pars_(rcv,"-",expression,smalltalk:newArray({smalltalk:newArray({"", ""}), smalltalk:newArray({"", ""})}));
return (self);
end
,"asm","expr: rcv less: expression\r\n\t\" Private - Decrement expression. \"\r\n\r\n\tself\texpr: rcv op: #- with: expression\r\n\t\tpars: #(#('' '') #('' ''))","function(self,rcv,expression)\r\n(self):expr_op_with_pars_(rcv,\"-\",expression,smalltalk:newArray({smalltalk:newArray({\"\", \"\"}), smalltalk:newArray({\"\", \"\"})}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"expr:gteq:",0
,function(self,rcv,expression)
(self):expr_op_with_pars_(rcv,">=",expression,smalltalk:newArray({smalltalk:newArray({"", ""}), smalltalk:newArray({"", ""})}));
return (self);
end
,"asm","expr: rcv gteq: expression\r\n\t\" Private - Compare expression. \"\r\n\r\n\tself\texpr: rcv op: #>= with: expression\r\n\t\tpars: #(#('' '') #('' ''))","function(self,rcv,expression)\r\n(self):expr_op_with_pars_(rcv,\">=\",expression,smalltalk:newArray({smalltalk:newArray({\"\", \"\"}), smalltalk:newArray({\"\", \"\"})}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"try:except:as:doing:",0
,function(self,block,tags,varName,exBlock)
(self):between_do_indent_(smalltalk:newArray({"try:", "except"}),block,true);
(
function(_s8_rec)
	(_s8_rec):space();
	return ((_s8_rec):nextPutAll_(tags))
end
)(self);
if (smalltalk:notNil_((varName)))==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_(" as ");
	return ((_s8_rec):nextPutAll_(varName))
end
)(self); end;
(self):between_do_indent_((smalltalk.Array):with_with_(":",nil),exBlock,true);
return (self);
end
,"asm","try: block except: tags as: varName doing: exBlock\r\n\t\" Private - Encoding for try/except expression. \"\r\n\r\n\tself between: #('try:' except) do: block indent: true.\r\n\tself space; nextPutAll: tags.\r\n\tvarName notNil ifTrue: [\r\n\t\tself nextPutAll: ' as '; nextPutAll: varName\r\n\t].\r\n\tself between: (Array with: $: with: nil) do: exBlock indent: true","function(self,block,tags,varName,exBlock)\r\n(self):between_do_indent_(smalltalk:newArray({\"try:\", \"except\"}),block,true);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):space();\r\n\treturn ((_s8_rec):nextPutAll_(tags))\r\nend\r\n)(self);\r\nif (smalltalk:notNil_((varName)))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\" as \");\r\n\treturn ((_s8_rec):nextPutAll_(varName))\r\nend\r\n)(self); end;\r\n(self):between_do_indent_((smalltalk.Array):with_with_(\":\",nil),exBlock,true);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"expr:is:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,"is",expr2);
return (self);
end
,"asm","expr: expr1 is: expr2\r\n\t\" Private - Encoding for is not expression. \"\r\n\r\n\tself expr: expr1 op: #is with: expr2","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,\"is\",expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"expr:isNot:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,"is not",expr2);
return (self);
end
,"asm","expr: expr1 isNot: expr2\r\n\t\" Private - Encoding for is not expression. \"\r\n\r\n\tself expr: expr1 op: 'is not' with: expr2","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,\"is not\",expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"expr:in:",0
,function(self,expr1,expr2)
(self):expr_op_with_(expr1,"in",expr2);
return (self);
end
,"asm","expr: expr1 in: expr2\r\n\t\" Private - Encoding for is not expression. \"\r\n\r\n\tself expr: expr1 op: #in with: expr2","function(self,expr1,expr2)\r\n(self):expr_op_with_(expr1,\"in\",expr2);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"typeofOPs",0
,function(self)
return (smalltalk:newArray({"type(", ")"}));
end
,"asm-constants","typeofOPs\r\n\t\" Private - Return the OP for typeOf expression. \"\r\n\r\n\t^#('type(' $)) ","function(self)\r\nreturn (smalltalk:newArray({\"type(\", \")\"}));\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"typeofArg:",0
,function(self,token)
return (token);
end
,"asm-constants","typeofArg: token\r\n\t\" Private - Return the OP for typeOf argument. \"\r\n\r\n\t^token ","function(self,token)\r\nreturn (token);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"lambda:expr:",0
,function(self,arg,expression)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("lambda");
	return ((_s8_rec):space())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(arg);
	return ((_s8_rec):space())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(":");
	return ((_s8_rec):space())
end
)(self);
(self):nextPutAll_(expression);
return (self);
end
,"asm","lambda: arg expr: expression\r\n\t\" Private - Encoding for lambda expression. \"\r\n\r\n\tself nextPutAll: #lambda; space.\r\n\tself nextPutAll: arg; space.\r\n\tself nextPutAll: $:;space.\r\n\tself nextPutAll: expression","function(self,arg,expression)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"lambda\");\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(arg);\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\":\");\r\n\treturn ((_s8_rec):space())\r\nend\r\n)(self);\r\n(self):nextPutAll_(expression);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"pointerTo:",0
,function(self,expression)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("*");
	return ((_s8_rec):nextPutAll_(expression))
end
)(self);
return (self);
end
,"asm","pointerTo: expression\r\n\t\" Private - Encoding for pointer to expression. \"\r\n\r\n\tself nextPutAll: $*; nextPutAll: expression ","function(self,expression)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"*\");\r\n\treturn ((_s8_rec):nextPutAll_(expression))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"__b__OBSOLETEStSystemDictionary",0
,function(self)
(self):call_withArguments_("exec",(smalltalk.Array):with_with_with_("\"def __b__\"+source",(function()
return ((self):call_("globals"))
end),"locals"));
(self):call_withArguments_("setattr",smalltalk:newArray({"locals[\"__b__\"]", "\"$nativeSource\"", "source"}));
(self):return_("locals[\"__b__\"]");
return (self);
end
,"api","__b__OBSOLETEStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself call: #exec withArguments: (Array\r\n\t\twith: '\"def __b__\"+source'\r\n\t\twith: [self call: #globals]\r\n\t\twith: #locals).\r\n\tself call: #setattr withArguments: #(\r\n\t\t'locals[\"__b__\"]'\r\n\t\t'\"$nativeSource\"'\r\n\t\tsource).\r\n\tself return: 'locals[\"__b__\"]' ","function(self)\r\n(self):call_withArguments_(\"exec\",(smalltalk.Array):with_with_with_(\"\\\"def __b__\\\"+source\",(function()\r\nreturn ((self):call_(\"globals\"))\r\nend),\"locals\"));\r\n(self):call_withArguments_(\"setattr\",smalltalk:newArray({\"locals[\\\"__b__\\\"]\", \"\\\"$nativeSource\\\"\", \"source\"}));\r\n(self):return_(\"locals[\\\"__b__\\\"]\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"__f__StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):send_with_("is_Nil","tag"))
end),(function()
return ((self):assign_to_("fName","\"__f__\""))
end),(function()
return ((self):assign_to_("fName","tag"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("print(\"def \"+fName,source)");
(
function(_s8_rec)
	(_s8_rec):assign_to_("locals",(function()
return ((self):call_("dict"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):try_except_as_doing_((function()
return ((self):call_withArguments_("exec",(smalltalk.Array):with_with_with_((function()
return ((self):sum_(smalltalk:newArray({"\"def \"", "fName", "source"})))
end),(function()
return ((self):call_("globals"))
end),"locals")))
end),"Exception","ex",(function()
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("print",(smalltalk.Array):with_with_((function()
return ((self):sum_(smalltalk:newArray({"\"def \"", "fName"})))
end),"source"));
	return ((_s8_rec):cr())
end
)(self);return ((self):call_with_("print","ex"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("delim",smalltalk:object_comma_((smalltalk:object_comma_(("'"),"\"\"\"")),"'"));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):is_in_("delim","source"))
end),(function()
return ((self):assign_to_("delim",smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("\""),"'")),"'")),"'")),"\"")))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("source",(function()
return ((self):send_to_withArguments_("replace","source",smalltalk:newArray({"\"\\\\\"", "\"\\\\\\\\\""})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("nativeSource",(function()
return ((self):sum_(smalltalk:object_comma_((smalltalk:newArray({"\"smalltalk.__f__(\"", "delim", "source", "delim"})),(smalltalk.Array):with_with_with_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("'"),",")),"\"")),"'"),(function()
return ((self):call_with_("str","tag"))
end),smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("'"),"\"")),")")),"'")))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"locals[fName]", "\"$nativeSource\"", "nativeSource"}));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("locals[fName]");
return (self);
end
,"api","__f__StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self send: #is_Nil with: #tag]\r\n\t\tdo: [ self assign: #fName to: '\"__f__\"' ]\r\n\t\telse: [ self assign: #fName to: #tag ];cr.\r\n\tself comment: 'print(\"def \"+fName,source)'.\r\n\tself assign: #locals to: [self call: #dict];cr.\r\n\tself try: [\r\n\t\tself call: #exec withArguments: (Array\r\n\t\t\twith: [self sum: #('\"def \"' fName source)]\r\n\t\t\twith: [self call: #globals]\r\n\t\t\twith: #locals)\r\n\t] except: #Exception as: #ex doing: [\r\n\t\tself call: #print withArguments: (Array with: [self sum: #('\"def \"' fName)] with: #source);cr.\r\n\t\tself call: #print with: #ex\r\n\t];cr.\r\n\tself assign: #delim to: $' ,'\"\"\"' ,$';cr.\r\n\tself if: [self is: #delim in: #source] do: [\r\n\t\tself assign: #delim to: $\" ,$' ,$' ,$' ,$\"\r\n\t];cr.\r\n\tself assign: #source to: [self send: #replace to: #source withArguments: #('\"\\\\\"' '\"\\\\\\\\\"')];cr.\r\n\tself assign: #nativeSource to: [self\r\n\t\tsum: #(\t'\"smalltalk.__f__(\"'\r\n\t\t\tdelim source delim\r\n\t\t\t),(Array with: $' ,$, ,$\" ,$'\r\n\t\t\twith: [self call: #str with: #tag]\r\n\t\t\twith: $' ,$\" ,$) ,$')\r\n\t];cr.\r\n\tself call: #setattr withArguments: #('locals[fName]' '\"$nativeSource\"' nativeSource);cr.\r\n\tself return: 'locals[fName]' ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"tag\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"fName\",\"\\\"__f__\\\"\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"fName\",\"tag\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"print(\\\"def \\\"+fName,source)\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"locals\",(function()\r\nreturn ((self):call_(\"dict\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):try_except_as_doing_((function()\r\nreturn ((self):call_withArguments_(\"exec\",(smalltalk.Array):with_with_with_((function()\r\nreturn ((self):sum_(smalltalk:newArray({\"\\\"def \\\"\", \"fName\", \"source\"})))\r\nend),(function()\r\nreturn ((self):call_(\"globals\"))\r\nend),\"locals\")))\r\nend),\"Exception\",\"ex\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"print\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):sum_(smalltalk:newArray({\"\\\"def \\\"\", \"fName\"})))\r\nend),\"source\"));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):call_with_(\"print\",\"ex\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"delim\",smalltalk:object_comma_((smalltalk:object_comma_((\"'\"),\"\\\"\\\"\\\"\")),\"'\"));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):is_in_(\"delim\",\"source\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"delim\",smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),\"'\")),\"'\")),\"'\")),\"\\\"\")))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"source\",(function()\r\nreturn ((self):send_to_withArguments_(\"replace\",\"source\",smalltalk:newArray({\"\\\"\\\\\\\\\\\"\", \"\\\"\\\\\\\\\\\\\\\\\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"nativeSource\",(function()\r\nreturn ((self):sum_(smalltalk:object_comma_((smalltalk:newArray({\"\\\"smalltalk.__f__(\\\"\", \"delim\", \"source\", \"delim\"})),(smalltalk.Array):with_with_with_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"'\"),\",\")),\"\\\"\")),\"'\"),(function()\r\nreturn ((self):call_with_(\"str\",\"tag\"))\r\nend),smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"'\"),\"\\\"\")),\")\")),\"'\")))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"locals[fName]\", \"\\\"$nativeSource\\\"\", \"nativeSource\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"locals[fName]\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"__get__SuperForClass",0
,function(self)
(self):if_do_else_((function()
return ((self):expr_and_((function()
return ((self):expr_is_("self.__obj__","None"))
end),(function()
return ((self):expr_isNot_("obj","None"))
end)))
end),(function()
return ((self):return_((function()
return ((self):call_withArguments_("super",smalltalk:newArray({"self.__type__", "obj"})))
end)))
end),(function()
return ((self):return_("self"))
end));
return (self);
end
,"api","__get__SuperForClass\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself \tif: [self expr: [self expr: 'self.__obj__' is: #None]\r\n\t\t\tand: [self expr: #obj isNot: #None]]\r\n\t\tdo: [self return: [self call: #super withArguments: #('self.__type__' obj)]]\r\n\t\telse: [self return: #self] ","function(self)\r\n(self):if_do_else_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):expr_is_(\"self.__obj__\",\"None\"))\r\nend),(function()\r\nreturn ((self):expr_isNot_(\"obj\",\"None\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):call_withArguments_(\"super\",smalltalk:newArray({\"self.__type__\", \"obj\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):return_(\"self\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"lookup_in_StMetaType",0
,function(self)
(self):comment_("print(\"[look]\",selector,aClass,\"meta=\",getattr(self,\"$meta\",\"missing\"))");
(self):try_except_as_doing_((function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self", "selector"})))
end));
	return ((_s8_rec):cr())
end
)(self);(self):comment_("print(\"[look]local\",selector,result)");(self):if_return_((function()
return ((self):call_with_("callable","result"))
end),(function()
return ((self):send_to_with_("__get__","result.__func__","aClass"))
end));return ((self):return_("result"))
end),"AttributeError","ex",(function()
(self):comment_("print(\"[look]missing@\",item ,\"ex=\",ex.args)");return ((self):return_("None"))
end));
return (self);
end
,"api","lookup_in_StMetaType\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'print(\"[look]\",selector,aClass,\"meta=\",getattr(self,\"$meta\",\"missing\"))'.\r\n\tself try: [\r\n\t\tself assign: #result to: [self call: #getattr withArguments: #(self selector)];cr.\r\n\t\tself comment: 'print(\"[look]local\",selector,result)'.\r\n\t\tself\tif: [self call: #callable with: #result]\r\n\t\t\treturn: [self send: #__get__ to: 'result.__func__' with: #aClass ].\r\n\t\tself return: #result\r\n\t] except: #AttributeError as: #ex doing: [\r\n\t\tself comment: 'print(\"[look]missing@\",item ,\"ex=\",ex.args)'.\r\n\t\tself return: #None\r\n\t]","function(self)\r\n(self):comment_(\"print(\\\"[look]\\\",selector,aClass,\\\"meta=\\\",getattr(self,\\\"$meta\\\",\\\"missing\\\"))\");\r\n(self):try_except_as_doing_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self\", \"selector\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"print(\\\"[look]local\\\",selector,result)\");(self):if_return_((function()\r\nreturn ((self):call_with_(\"callable\",\"result\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"__get__\",\"result.__func__\",\"aClass\"))\r\nend));return ((self):return_(\"result\"))\r\nend),\"AttributeError\",\"ex\",(function()\r\n(self):comment_(\"print(\\\"[look]missing@\\\",item ,\\\"ex=\\\",ex.args)\");return ((self):return_(\"None\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"__getattr__SuperForClass",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):try_except_as_doing_((function()
return ((self):return_((function()
return ((self):call_withArguments_("getattr",(smalltalk.Array):with_with_((function()
return ((self):call_withArguments_("super",smalltalk:newArray({"self.__type__", "self.__obj__"})))
end),"attr")))
end)))
end),"AttributeError","ex",(function()
(self):comment_("print(\"[SuperForClass]missing@\",attr ,\"ex=\",ex.args)");return ((self):pass())
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"smalltalk.Class", "attr"})))
end),(function()
(self):comment_("print(\"[SuperForClass]found as Class@\",attr)");(
function(_s8_rec)
	(_s8_rec):assign_to_("theAttr",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"smalltalk.Class", "attr"})))
end));
	return ((_s8_rec):cr())
end
)(self);(self):comment_("print(\"[SuperForClass] got \",theAttr,\" binding to \",self.__obj__)");return ((self):return_((function()
return ((self):send_to_with_("__get__","theAttr.__func__","self.__obj__"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):raise_((function()
return ((self):call_with_("AttributeError",(function()
return ((self):format_withArguments_("\"%s has no attribute %s.\"",smalltalk:newArray({"self.__type__", "attr"})))
end)))
end));
return (self);
end
,"api","__getattr__SuperForClass\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself try: [\r\n\t\tself return: [self call: #getattr withArguments: (Array\r\n\t\t\twith: [self call: #super withArguments: #('self.__type__' 'self.__obj__')]\r\n\t\t\twith: #attr)]\r\n\t] except: #AttributeError as: #ex doing: [\r\n\t\tself comment: 'print(\"[SuperForClass]missing@\",attr ,\"ex=\",ex.args)'.\r\n\t\tself pass\r\n\t];cr.\r\n\tself if: [self call: #hasattr withArguments: #('smalltalk.Class' attr)] do: [\r\n\t\tself comment: 'print(\"[SuperForClass]found as Class@\",attr)'.\r\n\t\tself assign: #theAttr to: [self call: #getattr withArguments: #('smalltalk.Class' attr)];cr.\r\n\t\tself comment: 'print(\"[SuperForClass] got \",theAttr,\" binding to \",self.__obj__)'.\r\n\t\tself return: [self send: #__get__ to: 'theAttr.__func__' with: 'self.__obj__']\r\n\t];cr.\r\n\tself raise: [self call: #AttributeError with: [\r\n\t\tself format: '\"%s has no attribute %s.\"'\r\n\t\t\twithArguments: #('self.__type__' attr)]\r\n\t] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):try_except_as_doing_((function()\r\nreturn ((self):return_((function()\r\nreturn ((self):call_withArguments_(\"getattr\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):call_withArguments_(\"super\",smalltalk:newArray({\"self.__type__\", \"self.__obj__\"})))\r\nend),\"attr\")))\r\nend)))\r\nend),\"AttributeError\",\"ex\",(function()\r\n(self):comment_(\"print(\\\"[SuperForClass]missing@\\\",attr ,\\\"ex=\\\",ex.args)\");return ((self):pass())\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"smalltalk.Class\", \"attr\"})))\r\nend),(function()\r\n(self):comment_(\"print(\\\"[SuperForClass]found as Class@\\\",attr)\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"theAttr\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"smalltalk.Class\", \"attr\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"print(\\\"[SuperForClass] got \\\",theAttr,\\\" binding to \\\",self.__obj__)\");return ((self):return_((function()\r\nreturn ((self):send_to_with_(\"__get__\",\"theAttr.__func__\",\"self.__obj__\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):raise_((function()\r\nreturn ((self):call_with_(\"AttributeError\",(function()\r\nreturn ((self):format_withArguments_(\"\\\"%s has no attribute %s.\\\"\",smalltalk:newArray({\"self.__type__\", \"attr\"})))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"__getattribute__StMetaType",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_or_((function()
return ((self):expr_or_((function()
return ((self):expr_eqeq_("item[0:2]","\"__\""))
end),(function()
return ((self):expr_eqeq_("item[0]","\"$\""))
end)))
end),(function()
return ((self):expr_eqeq_("item[0]","\"@\""))
end)))
end),(function()
(self):if_return_((function()
return ((self):expr_eqeq_("item","\"__class__\""))
end),"smalltalk.Metaclass");return ((self):return_((function()
return ((self):send_to_with_("__getattribute__",(function()
return ((self):call_("super"))
end),"item"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("print(\"[meta]\"+str(self)+\"@\"+item,\"meta=\",getattr(self,\"$meta\",\"missing\"))");
(
function(_s8_rec)
	(_s8_rec):try_except_as_doing_((function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):send_to_with_("__getattribute__",(function()
return ((self):call_("super"))
end),"item"))
end));
	return ((_s8_rec):cr())
end
)(self);(self):comment_("print(\"[meta]super\",item)");return ((self):return_((function()
return ((self):send_to_with_("__get__","result","self"))
end)))
end),"AttributeError","ex",(function()
(self):comment_("print(\"[meta]@\",item ,\"missing ex=\",ex.args)");return ((self):assign_to_("result","None"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("parent","\"Metaclass\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("delegate",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"smalltalk", "parent", "None"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("delegate",(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("delegate",(function()
return ((self):call_with_("delegate","None"))
end));
	return ((_s8_rec):cr())
end
)(self);(self):comment_("print(\"[meta]as\"+parent)");(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"delegate", "item", "None"})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):call_with_("callable","result"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("result","result.__func__");
	return ((_s8_rec):cr())
end
)(self);(self):comment_("print(\"[meta]found(\"+parent+\"@\"+item+\") src=\",result.__method__.src())");(self):comment_("print(\"[meta]calling \",result.__get__(self))");return ((self):return_((function()
return ((self):send_to_with_("__get__","result","self"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("parent","\"Class\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("delegate",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"smalltalk", "parent", "None"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("delegate",(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("delegate",(function()
return ((self):call_with_("delegate","None"))
end));
	return ((_s8_rec):cr())
end
)(self);(self):comment_("print(\"[meta]as\"+parent)");(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"delegate", "item", "None"})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):call_with_("callable","result"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("result","result.__func__");
	return ((_s8_rec):cr())
end
)(self);(self):comment_("print(\"[meta]found(\"+parent+\"@\"+item+\") src=\",result.__method__.src())");(self):comment_("print(\"[meta]calling \",result.__get__(self))");return ((self):return_((function()
return ((self):send_to_with_("__get__","result","self"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):raise_((function()
return ((self):call_with_("AttributeError",(function()
return ((self):format_withArguments_("\"%s has no attribute %s.\"",smalltalk:newArray({"self.__name__", "item"})))
end)))
end));
return (self);
end
,"api","__getattribute__StMetaType\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: [self expr:\r\n\t\t[self expr: 'item[0:2]' eqeq: '\"__\"']\r\n\t\tor: [self expr: 'item[0]' eqeq: '\"$\"']]\r\n\t\tor: [self expr: 'item[0]' eqeq: '\"@\"']]\r\n\tdo: [\r\n\t\tself if: [self expr: #item eqeq: '\"__class__\"'] return: 'smalltalk.Metaclass'.\r\n\t\tself return: [self send: #__getattribute__ to: [self call: #super] with: #item]\r\n\t];cr.\r\n\r\n\tself comment: 'print(\"[meta]\"+str(self)+\"@\"+item,\"meta=\",getattr(self,\"$meta\",\"missing\"))'.\r\n\tself try: [\r\n\t\tself assign: #result to: [self send: #__getattribute__ to: [self call: #super] with: #item];cr.\r\n\t\tself comment: 'print(\"[meta]super\",item)'.\r\n\t\tself return: [self send: #__get__ to: #result with: #self ]\r\n\t] except: #AttributeError as: #ex doing: [\r\n\t\tself comment: 'print(\"[meta]@\",item ,\"missing ex=\",ex.args)'.\r\n\t\tself assign: #result to: #None\r\n\t];cr.\r\n\r\n\tself assign: #parent to: '\"Metaclass\"';cr.\r\n\tself assign: #delegate to: [self call: #getattr withArguments: #(smalltalk parent None)];cr.\r\n\tself if: #delegate do: [\r\n\t\tself assign: #delegate to: [self call: #delegate with: #None];cr.\r\n\t\tself comment: 'print(\"[meta]as\"+parent)'.\r\n\t\tself assign: #result to: [self call: #getattr withArguments: #(delegate item None)];cr.\r\n\t\tself if: [self call: #callable with: #result] do: [\r\n\t\t\tself assign: #result to: 'result.__func__';cr.\r\n\t\t\tself comment: 'print(\"[meta]found(\"+parent+\"@\"+item+\") src=\",result.__method__.src())'.\r\n\t\t\tself comment: 'print(\"[meta]calling \",result.__get__(self))'.\r\n\t\t\tself return: [self send: #__get__ to: #result with: #self]\r\n\t\t]\r\n\t];cr.\r\n\r\n\tself assign: #parent to: '\"Class\"';cr.\r\n\tself assign: #delegate to: [self call: #getattr withArguments: #(smalltalk parent None)];cr.\r\n\tself if: #delegate do: [\r\n\t\tself assign: #delegate to: [self call: #delegate with: #None];cr.\r\n\t\tself comment: 'print(\"[meta]as\"+parent)'.\r\n\t\tself assign: #result to: [self call: #getattr withArguments: #(delegate item None)];cr.\r\n\t\tself if: [self call: #callable with: #result] do: [\r\n\t\t\tself assign: #result to: 'result.__func__';cr.\r\n\t\t\tself comment: 'print(\"[meta]found(\"+parent+\"@\"+item+\") src=\",result.__method__.src())'.\r\n\t\t\tself comment: 'print(\"[meta]calling \",result.__get__(self))'.\r\n\t\t\tself return: [self send: #__get__ to: #result with: #self]\r\n\t\t]\r\n\t];cr.\r\n\tself raise: [self call: #AttributeError with: [\r\n\t\tself format: '\"%s has no attribute %s.\"'\r\n\t\t\twithArguments: #('self.__name__' item)\r\n\t]]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_eqeq_(\"item[0:2]\",\"\\\"__\\\"\"))\r\nend),(function()\r\nreturn ((self):expr_eqeq_(\"item[0]\",\"\\\"$\\\"\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):expr_eqeq_(\"item[0]\",\"\\\"@\\\"\"))\r\nend)))\r\nend),(function()\r\n(self):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"item\",\"\\\"__class__\\\"\"))\r\nend),\"smalltalk.Metaclass\");return ((self):return_((function()\r\nreturn ((self):send_to_with_(\"__getattribute__\",(function()\r\nreturn ((self):call_(\"super\"))\r\nend),\"item\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"print(\\\"[meta]\\\"+str(self)+\\\"@\\\"+item,\\\"meta=\\\",getattr(self,\\\"$meta\\\",\\\"missing\\\"))\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):try_except_as_doing_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):send_to_with_(\"__getattribute__\",(function()\r\nreturn ((self):call_(\"super\"))\r\nend),\"item\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"print(\\\"[meta]super\\\",item)\");return ((self):return_((function()\r\nreturn ((self):send_to_with_(\"__get__\",\"result\",\"self\"))\r\nend)))\r\nend),\"AttributeError\",\"ex\",(function()\r\n(self):comment_(\"print(\\\"[meta]@\\\",item ,\\\"missing ex=\\\",ex.args)\");return ((self):assign_to_(\"result\",\"None\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"parent\",\"\\\"Metaclass\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"delegate\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"smalltalk\", \"parent\", \"None\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"delegate\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"delegate\",(function()\r\nreturn ((self):call_with_(\"delegate\",\"None\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"print(\\\"[meta]as\\\"+parent)\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"delegate\", \"item\", \"None\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):call_with_(\"callable\",\"result\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",\"result.__func__\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"print(\\\"[meta]found(\\\"+parent+\\\"@\\\"+item+\\\") src=\\\",result.__method__.src())\");(self):comment_(\"print(\\\"[meta]calling \\\",result.__get__(self))\");return ((self):return_((function()\r\nreturn ((self):send_to_with_(\"__get__\",\"result\",\"self\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"parent\",\"\\\"Class\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"delegate\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"smalltalk\", \"parent\", \"None\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"delegate\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"delegate\",(function()\r\nreturn ((self):call_with_(\"delegate\",\"None\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"print(\\\"[meta]as\\\"+parent)\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"delegate\", \"item\", \"None\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):call_with_(\"callable\",\"result\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",\"result.__func__\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"print(\\\"[meta]found(\\\"+parent+\\\"@\\\"+item+\\\") src=\\\",result.__method__.src())\");(self):comment_(\"print(\\\"[meta]calling \\\",result.__get__(self))\");return ((self):return_((function()\r\nreturn ((self):send_to_with_(\"__get__\",\"result\",\"self\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):raise_((function()\r\nreturn ((self):call_with_(\"AttributeError\",(function()\r\nreturn ((self):format_withArguments_(\"\\\"%s has no attribute %s.\\\"\",smalltalk:newArray({\"self.__name__\", \"item\"})))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"__init__StObject",0
,function(self)
(self):if_do_((function()
return ((self):send_to_with_("not_Nil","smalltalk","aHandle"))
end),(function()
return ((self):call_withArguments_("setattr",smalltalk:newArray({"self", "\"@handle\"", "aHandle"})))
end));
return (self);
end
,"api","__init__StObject\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself\tif: [self send: #not_Nil to: #smalltalk with: #aHandle]\r\n\t\tdo: [self call: #setattr withArguments: #(self '\"@handle\"' aHandle)] ","function(self)\r\n(self):if_do_((function()\r\nreturn ((self):send_to_with_(\"not_Nil\",\"smalltalk\",\"aHandle\"))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"setattr\",smalltalk:newArray({\"self\", \"\\\"@handle\\\"\", \"aHandle\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"__init__StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"self", "\"$nativeLanguage\"", "\"py\""}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_property_to_("self","useManager","False");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("state:","\"__init__\"");
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("self.st = self #OBSOLETE");
return (self);
end
,"api","__init__StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself call: #setattr withArguments: #(self '\"$nativeLanguage\"' '\"py\"');cr.\r\n\tself assign: #self property: #useManager to: #False;cr.\r\n\tself send: #state: with: '\"__init__\"';cr.\r\n\tself comment: 'self.st = self #OBSOLETE' ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"self\", \"\\\"$nativeLanguage\\\"\", \"\\\"py\\\"\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_property_to_(\"self\",\"useManager\",\"False\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"state:\",\"\\\"__init__\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"self.st = self #OBSOLETE\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"__init__SuperForClass",0
,function(self)
(self):comment_("print(\"SuperForClass[init] type=\",type,\"obj=\",obj)");
(
function(_s8_rec)
	(_s8_rec):assign_property_to_("self","__type__","type");
	return ((_s8_rec):cr())
end
)(self);
(self):assign_property_to_("self","__obj__","obj");
return (self);
end
,"api","__init__SuperForClass\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'print(\"SuperForClass[init] type=\",type,\"obj=\",obj)'.\r\n\tself assign: #self property: #__type__ to: #type;cr.\r\n\tself assign: #self property: #__obj__ to: #obj ","function(self)\r\n(self):comment_(\"print(\\\"SuperForClass[init] type=\\\",type,\\\"obj=\\\",obj)\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_property_to_(\"self\",\"__type__\",\"type\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):assign_property_to_(\"self\",\"__obj__\",\"obj\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"__repr__StObject",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("h",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self", "\"@handle\"", "None"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):send_to_with_("is_Nil","smalltalk","h"))
end),(function()
return ((self):send_to_("__repr__",(function()
return ((self):call_("super"))
end)))
end));
(self):return_((function()
return ((self):expr_plus_plus_("\"smalltalk.\"",(function()
return ((self):send_to_with_("handleOf","smalltalk",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self.__class__", "\"$className\"", "\"???\""})))
end)))
end),(function()
return ((self):sum_((smalltalk.Array):with_with_with_("\"(\"",(function()
return ((self):call_with_("repr","h"))
end),"\")\"")))
end)))
end));
return (self);
end
,"api","__repr__StObject\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #h to: [self call: #getattr withArguments: #(self '\"@handle\"' None)];cr.\r\n\tself if: [self send: #is_Nil to: #smalltalk with: #h] return: [\r\n\t\tself send: #__repr__ to: [self call: #super]\r\n\t].\r\n\tself return: [self expr: '\"smalltalk.\"'\r\n\t\tplus: [self send: #handleOf to: #smalltalk with: [\r\n\t\t\tself call: #getattr withArguments: #('self.__class__' '\"$className\"' '\"???\"')\r\n\t\t]] plus: [self sum: (Array with: '\"(\"'\r\n\t\t\twith: [self call: #repr with: #h]\r\n\t\t\twith: '\")\"' )]\r\n\t\t] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self\", \"\\\"@handle\\\"\", \"None\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):send_to_with_(\"is_Nil\",\"smalltalk\",\"h\"))\r\nend),(function()\r\nreturn ((self):send_to_(\"__repr__\",(function()\r\nreturn ((self):call_(\"super\"))\r\nend)))\r\nend));\r\n(self):return_((function()\r\nreturn ((self):expr_plus_plus_(\"\\\"smalltalk.\\\"\",(function()\r\nreturn ((self):send_to_with_(\"handleOf\",\"smalltalk\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self.__class__\", \"\\\"$className\\\"\", \"\\\"???\\\"\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):sum_((smalltalk.Array):with_with_with_(\"\\\"(\\\"\",(function()\r\nreturn ((self):call_with_(\"repr\",\"h\"))\r\nend),\"\\\")\\\"\")))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"__setitem__StSystemDictionary",0
,function(self)
(self):call_withArguments_("setattr",smalltalk:newArray({"self", "item", "value"}));
return (self);
end
,"api","__setitem__StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself call: #setattr withArguments: #(self item value)","function(self)\r\n(self):call_withArguments_(\"setattr\",smalltalk:newArray({\"self\", \"item\", \"value\"}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"__str__StObject",0
,function(self)
(self):if_do_((function()
return ((self):expr_is_("self","nil"))
end),(function()
return ((self):return_("\"nil\""))
end));
(
function(_s8_rec)
	(_s8_rec):assign_to_("h",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self", "\"@handle\"", "None"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):expr_or_((function()
return ((self):typeOf_is_("h","str"))
end),(function()
return ((self):send_to_with_("is_Number","smalltalk","h"))
end)))
end),(function()
return ((self):call_with_("str","h"))
end));
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):typeOf_is_("h","bool"))
end),(function()
(self):if_return_((function()
return ((self):expr_eqeq_("h","True"))
end),"\"true\"");return ((self):return_("\"false\""))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_("__str__",(function()
return ((self):call_("super"))
end)))
end));
return (self);
end
,"api","__str__StObject\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: #self is: #nil] do: [self return: '\"nil\"'].\r\n\tself assign: #h to: [self call: #getattr withArguments: #(self '\"@handle\"' None)];cr.\r\n\tself if: [self expr: [self typeOf: #h is: #str]\r\n\t\t or: [self send: #is_Number to: #smalltalk with: #h]]\r\n\t\treturn: [self call: #str with: #h ].\r\n\tself if: [self typeOf: #h is: #bool] do: [\r\n\t\tself if: [self expr: #h eqeq: #True] return: '\"true\"'.\r\n\t\tself return: '\"false\"'\r\n\t];cr.\r\n\tself return: [self send: #__str__ to: [self call: #super]]","function(self)\r\n(self):if_do_((function()\r\nreturn ((self):expr_is_(\"self\",\"nil\"))\r\nend),(function()\r\nreturn ((self):return_(\"\\\"nil\\\"\"))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self\", \"\\\"@handle\\\"\", \"None\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):typeOf_is_(\"h\",\"str\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"is_Number\",\"smalltalk\",\"h\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):call_with_(\"str\",\"h\"))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):typeOf_is_(\"h\",\"bool\"))\r\nend),(function()\r\n(self):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"h\",\"True\"))\r\nend),\"\\\"true\\\"\");return ((self):return_(\"\\\"false\\\"\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_(\"__str__\",(function()\r\nreturn ((self):call_(\"super\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"aboutToBindToStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):lambda_expr_("sm",(function()
return ((self):send_to_withArguments_("aboutToBind:to:","sm",smalltalk:newArray({"method", "klass"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"api","aboutToBindToStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self lambda: #sm expr: [\r\n\t\tself send: #aboutToBind:to: to: #sm withArguments: #(method klass)\r\n\t]];cr.\r\n\tself return: #method ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):lambda_expr_(\"sm\",(function()\r\nreturn ((self):send_to_withArguments_(\"aboutToBind:to:\",\"sm\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"aboutToChangeClassStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):lambda_expr_("sm",(function()
return ((self):send_to_withArguments_("aboutToChange:superclass:iVarNames:category:","sm",smalltalk:newArray({"aClass", "superclass", "iVarNames", "category"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"api","aboutToChangeClassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self lambda: #sm expr: [\r\n\t\tself send: #aboutToChange:superclass:iVarNames:category: to: #sm\r\n\t\t\twithArguments: #(aClass superclass iVarNames category)\r\n\t]];cr ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):lambda_expr_(\"sm\",(function()\r\nreturn ((self):send_to_withArguments_(\"aboutToChange:superclass:iVarNames:category:\",\"sm\",smalltalk:newArray({\"aClass\", \"superclass\", \"iVarNames\", \"category\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"aboutToCreateClassStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):lambda_expr_("sm",(function()
return ((self):send_to_withArguments_("aboutToCreateClass:superclass:iVarNames:category:","sm",smalltalk:newArray({"className", "superclass", "iVarNames", "category"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"api","aboutToCreateClassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self lambda: #sm expr: [\r\n\t\tself send: #aboutToCreateClass:superclass:iVarNames:category: to: #sm\r\n\t\t\twithArguments: #(className superclass iVarNames category)\r\n\t]];cr ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):lambda_expr_(\"sm\",(function()\r\nreturn ((self):send_to_withArguments_(\"aboutToCreateClass:superclass:iVarNames:category:\",\"sm\",smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"aboutToRemoveFromStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):lambda_expr_("sm",(function()
return ((self):send_to_withArguments_("aboutToRemove:from:","sm",smalltalk:newArray({"method", "klass"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"api","aboutToRemoveFromStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self lambda: #sm expr: [\r\n\t\tself send: #aboutToRemove:from: to: #sm withArguments: #(method klass)\r\n\t]];cr.\r\n\tself return: #method ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):lambda_expr_(\"sm\",(function()\r\nreturn ((self):send_to_withArguments_(\"aboutToRemove:from:\",\"sm\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"addClassStSystemDictionary",0
,function(self)
(self):comment_("Boot - Register a Class onto the system");
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("debugAddClass",smalltalk:newArray({"className", "superclass", "iVarNames", "category"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self", "className", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):send_with_("not_Nil","aClass"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("parent",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aClass", "\"$superclass\"", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):send_with_("is_Nil","parent"))
end),(function()
return ((self):assign_to_("parent","nil"))
end),(function()
(self):comment_("invalidate subclasses of parent");(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"parent", "\"@subclasses\"", "nil"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):call_withArguments_("setattr",smalltalk:newArray({"parent.__class__", "\"@subclasses\"", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("is_Nil","superclass"))
end),(function()
return ((self):assign_to_("superclass","nil"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("sameShape",(function()
return ((self):expr_and_((function()
return ((self):expr_eqeq_("superclass","parent"))
end),(function()
return ((self):send_withArguments_("isArray_equalTo",(smalltalk.Array):with_with_((function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aClass", "\"$iVarNames\"", "[]"})))
end),"iVarNames")))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_and_("sameShape",(function()
return ((self):expr_eqeq_("category",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aClass", "\"$category\"", "nil"})))
end)))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):send_with_("reshapeClass:","aClass");
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("aClass"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_withArguments_("aboutToChangeClass",smalltalk:newArray({"aClass", "superclass", "iVarNames", "category"}));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):expr_is_("parent","superclass"))
end)))
end),(function()
(self):comment_("move in hierarchy");(self):comment_("link to new parent");(self):call_withArguments_("setattr",smalltalk:newArray({"aClass", "\"$superclass\"", "superclass"}));(self):comment_("do we need to move in native hierarchy?");(
function(_s8_rec)
	(_s8_rec):assign_to_("aMeta","aClass.__class__");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_and_("aMeta","superclass"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("msuper",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aMeta", "\"$superclass\""})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"msuper", "\"@subclasses\"", "nil"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):call_withArguments_("setattr",smalltalk:newArray({"aMeta", "\"$superclass\"", "superclass.__class__"})))
end));
	return ((_s8_rec):cr())
end
)(self);(self):comment_("invalidate subclasses of superclass");(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"superclass", "\"@subclasses\"", "nil"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):call_withArguments_("setattr",smalltalk:newArray({"superclass.__class__", "\"@subclasses\"", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",(smalltalk.Array):with_with_with_("aClass","\"$category\"",(function()
return ((self):expr_or_("category",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aClass", "\"$category\"", "\"\""})))
end)))
end)));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setVarNames",smalltalk:newArray({"aClass", "iVarNames", "nil"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):not_("sameShape"))
end),(function()
return ((self):send_with_("classShapeChanged","aClass"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("aboutToCreateClass",smalltalk:newArray({"className", "superclass", "iVarNames", "category"}));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"className", "category", "nil", "superclass"}));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("aClass",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self", "className"})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setVarNames",smalltalk:newArray({"aClass", "iVarNames", "nil"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):send_with_("not_Nil","superclass"))
end),(function()
(self):comment_("invalidate subclasses of superclass");(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"superclass", "\"@subclasses\"", "nil"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):call_withArguments_("setattr",smalltalk:newArray({"superclass.__class__", "\"@subclasses\"", "nil"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("classChanged","aClass");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("reshapeClass:","aClass");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("aClass");
return (self);
end
,"api","addClassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Boot - Register a Class onto the system'.\r\n\tself send: #debugAddClass withArguments: #(className superclass iVarNames category);cr.\r\n\tself assign: #aClass to: [self call: #getattr withArguments: #(self className #nil)];cr.\r\n\tself if: [self send: #not_Nil with: #aClass] do: [\r\n\t\tself assign: #parent to: [self call: #getattr withArguments: #(aClass '\"$superclass\"' #nil)];cr.\r\n\t\tself if: [self send: #is_Nil with: #parent] do: [\r\n\t\t\tself assign: #parent to: #nil\r\n\t\t] else: [\r\n\t\t\tself comment: 'invalidate subclasses of parent'.\r\n\t\t\tself call: #setattr withArguments: #(parent '\"@subclasses\"' #nil);cr.\r\n\t\t\tself call: #setattr withArguments: #('parent.__class__' '\"@subclasses\"' #nil)\r\n\t\t];cr.\r\n\t\tself  if: [self send: #is_Nil with: #superclass] do: [\r\n\t\t\tself assign: #superclass to: #nil\r\n\t\t];cr.\r\n\t\tself assign: #sameShape to: [self expr: \r\n\t\t\t[self expr: #superclass eqeq: #parent]\r\n\t\t\tand: [self send: #isArray_equalTo withArguments: (Array\r\n\t\t\t\twith: [self call: #getattr withArguments: #(aClass '\"$iVarNames\"' '[]')]\r\n\t\t\t\twith: #iVarNames)]];cr.\r\n\t\tself if: [self expr: #sameShape and: [\r\n\t\t\tself expr: #category eqeq: [\r\n\t\t\t\tself call: #getattr withArguments: #(aClass '\"$category\"' #nil)]\r\n\t\t\t]] do: [\r\n\t\t\tself send: #reshapeClass: with: #aClass;cr.\r\n\t\t\tself return: #aClass\r\n\t\t];cr.\r\n\t\tself send: #aboutToChangeClass withArguments: #(aClass superclass iVarNames category);cr.\r\n\t\tself if: [self not: [self expr: #parent is: #superclass]] do: [\r\n\t\t\tself comment: 'move in hierarchy'.\r\n\t\t\tself comment: 'link to new parent'.\r\n\t\t\tself call: #setattr withArguments: #(aClass '\"$superclass\"' superclass).\r\n\t\t\tself comment: 'do we need to move in native hierarchy?'.\r\n\t\t\tself assign: #aMeta to: 'aClass.__class__';cr.\r\n\t\t\tself if: [self expr: #aMeta and: #superclass] do: [\r\n\t\t\t\tself assign: #msuper to: [self call: #getattr withArguments: #(aMeta '\"$superclass\"')];cr.\r\n\t\t\t\tself call: #setattr withArguments: #(msuper '\"@subclasses\"' #nil);cr.\r\n\t\t\t\tself call: #setattr withArguments: #(aMeta '\"$superclass\"' 'superclass.__class__')\r\n\t\t\t];cr.\r\n\t\t\tself comment: 'invalidate subclasses of superclass'.\r\n\t\t\tself call: #setattr withArguments: #(superclass '\"@subclasses\"' #nil);cr.\r\n\t\t\tself call: #setattr withArguments: #('superclass.__class__' '\"@subclasses\"' #nil)\r\n\t\t];cr.\r\n\t\tself call: #setattr withArguments: (Array with: #aClass with: '\"$category\"'\r\n\t\t\twith: [self expr: #category\r\n\t\t\t\tor: [self call: #getattr withArguments: #(aClass '\"$category\"' '\"\"')]]);cr.\r\n\t\tself send: #setVarNames withArguments: #(aClass iVarNames #nil);cr.\r\n\t\tself if: [self not: #sameShape] do: [ self send: #classShapeChanged with: #aClass]\r\n\t] else: [\r\n\t\tself send: #aboutToCreateClass withArguments: #(className superclass iVarNames category);cr.\r\n\t\tself send: #mapClassName withArguments: #(className category #nil superclass);cr.\r\n\t\tself assign: #aClass to: [self call: #getattr withArguments: #(self className)];cr.\r\n\t\tself send: #setVarNames withArguments: #(aClass iVarNames #nil);cr.\r\n\t\tself if: [self send: #not_Nil with: #superclass] do: [\r\n\t\t\tself comment: 'invalidate subclasses of superclass'.\r\n\t\t\tself call: #setattr withArguments: #(superclass '\"@subclasses\"' #nil);cr.\r\n\t\t\tself call: #setattr withArguments: #('superclass.__class__' '\"@subclasses\"' #nil)\r\n\t\t]\r\n\t];cr.\r\n\tself send: #classChanged with: #aClass;cr.\r\n\tself send: #reshapeClass: with: #aClass;cr.\r\n\tself return: #aClass ","function(self)\r\n(self):comment_(\"Boot - Register a Class onto the system\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"debugAddClass\",smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self\", \"className\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):send_with_(\"not_Nil\",\"aClass\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"parent\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aClass\", \"\\\"$superclass\\\"\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"parent\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"parent\",\"nil\"))\r\nend),(function()\r\n(self):comment_(\"invalidate subclasses of parent\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"parent\", \"\\\"@subclasses\\\"\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):call_withArguments_(\"setattr\",smalltalk:newArray({\"parent.__class__\", \"\\\"@subclasses\\\"\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"superclass\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"superclass\",\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"sameShape\",(function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):expr_eqeq_(\"superclass\",\"parent\"))\r\nend),(function()\r\nreturn ((self):send_withArguments_(\"isArray_equalTo\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aClass\", \"\\\"$iVarNames\\\"\", \"[]\"})))\r\nend),\"iVarNames\")))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_and_(\"sameShape\",(function()\r\nreturn ((self):expr_eqeq_(\"category\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aClass\", \"\\\"$category\\\"\", \"nil\"})))\r\nend)))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"reshapeClass:\",\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"aClass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"aboutToChangeClass\",smalltalk:newArray({\"aClass\", \"superclass\", \"iVarNames\", \"category\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):expr_is_(\"parent\",\"superclass\"))\r\nend)))\r\nend),(function()\r\n(self):comment_(\"move in hierarchy\");(self):comment_(\"link to new parent\");(self):call_withArguments_(\"setattr\",smalltalk:newArray({\"aClass\", \"\\\"$superclass\\\"\", \"superclass\"}));(self):comment_(\"do we need to move in native hierarchy?\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aMeta\",\"aClass.__class__\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_and_(\"aMeta\",\"superclass\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"msuper\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aMeta\", \"\\\"$superclass\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"msuper\", \"\\\"@subclasses\\\"\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):call_withArguments_(\"setattr\",smalltalk:newArray({\"aMeta\", \"\\\"$superclass\\\"\", \"superclass.__class__\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"invalidate subclasses of superclass\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"superclass\", \"\\\"@subclasses\\\"\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):call_withArguments_(\"setattr\",smalltalk:newArray({\"superclass.__class__\", \"\\\"@subclasses\\\"\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",(smalltalk.Array):with_with_with_(\"aClass\",\"\\\"$category\\\"\",(function()\r\nreturn ((self):expr_or_(\"category\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aClass\", \"\\\"$category\\\"\", \"\\\"\\\"\"})))\r\nend)))\r\nend)));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setVarNames\",smalltalk:newArray({\"aClass\", \"iVarNames\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):not_(\"sameShape\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"classShapeChanged\",\"aClass\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"aboutToCreateClass\",smalltalk:newArray({\"className\", \"superclass\", \"iVarNames\", \"category\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"className\", \"category\", \"nil\", \"superclass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aClass\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self\", \"className\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setVarNames\",smalltalk:newArray({\"aClass\", \"iVarNames\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):send_with_(\"not_Nil\",\"superclass\"))\r\nend),(function()\r\n(self):comment_(\"invalidate subclasses of superclass\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"superclass\", \"\\\"@subclasses\\\"\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):call_withArguments_(\"setattr\",smalltalk:newArray({\"superclass.__class__\", \"\\\"@subclasses\\\"\", \"nil\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"classChanged\",\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"reshapeClass:\",\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"aClass\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"addMethodStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("aboutToBindTo",smalltalk:newArray({"method", "klass"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("fn",(function()
return ((self):send_withArguments_("instVarAt",smalltalk:newArray({"method", "\"fn\""})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("setattr(fn,\"$s8-method\",method) # needed? for back refs to method");
(
function(_s8_rec)
	(_s8_rec):assign_to_("fn.__method__","method");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",(smalltalk.Array):with_with_with_("klass",(function()
return ((self):send_with_("handleOf","jsSelector"))
end),"fn"));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"method", "\"@classField\"", "klass"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"method", "\"$fn\"", "fn"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_or_((function()
return ((self):send_with_("is_Nil","stSelector"))
end),(function()
return ((self):not_("stSelector"))
end)))
end),(function()
return ((self):assign_to_("stSelector",(function()
return ((self):send_to_("asNativeSelector","jsSelector"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("register:method:in:",smalltalk:newArray({"stSelector", "method", "klass"}));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_withArguments_("methodBoundTo",smalltalk:newArray({"method", "klass"})))
end));
return (self);
end
,"api","addMethodStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #aboutToBindTo withArguments: #(method klass);cr.\r\n\tself assign: #fn to: [self send: #instVarAt withArguments: #(method '\"fn\"') ];cr.\r\n\tself comment: 'setattr(fn,\"$s8-method\",method) # needed? for back refs to method'.\r\n\tself assign: 'fn.__method__' to: #method;cr.\r\n\tself call: #setattr withArguments: (Array\r\n\t\twith: #klass\r\n\t\twith: [self send: #handleOf with: #jsSelector]\r\n\t\twith: #fn);cr.\r\n\tself call: #setattr withArguments: #(method '\"@classField\"' klass);cr.\r\n\tself call: #setattr withArguments: #(method '\"$fn\"' fn);cr.\r\n\tself if: [self expr: [self send: #is_Nil with: #stSelector] or: [self not: #stSelector]] do: [\r\n\t\tself assign: #stSelector to: [self send: #asNativeSelector to: #jsSelector]\r\n\t];cr.\r\n\tself send: #register:method:in: withArguments: #(stSelector method klass);cr.\r\n\tself return: [self send: #methodBoundTo withArguments: #(method klass)] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"aboutToBindTo\",smalltalk:newArray({\"method\", \"klass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"fn\",(function()\r\nreturn ((self):send_withArguments_(\"instVarAt\",smalltalk:newArray({\"method\", \"\\\"fn\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"setattr(fn,\\\"$s8-method\\\",method) # needed? for back refs to method\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"fn.__method__\",\"method\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",(smalltalk.Array):with_with_with_(\"klass\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"jsSelector\"))\r\nend),\"fn\"));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"method\", \"\\\"@classField\\\"\", \"klass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"method\", \"\\\"$fn\\\"\", \"fn\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"stSelector\"))\r\nend),(function()\r\nreturn ((self):not_(\"stSelector\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"stSelector\",(function()\r\nreturn ((self):send_to_(\"asNativeSelector\",\"jsSelector\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"register:method:in:\",smalltalk:newArray({\"stSelector\", \"method\", \"klass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"methodBoundTo\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"allSubclassesDoStSystemDictionary",0
,function(self)
(self):comment_("Boot - Evaluates aBlock with all the subclasses of aClass");
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_comment_("__blk1__",smalltalk:newArray({"cls"}),(function()
(
function(_s8_rec)
	(_s8_rec):call_with_("aBlock","cls");
	return ((_s8_rec):cr())
end
)(self);return ((self):send_withArguments_("allSubclassesDo",smalltalk:newArray({"cls", "aBlock"})))
end),nil);
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_to_with_("do:",(function()
return ((self):send_with_("subclasses","aClass"))
end),(function()
return ((self):send_withArguments_("blk",smalltalk:newArray({"__blk1__", "1"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("self");
return (self);
end
,"api","allSubclassesDoStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Boot - Evaluates aBlock with all the subclasses of aClass'.\r\n\tself implementFunction: #__blk1__ arguments: #(cls) doing: [\r\n\t\tself call: #aBlock with: #cls;cr.\r\n\t\tself send: #allSubclassesDo withArguments: #(cls aBlock)\r\n\t] comment: nil;cr.\r\n\tself send: #do:\r\n\t\tto: [self send: #subclasses with: #aClass]\r\n\t\twith: [self send: #blk withArguments: #(__blk1__ #1)];cr.\r\n\tself return: #self ","function(self)\r\n(self):comment_(\"Boot - Evaluates aBlock with all the subclasses of aClass\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_comment_(\"__blk1__\",smalltalk:newArray({\"cls\"}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"aBlock\",\"cls\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_withArguments_(\"allSubclassesDo\",smalltalk:newArray({\"cls\", \"aBlock\"})))\r\nend),nil);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_with_(\"do:\",(function()\r\nreturn ((self):send_with_(\"subclasses\",\"aClass\"))\r\nend),(function()\r\nreturn ((self):send_withArguments_(\"blk\",smalltalk:newArray({\"__blk1__\", \"1\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"argumentCount_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_to_("debug","smalltalk"))
end),(function()
return ((self):call_withArguments_("print",(smalltalk.Array):with_with_("\"@argumentCount - \"",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aCallable", "\"@argumentCount\"", "nil"})))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("count",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aCallable", "\"@argumentCount\"", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_is_("count","nil"))
end),(function()
return ((self):try_except_as_doing_((function()
(
function(_s8_rec)
	(_s8_rec):from_import_("inspect","signature");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("f",(function()
return ((self):send_with_("handleOf","aCallable"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("count",(function()
return ((self):call_with_("len",(function()
return ((self):property_of_("parameters",(function()
return ((self):call_with_("signature","f"))
end)))
end)))
end)))
end),"Exception","ex",(function()
return ((self):return_("nil"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_with_("self.Number","count"))
end));
return (self);
end
,"api","argumentCount_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self send: #debug to: #smalltalk] do: [\r\n\t\tself call: #print withArguments: (Array\r\n\t\t\twith: '\"@argumentCount - \"'\r\n\t\t\twith: [self call: #getattr\r\n\t\t\t\twithArguments: #(aCallable '\"@argumentCount\"' #nil)])\r\n\t];cr.\r\n\tself assign: #count to: [self call: #getattr\r\n\t\twithArguments: #(aCallable '\"@argumentCount\"' #nil)];cr.\r\n\tself if: [self expr: #count is: #nil] do: [\r\n\t\tself try: [\r\n\t\t\tself from: #inspect import: #signature;cr.\r\n\t\t\tself assign: #f to: [self send: #handleOf with: #aCallable];cr.\r\n\t\t\tself assign: #count to: [self call: #len with: [\r\n\t\t\t\tself property: #parameters of: [self call: #signature with: #f]\r\n\t\t\t]]\r\n\t\t] except: #Exception as: #ex doing: [\r\n\t\t\tself return: #nil\r\n\t\t]\r\n\t];cr.\r\n\tself return: [self call: 'self.Number' with: #count] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_to_(\"debug\",\"smalltalk\"))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"print\",(smalltalk.Array):with_with_(\"\\\"@argumentCount - \\\"\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aCallable\", \"\\\"@argumentCount\\\"\", \"nil\"})))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"count\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aCallable\", \"\\\"@argumentCount\\\"\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_is_(\"count\",\"nil\"))\r\nend),(function()\r\nreturn ((self):try_except_as_doing_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):from_import_(\"inspect\",\"signature\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"f\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"aCallable\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"count\",(function()\r\nreturn ((self):call_with_(\"len\",(function()\r\nreturn ((self):property_of_(\"parameters\",(function()\r\nreturn ((self):call_with_(\"signature\",\"f\"))\r\nend)))\r\nend)))\r\nend)))\r\nend),\"Exception\",\"ex\",(function()\r\nreturn ((self):return_(\"nil\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"self.Number\",\"count\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"arguments_toCall_StSystemDictionary",0
,function(self)
(self):comment_("Returns arguments adapted to call aBlock");
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_to_("debug","smalltalk"))
end),(function()
return ((self):call_withArguments_("print",smalltalk:newArray({"\"arguments_toCall_ - \"", "args"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("count",(function()
return ((self):send_with_("handleOf",(function()
return ((self):send_with_("argumentCount:","aBlock"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):send_with_("is_Nil","count"))
end),"args");
(self):if_return_((function()
return ((self):expr_eqeq_("count",(function()
return ((self):call_with_("len","args"))
end)))
end),"args");
(
function(_s8_rec)
	(_s8_rec):assign_to_("largs",(function()
return ((self):send_with_("arrayContents","list(args)[:count]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):while_do_((function()
return ((self):expr_lt_((function()
return ((self):call_with_("len","largs"))
end),"count"))
end),(function()
return ((self):send_to_with_("append","largs","nil"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_with_("tuple","largs"))
end));
return (self);
end
,"api","arguments_toCall_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Returns arguments adapted to call aBlock'.\r\n\tself if: [self send: #debug to: #smalltalk] do: [\r\n\t\tself call: #print withArguments: #('\"arguments_toCall_ - \"' args)\r\n\t];cr.\r\n\tself assign: #count to: [self send: #handleOf with: [\r\n\t\tself send: #argumentCount: with: #aBlock]\r\n\t];cr.\r\n\tself if: [self send: #is_Nil with: #count] return: #args.\r\n\tself if: [self expr: #count eqeq: [self call: #len with: #args]] return: #args.\r\n\tself assign: #largs to: [self send: #arrayContents with: 'list(args)[:count]'];cr.\r\n\tself while: [self expr: [self call: #len with: #largs] lt: #count] do: [\r\n\t\tself send: #append to: #largs with: #nil\r\n\t];cr.\r\n\tself return: [self call: #tuple with: #largs] ","function(self)\r\n(self):comment_(\"Returns arguments adapted to call aBlock\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_to_(\"debug\",\"smalltalk\"))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"print\",smalltalk:newArray({\"\\\"arguments_toCall_ - \\\"\", \"args\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"count\",(function()\r\nreturn ((self):send_with_(\"handleOf\",(function()\r\nreturn ((self):send_with_(\"argumentCount:\",\"aBlock\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"count\"))\r\nend),\"args\");\r\n(self):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"count\",(function()\r\nreturn ((self):call_with_(\"len\",\"args\"))\r\nend)))\r\nend),\"args\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"largs\",(function()\r\nreturn ((self):send_with_(\"arrayContents\",\"list(args)[:count]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):while_do_((function()\r\nreturn ((self):expr_lt_((function()\r\nreturn ((self):call_with_(\"len\",\"largs\"))\r\nend),\"count\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"append\",\"largs\",\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"tuple\",\"largs\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"arrayContentsStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("result","[]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("each",(function()
return ((self):call_with_("list",(function()
return ((self):send_with_("handleOf","anArray"))
end)))
end),(function()
return ((self):send_to_with_("append","result",(function()
return ((self):send_with_("asObject:","each"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"api","arrayContentsStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #result to: '[]';cr.\r\n\tself for: #each in: [self call: #list with: [self send: #handleOf with: #anArray]] do: [\r\n\t\tself send: #append to: #result with: [self send: #asObject: with: #each]\r\n\t];cr.\r\n\tself return: #result ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",\"[]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"each\",(function()\r\nreturn ((self):call_with_(\"list\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"anArray\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"append\",\"result\",(function()\r\nreturn ((self):send_with_(\"asObject:\",\"each\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"arrayHandlesStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("result","[]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("each",(function()
return ((self):call_with_("list",(function()
return ((self):send_with_("handleOf","anArray"))
end)))
end),(function()
return ((self):send_to_with_("append","result",(function()
return ((self):send_with_("handleOf","each"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"api","arrayHandlesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #result to: '[]';cr.\r\n\tself for: #each in: [self call: #list with: [self send: #handleOf with: #anArray]] do: [\r\n\t\tself send: #append to: #result with: [self send: #handleOf with: #each]\r\n\t];cr.\r\n\tself return: #result ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",\"[]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"each\",(function()\r\nreturn ((self):call_with_(\"list\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"anArray\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"append\",\"result\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"each\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"arrayHasNativeContentsStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):for_in_do_("each",(function()
return ((self):send_with_("handleOf","anArray"))
end),(function()
return ((self):if_do_else_((function()
return ((self):send_with_("isObject","each"))
end),(function()
return ((self):return_("False"))
end),(function()
return ((self):return_("True"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("False");
return (self);
end
,"api","arrayHasNativeContentsStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself for: #each in: [self send: #handleOf with: #anArray] do: [\r\n\t\tself if: [self send: #isObject with: #each] do: [\r\n\t\t\tself return: #False\r\n\t\t] else: [ self return: #True ]\r\n\t];cr.\r\n\tself return: #False ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"each\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"anArray\"))\r\nend),(function()\r\nreturn ((self):if_do_else_((function()\r\nreturn ((self):send_with_(\"isObject\",\"each\"))\r\nend),(function()\r\nreturn ((self):return_(\"False\"))\r\nend),(function()\r\nreturn ((self):return_(\"True\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"False\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"array_atAllPut_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("array",(function()
return ((self):send_with_("handleOf","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("o",(function()
return ((self):send_with_("asNativeValue:","anObject"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):for_in_do_("i",(function()
return ((self):call_with_("range",(function()
return ((self):call_with_("len","array"))
end)))
end),(function()
return ((self):assign_to_("array[i]","o"))
end));
return (self);
end
,"api","array_atAllPut_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #array to: [self send: #handleOf with: #receiver];cr.\r\n\tself assign: #o to: [self send: #asNativeValue: with: #anObject];cr.\r\n\tself for: #i in: [self call: #range with: [self call: #len with: #array]] do: [\r\n\t\tself assign: 'array[i]' to: #o\r\n\t]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"array\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"o\",(function()\r\nreturn ((self):send_with_(\"asNativeValue:\",\"anObject\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):for_in_do_(\"i\",(function()\r\nreturn ((self):call_with_(\"range\",(function()\r\nreturn ((self):call_with_(\"len\",\"array\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"array[i]\",\"o\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"array_at_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("array",(function()
return ((self):send_with_("handleOf","anArray"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("offset",(function()
return ((self):expr_less_((function()
return ((self):send_with_("handleOf","anIndex"))
end),"1"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):expr_or_((function()
return ((self):expr_lt_("offset","0"))
end),(function()
return ((self):expr_lteq_((function()
return ((self):call_with_("len","array"))
end),"offset"))
end)))
end),(function()
return ((self):send_to_with_("objectNotFoundAt:","anArray","anIndex"))
end));
(self):return_((function()
return ((self):send_with_("asObject:","array[offset]"))
end));
return (self);
end
,"api","array_at_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #array to: [self send: #handleOf with: #anArray];cr.\r\n\tself assign: #offset to: [self expr: [self send: #handleOf with: #anIndex] less: #1];cr.\r\n\tself if: [\tself expr: [self expr: #offset lt: #0]\r\n\t\tor: [self expr: [self call: #len with: #array] lteq: #offset]]\r\n\t\treturn: [self send: #objectNotFoundAt: to: #anArray with: #anIndex ].\r\n\tself return: [self send: #asObject: with: 'array[offset]']","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"array\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"anArray\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"offset\",(function()\r\nreturn ((self):expr_less_((function()\r\nreturn ((self):send_with_(\"handleOf\",\"anIndex\"))\r\nend),\"1\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_lt_(\"offset\",\"0\"))\r\nend),(function()\r\nreturn ((self):expr_lteq_((function()\r\nreturn ((self):call_with_(\"len\",\"array\"))\r\nend),\"offset\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"objectNotFoundAt:\",\"anArray\",\"anIndex\"))\r\nend));\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"asObject:\",\"array[offset]\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"array_at_ifAbsent_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("array",(function()
return ((self):send_with_("handleOf","anArray"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("offset",(function()
return ((self):expr_less_((function()
return ((self):send_with_("handleOf","anIndex"))
end),"1"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):expr_or_((function()
return ((self):expr_lt_("offset","0"))
end),(function()
return ((self):expr_lteq_((function()
return ((self):call_with_("len","array"))
end),"offset"))
end)))
end),(function()
return ((self):send_with_("callBlock0:","aBlock"))
end));
(self):return_((function()
return ((self):send_with_("asObject:","array[offset]"))
end));
return (self);
end
,"api","array_at_ifAbsent_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #array to: [self send: #handleOf with: #anArray];cr.\r\n\tself assign: #offset to: [self expr: [self send: #handleOf with: #anIndex] less: #1];cr.\r\n\tself if: [\tself expr: [self expr: #offset lt: #0]\r\n\t\tor: [self expr: [self call: #len with: #array] lteq: #offset]]\r\n\t\treturn: [self send: #callBlock0: with: #aBlock ].\r\n\tself return: [self send: #asObject: with: 'array[offset]']","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"array\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"anArray\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"offset\",(function()\r\nreturn ((self):expr_less_((function()\r\nreturn ((self):send_with_(\"handleOf\",\"anIndex\"))\r\nend),\"1\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_lt_(\"offset\",\"0\"))\r\nend),(function()\r\nreturn ((self):expr_lteq_((function()\r\nreturn ((self):call_with_(\"len\",\"array\"))\r\nend),\"offset\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_with_(\"callBlock0:\",\"aBlock\"))\r\nend));\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"asObject:\",\"array[offset]\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"array_at_put_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("array",(function()
return ((self):send_with_("handleOf","anArray"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("offset",(function()
return ((self):expr_less_((function()
return ((self):send_with_("handleOf","anIndex"))
end),"1"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):expr_or_((function()
return ((self):expr_lt_("offset","0"))
end),(function()
return ((self):expr_lt_((function()
return ((self):call_with_("len","array"))
end),"offset"))
end)))
end),(function()
return ((self):send_to_with_("invalidIndex:","anArray","anIndex"))
end));
(self):if_return_((function()
return ((self):expr_eqeq_((function()
return ((self):call_with_("len","array"))
end),"offset"))
end),(function()
return ((self):send_to_with_("add:","anArray","anObject"))
end));
(
function(_s8_rec)
	(_s8_rec):assign_to_("array[offset]",(function()
return ((self):send_with_("asNativeValue:","anObject"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("anObject");
return (self);
end
,"api","array_at_put_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #array to: [self send: #handleOf with: #anArray];cr.\r\n\tself assign: #offset to: [self expr: [self send: #handleOf with: #anIndex] less: #1];cr.\r\n\tself if: [self expr: [self expr: #offset lt: #0]\r\n\t\tor: [self expr: [self call: #len with: #array] lt: #offset]]\r\n\t\treturn: [self send: #invalidIndex: to: #anArray with: #anIndex].\r\n\tself if: [self expr: [self call: #len with: #array] eqeq: #offset]\r\n\t\treturn: [self send: #add: to: #anArray with: #anObject].\r\n\tself assign: 'array[offset]' to: [self send: #asNativeValue: with: #anObject];cr.\r\n\tself return: #anObject ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"array\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"anArray\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"offset\",(function()\r\nreturn ((self):expr_less_((function()\r\nreturn ((self):send_with_(\"handleOf\",\"anIndex\"))\r\nend),\"1\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_lt_(\"offset\",\"0\"))\r\nend),(function()\r\nreturn ((self):expr_lt_((function()\r\nreturn ((self):call_with_(\"len\",\"array\"))\r\nend),\"offset\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"invalidIndex:\",\"anArray\",\"anIndex\"))\r\nend));\r\n(self):if_return_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):call_with_(\"len\",\"array\"))\r\nend),\"offset\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"add:\",\"anArray\",\"anObject\"))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"array[offset]\",(function()\r\nreturn ((self):send_with_(\"asNativeValue:\",\"anObject\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"anObject\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"array_copyWithAll_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):send_to_("shallowCopy","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_to_with_("addAll:","result","anArray");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"api","array_copyWithAll_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #result to: [self send: #shallowCopy to: #receiver];cr.\r\n\tself send: #addAll: to: #result with: #anArray;cr.\r\n\tself return: #result ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):send_to_(\"shallowCopy\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_with_(\"addAll:\",\"result\",\"anArray\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"array_join_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("glue",(function()
return ((self):send_with_("handleOf",(function()
return ((self):send_with_("to_String","aString"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_comment_("eachString",smalltalk:newArray({"each"}),(function()
return ((self):return_((function()
return ((self):send_with_("handleOf",(function()
return ((self):send_with_("to_String",(function()
return ((self):send_with_("asObject:","each"))
end)))
end)))
end)))
end),nil);
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("parts",(function()
return ((self):send_to_with_("collect:","anArray",(function()
return ((self):send_withArguments_("blk",smalltalk:newArray({"eachString", "1"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):return_((function()
return ((self):call_with_("self.String",(function()
return ((self):send_to_with_("join","glue",(function()
return ((self):send_with_("handleOf","parts"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("return self.String(glue.join(self.handleOf(anArray)))");
return (self);
end
,"api","array_join_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #glue to: [self send: #handleOf with: [self send: #to_String with: #aString]];cr.\r\n\r\n\tself implementFunction: #eachString arguments: #(each) doing: [\r\n\t\tself return: [\r\n\t\t\tself send: #handleOf with: [\r\n\t\t\tself send: #to_String with: [\r\n\t\t\tself send: #asObject: with: #each\r\n\t\t]]]\r\n\t] comment: nil;cr.\r\n\tself assign: #parts to: [\r\n\t\tself send: #collect: to: #anArray with: [\r\n\t\tself send: #blk withArguments: #(eachString #1)]\r\n\t];cr.\r\n\tself return: [self call: 'self.String' with: [\r\n\t\tself send: #join to: #glue with: [\r\n\t\tself send: #handleOf with: #parts\r\n\t]]];cr.\r\n\tself comment: 'return self.String(glue.join(self.handleOf(anArray)))' ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"glue\",(function()\r\nreturn ((self):send_with_(\"handleOf\",(function()\r\nreturn ((self):send_with_(\"to_String\",\"aString\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_comment_(\"eachString\",smalltalk:newArray({\"each\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_with_(\"handleOf\",(function()\r\nreturn ((self):send_with_(\"to_String\",(function()\r\nreturn ((self):send_with_(\"asObject:\",\"each\"))\r\nend)))\r\nend)))\r\nend)))\r\nend),nil);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"parts\",(function()\r\nreturn ((self):send_to_with_(\"collect:\",\"anArray\",(function()\r\nreturn ((self):send_withArguments_(\"blk\",smalltalk:newArray({\"eachString\", \"1\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):return_((function()\r\nreturn ((self):call_with_(\"self.String\",(function()\r\nreturn ((self):send_to_with_(\"join\",\"glue\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"parts\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"return self.String(glue.join(self.handleOf(anArray)))\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"array_remove_ifAbsent_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):try_except_as_doing_((function()
return ((self):send_to_with_("remove",(function()
return ((self):send_with_("handleOf","receiver"))
end),(function()
return ((self):send_with_("asNativeValue:","anObject"))
end)))
end),"ValueError","ex",(function()
return ((self):return_((function()
return ((self):send_with_("callBlock0:","aBlock"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("anObject");
return (self);
end
,"api","array_remove_ifAbsent_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself try: [\r\n\t\tself\tsend: #remove\r\n\t\t\tto: [self send: #handleOf with: #receiver]\r\n\t\t\twith: [self send: #asNativeValue: with: #anObject]\r\n\t] except: #ValueError as: #ex doing: [\r\n\t\tself return: [self send: #callBlock0: with: #aBlock\r\n\t]];cr.\r\n\tself return: #anObject ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):try_except_as_doing_((function()\r\nreturn ((self):send_to_with_(\"remove\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"asNativeValue:\",\"anObject\"))\r\nend)))\r\nend),\"ValueError\",\"ex\",(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_with_(\"callBlock0:\",\"aBlock\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"anObject\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"asCharacter_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):call_withArguments_("isinstance",smalltalk:newArray({"receiver", "self.Number"})))
end),(function()
return ((self):call_with_("self.String",(function()
return ((self):call_with_("chr",(function()
return ((self):send_with_("handleOf","receiver"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_("asCharacter","receiver"))
end));
return (self);
end
,"api","asCharacter_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self call: #isinstance withArguments: #(receiver 'self.Number')]\r\n\t\treturn: [\tself call: 'self.String' with: [\r\n\t\t\tself call: #chr with: [\r\n\t\t\tself send: #handleOf with: #receiver\r\n\t]]];cr.\r\n\tself return: [self send: #asCharacter to: #receiver] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):call_withArguments_(\"isinstance\",smalltalk:newArray({\"receiver\", \"self.Number\"})))\r\nend),(function()\r\nreturn ((self):call_with_(\"self.String\",(function()\r\nreturn ((self):call_with_(\"chr\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_(\"asCharacter\",\"receiver\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"asNativeValue_StSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):send_with_("is_Nil","anObject"))
end),"None");
(self):if_return_((function()
return ((self):call_withArguments_("isinstance",smalltalk:newArray({"anObject", "(self.String,self.Number,self.Boolean)"})))
end),(function()
return ((self):send_with_("handleOf","anObject"))
end));
(self):if_return_((function()
return ((self):not_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"self", "\"Array\""})))
end)))
end),"anObject");
(
function(_s8_rec)
	(_s8_rec):assign_to_("cls",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"anObject", "\"__class__\"", "None"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):expr_is_("cls","self.Array"))
end),(function()
return ((self):send_with_("handleOf","anObject"))
end));
(self):return_("anObject");
return (self);
end
,"api","asNativeValue_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self send: #is_Nil with: #anObject] return: #None.\r\n\tself if: [self call: #isinstance withArguments: #(anObject '(self.String,self.Number,self.Boolean)')]\r\n\t\treturn: [self send: #handleOf with: #anObject].\r\n\tself if: [self not: [self call: #hasattr withArguments: #(self '\"Array\"')]]\r\n\t\treturn: #anObject.\r\n\tself assign: #cls to: [self call: #getattr withArguments: #(anObject '\"__class__\"' #None)];cr.\r\n\tself if: [self expr: #cls is: 'self.Array']\r\n\t\treturn: [self send: #handleOf with: #anObject ].\r\n\tself return: #anObject ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"anObject\"))\r\nend),\"None\");\r\n(self):if_return_((function()\r\nreturn ((self):call_withArguments_(\"isinstance\",smalltalk:newArray({\"anObject\", \"(self.String,self.Number,self.Boolean)\"})))\r\nend),(function()\r\nreturn ((self):send_with_(\"handleOf\",\"anObject\"))\r\nend));\r\n(self):if_return_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"self\", \"\\\"Array\\\"\"})))\r\nend)))\r\nend),\"anObject\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"cls\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"anObject\", \"\\\"__class__\\\"\", \"None\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):expr_is_(\"cls\",\"self.Array\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"handleOf\",\"anObject\"))\r\nend));\r\n(self):return_(\"anObject\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"asObject_StSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):send_with_("isObject","aNativeObject"))
end),"aNativeObject");
(self):if_return_((function()
return ((self):not_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"self", "\"Array\""})))
end)))
end),"aNativeObject");
(
function(_s8_rec)
	(_s8_rec):assign_to_("h",(function()
return ((self):send_with_("handleOf","aNativeObject"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):send_with_("is_Number","h"))
end),(function()
return ((self):call_with_("self.Number","h"))
end));
(self):if_return_((function()
return ((self):send_with_("is_Nil","h"))
end),"nil");
(
function(_s8_rec)
	(_s8_rec):assign_to_("t",(function()
return ((self):call_with_("type","h"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):expr_eqeq_("t","bool"))
end),(function()
return ((self):send_with_("b:","h"))
end));
(self):if_return_((function()
return ((self):expr_eqeq_("t","str"))
end),(function()
return ((self):call_with_("self.String","h"))
end));
(self):if_return_((function()
return ((self):call_withArguments_("isinstance",smalltalk:newArray({"h", "(list,tuple)"})))
end),(function()
return ((self):call_with_("self.Array","h"))
end));
(self):if_return_((function()
return ((self):call_with_("callable","h"))
end),(function()
return ((self):call_with_("self.BlockClosure","h"))
end));
(self):return_("aNativeObject");
return (self);
end
,"api","asObject_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self send: #isObject with: #aNativeObject]\r\n\t\treturn: #aNativeObject.\r\n\tself if: [self not: [self call: #hasattr withArguments: #(self '\"Array\"')]]\r\n\t\treturn: #aNativeObject.\r\n\tself assign: #h to: [self send: #handleOf with: #aNativeObject];cr.\r\n\tself if: [self send: #is_Number with: #h]\r\n\t\treturn: [self call: 'self.Number' with: #h].\r\n\tself if: [self send: #is_Nil with: #h]\r\n\t\treturn: #nil.\r\n\tself assign: #t to: [self call: #type with: #h];cr.\r\n\tself if: [self expr: #t eqeq: #bool]\r\n\t\treturn: [self send: #b: with: #h].\r\n\tself if: [self expr: #t eqeq: #str]\r\n\t\treturn: [self call: 'self.String' with: #h].\r\n\tself if: [self call: #isinstance withArguments: #(h '(list,tuple)')]\r\n\t\treturn: [self call: 'self.Array' with: #h].\r\n\tself if: [self call: #callable with: #h]\r\n\t\treturn: [self call: 'self.BlockClosure' with: #h].\r\n\tself return: #aNativeObject ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"isObject\",\"aNativeObject\"))\r\nend),\"aNativeObject\");\r\n(self):if_return_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"self\", \"\\\"Array\\\"\"})))\r\nend)))\r\nend),\"aNativeObject\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"aNativeObject\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"is_Number\",\"h\"))\r\nend),(function()\r\nreturn ((self):call_with_(\"self.Number\",\"h\"))\r\nend));\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"h\"))\r\nend),\"nil\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"t\",(function()\r\nreturn ((self):call_with_(\"type\",\"h\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"t\",\"bool\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"b:\",\"h\"))\r\nend));\r\n(self):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"t\",\"str\"))\r\nend),(function()\r\nreturn ((self):call_with_(\"self.String\",\"h\"))\r\nend));\r\n(self):if_return_((function()\r\nreturn ((self):call_withArguments_(\"isinstance\",smalltalk:newArray({\"h\", \"(list,tuple)\"})))\r\nend),(function()\r\nreturn ((self):call_with_(\"self.Array\",\"h\"))\r\nend));\r\n(self):if_return_((function()\r\nreturn ((self):call_with_(\"callable\",\"h\"))\r\nend),(function()\r\nreturn ((self):call_with_(\"self.BlockClosure\",\"h\"))\r\nend));\r\n(self):return_(\"aNativeObject\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"asParameterStObject",0
,function(self)
(self):return_((function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self", "\"@handle\"", "nil"})))
end));
return (self);
end
,"api","asParameterStObject\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self call: #getattr\r\n\t\twithArguments: #(self '\"@handle\"' #nil)\r\n\t] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self\", \"\\\"@handle\\\"\", \"nil\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"asPoolDictionaryStSystemDictionary",0
,function(self)
(self):comment_("DEBUG");
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):call_("self.PoolDictionary.new"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("k",(function()
return ((self):call_with_("dir","self"))
end),(function()
return ((self):send_to_withArguments_("at:put:","result",(smalltalk.Array):with_with_("k",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self", "k"})))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"api","asPoolDictionaryStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: #DEBUG.\r\n\tself assign: #result to: [self call: 'self.PoolDictionary.new'];cr.\r\n\tself for: #k in: [self call: #dir with: #self] do: [\r\n\t\tself send: #at:put: to: #result withArguments: (\r\n\t\t\tArray\twith: #k\r\n\t\t\t\twith: [self call: #getattr withArguments: #(self k)]\r\n\t\t\t)\r\n\t];cr.\r\n\tself return: #result ","function(self)\r\n(self):comment_(\"DEBUG\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):call_(\"self.PoolDictionary.new\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"k\",(function()\r\nreturn ((self):call_with_(\"dir\",\"self\"))\r\nend),(function()\r\nreturn ((self):send_to_withArguments_(\"at:put:\",\"result\",(smalltalk.Array):with_with_(\"k\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self\", \"k\"})))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"asString_StSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):send_withArguments_("responds_to",smalltalk:newArray({"receiver", "\"asString\""})))
end),(function()
return ((self):send_to_("asString","receiver"))
end));
(self):return_((function()
return ((self):call_with_("self.String",(function()
return ((self):call_with_("str",(function()
return ((self):send_with_("handleOf","receiver"))
end)))
end)))
end));
return (self);
end
,"api","asString_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self send: #responds_to withArguments: #(receiver '\"asString\"')]\r\n\t\treturn: [self send: #asString to: #receiver].\r\n\tself return: [self call: 'self.String' with: [\r\n\t\tself call: #str with: [\r\n\t\tself send: #handleOf with: #receiver\r\n\t]]]","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):send_withArguments_(\"responds_to\",smalltalk:newArray({\"receiver\", \"\\\"asString\\\"\"})))\r\nend),(function()\r\nreturn ((self):send_to_(\"asString\",\"receiver\"))\r\nend));\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"self.String\",(function()\r\nreturn ((self):call_with_(\"str\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"availableStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):try_except_as_doing_((function()
return ((self):for_in_do_("module","modules",(function()
return ((self):send_with_("import:","module"))
end)))
end),"Exception","ex",(function()
(
function(_s8_rec)
	(_s8_rec):call_with_("print","ex");
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("False"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("True");
return (self);
end
,"api","availableStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself try: [\r\n\t\tself for: #module in: #modules do: [\r\n\t\t\tself send: #import: with: #module\r\n\t\t]\r\n\t] except: #Exception as: #ex doing: [\r\n\t\t\tself call: #print with: #ex;cr.\r\n\t\t\tself return: #False\r\n\t];cr.\r\n\tself return: #True ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):try_except_as_doing_((function()\r\nreturn ((self):for_in_do_(\"module\",\"modules\",(function()\r\nreturn ((self):send_with_(\"import:\",\"module\"))\r\nend)))\r\nend),\"Exception\",\"ex\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"print\",\"ex\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"False\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"True\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"bStSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):expr_or_((function()
return ((self):expr_is_("aBoolean","self.true"))
end),(function()
return ((self):expr_is_("aBoolean","self.false"))
end)))
end),(function()
return ((self):expr_is_("aBoolean","self.true"))
end));
(self):return_((function()
return ((self):expr_is_("aBoolean","True"))
end));
return (self);
end
,"api","bStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: [self expr: #aBoolean is: 'self.true']\r\n\t\tor: [self expr: #aBoolean is: 'self.false']]\r\n\t\treturn: [self expr: #aBoolean is: 'self.true'].\r\n\tself return: [self expr: #aBoolean is: #True] ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_is_(\"aBoolean\",\"self.true\"))\r\nend),(function()\r\nreturn ((self):expr_is_(\"aBoolean\",\"self.false\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):expr_is_(\"aBoolean\",\"self.true\"))\r\nend));\r\n(self):return_((function()\r\nreturn ((self):expr_is_(\"aBoolean\",\"True\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"b_StSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):expr_or_((function()
return ((self):expr_is_("aBool","True"))
end),(function()
return ((self):expr_is_("aBool","self.true"))
end)))
end),"self.true");
(self):return_("self.false");
return (self);
end
,"api","b_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: [self expr: #aBool is: #True]\r\n\t\tor: [self expr: #aBool is: 'self.true']]\r\n\t\treturn: 'self.true'.\r\n\tself return: 'self.false' ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_is_(\"aBool\",\"True\"))\r\nend),(function()\r\nreturn ((self):expr_is_(\"aBool\",\"self.true\"))\r\nend)))\r\nend),\"self.true\");\r\n(self):return_(\"self.false\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"basenStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("b",(function()
return ((self):send_with_("handleOf","bas"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("baseN",smalltalk:newArray({"num"}),(function()
return ((self):return_((function()
return ((self):expr_or_((function()
return ((self):expr_and_((function()
return ((self):expr_eqeq_("num","0"))
end),"numerals[0]"))
end),(function()
return ((self):expr_plus_((function()
return ((self):send_to_with_("lstrip",(function()
return ((self):call_with_("baseN","num // b"))
end),"numerals[0]"))
end),"numerals[num % b]"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):expr_lt_((function()
return ((self):send_with_("handleOf","n"))
end),"0"))
end),(function()
return ((self):send_with_("invalidMessage:","\"basen - must be positive\""))
end));
(self):return_((function()
return ((self):send_to_with_("String","smalltalk",(function()
return ((self):call_with_("baseN",(function()
return ((self):send_with_("handleOf","n"))
end)))
end)))
end));
return (self);
end
,"api","basenStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #b to: [self send: #handleOf with: #bas];cr.\r\n\tself implementFunction: #baseN arguments: #(num) doing: [\r\n\t\tself return: [self expr: [ self expr: [\r\n\t\t\tself expr: #num eqeq: #0] \r\n\t\t\tand: 'numerals[0]']\r\n\t\t\tor: [self expr: [\r\n\t\t\t\tself send: #lstrip to: [\r\n\t\t\t\t\tself call: #baseN with: 'num // b'\r\n\t\t\t\t\t] with: 'numerals[0]'\r\n\t\t\t\t] plus: 'numerals[num % b]'\r\n\t\t\t]]\r\n\t];cr.\r\n\tself if: [self expr: [self send: #handleOf with: #n] lt: #0]\r\n\t\treturn: [self send: #invalidMessage: with: '\"basen - must be positive\"' ].\r\n\tself return: [\r\n\t\tself send: #String to: #smalltalk with: [\r\n\t\tself call: #baseN with: [\r\n\t\tself send: #handleOf with: #n\r\n\t]]]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"b\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"bas\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"baseN\",smalltalk:newArray({\"num\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):expr_eqeq_(\"num\",\"0\"))\r\nend),\"numerals[0]\"))\r\nend),(function()\r\nreturn ((self):expr_plus_((function()\r\nreturn ((self):send_to_with_(\"lstrip\",(function()\r\nreturn ((self):call_with_(\"baseN\",\"num // b\"))\r\nend),\"numerals[0]\"))\r\nend),\"numerals[num % b]\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):expr_lt_((function()\r\nreturn ((self):send_with_(\"handleOf\",\"n\"))\r\nend),\"0\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"invalidMessage:\",\"\\\"basen - must be positive\\\"\"))\r\nend));\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"String\",\"smalltalk\",(function()\r\nreturn ((self):call_with_(\"baseN\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"n\"))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"basic_at_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("h",(function()
return ((self):send_withArguments_("basic_at_ifAbsent",smalltalk:newArray({"receiver", "key", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_with_("asObject:","h"))
end));
return (self);
end
,"api","basic_at_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #h to: [self send: #basic_at_ifAbsent withArguments: #(receiver key #nil)];cr.\r\n\tself return: [self send: #asObject: with: #h]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",(function()\r\nreturn ((self):send_withArguments_(\"basic_at_ifAbsent\",smalltalk:newArray({\"receiver\", \"key\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"asObject:\",\"h\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"basic_at_ifAbsentStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("k",(function()
return ((self):call_with_("str",(function()
return ((self):send_with_("handleOf","key"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):typeOf_is_("receiver","dict"))
end),(function()
(self):if_return_((function()
return ((self):expr_in_("k","receiver"))
end),"receiver[k]");return ((self):return_((function()
return ((self):send_with_("callBlock0:","aBlock"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("absent",(function()
return ((self):call_with_("StObject","nil"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"receiver", "k", "absent"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):expr_is_("result","absent"))
end),(function()
return ((self):send_with_("callBlock0:","aBlock"))
end));
(self):return_("result");
return (self);
end
,"api","basic_at_ifAbsentStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #k to: [ self call: #str with: [self send: #handleOf with: #key]];cr.\r\n\tself if: [self typeOf: #receiver is: #dict] do: [\r\n\t\tself if: [self expr: #k in: #receiver] return: 'receiver[k]'.\r\n\t\tself return: [self send: #callBlock0: with: #aBlock]\r\n\t];cr.\r\n\tself assign: #absent to: [self call: #StObject with: #nil];cr.\r\n\tself assign: #result to: [self call: #getattr withArguments: #(receiver k absent)];cr.\r\n\tself if: [self expr: #result is: #absent] return: [self send: #callBlock0: with: #aBlock].\r\n\tself return: #result ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"k\",(function()\r\nreturn ((self):call_with_(\"str\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"key\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):typeOf_is_(\"receiver\",\"dict\"))\r\nend),(function()\r\n(self):if_return_((function()\r\nreturn ((self):expr_in_(\"k\",\"receiver\"))\r\nend),\"receiver[k]\");return ((self):return_((function()\r\nreturn ((self):send_with_(\"callBlock0:\",\"aBlock\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"absent\",(function()\r\nreturn ((self):call_with_(\"StObject\",\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"receiver\", \"k\", \"absent\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):expr_is_(\"result\",\"absent\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"callBlock0:\",\"aBlock\"))\r\nend));\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"basic_at_ifAbsent_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("h",(function()
return ((self):send_withArguments_("basic_at_ifAbsent",smalltalk:newArray({"receiver", "key", "aBlock"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_with_("asObject:","h"))
end));
return (self);
end
,"api","basic_at_ifAbsent_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #h to: [self send: #basic_at_ifAbsent withArguments: #(receiver key aBlock)];cr.\r\n\tself return: [self send: #asObject: with: #h] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",(function()\r\nreturn ((self):send_withArguments_(\"basic_at_ifAbsent\",smalltalk:newArray({\"receiver\", \"key\", \"aBlock\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"asObject:\",\"h\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"basic_at_putStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("k",(function()
return ((self):call_with_("str",(function()
return ((self):send_with_("handleOf","key"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):typeOf_is_("receiver","dict"))
end),(function()
(self):if_return_((function()
return ((self):expr_is_("value","None"))
end),(function()
return ((self):send_to_withArguments_("pop","receiver",smalltalk:newArray({"k", "None"})))
end));(
function(_s8_rec)
	(_s8_rec):assign_to_("receiver[k]","value");
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("value"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_is_("value","None"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"receiver", "k"})))
end),(function()
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("isObject","receiver"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("delattr",smalltalk:newArray({"receiver", "k"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("value"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):call_withArguments_("setattr",smalltalk:newArray({"receiver", "k", "value"})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("value"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"receiver", "k", "value"}));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("value");
return (self);
end
,"api","basic_at_putStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #k to: [self call: #str with: [self send: #handleOf with: #key]];cr.\r\n\tself if: [self typeOf: #receiver is: #dict] do: [\r\n\t\tself if: [self expr: #value is: #None]\r\n\t\t\treturn: [self send: #pop to: #receiver withArguments: #(k #None)].\r\n\t\tself assign: 'receiver[k]' to: #value;cr.\r\n\t\tself return: #value\r\n\t];cr.\r\n\tself if: [self expr: #value is: #None] do: [\r\n\t\tself if: [self call: #hasattr withArguments: #(receiver k)] do: [\r\n\t\t\tself if: [self send: #isObject with: #receiver] do: [\r\n\t\t\t\tself call: #delattr withArguments: #(receiver k);cr.\r\n\t\t\t\tself return: #value\r\n\t\t\t];cr.\r\n\t\t\tself call: #setattr withArguments: #(receiver k value)\r\n\t\t];cr.\r\n\t\tself return: #value\r\n\t];cr.\r\n\tself call: #setattr withArguments: #(receiver k value);cr.\r\n\tself return: #value ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"k\",(function()\r\nreturn ((self):call_with_(\"str\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"key\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):typeOf_is_(\"receiver\",\"dict\"))\r\nend),(function()\r\n(self):if_return_((function()\r\nreturn ((self):expr_is_(\"value\",\"None\"))\r\nend),(function()\r\nreturn ((self):send_to_withArguments_(\"pop\",\"receiver\",smalltalk:newArray({\"k\", \"None\"})))\r\nend));(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"receiver[k]\",\"value\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"value\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_is_(\"value\",\"None\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"receiver\", \"k\"})))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"isObject\",\"receiver\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"delattr\",smalltalk:newArray({\"receiver\", \"k\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"value\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):call_withArguments_(\"setattr\",smalltalk:newArray({\"receiver\", \"k\", \"value\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"value\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"receiver\", \"k\", \"value\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"value\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"basic_at_put_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("basic_at_put",(smalltalk.Array):with_with_with_("receiver","key",(function()
return ((self):send_with_("asNativeValue:","value"))
end)));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("value");
return (self);
end
,"api","basic_at_put_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #basic_at_put withArguments: (Array\r\n\t\twith: #receiver with: #key\r\n\t\twith: [self send: #asNativeValue: with: #value]);cr.\r\n\tself return: #value ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"basic_at_put\",(smalltalk.Array):with_with_with_(\"receiver\",\"key\",(function()\r\nreturn ((self):send_with_(\"asNativeValue:\",\"value\"))\r\nend)));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"value\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"become_a_StSystemDictionary",0
,function(self)
(self):comment_("mutate object to an instance of aClass");
(self):send_with_("invalidMessage:","\"become:a:\"");
return (self);
end
,"api","become_a_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'mutate object to an instance of aClass'.\r\n\tself send: #invalidMessage: with: '\"become:a:\"' ","function(self)\r\n(self):comment_(\"mutate object to an instance of aClass\");\r\n(self):send_with_(\"invalidMessage:\",\"\\\"become:a:\\\"\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"bindCoreStSystemDictionary",0
,function(self)
(self):comment_("--bind the minimal functions (e.g i/o)");
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("stringOf",smalltalk:newArray({"param"}),(function()
return ((self):return_((function()
return ((self):call_with_("self.String",(function()
return ((self):send_with_("handleOf","param"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("g",(function()
return ((self):call_("globals"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("read",smalltalk:newArray({"fileName"}),(function()
return ((self):return_((function()
return ((self):send_with_("fileContents",(function()
return ((self):call_with_("stringOf","fileName"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("g[\"read\"]","read");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("g[\"fileContents\"]","read");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("fileWrite",smalltalk:newArray({"fileName", "contents", "mode"}),(function()
return ((self):return_((function()
return ((self):send_withArguments_("fileWrite",(smalltalk.Array):with_with_with_((function()
return ((self):call_with_("stringOf","fileName"))
end),(function()
return ((self):call_with_("stringOf","contents"))
end),(function()
return ((self):call_with_("stringOf","mode"))
end))))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("g[\"fileWrite\"]","fileWrite");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("fileIn",smalltalk:newArray({"fileName"}),(function()
return ((self):return_((function()
return ((self):send_with_("fileIn",(function()
return ((self):call_with_("stringOf","fileName"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("g[\"fileIn\"]","fileIn");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("fileInJS",smalltalk:newArray({"fileName"}),(function()
return ((self):return_((function()
return ((self):send_with_("fileInJS",(function()
return ((self):call_with_("stringOf","fileName"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("g[\"fileInJS\"]","fileInJS");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("doit",smalltalk:newArray({"aString"}),(function()
return ((self):return_((function()
return ((self):send_to_("doIt",(function()
return ((self):call_with_("stringOf","aString"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("g[\"doit\"]","doit");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("exportCategory",smalltalk:newArray({"aString"}),(function()
return ((self):return_((function()
return ((self):send_to_with_("exportCategory:","self.Exporter",(function()
return ((self):call_with_("stringOf","aString"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("g[\"exportCategory\"]","exportCategory");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("saveImage",smalltalk:newArray({"ignored"}),(function()
return ((self):return_((function()
return ((self):send_("saveImage"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("g[\"saveImage\"]","saveImage");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("saveImageAs",smalltalk:newArray({"fileName"}),(function()
return ((self):return_((function()
return ((self):send_with_("saveImageAs:",(function()
return ((self):call_with_("stringOf","fileName"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("g[\"saveImageAs\"]","saveImageAs");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("isFileOlderThan",smalltalk:newArray({"fileName", "referenceFileName"}),(function()
return ((self):return_((function()
return ((self):send_with_with_("isFileOlderThan",(function()
return ((self):call_with_("stringOf","fileName"))
end),(function()
return ((self):call_with_("stringOf","referenceFileName"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("g[\"isFileOlderThan\"]","isFileOlderThan");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"self", "\"$imageFileName\""})))
end)))
end),(function()
return ((self):call_withArguments_("setattr",(smalltalk.Array):with_with_with_("self","\"$imageFileName\"",(function()
return ((self):call_with_("self.String",(function()
return ((self):expr_plus_("\"s8.image.\"",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self", "\"$nativeLanguage\""})))
end)))
end)))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("True");
return (self);
end
,"api","bindCoreStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: '--bind the minimal functions (e.g i/o)'.\r\n\tself implementFunction: #stringOf arguments: #(param) doing: [\r\n\t\tself return: [self call: 'self.String' with: [self send: #handleOf with: #param]]\r\n\t];cr.\r\n\tself assign: #g to: [self call: #globals];cr.\r\n\tself implementFunction: #read arguments: #(fileName) doing: [\r\n\t\tself return: [self send: #fileContents with: [self call: #stringOf with: #fileName]]\r\n\t];cr.\r\n\tself assign: 'g[\"read\"]' to: #read;cr.\r\n\tself assign: 'g[\"fileContents\"]' to: #read;cr.\r\n\tself implementFunction: #fileWrite arguments: #(fileName contents mode) doing: [\r\n\t\tself return: [self send: #fileWrite withArguments: (Array\r\n\t\t\twith: [self call: #stringOf with: #fileName]\r\n\t\t\twith: [self call: #stringOf with: #contents]\r\n\t\t\twith: [self call: #stringOf with: #mode]\r\n\t\t)]\r\n\t];cr.\r\n\tself assign: 'g[\"fileWrite\"]' to: #fileWrite;cr.\r\n\tself implementFunction: #fileIn arguments: #(fileName) doing: [\r\n\t\tself return: [self send: #fileIn with:\r\n\t\t\t[self call: #stringOf with: #fileName]\r\n\t\t]\r\n\t];cr.\r\n\tself assign: 'g[\"fileIn\"]' to: #fileIn;cr.\r\n\tself implementFunction: #fileInJS arguments: #(fileName) doing: [\r\n\t\tself return: [self send: #fileInJS with:\r\n\t\t\t[self call: #stringOf with: #fileName]\r\n\t\t]\r\n\t];cr.\r\n\tself assign: 'g[\"fileInJS\"]' to: #fileInJS;cr.\r\n\tself implementFunction: #doit arguments: #(aString) doing: [\r\n\t\tself return: [self send: #doIt to: [self call: #stringOf with: #aString]]\r\n\t];cr.\r\n\tself assign: 'g[\"doit\"]' to: #doit;cr.\r\n\tself implementFunction: #exportCategory arguments: #(aString) doing: [\r\n\t\tself return: [self\r\n\t\t\tsend: #exportCategory: to: 'self.Exporter'\r\n\t\t\twith: [self call: #stringOf with: #aString]\r\n\t\t]\r\n\t];cr.\r\n\tself assign: 'g[\"exportCategory\"]' to: #exportCategory;cr.\r\n\tself implementFunction: #saveImage arguments: #(ignored) doing: [\r\n\t\tself return: [self send: #saveImage]\r\n\t];cr.\r\n\tself assign: 'g[\"saveImage\"]' to: #saveImage;cr.\r\n\tself implementFunction: #saveImageAs arguments: #(fileName) doing: [\r\n\t\tself return: [self send: #saveImageAs: with:\r\n\t\t\t[self call: #stringOf with: #fileName]\r\n\t\t]\r\n\t];cr.\r\n\tself assign: 'g[\"saveImageAs\"]' to: #saveImageAs;cr.\r\n\tself implementFunction: #isFileOlderThan arguments: #(fileName referenceFileName) doing: [\r\n\t\tself return: [self send: #isFileOlderThan\r\n\t\t\twith: [self call: #stringOf with: #fileName]\r\n\t\t\twith: [self call: #stringOf with: #referenceFileName]\r\n\t\t]\r\n\t];cr.\r\n\tself assign: 'g[\"isFileOlderThan\"]' to: #isFileOlderThan;cr.\r\n\tself if: [self not: [self call: #hasattr withArguments: #(self '\"$imageFileName\"')]] do: [\r\n\t\tself call: #setattr withArguments: (Array\r\n\t\t\twith: #self with: '\"$imageFileName\"'\r\n\t\t\twith: [self call: 'self.String' with: [\r\n\t\t\t\tself expr: '\"s8.image.\"' plus: [\r\n\t\t\t\t\tself call: #getattr\r\n\t\t\t\t\t\twithArguments: #(self '\"$nativeLanguage\"')\r\n\t\t\t\t]]\r\n\t\t\t])\r\n\t];cr.\r\n\tself return: #True ","function(self)\r\n(self):comment_(\"--bind the minimal functions (e.g i/o)\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"stringOf\",smalltalk:newArray({\"param\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):call_with_(\"self.String\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"param\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"g\",(function()\r\nreturn ((self):call_(\"globals\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"read\",smalltalk:newArray({\"fileName\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_with_(\"fileContents\",(function()\r\nreturn ((self):call_with_(\"stringOf\",\"fileName\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"g[\\\"read\\\"]\",\"read\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"g[\\\"fileContents\\\"]\",\"read\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"fileWrite\",smalltalk:newArray({\"fileName\", \"contents\", \"mode\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_withArguments_(\"fileWrite\",(smalltalk.Array):with_with_with_((function()\r\nreturn ((self):call_with_(\"stringOf\",\"fileName\"))\r\nend),(function()\r\nreturn ((self):call_with_(\"stringOf\",\"contents\"))\r\nend),(function()\r\nreturn ((self):call_with_(\"stringOf\",\"mode\"))\r\nend))))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"g[\\\"fileWrite\\\"]\",\"fileWrite\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"fileIn\",smalltalk:newArray({\"fileName\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_with_(\"fileIn\",(function()\r\nreturn ((self):call_with_(\"stringOf\",\"fileName\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"g[\\\"fileIn\\\"]\",\"fileIn\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"fileInJS\",smalltalk:newArray({\"fileName\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_with_(\"fileInJS\",(function()\r\nreturn ((self):call_with_(\"stringOf\",\"fileName\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"g[\\\"fileInJS\\\"]\",\"fileInJS\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"doit\",smalltalk:newArray({\"aString\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_(\"doIt\",(function()\r\nreturn ((self):call_with_(\"stringOf\",\"aString\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"g[\\\"doit\\\"]\",\"doit\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"exportCategory\",smalltalk:newArray({\"aString\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_to_with_(\"exportCategory:\",\"self.Exporter\",(function()\r\nreturn ((self):call_with_(\"stringOf\",\"aString\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"g[\\\"exportCategory\\\"]\",\"exportCategory\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"saveImage\",smalltalk:newArray({\"ignored\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_(\"saveImage\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"g[\\\"saveImage\\\"]\",\"saveImage\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"saveImageAs\",smalltalk:newArray({\"fileName\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_with_(\"saveImageAs:\",(function()\r\nreturn ((self):call_with_(\"stringOf\",\"fileName\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"g[\\\"saveImageAs\\\"]\",\"saveImageAs\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"isFileOlderThan\",smalltalk:newArray({\"fileName\", \"referenceFileName\"}),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_with_with_(\"isFileOlderThan\",(function()\r\nreturn ((self):call_with_(\"stringOf\",\"fileName\"))\r\nend),(function()\r\nreturn ((self):call_with_(\"stringOf\",\"referenceFileName\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"g[\\\"isFileOlderThan\\\"]\",\"isFileOlderThan\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"self\", \"\\\"$imageFileName\\\"\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"setattr\",(smalltalk.Array):with_with_with_(\"self\",\"\\\"$imageFileName\\\"\",(function()\r\nreturn ((self):call_with_(\"self.String\",(function()\r\nreturn ((self):expr_plus_(\"\\\"s8.image.\\\"\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self\", \"\\\"$nativeLanguage\\\"\"})))\r\nend)))\r\nend)))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"True\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"bindRootsStSystemDictionary",0
,function(self)
(self):comment_("Private - Link the system roots to ensure proper delegation chains");
(self):send_with_("invalidMessage:","\"bindRoots\"");
return (self);
end
,"api","bindRootsStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Private - Link the system roots to ensure proper delegation chains'.\r\n\tself send: #invalidMessage: with: '\"bindRoots\"' ","function(self)\r\n(self):comment_(\"Private - Link the system roots to ensure proper delegation chains\");\r\n(self):send_with_(\"invalidMessage:\",\"\\\"bindRoots\\\"\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"bindStSystemDictionary",0
,function(self)
(self):comment_("Boot - Bind an implementation for message stSelector of klass instances");
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_or_((function()
return ((self):send_with_("is_Nil","jsSelector"))
end),(function()
return ((self):not_("jsSelector"))
end)))
end),(function()
return ((self):assign_to_("jsSelector",(function()
return ((self):send_to_withArguments_("replace","stSelector",smalltalk:newArray({"\":\"", "\"_\""})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("stSelector",(function()
return ((self):send_with_("asObject:","stSelector"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("category",(function()
return ((self):send_with_("asObject:","category"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("stSource",(function()
return ((self):send_with_("asObject:","stSource"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("nativeSource",(function()
return ((self):send_with_("asObject:","nativeSource"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("is_Nil","nativeSource"))
end),(function()
return ((self):assign_to_("nativeSource",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"jsFunction", "\"$nativeSource\"", "nil"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("stamp",(function()
return ((self):send_with_("asObject:","stamp"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("debugBind",smalltalk:newArray({"klass", "stSelector", "jsSelector", "jsFunction", "category", "stSource", "nativeSource", "stamp"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("generation",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self", "\"$state\"", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("spec",(function()
return ((self):object_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((("\"$fn\""):_minus_gt("jsFunction")),("#\"$selector\""):_minus_gt("stSelector"))),("#\"$category\""):_minus_gt("category"))),("#\"$source\""):_minus_gt("stSource"))),("#\"$nativeSource\""):_minus_gt("nativeSource"))),("#\"$stamp\""):_minus_gt("stamp"))),("#\"$generation\""):_minus_gt("generation,"))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"self", "\"CompiledMethod\""})))
end),(function()
return ((self):assign_to_("method",(function()
return ((self):call_with_("self.CompiledMethod","spec"))
end)))
end),(function()
return ((self):assign_to_("method","spec"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"method", "\"$selector\"", "stSelector"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"method", "\"$category\"", "category"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"method", "\"$source\"", "stSource"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"method", "\"$nativeSource\"", "nativeSource"}));
	return ((_s8_rec):cr())
end
)(self);
(self):if_do_((function()
return ((self):send_with_("not_Nil","stamp"))
end),(function()
return ((
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"method", "\"$stamp\"", "stamp"}));
	return ((_s8_rec):cr())
end
)(self))
end));
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"method", "\"$generation\"", "generation"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("not_Nil","klass"))
end),(function()
return ((self):send_withArguments_("addMethod",smalltalk:newArray({"jsSelector", "method", "klass", "stSelector"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"api","bindStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Boot - Bind an implementation for message stSelector of klass instances'.\r\n\tself if: [self expr: [self send: #is_Nil with: #jsSelector] or: [self not: #jsSelector]] do: [\r\n\t\tself assign: #jsSelector to: [\r\n\t\t\tself send: #replace to: #stSelector withArguments: #('\":\"' '\"_\"')\r\n\t\t]\r\n\t];cr.\r\n\tself assign: #stSelector to: [self send: #asObject: with: #stSelector];cr.\r\n\tself assign: #category to: [self send: #asObject: with: #category];cr.\r\n\tself assign: #stSource to: [self send: #asObject: with: #stSource];cr.\r\n\tself assign: #nativeSource to: [self send: #asObject: with: #nativeSource];cr.\r\n\tself if: [self send: #is_Nil with: #nativeSource] do: [\r\n\t\tself assign: #nativeSource to: [\r\n\t\t\tself call: #getattr withArguments: #(jsFunction '\"$nativeSource\"' #nil)\r\n\t\t]\r\n\t];cr.\r\n\tself assign: #stamp to: [self send: #asObject: with: #stamp];cr.\r\n\tself send: #debugBind withArguments: #(\r\n\t\tklass stSelector jsSelector jsFunction\r\n\t\tcategory stSource nativeSource stamp);cr.\r\n\tself assign: #generation to: [\r\n\t\tself call: #getattr withArguments: #(self '\"$state\"' #nil)\r\n\t];cr.\r\n\tself assign: #spec to: [self object:\r\n\t\t'\"$fn\"' -> #jsFunction\r\n\t\t,('#\"$selector\"' -> #stSelector)\r\n\t\t,('#\"$category\"' -> #category)\r\n\t\t,('#\"$source\"' -> #stSource)\r\n\t\t,('#\"$nativeSource\"' -> #nativeSource)\r\n\t\t,('#\"$stamp\"' -> #stamp)\r\n\t\t,('#\"$generation\"' -> 'generation,')\r\n\t];cr.\r\n\tself if: [self call: #hasattr withArguments: #(self '\"CompiledMethod\"')] do: [\r\n\t\tself assign: #method to: [self call: 'self.CompiledMethod' with: #spec]\r\n\t\t] else: [ self assign: #method to: #spec ];cr.\r\n\tself call: #setattr withArguments: #(method '\"$selector\"' stSelector);cr.\r\n\tself call: #setattr withArguments: #(method '\"$category\"' category);cr.\r\n\tself call: #setattr withArguments: #(method '\"$source\"' stSource);cr.\r\n\tself call: #setattr withArguments: #(method '\"$nativeSource\"' nativeSource);cr.\r\n\tself if: [self send: #not_Nil with: #stamp] do: [\r\n\t\tself call: #setattr withArguments: #(method '\"$stamp\"' stamp);cr.\r\n\t].\r\n\t\tself call: #setattr withArguments: #(method '\"$generation\"' generation);cr.\r\n\tself if: [self send: #not_Nil with: #klass] do: [\r\n\t\tself send: #addMethod withArguments: #(jsSelector method klass stSelector)\r\n\t];cr.\r\n\tself return: #method ","function(self)\r\n(self):comment_(\"Boot - Bind an implementation for message stSelector of klass instances\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"jsSelector\"))\r\nend),(function()\r\nreturn ((self):not_(\"jsSelector\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"jsSelector\",(function()\r\nreturn ((self):send_to_withArguments_(\"replace\",\"stSelector\",smalltalk:newArray({\"\\\":\\\"\", \"\\\"_\\\"\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"stSelector\",(function()\r\nreturn ((self):send_with_(\"asObject:\",\"stSelector\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"category\",(function()\r\nreturn ((self):send_with_(\"asObject:\",\"category\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"stSource\",(function()\r\nreturn ((self):send_with_(\"asObject:\",\"stSource\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"nativeSource\",(function()\r\nreturn ((self):send_with_(\"asObject:\",\"nativeSource\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"nativeSource\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"nativeSource\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"jsFunction\", \"\\\"$nativeSource\\\"\", \"nil\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"stamp\",(function()\r\nreturn ((self):send_with_(\"asObject:\",\"stamp\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"debugBind\",smalltalk:newArray({\"klass\", \"stSelector\", \"jsSelector\", \"jsFunction\", \"category\", \"stSource\", \"nativeSource\", \"stamp\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"generation\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self\", \"\\\"$state\\\"\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"spec\",(function()\r\nreturn ((self):object_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((\"\\\"$fn\\\"\"):_minus_gt(\"jsFunction\")),(\"#\\\"$selector\\\"\"):_minus_gt(\"stSelector\"))),(\"#\\\"$category\\\"\"):_minus_gt(\"category\"))),(\"#\\\"$source\\\"\"):_minus_gt(\"stSource\"))),(\"#\\\"$nativeSource\\\"\"):_minus_gt(\"nativeSource\"))),(\"#\\\"$stamp\\\"\"):_minus_gt(\"stamp\"))),(\"#\\\"$generation\\\"\"):_minus_gt(\"generation,\"))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"self\", \"\\\"CompiledMethod\\\"\"})))\r\nend),(function()\r\nreturn ((self):assign_to_(\"method\",(function()\r\nreturn ((self):call_with_(\"self.CompiledMethod\",\"spec\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"method\",\"spec\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"method\", \"\\\"$selector\\\"\", \"stSelector\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"method\", \"\\\"$category\\\"\", \"category\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"method\", \"\\\"$source\\\"\", \"stSource\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"method\", \"\\\"$nativeSource\\\"\", \"nativeSource\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_do_((function()\r\nreturn ((self):send_with_(\"not_Nil\",\"stamp\"))\r\nend),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"method\", \"\\\"$stamp\\\"\", \"stamp\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"method\", \"\\\"$generation\\\"\", \"generation\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"not_Nil\",\"klass\"))\r\nend),(function()\r\nreturn ((self):send_withArguments_(\"addMethod\",smalltalk:newArray({\"jsSelector\", \"method\", \"klass\", \"stSelector\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"blkStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):call_with_("self.BlockClosure","func"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):expr_is_("argumentCount","nil"))
end)))
end),(function()
(self):comment_("self.not_Nil(argumentCount):");return ((self):call_withArguments_("setattr",smalltalk:newArray({"result", "\"@argumentCount\"", "argumentCount"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):expr_is_("info","nil"))
end)))
end),(function()
(self):comment_("self.not_Nil(info):");return ((self):call_withArguments_("setattr",smalltalk:newArray({"result", "\"$info\"", "info"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"api","blkStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #result to: [self call: 'self.BlockClosure' with: #func];cr.\r\n\tself if: [self not: [self expr: #argumentCount is: #nil]] do: [\r\n\t\tself comment: 'self.not_Nil(argumentCount):'.\r\n\t\tself call: #setattr withArguments: #(result '\"@argumentCount\"' argumentCount)\r\n\t];cr.\r\n\tself if: [self not: [self expr: #info is: #nil]] do: [\r\n\t\tself comment: 'self.not_Nil(info):'.\r\n\t\tself call: #setattr withArguments: #(result '\"$info\"' info)\r\n\t];cr.\r\n\tself return: #result ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):call_with_(\"self.BlockClosure\",\"func\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):expr_is_(\"argumentCount\",\"nil\"))\r\nend)))\r\nend),(function()\r\n(self):comment_(\"self.not_Nil(argumentCount):\");return ((self):call_withArguments_(\"setattr\",smalltalk:newArray({\"result\", \"\\\"@argumentCount\\\"\", \"argumentCount\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):expr_is_(\"info\",\"nil\"))\r\nend)))\r\nend),(function()\r\n(self):comment_(\"self.not_Nil(info):\");return ((self):call_withArguments_(\"setattr\",smalltalk:newArray({\"result\", \"\\\"$info\\\"\", \"info\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"booleanNot_StSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):expr_is_("receiver","self.true"))
end),"self.false");
(self):if_return_((function()
return ((self):expr_is_("receiver","self.false"))
end),"self.true");
(
function(_s8_rec)
	(_s8_rec):assign_to_("aHandle",(function()
return ((self):send_with_("handleOf","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):send_withArguments_("responds_to",smalltalk:newArray({"receiver", "\"_8not\""})))
end),(function()
return ((self):send_to_("_8not","receiver"))
end));
(self):return_((function()
return ((self):send_with_("b:",(function()
return ((self):not_("aHandle"))
end)))
end));
return (self);
end
,"api","booleanNot_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: #receiver is: 'self.true']\r\n\t\treturn: 'self.false'.\r\n\tself if: [self expr: #receiver is: 'self.false']\r\n\t\treturn: 'self.true'.\r\n\tself assign: #aHandle to: [self send: #handleOf with: #receiver];cr.\r\n\tself if: [self send: #responds_to withArguments: #(receiver '\"_8not\"')]\r\n\t\treturn: [self send: #_8not to: #receiver ].\r\n\tself return: [self send: #b: with: [self not: #aHandle]] ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):expr_is_(\"receiver\",\"self.true\"))\r\nend),\"self.false\");\r\n(self):if_return_((function()\r\nreturn ((self):expr_is_(\"receiver\",\"self.false\"))\r\nend),\"self.true\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aHandle\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):send_withArguments_(\"responds_to\",smalltalk:newArray({\"receiver\", \"\\\"_8not\\\"\"})))\r\nend),(function()\r\nreturn ((self):send_to_(\"_8not\",\"receiver\"))\r\nend));\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"b:\",(function()\r\nreturn ((self):not_(\"aHandle\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"boolean_and_StSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):expr_is_("receiver","self.false"))
end),"receiver");
(self):return_((function()
return ((self):send_with_("callBlock0:","option"))
end));
return (self);
end
,"api","boolean_and_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: #receiver is: 'self.false']\r\n\t\treturn: #receiver.\r\n\tself return: [self send: #callBlock0: with: #option] ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):expr_is_(\"receiver\",\"self.false\"))\r\nend),\"receiver\");\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"callBlock0:\",\"option\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"boolean_or_StSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):expr_is_("receiver","self.true"))
end),"receiver");
(self):return_((function()
return ((self):send_with_("callBlock0:","option"))
end));
return (self);
end
,"api","boolean_or_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: #receiver is: 'self.true']\r\n\t\treturn: #receiver.\r\n\tself return: [self send: #callBlock0: with: #option] ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):expr_is_(\"receiver\",\"self.true\"))\r\nend),\"receiver\");\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"callBlock0:\",\"option\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"callBlock0_StSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):expr_is_("aBlock","nil"))
end),"noBlockValue");
(
function(_s8_rec)
	(_s8_rec):import_("types");
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):typeOf_is_("aBlock","types.FunctionType"))
end),(function()
return ((self):call_("aBlock"))
end));
(
function(_s8_rec)
	(_s8_rec):assign_to_("hBlock",(function()
return ((self):send_to_("handle","aBlock"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_is_("hBlock","nil"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("print",smalltalk:newArray({"\"Corrupted block\"", "aBlock"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("nil"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_("hBlock"))
end));
return (self);
end
,"api","callBlock0_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: #aBlock is: #nil] return: #noBlockValue.\r\n\tself import: #types;cr.\r\n\tself if: [self typeOf: #aBlock is: 'types.FunctionType'] return: [self call: #aBlock].\r\n\tself assign: #hBlock to: [self send: #handle to: #aBlock];cr.\r\n\tself if: [self expr: #hBlock is: #nil] do: [\r\n\t\tself call: #print withArguments: #('\"Corrupted block\"' aBlock);cr.\r\n\t\tself return: #nil\r\n\t];cr.\r\n\tself return: [self call: #hBlock] ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):expr_is_(\"aBlock\",\"nil\"))\r\nend),\"noBlockValue\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):import_(\"types\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):typeOf_is_(\"aBlock\",\"types.FunctionType\"))\r\nend),(function()\r\nreturn ((self):call_(\"aBlock\"))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"hBlock\",(function()\r\nreturn ((self):send_to_(\"handle\",\"aBlock\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_is_(\"hBlock\",\"nil\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"print\",smalltalk:newArray({\"\\\"Corrupted block\\\"\", \"aBlock\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_(\"hBlock\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"classChangedStSystemDictionary",0
,function(self)
(self):send_with_("smDo",(function()
return ((self):lambda_expr_("sm",(function()
return ((self):send_to_with_("classChanged:","sm","aBehavior"))
end)))
end));
return (self);
end
,"api","classChangedStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self lambda: #sm expr: [\r\n\t\tself send: #classChanged: to: #sm with: #aBehavior\r\n\t]] ","function(self)\r\n(self):send_with_(\"smDo\",(function()\r\nreturn ((self):lambda_expr_(\"sm\",(function()\r\nreturn ((self):send_to_with_(\"classChanged:\",\"sm\",\"aBehavior\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"classShapeChangedStSystemDictionary",0
,function(self)
(self):send_with_("smDo",(function()
return ((self):lambda_expr_("sm",(function()
return ((self):send_to_with_("classShapeChanged:","sm","aBehavior"))
end)))
end));
return (self);
end
,"api","classShapeChangedStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self lambda: #sm expr: [\r\n\t\tself send: #classShapeChanged: to: #sm with: #aBehavior\r\n\t]] ","function(self)\r\n(self):send_with_(\"smDo\",(function()\r\nreturn ((self):lambda_expr_(\"sm\",(function()\r\nreturn ((self):send_to_with_(\"classShapeChanged:\",\"sm\",\"aBehavior\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"classesStSystemDictionary",0
,function(self)
(self):comment_("Boot - Returns an Array with the classes defined in the system");
(
function(_s8_rec)
	(_s8_rec):assign_to_("result","[]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("k",(function()
return ((self):call_with_("dir","smalltalk"))
end),(function()
return ((self):if_do_((function()
return ((self):send_to_("isupper","k[0]"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("cls",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"smalltalk", "k"})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):expr_and_((function()
return ((self):send_to_with_("isObject","smalltalk","cls"))
end),(function()
return ((self):send_to_with_("b","smalltalk",(function()
return ((self):send_to_("isClass","cls"))
end)))
end)))
end),(function()
return ((self):send_to_with_("append","result","cls"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_with_("newArray","smalltalk","result"))
end));
return (self);
end
,"api","classesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Boot - Returns an Array with the classes defined in the system'.\r\n\tself assign: #result to: '[]';cr.\r\n\tself for: #k in: [self call: #dir with: #smalltalk] do: [\r\n\t\tself if: [self send: #isupper to: 'k[0]'] do: [\r\n\t\t\tself assign: #cls to: [self call: #getattr withArguments: #(smalltalk k)];cr.\r\n\t\t\tself if: [self\r\n\t\t\t\texpr: [self send: #isObject to: #smalltalk with: #cls]\r\n\t\t\t\tand: [self send: #b to: #smalltalk with: [\r\n\t\t\t\tself send: #isClass to: #cls ]]] do: [\r\n\t\t\t\t\tself send: #append to: #result with: #cls\r\n\t\t\t]\r\n\t\t]\r\n\t];cr.\r\n\tself return: [self send: #newArray to: #smalltalk with: #result]","function(self)\r\n(self):comment_(\"Boot - Returns an Array with the classes defined in the system\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",\"[]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"k\",(function()\r\nreturn ((self):call_with_(\"dir\",\"smalltalk\"))\r\nend),(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):send_to_(\"isupper\",\"k[0]\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"cls\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"smalltalk\", \"k\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):send_to_with_(\"isObject\",\"smalltalk\",\"cls\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"b\",\"smalltalk\",(function()\r\nreturn ((self):send_to_(\"isClass\",\"cls\"))\r\nend)))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"append\",\"result\",\"cls\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"newArray\",\"smalltalk\",\"result\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"computeMetaSubclassesOf_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):send_with_("newArray","[]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("addSubMeta",smalltalk:newArray({"cls"}),(function()
return ((self):send_to_with_("add:","result","cls.__class__"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("array",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aClass", "\"@subclasses\""})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_gt_((function()
return ((self):send_to_("handle",(function()
return ((self):send_to_("size","array"))
end)))
end),"0"))
end),(function()
return ((self):for_in_do_("cls",(function()
return ((self):send_to_("handle","array"))
end),(function()
return ((self):call_with_("addSubMeta","cls"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):call_withArguments_("setattr",smalltalk:newArray({"aClass.__class__", "\"@subclasses\"", "result"}));
return (self);
end
,"api","computeMetaSubclassesOf_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #result to: [self send: #newArray with: '[]'];cr.\r\n\tself implementFunction: #addSubMeta arguments: #(cls) doing: [\r\n\t\tself send: #add: to: #result with: 'cls.__class__'\r\n\t];cr.\r\n\tself assign: #array to: [self call: #getattr withArguments: #(aClass '\"@subclasses\"')];cr.\r\n\tself if: [self expr: [self send: #handle to: [self send: #size to: #array]] gt: #0] do: [\r\n\t\tself for: #cls in: [self send: #handle to: #array] do: [\r\n\t\t\tself call: #addSubMeta with: #cls\r\n\t\t]\r\n\t];cr.\r\n\tself call: #setattr withArguments: #('aClass.__class__' '\"@subclasses\"' result)","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):send_with_(\"newArray\",\"[]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"addSubMeta\",smalltalk:newArray({\"cls\"}),(function()\r\nreturn ((self):send_to_with_(\"add:\",\"result\",\"cls.__class__\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"array\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aClass\", \"\\\"@subclasses\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_gt_((function()\r\nreturn ((self):send_to_(\"handle\",(function()\r\nreturn ((self):send_to_(\"size\",\"array\"))\r\nend)))\r\nend),\"0\"))\r\nend),(function()\r\nreturn ((self):for_in_do_(\"cls\",(function()\r\nreturn ((self):send_to_(\"handle\",\"array\"))\r\nend),(function()\r\nreturn ((self):call_with_(\"addSubMeta\",\"cls\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):call_withArguments_(\"setattr\",smalltalk:newArray({\"aClass.__class__\", \"\\\"@subclasses\\\"\", \"result\"}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"computeSubclassesStSystemDictionary",0
,function(self)
(self):for_in_do_("aClass",(function()
return ((self):send_with_("handleOf",(function()
return ((self):send_("classes"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):call_with_("list",(function()
return ((self):send_to_("__subclasses__","aClass"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",(smalltalk.Array):with_with_with_("aClass","\"@subclasses\"",(function()
return ((self):send_with_("newArray","result"))
end)));
	return ((_s8_rec):cr())
end
)(self);return ((self):send_with_("computeMetaSubclassesOf:","aClass"))
end));
return (self);
end
,"api","computeSubclassesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself for: #aClass in: [self send: #handleOf with: [self send: #classes]] do: [\r\n\t\tself assign: #result to: [self call: #list with: [self send: #__subclasses__ to: #aClass]];cr.\r\n\t\tself call: #setattr withArguments: (Array\r\n\t\t\twith: #aClass with: '\"@subclasses\"'\r\n\t\t\twith: [self send: #newArray with: #result]);cr.\r\n\t\tself send: #computeMetaSubclassesOf: with: #aClass\r\n\t]","function(self)\r\n(self):for_in_do_(\"aClass\",(function()\r\nreturn ((self):send_with_(\"handleOf\",(function()\r\nreturn ((self):send_(\"classes\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):call_with_(\"list\",(function()\r\nreturn ((self):send_to_(\"__subclasses__\",\"aClass\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",(smalltalk.Array):with_with_with_(\"aClass\",\"\\\"@subclasses\\\"\",(function()\r\nreturn ((self):send_with_(\"newArray\",\"result\"))\r\nend)));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_with_(\"computeMetaSubclassesOf:\",\"aClass\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"copyToStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("source","self.__dict__");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("target","anInstance.__dict__");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("k",(function()
return ((self):send_to_("keys","source"))
end),(function()
return ((self):assign_to_("target[k]","source[k]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("False",(function()
(self):comment_("True:");(
function(_s8_rec)
	(_s8_rec):call_with_("print","\"smalltalk replacement with new instance notImplemented. Yet\"");
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("self"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("anInstance");
return (self);
end
,"api","copyToStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #source to: 'self.__dict__';cr.\r\n\tself assign: #target to: 'anInstance.__dict__';cr.\r\n\tself for: #k in: [self send: #keys to: #source] do: [\r\n\t\tself assign: 'target[k]' to: 'source[k]'\r\n\t];cr.\r\n\tself if: #False do: [\r\n\t\tself comment: #True:.\r\n\t\tself call: #print with: '\"smalltalk replacement with new instance notImplemented. Yet\"';cr.\r\n\t\tself return: #self\r\n\t];cr.\r\n\tself return: #anInstance ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"source\",\"self.__dict__\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"target\",\"anInstance.__dict__\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"k\",(function()\r\nreturn ((self):send_to_(\"keys\",\"source\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"target[k]\",\"source[k]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"False\",(function()\r\n(self):comment_(\"True:\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"print\",\"\\\"smalltalk replacement with new instance notImplemented. Yet\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"self\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"anInstance\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"debugAddClassStSystemDictionary",0
,function(self)
(self):return_("self");
return (self);
end
,"api","debugAddClassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: #self ","function(self)\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"debugBindStSystemDictionary",0
,function(self)
(self):return_("self");
return (self);
end
,"api","debugBindStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: #self ","function(self)\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"debugStSystemDictionary",0
,function(self)
(self):comment_("DEBUG");
(
function(_s8_rec)
	(_s8_rec):assign_to_("dbg",(function()
return ((self):expr_is_((function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self", "\"DEBUG\"", "nil"})))
end),"self.true"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("if dbg: print(\"# outerFramesCount\",self.outerFramesCount())");
(self):return_("dbg");
return (self);
end
,"api","debugStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: #DEBUG.\r\n\tself assign: #dbg to: [self\r\n\t\texpr: [self call: #getattr withArguments: #(self '\"DEBUG\"' #nil)]\r\n\t\tis: 'self.true'];cr.\r\n\tself comment: 'if dbg: print(\"# outerFramesCount\",self.outerFramesCount())'.\r\n\tself return: #dbg ","function(self)\r\n(self):comment_(\"DEBUG\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"dbg\",(function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self\", \"\\\"DEBUG\\\"\", \"nil\"})))\r\nend),\"self.true\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"if dbg: print(\\\"# outerFramesCount\\\",self.outerFramesCount())\");\r\n(self):return_(\"dbg\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"debug_StSystemDictionary",0
,function(self)
(self):comment_("DEBUG");
(self):call_withArguments_("setattr",smalltalk:newArray({"self", "\"DEBUG\"", "aBoolean"}));
return (self);
end
,"api","debug_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: #DEBUG.\r\n\tself call: #setattr withArguments: #(self '\"DEBUG\"' aBoolean) ","function(self)\r\n(self):comment_(\"DEBUG\");\r\n(self):call_withArguments_(\"setattr\",smalltalk:newArray({\"self\", \"\\\"DEBUG\\\"\", \"aBoolean\"}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"do_onError_StSystemDictionary",0
,function(self)
(self):send_with_("invalidMessage:","\"do:onError:\"");
return (self);
end
,"api","do_onError_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #invalidMessage: with: '\"do:onError:\"' ","function(self)\r\n(self):send_with_(\"invalidMessage:\",\"\\\"do:onError:\\\"\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"emmitStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_to_with_("emmit:","smalltalk","fileName"))
end));
return (self);
end
,"api","emmitStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #emmit: to: #smalltalk with: #fileName] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"emmit:\",\"smalltalk\",\"fileName\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"exceptionResult_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("_s8Ret_","__ex.args[0]");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("_s8Ret_.result");
return (self);
end
,"api","exceptionResult_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #_s8Ret_ to: '__ex.args[0]';cr.\r\n\tself return: '_s8Ret_.result' ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"_s8Ret_\",\"__ex.args[0]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"_s8Ret_.result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"exception_atStSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):send_with_("is_Nil","__ex"))
end),"False");
(self):if_return_((function()
return ((self):not_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"__ex", "\"args\""})))
end)))
end),"False");
(
function(_s8_rec)
	(_s8_rec):assign_to_("arg","__ex.args[0]");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):expr_eqeq_("arg","target"))
end));
return (self);
end
,"api","exception_atStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self send: #is_Nil with: #__ex] return: #False.\r\n\tself if: [self not: [self call: #hasattr withArguments: #(__ex '\"args\"')]] return: #False.\r\n\tself assign: #arg to: '__ex.args[0]';cr.\r\n\tself return: [self expr: #arg eqeq: #target] ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"__ex\"))\r\nend),\"False\");\r\n(self):if_return_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"__ex\", \"\\\"args\\\"\"})))\r\nend)))\r\nend),\"False\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"arg\",\"__ex.args[0]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):expr_eqeq_(\"arg\",\"target\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"exportCategoryStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("exportCategory:","aString"))
end));
return (self);
end
,"api","exportCategoryStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #exportCategory: with: #aString] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"exportCategory:\",\"aString\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"fileContentsStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("filename",(function()
return ((self):send_with_("handleOf","fileName"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):expr_eqeq_((function()
return ((self):send_to_("lower","filename[:4]"))
end),"\"http\""))
end),(function()
return ((self):send_with_("httpContents","filename"))
end));
(
function(_s8_rec)
	(_s8_rec):import_("os");
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):send_to_with_("isdir","os.path","filename"))
end),(function()
return ((self):send_with_("folderContents","filename"))
end));
(self):with_as_do_((function()
return ((self):call_withArguments_("open",smalltalk:newArray({"filename", "encoding=\"utf-8\"", "errors=\"ignore\""})))
end),"f",(function()
return ((self):return_((function()
return ((self):call_with_("self.String",(function()
return ((self):send_to_("read","f"))
end)))
end)))
end));
return (self);
end
,"api","fileContentsStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #filename to: [self send: #handleOf with: #fileName];cr.\r\n\tself if: [self expr: [self send: #lower to: 'filename[:4]'] eqeq: '\"http\"']\r\n\t\treturn: [self send: #httpContents with: #filename].\r\n\tself import: #os;cr.\r\n\tself if: [self send: #isdir to: 'os.path' with: #filename]\r\n\t\treturn: [self send: #folderContents with: #filename].\r\n\tself\twith: [self call: #open\r\n\t\t\twithArguments: #(filename\r\n\t\t\t\t'encoding=\"utf-8\"'\r\n\t\t\t\t'errors=\"ignore\"')]\r\n\t\tas: #f do: [\r\n\t\t\tself return: [self\r\n\t\t\t\tcall: 'self.String'\r\n\t\t\t\twith: [self send: #read to: #f]]\r\n\t]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"filename\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"fileName\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):send_to_(\"lower\",\"filename[:4]\"))\r\nend),\"\\\"http\\\"\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"httpContents\",\"filename\"))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):import_(\"os\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):send_to_with_(\"isdir\",\"os.path\",\"filename\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"folderContents\",\"filename\"))\r\nend));\r\n(self):with_as_do_((function()\r\nreturn ((self):call_withArguments_(\"open\",smalltalk:newArray({\"filename\", \"encoding=\\\"utf-8\\\"\", \"errors=\\\"ignore\\\"\"})))\r\nend),\"f\",(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):call_with_(\"self.String\",(function()\r\nreturn ((self):send_to_(\"read\",\"f\"))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"fileInJSStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("sName",(function()
return ((self):call_with_("str",(function()
return ((self):send_with_("handleOf","fileName"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("contents",(function()
return ((self):send_to_("fileContents",(function()
return ((self):call_with_("self.String","sName"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_to_with_("is_Nil","smalltalk","contents"))
end),(function()
return ((self):send_to_with_("error:","smalltalk",(function()
return ((self):call_with_("self.String",(function()
return ((self):expr_plus_("\"Missing file \"","sName"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("was: return smalltalk.eval_(contents)");
(
function(_s8_rec)
	(_s8_rec):assign_to_("locals",(function()
return ((self):call_("dict"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):try_except_as_doing_((function()
return ((self):call_withArguments_("exec",(smalltalk.Array):with_with_with_((function()
return ((self):send_with_("handleOf","contents"))
end),(function()
return ((self):call_("globals"))
end),"locals")))
end),"Exception","ex",(function()
return ((self):call_with_("print","ex"))
end));
return (self);
end
,"api","fileInJSStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #sName to: [self call: #str with: [self send: #handleOf with: #fileName]];cr.\r\n\tself assign: #contents to: [self send: #fileContents to: [self call: 'self.String' with: #sName]];cr.\r\n\tself if: [self send: #is_Nil to: #smalltalk with: #contents] do: [\r\n\t\tself send: #error: to: #smalltalk with: [self call: 'self.String' with:\r\n\t\t\t[self expr: '\"Missing file \"' plus: #sName]]\r\n\t];cr.\r\n\tself comment: 'was: return smalltalk.eval_(contents)'.\r\n\tself assign: #locals to: [self call: #dict];cr.\r\n\tself try: [\r\n\t\tself call: #exec withArguments: (Array\r\n\t\t\twith: [self send: #handleOf with: #contents]\r\n\t\t\twith: [self call: #globals]\r\n\t\t\twith: #locals)\r\n\t] except: #Exception as: #ex doing: [\r\n\t\tself call: #print with: #ex\r\n\t]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"sName\",(function()\r\nreturn ((self):call_with_(\"str\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"fileName\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"contents\",(function()\r\nreturn ((self):send_to_(\"fileContents\",(function()\r\nreturn ((self):call_with_(\"self.String\",\"sName\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_to_with_(\"is_Nil\",\"smalltalk\",\"contents\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"error:\",\"smalltalk\",(function()\r\nreturn ((self):call_with_(\"self.String\",(function()\r\nreturn ((self):expr_plus_(\"\\\"Missing file \\\"\",\"sName\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"was: return smalltalk.eval_(contents)\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"locals\",(function()\r\nreturn ((self):call_(\"dict\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):try_except_as_doing_((function()\r\nreturn ((self):call_withArguments_(\"exec\",(smalltalk.Array):with_with_with_((function()\r\nreturn ((self):send_with_(\"handleOf\",\"contents\"))\r\nend),(function()\r\nreturn ((self):call_(\"globals\"))\r\nend),\"locals\")))\r\nend),\"Exception\",\"ex\",(function()\r\nreturn ((self):call_with_(\"print\",\"ex\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"fileInStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("sName",(function()
return ((self):call_with_("str",(function()
return ((self):send_with_("handleOf","fileName"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("contents",(function()
return ((self):send_to_("fileContents",(function()
return ((self):call_with_("self.String","sName"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_to_with_("is_Nil","smalltalk","contents"))
end),(function()
return ((self):send_to_with_("error:","smalltalk",(function()
return ((self):call_with_("self.String",(function()
return ((self):expr_plus_("\"Missing file \"","sName"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_("fileIn","contents"))
end));
return (self);
end
,"api","fileInStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #sName to: [self call: #str with: [self send: #handleOf with: #fileName]];cr.\r\n\tself assign: #contents to: [self send: #fileContents to: [self call: 'self.String' with: #sName]];cr.\r\n\tself if: [self send: #is_Nil to: #smalltalk with: #contents] do: [\r\n\t\tself send: #error: to: #smalltalk with: [self call: 'self.String' with:\r\n\t\t\t[self expr: '\"Missing file \"' plus: #sName]]\r\n\t];cr.\r\n\tself return: [self send: #fileIn to: #contents] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"sName\",(function()\r\nreturn ((self):call_with_(\"str\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"fileName\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"contents\",(function()\r\nreturn ((self):send_to_(\"fileContents\",(function()\r\nreturn ((self):call_with_(\"self.String\",\"sName\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_to_with_(\"is_Nil\",\"smalltalk\",\"contents\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"error:\",\"smalltalk\",(function()\r\nreturn ((self):call_with_(\"self.String\",(function()\r\nreturn ((self):expr_plus_(\"\\\"Missing file \\\"\",\"sName\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_(\"fileIn\",\"contents\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"fileWriteStSystemDictionary",0
,function(self)
(self):with_as_do_((function()
return ((self):call_withArguments_("open",(smalltalk.Array):with_with_((function()
return ((self):send_with_("handleOf","fileName"))
end),(function()
return ((self):send_with_("handleOf","mode"))
end))))
end),"f",(function()
return ((self):send_to_with_("write","f",(function()
return ((self):call_withArguments_("bytes",(smalltalk.Array):with_with_with_((function()
return ((self):send_with_("handleOf","contents"))
end),"encoding=\"utf8\"","errors=\"ignore\"")))
end)))
end));
return (self);
end
,"api","fileWriteStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself with: [self call: #open withArguments: (Array\r\n\t\twith: [self send: #handleOf with: #fileName]\r\n\t\twith: [self send: #handleOf with: #mode])\r\n\t] as: #f do: [\r\n\t\tself send: #write to: #f with: [\r\n\t\t\tself call: #bytes withArguments: (Array\r\n\t\t\t\twith: [self send: #handleOf with: #contents]\r\n\t\t\t\twith: 'encoding=\"utf8\"'\r\n\t\t\t\twith: 'errors=\"ignore\"')\r\n\t\t]\r\n\t]","function(self)\r\n(self):with_as_do_((function()\r\nreturn ((self):call_withArguments_(\"open\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):send_with_(\"handleOf\",\"fileName\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"handleOf\",\"mode\"))\r\nend))))\r\nend),\"f\",(function()\r\nreturn ((self):send_to_with_(\"write\",\"f\",(function()\r\nreturn ((self):call_withArguments_(\"bytes\",(smalltalk.Array):with_with_with_((function()\r\nreturn ((self):send_with_(\"handleOf\",\"contents\"))\r\nend),\"encoding=\\\"utf8\\\"\",\"errors=\\\"ignore\\\"\")))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"fnInSpecStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):call_with_("print",(function()
return ((self):expr_plus_("\"OBSOLETE - fnInSpec \"","spec.className"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):send_("obsolete");
return (self);
end
,"api","fnInSpecStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself call: #print with: [self\r\n\t\texpr: '\"OBSOLETE - fnInSpec \"'\r\n\t\tplus: 'spec.className'];cr.\r\n\tself send: #obsolete ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"print\",(function()\r\nreturn ((self):expr_plus_(\"\\\"OBSOLETE - fnInSpec \\\"\",\"spec.className\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"fn_OfStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"klass", "\"$fn\"", "nil"})))
end));
return (self);
end
,"api","fn_OfStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self call: #getattr withArguments: #(klass '\"$fn\"' #nil)] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"klass\", \"\\\"$fn\\\"\", \"nil\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"folderContentsStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):import_("os");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("filename",(function()
return ((self):send_with_("handleOf","fileName"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):send_with_("newArray","[]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("each",(function()
return ((self):call_with_("os.listdir","filename"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("fullName",(function()
return ((self):call_withArguments_("os.path.join",smalltalk:newArray({"filename", "each"})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_else_((function()
return ((self):call_with_("os.path.isdir","fullName"))
end),(function()
return ((self):send_to_with_("add:","result",(function()
return ((self):send_with_("newArray","[\"folder\",0,each]"))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("fSize",(function()
return ((self):call_with_("os.path.getsize","fullName"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):send_to_with_("add:","result",(function()
return ((self):send_with_("newArray","[\"file\",fSize,each]"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"api","folderContentsStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself import: #os;cr.\r\n\tself assign: #filename to: [self send: #handleOf with: #fileName];cr.\r\n\tself assign: #result to: [self send: #newArray with: '[]'];cr.\r\n\tself for: #each in: [self call: 'os.listdir' with: #filename] do: [\r\n\t\tself assign: #fullName to: [self call: 'os.path.join' withArguments: #(filename each)];cr.\r\n\t\tself if: [self call: 'os.path.isdir' with: #fullName] do: [\r\n\t\t\tself send: #add: to: #result with: [\r\n\t\t\t\tself send: #newArray with: '[\"folder\",0,each]'\r\n\t\t\t]\r\n\t\t] else: [\r\n\t\t\tself assign: #fSize to: [self call: 'os.path.getsize' with: #fullName];cr.\r\n\t\t\tself send: #add: to: #result with: [\r\n\t\t\t\tself send: #newArray with: '[\"file\",fSize,each]'\r\n\t\t\t]\r\n\t\t]\r\n\t];cr.\r\n\tself return: #result ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):import_(\"os\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"filename\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"fileName\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):send_with_(\"newArray\",\"[]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"each\",(function()\r\nreturn ((self):call_with_(\"os.listdir\",\"filename\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"fullName\",(function()\r\nreturn ((self):call_withArguments_(\"os.path.join\",smalltalk:newArray({\"filename\", \"each\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_else_((function()\r\nreturn ((self):call_with_(\"os.path.isdir\",\"fullName\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"add:\",\"result\",(function()\r\nreturn ((self):send_with_(\"newArray\",\"[\\\"folder\\\",0,each]\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"fSize\",(function()\r\nreturn ((self):call_with_(\"os.path.getsize\",\"fullName\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_to_with_(\"add:\",\"result\",(function()\r\nreturn ((self):send_with_(\"newArray\",\"[\\\"file\\\",fSize,each]\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"from_import_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("hLibName",(function()
return ((self):send_with_("handleOf","libraryName"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("hName",(function()
return ((self):send_with_("handleOf","aName"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_((function()
return ((self):send_with_("__f__",(function()
return ((self):sum_(smalltalk:newArray({"\"():from \"", "hLibName", "\" import \"", "hName", "\"; return \"", "hName"})))
end)))
end)))
end));
return (self);
end
,"api","from_import_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #hLibName to: [self send: #handleOf with: #libraryName];cr.\r\n\tself assign: #hName to: [self send: #handleOf with: #aName];cr.\r\n\tself return: [self call: [\r\n\t\tself send: #__f__ with: [self sum: #(\r\n\t\t\t'\"():from \"' hLibName\r\n\t\t\t'\" import \"' hName\r\n\t\t\t'\"; return \"' hName)]]]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"hLibName\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"libraryName\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"hName\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"aName\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_((function()\r\nreturn ((self):send_with_(\"__f__\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"\\\"():from \\\"\", \"hLibName\", \"\\\" import \\\"\", \"hName\", \"\\\"; return \\\"\", \"hName\"})))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"globalsDoStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):for_in_do_("k","self.__dict__",(function()
return ((self):if_do_((function()
return ((self):send_to_("isupper","k[0]"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("aValue",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self", "k", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):expr_and_((function()
return ((self):call_with_("callable",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aValue", "\"isClass\"", "nil"})))
end)))
end),(function()
return ((self):expr_is_((function()
return ((self):send_to_("isClass","aValue"))
end),"self.false"))
end)))
end),(function()
return ((self):call_with_("action",(function()
return ((self):call_with_("self.String","k"))
end)))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("self");
return (self);
end
,"api","globalsDoStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself for: #k in: 'self.__dict__' do: [\r\n\t\tself if: [self send: #isupper to: 'k[0]'] do: [\r\n\t\t\tself assign: #aValue to: [self call: #getattr withArguments: #(self k #nil)];cr.\r\n\t\t\tself if: [self expr: [\r\n\t\t\t\tself call: #callable with: [\r\n\t\t\t\tself call: #getattr withArguments: #(aValue '\"isClass\"' #nil)]\r\n\t\t\t\t] and: [self expr: [self send: #isClass to: #aValue] is: 'self.false']]\r\n\t\t\t\tdo: [self call: #action with: [self call: 'self.String' with: #k]]\r\n\t\t]\r\n\t];cr.\r\n\tself return: #self ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"k\",\"self.__dict__\",(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):send_to_(\"isupper\",\"k[0]\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"aValue\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self\", \"k\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):call_with_(\"callable\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aValue\", \"\\\"isClass\\\"\", \"nil\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):send_to_(\"isClass\",\"aValue\"))\r\nend),\"self.false\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):call_with_(\"action\",(function()\r\nreturn ((self):call_with_(\"self.String\",\"k\"))\r\nend)))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"haltStObject",0
,function(self)
(self):comment_("import pdb; pdb.set_trace()");
(self):return_("self");
return (self);
end
,"api","haltStObject\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'import pdb; pdb.set_trace()'.\r\n\tself return: #self ","function(self)\r\n(self):comment_(\"import pdb; pdb.set_trace()\");\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"handleOfStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"anObject", "\"@handle\"", "anObject"})))
end));
return (self);
end
,"api","handleOfStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self call: #getattr withArguments: #(anObject '\"@handle\"' anObject)] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"anObject\", \"\\\"@handle\\\"\", \"anObject\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"handleOf_or_StSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"anObject", "\"@handle\"", "default"})))
end));
return (self);
end
,"api","handleOf_or_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self call: #getattr withArguments: #(anObject '\"@handle\"' default)] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"anObject\", \"\\\"@handle\\\"\", \"default\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"handleStObject",0
,function(self)
(self):return_((function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self", "\"@handle\"", "nil"})))
end));
return (self);
end
,"api","handleStObject\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self call: #getattr withArguments: #(self '\"@handle\"' #nil)] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self\", \"\\\"@handle\\\"\", \"nil\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"hashedSet_privateAdd_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("k",(function()
return ((self):call_with_("str",(function()
return ((self):send_to_with_("handleOf","smalltalk","cookie"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):assign_to_("getattr(aSet,\"@hash\")[k]","cookie");
return (self);
end
,"api","hashedSet_privateAdd_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #k to: [self call: #str with: [\r\n\t\tself send: #handleOf to: #smalltalk with: #cookie\r\n\t]];cr.\r\n\tself assign: 'getattr(aSet,\"@hash\")[k]' to: #cookie ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"k\",(function()\r\nreturn ((self):call_with_(\"str\",(function()\r\nreturn ((self):send_to_with_(\"handleOf\",\"smalltalk\",\"cookie\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):assign_to_(\"getattr(aSet,\\\"@hash\\\")[k]\",\"cookie\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"hashedSet_privateRemove_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("contents",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aSet", "\"@contents\""})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("remotion",smalltalk:newArray({"each"}),(function()
return ((self):if_do_((function()
return ((self):send_to_withArguments_("isObject_equalTo","smalltalk",smalltalk:newArray({"each", "cookie"})))
end),(function()
(
function(_s8_rec)
	(_s8_rec):send_to_with_("remove:","contents","each");
	return ((_s8_rec):cr())
end
)(self);return ((self):raise_((function()
return ((self):call_with_("Exception","\"done\""))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("k",(function()
return ((self):call_with_("str",(function()
return ((self):send_to_with_("handleOf","smalltalk","cookie"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_to_withArguments_("pop",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aSet", "\"@hash\""})))
end),smalltalk:newArray({"k", "None"}));
	return ((_s8_rec):cr())
end
)(self);
(self):try_except_as_doing_((function()
return ((self):send_to_with_("do:","contents",(function()
return ((self):send_to_withArguments_("blk","smalltalk",smalltalk:newArray({"remotion", "1"})))
end)))
end),"Exception","ex",(function()
return ((self):pass())
end));
return (self);
end
,"api","hashedSet_privateRemove_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #contents to: [self call: #getattr withArguments: #(aSet '\"@contents\"')];cr.\r\n\tself implementFunction: #remotion arguments: #(each) doing: [\r\n\t\tself if: [self send: #isObject_equalTo to: #smalltalk withArguments: #(each cookie)] do: [\r\n\t\t\tself send: #remove: to: #contents with: #each;cr.\r\n\t\t\tself raise: [self call: #Exception with: '\"done\"']\r\n\t\t]\r\n\t];cr.\r\n\tself assign: #k to: [self call: #str with: [self send: #handleOf to: #smalltalk with: #cookie]];cr.\r\n\tself send: #pop\r\n\t\tto: [self call: #getattr withArguments: #(aSet '\"@hash\"')]\r\n\t\twithArguments: #(k None) ;cr.\r\n\tself try: [\r\n\t\tself send: #do: to: #contents with: [\r\n\t\t\tself send: #blk to: #smalltalk withArguments: #(remotion #1)\r\n\t\t]\r\n\t] except: #Exception as: #ex doing: [self pass]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"contents\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aSet\", \"\\\"@contents\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"remotion\",smalltalk:newArray({\"each\"}),(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):send_to_withArguments_(\"isObject_equalTo\",\"smalltalk\",smalltalk:newArray({\"each\", \"cookie\"})))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_with_(\"remove:\",\"contents\",\"each\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):raise_((function()\r\nreturn ((self):call_with_(\"Exception\",\"\\\"done\\\"\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"k\",(function()\r\nreturn ((self):call_with_(\"str\",(function()\r\nreturn ((self):send_to_with_(\"handleOf\",\"smalltalk\",\"cookie\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_withArguments_(\"pop\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aSet\", \"\\\"@hash\\\"\"})))\r\nend),smalltalk:newArray({\"k\", \"None\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):try_except_as_doing_((function()\r\nreturn ((self):send_to_with_(\"do:\",\"contents\",(function()\r\nreturn ((self):send_to_withArguments_(\"blk\",\"smalltalk\",smalltalk:newArray({\"remotion\", \"1\"})))\r\nend)))\r\nend),\"Exception\",\"ex\",(function()\r\nreturn ((self):pass())\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"httpContentsStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("filename",(function()
return ((self):send_with_("handleOf","fileName"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):import_("urllib.request");
	return ((_s8_rec):cr())
end
)(self);
(self):with_as_do_((function()
return ((self):call_with_("urllib.request.urlopen","filename"))
end),"f",(function()
return ((self):return_((function()
return ((self):call_with_("self.String",(function()
return ((self):send_to_withArguments_("decode",(function()
return ((self):send_to_("read","f"))
end),smalltalk:newArray({"\"utf-8\"", "errors=\"ignore\""})))
end)))
end)))
end));
return (self);
end
,"api","httpContentsStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #filename to: [self send: #handleOf with: #fileName];cr.\r\n\tself import: 'urllib.request';cr.\r\n\tself with: [ self call: 'urllib.request.urlopen' with: #filename] as: #f do: [\r\n\t\tself return: [self call: 'self.String' with: [\r\n\t\t\tself send: #decode to: [self send: #read to: #f]\r\n\t\t\t\twithArguments: #('\"utf-8\"' 'errors=\"ignore\"')\r\n\t\t]]\r\n\t]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"filename\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"fileName\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):import_(\"urllib.request\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):with_as_do_((function()\r\nreturn ((self):call_with_(\"urllib.request.urlopen\",\"filename\"))\r\nend),\"f\",(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):call_with_(\"self.String\",(function()\r\nreturn ((self):send_to_withArguments_(\"decode\",(function()\r\nreturn ((self):send_to_(\"read\",\"f\"))\r\nend),smalltalk:newArray({\"\\\"utf-8\\\"\", \"errors=\\\"ignore\\\"\"})))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"ifUndefined_do_StSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):send_with_("is_Nil","receiver"))
end),(function()
return ((self):send_with_("callBlock0:","aBlock"))
end));
(self):return_("receiver");
return (self);
end
,"api","ifUndefined_do_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self send: #is_Nil with: #receiver]\r\n\t\treturn: [self send: #callBlock0: with: #aBlock].\r\n\tself return: #receiver ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"receiver\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"callBlock0:\",\"aBlock\"))\r\nend));\r\n(self):return_(\"receiver\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"if_nil_notNil_StSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):send_with_("is_Nil","anObject"))
end),(function()
return ((self):send_with_("callBlock0:","block1"))
end));
(self):return_((function()
return ((self):send_with_("callBlock0:","block2"))
end));
return (self);
end
,"api","if_nil_notNil_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self send: #is_Nil with: #anObject]\r\n\t\treturn: [self send: #callBlock0: with: #block1].\r\n\tself return: [self send: #callBlock0: with: #block2] ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"anObject\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"callBlock0:\",\"block1\"))\r\nend));\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"callBlock0:\",\"block2\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"if_true_false_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):send_with_("b","aBoolean"))
end),(function()
return ((self):if_return_((function()
return ((self):send_with_("not_Nil","blk1"))
end),(function()
return ((self):send_with_("callBlock0:","blk1"))
end)))
end),(function()
return ((self):if_return_((function()
return ((self):send_with_("not_Nil","blk2"))
end),(function()
return ((self):send_with_("callBlock0:","blk2"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("nil");
return (self);
end
,"api","if_true_false_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self send: #b with: #aBoolean] do: [\r\n\t\tself if: [self send: #not_Nil with: #blk1]\r\n\t\t\treturn: [self send: #callBlock0: with: #blk1]\r\n\t] else: [\r\n\t\tself if: [self send: #not_Nil with: #blk2]\r\n\t\t\treturn: [self send: #callBlock0: with: #blk2]\r\n\t];cr.\r\n\tself return: #nil ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):send_with_(\"b\",\"aBoolean\"))\r\nend),(function()\r\nreturn ((self):if_return_((function()\r\nreturn ((self):send_with_(\"not_Nil\",\"blk1\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"callBlock0:\",\"blk1\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):if_return_((function()\r\nreturn ((self):send_with_(\"not_Nil\",\"blk2\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"callBlock0:\",\"blk2\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"nil\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"import_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("hName",(function()
return ((self):send_with_("handleOf","libraryName"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_((function()
return ((self):send_with_("__f__",(function()
return ((self):sum_(smalltalk:newArray({"\"():import \"", "hName", "\"; return \"", "hName"})))
end)))
end)))
end));
return (self);
end
,"api","import_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #hName to: [self send: #handleOf with: #libraryName];cr.\r\n\tself return: [self call: [self send: #__f__\r\n\t\twith: [self sum: #('\"():import \"' hName '\"; return \"' hName)]]]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"hName\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"libraryName\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_((function()\r\nreturn ((self):send_with_(\"__f__\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"\\\"():import \\\"\", \"hName\", \"\\\"; return \\\"\", \"hName\"})))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"instVarAtStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("key",(function()
return ((self):sum_(smalltalk:newArray({"\"$\"", "ivName"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"object", "key"})))
end),(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"object", "key"})))
end));
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"object", "\"@handle\""})))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("h",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"object", "\"@handle\""})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("h[key]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("default");
return (self);
end
,"api","instVarAtStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #key to: [self sum: #('\"$\"' ivName)];cr.\r\n\tself if: [self call: #hasattr withArguments: #(object key)]\r\n\t\treturn: [self call: #getattr withArguments: #(object key)].\r\n\tself if: [self call: #hasattr withArguments: #(object '\"@handle\"')] do: [\r\n\t\tself assign: #h to: [self call: #getattr withArguments: #(object '\"@handle\"')];cr.\r\n\t\tself return: 'h[key]'\r\n\t];cr.\r\n\tself return: #default ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"key\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"\\\"$\\\"\", \"ivName\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"object\", \"key\"})))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"object\", \"key\"})))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"object\", \"\\\"@handle\\\"\"})))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"object\", \"\\\"@handle\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"h[key]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"default\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"invalidMessage_StSystemDictionary",0
,function(self)
(self):raise_((function()
return ((self):call_with_("Exception",(function()
return ((self):sum_((smalltalk.Array):with_with_("\"Invalid message #\"",(function()
return ((self):call_with_("str",(function()
return ((self):send_with_("handleOf","msg"))
end)))
end))))
end)))
end));
return (self);
end
,"api","invalidMessage_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself raise: [self call: #Exception with: [self sum: (Array\r\n\t\twith: '\"Invalid message #\"'\r\n\t\twith: [self call: #str with: [self send: #handleOf with: #msg]])\r\n\t]]","function(self)\r\n(self):raise_((function()\r\nreturn ((self):call_with_(\"Exception\",(function()\r\nreturn ((self):sum_((smalltalk.Array):with_with_(\"\\\"Invalid message #\\\"\",(function()\r\nreturn ((self):call_with_(\"str\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"msg\"))\r\nend)))\r\nend))))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"isArray_equalToStSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):expr_is_("table1","table2"))
end),"True");
(self):return_((function()
return ((self):expr_eqeq_((function()
return ((self):send_withArguments_("handleOf:or:",smalltalk:newArray({"table1", "1"})))
end),(function()
return ((self):send_withArguments_("handleOf:or:",smalltalk:newArray({"table2", "2"})))
end)))
end));
return (self);
end
,"api","isArray_equalToStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: #table1 is: #table2] return: #True.\r\n\tself return: [self\r\n\t\texpr: [self send: #handleOf:or: withArguments: #(table1 #1)]\r\n\t\teqeq: [self send: #handleOf:or: withArguments: #(table2 #2)]\r\n\t] ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):expr_is_(\"table1\",\"table2\"))\r\nend),\"True\");\r\n(self):return_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):send_withArguments_(\"handleOf:or:\",smalltalk:newArray({\"table1\", \"1\"})))\r\nend),(function()\r\nreturn ((self):send_withArguments_(\"handleOf:or:\",smalltalk:newArray({\"table2\", \"2\"})))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"isBoolean_StSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("b:",(function()
return ((self):expr_is_((function()
return ((self):call_with_("type",(function()
return ((self):send_with_("handleOf","receiver"))
end)))
end),"bool"))
end)))
end));
return (self);
end
,"api","isBoolean_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #b: with: [\r\n\t\tself expr: [self call: #type with: [self send: #handleOf with: #receiver]]\r\n\t\t\tis: #bool\r\n\t]] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"b:\",(function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):call_with_(\"type\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend)))\r\nend),\"bool\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"isFileOlderThanStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):try_except_as_doing_((function()
(
function(_s8_rec)
	(_s8_rec):import_("os");
	return ((_s8_rec):cr())
end
)(self);return ((self):if_return_((function()
return ((self):expr_lt_((function()
return ((self):call_with_("os.path.getmtime",(function()
return ((self):send_with_("handleOf","fileName"))
end)))
end),(function()
return ((self):call_with_("os.path.getmtime",(function()
return ((self):send_with_("handleOf","referenceFileName"))
end)))
end)))
end),"self.true"))
end),"FileNotFoundError","ex",(function()
(self):comment_("print(ex)");return ((self):pass())
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("self.false");
return (self);
end
,"api","isFileOlderThanStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself try: [\r\n\t\tself import: #os;cr.\r\n\t\tself if: [self expr: [self call: 'os.path.getmtime'\r\n\t\t\t\twith: [self send: #handleOf with: #fileName]]\r\n\t\t\tlt: [self call: 'os.path.getmtime'\r\n\t\t\t\twith: [self send: #handleOf with: #referenceFileName]]]\r\n\t\t\treturn: 'self.true'\r\n\t] except: #FileNotFoundError as: #ex doing: [\r\n\t\tself comment: 'print(ex)'.\r\n\t\tself pass\r\n\t];cr.\r\n\tself return: 'self.false' ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):try_except_as_doing_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):import_(\"os\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_return_((function()\r\nreturn ((self):expr_lt_((function()\r\nreturn ((self):call_with_(\"os.path.getmtime\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"fileName\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):call_with_(\"os.path.getmtime\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"referenceFileName\"))\r\nend)))\r\nend)))\r\nend),\"self.true\"))\r\nend),\"FileNotFoundError\",\"ex\",(function()\r\n(self):comment_(\"print(ex)\");return ((self):pass())\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"self.false\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"isNil_StSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("b:",(function()
return ((self):send_with_("is_Nil","aValue"))
end)))
end));
return (self);
end
,"api","isNil_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #b: with: [self send: #is_Nil with: #aValue]] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"b:\",(function()\r\nreturn ((self):send_with_(\"is_Nil\",\"aValue\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"isObjectStSystemDictionary",0
,function(self)
(self):comment_("return isinstance(anObject,StObject)");
(self):if_return_((function()
return ((self):call_withArguments_("isinstance",smalltalk:newArray({"anObject", "StObject"})))
end),"True");
(self):return_((function()
return ((self):send_withArguments_("responds_to",smalltalk:newArray({"anObject", "\"yourself\""})))
end));
return (self);
end
,"api","isObjectStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'return isinstance(anObject,StObject)'.\r\n\tself if: [self call: #isinstance withArguments: #(anObject StObject)]\r\n\t\treturn: #True.\r\n\tself return: [self send: #responds_to withArguments: #(anObject '\"yourself\"')] ","function(self)\r\n(self):comment_(\"return isinstance(anObject,StObject)\");\r\n(self):if_return_((function()\r\nreturn ((self):call_withArguments_(\"isinstance\",smalltalk:newArray({\"anObject\", \"StObject\"})))\r\nend),\"True\");\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"responds_to\",smalltalk:newArray({\"anObject\", \"\\\"yourself\\\"\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"isObject_eqeqStSystemDictionary",0
,function(self)
(self):comment_("OBSOLETE");
(self):if_return_((function()
return ((self):expr_is_("receiver","anObject"))
end),"True");
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):expr_or_((function()
return ((self):send_with_("is_Nil","receiver"))
end),(function()
return ((self):send_with_("is_Nil","anObject"))
end)))
end),(function()
return ((self):expr_and_((function()
return ((self):send_with_("is_Nil","receiver"))
end),(function()
return ((self):send_with_("is_Nil","anObject"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):expr_is_((function()
return ((self):send_with_("handleOf","receiver"))
end),(function()
return ((self):send_with_("handleOf","anObject"))
end)))
end));
return (self);
end
,"api","isObject_eqeqStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: #OBSOLETE.\r\n\tself if: [self expr: #receiver is: #anObject] return: #True.\r\n\tself if: [self expr: [self send: #is_Nil with: #receiver]\r\n\t\tor: [self send: #is_Nil with: #anObject]]\r\n\t\treturn: [self expr: [self send: #is_Nil with: #receiver]\r\n\t\t\tand: [self send: #is_Nil with: #anObject]];cr.\r\n\tself return: [self\r\n\t\texpr: [self send: #handleOf with: #receiver]\r\n\t\tis: [self send: #handleOf with: #anObject]] ","function(self)\r\n(self):comment_(\"OBSOLETE\");\r\n(self):if_return_((function()\r\nreturn ((self):expr_is_(\"receiver\",\"anObject\"))\r\nend),\"True\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"receiver\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"is_Nil\",\"anObject\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"receiver\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"is_Nil\",\"anObject\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"handleOf\",\"anObject\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"isObject_eqeq_StSystemDictionary",0
,function(self)
(self):comment_("OBSOLETE");
(self):return_((function()
return ((self):send_with_("b:",(function()
return ((self):send_withArguments_("isObject_eqeq",smalltalk:newArray({"receiver", "anObject"})))
end)))
end));
return (self);
end
,"api","isObject_eqeq_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: #OBSOLETE.\r\n\tself return: [self send: #b: with: [self\r\n\t\tsend: #isObject_eqeq\r\n\t\twithArguments: #(receiver anObject)]] ","function(self)\r\n(self):comment_(\"OBSOLETE\");\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"b:\",(function()\r\nreturn ((self):send_withArguments_(\"isObject_eqeq\",smalltalk:newArray({\"receiver\", \"anObject\"})))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"isObject_equalToStSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):expr_is_("receiver","anObject"))
end),"True");
(self):if_return_((function()
return ((self):expr_or_((function()
return ((self):send_with_("is_Nil","receiver"))
end),(function()
return ((self):send_with_("is_Nil","anObject"))
end)))
end),(function()
return ((self):expr_and_((function()
return ((self):send_with_("is_Nil","receiver"))
end),(function()
return ((self):send_with_("is_Nil","anObject"))
end)))
end));
(
function(_s8_rec)
	(_s8_rec):assign_to_("h1",(function()
return ((self):send_with_("handleOf","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("h2",(function()
return ((self):send_with_("handleOf","anObject"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_or_((function()
return ((self):expr_noteq_("h1","nil"))
end),(function()
return ((self):expr_noteq_("h2","nil"))
end)))
end),(function()
return ((self):if_do_((function()
return ((self):expr_eqeq_("h1","h2"))
end),(function()
(self):if_return_((function()
return ((self):expr_and_((function()
return ((self):send_with_("is_Number","h1"))
end),(function()
return ((self):send_with_("is_Number","h2"))
end)))
end),"True");(self):if_return_((function()
return ((self):expr_noteq_((function()
return ((self):call_with_("type","h1"))
end),(function()
return ((self):call_with_("type","h2"))
end)))
end),"False");return ((self):return_("True"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):send_withArguments_("responds_to",smalltalk:newArray({"receiver", "\"_eq\""})))
end),(function()
return ((self):expr_is_((function()
return ((self):send_to_with_("=","receiver","anObject"))
end),"self.true"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_return_((function()
return ((self):send_withArguments_("responds_to",smalltalk:newArray({"anObject", "\"_eq\""})))
end),(function()
return ((self):expr_is_((function()
return ((self):send_to_with_("=","anObject","receiver"))
end),"self.true"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("False");
return (self);
end
,"api","isObject_equalToStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: #receiver is: #anObject] return: #True.\r\n\tself if: [self expr: [self send: #is_Nil with: #receiver]\r\n\t\tor: [self send: #is_Nil with: #anObject]]\r\n\t\treturn: [self expr: [self send: #is_Nil with: #receiver]\r\n\t\t\tand: [self send: #is_Nil with: #anObject]].\r\n\tself assign: #h1 to: [self send: #handleOf with: #receiver];cr.\r\n\tself assign: #h2 to: [self send: #handleOf with: #anObject];cr.\r\n\tself if: [self expr: [self expr: #h1 noteq: #nil]\r\n\t\tor: [self expr: #h2 noteq: #nil]] do: [\r\n\t\tself if: [self expr: #h1 eqeq: #h2] do: [\r\n\t\t\tself if: [self expr: [self send: #is_Number with: #h1]\r\n\t\t\t\tand: [self send: #is_Number with: #h2]]\r\n\t\t\t\treturn: #True.\r\n\t\t\tself if: [self expr: [self call: #type with: #h1]\r\n\t\t\t\tnoteq: [self call: #type with: #h2]]\r\n\t\t\t\treturn: #False.\r\n\t\t\tself return: #True\r\n\t\t]\r\n\t];cr.\r\n\tself if: [self send: #responds_to withArguments: #(receiver '\"_eq\"')]\r\n\t\treturn: [self expr: [self send: #= to: #receiver with: #anObject]\r\n\t\t\tis: 'self.true'];cr.\r\n\tself if: [self send: #responds_to withArguments: #(anObject '\"_eq\"')]\r\n\t\treturn: [self expr: [self send: #= to: #anObject with: #receiver]\r\n\t\t\tis: 'self.true'];cr.\r\n\tself return: #False ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):expr_is_(\"receiver\",\"anObject\"))\r\nend),\"True\");\r\n(self):if_return_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"receiver\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"is_Nil\",\"anObject\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"receiver\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"is_Nil\",\"anObject\"))\r\nend)))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h1\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h2\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"anObject\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_noteq_(\"h1\",\"nil\"))\r\nend),(function()\r\nreturn ((self):expr_noteq_(\"h2\",\"nil\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"h1\",\"h2\"))\r\nend),(function()\r\n(self):if_return_((function()\r\nreturn ((self):expr_and_((function()\r\nreturn ((self):send_with_(\"is_Number\",\"h1\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"is_Number\",\"h2\"))\r\nend)))\r\nend),\"True\");(self):if_return_((function()\r\nreturn ((self):expr_noteq_((function()\r\nreturn ((self):call_with_(\"type\",\"h1\"))\r\nend),(function()\r\nreturn ((self):call_with_(\"type\",\"h2\"))\r\nend)))\r\nend),\"False\");return ((self):return_(\"True\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):send_withArguments_(\"responds_to\",smalltalk:newArray({\"receiver\", \"\\\"_eq\\\"\"})))\r\nend),(function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):send_to_with_(\"=\",\"receiver\",\"anObject\"))\r\nend),\"self.true\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_return_((function()\r\nreturn ((self):send_withArguments_(\"responds_to\",smalltalk:newArray({\"anObject\", \"\\\"_eq\\\"\"})))\r\nend),(function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):send_to_with_(\"=\",\"anObject\",\"receiver\"))\r\nend),\"self.true\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"False\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"isObject_equalTo_StSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("b:",(function()
return ((self):send_withArguments_("isObject_equalTo",smalltalk:newArray({"receiver", "anObject"})))
end)))
end));
return (self);
end
,"api","isObject_equalTo_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #b: with: [self\r\n\t\tsend: #isObject_equalTo\r\n\t\twithArguments: #(receiver anObject)]]","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"b:\",(function()\r\nreturn ((self):send_withArguments_(\"isObject_equalTo\",smalltalk:newArray({\"receiver\", \"anObject\"})))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"is_NilStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):expr_or_((function()
return ((self):expr_is_("aValue","nil"))
end),(function()
return ((self):expr_is_("aValue","None"))
end)))
end));
return (self);
end
,"api","is_NilStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self expr: [self expr: #aValue is: #nil]\r\n\t\tor: [self expr: #aValue is: #None]] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_is_(\"aValue\",\"nil\"))\r\nend),(function()\r\nreturn ((self):expr_is_(\"aValue\",\"None\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"is_NumberStSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):expr_is_((function()
return ((self):call_with_("type","x"))
end),"bool"))
end),"False");
(self):return_((function()
return ((self):call_withArguments_("isinstance",smalltalk:newArray({"x", "(int,float)"})))
end));
return (self);
end
,"api","is_NumberStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: [self call: #type with: #x] is: #bool] return: #False.\r\n\tself return: [self call: #isinstance withArguments: #(x '(int,float)')] ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):call_with_(\"type\",\"x\"))\r\nend),\"bool\"))\r\nend),\"False\");\r\n(self):return_((function()\r\nreturn ((self):call_withArguments_(\"isinstance\",smalltalk:newArray({\"x\", \"(int,float)\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"is_kindOf_StSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):not_((function()
return ((self):call_withArguments_("isinstance",smalltalk:newArray({"aClass", "(type,tuple)"})))
end)))
end),"self.false");
(self):if_return_((function()
return ((self):call_withArguments_("isinstance",smalltalk:newArray({"anObject", "aClass"})))
end),"self.true");
(self):return_((function()
return ((self):send_to_with_("isKindOf:","anObject","aClass"))
end));
return (self);
end
,"api","is_kindOf_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self not: [self call: #isinstance withArguments: #(aClass '(type,tuple)')]]\r\n\t\treturn: 'self.false'.\r\n\tself if: [self call: #isinstance withArguments: #(anObject aClass)]\r\n\t\treturn: 'self.true'.\r\n\tself return: [self send: #isKindOf: to: #anObject with: #aClass] ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):call_withArguments_(\"isinstance\",smalltalk:newArray({\"aClass\", \"(type,tuple)\"})))\r\nend)))\r\nend),\"self.false\");\r\n(self):if_return_((function()\r\nreturn ((self):call_withArguments_(\"isinstance\",smalltalk:newArray({\"anObject\", \"aClass\"})))\r\nend),\"self.true\");\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"isKindOf:\",\"anObject\",\"aClass\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"klassStObject",0
,function(self)
(self):return_("self.__class__");
return (self);
end
,"api","klassStObject\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: 'self.__class__' ","function(self)\r\n(self):return_(\"self.__class__\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"klassStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):call_with_("print",(function()
return ((self):sum_(smalltalk:newArray({"\"OBSOLETE - klass \"", "spec.className"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):send_("obsolete");
return (self);
end
,"api","klassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself call: #print with: [self sum: #('\"OBSOLETE - klass \"' 'spec.className')];cr.\r\n\tself send: #obsolete ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"print\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"\\\"OBSOLETE - klass \\\"\", \"spec.className\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"launchImageStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("self.useManager","True");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("not_Nil","imageName"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"self", "\"$imageFileName\"", "imageName"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):call_with_("load","imageName"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("state:","\"launching\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):call_with_("callable",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self", "\"launch\"", "nil"})))
end)))
end),(function()
return ((self):send_("launch"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("state:","\"running\"");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("self");
return (self);
end
,"api","launchImageStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: 'self.useManager' to: #True;cr.\r\n\tself if: [self send: #not_Nil with: #imageName] do: [\r\n\t\tself call: #setattr withArguments: #(self '\"$imageFileName\"' imageName);cr.\r\n\t\tself call: #load with: #imageName\r\n\t];cr.\r\n\tself send: #state: with: '\"launching\"';cr.\r\n\tself if: [self call: #callable with: [\r\n\t\tself call: #getattr withArguments: #(self '\"launch\"' #nil)]] do: [\r\n\t\tself send: #launch\r\n\t];cr.\r\n\tself send: #state: with: '\"running\"';cr.\r\n\tself return: #self ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self.useManager\",\"True\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"not_Nil\",\"imageName\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"self\", \"\\\"$imageFileName\\\"\", \"imageName\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):call_with_(\"load\",\"imageName\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"state:\",\"\\\"launching\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):call_with_(\"callable\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self\", \"\\\"launch\\\"\", \"nil\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_(\"launch\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"state:\",\"\\\"running\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"linkNative_to_StSystemDictionary",0
,function(self)
(self):comment_("link native species of instance to delegate to aClass implementation");
(self):send_("obsolete");
return (self);
end
,"api","linkNative_to_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'link native species of instance to delegate to aClass implementation'.\r\n\tself send: #obsolete ","function(self)\r\n(self):comment_(\"link native species of instance to delegate to aClass implementation\");\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"linkNativesStSystemDictionary",0
,function(self)
(self):comment_("--bind the native linkings");
(
function(_s8_rec)
	(_s8_rec):import_("sys");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_to_with_("setrecursionlimit","sys","10**6");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):import_("math");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self.math","math");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self.true",(function()
return ((self):call_with_("self.Boolean","True"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("self.false",(function()
return ((self):call_with_("self.Boolean","False"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("makeCallable:","self.BlockClosure");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("makeStringable:","self.String");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"self.Object.__class__", "\"$superclass\"", "self.Class"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"self.Metaclass.__class__", "\"@instanceClass\"", "self.Metaclass"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"self", "\"OverwriteMethods\""})))
end)))
end),(function()
return ((self):assign_to_("self.OverwriteMethods","self.true"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):not_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"self", "\"DumpOverwritenMethods\""})))
end)))
end),(function()
return ((self):assign_to_("self.DumpOverwritenMethods","self.false"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("True");
return (self);
end
,"api","linkNativesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: '--bind the native linkings'.\r\n\tself import: #sys;cr.\r\n\tself send: #setrecursionlimit to: #sys with: '10**6';cr.\r\n\tself import: #math;cr.\r\n\tself assign: 'self.math' to: #math;cr.\r\n\tself assign: 'self.true' to: [self call: 'self.Boolean' with: #True];cr.\r\n\tself assign: 'self.false' to: [self call: 'self.Boolean' with: #False];cr.\r\n\tself send: #makeCallable: with: 'self.BlockClosure';cr.\r\n\tself send: #makeStringable: with: 'self.String';cr.\r\n\tself call: #setattr withArguments: #('self.Object.__class__' '\"$superclass\"' 'self.Class');cr.\r\n\tself call: #setattr withArguments: #('self.Metaclass.__class__' '\"@instanceClass\"' 'self.Metaclass');cr.\r\n\tself if: [self not: [self call: #hasattr withArguments: #(self '\"OverwriteMethods\"')]] do: [\r\n\t\tself assign: 'self.OverwriteMethods' to: 'self.true'\r\n\t];cr.\r\n\tself if: [self not: [self call: #hasattr withArguments: #(self '\"DumpOverwritenMethods\"')]] do: [\r\n\t\tself assign: 'self.DumpOverwritenMethods' to: 'self.false'\r\n\t];cr.\r\n\tself return: #True ","function(self)\r\n(self):comment_(\"--bind the native linkings\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):import_(\"sys\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_with_(\"setrecursionlimit\",\"sys\",\"10**6\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):import_(\"math\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self.math\",\"math\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self.true\",(function()\r\nreturn ((self):call_with_(\"self.Boolean\",\"True\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"self.false\",(function()\r\nreturn ((self):call_with_(\"self.Boolean\",\"False\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"makeCallable:\",\"self.BlockClosure\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"makeStringable:\",\"self.String\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"self.Object.__class__\", \"\\\"$superclass\\\"\", \"self.Class\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"self.Metaclass.__class__\", \"\\\"@instanceClass\\\"\", \"self.Metaclass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"self\", \"\\\"OverwriteMethods\\\"\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"self.OverwriteMethods\",\"self.true\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"self\", \"\\\"DumpOverwritenMethods\\\"\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"self.DumpOverwritenMethods\",\"self.false\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"True\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"linkRouteStSystemDictionary",0
,function(self)
(self):comment_("Boot - Extend lookup on classes");
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("lookup",smalltalk:newArray({"self", "item"}),(function()
(self):if_return_((function()
return ((self):expr_or_((function()
return ((self):expr_or_((function()
return ((self):expr_eqeq_("item[0:2]","\"__\""))
end),(function()
return ((self):expr_eqeq_("item[0]","\"$\""))
end)))
end),(function()
return ((self):expr_eqeq_("item[0]","\"@\""))
end)))
end),(function()
return ((self):send_to_with_("__getattribute__",(function()
return ((self):call_withArguments_("super",smalltalk:newArray({"receiver", "self"})))
end),"item"))
end));(self):comment_("print(\"[info]\"+str(self)+\"@\"+item)");(
function(_s8_rec)
	(_s8_rec):try_except_as_doing_((function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):send_to_with_("__getattribute__",(function()
return ((self):call_withArguments_("super",smalltalk:newArray({"receiver", "self"})))
end),"item"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):comment_("print(\"[info]local@\"+item) #,result.__method__.src())"))
end),"AttributeError","ex",(function()
(self):comment_("print(\"[info]missing@\",item)");return ((self):assign_to_("result","None"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("implementor","nil");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("delegate",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"smalltalk", "parent", "None"})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_("result",(function()
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_is_("delegate","self"))
end),(function()
(self):comment_("print(\"[info]exit \",delegate)");return ((self):return_((function()
return ((self):send_to_with_("__get__","result","self"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("mth",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"result", "\"__method__\"", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);(self):if_return_((function()
return ((self):send_to_with_("is_Nil","smalltalk","mth"))
end),(function()
return ((self):send_to_with_("__get__","result","self"))
end));(
function(_s8_rec)
	(_s8_rec):assign_to_("implementor",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"mth", "\"@classField\"", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);(self):comment_("print(\"[info]implementor=\",implementor)");(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_or_((function()
return ((self):expr_is_("implementor","self"))
end),(function()
return ((self):send_to_with_("b","smalltalk",(function()
return ((self):send_to_("isClass","implementor"))
end)))
end)))
end),(function()
(self):comment_("print(\"[info] instance method - IGNORED\")");return ((self):assign_to_("implementor","nil"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):expr_or_((function()
return ((self):expr_or_((function()
return ((self):expr_is_("implementor","smalltalk.Object"))
end),(function()
return ((self):expr_is_("implementor","smalltalk.Metaclass"))
end)))
end),(function()
return ((self):expr_is_("implementor","smalltalk.Behavior"))
end)))
end),(function()
(self):comment_("print(\"[info] abstract implementor - IGNORED\")");return ((self):assign_to_("implementor","nil"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_is_("implementor","nil"))
end),(function()
(self):comment_("print(\"[info]as\",parent)");return ((self):if_do_((function()
return ((self):send_to_with_("not_Nil","smalltalk","delegate"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("delegate",(function()
return ((self):call_with_("delegate","nil"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("citem",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"delegate", "item", "None"})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):call_with_("callable","citem"))
end),(function()
(self):comment_("print(\"[info]@\"+item+\" as \"+parent)");(self):comment_("print(\"[info]calling\",citem.__func__.__method__.src())");return ((self):return_((function()
return ((self):send_to_with_("__get__","citem.__func__","self"))
end)))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):assign_to_("delegate","self.__class__");
	return ((_s8_rec):cr())
end
)(self);(self):comment_("print(\"[cls] lookup \"+delegate.__name__+\"@\",item,\"implementor=\",implementor)");(
function(_s8_rec)
	(_s8_rec):assign_to_("citem",(function()
return ((self):send_to_withArguments_("lookup:in:","delegate",smalltalk:newArray({"item", "self"})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):call_with_("callable","citem"))
end),(function()
(self):comment_("print(\"[cls]\"+delegate.__name__+\"@\"+item)");(self):comment_("print(\"[cls]calling\",citem.__func__.__method__.src())");return ((self):return_("citem"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_("result",(function()
(self):comment_("print(\"[info]result@\"+item)");return ((self):return_((function()
return ((self):send_to_with_("__get__","result","self"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):raise_((function()
return ((self):call_with_("AttributeError",smalltalk:object_comma_((smalltalk:object_comma_(("\"%s has no attribute %s. \""),"%"))," (self.__class__.__name__,item)")))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"receiver", "\"__getattribute__\"", "lookup"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("removeItem",smalltalk:newArray({"self", "item"}),(function()
(self):comment_("print(\"[info]-delitem[\",item,\"] on \",self)");(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_or_((function()
return ((self):expr_eqeq_("item[0]","\"$\""))
end),(function()
return ((self):expr_eqeq_("item[0]","\"@\""))
end)))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("old",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self", "item", "None"})))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_("old",(function()
return ((self):call_withArguments_("delattr",smalltalk:newArray({"self", "item"})))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("old"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_((function()
return ((self):send_to_with_("__delitem__",(function()
return ((self):call_withArguments_("super",smalltalk:newArray({"receiver", "self"})))
end),"item"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):call_withArguments_("setattr",smalltalk:newArray({"receiver", "\"__delitem__\"", "removeItem"}));
return (self);
end
,"api","linkRouteStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Boot - Extend lookup on classes'.\r\n\tself implementFunction: #lookup arguments: #(self item) doing: [\r\n\t\tself if: [self expr: \r\n\t\t\t[self expr: [self expr: 'item[0:2]' eqeq: '\"__\"']\r\n\t\t\t\tor: [self expr: 'item[0]' eqeq: '\"$\"']]\r\n\t\t\tor: [self expr: 'item[0]' eqeq: '\"@\"']\r\n\t\t] return: [self send: #__getattribute__\r\n\t\t\t\tto: [self call: #super withArguments: #(receiver self)]\r\n\t\t\t\twith: #item].\r\n\t\tself comment: 'print(\"[info]\"+str(self)+\"@\"+item)'.\r\n\t\tself try: [\r\n\t\t\tself assign: #result to: [self send: #__getattribute__\r\n\t\t\t\tto: [self call: #super withArguments: #(receiver self)]\r\n\t\t\t\twith: #item];cr.\r\n\t\t\tself comment: 'print(\"[info]local@\"+item) #,result.__method__.src())'\r\n\t\t] except: #AttributeError as: #ex doing: [\r\n\t\t\tself comment: 'print(\"[info]missing@\",item)'.\r\n\t\t\tself assign: #result to: #None\r\n\t\t];cr.\r\n\t\tself assign: #implementor to: #nil;cr.\r\n\t\tself assign: #delegate to: [self\r\n\t\t\tcall: #getattr\r\n\t\t\twithArguments: #(smalltalk parent None)\r\n\t\t];cr.\r\n\t\tself if: #result do: [\r\n\r\n\t\t\tself if: [self expr: #delegate is: #self] do: [\r\n\t\t\t\tself comment: 'print(\"[info]exit \",delegate)'.\r\n\t\t\t\tself return: [self send: #__get__ to: #result with: #self]\r\n\t\t\t];cr.\r\n\t\t\tself assign: #mth to: [\r\n\t\t\t\tself call: #getattr withArguments: #(result '\"__method__\"' #nil)\r\n\t\t\t];cr.\r\n\t\t\tself if: [self send: #is_Nil to: #smalltalk with: #mth]\r\n\t\t\t\treturn: [self send: #__get__ to: #result with: #self].\r\n\t\t\tself assign: #implementor to: [\r\n\t\t\t\tself call: #getattr withArguments: #(mth '\"@classField\"' #nil)\r\n\t\t\t];cr.\r\n\t\t\tself comment: 'print(\"[info]implementor=\",implementor)'.\r\n\t\t\tself if: [self expr: [self expr: #implementor is: #self]\r\n\t\t\t\tor: [self send: #b to: #smalltalk with: [\r\n\t\t\t\t\tself send: #isClass to: #implementor]]] do: [\r\n\t\t\t\tself comment: 'print(\"[info] instance method - IGNORED\")'.\r\n\t\t\t\tself assign: #implementor to: #nil\r\n\t\t\t];cr.\r\n\t\t\tself if: [self expr: [self\r\n\t\t\t\t\texpr: [self expr: #implementor is: 'smalltalk.Object']\r\n\t\t\t\t\tor: [self expr: #implementor is: 'smalltalk.Metaclass']]\r\n\t\t\t\tor: [self expr: #implementor is: 'smalltalk.Behavior']] do: [\r\n\t\t\t\tself comment: 'print(\"[info] abstract implementor - IGNORED\")'.\r\n\t\t\t\tself assign: #implementor to: #nil\r\n\t\t\t]\r\n\t\t];cr.\r\n\t\tself if: [self expr: #implementor is: #nil] do: [\r\n\t\t\tself comment: 'print(\"[info]as\",parent)'.\r\n\t\t\tself if: [self send: #not_Nil to: #smalltalk with: #delegate] do: [\r\n\t\t\t\tself assign: #delegate to: [self call: #delegate with: #nil];cr.\r\n\t\t\t\tself assign: #citem to: [self call: #getattr\r\n\t\t\t\t\twithArguments: #(delegate item None)];cr.\r\n\t\t\t\tself if: [self call: #callable with: #citem] do: [\r\n\t\t\t\t\tself comment: 'print(\"[info]@\"+item+\" as \"+parent)'.\r\n\t\t\t\t\tself comment: 'print(\"[info]calling\",citem.__func__.__method__.src())'.\r\n\t\t\t\t\tself return: [self send: #__get__ to: 'citem.__func__' with: #self]\r\n\t\t\t\t]\r\n\t\t\t]\r\n\t\t];cr.\r\n\t\tself assign: #delegate to: 'self.__class__';cr.\r\n\t\tself comment: 'print(\"[cls] lookup \"+delegate.__name__+\"@\",item,\"implementor=\",implementor)'.\r\n\t\tself assign: #citem to: [self send: #lookup:in: to: #delegate withArguments: #(item self)];cr.\r\n\t\tself if: [self call: #callable with: #citem] do: [\r\n\t\t\tself comment: 'print(\"[cls]\"+delegate.__name__+\"@\"+item)'.\r\n\t\t\tself comment: 'print(\"[cls]calling\",citem.__func__.__method__.src())'.\r\n\t\t\tself return: #citem\r\n\t\t];cr.\r\n\t\tself if: #result do: [\r\n\t\t\tself comment: 'print(\"[info]result@\"+item)'.\r\n\t\t\tself return: [self send: #__get__ to: #result with: #self]\r\n\t\t];cr.\r\n\t\tself raise: [self call: #AttributeError with: '\"%s has no attribute %s. \"'\r\n\t\t\t,$% ,' (self.__class__.__name__,item)']\r\n\t];cr.\r\n\tself call: #setattr withArguments: #(receiver '\"__getattribute__\"' lookup);cr.\r\n\tself implementFunction: #removeItem arguments: #(self item) doing: [\r\n\t\tself comment: 'print(\"[info]-delitem[\",item,\"] on \",self)'.\r\n\t\tself if: [self expr: [self expr: 'item[0]' eqeq: '\"$\"']\r\n\t\t\tor: [self expr: 'item[0]' eqeq: '\"@\"']] do: [\r\n\t\t\t\tself assign: #old to: [self call: #getattr withArguments: #(self item None)];cr.\r\n\t\t\t\tself if: #old do: [self call: #delattr withArguments: #(self item)];cr.\r\n\t\t\t\tself return: #old\r\n\t\t];cr.\r\n\t\tself return: [self send: #__delitem__ to: [\r\n\t\t\tself call: #super withArguments: #(receiver self)\r\n\t\t\t] with: #item]\r\n\t];cr.\r\n\tself call: #setattr withArguments: #(receiver '\"__delitem__\"' removeItem) ","function(self)\r\n(self):comment_(\"Boot - Extend lookup on classes\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"lookup\",smalltalk:newArray({\"self\", \"item\"}),(function()\r\n(self):if_return_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_eqeq_(\"item[0:2]\",\"\\\"__\\\"\"))\r\nend),(function()\r\nreturn ((self):expr_eqeq_(\"item[0]\",\"\\\"$\\\"\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):expr_eqeq_(\"item[0]\",\"\\\"@\\\"\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"__getattribute__\",(function()\r\nreturn ((self):call_withArguments_(\"super\",smalltalk:newArray({\"receiver\", \"self\"})))\r\nend),\"item\"))\r\nend));(self):comment_(\"print(\\\"[info]\\\"+str(self)+\\\"@\\\"+item)\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):try_except_as_doing_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):send_to_with_(\"__getattribute__\",(function()\r\nreturn ((self):call_withArguments_(\"super\",smalltalk:newArray({\"receiver\", \"self\"})))\r\nend),\"item\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):comment_(\"print(\\\"[info]local@\\\"+item) #,result.__method__.src())\"))\r\nend),\"AttributeError\",\"ex\",(function()\r\n(self):comment_(\"print(\\\"[info]missing@\\\",item)\");return ((self):assign_to_(\"result\",\"None\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"implementor\",\"nil\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"delegate\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"smalltalk\", \"parent\", \"None\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"result\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_is_(\"delegate\",\"self\"))\r\nend),(function()\r\n(self):comment_(\"print(\\\"[info]exit \\\",delegate)\");return ((self):return_((function()\r\nreturn ((self):send_to_with_(\"__get__\",\"result\",\"self\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"mth\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"result\", \"\\\"__method__\\\"\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):if_return_((function()\r\nreturn ((self):send_to_with_(\"is_Nil\",\"smalltalk\",\"mth\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"__get__\",\"result\",\"self\"))\r\nend));(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"implementor\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"mth\", \"\\\"@classField\\\"\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"print(\\\"[info]implementor=\\\",implementor)\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_is_(\"implementor\",\"self\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"b\",\"smalltalk\",(function()\r\nreturn ((self):send_to_(\"isClass\",\"implementor\"))\r\nend)))\r\nend)))\r\nend),(function()\r\n(self):comment_(\"print(\\\"[info] instance method - IGNORED\\\")\");return ((self):assign_to_(\"implementor\",\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_is_(\"implementor\",\"smalltalk.Object\"))\r\nend),(function()\r\nreturn ((self):expr_is_(\"implementor\",\"smalltalk.Metaclass\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):expr_is_(\"implementor\",\"smalltalk.Behavior\"))\r\nend)))\r\nend),(function()\r\n(self):comment_(\"print(\\\"[info] abstract implementor - IGNORED\\\")\");return ((self):assign_to_(\"implementor\",\"nil\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_is_(\"implementor\",\"nil\"))\r\nend),(function()\r\n(self):comment_(\"print(\\\"[info]as\\\",parent)\");return ((self):if_do_((function()\r\nreturn ((self):send_to_with_(\"not_Nil\",\"smalltalk\",\"delegate\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"delegate\",(function()\r\nreturn ((self):call_with_(\"delegate\",\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"citem\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"delegate\", \"item\", \"None\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):call_with_(\"callable\",\"citem\"))\r\nend),(function()\r\n(self):comment_(\"print(\\\"[info]@\\\"+item+\\\" as \\\"+parent)\");(self):comment_(\"print(\\\"[info]calling\\\",citem.__func__.__method__.src())\");return ((self):return_((function()\r\nreturn ((self):send_to_with_(\"__get__\",\"citem.__func__\",\"self\"))\r\nend)))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"delegate\",\"self.__class__\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):comment_(\"print(\\\"[cls] lookup \\\"+delegate.__name__+\\\"@\\\",item,\\\"implementor=\\\",implementor)\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"citem\",(function()\r\nreturn ((self):send_to_withArguments_(\"lookup:in:\",\"delegate\",smalltalk:newArray({\"item\", \"self\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):call_with_(\"callable\",\"citem\"))\r\nend),(function()\r\n(self):comment_(\"print(\\\"[cls]\\\"+delegate.__name__+\\\"@\\\"+item)\");(self):comment_(\"print(\\\"[cls]calling\\\",citem.__func__.__method__.src())\");return ((self):return_(\"citem\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"result\",(function()\r\n(self):comment_(\"print(\\\"[info]result@\\\"+item)\");return ((self):return_((function()\r\nreturn ((self):send_to_with_(\"__get__\",\"result\",\"self\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):raise_((function()\r\nreturn ((self):call_with_(\"AttributeError\",smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"%s has no attribute %s. \\\"\"),\"%\")),\" (self.__class__.__name__,item)\")))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"receiver\", \"\\\"__getattribute__\\\"\", \"lookup\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"removeItem\",smalltalk:newArray({\"self\", \"item\"}),(function()\r\n(self):comment_(\"print(\\\"[info]-delitem[\\\",item,\\\"] on \\\",self)\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_eqeq_(\"item[0]\",\"\\\"$\\\"\"))\r\nend),(function()\r\nreturn ((self):expr_eqeq_(\"item[0]\",\"\\\"@\\\"\"))\r\nend)))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"old\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self\", \"item\", \"None\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"old\",(function()\r\nreturn ((self):call_withArguments_(\"delattr\",smalltalk:newArray({\"self\", \"item\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"old\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_((function()\r\nreturn ((self):send_to_with_(\"__delitem__\",(function()\r\nreturn ((self):call_withArguments_(\"super\",smalltalk:newArray({\"receiver\", \"self\"})))\r\nend),\"item\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):call_withArguments_(\"setattr\",smalltalk:newArray({\"receiver\", \"\\\"__delitem__\\\"\", \"removeItem\"}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"makeCallable_StSystemDictionary",0
,function(self)
(self):comment_("implement callable protocoll for instances of aClass");
(
function(_s8_rec)
	(_s8_rec):assign_to_("st","self");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("callS8Callable",smalltalk:newArray({"self", "*args", "**kwargs"}),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("hBlock",(function()
return ((self):send_("handle"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_to_with_("is_Nil","st","hBlock"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("print",smalltalk:newArray({"\"Corrupted callable\"", "self"}));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_("nil"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):return_((function()
return ((self):call_withArguments_("hBlock",smalltalk:newArray({"*(st.arguments_toCall_(args,self))", "**kwargs"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):call_withArguments_("setattr",smalltalk:newArray({"aClass", "\"__call__\"", "callS8Callable"}));
return (self);
end
,"api","makeCallable_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'implement callable protocoll for instances of aClass'.\r\n\tself assign: #st to: #self;cr.\r\n\tself implementFunction: #callS8Callable arguments: #(self '*args' '**kwargs') doing: [\r\n\t\tself assign: #hBlock to: [self send: #handle];cr.\r\n\t\tself if: [self send: #is_Nil to: #st with: #hBlock] do: [\r\n\t\t\tself call: #print withArguments: #('\"Corrupted callable\"' self);cr.\r\n\t\t\tself return: #nil\r\n\t\t];cr.\r\n\t\tself return: [self call: #hBlock withArguments: #(\r\n\t\t\t'*(st.arguments_toCall_(args,self))'\r\n\t\t\t'**kwargs')]\r\n\t];cr.\r\n\tself call: #setattr withArguments: #(aClass '\"__call__\"' callS8Callable) ","function(self)\r\n(self):comment_(\"implement callable protocoll for instances of aClass\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"st\",\"self\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"callS8Callable\",smalltalk:newArray({\"self\", \"*args\", \"**kwargs\"}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"hBlock\",(function()\r\nreturn ((self):send_(\"handle\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_to_with_(\"is_Nil\",\"st\",\"hBlock\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"print\",smalltalk:newArray({\"\\\"Corrupted callable\\\"\", \"self\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_(\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):return_((function()\r\nreturn ((self):call_withArguments_(\"hBlock\",smalltalk:newArray({\"*(st.arguments_toCall_(args,self))\", \"**kwargs\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):call_withArguments_(\"setattr\",smalltalk:newArray({\"aClass\", \"\\\"__call__\\\"\", \"callS8Callable\"}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"makeStringable_StSystemDictionary",0
,function(self)
(self):comment_("implement string protocoll for instances of aClass");
(
function(_s8_rec)
	(_s8_rec):assign_to_("st","self");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):implementFunction_arguments_doing_("stringBlock",smalltalk:newArray({"self", "*args"}),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("h",(function()
return ((self):send_to_with_("handleOf","st","self"))
end));
	return ((_s8_rec):cr())
end
)(self);(self):if_return_((function()
return ((self):expr_is_((function()
return ((self):call_with_("type","h"))
end),"str"))
end),"h");return ((self):return_((function()
return ((self):send_to_with_("__str__",(function()
return ((self):call_("super"))
end),"self"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):call_withArguments_("setattr",smalltalk:newArray({"aClass", "\"__str__\"", "stringBlock"}));
return (self);
end
,"api","makeStringable_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'implement string protocoll for instances of aClass'.\r\n\tself assign: #st to: #self;cr.\r\n\tself implementFunction: #stringBlock arguments: #(self '*args') doing: [\r\n\t\tself assign: #h to: [self send: #handleOf to: #st with: #self];cr.\r\n\t\tself if: [self expr: [self call: #type with: #h] is: #str] return: #h.\r\n\t\tself return: [self send: #__str__ to: [self call: #super] with: #self]\r\n\t];cr.\r\n\tself call: #setattr withArguments: #(aClass '\"__str__\"' stringBlock) ","function(self)\r\n(self):comment_(\"implement string protocoll for instances of aClass\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"st\",\"self\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):implementFunction_arguments_doing_(\"stringBlock\",smalltalk:newArray({\"self\", \"*args\"}),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",(function()\r\nreturn ((self):send_to_with_(\"handleOf\",\"st\",\"self\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):if_return_((function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):call_with_(\"type\",\"h\"))\r\nend),\"str\"))\r\nend),\"h\");return ((self):return_((function()\r\nreturn ((self):send_to_with_(\"__str__\",(function()\r\nreturn ((self):call_(\"super\"))\r\nend),\"self\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):call_withArguments_(\"setattr\",smalltalk:newArray({\"aClass\", \"\\\"__str__\\\"\", \"stringBlock\"}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"mapClassNameStSystemDictionary",0
,function(self)
(self):comment_("Boot - Add a new class mapping to the system");
(self):comment_("print(\"mapClassName\",className)");
(
function(_s8_rec)
	(_s8_rec):assign_to_("mi","None");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):not_("superclass"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("mi",(function()
return ((self):call_withArguments_("type",(smalltalk.Array):with_with_with_((function()
return ((self):sum_(smalltalk:newArray({"className", "\"$info\""})))
end),"(type,)",(function()
return ((self):call_("dict"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):send_withArguments_("linkRoute",smalltalk:newArray({"mi", "\"Class\""}));
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("delegate","(mi,)"))
end),(function()
return ((self):assign_to_("delegate","(superclass.__class__,)"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("mc",(function()
return ((self):call_withArguments_("StMetaType",(smalltalk.Array):with_with_with_((function()
return ((self):sum_(smalltalk:newArray({"className", "\" class\""})))
end),"delegate",(function()
return ((self):object_((smalltalk.Array):with_(("\"$meta\""):_minus_gt("True"))))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):send_with_("is_Nil","superclass"))
end),(function()
return ((self):assign_to_("delegate","()"))
end),(function()
return ((self):assign_to_("delegate","(superclass,)"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("not_Nil","native"))
end),(function()
return ((self):if_do_else_((function()
return ((self):typeOf_is_("native","tuple"))
end),(function()
return ((self):assign_to_("delegate",(function()
return ((self):sum_(smalltalk:newArray({"delegate", "native"})))
end)))
end),(function()
return ((self):assign_to_("delegate",(function()
return ((self):sum_(smalltalk:newArray({"delegate", "(native,)"})))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("cls",(function()
return ((self):call_withArguments_("mc",(smalltalk.Array):with_with_with_("className","delegate",(function()
return ((self):object_((smalltalk.Array):with_(("\"$meta\""):_minus_gt("False"))))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",(smalltalk.Array):with_with_with_("mc","\"$className\"",(function()
return ((self):send_with_("stringOf","mc.__name__"))
end)));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"mc", "\"@instanceClass\"", "cls"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"mc", "\"@subclasses\"", "nil"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"mc", "\"$iVarNames\"", "[]"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",(smalltalk.Array):with_with_with_("mc","\"$methods\"",(function()
return ((self):call_("dict"))
end)));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("not_Nil","superclass"))
end),(function()
return ((self):call_withArguments_("setattr",smalltalk:newArray({"mc", "\"$superclass\"", "superclass.__class__"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",(smalltalk.Array):with_with_with_("cls","\"$className\"",(function()
return ((self):send_with_("stringOf","cls.__name__"))
end)));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"cls", "\"$category\"", "category"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"cls", "\"$superclass\"", "superclass"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"cls", "\"@subclasses\"", "nil"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",(smalltalk.Array):with_with_with_("cls","\"$methods\"",(function()
return ((self):call_("dict"))
end)));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"cls", "\"$comment\"", "nil"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"self", "className", "cls"}));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("cls");
return (self);
end
,"api","mapClassNameStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Boot - Add a new class mapping to the system'.\r\n\tself comment: 'print(\"mapClassName\",className)'.\r\n\tself assign: #mi to: #None;cr.\r\n\tself if: [self not: #superclass] do: [\r\n\t\tself assign: #mi to: [self call: #type\r\n\t\t\twithArguments: (Array\r\n\t\t\t\twith: [self sum: #(className '\"$info\"')]\r\n\t\t\t\twith: '(type,)'\r\n\t\t\t\twith: [self call: #dict])\r\n\t\t];cr.\r\n\t\tself send: #linkRoute withArguments: #(mi '\"Class\"');cr.\r\n\t\tself assign: #delegate to: '(mi,)'\r\n\t] else: [\r\n\t\tself assign: #delegate to: '(superclass.__class__,)'\r\n\t];cr.\r\n\tself assign: #mc to: [ self call: #StMetaType\r\n\t\twithArguments: (Array\r\n\t\t\twith: [self sum: #(className '\" class\"')]\r\n\t\t\twith: #delegate\r\n\t\t\twith: [self object: (Array with: '\"$meta\"' -> #True)])\r\n\t];cr.\r\n\tself if: [self send: #is_Nil with: #superclass] do: [\r\n\t\tself assign: #delegate to: '()'\r\n\t] else: [\tself assign: #delegate to: '(superclass,)'\r\n\t];cr.\r\n\tself if: [self send: #not_Nil with: #native] do: [\r\n\t\tself if: [self typeOf: #native is: #tuple] do: [\r\n\t\t\tself assign: #delegate to: [self sum: #(delegate native)]\r\n\t\t] else: [\r\n\t\t\tself assign: #delegate to: [self sum: #(delegate '(native,)')]\r\n\t] ];cr.\r\n\tself assign: #cls to: [self call: #mc\r\n\t\twithArguments: (Array\r\n\t\t\twith: #className with: #delegate\r\n\t\t\twith: [self object: (Array with: '\"$meta\"' -> #False)])\r\n\t];cr.\r\n\tself call: #setattr withArguments: (Array\r\n\t\twith: #mc with: '\"$className\"'\r\n\t\twith: [self send: #stringOf with: 'mc.__name__']);cr.\r\n\tself call: #setattr withArguments: #(mc '\"@instanceClass\"' cls);cr.\r\n\tself call: #setattr withArguments: #(mc '\"@subclasses\"' #nil);cr.\r\n\tself call: #setattr withArguments: #(mc '\"$iVarNames\"' '[]');cr.\r\n\tself call: #setattr withArguments: (Array\r\n\t\twith: #mc with: '\"$methods\"'\r\n\t\twith: [self call: #dict]);cr.\r\n\tself if: [self send: #not_Nil with: #superclass] do: [\r\n\t\tself call: #setattr withArguments: #(mc '\"$superclass\"' 'superclass.__class__')\r\n\t];cr.\r\n\tself call: #setattr withArguments: (Array\r\n\t\twith: #cls with: '\"$className\"'\r\n\t\twith: [self send: #stringOf with: 'cls.__name__']);cr.\r\n\tself call: #setattr withArguments: #(cls '\"$category\"' category);cr.\r\n\tself call: #setattr withArguments: #(cls '\"$superclass\"' superclass);cr.\r\n\tself call: #setattr withArguments: #(cls '\"@subclasses\"' #nil);cr.\r\n\tself call: #setattr withArguments: (Array\r\n\t\twith: #cls with: '\"$methods\"'\r\n\t\twith: [self call: #dict]);cr.\r\n\tself call: #setattr withArguments: #(cls '\"$comment\"' #nil);cr.\r\n\tself call: #setattr withArguments: #(self className cls);cr.\r\n\tself return: #cls ","function(self)\r\n(self):comment_(\"Boot - Add a new class mapping to the system\");\r\n(self):comment_(\"print(\\\"mapClassName\\\",className)\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"mi\",\"None\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):not_(\"superclass\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"mi\",(function()\r\nreturn ((self):call_withArguments_(\"type\",(smalltalk.Array):with_with_with_((function()\r\nreturn ((self):sum_(smalltalk:newArray({\"className\", \"\\\"$info\\\"\"})))\r\nend),\"(type,)\",(function()\r\nreturn ((self):call_(\"dict\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"linkRoute\",smalltalk:newArray({\"mi\", \"\\\"Class\\\"\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"delegate\",\"(mi,)\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"delegate\",\"(superclass.__class__,)\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"mc\",(function()\r\nreturn ((self):call_withArguments_(\"StMetaType\",(smalltalk.Array):with_with_with_((function()\r\nreturn ((self):sum_(smalltalk:newArray({\"className\", \"\\\" class\\\"\"})))\r\nend),\"delegate\",(function()\r\nreturn ((self):object_((smalltalk.Array):with_((\"\\\"$meta\\\"\"):_minus_gt(\"True\"))))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"superclass\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"delegate\",\"()\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"delegate\",\"(superclass,)\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"not_Nil\",\"native\"))\r\nend),(function()\r\nreturn ((self):if_do_else_((function()\r\nreturn ((self):typeOf_is_(\"native\",\"tuple\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"delegate\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"delegate\", \"native\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):assign_to_(\"delegate\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"delegate\", \"(native,)\"})))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"cls\",(function()\r\nreturn ((self):call_withArguments_(\"mc\",(smalltalk.Array):with_with_with_(\"className\",\"delegate\",(function()\r\nreturn ((self):object_((smalltalk.Array):with_((\"\\\"$meta\\\"\"):_minus_gt(\"False\"))))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",(smalltalk.Array):with_with_with_(\"mc\",\"\\\"$className\\\"\",(function()\r\nreturn ((self):send_with_(\"stringOf\",\"mc.__name__\"))\r\nend)));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"mc\", \"\\\"@instanceClass\\\"\", \"cls\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"mc\", \"\\\"@subclasses\\\"\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"mc\", \"\\\"$iVarNames\\\"\", \"[]\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",(smalltalk.Array):with_with_with_(\"mc\",\"\\\"$methods\\\"\",(function()\r\nreturn ((self):call_(\"dict\"))\r\nend)));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"not_Nil\",\"superclass\"))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"setattr\",smalltalk:newArray({\"mc\", \"\\\"$superclass\\\"\", \"superclass.__class__\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",(smalltalk.Array):with_with_with_(\"cls\",\"\\\"$className\\\"\",(function()\r\nreturn ((self):send_with_(\"stringOf\",\"cls.__name__\"))\r\nend)));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"cls\", \"\\\"$category\\\"\", \"category\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"cls\", \"\\\"$superclass\\\"\", \"superclass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"cls\", \"\\\"@subclasses\\\"\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",(smalltalk.Array):with_with_with_(\"cls\",\"\\\"$methods\\\"\",(function()\r\nreturn ((self):call_(\"dict\"))\r\nend)));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"cls\", \"\\\"$comment\\\"\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"self\", \"className\", \"cls\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"cls\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"math_max_StSystemDictionary",0
,function(self)
(self):send_("obsolete");
return (self);
end
,"api","math_max_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #obsolete ","function(self)\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"math_min_StSystemDictionary",0
,function(self)
(self):send_("obsolete");
return (self);
end
,"api","math_min_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #obsolete ","function(self)\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"metaVarNamesStSystemDictionary",0
,function(self)
(self):comment_("Boot - Set the instance variables of aMetaclass");
(self):if_return_((function()
return ((self):send_withArguments_("isArray_equalTo",(smalltalk.Array):with_with_((function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aMetaClass", "\"$iVarNames\"", "[]"})))
end),"iVarNames")))
end),"self.false");
(
function(_s8_rec)
	(_s8_rec):assign_to_("hArray",(function()
return ((self):send_with_("handleOf","iVarNames"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("is_Nil","hArray"))
end),(function()
return ((self):assign_to_("hArray","[]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("setVarNames",smalltalk:newArray({"aMetaClass", "hArray", "nil"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("classShapeChanged","aMetaClass");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("classChanged","aMetaClass");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("self.true");
return (self);
end
,"api","metaVarNamesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Boot - Set the instance variables of aMetaclass'.\r\n\tself if: [self send: #isArray_equalTo withArguments: (Array\r\n\t\twith: [self call: #getattr withArguments: #(aMetaClass '\"$iVarNames\"' '[]')]\r\n\t\twith: #iVarNames)] return: 'self.false'.\r\n\tself assign: #hArray to: [self send: #handleOf with: #iVarNames];cr.\r\n\tself if: [self send: #is_Nil with: #hArray] do: [\r\n\t\tself assign: #hArray to: '[]'\r\n\t];cr.\r\n\tself send: #setVarNames withArguments: #(aMetaClass hArray #nil);cr.\r\n\tself send: #classShapeChanged with: #aMetaClass;cr.\r\n\tself send: #classChanged with: #aMetaClass;cr.\r\n\tself return: 'self.true' ","function(self)\r\n(self):comment_(\"Boot - Set the instance variables of aMetaclass\");\r\n(self):if_return_((function()\r\nreturn ((self):send_withArguments_(\"isArray_equalTo\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aMetaClass\", \"\\\"$iVarNames\\\"\", \"[]\"})))\r\nend),\"iVarNames\")))\r\nend),\"self.false\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"hArray\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"iVarNames\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"hArray\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"hArray\",\"[]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"setVarNames\",smalltalk:newArray({\"aMetaClass\", \"hArray\", \"nil\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"classShapeChanged\",\"aMetaClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"classChanged\",\"aMetaClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"self.true\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"methodBoundToStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):lambda_expr_("sm",(function()
return ((self):send_to_withArguments_("methodBound:to:","sm",smalltalk:newArray({"method", "klass"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"api","methodBoundToStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self lambda: #sm expr: [\r\n\t\tself send: #methodBound:to: to: #sm withArguments: #(method klass)\r\n\t]];cr.\r\n\tself return: #method ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):lambda_expr_(\"sm\",(function()\r\nreturn ((self):send_to_withArguments_(\"methodBound:to:\",\"sm\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"methodRemovedFromStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):lambda_expr_("sm",(function()
return ((self):send_to_withArguments_("methodRemoved:from:","sm",smalltalk:newArray({"method", "klass"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("method");
return (self);
end
,"api","methodRemovedFromStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self lambda: #sm expr: [\r\n\t\tself send: #methodRemoved:from: to: #sm withArguments: #(method klass)\r\n\t]];cr.\r\n\tself return: #method ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):lambda_expr_(\"sm\",(function()\r\nreturn ((self):send_to_withArguments_(\"methodRemoved:from:\",\"sm\",smalltalk:newArray({\"method\", \"klass\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"method\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"methodStSystemDictionary",0
,function(self)
(self):comment_("OBSOLETE");
(self):return_((function()
return ((self):send_withArguments_("bind",smalltalk:object_comma_((smalltalk:newArray({"nil", "spec.selector", "nil", "spec.fn", "spec.category", "spec.source"})),(smalltalk.Array):with_with_((function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"spec", "\"$nativeSource\"", "nil"})))
end),(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"spec", "\"$stamp\"", "nil"})))
end)))))
end));
return (self);
end
,"api","methodStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: #OBSOLETE.\r\n\tself return: [self send: #bind withArguments:\r\n\t\t#(#nil 'spec.selector' #nil 'spec.fn' 'spec.category' 'spec.source')\r\n\t\t,(Array\r\n\t\t\twith: [self call: #getattr withArguments: #(spec '\"$nativeSource\"' #nil)]\r\n\t\t\twith: [self call: #getattr withArguments: #(spec '\"$stamp\"' #nil)])\r\n\t] ","function(self)\r\n(self):comment_(\"OBSOLETE\");\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"bind\",smalltalk:object_comma_((smalltalk:newArray({\"nil\", \"spec.selector\", \"nil\", \"spec.fn\", \"spec.category\", \"spec.source\"})),(smalltalk.Array):with_with_((function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"spec\", \"\\\"$nativeSource\\\"\", \"nil\"})))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"spec\", \"\\\"$stamp\\\"\", \"nil\"})))\r\nend)))))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"methods_OfStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("proto",(function()
return ((self):send_with_("prototype_Of","klass"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"proto", "\"$methods\"", "nil"})))
end));
return (self);
end
,"api","methods_OfStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #proto to: [self send: #prototype_Of with: #klass];cr.\r\n\tself return: [self call: #getattr withArguments: #(proto '\"$methods\"' #nil)] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"proto\",(function()\r\nreturn ((self):send_with_(\"prototype_Of\",\"klass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"proto\", \"\\\"$methods\\\"\", \"nil\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"moduleAtStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("result","object");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):try_except_as_doing_((function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("m",(function()
return ((self):send_with_("import:","module"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("result",(function()
return ((self):call_with_("getattr","m.field"))
end)))
end),"Exception","ex",(function()
return ((self):call_with_("print","ex"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"api","moduleAtStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #result to: #object;cr.\r\n\tself try: [\r\n\t\tself assign: #m to: [self send: #import: with: #module];cr.\r\n\t\tself assign: #result to: [self call: #getattr with: 'm.field']\r\n\t] except: #Exception as: #ex doing: [\r\n\t\tself call: #print with: #ex\r\n\t];cr.\r\n\tself return: #result","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",\"object\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):try_except_as_doing_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"m\",(function()\r\nreturn ((self):send_with_(\"import:\",\"module\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"result\",(function()\r\nreturn ((self):call_with_(\"getattr\",\"m.field\"))\r\nend)))\r\nend),\"Exception\",\"ex\",(function()\r\nreturn ((self):call_with_(\"print\",\"ex\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"mustBeNumber_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):from_import_("numbers","Number");
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):call_withArguments_("isinstance",(smalltalk.Array):with_with_((function()
return ((self):send_with_("handleOf","receiver"))
end),"Number")))
end),"receiver");
(self):return_((function()
return ((self):send_to_with_("error:","receiver",(function()
return ((self):send_with_("String","\"Must be a Number\""))
end)))
end));
return (self);
end
,"api","mustBeNumber_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself from: #numbers import: #Number;cr.\r\n\tself if: [self call: #isinstance withArguments: (Array\r\n\t\twith: [self send: #handleOf with: #receiver]\r\n\t\twith: #Number)] return: #receiver.\r\n\tself return: [self send: #error: to: #receiver\r\n\t\twith: [self send: #String with: '\"Must be a Number\"']] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):from_import_(\"numbers\",\"Number\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):call_withArguments_(\"isinstance\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend),\"Number\")))\r\nend),\"receiver\");\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"error:\",\"receiver\",(function()\r\nreturn ((self):send_with_(\"String\",\"\\\"Must be a Number\\\"\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"nativeCallStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("func","anObject");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("not_Nil","selector"))
end),(function()
return ((self):assign_to_("func",(function()
return ((self):call_withArguments_("getattr",(smalltalk.Array):with_with_("anObject",(function()
return ((self):send_with_("handleOf","selector"))
end))))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):send_with_("isObject","anObject"))
end),(function()
return ((self):call_with_("func","*args"))
end));
(
function(_s8_rec)
	(_s8_rec):assign_to_("handles","[]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("arg","args",(function()
return ((self):send_to_with_("append","handles",(function()
return ((self):send_with_("handleOf","arg"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):call_with_("func",(function()
return ((self):pointerTo_((function()
return ((self):call_with_("tuple","handles"))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_with_("asObject:","result"))
end));
return (self);
end
,"api","nativeCallStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #func to: #anObject;cr.\r\n\tself if: [self send: #not_Nil with: #selector] do: [\r\n\t\tself assign: #func to: [self call: #getattr\r\n\t\t\twithArguments: (Array with: #anObject\r\n\t\t\t\twith: [self send: #handleOf with: #selector])\r\n\t\t]\r\n\t];cr.\r\n\tself if: [self send: #isObject with: #anObject]\r\n\t\treturn: [self call: #func with: '*args'].\r\n\tself assign: #handles to: '[]';cr.\r\n\tself for: #arg in: #args do: [\r\n\t\tself send: #append to: #handles with: [\r\n\t\t\tself send: #handleOf with: #arg\r\n\t\t]\r\n\t];cr.\r\n\tself assign: #result to: [self call: #func with: [\r\n\t\tself pointerTo: [self call: #tuple with: #handles]]\r\n\t];cr.\r\n\tself return: [self send: #asObject: with: #result] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"func\",\"anObject\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"not_Nil\",\"selector\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"func\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",(smalltalk.Array):with_with_(\"anObject\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"selector\"))\r\nend))))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"isObject\",\"anObject\"))\r\nend),(function()\r\nreturn ((self):call_with_(\"func\",\"*args\"))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"handles\",\"[]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"arg\",\"args\",(function()\r\nreturn ((self):send_to_with_(\"append\",\"handles\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"arg\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):call_with_(\"func\",(function()\r\nreturn ((self):pointerTo_((function()\r\nreturn ((self):call_with_(\"tuple\",\"handles\"))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"asObject:\",\"result\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"newArrayStSystemDictionary",0
,function(self)
(self):comment_("return a new Array instance with contents in object");
(self):return_((function()
return ((self):send_with_("Array",(function()
return ((self):expr_or_("object","[]"))
end)))
end));
return (self);
end
,"api","newArrayStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'return a new Array instance with contents in object'.\r\n\tself return: [self send: #Array with: [self expr: #object or: '[]']] ","function(self)\r\n(self):comment_(\"return a new Array instance with contents in object\");\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"Array\",(function()\r\nreturn ((self):expr_or_(\"object\",\"[]\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"newConstructorStSystemDictionary",0
,function(self)
(self):comment_("return a new constructor of instances inheriting from superC (constructor)");
(self):comment_("superC can be nil to return a constructor for a root class");
(self):send_with_("invalidMessage:","\"newConstructor\"");
return (self);
end
,"api","newConstructorStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'return a new constructor of instances inheriting from superC (constructor)'.\r\n\tself comment: 'superC can be nil to return a constructor for a root class'.\r\n\tself send: #invalidMessage: with: '\"newConstructor\"' ","function(self)\r\n(self):comment_(\"return a new constructor of instances inheriting from superC (constructor)\");\r\n(self):comment_(\"superC can be nil to return a constructor for a root class\");\r\n(self):send_with_(\"invalidMessage:\",\"\\\"newConstructor\\\"\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"newContextStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):call_with_("StObject","nil"))
end));
return (self);
end
,"api","newContextStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self call: #StObject with: #nil] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"StObject\",\"nil\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"newHashStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):object_(smalltalk:newArray({})))
end));
return (self);
end
,"api","newHashStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self object: #()]","function(self)\r\n(self):return_((function()\r\nreturn ((self):object_(smalltalk:newArray({})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"newMethodStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_withArguments_("bind",smalltalk:newArray({"nil", "selector", "nil", "fn", "nil", "source", "nativeSource", "stamp"})))
end));
return (self);
end
,"api","newMethodStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #bind withArguments: #(\r\n\t\t#nil selector #nil fn #nil source\r\n\t\tnativeSource stamp)] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"bind\",smalltalk:newArray({\"nil\", \"selector\", \"nil\", \"fn\", \"nil\", \"source\", \"nativeSource\", \"stamp\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"niyStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):import_("inspect");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("text",(function()
return ((self):sum_(smalltalk:newArray({"\"NIY #\"", "inspect.stack()[1].function"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_with_("print","text");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("text");
return (self);
end
,"api","niyStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself import: #inspect;cr.\r\n\tself assign: #text to: [self sum: #(\r\n\t\t'\"NIY #\"' 'inspect.stack()[1].function'\r\n\t)];cr.\r\n\tself call: #print with: #text;cr.\r\n\tself return: #text ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):import_(\"inspect\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"text\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"\\\"NIY #\\\"\", \"inspect.stack()[1].function\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"print\",\"text\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"text\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"niy_StSystemDictionary",0
,function(self)
(self):call_with_("print",(function()
return ((self):sum_(smalltalk:newArray({"\"NIY #\"", "msg"})))
end));
return (self);
end
,"api","niy_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself call: #print with: [self sum: #('\"NIY #\"' msg)] ","function(self)\r\n(self):call_with_(\"print\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"\\\"NIY #\\\"\", \"msg\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"notNil_StSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("b:",(function()
return ((self):send_with_("not_Nil","aValue"))
end)))
end));
return (self);
end
,"api","notNil_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #b: with: [self send: #not_Nil with: #aValue]] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"b:\",(function()\r\nreturn ((self):send_with_(\"not_Nil\",\"aValue\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"not_NilStSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):expr_or_((function()
return ((self):expr_is_("aValue","nil"))
end),(function()
return ((self):expr_is_("aValue","None"))
end)))
end),"False");
(self):return_("True");
return (self);
end
,"api","not_NilStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: [self expr: #aValue is: #nil]\r\n\t\tor: [self expr: #aValue is: #None]]\r\n\t\treturn: #False.\r\n\tself return: #True ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):expr_or_((function()\r\nreturn ((self):expr_is_(\"aValue\",\"nil\"))\r\nend),(function()\r\nreturn ((self):expr_is_(\"aValue\",\"None\"))\r\nend)))\r\nend),\"False\");\r\n(self):return_(\"True\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"objectNotFoundStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("smDo",(function()
return ((self):lambda_expr_("sm",(function()
return ((self):send_to_withArguments_("object:at:notFoundIn:","sm",smalltalk:newArray({"object", "indexOrKey", "collection"})))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("collection");
return (self);
end
,"api","objectNotFoundStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #smDo with: [self lambda: #sm expr: [\r\n\t\tself send: #object:at:notFoundIn: to: #sm\r\n\t\t\twithArguments: #(object indexOrKey collection)\r\n\t]];cr.\r\n\tself return: #collection ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"smDo\",(function()\r\nreturn ((self):lambda_expr_(\"sm\",(function()\r\nreturn ((self):send_to_withArguments_(\"object:at:notFoundIn:\",\"sm\",smalltalk:newArray({\"object\", \"indexOrKey\", \"collection\"})))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"collection\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"object_comma_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("h1",(function()
return ((self):send_with_("handleOf","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("h2",(function()
return ((self):send_with_("handleOf","anObject"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_is_((function()
return ((self):call_with_("type","h1"))
end),"str"))
end),(function()
(self):if_return_((function()
return ((self):send_with_("is_Nil","anObject"))
end),(function()
return ((self):send_with_("String",(function()
return ((self):sum_(smalltalk:newArray({"h1", "\"\""})))
end)))
end));(self):if_return_((function()
return ((self):expr_is_((function()
return ((self):call_with_("type","h2"))
end),"str"))
end),(function()
return ((self):send_with_("String",(function()
return ((self):sum_(smalltalk:newArray({"h1", "h2"})))
end)))
end));(self):if_return_((function()
return ((self):send_with_("isObject","anObject"))
end),(function()
return ((self):send_with_("String",(function()
return ((self):sum_((smalltalk.Array):with_with_("h1",(function()
return ((self):send_with_("handleOf",(function()
return ((self):send_with_("to_String","anObject"))
end)))
end))))
end)))
end));return ((self):return_((function()
return ((self):send_with_("String",(function()
return ((self):sum_((smalltalk.Array):with_with_("h1",(function()
return ((self):call_with_("str","h2"))
end))))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):not_((function()
return ((self):send_with_("isObject","receiver"))
end)))
end),(function()
return ((self):send_with_with_("object:comma:",(function()
return ((self):send_with_("to_String","receiver"))
end),"anObject"))
end));
(self):return_((function()
return ((self):send_to_with_(",","receiver","anObject"))
end));
return (self);
end
,"api","object_comma_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #h1 to: [self send: #handleOf with: #receiver];cr.\r\n\tself assign: #h2 to: [self send: #handleOf with: #anObject];cr.\r\n\tself if: [self expr: [self call: #type with: #h1] is: #str] do: [\r\n\t\tself if: [self send: #is_Nil with: #anObject]\r\n\t\t\treturn: [self send: #String with: [self sum: #(h1 '\"\"')]].\r\n\t\tself if: [self expr: [self call: #type with: #h2] is: #str]\r\n\t\t\treturn: [self send: #String with: [self sum: #(h1 h2)]].\r\n\t\tself if: [self send: #isObject with: #anObject]\r\n\t\t\treturn: [self send: #String with: [self sum: (Array with: #h1 \r\n\t\t\t\twith: [self send: #handleOf with: [\r\n\t\t\t\t\tself send: #to_String with: #anObject\r\n\t\t\t\t]])]].\r\n\t\tself return: [self send: #String with: [\r\n\t\t\tself sum: (Array with: #h1 with: [\r\n\t\t\t\tself call: #str with: #h2])]]\r\n\t];cr.\r\n\tself if: [self not: [self send: #isObject with: #receiver]]\r\n\t\treturn: [self send: #object:comma:\r\n\t\t\twith: [self send: #to_String with: #receiver]\r\n\t\t\twith: #anObject].\r\n\tself return: [self send: #, to: #receiver with: #anObject] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h1\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h2\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"anObject\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):call_with_(\"type\",\"h1\"))\r\nend),\"str\"))\r\nend),(function()\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"anObject\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"String\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"h1\", \"\\\"\\\"\"})))\r\nend)))\r\nend));(self):if_return_((function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):call_with_(\"type\",\"h2\"))\r\nend),\"str\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"String\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"h1\", \"h2\"})))\r\nend)))\r\nend));(self):if_return_((function()\r\nreturn ((self):send_with_(\"isObject\",\"anObject\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"String\",(function()\r\nreturn ((self):sum_((smalltalk.Array):with_with_(\"h1\",(function()\r\nreturn ((self):send_with_(\"handleOf\",(function()\r\nreturn ((self):send_with_(\"to_String\",\"anObject\"))\r\nend)))\r\nend))))\r\nend)))\r\nend));return ((self):return_((function()\r\nreturn ((self):send_with_(\"String\",(function()\r\nreturn ((self):sum_((smalltalk.Array):with_with_(\"h1\",(function()\r\nreturn ((self):call_with_(\"str\",\"h2\"))\r\nend))))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):send_with_(\"isObject\",\"receiver\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_with_with_(\"object:comma:\",(function()\r\nreturn ((self):send_with_(\"to_String\",\"receiver\"))\r\nend),\"anObject\"))\r\nend));\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\",\",\"receiver\",\"anObject\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"objects_toCall_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("result","[]");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):for_in_do_("x",(function()
return ((self):send_with_("handleOf","anArray"))
end),(function()
return ((self):send_to_with_("append","result",(function()
return ((self):send_with_("asObject:","x"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"api","objects_toCall_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #result to: '[]';cr.\r\n\tself for: #x in: [self send: #handleOf with: #anArray] do: [\r\n\t\tself send: #append to: #result with: [\r\n\t\t\tself send: #asObject: with: #x\r\n\t\t]\r\n\t];cr.\r\n\tself return: #result ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",\"[]\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"x\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"anArray\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"append\",\"result\",(function()\r\nreturn ((self):send_with_(\"asObject:\",\"x\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"obsoleteStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):import_("inspect");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("text",(function()
return ((self):sum_(smalltalk:newArray({"\"OBSOLETE #\"", "inspect.stack()[1].function"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_with_("print","text");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("text");
return (self);
end
,"api","obsoleteStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself import: #inspect;cr.\r\n\tself assign: #text to: [self sum: #('\"OBSOLETE #\"' 'inspect.stack()[1].function')];cr.\r\n\tself call: #print with: #text;cr.\r\n\tself return: #text","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):import_(\"inspect\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"text\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"\\\"OBSOLETE #\\\"\", \"inspect.stack()[1].function\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"print\",\"text\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"text\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"outerFramesCountStSystemDictionary",0
,function(self)
(self):comment_("DEBUG");
(
function(_s8_rec)
	(_s8_rec):from_import_("inspect","getouterframes, currentframe");
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_with_("len",(function()
return ((self):call_with_("getouterframes",(function()
return ((self):call_("currentframe"))
end)))
end)))
end));
return (self);
end
,"api","outerFramesCountStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: #DEBUG.\r\n\tself from: #inspect import: 'getouterframes, currentframe';cr.\r\n\tself return: [self call: #len with: [\r\n\t\tself call: #getouterframes with: [\r\n\t\tself call: #currentframe]]] ","function(self)\r\n(self):comment_(\"DEBUG\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):from_import_(\"inspect\",\"getouterframes, currentframe\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"len\",(function()\r\nreturn ((self):call_with_(\"getouterframes\",(function()\r\nreturn ((self):call_(\"currentframe\"))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"pool_at_ifAbsent_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("h",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"pool", "\"@hash\""})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("k",(function()
return ((self):call_with_("str",(function()
return ((self):send_with_("handleOf","aKey"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):typeOf_is_("h","dict"))
end),(function()
return ((self):if_return_((function()
return ((self):expr_in_("k","h"))
end),(function()
return ((self):send_with_("asObject:","h[k]"))
end)))
end),(function()
return ((self):if_return_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"h", "k"})))
end),(function()
return ((self):send_with_("asObject:",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"h", "k"})))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("print(\"pool key=\",k,\"missing\") # in \",h)");
(self):if_return_((function()
return ((self):send_with_("is_Nil","aBlock"))
end),"nil");
(self):comment_("info = getattr(aBlock,\"$info\",\"no-info\")");
(self):if_return_((function()
return ((self):call_with_("callable","aBlock"))
end),(function()
return ((self):send_with_("callBlock0:","aBlock"))
end));
(self):return_((function()
return ((self):send_to_("evaluate","aBlock"))
end));
return (self);
end
,"api","pool_at_ifAbsent_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #h to: [self call: #getattr withArguments: #(pool '\"@hash\"')];cr.\r\n\tself assign: #k to: [self call: #str with: [self send: #handleOf with: #aKey]];cr.\r\n\tself if: [self typeOf: #h is: #dict] do: [\r\n\t\tself if: [self expr: #k in: #h]\r\n\t\t\treturn: [self send: #asObject: with: 'h[k]']\r\n\t] else: [\r\n\t\tself if: [self call: #hasattr withArguments: #(h k)]\r\n\t\t\treturn: [self send: #asObject: with: [\r\n\t\t\t\tself call: #getattr withArguments: #(h k)]]\r\n\t];cr.\r\n\tself comment: 'print(\"pool key=\",k,\"missing\") # in \",h)'.\r\n\tself if: [self send: #is_Nil with: #aBlock] return: #nil.\r\n\tself comment: 'info = getattr(aBlock,\"$info\",\"no-info\")'.\r\n\tself if: [self call: #callable with: #aBlock]\r\n\t\treturn: [self send: #callBlock0: with: #aBlock].\r\n\tself return: [self send: #evaluate to: #aBlock] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"pool\", \"\\\"@hash\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"k\",(function()\r\nreturn ((self):call_with_(\"str\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"aKey\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):typeOf_is_(\"h\",\"dict\"))\r\nend),(function()\r\nreturn ((self):if_return_((function()\r\nreturn ((self):expr_in_(\"k\",\"h\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"asObject:\",\"h[k]\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):if_return_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"h\", \"k\"})))\r\nend),(function()\r\nreturn ((self):send_with_(\"asObject:\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"h\", \"k\"})))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"print(\\\"pool key=\\\",k,\\\"missing\\\") # in \\\",h)\");\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"aBlock\"))\r\nend),\"nil\");\r\n(self):comment_(\"info = getattr(aBlock,\\\"$info\\\",\\\"no-info\\\")\");\r\n(self):if_return_((function()\r\nreturn ((self):call_with_(\"callable\",\"aBlock\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"callBlock0:\",\"aBlock\"))\r\nend));\r\n(self):return_((function()\r\nreturn ((self):send_to_(\"evaluate\",\"aBlock\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"pool_at_put_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("h",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"pool", "\"@hash\""})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("k",(function()
return ((self):call_with_("str",(function()
return ((self):send_with_("handleOf","aKey"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("v",(function()
return ((self):send_to_with_("wrap:","pool","aValue"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):typeOf_is_("h","dict"))
end),(function()
return ((self):assign_to_("h[k]","v"))
end),(function()
return ((self):call_withArguments_("setattr",smalltalk:newArray({"h", "k", "v"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("aValue");
return (self);
end
,"api","pool_at_put_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #h to: [self\r\n\t\tcall: #getattr withArguments: #(pool '\"@hash\"')\r\n\t];cr.\r\n\tself assign: #k to: [self call: #str with: [\r\n\t\tself send: #handleOf with: #aKey]\r\n\t];cr.\r\n\tself assign: #v to: [\r\n\t\tself send: #wrap: to: #pool with: #aValue\r\n\t];cr.\r\n\tself if: [self typeOf: #h is: #dict] do: [\r\n\t\tself assign: 'h[k]' to: #v\r\n\t] else: [\r\n\t\tself call: #setattr withArguments: #(h k v)\r\n\t];cr.\r\n\tself return: #aValue ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"pool\", \"\\\"@hash\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"k\",(function()\r\nreturn ((self):call_with_(\"str\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"aKey\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"v\",(function()\r\nreturn ((self):send_to_with_(\"wrap:\",\"pool\",\"aValue\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):typeOf_is_(\"h\",\"dict\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"h[k]\",\"v\"))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"setattr\",smalltalk:newArray({\"h\", \"k\", \"v\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"aValue\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"pool_includesKey_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("h",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"pool", "\"@hash\""})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("k",(function()
return ((self):call_with_("str",(function()
return ((self):send_with_("handleOf","aKey"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_else_((function()
return ((self):typeOf_is_("h","dict"))
end),(function()
return ((self):if_return_((function()
return ((self):expr_in_("k","h"))
end),"self.true"))
end),(function()
return ((self):if_return_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"h", "k"})))
end),"self.true"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("self.false");
return (self);
end
,"api","pool_includesKey_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #h to: [self call: #getattr withArguments: #(pool '\"@hash\"') ];cr.\r\n\tself assign: #k to: [self call: #str with: [self send: #handleOf with: #aKey]];cr.\r\n\tself if: [self typeOf: #h is: #dict] do: [\r\n\t\tself if: [self expr: #k in: #h] return: 'self.true'\r\n\t] else: [\r\n\t\tself if: [self call: #hasattr withArguments: #(h k)] return: 'self.true'\r\n\t];cr.\r\n\tself return: 'self.false' ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"pool\", \"\\\"@hash\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"k\",(function()\r\nreturn ((self):call_with_(\"str\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"aKey\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_else_((function()\r\nreturn ((self):typeOf_is_(\"h\",\"dict\"))\r\nend),(function()\r\nreturn ((self):if_return_((function()\r\nreturn ((self):expr_in_(\"k\",\"h\"))\r\nend),\"self.true\"))\r\nend),(function()\r\nreturn ((self):if_return_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"h\", \"k\"})))\r\nend),\"self.true\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"self.false\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"pool_keysStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("h",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"pool", "\"@hash\""})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):typeOf_is_("h","dict"))
end),(function()
return ((self):send_with_("newArray",(function()
return ((self):call_with_("list",(function()
return ((self):send_to_("keys","h"))
end)))
end)))
end));
(self):if_return_((function()
return ((self):typeOf_is_("h","list"))
end),(function()
return ((self):send_with_("newArray","h"))
end));
(
function(_s8_rec)
	(_s8_rec):assign_to_("h",(function()
return ((self):send_to_("keys","h.__dict__"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_with_("newArray",(function()
return ((self):call_with_("list","h"))
end)))
end));
return (self);
end
,"api","pool_keysStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #h to: [self call: #getattr withArguments: #(pool '\"@hash\"')];cr.\r\n\tself if: [self typeOf: #h is: #dict] return: [\r\n\t\tself send: #newArray with: [\r\n\t\t\tself call: #list with: [\r\n\t\t\t\tself send: #keys to: #h]]\r\n\t].\r\n\tself if: [self typeOf: #h is: #list] return: [self send: #newArray with: #h].\r\n\tself assign: #h to: [self send: #keys to: 'h.__dict__'];cr.\r\n\tself return: [self send: #newArray with: [self call: #list with: #h]] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"pool\", \"\\\"@hash\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):typeOf_is_(\"h\",\"dict\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"newArray\",(function()\r\nreturn ((self):call_with_(\"list\",(function()\r\nreturn ((self):send_to_(\"keys\",\"h\"))\r\nend)))\r\nend)))\r\nend));\r\n(self):if_return_((function()\r\nreturn ((self):typeOf_is_(\"h\",\"list\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"newArray\",\"h\"))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",(function()\r\nreturn ((self):send_to_(\"keys\",\"h.__dict__\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"newArray\",(function()\r\nreturn ((self):call_with_(\"list\",\"h\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"pool_removeKey_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("h",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"pool", "\"@hash\""})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("k",(function()
return ((self):call_with_("str",(function()
return ((self):send_with_("handleOf","aKey"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_do_else_((function()
return ((self):typeOf_is_("h","dict"))
end),(function()
return ((self):send_to_withArguments_("pop","h",smalltalk:newArray({"k", "nil"})))
end),(function()
return ((self):call_withArguments_("delattr",smalltalk:newArray({"h", "k"})))
end));
return (self);
end
,"api","pool_removeKey_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #h to: [\r\n\t\tself call: #getattr withArguments: #(pool '\"@hash\"')\r\n\t];cr.\r\n\tself assign: #k to: [\r\n\t\tself call: #str with: [self send: #handleOf with: #aKey]\r\n\t];cr.\r\n\tself if: [self typeOf: #h is: #dict] do: [\r\n\t\tself send: #pop to: #h withArguments: #(k #nil)\r\n\t] else: [ self call: #delattr withArguments: #(h k) ] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"h\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"pool\", \"\\\"@hash\\\"\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"k\",(function()\r\nreturn ((self):call_with_(\"str\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"aKey\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_do_else_((function()\r\nreturn ((self):typeOf_is_(\"h\",\"dict\"))\r\nend),(function()\r\nreturn ((self):send_to_withArguments_(\"pop\",\"h\",smalltalk:newArray({\"k\", \"nil\"})))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"delattr\",smalltalk:newArray({\"h\", \"k\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"printString_StSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):expr_is_("receiver.__class__","self.String"))
end),(function()
return ((self):send_with_("String",(function()
return ((self):sum_((smalltalk.Array):with_with_with_(smalltalk:object_comma_((smalltalk:object_comma_(("\""),"'")),"\""),(function()
return ((self):send_with_("handleOf","receiver"))
end),smalltalk:object_comma_((smalltalk:object_comma_(("\""),"'")),"\""))))
end)))
end));
(self):if_return_((function()
return ((self):send_withArguments_("responds_to",smalltalk:newArray({"receiver", "\"printString\""})))
end),(function()
return ((self):send_to_("printString","receiver"))
end));
(self):return_((function()
return ((self):send_with_("String",(function()
return ((self):call_with_("repr",(function()
return ((self):send_with_("handleOf","receiver"))
end)))
end)))
end));
return (self);
end
,"api","printString_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self expr: 'receiver.__class__' is: 'self.String']\r\n\t\treturn: [self send: #String with: [self sum: (Array\r\n\t\t\twith: $\",$',$\"\r\n\t\t\twith: [self send: #handleOf with: #receiver]\r\n\t\t\twith: $\",$',$\")]].\r\n\tself if: [self send: #responds_to withArguments: #(receiver '\"printString\"')]\r\n\t\treturn: [self send: #printString to: #receiver].\r\n\tself return: [self send: #String with: [\r\n\t\tself call: #repr with: [\r\n\t\t\tself send: #handleOf with: #receiver\r\n\t]]] ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):expr_is_(\"receiver.__class__\",\"self.String\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"String\",(function()\r\nreturn ((self):sum_((smalltalk.Array):with_with_with_(smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),\"'\")),\"\\\"\"),(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend),smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),\"'\")),\"\\\"\"))))\r\nend)))\r\nend));\r\n(self):if_return_((function()\r\nreturn ((self):send_withArguments_(\"responds_to\",smalltalk:newArray({\"receiver\", \"\\\"printString\\\"\"})))\r\nend),(function()\r\nreturn ((self):send_to_(\"printString\",\"receiver\"))\r\nend));\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"String\",(function()\r\nreturn ((self):call_with_(\"repr\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"prototype_OfStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("fn",(function()
return ((self):send_with_("fn_Of","klass"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):send_with_("is_Nil","fn"))
end),"klass");
(self):return_((function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"fn", "\"prototype\"", "nil"})))
end));
return (self);
end
,"api","prototype_OfStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #fn to: [self send: #fn_Of with: #klass];cr.\r\n\tself if: [self send: #is_Nil with: #fn] return: #klass.\r\n\tself return: [self call: #getattr withArguments: #(fn '\"prototype\"' #nil)] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"fn\",(function()\r\nreturn ((self):send_with_(\"fn_Of\",\"klass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"fn\"))\r\nend),\"klass\");\r\n(self):return_((function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"fn\", \"\\\"prototype\\\"\", \"nil\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"quitStSystemDictionary",0
,function(self)
(self):raise_("SystemExit");
return (self);
end
,"api","quitStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself raise: #SystemExit","function(self)\r\n(self):raise_(\"SystemExit\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"raise_result_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("_s8Ret_.result","result");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):raise_((function()
return ((self):call_with_("Exception","_s8Ret_"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("result");
return (self);
end
,"api","raise_result_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: '_s8Ret_.result' to: #result;cr.\r\n\tself raise: [self call: #Exception with: #_s8Ret_];cr.\r\n\tself return: #result ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"_s8Ret_.result\",\"result\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):raise_((function()\r\nreturn ((self):call_with_(\"Exception\",\"_s8Ret_\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"result\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"readJSObjectStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("invalidMessage:","\"readJSObject\""))
end));
return (self);
end
,"api","readJSObjectStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #invalidMessage: with: '\"readJSObject\"'] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"invalidMessage:\",\"\\\"readJSObject\\\"\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"register_method_in_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("methods",(function()
return ((self):send_with_("methods_Of","klass"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_do_((function()
return ((self):send_with_("not_Nil","methods"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("key",(function()
return ((self):send_with_("handleOf","stSelector"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):assign_to_("methods[key]","aMethod"))
end));
return (self);
end
,"api","register_method_in_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #methods to: [self send: #methods_Of with: #klass];cr.\r\n\tself if: [self send: #not_Nil with: #methods] do: [\r\n\t\tself assign: #key to: [self send: #handleOf with: #stSelector];cr.\r\n\t\tself assign: 'methods[key]' to: #aMethod\r\n\t]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"methods\",(function()\r\nreturn ((self):send_with_(\"methods_Of\",\"klass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_do_((function()\r\nreturn ((self):send_with_(\"not_Nil\",\"methods\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"key\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"stSelector\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):assign_to_(\"methods[key]\",\"aMethod\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"removeClassStSystemDictionary",0
,function(self)
(self):comment_("Boot - Remove aClass from system");
(
function(_s8_rec)
	(_s8_rec):assign_to_("deleted",(function()
return ((self):send_with_("String",(function()
return ((self):sum_((smalltalk.Array):with_with_("\"Deleted-\"",(function()
return ((self):send_with_("handleOf",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aClass", "\"$className\""})))
end)))
end))))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("array",(function()
return ((self):call_withArguments_("getattr",(smalltalk.Array):with_with_with_((function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aClass", "\"$superclass\"", "nil"})))
end),"\"@subclasses\"","None")))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("array",(function()
return ((self):send_to_withArguments_("remove:ifAbsent:","array",(smalltalk.Array):with_with_("aClass",(function()
return ((self):send_to_("empty","self.BlockClosure"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("meta","aClass.__class__");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("info",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"meta", "\"$info\"", "None"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("delattr",(smalltalk.Array):with_with_("self",(function()
return ((self):send_with_("handleOf",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aClass", "\"$className\""})))
end)))
end)));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("info",(function()
return ((self):call_withArguments_("setattr",(smalltalk.Array):with_with_with_("info","\"$className\"",(function()
return ((self):sum_(smalltalk:newArray({"deleted", "\" class\""})))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"meta", "\"$className\"", "deleted"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("classChanged","aClass");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("self");
return (self);
end
,"api","removeClassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Boot - Remove aClass from system'.\r\n\tself assign: #deleted to: [self send: #String with: [self sum: (Array\r\n\t\twith: '\"Deleted-\"' with: [self send: #handleOf with: [\r\n\t\t\tself call: #getattr withArguments: #(aClass '\"$className\"')]]\r\n\t\t)]];cr.\r\n\tself assign: #array to: [self call: #getattr withArguments: (Array\r\n\t\twith: [self call: #getattr withArguments: #(aClass '\"$superclass\"' #nil)]\r\n\t\twith: '\"@subclasses\"' with: #None)\r\n\t];cr.\r\n\tself if: #array do: [\r\n\t\tself send: #remove:ifAbsent: to: #array withArguments: (Array\r\n\t\t\twith: #aClass\r\n\t\t\twith: [self send: #empty to: 'self.BlockClosure'])\r\n\t];cr.\r\n\tself assign: #meta to: 'aClass.__class__';cr.\r\n\tself assign: #info to: [self call: #getattr withArguments: #(meta '\"$info\"' None)];cr.\r\n\tself call: #delattr withArguments: (Array with: #self\r\n\t\twith: [self send: #handleOf with: [\r\n\t\t\tself call: #getattr withArguments: #(aClass '\"$className\"')]\r\n\t]);cr.\r\n\tself if: #info do: [self call: #setattr withArguments: (Array\r\n\t\twith: #info with: '\"$className\"'\r\n\t\twith: [self sum: #(deleted '\" class\"')])\r\n\t];cr.\r\n\tself call: #setattr withArguments: #(meta '\"$className\"' deleted);cr.\r\n\tself send: #classChanged with: #aClass;cr.\r\n\tself return: #self ","function(self)\r\n(self):comment_(\"Boot - Remove aClass from system\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"deleted\",(function()\r\nreturn ((self):send_with_(\"String\",(function()\r\nreturn ((self):sum_((smalltalk.Array):with_with_(\"\\\"Deleted-\\\"\",(function()\r\nreturn ((self):send_with_(\"handleOf\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aClass\", \"\\\"$className\\\"\"})))\r\nend)))\r\nend))))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"array\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",(smalltalk.Array):with_with_with_((function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aClass\", \"\\\"$superclass\\\"\", \"nil\"})))\r\nend),\"\\\"@subclasses\\\"\",\"None\")))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"array\",(function()\r\nreturn ((self):send_to_withArguments_(\"remove:ifAbsent:\",\"array\",(smalltalk.Array):with_with_(\"aClass\",(function()\r\nreturn ((self):send_to_(\"empty\",\"self.BlockClosure\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"meta\",\"aClass.__class__\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"info\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"meta\", \"\\\"$info\\\"\", \"None\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"delattr\",(smalltalk.Array):with_with_(\"self\",(function()\r\nreturn ((self):send_with_(\"handleOf\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aClass\", \"\\\"$className\\\"\"})))\r\nend)))\r\nend)));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"info\",(function()\r\nreturn ((self):call_withArguments_(\"setattr\",(smalltalk.Array):with_with_with_(\"info\",\"\\\"$className\\\"\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"deleted\", \"\\\" class\\\"\"})))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"meta\", \"\\\"$className\\\"\", \"deleted\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"classChanged\",\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"removeMethodStSystemDictionary",0
,function(self)
(self):comment_("Boot - Remove aMethod implementation from aClass");
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("aboutToRemoveFrom",smalltalk:newArray({"aMethod", "aClass"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("stSelector",(function()
return ((self):send_to_("selector","aMethod"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("jsSelector",(function()
return ((self):send_with_("handleOf",(function()
return ((self):send_to_("asSelector","stSelector"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("unregister:in:",smalltalk:newArray({"stSelector", "aClass"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("delattr",smalltalk:newArray({"aClass", "jsSelector"}));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_withArguments_("methodRemovedFrom",smalltalk:newArray({"aMethod", "aClass"})))
end));
return (self);
end
,"api","removeMethodStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Boot - Remove aMethod implementation from aClass'.\r\n\tself send: #aboutToRemoveFrom withArguments: #(aMethod aClass);cr.\r\n\tself assign: #stSelector to: [self send: #selector to: #aMethod];cr.\r\n\tself assign: #jsSelector to: [self send: #handleOf\r\n\t\twith: [self send: #asSelector to: #stSelector]\r\n\t];cr.\r\n\tself send: #unregister:in: withArguments: #(stSelector aClass);cr.\r\n\tself call: #delattr withArguments: #(aClass jsSelector);cr.\r\n\tself return: [self send: #methodRemovedFrom withArguments: #(aMethod aClass)] ","function(self)\r\n(self):comment_(\"Boot - Remove aMethod implementation from aClass\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"aboutToRemoveFrom\",smalltalk:newArray({\"aMethod\", \"aClass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"stSelector\",(function()\r\nreturn ((self):send_to_(\"selector\",\"aMethod\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"jsSelector\",(function()\r\nreturn ((self):send_with_(\"handleOf\",(function()\r\nreturn ((self):send_to_(\"asSelector\",\"stSelector\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"unregister:in:\",smalltalk:newArray({\"stSelector\", \"aClass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"delattr\",smalltalk:newArray({\"aClass\", \"jsSelector\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_withArguments_(\"methodRemovedFrom\",smalltalk:newArray({\"aMethod\", \"aClass\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"renameClassStSystemDictionary",0
,function(self)
(self):comment_("Boot - Rename aClass to aString");
(
function(_s8_rec)
	(_s8_rec):assign_to_("meta","aClass.__class__");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("info",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"meta", "\"$info\"", "None"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("delattr",(smalltalk.Array):with_with_("self",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aClass", "\"$className\""})))
end)));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_("info",(function()
return ((self):call_withArguments_("setattr",(smalltalk.Array):with_with_with_("info","\"$className\"",(function()
return ((self):sum_(smalltalk:newArray({"aString", "\" class\""})))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"meta", "\"$className\"", "aString"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"self", "aString", "aClass"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("classChanged","aClass");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("self");
return (self);
end
,"api","renameClassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Boot - Rename aClass to aString'.\r\n\tself assign: #meta to: 'aClass.__class__';cr.\r\n\tself assign: #info to: [self call: #getattr withArguments: #(meta '\"$info\"' None)];cr.\r\n\tself call: #delattr withArguments: (Array with: #self\r\n\t\twith: [self call: #getattr withArguments: #(aClass '\"$className\"')]);cr.\r\n\tself if: #info do: [self call: #setattr withArguments: (Array\r\n\t\twith: #info with: '\"$className\"'\r\n\t\twith: [self sum: #(aString '\" class\"')])];cr.\r\n\tself call: #setattr withArguments: #(meta '\"$className\"' aString);cr.\r\n\tself call: #setattr withArguments: #(self aString aClass);cr.\r\n\tself send: #classChanged with: #aClass;cr.\r\n\tself return: #self ","function(self)\r\n(self):comment_(\"Boot - Rename aClass to aString\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"meta\",\"aClass.__class__\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"info\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"meta\", \"\\\"$info\\\"\", \"None\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"delattr\",(smalltalk.Array):with_with_(\"self\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aClass\", \"\\\"$className\\\"\"})))\r\nend)));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_(\"info\",(function()\r\nreturn ((self):call_withArguments_(\"setattr\",(smalltalk.Array):with_with_with_(\"info\",\"\\\"$className\\\"\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"aString\", \"\\\" class\\\"\"})))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"meta\", \"\\\"$className\\\"\", \"aString\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"self\", \"aString\", \"aClass\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"classChanged\",\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"self\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"reshapeClass_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_with_("reshape:of:","\"$className\"","aClass");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_with_("reshape:of:","\"$category\"","aClass");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_with_("reshape:of:","\"$iVarNames\"","aClass");
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"api","reshapeClass_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #reshape:of: with: '\"$className\"' with: #aClass;cr.\r\n\tself send: #reshape:of: with: '\"$category\"' with: #aClass;cr.\r\n\tself send: #reshape:of: with: '\"$iVarNames\"' with: #aClass;cr ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_with_(\"reshape:of:\",\"\\\"$className\\\"\",\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_with_(\"reshape:of:\",\"\\\"$category\\\"\",\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_with_(\"reshape:of:\",\"\\\"$iVarNames\\\"\",\"aClass\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"reshapeClassesStSystemDictionary",0
,function(self)
(self):comment_("mutate class shapes to my implementation");
(self):for_in_do_("cls",(function()
return ((self):send_to_("values","self.__dict__"))
end),(function()
return ((self):if_do_((function()
return ((self):expr_is_((function()
return ((self):call_with_("type",(function()
return ((self):call_with_("type","cls"))
end)))
end),"StMetaType"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):send_with_("reshapeClass:","cls");
	return ((_s8_rec):cr())
end
)(self);return ((self):send_with_("reshapeClass:","cls.__class__"))
end)))
end));
return (self);
end
,"api","reshapeClassesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'mutate class shapes to my implementation'.\r\n\tself for: #cls in: [self send: #values to: 'self.__dict__'] do: [\r\n\t\tself if: [self expr: [self call: #type with: [self call: #type with: #cls]] is: #StMetaType] do: [\r\n\t\t\tself send: #reshapeClass: with: #cls;cr.\r\n\t\t\tself send: #reshapeClass: with: 'cls.__class__'\r\n\t\t]\r\n\t]","function(self)\r\n(self):comment_(\"mutate class shapes to my implementation\");\r\n(self):for_in_do_(\"cls\",(function()\r\nreturn ((self):send_to_(\"values\",\"self.__dict__\"))\r\nend),(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):call_with_(\"type\",(function()\r\nreturn ((self):call_with_(\"type\",\"cls\"))\r\nend)))\r\nend),\"StMetaType\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"reshapeClass:\",\"cls\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_with_(\"reshapeClass:\",\"cls.__class__\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"reshape_of_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("value",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"anObject", "field", "None"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):expr_is_("value","None"))
end),"");
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_is_((function()
return ((self):call_with_("type","value"))
end),"str"))
end),(function()
return ((self):call_withArguments_("setattr",(smalltalk.Array):with_with_with_("anObject","field",(function()
return ((self):send_with_("String","value"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_is_((function()
return ((self):call_with_("type","value"))
end),"list"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):send_with_("toObjects","value");
	return ((_s8_rec):cr())
end
)(self);return ((self):call_withArguments_("setattr",(smalltalk.Array):with_with_with_("anObject","field",(function()
return ((self):send_with_("newArray","value"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_do_((function()
return ((self):expr_eqeq_("value.__class__","self.Array"))
end),(function()
return ((self):send_with_("toObjects",(function()
return ((self):send_with_("handleOf","value"))
end)))
end));
return (self);
end
,"api","reshape_of_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #value to: [self call: #getattr withArguments: #(anObject field None)];cr.\r\n\tself if: [self expr: #value is: #None] return: ''.\r\n\tself if: [self expr: [self call: #type with: #value] is: #str] do: [\r\n\t\tself call: #setattr withArguments: (Array\r\n\t\t\twith: #anObject with: #field\r\n\t\t\twith: [self send: #String with: #value])\r\n\t];cr.\r\n\tself if: [self expr: [self call: #type with: #value] is: #list] do: [\r\n\t\tself send: #toObjects with: #value;cr.\r\n\t\tself call: #setattr withArguments: (Array\r\n\t\t\twith: #anObject with: #field\r\n\t\t\twith: [self send: #newArray with: #value])\r\n\t];cr.\r\n\tself if: [self expr: 'value.__class__' eqeq: 'self.Array'] do: [\r\n\t\tself send: #toObjects with: [\r\n\t\t\tself send: #handleOf with: #value]\r\n\t]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"value\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"anObject\", \"field\", \"None\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):expr_is_(\"value\",\"None\"))\r\nend),\"\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):call_with_(\"type\",\"value\"))\r\nend),\"str\"))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"setattr\",(smalltalk.Array):with_with_with_(\"anObject\",\"field\",(function()\r\nreturn ((self):send_with_(\"String\",\"value\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):call_with_(\"type\",\"value\"))\r\nend),\"list\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"toObjects\",\"value\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):call_withArguments_(\"setattr\",(smalltalk.Array):with_with_with_(\"anObject\",\"field\",(function()\r\nreturn ((self):send_with_(\"newArray\",\"value\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_do_((function()\r\nreturn ((self):expr_eqeq_(\"value.__class__\",\"self.Array\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"toObjects\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"value\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"responds_toStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("selector",(function()
return ((self):send_with_("handleOf","jsSelector"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):expr_noteq_((function()
return ((self):call_with_("type","selector"))
end),"str"))
end),"False");
(self):return_((function()
return ((self):call_with_("callable",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"anObject", "selector", "None"})))
end)))
end));
return (self);
end
,"api","responds_toStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #selector to: [self send: #handleOf with: #jsSelector];cr.\r\n\tself if: [self expr: [self call: #type with: #selector] noteq: #str] return: #False.\r\n\tself return: [self call: #callable with: [\r\n\t\tself call: #getattr withArguments: #(anObject selector None)\r\n\t]] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"selector\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"jsSelector\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):expr_noteq_((function()\r\nreturn ((self):call_with_(\"type\",\"selector\"))\r\nend),\"str\"))\r\nend),\"False\");\r\n(self):return_((function()\r\nreturn ((self):call_with_(\"callable\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"anObject\", \"selector\", \"None\"})))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"responds_to_StSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):not_((function()
return ((self):expr_is_((function()
return ((self):call_with_("type","aSelector"))
end),"self.String"))
end)))
end),"self.false");
(self):return_((function()
return ((self):send_with_("b:",(function()
return ((self):send_with_with_("responds_to","anObject",(function()
return ((self):send_to_("asSelector","aSelector"))
end)))
end)))
end));
return (self);
end
,"api","responds_to_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self not: [self expr: [self call: #type with: #aSelector] is: 'self.String']] return: 'self.false'.\r\n\tself return: [self send: #b: with: [\r\n\t\tself send: #responds_to with: #anObject\r\n\t\t\twith: [self send: #asSelector to: #aSelector]\r\n\t]] ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):call_with_(\"type\",\"aSelector\"))\r\nend),\"self.String\"))\r\nend)))\r\nend),\"self.false\");\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"b:\",(function()\r\nreturn ((self):send_with_with_(\"responds_to\",\"anObject\",(function()\r\nreturn ((self):send_to_(\"asSelector\",\"aSelector\"))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"saveImageAsStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_to_with_("saveImageAs:","smalltalk","fileName"))
end));
return (self);
end
,"api","saveImageAsStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #saveImageAs: to: #smalltalk with: #fileName] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"saveImageAs:\",\"smalltalk\",\"fileName\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"saveImageStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_to_("saveImage","smalltalk"))
end));
return (self);
end
,"api","saveImageStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #saveImage to: #smalltalk] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_to_(\"saveImage\",\"smalltalk\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"setClassStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):call_with_("print",(function()
return ((self):sum_(smalltalk:newArray({"\"OBSOLETE - setClass \"", "spec.className"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):send_("obsolete");
return (self);
end
,"api","setClassStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself call: #print with: [self sum: #('\"OBSOLETE - setClass \"' 'spec.className')];cr.\r\n\tself send: #obsolete ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"print\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"\\\"OBSOLETE - setClass \\\"\", \"spec.className\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):send_(\"obsolete\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"setPropertyNamesStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("hArray",(function()
return ((self):send_with_("handleOf","pNames"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("is_Nil","hArray"))
end),(function()
return ((self):assign_to_("hArray","[]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):call_withArguments_("setattr",(smalltalk.Array):with_with_with_("aClass","\"$propertyNames\"",(function()
return ((self):send_with_("newArray","hArray"))
end)));
return (self);
end
,"api","setPropertyNamesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #hArray to: [self send: #handleOf with: #pNames];cr.\r\n\tself if: [self send: #is_Nil with: #hArray] do: [\r\n\t\tself assign: #hArray to: '[]'\r\n\t];cr.\r\n\tself call: #setattr withArguments: (Array\r\n\t\twith: #aClass with: '\"$propertyNames\"'\r\n\t\twith: [self send: #newArray with: #hArray]) ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"hArray\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"pNames\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"hArray\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"hArray\",\"[]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):call_withArguments_(\"setattr\",(smalltalk.Array):with_with_with_(\"aClass\",\"\\\"$propertyNames\\\"\",(function()\r\nreturn ((self):send_with_(\"newArray\",\"hArray\"))\r\nend)));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"setProtoOf_to_StSystemDictionary",0
,function(self)
(self):send_with_("invalidMessage:","\"setProtoOf:to:\"");
return (self);
end
,"api","setProtoOf_to_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #invalidMessage: with: '\"setProtoOf:to:\"' ","function(self)\r\n(self):send_with_(\"invalidMessage:\",\"\\\"setProtoOf:to:\\\"\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"setVarNamesStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("hArray",(function()
return ((self):send_with_("handleOf","iVarNames"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("is_Nil","hArray"))
end),(function()
return ((self):assign_to_("hArray","[]"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",(smalltalk.Array):with_with_with_("aClass","\"$iVarNames\"",(function()
return ((self):send_with_("newArray","hArray"))
end)));
	return ((_s8_rec):cr())
end
)(self);
(self):for_in_do_("iv","hArray",(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("key",(function()
return ((self):sum_((smalltalk.Array):with_with_("\"@\"",(function()
return ((self):send_with_("handleOf","iv"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):not_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"aClass", "key"})))
end)))
end),(function()
return ((self):call_withArguments_("setattr",smalltalk:newArray({"aClass", "key", "aValue"})))
end)))
end));
return (self);
end
,"api","setVarNamesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #hArray to: [self send: #handleOf with: #iVarNames];cr.\r\n\tself if: [self send: #is_Nil with: #hArray] do: [\r\n\t\tself assign: #hArray to: '[]'\r\n\t];cr.\r\n\tself call: #setattr withArguments: (Array\r\n\t\twith: #aClass with: '\"$iVarNames\"'\r\n\t\twith: [self send: #newArray with: #hArray]);cr.\r\n\tself for: #iv in: #hArray do: [\r\n\t\tself assign: #key to: [self sum: (Array\r\n\t\t\twith: '\"@\"'\r\n\t\t\twith: [self send: #handleOf with: #iv])];cr.\r\n\t\tself if: [self not: [self call: #hasattr withArguments: #(aClass key)]] do: [\r\n\t\t\tself call: #setattr withArguments: #(aClass key aValue)\r\n\t\t]\r\n\t]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"hArray\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"iVarNames\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"hArray\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"hArray\",\"[]\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",(smalltalk.Array):with_with_with_(\"aClass\",\"\\\"$iVarNames\\\"\",(function()\r\nreturn ((self):send_with_(\"newArray\",\"hArray\"))\r\nend)));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):for_in_do_(\"iv\",\"hArray\",(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"key\",(function()\r\nreturn ((self):sum_((smalltalk.Array):with_with_(\"\\\"@\\\"\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"iv\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"aClass\", \"key\"})))\r\nend)))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"setattr\",smalltalk:newArray({\"aClass\", \"key\", \"aValue\"})))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"smDoStSystemDictionary",0
,function(self)
(self):comment_("Boot - Notify the system about executing aBlock");
(self):if_do_((function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self", "\"useManager\"", "False"})))
end),(function()
return ((self):if_do_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"self", "\"SystemManager\""})))
end),(function()
return ((self):if_do_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"self.SystemManager", "\"currentOrNil\""})))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("sm",(function()
return ((self):send_to_("currentOrNil","self.SystemManager"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_return_((function()
return ((self):send_with_("not_Nil","sm"))
end),(function()
return ((self):call_with_("block","sm"))
end)))
end)))
end)))
end));
return (self);
end
,"api","smDoStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Boot - Notify the system about executing aBlock'.\r\n\tself if: [self call: #getattr withArguments: #(self '\"useManager\"' False)] do: [\r\n\t\tself if: [self call: #hasattr withArguments: #(self '\"SystemManager\"')] do: [\r\n\t\t\tself if: [self call: #hasattr withArguments: #('self.SystemManager' '\"currentOrNil\"')] do: [\r\n\t\t\t\tself assign: #sm to: [self send: #currentOrNil to: #'self.SystemManager'];cr.\r\n\t\t\t\tself if: [self send: #not_Nil with: #sm] return: [self call: #block with: #sm]\r\n\t\t\t]\r\n\t\t]\r\n\t]","function(self)\r\n(self):comment_(\"Boot - Notify the system about executing aBlock\");\r\n(self):if_do_((function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self\", \"\\\"useManager\\\"\", \"False\"})))\r\nend),(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"self\", \"\\\"SystemManager\\\"\"})))\r\nend),(function()\r\nreturn ((self):if_do_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"self.SystemManager\", \"\\\"currentOrNil\\\"\"})))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"sm\",(function()\r\nreturn ((self):send_to_(\"currentOrNil\",\"self.SystemManager\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_return_((function()\r\nreturn ((self):send_with_(\"not_Nil\",\"sm\"))\r\nend),(function()\r\nreturn ((self):call_with_(\"block\",\"sm\"))\r\nend)))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"stObjectStSystemDictionary",0
,function(self)
(self):return_("StObject");
return (self);
end
,"api","stObjectStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: #StObject ","function(self)\r\n(self):return_(\"StObject\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"startDebugStSystemDictionary",0
,function(self)
(self):comment_("DEBUG");
(
function(_s8_rec)
	(_s8_rec):call_withArguments_("setattr",smalltalk:newArray({"self", "\"DEBUG\"", "self.true"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):call_with_("print","\"# DEBUG started\"");
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("print(\"# outerFramesCount\",self.outerFramesCount())");
(self):comment_("import gc");
(self):comment_("gc.collect()");
(self):comment_("print(\"# collection finished\")");
(self):comment_("gc.set_debug(gc.DEBUG_LEAK)");
return (self);
end
,"api","startDebugStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: #DEBUG.\r\n\tself call: #setattr withArguments: #(self '\"DEBUG\"' 'self.true');cr.\r\n\tself call: #print with: '\"# DEBUG started\"';cr.\r\n\tself comment: 'print(\"# outerFramesCount\",self.outerFramesCount())'.\r\n\tself comment: 'import gc'.\r\n\tself comment: 'gc.collect()'.\r\n\tself comment: 'print(\"# collection finished\")'.\r\n\tself comment: 'gc.set_debug(gc.DEBUG_LEAK)' ","function(self)\r\n(self):comment_(\"DEBUG\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_withArguments_(\"setattr\",smalltalk:newArray({\"self\", \"\\\"DEBUG\\\"\", \"self.true\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):call_with_(\"print\",\"\\\"# DEBUG started\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"print(\\\"# outerFramesCount\\\",self.outerFramesCount())\");\r\n(self):comment_(\"import gc\");\r\n(self):comment_(\"gc.collect()\");\r\n(self):comment_(\"print(\\\"# collection finished\\\")\");\r\n(self):comment_(\"gc.set_debug(gc.DEBUG_LEAK)\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"startupStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):send_with_("state:","\"booting\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("state:","\"singularity\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Object\"", "\"Kernel\"", "StObject"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Smalltalk\"", "\"Kernel\"", "StSystemDictionary", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Behavior\"", "\"Kernel\"", "nil", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Class\"", "\"Kernel\"", "nil", "self.Behavior"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Metaclass\"", "\"Kernel\"", "nil", "self.Behavior"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"CompiledMethod\"", "\"Kernel\"", "nil", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Number\"", "\"Kernel\"", "nil", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"BlockClosure\"", "\"Kernel\"", "nil", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Boolean\"", "\"Kernel\"", "nil", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("self.mapClassName(\"DateTime\",\"Kernel\",Date,self.Object)");
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"UndefinedObject\"", "\"Kernel\"", "nil", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Collection\"", "\"Kernel\"", "nil", "self.Object"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"SequenceableCollection\"", "\"Kernel\"", "nil", "self.Collection"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"String\"", "\"Kernel\"", "nil", "self.SequenceableCollection"}));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_withArguments_("mapClassName",smalltalk:newArray({"\"Array\"", "\"Kernel\"", "nil", "self.SequenceableCollection"}));
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("self.mapClassName(\"RegularExpression\",\"Kernel\",RegExp,self.Object)");
(
function(_s8_rec)
	(_s8_rec):send_with_("state:","\"whiteHole\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_("linkNatives");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_("reshapeClasses");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("state:","\"wormHole\"");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_("bindCore");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_with_("state:","\"startup\"");
	return ((_s8_rec):cr())
end
)(self);
(self):return_and_((function()
return ((self):send_with_("copyTo",(function()
return ((self):send_with_("Smalltalk","nil"))
end)))
end),(function()
return ((self):send_with_("UndefinedObject","nil"))
end));
return (self);
end
,"api","startupStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself send: #state: with: '\"booting\"';cr.\r\n\tself send: #state: with: '\"singularity\"';cr.\r\n\tself send: #mapClassName withArguments: #('\"Object\"' '\"Kernel\"' StObject);cr.\r\n\tself send: #mapClassName withArguments: #('\"Smalltalk\"' '\"Kernel\"' StSystemDictionary 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"Behavior\"' '\"Kernel\"' #nil 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"Class\"' '\"Kernel\"' #nil 'self.Behavior');cr.\r\n\tself send: #mapClassName withArguments: #('\"Metaclass\"' '\"Kernel\"' #nil 'self.Behavior');cr.\r\n\tself send: #mapClassName withArguments: #('\"CompiledMethod\"' '\"Kernel\"' #nil 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"Number\"' '\"Kernel\"' #nil 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"BlockClosure\"' '\"Kernel\"' #nil 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"Boolean\"' '\"Kernel\"' #nil 'self.Object');cr.\r\n\tself comment: 'self.mapClassName(\"DateTime\",\"Kernel\",Date,self.Object)'.\r\n\tself send: #mapClassName withArguments: #('\"UndefinedObject\"' '\"Kernel\"' #nil 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"Collection\"' '\"Kernel\"' #nil 'self.Object');cr.\r\n\tself send: #mapClassName withArguments: #('\"SequenceableCollection\"' '\"Kernel\"' #nil 'self.Collection');cr.\r\n\tself send: #mapClassName withArguments: #('\"String\"' '\"Kernel\"' #nil 'self.SequenceableCollection');cr.\r\n\tself send: #mapClassName withArguments: #('\"Array\"' '\"Kernel\"' #nil 'self.SequenceableCollection');cr.\r\n\tself comment: 'self.mapClassName(\"RegularExpression\",\"Kernel\",RegExp,self.Object)'.\r\n\tself send: #state: with: '\"whiteHole\"';cr.\r\n\tself send: #linkNatives;cr.\r\n\tself send: #reshapeClasses;cr.\r\n\tself send: #state: with: '\"wormHole\"';cr.\r\n\tself send: #bindCore;cr.\r\n\tself send: #state: with: '\"startup\"';cr.\r\n\tself return: [self send: #copyTo with: [self send: #Smalltalk with: #nil]]\r\n\t\tand: [self send: #UndefinedObject with: #nil]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"state:\",\"\\\"booting\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"state:\",\"\\\"singularity\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Object\\\"\", \"\\\"Kernel\\\"\", \"StObject\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Smalltalk\\\"\", \"\\\"Kernel\\\"\", \"StSystemDictionary\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Behavior\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Class\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Behavior\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Metaclass\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Behavior\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"CompiledMethod\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Number\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"BlockClosure\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Boolean\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"self.mapClassName(\\\"DateTime\\\",\\\"Kernel\\\",Date,self.Object)\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"UndefinedObject\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Collection\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Object\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"SequenceableCollection\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.Collection\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"String\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.SequenceableCollection\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_withArguments_(\"mapClassName\",smalltalk:newArray({\"\\\"Array\\\"\", \"\\\"Kernel\\\"\", \"nil\", \"self.SequenceableCollection\"}));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"self.mapClassName(\\\"RegularExpression\\\",\\\"Kernel\\\",RegExp,self.Object)\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"state:\",\"\\\"whiteHole\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_(\"linkNatives\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_(\"reshapeClasses\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"state:\",\"\\\"wormHole\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_(\"bindCore\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_with_(\"state:\",\"\\\"startup\\\"\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_and_((function()\r\nreturn ((self):send_with_(\"copyTo\",(function()\r\nreturn ((self):send_with_(\"Smalltalk\",\"nil\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_with_(\"UndefinedObject\",\"nil\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"state_StSystemDictionary",0
,function(self)
(self):call_withArguments_("setattr",smalltalk:newArray({"self", "\"$state\"", "aState"}));
return (self);
end
,"api","state_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself call: #setattr withArguments: #(self '\"$state\"' aState) ","function(self)\r\n(self):call_withArguments_(\"setattr\",smalltalk:newArray({\"self\", \"\\\"$state\\\"\", \"aState\"}));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"stringOfStSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):not_((function()
return ((self):expr_is_((function()
return ((self):call_with_("type","nativeString"))
end),"str"))
end)))
end),(function()
return ((self):send_with_("invalidMessage:","\"Must be a native string\""))
end));
(self):if_return_((function()
return ((self):call_withArguments_("hasattr",smalltalk:newArray({"self", "\"String\""})))
end),(function()
return ((self):send_with_("String","nativeString"))
end));
(self):return_("nativeString");
return (self);
end
,"api","stringOfStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self not: [self expr: [self call: #type with: #nativeString] is: #str]]\r\n\t\treturn: [self send: #invalidMessage: with: '\"Must be a native string\"'].\r\n\tself if: [self call: #hasattr withArguments: #(self '\"String\"')]\r\n\t\treturn: [self send: #String with: #nativeString].\r\n\tself return: #nativeString ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):not_((function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):call_with_(\"type\",\"nativeString\"))\r\nend),\"str\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):send_with_(\"invalidMessage:\",\"\\\"Must be a native string\\\"\"))\r\nend));\r\n(self):if_return_((function()\r\nreturn ((self):call_withArguments_(\"hasattr\",smalltalk:newArray({\"self\", \"\\\"String\\\"\"})))\r\nend),(function()\r\nreturn ((self):send_with_(\"String\",\"nativeString\"))\r\nend));\r\n(self):return_(\"nativeString\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"string_asNumber_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("s",(function()
return ((self):send_with_("handleOf","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_do_else_((function()
return ((self):expr_in_("\".\"","s"))
end),(function()
return ((self):return_((function()
return ((self):send_with_("Number",(function()
return ((self):call_with_("float","s"))
end)))
end)))
end),(function()
return ((self):return_((function()
return ((self):send_with_("Number",(function()
return ((self):call_with_("int","s"))
end)))
end)))
end));
return (self);
end
,"api","string_asNumber_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #s to: [self send: #handleOf with: #receiver];cr.\r\n\tself if: [self expr: '\".\"' in: #s] do: [\r\n\t\tself return: [self send: #Number with: [self call: #float with: #s]]\r\n\t] else: [\r\n\t\tself return: [self send: #Number with: [self call: #int with: #s]]\r\n\t]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"s\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_do_else_((function()\r\nreturn ((self):expr_in_(\"\\\".\\\"\",\"s\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_with_(\"Number\",(function()\r\nreturn ((self):call_with_(\"float\",\"s\"))\r\nend)))\r\nend)))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_with_(\"Number\",(function()\r\nreturn ((self):call_with_(\"int\",\"s\"))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"string_isLiteral_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("s",(function()
return ((self):send_with_("handleOf","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("l",(function()
return ((self):call_with_("len","s"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):expr_eqeq_("l","0"))
end),"self.false");
(self):if_return_((function()
return ((self):send_with_("b",(function()
return ((self):send_to_with_("isBinarySelector:","self.String","receiver"))
end)))
end),"self.true");
(
function(_s8_rec)
	(_s8_rec):import_("re");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("p",(function()
return ((self):send_to_with_("compile","re","\"[\\w:]*\""))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("match",(function()
return ((self):send_to_with_("match","p","s"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):expr_and_("match",(function()
return ((self):expr_eqeq_((function()
return ((self):send_to_("end","match"))
end),"l"))
end)))
end),"self.true");
(self):return_("self.false");
return (self);
end
,"api","string_isLiteral_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #s to: [self send: #handleOf with: #receiver];cr.\r\n\tself assign: #l to: [self call: #len with: #s];cr.\r\n\tself if: [self expr: #l eqeq: #0] return: 'self.false'.\r\n\tself if: [self send: #b with: [self send: #isBinarySelector: to: 'self.String' with: #receiver]] return: 'self.true'.\r\n\tself import: #re;cr.\r\n\tself assign: #p to: [self send: #compile to: #re with: '\"[\\w:]*\"'];cr.\r\n\tself assign: #match to: [self send: #match to: #p with: #s];cr.\r\n\tself if: [self expr: #match and: [self expr: [self send: #end to: #match] eqeq: #l]] return: 'self.true'.\r\n\tself return: 'self.false' ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"s\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"l\",(function()\r\nreturn ((self):call_with_(\"len\",\"s\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):expr_eqeq_(\"l\",\"0\"))\r\nend),\"self.false\");\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"b\",(function()\r\nreturn ((self):send_to_with_(\"isBinarySelector:\",\"self.String\",\"receiver\"))\r\nend)))\r\nend),\"self.true\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):import_(\"re\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"p\",(function()\r\nreturn ((self):send_to_with_(\"compile\",\"re\",\"\\\"[\\\\w:]*\\\"\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"match\",(function()\r\nreturn ((self):send_to_with_(\"match\",\"p\",\"s\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):expr_and_(\"match\",(function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):send_to_(\"end\",\"match\"))\r\nend),\"l\"))\r\nend)))\r\nend),\"self.true\");\r\n(self):return_(\"self.false\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"string_matchStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("s",(function()
return ((self):send_with_("handleOf","receiver"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("regexp",(function()
return ((self):send_with_("handleOf","aRegexp"))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):import_("re");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("p",(function()
return ((self):send_to_with_("compile","re","regexp"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_to_with_("match","p","s"))
end));
return (self);
end
,"api","string_matchStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #s to: [self send: #handleOf with: #receiver];cr.\r\n\tself assign: #regexp to: [self send: #handleOf with: #aRegexp];cr.\r\n\tself import: #re;cr.\r\n\tself assign: #p to: [self send: #compile to: #re with: #regexp];cr.\r\n\tself return: [self send: #match to: #p with: #s] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"s\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"regexp\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"aRegexp\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):import_(\"re\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"p\",(function()\r\nreturn ((self):send_to_with_(\"compile\",\"re\",\"regexp\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"match\",\"p\",\"s\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"string_occurrencesOf_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("s",(function()
return ((self):send_with_("handleOf","aString"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_do_else_((function()
return ((self):expr_eqeq_((function()
return ((self):call_with_("type","s"))
end),"str"))
end),(function()
return ((self):return_((function()
return ((self):send_with_("Number",(function()
return ((self):send_to_with_("count",(function()
return ((self):send_with_("handleOf","receiver"))
end),"s"))
end)))
end)))
end),(function()
return ((self):return_((function()
return ((self):send_with_("Number","0"))
end)))
end));
return (self);
end
,"api","string_occurrencesOf_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #s to: [self send: #handleOf with: #aString];cr.\r\n\tself if: [self expr: [self call: #type with: #s] eqeq: #str] do: [\r\n\t\tself return: [self send: #Number with: [\r\n\t\t\tself send: #count\r\n\t\t\t\tto: [self send: #handleOf with: #receiver]\r\n\t\t\t\twith: #s\r\n\t\t\t]]\r\n\t] else: [\r\n\t\tself return: [self send: #Number with: #0]\r\n\t]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"s\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"aString\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_do_else_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):call_with_(\"type\",\"s\"))\r\nend),\"str\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_with_(\"Number\",(function()\r\nreturn ((self):send_to_with_(\"count\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend),\"s\"))\r\nend)))\r\nend)))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_with_(\"Number\",\"0\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"string_startsWith_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("s",(function()
return ((self):send_with_("handleOf","aString"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_do_else_((function()
return ((self):expr_eqeq_((function()
return ((self):call_with_("type","s"))
end),"str"))
end),(function()
return ((self):return_((function()
return ((self):send_with_("b:",(function()
return ((self):send_to_with_("startswith",(function()
return ((self):send_with_("handleOf","receiver"))
end),"s"))
end)))
end)))
end),(function()
return ((self):return_("self.false"))
end));
return (self);
end
,"api","string_startsWith_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #s to: [self send: #handleOf with: #aString];cr.\r\n\tself if: [self expr: [self call: #type with: #s] eqeq: #str] do: [\r\n\t\tself return: [self send: #b: with: [\r\n\t\t\tself send: #startswith\r\n\t\t\t\tto: [self send: #handleOf with: #receiver]\r\n\t\t\t\twith: #s\r\n\t\t]]\r\n\t] else: [\r\n\t\tself return: 'self.false'\r\n\t]","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"s\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"aString\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_do_else_((function()\r\nreturn ((self):expr_eqeq_((function()\r\nreturn ((self):call_with_(\"type\",\"s\"))\r\nend),\"str\"))\r\nend),(function()\r\nreturn ((self):return_((function()\r\nreturn ((self):send_with_(\"b:\",(function()\r\nreturn ((self):send_to_with_(\"startswith\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend),\"s\"))\r\nend)))\r\nend)))\r\nend),(function()\r\nreturn ((self):return_(\"self.false\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"subclassesStSystemDictionary",0
,function(self)
(self):comment_("Boot - Return the subclasses of aClass");
(self):if_return_((function()
return ((self):send_with_("is_Nil","aClass"))
end),(function()
return ((self):send_to_with_("subclasses","smalltalk","smalltalk.Smalltalk"))
end));
(
function(_s8_rec)
	(_s8_rec):assign_to_("result",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aClass", "\"@subclasses\"", "nil"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):send_with_("is_Nil","result"))
end),(function()
return ((self):send_("computeSubclasses"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"aClass", "\"@subclasses\""})))
end));
return (self);
end
,"api","subclassesStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'Boot - Return the subclasses of aClass'.\r\n\tself if: [self send: #is_Nil with: #aClass]\r\n\t\treturn: [self send: #subclasses to: #smalltalk with: 'smalltalk.Smalltalk'].\r\n\tself assign: #result to: [self call: #getattr withArguments: #(aClass '\"@subclasses\"' #nil)];cr.\r\n\tself if: [self send: #is_Nil with: #result] do: [\r\n\t\tself send: #computeSubclasses\r\n\t];cr.\r\n\tself return: [self call: #getattr withArguments: #(aClass '\"@subclasses\"')] ","function(self)\r\n(self):comment_(\"Boot - Return the subclasses of aClass\");\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"aClass\"))\r\nend),(function()\r\nreturn ((self):send_to_with_(\"subclasses\",\"smalltalk\",\"smalltalk.Smalltalk\"))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"result\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aClass\", \"\\\"@subclasses\\\"\", \"nil\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"result\"))\r\nend),(function()\r\nreturn ((self):send_(\"computeSubclasses\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"aClass\", \"\\\"@subclasses\\\"\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"superImplementorStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("invalidMessage:","\"superImplementor\""))
end));
return (self);
end
,"api","superImplementorStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #invalidMessage: with: '\"superImplementor\"'] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"invalidMessage:\",\"\\\"superImplementor\\\"\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"superReceiverStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("meta",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"receiver", "\"$meta\"", "False"})))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):comment_("print(\"superReceiver\",implementor,receiver ,\"meta=\",meta,\"isClass=\",receiver.isClass())");
(self):if_return_("meta",(function()
return ((self):call_withArguments_("super",(smalltalk.Array):with_with_("implementor",(function()
return ((self):send_to_("instanceClass","receiver"))
end))))
end));
(self):if_return_((function()
return ((self):send_with_("b",(function()
return ((self):send_to_("isClass","receiver"))
end)))
end),(function()
return ((self):call_withArguments_("SuperForClass",smalltalk:newArray({"implementor", "receiver"})))
end));
(self):return_((function()
return ((self):call_withArguments_("super",smalltalk:newArray({"implementor", "receiver"})))
end));
return (self);
end
,"api","superReceiverStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #meta to: [self call: #getattr withArguments: #(receiver '\"$meta\"' False)];cr.\r\n\tself comment: 'print(\"superReceiver\",implementor,receiver ,\"meta=\",meta,\"isClass=\",receiver.isClass())'.\r\n\tself if: #meta return: [self call: #super withArguments: (Array\r\n\t\twith: #implementor\r\n\t\twith: [self send: #instanceClass to: #receiver])].\r\n\tself if: [self send: #b with: [self send: #isClass to: #receiver]]\r\n\t\treturn: [self call: #SuperForClass withArguments: #(implementor receiver)].\r\n\tself return: [self call: #super withArguments: #(implementor receiver)] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"meta\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"receiver\", \"\\\"$meta\\\"\", \"False\"})))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):comment_(\"print(\\\"superReceiver\\\",implementor,receiver ,\\\"meta=\\\",meta,\\\"isClass=\\\",receiver.isClass())\");\r\n(self):if_return_(\"meta\",(function()\r\nreturn ((self):call_withArguments_(\"super\",(smalltalk.Array):with_with_(\"implementor\",(function()\r\nreturn ((self):send_to_(\"instanceClass\",\"receiver\"))\r\nend))))\r\nend));\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"b\",(function()\r\nreturn ((self):send_to_(\"isClass\",\"receiver\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):call_withArguments_(\"SuperForClass\",smalltalk:newArray({\"implementor\", \"receiver\"})))\r\nend));\r\n(self):return_((function()\r\nreturn ((self):call_withArguments_(\"super\",smalltalk:newArray({\"implementor\", \"receiver\"})))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"tStSystemDictionary",0
,function(self)
(self):comment_("TESTING - print the native sources of test method");
(
function(_s8_rec)
	(_s8_rec):assign_to_("test",(function()
return ((self):sum_((smalltalk.Array):with_with_("\"test\"",(function()
return ((self):call_with_("str","number"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):call_with_("print",(function()
return ((self):send_to_("src",(function()
return ((self):property_of_("__method__",(function()
return ((self):call_withArguments_("getattr",smalltalk:newArray({"self.true", "test"})))
end)))
end)))
end));
return (self);
end
,"api","tStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'TESTING - print the native sources of test method'.\r\n\tself assign: #test to: [self sum: (Array\r\n\t\twith: '\"test\"'\r\n\t\twith: [self call: #str with: #number])];cr.\r\n\tself call: #print with: [\r\n\t\tself send: #src to: [self\r\n\t\t\tproperty: #__method__\r\n\t\t\tof: [self call: #getattr withArguments: #('self.true' test)]\r\n\t\t]\r\n\t] ","function(self)\r\n(self):comment_(\"TESTING - print the native sources of test method\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"test\",(function()\r\nreturn ((self):sum_((smalltalk.Array):with_with_(\"\\\"test\\\"\",(function()\r\nreturn ((self):call_with_(\"str\",\"number\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):call_with_(\"print\",(function()\r\nreturn ((self):send_to_(\"src\",(function()\r\nreturn ((self):property_of_(\"__method__\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",smalltalk:newArray({\"self.true\", \"test\"})))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"testAllStSystemDictionary",0
,function(self)
(self):comment_("TESTING - Run all tests");
(self):return_((function()
return ((self):send_to_("testAll","self.true"))
end));
return (self);
end
,"api","testAllStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'TESTING - Run all tests'.\r\n\tself return: [self send: #testAll to: 'self.true'] ","function(self)\r\n(self):comment_(\"TESTING - Run all tests\");\r\n(self):return_((function()\r\nreturn ((self):send_to_(\"testAll\",\"self.true\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"testFromStSystemDictionary",0
,function(self)
(self):comment_("TESTING - Run from first test");
(self):for_in_do_("i",(function()
return ((self):call_withArguments_("range",smalltalk:newArray({"first", "last"})))
end),(function()
return ((self):try_except_as_doing_((function()
return ((self):send_with_("test","i"))
end),"Exception","ex",(function()
return ((self):call_withArguments_("print",(smalltalk.Array):with_with_((function()
return ((self):sum_((smalltalk.Array):with_with_("\"test\"",(function()
return ((self):call_with_("str","i"))
end))))
end),"ex.args")))
end)))
end));
return (self);
end
,"api","testFromStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'TESTING - Run from first test'.\r\n\tself for: #i in: [self call: #range withArguments: #(first last)] do: [\r\n\t\tself try: [ self send: #test with: #i\r\n\t\t] except: #Exception as: #ex doing: [\r\n\t\t\tself call: #print withArguments: (Array\r\n\t\t\t\twith: [self sum: (Array\r\n\t\t\t\t\twith: '\"test\"'\r\n\t\t\t\t\twith: [self call: #str with: #i])]\r\n\t\t\t\twith: 'ex.args')\r\n\t\t]\r\n\t] ","function(self)\r\n(self):comment_(\"TESTING - Run from first test\");\r\n(self):for_in_do_(\"i\",(function()\r\nreturn ((self):call_withArguments_(\"range\",smalltalk:newArray({\"first\", \"last\"})))\r\nend),(function()\r\nreturn ((self):try_except_as_doing_((function()\r\nreturn ((self):send_with_(\"test\",\"i\"))\r\nend),\"Exception\",\"ex\",(function()\r\nreturn ((self):call_withArguments_(\"print\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):sum_((smalltalk.Array):with_with_(\"\\\"test\\\"\",(function()\r\nreturn ((self):call_with_(\"str\",\"i\"))\r\nend))))\r\nend),\"ex.args\")))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"testStSystemDictionary",0
,function(self)
(self):comment_("TESTING - Returns the result of running test (or nil)");
(
function(_s8_rec)
	(_s8_rec):assign_to_("f",(function()
return ((self):call_withArguments_("getattr",(smalltalk.Array):with_with_with_("smalltalk.true",(function()
return ((self):sum_((smalltalk.Array):with_with_("\"test\"",(function()
return ((self):call_with_("str","what"))
end))))
end),"nil")))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_return_((function()
return ((self):send_with_("is_Nil","f"))
end),"nil");
(self):comment_("print(\"test\",what)");
(self):if_return_((function()
return ((self):expr_is_((function()
return ((self):call_("f"))
end),"smalltalk.true"))
end),"True");
(self):comment_("print(\"FAILED test\",what)");
(self):call_withArguments_("print",(smalltalk.Array):with_with_("\"FAILED\"",(function()
return ((self):send_to_("src",(function()
return ((self):property_of_("__method__","f"))
end)))
end)));
return (self);
end
,"api","testStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'TESTING - Returns the result of running test (or nil)'.\r\n\tself assign: #f to: [self call: #getattr withArguments: (Array\r\n\t\twith: 'smalltalk.true'\r\n\t\twith: [self sum: (Array\r\n\t\t\twith: '\"test\"'\r\n\t\t\twith: [self call: #str with: #what])]\r\n\t\twith: #nil)\r\n\t];cr.\r\n\tself if: [self send: #is_Nil with: #f] return: #nil.\r\n\tself comment: 'print(\"test\",what)'.\r\n\tself if: [self expr: [self call: #f] is: 'smalltalk.true'] return: #True.\r\n\tself comment: 'print(\"FAILED test\",what)'.\r\n\tself call: #print withArguments: (Array\r\n\t\twith: '\"FAILED\"'\r\n\t\twith: [self send: #src to: [self\r\n\t\t\tproperty: #__method__\r\n\t\t\tof: #f]]) ","function(self)\r\n(self):comment_(\"TESTING - Returns the result of running test (or nil)\");\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"f\",(function()\r\nreturn ((self):call_withArguments_(\"getattr\",(smalltalk.Array):with_with_with_(\"smalltalk.true\",(function()\r\nreturn ((self):sum_((smalltalk.Array):with_with_(\"\\\"test\\\"\",(function()\r\nreturn ((self):call_with_(\"str\",\"what\"))\r\nend))))\r\nend),\"nil\")))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"f\"))\r\nend),\"nil\");\r\n(self):comment_(\"print(\\\"test\\\",what)\");\r\n(self):if_return_((function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):call_(\"f\"))\r\nend),\"smalltalk.true\"))\r\nend),\"True\");\r\n(self):comment_(\"print(\\\"FAILED test\\\",what)\");\r\n(self):call_withArguments_(\"print\",(smalltalk.Array):with_with_(\"\\\"FAILED\\\"\",(function()\r\nreturn ((self):send_to_(\"src\",(function()\r\nreturn ((self):property_of_(\"__method__\",\"f\"))\r\nend)))\r\nend)));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"times_repeat_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):for_in_do_("i",(function()
return ((self):call_with_("range",(function()
return ((self):send_to_("asParameter","count"))
end)))
end),(function()
return ((self):call_with_("aBlock",(function()
return ((self):send_with_("Number",(function()
return ((self):sum_(smalltalk:newArray({"i", "1"})))
end)))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("count");
return (self);
end
,"api","times_repeat_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself for: #i in: [self call: #range with: [self send: #asParameter to: #count]] do: [\r\n\t\tself call: #aBlock with: [self send: #Number with: [self sum: #(i #1)]]\r\n\t];cr.\r\n\tself return: #count ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):for_in_do_(\"i\",(function()\r\nreturn ((self):call_with_(\"range\",(function()\r\nreturn ((self):send_to_(\"asParameter\",\"count\"))\r\nend)))\r\nend),(function()\r\nreturn ((self):call_with_(\"aBlock\",(function()\r\nreturn ((self):send_with_(\"Number\",(function()\r\nreturn ((self):sum_(smalltalk:newArray({\"i\", \"1\"})))\r\nend)))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"count\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"toObjectsStSystemDictionary",0
,function(self)
(self):for_in_do_("i",(function()
return ((self):call_withArguments_("range",(smalltalk.Array):with_with_("0",(function()
return ((self):call_with_("len","list"))
end))))
end),(function()
(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_is_("list[i]","None"))
end),(function()
return ((self):assign_to_("list[i]","nil"))
end));
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):if_do_((function()
return ((self):expr_is_((function()
return ((self):call_with_("type","list[i]"))
end),"str"))
end),(function()
return ((self):assign_to_("list[i]",(function()
return ((self):send_with_("String","list[i]"))
end)))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):if_do_((function()
return ((self):send_with_("is_Number","list[i]"))
end),(function()
return ((self):assign_to_("list[i]",(function()
return ((self):send_with_("Number","list[i]"))
end)))
end)))
end));
return (self);
end
,"api","toObjectsStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself for: #i in: [self call: #range withArguments: (Array\r\n\t\twith: #0 with: [self call: #len with: #list])] do: [\r\n\t\tself if: [self expr: 'list[i]' is: #None] do: [\r\n\t\t\tself assign: 'list[i]' to: #nil\r\n\t\t];cr.\r\n\t\tself if: [self expr: [self call: #type with: 'list[i]'] is: #str] do: [\r\n\t\t\tself assign: 'list[i]' to: [self send: #String with: 'list[i]']\r\n\t\t];cr.\r\n\t\tself if: [self send: #is_Number with: 'list[i]'] do: [\r\n\t\t\tself assign: 'list[i]' to: [self send: #Number with: 'list[i]']\r\n\t\t]\r\n\t] ","function(self)\r\n(self):for_in_do_(\"i\",(function()\r\nreturn ((self):call_withArguments_(\"range\",(smalltalk.Array):with_with_(\"0\",(function()\r\nreturn ((self):call_with_(\"len\",\"list\"))\r\nend))))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_is_(\"list[i]\",\"None\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"list[i]\",\"nil\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):if_do_((function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):call_with_(\"type\",\"list[i]\"))\r\nend),\"str\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"list[i]\",(function()\r\nreturn ((self):send_with_(\"String\",\"list[i]\"))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):if_do_((function()\r\nreturn ((self):send_with_(\"is_Number\",\"list[i]\"))\r\nend),(function()\r\nreturn ((self):assign_to_(\"list[i]\",(function()\r\nreturn ((self):send_with_(\"Number\",\"list[i]\"))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"toStringStObject",0
,function(self)
(self):return_((function()
return ((self):send_to_with_("String","smalltalk",(function()
return ((self):send_("__str__"))
end)))
end));
return (self);
end
,"api","toStringStObject\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #String to: #smalltalk with: [self send: #__str__]] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_to_with_(\"String\",\"smalltalk\",(function()\r\nreturn ((self):send_(\"__str__\"))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"toStringStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("String","\"smalltalk\""))
end));
return (self);
end
,"api","toStringStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #String with: '\"smalltalk\"'] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"String\",\"\\\"smalltalk\\\"\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"to_StringStSystemDictionary",0
,function(self)
(self):if_return_((function()
return ((self):send_with_("is_Nil","receiver"))
end),(function()
return ((self):send_with_("String","\"nil\""))
end));
(self):if_return_((function()
return ((self):call_withArguments_("isinstance",smalltalk:newArray({"receiver", "self.Boolean"})))
end),(function()
return ((self):send_with_("String",(function()
return ((self):call_with_("str","receiver"))
end)))
end));
(self):if_return_((function()
return ((self):send_withArguments_("responds_to",smalltalk:newArray({"receiver", "\"toString\""})))
end),(function()
return ((self):send_to_("toString","receiver"))
end));
(self):return_((function()
return ((self):send_with_("String",(function()
return ((self):call_with_("str",(function()
return ((self):send_with_("handleOf","receiver"))
end)))
end)))
end));
return (self);
end
,"api","to_StringStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself if: [self send: #is_Nil with: #receiver] return: [self send: #String with: '\"nil\"'].\r\n\tself if: [self call: #isinstance withArguments: #(receiver 'self.Boolean')]\r\n\t\treturn: [self send: #String with: [self call: #str with: #receiver]].\r\n\tself if: [self send: #responds_to withArguments: #(receiver '\"toString\"')]\r\n\t\treturn: [self send: #toString to: #receiver].\r\n\tself return: [self send: #String with: [\r\n\t\tself call: #str with: [\r\n\t\tself send: #handleOf with: #receiver\r\n\t]]] ","function(self)\r\n(self):if_return_((function()\r\nreturn ((self):send_with_(\"is_Nil\",\"receiver\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"String\",\"\\\"nil\\\"\"))\r\nend));\r\n(self):if_return_((function()\r\nreturn ((self):call_withArguments_(\"isinstance\",smalltalk:newArray({\"receiver\", \"self.Boolean\"})))\r\nend),(function()\r\nreturn ((self):send_with_(\"String\",(function()\r\nreturn ((self):call_with_(\"str\",\"receiver\"))\r\nend)))\r\nend));\r\n(self):if_return_((function()\r\nreturn ((self):send_withArguments_(\"responds_to\",smalltalk:newArray({\"receiver\", \"\\\"toString\\\"\"})))\r\nend),(function()\r\nreturn ((self):send_to_(\"toString\",\"receiver\"))\r\nend));\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"String\",(function()\r\nreturn ((self):call_with_(\"str\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"unregister_in_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("methods",(function()
return ((self):send_with_("methods_Of","klass"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):if_do_((function()
return ((self):send_with_("not_Nil","methods"))
end),(function()
(
function(_s8_rec)
	(_s8_rec):assign_to_("key",(function()
return ((self):send_with_("handleOf","stSelector"))
end));
	return ((_s8_rec):cr())
end
)(self);return ((self):send_to_with_("pop","methods","key"))
end));
return (self);
end
,"api","unregister_in_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #methods to: [self send: #methods_Of with: #klass];cr.\r\n\tself if: [self send: #not_Nil with: #methods] do: [\r\n\t\tself assign: #key to: [self send: #handleOf with: #stSelector];cr.\r\n\t\tself send: #pop to: #methods with: #key\r\n\t] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"methods\",(function()\r\nreturn ((self):send_with_(\"methods_Of\",\"klass\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):if_do_((function()\r\nreturn ((self):send_with_(\"not_Nil\",\"methods\"))\r\nend),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"key\",(function()\r\nreturn ((self):send_with_(\"handleOf\",\"stSelector\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):send_to_with_(\"pop\",\"methods\",\"key\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"value_withInterval_StSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("invalidMessage:","\"value_withInterval_\""))
end));
return (self);
end
,"api","value_withInterval_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #invalidMessage: with: '\"value_withInterval_\"'] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"invalidMessage:\",\"\\\"value_withInterval_\\\"\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"value_withTimeout_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):from_import_("threading","Timer");
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):assign_to_("t",(function()
return ((self):call_withArguments_("Timer",(smalltalk.Array):with_with_((function()
return ((self):send_to_("asParameter","aNumber"))
end),(function()
return ((self):send_to_("asParameter","aBlock"))
end))))
end));
	return ((_s8_rec):cr())
end
)(self);
(
function(_s8_rec)
	(_s8_rec):send_to_("start","t");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("t");
return (self);
end
,"api","value_withTimeout_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself from: #threading import: #Timer;cr.\r\n\tself assign: #t to: [self call: #Timer withArguments: (Array\r\n\t\twith: [self send: #asParameter to: #aNumber]\r\n\t\twith: [self send: #asParameter to: #aBlock])\r\n\t];cr.\r\n\tself send: #start to: #t;cr.\r\n\tself return: #t ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):from_import_(\"threading\",\"Timer\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"t\",(function()\r\nreturn ((self):call_withArguments_(\"Timer\",(smalltalk.Array):with_with_((function()\r\nreturn ((self):send_to_(\"asParameter\",\"aNumber\"))\r\nend),(function()\r\nreturn ((self):send_to_(\"asParameter\",\"aBlock\"))\r\nend))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):send_to_(\"start\",\"t\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"t\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"versionStSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):import_("sys");
	return ((_s8_rec):cr())
end
)(self);
(self):return_("sys.version");
return (self);
end
,"api","versionStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself import: #sys;cr.\r\n\tself return: 'sys.version' ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):import_(\"sys\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"sys.version\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"whileNot_do_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):while_do_((function()
return ((self):expr_is_((function()
return ((self):call_("condition"))
end),"self.false"))
end),(function()
return ((self):send_with_("callBlock0:","aBlock"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("nil");
return (self);
end
,"api","whileNot_do_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself while: [self expr: [self call: #condition] is: 'self.false'] do: [\r\n\t\tself send: #callBlock0: with: #aBlock\r\n\t];cr.\r\n\tself return: #nil ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):while_do_((function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):call_(\"condition\"))\r\nend),\"self.false\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"callBlock0:\",\"aBlock\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"nil\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"while_do_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):while_do_((function()
return ((self):expr_is_((function()
return ((self):call_("condition"))
end),"self.true"))
end),(function()
return ((self):send_with_("callBlock0:","aBlock"))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_("nil");
return (self);
end
,"api","while_do_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself while: [self expr: [self call: #condition] is: 'self.true'] do: [\r\n\t\tself send: #callBlock0: with: #aBlock\r\n\t];cr.\r\n\tself return: #nil ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):while_do_((function()\r\nreturn ((self):expr_is_((function()\r\nreturn ((self):call_(\"condition\"))\r\nend),\"self.true\"))\r\nend),(function()\r\nreturn ((self):send_with_(\"callBlock0:\",\"aBlock\"))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_(\"nil\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"whoImplementsStSystemDictionary",0
,function(self)
(self):return_((function()
return ((self):send_with_("invalidMessage:","\"whoImplements\""))
end));
return (self);
end
,"api","whoImplementsStSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself return: [self send: #invalidMessage: with: '\"whoImplements\"'] ","function(self)\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"invalidMessage:\",\"\\\"whoImplements\\\"\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"will_be_StSystemDictionary",0
,function(self)
(self):comment_("return an object that will become an instance of class (named className) when accessed");
(self):send_with_("invalidMessage:","\"will:be:\"");
return (self);
end
,"api","will_be_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself comment: 'return an object that will become an instance of class (named className) when accessed'.\r\n\tself send: #invalidMessage: with: '\"will:be:\"' ","function(self)\r\n(self):comment_(\"return an object that will become an instance of class (named className) when accessed\");\r\n(self):send_with_(\"invalidMessage:\",\"\\\"will:be:\\\"\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"string_asPrivateSelector_StSystemDictionary",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):assign_to_("s",(function()
return ((self):expressions_(smalltalk:object_comma_(((smalltalk.Array):with_with_with_with_((function()
return ((self):send_with_("handleOf","receiver"))
end),(function()
(self):dot_((function()
return ((self):call_withArguments_("replace",smalltalk:newArray({"\":\"", "\"_\""})))
end));return ((self):dot_((function()
return ((self):call_withArguments_("replace",smalltalk:newArray({"\"+\"", "\"_plus\""})))
end)))
end),(function()
(self):dot_((function()
return ((self):call_withArguments_("replace",smalltalk:newArray({"\"-\"", "\"_minus\""})))
end));return ((self):dot_((function()
return ((self):call_withArguments_("replace",smalltalk:newArray({"\"*\"", "\"_star\""})))
end)))
end),(function()
(self):dot_((function()
return ((self):call_withArguments_("replace",smalltalk:newArray({"\"/\"", "\"_slash\""})))
end));return ((self):dot_((function()
return ((self):call_withArguments_("replace",smalltalk:newArray({"\"|\"", "\"_bar\""})))
end)))
end))),(smalltalk.Array):with_with_with_with_((function()
(self):dot_((function()
return ((self):call_withArguments_("replace",smalltalk:newArray({"\"&\"", "\"_amp\""})))
end));return ((self):dot_((function()
return ((self):call_withArguments_("replace",smalltalk:newArray({"\">\"", "\"_gt\""})))
end)))
end),(function()
(self):dot_((function()
return ((self):call_withArguments_("replace",smalltalk:newArray({"\"<\"", "\"_lt\""})))
end));return ((self):dot_((function()
return ((self):call_withArguments_("replace",smalltalk:newArray({"\"=\"", "\"_eq\""})))
end)))
end),(function()
(self):dot_((function()
return ((self):call_withArguments_("replace",smalltalk:newArray({"\",\"", "\"_comma\""})))
end));return ((self):dot_((function()
return ((self):call_withArguments_("replace",smalltalk:newArray({"\"@\"", "\"_at\""})))
end)))
end),(function()
(self):dot_((function()
return ((self):call_withArguments_("replace",smalltalk:newArray({"\"~\"", "\"_no\""})))
end));return ((self):dot_((function()
return ((self):call_withArguments_("replace",smalltalk:newArray({"\"\\\\\"", "\"_bk\""})))
end)))
end)))))
end));
	return ((_s8_rec):cr())
end
)(self);
(self):return_((function()
return ((self):send_with_("String","s"))
end));
return (self);
end
,"api","string_asPrivateSelector_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself assign: #s to: [\r\n\t\tself expressions: (Array\r\n\t\t\twith: [self send: #handleOf with: #receiver]\r\n\t\t\twith: [\tself dot: [self call: #replace withArguments: #('\":\"' '\"_\"')].\r\n\t\t\t\tself dot: [self call: #replace withArguments: #('\"+\"' '\"_plus\"')] ]\r\n\t\t\twith: [\tself dot: [self call: #replace withArguments: #('\"-\"' '\"_minus\"')].\r\n\t\t\t\tself dot: [self call: #replace withArguments: #('\"*\"' '\"_star\"')] ]\r\n\t\t\twith: [\tself dot: [self call: #replace withArguments: #('\"/\"' '\"_slash\"')].\r\n\t\t\t\tself dot: [self call: #replace withArguments: #('\"|\"' '\"_bar\"')] ]\r\n\t\t\t),(Array\r\n\t\t\twith: [\tself dot: [self call: #replace withArguments: #('\"&\"' '\"_amp\"')].\r\n\t\t\t\tself dot: [self call: #replace withArguments: #('\">\"' '\"_gt\"')] ]\r\n\t\t\twith: [\tself dot: [self call: #replace withArguments: #('\"<\"' '\"_lt\"')].\r\n\t\t\t\tself dot: [self call: #replace withArguments: #('\"=\"' '\"_eq\"')] ]\r\n\t\t\twith: [\tself dot: [self call: #replace withArguments: #('\",\"' '\"_comma\"')].\r\n\t\t\t\tself dot: [self call: #replace withArguments: #('\"@\"' '\"_at\"')] ]\r\n\t\t\twith: [\tself dot: [self call: #replace withArguments: #('\"~\"' '\"_no\"')].\r\n\t\t\t\tself dot: [self call: #replace withArguments: #('\"\\\\\"' '\"_bk\"')] ]\r\n\t\t\t)\r\n\t];cr.\r\n\tself return: [self send: #String with: #s] ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):assign_to_(\"s\",(function()\r\nreturn ((self):expressions_(smalltalk:object_comma_(((smalltalk.Array):with_with_with_with_((function()\r\nreturn ((self):send_with_(\"handleOf\",\"receiver\"))\r\nend),(function()\r\n(self):dot_((function()\r\nreturn ((self):call_withArguments_(\"replace\",smalltalk:newArray({\"\\\":\\\"\", \"\\\"_\\\"\"})))\r\nend));return ((self):dot_((function()\r\nreturn ((self):call_withArguments_(\"replace\",smalltalk:newArray({\"\\\"+\\\"\", \"\\\"_plus\\\"\"})))\r\nend)))\r\nend),(function()\r\n(self):dot_((function()\r\nreturn ((self):call_withArguments_(\"replace\",smalltalk:newArray({\"\\\"-\\\"\", \"\\\"_minus\\\"\"})))\r\nend));return ((self):dot_((function()\r\nreturn ((self):call_withArguments_(\"replace\",smalltalk:newArray({\"\\\"*\\\"\", \"\\\"_star\\\"\"})))\r\nend)))\r\nend),(function()\r\n(self):dot_((function()\r\nreturn ((self):call_withArguments_(\"replace\",smalltalk:newArray({\"\\\"/\\\"\", \"\\\"_slash\\\"\"})))\r\nend));return ((self):dot_((function()\r\nreturn ((self):call_withArguments_(\"replace\",smalltalk:newArray({\"\\\"|\\\"\", \"\\\"_bar\\\"\"})))\r\nend)))\r\nend))),(smalltalk.Array):with_with_with_with_((function()\r\n(self):dot_((function()\r\nreturn ((self):call_withArguments_(\"replace\",smalltalk:newArray({\"\\\"&\\\"\", \"\\\"_amp\\\"\"})))\r\nend));return ((self):dot_((function()\r\nreturn ((self):call_withArguments_(\"replace\",smalltalk:newArray({\"\\\">\\\"\", \"\\\"_gt\\\"\"})))\r\nend)))\r\nend),(function()\r\n(self):dot_((function()\r\nreturn ((self):call_withArguments_(\"replace\",smalltalk:newArray({\"\\\"<\\\"\", \"\\\"_lt\\\"\"})))\r\nend));return ((self):dot_((function()\r\nreturn ((self):call_withArguments_(\"replace\",smalltalk:newArray({\"\\\"=\\\"\", \"\\\"_eq\\\"\"})))\r\nend)))\r\nend),(function()\r\n(self):dot_((function()\r\nreturn ((self):call_withArguments_(\"replace\",smalltalk:newArray({\"\\\",\\\"\", \"\\\"_comma\\\"\"})))\r\nend));return ((self):dot_((function()\r\nreturn ((self):call_withArguments_(\"replace\",smalltalk:newArray({\"\\\"@\\\"\", \"\\\"_at\\\"\"})))\r\nend)))\r\nend),(function()\r\n(self):dot_((function()\r\nreturn ((self):call_withArguments_(\"replace\",smalltalk:newArray({\"\\\"~\\\"\", \"\\\"_no\\\"\"})))\r\nend));return ((self):dot_((function()\r\nreturn ((self):call_withArguments_(\"replace\",smalltalk:newArray({\"\\\"\\\\\\\\\\\"\", \"\\\"_bk\\\"\"})))\r\nend)))\r\nend)))))\r\nend));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\n(self):return_((function()\r\nreturn ((self):send_with_(\"String\",\"s\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PythonBoot,"array_sort_StSystemDictionary",0
,function(self)
(self):nextPutLines_(("\r\ndef merge(left, right):\r\n\tif len(left) == 0:\r\n\t\treturn right\r\n\tif len(right) == 0:\r\n\t\treturn left\r\n\tresult = []\r\n\tindex_left = index_right = 0\r\n\twhile len(result) < len(left) + len(right):\r\n\t\t#if left[index_left] <= right[index_right]:\r\n\t\tif self.b(aBlock.value_value_(anArray.unwrap_(left[index_left]),anArray.unwrap_(right[index_right]))):\r\n\t\t\tresult.append(left[index_left])\r\n\t\t\tindex_left += 1\r\n\t\telse:\r\n\t\t\tresult.append(right[index_right])\r\n\t\t\tindex_right += 1\r\n\t\tif index_right == len(right):\r\n\t\t\tresult += left[index_left:]\r\n\t\t\tbreak\r\n\t\tif index_left == len(left):\r\n\t\t\tresult += right[index_right:]\r\n\t\t\tbreak\r\n\treturn result\r\ndef insertion_sort(array, left=0, right=None):\r\n\tif right is None:\r\n\t\tright = len(array) - 1\r\n\tfor i in range(left + 1, right + 1):\r\n\t\tkey_item = array[i]\r\n\t\tj = i - 1\r\n\t\t#while j >= left and key_item < array[j]:\r\n\t\twhile j >= left and self.b(aBlock.value_value_(anArray.unwrap_(key_item),anArray.unwrap_(array[j]))):\r\n\t\t\tarray[j + 1] = array[j]\r\n\t\t\tj -= 1\r\n\t\tarray[j + 1] = key_item\r\n\treturn array\r\ndef timsort(array):\r\n\tmin_run = 32\r\n\tn = len(array)\r\n\tfor i in range(0, n, min_run):\r\n\t\tinsertion_sort(array, i, min((i + min_run - 1), n - 1))\r\n\tsize = min_run\r\n\twhile size < n:\r\n\t\tfor start in range(0, n, size * 2):\r\n\t\t\tmidpoint = start + size - 1\r\n\t\t\tend = min((start + size * 2 - 1), (n-1))\r\n\t\t\tmerged_array = merge(\r\n\t\t\t\tleft=array[start:midpoint + 1],\r\n\t\t\t\tright=array[midpoint + 1:end + 1])\r\n\t\t\tarray[start:start + len(merged_array)] = merged_array\r\n\t\tsize *= 2\r\n\treturn array\r\nif self.is_Nil(aBlock):\r\n\t# def defaultBlock(a,b): return a._lt(b) \r\n\t# aBlock = self.blk(defaultBlock,2)\r\n\taBlock = self.BlockClosure.defaultSortBlock()\r\ntimsort(self.handleOf(anArray))\r\nreturn anArray"):trimBlanks());
return (self);
end
,"api","array_sort_StSystemDictionary\r\n\t\" Private - Implementation of api function \"\r\n\r\n\tself nextPutLines: '\r\ndef merge(left, right):\r\n\tif len(left) == 0:\r\n\t\treturn right\r\n\tif len(right) == 0:\r\n\t\treturn left\r\n\tresult = []\r\n\tindex_left = index_right = 0\r\n\twhile len(result) < len(left) + len(right):\r\n\t\t#if left[index_left] <= right[index_right]:\r\n\t\tif self.b(aBlock.value_value_(anArray.unwrap_(left[index_left]),anArray.unwrap_(right[index_right]))):\r\n\t\t\tresult.append(left[index_left])\r\n\t\t\tindex_left += 1\r\n\t\telse:\r\n\t\t\tresult.append(right[index_right])\r\n\t\t\tindex_right += 1\r\n\t\tif index_right == len(right):\r\n\t\t\tresult += left[index_left:]\r\n\t\t\tbreak\r\n\t\tif index_left == len(left):\r\n\t\t\tresult += right[index_right:]\r\n\t\t\tbreak\r\n\treturn result\r\ndef insertion_sort(array, left=0, right=None):\r\n\tif right is None:\r\n\t\tright = len(array) - 1\r\n\tfor i in range(left + 1, right + 1):\r\n\t\tkey_item = array[i]\r\n\t\tj = i - 1\r\n\t\t#while j >= left and key_item < array[j]:\r\n\t\twhile j >= left and self.b(aBlock.value_value_(anArray.unwrap_(key_item),anArray.unwrap_(array[j]))):\r\n\t\t\tarray[j + 1] = array[j]\r\n\t\t\tj -= 1\r\n\t\tarray[j + 1] = key_item\r\n\treturn array\r\ndef timsort(array):\r\n\tmin_run = 32\r\n\tn = len(array)\r\n\tfor i in range(0, n, min_run):\r\n\t\tinsertion_sort(array, i, min((i + min_run - 1), n - 1))\r\n\tsize = min_run\r\n\twhile size < n:\r\n\t\tfor start in range(0, n, size * 2):\r\n\t\t\tmidpoint = start + size - 1\r\n\t\t\tend = min((start + size * 2 - 1), (n-1))\r\n\t\t\tmerged_array = merge(\r\n\t\t\t\tleft=array[start:midpoint + 1],\r\n\t\t\t\tright=array[midpoint + 1:end + 1])\r\n\t\t\tarray[start:start + len(merged_array)] = merged_array\r\n\t\tsize *= 2\r\n\treturn array\r\nif self.is_Nil(aBlock):\r\n\t# def defaultBlock(a,b): return a._lt(b) \r\n\t# aBlock = self.blk(defaultBlock,2)\r\n\taBlock = self.BlockClosure.defaultSortBlock()\r\ntimsort(self.handleOf(anArray))\r\nreturn anArray' trimBlanks","function(self)\r\n(self):nextPutLines_((\"\\r\\ndef merge(left, right):\\r\\n\\tif len(left) == 0:\\r\\n\\t\\treturn right\\r\\n\\tif len(right) == 0:\\r\\n\\t\\treturn left\\r\\n\\tresult = []\\r\\n\\tindex_left = index_right = 0\\r\\n\\twhile len(result) < len(left) + len(right):\\r\\n\\t\\t#if left[index_left] <= right[index_right]:\\r\\n\\t\\tif self.b(aBlock.value_value_(anArray.unwrap_(left[index_left]),anArray.unwrap_(right[index_right]))):\\r\\n\\t\\t\\tresult.append(left[index_left])\\r\\n\\t\\t\\tindex_left += 1\\r\\n\\t\\telse:\\r\\n\\t\\t\\tresult.append(right[index_right])\\r\\n\\t\\t\\tindex_right += 1\\r\\n\\t\\tif index_right == len(right):\\r\\n\\t\\t\\tresult += left[index_left:]\\r\\n\\t\\t\\tbreak\\r\\n\\t\\tif index_left == len(left):\\r\\n\\t\\t\\tresult += right[index_right:]\\r\\n\\t\\t\\tbreak\\r\\n\\treturn result\\r\\ndef insertion_sort(array, left=0, right=None):\\r\\n\\tif right is None:\\r\\n\\t\\tright = len(array) - 1\\r\\n\\tfor i in range(left + 1, right + 1):\\r\\n\\t\\tkey_item = array[i]\\r\\n\\t\\tj = i - 1\\r\\n\\t\\t#while j >= left and key_item < array[j]:\\r\\n\\t\\twhile j >= left and self.b(aBlock.value_value_(anArray.unwrap_(key_item),anArray.unwrap_(array[j]))):\\r\\n\\t\\t\\tarray[j + 1] = array[j]\\r\\n\\t\\t\\tj -= 1\\r\\n\\t\\tarray[j + 1] = key_item\\r\\n\\treturn array\\r\\ndef timsort(array):\\r\\n\\tmin_run = 32\\r\\n\\tn = len(array)\\r\\n\\tfor i in range(0, n, min_run):\\r\\n\\t\\tinsertion_sort(array, i, min((i + min_run - 1), n - 1))\\r\\n\\tsize = min_run\\r\\n\\twhile size < n:\\r\\n\\t\\tfor start in range(0, n, size * 2):\\r\\n\\t\\t\\tmidpoint = start + size - 1\\r\\n\\t\\t\\tend = min((start + size * 2 - 1), (n-1))\\r\\n\\t\\t\\tmerged_array = merge(\\r\\n\\t\\t\\t\\tleft=array[start:midpoint + 1],\\r\\n\\t\\t\\t\\tright=array[midpoint + 1:end + 1])\\r\\n\\t\\t\\tarray[start:start + len(merged_array)] = merged_array\\r\\n\\t\\tsize *= 2\\r\\n\\treturn array\\r\\nif self.is_Nil(aBlock):\\r\\n\\t# def defaultBlock(a,b): return a._lt(b) \\r\\n\\t# aBlock = self.blk(defaultBlock,2)\\r\\n\\taBlock = self.BlockClosure.defaultSortBlock()\\r\\ntimsort(self.handleOf(anArray))\\r\\nreturn anArray\"):trimBlanks());\r\nreturn (self);\r\nend")
