
-- fileIn("s8/library/scripting/Scripting.st")
smalltalk:addClass("ScriptingObject",smalltalk.Object,smalltalk:newArray({}),"Scripting")

smalltalk:addClass("ParseContext",smalltalk.ScriptingObject,smalltalk:newArray({"map","parent"}),"Scripting")

smalltalk:addClass("ParseNode",smalltalk.ScriptingObject,smalltalk:newArray({"sourceRange"}),"Scripting")

smalltalk:addClass("AssignNode",smalltalk.ParseNode,smalltalk:newArray({"variable","expression"}),"Scripting")

smalltalk:addClass("MessageNode",smalltalk.ParseNode,smalltalk:newArray({"receiver","selector","args","action"}),"Scripting")

smalltalk:addClass("NativeMessageNode",smalltalk.MessageNode,smalltalk:newArray({}),"Scripting")

smalltalk:addClass("ParseStatements",smalltalk.ParseNode,smalltalk:newArray({"temporaries","statements"}),"Scripting")

smalltalk:addClass("BlockClosureNode",smalltalk.ParseStatements,smalltalk:newArray({"args"}),"Scripting")

smalltalk:addClass("CascadedMessageNode",smalltalk.ParseStatements,smalltalk:newArray({"receiver"}),"Scripting")

smalltalk:addClass("Script",smalltalk.ParseStatements,smalltalk:newArray({}),"Scripting")

smalltalk:addClass("StepOverScript",smalltalk.Script,smalltalk:newArray({"action"}),"Scripting")

smalltalk:addClass("ParseVariable",smalltalk.ParseNode,smalltalk:newArray({"binding","indices"}),"Scripting")

smalltalk:addClass("ParseArgument",smalltalk.ParseVariable,smalltalk:newArray({"canBeAssigned"}),"Scripting")

smalltalk:addClass("ParseGlobalVariable",smalltalk.ParseVariable,smalltalk:newArray({}),"Scripting")

smalltalk:addClass("ParseGlobalConstant",smalltalk.ParseGlobalVariable,smalltalk:newArray({}),"Scripting")

smalltalk:addClass("ParseSpecial",smalltalk.ParseVariable,smalltalk:newArray({}),"Scripting")

smalltalk:addClass("ParseLiteral",smalltalk.ParseSpecial,smalltalk:newArray({}),"Scripting")

smalltalk:addClass("ParseInstanceVariable",smalltalk.ParseSpecial,smalltalk:newArray({"name","index"}),"Scripting")

smalltalk:addClass("ParseUniversal",smalltalk.ParseSpecial,smalltalk:newArray({}),"Scripting")

smalltalk:addClass("ParseSelf",smalltalk.ParseUniversal,smalltalk:newArray({}),"Scripting")

smalltalk:addClass("ParseSuper",smalltalk.ParseSelf,smalltalk:newArray({"implementor"}),"Scripting")

smalltalk:addClass("ParseNoReceiver",smalltalk.ParseSpecial,smalltalk:newArray({}),"Scripting")

smalltalk:addClass("ParseNativeVariable",smalltalk.ParseSpecial,smalltalk:newArray({}),"Scripting")

smalltalk:addClass("MethodExitNode",smalltalk.ParseNode,smalltalk:newArray({"exitBlock"}),"Scripting")

smalltalk:addClass("MethodReturnNode",smalltalk.MethodExitNode,smalltalk:newArray({"expression"}),"Scripting")

smalltalk:addClass("PrimitiveNode",smalltalk.MethodExitNode,smalltalk:newArray({"action"}),"Scripting")

smalltalk:addClass("ScriptParser",smalltalk.ScriptingObject,smalltalk:newArray({"currentClass","source","scope","instanceVariables","errorBlock"}),"Scripting")

smalltalk.ScriptParser["$klass"]["$iVarNames"]=smalltalk:newArray({"primitiveHandlers","defaultPrimitiveHandler"})

smalltalk:addClass("ScriptingError",smalltalk.ScriptingObject,smalltalk:newArray({"description"}),"Scripting")

smalltalk:addClass("ParseError",smalltalk.ScriptingError,smalltalk:newArray({"source","position"}),"Scripting")

smalltalk:addClass("SyntaxError",smalltalk.ParseError,smalltalk:newArray({}),"Scripting")

smalltalk:bind(smalltalk.ParseContext["$klass"],"default",0
,function(self)
return ((
function(_s8_rec)
	(_s8_rec):beDefault();
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"defaults","default\r\n\t\" Returns an instance of the receiver set to the default scope. \"\r\n\r\n\t^self new\r\n\t\tbeDefault;\r\n\t\tyourself ","function(self)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):beDefault();\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.ParseContext["$klass"],"in:",0
,function(self,aParentScope)
return ((
function(_s8_rec)
	(_s8_rec):parent_(aParentScope);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","in: aParentScope\r\n\t\" Returns the a new scope included in aParentScope. \"\r\n\r\n\t^self new\r\n\t\tparent: aParentScope;\r\n\t\tyourself ","function(self,aParentScope)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):parent_(aParentScope);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.ParseContext,"at:put:",0
,function(self,aKey,anObject)
return (((self):map()):at_put_(aKey,anObject));
end
,"accessing","at: aKey put: anObject\r\n\t\"Creates a new variable binding for aKey in the receiver's local context (the map). \"\r\n\r\n\t^self map at: aKey put: anObject","function(self,aKey,anObject)\r\nreturn (((self):map()):at_put_(aKey,anObject));\r\nend")

smalltalk:bind(smalltalk.ParseContext,"map",0
,function(self)
if (smalltalk:isNil_((self["@map"])))==true then (self):initializeMap(); end;
return (self["@map"]);
end
,"accessing","map\r\n\t\" Private - Returns the receiver's map. \"\r\n\r\n\tmap isNil ifTrue: [ self initializeMap ].\r\n\t^map ","function(self)\r\nif (smalltalk:isNil_((self[\"@map\"])))==true then (self):initializeMap(); end;\r\nreturn (self[\"@map\"]);\r\nend")

smalltalk:bind(smalltalk.ParseContext,"parent:",0
,function(self,aScope)
(function()
	local _s8_value=(aScope)
	self["@parent"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","parent: aScope\r\n\t\" Private - Sets the receiver's parent scope. \"\r\n\r\n\tparent := aScope ","function(self,aScope)\r\n(function()\r\n\tlocal _s8_value=(aScope)\r\n\tself[\"@parent\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseContext,"bindingAt:",0
,function(self,aName)
return ((self):bindingAt_ifAbsent_(aName,(function()
return ((self):error_("Absent element."))
end)));
end
,"binding","bindingAt: aName\r\n\t\" LookUp for variable named aName in the receiver.\r\n\tReturns the binding found for aName or produces an error if failed. \"\r\n\r\n\t^self bindingAt: aName ifAbsent: [ self error: 'Absent element.' ] ","function(self,aName)\r\nreturn ((self):bindingAt_ifAbsent_(aName,(function()\r\nreturn ((self):error_(\"Absent element.\"))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ParseContext,"bindingAt:ifAbsent:",0
,function(self,aName,errorBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local assoc=nil
local key=nil
if (smalltalk:isObject_equalTo_(((aName):size()),0))==true then return (nil); end;
(function()
	local _s8_value=((self):bindingIn_at_ifAbsent_((self):map(),aName,(function()
return (nil)
end)))
	assoc=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((assoc)))==true then return ((assoc):__local()); end;
if (smalltalk:is_kindOf_((self["@parent"]),(smalltalk.KeyedCollection)))==true then (function()
	local _s8_value=((self):bindingIn_at_ifAbsent_(self["@parent"],aName,(function()
return (nil)
end)))
	assoc=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:notNil_((assoc))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (assoc)
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:if_true_false_((smalltalk:notNil_((self["@parent"]))),(function()
return ((self["@parent"]):bindingAt_ifAbsent_(aName,errorBlock))
end),(function()
return ((errorBlock):value())
end)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"binding","bindingAt: aName ifAbsent: errorBlock\r\n\t\" LookUp for variable named aName in the receiver.\r\n\tReturns the binding found for aName or evaluates errorBlock if failed. \"\r\n\r\n\t| assoc key |\r\n\taName size = 0 ifTrue: [ ^nil ].\r\n\r\n\tassoc := self bindingIn: self map at: aName ifAbsent: [].\r\n\tassoc notNil ifTrue: [ ^assoc local ].\r\n\r\n\t(parent isKindOf: KeyedCollection) ifTrue: [\r\n\t\tassoc := self bindingIn: parent at: aName ifAbsent: [].\r\n\t\tassoc notNil ifTrue: [ ^assoc ].\r\n\t].\r\n\r\n\t^parent notNil\r\n\tifTrue: [ parent bindingAt: aName ifAbsent: errorBlock ]\r\n\tifFalse: [ errorBlock value ] ","function(self,aName,errorBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal assoc=nil\r\nlocal key=nil\r\nif (smalltalk:isObject_equalTo_(((aName):size()),0))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((self):bindingIn_at_ifAbsent_((self):map(),aName,(function()\r\nreturn (nil)\r\nend)))\r\n\tassoc=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((assoc)))==true then return ((assoc):__local()); end;\r\nif (smalltalk:is_kindOf_((self[\"@parent\"]),(smalltalk.KeyedCollection)))==true then (function()\r\n\tlocal _s8_value=((self):bindingIn_at_ifAbsent_(self[\"@parent\"],aName,(function()\r\nreturn (nil)\r\nend)))\r\n\tassoc=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:notNil_((assoc))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (assoc)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((self[\"@parent\"]))),(function()\r\nreturn ((self[\"@parent\"]):bindingAt_ifAbsent_(aName,errorBlock))\r\nend),(function()\r\nreturn ((errorBlock):value())\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ParseContext,"bindingIn:at:ifAbsent:",0
,function(self,aDictionary,aName,errorBlock)
local assoc=nil
local key=nil
return ((aDictionary):bindingAt_ifAbsent_(aName,(function()
(function()
	local _s8_value=(((aDictionary):keys()):detect_ifNone_((function(one)
return (smalltalk:isObject_equalTo_((smalltalk:asString_((one))),aName))
end),(function()
return (nil)
end)))
	key=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((key))),(function()
return ((aDictionary):bindingAt_ifAbsent_(key,(function()
return (nil)
end)))
end),nil))
end)));
end
,"binding","bindingIn: aDictionary at: aName ifAbsent: errorBlock\r\n\t\" Private - LookUp for variable named aName in the dictionary aDictionary. \"\r\n\r\n\t| assoc key |\r\n\t^aDictionary bindingAt: aName ifAbsent: [\r\n\t\tkey := aDictionary keys detect: [:one| one asString = aName ] ifNone: [].\r\n\t\tkey notNil ifTrue: [ aDictionary bindingAt: key ifAbsent: [] ]\r\n\t] ","function(self,aDictionary,aName,errorBlock)\r\nlocal assoc=nil\r\nlocal key=nil\r\nreturn ((aDictionary):bindingAt_ifAbsent_(aName,(function()\r\n(function()\r\n\tlocal _s8_value=(((aDictionary):keys()):detect_ifNone_((function(one)\r\nreturn (smalltalk:isObject_equalTo_((smalltalk:asString_((one))),aName))\r\nend),(function()\r\nreturn (nil)\r\nend)))\r\n\tkey=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((key))),(function()\r\nreturn ((aDictionary):bindingAt_ifAbsent_(key,(function()\r\nreturn (nil)\r\nend)))\r\nend),nil))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ParseContext,"initializeMap",0
,function(self)
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	self["@map"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeMap\r\n\t\" Private - Initializes the receiver's map. \"\r\n\r\n\tmap := PoolDictionary new ","function(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tself[\"@map\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseContext,"beDefault",0
,function(self)
(function()
	local _s8_value=((self):smalltalk())
	self["@parent"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"private","beDefault\r\n\t\" Private - Set the receiver as child of default context. \"\r\n\r\n\tparent := self smalltalk ","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):smalltalk())\r\n\tself[\"@parent\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseNode["$klass"],"sourceRange:",0
,function(self,interval)
return (((self):new()):sourceRange_(interval));
end
,"instantiation","sourceRange: interval\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^self new sourceRange: interval ","function(self,interval)\r\nreturn (((self):new()):sourceRange_(interval));\r\nend")

smalltalk:bind(smalltalk.ParseNode["$klass"],"from:to:",0
,function(self,start,stop)
return ((self):sourceRange_((start):to_(stop)));
end
,"instantiation","from: start to: stop\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^self sourceRange: (start to: stop) ","function(self,start,stop)\r\nreturn ((self):sourceRange_((start):to_(stop)));\r\nend")

smalltalk:bind(smalltalk.ParseNode,"sourcePosition:",0
,function(self,anInterval)
return ((self):sourceRange_(anInterval));
end
,"accessing","sourcePosition: anInterval\r\n\t\" Set the receiver's sourceRange. \"\r\n\r\n\t^self sourceRange: anInterval ","function(self,anInterval)\r\nreturn ((self):sourceRange_(anInterval));\r\nend")

smalltalk:bind(smalltalk.ParseNode,"sourceRange",0
,function(self)
return (self["@sourceRange"]);
end
,"accessing","sourceRange\r\n\t\" Returns the receiver's sourceRange. \"\r\n\r\n\t^sourceRange","function(self)\r\nreturn (self[\"@sourceRange\"]);\r\nend")

smalltalk:bind(smalltalk.ParseNode,"sourceRange:",0
,function(self,anInterval)
(function()
	local _s8_value=(anInterval)
	self["@sourceRange"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","sourceRange: anInterval\r\n\t\" Set the receiver's sourceRange. \"\r\n\r\n\tsourceRange := anInterval ","function(self,anInterval)\r\n(function()\r\n\tlocal _s8_value=(anInterval)\r\n\tself[\"@sourceRange\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseNode,",","_comma"
,function(self,aParseNode)
return ((smalltalk.ParseStatements):with_with_(self,aParseNode));
end
,"composing",", aParseNode\r\n\t\" Returns a composite parse node with the receiver and aParseNode appended at end. \"\r\n\r\n\t^ParseStatements\r\n\t\twith: self\r\n\t\twith: aParseNode ","function(self,aParseNode)\r\nreturn ((smalltalk.ParseStatements):with_with_(self,aParseNode));\r\nend")

smalltalk:bind(smalltalk.ParseNode,"evaluate",0
,function(self)
return ((self):evaluate_(nil));
end
,"evaluating","evaluate\r\n\t\" Evaluate the receiver in an empty context. \"\r\n\r\n\t^self evaluate: nil ","function(self)\r\nreturn ((self):evaluate_(nil));\r\nend")

smalltalk:bind(smalltalk.ParseNode,"evaluate:",0
,function(self,aReceiver)
return ((self):evaluateIn_((smalltalk.S8Context):for_(aReceiver)));
end
,"evaluating","evaluate: aReceiver\r\n\t\" Returns the result of evaluating the receiver in a context bound to aReceiver. \"\r\n\r\n\t^self evaluateIn: (S8Context for: aReceiver) ","function(self,aReceiver)\r\nreturn ((self):evaluateIn_((smalltalk.S8Context):for_(aReceiver)));\r\nend")

smalltalk:bind(smalltalk.ParseNode,"evaluateIn:",0
,function(self,aContext)
return ((self):subclassResponsibility_("evaluateIn:"));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext.\r\n\tThis message must be implemented by the subclasses. \"\r\n\r\n\t^self subclassResponsibility: #evaluateIn: ","function(self,aContext)\r\nreturn ((self):subclassResponsibility_(\"evaluateIn:\"));\r\nend")

smalltalk:bind(smalltalk.ParseNode,"exitBlock:",0
,function(self,aBlock)
return (self);
end
,"evaluating","exitBlock: aBlock\r\n\t\" Set the exit block of the receiver.\r\n\tThis block will be used to abort execution of the receiver.\r\n\tDo nothing by default.\r\n\tThis method can be refined by subclasses. \" ","function(self,aBlock)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseNode,"clear:",0
,function(self,aContext)
return ((self):subclassResponsibility());
end
,"private","clear: aContext\r\n\t\" Private - Clear the receiver's cached state.\r\n\tThis method must be implemented by subclasses. \"\r\n\r\n\t^self subclassResponsibility ","function(self,aContext)\r\nreturn ((self):subclassResponsibility());\r\nend")

smalltalk:bind(smalltalk.ParseNode,"isComposite",0
,function(self)
return (false);
end
,"query","isComposite\r\n\t\" Returns true if the receiver is a composite parse node. \"\r\n\r\n\t^false ","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.ParseNode,"isReturn",0
,function(self)
return (false);
end
,"query","isReturn\r\n\t\" Returns true if the receiver is a return parse node. \"\r\n\r\n\t^false ","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.ParseNode,"isSuper",0
,function(self)
return (false);
end
,"query","isSuper\r\n\t\" Returns true if the receiver is a reference to super. \"\r\n\r\n\t^false ","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.ParseNode,"isOO",0
,function(self)
return (true);
end
,"query","isOO\r\n\t\" Returns true if the receiver refers to an object. \"\r\n\r\n\t^true ","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.ParseNode,"isMessageNode",0
,function(self)
return (false);
end
,"query","isMessageNode\r\n\t\" Returns true if the receiver is a message send. \"\r\n\r\n\t^false ","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.ParseNode,"isPrimitiveNode",0
,function(self)
return (false);
end
,"query","isPrimitiveNode\r\n\t\" Returns true if the receiver is a primitive. \"\r\n\r\n\t^false ","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.ParseNode,"isVariable",0
,function(self)
return (false);
end
,"query","isVariable\r\n\t\" Returns true if the receiver is a variable parse node. \"\r\n\r\n\t^false ","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.AssignNode,"expression",0
,function(self)
return (self["@expression"]);
end
,"accessing","expression\r\n\t\" Returns the receiver's expression. \"\r\n\r\n\t^expression ","function(self)\r\nreturn (self[\"@expression\"]);\r\nend")

smalltalk:bind(smalltalk.AssignNode,"expression:",0
,function(self,anExpression)
(function()
	local _s8_value=(anExpression)
	self["@expression"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","expression: anExpression\r\n\t\" Set the receiver's expression. \"\r\n\r\n\texpression := anExpression","function(self,anExpression)\r\n(function()\r\n\tlocal _s8_value=(anExpression)\r\n\tself[\"@expression\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.AssignNode,"variable",0
,function(self)
return (self["@variable"]);
end
,"accessing","variable\r\n\t\" Returns the receiver's variable. \"\r\n\r\n\t^variable ","function(self)\r\nreturn (self[\"@variable\"]);\r\nend")

smalltalk:bind(smalltalk.AssignNode,"variable:",0
,function(self,aVariable)
(function()
	local _s8_value=(aVariable)
	self["@variable"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","variable: aVariable\r\n\t\" Set the receiver's variable. \"\r\n\r\n\tvariable := aVariable ","function(self,aVariable)\r\n(function()\r\n\tlocal _s8_value=(aVariable)\r\n\tself[\"@variable\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.AssignNode,"exitBlock:",0
,function(self,aBlock)
smalltalk:superImplementor(smalltalk.AssignNode,"exitBlock_")(self,aBlock);
((self):variable()):exitBlock_(aBlock);
((self):expression()):exitBlock_(aBlock);
return (self);
end
,"evaluating","exitBlock: aBlock\r\n\t\" Set the exit block of the receiver. \"\r\n\r\n\tsuper exitBlock: aBlock.\r\n\tself variable exitBlock: aBlock.\r\n\tself expression exitBlock: aBlock ","function(self,aBlock)\r\nsmalltalk:superImplementor(smalltalk.AssignNode,\"exitBlock_\")(self,aBlock);\r\n((self):variable()):exitBlock_(aBlock);\r\n((self):expression()):exitBlock_(aBlock);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.AssignNode,"evaluateIn:",0
,function(self,aContext)
return (((self):variable()):bind_in_(((self):expression()):evaluateIn_(aContext),aContext));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t^self variable bind: (self expression evaluateIn: aContext) in: aContext ","function(self,aContext)\r\nreturn (((self):variable()):bind_in_(((self):expression()):evaluateIn_(aContext),aContext));\r\nend")

smalltalk:bind(smalltalk.MessageNode["$klass"],"actionToSend:ifAbsent:",0
,function(self,selector,aBlock)
return (((smalltalk.S8Block):optimizations()):at_ifAbsent_(selector,aBlock));
end
,"actions","actionToSend: selector ifAbsent: aBlock\r\n\t\" Private - Returns the block to evaluate for sending message selector. \"\r\n\r\n\t^S8Block optimizations at: selector ifAbsent: aBlock ","function(self,selector,aBlock)\r\nreturn (((smalltalk.S8Block):optimizations()):at_ifAbsent_(selector,aBlock));\r\nend")

smalltalk:bind(smalltalk.MessageNode["$klass"],"native:from:to:",0
,function(self,isNative,start,stop)
return ((smalltalk:if_true_false_((isNative),(function()
return (smalltalk.NativeMessageNode)
end),(function()
return (smalltalk.MessageNode)
end))):from_to_(start,stop));
end
,"instantiation","native: isNative from: start to: stop\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^(isNative\r\n\t\tifTrue: [ NativeMessageNode ]\r\n\t\tifFalse: [ MessageNode ])\r\n\t\tfrom: start to: stop ","function(self,isNative,start,stop)\r\nreturn ((smalltalk:if_true_false_((isNative),(function()\r\nreturn (smalltalk.NativeMessageNode)\r\nend),(function()\r\nreturn (smalltalk.MessageNode)\r\nend))):from_to_(start,stop));\r\nend")

smalltalk:bind(smalltalk.MessageNode["$klass"],"receiver:selector:arguments:",0
,function(self,receiver,selector,args)
return (((self):new()):receiver_selector_arguments_(receiver,selector,args));
end
,"instantiation","receiver: receiver selector: selector arguments: args\r\n\t\" Returns a new instance of the receiver. \"\r\n\r\n\t^self new receiver: receiver selector: selector arguments: args ","function(self,receiver,selector,args)\r\nreturn (((self):new()):receiver_selector_arguments_(receiver,selector,args));\r\nend")

smalltalk:bind(smalltalk.MessageNode,"receiver:selector:arguments:",0
,function(self,aParseNode,aSelector,aCollection)
(
function(_s8_rec)
	(_s8_rec):receiver_(aParseNode);
	(_s8_rec):selector_(aSelector);
	return ((_s8_rec):arguments_(aCollection))
end
)(self);
return (self);
end
,"accessing","receiver: aParseNode selector: aSelector arguments: aCollection\r\n\t\" Set the receiver contents. \"\r\n\r\n\tself\treceiver: aParseNode;\r\n\t\tselector: aSelector;\r\n\t\targuments: aCollection ","function(self,aParseNode,aSelector,aCollection)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):receiver_(aParseNode);\r\n\t(_s8_rec):selector_(aSelector);\r\n\treturn ((_s8_rec):arguments_(aCollection))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.MessageNode,"args",0
,function(self)
return (self["@args"]);
end
,"accessing","args\r\n\t^args ","function(self)\r\nreturn (self[\"@args\"]);\r\nend")

smalltalk:bind(smalltalk.MessageNode,"args:",0
,function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@args"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","args: aCollection\r\n\targs := aCollection ","function(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@args\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.MessageNode,"arguments",0
,function(self)
return ((self):args());
end
,"accessing","arguments\r\n\t^self args ","function(self)\r\nreturn ((self):args());\r\nend")

smalltalk:bind(smalltalk.MessageNode,"arguments:",0
,function(self,aCollection)
(self):args_(aCollection);
return (self);
end
,"accessing","arguments: aCollection\r\n\tself args: aCollection","function(self,aCollection)\r\n(self):args_(aCollection);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.MessageNode,"receiver",0
,function(self)
return (self["@receiver"]);
end
,"accessing","receiver\r\n\t^receiver","function(self)\r\nreturn (self[\"@receiver\"]);\r\nend")

smalltalk:bind(smalltalk.MessageNode,"receiver:",0
,function(self,aParseNode)
(function()
	local _s8_value=(aParseNode)
	self["@receiver"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","receiver: aParseNode\r\n\treceiver := aParseNode ","function(self,aParseNode)\r\n(function()\r\n\tlocal _s8_value=(aParseNode)\r\n\tself[\"@receiver\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.MessageNode,"selector",0
,function(self)
return (self["@selector"]);
end
,"accessing","selector\r\n\t^selector","function(self)\r\nreturn (self[\"@selector\"]);\r\nend")

smalltalk:bind(smalltalk.MessageNode,"selector:",0
,function(self,aSymbol)
(function()
	local _s8_value=(aSymbol)
	self["@selector"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","selector: aSymbol\r\n\tselector := aSymbol ","function(self,aSymbol)\r\n(function()\r\n\tlocal _s8_value=(aSymbol)\r\n\tself[\"@selector\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.MessageNode,"isMessageNode",0
,function(self)
return (true);
end
,"query","isMessageNode\r\n\t\" Returns true if the receiver is a message send. \"\r\n\r\n\t^true ","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.MessageNode,"evaluateIn:",0
,function(self,aContext)
local value=nil
(function()
	local _s8_value=(((self):receiver()):evaluateIn_(aContext))
	value=_s8_value
	return _s8_value
end)();
return ((self):evaluate_value_in_((self):receiver(),value,aContext));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t| value |\r\n\tvalue := self receiver evaluateIn: aContext.\r\n\t^self evaluate: self receiver value: value in: aContext ","function(self,aContext)\r\nlocal value=nil\r\n(function()\r\n\tlocal _s8_value=(((self):receiver()):evaluateIn_(aContext))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):evaluate_value_in_((self):receiver(),value,aContext));\r\nend")

smalltalk:bind(smalltalk.MessageNode,"actionToSend:",0
,function(self,aSymbol)
return (((self)["$klass"]):actionToSend_ifAbsent_(aSymbol,(function()
return ((function(receiver,msg,values,context)
return ((receiver):perform_withArguments_(msg,values))
end))
end)));
end
,"actions","actionToSend: aSymbol\r\n\t\" Private - Returns the block to evaluate for sending message aSymbol. \"\r\n\r\n\t^self class actionToSend: aSymbol ifAbsent: [\r\n\t\t[:receiver :msg :values :context|\r\n\t\t\treceiver perform: msg withArguments: values\r\n\t\t]\r\n\t] ","function(self,aSymbol)\r\nreturn (((self)[\"$klass\"]):actionToSend_ifAbsent_(aSymbol,(function()\r\nreturn ((function(receiver,msg,values,context)\r\nreturn ((receiver):perform_withArguments_(msg,values))\r\nend))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.MessageNode,"valuesToSend:to:withArguments:in:",0
,function(self,msg,anObject,values,aContext)
return (values);
end
,"sending","valuesToSend: msg to: anObject withArguments: values in: aContext\r\n\t\" Private - Returns the arguments to send msg to anObject. \"\r\n\r\n\t^values ","function(self,msg,anObject,values,aContext)\r\nreturn (values);\r\nend")

smalltalk:bind(smalltalk.MessageNode,"send:to:withArguments:in:",0
,function(self,msg,anObject,values,aContext)
if (smalltalk:isNil_((self["@action"])))==true then (function()
	local _s8_value=((self):actionToSend_(msg))
	self["@action"]=_s8_value
	return _s8_value
end)(); end;
return ((self["@action"]):value_value_value_value_(anObject,msg,(self):valuesToSend_to_withArguments_in_(msg,anObject,values,aContext),aContext));
end
,"sending","send: msg to: anObject withArguments: values in: aContext\r\n\t\" Private - Returns the result of sending message to anObject in aContext. \"\r\n\r\n\taction isNil ifTrue: [ action := self actionToSend: msg ].\r\n\t^action\tvalue: anObject value: msg\r\n\t\tvalue: (self\r\n\t\t\tvaluesToSend: msg to: anObject\r\n\t\t\twithArguments: values in: aContext)\r\n\t\tvalue: aContext ","function(self,msg,anObject,values,aContext)\r\nif (smalltalk:isNil_((self[\"@action\"])))==true then (function()\r\n\tlocal _s8_value=((self):actionToSend_(msg))\r\n\tself[\"@action\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((self[\"@action\"]):value_value_value_value_(anObject,msg,(self):valuesToSend_to_withArguments_in_(msg,anObject,values,aContext),aContext));\r\nend")

smalltalk:bind(smalltalk.MessageNode,"evaluate:value:in:",0
,function(self,aReceiver,anObject,aContext)
local values=nil
(function()
	local _s8_value=(((self):args()):collect_((function(each)
return ((each):evaluateIn_(aContext))
end)))
	values=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_or_(((aReceiver):isSuper()),(function()
return (smalltalk:booleanNot_(((aReceiver):isOO())))
end)))==true then return ((aReceiver):send_to_withArguments_in_((self):selector(),anObject,values,aContext)); end;
return ((self):send_to_withArguments_in_((self):selector(),anObject,values,aContext));
end
,"evaluating","evaluate: aReceiver value: anObject in: aContext\r\n\t\" Private - Returns the result of sending message to anObject in aContext. \"\r\n\r\n\t| values |\r\n\tvalues := self args collect: [:each| each evaluateIn: aContext ].\r\n\t(aReceiver isSuper or: [ aReceiver isOO not ]) ifTrue: [\r\n\t\t^aReceiver send: self selector to: anObject withArguments: values in: aContext\r\n\t].\r\n\t^self send: self selector to: anObject withArguments: values in: aContext","function(self,aReceiver,anObject,aContext)\r\nlocal values=nil\r\n(function()\r\n\tlocal _s8_value=(((self):args()):collect_((function(each)\r\nreturn ((each):evaluateIn_(aContext))\r\nend)))\r\n\tvalues=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_or_(((aReceiver):isSuper()),(function()\r\nreturn (smalltalk:booleanNot_(((aReceiver):isOO())))\r\nend)))==true then return ((aReceiver):send_to_withArguments_in_((self):selector(),anObject,values,aContext)); end;\r\nreturn ((self):send_to_withArguments_in_((self):selector(),anObject,values,aContext));\r\nend")

smalltalk:bind(smalltalk.MessageNode,"exitBlock:",0
,function(self,aBlock)
smalltalk:superImplementor(smalltalk.MessageNode,"exitBlock_")(self,aBlock);
((self):receiver()):exitBlock_(aBlock);
((self):args()):do_((function(each)
return ((each):exitBlock_(aBlock))
end));
return (self);
end
,"evaluating","exitBlock: aBlock\r\n\t\" Set the exit block of the receiver. \"\r\n\r\n\tsuper exitBlock: aBlock.\r\n\tself receiver exitBlock: aBlock.\r\n\tself args do: [:each| each exitBlock: aBlock ] ","function(self,aBlock)\r\nsmalltalk:superImplementor(smalltalk.MessageNode,\"exitBlock_\")(self,aBlock);\r\n((self):receiver()):exitBlock_(aBlock);\r\n((self):args()):do_((function(each)\r\nreturn ((each):exitBlock_(aBlock))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeMessageNode,"selector:",0
,function(self,aSymbol)
smalltalk:superImplementor(smalltalk.NativeMessageNode,"selector_")(self,(aSymbol):upTo_(":"));
return (self);
end
,"accessing","selector: aSymbol\r\n\t\" Set the selector converting aSymbol to native selector. \"\r\n\r\n\tsuper selector: (aSymbol upTo: $:) ","function(self,aSymbol)\r\nsmalltalk:superImplementor(smalltalk.NativeMessageNode,\"selector_\")(self,(aSymbol):upTo_(\":\"));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeMessageNode,"valuesToSend:to:withArguments:in:",0
,function(self,msg,anObject,values,aContext)
return ((values):collect_((function(each)
return (smalltalk:if_true_false_((smalltalk:is_kindOf_((each),(smalltalk.SimulationBlock))),(function()
return ((self):callableOf_(each))
end),(function()
return (each)
end)))
end)));
end
,"sending","valuesToSend: msg to: anObject withArguments: values in: aContext\r\n\t\" Private - Returns the arguments to send msg to anObject. \"\r\n\r\n\t^values collect: [:each|\r\n\t\t(each isKindOf: SimulationBlock)\r\n\t\tifTrue: [ self callableOf: each ]\r\n\t\tifFalse: [ each ]\r\n\t] ","function(self,msg,anObject,values,aContext)\r\nreturn ((values):collect_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:is_kindOf_((each),(smalltalk.SimulationBlock))),(function()\r\nreturn ((self):callableOf_(each))\r\nend),(function()\r\nreturn (each)\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeMessageNode,"send:to:withArguments:in:",0
,function(self,msg,anObject,values,aContext)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local fn=nil
local anArray=nil
(function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((anObject),msg,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_(("Missing function "),(msg):asLiteral())))
end
)()
error(_s8Ret_,0)
end)())
end)))
	fn=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):valuesToSend_to_withArguments_in_(msg,anObject,values,aContext))
	anArray=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (fn(anObject,(table.unpack or unpack)(anArray)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"sending","send: msg to: anObject withArguments: values in: aContext\r\n\t\" Private - Returns the result of sending message to anObject in aContext. \"\r\n\r\n\t| fn anArray |\r\n\tfn := anObject basicAt: msg ifAbsent: [\r\n\t\t^self error: 'Missing function ' ,msg asLiteral\r\n\t].\r\n\tanArray := self\r\n\t\tvaluesToSend: msg to: anObject\r\n\t\twithArguments: values in: aContext.\r\n\t^{''\r\n\tjs'fn.apply(anObject,anArray)'\r\n\tlua'fn(anObject,(table.unpack or unpack)(anArray))'\r\n\tpy'__0__.fn(anObject,*smalltalk.objects_toCall_(anArray,__0__.fn))'}","function(self,msg,anObject,values,aContext)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal fn=nil\r\nlocal anArray=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((anObject),msg,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Missing function \"),(msg):asLiteral())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):valuesToSend_to_withArguments_in_(msg,anObject,values,aContext))\r\n\tanArray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (fn(anObject,(table.unpack or unpack)(anArray)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ParseStatements["$klass"],"with:",0
,function(self,aStatement)
return ((
function(_s8_rec)
	(_s8_rec):add_(aStatement);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","with: aStatement\r\n\t\" Returns an instance of the receiver containing aStatement. \"\r\n\r\n\t^self new\r\n\t\tadd: aStatement;\r\n\t\tyourself ","function(self,aStatement)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(aStatement);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.ParseStatements["$klass"],"with:with:",0
,function(self,statement1,statement2)
return ((
function(_s8_rec)
	(_s8_rec):add_(statement1);
	(_s8_rec):add_(statement2);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","with: statement1 with: statement2\r\n\t\" Returns an instance of the receiver containing the statements. \"\r\n\r\n\t^self new\r\n\t\tadd: statement1;\r\n\t\tadd: statement2;\r\n\t\tyourself ","function(self,statement1,statement2)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(statement1);\r\n\t(_s8_rec):add_(statement2);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.ParseStatements["$klass"],"with:with:with:",0
,function(self,statement1,statement2,statement3)
return ((
function(_s8_rec)
	(_s8_rec):add_(statement1);
	(_s8_rec):add_(statement2);
	(_s8_rec):add_(statement3);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","with: statement1 with: statement2 with: statement3\r\n\t\" Returns an instance of the receiver containing the statements. \"\r\n\r\n\t^self new\r\n\t\tadd: statement1;\r\n\t\tadd: statement2;\r\n\t\tadd: statement3;\r\n\t\tyourself ","function(self,statement1,statement2,statement3)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(statement1);\r\n\t(_s8_rec):add_(statement2);\r\n\t(_s8_rec):add_(statement3);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.ParseStatements["$klass"],"with:with:with:with:",0
,function(self,statement1,statement2,statement3,statement4)
return ((
function(_s8_rec)
	(_s8_rec):add_(statement1);
	(_s8_rec):add_(statement2);
	(_s8_rec):add_(statement3);
	(_s8_rec):add_(statement4);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","with: statement1 with: statement2 with: statement3 with: statement4\r\n\t\" Returns an instance of the receiver containing the statements. \"\r\n\r\n\t^self new\r\n\t\tadd: statement1;\r\n\t\tadd: statement2;\r\n\t\tadd: statement3;\r\n\t\tadd: statement4;\r\n\t\tyourself ","function(self,statement1,statement2,statement3,statement4)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(statement1);\r\n\t(_s8_rec):add_(statement2);\r\n\t(_s8_rec):add_(statement3);\r\n\t(_s8_rec):add_(statement4);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.ParseStatements["$klass"],"withAll:",0
,function(self,aCollection)
return ((
function(_s8_rec)
	(_s8_rec):addAll_(aCollection);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","withAll: aCollection\r\n\t\" Returns an instance of the receiver containing all the statements in aCollection. \"\r\n\r\n\t^self new\r\n\t\taddAll: aCollection;\r\n\t\tyourself ","function(self,aCollection)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAll_(aCollection);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"statements",0
,function(self)
if (smalltalk:isNil_((self["@statements"])))==true then (self):initializeStatements(); end;
return (self["@statements"]);
end
,"accessing","statements\r\n\t\" Returns the receiver's statements. \"\r\n\r\n\tstatements isNil ifTrue: [ self initializeStatements ].\r\n\t^statements ","function(self)\r\nif (smalltalk:isNil_((self[\"@statements\"])))==true then (self):initializeStatements(); end;\r\nreturn (self[\"@statements\"]);\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"temporaries",0
,function(self)
if (smalltalk:isNil_((self["@temporaries"])))==true then (self):initializeTemporaries(); end;
return (self["@temporaries"]);
end
,"accessing","temporaries\r\n\t\" Returns the receiver's temporaries. \"\r\n\r\n\ttemporaries isNil ifTrue: [ self initializeTemporaries ].\r\n\t^temporaries ","function(self)\r\nif (smalltalk:isNil_((self[\"@temporaries\"])))==true then (self):initializeTemporaries(); end;\r\nreturn (self[\"@temporaries\"]);\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"temporaries:",0
,function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@temporaries"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","temporaries: aCollection\r\n\t\" Set the receiver's temporaries. \"\r\n\r\n\ttemporaries := aCollection ","function(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@temporaries\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"sourceRange",0
,function(self)
local start=nil
local __end=nil
if (smalltalk:notNil_((self["@sourceRange"])))==true then return (self["@sourceRange"]); end;
if (smalltalk:isObject_equalTo_(((self["@statements"]):size()),0))==true then return (nil); end;
(function()
	local _s8_value=(999)
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(0)
	__end=_s8_value
	return _s8_value
end)();
(self["@statements"]):do_((function(each)
local range=nil
(function()
	local _s8_value=((each):sourceRange())
	range=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((range))),(function()
(function()
	local _s8_value=((start):min_((range):start()))
	start=_s8_value
	return _s8_value
end)();return ((function()
	local _s8_value=((__end):max_((range):__end()))
	__end=_s8_value
	return _s8_value
end)())
end),nil))
end));
if (smalltalk:isObject_equalTo_((__end),0))==true then return (nil); end;
return ((start):to_(__end));
end
,"accessing","sourceRange\r\n\t\" Returns the receiver's sourceRange. \"\r\n\r\n\t| start end |\r\n\tsourceRange notNil ifTrue: [ ^sourceRange ].\r\n\tstatements size = 0 ifTrue: [ ^nil ].\r\n\r\n\tstart := 999. end := 0.\r\n\tstatements do: [:each| | range |\r\n\t\trange := each sourceRange.\r\n\t\trange notNil ifTrue: [\r\n\t\t\tstart := start min: range start.\r\n\t\t\tend := end max: range end.\r\n\t\t].\r\n\t].\r\n\tend = 0 ifTrue: [ ^nil ].\r\n\r\n\t^start to: end ","function(self)\r\nlocal start=nil\r\nlocal __end=nil\r\nif (smalltalk:notNil_((self[\"@sourceRange\"])))==true then return (self[\"@sourceRange\"]); end;\r\nif (smalltalk:isObject_equalTo_(((self[\"@statements\"]):size()),0))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=(999)\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\t__end=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self[\"@statements\"]):do_((function(each)\r\nlocal range=nil\r\n(function()\r\n\tlocal _s8_value=((each):sourceRange())\r\n\trange=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((range))),(function()\r\n(function()\r\n\tlocal _s8_value=((start):min_((range):start()))\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();return ((function()\r\n\tlocal _s8_value=((__end):max_((range):__end()))\r\n\t__end=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),nil))\r\nend));\r\nif (smalltalk:isObject_equalTo_((__end),0))==true then return (nil); end;\r\nreturn ((start):to_(__end));\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"add:",0
,function(self,aStatement)
return ((self):addLast_(aStatement));
end
,"collection","add: aStatement\r\n\t\"Add aStatement to the receiver. \"\r\n\r\n\t^self addLast: aStatement ","function(self,aStatement)\r\nreturn ((self):addLast_(aStatement));\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"addAll:",0
,function(self,aCollection)
return (((self):statements()):addAll_(aCollection));
end
,"collection","addAll: aCollection\r\n\t\"Add aCollection of statements to the receiver. \"\r\n\r\n\t^self statements addAll: aCollection ","function(self,aCollection)\r\nreturn (((self):statements()):addAll_(aCollection));\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"addFirst:",0
,function(self,aStatement)
return (((self):statements()):addFirst_(aStatement));
end
,"collection","addFirst: aStatement\r\n\t\"Add aStatement to the receiver. \"\r\n\r\n\t^self statements addFirst: aStatement ","function(self,aStatement)\r\nreturn (((self):statements()):addFirst_(aStatement));\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"addFirstAll:",0
,function(self,aCollection)
((aCollection):asArray()):reverseDo_((function(each)
return (((self):statements()):addFirst_(each))
end));
return (self);
end
,"collection","addFirstAll: aCollection\r\n\t\"Add aCollection of statements to the receiver. \"\r\n\r\n\taCollection asArray reverseDo: [:each|\r\n\t\tself statements addFirst: each\r\n\t] ","function(self,aCollection)\r\n((aCollection):asArray()):reverseDo_((function(each)\r\nreturn (((self):statements()):addFirst_(each))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"addLast:",0
,function(self,aStatement)
return (((self):statements()):addLast_(aStatement));
end
,"collection","addLast: aStatement\r\n\t\"Add aStatement to the receiver. \"\r\n\r\n\t^self statements addLast: aStatement ","function(self,aStatement)\r\nreturn (((self):statements()):addLast_(aStatement));\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"remove:",0
,function(self,aStatement)
return (((self):statements()):remove_(aStatement));
end
,"collection","remove: aStatement\r\n\t\"Remove aStatement from the receiver. \"\r\n\r\n\t^self statements remove: aStatement ","function(self,aStatement)\r\nreturn (((self):statements()):remove_(aStatement));\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"removeAll:",0
,function(self,aCollection)
return (((self):statements()):removeAll_(aCollection));
end
,"collection","removeAll: aCollection\r\n\t\"Remove aCollection of statements from the receiver. \"\r\n\r\n\t^self statements removeAll: aCollection ","function(self,aCollection)\r\nreturn (((self):statements()):removeAll_(aCollection));\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"contextVariables",0
,function(self)
return ((self):temporaries());
end
,"activation","contextVariables\r\n\t\" Private - Returns the variables involved in activation of the receiver. \"\r\n\r\n\t^self temporaries ","function(self)\r\nreturn ((self):temporaries());\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"evaluateContentsIn:",0
,function(self,localContext)
return (((self):statements()):inject_into_(nil,(function(result,each)
return ((each):evaluateIn_(localContext))
end)));
end
,"evaluating","evaluateContentsIn: localContext\r\n\t\" Private - Returns the result of evaluating the contents of the receiver in local context. \"\r\n\r\n\t^self statements inject: nil into: [:result :each|\r\n\t\teach evaluateIn: localContext\r\n\t]","function(self,localContext)\r\nreturn (((self):statements()):inject_into_(nil,(function(result,each)\r\nreturn ((each):evaluateIn_(localContext))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"evaluateIn:",0
,function(self,aContext)
return ((smalltalk.S8Context):in_clear_do_(aContext,(self):contextVariables(),(function(ctx)
return ((self):evaluateContentsIn_(ctx))
end)));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t^S8Context\r\n\t\tin: aContext clear: self contextVariables\r\n\t\tdo: [:ctx| self evaluateContentsIn: ctx ] ","function(self,aContext)\r\nreturn ((smalltalk.S8Context):in_clear_do_(aContext,(self):contextVariables(),(function(ctx)\r\nreturn ((self):evaluateContentsIn_(ctx))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"exitBlock:",0
,function(self,aBlock)
smalltalk:superImplementor(smalltalk.ParseStatements,"exitBlock_")(self,aBlock);
((self):temporaries()):do_((function(each)
return ((each):exitBlock_(aBlock))
end));
((self):statements()):do_((function(each)
return ((each):exitBlock_(aBlock))
end));
return (self);
end
,"evaluating","exitBlock: aBlock\r\n\t\" Set the exit block of the receiver. \"\r\n\r\n\tsuper exitBlock: aBlock.\r\n\tself temporaries do: [:each| each exitBlock: aBlock ].\r\n\tself statements do: [:each| each exitBlock: aBlock ] ","function(self,aBlock)\r\nsmalltalk:superImplementor(smalltalk.ParseStatements,\"exitBlock_\")(self,aBlock);\r\n((self):temporaries()):do_((function(each)\r\nreturn ((each):exitBlock_(aBlock))\r\nend));\r\n((self):statements()):do_((function(each)\r\nreturn ((each):exitBlock_(aBlock))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"initializeStatements",0
,function(self)
(function()
	local _s8_value=((smalltalk.Array):new())
	self["@statements"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeStatements\r\n\t\" Private - Initialize the receiver's statements. \"\r\n\r\n\tstatements := Array new ","function(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@statements\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"initializeTemporaries",0
,function(self)
(function()
	local _s8_value=((smalltalk.Array):new())
	self["@temporaries"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeTemporaries\r\n\t\" Private - Initialize the receiver's temporaries. \"\r\n\r\n\ttemporaries := Array new ","function(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@temporaries\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"isComposite",0
,function(self)
return (true);
end
,"query","isComposite\r\n\t\" Returns true if the receiver is a composite parse node. \"\r\n\r\n\t^true ","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.ParseStatements,"isEmpty",0
,function(self)
return (((self):statements()):isEmpty());
end
,"query","isEmpty\r\n\t\" Returns true if the receiver is empty. \"\r\n\r\n\t^self statements isEmpty ","function(self)\r\nreturn (((self):statements()):isEmpty());\r\nend")

smalltalk:bind(smalltalk.BlockClosureNode,"args",0
,function(self)
if (smalltalk:isNil_((self["@args"])))==true then (self):initializeArgs(); end;
return (self["@args"]);
end
,"accessing","args\r\n\t\" Returns the receiver's arguments. \"\r\n\r\n\targs isNil ifTrue: [ self initializeArgs ].\r\n\t^args ","function(self)\r\nif (smalltalk:isNil_((self[\"@args\"])))==true then (self):initializeArgs(); end;\r\nreturn (self[\"@args\"]);\r\nend")

smalltalk:bind(smalltalk.BlockClosureNode,"args:",0
,function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@args"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","args: aCollection\r\n\t\" Set the receiver's arguments. \"\r\n\r\n\targs := aCollection","function(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@args\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BlockClosureNode,"arguments",0
,function(self)
return ((self):args());
end
,"accessing","arguments\r\n\t\" Returns the receiver's arguments. \"\r\n\r\n\t^self args ","function(self)\r\nreturn ((self):args());\r\nend")

smalltalk:bind(smalltalk.BlockClosureNode,"arguments:",0
,function(self,aCollection)
(self):args_(aCollection);
return (self);
end
,"accessing","arguments: aCollection\r\n\t\" Set the receiver's arguments. \"\r\n\r\n\tself args: aCollection ","function(self,aCollection)\r\n(self):args_(aCollection);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BlockClosureNode,"contextVariables",0
,function(self)
return (smalltalk:object_comma_(((self):args()),smalltalk:superImplementor(smalltalk.BlockClosureNode,"contextVariables")(self)));
end
,"activation","contextVariables\r\n\t\" Private - Returns the variables involved in activation of the receiver. \"\r\n\r\n\t^self args ,super contextVariables ","function(self)\r\nreturn (smalltalk:object_comma_(((self):args()),smalltalk:superImplementor(smalltalk.BlockClosureNode,\"contextVariables\")(self)));\r\nend")

smalltalk:bind(smalltalk.BlockClosureNode,"exitBlock:",0
,function(self,aBlock)
smalltalk:superImplementor(smalltalk.BlockClosureNode,"exitBlock_")(self,aBlock);
((self):args()):do_((function(each)
return ((each):exitBlock_(aBlock))
end));
return (self);
end
,"evaluating","exitBlock: aBlock\r\n\t\" Set the exit block of the receiver. \"\r\n\r\n\tsuper exitBlock: aBlock.\r\n\tself args do: [:each| each exitBlock: aBlock ] ","function(self,aBlock)\r\nsmalltalk:superImplementor(smalltalk.BlockClosureNode,\"exitBlock_\")(self,aBlock);\r\n((self):args()):do_((function(each)\r\nreturn ((each):exitBlock_(aBlock))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BlockClosureNode,"initializeArgs",0
,function(self)
(function()
	local _s8_value=((smalltalk.Array):new())
	self["@args"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeArgs\r\n\t\" Private - Initializes the receiver's arguments. \"\r\n\r\n\targs := Array new ","function(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@args\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BlockClosureNode,"evaluateContentsIn:",0
,function(self,localContext)
return ((smalltalk.S8Block):for_in_(self,localContext));
end
,"evaluating","evaluateContentsIn: localContext\r\n\t\" Private - Returns the result of evaluating the contents of the receiver in local context.\r\n\tBlock defer evaluation until message #value:... is sent\r\n\t (re-using a local context for execution) \"\r\n\r\n\t^S8Block for: self in: localContext ","function(self,localContext)\r\nreturn ((smalltalk.S8Block):for_in_(self,localContext));\r\nend")

smalltalk:bind(smalltalk.CascadedMessageNode["$klass"],"for:",0
,function(self,aMessageNode)
return (((self):new()):initialize_(aMessageNode));
end
,"instantiation","for: aMessageNode\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new initialize: aMessageNode ","function(self,aMessageNode)\r\nreturn (((self):new()):initialize_(aMessageNode));\r\nend")

smalltalk:bind(smalltalk.CascadedMessageNode,"receiver",0
,function(self)
return (self["@receiver"]);
end
,"accessing","receiver\r\n\t\" Returns the receiver's receiver. \"\r\n\r\n\t^receiver ","function(self)\r\nreturn (self[\"@receiver\"]);\r\nend")

smalltalk:bind(smalltalk.CascadedMessageNode,"receiver:",0
,function(self,aReceiver)
(function()
	local _s8_value=(aReceiver)
	self["@receiver"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","receiver: aReceiver\r\n\t\" Set the receiver's receiver. \"\r\n\r\n\treceiver := aReceiver ","function(self,aReceiver)\r\n(function()\r\n\tlocal _s8_value=(aReceiver)\r\n\tself[\"@receiver\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CascadedMessageNode,"initialize:",0
,function(self,expression)
(self):add_(((smalltalk.MessageNode):new()):receiver_selector_arguments_((expression):receiver(),(expression):selector(),(expression):arguments()));
return (self);
end
,"initialize","initialize: expression\r\n\t\" Private - Initialize the receiver to start execution with expression. \"\r\n\r\n\tself add: (MessageNode new\r\n\t\treceiver: expression receiver\r\n\t\tselector: expression selector\r\n\t\targuments: expression arguments) ","function(self,expression)\r\n(self):add_(((smalltalk.MessageNode):new()):receiver_selector_arguments_((expression):receiver(),(expression):selector(),(expression):arguments()));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CascadedMessageNode,"evaluateContentsIn:",0
,function(self,localContext)
local result=nil
local rec=nil
local assoc=nil
((self):statements()):do_((function(each)
if (smalltalk:isNil_((assoc)))==true then (function()
	local _s8_value=((each):receiver())
	rec=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(("$rec"):_minus_gt((rec):evaluateIn_(localContext)))
	assoc=_s8_value
	return _s8_value
end)(); end;return ((function()
	local _s8_value=((each):evaluate_value_in_(rec,(assoc):value(),localContext))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
,"evaluating","evaluateContentsIn: localContext\r\n\t\" Private - Returns the result of evaluating the contents of the receiver in local context. \"\r\n\r\n\t| result rec assoc |\r\n\tself statements do: [:each|\r\n\t\tassoc isNil ifTrue: [\r\n\t\t\trec := each receiver.\r\n\t\t\tassoc := '$rec' -> (rec evaluateIn: localContext).\r\n\t\t].\r\n\t\tresult := each evaluate: rec value: assoc value in: localContext.\r\n\t].\r\n\t^result ","function(self,localContext)\r\nlocal result=nil\r\nlocal rec=nil\r\nlocal assoc=nil\r\n((self):statements()):do_((function(each)\r\nif (smalltalk:isNil_((assoc)))==true then (function()\r\n\tlocal _s8_value=((each):receiver())\r\n\trec=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"$rec\"):_minus_gt((rec):evaluateIn_(localContext)))\r\n\tassoc=_s8_value\r\n\treturn _s8_value\r\nend)(); end;return ((function()\r\n\tlocal _s8_value=((each):evaluate_value_in_(rec,(assoc):value(),localContext))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Script,"clearExitBlock",0
,function(self)
(self):exitBlock_(nil);
return (self);
end
,"evaluating","clearExitBlock\r\n\t\" Clear the exit block. \"\r\n\r\n\tself exitBlock: nil ","function(self)\r\n(self):exitBlock_(nil);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Script,"evaluateIn:",0
,function(self,aContext)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):exitBlock_((function(result)
(self):clearExitBlock();return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:superImplementor(smalltalk.Script,"evaluateIn_")(self,aContext))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\tself exitBlock: [:result| self clearExitBlock. ^result ].\r\n\t^super evaluateIn: aContext ","function(self,aContext)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):exitBlock_((function(result)\r\n(self):clearExitBlock();return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:superImplementor(smalltalk.Script,\"evaluateIn_\")(self,aContext))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Script,"contextFor:binding:to:",0
,function(self,aReceiver,args,array)
local result=nil
local count=nil
(function()
	local _s8_value=((smalltalk.S8Context):for_(aReceiver))
	result=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((args):size()):min_((array):size()))
	count=_s8_value
	return _s8_value
end)();
(1):to_do_(count,(function(i)
return ((result):at_put_((((args):at_(i)):binding()):key(),(array):at_(i)))
end));
return (result);
end
,"evaluating","contextFor: aReceiver binding: args to: array\r\n\t\" Private - Returns the context to evaluate the receiver on aReceiver with parameters. \"\r\n\r\n\t| result count |\r\n\tresult := S8Context for: aReceiver.\r\n\tcount := args size min: array size.\r\n\t1 to: count do: [:i| result at: (args at: i) binding key put: (array at: i) ].\r\n\t^result ","function(self,aReceiver,args,array)\r\nlocal result=nil\r\nlocal count=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.S8Context):for_(aReceiver))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((args):size()):min_((array):size()))\r\n\tcount=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(1):to_do_(count,(function(i)\r\nreturn ((result):at_put_((((args):at_(i)):binding()):key(),(array):at_(i)))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Script,"evaluate:binding:to:",0
,function(self,aReceiver,args,array)
return ((self):evaluateIn_((self):contextFor_binding_to_(aReceiver,args,array)));
end
,"evaluating","evaluate: aReceiver binding: args to: array\r\n\t\" Returns the result of evaluating the receiver with activation bindings. \"\r\n\r\n\t^self evaluateIn: (self contextFor: aReceiver binding: args to: array)","function(self,aReceiver,args,array)\r\nreturn ((self):evaluateIn_((self):contextFor_binding_to_(aReceiver,args,array)));\r\nend")

smalltalk:bind(smalltalk.Script,"nativeImplementationFor:",0
,function(self,mth)
local msg=nil
(function()
	local _s8_value=(smalltalk:object_comma_(((smalltalk.Smalltalk):nativeLanguage()),"ImplementationFor:args:"))
	msg=_s8_value
	return _s8_value
end)();
if (smalltalk:responds_to_((self),(msg)))==true then return ((self):perform_withArguments_(msg,(smalltalk.Array):with_with_(mth,(self):argsIn_(mth)))); end;
return ((self):error_(smalltalk:object_comma_(("Should not happen "),"nativeImplementationFor:")));
end
,"native","nativeImplementationFor: mth\r\n\t\" Return the native implementation to run a compiled script (mth). \"\r\n\r\n\t| msg |\r\n\tmsg := Smalltalk nativeLanguage ,#ImplementationFor:args:.\r\n\t(self respondsTo: msg) ifTrue: [\r\n\t\t^self perform: msg withArguments: (Array with: mth with: (self argsIn: mth))\r\n\t].\r\n\t^self error: 'Should not happen ' ,#nativeImplementationFor: ","function(self,mth)\r\nlocal msg=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((smalltalk.Smalltalk):nativeLanguage()),\"ImplementationFor:args:\"))\r\n\tmsg=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:responds_to_((self),(msg)))==true then return ((self):perform_withArguments_(msg,(smalltalk.Array):with_with_(mth,(self):argsIn_(mth)))); end;\r\nreturn ((self):error_(smalltalk:object_comma_((\"Should not happen \"),\"nativeImplementationFor:\")));\r\nend")

smalltalk:bind(smalltalk.Script,"argsIn:",0
,function(self,mth)
return ((mth):args());
end
,"native","argsIn: mth\r\n\t\" Private - Return the arguments bound to mth. \"\r\n\r\n\t^mth args ","function(self,mth)\r\nreturn ((mth):args());\r\nend")

smalltalk:bind(smalltalk.Script,"jsImplementationFor:args:",0
,function(self,mth,args)
return ((function()
return ((self):evaluate_binding_to_(this,args,(smalltalk.Array):slice_(arguments)))
end));
end
,"native","jsImplementationFor: mth args: args\r\n\t\" Private - Return the function to run mth. \"\r\n\r\n\t^[ self evaluate: #{this} binding: args to: (Array slice: #{arguments}) ]","function(self,mth,args)\r\nreturn ((function()\r\nreturn ((self):evaluate_binding_to_(this,args,(smalltalk.Array):slice_(arguments)))\r\nend));\r\nend")

smalltalk:bind(smalltalk.Script,"luaImplementationFor:args:",0
,function(self,mth,args)
local script=nil
local fn=nil
local hash=nil
(function()
	local _s8_value=("#")
	hash=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(self)
	script=_s8_value
	return _s8_value
end)();
fn = function (...)
		local array = smalltalk:newArray()
		for i=1,select(hash,...),1 do array:add_(select(i,...)) end
		return script:evaluate_binding_to_(self,args,array)
	end;
return (fn);
end
,"native","luaImplementationFor: mth args: args\r\n\t\" Private - Return the function to run mth. \"\r\n\r\n\t| script fn hash |\r\n\thash := $#.\r\n\tscript := self.\r\n\t{''lua'fn = function (...)\r\n\t\tlocal array = smalltalk:newArray()\r\n\t\tfor i=1,select(hash,...),1 do array:add_(select(i,...)) end\r\n\t\treturn script:evaluate_binding_to_(self,args,array)\r\n\tend'}.\r\n\t^fn","function(self,mth,args)\r\nlocal script=nil\r\nlocal fn=nil\r\nlocal hash=nil\r\n(function()\r\n\tlocal _s8_value=(\"#\")\r\n\thash=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(self)\r\n\tscript=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nfn = function (...)\r\n\t\tlocal array = smalltalk:newArray()\r\n\t\tfor i=1,select(hash,...),1 do array:add_(select(i,...)) end\r\n\t\treturn script:evaluate_binding_to_(self,args,array)\r\n\tend;\r\nreturn (fn);\r\nend")

smalltalk:bind(smalltalk.Script,"pyImplementationFor:args:",0
,function(self,mth,args)
local script=nil
(function()
	local _s8_value=(self)
	script=_s8_value
	return _s8_value
end)();
(function() self:invalidMessage_("pyImplementationFor:args:") end)();
return (self);
end
,"native","pyImplementationFor: mth args: args\r\n\t\" Private - Return the function to run mth. \"\r\n\r\n\t| script |\r\n\tscript := self.\r\n\t{''py'def result(rcv,*params):%>%return __0__.script.evaluate_binding_to_(rcv,args,%Array%(params))%<%if True: return result'}","function(self,mth,args)\r\nlocal script=nil\r\n(function()\r\n\tlocal _s8_value=(self)\r\n\tscript=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function() self:invalidMessage_(\"pyImplementationFor:args:\") end)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.StepOverScript["$klass"],"doing:",0
,function(self,aBlock)
return (((self):new()):initialize_(aBlock));
end
,"instantiation","doing: aBlock\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^self new initialize: aBlock ","function(self,aBlock)\r\nreturn (((self):new()):initialize_(aBlock));\r\nend")

smalltalk:bind(smalltalk.StepOverScript,"initialize:",0
,function(self,anAction)
(function()
	local _s8_value=(anAction)
	self["@action"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initialize: anAction\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\taction := anAction ","function(self,anAction)\r\n(function()\r\n\tlocal _s8_value=(anAction)\r\n\tself[\"@action\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.StepOverScript,"argsIn:",0
,function(self,aMethod)
local i=nil
(function()
	local _s8_value=(0)
	i=_s8_value
	return _s8_value
end)();
return ((((aMethod):selector()):asArrayOfSubstringsSeparatedBy_(":")):collect_((function(each)
(function()
	local _s8_value=((i):_plus(1))
	i=_s8_value
	return _s8_value
end)();return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("("),i)),")")),each))
end)));
end
,"native","argsIn: aMethod\r\n\t\" Private - Return the arguments bound to aMethod. \"\r\n\r\n\t| i | i := 0.\r\n\t^(aMethod selector asArrayOfSubstringsSeparatedBy: $:) collect: [:each|\r\n\t\ti := i + 1. $( ,i ,$) ,each\r\n\t] ","function(self,aMethod)\r\nlocal i=nil\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((((aMethod):selector()):asArrayOfSubstringsSeparatedBy_(\":\")):collect_((function(each)\r\n(function()\r\n\tlocal _s8_value=((i):_plus(1))\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"(\"),i)),\")\")),each))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.StepOverScript,"contextFor:binding:to:",0
,function(self,aReceiver,args,array)
local result=nil
local count=nil
(function()
	local _s8_value=((smalltalk.S8Context):for_(aReceiver))
	result=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((args):size()):min_((array):size()))
	count=_s8_value
	return _s8_value
end)();
(1):to_do_(count,(function(i)
return ((result):at_put_((args):at_(i),(array):at_(i)))
end));
return (result);
end
,"evaluating","contextFor: aReceiver binding: args to: array\r\n\t\" Returns the context to evaluate the receiver on aReceiver with parameters. \"\r\n\r\n\t| result count |\r\n\tresult := S8Context for: aReceiver.\r\n\tcount := args size min: array size.\r\n\t1 to: count do: [:i| result at: (args at: i) put: (array at: i) ].\r\n\t^result ","function(self,aReceiver,args,array)\r\nlocal result=nil\r\nlocal count=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.S8Context):for_(aReceiver))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((args):size()):min_((array):size()))\r\n\tcount=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(1):to_do_(count,(function(i)\r\nreturn ((result):at_put_((args):at_(i),(array):at_(i)))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.StepOverScript,"stepsFor:entering:withArguments:",0
,function(self,aReceiver,aMethod,array)
(self):sourceRange_((0):to_((((aMethod):source()):size()):_minus(1)));
return (smalltalk:superImplementor(smalltalk.StepOverScript,"stepsFor_entering_withArguments_")(self,aReceiver,aMethod,array));
end
,"simulating","stepsFor: aReceiver entering: aMethod withArguments: array\r\n\t\" Returns the steps to evaluate execution of the receiver activating aMethod. \"\r\n\r\n\tself sourceRange: (0 to: aMethod source size - 1).\r\n\t^super stepsFor: aReceiver entering: aMethod withArguments: array ","function(self,aReceiver,aMethod,array)\r\n(self):sourceRange_((0):to_((((aMethod):source()):size()):_minus(1)));\r\nreturn (smalltalk:superImplementor(smalltalk.StepOverScript,\"stepsFor_entering_withArguments_\")(self,aReceiver,aMethod,array));\r\nend")

smalltalk:bind(smalltalk.StepOverScript,"inject:in:",0
,function(self,simulator,aContext)
if ((self):isEmpty())==true then return ((simulator):add_step_in_(self,(function(simulator)
return ((simulator):value_((self["@action"]):evaluateWith_(simulator)))
end),aContext)); end;
return ((self):invalidMessage_("inject:in:"));
end
,"internal","inject: simulator in: aContext\r\n\t\" Private - Add the steps for evaluation of contents of the receiver in aContext. \"\r\n\r\n\tself isEmpty ifTrue: [\r\n\t\t^simulator add: self\r\n\t\t\tstep: [:simulator| simulator value: (action evaluateWith: simulator) ]\r\n\t\t\tin: aContext\r\n\t].\r\n\t^self invalidMessage: #inject:in: ","function(self,simulator,aContext)\r\nif ((self):isEmpty())==true then return ((simulator):add_step_in_(self,(function(simulator)\r\nreturn ((simulator):value_((self[\"@action\"]):evaluateWith_(simulator)))\r\nend),aContext)); end;\r\nreturn ((self):invalidMessage_(\"inject:in:\"));\r\nend")

smalltalk:bind(smalltalk.StepOverScript,"evaluateContentsIn:",0
,function(self,localContext)
if ((self):isEmpty())==true then return ((self["@action"]):evaluateWith_(nil)); end;
return ((self):invalidMessage_("evaluateContentsIn:"));
end
,"evaluating","evaluateContentsIn: localContext\r\n\t\" Private - Returns the result of evaluating the contents of the receiver in local context. \"\r\n\r\n\tself isEmpty ifTrue: [ ^action evaluateWith: nil ].\r\n\t^self invalidMessage: #evaluateContentsIn: ","function(self,localContext)\r\nif ((self):isEmpty())==true then return ((self[\"@action\"]):evaluateWith_(nil)); end;\r\nreturn ((self):invalidMessage_(\"evaluateContentsIn:\"));\r\nend")

smalltalk:bind(smalltalk.ParseVariable["$klass"],"boundTo:",0
,function(self,assoc)
return (((self):new()):binding_(assoc));
end
,"instantiation","boundTo: assoc\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^self new binding: assoc ","function(self,assoc)\r\nreturn (((self):new()):binding_(assoc));\r\nend")

smalltalk:bind(smalltalk.ParseVariable,"name",0
,function(self)
return (((self):binding()):key());
end
,"accessing","name\r\n\t\" Returns the receiver's name. \"\r\n\r\n\t^self binding key ","function(self)\r\nreturn (((self):binding()):key());\r\nend")

smalltalk:bind(smalltalk.ParseVariable,"indices:",0
,function(self,anArray)
(function()
	local _s8_value=(anArray)
	self["@indices"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","indices: anArray\r\n\t\" Set the receiver's indices. \"\r\n\r\n\tindices := anArray ","function(self,anArray)\r\n(function()\r\n\tlocal _s8_value=(anArray)\r\n\tself[\"@indices\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseVariable,"bind:in:",0
,function(self,aValue,aContext)
if not (((self):canBeAssigned()))==true then return ((self):error_("Invalid assignment")); end;
return ((self):assignValue_in_(aValue,aContext));
end
,"binding","bind: aValue in: aContext\r\n\t\" Set the receiver's value to aValue in aContext.\r\n\tCheck if the receiver is assignable.\r\n\tWARNING: The receiver MUST return the value set. \"\r\n\r\n\tself canBeAssigned ifFalse: [\r\n\t\t^self error: 'Invalid assignment'\r\n\t].\r\n\t^self assignValue: aValue in: aContext ","function(self,aValue,aContext)\r\nif not (((self):canBeAssigned()))==true then return ((self):error_(\"Invalid assignment\")); end;\r\nreturn ((self):assignValue_in_(aValue,aContext));\r\nend")

smalltalk:bind(smalltalk.ParseVariable,"binding",0
,function(self)
return (self["@binding"]);
end
,"binding","binding\r\n\t\" Returns the receiver's binding. \"\r\n\r\n\t^binding ","function(self)\r\nreturn (self[\"@binding\"]);\r\nend")

smalltalk:bind(smalltalk.ParseVariable,"binding:",0
,function(self,aBinding)
(function()
	local _s8_value=(aBinding)
	self["@binding"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"binding","binding: aBinding\r\n\t\" Set the receiver's binding. \"\r\n\r\n\tbinding := aBinding ","function(self,aBinding)\r\n(function()\r\n\tlocal _s8_value=(aBinding)\r\n\tself[\"@binding\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseVariable,"key:in:",0
,function(self,index,aContext)
return (smalltalk:if_true_false_((smalltalk:is_kindOf_((index),(smalltalk.ParseNode))),(function()
return ((index):evaluateIn_(aContext))
end),(function()
return (index)
end)));
end
,"indexing","key: index in: aContext\r\n\t\" Private - Returns the key to index an object in aContext. \"\r\n\r\n\t^(index isKindOf: ParseNode)\r\n\tifTrue: [ index evaluateIn: aContext ]\r\n\tifFalse: [ index ]","function(self,index,aContext)\r\nreturn (smalltalk:if_true_false_((smalltalk:is_kindOf_((index),(smalltalk.ParseNode))),(function()\r\nreturn ((index):evaluateIn_(aContext))\r\nend),(function()\r\nreturn (index)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ParseVariable,"index:in:",0
,function(self,anObject,aContext)
if (smalltalk:isNil_((self["@indices"])))==true then return (anObject); end;
return ((self["@indices"]):inject_into_(anObject,(function(result,index)
return (smalltalk:basic_at_ifAbsent_((result),(self):key_in_(index,aContext),(function()
return (nil)
end)))
end)));
end
,"indexing","index: anObject in: aContext\r\n\t\" Private - Returns the result of indexing anObject. \"\r\n\r\n\tindices isNil ifTrue: [ ^anObject ].\r\n\t^indices inject: anObject into: [:result :index|\r\n\t\tresult\tbasicAt: (self key: index in: aContext)\r\n\t\t\tifAbsent: [ ]\r\n\t]","function(self,anObject,aContext)\r\nif (smalltalk:isNil_((self[\"@indices\"])))==true then return (anObject); end;\r\nreturn ((self[\"@indices\"]):inject_into_(anObject,(function(result,index)\r\nreturn (smalltalk:basic_at_ifAbsent_((result),(self):key_in_(index,aContext),(function()\r\nreturn (nil)\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ParseVariable,"follow:in:",0
,function(self,anObject,aContext)
local target=nil
local index=nil
if (smalltalk:isNil_((self["@indices"])))==true then return (nil); end;
(function()
	local _s8_value=(anObject)
	target=_s8_value
	return _s8_value
end)();
(1):to_do_(((self["@indices"]):size()):_minus(1),(function(i)
(function()
	local _s8_value=((self):key_in_((self["@indices"]):at_(i),aContext))
	index=_s8_value
	return _s8_value
end)();return ((function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((target),index,(function()
return (nil)
end)))
	target=_s8_value
	return _s8_value
end)())
end));
(function()
	local _s8_value=((self):key_in_((self["@indices"]):last(),aContext))
	index=_s8_value
	return _s8_value
end)();
return ((smalltalk.Array):with_with_(target,index));
end
,"indexing","follow: anObject in: aContext\r\n\t\" Private - Returns the result of following the indices from anObject and last index to evaluate (or nil). \"\r\n\r\n\t| target index |\r\n\tindices isNil ifTrue: [ ^nil ].\r\n\ttarget := anObject.\r\n\t1 to: indices size - 1 do: [:i|\r\n\t\tindex := self key: (indices at: i) in: aContext.\r\n\t\ttarget := target basicAt: index ifAbsent: []\r\n\t].\r\n\tindex := self key: indices last in: aContext.\r\n\t^Array with: target with: index ","function(self,anObject,aContext)\r\nlocal target=nil\r\nlocal index=nil\r\nif (smalltalk:isNil_((self[\"@indices\"])))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(1):to_do_(((self[\"@indices\"]):size()):_minus(1),(function(i)\r\n(function()\r\n\tlocal _s8_value=((self):key_in_((self[\"@indices\"]):at_(i),aContext))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();return ((function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((target),index,(function()\r\nreturn (nil)\r\nend)))\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\n(function()\r\n\tlocal _s8_value=((self):key_in_((self[\"@indices\"]):last(),aContext))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((smalltalk.Array):with_with_(target,index));\r\nend")

smalltalk:bind(smalltalk.ParseVariable,"assignValue:in:",0
,function(self,aValue,aContext)
return (((self):binding()):assign_to_in_(smalltalk:if_true_false_((smalltalk:notNil_((self["@indices"]))),(function()
return ((function(root)
return ((self):follow_in_(root,aContext))
end))
end),nil),aValue,aContext));
end
,"evaluating","assignValue: aValue in: aContext\r\n\t\" Private - Set the receiver's value to aValue.\r\n\tWARNING: The receiver MUST return the value set. \"\r\n\r\n\t^self binding\r\n\t\tassign: (indices notNil ifTrue: [ [:root| self follow: root in: aContext ] ])\r\n\t\tto: aValue in: aContext ","function(self,aValue,aContext)\r\nreturn (((self):binding()):assign_to_in_(smalltalk:if_true_false_((smalltalk:notNil_((self[\"@indices\"]))),(function()\r\nreturn ((function(root)\r\nreturn ((self):follow_in_(root,aContext))\r\nend))\r\nend),nil),aValue,aContext));\r\nend")

smalltalk:bind(smalltalk.ParseVariable,"valueIn:",0
,function(self,aContext)
return (((self):binding()):evaluateIn_(aContext));
end
,"value","valueIn: aContext\r\n\t\" Private - Returns the value of the receiver in aContext. \"\r\n\r\n\t^self binding evaluateIn: aContext ","function(self,aContext)\r\nreturn (((self):binding()):evaluateIn_(aContext));\r\nend")

smalltalk:bind(smalltalk.ParseVariable,"evaluateIn:",0
,function(self,aContext)
return ((self):index_in_((self):valueIn_(aContext),aContext));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t^self index: (self valueIn: aContext) in: aContext ","function(self,aContext)\r\nreturn ((self):index_in_((self):valueIn_(aContext),aContext));\r\nend")

smalltalk:bind(smalltalk.ParseVariable,"canBeAssigned",0
,function(self)
return (false);
end
,"query","canBeAssigned\r\n\t\" Returns true if the receiver is a variable that can be assigned. \"\r\n\r\n\t^false ","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.ParseVariable,"isVariable",0
,function(self)
return (true);
end
,"query","isVariable\r\n\t\" Returns true if the receiver is a variable parse node. \"\r\n\r\n\t^true ","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.ParseArgument,"clear:",0
,function(self,aContext)
return ((aContext):clear_((self):binding()));
end
,"evaluating","clear: aContext\r\n\t\" Clear the receiver's contents. \"\r\n\r\n\t^aContext clear: self binding ","function(self,aContext)\r\nreturn ((aContext):clear_((self):binding()));\r\nend")

smalltalk:bind(smalltalk.ParseArgument,"canBeAssigned",0
,function(self)
return (((self["@canBeAssigned"])==true));
end
,"query","canBeAssigned\r\n\t\" Returns true if the receiver is a variable that can be assigned. \"\r\n\r\n\t^canBeAssigned == true","function(self)\r\nreturn (((self[\"@canBeAssigned\"])==true));\r\nend")

smalltalk:bind(smalltalk.ParseArgument,"canBeAssigned:",0
,function(self,aBoolean)
(function()
	local _s8_value=(aBoolean)
	self["@canBeAssigned"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"query","canBeAssigned: aBoolean\r\n\t\" Set canBeAssigned to aBoolean. \"\r\n\r\n\tcanBeAssigned := aBoolean ","function(self,aBoolean)\r\n(function()\r\n\tlocal _s8_value=(aBoolean)\r\n\tself[\"@canBeAssigned\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseGlobalVariable,"canBeAssigned",0
,function(self)
return (true);
end
,"query","canBeAssigned\r\n\t\" Returns true if the receiver is a variable that can be assigned. \"\r\n\r\n\t^true ","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.ParseGlobalConstant,"canBeAssigned",0
,function(self)
return (false);
end
,"query","canBeAssigned\r\n\t\" Returns true if the receiver is a variable that can be assigned. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.ParseSpecial["$klass"],"value:",0
,function(self,aValue)
return ((
function(_s8_rec)
	(_s8_rec):binding_((smalltalk.S8LiteralBinding):value_(aValue));
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"evaluating","value: aValue\r\n\t\" Returns an instance of the receiver with value aValue. \"\r\n\r\n\t^self new\r\n\t\tbinding: (S8LiteralBinding value: aValue);\r\n\t\tyourself ","function(self,aValue)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):binding_((smalltalk.S8LiteralBinding):value_(aValue));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.ParseLiteral["$klass"],"from:to:copy:",0
,function(self,start,stop,aValue)
return ((
function(_s8_rec)
	(_s8_rec):binding_((smalltalk.S8CopyBinding):value_(aValue));
	return ((_s8_rec):yourself())
end
)((self):from_to_(start,stop)));
end
,"instantiation","from: start to: stop copy: aValue\r\n\t\" Returns an instance of the receiver with value aValue. \"\r\n\r\n\t^(self from: start to: stop)\r\n\t\tbinding: (S8CopyBinding value: aValue);\r\n\t\tyourself ","function(self,start,stop,aValue)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):binding_((smalltalk.S8CopyBinding):value_(aValue));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):from_to_(start,stop)));\r\nend")

smalltalk:bind(smalltalk.ParseLiteral["$klass"],"from:to:value:",0
,function(self,start,stop,aValue)
return ((
function(_s8_rec)
	(_s8_rec):binding_((smalltalk.S8LiteralBinding):value_(aValue));
	return ((_s8_rec):yourself())
end
)((self):from_to_(start,stop)));
end
,"instantiation","from: start to: stop value: aValue\r\n\t\" Returns an instance of the receiver with value aValue. \"\r\n\r\n\t^(self from: start to: stop)\r\n\t\tbinding: (S8LiteralBinding value: aValue);\r\n\t\tyourself ","function(self,start,stop,aValue)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):binding_((smalltalk.S8LiteralBinding):value_(aValue));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):from_to_(start,stop)));\r\nend")

smalltalk:bind(smalltalk.ParseLiteral["$klass"],"sourceRange:value:",0
,function(self,interval,aValue)
return ((
function(_s8_rec)
	(_s8_rec):binding_((smalltalk.S8LiteralBinding):value_(aValue));
	return ((_s8_rec):yourself())
end
)((self):sourceRange_(interval)));
end
,"instantiation","sourceRange: interval value: aValue\r\n\t\" Returns an instance of the receiver with value aValue. \"\r\n\r\n\t^(self sourceRange: interval)\r\n\t\tbinding: (S8LiteralBinding value: aValue);\r\n\t\tyourself ","function(self,interval,aValue)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):binding_((smalltalk.S8LiteralBinding):value_(aValue));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):sourceRange_(interval)));\r\nend")

smalltalk:bind(smalltalk.ParseInstanceVariable["$klass"],"name:index:",0
,function(self,aName,index)
return ((
function(_s8_rec)
	(_s8_rec):name_(aName);
	(_s8_rec):index_(index);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","name: aName index: index\r\n\t\" Returns an instance of the receiver with name aName. \"\r\n\r\n\t^self new\r\n\t\tname: aName;\r\n\t\tindex: index;\r\n\t\tyourself ","function(self,aName,index)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):name_(aName);\r\n\t(_s8_rec):index_(index);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.ParseInstanceVariable,"index",0
,function(self)
return (self["@index"]);
end
,"accessing","index\r\n\t\" Returns the receiver's index. \"\r\n\r\n\t^index ","function(self)\r\nreturn (self[\"@index\"]);\r\nend")

smalltalk:bind(smalltalk.ParseInstanceVariable,"index:",0
,function(self,anIndex)
(function()
	local _s8_value=(anIndex)
	self["@index"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","index: anIndex\r\n\t\" Set the receiver's index. \"\r\n\r\n\tindex := anIndex ","function(self,anIndex)\r\n(function()\r\n\tlocal _s8_value=(anIndex)\r\n\tself[\"@index\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseInstanceVariable,"name",0
,function(self)
return (self["@name"]);
end
,"accessing","name\r\n\t\" Returns the receiver's name. \"\r\n\r\n\t^name ","function(self)\r\nreturn (self[\"@name\"]);\r\nend")

smalltalk:bind(smalltalk.ParseInstanceVariable,"name:",0
,function(self,aName)
(function()
	local _s8_value=(aName)
	self["@name"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","name: aName\r\n\t\" Set the receiver's name. \"\r\n\r\n\tname := aName ","function(self,aName)\r\n(function()\r\n\tlocal _s8_value=(aName)\r\n\tself[\"@name\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseInstanceVariable,"instVarKey",0
,function(self)
return ((self):name());
end
,"accessing","instVarKey\r\n\t\" Private - Returns the instance access index of the receiver. \"\r\n\r\n\t^self name \"\r\n\t\twas: index\r\n\t\tNote: S8 has better access to named i.v.\r\n\t\" ","function(self)\r\nreturn ((self):name());\r\nend")

smalltalk:bind(smalltalk.ParseInstanceVariable,"bind:in:",0
,function(self,aValue,aContext)
if not (((self):canBeAssigned()))==true then return ((self):error_("Invalid assignment.")); end;
return (((aContext):self()):instVarAt_put_((self):instVarKey(),aValue));
end
,"binding","bind: aValue in: aContext\r\n\t\" Set the receiver's value to aValue in aContext.\r\n\tCheck if the receiver is assignable.\r\n\tWARNING: The receiver MUST return the set value. \"\r\n\r\n\tself canBeAssigned ifFalse: [\r\n\t\t^self error: 'Invalid assignment.'\r\n\t].\r\n\t^aContext self\r\n\t\tinstVarAt: self instVarKey\r\n\t\tput: aValue ","function(self,aValue,aContext)\r\nif not (((self):canBeAssigned()))==true then return ((self):error_(\"Invalid assignment.\")); end;\r\nreturn (((aContext):self()):instVarAt_put_((self):instVarKey(),aValue));\r\nend")

smalltalk:bind(smalltalk.ParseInstanceVariable,"valueIn:",0
,function(self,aContext)
return (((aContext):self()):instVarAt_((self):instVarKey()));
end
,"value","valueIn: aContext\r\n\t\" Private - Returns the value of the receiver in aContext. \"\r\n\r\n\t^aContext self instVarAt: self instVarKey ","function(self,aContext)\r\nreturn (((aContext):self()):instVarAt_((self):instVarKey()));\r\nend")

smalltalk:bind(smalltalk.ParseInstanceVariable,"canBeAssigned",0
,function(self)
return (true);
end
,"query","canBeAssigned\r\n\t\" Returns true if the receiver is a variable that can be assigned. \"\r\n\r\n\t^true ","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.ParseUniversal,"canBeAssigned",0
,function(self)
return ((((self["@indices"]):size()) > 0));
end
,"query","canBeAssigned\r\n\t\" Returns true if the receiver is a variable that can be assigned. \"\r\n\r\n\t^indices size > 0 ","function(self)\r\nreturn ((((self[\"@indices\"]):size()) > 0));\r\nend")

smalltalk:bind(smalltalk.ParseUniversal,"assignValue:in:",0
,function(self,aValue,aContext)
local target=nil
(function()
	local _s8_value=((self):valueIn_(aContext))
	target=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):follow_in_(target,aContext))
	target=_s8_value
	return _s8_value
end)();
return (smalltalk:basic_at_put_(((target):first()),(target):last(),aValue));
end
,"evaluating","assignValue: aValue in: aContext\r\n\t\"Private - Set the receiver's value to aValue.\r\n\tWARNING: The receiver MUST return the value set. \"\r\n\r\n\t| target |\r\n\ttarget := self valueIn: aContext.\r\n\ttarget := self follow: target in: aContext.\r\n\t^target first basicAt: target last put: aValue ","function(self,aValue,aContext)\r\nlocal target=nil\r\n(function()\r\n\tlocal _s8_value=((self):valueIn_(aContext))\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):follow_in_(target,aContext))\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:basic_at_put_(((target):first()),(target):last(),aValue));\r\nend")

smalltalk:bind(smalltalk.ParseSelf,"valueIn:",0
,function(self,aContext)
return ((aContext):self());
end
,"value","valueIn: aContext\r\n\t\" Private - Returns the value of the receiver in aContext. \"\r\n\r\n\t^aContext self ","function(self,aContext)\r\nreturn ((aContext):self());\r\nend")

smalltalk:bind(smalltalk.ParseSuper["$klass"],"in:",0
,function(self,aClass)
return (((self):new()):initialize_(aClass));
end
,"instantiation","in: aClass\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^self new initialize: aClass","function(self,aClass)\r\nreturn (((self):new()):initialize_(aClass));\r\nend")

smalltalk:bind(smalltalk.ParseSuper,"initialize:",0
,function(self,aClass)
(function()
	local _s8_value=(aClass)
	self["@implementor"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initialize: aClass\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\timplementor := aClass","function(self,aClass)\r\n(function()\r\n\tlocal _s8_value=(aClass)\r\n\tself[\"@implementor\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseSuper,"isSuper",0
,function(self)
return (true);
end
,"query","isSuper\r\n\t\" Returns true if the receiver is a reference to super. \"\r\n\r\n\t^true ","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.ParseSuper,"functionToCall:in:",0
,function(self,selector,anImplementor)
return (((smalltalk.Smalltalk):current()):superImplementor(anImplementor,selector));
end
,"evaluating","functionToCall: selector in: anImplementor\r\n\t\" Private - Returns the native function to call for selector. \"\r\n\r\n\t^Smalltalk current\r\n\t\t#superImplementor: anImplementor\r\n\t\tof: selector ","function(self,selector,anImplementor)\r\nreturn (((smalltalk.Smalltalk):current()):superImplementor(anImplementor,selector));\r\nend")

smalltalk:bind(smalltalk.ParseSuper,"apply:to:withArguments:in:",0
,function(self,fn,anObject,anArray,aContext)
return (fn(anObject,(table.unpack or unpack)(anArray)));
end
,"evaluating","apply: fn to: anObject withArguments: anArray in: aContext\r\n\t\" Private - Returns the result of evaluating the native function in anObject @ aContext. \"\r\n\r\n\t^{''\r\n\tjs'fn.apply(anObject,anArray)'\r\n\tlua'fn(anObject,(table.unpack or unpack)(anArray))'\r\n\tpy'fn(anObject,*smalltalk.objects_toCall_(anArray,fn))'}. ","function(self,fn,anObject,anArray,aContext)\r\nreturn (fn(anObject,(table.unpack or unpack)(anArray)));\r\nend")

smalltalk:bind(smalltalk.ParseSuper,"send:to:withArguments:in:",0
,function(self,selector,anObject,anArray,aContext)
local anImplementor=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((self["@implementor"]))),(function()
return ((anObject)["$klass"])
end),(function()
return (self["@implementor"])
end)))
	anImplementor=_s8_value
	return _s8_value
end)();
return ((self):apply_to_withArguments_in_((self):functionToCall_in_(selector,anImplementor),anObject,anArray,aContext));
end
,"evaluating","send: selector to: anObject withArguments: anArray in: aContext\r\n\t\" Private - Returns the result of sending message to anObject in aContext. \"\r\n\r\n\t| anImplementor |\r\n\tanImplementor := implementor isNil\r\n\t\tifTrue: [ anObject class ]\r\n\t\tifFalse: [ implementor ].\r\n\t^self\tapply: (self functionToCall: selector in: anImplementor)\r\n\t\tto: anObject withArguments: anArray\r\n\t\tin: aContext ","function(self,selector,anObject,anArray,aContext)\r\nlocal anImplementor=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((self[\"@implementor\"]))),(function()\r\nreturn ((anObject)[\"$klass\"])\r\nend),(function()\r\nreturn (self[\"@implementor\"])\r\nend)))\r\n\tanImplementor=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):apply_to_withArguments_in_((self):functionToCall_in_(selector,anImplementor),anObject,anArray,aContext));\r\nend")

smalltalk:bind(smalltalk.ParseNoReceiver,"isOO",0
,function(self)
return (false);
end
,"query","isOO\r\n\t\" Returns true if the receiver refers to an object. \"\r\n\r\n\t^false ","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.ParseNoReceiver,"valueIn:",0
,function(self,aContext)
return (aContext);
end
,"value","valueIn: aContext\r\n\t\" Private - Returns the value of the receiver in aContext. \"\r\n\r\n\t^aContext ","function(self,aContext)\r\nreturn (aContext);\r\nend")

smalltalk:bind(smalltalk.ParseNoReceiver,"send:to:withArguments:in:",0
,function(self,selector,anObject,anArray,aContext)
local fn=nil
if (smalltalk:isObject_equalTo_((selector),"self"))==true then return (((anObject):self()):evaluateWithArguments_(anArray)); end;
(function()
	local _s8_value=((smalltalk.Smalltalk):nativeObjectAt_(selector))
	fn=_s8_value
	return _s8_value
end)();
return ((fn):evaluateWithArguments_(anArray));
end
,"evaluating","send: selector to: anObject withArguments: anArray in: aContext\r\n\t\" Private - Returns the result of sending message to anObject in aContext. \"\r\n\r\n\t| fn |\r\n\tselector = #self ifTrue: [ \"note that anObject is the context of evaluation\"\r\n\t\t^anObject self evaluateWithArguments: anArray\r\n\t].\r\n\tfn := Smalltalk nativeObjectAt: selector.\r\n\t^fn evaluateWithArguments: anArray ","function(self,selector,anObject,anArray,aContext)\r\nlocal fn=nil\r\nif (smalltalk:isObject_equalTo_((selector),\"self\"))==true then return (((anObject):self()):evaluateWithArguments_(anArray)); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):nativeObjectAt_(selector))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((fn):evaluateWithArguments_(anArray));\r\nend")

smalltalk:bind(smalltalk.ParseNativeVariable["$klass"],"named:from:to:",0
,function(self,aName,start,stop)
return ((
function(_s8_rec)
	(_s8_rec):binding_((aName):_minus_gt(nil));
	return ((_s8_rec):yourself())
end
)((self):from_to_(start,stop)));
end
,"instantiation","named: aName from: start to: stop\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^(self from: start to: stop)\r\n\t\tbinding: aName -> nil;\r\n\t\tyourself ","function(self,aName,start,stop)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):binding_((aName):_minus_gt(nil));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):from_to_(start,stop)));\r\nend")

smalltalk:bind(smalltalk.ParseNativeVariable,"valueIn:",0
,function(self,aContext)
return (((smalltalk.Smalltalk):global())[(self):name()]);
end
,"value","valueIn: aContext\r\n\t\" Private - Returns the value of the receiver in aContext. \"\r\n\r\n\t^Smalltalk global basicAt: self name ","function(self,aContext)\r\nreturn (((smalltalk.Smalltalk):global())[(self):name()]);\r\nend")

smalltalk:bind(smalltalk.ParseNativeVariable,"canBeAssigned",0
,function(self)
return (true);
end
,"query","canBeAssigned\r\n\t\" Returns true if the receiver is a variable that can be assigned. \"\r\n\r\n\t^true ","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.ParseNativeVariable,"assignValue:in:",0
,function(self,aValue,aContext)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local target=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):global())
	target=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((self["@indices"])))==true then return (smalltalk:basic_at_put_((target),(self):name(),aValue)); end;
(function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((target),(self):name(),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_(("Native Global not found - "),(self):name())))
end
)()
error(_s8Ret_,0)
end)())
end)))
	target=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):follow_in_(target,aContext))
	target=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:basic_at_put_(((target):first()),(target):last(),aValue))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"evaluating","assignValue: aValue in: aContext\r\n\t\"Private - Set the receiver's value to aValue.\r\n\tWARNING: The receiver MUST return the value set. \"\r\n\r\n\t| target |\r\n\ttarget := Smalltalk global.\r\n\tindices isNil ifTrue: [ ^target basicAt: self name put: aValue ].\r\n\ttarget := target basicAt: self name ifAbsent: [\r\n\t\t^self error: 'Native Global not found - ' ,self name\r\n\t].\r\n\ttarget := self follow: target in: aContext.\r\n\t^target first basicAt: target last put: aValue ","function(self,aValue,aContext)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal target=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):global())\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((self[\"@indices\"])))==true then return (smalltalk:basic_at_put_((target),(self):name(),aValue)); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((target),(self):name(),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Native Global not found - \"),(self):name())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):follow_in_(target,aContext))\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:basic_at_put_(((target):first()),(target):last(),aValue))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.MethodExitNode,"exitBlock",0
,function(self)
return (self["@exitBlock"]);
end
,"accessing","exitBlock\r\n\t\" Returns the receiver's exitBlock. \"\r\n\r\n\t^exitBlock ","function(self)\r\nreturn (self[\"@exitBlock\"]);\r\nend")

smalltalk:bind(smalltalk.MethodExitNode,"exitBlock:",0
,function(self,aBlock)
smalltalk:superImplementor(smalltalk.MethodExitNode,"exitBlock_")(self,aBlock);
(function()
	local _s8_value=(aBlock)
	self["@exitBlock"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","exitBlock: aBlock\r\n\t\" Set the receiver's exitBlock. \"\r\n\r\n\tsuper exitBlock: aBlock.\r\n\texitBlock := aBlock.","function(self,aBlock)\r\nsmalltalk:superImplementor(smalltalk.MethodExitNode,\"exitBlock_\")(self,aBlock);\r\n(function()\r\n\tlocal _s8_value=(aBlock)\r\n\tself[\"@exitBlock\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.MethodExitNode,"exitWith:",0
,function(self,anObject)
if (smalltalk:isNil_((self["@exitBlock"])))==true then return ((self):error_("Invalid script context.")); end;
return ((self["@exitBlock"]):value_(anObject));
end
,"evaluating","exitWith: anObject\r\n\t\" Exit the receiver with anObject as returned value. \"\r\n\r\n\texitBlock isNil ifTrue: [ ^self error: 'Invalid script context.' ].\r\n\t^exitBlock value: anObject ","function(self,anObject)\r\nif (smalltalk:isNil_((self[\"@exitBlock\"])))==true then return ((self):error_(\"Invalid script context.\")); end;\r\nreturn ((self[\"@exitBlock\"]):value_(anObject));\r\nend")

smalltalk:bind(smalltalk.MethodReturnNode,"expression",0
,function(self)
return (self["@expression"]);
end
,"accessing","expression\r\n\t\" Returns the receiver's expression. \"\r\n\r\n\t^expression ","function(self)\r\nreturn (self[\"@expression\"]);\r\nend")

smalltalk:bind(smalltalk.MethodReturnNode,"expression:",0
,function(self,anExpressionNode)
(function()
	local _s8_value=(anExpressionNode)
	self["@expression"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","expression: anExpressionNode\r\n\t\" Set the receiver's expression. \"\r\n\r\n\texpression := anExpressionNode ","function(self,anExpressionNode)\r\n(function()\r\n\tlocal _s8_value=(anExpressionNode)\r\n\tself[\"@expression\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.MethodReturnNode,"exitBlock:",0
,function(self,aBlock)
smalltalk:superImplementor(smalltalk.MethodReturnNode,"exitBlock_")(self,aBlock);
(self["@expression"]):exitBlock_(aBlock);
return (self);
end
,"accessing","exitBlock: aBlock\r\n\t\" Set the receiver's exitBlock. \"\r\n\r\n\tsuper exitBlock: aBlock.\r\n\texpression exitBlock: aBlock ","function(self,aBlock)\r\nsmalltalk:superImplementor(smalltalk.MethodReturnNode,\"exitBlock_\")(self,aBlock);\r\n(self[\"@expression\"]):exitBlock_(aBlock);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.MethodReturnNode,"isReturn",0
,function(self)
return (true);
end
,"query","isReturn\r\n\t\" Returns true if the receiver is a return parse node. \"\r\n\r\n\t^true ","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.MethodReturnNode,"evaluateIn:",0
,function(self,aContext)
return ((self):exitWith_(((self):expression()):evaluateIn_(aContext)));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t^self exitWith: (self expression evaluateIn: aContext) ","function(self,aContext)\r\nreturn ((self):exitWith_(((self):expression()):evaluateIn_(aContext)));\r\nend")

smalltalk:bind(smalltalk.PrimitiveNode["$klass"],"doing:",0
,function(self,anAction)
return ((
function(_s8_rec)
	(_s8_rec):action_(anAction);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","doing: anAction\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\taction: anAction;\r\n\t\tyourself ","function(self,anAction)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):action_(anAction);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.PrimitiveNode,"isPrimitiveNode",0
,function(self)
return (true);
end
,"query","isPrimitiveNode\r\n\t\" Returns true if the receiver is a primitive. \"\r\n\r\n\t^true ","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.PrimitiveNode,"action:",0
,function(self,anAction)
(function()
	local _s8_value=(anAction)
	self["@action"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","action: anAction\r\n\t\" Set the receiver's action. \"\r\n\r\n\taction := anAction ","function(self,anAction)\r\n(function()\r\n\tlocal _s8_value=(anAction)\r\n\tself[\"@action\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PrimitiveNode,"evaluateIn:",0
,function(self,aContext)
if (smalltalk:isNil_((self["@action"])))==true then return ((self):error_("Action to evaluate missing.")); end;
return ((self["@action"]):evaluateWithArguments_((smalltalk.Array):with_with_(aContext,self)));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\taction isNil ifTrue: [ ^self error: 'Action to evaluate missing.' ].\r\n\t^action evaluateWithArguments: (Array with: aContext with: self) ","function(self,aContext)\r\nif (smalltalk:isNil_((self[\"@action\"])))==true then return ((self):error_(\"Action to evaluate missing.\")); end;\r\nreturn ((self[\"@action\"]):evaluateWithArguments_((smalltalk.Array):with_with_(aContext,self)));\r\nend")

smalltalk:bind(smalltalk.ScriptParser["$klass"],"for:on:",0
,function(self,aReceiver,aScope)
return ((
function(_s8_rec)
	(_s8_rec):scope_(aScope);
	(_s8_rec):receiver_(aReceiver);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","for: aReceiver on: aScope\r\n\t\" OBSOLETE - Returns an instance of the receiver for evaluating on objects like aReceiver on given scope. \"\r\n\r\n\t^self new\r\n\t\tscope: aScope;\r\n\t\treceiver: aReceiver;\r\n\t\tyourself ","function(self,aReceiver,aScope)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):scope_(aScope);\r\n\t(_s8_rec):receiver_(aReceiver);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.ScriptParser["$klass"],"for:",0
,function(self,aClass)
return ((
function(_s8_rec)
	(_s8_rec):currentClass_(aClass);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","for: aClass\r\n\t\" Returns an instance of the receiver to parse in aClass. \"\r\n\r\n\t^self new\r\n\t\tcurrentClass: aClass;\r\n\t\tyourself ","function(self,aClass)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):currentClass_(aClass);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.ScriptParser["$klass"],"on:",0
,function(self,aScope)
return ((
function(_s8_rec)
	(_s8_rec):scope_(aScope);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","on: aScope\r\n\t\" Returns an instance of the receiver to parse on given scope. \"\r\n\r\n\t^self new\r\n\t\tscope: aScope;\r\n\t\tyourself ","function(self,aScope)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):scope_(aScope);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.ScriptParser["$klass"],"initializePrimitiveHandlers",0
,function(self)
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	self["@primitiveHandlers"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializePrimitiveHandlers\r\n\t\" Private - Initialize the primitiveHandlers of the receiver. \"\r\n\r\n\tprimitiveHandlers := PoolDictionary new","function(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tself[\"@primitiveHandlers\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptParser["$klass"],"primitiveHandlers",0
,function(self)
if (smalltalk:isNil_((self["@primitiveHandlers"])))==true then (self):initializePrimitiveHandlers(); end;
return (self["@primitiveHandlers"]);
end
,"accessing","primitiveHandlers\r\n\t\" Return the primitiveHandlers of the receiver. \"\r\n\r\n\tprimitiveHandlers isNil ifTrue: [ self initializePrimitiveHandlers ].\r\n\t^primitiveHandlers","function(self)\r\nif (smalltalk:isNil_((self[\"@primitiveHandlers\"])))==true then (self):initializePrimitiveHandlers(); end;\r\nreturn (self[\"@primitiveHandlers\"]);\r\nend")

smalltalk:bind(smalltalk.ScriptParser["$klass"],"defaultPrimitiveHandler",0
,function(self)
return (self["@defaultPrimitiveHandler"]);
end
,"accessing","defaultPrimitiveHandler\r\n\t\" Return the defaultPrimitiveHandler of the receiver. \"\r\n\r\n\t^defaultPrimitiveHandler","function(self)\r\nreturn (self[\"@defaultPrimitiveHandler\"]);\r\nend")

smalltalk:bind(smalltalk.ScriptParser["$klass"],"defaultPrimitiveHandler:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@defaultPrimitiveHandler"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","defaultPrimitiveHandler: anObject\r\n\t\" Set the defaultPrimitiveHandler of the receiver. \"\r\n\r\n\tdefaultPrimitiveHandler := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@defaultPrimitiveHandler\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptParser["$klass"],"handlerForPrimitive:",0
,function(self,type)
return (smalltalk:if_true_false_((smalltalk:notNil_((type))),(function()
return (((self):primitiveHandlers()):at_ifAbsent_(type,(function()
return ((self):defaultPrimitiveHandler())
end)))
end),nil));
end
,"parsing","handlerForPrimitive: type\r\n\t\" Private - Returns a handler to evaluate for parsing a primitive of specified type. \"\r\n\r\n\t^type notNil ifTrue: [\r\n\t\tself primitiveHandlers at: type ifAbsent: [\r\n\t\t\tself defaultPrimitiveHandler\r\n\t\t]\r\n\t] ","function(self,type)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((type))),(function()\r\nreturn (((self):primitiveHandlers()):at_ifAbsent_(type,(function()\r\nreturn ((self):defaultPrimitiveHandler())\r\nend)))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.ScriptParser["$klass"],"parsePrimitive:in:",0
,function(self,aParser,aContext)
local handler=nil
local type=nil
(function()
	local _s8_value=((aParser):nextSelectorOrNil())
	type=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):handlerForPrimitive_(type))
	handler=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((handler))),(function()
return ((handler):evaluateWithArguments_((smalltalk.Array):with_with_with_(aParser,aContext,type)))
end),nil));
end
,"parsing","parsePrimitive: aParser in: aContext\r\n\t\" Private - Parse a primitive in aContext.\r\n\tReturns nil if failed. \"\r\n\r\n\t| handler type |\r\n\ttype := aParser nextSelectorOrNil.\r\n\thandler := self handlerForPrimitive: type.\r\n\t^handler notNil ifTrue: [\r\n\t\thandler evaluateWithArguments:\r\n\t\t\t(Array with: aParser with: aContext with: type)\r\n\t] ","function(self,aParser,aContext)\r\nlocal handler=nil\r\nlocal type=nil\r\n(function()\r\n\tlocal _s8_value=((aParser):nextSelectorOrNil())\r\n\ttype=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):handlerForPrimitive_(type))\r\n\thandler=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((handler))),(function()\r\nreturn ((handler):evaluateWithArguments_((smalltalk.Array):with_with_with_(aParser,aContext,type)))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"expression:",0
,function(self,aContext)
local variable=nil
local expression=nil
local aReceiver=nil
local start=nil
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();
if ((self):match_((self):primitiveStart()))==true then return ((self):nextPrimitive_(aContext)); end;
(function()
	local _s8_value=((self):nextVariable_(aContext))
	variable=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_and_((smalltalk:notNil_((variable))),(function()
return ((self):match_((self):leftArrow()))
end)))==true then return ((self):assignment_in_startPosition_(variable,aContext,start)); end;
(self):position_(start);
(function()
	local _s8_value=((self):primaryExpression_(aContext))
	aReceiver=_s8_value
	return _s8_value
end)();
if ((self):atEnd())==true then return (aReceiver); end;
(function()
	local _s8_value=((self):message3_repeat_in_(aReceiver,true,aContext))
	expression=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((expression)))==true then return (aReceiver); end;
if ((self):match_((self):semicolon()))==true then (function()
	local _s8_value=((self):cascade_to_in_(expression,aReceiver,aContext))
	expression=_s8_value
	return _s8_value
end)(); end;
return (expression);
end
,"parsing","expression: aContext\r\n\t\" Private - Parse the receiver looking for an expression using variables in aContext. Returns nil if failed.\r\n\t<rule> expression = primitive | {variableName ':='} (primary | messageExpression {';' cascadeMessage})\r\n\t\"\r\n\r\n\t| variable expression aReceiver start |\r\n\tstart := self startOfNextToken.\r\n\t(self match: self primitiveStart) ifTrue: [\r\n\t\t^self nextPrimitive: aContext\r\n\t].\r\n\r\n\tvariable := self nextVariable: aContext.\r\n\t(variable notNil and: [ self match: self leftArrow ])\r\n\tifTrue: [ ^self assignment: variable in: aContext startPosition: start ].\r\n\r\n\tself position: start.\r\n\taReceiver := self primaryExpression: aContext.\r\n\tself atEnd ifTrue: [ ^aReceiver ].\r\n\texpression := self message3: aReceiver repeat: true in: aContext.\r\n\texpression isNil ifTrue: [ ^aReceiver ].\r\n\t(self match: self semicolon) ifTrue: [\r\n\t\texpression := self cascade: expression to: aReceiver in: aContext\r\n\t].\r\n\t^expression","function(self,aContext)\r\nlocal variable=nil\r\nlocal expression=nil\r\nlocal aReceiver=nil\r\nlocal start=nil\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((self):match_((self):primitiveStart()))==true then return ((self):nextPrimitive_(aContext)); end;\r\n(function()\r\n\tlocal _s8_value=((self):nextVariable_(aContext))\r\n\tvariable=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((variable))),(function()\r\nreturn ((self):match_((self):leftArrow()))\r\nend)))==true then return ((self):assignment_in_startPosition_(variable,aContext,start)); end;\r\n(self):position_(start);\r\n(function()\r\n\tlocal _s8_value=((self):primaryExpression_(aContext))\r\n\taReceiver=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((self):atEnd())==true then return (aReceiver); end;\r\n(function()\r\n\tlocal _s8_value=((self):message3_repeat_in_(aReceiver,true,aContext))\r\n\texpression=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((expression)))==true then return (aReceiver); end;\r\nif ((self):match_((self):semicolon()))==true then (function()\r\n\tlocal _s8_value=((self):cascade_to_in_(expression,aReceiver,aContext))\r\n\texpression=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (expression);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"position",0
,function(self)
local result=nil
(function()
	local _s8_value=((self["@source"]):position())
	result=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:isNil_((result))),(function()
return (0)
end),(function()
return (result)
end)));
end
,"accessing","position\r\n\t\" Returns the current position. \"\r\n\r\n\t| result |\r\n\tresult := source position.\r\n\t^result isNil ifTrue: [0] ifFalse: [result]","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self[\"@source\"]):position())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((result))),(function()\r\nreturn (0)\r\nend),(function()\r\nreturn (result)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"position:",0
,function(self,index)
return ((self["@source"]):position_(index));
end
,"accessing","position: index\r\n\t\" Set the current position. \"\r\n\r\n\t^source position: index","function(self,index)\r\nreturn ((self[\"@source\"]):position_(index));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"currentClass",0
,function(self)
if (smalltalk:isNil_((self["@currentClass"])))==true then (self):currentClass_(nil); end;
return (self["@currentClass"]);
end
,"accessing","currentClass\r\n\t\" Return the current class of the receiver. \"\r\n\r\n\tcurrentClass isNil ifTrue: [ self currentClass: nil ].\r\n\t^currentClass","function(self)\r\nif (smalltalk:isNil_((self[\"@currentClass\"])))==true then (self):currentClass_(nil); end;\r\nreturn (self[\"@currentClass\"]);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"currentClass:",0
,function(self,aClass)
local index=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aClass))),(function()
return ((nil)["$klass"])
end),(function()
return (aClass)
end)))
	self["@currentClass"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(0)
	index=_s8_value
	return _s8_value
end)();
(self):instanceVariables_(((self["@currentClass"]):allInstVarNames()):collect_((function(each)
(function()
	local _s8_value=((index):_plus(1))
	index=_s8_value
	return _s8_value
end)();return ((smalltalk.ParseInstanceVariable):name_index_(each,index))
end)));
return (self);
end
,"accessing","currentClass: aClass\r\n\t\" Set the current class of the receiver. \"\r\n\r\n\t| index |\r\n\tcurrentClass := aClass isNil ifTrue: [ nil class ] ifFalse: [ aClass ].\r\n\tindex := 0.\r\n\tself instanceVariables: (currentClass allInstVarNames collect: [:each|\r\n\t\tindex := index + 1.\r\n\t\tParseInstanceVariable name: each index: index.\r\n\t])","function(self,aClass)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aClass))),(function()\r\nreturn ((nil)[\"$klass\"])\r\nend),(function()\r\nreturn (aClass)\r\nend)))\r\n\tself[\"@currentClass\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):instanceVariables_(((self[\"@currentClass\"]):allInstVarNames()):collect_((function(each)\r\n(function()\r\n\tlocal _s8_value=((index):_plus(1))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();return ((smalltalk.ParseInstanceVariable):name_index_(each,index))\r\nend)));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"receiver:",0
,function(self,anObject)
(self):currentClass_((anObject)["$klass"]);
return (self);
end
,"accessing","receiver: anObject\r\n\t\" Set the receiver to parse considering the receiver will be a member of anObject species when evaluated. \"\r\n\r\n\tself currentClass: anObject class ","function(self,anObject)\r\n(self):currentClass_((anObject)[\"$klass\"]);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"parseTemporaries:",0
,function(self,aContext)
local vars=nil
local word=nil
local start=nil
local temporary=nil
if ((self):match_((self):verticalBar()))==true then return (smalltalk:newArray({})); end;
(function()
	local _s8_value=((smalltalk.Array):new())
	vars=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((self):nextWord())
	word=_s8_value
	return _s8_value
end)();return (smalltalk:notNil_((word)))
end))() do (self):position_(start);
(function()
	local _s8_value=((self):nextArgument_(aContext))
	temporary=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((temporary)))==true then return ((self):expected_("local name")); end;
(temporary):canBeAssigned_(true);
(vars):addLast_(temporary); end;
if ((self):match_((self):verticalBar()))==true then return (vars); end;
return ((self):expected_((self):verticalBar()));
end
,"parsing","parseTemporaries: aContext\r\n\t\" Private - Read temporaries from the receiver's stream.\r\n\t<rule> temporaries = [ '|' (variable) ] (variable, ..., variable)*\r\n\t\"\r\n\r\n\t| vars word start temporary |\r\n\t(self match: self verticalBar) ifTrue: [ ^#() ].\r\n\tvars := Array new.\r\n\t[\tstart := self startOfNextToken.\r\n\t\tword := self nextWord.\r\n\t\tword notNil\r\n\t] whileTrue: [\r\n\t\tself position: start.\r\n\t\ttemporary := self nextArgument: aContext.\r\n\t\ttemporary isNil ifTrue: [ ^self expected: 'local name' ].\r\n\t\ttemporary canBeAssigned: true.\r\n\t\tvars addLast: temporary.\r\n\t].\r\n\t(self match: self verticalBar) ifTrue: [ ^vars ].\r\n\t^self expected: self verticalBar","function(self,aContext)\r\nlocal vars=nil\r\nlocal word=nil\r\nlocal start=nil\r\nlocal temporary=nil\r\nif ((self):match_((self):verticalBar()))==true then return (smalltalk:newArray({})); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tvars=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((self):nextWord())\r\n\tword=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:notNil_((word)))\r\nend))() do (self):position_(start);\r\n(function()\r\n\tlocal _s8_value=((self):nextArgument_(aContext))\r\n\ttemporary=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((temporary)))==true then return ((self):expected_(\"local name\")); end;\r\n(temporary):canBeAssigned_(true);\r\n(vars):addLast_(temporary); end;\r\nif ((self):match_((self):verticalBar()))==true then return (vars); end;\r\nreturn ((self):expected_((self):verticalBar()));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"assignment:in:",0
,function(self,aVariable,aContext)
local expression=nil
if not (((aVariable):canBeAssigned()))==true then return ((self):syntaxError_("Cant assign to this variable.")); end;
(function()
	local _s8_value=((self):expression_(aContext))
	expression=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((expression)))==true then return ((self):expected_("expression")); end;
return ((
function(_s8_rec)
	(_s8_rec):variable_(aVariable);
	(_s8_rec):expression_(expression);
	return ((_s8_rec):yourself())
end
)((smalltalk.AssignNode):new()));
end
,"parsing","assignment: aVariable in: aContext\r\n\t\" Private - Get the assignment from the receiver.\r\n\t<rule> expression = {variableName ':='} (primary | messageExpression {';' cascadeMessage} ).\r\n\t \"\r\n\r\n\t| expression |\r\n\taVariable canBeAssigned ifFalse: [ ^self syntaxError: 'Cant assign to this variable.' ].\r\n\texpression := self expression: aContext.\r\n\texpression isNil ifTrue: [ ^self expected: #expression ].\r\n\t^AssignNode new\r\n\t\tvariable: aVariable;\r\n\t\texpression: expression;\r\n\t\tyourself","function(self,aVariable,aContext)\r\nlocal expression=nil\r\nif not (((aVariable):canBeAssigned()))==true then return ((self):syntaxError_(\"Cant assign to this variable.\")); end;\r\n(function()\r\n\tlocal _s8_value=((self):expression_(aContext))\r\n\texpression=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((expression)))==true then return ((self):expected_(\"expression\")); end;\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):variable_(aVariable);\r\n\t(_s8_rec):expression_(expression);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.AssignNode):new()));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"assignment:in:startPosition:",0
,function(self,variable,aContext,startPosition)
local assignment=nil
(function()
	local _s8_value=((self):assignment_in_(variable,aContext))
	assignment=_s8_value
	return _s8_value
end)();
(assignment):sourceRange_((startPosition):to_((self):position()));
return (assignment);
end
,"parsing","assignment: variable in: aContext startPosition: startPosition\r\n\t\" Private - Get the an assignement from the receiver. \"\r\n\r\n\t| assignment |\r\n\tassignment := self assignment: variable in: aContext.\r\n\tassignment sourceRange: (startPosition to: self position).\r\n\t^assignment","function(self,variable,aContext,startPosition)\r\nlocal assignment=nil\r\n(function()\r\n\tlocal _s8_value=((self):assignment_in_(variable,aContext))\r\n\tassignment=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(assignment):sourceRange_((startPosition):to_((self):position()));\r\nreturn (assignment);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"initializeInstanceVariables",0
,function(self)
(self):instanceVariables_((smalltalk.Array):new());
return (self);
end
,"initialize","initializeInstanceVariables\r\n\t\" Private - Initializes the receiver's instanceVariables. \"\r\n\r\n\tself instanceVariables: Array new","function(self)\r\n(self):instanceVariables_((smalltalk.Array):new());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"initializeScope",0
,function(self)
(self):scope_((smalltalk.ParseContext):default());
return (self);
end
,"initialize","initializeScope\r\n\t\" Private - Initializes the receiver's scope. \"\r\n\r\n\tself scope: ParseContext default","function(self)\r\n(self):scope_((smalltalk.ParseContext):default());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"atEnd",0
,function(self)
(self):skipSeparators();
return ((self["@source"]):atEnd());
end
,"query","atEnd\r\n\t\" Returns true when the receiver is atEnd. \"\r\n\r\n\tself skipSeparators.\r\n\t^source atEnd","function(self)\r\n(self):skipSeparators();\r\nreturn ((self[\"@source\"]):atEnd());\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"isBinarySelector:",0
,function(self,aSelector)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if ((aSelector):isEmpty())==true then return (false); end;
(aSelector):detect_ifNone_((function(one)
return (smalltalk:booleanNot_(((self):isSelectorCharacter_(one))))
end),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"query","isBinarySelector: aSelector\r\n\t\" Private - Returns true if aSelector is a keyword selector. \"\r\n\r\n\taSelector isEmpty ifTrue: [ ^false ].\r\n\taSelector\r\n\t\tdetect: [:one| (self isSelectorCharacter: one) not ]\r\n\t\tifNone: [ ^true ].\r\n\t^false","function(self,aSelector)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif ((aSelector):isEmpty())==true then return (false); end;\r\n(aSelector):detect_ifNone_((function(one)\r\nreturn (smalltalk:booleanNot_(((self):isSelectorCharacter_(one))))\r\nend),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"isKeywordSelector:",0
,function(self,aSelector)
return (smalltalk:isObject_equalTo_(((aSelector):last()),":"));
end
,"query","isKeywordSelector: aSelector\r\n\t\" Private - Returns true if aSelector is a keyword selector. \"\r\n\r\n\t^aSelector last = $:","function(self,aSelector)\r\nreturn (smalltalk:isObject_equalTo_(((aSelector):last()),\":\"));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"isAlpha:",0
,function(self,aCharacter)
return (smalltalk:boolean_or_(((aCharacter):isAlphaNumeric()),(function()
return (("_"):includes_(aCharacter))
end)));
end
,"query","isAlpha: aCharacter\r\n\t\" Private - Returns true if aCharacter is good in a word. \"\r\n\r\n\t^aCharacter isAlphaNumeric or: [ '_' includes: aCharacter ]","function(self,aCharacter)\r\nreturn (smalltalk:boolean_or_(((aCharacter):isAlphaNumeric()),(function()\r\nreturn ((\"_\"):includes_(aCharacter))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"binarySelectorChars",0
,function(self)
return ("|&+*/=><,@%~-?!\\");
end
,"constants","binarySelectorChars\r\n\t\" Return the binary selector characters mask. \"\r\n\r\n\t^'|&+*/=><,@%~-?!\\' ","function(self)\r\nreturn (\"|&+*/=><,@%~-?!\\\\\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"isSelectorCharacter:",0
,function(self,aCharacter)
return (((self):binarySelectorChars()):includes_(aCharacter));
end
,"query","isSelectorCharacter: aCharacter\r\n\t\" Private - Returns true if aCharacter is a selector character.\r\n\t<rule> selectorCharacter = ',' | '+' | '-' | '/' | '\\' | '*' | '~' | '>' | '<' | '=' | '@' | '%' | '|' | '&' | '?' | '!' .\r\n\t\"\r\n\r\n\t^self binarySelectorChars includes: aCharacter","function(self,aCharacter)\r\nreturn (((self):binarySelectorChars()):includes_(aCharacter));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"isUnarySelector:",0
,function(self,aSelector)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if ((aSelector):isEmpty())==true then return (false); end;
(aSelector):detect_ifNone_((function(one)
return (smalltalk:booleanNot_(((self):isAlpha_(one))))
end),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"query","isUnarySelector: aSelector\r\n\t\" Private - Returns true if aSelector is a unary selector. \"\r\n\r\n\taSelector isEmpty ifTrue: [ ^false ].\r\n\"\taSelector first isLetter ifFalse: [ ^false ].\"\r\n\taSelector\r\n\t\tdetect: [:one| (self isAlpha: one) not ]\r\n\t\tifNone: [ ^true ].\r\n\t^false","function(self,aSelector)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif ((aSelector):isEmpty())==true then return (false); end;\r\n(aSelector):detect_ifNone_((function(one)\r\nreturn (smalltalk:booleanNot_(((self):isAlpha_(one))))\r\nend),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"arrayLiteralElement:",0
,function(self,aContext)
return ((self):constant_(aContext));
end
,"parsing","arrayLiteralElement: aContext\r\n\t\" Private - Gets the next array element from the receiver. \"\r\n\r\n\t^self constant: aContext ","function(self,aContext)\r\nreturn ((self):constant_(aContext));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"basicPeek",0
,function(self)
if (smalltalk:isObject_equalTo_(((self["@source"]):peek()),"\""))==true then (
function(_s8_rec)
	(_s8_rec):next();
	return ((_s8_rec):upTo_("\""))
end
)(self["@source"]); end;
return ((self["@source"]):peek());
end
,"parsing","basicPeek\r\n\t\"Peek the next character from source stream. \"\r\n\r\n\tsource peek = $\" ifTrue: [ \"skip coments\"\r\n\t\tsource next;upTo: $\"\r\n\t].\r\n\t^source peek","function(self)\r\nif (smalltalk:isObject_equalTo_(((self[\"@source\"]):peek()),\"\\\"\"))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):next();\r\n\treturn ((_s8_rec):upTo_(\"\\\"\"))\r\nend\r\n)(self[\"@source\"]); end;\r\nreturn ((self[\"@source\"]):peek());\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"cascade:to:in:",0
,function(self,expression,aReceiver,aContext)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local start=nil
local cascade=nil
local message=nil
(function()
	local _s8_value=((self):position())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.CascadedMessageNode):for_(expression))
	cascade=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((self):message3_repeat_in_(aReceiver,false,aContext))
	message=_s8_value
	return _s8_value
end)();if (smalltalk:isNil_((message)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):expected_("message"))
end
)()
error(_s8Ret_,0)
end)(); end;(cascade):add_(message);return ((self):match_((self):semicolon()))
end))() do  end;
(cascade):sourceRange_((start):to_((self):position()));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (cascade)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","cascade: expression to: aReceiver in: aContext\r\n\t\" Private - Parse the receiver looking for a cascade expression using variables in aContext.\r\n\t<rule> cascadeMessage = unaryMessage | binaryMessage | keywordMessage.\r\n\t\"\r\n\r\n\t| start cascade message |\r\n\tstart := self position.\r\n\tcascade := CascadedMessageNode for: expression.\r\n\t[\tmessage := self message3: aReceiver repeat: false in: aContext.\r\n\t\tmessage isNil ifTrue: [ ^self expected: #message ].\r\n\t\tcascade add: message.\r\n\t\tself match: self semicolon ] whileTrue: [].\r\n\tcascade sourceRange: (start to: self position).\r\n\t^cascade","function(self,expression,aReceiver,aContext)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal start=nil\r\nlocal cascade=nil\r\nlocal message=nil\r\n(function()\r\n\tlocal _s8_value=((self):position())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.CascadedMessageNode):for_(expression))\r\n\tcascade=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((self):message3_repeat_in_(aReceiver,false,aContext))\r\n\tmessage=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isNil_((message)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):expected_(\"message\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;(cascade):add_(message);return ((self):match_((self):semicolon()))\r\nend))() do  end;\r\n(cascade):sourceRange_((start):to_((self):position()));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (cascade)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"checkForOldSyntax:with:on:",0
,function(self,radix,value,aStream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (smalltalk:boolean_and_((smalltalk:booleanNot_(((aStream):atEnd()))),(function()
return ((aStream):peekFor_("."))
end)))==true then smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:booleanNot_(((aStream):atEnd()))),(function()
return ((((aStream):peek()):digitValue()):between_and_(0,(radix):_minus(1)))
end))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):syntaxError_("Non-radix 10 numbers may not contain decimal points"))
end
)()
error(_s8Ret_,0)
end)())
end),(function()
return ((aStream):skip_(-1))
end)); end;
if (smalltalk:boolean_and_((smalltalk:booleanNot_(((aStream):atEnd()))),(function()
return (smalltalk:isObject_equalTo_((((aStream):peek()):asLowercase()),"e"))
end)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):syntaxError_("Non-radix 10 numbers may not have an exponent"))
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (value)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","checkForOldSyntax: radix with: value on: aStream\r\n\t\" Private - Answer aNumber as described on the stream, aStream. \"\r\n\r\n\t(aStream atEnd not and: [aStream peekFor: $.])\r\n\tifTrue: [\r\n\t\t(aStream atEnd not and: [aStream peek digitValue between: 0 and: radix-1])\r\n\t\tifTrue: [ ^self syntaxError: 'Non-radix 10 numbers may not contain decimal points' ]\r\n\t\tifFalse: [ aStream skip: -1 ]\r\n\t].\r\n\t(aStream atEnd not and: [aStream peek asLowercase = $e])\r\n\tifTrue: [ ^self syntaxError: 'Non-radix 10 numbers may not have an exponent' ].\r\n\t^value","function(self,radix,value,aStream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (smalltalk:boolean_and_((smalltalk:booleanNot_(((aStream):atEnd()))),(function()\r\nreturn ((aStream):peekFor_(\".\"))\r\nend)))==true then smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:booleanNot_(((aStream):atEnd()))),(function()\r\nreturn ((((aStream):peek()):digitValue()):between_and_(0,(radix):_minus(1)))\r\nend))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):syntaxError_(\"Non-radix 10 numbers may not contain decimal points\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),(function()\r\nreturn ((aStream):skip_(-1))\r\nend)); end;\r\nif (smalltalk:boolean_and_((smalltalk:booleanNot_(((aStream):atEnd()))),(function()\r\nreturn (smalltalk:isObject_equalTo_((((aStream):peek()):asLowercase()),\"e\"))\r\nend)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):syntaxError_(\"Non-radix 10 numbers may not have an exponent\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (value)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"colon",0
,function(self)
return (":");
end
,"constants","colon\r\n\t\" Private - Returns the colon token. \"\r\n\r\n\t^$:","function(self)\r\nreturn (\":\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextDashOrNumber",0
,function(self)
local result=nil
if not ((smalltalk:isObject_equalTo_(((self["@source"]):peek()),"-")))==true then return ((self):nextNumber()); end;
(function()
	local _s8_value=((self["@source"]):next())
	result=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:booleanNot_(((self["@source"]):atEnd()))),(function()
return (((self["@source"]):peek()):isDigit())
end))),(function()
return (((self):nextNumber()):negated())
end),(function()
return (result)
end)));
end
,"parsing","nextDashOrNumber\r\n\t\" Private - Returns the next Number or #- \"\r\n\r\n\t| result |\r\n\t(source peek = $-) ifFalse: [ ^self nextNumber ].\r\n\tresult := source next.\r\n\t^(source atEnd not and: [source peek isDigit])\r\n\t\tifTrue: [ self nextNumber negated ]\r\n\t\tifFalse: [ result ]","function(self)\r\nlocal result=nil\r\nif not ((smalltalk:isObject_equalTo_(((self[\"@source\"]):peek()),\"-\")))==true then return ((self):nextNumber()); end;\r\n(function()\r\n\tlocal _s8_value=((self[\"@source\"]):next())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:booleanNot_(((self[\"@source\"]):atEnd()))),(function()\r\nreturn (((self[\"@source\"]):peek()):isDigit())\r\nend))),(function()\r\nreturn (((self):nextNumber()):negated())\r\nend),(function()\r\nreturn (result)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"constant:",0
,function(self,aContext)
(self):skipSeparators();
if ((self):match_("false"))==true then return (false); end;
if ((self):match_("true"))==true then return (true); end;
if ((self):match_("nil"))==true then return (nil); end;
if ((self):match_((self):singleQuote()))==true then return ((self):nextString()); end;
if (smalltalk:notNil_(((self):peekAny_advance_("0123456789-",false))))==true then return ((self):nextDashOrNumber()); end;
if ((self):match_((self):dollar()))==true then return ((self):nextCharacter()); end;
if ((self):match_((smalltalk.Array):with_with_((self):literalQuote(),(self):leftParenthesis())))==true then return ((self):nextArray_(aContext)); end;
if ((self):match_((self):literalQuote()))==true then return ((self):nextSymbol()); end;
if ((self):match_((self):leftParenthesis()))==true then return ((self):nextArray_(aContext)); end;
if ((self):match_((self):leftBracket()))==true then return ((self):nextByteArray_(aContext)); end;
if ((self):match_((self):leftBrace()))==true then return ((self):nextBraceLiteral_(aContext)); end;
return ((self):nextSymbol());
end
,"parsing","constant: aContext\r\n\t\" Private - Recognize a constant (named, number, character, string, or quoted).\r\n\tReturns the constant value. \"\r\n\r\n\tself skipSeparators.\r\n\t(self match: #false) ifTrue: [ ^false ].\r\n\t(self match: #true) ifTrue: [ ^true ].\r\n\t(self match: #nil) ifTrue: [ ^nil ].\r\n\t(self match: self singleQuote) ifTrue: [ ^self nextString ].\r\n\t(self peekAny: '0123456789-' advance: false) notNil ifTrue: [ ^self nextDashOrNumber ].\r\n\t(self match: self dollar) ifTrue: [ ^self nextCharacter ].\r\n\t(self match: (Array with: self literalQuote with: self leftParenthesis)) ifTrue: [ ^self nextArray: aContext ].\r\n\t(self match: self literalQuote) ifTrue: [ ^self nextSymbol ].\r\n\t(self match: self leftParenthesis) ifTrue: [ ^self nextArray: aContext ].\r\n\t(self match: self leftBracket) ifTrue: [ ^self nextByteArray: aContext ].\r\n\t(self match: self leftBrace) ifTrue: [ ^self nextBraceLiteral: aContext ].\r\n\t^self nextSymbol ","function(self,aContext)\r\n(self):skipSeparators();\r\nif ((self):match_(\"false\"))==true then return (false); end;\r\nif ((self):match_(\"true\"))==true then return (true); end;\r\nif ((self):match_(\"nil\"))==true then return (nil); end;\r\nif ((self):match_((self):singleQuote()))==true then return ((self):nextString()); end;\r\nif (smalltalk:notNil_(((self):peekAny_advance_(\"0123456789-\",false))))==true then return ((self):nextDashOrNumber()); end;\r\nif ((self):match_((self):dollar()))==true then return ((self):nextCharacter()); end;\r\nif ((self):match_((smalltalk.Array):with_with_((self):literalQuote(),(self):leftParenthesis())))==true then return ((self):nextArray_(aContext)); end;\r\nif ((self):match_((self):literalQuote()))==true then return ((self):nextSymbol()); end;\r\nif ((self):match_((self):leftParenthesis()))==true then return ((self):nextArray_(aContext)); end;\r\nif ((self):match_((self):leftBracket()))==true then return ((self):nextByteArray_(aContext)); end;\r\nif ((self):match_((self):leftBrace()))==true then return ((self):nextBraceLiteral_(aContext)); end;\r\nreturn ((self):nextSymbol());\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"dollar",0
,function(self)
return ("$");
end
,"constants","dollar\r\n\t\" Private - Returns the dollar token. \"\r\n\r\n\t^$$","function(self)\r\nreturn (\"$\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"syntaxError:",0
,function(self,aString)
local syntaxError=nil
(function()
	local _s8_value=((smalltalk.SyntaxError):description_(aString))
	syntaxError=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):source_((self["@source"]):contents());
	(_s8_rec):position_(((self):position()):_plus(1));
	return ((_s8_rec):yourself())
end
)(syntaxError);
return ((self["@errorBlock"]):value_(syntaxError));
end
,"error","syntaxError: aString\r\n\t\" A Syntax error has been occurred at current position in source. \"\r\n\r\n\t| syntaxError |\r\n\tsyntaxError := SyntaxError description: aString.\r\n\tsyntaxError\r\n\t\tsource: source contents;\r\n\t\tposition: self position + 1;\r\n\t\tyourself.\r\n\t^errorBlock value: syntaxError","function(self,aString)\r\nlocal syntaxError=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.SyntaxError):description_(aString))\r\n\tsyntaxError=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):source_((self[\"@source\"]):contents());\r\n\t(_s8_rec):position_(((self):position()):_plus(1));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(syntaxError);\r\nreturn ((self[\"@errorBlock\"]):value_(syntaxError));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"expected:",0
,function(self,aString)
return ((self):syntaxError_(smalltalk:object_comma_((aString)," expected")));
end
,"error","expected: aString\r\n\t\"An expected element can't be found at current position in source. \"\r\n\r\n\t^self syntaxError: aString ,' expected'","function(self,aString)\r\nreturn ((self):syntaxError_(smalltalk:object_comma_((aString),\" expected\")));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"instanceVariables",0
,function(self)
if (smalltalk:isNil_((self["@instanceVariables"])))==true then (self):initializeInstanceVariables(); end;
return (self["@instanceVariables"]);
end
,"accessing","instanceVariables\r\n\t\" Returns the receiver's instanceVariables. \"\r\n\r\n\tinstanceVariables isNil ifTrue: [ self initializeInstanceVariables ].\r\n\t^instanceVariables","function(self)\r\nif (smalltalk:isNil_((self[\"@instanceVariables\"])))==true then (self):initializeInstanceVariables(); end;\r\nreturn (self[\"@instanceVariables\"]);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"instanceVariables:",0
,function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@instanceVariables"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","instanceVariables: aCollection\r\n\t\" Set the receiver's instanceVariables. \"\r\n\r\n\tinstanceVariables := aCollection","function(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@instanceVariables\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"leftArrow",0
,function(self)
return (":=");
end
,"constants","leftArrow\r\n\t\" Private - Returns the leftArrow token. \"\r\n\r\n\t^':='","function(self)\r\nreturn (\":=\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"period",0
,function(self)
return (".");
end
,"constants","period\r\n\t\" Private - Returns the period token. \"\r\n\r\n\t^$.","function(self)\r\nreturn (\".\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"leftBrace",0
,function(self)
return ("{");
end
,"constants","leftBrace\r\n\t\" Private - Returns the leftBrace token. \"\r\n\r\n\t^${","function(self)\r\nreturn (\"{\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"leftBracket",0
,function(self)
return ("[");
end
,"constants","leftBracket\r\n\t\" Private - Returns the leftBracket token. \"\r\n\r\n\t^$[","function(self)\r\nreturn (\"[\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"leftParenthesis",0
,function(self)
return ("(");
end
,"constants","leftParenthesis\r\n\t\" Private - Returns the leftParentesis token. \"\r\n\r\n\t^$(","function(self)\r\nreturn (\"(\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"literalQuote",0
,function(self)
return ("#");
end
,"constants","literalQuote\r\n\t\" Private - Returns the literal quote token. \"\r\n\r\n\t^$#","function(self)\r\nreturn (\"#\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"primitiveStart",0
,function(self)
return ("<");
end
,"constants","primitiveStart\r\n\t\" Private - Returns the start primitive token. \"\r\n\r\n\t^$<","function(self)\r\nreturn (\"<\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"primitiveEnd",0
,function(self)
return (">");
end
,"constants","primitiveEnd\r\n\t\" Private - Returns the end primitive token. \"\r\n\r\n\t^$>","function(self)\r\nreturn (\">\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"match:",0
,function(self,token)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local position=nil
if ((self):atEnd())==true then return (false); end;
(function()
	local _s8_value=((self):position())
	position=_s8_value
	return _s8_value
end)();
if ((token):isCharacter())==true then smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):peek()),token)),(function()
(self):next();return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil); else smalltalk:if_true_false_(((token):isMemberOf_(smalltalk.BlockClosure)),(function()
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((token):argumentCount()),0)),(function()
return (smalltalk:if_true_false_(((token):value()),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end),(function()
return (smalltalk:if_true_false_(((token):value_((self):next())),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end)))
end),(function()
return ((token):detect_ifNone_((function(one)
return (smalltalk:booleanNot_(((self):match_(one))))
end),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end)))
end)); end;
(self):position_(position);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","match: token\r\n\t\" Try to match token.\r\n\ttoken can be a single token or a collection of tokens.\r\n\tReturns true if success and advance the receiver's stream.\r\n\tIf failed, restore the receiver's position. \"\r\n\r\n\t| position |\r\n\tself atEnd ifTrue: [^false].\r\n\tposition := self position.\r\n\ttoken isCharacter ifTrue: [\r\n\t\tself peek = token\r\n\t\tifTrue: [ self next.^true ]\r\n\t] ifFalse: [\r\n\t\t(token isMemberOf: BlockClosure) ifTrue: [\r\n\t\t\ttoken argumentCount = 0\r\n\t\t\tifTrue: [ token value ifTrue: [ ^true ] ]\r\n\t\t\tifFalse: [ (token value: self next) ifTrue: [ ^true ] ]\r\n\t\t] ifFalse: [\r\n\t\t\ttoken\r\n\t\t\t\tdetect: [:one| (self match: one) not ]\r\n\t\t\t\tifNone: [ ^true ].\r\n\t\t].\r\n\t].\r\n\tself position: position.\r\n\t^false","function(self,token)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal position=nil\r\nif ((self):atEnd())==true then return (false); end;\r\n(function()\r\n\tlocal _s8_value=((self):position())\r\n\tposition=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((token):isCharacter())==true then smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):peek()),token)),(function()\r\n(self):next();return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); else smalltalk:if_true_false_(((token):isMemberOf_(smalltalk.BlockClosure)),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((token):argumentCount()),0)),(function()\r\nreturn (smalltalk:if_true_false_(((token):value()),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend),(function()\r\nreturn (smalltalk:if_true_false_(((token):value_((self):next())),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend)))\r\nend),(function()\r\nreturn ((token):detect_ifNone_((function(one)\r\nreturn (smalltalk:booleanNot_(((self):match_(one))))\r\nend),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend)); end;\r\n(self):position_(position);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"message1:repeat:in:",0
,function(self,aNode,__repeat,aContext)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local aReceiver=nil
local start=nil
local selector=nil
local params=nil
local argument=nil
local part=nil
local partStart=nil
(function()
	local _s8_value=(aNode)
	aReceiver=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((self):nextSelectorOrNil())
	selector=_s8_value
	return _s8_value
end)();if (smalltalk:isNil_((selector)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (aReceiver)
end
)()
error(_s8Ret_,0)
end)(); end;if ((self):isUnarySelector_(selector))==true then (function()
	local _s8_value=(smalltalk:newArray({}))
	params=_s8_value
	return _s8_value
end)(); else if ((aReceiver):isSuper())==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):expected_("message"))
end
)()
error(_s8Ret_,0)
end)(); end;
(self):position_(start);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (aReceiver)
end
)()
error(_s8Ret_,0)
end)(); end;if (smalltalk:isNil_((aReceiver)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):expected_("Receiver or name"))
end
)()
error(_s8Ret_,0)
end)(); end;(function()
	local _s8_value=(((smalltalk.MessageNode):from_to_(start,(self):position())):receiver_selector_arguments_(aReceiver,(self):newSelectorName_(selector),params))
	aReceiver=_s8_value
	return _s8_value
end)();return (__repeat)
end))() do  end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (aReceiver)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","message1: aNode repeat: repeat in: aContext\r\n\t\" Private - Parse the receiver looking for a message expression using variables in aContext.\r\n\t<rule> messageExpression = unaryExpression | binaryExpression | keywordExpression.\r\n\t<rule> unaryExpression = primaryMessage {unaryMessage}.\r\n\t<rule> binaryExpression = (unaryExpression | primary) binaryMessage {binaryMessage}.\r\n\t<rule> keywordExpression = (binaryExpression | primary) keywordMessage.\r\n\t\"\r\n\r\n\t| aReceiver start selector params argument part partStart |\r\n\taReceiver := aNode.\r\n\t[\r\n\t\tstart := self startOfNextToken.\r\n\t\tselector := self nextSelectorOrNil.\r\n\t\tselector isNil ifTrue: [ ^aReceiver ].\r\n\t\t(self isUnarySelector: selector) \"simple message\"\r\n\t\tifTrue: [ params := #() ]\r\n\t\tifFalse: [\r\n\t\t\taReceiver isSuper ifTrue: [ ^self expected: #message ].\r\n\t\t\tself position: start.\r\n\t\t\t^aReceiver\r\n\t\t].\r\n\t\taReceiver isNil ifTrue: [ ^self expected: 'Receiver or name' ].\r\n\t\taReceiver := (MessageNode from: start to: self position)\r\n\t\t\treceiver: aReceiver\r\n\t\t\tselector: (self newSelectorName: selector)\r\n\t\t\targuments: params.\r\n\trepeat ] whileTrue: [].\r\n\t^aReceiver","function(self,aNode,__repeat,aContext)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal aReceiver=nil\r\nlocal start=nil\r\nlocal selector=nil\r\nlocal params=nil\r\nlocal argument=nil\r\nlocal part=nil\r\nlocal partStart=nil\r\n(function()\r\n\tlocal _s8_value=(aNode)\r\n\taReceiver=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((self):nextSelectorOrNil())\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isNil_((selector)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (aReceiver)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;if ((self):isUnarySelector_(selector))==true then (function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tparams=_s8_value\r\n\treturn _s8_value\r\nend)(); else if ((aReceiver):isSuper())==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):expected_(\"message\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(self):position_(start);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (aReceiver)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;if (smalltalk:isNil_((aReceiver)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):expected_(\"Receiver or name\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;(function()\r\n\tlocal _s8_value=(((smalltalk.MessageNode):from_to_(start,(self):position())):receiver_selector_arguments_(aReceiver,(self):newSelectorName_(selector),params))\r\n\taReceiver=_s8_value\r\n\treturn _s8_value\r\nend)();return (__repeat)\r\nend))() do  end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (aReceiver)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"message2:repeat:in:",0
,function(self,aNode,__repeat,aContext)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local aReceiver=nil
local start=nil
local selector=nil
local params=nil
local argument=nil
local part=nil
local partStart=nil
(function()
	local _s8_value=(aNode)
	aReceiver=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((self):nextSelectorOrNil())
	selector=_s8_value
	return _s8_value
end)();if (smalltalk:isNil_((selector)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (aReceiver)
end
)()
error(_s8Ret_,0)
end)(); end;if (smalltalk:boolean_or_((smalltalk:isObject_equalTo_((selector),"|")),(function()
return ((self):isBinarySelector_(selector))
end)))==true then (function()
	local _s8_value=((self):primaryExpression_(aContext))
	argument=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((argument)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):expected_("argument"))
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
	local _s8_value=((self):message1_repeat_in_(argument,true,aContext))
	argument=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((argument)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):expected_("argument"))
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
	local _s8_value=((smalltalk.Array):with_(argument))
	params=_s8_value
	return _s8_value
end)(); else smalltalk:if_true_false_(((self):isUnarySelector_(selector)),(function()
return ((function()
	local _s8_value=(smalltalk:newArray({}))
	params=_s8_value
	return _s8_value
end)())
end),(function()
if ((aReceiver):isSuper())==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):expected_("message"))
end
)()
error(_s8Ret_,0)
end)(); end;(self):position_(start);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (aReceiver)
end
)()
error(_s8Ret_,0)
end)())
end)); end;if (smalltalk:isNil_((aReceiver)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):syntaxError_("Invalid receiver or invalid name"))
end
)()
error(_s8Ret_,0)
end)(); end;(function()
	local _s8_value=(((smalltalk.MessageNode):from_to_(start,(self):position())):receiver_selector_arguments_(aReceiver,(self):newSelectorName_(selector),params))
	aReceiver=_s8_value
	return _s8_value
end)();return (__repeat)
end))() do  end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (aReceiver)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","message2: aNode repeat: repeat in: aContext\r\n\t\" Private - Parse the receiver looking for a message expression using variables in aContext.\r\n\t<rule> messageExpression = unaryExpression | binaryExpression | keywordExpression.\r\n\t<rule> unaryExpression = primaryMessage {unaryMessage}.\r\n\t<rule> binaryExpression = (unaryExpression | primary) binaryMessage {binaryMessage}.\r\n\t<rule> keywordExpression = (binaryExpression | primary) keywordMessage.\r\n\t\"\r\n\r\n\t| aReceiver start selector params argument part partStart |\r\n\taReceiver := aNode.\r\n\t[\r\n\t\tstart := self startOfNextToken.\r\n\t\tselector := self nextSelectorOrNil.\r\n\t\tselector isNil ifTrue: [ ^aReceiver ].\r\n\t\t(selector = #| or: [self isBinarySelector: selector]) \"level>=2\"\r\n\t\tifTrue: [\r\n\t\t\targument := self primaryExpression: aContext.\r\n\t\t\targument isNil ifTrue: [ ^self expected: #argument ].\r\n\t\t\targument := self message1: argument repeat: true in: aContext.\r\n\t\t\targument isNil ifTrue: [ ^self expected: #argument ].\r\n\t\t\tparams := Array with: argument.\r\n\t\t]\r\n\t\tifFalse: [\r\n\t\t\t(self isUnarySelector: selector) \"simple message\"\r\n\t\t\tifTrue: [ params := #() ]\r\n\t\t\tifFalse: [\r\n\t\t\t\taReceiver isSuper ifTrue: [ ^self expected: #message ].\r\n\t\t\t\tself position: start.\r\n\t\t\t\t^aReceiver\r\n\t\t\t]\r\n\t\t].\r\n\t\taReceiver isNil ifTrue: [ ^self syntaxError: 'Invalid receiver or invalid name' ].\r\n\t\taReceiver := (MessageNode from: start to: self position)\r\n\t\t\treceiver: aReceiver\r\n\t\t\tselector: (self newSelectorName: selector)\r\n\t\t\targuments: params.\r\n\trepeat ] whileTrue: [].\r\n\t^aReceiver","function(self,aNode,__repeat,aContext)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal aReceiver=nil\r\nlocal start=nil\r\nlocal selector=nil\r\nlocal params=nil\r\nlocal argument=nil\r\nlocal part=nil\r\nlocal partStart=nil\r\n(function()\r\n\tlocal _s8_value=(aNode)\r\n\taReceiver=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((self):nextSelectorOrNil())\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isNil_((selector)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (aReceiver)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;if (smalltalk:boolean_or_((smalltalk:isObject_equalTo_((selector),\"|\")),(function()\r\nreturn ((self):isBinarySelector_(selector))\r\nend)))==true then (function()\r\n\tlocal _s8_value=((self):primaryExpression_(aContext))\r\n\targument=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((argument)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):expected_(\"argument\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((self):message1_repeat_in_(argument,true,aContext))\r\n\targument=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((argument)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):expected_(\"argument\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_(argument))\r\n\tparams=_s8_value\r\n\treturn _s8_value\r\nend)(); else smalltalk:if_true_false_(((self):isUnarySelector_(selector)),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tparams=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),(function()\r\nif ((aReceiver):isSuper())==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):expected_(\"message\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;(self):position_(start);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (aReceiver)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)); end;if (smalltalk:isNil_((aReceiver)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):syntaxError_(\"Invalid receiver or invalid name\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;(function()\r\n\tlocal _s8_value=(((smalltalk.MessageNode):from_to_(start,(self):position())):receiver_selector_arguments_(aReceiver,(self):newSelectorName_(selector),params))\r\n\taReceiver=_s8_value\r\n\treturn _s8_value\r\nend)();return (__repeat)\r\nend))() do  end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (aReceiver)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"message3:repeat:in:",0
,function(self,aNode,__repeat,aContext)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local aReceiver=nil
local start=nil
local selector=nil
local params=nil
local argument=nil
local part=nil
local partStart=nil
local isNative=nil
(function()
	local _s8_value=(aNode)
	aReceiver=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((self):match_((self):literalQuote()))
	isNative=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((self):nextSelectorOrNil())
	selector=_s8_value
	return _s8_value
end)();if (smalltalk:isNil_((selector)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (aReceiver)
end
)()
error(_s8Ret_,0)
end)(); end;if ((self):isKeywordSelector_(selector))==true then (function()
	local _s8_value=((self):primaryExpression_(aContext))
	argument=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((argument)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):expected_("argument"))
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
	local _s8_value=((self):message2_repeat_in_(argument,true,aContext))
	argument=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((argument)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):expected_("argument"))
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
	local _s8_value=((smalltalk.Array):with_(argument))
	params=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((self):startOfNextToken())
	partStart=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((self):nextSelectorOrNil())
	part=_s8_value
	return _s8_value
end)();return (smalltalk:boolean_and_((smalltalk:notNil_((part))),(function()
return ((self):isKeywordSelector_(part))
end)))
end))() do (function()
	local _s8_value=(smalltalk:object_comma_((selector),part))
	selector=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):primaryExpression_(aContext))
	argument=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((argument)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):expected_("argument"))
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
	local _s8_value=((self):message2_repeat_in_(argument,true,aContext))
	argument=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((argument)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):expected_("argument"))
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
	local _s8_value=((params):copyWith_(argument))
	params=_s8_value
	return _s8_value
end)(); end;
(self):position_(partStart); else smalltalk:if_true_false_((smalltalk:boolean_or_((smalltalk:isObject_equalTo_((selector),"|")),(function()
return ((self):isBinarySelector_(selector))
end))),(function()
(function()
	local _s8_value=((self):primaryExpression_(aContext))
	argument=_s8_value
	return _s8_value
end)();if (smalltalk:isNil_((argument)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):expected_("argument"))
end
)()
error(_s8Ret_,0)
end)(); end;(function()
	local _s8_value=((self):message1_repeat_in_(argument,true,aContext))
	argument=_s8_value
	return _s8_value
end)();if (smalltalk:isNil_((argument)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):expected_("argument"))
end
)()
error(_s8Ret_,0)
end)(); end;return ((function()
	local _s8_value=((smalltalk.Array):with_(argument))
	params=_s8_value
	return _s8_value
end)())
end),(function()
return (smalltalk:if_true_false_(((self):isUnarySelector_(selector)),(function()
return ((function()
	local _s8_value=(smalltalk:newArray({}))
	params=_s8_value
	return _s8_value
end)())
end),(function()
if ((aReceiver):isSuper())==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):expected_("message"))
end
)()
error(_s8Ret_,0)
end)(); end;(self):position_(start);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (aReceiver)
end
)()
error(_s8Ret_,0)
end)())
end)))
end)); end;if (smalltalk:isNil_((aReceiver)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):syntaxError_("Invalid receiver or invalid name"))
end
)()
error(_s8Ret_,0)
end)(); end;(function()
	local _s8_value=(((smalltalk.MessageNode):native_from_to_(isNative,start,(self):position())):receiver_selector_arguments_(aReceiver,(self):newSelectorName_(selector),params))
	aReceiver=_s8_value
	return _s8_value
end)();return (__repeat)
end))() do  end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (aReceiver)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","message3: aNode repeat: repeat in: aContext\r\n\t\" Private - Parse the receiver looking for a message expression using variables in aContext.\r\n\t<rule> messageExpression = unaryExpression | binaryExpression | keywordExpression.\r\n\t<rule> unaryExpression = primaryMessage {unaryMessage}.\r\n\t<rule> binaryExpression = (unaryExpression | primary) binaryMessage {binaryMessage}.\r\n\t<rule> keywordExpression = (binaryExpression | primary) keywordMessage.\r\n\t\"\r\n\r\n\t| aReceiver start selector params argument part partStart isNative |\r\n\taReceiver := aNode.\r\n\t[\tstart := self startOfNextToken.\r\n\t\tisNative := self match: self literalQuote.\r\n\t\tselector := self nextSelectorOrNil.\r\n\t\tselector isNil ifTrue: [ ^aReceiver ].\r\n\t\t(self isKeywordSelector: selector) \"level>=3\" ifTrue: [\r\n\t\t\targument := self primaryExpression: aContext.\r\n\t\t\targument isNil ifTrue: [ ^self expected: #argument ].\r\n\t\t\targument := self message2: argument repeat: true in: aContext.\r\n\t\t\targument isNil ifTrue: [ ^self expected: #argument ].\r\n\t\t\tparams := Array with: argument.\r\n\t\t\t[ partStart := self startOfNextToken.\r\n\t\t\tpart := self nextSelectorOrNil.\r\n\t\t\tpart notNil and: [ self isKeywordSelector: part ]\r\n\t\t\t] whileTrue: [\r\n\t\t\t\tselector := selector , part.\r\n\t\t\t\targument := self primaryExpression: aContext.\r\n\t\t\t\targument isNil ifTrue: [ ^self expected: #argument ].\r\n\t\t\t\targument := self message2: argument repeat: true in: aContext.\r\n\t\t\t\targument isNil ifTrue: [ ^self expected: #argument ].\r\n\t\t\t\tparams := params copyWith: argument.\r\n\t\t\t].\r\n\t\t\tself position: partStart.\r\n\t\t] ifFalse: [\r\n\t\t\t(selector = #| or: [self isBinarySelector: selector]) \"level>=2\" ifTrue: [\r\n\t\t\t\targument := self primaryExpression: aContext.\r\n\t\t\t\targument isNil ifTrue: [ ^self expected: #argument ].\r\n\t\t\t\targument := self message1: argument repeat: true in: aContext.\r\n\t\t\t\targument isNil ifTrue: [ ^self expected: #argument ].\r\n\t\t\t\tparams := Array with: argument.\r\n\t\t\t] ifFalse: [\r\n\t\t\t\t(self isUnarySelector: selector) \"simple message\"\r\n\t\t\t\tifTrue: [ params := #() ]\r\n\t\t\t\tifFalse: [\r\n\t\t\t\t\taReceiver isSuper ifTrue: [ ^self expected: #message ].\r\n\t\t\t\t\tself position: start.\r\n\t\t\t\t\t^aReceiver\r\n\t\t\t\t]\r\n\t\t\t]\r\n\t\t].\r\n\t\taReceiver isNil ifTrue: [ ^self syntaxError: 'Invalid receiver or invalid name' ].\r\n\t\taReceiver := (MessageNode native: isNative from: start to: self position)\r\n\t\t\treceiver: aReceiver\r\n\t\t\tselector: (self newSelectorName: selector)\r\n\t\t\targuments: params.\r\n\trepeat ] whileTrue: [].\r\n\t^aReceiver","function(self,aNode,__repeat,aContext)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal aReceiver=nil\r\nlocal start=nil\r\nlocal selector=nil\r\nlocal params=nil\r\nlocal argument=nil\r\nlocal part=nil\r\nlocal partStart=nil\r\nlocal isNative=nil\r\n(function()\r\n\tlocal _s8_value=(aNode)\r\n\taReceiver=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((self):match_((self):literalQuote()))\r\n\tisNative=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((self):nextSelectorOrNil())\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isNil_((selector)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (aReceiver)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;if ((self):isKeywordSelector_(selector))==true then (function()\r\n\tlocal _s8_value=((self):primaryExpression_(aContext))\r\n\targument=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((argument)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):expected_(\"argument\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((self):message2_repeat_in_(argument,true,aContext))\r\n\targument=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((argument)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):expected_(\"argument\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_(argument))\r\n\tparams=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tpartStart=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((self):nextSelectorOrNil())\r\n\tpart=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:boolean_and_((smalltalk:notNil_((part))),(function()\r\nreturn ((self):isKeywordSelector_(part))\r\nend)))\r\nend))() do (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((selector),part))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):primaryExpression_(aContext))\r\n\targument=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((argument)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):expected_(\"argument\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((self):message2_repeat_in_(argument,true,aContext))\r\n\targument=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((argument)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):expected_(\"argument\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((params):copyWith_(argument))\r\n\tparams=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(self):position_(partStart); else smalltalk:if_true_false_((smalltalk:boolean_or_((smalltalk:isObject_equalTo_((selector),\"|\")),(function()\r\nreturn ((self):isBinarySelector_(selector))\r\nend))),(function()\r\n(function()\r\n\tlocal _s8_value=((self):primaryExpression_(aContext))\r\n\targument=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isNil_((argument)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):expected_(\"argument\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;(function()\r\n\tlocal _s8_value=((self):message1_repeat_in_(argument,true,aContext))\r\n\targument=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isNil_((argument)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):expected_(\"argument\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return ((function()\r\n\tlocal _s8_value=((smalltalk.Array):with_(argument))\r\n\tparams=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),(function()\r\nreturn (smalltalk:if_true_false_(((self):isUnarySelector_(selector)),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tparams=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),(function()\r\nif ((aReceiver):isSuper())==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):expected_(\"message\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;(self):position_(start);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (aReceiver)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend)); end;if (smalltalk:isNil_((aReceiver)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):syntaxError_(\"Invalid receiver or invalid name\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;(function()\r\n\tlocal _s8_value=(((smalltalk.MessageNode):native_from_to_(isNative,start,(self):position())):receiver_selector_arguments_(aReceiver,(self):newSelectorName_(selector),params))\r\n\taReceiver=_s8_value\r\n\treturn _s8_value\r\nend)();return (__repeat)\r\nend))() do  end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (aReceiver)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"bodyScope:",0
,function(self,statements)
local result=nil
if not (((self):match_((self):verticalBar())))==true then return ((self):scope()); end;
(function()
	local _s8_value=((smalltalk.ParseContext):in_((self):scope()))
	result=_s8_value
	return _s8_value
end)();
(statements):temporaries_((self):parseTemporaries_(result));
return (result);
end
,"parsing","bodyScope: statements\r\n\t\" Private - Returns a context for body of script.\r\n\t<rule> script = [ | temporaries ] statements.\r\n\t\"\r\n\r\n\t| result |\r\n\t(self match: self verticalBar) ifFalse: [ ^self scope ].\r\n\tresult := ParseContext in: self scope.\r\n\tstatements temporaries: (self parseTemporaries: result).\r\n\t^result ","function(self,statements)\r\nlocal result=nil\r\nif not (((self):match_((self):verticalBar())))==true then return ((self):scope()); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.ParseContext):in_((self):scope()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(statements):temporaries_((self):parseTemporaries_(result));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"mustHaveA:",0
,function(self,aCharacter)
if not ((smalltalk:isObject_equalTo_(((self):peek()),aCharacter)))==true then return ((self):syntaxError_(smalltalk:object_comma_((smalltalk:printString_((aCharacter)))," expected."))); end;
if not (((self):atEnd()))==true then (self):next(); end;
return (self);
end
,"parsing","mustHaveA: aCharacter\r\n\t\" Private - Check that the next character is aCharacter.\r\n\tRead the character if success. Generates a syntax error in absent. \"\r\n\r\n\tself peek = aCharacter ifFalse: [\r\n\t\t^self syntaxError: aCharacter printString,' expected.'\r\n\t].\r\n\tself atEnd ifFalse: [ self next ]","function(self,aCharacter)\r\nif not ((smalltalk:isObject_equalTo_(((self):peek()),aCharacter)))==true then return ((self):syntaxError_(smalltalk:object_comma_((smalltalk:printString_((aCharacter))),\" expected.\"))); end;\r\nif not (((self):atEnd()))==true then (self):next(); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"newSelectorName:",0
,function(self,aSelectorName)
return ((aSelectorName):asSymbol());
end
,"parsing","newSelectorName: aSelectorName\r\n\t\" Private - Build a new message name from aSelectorName. \"\r\n\r\n\t^aSelectorName asSymbol ","function(self,aSelectorName)\r\nreturn ((aSelectorName):asSymbol());\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"next",0
,function(self)
(self):skipSeparators();
return ((self["@source"]):next());
end
,"parsing","next\r\n\t\"Advance to the next character onto source stream. \"\r\n\r\n\tself skipSeparators.\r\n\t^source next","function(self)\r\n(self):skipSeparators();\r\nreturn ((self[\"@source\"]):next());\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextArgument:",0
,function(self,aContext)
local start=nil
local word=nil
local assoc=nil
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):nextWord())
	word=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((word)))==true then return (nil); end;
(aContext):at_put_(word,nil);
(function()
	local _s8_value=((aContext):bindingAt_(word))
	assoc=_s8_value
	return _s8_value
end)();
return ((
function(_s8_rec)
	(_s8_rec):binding_(assoc);
	return ((_s8_rec):yourself())
end
)((smalltalk.ParseArgument):from_to_(start,(self):position())));
end
,"parsing","nextArgument: aContext\r\n\t\" Private - Parse the receiver looking for a new argument using variables in aContext.\r\n\tReturns nil if failed. \"\r\n\r\n\t| start word assoc |\r\n\tstart := self startOfNextToken.\r\n\tword := self nextWord.\r\n\tword isNil ifTrue: [ ^nil ].\r\n\taContext at: word put: nil.\r\n\tassoc := aContext bindingAt: word.\r\n\t^(ParseArgument\r\n\t\tfrom: start to: self position)\r\n\t\tbinding: assoc;\r\n\t\tyourself","function(self,aContext)\r\nlocal start=nil\r\nlocal word=nil\r\nlocal assoc=nil\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):nextWord())\r\n\tword=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((word)))==true then return (nil); end;\r\n(aContext):at_put_(word,nil);\r\n(function()\r\n\tlocal _s8_value=((aContext):bindingAt_(word))\r\n\tassoc=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):binding_(assoc);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.ParseArgument):from_to_(start,(self):position())));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextArray:",0
,function(self,aContext)
local stream=nil
(function()
	local _s8_value=(((smalltalk.Array):new()):writeStream())
	stream=_s8_value
	return _s8_value
end)();
while not ((function()
return ((self):match_((self):rightParenthesis()))
end))() do (stream):nextPut_((self):arrayLiteralElement_(aContext)); end;
return ((stream):contents());
end
,"parsing","nextArray: aContext\r\n\t\" Private - Parse the receiver looking for an Array using variables in aContext.\r\n\tReturns anArray or generates an error if failed.\r\n\t<rule> array = '(' {number | string | symbol | array | characterConstant} ')'.\r\n\t\"\r\n\r\n\t| stream |\r\n\tstream := Array new writeStream.\r\n\t[ self match: self rightParenthesis ] whileFalse: [\r\n\t\tstream nextPut: (self arrayLiteralElement: aContext)\r\n\t].\r\n\t^stream contents","function(self,aContext)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.Array):new()):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((self):match_((self):rightParenthesis()))\r\nend))() do (stream):nextPut_((self):arrayLiteralElement_(aContext)); end;\r\nreturn ((stream):contents());\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextArrayConstant:",0
,function(self,aContext)
local start=nil
local value=nil
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();
if not (((self):match_((smalltalk.Array):with_with_((self):literalQuote(),(self):leftParenthesis()))))==true then return (nil); end;
(function()
	local _s8_value=((self):nextArray_(aContext))
	value=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((value)))==true then (self):position_(start);
return (nil); end;
return ((smalltalk.ParseLiteral):from_to_copy_(start,(self):position(),value));
end
,"parsing","nextArrayConstant: aContext\r\n\t\" Private - Parse the receiver looking for an Array using variables in aContext.\r\n\tReturns nil if failed.\r\n\t<rule> arrayConstant = '#' array.\r\n\t<rule> array = '(' {number | string | symbol | array | characterConstant} ')'.\r\n\t\"\r\n\r\n\t| start value |\r\n\tstart := self startOfNextToken.\r\n\t(self match: (Array with: self literalQuote with: self leftParenthesis)) ifFalse: [ ^nil ].\r\n\tvalue := self nextArray: aContext.\r\n\tvalue isNil ifTrue: [ self position: start. ^nil ].\r\n\t^ParseLiteral\r\n\t\tfrom: start to: self position\r\n\t\tcopy: value ","function(self,aContext)\r\nlocal start=nil\r\nlocal value=nil\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((self):match_((smalltalk.Array):with_with_((self):literalQuote(),(self):leftParenthesis()))))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((self):nextArray_(aContext))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((value)))==true then (self):position_(start);\r\nreturn (nil); end;\r\nreturn ((smalltalk.ParseLiteral):from_to_copy_(start,(self):position(),value));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextBlock:",0
,function(self,aContext)
local start=nil
local args=nil
local block=nil
local peek=nil
(function()
	local _s8_value=(((self):position()):_minus(1))
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:newArray({}))
	args=_s8_value
	return _s8_value
end)();
while ((function()
return ((self):match_((self):colon()))
end))() do local arg=nil
(function()
	local _s8_value=((self):nextArgument_(aContext))
	arg=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((arg)))==true then return ((self):expected_("argument")); end;
(args):add_(arg); end;
if ((((args):size()) > 0))==true then (function()
	local _s8_value=((self):peek())
	peek=_s8_value
	return _s8_value
end)();
if not ((smalltalk:boolean_or_((smalltalk:isObject_equalTo_((peek),(self):rightBracket())),(function()
return (smalltalk:isObject_equalTo_((peek),(self):verticalBar()))
end))))==true then return ((self):expected_((self):verticalBar())); end;
smalltalk:if_true_false_((smalltalk:isObject_equalTo_((peek),(self):verticalBar())),(function()
return ((self):skip_((self):verticalBar()))
end),nil); end;
(function()
	local _s8_value=((self):statementsArgs_in_(args,aContext))
	block=_s8_value
	return _s8_value
end)();
if not (((self):match_((self):rightBracket())))==true then return ((self):expected_("Period or right bracket")); end;
(block):sourcePosition_((start):to_((self):position()));
return (block);
end
,"parsing","nextBlock: aContext\r\n\t\" Private - Parse the receiver looking for a block using variables in aContext.\r\n\tReturns nil if failed.\r\n\t<node> $[ ($: arg)* temporaries statements $] => BlockClosureNode\r\n\t\"\r\n\r\n\t| start args block peek |\r\n\tstart := self position - 1.\r\n\targs := #().\r\n\t[ self match: self colon ] whileTrue: [ | arg |\r\n\t\targ := self nextArgument: aContext.\r\n\t\targ isNil ifTrue: [ ^self expected: #argument ].\r\n\t\targs add: arg.\r\n\t].\r\n\targs size > 0 ifTrue: [\r\n\t\tpeek := self peek.\r\n\t\t(peek = self rightBracket or: [ peek = self verticalBar ])\r\n\t\tifFalse: [ ^self expected: self verticalBar ].\r\n\t\tpeek = self verticalBar ifTrue: [ self skip: self verticalBar ].\r\n\t].\r\n\tblock := self statementsArgs: args in: aContext.\r\n\t(self match: self rightBracket) ifFalse: [\r\n\t\t^self expected: 'Period or right bracket'\r\n\t].\r\n\tblock sourcePosition: (start to: self position).\r\n\t^block","function(self,aContext)\r\nlocal start=nil\r\nlocal args=nil\r\nlocal block=nil\r\nlocal peek=nil\r\n(function()\r\n\tlocal _s8_value=(((self):position()):_minus(1))\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn ((self):match_((self):colon()))\r\nend))() do local arg=nil\r\n(function()\r\n\tlocal _s8_value=((self):nextArgument_(aContext))\r\n\targ=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((arg)))==true then return ((self):expected_(\"argument\")); end;\r\n(args):add_(arg); end;\r\nif ((((args):size()) > 0))==true then (function()\r\n\tlocal _s8_value=((self):peek())\r\n\tpeek=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:boolean_or_((smalltalk:isObject_equalTo_((peek),(self):rightBracket())),(function()\r\nreturn (smalltalk:isObject_equalTo_((peek),(self):verticalBar()))\r\nend))))==true then return ((self):expected_((self):verticalBar())); end;\r\nsmalltalk:if_true_false_((smalltalk:isObject_equalTo_((peek),(self):verticalBar())),(function()\r\nreturn ((self):skip_((self):verticalBar()))\r\nend),nil); end;\r\n(function()\r\n\tlocal _s8_value=((self):statementsArgs_in_(args,aContext))\r\n\tblock=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((self):match_((self):rightBracket())))==true then return ((self):expected_(\"Period or right bracket\")); end;\r\n(block):sourcePosition_((start):to_((self):position()));\r\nreturn (block);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextPrimitive:",0
,function(self,aContext)
local start=nil
local result=nil
(function()
	local _s8_value=(((self):position()):_minus(1))
	start=_s8_value
	return _s8_value
end)();
(self):skipSeparators();
(function()
	local _s8_value=(((self)["$klass"]):parsePrimitive_in_(self,aContext))
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((result)))==true then return (nil); end;
if not (((self):match_((self):primitiveEnd())))==true then return ((self):expected_("End of primitive")); end;
(result):sourcePosition_((start):to_((self):position()));
return (result);
end
,"parsing","nextPrimitive: aContext\r\n\t\" Private - Parse the receiver looking for primitive in aContext.\r\n\tReturns nil if failed.\r\n\t<node> $< ...prim... $> => PrimitiveNode\r\n\t\"\r\n\r\n\t| start result |\r\n\tstart := self position - 1.\r\n\tself skipSeparators.\r\n\tresult := self class parsePrimitive: self in: aContext.\r\n\tresult isNil ifTrue: [ ^nil ].\r\n\t(self match: self primitiveEnd) ifFalse: [\r\n\t\t^self expected: 'End of primitive'\r\n\t].\r\n\tresult sourcePosition: (start to: self position).\r\n\t^result","function(self,aContext)\r\nlocal start=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):position()):_minus(1))\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):skipSeparators();\r\n(function()\r\n\tlocal _s8_value=(((self)[\"$klass\"]):parsePrimitive_in_(self,aContext))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((result)))==true then return (nil); end;\r\nif not (((self):match_((self):primitiveEnd())))==true then return ((self):expected_(\"End of primitive\")); end;\r\n(result):sourcePosition_((start):to_((self):position()));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextBraceLiteral:",0
,function(self,aContext)
return ((self):notImplementedYet_("nextBraceLiteral:"));
end
,"parsing","nextBraceLiteral: aContext\r\n\t\" Private - Parse the receiver looking for a brace literal in aContext.\r\n\tReturns the literal or generates an error if failed.\r\n\t\"\r\n\r\n\t^self notImplementedYet: #nextBraceLiteral: ","function(self,aContext)\r\nreturn ((self):notImplementedYet_(\"nextBraceLiteral:\"));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextInline:",0
,function(self,aContext)
local start=nil
local lang=nil
local code=nil
local codeStart=nil
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):nextSelectorOrNil())
	lang=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):startOfNextToken())
	codeStart=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):nextStringConstant_(aContext))
	code=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((code))),(function()
return ((smalltalk.Array):with_with_with_(lang,codeStart,((code):binding()):source()))
end),nil));
end
,"inlines","nextInline: aContext\r\n\t\" Private - Returns the next inline in the receiver's stream (or nil). \"\r\n\r\n\t| start lang code codeStart |\r\n\tstart := self startOfNextToken.\r\n\tlang := self nextSelectorOrNil.\r\n\tcodeStart := self startOfNextToken.\r\n\tcode := self nextStringConstant: aContext.\r\n\t^code notNil ifTrue: [\r\n\t\tArray\twith: lang with: codeStart\r\n\t\t\twith: code binding source\r\n\t] ","function(self,aContext)\r\nlocal start=nil\r\nlocal lang=nil\r\nlocal code=nil\r\nlocal codeStart=nil\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):nextSelectorOrNil())\r\n\tlang=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tcodeStart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):nextStringConstant_(aContext))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((code))),(function()\r\nreturn ((smalltalk.Array):with_with_with_(lang,codeStart,((code):binding()):source()))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"inlineStatements:in:",0
,function(self,pool,aContext)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local inline=nil
(function()
	local _s8_value=((pool):at_ifAbsent_("s8",(function()
return ((pool):at_ifAbsent_(smalltalk:object_comma_((smalltalk:object_comma_(("s8"),"_")),(self):nativeLanguage()),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end)))
end)))
	inline=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):inlineStatements_startingAt_in_((inline):last(),((inline):first()):_plus(1),aContext))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"inlines","inlineStatements: pool in: aContext\r\n\t\" Private - Returns a statements sequence parsed from pool (or nil). \"\r\n\r\n\t| inline |\r\n\tinline := pool at: #s8 ifAbsent: [\r\n\t\tpool at: #s8 ,$_ ,self nativeLanguage ifAbsent: [ ^nil ]\r\n\t].\r\n\t^self\tinlineStatements: inline last\r\n\t\tstartingAt: inline first + 1\r\n\t\tin: aContext","function(self,pool,aContext)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal inline=nil\r\n(function()\r\n\tlocal _s8_value=((pool):at_ifAbsent_(\"s8\",(function()\r\nreturn ((pool):at_ifAbsent_(smalltalk:object_comma_((smalltalk:object_comma_((\"s8\"),\"_\")),(self):nativeLanguage()),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend)))\r\n\tinline=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):inlineStatements_startingAt_in_((inline):last(),((inline):first()):_plus(1),aContext))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"inlineStatements:startingAt:in:",0
,function(self,code,start,aContext)
local src=nil
local result=nil
(function()
	local _s8_value=(self["@source"])
	src=_s8_value
	return _s8_value
end)();
((function()
(function()
	local _s8_value=((smalltalk:object_comma_((smalltalk:object_comma_((((self["@source"]):contents()):copyFrom_to_(1,start)),code)),"]")):readStream())
	self["@source"]=_s8_value
	return _s8_value
end)();(self["@source"]):position_(start);return ((function()
	local _s8_value=(((smalltalk.MessageNode):from_to_(start,(self):position())):receiver_selector_arguments_((self):statementsArgs_in_(smalltalk:newArray({}),aContext),"value",smalltalk:newArray({})))
	result=_s8_value
	return _s8_value
end)())
end)):ensure_((function()
return ((function()
	local _s8_value=(src)
	self["@source"]=_s8_value
	return _s8_value
end)())
end));
return (result);
end
,"inlines","inlineStatements: code startingAt: start in: aContext\r\n\t\" Private - Returns a statements sequence parsed on code (or nil). \"\r\n\r\n\t| src result |\r\n\tsrc := source.\r\n\t[\tsource := ((source contents copyFrom: 1 to: start), code ,$]) readStream.\r\n\t\tsource position: start.\r\n\t\tresult := (MessageNode from: start to: self position)\r\n\t\t\treceiver: (self statementsArgs: #() in: aContext)\r\n\t\t\tselector: #value arguments: #()\r\n\t] ensure: [ source := src ].\r\n\t^result","function(self,code,start,aContext)\r\nlocal src=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(self[\"@source\"])\r\n\tsrc=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((function()\r\n(function()\r\n\tlocal _s8_value=((smalltalk:object_comma_((smalltalk:object_comma_((((self[\"@source\"]):contents()):copyFrom_to_(1,start)),code)),\"]\")):readStream())\r\n\tself[\"@source\"]=_s8_value\r\n\treturn _s8_value\r\nend)();(self[\"@source\"]):position_(start);return ((function()\r\n\tlocal _s8_value=(((smalltalk.MessageNode):from_to_(start,(self):position())):receiver_selector_arguments_((self):statementsArgs_in_(smalltalk:newArray({}),aContext),\"value\",smalltalk:newArray({})))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):ensure_((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(src)\r\n\tself[\"@source\"]=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextBraceExpression:",0
,function(self,aContext)
local start=nil
local pool=nil
local block=nil
(function()
	local _s8_value=((self):position())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	pool=_s8_value
	return _s8_value
end)();
while not ((function()
return ((self):match_((self):rightBrace()))
end))() do local inline=nil
(function()
	local _s8_value=((self):nextInline_(aContext))
	inline=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:notNil_((inline))),(function()
return ((pool):at_put_((inline):removeFirst(),inline))
end),nil); end;
if ((pool):isEmpty())==true then (self):position_(start);
return ((self):expected_("Inline code")); end;
(function()
	local _s8_value=((self):inlineStatements_in_(pool,aContext))
	block=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((block)))==true then (self):position_(start);
return ((self):expected_("Code for s8 language")); end;
(block):sourcePosition_(((start):_minus(1)):to_((self):position()));
return (block);
end
,"parsing","nextBraceExpression: aContext\r\n\t\" Private - Parse the receiver looking for a brace expression in aContext.\r\n\tReturns nil if failed.\r\n\t<node> ${ ({lang} string)* $} => statements\r\n\t\"\r\n\r\n\t| start pool block |\r\n\tstart := self position.\r\n\tpool := PoolDictionary new.\r\n\t[ self match: self rightBrace ] whileFalse: [ | inline |\r\n\t\tinline := self nextInline: aContext.\r\n\t\tinline notNil ifTrue: [\r\n\t\t\tpool at: inline removeFirst put: inline\r\n\t\t].\r\n\t].\r\n\tpool isEmpty ifTrue: [\r\n\t\tself position: start.\r\n\t\t^self expected: 'Inline code'\r\n\t].\r\n\tblock := self inlineStatements: pool in: aContext.\r\n\tblock isNil ifTrue: [\r\n\t\tself position: start.\r\n\t\t^self expected: 'Code for s8 language'\r\n\t].\r\n\tblock sourcePosition: (start - 1 to: self position).\r\n\t^block","function(self,aContext)\r\nlocal start=nil\r\nlocal pool=nil\r\nlocal block=nil\r\n(function()\r\n\tlocal _s8_value=((self):position())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tpool=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((self):match_((self):rightBrace()))\r\nend))() do local inline=nil\r\n(function()\r\n\tlocal _s8_value=((self):nextInline_(aContext))\r\n\tinline=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:notNil_((inline))),(function()\r\nreturn ((pool):at_put_((inline):removeFirst(),inline))\r\nend),nil); end;\r\nif ((pool):isEmpty())==true then (self):position_(start);\r\nreturn ((self):expected_(\"Inline code\")); end;\r\n(function()\r\n\tlocal _s8_value=((self):inlineStatements_in_(pool,aContext))\r\n\tblock=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((block)))==true then (self):position_(start);\r\nreturn ((self):expected_(\"Code for s8 language\")); end;\r\n(block):sourcePosition_(((start):_minus(1)):to_((self):position()));\r\nreturn (block);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextByteArray:",0
,function(self,aContext)
return ((self):notImplementedYet_("nextByteArray:"));
end
,"parsing","nextByteArray: aContext\r\n\t\" Private - Parse the receiver looking for aByteArray using variables in aContext.\r\n\tReturns aByteArray or generates an error if failed.\r\n\t\"\r\n\r\n\t^self notImplementedYet: #nextByteArray: ","function(self,aContext)\r\nreturn ((self):notImplementedYet_(\"nextByteArray:\"));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextCharacter",0
,function(self)
return (smalltalk:if_true_false_(((self["@source"]):atEnd()),(function()
return (" ")
end),(function()
return ((self["@source"]):next())
end)));
end
,"parsing","nextCharacter\r\n\t\" Private - Read aCharacter from the receiver. \"\r\n\r\n\t^source atEnd ifTrue: [ $  ] ifFalse: [ source next ]","function(self)\r\nreturn (smalltalk:if_true_false_(((self[\"@source\"]):atEnd()),(function()\r\nreturn (\" \")\r\nend),(function()\r\nreturn ((self[\"@source\"]):next())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextCharacterConstant:",0
,function(self,aContext)
local start=nil
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();
if not (((self):match_((self):dollar())))==true then return (nil); end;
return ((smalltalk.ParseLiteral):from_to_value_(start,(self):position(),(self):nextCharacter()));
end
,"parsing","nextCharacterConstant: aContext\r\n\t\" Private - Parse the receiver looking for aCharacter using variables in aContext.\r\n\tReturns nil if failed. \"\r\n\r\n\t| start |\r\n\tstart := self startOfNextToken.\r\n\t(self match: self dollar) ifFalse: [ ^nil ].\r\n\t^ParseLiteral\r\n\t\tfrom: start to: self position\r\n\t\tvalue: self nextCharacter ","function(self,aContext)\r\nlocal start=nil\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((self):match_((self):dollar())))==true then return (nil); end;\r\nreturn ((smalltalk.ParseLiteral):from_to_value_(start,(self):position(),(self):nextCharacter()));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextLiteral:",0
,function(self,aContext)
local node=nil
(function()
	local _s8_value=((self):nextNumberConstant_(aContext))
	node=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((node)))==true then return (node); end;
(function()
	local _s8_value=((self):nextStringConstant_(aContext))
	node=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((node)))==true then return (node); end;
(function()
	local _s8_value=((self):nextCharacterConstant_(aContext))
	node=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((node)))==true then return (node); end;
(function()
	local _s8_value=((self):nextArrayConstant_(aContext))
	node=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((node)))==true then return (node); end;
(function()
	local _s8_value=((self):nextSymbolConstant_(aContext))
	node=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((node)))==true then return (node); end;
return (nil);
end
,"parsing","nextLiteral: aContext\r\n\t\" Private - Parse the receiver looking for a literal using variables in aContext.\r\n\tReturns nil if failed.\r\n\t<rule> literal = number | string | characterConstant | symbolConstant | arrayConstant.\r\n\t\"\r\n\r\n\t| node |\r\n\tnode := self nextNumberConstant: aContext.\r\n\tnode notNil ifTrue: [ ^node ].\r\n\tnode := self nextStringConstant: aContext.\r\n\tnode notNil ifTrue: [ ^node ].\r\n\tnode := self nextCharacterConstant: aContext.\r\n\tnode notNil ifTrue: [ ^node ].\r\n\tnode := self nextArrayConstant: aContext.\r\n\tnode notNil ifTrue: [ ^node ].\r\n\tnode := self nextSymbolConstant: aContext.\r\n\tnode notNil ifTrue: [ ^node ].\r\n\t^nil","function(self,aContext)\r\nlocal node=nil\r\n(function()\r\n\tlocal _s8_value=((self):nextNumberConstant_(aContext))\r\n\tnode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((node)))==true then return (node); end;\r\n(function()\r\n\tlocal _s8_value=((self):nextStringConstant_(aContext))\r\n\tnode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((node)))==true then return (node); end;\r\n(function()\r\n\tlocal _s8_value=((self):nextCharacterConstant_(aContext))\r\n\tnode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((node)))==true then return (node); end;\r\n(function()\r\n\tlocal _s8_value=((self):nextArrayConstant_(aContext))\r\n\tnode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((node)))==true then return (node); end;\r\n(function()\r\n\tlocal _s8_value=((self):nextSymbolConstant_(aContext))\r\n\tnode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((node)))==true then return (node); end;\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextNumber",0
,function(self)
return ((self):readSmalltalkNumberFrom_(self["@source"]));
end
,"parsing","nextNumber\r\n\t\" Private - Parse the receiver looking for a number using variables in aContext.\r\n\tReturns aNumber or generates an error if failed.\r\n\t<rule> number = [digits 'r'] ['-'] bigDigits ['.'bigDigits] ['e' ['-'] digits].\r\n\t<rule> digits = digit {digit}.\r\n\t<rule> Digit = '0' | '1' | '2' | '3' | '4' | '5' | '6' | '7' | '8' | '9'.\r\n\t<rule> bigDigits = bigDigit {bigDigit}.\r\n\t<rule> bigDigit = digit | capitalLetter.\r\n\t\"\r\n\r\n\t^self readSmalltalkNumberFrom: source","function(self)\r\nreturn ((self):readSmalltalkNumberFrom_(self[\"@source\"]));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextNumberConstant:",0
,function(self,aContext)
local start=nil
local value=nil
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_(((self):peekAny_advance_("0123456789-",false))))==true then return (nil); end;
(function()
	local _s8_value=((self):nextNumber())
	value=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((value)))==true then (self):position_(start);
return (nil); end;
return ((smalltalk.ParseLiteral):from_to_value_(start,(self):position(),value));
end
,"parsing","nextNumberConstant: aContext\r\n\t\" Private - Parse the receiver looking for a number using variables in aContext.\r\n\tReturns nil if failed.\r\n\t<rule> number = [digits 'r'] ['-'] bigDigits ['.'bigDigits] ['e' ['-'] digits].\r\n\t<rule> digits = digit {digit}.\r\n\t<rule> Digit = '0' | '1' | '2' | '3' | '4' | '5' | '6' | '7' | '8' | '9'.\r\n\t<rule> bigDigits = bigDigit {bigDigit}.\r\n\t<rule> bigDigit = digit | capitalLetter.\r\n\t\"\r\n\r\n\t| start value |\r\n\tstart := self startOfNextToken.\r\n\t(self peekAny: '0123456789-' advance: false) isNil ifTrue: [ ^nil ].\r\n\tvalue := self nextNumber.\r\n\tvalue isNil ifTrue: [ self position: start. ^nil ].\r\n\t^ParseLiteral\r\n\t\tfrom: start to: self position\r\n\t\tvalue: value ","function(self,aContext)\r\nlocal start=nil\r\nlocal value=nil\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_(((self):peekAny_advance_(\"0123456789-\",false))))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((self):nextNumber())\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((value)))==true then (self):position_(start);\r\nreturn (nil); end;\r\nreturn ((smalltalk.ParseLiteral):from_to_value_(start,(self):position(),value));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextSelector",0
,function(self)
local result=nil
(function()
	local _s8_value=((self):nextSelectorOrNil())
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((result)))==true then return ((self):expected_("selector")); end;
return (result);
end
,"parsing","nextSelector\r\n\t\" Private - Returns the next selector in the receiver.\r\n\tGenerates an error if failed.\r\n\t\t<rule> symbol = unarySelector | binarySelector | keyword {keyword}.\r\n\t\t<rule> unarySelector = identifier.\r\n\t\t<rule> binarySelector = selectorCharacter [selectorCharacter] | '-'.\r\n\t\t<rule> keyword = identifier ':'.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := self nextSelectorOrNil.\r\n\tresult isNil ifTrue: [ ^self expected: #selector ].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):nextSelectorOrNil())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((result)))==true then return ((self):expected_(\"selector\")); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextSelectorOrNil",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local contents=nil
local peek=nil
(function()
	local _s8_value=((self):basicPeek())
	peek=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_or_((smalltalk:isNil_((peek))),(function()
return ((peek):isSeparator())
end)))==true then return (nil); end;
if (smalltalk:boolean_or_((smalltalk:isObject_equalTo_((peek),"-")),(function()
return ((self):isSelectorCharacter_(peek))
end)))==true then return ((self):nextSelectorWith_(peek)); end;
if not (((self):isAlpha_(peek)))==true then return (nil); end;
(function()
	local _s8_value=((smalltalk.String):new())
	contents=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=(smalltalk:object_comma_((contents),(self):nextWord()))
	contents=_s8_value
	return _s8_value
end)();return (smalltalk:isObject_equalTo_(((self):basicPeek()),(self):colon()))
end))() do (function()
	local _s8_value=(smalltalk:object_comma_((contents),(self):colon()))
	contents=_s8_value
	return _s8_value
end)();
(self):skip_((self):colon());
(function()
	local _s8_value=((self):basicPeek())
	peek=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:boolean_or_((smalltalk:isNil_((peek))),(function()
return (smalltalk:booleanNot_(((self):isAlpha_(peek))))
end))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (contents)
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((contents):asSymbol())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","nextSelectorOrNil\r\n\t\" Private - Returns the next selector in the receiver.\r\n\tReturns nil if failed.\r\n\t\t<rule> symbol = unarySelector | binarySelector | keyword {keyword}.\r\n\t\t<rule> unarySelector = identifier.\r\n\t\t<rule> binarySelector = selectorCharacter [selectorCharacter] | '-'.\r\n\t\t<rule> keyword = identifier ':'.\r\n\t\"\r\n\r\n\t| contents peek |\r\n\tpeek := self basicPeek.\r\n\t(peek isNil or: [ peek isSeparator ]) ifTrue: [ ^nil ].\r\n\r\n\t(peek = $- or: [ self isSelectorCharacter: peek ]) \"binarySelector\"\r\n\tifTrue: [ ^self nextSelectorWith: peek ].\r\n\r\n\t(self isAlpha: peek) ifFalse: [ ^nil ].\r\n\tcontents := String new.\r\n\t[\tcontents := contents, self nextWord.\r\n\t\tself basicPeek = self colon ] whileTrue: [\r\n\t\tcontents := contents ,self colon.\r\n\t\tself skip: self colon.\r\n\t\tpeek := self basicPeek.\r\n\t\t(peek isNil or: [ (self isAlpha: peek) not ]) ifTrue: [ ^contents ]\r\n\t].\r\n\t^contents asSymbol","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal contents=nil\r\nlocal peek=nil\r\n(function()\r\n\tlocal _s8_value=((self):basicPeek())\r\n\tpeek=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_or_((smalltalk:isNil_((peek))),(function()\r\nreturn ((peek):isSeparator())\r\nend)))==true then return (nil); end;\r\nif (smalltalk:boolean_or_((smalltalk:isObject_equalTo_((peek),\"-\")),(function()\r\nreturn ((self):isSelectorCharacter_(peek))\r\nend)))==true then return ((self):nextSelectorWith_(peek)); end;\r\nif not (((self):isAlpha_(peek)))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.String):new())\r\n\tcontents=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((contents),(self):nextWord()))\r\n\tcontents=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:isObject_equalTo_(((self):basicPeek()),(self):colon()))\r\nend))() do (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((contents),(self):colon()))\r\n\tcontents=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):skip_((self):colon());\r\n(function()\r\n\tlocal _s8_value=((self):basicPeek())\r\n\tpeek=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:boolean_or_((smalltalk:isNil_((peek))),(function()\r\nreturn (smalltalk:booleanNot_(((self):isAlpha_(peek))))\r\nend))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (contents)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((contents):asSymbol())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextSelectorWith:",0
,function(self,start)
local result=nil
local peek=nil
(function()
	local _s8_value=(start)
	result=_s8_value
	return _s8_value
end)();
while ((function()
(self):next();(function()
	local _s8_value=((self):basicPeek())
	peek=_s8_value
	return _s8_value
end)();return ((self):isSelectorCharacter_(peek))
end))() do (function()
	local _s8_value=(smalltalk:object_comma_((result),smalltalk:asString_((peek))))
	result=_s8_value
	return _s8_value
end)(); end;
return (result);
end
,"parsing","nextSelectorWith: start\r\n\t\" Private - Returns the next selector starting with start character. \"\r\n\r\n\t| result peek |\r\n\tresult := start.\r\n\t[\tself next.\r\n\t\tpeek := self basicPeek.\r\n\t\tself isSelectorCharacter: peek\r\n\t] whileTrue: [\r\n\t\tresult := result , peek asString\r\n\t].\r\n\t^result","function(self,start)\r\nlocal result=nil\r\nlocal peek=nil\r\n(function()\r\n\tlocal _s8_value=(start)\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(self):next();(function()\r\n\tlocal _s8_value=((self):basicPeek())\r\n\tpeek=_s8_value\r\n\treturn _s8_value\r\nend)();return ((self):isSelectorCharacter_(peek))\r\nend))() do (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((result),smalltalk:asString_((peek))))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextString",0
,function(self)
local contents=nil
(function()
	local _s8_value=((smalltalk.String):new())
	contents=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=(smalltalk:object_comma_((contents),(self["@source"]):upTo_((self):singleQuote())))
	contents=_s8_value
	return _s8_value
end)();return (smalltalk:isObject_equalTo_(((self["@source"]):peek()),(self):singleQuote()))
end))() do (function()
	local _s8_value=((contents):copyWith_("'"))
	contents=_s8_value
	return _s8_value
end)();
(self["@source"]):next(); end;
return (contents);
end
,"parsing","nextString\r\n\t\" Private - Returns the next String contents from the receiver. \"\r\n\r\n\t| contents |\r\n\tcontents := String new.\r\n\t[\tcontents := contents , (source upTo: self singleQuote).\r\n\t\tsource peek = self singleQuote\r\n\t] whileTrue: [\r\n\t\tcontents := contents copyWith: $'.\r\n\t\tsource next\r\n\t].\r\n\t^contents","function(self)\r\nlocal contents=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.String):new())\r\n\tcontents=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((contents),(self[\"@source\"]):upTo_((self):singleQuote())))\r\n\tcontents=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:isObject_equalTo_(((self[\"@source\"]):peek()),(self):singleQuote()))\r\nend))() do (function()\r\n\tlocal _s8_value=((contents):copyWith_(\"'\"))\r\n\tcontents=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self[\"@source\"]):next(); end;\r\nreturn (contents);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextStringConstant:",0
,function(self,aContext)
local start=nil
local contents=nil
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();
if not (((self):match_((self):singleQuote())))==true then return (nil); end;
return ((smalltalk.ParseLiteral):from_to_value_(start,(self):position(),(self):nextString()));
end
,"parsing","nextStringConstant: aContext\r\n\t\" Private - Parse the receiver looking for a string using variables in aContext.\r\n\tReturns nil if failed. \"\r\n\r\n\t| start contents |\r\n\tstart := self startOfNextToken.\r\n\t(self match: self singleQuote) ifFalse: [ ^nil ].\r\n\t^ParseLiteral\r\n\t\tfrom: start to: self position\r\n\t\tvalue: self nextString ","function(self,aContext)\r\nlocal start=nil\r\nlocal contents=nil\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((self):match_((self):singleQuote())))==true then return (nil); end;\r\nreturn ((smalltalk.ParseLiteral):from_to_value_(start,(self):position(),(self):nextString()));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextSymbol",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local c=nil
local result=nil
(function()
	local _s8_value=((smalltalk.String):new())
	result=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((self["@source"]):peek())
	c=_s8_value
	return _s8_value
end)();if (smalltalk:isNil_((c)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:if_true_false_(((result):notEmpty()),(function()
return (result)
end),nil))
end
)()
error(_s8Ret_,0)
end)(); end;return (smalltalk:boolean_or_(((c):between_and_("a","z")),(function()
return (smalltalk:boolean_or_(((c):between_and_("A","Z")),(function()
return (smalltalk:boolean_or_(((c):between_and_("0","9")),(function()
return (smalltalk:boolean_or_((((self):binarySelectorChars()):includes_(c)),(function()
return (("_:"):includes_(c))
end)))
end)))
end)))
end)))
end))() do (function()
	local _s8_value=(smalltalk:object_comma_((result),(self["@source"]):next()))
	result=_s8_value
	return _s8_value
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:if_true_false_(((result):notEmpty()),(function()
return (result)
end),nil))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","nextSymbol\r\n\t\" Private - Returns the characters in next Symbol (or nil). \"\r\n\r\n\t| c result |\r\n\tresult := String new.\r\n\t[\tc := source peek.\r\n\t\tc isNil ifTrue: [\r\n\t\t\t^result notEmpty ifTrue: [ result ]\r\n\t\t].\r\n\t\t(c between: $a and: $z)\r\n\t\tor: [ (c between: $A and: $Z)\r\n\t\tor: [ (c between: $0 and: $9)\r\n\t\tor: [ (self binarySelectorChars includes: c)\r\n\t\tor: [ '_:' includes: c ]]]]\r\n\t] whileTrue: [\r\n\t\tresult := result ,source next\r\n\t].\r\n\t^result notEmpty ifTrue: [ result ] ","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal c=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.String):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((self[\"@source\"]):peek())\r\n\tc=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isNil_((c)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:if_true_false_(((result):notEmpty()),(function()\r\nreturn (result)\r\nend),nil))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return (smalltalk:boolean_or_(((c):between_and_(\"a\",\"z\")),(function()\r\nreturn (smalltalk:boolean_or_(((c):between_and_(\"A\",\"Z\")),(function()\r\nreturn (smalltalk:boolean_or_(((c):between_and_(\"0\",\"9\")),(function()\r\nreturn (smalltalk:boolean_or_((((self):binarySelectorChars()):includes_(c)),(function()\r\nreturn ((\"_:\"):includes_(c))\r\nend)))\r\nend)))\r\nend)))\r\nend)))\r\nend))() do (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((result),(self[\"@source\"]):next()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:if_true_false_(((result):notEmpty()),(function()\r\nreturn (result)\r\nend),nil))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextNativeConstant:",0
,function(self,aContext)
local start=nil
local aName=nil
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();
if not (((self):match_((self):leftBrace())))==true then return (nil); end;
(function()
	local _s8_value=((self):nextWord())
	aName=_s8_value
	return _s8_value
end)();
if not (((self):match_((self):rightBrace())))==true then return ((self):expected_((self):rightBrace())); end;
return ((smalltalk.ParseNativeVariable):named_from_to_(aName,start,(self):position()));
end
,"parsing","nextNativeConstant: aContext\r\n\t\" Private - Parse the receiver looking for a name of native constant in aContext.\r\n\tReturns nil if failed.\r\n\t\t<rule> nativeConstant = '{' word '}'\r\n\t\"\r\n\r\n\t| start aName |\r\n\tstart := self startOfNextToken.\r\n\t(self match: self leftBrace) ifFalse: [ ^nil ].\r\n\taName := self nextWord.\r\n\t(self match: self rightBrace) ifFalse: [ ^self expected: self rightBrace ].\r\n\t^ParseNativeVariable named: aName from: start to: self position ","function(self,aContext)\r\nlocal start=nil\r\nlocal aName=nil\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((self):match_((self):leftBrace())))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((self):nextWord())\r\n\taName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((self):match_((self):rightBrace())))==true then return ((self):expected_((self):rightBrace())); end;\r\nreturn ((smalltalk.ParseNativeVariable):named_from_to_(aName,start,(self):position()));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextSymbolConstant:",0
,function(self,aContext)
local start=nil
local value=nil
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();
if not (((self):match_((self):literalQuote())))==true then return (nil); end;
if (smalltalk:isObject_equalTo_(((self["@source"]):peek()),(self):leftBrace()))==true then return ((self):nextNativeConstant_(aContext)); end;
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self["@source"]):peek()),(self):singleQuote())),(function()
(self["@source"]):next();return ((self):nextString())
end),(function()
return ((self):nextSymbol())
end)))
	value=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((value)))==true then return ((smalltalk.ParseNoReceiver):from_to_(start,(self):position())); end;
return ((smalltalk.ParseLiteral):from_to_value_(start,(self):position(),(value):asSymbol()));
end
,"parsing","nextSymbolConstant: aContext\r\n\t\" Private - Parse the receiver looking for aSymbol using variables in aContext.\r\n\tReturns nil if failed.\r\n\t\t<rule> symbolConstant = '#' string | symbolChars | ${ nativeConstant\r\n\t\"\r\n\r\n\t| start value |\r\n\tstart := self startOfNextToken.\r\n\t(self match: self literalQuote) ifFalse: [ ^nil ].\r\n\tsource peek = self leftBrace ifTrue: [ ^self nextNativeConstant: aContext ].\r\n\tvalue := source peek = self singleQuote\r\n\t\tifTrue: [ source next. self nextString ]\r\n\t\tifFalse: [ self nextSymbol ].\r\n\tvalue isNil ifTrue: [\r\n\t\t^ParseNoReceiver\r\n\t\t\tfrom: start to: self position\r\n\t].\r\n\t^ParseLiteral\r\n\t\tfrom: start to: self position\r\n\t\tvalue: value asSymbol ","function(self,aContext)\r\nlocal start=nil\r\nlocal value=nil\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((self):match_((self):literalQuote())))==true then return (nil); end;\r\nif (smalltalk:isObject_equalTo_(((self[\"@source\"]):peek()),(self):leftBrace()))==true then return ((self):nextNativeConstant_(aContext)); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self[\"@source\"]):peek()),(self):singleQuote())),(function()\r\n(self[\"@source\"]):next();return ((self):nextString())\r\nend),(function()\r\nreturn ((self):nextSymbol())\r\nend)))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((value)))==true then return ((smalltalk.ParseNoReceiver):from_to_(start,(self):position())); end;\r\nreturn ((smalltalk.ParseLiteral):from_to_value_(start,(self):position(),(value):asSymbol()));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"classBindingNamed:",0
,function(self,varName)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local aClass=nil
local pool=nil
local binding=nil
(function()
	local _s8_value=(((self):currentClass()):instanceClass())
	aClass=_s8_value
	return _s8_value
end)();
(aClass):withAllSuperclassesDo_((function(cls)
(function()
	local _s8_value=((cls):classVariables())
	pool=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((pool))),(function()
(function()
	local _s8_value=((pool):bindingAt_ifAbsent_(varName,(function()
return (nil)
end)))
	binding=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((binding))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (binding)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end),nil))
end));
(aClass):withAllSuperclassesDo_((function(cls)
return (((cls):poolDictionaryNames()):do_((function(aName)
(function()
	local _s8_value=((smalltalk.Smalltalk):poolDictionary_ifAbsent_(aName,(function()
return (nil)
end)))
	pool=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((pool))),(function()
(function()
	local _s8_value=((pool):bindingAt_ifAbsent_(varName,(function()
return (nil)
end)))
	binding=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((binding))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (binding)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end),nil))
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","classBindingNamed: varName\r\n\t\" Private - Returns a binding known by the currentClass with name varName. \"\r\n\r\n\t| aClass pool binding |\r\n\taClass := self currentClass instanceClass.\r\n\taClass withAllSuperclassesDo: [:cls|\r\n\t\tpool := cls classVariables.\r\n\t\tpool notNil ifTrue: [\r\n\t\t\tbinding := pool bindingAt: varName ifAbsent: [].\r\n\t\t\tbinding notNil ifTrue: [ ^binding ].\r\n\t\t]\r\n\t].\r\n\taClass withAllSuperclassesDo: [:cls|\r\n\t\tcls poolDictionaryNames do: [:aName|\r\n\t\t\tpool := Smalltalk poolDictionary: aName ifAbsent: [].\r\n\t\t\tpool notNil ifTrue: [\r\n\t\t\t\tbinding := pool bindingAt: varName ifAbsent: [].\r\n\t\t\t\tbinding notNil ifTrue: [ ^binding ].\r\n\t\t\t]\r\n\t\t].\r\n\t].\r\n\t^nil","function(self,varName)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal aClass=nil\r\nlocal pool=nil\r\nlocal binding=nil\r\n(function()\r\n\tlocal _s8_value=(((self):currentClass()):instanceClass())\r\n\taClass=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aClass):withAllSuperclassesDo_((function(cls)\r\n(function()\r\n\tlocal _s8_value=((cls):classVariables())\r\n\tpool=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((pool))),(function()\r\n(function()\r\n\tlocal _s8_value=((pool):bindingAt_ifAbsent_(varName,(function()\r\nreturn (nil)\r\nend)))\r\n\tbinding=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((binding))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (binding)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend),nil))\r\nend));\r\n(aClass):withAllSuperclassesDo_((function(cls)\r\nreturn (((cls):poolDictionaryNames()):do_((function(aName)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):poolDictionary_ifAbsent_(aName,(function()\r\nreturn (nil)\r\nend)))\r\n\tpool=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((pool))),(function()\r\n(function()\r\n\tlocal _s8_value=((pool):bindingAt_ifAbsent_(varName,(function()\r\nreturn (nil)\r\nend)))\r\n\tbinding=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((binding))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (binding)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend),nil))\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"collectIndices:in:",0
,function(self,variable,aContext)
local start=nil
local indices=nil
local done=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	indices=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(false)
	done=_s8_value
	return _s8_value
end)();
while ((function()
return (smalltalk:boolean_and_((smalltalk:boolean_or_((smalltalk:isObject_equalTo_(((self["@source"]):peek()),(self):literalQuote())),(function()
return (smalltalk:isObject_equalTo_(((self["@source"]):peek()),(self):leftBracket()))
end))),(function()
return (smalltalk:booleanNot_((done)))
end)))
end))() do local c=nil
local index=nil
(function()
	local _s8_value=((self):position())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self["@source"]):next())
	c=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((c),(self):literalQuote()))==true then (function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self["@source"]):peek()),(self):singleQuote())),(function()
(self["@source"]):next();return ((self):nextString())
end),(function()
return ((self):nextSymbol())
end)))
	index=_s8_value
	return _s8_value
end)(); end;
if (smalltalk:isObject_equalTo_((c),(self):leftBracket()))==true then (function()
	local _s8_value=((self):expression_(aContext))
	index=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:notNil_((index))),(function()
(self):startOfNextToken();return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self["@source"]):peek()),(self):rightBracket())),(function()
return ((self["@source"]):next())
end),(function()
return ((function()
	local _s8_value=(nil)
	index=_s8_value
	return _s8_value
end)())
end)))
end),nil); end;
smalltalk:if_true_false_((smalltalk:isNil_((index))),(function()
(self):position_(start);return ((function()
	local _s8_value=(true)
	done=_s8_value
	return _s8_value
end)())
end),(function()
return ((indices):add_(index))
end)); end;
if ((indices):notEmpty())==true then (variable):indices_(indices); end;
return (self);
end
,"parsing","collectIndices: variable in: aContext\r\n\t\" Private - Collect the indices following variable reference in aContext.\r\n\t<rule> indices = {'#' string | '[' expression ']'}\r\n\t\"\r\n\r\n\t| start indices done |\r\n\tindices := #(). done := false.\r\n\t[\t(source peek = self literalQuote\r\n\t\tor: [ source peek = self leftBracket ])\r\n\t\tand: [ done not ]\r\n\t] whileTrue: [ | c index |\r\n\t\tstart := self position.\r\n\t\tc := source next.\r\n\t\tc = self literalQuote ifTrue: [\r\n\t\t\tindex := source peek = self singleQuote\r\n\t\t\t\tifTrue: [ source next. self nextString ]\r\n\t\t\t\tifFalse: [ self nextSymbol ].\r\n\t\t].\r\n\t\tc = self leftBracket ifTrue: [\r\n\t\t\tindex := self expression: aContext.\r\n\t\t\tindex notNil ifTrue: [\r\n\t\t\t\tself startOfNextToken.\r\n\t\t\t\tsource peek = self rightBracket\r\n\t\t\t\tifTrue: [ source next ]\r\n\t\t\t\tifFalse: [ index := nil ]\r\n\t\t\t]\r\n\t\t].\r\n\t\tindex isNil ifTrue: [\r\n\t\t\tself position: start.\r\n\t\t\tdone := true\r\n\t\t] ifFalse: [ indices add: index ]\r\n\t].\r\n\tindices notEmpty ifTrue: [\r\n\t\tvariable indices: indices\r\n\t]","function(self,variable,aContext)\r\nlocal start=nil\r\nlocal indices=nil\r\nlocal done=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tindices=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(false)\r\n\tdone=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (smalltalk:boolean_and_((smalltalk:boolean_or_((smalltalk:isObject_equalTo_(((self[\"@source\"]):peek()),(self):literalQuote())),(function()\r\nreturn (smalltalk:isObject_equalTo_(((self[\"@source\"]):peek()),(self):leftBracket()))\r\nend))),(function()\r\nreturn (smalltalk:booleanNot_((done)))\r\nend)))\r\nend))() do local c=nil\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):position())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self[\"@source\"]):next())\r\n\tc=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((c),(self):literalQuote()))==true then (function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self[\"@source\"]):peek()),(self):singleQuote())),(function()\r\n(self[\"@source\"]):next();return ((self):nextString())\r\nend),(function()\r\nreturn ((self):nextSymbol())\r\nend)))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif (smalltalk:isObject_equalTo_((c),(self):leftBracket()))==true then (function()\r\n\tlocal _s8_value=((self):expression_(aContext))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:notNil_((index))),(function()\r\n(self):startOfNextToken();return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self[\"@source\"]):peek()),(self):rightBracket())),(function()\r\nreturn ((self[\"@source\"]):next())\r\nend),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(nil)\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)))\r\nend),nil); end;\r\nsmalltalk:if_true_false_((smalltalk:isNil_((index))),(function()\r\n(self):position_(start);return ((function()\r\n\tlocal _s8_value=(true)\r\n\tdone=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),(function()\r\nreturn ((indices):add_(index))\r\nend)); end;\r\nif ((indices):notEmpty())==true then (variable):indices_(indices); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextVariable:",0
,function(self,aContext)
local word=nil
local assoc=nil
local start=nil
local variable=nil
local found=nil
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):nextWord())
	word=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((word)))==true then return (nil); end;
(function()
	local _s8_value=((function()
(self):collectIndices_in_(variable,aContext);return ((variable):sourceRange_((start):to_((self):position())))
end))
	found=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):specialVariableNamed_(word))
	variable=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((variable)))==true then return ((found):value()); end;
(function()
	local _s8_value=((self):classBindingNamed_(word))
	assoc=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((assoc)))==true then (function()
	local _s8_value=((aContext):bindingAt_ifAbsent_(word,(function()
return (nil)
end)))
	assoc=_s8_value
	return _s8_value
end)(); end;
if (smalltalk:boolean_and_((smalltalk:isNil_((assoc))),(function()
return (((word):first()):isUppercase())
end)))==true then (function()
	local _s8_value=((smalltalk.S8Binding):key_in_(word,smalltalk.Smalltalk))
	assoc=_s8_value
	return _s8_value
end)(); end;
if (smalltalk:isNil_((assoc)))==true then (self):position_(start);
return (nil); end;
(function()
	local _s8_value=((smalltalk.ParseGlobalVariable):boundTo_(assoc))
	variable=_s8_value
	return _s8_value
end)();
return ((found):value());
end
,"parsing","nextVariable: aContext\r\n\t\" Private - Parse the receiver looking for a variable name.\r\n\tReturns the variable binding or nil if failed. \"\r\n\r\n\t| word assoc start variable found |\r\n\tstart := self startOfNextToken.\r\n\tword := self nextWord.\r\n\tword isNil ifTrue: [ ^nil ].\r\n\tfound := [\r\n\t\tself collectIndices: variable in: aContext.\r\n\t\tvariable sourceRange: (start to: self position)\r\n\t].\r\n\r\n\tvariable := self specialVariableNamed: word.\r\n\tvariable notNil ifTrue: [ ^found value ].\r\n\tassoc := self classBindingNamed: word.\r\n\tassoc isNil ifTrue: [\r\n\t\tassoc := aContext bindingAt: word ifAbsent: [].\r\n\t].\r\n\t(assoc isNil and: [ word first isUppercase ]) ifTrue: [\r\n\t\tassoc := S8Binding key: word in: Smalltalk.\r\n\t].\r\n\tassoc isNil ifTrue: [\r\n\t\tself position: start.\r\n\t\t^nil\r\n\t].\r\n\tvariable := ParseGlobalVariable boundTo: assoc.\r\n\t^found value","function(self,aContext)\r\nlocal word=nil\r\nlocal assoc=nil\r\nlocal start=nil\r\nlocal variable=nil\r\nlocal found=nil\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):nextWord())\r\n\tword=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((word)))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((function()\r\n(self):collectIndices_in_(variable,aContext);return ((variable):sourceRange_((start):to_((self):position())))\r\nend))\r\n\tfound=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):specialVariableNamed_(word))\r\n\tvariable=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((variable)))==true then return ((found):value()); end;\r\n(function()\r\n\tlocal _s8_value=((self):classBindingNamed_(word))\r\n\tassoc=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((assoc)))==true then (function()\r\n\tlocal _s8_value=((aContext):bindingAt_ifAbsent_(word,(function()\r\nreturn (nil)\r\nend)))\r\n\tassoc=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif (smalltalk:boolean_and_((smalltalk:isNil_((assoc))),(function()\r\nreturn (((word):first()):isUppercase())\r\nend)))==true then (function()\r\n\tlocal _s8_value=((smalltalk.S8Binding):key_in_(word,smalltalk.Smalltalk))\r\n\tassoc=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif (smalltalk:isNil_((assoc)))==true then (self):position_(start);\r\nreturn (nil); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.ParseGlobalVariable):boundTo_(assoc))\r\n\tvariable=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((found):value());\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextWord",0
,function(self)
local start=nil
local word=nil
if ((self):atEnd())==true then return (nil); end;
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();
if not (((self):isAlpha_((self):peek())))==true then return (nil); end;
(function()
	local _s8_value=((self):next())
	word=_s8_value
	return _s8_value
end)();
while ((function()
return (smalltalk:boolean_and_((smalltalk:booleanNot_(((self["@source"]):atEnd()))),(function()
return ((self):isAlpha_((self["@source"]):peek()))
end)))
end))() do (function()
	local _s8_value=(smalltalk:object_comma_((word),(self["@source"]):next()))
	word=_s8_value
	return _s8_value
end)(); end;
return (word);
end
,"parsing","nextWord\r\n\t\" Returns the next word in the receiver or nil if failed.\r\n\t Advance the receiver. \"\r\n\r\n\t| start word |\r\n\tself atEnd ifTrue: [ ^nil ].\r\n\tstart := self startOfNextToken.\r\n\t(self isAlpha: self peek) ifFalse: [ ^nil ].\r\n\r\n\tword := self next.\r\n\t[\tsource atEnd not\r\n\t\tand: [ self isAlpha: source peek ]\r\n\t] whileTrue: [ word := word , source next ].\r\n\r\n\t^word","function(self)\r\nlocal start=nil\r\nlocal word=nil\r\nif ((self):atEnd())==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((self):isAlpha_((self):peek())))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((self):next())\r\n\tword=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (smalltalk:boolean_and_((smalltalk:booleanNot_(((self[\"@source\"]):atEnd()))),(function()\r\nreturn ((self):isAlpha_((self[\"@source\"]):peek()))\r\nend)))\r\nend))() do (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((word),(self[\"@source\"]):next()))\r\n\tword=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (word);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"notImplementedYet:",0
,function(self,aString)
return ((self):syntaxError_(smalltalk:object_comma_((aString)," not implemented. Yet")));
end
,"error","notImplementedYet: aString\r\n\t\" Returns a syntax error because the functionality is not implemented yet. \"\r\n\r\n\t^self syntaxError: aString ,' not implemented. Yet' ","function(self,aString)\r\nreturn ((self):syntaxError_(smalltalk:object_comma_((aString),\" not implemented. Yet\")));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"parse:doing:onError:",0
,function(self,code,action,aBlock)
local result=nil
(function()
	local _s8_value=(aBlock)
	self["@errorBlock"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_(((code):isString()),(function()
return ((code):stream())
end),(function()
return (code)
end)))
	self["@source"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((action):evaluate())
	result=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((function()
	local _s8_value=(nil)
	self["@source"]=_s8_value
	return _s8_value
end)())
	self["@errorBlock"]=_s8_value
	return _s8_value
end)();
return (result);
end
,"parsing","parse: code doing: action onError: aBlock\r\n\t\" Private - Parse code with action and returns the root node of the parsing. \"\r\n\r\n\t| result |\r\n\terrorBlock := aBlock.\r\n\tsource := code isString\r\n\t\tifTrue: [ code stream ]\r\n\t\tifFalse: [ code ].\r\n\tresult := action evaluate.\r\n\terrorBlock := source := nil.\r\n\t^result","function(self,code,action,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(aBlock)\r\n\tself[\"@errorBlock\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((code):isString()),(function()\r\nreturn ((code):stream())\r\nend),(function()\r\nreturn (code)\r\nend)))\r\n\tself[\"@source\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((action):evaluate())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@source\"]=_s8_value\r\n\treturn _s8_value\r\nend)())\r\n\tself[\"@errorBlock\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"parse:onError:",0
,function(self,aStringOrStream,aBlock)
return ((self):parse_doing_onError_(aStringOrStream,(function()
local statements=nil
(function()
	local _s8_value=((smalltalk.ParseStatements):new())
	statements=_s8_value
	return _s8_value
end)();(self):parseStatements_in_innerBlock_(statements,(self):bodyScope_(statements),false);return ((smalltalk.Script):with_(statements))
end),aBlock));
end
,"scripting","parse: aStringOrStream onError: aBlock\r\n\t\" Parse S8 code (aStringOrStream) and returns the root node of the parsing.\r\n\tIf occurs an error aBlock will be valued with the cause as an argument.\r\n\tExample:\r\n\t\tScriptParser new parse: 'Smalltalk keys' onError: [:error| ^error printString ].\r\n\t\"\r\n\r\n\t^self\tparse: aStringOrStream doing: [ | statements |\r\n\t\t\tstatements := ParseStatements new.\r\n\t\t\tself\tparseStatements: statements\r\n\t\t\t\tin: (self bodyScope: statements)\r\n\t\t\t\tinnerBlock: false.\r\n\t\t\tScript with: statements\r\n\t\t] onError: aBlock","function(self,aStringOrStream,aBlock)\r\nreturn ((self):parse_doing_onError_(aStringOrStream,(function()\r\nlocal statements=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.ParseStatements):new())\r\n\tstatements=_s8_value\r\n\treturn _s8_value\r\nend)();(self):parseStatements_in_innerBlock_(statements,(self):bodyScope_(statements),false);return ((smalltalk.Script):with_(statements))\r\nend),aBlock));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"parse:",0
,function(self,aStringOrStream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
(function()
	local _s8_value=((self):parse_onError_(aStringOrStream,(function(error)
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (error)
end
)()
error(_s8Ret_,0)
end)())
end)))
	result=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"scripting","parse: aStringOrStream\r\n\t\" Parse S8 code (aStringOrStream) and returns the root node of the parsing (or an error). \"\r\n\r\n\t| result |\r\n\tresult := self parse: aStringOrStream onError: [:error| ^error ].\r\n\t^result ","function(self,aStringOrStream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):parse_onError_(aStringOrStream,(function(error)\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (error)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"peek",0
,function(self)
(self):skipSeparators();
return ((self):basicPeek());
end
,"parsing","peek\r\n\t\" Peek the next character from source stream. \"\r\n\r\n\tself skipSeparators.\r\n\t^self basicPeek","function(self)\r\n(self):skipSeparators();\r\nreturn ((self):basicPeek());\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"peekAny:",0
,function(self,aCollection)
return ((self):peekAny_advance_(aCollection,true));
end
,"parsing","peekAny: aCollection\r\n\t\" Try to match the next token of the receiver to any of the elements in aCollection.\r\n\tReturns the first element in aCollection that matches or nil if none. \"\r\n\r\n\t^self peekAny: aCollection advance: true","function(self,aCollection)\r\nreturn ((self):peekAny_advance_(aCollection,true));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"peekAny:advance:",0
,function(self,aCollection,advance)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local start=nil
(function()
	local _s8_value=((self):position())
	start=_s8_value
	return _s8_value
end)();
(aCollection):do_((function(each)
return (smalltalk:if_true_false_(((self):match_(each)),(function()
if not ((advance))==true then (self):position_(start); end;return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (each)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","peekAny: aCollection advance: advance\r\n\t\" Try to match the next token of the receiver to any of the elements in aCollection.\r\n\tReturns the first element in aCollection that matches or nil if none. \"\r\n\r\n\t| start |\r\n\tstart := self position.\r\n\taCollection do: [:each|\r\n\t\t(self match: each) ifTrue: [\r\n\t\t\tadvance ifFalse: [ self position: start ].\r\n\t\t\t^each\r\n\t\t].\r\n\t].\r\n\t^nil","function(self,aCollection,advance)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal start=nil\r\n(function()\r\n\tlocal _s8_value=((self):position())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aCollection):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((self):match_(each)),(function()\r\nif not ((advance))==true then (self):position_(start); end;return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (each)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"primaryExpression:",0
,function(self,aContext)
local node=nil
(function()
	local _s8_value=((self):nextLiteral_(aContext))
	node=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((node)))==true then return (node); end;
(function()
	local _s8_value=((self):nextVariable_(aContext))
	node=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((node)))==true then return (node); end;
if ((self):match_((self):leftBrace()))==true then return ((self):nextBraceExpression_(aContext)); end;
if ((self):match_((self):leftBracket()))==true then return ((self):nextBlock_(aContext)); end;
if ((self):match_((self):leftParenthesis()))==true then (function()
	local _s8_value=((self):expression_(aContext))
	node=_s8_value
	return _s8_value
end)();
if ((self):match_((self):rightParenthesis()))==true then return (node); end;
return ((self):expected_((self):rightParenthesis())); end;
return (nil);
end
,"parsing","primaryExpression: aContext\r\n\t\" Private - Parse the receiver looking for a primary expression using variables in aContext.\r\n\tReturns nil if failed.\r\n\t<rule> primary = literal | variableName | brace | block | '(' expression ')' | '<' primitive '>' .\r\n\t\"\r\n\r\n\t| node |\r\n\tnode := self nextLiteral: aContext.\r\n\tnode notNil ifTrue: [ ^node ].\r\n\tnode := self nextVariable: aContext.\r\n\tnode notNil ifTrue: [ ^node ].\r\n\t(self match: self leftBrace) ifTrue: [\r\n\t\t^self nextBraceExpression: aContext\r\n\t].\r\n\t(self match: self leftBracket) ifTrue: [\r\n\t\t^self nextBlock: aContext\r\n\t].\r\n\r\n\t(self match: self leftParenthesis) ifTrue: [\r\n\t\tnode := self expression: aContext.\r\n\t\t(self match: self rightParenthesis) ifTrue: [ ^node ].\r\n\t\t^self expected: self rightParenthesis\r\n\t].\r\n\t^nil \" self expected: #expression \"","function(self,aContext)\r\nlocal node=nil\r\n(function()\r\n\tlocal _s8_value=((self):nextLiteral_(aContext))\r\n\tnode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((node)))==true then return (node); end;\r\n(function()\r\n\tlocal _s8_value=((self):nextVariable_(aContext))\r\n\tnode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((node)))==true then return (node); end;\r\nif ((self):match_((self):leftBrace()))==true then return ((self):nextBraceExpression_(aContext)); end;\r\nif ((self):match_((self):leftBracket()))==true then return ((self):nextBlock_(aContext)); end;\r\nif ((self):match_((self):leftParenthesis()))==true then (function()\r\n\tlocal _s8_value=((self):expression_(aContext))\r\n\tnode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((self):match_((self):rightParenthesis()))==true then return (node); end;\r\nreturn ((self):expected_((self):rightParenthesis())); end;\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"pushNil",0
,function(self)
return ((self):specialVariableNamed_("nil"));
end
,"parsing","pushNil\r\n\t\" Returns a node returning nil. \"\r\n\r\n\t^self specialVariableNamed: #nil ","function(self)\r\nreturn ((self):specialVariableNamed_(\"nil\"));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"pushSelf",0
,function(self)
return ((self):specialVariableNamed_("self"));
end
,"parsing","pushSelf\r\n\t\" Returns a node returning self. \"\r\n\r\n\t^self specialVariableNamed: #self ","function(self)\r\nreturn ((self):specialVariableNamed_(\"self\"));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"readIntegerFrom:radix:",0
,function(self,aStream,radix)
local digit=nil
local value=nil
(function()
	local _s8_value=(0)
	value=_s8_value
	return _s8_value
end)();
while not ((function()
return ((aStream):atEnd())
end))() do (function()
	local _s8_value=((aStream):next())
	digit=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_(((digit):isDigit()),(function()
return ((digit):digitValue())
end),(function()
return (-1)
end)))
	digit=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_or_((((digit) < 0)),(function()
return (((digit) >= radix))
end)))==true then (aStream):skip_(-1);
return (value); end;
(function()
	local _s8_value=(((value):_star(radix)):_plus(digit))
	value=_s8_value
	return _s8_value
end)(); end;
return (value);
end
,"parsing","readIntegerFrom: aStream radix: radix\r\n\t\" Private - Answer aNumber of the concrete subclasses if Integer.\r\n\tInitial minus sign accepted, and bases > 10 use letters A-Z.\r\n\tImbedded radix specifiers not allowed; use Integer\r\n\tclass readFrom: for that. Answer zero if there are no digits. \"\r\n\r\n\t| digit value |\r\n\tvalue := 0.\r\n\t[aStream atEnd] whileFalse: [\r\n\t\tdigit := aStream next.\r\n\t\tdigit := digit isDigit ifTrue: [ digit digitValue ] ifFalse: [-1].\r\n\t\t(digit < 0 or: [digit >= radix]) ifTrue: [\r\n\t\t\taStream skip: -1.\r\n\t\t\t^value\r\n\t\t].\r\n\t\tvalue := value * radix + digit\r\n\t].\r\n\t^value","function(self,aStream,radix)\r\nlocal digit=nil\r\nlocal value=nil\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((aStream):atEnd())\r\nend))() do (function()\r\n\tlocal _s8_value=((aStream):next())\r\n\tdigit=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((digit):isDigit()),(function()\r\nreturn ((digit):digitValue())\r\nend),(function()\r\nreturn (-1)\r\nend)))\r\n\tdigit=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_or_((((digit) < 0)),(function()\r\nreturn (((digit) >= radix))\r\nend)))==true then (aStream):skip_(-1);\r\nreturn (value); end;\r\n(function()\r\n\tlocal _s8_value=(((value):_star(radix)):_plus(digit))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (value);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"readSmalltalkFloat:from:",0
,function(self,integerPart,aStream)
local value=nil
local coercionClass=nil
local possibleCoercionClass=nil
local precision=nil
local digit=nil
local num=nil
local den=nil
local exp=nil
local neg=nil
local endOfNumber=nil
local eChar=nil
local atEnd=nil
(function()
	local _s8_value=(0)
	precision=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(0)
	num=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(1)
	den=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=("Integer")
	coercionClass=_s8_value
	return _s8_value
end)();
if ((aStream):peekFor_("."))==true then smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:booleanNot_(((aStream):atEnd()))),(function()
return (((aStream):peek()):isDigit())
end))),(function()
(function()
	local _s8_value=("Float")
	coercionClass=_s8_value
	return _s8_value
end)();while not ((function()
return (smalltalk:boolean_or_((((function()
	local _s8_value=((aStream):atEnd())
	atEnd=_s8_value
	return _s8_value
end)())),(function()
return (smalltalk:booleanNot_(((((function()
	local _s8_value=((aStream):next())
	digit=_s8_value
	return _s8_value
end)())):isDigit())))
end)))
end))() do (function()
	local _s8_value=(((num):_star(10)):_plus((digit):digitValue()))
	num=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((precision):_plus(1))
	precision=_s8_value
	return _s8_value
end)(); end;(function()
	local _s8_value=((10):raisedTo_(precision))
	den=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((atEnd),nil,(function()
return ((aStream):skip_(-1))
end)))
end),(function()
return ((aStream):skip_(-1))
end)); end;
(function()
	local _s8_value=((aStream):peek())
	eChar=_s8_value
	return _s8_value
end)();
if (((eChar)==nil))==true then (function()
	local _s8_value=(nil)
	possibleCoercionClass=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=((eChar):asLowercase())
	eChar=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((eChar),"e")),(function()
return ("Float")
end),nil))
	possibleCoercionClass=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((((possibleCoercionClass)==nil)),nil,(function()
return ((aStream):next())
end)); end;
(function()
	local _s8_value=(nil)
	exp=_s8_value
	return _s8_value
end)();
if not ((((possibleCoercionClass)==nil)))==true then (function()
	local _s8_value=(possibleCoercionClass)
	coercionClass=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aStream):position())
	endOfNumber=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aStream):peekFor_("-"))
	neg=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((((function()
	local _s8_value=((aStream):peek())
	digit=_s8_value
	return _s8_value
end)())))),(function()
return ((digit):isDigit())
end))),(function()
(function()
	local _s8_value=((self):readIntegerFrom_radix_(aStream,10))
	exp=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((neg),(function()
return ((function()
	local _s8_value=((exp):negated())
	exp=_s8_value
	return _s8_value
end)())
end),nil))
end),(function()
return ((aStream):position_(endOfNumber))
end)); end;
(function()
	local _s8_value=((integerPart):_plus((num):_slash(den)))
	value=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:isNil_((exp))),(function()
return (value)
end),(function()
return ((value):_star((10):raisedTo_(exp)))
end)));
end
,"parsing","readSmalltalkFloat: integerPart from: aStream\r\n\t\" Private -Answer aNumber as described on the stream, aStream. \"\r\n\r\n\t| value coercionClass possibleCoercionClass precision digit num den exp neg endOfNumber eChar atEnd |\r\n\tprecision := 0. num := 0. den := 1.\r\n\tcoercionClass := #Integer.\r\n\t(aStream peekFor: $.) ifTrue: [\"<integer>.<fraction>\"\r\n\t\t(aStream atEnd not and: [aStream peek isDigit]) ifTrue: [\r\n\t\t\tcoercionClass := #Float.\r\n\t\t\t[ (atEnd := aStream atEnd) or: [(digit := aStream next) isDigit not]\r\n\t\t\t] whileFalse: [\r\n\t\t\t\tnum := num * 10 + digit digitValue.\r\n\t\t\t\tprecision := precision + 1\r\n\t\t\t].\r\n\t\t\tden := 10 raisedTo: precision.\r\n\t\t\tatEnd ifFalse: [ aStream skip: -1 ]\r\n\t\t] ifFalse: [\"just <integer>. un-gobble the period\"\r\n\t\t\taStream skip: -1\r\n\t\t]\r\n\t].\r\n\teChar := aStream peek.\r\n\teChar == nil\r\n\tifTrue: [ possibleCoercionClass := nil ]\r\n\tifFalse: [\r\n\t\t\"true ifTrue: [ \"eChar := eChar asLowercase\" ]\".\r\n\t\tpossibleCoercionClass := eChar = $e ifTrue: [ #Float ].\r\n\t\tpossibleCoercionClass == nil ifFalse: [ aStream next ]\r\n\t].\r\n\texp := nil.\r\n\tpossibleCoercionClass == nil ifFalse: [\r\n\t\tcoercionClass := possibleCoercionClass.\r\n\t\tendOfNumber := aStream position.\r\n\t\tneg := aStream peekFor: $-.\r\n\t\t((digit := aStream peek) notNil and: [digit isDigit]) ifTrue: [\r\n\t\t\texp := self readIntegerFrom: aStream radix: 10.\r\n\t\t\tneg ifTrue: [ exp := exp negated ]\r\n\t\t] ifFalse: [ aStream position: endOfNumber ]\r\n\t].\r\n\tvalue := integerPart + (num / den). \"The exponent will be added in the next step. \"\r\n\t\" ^self\r\n\t\tcoerce: value\r\n\t\tto: coercionClass\r\n\t\tprecision: precision\r\n\t\texponent: exp\r\n\t\texponentChar: eChar \"\r\n\t^exp isNil ifTrue: [ value ] ifFalse: [ value * (10 raisedTo: exp) ]","function(self,integerPart,aStream)\r\nlocal value=nil\r\nlocal coercionClass=nil\r\nlocal possibleCoercionClass=nil\r\nlocal precision=nil\r\nlocal digit=nil\r\nlocal num=nil\r\nlocal den=nil\r\nlocal exp=nil\r\nlocal neg=nil\r\nlocal endOfNumber=nil\r\nlocal eChar=nil\r\nlocal atEnd=nil\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tprecision=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tnum=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(1)\r\n\tden=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(\"Integer\")\r\n\tcoercionClass=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((aStream):peekFor_(\".\"))==true then smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:booleanNot_(((aStream):atEnd()))),(function()\r\nreturn (((aStream):peek()):isDigit())\r\nend))),(function()\r\n(function()\r\n\tlocal _s8_value=(\"Float\")\r\n\tcoercionClass=_s8_value\r\n\treturn _s8_value\r\nend)();while not ((function()\r\nreturn (smalltalk:boolean_or_((((function()\r\n\tlocal _s8_value=((aStream):atEnd())\r\n\tatEnd=_s8_value\r\n\treturn _s8_value\r\nend)())),(function()\r\nreturn (smalltalk:booleanNot_(((((function()\r\n\tlocal _s8_value=((aStream):next())\r\n\tdigit=_s8_value\r\n\treturn _s8_value\r\nend)())):isDigit())))\r\nend)))\r\nend))() do (function()\r\n\tlocal _s8_value=(((num):_star(10)):_plus((digit):digitValue()))\r\n\tnum=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((precision):_plus(1))\r\n\tprecision=_s8_value\r\n\treturn _s8_value\r\nend)(); end;(function()\r\n\tlocal _s8_value=((10):raisedTo_(precision))\r\n\tden=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((atEnd),nil,(function()\r\nreturn ((aStream):skip_(-1))\r\nend)))\r\nend),(function()\r\nreturn ((aStream):skip_(-1))\r\nend)); end;\r\n(function()\r\n\tlocal _s8_value=((aStream):peek())\r\n\teChar=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (((eChar)==nil))==true then (function()\r\n\tlocal _s8_value=(nil)\r\n\tpossibleCoercionClass=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=((eChar):asLowercase())\r\n\teChar=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((eChar),\"e\")),(function()\r\nreturn (\"Float\")\r\nend),nil))\r\n\tpossibleCoercionClass=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((((possibleCoercionClass)==nil)),nil,(function()\r\nreturn ((aStream):next())\r\nend)); end;\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\texp=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((((possibleCoercionClass)==nil)))==true then (function()\r\n\tlocal _s8_value=(possibleCoercionClass)\r\n\tcoercionClass=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aStream):position())\r\n\tendOfNumber=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aStream):peekFor_(\"-\"))\r\n\tneg=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((((function()\r\n\tlocal _s8_value=((aStream):peek())\r\n\tdigit=_s8_value\r\n\treturn _s8_value\r\nend)())))),(function()\r\nreturn ((digit):isDigit())\r\nend))),(function()\r\n(function()\r\n\tlocal _s8_value=((self):readIntegerFrom_radix_(aStream,10))\r\n\texp=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((neg),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=((exp):negated())\r\n\texp=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),nil))\r\nend),(function()\r\nreturn ((aStream):position_(endOfNumber))\r\nend)); end;\r\n(function()\r\n\tlocal _s8_value=((integerPart):_plus((num):_slash(den)))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((exp))),(function()\r\nreturn (value)\r\nend),(function()\r\nreturn ((value):_star((10):raisedTo_(exp)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"readSmalltalkNumberFrom:",0
,function(self,aStream)
local value=nil
local neg=nil
local radix=nil
if (smalltalk:boolean_or_(((aStream):atEnd()),(function()
return (((aStream):peek()):isLetter())
end)))==true then return (0); end;
(function()
	local _s8_value=((aStream):peekFor_("-"))
	neg=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):readIntegerFrom_radix_(aStream,10))
	value=_s8_value
	return _s8_value
end)();
if ((aStream):peekFor_("r"))==true then (function()
	local _s8_value=(value)
	radix=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):readSmalltalkRadix_from_(value,aStream))
	value=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):checkForOldSyntax_with_on_(radix,value,aStream))
	value=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=((self):readSmalltalkFloat_from_(value,aStream))
	value=_s8_value
	return _s8_value
end)(); end;
return (smalltalk:if_true_false_((neg),(function()
return ((value):negated())
end),(function()
return (value)
end)));
end
,"parsing","readSmalltalkNumberFrom: aStream\r\n\t\" Private - Answer aNumber as described on the stream, aStream. \"\r\n\r\n\t| value neg radix |\r\n\t(aStream atEnd or: [aStream peek isLetter]) ifTrue: [^0].\r\n\tneg := aStream peekFor: $-.\r\n\tvalue := self readIntegerFrom: aStream radix: 10.\r\n\t(aStream peekFor: $r) ifTrue: [\r\n\t\tradix := value.\r\n\t\tvalue := self readSmalltalkRadix: value from: aStream.\r\n\t\tvalue := self checkForOldSyntax: radix with: value on: aStream\r\n\t] ifFalse: [\r\n\t\tvalue := self readSmalltalkFloat: value from: aStream\r\n\t].\r\n\t^neg\r\n\t\tifTrue: [value negated]\r\n\t\tifFalse: [value]","function(self,aStream)\r\nlocal value=nil\r\nlocal neg=nil\r\nlocal radix=nil\r\nif (smalltalk:boolean_or_(((aStream):atEnd()),(function()\r\nreturn (((aStream):peek()):isLetter())\r\nend)))==true then return (0); end;\r\n(function()\r\n\tlocal _s8_value=((aStream):peekFor_(\"-\"))\r\n\tneg=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):readIntegerFrom_radix_(aStream,10))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((aStream):peekFor_(\"r\"))==true then (function()\r\n\tlocal _s8_value=(value)\r\n\tradix=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):readSmalltalkRadix_from_(value,aStream))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):checkForOldSyntax_with_on_(radix,value,aStream))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=((self):readSmalltalkFloat_from_(value,aStream))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (smalltalk:if_true_false_((neg),(function()\r\nreturn ((value):negated())\r\nend),(function()\r\nreturn (value)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"readSmalltalkRadix:from:",0
,function(self,radix,aStream)
if (((radix) < 2))==true then return ((self):syntaxError_("Invalid radix")); end;
if (smalltalk:boolean_or_(((aStream):atEnd()),(function()
return (smalltalk:booleanNot_(((((aStream):peek()):digitValue()):between_and_(0,(radix):_minus(1)))))
end)))==true then (aStream):skip_(-1);
return (radix); end;
return ((self):readIntegerFrom_radix_(aStream,radix));
end
,"parsing","readSmalltalkRadix: radix from: aStream\r\n\t\" Private - Answer aNumber as described on the stream, aStream. \"\r\n\r\n\tradix < 2 ifTrue: [ ^self syntaxError: 'Invalid radix' ].\r\n\t(aStream atEnd or: [(aStream peek digitValue between: 0 and: radix - 1) not])\r\n\tifTrue: [ aStream skip: -1. ^radix ].\r\n\t^self readIntegerFrom: aStream radix: radix","function(self,radix,aStream)\r\nif (((radix) < 2))==true then return ((self):syntaxError_(\"Invalid radix\")); end;\r\nif (smalltalk:boolean_or_(((aStream):atEnd()),(function()\r\nreturn (smalltalk:booleanNot_(((((aStream):peek()):digitValue()):between_and_(0,(radix):_minus(1)))))\r\nend)))==true then (aStream):skip_(-1);\r\nreturn (radix); end;\r\nreturn ((self):readIntegerFrom_radix_(aStream,radix));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"rightBrace",0
,function(self)
return ("}");
end
,"constants","rightBrace\r\n\t\" Private - Returns the rightBrace token. \"\r\n\r\n\t^$}","function(self)\r\nreturn (\"}\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"rightBracket",0
,function(self)
return ("]");
end
,"constants","rightBracket\r\n\t\" Private - Returns the rightBracket token. \"\r\n\r\n\t^$]","function(self)\r\nreturn (\"]\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"rightParenthesis",0
,function(self)
return (")");
end
,"constants","rightParenthesis\r\n\t\" Private - Returns the rightParenthesis token. \"\r\n\r\n\t^$)","function(self)\r\nreturn (\")\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"scope",0
,function(self)
if (smalltalk:isNil_((self["@scope"])))==true then (self):initializeScope(); end;
return (self["@scope"]);
end
,"accessing","scope\r\n\t\" Returns the receiver's root scope. \"\r\n\r\n\tscope isNil ifTrue: [ self initializeScope ].\r\n\t^scope","function(self)\r\nif (smalltalk:isNil_((self[\"@scope\"])))==true then (self):initializeScope(); end;\r\nreturn (self[\"@scope\"]);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"scope:",0
,function(self,aScope)
(function()
	local _s8_value=(aScope)
	self["@scope"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","scope: aScope\r\n\t\" Set the receiver's root scope. \"\r\n\r\n\tscope := aScope","function(self,aScope)\r\n(function()\r\n\tlocal _s8_value=(aScope)\r\n\tself[\"@scope\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"semicolon",0
,function(self)
return (";");
end
,"constants","semicolon\r\n\t\" Private - Returns the semicolon token. \"\r\n\r\n\t^$;","function(self)\r\nreturn (\";\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"singleQuote",0
,function(self)
return ("'");
end
,"constants","singleQuote\r\n\t\" Private - Returns the singleQuote token. \"\r\n\r\n\t^$'","function(self)\r\nreturn (\"'\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"skip:",0
,function(self,aCharacter)
if (smalltalk:isObject_equalTo_(((self):peek()),aCharacter))==true then (self):next(); end;
return (self);
end
,"parsing","skip: aCharacter\r\n\t\" Skip aCharacter from source stream if present. \"\r\n\r\n\tself peek = aCharacter ifTrue: [ self next ]","function(self,aCharacter)\r\nif (smalltalk:isObject_equalTo_(((self):peek()),aCharacter))==true then (self):next(); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"skipSeparators",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
while ((function()
if (smalltalk:isNil_(((self):basicPeek())))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)(); end;return (((self):basicPeek()):isSeparator())
end))() do (self["@source"]):next(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","skipSeparators\r\n\t\" Advance to the source stream to the next non-separator character. \"\r\n\r\n\t[\tself basicPeek isNil ifTrue: [ ^self ].\r\n\t\tself basicPeek isSeparator\r\n\t] whileTrue: [ source next ]","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nwhile ((function()\r\nif (smalltalk:isNil_(((self):basicPeek())))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return (((self):basicPeek()):isSeparator())\r\nend))() do (self[\"@source\"]):next(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"specialVariableNamed:",0
,function(self,aName)
local index=nil
if (smalltalk:isObject_equalTo_((aName),"self"))==true then return ((smalltalk.ParseSelf):new()); end;
if (smalltalk:isObject_equalTo_((aName),"nil"))==true then return ((smalltalk.ParseUniversal):value_(nil)); end;
if (smalltalk:isObject_equalTo_((aName),"true"))==true then return ((smalltalk.ParseUniversal):value_(true)); end;
if (smalltalk:isObject_equalTo_((aName),"false"))==true then return ((smalltalk.ParseUniversal):value_(false)); end;
if (smalltalk:isObject_equalTo_((aName),"super"))==true then return ((smalltalk.ParseSuper):in_((self):currentClass())); end;
return (((self):instanceVariables()):detect_ifNone_((function(one)
return (smalltalk:isObject_equalTo_(((one):name()),aName))
end),(function()
return (nil)
end)));
end
,"parsing","specialVariableNamed: aName\r\n\t\" Private - Returns a variable known by the receiver with name aName. \"\r\n\r\n\t| index |\r\n\taName = #self ifTrue: [ ^ParseSelf new ].\r\n\taName = #nil ifTrue: [ ^ParseUniversal value: nil ].\r\n\taName = #true ifTrue: [ ^ParseUniversal value: true ].\r\n\taName = #false ifTrue: [ ^ParseUniversal value: false ].\r\n\taName = #super ifTrue: [ ^ParseSuper in: self currentClass ].\r\n\t^self instanceVariables detect: [:one| one name = aName ] ifNone: [] ","function(self,aName)\r\nlocal index=nil\r\nif (smalltalk:isObject_equalTo_((aName),\"self\"))==true then return ((smalltalk.ParseSelf):new()); end;\r\nif (smalltalk:isObject_equalTo_((aName),\"nil\"))==true then return ((smalltalk.ParseUniversal):value_(nil)); end;\r\nif (smalltalk:isObject_equalTo_((aName),\"true\"))==true then return ((smalltalk.ParseUniversal):value_(true)); end;\r\nif (smalltalk:isObject_equalTo_((aName),\"false\"))==true then return ((smalltalk.ParseUniversal):value_(false)); end;\r\nif (smalltalk:isObject_equalTo_((aName),\"super\"))==true then return ((smalltalk.ParseSuper):in_((self):currentClass())); end;\r\nreturn (((self):instanceVariables()):detect_ifNone_((function(one)\r\nreturn (smalltalk:isObject_equalTo_(((one):name()),aName))\r\nend),(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"startOfNextToken",0
,function(self)
(self):skipSeparators();
return ((self):position());
end
,"parsing","startOfNextToken\r\n\t\" Advance to next token and return current position. \"\r\n\r\n\tself skipSeparators.\r\n\t^self position","function(self)\r\n(self):skipSeparators();\r\nreturn ((self):position());\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"parseStatements:in:innerBlock:",0
,function(self,statements,aContext,isInnerBlock)
local returns=nil
local more=nil
local expression=nil
local start=nil
local origin=nil
(function()
	local _s8_value=((self):startOfNextToken())
	origin=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(false)
	returns=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(true)
	more=_s8_value
	return _s8_value
end)();
while ((function()
return (more)
end))() do (function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):match_((self):upArrow()))
	returns=_s8_value
	return _s8_value
end)();
if (returns)==true then (function()
	local _s8_value=((self):expression_(aContext))
	expression=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((expression)))==true then return ((self):expected_("expression to return")); end;
(statements):addLast_((
function(_s8_rec)
	(_s8_rec):expression_(expression);
	(_s8_rec):sourceRange_((start):to_((self):position()));
	return ((_s8_rec):yourself())
end
)((smalltalk.MethodReturnNode):new())); else (function()
	local _s8_value=((self):expression_(aContext))
	expression=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((expression)))==true then (function()
	local _s8_value=(smalltalk:if_true_false_((isInnerBlock),(function()
return ((self):pushNil())
end),(function()
return ((self):pushSelf())
end)))
	expression=_s8_value
	return _s8_value
end)(); end;
(statements):addLast_(expression); end;
if (returns)==true then (self):skip_((self):period()); end;
(function()
	local _s8_value=(smalltalk:boolean_and_((smalltalk:booleanNot_((returns))),(function()
return (smalltalk:boolean_or_(((expression):isPrimitiveNode()),(function()
return ((self):match_((self):period()))
end)))
end)))
	more=_s8_value
	return _s8_value
end)(); end;
(self):skipSeparators();
if not (((self):atEnd()))==true then return ((self):expected_("message or period")); end;
(statements):sourceRange_((origin):to_((self):position()));
return (statements);
end
,"parsing","parseStatements: statements in: aContext innerBlock: isInnerBlock\r\n\t\" Private - Parse the statements in the receiver looking for variables in aContext. \"\r\n\r\n\t| returns more expression start origin |\r\n\torigin := self startOfNextToken.\r\n\treturns := false.\r\n\tmore := true.\r\n\t[more] whileTrue: [\r\n\t\tstart := self startOfNextToken.\r\n\t\treturns := self match: self upArrow.\r\n\t\treturns ifTrue: [ \"Return expression. \"\r\n\t\t\texpression := self expression: aContext.\r\n\t\t\texpression isNil ifTrue: [ ^self expected: 'expression to return' ].\r\n\t\t\tstatements addLast: (\r\n\t\t\t\tMethodReturnNode new\r\n\t\t\t\t\texpression: expression;\r\n\t\t\t\t\tsourceRange: (start to: self position);\r\n\t\t\t\t\tyourself).\r\n\t\t]\r\n\t\tifFalse: [\r\n\t\t\texpression := self expression: aContext.\r\n\t\t\texpression isNil ifTrue: [\r\n\t\t\t\texpression := isInnerBlock\r\n\t\t\t\t\tifTrue: [ self pushNil ]\r\n\t\t\t\t\tifFalse: [ self pushSelf ]\r\n\t\t\t].\r\n\t\t\tstatements addLast: expression\r\n\t\t].\r\n\t\treturns ifTrue: [ self skip: self period ].\r\n\t\tmore := returns not and: [\r\n\t\t\texpression isPrimitiveNode or: [\r\n\t\t\t\tself match: self period ] ]\r\n\t].\r\n\tself skipSeparators.\r\n\tself atEnd ifFalse: [ ^self expected: 'message or period' ].\r\n\tstatements sourceRange: (origin to: self position).\r\n\t^statements","function(self,statements,aContext,isInnerBlock)\r\nlocal returns=nil\r\nlocal more=nil\r\nlocal expression=nil\r\nlocal start=nil\r\nlocal origin=nil\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\torigin=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(false)\r\n\treturns=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(true)\r\n\tmore=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (more)\r\nend))() do (function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):match_((self):upArrow()))\r\n\treturns=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (returns)==true then (function()\r\n\tlocal _s8_value=((self):expression_(aContext))\r\n\texpression=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((expression)))==true then return ((self):expected_(\"expression to return\")); end;\r\n(statements):addLast_((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expression_(expression);\r\n\t(_s8_rec):sourceRange_((start):to_((self):position()));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.MethodReturnNode):new())); else (function()\r\n\tlocal _s8_value=((self):expression_(aContext))\r\n\texpression=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((expression)))==true then (function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((isInnerBlock),(function()\r\nreturn ((self):pushNil())\r\nend),(function()\r\nreturn ((self):pushSelf())\r\nend)))\r\n\texpression=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(statements):addLast_(expression); end;\r\nif (returns)==true then (self):skip_((self):period()); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:boolean_and_((smalltalk:booleanNot_((returns))),(function()\r\nreturn (smalltalk:boolean_or_(((expression):isPrimitiveNode()),(function()\r\nreturn ((self):match_((self):period()))\r\nend)))\r\nend)))\r\n\tmore=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(self):skipSeparators();\r\nif not (((self):atEnd()))==true then return ((self):expected_(\"message or period\")); end;\r\n(statements):sourceRange_((origin):to_((self):position()));\r\nreturn (statements);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"statementsArgs:in:",0
,function(self,argNodes,aScope)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local stmts=nil
local start=nil
local returnStart=nil
local parseNode=nil
local aContext=nil
(function()
	local _s8_value=(aScope)
	aContext=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.BlockClosureNode):new())
	stmts=_s8_value
	return _s8_value
end)();
(stmts):arguments_(argNodes);
(function()
	local _s8_value=((self):position())
	start=_s8_value
	return _s8_value
end)();
(self):skipSeparators();
if ((self):match_((self):verticalBar()))==true then (function()
	local _s8_value=((smalltalk.ParseContext):in_(aContext))
	aContext=_s8_value
	return _s8_value
end)();
(stmts):temporaries_((self):parseTemporaries_(aContext)); end;
while ((function()
return (smalltalk:if_true_false_(((self):match_((self):upArrow())),(function()
(function()
	local _s8_value=((self):position())
	returnStart=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((self):expression_(aContext))
	parseNode=_s8_value
	return _s8_value
end)();if (smalltalk:isNil_((parseNode)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):expected_("expression to return"))
end
)()
error(_s8Ret_,0)
end)(); end;(function()
	local _s8_value=((
function(_s8_rec)
	(_s8_rec):expression_(parseNode);
	(_s8_rec):sourcePosition_((returnStart):to_((self):position()));
	return ((_s8_rec):yourself())
end
)((smalltalk.MethodReturnNode):new()))
	parseNode=_s8_value
	return _s8_value
end)();(stmts):addLast_(parseNode);(self):match_((self):period());return (false)
end),(function()
(function()
	local _s8_value=((self):expression_(aContext))
	parseNode=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((parseNode))),(function()
(stmts):addLast_(parseNode);return ((self):match_((self):period()))
end),(function()
return (false)
end)))
end)))
end))() do  end;
(stmts):sourcePosition_((start):to_((self):position()));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (stmts)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","statementsArgs: argNodes in: aScope\r\n\t\" Private - Parse the receiver looking for a statements in a block using variables in aScope.\r\n\tReturns nil if failed.\r\n\t<node> $[ ($: var)* temporaries statements $] => BlockClosureNode\r\n\t\"\r\n\r\n\t| stmts start returnStart parseNode aContext |\r\n\taContext := aScope.\r\n\tstmts := BlockClosureNode new.\r\n\tstmts arguments: argNodes.\t\t\r\n\tstart := self position.\r\n\tself skipSeparators.\r\n\t(self match: self verticalBar) ifTrue: [ \r\n\t\taContext := ParseContext in: aContext.\r\n\t\tstmts temporaries: (self parseTemporaries: aContext).\r\n\t].\r\n\t[\t(self match: self upArrow) ifTrue: [\r\n\t\t\treturnStart := self position.\r\n\t\t\tparseNode := self expression: aContext.\r\n\t\t\tparseNode isNil ifTrue: [ ^self expected: 'expression to return' ].\r\n\t\t\tparseNode := MethodReturnNode new\r\n\t\t\t\texpression: parseNode;\r\n\t\t\t\tsourcePosition: (returnStart to: self position);\r\n\t\t\t\tyourself.\r\n\t\t\tstmts addLast: parseNode.\r\n\t\t\tself match: self period.\r\n\t\t\tfalse\r\n\t\t] ifFalse: [\r\n\t\t\tparseNode := self expression: aContext.\r\n\t\t\tparseNode notNil ifTrue: [\r\n\t\t\t\tstmts addLast: parseNode.\r\n\t\t\t\tself match: self period\r\n\t\t\t] ifFalse: [false]\r\n\t\t]\r\n\t] whileTrue: [].\r\n\tstmts sourcePosition: (start to: self position).\r\n\t^stmts","function(self,argNodes,aScope)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal stmts=nil\r\nlocal start=nil\r\nlocal returnStart=nil\r\nlocal parseNode=nil\r\nlocal aContext=nil\r\n(function()\r\n\tlocal _s8_value=(aScope)\r\n\taContext=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.BlockClosureNode):new())\r\n\tstmts=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(stmts):arguments_(argNodes);\r\n(function()\r\n\tlocal _s8_value=((self):position())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):skipSeparators();\r\nif ((self):match_((self):verticalBar()))==true then (function()\r\n\tlocal _s8_value=((smalltalk.ParseContext):in_(aContext))\r\n\taContext=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(stmts):temporaries_((self):parseTemporaries_(aContext)); end;\r\nwhile ((function()\r\nreturn (smalltalk:if_true_false_(((self):match_((self):upArrow())),(function()\r\n(function()\r\n\tlocal _s8_value=((self):position())\r\n\treturnStart=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((self):expression_(aContext))\r\n\tparseNode=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isNil_((parseNode)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):expected_(\"expression to return\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;(function()\r\n\tlocal _s8_value=((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):expression_(parseNode);\r\n\t(_s8_rec):sourcePosition_((returnStart):to_((self):position()));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.MethodReturnNode):new()))\r\n\tparseNode=_s8_value\r\n\treturn _s8_value\r\nend)();(stmts):addLast_(parseNode);(self):match_((self):period());return (false)\r\nend),(function()\r\n(function()\r\n\tlocal _s8_value=((self):expression_(aContext))\r\n\tparseNode=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((parseNode))),(function()\r\n(stmts):addLast_(parseNode);return ((self):match_((self):period()))\r\nend),(function()\r\nreturn (false)\r\nend)))\r\nend)))\r\nend))() do  end;\r\n(stmts):sourcePosition_((start):to_((self):position()));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (stmts)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"upArrow",0
,function(self)
return ("^");
end
,"constants","upArrow\r\n\t\" Private - Returns the upArrow token. \"\r\n\r\n\t^$^","function(self)\r\nreturn (\"^\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"verticalBar",0
,function(self)
return ("|");
end
,"constants","verticalBar\r\n\t\" Private - Returns the verticalBar token. \"\r\n\r\n\t^$|","function(self)\r\nreturn (\"|\");\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"nextMessage:in:",0
,function(self,args,aContext)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local exit=nil
local nextArg=nil
local start=nil
local selector=nil
local part=nil
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):nextSelector())
	selector=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((function()
(self):skipSeparators();return (selector)
end))
	exit=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((function()
local arg=nil
(function()
	local _s8_value=((self):nextArgument_(aContext))
	arg=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((arg))),(function()
(arg):canBeAssigned_(true);return ((args):addLast_(arg))
end),nil))
end))
	nextArg=_s8_value
	return _s8_value
end)();
if not ((smalltalk:isObject_equalTo_(((selector):last()),(self):colon())))==true then smalltalk:times_repeat_(((selector):argumentCount()),(function()
return (smalltalk:if_true_false_((smalltalk:isNil_(((nextArg):value()))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):expected_("argument"))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((exit):value())
end
)()
error(_s8Ret_,0)
end)(); end;
(nextArg):value();
while ((function()
(function()
	local _s8_value=((self):startOfNextToken())
	start=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((self):nextWord())
	part=_s8_value
	return _s8_value
end)();if (smalltalk:isNil_((part)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((exit):value())
end
)()
error(_s8Ret_,0)
end)(); end;return (smalltalk:isObject_equalTo_(((self):basicPeek()),(self):colon()))
end))() do (function()
	local _s8_value=(smalltalk:object_comma_((part),(self):next()))
	part=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_(((nextArg):value())))==true then (self):position_(start);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (selector)
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
	local _s8_value=(smalltalk:object_comma_((selector),part))
	selector=_s8_value
	return _s8_value
end)(); end;
(self):position_(start);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((exit):value())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","nextMessage: args in: aContext\r\n\t\" Private - Returns the selector from next message header.\r\n\t<rule> message = (selector | (selector $: argument)*) [comment]\r\n\t\"\r\n\r\n\t| exit nextArg start selector part |\r\n\tstart := self startOfNextToken.\r\n\tselector := self nextSelector.\r\n\texit := [ self skipSeparators. selector ].\r\n\tnextArg := [ | arg |\r\n\t\targ := self nextArgument: aContext.\r\n\t\targ notNil ifTrue: [\r\n\t\t\targ canBeAssigned: true.\r\n\t\t\targs addLast: arg\r\n\t\t]\r\n\t].\r\n\tselector last = self colon ifFalse: [\r\n\t\tselector argumentCount timesRepeat: [\r\n\t\t\tnextArg value isNil ifTrue: [\r\n\t\t\t\t^self expected: #argument\r\n\t\t\t]\r\n\t\t].\r\n\t\t^exit value\r\n\t].\r\n\tnextArg value.\r\n\t[\tstart := self startOfNextToken.\r\n\t\tpart := self nextWord.\r\n\t\tpart isNil ifTrue: [ ^exit value ].\r\n\t\tself basicPeek = self colon\r\n\t] whileTrue: [\r\n\t\tpart := part ,self next.\r\n\t\tnextArg value isNil ifTrue: [\r\n\t\t\tself position: start.\r\n\t\t\t^selector\r\n\t\t].\r\n\t\tselector := selector ,part.\r\n\t].\r\n\tself position: start.\r\n\t^exit value","function(self,args,aContext)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal exit=nil\r\nlocal nextArg=nil\r\nlocal start=nil\r\nlocal selector=nil\r\nlocal part=nil\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):nextSelector())\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((function()\r\n(self):skipSeparators();return (selector)\r\nend))\r\n\texit=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((function()\r\nlocal arg=nil\r\n(function()\r\n\tlocal _s8_value=((self):nextArgument_(aContext))\r\n\targ=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((arg))),(function()\r\n(arg):canBeAssigned_(true);return ((args):addLast_(arg))\r\nend),nil))\r\nend))\r\n\tnextArg=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:isObject_equalTo_(((selector):last()),(self):colon())))==true then smalltalk:times_repeat_(((selector):argumentCount()),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_(((nextArg):value()))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):expected_(\"argument\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((exit):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(nextArg):value();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((self):startOfNextToken())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((self):nextWord())\r\n\tpart=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isNil_((part)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((exit):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return (smalltalk:isObject_equalTo_(((self):basicPeek()),(self):colon()))\r\nend))() do (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((part),(self):next()))\r\n\tpart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_(((nextArg):value())))==true then (self):position_(start);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (selector)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((selector),part))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(self):position_(start);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((exit):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"methodScope:for:",0
,function(self,aCompiledScript,statements)
local args=nil
local selector=nil
local ctx=nil
(function()
	local _s8_value=((smalltalk.ParseContext):new())
	ctx=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:newArray({}))
	args=_s8_value
	return _s8_value
end)();
(aCompiledScript):args_(args);
(function()
	local _s8_value=((self):nextMessage_in_(args,ctx))
	selector=_s8_value
	return _s8_value
end)();
(aCompiledScript):selector_(selector);
if ((args):notEmpty())==true then (ctx):parent_((self):scope());
(function()
	local _s8_value=(ctx)
	self["@scope"]=_s8_value
	return _s8_value
end)(); end;
return ((self):bodyScope_(statements));
end
,"parsing","methodScope: aCompiledScript for: statements\r\n\t\" Private - Returns a context for parsing aCompiledScript.\r\n\t<rule> compiledScript = message script.\r\n\t<rule> message = (selector [[:] argument]...) [comment].\r\n\t\"\r\n\r\n\t| args selector ctx |\r\n\tctx := ParseContext new.\r\n\targs := #().\r\n\taCompiledScript args: args.\r\n\tselector := self nextMessage: args in: ctx.\r\n\taCompiledScript selector: selector.\r\n\targs notEmpty ifTrue: [\r\n\t\tctx parent: self scope.\r\n\t\tscope := ctx.\r\n\t].\r\n\t^self bodyScope: statements","function(self,aCompiledScript,statements)\r\nlocal args=nil\r\nlocal selector=nil\r\nlocal ctx=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.ParseContext):new())\r\n\tctx=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aCompiledScript):args_(args);\r\n(function()\r\n\tlocal _s8_value=((self):nextMessage_in_(args,ctx))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aCompiledScript):selector_(selector);\r\nif ((args):notEmpty())==true then (ctx):parent_((self):scope());\r\n(function()\r\n\tlocal _s8_value=(ctx)\r\n\tself[\"@scope\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((self):bodyScope_(statements));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"methodReturn",0
,function(self)
return (((smalltalk.MethodReturnNode):from_to_((self):position(),(self):position())):expression_((smalltalk.ParseSelf):new()));
end
,"parsing","methodReturn\r\n\t\" Private - Returns an implisit return node. \"\r\n\r\n\t^(MethodReturnNode\r\n\t\tfrom: self position to: self position)\r\n\t\texpression: ParseSelf new ","function(self)\r\nreturn (((smalltalk.MethodReturnNode):from_to_((self):position(),(self):position())):expression_((smalltalk.ParseSelf):new()));\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"parseMethod:",0
,function(self,aCompiledScript)
local body=nil
local methodScope=nil
local statements=nil
(function()
	local _s8_value=((smalltalk.ParseStatements):new())
	statements=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):methodScope_for_(aCompiledScript,statements))
	methodScope=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):parseStatements_in_innerBlock_(statements,methodScope,false))
	body=_s8_value
	return _s8_value
end)();
if not ((smalltalk:responds_to_((body),("isEmpty"))))==true then return (nil); end;
if (smalltalk:boolean_or_(((body):isEmpty()),(function()
return (smalltalk:booleanNot_(((((body):statements()):last()):isReturn())))
end)))==true then ((body):statements()):add_((self):methodReturn()); end;
(aCompiledScript):script_((smalltalk.Script):with_(body));
return (self);
end
,"parsing","parseMethod: aCompiledScript\r\n\t\" Private - Parse method (aCompiledScript) reading from source stream. \"\r\n\r\n\t| body methodScope statements |\r\n\tstatements := ParseStatements new.\r\n\tmethodScope := self methodScope: aCompiledScript for: statements.\r\n\tbody := self parseStatements: statements in: methodScope innerBlock: false.\r\n\t(body respondsTo: #isEmpty) ifFalse: [ ^nil ].\r\n\t(body isEmpty or: [body statements last isReturn not]) ifTrue: [\r\n\t\tbody statements add: self methodReturn\r\n\t].\r\n\taCompiledScript script: (Script with: body)","function(self,aCompiledScript)\r\nlocal body=nil\r\nlocal methodScope=nil\r\nlocal statements=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.ParseStatements):new())\r\n\tstatements=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):methodScope_for_(aCompiledScript,statements))\r\n\tmethodScope=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):parseStatements_in_innerBlock_(statements,methodScope,false))\r\n\tbody=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:responds_to_((body),(\"isEmpty\"))))==true then return (nil); end;\r\nif (smalltalk:boolean_or_(((body):isEmpty()),(function()\r\nreturn (smalltalk:booleanNot_(((((body):statements()):last()):isReturn())))\r\nend)))==true then ((body):statements()):add_((self):methodReturn()); end;\r\n(aCompiledScript):script_((smalltalk.Script):with_(body));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptParser,"parse:method:onError:",0
,function(self,aString,aCompiledScript,aBlock)
(self):parse_doing_onError_(aString,(function()
(self):currentClass_((aCompiledScript):classField());(self):parseMethod_(aCompiledScript);return ((aCompiledScript):source_(aString))
end),aBlock);
return (self);
end
,"scripting","parse: aString method: aCompiledScript onError: aBlock\r\n\t\" Parse aString as method source code implemented in aCompiledScript.\r\n\tReturns the receiver.\r\n\tSee ScriptCompiler framework to learn more on #scripting.\r\n\t\"\r\n\r\n\tself parse: aString doing: [\r\n\t\tself currentClass: aCompiledScript classField.\r\n\t\tself parseMethod: aCompiledScript.\r\n\t\taCompiledScript source: aString.\r\n\t\t] onError: aBlock","function(self,aString,aCompiledScript,aBlock)\r\n(self):parse_doing_onError_(aString,(function()\r\n(self):currentClass_((aCompiledScript):classField());(self):parseMethod_(aCompiledScript);return ((aCompiledScript):source_(aString))\r\nend),aBlock);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptingError["$klass"],"description:",0
,function(self,aString)
return ((
function(_s8_rec)
	(_s8_rec):description_(aString);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"accessing","description: aString\r\n\t\" Returns an instance of the receiver with description aString. \"\r\n\r\n\t^self new\r\n\t\tdescription: aString;\r\n\t\tyourself","function(self,aString)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):description_(aString);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.ScriptingError,"isParseFailure",0
,function(self)
return (true);
end
,"testing","isParseFailure\r\n\t\" Return true if the receiver is a parse failure. \"\r\n\r\n\t^true","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.ScriptingError,"description",0
,function(self)
if (smalltalk:isNil_((self["@description"])))==true then (self):initializeDescription(); end;
return (self["@description"]);
end
,"accessing","description\r\n\t\" Returns the receiver's description string. \"\r\n\r\n\tdescription isNil ifTrue: [ self initializeDescription ].\r\n\t^description","function(self)\r\nif (smalltalk:isNil_((self[\"@description\"])))==true then (self):initializeDescription(); end;\r\nreturn (self[\"@description\"]);\r\nend")

smalltalk:bind(smalltalk.ScriptingError,"description:",0
,function(self,aText)
(function()
	local _s8_value=(aText)
	self["@description"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","description: aText\r\n\t\" Set the receiver's description string. \"\r\n\r\n\tdescription := aText","function(self,aText)\r\n(function()\r\n\tlocal _s8_value=(aText)\r\n\tself[\"@description\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptingError,"initializeDescription",0
,function(self)
(function()
	local _s8_value=("*Error*")
	self["@description"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeDescription\r\n\t\" Private - Initializes the receiver's description. \"\r\n\r\n\tdescription := '*Error*'","function(self)\r\n(function()\r\n\tlocal _s8_value=(\"*Error*\")\r\n\tself[\"@description\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ScriptingError,"descriptionString",0
,function(self)
return ((self):description());
end
,"printing","descriptionString\r\n\t\" Returns the receiver's description as shown to the user. \"\r\n\r\n\t^self description","function(self)\r\nreturn ((self):description());\r\nend")

smalltalk:bind(smalltalk.ScriptingError,"printOn:",0
,function(self,aStream)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((((self)["$klass"]):name()),": "));
	return ((_s8_rec):nextPutAll_((self):descriptionString()))
end
)(aStream);
return (self);
end
,"printing","printOn: aStream\r\n\t\" Append to the argument aStream, a sequence of characters that describes the receiver. \"\r\n\r\n\taStream\r\n\t\tnextPutAll: self class name ,': ';\r\n\t\tnextPutAll: self descriptionString","function(self,aStream)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((((self)[\"$klass\"]):name()),\": \"));\r\n\treturn ((_s8_rec):nextPutAll_((self):descriptionString()))\r\nend\r\n)(aStream);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseError,"position",0
,function(self)
return (self["@position"]);
end
,"accessing","position\r\n\t\" Returns the receiver's position. \"\r\n\r\n\t^position","function(self)\r\nreturn (self[\"@position\"]);\r\nend")

smalltalk:bind(smalltalk.ParseError,"position:",0
,function(self,index)
(function()
	local _s8_value=(index)
	self["@position"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","position: index\r\n\t\" Set the receiver's position. \"\r\n\r\n\tposition := index","function(self,index)\r\n(function()\r\n\tlocal _s8_value=(index)\r\n\tself[\"@position\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseError,"source",0
,function(self)
return (self["@source"]);
end
,"accessing","source\r\n\t\" Returns the receiver's source. \"\r\n\r\n\t^source","function(self)\r\nreturn (self[\"@source\"]);\r\nend")

smalltalk:bind(smalltalk.ParseError,"source:",0
,function(self,aString)
(function()
	local _s8_value=(aString)
	self["@source"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","source: aString\r\n\t\" Set the receiver's source. \"\r\n\r\n\tsource := aString","function(self,aString)\r\n(function()\r\n\tlocal _s8_value=(aString)\r\n\tself[\"@source\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ParseError,"descriptionString",0
,function(self)
local stream=nil
if (smalltalk:isNil_(((self):source())))==true then return (smalltalk:superImplementor(smalltalk.ParseError,"descriptionString")(self)); end;
(function()
	local _s8_value=(((self):source()):stream())
	stream=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((" "),(stream):next_(((self):position()):min_((stream):size())))),"<---")),(self):description()))," ")),(stream):upToEnd()));
end
,"printing","descriptionString\r\n\t\" Returns the receiver's description as shown to the user. \"\r\n\r\n\t| stream |\r\n\tself source isNil ifTrue: [ ^super descriptionString ].\r\n\tstream := self source stream.\r\n\t^' '\r\n\t,(stream next: (self position min: stream size))\r\n\t,'<---' ,self description\r\n\t,' ' ,stream upToEnd","function(self)\r\nlocal stream=nil\r\nif (smalltalk:isNil_(((self):source())))==true then return (smalltalk:superImplementor(smalltalk.ParseError,\"descriptionString\")(self)); end;\r\n(function()\r\n\tlocal _s8_value=(((self):source()):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\" \"),(stream):next_(((self):position()):min_((stream):size())))),\"<---\")),(self):description())),\" \")),(stream):upToEnd()));\r\nend")

smalltalk:bind(smalltalk.SyntaxError,"initializeDescription",0
,function(self)
(function()
	local _s8_value=("Syntax Error")
	self["@description"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeDescription\r\n\t\" Private - Initializes the receiver's description. \"\r\n\r\n\tdescription := 'Syntax Error'","function(self)\r\n(function()\r\n\tlocal _s8_value=(\"Syntax Error\")\r\n\tself[\"@description\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")
