
-- fileIn("s8/library/scripting/Steps.st")
smalltalk:addClass("StepsObject",smalltalk.EventManager,smalltalk:newArray({"id"}),"Steps")
smalltalk.StepsObject["$classVariableNames"]="LastID"

smalltalk.StepsObject["$comment"]="\r\n\tInstances are part of Steps framework, can trigger events and maintain a reference ID.\r\n"

smalltalk:bind(smalltalk.StepsObject["$klass"],"constructEventsTriggered",0
,function(self)
return (smalltalk:object_comma_((smalltalk:newArray({"needsID"})),smalltalk:superImplementor(smalltalk.StepsObject["$klass"],"constructEventsTriggered")(self)));
end
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^#(\tneedsID\r\n\t) ,super constructEventsTriggered","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:newArray({\"needsID\"})),smalltalk:superImplementor(smalltalk.StepsObject[\"$klass\"],\"constructEventsTriggered\")(self)));\r\nend")

smalltalk:bind(smalltalk.StepsObject["$klass"],"newID",0
,function(self)
if (smalltalk:isNil_((smalltalk.StepsObject:classVariableAt_("LastID"))))==true then smalltalk.StepsObject:classVariableAt_put_("LastID",0); end;
smalltalk.StepsObject:classVariableAt_put_("LastID",(smalltalk.StepsObject:classVariableAt_("LastID")):_plus(1));
return (smalltalk.StepsObject:classVariableAt_("LastID"));
end
,"id","newID\r\n\t\" Private - Returns a new/unique ID to reference an instance of the receiver. \"\r\n\r\n\tLastID isNil ifTrue: [ LastID := 0 ].\r\n\tLastID := LastID + 1.\r\n\t^LastID ","function(self)\r\nif (smalltalk:isNil_((smalltalk.StepsObject:classVariableAt_(\"LastID\"))))==true then smalltalk.StepsObject:classVariableAt_put_(\"LastID\",0); end;\r\nsmalltalk.StepsObject:classVariableAt_put_(\"LastID\",(smalltalk.StepsObject:classVariableAt_(\"LastID\")):_plus(1));\r\nreturn (smalltalk.StepsObject:classVariableAt_(\"LastID\"));\r\nend")

smalltalk:bind(smalltalk.StepsObject,"initializeId",0
,function(self)
(function()
	local _s8_value=((self):triggerEvent_ifNotHandled_("needsID",(function()
return (((self)["$klass"]):newID())
end)))
	self["@id"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeId\r\n\t\" Private - Initialize the id of the receiver. \"\r\n\r\n\tid := self\r\n\t\ttriggerEvent: #needsID\r\n\t\tifNotHandled: [ self class newID ] ","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):triggerEvent_ifNotHandled_(\"needsID\",(function()\r\nreturn (((self)[\"$klass\"]):newID())\r\nend)))\r\n\tself[\"@id\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.StepsObject,"id",0
,function(self)
if (smalltalk:isNil_((self["@id"])))==true then (self):initializeId(); end;
return (self["@id"]);
end
,"accessing","id\r\n\t\" Returns the id of the receiver. \"\r\n\r\n\tid isNil ifTrue: [ self initializeId ].\r\n\t^id ","function(self)\r\nif (smalltalk:isNil_((self[\"@id\"])))==true then (self):initializeId(); end;\r\nreturn (self[\"@id\"]);\r\nend")

smalltalk:bind(smalltalk.StepsObject,"descriptionForBinding:",0
,function(self,aBinding)
local text=nil
local max=nil
(function()
	local _s8_value=(30)
	max=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):descriptionForValue_((aBinding):value()))
	text=_s8_value
	return _s8_value
end)();
if ((((text):size()) > max))==true then (function()
	local _s8_value=(smalltalk:object_comma_(((text):copyFrom_to_(1,(max):_minus(3))),"..."))
	text=_s8_value
	return _s8_value
end)(); end;
return (smalltalk:object_comma_((smalltalk:object_comma_(((aBinding):key())," := ")),text));
end
,"ui","descriptionForBinding: aBinding\r\n\t\" Private - Returns a (short) description of aBinding. \"\r\n\r\n\t| text max |\r\n\tmax := 30.\r\n\ttext := self descriptionForValue: aBinding value.\r\n\ttext size > max ifTrue: [ text := (text copyFrom: 1 to: max - 3) ,'...'].\r\n\t^aBinding key ,' := ' ,text ","function(self,aBinding)\r\nlocal text=nil\r\nlocal max=nil\r\n(function()\r\n\tlocal _s8_value=(30)\r\n\tmax=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):descriptionForValue_((aBinding):value()))\r\n\ttext=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((((text):size()) > max))==true then (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((text):copyFrom_to_(1,(max):_minus(3))),\"...\"))\r\n\ttext=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_(((aBinding):key()),\" := \")),text));\r\nend")

smalltalk:bind(smalltalk.StepsObject,"descriptionForValue:",0
,function(self,anObject)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local text=nil
if (smalltalk:isNil_((anObject)))==true then return ("nil"); end;
((function()
return ((function()
	local _s8_value=((self):toString_(anObject))
	text=_s8_value
	return _s8_value
end)())
end)):on_do_(smalltalk.Exception,(function(ex)
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_(("Note: "),(ex):messageText()))
end
)()
error(_s8Ret_,0)
end)())
end));
if ((self):isObject_(anObject))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((anObject):asLiteral())
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (text)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"ui","descriptionForValue: anObject\r\n\t\" Private - Returns a (short) description of anObject. \"\r\n\r\n\t| text |\r\n\tanObject isNil ifTrue: [ ^#nil ].\r\n\r\n\t[ text := self toString: anObject\r\n\t] on: Exception do: [:ex|\r\n\t\t^'Note: ' ,ex messageText\r\n\t].\r\n\r\n\t(self isObject: anObject) ifTrue: [ ^anObject asLiteral ].\r\n\t^text ","function(self,anObject)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal text=nil\r\nif (smalltalk:isNil_((anObject)))==true then return (\"nil\"); end;\r\n((function()\r\nreturn ((function()\r\n\tlocal _s8_value=((self):toString_(anObject))\r\n\ttext=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((\"Note: \"),(ex):messageText()))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\nif ((self):isObject_(anObject))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((anObject):asLiteral())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (text)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.StepsObject,"info",0
,function(self)
return (((smalltalk.NativeHandle):support()):_at_gt(self));
end
,"debug","info\r\n\t\" Returns the description of the receiver. \"\r\n\r\n\t^NativeHandle support @> self ","function(self)\r\nreturn (((smalltalk.NativeHandle):support()):_at_gt(self));\r\nend")

smalltalk:addClass("SimulationBlock",smalltalk.S8Block,smalltalk:newArray({"simulator","method"}),"Steps")

smalltalk:bind(smalltalk.SimulationBlock,"simulator:",0
,function(self,aSimulator)
local tos=nil
(function()
	local _s8_value=(aSimulator)
	self["@simulator"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aSimulator):topFrame())
	tos=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((tos)))==true then (function()
	local _s8_value=((tos):method())
	self["@method"]=_s8_value
	return _s8_value
end)(); end;
return (self);
end
,"accessing","simulator: aSimulator\r\n\t\" Private - Set the receiver. \"\r\n\r\n\t| tos |\r\n\tsimulator := aSimulator.\r\n\ttos := aSimulator topFrame.\r\n\ttos notNil ifTrue: [ method := tos method ] ","function(self,aSimulator)\r\nlocal tos=nil\r\n(function()\r\n\tlocal _s8_value=(aSimulator)\r\n\tself[\"@simulator\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aSimulator):topFrame())\r\n\ttos=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((tos)))==true then (function()\r\n\tlocal _s8_value=((tos):method())\r\n\tself[\"@method\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationBlock,"node",0
,function(self)
return (self["@node"]);
end
,"accessing","node\r\n\t\" Private - Returns the node of the receiver. \"\r\n\r\n\t^node ","function(self)\r\nreturn (self[\"@node\"]);\r\nend")

smalltalk:bind(smalltalk.SimulationBlock,"context",0
,function(self)
return (self["@context"]);
end
,"accessing","context\r\n\t\" Private - Returns the activation context of the receiver. \"\r\n\r\n\t^context ","function(self)\r\nreturn (self[\"@context\"]);\r\nend")

smalltalk:bind(smalltalk.SimulationBlock,"source",0
,function(self)
local interval=nil
if (smalltalk:boolean_or_((smalltalk:isNil_((self["@method"]))),(function()
return (smalltalk:isObject_equalTo_((((self["@method"]):source()):size()),0))
end)))==true then return (nil); end;
(function()
	local _s8_value=((self["@node"]):sourceRange())
	interval=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((interval))),(function()
return (((self["@method"]):source()):copyFrom_to_(((interval):start()):max_(1),(interval):__end()))
end),nil));
end
,"accessing","source\r\n\t\" Return the source of the receiver (or nil). \"\r\n\r\n\t| interval |\r\n\t(method isNil or: [ method source size = 0 ]) ifTrue: [ ^nil ].\r\n\tinterval := node sourceRange.\r\n\t^interval notNil ifTrue: [\r\n\t\tmethod source\r\n\t\t\tcopyFrom: (interval start max: 1)\r\n\t\t\tto: interval end\r\n\t] ","function(self)\r\nlocal interval=nil\r\nif (smalltalk:boolean_or_((smalltalk:isNil_((self[\"@method\"]))),(function()\r\nreturn (smalltalk:isObject_equalTo_((((self[\"@method\"]):source()):size()),0))\r\nend)))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((self[\"@node\"]):sourceRange())\r\n\tinterval=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((interval))),(function()\r\nreturn (((self[\"@method\"]):source()):copyFrom_to_(((interval):start()):max_(1),(interval):__end()))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.SimulationBlock,"asLiteral",0
,function(self)
local result=nil
(function()
	local _s8_value=((self):source())
	result=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((result))),(function()
return (result)
end),(function()
return (smalltalk:superImplementor(smalltalk.SimulationBlock,"asLiteral")(self))
end)));
end
,"converting","asLiteral\r\n\t\" Return the receiver in literal notation. \"\r\n\r\n\t| result |\r\n\tresult := self source.\r\n\t^result notNil ifTrue: [ result ] ifFalse: [ super asLiteral ] ","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):source())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((result))),(function()\r\nreturn (result)\r\nend),(function()\r\nreturn (smalltalk:superImplementor(smalltalk.SimulationBlock,\"asLiteral\")(self))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SimulationBlock,"asBlock",0
,function(self)
return ((smalltalk.S8Block):for_in_(self["@node"],self["@context"]));
end
,"converting","asBlock\r\n\t\" Returns the receiver an an evaluable block. \"\r\n\r\n\t^S8Block for: node in: context ","function(self)\r\nreturn ((smalltalk.S8Block):for_in_(self[\"@node\"],self[\"@context\"]));\r\nend")

smalltalk:bind(smalltalk.SimulationBlock,"valueWithArguments:",0
,function(self,anArray)
(smalltalk.S8Context):in_clear_do_(self["@context"],smalltalk:object_comma_(((self):arguments()),(self):temporaries()),(function(ctx)
(self):bindTo_in_(anArray,ctx);return ((self["@node"]):inject_in_(self["@simulator"],ctx))
end));
return (self);
end
,"evaluating","valueWithArguments: anArray\r\n\t\" Evaluate the receiver with parameters anArray.\r\n\tResult of evaluation is loaded on simulator value when finished.\r\n\t\"\r\n\r\n\tS8Context\r\n\t\tin: context clear: self arguments ,self temporaries\r\n\t\tdo: [:ctx|\r\n\t\t\tself bindTo: anArray in: ctx.\r\n\t\t\tnode inject: simulator in: ctx\r\n\t]. ","function(self,anArray)\r\n(smalltalk.S8Context):in_clear_do_(self[\"@context\"],smalltalk:object_comma_(((self):arguments()),(self):temporaries()),(function(ctx)\r\n(self):bindTo_in_(anArray,ctx);return ((self[\"@node\"]):inject_in_(self[\"@simulator\"],ctx))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationBlock,"ensure:",0
,function(self,aBlock)
(self):bindTo_in_(smalltalk:newArray({}),self["@context"]);
(self["@node"]):inject_in_catch_curtail_finally_(self["@simulator"],self["@context"],nil,nil,aBlock);
return (self);
end
,"evaluating","ensure: aBlock\r\n\t\" Return the result of evaluating the receiver.\r\n\tExecute aBlock after the receiver is executed.\r\n\t\"\r\n\r\n\tself bindTo: #() in: context.\r\n\tnode\tinject: simulator in: context\r\n\t\tcatch: nil curtail: nil\r\n\t\tfinally: aBlock ","function(self,aBlock)\r\n(self):bindTo_in_(smalltalk:newArray({}),self[\"@context\"]);\r\n(self[\"@node\"]):inject_in_catch_curtail_finally_(self[\"@simulator\"],self[\"@context\"],nil,nil,aBlock);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationBlock,"ifCurtailed:",0
,function(self,exceptionBlock)
(self):bindTo_in_(smalltalk:newArray({}),self["@context"]);
(self["@node"]):inject_in_catch_curtail_finally_(self["@simulator"],self["@context"],nil,exceptionBlock,nil);
return (self);
end
,"evaluating","ifCurtailed: exceptionBlock\r\n\t\" Return the result of evaluating the receiver.\r\n\tIf evaluation is limited by exiting before completion, the exception block is evaluated.\r\n\t\"\r\n\r\n\tself bindTo: #() in: context.\r\n\tnode\tinject: simulator in: context\r\n\t\tcatch: nil curtail: exceptionBlock\r\n\t\tfinally: nil ","function(self,exceptionBlock)\r\n(self):bindTo_in_(smalltalk:newArray({}),self[\"@context\"]);\r\n(self[\"@node\"]):inject_in_catch_curtail_finally_(self[\"@simulator\"],self[\"@context\"],nil,exceptionBlock,nil);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationBlock,"on:do:",0
,function(self,anExceptionType,aBlock)
(self):bindTo_in_(smalltalk:newArray({}),self["@context"]);
(self["@node"]):inject_in_catch_curtail_finally_(self["@simulator"],self["@context"],(smalltalk.Association):key_value_(anExceptionType,aBlock),nil,nil);
return (self);
end
,"evaluating","on: anExceptionType do: aBlock\r\n\t\" Return the result of evaluating the receiver catching exceptions. \"\r\n\r\n\tself bindTo: #() in: context.\r\n\tnode\tinject: simulator in: context\r\n\t\tcatch: (Association key: anExceptionType value: aBlock)\r\n\t\tcurtail: nil finally: nil ","function(self,anExceptionType,aBlock)\r\n(self):bindTo_in_(smalltalk:newArray({}),self[\"@context\"]);\r\n(self[\"@node\"]):inject_in_catch_curtail_finally_(self[\"@simulator\"],self[\"@context\"],(smalltalk.Association):key_value_(anExceptionType,aBlock),nil,nil);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationBlock,"repeat","__repeat"
,function(self)
(self["@simulator"]):repeat_while_doing_then_(self,(function()
return (true)
end),nil,(function()
return (nil)
end));
return (self);
end
,"evaluating","repeat\r\n\t\" OBSOLETE - Evaluate the receiver repeatedly, ending only if the block forces some stopping condition. \"\r\n\r\n\tsimulator\r\n\t\trepeat: self while: [ true ]\r\n\t\tdoing: nil then: [] ","function(self)\r\n(self[\"@simulator\"]):repeat_while_doing_then_(self,(function()\r\nreturn (true)\r\nend),nil,(function()\r\nreturn (nil)\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationBlock,"whileFalse:",0
,function(self,aBlock)
(self["@simulator"]):repeat_while_doing_then_(self,(function()
return (smalltalk:isObject_equalTo_((false),(self["@simulator"]):value()))
end),aBlock,(function()
return ((self["@simulator"]):value_(nil))
end));
return (self);
end
,"evaluating","whileFalse: aBlock\r\n\t\" Evaluate aBlock while the result of evaluating the receiver is false. \"\r\n\r\n\tsimulator\r\n\t\trepeat: self while: [ false = simulator value ]\r\n\t\tdoing: aBlock then: [ simulator value: nil ] ","function(self,aBlock)\r\n(self[\"@simulator\"]):repeat_while_doing_then_(self,(function()\r\nreturn (smalltalk:isObject_equalTo_((false),(self[\"@simulator\"]):value()))\r\nend),aBlock,(function()\r\nreturn ((self[\"@simulator\"]):value_(nil))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationBlock,"whileTrue:",0
,function(self,aBlock)
(self["@simulator"]):repeat_while_doing_then_(self,(function()
return (smalltalk:isObject_equalTo_((true),(self["@simulator"]):value()))
end),aBlock,(function()
return ((self["@simulator"]):value_(nil))
end));
return (self);
end
,"evaluating","whileTrue: aBlock\r\n\t\" Evaluate aBlock while the result of evaluating the receiver is true. \"\r\n\r\n\tsimulator\r\n\t\trepeat: self while: [ true = simulator value ]\r\n\t\tdoing: aBlock then: [ simulator value: nil ] ","function(self,aBlock)\r\n(self[\"@simulator\"]):repeat_while_doing_then_(self,(function()\r\nreturn (smalltalk:isObject_equalTo_((true),(self[\"@simulator\"]):value()))\r\nend),aBlock,(function()\r\nreturn ((self[\"@simulator\"]):value_(nil))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationBlock,"isValuable",0
,function(self)
return (true);
end
,"testing","isValuable\r\n\t\" Return true if the receiver can be evaluated. \"\r\n\r\n\t^true","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.SimulationBlock,"asJSONObject",0
,function(self)
return (self);
end
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:addClass("SimulationStep",smalltalk.StepsObject,smalltalk:newArray({"source","action","context"}),"Steps")

smalltalk:bind(smalltalk.SimulationStep,"source",0
,function(self)
return (self["@source"]);
end
,"accessing","source\r\n\t\" Return the source of the receiver. \"\r\n\r\n\t^source","function(self)\r\nreturn (self[\"@source\"]);\r\nend")

smalltalk:bind(smalltalk.SimulationStep,"source:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@source"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","source: anObject\r\n\t\" Set the source of the receiver. \"\r\n\r\n\tsource := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@source\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationStep,"action",0
,function(self)
return (self["@action"]);
end
,"accessing","action\r\n\t\" Return the action of the receiver. \"\r\n\r\n\t^action","function(self)\r\nreturn (self[\"@action\"]);\r\nend")

smalltalk:bind(smalltalk.SimulationStep,"action:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@action"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","action: anObject\r\n\t\" Set the action of the receiver. \"\r\n\r\n\taction := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@action\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationStep,"context",0
,function(self)
return (self["@context"]);
end
,"accessing","context\r\n\t\" Return the context of the receiver. \"\r\n\r\n\t^context","function(self)\r\nreturn (self[\"@context\"]);\r\nend")

smalltalk:bind(smalltalk.SimulationStep,"context:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@context"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","context: anObject\r\n\t\" Set the context of the receiver. \"\r\n\r\n\tcontext := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@context\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationStep["$klass"],"for:doing:in:",0
,function(self,aNodeOrMethod,action,aContext)
return (((self):new()):initialize_doing_in_(aNodeOrMethod,action,aContext));
end
,"instantiation","for: aNodeOrMethod doing: action in: aContext\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new initialize: aNodeOrMethod doing: action in: aContext ","function(self,aNodeOrMethod,action,aContext)\r\nreturn (((self):new()):initialize_doing_in_(aNodeOrMethod,action,aContext));\r\nend")

smalltalk:bind(smalltalk.SimulationStep,"initialize:doing:in:",0
,function(self,aNodeOrMethod,aBlock,aContext)
(function()
	local _s8_value=(aNodeOrMethod)
	self["@source"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(aBlock)
	self["@action"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(aContext)
	self["@context"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initialize: aNodeOrMethod doing: aBlock in: aContext\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsource := aNodeOrMethod.\r\n\taction := aBlock.\r\n\tcontext := aContext ","function(self,aNodeOrMethod,aBlock,aContext)\r\n(function()\r\n\tlocal _s8_value=(aNodeOrMethod)\r\n\tself[\"@source\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(aBlock)\r\n\tself[\"@action\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(aContext)\r\n\tself[\"@context\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationStep,"evaluateWithArguments:",0
,function(self,anArray)
return (((self):action()):evaluateWithArguments_(anArray));
end
,"evaluating","evaluateWithArguments: anArray\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\"self note: source class name ,$\t,(JS@> source).\"\r\n\t^self action evaluateWithArguments: anArray ","function(self,anArray)\r\nreturn (((self):action()):evaluateWithArguments_(anArray));\r\nend")

smalltalk:bind(smalltalk.SimulationStep,"sourceRange",0
,function(self)
return (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((self["@source"]))),(function()
return (smalltalk:responds_to_((self["@source"]),("sourceRange")))
end))),(function()
return ((self["@source"]):sourceRange())
end),nil));
end
,"accessing","sourceRange\r\n\t\" Returns the source range of source (or nil). \"\r\n\r\n\t^(source notNil and: [ source respondsTo: #sourceRange ])\r\n\t\tifTrue: [ source sourceRange ] ","function(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((self[\"@source\"]))),(function()\r\nreturn (smalltalk:responds_to_((self[\"@source\"]),(\"sourceRange\")))\r\nend))),(function()\r\nreturn ((self[\"@source\"]):sourceRange())\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.SimulationStep,"sourceLimits",0
,function(self)
local range=nil
(function()
	local _s8_value=((self):sourceRange())
	range=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((range))),(function()
return ((smalltalk.Array):with_with_((range):start(),(range):__end()))
end),nil));
end
,"accessing","sourceLimits\r\n\t\" Returns the source range limits of source (or nil). \"\r\n\r\n\t| range |\r\n\trange := self sourceRange.\r\n\t^range notNil ifTrue: [ Array with: range start with: range end ] ","function(self)\r\nlocal range=nil\r\n(function()\r\n\tlocal _s8_value=((self):sourceRange())\r\n\trange=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((range))),(function()\r\nreturn ((smalltalk.Array):with_with_((range):start(),(range):__end()))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.SimulationStep,"bindings",0
,function(self)
local array=nil
if (smalltalk:isNil_((self["@context"])))==true then return (nil); end;
(function()
	local _s8_value=(smalltalk:newArray({}))
	array=_s8_value
	return _s8_value
end)();
(self["@context"]):associationsDo_((function(assoc)
return ((array):add_(assoc))
end));
return (array);
end
,"accessing","bindings\r\n\t\" Returns the bindings of the receiver (or nil). \"\r\n\r\n\t| array |\r\n\tcontext isNil ifTrue: [ ^nil ].\r\n\tarray := #().\r\n\tcontext associationsDo: [:assoc| array add: assoc ].\r\n\t^array ","function(self)\r\nlocal array=nil\r\nif (smalltalk:isNil_((self[\"@context\"])))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self[\"@context\"]):associationsDo_((function(assoc)\r\nreturn ((array):add_(assoc))\r\nend));\r\nreturn (array);\r\nend")

smalltalk:bind(smalltalk.SimulationStep,"@","_at"
,function(self,key)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (smalltalk:isNil_((self["@context"])))==true then return (nil); end;
(self["@context"]):associationsDo_((function(assoc)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((assoc):key()),key)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (assoc)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"virtuals","@ key\r\n\t\" Returns the result of accessing the receiver at key (or nil). \"\r\n\r\n\tcontext isNil ifTrue: [ ^nil ].\r\n\tcontext associationsDo: [:assoc|\r\n\t\tassoc key = key ifTrue: [ ^assoc ]\r\n\t].\r\n\t^nil ","function(self,key)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (smalltalk:isNil_((self[\"@context\"])))==true then return (nil); end;\r\n(self[\"@context\"]):associationsDo_((function(assoc)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((assoc):key()),key)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (assoc)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SimulationStep,"bindingAt:put:",0
,function(self,key,aValue)
if (smalltalk:isNil_((self["@context"])))==true then return (nil); end;
return ((self["@context"]):at_put_(key,aValue));
end
,"accessing","bindingAt: key put: aValue\r\n\t\" Set the binding of the receiver. \"\r\n\r\n\tcontext isNil ifTrue: [ ^nil ].\r\n\t^context at: key put: aValue ","function(self,key,aValue)\r\nif (smalltalk:isNil_((self[\"@context\"])))==true then return (nil); end;\r\nreturn ((self[\"@context\"]):at_put_(key,aValue));\r\nend")

smalltalk:bind(smalltalk.SimulationStep,"printString",0
,function(self)
if not ((smalltalk:responds_to_((self["@source"]),("sourceRange"))))==true then return (smalltalk:superImplementor(smalltalk.SimulationStep,"printString")(self)); end;
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("["),(self["@source"]):asLiteral())),"@")),(self["@source"]):sourceRange())),"]"));
end
,"printing","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t(source respondsTo: #sourceRange) ifFalse: [\r\n\t\t^super printString\r\n\t].\r\n\t^$[ ,source asLiteral ,$@ ,source sourceRange ,$] ","function(self)\r\nif not ((smalltalk:responds_to_((self[\"@source\"]),(\"sourceRange\"))))==true then return (smalltalk:superImplementor(smalltalk.SimulationStep,\"printString\")(self)); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"[\"),(self[\"@source\"]):asLiteral())),\"@\")),(self[\"@source\"]):sourceRange())),\"]\"));\r\nend")

smalltalk:addClass("SimulationFrame",smalltalk.StepsObject,smalltalk:newArray({"method","steps","receiver","values","catcher","curtail","final"}),"Steps")

smalltalk:bind(smalltalk.SimulationFrame,"method",0
,function(self)
return (self["@method"]);
end
,"accessing","method\r\n\t\" Return the method of the receiver. \"\r\n\r\n\t^method","function(self)\r\nreturn (self[\"@method\"]);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"method:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@method"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","method: anObject\r\n\t\" Set the method of the receiver. \"\r\n\r\n\tmethod := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@method\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"steps",0
,function(self)
return (self["@steps"]);
end
,"accessing","steps\r\n\t\" Return the steps of the receiver. \"\r\n\r\n\t^steps","function(self)\r\nreturn (self[\"@steps\"]);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"steps:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@steps"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","steps: anObject\r\n\t\" Set the steps of the receiver. \"\r\n\r\n\tsteps := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@steps\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"receiver",0
,function(self)
return (self["@receiver"]);
end
,"accessing","receiver\r\n\t\" Return the receiver of the receiver. \"\r\n\r\n\t^receiver","function(self)\r\nreturn (self[\"@receiver\"]);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"receiver:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@receiver"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","receiver: anObject\r\n\t\" Set the receiver of the receiver. \"\r\n\r\n\treceiver := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@receiver\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"values",0
,function(self)
return (self["@values"]);
end
,"accessing","values\r\n\t\" Return the values of the receiver. \"\r\n\r\n\t^values","function(self)\r\nreturn (self[\"@values\"]);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"values:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@values"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","values: anObject\r\n\t\" Set the values of the receiver. \"\r\n\r\n\tvalues := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@values\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"catcher",0
,function(self)
return (self["@catcher"]);
end
,"accessing","catcher\r\n\t\" Return the catcher of the receiver. \"\r\n\r\n\t^catcher","function(self)\r\nreturn (self[\"@catcher\"]);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"catcher:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@catcher"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","catcher: anObject\r\n\t\" Set the catcher of the receiver. \"\r\n\r\n\tcatcher := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@catcher\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"curtail",0
,function(self)
return (self["@curtail"]);
end
,"accessing","curtail\r\n\t\" Return the curtail of the receiver. \"\r\n\r\n\t^curtail","function(self)\r\nreturn (self[\"@curtail\"]);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"curtail:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@curtail"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","curtail: anObject\r\n\t\" Set the curtail of the receiver. \"\r\n\r\n\tcurtail := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@curtail\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"final",0
,function(self)
return (self["@final"]);
end
,"accessing","final\r\n\t\" Return the final of the receiver. \"\r\n\r\n\t^final","function(self)\r\nreturn (self[\"@final\"]);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"final:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@final"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","final: anObject\r\n\t\" Set the final of the receiver. \"\r\n\r\n\tfinal := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@final\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame["$klass"],"for:doing:",0
,function(self,aMethod,steps)
return (((self):new()):initialize_doing_(aMethod,steps));
end
,"instantiation","for: aMethod doing: steps\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new initialize: aMethod doing: steps ","function(self,aMethod,steps)\r\nreturn (((self):new()):initialize_doing_(aMethod,steps));\r\nend")

smalltalk:bind(smalltalk.SimulationFrame["$klass"],"for:catch:curtail:finally:",0
,function(self,aMethod,catcher,curtail,final)
return ((
function(_s8_rec)
	(_s8_rec):catcher_(catcher);
	(_s8_rec):curtail_(curtail);
	(_s8_rec):final_(final);
	return ((_s8_rec):yourself())
end
)((self):for_doing_(aMethod,smalltalk:newArray({}))));
end
,"instantiation","for: aMethod catch: catcher curtail: curtail finally: final\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^(self for: aMethod doing: #())\r\n\t\tcatcher: catcher;\r\n\t\tcurtail: curtail;\r\n\t\tfinal: final;\r\n\t\tyourself ","function(self,aMethod,catcher,curtail,final)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):catcher_(catcher);\r\n\t(_s8_rec):curtail_(curtail);\r\n\t(_s8_rec):final_(final);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):for_doing_(aMethod,smalltalk:newArray({}))));\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"initialize:doing:",0
,function(self,aMethod,array)
(function()
	local _s8_value=(aMethod)
	self["@method"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((array):copy())
	self["@steps"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initialize: aMethod doing: array\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tmethod := aMethod.\r\n\tsteps := array copy ","function(self,aMethod,array)\r\n(function()\r\n\tlocal _s8_value=(aMethod)\r\n\tself[\"@method\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((array):copy())\r\n\tself[\"@steps\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"receiver:values:",0
,function(self,anObject,array)
(function()
	local _s8_value=(anObject)
	self["@receiver"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(array)
	self["@values"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","receiver: anObject values: array\r\n\t\" Private - Set activation data. \"\r\n\r\n\treceiver := anObject.\r\n\tvalues := array ","function(self,anObject,array)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@receiver\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(array)\r\n\tself[\"@values\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"selector",0
,function(self)
return (((self):method()):selector());
end
,"accessing","selector\r\n\t\" Returns the selector of message sent. \"\r\n\r\n\t^self method selector ","function(self)\r\nreturn (((self):method()):selector());\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"contents",0
,function(self)
return (smalltalk:if_true_false_((smalltalk:isNil_((self["@steps"]))),(function()
return (smalltalk:newArray({}))
end),(function()
return (self["@steps"])
end)));
end
,"accessing","contents\r\n\t\" Returns the receiver's contents. \"\r\n\r\n\t^steps isNil\r\n\t\tifTrue: [ #() ]\r\n\t\tifFalse: [ steps ] ","function(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((self[\"@steps\"]))),(function()\r\nreturn (smalltalk:newArray({}))\r\nend),(function()\r\nreturn (self[\"@steps\"])\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"bindings",0
,function(self)
return (smalltalk:if_true_false_(((((self["@steps"]):size()) > 0)),(function()
return (((self["@steps"]):first()):bindings())
end),nil));
end
,"accessing","bindings\r\n\t\" Returns the associations bound to the receiver (or nil). \"\r\n\r\n\t^steps size > 0 ifTrue: [ steps first bindings ] ","function(self)\r\nreturn (smalltalk:if_true_false_(((((self[\"@steps\"]):size()) > 0)),(function()\r\nreturn (((self[\"@steps\"]):first()):bindings())\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"bindingsInfo",0
,function(self)
local array=nil
(function()
	local _s8_value=((self):bindings())
	array=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((array))),(function()
return ((smalltalk.Array):with_with_(((self["@steps"]):first()):id(),(array):collect_((function(each)
return ((smalltalk.Array):with_with_((each):key(),(self):descriptionForBinding_(each)))
end))))
end),nil));
end
,"virtuals","bindingsInfo\r\n\t\" Returns the information for bindings of the receiver. \"\r\n\r\n\t| array |\r\n\tarray := self bindings.\r\n\t^array notNil ifTrue: [\r\n\t\tArray\twith: steps first id\r\n\t\t\twith: (array collect: [:each|\r\n\t\t\t\tArray\twith: each key\r\n\t\t\t\t\twith: (self descriptionForBinding: each)\r\n\t\t\t])\r\n\t] ","function(self)\r\nlocal array=nil\r\n(function()\r\n\tlocal _s8_value=((self):bindings())\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((array))),(function()\r\nreturn ((smalltalk.Array):with_with_(((self[\"@steps\"]):first()):id(),(array):collect_((function(each)\r\nreturn ((smalltalk.Array):with_with_((each):key(),(self):descriptionForBinding_(each)))\r\nend))))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"isEmpty",0
,function(self)
return (smalltalk:isObject_equalTo_(((self["@steps"]):size()),0));
end
,"query","isEmpty\r\n\t\" Returns true if the receiver is empty. \"\r\n\r\n\t^steps size = 0 ","function(self)\r\nreturn (smalltalk:isObject_equalTo_(((self[\"@steps\"]):size()),0));\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"peek",0
,function(self)
return (smalltalk:if_true_false_(((((self["@steps"]):size()) > 0)),(function()
return ((self["@steps"]):first())
end),nil));
end
,"stream","peek\r\n\t\" Returns the next action to evaluate (or nil). \"\r\n\r\n\t^steps size > 0 ifTrue: [ steps first ]","function(self)\r\nreturn (smalltalk:if_true_false_(((((self[\"@steps\"]):size()) > 0)),(function()\r\nreturn ((self[\"@steps\"]):first())\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"next",0
,function(self)
return (smalltalk:if_true_false_(((((self["@steps"]):size()) > 0)),(function()
return ((self["@steps"]):removeFirst())
end),nil));
end
,"stream","next\r\n\t\" Returns and remove the next action to evaluate (or nil). \"\r\n\r\n\t^steps size > 0 ifTrue: [ steps removeFirst ]","function(self)\r\nreturn (smalltalk:if_true_false_(((((self[\"@steps\"]):size()) > 0)),(function()\r\nreturn ((self[\"@steps\"]):removeFirst())\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"add:",0
,function(self,aStep)
return ((self["@steps"]):addFirst_(aStep));
end
,"add","add: aStep\r\n\t\" Add an inmediate step to evaluate. \"\r\n\r\n\t^steps addFirst: aStep ","function(self,aStep)\r\nreturn ((self[\"@steps\"]):addFirst_(aStep));\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"restart:",0
,function(self,simulator)
if not ((smalltalk:isObject_equalTo_((((simulator):callStack()):removeFirst()),self)))==true then return ((self):error_("Broken stack")); end;
(simulator):send_to_withArguments_((self):selector(),(self):receiver(),(self):values());
return (self);
end
,"stack","restart: simulator\r\n\t\" Private - Set simulator to restart the execution of the receiver.\r\n\tNOTE: the receiver will be (silently) removed from stack and a new frame activation will occur for the original message.\r\n\t\"\r\n\r\n\tsimulator callStack removeFirst = self ifFalse: [ ^self error: 'Broken stack' ].\r\n\tsimulator\r\n\t\tsend: self selector to: self receiver\r\n\t\twithArguments: self values ","function(self,simulator)\r\nif not ((smalltalk:isObject_equalTo_((((simulator):callStack()):removeFirst()),self)))==true then return ((self):error_(\"Broken stack\")); end;\r\n(simulator):send_to_withArguments_((self):selector(),(self):receiver(),(self):values());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"execute:for:",0
,function(self,step,simulator)
((function()
return ((step):evaluateWith_(simulator))
end)):on_do_(smalltalk.Exception,(function(ex)
return ((simulator):handleException_(ex))
end));
return (self);
end
,"execute","execute: step for: simulator\r\n\t\" Private - Capture execution of step in simulator. \"\r\n\r\n\t[ step evaluateWith: simulator\r\n\t] on: Exception do: [:ex|\r\n\t\tsimulator\thandleException: ex\r\n\t]","function(self,step,simulator)\r\n((function()\r\nreturn ((step):evaluateWith_(simulator))\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\nreturn ((simulator):handleException_(ex))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"printString",0
,function(self)
if (smalltalk:isNil_((self["@method"])))==true then return (smalltalk:superImplementor(smalltalk.SimulationFrame,"printString")(self)); end;
return (smalltalk:object_comma_((smalltalk:object_comma_((((self["@method"]):classField()):asLiteral()),"~>")),((self["@method"]):selector()):asLiteral()));
end
,"printing","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\tmethod isNil ifTrue: [ ^super printString ].\r\n\t^method classField asLiteral ,#~> ,method selector asLiteral ","function(self)\r\nif (smalltalk:isNil_((self[\"@method\"])))==true then return (smalltalk:superImplementor(smalltalk.SimulationFrame,\"printString\")(self)); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((((self[\"@method\"]):classField()):asLiteral()),\"~>\")),((self[\"@method\"]):selector()):asLiteral()));\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"methodInfo",0
,function(self)
return (smalltalk:if_true_false_((smalltalk:notNil_((self["@method"]))),(function()
return ((smalltalk.Array):with_with_with_(((self["@method"]):classField()):name(),(self["@method"]):selector(),(self["@method"]):source()))
end),nil));
end
,"virtuals","methodInfo\r\n\t\" Private - Returns the information to catch for the method (or nil). \"\r\n\r\n\t^method notNil ifTrue: [\r\n\t\tArray\twith: method classField name \r\n\t\t\twith: method selector\r\n\t\t\twith: method source\r\n\t] ","function(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((self[\"@method\"]))),(function()\r\nreturn ((smalltalk.Array):with_with_with_(((self[\"@method\"]):classField()):name(),(self[\"@method\"]):selector(),(self[\"@method\"]):source()))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"stepIDs",0
,function(self)
return (((self):steps()):collect_((function(each)
return ((each):id())
end)));
end
,"virtuals","stepIDs\r\n\t\" Private - Returns an array with steps IDs. \"\r\n\r\n\t^self steps collect: [:each| each id ] ","function(self)\r\nreturn (((self):steps()):collect_((function(each)\r\nreturn ((each):id())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SimulationFrame,"@","_at"
,function(self,key)
local anID=nil
(function()
	local _s8_value=((key):asNumber())
	anID=_s8_value
	return _s8_value
end)();
return (((self):steps()):detect_ifNone_((function(one)
return (smalltalk:isObject_equalTo_(((one):id()),anID))
end),(function()
return (nil)
end)));
end
,"virtuals","@ key\r\n\t\" Returns the result of accessing the receiver at key (or nil). \"\r\n\r\n\t| anID |\r\n\tanID := key asNumber.\r\n\t^self steps detect: [:one| one id = anID ] ifNone: [] ","function(self,key)\r\nlocal anID=nil\r\n(function()\r\n\tlocal _s8_value=((key):asNumber())\r\n\tanID=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((self):steps()):detect_ifNone_((function(one)\r\nreturn (smalltalk:isObject_equalTo_(((one):id()),anID))\r\nend),(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:addClass("S8Simulator",smalltalk.StepsObject,smalltalk:newArray({"callStack","value","state","shortcuts","scriptCompiler","breakpoints"}),"Steps")
smalltalk.S8Simulator["$classVariableNames"]="InUse"

smalltalk:bind(smalltalk.S8Simulator,"initializeCallStack",0
,function(self)
(function()
	local _s8_value=((smalltalk.Array):new())
	self["@callStack"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeCallStack\r\n\t\" Private - Initialize the callStack of the receiver. \"\r\n\r\n\tcallStack := Array new","function(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@callStack\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"callStack",0
,function(self)
if (smalltalk:isNil_((self["@callStack"])))==true then (self):initializeCallStack(); end;
return (self["@callStack"]);
end
,"accessing","callStack\r\n\t\" Return the callStack of the receiver. \"\r\n\r\n\tcallStack isNil ifTrue: [ self initializeCallStack ].\r\n\t^callStack","function(self)\r\nif (smalltalk:isNil_((self[\"@callStack\"])))==true then (self):initializeCallStack(); end;\r\nreturn (self[\"@callStack\"]);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"initializeBreakpoints",0
,function(self)
(function()
	local _s8_value=((smalltalk.Array):new())
	self["@breakpoints"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeBreakpoints\r\n\t\" Private - Initialize the breakpoints of the receiver. \"\r\n\r\n\tbreakpoints := Array new","function(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@breakpoints\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"breakpoints",0
,function(self)
if (smalltalk:isNil_((self["@breakpoints"])))==true then (self):initializeBreakpoints(); end;
return (self["@breakpoints"]);
end
,"accessing","breakpoints\r\n\t\" Return the breakpoints of the receiver. \"\r\n\r\n\tbreakpoints isNil ifTrue: [ self initializeBreakpoints ].\r\n\t^breakpoints","function(self)\r\nif (smalltalk:isNil_((self[\"@breakpoints\"])))==true then (self):initializeBreakpoints(); end;\r\nreturn (self[\"@breakpoints\"]);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"initializeScriptCompiler",0
,function(self)
(function()
	local _s8_value=((self):defaultScriptCompiler())
	self["@scriptCompiler"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeScriptCompiler\r\n\t\" Private - Initialize the scriptCompiler of the receiver. \"\r\n\r\n\tscriptCompiler := self defaultScriptCompiler","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):defaultScriptCompiler())\r\n\tself[\"@scriptCompiler\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"scriptCompiler",0
,function(self)
if (smalltalk:isNil_((self["@scriptCompiler"])))==true then (self):initializeScriptCompiler(); end;
return (self["@scriptCompiler"]);
end
,"accessing","scriptCompiler\r\n\t\" Return the scriptCompiler of the receiver. \"\r\n\r\n\tscriptCompiler isNil ifTrue: [ self initializeScriptCompiler ].\r\n\t^scriptCompiler","function(self)\r\nif (smalltalk:isNil_((self[\"@scriptCompiler\"])))==true then (self):initializeScriptCompiler(); end;\r\nreturn (self[\"@scriptCompiler\"]);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"scriptCompiler:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@scriptCompiler"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","scriptCompiler: anObject\r\n\t\" Set the scriptCompiler of the receiver. \"\r\n\r\n\tscriptCompiler := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@scriptCompiler\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"initializeShortcuts",0
,function(self)
(function()
	local _s8_value=((self):triggerEvent_ifNotHandled_("needsShortcuts",(function()
return ((smalltalk.PoolDictionary):new())
end)))
	self["@shortcuts"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeShortcuts\r\n\t\" Private - Initialize the shortcuts of the receiver. \"\r\n\r\n\tshortcuts := self\r\n\t\ttriggerEvent: #needsShortcuts\r\n\t\tifNotHandled: [ PoolDictionary new ]","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):triggerEvent_ifNotHandled_(\"needsShortcuts\",(function()\r\nreturn ((smalltalk.PoolDictionary):new())\r\nend)))\r\n\tself[\"@shortcuts\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"shortcuts",0
,function(self)
if (smalltalk:isNil_((self["@shortcuts"])))==true then (self):initializeShortcuts(); end;
return (self["@shortcuts"]);
end
,"accessing","shortcuts\r\n\t\" Return the shortcuts of the receiver. \"\r\n\r\n\tshortcuts isNil ifTrue: [ self initializeShortcuts ].\r\n\t^shortcuts","function(self)\r\nif (smalltalk:isNil_((self[\"@shortcuts\"])))==true then (self):initializeShortcuts(); end;\r\nreturn (self[\"@shortcuts\"]);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"shortcuts:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@shortcuts"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","shortcuts: anObject\r\n\t\" Set the shortcuts of the receiver. \"\r\n\r\n\tshortcuts := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@shortcuts\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk.S8Simulator["$klass"]["$iVarNames"]=smalltalk:newArray({"current","useScripting"})

smalltalk:bind(smalltalk.S8Simulator["$klass"],"current",0
,function(self)
return (self["@current"]);
end
,"accessing","current\r\n\t\" Return the current of the receiver. \"\r\n\r\n\t^current","function(self)\r\nreturn (self[\"@current\"]);\r\nend")

smalltalk:bind(smalltalk.S8Simulator["$klass"],"current:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@current"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","current: anObject\r\n\t\" Set the current of the receiver. \"\r\n\r\n\tcurrent := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@current\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator["$klass"],"initializeUseScripting",0
,function(self)
(function()
	local _s8_value=(false)
	self["@useScripting"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeUseScripting\r\n\t\" Private - Initialize the useScripting of the receiver. \"\r\n\r\n\tuseScripting := false","function(self)\r\n(function()\r\n\tlocal _s8_value=(false)\r\n\tself[\"@useScripting\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator["$klass"],"useScripting",0
,function(self)
if (smalltalk:isNil_((self["@useScripting"])))==true then (self):initializeUseScripting(); end;
return (self["@useScripting"]);
end
,"accessing","useScripting\r\n\t\" Return the useScripting of the receiver. \"\r\n\r\n\tuseScripting isNil ifTrue: [ self initializeUseScripting ].\r\n\t^useScripting","function(self)\r\nif (smalltalk:isNil_((self[\"@useScripting\"])))==true then (self):initializeUseScripting(); end;\r\nreturn (self[\"@useScripting\"]);\r\nend")

smalltalk:bind(smalltalk.S8Simulator["$klass"],"useScripting:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@useScripting"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","useScripting: anObject\r\n\t\" Set the useScripting of the receiver. \"\r\n\r\n\tuseScripting := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@useScripting\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator["$klass"],"example",0
,function(self)
((self):open_("self halt. 3 + 4 ")):run();
return (self);
end
,"example","example\r\n\t\" DEBUG - Open an instance with a simple expression. \"\r\n\r\n\t(self open: 'self halt. 3 + 4 ') run ","function(self)\r\n((self):open_(\"self halt. 3 + 4 \")):run();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator["$klass"],"open:",0
,function(self,initializer)
return (((self):new()):open_(initializer));
end
,"ui","open: initializer\r\n\t\" Returns an instance opened with initializer. \"\r\n\r\n\t^self new open: initializer ","function(self,initializer)\r\nreturn (((self):new()):open_(initializer));\r\nend")

smalltalk:bind(smalltalk.S8Simulator["$klass"],"run:",0
,function(self,initializer)
return (((self):open_(initializer)):run());
end
,"ui","run: initializer\r\n\t\" Returns an instance opened with initializer. \"\r\n\r\n\t^(self open: initializer) run ","function(self,initializer)\r\nreturn (((self):open_(initializer)):run());\r\nend")

smalltalk:bind(smalltalk.S8Simulator["$klass"],"constructEventsTriggered",0
,function(self)
return (smalltalk:object_comma_((smalltalk:newArray({"aboutToOpen:", "opened", "ready", "paused", "breakpoint:", "aboutToRun", "atEnd", "aboutToClose", "closed", "valueChanged:", "enter:", "enter:with:", "exit:", "exit:with:", "aboutToExit:", "activateMethod:", "activateNative:", "activateBlock:", "deactivateBlock:", "terminate:", "discard:", "aboutToExecute:", "executed:", "needsShortcuts", "getShortcuts:"})),smalltalk:superImplementor(smalltalk.S8Simulator["$klass"],"constructEventsTriggered")(self)));
end
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^#(\taboutToOpen: opened\r\n\t\tready paused breakpoint:\r\n\t\taboutToRun atEnd\r\n\t\taboutToClose closed\r\n\t\tvalueChanged:\r\n\t\tenter: enter:with:\r\n\t\texit: exit:with: aboutToExit:\r\n\t\tactivateMethod: activateNative:\r\n\t\tactivateBlock: deactivateBlock:\r\n\t\tterminate: discard:\r\n\t\taboutToExecute: executed:\r\n\t\tneedsShortcuts getShortcuts:\r\n\t) ,super constructEventsTriggered","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:newArray({\"aboutToOpen:\", \"opened\", \"ready\", \"paused\", \"breakpoint:\", \"aboutToRun\", \"atEnd\", \"aboutToClose\", \"closed\", \"valueChanged:\", \"enter:\", \"enter:with:\", \"exit:\", \"exit:with:\", \"aboutToExit:\", \"activateMethod:\", \"activateNative:\", \"activateBlock:\", \"deactivateBlock:\", \"terminate:\", \"discard:\", \"aboutToExecute:\", \"executed:\", \"needsShortcuts\", \"getShortcuts:\"})),smalltalk:superImplementor(smalltalk.S8Simulator[\"$klass\"],\"constructEventsTriggered\")(self)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator["$klass"],"inUse",0
,function(self)
if (smalltalk:isNil_((smalltalk.S8Simulator:classVariableAt_("InUse"))))==true then smalltalk.S8Simulator:classVariableAt_put_("InUse",(smalltalk.PoolDictionary):new()); end;
return (smalltalk.S8Simulator:classVariableAt_("InUse"));
end
,"accessing","inUse\r\n\t\" Returns the pool of open instances of the receiver. \"\r\n\r\n\tInUse isNil ifTrue: [ InUse := PoolDictionary new ].\r\n\t^InUse","function(self)\r\nif (smalltalk:isNil_((smalltalk.S8Simulator:classVariableAt_(\"InUse\"))))==true then smalltalk.S8Simulator:classVariableAt_put_(\"InUse\",(smalltalk.PoolDictionary):new()); end;\r\nreturn (smalltalk.S8Simulator:classVariableAt_(\"InUse\"));\r\nend")

smalltalk:bind(smalltalk.S8Simulator["$klass"],"@","_at"
,function(self,key)
return (((self):inUse()):_at((key):asNumber()));
end
,"accessing","@ key\r\n\t\" Returns the information given at key (or nil). \"\r\n\r\n\t^self inUse @ key asNumber ","function(self,key)\r\nreturn (((self):inUse()):_at((key):asNumber()));\r\nend")

smalltalk:bind(smalltalk.S8Simulator["$klass"],"empty",0
,function(self)
return ((self):open_(nil));
end
,"instantiation","empty\r\n\t\" Returns a fresh instance of the receiver. \"\r\n\r\n\t^self open: nil ","function(self)\r\nreturn ((self):open_(nil));\r\nend")

smalltalk:bind(smalltalk.S8Simulator["$klass"],"reset",0
,function(self)
smalltalk.S8Simulator:classVariableAt_put_("LastID",smalltalk.S8Simulator:classVariableAt_put_("InUse",nil));
return (self);
end
,"private","reset\r\n\t\" Reset the receiver. \"\r\n\r\n\tLastID := InUse := nil ","function(self)\r\nsmalltalk.S8Simulator:classVariableAt_put_(\"LastID\",smalltalk.S8Simulator:classVariableAt_put_(\"InUse\",nil));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"defaultScriptCompiler",0
,function(self)
if (((self)["$klass"]):useScripting())==true then return ((smalltalk.Smalltalk):at_("ScriptCompiler")); end;
return (smalltalk.Compiler);
end
,"defaults","defaultScriptCompiler\r\n\t\" Returns the default script compiler for the receiver. \"\r\n\r\n\tself class useScripting ifTrue: [\r\n\t\t^Smalltalk at: #ScriptCompiler\r\n\t].\r\n\t^Compiler ","function(self)\r\nif (((self)[\"$klass\"]):useScripting())==true then return ((smalltalk.Smalltalk):at_(\"ScriptCompiler\")); end;\r\nreturn (smalltalk.Compiler);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"value",0
,function(self)
return (self["@value"]);
end
,"accessing","value\r\n\t\" Returns the value of the receiver. \"\r\n\r\n\t^value ","function(self)\r\nreturn (self[\"@value\"]);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"value:",0
,function(self,aValue)
(function()
	local _s8_value=(aValue)
	self["@value"]=_s8_value
	return _s8_value
end)();
(self):triggerEvent_with_("valueChanged:",aValue);
return (self);
end
,"accessing","value: aValue\r\n\t\" Set the value of the receiver. \"\r\n\r\n\tvalue := aValue.\r\n\tself triggerEvent: #valueChanged: with: aValue ","function(self,aValue)\r\n(function()\r\n\tlocal _s8_value=(aValue)\r\n\tself[\"@value\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):triggerEvent_with_(\"valueChanged:\",aValue);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"breakpointFromString:",0
,function(self,aString)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if ((aString):includes_(">>"))==true then smalltalk:if_true_false_(((((aString):upTo_(">>")):trimBlanks()):notEmpty()),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aString):fileIn())
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (aString)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"breakpoints","breakpointFromString: aString\r\n\t\" Private - Returns a breakpoint specified by aString. \"\r\n\r\n\t(aString includes: #>>) ifTrue: [\r\n\t\t(aString upTo: #>>) trimBlanks notEmpty ifTrue: [\r\n\t\t\t^aString fileIn\r\n\t\t].\r\n\t].\r\n\t^aString ","function(self,aString)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif ((aString):includes_(\">>\"))==true then smalltalk:if_true_false_(((((aString):upTo_(\">>\")):trimBlanks()):notEmpty()),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aString):fileIn())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (aString)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"breakpoints:",0
,function(self,array)
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((array))),(function()
return ((array):collect_((function(each)
return (smalltalk:if_true_false_(((each):isString()),(function()
return ((self):breakpointFromString_(each))
end),(function()
return (each)
end)))
end)))
end),nil))
	self["@breakpoints"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","breakpoints: array\r\n\t\" Set the breakpoints of the receiver. \"\r\n\r\n\tbreakpoints := array notNil ifTrue: [\r\n\t\tarray collect: [:each|\r\n\t\t\teach isString\r\n\t\t\tifTrue: [ self breakpointFromString: each ]\r\n\t\t\tifFalse: [ each ]\r\n\t\t]\r\n\t]","function(self,array)\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((array))),(function()\r\nreturn ((array):collect_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):isString()),(function()\r\nreturn ((self):breakpointFromString_(each))\r\nend),(function()\r\nreturn (each)\r\nend)))\r\nend)))\r\nend),nil))\r\n\tself[\"@breakpoints\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"isEmpty",0
,function(self)
return (smalltalk:isObject_equalTo_(((self["@callStack"]):size()),0));
end
,"query","isEmpty\r\n\t\" Returns true if the receiver is empty. \"\r\n\r\n\t^callStack size = 0 ","function(self)\r\nreturn (smalltalk:isObject_equalTo_(((self[\"@callStack\"]):size()),0));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"size",0
,function(self)
return ((self["@callStack"]):size());
end
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^callStack size ","function(self)\r\nreturn ((self[\"@callStack\"]):size());\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"topFrame",0
,function(self)
return (smalltalk:if_true_false_((smalltalk:booleanNot_(((self):isEmpty()))),(function()
return ((self["@callStack"]):first())
end),nil));
end
,"accessing","topFrame\r\n\t\" Returns the frame at top (or nil). \"\r\n\r\n\t^self isEmpty not ifTrue: [ callStack first ] ","function(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:booleanNot_(((self):isEmpty()))),(function()\r\nreturn ((self[\"@callStack\"]):first())\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"bindings",0
,function(self)
return (smalltalk:if_true_false_(((self):atEnd()),(function()
return ((smalltalk.Array):with_(("result"):_minus_gt((self):value())))
end),nil));
end
,"accessing","bindings\r\n\t\" Returns the bindings of the receiver (or nil).\r\n\tNote: it is nil or an Array with result (when finished).\r\n\t\"\r\n\r\n\t^self atEnd ifTrue: [ Array with: #result -> self value ] ","function(self)\r\nreturn (smalltalk:if_true_false_(((self):atEnd()),(function()\r\nreturn ((smalltalk.Array):with_((\"result\"):_minus_gt((self):value())))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"bindingKeys",0
,function(self)
local array=nil
(function()
	local _s8_value=((self):bindings())
	array=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((array))),(function()
return ((array):collect_((function(each)
return ((each):key())
end)))
end),nil));
end
,"virtuals","bindingKeys\r\n\t\" Returns the keys for bindings of the receiver. \"\r\n\r\n\t| array |\r\n\tarray := self bindings.\r\n\t^array notNil ifTrue: [ array collect: [:each| each key ] ] ","function(self)\r\nlocal array=nil\r\n(function()\r\n\tlocal _s8_value=((self):bindings())\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((array))),(function()\r\nreturn ((array):collect_((function(each)\r\nreturn ((each):key())\r\nend)))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"topFrameID",0
,function(self)
local part=nil
(function()
	local _s8_value=((self):topFrame())
	part=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((part))),(function()
return ((part):id())
end),nil));
end
,"virtuals","topFrameID\r\n\t\" Returns the ID of the frame at top (or nil). \"\r\n\r\n\t| part |\r\n\tpart := self topFrame.\r\n\t^part notNil ifTrue: [ part id ]","function(self)\r\nlocal part=nil\r\n(function()\r\n\tlocal _s8_value=((self):topFrame())\r\n\tpart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((part))),(function()\r\nreturn ((part):id())\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"callStackIDs",0
,function(self)
return (((self):callStack()):collect_((function(each)
return ((each):id())
end)));
end
,"virtuals","callStackIDs\r\n\t\" Returns the IDs of the callStack elements. \"\r\n\r\n\t^self callStack collect: [:each| each id ] ","function(self)\r\nreturn (((self):callStack()):collect_((function(each)\r\nreturn ((each):id())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"needsWorkTo:",0
,function(self,aFrame)
return (smalltalk:boolean_and_(((self):includes_(aFrame)),(function()
return ((not smalltalk:isObject_equalTo_(((self["@callStack"]):first()),aFrame)))
end)));
end
,"accessing","needsWorkTo: aFrame\r\n\t\" Returns true when more work must be done to reach aFrame on top of stack. \"\r\n\r\n\t^(self includes: aFrame) and: [ callStack first ~= aFrame ] ","function(self,aFrame)\r\nreturn (smalltalk:boolean_and_(((self):includes_(aFrame)),(function()\r\nreturn ((not smalltalk:isObject_equalTo_(((self[\"@callStack\"]):first()),aFrame)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"needsWorkToID:",0
,function(self,aFrameID)
return ((self):needsWorkTo_((self):_at(aFrameID)));
end
,"virtuals","needsWorkToID: aFrameID\r\n\t\" Returns true when more work must be done to reach aFrame on top of stack. \"\r\n\r\n\t^self needsWorkTo: self @ aFrameID ","function(self,aFrameID)\r\nreturn ((self):needsWorkTo_((self):_at(aFrameID)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"frames",0
,function(self)
return (((self):callStack()):collect_((function(each)
return ((each):asLiteral())
end)));
end
,"accessing","frames\r\n\t\" Returns a snapshot of the frames of the receiver. \"\r\n\r\n\t^self callStack collect: [:each| each asLiteral ] ","function(self)\r\nreturn (((self):callStack()):collect_((function(each)\r\nreturn ((each):asLiteral())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"@","_at"
,function(self,key)
local anID=nil
if (smalltalk:isObject_equalTo_((key),"result"))==true then return (("result"):_minus_gt((self):value())); end;
(function()
	local _s8_value=((key):asNumber())
	anID=_s8_value
	return _s8_value
end)();
return (((self):callStack()):detect_ifNone_((function(one)
return (smalltalk:isObject_equalTo_(((one):id()),anID))
end),(function()
return (nil)
end)));
end
,"virtuals","@ key\r\n\t\" Returns the result of accessing the receiver at key (or nil). \"\r\n\r\n\t| anID |\r\n\tkey = #result ifTrue: [ ^#result -> self value ].\r\n\r\n\tanID := key asNumber.\r\n\t^self callStack detect: [:one| one id = anID ] ifNone: [] ","function(self,key)\r\nlocal anID=nil\r\nif (smalltalk:isObject_equalTo_((key),\"result\"))==true then return ((\"result\"):_minus_gt((self):value())); end;\r\n(function()\r\n\tlocal _s8_value=((key):asNumber())\r\n\tanID=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((self):callStack()):detect_ifNone_((function(one)\r\nreturn (smalltalk:isObject_equalTo_(((one):id()),anID))\r\nend),(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"removeTop",0
,function(self)
local frame=nil
local aMethod=nil
if ((self):isEmpty())==true then return (nil); end;
(function()
	local _s8_value=((self["@callStack"]):removeFirst())
	frame=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((frame):method())
	aMethod=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):triggerEvent_with_("exit:",aMethod);
	return ((_s8_rec):triggerEvent_with_with_("exit:with:",aMethod,self["@value"]))
end
)(self);
(self):curtail_finally_((frame):curtail(),(frame):final());
return (self);
end
,"stack","removeTop\r\n\t\" Remove the method at top of call stack. \"\r\n\r\n\t| frame aMethod |\r\n\tself isEmpty ifTrue: [ ^nil ].\r\n\tframe := callStack removeFirst.\r\n\taMethod := frame method.\r\n\tself\ttriggerEvent: #exit: with: aMethod;\r\n\t\ttriggerEvent: #exit:with: with: aMethod with: value.\r\n\tself curtail: frame curtail finally: frame final ","function(self)\r\nlocal frame=nil\r\nlocal aMethod=nil\r\nif ((self):isEmpty())==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((self[\"@callStack\"]):removeFirst())\r\n\tframe=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((frame):method())\r\n\taMethod=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):triggerEvent_with_(\"exit:\",aMethod);\r\n\treturn ((_s8_rec):triggerEvent_with_with_(\"exit:with:\",aMethod,self[\"@value\"]))\r\nend\r\n)(self);\r\n(self):curtail_finally_((frame):curtail(),(frame):final());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"handleException:",0
,function(self,exception)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local handler=nil
(function()
	local _s8_value=((self["@callStack"]):detect_ifNone_((function(each)
return ((self):catcher_canHandle_((each):catcher(),exception))
end),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_(("Uncaptured exception "),(exception):description())))
end
)()
error(_s8Ret_,0)
end)())
end)))
	handler=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):discard_(handler);
	return ((_s8_rec):removeTop())
end
)(self);
(((handler):catcher()):value()):evaluateWith_(exception);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"exceptions","handleException: exception\r\n\t\" Private - Leave activated frames handling captured exception \"\r\n\r\n\t| handler |\r\n\thandler := callStack detect: [:each|\r\n\t\tself catcher: each catcher canHandle: exception\r\n\t] ifNone: [ ^self error: 'Uncaptured exception ' ,exception description ].\r\n\tself discard: handler; removeTop.\r\n\thandler catcher value evaluateWith: exception. ","function(self,exception)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal handler=nil\r\n(function()\r\n\tlocal _s8_value=((self[\"@callStack\"]):detect_ifNone_((function(each)\r\nreturn ((self):catcher_canHandle_((each):catcher(),exception))\r\nend),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Uncaptured exception \"),(exception):description())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\thandler=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):discard_(handler);\r\n\treturn ((_s8_rec):removeTop())\r\nend\r\n)(self);\r\n(((handler):catcher()):value()):evaluateWith_(exception);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"catcher:canHandle:",0
,function(self,assoc,exception)
return (smalltalk:boolean_and_((smalltalk:notNil_((assoc))),(function()
return (((function()
return (nil)
end)):exception_matches_(exception,(assoc):key()))
end)));
end
,"exceptions","catcher: assoc canHandle: exception\r\n\t\" Private - Returns true if catcher assoc can handle exception \"\r\n\r\n\t^assoc notNil and: [\r\n\t\t[] exception: exception matches: assoc key\r\n\t] ","function(self,assoc,exception)\r\nreturn (smalltalk:boolean_and_((smalltalk:notNil_((assoc))),(function()\r\nreturn (((function()\r\nreturn (nil)\r\nend)):exception_matches_(exception,(assoc):key()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"peek",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
while ((function()
if ((self):isEmpty())==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)(); end;(function()
	local _s8_value=(((self):topFrame()):peek())
	result=_s8_value
	return _s8_value
end)();return (smalltalk:isNil_((result)))
end))() do (self):removeTop(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"stream","peek\r\n\t\" Returns the next action to evaluate (or nil). \"\r\n\r\n\t| result |\r\n\t[\tself isEmpty ifTrue: [ ^nil ].\r\n\t\tresult := self topFrame peek.\r\n\t\tresult isNil\r\n\t] whileTrue: [ self removeTop ].\r\n\t^result","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\nwhile ((function()\r\nif ((self):isEmpty())==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;(function()\r\n\tlocal _s8_value=(((self):topFrame()):peek())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:isNil_((result)))\r\nend))() do (self):removeTop(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"peekID",0
,function(self)
local top=nil
local part=nil
(function()
	local _s8_value=((self):topFrame())
	top=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((top)))==true then return (nil); end;
(function()
	local _s8_value=((top):peek())
	part=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((part))),(function()
return ((smalltalk.Array):with_with_((top):id(),(part):id()))
end),nil));
end
,"virtuals","peekID\r\n\t\" Returns the ID of next action to evaluate (or nil). \"\r\n\r\n\t| top part |\r\n\ttop := self topFrame.\r\n\ttop isNil ifTrue: [ ^nil ].\r\n\tpart := top peek.\r\n\t^part notNil ifTrue: [ Array with: top id with: part id ]","function(self)\r\nlocal top=nil\r\nlocal part=nil\r\n(function()\r\n\tlocal _s8_value=((self):topFrame())\r\n\ttop=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((top)))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((top):peek())\r\n\tpart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((part))),(function()\r\nreturn ((smalltalk.Array):with_with_((top):id(),(part):id()))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"peekSource",0
,function(self)
local step=nil
(function()
	local _s8_value=((self):peek())
	step=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((step))),(function()
return ((step):source())
end),nil));
end
,"accessing","peekSource\r\n\t\" Returns the source of next step (or nil). \"\r\n\r\n\t| step |\r\n\tstep := self peek.\r\n\t^step notNil ifTrue: [ step source ]","function(self)\r\nlocal step=nil\r\n(function()\r\n\tlocal _s8_value=((self):peek())\r\n\tstep=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((step))),(function()\r\nreturn ((step):source())\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"hasMessage",0
,function(self)
local node=nil
(function()
	local _s8_value=((self):peekSource())
	node=_s8_value
	return _s8_value
end)();
return (smalltalk:boolean_and_((smalltalk:responds_to_((node),("isMessageNode"))),(function()
return ((node):isMessageNode())
end)));
end
,"query","hasMessage\r\n\t\" Returns true when the next action to evaluate is a message send. \"\r\n\r\n\t| node |\r\n\tnode := self peekSource.\r\n\t^(node respondsTo: #isMessageNode) and: [ node isMessageNode ] ","function(self)\r\nlocal node=nil\r\n(function()\r\n\tlocal _s8_value=((self):peekSource())\r\n\tnode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:boolean_and_((smalltalk:responds_to_((node),(\"isMessageNode\"))),(function()\r\nreturn ((node):isMessageNode())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"peekSourceID",0
,function(self)
local source=nil
local hash=nil
(function()
	local _s8_value=((self):peekSource())
	source=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((source)))==true then return (nil); end;
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:responds_to_((source),("sourceRange"))),(function()
return ((source):sourceRange())
end),(function()
return ("none")
end)))
	hash=_s8_value
	return _s8_value
end)();
return ((smalltalk.Array):with_with_(((source)["$klass"]):name(),smalltalk:toString_((hash))));
end
,"accessing","peekSourceID\r\n\t\" Returns the ID of current source (or nil). \"\r\n\r\n\t| source hash |\r\n\tsource := self peekSource.\r\n\tsource isNil ifTrue: [ ^nil ].\r\n\thash := (source respondsTo: #sourceRange)\r\n\t\tifTrue: [ source sourceRange ]\r\n\t\tifFalse: [ #none ].\r\n\t^Array\twith: source class name\r\n\t\twith: hash toString ","function(self)\r\nlocal source=nil\r\nlocal hash=nil\r\n(function()\r\n\tlocal _s8_value=((self):peekSource())\r\n\tsource=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((source)))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:responds_to_((source),(\"sourceRange\"))),(function()\r\nreturn ((source):sourceRange())\r\nend),(function()\r\nreturn (\"none\")\r\nend)))\r\n\thash=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((smalltalk.Array):with_with_(((source)[\"$klass\"]):name(),smalltalk:toString_((hash))));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"stepsOn:hasSource:",0
,function(self,aFrame,node)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
((aFrame):steps()):do_((function(each)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((each):source()),node)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"query","stepsOn: aFrame hasSource: node\r\n\t\" Private - Returns true if the source is on sources to execute for frame. \"\r\n\r\n\taFrame steps do: [:each| each source = node ifTrue: [ ^true ] ].\r\n\t^false ","function(self,aFrame,node)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n((aFrame):steps()):do_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((each):source()),node)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"includes:",0
,function(self,aFrame)
return (((self):callStack()):includes_(aFrame));
end
,"query","includes: aFrame\r\n\t\" Returns true if the callStack includes frame. \"\r\n\r\n\t^self callStack includes: aFrame ","function(self,aFrame)\r\nreturn (((self):callStack()):includes_(aFrame));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"includesID:",0
,function(self,aFrameID)
return ((self):includes_((self):_at(aFrameID)));
end
,"query","includesID: aFrameID\r\n\t\" Returns true if the callStack includes frame with id aFrameID. \"\r\n\r\n\t^self includes: self @ aFrameID ","function(self,aFrameID)\r\nreturn ((self):includes_((self):_at(aFrameID)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"execute:in:",0
,function(self,step,frame)
(frame):execute_for_(step,self);
return (self);
end
,"execute","execute: step in: frame\r\n\t\" Private - Evaluate the step in the frame (actually on top of callstack). \"\r\n\r\n\tframe execute: step for: self","function(self,step,frame)\r\n(frame):execute_for_(step,self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"atEnd",0
,function(self)
return (smalltalk:isNil_(((self):peek())));
end
,"stream","atEnd\r\n\t\" Returns true if the receiver is at end. \"\r\n\r\n\t^self peek isNil ","function(self)\r\nreturn (smalltalk:isNil_(((self):peek())));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"next",0
,function(self)
local tos=nil
local step=nil
if ((self):atEnd())==true then return (false); end;
(function()
	local _s8_value=("running")
	self["@state"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):topFrame())
	tos=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((tos):next())
	step=_s8_value
	return _s8_value
end)();
(self):triggerEvent_with_("aboutToExecute:",step);
(self):execute_in_(step,tos);
(self):triggerEvent_with_("executed:",step);
return (((self["@state"])~="paused"));
end
,"stream","next\r\n\t\" Evaluate the next action in the receiver; returns true when it is expected to continue execution. \"\r\n\r\n\t| tos step |\r\n\tself atEnd ifTrue: [ ^false ].\r\n\tstate := #running.\r\n\ttos := self topFrame.\r\n\tstep := tos next.\r\n\tself triggerEvent: #aboutToExecute: with: step.\r\n\tself execute: step in: tos.\r\n\tself triggerEvent: #executed: with: step.\r\n\t^state ~~ #paused ","function(self)\r\nlocal tos=nil\r\nlocal step=nil\r\nif ((self):atEnd())==true then return (false); end;\r\n(function()\r\n\tlocal _s8_value=(\"running\")\r\n\tself[\"@state\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):topFrame())\r\n\ttos=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((tos):next())\r\n\tstep=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):triggerEvent_with_(\"aboutToExecute:\",step);\r\n(self):execute_in_(step,tos);\r\n(self):triggerEvent_with_(\"executed:\",step);\r\nreturn (((self[\"@state\"])~=\"paused\"));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"open:",0
,function(self,initializer)
return ((self):open_on_(initializer,nil));
end
,"gui","open: initializer\r\n\t\" Open the receiver to execute initializer. \"\r\n\r\n\t^self open: initializer on: nil ","function(self,initializer)\r\nreturn ((self):open_on_(initializer,nil));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"open:on:",0
,function(self,initializer,aReceiver)
local rcv=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((aReceiver))),(function()
return (aReceiver)
end),nil))
	rcv=_s8_value
	return _s8_value
end)();
(self):triggerEvent_with_("aboutToOpen:",initializer);
(((self)["$klass"]):inUse()):at_put_((self):id(),self);
((self)["$klass"]):current_(self);
(self):prepare_on_(initializer,rcv);
(
function(_s8_rec)
	(_s8_rec):triggerEvent_("opened");
	return ((_s8_rec):triggerEvent_("ready"))
end
)(self);
return (self);
end
,"gui","open: initializer on: aReceiver\r\n\t\" Open the receiver to execute initializer. \"\r\n\r\n\t| rcv |\r\n\trcv := aReceiver notNil ifTrue: [ aReceiver ].\r\n\tself triggerEvent: #aboutToOpen: with: initializer.\r\n\tself class inUse at: self id put: self.\r\n\tself class current: self.\r\n\tself prepare: initializer on: rcv.\r\n\tself\ttriggerEvent: #opened;\r\n\t\ttriggerEvent: #ready ","function(self,initializer,aReceiver)\r\nlocal rcv=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((aReceiver))),(function()\r\nreturn (aReceiver)\r\nend),nil))\r\n\trcv=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):triggerEvent_with_(\"aboutToOpen:\",initializer);\r\n(((self)[\"$klass\"]):inUse()):at_put_((self):id(),self);\r\n((self)[\"$klass\"]):current_(self);\r\n(self):prepare_on_(initializer,rcv);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):triggerEvent_(\"opened\");\r\n\treturn ((_s8_rec):triggerEvent_(\"ready\"))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"close",0
,function(self)
(self):triggerEvent_("aboutToClose");
(((self)["$klass"]):inUse()):removeKey_ifAbsent_((self):id(),(function()
return (nil)
end));
(function()
	local _s8_value=((function()
	local _s8_value=(nil)
	self["@value"]=_s8_value
	return _s8_value
end)())
	self["@callStack"]=_s8_value
	return _s8_value
end)();
(self):triggerEvent_("closed");
return (true);
end
,"gui","close\r\n\t\" Close the receiver. \"\r\n\r\n\tself triggerEvent: #aboutToClose.\r\n\tself class inUse removeKey: self id ifAbsent: [].\r\n\tcallStack := value := nil.\r\n\tself triggerEvent: #closed.\r\n\t^true ","function(self)\r\n(self):triggerEvent_(\"aboutToClose\");\r\n(((self)[\"$klass\"]):inUse()):removeKey_ifAbsent_((self):id(),(function()\r\nreturn (nil)\r\nend));\r\n(function()\r\n\tlocal _s8_value=((function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@value\"]=_s8_value\r\n\treturn _s8_value\r\nend)())\r\n\tself[\"@callStack\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):triggerEvent_(\"closed\");\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"runWhile:",0
,function(self,condition)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):triggerEvent_("aboutToRun");
while ((function()
if ((self):atEnd())==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):triggerEvent_("atEnd"))
end
)()
error(_s8Ret_,0)
end)(); end;return (smalltalk:boolean_and_(((condition):value()),(function()
return ((self):next())
end)))
end))() do end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"running","runWhile: condition\r\n\t\" Execute the receiver (until paused, empty or condition value is true). \"\r\n\r\n\tself triggerEvent: #aboutToRun.\r\n\t[\tself atEnd ifTrue: [ ^self triggerEvent: #atEnd ].\r\n\t\tcondition value and: [ self next ]\r\n\t] whileTrue ","function(self,condition)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):triggerEvent_(\"aboutToRun\");\r\nwhile ((function()\r\nif ((self):atEnd())==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):triggerEvent_(\"atEnd\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return (smalltalk:boolean_and_(((condition):value()),(function()\r\nreturn ((self):next())\r\nend)))\r\nend))() do end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"run",0
,function(self)
(self):runWhile_((function()
return (true)
end));
return (self);
end
,"running","run\r\n\t\" Start execution of the receiver (until paused or empty). \"\r\n\r\n\tself runWhile: [ true ] ","function(self)\r\n(self):runWhile_((function()\r\nreturn (true)\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"stepIn",0
,function(self)
local top=nil
local node=nil
(function()
	local _s8_value=((self):peekSource())
	node=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((node)))==true then return (nil); end;
(function()
	local _s8_value=((self):topFrame())
	top=_s8_value
	return _s8_value
end)();
(self):runWhile_((function()
return (smalltalk:isObject_equalTo_(((self):peekSource()),node))
end));
return (self);
end
,"actions","stepIn\r\n\t\" Step in current message sent. \"\r\n\r\n\t| top node |\r\n\tnode := self peekSource.\r\n\tnode isNil ifTrue: [ ^nil ].\r\n\ttop := self topFrame.\r\n\tself runWhile: [ self peekSource = node ] ","function(self)\r\nlocal top=nil\r\nlocal node=nil\r\n(function()\r\n\tlocal _s8_value=((self):peekSource())\r\n\tnode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((node)))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((self):topFrame())\r\n\ttop=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):runWhile_((function()\r\nreturn (smalltalk:isObject_equalTo_(((self):peekSource()),node))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"stepOver",0
,function(self)
local top=nil
local node=nil
(function()
	local _s8_value=((self):peekSource())
	node=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((node)))==true then return (nil); end;
(function()
	local _s8_value=((self):topFrame())
	top=_s8_value
	return _s8_value
end)();
(self):runWhile_((function()
return (smalltalk:boolean_and_(((self):includes_(top)),(function()
return ((self):stepsOn_hasSource_(top,node))
end)))
end));
return (self);
end
,"actions","stepOver\r\n\t\" Run until the current message is consumed. \"\r\n\r\n\t| top node |\r\n\tnode := self peekSource.\r\n\tnode isNil ifTrue: [ ^nil ].\r\n\ttop := self topFrame.\r\n\tself runWhile: [\r\n\t\t(self includes: top) and: [\r\n\t\t\tself stepsOn: top hasSource: node\r\n\t\t]\r\n\t] ","function(self)\r\nlocal top=nil\r\nlocal node=nil\r\n(function()\r\n\tlocal _s8_value=((self):peekSource())\r\n\tnode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((node)))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((self):topFrame())\r\n\ttop=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):runWhile_((function()\r\nreturn (smalltalk:boolean_and_(((self):includes_(top)),(function()\r\nreturn ((self):stepsOn_hasSource_(top,node))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"stepOut",0
,function(self)
local top=nil
(function()
	local _s8_value=((self):topFrame())
	top=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((top)))==true then return (nil); end;
(self):runWhile_((function()
return ((self):includes_(top))
end));
return (self);
end
,"actions","stepOut\r\n\t\" Run the receiver while current frame is still on the callStack. \"\r\n\r\n\t| top |\r\n\ttop := self topFrame.\r\n\ttop isNil ifTrue: [ ^nil ].\r\n\tself runWhile: [ self includes: top ] ","function(self)\r\nlocal top=nil\r\n(function()\r\n\tlocal _s8_value=((self):topFrame())\r\n\ttop=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((top)))==true then return (nil); end;\r\n(self):runWhile_((function()\r\nreturn ((self):includes_(top))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"pause",0
,function(self)
(self):add_step_in_("pause",(function()
(self):triggerEvent_("paused");return ((function()
	local _s8_value=("paused")
	self["@state"]=_s8_value
	return _s8_value
end)())
end),nil);
return (self);
end
,"running","pause\r\n\t\" Pause execution of the receiver. \"\r\n\r\n\tself add: #pause step: [\r\n\t\tself triggerEvent: #paused.\r\n\t\tstate := #paused\r\n\t] in: nil ","function(self)\r\n(self):add_step_in_(\"pause\",(function()\r\n(self):triggerEvent_(\"paused\");return ((function()\r\n\tlocal _s8_value=(\"paused\")\r\n\tself[\"@state\"]=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),nil);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"prepare:on:",0
,function(self,initializer,rcv)
if ((initializer):isMemberOf_(smalltalk.Message))==true then return ((self):send_to_withArguments_((initializer):selector(),(initializer):receiver(),(initializer):arguments())); end;
if (smalltalk:boolean_or_((smalltalk:booleanNot_(((self):isObject_(initializer)))),(function()
return (smalltalk:isNil_((initializer)))
end)))==true then return (self); end;
if ((initializer):isString())==true then local cls=nil
local mth=nil
(function()
	local _s8_value=((rcv)["$klass"])
	cls=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((cls):compiler()):compiledMethodToEvaluate_in_(initializer,cls))
	mth=_s8_value
	return _s8_value
end)();
return ((self):callMethod_for_withArguments_(mth,rcv,smalltalk:newArray({}))); end;
return ((self):send_to_withArguments_("evaluate",initializer,smalltalk:newArray({})));
end
,"initialize","prepare: initializer on: rcv\r\n\t\" Private - Initialize the receiver to execute initializer. \"\r\n\r\n\t(initializer isMemberOf: Message) ifTrue: [\r\n\t\t^self\tsend: initializer selector\r\n\t\t\tto: initializer receiver\r\n\t\t\twithArguments: initializer arguments\r\n\t].\r\n\t((self isObject: initializer) not or: [initializer isNil]) ifTrue: [ ^self ].\r\n\tinitializer isString ifTrue: [ | cls mth |\r\n\t\tcls := rcv class.\r\n\t\tmth := cls compiler\r\n\t\t\tcompiledMethodToEvaluate: initializer\r\n\t\t\tin: cls.\r\n\t\t^self callMethod: mth for: rcv withArguments: #()\r\n\t].\r\n\t^self send: #evaluate to: initializer withArguments: #()","function(self,initializer,rcv)\r\nif ((initializer):isMemberOf_(smalltalk.Message))==true then return ((self):send_to_withArguments_((initializer):selector(),(initializer):receiver(),(initializer):arguments())); end;\r\nif (smalltalk:boolean_or_((smalltalk:booleanNot_(((self):isObject_(initializer)))),(function()\r\nreturn (smalltalk:isNil_((initializer)))\r\nend)))==true then return (self); end;\r\nif ((initializer):isString())==true then local cls=nil\r\nlocal mth=nil\r\n(function()\r\n\tlocal _s8_value=((rcv)[\"$klass\"])\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((cls):compiler()):compiledMethodToEvaluate_in_(initializer,cls))\r\n\tmth=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):callMethod_for_withArguments_(mth,rcv,smalltalk:newArray({}))); end;\r\nreturn ((self):send_to_withArguments_(\"evaluate\",initializer,smalltalk:newArray({})));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"exit:",0
,function(self,aValue)
(self):triggerEvent_with_("aboutToExit:",aValue);
(function()
	local _s8_value=(aValue)
	self["@value"]=_s8_value
	return _s8_value
end)();
return ((self):removeTop());
end
,"execute","exit: aValue\r\n\t\" Exit the execution of current method returning aValue. \"\r\n\r\n\tself triggerEvent: #aboutToExit: with: aValue.\r\n\tvalue := aValue.\r\n\t^self removeTop ","function(self,aValue)\r\n(self):triggerEvent_with_(\"aboutToExit:\",aValue);\r\n(function()\r\n\tlocal _s8_value=(aValue)\r\n\tself[\"@value\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):removeTop());\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"stack:remove:doing:",0
,function(self,eventName,aFrame,aBlock)
while not ((function()
return (smalltalk:boolean_or_(((self):isEmpty()),(function()
return (smalltalk:isObject_equalTo_((aFrame),(self):topFrame()))
end)))
end))() do local frame=nil
(function()
	local _s8_value=(((self):callStack()):removeFirst())
	frame=_s8_value
	return _s8_value
end)();
(self):triggerEvent_with_(eventName,frame);
(aBlock):evaluateWith_(frame); end;
return (self);
end
,"stack","stack: eventName remove: aFrame doing: aBlock\r\n\t\" Private - Remove frames at top of the callStack until aFrame is found. \"\r\n\r\n\t[  self isEmpty or: [aFrame = self topFrame] ] whileFalse: [ | frame |\r\n\t\tframe := self callStack removeFirst.\r\n\t\tself triggerEvent: eventName with: frame.\r\n\t\taBlock evaluateWith: frame.\r\n\t]","function(self,eventName,aFrame,aBlock)\r\nwhile not ((function()\r\nreturn (smalltalk:boolean_or_(((self):isEmpty()),(function()\r\nreturn (smalltalk:isObject_equalTo_((aFrame),(self):topFrame()))\r\nend)))\r\nend))() do local frame=nil\r\n(function()\r\n\tlocal _s8_value=(((self):callStack()):removeFirst())\r\n\tframe=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):triggerEvent_with_(eventName,frame);\r\n(aBlock):evaluateWith_(frame); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"removeTop:then:",0
,function(self,frames,aBlock)
(self):removeTop();
(self):add_step_in_("terminate",(function()
return ((self):terminate_then_(frames,aBlock))
end),nil);
return (self);
end
,"stack","removeTop: frames then: aBlock\r\n\t\" Private - Remove top of the callStack and continue terminating frames. \"\r\n\r\n\tself removeTop.\r\n\tself add: #terminate step: [ self terminate: frames then: aBlock ] in: nil. ","function(self,frames,aBlock)\r\n(self):removeTop();\r\n(self):add_step_in_(\"terminate\",(function()\r\nreturn ((self):terminate_then_(frames,aBlock))\r\nend),nil);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"terminate:then:",0
,function(self,frames,aBlock)
local frame=nil
if ((frames):isEmpty())==true then return ((aBlock):evaluate()); end;
(function()
	local _s8_value=((frames):removeFirst())
	frame=_s8_value
	return _s8_value
end)();
if not ((smalltalk:isObject_equalTo_(((self):topFrame()),frame)))==true then (self):error_("Broken call stack"); end;
(self):triggerEvent_with_ifNotHandled_("terminate:",frame,(function()
return ((self):removeTop_then_(frames,aBlock))
end));
return (self);
end
,"stack","terminate: frames then: aBlock\r\n\t\" Private - Terminate the execution of frames at top of the callStack. \"\r\n\r\n\t| frame |\r\n\tframes isEmpty ifTrue: [ ^aBlock evaluate ].\r\n\tframe := frames removeFirst.\r\n\tself topFrame = frame ifFalse: [ self error: 'Broken call stack' ].\r\n\tself triggerEvent: #terminate: with: frame ifNotHandled: [\r\n\t\tself removeTop: frames then: aBlock\r\n\t]. ","function(self,frames,aBlock)\r\nlocal frame=nil\r\nif ((frames):isEmpty())==true then return ((aBlock):evaluate()); end;\r\n(function()\r\n\tlocal _s8_value=((frames):removeFirst())\r\n\tframe=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:isObject_equalTo_(((self):topFrame()),frame)))==true then (self):error_(\"Broken call stack\"); end;\r\n(self):triggerEvent_with_ifNotHandled_(\"terminate:\",frame,(function()\r\nreturn ((self):removeTop_then_(frames,aBlock))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"discard:",0
,function(self,aFrame)
(self):triggerEvent_with_ifNotHandled_("discard:",aFrame,(function()
return ((self):stack_remove_doing_("discard:",aFrame,nil))
end));
return (self);
end
,"stack","discard: aFrame\r\n\t\" Private - Discard the execution of frames at top of the callStack until aFrame is found. \"\r\n\r\n\tself triggerEvent: #discard: with: aFrame ifNotHandled: [\r\n\t\tself stack: #discard: remove: aFrame doing: nil\r\n\t] ","function(self,aFrame)\r\n(self):triggerEvent_with_ifNotHandled_(\"discard:\",aFrame,(function()\r\nreturn ((self):stack_remove_doing_(\"discard:\",aFrame,nil))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"curtail:finally:",0
,function(self,curtail,final)
if (smalltalk:notNil_((curtail)))==true then return ((curtail):ensure_(final)); end;
if (smalltalk:notNil_((final)))==true then (final):ensure_(nil); end;
return (self);
end
,"private","curtail: curtail finally: final\r\n\t\" Private - Evaluate curtail & final blocks in current frame. \"\r\n\r\n\tcurtail notNil ifTrue: [ ^curtail ensure: final ].\r\n\tfinal notNil ifTrue: [ final ensure: nil ] ","function(self,curtail,final)\r\nif (smalltalk:notNil_((curtail)))==true then return ((curtail):ensure_(final)); end;\r\nif (smalltalk:notNil_((final)))==true then (final):ensure_(nil); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"restart:",0
,function(self,aFrame)
(self):discard_(aFrame);
if ((self):isEmpty())==true then return (nil); end;
(aFrame):restart_(self);
return (self);
end
,"stack","restart: aFrame\r\n\t\" Restart execution at start of aFrame. \"\r\n\r\n\tself discard: aFrame.\r\n\tself isEmpty ifTrue: [ ^nil ].\r\n\taFrame restart: self ","function(self,aFrame)\r\n(self):discard_(aFrame);\r\nif ((self):isEmpty())==true then return (nil); end;\r\n(aFrame):restart_(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"restartID:",0
,function(self,aFrameID)
return ((self):restart_((self):_at(aFrameID)));
end
,"virtuals","restartID: aFrameID\r\n\t\" Restart execution at start of aFrame with id aFrameID. \"\r\n\r\n\t^self restart: self @ aFrameID ","function(self,aFrameID)\r\nreturn ((self):restart_((self):_at(aFrameID)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"return:in:then:",0
,function(self,aNode,aContext,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local tos=nil
local all=nil
(function()
	local _s8_value=((aContext):home())
	tos=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((tos)))==true then return ((self):error_("Method context missing")); end;
(function()
	local _s8_value=(smalltalk:newArray({}))
	all=_s8_value
	return _s8_value
end)();
((self):callStack()):do_((function(frame)
if (smalltalk:isObject_equalTo_((tos),frame))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):terminate_then_(all,aBlock))
end
)()
error(_s8Ret_,0)
end)(); end;return ((all):add_(frame))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_(("Activation("),tos)),") missing in call stack")))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"execute","return: aNode in: aContext then: aBlock\r\n\t\" Prepare the receiver to return from method. \"\r\n\r\n\t| tos all |\r\n\ttos := aContext home.\r\n\ttos isNil ifTrue: [ ^self error: 'Method context missing' ].\r\n\tall := #().\r\n\tself callStack do: [:frame|\r\n\t\ttos = frame ifTrue: [ ^self terminate: all then: aBlock ].\r\n\t\tall add: frame.\r\n\t].\r\n\t^self error: 'Activation(' ,tos ,') missing in call stack'","function(self,aNode,aContext,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal tos=nil\r\nlocal all=nil\r\n(function()\r\n\tlocal _s8_value=((aContext):home())\r\n\ttos=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((tos)))==true then return ((self):error_(\"Method context missing\")); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tall=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):callStack()):do_((function(frame)\r\nif (smalltalk:isObject_equalTo_((tos),frame))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):terminate_then_(all,aBlock))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return ((all):add_(frame))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((\"Activation(\"),tos)),\") missing in call stack\")))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"addAll:in:",0
,function(self,statements,aContext)
(statements):reverseDo_((function(each)
return ((self):add_in_(each,aContext))
end));
return (self);
end
,"execute","addAll: statements in: aContext\r\n\t\" Add steps to simulate statements in current method with aContext. \"\r\n\r\n\tstatements reverseDo: [:each| self add: each in: aContext ] ","function(self,statements,aContext)\r\n(statements):reverseDo_((function(each)\r\nreturn ((self):add_in_(each,aContext))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"activateBlock:catch:curtail:finally:",0
,function(self,aFrame,catcher,curtail,final)
local tos=nil
if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((aFrame),(self):topFrame())),(function()
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((catcher),(aFrame):catcher())),(function()
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((curtail),(aFrame):curtail())),(function()
return (smalltalk:isObject_equalTo_((final),(aFrame):final()))
end)))
end)))
end)))==true then return (aFrame); end;
(function()
	local _s8_value=((smalltalk.SimulationFrame):for_catch_curtail_finally_((aFrame):method(),catcher,curtail,final))
	tos=_s8_value
	return _s8_value
end)();
((self):callStack()):addFirst_(tos);
(self):triggerEvent_with_("activateBlock:",tos);
return (tos);
end
,"execute","activateBlock: aFrame catch: catcher curtail: curtail finally: final\r\n\t\" Private - (re)Activate a method context to evaluate a block. \"\r\n\r\n\t| tos |\r\n\t(aFrame = self topFrame\r\n\t\tand: [ catcher = aFrame catcher \r\n\t\tand: [ curtail = aFrame curtail\r\n\t\tand: [ final = aFrame final ]]])\r\n\t\tifTrue: [ ^aFrame ].\r\n\ttos := SimulationFrame\r\n\t\tfor: aFrame method\r\n\t\tcatch: catcher curtail: curtail finally: final.\r\n\tself callStack addFirst: tos.\r\n\tself triggerEvent: #activateBlock: with: tos.\r\n\t^tos ","function(self,aFrame,catcher,curtail,final)\r\nlocal tos=nil\r\nif (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((aFrame),(self):topFrame())),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((catcher),(aFrame):catcher())),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((curtail),(aFrame):curtail())),(function()\r\nreturn (smalltalk:isObject_equalTo_((final),(aFrame):final()))\r\nend)))\r\nend)))\r\nend)))==true then return (aFrame); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.SimulationFrame):for_catch_curtail_finally_((aFrame):method(),catcher,curtail,final))\r\n\ttos=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):callStack()):addFirst_(tos);\r\n(self):triggerEvent_with_(\"activateBlock:\",tos);\r\nreturn (tos);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"deactivateBlock:finally:",0
,function(self,aFrame,final)
(self):triggerEvent_with_("deactivateBlock:",aFrame);
(self):curtail_finally_(nil,final);
return (self);
end
,"execute","deactivateBlock: aFrame finally: final\r\n\t\" Private - Deactivate a block context that run up to end. \"\r\n\r\n\tself triggerEvent: #deactivateBlock: with: aFrame.\r\n\tself curtail: nil finally: final ","function(self,aFrame,final)\r\n(self):triggerEvent_with_(\"deactivateBlock:\",aFrame);\r\n(self):curtail_finally_(nil,final);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"addBlock:contents:in:catch:curtail:finally:",0
,function(self,aNode,nodes,aContext,catcher,curtail,final)
local home=nil
local tos=nil
(function()
	local _s8_value=((aContext):home())
	home=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):activateBlock_catch_curtail_finally_(home,catcher,curtail,final))
	tos=_s8_value
	return _s8_value
end)();
(self):add_step_in_(aNode,(function()
return ((self):deactivateBlock_finally_(home,final))
end),aContext);
(self):addAll_in_(nodes,aContext);
return (self);
end
,"execute","addBlock: aNode contents: nodes in: aContext\r\n\tcatch: catcher curtail: curtail finally: final\r\n\t\" Add steps to activate a block of statements with aContext. \"\r\n\r\n\t| home tos |\r\n\thome := aContext home.\r\n\ttos := self\r\n\t\tactivateBlock: home\r\n\t\tcatch: catcher curtail: curtail\r\n\t\tfinally: final.\r\n\tself\tadd: aNode\r\n\t\tstep: [ self deactivateBlock: home finally: final ]\r\n\t\tin: aContext.\r\n\tself addAll: nodes in: aContext. ","function(self,aNode,nodes,aContext,catcher,curtail,final)\r\nlocal home=nil\r\nlocal tos=nil\r\n(function()\r\n\tlocal _s8_value=((aContext):home())\r\n\thome=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):activateBlock_catch_curtail_finally_(home,catcher,curtail,final))\r\n\ttos=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):add_step_in_(aNode,(function()\r\nreturn ((self):deactivateBlock_finally_(home,final))\r\nend),aContext);\r\n(self):addAll_in_(nodes,aContext);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"collect:all:in:",0
,function(self,aStatement,nodes,aContext)
local array=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	self["@value"]=_s8_value
	return _s8_value
end)();
if ((nodes):isEmpty())==true then return (self); end;
(self):add_step_in_(aStatement,(function()
return ((function()
	local _s8_value=(array)
	self["@value"]=_s8_value
	return _s8_value
end)())
end),aContext);
(nodes):reverseDo_((function(each)
(self):add_step_in_(aStatement,(function()
return ((array):add_(self["@value"]))
end),aContext);return ((self):add_in_(each,aContext))
end));
(function()
	local _s8_value=(self["@value"])
	array=_s8_value
	return _s8_value
end)();
return (self);
end
,"execute","collect: aStatement all: nodes in: aContext\r\n\t\" Add steps to simulate nodes in current method with aContext and collect results. \"\r\n\r\n\t| array |\r\n\tvalue := #().\r\n\tnodes isEmpty ifTrue: [ ^self ].\r\n\tself add: aStatement step: [ value := array ] in: aContext.\r\n\tnodes reverseDo: [:each|\r\n\t\tself add: aStatement step: [ array add: value ] in: aContext.\r\n\t\tself add: each in: aContext\r\n\t].\r\n\tarray := value.","function(self,aStatement,nodes,aContext)\r\nlocal array=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tself[\"@value\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((nodes):isEmpty())==true then return (self); end;\r\n(self):add_step_in_(aStatement,(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(array)\r\n\tself[\"@value\"]=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),aContext);\r\n(nodes):reverseDo_((function(each)\r\n(self):add_step_in_(aStatement,(function()\r\nreturn ((array):add_(self[\"@value\"]))\r\nend),aContext);return ((self):add_in_(each,aContext))\r\nend));\r\n(function()\r\n\tlocal _s8_value=(self[\"@value\"])\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"add:step:in:",0
,function(self,aStatement,action,aContext)
((self):topFrame()):add_((smalltalk.SimulationStep):for_doing_in_(aStatement,action,aContext));
return (self);
end
,"execute","add: aStatement step: action in: aContext\r\n\t\" Add step to simulate aStatement in current method with aContext. \"\r\n\r\n\tself topFrame add: (SimulationStep for: aStatement doing: action in: aContext) ","function(self,aStatement,action,aContext)\r\n((self):topFrame()):add_((smalltalk.SimulationStep):for_doing_in_(aStatement,action,aContext));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"add:steps:in:",0
,function(self,aStatement,array,aContext)
(array):reverseDo_((function(action)
return ((self):add_step_in_(aStatement,action,aContext))
end));
return (self);
end
,"execute","add: aStatement steps: array in: aContext\r\n\t\" Add steps to simulate aStatement in current method with aContext. \"\r\n\r\n\tarray reverseDo: [:action| self add: aStatement step: action in: aContext ] ","function(self,aStatement,array,aContext)\r\n(array):reverseDo_((function(action)\r\nreturn ((self):add_step_in_(aStatement,action,aContext))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"add:in:",0
,function(self,aStatement,aContext)
return ((self):add_steps_in_(aStatement,(aStatement):actionsIn_(aContext),aContext));
end
,"execute","add: aStatement in: aContext\r\n\t\" Add steps to simulate aStatement in current method with aContext. \"\r\n\r\n\t^self\tadd: aStatement\r\n\t\tsteps: (aStatement actionsIn: aContext)\r\n\t\tin: aContext","function(self,aStatement,aContext)\r\nreturn ((self):add_steps_in_(aStatement,(aStatement):actionsIn_(aContext),aContext));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"activateMethod:in:",0
,function(self,aFrame,aContext)
if (smalltalk:notNil_((aContext)))==true then (self):triggerEvent_with_("activateMethod:",aFrame);
(aContext):home_(aFrame); end;
return (self);
end
,"activation","activateMethod: aFrame in: aContext\r\n\t\" Private - Activate the method context. \"\r\n\r\n\taContext notNil ifTrue: [\r\n\t\tself triggerEvent: #activateMethod: with: aFrame.\r\n\t\taContext home: aFrame\r\n\t] ","function(self,aFrame,aContext)\r\nif (smalltalk:notNil_((aContext)))==true then (self):triggerEvent_with_(\"activateMethod:\",aFrame);\r\n(aContext):home_(aFrame); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"enter:method:withAll:",0
,function(self,anObject,aMethod,steps)
local tos=nil
(function()
	local _s8_value=((smalltalk.SimulationFrame):for_doing_(aMethod,steps))
	tos=_s8_value
	return _s8_value
end)();
((self):callStack()):addFirst_(tos);
(
function(_s8_rec)
	(_s8_rec):triggerEvent_with_("enter:",aMethod);
	return ((_s8_rec):triggerEvent_with_with_("enter:with:",aMethod,anObject))
end
)(self);
if ((steps):notEmpty())==true then (self):activateMethod_in_(tos,((steps):first()):context()); end;
return (tos);
end
,"execute","enter: anObject method: aMethod withAll: steps\r\n\t\" Private - Activate execution of Method and returns the frame pushed on stack. \"\r\n\r\n\t| tos |\r\n\ttos := SimulationFrame for: aMethod doing: steps.\r\n\tself callStack addFirst: tos.\r\n\tself\ttriggerEvent: #enter: with: aMethod;\r\n\t\ttriggerEvent: #enter:with: with: aMethod with: anObject.\r\n\tsteps notEmpty ifTrue: [\r\n\t\tself activateMethod: tos in: steps first context\r\n\t].\r\n\t^tos ","function(self,anObject,aMethod,steps)\r\nlocal tos=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.SimulationFrame):for_doing_(aMethod,steps))\r\n\ttos=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):callStack()):addFirst_(tos);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):triggerEvent_with_(\"enter:\",aMethod);\r\n\treturn ((_s8_rec):triggerEvent_with_with_(\"enter:with:\",aMethod,anObject))\r\nend\r\n)(self);\r\nif ((steps):notEmpty())==true then (self):activateMethod_in_(tos,((steps):first()):context()); end;\r\nreturn (tos);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"evaluationScript",0
,function(self)
return (((self):scriptCompiler()):evaluationScript());
end
,"private","evaluationScript\r\n\t\" Private - Return the support for skipping method execution. \"\r\n\r\n\t^self scriptCompiler evaluationScript ","function(self)\r\nreturn (((self):scriptCompiler()):evaluationScript());\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"scriptCompilerFor:",0
,function(self,aClass)
local support=nil
(function()
	local _s8_value=((self):scriptCompiler())
	support=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((support),smalltalk.Compiler))==true then return ((aClass):compiler()); end;
return ((support):for_(aClass));
end
,"private","scriptCompilerFor: aClass\r\n\t\" Private - Return the script compiler to use for aClass. \"\r\n\r\n\t| support |\r\n\tsupport := self scriptCompiler.\r\n\tsupport = Compiler ifTrue: [ ^aClass compiler ].\r\n\t^support for: aClass ","function(self,aClass)\r\nlocal support=nil\r\n(function()\r\n\tlocal _s8_value=((self):scriptCompiler())\r\n\tsupport=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((support),smalltalk.Compiler))==true then return ((aClass):compiler()); end;\r\nreturn ((support):for_(aClass));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"compiledScriptFor:",0
,function(self,aMethod)
local script=nil
if (smalltalk:responds_to_((aMethod),("compiledScript")))==true then return ((aMethod):compiledScript()); end;
(function()
	local _s8_value=((aMethod):basicAt_ifAbsentPut_("s8_compiledScript",(function()
return (((self):scriptCompilerFor_((aMethod):classField())):scriptForMethod_onError_((aMethod):source(),(function()
return ("none")
end)))
end)))
	script=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((script),"none")),nil,(function()
return (script)
end)));
end
,"private","compiledScriptFor: aMethod\r\n\t\" Private - Returns the compiled script of aMethod (or nil). \"\r\n\r\n\t| script |\r\n\t(aMethod respondsTo: #compiledScript)\r\n\t\tifTrue: [ ^aMethod compiledScript ].\r\n\r\n\tscript := aMethod basicAt: #s8_compiledScript ifAbsentPut: [\r\n\t\t(self scriptCompilerFor: aMethod classField)\r\n\t\t\tscriptForMethod: aMethod source\r\n\t\t\tonError: [ #none ]\r\n\t].\r\n\t^script = #none ifFalse: [ script ] ","function(self,aMethod)\r\nlocal script=nil\r\nif (smalltalk:responds_to_((aMethod),(\"compiledScript\")))==true then return ((aMethod):compiledScript()); end;\r\n(function()\r\n\tlocal _s8_value=((aMethod):basicAt_ifAbsentPut_(\"s8_compiledScript\",(function()\r\nreturn (((self):scriptCompilerFor_((aMethod):classField())):scriptForMethod_onError_((aMethod):source(),(function()\r\nreturn (\"none\")\r\nend)))\r\nend)))\r\n\tscript=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((script),\"none\")),nil,(function()\r\nreturn (script)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"callMethod:for:withArguments:",0
,function(self,aMethod,anObject,array)
local steps=nil
local mth=nil
if (smalltalk:isNil_((aMethod)))==true then return ((self):error_("Missing method")); end;
(function()
	local _s8_value=((self):compiledScriptFor_(aMethod))
	mth=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((mth)))==true then local script=nil
(function()
	local _s8_value=((mth):script())
	script=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:notNil_((script))),(function()
return ((function()
	local _s8_value=((script):stepsFor_entering_withArguments_(anObject,mth,array))
	steps=_s8_value
	return _s8_value
end)())
end),nil); end;
if (smalltalk:isNil_((steps)))==true then (function()
	local _s8_value=((self):stepsOver_for_withArguments_(aMethod,anObject,array))
	steps=_s8_value
	return _s8_value
end)(); end;
((self):enter_method_withAll_(anObject,aMethod,steps)):receiver_values_(anObject,array);
return (self);
end
,"execute","callMethod: aMethod for: anObject withArguments: array\r\n\t\" Call aMethod for anObject with given arguments. \"\r\n\r\n\t| steps mth |\r\n\taMethod isNil ifTrue: [ ^self error: 'Missing method' ].\r\n\tmth := self compiledScriptFor: aMethod.\r\n\tmth notNil ifTrue: [ | script |\r\n\t\tscript := mth script.\r\n\t\tscript notNil ifTrue: [\r\n\t\t\tsteps := script\r\n\t\t\t\tstepsFor: anObject entering: mth\r\n\t\t\t\twithArguments: array.\r\n\t\t].\r\n\t].\r\n\tsteps isNil ifTrue: [\r\n\t\tsteps := self\r\n\t\t\tstepsOver: aMethod for: anObject\r\n\t\t\twithArguments: array.\r\n\t].\r\n\t(self enter: anObject method: aMethod withAll: steps)\r\n\t\treceiver: anObject values: array ","function(self,aMethod,anObject,array)\r\nlocal steps=nil\r\nlocal mth=nil\r\nif (smalltalk:isNil_((aMethod)))==true then return ((self):error_(\"Missing method\")); end;\r\n(function()\r\n\tlocal _s8_value=((self):compiledScriptFor_(aMethod))\r\n\tmth=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((mth)))==true then local script=nil\r\n(function()\r\n\tlocal _s8_value=((mth):script())\r\n\tscript=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:notNil_((script))),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=((script):stepsFor_entering_withArguments_(anObject,mth,array))\r\n\tsteps=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),nil); end;\r\nif (smalltalk:isNil_((steps)))==true then (function()\r\n\tlocal _s8_value=((self):stepsOver_for_withArguments_(aMethod,anObject,array))\r\n\tsteps=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n((self):enter_method_withAll_(anObject,aMethod,steps)):receiver_values_(anObject,array);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"stepsOver:for:withArguments:",0
,function(self,aMethod,aReceiver,array)
local script=nil
(array):do_((function(each)
return (smalltalk:if_true_false_((smalltalk:boolean_and_(((self):isObject_(each)),(function()
return (smalltalk:boolean_and_(((each):isMemberOf_(smalltalk.SimulationBlock)),(function()
return (((aMethod):messages()):includes_("callableOf:"))
end)))
end))),(function()
return ((self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Step in method calling block "),(each):asLiteral())),"\r\n\tMethod ")),aMethod))," needs edition to run.\r\n\tEdit inline expressions to avoid block activations")))
end),nil))
end));
(function()
	local _s8_value=(((self):evaluationScript()):doing_((function(simulator)
return ((aReceiver):basicPerform_withArguments_(((aMethod):selector()):asSelector(),array))
end)))
	script=_s8_value
	return _s8_value
end)();
return ((script):stepsFor_entering_withArguments_(aReceiver,aMethod,array));
end
,"execute","stepsOver: aMethod for: aReceiver withArguments: array\r\n\t\" Private - The method do not have a script to evaluate.\r\n\tReturn the steps to execute the method without entering script.\r\n\t\"\r\n\r\n\t| script |\r\n\tarray do: [:each| ((self isObject: each) and: [\r\n\t\t(each isMemberOf: SimulationBlock) and: [\r\n\t\taMethod messages includes: #callableOf: ]]) ifTrue: [\r\n\t\t\tself note: 'Step in method calling block ' ,each asLiteral ,'\r\n\tMethod ' ,aMethod ,' needs edition to run.\r\n\tEdit inline expressions to avoid block activations'\r\n\t] ].\r\n\r\n\tscript := self evaluationScript doing: [:simulator|\r\n\t\taReceiver\r\n\t\t\tbasicPerform: aMethod selector asSelector\r\n\t\t\twithArguments: array\r\n\t].\r\n\t^script stepsFor: aReceiver entering: aMethod withArguments: array ","function(self,aMethod,aReceiver,array)\r\nlocal script=nil\r\n(array):do_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_(((self):isObject_(each)),(function()\r\nreturn (smalltalk:boolean_and_(((each):isMemberOf_(smalltalk.SimulationBlock)),(function()\r\nreturn (((aMethod):messages()):includes_(\"callableOf:\"))\r\nend)))\r\nend))),(function()\r\nreturn ((self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Step in method calling block \"),(each):asLiteral())),\"\\r\\n\\tMethod \")),aMethod)),\" needs edition to run.\\r\\n\\tEdit inline expressions to avoid block activations\")))\r\nend),nil))\r\nend));\r\n(function()\r\n\tlocal _s8_value=(((self):evaluationScript()):doing_((function(simulator)\r\nreturn ((aReceiver):basicPerform_withArguments_(((aMethod):selector()):asSelector(),array))\r\nend)))\r\n\tscript=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((script):stepsFor_entering_withArguments_(aReceiver,aMethod,array));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"shortcut:message:for:withArguments:",0
,function(self,aClass,selector,anObject,values)
local pool=nil
local pair=nil
if not (((self):isObject_(anObject)))==true then return (nil); end;
(function()
	local _s8_value=((self):shortcuts())
	pool=_s8_value
	return _s8_value
end)();
if ((pool):isEmpty())==true then (self):triggerEvent_with_("getShortcuts:",pool);
smalltalk:if_true_false_(((pool):isEmpty()),(function()
return ((self):registerDefaultShortcuts())
end),nil); end;
(function()
	local _s8_value=((smalltalk.Array):with_with_(anObject,values))
	pair=_s8_value
	return _s8_value
end)();
return ((((pool):at_ifAbsent_(selector,(function()
return (smalltalk:newArray({}))
end))):detect_ifNone_((function(assoc)
return (((assoc):key()):evaluateWithArguments_(pair))
end),(function()
return (("halt"):_minus_gt(nil))
end))):value());
end
,"shortcuts","shortcut: aClass message: selector for: anObject withArguments: values\r\n\t\" Private - Returns an action to handle an optimized message send (or nil). \"\r\n\r\n\t| pool pair |\r\n\t(self isObject: anObject) ifFalse: [ ^nil ].\r\n\tpool := self shortcuts.\r\n\tpool isEmpty ifTrue: [\r\n\t\tself triggerEvent: #getShortcuts: with: pool.\r\n\t\tpool isEmpty ifTrue: [ self registerDefaultShortcuts ].\r\n\t].\r\n\tpair := Array with: anObject with: values.\r\n\t^((pool at: selector ifAbsent: [#()])\r\n\t \tdetect: [:assoc| assoc key evaluateWithArguments: pair ]\r\n\t\tifNone: [ #halt -> nil ]) value ","function(self,aClass,selector,anObject,values)\r\nlocal pool=nil\r\nlocal pair=nil\r\nif not (((self):isObject_(anObject)))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((self):shortcuts())\r\n\tpool=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((pool):isEmpty())==true then (self):triggerEvent_with_(\"getShortcuts:\",pool);\r\nsmalltalk:if_true_false_(((pool):isEmpty()),(function()\r\nreturn ((self):registerDefaultShortcuts())\r\nend),nil); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_with_(anObject,values))\r\n\tpair=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((((pool):at_ifAbsent_(selector,(function()\r\nreturn (smalltalk:newArray({}))\r\nend))):detect_ifNone_((function(assoc)\r\nreturn (((assoc):key()):evaluateWithArguments_(pair))\r\nend),(function()\r\nreturn ((\"halt\"):_minus_gt(nil))\r\nend))):value());\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"break:",0
,function(self,why)
(self):triggerEvent_with_("breakpoint:",why);
(function()
	local _s8_value=("paused")
	self["@state"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"breakpoints","break: why\r\n\t\" Breakpoint hit. \"\r\n\r\n\tself triggerEvent: #breakpoint: with: why.\r\n\tstate := #paused","function(self,why)\r\n(self):triggerEvent_with_(\"breakpoint:\",why);\r\n(function()\r\n\tlocal _s8_value=(\"paused\")\r\n\tself[\"@state\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"testPoint:",0
,function(self,test)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (smalltalk:boolean_or_((smalltalk:isNil_((test))),(function()
return (smalltalk:isObject_equalTo_(((self["@breakpoints"]):size()),0))
end)))==true then return (self); end;
if ((self["@breakpoints"]):includes_(test))==true then return ((self):break_(test)); end;
if (smalltalk:is_kindOf_((test),(smalltalk.Behavior)))==true then (self["@breakpoints"]):do_((function(each)
return (smalltalk:if_true_false_((smalltalk:boolean_or_((smalltalk:boolean_and_(((each):isArray()),(function()
return ((each):includes_(test))
end))),(function()
return (smalltalk:boolean_and_((smalltalk:is_kindOf_((each),(smalltalk.Behavior))),(function()
return ((test):inheritsFrom_(each))
end)))
end))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):break_(test))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)(); end;
if ((test):isString())==true then (self["@breakpoints"]):do_((function(each)
return (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:boolean_and_(((each):isString()),(function()
return ((each):endsWith_("*"))
end))),(function()
return ((test):startsWith_((each):upTo_("*")))
end))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):break_(test))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end)); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"breakpoints","testPoint: test\r\n\t\" Private - Test matching of a breakpoint. \"\r\n\r\n\t(test isNil or: [breakpoints size = 0]) ifTrue: [ ^self ].\r\n\t(breakpoints includes: test) ifTrue: [ ^self break: test ]. \"method selector or cls\"\r\n\t(test isKindOf: Behavior) ifTrue: [\r\n\t\tbreakpoints do: [:each|\r\n\t\t\t((each isArray and: [each includes: test]) \"#(cls1 cls2 cls3)\"\r\n\t\t\tor: [ (each isKindOf: Behavior) and: [ test inheritsFrom: each ]]) \"cls w/subclasses\"\r\n\t\t\tifTrue: [ ^self break: test ].\r\n\t\t].\t^self\r\n\t].\r\n\ttest isString ifTrue: [\r\n\t\tbreakpoints do: [:each| \"sel*\"\r\n\t\t\t((each isString and: [each endsWith: $*])\r\n\t\t\tand: [test startsWith: (each upTo: $*)]) ifTrue: [\r\n\t\t\t\t^self break: test\r\n\t\t\t]\r\n\t\t]\r\n\t]","function(self,test)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (smalltalk:boolean_or_((smalltalk:isNil_((test))),(function()\r\nreturn (smalltalk:isObject_equalTo_(((self[\"@breakpoints\"]):size()),0))\r\nend)))==true then return (self); end;\r\nif ((self[\"@breakpoints\"]):includes_(test))==true then return ((self):break_(test)); end;\r\nif (smalltalk:is_kindOf_((test),(smalltalk.Behavior)))==true then (self[\"@breakpoints\"]):do_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_or_((smalltalk:boolean_and_(((each):isArray()),(function()\r\nreturn ((each):includes_(test))\r\nend))),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:is_kindOf_((each),(smalltalk.Behavior))),(function()\r\nreturn ((test):inheritsFrom_(each))\r\nend)))\r\nend))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):break_(test))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\nif ((test):isString())==true then (self[\"@breakpoints\"]):do_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:boolean_and_(((each):isString()),(function()\r\nreturn ((each):endsWith_(\"*\"))\r\nend))),(function()\r\nreturn ((test):startsWith_((each):upTo_(\"*\")))\r\nend))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):break_(test))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend)); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"activateBasic:message:withArguments:",0
,function(self,anObject,selector,values)
if (smalltalk:is_kindOf_((anObject),(smalltalk.SimulationBlock)))==true then (self):value_((anObject):perform_withArguments_(selector,values));
return (true); end;
if (smalltalk:isObject_equalTo_((selector),"halt"))==true then (
function(_s8_rec)
	(_s8_rec):value_(anObject);
	return ((_s8_rec):pause())
end
)(self);
return (true); end;
if (smalltalk:isObject_equalTo_((selector),"||"))==true then (self):value_(((anObject) or (values):first()));
return (true); end;
return (false);
end
,"execute","activateBasic: anObject message: selector withArguments: values\r\n\t\" Private - Returns true if selector sent to anObject has been activated as basic message sent. \"\r\n\r\n\t(anObject isKindOf: SimulationBlock) ifTrue: [\r\n\t\tself value: (anObject\r\n\t\t\tperform: selector\r\n\t\t\twithArguments: values).\r\n\t\t^true\r\n\t].\r\n\tselector = #halt ifTrue: [\r\n\t\tself value: anObject; pause.\r\n\t\t^true\r\n\t].\r\n\tselector = #|| ifTrue: [\r\n\t\tself value: anObject || values first.\r\n\t\t^true\r\n\t].\r\n\t^false","function(self,anObject,selector,values)\r\nif (smalltalk:is_kindOf_((anObject),(smalltalk.SimulationBlock)))==true then (self):value_((anObject):perform_withArguments_(selector,values));\r\nreturn (true); end;\r\nif (smalltalk:isObject_equalTo_((selector),\"halt\"))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):value_(anObject);\r\n\treturn ((_s8_rec):pause())\r\nend\r\n)(self);\r\nreturn (true); end;\r\nif (smalltalk:isObject_equalTo_((selector),\"||\"))==true then (self):value_(((anObject) or (values):first()));\r\nreturn (true); end;\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"callNative:message:withArguments:",0
,function(self,anObject,selector,values)
local mth=nil

if (smalltalk:isNil_((mth)))==true then (function()
	local _s8_value=((anObject)[(selector):asSelector()])
	mth=_s8_value
	return _s8_value
end)(); end;
if (smalltalk:boolean_and_((smalltalk:notNil_((mth))),(function()
return (smalltalk:responds_to_((mth),("valueWithArguments:")))
end)))==true then (self):value_((self):callNative_on_withArguments_(mth,anObject,values));
return (true); end;
if not (((self):isObject_(anObject)))==true then return ((self):error_(smalltalk:object_comma_(("Native object DNU "),(selector):asLiteral()))); end;
return (false);
end
,"execute","callNative: anObject message: selector withArguments: values\r\n\t\" Private - Returns true if selector sent to anObject has been activated as native call. \"\r\n\r\n\t| mth |\r\n\t{'self' jl' mth=eval(Symbol(asSelector(selector))) '}.\r\n\tmth isNil ifTrue: [\r\n\t\t\"self note: 'proto-lookup for ',selector asSeletor.\"\r\n\t\tmth := anObject basicAt: selector asSelector.\r\n\t].\r\n\t(mth notNil and: [ mth respondsTo: #valueWithArguments: ]) ifTrue: [\r\n\t\tself value: (self callNative: mth on: anObject withArguments: values).\r\n\t\t^true\r\n\t].\r\n\t(self isObject: anObject) ifFalse: [\r\n\t\t^self error: 'Native object DNU ' ,selector asLiteral\r\n\t].\r\n\t^false","function(self,anObject,selector,values)\r\nlocal mth=nil\r\n\r\nif (smalltalk:isNil_((mth)))==true then (function()\r\n\tlocal _s8_value=((anObject)[(selector):asSelector()])\r\n\tmth=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((mth))),(function()\r\nreturn (smalltalk:responds_to_((mth),(\"valueWithArguments:\")))\r\nend)))==true then (self):value_((self):callNative_on_withArguments_(mth,anObject,values));\r\nreturn (true); end;\r\nif not (((self):isObject_(anObject)))==true then return ((self):error_(smalltalk:object_comma_((\"Native object DNU \"),(selector):asLiteral()))); end;\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"activateNative:message:withArguments:",0
,function(self,anObject,selector,values)
return ((self):triggerEvent_with_ifNotHandled_("activateNative:",(smalltalk.Message):receiver_selector_arguments_(anObject,selector,values),(function()
return ((self):callNative_message_withArguments_(anObject,selector,values))
end)));
end
,"execute","activateNative: anObject message: selector withArguments: values\r\n\t\" Private - Returns true if selector sent to anObject has been activated as native call. \"\r\n\r\n\t^self\r\n\t\ttriggerEvent: #activateNative:\r\n\t\twith: (Message receiver: anObject selector: selector arguments: values)\r\n\t\tifNotHandled: [\r\n\t\t\tself callNative: anObject message: selector withArguments: values\r\n\t\t] ","function(self,anObject,selector,values)\r\nreturn ((self):triggerEvent_with_ifNotHandled_(\"activateNative:\",(smalltalk.Message):receiver_selector_arguments_(anObject,selector,values),(function()\r\nreturn ((self):callNative_message_withArguments_(anObject,selector,values))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"callDNU:message:withArguments:",0
,function(self,anObject,selector,values)
local mth=nil
local array=nil
(function()
	local _s8_value=(((anObject)["$klass"]):_gt_gt_gt("dnu:withArguments:"))
	mth=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((mth)))==true then (function()
	local _s8_value=(((anObject)["$klass"]):_gt_gt_gt("doesNotUnderstand:"))
	mth=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.Array):with_(selector))
	array=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=((smalltalk.Array):with_with_(selector,values))
	array=_s8_value
	return _s8_value
end)(); end;
(self):callMethod_for_withArguments_(mth,anObject,array);
return (self);
end
,"execute","callDNU: anObject message: selector withArguments: values\r\n\t\" Private - Call DNU error condition. \"\r\n\r\n\t| mth array |\r\n\tmth := anObject class >>> #dnu:withArguments:.\r\n\tmth isNil ifTrue: [\r\n\t\tmth := anObject class >>> #doesNotUnderstand:.\r\n\t\tarray := Array with: selector.\r\n\t] ifFalse: [\r\n\t\tarray := Array with: selector with: values\r\n\t].\r\n\tself callMethod: mth for: anObject withArguments: array ","function(self,anObject,selector,values)\r\nlocal mth=nil\r\nlocal array=nil\r\n(function()\r\n\tlocal _s8_value=(((anObject)[\"$klass\"]):_gt_gt_gt(\"dnu:withArguments:\"))\r\n\tmth=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((mth)))==true then (function()\r\n\tlocal _s8_value=(((anObject)[\"$klass\"]):_gt_gt_gt(\"doesNotUnderstand:\"))\r\n\tmth=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_(selector))\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=((smalltalk.Array):with_with_(selector,values))\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(self):callMethod_for_withArguments_(mth,anObject,array);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"activate:message:for:withArguments:",0
,function(self,aClass,selector,anObject,values)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local mth=nil
(self):testPoint_(smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isNil_((aClass))),(function()
return ((self):isObject_(anObject))
end))),(function()
return ((anObject)["$klass"])
end),(function()
return (aClass)
end)));
(self):testPoint_(selector);
if ((self):activateBasic_message_withArguments_(anObject,selector,values))==true then return (self); end;
if (smalltalk:notNil_((aClass)))==true then (function()
	local _s8_value=((self):shortcut_message_for_withArguments_(aClass,selector,anObject,values))
	mth=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((mth)))==true then return ((mth):evaluateWithArguments_((smalltalk.Array):with_with_with_with_(anObject,selector,values,aClass))); end;
(function()
	local _s8_value=((aClass):_gt_gt_gt(selector))
	mth=_s8_value
	return _s8_value
end)(); end;
if (smalltalk:boolean_and_((smalltalk:notNil_((aClass))),(function()
return (smalltalk:isNil_((mth)))
end)))==true then smalltalk:if_true_false_(((self):activateNative_message_withArguments_(anObject,selector,values)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
if (smalltalk:isNil_((mth)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):callDNU_message_withArguments_(anObject,selector,values))
end
)()
error(_s8Ret_,0)
end)(); end;
(self):testPoint_(mth);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):callMethod_for_withArguments_(mth,anObject,values))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"execute","activate: aClass message: selector for: anObject withArguments: values\r\n\t\" Activate a method context simulation for sending message to anObject with given arguments. \"\r\n\r\n\t| mth |\r\n\tself testPoint: ((aClass isNil and: [self isObject: anObject])\r\n\t\tifTrue: [ anObject class ] ifFalse: [aClass]).\r\n\tself testPoint: selector.\r\n\t(self\tactivateBasic: anObject\r\n\t\tmessage: selector withArguments: values)\r\n\t\tifTrue: [ ^self ].\r\n\taClass notNil ifTrue: [\r\n\t\tmth := self shortcut: aClass message: selector for: anObject withArguments: values.\r\n\t\tmth notNil ifTrue: [\r\n\t\t\t^mth evaluateWithArguments: (Array\r\n\t\t\t\twith: anObject with: selector\r\n\t\t\t\twith: values with: aClass)\r\n\t\t].\r\n\t\tmth := aClass >>> selector.\r\n\t].\r\n\t(aClass notNil and: [mth isNil]) ifTrue: [\r\n\t\t(self\tactivateNative: anObject\r\n\t\t\tmessage: selector withArguments: values)\r\n\t\t\tifTrue: [ ^self ]\r\n\t].\r\n\tmth isNil ifTrue: [\r\n\t\t^self\tcallDNU: anObject\r\n\t\t\tmessage: selector\r\n\t\t\twithArguments: values\r\n\t].\r\n\tself testPoint: mth.\r\n\t^self callMethod: mth for: anObject withArguments: values ","function(self,aClass,selector,anObject,values)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal mth=nil\r\n(self):testPoint_(smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isNil_((aClass))),(function()\r\nreturn ((self):isObject_(anObject))\r\nend))),(function()\r\nreturn ((anObject)[\"$klass\"])\r\nend),(function()\r\nreturn (aClass)\r\nend)));\r\n(self):testPoint_(selector);\r\nif ((self):activateBasic_message_withArguments_(anObject,selector,values))==true then return (self); end;\r\nif (smalltalk:notNil_((aClass)))==true then (function()\r\n\tlocal _s8_value=((self):shortcut_message_for_withArguments_(aClass,selector,anObject,values))\r\n\tmth=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((mth)))==true then return ((mth):evaluateWithArguments_((smalltalk.Array):with_with_with_with_(anObject,selector,values,aClass))); end;\r\n(function()\r\n\tlocal _s8_value=((aClass):_gt_gt_gt(selector))\r\n\tmth=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((aClass))),(function()\r\nreturn (smalltalk:isNil_((mth)))\r\nend)))==true then smalltalk:if_true_false_(((self):activateNative_message_withArguments_(anObject,selector,values)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\nif (smalltalk:isNil_((mth)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):callDNU_message_withArguments_(anObject,selector,values))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(self):testPoint_(mth);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):callMethod_for_withArguments_(mth,anObject,values))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"callNativeLua:on:withArguments:",0
,function(self,evaluable,anObject,values)
return ((evaluable):valueWithArguments_(smalltalk:object_comma_(((smalltalk.Array):with_(anObject)),values)));
end
,"execute","callNativeLua: evaluable on: anObject withArguments: values\r\n\t\" Private - Returns the result of evaluating an evaluable function on anObject. \"\r\n\r\n\t^evaluable valueWithArguments: (Array with: anObject) ,values","function(self,evaluable,anObject,values)\r\nreturn ((evaluable):valueWithArguments_(smalltalk:object_comma_(((smalltalk.Array):with_(anObject)),values)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"callNativeJulia:on:withArguments:",0
,function(self,evaluable,anObject,values)
if (smalltalk:boolean_and_((smalltalk:isNil_((anObject))),(function()
return ((evaluable):isMemberOf_(smalltalk.BlockClosure))
end)))==true then return ((function() self:invalidMessage_("callNativeJulia:on:withArguments:") end)()); end;
(self):note_(smalltalk:object_comma_(("[S8Simulator] native-oo call with "),(values):asLiteral()));
return ((evaluable):valueWithArguments_(smalltalk:object_comma_(((smalltalk.Array):with_(anObject)),values)));
end
,"execute","callNativeJulia: evaluable on: anObject withArguments: values\r\n\t\" Private - Returns the result of evaluating an evaluable function on anObject. \"\r\n\r\n\t(anObject isNil and: [evaluable isMemberOf: BlockClosure]) ifTrue: [\r\n\t\t^{'' jl'evaluable(handle(values)...)'}\r\n\t].\r\n\r\n\"DEBUG-\"\tself note: '[S8Simulator] native-oo call with ',values asLiteral.\r\n\t^evaluable valueWithArguments: (Array with: anObject) ,values","function(self,evaluable,anObject,values)\r\nif (smalltalk:boolean_and_((smalltalk:isNil_((anObject))),(function()\r\nreturn ((evaluable):isMemberOf_(smalltalk.BlockClosure))\r\nend)))==true then return ((function() self:invalidMessage_(\"callNativeJulia:on:withArguments:\") end)()); end;\r\n(self):note_(smalltalk:object_comma_((\"[S8Simulator] native-oo call with \"),(values):asLiteral()));\r\nreturn ((evaluable):valueWithArguments_(smalltalk:object_comma_(((smalltalk.Array):with_(anObject)),values)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"callNative:on:withArguments:",0
,function(self,evaluable,anObject,values)
if (smalltalk:isObject_equalTo_(((self):nativeLanguage()),"lua"))==true then return ((self):callNativeLua_on_withArguments_(evaluable,anObject,values)); end;
if (smalltalk:isObject_equalTo_(((self):nativeLanguage()),"jl"))==true then return ((self):callNativeJulia_on_withArguments_(evaluable,anObject,values)); end;
return ((evaluable):valueWithArguments_(values));
end
,"execute","callNative: evaluable on: anObject withArguments: values\r\n\t\" Private - Returns the result of evaluating an evaluable function on anObject.\r\n\te.g.\tSmalltalk current classes\r\n\tsee also\tBehavior>>#allSubclassesDo:\r\n\t\"\r\n\r\n\tself nativeLanguage = #lua ifTrue: [ \"transform to a lua oo call\"\r\n\t\t^self callNativeLua: evaluable on: anObject withArguments: values\r\n\t].\r\n\tself nativeLanguage = #jl ifTrue: [\r\n\t\t^self callNativeJulia: evaluable on: anObject withArguments: values\r\n\t].\r\n\t^evaluable valueWithArguments: values","function(self,evaluable,anObject,values)\r\nif (smalltalk:isObject_equalTo_(((self):nativeLanguage()),\"lua\"))==true then return ((self):callNativeLua_on_withArguments_(evaluable,anObject,values)); end;\r\nif (smalltalk:isObject_equalTo_(((self):nativeLanguage()),\"jl\"))==true then return ((self):callNativeJulia_on_withArguments_(evaluable,anObject,values)); end;\r\nreturn ((evaluable):valueWithArguments_(values));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"send:to:withArguments:",0
,function(self,selector,anObject,values)
return ((self):activate_message_for_withArguments_((anObject)["$klass"],selector,anObject,values));
end
,"execute","send: selector to: anObject withArguments: values\r\n\t\" Add message send to anObject with given arguments. \"\r\n\r\n\t^self\tactivate: anObject class message: selector\r\n\t\tfor: anObject withArguments: values ","function(self,selector,anObject,values)\r\nreturn ((self):activate_message_for_withArguments_((anObject)[\"$klass\"],selector,anObject,values));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"repeat:while:doing:then:",0
,function(self,aSimulationBlock,condition,action,epilogue)
(self):add_step_in_((aSimulationBlock):node(),(function()
return (smalltalk:if_true_false_(((condition):value()),(function()
(self):add_step_in_((aSimulationBlock):node(),(function()
(self):triggerEvent_with_("aboutToLoop:",aSimulationBlock);return ((self):repeat_while_doing_then_(aSimulationBlock,condition,action,epilogue))
end),(aSimulationBlock):context());return ((self):add_step_in_((aSimulationBlock):node(),(function()
return (smalltalk:if_true_false_((smalltalk:notNil_((action))),(function()
return ((action):value())
end),nil))
end),(aSimulationBlock):context()))
end),(function()
return ((epilogue):value())
end)))
end),(aSimulationBlock):context());
(aSimulationBlock):value();
return (self);
end
,"execute","repeat: aSimulationBlock while: condition doing: action then: epilogue\r\n\t\" Private - Execute evaluations in a loop. \"\r\n\r\n\tself add: aSimulationBlock node step: [\r\n\t\tcondition value ifTrue: [\r\n\t\t\tself add: aSimulationBlock node step: [\r\n\t\t\t\tself triggerEvent: #aboutToLoop: with: aSimulationBlock.\r\n\t\t\t\tself repeat: aSimulationBlock while: condition doing: action then: epilogue\r\n\t\t\t] in: aSimulationBlock context.\r\n\t\t\tself add: aSimulationBlock node step: [\r\n\t\t\t\taction notNil ifTrue: [ action value ].\r\n\t\t\t] in: aSimulationBlock context.\r\n\t\t] ifFalse: [ epilogue value ]\r\n\t] in: aSimulationBlock context.\r\n\taSimulationBlock value ","function(self,aSimulationBlock,condition,action,epilogue)\r\n(self):add_step_in_((aSimulationBlock):node(),(function()\r\nreturn (smalltalk:if_true_false_(((condition):value()),(function()\r\n(self):add_step_in_((aSimulationBlock):node(),(function()\r\n(self):triggerEvent_with_(\"aboutToLoop:\",aSimulationBlock);return ((self):repeat_while_doing_then_(aSimulationBlock,condition,action,epilogue))\r\nend),(aSimulationBlock):context());return ((self):add_step_in_((aSimulationBlock):node(),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((action))),(function()\r\nreturn ((action):value())\r\nend),nil))\r\nend),(aSimulationBlock):context()))\r\nend),(function()\r\nreturn ((epilogue):value())\r\nend)))\r\nend),(aSimulationBlock):context());\r\n(aSimulationBlock):value();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"ignoreShortcuts",0
,function(self)
local pool=nil
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	pool=_s8_value
	return _s8_value
end)();
(pool):at_put_("halt",smalltalk:newArray({}));
(self):shortcuts_(pool);
return (self);
end
,"shortcuts","ignoreShortcuts\r\n\t\" Private - Set the receiver to do NOT use shortcuts. \"\r\n\r\n\t| pool |\r\n\tpool := PoolDictionary new.\r\n\tpool at: #halt put: #().\r\n\tself shortcuts: pool ","function(self)\r\nlocal pool=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tpool=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(pool):at_put_(\"halt\",smalltalk:newArray({}));\r\n(self):shortcuts_(pool);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"useShortcuts",0
,function(self)
(self):shortcuts_(nil);
return (self);
end
,"shortcuts","useShortcuts\r\n\t\" Private - Set the receiver to use shortcuts. \"\r\n\r\n\tself shortcuts: nil ","function(self)\r\n(self):shortcuts_(nil);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"register:shortcut:",0
,function(self,selector,assoc)
(((self):shortcuts()):at_ifAbsentPut_(selector,(function()
return (smalltalk:newArray({}))
end))):add_(assoc);
return (self);
end
,"shortcuts","register: selector shortcut: assoc\r\n\t\" Private - Register the shortcut for selector with assoc. \"\r\n\r\n\t(self shortcuts\r\n\t\tat: selector ifAbsentPut: [#()])\r\n\t\tadd: assoc ","function(self,selector,assoc)\r\n(((self):shortcuts()):at_ifAbsentPut_(selector,(function()\r\nreturn (smalltalk:newArray({}))\r\nend))):add_(assoc);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"registerInlined:",0
,function(self,messages)
(messages):do_((function(selector)
return ((self):register_shortcut_(selector,((function(receiver,args)
return (smalltalk:responds_to_((receiver),(selector)))
end)):_minus_gt((function(receiver,selector,args,cls)
return ((self):value_((receiver):perform_withArguments_(selector,args)))
end))))
end));
return (self);
end
,"shortcuts","registerInlined: messages\r\n\t\" Private - Register messages to be inlined. \"\r\n\r\n\tmessages do: [:selector|\r\n\t\tself register: selector shortcut:\r\n\t\t\t[:receiver :args| receiver respondsTo: selector ]\r\n\t\t\t-> [:receiver :selector :args :cls|\r\n\t\t\t\tself value: (receiver perform: selector withArguments: args)\r\n\t\t\t]\r\n\t] ","function(self,messages)\r\n(messages):do_((function(selector)\r\nreturn ((self):register_shortcut_(selector,((function(receiver,args)\r\nreturn (smalltalk:responds_to_((receiver),(selector)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nreturn ((self):value_((receiver):perform_withArguments_(selector,args)))\r\nend))))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"registerInlined:for:",0
,function(self,messages,classOrArray)
local test=nil
if ((classOrArray):isClass())==true then (function()
	local _s8_value=((function(receiver,args)
return (smalltalk:is_kindOf_((receiver),(classOrArray)))
end))
	test=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=((function(receiver,args)
return (smalltalk:notNil_(((classOrArray):detect_ifNone_((function(cls)
return (smalltalk:is_kindOf_((receiver),(cls)))
end),(function()
return (nil)
end)))))
end))
	test=_s8_value
	return _s8_value
end)(); end;
(messages):do_((function(selector)
return ((self):register_shortcut_(selector,(test):_minus_gt((function(receiver,selector,args,cls)
return ((self):value_((receiver):perform_withArguments_(selector,args)))
end))))
end));
return (self);
end
,"shortcuts","registerInlined: messages for: classOrArray\r\n\t\" Private - Register messages to be inlined. \"\r\n\r\n\t| test |\r\n\tclassOrArray isClass ifTrue: [\r\n\t\ttest := [:receiver :args| receiver isKindOf: classOrArray ]\r\n\t] ifFalse: [\r\n\t\ttest := [:receiver :args|\r\n\t\t\t(classOrArray detect: [:cls|\r\n\t\t\t\treceiver isKindOf: cls\r\n\t\t\t] ifNone: []) notNil\r\n\t\t]\r\n\t\t\r\n\t].\r\n\tmessages do: [:selector|\r\n\t\tself register: selector shortcut:\r\n\t\t\ttest -> [:receiver :selector :args :cls|\r\n\t\t\t\tself value: (receiver perform: selector withArguments: args)\r\n\t\t\t]\r\n\t] ","function(self,messages,classOrArray)\r\nlocal test=nil\r\nif ((classOrArray):isClass())==true then (function()\r\n\tlocal _s8_value=((function(receiver,args)\r\nreturn (smalltalk:is_kindOf_((receiver),(classOrArray)))\r\nend))\r\n\ttest=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=((function(receiver,args)\r\nreturn (smalltalk:notNil_(((classOrArray):detect_ifNone_((function(cls)\r\nreturn (smalltalk:is_kindOf_((receiver),(cls)))\r\nend),(function()\r\nreturn (nil)\r\nend)))))\r\nend))\r\n\ttest=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(messages):do_((function(selector)\r\nreturn ((self):register_shortcut_(selector,(test):_minus_gt((function(receiver,selector,args,cls)\r\nreturn ((self):value_((receiver):perform_withArguments_(selector,args)))\r\nend))))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"registerDefaultShortcuts",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):registerInlined_(smalltalk:newArray({"json", "handle", "size", "asLiteral", "@", "->", "asNativeSelector", "toString"}));
	(_s8_rec):register_shortcut_("yourself",(true):_minus_gt((function(receiver)
return ((self):value_(receiver))
end)));
	(_s8_rec):register_shortcut_("timesRepeat:",(self):timesRepeatShortcut());
	(_s8_rec):register_shortcut_("do:",(self):doShortcut());
	(_s8_rec):register_shortcut_("reverseDo:",(self):reverseDoShortcut());
	(_s8_rec):register_shortcut_("withIndexDo:",(self):withIndexDoShortcut());
	(_s8_rec):register_shortcut_("to:do:",(self):toDoShortcut());
	(_s8_rec):register_shortcut_("to:by:do:",(self):toByDoShortcut());
	(_s8_rec):register_shortcut_("keysAndValuesDo:",(self):keysAndValuesDoShortcut());
	(_s8_rec):register_shortcut_("ifTrue:",(self):ifTrueShortcut());
	(_s8_rec):register_shortcut_("ifFalse:",(self):ifFalseShortcut());
	(_s8_rec):register_shortcut_("at:ifAbsent:",(self):atIfAbsentShortcut());
	(_s8_rec):register_shortcut_("ifTrue:ifFalse:",(self):ifTrueIfFalseShortcut());
	(_s8_rec):register_shortcut_("ifFalse:ifTrue:",(self):ifFalseIfTrueShortcut());
	(_s8_rec):register_shortcut_("indexOf:ifAbsent:",(self):indexOfIfAbsentShortcut());
	(_s8_rec):register_shortcut_("sorted:",(self):sortedShortcut());
	(_s8_rec):register_shortcut_("sort:",(self):sortShortcut());
	return ((_s8_rec):yourself())
end
)(self);
return (self);
end
,"shortcuts","registerDefaultShortcuts\r\n\t\" Private - Register the default shortcuts. \"\r\n\r\n\tself\tregisterInlined: #(\r\n\t\t\tjson handle size asLiteral\r\n\t\t\t@ -> asNativeSelector\r\n\t\t\ttoString );\r\n\t\tregister: #yourself shortcut: true -> [:receiver | self value: receiver ];\r\n\t\tregister: #timesRepeat: shortcut: self timesRepeatShortcut;\r\n\t\tregister: #do: shortcut: self doShortcut;\r\n\t\tregister: #reverseDo: shortcut: self reverseDoShortcut;\r\n\t\tregister: #withIndexDo: shortcut: self withIndexDoShortcut;\r\n\t\tregister: #to:do: shortcut: self toDoShortcut;\r\n\t\tregister: #to:by:do: shortcut: self toByDoShortcut;\r\n\t\tregister: #keysAndValuesDo: shortcut: self keysAndValuesDoShortcut;\r\n\t\tregister: #ifTrue: shortcut: self ifTrueShortcut;\r\n\t\tregister: #ifFalse: shortcut: self ifFalseShortcut;\r\n\t\tregister: #at:ifAbsent: shortcut: self atIfAbsentShortcut;\r\n\t\tregister: #ifTrue:ifFalse: shortcut: self ifTrueIfFalseShortcut;\r\n\t\tregister: #ifFalse:ifTrue: shortcut: self ifFalseIfTrueShortcut;\r\n\t\tregister: #indexOf:ifAbsent: shortcut: self indexOfIfAbsentShortcut;\r\n\t\tregister: #sorted: shortcut: self sortedShortcut;\r\n\t\tregister: #sort: shortcut: self sortShortcut;\r\n\t\tyourself ","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):registerInlined_(smalltalk:newArray({\"json\", \"handle\", \"size\", \"asLiteral\", \"@\", \"->\", \"asNativeSelector\", \"toString\"}));\r\n\t(_s8_rec):register_shortcut_(\"yourself\",(true):_minus_gt((function(receiver)\r\nreturn ((self):value_(receiver))\r\nend)));\r\n\t(_s8_rec):register_shortcut_(\"timesRepeat:\",(self):timesRepeatShortcut());\r\n\t(_s8_rec):register_shortcut_(\"do:\",(self):doShortcut());\r\n\t(_s8_rec):register_shortcut_(\"reverseDo:\",(self):reverseDoShortcut());\r\n\t(_s8_rec):register_shortcut_(\"withIndexDo:\",(self):withIndexDoShortcut());\r\n\t(_s8_rec):register_shortcut_(\"to:do:\",(self):toDoShortcut());\r\n\t(_s8_rec):register_shortcut_(\"to:by:do:\",(self):toByDoShortcut());\r\n\t(_s8_rec):register_shortcut_(\"keysAndValuesDo:\",(self):keysAndValuesDoShortcut());\r\n\t(_s8_rec):register_shortcut_(\"ifTrue:\",(self):ifTrueShortcut());\r\n\t(_s8_rec):register_shortcut_(\"ifFalse:\",(self):ifFalseShortcut());\r\n\t(_s8_rec):register_shortcut_(\"at:ifAbsent:\",(self):atIfAbsentShortcut());\r\n\t(_s8_rec):register_shortcut_(\"ifTrue:ifFalse:\",(self):ifTrueIfFalseShortcut());\r\n\t(_s8_rec):register_shortcut_(\"ifFalse:ifTrue:\",(self):ifFalseIfTrueShortcut());\r\n\t(_s8_rec):register_shortcut_(\"indexOf:ifAbsent:\",(self):indexOfIfAbsentShortcut());\r\n\t(_s8_rec):register_shortcut_(\"sorted:\",(self):sortedShortcut());\r\n\t(_s8_rec):register_shortcut_(\"sort:\",(self):sortShortcut());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"timesRepeatShortcut",0
,function(self)
return (((function(receiver,args)
return (smalltalk:boolean_and_(((receiver):isNumber()),(function()
return (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))
end)))
end)):_minus_gt((function(receiver,selector,args,cls)
local i=nil
local blk=nil
local loop=nil
(function()
	local _s8_value=((args):last())
	blk=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=(1)
	i=_s8_value
	return _s8_value
end)();(self):add_step_in_("timesRepeat-exit",(function()
return ((self):value_(receiver))
end),nil);(function()
	local _s8_value=((function()
if (((i) < receiver))==true then (self):add_step_in_("timesRepeat-loop",loop,nil); end;(blk):value_(i);return ((function()
	local _s8_value=((i):_plus(1))
	i=_s8_value
	return _s8_value
end)())
end))
	loop=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((((i) <= receiver)),(function()
return ((self):add_step_in_("timesRepeat-loop",loop,nil))
end),nil))
end)));
end
,"shortcuts","timesRepeatShortcut\r\n\t\" Private - Returns the shortcut for the selector. \"\r\n\r\n\t^[:receiver :args|\r\n\t\treceiver isNumber and: [\r\n\t\targs last isKindOf: SimulationBlock ] ]\r\n\t-> [:receiver :selector :args :cls| | i blk loop |\r\n\t\tblk := args last. i := 1.\r\n\t\tself add: #timesRepeat-exit step: [ self value: receiver ] in: nil.\r\n\t\tloop := [ i < receiver ifTrue: [ self add: #timesRepeat-loop step: loop in: nil ].\r\n\t\t\tblk value: i. i := i + 1.\r\n\t\t].\r\n\t\ti <= receiver ifTrue: [ self add: #timesRepeat-loop step: loop in: nil ].\r\n\t] ","function(self)\r\nreturn (((function(receiver,args)\r\nreturn (smalltalk:boolean_and_(((receiver):isNumber()),(function()\r\nreturn (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))\r\nend)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nlocal i=nil\r\nlocal blk=nil\r\nlocal loop=nil\r\n(function()\r\n\tlocal _s8_value=((args):last())\r\n\tblk=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=(1)\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)();(self):add_step_in_(\"timesRepeat-exit\",(function()\r\nreturn ((self):value_(receiver))\r\nend),nil);(function()\r\n\tlocal _s8_value=((function()\r\nif (((i) < receiver))==true then (self):add_step_in_(\"timesRepeat-loop\",loop,nil); end;(blk):value_(i);return ((function()\r\n\tlocal _s8_value=((i):_plus(1))\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend))\r\n\tloop=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((((i) <= receiver)),(function()\r\nreturn ((self):add_step_in_(\"timesRepeat-loop\",loop,nil))\r\nend),nil))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"doShortcut",0
,function(self)
return (((function(receiver,args)
return (smalltalk:boolean_and_((smalltalk:is_kindOf_((receiver),(smalltalk.SequenceableCollection))),(function()
return (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))
end)))
end)):_minus_gt((function(receiver,selector,args,cls)
local i=nil
local to=nil
local blk=nil
local loop=nil
(function()
	local _s8_value=((receiver):size())
	to=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((args):last())
	blk=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=(1)
	i=_s8_value
	return _s8_value
end)();(self):add_step_in_("do-exit",(function()
return ((self):value_(receiver))
end),nil);(function()
	local _s8_value=((function()
if (((i) < to))==true then (self):add_step_in_("do-loop",loop,nil); end;(blk):value_((receiver):at_(i));return ((function()
	local _s8_value=((i):_plus(1))
	i=_s8_value
	return _s8_value
end)())
end))
	loop=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((((i) <= to)),(function()
return ((self):add_step_in_("do-loop",loop,nil))
end),nil))
end)));
end
,"shortcuts","doShortcut\r\n\t\" Private - Returns the shortcut for the selector. \"\r\n\r\n\t^[:receiver :args|\r\n\t\t(receiver isKindOf: SequenceableCollection) and: [\r\n\t\targs last isKindOf: SimulationBlock ] ]\r\n\t-> [:receiver :selector :args :cls| | i to blk loop |\r\n\t\tto := receiver size. blk := args last. i := 1.\r\n\t\tself add: #do-exit step: [ self value: receiver ] in: nil.\r\n\t\tloop := [ i < to ifTrue: [ self add: #do-loop step: loop in: nil ].\r\n\t\t\tblk value: (receiver at: i). i := i + 1.\r\n\t\t].\r\n\t\ti <= to ifTrue: [ self add: #do-loop step: loop in: nil ].\r\n\t] ","function(self)\r\nreturn (((function(receiver,args)\r\nreturn (smalltalk:boolean_and_((smalltalk:is_kindOf_((receiver),(smalltalk.SequenceableCollection))),(function()\r\nreturn (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))\r\nend)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nlocal i=nil\r\nlocal to=nil\r\nlocal blk=nil\r\nlocal loop=nil\r\n(function()\r\n\tlocal _s8_value=((receiver):size())\r\n\tto=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((args):last())\r\n\tblk=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=(1)\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)();(self):add_step_in_(\"do-exit\",(function()\r\nreturn ((self):value_(receiver))\r\nend),nil);(function()\r\n\tlocal _s8_value=((function()\r\nif (((i) < to))==true then (self):add_step_in_(\"do-loop\",loop,nil); end;(blk):value_((receiver):at_(i));return ((function()\r\n\tlocal _s8_value=((i):_plus(1))\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend))\r\n\tloop=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((((i) <= to)),(function()\r\nreturn ((self):add_step_in_(\"do-loop\",loop,nil))\r\nend),nil))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"reverseDoShortcut",0
,function(self)
return (((function(receiver,args)
return (smalltalk:boolean_and_((smalltalk:is_kindOf_((receiver),(smalltalk.SequenceableCollection))),(function()
return (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))
end)))
end)):_minus_gt((function(receiver,selector,args,cls)
local i=nil
local blk=nil
local loop=nil
(function()
	local _s8_value=((receiver):size())
	i=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((args):last())
	blk=_s8_value
	return _s8_value
end)();(self):add_step_in_("reverseDo-exit",(function()
return ((self):value_(receiver))
end),nil);(function()
	local _s8_value=((function()
if (((i) > 1))==true then (self):add_step_in_("reverseDo-loop",loop,nil); end;(blk):value_((receiver):at_(i));return ((function()
	local _s8_value=((i):_minus(1))
	i=_s8_value
	return _s8_value
end)())
end))
	loop=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((((i) > 0)),(function()
return ((self):add_step_in_("reverseDo-loop",loop,nil))
end),nil))
end)));
end
,"shortcuts","reverseDoShortcut\r\n\t\" Private - Returns the shortcut for the selector. \"\r\n\r\n\t^[:receiver :args|\r\n\t\t(receiver isKindOf: SequenceableCollection) and: [\r\n\t\targs last isKindOf: SimulationBlock ] ]\r\n\t-> [:receiver :selector :args :cls| | i blk loop |\r\n\t\ti := receiver size. blk := args last.\r\n\t\tself add: #reverseDo-exit step: [ self value: receiver ] in: nil.\r\n\t\tloop := [ i > 1 ifTrue: [ self add: #reverseDo-loop step: loop in: nil ].\r\n\t\t\tblk value: (receiver at: i). i := i - 1.\r\n\t\t].\r\n\t\ti > 0 ifTrue: [ self add: #reverseDo-loop step: loop in: nil ].\r\n\t] ","function(self)\r\nreturn (((function(receiver,args)\r\nreturn (smalltalk:boolean_and_((smalltalk:is_kindOf_((receiver),(smalltalk.SequenceableCollection))),(function()\r\nreturn (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))\r\nend)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nlocal i=nil\r\nlocal blk=nil\r\nlocal loop=nil\r\n(function()\r\n\tlocal _s8_value=((receiver):size())\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((args):last())\r\n\tblk=_s8_value\r\n\treturn _s8_value\r\nend)();(self):add_step_in_(\"reverseDo-exit\",(function()\r\nreturn ((self):value_(receiver))\r\nend),nil);(function()\r\n\tlocal _s8_value=((function()\r\nif (((i) > 1))==true then (self):add_step_in_(\"reverseDo-loop\",loop,nil); end;(blk):value_((receiver):at_(i));return ((function()\r\n\tlocal _s8_value=((i):_minus(1))\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend))\r\n\tloop=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((((i) > 0)),(function()\r\nreturn ((self):add_step_in_(\"reverseDo-loop\",loop,nil))\r\nend),nil))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"withIndexDoShortcut",0
,function(self)
return (((function(receiver,args)
return (smalltalk:boolean_and_((smalltalk:is_kindOf_((receiver),(smalltalk.SequenceableCollection))),(function()
return (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))
end)))
end)):_minus_gt((function(receiver,selector,args,cls)
local i=nil
local to=nil
local blk=nil
local loop=nil
(function()
	local _s8_value=(1)
	i=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((receiver):size())
	to=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((args):last())
	blk=_s8_value
	return _s8_value
end)();(self):add_step_in_("withIndexDo-exit",(function()
return ((self):value_(receiver))
end),nil);(function()
	local _s8_value=((function()
if (((i) < to))==true then (self):add_step_in_("withIndexDo-loop",loop,nil); end;(blk):value_value_((receiver):at_(i),i);return ((function()
	local _s8_value=((i):_plus(1))
	i=_s8_value
	return _s8_value
end)())
end))
	loop=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((((i) <= to)),(function()
return ((self):add_step_in_("withIndexDo-loop",loop,nil))
end),nil))
end)));
end
,"shortcuts","withIndexDoShortcut\r\n\t\" Private - Returns the shortcut for the selector. \"\r\n\r\n\t^[:receiver :args|\r\n\t\t(receiver isKindOf: SequenceableCollection) and: [\r\n\t\targs last isKindOf: SimulationBlock ] ]\r\n\t-> [:receiver :selector :args :cls| | i to blk loop |\r\n\t\ti := 1. to := receiver size. blk := args last.\r\n\t\tself add: #withIndexDo-exit step: [ self value: receiver ] in: nil.\r\n\t\tloop := [ i < to ifTrue: [ self add: #withIndexDo-loop step: loop in: nil ].\r\n\t\t\tblk value: (receiver at: i) value: i. i := i + 1. \r\n\t\t].\r\n\t\ti <= to ifTrue: [ self add: #withIndexDo-loop step: loop in: nil ].\r\n\t] ","function(self)\r\nreturn (((function(receiver,args)\r\nreturn (smalltalk:boolean_and_((smalltalk:is_kindOf_((receiver),(smalltalk.SequenceableCollection))),(function()\r\nreturn (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))\r\nend)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nlocal i=nil\r\nlocal to=nil\r\nlocal blk=nil\r\nlocal loop=nil\r\n(function()\r\n\tlocal _s8_value=(1)\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((receiver):size())\r\n\tto=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((args):last())\r\n\tblk=_s8_value\r\n\treturn _s8_value\r\nend)();(self):add_step_in_(\"withIndexDo-exit\",(function()\r\nreturn ((self):value_(receiver))\r\nend),nil);(function()\r\n\tlocal _s8_value=((function()\r\nif (((i) < to))==true then (self):add_step_in_(\"withIndexDo-loop\",loop,nil); end;(blk):value_value_((receiver):at_(i),i);return ((function()\r\n\tlocal _s8_value=((i):_plus(1))\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend))\r\n\tloop=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((((i) <= to)),(function()\r\nreturn ((self):add_step_in_(\"withIndexDo-loop\",loop,nil))\r\nend),nil))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"keysAndValuesDoShortcut",0
,function(self)
return (((function(receiver,args)
return (smalltalk:boolean_and_((smalltalk:is_kindOf_((receiver),(smalltalk.KeyedCollection))),(function()
return (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))
end)))
end)):_minus_gt((function(receiver,selector,args,cls)
local keys=nil
local blk=nil
local loop=nil
(function()
	local _s8_value=((((receiver):keys()):asArray()):copy())
	keys=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((args):last())
	blk=_s8_value
	return _s8_value
end)();(self):add_step_in_("keysAndValuesDo-exit",(function()
return ((self):value_(receiver))
end),nil);(function()
	local _s8_value=((function()
if ((((keys):size()) > 1))==true then (self):add_step_in_("keysAndValuesDo-loop",loop,nil); end;return ((blk):value_value_((keys):first(),(receiver):at_((keys):removeFirst())))
end))
	loop=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_(((keys):notEmpty()),(function()
return ((self):add_step_in_("keysAndValuesDo-loop",loop,nil))
end),nil))
end)));
end
,"shortcuts","keysAndValuesDoShortcut\r\n\t\" Private - Returns the shortcut for the selector. \"\r\n\r\n\t^[:receiver :args|\r\n\t\t(receiver isKindOf: KeyedCollection) and: [\r\n\t\targs last isKindOf: SimulationBlock ] ]\r\n\t-> [:receiver :selector :args :cls| | keys blk loop |\r\n\t\tkeys := receiver keys asArray copy. blk := args last.\r\n\t\tself add: #keysAndValuesDo-exit step: [ self value: receiver ] in: nil.\r\n\t\tloop := [ keys size > 1 ifTrue: [ self add: #keysAndValuesDo-loop step: loop in: nil ].\r\n\t\t\tblk value: keys first value: (receiver at: keys removeFirst).\r\n\t\t].\r\n\t\tkeys notEmpty ifTrue: [ self add: #keysAndValuesDo-loop step: loop in: nil ].\r\n\t] ","function(self)\r\nreturn (((function(receiver,args)\r\nreturn (smalltalk:boolean_and_((smalltalk:is_kindOf_((receiver),(smalltalk.KeyedCollection))),(function()\r\nreturn (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))\r\nend)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nlocal keys=nil\r\nlocal blk=nil\r\nlocal loop=nil\r\n(function()\r\n\tlocal _s8_value=((((receiver):keys()):asArray()):copy())\r\n\tkeys=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((args):last())\r\n\tblk=_s8_value\r\n\treturn _s8_value\r\nend)();(self):add_step_in_(\"keysAndValuesDo-exit\",(function()\r\nreturn ((self):value_(receiver))\r\nend),nil);(function()\r\n\tlocal _s8_value=((function()\r\nif ((((keys):size()) > 1))==true then (self):add_step_in_(\"keysAndValuesDo-loop\",loop,nil); end;return ((blk):value_value_((keys):first(),(receiver):at_((keys):removeFirst())))\r\nend))\r\n\tloop=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_(((keys):notEmpty()),(function()\r\nreturn ((self):add_step_in_(\"keysAndValuesDo-loop\",loop,nil))\r\nend),nil))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"toDoShortcut",0
,function(self)
return (((function(receiver,args)
return (smalltalk:boolean_and_(((receiver):isNumber()),(function()
return (smalltalk:boolean_and_((((args):first()):isNumber()),(function()
return (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))
end)))
end)))
end)):_minus_gt((function(receiver,selector,args,cls)
local i=nil
local to=nil
local blk=nil
local loop=nil
(function()
	local _s8_value=((args):first())
	to=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((args):last())
	blk=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=(receiver)
	i=_s8_value
	return _s8_value
end)();(self):add_step_in_("toDo-exit",(function()
return ((self):value_(receiver))
end),nil);(function()
	local _s8_value=((function()
if (((i) < to))==true then (self):add_step_in_("toDo-loop",loop,nil); end;(blk):value_(i);return ((function()
	local _s8_value=((i):_plus(1))
	i=_s8_value
	return _s8_value
end)())
end))
	loop=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((((i) <= to)),(function()
return ((self):add_step_in_("toDo-loop",loop,nil))
end),nil))
end)));
end
,"shortcuts","toDoShortcut\r\n\t\" Private - Returns the shortcut for the selector. \"\r\n\r\n\t^[:receiver :args|\r\n\t\treceiver isNumber and: [\r\n\t\targs first isNumber and: [\r\n\t\targs last isKindOf: SimulationBlock ]] ]\r\n\t-> [:receiver :selector :args :cls| | i to blk loop |\r\n\t\tto := args first. blk := args last. i := receiver.\r\n\t\tself add: #toDo-exit step: [ self value: receiver ] in: nil.\r\n\t\tloop := [ i < to ifTrue: [ self add: #toDo-loop step: loop in: nil ].\r\n\t\t\tblk value: i. i := i + 1.\r\n\t\t].\r\n\t\ti <= to ifTrue: [ self add: #toDo-loop step: loop in: nil ].\r\n\t] ","function(self)\r\nreturn (((function(receiver,args)\r\nreturn (smalltalk:boolean_and_(((receiver):isNumber()),(function()\r\nreturn (smalltalk:boolean_and_((((args):first()):isNumber()),(function()\r\nreturn (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))\r\nend)))\r\nend)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nlocal i=nil\r\nlocal to=nil\r\nlocal blk=nil\r\nlocal loop=nil\r\n(function()\r\n\tlocal _s8_value=((args):first())\r\n\tto=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((args):last())\r\n\tblk=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=(receiver)\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)();(self):add_step_in_(\"toDo-exit\",(function()\r\nreturn ((self):value_(receiver))\r\nend),nil);(function()\r\n\tlocal _s8_value=((function()\r\nif (((i) < to))==true then (self):add_step_in_(\"toDo-loop\",loop,nil); end;(blk):value_(i);return ((function()\r\n\tlocal _s8_value=((i):_plus(1))\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend))\r\n\tloop=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((((i) <= to)),(function()\r\nreturn ((self):add_step_in_(\"toDo-loop\",loop,nil))\r\nend),nil))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"toByDoShortcut",0
,function(self)
return (((function(receiver,args)
return (smalltalk:boolean_and_(((receiver):isNumber()),(function()
return (smalltalk:boolean_and_((((args):first()):isNumber()),(function()
return (smalltalk:boolean_and_((((args):second()):isNumber()),(function()
return (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))
end)))
end)))
end)))
end)):_minus_gt((function(receiver,selector,args,cls)
local i=nil
local to=nil
local increment=nil
local blk=nil
local loop=nil
local min=nil
local max=nil
(function()
	local _s8_value=((args):first())
	to=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((args):second())
	increment=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((args):last())
	blk=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=(receiver)
	i=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((receiver):min_(to))
	min=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((receiver):max_(to))
	max=_s8_value
	return _s8_value
end)();(self):add_step_in_("toByDo-exit",(function()
return ((self):value_(receiver))
end),nil);(function()
	local _s8_value=((function()
if (((i):_plus(increment)):between_and_(min,max))==true then (self):add_step_in_("toByDo-loop",loop,nil); end;(blk):value_(i);return ((function()
	local _s8_value=((i):_plus(increment))
	i=_s8_value
	return _s8_value
end)())
end))
	loop=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:if_true_false_((((increment) > 0)),(function()
return (((i) < to))
end),(function()
return (((i) > to))
end))),(function()
return ((self):add_step_in_("toByDo-loop",loop,nil))
end),nil))
end)));
end
,"shortcuts","toByDoShortcut\r\n\t\" Private - Returns the shortcut for the selector. \"\r\n\r\n\t^[:receiver :args|\r\n\t\treceiver isNumber and: [\r\n\t\targs first isNumber and: [ args second isNumber and: [\r\n\t\targs last isKindOf: SimulationBlock ]]] ]\r\n\t-> [:receiver :selector :args :cls| | i to increment blk loop min max |\r\n\t\tto := args first. increment := args second. blk := args last. i := receiver.\r\n\t\tmin := receiver min: to. max := receiver max: to.\r\n\t\tself add: #toByDo-exit step: [ self value: receiver ] in: nil.\r\n\t\tloop := [\t(i + increment between: min and: max) ifTrue: [\r\n\t\t\t\tself add: #toByDo-loop step: loop in: nil\r\n\t\t\t].\r\n\t\t\tblk value: i. i := i + increment. \r\n\t\t].\r\n\t\t(increment > 0\r\n\t\t\tifTrue: [ i < to ]\r\n\t\t\tifFalse: [ i > to ])\r\n\t\tifTrue: [ self add: #toByDo-loop step: loop in: nil ].\r\n\t] ","function(self)\r\nreturn (((function(receiver,args)\r\nreturn (smalltalk:boolean_and_(((receiver):isNumber()),(function()\r\nreturn (smalltalk:boolean_and_((((args):first()):isNumber()),(function()\r\nreturn (smalltalk:boolean_and_((((args):second()):isNumber()),(function()\r\nreturn (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))\r\nend)))\r\nend)))\r\nend)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nlocal i=nil\r\nlocal to=nil\r\nlocal increment=nil\r\nlocal blk=nil\r\nlocal loop=nil\r\nlocal min=nil\r\nlocal max=nil\r\n(function()\r\n\tlocal _s8_value=((args):first())\r\n\tto=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((args):second())\r\n\tincrement=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((args):last())\r\n\tblk=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=(receiver)\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((receiver):min_(to))\r\n\tmin=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((receiver):max_(to))\r\n\tmax=_s8_value\r\n\treturn _s8_value\r\nend)();(self):add_step_in_(\"toByDo-exit\",(function()\r\nreturn ((self):value_(receiver))\r\nend),nil);(function()\r\n\tlocal _s8_value=((function()\r\nif (((i):_plus(increment)):between_and_(min,max))==true then (self):add_step_in_(\"toByDo-loop\",loop,nil); end;(blk):value_(i);return ((function()\r\n\tlocal _s8_value=((i):_plus(increment))\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend))\r\n\tloop=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:if_true_false_((((increment) > 0)),(function()\r\nreturn (((i) < to))\r\nend),(function()\r\nreturn (((i) > to))\r\nend))),(function()\r\nreturn ((self):add_step_in_(\"toByDo-loop\",loop,nil))\r\nend),nil))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"ifTrueShortcut",0
,function(self)
return (((function(receiver,args)
return (smalltalk:boolean_and_(((type((receiver))=="boolean")),(function()
return (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))
end)))
end)):_minus_gt((function(receiver,selector,args,cls)
return (smalltalk:if_true_false_((((receiver)==true)),(function()
return (((args):last()):value())
end),(function()
return ((self):value_(nil))
end)))
end)));
end
,"shortcuts","ifTrueShortcut\r\n\t\" Private - Returns the shortcut for the selector. \"\r\n\r\n\t^[:receiver :args|\r\n\t\treceiver isBoolean and: [\r\n\t\targs last isKindOf: SimulationBlock ] ]\r\n\t-> [:receiver :selector :args :cls|\r\n\t\treceiver == true\r\n\t\tifTrue: [ args last value ]\r\n\t\tifFalse: [ self value: nil ]\r\n\t] ","function(self)\r\nreturn (((function(receiver,args)\r\nreturn (smalltalk:boolean_and_(((type((receiver))==\"boolean\")),(function()\r\nreturn (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))\r\nend)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nreturn (smalltalk:if_true_false_((((receiver)==true)),(function()\r\nreturn (((args):last()):value())\r\nend),(function()\r\nreturn ((self):value_(nil))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"ifFalseShortcut",0
,function(self)
return (((function(receiver,args)
return (smalltalk:boolean_and_(((type((receiver))=="boolean")),(function()
return (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))
end)))
end)):_minus_gt((function(receiver,selector,args,cls)
return (smalltalk:if_true_false_((((receiver)==false)),(function()
return (((args):last()):value())
end),(function()
return ((self):value_(nil))
end)))
end)));
end
,"shortcuts","ifFalseShortcut\r\n\t\" Private - Returns the shortcut for the selector. \"\r\n\r\n\t^[:receiver :args|\r\n\t\treceiver isBoolean and: [\r\n\t\targs last isKindOf: SimulationBlock ] ]\r\n\t-> [:receiver :selector :args :cls|\r\n\t\treceiver == false\r\n\t\tifTrue: [ args last value ]\r\n\t\tifFalse: [ self value: nil ]\r\n\t] ","function(self)\r\nreturn (((function(receiver,args)\r\nreturn (smalltalk:boolean_and_(((type((receiver))==\"boolean\")),(function()\r\nreturn (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))\r\nend)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nreturn (smalltalk:if_true_false_((((receiver)==false)),(function()\r\nreturn (((args):last()):value())\r\nend),(function()\r\nreturn ((self):value_(nil))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"atIfAbsentShortcut",0
,function(self)
return (((function(receiver,args)
return (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))
end)):_minus_gt((function(receiver,selector,args,cls)
local failed=nil
local result=nil
(function()
	local _s8_value=((smalltalk.Object):new())
	failed=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((receiver):at_ifAbsent_((args):first(),(function()
return (failed)
end)))
	result=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((((failed)==result)),(function()
return ((self):add_step_in_("atIfAbsent-failed",(function()
return (((args):last()):value())
end),nil))
end),(function()
return ((self):value_(result))
end)))
end)));
end
,"shortcuts","atIfAbsentShortcut\r\n\t\" Private - Returns the shortcut for the selector. \"\r\n\r\n\t^[:receiver :args| args last isKindOf: SimulationBlock ]\r\n\t-> [:receiver :selector :args :cls| | failed result |\r\n\t\tfailed := Object new.\r\n\t\tresult := receiver at: args first ifAbsent: [ failed ].\r\n\t\tfailed == result ifTrue: [\r\n\t\t\tself add: #atIfAbsent-failed step: [ args last value ] in: nil\r\n\t\t] ifFalse: [ self value: result ]\r\n\t] ","function(self)\r\nreturn (((function(receiver,args)\r\nreturn (smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nlocal failed=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Object):new())\r\n\tfailed=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((receiver):at_ifAbsent_((args):first(),(function()\r\nreturn (failed)\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((((failed)==result)),(function()\r\nreturn ((self):add_step_in_(\"atIfAbsent-failed\",(function()\r\nreturn (((args):last()):value())\r\nend),nil))\r\nend),(function()\r\nreturn ((self):value_(result))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"ifTrueIfFalseShortcut",0
,function(self)
return (((function(receiver,args)
return (smalltalk:boolean_and_(((type((receiver))=="boolean")),(function()
return (smalltalk:boolean_and_((smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock))),(function()
return (smalltalk:is_kindOf_(((args):first()),(smalltalk.SimulationBlock)))
end)))
end)))
end)):_minus_gt((function(receiver,selector,args,cls)
return (smalltalk:if_true_false_((((receiver)==true)),(function()
return (((args):first()):value())
end),(function()
return (((args):last()):value())
end)))
end)));
end
,"shortcuts","ifTrueIfFalseShortcut\r\n\t\" Private - Returns the shortcut for the selector. \"\r\n\r\n\t^[:receiver :args|\r\n\t\treceiver isBoolean and: [\r\n\t\t(args last isKindOf: SimulationBlock) and: [\r\n\t\targs first isKindOf: SimulationBlock ]] ]\r\n\t-> [:receiver :selector :args :cls|\r\n\t\treceiver == true\r\n\t\tifTrue: [ args first value ]\r\n\t\tifFalse: [ args last value ]\r\n\t] ","function(self)\r\nreturn (((function(receiver,args)\r\nreturn (smalltalk:boolean_and_(((type((receiver))==\"boolean\")),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock))),(function()\r\nreturn (smalltalk:is_kindOf_(((args):first()),(smalltalk.SimulationBlock)))\r\nend)))\r\nend)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nreturn (smalltalk:if_true_false_((((receiver)==true)),(function()\r\nreturn (((args):first()):value())\r\nend),(function()\r\nreturn (((args):last()):value())\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"ifFalseIfTrueShortcut",0
,function(self)
return (((function(receiver,args)
return (smalltalk:boolean_and_(((type((receiver))=="boolean")),(function()
return (smalltalk:boolean_and_((smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock))),(function()
return (smalltalk:is_kindOf_(((args):first()),(smalltalk.SimulationBlock)))
end)))
end)))
end)):_minus_gt((function(receiver,selector,args,cls)
return (smalltalk:if_true_false_((((receiver)==false)),(function()
return (((args):first()):value())
end),(function()
return (((args):last()):value())
end)))
end)));
end
,"shortcuts","ifFalseIfTrueShortcut\r\n\t\" Private - Returns the shortcut for the selector. \"\r\n\r\n\t^[:receiver :args|\r\n\t\treceiver isBoolean and: [\r\n\t\t(args last isKindOf: SimulationBlock) and: [\r\n\t\targs first isKindOf: SimulationBlock ]] ]\r\n\t-> [:receiver :selector :args :cls|\r\n\t\treceiver == false\r\n\t\tifTrue: [ args first value ]\r\n\t\tifFalse: [ args last value ]\r\n\t] ","function(self)\r\nreturn (((function(receiver,args)\r\nreturn (smalltalk:boolean_and_(((type((receiver))==\"boolean\")),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:is_kindOf_(((args):last()),(smalltalk.SimulationBlock))),(function()\r\nreturn (smalltalk:is_kindOf_(((args):first()),(smalltalk.SimulationBlock)))\r\nend)))\r\nend)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nreturn (smalltalk:if_true_false_((((receiver)==false)),(function()\r\nreturn (((args):first()):value())\r\nend),(function()\r\nreturn (((args):last()):value())\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"indexOfIfAbsentShortcut",0
,function(self)
return (((function(receiver,args)
return (smalltalk:is_kindOf_((receiver),(smalltalk.SequenceableCollection)))
end)):_minus_gt((function(receiver,selector,args,cls)
local failed=nil
local result=nil
(function()
	local _s8_value=((smalltalk.Object):new())
	failed=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((receiver):indexOf_ifAbsent_((args):first(),(function()
return (failed)
end)))
	result=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((((failed)==result)),(function()
return ((self):add_step_in_("indexOfIfAbsent-failed",(function()
return (((args):last()):value())
end),nil))
end),(function()
return ((self):value_(result))
end)))
end)));
end
,"shortcuts","indexOfIfAbsentShortcut\r\n\t\" Private - Returns the shortcut for the selector. \"\r\n\r\n\t^[:receiver :args| receiver isKindOf: SequenceableCollection  ]\r\n\t-> [:receiver :selector :args :cls| | failed result |\r\n\t\tfailed := Object new.\r\n\t\tresult := receiver indexOf: args first ifAbsent: [ failed ].\r\n\t\tfailed == result ifTrue: [\r\n\t\t\tself add: #indexOfIfAbsent-failed step: [ args last value ] in: nil\r\n\t\t] ifFalse: [ self value: result ]\r\n\t] ","function(self)\r\nreturn (((function(receiver,args)\r\nreturn (smalltalk:is_kindOf_((receiver),(smalltalk.SequenceableCollection)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nlocal failed=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Object):new())\r\n\tfailed=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((receiver):indexOf_ifAbsent_((args):first(),(function()\r\nreturn (failed)\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((((failed)==result)),(function()\r\nreturn ((self):add_step_in_(\"indexOfIfAbsent-failed\",(function()\r\nreturn (((args):last()):value())\r\nend),nil))\r\nend),(function()\r\nreturn ((self):value_(result))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"sortedShortcut",0
,function(self)
return (((function(receiver,args)
return (smalltalk:boolean_and_((smalltalk:is_kindOf_((receiver),(smalltalk.SequenceableCollection))),(function()
return (smalltalk:is_kindOf_(((args):first()),(smalltalk.SimulationBlock)))
end)))
end)):_minus_gt((function(receiver,selector,args,cls)
return ((self):value_((receiver):sorted_(((args):first()):asBlock())))
end)));
end
,"shortcuts","sortedShortcut\r\n\t\" Private - Returns the shortcut for the selector. \"\r\n\r\n\t^[:receiver :args|\r\n\t\t(receiver isKindOf: SequenceableCollection) and: [\r\n\t\targs first isKindOf: SimulationBlock ] ]\r\n\t-> [:receiver :selector :args :cls| self value: (receiver sorted: args first asBlock) ] ","function(self)\r\nreturn (((function(receiver,args)\r\nreturn (smalltalk:boolean_and_((smalltalk:is_kindOf_((receiver),(smalltalk.SequenceableCollection))),(function()\r\nreturn (smalltalk:is_kindOf_(((args):first()),(smalltalk.SimulationBlock)))\r\nend)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nreturn ((self):value_((receiver):sorted_(((args):first()):asBlock())))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.S8Simulator,"sortShortcut",0
,function(self)
return (((function(receiver,args)
return (smalltalk:boolean_and_((smalltalk:is_kindOf_((receiver),(smalltalk.SequenceableCollection))),(function()
return (smalltalk:is_kindOf_(((args):first()),(smalltalk.SimulationBlock)))
end)))
end)):_minus_gt((function(receiver,selector,args,cls)
return ((self):value_((receiver):sort_(((args):first()):asBlock())))
end)));
end
,"shortcuts","sortShortcut\r\n\t\" Private - Returns the shortcut for the selector. \"\r\n\r\n\t^[:receiver :args|\r\n\t\t(receiver isKindOf: SequenceableCollection) and: [\r\n\t\targs first isKindOf: SimulationBlock ] ]\r\n\t-> [:receiver :selector :args :cls| self value: (receiver sort: args first asBlock) ] ","function(self)\r\nreturn (((function(receiver,args)\r\nreturn (smalltalk:boolean_and_((smalltalk:is_kindOf_((receiver),(smalltalk.SequenceableCollection))),(function()\r\nreturn (smalltalk:is_kindOf_(((args):first()),(smalltalk.SimulationBlock)))\r\nend)))\r\nend)):_minus_gt((function(receiver,selector,args,cls)\r\nreturn ((self):value_((receiver):sort_(((args):first()):asBlock())))\r\nend)));\r\nend")
