
-- fileIn("s8/start/Kernel.st")
smalltalk:addClass("Exception",smalltalk.Object,smalltalk:newArray({"messageText"}),"Kernel")

smalltalk:addClass("Error",smalltalk.Exception,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.Object,"smalltalk",0
,function(self)
return (smalltalk:basic_at_ifAbsent_((self),"$smalltalk",(function()
return ((smalltalk.Smalltalk):current())
end)));
end
,"system","smalltalk\r\n\t\" Private - Return the hosting context of the receiver.\r\n\tThe smalltalk host is used for evaluations in the receiver. \"\r\n\r\n\t^self basicAt: '$smalltalk' ifAbsent: [ Smalltalk current ]","function(self)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),\"$smalltalk\",(function()\r\nreturn ((smalltalk.Smalltalk):current())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"nativeLanguage",0
,function(self)
return (smalltalk:basic_at_ifAbsent_(((self):smalltalk()),"$nativeLanguage",(function()
return ("js")
end)));
end
,"environment","nativeLanguage\r\n\t\" Private - Return the native language of the host. \"\r\n\r\n\t^self smalltalk\r\n\t\tbasicAt: '$nativeLanguage'\r\n\t\tifAbsent: [ #js ]","function(self)\r\nreturn (smalltalk:basic_at_ifAbsent_(((self):smalltalk()),\"$nativeLanguage\",(function()\r\nreturn (\"js\")\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"halt",0
,function(self)
debug.debug();
return (self);
end
,"debug","halt\r\n\t\" Private - Halt execution entering debugger. \"\r\n\r\n\t{'' doc'Enter lowlevel debugger (or do nothing)'}","function(self)\r\ndebug.debug();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"note:",0
,function(self,aString)
(self):print_((smalltalk:asString_((aString))):asComment());
return (self);
end
,"development","note: aString\r\n\t\" Print a note (aString) to the user. \"\r\n\r\n\tself print: aString asString asComment","function(self,aString)\r\n(self):print_((smalltalk:asString_((aString))):asComment());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"notImplementedYet",0
,function(self)
(self):error_(("Not implemented. Yet"):halt());
return (self);
end
,"development","notImplementedYet\r\n\t\" Private - Halt execution and/or generate an error reporting implementation incomplete. \"\r\n\r\n\tself error: 'Not implemented. Yet' halt","function(self)\r\n(self):error_((\"Not implemented. Yet\"):halt());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"notImplementedYet:",0
,function(self,aSelector)
(self):error_((smalltalk:object_comma_(((aSelector):asLiteral())," Not implemented. Yet")):halt());
return (self);
end
,"development","notImplementedYet: aSelector\r\n\t\" Private - Halt execution and/or generate an error reporting implementation incomplete. \"\r\n\r\n\tself error: (aSelector asLiteral ,' Not implemented. Yet') halt","function(self,aSelector)\r\n(self):error_((smalltalk:object_comma_(((aSelector):asLiteral()),\" Not implemented. Yet\")):halt());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"=","_eq"
,function(self,anObject)
return (((self)==anObject));
end
,"comparing","= anObject\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\t^self == anObject","function(self,anObject)\r\nreturn (((self)==anObject));\r\nend")

smalltalk:bind(smalltalk.Object,"~=","_no_eq"
,function(self,anObject)
return (((smalltalk:isObject_equalTo_((self),anObject))==false));
end
,"comparing","~= anObject\r\n\t\" Return true if the receiver is not equal to anObject. \"\r\n\r\n\t^(self = anObject) == false","function(self,anObject)\r\nreturn (((smalltalk:isObject_equalTo_((self),anObject))==false));\r\nend")

smalltalk:bind(smalltalk.Object,"initialize",0
,function(self)
return (self);
end
,"initialize","initialize\r\n\t\" Private - Initialize the receiver.\r\n\tThe default implementation do nothing.\r\n\tThis method can be refined by subclasses to support creation time initialization of collaborators.\r\n\t\"","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"yourself",0
,function(self)
return (self);
end
,"identity","yourself\r\n\t\" Return the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"species",0
,function(self)
return ((self)["$klass"]);
end
,"species","species\r\n\t\" Return the species to instantiate objects like the receiver. \"\r\n\r\n\t^self class ","function(self)\r\nreturn ((self)[\"$klass\"]);\r\nend")

smalltalk:bind(smalltalk.Object,"class",0
,function(self)
return (smalltalk:basic_at_ifAbsent_((self),"$klass",(function()
return ((self):klass())
end)));
end
,"accessing","class\r\n\t\" Return the class of the receiver. \"\r\n\r\n\t^self basicAt: '$klass' ifAbsent: [ self klass ]","function(self)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),\"$klass\",(function()\r\nreturn ((self):klass())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"size",0
,function(self)
return (0);
end
,"accessing","size\r\n\t\" Return the size of the receiver.\r\n\tThe default implementation return zero.\r\n\tThis method can be refined by subclasses to support indexed access.\r\n\t\"\r\n\r\n\t^0","function(self)\r\nreturn (0);\r\nend")

smalltalk:bind(smalltalk.Object,"copy",0
,function(self)
return ((self):shallowCopy());
end
,"copying","copy\r\n\t\" Return a copy of the receiver. \"\r\n\r\n\t^self shallowCopy","function(self)\r\nreturn ((self):shallowCopy());\r\nend")

smalltalk:bind(smalltalk.Object,"shallowCopy",0
,function(self)
local result=nil
(function()
	local _s8_value=(((self)["$klass"]):basicNew())
	result=_s8_value
	return _s8_value
end)();
((self)["$klass"]):allInstVarNamesDo_((function(iv)
local v=nil
(function()
	local _s8_value=((self)[smalltalk:object_comma_(("@"),iv)])
	v=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((v))),(function()
return (smalltalk:basic_at_put_((result),smalltalk:object_comma_(("@"),iv),v))
end),nil))
end));
return (result);
end
,"copying","shallowCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self class basicNew.\r\n\tself class allInstVarNamesDo: [:iv| | v |\r\n\t\tv := self basicAt: $@,iv.\r\n\t\tv notNil ifTrue: [ result basicAt: $@,iv put: v ]\r\n\t].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self)[\"$klass\"]):basicNew())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self)[\"$klass\"]):allInstVarNamesDo_((function(iv)\r\nlocal v=nil\r\n(function()\r\n\tlocal _s8_value=((self)[smalltalk:object_comma_((\"@\"),iv)])\r\n\tv=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((v))),(function()\r\nreturn (smalltalk:basic_at_put_((result),smalltalk:object_comma_((\"@\"),iv),v))\r\nend),nil))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Object,"deepCopyOf:",0
,function(self,what)
if (smalltalk:isNil_((what)))==true then return (what); end;
if ((self):isObject_(what))==true then return ((what):deepCopy()); end;
return (what);
end
,"copying","deepCopyOf: what\r\n\t\" Private - Return a deep copy of what. \"\r\n\r\n\twhat isNil ifTrue: [ ^what ].\r\n\t(self isObject: what) ifTrue: [ ^what deepCopy ].\r\n\t^what","function(self,what)\r\nif (smalltalk:isNil_((what)))==true then return (what); end;\r\nif ((self):isObject_(what))==true then return ((what):deepCopy()); end;\r\nreturn (what);\r\nend")

smalltalk:bind(smalltalk.Object,"deepCopy",0
,function(self)
local result=nil
(function()
	local _s8_value=(((self)["$klass"]):basicNew())
	result=_s8_value
	return _s8_value
end)();
((self)["$klass"]):allInstVarNamesDo_((function(iv)
local v=nil
(function()
	local _s8_value=((self):deepCopyOf_((self)[smalltalk:object_comma_(("@"),iv)]))
	v=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((v))),(function()
return (smalltalk:basic_at_put_((result),smalltalk:object_comma_(("@"),iv),v))
end),nil))
end));
return (result);
end
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self class basicNew.\r\n\tself class allInstVarNamesDo: [:iv| | v |\r\n\t\tv := self deepCopyOf: (self basicAt: $@,iv).\r\n\t\tv notNil ifTrue: [ result basicAt: $@,iv put: v ]\r\n\t].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self)[\"$klass\"]):basicNew())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self)[\"$klass\"]):allInstVarNamesDo_((function(iv)\r\nlocal v=nil\r\n(function()\r\n\tlocal _s8_value=((self):deepCopyOf_((self)[smalltalk:object_comma_((\"@\"),iv)]))\r\n\tv=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((v))),(function()\r\nreturn (smalltalk:basic_at_put_((result),smalltalk:object_comma_((\"@\"),iv),v))\r\nend),nil))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Object,"->","_minus_gt"
,function(self,anObject)
return ((smalltalk.Association):key_value_(self,anObject));
end
,"converting","-> anObject\r\n\t\" Return an association of the receiver to anObject. \"\r\n\r\n\t^Association key: self value: anObject","function(self,anObject)\r\nreturn ((smalltalk.Association):key_value_(self,anObject));\r\nend")

smalltalk:bind(smalltalk.Object,"asString",0
,function(self)
return (smalltalk:printString_((self)));
end
,"converting","asString\r\n\t\" Return the receiver represented as String. \"\r\n\r\n\t^self printString","function(self)\r\nreturn (smalltalk:printString_((self)));\r\nend")

smalltalk:bind(smalltalk.Object,"toString",0
,function(self)

return (smalltalk:object_comma_((smalltalk:object_comma_(("{st:a"),((self)["$klass"]):name())),"}"));
end
,"converting","toString\r\n\t\" Return the receiver as a String. \"\r\n\r\n\t{'self'}.\r\n\t^'{st:a',self class name,$}","function(self)\r\n\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"{st:a\"),((self)[\"$klass\"]):name())),\"}\"));\r\nend")

smalltalk:bind(smalltalk.Object,"toString:",0
,function(self,anObject)
if (smalltalk:isNil_((anObject)))==true then return ("nil"); end;
if ((self):isObject_(anObject))==true then return (smalltalk:toString_((anObject))); end;
return (tostring(anObject));
end
,"converting","toString: anObject\r\n\t\" Return anObject converted to a String. \"\r\n\r\n\tanObject isNil ifTrue: [ ^#nil ].\r\n\t(self isObject: anObject) ifTrue: [ ^anObject toString ].\r\n\t^{'' doc'Native conversion (default goes to error)'}","function(self,anObject)\r\nif (smalltalk:isNil_((anObject)))==true then return (\"nil\"); end;\r\nif ((self):isObject_(anObject))==true then return (smalltalk:toString_((anObject))); end;\r\nreturn (tostring(anObject));\r\nend")

smalltalk:bind(smalltalk.Object,"asNative:",0
,function(self,lang)
return (smalltalk:asString_((self)));
end
,"converting","asNative: lang\r\n\t\" Return the native representation of the receiver in target language lang.\r\n\tThe default implementation return the receiver as a String.\r\n\tThis method must be refined by subclasses implementing native literal representation.\r\n\t\"\r\n\r\n\t^self asString","function(self,lang)\r\nreturn (smalltalk:asString_((self)));\r\nend")

smalltalk:bind(smalltalk.Object,"asNative",0
,function(self)
return ((self):asNative_((self):nativeLanguage()));
end
,"converting","asNative\r\n\t\" Return the native representation of the receiver.\r\n\tThe default implementation return the receiver as a String.\r\n\tThis method must be refined by subclasses implementing native literal representation.\r\n\t\"\r\n\r\n\t^self asNative: self nativeLanguage","function(self)\r\nreturn ((self):asNative_((self):nativeLanguage()));\r\nend")

smalltalk:bind(smalltalk.Object,"asJSON",0
,function(self)
local json=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):nativeObjectAt_("JSON"))
	json=_s8_value
	return _s8_value
end)();
return ((json):stringify((self):asJSONObject()));
end
,"json","asJSON\r\n\t\" Return the JSON representation of the receiver. \"\r\n\r\n\t| json |\r\n\tjson := Smalltalk nativeObjectAt: #JSON.\r\n\t^json #stringify: self asJSONObject","function(self)\r\nlocal json=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):nativeObjectAt_(\"JSON\"))\r\n\tjson=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((json):stringify((self):asJSONObject()));\r\nend")

smalltalk:bind(smalltalk.Object,"escapedCode",0
,function(self)
return ((self):asNative());
end
,"converting","escapedCode\r\n\t\" Return the code to reproduce receiver from code. \"\r\n\r\n\t^self asNative","function(self)\r\nreturn ((self):asNative());\r\nend")

smalltalk:bind(smalltalk.Object,"perform:",0
,function(self,aSymbol)
return ((self):perform_withArguments_(aSymbol,smalltalk:newArray({})));
end
,"perform","perform: aSymbol\r\n\t\" Return the result of sending message aSymbol to the receiver. \"\r\n\r\n\t^self perform: aSymbol withArguments: #()","function(self,aSymbol)\r\nreturn ((self):perform_withArguments_(aSymbol,smalltalk:newArray({})));\r\nend")

smalltalk:bind(smalltalk.Object,"perform:with:",0
,function(self,aSymbol,argument)
return ((self):perform_withArguments_(aSymbol,(smalltalk.Array):with_(argument)));
end
,"perform","perform: aSymbol with: argument\r\n\t\" Return the result of sending message aSymbol to the receiver. \"\r\n\r\n\t^self perform: aSymbol withArguments: (Array with: argument)","function(self,aSymbol,argument)\r\nreturn ((self):perform_withArguments_(aSymbol,(smalltalk.Array):with_(argument)));\r\nend")

smalltalk:bind(smalltalk.Object,"perform:withArguments:",0
,function(self,aSymbol,aCollection)
return ((self):basicPerform_withArguments_((aSymbol):asSelector(),(aCollection):asArray()));
end
,"perform","perform: aSymbol withArguments: aCollection\r\n\t\" Return the result of sending message aSymbol to the receiver. \"\r\n\r\n\"\tWarning: To do NOT check arguments size is a feature\r\n\t\tif we do strict matching U8 tools will break because they are using the feature.\r\n\taSymbol numberOfArguments = aCollection size ifFalse: [\r\n\t\t^self error: 'Invalid arguments size'\r\n\t].\r\n\"\t^self basicPerform: aSymbol asSelector withArguments: aCollection asArray","function(self,aSymbol,aCollection)\r\nreturn ((self):basicPerform_withArguments_((aSymbol):asSelector(),(aCollection):asArray()));\r\nend")

smalltalk:bind(smalltalk.Object,"isObject:",0
,function(self,anObject)

	local status, result = pcall(function() return type(anObject.yourself)=="function" end)
	if true then return status and result end;
return (self);
end
,"testing","isObject: anObject\r\n\t\" Return true if anObject is a smalltalk object.\r\n\tReturn false if the object is a native object.\r\n\t\"\r\n\r\n\t{'' doc'Native detection (default goes to error)'}","function(self,anObject)\r\n\r\n\tlocal status, result = pcall(function() return type(anObject.yourself)==\"function\" end)\r\n\tif true then return status and result end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"isNumber:",0
,function(self,anObject)
return (smalltalk:boolean_and_(((self):isObject_(anObject)),(function()
return ((anObject):isNumber())
end)));
end
,"testing","isNumber: anObject\r\n\t\" Return true if anObject is a number. \"\r\n\r\n\t^(self isObject: anObject) and: [ anObject isNumber ]","function(self,anObject)\r\nreturn (smalltalk:boolean_and_(((self):isObject_(anObject)),(function()\r\nreturn ((anObject):isNumber())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"basicAt:",0
,function(self,aString)
local result=nil
(function()
	local _s8_value=(self[aString])
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((result)))==true then return (nil); end;
return (result);
end
,"accessing","basicAt: aString\r\n\t\" Return the property of the receiver known as aString (or nil). \"\r\n\r\n\t| result |\r\n\tresult := self[aString].\r\n\tresult isNil ifTrue: [ ^nil ].\r\n\t^result","function(self,aString)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(self[aString])\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((result)))==true then return (nil); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Object,"basicAt:ifAbsent:",0
,function(self,aString,aBlock)
return (smalltalk:ifUndefined_do_((self[aString]),(function()
return ((aBlock):value())
end)));
end
,"accessing","basicAt: aString ifAbsent: aBlock\r\n\t\" Return the property of the receiver known as aString (or the result of evaluating aBlock). \"\r\n\r\n\t^self[aString] ifUndefined: [ aBlock value ]","function(self,aString,aBlock)\r\nreturn (smalltalk:ifUndefined_do_((self[aString]),(function()\r\nreturn ((aBlock):value())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"basicAt:ifAbsentPut:",0
,function(self,aString,aBlock)
return (smalltalk:basic_at_ifAbsent_((self),aString,(function()
return (smalltalk:basic_at_put_((self),aString,(aBlock):value()))
end)));
end
,"accessing","basicAt: aString ifAbsentPut: aBlock\r\n\t\" Return the property of the receiver known as aString (or set it with the result of evaluating aBlock). \"\r\n\r\n\t^self basicAt: aString ifAbsent: [ self basicAt: aString put: aBlock value ]","function(self,aString,aBlock)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),aString,(function()\r\nreturn (smalltalk:basic_at_put_((self),aString,(aBlock):value()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"instVarAt:",0
,function(self,instVarName)
if ((self):isNumber_(instVarName))==true then return ((self):instVarAt_((((self)["$klass"]):allInstVarNames()):at_(instVarName))); end;
return ((self)[smalltalk:object_comma_(("@"),instVarName)]);
end
,"accessing","instVarAt: instVarName\r\n\t\" Return the internal collaborator of the receiver known as instVarName. \"\r\n\r\n\t(self isNumber: instVarName) ifTrue: [\r\n\t\t^self instVarAt: (self class allInstVarNames at: instVarName)\r\n\t].\r\n\t^self basicAt: $@ ,instVarName","function(self,instVarName)\r\nif ((self):isNumber_(instVarName))==true then return ((self):instVarAt_((((self)[\"$klass\"]):allInstVarNames()):at_(instVarName))); end;\r\nreturn ((self)[smalltalk:object_comma_((\"@\"),instVarName)]);\r\nend")

smalltalk:bind(smalltalk.Object,"instVarAt:put:",0
,function(self,instVarName,anObject)
if ((self):isNumber_(instVarName))==true then return ((self):instVarAt_put_((((self)["$klass"]):allInstVarNames()):at_(instVarName),anObject)); end;
return (smalltalk:basic_at_put_((self),smalltalk:object_comma_(("@"),instVarName),anObject));
end
,"accessing","instVarAt: instVarName put: anObject\r\n\t\" Set the internal collaborator of the receiver known as instVarName to anObject. \"\r\n\r\n\t(self isNumber: instVarName) ifTrue: [\r\n\t\t^self instVarAt: (self class allInstVarNames at: instVarName) put: anObject\r\n\t].\r\n\t^self basicAt: $@ ,instVarName put: anObject","function(self,instVarName,anObject)\r\nif ((self):isNumber_(instVarName))==true then return ((self):instVarAt_put_((((self)[\"$klass\"]):allInstVarNames()):at_(instVarName),anObject)); end;\r\nreturn (smalltalk:basic_at_put_((self),smalltalk:object_comma_((\"@\"),instVarName),anObject));\r\nend")

smalltalk:bind(smalltalk.Object,"basicAt:put:",0
,function(self,aString,anObject)
return ((function()
	local _s8_value=(anObject)
	self[aString]=_s8_value
	return _s8_value
end)());
end
,"accessing","basicAt: aString put: anObject\r\n\t\" Set the property of the receiver known as aString. \"\r\n\r\n\t^self[aString] := anObject","function(self,aString,anObject)\r\nreturn ((function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[aString]=_s8_value\r\n\treturn _s8_value\r\nend)());\r\nend")

smalltalk:bind(smalltalk.Object,"error:",0
,function(self,aString)
return ((smalltalk.Error):signal_(aString));
end
,"error","error: aString\r\n\t\" Return the result of managing error(aString) in the receiver. \"\r\n\r\n\t^Error signal: aString","function(self,aString)\r\nreturn ((smalltalk.Error):signal_(aString));\r\nend")

smalltalk:bind(smalltalk.Object,"subclassResponsibility",0
,function(self)
return ((self):subclassResponsibility_(nil));
end
,"error","subclassResponsibility\r\n\t\" Private - The concrete implementation on the receiver is not complete. \"\r\n\r\n\t^self subclassResponsibility: nil","function(self)\r\nreturn ((self):subclassResponsibility_(nil));\r\nend")

smalltalk:bind(smalltalk.Object,"implementedBySubclass",0
,function(self)
return ((self):subclassResponsibility());
end
,"error","implementedBySubclass\r\n\t\" Private - The concrete implementation on the receiver is not complete. \"\r\n\r\n\t^self subclassResponsibility","function(self)\r\nreturn ((self):subclassResponsibility());\r\nend")

smalltalk:bind(smalltalk.Object,"shouldNotImplement",0
,function(self)
return ((self):shouldNotImplement_(nil));
end
,"error","shouldNotImplement\r\n\t\" The receiver received a message that is not expected. \"\r\n\r\n\t^self shouldNotImplement: nil","function(self)\r\nreturn ((self):shouldNotImplement_(nil));\r\nend")

smalltalk:bind(smalltalk.Object,"invalidMessage",0
,function(self)
return ((self):invalidMessage_(nil));
end
,"error","invalidMessage\r\n\t\" The receiver received a message that is invalid (not expected for this object). \"\r\n\r\n\t^self invalidMessage: nil","function(self)\r\nreturn ((self):invalidMessage_(nil));\r\nend")

smalltalk:bind(smalltalk.Object,"subclassResponsibility:",0
,function(self,aSelector)
return (((self):halt()):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Implementation of"),smalltalk:if_true_false_((smalltalk:isNil_((aSelector))),(function()
return (" ")
end),(function()
return (smalltalk:object_comma_((" #"),aSelector))
end))))," is a responsibility of the subclass(")),((self)["$klass"]):name())),").")));
end
,"error","subclassResponsibility: aSelector\r\n\t\" Private - The concrete implementation on the receiver is not complete. \"\r\n\r\n\t^self halt error:\r\n\t\t 'Implementation of'\r\n\t\t,(aSelector isNil ifTrue: [' '] ifFalse: [' #',aSelector])\r\n\t\t,' is a responsibility of the subclass(',self class name,').'","function(self,aSelector)\r\nreturn (((self):halt()):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Implementation of\"),smalltalk:if_true_false_((smalltalk:isNil_((aSelector))),(function()\r\nreturn (\" \")\r\nend),(function()\r\nreturn (smalltalk:object_comma_((\" #\"),aSelector))\r\nend)))),\" is a responsibility of the subclass(\")),((self)[\"$klass\"]):name())),\").\")));\r\nend")

smalltalk:bind(smalltalk.Object,"implementedBySubclass:",0
,function(self,aSelector)
return ((self):subclassResponsibility_(aSelector));
end
,"error","implementedBySubclass: aSelector\r\n\t\" Private - The concrete implementation on the receiver is not complete. \"\r\n\r\n\t^self subclassResponsibility: aSelector","function(self,aSelector)\r\nreturn ((self):subclassResponsibility_(aSelector));\r\nend")

smalltalk:bind(smalltalk.Object,"shouldNotImplement:",0
,function(self,aSelector)
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Message"),smalltalk:if_true_false_((smalltalk:isNil_((aSelector))),(function()
return (" ")
end),(function()
return (smalltalk:object_comma_((" #"),aSelector))
end))))," should not be implemented for instances of ")),((self)["$klass"]):name())));
end
,"error","shouldNotImplement: aSelector\r\n\t\" The receiver received a message that is not expected. \"\r\n\r\n\t^self error:\r\n\t\t 'Message'\r\n\t\t,(aSelector isNil ifTrue: [' '] ifFalse: [' #',aSelector])\r\n\t\t,' should not be implemented for instances of ', self class name","function(self,aSelector)\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Message\"),smalltalk:if_true_false_((smalltalk:isNil_((aSelector))),(function()\r\nreturn (\" \")\r\nend),(function()\r\nreturn (smalltalk:object_comma_((\" #\"),aSelector))\r\nend)))),\" should not be implemented for instances of \")),((self)[\"$klass\"]):name())));\r\nend")

smalltalk:bind(smalltalk.Object,"invalidMessage:",0
,function(self,aSelector)
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Message"),smalltalk:if_true_false_((smalltalk:isNil_((aSelector))),(function()
return (" ")
end),(function()
return (smalltalk:object_comma_((" #"),aSelector))
end))))," should not be sent to instances of ")),((self)["$klass"]):name())));
end
,"error","invalidMessage: aSelector\r\n\t\" The receiver received a message that is invalid (not expected for this object). \"\r\n\r\n\t^self error: \r\n\t\t 'Message'\r\n\t\t,(aSelector isNil ifTrue: [' '] ifFalse: [' #',aSelector])\r\n\t\t,' should not be sent to instances of ', self class name","function(self,aSelector)\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Message\"),smalltalk:if_true_false_((smalltalk:isNil_((aSelector))),(function()\r\nreturn (\" \")\r\nend),(function()\r\nreturn (smalltalk:object_comma_((\" #\"),aSelector))\r\nend)))),\" should not be sent to instances of \")),((self)[\"$klass\"]):name())));\r\nend")

smalltalk:bind(smalltalk.Object,"smalltalkErrorOf:",0
,function(self,aNativeException)
local result=nil
if ((self):isObject_(aNativeException))==true then if (smalltalk:is_kindOf_((aNativeException),(smalltalk.Exception)))==true then return (aNativeException); end;
return (((smalltalk.Error):new()):messageText_(aNativeException)); end;
(function()
	local _s8_value=((aNativeException)["smalltalkError"])
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((result)))==true then return (result); end;
return ((
function(_s8_rec)
	(_s8_rec):messageText_(((aNativeException["description"]) or aNativeException["message"]));
	(_s8_rec):nativeException_(aNativeException);
	return ((_s8_rec):yourself())
end
)((smalltalk.Error):new()));
end
,"private","smalltalkErrorOf: aNativeException\r\n\t\" Private, Internal - Return anException associated with a native exception. \"\r\n\r\n\t| result |\r\n\t(self isObject: aNativeException) ifTrue: [\r\n\t\t(aNativeException isKindOf: Exception) ifTrue: [ ^aNativeException ].\r\n\t\t^Error new messageText: aNativeException\r\n\t].\r\n\tresult := aNativeException basicAt: #smalltalkError.\r\n\tresult notNil ifTrue: [ ^result ].\r\n\t^Error new\r\n\t\tmessageText: aNativeException#description || aNativeException#message;\r\n\t\tnativeException: aNativeException;\r\n\t\tyourself","function(self,aNativeException)\r\nlocal result=nil\r\nif ((self):isObject_(aNativeException))==true then if (smalltalk:is_kindOf_((aNativeException),(smalltalk.Exception)))==true then return (aNativeException); end;\r\nreturn (((smalltalk.Error):new()):messageText_(aNativeException)); end;\r\n(function()\r\n\tlocal _s8_value=((aNativeException)[\"smalltalkError\"])\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((result)))==true then return (result); end;\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):messageText_(((aNativeException[\"description\"]) or aNativeException[\"message\"]));\r\n\t(_s8_rec):nativeException_(aNativeException);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.Error):new()));\r\nend")

smalltalk:bind(smalltalk.Object,"inspect",0
,function(self)
return ((self):basicInspect());
end
,"inspection","inspect\r\n\t\" Open an inspector on the receiver. \"\r\n\r\n\t^self basicInspect","function(self)\r\nreturn ((self):basicInspect());\r\nend")

smalltalk:bind(smalltalk.Object,"basicInspect",0
,function(self)
if (((self):smalltalk()):includesKey_("NativeHandle"))==true then return ((self):print_((smalltalk.NativeHandle):_at_gt(self))); end;
return (self);
end
,"inspection","basicInspect\r\n\t\" Private - Open an inspector on the receiver. \"\r\n\r\n\t(self smalltalk includesKey: #NativeHandle) ifTrue: [ \"print native representation\"\r\n\t\t^self print: NativeHandle @> self\r\n\t].\r\n\t^self","function(self)\r\nif (((self):smalltalk()):includesKey_(\"NativeHandle\"))==true then return ((self):print_((smalltalk.NativeHandle):_at_gt(self))); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Exception,"captureStack",0
,function(self)

return (self);
end
,"private","captureStack\r\n\t\" Private, Internal - Capture the native stack of the receiver. \"\r\n\r\n\t{'self' doc'Must return the native stack'}","function(self)\r\n\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Exception,"nativeStack",0
,function(self)
return ((self)["@stack"]);
end
,"private","nativeStack\r\n\t\" Private, Internal - Return the native stack of the receiver (or nil).\r\n\tNote that the native stack can be nativelly captured during signal.\r\n\t\"\r\n\r\n\t^self basicAt: '@stack'","function(self)\r\nreturn ((self)[\"@stack\"]);\r\nend")

smalltalk:bind(smalltalk.Exception,"nativeException",0
,function(self)
return ((self)["@nativeException"]);
end
,"private","nativeException\r\n\t\" Private, Internal - Return the native exception associated with the receiver (or nil). \"\r\n\r\n\t^self basicAt: '@nativeException'","function(self)\r\nreturn ((self)[\"@nativeException\"]);\r\nend")

smalltalk:bind(smalltalk.Exception,"nativeException:",0
,function(self,nex)
return (smalltalk:basic_at_put_((self),"@nativeException",nex));
end
,"private","nativeException: nex\r\n\t\" Private, Internal - Set the native exception associated with the receiver. \"\r\n\r\n\t^self basicAt: '@nativeException' put: nex","function(self,nex)\r\nreturn (smalltalk:basic_at_put_((self),\"@nativeException\",nex));\r\nend")

smalltalk:bind(smalltalk.Exception,"stack",0
,function(self)
local nex=nil
local stk=nil
(function()
	local _s8_value=((self):nativeStack())
	stk=_s8_value
	return _s8_value
end)();
if ((((stk):size()) > 0))==true then return (stk); end;
(function()
	local _s8_value=((self):nativeException())
	nex=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((nex)))==true then return (""); end;
(function()
	local _s8_value=((nex)["stack"])
	stk=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:isNil_((stk))),(function()
return ("")
end),(function()
return (stk)
end)));
end
,"stack","stack\r\n\t\" Private - Return a stack trace string (or an empty string). \"\r\n\r\n\t| nex stk |\r\n\tstk := self nativeStack.\r\n\tstk size > 0 ifTrue: [ ^stk ].\r\n\tnex := self nativeException.\r\n\tnex isNil ifTrue: [ ^'' ].\r\n\tstk := nex basicAt: #stack.\r\n\t^stk isNil ifTrue: [''] ifFalse: [stk]","function(self)\r\nlocal nex=nil\r\nlocal stk=nil\r\n(function()\r\n\tlocal _s8_value=((self):nativeStack())\r\n\tstk=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((((stk):size()) > 0))==true then return (stk); end;\r\n(function()\r\n\tlocal _s8_value=((self):nativeException())\r\n\tnex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((nex)))==true then return (\"\"); end;\r\n(function()\r\n\tlocal _s8_value=((nex)[\"stack\"])\r\n\tstk=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((stk))),(function()\r\nreturn (\"\")\r\nend),(function()\r\nreturn (stk)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Exception,"toString",0
,function(self)
local txt=nil
local stk=nil
(function()
	local _s8_value=((self):messageText())
	txt=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((txt)))==true then (function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(("{st: "),(self):description())),"}"))
	txt=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=((self):stack())
	stk=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((stk):size()),0))==true then return (txt); end;
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_(txt);
	(_s8_rec):cr();
	(_s8_rec):nextPutAll_(stk);
	return ((_s8_rec):contents())
end
)((""):writeStream()));
end
,"converting","toString\r\n\t\" Return the receiver as a String. \"\r\n\r\n\t| txt stk |\r\n\ttxt := self messageText.\r\n\ttxt isNil ifTrue: [ txt := '{st: ' ,self description ,$} ].\r\n\tstk := self stack.\r\n\tstk size = 0 ifTrue: [ ^txt ].\r\n\t^'' writeStream\r\n\t\tnextPutAll: txt; cr;\r\n\t\tnextPutAll: stk;\r\n\t\tcontents","function(self)\r\nlocal txt=nil\r\nlocal stk=nil\r\n(function()\r\n\tlocal _s8_value=((self):messageText())\r\n\ttxt=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((txt)))==true then (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((\"{st: \"),(self):description())),\"}\"))\r\n\ttxt=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((self):stack())\r\n\tstk=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((stk):size()),0))==true then return (txt); end;\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(txt);\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):nextPutAll_(stk);\r\n\treturn ((_s8_rec):contents())\r\nend\r\n)((\"\"):writeStream()));\r\nend")

smalltalk:bind(smalltalk.Object,"printString",0
,function(self)
return (smalltalk:object_comma_(("a "),((self)["$klass"]):name()));
end
,"printing","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t^'a ', self class name","function(self)\r\nreturn (smalltalk:object_comma_((\"a \"),((self)[\"$klass\"]):name()));\r\nend")

smalltalk:bind(smalltalk.Object,"isKindOf:",0
,function(self,aClass)
return (((self)["$klass"]):inheritsFrom_(aClass));
end
,"testing","isKindOf: aClass\r\n\t\" Return true if the receiver is kind of aClass. \"\r\n\r\n\t^self class inheritsFrom: aClass","function(self,aClass)\r\nreturn (((self)[\"$klass\"]):inheritsFrom_(aClass));\r\nend")

smalltalk:bind(smalltalk.Object,"isMemberOf:",0
,function(self,aClass)
return ((((self)["$klass"])==aClass));
end
,"testing","isMemberOf: aClass\r\n\t\" Return true if the receiver is member of aClass. \"\r\n\r\n\t^self class == aClass","function(self,aClass)\r\nreturn ((((self)[\"$klass\"])==aClass));\r\nend")

smalltalk:bind(smalltalk.Object,"ifNil:",0
,function(self,aBlock)
return (self);
end
,"testing","ifNil: aBlock\r\n\t\" Return the receiver if it is not nil, or the result of evaluating aBlock (if it is nil). \"\r\n\r\n\t^self","function(self,aBlock)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"ifNil:ifNotNil:",0
,function(self,aBlock,anotherBlock)
return ((anotherBlock):value());
end
,"testing","ifNil: aBlock ifNotNil: anotherBlock\r\n\t\" Return the result of evaluating aBlock if the receiver is nil or the result of evaluating anotherBlock (if not nil). \"\r\n\r\n\t^anotherBlock value","function(self,aBlock,anotherBlock)\r\nreturn ((anotherBlock):value());\r\nend")

smalltalk:bind(smalltalk.Object,"ifNotNil:",0
,function(self,aBlock)
return ((aBlock):value());
end
,"testing","ifNotNil: aBlock\r\n\t\" Return the result of evaluating aBlock if the receiver is not nil, or nil if it is nil. \"\r\n\r\n\t^aBlock value","function(self,aBlock)\r\nreturn ((aBlock):value());\r\nend")

smalltalk:bind(smalltalk.Object,"ifNotNil:ifNil:",0
,function(self,aBlock,anotherBlock)
return ((aBlock):value());
end
,"testing","ifNotNil: aBlock ifNil: anotherBlock\r\n\t\" Return the result of evaluating aBlock if the receiver is not nil, or the result of evaluating anotherBlock if it is nil. \"\r\n\r\n\t^aBlock value","function(self,aBlock,anotherBlock)\r\nreturn ((aBlock):value());\r\nend")

smalltalk:bind(smalltalk.Object,"isNil",0
,function(self)
return (false);
end
,"testing","isNil\r\n\t\" Return true if the receiver is nil. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.Object,"notNil",0
,function(self)
return (smalltalk:booleanNot_((smalltalk:isNil_((self)))));
end
,"testing","notNil\r\n\t\" Return true if the receiver is not nil. \"\r\n\r\n\t^self isNil not","function(self)\r\nreturn (smalltalk:booleanNot_((smalltalk:isNil_((self)))));\r\nend")

smalltalk:bind(smalltalk.Object,"isClass",0
,function(self)
return (false);
end
,"testing","isClass\r\n\t\" Return true if the receiver is a Class. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.Object,"isMetaclass",0
,function(self)
return (false);
end
,"testing","isMetaclass\r\n\t\" Return true if the receiver is a metaclass. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.Object,"isNumber",0
,function(self)
return (false);
end
,"testing","isNumber\r\n\t\" Return true if the receiver is a Number. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.Object,"isString",0
,function(self)
return (false);
end
,"testing","isString\r\n\t\" Return true if the receiver is a String. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.Object,"isArray",0
,function(self)
return (false);
end
,"testing","isArray\r\n\t\" Return true if the receiver is an Array. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.Object,"isValuable",0
,function(self)
return (false);
end
,"testing","isValuable\r\n\t\" Return true if the receiver can be evaluated. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.Object,"typeOf:",0
,function(self,anObject)
return (type(anObject));
end
,"native","typeOf: anObject\r\n\t\" Return the (native) type of anObject. \"\r\n\r\n\t^{'' doc'Get native type (default goes to error, use to be a String instance)'}","function(self,anObject)\r\nreturn (type(anObject));\r\nend")

smalltalk:bind(smalltalk.Object,"callableOf:",0
,function(self,aBlock)

if (smalltalk:isNil_((aBlock)))==true then return (aBlock); end;
if (smalltalk:isObject_equalTo_(((self):typeOf_(aBlock)),"function"))==true then return (aBlock); end;
return ((function(x,y,z)
return ((aBlock):value_value_value_(x,y,z))
end));
end
,"native","callableOf: aBlock\r\n\t\" Return a (native) callable object for evaluating aBlock. \"\r\n\r\n\t{'self' s8' ^aBlock '}.\r\n\taBlock isNil ifTrue: [ ^aBlock ].\r\n\t(self typeOf: aBlock) = #function ifTrue: [ ^aBlock ].\r\n\t^[:x :y :z| aBlock value: x value: y value: z ] ","function(self,aBlock)\r\n\r\nif (smalltalk:isNil_((aBlock)))==true then return (aBlock); end;\r\nif (smalltalk:isObject_equalTo_(((self):typeOf_(aBlock)),\"function\"))==true then return (aBlock); end;\r\nreturn ((function(x,y,z)\r\nreturn ((aBlock):value_value_value_(x,y,z))\r\nend));\r\nend")

smalltalk:bind(smalltalk.Object,"methodFor:",0
,function(self,aSymbol)
return (((self)["$klass"]):compiledMethodFor_(aSymbol));
end
,"messages","methodFor: aSymbol \r\n\t\" Return the method implementing aSymbol (or nil). \"\r\n\r\n\t^self class compiledMethodFor: aSymbol","function(self,aSymbol)\r\nreturn (((self)[\"$klass\"]):compiledMethodFor_(aSymbol));\r\nend")

smalltalk:bind(smalltalk.Object,"respondsTo:",0
,function(self,aSymbol)
return (smalltalk:notNil_(((self):methodFor_(aSymbol))));
end
,"messages","respondsTo: aSymbol \r\n\t\" Return true if the receiver respond to message aSymbol. \"\r\n\r\n\t^(self methodFor: aSymbol) notNil","function(self,aSymbol)\r\nreturn (smalltalk:notNil_(((self):methodFor_(aSymbol))));\r\nend")

smalltalk:bind(smalltalk.Object,"basicDelete:",0
,function(self,aString)
if self==nil then return else self[aString]=nil end;
return (self);
end
,"accessing","basicDelete: aString\r\n\t\" Private - Basic implementation of deletion of property aString of the receiver. \"\r\n\r\n\t{'' doc'native deletion'}","function(self,aString)\r\nif self==nil then return else self[aString]=nil end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"doesNotUnderstand:",0
,function(self,aMessage)
return ((
function(_s8_rec)
	(_s8_rec):receiver_(self);
	(_s8_rec):message_(aMessage);
	return ((_s8_rec):signal())
end
)((smalltalk.MessageNotUnderstood):new()));
end
,"dnu","doesNotUnderstand: aMessage\r\n\t\" Private - Basic implementation of a message sent and not understood by the receiver. \"\r\n\r\n\t^MessageNotUnderstood new\r\n\t\treceiver: self;\r\n\t\tmessage: aMessage;\r\n\t\tsignal","function(self,aMessage)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):receiver_(self);\r\n\t(_s8_rec):message_(aMessage);\r\n\treturn ((_s8_rec):signal())\r\nend\r\n)((smalltalk.MessageNotUnderstood):new()));\r\nend")

smalltalk:bind(smalltalk.Object,"dnu:withArguments:",0
,function(self,selector,anArray)
return ((self):doesNotUnderstand_((smalltalk.Message):selector_arguments_(selector,anArray)));
end
,"dnu","dnu: selector withArguments: anArray\r\n\t\" Private - Basic implementation of a message sent and not understood by the receiver. \"\r\n\r\n\t^self doesNotUnderstand: (Message selector: selector arguments: anArray)","function(self,selector,anArray)\r\nreturn ((self):doesNotUnderstand_((smalltalk.Message):selector_arguments_(selector,anArray)));\r\nend")

smalltalk:bind(smalltalk.Object,"basicPerform:withArguments:",0
,function(self,jsSelector,anArray)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local fn=nil

(function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((self),jsSelector,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):dnu_withArguments_((jsSelector):asNativeSelector(),anArray))
end
)()
error(_s8Ret_,0)
end)())
end)))
	fn=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (fn(self,(table.unpack or unpack)(anArray)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"private","basicPerform: jsSelector withArguments: anArray\r\n\t\" Private - Basic implementation of #perform... \"\r\n\r\n\t| fn |\r\n\t{'self'}.\r\n\tfn := self basicAt: jsSelector ifAbsent: [\r\n\t\t^self dnu: jsSelector asNativeSelector withArguments: anArray\r\n\t].\r\n\t^{'' doc'dynamic message send (fn can be native function to call)'}","function(self,jsSelector,anArray)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal fn=nil\r\n\r\n(function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((self),jsSelector,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):dnu_withArguments_((jsSelector):asNativeSelector(),anArray))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (fn(self,(table.unpack or unpack)(anArray)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Object,"json",0
,function(self)
return ((self):asJSONObject());
end
,"json","json\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t^self asJSONObject","function(self)\r\nreturn ((self):asJSONObject());\r\nend")

smalltalk:bind(smalltalk.Object,"asJson:",0
,function(self,anObject)
if (smalltalk:isNil_((anObject)))==true then return ((nil):json()); end;
return (smalltalk:if_true_false_(((self):isObject_(anObject)),(function()
return ((anObject):json())
end),(function()
return (anObject)
end)));
end
,"json","asJson: anObject\r\n\t\" Return anObject as a hash object. \"\r\n\r\n\tanObject isNil ifTrue: [ ^nil json ].\r\n\t^(self isObject: anObject)\r\n\t\tifTrue: [ anObject json ]\r\n\t\tifFalse: [ anObject ]","function(self,anObject)\r\nif (smalltalk:isNil_((anObject)))==true then return ((nil):json()); end;\r\nreturn (smalltalk:if_true_false_(((self):isObject_(anObject)),(function()\r\nreturn ((anObject):json())\r\nend),(function()\r\nreturn (anObject)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"asJSONObject",0
,function(self)
local result=nil
(function()
	local _s8_value=({})
	result=_s8_value
	return _s8_value
end)();
(self):jsonFieldsDo_ignoring_((function(field,value)
return (smalltalk:if_true_false_((smalltalk:boolean_or_((smalltalk:notNil_((value))),(function()
return ((self):jsonExportNil())
end))),(function()
return (smalltalk:basic_at_put_((result),field,(self):asJson_(value)))
end),nil))
end),(self):jsonHiddenNames());
return (result);
end
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t| result |\r\n\tresult := {'' doc'get empty JSON collector'}.\r\n\tself\tjsonFieldsDo: [:field :value|\r\n\t\t(value notNil or: [ self jsonExportNil ]) ifTrue: [\r\n\t\t\tresult basicAt: field put: (self asJson: value)\r\n\t\t].\r\n\t]\tignoring: self jsonHiddenNames.\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=({})\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):jsonFieldsDo_ignoring_((function(field,value)\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_or_((smalltalk:notNil_((value))),(function()\r\nreturn ((self):jsonExportNil())\r\nend))),(function()\r\nreturn (smalltalk:basic_at_put_((result),field,(self):asJson_(value)))\r\nend),nil))\r\nend),(self):jsonHiddenNames());\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Object,"jsonHiddenNames",0
,function(self)
return (smalltalk:newArray({}));
end
,"converting","jsonHiddenNames\r\n\t\" Private - Return the names of the fields to skip when mapping the receiver to JSON structure. \"\r\n\r\n\t^#()","function(self)\r\nreturn (smalltalk:newArray({}));\r\nend")

smalltalk:bind(smalltalk.Object,"jsonFieldsDo:ignoring:",0
,function(self,aBlock,ignored)
return (((self)["$klass"]):allInstVarNamesDo_((function(each)
return (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((ignored))),(function()
return ((ignored):includes_(each))
end))),nil,(function()
return ((aBlock):value_value_(each,(self):instVarAt_(each)))
end)))
end)));
end
,"converting","jsonFieldsDo: aBlock ignoring: ignored\r\n\t\" Private - Evaluates a(TwoArguments)Block with the fields to map the receiver to JSON structure. \"\r\n\r\n\t^self class allInstVarNamesDo: [:each|\r\n\t\t(ignored notNil and: [ ignored includes: each ]) ifFalse: [\r\n\t\t\taBlock value: each value: (self instVarAt: each)\r\n\t\t].\r\n\t]","function(self,aBlock,ignored)\r\nreturn (((self)[\"$klass\"]):allInstVarNamesDo_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((ignored))),(function()\r\nreturn ((ignored):includes_(each))\r\nend))),nil,(function()\r\nreturn ((aBlock):value_value_(each,(self):instVarAt_(each)))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"jsonExportNil",0
,function(self)
return (false);
end
,"converting","jsonExportNil\r\n\t\" Private - Return true if the receiver export nil values. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.Object,"mustBeBoolean",0
,function(self)
return ((self):error_("Must be boolean."));
end
,"testing","mustBeBoolean\r\n\t\" Signal an error if the receiver is not a Boolean. \"\r\n\r\n\t^self error: 'Must be boolean.'","function(self)\r\nreturn ((self):error_(\"Must be boolean.\"));\r\nend")

smalltalk:bind(smalltalk.Boolean,"mustBeBoolean",0
,function(self)
return (self);
end
,"testing","mustBeBoolean\r\n\t\" Signal an error if the receiver is not a Boolean. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:addClass("Smalltalk",smalltalk.Object,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"current",0
,function(self)
return (smalltalk);
end
,"accessing","current\r\n\t\" Return the current instance of the receiver. \"\r\n\r\n\t^#{smalltalk} ","function(self)\r\nreturn (smalltalk);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"globalAt:",0
,function(self,aKey)
return ((self)[aKey]);
end
,"accessing","globalAt: aKey\r\n\t\" Return the global at aKey (or nil). \"\r\n\r\n\t^self basicAt: aKey","function(self,aKey)\r\nreturn ((self)[aKey]);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"globalAt:ifAbsent:",0
,function(self,aKey,aBlock)
return (smalltalk:basic_at_ifAbsent_((self),aKey,aBlock));
end
,"accessing","globalAt: aKey ifAbsent: aBlock\r\n\t\" Return the global at aKey (or the result of evaluating aBlock). \"\r\n\r\n\t^self basicAt: aKey ifAbsent: aBlock","function(self,aKey,aBlock)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),aKey,aBlock));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"rootClasses",0
,function(self)
return (((self):classes()):select_((function(each)
return (smalltalk:isNil_(((each):superclass())))
end)));
end
,"accessing","rootClasses\r\n\t\" Return the collection of topLevel classes in the receiver. \"\r\n\r\n\t^self classes select: [:each| each superclass isNil ]","function(self)\r\nreturn (((self):classes()):select_((function(each)\r\nreturn (smalltalk:isNil_(((each):superclass())))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"at:",0
,function(self,aGlobalName)
return (smalltalk:basic_at_ifAbsent_((self),aGlobalName,(function()
return (nil)
end)));
end
,"accessing","at: aGlobalName\r\n\t\" Return the global known as aGlobalName in the receiver (or nil). \"\r\n\r\n\t^self basicAt: aGlobalName ifAbsent: [ nil ]","function(self,aGlobalName)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),aGlobalName,(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"at:ifAbsent:",0
,function(self,aGlobalName,aBlock)
return (smalltalk:basic_at_ifAbsent_((self),aGlobalName,aBlock));
end
,"accessing","at: aGlobalName ifAbsent: aBlock\r\n\t\" Return the value at aKey or the result of evaluating aBlock. \"\r\n\r\n\t^self basicAt: aGlobalName ifAbsent: aBlock","function(self,aGlobalName,aBlock)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),aGlobalName,aBlock));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"at:ifAbsentPut:",0
,function(self,aGlobalName,aBlock)
return ((self):basicAt_ifAbsentPut_(aGlobalName,aBlock));
end
,"accessing","at: aGlobalName ifAbsentPut: aBlock\r\n\t\" Return the global known as aGlobalName in the receiver or the result of evaluating aBlock.\r\n\tSet the global to return value if was absent.\r\n\t\"\r\n\r\n\t^self basicAt: aGlobalName ifAbsentPut: aBlock","function(self,aGlobalName,aBlock)\r\nreturn ((self):basicAt_ifAbsentPut_(aGlobalName,aBlock));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"at:put:",0
,function(self,aGlobalName,anObject)
return (smalltalk:basic_at_put_((self),aGlobalName,anObject));
end
,"accessing","at: aGlobalName put: anObject\r\n\t\" Set the global known as aGlobalName in the receiver top anObject. \"\r\n\r\n\t^self basicAt: aGlobalName put: anObject","function(self,aGlobalName,anObject)\r\nreturn (smalltalk:basic_at_put_((self),aGlobalName,anObject));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"includesKey:",0
,function(self,aGlobalName)
local none=nil
(function()
	local _s8_value=({})
	none=_s8_value
	return _s8_value
end)();
return (smalltalk:booleanNot_((((smalltalk:basic_at_ifAbsent_((self),aGlobalName,(function()
return (none)
end)))==none))));
end
,"testing","includesKey: aGlobalName\r\n\t\" Return true if the global aGlobalName is defined in the receiver. \"\r\n\r\n\t| none |\r\n\tnone := {'' doc'absence sentinel'}.\r\n\t^((self\r\n\t\tbasicAt: aGlobalName ifAbsent: [none])\r\n\t\t== none) not","function(self,aGlobalName)\r\nlocal none=nil\r\n(function()\r\n\tlocal _s8_value=({})\r\n\tnone=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:booleanNot_((((smalltalk:basic_at_ifAbsent_((self),aGlobalName,(function()\r\nreturn (none)\r\nend)))==none))));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"implementorsOf:",0
,function(self,aSymbol)
local result=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
((self):rootClasses()):do_((function(each)
return ((result):addAll_((each):implementorsOf_(aSymbol)))
end));
return (result);
end
,"accessing","implementorsOf: aSymbol\r\n\t\" Return the implementors of aSymbol. \"\r\n\r\n\t| result |\r\n\tresult := #().\r\n\tself rootClasses do: [:each|\r\n\t\tresult addAll: (each implementorsOf: aSymbol)\r\n\t].\r\n\t^result","function(self,aSymbol)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):rootClasses()):do_((function(each)\r\nreturn ((result):addAll_((each):implementorsOf_(aSymbol)))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"objectAt:ifAbsent:",0
,function(self,aName,aBlock)
local result=nil
(function()
	local _s8_value=((self):nativeObjectAt_ifAbsent_(aName,aBlock))
	result=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((result["yourself"]))),(function()
return (result)
end),nil));
end
,"accessing","objectAt: aName ifAbsent: aBlock\r\n\t\" Return the (global scoped) smalltalk object at aName or the result of evaluating aBlock (if undefined or not an Object instance). \"\r\n\r\n\t| result |\r\n\tresult := self nativeObjectAt: aName ifAbsent: aBlock.\r\n\t^result#yourself notNil ifTrue: [ result ]","function(self,aName,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):nativeObjectAt_ifAbsent_(aName,aBlock))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((result[\"yourself\"]))),(function()\r\nreturn (result)\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"jsObjectAt:ifAbsent:",0
,function(self,aName,aBlock)
(self):note_(smalltalk:object_comma_(("OBSOLETE")," - jsObjectAt:ifAbsent: "));
return ((self):nativeObjectAt_ifAbsent_(aName,aBlock));
end
,"accessing","jsObjectAt: aName ifAbsent: aBlock\r\n\t\" OBSOLETE - Return the (global) object at aName or the result of evaluating aBlock (if undefined). \"\r\n\r\nself note: #OBSOLETE ,' - jsObjectAt:ifAbsent: '.\r\n\t^self nativeObjectAt: aName ifAbsent: aBlock","function(self,aName,aBlock)\r\n(self):note_(smalltalk:object_comma_((\"OBSOLETE\"),\" - jsObjectAt:ifAbsent: \"));\r\nreturn ((self):nativeObjectAt_ifAbsent_(aName,aBlock));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"jsObjectAt:",0
,function(self,aName)
(self):note_(smalltalk:object_comma_(("OBSOLETE")," - jsObjectAt: "));
return ((self):nativeObjectAt_ifAbsent_(aName,(function()
return ((self):error_(smalltalk:object_comma_(("Undefined "),aName)))
end)));
end
,"accessing","jsObjectAt: aName\r\n\t\" OBSOLETE - Return the (global) object at aName. \"\r\n\r\nself note: #OBSOLETE ,' - jsObjectAt: '.\r\n\t^self nativeObjectAt: aName ifAbsent: [ self error: 'Undefined ',aName ]","function(self,aName)\r\n(self):note_(smalltalk:object_comma_((\"OBSOLETE\"),\" - jsObjectAt: \"));\r\nreturn ((self):nativeObjectAt_ifAbsent_(aName,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Undefined \"),aName)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"nativeObjectAt:ifAbsent:",0
,function(self,aName,aBlock)
return (smalltalk:basic_at_ifAbsent_(((smalltalk.Smalltalk):global()),aName,aBlock));
end
,"accessing","nativeObjectAt: aName ifAbsent: aBlock\r\n\t\" Return the (global) object at aName or the result of evaluating aBlock (if undefined). \"\r\n\r\n\t^Smalltalk global basicAt: aName ifAbsent: aBlock","function(self,aName,aBlock)\r\nreturn (smalltalk:basic_at_ifAbsent_(((smalltalk.Smalltalk):global()),aName,aBlock));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"nativeObjectAt:",0
,function(self,aName)
return ((self):nativeObjectAt_ifAbsent_(aName,(function()
return ((self):error_(smalltalk:object_comma_(("Undefined "),aName)))
end)));
end
,"accessing","nativeObjectAt: aName\r\n\t\" Return the (global) object at aName. \"\r\n\r\n\t^self nativeObjectAt: aName ifAbsent: [ self error: 'Undefined ',aName ]","function(self,aName)\r\nreturn ((self):nativeObjectAt_ifAbsent_(aName,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Undefined \"),aName)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"removeKey:ifAbsent:",0
,function(self,aKey,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
smalltalk:basic_at_ifAbsent_((self),aKey,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):value())
end
)()
error(_s8Ret_,0)
end)())
end));
(self):basicDelete_(aKey);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"removing","removeKey: aKey ifAbsent: aBlock\r\n\t\" Remove the binding at aKey. \"\r\n\r\n\tself basicAt: aKey ifAbsent: [ ^aBlock value ].\r\n\tself basicDelete: aKey","function(self,aKey,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nsmalltalk:basic_at_ifAbsent_((self),aKey,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(self):basicDelete_(aKey);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"definePool:",0
,function(self,poolName)
return ((self):definePool_with_(poolName,(smalltalk.Array):new()));
end
,"accessing","definePool: poolName\r\n\t\" Define the pool dictionary (if it is not defined yet). \"\r\n\r\n\t^self definePool: poolName with: Array new","function(self,poolName)\r\nreturn ((self):definePool_with_(poolName,(smalltalk.Array):new()));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"poolDictionary:ifAbsent:",0
,function(self,aPoolName,aBlock)
return (smalltalk:basic_at_ifAbsent_((self),aPoolName,(function()
return ((aBlock):value())
end)));
end
,"accessing","poolDictionary: aPoolName ifAbsent: aBlock\r\n\t\" Return the pool dictionary named aPoolName or the result of evaluating aBlock. \"\r\n\r\n\t^self basicAt: aPoolName ifAbsent: [ aBlock value ]","function(self,aPoolName,aBlock)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),aPoolName,(function()\r\nreturn ((aBlock):value())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"poolDictionary:",0
,function(self,aPoolName)
return ((self):poolDictionary_ifAbsent_(aPoolName,(function()
return ((self):definePool_(aPoolName))
end)));
end
,"accessing","poolDictionary: aPoolName\r\n\t\" Return the pool dictionary named aPoolName. \"\r\n\r\n\t^self poolDictionary: aPoolName ifAbsent: [\r\n\t\t\"self error: 'Missing Pool dictionary: ',aPoolName. \"\r\n\t\tself definePool: aPoolName\r\n\t]","function(self,aPoolName)\r\nreturn ((self):poolDictionary_ifAbsent_(aPoolName,(function()\r\nreturn ((self):definePool_(aPoolName))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"printDefinePool:with:",0
,function(self,poolName,tuples)
(self):print_(smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk.definePool_with_(\""),poolName)),"\",["));
(tuples):do_((function(tuple)
return (smalltalk:if_true_false_(((tuple):isArray()),(function()
return ((self):print_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("\t["),smalltalk:printString_(((tuple):first())))),",")),((tuple):last()):asNative())),"],")))
end),(function()
return ((self):print_(smalltalk:object_comma_((smalltalk:object_comma_(("\t"),(tuple):asNative())),",")))
end)))
end));
(self):print_("\t]);");
return (self);
end
,"compiling","printDefinePool: poolName with: tuples\r\n\t\" DEBUG - Dump definition of the pool dictionary. \"\r\n\r\n\tself print: 'smalltalk.definePool_with_(\"',poolName,'\",['.\r\n\ttuples do: [:tuple|\r\n\t\ttuple isArray ifTrue: [\r\n\t\t\tself print: '\t[',tuple first printString,',',tuple last asNative,'],'\r\n\t\t] ifFalse: [\r\n\t\t\tself print: '\t',tuple asNative ,','\r\n\t\t]\r\n\t].\r\n\tself print: '\t]);'.","function(self,poolName,tuples)\r\n(self):print_(smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.definePool_with_(\\\"\"),poolName)),\"\\\",[\"));\r\n(tuples):do_((function(tuple)\r\nreturn (smalltalk:if_true_false_(((tuple):isArray()),(function()\r\nreturn ((self):print_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"\\t[\"),smalltalk:printString_(((tuple):first())))),\",\")),((tuple):last()):asNative())),\"],\")))\r\nend),(function()\r\nreturn ((self):print_(smalltalk:object_comma_((smalltalk:object_comma_((\"\\t\"),(tuple):asNative())),\",\")))\r\nend)))\r\nend));\r\n(self):print_(\"\\t]);\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"definePool:with:",0
,function(self,poolName,tuples)
local dictionary=nil
local offset=nil
(function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((self),poolName,(function()
return (smalltalk:basic_at_put_((self),poolName,(smalltalk.PoolDictionary):new()))
end)))
	dictionary=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(0)
	offset=_s8_value
	return _s8_value
end)();
(tuples):do_((function(each)
return (smalltalk:if_true_false_(((each):isArray()),(function()
(dictionary):at_put_((each):first(),(each):last());return (smalltalk:if_true_false_((((each):last()):isNumber()),(function()
return ((function()
	local _s8_value=(((each):last()):_plus(1))
	offset=_s8_value
	return _s8_value
end)())
end),nil))
end),(function()
return (smalltalk:if_true_false_(((each):isNumber()),(function()
return ((function()
	local _s8_value=(each)
	offset=_s8_value
	return _s8_value
end)())
end),(function()
(dictionary):at_put_(each,offset);return ((function()
	local _s8_value=((offset):_plus(1))
	offset=_s8_value
	return _s8_value
end)())
end)))
end)))
end));
return (dictionary);
end
,"compiling","definePool: poolName with: tuples\r\n\t\" Define the pool dictionary. \"\r\n\r\n\t| dictionary offset |\r\n\tdictionary := self basicAt: poolName ifAbsent: [\r\n\t\tself basicAt: poolName put: PoolDictionary new\r\n\t].\r\n\toffset := 0.\r\n\ttuples do: [:each|\r\n\t\teach isArray ifTrue: [\r\n\t\t\tdictionary at: each first put: each last.\r\n\t\t\teach last isNumber ifTrue: [ offset := each last + 1 ].\r\n\t\t] ifFalse: [\r\n\t\t\teach isNumber ifTrue: [ offset := each ]\r\n\t\t\tifFalse: [\r\n\t\t\t\tdictionary at: each put: offset.\r\n\t\t\t\toffset := offset + 1.\r\n\t\t\t]\r\n\t\t]\r\n\t].\r\n\t^dictionary","function(self,poolName,tuples)\r\nlocal dictionary=nil\r\nlocal offset=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((self),poolName,(function()\r\nreturn (smalltalk:basic_at_put_((self),poolName,(smalltalk.PoolDictionary):new()))\r\nend)))\r\n\tdictionary=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\toffset=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(tuples):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):isArray()),(function()\r\n(dictionary):at_put_((each):first(),(each):last());return (smalltalk:if_true_false_((((each):last()):isNumber()),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(((each):last()):_plus(1))\r\n\toffset=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),nil))\r\nend),(function()\r\nreturn (smalltalk:if_true_false_(((each):isNumber()),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(each)\r\n\toffset=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),(function()\r\n(dictionary):at_put_(each,offset);return ((function()\r\n\tlocal _s8_value=((offset):_plus(1))\r\n\toffset=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)))\r\nend)))\r\nend));\r\nreturn (dictionary);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"state",0
,function(self)
return ((self)["$state"]);
end
,"accessing","state\r\n\t\" Return the state of the receiver (or nil). \"\r\n\r\n\t^self basicAt: '$state'","function(self)\r\nreturn ((self)[\"$state\"]);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"state:",0
,function(self,aState)
smalltalk:basic_at_put_((self),"$state",aState);
return (self);
end
,"accessing","state: aState\r\n\t\" Set the state of the receiver. \"\r\n\r\n\tself basicAt: '$state' put: aState","function(self,aState)\r\nsmalltalk:basic_at_put_((self),\"$state\",aState);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"withState:do:",0
,function(self,aState,aBlock)
local old=nil
(function()
	local _s8_value=((self):state())
	old=_s8_value
	return _s8_value
end)();
return (((function()
(self):state_(aState);return ((aBlock):value())
end)):ensure_((function()
return ((self):state_(old))
end)));
end
,"accessing","withState: aState do: aBlock\r\n\t\" Set the state of the receiver to aState during execution of aBlock. \"\r\n\r\n\t| old |\r\n\told := self state.\r\n\t^[\tself state: aState.\r\n\t\taBlock value\r\n\t] ensure: [\r\n\t\tself state: old\r\n\t]","function(self,aState,aBlock)\r\nlocal old=nil\r\n(function()\r\n\tlocal _s8_value=((self):state())\r\n\told=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((function()\r\n(self):state_(aState);return ((aBlock):value())\r\nend)):ensure_((function()\r\nreturn ((self):state_(old))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"@","_at"
,function(self,keyOrPath)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
if not (((keyOrPath):isArray()))==true then return (((self)["$klass"]):at_ifAbsent_(keyOrPath,(function()
return (nil)
end))); end;
(function()
	local _s8_value=((keyOrPath):inject_into_(self,(function(pool,key)
local value=nil
if (smalltalk:isNil_((((function()
	local _s8_value=((pool):_at(key))
	value=_s8_value
	return _s8_value
end)()))))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)(); end;return (value)
end)))
	result=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","@ keyOrPath\r\n\t\" Return the result of accessing the receiver at key or path (or nil). \"\r\n\r\n\t| result |\r\n\tkeyOrPath isArray ifFalse: [ ^self class at: keyOrPath ifAbsent: [] ].\r\n\tresult := keyOrPath inject: self into: [:pool :key | | value |\r\n\t\t(value := pool @ key) isNil ifTrue: [ ^nil ].\r\n\t\tvalue\r\n\t].\r\n\t^result","function(self,keyOrPath)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\nif not (((keyOrPath):isArray()))==true then return (((self)[\"$klass\"]):at_ifAbsent_(keyOrPath,(function()\r\nreturn (nil)\r\nend))); end;\r\n(function()\r\n\tlocal _s8_value=((keyOrPath):inject_into_(self,(function(pool,key)\r\nlocal value=nil\r\nif (smalltalk:isNil_((((function()\r\n\tlocal _s8_value=((pool):_at(key))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)()))))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return (value)\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"eval:",0
,function(self,anExpression)

	-- (req v5.3) local fn,err  = load(anExpression)
	function f() local r = anExpression; anExpression= ""; return r end -- (req v5.1)
	local fn,err  = load(f)
	if fn then return fn() else
		self:note_(" eval: Error "..err) --the expression must be a lua expression (including return)
		self:note_(" expression= "..anExpression)
		return nil
	end;
return (self);
end
,"eval","eval: anExpression\r\n\t\" Return the result of evaluating a native expression in global context. \"\r\n\r\n\t{'' doc'Native evaluation hook'}","function(self,anExpression)\r\n\r\n\t-- (req v5.3) local fn,err  = load(anExpression)\r\n\tfunction f() local r = anExpression; anExpression= \"\"; return r end -- (req v5.1)\r\n\tlocal fn,err  = load(f)\r\n\tif fn then return fn() else\r\n\t\tself:note_(\" eval: Error \"..err) --the expression must be a lua expression (including return)\r\n\t\tself:note_(\" expression= \"..anExpression)\r\n\t\treturn nil\r\n\tend;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"eval:as:",0
,function(self,anExpression,aState)
return ((self):withState_do_(aState,(function()
return ((self):eval_(anExpression))
end)));
end
,"eval","eval: anExpression as: aState\r\n\t\" Return the result of evaluating a native expression in global context.\r\n\tThe state of the system change to state while evaluating the expression.\r\n\t\"\r\n\r\n\t^self withState: aState do: [ self eval: anExpression ]","function(self,anExpression,aState)\r\nreturn ((self):withState_do_(aState,(function()\r\nreturn ((self):eval_(anExpression))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"capture:with:",0
,function(self,keyOrPath,aBlock)
if (smalltalk:isNil_((aBlock)))==true then return ((self):capture_with_(keyOrPath,(function(result)
return (result)
end))); end;
if (smalltalk:isNil_((keyOrPath)))==true then return ((aBlock):evaluateWith_(nil)); end;
if not (((keyOrPath):isString()))==true then return ((self):_at(keyOrPath)); end;
if ((keyOrPath):startsWith_("!"))==true then return ((aBlock):evaluateWith_((keyOrPath):fileIn())); end;
if ((keyOrPath):startsWith_("@"))==true then return ((self):_at((keyOrPath):asArrayOfSubstringsSeparatedBy_("@"))); end;
if ((keyOrPath):startsWith_("."))==true then return ((self):_at((keyOrPath):asArrayOfSubstringsSeparatedBy_("."))); end;
if not ((smalltalk:responds_to_((self),(keyOrPath))))==true then return ((aBlock):evaluateWith_(nil)); end;
if (smalltalk:isObject_equalTo_(((keyOrPath):argumentCount()),1))==true then return ((self):perform_with_(keyOrPath,aBlock)); end;
return ((aBlock):evaluateWith_((self):perform_(keyOrPath)));
end
,"tools","capture: keyOrPath with: aBlock\r\n\t\" Capture keyOrPath of the receiver and evaluate aBlock.\r\n\tDefault action will try to capture the object found and (potentially) evaluate aBlock with the result. \"\r\n\r\n\taBlock isNil ifTrue: [ ^self capture: keyOrPath with: [:result | result ] ].\r\n\tkeyOrPath isNil ifTrue: [ ^aBlock evaluateWith: nil ].\r\n\tkeyOrPath isString ifFalse: [ ^self @ keyOrPath ].\r\n\t(keyOrPath startsWith: $!) ifTrue: [ ^aBlock evaluateWith: keyOrPath fileIn ].\r\n\t(keyOrPath startsWith: $@) ifTrue: [ ^self @ (keyOrPath asArrayOfSubstringsSeparatedBy: $@) ].\r\n\t(keyOrPath startsWith: $.) ifTrue: [ ^self @ (keyOrPath asArrayOfSubstringsSeparatedBy: $.) ].\r\n\t(self respondsTo: keyOrPath) ifFalse: [ ^aBlock evaluateWith: nil ].\r\n\tkeyOrPath argumentCount = 1 ifTrue: [ ^self perform: keyOrPath with: aBlock ].\r\n\t^aBlock evaluateWith: (self perform: keyOrPath)","function(self,keyOrPath,aBlock)\r\nif (smalltalk:isNil_((aBlock)))==true then return ((self):capture_with_(keyOrPath,(function(result)\r\nreturn (result)\r\nend))); end;\r\nif (smalltalk:isNil_((keyOrPath)))==true then return ((aBlock):evaluateWith_(nil)); end;\r\nif not (((keyOrPath):isString()))==true then return ((self):_at(keyOrPath)); end;\r\nif ((keyOrPath):startsWith_(\"!\"))==true then return ((aBlock):evaluateWith_((keyOrPath):fileIn())); end;\r\nif ((keyOrPath):startsWith_(\"@\"))==true then return ((self):_at((keyOrPath):asArrayOfSubstringsSeparatedBy_(\"@\"))); end;\r\nif ((keyOrPath):startsWith_(\".\"))==true then return ((self):_at((keyOrPath):asArrayOfSubstringsSeparatedBy_(\".\"))); end;\r\nif not ((smalltalk:responds_to_((self),(keyOrPath))))==true then return ((aBlock):evaluateWith_(nil)); end;\r\nif (smalltalk:isObject_equalTo_(((keyOrPath):argumentCount()),1))==true then return ((self):perform_with_(keyOrPath,aBlock)); end;\r\nreturn ((aBlock):evaluateWith_((self):perform_(keyOrPath)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"removeSources",0
,function(self)
((self):classes()):do_((function(each)
return ((each):removeSources())
end));
return (self);
end
,"tools","removeSources\r\n\t\" Remove all development sources of the receiver. \"\r\n\r\n\tself classes do: [:each | each removeSources ]","function(self)\r\n((self):classes()):do_((function(each)\r\nreturn ((each):removeSources())\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"readJSON:",0
,function(self,anObject)
return ((self):readJSObject(anObject));
end
,"json","readJSON: anObject\r\n\t\" Return an object read from JSON map object anObject. \"\r\n\r\n\t^self #readJSObject: anObject","function(self,anObject)\r\nreturn ((self):readJSObject(anObject));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"shallowCopy",0
,function(self)
return (self);
end
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"deepCopy",0
,function(self)
return (self);
end
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"at:ifAbsent:",0
,function(self,aGlobalName,aBlock)
return (smalltalk:basic_at_ifAbsent_(((self):current()),aGlobalName,aBlock));
end
,"accessing","at: aGlobalName ifAbsent: aBlock\r\n\t\" Return the global known as aGlobalName in the receiver or the result of evaluating aBlock. \"\r\n\r\n\t^self current basicAt: aGlobalName ifAbsent: aBlock","function(self,aGlobalName,aBlock)\r\nreturn (smalltalk:basic_at_ifAbsent_(((self):current()),aGlobalName,aBlock));\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"includesKey:",0
,function(self,aGlobalName)
return (((self):current()):includesKey_(aGlobalName));
end
,"testing","includesKey: aGlobalName\r\n\t\" Return true if the global aGlobalName is defined in the receiver. \"\r\n\r\n\t^self current includesKey: aGlobalName","function(self,aGlobalName)\r\nreturn (((self):current()):includesKey_(aGlobalName));\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"at:",0
,function(self,aGlobalName)
return (smalltalk:basic_at_ifAbsent_(((self):current()),aGlobalName,(function()
return (nil)
end)));
end
,"accessing","at: aGlobalName\r\n\t\" Return the global known as aGlobalName in the receiver (or nil). \"\r\n\r\n\t^self current basicAt: aGlobalName ifAbsent: [ nil ]","function(self,aGlobalName)\r\nreturn (smalltalk:basic_at_ifAbsent_(((self):current()),aGlobalName,(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"at:put:",0
,function(self,aGlobalName,anObject)
return (smalltalk:basic_at_put_(((self):current()),aGlobalName,anObject));
end
,"accessing","at: aGlobalName put: anObject\r\n\t\" Set the global known as aGlobalName in the receiver top anObject. \"\r\n\r\n\t^self current basicAt: aGlobalName put: anObject","function(self,aGlobalName,anObject)\r\nreturn (smalltalk:basic_at_put_(((self):current()),aGlobalName,anObject));\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"at:ifAbsentPut:",0
,function(self,aGlobalName,aBlock)
return ((self):at_ifAbsent_(aGlobalName,(function()
return ((self):at_put_(aGlobalName,(aBlock):value()))
end)));
end
,"accessing","at: aGlobalName ifAbsentPut: aBlock\r\n\t\" Return the global known as aGlobalName in the receiver or the result of evaluating aBlock.\r\n\tSet the global to return value if was absent.\r\n\t\"\r\n\r\n\t^self at: aGlobalName ifAbsent: [\r\n\t\tself at: aGlobalName put: aBlock value\r\n\t]","function(self,aGlobalName,aBlock)\r\nreturn ((self):at_ifAbsent_(aGlobalName,(function()\r\nreturn ((self):at_put_(aGlobalName,(aBlock):value()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"removeKey:ifAbsent:",0
,function(self,aKey,aBlock)
return (((self):current()):removeKey_ifAbsent_(aKey,aBlock));
end
,"removing","removeKey: aKey ifAbsent: aBlock\r\n\t\" Remove the binding at aKey. \"\r\n\r\n\t^self current removeKey: aKey ifAbsent: aBlock","function(self,aKey,aBlock)\r\nreturn (((self):current()):removeKey_ifAbsent_(aKey,aBlock));\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"@","_at"
,function(self,aGlobalName)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local binding=nil
(function()
	local _s8_value=((self):at_ifAbsent_(aGlobalName,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.Array):new())
end
)()
error(_s8Ret_,0)
end)())
end)))
	binding=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.Array):with_(binding))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","@ aGlobalName\r\n\t\" Return a collection with the objects bound to aGlobalName (or an empty collection if global is not defined).\r\n\tIt is used in expressions like:\r\n\t\tSmalltalk @ #MyGlobal do: [:global| ... ]\r\n\t\"\r\n\r\n\t| binding |\r\n\tbinding := self at: aGlobalName ifAbsent: [ ^Array new ].\r\n\t^Array with: binding","function(self,aGlobalName)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal binding=nil\r\n(function()\r\n\tlocal _s8_value=((self):at_ifAbsent_(aGlobalName,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.Array):new())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tbinding=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.Array):with_(binding))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"definePool:with:",0
,function(self,poolName,tuples)
return (((self):current()):definePool_with_(poolName,tuples));
end
,"accessing","definePool: poolName with: tuples\r\n\t\" Define the pool dictionary. \"\r\n\r\n\t^self current definePool: poolName with: tuples","function(self,poolName,tuples)\r\nreturn (((self):current()):definePool_with_(poolName,tuples));\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"poolDictionary:ifAbsent:",0
,function(self,aPoolName,aBlock)
return (((self):current()):poolDictionary_ifAbsent_(aPoolName,aBlock));
end
,"accessing","poolDictionary: aPoolName ifAbsent: aBlock\r\n\t\" Return the pool dictionary named aPoolName or the result of evaluating aBlock. \"\r\n\r\n\t^self current poolDictionary: aPoolName ifAbsent: aBlock","function(self,aPoolName,aBlock)\r\nreturn (((self):current()):poolDictionary_ifAbsent_(aPoolName,aBlock));\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"objectAt:ifAbsent:",0
,function(self,aName,aBlock)
return (((self):current()):objectAt_ifAbsent_(aName,aBlock));
end
,"accessing","objectAt: aName ifAbsent: aBlock\r\n\t\" Return the (global scoped) smalltalk object at aName or the result of evaluating aBlock (if undefined or not an Object instance). \"\r\n\r\n\t^self current objectAt: aName ifAbsent: aBlock","function(self,aName,aBlock)\r\nreturn (((self):current()):objectAt_ifAbsent_(aName,aBlock));\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"jsObjectAt:ifAbsent:",0
,function(self,aName,aBlock)
(self):note_(smalltalk:object_comma_(("OBSOLETE")," - jsObjectAt:ifAbsent: "));
return (((self):current()):nativeObjectAt_ifAbsent_(aName,aBlock));
end
,"accessing","jsObjectAt: aName ifAbsent: aBlock\r\n\t\" OBSOLETE - Return the (global) object at aName or the result of evaluating aBlock (if undefined). \"\r\n\r\nself note: #OBSOLETE ,' - jsObjectAt:ifAbsent: '.\r\n\t^self current nativeObjectAt: aName ifAbsent: aBlock","function(self,aName,aBlock)\r\n(self):note_(smalltalk:object_comma_((\"OBSOLETE\"),\" - jsObjectAt:ifAbsent: \"));\r\nreturn (((self):current()):nativeObjectAt_ifAbsent_(aName,aBlock));\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"jsObjectAt:",0
,function(self,aName)
(self):note_(smalltalk:object_comma_(("OBSOLETE")," - jsObjectAt: "));
return ((self):nativeObjectAt_ifAbsent_(aName,(function()
return ((self):error_(smalltalk:object_comma_(("Undefined "),aName)))
end)));
end
,"accessing","jsObjectAt: aName\r\n\t\" OBSOLETE - Return the (global) object at aName. \"\r\n\r\nself note: #OBSOLETE ,' - jsObjectAt: '.\r\n\t^self nativeObjectAt: aName ifAbsent: [ self error: 'Undefined ',aName ]","function(self,aName)\r\n(self):note_(smalltalk:object_comma_((\"OBSOLETE\"),\" - jsObjectAt: \"));\r\nreturn ((self):nativeObjectAt_ifAbsent_(aName,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Undefined \"),aName)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"nativeObjectAt:ifAbsent:",0
,function(self,aName,aBlock)
return (((self):current()):nativeObjectAt_ifAbsent_(aName,aBlock));
end
,"accessing","nativeObjectAt: aName ifAbsent: aBlock\r\n\t\" Return the (global) object at aName or the result of evaluating aBlock (if undefined). \"\r\n\r\n\t^self current nativeObjectAt: aName ifAbsent: aBlock","function(self,aName,aBlock)\r\nreturn (((self):current()):nativeObjectAt_ifAbsent_(aName,aBlock));\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"nativeObjectAt:",0
,function(self,aName)
return ((self):nativeObjectAt_ifAbsent_(aName,(function()
return ((self):error_(smalltalk:object_comma_(("Undefined "),aName)))
end)));
end
,"accessing","nativeObjectAt: aName\r\n\t\" Return the (global) object at aName. \"\r\n\r\n\t^self nativeObjectAt: aName ifAbsent: [ self error: 'Undefined ',aName ]","function(self,aName)\r\nreturn ((self):nativeObjectAt_ifAbsent_(aName,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Undefined \"),aName)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"global",0
,function(self)
return (_G);
end
,"accessing","global\r\n\t\" Return the global context object. \"\r\n\r\n\t^{'' doc'get the global context object'}","function(self)\r\nreturn (_G);\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"install:as:",0
,function(self,aBlockClosure,functionName)
local old=nil
(function()
	local _s8_value=(((self):global())[functionName])
	old=_s8_value
	return _s8_value
end)();
smalltalk:basic_at_put_(((self):global()),functionName,aBlockClosure);
return (old);
end
,"installing","install: aBlockClosure as: functionName\r\n\t\" Install the aBlockClosure as a function in global scope. \"\r\n\r\n\t| old |\r\n\told := self global basicAt: functionName.\r\n\tself global basicAt: functionName put: aBlockClosure.\r\n\t^old","function(self,aBlockClosure,functionName)\r\nlocal old=nil\r\n(function()\r\n\tlocal _s8_value=(((self):global())[functionName])\r\n\told=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:basic_at_put_(((self):global()),functionName,aBlockClosure);\r\nreturn (old);\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"classes",0
,function(self)
return (((self):current()):classes());
end
,"accessing","classes\r\n\t\" Return the classes defined in current instance. \"\r\n\r\n\t^self current classes","function(self)\r\nreturn (((self):current()):classes());\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"rootClasses",0
,function(self)
return (((self):current()):rootClasses());
end
,"accessing","rootClasses\r\n\t\" Return the collection of topLevel classes in the receiver. \"\r\n\r\n\t^self current rootClasses","function(self)\r\nreturn (((self):current()):rootClasses());\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"implementorsOf:",0
,function(self,aSymbol)
return (((self):current()):implementorsOf_(aSymbol));
end
,"tools","implementorsOf: aSymbol\r\n\t\" Return the implementors of aSymbol. \"\r\n\r\n\t^self current implementorsOf: aSymbol","function(self,aSymbol)\r\nreturn (((self):current()):implementorsOf_(aSymbol));\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"isRunningOn:",0
,function(self,lang)
return (smalltalk:isObject_equalTo_(((self):nativeLanguage()),lang));
end
,"environment","isRunningOn: lang\r\n\t\" Private - Return true when running hosted by native lang execution environment. \"\r\n\r\n\t^self nativeLanguage = lang","function(self,lang)\r\nreturn (smalltalk:isObject_equalTo_(((self):nativeLanguage()),lang));\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"gc",0
,function(self)
if collectgarbage() then return true end;
return (false);
end
,"tools","gc\r\n\t\" Collect garbage. \"\r\n\r\n\t{'' doc'forced full garbage collection'}.\r\n\t^false","function(self)\r\nif collectgarbage() then return true end;\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"allMethodsDo:",0
,function(self,aBlock)
((self):classes()):do_((function(each)
(each):methodsDo_(aBlock);return (((each)["$klass"]):methodsDo_(aBlock))
end));
return (self);
end
,"iterating","allMethodsDo: aBlock\r\n\t\" Evaluates aBlock for all the methods in the current instance. \"\r\n\r\n\tself classes do: [:each|\r\n\t\teach methodsDo: aBlock.\r\n\t\teach class methodsDo: aBlock.\r\n\t]","function(self,aBlock)\r\n((self):classes()):do_((function(each)\r\n(each):methodsDo_(aBlock);return (((each)[\"$klass\"]):methodsDo_(aBlock))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"allSelectorsDo:",0
,function(self,aBlock)
local found=nil
(function()
	local _s8_value=((smalltalk.HashedSet):new())
	found=_s8_value
	return _s8_value
end)();
(self):allMethodsDo_((function(mth)
local msg=nil
(function()
	local _s8_value=((mth):selector())
	msg=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_(((found):includes_(msg)),nil,(function()
if (smalltalk:notNil_((aBlock)))==true then (aBlock):value_(msg); end;return ((found):add_(msg))
end)))
end));
return (found);
end
,"iterating","allSelectorsDo: aBlock\r\n\t\" Evaluates aBlock for all the selectors defined in the current instance. \"\r\n\r\n\t| found |\r\n\tfound := HashedSet new.\r\n\tself allMethodsDo: [:mth| | msg |\r\n\t\tmsg := mth selector.\r\n\t\t(found includes: msg) ifFalse: [\r\n\t\t\taBlock notNil ifTrue: [\r\n\t\t\t\taBlock value: msg\r\n\t\t\t].\r\n\t\t\tfound add: msg\r\n\t\t]\r\n\t].\r\n\t^found","function(self,aBlock)\r\nlocal found=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.HashedSet):new())\r\n\tfound=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):allMethodsDo_((function(mth)\r\nlocal msg=nil\r\n(function()\r\n\tlocal _s8_value=((mth):selector())\r\n\tmsg=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_(((found):includes_(msg)),nil,(function()\r\nif (smalltalk:notNil_((aBlock)))==true then (aBlock):value_(msg); end;return ((found):add_(msg))\r\nend)))\r\nend));\r\nreturn (found);\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"allSelectors",0
,function(self)
return (((self):allSelectorsDo_(nil)):sorted());
end
,"iterating","allSelectors\r\n\t\" Return all the selectors (sorted) defined in the current instance. \"\r\n\r\n\t^(self allSelectorsDo: nil) sorted","function(self)\r\nreturn (((self):allSelectorsDo_(nil)):sorted());\r\nend")

smalltalk:addClass("Behavior",smalltalk.Object,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.Behavior,"new",0
,function(self)
return (((self):basicNew()):initialize());
end
,"instantiation","new\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew initialize","function(self)\r\nreturn (((self):basicNew()):initialize());\r\nend")

smalltalk:bind(smalltalk.Behavior,"new:",0
,function(self,size)
return ((self):basicNew_(size));
end
,"instantiation","new: size\r\n\t\" Return an instance of the receiver of specified size. \"\r\n\r\n\t^self basicNew: size","function(self,size)\r\nreturn ((self):basicNew_(size));\r\nend")

smalltalk:bind(smalltalk.Behavior,"basicNew:",0
,function(self,size)
return ((self):invalidMessage_("basicNew:"));
end
,"instantiation","basicNew: size\r\n\t\" Return an instance of the receiver of specified size. \"\r\n\r\n\t^self invalidMessage: #basicNew:","function(self,size)\r\nreturn ((self):invalidMessage_(\"basicNew:\"));\r\nend")

smalltalk:bind(smalltalk.Behavior,"basicNew",0
,function(self)
return (self["$fn"]());
end
,"instantiation","basicNew\r\n\t\" Return a new (non-initialized) instance of the receiver. \"\r\n\r\n\t^{'' doc'native instantiation of class'}","function(self)\r\nreturn (self[\"$fn\"]());\r\nend")

smalltalk:bind(smalltalk.Behavior,"name",0
,function(self)
return ((self)["$className"]);
end
,"accessing","name\r\n\t\" Return the name of the receiver. \"\r\n\r\n\t^self basicAt: '$className'","function(self)\r\nreturn ((self)[\"$className\"]);\r\nend")

smalltalk:bind(smalltalk.Behavior,"superclass",0
,function(self)
return ((self)["$superclass"]);
end
,"accessing","superclass\r\n\t\" Return the superclass of the receiver. \"\r\n\r\n\t^self basicAt: '$superclass'","function(self)\r\nreturn ((self)[\"$superclass\"]);\r\nend")

smalltalk:bind(smalltalk.Behavior,"subclasses",0
,function(self)
return (((self):smalltalk()):subclasses(self));
end
,"accessing","subclasses\r\n\t\" Return the subclasses of the receiver. \"\r\n\r\n\t^self smalltalk #subclasses: self","function(self)\r\nreturn (((self):smalltalk()):subclasses(self));\r\nend")

smalltalk:bind(smalltalk.Behavior,"allSubclasses",0
,function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(self):allSubclassesDo_((function(each)
return ((result):add_(each))
end));
return (result);
end
,"testing","allSubclasses\r\n\t\" Return all the subclasses of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := Array new.\r\n\tself allSubclassesDo: [:each| result add: each ].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):allSubclassesDo_((function(each)\r\nreturn ((result):add_(each))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Behavior,"allSubclassesDo:",0
,function(self,aBlock)
((self):smalltalk()):allSubclassesDo(self,aBlock);
return (self);
end
,"testing","allSubclassesDo: aBlock\r\n\t\" Evaluates aBlock with all the subclasses of the receiver. \"\r\n\r\n\tself smalltalk #allSubclassesDo: self value: aBlock","function(self,aBlock)\r\n((self):smalltalk()):allSubclassesDo(self,aBlock);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"withAllSubclassesDo:",0
,function(self,aBlock)
(aBlock):value_(self);
(self):allSubclassesDo_(aBlock);
return (self);
end
,"testing","withAllSubclassesDo: aBlock\r\n\t\" Evaluates aBlock with the receiver and all the subclasses. \"\r\n\r\n\taBlock value: self.\r\n\tself allSubclassesDo: aBlock","function(self,aBlock)\r\n(aBlock):value_(self);\r\n(self):allSubclassesDo_(aBlock);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"withAllSubclasses",0
,function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):with_(self))
	result=_s8_value
	return _s8_value
end)();
(self):allSubclassesDo_((function(each)
return ((result):add_(each))
end));
return (result);
end
,"accessing","withAllSubclasses\r\n\t\" Return a collection with the receiver and all subclasses. \"\r\n\r\n\t| result |\r\n\tresult := Array with: self.\r\n\tself allSubclassesDo: [:each| result add: each ].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_(self))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):allSubclassesDo_((function(each)\r\nreturn ((result):add_(each))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Behavior,"allSuperclassesDo:",0
,function(self,aBlock)
local current=nil
(function()
	local _s8_value=((self):superclass())
	current=_s8_value
	return _s8_value
end)();
while ((function()
return (smalltalk:notNil_((current)))
end))() do (aBlock):value_(current);
(function()
	local _s8_value=((current):superclass())
	current=_s8_value
	return _s8_value
end)(); end;
return (self);
end
,"accessing","allSuperclassesDo: aBlock\r\n\t\" Evaluate aBlock with the superclasses of the receiver.\r\n\tThe superclasses are walked in inverse hierarchical order, i.e class Object is last.\r\n\t\"\r\n\r\n\t| current |\r\n\tcurrent := self superclass.\r\n\t[ current notNil ] whileTrue: [\r\n\t        aBlock value: current.\r\n\t\tcurrent := current superclass.\r\n\t]","function(self,aBlock)\r\nlocal current=nil\r\n(function()\r\n\tlocal _s8_value=((self):superclass())\r\n\tcurrent=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (smalltalk:notNil_((current)))\r\nend))() do (aBlock):value_(current);\r\n(function()\r\n\tlocal _s8_value=((current):superclass())\r\n\tcurrent=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"withAllSuperclassesDo:",0
,function(self,aBlock)
(aBlock):value_(self);
return ((self):allSuperclassesDo_(aBlock));
end
,"accessing","withAllSuperclassesDo: aBlock\r\n\t\" Evaluate aBlock with the receiver and it's superclasses.\r\n\tThe superclasses are walked in inverse hierarchical order, i.e class Object is last.\r\n\t\"\r\n\r\n\taBlock value: self.\r\n\t^self allSuperclassesDo: aBlock","function(self,aBlock)\r\n(aBlock):value_(self);\r\nreturn ((self):allSuperclassesDo_(aBlock));\r\nend")

smalltalk:bind(smalltalk.Behavior,"withAllSuperclasses",0
,function(self)
return (smalltalk:object_comma_(((smalltalk.Array):with_(self)),(self):allSuperclasses()));
end
,"accessing","withAllSuperclasses\r\n\t\" Return a collection with the receiver and all superclasses. \"\r\n\r\n\t^(Array with: self) , self allSuperclasses","function(self)\r\nreturn (smalltalk:object_comma_(((smalltalk.Array):with_(self)),(self):allSuperclasses()));\r\nend")

smalltalk:bind(smalltalk.Behavior,"allSuperclasses",0
,function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(self):allSuperclassesDo_((function(each)
return ((result):add_(each))
end));
return (result);
end
,"accessing","allSuperclasses\r\n\t\" Return a collection of all the superclasses of the receiver.\r\n\tThe superclasses are in inverse hierarchical order, i.e class Object is last.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := Array new.\r\n\tself allSuperclassesDo: [:each| result add: each ].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):allSuperclassesDo_((function(each)\r\nreturn ((result):add_(each))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Behavior,"inheritsFrom:",0
,function(self,aClass)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (((self)==aClass))==true then return (true); end;
(self):allSuperclassesDo_((function(each)
return (smalltalk:if_true_false_((((aClass)==each)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"testing","inheritsFrom: aClass\r\n\t\" Return true if the receiver inherits from aClass. \"\r\n\r\n\tself == aClass ifTrue: [ ^true ].\r\n\tself allSuperclassesDo: [:each|\r\n\t\taClass == each ifTrue: [ ^true ]\r\n\t].\r\n\t^false","function(self,aClass)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (((self)==aClass))==true then return (true); end;\r\n(self):allSuperclassesDo_((function(each)\r\nreturn (smalltalk:if_true_false_((((aClass)==each)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Behavior,"fn",0
,function(self)

return ((self)["$fn"]);
end
,"accessing","fn\r\n\t\" Private - Return the internal function of the receiver (or nil). \"\r\n\r\n\t{'self'}.\r\n\t^self basicAt: '$fn' ","function(self)\r\n\r\nreturn ((self)[\"$fn\"]);\r\nend")

smalltalk:bind(smalltalk.Behavior,"prototype",0
,function(self)

return (((self):fn())["prototype"]);
end
,"accessing","prototype\r\n\t\" Private - Return the prototype of the receiver (or nil). \"\r\n\r\n\t{'self'}.\r\n\t^self fn basicAt: #prototype ","function(self)\r\n\r\nreturn (((self):fn())[\"prototype\"]);\r\nend")

smalltalk:bind(smalltalk.Behavior,"privateMethods",0
,function(self)

return (((self):prototype())["$methods"]);
end
,"accessing","privateMethods\r\n\t\" Private, Internal - Return all the methods defined by the receiver. \"\r\n\r\n\t{'self'}.\r\n\t^self prototype basicAt: '$methods' ","function(self)\r\n\r\nreturn (((self):prototype())[\"$methods\"]);\r\nend")

smalltalk:bind(smalltalk.Behavior,"constructorName",0
,function(self)
local result=nil
local fn=nil
(function()
	local _s8_value=((self):fn())
	fn=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((fn)["name"])
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((result)))==true then if ((result):isEmpty())==true then return (nil); end;
if (smalltalk:isObject_equalTo_((result),"$s8Constructor"))==true then return (nil); end;
return (result); end;
(function()
	local _s8_value=(((smalltalk:toString_((fn))):upTo_("(")):asArrayOfSubstrings())
	result=_s8_value
	return _s8_value
end)();
if not ((smalltalk:isObject_equalTo_(((result):size()),2)))==true then return (nil); end;
return ((result):last());
end
,"accessing","constructorName\r\n\t\" Private - Return the name of the constructor of the receiver (or nil). \"\r\n\r\n\t| result fn |\r\n\tfn := self fn.\r\n\tresult := fn basicAt: #name.\r\n\tresult notNil ifTrue: [\r\n\t\tresult isEmpty ifTrue: [ ^nil ].\r\n\t\tresult = '$s8Constructor' ifTrue: [ ^nil ].\r\n\t\t^result\r\n\t].\r\n\tresult := (fn toString upTo: $() asArrayOfSubstrings.\r\n\tresult size = 2 ifFalse: [ ^nil ].\r\n\t^result last","function(self)\r\nlocal result=nil\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):fn())\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((fn)[\"name\"])\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((result)))==true then if ((result):isEmpty())==true then return (nil); end;\r\nif (smalltalk:isObject_equalTo_((result),\"$s8Constructor\"))==true then return (nil); end;\r\nreturn (result); end;\r\n(function()\r\n\tlocal _s8_value=(((smalltalk:toString_((fn))):upTo_(\"(\")):asArrayOfSubstrings())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:isObject_equalTo_(((result):size()),2)))==true then return (nil); end;\r\nreturn ((result):last());\r\nend")

smalltalk:bind(smalltalk.Behavior,"methodDictionary",0
,function(self)
return ((smalltalk.PoolDictionary):_at_at((self):privateMethods()));
end
,"accessing","methodDictionary\r\n\t\" Return a (pool)dictionary with the methods implemented by the receiver. \"\r\n\r\n\t^PoolDictionary @@ self privateMethods ","function(self)\r\nreturn ((smalltalk.PoolDictionary):_at_at((self):privateMethods()));\r\nend")

smalltalk:bind(smalltalk.Behavior,"methodsDo:",0
,function(self,aBlock)
((self):methodDictionary()):do_((function(mth)
return ((aBlock):value_(mth))
end));
return (self);
end
,"accessing","methodsDo: aBlock\r\n\t\" Evaluates aBlock for all the methods defined by the receiver. \"\r\n\r\n\tself methodDictionary do: [:mth| aBlock value: mth ]","function(self,aBlock)\r\n((self):methodDictionary()):do_((function(mth)\r\nreturn ((aBlock):value_(mth))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"compiledMethods",0
,function(self)
return (((self):methodDictionary()):values());
end
,"accessing","compiledMethods\r\n\t\" Return a collection with all the methods defined by the receiver. \"\r\n\r\n\t^self methodDictionary values","function(self)\r\nreturn (((self):methodDictionary()):values());\r\nend")

smalltalk:bind(smalltalk.Behavior,"selectorsDo:",0
,function(self,aBlock)
return ((((self):methodDictionary()):keys()):do_(aBlock));
end
,"accessing","selectorsDo: aBlock\r\n\t\" Evaluate aBlock for all the selectors implemented by the receiver. \"\r\n\r\n\t^self methodDictionary keys do: aBlock ","function(self,aBlock)\r\nreturn ((((self):methodDictionary()):keys()):do_(aBlock));\r\nend")

smalltalk:bind(smalltalk.Behavior,"selectors",0
,function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(self):selectorsDo_((function(each)
return ((result):add_(each))
end));
return (result);
end
,"accessing","selectors\r\n\t\" Return the selectors implemented by the receiver. \"\r\n\r\n\t| result |\r\n\tresult := Array new.\r\n\tself selectorsDo: [:each| result add: each ].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):selectorsDo_((function(each)\r\nreturn ((result):add_(each))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Behavior,"categorizedSelectors",0
,function(self)
local pool=nil
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	pool=_s8_value
	return _s8_value
end)();
(self):methodsDo_((function(mth)
local category=nil
(function()
	local _s8_value=((mth):category())
	category=_s8_value
	return _s8_value
end)();if (smalltalk:isNil_((category)))==true then (function()
	local _s8_value=("undefined")
	category=_s8_value
	return _s8_value
end)(); end;return (((pool):at_ifAbsentPut_(category,(function()
return ((smalltalk.Array):new())
end))):add_((mth):selector()))
end));
return ((((pool):keys()):sorted()):collect_((function(key)
return ((smalltalk.Array):with_with_(key,((pool):at_(key)):sorted()))
end)));
end
,"accessing","categorizedSelectors\r\n\t\" Return the selectors classified by category. \"\r\n\r\n\t| pool |\r\n\tpool := PoolDictionary new.\r\n\tself methodsDo: [:mth| | category |\r\n\t\tcategory := mth category.\r\n\t\tcategory isNil ifTrue: [ category := #undefined ].\r\n\t\t(pool at: category ifAbsentPut: [Array new]) add: mth selector\r\n\t].\r\n\t^pool keys sorted collect: [:key|\r\n\t\tArray with: key with: (pool at: key) sorted\r\n\t]","function(self)\r\nlocal pool=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tpool=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):methodsDo_((function(mth)\r\nlocal category=nil\r\n(function()\r\n\tlocal _s8_value=((mth):category())\r\n\tcategory=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isNil_((category)))==true then (function()\r\n\tlocal _s8_value=(\"undefined\")\r\n\tcategory=_s8_value\r\n\treturn _s8_value\r\nend)(); end;return (((pool):at_ifAbsentPut_(category,(function()\r\nreturn ((smalltalk.Array):new())\r\nend))):add_((mth):selector()))\r\nend));\r\nreturn ((((pool):keys()):sorted()):collect_((function(key)\r\nreturn ((smalltalk.Array):with_with_(key,((pool):at_(key)):sorted()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Behavior,"implements:",0
,function(self,aSymbol)
return (((self):methodDictionary()):includesKey_(aSymbol));
end
,"testing","implements: aSymbol\r\n\t\" Return true if the receiver implements message aSymbol. \"\r\n\r\n\t^self methodDictionary includesKey: aSymbol ","function(self,aSymbol)\r\nreturn (((self):methodDictionary()):includesKey_(aSymbol));\r\nend")

smalltalk:bind(smalltalk.Behavior,"compiledMethodAt:",0
,function(self,aSymbol)
return (((self):methodDictionary()):at_ifAbsent_(aSymbol,(function()
return (nil)
end)));
end
,"accessing","compiledMethodAt: aSymbol\r\n\t\" Return the compiled method at aSymbol implemented by the receiver (or nil). \"\r\n\r\n\t^self methodDictionary at: aSymbol ifAbsent: [] ","function(self,aSymbol)\r\nreturn (((self):methodDictionary()):at_ifAbsent_(aSymbol,(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Behavior,">>","_gt_gt"
,function(self,aSymbol)
return ((self):compiledMethodAt_(aSymbol));
end
,"accessing",">> aSymbol\r\n\t\" Return the method at aSymbol (or nil if not implemented by the receiver). \"\r\n\r\n\t^self compiledMethodAt: aSymbol","function(self,aSymbol)\r\nreturn ((self):compiledMethodAt_(aSymbol));\r\nend")

smalltalk:bind(smalltalk.Behavior,"compiledMethodFor:",0
,function(self,aSymbol)
local current=nil
local mth=nil
(function()
	local _s8_value=(self)
	current=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((current):compiledMethodAt_(aSymbol))
	mth=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((current):superclass())
	current=_s8_value
	return _s8_value
end)();return (smalltalk:boolean_and_((smalltalk:isNil_((mth))),(function()
return (smalltalk:notNil_((current)))
end)))
end))() do end;
return (mth);
end
,"accessing","compiledMethodFor: aSymbol\r\n\t\" Return the method at aSymbol searching up in receiver's hierarchy (or nil). \"\r\n\r\n\t| current mth |\r\n\tcurrent := self.\r\n\t[\tmth := current compiledMethodAt: aSymbol.\r\n\t\tcurrent := current superclass.\r\n\t\tmth isNil and: [ current notNil ]\r\n\t] whileTrue.\r\n\t^mth ","function(self,aSymbol)\r\nlocal current=nil\r\nlocal mth=nil\r\n(function()\r\n\tlocal _s8_value=(self)\r\n\tcurrent=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((current):compiledMethodAt_(aSymbol))\r\n\tmth=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((current):superclass())\r\n\tcurrent=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:boolean_and_((smalltalk:isNil_((mth))),(function()\r\nreturn (smalltalk:notNil_((current)))\r\nend)))\r\nend))() do end;\r\nreturn (mth);\r\nend")

smalltalk:bind(smalltalk.Behavior,">>>","_gt_gt_gt"
,function(self,aSymbol)
return ((self):compiledMethodFor_(aSymbol));
end
,"accessing",">>> aSymbol\r\n\t\" OBSOLETE - Return the method at aSymbol searching up in receiver's hierarchy (or nil if not implemented by the receiver nor its superclasses). \"\r\n\r\n\t^self compiledMethodFor: aSymbol ","function(self,aSymbol)\r\nreturn ((self):compiledMethodFor_(aSymbol));\r\nend")

smalltalk:bind(smalltalk.Behavior,"instVarNames",0
,function(self)
return ((self):basicAt_ifAbsentPut_("$iVarNames",(function()
return (smalltalk:newArray({}))
end)));
end
,"accessing","instVarNames\r\n\t\" Return the instance variable names of the receiver. \"\r\n\r\n\t^self basicAt: '$iVarNames' ifAbsentPut: [#()]","function(self)\r\nreturn ((self):basicAt_ifAbsentPut_(\"$iVarNames\",(function()\r\nreturn (smalltalk:newArray({}))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Behavior,"instVarNamesDo:",0
,function(self,aBlock)
local array=nil
(function()
	local _s8_value=((self)["$iVarNames"])
	array=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((array))),(function()
return ((array):do_(aBlock))
end),nil));
end
,"accessing","instVarNamesDo: aBlock\r\n\t\" Evaluate aBlock with the instance variable names of the receiver. \"\r\n\r\n\t| array |\r\n\tarray := self basicAt: '$iVarNames'.\r\n\t^array notNil ifTrue: [ array do: aBlock ]","function(self,aBlock)\r\nlocal array=nil\r\n(function()\r\n\tlocal _s8_value=((self)[\"$iVarNames\"])\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((array))),(function()\r\nreturn ((array):do_(aBlock))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.Behavior,"allInstVarNames",0
,function(self)
local result=nil
(function()
	local _s8_value=((self):instVarNames())
	result=_s8_value
	return _s8_value
end)();
(self):allSuperclassesDo_((function(each)
return ((function()
	local _s8_value=(smalltalk:object_comma_(((each):instVarNames()),result))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
,"accessing","allInstVarNames\r\n\t\" Return all of the instance variable names defined in the receiver and its superclasses. \"\r\n\r\n\t| result |\r\n\tresult := self instVarNames.\r\n\tself allSuperclassesDo: [ :each | result := each instVarNames , result ].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):instVarNames())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):allSuperclassesDo_((function(each)\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((each):instVarNames()),result))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Behavior,"instanceVariableNames",0
,function(self)
return ((self):instVarNames());
end
,"accessing","instanceVariableNames\r\n\t\" Return the instance variable names defined by the receiver. \"\r\n\r\n\t^self instVarNames","function(self)\r\nreturn ((self):instVarNames());\r\nend")

smalltalk:bind(smalltalk.Behavior,"propertyNames",0
,function(self)
return (smalltalk:basic_at_ifAbsent_((self),"$propertyNames",(function()
return ((smalltalk.Array):new())
end)));
end
,"accessing","propertyNames\r\n\t\" Return the property names of the receiver. \"\r\n\r\n\t^self basicAt: '$propertyNames' ifAbsent: [ Array new ]","function(self)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),\"$propertyNames\",(function()\r\nreturn ((smalltalk.Array):new())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Behavior,"propertyNames:",0
,function(self,anArray)
if (smalltalk:isNil_((anArray)))==true then return ((self):basicDelete_("$propertyNames")); end;
return (smalltalk:basic_at_put_((self),"$propertyNames",anArray));
end
,"accessing","propertyNames: anArray\r\n\t\" Set the property names of the receiver. \"\r\n\r\n\tanArray isNil ifTrue: [ ^self basicDelete: '$propertyNames' ].\r\n\t^self basicAt: '$propertyNames' put: anArray","function(self,anArray)\r\nif (smalltalk:isNil_((anArray)))==true then return ((self):basicDelete_(\"$propertyNames\")); end;\r\nreturn (smalltalk:basic_at_put_((self),\"$propertyNames\",anArray));\r\nend")

smalltalk:bind(smalltalk.Behavior,"allPropertyNamesDo:",0
,function(self,aBlock)
((self):propertyNames()):do_(aBlock);
(self):allSuperclassesDo_((function(each)
return (((each):propertyNames()):do_(aBlock))
end));
return (self);
end
,"accessing","allPropertyNamesDo: aBlock\r\n\t\" Evaluates aBlock for the property names defined in the receiver and its superclasses. \"\r\n\r\n\tself propertyNames do: aBlock.\r\n\tself allSuperclassesDo: [ :each | each propertyNames do: aBlock ].","function(self,aBlock)\r\n((self):propertyNames()):do_(aBlock);\r\n(self):allSuperclassesDo_((function(each)\r\nreturn (((each):propertyNames()):do_(aBlock))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"allInstVarNamesDo:",0
,function(self,aBlock)
(self):instVarNamesDo_(aBlock);
(self):allSuperclassesDo_((function(each)
return ((each):instVarNamesDo_(aBlock))
end));
return (self);
end
,"accessing","allInstVarNamesDo: aBlock\r\n\t\" Evaluates aBlock for the instance variable names defined in the receiver and its superclasses. \"\r\n\r\n\tself instVarNamesDo: aBlock.\r\n\tself allSuperclassesDo: [ :each | each instVarNamesDo: aBlock ].","function(self,aBlock)\r\n(self):instVarNamesDo_(aBlock);\r\n(self):allSuperclassesDo_((function(each)\r\nreturn ((each):instVarNamesDo_(aBlock))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"comment",0
,function(self)
return (smalltalk:basic_at_ifAbsent_(((self):instanceClass()),"$comment",(function()
return ("")
end)));
end
,"accessing","comment\r\n\t\" Return the comment of the receiver. \"\r\n\r\n\t^self instanceClass basicAt: '$comment' ifAbsent: [ '' ]","function(self)\r\nreturn (smalltalk:basic_at_ifAbsent_(((self):instanceClass()),\"$comment\",(function()\r\nreturn (\"\")\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Behavior,"basicComment:",0
,function(self,aString)
smalltalk:basic_at_put_(((self):instanceClass()),"$comment",aString);
return (self);
end
,"private","basicComment: aString\r\n\t\" Set the comment of the receiver. \"\r\n\r\n\tself instanceClass basicAt: '$comment' put: aString","function(self,aString)\r\nsmalltalk:basic_at_put_(((self):instanceClass()),\"$comment\",aString);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"comment:",0
,function(self,aString)
((smalltalk.ClassBuilder):new()):class_comment_((self):instanceClass(),aString);
return (self);
end
,"accessing","comment: aString\r\n\t\" Set the comment of the receiver. \"\r\n\r\n\tClassBuilder new\r\n\t\tclass: self instanceClass\r\n\t\tcomment: aString","function(self,aString)\r\n((smalltalk.ClassBuilder):new()):class_comment_((self):instanceClass(),aString);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"removeSources",0
,function(self)
((self):instanceClass()):removeSources();
return (self);
end
,"tools","removeSources\r\n\t\" Remove all development sources of the receiver. \"\r\n\r\n\tself instanceClass removeSources","function(self)\r\n((self):instanceClass()):removeSources();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"poolDictionaries",0
,function(self)
return (((self):instanceClass()):poolDictionaries());
end
,"accessing","poolDictionaries\r\n\t\" Return the poolDictionaries of the receiver. \"\r\n\r\n\t^self instanceClass poolDictionaries","function(self)\r\nreturn (((self):instanceClass()):poolDictionaries());\r\nend")

smalltalk:bind(smalltalk.Behavior,"poolDictionaryNames",0
,function(self)
return (((self):instanceClass()):poolDictionaryNames());
end
,"accessing","poolDictionaryNames\r\n\t\" Return the shared pool names of the receiver. \"\r\n\r\n\t^self instanceClass poolDictionaryNames","function(self)\r\nreturn (((self):instanceClass()):poolDictionaryNames());\r\nend")

smalltalk:bind(smalltalk.Behavior,"sharedPoolsAndNamesDo:",0
,function(self,aBlock)
local pool=nil
((self):instanceClass()):withAllSuperclassesDo_((function(each)
return (((each):poolDictionaryNames()):do_((function(aName)
(function()
	local _s8_value=((smalltalk.Smalltalk):poolDictionary_ifAbsent_(aName,(function()
return (nil)
end)))
	pool=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((pool))),(function()
return ((aBlock):value_value_(aName,pool))
end),nil))
end)))
end));
return (self);
end
,"accessing","sharedPoolsAndNamesDo: aBlock\r\n\t\" Execute aBlock for the pool dictionaries known by the receiver. \"\r\n\r\n\t| pool |\r\n\tself instanceClass withAllSuperclassesDo: [:each|\r\n\t\teach poolDictionaryNames do: [:aName|\r\n\t\t\tpool := Smalltalk poolDictionary: aName ifAbsent: [ nil ].\r\n\t\t\tpool notNil ifTrue: [ aBlock value: aName value: pool ]\r\n\t\t].\r\n\t]","function(self,aBlock)\r\nlocal pool=nil\r\n((self):instanceClass()):withAllSuperclassesDo_((function(each)\r\nreturn (((each):poolDictionaryNames()):do_((function(aName)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):poolDictionary_ifAbsent_(aName,(function()\r\nreturn (nil)\r\nend)))\r\n\tpool=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((pool))),(function()\r\nreturn ((aBlock):value_value_(aName,pool))\r\nend),nil))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"sharedPoolsDo:",0
,function(self,aBlock)
(self):sharedPoolsAndNamesDo_((function(aName,aPool)
return ((aBlock):value_(aPool))
end));
return (self);
end
,"accessing","sharedPoolsDo: aBlock\r\n\t\" Execute aBlock for the pool dictionaries known by the receiver. \"\r\n\r\n\tself sharedPoolsAndNamesDo: [:aName :aPool| aBlock value: aPool ]","function(self,aBlock)\r\n(self):sharedPoolsAndNamesDo_((function(aName,aPool)\r\nreturn ((aBlock):value_(aPool))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"classVariablesDo:",0
,function(self,aBlock)
local bindings=nil
return (((self):instanceClass()):withAllSuperclassesDo_((function(each)
(function()
	local _s8_value=((each):classVariables())
	bindings=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((bindings))),(function()
return ((bindings):associationsDo_((function(assoc)
return ((aBlock):value_(assoc))
end)))
end),nil))
end)));
end
,"accessing","classVariablesDo: aBlock\r\n\t\" Execute aBlock for the classVariables bindings known by the receiver. \"\r\n\r\n\t| bindings |\r\n\t^self instanceClass withAllSuperclassesDo: [:each|\r\n\t\tbindings := each classVariables.\r\n\t\tbindings notNil ifTrue: [\r\n\t\t\tbindings associationsDo: [:assoc| aBlock value: assoc ]\r\n\t\t]\r\n\t]","function(self,aBlock)\r\nlocal bindings=nil\r\nreturn (((self):instanceClass()):withAllSuperclassesDo_((function(each)\r\n(function()\r\n\tlocal _s8_value=((each):classVariables())\r\n\tbindings=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((bindings))),(function()\r\nreturn ((bindings):associationsDo_((function(assoc)\r\nreturn ((aBlock):value_(assoc))\r\nend)))\r\nend),nil))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Behavior,"classVariableNamesDo:",0
,function(self,aBlock)
local bindings=nil
return (((self):instanceClass()):withAllSuperclassesDo_((function(each)
(function()
	local _s8_value=((each):classVariables())
	bindings=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((bindings))),(function()
return ((bindings):keysDo_((function(aName)
return ((aBlock):value_(aName))
end)))
end),nil))
end)));
end
,"accessing","classVariableNamesDo: aBlock\r\n\t\" Execute aBlock for the classVariable names known by the receiver. \"\r\n\r\n\t| bindings |\r\n\t^self instanceClass withAllSuperclassesDo: [:each|\r\n\t\tbindings := each classVariables.\r\n\t\tbindings notNil ifTrue: [\r\n\t\t\tbindings keysDo: [:aName| aBlock value: aName ]\r\n\t\t]\r\n\t]","function(self,aBlock)\r\nlocal bindings=nil\r\nreturn (((self):instanceClass()):withAllSuperclassesDo_((function(each)\r\n(function()\r\n\tlocal _s8_value=((each):classVariables())\r\n\tbindings=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((bindings))),(function()\r\nreturn ((bindings):keysDo_((function(aName)\r\nreturn ((aBlock):value_(aName))\r\nend)))\r\nend),nil))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Behavior,"classVariableAt:put:",0
,function(self,aName,anObject)
return ((((self):instanceClass()):classVariables()):at_put_(aName,anObject));
end
,"accessing","classVariableAt: aName put: anObject\r\n\t\" Set the classVariable of the receiver to anObject. \"\r\n\r\n\t^self instanceClass classVariables at: aName put: anObject","function(self,aName,anObject)\r\nreturn ((((self):instanceClass()):classVariables()):at_put_(aName,anObject));\r\nend")

smalltalk:bind(smalltalk.Behavior,"classVariableAt:ifAbsent:",0
,function(self,aName,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local bindings=nil
((self):instanceClass()):withAllSuperclassesDo_((function(each)
(function()
	local _s8_value=((each):classVariables())
	bindings=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((bindings))),(function()
return (smalltalk:if_true_false_(((bindings):includesKey_(aName)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((bindings):at_(aName))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):evaluate())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","classVariableAt: aName ifAbsent: aBlock\r\n\t\" Return the value of classVariable named aName. \"\r\n\r\n\t| bindings |\r\n\tself instanceClass withAllSuperclassesDo: [:each|\r\n\t\tbindings := each classVariables.\r\n\t\tbindings notNil ifTrue: [\r\n\t\t\t(bindings includesKey: aName) ifTrue: [\r\n\t\t\t\t^bindings at: aName\r\n\t\t\t]\r\n\t\t]\r\n\t].\r\n\t^aBlock evaluate","function(self,aName,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal bindings=nil\r\n((self):instanceClass()):withAllSuperclassesDo_((function(each)\r\n(function()\r\n\tlocal _s8_value=((each):classVariables())\r\n\tbindings=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((bindings))),(function()\r\nreturn (smalltalk:if_true_false_(((bindings):includesKey_(aName)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((bindings):at_(aName))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):evaluate())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Behavior,"classVariableAt:",0
,function(self,aName)
return ((self):classVariableAt_ifAbsent_(aName,(function()
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Undefined class variable "),aName))," in ")),(self):name())))
end)));
end
,"accessing","classVariableAt: aName\r\n\t\" Return the value of classVariable named aName or generates an error. \"\r\n\r\n\t^self classVariableAt: aName ifAbsent: [\r\n\t\tself error: 'Undefined class variable ',aName ,' in ' ,self name\r\n\t]","function(self,aName)\r\nreturn ((self):classVariableAt_ifAbsent_(aName,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Undefined class variable \"),aName)),\" in \")),(self):name())))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Behavior,"pool:variableAt:put:",0
,function(self,poolName,aName,anObject)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local pool=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):poolDictionary_ifAbsent_(poolName,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Undefined pool variable "),poolName))," in ")),(self):name())))
end
)()
error(_s8Ret_,0)
end)())
end)))
	pool=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((pool):at_put_(aName,anObject))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","pool: poolName variableAt: aName put: anObject\r\n\t\" Set the pool Variable of the receiver to anObject. \"\r\n\r\n\t| pool |\r\n\tpool := Smalltalk\r\n\t\tpoolDictionary: poolName\r\n\t\tifAbsent: [ ^self error: 'Undefined pool variable ',poolName ,' in ' ,self name ].\r\n\t^pool at: aName put: anObject","function(self,poolName,aName,anObject)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal pool=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):poolDictionary_ifAbsent_(poolName,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Undefined pool variable \"),poolName)),\" in \")),(self):name())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tpool=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((pool):at_put_(aName,anObject))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Behavior,"loadRequirementsInto:for:",0
,function(self,aCollection,anEncoder)
return (self);
end
,"loading","loadRequirementsInto: aCollection for: anEncoder\r\n\t\" Add the requirements to load the receiver from sources to aCollection.\r\n\tDefault action do nothing, this method can be refined by the subclasses.\r\n\t\"\r\n\r\n\t^self","function(self,aCollection,anEncoder)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"removeSelectors:",0
,function(self,aCollection)
(aCollection):do_((function(each)
return ((self):removeSelector_(each))
end));
return (self);
end
,"methods","removeSelectors: aCollection\r\n\t\" Remove the methods for messages in aCollection, implemented by the receiver. \"\r\n\r\n\taCollection do: [:each| self removeSelector: each ]","function(self,aCollection)\r\n(aCollection):do_((function(each)\r\nreturn ((self):removeSelector_(each))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"removeCompiledMethod:",0
,function(self,aMethod)
((self):smalltalk()):removeMethod(self,aMethod);
return (self);
end
,"private","removeCompiledMethod: aMethod\r\n\t\" Remove aMethod from the receiver. \"\r\n\r\n\tself smalltalk #removeMethod: self method: aMethod","function(self,aMethod)\r\n((self):smalltalk()):removeMethod(self,aMethod);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"missingImplementorFor:",0
,function(self,jsSelector)
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Missing implementor for "),((jsSelector):asNativeSelector()):asLiteral()))," in ")),(self):name())));
end
,"private","missingImplementorFor: jsSelector\r\n\t\" Private - Handle the situation where there is no implementor for jsSelector.\r\n\tThis can happen when there is no implementation for jsSelector and the message\r\n\t has been dispatched through a superSend.\r\n\t\"\r\n\r\n\t^self error: 'Missing implementor for '\r\n\t\t, jsSelector asNativeSelector asLiteral\r\n\t\t,' in ',self name","function(self,jsSelector)\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Missing implementor for \"),((jsSelector):asNativeSelector()):asLiteral())),\" in \")),(self):name())));\r\nend")

smalltalk:bind(smalltalk.Behavior,"removeSelector:",0
,function(self,aSelector)
local method=nil
(function()
	local _s8_value=((self):compiledMethodAt_(aSelector))
	method=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((method)))==true then (self):removeCompiledMethod_(method); end;
return (self);
end
,"methods","removeSelector: aSelector\r\n\t\" Remove the method for message aSelector implemented by the receiver. \"\r\n\r\n\t| method |\r\n\tmethod := self compiledMethodAt: aSelector.\r\n\tmethod notNil ifTrue: [ self removeCompiledMethod: method ].","function(self,aSelector)\r\nlocal method=nil\r\n(function()\r\n\tlocal _s8_value=((self):compiledMethodAt_(aSelector))\r\n\tmethod=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((method)))==true then (self):removeCompiledMethod_(method); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"removeFromSystem",0
,function(self)
return (((self):instanceClass()):removeFromSystem());
end
,"remove","removeFromSystem\r\n\t\" Remove the receiver from system. \"\r\n\r\n\t^self instanceClass removeFromSystem ","function(self)\r\nreturn (((self):instanceClass()):removeFromSystem());\r\nend")

smalltalk:bind(smalltalk.Behavior,"implementorsOf:",0
,function(self,aSymbol)
local result=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
(self):withAllSubclassesDo_((function(each)
local method=nil
(function()
	local _s8_value=((each):_gt_gt(aSymbol))
	method=_s8_value
	return _s8_value
end)();if (smalltalk:notNil_((method)))==true then (result):add_(method); end;(function()
	local _s8_value=(((each)["$klass"]):_gt_gt(aSymbol))
	method=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((method))),(function()
return ((result):add_(method))
end),nil))
end));
return (result);
end
,"testing","implementorsOf: aSymbol\r\n\t\" Return the implementors of aSymbol in the receiver and its subclasses. \"\r\n\r\n\t| result |\r\n\tresult := #().\r\n\tself withAllSubclassesDo: [:each | | method |\r\n\t\tmethod := each >> aSymbol.\r\n\t\tmethod notNil ifTrue: [ result add: method ].\r\n\t\tmethod := each class >> aSymbol.\r\n\t\tmethod notNil ifTrue: [ result add: method ].\r\n\t].\r\n\t^result","function(self,aSymbol)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):withAllSubclassesDo_((function(each)\r\nlocal method=nil\r\n(function()\r\n\tlocal _s8_value=((each):_gt_gt(aSymbol))\r\n\tmethod=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:notNil_((method)))==true then (result):add_(method); end;(function()\r\n\tlocal _s8_value=(((each)[\"$klass\"]):_gt_gt(aSymbol))\r\n\tmethod=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((method))),(function()\r\nreturn ((result):add_(method))\r\nend),nil))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Behavior,"asJSONObject",0
,function(self)
return (self);
end
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"shallowCopy",0
,function(self)
return (self);
end
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"deepCopy",0
,function(self)
return (self);
end
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"toString",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(("{st:"),(self):name())),"}"));
end
,"converting","toString\r\n\t\" Return the receiver as a String. \"\r\n\r\n\t^'{st:',self name,$}","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"{st:\"),(self):name())),\"}\"));\r\nend")

smalltalk:addClass("Class",smalltalk.Behavior,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.Class,"category",0
,function(self)
return ((self)["$category"]);
end
,"accessing","category\r\n\t\" Return the category of the receiver. \"\r\n\r\n\t^self basicAt: '$category'","function(self)\r\nreturn ((self)[\"$category\"]);\r\nend")

smalltalk:bind(smalltalk.Class,"category:",0
,function(self,aString)
smalltalk:basic_at_put_((self),"$category",aString);
return (self);
end
,"accessing","category: aString\r\n\t\" Set the category of the receiver. \"\r\n\r\n\tself basicAt: '$category' put: aString","function(self,aString)\r\nsmalltalk:basic_at_put_((self),\"$category\",aString);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Class,"classVariables",0
,function(self)
local names=nil
(function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((self),"$classVariableNames",(function()
return (nil)
end)))
	names=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((names)))==true then return ((self)["$classVariables"]); end;
(self):basicDelete_("$classVariableNames");
(self):classVariableNames_(names);
return ((self)["$classVariables"]);
end
,"accessing","classVariables\r\n\t\" Return the class variables of the receiver. \"\r\n\r\n\t| names |\r\n\tnames := self basicAt: '$classVariableNames' ifAbsent: [].\r\n\tnames isNil ifTrue: [ ^self basicAt: '$classVariables' ].\r\n\tself basicDelete: '$classVariableNames'.\r\n\tself classVariableNames: names.\r\n\t^self basicAt: '$classVariables'","function(self)\r\nlocal names=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((self),\"$classVariableNames\",(function()\r\nreturn (nil)\r\nend)))\r\n\tnames=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((names)))==true then return ((self)[\"$classVariables\"]); end;\r\n(self):basicDelete_(\"$classVariableNames\");\r\n(self):classVariableNames_(names);\r\nreturn ((self)[\"$classVariables\"]);\r\nend")

smalltalk:bind(smalltalk.Class,"classVariables:",0
,function(self,aDictionary)
if (smalltalk:boolean_or_((smalltalk:isNil_((aDictionary))),(function()
return ((aDictionary):isEmpty())
end)))==true then return ((self):basicDelete_("$classVariables")); end;
return (smalltalk:basic_at_put_((self),"$classVariables",aDictionary));
end
,"accessing","classVariables: aDictionary\r\n\t\" Set the class variables of the receiver. \"\r\n\r\n\t(aDictionary isNil or: [ aDictionary isEmpty ]) ifTrue: [\r\n\t\t^self basicDelete: '$classVariables'\r\n\t].\r\n\t^self basicAt: '$classVariables' put: aDictionary","function(self,aDictionary)\r\nif (smalltalk:boolean_or_((smalltalk:isNil_((aDictionary))),(function()\r\nreturn ((aDictionary):isEmpty())\r\nend)))==true then return ((self):basicDelete_(\"$classVariables\")); end;\r\nreturn (smalltalk:basic_at_put_((self),\"$classVariables\",aDictionary));\r\nend")

smalltalk:bind(smalltalk.Class,"poolDictionaries",0
,function(self)
return ((self)["$poolDictionaries"]);
end
,"accessing","poolDictionaries\r\n\t\" Return the poolDictionaries of the receiver (anArray or nil). \"\r\n\r\n\t^self basicAt: '$poolDictionaries'","function(self)\r\nreturn ((self)[\"$poolDictionaries\"]);\r\nend")

smalltalk:bind(smalltalk.Class,"poolDictionaries:",0
,function(self,anArray)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (smalltalk:notNil_((anArray)))==true then if ((anArray):isEmpty())==true then return ((self):poolDictionaries_(nil)); end;
smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((anArray):size()),((anArray):asSet()):size())),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_(("Invalid pool dictionary names "),(anArray):asLiteral())))
end
)()
error(_s8Ret_,0)
end)())
end)); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:basic_at_put_((self),"$poolDictionaries",anArray))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","poolDictionaries: anArray\r\n\t\" Set the poolDictionaries of the receiver. \"\r\n\r\n\tanArray notNil ifTrue: [\r\n\t\tanArray isEmpty ifTrue: [\r\n\t\t\t^self poolDictionaries: nil\r\n\t\t].\r\n\t\tanArray size = anArray asSet size ifFalse: [\r\n\t\t\t^self error: 'Invalid pool dictionary names ' ,anArray asLiteral\r\n\t\t].\r\n\t].\r\n\t^self basicAt: '$poolDictionaries' put: anArray","function(self,anArray)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (smalltalk:notNil_((anArray)))==true then if ((anArray):isEmpty())==true then return ((self):poolDictionaries_(nil)); end;\r\nsmalltalk:if_true_false_((smalltalk:isObject_equalTo_(((anArray):size()),((anArray):asSet()):size())),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Invalid pool dictionary names \"),(anArray):asLiteral())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:basic_at_put_((self),\"$poolDictionaries\",anArray))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Class,"classVariableNames",0
,function(self)
return (smalltalk:if_true_false_((smalltalk:isNil_(((self):classVariables()))),(function()
return ((smalltalk.Array):new())
end),(function()
return (((self):classVariables()):keys())
end)));
end
,"accessing","classVariableNames\r\n\t\" Return the class variable names of the receiver. \"\r\n\r\n\t^self classVariables isNil\r\n\t\tifTrue: [ Array new ]\r\n\t\tifFalse: [ self classVariables keys ]","function(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_(((self):classVariables()))),(function()\r\nreturn ((smalltalk.Array):new())\r\nend),(function()\r\nreturn (((self):classVariables()):keys())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Class,"classVariablesString",0
,function(self)
return (((self):classVariableNames()):join_(" "));
end
,"accessing","classVariablesString\r\n\t\" Return the class variable names of the receiver as aString. \"\r\n\r\n\t^self classVariableNames join: ' '","function(self)\r\nreturn (((self):classVariableNames()):join_(\" \"));\r\nend")

smalltalk:bind(smalltalk.Class,"poolDictionaryNames",0
,function(self)
return (smalltalk:if_true_false_((smalltalk:isNil_(((self):poolDictionaries()))),(function()
return ((smalltalk.Array):new())
end),(function()
return ((self):poolDictionaries())
end)));
end
,"accessing","poolDictionaryNames\r\n\t\" Return the pool dictionary names of the receiver. \"\r\n\r\n\t^self poolDictionaries isNil\r\n\t\tifTrue: [ Array new ]\r\n\t\tifFalse: [ self poolDictionaries ]","function(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_(((self):poolDictionaries()))),(function()\r\nreturn ((smalltalk.Array):new())\r\nend),(function()\r\nreturn ((self):poolDictionaries())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Class,"poolDictionariesString",0
,function(self)
return (((self):poolDictionaryNames()):join_(" "));
end
,"accessing","poolDictionariesString\r\n\t\" Return the poolDictionary names of the receiver as aString. \"\r\n\r\n\t^self poolDictionaryNames join: ' '","function(self)\r\nreturn (((self):poolDictionaryNames()):join_(\" \"));\r\nend")

smalltalk:bind(smalltalk.Class,"classVariableNames:",0
,function(self,classVarNames)
local names=nil
local dictionary=nil
local old=nil
if (smalltalk:isNil_((classVarNames)))==true then return ((self):classVariables_(nil)); end;
(function()
	local _s8_value=(smalltalk:if_true_false_(((classVarNames):isString()),(function()
return ((classVarNames):asArrayOfSubstrings())
end),(function()
return (classVarNames)
end)))
	names=_s8_value
	return _s8_value
end)();
if not ((smalltalk:isObject_equalTo_(((names):size()),((names):asSet()):size())))==true then return ((self):error_(smalltalk:object_comma_(("Invalid class variable names "),(names):asLiteral()))); end;
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	dictionary=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):classVariables())
	old=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((old)))==true then (function()
	local _s8_value=(dictionary)
	old=_s8_value
	return _s8_value
end)(); end;
(names):do_((function(each)
return ((dictionary):at_put_(each,(old):at_ifAbsent_(each,(function()
return (nil)
end))))
end));
(self):classVariables_(dictionary);
return (self);
end
,"accessing","classVariableNames: classVarNames\r\n\t\" Set the variable names defined in the receiver. \"\r\n\r\n\t| names dictionary old |\r\n\tclassVarNames isNil ifTrue: [ ^self classVariables: nil ].\r\n\tnames := classVarNames isString\r\n\t\tifTrue: [ classVarNames asArrayOfSubstrings ]\r\n\t\tifFalse: [ classVarNames ].\r\n\tnames size = names asSet size ifFalse: [\r\n\t\t^self error: 'Invalid class variable names ' ,names asLiteral\r\n\t].\r\n\tdictionary := PoolDictionary new.\r\n\told := self classVariables. old isNil ifTrue: [ old := dictionary ].\r\n\tnames do: [:each|\r\n\t\tdictionary at: each put: (old at: each ifAbsent: [ nil ])\r\n\t].\r\n\tself classVariables: dictionary.","function(self,classVarNames)\r\nlocal names=nil\r\nlocal dictionary=nil\r\nlocal old=nil\r\nif (smalltalk:isNil_((classVarNames)))==true then return ((self):classVariables_(nil)); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((classVarNames):isString()),(function()\r\nreturn ((classVarNames):asArrayOfSubstrings())\r\nend),(function()\r\nreturn (classVarNames)\r\nend)))\r\n\tnames=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:isObject_equalTo_(((names):size()),((names):asSet()):size())))==true then return ((self):error_(smalltalk:object_comma_((\"Invalid class variable names \"),(names):asLiteral()))); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tdictionary=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):classVariables())\r\n\told=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((old)))==true then (function()\r\n\tlocal _s8_value=(dictionary)\r\n\told=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(names):do_((function(each)\r\nreturn ((dictionary):at_put_(each,(old):at_ifAbsent_(each,(function()\r\nreturn (nil)\r\nend))))\r\nend));\r\n(self):classVariables_(dictionary);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Class,"poolDictionaryNames:",0
,function(self,poolVarNames)
(self):poolDictionaries_(smalltalk:if_true_false_(((poolVarNames):isString()),(function()
return ((poolVarNames):asArrayOfSubstrings())
end),(function()
return (poolVarNames)
end)));
return (self);
end
,"accessing","poolDictionaryNames: poolVarNames\r\n\t\" Set the pool dictionary names known to the receiver. \"\r\n\r\n\tself poolDictionaries: (poolVarNames isString\r\n\t\tifTrue: [ poolVarNames asArrayOfSubstrings ]\r\n\t\tifFalse: [ poolVarNames ]).","function(self,poolVarNames)\r\n(self):poolDictionaries_(smalltalk:if_true_false_(((poolVarNames):isString()),(function()\r\nreturn ((poolVarNames):asArrayOfSubstrings())\r\nend),(function()\r\nreturn (poolVarNames)\r\nend)));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:",0
,function(self,aString,anotherString)
return ((self):subclass_instanceVariableNames_category_(aString,anotherString,nil));
end
,"instantiation","subclass: aString instanceVariableNames: anotherString\r\n\t\" Create a subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: anotherString\r\n\t\tcategory: nil","function(self,aString,anotherString)\r\nreturn ((self):subclass_instanceVariableNames_category_(aString,anotherString,nil));\r\nend")

smalltalk:bind(smalltalk.Class,"subclass:category:",0
,function(self,aString,aCategory)
return ((self):subclass_instanceVariableNames_category_(aString,"",aCategory));
end
,"instantiation","subclass: aString category: aCategory\r\n\t\" Create a subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: ''\r\n\t\tcategory: aCategory","function(self,aString,aCategory)\r\nreturn ((self):subclass_instanceVariableNames_category_(aString,\"\",aCategory));\r\nend")

smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:category:",0
,function(self,aString,aString2,aString3)
return (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_category_(self,aString,aString2,aString3));
end
,"instantiation","subclass: aString instanceVariableNames: aString2 category: aString3\r\n\t\" Create a subclass of the receiver. \"\r\n\r\n\t^ClassBuilder new\r\n\t\tsuperclass: self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tcategory: aString3","function(self,aString,aString2,aString3)\r\nreturn (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_category_(self,aString,aString2,aString3));\r\nend")

smalltalk:bind(smalltalk.Class,"isClass",0
,function(self)
return (true);
end
,"testing","isClass\r\n\t\" Return true if the receiver is a Class. \"\r\n\r\n\t^true","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.Class,"printString",0
,function(self)
return ((self):name());
end
,"printing","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t^self name","function(self)\r\nreturn ((self):name());\r\nend")

smalltalk:bind(smalltalk.Class,"instanceClass",0
,function(self)
return (self);
end
,"accessing","instanceClass\r\n\t\" Return the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Class,"rename:",0
,function(self,aString)
((self):smalltalk()):renameClass(self,aString);
return (self);
end
,"renaming","rename: aString\r\n\t\" Rename the receiver to aString. \"\r\n\r\n\tself smalltalk #renameClass: self to: aString","function(self,aString)\r\n((self):smalltalk()):renameClass(self,aString);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Class,"removeFromSystem",0
,function(self)
((self):subclasses()):do_((function(each)
return ((each):removeFromSystem())
end));
((self):smalltalk()):removeClass(self);
return (true);
end
,"remove","removeFromSystem\r\n\t\" Remove the receiver from system. \"\r\n\r\n\tself subclasses do: [:each| each removeFromSystem ].\r\n\tself smalltalk #removeClass: self.\r\n\t^true","function(self)\r\n((self):subclasses()):do_((function(each)\r\nreturn ((each):removeFromSystem())\r\nend));\r\n((self):smalltalk()):removeClass(self);\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.Class,"removeSources",0
,function(self)
((self)["$klass"]):methodsDo_((function(each)
return ((each):removeSources())
end));
(self):methodsDo_((function(each)
return ((each):removeSources())
end));
(
function(_s8_rec)
	(_s8_rec):comment_("");
	return ((_s8_rec):category_("s8"))
end
)(self);
return (self);
end
,"tools","removeSources\r\n\t\" Remove all development sources of the receiver. \"\r\n\r\n\tself class methodsDo: [:each | each removeSources ].\r\n\tself methodsDo: [:each | each removeSources ].\r\n\tself comment: ''; category: #s8","function(self)\r\n((self)[\"$klass\"]):methodsDo_((function(each)\r\nreturn ((each):removeSources())\r\nend));\r\n(self):methodsDo_((function(each)\r\nreturn ((each):removeSources())\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):comment_(\"\");\r\n\treturn ((_s8_rec):category_(\"s8\"))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:addClass("Metaclass",smalltalk.Behavior,smalltalk:newArray({"instanceClass"}),"Kernel")

smalltalk:bind(smalltalk.Metaclass,"instanceClass",0
,function(self)
return (self["@instanceClass"]);
end
,"accessing","instanceClass\r\n\t\" Return the instance class of receiver. \"\r\n\r\n\t^instanceClass","function(self)\r\nreturn (self[\"@instanceClass\"]);\r\nend")

smalltalk:bind(smalltalk.Metaclass,"instanceVariableNames:",0
,function(self,aString)
((smalltalk.ClassBuilder):new()):class_instanceVariableNames_(self,aString);
return ((self):instanceVariableNames());
end
,"accessing","instanceVariableNames: aString\r\n\t\" Set the instance variable names of the receiver. \"\r\n\r\n\tClassBuilder new\r\n\t\tclass: self\r\n\t\tinstanceVariableNames: aString.\r\n\t^self instanceVariableNames ","function(self,aString)\r\n((smalltalk.ClassBuilder):new()):class_instanceVariableNames_(self,aString);\r\nreturn ((self):instanceVariableNames());\r\nend")

smalltalk:bind(smalltalk.Metaclass,"isMetaclass",0
,function(self)
return (true);
end
,"testing","isMetaclass\r\n\t\" Return true if the receiver is a metaclass. \"\r\n\r\n\t^true","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.Metaclass,"printString",0
,function(self)
return (smalltalk:object_comma_((((self):instanceClass()):name())," class"));
end
,"printing","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t^self instanceClass name, ' class'","function(self)\r\nreturn (smalltalk:object_comma_((((self):instanceClass()):name()),\" class\"));\r\nend")

smalltalk:bind(smalltalk.Metaclass,"classVariables",0
,function(self)
return (((self):instanceClass()):classVariables());
end
,"accessing","classVariables\r\n\t\" Return the class variables of the receiver. \"\r\n\r\n\t^self instanceClass classVariables","function(self)\r\nreturn (((self):instanceClass()):classVariables());\r\nend")

smalltalk:addClass("CompiledMethod",smalltalk.Object,smalltalk:newArray({"classField"}),"Kernel")

smalltalk:bind(smalltalk.CompiledMethod,"source",0
,function(self)
return (smalltalk:basic_at_ifAbsent_((self),"$source",(function()
return ("")
end)));
end
,"accessing","source\r\n\t\" Return the source code of the receiver. \"\r\n\r\n\t^self basicAt: '$source' ifAbsent: ['']","function(self)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),\"$source\",(function()\r\nreturn (\"\")\r\nend)));\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"source:",0
,function(self,aString)
smalltalk:basic_at_put_((self),"$source",aString);
return (self);
end
,"accessing","source: aString\r\n\t\" Set the source code of the receiver. \"\r\n\r\n\tself basicAt: '$source' put: aString","function(self,aString)\r\nsmalltalk:basic_at_put_((self),\"$source\",aString);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"category",0
,function(self)
return (smalltalk:basic_at_ifAbsent_((self),"$category",(function()
return ("")
end)));
end
,"accessing","category\r\n\t\" Return the category of the receiver. \"\r\n\r\n\t^self basicAt: '$category' ifAbsent: ['']","function(self)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),\"$category\",(function()\r\nreturn (\"\")\r\nend)));\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"category:",0
,function(self,aString)
smalltalk:basic_at_put_((self),"$category",aString);
return (self);
end
,"accessing","category: aString\r\n\t\" Set the category of the receiver. \"\r\n\r\n\tself basicAt: '$category' put: aString","function(self,aString)\r\nsmalltalk:basic_at_put_((self),\"$category\",aString);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"stamp",0
,function(self)
return ((self)["$stamp"]);
end
,"accessing","stamp\r\n\t\" Return the stamp of the receiver. \"\r\n\r\n\t^self basicAt: '$stamp'","function(self)\r\nreturn ((self)[\"$stamp\"]);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"stamp:",0
,function(self,aString)
smalltalk:basic_at_put_((self),"$stamp",aString);
return (self);
end
,"accessing","stamp: aString\r\n\t\" Set the stamp of the receiver. \"\r\n\r\n\tself basicAt: '$stamp' put: aString","function(self,aString)\r\nsmalltalk:basic_at_put_((self),\"$stamp\",aString);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"selector",0
,function(self)
return ((self)["$selector"]);
end
,"accessing","selector\r\n\t\" Return the selector of the receiver. \"\r\n\r\n\t^self basicAt: '$selector'","function(self)\r\nreturn ((self)[\"$selector\"]);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"selector:",0
,function(self,aString)
smalltalk:basic_at_put_((self),"$selector",aString);
return (self);
end
,"accessing","selector: aString\r\n\t\" Set the selector of the receiver. \"\r\n\r\n\tself basicAt: '$selector' put: aString","function(self,aString)\r\nsmalltalk:basic_at_put_((self),\"$selector\",aString);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"fn",0
,function(self)
return ((self)["$fn"]);
end
,"accessing","fn\r\n\t\" Return the native implementation of the receiver (or nil). \"\r\n\r\n\t^self basicAt: '$fn'","function(self)\r\nreturn ((self)[\"$fn\"]);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"fn:",0
,function(self,aBlock)
smalltalk:basic_at_put_((self),"$fn",aBlock);
return (self);
end
,"accessing","fn: aBlock\r\n\t\" Set the native implementation of the receiver. \"\r\n\r\n\tself basicAt: '$fn' put: aBlock","function(self,aBlock)\r\nsmalltalk:basic_at_put_((self),\"$fn\",aBlock);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"asClosure",0
,function(self)

return ((self):fn());
end
,"accessing","asClosure\r\n\t\" Private - Return the receiver as a native closure (or nil). \"\r\n\r\n\t{'self'}.\r\n\t^self fn","function(self)\r\n\r\nreturn ((self):fn());\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"compiledSource",0
,function(self)
local closure=nil
(function()
	local _s8_value=((self):asClosure())
	closure=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((closure))),(function()
return ((closure):compiledSourceAt_(self))
end),nil));
end
,"accessing","compiledSource\r\n\t\" Return the native source code of the receiver (or nil). \"\r\n\r\n\t| closure |\r\n\tclosure := self asClosure.\r\n\t^closure notNil ifTrue: [ closure compiledSourceAt: self ]","function(self)\r\nlocal closure=nil\r\n(function()\r\n\tlocal _s8_value=((self):asClosure())\r\n\tclosure=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((closure))),(function()\r\nreturn ((closure):compiledSourceAt_(self))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"classField",0
,function(self)
return (self["@classField"]);
end
,"accessing","classField\r\n\t\" Return the implementor of the receiver. \"\r\n\r\n\t^classField","function(self)\r\nreturn (self[\"@classField\"]);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"classField:",0
,function(self,aClass)
(function()
	local _s8_value=(aClass)
	self["@classField"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","classField: aClass\r\n\t\" Set the implementor of the receiver. \"\r\n\r\n\tclassField := aClass","function(self,aClass)\r\n(function()\r\n\tlocal _s8_value=(aClass)\r\n\tself[\"@classField\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"generation",0
,function(self)
return ((self)["$generation"]);
end
,"accessing","generation\r\n\t\" Return the generation of the receiver. \"\r\n\r\n\t^self basicAt: '$generation'","function(self)\r\nreturn ((self)[\"$generation\"]);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"comment",0
,function(self)
return (((
function(_s8_rec)
	(_s8_rec):upTo_("\"");
	return ((_s8_rec):upTo_("\""))
end
)(((self):source()):stream())):trimBlanks());
end
,"accessing","comment\r\n\t\" Return the comment of the receiver. \"\r\n\r\n\t^(self source stream upTo: $\"; upTo: $\") trimBlanks","function(self)\r\nreturn (((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):upTo_(\"\\\"\");\r\n\treturn ((_s8_rec):upTo_(\"\\\"\"))\r\nend\r\n)(((self):source()):stream())):trimBlanks());\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"toString",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:if_true_false_((smalltalk:isNil_((self["@classField"]))),(function()
return (smalltalk:toString_((self["@classField"])))
end),(function()
return ((self["@classField"]):name())
end))),">>#")),smalltalk:toString_(((self):selector()))));
end
,"printing","toString\r\n\t\" Return the receiver as a String. \"\r\n\r\n\t^(classField isNil\r\n\t\tifTrue: [classField toString]\r\n\t\tifFalse: [classField name])\r\n\t\t,'>>#' ,self selector toString","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:if_true_false_((smalltalk:isNil_((self[\"@classField\"]))),(function()\r\nreturn (smalltalk:toString_((self[\"@classField\"])))\r\nend),(function()\r\nreturn ((self[\"@classField\"]):name())\r\nend))),\">>#\")),smalltalk:toString_(((self):selector()))));\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"printString",0
,function(self)

return (smalltalk:toString_((self)));
end
,"printing","printString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t{'self'}.\r\n\t^self toString","function(self)\r\n\r\nreturn (smalltalk:toString_((self)));\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"asJSONObject",0
,function(self)
return (self);
end
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"shallowCopy",0
,function(self)
return (self);
end
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"deepCopy",0
,function(self)
return (self);
end
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"removeSources",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):source_("");
	return ((_s8_rec):category_("s8"))
end
)(self);
return (self);
end
,"tools","removeSources\r\n\t\" Remove all development sources of the receiver. \"\r\n\r\n\tself source: ''; category: #s8","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):source_(\"\");\r\n\treturn ((_s8_rec):category_(\"s8\"))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"removeFromSystem",0
,function(self)
if (smalltalk:isObject_equalTo_((((self):classField()):_gt_gt((self):selector())),self))==true then ((self):classField()):removeSelector_((self):selector()); end;
return (true);
end
,"remove","removeFromSystem\r\n\t\" Remove the receiver from system. \"\r\n\r\n\tself classField >> self selector = self ifTrue: [\r\n\t\tself classField removeSelector: self selector\r\n\t].\r\n\t^true","function(self)\r\nif (smalltalk:isObject_equalTo_((((self):classField()):_gt_gt((self):selector())),self))==true then ((self):classField()):removeSelector_((self):selector()); end;\r\nreturn (true);\r\nend")

smalltalk:addClass("Boolean",smalltalk.Object,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.Boolean,"=","_eq"
,function(self,anObject)

	if anObject==nil then return false end
	if true then return self==anObject end;
return (self);
end
,"comparing","= anObject\r\n    \" Return true if the receiver is equal to argument. \"\r\n\r\n\t{'' doc'boolean test'}","function(self,anObject)\r\n\r\n\tif anObject==nil then return false end\r\n\tif true then return self==anObject end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Boolean,"ifTrue:ifFalse:",0
,function(self,aBlock,anotherBlock)

	if (self==true)
		then return aBlock:value()
		else return anotherBlock:value() end;
return (self);
end
,"control","ifTrue: aBlock ifFalse: anotherBlock\r\n\t\" Return the result of evaluating aBlock if the receiver is true, else the result of evaluating anotherBlock. \"\r\n\r\n\t{'' doc'boolean switch'}","function(self,aBlock,anotherBlock)\r\n\r\n\tif (self==true)\r\n\t\tthen return aBlock:value()\r\n\t\telse return anotherBlock:value() end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Boolean,"ifTrue:",0
,function(self,aBlock)
return (smalltalk:if_true_false_((self),(function()
return ((aBlock):value())
end),(function()
return (nil)
end)));
end
,"control","ifTrue: aBlock\r\n\t\" Return the result of evaluating aBlock if the receiver is true, else return nil. \"\r\n\r\n\t^self ifTrue: [ aBlock value ] ifFalse: []","function(self,aBlock)\r\nreturn (smalltalk:if_true_false_((self),(function()\r\nreturn ((aBlock):value())\r\nend),(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Boolean,"ifFalse:",0
,function(self,aBlock)
return (smalltalk:if_true_false_((self),(function()
return (nil)
end),(function()
return ((aBlock):value())
end)));
end
,"control","ifFalse: aBlock\r\n\t\" Return the result of evaluating aBlock if the receiver is false, else return nil. \"\r\n\r\n\t^self ifTrue: [] ifFalse: [ aBlock value ]","function(self,aBlock)\r\nreturn (smalltalk:if_true_false_((self),(function()\r\nreturn (nil)\r\nend),(function()\r\nreturn ((aBlock):value())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Boolean,"ifFalse:ifTrue:",0
,function(self,aBlock,anotherBlock)
return ((self):ifTrue_ifFalse_(anotherBlock,(function()
return ((aBlock):value())
end)));
end
,"control","ifFalse: aBlock ifTrue: anotherBlock\r\n\t\" Return the result of evaluating aBlock if the receiver is false, else the result of evaluating anotherBlock. \"\r\n\r\n\t^self ifTrue: anotherBlock ifFalse: [ aBlock value ]","function(self,aBlock,anotherBlock)\r\nreturn ((self):ifTrue_ifFalse_(anotherBlock,(function()\r\nreturn ((aBlock):value())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Boolean,"and:",0
,function(self,aBlock)
return (smalltalk:if_true_false_((self),(function()
return ((aBlock):value())
end),(function()
return (false)
end)));
end
,"control","and: aBlock\r\n\t\" Return true if the receiver is true and the result of evaluating aBlock is also true. \"\r\n\r\n\t^self ifTrue: [ aBlock value ] ifFalse: [false]","function(self,aBlock)\r\nreturn (smalltalk:if_true_false_((self),(function()\r\nreturn ((aBlock):value())\r\nend),(function()\r\nreturn (false)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Boolean,"or:",0
,function(self,aBlock)
return (smalltalk:if_true_false_((self),(function()
return (true)
end),(function()
return ((aBlock):value())
end)));
end
,"control","or: aBlock\r\n\t\" Return true if the receiver is true or the result of evaluating aBlock is true. \"\r\n\r\n\t^self ifTrue: [true] ifFalse: [ aBlock value ]","function(self,aBlock)\r\nreturn (smalltalk:if_true_false_((self),(function()\r\nreturn (true)\r\nend),(function()\r\nreturn ((aBlock):value())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Boolean,"not","__not"
,function(self)
return (self == false);
end
,"control","not\r\n\t\" Return true if the receiver is false. \"\r\n\r\n\t^{'' doc'boolean inversion'}","function(self)\r\nreturn (self == false);\r\nend")

smalltalk:bind(smalltalk.Boolean,"printString",0
,function(self)
return (smalltalk:if_true_false_((self),(function()
return ("true")
end),(function()
return ("false")
end)));
end
,"printing","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t^self ifTrue: [ #true ] ifFalse: [ #false ]","function(self)\r\nreturn (smalltalk:if_true_false_((self),(function()\r\nreturn (\"true\")\r\nend),(function()\r\nreturn (\"false\")\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Boolean,"asJSONObject",0
,function(self)

return (smalltalk:boolean_and_((self),(function()
return (true)
end)));
end
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t{'self'}.\r\n\t^self and: [ true ]","function(self)\r\n\r\nreturn (smalltalk:boolean_and_((self),(function()\r\nreturn (true)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Boolean,"shallowCopy",0
,function(self)
return (self);
end
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Boolean,"deepCopy",0
,function(self)
return (self);
end
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Boolean,"isBoolean",0
,function(self)
return (true);
end
,"testing","isBoolean\r\n\t\" Return true if the receiver is a boolean. \"\r\n\r\n\t^true","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.Object,"isBoolean",0
,function(self)
return (false);
end
,"testing","isBoolean\r\n\t\" Return true if the receiver is a boolean. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:addClass("Number",smalltalk.Object,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.Number,"=","_eq"
,function(self,anObject)

	if (type(anObject)=="number")
		then return self==anObject
		else return false
		end;
return (self);
end
,"comparing","= anObject\r\n    \" Return true if the receiver is equal to argument. \"\r\n\r\n\t{'' doc'number equality test'}","function(self,anObject)\r\n\r\n\tif (type(anObject)==\"number\")\r\n\t\tthen return self==anObject\r\n\t\telse return false\r\n\t\tend;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Number,"mustBeNumber",0
,function(self)
return (self);
end
,"testing","mustBeNumber\r\n\t\" Signal an error if the receiver is not a Number.\r\n\tWARNING: this check impose a severe loss of perfomance (five times slower).\r\n\tIf you are sure the operation/compare arguments are ok (a number),\r\n\t comment the implementation of this method making the code empty.\r\n\t\"\r\n\r\n\t\"(# #isNaN: self) ifTrue: [ super mustBeNumber ]\"","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"mustBeNumber",0
,function(self)
return ((self):error_("Must be a Number"));
end
,"testing","mustBeNumber\r\n\t\" Signal an error if the receiver is not a Number. \"\r\n\r\n\t^self error: 'Must be a Number'","function(self)\r\nreturn ((self):error_(\"Must be a Number\"));\r\nend")

smalltalk:bind(smalltalk.Number,">","_gt"
,function(self,aNumber)
return (self > aNumber);
end
,"comparing","> aNumber\r\n\t\" Return true if the receiver is greater than argument. \"\r\n\r\n\t^{'' doc'number compare'}","function(self,aNumber)\r\nreturn (self > aNumber);\r\nend")

smalltalk:bind(smalltalk.Number,"<","_lt"
,function(self,aNumber)
return (self < aNumber);
end
,"comparing","< aNumber\r\n\t\" Return true if the receiver is smaller than argument. \"\r\n\r\n\t^{'' doc'number compare'}","function(self,aNumber)\r\nreturn (self < aNumber);\r\nend")

smalltalk:bind(smalltalk.Number,">=","_gt_eq"
,function(self,aNumber)
return (self >= aNumber);
end
,"comparing",">= aNumber\r\n\t\" Return true if the receiver is greater or equal to argument. \"\r\n\r\n\t^{'' doc'number compare'}","function(self,aNumber)\r\nreturn (self >= aNumber);\r\nend")

smalltalk:bind(smalltalk.Number,"<=","_lt_eq"
,function(self,aNumber)
return (self <= aNumber);
end
,"comparing","<= aNumber\r\n\t\" Return true if the receiver is smaller or equal to argument. \"\r\n\r\n\t^{'' doc'number compare'}","function(self,aNumber)\r\nreturn (self <= aNumber);\r\nend")

smalltalk:bind(smalltalk.Number,"+","_plus"
,function(self,aNumber)
return (self + aNumber);
end
,"arithmetic","+ aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\t^{'' doc'number operation'}","function(self,aNumber)\r\nreturn (self + aNumber);\r\nend")

smalltalk:bind(smalltalk.Number,"-","_minus"
,function(self,aNumber)
return (self - aNumber);
end
,"arithmetic","- aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\t^{'' doc'number operation'}","function(self,aNumber)\r\nreturn (self - aNumber);\r\nend")

smalltalk:bind(smalltalk.Number,"*","_star"
,function(self,aNumber)
return (self * aNumber);
end
,"arithmetic","* aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\t^{'' doc'number operation'}","function(self,aNumber)\r\nreturn (self * aNumber);\r\nend")

smalltalk:bind(smalltalk.Number,"/","_slash"
,function(self,aNumber)
return (self / aNumber);
end
,"arithmetic","/ aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\t^{'' doc'number operation'}","function(self,aNumber)\r\nreturn (self / aNumber);\r\nend")

smalltalk:bind(smalltalk.Number,"divideByZero",0
,function(self)
return ((self):error_("Divide by Zero"));
end
,"signaling","divideByZero\r\n\t\" Signal divide by cero attempt. \"\r\n\r\n\t^self error: 'Divide by Zero'","function(self)\r\nreturn ((self):error_(\"Divide by Zero\"));\r\nend")

smalltalk:bind(smalltalk.Number,"\\\\","_bk_bk"
,function(self,aNumber)
(aNumber):mustBeNumber();
if (smalltalk:isObject_equalTo_((aNumber),0))==true then (self):divideByZero(); end;
return ((self):_minus(((self):_slash_slash(aNumber)):_star(aNumber)));
end
,"arithmetic","\\\\\\\\ aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\taNumber mustBeNumber.\r\n\taNumber = 0 ifTrue: [ self divideByZero ].\r\n\t^self - (self // aNumber * aNumber)","function(self,aNumber)\r\n(aNumber):mustBeNumber();\r\nif (smalltalk:isObject_equalTo_((aNumber),0))==true then (self):divideByZero(); end;\r\nreturn ((self):_minus(((self):_slash_slash(aNumber)):_star(aNumber)));\r\nend")

smalltalk:bind(smalltalk.Number,"//","_slash_slash"
,function(self,aNumber)
(aNumber):mustBeNumber();
if (smalltalk:isObject_equalTo_((aNumber),0))==true then (self):divideByZero(); end;
return (((self):_slash(aNumber)):truncated());
end
,"arithmetic","// aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\taNumber mustBeNumber.\r\n\taNumber = 0 ifTrue: [ self divideByZero ].\r\n\t^(self / aNumber) truncated","function(self,aNumber)\r\n(aNumber):mustBeNumber();\r\nif (smalltalk:isObject_equalTo_((aNumber),0))==true then (self):divideByZero(); end;\r\nreturn (((self):_slash(aNumber)):truncated());\r\nend")

smalltalk:bind(smalltalk.Number,"sin",0
,function(self)
return (math.sin(self));
end
,"arithmetic","sin\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","function(self)\r\nreturn (math.sin(self));\r\nend")

smalltalk:bind(smalltalk.Number,"cos",0
,function(self)
return (math.cos(self));
end
,"arithmetic","cos\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","function(self)\r\nreturn (math.cos(self));\r\nend")

smalltalk:bind(smalltalk.Number,"tan",0
,function(self)
return (math.tan(self));
end
,"arithmetic","tan\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","function(self)\r\nreturn (math.tan(self));\r\nend")

smalltalk:bind(smalltalk.Number,"arcCos",0
,function(self)
return (math.acos(self));
end
,"arithmetic","arcCos\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","function(self)\r\nreturn (math.acos(self));\r\nend")

smalltalk:bind(smalltalk.Number,"arcSin",0
,function(self)
return (math.asin(self));
end
,"arithmetic","arcSin\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","function(self)\r\nreturn (math.asin(self));\r\nend")

smalltalk:bind(smalltalk.Number,"arcTan",0
,function(self)
return (math.atan(self));
end
,"arithmetic","arcTan\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","function(self)\r\nreturn (math.atan(self));\r\nend")

smalltalk:bind(smalltalk.Number,"atan2:",0
,function(self,aNumber)
return (math.atan2(self,aNumber));
end
,"arithmetic","atan2: aNumber\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","function(self,aNumber)\r\nreturn (math.atan2(self,aNumber));\r\nend")

smalltalk:bind(smalltalk.Number,"negated",0
,function(self)
return ((-1):_star(self));
end
,"arithmetic","negated\r\n\t\" Return the receiver negated\"\r\n\r\n\t^-1 * self ","function(self)\r\nreturn ((-1):_star(self));\r\nend")

smalltalk:bind(smalltalk.Number,"squared",0
,function(self)
return ((self):_star(self));
end
,"arithmetic","squared\r\n\t^self * self ","function(self)\r\nreturn ((self):_star(self));\r\nend")

smalltalk:bind(smalltalk.Number,"sqrt",0
,function(self)
return (math.sqrt(self));
end
,"arithmetic","sqrt\r\n\t\" Return the result of operation\"\r\n\r\n\t^{'' doc'number operation'}","function(self)\r\nreturn (math.sqrt(self));\r\nend")

smalltalk:bind(smalltalk.Number,"<<","_lt_lt"
,function(self,aNumber)
return (bit.lshift(self,aNumber));
end
,"arithmetic","<< aNumber\r\n\t\" Return the receiver shifted aNumber of bits to the left. \"\r\n\r\n\t^{'' doc'number operation'}","function(self,aNumber)\r\nreturn (bit.lshift(self,aNumber));\r\nend")

smalltalk:bind(smalltalk.Number,">>","_gt_gt"
,function(self,aNumber)
return (bit.rshift(self,aNumber));
end
,"arithmetic",">> aNumber\r\n\t\" Return the receiver shifted aNumber of bits to the right. \"\r\n\r\n\t^{'' doc'number operation'}","function(self,aNumber)\r\nreturn (bit.rshift(self,aNumber));\r\nend")

smalltalk:bind(smalltalk.Number,"bitShift:",0
,function(self,anInteger)
if (((anInteger) < 0))==true then return ((self):_gt_gt((anInteger):negated())); end;
return ((self):_lt_lt(anInteger));
end
,"arithmetic","bitShift: anInteger\r\n\t\" Return the receiver shifted left anInteger number of bits if anInteger is positive, or shifted right for anInteger negated number of bits if anInteger is negative.\"\r\n\r\n\tanInteger < 0 ifTrue: [ ^self >> anInteger negated ].\r\n\t^self << anInteger","function(self,anInteger)\r\nif (((anInteger) < 0))==true then return ((self):_gt_gt((anInteger):negated())); end;\r\nreturn ((self):_lt_lt(anInteger));\r\nend")

smalltalk:bind(smalltalk.Number,"raisedTo:",0
,function(self,aNumber)
if (smalltalk:isObject_equalTo_((aNumber),0))==true then return (1); end;
if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((self),0)),(function()
return (((aNumber) > 0))
end)))==true then return (0); end;
return (math.pow(self,aNumber));
end
,"arithmetic","raisedTo: aNumber\r\n\t\" Return the receiver raised to the power of aNumber. \"\r\n\r\n\taNumber = 0 ifTrue: [ ^1.0 ].\r\n\t(self = 0 and: [aNumber > 0]) ifTrue: [ ^0.0 ].\r\n\t^{'' doc'number operation'}","function(self,aNumber)\r\nif (smalltalk:isObject_equalTo_((aNumber),0))==true then return (1); end;\r\nif (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((self),0)),(function()\r\nreturn (((aNumber) > 0))\r\nend)))==true then return (0); end;\r\nreturn (math.pow(self,aNumber));\r\nend")

smalltalk:bind(smalltalk.Number,"max:",0
,function(self,aNumber)
return (math.max(self,aNumber));
end
,"arithmetic","max: aNumber\r\n\t\" Return the maximum between the receiver and argument. \"\r\n\r\n\t^{'' doc'number operation'}","function(self,aNumber)\r\nreturn (math.max(self,aNumber));\r\nend")

smalltalk:bind(smalltalk.Number,"min:",0
,function(self,aNumber)
return (math.min(self,aNumber));
end
,"arithmetic","min: aNumber\r\n\t\" Return the minimum between the receiver and argument. \"\r\n\r\n\t^{'' doc'number operation'}","function(self,aNumber)\r\nreturn (math.min(self,aNumber));\r\nend")

smalltalk:bind(smalltalk.Number,"asNumber",0
,function(self)
return ((self):_plus(0));
end
,"converting","asNumber\r\n\t\" Return the receiver as a Number. \"\r\n\r\n\t^self + 0","function(self)\r\nreturn ((self):_plus(0));\r\nend")

smalltalk:bind(smalltalk.Number,"abs",0
,function(self)
if (((self) < 0))==true then return ((self):negated()); end;
return (self);
end
,"converting","abs\r\n\t\" Return the absolute value of the receiver. \"\r\n\r\n\tself < 0 ifTrue: [ ^self negated ].\r\n\t^self","function(self)\r\nif (((self) < 0))==true then return ((self):negated()); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Number,"rounded",0
,function(self)
return (self + 0.5 - (self + 0.5) % 1);
end
,"converting","rounded\r\n\t\" Return the receiver rounded. \"\r\n\r\n\t^{'' doc'number operation'}","function(self)\r\nreturn (self + 0.5 - (self + 0.5) % 1);\r\nend")

smalltalk:bind(smalltalk.Number,"truncated",0
,function(self)
return (math.floor(self));
end
,"converting","truncated\r\n\t\" Return the receiver truncated. \"\r\n\r\n\t^{'' doc'number operation'}","function(self)\r\nreturn (math.floor(self));\r\nend")

smalltalk:bind(smalltalk.Number,"asCharacter",0
,function(self)
return ((smalltalk.String):fromCharCode_(self));
end
,"converting","asCharacter\r\n\t\" Return the character with the receiver's code. \"\r\n\r\n\t^String fromCharCode: self","function(self)\r\nreturn ((smalltalk.String):fromCharCode_(self));\r\nend")

smalltalk:bind(smalltalk.Number,"to:by:value:",0
,function(self,aNumber,increment,aBlock)
return ((smalltalk.Interval):from_to_by_value_(self,aNumber,increment,aBlock));
end
,"iterating","to: aNumber by: increment value: aBlock\r\n\t\" Private - Return an iterable to evaluate aBlock on each step of iteration. \"\r\n\r\n\t^Interval from: self to: aNumber by: increment value: aBlock ","function(self,aNumber,increment,aBlock)\r\nreturn ((smalltalk.Interval):from_to_by_value_(self,aNumber,increment,aBlock));\r\nend")

smalltalk:bind(smalltalk.Number,"to:by:",0
,function(self,__end,increment)
return ((self):to_by_value_(__end,increment,(function(index,block)
return ((block):value_(index))
end)));
end
,"iterating","to: end by: increment\r\n\t\" Return an iterable from the receiver to end. \"\r\n\r\n\t^self\tto: end by: increment\r\n\t\tvalue: [:index :block| block value: index ]","function(self,__end,increment)\r\nreturn ((self):to_by_value_(__end,increment,(function(index,block)\r\nreturn ((block):value_(index))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Number,"to:",0
,function(self,__end)
return ((self):to_by_(__end,1));
end
,"iterating","to: end\r\n\t\" Return an iterable from the receiver to end. \"\r\n\r\n\t^self to: end by: 1 \"to iterate like other smalltalks\r\n\t\t(self <= end ifTrue: [1] ifFalse: [-1])\"","function(self,__end)\r\nreturn ((self):to_by_(__end,1));\r\nend")

smalltalk:bind(smalltalk.Number,"timesRepeat:",0
,function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
for i=1,self do fn(i) end;
return (self);
end
,"enumerating","timesRepeat: aBlock\r\n\t\" Evaluates aBlock a number of times given by the receiver.\r\n\tReturn the receiver.\r\n\t\"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{'' s8'(1 to: self) do: aBlock' doc'iteration'}","function(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nfor i=1,self do fn(i) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Number,"to:do:",0
,function(self,aNumber,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
for i=self,aNumber do fn(i) end;
return (self);
end
,"iterating","to: aNumber do: aBlock\r\n\t\" Evaluate aBlock from the receiver to aNumber.\r\n\tReturn the receiver.\r\n\t\"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8' (self to: aNumber) do: aBlock' doc'iteration'}","function(self,aNumber,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nfor i=self,aNumber do fn(i) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Number,"to:by:do:",0
,function(self,aNumber,increment,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
for i=self,aNumber,increment do fn(i) end;
return (self);
end
,"iterating","to: aNumber by: increment do: aBlock\r\n\t\" Evaluate aBlock for the numbers between the receiver and aNumber where each number is the previous number plus increment.\r\n\tReturn the receiver.\r\n\t\"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'(self to: aNumber by: increment) consume: aBlock' doc'iteration'}","function(self,aNumber,increment,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nfor i=self,aNumber,increment do fn(i) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Number,"asString",0
,function(self)
return (smalltalk:printString_((self)));
end
,"converting","asString\r\n\t\" Return the receiver as a String. \"\r\n\r\n\t^self printString","function(self)\r\nreturn (smalltalk:printString_((self)));\r\nend")

smalltalk:bind(smalltalk.Number,"asNative:",0
,function(self,lang)
return (smalltalk:object_comma_((smalltalk:object_comma_(("("),smalltalk:printString_((self)))),")"));
end
,"converting","asNative: lang\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t^'(', self printString, ')'","function(self,lang)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"(\"),smalltalk:printString_((self)))),\")\"));\r\nend")

smalltalk:bind(smalltalk.Number,"printString",0
,function(self)
return (tostring(self));
end
,"printing","printString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^{'' doc'native conversion'}","function(self)\r\nreturn (tostring(self));\r\nend")

smalltalk:bind(smalltalk.Number,"toString:",0
,function(self,radix)
if not (((radix):isNumber()))==true then return (("converting"):toString_(radix)); end;
return (smalltalk:basen(self,radix));
end
,"printing","toString: radix\r\n\t\" Return the ASCII representation of the receiver in base radix. \"\r\n\r\n\tradix isNumber ifFalse: [\r\n\t\t^#converting toString: radix\r\n\t].\r\n\t^{'' doc'native conversion'}","function(self,radix)\r\nif not (((radix):isNumber()))==true then return ((\"converting\"):toString_(radix)); end;\r\nreturn (smalltalk:basen(self,radix));\r\nend")

smalltalk:bind(smalltalk.Number,"printPaddedWith:to:base:",0
,function(self,aCharacter,anInteger,aRadix)
local result=nil
(function()
	local _s8_value=((self):toString_(aRadix))
	result=_s8_value
	return _s8_value
end)();
while ((function()
return ((((result):size()) < anInteger))
end))() do (function()
	local _s8_value=(smalltalk:object_comma_((aCharacter),result))
	result=_s8_value
	return _s8_value
end)(); end;
return (result);
end
,"printing","printPaddedWith: aCharacter to: anInteger base: aRadix\r\n\t\" Return the ASCII representation of the receiver padded on the left with aCharacter to be at least anInteger characters. \"\r\n\r\n\t| result |\r\n\tresult := self toString: aRadix.\r\n\t[ result size < anInteger ] whileTrue: [\r\n\t\tresult := aCharacter ,result\r\n\t].\r\n\t^result","function(self,aCharacter,anInteger,aRadix)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):toString_(aRadix))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn ((((result):size()) < anInteger))\r\nend))() do (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((aCharacter),result))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Number,"isNumber",0
,function(self)
if (self~=self) then return false else return (self~=math.huge and self~=-math.huge) end;
return (self);
end
,"testing","isNumber\r\n\t\" Return true if the receiver is a Number. \"\r\n\r\n\t{'' doc'number testing'}","function(self)\r\nif (self~=self) then return false else return (self~=math.huge and self~=-math.huge) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Number,"atRandom",0
,function(self)
return ((((((smalltalk.Random):new()):next()):_star(self)):truncated()):_plus(1));
end
,"converting","atRandom\r\n\t\" Return a random integer in the interval from 1 to the receiver. \"\r\n\r\n\t^(Random new next * self) truncated + 1","function(self)\r\nreturn ((((((smalltalk.Random):new()):next()):_star(self)):truncated()):_plus(1));\r\nend")

smalltalk:bind(smalltalk.Number,"@","_at"
,function(self,aNumber)
return ((smalltalk.Point):x_y_(self,smalltalk:if_true_false_((smalltalk:isNil_((aNumber))),(function()
return (0)
end),(function()
return (aNumber)
end))));
end
,"converting","@ aNumber\r\n\t\" Return a Point with coordinates given by the receiver and aNumber. \"\r\n\r\n\t^Point x: self y: (aNumber isNil ifTrue: [0] ifFalse: [aNumber])","function(self,aNumber)\r\nreturn ((smalltalk.Point):x_y_(self,smalltalk:if_true_false_((smalltalk:isNil_((aNumber))),(function()\r\nreturn (0)\r\nend),(function()\r\nreturn (aNumber)\r\nend))));\r\nend")

smalltalk:bind(smalltalk.Number,"asPoint",0
,function(self)
return ((smalltalk.Point):x_y_(self,self));
end
,"converting","asPoint\r\n\t\" Return the receiver as a Point. \"\r\n\r\n\t^Point x: self y: self","function(self)\r\nreturn ((smalltalk.Point):x_y_(self,self));\r\nend")

smalltalk:bind(smalltalk.Number,"asJSONObject",0
,function(self)

return ((self):_plus(0));
end
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t{'self'}.\r\n\t^self + 0\r\n\"Note:\twe need to normalize result to do not destroy typeof checkings\r\n\tDo NOT modify this method if you do not know what you are doing.\r\n\tIf you remove the + 0 computation, the returned object will return 'object' and not 'number' as result of typeof operation.\r\n\"","function(self)\r\n\r\nreturn ((self):_plus(0));\r\nend")

smalltalk:bind(smalltalk.Number,"between:and:",0
,function(self,min,max)
return (smalltalk:boolean_and_((((min) <= self)),(function()
return (((self) <= max))
end)));
end
,"testing","between: min and: max\r\n\t\" Return true if the receiver is between arguments. \"\r\n\r\n\t^min <= self and: [ self <= max ]","function(self,min,max)\r\nreturn (smalltalk:boolean_and_((((min) <= self)),(function()\r\nreturn (((self) <= max))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Number,"even",0
,function(self)
return (smalltalk:isObject_equalTo_(((self):_bk_bk(2)),0));
end
,"testing","even\r\n\t\" Return true if the receiver is an even number. \"\r\n\r\n\t^self \\\\ 2 = 0","function(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):_bk_bk(2)),0));\r\nend")

smalltalk:bind(smalltalk.Number,"odd",0
,function(self)
return (smalltalk:isObject_equalTo_(((self):_bk_bk(2)),1));
end
,"testing","odd\r\n\t\" Return true if the receiver is an odd number. \"\r\n\r\n\t^self \\\\ 2 = 1","function(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):_bk_bk(2)),1));\r\nend")

smalltalk:bind(smalltalk.Number,"clearInterval",0
,function(self)
if true then self:notImplementedYet_("clearInterval") end;
return (self);
end
,"intervals","clearInterval\r\n\r\n\t{'' doc'native timer cancelation'}","function(self)\r\nif true then self:notImplementedYet_(\"clearInterval\") end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Number,"clearTimeout",0
,function(self)
if true then self:notImplementedYet_("clearTimeout") end;
return (self);
end
,"intervals","clearTimeout\r\n\r\n\t{'' doc'native timer cancelation'}","function(self)\r\nif true then self:notImplementedYet_(\"clearTimeout\") end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Number,"shallowCopy",0
,function(self)
return (self);
end
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Number,"deepCopy",0
,function(self)
return (self);
end
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Number["$klass"],"pi",0
,function(self)
return (math.pi);
end
,"instantiation","pi\r\n\t\" Return the singular value PI. \"\r\n\r\n\t^{'' doc'native constant'}","function(self)\r\nreturn (math.pi);\r\nend")

smalltalk:bind(smalltalk.Number["$klass"],"readFrom:radix:",0
,function(self,aStream,radix)
local value=nil
local char=nil
(function()
	local _s8_value=(0)
	value=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((aStream):peek())
	char=_s8_value
	return _s8_value
end)();return (smalltalk:boolean_and_((smalltalk:notNil_((char))),(function()
return (smalltalk:boolean_or_(((char):isDigit()),(function()
return ((char):isUpperCase())
end)))
end)))
end))() do if (((radix) < (char):digitValue()))==true then return (value); end;
(function()
	local _s8_value=(((value):_star(radix)):_plus((char):digitValue()))
	value=_s8_value
	return _s8_value
end)();
(aStream):next(); end;
return (value);
end
,"converting","readFrom: aStream radix: radix\r\n\t\" Private - Read an integer from <aStream> and return it. \"\r\n\r\n\t| value char |\r\n\tvalue := 0.\r\n\t[\tchar := aStream peek.\r\n\t\tchar notNil and: [ char isDigit or: [ char isUpperCase ] ]\r\n\t] whileTrue: [\r\n\t\tradix <  char digitValue ifTrue: [ ^value ].\r\n\t\tvalue := value * radix + char digitValue.\r\n\t\taStream next\r\n\t].\r\n\t^value","function(self,aStream,radix)\r\nlocal value=nil\r\nlocal char=nil\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((aStream):peek())\r\n\tchar=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:boolean_and_((smalltalk:notNil_((char))),(function()\r\nreturn (smalltalk:boolean_or_(((char):isDigit()),(function()\r\nreturn ((char):isUpperCase())\r\nend)))\r\nend)))\r\nend))() do if (((radix) < (char):digitValue()))==true then return (value); end;\r\n(function()\r\n\tlocal _s8_value=(((value):_star(radix)):_plus((char):digitValue()))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aStream):next(); end;\r\nreturn (value);\r\nend")

smalltalk:bind(smalltalk.Number["$klass"],"readFrom:",0
,function(self,aStream)
local value=nil
local char=nil
(function()
	local _s8_value=(0)
	value=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((aStream):peek())
	char=_s8_value
	return _s8_value
end)();return (smalltalk:boolean_and_((smalltalk:notNil_((char))),(function()
return ((char):isDigit())
end)))
end))() do (function()
	local _s8_value=(((value):_star(10)):_plus((char):digitValue()))
	value=_s8_value
	return _s8_value
end)();
(aStream):next(); end;
if not ((smalltalk:isObject_equalTo_(("r"),char)))==true then return (value); end;
(aStream):next();
return ((self):readFrom_radix_(aStream,value));
end
,"converting","readFrom: aStream\r\n\t\" Private - Read an integer from <aStream> and return it. \"\r\n\r\n\t| value char |\r\n\tvalue := 0.\r\n\t[\tchar := aStream peek.\r\n\t\tchar notNil and: [ char isDigit ]\r\n\t] whileTrue: [\r\n\t\tvalue := value * 10 + char digitValue.\r\n\t\taStream next\r\n\t].\r\n\t$r = char ifFalse: [ ^value ].\r\n\taStream next.\r\n\t^self readFrom: aStream radix: value","function(self,aStream)\r\nlocal value=nil\r\nlocal char=nil\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((aStream):peek())\r\n\tchar=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:boolean_and_((smalltalk:notNil_((char))),(function()\r\nreturn ((char):isDigit())\r\nend)))\r\nend))() do (function()\r\n\tlocal _s8_value=(((value):_star(10)):_plus((char):digitValue()))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aStream):next(); end;\r\nif not ((smalltalk:isObject_equalTo_((\"r\"),char)))==true then return (value); end;\r\n(aStream):next();\r\nreturn ((self):readFrom_radix_(aStream,value));\r\nend")

smalltalk:bind(smalltalk.Number["$klass"],"readFromOBSOLETE:",0
,function(self,aStream)
local value=nil
local char=nil
(function()
	local _s8_value=(0)
	value=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((aStream):peek())
	char=_s8_value
	return _s8_value
end)();return (smalltalk:boolean_and_((smalltalk:notNil_((char))),(function()
return ((char):isDigit())
end)))
end))() do (function()
	local _s8_value=(((value):_star(10)):_plus((char):digitValue()))
	value=_s8_value
	return _s8_value
end)();
(aStream):next(); end;
if not ((((char)=="r")))==true then return (value); end;
(aStream):next();
return ((self):readFrom_radix_(aStream,value));
end
,"converting","readFromOBSOLETE: aStream\r\n\t\" Private - Read an integer from <aStream> and return it. \"\r\n\r\n\t| value char |\r\n\tvalue := 0.\r\n\t[\tchar := aStream peek.\r\n\t\tchar notNil and: [ char isDigit ]\r\n\t] whileTrue: [\r\n\t\tvalue := value * 10 + char digitValue.\r\n\t\taStream next\r\n\t].\r\n\tchar == \"$r\"'r' ifFalse: [ ^value ].\r\n\taStream next. \"skip the r\"\r\n\t^self readFrom: aStream radix: value","function(self,aStream)\r\nlocal value=nil\r\nlocal char=nil\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((aStream):peek())\r\n\tchar=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:boolean_and_((smalltalk:notNil_((char))),(function()\r\nreturn ((char):isDigit())\r\nend)))\r\nend))() do (function()\r\n\tlocal _s8_value=(((value):_star(10)):_plus((char):digitValue()))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aStream):next(); end;\r\nif not ((((char)==\"r\")))==true then return (value); end;\r\n(aStream):next();\r\nreturn ((self):readFrom_radix_(aStream,value));\r\nend")

smalltalk:addClass("BlockClosure",smalltalk.Object,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.BlockClosure["$klass"],"empty",0
,function(self)
return ((function()
return (nil)
end));
end
,"instantiation","empty\r\n\t\" Return an empty block. \"\r\n\r\n\t^[]","function(self)\r\nreturn ((function()\r\nreturn (nil)\r\nend));\r\nend")

smalltalk:bind(smalltalk.BlockClosure["$klass"],"defaultSortBlock",0
,function(self)

return ((function(a,b)
return (((function()
return (((a) < b))
end)):on_do_(smalltalk.Exception,(function()
return (((smalltalk:toString_((a))) < smalltalk:toString_((b))))
end)))
end));
end
,"instantiation","defaultSortBlock\r\n\t\" Private - Return the block used for default sort. \"\r\n\r\n\t{'self'}.\r\n\t^[:a :b| [ a < b ] on: Exception do: [ a toString < b toString ] ]","function(self)\r\n\r\nreturn ((function(a,b)\r\nreturn (((function()\r\nreturn (((a) < b))\r\nend)):on_do_(smalltalk.Exception,(function()\r\nreturn (((smalltalk:toString_((a))) < smalltalk:toString_((b))))\r\nend)))\r\nend));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"compiledSourceAt:",0
,function(self,aCompiledMethod)
local cached=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((aCompiledMethod))),(function()
return (smalltalk:basic_at_ifAbsent_((aCompiledMethod),"$nativeSource",(function()
return (nil)
end)))
end),nil))
	cached=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:isNil_((cached))),(function()
return ((self):compiledSource())
end),(function()
return (cached)
end)));
end
,"accessing","compiledSourceAt: aCompiledMethod\r\n\t\" Return the native source code of the receiver. \"\r\n\r\n\t| cached |\r\n\tcached := aCompiledMethod notNil ifTrue: [\r\n\t\taCompiledMethod basicAt: '$nativeSource' ifAbsent: []\r\n\t].\r\n\t^cached isNil ifTrue: [ self compiledSource ] ifFalse: [ cached ]","function(self,aCompiledMethod)\r\nlocal cached=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((aCompiledMethod))),(function()\r\nreturn (smalltalk:basic_at_ifAbsent_((aCompiledMethod),\"$nativeSource\",(function()\r\nreturn (nil)\r\nend)))\r\nend),nil))\r\n\tcached=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((cached))),(function()\r\nreturn ((self):compiledSource())\r\nend),(function()\r\nreturn (cached)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"compiledSource",0
,function(self)

return (smalltalk:toString_((self)));
end
,"accessing","compiledSource\r\n\t\" Return the native source code of the receiver. \"\r\n\r\n\t{'self'}.\r\n\t^self toString","function(self)\r\n\r\nreturn (smalltalk:toString_((self)));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"whileTrue:",0
,function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
while self() do fn() end;
return (self);
end
,"iterating","whileTrue: aBlock\r\n\t\" Evaluate aBlock while the result of evaluating the receiver is true. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8' self value == true ifTrue: [\r\n\t\taBlock value.\r\n\t\tself whileTrue: aBlock\r\n\t]' doc'iteration'}","function(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile self() do fn() end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"whileFalse:",0
,function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
while (self()==false) do fn() end;
return (self);
end
,"iterating","whileFalse: aBlock\r\n\t\" Evaluate aBlock while the result of evaluating the receiver is false. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'\tself value == false ifTrue: [\r\n\t\taBlock value.\r\n\t\tself whileFalse: aBlock\r\n\t]' doc'iteration'}","function(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile (self()==false) do fn() end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"whileTrue",0
,function(self)
return ((self):whileTrue_((function()
return (nil)
end)));
end
,"iterating","whileTrue\r\n\t\" Evaluate the receiver while the result is true. \"\r\n\r\n\t^self whileTrue: []","function(self)\r\nreturn ((self):whileTrue_((function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"whileFalse",0
,function(self)
return ((self):whileFalse_((function()
return (nil)
end)));
end
,"iterating","whileFalse\r\n\t\" Evaluate the receiver while the result is false. \"\r\n\r\n\t^self whileFalse: []","function(self)\r\nreturn ((self):whileFalse_((function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"value",0
,function(self)
return (self());
end
,"evaluating","value\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^{'self()' doc'native activation'}","function(self)\r\nreturn (self());\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"value:",0
,function(self,anObject)
return (self(anObject));
end
,"evaluating","value: anObject\r\n\t\" Return the result of evaluating the receiver with anObject. \"\r\n\r\n\t^{'self(anObject)' doc'native activation'}","function(self,anObject)\r\nreturn (self(anObject));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"value:value:",0
,function(self,arg1,arg2)
return (self(arg1,arg2));
end
,"evaluating","value: arg1 value: arg2\r\n\t\" Return the result of evaluating the receiver with arguments. \"\r\n\r\n\t^{'self(arg1,arg2)' doc'native activation'}","function(self,arg1,arg2)\r\nreturn (self(arg1,arg2));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"value:value:value:",0
,function(self,arg1,arg2,arg3)
return (self(arg1,arg2,arg3));
end
,"evaluating","value: arg1 value: arg2 value: arg3\r\n\t\" Return the result of evaluating the receiver with arguments. \"\r\n\r\n\t^{'self(arg1,arg2,arg3)' doc'native activation'}","function(self,arg1,arg2,arg3)\r\nreturn (self(arg1,arg2,arg3));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"value:value:value:value:",0
,function(self,arg1,arg2,arg3,arg4)
return (self(arg1,arg2,arg3,arg4));
end
,"evaluating","value: arg1 value: arg2 value: arg3 value: arg4\r\n\t\" Return the result of evaluating the receiver with arguments. \"\r\n\r\n\t^{'self(arg1,arg2,arg3,arg4)' doc'native activation'}","function(self,arg1,arg2,arg3,arg4)\r\nreturn (self(arg1,arg2,arg3,arg4));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"valueWithPossibleArguments:",0
,function(self,array)
if not (((array):isArray()))==true then (self):error_(smalltalk:object_comma_(("Invalid arguments in #valueWithPossibleArguments: (must be anArray). receiver="),smalltalk:toString_((self)))); end;
return (self((table.unpack or unpack)(array)));
end
,"evaluating","valueWithPossibleArguments: array\r\n\t\" Return the result of evaluating the receiver with potential arguments. \"\r\n\r\n\tarray isArray ifFalse: [\r\n\t\tself error: 'Invalid arguments in #valueWithPossibleArguments: (must be anArray). receiver=' ,self toString\r\n\t].\r\n\t^{'' doc'native activation'}","function(self,array)\r\nif not (((array):isArray()))==true then (self):error_(smalltalk:object_comma_((\"Invalid arguments in #valueWithPossibleArguments: (must be anArray). receiver=\"),smalltalk:toString_((self)))); end;\r\nreturn (self((table.unpack or unpack)(array)));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"exception:matches:",0
,function(self,anException,type)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (smalltalk:isNil_((type)))==true then return (true); end;
if not (((self):isObject_(type)))==true then return (smalltalk:isObject_equalTo_((type),anException)); end;
if ((type):isClass())==true then return (smalltalk:is_kindOf_((anException),(type))); end;
if (smalltalk:isObject_equalTo_((type),"all"))==true then return (true); end;
if ((type):isArray())==true then (type):detect_ifNone_((function(one)
return ((self):exception_matches_(anException,one))
end),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)(); end;
if ((type):isString())==true then local cls=nil
(function()
	local _s8_value=(((self):smalltalk()):at_ifAbsent_(cls,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
	cls=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):exception_matches_(anException,cls))
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((((type):evaluateWith_(anException))==true))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"private","exception: anException matches: type\r\n\t\" Private - Return true if anException is of specified type. \"\r\n\r\n\ttype isNil ifTrue: [ ^true ].\r\n\t(self isObject: type) ifFalse: [ ^type = anException ].\r\n\ttype isClass ifTrue: [ ^anException isKindOf: type ].\r\n\ttype = #all ifTrue: [ ^true ].\r\n\ttype isArray ifTrue: [\r\n\t\ttype\r\n\t\t\tdetect: [:one| self exception: anException matches: one ]\r\n\t\t\tifNone: [ ^false ].\r\n\t\t^true\r\n\t].\r\n\ttype isString ifTrue: [ | cls |\r\n\t\tcls := self smalltalk at: cls ifAbsent: [ ^false ].\r\n\t\t^self exception: anException matches: cls\r\n\t].\r\n\t^(type evaluateWith: anException) == true ","function(self,anException,type)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (smalltalk:isNil_((type)))==true then return (true); end;\r\nif not (((self):isObject_(type)))==true then return (smalltalk:isObject_equalTo_((type),anException)); end;\r\nif ((type):isClass())==true then return (smalltalk:is_kindOf_((anException),(type))); end;\r\nif (smalltalk:isObject_equalTo_((type),\"all\"))==true then return (true); end;\r\nif ((type):isArray())==true then (type):detect_ifNone_((function(one)\r\nreturn ((self):exception_matches_(anException,one))\r\nend),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\nif ((type):isString())==true then local cls=nil\r\n(function()\r\n\tlocal _s8_value=(((self):smalltalk()):at_ifAbsent_(cls,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):exception_matches_(anException,cls))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((((type):evaluateWith_(anException))==true))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"on:do:",0
,function(self,type,aBlock)
return ((self):try_catch_(self,(function(anException)
return (smalltalk:if_true_false_(((self):exception_matches_(anException,type)),(function()
return ((aBlock):evaluateWith_(anException))
end),(function()
return ((anException):signal())
end)))
end)));
end
,"evaluating","on: type do: aBlock\r\n\t\" Return the result of evaluating the receiver catching exceptions of specified type. \"\r\n\r\n\t^self try: self catch: [:anException |\r\n\t\t(self exception: anException matches: type)\r\n\t\tifTrue: [ aBlock evaluateWith: anException ]\r\n\t\tifFalse: [ anException signal ]\r\n\t]","function(self,type,aBlock)\r\nreturn ((self):try_catch_(self,(function(anException)\r\nreturn (smalltalk:if_true_false_(((self):exception_matches_(anException,type)),(function()\r\nreturn ((aBlock):evaluateWith_(anException))\r\nend),(function()\r\nreturn ((anException):signal())\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"try:catch:",0
,function(self,aBlock,anotherBlock)
local fn=nil
local ab=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):callableOf_(anotherBlock))
	ab=_s8_value
	return _s8_value
end)();

	local success, result = pcall(function() return fn() end)
	if success
		then return result
		else return ab( self:smalltalkErrorOf_(result) ) end;
return (self);
end
,"private","try: aBlock catch: anotherBlock\r\n\t\" Private - Try to evaluate aBlock catching exceptions with catchBlock. \"\r\n\r\n\t| fn ab |\r\n\tfn := self callableOf: aBlock.\r\n\tab := self callableOf: anotherBlock.\r\n\t{'' doc'secured activation'}","function(self,aBlock,anotherBlock)\r\nlocal fn=nil\r\nlocal ab=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(anotherBlock))\r\n\tab=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\n\tlocal success, result = pcall(function() return fn() end)\r\n\tif success\r\n\t\tthen return result\r\n\t\telse return ab( self:smalltalkErrorOf_(result) ) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"valueDeferred:",0
,function(self,milliseconds)
(self):valueWithTimeout_(milliseconds);
return (self);
end
,"evaluating","valueDeferred: milliseconds\r\n\t\" Evaluate the receiver deferred in time.\r\n\tReturn the receiver.\r\n\t\"\r\n\r\n\tself valueWithTimeout: milliseconds","function(self,milliseconds)\r\n(self):valueWithTimeout_(milliseconds);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BlockClosure["$klass"],"hasDeferredSupport",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
((function()
return (smalltalk:notNil_((setTimeout)))
end)):on_do_(smalltalk.Exception,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:notNil_((setTimeout)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"deferredEvaluation","hasDeferredSupport\r\n\t\" Return true if the platform can defer instance evaluation. \"\r\n\r\n\t[ #{setTimeout} notNil ] on: Exception do: [ ^false ].\r\n\t^#{setTimeout} notNil","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n((function()\r\nreturn (smalltalk:notNil_((setTimeout)))\r\nend)):on_do_(smalltalk.Exception,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:notNil_((setTimeout)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"valueDeferred",0
,function(self)
(self):valueDeferred_(0);
return (self);
end
,"evaluating","valueDeferred\r\n\t\" Evaluate the receiver deferred in time.\r\n\tReturn the receiver.\r\n\t\"\r\n\r\n\tself valueDeferred: 0","function(self)\r\n(self):valueDeferred_(0);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"valueWithTimeout:",0
,function(self,aNumber)
return (self:notImplementedYet_("valueWithTimeout:"));
end
,"timeout","valueWithTimeout: aNumber\r\n\t\" Evaluate the receiver with time out. \"\r\n\r\n\t^{'' doc'native timer activation'}","function(self,aNumber)\r\nreturn (self:notImplementedYet_(\"valueWithTimeout:\"));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"valueWithInterval:",0
,function(self,aNumber)
return (self:notImplementedYet_("valueWithInterval:"));
end
,"timeout","valueWithInterval: aNumber\r\n\t\" Evaluate the receiver with interval. \"\r\n\r\n\t^{'' doc'native timer activation'}","function(self,aNumber)\r\nreturn (self:notImplementedYet_(\"valueWithInterval:\"));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"ensure:",0
,function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();

	local success, result = pcall(function() return self() end)
	fn()
	if true then return result end;
return (self);
end
,"evaluating","ensure: aBlock\r\n\t\" Return the result of evaluating the receiver.\r\n\tExecute aBlock after the receiver is executed.\r\n\t\"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{'' doc'protected activation'}","function(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\n\tlocal success, result = pcall(function() return self() end)\r\n\tfn()\r\n\tif true then return result end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"ifCurtailed:",0
,function(self,exceptionBlock)
local curtailed=nil
local result=nil
(function()
	local _s8_value=(true)
	curtailed=_s8_value
	return _s8_value
end)();

	local curtailed = true
	local success, result = pcall(function()
		local r = self()
		curtailed = false
		return r
	end)
	if (curtailed)
		then exceptionBlock:value()
		else return result
		end;
return (self);
end
,"evaluating","ifCurtailed: exceptionBlock\r\n\t\" Return the result of evaluating the receiver.\r\n\tIf evaluation is limited by exiting before completion, the exception block is evaluated.\r\n\t\"\r\n\r\n\t| curtailed result |\r\n\tcurtailed := true.\r\n\t{'' doc'protected activation'}","function(self,exceptionBlock)\r\nlocal curtailed=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(true)\r\n\tcurtailed=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\n\tlocal curtailed = true\r\n\tlocal success, result = pcall(function()\r\n\t\tlocal r = self()\r\n\t\tcurtailed = false\r\n\t\treturn r\r\n\tend)\r\n\tif (curtailed)\r\n\t\tthen exceptionBlock:value()\r\n\t\telse return result\r\n\t\tend;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"argumentCount",0
,function(self)
return (self:notImplementedYet_("argumentCount"));
end
,"evaluating","argumentCount\r\n\t\" Return the number of arguments of the receiver. \"\r\n\r\n\t^{'' doc'activation constants'}","function(self)\r\nreturn (self:notImplementedYet_(\"argumentCount\"));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"installAs:",0
,function(self,functionName)
return ((smalltalk.Smalltalk):install_as_(self,functionName));
end
,"installing","installAs: functionName\r\n\t\" Install the receiver as a function in global scope. \"\r\n\r\n\t^Smalltalk install: self as: functionName","function(self,functionName)\r\nreturn ((smalltalk.Smalltalk):install_as_(self,functionName));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"asJSONObject",0
,function(self)
return (self);
end
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"shallowCopy",0
,function(self)
return (self);
end
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"deepCopy",0
,function(self)
return (self);
end
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"isValuable",0
,function(self)
return (true);
end
,"testing","isValuable\r\n\t\" Return true if the receiver can be evaluated. \"\r\n\r\n\t^true","function(self)\r\nreturn (true);\r\nend")

smalltalk:addClass("UndefinedObject",smalltalk.Object,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.UndefinedObject["$klass"],"new",0
,function(self)
return ((self):error_("UndefinedObject can't be instantiated."));
end
,"instantiation","new\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self error: 'UndefinedObject can''t be instantiated.'","function(self)\r\nreturn ((self):error_(\"UndefinedObject can't be instantiated.\"));\r\nend")

smalltalk:bind(smalltalk.UndefinedObject["$klass"],"alias",0
,function(self)
return ((self):basicAt_ifAbsentPut_("@alias",(function()
return ((self):basicNew())
end)));
end
,"alias","alias\r\n\t\" Private - Return an alias of nil.\r\n\tNote that is is a hack used to wrap nil in an alias instance to make possible for Lua collections to contain nil\r\n\t\"\r\n\r\n\t^self basicAt: '@alias' ifAbsentPut: [ self basicNew ]","function(self)\r\nreturn ((self):basicAt_ifAbsentPut_(\"@alias\",(function()\r\nreturn ((self):basicNew())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"ifNil:",0
,function(self,aBlock)
return ((aBlock):value());
end
,"testing","ifNil: aBlock\r\n\t\" Return the receiver if it is not nil, or the result of evaluating aBlock (if it is nil). \"\r\n\r\n\t^aBlock value","function(self,aBlock)\r\nreturn ((aBlock):value());\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"ifNotNil:",0
,function(self,aBlock)
return (self);
end
,"testing","ifNotNil: aBlock\r\n\t\" Return the receiver if it is nil, or the result of evaluating aBlock. \"\r\n\r\n\t^self","function(self,aBlock)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"ifNil:ifNotNil:",0
,function(self,aBlock,anotherBlock)
return ((aBlock):value());
end
,"testing","ifNil: aBlock ifNotNil: anotherBlock\r\n\t\" Return the receiver if it is nil, or the result of evaluating aBlock. \"\r\n\r\n\t^aBlock value","function(self,aBlock,anotherBlock)\r\nreturn ((aBlock):value());\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"ifNotNil:ifNil:",0
,function(self,aBlock,anotherBlock)
return ((anotherBlock):value());
end
,"testing","ifNotNil: aBlock ifNil: anotherBlock\r\n\t\" Return the result of evaluating anotherBlock if teh receiver is nil, or the result of evaluating aBlock. \"\r\n\r\n\t^anotherBlock value","function(self,aBlock,anotherBlock)\r\nreturn ((anotherBlock):value());\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"isNil",0
,function(self)
return (true);
end
,"testing","isNil\r\n\t\" Return true if the receiver is nil. \"\r\n\r\n\t^true","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"notNil",0
,function(self)
return (false);
end
,"testing","notNil\r\n\t\" Return true if the receiver is not nil. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"printString",0
,function(self)
return ("nil");
end
,"printing","printString\r\n\t\" Return the text representation of the receiver. \"\r\n\r\n\t^#nil","function(self)\r\nreturn (\"nil\");\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:",0
,function(self,aString,anotherString)
return ((self):subclass_instanceVariableNames_category_(aString,anotherString,nil));
end
,"instantiation","subclass: aString instanceVariableNames: anotherString\r\n\t\" Create a subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: anotherString\r\n\t\tcategory: nil","function(self,aString,anotherString)\r\nreturn ((self):subclass_instanceVariableNames_category_(aString,anotherString,nil));\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:category:",0
,function(self,aString,aString2,aString3)
return (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_category_(self,aString,aString2,aString3));
end
,"instantiation","subclass: aString instanceVariableNames: aString2 category: aString3\r\n\t\" Create a subclass of the receiver. \"\r\n\r\n\t^ClassBuilder new\r\n\t\tsuperclass: self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tcategory: aString3","function(self,aString,aString2,aString3)\r\nreturn (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_category_(self,aString,aString2,aString3));\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"asJSONObject",0
,function(self)
return (nil);
end
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t^{'' doc'native constant'}","function(self)\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"shallowCopy",0
,function(self)
return (self);
end
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"deepCopy",0
,function(self)
return (self);
end
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"value",0
,function(self)
return (self);
end
,"evaluating","value\r\n\t\" Return the result of evaluating the receiver. \"","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"@","_at"
,function(self,aNumber)
return ((smalltalk.Point):x_y_(0,aNumber));
end
,"converting","@ aNumber\r\n\t\" Return a Point with coordinates given by the receiver and aNumber. \"\r\n\r\n\t^Point x: 0 y: aNumber","function(self,aNumber)\r\nreturn ((smalltalk.Point):x_y_(0,aNumber));\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"=","_eq"
,function(self,anObject)
return (smalltalk:isNil_((anObject)));
end
,"comparing","= anObject\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\t^anObject isNil","function(self,anObject)\r\nreturn (smalltalk:isNil_((anObject)));\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"~=","_no_eq"
,function(self,anObject)
return (smalltalk:notNil_((anObject)));
end
,"comparing","~= anObject\r\n\t\" Return true if the receiver is not equal to anObject. \"\r\n\r\n\t^anObject notNil","function(self,anObject)\r\nreturn (smalltalk:notNil_((anObject)));\r\nend")

smalltalk:addClass("Collection",smalltalk.Object,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.Collection,"wrap:",0
,function(self,anObject)
if smalltalk:isNil_(anObject) --anObject==nil
	then return smalltalk.UndefinedObject:alias()
	else return anObject end;
return (anObject);
end
,"alias","wrap: anObject\r\n\t\" Private - Return an element holding anObject. \"\r\n\r\n\t{'self'}.\r\n\t^anObject","function(self,anObject)\r\nif smalltalk:isNil_(anObject) --anObject==nil\r\n\tthen return smalltalk.UndefinedObject:alias()\r\n\telse return anObject end;\r\nreturn (anObject);\r\nend")

smalltalk:bind(smalltalk.Collection,"unwrap:",0
,function(self,anObject)
--if anObject==nil then return nil end
	--if (type(anObject)=="table") and smalltalk:isNil_(anObject)
	if smalltalk:isNil_(anObject)
		then return nil
		else return anObject end;
return (anObject);
end
,"alias","unwrap: anObject\r\n\t\" Private - Return object held by anObject. \"\r\n\r\n\t{'self'}.\r\n\t^anObject","function(self,anObject)\r\n--if anObject==nil then return nil end\r\n\t--if (type(anObject)==\"table\") and smalltalk:isNil_(anObject)\r\n\tif smalltalk:isNil_(anObject)\r\n\t\tthen return nil\r\n\t\telse return anObject end;\r\nreturn (anObject);\r\nend")

smalltalk:bind(smalltalk.Collection,"size",0
,function(self)
return ((self):subclassResponsibility_("size"));
end
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^self subclassResponsibility: #size","function(self)\r\nreturn ((self):subclassResponsibility_(\"size\"));\r\nend")

smalltalk:bind(smalltalk.Collection,"readStream",0
,function(self)
return ((self):stream());
end
,"streams","readStream\r\n\t\" Return a read stream on the receiver. \"\r\n\r\n\t^self stream","function(self)\r\nreturn ((self):stream());\r\nend")

smalltalk:bind(smalltalk.Collection,"writeStream",0
,function(self)
return ((self):stream());
end
,"streams","writeStream\r\n\t\" Return a write stream on the receiver. \"\r\n\r\n\t^self stream","function(self)\r\nreturn ((self):stream());\r\nend")

smalltalk:bind(smalltalk.Collection,"stream",0
,function(self)
return (((self):streamClass()):on_(self));
end
,"streams","stream\r\n\t\" Return a stream on the receiver. \"\r\n\r\n\t^self streamClass on: self","function(self)\r\nreturn (((self):streamClass()):on_(self));\r\nend")

smalltalk:bind(smalltalk.Collection,"streamClass",0
,function(self)
return (((self)["$klass"]):streamClass());
end
,"streams","streamClass\r\n\t\" Private - Return the support for streamming on the receiver. \"\r\n\r\n\t^self class streamClass","function(self)\r\nreturn (((self)[\"$klass\"]):streamClass());\r\nend")

smalltalk:bind(smalltalk.Collection,"objectNotFound",0
,function(self)
((self):smalltalk()):objectNotFound(nil,nil,self);
return ((self):error_("Object is not in the collection"));
end
,"error","objectNotFound\r\n\t\" Private - Generates an error.\r\n\tAn object was not found in the receiver's contents.\r\n\t\"\r\n\r\n\tself smalltalk #objectNotFound: nil at: nil in: self.\r\n\t^self error: 'Object is not in the collection'","function(self)\r\n((self):smalltalk()):objectNotFound(nil,nil,self);\r\nreturn ((self):error_(\"Object is not in the collection\"));\r\nend")

smalltalk:bind(smalltalk.Collection,"invalidIndex:",0
,function(self,anIndex)
return ((self):error_(smalltalk:object_comma_(("Invalid index "),anIndex)));
end
,"error","invalidIndex: anIndex\r\n\t\" Private - Generates an error.\r\n\tAn index to the receiver's contents is invalid/wrong.\r\n\t\"\r\n\r\n\t^self error: 'Invalid index ' ,anIndex ","function(self,anIndex)\r\nreturn ((self):error_(smalltalk:object_comma_((\"Invalid index \"),anIndex)));\r\nend")

smalltalk:bind(smalltalk.Collection,"objectNotFound:",0
,function(self,anObject)
((self):smalltalk()):objectNotFound(anObject,nil,self);
return ((self):error_(smalltalk:object_comma_(("Object not found: "),(self):toString_(anObject))));
end
,"error","objectNotFound: anObject\r\n\t\" Private - Generates an error.\r\n\tanObject was not found in the receiver's contents.\r\n\t\"\r\n\r\n\tself smalltalk #objectNotFound: anObject at: nil in: self.\r\n\t^self error: 'Object not found: ' ,(self toString: anObject)","function(self,anObject)\r\n((self):smalltalk()):objectNotFound(anObject,nil,self);\r\nreturn ((self):error_(smalltalk:object_comma_((\"Object not found: \"),(self):toString_(anObject))));\r\nend")

smalltalk:bind(smalltalk.Collection,"objectNotFoundAt:",0
,function(self,indexOrKey)
((self):smalltalk()):objectNotFound(nil,indexOrKey,self);
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Object not found at "),(self):toString_(indexOrKey)))," in ")),(self):asLiteral())));
end
,"error","objectNotFoundAt: indexOrKey\r\n\t\" Private - Generates an error.\r\n\tThe object at key/index was not found in the receiver's contents.\r\n\t\"\r\n\r\n\tself smalltalk #objectNotFound: nil at: indexOrKey in: self.\r\n\t^self error: 'Object not found at '\r\n\t\t,(self toString: indexOrKey)\r\n\t\t,' in ' ,self asLiteral","function(self,indexOrKey)\r\n((self):smalltalk()):objectNotFound(nil,indexOrKey,self);\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Object not found at \"),(self):toString_(indexOrKey))),\" in \")),(self):asLiteral())));\r\nend")

smalltalk:bind(smalltalk.Collection,"add:",0
,function(self,anObject)
return ((self):subclassResponsibility_("add:"));
end
,"adding","add: anObject\r\n\t\" Add anObject to the receiver. \"\r\n\r\n\t^self subclassResponsibility: #add:","function(self,anObject)\r\nreturn ((self):subclassResponsibility_(\"add:\"));\r\nend")

smalltalk:bind(smalltalk.Collection,"addAll:",0
,function(self,aCollection)
(aCollection):do_((function(each)
return ((self):add_(each))
end));
return (aCollection);
end
,"adding","addAll: aCollection\r\n\t\" Add objects in aCollection to the receiver. \"\r\n\r\n\taCollection do: [:each | self add: each ].\r\n\t^aCollection","function(self,aCollection)\r\n(aCollection):do_((function(each)\r\nreturn ((self):add_(each))\r\nend));\r\nreturn (aCollection);\r\nend")

smalltalk:bind(smalltalk.Collection,",","_comma"
,function(self,aCollection)
return ((
function(_s8_rec)
	(_s8_rec):addAll_(aCollection);
	return ((_s8_rec):yourself())
end
)((self):copy()));
end
,"copying",", aCollection\r\n\t\" Return a copy of the receiver with all contents of aCollection. \"\r\n\r\n\t^self copy\r\n\t\taddAll: aCollection;\r\n\t\tyourself","function(self,aCollection)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAll_(aCollection);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):copy()));\r\nend")

smalltalk:bind(smalltalk.Collection,"copyWith:",0
,function(self,anObject)
return ((
function(_s8_rec)
	(_s8_rec):add_(anObject);
	return ((_s8_rec):yourself())
end
)((self):copy()));
end
,"copying","copyWith: anObject\r\n\t\" Return a copy of the receiver with anObject. \"\r\n\r\n\t^self copy add: anObject; yourself","function(self,anObject)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(anObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):copy()));\r\nend")

smalltalk:bind(smalltalk.Collection,"copyWithAll:",0
,function(self,aCollection)
return ((
function(_s8_rec)
	(_s8_rec):addAll_(aCollection);
	return ((_s8_rec):yourself())
end
)((self):copy()));
end
,"copying","copyWithAll: aCollection\r\n\t\" Return a copy of the receiver with all contents of aCollection. \"\r\n\r\n\t^self copy\r\n\t\taddAll: aCollection;\r\n\t\tyourself","function(self,aCollection)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAll_(aCollection);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):copy()));\r\nend")

smalltalk:bind(smalltalk.Collection,"asArray",0
,function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(self):do_((function(each)
return ((result):add_(each))
end));
return (result);
end
,"converting","asArray\r\n\t\" Return an array with the contents of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := Array new.\r\n\tself do: [:each| result add: each ].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(each)\r\nreturn ((result):add_(each))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Collection,"do:",0
,function(self,aBlock)
return ((self):subclassResponsibility_("do:"));
end
,"enumerating","do: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver. \"\r\n\r\n\t^self subclassResponsibility: #do:","function(self,aBlock)\r\nreturn ((self):subclassResponsibility_(\"do:\"));\r\nend")

smalltalk:bind(smalltalk.Collection,"detect:ifNone:",0
,function(self,aBlock,anotherBlock)
return ((self):subclassResponsibility_("detect:ifNone:"));
end
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. \"\r\n\r\n\t^self subclassResponsibility: #detect:ifNone:","function(self,aBlock,anotherBlock)\r\nreturn ((self):subclassResponsibility_(\"detect:ifNone:\"));\r\nend")

smalltalk:bind(smalltalk.Collection,"reverseDo:",0
,function(self,aBlock)
return ((self):subclassResponsibility_("reverseDo:"));
end
,"enumerating","reverseDo: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver in reverse order of iteration. \"\r\n\r\n\t^self subclassResponsibility: #reverseDo:","function(self,aBlock)\r\nreturn ((self):subclassResponsibility_(\"reverseDo:\"));\r\nend")

smalltalk:bind(smalltalk.Collection,"collect:",0
,function(self,aBlock)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(self):do_((function(each)
return ((result):add_((aBlock):value_(each)))
end));
return (result);
end
,"enumerating","collect: aBlock\r\n\t\" Return a collection with the result of evaluating aBlock with the contents of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tself do: [:each | result add: (aBlock value: each) ].\r\n\t^result","function(self,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(each)\r\nreturn ((result):add_((aBlock):value_(each)))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Collection,"select:",0
,function(self,aBlock)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(self):do_((function(each)
return (smalltalk:if_true_false_(((aBlock):value_(each)),(function()
return ((result):add_(each))
end),nil))
end));
return (result);
end
,"enumerating","select: aBlock\r\n\t\" Return the contents of the receiver which evaluates aBlock to true. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tself do: [:each|\r\n\t    (aBlock value: each) ifTrue: [ result add: each ]\r\n\t].\r\n\t^result","function(self,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((aBlock):value_(each)),(function()\r\nreturn ((result):add_(each))\r\nend),nil))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Collection,"detect:",0
,function(self,aBlock)
return ((self):detect_ifNone_(aBlock,(function()
return ((self):objectNotFound())
end)));
end
,"enumerating","detect: aBlock\r\n\t\" Return the object in the receiver that return true when evaluated with aBlock.\r\n\tGenerates an error if there is no object that evaluates aBlock to true.\r\n\t\"\r\n\r\n\t^self detect: aBlock ifNone: [ self objectNotFound ]","function(self,aBlock)\r\nreturn ((self):detect_ifNone_(aBlock,(function()\r\nreturn ((self):objectNotFound())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Collection,"do:andBetweenDo:",0
,function(self,aBlock,separatorBlock)
return ((self):do_separatedBy_(aBlock,separatorBlock));
end
,"enumerating","do: aBlock andBetweenDo: separatorBlock\r\n\t\" For each element in the receiver, evaluate aBlock with that element as the argument.\r\n\tEvaluate the separatorBlock between successive elements of the receiver.\r\n\t\"\r\n\r\n\t^self do: aBlock separatedBy: separatorBlock","function(self,aBlock,separatorBlock)\r\nreturn ((self):do_separatedBy_(aBlock,separatorBlock));\r\nend")

smalltalk:bind(smalltalk.Collection,"do:separatedBy:",0
,function(self,aBlock,anotherBlock)
local first=nil
(function()
	local _s8_value=(true)
	first=_s8_value
	return _s8_value
end)();
(self):do_((function(each)
if (first)==true then (function()
	local _s8_value=(false)
	first=_s8_value
	return _s8_value
end)(); else (anotherBlock):value(); end;return ((aBlock):value_(each))
end));
return (self);
end
,"enumerating","do: aBlock separatedBy: anotherBlock\r\n\t\" Evaluate aBlock for contents of the receiver evaluating anotherBlock inbetween aBlock evaluations. \"\r\n\r\n\t| first |\r\n\tfirst := true.\r\n\tself do: [:each |\r\n\t    first\r\n\t\tifTrue: [ first := false ]\r\n\t\tifFalse: [ anotherBlock value ].\r\n\t    aBlock value: each\r\n\t]","function(self,aBlock,anotherBlock)\r\nlocal first=nil\r\n(function()\r\n\tlocal _s8_value=(true)\r\n\tfirst=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(each)\r\nif (first)==true then (function()\r\n\tlocal _s8_value=(false)\r\n\tfirst=_s8_value\r\n\treturn _s8_value\r\nend)(); else (anotherBlock):value(); end;return ((aBlock):value_(each))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Collection,"inject:into:",0
,function(self,anObject,aBlock)
local result=nil
(function()
	local _s8_value=(anObject)
	result=_s8_value
	return _s8_value
end)();
(self):do_((function(each)
return ((function()
	local _s8_value=((aBlock):value_value_(result,each))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
,"enumerating","inject: anObject into: aBlock\r\n\t\" Evaluate aBlock for result of previous evaluation and contents of the receiver.\r\n\tOn first evaluation anObject is used as first argument to evaluate aBlock.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := anObject.\r\n\tself do: [:each | result := aBlock value: result value: each ].\r\n\t^result","function(self,anObject,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(each)\r\nreturn ((function()\r\n\tlocal _s8_value=((aBlock):value_value_(result,each))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Collection,"reject:",0
,function(self,aBlock)
return ((self):select_((function(each)
return (smalltalk:isObject_equalTo_(((aBlock):value_(each)),false))
end)));
end
,"enumerating","reject: aBlock\r\n\t\" Return the contents of the receiver wich evaluates aBlock to false. \"\r\n\r\n\t^self select: [:each | (aBlock value: each) = false]","function(self,aBlock)\r\nreturn ((self):select_((function(each)\r\nreturn (smalltalk:isObject_equalTo_(((aBlock):value_(each)),false))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Collection,"select:thenCollect:",0
,function(self,selectBlock,collectBlock)
return (((self):select_(selectBlock)):collect_(collectBlock));
end
,"enumerating","select: selectBlock thenCollect: collectBlock\r\n\t\" Return a new collection with the result of evaluating collectBlock on the contents of the receiver wich evaluates selectBlock to true. \"\r\n\r\n\t^(self select: selectBlock) collect: collectBlock","function(self,selectBlock,collectBlock)\r\nreturn (((self):select_(selectBlock)):collect_(collectBlock));\r\nend")

smalltalk:bind(smalltalk.Collection,"collect:thenSelect:",0
,function(self,collectBlock,selectBlock)
return (((self):collect_(collectBlock)):select_(selectBlock));
end
,"enumerating","collect: collectBlock thenSelect: selectBlock\r\n\t\" Return a new collection with the result of evaluating collectBlock on the contents of the receiver wich evaluates selectBlock to true. \"\r\n\r\n\t^(self collect: collectBlock) select: selectBlock","function(self,collectBlock,selectBlock)\r\nreturn (((self):collect_(collectBlock)):select_(selectBlock));\r\nend")

smalltalk:bind(smalltalk.Collection,"reversed",0
,function(self)
return ((self):subclassResponsibility_("reversed"));
end
,"copying","reversed\r\n\t\" Return an array with the contents of the receiver in reverse order. \"\r\n\r\n\t^self subclassResponsibility: #reversed","function(self)\r\nreturn ((self):subclassResponsibility_(\"reversed\"));\r\nend")

smalltalk:bind(smalltalk.Collection,"includes:",0
,function(self,anObject)
return ((self):subclassResponsibility_("includes:"));
end
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t^self subclassResponsibility: #includes:","function(self,anObject)\r\nreturn ((self):subclassResponsibility_(\"includes:\"));\r\nend")

smalltalk:bind(smalltalk.Collection,"notEmpty",0
,function(self)
return (smalltalk:booleanNot_(((self):isEmpty())));
end
,"testing","notEmpty\r\n\t\" Return true if the receiver is not empty. \"\r\n\r\n\t^self isEmpty not","function(self)\r\nreturn (smalltalk:booleanNot_(((self):isEmpty())));\r\nend")

smalltalk:bind(smalltalk.Collection,"isEmpty",0
,function(self)
return ((((self):size())==0));
end
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^self size == 0","function(self)\r\nreturn ((((self):size())==0));\r\nend")

smalltalk:bind(smalltalk.Collection,"remove:",0
,function(self,anObject)
return ((self):remove_ifAbsent_(anObject,(function()
return ((self):objectNotFound_(anObject))
end)));
end
,"removing","remove: anObject\r\n\t\" Remove anObject from receiver, return the removed object. \"\r\n\r\n\t^self remove: anObject ifAbsent: [ self objectNotFound: anObject ]","function(self,anObject)\r\nreturn ((self):remove_ifAbsent_(anObject,(function()\r\nreturn ((self):objectNotFound_(anObject))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Collection,"remove:ifAbsent:",0
,function(self,anObject,aBlock)
return ((self):subclassResponsibility_("remove:ifAbsent:"));
end
,"removing","remove: anObject ifAbsent: aBlock\r\n\t\" Remove anObject from receiver.\r\n\tReturn the removed object or the result of evaluating aBlock (if the object is not found).\r\n\t\"\r\n\r\n\t^self subclassResponsibility: #remove:ifAbsent:","function(self,anObject,aBlock)\r\nreturn ((self):subclassResponsibility_(\"remove:ifAbsent:\"));\r\nend")

smalltalk:bind(smalltalk.Collection,"removeAll:",0
,function(self,aCollection)
(aCollection):do_((function(each)
return ((self):remove_(each))
end));
return (aCollection);
end
,"removing","removeAll: aCollection\r\n\t\" Remove aCollection from receiver. \"\r\n\r\n\taCollection do: [:each| self remove: each ].\r\n\t^aCollection","function(self,aCollection)\r\n(aCollection):do_((function(each)\r\nreturn ((self):remove_(each))\r\nend));\r\nreturn (aCollection);\r\nend")

smalltalk:bind(smalltalk.Collection,"removeAll",0
,function(self)
(self):removeAll_((self):shallowCopy());
return (self);
end
,"removing","removeAll\r\n\t\" Remove all elements in the receiver. \"\r\n\r\n\tself removeAll: self shallowCopy","function(self)\r\n(self):removeAll_((self):shallowCopy());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Collection,"occurrencesOf:",0
,function(self,anObject)
return ((self):inject_into_(0,(function(total,each)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((each),anObject)),(function()
return ((total):_plus(1))
end),(function()
return (total)
end)))
end)));
end
,"counting","occurrencesOf: anObject\r\n\t\" Return the occurrences of anObject in the receiver. \"\r\n\r\n\t^self inject: 0 into: [:total :each|\r\n\t\teach = anObject ifTrue: [ total + 1 ] ifFalse: [total]\r\n\t]","function(self,anObject)\r\nreturn ((self):inject_into_(0,(function(total,each)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((each),anObject)),(function()\r\nreturn ((total):_plus(1))\r\nend),(function()\r\nreturn (total)\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Collection,"shallowCopy",0
,function(self)
return ((self):collect_((function(each)
return (each)
end)));
end
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self collect: [:each| each ]","function(self)\r\nreturn ((self):collect_((function(each)\r\nreturn (each)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Collection,"deepCopy",0
,function(self)
return ((self):collect_((function(each)
return ((each):deepCopy())
end)));
end
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self collect: [:each| each deepCopy ]","function(self)\r\nreturn ((self):collect_((function(each)\r\nreturn ((each):deepCopy())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Collection,"on:",0
,function(self,target)
local array=nil
(function()
	local _s8_value=((self):asArray())
	array=_s8_value
	return _s8_value
end)();
return ((1):to_by_value_((array):size(),1,(function(index,block)
return ((block):value_((target):at_ifAbsent_((array):at_(index),(function()
return (nil)
end))))
end)));
end
,"iterating","on: target\r\n\t\" Return an iterable on the target contents accessed by the receiver. \"\r\n\r\n\t| array |\r\n\tarray := self asArray.\r\n\t^1 to: array size by: 1 value: [:index :block|\r\n\t\tblock value: (target at: (array at: index) ifAbsent:[])\r\n\t]","function(self,target)\r\nlocal array=nil\r\n(function()\r\n\tlocal _s8_value=((self):asArray())\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((1):to_by_value_((array):size(),1,(function(index,block)\r\nreturn ((block):value_((target):at_ifAbsent_((array):at_(index),(function()\r\nreturn (nil)\r\nend))))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Collection["$klass"],"streamClass",0
,function(self)
return (smalltalk.Stream);
end
,"streams","streamClass\r\n\t\" Private - Return the support for streamming on the receiver's instances. \"\r\n\r\n\t^Stream","function(self)\r\nreturn (smalltalk.Stream);\r\nend")

smalltalk:bind(smalltalk.Collection["$klass"],"with:",0
,function(self,anObject)
return ((
function(_s8_rec)
	(_s8_rec):add_(anObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","with: anObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tadd: anObject;\r\n\t\tyourself","function(self,anObject)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(anObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.Collection["$klass"],"with:with:",0
,function(self,anObject,anotherObject)
return ((
function(_s8_rec)
	(_s8_rec):add_(anObject);
	(_s8_rec):add_(anotherObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","with: anObject with: anotherObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tadd: anObject;\r\n\t\tadd: anotherObject;\r\n\t\tyourself","function(self,anObject,anotherObject)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(anObject);\r\n\t(_s8_rec):add_(anotherObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.Collection["$klass"],"with:with:with:",0
,function(self,firstObject,secondObject,thirdObject)
return ((
function(_s8_rec)
	(_s8_rec):add_(firstObject);
	(_s8_rec):add_(secondObject);
	(_s8_rec):add_(thirdObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","with: firstObject with: secondObject with: thirdObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tadd: firstObject;\r\n\t\tadd: secondObject;\r\n\t\tadd: thirdObject;\r\n\t\tyourself","function(self,firstObject,secondObject,thirdObject)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(firstObject);\r\n\t(_s8_rec):add_(secondObject);\r\n\t(_s8_rec):add_(thirdObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.Collection["$klass"],"with:with:with:with:",0
,function(self,firstObject,secondObject,thirdObject,fourthObject)
return ((
function(_s8_rec)
	(_s8_rec):add_(firstObject);
	(_s8_rec):add_(secondObject);
	(_s8_rec):add_(thirdObject);
	(_s8_rec):add_(fourthObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","with: firstObject with: secondObject with: thirdObject with: fourthObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tadd: firstObject;\r\n\t\tadd: secondObject;\r\n\t\tadd: thirdObject;\r\n\t\tadd: fourthObject;\r\n\t\tyourself","function(self,firstObject,secondObject,thirdObject,fourthObject)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(firstObject);\r\n\t(_s8_rec):add_(secondObject);\r\n\t(_s8_rec):add_(thirdObject);\r\n\t(_s8_rec):add_(fourthObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.Collection["$klass"],"withAll:",0
,function(self,aCollection)
return ((
function(_s8_rec)
	(_s8_rec):addAll_(aCollection);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","withAll: aCollection\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\taddAll: aCollection;\r\n\t\tyourself","function(self,aCollection)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):addAll_(aCollection);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.Collection["$klass"],"basicNew:",0
,function(self,size)
return ((self):subclassResponsibility_("basicNew:"));
end
,"instantiation","basicNew: size\r\n\t\" Return an instance of the receiver of specified size. \"\r\n\r\n\t^self subclassResponsibility: #basicNew:","function(self,size)\r\nreturn ((self):subclassResponsibility_(\"basicNew:\"));\r\nend")

smalltalk:addClass("Interval",smalltalk.Collection,smalltalk:newArray({"start","end","step","value"}),"Kernel")

smalltalk:bind(smalltalk.Interval["$klass"],"from:to:by:value:",0
,function(self,start,__end,step,aBlock)
return (((self):basicNew()):initialize_to_by_value_(start,__end,step,aBlock));
end
,"instantiation","from: start to: end by: step value: aBlock\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew initialize: start to: end by: step value: aBlock","function(self,start,__end,step,aBlock)\r\nreturn (((self):basicNew()):initialize_to_by_value_(start,__end,step,aBlock));\r\nend")

smalltalk:bind(smalltalk.Interval,"initialize:to:by:value:",0
,function(self,from,to,increment,aBlock)
(function()
	local _s8_value=(from)
	self["@start"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(to)
	self["@end"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(increment)
	self["@step"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(aBlock)
	self["@value"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initialize: from to: to by: increment value: aBlock\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tstart := from.\r\n\tend := to.\r\n\tstep := increment.\r\n\tvalue := aBlock","function(self,from,to,increment,aBlock)\r\n(function()\r\n\tlocal _s8_value=(from)\r\n\tself[\"@start\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(to)\r\n\tself[\"@end\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(increment)\r\n\tself[\"@step\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(aBlock)\r\n\tself[\"@value\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Interval,"start",0
,function(self)
return (self["@start"]);
end
,"accessing","start\r\n\t\" Return the start of the receiver. \"\r\n\r\n\t^start ","function(self)\r\nreturn (self[\"@start\"]);\r\nend")

smalltalk:bind(smalltalk.Interval,"end","__end"
,function(self)
return (self["@end"]);
end
,"accessing","end\r\n\t\" Return the end of the receiver. \"\r\n\r\n\t^end ","function(self)\r\nreturn (self[\"@end\"]);\r\nend")

smalltalk:bind(smalltalk.Interval,"step",0
,function(self)
return (self["@step"]);
end
,"accessing","step\r\n\t\" Return the step of the receiver. \"\r\n\r\n\t^step ","function(self)\r\nreturn (self[\"@step\"]);\r\nend")

smalltalk:bind(smalltalk.Interval,"start:",0
,function(self,from)
(function()
	local _s8_value=(from)
	self["@start"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","start: from\r\n\t\" Set the start of the receiver. \"\r\n\r\n\tstart := from ","function(self,from)\r\n(function()\r\n\tlocal _s8_value=(from)\r\n\tself[\"@start\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Interval,"end:",0
,function(self,to)
(function()
	local _s8_value=(to)
	self["@end"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","end: to\r\n\t\" Set the end of the receiver. \"\r\n\r\n\tend := to ","function(self,to)\r\n(function()\r\n\tlocal _s8_value=(to)\r\n\tself[\"@end\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Interval,"step:",0
,function(self,increment)
(function()
	local _s8_value=(increment)
	self["@step"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","step: increment\r\n\t\" Set the step of the receiver. \"\r\n\r\n\tstep := increment ","function(self,increment)\r\n(function()\r\n\tlocal _s8_value=(increment)\r\n\tself[\"@step\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Interval,"species",0
,function(self)
return (smalltalk.Array);
end
,"species","species\r\n\t\" Return the species to instantiate objects like the receiver. \"\r\n\r\n\t^Array ","function(self)\r\nreturn (smalltalk.Array);\r\nend")

smalltalk:bind(smalltalk.Interval,"subclassResponsibility:",0
,function(self,aSelector)
return ((self):invalidMessage_(aSelector));
end
,"error","subclassResponsibility: aSelector\r\n\t\" Private - The concrete implementation on the receiver is not complete.\r\n\tNote: Unimplemented methods handle invalid messages sent to the receiver.\r\n\t\"\r\n\r\n\t^self invalidMessage: aSelector","function(self,aSelector)\r\nreturn ((self):invalidMessage_(aSelector));\r\nend")

smalltalk:bind(smalltalk.Interval,"size",0
,function(self)
return ((0):max_((((self["@end"]):_minus(self["@start"])):_slash_slash(self["@step"])):_plus(1)));
end
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^0 max: end - start // step + 1","function(self)\r\nreturn ((0):max_((((self[\"@end\"]):_minus(self[\"@start\"])):_slash_slash(self[\"@step\"])):_plus(1)));\r\nend")

smalltalk:bind(smalltalk.Interval,"consume:",0
,function(self,aBlock)
while not ((function()
return ((self):isEmpty())
end))() do (aBlock):value_(self["@start"]);
(function()
	local _s8_value=((self["@start"]):_plus(self["@step"]))
	self["@start"]=_s8_value
	return _s8_value
end)(); end;
return (self);
end
,"iterating","consume: aBlock\r\n\t\" Private - Evaluates aBlock while the receiver is not empty. \"\r\n\r\n\t[ self isEmpty ] whileFalse: [\r\n\t\taBlock value: start.\r\n\t\tstart := start + step\r\n\t] ","function(self,aBlock)\r\nwhile not ((function()\r\nreturn ((self):isEmpty())\r\nend))() do (aBlock):value_(self[\"@start\"]);\r\n(function()\r\n\tlocal _s8_value=((self[\"@start\"]):_plus(self[\"@step\"]))\r\n\tself[\"@start\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Interval,"atEnd",0
,function(self)
return (smalltalk:isObject_equalTo_(((self):size()),0));
end
,"testing","atEnd\r\n\t\" Return true if the receiver is at end. \"\r\n\r\n\t^self size = 0 ","function(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):size()),0));\r\nend")

smalltalk:bind(smalltalk.Interval,"isEmpty",0
,function(self)
return (smalltalk:isObject_equalTo_(((self):size()),0));
end
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^self size = 0 ","function(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):size()),0));\r\nend")

smalltalk:bind(smalltalk.Interval,"notEmpty",0
,function(self)
return (smalltalk:booleanNot_(((self):isEmpty())));
end
,"testing","notEmpty\r\n\t\" Return true if the receiver is not empty. \"\r\n\r\n\t^self isEmpty not","function(self)\r\nreturn (smalltalk:booleanNot_(((self):isEmpty())));\r\nend")

smalltalk:bind(smalltalk.Interval,"reversed",0
,function(self)
return (((self)["$klass"]):from_to_by_value_(self["@end"],self["@start"],(self["@step"]):negated(),self["@value"]));
end
,"copying","reversed\r\n\t\" Return an Interval with the contents of the receiver in reverse order. \"\r\n\r\n\t^self class from: end to: start by: step negated value: value ","function(self)\r\nreturn (((self)[\"$klass\"]):from_to_by_value_(self[\"@end\"],self[\"@start\"],(self[\"@step\"]):negated(),self[\"@value\"]));\r\nend")

smalltalk:bind(smalltalk.Interval,"reverseDo:",0
,function(self,aBlock)
return (((self):reversed()):do_(aBlock));
end
,"enumerating","reverseDo: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver in reverse order of iteration. \"\r\n\r\n\t^self reversed do: aBlock ","function(self,aBlock)\r\nreturn (((self):reversed()):do_(aBlock));\r\nend")

smalltalk:bind(smalltalk.Interval,"do:",0
,function(self,aBlock)
(self["@start"]):to_by_do_(self["@end"],self["@step"],(function(i)
return ((self["@value"]):value_value_(i,aBlock))
end));
return (self);
end
,"enumerating","do: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver. \"\r\n\r\n\tstart to: end by: step do: [:i|\r\n\t\tvalue value: i value: aBlock\r\n\t]","function(self,aBlock)\r\n(self[\"@start\"]):to_by_do_(self[\"@end\"],self[\"@step\"],(function(i)\r\nreturn ((self[\"@value\"]):value_value_(i,aBlock))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Interval,"+","_plus"
,function(self,aNumber)
return (((self["@start"]):_plus(aNumber)):to_by_value_((self["@end"]):_plus(aNumber),self["@step"],self["@value"]));
end
,"arithmetic","+ aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\t^start + aNumber to: end + aNumber by: step value: value","function(self,aNumber)\r\nreturn (((self[\"@start\"]):_plus(aNumber)):to_by_value_((self[\"@end\"]):_plus(aNumber),self[\"@step\"],self[\"@value\"]));\r\nend")

smalltalk:bind(smalltalk.Interval,"-","_minus"
,function(self,aNumber)
return (((self["@start"]):_minus(aNumber)):to_by_value_((self["@end"]):_minus(aNumber),self["@step"],self["@value"]));
end
,"arithmetic","- aNumber\r\n\t\" Return the result of operation. \"\r\n\r\n\t^start - aNumber to: end - aNumber by: step value: value","function(self,aNumber)\r\nreturn (((self[\"@start\"]):_minus(aNumber)):to_by_value_((self[\"@end\"]):_minus(aNumber),self[\"@step\"],self[\"@value\"]));\r\nend")

smalltalk:bind(smalltalk.Interval,"printString",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("("),self["@start"])),"to:")),self["@end"])),")"));
end
,"printing","printString\r\n\t\" Return the string representation of the receiver. \"\r\n\r\n\t^$( ,start ,#to: ,end ,$) ","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"(\"),self[\"@start\"])),\"to:\")),self[\"@end\"])),\")\"));\r\nend")

smalltalk:bind(smalltalk.Interval,"toString",0
,function(self)
if (smalltalk:boolean_or_((smalltalk:isNil_((self["@start"]))),(function()
return (smalltalk:isNil_((self["@end"])))
end)))==true then return (smalltalk:superImplementor(smalltalk.Interval,"toString")(self)); end;
return (smalltalk:printString_((self)));
end
,"converting","toString\r\n\t\" Return the receiver as a String. \"\r\n\r\n\t(start isNil or: [end isNil]) ifTrue: [ ^super toString ].\r\n\t^self printString ","function(self)\r\nif (smalltalk:boolean_or_((smalltalk:isNil_((self[\"@start\"]))),(function()\r\nreturn (smalltalk:isNil_((self[\"@end\"])))\r\nend)))==true then return (smalltalk:superImplementor(smalltalk.Interval,\"toString\")(self)); end;\r\nreturn (smalltalk:printString_((self)));\r\nend")

smalltalk:addClass("Set",smalltalk.Collection,smalltalk:newArray({"contents"}),"Kernel")

smalltalk:bind(smalltalk.Collection,"asSet",0
,function(self)
return ((smalltalk.Set):withAll_(self));
end
,"converting","asSet\r\n\t\" Return the receiver contents in a Set. \"\r\n\r\n\t^Set withAll: self","function(self)\r\nreturn ((smalltalk.Set):withAll_(self));\r\nend")

smalltalk:bind(smalltalk.Collection,"asHashedSet",0
,function(self)
return ((smalltalk.HashedSet):withAll_(self));
end
,"converting","asHashedSet\r\n\t\" Return the receiver contents in a HashedSet. \"\r\n\r\n\t^HashedSet withAll: self","function(self)\r\nreturn ((smalltalk.HashedSet):withAll_(self));\r\nend")

smalltalk:bind(smalltalk.Set["$klass"],"newContents:",0
,function(self,contents)
return (((self):basicNew()):initialize_(contents));
end
,"private","newContents: contents\r\n\t\" Return an instance of the receiver initialized from given contents. \"\r\n\r\n\t^self basicNew initialize: contents","function(self,contents)\r\nreturn (((self):basicNew()):initialize_(contents));\r\nend")

smalltalk:bind(smalltalk.Set["$klass"],"basicNew:",0
,function(self,size)
return ((self):new());
end
,"instantiation","basicNew: size\r\n\t\" Return an instance of the receiver of specified size. \"\r\n\r\n\t^self new","function(self,size)\r\nreturn ((self):new());\r\nend")

smalltalk:bind(smalltalk.Set,"initialize",0
,function(self)
smalltalk:superImplementor(smalltalk.Set,"initialize")(self);
(function()
	local _s8_value=(smalltalk:newArray({}))
	self["@contents"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initialize\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsuper initialize.\r\n\tcontents := #().","function(self)\r\nsmalltalk:superImplementor(smalltalk.Set,\"initialize\")(self);\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tself[\"@contents\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Set,"initialize:",0
,function(self,initializer)
(function()
	local _s8_value=(initializer)
	self["@contents"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initialize: initializer\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tcontents := initializer.","function(self,initializer)\r\n(function()\r\n\tlocal _s8_value=(initializer)\r\n\tself[\"@contents\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Set,"size",0
,function(self)
return ((self["@contents"]):size());
end
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^contents size","function(self)\r\nreturn ((self[\"@contents\"]):size());\r\nend")

smalltalk:bind(smalltalk.Set,"basicAdd:",0
,function(self,anObject)
(self["@contents"]):add_(anObject);
return (anObject);
end
,"private","basicAdd: anObject\r\n\t\" Private - Add anObject to the receiver's contents. \"\r\n\r\n\tcontents add: anObject.\r\n\t^anObject","function(self,anObject)\r\n(self[\"@contents\"]):add_(anObject);\r\nreturn (anObject);\r\nend")

smalltalk:bind(smalltalk.Set,"includes:",0
,function(self,anObject)
return ((self["@contents"]):includes_(anObject));
end
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t^contents includes: anObject","function(self,anObject)\r\nreturn ((self[\"@contents\"]):includes_(anObject));\r\nend")

smalltalk:bind(smalltalk.Set,"add:",0
,function(self,anObject)
if ((self):includes_(anObject))==true then return (anObject); end;
return ((self):basicAdd_(anObject));
end
,"adding","add: anObject\r\n\t\" Add anObject to the receiver. \"\r\n\r\n\t(self includes: anObject) ifTrue: [ ^anObject ].\r\n\t^self basicAdd: anObject","function(self,anObject)\r\nif ((self):includes_(anObject))==true then return (anObject); end;\r\nreturn ((self):basicAdd_(anObject));\r\nend")

smalltalk:bind(smalltalk.Set,"remove:ifAbsent:",0
,function(self,anObject,aBlock)
return ((self["@contents"]):remove_ifAbsent_(anObject,aBlock));
end
,"removing","remove: anObject ifAbsent: aBlock\r\n\t\" Remove anObject from the receiver.\r\n\tReturn the result of evaluating aBlock if anObject is not in the receiver.\r\n\t\"\r\n\r\n\t^contents remove: anObject ifAbsent: aBlock","function(self,anObject,aBlock)\r\nreturn ((self[\"@contents\"]):remove_ifAbsent_(anObject,aBlock));\r\nend")

smalltalk:bind(smalltalk.Set,"copyFrom:to:",0
,function(self,anIndex,anotherIndex)
return ((self):shouldNotImplement_("copyFrom:to:"));
end
,"copying","copyFrom: anIndex to: anotherIndex\r\n\t\" Return a copy of the receiver from anIndex to anotherIndex. \"\r\n\r\n\t^self shouldNotImplement: #copyFrom:to:","function(self,anIndex,anotherIndex)\r\nreturn ((self):shouldNotImplement_(\"copyFrom:to:\"));\r\nend")

smalltalk:bind(smalltalk.Set,"asNative:",0
,function(self,lang)
local send=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((lang),"lua")),(function()
return (":")
end),(function()
return (".")
end)))
	send=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),((self)["$klass"]):name())),send)),"newContents_(")),(self["@contents"]):asNative_(lang))),")"));
end
,"converting","asNative: lang\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t| send |\r\n\tsend := lang = #lua ifTrue: [ $: ] ifFalse: [ $. ].\r\n\t^'smalltalk.' ,self class name\r\n\t\t,send ,'newContents_('\r\n\t\t,(contents asNative: lang)\r\n\t\t,')'","function(self,lang)\r\nlocal send=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((lang),\"lua\")),(function()\r\nreturn (\":\")\r\nend),(function()\r\nreturn (\".\")\r\nend)))\r\n\tsend=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),((self)[\"$klass\"]):name())),send)),\"newContents_(\")),(self[\"@contents\"]):asNative_(lang))),\")\"));\r\nend")

smalltalk:bind(smalltalk.Set,"=","_eq"
,function(self,aSet)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if not ((smalltalk:isObject_equalTo_(((self)["$klass"]),(aSet)["$klass"])))==true then return (false); end;
if not ((smalltalk:isObject_equalTo_(((self):size()),(aSet):size())))==true then return (false); end;
(self):do_((function(each)
return (smalltalk:if_true_false_(((aSet):includes_(each)),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"comparing","= aSet\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\tself class = aSet class ifFalse: [^false].\r\n\tself size = aSet size ifFalse: [^false].\r\n\tself do: [:each | (aSet includes: each) ifFalse: [^false] ].\r\n\t^true","function(self,aSet)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif not ((smalltalk:isObject_equalTo_(((self)[\"$klass\"]),(aSet)[\"$klass\"])))==true then return (false); end;\r\nif not ((smalltalk:isObject_equalTo_(((self):size()),(aSet):size())))==true then return (false); end;\r\n(self):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((aSet):includes_(each)),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Set,"asArray",0
,function(self)
return ((self["@contents"]):copy());
end
,"converting","asArray\r\n\t\" Return an array with the contents of the receiver. \"\r\n\r\n\t^contents copy","function(self)\r\nreturn ((self[\"@contents\"]):copy());\r\nend")

smalltalk:bind(smalltalk.Set,"toString",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((((self)["$klass"]):name())," withAll: ")),smalltalk:printString_(((self):asArray()))));
end
,"converting","toString\r\n\t\" Convert the receiver to a String. \"\r\n\r\n\t^self class name,' withAll: ',self asArray printString","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((((self)[\"$klass\"]):name()),\" withAll: \")),smalltalk:printString_(((self):asArray()))));\r\nend")

smalltalk:bind(smalltalk.Set,"sorted",0
,function(self)
return (((self):asArray()):sort());
end
,"sorting","sorted\r\n\t\" Return the contents of the receiver sorted. \"\r\n\r\n\t^self asArray sort","function(self)\r\nreturn (((self):asArray()):sort());\r\nend")

smalltalk:bind(smalltalk.Set,"sorted:",0
,function(self,aBlock)
return (((self):asArray()):sort_(aBlock));
end
,"sorting","sorted: aBlock\r\n\t\" Return a sorted copy of the receiver. \"\r\n\r\n\t^self asArray sort: aBlock","function(self,aBlock)\r\nreturn (((self):asArray()):sort_(aBlock));\r\nend")

smalltalk:bind(smalltalk.Set,"do:",0
,function(self,aBlock)
return ((self["@contents"]):do_(aBlock));
end
,"enumerating","do: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver. \"\r\n\r\n\t^contents do: aBlock","function(self,aBlock)\r\nreturn ((self[\"@contents\"]):do_(aBlock));\r\nend")

smalltalk:bind(smalltalk.Set,"detect:ifNone:",0
,function(self,aBlock,anotherBlock)
return ((self["@contents"]):detect_ifNone_(aBlock,anotherBlock));
end
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. \"\r\n\r\n\t^contents detect: aBlock ifNone: anotherBlock","function(self,aBlock,anotherBlock)\r\nreturn ((self[\"@contents\"]):detect_ifNone_(aBlock,anotherBlock));\r\nend")

smalltalk:bind(smalltalk.Set,"reverseDo:",0
,function(self,aBlock)
return ((self["@contents"]):reverseDo_(aBlock));
end
,"enumerating","reverseDo: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver in reverse order of iteration. \"\r\n\r\n\t^contents reverseDo: aBlock","function(self,aBlock)\r\nreturn ((self[\"@contents\"]):reverseDo_(aBlock));\r\nend")

smalltalk:bind(smalltalk.Set,"collect:",0
,function(self,aBlock)
return (((self)["$klass"]):withAll_((self["@contents"]):collect_(aBlock)));
end
,"enumerating","collect: aBlock\r\n\t\" Return a collection with the result of evaluating aBlock with the contents of the receiver. \"\r\n\r\n\t^self class withAll: (contents collect: aBlock)","function(self,aBlock)\r\nreturn (((self)[\"$klass\"]):withAll_((self[\"@contents\"]):collect_(aBlock)));\r\nend")

smalltalk:bind(smalltalk.Set,"do:separatedBy:",0
,function(self,aBlock,anotherBlock)
return ((self["@contents"]):do_separatedBy_(aBlock,anotherBlock));
end
,"enumerating","do: aBlock separatedBy: anotherBlock\r\n\t\" Evaluate aBlock for contents of the receiver evaluating anotherBlock inbetween aBlock evaluations. \"\r\n\r\n\t^contents do: aBlock separatedBy: anotherBlock","function(self,aBlock,anotherBlock)\r\nreturn ((self[\"@contents\"]):do_separatedBy_(aBlock,anotherBlock));\r\nend")

smalltalk:bind(smalltalk.Set,"inject:into:",0
,function(self,anObject,aBlock)
return ((self["@contents"]):inject_into_(anObject,aBlock));
end
,"enumerating","inject: anObject into: aBlock\r\n\t\" Evaluate aBlock for result of previous evaluation and contents of the receiver.\r\n\tOn first evaluation anObject is used as first argument to evaluate aBlock.\r\n\t\"\r\n\r\n\t^contents inject: anObject into: aBlock","function(self,anObject,aBlock)\r\nreturn ((self[\"@contents\"]):inject_into_(anObject,aBlock));\r\nend")

smalltalk:bind(smalltalk.Set,"select:",0
,function(self,aBlock)
return (((self)["$klass"]):withAll_((self["@contents"]):select_(aBlock)));
end
,"enumerating","select: aBlock\r\n\t\" Return a copy of the receiver with elements wich evaluates aBlock to true. \"\r\n\r\n\t^self class withAll: (contents select: aBlock)","function(self,aBlock)\r\nreturn (((self)[\"$klass\"]):withAll_((self[\"@contents\"]):select_(aBlock)));\r\nend")

smalltalk:bind(smalltalk.Set,"reject:",0
,function(self,aBlock)
return (((self)["$klass"]):withAll_((self["@contents"]):reject_(aBlock)));
end
,"enumerating","reject: aBlock\r\n\t\" Return the contents of the receiver wich evaluates aBlock to false. \"\r\n\r\n\t^self class withAll: (contents reject: aBlock)","function(self,aBlock)\r\nreturn (((self)[\"$klass\"]):withAll_((self[\"@contents\"]):reject_(aBlock)));\r\nend")

smalltalk:bind(smalltalk.Set,"reversed",0
,function(self)
return ((self["@contents"]):reversed());
end
,"copying","reversed\r\n\t\" Return an array with the contents of the receiver in reverse order. \"\r\n\r\n\t^contents reversed","function(self)\r\nreturn ((self[\"@contents\"]):reversed());\r\nend")

smalltalk:bind(smalltalk.Set,"notEmpty",0
,function(self)
return ((self["@contents"]):notEmpty());
end
,"testing","notEmpty\r\n\t\" Return true if the receiver is not empty. \"\r\n\r\n\t^contents notEmpty","function(self)\r\nreturn ((self[\"@contents\"]):notEmpty());\r\nend")

smalltalk:bind(smalltalk.Set,"isEmpty",0
,function(self)
return ((self["@contents"]):isEmpty());
end
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^contents isEmpty","function(self)\r\nreturn ((self[\"@contents\"]):isEmpty());\r\nend")

smalltalk:bind(smalltalk.Set,"occurrencesOf:",0
,function(self,anObject)
return (smalltalk:if_true_false_(((self):includes_(anObject)),(function()
return (1)
end),(function()
return (0)
end)));
end
,"counting","occurrencesOf: anObject\r\n\t\" Return the occurrences of anObject in the receiver. \"\r\n\r\n\t^(self includes: anObject) ifTrue: [ 1 ] ifFalse: [ 0 ]","function(self,anObject)\r\nreturn (smalltalk:if_true_false_(((self):includes_(anObject)),(function()\r\nreturn (1)\r\nend),(function()\r\nreturn (0)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Set,"asSet",0
,function(self)
return (self);
end
,"converting","asSet\r\n\t\" Return the receiver contents in a Set. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Set,"shallowCopy",0
,function(self)
return (((self):species()):newContents_((self["@contents"]):copy()));
end
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self species newContents: contents copy","function(self)\r\nreturn (((self):species()):newContents_((self[\"@contents\"]):copy()));\r\nend")

smalltalk:bind(smalltalk.Set,"deepCopy",0
,function(self)
return (((self):species()):newContents_((self["@contents"]):deepCopy()));
end
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self species newContents: contents deepCopy","function(self)\r\nreturn (((self):species()):newContents_((self[\"@contents\"]):deepCopy()));\r\nend")

smalltalk:addClass("HashedSet",smalltalk.Set,smalltalk:newArray({"hash"}),"Kernel")

smalltalk:bind(smalltalk.HashedSet,"initialize",0
,function(self)
smalltalk:superImplementor(smalltalk.HashedSet,"initialize")(self);
(self):initializeHash();
return (self);
end
,"initialize","initialize\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsuper initialize.\r\n\tself initializeHash.","function(self)\r\nsmalltalk:superImplementor(smalltalk.HashedSet,\"initialize\")(self);\r\n(self):initializeHash();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.HashedSet,"initialize:",0
,function(self,initializer)
(function()
	local _s8_value=(initializer)
	self["@contents"]=_s8_value
	return _s8_value
end)();
(self):rehash();
return (self);
end
,"initialize","initialize: initializer\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tcontents := initializer.\r\n\tself rehash.","function(self,initializer)\r\n(function()\r\n\tlocal _s8_value=(initializer)\r\n\tself[\"@contents\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):rehash();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.HashedSet,"initializeHash",0
,function(self)
(function()
	local _s8_value=({})
	self["@hash"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"private","initializeHash\r\n\t\" Private - Initialize the hash of the receiver. \"\r\n\r\n\thash := {'' doc'get native sentinel'}.","function(self)\r\n(function()\r\n\tlocal _s8_value=({})\r\n\tself[\"@hash\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.HashedSet,"rehash",0
,function(self)
(self):initializeHash();
(self["@contents"]):do_((function(each)
return ((self):privateAdd_((self):wrap_(each)))
end));
return (self);
end
,"private","rehash\r\n\t\" Private - Rehash the receiver contents. \"\r\n\r\n\tself initializeHash.\r\n\tcontents do: [:each|\r\n\t\tself privateAdd: (self wrap: each)\r\n\t]","function(self)\r\n(self):initializeHash();\r\n(self[\"@contents\"]):do_((function(each)\r\nreturn ((self):privateAdd_((self):wrap_(each)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.HashedSet,"asHashedSet",0
,function(self)
return (self);
end
,"converting","asHashedSet\r\n\t\" Return the receiver contents in a HashedSet. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.HashedSet,"indexOf:ifAbsent:",0
,function(self,anObject,aBlock)
if not (((self):includes_(anObject)))==true then return ((aBlock):value()); end;
return ((self["@contents"]):indexOf_ifAbsent_(anObject,aBlock));
end
,"private","indexOf: anObject ifAbsent: aBlock\r\n\t\" Return the position of anObject in the receiver, or the result of evaluating aBlock. \"\r\n\r\n\t(self includes: anObject) ifFalse: [ ^aBlock value ].\r\n\t^contents indexOf: anObject ifAbsent: aBlock","function(self,anObject,aBlock)\r\nif not (((self):includes_(anObject)))==true then return ((aBlock):value()); end;\r\nreturn ((self[\"@contents\"]):indexOf_ifAbsent_(anObject,aBlock));\r\nend")

smalltalk:bind(smalltalk.HashedSet,"withIndexDo:",0
,function(self,aBlock)
return ((self["@contents"]):withIndexDo_(aBlock));
end
,"private","withIndexDo: aBlock\r\n\t\" Evaluate aBlock with all the index positions in the receiver. \"\r\n\r\n\t^contents withIndexDo: aBlock","function(self,aBlock)\r\nreturn ((self[\"@contents\"]):withIndexDo_(aBlock));\r\nend")

smalltalk:bind(smalltalk.HashedSet,"removeIndex:",0
,function(self,index)
return ((self):remove_((self["@contents"]):at_(index)));
end
,"private","removeIndex: index\r\n\t\" Remove the element at index. \"\r\n\r\n\t^self remove: (contents at: index)","function(self,index)\r\nreturn ((self):remove_((self[\"@contents\"]):at_(index)));\r\nend")

smalltalk:bind(smalltalk.HashedSet,"privateAdd:",0
,function(self,cookie)

smalltalk:basic_at_put_((self["@hash"]),cookie,cookie);
return (self);
end
,"private","privateAdd: cookie\r\n\t\" Private - Register a cookie onto the receiver's hash. \"\r\n\r\n\t{'self'}.\r\n\thash basicAt: cookie put: cookie","function(self,cookie)\r\n\r\nsmalltalk:basic_at_put_((self[\"@hash\"]),cookie,cookie);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.HashedSet,"privateRemove:",0
,function(self,cookie)
self["@hash"][cookie] = nil;
return (self);
end
,"private","privateRemove: cookie\r\n\t\" Private - Remove a cookie in the receiver's hash. \"\r\n\r\n\t{'' doc'native remotion'}","function(self,cookie)\r\nself[\"@hash\"][cookie] = nil;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.HashedSet,"includes:",0
,function(self,anObject)
local cookie=nil
(function()
	local _s8_value=((self):wrap_(anObject))
	cookie=_s8_value
	return _s8_value
end)();
return ((self["@hash"][cookie])~=nil);
end
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t| cookie |\r\n\tcookie := self wrap: anObject.\r\n\t^{'' doc'testing'}","function(self,anObject)\r\nlocal cookie=nil\r\n(function()\r\n\tlocal _s8_value=((self):wrap_(anObject))\r\n\tcookie=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self[\"@hash\"][cookie])~=nil);\r\nend")

smalltalk:bind(smalltalk.HashedSet,"add:",0
,function(self,anObject)
if ((self):includes_(anObject))==true then return (anObject); end;
(self):privateAdd_((self):wrap_(anObject));
return ((self):basicAdd_(anObject));
end
,"adding","add: anObject\r\n\t\" Add anObject to the receiver. \"\r\n\r\n\t(self includes: anObject) ifTrue: [ ^anObject ].\r\n\tself privateAdd: (self wrap: anObject).\r\n\t^self basicAdd: anObject","function(self,anObject)\r\nif ((self):includes_(anObject))==true then return (anObject); end;\r\n(self):privateAdd_((self):wrap_(anObject));\r\nreturn ((self):basicAdd_(anObject));\r\nend")

smalltalk:bind(smalltalk.HashedSet,"remove:ifAbsent:",0
,function(self,anObject,aBlock)
if not (((self):includes_(anObject)))==true then return ((aBlock):value()); end;
(self["@contents"]):remove_ifAbsent_(anObject,(function()
return (nil)
end));
(self):privateRemove_((self):wrap_(anObject));
return (anObject);
end
,"removing","remove: anObject ifAbsent: aBlock\r\n\t\" Remove anObject from the receiver.\r\n\tReturn the result of evaluating aBlock if anObject is not in the receiver.\r\n\t\"\r\n\r\n\t(self includes: anObject) ifFalse: [ ^aBlock value ].\r\n\tcontents remove: anObject ifAbsent: [ ].\r\n\tself privateRemove: (self wrap: anObject).\r\n\t^anObject","function(self,anObject,aBlock)\r\nif not (((self):includes_(anObject)))==true then return ((aBlock):value()); end;\r\n(self[\"@contents\"]):remove_ifAbsent_(anObject,(function()\r\nreturn (nil)\r\nend));\r\n(self):privateRemove_((self):wrap_(anObject));\r\nreturn (anObject);\r\nend")

smalltalk:addClass("SequenceableCollection",smalltalk.Collection,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.SequenceableCollection,"at:",0
,function(self,anIndex)
return ((self):at_ifAbsent_(anIndex,(function()
return ((self):objectNotFoundAt_(anIndex))
end)));
end
,"accessing","at: anIndex\r\n\t\" Return the object in the receiver at anIndex position. \"\r\n\r\n\t^self at: anIndex ifAbsent: [ self objectNotFoundAt: anIndex ]","function(self,anIndex)\r\nreturn ((self):at_ifAbsent_(anIndex,(function()\r\nreturn ((self):objectNotFoundAt_(anIndex))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"at:ifAbsent:",0
,function(self,anIndex,aBlock)
return ((self):subclassResponsibility_("at:ifAbsent:"));
end
,"accessing","at: anIndex ifAbsent: aBlock\r\n\t\" Return the object in the receiver at anIndex position or the result of evaluating aBlock. \"\r\n\r\n\t^self subclassResponsibility: #at:ifAbsent:","function(self,anIndex,aBlock)\r\nreturn ((self):subclassResponsibility_(\"at:ifAbsent:\"));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"at:put:",0
,function(self,anIndex,anObject)
return ((self):subclassResponsibility_("at:put:"));
end
,"accessing","at: anIndex put: anObject\r\n\t\" Set the object in the receiver at anIndex position. \"\r\n\r\n\t^self subclassResponsibility: #at:put:","function(self,anIndex,anObject)\r\nreturn ((self):subclassResponsibility_(\"at:put:\"));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"at:ifAbsentPut:",0
,function(self,aKey,aBlock)
return ((self):at_ifAbsent_(aKey,(function()
return ((self):at_put_(aKey,(aBlock):value()))
end)));
end
,"accessing","at: aKey ifAbsentPut: aBlock\r\n\t\" Return the value at aKey, or add the result of evaluating aBlock to the receiver if it is absent. \"\r\n\r\n\t^self at: aKey ifAbsent: [ self at: aKey put: aBlock value ]","function(self,aKey,aBlock)\r\nreturn ((self):at_ifAbsent_(aKey,(function()\r\nreturn ((self):at_put_(aKey,(aBlock):value()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"copyFrom:to:",0
,function(self,anIndex,anotherIndex)
return ((self):subclassResponsibility_("copyFrom:to:"));
end
,"copying","copyFrom: anIndex to: anotherIndex\r\n\t\" Return a copy of the receiver. \"\r\n\r\n\t^self subclassResponsibility: #copyFrom:to:","function(self,anIndex,anotherIndex)\r\nreturn ((self):subclassResponsibility_(\"copyFrom:to:\"));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"indexOf:",0
,function(self,anObject)
return ((self):indexOf_ifAbsent_(anObject,(function()
return (0)
end)));
end
,"testing","indexOf: anObject\r\n\t\" Return the position of anObject in the receiver, or 0. \"\r\n\r\n\t^self indexOf: anObject ifAbsent: [ 0 ]","function(self,anObject)\r\nreturn ((self):indexOf_ifAbsent_(anObject,(function()\r\nreturn (0)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"indexOf:ifAbsent:",0
,function(self,anObject,aBlock)

	for i,value in ipairs(self) do
		if (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then return i end
	end
	if true then return aBlock:value() end;
return (self);
end
,"testing","indexOf: anObject ifAbsent: aBlock\r\n\t\" Return the position of anObject in the receiver, or the result of evaluating aBlock. \"\r\n\r\n\t{'' doc'detection'}","function(self,anObject,aBlock)\r\n\r\n\tfor i,value in ipairs(self) do\r\n\t\tif (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then return i end\r\n\tend\r\n\tif true then return aBlock:value() end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"do:",0
,function(self,aBlock)
return ((self):implementedBySubclass_("do:"));
end
,"enumerating","do: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver. \"\r\n\r\n\t^self implementedBySubclass: #do: ","function(self,aBlock)\r\nreturn ((self):implementedBySubclass_(\"do:\"));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"detect:ifNone:",0
,function(self,aBlock,anotherBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();

	for _,value in ipairs(self) do
		local v=self:unwrap_(value)
		if (fn(v)) then return v end
	end
	if true then return anotherBlock:value() end;
return (self);
end
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'\tself do: [:each|\r\n\t\t(aBlock value: each) ifTrue: [ ^each ]\r\n\t].\r\n\t^anotherBlock value'\r\n\tdoc'detection'}","function(self,aBlock,anotherBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\n\tfor _,value in ipairs(self) do\r\n\t\tlocal v=self:unwrap_(value)\r\n\t\tif (fn(v)) then return v end\r\n\tend\r\n\tif true then return anotherBlock:value() end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"reversed",0
,function(self)

	local result = smalltalk.Array:new()
	local top = #self + 1
	for i,v in ipairs(self) do result[top - i] = v end
	if true then return result end;
return (self);
end
,"copying","reversed\r\n\t\" Return an array with the contents of the receiver in reverse order. \"\r\n\r\n\t{'' doc'converting'}","function(self)\r\n\r\n\tlocal result = smalltalk.Array:new()\r\n\tlocal top = #self + 1\r\n\tfor i,v in ipairs(self) do result[top - i] = v end\r\n\tif true then return result end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"isEmpty",0
,function(self)
return (#self==0);
end
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty.\r\n\tNote: ^self size = 0 is slower than inlined impl.\r\n\t\"\r\n\r\n\t^{'' doc'testing'}","function(self)\r\nreturn (#self==0);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"reverseDo:",0
,function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
for i = #self,1,-1 do fn(self:unwrap_(self[i])) end;
return (self);
end
,"enumerating","reverseDo: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver in reverse order of iteration. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'\tself size to: 1 by: -1 do: [:i|\r\n\t\taBlock value: (self at: i)\r\n\t]' doc'(reversed) iteration'}","function(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nfor i = #self,1,-1 do fn(self:unwrap_(self[i])) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"includes:",0
,function(self,anObject)

	for _,value in ipairs(self) do
		if (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then return true end
	end
	if true then return false end;
if not (((self):isObject_(anObject)))==true then return ((((self):indexOf(anObject)) > -1)); end;
if true then end;
return (self);
end
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t{'self'}.\r\n\t(self isObject: anObject) ifFalse: [ ^(self #indexOf: anObject) > -1 ].\r\n\t{'' doc'native detection'}","function(self,anObject)\r\n\r\n\tfor _,value in ipairs(self) do\r\n\t\tif (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then return true end\r\n\tend\r\n\tif true then return false end;\r\nif not (((self):isObject_(anObject)))==true then return ((((self):indexOf(anObject)) > -1)); end;\r\nif true then end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"occurrencesOf:",0
,function(self,anObject)

	local count = 0
	for _,value in ipairs(self) do
		if (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then count = count + 1 end
	end
	if true then return count end;
return (self);
end
,"counting","occurrencesOf: anObject\r\n\t\" Return the occurrences of anObject in the receiver. \"\r\n\r\n\t{'' doc'native counting'}","function(self,anObject)\r\n\r\n\tlocal count = 0\r\n\tfor _,value in ipairs(self) do\r\n\t\tif (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then count = count + 1 end\r\n\tend\r\n\tif true then return count end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"first",0
,function(self)
return ((self):at_(1));
end
,"accessing","first\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t^self at: 1","function(self)\r\nreturn ((self):at_(1));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"fourth",0
,function(self)
return ((self):at_(4));
end
,"accessing","fourth\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t^self at: 4","function(self)\r\nreturn ((self):at_(4));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"last",0
,function(self)
return ((self):at_((self):size()));
end
,"accessing","last\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t^self at: self size","function(self)\r\nreturn ((self):at_((self):size()));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"second",0
,function(self)
return ((self):at_(2));
end
,"accessing","second\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t^self at: 2","function(self)\r\nreturn ((self):at_(2));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"third",0
,function(self)
return ((self):at_(3));
end
,"accessing","third\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t^self at: 3","function(self)\r\nreturn ((self):at_(3));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"removeLast",0
,function(self)
return ((self):remove_((self):last()));
end
,"removing","removeLast\r\n\t\" Remove the last object in the receiver. \"\r\n\r\n\t^self remove: self last","function(self)\r\nreturn ((self):remove_((self):last()));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"removeFirst",0
,function(self)
return ((self):remove_((self):first()));
end
,"removing","removeFirst\r\n\t\" Remove the first object in the receiver. \"\r\n\r\n\t^self remove: self first","function(self)\r\nreturn ((self):remove_((self):first()));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"addLast:",0
,function(self,anObject)
return ((self):add_(anObject));
end
,"adding","addLast: anObject\r\n\t\" Add anObject to the receiver (at end). \"\r\n\r\n\t^self add: anObject","function(self,anObject)\r\nreturn ((self):add_(anObject));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"atAll:put:",0
,function(self,indices,anObject)
(indices):do_((function(index)
return ((self):at_put_(index,anObject))
end));
return (self);
end
,"accessing","atAll: indices put: anObject\r\n\t\" Return the receiver after replacing those elements, indexed by the indices, with anObject. \"\r\n\r\n\tindices do: [ :index | self at: index put: anObject ]","function(self,indices,anObject)\r\n(indices):do_((function(index)\r\nreturn ((self):at_put_(index,anObject))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"atAllPut:",0
,function(self,anObject)
((1):to_((self):size())):do_((function(index)
return ((self):at_put_(index,anObject))
end));
return (self);
end
,"accessing","atAllPut: anObject\r\n\t\" Replace all elements of the receiver with anObject. \"\r\n\r\n\t(1 to: self size) do: [ :index | self at: index put: anObject ]","function(self,anObject)\r\n((1):to_((self):size())):do_((function(index)\r\nreturn ((self):at_put_(index,anObject))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"withIndexDo:",0
,function(self,aBlock)
((1):to_((self):size())):do_((function(index)
return ((aBlock):value_value_((self):at_(index),index))
end));
return (self);
end
,"enumerating","withIndexDo: aBlock\r\n\t\" Evaluate aBlock with all the index positions in the receiver. \"\r\n\r\n\t(1 to: self size) do: [ :index |\r\n\t\taBlock value: (self at: index) value: index\r\n\t]","function(self,aBlock)\r\n((1):to_((self):size())):do_((function(index)\r\nreturn ((aBlock):value_value_((self):at_(index),index))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"=","_eq"
,function(self,aCollection)
local index=nil
if (((self)==aCollection))==true then return (true); end;
if not (((((self)["$klass"])==(aCollection)["$klass"])))==true then return (false); end;
(function()
	local _s8_value=((self):size())
	index=_s8_value
	return _s8_value
end)();
if ((not smalltalk:isObject_equalTo_((index),(aCollection):size())))==true then return (false); end;
while not ((function()
return (((index) <= 0))
end))() do if not ((smalltalk:isObject_equalTo_(((self):at_(index)),(aCollection):at_(index))))==true then return (false); end;
(function()
	local _s8_value=((index):_minus(1))
	index=_s8_value
	return _s8_value
end)(); end;
return (true);
end
,"testing","= aCollection\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\t| index |\r\n\tself == aCollection ifTrue: [ ^true ].\r\n\tself class == aCollection class ifFalse: [ ^false ].\r\n\tindex := self size.\r\n\tindex ~= aCollection size ifTrue: [ ^false ].\r\n\t[ index <= 0 ] whileFalse: [\r\n\t\t(self at: index) = (aCollection at: index) ifFalse: [ ^false ].\r\n\t\tindex := index - 1\r\n\t].\r\n\t^true","function(self,aCollection)\r\nlocal index=nil\r\nif (((self)==aCollection))==true then return (true); end;\r\nif not (((((self)[\"$klass\"])==(aCollection)[\"$klass\"])))==true then return (false); end;\r\n(function()\r\n\tlocal _s8_value=((self):size())\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((not smalltalk:isObject_equalTo_((index),(aCollection):size())))==true then return (false); end;\r\nwhile not ((function()\r\nreturn (((index) <= 0))\r\nend))() do if not ((smalltalk:isObject_equalTo_(((self):at_(index)),(aCollection):at_(index))))==true then return (false); end;\r\n(function()\r\n\tlocal _s8_value=((index):_minus(1))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"beginsWith:",0
,function(self,aCollection)
if ((((self):size()) < (aCollection):size()))==true then return (false); end;
if (smalltalk:isObject_equalTo_(((self):size()),(aCollection):size()))==true then return (smalltalk:isObject_equalTo_((aCollection),self)); end;
return (smalltalk:isObject_equalTo_((aCollection),(self):copyFrom_to_(1,(aCollection):size())));
end
,"testing","beginsWith: aCollection\r\n\t\" Return true if the receiver begins with aCollection. \"\r\n\r\n\tself size < aCollection size ifTrue: [ ^false ].\r\n\tself size = aCollection size ifTrue: [ ^aCollection = self ].\r\n\t^aCollection = (self copyFrom: 1 to: aCollection size)","function(self,aCollection)\r\nif ((((self):size()) < (aCollection):size()))==true then return (false); end;\r\nif (smalltalk:isObject_equalTo_(((self):size()),(aCollection):size()))==true then return (smalltalk:isObject_equalTo_((aCollection),self)); end;\r\nreturn (smalltalk:isObject_equalTo_((aCollection),(self):copyFrom_to_(1,(aCollection):size())));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"endsWith:",0
,function(self,aCollection)
if ((((self):size()) < (aCollection):size()))==true then return (false); end;
if (smalltalk:isObject_equalTo_(((self):size()),(aCollection):size()))==true then return (smalltalk:isObject_equalTo_((aCollection),self)); end;
return (smalltalk:isObject_equalTo_((aCollection),(self):copyFrom_to_((((self):size()):_minus((aCollection):size())):_plus(1),(self):size())));
end
,"testing","endsWith: aCollection\r\n\t\" Return true if the receiver ends with aCollection. \"\r\n\r\n\tself size < aCollection size ifTrue: [ ^false ].\r\n\tself size = aCollection size ifTrue: [ ^aCollection = self ].\r\n\t^aCollection = (self copyFrom: self size - aCollection size + 1 to: self size)","function(self,aCollection)\r\nif ((((self):size()) < (aCollection):size()))==true then return (false); end;\r\nif (smalltalk:isObject_equalTo_(((self):size()),(aCollection):size()))==true then return (smalltalk:isObject_equalTo_((aCollection),self)); end;\r\nreturn (smalltalk:isObject_equalTo_((aCollection),(self):copyFrom_to_((((self):size()):_minus((aCollection):size())):_plus(1),(self):size())));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"copyReplaceFrom:to:with:",0
,function(self,start,stop,aCollection)
return (smalltalk:object_comma_((smalltalk:object_comma_(((self):copyFrom_to_(1,(start):_minus(1))),aCollection)),(self):copyFrom_to_((stop):_plus(1),(self):size())));
end
,"copying","copyReplaceFrom: start to: stop with: aCollection\r\n\t\" Return a collection containing a copy of the receiver with the elements at index positions from start through stop replaced with the elements of aCollection. \"\r\n\r\n\t^(self copyFrom: 1 to: start - 1)\r\n\t\t, aCollection\r\n\t\t, (self copyFrom: stop + 1 to: self size)","function(self,start,stop,aCollection)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_(((self):copyFrom_to_(1,(start):_minus(1))),aCollection)),(self):copyFrom_to_((stop):_plus(1),(self):size())));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"copyWithout:",0
,function(self,anObject)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local index=nil
(function()
	local _s8_value=((self):indexOf_ifAbsent_(anObject,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):copy())
end
)()
error(_s8Ret_,0)
end)())
end)))
	index=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_(((self):copyFrom_to_(1,(index):_minus(1))),((self):copyFrom_to_((index):_plus(1),(self):size())):copyWithout_(anObject)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"copying","copyWithout: anObject\r\n\t\" Return a copy of the receiver excluding anObject, if any. \"\r\n\r\n\t| index |\r\n\tindex := self indexOf: anObject ifAbsent: [ ^self copy ].\r\n\t^(self copyFrom: 1 to: index - 1)\r\n\t\t,((self copyFrom: index + 1 to: self size)\r\n\t\t\tcopyWithout: anObject)","function(self,anObject)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):indexOf_ifAbsent_(anObject,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):copy())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_(((self):copyFrom_to_(1,(index):_minus(1))),((self):copyFrom_to_((index):_plus(1),(self):size())):copyWithout_(anObject)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"copyWithAll:",0
,function(self,aCollection)
return (smalltalk:object_comma_((self),aCollection));
end
,"copying","copyWithAll: aCollection\r\n\t\" Return a copy of the receiver with all contents of aCollection. \"\r\n\r\n\t^self , aCollection ","function(self,aCollection)\r\nreturn (smalltalk:object_comma_((self),aCollection));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"findFirst:",0
,function(self,aBlock)
return ((self):findFirst_ifAbsent_(aBlock,(function()
return ((self):errorAbsentObject())
end)));
end
,"searching","findFirst: aBlock\r\n\t\" Return the index of the first element of the receiver that causes aBlock to evaluate to true.\r\n         If no such element is found, report an error.\r\n\t\"\r\n\r\n\t^self findFirst: aBlock ifAbsent: [ self errorAbsentObject ]","function(self,aBlock)\r\nreturn ((self):findFirst_ifAbsent_(aBlock,(function()\r\nreturn ((self):errorAbsentObject())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"findFirst:ifAbsent:",0
,function(self,aBlock,absentBlock)
local index=nil
local size=nil
(function()
	local _s8_value=((self):size())
	size=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(1)
	index=_s8_value
	return _s8_value
end)();
while ((function()
return (((index) <= size))
end))() do if ((aBlock):value_((self):at_(index)))==true then return (index); end;
(function()
	local _s8_value=((index):_plus(1))
	index=_s8_value
	return _s8_value
end)(); end;
return ((absentBlock):value());
end
,"searching","findFirst: aBlock ifAbsent: absentBlock\r\n\t\" Return the index of the first element of the receiver that causes aBlock to evaluate to true.\r\n\tIf no such element is found, return the result of evaluating the argument block.\r\n\t\"\r\n\r\n\t| index size |\r\n\tsize := self size.\r\n\tindex := 1.\r\n\t[ index <= size ] whileTrue: [\r\n\t\t(aBlock value: (self at: index)) ifTrue: [ ^index ].\r\n\t\tindex := index + 1\r\n\t].\r\n\t^absentBlock value","function(self,aBlock,absentBlock)\r\nlocal index=nil\r\nlocal size=nil\r\n(function()\r\n\tlocal _s8_value=((self):size())\r\n\tsize=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(1)\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (((index) <= size))\r\nend))() do if ((aBlock):value_((self):at_(index)))==true then return (index); end;\r\n(function()\r\n\tlocal _s8_value=((index):_plus(1))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((absentBlock):value());\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"findLast:",0
,function(self,aBlock)
return ((self):findLast_ifAbsent_(aBlock,(function()
return ((self):errorAbsentObject())
end)));
end
,"searching","findLast: aBlock\r\n\t\" Return the index of the last element of the receiver that causes aBlock to evaluate to true.\r\n\tIf no such element is found, report an error.\r\n\t\"\r\n\r\n\t^self findLast: aBlock ifAbsent: [ self errorAbsentObject ]","function(self,aBlock)\r\nreturn ((self):findLast_ifAbsent_(aBlock,(function()\r\nreturn ((self):errorAbsentObject())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"findLast:ifAbsent:",0
,function(self,aBlock,absentBlock)
local index=nil
(function()
	local _s8_value=((self):size())
	index=_s8_value
	return _s8_value
end)();
while ((function()
return (((index) > 0))
end))() do if ((aBlock):value_((self):at_(index)))==true then return (index); end;
(function()
	local _s8_value=((index):_minus(1))
	index=_s8_value
	return _s8_value
end)(); end;
return ((absentBlock):value());
end
,"searching","findLast: aBlock ifAbsent: absentBlock\r\n\t\" Return the index of the last element of the receiver that causes aBlock to evaluate to true.\r\n\tIf no such element is found, return the result of evaluating the argument block.\r\n\t\"\r\n\r\n\t| index |\r\n\tindex := self size.\r\n\t[ index > 0 ] whileTrue: [\r\n\t\t(aBlock value: (self at: index)) ifTrue: [ ^index ].\r\n\t\tindex := index - 1\r\n\t].\r\n\t^absentBlock value","function(self,aBlock,absentBlock)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):size())\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (((index) > 0))\r\nend))() do if ((aBlock):value_((self):at_(index)))==true then return (index); end;\r\n(function()\r\n\tlocal _s8_value=((index):_minus(1))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((absentBlock):value());\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"replaceFrom:to:with:",0
,function(self,start,stop,aCollection)
if not ((smalltalk:isObject_equalTo_((((stop):_minus(start)):_plus(1)),(aCollection):size())))==true then return ((self):error_("Replacement has wrong size")); end;
(self):replaceFrom_to_with_startingAt_(start,stop,aCollection,1);
return (self);
end
,"replace","replaceFrom: start to: stop with: aCollection\r\n\t\" Return the receiver.\r\n\tReplace the elements of the receiver at index positions start through stop, with the elements of aCollection. \"\r\n\r\n\tstop - start + 1 = aCollection size ifFalse: [\r\n\t\t^self error: 'Replacement has wrong size'\r\n\t].\r\n\tself\r\n\t\treplaceFrom: start\r\n\t\tto: stop\r\n\t\twith: aCollection\r\n\t\tstartingAt: 1","function(self,start,stop,aCollection)\r\nif not ((smalltalk:isObject_equalTo_((((stop):_minus(start)):_plus(1)),(aCollection):size())))==true then return ((self):error_(\"Replacement has wrong size\")); end;\r\n(self):replaceFrom_to_with_startingAt_(start,stop,aCollection,1);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"replaceFrom:to:with:startingAt:",0
,function(self,start,stop,aCollection,repStart)
local index1=nil
local index2=nil
if (smalltalk:boolean_and_((((self)==aCollection)),(function()
return (((repStart) < start))
end)))==true then (function()
	local _s8_value=(((repStart):_plus(stop)):_minus(start))
	index2=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(stop)
	index1=_s8_value
	return _s8_value
end)();
while ((function()
return (((start) <= index1))
end))() do (self):at_put_(index1,(aCollection):at_(index2));
(function()
	local _s8_value=((index1):_minus(1))
	index1=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((index2):_minus(1))
	index2=_s8_value
	return _s8_value
end)(); end;
return (self); end;
(function()
	local _s8_value=(repStart)
	index2=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(start)
	index1=_s8_value
	return _s8_value
end)();
while ((function()
return (((index1) <= stop))
end))() do (self):at_put_(index1,(aCollection):at_(index2));
(function()
	local _s8_value=((index1):_plus(1))
	index1=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((index2):_plus(1))
	index2=_s8_value
	return _s8_value
end)(); end;
return (self);
end
,"replace","replaceFrom: start\r\n    to: stop\r\n    with: aCollection\r\n    startingAt: repStart\r\n\t\" Return the receiver.\r\n\tReplace the elements of the receiver at index positions start through stop with consecutive\r\n         elements of aCollection beginning at index position repStart.\r\n\t\"\r\n\r\n\t| index1 index2 |\r\n\t(self == aCollection and: [ repStart < start ]) ifTrue: [ \"do backward move for same object\"\r\n\t\tindex2 := repStart + stop - start.\r\n\t\tindex1 := stop.\r\n\t\t[ start <= index1 ] whileTrue: [\r\n\t\t\tself at: index1 put: (aCollection at: index2).\r\n\t\t\tindex1 := index1 - 1.\r\n\t\t\tindex2 := index2 - 1\r\n\t\t].\r\n\t\t^self\r\n\t].\r\n\tindex2 := repStart.\r\n\tindex1 := start.\r\n\t[ index1 <= stop ] whileTrue: [\r\n\t\tself at: index1 put: (aCollection at: index2).\r\n\t\tindex1 := index1 + 1.\r\n\t\tindex2 := index2 + 1\r\n\t]","function(self,start,stop,aCollection,repStart)\r\nlocal index1=nil\r\nlocal index2=nil\r\nif (smalltalk:boolean_and_((((self)==aCollection)),(function()\r\nreturn (((repStart) < start))\r\nend)))==true then (function()\r\n\tlocal _s8_value=(((repStart):_plus(stop)):_minus(start))\r\n\tindex2=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(stop)\r\n\tindex1=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (((start) <= index1))\r\nend))() do (self):at_put_(index1,(aCollection):at_(index2));\r\n(function()\r\n\tlocal _s8_value=((index1):_minus(1))\r\n\tindex1=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((index2):_minus(1))\r\n\tindex2=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self); end;\r\n(function()\r\n\tlocal _s8_value=(repStart)\r\n\tindex2=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(start)\r\n\tindex1=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (((index1) <= stop))\r\nend))() do (self):at_put_(index1,(aCollection):at_(index2));\r\n(function()\r\n\tlocal _s8_value=((index1):_plus(1))\r\n\tindex1=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((index2):_plus(1))\r\n\tindex2=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"replaceFrom:to:with:startingWith:",0
,function(self,start,stop,replacement,replacementStart)
return ((self):replaceFrom_to_with_startingAt_(start,stop,replacement,replacementStart));
end
,"replace","replaceFrom: start\r\n    to: stop\r\n    with: replacement\r\n    startingWith: replacementStart\r\n\t\" Replace the elements of the receiver. \"\r\n\r\n\t^self\r\n\t\treplaceFrom: start\r\n\t\tto: stop\r\n\t\twith: replacement\r\n\t\tstartingAt: replacementStart","function(self,start,stop,replacement,replacementStart)\r\nreturn ((self):replaceFrom_to_with_startingAt_(start,stop,replacement,replacementStart));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"replaceFrom:to:withObject:",0
,function(self,start,stop,anObject)
local index=nil
(function()
	local _s8_value=(start)
	index=_s8_value
	return _s8_value
end)();
while ((function()
return (((index) <= stop))
end))() do (self):at_put_(index,anObject);
(function()
	local _s8_value=((index):_plus(1))
	index=_s8_value
	return _s8_value
end)(); end;
return (anObject);
end
,"replace","replaceFrom: start to: stop withObject: anObject\r\n\t\"Replace each of the elements of the receiver at index positions start through stop with anObject. \"\r\n\r\n\t| index |\r\n\tindex := start.\r\n\t[ index <= stop ] whileTrue: [\r\n\t\tself at: index put: anObject.\r\n\t\tindex := index + 1\r\n\t].\r\n\t^anObject","function(self,start,stop,anObject)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=(start)\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (((index) <= stop))\r\nend))() do (self):at_put_(index,anObject);\r\n(function()\r\n\tlocal _s8_value=((index):_plus(1))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (anObject);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"with:do:",0
,function(self,aCollection,aBlock)
local first=nil
local second=nil
(function()
	local _s8_value=((self):stream())
	first=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aCollection):stream())
	second=_s8_value
	return _s8_value
end)();
while not ((function()
return (smalltalk:boolean_or_(((first):atEnd()),(function()
return ((second):atEnd())
end)))
end))() do (aBlock):value_value_((first):next(),(second):next()); end;
return (self);
end
,"iterating","with: aCollection do: aBlock\r\n\t\" For each pair of elements evaluate aBlock with those elements as the arguments. \"\r\n\r\n\t| first second |\r\n\tfirst\t:= self stream.\r\n\tsecond\t:= aCollection stream.\r\n\t[ first atEnd or: [ second atEnd ] ] whileFalse: [\r\n\t\taBlock value: first next value: second next\r\n\t].","function(self,aCollection,aBlock)\r\nlocal first=nil\r\nlocal second=nil\r\n(function()\r\n\tlocal _s8_value=((self):stream())\r\n\tfirst=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aCollection):stream())\r\n\tsecond=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn (smalltalk:boolean_or_(((first):atEnd()),(function()\r\nreturn ((second):atEnd())\r\nend)))\r\nend))() do (aBlock):value_value_((first):next(),(second):next()); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"sort",0
,function(self)
(self):sort_(nil);
return (self);
end
,"sorting","sort\r\n\t\" Sort (inplace) the receiver's contents with default criteria. \"\r\n\r\n\tself sort: nil","function(self)\r\n(self):sort_(nil);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"sort:",0
,function(self,aBlock)
(self):implementedBySubclass_("sort:");
return (self);
end
,"sorting","sort: aBlock\r\n\t\" Sort (inplace) the receiver's contents with aBlock. \"\r\n\r\n\tself implementedBySubclass: #sort:","function(self,aBlock)\r\n(self):implementedBySubclass_(\"sort:\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"from:to:by:",0
,function(self,start,__end,increment)
return ((start):to_by_value_(__end,increment,(function(index,block)
return ((block):value_((self):at_(index)))
end)));
end
,"iterating","from: start to: end by: increment\r\n\t\" Return an iterable on the receiver's contents from start to end. \"\r\n\r\n\t^start to: end by: increment value: [:index :block|\r\n\t\tblock value: (self at: index)\r\n\t]","function(self,start,__end,increment)\r\nreturn ((start):to_by_value_(__end,increment,(function(index,block)\r\nreturn ((block):value_((self):at_(index)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"from:to:",0
,function(self,start,__end)
return ((self):from_to_by_(start,__end,smalltalk:if_true_false_((((start) <= __end)),(function()
return (1)
end),(function()
return (-1)
end))));
end
,"iterating","from: start to: end\r\n\t\" Return an iterable on the receiver's contents from start to end. \"\r\n\r\n\t^self\tfrom: start to: end\r\n\t\tby: (start <= end ifTrue: [1] ifFalse: [-1]) ","function(self,start,__end)\r\nreturn ((self):from_to_by_(start,__end,smalltalk:if_true_false_((((start) <= __end)),(function()\r\nreturn (1)\r\nend),(function()\r\nreturn (-1)\r\nend))));\r\nend")

smalltalk:addClass("String",smalltalk.SequenceableCollection,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.String["$klass"],"fromString:",0
,function(self,aString)
if true then tostring(aString) end;
return (self);
end
,"instantiation","fromString: aString\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'instatiation'}","function(self,aString)\r\nif true then tostring(aString) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"new",0
,function(self)
return ("");
end
,"instantiation","new\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^{'' doc'instantiation'}","function(self)\r\nreturn (\"\");\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"cr",0
,function(self)
return ("\r");
end
,"constants","cr\r\n\t\" Return the singular instance. \"\r\n\r\n\t^{'' doc'native constant'}","function(self)\r\nreturn (\"\\r\");\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"lf",0
,function(self)
return ("\n");
end
,"constants","lf\r\n\t\" Return the singular instance. \"\r\n\r\n\t^{'' doc'native constant'}","function(self)\r\nreturn (\"\\n\");\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"crlf",0
,function(self)
return ("\r\n");
end
,"constants","crlf\r\n\t\" Return the singular instance. \"\r\n\r\n\t^{'' doc'native constant'}","function(self)\r\nreturn (\"\\r\\n\");\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"space",0
,function(self)
return (" ");
end
,"constants","space\r\n\t\" Return the singular instance. \"\r\n\r\n\t^{'' doc'native constant'}","function(self)\r\nreturn (\" \");\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"tab",0
,function(self)
return ("\t");
end
,"constants","tab\r\n\t\" Return the singular instance. \"\r\n\r\n\t^{'' doc'native constant'}","function(self)\r\nreturn (\"\\t\");\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"zero",0
,function(self)
return (string.char(0));
end
,"constants","zero\r\n\t\" Return the singular instance. \"\r\n\r\n\t^{'' doc'native constant'}","function(self)\r\nreturn (string.char(0));\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"with:",0
,function(self,aCharacter)
return (aCharacter);
end
,"instantiation","with: aCharacter\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^aCharacter","function(self,aCharacter)\r\nreturn (aCharacter);\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"with:with:",0
,function(self,aCharacter,bCharacter)
return (smalltalk:object_comma_((aCharacter),bCharacter));
end
,"instantiation","with: aCharacter with: bCharacter\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^aCharacter , bCharacter","function(self,aCharacter,bCharacter)\r\nreturn (smalltalk:object_comma_((aCharacter),bCharacter));\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"with:with:with:",0
,function(self,aCharacter,bCharacter,cCharacter)
return (smalltalk:object_comma_((smalltalk:object_comma_((aCharacter),bCharacter)),cCharacter));
end
,"instantiation","with: aCharacter with: bCharacter with: cCharacter\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^aCharacter , bCharacter , cCharacter","function(self,aCharacter,bCharacter,cCharacter)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((aCharacter),bCharacter)),cCharacter));\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"with:with:with:with:",0
,function(self,aCharacter,bCharacter,cCharacter,dCharacter)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((aCharacter),bCharacter)),cCharacter)),dCharacter));
end
,"instantiation","with: aCharacter with: bCharacter\r\n\twith: cCharacter with: dCharacter\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^aCharacter , bCharacter , cCharacter , dCharacter","function(self,aCharacter,bCharacter,cCharacter,dCharacter)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((aCharacter),bCharacter)),cCharacter)),dCharacter));\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"fromCharCode:",0
,function(self,anArrayOrNumber)

	if (type(anArrayOrNumber)=="number") then
		return string.char(anArrayOrNumber)
	end
	if true then
		local fup = table.unpack or unpack
		return (string.char(fup(anArrayOrNumber)))
	end;
return (self);
end
,"instantiation","fromCharCode: anArrayOrNumber\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native conversion'}","function(self,anArrayOrNumber)\r\n\r\n\tif (type(anArrayOrNumber)==\"number\") then\r\n\t\treturn string.char(anArrayOrNumber)\r\n\tend\r\n\tif true then\r\n\t\tlocal fup = table.unpack or unpack\r\n\t\treturn (string.char(fup(anArrayOrNumber)))\r\n\tend;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"doItSelector",0
,function(self)
return ("s8DoIt");
end
,"constants","doItSelector\r\n\t\" Return the selector to use for doIt evaluations.\r\n\tWarning: this selector will not be dump on image nor change log expressions.\r\n\t\"\r\n\r\n\t^#s8DoIt","function(self)\r\nreturn (\"s8DoIt\");\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"nativeFileExtension",0
,function(self)
return (smalltalk:toString_(((self):nativeLanguage())));
end
,"fileNames","nativeFileExtension\r\n\t\" Return the file extension to use for files with native code. \"\r\n\r\n\t^self nativeLanguage toString","function(self)\r\nreturn (smalltalk:toString_(((self):nativeLanguage())));\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"sourceFileExtension",0
,function(self)
return ("st");
end
,"fileNames","sourceFileExtension\r\n\t\" Return the file extension to use for source files. \"\r\n\r\n\t^#st ","function(self)\r\nreturn (\"st\");\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"nativeLibraryExtension",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(((self):sourceFileExtension()),".")),(self):nativeFileExtension()));
end
,"fileNames","nativeLibraryExtension\r\n\t\" Return the file extension to use for native library files. \"\r\n\r\n\t^self sourceFileExtension ,$. ,self nativeFileExtension ","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_(((self):sourceFileExtension()),\".\")),(self):nativeFileExtension()));\r\nend")

smalltalk:bind(smalltalk.String,"=","_eq"
,function(self,anObject)
if true then return self==anObject end;
return (self);
end
,"comparing","= anObject\r\n    \" Return true if the receiver is equal to argument. \"\r\n\r\n\t{'' doc'native testing'}","function(self,anObject)\r\nif true then return self==anObject end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"size",0
,function(self)
return (#self);
end
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^{'' doc'native string size'}","function(self)\r\nreturn (#self);\r\nend")

smalltalk:bind(smalltalk.String,"at:",0
,function(self,anIndex)
return (self:sub(anIndex,anIndex));
end
,"accessing","at: anIndex\r\n\t\" Return the receiver at anIndex. \"\r\n\r\n\t^{'' doc'native indexing'}","function(self,anIndex)\r\nreturn (self:sub(anIndex,anIndex));\r\nend")

smalltalk:bind(smalltalk.String,"at:put:",0
,function(self,anIndex,anObject)
return ((self):errorReadOnly_("at:put:"));
end
,"accessing","at: anIndex put: anObject\r\n\t\" Set the receiver at anIndex. \"\r\n\r\n\t^self errorReadOnly: #at:put:","function(self,anIndex,anObject)\r\nreturn ((self):errorReadOnly_(\"at:put:\"));\r\nend")

smalltalk:bind(smalltalk.String,"at:ifAbsent:",0
,function(self,anIndex,aBlock)
return (smalltalk:if_nil_notNil_(((self):at_(anIndex)),aBlock,nil));
end
,"accessing","at: anIndex ifAbsent: aBlock\r\n\t\" Return the receiver at anIndex position or the result of evaluating aBlock. \"\r\n\r\n\t^(self at: anIndex) ifNil: aBlock","function(self,anIndex,aBlock)\r\nreturn (smalltalk:if_nil_notNil_(((self):at_(anIndex)),aBlock,nil));\r\nend")

smalltalk:bind(smalltalk.String,"do:",0
,function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
for c in self:gmatch(".") do fn(c) end;
return (self);
end
,"enumerating","do: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'\t1 to: self size do: [:i|\r\n\t\taBlock value: (self at: i)\r\n\t]' doc'native iteration'}","function(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nfor c in self:gmatch(\".\") do fn(c) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"detect:ifNone:",0
,function(self,aBlock,anotherBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();

	for c in self:gmatch(".") do
		if (fn(c)) then return c end
	end
	if true then return anotherBlock:value() end;
return (self);
end
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'\tself do: [:each|\r\n\t\t(aBlock value: each) ifTrue: [ ^each ]\r\n\t].\r\n\t^anotherBlock value' doc'native detection'}","function(self,aBlock,anotherBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (fn(c)) then return c end\r\n\tend\r\n\tif true then return anotherBlock:value() end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"includes:",0
,function(self,anObject)
local ignored;
return ((((self):indexOf_(anObject)) > 0));
end
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t{'self'}.\r\n\t^(self indexOf: anObject) > 0","function(self,anObject)\r\nlocal ignored;\r\nreturn ((((self):indexOf_(anObject)) > 0));\r\nend")

smalltalk:bind(smalltalk.String,"withIndexDo:",0
,function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
for i=1,#self do fn(self:sub(i,i),i) end;
return (self);
end
,"enumerating","withIndexDo: aBlock\r\n\t\" Evaluate aBlock with all the index positions in the receiver. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'\t1 to: self size do: [:i|\r\n\t\taBlock value: (self at: i) value: i\r\n\t]' doc'native iteration'}","function(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nfor i=1,#self do fn(self:sub(i,i),i) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"copyWithout:",0
,function(self,anObject)
return ((self):replace_with_(anObject,""));
end
,"copying","copyWithout: anObject\r\n\t\" Return a copy of the receiver excluding anObject, if any. \"\r\n\r\n\t^self replace: anObject with: ''","function(self,anObject)\r\nreturn ((self):replace_with_(anObject,\"\"));\r\nend")

smalltalk:bind(smalltalk.String,"asSymbol",0
,function(self)
return (self);
end
,"conversion","asSymbol\r\n\t\" Return a symbol with the same characters as the receiver. \"\r\n\r\n\t^self \"we do not discriminate singular strings\"","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"binarySelectorChars",0
,function(self)
return ("|&+/=><,@~!*-%\\?\\\\");
end
,"constants","binarySelectorChars\r\n\t\" Private - Return the characters that can be included in binary selectors. \"\r\n\r\n\t^'|&+/=><,@~!*-%\\?\\\\' ","function(self)\r\nreturn (\"|&+/=><,@~!*-%\\\\?\\\\\\\\\");\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"isBinarySelector:",0
,function(self,aString)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local chars=nil
(function()
	local _s8_value=((self):binarySelectorChars())
	chars=_s8_value
	return _s8_value
end)();
(aString):do_((function(c)
return (smalltalk:if_true_false_(((chars):includes_(c)),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"private","isBinarySelector: aString\r\n\t\" Private - Return true if aString is a binary selector. \"\r\n\r\n\t| chars |\r\n\tchars := self binarySelectorChars.\r\n\taString do: [:c| (chars includes: c) ifFalse: [ ^false ] ].\r\n\t^true ","function(self,aString)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal chars=nil\r\n(function()\r\n\tlocal _s8_value=((self):binarySelectorChars())\r\n\tchars=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aString):do_((function(c)\r\nreturn (smalltalk:if_true_false_(((chars):includes_(c)),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"isKeywordSelector:",0
,function(self,aString)
(function() self:invalidMessage_("isKeywordSelector:") end)();
return (smalltalk:isNil_((((smalltalk.RegularExpression):fromString_("[^a-zA-Z0-9_:]")):exec_(aString))));
end
,"private","isKeywordSelector: aString\r\n\t\" Private - Return true if aString is a keyword selector. \"\r\n\r\n\t{'' js'self' doc'native testing'}.\r\n\t^((RegularExpression fromString: '[^a-zA-Z0-9_:]') exec: aString) isNil ","function(self,aString)\r\n(function() self:invalidMessage_(\"isKeywordSelector:\") end)();\r\nreturn (smalltalk:isNil_((((smalltalk.RegularExpression):fromString_(\"[^a-zA-Z0-9_:]\")):exec_(aString))));\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"isMessageSelector:",0
,function(self,aString)
return (smalltalk:boolean_or_(((self):isKeywordSelector_(aString)),(function()
return ((self):isBinarySelector_(aString))
end)));
end
,"private","isMessageSelector: aString\r\n\t\" Private - Return true if aString is a message selector. \"\r\n\r\n\t^(self isKeywordSelector: aString)\r\n\tor: [ self isBinarySelector: aString ] ","function(self,aString)\r\nreturn (smalltalk:boolean_or_(((self):isKeywordSelector_(aString)),(function()\r\nreturn ((self):isBinarySelector_(aString))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.String,"argumentCount",0
,function(self)
if ((self):isEmpty())==true then return (0); end;
if ((((self)["$klass"]):binarySelectorChars()):includes_((self):first()))==true then return (1); end;
return ((self):occurrencesOf_(":"));
end
,"evaluating","argumentCount\r\n\t\" Return the number of arguments of the receiver. \"\r\n\r\n\tself isEmpty ifTrue: [ ^0 ].\r\n\t(self class binarySelectorChars includes: self first) ifTrue: [ ^1 ].\r\n\t^self occurrencesOf: $:","function(self)\r\nif ((self):isEmpty())==true then return (0); end;\r\nif ((((self)[\"$klass\"]):binarySelectorChars()):includes_((self):first()))==true then return (1); end;\r\nreturn ((self):occurrencesOf_(\":\"));\r\nend")

smalltalk:bind(smalltalk.String,"isLiteral",0
,function(self)

	if #self==0 then return false end
	if smalltalk.String:isBinarySelector_(self) then return true end
	if true then return string.find(self,"[^a-zA-Z0-9_:]+")==nil end;
return (smalltalk:boolean_and_(((self):notEmpty()),(function()
return (((self)["$klass"]):isMessageSelector_(self))
end)));
end
,"testing","isLiteral\r\n\t\" Return true if the receiver can be output using literal notation. \"\r\n\r\n\t{'' js'self' doc'native testing'}.\r\n\t^self notEmpty and: [ self class isMessageSelector: self ]","function(self)\r\n\r\n\tif #self==0 then return false end\r\n\tif smalltalk.String:isBinarySelector_(self) then return true end\r\n\tif true then return string.find(self,\"[^a-zA-Z0-9_:]+\")==nil end;\r\nreturn (smalltalk:boolean_and_(((self):notEmpty()),(function()\r\nreturn (((self)[\"$klass\"]):isMessageSelector_(self))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.String,"asLiteral",0
,function(self)
return (smalltalk:if_true_false_(((self):isLiteral()),(function()
return (smalltalk:object_comma_(("#"),self))
end),(function()
return (smalltalk:printString_((self)))
end)));
end
,"converting","asLiteral\r\n\t\" Return the receiver in literal notation. \"\r\n\r\n\t^self isLiteral ifTrue: [ $# ,self ] ifFalse: [ self printString ]","function(self)\r\nreturn (smalltalk:if_true_false_(((self):isLiteral()),(function()\r\nreturn (smalltalk:object_comma_((\"#\"),self))\r\nend),(function()\r\nreturn (smalltalk:printString_((self)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"asLiteral",0
,function(self)
return (smalltalk:printString_((self)));
end
,"converting","asLiteral\r\n\t\" Return the receiver in literal notation. \"\r\n\r\n\t^self printString","function(self)\r\nreturn (smalltalk:printString_((self)));\r\nend")

smalltalk:bind(smalltalk.String,"occurrencesOf:",0
,function(self,aString)
local result=nil
local index=nil

	local j
	local k,count = 0,0
	repeat	j, k = self:find(aString, k + 1, true)
		if (j~=nil) then count=count+1 end
	until j == nil
	if true then return count end;
if not (((aString):isString()))==true then (function()
	local _s8_value=((self):match(aString))
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((result)))==true then return (0); end;
return (result["length"]); end;
if (smalltalk:isObject_equalTo_(((aString):size()),1))==true then (function()
	local _s8_value=((self):match((smalltalk.RegularExpression):fromString_flag_(smalltalk:object_comma_((smalltalk:object_comma_(("["),aString)),"]"),"g")))
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((result)))==true then return (0); end;
return (result["length"]); end;
(function()
	local _s8_value=(0)
	result=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(0)
	index=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((self):indexOf_startingAt_(aString,(index):_plus(1)))
	index=_s8_value
	return _s8_value
end)();return (((index) > 1))
end))() do (function()
	local _s8_value=((result):_plus(1))
	result=_s8_value
	return _s8_value
end)(); end;
return (result);
end
,"testing","occurrencesOf: aString\r\n\t\" Return the times aString can be found in the receiver. \"\r\n\r\n\t| result index |\r\n\t{'' doc'native counting'}.\r\n\taString isString ifFalse: [\r\n\t\tresult := self #match: aString.\r\n\t\tresult isNil ifTrue: [ ^0 ].\r\n\t\t^result#length\r\n\t].\r\n\taString size = 1 ifTrue: [\r\n\t\tresult := self #match: (RegularExpression\r\n\t\t\t\tfromString: '[',aString,']'\r\n\t\t\t\tflag: 'g').\r\n\t\tresult isNil ifTrue: [ ^0 ].\r\n\t\t^result#length\r\n\t].\r\n\tresult := 0. index := 0.\r\n\t[\tindex := self indexOf: aString startingAt: index + 1.\r\n\t\tindex > 1 ] whileTrue: [ result := result + 1 ].\r\n\t^result","function(self,aString)\r\nlocal result=nil\r\nlocal index=nil\r\n\r\n\tlocal j\r\n\tlocal k,count = 0,0\r\n\trepeat\tj, k = self:find(aString, k + 1, true)\r\n\t\tif (j~=nil) then count=count+1 end\r\n\tuntil j == nil\r\n\tif true then return count end;\r\nif not (((aString):isString()))==true then (function()\r\n\tlocal _s8_value=((self):match(aString))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((result)))==true then return (0); end;\r\nreturn (result[\"length\"]); end;\r\nif (smalltalk:isObject_equalTo_(((aString):size()),1))==true then (function()\r\n\tlocal _s8_value=((self):match((smalltalk.RegularExpression):fromString_flag_(smalltalk:object_comma_((smalltalk:object_comma_((\"[\"),aString)),\"]\"),\"g\")))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((result)))==true then return (0); end;\r\nreturn (result[\"length\"]); end;\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((self):indexOf_startingAt_(aString,(index):_plus(1)))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();return (((index) > 1))\r\nend))() do (function()\r\n\tlocal _s8_value=((result):_plus(1))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.String,"startsWith:",0
,function(self,aString)
if true then return (self:sub(1, #aString) == aString) end;
return ((self):beginsWith_(aString));
end
,"testing","startsWith: aString\r\n\t\" Return true if the receiver begins with the characters of aString. \"\r\n\r\n\t{'' doc'native testing'}.\r\n\t^self beginsWith: aString","function(self,aString)\r\nif true then return (self:sub(1, #aString) == aString) end;\r\nreturn ((self):beginsWith_(aString));\r\nend")

smalltalk:bind(smalltalk.String,"escaped",0
,function(self)
self:notImplementedYet_("escaped");
return (self);
end
,"converting","escaped\r\n\t\" Return the receiver with escape codes. \"\r\n\r\n\t{'' doc'native conversion'}","function(self)\r\nself:notImplementedYet_(\"escaped\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"unescaped",0
,function(self)

	local x16 = function(x) return string.char(tonumber(x, 16)) end
	if true then return self:gsub("%%(%x%x)", x16) end;
return (self);
end
,"converting","unescaped\r\n\t\" Return the receiver from encoded URI escape codes. \"\r\n\r\n\t{'' doc'native conversion'}","function(self)\r\n\r\n\tlocal x16 = function(x) return string.char(tonumber(x, 16)) end\r\n\tif true then return self:gsub(\"%%(%x%x)\", x16) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"escapedCode",0
,function(self)
local escaped=nil
(function()
	local _s8_value=((self):escaped())
	escaped=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((escaped),self))==true then return (smalltalk:object_comma_((smalltalk:object_comma_(("\""),escaped)),"\"")); end;
return (smalltalk:object_comma_((smalltalk:object_comma_(("unescape(\""),escaped)),"\")"));
end
,"converting","escapedCode\r\n\t\" Return the code to reproduce receiver from code. \"\r\n\r\n\t| escaped |\r\n\tescaped := self escaped.\r\n\tescaped = self ifTrue: [ ^$\" ,escaped ,$\" ].\r\n\t^'unescape(\"' ,escaped ,'\")'","function(self)\r\nlocal escaped=nil\r\n(function()\r\n\tlocal _s8_value=((self):escaped())\r\n\tescaped=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((escaped),self))==true then return (smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),escaped)),\"\\\"\")); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"unescape(\\\"\"),escaped)),\"\\\")\"));\r\nend")

smalltalk:bind(smalltalk.String,"asEncodedURI",0
,function(self)
self:notImplementedYet_("asEncodedURI");
return (self);
end
,"converting","asEncodedURI\r\n\t\" Return the receiver encoded as an URI component.\r\n\tEncodes special characters and it encodes the following characters: , / ? : @ & = + $ #\r\n\t\"\r\n\r\n\t{'' doc'native conversion'}","function(self)\r\nself:notImplementedYet_(\"asEncodedURI\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"asDecodedURI",0
,function(self)
self:notImplementedYet_("asDecodedURI");
return (self);
end
,"converting","asDecodedURI\r\n\t\" Return the receiver decoded as an URI component. \"\r\n\r\n\t{'' doc'native conversion'}","function(self)\r\nself:notImplementedYet_(\"asDecodedURI\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"add:",0
,function(self,anObject)
return ((self):errorReadOnly_("add:"));
end
,"adding","add: anObject\r\n\t\" Add anObject to the receiver. \"\r\n\r\n\t^self errorReadOnly: #add:","function(self,anObject)\r\nreturn ((self):errorReadOnly_(\"add:\"));\r\nend")

smalltalk:bind(smalltalk.String,"-->","_minus_minus_gt"
,function(self,anObject)
return ((smalltalk.Association):key_value_((self):asArrayOfSubstringsSeparatedBy_("."),anObject));
end
,"converting","--> anObject\r\n\t\" Return a far-association of the receiver to anObject. \"\r\n\r\n\t^Association key: (self asArrayOfSubstringsSeparatedBy: $.) value: anObject","function(self,anObject)\r\nreturn ((smalltalk.Association):key_value_((self):asArrayOfSubstringsSeparatedBy_(\".\"),anObject));\r\nend")

smalltalk:bind(smalltalk.String,",","_comma"
,function(self,aCollection)
if true then return self..(smalltalk:asString_(aCollection)) end;
return (self);
end
,"copying",", aCollection\r\n\t\" Return a copy of the receiver with all contents of aCollection. \"\r\n\r\n\t{'' doc'native composition'}","function(self,aCollection)\r\nif true then return self..(smalltalk:asString_(aCollection)) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"copyWith:",0
,function(self,anObject)
return (self..(smalltalk:asString_(anObject)));
end
,"copying","copyWith: anObject\r\n\t\" Return a copy of the receiver with anObject. \"\r\n\r\n\t^{'' doc'native composition'}","function(self,anObject)\r\nreturn (self..(smalltalk:asString_(anObject)));\r\nend")

smalltalk:bind(smalltalk.String,"copyFrom:to:",0
,function(self,anIndex,anotherIndex)
return (self:sub(anIndex,anotherIndex));
end
,"copying","copyFrom: anIndex to: anotherIndex\r\n\t\" Return the receiver between limits. \"\r\n\r\n\t^{'' doc'native copy'}","function(self,anIndex,anotherIndex)\r\nreturn (self:sub(anIndex,anotherIndex));\r\nend")

smalltalk:bind(smalltalk.String,"shallowCopy",0
,function(self)
return (self);
end
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"deepCopy",0
,function(self)
return (self);
end
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"reversed",0
,function(self)
local result=nil
if true then return self:reverse() end;
(function()
	local _s8_value=("")
	result=_s8_value
	return _s8_value
end)();
(self):reverseDo_((function(c)
return ((function()
	local _s8_value=(smalltalk:object_comma_((result),c))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
,"copying","reversed\r\n\t\" Return a string with the contents of the receiver in reverse order. \"\r\n\r\n\t| result |\r\n\t{'self' doc'native conversion'}.\r\n\tresult := ''.\r\n\tself reverseDo: [:c| result := result , c ].\r\n\t^result","function(self)\r\nlocal result=nil\r\nif true then return self:reverse() end;\r\n(function()\r\n\tlocal _s8_value=(\"\")\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):reverseDo_((function(c)\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((result),c))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.String,"indexOf:",0
,function(self,aString)

	local index = self:find(aString,1,true)
	if not index
		then return 0
		else return index end;
return (self);
end
,"accessing","indexOf: aString\r\n\t\" Return the position of first occurrence of aString (or 0 if not present). \"\r\n\r\n\t{'' doc'native detection'}","function(self,aString)\r\n\r\n\tlocal index = self:find(aString,1,true)\r\n\tif not index\r\n\t\tthen return 0\r\n\t\telse return index end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"indexOf:ifAbsent:",0
,function(self,aString,aBlock)
local result=nil
(function()
	local _s8_value=((self):indexOf_(aString))
	result=_s8_value
	return _s8_value
end)();
return ((smalltalk:isObject_equalTo_((result),0)):ifTrue_ifFalse_(aBlock,(function()
return (result)
end)));
end
,"accessing","indexOf: aString ifAbsent: aBlock\r\n\t\" Return the position of first occurrence of aString (or the result of evaluating aBlock). \"\r\n\r\n\t| result |\r\n\tresult := self indexOf: aString.\r\n\t^result = 0 ifTrue: aBlock ifFalse: [ result ]","function(self,aString,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):indexOf_(aString))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((smalltalk:isObject_equalTo_((result),0)):ifTrue_ifFalse_(aBlock,(function()\r\nreturn (result)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.String,"indexOf:startingAt:",0
,function(self,aString,position)

	local index = self:find(aString,position,true)
	if not index
		then return 0
		else return index end;
return (self);
end
,"accessing","indexOf: aString startingAt: position\r\n\t\" Return the position of first occurrence of aString after position (or 0 if not present). \"\r\n\r\n\t{'' doc'native detection'}","function(self,aString,position)\r\n\r\n\tlocal index = self:find(aString,position,true)\r\n\tif not index\r\n\t\tthen return 0\r\n\t\telse return index end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"lastIndexOf:",0
,function(self,aString)

	local i = 0
	local j = 0
	local k = 0
	repeat	i = j
		j, k = self:find(aString, k + 1, true)
	until j == nil
	if true then return i end;
return (self);
end
,"accessing","lastIndexOf: aString\r\n\t\" Return the position of last occurrence of aString (or 0 if not present). \"\r\n\r\n\t{'' doc'native detection'}","function(self,aString)\r\n\r\n\tlocal i = 0\r\n\tlocal j = 0\r\n\tlocal k = 0\r\n\trepeat\ti = j\r\n\t\tj, k = self:find(aString, k + 1, true)\r\n\tuntil j == nil\r\n\tif true then return i end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"lastIndexOf:ifAbsent:",0
,function(self,aString,aBlock)
local result=nil
(function()
	local _s8_value=((self):lastIndexOf_(aString))
	result=_s8_value
	return _s8_value
end)();
return ((smalltalk:isObject_equalTo_((result),0)):ifTrue_ifFalse_(aBlock,(function()
return (result)
end)));
end
,"accessing","lastIndexOf: aString ifAbsent: aBlock\r\n\t\" Return the position of last occurrence of aString (or the result of evaluating aBlock). \"\r\n\r\n\t| result |\r\n\tresult := self lastIndexOf: aString.\r\n\t^result = 0 ifTrue: aBlock ifFalse: [ result ]","function(self,aString,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):lastIndexOf_(aString))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((smalltalk:isObject_equalTo_((result),0)):ifTrue_ifFalse_(aBlock,(function()\r\nreturn (result)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.String,"lastIndexOf:startingAt:",0
,function(self,aString,position)

	local i, j
	local k = position
	repeat	i = j
		j, k = self:find(aString, k + 1, true)
	until j == nil
	if true then return i end;
return (self);
end
,"accessing","lastIndexOf: aString startingAt: position\r\n\t\" Return the position of last occurrence of aString before position (or 0 if not present). \"\r\n\r\n\t{'' doc'native detection'}","function(self,aString,position)\r\n\r\n\tlocal i, j\r\n\tlocal k = position\r\n\trepeat\ti = j\r\n\t\tj, k = self:find(aString, k + 1, true)\r\n\tuntil j == nil\r\n\tif true then return i end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"upTo:startingAt:",0
,function(self,aString,position)
local index=nil
(function()
	local _s8_value=((self):indexOf_startingAt_(aString,position))
	index=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((index),0)),(function()
return ((self):size())
end),(function()
return ((index):_minus(1))
end)))
	index=_s8_value
	return _s8_value
end)();
return ((self):copyFrom_to_(position,index));
end
,"accessing","upTo: aString startingAt: position\r\n\t\" Return the receiver upto first occurrence of aString after position. \"\r\n\r\n\t| index |\r\n\tindex := self indexOf: aString startingAt: position.\r\n\tindex := index = 0 ifTrue: [ self size ] ifFalse: [ index - 1 ].\r\n\t^self copyFrom: position to: index","function(self,aString,position)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):indexOf_startingAt_(aString,position))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((index),0)),(function()\r\nreturn ((self):size())\r\nend),(function()\r\nreturn ((index):_minus(1))\r\nend)))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):copyFrom_to_(position,index));\r\nend")

smalltalk:bind(smalltalk.String,"upTo:",0
,function(self,aCharacter)
return ((self):upTo_startingAt_(aCharacter,1));
end
,"accessing","upTo: aCharacter\r\n\t\" Return the receiver upto first occurrence of aCharacter. \"\r\n\r\n\t^self upTo: aCharacter startingAt: 1","function(self,aCharacter)\r\nreturn ((self):upTo_startingAt_(aCharacter,1));\r\nend")

smalltalk:bind(smalltalk.String,"upToLast:",0
,function(self,aString)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local index=nil
(function()
	local _s8_value=((self):lastIndexOf_ifAbsent_(aString,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end)))
	index=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):copyFrom_to_(1,(index):_minus(1)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","upToLast: aString\r\n\t\" Return the receiver upto last occurrence of aString. \"\r\n\r\n\t| index |\r\n\tindex := self lastIndexOf: aString ifAbsent: [ ^self ].\r\n\t^self copyFrom: 1 to: index - 1","function(self,aString)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):lastIndexOf_ifAbsent_(aString,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):copyFrom_to_(1,(index):_minus(1)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.String,"fromLast:",0
,function(self,aString)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local index=nil
(function()
	local _s8_value=((self):lastIndexOf_ifAbsent_(aString,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end)))
	index=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):copyFrom_to_((index):_plus((aString):size()),(self):size()))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","fromLast: aString\r\n\t\" Return the receiver contents from last occurrence of aString. \"\r\n\r\n\t| index |\r\n\tindex := self lastIndexOf: aString ifAbsent: [ ^self ].\r\n\t^self copyFrom: index + aString size to: self size","function(self,aString)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):lastIndexOf_ifAbsent_(aString,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):copyFrom_to_((index):_plus((aString):size()),(self):size()))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.String,"asJsName",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (((smalltalk.String):reservedWords()):includes_(self))==true then smalltalk:if_true_false_((smalltalk:isObject_equalTo_((self),"toString")),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_(("$$"),self))
end
)()
error(_s8Ret_,0)
end)())
end)); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"js","asJsName\r\n\t\" Private - Return the receiver as a valid native name. \"\r\n\r\n\t(String reservedWords includes: self) ifTrue: [\r\n\t\tself = #toString ifFalse: [ ^'$$' ,self ]\r\n\t].\r\n\t^self","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (((smalltalk.String):reservedWords()):includes_(self))==true then smalltalk:if_true_false_((smalltalk:isObject_equalTo_((self),\"toString\")),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((\"$$\"),self))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.String,"asNativeName",0
,function(self)
return (self:asLuaName());
end
,"js","asNativeName\r\n\t\" Return the receiver as a valid native name. \"\r\n\r\n\t^{'' doc'native conversion'}","function(self)\r\nreturn (self:asLuaName());\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"reservedArray",0
,function(self)
return (("abstract as boolean break byte case catch char class\r\n\tcontinue const debugger default delete do double else\r\n\tenum export extends false final finally float for function\r\n\tgoto if implements import in instanceof int interface is\r\n\tlong namespace native new null package private\r\n\tprotected public return short static super switch\r\n\tsynchronized this throw throws transient true try typeof\r\n\tuse var void volatile while with"):asArrayOfSubstrings());
end
,"js","reservedArray\r\n\t\" Private - Return the reserved names of native language. \"\r\n\r\n\t^'abstract as boolean break byte case catch char class\r\n\tcontinue const debugger default delete do double else\r\n\tenum export extends false final finally float for function\r\n\tgoto if implements import in instanceof int interface is\r\n\tlong namespace native new null package private\r\n\tprotected public return short static super switch\r\n\tsynchronized this throw throws transient true try typeof\r\n\tuse var void volatile while with' asArrayOfSubstrings","function(self)\r\nreturn ((\"abstract as boolean break byte case catch char class\\r\\n\\tcontinue const debugger default delete do double else\\r\\n\\tenum export extends false final finally float for function\\r\\n\\tgoto if implements import in instanceof int interface is\\r\\n\\tlong namespace native new null package private\\r\\n\\tprotected public return short static super switch\\r\\n\\tsynchronized this throw throws transient true try typeof\\r\\n\\tuse var void volatile while with\"):asArrayOfSubstrings());\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"reservedWords",0
,function(self)
return ((self):basicAt_ifAbsentPut_("$reservedSet",(function()
return ((smalltalk.HashedSet):withAll_((self):reservedArray()))
end)));
end
,"js","reservedWords\r\n\t\" Private - Return the reserved names of native language. \"\r\n\r\n\t^self basicAt: '$reservedSet' ifAbsentPut: [\r\n\t\tHashedSet withAll: self reservedArray\r\n\t]","function(self)\r\nreturn ((self):basicAt_ifAbsentPut_(\"$reservedSet\",(function()\r\nreturn ((smalltalk.HashedSet):withAll_((self):reservedArray()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.String,"asPrivateSelector",0
,function(self)
local result=nil
local map = {
		[":"]="_",
		["+"]="_plus",
		["-"]="_minus",
		["*"]="_star",
		["/"]="_slash",
		["|"]="_bar",
		["&"]="_amp",
		[">"]="_gt",
		["<"]="_lt",
		["="]="_eq",
		[","]="_comma",
		["@"]="_at",
		["~"]="_no",
		["\\"]="_bk"
	};
	result = self:gsub(".",function(c) return map[c] end);
return (result);
end
,"converting","asPrivateSelector\r\n\t\" Private - Return the receiver as an encoded selector. \"\r\n\r\n\t| result |\r\n\t{'' doc'native conversion'}.\r\n\t^result ","function(self)\r\nlocal result=nil\r\nlocal map = {\r\n\t\t[\":\"]=\"_\",\r\n\t\t[\"+\"]=\"_plus\",\r\n\t\t[\"-\"]=\"_minus\",\r\n\t\t[\"*\"]=\"_star\",\r\n\t\t[\"/\"]=\"_slash\",\r\n\t\t[\"|\"]=\"_bar\",\r\n\t\t[\"&\"]=\"_amp\",\r\n\t\t[\">\"]=\"_gt\",\r\n\t\t[\"<\"]=\"_lt\",\r\n\t\t[\"=\"]=\"_eq\",\r\n\t\t[\",\"]=\"_comma\",\r\n\t\t[\"@\"]=\"_at\",\r\n\t\t[\"~\"]=\"_no\",\r\n\t\t[\"\\\\\"]=\"_bk\"\r\n\t};\r\n\tresult = self:gsub(\".\",function(c) return map[c] end);\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.String,"asSelector",0
,function(self)
if ((self):startsWith_("#"))==true then return ((self):upTo_startingAt_(":",2)); end;
return (((self):asPrivateSelector()):asNativeName());
end
,"converting","asSelector\r\n\t\" Private - Return the receiver as a valid native selector. \"\r\n\r\n\t(self startsWith: $#) ifTrue: [\r\n\t\t^self upTo: $: startingAt: 2\r\n\t].\r\n\t^self asPrivateSelector asNativeName ","function(self)\r\nif ((self):startsWith_(\"#\"))==true then return ((self):upTo_startingAt_(\":\",2)); end;\r\nreturn (((self):asPrivateSelector()):asNativeName());\r\nend")

smalltalk:bind(smalltalk.String,"asNativeSelector",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local operations=nil
if (smalltalk:isObject_equalTo_((self),"$"))==true then return (""); end;
if (smalltalk:isObject_equalTo_((self),"_bk"))==true then return (smalltalk:asCharacter_((92))); end;
if ((self):startsWith_("$$"))==true then return (((self):copyFrom_to_(3,(self):size())):asNativeSelector()); end;
(function()
	local _s8_value=(smalltalk:newArray({smalltalk:newArray({"+", "_plus"}), smalltalk:newArray({"-", "_minus"}), smalltalk:newArray({"*", "_star"}), smalltalk:newArray({"/", "_slash"}), smalltalk:newArray({"|", "_bar"}), smalltalk:newArray({"&", "_amp"}), smalltalk:newArray({">", "_gt"}), smalltalk:newArray({"<", "_lt"}), smalltalk:newArray({"=", "_eq"}), smalltalk:newArray({",", "_comma"}), smalltalk:newArray({"@", "_at"}), smalltalk:newArray({"~", "_no"})}))
	operations=_s8_value
	return _s8_value
end)();
(operations):add_((smalltalk.Array):with_with_(smalltalk:asCharacter_((92)),"_bk"));
(operations):do_((function(tuple)
return (smalltalk:if_true_false_(((self):startsWith_((tuple):last())),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (((operations):reversed()):inject_into_(self,(function(result,each)
return ((result):replace_with_((each):last(),(each):first()))
end)))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):replace_with_("_",":"))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"converting","asNativeSelector\r\n\t\" Return a smalltalk selector from a native function name.\r\n\tNote: it must be the reverse operation of #asSelector\r\n\t\"\r\n\r\n\t| operations |\r\n\tself = '$' ifTrue: [ ^'' ].\r\n\tself = #_bk ifTrue: [ ^92 asCharacter ].\r\n\t(self startsWith: '$$') ifTrue: [\r\n\t\t^(self copyFrom: 3 to: self size) asNativeSelector\r\n\t].\r\n\toperations := #(\r\n\t\t#( + _plus )\r\n\t\t#( - _minus )\r\n\t\t#( * _star )\r\n\t\t#( / _slash )\r\n\t\t#( | _bar )\r\n\t\t#( & _amp )\r\n\t\t#( > _gt )\r\n\t\t#( < _lt )\r\n\t\t#( = _eq )\r\n\t\t#( , _comma )\r\n\t\t#( @ _at )\r\n\t\t#( ~ _no )\r\n\t).\r\n\toperations add: (Array with: 92 asCharacter with: #_bk).\r\n\toperations do: [:tuple|\r\n\t\t(self startsWith: tuple last) ifTrue: [\r\n\t\t\t^operations reversed inject: self into: [:result :each|\r\n\t\t\t\tresult replace: each last with: each first\r\n\t\t\t]\r\n\t\t].\r\n\t].\r\n\t^self replace: $_ with: $:","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal operations=nil\r\nif (smalltalk:isObject_equalTo_((self),\"$\"))==true then return (\"\"); end;\r\nif (smalltalk:isObject_equalTo_((self),\"_bk\"))==true then return (smalltalk:asCharacter_((92))); end;\r\nif ((self):startsWith_(\"$$\"))==true then return (((self):copyFrom_to_(3,(self):size())):asNativeSelector()); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({smalltalk:newArray({\"+\", \"_plus\"}), smalltalk:newArray({\"-\", \"_minus\"}), smalltalk:newArray({\"*\", \"_star\"}), smalltalk:newArray({\"/\", \"_slash\"}), smalltalk:newArray({\"|\", \"_bar\"}), smalltalk:newArray({\"&\", \"_amp\"}), smalltalk:newArray({\">\", \"_gt\"}), smalltalk:newArray({\"<\", \"_lt\"}), smalltalk:newArray({\"=\", \"_eq\"}), smalltalk:newArray({\",\", \"_comma\"}), smalltalk:newArray({\"@\", \"_at\"}), smalltalk:newArray({\"~\", \"_no\"})}))\r\n\toperations=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(operations):add_((smalltalk.Array):with_with_(smalltalk:asCharacter_((92)),\"_bk\"));\r\n(operations):do_((function(tuple)\r\nreturn (smalltalk:if_true_false_(((self):startsWith_((tuple):last())),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (((operations):reversed()):inject_into_(self,(function(result,each)\r\nreturn ((result):replace_with_((each):last(),(each):first()))\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):replace_with_(\"_\",\":\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.String,"asStSelector",0
,function(self)
(self):note_("OBSOLETE - #asStSelector (please use #asNativeSelector)");
return ((self):asNativeSelector());
end
,"converting","asStSelector\r\n\t\" OBSOLETE - Return a smalltalk selector from a native function name.\r\n\tNote: use #asNativeSelector\r\n\t\"\r\n\r\n\tself note: 'OBSOLETE - #asStSelector (please use #asNativeSelector)'.\r\n\t^self asNativeSelector","function(self)\r\n(self):note_(\"OBSOLETE - #asStSelector (please use #asNativeSelector)\");\r\nreturn ((self):asNativeSelector());\r\nend")

smalltalk:bind(smalltalk.String,"slashEncoded",0
,function(self)
local encoded=nil
local bar=nil
(function()
	local _s8_value=(smalltalk:asCharacter_((92)))
	bar=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(self)
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_(bar,smalltalk:object_comma_((bar),bar)))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_((smalltalk.String):lf(),smalltalk:object_comma_((bar),"n")))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_((smalltalk.String):cr(),smalltalk:object_comma_((bar),"r")))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_((smalltalk.String):tab(),smalltalk:object_comma_((bar),"t")))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_("\"",smalltalk:object_comma_((bar),"\"")))
	encoded=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_(("\""),encoded)),"\""));
end
,"converting","slashEncoded\r\n\t\" Private - Return the native representation of the receiver slashed. \"\r\n\r\n\t| encoded bar |\r\n\tbar := 92 asCharacter.\r\n\tencoded := self.\r\n\tencoded := encoded replace: bar with: bar ,bar.\r\n\tencoded := encoded replace: String lf with: bar ,$n.\r\n\tencoded := encoded replace: String cr with: bar ,$r.\r\n\tencoded := encoded replace: String tab with: bar ,$t.\r\n\tencoded := encoded replace: $\" with: bar ,$\".\r\n\t^$\" ,encoded ,$\"","function(self)\r\nlocal encoded=nil\r\nlocal bar=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:asCharacter_((92)))\r\n\tbar=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(self)\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_(bar,smalltalk:object_comma_((bar),bar)))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_((smalltalk.String):lf(),smalltalk:object_comma_((bar),\"n\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_((smalltalk.String):cr(),smalltalk:object_comma_((bar),\"r\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_((smalltalk.String):tab(),smalltalk:object_comma_((bar),\"t\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_(\"\\\"\",smalltalk:object_comma_((bar),\"\\\"\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),encoded)),\"\\\"\"));\r\nend")

smalltalk:bind(smalltalk.String,"asNative:",0
,function(self,lang)
if (smalltalk:isObject_equalTo_((lang),"lua"))==true then return ((self):slashEncoded()); end;
if true then return self:slashEncoded() end;
return (self);
end
,"converting","asNative: lang\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\tlang = #lua ifTrue: [ ^self slashEncoded ].\r\n\t{'' doc'native conversion'}","function(self,lang)\r\nif (smalltalk:isObject_equalTo_((lang),\"lua\"))==true then return ((self):slashEncoded()); end;\r\nif true then return self:slashEncoded() end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"replace:with:",0
,function(self,aString,anotherString)

	local result=""
	local i,j
	local k = 0
	repeat	i=k+1
		j, k = self:find(aString, i, true)
		if (j==nil) then
			result=result..(self:sub(i))
		else
			result=result..(self:sub(i,j-1)..anotherString)
		end
	until j == nil
	if true then return result end;
if (((aString)=="\\"))==true then return ((self):replace_with_("\\\\",anotherString)); end;
return ((self):replaceRegexp_with_((smalltalk.RegularExpression):fromString_flag_(aString,"g"),anotherString));
end
,"regularExpressions","replace: aString with: anotherString\r\n\t\" Return the result of replacement of aString with anotherString in the receiver. \"\r\n\r\n\t{'self' doc'native conversion'}.\r\n\taString == $\\ ifTrue: [ ^self replace: '\\\\' with: anotherString ].\r\n\t^self\r\n\t\treplaceRegexp: (RegularExpression fromString: aString flag: 'g')\r\n\t\twith: anotherString","function(self,aString,anotherString)\r\n\r\n\tlocal result=\"\"\r\n\tlocal i,j\r\n\tlocal k = 0\r\n\trepeat\ti=k+1\r\n\t\tj, k = self:find(aString, i, true)\r\n\t\tif (j==nil) then\r\n\t\t\tresult=result..(self:sub(i))\r\n\t\telse\r\n\t\t\tresult=result..(self:sub(i,j-1)..anotherString)\r\n\t\tend\r\n\tuntil j == nil\r\n\tif true then return result end;\r\nif (((aString)==\"\\\\\"))==true then return ((self):replace_with_(\"\\\\\\\\\",anotherString)); end;\r\nreturn ((self):replaceRegexp_with_((smalltalk.RegularExpression):fromString_flag_(aString,\"g\"),anotherString));\r\nend")

smalltalk:bind(smalltalk.String,"replaceRegexp:with:",0
,function(self,aRegexp,aString)
return (self:notImplementedYet_("replaceRegexp:with:"));
end
,"regularExpressions","replaceRegexp: aRegexp with: aString\r\n\t\" Return the result of replacement of aRegexp with aString in the receiver. \"\r\n\r\n\t^{'' doc'native conversion'}","function(self,aRegexp,aString)\r\nreturn (self:notImplementedYet_(\"replaceRegexp:with:\"));\r\nend")

smalltalk:bind(smalltalk.String,"tokenize:",0
,function(self,aString)

	local result=smalltalk.Array:new()
	local i,j
	local k = 0
	repeat	i=k+1
		j, k = self:find(aString, i, true)
		if (j==nil) then
			result:add_(self:sub(i))
		else
			result:add_(self:sub(i,j-#aString))
		end
	until j == nil
	if true then return result end;
return (self);
end
,"converting","tokenize: aString\r\n\t\" Return the split tokenization of the receiver. \"\r\n\r\n\t{'' doc'native conversion'}","function(self,aString)\r\n\r\n\tlocal result=smalltalk.Array:new()\r\n\tlocal i,j\r\n\tlocal k = 0\r\n\trepeat\ti=k+1\r\n\t\tj, k = self:find(aString, i, true)\r\n\t\tif (j==nil) then\r\n\t\t\tresult:add_(self:sub(i))\r\n\t\telse\r\n\t\t\tresult:add_(self:sub(i,j-#aString))\r\n\t\tend\r\n\tuntil j == nil\r\n\tif true then return result end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"asArrayOfSubstrings",0
,function(self)
local result=nil
local start=nil
local i=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(1)
	i=_s8_value
	return _s8_value
end)();
(self):do_((function(c)
if (smalltalk:isNil_((start)))==true then smalltalk:if_true_false_(((c):isSeparator()),nil,(function()
return ((function()
	local _s8_value=(i)
	start=_s8_value
	return _s8_value
end)())
end)); else smalltalk:if_true_false_(((c):isSeparator()),(function()
(result):add_((self):copyFrom_to_(start,(i):_minus(1)));return ((function()
	local _s8_value=(nil)
	start=_s8_value
	return _s8_value
end)())
end),nil); end;return ((function()
	local _s8_value=((i):_plus(1))
	i=_s8_value
	return _s8_value
end)())
end));
if (smalltalk:notNil_((start)))==true then (result):add_((self):copyFrom_to_(start,(self):size())); end;
return (result);
end
,"converting","asArrayOfSubstrings\r\n\t\" Return an array of substrings from the receiver.\r\n\tThe receiver is divided into substrings by one or more occurrences of separators.\r\n\t\"\r\n\r\n\t| result start i |\r\n\tresult := Array new. i := 1.\r\n\tself do: [:c|\r\n\t\tstart isNil ifTrue: [ \"in separator\"\r\n\t\t\tc isSeparator ifFalse: [ \"start of substring\"\r\n\t\t\t\tstart := i.\r\n\t\t\t]\r\n\t\t] ifFalse: [ \"in word\"\r\n\t\t\tc isSeparator ifTrue: [ \"end of substring\"\r\n\t\t\t\tresult add: (self copyFrom: start to: i - 1).\r\n\t\t\t\tstart := nil.\r\n\t\t\t].\r\n\t\t].\r\n\t\ti := i + 1.\r\n\t].\r\n\tstart notNil ifTrue: [\r\n\t\tresult add: (self copyFrom: start to: self size)\r\n\t].\r\n\t^result","function(self)\r\nlocal result=nil\r\nlocal start=nil\r\nlocal i=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(1)\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(c)\r\nif (smalltalk:isNil_((start)))==true then smalltalk:if_true_false_(((c):isSeparator()),nil,(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(i)\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)); else smalltalk:if_true_false_(((c):isSeparator()),(function()\r\n(result):add_((self):copyFrom_to_(start,(i):_minus(1)));return ((function()\r\n\tlocal _s8_value=(nil)\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),nil); end;return ((function()\r\n\tlocal _s8_value=((i):_plus(1))\r\n\ti=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nif (smalltalk:notNil_((start)))==true then (result):add_((self):copyFrom_to_(start,(self):size())); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.String,"asArrayOfSubstringsSeparatedBy:",0
,function(self,aCharacter)
return ((self):tokenize_(aCharacter));
end
,"converting","asArrayOfSubstringsSeparatedBy: aCharacter\r\n\t\" Return an array of substrings from the receiver.\r\n\tThe receiver is divided into substrings by one or more occurrences of aCharacter.\r\n\t\"\r\n\r\n\t^self tokenize: aCharacter","function(self,aCharacter)\r\nreturn ((self):tokenize_(aCharacter));\r\nend")

smalltalk:bind(smalltalk.String,"match:",0
,function(self,aRegexp)
return (self:notImplementedYet_("match:"));
end
,"regularExpressions","match: aRegexp\r\n\t\" Return the match index of aRegexp in the receiver. \"\r\n\r\n\t^{'' doc'native testing'}","function(self,aRegexp)\r\nreturn (self:notImplementedYet_(\"match:\"));\r\nend")

smalltalk:bind(smalltalk.String,"asString",0
,function(self)
return (self);
end
,"converting","asString\r\n\t\" Return the text representation of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"between:and:",0
,function(self,min,max)
return (smalltalk:boolean_and_((((min) <= self)),(function()
return (((self) <= max))
end)));
end
,"testing","between: min and: max\r\n\t\" Return true if the receiver is between arguments. \"\r\n\r\n\t^min <= self and: [ self <= max ]","function(self,min,max)\r\nreturn (smalltalk:boolean_and_((((min) <= self)),(function()\r\nreturn (((self) <= max))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.String,"isLetter",0
,function(self)
return (#self==1 and string.find(self,"%a")==1);
end
,"testing","isLetter\r\n\t\" Return true if the receiver is a one character letter. \"\r\n\r\n\t^{'' doc'native testing'}","function(self)\r\nreturn (#self==1 and string.find(self,\"%a\")==1);\r\nend")

smalltalk:bind(smalltalk.String,"isDigit",0
,function(self)
return (#self==1 and string.find(self,"%d")==1);
end
,"testing","isDigit\r\n\t\" Return true if the receiver is one character numeric digit. \"\r\n\r\n\t^{'' doc'native testing'}","function(self)\r\nreturn (#self==1 and string.find(self,\"%d\")==1);\r\nend")

smalltalk:bind(smalltalk.String,"isAlphaNumeric",0
,function(self)

return (smalltalk:boolean_or_(((self):isDigit()),(function()
return ((self):isLetter())
end)));
end
,"testing","isAlphaNumeric\r\n\t\" Return true if the receiver is an alphanumeric character. \"\r\n\r\n\t{'self' doc'native testing'}.\r\n\t^self isDigit or: [self isLetter]","function(self)\r\n\r\nreturn (smalltalk:boolean_or_(((self):isDigit()),(function()\r\nreturn ((self):isLetter())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.String,"isUppercase",0
,function(self)
return ((self):isUpperCase());
end
,"testing","isUppercase\r\n\t\" Return true if all the receiver characters are uppercase. \"\r\n\r\n\t^self isUpperCase","function(self)\r\nreturn ((self):isUpperCase());\r\nend")

smalltalk:bind(smalltalk.String,"isUpperCase",0
,function(self)

	if (#self==0) then return false end
	for c in self:gmatch(".") do
		if (c<"A" or c>"Z") then return false end
	end
	if true then return true end;
return (smalltalk:booleanNot_(((self):match_("[^A-Z]"))));
end
,"testing","isUpperCase\r\n\t\" Return true if all the receiver characters are uppercase. \"\r\n\r\n\t{'self' doc'native testing'}.\r\n\t^(self match: '[^A-Z]') not","function(self)\r\n\r\n\tif (#self==0) then return false end\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (c<\"A\" or c>\"Z\") then return false end\r\n\tend\r\n\tif true then return true end;\r\nreturn (smalltalk:booleanNot_(((self):match_(\"[^A-Z]\"))));\r\nend")

smalltalk:bind(smalltalk.String,"isLowerCase",0
,function(self)

	if (#self==0) then return false end
	for c in self:gmatch(".") do
		if (c<"a" or c>"z") then return false end
	end
	if true then return true end;
return (smalltalk:booleanNot_(((self):match_("[^a-z]"))));
end
,"testing","isLowerCase\r\n\t\" Return true if all the receiver characters are lowercase. \"\r\n\r\n\t{'self' doc'native testing'}.\r\n\t^(self match: '[^a-z]') not","function(self)\r\n\r\n\tif (#self==0) then return false end\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (c<\"a\" or c>\"z\") then return false end\r\n\tend\r\n\tif true then return true end;\r\nreturn (smalltalk:booleanNot_(((self):match_(\"[^a-z]\"))));\r\nend")

smalltalk:bind(smalltalk.String,"isLowercase",0
,function(self)
return ((self):isLowerCase());
end
,"testing","isLowercase\r\n\t\" Return true if the receiver is one character lowercase. \"\r\n\r\n\t^self isLowerCase","function(self)\r\nreturn ((self):isLowerCase());\r\nend")

smalltalk:bind(smalltalk.String,"asUppercase",0
,function(self)
return (self:upper());
end
,"converting","asUppercase\r\n\t\" Return a copy of the receiver converted to uppercase. \"\r\n\r\n\t^{'' doc'native testing'}","function(self)\r\nreturn (self:upper());\r\nend")

smalltalk:bind(smalltalk.String,"asUpperCase",0
,function(self)
return ((self):asUppercase());
end
,"converting","asUpperCase\r\n\t\" Return a copy of the receiver converted to uppercase. \"\r\n\r\n\t^self asUppercase","function(self)\r\nreturn ((self):asUppercase());\r\nend")

smalltalk:bind(smalltalk.String,"asLowercase",0
,function(self)
return (self:lower());
end
,"converting","asLowercase\r\n\t\" Return a copy of the receiver converted to lowercase. \"\r\n\r\n\t^{'' doc'native testing'}","function(self)\r\nreturn (self:lower());\r\nend")

smalltalk:bind(smalltalk.String,"asLowerCase",0
,function(self)
return ((self):asLowercase());
end
,"converting","asLowerCase\r\n\t\" Return a copy of the receiver converted to lowercase. \"\r\n\r\n\t^self asLowercase","function(self)\r\nreturn ((self):asLowercase());\r\nend")

smalltalk:bind(smalltalk.String,"asSmalltalkName:",0
,function(self,upCase)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local up=nil
local result=nil
if (smalltalk:boolean_and_((smalltalk:booleanNot_((upCase))),(function()
return (smalltalk:isNil_(((self):detect_ifNone_((function(c)
return (((c) >= "a"))
end),(function()
return (nil)
end)))))
end)))==true then return (((self):asLowercase()):asSmalltalkName_(upCase)); end;
(function()
	local _s8_value=(upCase)
	up=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):inject_into_("",(function(s,each)
return (smalltalk:if_true_false_((("_:.&%$?"):includes_(each)),(function()
(function()
	local _s8_value=(true)
	up=_s8_value
	return _s8_value
end)();return (s)
end),(function()
return (smalltalk:object_comma_((s),smalltalk:if_true_false_((up),(function()
(function()
	local _s8_value=(false)
	up=_s8_value
	return _s8_value
end)();return ((each):asUppercase())
end),(function()
return (each)
end))))
end)))
end)))
	result=_s8_value
	return _s8_value
end)();
if ((result):isEmpty())==true then return ("_"); end;
if (((result):first()):isDigit())==true then return (smalltalk:object_comma_(("_"),result)); end;
if (upCase)==true then smalltalk:if_true_false_((((result):first()):isLowercase()),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((((result):first()):asUppercase()),(result):copyFrom_to_(2,(result):size())))
end
)()
error(_s8Ret_,0)
end)())
end),nil); else smalltalk:if_true_false_((((result):first()):isUppercase()),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((((result):first()):asLowercase()),(result):copyFrom_to_(2,(result):size())))
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"converting","asSmalltalkName: upCase\r\n\t\" Return a copy of the receiver converted to a smalltalk global name. \"\r\n\r\n\t| up result |\r\n\t(upCase not and: [\r\n\t\t(self detect: [:c| c >= $a ] ifNone: []) isNil\r\n\t]) ifTrue: [\r\n\t\t^self asLowercase asSmalltalkName: upCase\r\n\t].\r\n\tup := upCase.\r\n\tresult := self inject: '' into: [:s :each|\r\n\t\t('_:.&%$?' includes: each) ifTrue: [ up := true. s ]\r\n\t\tifFalse: [ s , (up\r\n\t\t\tifTrue: [  up := false. each asUppercase ]\r\n\t\t\tifFalse: [ each ])\r\n\t\t]\r\n\t].\r\n\tresult isEmpty ifTrue: [ ^$_ ].\r\n\tresult first isDigit ifTrue: [ ^$_ ,result ].\r\n\tupCase ifTrue: [\r\n\t\tresult first isLowercase ifTrue: [\r\n\t\t\t^result first asUppercase ,(result copyFrom: 2 to: result size)\r\n\t\t]\r\n\t] ifFalse: [\r\n\t\tresult first isUppercase ifTrue: [\r\n\t\t\t^result first asLowercase ,(result copyFrom: 2 to: result size)\r\n\t\t]\r\n\t].\r\n\t^result","function(self,upCase)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal up=nil\r\nlocal result=nil\r\nif (smalltalk:boolean_and_((smalltalk:booleanNot_((upCase))),(function()\r\nreturn (smalltalk:isNil_(((self):detect_ifNone_((function(c)\r\nreturn (((c) >= \"a\"))\r\nend),(function()\r\nreturn (nil)\r\nend)))))\r\nend)))==true then return (((self):asLowercase()):asSmalltalkName_(upCase)); end;\r\n(function()\r\n\tlocal _s8_value=(upCase)\r\n\tup=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):inject_into_(\"\",(function(s,each)\r\nreturn (smalltalk:if_true_false_(((\"_:.&%$?\"):includes_(each)),(function()\r\n(function()\r\n\tlocal _s8_value=(true)\r\n\tup=_s8_value\r\n\treturn _s8_value\r\nend)();return (s)\r\nend),(function()\r\nreturn (smalltalk:object_comma_((s),smalltalk:if_true_false_((up),(function()\r\n(function()\r\n\tlocal _s8_value=(false)\r\n\tup=_s8_value\r\n\treturn _s8_value\r\nend)();return ((each):asUppercase())\r\nend),(function()\r\nreturn (each)\r\nend))))\r\nend)))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((result):isEmpty())==true then return (\"_\"); end;\r\nif (((result):first()):isDigit())==true then return (smalltalk:object_comma_((\"_\"),result)); end;\r\nif (upCase)==true then smalltalk:if_true_false_((((result):first()):isLowercase()),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((((result):first()):asUppercase()),(result):copyFrom_to_(2,(result):size())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); else smalltalk:if_true_false_((((result):first()):isUppercase()),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((((result):first()):asLowercase()),(result):copyFrom_to_(2,(result):size())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.String,"asGlobalName",0
,function(self)
return ((self):asSmalltalkName_(true));
end
,"converting","asGlobalName\r\n\t\" Return a copy of the receiver converted to a smalltalk global name. \"\r\n\r\n\t^self asSmalltalkName: true","function(self)\r\nreturn ((self):asSmalltalkName_(true));\r\nend")

smalltalk:bind(smalltalk.String,"asLocalName",0
,function(self)
return ((self):asSmalltalkName_(false));
end
,"converting","asLocalName\r\n\t\" Return a copy of the receiver converted to a smalltalk local name. \"\r\n\r\n\t^self asSmalltalkName: false","function(self)\r\nreturn ((self):asSmalltalkName_(false));\r\nend")

smalltalk:bind(smalltalk.String,"digitValue",0
,function(self)
return (((("0123456789ABCDEF"):indexOf_(self)):_minus(1)):max_((0):_minus(1)));
end
,"converting","digitValue\r\n\t\" Return the digit value of the receiver (or -1). \"\r\n\r\n\t^('0123456789ABCDEF' indexOf: self) - 1 max: 0 - 1","function(self)\r\nreturn ((((\"0123456789ABCDEF\"):indexOf_(self)):_minus(1)):max_((0):_minus(1)));\r\nend")

smalltalk:bind(smalltalk.String,"asNumber",0
,function(self)
if ((self):includes_("r"))==true then return ((smalltalk.Number):readFrom_((self):readStream())); end;
return (tonumber(self));
end
,"converting","asNumber\r\n\t\" Return the receiver as a Number. \"\r\n\r\n\t(self includes: $r) ifTrue: [\r\n\t\t^Number readFrom: self readStream\r\n\t].\r\n\t^{'' doc'native converting'}","function(self)\r\nif ((self):includes_(\"r\"))==true then return ((smalltalk.Number):readFrom_((self):readStream())); end;\r\nreturn (tonumber(self));\r\nend")

smalltalk:bind(smalltalk.String,"errorReadOnly",0
,function(self)
return ((self):error_(smalltalk:object_comma_(("Strings are inmutable. Attempt to change "),(self):asLiteral())));
end
,"error","errorReadOnly\r\n\t\" DEPRECATED, Private - The receiver is read-only instance. \"\r\n\r\n\t^self error: 'Strings are inmutable. Attempt to change ' ,self asLiteral","function(self)\r\nreturn ((self):error_(smalltalk:object_comma_((\"Strings are inmutable. Attempt to change \"),(self):asLiteral())));\r\nend")

smalltalk:bind(smalltalk.String,"errorReadOnly:",0
,function(self,selector)
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Strings are inmutable. "),(selector):asLiteral()))," sent to ")),(self):asLiteral())));
end
,"error","errorReadOnly: selector\r\n\t\" Private - The receiver is read-only instance. \"\r\n\r\n\t^self error: 'Strings are inmutable. '\r\n\t\t,selector asLiteral\r\n\t\t,' sent to ' ,self asLiteral","function(self,selector)\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Strings are inmutable. \"),(selector):asLiteral())),\" sent to \")),(self):asLiteral())));\r\nend")

smalltalk:bind(smalltalk.String,"printString",0
,function(self)
local body=nil
(function()
	local _s8_value=(smalltalk:if_true_false_(((self):includes_("'")),(function()
return (((self):asArrayOfSubstringsSeparatedBy_("'")):join_("''"))
end),(function()
return (self)
end)))
	body=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_(("'"),body)),"'"));
end
,"printing","printString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t| body |\r\n\tbody := (self includes: $') ifTrue: [\r\n\t\t(self asArrayOfSubstringsSeparatedBy: $') join: ''''''\r\n\t] ifFalse: [ self ].\r\n\t^$' ,body ,$'","function(self)\r\nlocal body=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((self):includes_(\"'\")),(function()\r\nreturn (((self):asArrayOfSubstringsSeparatedBy_(\"'\")):join_(\"''\"))\r\nend),(function()\r\nreturn (self)\r\nend)))\r\n\tbody=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"'\"),body)),\"'\"));\r\nend")

smalltalk:bind(smalltalk.String,"isString",0
,function(self)
return (true);
end
,"testing","isString\r\n\t\" Return true if the receiver is a String. \"\r\n\r\n\t^true","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.String,"isBackSlash",0
,function(self)
return (smalltalk:isObject_equalTo_(((self):asciiValue()),92));
end
,"testing","isBackSlash\r\n\t\" Return true if the receiver is a back-slash string. \"\r\n\r\n\t^self asciiValue = 92 ","function(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):asciiValue()),92));\r\nend")

smalltalk:bind(smalltalk.String,">","_gt"
,function(self,aString)
return (self > aString);
end
,"comparing","> aString\r\n\t\" Return true if the receiver is greater than argument. \"\r\n\r\n\t^{'' doc'native compare'}","function(self,aString)\r\nreturn (self > aString);\r\nend")

smalltalk:bind(smalltalk.String,"<","_lt"
,function(self,aString)
return (self < aString);
end
,"comparing","< aString\r\n\t\" Return true if the receiver is smaller than argument. \"\r\n\r\n\t^{'' doc'native compare'}","function(self,aString)\r\nreturn (self < aString);\r\nend")

smalltalk:bind(smalltalk.String,">=","_gt_eq"
,function(self,aString)
return (self >= aString);
end
,"comparing",">= aString\r\n\t\" Return true if the receiver is greater or equal to argument. \"\r\n\r\n\t^{'' doc'native compare'}","function(self,aString)\r\nreturn (self >= aString);\r\nend")

smalltalk:bind(smalltalk.String,"<=","_lt_eq"
,function(self,aString)
return (self <= aString);
end
,"comparing","<= aString\r\n\t\" Return true if the receiver is smaller or equal to argument. \"\r\n\r\n\t^{'' doc'native compare'}","function(self,aString)\r\nreturn (self <= aString);\r\nend")

smalltalk:bind(smalltalk.String,"remove:ifAbsent:",0
,function(self,anObject,aBlock)
return ((self):errorReadOnly_("remove:ifAbsent:"));
end
,"removing","remove: anObject ifAbsent: aBlock\r\n\t\" Remove anObject from the receiver. \"\r\n\r\n\t^self errorReadOnly: #remove:ifAbsent:","function(self,anObject,aBlock)\r\nreturn ((self):errorReadOnly_(\"remove:ifAbsent:\"));\r\nend")

smalltalk:bind(smalltalk.String,"removeAll:",0
,function(self,aCollection)
return ((self):errorReadOnly_("removeAll:"));
end
,"removing","removeAll: aCollection\r\n\t\" Remove aCollection from receiver. \"\r\n\r\n\t^self errorReadOnly: #removeAll:","function(self,aCollection)\r\nreturn ((self):errorReadOnly_(\"removeAll:\"));\r\nend")

smalltalk:bind(smalltalk.String,"removeAll",0
,function(self)
return ((self):errorReadOnly_("removeAll"));
end
,"removing","removeAll\r\n\t\" Remove all elements in the receiver. \"\r\n\r\n\t^self errorReadOnly: #removeAll","function(self)\r\nreturn ((self):errorReadOnly_(\"removeAll\"));\r\nend")

smalltalk:bind(smalltalk.String,"asJSONObject",0
,function(self)

return (smalltalk:object_comma_((self),""));
end
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t{'self'}.\r\n\t^self , ''\r\n\"Note:\twe need to normalize result to do not destroy typeof checkings\r\n\tDo NOT modify this method if you do not know what you are doing.\r\n\tIf you remove the ,'' computation, the returned object will return 'object' and not 'string' as result of typeof operation.\r\n\"","function(self)\r\n\r\nreturn (smalltalk:object_comma_((self),\"\"));\r\nend")

smalltalk:bind(smalltalk.Object,"isCharacter",0
,function(self)
return (false);
end
,"testing","isCharacter\r\n\t\" Return true if the receiver is a character. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.String,"isCharacter",0
,function(self)
return (#self == 1);
end
,"testing","isCharacter\r\n\t\" Implemented to support Character protocoll for one-character Strings. \"\r\n\r\n\t^{'' doc'native testing'}","function(self)\r\nreturn (#self == 1);\r\nend")

smalltalk:bind(smalltalk.String,"asciiValue",0
,function(self)
return (string.byte(self));
end
,"testing","asciiValue\r\n\t\" Return the number corresponding to the ASCII encoding of the first character of the receiver. \"\r\n\r\n\t^{'' doc'native converting'}","function(self)\r\nreturn (string.byte(self));\r\nend")

smalltalk:bind(smalltalk.String,"isSeparator",0
,function(self)
return (#self==1 and self:find("%s")==1);
end
,"testing","isSeparator\r\n\t\" Return true if the receiver is either a space, tab, new-line, form-feed character, or double-byte space.\r\n\tNote that new-line has been extended to support NEL character.\r\n\tSee https://en.wikipedia.org/wiki/Newline\r\n\t\"\r\n\r\n\t^{'' doc'native testing'}","function(self)\r\nreturn (#self==1 and self:find(\"%s\")==1);\r\nend")

smalltalk:bind(smalltalk.String,"asAsciiZ",0
,function(self)
return (smalltalk:object_comma_((self),((self)["$klass"]):zero()));
end
,"converting","asAsciiZ\r\n\t\" Return the receiver with ascii zero appended. \"\r\n\r\n\t^self , self class zero","function(self)\r\nreturn (smalltalk:object_comma_((self),((self)[\"$klass\"]):zero()));\r\nend")

smalltalk:bind(smalltalk.String,"trimFirst:last:",0
,function(self,firstBlock,lastBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local start=nil
local stop=nil
(function()
	local _s8_value=(1)
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):size())
	stop=_s8_value
	return _s8_value
end)();
while ((function()
if (((start) > stop))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.String):new())
end
)()
error(_s8Ret_,0)
end)(); end;return ((firstBlock):value_((self):at_(start)))
end))() do (function()
	local _s8_value=((start):_plus(1))
	start=_s8_value
	return _s8_value
end)(); end;
while ((function()
if (((stop) < start))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.String):new())
end
)()
error(_s8Ret_,0)
end)(); end;return ((lastBlock):value_((self):at_(stop)))
end))() do (function()
	local _s8_value=((stop):_minus(1))
	stop=_s8_value
	return _s8_value
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):copyFrom_to_(start,stop))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"selecting","trimFirst: firstBlock last: lastBlock\r\n\t\" Return a String containing the result of trimming characters matching blocks from both sides of the receiver. \"\r\n\r\n\t| start stop |\r\n\tstart := 1. stop := self size.\r\n\t[\tstart > stop ifTrue: [ ^String new ].\r\n\t\tfirstBlock value: (self at: start)\r\n\t] whileTrue: [ start := start + 1 ].\r\n\t[\tstop < start ifTrue: [ ^String new ].\r\n\t\tlastBlock value: (self at: stop)\r\n\t] whileTrue: [ stop := stop - 1 ].\r\n\t^self copyFrom: start to: stop","function(self,firstBlock,lastBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal start=nil\r\nlocal stop=nil\r\n(function()\r\n\tlocal _s8_value=(1)\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):size())\r\n\tstop=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nif (((start) > stop))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.String):new())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return ((firstBlock):value_((self):at_(start)))\r\nend))() do (function()\r\n\tlocal _s8_value=((start):_plus(1))\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nwhile ((function()\r\nif (((stop) < start))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.String):new())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return ((lastBlock):value_((self):at_(stop)))\r\nend))() do (function()\r\n\tlocal _s8_value=((stop):_minus(1))\r\n\tstop=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):copyFrom_to_(start,stop))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.String,"trim:",0
,function(self,aBlock)
return ((self):trimFirst_last_(aBlock,aBlock));
end
,"selecting","trim: aBlock\r\n\t\" Return a String containing the result of trimming characters matching aBlock from both sides of the receiver. \"\r\n\r\n\t^self trimFirst: aBlock last: aBlock","function(self,aBlock)\r\nreturn ((self):trimFirst_last_(aBlock,aBlock));\r\nend")

smalltalk:bind(smalltalk.String,"trimFirst:",0
,function(self,aBlock)
return ((self):trimFirst_last_(aBlock,(function(c)
return (false)
end)));
end
,"selecting","trimFirst: aBlock\r\n\t\" Return a String containing the result of trimming characters matching aBlock from start of the receiver. \"\r\n\r\n\t^self trimFirst: aBlock last: [:c| false ]","function(self,aBlock)\r\nreturn ((self):trimFirst_last_(aBlock,(function(c)\r\nreturn (false)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.String,"trimLast:",0
,function(self,aBlock)
return ((self):trimFirst_last_((function(c)
return (false)
end),aBlock));
end
,"selecting","trimLast: aBlock\r\n\t\" Return a String containing the result of trimming characters matching aBlock from end of the receiver. \"\r\n\r\n\t^self trimFirst: [:c| false ] last: aBlock","function(self,aBlock)\r\nreturn ((self):trimFirst_last_((function(c)\r\nreturn (false)\r\nend),aBlock));\r\nend")

smalltalk:bind(smalltalk.String,"trimBlanks",0
,function(self)
return ((self):trim_((function(c)
return ((c):isSeparator())
end)));
end
,"selecting","trimBlanks\r\n\t\" Return a String containing the receiver string with leading and trailing blanks removed. \"\r\n\r\n\t^self trim: [:c| c isSeparator ]","function(self)\r\nreturn ((self):trim_((function(c)\r\nreturn ((c):isSeparator())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.String,"to:",0
,function(self,__end)
return ((self):to_by_(__end,smalltalk:if_true_false_((((self) <= __end)),(function()
return (1)
end),(function()
return (-1)
end))));
end
,"iterating","to: end\r\n\t\" Return an iterable from the receiver to end. \"\r\n\r\n\t^self to: end by: (self <= end ifTrue: [1] ifFalse: [-1])","function(self,__end)\r\nreturn ((self):to_by_(__end,smalltalk:if_true_false_((((self) <= __end)),(function()\r\nreturn (1)\r\nend),(function()\r\nreturn (-1)\r\nend))));\r\nend")

smalltalk:bind(smalltalk.String,"to:by:",0
,function(self,__end,increment)
return (((self):asciiValue()):to_by_value_((__end):asciiValue(),increment,(function(index,block)
return ((block):value_(smalltalk:asCharacter_((index))))
end)));
end
,"iterating","to: end by: increment\r\n\t\" Return an iterable from the receiver to end. \"\r\n\r\n\t^self asciiValue\r\n\t\tto: end asciiValue\r\n\t\tby: increment\r\n\t\tvalue: [:index :block| block value: index asCharacter ]","function(self,__end,increment)\r\nreturn (((self):asciiValue()):to_by_value_((__end):asciiValue(),increment,(function(index,block)\r\nreturn ((block):value_(smalltalk:asCharacter_((index))))\r\nend)));\r\nend")

smalltalk:addClass("Array",smalltalk.SequenceableCollection,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.Array["$klass"],"new",0
,function(self)
return (smalltalk:newArray({}));
end
,"instantiation","new\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^#()","function(self)\r\nreturn (smalltalk:newArray({}));\r\nend")

smalltalk:bind(smalltalk.Array["$klass"],"basicNew:",0
,function(self,size)
return (smalltalk:newArray());
end
,"instantiation","basicNew: size\r\n\t\" Return an instance of the receiver of specified size. \"\r\n\r\n\t^{'' doc'native instantiation'}","function(self,size)\r\nreturn (smalltalk:newArray());\r\nend")

smalltalk:bind(smalltalk.Array["$klass"],"new:",0
,function(self,size)
return (((self):basicNew_(size)):atAllPut_(nil));
end
,"instantiation","new: size\r\n\t\" Return an instance of the receiver of specified size. \"\r\n\r\n\t^(self basicNew: size) atAllPut: nil","function(self,size)\r\nreturn (((self):basicNew_(size)):atAllPut_(nil));\r\nend")

smalltalk:bind(smalltalk.Array["$klass"],"with:",0
,function(self,anObject)

return ((
function(_s8_rec)
	(_s8_rec):add_(anObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","with: anObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}.\r\n\t^self new\r\n\t\tadd: anObject;\r\n\t\tyourself","function(self,anObject)\r\n\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(anObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.Array["$klass"],"with:with:",0
,function(self,firstObject,secondObject)

return ((
function(_s8_rec)
	(_s8_rec):add_(firstObject);
	(_s8_rec):add_(secondObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","with: firstObject with: secondObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}.\r\n\t^self new\r\n\t\tadd: firstObject;\r\n\t\tadd: secondObject;\r\n\t\tyourself","function(self,firstObject,secondObject)\r\n\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(firstObject);\r\n\t(_s8_rec):add_(secondObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.Array["$klass"],"with:with:with:",0
,function(self,firstObject,secondObject,thirdObject)

return ((
function(_s8_rec)
	(_s8_rec):add_(firstObject);
	(_s8_rec):add_(secondObject);
	(_s8_rec):add_(thirdObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","with: firstObject with: secondObject with: thirdObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}.\r\n\t^self new\r\n\t\tadd: firstObject;\r\n\t\tadd: secondObject;\r\n\t\tadd: thirdObject;\r\n\t\tyourself","function(self,firstObject,secondObject,thirdObject)\r\n\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(firstObject);\r\n\t(_s8_rec):add_(secondObject);\r\n\t(_s8_rec):add_(thirdObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.Array["$klass"],"with:with:with:with:",0
,function(self,firstObject,secondObject,thirdObject,fourthObject)

return ((
function(_s8_rec)
	(_s8_rec):add_(firstObject);
	(_s8_rec):add_(secondObject);
	(_s8_rec):add_(thirdObject);
	(_s8_rec):add_(fourthObject);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","with: firstObject with: secondObject with: thirdObject with: fourthObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}.\r\n\t^self new\r\n\t\tadd: firstObject;\r\n\t\tadd: secondObject;\r\n\t\tadd: thirdObject;\r\n\t\tadd: fourthObject;\r\n\t\tyourself","function(self,firstObject,secondObject,thirdObject,fourthObject)\r\n\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(firstObject);\r\n\t(_s8_rec):add_(secondObject);\r\n\t(_s8_rec):add_(thirdObject);\r\n\t(_s8_rec):add_(fourthObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.Array["$klass"],"withAll:",0
,function(self,aCollection)

	local result = aCollection:asArray()
	if aCollection==result
		then return result:copy()
		else return result
	end;
return (self);
end
,"instantiation","withAll: aCollection\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}","function(self,aCollection)\r\n\r\n\tlocal result = aCollection:asArray()\r\n\tif aCollection==result\r\n\t\tthen return result:copy()\r\n\t\telse return result\r\n\tend;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Array["$klass"],"slice:",0
,function(self,anIterable)
return (self:notImplementedYet_("slice:"));
end
,"util","slice: anIterable\r\n\t\" Return an Array instance from contents of anIterable. \"\r\n\r\n\t^{'' doc'native instantiation'}","function(self,anIterable)\r\nreturn (self:notImplementedYet_(\"slice:\"));\r\nend")

smalltalk:bind(smalltalk.Array,"size",0
,function(self)
return (#self);
end
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^{'' doc'native size'}","function(self)\r\nreturn (#self);\r\nend")

smalltalk:bind(smalltalk.Array,"at:",0
,function(self,anIndex)

	local value = self[anIndex]
	if value==nil then return self:objectNotFoundAt_(anIndex) end
	if true then return self:unwrap_(value) end;
return (self);
end
,"accessing","at: anIndex\r\n\t\" Return the contents of the receiver at anIndex. \"\r\n\r\n\t{'' doc'native indexing'}","function(self,anIndex)\r\n\r\n\tlocal value = self[anIndex]\r\n\tif value==nil then return self:objectNotFoundAt_(anIndex) end\r\n\tif true then return self:unwrap_(value) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Array,"at:ifAbsent:",0
,function(self,anIndex,aBlock)

	local value = self[anIndex]
	if (value==nil) then return aBlock:value() end
	if true then return self:unwrap_(value) end;
return (self);
end
,"accessing","at: anIndex ifAbsent: aBlock\r\n\t\" Return the contents of the receiver at anIndex or the result of evaluating aBlock. \"\r\n\r\n\t{'' doc'native indexing'}","function(self,anIndex,aBlock)\r\n\r\n\tlocal value = self[anIndex]\r\n\tif (value==nil) then return aBlock:value() end\r\n\tif true then return self:unwrap_(value) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Array,"at:put:",0
,function(self,anIndex,anObject)

	self[anIndex]=self:wrap_(anObject)
	if true then return anObject end;
return (self);
end
,"accessing","at: anIndex put: anObject\r\n\t\" Set the contents of the receiver at anIndex. \"\r\n\r\n\t{'' doc'native indexing'}","function(self,anIndex,anObject)\r\n\r\n\tself[anIndex]=self:wrap_(anObject)\r\n\tif true then return anObject end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Array,"do:",0
,function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();

	for _,value in ipairs(self) do
		fn(self:unwrap_(value))
	end;
return (self);
end
,"enumerating","do: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{''s8'\t1 to: self size do: [:i|\r\n\t\taBlock value: (self at: i)\r\n\t]' doc'native iteration'}","function(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\n\tfor _,value in ipairs(self) do\r\n\t\tfn(self:unwrap_(value))\r\n\tend;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Array,"isArray",0
,function(self)
return ((((self)["$klass"])==smalltalk.Array));
end
,"testing","isArray\r\n\t\" Return true if the receiver is an Array. \"\r\n\r\n\t^self class == Array","function(self)\r\nreturn ((((self)[\"$klass\"])==smalltalk.Array));\r\nend")

smalltalk:bind(smalltalk.Array,"addAll:",0
,function(self,aCollection)

	local array = aCollection:asArray()
	for i=1,#array do self[#self+1]=self:wrap_(array[i]) end;
return (aCollection);
end
,"adding","addAll: aCollection\r\n\t\" Add objects in aCollection to the receiver. \"\r\n\r\n\t{'' doc'native composing'}.\r\n\t^aCollection","function(self,aCollection)\r\n\r\n\tlocal array = aCollection:asArray()\r\n\tfor i=1,#array do self[#self+1]=self:wrap_(array[i]) end;\r\nreturn (aCollection);\r\nend")

smalltalk:bind(smalltalk.Array,"shallowCopy",0
,function(self)
local result=nil

	result = self:class():new()
	for i=1,#self do result[#result+1]=self[i] end;
return (result);
end
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t| result |\r\n\t{'' doc'native copy'}.\r\n\t^result","function(self)\r\nlocal result=nil\r\n\r\n\tresult = self:class():new()\r\n\tfor i=1,#self do result[#result+1]=self[i] end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Array,"deepCopy",0
,function(self)
return ((self):collect_((function(each)
return ((each):deepCopy())
end)));
end
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self collect: [:each | each deepCopy ]","function(self)\r\nreturn ((self):collect_((function(each)\r\nreturn ((each):deepCopy())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Array,"copyFrom:to:",0
,function(self,anIndex,anotherIndex)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(anIndex):to_do_(anotherIndex,(function(each)
return ((result):add_((self):at_(each)))
end));
return (result);
end
,"copying","copyFrom: anIndex to: anotherIndex\r\n\t\" Return the receiver contents in the interval. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tanIndex to: anotherIndex do: [:each | result add: (self at: each) ].\r\n\t^result","function(self,anIndex,anotherIndex)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(anIndex):to_do_(anotherIndex,(function(each)\r\nreturn ((result):add_((self):at_(each)))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Array,"copyWithAll:",0
,function(self,aCollection)

	local result = self:copy()
	result:addAll_(aCollection)
	if true then return result end;
return (self);
end
,"copying","copyWithAll: aCollection\r\n\t\" Return a copy of the receiver with all contents of aCollection. \"\r\n\r\n\t{'' doc'native composition'}","function(self,aCollection)\r\n\r\n\tlocal result = self:copy()\r\n\tresult:addAll_(aCollection)\r\n\tif true then return result end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Array,",","_comma"
,function(self,aCollection)

	local result = self:copy()
	result:addAll_(aCollection)
	if true then return result end;
return (self);
end
,"copying",", aCollection\r\n\t\" Return a copy of the receiver with all contents of aCollection. \"\r\n\r\n\t{'' doc'native composition'}","function(self,aCollection)\r\n\r\n\tlocal result = self:copy()\r\n\tresult:addAll_(aCollection)\r\n\tif true then return result end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Array,"join:",0
,function(self,aString)
return (table.concat(self,aString));
end
,"composing","join: aString\r\n\t\" Return a string with the receiver's contents separated by aString. \"\r\n\r\n\t^{'' doc'native composition'}","function(self,aString)\r\nreturn (table.concat(self,aString));\r\nend")

smalltalk:bind(smalltalk.Array,"compose:with:",0
,function(self,aBlock,aString)
return (((self):collect_thenSelect_(aBlock,(function(each)
return (smalltalk:notNil_((each)))
end))):join_(aString));
end
,"composing","compose: aBlock with: aString\r\n\t\" Return a string composed with the result of evaluating aBlock into receiver's contents. \"\r\n\r\n\t^(self\tcollect: aBlock\r\n\t\tthenSelect: [:each| each notNil ])\r\n\t\tjoin: aString","function(self,aBlock,aString)\r\nreturn (((self):collect_thenSelect_(aBlock,(function(each)\r\nreturn (smalltalk:notNil_((each)))\r\nend))):join_(aString));\r\nend")

smalltalk:bind(smalltalk.Array,"compose:",0
,function(self,aBlock)
return ((self):compose_with_(aBlock,""));
end
,"composing","compose: aBlock\r\n\t\" Return a string composed with the result of evaluating aBlock into receiver's contents. \"\r\n\r\n\t^self compose: aBlock with: ''","function(self,aBlock)\r\nreturn ((self):compose_with_(aBlock,\"\"));\r\nend")

smalltalk:bind(smalltalk.Array,"asNative:",0
,function(self,lang)
local list=nil
(function()
	local _s8_value=(((self):collect_((function(each)
return ((each):asNative_(lang))
end))):join_(", "))
	list=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((lang),"lua"))==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk:newArray"),"(")),"{")),list)),"}")),")")); end;
return (smalltalk:object_comma_((smalltalk:object_comma_(("["),list)),"]"));
end
,"converting","asNative: lang\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t| list |\r\n\tlist := (self collect: [:each | each asNative: lang ]) join: ', '.\r\n\tlang = #lua ifTrue: [ ^'smalltalk:newArray' ,$( ,${ ,list ,$} ,$) ].\r\n\t^$[ ,list ,$]","function(self,lang)\r\nlocal list=nil\r\n(function()\r\n\tlocal _s8_value=(((self):collect_((function(each)\r\nreturn ((each):asNative_(lang))\r\nend))):join_(\", \"))\r\n\tlist=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((lang),\"lua\"))==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk:newArray\"),\"(\")),\"{\")),list)),\"}\")),\")\")); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"[\"),list)),\"]\"));\r\nend")

smalltalk:bind(smalltalk.Array,"sort:",0
,function(self,aBlock)
local fn=nil
(function()
	local _s8_value=((self):callableOf_(aBlock))
	fn=_s8_value
	return _s8_value
end)();
table.sort(self,fn);
return (self);
end
,"sorting","sort: aBlock\r\n\t\" Sort (inplace) the receiver's contents with aBlock. \"\r\n\r\n\t| fn | fn := self callableOf: aBlock.\r\n\t{'' doc'native sorting'}","function(self,aBlock)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):callableOf_(aBlock))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\ntable.sort(self,fn);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Array,"asArray",0
,function(self)
return (self);
end
,"converting","asArray\r\n\t\" Return an array with the contents of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Array,"remove:ifAbsent:",0
,function(self,anObject,aBlock)

	for i,value in ipairs(self) do
		if (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then return table.remove(self,i) end
	end
	if true then return aBlock:value() end;
return (self);
end
,"removing","remove: anObject ifAbsent: aBlock\r\n\t\" Remove anObject from the receiver.\r\n\tReturn the result of evaluating aBlock if anObject is not in the receiver.\r\n\t\"\r\n\r\n\t{'' doc'native remotion'}","function(self,anObject,aBlock)\r\n\r\n\tfor i,value in ipairs(self) do\r\n\t\tif (smalltalk:isObject_equalTo_(self:unwrap_(value),anObject)) then return table.remove(self,i) end\r\n\tend\r\n\tif true then return aBlock:value() end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Array,"add:",0
,function(self,anObject)
self[#self+1]=self:wrap_(anObject);
return (anObject);
end
,"adding","add: anObject\r\n\t\" Add anObject to the receiver. \"\r\n\r\n\t{'' doc'native addition'}.\r\n\t^anObject","function(self,anObject)\r\nself[#self+1]=self:wrap_(anObject);\r\nreturn (anObject);\r\nend")

smalltalk:bind(smalltalk.Array,"addFirst:",0
,function(self,anObject)
table.insert(self,1,self:wrap_(anObject));
return (anObject);
end
,"adding","addFirst: anObject\r\n\t\" Add anObject to the receiver. \"\r\n\r\n\t{'' doc'native addition'}.\r\n\t^anObject","function(self,anObject)\r\ntable.insert(self,1,self:wrap_(anObject));\r\nreturn (anObject);\r\nend")

smalltalk:bind(smalltalk.Array,"addLast:",0
,function(self,anObject)
self[#self+1]=self:wrap_(anObject);
return (anObject);
end
,"adding","addLast: anObject\r\n\t\" Add anObject to the receiver (at end). \"\r\n\r\n\t{'' doc'native addition'}.\r\n\t^anObject","function(self,anObject)\r\nself[#self+1]=self:wrap_(anObject);\r\nreturn (anObject);\r\nend")

smalltalk:bind(smalltalk.Array,"removeAll",0
,function(self)
for i=#self,1,-1 do self[i]=nil end;
return (self);
end
,"removing","removeAll\r\n\t\" Remove all the objects in the receiver. \"\r\n\r\n\t{'' doc'native remotion'}","function(self)\r\nfor i=#self,1,-1 do self[i]=nil end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Array,"removeFirst",0
,function(self)
local result=nil
(function()
	local _s8_value=((self):first())
	result=_s8_value
	return _s8_value
end)();
table.remove(self,1);
return (result);
end
,"removing","removeFirst\r\n\t\" Remove the first object in the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self first.\r\n\t{'' doc'native remotion'}.\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):first())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\ntable.remove(self,1);\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Array,"removeIndex:",0
,function(self,index)
table.remove(self,index);
return (self);
end
,"removing","removeIndex: index\r\n\t\" Remove the element at index. \"\r\n\r\n\t{'' doc'native remotion'}","function(self,index)\r\ntable.remove(self,index);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Array,"removeLast",0
,function(self)
return (self:unwrap_(table.remove(self)));
end
,"removing","removeLast\r\n\t\" Remove the last object in the receiver. \"\r\n\r\n\t^{'' doc'native remotion'}","function(self)\r\nreturn (self:unwrap_(table.remove(self)));\r\nend")

smalltalk:bind(smalltalk.Array,"sorted",0
,function(self)
return (((self):copy()):sort_(nil));
end
,"sorting","sorted\r\n\t\" Return a sorted copy of the receiver. \"\r\n\r\n\t^self copy sort: nil","function(self)\r\nreturn (((self):copy()):sort_(nil));\r\nend")

smalltalk:bind(smalltalk.Array,"sorted:",0
,function(self,aBlock)
return (((self):copy()):sort_(aBlock));
end
,"sorting","sorted: aBlock\r\n\t\" Return a sorted copy of the receiver. \"\r\n\r\n\t^self copy sort: aBlock","function(self,aBlock)\r\nreturn (((self):copy()):sort_(aBlock));\r\nend")

smalltalk:bind(smalltalk.Array,"atAllPut:",0
,function(self,anObject)

	local what=self:wrap_(anObject)
	for i=1,#self do self[i]=what end;
return (self);
end
,"accessing","atAllPut: anObject\r\n\t\" Replace all elements of the receiver with anObject. \"\r\n\r\n\t{'' doc'native operation'}","function(self,anObject)\r\n\r\n\tlocal what=self:wrap_(anObject)\r\n\tfor i=1,#self do self[i]=what end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Array,"first",0
,function(self)

	local value=self[1]
	if (value~=nil) then return self:unwrap_(value) end;
return ((self):at_(1));
end
,"accessing","first\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t{'' doc'native indexing'}.\r\n\t^self at: 1","function(self)\r\n\r\n\tlocal value=self[1]\r\n\tif (value~=nil) then return self:unwrap_(value) end;\r\nreturn ((self):at_(1));\r\nend")

smalltalk:bind(smalltalk.Array,"second",0
,function(self)

	local value=self[2]
	if (value~=nil) then return self:unwrap_(value) end;
return ((self):at_(2));
end
,"accessing","second\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t{'' doc'native indexing'}.\r\n\t^self at: 2","function(self)\r\n\r\n\tlocal value=self[2]\r\n\tif (value~=nil) then return self:unwrap_(value) end;\r\nreturn ((self):at_(2));\r\nend")

smalltalk:bind(smalltalk.Array,"third",0
,function(self)

	local value=self[3]
	if (value~=nil) then return self:unwrap_(value) end;
return ((self):at_(3));
end
,"accessing","third\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t{'' doc'native indexing'}.\r\n\t^self at: 3","function(self)\r\n\r\n\tlocal value=self[3]\r\n\tif (value~=nil) then return self:unwrap_(value) end;\r\nreturn ((self):at_(3));\r\nend")

smalltalk:bind(smalltalk.Array,"fourth",0
,function(self)
	
	local value=self[4]
	if (value~=nil) then return self:unwrap_(value) end;
return ((self):at_(4));
end
,"accessing","fourth\r\n\t\" Return the object in the receiver. \"\r\n\r\n\t{'' doc'native indexing'}.\r\n\t^self at: 4","function(self)\r\n\t\r\n\tlocal value=self[4]\r\n\tif (value~=nil) then return self:unwrap_(value) end;\r\nreturn ((self):at_(4));\r\nend")

smalltalk:bind(smalltalk.Array,"fifth",0
,function(self)

	local value=self[5]
	if (value~=nil) then return self:unwrap_(value) end;
return ((self):at_(5));
end
,"accessing","fifth\r\n\t\" Return the fifth object in the receiver. \"\r\n\r\n\t{'' doc'native indexing'}.\r\n\t^self at: 5","function(self)\r\n\r\n\tlocal value=self[5]\r\n\tif (value~=nil) then return self:unwrap_(value) end;\r\nreturn ((self):at_(5));\r\nend")

smalltalk:bind(smalltalk.Array,"sixth",0
,function(self)

	local value=self[6]
	if (value~=nil) then return self:unwrap_(value) end;
return ((self):at_(6));
end
,"accessing","sixth\r\n\t\" Return the sixth object in the receiver. \"\r\n\r\n\t{'' doc'native indexing'}.\r\n\t^self at: 6","function(self)\r\n\r\n\tlocal value=self[6]\r\n\tif (value~=nil) then return self:unwrap_(value) end;\r\nreturn ((self):at_(6));\r\nend")

smalltalk:bind(smalltalk.Array,"withIndexDo:",0
,function(self,aBlock)
local index=nil
(function()
	local _s8_value=(1)
	index=_s8_value
	return _s8_value
end)();
(self):do_((function(each)
(aBlock):value_value_(each,index);return ((function()
	local _s8_value=((index):_plus(1))
	index=_s8_value
	return _s8_value
end)())
end));
return (self);
end
,"enumerating","withIndexDo: aBlock\r\n\t\" Evaluate aBlock with all the index positions in the receiver. \"\r\n\r\n\t| index |\r\n\tindex := 1.\r\n\tself do: [:each|\r\n\t\taBlock value: each value: index.\r\n\t\tindex := index + 1\r\n\t]","function(self,aBlock)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=(1)\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(each)\r\n(aBlock):value_value_(each,index);return ((function()\r\n\tlocal _s8_value=((index):_plus(1))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Array,"printString",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
if ((self):isEmpty())==true then return ("#()"); end;
(function()
	local _s8_value=("#( ")
	result=_s8_value
	return _s8_value
end)();
(self):do_((function(each)
if ((((result):size()) > 10000))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((result),"...)"))
end
)()
error(_s8Ret_,0)
end)(); end;return ((function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((result),smalltalk:if_true_false_(((self):isObject_(each)),(function()
return (smalltalk:printString_((each)))
end),(function()
return (each)
end))))," "))
	result=_s8_value
	return _s8_value
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((result),")"))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"printing","printString\r\n\t\" DEBUG - Temporary printing method (must check for recursion). \"\r\n\r\n\t| result |\r\n\tself isEmpty ifTrue: [ ^'#()' ].\r\n\tresult := '#( '.\r\n\tself do: [:each|\r\n\t\tresult size > 10000 ifTrue: [ ^result,'...)' ].\r\n\t\tresult := result , (\r\n\t\t\t(self isObject: each)\r\n\t\t\tifTrue: [ each printString ]\r\n\t\t\tifFalse: [ each ]) ,' '\r\n\t].\r\n\t^result,')'","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\nif ((self):isEmpty())==true then return (\"#()\"); end;\r\n(function()\r\n\tlocal _s8_value=(\"#( \")\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(each)\r\nif ((((result):size()) > 10000))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((result),\"...)\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((result),smalltalk:if_true_false_(((self):isObject_(each)),(function()\r\nreturn (smalltalk:printString_((each)))\r\nend),(function()\r\nreturn (each)\r\nend)))),\" \"))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((result),\")\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Array,"asLiteral",0
,function(self)
local literals=nil
(function()
	local _s8_value=((self):collect_((function(each)
return (smalltalk:if_true_false_(((self):isObject_(each)),(function()
return ((each):asLiteral())
end),(function()
return (smalltalk:toString_((each)))
end)))
end)))
	literals=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_(("#("),(literals):join_(" "))),")"));
end
,"converting","asLiteral\r\n\t\" Return the receiver in literal notation. \"\r\n\r\n\t| literals |\r\n\tliterals := self collect: [:each|\r\n\t\t(self isObject: each)\r\n\t\tifTrue: [ each asLiteral ]\r\n\t\tifFalse: [ each toString ]\r\n\t].\r\n\t^'#(' ,(literals join: $ ) ,$)","function(self)\r\nlocal literals=nil\r\n(function()\r\n\tlocal _s8_value=((self):collect_((function(each)\r\nreturn (smalltalk:if_true_false_(((self):isObject_(each)),(function()\r\nreturn ((each):asLiteral())\r\nend),(function()\r\nreturn (smalltalk:toString_((each)))\r\nend)))\r\nend)))\r\n\tliterals=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"#(\"),(literals):join_(\" \"))),\")\"));\r\nend")

smalltalk:bind(smalltalk.Array,"asJSONObject",0
,function(self)
local result=nil

(function()
	local _s8_value=((self):collect_((function(each)
return (smalltalk:if_true_false_(((self):isObject_(each)),(function()
return ((each):asJSONObject())
end),(function()
return (each)
end)))
end)))
	result=_s8_value
	return _s8_value
end)();

return (result);
end
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t| result |\r\n\t{'self' doc'native conversion'}.\r\n\tresult := self collect: [:each| \r\n\t\t(self isObject: each)\r\n\t\tifTrue: [ each asJSONObject ]\r\n\t\tifFalse: [ each ]\r\n\t].\r\n\t{'self' doc'native closing'}.\r\n\t^result","function(self)\r\nlocal result=nil\r\n\r\n(function()\r\n\tlocal _s8_value=((self):collect_((function(each)\r\nreturn (smalltalk:if_true_false_(((self):isObject_(each)),(function()\r\nreturn ((each):asJSONObject())\r\nend),(function()\r\nreturn (each)\r\nend)))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Array,"json",0
,function(self)
local result=nil

(function()
	local _s8_value=((self):collect_((function(each)
return (smalltalk:if_true_false_(((self):isObject_(each)),(function()
return ((each):json())
end),(function()
return (each)
end)))
end)))
	result=_s8_value
	return _s8_value
end)();

return (result);
end
,"converting","json\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t| result |\r\n\t{'self' doc'native conversion'}.\r\n\tresult := self collect: [:each| \r\n\t\t(self isObject: each)\r\n\t\tifTrue: [ each json ]\r\n\t\tifFalse: [ each ]\r\n\t].\r\n\t{'self' doc'native closing'}.\r\n\t^result","function(self)\r\nlocal result=nil\r\n\r\n(function()\r\n\tlocal _s8_value=((self):collect_((function(each)\r\nreturn (smalltalk:if_true_false_(((self):isObject_(each)),(function()\r\nreturn ((each):json())\r\nend),(function()\r\nreturn (each)\r\nend)))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\nreturn (result);\r\nend")

smalltalk:addClass("RegularExpression",smalltalk.Object,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.RegularExpression,"compile:",0
,function(self,aString)
return ((self):compile(aString));
end
,"evaluating","compile: aString\r\n\t\" Return the result of compilation of aString. \"\r\n\r\n\t^self #compile: aString","function(self,aString)\r\nreturn ((self):compile(aString));\r\nend")

smalltalk:bind(smalltalk.RegularExpression,"exec:",0
,function(self,aString)
return ((self):exec(aString));
end
,"evaluating","exec: aString\r\n\t\" Return the result of excecution of aString. \"\r\n\r\n\t^self #exec: aString","function(self,aString)\r\nreturn ((self):exec(aString));\r\nend")

smalltalk:bind(smalltalk.RegularExpression,"test:",0
,function(self,aString)
return ((self):test(aString));
end
,"evaluating","test: aString\r\n\t\" Return the result of testing of aString. \"\r\n\r\n\t^self #test: aString","function(self,aString)\r\nreturn ((self):test(aString));\r\nend")

smalltalk:bind(smalltalk.RegularExpression["$klass"],"fromString:flag:",0
,function(self,aString,anotherString)
return (self:notImplementedYet_("fromString:flag:"));
end
,"instantiation","fromString: aString flag: anotherString\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^{'' doc'native instantiation'}","function(self,aString,anotherString)\r\nreturn (self:notImplementedYet_(\"fromString:flag:\"));\r\nend")

smalltalk:bind(smalltalk.RegularExpression["$klass"],"fromString:",0
,function(self,aString)
return ((self):fromString_flag_(aString,""));
end
,"instantiation","fromString: aString\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t    ^self fromString: aString flag: ''","function(self,aString)\r\nreturn ((self):fromString_flag_(aString,\"\"));\r\nend")

smalltalk:bind(smalltalk.RegularExpression,"shallowCopy",0
,function(self)
return (self);
end
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.RegularExpression,"deepCopy",0
,function(self)
return (self);
end
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.RegularExpression,"asJSONObject",0
,function(self)
return (self);
end
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Error["$klass"],"signal:",0
,function(self,aString)
return ((
function(_s8_rec)
	(_s8_rec):messageText_(aString);
	(_s8_rec):captureStack();
	return ((_s8_rec):signal())
end
)((self):new()));
end
,"instantiation","signal: aString\r\n\t\" Signal an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tmessageText: aString;\r\n\t\tcaptureStack;\r\n\t\tsignal","function(self,aString)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):messageText_(aString);\r\n\t(_s8_rec):captureStack();\r\n\treturn ((_s8_rec):signal())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.Exception,"messageText",0
,function(self)
return (self["@messageText"]);
end
,"accessing","messageText\r\n\t\" Return the messageText of the receiver. \"\r\n\r\n\t^messageText","function(self)\r\nreturn (self[\"@messageText\"]);\r\nend")

smalltalk:bind(smalltalk.Exception,"description",0
,function(self)
local txt=nil
local ex=nil
(function()
	local _s8_value=((self):messageText())
	txt=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((txt)))==true then (function()
	local _s8_value=("")
	txt=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=((self):toString_(txt))
	txt=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):nativeException())
	ex=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((ex)))==true then (function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((txt)," [")),(self):typeOf_(ex))),"] ")),(self):toString_(ex)))
	txt=_s8_value
	return _s8_value
end)(); end;
return (smalltalk:object_comma_((smalltalk:object_comma_((((self)["$klass"]):name())," - ")),txt));
end
,"accessing","description\r\n\t\" Return the description of the receiver. \"\r\n\r\n\t| txt ex |\r\n\ttxt := self messageText.\r\n\ttxt isNil ifTrue: [ txt := '' ].\r\n\ttxt := self toString: txt.\r\n\tex := self nativeException.\r\n\tex notNil ifTrue: [\r\n\t\ttxt := txt\r\n\t\t\t,' [' ,(self typeOf: ex)\r\n\t\t\t,'] ' ,(self toString: ex)\r\n\t].\r\n\t^self class name ,' - ' ,txt ","function(self)\r\nlocal txt=nil\r\nlocal ex=nil\r\n(function()\r\n\tlocal _s8_value=((self):messageText())\r\n\ttxt=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((txt)))==true then (function()\r\n\tlocal _s8_value=(\"\")\r\n\ttxt=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((self):toString_(txt))\r\n\ttxt=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):nativeException())\r\n\tex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((ex)))==true then (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((txt),\" [\")),(self):typeOf_(ex))),\"] \")),(self):toString_(ex)))\r\n\ttxt=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((((self)[\"$klass\"]):name()),\" - \")),txt));\r\nend")

smalltalk:bind(smalltalk.Exception,"messageText:",0
,function(self,aString)
(function()
	local _s8_value=(aString)
	self["@messageText"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","messageText: aString\r\n\t\" Set the messageText of the receiver. \"\r\n\r\n\tmessageText := aString","function(self,aString)\r\n(function()\r\n\tlocal _s8_value=(aString)\r\n\tself[\"@messageText\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Exception,"signal",0
,function(self)
(self):note_((self):description());
error(self);
return (self);
end
,"signaling","signal\r\n\t\" Signal/throw the receiver. \"\r\n\r\n\tself note: self description.\r\n\t{'' doc'jump into native exception'}","function(self)\r\n(self):note_((self):description());\r\nerror(self);\r\nreturn (self);\r\nend")

smalltalk:addClass("ArrayedContents",smalltalk.SequenceableCollection,smalltalk:newArray({"contents"}),"Kernel")

smalltalk:bind(smalltalk.ArrayedContents,"contents",0
,function(self)
if (smalltalk:isNil_((self["@contents"])))==true then (function()
	local _s8_value=((smalltalk.Array):new())
	self["@contents"]=_s8_value
	return _s8_value
end)(); end;
return (self["@contents"]);
end
,"private","contents\r\n\t\" Private - Return the contents of the receiver. \"\r\n\r\n\tcontents isNil ifTrue: [ contents := Array new ].\r\n\t^contents","function(self)\r\nif (smalltalk:isNil_((self[\"@contents\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@contents\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@contents\"]);\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"add:",0
,function(self,anObject)
return (((self):contents()):add_(anObject));
end
,"adding","add: anObject\r\n\t\" Add anObject to the receiver. \"\r\n\r\n\t^self contents add: anObject","function(self,anObject)\r\nreturn (((self):contents()):add_(anObject));\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"at:ifAbsent:",0
,function(self,anIndex,aBlock)
return (((self):contents()):at_ifAbsent_(anIndex,aBlock));
end
,"accessing","at: anIndex ifAbsent: aBlock\r\n\t\" Return the contents of the receiver at anIndex or the result of evaluating aBlock. \"\r\n\r\n\t^self contents at: anIndex ifAbsent: aBlock","function(self,anIndex,aBlock)\r\nreturn (((self):contents()):at_ifAbsent_(anIndex,aBlock));\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"at:put:",0
,function(self,anIndex,anObject)
return (((self):contents()):at_put_(anIndex,anObject));
end
,"accessing","at: anIndex put: anObject\r\n\t\" Set the contents of the receiver at anIndex. \"\r\n\r\n\t^self contents at: anIndex put: anObject","function(self,anIndex,anObject)\r\nreturn (((self):contents()):at_put_(anIndex,anObject));\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"atAllPut:",0
,function(self,anObject)
return (((self):contents()):atAllPut_(anObject));
end
,"accessing","atAllPut: anObject\r\n\t\" Replace all elements of the receiver with anObject. \"\r\n\r\n\t^self contents atAllPut: anObject","function(self,anObject)\r\nreturn (((self):contents()):atAllPut_(anObject));\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"copyFrom:to:",0
,function(self,anIndex,anotherIndex)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(anIndex):to_do_(anotherIndex,(function(each)
return ((result):add_((self):at_(each)))
end));
return (result);
end
,"copying","copyFrom: anIndex to: anotherIndex\r\n\t\" Return the receiver contents in the interval. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tanIndex to: anotherIndex do: [:each | result add: (self at: each) ].\r\n\t^result","function(self,anIndex,anotherIndex)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(anIndex):to_do_(anotherIndex,(function(each)\r\nreturn ((result):add_((self):at_(each)))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"indexOf:ifAbsent:",0
,function(self,anObject,aBlock)
return (((self):contents()):indexOf_ifAbsent_(anObject,aBlock));
end
,"testing","indexOf: anObject ifAbsent: aBlock\r\n\t\" Return the position of anObject in the receiver, or the result of evaluating aBlock. \"\r\n\r\n\t^self contents indexOf: anObject ifAbsent: aBlock","function(self,anObject,aBlock)\r\nreturn (((self):contents()):indexOf_ifAbsent_(anObject,aBlock));\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"detect:ifNone:",0
,function(self,aBlock,anotherBlock)
return (((self):contents()):detect_ifNone_(aBlock,anotherBlock));
end
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. \"\r\n\r\n\t^self contents detect: aBlock ifNone: anotherBlock","function(self,aBlock,anotherBlock)\r\nreturn (((self):contents()):detect_ifNone_(aBlock,anotherBlock));\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"do:",0
,function(self,aBlock)
return (((self):contents()):do_(aBlock));
end
,"enumerating","do: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver. \"\r\n\r\n\t^self contents do: aBlock","function(self,aBlock)\r\nreturn (((self):contents()):do_(aBlock));\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"includes:",0
,function(self,anObject)
return (((self):contents()):includes_(anObject));
end
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t^self contents includes: anObject","function(self,anObject)\r\nreturn (((self):contents()):includes_(anObject));\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"isEmpty",0
,function(self)
return (((self):contents()):isEmpty());
end
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^self contents isEmpty","function(self)\r\nreturn (((self):contents()):isEmpty());\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"occurrencesOf:",0
,function(self,anObject)
return (((self):contents()):occurrencesOf_(anObject));
end
,"counting","occurrencesOf: anObject\r\n\t\" Return the occurrences of anObject in the receiver. \"\r\n\r\n\t^self contents occurrencesOf: anObject","function(self,anObject)\r\nreturn (((self):contents()):occurrencesOf_(anObject));\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"reverseDo:",0
,function(self,aBlock)
return (((self):contents()):reverseDo_(aBlock));
end
,"enumerating","reverseDo: aBlock\r\n\t\" Evaluate aBlock with the contents of the receiver in reverse order of iteration. \"\r\n\r\n\t^self contents reverseDo: aBlock","function(self,aBlock)\r\nreturn (((self):contents()):reverseDo_(aBlock));\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"reversed",0
,function(self)
return (((self)["$klass"]):withAll_(((self):contents()):reversed()));
end
,"copying","reversed\r\n\t\" Return an array with the contents of the receiver in reverse order. \"\r\n\r\n\t^self class withAll: self contents reversed","function(self)\r\nreturn (((self)[\"$klass\"]):withAll_(((self):contents()):reversed()));\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"detect:ifNone:",0
,function(self,aBlock,anotherBlock)
return (((self):contents()):detect_ifNone_(aBlock,anotherBlock));
end
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Return the object in the receiver that return true when evaluated with aBlock or the result of evaluating anotherBlock. \"\r\n\r\n\t^self contents detect: aBlock ifNone: anotherBlock","function(self,aBlock,anotherBlock)\r\nreturn (((self):contents()):detect_ifNone_(aBlock,anotherBlock));\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"remove:ifAbsent:",0
,function(self,anObject,aBlock)
return (((self):contents()):remove_ifAbsent_(anObject,aBlock));
end
,"removing","remove: anObject ifAbsent: aBlock\r\n\t\" Remove anObject from the receiver.\r\n\tReturn the result of evaluating aBlock if anObject is not in the receiver.\r\n\t\"\r\n\r\n\t^self contents remove: anObject ifAbsent: aBlock","function(self,anObject,aBlock)\r\nreturn (((self):contents()):remove_ifAbsent_(anObject,aBlock));\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"removeAll",0
,function(self)
(function()
	local _s8_value=(nil)
	self["@contents"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"removing","removeAll\r\n\t\" Remove all the objects in the receiver. \"\r\n\r\n\tcontents := nil","function(self)\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@contents\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"removeFirst",0
,function(self)
return (((self):contents()):removeFirst());
end
,"removing","removeFirst\r\n\t\" Remove the first object in the receiver. \"\r\n\r\n\t^self contents removeFirst","function(self)\r\nreturn (((self):contents()):removeFirst());\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"removeLast",0
,function(self)
return (((self):contents()):removeLast());
end
,"removing","removeLast\r\n\t\" Remove the last object in the receiver. \"\r\n\r\n\t^self contents removeLast","function(self)\r\nreturn (((self):contents()):removeLast());\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"removeIndex:",0
,function(self,index)
return (((self):contents()):removeIndex_(index));
end
,"removing","removeIndex: index\r\n\t\" Remove the element at index. \"\r\n\r\n\t^self contents removeIndex: index","function(self,index)\r\nreturn (((self):contents()):removeIndex_(index));\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"size",0
,function(self)
return (((self):contents()):size());
end
,"accesing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^self contents size","function(self)\r\nreturn (((self):contents()):size());\r\nend")

smalltalk:bind(smalltalk.ArrayedContents,"withIndexDo:",0
,function(self,aBlock)
return (((self):contents()):withIndexDo_(aBlock));
end
,"enumerating","withIndexDo: aBlock\r\n\t\" Evaluate aBlock with all the index positions in the receiver. \"\r\n\r\n\t^self contents withIndexDo: aBlock","function(self,aBlock)\r\nreturn (((self):contents()):withIndexDo_(aBlock));\r\nend")

smalltalk:addClass("ComposedAssociations",smalltalk.ArrayedContents,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.ComposedAssociations["$klass"],",","_comma"
,function(self,anObject)
return (smalltalk:object_comma_(((self):new()),anObject));
end
,"composing",", anObject\r\n\t\" Return an instance of the receiver with the argument. \"\r\n\r\n\t^self new ,anObject","function(self,anObject)\r\nreturn (smalltalk:object_comma_(((self):new()),anObject));\r\nend")

smalltalk:bind(smalltalk.ComposedAssociations,",","_comma"
,function(self,anObject)
if ((anObject):isAssociation())==true then return ((
function(_s8_rec)
	(_s8_rec):add_(anObject);
	return ((_s8_rec):yourself())
end
)(self)); end;
return (smalltalk:if_true_false_((smalltalk:isNil_((anObject))),(function()
return (self)
end),(function()
return (smalltalk:superImplementor(smalltalk.ComposedAssociations,"_comma")(self,anObject))
end)));
end
,"composing",", anObject\r\n\t\" Return the receiver composed with the argument. \"\r\n\r\n\tanObject isAssociation ifTrue: [\r\n\t\t^self add: anObject; yourself\r\n\t].\r\n\t^anObject isNil ifTrue: [ self ] ifFalse: [ super , anObject ]","function(self,anObject)\r\nif ((anObject):isAssociation())==true then return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_(anObject);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(self)); end;\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((anObject))),(function()\r\nreturn (self)\r\nend),(function()\r\nreturn (smalltalk:superImplementor(smalltalk.ComposedAssociations,\"_comma\")(self,anObject))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ComposedAssociations,"hashObject",0
,function(self)
return ({});
end
,"private","hashObject\r\n\t\" Private - Return an empty hash object. \"\r\n\r\n\t^{'' doc'native instantiation'}","function(self)\r\nreturn ({});\r\nend")

smalltalk:bind(smalltalk.ComposedAssociations,"install:value:into:",0
,function(self,key,value,jsObject)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (smalltalk:boolean_and_(((self):isObject_(key)),(function()
return ((key):isArray())
end)))==true then if (smalltalk:isObject_equalTo_(((key):size()),1))==true then return ((self):install_value_into_((key):first(),value,jsObject)); end;
smalltalk:if_true_false_(((((key):size()) > 1)),(function()
local target=nil
(function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((jsObject),(key):first(),(function()
return (smalltalk:basic_at_put_((jsObject),(self):toString_((key):first()),(self):hashObject()))
end)))
	target=_s8_value
	return _s8_value
end)();return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):install_value_into_((key):copyFrom_to_(2,(key):size()),value,target))
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:basic_at_put_((jsObject),(self):toString_(key),value))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"private","install: key value: value into: jsObject\r\n\t\" Private - Install a key/value pair into jsObject. \"\r\n\r\n\t((self isObject: key) and: [ key isArray ]) ifTrue: [\r\n\t\tkey size = 1 ifTrue: [ ^self install: key first value: value into: jsObject ].\r\n\t\tkey size > 1 ifTrue: [ | target |\r\n\t\t\ttarget := jsObject basicAt: key first ifAbsent: [\r\n\t\t\t\tjsObject basicAt: (self toString: key first) put: self hashObject\r\n\t\t\t].\r\n\t\t\t^self install: (key copyFrom: 2 to: key size) value: value into: target\r\n\t\t].\r\n\t].\r\n\t^jsObject\r\n\t\tbasicAt: (self toString: key) \"it is IMPORTANT to send #toString here (v8{4.7.0} bug will expose {object} instead of {string} Ale-14/oct/2015)\"\r\n\t\tput: value","function(self,key,value,jsObject)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (smalltalk:boolean_and_(((self):isObject_(key)),(function()\r\nreturn ((key):isArray())\r\nend)))==true then if (smalltalk:isObject_equalTo_(((key):size()),1))==true then return ((self):install_value_into_((key):first(),value,jsObject)); end;\r\nsmalltalk:if_true_false_(((((key):size()) > 1)),(function()\r\nlocal target=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((jsObject),(key):first(),(function()\r\nreturn (smalltalk:basic_at_put_((jsObject),(self):toString_((key):first()),(self):hashObject()))\r\nend)))\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):install_value_into_((key):copyFrom_to_(2,(key):size()),value,target))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:basic_at_put_((jsObject),(self):toString_(key),value))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ComposedAssociations,"asJSONObject",0
,function(self)
local result=nil
local aValue=nil
(function()
	local _s8_value=((self):hashObject())
	result=_s8_value
	return _s8_value
end)();
(self):do_((function(assoc)
(function()
	local _s8_value=(smalltalk:if_true_false_(((self):isObject_((assoc):value())),(function()
return (((assoc):value()):json())
end),(function()
return ((assoc):value())
end)))
	aValue=_s8_value
	return _s8_value
end)();return ((self):install_value_into_((assoc):key(),aValue,result))
end));
return (result);
end
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t| result aValue |\r\n\tresult := self hashObject.\r\n\tself do: [:assoc |\r\n\t\taValue := (self isObject: assoc value)\r\n\t\t\tifTrue: [ assoc value json ]\r\n\t\t\tifFalse: [ assoc value ].\r\n\t\tself install: assoc key value: aValue into: result\r\n\t].\r\n\t^result","function(self)\r\nlocal result=nil\r\nlocal aValue=nil\r\n(function()\r\n\tlocal _s8_value=((self):hashObject())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):do_((function(assoc)\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((self):isObject_((assoc):value())),(function()\r\nreturn (((assoc):value()):json())\r\nend),(function()\r\nreturn ((assoc):value())\r\nend)))\r\n\taValue=_s8_value\r\n\treturn _s8_value\r\nend)();return ((self):install_value_into_((assoc):key(),aValue,result))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.ComposedAssociations,"handle",0
,function(self)
return ((self):json());
end
,"converting","handle\r\n\t\" Return the receiver as a native object. \"\r\n\r\n\t^self json","function(self)\r\nreturn ((self):json());\r\nend")

smalltalk:bind(smalltalk.ComposedAssociations,"associationAt:ifAbsent:",0
,function(self,aKey,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):reverseDo_((function(assoc)
local value=nil
if (smalltalk:isObject_equalTo_(((assoc):key()),aKey))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (assoc)
end
)()
error(_s8Ret_,0)
end)(); end;(function()
	local _s8_value=((assoc):value())
	value=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:boolean_and_(((self):isObject_(value)),(function()
return (smalltalk:is_kindOf_((value),((self)["$klass"])))
end))),(function()
(function()
	local _s8_value=((value):associationAt_ifAbsent_(aKey,(function()
return (nil)
end)))
	value=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:notNil_((value))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (value)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):evaluate())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","associationAt: aKey ifAbsent: aBlock\r\n\t\" Return the association at aKey (or the result of evaluating aBlock).\r\n\tNote: the search will introspect in case of composite values.\r\n\t\"\r\n\r\n\tself reverseDo: [:assoc| | value |\r\n\t\tassoc key = aKey ifTrue: [ ^assoc ].\r\n\t\tvalue := assoc value.\r\n\t\t((self isObject: value) and: [value isKindOf: self class]) ifTrue: [\r\n\t\t\tvalue := value associationAt: aKey ifAbsent: [].\r\n\t\t\tvalue notNil ifTrue: [ ^value ].\r\n\t\t]\r\n\t].\r\n\t^aBlock evaluate","function(self,aKey,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):reverseDo_((function(assoc)\r\nlocal value=nil\r\nif (smalltalk:isObject_equalTo_(((assoc):key()),aKey))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (assoc)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;(function()\r\n\tlocal _s8_value=((assoc):value())\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:boolean_and_(((self):isObject_(value)),(function()\r\nreturn (smalltalk:is_kindOf_((value),((self)[\"$klass\"])))\r\nend))),(function()\r\n(function()\r\n\tlocal _s8_value=((value):associationAt_ifAbsent_(aKey,(function()\r\nreturn (nil)\r\nend)))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:notNil_((value))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (value)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):evaluate())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ComposedAssociations,"@","_at"
,function(self,aKey)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local assoc=nil
(function()
	local _s8_value=((self):associationAt_ifAbsent_(aKey,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end)))
	assoc=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((assoc):value())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","@ aKey\r\n\t\" Return the value at aKey (or nil).\r\n\tNote: the search will introspect in case of composite values.\r\n\t\"\r\n\r\n\t| assoc |\r\n\tassoc := self associationAt: aKey ifAbsent: [ ^nil ].\r\n\t^assoc value","function(self,aKey)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal assoc=nil\r\n(function()\r\n\tlocal _s8_value=((self):associationAt_ifAbsent_(aKey,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tassoc=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((assoc):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:addClass("Association",smalltalk.Object,smalltalk:newArray({"key","value"}),"Kernel")

smalltalk:bind(smalltalk.Association["$klass"],"key:",0
,function(self,aKey)
return (((self):new()):key_(aKey));
end
,"instantiation","key: aKey\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new key: aKey","function(self,aKey)\r\nreturn (((self):new()):key_(aKey));\r\nend")

smalltalk:bind(smalltalk.Association["$klass"],"key:value:",0
,function(self,aKey,aValue)
return (((self):key_(aKey)):value_(aValue));
end
,"instantiation","key: aKey value: aValue\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^(self key: aKey) value: aValue","function(self,aKey,aValue)\r\nreturn (((self):key_(aKey)):value_(aValue));\r\nend")

smalltalk:bind(smalltalk.Association,"=","_eq"
,function(self,anAssociation)
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((self)["$klass"]),(anAssociation)["$klass"])),(function()
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((self):key()),(anAssociation):key())),(function()
return (smalltalk:isObject_equalTo_(((self):value()),(anAssociation):value()))
end)))
end)));
end
,"comparing","= anAssociation\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\t^self class = anAssociation class and: [\r\n\t    self key = anAssociation key and: [\r\n\t\tself value = anAssociation value]]","function(self,anAssociation)\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((self)[\"$klass\"]),(anAssociation)[\"$klass\"])),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((self):key()),(anAssociation):key())),(function()\r\nreturn (smalltalk:isObject_equalTo_(((self):value()),(anAssociation):value()))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Association,"key:",0
,function(self,aKey)
(function()
	local _s8_value=(aKey)
	self["@key"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","key: aKey\r\n\t\" Set the key of the receiver. \"\r\n\r\n\tkey := aKey","function(self,aKey)\r\n(function()\r\n\tlocal _s8_value=(aKey)\r\n\tself[\"@key\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Association,"key",0
,function(self)
return (self["@key"]);
end
,"accessing","key\r\n\t\" Return the key of the receiver. \"\r\n\r\n\t^key","function(self)\r\nreturn (self[\"@key\"]);\r\nend")

smalltalk:bind(smalltalk.Association,"value:",0
,function(self,aValue)
(function()
	local _s8_value=(aValue)
	self["@value"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","value: aValue\r\n\t\" Set the value of the receiver. \"\r\n\r\n\tvalue := aValue","function(self,aValue)\r\n(function()\r\n\tlocal _s8_value=(aValue)\r\n\tself[\"@value\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Association,"value",0
,function(self)
return (self["@value"]);
end
,"accessing","value\r\n\t\" Return the value of the receiver. \"\r\n\r\n\t^value","function(self)\r\nreturn (self[\"@value\"]);\r\nend")

smalltalk:bind(smalltalk.Association,",","_comma"
,function(self,anAssociation)
return ((smalltalk.ComposedAssociations):with_with_(self,anAssociation));
end
,"composing",", anAssociation\r\n\t\" Return the receiver composed with the argument. \"\r\n\r\n\t^ComposedAssociations with: self with: anAssociation","function(self,anAssociation)\r\nreturn ((smalltalk.ComposedAssociations):with_with_(self,anAssociation));\r\nend")

smalltalk:bind(smalltalk.Association,"asJSONObject",0
,function(self)
return (((smalltalk.ComposedAssociations):with_(self)):json());
end
,"converting","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t^(ComposedAssociations with: self) json","function(self)\r\nreturn (((smalltalk.ComposedAssociations):with_(self)):json());\r\nend")

smalltalk:bind(smalltalk.Association,"isAssociation",0
,function(self)
return (true);
end
,"testing","isAssociation\r\n\t\" Return true if the receiver is anAssociation. \"\r\n\r\n\t^true","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.Object,"isAssociation",0
,function(self)
return (false);
end
,"testing","isAssociation\r\n\t\" Return true if the receiver is anAssociation. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.Association,"printString",0
,function(self)
return (smalltalk:toString_((self)));
end
,"printing","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t^self toString ","function(self)\r\nreturn (smalltalk:toString_((self)));\r\nend")

smalltalk:bind(smalltalk.Association,"toString",0
,function(self)
local string=nil
(function()
	local _s8_value=((function(x)
return (((function()
return (smalltalk:if_true_false_((smalltalk:isNil_((x))),(function()
return ("nil")
end),(function()
return (smalltalk:if_true_false_(((self):isObject_(x)),(function()
return ((x):asLiteral())
end),(function()
return ((self):toString_(x))
end)))
end)))
end)):on_do_(smalltalk.Exception,(function(ex)
return (smalltalk:object_comma_(("??? "),(ex):description()))
end)))
end))
	string=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("("),(string):value_(self["@key"])))," -> ")),(string):value_(self["@value"]))),")"));
end
,"converting","toString\r\n\t\" Return the receiver as a String. \"\r\n\r\n\t| string |\r\n\tstring := [:x| [\r\n\t\tx isNil ifTrue: [ #nil ] ifFalse: [\r\n\t\t\t(self isObject: x) ifTrue: [ x asLiteral ]\r\n\t\t\tifFalse: [ self toString: x ] ]\r\n\t\t] on: Exception do: [:ex| '??? ' ,ex description ] ].\r\n\t^$( ,(string value: key) ,' -> ' ,(string value: value) ,$)","function(self)\r\nlocal string=nil\r\n(function()\r\n\tlocal _s8_value=((function(x)\r\nreturn (((function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((x))),(function()\r\nreturn (\"nil\")\r\nend),(function()\r\nreturn (smalltalk:if_true_false_(((self):isObject_(x)),(function()\r\nreturn ((x):asLiteral())\r\nend),(function()\r\nreturn ((self):toString_(x))\r\nend)))\r\nend)))\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\nreturn (smalltalk:object_comma_((\"??? \"),(ex):description()))\r\nend)))\r\nend))\r\n\tstring=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"(\"),(string):value_(self[\"@key\"]))),\" -> \")),(string):value_(self[\"@value\"]))),\")\"));\r\nend")

smalltalk:addClass("KeyedCollection",smalltalk.Collection,smalltalk:newArray({}),"Kernel")

smalltalk:addClass("Dictionary",smalltalk.KeyedCollection,smalltalk:newArray({"keys","values"}),"Kernel")

smalltalk:addClass("PoolDictionary",smalltalk.KeyedCollection,smalltalk:newArray({"hash","size"}),"Kernel")

smalltalk:bind(smalltalk.KeyedCollection["$klass"],"basicNew:",0
,function(self,size)
return ((self):new());
end
,"instantiation","basicNew: size\r\n\t\" Return an instance of the receiver of specified size. \"\r\n\r\n\t^self new","function(self,size)\r\nreturn ((self):new());\r\nend")

smalltalk:bind(smalltalk.KeyedCollection["$klass"],"@","_at"
,function(self,jsObject)
local result=nil
local parts=nil
if (smalltalk:isNil_((jsObject)))==true then return (nil); end;
(function()
	local _s8_value=((self):new())
	result=_s8_value
	return _s8_value
end)();

	parts = smalltalk.Array:new()
	for k,_ in pairs(jsObject) do parts:add_(k) end;
(parts):do_((function(key)
return ((result):at_put_(key,(jsObject)[key]))
end));
return (result);
end
,"instantiation","@ jsObject\r\n\t\" Return an instance of the receiver with the properties owned by jsObject (or nil). \"\r\n\r\n\t| result parts |\r\n\tjsObject isNil ifTrue: [ ^nil ].\r\n\tresult := self new.\r\n\t{'' doc'native accessing'}.\r\n\tparts do: [:key|\r\n\t\tresult at: key put: (jsObject basicAt: key)\r\n\t].\r\n\t^result","function(self,jsObject)\r\nlocal result=nil\r\nlocal parts=nil\r\nif (smalltalk:isNil_((jsObject)))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=((self):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\n\tparts = smalltalk.Array:new()\r\n\tfor k,_ in pairs(jsObject) do parts:add_(k) end;\r\n(parts):do_((function(key)\r\nreturn ((result):at_put_(key,(jsObject)[key]))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection["$klass"],"fromTuples:",0
,function(self,tuples)
local result=nil
(function()
	local _s8_value=((self):new())
	result=_s8_value
	return _s8_value
end)();
(tuples):do_((function(tuple)
return ((result):at_put_((tuple):first(),(tuple):last()))
end));
return (result);
end
,"instantiation","fromTuples: tuples\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self new.\r\n\ttuples do: [:tuple| result at: tuple first put: tuple last ].\r\n\t^result","function(self,tuples)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(tuples):do_((function(tuple)\r\nreturn ((result):at_put_((tuple):first(),(tuple):last()))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,",","_comma"
,function(self,aCollection)
return ((self):shouldNotImplement_(","));
end
,"copying",", aCollection\r\n\t\" Return a copy of the receiver with all contents of aCollection. \"\r\n\r\n\t^self shouldNotImplement: #,","function(self,aCollection)\r\nreturn ((self):shouldNotImplement_(\",\"));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"=","_eq"
,function(self,anObject)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if not ((smalltalk:isObject_equalTo_(((self)["$klass"]),(anObject)["$klass"])))==true then return (false); end;
if not ((smalltalk:isObject_equalTo_(((self):size()),(anObject):size())))==true then return (false); end;
(self):keysAndValuesDo_((function(key,value)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((anObject):at_ifAbsent_(key,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end))),value)),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"comparing","= anObject\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\tself class = anObject class ifFalse: [^false].\r\n\tself size = anObject size ifFalse: [^false].\r\n\tself keysAndValuesDo: [:key :value |\r\n\t\t(anObject at: key ifAbsent: [^false])\r\n\t\t\t= value ifFalse: [^false]\r\n\t].\r\n\t^true","function(self,anObject)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif not ((smalltalk:isObject_equalTo_(((self)[\"$klass\"]),(anObject)[\"$klass\"])))==true then return (false); end;\r\nif not ((smalltalk:isObject_equalTo_(((self):size()),(anObject):size())))==true then return (false); end;\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((anObject):at_ifAbsent_(key,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))),value)),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"add:",0
,function(self,anAssociation)
(self):at_put_((anAssociation):key(),(anAssociation):value());
return (anAssociation);
end
,"adding","add: anAssociation\r\n\t\" Bind anAssociation to the receiver. \"\r\n\r\n\tself at: anAssociation key put: anAssociation value.\r\n\t^anAssociation","function(self,anAssociation)\r\n(self):at_put_((anAssociation):key(),(anAssociation):value());\r\nreturn (anAssociation);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"addAll:",0
,function(self,aKeyedCollection)
smalltalk:superImplementor(smalltalk.KeyedCollection,"addAll_")(self,(aKeyedCollection):associations());
return (aKeyedCollection);
end
,"adding","addAll: aKeyedCollection\r\n\t\" Bind all associations in aKeyedCollection to the receiver. \"\r\n\r\n\tsuper addAll: aKeyedCollection associations.\r\n\t^aKeyedCollection","function(self,aKeyedCollection)\r\nsmalltalk:superImplementor(smalltalk.KeyedCollection,\"addAll_\")(self,(aKeyedCollection):associations());\r\nreturn (aKeyedCollection);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"newHash",0
,function(self)
return ({});
end
,"private","newHash\r\n\t\" Private - Return a new hash object. \"\r\n\r\n\t^{'' doc'native instantiation'}","function(self)\r\nreturn ({});\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"asJSONObject",0
,function(self)
local result=nil
local value=nil
(function()
	local _s8_value=((self):newHash())
	result=_s8_value
	return _s8_value
end)();
(self):keysAndValuesDo_((function(key,aValue)
(function()
	local _s8_value=(smalltalk:if_true_false_(((self):isObject_(aValue)),(function()
return ((aValue):asJSONObject())
end),(function()
return (aValue)
end)))
	value=_s8_value
	return _s8_value
end)();return (smalltalk:basic_at_put_((result),key,value))
end));
return (result);
end
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t| result value |\r\n\tresult := self newHash.\r\n\tself keysAndValuesDo: [:key :aValue |\r\n\t\tvalue := (self isObject: aValue)\r\n\t\t\tifTrue: [ aValue asJSONObject ]\r\n\t\t\tifFalse: [ aValue ].\r\n\t\tresult basicAt: key put: value\r\n\t].\r\n\t^result","function(self)\r\nlocal result=nil\r\nlocal value=nil\r\n(function()\r\n\tlocal _s8_value=((self):newHash())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):keysAndValuesDo_((function(key,aValue)\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((self):isObject_(aValue)),(function()\r\nreturn ((aValue):asJSONObject())\r\nend),(function()\r\nreturn (aValue)\r\nend)))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:basic_at_put_((result),key,value))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"associations",0
,function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(self):associationsDo_((function(each)
return ((result):add_(each))
end));
return (result);
end
,"accessing","associations\r\n\t\" Return the associations of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := Array new.\r\n\tself associationsDo: [:each| result add: each ].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):associationsDo_((function(each)\r\nreturn ((result):add_(each))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"associationsDo:",0
,function(self,aBlock)
(self):keysAndValuesDo_((function(key,value)
return ((aBlock):value_((smalltalk.Association):key_value_(key,value)))
end));
return (self);
end
,"enumerating","associationsDo: aBlock\r\n\t\" Evaluate aBlock for all the receiver's associations. \"\r\n\r\n\tself keysAndValuesDo: [:key :value|\r\n\t\taBlock value: (Association key: key value: value)\r\n\t].","function(self,aBlock)\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn ((aBlock):value_((smalltalk.Association):key_value_(key,value)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"at:",0
,function(self,aKey)
return ((self):at_ifAbsent_(aKey,(function()
return ((self):objectNotFoundAt_(aKey))
end)));
end
,"accessing","at: aKey\r\n\t\" Return the value at aKey.\r\n\tSignal an error if the key is not present.\r\n\t\"\r\n\r\n\t^self at: aKey ifAbsent: [ self objectNotFoundAt: aKey ]","function(self,aKey)\r\nreturn ((self):at_ifAbsent_(aKey,(function()\r\nreturn ((self):objectNotFoundAt_(aKey))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"at:ifAbsent:",0
,function(self,aKey,aBlock)
return ((self):implementedBySubclass_("at:ifAbsent:"));
end
,"accessing","at: aKey ifAbsent: aBlock\r\n\t\" Return the value at aKey or the result of evaluating aBlock. \"\r\n\r\n\t^self implementedBySubclass: #at:ifAbsent:","function(self,aKey,aBlock)\r\nreturn ((self):implementedBySubclass_(\"at:ifAbsent:\"));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"values",0
,function(self)
return ((self):implementedBySubclass_("values"));
end
,"accessing","values\r\n\t\" Return the values of the receiver. \"\r\n\r\n\t^self implementedBySubclass: #values","function(self)\r\nreturn ((self):implementedBySubclass_(\"values\"));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"at:ifAbsentPut:",0
,function(self,aKey,aBlock)
return ((self):at_ifAbsent_(aKey,(function()
return ((self):at_put_(aKey,(aBlock):value()))
end)));
end
,"accessing","at: aKey ifAbsentPut: aBlock\r\n\t\" Return the value at aKey, or add the result of evaluating aBlock to the receiver if it is absent. \"\r\n\r\n\t^self at: aKey ifAbsent: [ self at: aKey put: aBlock value ]","function(self,aKey,aBlock)\r\nreturn ((self):at_ifAbsent_(aKey,(function()\r\nreturn ((self):at_put_(aKey,(aBlock):value()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"at:put:",0
,function(self,aKey,aValue)
return ((self):implementedBySubclass_("at:put:"));
end
,"accessing","at: aKey put: aValue\r\n\t\" Set the value at aKey of the receiver. \"\r\n\r\n\t^self implementedBySubclass: #at:put:","function(self,aKey,aValue)\r\nreturn ((self):implementedBySubclass_(\"at:put:\"));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"detect:ifNone:",0
,function(self,aBlock,anotherBlock)
return ((self):implementedBySubclass_("detect:ifNone:"));
end
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Detect the value who matches aBlock.\r\n\tReturn the result of evaluating aBlock if no value matches detection block.\r\n\t\"\r\n\r\n\t^self implementedBySubclass: #detect:ifNone:","function(self,aBlock,anotherBlock)\r\nreturn ((self):implementedBySubclass_(\"detect:ifNone:\"));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"do:",0
,function(self,aBlock)
return ((self):implementedBySubclass_("do:"));
end
,"enumerating","do: aBlock\r\n\t\" Evaluates aBlock for all values in the receiver. \"\r\n\r\n\t^self implementedBySubclass: #do:","function(self,aBlock)\r\nreturn ((self):implementedBySubclass_(\"do:\"));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"includes:",0
,function(self,anObject)
return ((self):implementedBySubclass_("includes:"));
end
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t^self implementedBySubclass: #includes:","function(self,anObject)\r\nreturn ((self):implementedBySubclass_(\"includes:\"));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"keyForValue:ifAbsent:",0
,function(self,anObject,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):keysAndValuesDo_((function(key,value)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((anObject),value)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (key)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):value())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","keyForValue: anObject ifAbsent: aBlock\r\n\t\" Return the key in the receiver for value anObject, or the result of evaluating aBlock. \"\r\n\r\n\tself keysAndValuesDo: [:key :value| anObject = value ifTrue: [ ^key ] ].\r\n\t^aBlock value","function(self,anObject,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((anObject),value)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (key)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"keys",0
,function(self)
return ((self):implementedBySubclass_("keys"));
end
,"accessing","keys\r\n\t\" Return the keys of the receiver. \"\r\n\r\n\t^self implementedBySubclass: #keys","function(self)\r\nreturn ((self):implementedBySubclass_(\"keys\"));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"keysAndValuesDo:",0
,function(self,aBlock)
return ((self):implementedBySubclass_("keysAndValuesDo:"));
end
,"enumerating","keysAndValuesDo: aBlock\r\n\t\" Evaluate aBlock for key/value pairs of the receiver. \"\r\n\r\n\t^self implementedBySubclass: #keysAndValuesDo:","function(self,aBlock)\r\nreturn ((self):implementedBySubclass_(\"keysAndValuesDo:\"));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"keysDo:",0
,function(self,aBlock)
return ((self):implementedBySubclass_("keysDo:"));
end
,"enumerating","keysDo: aBlock\r\n\t\" Evaluate aBlock with the keys of the receiver. \"\r\n\r\n\t^self implementedBySubclass: #keysDo:","function(self,aBlock)\r\nreturn ((self):implementedBySubclass_(\"keysDo:\"));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"includesKey:",0
,function(self,aKey)
return ((self):implementedBySubclass_("includesKey:"));
end
,"testing","includesKey: aKey\r\n\t\" Return true if the receiver's keys include aKey. \"\r\n\r\n\t^self implementedBySubclass: #includesKey:","function(self,aKey)\r\nreturn ((self):implementedBySubclass_(\"includesKey:\"));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"removeKey:ifAbsent:",0
,function(self,aKey,aBlock)
return ((self):implementedBySubclass_("removeKey:ifAbsent:"));
end
,"removing","removeKey: aKey ifAbsent: aBlock\r\n\t\" Remove the binding at aKey. \"\r\n\r\n\t^self implementedBySubclass: #removeKey:ifAbsent:","function(self,aKey,aBlock)\r\nreturn ((self):implementedBySubclass_(\"removeKey:ifAbsent:\"));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"removeKeys:",0
,function(self,aCollection)
(aCollection):do_((function(each)
return ((self):removeKey_ifAbsent_(each,(function()
return (nil)
end)))
end));
return (self);
end
,"removing","removeKeys: aCollection\r\n\t\" Remove aCollection of keys in the receiver. \"\r\n\r\n\taCollection do: [:each| self removeKey: each ifAbsent: [] ]","function(self,aCollection)\r\n(aCollection):do_((function(each)\r\nreturn ((self):removeKey_ifAbsent_(each,(function()\r\nreturn (nil)\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"removeAll",0
,function(self)
(self):initialize();
return (self);
end
,"removing","removeAll\r\n\t\" Remove all elements in the receiver. \"\r\n\r\n\tself initialize","function(self)\r\n(self):initialize();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"isEmpty",0
,function(self)
return (smalltalk:isObject_equalTo_(((self):size()),0));
end
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^self size = 0","function(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):size()),0));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"at:ifPresent:",0
,function(self,aKey,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local aValue=nil
(function()
	local _s8_value=((self):at_ifAbsent_(aKey,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end)))
	aValue=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):value_(aValue))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","at: aKey ifPresent: aBlock\r\n\t\" Return the result of evaluating aBlock if there is a value at aKey (or nil). \"\r\n\r\n\t| aValue |\r\n\taValue := self at: aKey ifAbsent: [ ^nil ].\r\n\t^aBlock value: aValue","function(self,aKey,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal aValue=nil\r\n(function()\r\n\tlocal _s8_value=((self):at_ifAbsent_(aKey,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\taValue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):value_(aValue))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"at:ifPresent:ifAbsent:",0
,function(self,aKey,aBlock,anotherBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local aValue=nil
(function()
	local _s8_value=((self):at_ifAbsent_(aKey,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((anotherBlock):value())
end
)()
error(_s8Ret_,0)
end)())
end)))
	aValue=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):value_(aValue))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","at: aKey ifPresent: aBlock ifAbsent: anotherBlock\r\n\t\" Return the result of evaluating aBlock if there is a value at aKey (or the result of evaluating anotherBlock). \"\r\n\r\n\t| aValue |\r\n\taValue := self at: aKey ifAbsent: [ ^anotherBlock value ].\r\n\t^aBlock value: aValue","function(self,aKey,aBlock,anotherBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal aValue=nil\r\n(function()\r\n\tlocal _s8_value=((self):at_ifAbsent_(aKey,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((anotherBlock):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\taValue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):value_(aValue))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"collect:",0
,function(self,aBlock)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(self):keysAndValuesDo_((function(key,value)
return ((result):at_put_(key,(aBlock):value_(value)))
end));
return (result);
end
,"enumerating","collect: aBlock\r\n\t\" Return aKeyedCollection with keys and result of evaluating aBlock with value. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tself keysAndValuesDo: [:key :value |\r\n\t\tresult at: key put: (aBlock value: value)\r\n\t].\r\n\t^result","function(self,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn ((result):at_put_(key,(aBlock):value_(value)))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"select:",0
,function(self,aBlock)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(self):keysAndValuesDo_((function(key,value)
return (smalltalk:if_true_false_(((aBlock):value_(value)),(function()
return ((result):at_put_(key,value))
end),nil))
end));
return (result);
end
,"enumerating","select: aBlock\r\n\t\" Return the contents of the receiver wich evaluates aBlock to true. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tself keysAndValuesDo: [:key :value |\r\n\t\t(aBlock value: value) ifTrue: [ result at: key put: value ]\r\n\t].\r\n\t^result","function(self,aBlock)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn (smalltalk:if_true_false_(((aBlock):value_(value)),(function()\r\nreturn ((result):at_put_(key,value))\r\nend),nil))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"shallowCopy",0
,function(self)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(self):keysAndValuesDo_((function(key,value)
return ((result):at_put_(key,value))
end));
return (result);
end
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tself keysAndValuesDo: [:key :value | result at: key put: value ].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn ((result):at_put_(key,value))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"tuples",0
,function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
(self):keysAndValuesDo_((function(key,value)
return ((result):add_((smalltalk.Array):with_with_(key,value)))
end));
return (result);
end
,"accessing","tuples\r\n\t\" Return an array of tuples built from the receiver's contents. \"\r\n\r\n\t| result |\r\n\tresult := Array new.\r\n\tself keysAndValuesDo: [:key :value|\r\n\t\tresult add: (Array with: key with: value)\r\n\t].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn ((result):add_((smalltalk.Array):with_with_(key,value)))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"copyFrom:to:",0
,function(self,anIndex,anotherIndex)
return ((self):shouldNotImplement_("copyFrom:to:"));
end
,"copying","copyFrom: anIndex to: anotherIndex\r\n\t\" Return a copy of the receiver from anIndex to anotherIndex. \"\r\n\r\n\t^self shouldNotImplement: #copyFrom:to:","function(self,anIndex,anotherIndex)\r\nreturn ((self):shouldNotImplement_(\"copyFrom:to:\"));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"deepCopy",0
,function(self)
local result=nil
(function()
	local _s8_value=(((self):species()):new())
	result=_s8_value
	return _s8_value
end)();
(self):keysAndValuesDo_((function(key,value)
return ((result):at_put_(key,(value):deepCopy()))
end));
return (result);
end
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self species new.\r\n\tself keysAndValuesDo: [:key :value |\r\n\t\tresult at: key put: value deepCopy\r\n\t].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn ((result):at_put_(key,(value):deepCopy()))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"remove:",0
,function(self,aKey)
(self):removeKey_(aKey);
return (self);
end
,"removing","remove: aKey\r\n\t\" Remove the binding at aKey. \"\r\n\r\n\tself removeKey: aKey","function(self,aKey)\r\n(self):removeKey_(aKey);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"removeKey:",0
,function(self,aKey)
return ((self):removeKey_ifAbsent_(aKey,(function()
return ((self):objectNotFoundAt_(aKey))
end)));
end
,"removing","removeKey: aKey\r\n\t\" Remove the binding at aKey.\r\n\tSignal an error if the key is not present.\r\n\t\"\r\n\r\n\t^self removeKey: aKey ifAbsent: [ self objectNotFoundAt: aKey ]","function(self,aKey)\r\nreturn ((self):removeKey_ifAbsent_(aKey,(function()\r\nreturn ((self):objectNotFoundAt_(aKey))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"printString",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((((self)["$klass"]):name())," fromTuples: ")),((self):tuples()):asLiteral()));
end
,"converting","printString\r\n\t\" Return a printable representation of the receiver. \"\r\n\r\n\t^self class name ,' fromTuples: ' ,self tuples asLiteral","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((((self)[\"$klass\"]):name()),\" fromTuples: \")),((self):tuples()):asLiteral()));\r\nend")

smalltalk:bind(smalltalk.KeyedCollection,"isDictionary",0
,function(self)
return (true);
end
,"testing","isDictionary\r\n\t\" Return true if the receiver is a dictionary. \"\r\n\r\n\t^true","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.Object,"isDictionary",0
,function(self)
return (false);
end
,"testing","isDictionary\r\n\t\" Return true if the receiver is a dictionary. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.Dictionary["$klass"],"basicNew",0
,function(self)
if true then return smalltalk.PoolDictionary:new() end;
return (smalltalk:superImplementor(smalltalk.Dictionary["$klass"],"basicNew")(self));
end
,"instantiation","basicNew\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'self' doc'native instantiation'}.\r\n\t^super basicNew","function(self)\r\nif true then return smalltalk.PoolDictionary:new() end;\r\nreturn (smalltalk:superImplementor(smalltalk.Dictionary[\"$klass\"],\"basicNew\")(self));\r\nend")

smalltalk:bind(smalltalk.Dictionary["$klass"],"fromKeys:and:",0
,function(self,keys,values)
return (((self):basicNew()):initializeKeys_values_(keys,values));
end
,"instantiation","fromKeys: keys and: values\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew initializeKeys: keys values: values","function(self,keys,values)\r\nreturn (((self):basicNew()):initializeKeys_values_(keys,values));\r\nend")

smalltalk:bind(smalltalk.Dictionary,"initialize",0
,function(self)
smalltalk:superImplementor(smalltalk.Dictionary,"initialize")(self);
(function()
	local _s8_value=((smalltalk.HashedSet):new())
	self["@keys"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:newArray({}))
	self["@values"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initialize\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsuper initialize.\r\n\tkeys := HashedSet new.\r\n\tvalues := #().","function(self)\r\nsmalltalk:superImplementor(smalltalk.Dictionary,\"initialize\")(self);\r\n(function()\r\n\tlocal _s8_value=((smalltalk.HashedSet):new())\r\n\tself[\"@keys\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tself[\"@values\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Dictionary,"initializeKeys:values:",0
,function(self,privateKeys,privateValues)
smalltalk:superImplementor(smalltalk.Dictionary,"initialize")(self);
(function()
	local _s8_value=((smalltalk.HashedSet):newContents_(privateKeys))
	self["@keys"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((privateValues):asArray())
	self["@values"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeKeys: privateKeys values: privateValues\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsuper initialize.\r\n\tkeys := HashedSet newContents: privateKeys.\r\n\tvalues := privateValues asArray.","function(self,privateKeys,privateValues)\r\nsmalltalk:superImplementor(smalltalk.Dictionary,\"initialize\")(self);\r\n(function()\r\n\tlocal _s8_value=((smalltalk.HashedSet):newContents_(privateKeys))\r\n\tself[\"@keys\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((privateValues):asArray())\r\n\tself[\"@values\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Dictionary,"size",0
,function(self)
return ((self["@keys"]):size());
end
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^keys size","function(self)\r\nreturn ((self[\"@keys\"]):size());\r\nend")

smalltalk:bind(smalltalk.Dictionary,"isEmpty",0
,function(self)
return ((self["@keys"]):isEmpty());
end
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^keys isEmpty","function(self)\r\nreturn ((self[\"@keys\"]):isEmpty());\r\nend")

smalltalk:bind(smalltalk.Dictionary,"lookUpKey:",0
,function(self,aKey)
return ((self["@keys"]):indexOf_ifAbsent_(aKey,(function()
return (nil)
end)));
end
,"private","lookUpKey: aKey\r\n\t\" Private - Return the index where aKey is found (or nil). \"\r\n\r\n\t^keys indexOf: aKey ifAbsent: [ nil ]","function(self,aKey)\r\nreturn ((self[\"@keys\"]):indexOf_ifAbsent_(aKey,(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Dictionary,"keysAndValuesDo:",0
,function(self,aBlock)
(self["@keys"]):withIndexDo_((function(aKey,index)
return ((aBlock):value_value_(aKey,(self["@values"]):at_(index)))
end));
return (self);
end
,"enumerating","keysAndValuesDo: aBlock\r\n\t\" Evaluate aBlock for key/value pairs of the receiver. \"\r\n\r\n\tkeys withIndexDo: [:aKey :index | aBlock value: aKey value: (values at: index) ]","function(self,aBlock)\r\n(self[\"@keys\"]):withIndexDo_((function(aKey,index)\r\nreturn ((aBlock):value_value_(aKey,(self[\"@values\"]):at_(index)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Dictionary,"keys",0
,function(self)
return ((self["@keys"]):copy());
end
,"accessing","keys\r\n\t\" Return the keys of the receiver. \"\r\n\r\n\t^keys copy","function(self)\r\nreturn ((self[\"@keys\"]):copy());\r\nend")

smalltalk:bind(smalltalk.Dictionary,"keysDo:",0
,function(self,aBlock)
(self["@keys"]):do_(aBlock);
return (self);
end
,"enumerating","keysDo: aBlock\r\n\t\" Evaluate aBlock with the keys of the receiver. \"\r\n\r\n\tkeys do: aBlock","function(self,aBlock)\r\n(self[\"@keys\"]):do_(aBlock);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Dictionary,"values",0
,function(self)
return ((self["@values"]):copy());
end
,"accessing","values\r\n\t\" Return the values of the receiver. \"\r\n\r\n\t^values copy","function(self)\r\nreturn ((self[\"@values\"]):copy());\r\nend")

smalltalk:bind(smalltalk.Dictionary,"at:put:",0
,function(self,aKey,aValue)
local index=nil
(function()
	local _s8_value=((self):lookUpKey_(aKey))
	index=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((index)))==true then (self["@keys"]):add_(aKey);
(self["@values"]):add_(aValue); else (self["@values"]):at_put_(index,aValue); end;
return (aValue);
end
,"accessing","at: aKey put: aValue\r\n\t\" Set the value at aKey of the receiver. \"\r\n\r\n\t| index |\r\n\tindex := self lookUpKey: aKey.\r\n\tindex isNil\r\n\t\tifTrue: [ keys add: aKey. values add: aValue.]\r\n\t\tifFalse: [ values at: index put: aValue ].\r\n\t^aValue","function(self,aKey,aValue)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):lookUpKey_(aKey))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((index)))==true then (self[\"@keys\"]):add_(aKey);\r\n(self[\"@values\"]):add_(aValue); else (self[\"@values\"]):at_put_(index,aValue); end;\r\nreturn (aValue);\r\nend")

smalltalk:bind(smalltalk.Dictionary,"at:ifAbsent:",0
,function(self,aKey,aBlock)
local index=nil
(function()
	local _s8_value=((self):lookUpKey_(aKey))
	index=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((index)))==true then return ((aBlock):value()); end;
return ((self["@values"]):at_(index));
end
,"accessing","at: aKey ifAbsent: aBlock\r\n\t\" Return the value at aKey or the result of evaluating aBlock. \"\r\n\r\n\t| index |\r\n\tindex := self lookUpKey: aKey.\r\n\tindex isNil ifTrue: [ ^aBlock value ].\r\n\t^values at: index","function(self,aKey,aBlock)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):lookUpKey_(aKey))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((index)))==true then return ((aBlock):value()); end;\r\nreturn ((self[\"@values\"]):at_(index));\r\nend")

smalltalk:bind(smalltalk.Dictionary,"at:ifAbsentPut:",0
,function(self,aKey,aBlock)
local index=nil
(function()
	local _s8_value=((self):lookUpKey_(aKey))
	index=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((index)))==true then return ((self):at_put_(aKey,(aBlock):value())); end;
return ((self["@values"]):at_(index));
end
,"accessing","at: aKey ifAbsentPut: aBlock\r\n\t\" Return the value at aKey, or add the result of evaluating aBlock to the receiver if it is absent. \"\r\n\r\n\t| index |\r\n\tindex := self lookUpKey: aKey.\r\n\tindex isNil ifTrue: [ ^self at: aKey put: aBlock value ].\r\n\t^values at: index","function(self,aKey,aBlock)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):lookUpKey_(aKey))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((index)))==true then return ((self):at_put_(aKey,(aBlock):value())); end;\r\nreturn ((self[\"@values\"]):at_(index));\r\nend")

smalltalk:bind(smalltalk.Dictionary,"do:",0
,function(self,aBlock)
return ((self["@values"]):do_(aBlock));
end
,"enumerating","do: aBlock\r\n\t\" Evaluates aBlock for all values in the receiver. \"\r\n\r\n\t^values do: aBlock","function(self,aBlock)\r\nreturn ((self[\"@values\"]):do_(aBlock));\r\nend")

smalltalk:bind(smalltalk.Dictionary,"detect:ifNone:",0
,function(self,aBlock,anotherBlock)
return ((self["@values"]):detect_ifNone_(aBlock,anotherBlock));
end
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Detect the value who matches aBlock.\r\n\tReturn the result of evaluating aBlock if no value matches detection block.\r\n\t\"\r\n\r\n\t^values detect: aBlock ifNone: anotherBlock","function(self,aBlock,anotherBlock)\r\nreturn ((self[\"@values\"]):detect_ifNone_(aBlock,anotherBlock));\r\nend")

smalltalk:bind(smalltalk.Dictionary,"includes:",0
,function(self,anObject)
return ((self["@values"]):includes_(anObject));
end
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t^values includes: anObject","function(self,anObject)\r\nreturn ((self[\"@values\"]):includes_(anObject));\r\nend")

smalltalk:bind(smalltalk.Dictionary,"includesKey:",0
,function(self,aKey)
return ((self["@keys"]):includes_(aKey));
end
,"enumerating","includesKey: aKey\r\n\t\" Return true if the receiver's keys include aKey. \"\r\n\r\n\t^keys includes: aKey","function(self,aKey)\r\nreturn ((self[\"@keys\"]):includes_(aKey));\r\nend")

smalltalk:bind(smalltalk.Dictionary,"removeKey:ifAbsent:",0
,function(self,aKey,aBlock)
local index=nil
(function()
	local _s8_value=((self):lookUpKey_(aKey))
	index=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((index)))==true then return ((aBlock):value()); end;
(self["@keys"]):removeIndex_(index);
(self["@values"]):removeIndex_(index);
return (self);
end
,"removing","removeKey: aKey ifAbsent: aBlock\r\n\t\" Remove the binding at aKey. \"\r\n\r\n\t| index |\r\n\tindex := self lookUpKey: aKey.\r\n\tindex isNil ifTrue: [ ^aBlock value ].\r\n\tkeys removeIndex: index.\r\n\tvalues removeIndex: index.","function(self,aKey,aBlock)\r\nlocal index=nil\r\n(function()\r\n\tlocal _s8_value=((self):lookUpKey_(aKey))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((index)))==true then return ((aBlock):value()); end;\r\n(self[\"@keys\"]):removeIndex_(index);\r\n(self[\"@values\"]):removeIndex_(index);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Dictionary,"keyForValue:ifAbsent:",0
,function(self,anObject,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):keysAndValuesDo_((function(key,aValue)
return (smalltalk:if_true_false_((((anObject)==aValue)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (key)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):value())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","keyForValue: anObject ifAbsent: aBlock\r\n\t\" Return the key in the receiver for value anObject, or the result of evaluating aBlock. \"\r\n\r\n\tself keysAndValuesDo: [:key :aValue| anObject == aValue ifTrue: [ ^key ] ].\r\n\t^aBlock value","function(self,anObject,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):keysAndValuesDo_((function(key,aValue)\r\nreturn (smalltalk:if_true_false_((((anObject)==aValue)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (key)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Dictionary,"asNative:",0
,function(self,lang)
local send=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((lang),"lua")),(function()
return (":")
end),(function()
return (".")
end)))
	send=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),((self)["$klass"]):name())),send)),"fromKeys_and_(")),((self["@keys"]):asArray()):asNative_(lang))),",")),(self["@values"]):asNative_(lang))),")"));
end
,"converting","asNative: lang\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t| send |\r\n\tsend := lang = #lua ifTrue: [$:] ifFalse: [$.].\r\n\t^'smalltalk.' ,self class name\r\n\t\t,send ,'fromKeys_and_('\r\n\t\t\t,(keys asArray asNative: lang)\r\n\t\t\t,',' ,(values asNative: lang)\r\n\t\t,')'","function(self,lang)\r\nlocal send=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((lang),\"lua\")),(function()\r\nreturn (\":\")\r\nend),(function()\r\nreturn (\".\")\r\nend)))\r\n\tsend=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),((self)[\"$klass\"]):name())),send)),\"fromKeys_and_(\")),((self[\"@keys\"]):asArray()):asNative_(lang))),\",\")),(self[\"@values\"]):asNative_(lang))),\")\"));\r\nend")

smalltalk:bind(smalltalk.PoolDictionary["$klass"],"@@","_at_at"
,function(self,aHash)
return ((
function(_s8_rec)
	(_s8_rec):instVarAt_put_("hash",aHash);
	return ((_s8_rec):yourself())
end
)((self):basicNew()));
end
,"instantiation","@@ aHash\r\n\t\" Return an instance of the receiver. \"\r\n\t\" The instance will hack aHash violating encapsulation of aHash and instance.\r\n\t Both will share internal state. \"\r\n\r\n\t^self basicNew\r\n\t\tinstVarAt: #hash put: aHash;\r\n\t\tyourself","function(self,aHash)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):instVarAt_put_(\"hash\",aHash);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):basicNew()));\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"initialize",0
,function(self)
smalltalk:superImplementor(smalltalk.PoolDictionary,"initialize")(self);
(function()
	local _s8_value=((self):newHash())
	self["@hash"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initialize\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsuper initialize.\r\n\thash := self newHash.","function(self)\r\nsmalltalk:superImplementor(smalltalk.PoolDictionary,\"initialize\")(self);\r\n(function()\r\n\tlocal _s8_value=((self):newHash())\r\n\tself[\"@hash\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"validKey:",0
,function(self,aKey)

return (aKey);
end
,"initialize","validKey: aKey\r\n\t\" Private - Returns a valid key to store a value in the receiver. \"\r\n\r\n\t{'self'}.\r\n\t\"(self typeOf: aKey) = #string ifFalse: [ ^self error: 'Invalid key (must be aString).' ].\"\r\n\t^aKey ","function(self,aKey)\r\n\r\nreturn (aKey);\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"at:put:",0
,function(self,aKey,aValue)
(function()
	local _s8_value=(nil)
	self["@size"]=_s8_value
	return _s8_value
end)();

smalltalk:basic_at_put_((self["@hash"]),(self):validKey_(aKey),(self):wrap_(aValue));
return (aValue);
end
,"accessing","at: aKey put: aValue\r\n\t\" Set the value at aKey of the receiver. \"\r\n\r\n\tsize := nil.\r\n\t{'self'}.\r\n\thash\tbasicAt: (self validKey: aKey)\r\n\t\tput: (self wrap: aValue).\r\n\t^aValue","function(self,aKey,aValue)\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@size\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\nsmalltalk:basic_at_put_((self[\"@hash\"]),(self):validKey_(aKey),(self):wrap_(aValue));\r\nreturn (aValue);\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"removeKey:ifAbsent:",0
,function(self,aKey,aBlock)
if not (((self):includesKey_(aKey)))==true then return ((aBlock):value()); end;
(function()
	local _s8_value=(nil)
	self["@size"]=_s8_value
	return _s8_value
end)();
self["@hash"][self:wrap_(aKey)]=nil;
return (self);
end
,"removing","removeKey: aKey ifAbsent: aBlock\r\n\t\" Remove the binding at aKey. \"\r\n\r\n\t(self includesKey: aKey) ifFalse: [ ^aBlock value ].\r\n\tsize := nil.\r\n\t{'' doc'native remotion'}","function(self,aKey,aBlock)\r\nif not (((self):includesKey_(aKey)))==true then return ((aBlock):value()); end;\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@size\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nself[\"@hash\"][self:wrap_(aKey)]=nil;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"size",0
,function(self)
if (smalltalk:isNil_((self["@size"])))==true then (function()
	local _s8_value=(((self):keys()):size())
	self["@size"]=_s8_value
	return _s8_value
end)(); end;
return (self["@size"]);
end
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\tsize isNil ifTrue: [ size := self keys size ].\r\n\t^size","function(self)\r\nif (smalltalk:isNil_((self[\"@size\"])))==true then (function()\r\n\tlocal _s8_value=(((self):keys()):size())\r\n\tself[\"@size\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@size\"]);\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"at:ifAbsent:",0
,function(self,aKey,aBlock)

	local found = self["@hash"][self:wrap_(aKey)]
	if found~=nil
		then return self:unwrap_(found)
		else return aBlock:value()
	end;
return (self);
end
,"accessing","at: aKey ifAbsent: aBlock\r\n\t\" Return the value at aKey or the result of evaluating aBlock. \"\r\n\r\n\t{'' doc'native indexing'}","function(self,aKey,aBlock)\r\n\r\n\tlocal found = self[\"@hash\"][self:wrap_(aKey)]\r\n\tif found~=nil\r\n\t\tthen return self:unwrap_(found)\r\n\t\telse return aBlock:value()\r\n\tend;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"includesKey:",0
,function(self,aKey)
return (self["@hash"][self:wrap_(aKey)]~=nil);
end
,"testing","includesKey: aKey\r\n\t\" Return true if the receiver's keys include aKey. \"\r\n\r\n\t^{'' doc'native testing'}","function(self,aKey)\r\nreturn (self[\"@hash\"][self:wrap_(aKey)]~=nil);\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"keys",0
,function(self)

	local result=smalltalk.Array:new()
	for k,_ in pairs(self["@hash"]) do result:add_(k) end
	if true then return result end;
return (self);
end
,"accessing","keys\r\n\t\" Return the keys of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","function(self)\r\n\r\n\tlocal result=smalltalk.Array:new()\r\n\tfor k,_ in pairs(self[\"@hash\"]) do result:add_(k) end\r\n\tif true then return result end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"keysAndValuesDo:",0
,function(self,aBlock)
(self):keysDo_((function(key)
return ((aBlock):value_value_(key,(self):at_(key)))
end));
return (self);
end
,"enumerating","keysAndValuesDo: aBlock\r\n\t\" Evaluate aBlock for key/value pairs of the receiver. \"\r\n\r\n\tself keysDo: [:key |\r\n\t\taBlock value: key value: (self at: key)\r\n\t]","function(self,aBlock)\r\n(self):keysDo_((function(key)\r\nreturn ((aBlock):value_value_(key,(self):at_(key)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"values",0
,function(self)
return (((self):keys()):collect_((function(key)
return ((self):at_(key))
end)));
end
,"accessing","values\r\n\t\" Return the values of the receiver. \"\r\n\r\n\t^self keys collect: [:key| self at: key ]","function(self)\r\nreturn (((self):keys()):collect_((function(key)\r\nreturn ((self):at_(key))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"asNative:",0
,function(self,lang)
local send=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((lang),"lua")),(function()
return (":")
end),(function()
return (".")
end)))
	send=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),((self)["$klass"]):name())),send)),"fromTuples_(")),((self):tuples()):asNative_(lang))),")"));
end
,"converting","asNative: lang\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t| send |\r\n\tsend := lang = #lua ifTrue: [$:] ifFalse: [$.].\r\n\t^'smalltalk.' ,self class name\r\n\t\t,send ,'fromTuples_('\r\n\t\t,(self tuples asNative: lang)\r\n\t\t,')'","function(self,lang)\r\nlocal send=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_((lang),\"lua\")),(function()\r\nreturn (\":\")\r\nend),(function()\r\nreturn (\".\")\r\nend)))\r\n\tsend=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),((self)[\"$klass\"]):name())),send)),\"fromTuples_(\")),((self):tuples()):asNative_(lang))),\")\"));\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"detect:ifNone:",0
,function(self,aBlock,anotherBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):keysAndValuesDo_((function(key,value)
return (smalltalk:if_true_false_(((aBlock):value_(value)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (value)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((anotherBlock):value())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"enumerating","detect: aBlock ifNone: anotherBlock\r\n\t\" Detect the value who matches aBlock.\r\n\tReturn the result of evaluating aBlock if no value matches detection block.\r\n\t\"\r\n\r\n\tself keysAndValuesDo: [:key :value |\r\n\t\t(aBlock value: value) ifTrue: [ ^value ]\r\n\t].\r\n\t^anotherBlock value","function(self,aBlock,anotherBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn (smalltalk:if_true_false_(((aBlock):value_(value)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (value)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((anotherBlock):value())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"do:",0
,function(self,aBlock)
(self):keysAndValuesDo_((function(key,value)
return ((aBlock):value_(value))
end));
return (self);
end
,"enumerating","do: aBlock\r\n\t\" Evaluates aBlock for all values in the receiver. \"\r\n\r\n\tself keysAndValuesDo: [:key :value | aBlock value: value ]","function(self,aBlock)\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn ((aBlock):value_(value))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"includes:",0
,function(self,anObject)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):keysAndValuesDo_((function(key,value)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((anObject),value)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\tself keysAndValuesDo: [:key :value |\r\n\t\tanObject = value ifTrue: [ ^true ].\r\n\t].\r\n\t^false","function(self,anObject)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):keysAndValuesDo_((function(key,value)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((anObject),value)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"keysDo:",0
,function(self,aBlock)
((self):keys()):do_(aBlock);
return (self);
end
,"enumerating","keysDo: aBlock\r\n\t\" Evaluate aBlock with the keys of the receiver. \"\r\n\r\n\tself keys do: aBlock","function(self,aBlock)\r\n((self):keys()):do_(aBlock);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"@","_at"
,function(self,keyOrPath)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
if not (((keyOrPath):isArray()))==true then return ((self):at_ifAbsent_(keyOrPath,(function()
return (nil)
end))); end;
(function()
	local _s8_value=((keyOrPath):inject_into_(self,(function(pool,key)
local value=nil
if (smalltalk:isNil_((((function()
	local _s8_value=((pool):_at(key))
	value=_s8_value
	return _s8_value
end)()))))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)(); end;return (value)
end)))
	result=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","@ keyOrPath\r\n\t\" Return the result of accessing the receiver at key or path (or nil). \"\r\n\r\n\t| result |\r\n\tkeyOrPath isArray ifFalse: [ ^self at: keyOrPath ifAbsent: [] ].\r\n\tresult := keyOrPath inject: self into: [:pool :key | | value |\r\n\t\t(value := pool @ key) isNil ifTrue: [ ^nil ].\r\n\t\tvalue\r\n\t].\r\n\t^result","function(self,keyOrPath)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\nif not (((keyOrPath):isArray()))==true then return ((self):at_ifAbsent_(keyOrPath,(function()\r\nreturn (nil)\r\nend))); end;\r\n(function()\r\n\tlocal _s8_value=((keyOrPath):inject_into_(self,(function(pool,key)\r\nlocal value=nil\r\nif (smalltalk:isNil_((((function()\r\n\tlocal _s8_value=((pool):_at(key))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)()))))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return (value)\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:addClass("ClassBuilder",smalltalk.Object,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.ClassBuilder,"superclass:subclass:",0
,function(self,aClass,aString)
return ((self):superclass_subclass_instanceVariableNames_category_(aClass,aString,"",nil));
end
,"instantiation","superclass: aClass subclass: aString\r\n\t\" Create/Register a new class in the system. \"\r\n\r\n\t^self\r\n\t\tsuperclass: aClass\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: ''\r\n\t\tcategory: nil","function(self,aClass,aString)\r\nreturn ((self):superclass_subclass_instanceVariableNames_category_(aClass,aString,\"\",nil));\r\nend")

smalltalk:bind(smalltalk.ClassBuilder,"superclass:subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:",0
,function(self,aClass,aString,aString2,classVarNames,poolVarNames,aString3)
local result=nil
local aCategory=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aString3))),(function()
return (smalltalk:if_true_false_((smalltalk:isNil_((aClass))),(function()
return ("unclassified")
end),(function()
return ((aClass):category())
end)))
end),(function()
return (aString3)
end)))
	aCategory=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):addSubclassOf_named_instanceVariableNames_(aClass,aString,(self):instanceVariableNamesFor_(aString2)))
	result=_s8_value
	return _s8_value
end)();
(self):setupClass_(result);
(
function(_s8_rec)
	(_s8_rec):classVariableNames_(classVarNames);
	(_s8_rec):poolDictionaryNames_(poolVarNames);
	return ((_s8_rec):category_(aCategory))
end
)(result);
if (smalltalk:boolean_and_((smalltalk:notNil_((aClass))),(function()
return ((smalltalk.Smalltalk):includesKey_("Exporter"))
end)))==true then (self):print_(((smalltalk.Exporter):new()):exportNew_(result)); end;
return (result);
end
,"instantiation","superclass: aClass\r\n\tsubclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\tpoolDictionaries: poolVarNames\r\n\tcategory: aString3\r\n\t\" Create/Register a new class in the system. \"\r\n\r\n\t| result aCategory |\r\n\taCategory := aString3 isNil ifTrue: [\r\n\t\t\taClass isNil ifTrue: [ #unclassified ]\r\n\t\t\tifFalse: [ aClass category ]\r\n\t\t] ifFalse: [ aString3 ].\r\n\tresult := self\r\n\t\taddSubclassOf: aClass named: aString\r\n\t\tinstanceVariableNames: (self instanceVariableNamesFor: aString2).\r\n\tself setupClass: result.\r\n\tresult \r\n\t\tclassVariableNames: classVarNames;\r\n\t\tpoolDictionaryNames: poolVarNames;\r\n\t\tcategory: aCategory.\r\n\t(aClass notNil and: [ Smalltalk includesKey: #Exporter ]) ifTrue: [\r\n\t\tself print: (Exporter new exportNew: result)\r\n\t].\r\n\t^result","function(self,aClass,aString,aString2,classVarNames,poolVarNames,aString3)\r\nlocal result=nil\r\nlocal aCategory=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aString3))),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((aClass))),(function()\r\nreturn (\"unclassified\")\r\nend),(function()\r\nreturn ((aClass):category())\r\nend)))\r\nend),(function()\r\nreturn (aString3)\r\nend)))\r\n\taCategory=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):addSubclassOf_named_instanceVariableNames_(aClass,aString,(self):instanceVariableNamesFor_(aString2)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):setupClass_(result);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):classVariableNames_(classVarNames);\r\n\t(_s8_rec):poolDictionaryNames_(poolVarNames);\r\n\treturn ((_s8_rec):category_(aCategory))\r\nend\r\n)(result);\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((aClass))),(function()\r\nreturn ((smalltalk.Smalltalk):includesKey_(\"Exporter\"))\r\nend)))==true then (self):print_(((smalltalk.Exporter):new()):exportNew_(result)); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.ClassBuilder,"superclass:subclass:instanceVariableNames:category:",0
,function(self,aClass,aString,aString2,aString3)
return ((self):superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aClass,aString,aString2,"","",aString3));
end
,"instantiation","superclass: aClass\r\n\tsubclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tcategory: aString3\r\n\t\" Create/Register a new class in the system. \"\r\n\r\n\t^self\r\n\t\tsuperclass: aClass\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: ''\r\n\t\tpoolDictionaries: ''\r\n\t\tcategory: aString3","function(self,aClass,aString,aString2,aString3)\r\nreturn ((self):superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aClass,aString,aString2,\"\",\"\",aString3));\r\nend")

smalltalk:bind(smalltalk.ClassBuilder,"class:comment:",0
,function(self,aClass,aString)
if (smalltalk:boolean_or_((smalltalk:isNil_((aClass))),(function()
return (smalltalk:isObject_equalTo_(((aClass):comment()),aString))
end)))==true then return (self); end;
(aClass):basicComment_(aString);
if ((smalltalk.Smalltalk):includesKey_("Exporter"))==true then (self):print_(((smalltalk.Exporter):new()):exportCommentOf_(aClass)); end;
return (self);
end
,"edition","class: aClass comment: aString\r\n\t\" Set/Register the class comment in the system. \"\r\n\r\n\t(aClass isNil or: [ aClass comment = aString ]) ifTrue: [ ^self ].\r\n\taClass basicComment: aString.\r\n\t(Smalltalk includesKey: #Exporter) ifTrue: [\r\n\t\tself print: (Exporter new exportCommentOf: aClass)\r\n\t].","function(self,aClass,aString)\r\nif (smalltalk:boolean_or_((smalltalk:isNil_((aClass))),(function()\r\nreturn (smalltalk:isObject_equalTo_(((aClass):comment()),aString))\r\nend)))==true then return (self); end;\r\n(aClass):basicComment_(aString);\r\nif ((smalltalk.Smalltalk):includesKey_(\"Exporter\"))==true then (self):print_(((smalltalk.Exporter):new()):exportCommentOf_(aClass)); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ClassBuilder,"basicClass:instanceVariableNames:",0
,function(self,aMetaClass,anArray)
return (((self):smalltalk()):metaVarNames(aMetaClass,anArray));
end
,"private","basicClass: aMetaClass instanceVariableNames: anArray\r\n\t\" Private - Register instance variables onto aMetaClass. \"\r\n\r\n\t^self smalltalk #metaVarNames: aMetaClass array: anArray","function(self,aMetaClass,anArray)\r\nreturn (((self):smalltalk()):metaVarNames(aMetaClass,anArray));\r\nend")

smalltalk:bind(smalltalk.ClassBuilder,"class:instanceVariableNames:",0
,function(self,aMetaClass,aString)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local varNames=nil
if not (((aMetaClass):isMetaclass()))==true then return ((self):error_(smalltalk:object_comma_(((aMetaClass):name())," is not a metaclass"))); end;
(function()
	local _s8_value=((self):instanceVariableNamesFor_(aString))
	varNames=_s8_value
	return _s8_value
end)();
if not ((smalltalk:isObject_equalTo_((varNames),(aMetaClass):instanceVariableNames())))==true then smalltalk:if_true_false_(((self):basicClass_instanceVariableNames_(aMetaClass,varNames)),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)); end;
(self):setupClass_(aMetaClass);
if ((smalltalk.Smalltalk):includesKey_("Exporter"))==true then (self):print_(((smalltalk.Exporter):new()):exportMetaDefinitionOf_((aMetaClass):instanceClass())); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"metaclass","class: aMetaClass instanceVariableNames: aString\r\n\t\" Register instance variable names onto aMetaClass. \"\r\n\r\n\t| varNames |\r\n\taMetaClass isMetaclass ifFalse: [\r\n\t\t^self error: aMetaClass name, ' is not a metaclass'\r\n\t].\r\n\tvarNames := self instanceVariableNamesFor: aString.\r\n\tvarNames = aMetaClass instanceVariableNames ifFalse: [\r\n\t\t(self basicClass: aMetaClass instanceVariableNames: varNames) ifFalse: [ ^false ].\r\n\t].\r\n\tself setupClass: aMetaClass.\r\n\t(Smalltalk includesKey: #Exporter) ifTrue: [\r\n\t\tself print: (Exporter new exportMetaDefinitionOf: aMetaClass instanceClass)\r\n\t].\r\n\t^true ","function(self,aMetaClass,aString)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal varNames=nil\r\nif not (((aMetaClass):isMetaclass()))==true then return ((self):error_(smalltalk:object_comma_(((aMetaClass):name()),\" is not a metaclass\"))); end;\r\n(function()\r\n\tlocal _s8_value=((self):instanceVariableNamesFor_(aString))\r\n\tvarNames=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:isObject_equalTo_((varNames),(aMetaClass):instanceVariableNames())))==true then smalltalk:if_true_false_(((self):basicClass_instanceVariableNames_(aMetaClass,varNames)),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)); end;\r\n(self):setupClass_(aMetaClass);\r\nif ((smalltalk.Smalltalk):includesKey_(\"Exporter\"))==true then (self):print_(((smalltalk.Exporter):new()):exportMetaDefinitionOf_((aMetaClass):instanceClass())); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ClassBuilder,"instanceVariableNamesFor:",0
,function(self,aString)
local result=nil
(function()
	local _s8_value=((aString):asArrayOfSubstrings())
	result=_s8_value
	return _s8_value
end)();
if not ((smalltalk:isObject_equalTo_(((result):size()),((result):asSet()):size())))==true then return ((self):error_(smalltalk:object_comma_(("Invalid instance variable names "),(result):asLiteral()))); end;
return (result);
end
,"private","instanceVariableNamesFor: aString\r\n\t\" Private - Return the instance variable names string. \"\r\n\r\n\t| result |\r\n\tresult := aString asArrayOfSubstrings.\r\n\tresult size = result asSet size ifFalse: [\r\n\t\t^self error: 'Invalid instance variable names ' ,result asLiteral\r\n\t].\r\n\t^result","function(self,aString)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((aString):asArrayOfSubstrings())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((smalltalk:isObject_equalTo_(((result):size()),((result):asSet()):size())))==true then return ((self):error_(smalltalk:object_comma_((\"Invalid instance variable names \"),(result):asLiteral()))); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.ClassBuilder,"addSubclassOf:named:instanceVariableNames:",0
,function(self,aClass,aString,aCollection)

	smalltalk:addClass(aString, aClass, aCollection)
	if true then return smalltalk[aString] end;
return (self);
end
,"private","addSubclassOf: aClass named: aString instanceVariableNames: aCollection\r\n\t\" Private - Add the subclass to system. \"\r\n\r\n\t{'' doc'native instantiation'}","function(self,aClass,aString,aCollection)\r\n\r\n\tsmalltalk:addClass(aString, aClass, aCollection)\r\n\tif true then return smalltalk[aString] end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ClassBuilder,"setupClass:",0
,function(self,aClass)
return (self);
end
,"private","setupClass: aClass\r\n\t\" Private - Bind/initialize the class delegation chain. \"","function(self,aClass)\r\nreturn (self);\r\nend")

smalltalk:addClass("Stream",smalltalk.Object,smalltalk:newArray({"collection","position","readLimit"}),"Kernel")

smalltalk:bind(smalltalk.Stream,"collection",0
,function(self)
return (self["@collection"]);
end
,"accessing","collection\r\n\t\" Private - Return the collection of the receiver. \"\r\n\r\n\t^collection","function(self)\r\nreturn (self[\"@collection\"]);\r\nend")

smalltalk:bind(smalltalk.Stream,"collection:",0
,function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@collection"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","collection: aCollection\r\n\t\" Private - Set the collection of the receiver. \"\r\n\r\n\tcollection := aCollection","function(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@collection\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"setCollection:",0
,function(self,aCollection)
(self):collection_(aCollection);
return (self);
end
,"accessing","setCollection: aCollection\r\n\t\" Private - Set the receiver stream collection to aCollection. \"\r\n\r\n\tself collection: aCollection","function(self,aCollection)\r\n(self):collection_(aCollection);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"initialize",0
,function(self)
smalltalk:superImplementor(smalltalk.Stream,"initialize")(self);
(function()
	local _s8_value=(0)
	self["@position"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initialize\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsuper initialize.\r\n\tposition := 0.","function(self)\r\nsmalltalk:superImplementor(smalltalk.Stream,\"initialize\")(self);\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tself[\"@position\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"position",0
,function(self)
return (self["@position"]);
end
,"accessing","position\r\n\t\" Return the position of the receiver. \"\r\n\r\n\t^position","function(self)\r\nreturn (self[\"@position\"]);\r\nend")

smalltalk:bind(smalltalk.Stream,"position:",0
,function(self,anInteger)
(function()
	local _s8_value=(anInteger)
	self["@position"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","position: anInteger\r\n\t\" Set the position of the receiver. \"\r\n\r\n\tposition := anInteger","function(self,anInteger)\r\n(function()\r\n\tlocal _s8_value=(anInteger)\r\n\tself[\"@position\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"readLimit",0
,function(self)
if (((self["@readLimit"])==nil))==true then (function()
	local _s8_value=(((self):collection()):size())
	self["@readLimit"]=_s8_value
	return _s8_value
end)(); end;
return (self["@readLimit"]);
end
,"accessing","readLimit\r\n\t\" Private - Return the read limit of the receiver. \"\r\n\r\n\treadLimit == nil ifTrue: [ readLimit := self collection size ].\r\n\t^readLimit","function(self)\r\nif (((self[\"@readLimit\"])==nil))==true then (function()\r\n\tlocal _s8_value=(((self):collection()):size())\r\n\tself[\"@readLimit\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@readLimit\"]);\r\nend")

smalltalk:bind(smalltalk.Stream,"readLimit:",0
,function(self,anInteger)
(function()
	local _s8_value=(anInteger)
	self["@readLimit"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","readLimit: anInteger\r\n\t\" Private - Set the stream size of the receiver. \"\r\n\r\n\treadLimit := anInteger","function(self,anInteger)\r\n(function()\r\n\tlocal _s8_value=(anInteger)\r\n\tself[\"@readLimit\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"contents",0
,function(self)
local result=nil
(function()
	local _s8_value=((self):collection())
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((self):readLimit()),(result):size()))==true then return (result); end;
return ((result):copyFrom_to_(1,(self):readLimit()));
end
,"accessing","contents\r\n\t\" Return the contents of the receiver. \"\r\n\r\n\t| result |\r\n\tresult := self collection.\r\n\tself readLimit = result size ifTrue: [ ^result ].\r\n\t^result copyFrom: 1 to: self readLimit","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):collection())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((self):readLimit()),(result):size()))==true then return (result); end;\r\nreturn ((result):copyFrom_to_(1,(self):readLimit()));\r\nend")

smalltalk:bind(smalltalk.Stream,"size",0
,function(self)
return ((self):readLimit());
end
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^self readLimit","function(self)\r\nreturn ((self):readLimit());\r\nend")

smalltalk:bind(smalltalk.Stream,"reset",0
,function(self)
(self):position_(0);
return (self);
end
,"actions","reset\r\n\t\" Reset the receiver. \"\r\n\r\n\tself position: 0","function(self)\r\n(self):position_(0);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"close",0
,function(self)
return (self);
end
,"actions","close\r\n\t\" Close the receiver. \"","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"flush",0
,function(self)
return (self);
end
,"io","flush\r\n\t\" Flush the receiver. \"","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"resetContents",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):reset();
	return ((_s8_rec):readLimit_(0))
end
)(self);
return (self);
end
,"actions","resetContents\r\n\t\" Reset the receiver contents. \"\r\n\r\n\tself reset; readLimit: 0","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):reset();\r\n\treturn ((_s8_rec):readLimit_(0))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"do:",0
,function(self,aBlock)
while not ((function()
return ((self):atEnd())
end))() do (aBlock):value_((self):next()); end;
return (self);
end
,"enumerating","do: aBlock\r\n\t\" Evaluates aBlock streaming on the receiver. \"\r\n\r\n\t[ self atEnd ] whileFalse: [ aBlock value: self next ]","function(self,aBlock)\r\nwhile not ((function()\r\nreturn ((self):atEnd())\r\nend))() do (aBlock):value_((self):next()); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"setToEnd",0
,function(self)
(self):position_((self):size());
return (self);
end
,"positioning","setToEnd\r\n\t\" Position the receiver at end. \"\r\n\r\n\tself position: self size","function(self)\r\n(self):position_((self):size());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"skip:",0
,function(self,anInteger)
(self):position_((((anInteger):_plus((self):position())):min_((self):size())):max_(0));
return (self);
end
,"positioning","skip: anInteger\r\n\t\" Skip next anInteger readable elements in the receiver. \"\r\n\r\n\tself position: ((anInteger + self position min: self size) max: 0)","function(self,anInteger)\r\n(self):position_((((anInteger):_plus((self):position())):min_((self):size())):max_(0));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"next",0
,function(self)
(self):position_(((self):position()):_plus(1));
return ((self["@collection"]):at_((self):position()));
end
,"reading","next\r\n\t\" Return the next readable element in the receiver (or nil). \"\r\n\r\n\tself position: self position + 1. \r\n\t^collection at: self position","function(self)\r\n(self):position_(((self):position()):_plus(1));\r\nreturn ((self[\"@collection\"]):at_((self):position()));\r\nend")

smalltalk:bind(smalltalk.Stream,"next:",0
,function(self,anInteger)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
(function()
	local _s8_value=((((self):collection()):species()):new())
	result=_s8_value
	return _s8_value
end)();
smalltalk:times_repeat_((anInteger),(function()
if ((self):atEnd())==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)(); end;return ((result):add_((self):next()))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"reading","next: anInteger\r\n\t\" Return the next anInteger elements read from the receiver.\r\n\tIf the receiver reach its end, the returned collection has less elements.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := self collection species new.\r\n\tanInteger timesRepeat: [\r\n\t\tself atEnd ifTrue: [ ^result ].\r\n\t\tresult add: self next.\r\n\t].\r\n\t^result","function(self,anInteger)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((((self):collection()):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:times_repeat_((anInteger),(function()\r\nif ((self):atEnd())==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return ((result):add_((self):next()))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Stream,"nextPut:",0
,function(self,anObject)
(self):position_(((self):position()):_plus(1));
((self):collection()):at_put_(self["@position"],anObject);
(self):readLimit_(((self):readLimit()):max_(self["@position"]));
return (self);
end
,"writing","nextPut: anObject\r\n\t\" Put anObject onto the receiver. \"\r\n\r\n\tself position: self position + 1.\r\n\tself collection at: position put: anObject.\r\n\tself readLimit: (self readLimit max: position)","function(self,anObject)\r\n(self):position_(((self):position()):_plus(1));\r\n((self):collection()):at_put_(self[\"@position\"],anObject);\r\n(self):readLimit_(((self):readLimit()):max_(self[\"@position\"]));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"nextPutAll:",0
,function(self,aCollection)
(aCollection):do_((function(each)
return ((self):nextPut_(each))
end));
return (self);
end
,"writing","nextPutAll: aCollection\r\n\t\" Put aCollection onto the receiver. \"\r\n\r\n\taCollection do: [:each | self nextPut: each ]","function(self,aCollection)\r\n(aCollection):do_((function(each)\r\nreturn ((self):nextPut_(each))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"cr",0
,function(self)
(self):nextPutAll_((smalltalk.String):crlf());
return (self);
end
,"writing","cr\r\n\t\" Put a line break sequence onto the receiver.\r\n\tNote: this implementation MUST be consistent with #nextLine\r\n\t\"\r\n\r\n\tself nextPutAll: String crlf","function(self)\r\n(self):nextPutAll_((smalltalk.String):crlf());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"space",0
,function(self)
(self):nextPutAll_((smalltalk.String):space());
return (self);
end
,"writing","space\r\n\t\" Put a space sequence onto the receiver. \"\r\n\r\n\tself nextPutAll: String space","function(self)\r\n(self):nextPutAll_((smalltalk.String):space());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"tab",0
,function(self)
(self):nextPutAll_((smalltalk.String):tab());
return (self);
end
,"writing","tab\r\n\t\" Put a tab sequence onto the receiver. \"\r\n\r\n\tself nextPutAll: String tab","function(self)\r\n(self):nextPutAll_((smalltalk.String):tab());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stream,"peek",0
,function(self)
return (smalltalk:if_true_false_(((self):atEnd()),nil,(function()
return (((self):collection()):at_(((self):position()):_plus(1)))
end)));
end
,"reading","peek\r\n\t\" Return the next readable element from the receiver without advancing the receiver (or nil). \"\r\n\r\n\t^self atEnd ifFalse: [\r\n\t    self collection at: self position + 1\r\n\t]","function(self)\r\nreturn (smalltalk:if_true_false_(((self):atEnd()),nil,(function()\r\nreturn (((self):collection()):at_(((self):position()):_plus(1)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Stream,"peekFor:",0
,function(self,anObject)
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((anObject),(self):peek())),(function()
if not (((self):atEnd()))==true then (self):next(); end;return (true)
end)));
end
,"reading","peekFor: anObject\r\n\t\" Return true if the next readable element from the receiver equals anObject.\r\n\tAdvance the receiver if the result is true.\r\n\t\"\r\n\r\n\t^anObject = self peek and: [\r\n\t\tself atEnd ifFalse: [ self next ].\r\n\t\ttrue\r\n\t]","function(self,anObject)\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((anObject),(self):peek())),(function()\r\nif not (((self):atEnd()))==true then (self):next(); end;return (true)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Stream,"peekForAll:",0
,function(self,aCollection)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local back=nil
(function()
	local _s8_value=((self):position())
	back=_s8_value
	return _s8_value
end)();
(aCollection):do_((function(each)
return (smalltalk:if_true_false_(((self):peekFor_(each)),nil,(function()
(self):position_(back);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"reading","peekForAll: aCollection\r\n\t\" Return true if the next readable elements from the receiver matches aCollection.\r\n\tAdvance the receiver if the result is true.\r\n\t\"\r\n\r\n\t| back |\r\n\tback := self position.\r\n\taCollection do: [:each|\r\n\t\t(self peekFor: each) ifFalse: [\r\n\t\t\tself position: back.\r\n\t\t\t^false\r\n\t\t].\r\n\t].\r\n\t^true","function(self,aCollection)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal back=nil\r\n(function()\r\n\tlocal _s8_value=((self):position())\r\n\tback=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aCollection):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((self):peekFor_(each)),nil,(function()\r\n(self):position_(back);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Stream,"atEnd",0
,function(self)
return ((((self):position()) >= (self):size()));
end
,"testing","atEnd\r\n\t\" Return true if the receiver is at end. \"\r\n\r\n\t^self position >= self size","function(self)\r\nreturn ((((self):position()) >= (self):size()));\r\nend")

smalltalk:bind(smalltalk.Stream,"atStart",0
,function(self)
return (smalltalk:isObject_equalTo_(((self):position()),0));
end
,"testing","atStart\r\n\t\" Return true if the receiver is at start position. \"\r\n\r\n\t^self position = 0","function(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):position()),0));\r\nend")

smalltalk:bind(smalltalk.Stream,"isEmpty",0
,function(self)
return (smalltalk:isObject_equalTo_(((self):size()),0));
end
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^self size = 0","function(self)\r\nreturn (smalltalk:isObject_equalTo_(((self):size()),0));\r\nend")

smalltalk:bind(smalltalk.Stream,"notEmpty",0
,function(self)
return (smalltalk:booleanNot_(((self):isEmpty())));
end
,"testing","notEmpty\r\n\t\" Return true if the receiver is not empty. \"\r\n\r\n\t^self isEmpty not","function(self)\r\nreturn (smalltalk:booleanNot_(((self):isEmpty())));\r\nend")

smalltalk:bind(smalltalk.Stream,"upTo:",0
,function(self,anObject)
local result=nil
(function()
	local _s8_value=((((self):collection()):species()):new())
	result=_s8_value
	return _s8_value
end)();
while not ((function()
return (smalltalk:boolean_or_(((self):atEnd()),(function()
return (smalltalk:isObject_equalTo_(((self):peek()),anObject))
end)))
end))() do (result):add_((self):next()); end;
if not (((self):atEnd()))==true then (self):next(); end;
return (result);
end
,"reading","upTo: anObject\r\n\t\" Return the elements read from the receiver upto anObject (or end). \"\r\n\r\n\t| result |\r\n\tresult := self collection species new.\r\n\t[ self atEnd or: [ self peek = anObject ]] whileFalse: [\r\n\t\tresult add: self next\r\n\t].\r\n\tself atEnd ifFalse: [ self next ].\r\n\t^result","function(self,anObject)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((((self):collection()):species()):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn (smalltalk:boolean_or_(((self):atEnd()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((self):peek()),anObject))\r\nend)))\r\nend))() do (result):add_((self):next()); end;\r\nif not (((self):atEnd()))==true then (self):next(); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Stream,"upToEnd",0
,function(self)
return ((self):upTo_((smalltalk.Object):new()));
end
,"reading","upToEnd\r\n\t\" Return the contents of the receiver upto end. \"\r\n\r\n\t^self upTo: Object new","function(self)\r\nreturn ((self):upTo_((smalltalk.Object):new()));\r\nend")

smalltalk:bind(smalltalk.Stream,"nextLine",0
,function(self)
local result=nil
local start=nil
(function()
	local _s8_value=((self):position())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):upTo_((smalltalk.String):cr()))
	result=_s8_value
	return _s8_value
end)();
if ((result):includes_((smalltalk.String):lf()))==true then return ((
function(_s8_rec)
	(_s8_rec):position_(start);
	return ((_s8_rec):upTo_((smalltalk.String):lf()))
end
)(self)); end;
if (smalltalk:isObject_equalTo_(((self):peek()),(smalltalk.String):lf()))==true then (self):next(); end;
return (result);
end
,"reading","nextLine\r\n\t\" Return the characters read from the receiver up to the line delimiter. \"\r\n\r\n\t| result start |\r\n\tstart := self position.\r\n\tresult := self upTo: String cr.\r\n\t(result includes: String lf) ifTrue: [\r\n\t\t^self position: start; upTo: String lf\r\n\t].\r\n\t(self peek = String lf) ifTrue: [ self next ].\r\n\t^result","function(self)\r\nlocal result=nil\r\nlocal start=nil\r\n(function()\r\n\tlocal _s8_value=((self):position())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):upTo_((smalltalk.String):cr()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((result):includes_((smalltalk.String):lf()))==true then return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):position_(start);\r\n\treturn ((_s8_rec):upTo_((smalltalk.String):lf()))\r\nend\r\n)(self)); end;\r\nif (smalltalk:isObject_equalTo_(((self):peek()),(smalltalk.String):lf()))==true then (self):next(); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Stream,"skipTo:",0
,function(self,anObject)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
while not ((function()
return ((self):atEnd())
end))() do smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):next()),anObject)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"reading","skipTo: anObject\r\n\t\" Advance the receiver upto anObject (or end). \"\r\n\r\n\t[ self atEnd ] whileFalse: [\r\n\t\tself next = anObject ifTrue: [ ^true ].\r\n\t].\r\n\t^false","function(self,anObject)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nwhile not ((function()\r\nreturn ((self):atEnd())\r\nend))() do smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):next()),anObject)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Stream,"skipSeparators",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
while ((function()
if ((self):atEnd())==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)(); end;return (((self):peek()):isSeparator())
end))() do (self):next(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"reading","skipSeparators\r\n\t\" Advance the receiver upto a non-separator (or end).\r\n\tReturn true  if a non-separator contents is found,\r\n\treturn false if run upto end of stream.\r\n\t\"\r\n\r\n\t[ self atEnd ifTrue: [ ^false ].\r\n\t  self peek isSeparator\r\n\t] whileTrue: [ self next ].\r\n\t^true","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nwhile ((function()\r\nif ((self):atEnd())==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;return (((self):peek()):isSeparator())\r\nend))() do (self):next(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Stream["$klass"],"on:",0
,function(self,aCollection)
return ((
function(_s8_rec)
	(_s8_rec):collection_(aCollection);
	(_s8_rec):readLimit_((aCollection):size());
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","on: aCollection\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new \r\n\t\tcollection: aCollection;\r\n\t\treadLimit: aCollection size;\r\n\t\tyourself","function(self,aCollection)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):collection_(aCollection);\r\n\t(_s8_rec):readLimit_((aCollection):size());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.Stream,"upToEnd",0
,function(self)
local result=nil
(function()
	local _s8_value=(((self):collection()):copyFrom_to_(((self):position()):_plus(1),(self):readLimit()))
	result=_s8_value
	return _s8_value
end)();
(self):setToEnd();
return (result);
end
,"reading","upToEnd\r\n\t\" Return the contents of the receiver upto end. \"\r\n\r\n\t| result |\r\n\tresult := self collection copyFrom: self position + 1 to: self readLimit.\r\n\tself setToEnd.\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):collection()):copyFrom_to_(((self):position()):_plus(1),(self):readLimit()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):setToEnd();\r\nreturn (result);\r\nend")

smalltalk:addClass("StringStream",smalltalk.Stream,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.StringStream,"next:",0
,function(self,anInteger)
local start=nil
local result=nil
local stop=nil
(function()
	local _s8_value=((self):position())
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((start):_plus(anInteger)):min_((self):readLimit()))
	stop=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((self):collection()):copyFrom_to_((start):_plus(1),stop))
	result=_s8_value
	return _s8_value
end)();
(self):position_(stop);
return (result);
end
,"reading","next: anInteger\r\n\t\" Return the next anInteger elements read from the receiver.\r\n\tIf the receiver reach its end, the returned collection has less elements.\r\n\t\"\r\n\r\n\t| start result stop |\r\n\tstart := self position.\r\n\tstop := start + anInteger min: self readLimit.\r\n\tresult := self collection copyFrom: start + 1 to: stop.\r\n\tself position: stop.\r\n\t^result","function(self,anInteger)\r\nlocal start=nil\r\nlocal result=nil\r\nlocal stop=nil\r\n(function()\r\n\tlocal _s8_value=((self):position())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((start):_plus(anInteger)):min_((self):readLimit()))\r\n\tstop=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((self):collection()):copyFrom_to_((start):_plus(1),stop))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):position_(stop);\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.StringStream,"nextPut:",0
,function(self,aString)
(self):nextPutAll_(aString);
return (self);
end
,"writing","nextPut: aString\r\n\t\" Put aString onto the receiver. \"\r\n\r\n\tself nextPutAll: aString","function(self,aString)\r\n(self):nextPutAll_(aString);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.StringStream,"nextPutAll:",0
,function(self,aString)
local result=nil
if (smalltalk:isObject_equalTo_(((self):position()),((self):collection()):size()))==true then (function()
	local _s8_value=(smalltalk:object_comma_(((self):collection()),aString))
	result=_s8_value
	return _s8_value
end)(); else local substring=nil
(function()
	local _s8_value=(((self):collection()):copyFrom_to_(1,(self):position()))
	substring=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_(((substring):isEmpty()),(function()
return (aString)
end),(function()
return (smalltalk:object_comma_((substring),aString))
end)))
	result=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((self):collection()):copyFrom_to_((((self):position()):_plus(1)):_plus((aString):size()),((self):collection()):size()))
	substring=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_(((substring):isEmpty()),(function()
return (result)
end),(function()
return (smalltalk:object_comma_((result),substring))
end)))
	result=_s8_value
	return _s8_value
end)(); end;
(self):collection_(result);
(self):position_(((self):position()):_plus((aString):size()));
(self):readLimit_(((self):readLimit()):max_(self["@position"]));
return (self);
end
,"writing","nextPutAll: aString\r\n\t\" Put aString onto the receiver at current position; expanding internal contents. \"\r\n\r\n\t| result |\r\n\tself position = self collection size\r\n\tifTrue: [ result := self collection , aString ]\r\n\tifFalse: [ | substring |\r\n\t\tsubstring := self collection copyFrom: 1 to: self position.\r\n\t\tresult := substring isEmpty ifTrue: [ aString ] ifFalse: [ substring , aString ].\r\n\t\tsubstring := self collection\r\n\t\t\tcopyFrom: self position + 1 + aString size\r\n\t\t\tto: self collection size.\r\n\t\tresult := substring isEmpty ifTrue: [ result ] ifFalse: [ result , substring ].\r\n\t].\r\n\tself collection: result.\r\n\tself position: self position + aString size.\r\n\tself readLimit: (self readLimit max: position)","function(self,aString)\r\nlocal result=nil\r\nif (smalltalk:isObject_equalTo_(((self):position()),((self):collection()):size()))==true then (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((self):collection()),aString))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)(); else local substring=nil\r\n(function()\r\n\tlocal _s8_value=(((self):collection()):copyFrom_to_(1,(self):position()))\r\n\tsubstring=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((substring):isEmpty()),(function()\r\nreturn (aString)\r\nend),(function()\r\nreturn (smalltalk:object_comma_((substring),aString))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((self):collection()):copyFrom_to_((((self):position()):_plus(1)):_plus((aString):size()),((self):collection()):size()))\r\n\tsubstring=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((substring):isEmpty()),(function()\r\nreturn (result)\r\nend),(function()\r\nreturn (smalltalk:object_comma_((result),substring))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(self):collection_(result);\r\n(self):position_(((self):position()):_plus((aString):size()));\r\n(self):readLimit_(((self):readLimit()):max_(self[\"@position\"]));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.StringStream,"skipTo:",0
,function(self,anObject)
local index=nil
if not (((anObject):isString()))==true then (self):setToEnd();
return (false); end;
(function()
	local _s8_value=(((self):collection()):indexOf_startingAt_(anObject,((self):position()):_plus(1)))
	index=_s8_value
	return _s8_value
end)();
if ((index):between_and_(((self):position()):_plus(1),(self):readLimit()))==true then (self):position_(((index):_plus((anObject):size())):_minus(1));
return (true); end;
(self):setToEnd();
return (false);
end
,"reading","skipTo: anObject\r\n\t\" Advance the receiver upto anObject (or end). \"\r\n\r\n\t| index |\r\n\tanObject isString ifFalse: [ self setToEnd. ^false ].\r\n\tindex := self collection indexOf: anObject startingAt: self position + 1.\r\n\t(index between: self position + 1 and: self readLimit) ifTrue: [\r\n\t\tself position: index + anObject size - 1.\r\n\t\t^true\r\n\t].\r\n\tself setToEnd.\r\n\t^false","function(self,anObject)\r\nlocal index=nil\r\nif not (((anObject):isString()))==true then (self):setToEnd();\r\nreturn (false); end;\r\n(function()\r\n\tlocal _s8_value=(((self):collection()):indexOf_startingAt_(anObject,((self):position()):_plus(1)))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((index):between_and_(((self):position()):_plus(1),(self):readLimit()))==true then (self):position_(((index):_plus((anObject):size())):_minus(1));\r\nreturn (true); end;\r\n(self):setToEnd();\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.StringStream,"upTo:",0
,function(self,anObject)
local start=nil
local found=nil
if not (((anObject):isString()))==true then return ((self):upToEnd()); end;
(function()
	local _s8_value=(((self):position()):_plus(1))
	start=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_(((self):skipTo_(anObject)),(function()
return ((anObject):size())
end),(function()
return (0)
end)))
	found=_s8_value
	return _s8_value
end)();
return (((self):collection()):copyFrom_to_(start,((self):position()):_minus(found)));
end
,"reading","upTo: anObject\r\n\t\" Return the elements read from the receiver upto anObject (or end). \"\r\n\r\n\t| start found |\r\n\tanObject isString ifFalse: [ ^self upToEnd ].\r\n\tstart := self position + 1.\r\n\tfound := (self skipTo: anObject) ifTrue: [ anObject size ] ifFalse: [ 0 ].\r\n\t^self collection copyFrom: start to: self position - found","function(self,anObject)\r\nlocal start=nil\r\nlocal found=nil\r\nif not (((anObject):isString()))==true then return ((self):upToEnd()); end;\r\n(function()\r\n\tlocal _s8_value=(((self):position()):_plus(1))\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((self):skipTo_(anObject)),(function()\r\nreturn ((anObject):size())\r\nend),(function()\r\nreturn (0)\r\nend)))\r\n\tfound=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((self):collection()):copyFrom_to_(start,((self):position()):_minus(found)));\r\nend")

smalltalk:bind(smalltalk.StringStream,"peek",0
,function(self)

	local c = self["@collection"]:at_(self:position()+1)
	if c=="" then return nil else return c end;
return (self);
end
,"reading","peek\r\n\t\" Return the next readable element from the receiver without advancing (or nil). \"\r\n\r\n\t{'' doc'native accessing'}","function(self)\r\n\r\n\tlocal c = self[\"@collection\"]:at_(self:position()+1)\r\n\tif c==\"\" then return nil else return c end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.StringStream,"next",0
,function(self)
local result=nil
(function()
	local _s8_value=((self):peek())
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:notNil_((result)))==true then (function()
	local _s8_value=((self["@position"]):_plus(1))
	self["@position"]=_s8_value
	return _s8_value
end)(); end;
return (result);
end
,"reading","next\r\n\t\" Return the next readable element in the receiver (or nil). \"\r\n\r\n\t| result |\r\n\tresult := self peek.\r\n\tresult notNil ifTrue: [ position := position + 1 ].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):peek())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:notNil_((result)))==true then (function()\r\n\tlocal _s8_value=((self[\"@position\"]):_plus(1))\r\n\tself[\"@position\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.StringStream,"peekForAll:",0
,function(self,aCollection)
if not (((aCollection):isString()))==true then return (smalltalk:superImplementor(smalltalk.StringStream,"peekForAll_")(self,aCollection)); end;

	local start=self:position()
	if (self["@collection"]:sub(start+1,start+#aCollection)~=aCollection) then return false end;
(function()
	local _s8_value=((self["@position"]):_plus((aCollection):size()))
	self["@position"]=_s8_value
	return _s8_value
end)();
return (true);
end
,"reading","peekForAll: aCollection\r\n\t\" Return true if the next readable elements from the receiver matches aCollection.\r\n\tAdvance the receiver if the result is true.\r\n\t\"\r\n\r\n\taCollection isString ifFalse: [ ^super peekForAll: aCollection ].\r\n\t{'' doc'native accessing'}.\r\n\tposition := position + aCollection size.\r\n\t^true","function(self,aCollection)\r\nif not (((aCollection):isString()))==true then return (smalltalk:superImplementor(smalltalk.StringStream,\"peekForAll_\")(self,aCollection)); end;\r\n\r\n\tlocal start=self:position()\r\n\tif (self[\"@collection\"]:sub(start+1,start+#aCollection)~=aCollection) then return false end;\r\n(function()\r\n\tlocal _s8_value=((self[\"@position\"]):_plus((aCollection):size()))\r\n\tself[\"@position\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.StringStream,"upToSeparator",0
,function(self)
local start=nil
(function()
	local _s8_value=(((self):position()):_plus(1))
	start=_s8_value
	return _s8_value
end)();
while ((function()
return (smalltalk:boolean_and_((smalltalk:booleanNot_(((self):atEnd()))),(function()
return (smalltalk:booleanNot_((((self):peek()):isSeparator())))
end)))
end))() do (self):next(); end;
return (((self):collection()):copyFrom_to_(start,(self):position()));
end
,"reading","upToSeparator\r\n\t\" Return the elements read from the receiver upto a separator (or end). \"\r\n\r\n\t| start |\r\n\tstart := self position + 1.\r\n\t[self atEnd not and: [self peek isSeparator not]] whileTrue: [\r\n\t\tself next\r\n\t].\r\n\t^self collection copyFrom: start to: self position","function(self)\r\nlocal start=nil\r\n(function()\r\n\tlocal _s8_value=(((self):position()):_plus(1))\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\nreturn (smalltalk:boolean_and_((smalltalk:booleanNot_(((self):atEnd()))),(function()\r\nreturn (smalltalk:booleanNot_((((self):peek()):isSeparator())))\r\nend)))\r\nend))() do (self):next(); end;\r\nreturn (((self):collection()):copyFrom_to_(start,(self):position()));\r\nend")

smalltalk:bind(smalltalk.StringStream,"nextMessagePattern",0
,function(self)
local part=nil
local selector=nil
local args=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	args=_s8_value
	return _s8_value
end)();
(self):skipSeparators();
(function()
	local _s8_value=((self):upToSeparator())
	selector=_s8_value
	return _s8_value
end)();
if ((selector):isEmpty())==true then return (nil); end;
if ((((selector):argumentCount()) > 0))==true then smalltalk:while_do_(((function()
(self):skipSeparators();(args):add_((self):upToSeparator());(self):skipSeparators();(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):peek()),"\"")),(function()
return ("")
end),(function()
return ((self):upToSeparator())
end)))
	part=_s8_value
	return _s8_value
end)();return (smalltalk:boolean_and_(((part):notEmpty()),(function()
return (smalltalk:isObject_equalTo_(((part):last()),":"))
end)))
end)),(function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((selector),part))
	selector=_s8_value
	return _s8_value
end)())
end)); end;
(function()
	local _s8_value=((smalltalk.Message):selector_arguments_(selector,args))
	part=_s8_value
	return _s8_value
end)();
(self):skipSeparators();
if (smalltalk:isObject_equalTo_(((self):peek()),"\""))==true then (part):comment_(((
function(_s8_rec)
	(_s8_rec):next();
	return ((_s8_rec):upTo_("\""))
end
)(self)):trimBlanks()); end;
return (part);
end
,"tools","nextMessagePattern\r\n\t\" Return a message pattern read from the receiver (or nil).\r\n\tNote: it is assumed that there is a correct message header in the receiver.\r\n\t\"\r\n\r\n\t| part selector args |\r\n\targs := #().\r\n\tself skipSeparators.\r\n\tselector := self upToSeparator.\r\n\tselector isEmpty ifTrue: [ ^nil ].\r\n\tselector argumentCount > 0 ifTrue: [\r\n\t\t[ self skipSeparators.\r\n\t\t  args add: self upToSeparator.\r\n\t\t  self skipSeparators.\r\n\t\t  part := self peek = $\" ifTrue: [ '' ]\r\n\t\t\tifFalse: [ self upToSeparator ].\r\n\t\t  part notEmpty and: [ part last = $: ]\r\n\t\t] whileTrue: [\r\n\t\t  selector := selector , part\r\n\t\t].\r\n\t].\r\n\tpart := Message selector: selector arguments: args.\r\n\tself skipSeparators.\r\n\tself peek = $\" ifTrue: [\r\n\t\tpart comment: (self next; upTo: $\") trimBlanks\r\n\t].\r\n\t^part","function(self)\r\nlocal part=nil\r\nlocal selector=nil\r\nlocal args=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):skipSeparators();\r\n(function()\r\n\tlocal _s8_value=((self):upToSeparator())\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((selector):isEmpty())==true then return (nil); end;\r\nif ((((selector):argumentCount()) > 0))==true then smalltalk:while_do_(((function()\r\n(self):skipSeparators();(args):add_((self):upToSeparator());(self):skipSeparators();(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):peek()),\"\\\"\")),(function()\r\nreturn (\"\")\r\nend),(function()\r\nreturn ((self):upToSeparator())\r\nend)))\r\n\tpart=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:boolean_and_(((part):notEmpty()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((part):last()),\":\"))\r\nend)))\r\nend)),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((selector),part))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Message):selector_arguments_(selector,args))\r\n\tpart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):skipSeparators();\r\nif (smalltalk:isObject_equalTo_(((self):peek()),\"\\\"\"))==true then (part):comment_(((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):next();\r\n\treturn ((_s8_rec):upTo_(\"\\\"\"))\r\nend\r\n)(self)):trimBlanks()); end;\r\nreturn (part);\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"streamClass",0
,function(self)
return (smalltalk.StringStream);
end
,"streams","streamClass\r\n\t\" Return the streamming support for the receiver's instances. \"\r\n\r\n\t^StringStream","function(self)\r\nreturn (smalltalk.StringStream);\r\nend")

smalltalk:addClass("StringWriteStream",smalltalk.Stream,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.StringWriteStream,"collection",0
,function(self)
return ((self):invalidMessage_("collection"));
end
,"accessing","collection\r\n\t\" Private - Return the collection of the receiver. \"\r\n\r\n\t^self invalidMessage: #collection","function(self)\r\nreturn ((self):invalidMessage_(\"collection\"));\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"collection:",0
,function(self,aCollection)
if not (((aCollection):isString()))==true then (self):error_("Collection must be a String"); end;
(function()
	local _s8_value=((smalltalk.Array):with_(aCollection))
	self["@collection"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","collection: aCollection\r\n\t\" Private - Set the collection of the receiver. \"\r\n\r\n\taCollection isString ifFalse: [ self error: 'Collection must be a String' ].\r\n\tcollection := Array with: aCollection","function(self,aCollection)\r\nif not (((aCollection):isString()))==true then (self):error_(\"Collection must be a String\"); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):with_(aCollection))\r\n\tself[\"@collection\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"contents",0
,function(self)
return ((self["@collection"]):join_(""));
end
,"accessing","contents\r\n\t\" Return the contents of the receiver. \"\r\n\r\n\t^collection join: ''","function(self)\r\nreturn ((self[\"@collection\"]):join_(\"\"));\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"position",0
,function(self)
return ((self):readLimit());
end
,"accessing","position\r\n\t\" Return the position of the receiver. \"\r\n\r\n\t^self readLimit","function(self)\r\nreturn ((self):readLimit());\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"position:",0
,function(self,anInteger)
return ((self):invalidMessage_("position:"));
end
,"accessing","position: anInteger\r\n\t\" Set the position of the receiver. \"\r\n\r\n\t^self invalidMessage: #position:","function(self,anInteger)\r\nreturn ((self):invalidMessage_(\"position:\"));\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"readLimit",0
,function(self)
return (self["@readLimit"]);
end
,"accessing","readLimit\r\n\t\" Private - Return the read limit of the receiver. \"\r\n\r\n\t^readLimit","function(self)\r\nreturn (self[\"@readLimit\"]);\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"readLimit:",0
,function(self,anInteger)
(function()
	local _s8_value=(anInteger)
	self["@readLimit"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","readLimit: anInteger\r\n\t\" Private - Set the stream size of the receiver. \"\r\n\r\n\treadLimit := anInteger","function(self,anInteger)\r\n(function()\r\n\tlocal _s8_value=(anInteger)\r\n\tself[\"@readLimit\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"setCollection:",0
,function(self,aCollection)
return ((self):invalidMessage_("setCollection:"));
end
,"accessing","setCollection: aCollection\r\n\t\" Private - Set the receiver stream collection to aCollection. \"\r\n\r\n\t^self invalidMessage: #setCollection:","function(self,aCollection)\r\nreturn ((self):invalidMessage_(\"setCollection:\"));\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"size",0
,function(self)
return ((self):readLimit());
end
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^self readLimit","function(self)\r\nreturn ((self):readLimit());\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"close",0
,function(self)
return (self);
end
,"actions","close\r\n\t\" Close the receiver. \"","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"reset",0
,function(self)
(self):initialize();
return (self);
end
,"actions","reset\r\n\t\" Reset the receiver. \"\r\n\r\n\tself initialize","function(self)\r\n(self):initialize();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"do:",0
,function(self,aBlock)
return ((self):invalidMessage_("do:"));
end
,"enumerating","do: aBlock\r\n\t\" Evaluates aBlock streaming on the receiver. \"\r\n\r\n\t^self invalidMessage: #do:","function(self,aBlock)\r\nreturn ((self):invalidMessage_(\"do:\"));\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"initialize",0
,function(self)
smalltalk:superImplementor(smalltalk.StringWriteStream,"initialize")(self);
(function()
	local _s8_value=((smalltalk.Array):new())
	self["@collection"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((function()
	local _s8_value=(0)
	self["@position"]=_s8_value
	return _s8_value
end)())
	self["@readLimit"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initialize\r\n\t\" Private - Initialize the receiver. \"\r\n\r\n\tsuper initialize.\r\n\tcollection := Array new.\r\n\treadLimit := position := 0.","function(self)\r\nsmalltalk:superImplementor(smalltalk.StringWriteStream,\"initialize\")(self);\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@collection\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((function()\r\n\tlocal _s8_value=(0)\r\n\tself[\"@position\"]=_s8_value\r\n\treturn _s8_value\r\nend)())\r\n\tself[\"@readLimit\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"setToEnd",0
,function(self)
return (self);
end
,"positioning","setToEnd\r\n\t\" Position the receiver at end. \"","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"skip:",0
,function(self,anInteger)
return ((self):invalidMessage_("skip:"));
end
,"positioning","skip: anInteger\r\n\t\" Skip next anInteger readable elements in the receiver. \"\r\n\r\n\t^self invalidMessage: #skip:","function(self,anInteger)\r\nreturn ((self):invalidMessage_(\"skip:\"));\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"next",0
,function(self)
return ((self):invalidMessage_("next"));
end
,"reading","next\r\n\t\" Return the next readable element in the receiver (or nil). \"\r\n\r\n\t^self invalidMessage: #next","function(self)\r\nreturn ((self):invalidMessage_(\"next\"));\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"next:",0
,function(self,anInteger)
return ((self):invalidMessage_("next"));
end
,"reading","next: anInteger\r\n\t\" Return the next anInteger elements read from the receiver. \"\r\n\r\n\t^self invalidMessage: #next","function(self,anInteger)\r\nreturn ((self):invalidMessage_(\"next\"));\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"nextLine",0
,function(self)
return ((self):invalidMessage_("nextLine"));
end
,"reading","nextLine\r\n\t\" Return the characters read from the receiver up to the line delimiter. \"\r\n\r\n\t^self invalidMessage: #nextLine","function(self)\r\nreturn ((self):invalidMessage_(\"nextLine\"));\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"peek",0
,function(self)
return ((self):invalidMessage_("peek"));
end
,"reading","peek\r\n\t\" Return the next readable element from the receiver without advancing the receiver (or nil). \"\r\n\r\n\t^self invalidMessage: #peek","function(self)\r\nreturn ((self):invalidMessage_(\"peek\"));\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"upTo:",0
,function(self,anObject)
return ((self):invalidMessage_("upTo:"));
end
,"reading","upTo: anObject\r\n\t\" Return the elements read from the receiver upto anObject (or end). \"\r\n\r\n\t^self invalidMessage: #upTo:","function(self,anObject)\r\nreturn ((self):invalidMessage_(\"upTo:\"));\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"upToEnd",0
,function(self)
return ((self):invalidMessage_("upToEnd"));
end
,"reading","upToEnd\r\n\t\" Return the contents of the receiver upto end. \"\r\n\r\n\t^self invalidMessage: #upToEnd","function(self)\r\nreturn ((self):invalidMessage_(\"upToEnd\"));\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"atEnd",0
,function(self)
return (true);
end
,"testing","atEnd\r\n\t\" Return true if the receiver is at end. \"\r\n\r\n\t^true","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"nextPut:",0
,function(self,anObject)
local string=nil
(function()
	local _s8_value=(smalltalk:asString_((anObject)))
	string=_s8_value
	return _s8_value
end)();
(self["@collection"]):add_(string);
(function()
	local _s8_value=((self["@readLimit"]):_plus((string):size()))
	self["@readLimit"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"writing","nextPut: anObject\r\n\t\" Put anObject onto the receiver. \"\r\n\r\n\t| string |\r\n\tstring :=  anObject asString.\r\n\tcollection add: string.\r\n\treadLimit := readLimit + string size","function(self,anObject)\r\nlocal string=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:asString_((anObject)))\r\n\tstring=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self[\"@collection\"]):add_(string);\r\n(function()\r\n\tlocal _s8_value=((self[\"@readLimit\"]):_plus((string):size()))\r\n\tself[\"@readLimit\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"nextPutAll:",0
,function(self,aCollection)
(self):nextPut_(aCollection);
return (self);
end
,"writing","nextPutAll: aCollection\r\n\t\" Put aCollection onto the receiver. \"\r\n\r\n\tself nextPut: aCollection","function(self,aCollection)\r\n(self):nextPut_(aCollection);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.StringWriteStream,"removeLastInput",0
,function(self)
(function()
	local _s8_value=((self["@readLimit"]):_minus(((self["@collection"]):removeLast()):size()))
	self["@readLimit"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"back","removeLastInput\r\n\t\" Remove last input recorded in the receiver. \"\r\n\r\n\treadLimit := readLimit - collection removeLast size","function(self)\r\n(function()\r\n\tlocal _s8_value=((self[\"@readLimit\"]):_minus(((self[\"@collection\"]):removeLast()):size()))\r\n\tself[\"@readLimit\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"writeStream",0
,function(self)
return ((smalltalk.StringWriteStream):on_(self));
end
,"streams","writeStream\r\n\t\" Return a write stream on the receiver. \"\r\n\r\n\t^StringWriteStream on: self","function(self)\r\nreturn ((smalltalk.StringWriteStream):on_(self));\r\nend")

smalltalk:addClass("Random",smalltalk.Object,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.Random,"next",0
,function(self)
if true then return math.random() end;
return (self);
end
,"accessing","next\r\n\t\" Return the next random number. \"\r\n\r\n\t{'' doc'native accessing'}","function(self)\r\nif true then return math.random() end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Random,"next:",0
,function(self,anInteger)
return (((1):to_(anInteger)):collect_((function(each)
return ((self):next())
end)));
end
,"accessing","next: anInteger\r\n\t\" Return the next anInteger random numbers. \"\r\n\r\n\t^(1 to: anInteger) collect: [:each | self next ]","function(self,anInteger)\r\nreturn (((1):to_(anInteger)):collect_((function(each)\r\nreturn ((self):next())\r\nend)));\r\nend")

smalltalk:addClass("Point",smalltalk.Object,smalltalk:newArray({"x","y"}),"Kernel")

smalltalk:bind(smalltalk.Point["$klass"],"x:y:",0
,function(self,x,y)
return ((
function(_s8_rec)
	(_s8_rec):x_(x);
	return ((_s8_rec):y_(y))
end
)((self):basicNew()));
end
,"instantiation","x: x y: y\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew x: x; y: y","function(self,x,y)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):x_(x);\r\n\treturn ((_s8_rec):y_(y))\r\nend\r\n)((self):basicNew()));\r\nend")

smalltalk:bind(smalltalk.Point["$klass"],"zero",0
,function(self)
return (((self):basicNew()):x_y_(0,0));
end
,"instantiation","zero\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew x: 0 y: 0","function(self)\r\nreturn (((self):basicNew()):x_y_(0,0));\r\nend")

smalltalk:bind(smalltalk.Point,"x",0
,function(self)
return (self["@x"]);
end
,"accessing","x\r\n\t\" Return the x of the receiver. \"\r\n\r\n\t^x","function(self)\r\nreturn (self[\"@x\"]);\r\nend")

smalltalk:bind(smalltalk.Point,"y",0
,function(self)
return (self["@y"]);
end
,"accessing","y\r\n\t\" Return the y of the receiver. \"\r\n\r\n\t^y","function(self)\r\nreturn (self[\"@y\"]);\r\nend")

smalltalk:bind(smalltalk.Point,"x:y:",0
,function(self,xValue,yValue)
(function()
	local _s8_value=(xValue)
	self["@x"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(yValue)
	self["@y"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","x: xValue y: yValue\r\n\t\" Set the receiver's coordinates. \"\r\n\r\n\tx := xValue.\r\n\ty := yValue","function(self,xValue,yValue)\r\n(function()\r\n\tlocal _s8_value=(xValue)\r\n\tself[\"@x\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(yValue)\r\n\tself[\"@y\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Point,"y:",0
,function(self,aNumber)
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aNumber))),(function()
return (0)
end),(function()
return (aNumber)
end)))
	self["@y"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","y: aNumber\r\n\t\" Set the y of the receiver. \"\r\n\r\n\ty := aNumber isNil ifTrue: [ 0 ] ifFalse: [ aNumber ]","function(self,aNumber)\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aNumber))),(function()\r\nreturn (0)\r\nend),(function()\r\nreturn (aNumber)\r\nend)))\r\n\tself[\"@y\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Point,"x:",0
,function(self,aNumber)
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aNumber))),(function()
return (0)
end),(function()
return (aNumber)
end)))
	self["@x"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","x: aNumber\r\n\t\" Set the x of the receiver. \"\r\n\r\n\tx := aNumber isNil ifTrue: [ 0 ] ifFalse: [ aNumber ]","function(self,aNumber)\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:isNil_((aNumber))),(function()\r\nreturn (0)\r\nend),(function()\r\nreturn (aNumber)\r\nend)))\r\n\tself[\"@x\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Point,"*","_star"
,function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self["@x"]):_star(aPoint)):_at((self["@y"]):_star(aPoint))); end;
return ((smalltalk.Point):x_y_((self["@x"]):_star(((aPoint):asPoint()):x()),(self["@y"]):_star(((aPoint):asPoint()):y())));
end
,"arithmetic","* aPoint\r\n\t\" Return the result of operation. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^x * aPoint @ (y * aPoint) ].\r\n\t^Point\tx: x * aPoint asPoint x\r\n\t\ty: y * aPoint asPoint y","function(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self[\"@x\"]):_star(aPoint)):_at((self[\"@y\"]):_star(aPoint))); end;\r\nreturn ((smalltalk.Point):x_y_((self[\"@x\"]):_star(((aPoint):asPoint()):x()),(self[\"@y\"]):_star(((aPoint):asPoint()):y())));\r\nend")

smalltalk:bind(smalltalk.Point,"+","_plus"
,function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self["@x"]):_plus(aPoint)):_at((self["@y"]):_plus(aPoint))); end;
return ((smalltalk.Point):x_y_((self["@x"]):_plus(((aPoint):asPoint()):x()),(self["@y"]):_plus(((aPoint):asPoint()):y())));
end
,"arithmetic","+ aPoint\r\n\t\" Return the result of operation. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^x + aPoint @ (y + aPoint) ].\r\n\t^Point\tx: x + aPoint asPoint x\r\n\t\ty: y + aPoint asPoint y","function(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self[\"@x\"]):_plus(aPoint)):_at((self[\"@y\"]):_plus(aPoint))); end;\r\nreturn ((smalltalk.Point):x_y_((self[\"@x\"]):_plus(((aPoint):asPoint()):x()),(self[\"@y\"]):_plus(((aPoint):asPoint()):y())));\r\nend")

smalltalk:bind(smalltalk.Point,"-","_minus"
,function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self["@x"]):_minus(aPoint)):_at((self["@y"]):_minus(aPoint))); end;
return ((smalltalk.Point):x_y_((self["@x"]):_minus(((aPoint):asPoint()):x()),(self["@y"]):_minus(((aPoint):asPoint()):y())));
end
,"arithmetic","- aPoint\r\n\t\" Return the result of operation. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^x - aPoint @ (y - aPoint) ].\r\n\t^Point\tx: x - aPoint asPoint x\r\n\t\ty: y - aPoint asPoint y","function(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self[\"@x\"]):_minus(aPoint)):_at((self[\"@y\"]):_minus(aPoint))); end;\r\nreturn ((smalltalk.Point):x_y_((self[\"@x\"]):_minus(((aPoint):asPoint()):x()),(self[\"@y\"]):_minus(((aPoint):asPoint()):y())));\r\nend")

smalltalk:bind(smalltalk.Point,"/","_slash"
,function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self["@x"]):_slash(aPoint)):_at((self["@y"]):_slash(aPoint))); end;
return ((smalltalk.Point):x_y_((self["@x"]):_slash(((aPoint):asPoint()):x()),(self["@y"]):_slash(((aPoint):asPoint()):y())));
end
,"arithmetic","/ aPoint\r\n\t\" Return the result of operation. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^x / aPoint @ (y / aPoint) ].\r\n\t^Point\tx: x / aPoint asPoint x\r\n\t\ty: y / aPoint asPoint y","function(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self[\"@x\"]):_slash(aPoint)):_at((self[\"@y\"]):_slash(aPoint))); end;\r\nreturn ((smalltalk.Point):x_y_((self[\"@x\"]):_slash(((aPoint):asPoint()):x()),(self[\"@y\"]):_slash(((aPoint):asPoint()):y())));\r\nend")

smalltalk:bind(smalltalk.Point,"//","_slash_slash"
,function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self["@x"]):_slash_slash(aPoint)):_at((self["@y"]):_slash_slash(aPoint))); end;
return ((smalltalk.Point):x_y_((self["@x"]):_slash_slash(((aPoint):asPoint()):x()),(self["@y"]):_slash_slash(((aPoint):asPoint()):y())));
end
,"arithmetic","// aPoint\r\n\t\" Return the result of operation. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^x // aPoint @ (y // aPoint) ].\r\n\t^Point\tx: x // aPoint asPoint x\r\n\t\ty: y // aPoint asPoint y","function(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self[\"@x\"]):_slash_slash(aPoint)):_at((self[\"@y\"]):_slash_slash(aPoint))); end;\r\nreturn ((smalltalk.Point):x_y_((self[\"@x\"]):_slash_slash(((aPoint):asPoint()):x()),(self[\"@y\"]):_slash_slash(((aPoint):asPoint()):y())));\r\nend")

smalltalk:bind(smalltalk.Point,"\\\\","_bk_bk"
,function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self["@x"]):_bk_bk(aPoint)):_at((self["@y"]):_bk_bk(aPoint))); end;
return ((smalltalk.Point):x_y_((self["@x"]):_bk_bk(((aPoint):asPoint()):x()),(self["@y"]):_bk_bk(((aPoint):asPoint()):y())));
end
,"arithmetic","\\\\\\\\ aPoint\r\n\t\" Return the result of operation. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^x \\\\ aPoint @ (y \\\\ aPoint) ].\r\n\t^Point\tx: x \\\\ aPoint asPoint x\r\n\t\ty: y \\\\ aPoint asPoint y","function(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self[\"@x\"]):_bk_bk(aPoint)):_at((self[\"@y\"]):_bk_bk(aPoint))); end;\r\nreturn ((smalltalk.Point):x_y_((self[\"@x\"]):_bk_bk(((aPoint):asPoint()):x()),(self[\"@y\"]):_bk_bk(((aPoint):asPoint()):y())));\r\nend")

smalltalk:bind(smalltalk.Point,"<","_lt"
,function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self) < (aPoint):asPoint())); end;
return (smalltalk:boolean_and_((((self["@x"]) < (aPoint):x())),(function()
return (((self["@y"]) < (aPoint):y()))
end)));
end
,"comparing","< aPoint\r\n\t\" Return true if the receiver is smaller than argument. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^self < aPoint asPoint ].\r\n\t^x < aPoint x and: [ y < aPoint y ]","function(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self) < (aPoint):asPoint())); end;\r\nreturn (smalltalk:boolean_and_((((self[\"@x\"]) < (aPoint):x())),(function()\r\nreturn (((self[\"@y\"]) < (aPoint):y()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Point,"<=","_lt_eq"
,function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self) <= (aPoint):asPoint())); end;
return (smalltalk:boolean_and_((((self["@x"]) <= (aPoint):x())),(function()
return (((self["@y"]) <= (aPoint):y()))
end)));
end
,"comparing","<= aPoint\r\n\t\" Return true if the receiver is smaller or equal to argument. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^self <= aPoint asPoint ].\r\n\t^x <= aPoint x and: [ y <= aPoint y ]","function(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self) <= (aPoint):asPoint())); end;\r\nreturn (smalltalk:boolean_and_((((self[\"@x\"]) <= (aPoint):x())),(function()\r\nreturn (((self[\"@y\"]) <= (aPoint):y()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Point,">","_gt"
,function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self) > (aPoint):asPoint())); end;
return (smalltalk:boolean_and_((((self["@x"]) > (aPoint):x())),(function()
return (((self["@y"]) > (aPoint):y()))
end)));
end
,"comparing","> aPoint\r\n\t\" Return true if the receiver is greater than argument. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^self > aPoint asPoint ].\r\n\t^x > aPoint x and: [ y > aPoint y ]","function(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self) > (aPoint):asPoint())); end;\r\nreturn (smalltalk:boolean_and_((((self[\"@x\"]) > (aPoint):x())),(function()\r\nreturn (((self[\"@y\"]) > (aPoint):y()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Point,">=","_gt_eq"
,function(self,aPoint)
if ((self):isNumber_(aPoint))==true then return (((self) >= (aPoint):asPoint())); end;
return (smalltalk:boolean_and_((((self["@x"]) >= (aPoint):x())),(function()
return (((self["@y"]) >= (aPoint):y()))
end)));
end
,"comparing",">= aPoint\r\n\t\" Return true if the receiver is greater or equal to argument. \"\r\n\r\n\t(self isNumber: aPoint) ifTrue: [ ^self >= aPoint asPoint ].\r\n\t^x >= aPoint x and: [ y >= aPoint y ]","function(self,aPoint)\r\nif ((self):isNumber_(aPoint))==true then return (((self) >= (aPoint):asPoint())); end;\r\nreturn (smalltalk:boolean_and_((((self[\"@x\"]) >= (aPoint):x())),(function()\r\nreturn (((self[\"@y\"]) >= (aPoint):y()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Point,"rounded",0
,function(self)
return (((self["@x"]):rounded()):_at((self["@y"]):rounded()));
end
,"converting","rounded\r\n\t\" Return the receiver rounded. \"\r\n\r\n\t^x rounded @ y rounded","function(self)\r\nreturn (((self[\"@x\"]):rounded()):_at((self[\"@y\"]):rounded()));\r\nend")

smalltalk:bind(smalltalk.Point,"truncated",0
,function(self)
return (((self["@x"]):truncated()):_at((self["@y"]):truncated()));
end
,"converting","truncated\r\n\t\" Return the receiver truncated. \"\r\n\r\n\t^x truncated @ y truncated","function(self)\r\nreturn (((self[\"@x\"]):truncated()):_at((self[\"@y\"]):truncated()));\r\nend")

smalltalk:bind(smalltalk.Point,"asPoint",0
,function(self)
return (self);
end
,"converting","asPoint\r\n\t\" Return the receiver as a Point. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Point,"printString",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:toString_((self["@x"])))," @ ")),smalltalk:toString_((self["@y"]))));
end
,"printing","printString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^x toString ,' @ ' ,y toString","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:toString_((self[\"@x\"]))),\" @ \")),smalltalk:toString_((self[\"@y\"]))));\r\nend")

smalltalk:bind(smalltalk.Point,"toString",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:toString_((self["@x"]))),"@")),smalltalk:toString_((self["@y"]))));
end
,"printing","toString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^x toString ,$@ ,y toString","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:toString_((self[\"@x\"]))),\"@\")),smalltalk:toString_((self[\"@y\"]))));\r\nend")

smalltalk:bind(smalltalk.Point,"asLiteral",0
,function(self)
local literal=nil
(function()
	local _s8_value=((function(v)
local string=nil
(function()
	local _s8_value=(smalltalk:if_true_false_(((self):isObject_(v)),(function()
return ((v):asLiteral())
end),(function()
return (smalltalk:toString_((v)))
end)))
	string=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:boolean_or_(((string):isEmpty()),(function()
return (smalltalk:boolean_or_((((string):first()):isDigit()),(function()
return (("#'-+"):includes_((string):first()))
end)))
end))),(function()
return (string)
end),(function()
return (smalltalk:object_comma_((smalltalk:object_comma_(("("),string)),")"))
end)))
end))
	literal=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_(((literal):value_(self["@x"])),"@")),(literal):value_(self["@y"])));
end
,"converting","asLiteral\r\n\t\" Return the receiver in literal notation. \"\r\n\r\n\t| literal |\r\n\tliteral := [:v| | string |\r\n\t\tstring := (self isObject: v) ifTrue: [v asLiteral] ifFalse: [v toString].\r\n\t\t(string isEmpty or: [string first isDigit or: ['#''-+' includes: string first]])\r\n\t\tifTrue: [string] ifFalse: [ $( ,string ,$) ]\r\n\t].\r\n\t^(literal value: x) ,$@ ,(literal value: y)","function(self)\r\nlocal literal=nil\r\n(function()\r\n\tlocal _s8_value=((function(v)\r\nlocal string=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((self):isObject_(v)),(function()\r\nreturn ((v):asLiteral())\r\nend),(function()\r\nreturn (smalltalk:toString_((v)))\r\nend)))\r\n\tstring=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:boolean_or_(((string):isEmpty()),(function()\r\nreturn (smalltalk:boolean_or_((((string):first()):isDigit()),(function()\r\nreturn ((\"#'-+\"):includes_((string):first()))\r\nend)))\r\nend))),(function()\r\nreturn (string)\r\nend),(function()\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"(\"),string)),\")\"))\r\nend)))\r\nend))\r\n\tliteral=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_(((literal):value_(self[\"@x\"])),\"@\")),(literal):value_(self[\"@y\"])));\r\nend")

smalltalk:bind(smalltalk.Point,"shallowCopy",0
,function(self)
return ((((self)["$klass"]):basicNew()):x_y_((self):x(),(self):y()));
end
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self class basicNew\r\n\t\tx: self x y: self y","function(self)\r\nreturn ((((self)[\"$klass\"]):basicNew()):x_y_((self):x(),(self):y()));\r\nend")

smalltalk:bind(smalltalk.Point,"=","_eq"
,function(self,aPoint)
if (smalltalk:isNil_((aPoint)))==true then return (false); end;
if not (((aPoint):isMemberOf_((self)["$klass"])))==true then return (smalltalk:boolean_and_((smalltalk:responds_to_((aPoint),("asPoint"))),(function()
return (smalltalk:isObject_equalTo_(((aPoint):asPoint()),self))
end))); end;
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((self["@x"]),(aPoint):x())),(function()
return (smalltalk:isObject_equalTo_((self["@y"]),(aPoint):y()))
end)));
end
,"testing","= aPoint\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\taPoint isNil ifTrue: [ ^false ].\r\n\t(aPoint isMemberOf: self class) ifFalse: [\r\n\t\t^(aPoint respondsTo: #asPoint) and: [\r\n\t\t\taPoint asPoint = self\r\n\t\t]\r\n\t].\r\n\t^x = aPoint x and: [ y = aPoint y ]","function(self,aPoint)\r\nif (smalltalk:isNil_((aPoint)))==true then return (false); end;\r\nif not (((aPoint):isMemberOf_((self)[\"$klass\"])))==true then return (smalltalk:boolean_and_((smalltalk:responds_to_((aPoint),(\"asPoint\"))),(function()\r\nreturn (smalltalk:isObject_equalTo_(((aPoint):asPoint()),self))\r\nend))); end;\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((self[\"@x\"]),(aPoint):x())),(function()\r\nreturn (smalltalk:isObject_equalTo_((self[\"@y\"]),(aPoint):y()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Point,"min:",0
,function(self,aPoint)
return (((self["@x"]):min_((aPoint):x())):_at((self["@y"]):min_((aPoint):y())));
end
,"magnitude","min: aPoint\r\n\t\" Return the minimum of the receiver and aPoint. \"\r\n\r\n\t^(x min: aPoint x) @ (y min: aPoint y)","function(self,aPoint)\r\nreturn (((self[\"@x\"]):min_((aPoint):x())):_at((self[\"@y\"]):min_((aPoint):y())));\r\nend")

smalltalk:bind(smalltalk.Point,"max:",0
,function(self,aPoint)
return (((self["@x"]):max_((aPoint):x())):_at((self["@y"]):max_((aPoint):y())));
end
,"magnitude","max: aPoint\r\n\t\" Return the maximum of the receiver and aPoint. \"\r\n\r\n\t^(x max: aPoint x) @ (y max: aPoint y)","function(self,aPoint)\r\nreturn (((self[\"@x\"]):max_((aPoint):x())):_at((self[\"@y\"]):max_((aPoint):y())));\r\nend")

smalltalk:addClass("Rectangle",smalltalk.Object,smalltalk:newArray({"leftTop","rightBottom"}),"Kernel")

smalltalk:bind(smalltalk.Object,"isRectangle",0
,function(self)
return (false);
end
,"testing","isRectangle\r\n\t\" Return true if receiver is a Rectangle. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.Point,"extent:",0
,function(self,extent)
return ((smalltalk.Rectangle):leftTop_rightBottom_(self,(self):_plus(extent)));
end
,"converting","extent: extent\r\n\t\" Return a Rectangle from the receiver with specified extent. \"\r\n\r\n\t^Rectangle leftTop: self rightBottom: self + extent","function(self,extent)\r\nreturn ((smalltalk.Rectangle):leftTop_rightBottom_(self,(self):_plus(extent)));\r\nend")

smalltalk:bind(smalltalk.Point,"rightBottom:",0
,function(self,rightBottom)
return ((smalltalk.Rectangle):leftTop_rightBottom_(self,rightBottom));
end
,"converting","rightBottom: rightBottom\r\n\t\" Return a Rectangle from the receiver to rightBottom. \"\r\n\r\n\t^Rectangle leftTop: self rightBottom: rightBottom","function(self,rightBottom)\r\nreturn ((smalltalk.Rectangle):leftTop_rightBottom_(self,rightBottom));\r\nend")

smalltalk:bind(smalltalk.Point,"to:",0
,function(self,rightBottom)
return ((smalltalk.Rectangle):leftTop_rightBottom_(self,rightBottom));
end
,"converting","to: rightBottom\r\n\t\" Return a Rectangle from the receiver to rightBottom. \"\r\n\r\n\t^Rectangle leftTop: self rightBottom: rightBottom","function(self,rightBottom)\r\nreturn ((smalltalk.Rectangle):leftTop_rightBottom_(self,rightBottom));\r\nend")

smalltalk:bind(smalltalk.Rectangle["$klass"],"leftTop:extent:",0
,function(self,leftTop,extent)
return (((self):new()):leftTop_rightBottom_(leftTop,(leftTop):_plus(extent)));
end
,"instantiation","leftTop: leftTop extent: extent\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new leftTop: leftTop rightBottom: leftTop + extent","function(self,leftTop,extent)\r\nreturn (((self):new()):leftTop_rightBottom_(leftTop,(leftTop):_plus(extent)));\r\nend")

smalltalk:bind(smalltalk.Rectangle["$klass"],"leftTop:rightBottom:",0
,function(self,leftTop,rightBottom)
return (((self):new()):leftTop_rightBottom_(leftTop,rightBottom));
end
,"instantiation","leftTop: leftTop rightBottom: rightBottom\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new leftTop: leftTop rightBottom: rightBottom","function(self,leftTop,rightBottom)\r\nreturn (((self):new()):leftTop_rightBottom_(leftTop,rightBottom));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"=","_eq"
,function(self,aRectangle)
return (smalltalk:boolean_and_(((aRectangle):isRectangle()),(function()
return (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((self["@leftTop"]),(aRectangle):leftTop())),(function()
return (smalltalk:isObject_equalTo_((self["@rightBottom"]),(aRectangle):rightBottom()))
end)))
end)));
end
,"testing","= aRectangle\r\n\t\" Return true if the receiver is equal to argument. \"\r\n\r\n\t^aRectangle isRectangle\r\n\tand: [ leftTop = aRectangle leftTop\r\n\tand: [ rightBottom = aRectangle rightBottom ]]","function(self,aRectangle)\r\nreturn (smalltalk:boolean_and_(((aRectangle):isRectangle()),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:isObject_equalTo_((self[\"@leftTop\"]),(aRectangle):leftTop())),(function()\r\nreturn (smalltalk:isObject_equalTo_((self[\"@rightBottom\"]),(aRectangle):rightBottom()))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"area",0
,function(self)
return (((self):height()):_star((self):width()));
end
,"accessing","area\r\n\t\" Return the area of the receiver.\"\r\n\r\n\t^self height * self width","function(self)\r\nreturn (((self):height()):_star((self):width()));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"areasOutside:",0
,function(self,aRectangle)
if not (((self):intersects_(aRectangle)))==true then return ((smalltalk.Array):with_(self)); end;
if (smalltalk:boolean_and_(((aRectangle):containsPoint_((self):topLeft())),(function()
return ((aRectangle):containsPoint_((self):bottomRight()))
end)))==true then return (smalltalk:newArray({})); end;
return (((smalltalk.Array):with_with_with_with_(smalltalk:if_true_false_(((((aRectangle):top()) > (self):top())),(function()
return (((self):topLeft()):rightBottom_(((self):right()):_at((aRectangle):top())))
end),nil),smalltalk:if_true_false_(((((aRectangle):bottom()) < (self):bottom())),(function()
return ((((self):left()):_at((aRectangle):bottom())):rightBottom_((self):bottomRight()))
end),nil),smalltalk:if_true_false_(((((aRectangle):left()) > (self):left())),(function()
return ((((self):left()):_at(((self):top()):max_((aRectangle):top()))):rightBottom_(((aRectangle):left()):_at(((self):bottom()):min_((aRectangle):bottom()))))
end),nil),smalltalk:if_true_false_(((((aRectangle):right()) < (self):right())),(function()
return ((((aRectangle):right()):_at(((self):top()):max_((aRectangle):top()))):rightBottom_(((self):right()):_at(((self):bottom()):min_((aRectangle):bottom()))))
end),nil))):select_((function(each)
return (smalltalk:notNil_((each)))
end)));
end
,"accessing","areasOutside: aRectangle\r\n\t\"Return a collection of rectangles where the receiver do not intersect aRectangle. \"\r\n\r\n\t(self intersects: aRectangle) ifFalse: [ ^Array with: self ].\r\n\t((aRectangle containsPoint: self topLeft)\r\n\tand: [aRectangle containsPoint: self bottomRight])\r\n        ifTrue: [ ^#() ].\r\n\t^(Array\r\n\twith: (aRectangle top > self top ifTrue: [ self topLeft rightBottom: self right @ aRectangle top])\r\n\twith: (aRectangle bottom < self bottom ifTrue: [ self left @ aRectangle bottom rightBottom: self bottomRight])\r\n\twith: (aRectangle left > self left ifTrue: [ self left @ (self top max: aRectangle top) rightBottom: aRectangle left @ (self bottom min: aRectangle bottom) ])\r\n\twith: (aRectangle right < self right ifTrue: [ aRectangle right @ (self top max: aRectangle top) rightBottom: self right @ (self bottom min: aRectangle bottom) ])\r\n\t) select: [:each| each notNil ]","function(self,aRectangle)\r\nif not (((self):intersects_(aRectangle)))==true then return ((smalltalk.Array):with_(self)); end;\r\nif (smalltalk:boolean_and_(((aRectangle):containsPoint_((self):topLeft())),(function()\r\nreturn ((aRectangle):containsPoint_((self):bottomRight()))\r\nend)))==true then return (smalltalk:newArray({})); end;\r\nreturn (((smalltalk.Array):with_with_with_with_(smalltalk:if_true_false_(((((aRectangle):top()) > (self):top())),(function()\r\nreturn (((self):topLeft()):rightBottom_(((self):right()):_at((aRectangle):top())))\r\nend),nil),smalltalk:if_true_false_(((((aRectangle):bottom()) < (self):bottom())),(function()\r\nreturn ((((self):left()):_at((aRectangle):bottom())):rightBottom_((self):bottomRight()))\r\nend),nil),smalltalk:if_true_false_(((((aRectangle):left()) > (self):left())),(function()\r\nreturn ((((self):left()):_at(((self):top()):max_((aRectangle):top()))):rightBottom_(((aRectangle):left()):_at(((self):bottom()):min_((aRectangle):bottom()))))\r\nend),nil),smalltalk:if_true_false_(((((aRectangle):right()) < (self):right())),(function()\r\nreturn ((((aRectangle):right()):_at(((self):top()):max_((aRectangle):top()))):rightBottom_(((self):right()):_at(((self):bottom()):min_((aRectangle):bottom()))))\r\nend),nil))):select_((function(each)\r\nreturn (smalltalk:notNil_((each)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"bottom",0
,function(self)
return ((self["@rightBottom"]):y());
end
,"accessing","bottom\r\n\t\" Return the bottom of the receiver.\"\r\n\r\n\t^rightBottom y","function(self)\r\nreturn ((self[\"@rightBottom\"]):y());\r\nend")

smalltalk:bind(smalltalk.Rectangle,"bottomCenter",0
,function(self)
return ((((self):center()):x()):_at((self):bottom()));
end
,"accessing","bottomCenter\r\n\t\" Return the center of the bottom edge of the receiver. \"\r\n\r\n\t^self center x @ self bottom","function(self)\r\nreturn ((((self):center()):x()):_at((self):bottom()));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"bottomLeft",0
,function(self)
return (((self):left()):_at((self):bottom()));
end
,"accessing","bottomLeft\r\n\t\" Return the bottom-left corner of the receiver. \"\r\n\r\n\t^self left @ self bottom","function(self)\r\nreturn (((self):left()):_at((self):bottom()));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"bottomRight",0
,function(self)
return (self["@rightBottom"]);
end
,"accessing","bottomRight\r\n\t\" Return the bottom-right corner of the receiver. \"\r\n\r\n\t^rightBottom","function(self)\r\nreturn (self[\"@rightBottom\"]);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"center",0
,function(self)
return (((self["@leftTop"]):_plus(self["@rightBottom"])):_slash_slash(2));
end
,"accessing","center\r\n\t\" Return the center of the receiver. \"\r\n\r\n\t^leftTop + rightBottom // 2","function(self)\r\nreturn (((self[\"@leftTop\"]):_plus(self[\"@rightBottom\"])):_slash_slash(2));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"centerTop",0
,function(self)
return (((((self):right()):_plus((self):left())):_slash_slash(2)):_at((self):top()));
end
,"accessing","centerTop\r\n\t\" Return the center top of the receiver. \"\r\n\r\n\t^self right + self left // 2 @ self top","function(self)\r\nreturn (((((self):right()):_plus((self):left())):_slash_slash(2)):_at((self):top()));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"contains:",0
,function(self,aRectangle)
return (smalltalk:boolean_and_(((((self):left()) <= (aRectangle):left())),(function()
return (smalltalk:boolean_and_(((((aRectangle):right()) <= (self):right())),(function()
return (smalltalk:boolean_and_(((((self):bottom()) >= (aRectangle):bottom())),(function()
return ((((aRectangle):top()) >= (self):top()))
end)))
end)))
end)));
end
,"testing","contains: aRectangle\r\n\t\" Return true if aRectangle lies completely within or on the edge of the receiver. \"\r\n\r\n\t^self left <= aRectangle left\r\n\tand: [ aRectangle right <= self right\r\n\tand: [ self bottom >= aRectangle bottom\r\n\tand: [ aRectangle top >= self top ]]]","function(self,aRectangle)\r\nreturn (smalltalk:boolean_and_(((((self):left()) <= (aRectangle):left())),(function()\r\nreturn (smalltalk:boolean_and_(((((aRectangle):right()) <= (self):right())),(function()\r\nreturn (smalltalk:boolean_and_(((((self):bottom()) >= (aRectangle):bottom())),(function()\r\nreturn ((((aRectangle):top()) >= (self):top()))\r\nend)))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"containsPoint:",0
,function(self,aPoint)
return (smalltalk:boolean_and_(((((self):left()) <= (aPoint):x())),(function()
return (smalltalk:boolean_and_(((((aPoint):x()) < (self):right())),(function()
return (smalltalk:boolean_and_(((((self):bottom()) > (aPoint):y())),(function()
return ((((aPoint):y()) >= (self):top()))
end)))
end)))
end)));
end
,"testing","containsPoint: aPoint\r\n\t\" Return true if aPoint is contained within the receiver. \"\r\n\r\n\t^(self left <= aPoint x)\r\n\tand: [ aPoint x < self right\r\n\tand: [ self bottom > aPoint y\r\n\tand: [ aPoint y >= self top ]]]","function(self,aPoint)\r\nreturn (smalltalk:boolean_and_(((((self):left()) <= (aPoint):x())),(function()\r\nreturn (smalltalk:boolean_and_(((((aPoint):x()) < (self):right())),(function()\r\nreturn (smalltalk:boolean_and_(((((self):bottom()) > (aPoint):y())),(function()\r\nreturn ((((aPoint):y()) >= (self):top()))\r\nend)))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"expandBy:",0
,function(self,delta)
if ((delta):isRectangle())==true then return (((self["@leftTop"]):_minus((delta):leftTop())):rightBottom_((self["@rightBottom"]):_plus((delta):rightBottom()))); end;
return (((self["@leftTop"]):_minus(delta)):rightBottom_((self["@rightBottom"]):_plus(delta)));
end
,"accessing","expandBy: delta\r\n\t\" Return a Rectangle obtained from the receiver expanded by delta. \"\r\n\r\n\tdelta isRectangle ifTrue: [\r\n            ^leftTop - delta leftTop rightBottom: rightBottom + delta rightBottom\r\n\t].\r\n\t^leftTop - delta rightBottom: rightBottom + delta","function(self,delta)\r\nif ((delta):isRectangle())==true then return (((self[\"@leftTop\"]):_minus((delta):leftTop())):rightBottom_((self[\"@rightBottom\"]):_plus((delta):rightBottom()))); end;\r\nreturn (((self[\"@leftTop\"]):_minus(delta)):rightBottom_((self[\"@rightBottom\"]):_plus(delta)));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"extent",0
,function(self)
return (((self):width()):_at((self):height()));
end
,"accessing","extent\r\n\t\" Return receiver's width and height.\"\r\n\r\n\t^self width @ self height","function(self)\r\nreturn (((self):width()):_at((self):height()));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"extent:",0
,function(self,aPoint)
(self):width_((aPoint):x());
(self):height_((aPoint):y());
return (self);
end
,"accessing","extent: aPoint\r\n\t\" Set the extent of receiver to aPoint. \"\r\n\r\n\tself width: aPoint x.\r\n\tself height: aPoint y","function(self,aPoint)\r\n(self):width_((aPoint):x());\r\n(self):height_((aPoint):y());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"height",0
,function(self)
return ((((self["@leftTop"]):y()):_minus((self["@rightBottom"]):y())):abs());
end
,"accessing","height\r\n\t\" Return the height of the receiver. \"\r\n\r\n\t^(leftTop y - rightBottom y) abs","function(self)\r\nreturn ((((self[\"@leftTop\"]):y()):_minus((self[\"@rightBottom\"]):y())):abs());\r\nend")

smalltalk:bind(smalltalk.Rectangle,"height:",0
,function(self,aNumber)
(self["@rightBottom"]):y_(((self["@leftTop"]):y()):_plus(aNumber));
return (self);
end
,"accessing","height: aNumber\r\n\t\" Change the height of the receiver. \"\r\n\r\n\trightBottom y: leftTop y + aNumber","function(self,aNumber)\r\n(self[\"@rightBottom\"]):y_(((self[\"@leftTop\"]):y()):_plus(aNumber));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"insetBy:",0
,function(self,delta)
if ((delta):isRectangle())==true then return (((self["@leftTop"]):_plus((delta):leftTop())):rightBottom_((self["@rightBottom"]):_minus((delta):rightBottom()))); end;
return (((self["@leftTop"]):_plus(delta)):rightBottom_((self["@rightBottom"]):_minus(delta)));
end
,"accessing","insetBy: delta\r\n\t\" Return the receiver inset by delta. \"\r\n\r\n\tdelta isRectangle ifTrue: [\r\n            ^leftTop + delta leftTop rightBottom: rightBottom - delta rightBottom\r\n\t].\r\n\t^leftTop + delta rightBottom: rightBottom - delta","function(self,delta)\r\nif ((delta):isRectangle())==true then return (((self[\"@leftTop\"]):_plus((delta):leftTop())):rightBottom_((self[\"@rightBottom\"]):_minus((delta):rightBottom()))); end;\r\nreturn (((self[\"@leftTop\"]):_plus(delta)):rightBottom_((self[\"@rightBottom\"]):_minus(delta)));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"intersect:",0
,function(self,aRectangle)
if (smalltalk:isNil_((aRectangle)))==true then return (self); end;
return (((self["@leftTop"]):max_((aRectangle):leftTop())):rightBottom_((self["@rightBottom"]):min_((aRectangle):rightBottom())));
end
,"accessing","intersect: aRectangle\r\n\t\" Return the rectangle in which the receiver and aRectangle overlap. \"\r\n\r\n\taRectangle isNil ifTrue: [ ^self ].\r\n\t^(leftTop max: aRectangle leftTop)\r\n        rightBottom: (rightBottom min: aRectangle rightBottom)","function(self,aRectangle)\r\nif (smalltalk:isNil_((aRectangle)))==true then return (self); end;\r\nreturn (((self[\"@leftTop\"]):max_((aRectangle):leftTop())):rightBottom_((self[\"@rightBottom\"]):min_((aRectangle):rightBottom())));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"intersects:",0
,function(self,aRectangle)
return (smalltalk:boolean_and_((((self["@leftTop"]) < (aRectangle):rightBottom())),(function()
return ((((aRectangle):leftTop()) < self["@rightBottom"]))
end)));
end
,"accessing","intersects: aRectangle\r\n\t\" Return true if the receiver and aRectangle have any area in common. \"\r\n\r\n\t^leftTop < aRectangle rightBottom\r\n\tand: [ aRectangle leftTop < rightBottom ]","function(self,aRectangle)\r\nreturn (smalltalk:boolean_and_((((self[\"@leftTop\"]) < (aRectangle):rightBottom())),(function()\r\nreturn ((((aRectangle):leftTop()) < self[\"@rightBottom\"]))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"isRectangle",0
,function(self)
return (true);
end
,"testing","isRectangle\r\n\t\" Return true if receiver is a Rectangle. \"\r\n\r\n\t^true","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"left",0
,function(self)
return ((self["@leftTop"]):x());
end
,"accessing","left\r\n\t\" Return the left of the receiver. \"\r\n\r\n\t^leftTop x","function(self)\r\nreturn ((self[\"@leftTop\"]):x());\r\nend")

smalltalk:bind(smalltalk.Rectangle,"leftBottom",0
,function(self)
return (((self):left()):_at((self):bottom()));
end
,"accessing","leftBottom\r\n\t\" Return the left bottom corner of the receiver. \"\r\n\r\n\t^self left @ self bottom","function(self)\r\nreturn (((self):left()):_at((self):bottom()));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"leftCenter",0
,function(self)
return (((self):left()):_at(((self):center()):y()));
end
,"accessing","leftCenter\r\n\t\" Return the center of the left edge of the receiver. \"\r\n\r\n\t^self left @ self center y","function(self)\r\nreturn (((self):left()):_at(((self):center()):y()));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"leftTop",0
,function(self)
return (self["@leftTop"]);
end
,"accessing","leftTop\r\n\t\" Return the left top of the receiver. \"\r\n\r\n\t^leftTop","function(self)\r\nreturn (self[\"@leftTop\"]);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"leftTop:",0
,function(self,aPoint)
(function()
	local _s8_value=(aPoint)
	self["@leftTop"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","leftTop: aPoint\r\n\t\" Set the leftTop of the receiver.\"\r\n\r\n\tleftTop := aPoint","function(self,aPoint)\r\n(function()\r\n\tlocal _s8_value=(aPoint)\r\n\tself[\"@leftTop\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"leftTop:rightBottom:",0
,function(self,leftTopPoint,rightBottomPoint)
(function()
	local _s8_value=(leftTopPoint)
	self["@leftTop"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(rightBottomPoint)
	self["@rightBottom"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","leftTop: leftTopPoint rightBottom: rightBottomPoint\r\n\t\"Set the receiver's coordinates. \"\r\n\r\n\tleftTop := leftTopPoint.\r\n\trightBottom := rightBottomPoint.","function(self,leftTopPoint,rightBottomPoint)\r\n(function()\r\n\tlocal _s8_value=(leftTopPoint)\r\n\tself[\"@leftTop\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(rightBottomPoint)\r\n\tself[\"@rightBottom\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"merge:",0
,function(self,aRectangle)
if (smalltalk:isNil_((aRectangle)))==true then return (self); end;
return (((self["@leftTop"]):min_((aRectangle):leftTop())):rightBottom_((self["@rightBottom"]):max_((aRectangle):rightBottom())));
end
,"accessing","merge: aRectangle\r\n\t\" Return a Rectangle representing the area in which the receiver and aRectangle merged together. \"\r\n\r\n\taRectangle isNil ifTrue: [ ^self ].\r\n\t^(leftTop min: aRectangle leftTop) rightBottom: (rightBottom max: aRectangle rightBottom)","function(self,aRectangle)\r\nif (smalltalk:isNil_((aRectangle)))==true then return (self); end;\r\nreturn (((self[\"@leftTop\"]):min_((aRectangle):leftTop())):rightBottom_((self[\"@rightBottom\"]):max_((aRectangle):rightBottom())));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"moveBy:",0
,function(self,aPoint)
(function()
	local _s8_value=((self["@leftTop"]):_plus(aPoint))
	self["@leftTop"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self["@rightBottom"]):_plus(aPoint))
	self["@rightBottom"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","moveBy: aPoint\r\n\t\" Move the receiver by aPoint. \"\r\n\r\n\tleftTop := leftTop + aPoint.\r\n\trightBottom := rightBottom + aPoint","function(self,aPoint)\r\n(function()\r\n\tlocal _s8_value=((self[\"@leftTop\"]):_plus(aPoint))\r\n\tself[\"@leftTop\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self[\"@rightBottom\"]):_plus(aPoint))\r\n\tself[\"@rightBottom\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"moveTo:",0
,function(self,aPoint)
(self):moveBy_((aPoint):_minus(self["@leftTop"]));
return (self);
end
,"accessing","moveTo: aPoint\r\n\t\" Move the receiver to aPoint. \"\r\n\r\n\tself moveBy: aPoint - leftTop","function(self,aPoint)\r\n(self):moveBy_((aPoint):_minus(self[\"@leftTop\"]));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"moveToLeftTop:",0
,function(self,aPoint)
(self):moveBy_((aPoint):_minus((self):leftTop()));
return (self);
end
,"accessing","moveToLeftTop: aPoint\r\n\t\" Move the receiver to leftTop. \"\r\n\r\n\tself moveBy: aPoint - self leftTop","function(self,aPoint)\r\n(self):moveBy_((aPoint):_minus((self):leftTop()));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"nonIntersections:",0
,function(self,aRectangle)
local areas=nil
if not (((self):intersects_(aRectangle)))==true then return ((smalltalk.Array):with_(self)); end;
if (smalltalk:boolean_and_(((aRectangle):containsPoint_(self["@leftTop"])),(function()
return ((aRectangle):containsPoint_(self["@rightBottom"]))
end)))==true then return (smalltalk:newArray({})); end;
return (((smalltalk.Array):with_with_with_with_(smalltalk:if_true_false_(((((aRectangle):top()) > (self):top())),(function()
return ((self["@leftTop"]):rightBottom_(((self["@rightBottom"]):x()):_at((aRectangle):top())))
end),nil),smalltalk:if_true_false_(((((aRectangle):bottom()) < (self):bottom())),(function()
return ((((self["@leftTop"]):x()):_at((aRectangle):bottom())):rightBottom_(self["@rightBottom"]))
end),nil),smalltalk:if_true_false_(((((aRectangle):left()) > (self):left())),(function()
return ((((self["@leftTop"]):x()):_at(((self["@leftTop"]):y()):max_((aRectangle):top()))):rightBottom_(((aRectangle):left()):_at(((self["@rightBottom"]):y()):min_((aRectangle):bottom()))))
end),nil),smalltalk:if_true_false_(((((aRectangle):right()) < (self):right())),(function()
return ((((aRectangle):right()):_at(((self["@leftTop"]):y()):max_((aRectangle):top()))):rightBottom_(((self["@rightBottom"]):x()):_at(((self["@rightBottom"]):y()):min_((aRectangle):bottom()))))
end),nil))):select_((function(each)
return (smalltalk:notNil_((each)))
end)));
end
,"accessing","nonIntersections: aRectangle\r\n\t\" Return the rectangles describing areas of the receiver outside aRectangle. \"\r\n\r\n\t| areas |\r\n\t(self intersects: aRectangle) ifFalse: [ ^Array with: self ].\r\n\t((aRectangle containsPoint: leftTop)\r\n\t\tand: [ aRectangle containsPoint: rightBottom ])\r\n\t\tifTrue: [ ^#() ].\r\n\t^(Array\r\n\twith: (aRectangle top > self top ifTrue: [ leftTop rightBottom: rightBottom x @ aRectangle top ])\r\n\twith: (aRectangle bottom < self bottom ifTrue: [ leftTop x @ aRectangle bottom rightBottom: rightBottom ])\r\n\twith: (aRectangle left > self left ifTrue: [ leftTop x @ (leftTop y max: aRectangle top)\r\n                rightBottom: aRectangle left @ (rightBottom y min: aRectangle bottom) ])\r\n\twith: (aRectangle right < self right ifTrue: [ aRectangle right @ (leftTop y max: aRectangle top)\r\n                rightBottom: rightBottom x @ (rightBottom y min: aRectangle bottom) ])\r\n\t) select: [:each| each notNil ]","function(self,aRectangle)\r\nlocal areas=nil\r\nif not (((self):intersects_(aRectangle)))==true then return ((smalltalk.Array):with_(self)); end;\r\nif (smalltalk:boolean_and_(((aRectangle):containsPoint_(self[\"@leftTop\"])),(function()\r\nreturn ((aRectangle):containsPoint_(self[\"@rightBottom\"]))\r\nend)))==true then return (smalltalk:newArray({})); end;\r\nreturn (((smalltalk.Array):with_with_with_with_(smalltalk:if_true_false_(((((aRectangle):top()) > (self):top())),(function()\r\nreturn ((self[\"@leftTop\"]):rightBottom_(((self[\"@rightBottom\"]):x()):_at((aRectangle):top())))\r\nend),nil),smalltalk:if_true_false_(((((aRectangle):bottom()) < (self):bottom())),(function()\r\nreturn ((((self[\"@leftTop\"]):x()):_at((aRectangle):bottom())):rightBottom_(self[\"@rightBottom\"]))\r\nend),nil),smalltalk:if_true_false_(((((aRectangle):left()) > (self):left())),(function()\r\nreturn ((((self[\"@leftTop\"]):x()):_at(((self[\"@leftTop\"]):y()):max_((aRectangle):top()))):rightBottom_(((aRectangle):left()):_at(((self[\"@rightBottom\"]):y()):min_((aRectangle):bottom()))))\r\nend),nil),smalltalk:if_true_false_(((((aRectangle):right()) < (self):right())),(function()\r\nreturn ((((aRectangle):right()):_at(((self[\"@leftTop\"]):y()):max_((aRectangle):top()))):rightBottom_(((self[\"@rightBottom\"]):x()):_at(((self[\"@rightBottom\"]):y()):min_((aRectangle):bottom()))))\r\nend),nil))):select_((function(each)\r\nreturn (smalltalk:notNil_((each)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"toString",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:toString_((self["@leftTop"])))," to: ")),smalltalk:toString_((self["@rightBottom"]))));
end
,"printing","toString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^leftTop toString ,' to: ' ,rightBottom toString ","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:toString_((self[\"@leftTop\"]))),\" to: \")),smalltalk:toString_((self[\"@rightBottom\"]))));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"printString",0
,function(self)

return (smalltalk:toString_((self)));
end
,"printing","printString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t{'self'}.\r\n\t^self toString","function(self)\r\n\r\nreturn (smalltalk:toString_((self)));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"relativeTo:",0
,function(self,aRectangle)
local extent=nil
(function()
	local _s8_value=((aRectangle):extent())
	extent=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_or_((smalltalk:isObject_equalTo_((((aRectangle):extent()):x()),0)),(function()
return (smalltalk:isObject_equalTo_((((aRectangle):extent()):y()),0))
end)))==true then return (self); end;
return ((((self["@leftTop"]):_minus((aRectangle):leftTop())):_slash(extent)):extent_(((self):extent()):_slash(extent)));
end
,"accessing","relativeTo: aRectangle\r\n\t\" Return a Rectangle proportionally relative to aRectangle. \"\r\n\r\n\t| extent |\r\n\textent := aRectangle extent.\r\n\t(aRectangle extent x = 0 or: [ aRectangle extent y = 0 ]) ifTrue: [ ^self ].\r\n\t^leftTop - aRectangle leftTop / extent extent: self extent / extent","function(self,aRectangle)\r\nlocal extent=nil\r\n(function()\r\n\tlocal _s8_value=((aRectangle):extent())\r\n\textent=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_or_((smalltalk:isObject_equalTo_((((aRectangle):extent()):x()),0)),(function()\r\nreturn (smalltalk:isObject_equalTo_((((aRectangle):extent()):y()),0))\r\nend)))==true then return (self); end;\r\nreturn ((((self[\"@leftTop\"]):_minus((aRectangle):leftTop())):_slash(extent)):extent_(((self):extent()):_slash(extent)));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"right",0
,function(self)
return ((self["@rightBottom"]):x());
end
,"accessing","right\r\n\t\" Return the receiver's right side. \"\r\n\r\n\t^rightBottom x","function(self)\r\nreturn ((self[\"@rightBottom\"]):x());\r\nend")

smalltalk:bind(smalltalk.Rectangle,"rightBottom",0
,function(self)
return (self["@rightBottom"]);
end
,"accessing","rightBottom\r\n\t\" Return the right bottom corner. \"\r\n\r\n\t^rightBottom","function(self)\r\nreturn (self[\"@rightBottom\"]);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"rightBottom:",0
,function(self,aPoint)
(function()
	local _s8_value=(aPoint)
	self["@rightBottom"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","rightBottom: aPoint\r\n\t\" Set the right bottom corner of the receiver. \"\r\n\r\n\trightBottom := aPoint","function(self,aPoint)\r\n(function()\r\n\tlocal _s8_value=(aPoint)\r\n\tself[\"@rightBottom\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"rightCenter",0
,function(self)
return (((self):right()):_at(((self):center()):y()));
end
,"accessing","rightCenter\r\n\t\" Return the center of the right edge of the receiver. \"\r\n\r\n\t^self right @ self center y","function(self)\r\nreturn (((self):right()):_at(((self):center()):y()));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"rightTop",0
,function(self)
return (((self):right()):_at((self):top()));
end
,"accessing","rightTop\r\n        \" Return the right top of the receiver. \"\r\n\r\n\t^self right @ self top","function(self)\r\nreturn (((self):right()):_at((self):top()));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"rounded",0
,function(self)
(function()
	local _s8_value=((self["@leftTop"]):rounded())
	self["@leftTop"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self["@rightBottom"]):rounded())
	self["@rightBottom"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","rounded\r\n\t\" Set the receiver with coordinates rounded to integers. \"\r\n\r\n\tleftTop := leftTop rounded.\r\n\trightBottom := rightBottom rounded.","function(self)\r\n(function()\r\n\tlocal _s8_value=((self[\"@leftTop\"]):rounded())\r\n\tself[\"@leftTop\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self[\"@rightBottom\"]):rounded())\r\n\tself[\"@rightBottom\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"scaleBy:",0
,function(self,delta)
return (((self["@leftTop"]):_star(delta)):rightBottom_((self["@rightBottom"]):_star(delta)));
end
,"accessing","scaleBy: delta\r\n\t\" Return the receiver multiplied by delta. \"\r\n\r\n\t^leftTop * delta rightBottom: rightBottom * delta","function(self,delta)\r\nreturn (((self[\"@leftTop\"]):_star(delta)):rightBottom_((self[\"@rightBottom\"]):_star(delta)));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"scaleTo:",0
,function(self,aRectangle)
return ((((aRectangle):scaleBy_((self):extent())):truncated()):moveBy_((self):leftTop()));
end
,"accessing","scaleTo: aRectangle\r\n\t\" Return a Rectangle whose size is proportional to the receiver with ratios specified by aRectangle. \"\r\n\r\n\t^(aRectangle scaleBy: self extent) truncated moveBy: self leftTop","function(self,aRectangle)\r\nreturn ((((aRectangle):scaleBy_((self):extent())):truncated()):moveBy_((self):leftTop()));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"top",0
,function(self)
return ((self["@leftTop"]):y());
end
,"accessing","top\r\n\t\" Return the top side of the receiver. \"\r\n\r\n\t^leftTop y","function(self)\r\nreturn ((self[\"@leftTop\"]):y());\r\nend")

smalltalk:bind(smalltalk.Rectangle,"topCenter",0
,function(self)
return ((((self):center()):x()):_at((self):top()));
end
,"accessing","topCenter\r\n\t\" Return the center of the top edge of the receiver. \"\r\n\r\n\t^self center x @ self top","function(self)\r\nreturn ((((self):center()):x()):_at((self):top()));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"topLeft",0
,function(self)
return (self["@leftTop"]);
end
,"accessing","topLeft\r\n\t\" Return the top-left corner of the receiver. \"\r\n\r\n\t^leftTop","function(self)\r\nreturn (self[\"@leftTop\"]);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"topLeft:",0
,function(self,aPoint)
(function()
	local _s8_value=(aPoint)
	self["@leftTop"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","topLeft: aPoint\r\n\t\"Set the top left corner of the receiver. \"\r\n\r\n\tleftTop := aPoint","function(self,aPoint)\r\n(function()\r\n\tlocal _s8_value=(aPoint)\r\n\tself[\"@leftTop\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"topRight",0
,function(self)
return (((self):right()):_at((self):top()));
end
,"accessing","topRight\r\n\t\" Return the top-right corner of the receiver. \"\r\n\r\n\t^self right @ self top","function(self)\r\nreturn (((self):right()):_at((self):top()));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"translateBy:",0
,function(self,delta)
return (((self["@leftTop"]):_plus(delta)):rightBottom_((self["@rightBottom"]):_plus(delta)));
end
,"accessing","translateBy: delta\r\n\t\" Return the receiver with position incremented by delta. \"\r\n\r\n\t^leftTop + delta rightBottom: rightBottom + delta","function(self,delta)\r\nreturn (((self[\"@leftTop\"]):_plus(delta)):rightBottom_((self[\"@rightBottom\"]):_plus(delta)));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"truncated",0
,function(self)
(function()
	local _s8_value=((self["@leftTop"]):truncated())
	self["@leftTop"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self["@rightBottom"]):truncated())
	self["@rightBottom"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","truncated\r\n\t\" Set the receiver with the coordinates truncated to integers. \"\r\n\r\n\tleftTop := leftTop truncated.\r\n\trightBottom := rightBottom truncated.","function(self)\r\n(function()\r\n\tlocal _s8_value=((self[\"@leftTop\"]):truncated())\r\n\tself[\"@leftTop\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self[\"@rightBottom\"]):truncated())\r\n\tself[\"@rightBottom\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Rectangle,"width",0
,function(self)
return ((((self["@rightBottom"]):x()):_minus((self["@leftTop"]):x())):abs());
end
,"accessing","width\r\n\t\" Return the width of the receiver. \"\r\n\r\n\t^(rightBottom x - leftTop x) abs","function(self)\r\nreturn ((((self[\"@rightBottom\"]):x()):_minus((self[\"@leftTop\"]):x())):abs());\r\nend")

smalltalk:bind(smalltalk.Rectangle,"width:",0
,function(self,anInteger)
(self["@rightBottom"]):x_(((self["@leftTop"]):x()):_plus(anInteger));
return (self);
end
,"accessing","width: anInteger\r\n\t\" Set the width of the receiver. \"\r\n\r\n\trightBottom x: leftTop x + anInteger","function(self,anInteger)\r\n(self[\"@rightBottom\"]):x_(((self[\"@leftTop\"]):x()):_plus(anInteger));\r\nreturn (self);\r\nend")

smalltalk:addClass("EvaluableAction",smalltalk.Object,smalltalk:newArray({}),"Kernel")
smalltalk.EvaluableAction["$comment"]="\r\n\tAction model, evaluable and composable actions are implemented to support evaluations.\r\n"

smalltalk:addClass("Message",smalltalk.EvaluableAction,smalltalk:newArray({"selector","arguments","receiver"}),"Kernel")

smalltalk:bind(smalltalk.Message["$klass"],"selector:arguments:",0
,function(self,aString,anArray)
return ((
function(_s8_rec)
	(_s8_rec):selector_(aString);
	(_s8_rec):arguments_(anArray);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","selector: aString arguments: anArray\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tselector: aString;\r\n\t\targuments: anArray;\r\n\t\tyourself","function(self,aString,anArray)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):selector_(aString);\r\n\t(_s8_rec):arguments_(anArray);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.Message["$klass"],"receiver:selector:arguments:",0
,function(self,anObject,aString,anArray)
return ((
function(_s8_rec)
	(_s8_rec):receiver_(anObject);
	(_s8_rec):selector_(aString);
	(_s8_rec):arguments_(anArray);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","receiver: anObject selector: aString arguments: anArray\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\treceiver: anObject;\r\n\t\tselector: aString;\r\n\t\targuments: anArray;\r\n\t\tyourself","function(self,anObject,aString,anArray)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):receiver_(anObject);\r\n\t(_s8_rec):selector_(aString);\r\n\t(_s8_rec):arguments_(anArray);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.Message,"selector",0
,function(self)
return (self["@selector"]);
end
,"accessing","selector\r\n\t\" Return the selector of the receiver. \"\r\n\r\n\t^selector","function(self)\r\nreturn (self[\"@selector\"]);\r\nend")

smalltalk:bind(smalltalk.Message,"selector:",0
,function(self,aString)
(function()
	local _s8_value=(aString)
	self["@selector"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","selector: aString\r\n\t\" Set the selector of the receiver. \"\r\n\r\n\tselector := aString","function(self,aString)\r\n(function()\r\n\tlocal _s8_value=(aString)\r\n\tself[\"@selector\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Message,"arguments:",0
,function(self,anArray)
(function()
	local _s8_value=(anArray)
	self["@arguments"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","arguments: anArray\r\n\t\" Set the arguments of the receiver. \"\r\n\r\n\targuments := anArray","function(self,anArray)\r\n(function()\r\n\tlocal _s8_value=(anArray)\r\n\tself[\"@arguments\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Message,"arguments",0
,function(self)
return (self["@arguments"]);
end
,"accessing","arguments\r\n\t\" Return the arguments of the receiver. \"\r\n\r\n\t^arguments","function(self)\r\nreturn (self[\"@arguments\"]);\r\nend")

smalltalk:bind(smalltalk.Message,"receiver",0
,function(self)
return (self["@receiver"]);
end
,"accessing","receiver\r\n\t\" Return the receiver of the receiver. \"\r\n\r\n\t^receiver","function(self)\r\nreturn (self[\"@receiver\"]);\r\nend")

smalltalk:bind(smalltalk.Message,"receiver:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@receiver"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","receiver: anObject\r\n\t\" Set the receiver of the receiver. \"\r\n\r\n\treceiver := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@receiver\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Message,"comment",0
,function(self)
return ((self)["@comment"]);
end
,"accessing","comment\r\n\t\" Return the comment of the receiver (or nil). \"\r\n\r\n\t^self basicAt: '@comment'","function(self)\r\nreturn ((self)[\"@comment\"]);\r\nend")

smalltalk:bind(smalltalk.Message,"comment:",0
,function(self,aString)
if (smalltalk:isNil_((aString)))==true then return ((self):basicDelete_("@comment")); end;
smalltalk:basic_at_put_((self),"@comment",aString);
return (self);
end
,"accessing","comment: aString\r\n\t\" Set the comment of the receiver. \"\r\n\r\n\taString isNil ifTrue: [ ^self basicDelete: '@comment' ].\r\n\tself basicAt: '@comment' put: aString","function(self,aString)\r\nif (smalltalk:isNil_((aString)))==true then return ((self):basicDelete_(\"@comment\")); end;\r\nsmalltalk:basic_at_put_((self),\"@comment\",aString);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Message,"perform",0
,function(self)
return (((self):receiver()):perform_withArguments_((self):selector(),(self):arguments()));
end
,"private","perform\r\n\t\" Return the result of sending the receiver. \"\r\n\r\n\t^self receiver\r\n\t\tperform: self selector\r\n\t\twithArguments: self arguments","function(self)\r\nreturn (((self):receiver()):perform_withArguments_((self):selector(),(self):arguments()));\r\nend")

smalltalk:bind(smalltalk.Message,"performDeferred",0
,function(self)
((function()
return ((self):perform())
end)):valueDeferred();
return (self);
end
,"evaluating","performDeferred\r\n\t\" Evaluate the receiver deferred in time.\r\n\tReturn the receiver.\r\n\t\"\r\n\r\n\t[ self perform ] valueDeferred.","function(self)\r\n((function()\r\nreturn ((self):perform())\r\nend)):valueDeferred();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Message,"evaluate",0
,function(self)
return ((self):perform());
end
,"evaluating","evaluate\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self perform","function(self)\r\nreturn ((self):perform());\r\nend")

smalltalk:bind(smalltalk.Message,"evaluateFor:",0
,function(self,anObject)
return ((self):evaluateWithArguments_((smalltalk.Array):with_(anObject)));
end
,"evaluating","evaluateFor: anObject\r\n\t\" Return the result of evaluating the receiver with anObject. \"\r\n\r\n\t^self evaluateWithArguments: (Array with: anObject)","function(self,anObject)\r\nreturn ((self):evaluateWithArguments_((smalltalk.Array):with_(anObject)));\r\nend")

smalltalk:bind(smalltalk.Message,"evaluateWithArguments:",0
,function(self,anArray)
return (((self):receiver()):perform_withArguments_((self):selector(),(self):collectArguments_(anArray)));
end
,"evaluating","evaluateWithArguments: anArray\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self receiver\r\n\t\tperform: self selector\r\n\t\twithArguments: (self collectArguments: anArray)","function(self,anArray)\r\nreturn (((self):receiver()):perform_withArguments_((self):selector(),(self):collectArguments_(anArray)));\r\nend")

smalltalk:bind(smalltalk.Message,"initializeArguments",0
,function(self)
(function()
	local _s8_value=((smalltalk.Array):new_(((self):selector()):argumentCount()))
	self["@arguments"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"private","initializeArguments\r\n\t\" Private - Initialize the arguments of the receiver. \"\r\n\r\n\targuments := Array new: self selector argumentCount","function(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new_(((self):selector()):argumentCount()))\r\n\tself[\"@arguments\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Message,"argumentCount",0
,function(self)
if (smalltalk:isNil_((self["@arguments"])))==true then (self):initializeArguments(); end;
return ((self["@arguments"]):size());
end
,"private","argumentCount\r\n\t\" Return the number of arguments of the receiver. \"\r\n\r\n\targuments isNil ifTrue: [ self initializeArguments ].\r\n\t^arguments size","function(self)\r\nif (smalltalk:isNil_((self[\"@arguments\"])))==true then (self):initializeArguments(); end;\r\nreturn ((self[\"@arguments\"]):size());\r\nend")

smalltalk:bind(smalltalk.Message,"collectArguments:",0
,function(self,evaluationArguments)
if (smalltalk:isObject_equalTo_(((self["@arguments"]):size()),(evaluationArguments):size()))==true then return (evaluationArguments); end;
return ((evaluationArguments):copyFrom_to_(1,((self):argumentCount()):min_((evaluationArguments):size())));
end
,"private","collectArguments: evaluationArguments\r\n\t\" Private - Return the arguments to evaluate the receiver. \"\r\n\r\n\targuments size = evaluationArguments size ifTrue: [ ^evaluationArguments ].\r\n\t^evaluationArguments copyFrom: 1 to: (self argumentCount min: evaluationArguments size)","function(self,evaluationArguments)\r\nif (smalltalk:isObject_equalTo_(((self[\"@arguments\"]):size()),(evaluationArguments):size()))==true then return (evaluationArguments); end;\r\nreturn ((evaluationArguments):copyFrom_to_(1,((self):argumentCount()):min_((evaluationArguments):size())));\r\nend")

smalltalk:bind(smalltalk.Message,"resolve:with:",0
,function(self,what,aPoolOrBlock)
if not (((aPoolOrBlock):isMemberOf_(smalltalk.PoolDictionary)))==true then return ((aPoolOrBlock):evaluateWith_(what)); end;
if (smalltalk:isNil_((what)))==true then return (what); end;
if not (((self):isObject_(what)))==true then return (what); end;
if ((what):isString())==true then return ((aPoolOrBlock):at_ifAbsent_(what,(function()
return (what)
end))); end;
return (what);
end
,"resolution","resolve: what with: aPoolOrBlock\r\n\t\" Private - Return the receiver to be evaluated with mappings given by aPoolOrBlock. \"\r\n\r\n\t(aPoolOrBlock isMemberOf: PoolDictionary) ifFalse: [\r\n\t\t^aPoolOrBlock evaluateWith: what\r\n\t].\r\n\twhat isNil ifTrue: [ ^what ].\r\n\t(self isObject: what) ifFalse: [ ^what ].\r\n\twhat isString ifTrue: [ ^aPoolOrBlock at: what ifAbsent: [ what ] ].\r\n\t^what","function(self,what,aPoolOrBlock)\r\nif not (((aPoolOrBlock):isMemberOf_(smalltalk.PoolDictionary)))==true then return ((aPoolOrBlock):evaluateWith_(what)); end;\r\nif (smalltalk:isNil_((what)))==true then return (what); end;\r\nif not (((self):isObject_(what)))==true then return (what); end;\r\nif ((what):isString())==true then return ((aPoolOrBlock):at_ifAbsent_(what,(function()\r\nreturn (what)\r\nend))); end;\r\nreturn (what);\r\nend")

smalltalk:bind(smalltalk.Message,"resolveWith:",0
,function(self,aPoolOrBlock)
local args=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((self["@arguments"]))),(function()
return ((self["@arguments"]):collect_((function(each)
return ((self):resolve_with_(each,aPoolOrBlock))
end)))
end),nil))
	args=_s8_value
	return _s8_value
end)();
return (((self)["$klass"]):receiver_selector_arguments_((self):resolve_with_(self["@receiver"],aPoolOrBlock),(self):selector(),args));
end
,"resolution","resolveWith: aPoolOrBlock\r\n\t\" Return a message set to be evaluated with mappings given by aPoolOrBlock. \"\r\n\r\n\t| args |\r\n\targs := arguments notNil ifTrue: [\r\n\t\targuments collect: [:each|\r\n\t\t\tself resolve: each with: aPoolOrBlock\r\n\t\t]\r\n\t].\r\n\t^self class\r\n\t\treceiver: (self resolve: receiver with: aPoolOrBlock)\r\n\t\tselector: self selector\r\n\t\targuments: args","function(self,aPoolOrBlock)\r\nlocal args=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((self[\"@arguments\"]))),(function()\r\nreturn ((self[\"@arguments\"]):collect_((function(each)\r\nreturn ((self):resolve_with_(each,aPoolOrBlock))\r\nend)))\r\nend),nil))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (((self)[\"$klass\"]):receiver_selector_arguments_((self):resolve_with_(self[\"@receiver\"],aPoolOrBlock),(self):selector(),args));\r\nend")

smalltalk:bind(smalltalk.Message,"isMessage",0
,function(self)
return (true);
end
,"testing","isMessage\r\n\t\" Return true if the receiver is a message. \"\r\n\r\n\t^true","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.Object,"isMessage",0
,function(self)
return (false);
end
,"testing","isMessage\r\n\t\" Return true if the receiver is a message. \"\r\n\r\n\t^false","function(self)\r\nreturn (false);\r\nend")

smalltalk:addClass("MessageNotUnderstood",smalltalk.Error,smalltalk:newArray({"message","receiver"}),"Kernel")

smalltalk:bind(smalltalk.MessageNotUnderstood,"message",0
,function(self)
return (self["@message"]);
end
,"accessing","message\r\n\t\" Return the message of the receiver. \"\r\n\r\n\t^message","function(self)\r\nreturn (self[\"@message\"]);\r\nend")

smalltalk:bind(smalltalk.MessageNotUnderstood,"message:",0
,function(self,aMessage)
(function()
	local _s8_value=(aMessage)
	self["@message"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","message: aMessage\r\n\t\" Set the message of the receiver. \"\r\n\r\n\tmessage := aMessage","function(self,aMessage)\r\n(function()\r\n\tlocal _s8_value=(aMessage)\r\n\tself[\"@message\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.MessageNotUnderstood,"receiver",0
,function(self)
return (self["@receiver"]);
end
,"accessing","receiver\r\n\t\" Return the receiver of the receiver. \"\r\n\r\n\t^receiver","function(self)\r\nreturn (self[\"@receiver\"]);\r\nend")

smalltalk:bind(smalltalk.MessageNotUnderstood,"receiver:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@receiver"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","receiver: anObject\r\n\t\" Set the receiver of the receiver. \"\r\n\r\n\treceiver := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@receiver\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.MessageNotUnderstood,"messageText",0
,function(self)
local type=nil
if (smalltalk:isNil_((self["@message"])))==true then return ("unknown"); end;
(function()
	local _s8_value=(smalltalk:if_true_false_(((self):isObject_(self["@receiver"])),(function()
return (smalltalk:object_comma_(("instance of "),((self["@receiver"])["$klass"]):name()))
end),(function()
return ("native object")
end)))
	type=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:if_true_false_(((self["@message"]):isString()),(function()
return ((self["@message"]):asLiteral())
end),(function()
return ((self["@message"]):selector())
end)))," not understood by ")),type));
end
,"accessing","messageText\r\n\t\" Return the message text of the receiver. \"\r\n\r\n\t| type |\r\n\tmessage isNil ifTrue: [ ^#unknown ].\r\n\ttype := (self isObject: receiver)\r\n\t\tifTrue: [ 'instance of ' ,receiver class name ]\r\n\t\tifFalse: [ 'native object' ].\r\n\t^(message isString\r\n\t\tifTrue: [ message asLiteral ]\r\n\t\tifFalse: [ message selector ])\r\n\t\t,' not understood by ' ,type","function(self)\r\nlocal type=nil\r\nif (smalltalk:isNil_((self[\"@message\"])))==true then return (\"unknown\"); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((self):isObject_(self[\"@receiver\"])),(function()\r\nreturn (smalltalk:object_comma_((\"instance of \"),((self[\"@receiver\"])[\"$klass\"]):name()))\r\nend),(function()\r\nreturn (\"native object\")\r\nend)))\r\n\ttype=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:if_true_false_(((self[\"@message\"]):isString()),(function()\r\nreturn ((self[\"@message\"]):asLiteral())\r\nend),(function()\r\nreturn ((self[\"@message\"]):selector())\r\nend))),\" not understood by \")),type));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"ms",0
,function(self)
return ((smalltalk.DateTime):millisecondsToRun_(self));
end
,"accessing","ms\r\n\t\" Return the milliseconds taken to evaluate the receiver. \"\r\n\r\n\t^DateTime millisecondsToRun: self","function(self)\r\nreturn ((smalltalk.DateTime):millisecondsToRun_(self));\r\nend")

smalltalk:bind(smalltalk.Class["$klass"],"categories",0
,function(self)
return ((((smalltalk.Smalltalk):classes()):collect_((function(each)
return ((each):category())
end))):asHashedSet());
end
,"export","categories\r\n\t\" Return a collection with all defined categories. \"\r\n\r\n\t^(Smalltalk classes collect: [:each | each category ]) asHashedSet","function(self)\r\nreturn ((((smalltalk.Smalltalk):classes()):collect_((function(each)\r\nreturn ((each):category())\r\nend))):asHashedSet());\r\nend")

smalltalk:bind(smalltalk.Class["$klass"],"uncategorized",0
,function(self)
return (((smalltalk.Smalltalk):classes()):select_((function(each)
return (smalltalk:isObject_equalTo_(((each):category()),"unclassified"))
end)));
end
,"export","uncategorized\r\n\t\" Return a collection with classes without category. \"\r\n\r\n\t^Smalltalk classes select: [:each | each category = #unclassified ]","function(self)\r\nreturn (((smalltalk.Smalltalk):classes()):select_((function(each)\r\nreturn (smalltalk:isObject_equalTo_(((each):category()),\"unclassified\"))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Class,"variableByteSubclass:classVariableNames:poolDictionaries:",0
,function(self,aString,classVarNames,poolVarNames)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,"",classVarNames,poolVarNames));
end
,"instantiation","variableByteSubclass: aString\r\n\tclassVariableNames: classVarNames\r\n\tpoolDictionaries: poolVarNames\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\"\tself note: 'WARNING: ',aString,' defined as variableByteSubclass:...'.\r\n\"\t^self \r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: ''\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: poolVarNames","function(self,aString,classVarNames,poolVarNames)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,\"\",classVarNames,poolVarNames));\r\nend")

smalltalk:bind(smalltalk.Class,"variableSubclass:instanceVariableNames:classVariableNames:poolDictionaries:",0
,function(self,aString,aString2,classVarNames,poolVarNames)
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_(("WARNING: "),aString))," defined as variableSubclass:..."));
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,classVarNames,poolVarNames));
end
,"instantiation","variableSubclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\tpoolDictionaries: poolVarNames\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\tself note: 'WARNING: ',aString,' defined as variableSubclass:...'.\r\n\t^self \r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: poolVarNames","function(self,aString,aString2,classVarNames,poolVarNames)\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((\"WARNING: \"),aString)),\" defined as variableSubclass:...\"));\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,classVarNames,poolVarNames));\r\nend")

smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:",0
,function(self,aString,aString2,classVarNames,poolVarNames,aCategory)
if (smalltalk:notNil_((((self):smalltalk()):globalAt_(aString))))==true then (self):note_(smalltalk:object_comma_(("WARNING: class REdefinition for "),aString)); end;
return (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(self,aString,aString2,classVarNames,poolVarNames,aCategory));
end
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\tpoolDictionaries: poolVarNames\r\n\tcategory: aCategory\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t(self smalltalk globalAt: aString) notNil ifTrue: [\r\n\t\tself note: 'WARNING: class REdefinition for ',aString.\r\n\t\t\"^self smalltalk globalAt: aString\"\r\n\t].\r\n\r\n\"\tself note: 'Creating ',aString.\"\r\n\t^ClassBuilder new\r\n\t\tsuperclass: self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: poolVarNames\r\n\t\tcategory: aCategory","function(self,aString,aString2,classVarNames,poolVarNames,aCategory)\r\nif (smalltalk:notNil_((((self):smalltalk()):globalAt_(aString))))==true then (self):note_(smalltalk:object_comma_((\"WARNING: class REdefinition for \"),aString)); end;\r\nreturn (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(self,aString,aString2,classVarNames,poolVarNames,aCategory));\r\nend")

smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:classVariableNames:category:",0
,function(self,aString,aString2,classVarNames,aCategory)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,classVarNames,"",aCategory));
end
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\tcategory: aCategory\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self subclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: ''\r\n\t\tcategory: aCategory","function(self,aString,aString2,classVarNames,aCategory)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,classVarNames,\"\",aCategory));\r\nend")

smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:",0
,function(self,aString,aString2,classVarNames,poolVarNames)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,classVarNames,poolVarNames,nil));
end
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\tpoolDictionaries: poolVarNames\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: poolVarNames\r\n\t\tcategory: nil","function(self,aString,aString2,classVarNames,poolVarNames)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,classVarNames,poolVarNames,nil));\r\nend")

smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:poolDictionaries:category:",0
,function(self,aString,aString2,poolVarNames,aCategory)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,"",poolVarNames,aCategory));
end
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tpoolDictionaries: poolVarNames\r\n\tcategory: aCategory\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: ''\r\n\t\tpoolDictionaries: poolVarNames\r\n\t\tcategory: aCategory","function(self,aString,aString2,poolVarNames,aCategory)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,\"\",poolVarNames,aCategory));\r\nend")

smalltalk:bind(smalltalk.Class,"variableByteSubclass:classVariableNames:",0
,function(self,aString,classVarNames)
return ((self):variableByteSubclass_classVariableNames_poolDictionaries_(aString,classVarNames,""));
end
,"instantiation","variableByteSubclass: aString classVariableNames: classVarNames\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tvariableByteSubclass: aString\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: ''","function(self,aString,classVarNames)\r\nreturn ((self):variableByteSubclass_classVariableNames_poolDictionaries_(aString,classVarNames,\"\"));\r\nend")

smalltalk:bind(smalltalk.Class,"variableByteSubclass:poolDictionaries:",0
,function(self,aString,aString2)
return ((self):variableByteSubclass_classVariableNames_poolDictionaries_(aString,"",aString2));
end
,"instantiation","variableByteSubclass: aString poolDictionaries: aString2\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tvariableByteSubclass: aString\r\n\t\tclassVariableNames: ''\r\n\t\tpoolDictionaries: aString2","function(self,aString,aString2)\r\nreturn ((self):variableByteSubclass_classVariableNames_poolDictionaries_(aString,\"\",aString2));\r\nend")

smalltalk:bind(smalltalk.Class,"variableByteSubclass:",0
,function(self,aString)
return ((self):variableByteSubclass_classVariableNames_(aString,""));
end
,"instantiation","variableByteSubclass: aString\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tvariableByteSubclass: aString\r\n\t\tclassVariableNames: ''","function(self,aString)\r\nreturn ((self):variableByteSubclass_classVariableNames_(aString,\"\"));\r\nend")

smalltalk:bind(smalltalk.Class,"variableSubclass:instanceVariableNames:classVariableNames:",0
,function(self,aString,aString2,classVarNames)
return ((self):variableSubclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,classVarNames,""));
end
,"instantiation","variableSubclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self \r\n\t\tvariableSubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: ''","function(self,aString,aString2,classVarNames)\r\nreturn ((self):variableSubclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,classVarNames,\"\"));\r\nend")

smalltalk:bind(smalltalk.Class,"variableSubclass:instanceVariableNames:",0
,function(self,aString,aString2)
return ((self):variableSubclass_instanceVariableNames_classVariableNames_(aString,aString2,""));
end
,"instantiation","variableSubclass: aString instanceVariableNames: aString2\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self \r\n\t\tvariableSubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: ''","function(self,aString,aString2)\r\nreturn ((self):variableSubclass_instanceVariableNames_classVariableNames_(aString,aString2,\"\"));\r\nend")

smalltalk:bind(smalltalk.Class,"variableSubclass:classVariableNames:",0
,function(self,aString,aString2)
return ((self):variableSubclass_instanceVariableNames_classVariableNames_(aString,"",aString2));
end
,"instantiation","variableSubclass: aString classVariableNames: aString2\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self \r\n\t\tvariableSubclass: aString\r\n\t\tinstanceVariableNames: ''\r\n\t\tclassVariableNames: aString2","function(self,aString,aString2)\r\nreturn ((self):variableSubclass_instanceVariableNames_classVariableNames_(aString,\"\",aString2));\r\nend")

smalltalk:bind(smalltalk.Class,"variableSubclass:poolDictionaries:",0
,function(self,aString,aString2)
return ((self):variableSubclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,"","",aString2));
end
,"instantiation","variableSubclass: aString poolDictionaries: aString2\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self \r\n\t\tvariableSubclass: aString\r\n\t\tinstanceVariableNames: ''\r\n\t\tclassVariableNames: ''\r\n\t\tpoolDictionaries: aString2","function(self,aString,aString2)\r\nreturn ((self):variableSubclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,\"\",\"\",aString2));\r\nend")

smalltalk:bind(smalltalk.Class,"variableSubclass:",0
,function(self,aString)
return ((self):variableSubclass_instanceVariableNames_(aString,""));
end
,"instantiation","variableSubclass: aString\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self \r\n\t\tvariableSubclass: aString\r\n\t\tinstanceVariableNames: ''","function(self,aString)\r\nreturn ((self):variableSubclass_instanceVariableNames_(aString,\"\"));\r\nend")

smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:classVariableNames:",0
,function(self,aString,aString2,classVarNames)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,classVarNames,""));
end
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: ''","function(self,aString,aString2,classVarNames)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,classVarNames,\"\"));\r\nend")

smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:poolDictionaries:",0
,function(self,aString,aString2,aString3)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,"",aString3));
end
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tpoolDictionaries: aString3\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: ''\r\n\t\tpoolDictionaries: aString3","function(self,aString,aString2,aString3)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,aString2,\"\",aString3));\r\nend")

smalltalk:bind(smalltalk.Class,"subclass:instanceVariableNames:",0
,function(self,aString,aString2)
return ((self):subclass_instanceVariableNames_classVariableNames_(aString,aString2,""));
end
,"instantiation","subclass: aString instanceVariableNames: aString2\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: ''","function(self,aString,aString2)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_(aString,aString2,\"\"));\r\nend")

smalltalk:bind(smalltalk.Class,"subclass:classVariableNames:",0
,function(self,aString,aString2)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,"",aString2,""));
end
,"instantiation","subclass: aString classVariableNames: aString2\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: ''\r\n\t\tclassVariableNames: aString2\r\n\t\tpoolDictionaries: ''","function(self,aString,aString2)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,\"\",aString2,\"\"));\r\nend")

smalltalk:bind(smalltalk.Class,"subclass:poolDictionaries:",0
,function(self,aString,aString2)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,"","",aString2));
end
,"instantiation","subclass: aString poolDictionaries: aString2\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: ''\r\n\t\tclassVariableNames: ''\r\n\t\tpoolDictionaries: aString2","function(self,aString,aString2)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_(aString,\"\",\"\",aString2));\r\nend")

smalltalk:bind(smalltalk.Class,"subclass:",0
,function(self,aString)
return ((self):subclass_instanceVariableNames_(aString,""));
end
,"instantiation","subclass: aString\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: ''","function(self,aString)\r\nreturn ((self):subclass_instanceVariableNames_(aString,\"\"));\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"category:",0
,function(self,ignored)
return (self);
end
,"instantiation","category: ignored\r\n\t\" BUG - throw an error in ClassBuilder. \" ","function(self,ignored)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:",0
,function(self,aString,aString2,classVarNames,poolVarNames,aCategory)
if (smalltalk:notNil_((((self):smalltalk()):globalAt_(aString))))==true then (self):note_(smalltalk:object_comma_(("WARNING: class REdefinition for "),aString)); end;
return (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(self,aString,aString2,classVarNames,poolVarNames,aCategory));
end
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\tpoolDictionaries: poolVarNames\r\n\tcategory: aCategory\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t(self smalltalk globalAt: aString) notNil ifTrue: [\r\n\t\tself note: 'WARNING: class REdefinition for ',aString.\r\n\t\t\"^self smalltalk globalAt: aString\"\r\n\t].\r\n\r\n\"\tself note: 'Creating ROOT class ',aString.\"\r\n\t^ClassBuilder new\r\n\t\tsuperclass: self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: poolVarNames\r\n\t\tcategory: aCategory","function(self,aString,aString2,classVarNames,poolVarNames,aCategory)\r\nif (smalltalk:notNil_((((self):smalltalk()):globalAt_(aString))))==true then (self):note_(smalltalk:object_comma_((\"WARNING: class REdefinition for \"),aString)); end;\r\nreturn (((smalltalk.ClassBuilder):new()):superclass_subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(self,aString,aString2,classVarNames,poolVarNames,aCategory));\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"subclass:instanceVariableNames:classVariableNames:poolDictionaries:",0
,function(self,aString,aString2,classVarNames,poolVarNames)
return ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,classVarNames,poolVarNames,nil));
end
,"instantiation","subclass: aString\r\n\tinstanceVariableNames: aString2\r\n\tclassVariableNames: classVarNames\r\n\tpoolDictionaries: poolVarNames\r\n\t\" Create a new subclass of the receiver. \"\r\n\r\n\t^self\r\n\t\tsubclass: aString\r\n\t\tinstanceVariableNames: aString2\r\n\t\tclassVariableNames: classVarNames\r\n\t\tpoolDictionaries: poolVarNames\r\n\t\tcategory: nil","function(self,aString,aString2,classVarNames,poolVarNames)\r\nreturn ((self):subclass_instanceVariableNames_classVariableNames_poolDictionaries_category_(aString,aString2,classVarNames,poolVarNames,nil));\r\nend")

smalltalk:bind(smalltalk.Object,"argumentCount",0
,function(self)
return (0);
end
,"evaluating","argumentCount\r\n\t\" Return the number of arguments of the receiver. \"\r\n\r\n\t^0","function(self)\r\nreturn (0);\r\nend")

smalltalk:bind(smalltalk.Object,"numberOfArguments",0
,function(self)
return ((self):argumentCount());
end
,"evaluating","numberOfArguments\r\n\t\" Return the number of arguments of the receiver. \"\r\n\r\n\t^self argumentCount","function(self)\r\nreturn ((self):argumentCount());\r\nend")

smalltalk:bind(smalltalk.Object,"evaluate",0
,function(self)
return (self);
end
,"evaluating","evaluate\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"evaluateDeferred",0
,function(self)
((function()
return ((self):evaluate())
end)):valueDeferred();
return (self);
end
,"evaluating","evaluateDeferred\r\n\t\" Evaluating the receiver deferred in time.\r\n\tReturn the receiver. \"\r\n\r\n\t[ self evaluate ] valueDeferred.","function(self)\r\n((function()\r\nreturn ((self):evaluate())\r\nend)):valueDeferred();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"evaluateWithArguments:",0
,function(self,anArray)
return (self);
end
,"evaluating","evaluateWithArguments: anArray\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self","function(self,anArray)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"evaluateWith:",0
,function(self,anObject)
return ((self):evaluateWithArguments_((smalltalk.Array):with_(anObject)));
end
,"evaluating","evaluateWith: anObject\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self evaluateWithArguments: (Array with: anObject)","function(self,anObject)\r\nreturn ((self):evaluateWithArguments_((smalltalk.Array):with_(anObject)));\r\nend")

smalltalk:bind(smalltalk.Object,"logEvaluate:",0
,function(self,source)
return ((self):evaluate());
end
,"evaluating","logEvaluate: source\r\n\t\" Return the result of evaluating the source.\r\n\tThis method should be refined/replaced to log the source expression as reference of evaluation.\r\n\t\"\r\n\r\n\t^self evaluate","function(self,source)\r\nreturn ((self):evaluate());\r\nend")

smalltalk:bind(smalltalk.String,"evaluateFor:",0
,function(self,anObject)
return ((anObject):perform_(self));
end
,"evaluating","evaluateFor: anObject\r\n\t\" Return the result of evaluating the receiver with anObject. \"\r\n\r\n\t^anObject perform: self","function(self,anObject)\r\nreturn ((anObject):perform_(self));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"evaluateFor:",0
,function(self,anObject)
return (self(anObject));
end
,"evaluating","evaluateFor: anObject\r\n\t\" Return the result of evaluating the receiver with anObject. \"\r\n\r\n\t^# #self: anObject","function(self,anObject)\r\nreturn (self(anObject));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"evaluate",0
,function(self)
return (self());
end
,"evaluating","evaluate\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^# #self","function(self)\r\nreturn (self());\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"evaluateWithArguments:",0
,function(self,anArray)
return ((self):valueWithPossibleArguments_(anArray));
end
,"evaluating","evaluateWithArguments: anArray\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self valueWithPossibleArguments: anArray","function(self,anArray)\r\nreturn ((self):valueWithPossibleArguments_(anArray));\r\nend")

smalltalk:bind(smalltalk.BlockClosure,"valueWithArguments:",0
,function(self,anArray)
return ((self):valueWithPossibleArguments_(anArray));
end
,"evaluating","valueWithArguments: anArray\r\n\t\" Return the result of evaluating the receiver with arguments. \"\r\n\r\n\t^self valueWithPossibleArguments: anArray","function(self,anArray)\r\nreturn ((self):valueWithPossibleArguments_(anArray));\r\nend")

smalltalk:addClass("ActionSequence",smalltalk.Object,smalltalk:newArray({"contents"}),"Kernel")

smalltalk:bind(smalltalk.EvaluableAction,",","_comma"
,function(self,anAction)
return ((smalltalk.ActionSequence):with_with_(self,anAction));
end
,"composing",", anAction\r\n\t\" Return the receiver composed with the argument. \"\r\n\r\n\t^ActionSequence with: self with: anAction","function(self,anAction)\r\nreturn ((smalltalk.ActionSequence):with_with_(self,anAction));\r\nend")

smalltalk:bind(smalltalk.Object,"asActionSequence",0
,function(self)
return ((smalltalk.ActionSequence):with_(self));
end
,"converting","asActionSequence\r\n\t\" Return an ActionSequence from the receiver. \"\r\n\r\n\t^ActionSequence with: self","function(self)\r\nreturn ((smalltalk.ActionSequence):with_(self));\r\nend")

smalltalk:bind(smalltalk.SequenceableCollection,"asActionSequence",0
,function(self)
return ((smalltalk.ActionSequence):withAll_(self));
end
,"converting","asActionSequence\r\n\t\" Return an ActionSequence from the receiver. \"\r\n\r\n\t^ActionSequence withAll: self","function(self)\r\nreturn ((smalltalk.ActionSequence):withAll_(self));\r\nend")

smalltalk:bind(smalltalk.ActionSequence["$klass"],"withAll:",0
,function(self,aCollection)
return ((
function(_s8_rec)
	(_s8_rec):contents_(aCollection);
	return ((_s8_rec):yourself())
end
)((self):new()));
end
,"instantiation","withAll: aCollection\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\tcontents: aCollection;\r\n\t\tyourself","function(self,aCollection)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):contents_(aCollection);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()));\r\nend")

smalltalk:bind(smalltalk.ActionSequence["$klass"],"with:",0
,function(self,anObject)
return ((self):withAll_((smalltalk.Array):with_(anObject)));
end
,"instantiation","with: anObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self withAll: (Array with: anObject)","function(self,anObject)\r\nreturn ((self):withAll_((smalltalk.Array):with_(anObject)));\r\nend")

smalltalk:bind(smalltalk.ActionSequence["$klass"],"with:with:",0
,function(self,anObject,bObject)
return ((self):withAll_((smalltalk.Array):with_with_(anObject,bObject)));
end
,"instantiation","with: anObject with: bObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self withAll: (Array with: anObject with: bObject)","function(self,anObject,bObject)\r\nreturn ((self):withAll_((smalltalk.Array):with_with_(anObject,bObject)));\r\nend")

smalltalk:bind(smalltalk.ActionSequence["$klass"],"with:with:with:",0
,function(self,anObject,bObject,cObject)
return ((self):withAll_((smalltalk.Array):with_with_with_(anObject,bObject,cObject)));
end
,"instantiation","with: anObject with: bObject with: cObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self withAll: (Array with: anObject with: bObject with: cObject)","function(self,anObject,bObject,cObject)\r\nreturn ((self):withAll_((smalltalk.Array):with_with_with_(anObject,bObject,cObject)));\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"contents:",0
,function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@contents"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"private","contents: aCollection\r\n\t\" Private - Set the contents of the receiver. \"\r\n\r\n\tcontents := aCollection","function(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@contents\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"contents",0
,function(self)
if (smalltalk:isNil_((self["@contents"])))==true then (function()
	local _s8_value=((smalltalk.Array):new())
	self["@contents"]=_s8_value
	return _s8_value
end)(); end;
return (self["@contents"]);
end
,"private","contents\r\n\t\" Private - Return the contents of the receiver. \"\r\n\r\n\tcontents isNil ifTrue: [ contents := Array new ].\r\n\t^contents","function(self)\r\nif (smalltalk:isNil_((self[\"@contents\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tself[\"@contents\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@contents\"]);\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"isEmpty",0
,function(self)
return (smalltalk:boolean_or_((smalltalk:isNil_((self["@contents"]))),(function()
return ((self["@contents"]):isEmpty())
end)));
end
,"testing","isEmpty\r\n\t\" Return true if the receiver is empty. \"\r\n\r\n\t^contents isNil or: [ contents isEmpty ]","function(self)\r\nreturn (smalltalk:boolean_or_((smalltalk:isNil_((self[\"@contents\"]))),(function()\r\nreturn ((self[\"@contents\"]):isEmpty())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"notEmpty",0
,function(self)
return (smalltalk:boolean_and_((smalltalk:notNil_((self["@contents"]))),(function()
return ((self["@contents"]):notEmpty())
end)));
end
,"testing","notEmpty\r\n\t\" Return true if the receiver is not empty. \"\r\n\r\n\t^contents notNil and: [ contents notEmpty ]","function(self)\r\nreturn (smalltalk:boolean_and_((smalltalk:notNil_((self[\"@contents\"]))),(function()\r\nreturn ((self[\"@contents\"]):notEmpty())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"asArray",0
,function(self)
if ((self):isEmpty())==true then return (smalltalk:newArray({})); end;
return ((self["@contents"]):asArray());
end
,"converting","asArray\r\n\t\" Return an array with the contents of the receiver. \"\r\n\r\n\tself isEmpty ifTrue: [ ^#() ].\r\n\t^contents asArray","function(self)\r\nif ((self):isEmpty())==true then return (smalltalk:newArray({})); end;\r\nreturn ((self[\"@contents\"]):asArray());\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"asActionSequence",0
,function(self)
return (self);
end
,"converting","asActionSequence\r\n\t\" Return an ActionSequence from the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ActionSequence,",","_comma"
,function(self,anAction)
if ((self):isEmpty())==true then return ((anAction):asActionSequence()); end;
return (((self)["$klass"]):withAll_(smalltalk:object_comma_(((self):contents()),((anAction):asActionSequence()):contents())));
end
,"converting",", anAction\r\n\t\" Return an action composed with the receiver and anAction. \"\r\n\r\n\tself isEmpty ifTrue: [ ^anAction asActionSequence ].\r\n\t^self class withAll: self contents , anAction asActionSequence contents","function(self,anAction)\r\nif ((self):isEmpty())==true then return ((anAction):asActionSequence()); end;\r\nreturn (((self)[\"$klass\"]):withAll_(smalltalk:object_comma_(((self):contents()),((anAction):asActionSequence()):contents())));\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"copyWith:",0
,function(self,anObject)
return (((self)["$klass"]):withAll_(((self):contents()):copyWith_(anObject)));
end
,"converting","copyWith: anObject\r\n\t\" Return an action composed with the receiver and anObject. \"\r\n\r\n\t^self class withAll: (self contents copyWith: anObject)","function(self,anObject)\r\nreturn (((self)[\"$klass\"]):withAll_(((self):contents()):copyWith_(anObject)));\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"do:",0
,function(self,aBlock)
return (smalltalk:if_true_false_(((self):notEmpty()),(function()
return (((self):contents()):do_(aBlock))
end),nil));
end
,"converting","do: aBlock\r\n\t\" Evaluate aBlock for each object in the receiver's contents. \"\r\n\r\n\t^self notEmpty ifTrue: [ self contents do: aBlock ]","function(self,aBlock)\r\nreturn (smalltalk:if_true_false_(((self):notEmpty()),(function()\r\nreturn (((self):contents()):do_(aBlock))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"includes:",0
,function(self,anObject)
return (smalltalk:boolean_and_(((self):notEmpty()),(function()
return (((self):contents()):includes_(anObject))
end)));
end
,"testing","includes: anObject\r\n\t\" Return true if anObject is in the receiver. \"\r\n\r\n\t^self notEmpty and: [ self contents includes: anObject ]","function(self,anObject)\r\nreturn (smalltalk:boolean_and_(((self):notEmpty()),(function()\r\nreturn (((self):contents()):includes_(anObject))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"select:",0
,function(self,aBlock)
return (((self)["$klass"]):withAll_(((self):asArray()):select_(aBlock)));
end
,"enumerating","select: aBlock\r\n\t\" Return the a copy of the receiver with elements wich evaluates aBlock to true. \"\r\n\r\n\t^self class withAll: (self asArray select: aBlock)","function(self,aBlock)\r\nreturn (((self)[\"$klass\"]):withAll_(((self):asArray()):select_(aBlock)));\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"reject:",0
,function(self,aBlock)
return (((self)["$klass"]):withAll_(((self):asArray()):reject_(aBlock)));
end
,"enumerating","reject: aBlock\r\n\t\" Return the a copy of the receiver with elements wich evaluates aBlock to false. \"\r\n\r\n\t^self class withAll: (self asArray reject: aBlock)","function(self,aBlock)\r\nreturn (((self)[\"$klass\"]):withAll_(((self):asArray()):reject_(aBlock)));\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"evaluate",0
,function(self)
local result=nil
(self):do_((function(each)
return ((function()
	local _s8_value=((each):evaluate())
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
,"evaluating","evaluate\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t| result |\r\n\tself do: [:each| result := each evaluate ].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(self):do_((function(each)\r\nreturn ((function()\r\n\tlocal _s8_value=((each):evaluate())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"evaluateWithArguments:",0
,function(self,anArray)
local result=nil
(self):do_((function(each)
return ((function()
	local _s8_value=((each):evaluateWithArguments_(anArray))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
,"evaluating","evaluateWithArguments: anArray\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t| result |\r\n\tself do: [:each| result := each evaluateWithArguments: anArray ].\r\n\t^result","function(self,anArray)\r\nlocal result=nil\r\n(self):do_((function(each)\r\nreturn ((function()\r\n\tlocal _s8_value=((each):evaluateWithArguments_(anArray))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"evaluateFor:",0
,function(self,anObject)
local result=nil
(self):do_((function(each)
return ((function()
	local _s8_value=((each):evaluateFor_(anObject))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
,"evaluating","evaluateFor: anObject\r\n\t\" Return the result of evaluating the receiver with anObject. \"\r\n\r\n\t| result |\r\n\tself do: [:each| result := each evaluateFor: anObject ].\r\n\t^result","function(self,anObject)\r\nlocal result=nil\r\n(self):do_((function(each)\r\nreturn ((function()\r\n\tlocal _s8_value=((each):evaluateFor_(anObject))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"reduced",0
,function(self)
return (smalltalk:if_true_false_(((self):notEmpty()),(function()
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self["@contents"]):size()),1)),(function()
return ((self["@contents"]):first())
end),(function()
return (self)
end)))
end),nil));
end
,"events","reduced\r\n\t\" Return the receiver reduced to minimal evaluable expression. \"\r\n\r\n\t^self notEmpty ifTrue: [\r\n\t\tcontents size = 1\r\n\t\tifTrue: [ contents first ]\r\n\t\tifFalse: [ self ]\r\n\t]","function(self)\r\nreturn (smalltalk:if_true_false_(((self):notEmpty()),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self[\"@contents\"]):size()),1)),(function()\r\nreturn ((self[\"@contents\"]):first())\r\nend),(function()\r\nreturn (self)\r\nend)))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"evaluateWithSelector:withArguments:",0
,function(self,aSelector,array)
local result=nil
(self):do_((function(each)
return ((function()
	local _s8_value=(((each):receiver()):perform_withArguments_(aSelector,array))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
,"changes","evaluateWithSelector: aSelector withArguments: array\r\n\t\" Private - Return the result of evaluating the receiver with aSelector and arguments array. \"\r\n\r\n\t| result |\r\n\tself do: [:each| result := each receiver perform: aSelector withArguments: array ].\r\n\t^result","function(self,aSelector,array)\r\nlocal result=nil\r\n(self):do_((function(each)\r\nreturn ((function()\r\n\tlocal _s8_value=(((each):receiver()):perform_withArguments_(aSelector,array))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.ActionSequence,"resolveWith:",0
,function(self,aPoolOrBlock)
return (((self)["$klass"]):withAll_(((self):asArray()):collect_((function(each)
return (smalltalk:if_true_false_((smalltalk:responds_to_((each),("resolveWith:"))),(function()
return ((each):resolveWith_(aPoolOrBlock))
end),(function()
return (each)
end)))
end))));
end
,"resolution","resolveWith: aPoolOrBlock\r\n\t\" Return an instance set to be evaluated with mappings given by aPoolOrBlock. \"\r\n\r\n\t^self class withAll: (self asArray collect: [:each|\r\n\t\t(each respondsTo: #resolveWith:)\r\n\t\tifTrue: [ each resolveWith: aPoolOrBlock ]\r\n\t\tifFalse: [ each ]\r\n\t])","function(self,aPoolOrBlock)\r\nreturn (((self)[\"$klass\"]):withAll_(((self):asArray()):collect_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:responds_to_((each),(\"resolveWith:\"))),(function()\r\nreturn ((each):resolveWith_(aPoolOrBlock))\r\nend),(function()\r\nreturn (each)\r\nend)))\r\nend))));\r\nend")

smalltalk:addClass("EventManager",smalltalk.Object,smalltalk:newArray({"handlers"}),"Kernel")
smalltalk.EventManager["$comment"]="\r\n\tEvent system, properties and change/update/release mechanism.\r\n\tWe hook $properties and $handlers internal properties to manage properties and events at Object level.\r\n\tEventManager instances implement events handler as pure instance variable.\r\n"

smalltalk.EventManager["$klass"]["$iVarNames"]=smalltalk:newArray({"eventsTriggered"})

smalltalk:bind(smalltalk.EventManager["$klass"],"eventsTriggered",0
,function(self)
if (smalltalk:isNil_((self["@eventsTriggered"])))==true then (self):initializeEventsTriggered(); end;
return (self["@eventsTriggered"]);
end
,"events","eventsTriggered\r\n\t\" Return all the events managed by instances of the receiver. \"\r\n\r\n\teventsTriggered isNil ifTrue: [ self initializeEventsTriggered ].\r\n\t^eventsTriggered","function(self)\r\nif (smalltalk:isNil_((self[\"@eventsTriggered\"])))==true then (self):initializeEventsTriggered(); end;\r\nreturn (self[\"@eventsTriggered\"]);\r\nend")

smalltalk:bind(smalltalk.EventManager["$klass"],"eventsTriggered:",0
,function(self,aCollection)
(function()
	local _s8_value=(aCollection)
	self["@eventsTriggered"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"events","eventsTriggered: aCollection\r\n\t\" Set all the events managed by instances of the receiver. \"\r\n\r\n\teventsTriggered := aCollection","function(self,aCollection)\r\n(function()\r\n\tlocal _s8_value=(aCollection)\r\n\tself[\"@eventsTriggered\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.EventManager["$klass"],"initializeEventsTriggered",0
,function(self)
(self):eventsTriggered_((self):constructEventsTriggered());
return (self);
end
,"events","initializeEventsTriggered\r\n\t\" Private - Initialize all the events managed by instances of the receiver. \"\r\n\r\n\tself eventsTriggered: self constructEventsTriggered","function(self)\r\n(self):eventsTriggered_((self):constructEventsTriggered());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.EventManager,"eventTable",0
,function(self)
return (smalltalk:if_true_false_((smalltalk:isNil_((self["@handlers"]))),(function()
return ((self):eventTableCreate())
end),(function()
return (self["@handlers"])
end)));
end
,"events","eventTable\r\n\t\" Private - Return the mapping event names to actions of the receiver. \"\r\n\r\n\t^handlers isNil\r\n\t\tifTrue: [ self eventTableCreate ]\r\n\t\tifFalse: [ handlers ]","function(self)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((self[\"@handlers\"]))),(function()\r\nreturn ((self):eventTableCreate())\r\nend),(function()\r\nreturn (self[\"@handlers\"])\r\nend)));\r\nend")

smalltalk:bind(smalltalk.EventManager,"eventTableForEdit",0
,function(self)
if (smalltalk:isNil_((self["@handlers"])))==true then (function()
	local _s8_value=((self):eventTableCreate())
	self["@handlers"]=_s8_value
	return _s8_value
end)(); end;
return (self["@handlers"]);
end
,"events","eventTableForEdit\r\n\t\" Private - Return the mapping event names to actions of the receiver.\r\n\tSet the internal map if not present.\r\n\t\"\r\n\r\n\thandlers isNil ifTrue: [ handlers := self eventTableCreate ].\r\n\t^handlers","function(self)\r\nif (smalltalk:isNil_((self[\"@handlers\"])))==true then (function()\r\n\tlocal _s8_value=((self):eventTableCreate())\r\n\tself[\"@handlers\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@handlers\"]);\r\nend")

smalltalk:bind(smalltalk.EventManager,"releaseEventTable",0
,function(self)
(function()
	local _s8_value=(nil)
	self["@handlers"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"events","releaseEventTable\r\n\t\" Private - Release the event table. \"\r\n\r\n\thandlers := nil","function(self)\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@handlers\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"eventTable",0
,function(self)
return (smalltalk:basic_at_ifAbsent_((self),"@handlers",(function()
return ((self):eventTableCreate())
end)));
end
,"events","eventTable\r\n\t\" Private - Return the mapping event names to actions of the receiver. \"\r\n\r\n\t^self basicAt: '@handlers' ifAbsent: [ self eventTableCreate ]","function(self)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),\"@handlers\",(function()\r\nreturn ((self):eventTableCreate())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"eventTableForEdit",0
,function(self)
return (smalltalk:basic_at_ifAbsent_((self),"@handlers",(function()
return (smalltalk:basic_at_put_((self),"@handlers",(self):eventTableCreate()))
end)));
end
,"events","eventTableForEdit\r\n\t\" Private - Return the mapping event names to actions of the receiver.\r\n\tSet the internal map if not present.\r\n\t\"\r\n\r\n\t^self basicAt: '@handlers' ifAbsent: [\r\n\t\tself basicAt: '@handlers' put: self eventTableCreate\r\n\t]","function(self)\r\nreturn (smalltalk:basic_at_ifAbsent_((self),\"@handlers\",(function()\r\nreturn (smalltalk:basic_at_put_((self),\"@handlers\",(self):eventTableCreate()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"releaseEventTable",0
,function(self)
(self):basicDelete_("@handlers");
return (self);
end
,"events","releaseEventTable\r\n\t\" Private - Release the event table. \"\r\n\r\n\tself basicDelete: '@handlers'","function(self)\r\n(self):basicDelete_(\"@handlers\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"release",0
,function(self)
(self):releaseEventTable();
return (self);
end
,"release","release\r\n\t\" Release the receiver. \"\r\n\r\n\tself releaseEventTable ","function(self)\r\n(self):releaseEventTable();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"eventTableCreate",0
,function(self)
return ((smalltalk.PoolDictionary):new());
end
,"events","eventTableCreate\r\n\t\" Private - Return a new mapping for the receiver. \"\r\n\r\n\t^PoolDictionary new","function(self)\r\nreturn ((smalltalk.PoolDictionary):new());\r\nend")

smalltalk:bind(smalltalk.Object["$klass"],"eventsTriggered",0
,function(self)
return ((self):constructEventsTriggered());
end
,"events","eventsTriggered\r\n\t\" Return all the events managed by instances of the receiver. \"\r\n\r\n\t^self constructEventsTriggered","function(self)\r\nreturn ((self):constructEventsTriggered());\r\nend")

smalltalk:bind(smalltalk.Object["$klass"],"constructEventsTriggered",0
,function(self)
return (smalltalk:newArray({"changed"}));
end
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver.\r\n\tThe default implementation return support for MVC change/update mechanism.\r\n\tThis method can be refined by the subclasses to extend event support.\r\n\t\"\r\n\r\n\t^#( #changed )","function(self)\r\nreturn (smalltalk:newArray({\"changed\"}));\r\nend")

smalltalk:bind(smalltalk.Object["$klass"],"canTriggerEvent:",0
,function(self,selector)
return (((self):eventsTriggered()):includes_(selector));
end
,"events","canTriggerEvent: selector\r\n\t\" Return true if instances of the receiver can trigger event.\"\r\n\r\n\t^self eventsTriggered includes: selector ","function(self,selector)\r\nreturn (((self):eventsTriggered()):includes_(selector));\r\nend")

smalltalk:bind(smalltalk.Object,"canTriggerEvent:",0
,function(self,selector)
return (((self)["$klass"]):canTriggerEvent_(selector));
end
,"events","canTriggerEvent: selector\r\n\t\" Return true if the receiver can trigger event.\"\r\n\r\n\t^self class canTriggerEvent: selector ","function(self,selector)\r\nreturn (((self)[\"$klass\"]):canTriggerEvent_(selector));\r\nend")

smalltalk:bind(smalltalk.Object,"invalidEvent:",0
,function(self,selector)
return (self);
end
,"events","invalidEvent: selector\r\n\t\" Private - Notify the situation where an unknown event is registered.\r\n\tDefault implementation ignore error during unknown event registration.\r\n\t\"\r\n\r\n\t^self\r\n\"DEBUG-\t^self note: self class name,' invalidEvent: ' ,selector asLiteral \"","function(self,selector)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"when:evaluate:",0
,function(self,selector,anAction)
local actions=nil
if not (((self):canTriggerEvent_(selector)))==true then (self):invalidEvent_(selector); end;
(function()
	local _s8_value=((self):actionListForEvent_(selector))
	actions=_s8_value
	return _s8_value
end)();
if ((actions):includes_(anAction))==true then return (self); end;
(self):setActionList_forEvent_((actions):copyWith_(anAction),selector);
return (self);
end
,"events","when: selector evaluate: anAction\r\n\t\" Register anAction to the be evaluated when the receiver triggers the event. \"\r\n\r\n\t| actions |\r\n\t(self canTriggerEvent: selector) ifFalse: [ self invalidEvent: selector ].\r\n\tactions := self actionListForEvent: selector.\r\n\t(actions includes: anAction) ifTrue: [ ^self ].\r\n\tself\r\n\t\tsetActionList: (actions copyWith: anAction)\r\n\t\tforEvent: selector","function(self,selector,anAction)\r\nlocal actions=nil\r\nif not (((self):canTriggerEvent_(selector)))==true then (self):invalidEvent_(selector); end;\r\n(function()\r\n\tlocal _s8_value=((self):actionListForEvent_(selector))\r\n\tactions=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((actions):includes_(anAction))==true then return (self); end;\r\n(self):setActionList_forEvent_((actions):copyWith_(anAction),selector);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"actionListForEvent:",0
,function(self,selector)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
(function()
	local _s8_value=(((self):eventTable()):at_ifAbsent_(selector,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.ActionSequence):new())
end
)()
error(_s8Ret_,0)
end)())
end)))
	result=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((result):asActionSequence())
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"events","actionListForEvent: selector\r\n\t\" Private - Return a collection of actions to evaluate when the event is triggered. \"\r\n\r\n\t| result |\r\n\tresult := self eventTable at: selector ifAbsent: [ ^ActionSequence new ].\r\n\t^result asActionSequence","function(self,selector)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):eventTable()):at_ifAbsent_(selector,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.ActionSequence):new())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((result):asActionSequence())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Object,"setActionList:forEvent:",0
,function(self,actionSequence,selector)
local action=nil
(function()
	local _s8_value=(((actionSequence):asActionSequence()):reduced())
	action=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((action)))==true then return ((self):removeActionsForEvent_(selector)); end;
((self):eventTableForEdit()):at_put_(selector,action);
return (self);
end
,"events","setActionList: actionSequence forEvent: selector\r\n\t\" Private - Set the list of actions to evaluate when the event is triggered by the receiver. \"\r\n\r\n\t| action |\r\n\taction := actionSequence asActionSequence reduced.\r\n\taction isNil ifTrue: [ ^self removeActionsForEvent: selector ].\r\n\tself eventTableForEdit at: selector put: action ","function(self,actionSequence,selector)\r\nlocal action=nil\r\n(function()\r\n\tlocal _s8_value=(((actionSequence):asActionSequence()):reduced())\r\n\taction=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((action)))==true then return ((self):removeActionsForEvent_(selector)); end;\r\n((self):eventTableForEdit()):at_put_(selector,action);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"removeActionsSatisfying:forEvent:",0
,function(self,aBlock,selector)
(self):setActionList_forEvent_((((self):actionListForEvent_(selector)):asArray()):reject_(aBlock),selector);
return (self);
end
,"events","removeActionsSatisfying: aBlock forEvent: selector\r\n\t\" Private - Remove all actions for the event that evaluates aBlock to true.\"\r\n\r\n\tself\r\n\t\tsetActionList: ((self actionListForEvent: selector) asArray reject: aBlock)\r\n\t\tforEvent: selector ","function(self,aBlock,selector)\r\n(self):setActionList_forEvent_((((self):actionListForEvent_(selector)):asArray()):reject_(aBlock),selector);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"removeActionsWithReceiver:forEvent:",0
,function(self,anObject,selector)
(self):removeActionsSatisfying_forEvent_((function(each)
return (smalltalk:boolean_and_((smalltalk:responds_to_((each),("receiver"))),(function()
return ((((each):receiver())==anObject))
end)))
end),selector);
return (self);
end
,"events","removeActionsWithReceiver: anObject forEvent: selector\r\n\t\" Remove all actions for the event in the receiver's event table which have anObject as receiver. \"\r\n\r\n\tself\r\n\t\tremoveActionsSatisfying: [:each| (each respondsTo: #receiver) and: [ each receiver == anObject ] ]\r\n\t\tforEvent: selector ","function(self,anObject,selector)\r\n(self):removeActionsSatisfying_forEvent_((function(each)\r\nreturn (smalltalk:boolean_and_((smalltalk:responds_to_((each),(\"receiver\"))),(function()\r\nreturn ((((each):receiver())==anObject))\r\nend)))\r\nend),selector);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"removeAction:forEvent:",0
,function(self,anAction,selector)
(self):removeActionsSatisfying_forEvent_((function(each)
return (smalltalk:isObject_equalTo_((each),anAction))
end),selector);
return (self);
end
,"events","removeAction: anAction forEvent: selector\r\n\t\" Remove anAction for the event in the receiver's event table which have anObject as receiver. \"\r\n\r\n\tself\r\n\t\tremoveActionsSatisfying: [:each| each = anAction ]\r\n\t\tforEvent: selector ","function(self,anAction,selector)\r\n(self):removeActionsSatisfying_forEvent_((function(each)\r\nreturn (smalltalk:isObject_equalTo_((each),anAction))\r\nend),selector);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"when:do:",0
,function(self,selector,aBlock)
(self):when_evaluate_(selector,aBlock);
return (self);
end
,"events","when: selector do: aBlock\r\n\t\" Evaluate aBlock when the receiver triggers the event. \"\r\n\r\n\tself when: selector evaluate: aBlock","function(self,selector,aBlock)\r\n(self):when_evaluate_(selector,aBlock);\r\nreturn (self);\r\nend")

smalltalk:addClass("LinkMessage",smalltalk.Message,smalltalk:newArray({"resultAction"}),"Kernel")
smalltalk.LinkMessage["$comment"]="\r\n\tImplement evaluation cascading argument evaluations."

smalltalk:bind(smalltalk.LinkMessage,"resultAction",0
,function(self)
return (self["@resultAction"]);
end
,"accessing","resultAction\r\n\t\" Return the resultAction of the receiver. \"\r\n\r\n\t^resultAction","function(self)\r\nreturn (self[\"@resultAction\"]);\r\nend")

smalltalk:bind(smalltalk.LinkMessage,"resultAction:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self["@resultAction"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","resultAction: anObject\r\n\t\" Set the resultAction of the receiver. \"\r\n\r\n\tresultAction := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@resultAction\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LinkMessage,"evaluate",0
,function(self)
return ((self):evaluateWithArguments_(smalltalk:newArray({})));
end
,"evaluating","evaluate\r\n\t\" Return the result of evaluating the receiver. \"\r\n\r\n\t^self evaluateWithArguments: #()","function(self)\r\nreturn ((self):evaluateWithArguments_(smalltalk:newArray({})));\r\nend")

smalltalk:bind(smalltalk.LinkMessage,"collectArguments:",0
,function(self,evaluationArguments)
return (((self):arguments()):collect_((function(each)
return ((each):evaluateWithArguments_(evaluationArguments))
end)));
end
,"evaluating","collectArguments: evaluationArguments\r\n\t\" Private - Return the arguments to evaluate the receiver. \"\r\n\r\n\t^self arguments collect: [:each| each evaluateWithArguments: evaluationArguments ]","function(self,evaluationArguments)\r\nreturn (((self):arguments()):collect_((function(each)\r\nreturn ((each):evaluateWithArguments_(evaluationArguments))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"when:send:to:withArguments:",0
,function(self,selector,message,anObject,array)
(self):when_evaluate_(selector,(smalltalk.LinkMessage):receiver_selector_arguments_(anObject,message,array));
return (self);
end
,"events","when: selector send: message to: anObject withArguments: array\r\n\t\" Send the message when the receiver triggers the event. \"\r\n\r\n\tself\r\n\t\twhen: selector\r\n\t\tevaluate: (LinkMessage\r\n\t\t\treceiver: anObject\r\n\t\t\tselector: message\r\n\t\t\targuments: array)","function(self,selector,message,anObject,array)\r\n(self):when_evaluate_(selector,(smalltalk.LinkMessage):receiver_selector_arguments_(anObject,message,array));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"when:send:to:",0
,function(self,selector,message,anObject)
(self):when_evaluate_(selector,(smalltalk.Message):receiver_selector_arguments_(anObject,message,(smalltalk.Array):new_((message):argumentCount())));
return (self);
end
,"events","when: selector send: message to: anObject\r\n\t\" Send the message when the receiver triggers the event. \"\r\n\r\n\tself\r\n\t\twhen: selector\r\n\t\tevaluate: (Message\r\n\t\t\treceiver: anObject selector: message\r\n\t\t\targuments: (Array new: message argumentCount))","function(self,selector,message,anObject)\r\n(self):when_evaluate_(selector,(smalltalk.Message):receiver_selector_arguments_(anObject,message,(smalltalk.Array):new_((message):argumentCount())));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"triggerEvent:ifNotHandled:",0
,function(self,selector,aBlock)
return ((((self):eventTable()):at_ifAbsent_(selector,(function()
return (aBlock)
end))):evaluate());
end
,"events","triggerEvent: selector ifNotHandled: aBlock\r\n\t\" Trigger the event.\r\n\tIf the event is not handled, return the value of evaluating aBlock,\r\n        or the value returned by the most recently defined event handler.\r\n\t\"\r\n\r\n\t^(self eventTable at: selector ifAbsent: [ aBlock ]) evaluate","function(self,selector,aBlock)\r\nreturn ((((self):eventTable()):at_ifAbsent_(selector,(function()\r\nreturn (aBlock)\r\nend))):evaluate());\r\nend")

smalltalk:bind(smalltalk.Object,"actionForEvent:",0
,function(self,selector)
return (((self):eventTable()):at_ifAbsent_(selector,(function()
return (nil)
end)));
end
,"events","actionForEvent: selector\r\n\t\" Return the action to evaluate when the event is triggered by the receiver (or nil). \"\r\n\r\n\t^self eventTable at: selector ifAbsent: [ nil ]","function(self,selector)\r\nreturn (((self):eventTable()):at_ifAbsent_(selector,(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"triggerEvent:",0
,function(self,selector)
return (((self):actionForEvent_(selector)):evaluate());
end
,"events","triggerEvent: selector\r\n\t\" Return the result of triggering the event. \"\r\n\r\n\t^(self actionForEvent: selector) evaluate","function(self,selector)\r\nreturn (((self):actionForEvent_(selector)):evaluate());\r\nend")

smalltalk:bind(smalltalk.Object,"triggerEvent:withArguments:",0
,function(self,selector,array)
return (((self):actionForEvent_(selector)):evaluateWithArguments_(array));
end
,"events","triggerEvent: selector withArguments: array\r\n\t\" Return the result of triggering the event. \"\r\n\r\n\t^(self actionForEvent: selector) evaluateWithArguments: array","function(self,selector,array)\r\nreturn (((self):actionForEvent_(selector)):evaluateWithArguments_(array));\r\nend")

smalltalk:bind(smalltalk.Object,"triggerEvent:with:",0
,function(self,selector,anObject)
return ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_(anObject)));
end
,"events","triggerEvent: selector with: anObject\r\n\t\" Return the result of triggering the event. \"\r\n\r\n\t^self triggerEvent: selector withArguments: (Array with: anObject)","function(self,selector,anObject)\r\nreturn ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_(anObject)));\r\nend")

smalltalk:bind(smalltalk.Object,"triggerEvent:with:with:",0
,function(self,selector,anObject,anotherObject)
return ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_with_(anObject,anotherObject)));
end
,"events","triggerEvent: selector with: anObject with: anotherObject\r\n\t\" Return the result of triggering the event. \"\r\n\r\n\t^self triggerEvent: selector withArguments: (Array with: anObject with: anotherObject)","function(self,selector,anObject,anotherObject)\r\nreturn ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_with_(anObject,anotherObject)));\r\nend")

smalltalk:bind(smalltalk.Object,"triggerEvent:withArguments:ifNotHandled:",0
,function(self,selector,array,aBlock)
return ((((self):eventTable()):at_ifAbsent_(selector,(function()
return (aBlock)
end))):evaluateWithArguments_(array));
end
,"events","triggerEvent: selector withArguments: array ifNotHandled: aBlock\r\n\t\" Return the result of triggering the event with the arguments.\r\n\tIf the event is not handled, return the value of evaluating aBlock,\r\n\tor the value returned by the most recently defined event handler action.\r\n\t\"\r\n\r\n\t^(self eventTable at: selector ifAbsent: [ aBlock ]) evaluateWithArguments: array","function(self,selector,array,aBlock)\r\nreturn ((((self):eventTable()):at_ifAbsent_(selector,(function()\r\nreturn (aBlock)\r\nend))):evaluateWithArguments_(array));\r\nend")

smalltalk:bind(smalltalk.Object,"triggerEvent:with:ifNotHandled:",0
,function(self,selector,anObject,aBlock)
return ((self):triggerEvent_withArguments_ifNotHandled_(selector,(smalltalk.Array):with_(anObject),aBlock));
end
,"events","triggerEvent: selector with: anObject ifNotHandled: aBlock\r\n\t\" Return the result of triggering the event with anObject. \"\r\n\r\n\t^self triggerEvent: selector withArguments: (Array with: anObject) ifNotHandled: aBlock","function(self,selector,anObject,aBlock)\r\nreturn ((self):triggerEvent_withArguments_ifNotHandled_(selector,(smalltalk.Array):with_(anObject),aBlock));\r\nend")

smalltalk:bind(smalltalk.Object,"hasActionForEvent:",0
,function(self,selector)
return (((self):eventTable()):includesKey_(selector));
end
,"events","hasActionForEvent: selector\r\n\t\" Return true if the receiver has an action registered for the event. \"\r\n\r\n\t^self eventTable includesKey: selector ","function(self,selector)\r\nreturn (((self):eventTable()):includesKey_(selector));\r\nend")

smalltalk:bind(smalltalk.Object,"eventsHandled",0
,function(self)
return (((self):eventTable()):keys());
end
,"events","eventsHandled\r\n\t\" Return the events for which there are actions registered in the receiver. \"\r\n\r\n\t^self eventTable keys","function(self)\r\nreturn (((self):eventTable()):keys());\r\nend")

smalltalk:bind(smalltalk.Object,"removeAllActionsWithReceiver:",0
,function(self,anObject)
(((self):eventTable()):keys()):do_((function(each)
return ((self):removeActionsWithReceiver_forEvent_(anObject,each))
end));
return (self);
end
,"events","removeAllActionsWithReceiver: anObject\r\n\t\" Remove all actions for all events in the receiver's event table with anObject as receiver. \"\r\n\r\n\tself eventTable keys do: [:each|self removeActionsWithReceiver: anObject forEvent: each ]","function(self,anObject)\r\n(((self):eventTable()):keys()):do_((function(each)\r\nreturn ((self):removeActionsWithReceiver_forEvent_(anObject,each))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"removeActionsForEvent:",0
,function(self,selector)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local actions=nil
(function()
	local _s8_value=((self):eventTable())
	actions=_s8_value
	return _s8_value
end)();
(actions):removeKey_ifAbsent_(selector,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end));
if ((actions):isEmpty())==true then (self):releaseEventTable(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"events","removeActionsForEvent: selector\r\n\t\" Remove all actions for the event. \"\r\n\r\n\t| actions |\r\n\tactions := self eventTable.\r\n\tactions removeKey: selector ifAbsent: [ ^self ].\r\n\tactions isEmpty ifTrue: [ self releaseEventTable ].","function(self,selector)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal actions=nil\r\n(function()\r\n\tlocal _s8_value=((self):eventTable())\r\n\tactions=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(actions):removeKey_ifAbsent_(selector,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\nif ((actions):isEmpty())==true then (self):releaseEventTable(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Object,"addDependent:",0
,function(self,anObject)
(self):when_send_to_("changed","update",anObject);
return (self);
end
,"changes","addDependent: anObject\r\n\t\" Make anObject dependent of the receiver. \"\r\n\r\n\tself when: #changed send: #update to: anObject","function(self,anObject)\r\n(self):when_send_to_(\"changed\",\"update\",anObject);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"changed",0
,function(self)
(self):triggerEvent_("changed");
return (self);
end
,"changes","changed\r\n\t\" Update the dependents of the receiver. \"\r\n\r\n\tself triggerEvent: #changed","function(self)\r\n(self):triggerEvent_(\"changed\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"updateEvent:selector:arguments:",0
,function(self,selector,message,array)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local action=nil
(function()
	local _s8_value=(((self):eventTable()):at_ifAbsent_(selector,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end)))
	action=_s8_value
	return _s8_value
end)();
((action):asActionSequence()):evaluateWithSelector_withArguments_(message,array);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"changes","updateEvent: selector selector: message arguments: array\r\n\t\" Private - Trigger the event with the message selector and the arguments. \"\r\n\r\n\t| action |\r\n\taction := self eventTable at: selector ifAbsent: [ ^nil ].\r\n\taction asActionSequence\r\n\t\tevaluateWithSelector: message\r\n\t\twithArguments: array ","function(self,selector,message,array)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal action=nil\r\n(function()\r\n\tlocal _s8_value=(((self):eventTable()):at_ifAbsent_(selector,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\taction=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((action):asActionSequence()):evaluateWithSelector_withArguments_(message,array);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Object,"changed:",0
,function(self,aspect)
(self):updateEvent_selector_arguments_("changed","update:",(smalltalk.Array):with_(aspect));
return (self);
end
,"changes","changed: aspect\r\n\t\" Update the dependents on aspect of the receiver. \"\r\n\r\n\tself\tupdateEvent: #changed selector: #update:\r\n\t\targuments: (Array with: aspect)","function(self,aspect)\r\n(self):updateEvent_selector_arguments_(\"changed\",\"update:\",(smalltalk.Array):with_(aspect));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"changed:with:",0
,function(self,aspect,anObject)
(self):updateEvent_selector_arguments_("changed","update:with:",(smalltalk.Array):with_with_(aspect,anObject));
return (self);
end
,"changes","changed: aspect with: anObject\r\n\t\" Update the dependents on aspect of the receiver. \"\r\n\r\n\tself\tupdateEvent: #changed selector: #update:with:\r\n\t\targuments: (Array with: aspect with: anObject)","function(self,aspect,anObject)\r\n(self):updateEvent_selector_arguments_(\"changed\",\"update:with:\",(smalltalk.Array):with_with_(aspect,anObject));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"changed:with:with:",0
,function(self,aspect,anObject,anotherObject)
(self):updateEvent_selector_arguments_("changed","update:with:with:",(smalltalk.Array):with_with_with_(aspect,anObject,anotherObject));
return (self);
end
,"changes","changed: aspect with: anObject with: anotherObject\r\n\t\" Update the dependents on aspect of the receiver. \"\r\n\r\n\tself\tupdateEvent: #changed selector: #update:with:with:\r\n\t\targuments: (Array with: aspect with: anObject with: anotherObject)","function(self,aspect,anObject,anotherObject)\r\n(self):updateEvent_selector_arguments_(\"changed\",\"update:with:with:\",(smalltalk.Array):with_with_with_(aspect,anObject,anotherObject));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"dependents",0
,function(self)
return (((self):actionListForEvent_("changed")):collect_((function(each)
return ((each):receiver())
end)));
end
,"changes","dependents\r\n\t\" Return the dependents of the receiver. \"\r\n\r\n\t^(self actionListForEvent: #changed) collect: [:each | each receiver ]","function(self)\r\nreturn (((self):actionListForEvent_(\"changed\")):collect_((function(each)\r\nreturn ((each):receiver())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Object,"update:with:",0
,function(self,anObject,anotherObject)
return (self);
end
,"changes","update: anObject with: anotherObject\r\n\t\" Update the receiver.\r\n\tDefault implementation do nothing.\r\n\tThis method must be refined by subclasses to support change/update protocoll.\r\n\t\"","function(self,anObject,anotherObject)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"update:",0
,function(self,anObject)
return (self);
end
,"changes","update: anObject\r\n\t\" Update the receiver.\r\n\tDefault implementation do nothing.\r\n\tThis method must be refined by subclasses to support change/update protocoll.\r\n\t\"","function(self,anObject)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Object,"printingWith:do:",0
,function(self,printing,aBlock)
local old=nil
local result=nil

((function()
(function()
	local _s8_value=((smalltalk.Smalltalk):install_as_(printing,"print"))
	old=_s8_value
	return _s8_value
end)();return ((function()
	local _s8_value=((aBlock):value())
	result=_s8_value
	return _s8_value
end)())
end)):ensure_((function()
return ((smalltalk.Smalltalk):install_as_(old,"print"))
end));
return (result);
end
,"printing","printingWith: printing do: aBlock\r\n\t\" Return the result of evaluating aBlock, redirecting output to printing block.\r\n\tNote: native print() will be overwritten with printing block and restored to original after aBlock is evaluated.\r\n\t\"\r\n\r\n\t| old result |\r\n\t{'self' doc'native printing'}.\r\n\t[\told := Smalltalk install: printing as: #print.\r\n\t\tresult := aBlock value.\r\n\t] ensure: [ Smalltalk install: old as: #print ].\r\n\t^result","function(self,printing,aBlock)\r\nlocal old=nil\r\nlocal result=nil\r\n\r\n((function()\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):install_as_(printing,\"print\"))\r\n\told=_s8_value\r\n\treturn _s8_value\r\nend)();return ((function()\r\n\tlocal _s8_value=((aBlock):value())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):ensure_((function()\r\nreturn ((smalltalk.Smalltalk):install_as_(old,\"print\"))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Behavior,"aboutToAdd:",0
,function(self,aMethod)
return (self);
end
,"private","aboutToAdd: aMethod\r\n\t\" Private - Prepare aMethod to be added onto the receiver. \" ","function(self,aMethod)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"canAdd:method:",0
,function(self,isDoIt,aMethod)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if not ((smalltalk:boolean_and_((smalltalk:notNil_((smalltalk.OverwriteMethods))),(function()
return (smalltalk.OverwriteMethods)
end))))==true then smalltalk:if_true_false_(((self):implements_((aMethod):selector())),(function()
return (smalltalk:if_true_false_((isDoIt),nil,(function()
if (smalltalk:boolean_and_((smalltalk:notNil_((smalltalk.DumpOverwritenMethods))),(function()
return (smalltalk:boolean_and_((smalltalk.DumpOverwritenMethods),(function()
return (smalltalk:notNil_((smalltalk.Exporter)))
end)))
end)))==true then (self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("? "),(self):name())),">>#")),(aMethod):selector()));
(self):print_(((smalltalk.Exporter):new()):export_method_(self,aMethod)); else (self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("-Overwrite Conflict- "),(self):name())),">>#")),(aMethod):selector())); end;return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end),nil); end;
(self):aboutToAdd_(aMethod);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"private","canAdd: isDoIt method: aMethod\r\n\t\" Private - Returns true if aMethod be added onto the receiver. \"\r\n\r\n\t(OverwriteMethods notNil and: [ OverwriteMethods ]) ifFalse: [\r\n\t\t(self implements: aMethod selector) ifTrue: [\r\n\t\t\tisDoIt ifFalse: [\r\n\t\t\t\t(DumpOverwritenMethods notNil\r\n\t\t\t\tand: [ DumpOverwritenMethods\r\n\t\t\t\tand: [ Exporter notNil ]]) ifTrue: [\r\n\t\t\t\t\tself note: '? ',self name,'>>#',aMethod selector.\r\n\t\t\t\t\tself print: (Exporter new export: self method: aMethod).\r\n\t\t\t\t] ifFalse: [\r\n\t\t\t\t\tself note: '-Overwrite Conflict- ',self name,'>>#',aMethod selector.\r\n\t\t\t\t].\r\n\t\t\t\t^false\r\n\t\t\t].\r\n\t\t].\r\n\t].\r\n\tself aboutToAdd: aMethod.\r\n\t^true ","function(self,isDoIt,aMethod)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif not ((smalltalk:boolean_and_((smalltalk:notNil_((smalltalk.OverwriteMethods))),(function()\r\nreturn (smalltalk.OverwriteMethods)\r\nend))))==true then smalltalk:if_true_false_(((self):implements_((aMethod):selector())),(function()\r\nreturn (smalltalk:if_true_false_((isDoIt),nil,(function()\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((smalltalk.DumpOverwritenMethods))),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk.DumpOverwritenMethods),(function()\r\nreturn (smalltalk:notNil_((smalltalk.Exporter)))\r\nend)))\r\nend)))==true then (self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"? \"),(self):name())),\">>#\")),(aMethod):selector()));\r\n(self):print_(((smalltalk.Exporter):new()):export_method_(self,aMethod)); else (self):note_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"-Overwrite Conflict- \"),(self):name())),\">>#\")),(aMethod):selector())); end;return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend),nil); end;\r\n(self):aboutToAdd_(aMethod);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Behavior,"basicAddCompiledMethod:",0
,function(self,aMethod)
((self):smalltalk()):addMethod(((aMethod):selector()):asSelector(),aMethod,self);
return (self);
end
,"private","basicAddCompiledMethod: aMethod\r\n\t\" Private - Register aMethod onto the receiver. \"\r\n\r\n\tself smalltalk\r\n\t\t#addMethod: aMethod selector asSelector\r\n\t\tmethod: aMethod to: self","function(self,aMethod)\r\n((self):smalltalk()):addMethod(((aMethod):selector()):asSelector(),aMethod,self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"addCompiledMethod:",0
,function(self,aMethod)
local isDoIt=nil
(function()
	local _s8_value=(smalltalk:isObject_equalTo_(((aMethod):selector()),(smalltalk.String):doItSelector()))
	isDoIt=_s8_value
	return _s8_value
end)();
if not (((self):canAdd_method_(isDoIt,aMethod)))==true then return (nil); end;
if (smalltalk:boolean_and_((smalltalk:notNil_((smalltalk.Exporter))),(function()
return (smalltalk:booleanNot_((isDoIt)))
end)))==true then (self):print_(((smalltalk.Exporter):new()):export_method_(self,aMethod)); end;
return ((self):basicAddCompiledMethod_(aMethod));
end
,"methods","addCompiledMethod: aMethod\r\n\t\" Add the compiled method, if appropiate, and register the method in recent methods. \"\r\n\r\n\t| isDoIt |\r\n\tisDoIt := aMethod selector = String doItSelector.\r\n\t(self canAdd: isDoIt method: aMethod) ifFalse: [ ^nil ].\r\n\t(Exporter notNil and: [ isDoIt not ]) ifTrue: [\r\n\" DEBUG -\tself note: self name,'>>#',aMethod selector.\"\r\n\t\tself print: (Exporter new export: self method: aMethod).\r\n\t].\r\n\t^self basicAddCompiledMethod: aMethod","function(self,aMethod)\r\nlocal isDoIt=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:isObject_equalTo_(((aMethod):selector()),(smalltalk.String):doItSelector()))\r\n\tisDoIt=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((self):canAdd_method_(isDoIt,aMethod)))==true then return (nil); end;\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((smalltalk.Exporter))),(function()\r\nreturn (smalltalk:booleanNot_((isDoIt)))\r\nend)))==true then (self):print_(((smalltalk.Exporter):new()):export_method_(self,aMethod)); end;\r\nreturn ((self):basicAddCompiledMethod_(aMethod));\r\nend")

smalltalk:addClass("ComposedObjects",smalltalk.ArrayedContents,smalltalk:newArray({"species"}),"Kernel")

smalltalk:bind(smalltalk.ComposedObjects,",","_comma"
,function(self,anObject)
if (smalltalk:isNil_((anObject)))==true then return (self); end;
if (smalltalk:boolean_or_(((anObject):isArray()),(function()
return (smalltalk:responds_to_((anObject),("asArray")))
end)))==true then ((anObject):asArray()):do_((function(each)
return (smalltalk:object_comma_((self),each))
end));
return (self); end;
if (smalltalk:boolean_and_((smalltalk:notNil_((self["@species"]))),(function()
return (smalltalk:booleanNot_((smalltalk:is_kindOf_((anObject),(self["@species"])))))
end)))==true then (self):error_("Invalid object to compose"); end;
(self):add_(anObject);
return (self);
end
,"composing",", anObject\r\n\t\" Return the receiver composed with the argument. \"\r\n\r\n\tanObject isNil ifTrue: [ ^self ].\r\n\t(anObject isArray or: [ anObject respondsTo: #asArray ]) ifTrue: [\r\n\t\tanObject asArray do: [:each| self , each ].\r\n\t\t^self\r\n\t].\r\n\r\n\t(species notNil and: [ (anObject isKindOf: species) not ]) ifTrue: [\r\n\t\tself error: 'Invalid object to compose'\r\n\t].\r\n\r\n\tself add: anObject.","function(self,anObject)\r\nif (smalltalk:isNil_((anObject)))==true then return (self); end;\r\nif (smalltalk:boolean_or_(((anObject):isArray()),(function()\r\nreturn (smalltalk:responds_to_((anObject),(\"asArray\")))\r\nend)))==true then ((anObject):asArray()):do_((function(each)\r\nreturn (smalltalk:object_comma_((self),each))\r\nend));\r\nreturn (self); end;\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((self[\"@species\"]))),(function()\r\nreturn (smalltalk:booleanNot_((smalltalk:is_kindOf_((anObject),(self[\"@species\"])))))\r\nend)))==true then (self):error_(\"Invalid object to compose\"); end;\r\n(self):add_(anObject);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ComposedObjects,"species:",0
,function(self,aBehavior)
(function()
	local _s8_value=(aBehavior)
	self["@species"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","species: aBehavior\r\n\t\" Set the species to compose in the receiver. \"\r\n\r\n\tspecies := aBehavior","function(self,aBehavior)\r\n(function()\r\n\tlocal _s8_value=(aBehavior)\r\n\tself[\"@species\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Behavior,"collection",0
,function(self)
return ((
function(_s8_rec)
	(_s8_rec):species_(self);
	return ((_s8_rec):yourself())
end
)((smalltalk.ComposedObjects):new()));
end
,"composing","collection\r\n\t\" Return a collection to compose instances of the receiver. \"\r\n\r\n\t^ComposedObjects new\r\n\t\tspecies: self;\r\n\t\tyourself","function(self)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):species_(self);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.ComposedObjects):new()));\r\nend")

smalltalk:addClass("DateTime",smalltalk.Object,smalltalk:newArray({}),"Kernel")

smalltalk:bind(smalltalk.DateTime["$klass"],"new:",0
,function(self,anObject)
if true then return self:notImplementedYet_("new:") end;
return (self);
end
,"instantiation","new: anObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}","function(self,anObject)\r\nif true then return self:notImplementedYet_(\"new:\") end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.DateTime["$klass"],"fromString:",0
,function(self,aString)
return ((self):new_(aString));
end
,"instantiation","fromString: aString\r\n\t\" Return an instance of the receiver.\r\n\tDateTime fromString: '1962/12/15 01:40:00'\r\n\t\"\r\n\r\n\t^self new: aString","function(self,aString)\r\nreturn ((self):new_(aString));\r\nend")

smalltalk:bind(smalltalk.DateTime["$klass"],"fromSeconds:",0
,function(self,aNumber)
return ((self):fromMilliseconds_((aNumber):_star(1000)));
end
,"instantiation","fromSeconds: aNumber\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self fromMilliseconds: aNumber * 1000","function(self,aNumber)\r\nreturn ((self):fromMilliseconds_((aNumber):_star(1000)));\r\nend")

smalltalk:bind(smalltalk.DateTime["$klass"],"fromMilliseconds:",0
,function(self,aNumber)
return ((self):new_(aNumber));
end
,"instantiation","fromMilliseconds: aNumber\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new: aNumber","function(self,aNumber)\r\nreturn ((self):new_(aNumber));\r\nend")

smalltalk:bind(smalltalk.DateTime["$klass"],"today",0
,function(self)
if true then return self:new() end;
return ((self):new());
end
,"instantiation","today\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}.\r\n\t^self new","function(self)\r\nif true then return self:new() end;\r\nreturn ((self):new());\r\nend")

smalltalk:bind(smalltalk.DateTime["$klass"],"now",0
,function(self)
if true then return self:today() end;
return ((self):today());
end
,"instantiation","now\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t{'' doc'native instantiation'}.\r\n\t^self today","function(self)\r\nif true then return self:today() end;\r\nreturn ((self):today());\r\nend")

smalltalk:bind(smalltalk.DateTime["$klass"],"msNow",0
,function(self)
if true then return os.clock()*1000 end;
return ((self):new());
end
,"instantiation","msNow\r\n\t\" Private - Return a magnitude to measure milliseconds. \"\r\n\r\n\t{'' doc'native instantiation'}.\r\n\t^self new","function(self)\r\nif true then return os.clock()*1000 end;\r\nreturn ((self):new());\r\nend")

smalltalk:bind(smalltalk.DateTime["$klass"],"millisecondsToRun:",0
,function(self,aBlock)
local start=nil
(function()
	local _s8_value=((self):msNow())
	start=_s8_value
	return _s8_value
end)();
(aBlock):value();
return (((self):msNow()):_minus(start));
end
,"instantiation","millisecondsToRun: aBlock\r\n\t\" Return the time elapsed during evaluation of aBlock. \"\r\n\r\n\t| start |\r\n\tstart := self msNow.\r\n\taBlock value.\r\n\t^self msNow - start","function(self,aBlock)\r\nlocal start=nil\r\n(function()\r\n\tlocal _s8_value=((self):msNow())\r\n\tstart=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aBlock):value();\r\nreturn (((self):msNow()):_minus(start));\r\nend")

smalltalk:bind(smalltalk.DateTime,"year",0
,function(self)
return ((function() self:invalidMessage_("year") end)());
end
,"accessing","year\r\n\t\" Return the year of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","function(self)\r\nreturn ((function() self:invalidMessage_(\"year\") end)());\r\nend")

smalltalk:bind(smalltalk.DateTime,"month",0
,function(self)
return ((function() self:invalidMessage_("month") end)());
end
,"accessing","month\r\n\t\" Return the month of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","function(self)\r\nreturn ((function() self:invalidMessage_(\"month\") end)());\r\nend")

smalltalk:bind(smalltalk.DateTime,"month:",0
,function(self,aNumber)
(function() self:invalidMessage_("month:") end)();
return (self);
end
,"accessing","month: aNumber\r\n\t\" Set the month of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","function(self,aNumber)\r\n(function() self:invalidMessage_(\"month:\") end)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.DateTime,"day",0
,function(self)
return ((function() self:invalidMessage_("day") end)());
end
,"accessing","day\r\n\t\" Return the day of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","function(self)\r\nreturn ((function() self:invalidMessage_(\"day\") end)());\r\nend")

smalltalk:bind(smalltalk.DateTime,"dayOfWeek",0
,function(self)
(self):invalidMessage_("dayOfWeek");
return (self);
end
,"accessing","dayOfWeek\r\n\t\" Return the day of week of the receiver. \"\r\n\r\n\tself invalidMessage: #dayOfWeek.","function(self)\r\n(self):invalidMessage_(\"dayOfWeek\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.DateTime,"dayOfWeek:",0
,function(self,aNumber)
(self):invalidMessage_("dayOfWeek:");
return (self);
end
,"accessing","dayOfWeek: aNumber\r\n\t\" Set the day of week of the receiver. \"\r\n\r\n\tself invalidMessage: #dayOfWeek:.","function(self,aNumber)\r\n(self):invalidMessage_(\"dayOfWeek:\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.DateTime,"day:",0
,function(self,aNumber)
(function() self:invalidMessage_("day:") end)();
return (self);
end
,"accessing","day: aNumber\r\n\t\" Set the day of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","function(self,aNumber)\r\n(function() self:invalidMessage_(\"day:\") end)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.DateTime,"year:",0
,function(self,aNumber)
(function() self:invalidMessage_("year:") end)();
return (self);
end
,"accessing","year: aNumber\r\n\t\" Set the year of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","function(self,aNumber)\r\n(function() self:invalidMessage_(\"year:\") end)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.DateTime,"dayOfMonth",0
,function(self)
return ((function() self:invalidMessage_("dayOfMonth") end)());
end
,"accessing","dayOfMonth\r\n\t\" Return the day of month of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","function(self)\r\nreturn ((function() self:invalidMessage_(\"dayOfMonth\") end)());\r\nend")

smalltalk:bind(smalltalk.DateTime,"dayOfMonth:",0
,function(self,aNumber)
(function() self:invalidMessage_("dayOfMonth:") end)();
return (self);
end
,"accessing","dayOfMonth: aNumber\r\n\t\" Set the day of month of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","function(self,aNumber)\r\n(function() self:invalidMessage_(\"dayOfMonth:\") end)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.DateTime,"asString",0
,function(self)

return (smalltalk:toString_((self)));
end
,"converting","asString\r\n\t\" Return the text representation of the receiver. \"\r\n\r\n\t{'self' doc'native conversion'}.\r\n\t^self toString","function(self)\r\n\r\nreturn (smalltalk:toString_((self)));\r\nend")

smalltalk:bind(smalltalk.DateTime,"printString",0
,function(self)
return (smalltalk:asString_((self)));
end
,"printing","printString\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self asString","function(self)\r\nreturn (smalltalk:asString_((self)));\r\nend")

smalltalk:bind(smalltalk.DateTime,"asMilliseconds",0
,function(self)
return ((self):time());
end
,"converting","asMilliseconds\r\n\t\" Return the receiver as milliseconds. \"\r\n\r\n\t^self time","function(self)\r\nreturn ((self):time());\r\nend")

smalltalk:bind(smalltalk.DateTime,"time",0
,function(self)
return ((function() self:invalidMessage_("time") end)());
end
,"accessing","time\r\n\t\" Return the time of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","function(self)\r\nreturn ((function() self:invalidMessage_(\"time\") end)());\r\nend")

smalltalk:bind(smalltalk.DateTime,"time:",0
,function(self,aNumber)
(function() self:invalidMessage_("time:") end)();
return (self);
end
,"accessing","time: aNumber\r\n\t\" Set the time of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","function(self,aNumber)\r\n(function() self:invalidMessage_(\"time:\") end)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.DateTime,"asDateString",0
,function(self)
return ((function() self:invalidMessage_("asDateString") end)());
end
,"converting","asDateString\r\n\t\" Return the date string of the receiver. \"\r\n\r\n\t^{'' doc'native converting'}","function(self)\r\nreturn ((function() self:invalidMessage_(\"asDateString\") end)());\r\nend")

smalltalk:bind(smalltalk.DateTime,"asTimeString",0
,function(self)
return ((function() self:invalidMessage_("asTimeString") end)());
end
,"converting","asTimeString\r\n\t\" Return the time string of the receiver. \"\r\n\r\n\t^{'' doc'native converting'}","function(self)\r\nreturn ((function() self:invalidMessage_(\"asTimeString\") end)());\r\nend")

smalltalk:bind(smalltalk.DateTime,"asLocaleString",0
,function(self)
return ((function() self:invalidMessage_("asLocaleString") end)());
end
,"converting","asLocaleString\r\n\t\" Return the locale string of the receiver. \"\r\n\r\n\t^{'' doc'native converting'}","function(self)\r\nreturn ((function() self:invalidMessage_(\"asLocaleString\") end)());\r\nend")

smalltalk:bind(smalltalk.DateTime,"asNumber",0
,function(self)
return ((self):asMilliseconds());
end
,"converting","asNumber\r\n\t\" Return the receiver as a Number. \"\r\n\r\n\t^self asMilliseconds","function(self)\r\nreturn ((self):asMilliseconds());\r\nend")

smalltalk:bind(smalltalk.DateTime,"hours:",0
,function(self,aNumber)
(function() self:invalidMessage_("hours:") end)();
return (self);
end
,"accessing","hours: aNumber\r\n\t\" Set the hours of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","function(self,aNumber)\r\n(function() self:invalidMessage_(\"hours:\") end)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.DateTime,"minutes:",0
,function(self,aNumber)
(function() self:invalidMessage_("minutes:") end)();
return (self);
end
,"accessing","minutes: aNumber\r\n\t\" Set the minutes of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","function(self,aNumber)\r\n(function() self:invalidMessage_(\"minutes:\") end)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.DateTime,"seconds:",0
,function(self,aNumber)
(function() self:invalidMessage_("seconds:") end)();
return (self);
end
,"accessing","seconds: aNumber\r\n\t\" Set the seconds of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","function(self,aNumber)\r\n(function() self:invalidMessage_(\"seconds:\") end)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.DateTime,"milliseconds:",0
,function(self,aNumber)
(function() self:invalidMessage_("milliseconds:") end)();
return (self);
end
,"accessing","milliseconds: aNumber\r\n\t\" Set the milliseconds of the receiver. \"\r\n\r\n\t{'' doc'native accessing'}","function(self,aNumber)\r\n(function() self:invalidMessage_(\"milliseconds:\") end)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.DateTime,"hours",0
,function(self)
return ((function() self:invalidMessage_("hours") end)());
end
,"accessing","hours\r\n\t\" Return the hours of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","function(self)\r\nreturn ((function() self:invalidMessage_(\"hours\") end)());\r\nend")

smalltalk:bind(smalltalk.DateTime,"minutes",0
,function(self)
return ((function() self:invalidMessage_("minutes") end)());
end
,"accessing","minutes\r\n\t\" Return the minutes of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","function(self)\r\nreturn ((function() self:invalidMessage_(\"minutes\") end)());\r\nend")

smalltalk:bind(smalltalk.DateTime,"seconds",0
,function(self)
return ((function() self:invalidMessage_("seconds") end)());
end
,"accessing","seconds\r\n\t\" Return the seconds of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","function(self)\r\nreturn ((function() self:invalidMessage_(\"seconds\") end)());\r\nend")

smalltalk:bind(smalltalk.DateTime,"milliseconds",0
,function(self)
return ((function() self:invalidMessage_("milliseconds") end)());
end
,"accessing","milliseconds\r\n\t\" Return the milliseconds of the receiver. \"\r\n\r\n\t^{'' doc'native accessing'}","function(self)\r\nreturn ((function() self:invalidMessage_(\"milliseconds\") end)());\r\nend")

smalltalk:bind(smalltalk.DateTime,"<","_lt"
,function(self,aDateTime)
return (self:notImplementedYet_("<"));
end
,"comparing","< aDateTime\r\n\t\" Return true if the receiver is smaller than argument. \"\r\n\r\n\t^{'' doc'native compare'}","function(self,aDateTime)\r\nreturn (self:notImplementedYet_(\"<\"));\r\nend")

smalltalk:bind(smalltalk.DateTime,">","_gt"
,function(self,aDateTime)
return (self:notImplementedYet_(">"));
end
,"comparing","> aDateTime\r\n\t\" Return true if the receiver is greater than argument. \"\r\n\r\n\t^{'' doc'native compare'}","function(self,aDateTime)\r\nreturn (self:notImplementedYet_(\">\"));\r\nend")

smalltalk:bind(smalltalk.DateTime,"<=","_lt_eq"
,function(self,aDateTime)
return (self:notImplementedYet_("<="));
end
,"comparing","<= aDateTime\r\n\t\" Return true if the receiver is smaller or equal to argument. \"\r\n\r\n\t^{'' doc'native compare'}","function(self,aDateTime)\r\nreturn (self:notImplementedYet_(\"<=\"));\r\nend")

smalltalk:bind(smalltalk.DateTime,">=","_gt_eq"
,function(self,aDateTime)
return (self:notImplementedYet_(">="));
end
,"comparing",">= aDateTime\r\n\t\" Return true if the receiver is greater or equal to argument. \"\r\n\r\n\t^{'' doc'native compare'}","function(self,aDateTime)\r\nreturn (self:notImplementedYet_(\">=\"));\r\nend")

smalltalk:bind(smalltalk.DateTime,"-","_minus"
,function(self,aDateTime)
return (self:notImplementedYet_("-"));
end
,"arithmetic","- aDateTime\r\n\t\" Return the result of operation. \"\r\n\r\n\t^{'' doc'native operation'}","function(self,aDateTime)\r\nreturn (self:notImplementedYet_(\"-\"));\r\nend")

smalltalk:bind(smalltalk.DateTime,"+","_plus"
,function(self,aDateTime)
return (self:notImplementedYet_("+"));
end
,"arithmetic","+ aDateTime\r\n\t\" Return the result of operation. \"\r\n\r\n\t^{'' doc'native operation'}","function(self,aDateTime)\r\nreturn (self:notImplementedYet_(\"+\"));\r\nend")

smalltalk:bind(smalltalk.DateTime,"isValid",0
,function(self)
return (self:notImplementedYet_("isValid"));
end
,"testing","isValid\r\n\t\" Return true if the receiver is a valid instance. \"\r\n\r\n\t^{'' doc'native testing'}","function(self)\r\nreturn (self:notImplementedYet_(\"isValid\"));\r\nend")

smalltalk:bind(smalltalk.DateTime,"asJSONObject",0
,function(self)

return (self);
end
,"json","asJSONObject\r\n\t\" Return the receiver as a hash object. \"\r\n\r\n\t{'self' doc'native converting'}.\r\n\t^self","function(self)\r\n\r\nreturn (self);\r\nend")
