
-- fileIn("s8/start/Lua.st")
smalltalk:addClass("LuaEncoder",smalltalk.NativeEncoder,smalltalk:newArray({}),"Lua")

smalltalk:bind(smalltalk.LuaEncoder["$klass"],"supportsLanguage:",0
,function(self,aLanguage)
return (smalltalk:isObject_equalTo_((aLanguage),"lua"));
end
,"instantiation","supportsLanguage: aLanguage\r\n\t\" Private - Return true if instances of the receiver can encode to aLanguage. \"\r\n\r\n\t^aLanguage = #lua ","function(self,aLanguage)\r\nreturn (smalltalk:isObject_equalTo_((aLanguage),\"lua\"));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"nativeLanguage",0
,function(self)
return ("lua");
end
,"accessing","nativeLanguage\r\n\t\" Return the nativeLanguage of the receiver. \"\r\n\r\n\t^#lua ","function(self)\r\nreturn (\"lua\");\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"nativeUndefined",0
,function(self)
return ("nil");
end
,"encoding","nativeUndefined\r\n\t\" Private - Return the code for undefined. \"\r\n\r\n\t^#nil ","function(self)\r\nreturn (\"nil\");\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"nativeNameOfMetaClass:",0
,function(self,aClass)
return (smalltalk:object_comma_((((aClass):instanceClass()):name()),"[\"$klass\"]"));
end
,"encoding","nativeNameOfMetaClass: aClass\r\n\t\" Private - Return the native name for metaclass aClass. \"\r\n\r\n\t^aClass instanceClass name ,'[\"$klass\"]' ","function(self,aClass)\r\nreturn (smalltalk:object_comma_((((aClass):instanceClass()):name()),\"[\\\"$klass\\\"]\"));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"callEscape",0
,function(self)
return ("#_");
end
,"accessing","callEscape\r\n\t\" Private - Return the selector sequence to escape OO message send selector, and produce code for function call.\r\n\tNote that an alien selector starting with two $$ are understood as a function call to function starting with $\r\n\t\"\r\n\r\n\t^'#_'","function(self)\r\nreturn (\"#_\");\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"missingNativeCodeFor:as:",0
,function(self,aNode,lang)
return (smalltalk:object_comma_((smalltalk:object_comma_(("(function() self:invalidMessage_(\""),(self["@compiler"]):selector())),"\") end)()"));
end
,"inlines","missingNativeCodeFor: aNode as: lang\r\n\t\" Private - Return the native language code for missing expression (or nil). \"\r\n\r\n\t^'(function() self:invalidMessage_(\"' ,compiler selector ,'\") end)()'","function(self,aNode,lang)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"(function() self:invalidMessage_(\\\"\"),(self[\"@compiler\"]):selector())),\"\\\") end)()\"));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"canExportMethod:",0
,function(self,aMethod)
return (true);
end
,"private","canExportMethod: aMethod\r\n\t\" Private - Return true if the receiver can/want to export method aMethod. \"\r\n\r\n\t^true","function(self,aMethod)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"asSelector:",0
,function(self,aSelector)
return ((aSelector):asLuaSelector());
end
,"converting","asSelector: aSelector\r\n\t\" Return the native representation of aSelector. \"\r\n\r\n\t^aSelector asLuaSelector","function(self,aSelector)\r\nreturn ((aSelector):asLuaSelector());\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"nativeSourceFor:",0
,function(self,aMethod)
return (smalltalk:if_true_false_(((self):canExportMethod_(aMethod)),(function()
return ((self):privateSourceFor_(aMethod))
end),nil));
end
,"private","nativeSourceFor: aMethod\r\n\t\" Private - Return the code of native function implementing aMethod. \"\r\n\r\n\t^(self canExportMethod: aMethod) ifTrue: [\r\n\t\tself privateSourceFor: aMethod\r\n\t]","function(self,aMethod)\r\nreturn (smalltalk:if_true_false_(((self):canExportMethod_(aMethod)),(function()\r\nreturn ((self):privateSourceFor_(aMethod))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"export:method:on:",0
,function(self,aClass,aMethod,aStream)
local fName=nil
local selectorName=nil
local bar=nil
local source=nil
(function()
	local _s8_value=((self):nativeSourceFor_(aMethod))
	source=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((source)))==true then return (false); end;
if (smalltalk:isNil_((aMethod)))==true then (self):error_("Method is missing"); end;
(function()
	local _s8_value=("\"")
	bar=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((aMethod):selector())
	fName=_s8_value
	return _s8_value
end)();
if (((fName):first()):isBackSlash())==true then (function()
	local _s8_value=((self):escaped_((aMethod):selector()))
	selectorName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):escaped_((self):asSelector_(fName)))
	fName=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((bar),(aMethod):selector())),bar))
	selectorName=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):asSelector_(fName)),((aMethod):selector()):replace_with_(":","_"))),(function()
return ((function()
	local _s8_value=(0)
	fName=_s8_value
	return _s8_value
end)())
end),(function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((bar),(self):asSelector_(fName))),bar))
	fName=_s8_value
	return _s8_value
end)())
end)); end;
(aStream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk:bind("),(self):smalltalkNameFor_(aClass))),",")),selectorName)),",")),fName)),"\r\n,")),source));
if (smalltalk:boolean_and_((smalltalk:notNil_(((aMethod):source()))),(function()
return (((aMethod):source()):notEmpty())
end)))==true then (
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((","),(self):escaped_((aMethod):category()))),",")),(self):escaped_((aMethod):source()))),",")),(self):escaped_(source))))
end
)(aStream); end;
if (smalltalk:boolean_and_((smalltalk:responds_to_((aMethod),("stamp"))),(function()
return (smalltalk:notNil_(((aMethod):stamp())))
end)))==true then (aStream):nextPutAll_(smalltalk:object_comma_((","),(self):escaped_((aMethod):stamp()))); end;
(aStream):nextPutAll_(")\r\n");
return (true);
end
,"export","export: aClass method: aMethod on: aStream\r\n\t\" Export a method definition of aClass onto aStream. \"\r\n\r\n\t| fName selectorName bar source |\r\n\tsource := self nativeSourceFor: aMethod.\r\n\tsource isNil ifTrue: [ ^false ].\r\n\taMethod isNil ifTrue: [ self error: 'Method is missing' ].\r\n\tbar := $\".\r\n\tfName := aMethod selector.\r\n\tfName first isBackSlash ifTrue: [\r\n\t\tselectorName := self escaped: aMethod selector.\r\n\t\tfName := self escaped: (self asSelector: fName).\r\n\t] ifFalse: [\r\n\t\tselectorName := bar ,aMethod selector, bar.\r\n\t\t(self asSelector: fName) = (aMethod selector replace: $: with: $_) ifTrue: [\r\n\t\t\tfName := 0\r\n\t\t] ifFalse: [\r\n\t\t\tfName := bar ,(self asSelector: fName) ,bar\r\n\t\t].\r\n\t].\r\n\taStream\r\n\t\tnextPutAll: 'smalltalk:bind(' ,(self smalltalkNameFor: aClass)\r\n\t\t\t,',' ,selectorName ,',' ,fName ,'\r\n,'\t\t\t,source.\r\n\t(aMethod source notNil and: [ aMethod source notEmpty ]) ifTrue: [\r\n\t    aStream cr; \"warning: this cr is important for debugger\"\r\n\t\tnextPutAll: ',' ,(self escaped: aMethod category)\r\n\t\t\t,',' ,(self escaped: aMethod source)\r\n\t\t\t,',' ,(self escaped: source).\r\n\t].\r\n\t((aMethod respondsTo: #stamp) and: [ aMethod stamp notNil ]) ifTrue: [\r\n\t\taStream nextPutAll: ',' ,(self escaped: aMethod stamp)\r\n\t].\r\n\taStream nextPutAll: ')\r\n'.\t^true","function(self,aClass,aMethod,aStream)\r\nlocal fName=nil\r\nlocal selectorName=nil\r\nlocal bar=nil\r\nlocal source=nil\r\n(function()\r\n\tlocal _s8_value=((self):nativeSourceFor_(aMethod))\r\n\tsource=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((source)))==true then return (false); end;\r\nif (smalltalk:isNil_((aMethod)))==true then (self):error_(\"Method is missing\"); end;\r\n(function()\r\n\tlocal _s8_value=(\"\\\"\")\r\n\tbar=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((aMethod):selector())\r\n\tfName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (((fName):first()):isBackSlash())==true then (function()\r\n\tlocal _s8_value=((self):escaped_((aMethod):selector()))\r\n\tselectorName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):escaped_((self):asSelector_(fName)))\r\n\tfName=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((bar),(aMethod):selector())),bar))\r\n\tselectorName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self):asSelector_(fName)),((aMethod):selector()):replace_with_(\":\",\"_\"))),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(0)\r\n\tfName=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((bar),(self):asSelector_(fName))),bar))\r\n\tfName=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)); end;\r\n(aStream):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk:bind(\"),(self):smalltalkNameFor_(aClass))),\",\")),selectorName)),\",\")),fName)),\"\\r\\n,\")),source));\r\nif (smalltalk:boolean_and_((smalltalk:notNil_(((aMethod):source()))),(function()\r\nreturn (((aMethod):source()):notEmpty())\r\nend)))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\",\"),(self):escaped_((aMethod):category()))),\",\")),(self):escaped_((aMethod):source()))),\",\")),(self):escaped_(source))))\r\nend\r\n)(aStream); end;\r\nif (smalltalk:boolean_and_((smalltalk:responds_to_((aMethod),(\"stamp\"))),(function()\r\nreturn (smalltalk:notNil_(((aMethod):stamp())))\r\nend)))==true then (aStream):nextPutAll_(smalltalk:object_comma_((\",\"),(self):escaped_((aMethod):stamp()))); end;\r\n(aStream):nextPutAll_(\")\\r\\n\");\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"arrayLiteralStart",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk:newArray"),"(")),"{"));
end
,"arrays","arrayLiteralStart\r\n\t\" Private - Return the code string to start exporting an array literal. \"\r\n\r\n\t^'smalltalk:newArray' ,$( ,${","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk:newArray\"),\"(\")),\"{\"));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"arrayLiteralEnd",0
,function(self)
return (smalltalk:object_comma_(("}"),")"));
end
,"arrays","arrayLiteralEnd\r\n\t\" Private - Return the code string to end exporting an array literal. \"\r\n\r\n\t^$} ,$)","function(self)\r\nreturn (smalltalk:object_comma_((\"}\"),\")\"));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"escaped:",0
,function(self,string)
return ((string):asLua());
end
,"literals","escaped: string\r\n\t\" Private - Return the code string to export string literal. \"\r\n\r\n\t^string asLua","function(self,string)\r\nreturn ((string):asLua());\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"exportCommentOf:on:",0
,function(self,aClass,aStream)
if (((((aClass):comment()):size()) > 0))==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	(_s8_rec):nextPutAll_(smalltalk:object_comma_(("[\"$comment\"]="),(self):escaped_((aClass):comment())));
	return ((_s8_rec):cr())
end
)(aStream); end;
return (self);
end
,"export","exportCommentOf: aClass on: aStream\r\n\t\" Export the comment of aClass onto aStream. \"\r\n\r\n\taClass comment size > 0 ifTrue: [\r\n\t    aStream\r\n\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\tnextPutAll: '[\"$comment\"]=' ,(self escaped: aClass comment); cr\r\n\t]","function(self,aClass,aStream)\r\nif (((((aClass):comment()):size()) > 0))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((\"[\\\"$comment\\\"]=\"),(self):escaped_((aClass):comment())));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"exportDefinitionOf:on:",0
,function(self,aClass,aStream)
((self):loadRequirementsOf_(aClass)):do_((function(each)
return (smalltalk:if_true_false_(((each):isString()),(function()
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_(each);
	return ((_s8_rec):cr())
end
)(aStream))
end),(function()
return ((aStream):fileOutOn_(aStream))
end)))
end));
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk:addClass(\""),(aClass):name())),"\","));
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass):superclass()));
	return ((_s8_rec):nextPutAll_(","))
end
)(aStream);
(self):exportArrayLiteral_on_newLine_((aClass):instanceVariableNames(),aStream,false);
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((",\""),(aClass):category())),"\""));
	(_s8_rec):nextPutAll_(")");
	return ((_s8_rec):cr())
end
)(aStream);
if (smalltalk:notNil_(((aClass):classVariables())))==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	(_s8_rec):nextPutAll_(smalltalk:object_comma_(("[\"$classVariableNames\"]="),(self):escaped_((aClass):classVariablesString())));
	return ((_s8_rec):cr())
end
)(aStream); end;
if (smalltalk:notNil_(((aClass):poolDictionaries())))==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	return ((_s8_rec):nextPutAll_("[\"$poolDictionaries\"]="))
end
)(aStream);
(self):exportArrayLiteral_on_newLine_((aClass):poolDictionaries(),aStream,true); end;
if (((aClass):propertyNames()):notEmpty())==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	return ((_s8_rec):nextPutAll_("[\"$propertyNames\"]="))
end
)(aStream);
(self):exportArrayLiteral_on_newLine_((aClass):propertyNames(),aStream,true); end;
(self):exportCommentOf_on_(aClass,aStream);
return (self);
end
,"export","exportDefinitionOf: aClass on: aStream\r\n\t\" Export definition of aClass onto aStream. \"\r\n\r\n\t(self loadRequirementsOf: aClass) do: [:each|\r\n\t\teach isString\r\n\t\tifTrue: [ aStream nextPutAll: each;cr ]\r\n\t\tifFalse: [ aStream fileOutOn: aStream ].\r\n\t].\r\n\taStream \r\n\t    nextPutAll: 'smalltalk:addClass(\"', aClass name, '\",';\r\n\t    nextPutAll: (self smalltalkNameFor: aClass superclass);\r\n\t    nextPutAll: ','.\r\n\tself exportArrayLiteral: aClass instanceVariableNames on: aStream newLine: false.\r\n\taStream\r\n\t    nextPutAll: ',\"' ,aClass category, $\";\r\n\t    nextPutAll: ')'; cr.\r\n\taClass classVariables notNil ifTrue: [\r\n\t    aStream\r\n\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\tnextPutAll: '[\"$classVariableNames\"]=' ,(self escaped: aClass classVariablesString); cr\r\n\t].\r\n\taClass poolDictionaries notNil ifTrue: [\r\n\t    aStream\r\n\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\tnextPutAll: '[\"$poolDictionaries\"]='.\r\n\t   self exportArrayLiteral: aClass poolDictionaries on: aStream newLine: true.\r\n\t].\r\n\taClass propertyNames notEmpty ifTrue: [\r\n\t    aStream\r\n\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\tnextPutAll: '[\"$propertyNames\"]='.\r\n\t   self exportArrayLiteral: aClass propertyNames on: aStream newLine: true.\r\n\t].\r\n\tself exportCommentOf: aClass on: aStream.","function(self,aClass,aStream)\r\n((self):loadRequirementsOf_(aClass)):do_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):isString()),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(each);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream))\r\nend),(function()\r\nreturn ((aStream):fileOutOn_(aStream))\r\nend)))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk:addClass(\\\"\"),(aClass):name())),\"\\\",\"));\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass):superclass()));\r\n\treturn ((_s8_rec):nextPutAll_(\",\"))\r\nend\r\n)(aStream);\r\n(self):exportArrayLiteral_on_newLine_((aClass):instanceVariableNames(),aStream,false);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\",\\\"\"),(aClass):category())),\"\\\"\"));\r\n\t(_s8_rec):nextPutAll_(\")\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream);\r\nif (smalltalk:notNil_(((aClass):classVariables())))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((\"[\\\"$classVariableNames\\\"]=\"),(self):escaped_((aClass):classVariablesString())));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(aStream); end;\r\nif (smalltalk:notNil_(((aClass):poolDictionaries())))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\treturn ((_s8_rec):nextPutAll_(\"[\\\"$poolDictionaries\\\"]=\"))\r\nend\r\n)(aStream);\r\n(self):exportArrayLiteral_on_newLine_((aClass):poolDictionaries(),aStream,true); end;\r\nif (((aClass):propertyNames()):notEmpty())==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\treturn ((_s8_rec):nextPutAll_(\"[\\\"$propertyNames\\\"]=\"))\r\nend\r\n)(aStream);\r\n(self):exportArrayLiteral_on_newLine_((aClass):propertyNames(),aStream,true); end;\r\n(self):exportCommentOf_on_(aClass,aStream);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"exportMetaDefinitionOf:on:",0
,function(self,aClass,aStream)
if ((((aClass)["$klass"]):instanceVariableNames()):notEmpty())==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass)["$klass"]));
	return ((_s8_rec):nextPutAll_("[\"$iVarNames\"]="))
end
)(aStream);
(self):exportArrayLiteral_on_newLine_(((aClass)["$klass"]):instanceVariableNames(),aStream,true); end;
if ((((aClass)["$klass"]):propertyNames()):notEmpty())==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass)["$klass"]));
	return ((_s8_rec):nextPutAll_("[\"$propertyNames\"]="))
end
)(aStream);
(self):exportArrayLiteral_on_newLine_(((aClass)["$klass"]):propertyNames(),aStream,true); end;
return (self);
end
,"export","exportMetaDefinitionOf: aClass on: aStream\r\n\t\" Export class side definition of aClass onto aStream. \"\r\n\r\n\taClass class instanceVariableNames notEmpty ifTrue: [\r\n\t\taStream \r\n\t\t\tnextPutAll: (self smalltalkNameFor: aClass class);\r\n\t\t\tnextPutAll: '[\"$iVarNames\"]='.\r\n\t\tself exportArrayLiteral: aClass class instanceVariableNames on: aStream newLine: true.\r\n\t].\r\n\r\n\taClass class propertyNames notEmpty ifTrue: [\r\n\t\taStream \r\n\t\t\tnextPutAll: (self smalltalkNameFor: aClass class);\r\n\t\t\tnextPutAll: '[\"$propertyNames\"]='.\r\n\t\tself exportArrayLiteral: aClass class propertyNames on: aStream newLine: true.\r\n\t].","function(self,aClass,aStream)\r\nif ((((aClass)[\"$klass\"]):instanceVariableNames()):notEmpty())==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass)[\"$klass\"]));\r\n\treturn ((_s8_rec):nextPutAll_(\"[\\\"$iVarNames\\\"]=\"))\r\nend\r\n)(aStream);\r\n(self):exportArrayLiteral_on_newLine_(((aClass)[\"$klass\"]):instanceVariableNames(),aStream,true); end;\r\nif ((((aClass)[\"$klass\"]):propertyNames()):notEmpty())==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_((aClass)[\"$klass\"]));\r\n\treturn ((_s8_rec):nextPutAll_(\"[\\\"$propertyNames\\\"]=\"))\r\nend\r\n)(aStream);\r\n(self):exportArrayLiteral_on_newLine_(((aClass)[\"$klass\"]):propertyNames(),aStream,true); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"privateSourceFor:",0
,function(self,aMethod)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local code=nil
if ((smalltalk.Smalltalk):isRunningOn_((self):nativeLanguage()))==true then (function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((aMethod),"$nativeSource",(function()
return (nil)
end)))
	code=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:notNil_((code))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (code)
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
	local _s8_value=(((function()
return ((self):privateCodeFor_(aMethod))
end)):on_do_(smalltalk.Exception,(function(ex)
(self):note_(aMethod);return ((self):privateNIYSourceFor_with_(aMethod,(ex):description()))
end)))
	code=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((smalltalk:object_comma_(("(\r\n"),code)),"\r\n)"))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"lua","privateSourceFor: aMethod\r\n\t\" Private - Return the native code implementing aMethod. \"\r\n\r\n\t| code |\r\n\t(Smalltalk isRunningOn: self nativeLanguage) ifTrue: [\r\n\t\tcode := aMethod basicAt: '$nativeSource' ifAbsent: [].\r\n\t\tcode notNil ifTrue: [ ^code ].\r\n\t].\r\n\r\n\tcode := [ self privateCodeFor: aMethod ] on: Exception do: [:ex|\r\n\t\tself note: aMethod.\r\n\t\tself privateNIYSourceFor: aMethod with: ex description\r\n\t].\r\n\t^'(\r\n'\t,code ,'\r\n)'","function(self,aMethod)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal code=nil\r\nif ((smalltalk.Smalltalk):isRunningOn_((self):nativeLanguage()))==true then (function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((aMethod),\"$nativeSource\",(function()\r\nreturn (nil)\r\nend)))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:notNil_((code))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (code)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n\tlocal _s8_value=(((function()\r\nreturn ((self):privateCodeFor_(aMethod))\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\n(self):note_(aMethod);return ((self):privateNIYSourceFor_with_(aMethod,(ex):description()))\r\nend)))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"(\\r\\n\"),code)),\"\\r\\n)\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"privateNIYSourceFor:with:",0
,function(self,aMethod,description)
return (smalltalk:object_comma_(((self):privateMethodDefinition_(aMethod)),(self):privateMethodBody_with_(aMethod,description)));
end
,"niy","privateNIYSourceFor: aMethod with: description\r\n\t\" Private - Return the native code implementing aMethod. \"\r\n\r\n\t^(self privateMethodDefinition: aMethod)\r\n\t,(self privateMethodBody: aMethod with: description)","function(self,aMethod,description)\r\nreturn (smalltalk:object_comma_(((self):privateMethodDefinition_(aMethod)),(self):privateMethodBody_with_(aMethod,description)));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"privateMethodDefinition:",0
,function(self,aMethod)
local args=nil
(function()
	local _s8_value=((
function(_s8_rec)
	(_s8_rec):upTo_("(");
	return ((_s8_rec):upTo_(")"))
end
)(((aMethod):compiledSource()):stream()))
	args=_s8_value
	return _s8_value
end)();
if ((args):notEmpty())==true then (function()
	local _s8_value=(((args):asArrayOfSubstringsSeparatedBy_(",")):inject_into_("",(function(total,each)
return (smalltalk:object_comma_((smalltalk:object_comma_((total),",")),(each):asLuaName()))
end)))
	args=_s8_value
	return _s8_value
end)(); end;
return (smalltalk:object_comma_((smalltalk:object_comma_(("function(self"),args)),")"));
end
,"niy","privateMethodDefinition: aMethod\r\n\t\" Private - Return the (Lua) method definition of aMethod. \"\r\n\r\n\t| args |\r\n\targs := aMethod compiledSource stream upTo: $(; upTo: $).\r\n\targs notEmpty ifTrue: [\r\n\t\targs := (args asArrayOfSubstringsSeparatedBy: $,)\r\n\t\t\tinject: '' into: [:total :each| total ,',' ,each asLuaName ].\r\n\t].\r\n\t^'function(self' ,args ,')'","function(self,aMethod)\r\nlocal args=nil\r\n(function()\r\n\tlocal _s8_value=((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):upTo_(\"(\");\r\n\treturn ((_s8_rec):upTo_(\")\"))\r\nend\r\n)(((aMethod):compiledSource()):stream()))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((args):notEmpty())==true then (function()\r\n\tlocal _s8_value=(((args):asArrayOfSubstringsSeparatedBy_(\",\")):inject_into_(\"\",(function(total,each)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((total),\",\")),(each):asLuaName()))\r\nend)))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"function(self\"),args)),\")\"));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"privateMethodBody:with:",0
,function(self,aMethod,description)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("\r\n\tprint(\"NIY:#privateMethodBody: "),aMethod))," - ")),description)),"\")\r\n\treturn self\r\nend"));
end
,"niy","privateMethodBody: aMethod with: description\r\n\t\" Private - Return the (Lua) body of aMethod. \"\r\n\r\n\t^'\r\n\tprint(\"NIY:#privateMethodBody: ',aMethod,' - ',description,'\")\r\n\treturn self\r\nend'","function(self,aMethod,description)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"\\r\\n\\tprint(\\\"NIY:#privateMethodBody: \"),aMethod)),\" - \")),description)),\"\\\")\\r\\n\\treturn self\\r\\nend\"));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"privateCodeFor:",0
,function(self,aMethod)
(self):compiler_(((aMethod):classField()):compiler());
return ((
function(_s8_rec)
	(_s8_rec):encoder_(self);
	return ((_s8_rec):compile_((aMethod):source()))
end
)((self):compiler()));
end
,"compiling","privateCodeFor: aMethod\r\n\t\" Private - Return the native code translated from sources of aMethod. \"\r\n\r\n\tself compiler: aMethod classField compiler.\r\n\t^self compiler\r\n\t\tencoder: self;\r\n\t\tcompile: aMethod source","function(self,aMethod)\r\n(self):compiler_(((aMethod):classField()):compiler());\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):encoder_(self);\r\n\treturn ((_s8_rec):compile_((aMethod):source()))\r\nend\r\n)((self):compiler()));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"emmitEnterMethod:",0
,function(self,aMethodNode)
return (self);
end
,"generation","emmitEnterMethod: aMethodNode\r\n\t\" Private - Generate home context definitions, entering aMethodNode. \"","function(self,aMethodNode)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"emmitFunctionBody:",0
,function(self,aBlock)
(self):cr();
(aBlock):evaluate();
(
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_("end"))
end
)(self);
return (self);
end
,"generation","emmitFunctionBody: aBlock\r\n\t\" Private - Emmit the code of function body evaluating aBlock. \"\r\n\r\n\tself cr.\r\n\taBlock evaluate.\r\n\tself cr; nextPutAll: #end ","function(self,aBlock)\r\n(self):cr();\r\n(aBlock):evaluate();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(\"end\"))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"newMethodFunctionName",0
,function(self)
return ("smalltalk:newMethod");
end
,"generation","newMethodFunctionName\r\n\t\" Private - Return the function to call when installing a new method. \"\r\n\r\n\t^'smalltalk:newMethod'","function(self)\r\nreturn (\"smalltalk:newMethod\");\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"emmitFunction:node:withSelf:arguments:doing:",0
,function(self,fName,aNode,aBoolean,argumentNames,aBlock)
local aStream=nil
(function()
	local _s8_value=((""):writeStream())
	aStream=_s8_value
	return _s8_value
end)();
if (aBoolean)==true then (aStream):nextPutAll_("self");
smalltalk:if_true_false_(((argumentNames):notEmpty()),(function()
return ((aStream):nextPutAll_((self):argumentsSeparatorOp()))
end),nil); end;
(argumentNames):do_separatedBy_((function(each)
((self):tempVariables()):add_(each);return ((aStream):nextPutAll_((self):localName_(each)))
end),(function()
return ((aStream):nextPutAll_((self):argumentsSeparatorOp()))
end));
(self):emmitFunction_arguments_doing_(fName,(aStream):contents(),aBlock);
return (self);
end
,"generation","emmitFunction: fName node: aNode withSelf: aBoolean arguments: argumentNames doing: aBlock\r\n\t\" Private - Generate function for aNode. \"\r\n\r\n\t| aStream |\r\n\taStream := '' writeStream.\r\n\taBoolean ifTrue: [\r\n\t\taStream nextPutAll: #self.\r\n\t\targumentNames notEmpty ifTrue: [ aStream nextPutAll: self argumentsSeparatorOp ].\r\n\t].\r\n\targumentNames do: [:each | \r\n\t\tself tempVariables add: each.\r\n\t\taStream nextPutAll: (self localName: each) ]\r\n\t    separatedBy: [ aStream nextPutAll: self argumentsSeparatorOp ].\r\n\tself\temmitFunction: fName\r\n\t\targuments: aStream contents\r\n\t\tdoing: aBlock","function(self,fName,aNode,aBoolean,argumentNames,aBlock)\r\nlocal aStream=nil\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\taStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (aBoolean)==true then (aStream):nextPutAll_(\"self\");\r\nsmalltalk:if_true_false_(((argumentNames):notEmpty()),(function()\r\nreturn ((aStream):nextPutAll_((self):argumentsSeparatorOp()))\r\nend),nil); end;\r\n(argumentNames):do_separatedBy_((function(each)\r\n((self):tempVariables()):add_(each);return ((aStream):nextPutAll_((self):localName_(each)))\r\nend),(function()\r\nreturn ((aStream):nextPutAll_((self):argumentsSeparatorOp()))\r\nend));\r\n(self):emmitFunction_arguments_doing_(fName,(aStream):contents(),aBlock);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"emmitFunction:node:arguments:doing:",0
,function(self,fName,aNode,argumentNames,aBlock)
return ((self):emmitFunction_node_withSelf_arguments_doing_(fName,aNode,false,argumentNames,aBlock));
end
,"generation","emmitFunction: fName node: aNode arguments: argumentNames doing: aBlock\r\n\t\" Private - Generate function for aNode. \"\r\n\r\n\t^self\temmitFunction: fName node: aNode\r\n\t\twithSelf: false arguments: argumentNames\r\n\t\tdoing: aBlock","function(self,fName,aNode,argumentNames,aBlock)\r\nreturn ((self):emmitFunction_node_withSelf_arguments_doing_(fName,aNode,false,argumentNames,aBlock));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"emmitFunction:node:doing:",0
,function(self,fName,aNode,aBlock)
return ((self):emmitFunction_node_withSelf_arguments_doing_(fName,aNode,true,(aNode):argumentNames(),aBlock));
end
,"generation","emmitFunction: fName node: aNode doing: aBlock\r\n\t\" Private - Generate function for aNode. \"\r\n\r\n\t^self\temmitFunction: fName node: aNode\r\n\t\twithSelf: true arguments: aNode argumentNames\r\n\t\tdoing: aBlock","function(self,fName,aNode,aBlock)\r\nreturn ((self):emmitFunction_node_withSelf_arguments_doing_(fName,aNode,true,(aNode):argumentNames(),aBlock));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"visitMethodNode:",0
,function(self,aNode)
local fnStart=nil
local fnEnd=nil
local nativeSource=nil
if not (((smalltalk.Smalltalk):isRunningOn_((self):nativeLanguage())))==true then return ((self):emmitMethod_(aNode)); end;
(self):nextPutAll_((self):newMethodFunctionName());
(self):nextArgumentsPut_((function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_((self):currentClass()));
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((",\""),(aNode):selector())),"\","));
	return ((_s8_rec):cr())
end
)(self);(function()
	local _s8_value=((self["@stream"]):position())
	fnStart=_s8_value
	return _s8_value
end)();(self):emmitMethod_(aNode);(function()
	local _s8_value=((self["@stream"]):position())
	fnEnd=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_(((self):includeSourceCode()),(function()
(function()
	local _s8_value=(((self["@stream"]):contents()):copyFrom_to_((fnStart):_plus(1),(fnEnd):_plus(1)))
	nativeSource=_s8_value
	return _s8_value
end)();return ((
function(_s8_rec)
	(_s8_rec):cr();
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((","),(self):escaped_((aNode):source())));
	return ((_s8_rec):nextPutAll_(smalltalk:object_comma_((","),(self):escaped_(nativeSource))))
end
)(self))
end),nil))
end));
return (self);
end
,"visiting","visitMethodNode: aNode\r\n\t\" Visit a method node. \"\r\n\r\n\t| fnStart fnEnd nativeSource |\r\n\t(Smalltalk isRunningOn: self nativeLanguage) ifFalse: [ ^self emmitMethod: aNode ].\r\n\r\n\t\"return the code for method ready to be injected in the system\"\r\n\tself nextPutAll: self newMethodFunctionName.\r\n\tself nextArgumentsPut: [\r\n\t\tself\r\n\t\t\tnextPutAll: (self smalltalkNameFor: self currentClass);\r\n\t\t\tnextPutAll: ',\"', aNode selector, '\",'; cr.\r\n\t\tfnStart := stream position.\r\n\t\tself emmitMethod: aNode.\r\n\t\tfnEnd := stream position.\r\n\t\tself includeSourceCode ifTrue: [\r\n\t\t\tnativeSource := stream contents copyFrom: fnStart+1 to: fnEnd+1.\r\n\t\t\tself\tcr; \"warning: this cr is important for debugger\"\r\n\t\t\t\tnextPutAll: ',' ,(self escaped: aNode source)\r\n\t\t\t\t;nextPutAll: ',' ,(self escaped: nativeSource)\r\n\t\t]\r\n\t] ","function(self,aNode)\r\nlocal fnStart=nil\r\nlocal fnEnd=nil\r\nlocal nativeSource=nil\r\nif not (((smalltalk.Smalltalk):isRunningOn_((self):nativeLanguage())))==true then return ((self):emmitMethod_(aNode)); end;\r\n(self):nextPutAll_((self):newMethodFunctionName());\r\n(self):nextArgumentsPut_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_((self):currentClass()));\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\",\\\"\"),(aNode):selector())),\"\\\",\"));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(function()\r\n\tlocal _s8_value=((self[\"@stream\"]):position())\r\n\tfnStart=_s8_value\r\n\treturn _s8_value\r\nend)();(self):emmitMethod_(aNode);(function()\r\n\tlocal _s8_value=((self[\"@stream\"]):position())\r\n\tfnEnd=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_(((self):includeSourceCode()),(function()\r\n(function()\r\n\tlocal _s8_value=(((self[\"@stream\"]):contents()):copyFrom_to_((fnStart):_plus(1),(fnEnd):_plus(1)))\r\n\tnativeSource=_s8_value\r\n\treturn _s8_value\r\nend)();return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((\",\"),(self):escaped_((aNode):source())));\r\n\treturn ((_s8_rec):nextPutAll_(smalltalk:object_comma_((\",\"),(self):escaped_(nativeSource))))\r\nend\r\n)(self))\r\nend),nil))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"visitDirectiveNode:",0
,function(self,aNode)
if (smalltalk:responds_to_((aNode),("asNative:for:on:")))==true then (
function(_s8_rec)
	(_s8_rec):nextPutAll_((aNode):asNative_for_on_(self["@functionName"],self,self["@stream"]));
	return ((_s8_rec):cr())
end
)(self);
return (self); end;
(self):visit_(aNode);
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):separatorOp());
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"visiting","visitDirectiveNode: aNode\r\n\t\" Private - Visit a directive node. \"\r\n\r\n\t(aNode respondsTo: #asNative:for:on:) ifTrue: [\r\n\t\tself nextPutAll: (aNode\r\n\t\t\tasNative: functionName\r\n\t\t\tfor: self on: stream); cr.\r\n\t\t^self\r\n\t].\r\n\r\n\tself visit: aNode.\r\n\tself nextPutAll: self separatorOp; cr","function(self,aNode)\r\nif (smalltalk:responds_to_((aNode),(\"asNative:for:on:\")))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((aNode):asNative_for_on_(self[\"@functionName\"],self,self[\"@stream\"]));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self); end;\r\n(self):visit_(aNode);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):separatorOp());\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"emmitedCode",0
,function(self)
if (smalltalk:isNil_((self["@stream"])))==true then return (nil); end;
if ((smalltalk.Smalltalk):isRunningOn_((self):nativeLanguage()))==true then return (smalltalk:object_comma_(("return "),(self["@stream"]):contents())); end;
return ((self["@stream"]):contents());
end
,"results","emmitedCode\r\n\t\" Return the emmited code during compilation (or nil). \"\r\n\r\n\tstream isNil ifTrue: [ ^nil ].\r\n\t(Smalltalk isRunningOn: self nativeLanguage) ifTrue: [\r\n\t\t\"the code must be valid native code including return expression\"\r\n\t\t^'return ' ,stream contents\r\n\t].\r\n\t^stream contents","function(self)\r\nif (smalltalk:isNil_((self[\"@stream\"])))==true then return (nil); end;\r\nif ((smalltalk.Smalltalk):isRunningOn_((self):nativeLanguage()))==true then return (smalltalk:object_comma_((\"return \"),(self[\"@stream\"]):contents())); end;\r\nreturn ((self[\"@stream\"]):contents());\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"returnOpStart",0
,function(self)
return ("return (");
end
,"constants","returnOpStart\r\n\t\" Private - Return the OP for starting return expressions. \"\r\n\r\n\t^'return (' ","function(self)\r\nreturn (\"return (\");\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"returnOpEnd",0
,function(self)
return (")");
end
,"constants","returnOpEnd\r\n\t\" Private - Return the OP for ending return expressions. \"\r\n\r\n\t^')' ","function(self)\r\nreturn (\")\");\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"visitValueNode:",0
,function(self,aNode)
(self):nextPutAll_(((aNode):value()):asLua());
return (self);
end
,"visiting","visitValueNode: aNode\r\n\t\" Private - Visit the node emmitting output. \"\r\n\r\n\tself nextPutAll: aNode value asLua","function(self,aNode)\r\n(self):nextPutAll_(((aNode):value()):asLua());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"visitNode:index:",0
,function(self,aNode,index)
(self):nextPutAll_("[");
(self):visit_(index);
(self):nextPutAll_("]");
return (self);
end
,"visiting","visitNode: aNode index: index\r\n\t\" Private - Generate code for indexed access. \"\r\n\r\n\"ToDo:\t((index isMemberOf: ValueNode) and: [ index hasString ]) ifTrue: [\r\n\t\t| selector |\r\n\t\tselector := self asSelector: index value.\r\n\t\t((selector includes: $ ) or: [ selector includes: $_ ]) ifFalse: [\r\n\t\t\tself nextPutAll: '.'; nextPutAll: selector.\r\n\t\t\t^self\r\n\t\t].\r\n\t].\r\n\"\tself nextPutAll: '['.\r\n\tself visit: index.\r\n\tself nextPutAll: ']'.","function(self,aNode,index)\r\n(self):nextPutAll_(\"[\");\r\n(self):visit_(index);\r\n(self):nextPutAll_(\"]\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"propertyAccessConnector",0
,function(self)
return (".");
end
,"encoding","propertyAccessConnector\r\n\t\" Private - Return the connector to use for accessing a native property. \"\r\n\r\n\t^$. ","function(self)\r\nreturn (\".\");\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"messageSendConnector",0
,function(self)
return (":");
end
,"encoding","messageSendConnector\r\n\t\" Private - Return the connector to use for sending a message. \"\r\n\r\n\t^$: ","function(self)\r\nreturn (\":\");\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"functionCallConnector",0
,function(self)
return (".");
end
,"encoding","functionCallConnector\r\n\t\" Private - Return the connector to use for calling a function. \"\r\n\r\n\t^$. ","function(self)\r\nreturn (\".\");\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"messageSendConnector:",0
,function(self,aNode)
if (smalltalk:isObject_equalTo_(((((aNode):receiver()):messageSendConnector()):size()),0))==true then return (""); end;
if ((self):isNativeCall_(aNode))==true then if (((aNode):selector()):startsWith_((self):callEscape()))==true then return ((self):functionCallConnector()); end;
return ((self):messageSendConnector()); end;
return ((self):messageSendConnector());
end
,"encoding","messageSendConnector: aNode\r\n\t\" Private - Return the connector to use for sending message. \"\r\n\r\n\taNode receiver messageSendConnector size = 0 ifTrue: [ ^'' ].\r\n\t(self isNativeCall: aNode) ifTrue: [ \"calling an alien\"\r\n\t\t(aNode selector startsWith: self callEscape) ifTrue: [\r\n\t\t\t^self functionCallConnector\r\n\t\t].\r\n\t\t^self messageSendConnector\r\n\t].\r\n\t^self messageSendConnector ","function(self,aNode)\r\nif (smalltalk:isObject_equalTo_(((((aNode):receiver()):messageSendConnector()):size()),0))==true then return (\"\"); end;\r\nif ((self):isNativeCall_(aNode))==true then if (((aNode):selector()):startsWith_((self):callEscape()))==true then return ((self):functionCallConnector()); end;\r\nreturn ((self):messageSendConnector()); end;\r\nreturn ((self):messageSendConnector());\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"asPrivateSelector:",0
,function(self,aSelector)
local result=nil
(function()
	local _s8_value=((self):asSelector_(aSelector))
	result=_s8_value
	return _s8_value
end)();
if ((aSelector):startsWith_((self):callEscape()))==true then return ((result):copyFrom_to_(2,(result):size())); end;
return (result);
end
,"encoding","asPrivateSelector: aSelector\r\n\t\" Private - Validate and returns a valid native selector \"\r\n\r\n\t| result |\r\n\tresult := self asSelector: aSelector.\r\n\t(aSelector startsWith: self callEscape) ifTrue: [ \"call to an alien starting with _\"\r\n\t\t^result copyFrom: 2 to: result size\r\n\t].\r\n\t^result","function(self,aSelector)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):asSelector_(aSelector))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((aSelector):startsWith_((self):callEscape()))==true then return ((result):copyFrom_to_(2,(result):size())); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"visitPrivateMessage:",0
,function(self,aNode)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):messageSendConnector_(aNode));
	return ((_s8_rec):nextPutAll_((self):asPrivateSelector_((aNode):selector())))
end
)(self);
return (self);
end
,"visiting","visitPrivateMessage: aNode\r\n\t\" Private - Generate code for native message send.\"\r\n\r\n\tself\r\n\t\tnextPutAll: (self messageSendConnector: aNode);\r\n\t\tnextPutAll: (self asPrivateSelector: aNode selector)","function(self,aNode)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):messageSendConnector_(aNode));\r\n\treturn ((_s8_rec):nextPutAll_((self):asPrivateSelector_((aNode):selector())))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"encodeNormalSend:",0
,function(self,aNode)
(self):visitReceiver_((aNode):receiver());
(self):visitPrivateMessage_(aNode);
(self):nextArgumentsPut_((function()
return ((self):visitSendArguments_(aNode))
end));
return (self);
end
,"encoding","encodeNormalSend: aNode\r\n\t\" Private - Generate code for direct/inlined message send.\"\r\n\r\n\tself visitReceiver: aNode receiver.\r\n\tself visitPrivateMessage: aNode.\r\n\tself nextArgumentsPut: [ self visitSendArguments: aNode ] ","function(self,aNode)\r\n(self):visitReceiver_((aNode):receiver());\r\n(self):visitPrivateMessage_(aNode);\r\n(self):nextArgumentsPut_((function()\r\nreturn ((self):visitSendArguments_(aNode))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"visitReceiver:",0
,function(self,aNode)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):nextArgumentsPut_((function()
local last=nil
(function()
	local _s8_value=((self["@stream"]):position())
	last=_s8_value
	return _s8_value
end)();if ((aNode):isAssignment())==true then (self):visitLocalAssignment_(aNode); else (self):visit_(aNode); end;return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self["@stream"]):position()),last)),(function()
(self["@stream"]):removeLastInput();return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"visiting","visitReceiver: aNode\r\n\t\" Private - Visit the node (as receiver) emmitting output. \"\r\n\r\n\tself nextArgumentsPut: [ | last |\r\n\t\tlast := stream position.\r\n\t\taNode isAssignment\r\n\t\t\tifTrue: [ self visitLocalAssignment: aNode ]\r\n\t\t\tifFalse: [ self visit: aNode ].\r\n\t\tstream position = last ifTrue: [\r\n\t\t\tstream removeLastInput.\r\n\t\t\t^self\r\n\t\t]\r\n\t]","function(self,aNode)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):nextArgumentsPut_((function()\r\nlocal last=nil\r\n(function()\r\n\tlocal _s8_value=((self[\"@stream\"]):position())\r\n\tlast=_s8_value\r\n\treturn _s8_value\r\nend)();if ((aNode):isAssignment())==true then (self):visitLocalAssignment_(aNode); else (self):visit_(aNode); end;return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((self[\"@stream\"]):position()),last)),(function()\r\n(self[\"@stream\"]):removeLastInput();return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"localName:",0
,function(self,aName)
if (((self):pseudoVariables()):includes_(aName))==true then return (aName); end;
return ((self):asSelector_(aName));
end
,"private","localName: aName\r\n\t\" Private - Return a valid (native, local) name for aName. \"\r\n\r\n\t(self pseudoVariables includes: aName) ifTrue: [ ^aName ].\r\n\t^self asSelector: aName","function(self,aName)\r\nif (((self):pseudoVariables()):includes_(aName))==true then return (aName); end;\r\nreturn ((self):asSelector_(aName));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"visitGlobalReferenceNode:",0
,function(self,aNode)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local aName=nil
local aClass=nil
local lookupPools=nil
(function()
	local _s8_value=((aNode):value())
	aName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((self):currentClass()):instanceClass())
	aClass=_s8_value
	return _s8_value
end)();
(aClass):classVariableNamesDo_((function(each)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((each),aName)),(function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	(_s8_rec):nextPutAll_(":classVariableAt_(\"");
	(_s8_rec):nextPutAll_(aName);
	return ((_s8_rec):nextPutAll_("\")"))
end
)(self);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(aClass):sharedPoolsAndNamesDo_((function(poolName,pool)
return (smalltalk:if_true_false_(((pool):includesKey_(aName)),(function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("(smalltalk:poolDictionary_(\"");
	(_s8_rec):nextPutAll_(poolName);
	(_s8_rec):nextPutAll_("\")):at_(\"");
	(_s8_rec):nextPutAll_(aName);
	return ((_s8_rec):nextPutAll_("\")"))
end
)(self);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("smalltalk.");
	return ((_s8_rec):nextPutAll_((aNode):value()))
end
)(self);
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"visiting","visitGlobalReferenceNode: aNode\r\n\r\n\t| aName aClass lookupPools |\r\n\taName := aNode value.\r\n\taClass := self currentClass instanceClass.\r\n\taClass classVariableNamesDo: [:each|\r\n\t\teach = aName ifTrue: [\r\n\t\t\tself\r\n\t\t\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\t\t\tnextPutAll: ':classVariableAt_(\"';\r\n\t\t\t\tnextPutAll: aName;\r\n\t\t\t\tnextPutAll: '\")'.\r\n\t\t\t^self\r\n\t\t]\r\n\t].\r\n\taClass sharedPoolsAndNamesDo: [:poolName :pool|\r\n\t\t(pool includesKey: aName) ifTrue: [\r\n\t\t\tself\r\n\t\t\t\tnextPutAll: '(smalltalk:poolDictionary_(\"';\r\n\t\t\t\tnextPutAll: poolName;\r\n\t\t\t\tnextPutAll: '\")):at_(\"';\r\n\t\t\t\tnextPutAll: aName;\r\n\t\t\t\tnextPutAll: '\")'.\r\n\t\t\t^self\r\n\t\t].\r\n\t].\r\n\tself\r\n\t\tnextPutAll: 'smalltalk.';\r\n\t\tnextPutAll: aNode value.","function(self,aNode)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal aName=nil\r\nlocal aClass=nil\r\nlocal lookupPools=nil\r\n(function()\r\n\tlocal _s8_value=((aNode):value())\r\n\taName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((self):currentClass()):instanceClass())\r\n\taClass=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(aClass):classVariableNamesDo_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((each),aName)),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\t(_s8_rec):nextPutAll_(\":classVariableAt_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(aName);\r\n\treturn ((_s8_rec):nextPutAll_(\"\\\")\"))\r\nend\r\n)(self);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(aClass):sharedPoolsAndNamesDo_((function(poolName,pool)\r\nreturn (smalltalk:if_true_false_(((pool):includesKey_(aName)),(function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"(smalltalk:poolDictionary_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(poolName);\r\n\t(_s8_rec):nextPutAll_(\"\\\")):at_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(aName);\r\n\treturn ((_s8_rec):nextPutAll_(\"\\\")\"))\r\nend\r\n)(self);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"smalltalk.\");\r\n\treturn ((_s8_rec):nextPutAll_((aNode):value()))\r\nend\r\n)(self);\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"visitBlockNode:",0
,function(self,aNode)
(self):nextArgumentsPut_((function()
return ((self):emmitFunction_node_arguments_doing_("",aNode,(aNode):parameterNames(),(function()
return (((aNode):nodes()):do_((function(each)
return ((self):visit_(each))
end)))
end)))
end));
return (self);
end
,"visiting","visitBlockNode: aNode\r\n\r\n\tself nextArgumentsPut: [\r\n\t\tself\temmitFunction: '' node: aNode\r\n\t\t\targuments: aNode parameterNames\r\n\t\t\tdoing: [ aNode nodes do: [:each | self visit: each ] ]\r\n\t] ","function(self,aNode)\r\n(self):nextArgumentsPut_((function()\r\nreturn ((self):emmitFunction_node_arguments_doing_(\"\",aNode,(aNode):parameterNames(),(function()\r\nreturn (((aNode):nodes()):do_((function(each)\r\nreturn ((self):visit_(each))\r\nend)))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"defineTemporary:",0
,function(self,aName)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_(("local "),(self):localName_(aName))),"=nil"));
	return ((_s8_rec):cr())
end
)(self);
return (self);
end
,"encoding","defineTemporary: aName\r\n\t\" Private - Return the code for defining temporary variable with aName. \"\r\n\r\n\tself nextPutAll: 'local ', (self localName: aName), '=nil' ;cr ","function(self,aName)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((\"local \"),(self):localName_(aName))),\"=nil\"));\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"visitCascadeNode:",0
,function(self,aNode)
local target=nil
(function()
	local _s8_value=("_s8_rec")
	target=_s8_value
	return _s8_value
end)();
if not ((((self):tempVariables()):includes_(target)))==true then ((self):tempVariables()):add_(target); end;
(self):compilerEvent_with_("aboutCascade:",aNode);
(
function(_s8_rec)
	(_s8_rec):nextArgumentsPut_((function()
(self):cr();(self):emmitFunction_arguments_doing_("",target,(function()
local index=nil
local rec=nil
(function()
	local _s8_value=(0)
	index=_s8_value
	return _s8_value
end)();(self):tab();return (((aNode):nodes()):do_((function(each)
(function()
	local _s8_value=((index):_plus(1))
	index=_s8_value
	return _s8_value
end)();if (smalltalk:isObject_equalTo_((index),((aNode):nodes()):size()))==true then (self):nextPutAll_((self):returnOpStart()); end;(function()
	local _s8_value=((smalltalk.VariableNode):new())
	rec=_s8_value
	return _s8_value
end)();(
function(_s8_rec)
	(_s8_rec):value_(target);
	return ((_s8_rec):start_end_((each):start(),(each):start()))
end
)(rec);(each):receiver_(rec);(self):visit_(each);return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((index),((aNode):nodes()):size())),(function()
(self):compilerEvent_withArguments_("returned:early:",(smalltalk.Array):with_with_(nil,false));return ((self):nextPutAll_((self):returnOpEnd()))
end),(function()
return ((
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):separatorOp());
	(_s8_rec):cr();
	return ((_s8_rec):tab())
end
)(self))
end)))
end)))
end));return ((self):cr())
end));
	return ((_s8_rec):nextArgumentsPut_((function()
return ((self):visit_((aNode):receiver()))
end)))
end
)(self);
(self):compilerEvent_with_("cascade:",aNode);
return (self);
end
,"visiting","visitCascadeNode: aNode\r\n\r\n\t| target |\r\n\ttarget := #_s8_rec.\r\n\t(self tempVariables includes: target) ifFalse: [ self tempVariables add: target ].\r\n\tself compilerEvent: #aboutCascade: with: aNode.\r\n\tself nextArgumentsPut: [\r\n\t\tself cr.\r\n\t\tself emmitFunction: '' arguments: target doing: [ | index rec |\r\n\t\t\tindex := 0. self tab.\r\n\t\t\taNode nodes do: [:each |\r\n\t\t\t    index := index + 1.\r\n\t\t\t    index = aNode nodes size ifTrue: [ self nextPutAll: self returnOpStart ].\r\n\t\t\t    rec := VariableNode new.\r\n\t\t\t    rec value: target; start: each start end: each start.\r\n\t\t\t    each receiver: rec.\r\n\t\t\t    self visit: each.\r\n\t\t\t    index = aNode nodes size ifTrue: [\r\n\t\t\t\t\tself\tcompilerEvent: #returned:early:\r\n\t\t\t\t\t\twithArguments: (Array with: nil with: false).\r\n\t\t\t\t\tself nextPutAll: self returnOpEnd\r\n\t\t\t    \t] ifFalse: [ self nextPutAll: self separatorOp; cr;tab ]\r\n\t\t\t]\r\n\t\t].\r\n\t\tself cr\r\n\t]; nextArgumentsPut: [ self visit: aNode receiver ].\r\n\tself compilerEvent: #cascade: with: aNode.","function(self,aNode)\r\nlocal target=nil\r\n(function()\r\n\tlocal _s8_value=(\"_s8_rec\")\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((((self):tempVariables()):includes_(target)))==true then ((self):tempVariables()):add_(target); end;\r\n(self):compilerEvent_with_(\"aboutCascade:\",aNode);\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextArgumentsPut_((function()\r\n(self):cr();(self):emmitFunction_arguments_doing_(\"\",target,(function()\r\nlocal index=nil\r\nlocal rec=nil\r\n(function()\r\n\tlocal _s8_value=(0)\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();(self):tab();return (((aNode):nodes()):do_((function(each)\r\n(function()\r\n\tlocal _s8_value=((index):_plus(1))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();if (smalltalk:isObject_equalTo_((index),((aNode):nodes()):size()))==true then (self):nextPutAll_((self):returnOpStart()); end;(function()\r\n\tlocal _s8_value=((smalltalk.VariableNode):new())\r\n\trec=_s8_value\r\n\treturn _s8_value\r\nend)();(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):value_(target);\r\n\treturn ((_s8_rec):start_end_((each):start(),(each):start()))\r\nend\r\n)(rec);(each):receiver_(rec);(self):visit_(each);return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((index),((aNode):nodes()):size())),(function()\r\n(self):compilerEvent_withArguments_(\"returned:early:\",(smalltalk.Array):with_with_(nil,false));return ((self):nextPutAll_((self):returnOpEnd()))\r\nend),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):separatorOp());\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):tab())\r\nend\r\n)(self))\r\nend)))\r\nend)))\r\nend));return ((self):cr())\r\nend));\r\n\treturn ((_s8_rec):nextArgumentsPut_((function()\r\nreturn ((self):visit_((aNode):receiver()))\r\nend)))\r\nend\r\n)(self);\r\n(self):compilerEvent_with_(\"cascade:\",aNode);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"emmitAssignment:",0
,function(self,aNode)
(
function(_s8_rec)
	(_s8_rec):nextArgumentsPut_((function()
local tab=nil
(function()
	local _s8_value=((smalltalk.String):tab())
	tab=_s8_value
	return _s8_value
end)();(
function(_s8_rec)
	(_s8_rec):nextPutAll_("function()");
	return ((_s8_rec):cr())
end
)(self);(
function(_s8_rec)
	(_s8_rec):tab();
	return ((_s8_rec):nextPutAll_("local _s8_value="))
end
)(self);(self):nextArgumentsPut_((function()
return ((self):visit_((aNode):right()))
end));(
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):tab())
end
)(self);(self):visit_((aNode):left());(
function(_s8_rec)
	(_s8_rec):nextPutAll_("=_s8_value");
	(_s8_rec):cr();
	(_s8_rec):tab();
	(_s8_rec):nextPutAll_("return _s8_value");
	return ((_s8_rec):cr())
end
)(self);return ((self):nextPutAll_("end"))
end));
	return ((_s8_rec):nextArgumentsPut_((function()
return (nil)
end)))
end
)(self);
return (self);
end
,"generation","emmitAssignment: aNode\r\n\t\" Private - Emmit the code for assignment. \"\r\n\r\n\tself nextArgumentsPut: [ | tab |\r\n\t\ttab := String tab.\r\n\t\tself nextPutAll: 'function()'; cr.\r\n\t\tself tab;nextPutAll: 'local _s8_value='.\r\n\t\tself nextArgumentsPut: [ self visit: aNode right ].\r\n\t\tself cr; tab.\r\n\t\tself visit: aNode left.\r\n\t\tself\tnextPutAll: '=_s8_value' \"; '\";\r\n\t\t\t cr; tab;\r\n\t\t\tnextPutAll: 'return _s8_value'; cr.\r\n\t\tself nextPutAll: #end\r\n\t]; nextArgumentsPut: [] ","function(self,aNode)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextArgumentsPut_((function()\r\nlocal tab=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.String):tab())\r\n\ttab=_s8_value\r\n\treturn _s8_value\r\nend)();(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"function()\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):tab();\r\n\treturn ((_s8_rec):nextPutAll_(\"local _s8_value=\"))\r\nend\r\n)(self);(self):nextArgumentsPut_((function()\r\nreturn ((self):visit_((aNode):right()))\r\nend));(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):tab())\r\nend\r\n)(self);(self):visit_((aNode):left());(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"=_s8_value\");\r\n\t(_s8_rec):cr();\r\n\t(_s8_rec):tab();\r\n\t(_s8_rec):nextPutAll_(\"return _s8_value\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);return ((self):nextPutAll_(\"end\"))\r\nend));\r\n\treturn ((_s8_rec):nextArgumentsPut_((function()\r\nreturn (nil)\r\nend)))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"visitClassVariableAssignment:in:to:",0
,function(self,aClassVariableName,aClass,anExpressionNode)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));
	(_s8_rec):nextPutAll_(":classVariableAt_put_(\"");
	(_s8_rec):nextPutAll_(aClassVariableName);
	return ((_s8_rec):nextPutAll_("\","))
end
)(self);
(self):visit_(anExpressionNode);
(self):nextPutAll_(")");
return (self);
end
,"visiting","visitClassVariableAssignment: aClassVariableName in: aClass to: anExpressionNode\r\n\r\n\tself\r\n\t\tnextPutAll: (self smalltalkNameFor: aClass);\r\n\t\tnextPutAll: ':classVariableAt_put_(\"';\r\n\t\tnextPutAll: aClassVariableName; nextPutAll: '\",'.\r\n\tself visit: anExpressionNode.\r\n\tself\tnextPutAll: ')'","function(self,aClassVariableName,aClass,anExpressionNode)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_((self):smalltalkNameFor_(aClass));\r\n\t(_s8_rec):nextPutAll_(\":classVariableAt_put_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(aClassVariableName);\r\n\treturn ((_s8_rec):nextPutAll_(\"\\\",\"))\r\nend\r\n)(self);\r\n(self):visit_(anExpressionNode);\r\n(self):nextPutAll_(\")\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"visitPoolVariableAssignment:in:to:",0
,function(self,aName,poolName,anExpressionNode)
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("smalltalk:poolDictionary_(\"");
	(_s8_rec):nextPutAll_(poolName);
	(_s8_rec):nextPutAll_("\"):at_put_(\"");
	(_s8_rec):nextPutAll_(aName);
	return ((_s8_rec):nextPutAll_("\","))
end
)(self);
(self):visit_(anExpressionNode);
(self):nextPutAll_(")");
return (self);
end
,"visiting","visitPoolVariableAssignment: aName in: poolName to: anExpressionNode\r\n\r\n\tself\r\n\t\tnextPutAll: 'smalltalk:poolDictionary_(\"';\r\n\t\tnextPutAll: poolName; nextPutAll: '\"):at_put_(\"';\r\n\t\tnextPutAll: aName; nextPutAll: '\",'.\r\n\tself visit: anExpressionNode.\r\n\tself\tnextPutAll: ')'","function(self,aName,poolName,anExpressionNode)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"smalltalk:poolDictionary_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(poolName);\r\n\t(_s8_rec):nextPutAll_(\"\\\"):at_put_(\\\"\");\r\n\t(_s8_rec):nextPutAll_(aName);\r\n\treturn ((_s8_rec):nextPutAll_(\"\\\",\"))\r\nend\r\n)(self);\r\n(self):visit_(anExpressionNode);\r\n(self):nextPutAll_(\")\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"visitOperation:",0
,function(self,aNode)
(self):compilerEvent_with_("aboutOperation:",aNode);
(self):nextArgumentsPut_((function()
return ((self):visitReceiver_((aNode):receiver()))
end));
(self):nextPutAll_((self):asPrivateSelector_((aNode):selector()));
(self):visitSendArguments_(aNode);
(self):compilerEvent_with_("operation:",aNode);
return (self);
end
,"visiting","visitOperation: aNode\r\n\t\" Private - aNode is an operation and selector is mapped to target operation. \"\r\n\r\n\tself compilerEvent: #aboutOperation: with: aNode.\r\n\tself nextArgumentsPut: [ self visitReceiver: aNode receiver ].\r\n\tself nextPutAll: (self asPrivateSelector: aNode selector).\r\n\tself visitSendArguments: aNode.\r\n\tself compilerEvent: #operation: with: aNode.","function(self,aNode)\r\n(self):compilerEvent_with_(\"aboutOperation:\",aNode);\r\n(self):nextArgumentsPut_((function()\r\nreturn ((self):visitReceiver_((aNode):receiver()))\r\nend));\r\n(self):nextPutAll_((self):asPrivateSelector_((aNode):selector()));\r\n(self):visitSendArguments_(aNode);\r\n(self):compilerEvent_with_(\"operation:\",aNode);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"encodeSuperSend:",0
,function(self,aNode)
(self):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk:superImplementor("),(self):smalltalkNameFor_((self):currentClass()))),",\"")),(self):asPrivateSelector_((aNode):selector()))),"\")(self"));
if (((aNode):arguments()):notEmpty())==true then (self):nextPutAll_((self):argumentsSeparatorOp());
(self):visitSendArguments_(aNode); end;
(self):nextPutAll_(")");
return (self);
end
,"encoding","encodeSuperSend: aNode\r\n\t\" Private - Generate code for super message send.\"\r\n\r\n\tself\r\n\t\tnextPutAll: 'smalltalk:superImplementor('\r\n\t\t\t,(self smalltalkNameFor: self currentClass)\r\n\t\t\t,',\"',(self asPrivateSelector: aNode selector)\r\n\t\t\t,'\")(self'.\r\n\taNode arguments notEmpty ifTrue: [\r\n\t\tself nextPutAll: self argumentsSeparatorOp.\r\n\t\tself visitSendArguments: aNode\r\n\t].\r\n\tself nextPutAll: ')'. ","function(self,aNode)\r\n(self):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk:superImplementor(\"),(self):smalltalkNameFor_((self):currentClass()))),\",\\\"\")),(self):asPrivateSelector_((aNode):selector()))),\"\\\")(self\"));\r\nif (((aNode):arguments()):notEmpty())==true then (self):nextPutAll_((self):argumentsSeparatorOp());\r\n(self):visitSendArguments_(aNode); end;\r\n(self):nextPutAll_(\")\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"visitReturnNode:",0
,function(self,aNode)
local theReturn=nil
if (((self["@nestedBlocks"]) > 0))==true then (function()
	local _s8_value=(true)
	self["@earlyReturn"]=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=((function()
return ((self):emmitReturn_((function()
return (((aNode):nodes()):do_((function(each)
return ((self):visit_(each))
end)))
end)))
end))
	theReturn=_s8_value
	return _s8_value
end)();
if not ((self["@earlyReturn"]))==true then return ((theReturn):value()); end;
(
function(_s8_rec)
	(_s8_rec):nextArgumentsPut_((function()
return ((self):emmitFunctionDoing_((function()
(
function(_s8_rec)
	(_s8_rec):nextPutAll_("_s8Ret_.hasResult=true");
	return ((_s8_rec):cr())
end
)(self);(self):nextPutAll_("_s8Ret_.result=");(
function(_s8_rec)
	(_s8_rec):nextArgumentsPut_((function()
return ((
function(_s8_rec)
	(_s8_rec):emmitFunctionDoing_(theReturn);
	return ((_s8_rec):cr())
end
)(self))
end));
	return ((_s8_rec):nextArgumentsPut_((function()
return (nil)
end)))
end
)(self);return ((
function(_s8_rec)
	(_s8_rec):cr();
	return ((_s8_rec):nextPutAll_("error(_s8Ret_,0)"))
end
)(self))
end)))
end));
	return ((_s8_rec):nextArgumentsPut_((function()
return (nil)
end)))
end
)(self);
return (self);
end
,"visiting","visitReturnNode: aNode\r\n\r\n\t| theReturn |\r\n\tnestedBlocks > 0 ifTrue: [ earlyReturn := true ].\r\n\ttheReturn := [ self emmitReturn: [\r\n\t\taNode nodes do: [:each | self visit: each ]\r\n\t] ].\r\n\tearlyReturn ifFalse: [ ^theReturn value ].\r\n\r\n\tself nextArgumentsPut: [\r\n\t\tself emmitFunctionDoing: [\r\n\t\t\tself nextPutAll: '_s8Ret_.hasResult=true';cr.\r\n\t\t\tself nextPutAll: '_s8Ret_.result='.\r\n\t\t\tself nextArgumentsPut: [\r\n\t\t\t\tself emmitFunctionDoing: theReturn; cr\r\n\t\t\t]; nextArgumentsPut: [].\r\n\t\t\tself cr;nextPutAll: 'error(_s8Ret_,0)'\r\n\t\t]\r\n\t]; nextArgumentsPut: [] ","function(self,aNode)\r\nlocal theReturn=nil\r\nif (((self[\"@nestedBlocks\"]) > 0))==true then (function()\r\n\tlocal _s8_value=(true)\r\n\tself[\"@earlyReturn\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((function()\r\nreturn ((self):emmitReturn_((function()\r\nreturn (((aNode):nodes()):do_((function(each)\r\nreturn ((self):visit_(each))\r\nend)))\r\nend)))\r\nend))\r\n\ttheReturn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not ((self[\"@earlyReturn\"]))==true then return ((theReturn):value()); end;\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextArgumentsPut_((function()\r\nreturn ((self):emmitFunctionDoing_((function()\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(\"_s8Ret_.hasResult=true\");\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self);(self):nextPutAll_(\"_s8Ret_.result=\");(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextArgumentsPut_((function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):emmitFunctionDoing_(theReturn);\r\n\treturn ((_s8_rec):cr())\r\nend\r\n)(self))\r\nend));\r\n\treturn ((_s8_rec):nextArgumentsPut_((function()\r\nreturn (nil)\r\nend)))\r\nend\r\n)(self);return ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cr();\r\n\treturn ((_s8_rec):nextPutAll_(\"error(_s8Ret_,0)\"))\r\nend\r\n)(self))\r\nend)))\r\nend));\r\n\treturn ((_s8_rec):nextArgumentsPut_((function()\r\nreturn (nil)\r\nend)))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"generate:early:return:",0
,function(self,fName,early,code)
local prev=nil
if not ((early))==true then (self):nextPutAll_(code);
return (0); end;
(function()
	local _s8_value=("\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n")
	prev=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):nextPutAll_(prev);
	(_s8_rec):nextPutAll_(code);
	return ((_s8_rec):nextPutAll_("\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      "))
end
)(self);
(self):emmitReturn_early_("_s8Ret_.result",true);
(self):nextPutAll_("\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n");
return ((prev):size());
end
,"generation","generate: fName early: early return: code\r\n\t\" Private - Generate code to catch early return of code expression in fName. \"\r\n\r\n\t| prev |\r\n\tearly ifFalse: [ self nextPutAll: code. ^0 ].\r\n\tprev := '\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n'.\r\n\tself\tnextPutAll: prev;\r\n\t\tnextPutAll: code;\r\n\t\tnextPutAll: '\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      '.\tself emmitReturn: '_s8Ret_.result' early: true.\r\n\tself nextPutAll: '\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n'.\r\n\t^prev size","function(self,fName,early,code)\r\nlocal prev=nil\r\nif not ((early))==true then (self):nextPutAll_(code);\r\nreturn (0); end;\r\n(function()\r\n\tlocal _s8_value=(\"\\r\\nlocal _s8Ret_={[\\\"name\\\"]=\\\"stReturn\\\"}\\r\\nlocal _s8_f = function()\\r\\n\")\r\n\tprev=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPutAll_(prev);\r\n\t(_s8_rec):nextPutAll_(code);\r\n\treturn ((_s8_rec):nextPutAll_(\"\\r\\nend\\r\\nlocal _s8_status, _s8_result = pcall(_s8_f)\\r\\nif _s8_status then return _s8_result\\r\\nelse\\r\\n    if (_s8Ret_.hasResult) then\\r\\n      \"))\r\nend\r\n)(self);\r\n(self):emmitReturn_early_(\"_s8Ret_.result\",true);\r\n(self):nextPutAll_(\"\\r\\n    end\\r\\nend\\r\\nerror(_s8_result,0)\\r\\n\");\r\nreturn ((prev):size());\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"coreOptimizations",0
,function(self)
return (smalltalk:newArray({"core", smalltalk:newArray({smalltalk:newArray({"class", "%receiver%[\"$klass\"]"}), smalltalk:newArray({"isNil", "%:isNil_%(%receiver%)"}), smalltalk:newArray({"notNil", "%:notNil_%(%receiver%)"}), smalltalk:newArray({"=", "%:isObject_equalTo_%(%receiver%,%arg1%)"}), smalltalk:newArray({"~=", "(not %:isObject_equalTo_%(%receiver%,%arg1%))"}), smalltalk:newArray({"==", "(%receiver%==%arg1%)"}), smalltalk:newArray({"~~", "(%receiver%~=%arg1%)"}), smalltalk:newArray({"===", "(%receiver% == %arg1%)"}), smalltalk:newArray({"||", "(%receiver% or %arg1%)"}), smalltalk:newArray({",", "%:object_comma_%(%receiver%,%arg1%)"}), smalltalk:newArray({"basicAt:", "%receiver%[%arg1%]"}), smalltalk:newArray({"basicAt:ifAbsent:", "%:basic_at_ifAbsent_%(%receiver%,%arg1%,%arg2%)"}), smalltalk:newArray({"basicAt:put:", "%:basic_at_put_%(%receiver%,%arg1%,%arg2%)"}), smalltalk:newArray({"ifUndefined:", "%:ifUndefined_do_%(%receiver%,%arg1%)"})})}));
end
,"optimization","coreOptimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(core  #(\r\n\t\t#(class\t'%receiver%[\"$klass\"]' )\r\n\t\t#(isNil\t'%:isNil_%(%receiver%)' )\r\n\t\t#(notNil\t'%:notNil_%(%receiver%)' )\r\n\t\t#(=\t'%:isObject_equalTo_%(%receiver%,%arg1%)' )\r\n\t\t#(~=\t'(not %:isObject_equalTo_%(%receiver%,%arg1%))' )\r\n\t\t#(==\t'(%receiver%==%arg1%)' )\r\n\t\t#(~~\t'(%receiver%~=%arg1%)' )\r\n\t\t#(===\t'(%receiver% == %arg1%)' )\r\n\t\t#(||\t'(%receiver% or %arg1%)' )\r\n\t\t#(,\t'%:object_comma_%(%receiver%,%arg1%)' )\r\n\t\t#(basicAt:\t'%receiver%[%arg1%]' )\r\n\t\t#(basicAt:ifAbsent: '%:basic_at_ifAbsent_%(%receiver%,%arg1%,%arg2%)' )\r\n\t\t#(basicAt:put:\t'%:basic_at_put_%(%receiver%,%arg1%,%arg2%)' )\r\n\t\t#(ifUndefined:\t'%:ifUndefined_do_%(%receiver%,%arg1%)' )\r\n\t))","function(self)\r\nreturn (smalltalk:newArray({\"core\", smalltalk:newArray({smalltalk:newArray({\"class\", \"%receiver%[\\\"$klass\\\"]\"}), smalltalk:newArray({\"isNil\", \"%:isNil_%(%receiver%)\"}), smalltalk:newArray({\"notNil\", \"%:notNil_%(%receiver%)\"}), smalltalk:newArray({\"=\", \"%:isObject_equalTo_%(%receiver%,%arg1%)\"}), smalltalk:newArray({\"~=\", \"(not %:isObject_equalTo_%(%receiver%,%arg1%))\"}), smalltalk:newArray({\"==\", \"(%receiver%==%arg1%)\"}), smalltalk:newArray({\"~~\", \"(%receiver%~=%arg1%)\"}), smalltalk:newArray({\"===\", \"(%receiver% == %arg1%)\"}), smalltalk:newArray({\"||\", \"(%receiver% or %arg1%)\"}), smalltalk:newArray({\",\", \"%:object_comma_%(%receiver%,%arg1%)\"}), smalltalk:newArray({\"basicAt:\", \"%receiver%[%arg1%]\"}), smalltalk:newArray({\"basicAt:ifAbsent:\", \"%:basic_at_ifAbsent_%(%receiver%,%arg1%,%arg2%)\"}), smalltalk:newArray({\"basicAt:put:\", \"%:basic_at_put_%(%receiver%,%arg1%,%arg2%)\"}), smalltalk:newArray({\"ifUndefined:\", \"%:ifUndefined_do_%(%receiver%,%arg1%)\"})})}));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"s8Optimizations",0
,function(self)
return (smalltalk:newArray({"s8", smalltalk:newArray({"core", smalltalk:newArray({"ifTrue:", "hasBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"ifTrue:", "noClient:", "if %receiver%==true then %seq1% end"}), smalltalk:newArray({"ifTrue:", "%:if_true_false_%(%receiver%,%arg1%,nil)"})})}), smalltalk:newArray({"ifFalse:", "hasBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"ifFalse:", "noClient:", "if not (%receiver%)==true then %seq1% end"}), smalltalk:newArray({"ifFalse:", "%:if_true_false_%(%receiver%,nil,%arg1%)"})})}), smalltalk:newArray({"ifTrue:ifFalse:", "hasBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"ifTrue:ifFalse:", "noClient:", "if %receiver%==true then %seq1% else %seq2% end"}), smalltalk:newArray({"ifTrue:ifFalse:", "%:if_true_false_%(%receiver%,%arg1%,%arg2%)"})})}), smalltalk:newArray({"ifFalse:ifTrue:", "hasBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"ifFalse:ifTrue:", "noClient:", "if %receiver%==true then %seq2% else %seq1% end"}), smalltalk:newArray({"ifFalse:ifTrue:", "%:if_true_false_%(%receiver%,%arg2%,%arg1%)"})})}), smalltalk:newArray({"whileTrue", "receiverIsBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"whileTrue", "noClient:", "while %receiver%() do end"}), smalltalk:newArray({"whileTrue", "%:while_do_%(%receiver%,nil)"})})}), smalltalk:newArray({"whileFalse", "receiverIsBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"whileFalse", "noClient:", "while not %receiver%() do end"}), smalltalk:newArray({"whileFalse", "%:whileNot_do_%(%receiver%,nil)"})})}), smalltalk:newArray({"whileTrue:", "receiverIsBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"whileTrue:", "noClient:", "while %receiver%() do %seq1% end"}), smalltalk:newArray({"whileTrue:", "%:while_do_%(%receiver%,%arg1%)"})})}), smalltalk:newArray({"whileFalse:", "receiverIsBlockNoArguments:", smalltalk:newArray({smalltalk:newArray({"whileFalse:", "noClient:", "while not %receiver%() do %seq1% end"}), smalltalk:newArray({"whileFalse:", "%:whileNot_do_%(%receiver%,%arg1%)"})})}), smalltalk:newArray({"orNil", "%:orNil_%(%receiver%)"}), smalltalk:newArray({"timesRepeat:", "%:times_repeat_%(%receiver%,%arg1%)"}), smalltalk:newArray({"isKindOf:", "%:is_kindOf_%(%receiver%,(%arg1%))"}), smalltalk:newArray({"respondsTo:", "%:responds_to_%(%receiver%,(%arg1%))"}), smalltalk:newArray({"ifNil:", "%:if_nil_notNil_%(%receiver%,%arg1%,nil)"}), smalltalk:newArray({"ifNotNil:", "%:if_nil_notNil_%(%receiver%,nil,%arg1%)"}), smalltalk:newArray({"ifNil:ifNotNil:", "%:if_nil_notNil_%(%receiver%,%arg1%,%arg2%)"}), smalltalk:newArray({"ifNotNil:ifNil:", "%:if_nil_notNil_%(%receiver%,%arg2%,%arg1%)"})})}));
end
,"optimization","s8Optimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(s8\t#(\r\n\t\tcore\r\n\t\t#(ifTrue: hasBlockNoArguments: #(\r\n\t\t\t#(ifTrue: noClient: 'if %receiver%==true then %seq1% end' )\r\n\t\t\t#(ifTrue: '%:if_true_false_%(%receiver%,%arg1%,nil)' )\r\n\t\t))\r\n\t\t#(ifFalse: hasBlockNoArguments: #(\r\n\t\t\t#(ifFalse: noClient: 'if not (%receiver%)==true then %seq1% end' )\r\n\t\t\t#(ifFalse: '%:if_true_false_%(%receiver%,nil,%arg1%)' )\r\n\t\t))\r\n\t\t#(ifTrue:ifFalse: hasBlockNoArguments: #(\r\n\t\t\t#(ifTrue:ifFalse: noClient: 'if %receiver%==true then %seq1% else %seq2% end' )\r\n\t\t\t#(ifTrue:ifFalse: '%:if_true_false_%(%receiver%,%arg1%,%arg2%)' )\r\n\t\t))\r\n\t\t#(ifFalse:ifTrue: hasBlockNoArguments: #(\r\n\t\t\t#(ifFalse:ifTrue: noClient: 'if %receiver%==true then %seq2% else %seq1% end' )\r\n\t\t\t#(ifFalse:ifTrue: '%:if_true_false_%(%receiver%,%arg2%,%arg1%)' )\r\n\t\t))\r\n\t\t#(whileTrue receiverIsBlockNoArguments: #(\r\n\t\t\t#(whileTrue noClient: 'while %receiver%() do end' )\r\n\t\t\t#(whileTrue '%:while_do_%(%receiver%,nil)' )\r\n\t\t))\r\n\t\t#(whileFalse receiverIsBlockNoArguments: #(\r\n\t\t\t#(whileFalse noClient: 'while not %receiver%() do end' )\r\n\t\t\t#(whileFalse '%:whileNot_do_%(%receiver%,nil)' )\r\n\t\t))\r\n\t\t#(whileTrue: receiverIsBlockNoArguments: #(\r\n\t\t\t#(whileTrue: noClient: 'while %receiver%() do %seq1% end' )\r\n\t\t\t#(whileTrue: '%:while_do_%(%receiver%,%arg1%)' )\r\n\t\t))\r\n\t\t#(whileFalse: receiverIsBlockNoArguments: #(\r\n\t\t\t#(whileFalse: noClient: 'while not %receiver%() do %seq1% end' )\r\n\t\t\t#(whileFalse: '%:whileNot_do_%(%receiver%,%arg1%)' )\r\n\t\t))\r\n\t\t#(orNil '%:orNil_%(%receiver%)' )\r\n\t\t#(timesRepeat: '%:times_repeat_%(%receiver%,%arg1%)' )\r\n\t\t#(isKindOf: '%:is_kindOf_%(%receiver%,(%arg1%))' )\r\n\t\t#(respondsTo: '%:responds_to_%(%receiver%,(%arg1%))' )\r\n\t\t#(ifNil: '%:if_nil_notNil_%(%receiver%,%arg1%,nil)' )\r\n\t\t#(ifNotNil: '%:if_nil_notNil_%(%receiver%,nil,%arg1%)' )\r\n\t\t#(ifNil:ifNotNil: '%:if_nil_notNil_%(%receiver%,%arg1%,%arg2%)' )\r\n\t\t#(ifNotNil:ifNil: '%:if_nil_notNil_%(%receiver%,%arg2%,%arg1%)' )\r\n\t))","function(self)\r\nreturn (smalltalk:newArray({\"s8\", smalltalk:newArray({\"core\", smalltalk:newArray({\"ifTrue:\", \"hasBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"ifTrue:\", \"noClient:\", \"if %receiver%==true then %seq1% end\"}), smalltalk:newArray({\"ifTrue:\", \"%:if_true_false_%(%receiver%,%arg1%,nil)\"})})}), smalltalk:newArray({\"ifFalse:\", \"hasBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"ifFalse:\", \"noClient:\", \"if not (%receiver%)==true then %seq1% end\"}), smalltalk:newArray({\"ifFalse:\", \"%:if_true_false_%(%receiver%,nil,%arg1%)\"})})}), smalltalk:newArray({\"ifTrue:ifFalse:\", \"hasBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"ifTrue:ifFalse:\", \"noClient:\", \"if %receiver%==true then %seq1% else %seq2% end\"}), smalltalk:newArray({\"ifTrue:ifFalse:\", \"%:if_true_false_%(%receiver%,%arg1%,%arg2%)\"})})}), smalltalk:newArray({\"ifFalse:ifTrue:\", \"hasBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"ifFalse:ifTrue:\", \"noClient:\", \"if %receiver%==true then %seq2% else %seq1% end\"}), smalltalk:newArray({\"ifFalse:ifTrue:\", \"%:if_true_false_%(%receiver%,%arg2%,%arg1%)\"})})}), smalltalk:newArray({\"whileTrue\", \"receiverIsBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"whileTrue\", \"noClient:\", \"while %receiver%() do end\"}), smalltalk:newArray({\"whileTrue\", \"%:while_do_%(%receiver%,nil)\"})})}), smalltalk:newArray({\"whileFalse\", \"receiverIsBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"whileFalse\", \"noClient:\", \"while not %receiver%() do end\"}), smalltalk:newArray({\"whileFalse\", \"%:whileNot_do_%(%receiver%,nil)\"})})}), smalltalk:newArray({\"whileTrue:\", \"receiverIsBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"whileTrue:\", \"noClient:\", \"while %receiver%() do %seq1% end\"}), smalltalk:newArray({\"whileTrue:\", \"%:while_do_%(%receiver%,%arg1%)\"})})}), smalltalk:newArray({\"whileFalse:\", \"receiverIsBlockNoArguments:\", smalltalk:newArray({smalltalk:newArray({\"whileFalse:\", \"noClient:\", \"while not %receiver%() do %seq1% end\"}), smalltalk:newArray({\"whileFalse:\", \"%:whileNot_do_%(%receiver%,%arg1%)\"})})}), smalltalk:newArray({\"orNil\", \"%:orNil_%(%receiver%)\"}), smalltalk:newArray({\"timesRepeat:\", \"%:times_repeat_%(%receiver%,%arg1%)\"}), smalltalk:newArray({\"isKindOf:\", \"%:is_kindOf_%(%receiver%,(%arg1%))\"}), smalltalk:newArray({\"respondsTo:\", \"%:responds_to_%(%receiver%,(%arg1%))\"}), smalltalk:newArray({\"ifNil:\", \"%:if_nil_notNil_%(%receiver%,%arg1%,nil)\"}), smalltalk:newArray({\"ifNotNil:\", \"%:if_nil_notNil_%(%receiver%,nil,%arg1%)\"}), smalltalk:newArray({\"ifNil:ifNotNil:\", \"%:if_nil_notNil_%(%receiver%,%arg1%,%arg2%)\"}), smalltalk:newArray({\"ifNotNil:ifNil:\", \"%:if_nil_notNil_%(%receiver%,%arg2%,%arg1%)\"})})}));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"magnitudeOptimizations",0
,function(self)
return (smalltalk:newArray({"magnitude", smalltalk:newArray({smalltalk:newArray({">", "(%receiver% > %arg1%)"}), smalltalk:newArray({"<", "(%receiver% < %arg1%)"}), smalltalk:newArray({">=", "(%receiver% >= %arg1%)"}), smalltalk:newArray({"<=", "(%receiver% <= %arg1%)"})})}));
end
,"optimization","magnitudeOptimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(magnitude #(\r\n\t\t#(> \t'(%receiver% > %arg1%)' )\r\n\t\t#(< \t'(%receiver% < %arg1%)' )\r\n\t\t#(>=\t'(%receiver% >= %arg1%)' )\r\n\t\t#(<=\t'(%receiver% <= %arg1%)' )\r\n\t))","function(self)\r\nreturn (smalltalk:newArray({\"magnitude\", smalltalk:newArray({smalltalk:newArray({\">\", \"(%receiver% > %arg1%)\"}), smalltalk:newArray({\"<\", \"(%receiver% < %arg1%)\"}), smalltalk:newArray({\">=\", \"(%receiver% >= %arg1%)\"}), smalltalk:newArray({\"<=\", \"(%receiver% <= %arg1%)\"})})}));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"mathOptimizations",0
,function(self)
return (smalltalk:newArray({"math", smalltalk:newArray({smalltalk:newArray({"max:", "%:math_max_%(%receiver%,%arg1%)"}), smalltalk:newArray({"min:", "%:math_min_%(%receiver%,%arg1%)"}), smalltalk:newArray({"mustBeNumber", "%:mustBeNumber_%(%receiver%)"}), smalltalk:newArray({"+", "(%receiver% + %arg1%)"}), smalltalk:newArray({"-", "(%receiver% - %arg1%)"}), smalltalk:newArray({"*", "(%receiver% * %arg1%)"}), smalltalk:newArray({"/", "(%receiver% / %arg1%)"})})}));
end
,"optimization","mathOptimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(math #(\r\n\t\t#(max:\t'%:math_max_%(%receiver%,%arg1%)' )\r\n\t\t#(min:\t'%:math_min_%(%receiver%,%arg1%)' )\r\n\t\t#(mustBeNumber\t'%:mustBeNumber_%(%receiver%)' )\r\n\t\t#(+\t'(%receiver% + %arg1%)' )\r\n\t\t#(#-\t'(%receiver% - %arg1%)' )\r\n\t\t#(*\t'(%receiver% * %arg1%)' )\r\n\t\t#(/\t'(%receiver% / %arg1%)' )\r\n\t))","function(self)\r\nreturn (smalltalk:newArray({\"math\", smalltalk:newArray({smalltalk:newArray({\"max:\", \"%:math_max_%(%receiver%,%arg1%)\"}), smalltalk:newArray({\"min:\", \"%:math_min_%(%receiver%,%arg1%)\"}), smalltalk:newArray({\"mustBeNumber\", \"%:mustBeNumber_%(%receiver%)\"}), smalltalk:newArray({\"+\", \"(%receiver% + %arg1%)\"}), smalltalk:newArray({\"-\", \"(%receiver% - %arg1%)\"}), smalltalk:newArray({\"*\", \"(%receiver% * %arg1%)\"}), smalltalk:newArray({\"/\", \"(%receiver% / %arg1%)\"})})}));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"printingOptimizations",0
,function(self)
return (smalltalk:newArray({"printing", smalltalk:newArray({smalltalk:newArray({"toString", "%:toString_%(%receiver%)"}), smalltalk:newArray({"printString", "%:printString_%(%receiver%)"}), smalltalk:newArray({"asString", "%:asString_%(%receiver%)"}), smalltalk:newArray({"asCharacter", "%:asCharacter_%(%receiver%)"})})}));
end
,"optimization","printingOptimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(printing #(\r\n\t\t#(toString\t'%:toString_%(%receiver%)' )\r\n\t\t#(printString\t'%:printString_%(%receiver%)' )\r\n\t\t#(asString\t'%:asString_%(%receiver%)' )\r\n\t\t#(asCharacter\t'%:asCharacter_%(%receiver%)' )\r\n\t))","function(self)\r\nreturn (smalltalk:newArray({\"printing\", smalltalk:newArray({smalltalk:newArray({\"toString\", \"%:toString_%(%receiver%)\"}), smalltalk:newArray({\"printString\", \"%:printString_%(%receiver%)\"}), smalltalk:newArray({\"asString\", \"%:asString_%(%receiver%)\"}), smalltalk:newArray({\"asCharacter\", \"%:asCharacter_%(%receiver%)\"})})}));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"booleanOptimizations",0
,function(self)
return (smalltalk:newArray({"boolean", smalltalk:newArray({smalltalk:newArray({"isBoolean", "(type(%receiver%)==\"boolean\")"}), smalltalk:newArray({"and:", "hasBlockNoArguments:", "%:boolean_and_%(%receiver%,%arg1%)"}), smalltalk:newArray({"or:", "hasBlockNoArguments:", "%:boolean_or_%(%receiver%,%arg1%)"}), smalltalk:newArray({"not", "%:booleanNot_%(%receiver%)"})})}));
end
,"optimization","booleanOptimizations\r\n\t\" Private - Return the optimization set. \"\r\n\r\n\t^#(boolean #(\r\n\t\t#(isBoolean '(type(%receiver%)==\"boolean\")' )\r\n\t\t#(and: hasBlockNoArguments: '%:boolean_and_%(%receiver%,%arg1%)' )\r\n\t\t#(or: hasBlockNoArguments:  '%:boolean_or_%(%receiver%,%arg1%)' )\r\n\t\t#(not '%:booleanNot_%(%receiver%)' )\r\n\t))","function(self)\r\nreturn (smalltalk:newArray({\"boolean\", smalltalk:newArray({smalltalk:newArray({\"isBoolean\", \"(type(%receiver%)==\\\"boolean\\\")\"}), smalltalk:newArray({\"and:\", \"hasBlockNoArguments:\", \"%:boolean_and_%(%receiver%,%arg1%)\"}), smalltalk:newArray({\"or:\", \"hasBlockNoArguments:\", \"%:boolean_or_%(%receiver%,%arg1%)\"}), smalltalk:newArray({\"not\", \"%:booleanNot_%(%receiver%)\"})})}));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"defaultKnownOptimizations",0
,function(self)
return ((
function(_s8_rec)
	(_s8_rec):add_((self):s8Optimizations());
	(_s8_rec):add_((self):magnitudeOptimizations());
	(_s8_rec):add_((self):booleanOptimizations());
	(_s8_rec):add_((self):printingOptimizations());
	return ((_s8_rec):yourself())
end
)((smalltalk.Array):with_((self):coreOptimizations())));
end
,"defaults","defaultKnownOptimizations\r\n\t\" Private - Return the default knownOptimizations of the receiver. \"\r\n\r\n\t^(Array\twith: self coreOptimizations)\r\n\t\tadd: self s8Optimizations;\r\n\t\tadd: self magnitudeOptimizations;\r\n\"\t\tadd: self mathOptimizations;\"\r\n\t\tadd: self booleanOptimizations;\r\n\t\tadd: self printingOptimizations;\r\n\t\tyourself","function(self)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):add_((self):s8Optimizations());\r\n\t(_s8_rec):add_((self):magnitudeOptimizations());\r\n\t(_s8_rec):add_((self):booleanOptimizations());\r\n\t(_s8_rec):add_((self):printingOptimizations());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.Array):with_((self):coreOptimizations())));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder,"defaultOptimizations",0
,function(self)
return (smalltalk:newArray({"s8", "magnitude", "boolean", "printing"}));
end
,"defaults","defaultOptimizations\r\n\t\" Private - Return the default optimizations of the receiver. \"\r\n\r\n\t^#( s8 magnitude \"math\" boolean \"evaluation\" printing )","function(self)\r\nreturn (smalltalk:newArray({\"s8\", \"magnitude\", \"boolean\", \"printing\"}));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder["$klass"],"initializeKernelInlines:",0
,function(self,pool)
return ((self):register_into_((self):kernelInlines(),pool));
end
,"inlines","initializeKernelInlines: pool\r\n\t\" Private - Initialize the inlines for methods in the category. \"\r\n\r\n\t^self register: self kernelInlines into: pool ","function(self,pool)\r\nreturn ((self):register_into_((self):kernelInlines(),pool));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder["$klass"],"kernelInlines",0
,function(self)
return (smalltalk:newArray({smalltalk:newArray({"Object", smalltalk:newArray({smalltalk:newArray({"halt", "debug.debug()"}), smalltalk:newArray({"toString:", "tostring(anObject)"}), smalltalk:newArray({"isObject:", "\r\n\tlocal status, result = pcall(function() return type(anObject.yourself)==\"function\" end)\r\n\tif true then return status and result end"}), smalltalk:newArray({"typeOf:", "type(anObject)"}), smalltalk:newArray({"basicDelete:", "if self==nil then return else self[aString]=nil end"}), smalltalk:newArray({"basicPerform:withArguments:", smalltalk:newArray({"self", "fn(self,(table.unpack or unpack)(anArray))"})}), smalltalk:newArray({"asJSONObject", "{}"})})}), smalltalk:newArray({"Smalltalk", smalltalk:newArray({smalltalk:newArray({"includesKey:", "{}"}), smalltalk:newArray({"eval:", "\r\n\t-- (req v5.3) local fn,err  = load(anExpression)\r\n\tfunction f() local r = anExpression; anExpression= \"\"; return r end -- (req v5.1)\r\n\tlocal fn,err  = load(f)\r\n\tif fn then return fn() else\r\n\t\tself:note_(\" eval: Error \"..err) --the expression must be a lua expression (including return)\r\n\t\tself:note_(\" expression= \"..anExpression)\r\n\t\treturn nil\r\n\tend"})})}), smalltalk:newArray({"Smalltalk class", smalltalk:newArray({smalltalk:newArray({"global", "_G"}), smalltalk:newArray({"gc", "if collectgarbage() then return true end"})})}), smalltalk:newArray({"Behavior", smalltalk:newArray({smalltalk:newArray({"basicNew", "self[\"$fn\"]()"})})}), smalltalk:newArray({"CompiledMethod", smalltalk:newArray({})}), smalltalk:newArray({"Boolean", smalltalk:newArray({smalltalk:newArray({"not", "self == false"}), smalltalk:newArray({"=", "\r\n\tif anObject==nil then return false end\r\n\tif true then return self==anObject end"}), smalltalk:newArray({"ifTrue:ifFalse:", "\r\n\tif (self==true)\r\n\t\tthen return aBlock:value()\r\n\t\telse return anotherBlock:value() end"})})}), smalltalk:newArray({"Number", smalltalk:newArray({smalltalk:newArray({"=", "\r\n\tif (type(anObject)==\"number\")\r\n\t\tthen return self==anObject\r\n\t\telse return false\r\n\t\tend"}), smalltalk:newArray({">", "self > aNumber"}), smalltalk:newArray({">=", "self >= aNumber"}), smalltalk:newArray({"<", "self < aNumber"}), smalltalk:newArray({"<=", "self <= aNumber"}), smalltalk:newArray({"+", "self + aNumber"}), smalltalk:newArray({"-", "self - aNumber"}), smalltalk:newArray({"*", "self * aNumber"}), smalltalk:newArray({"/", "self / aNumber"}), smalltalk:newArray({"sin", "math.sin(self)"}), smalltalk:newArray({"cos", "math.cos(self)"}), smalltalk:newArray({"tan", "math.tan(self)"}), smalltalk:newArray({"arcCos", "math.acos(self)"}), smalltalk:newArray({"arcSin", "math.asin(self)"}), smalltalk:newArray({"arcTan", "math.atan(self)"}), smalltalk:newArray({"atan2:", "math.atan2(self,aNumber)"}), smalltalk:newArray({"sqrt", "math.sqrt(self)"}), smalltalk:newArray({"<<", "bit.lshift(self,aNumber)"}), smalltalk:newArray({">>", "bit.rshift(self,aNumber)"}), smalltalk:newArray({"raisedTo:", "math.pow(self,aNumber)"}), smalltalk:newArray({"max:", "math.max(self,aNumber)"}), smalltalk:newArray({"min:", "math.min(self,aNumber)"}), smalltalk:newArray({"rounded", "self + 0.5 - (self + 0.5) %% 1"}), smalltalk:newArray({"truncated", "math.floor(self)"}), smalltalk:newArray({"timesRepeat:", "for i=1,self do fn(i) end"}), smalltalk:newArray({"to:do:", "for i=self,aNumber do fn(i) end"}), smalltalk:newArray({"to:by:do:", "for i=self,aNumber,increment do fn(i) end"}), smalltalk:newArray({"printString", "tostring(self)"}), smalltalk:newArray({"toString:", "%:basen%(self,radix)"}), smalltalk:newArray({"isNumber", "if (self~=self) then return false else return (self~=math.huge and self~=-math.huge) end"}), smalltalk:newArray({"clearInterval", "if true then self:notImplementedYet_(\"clearInterval\") end"}), smalltalk:newArray({"clearTimeout", "if true then self:notImplementedYet_(\"clearTimeout\") end"})})}), smalltalk:newArray({"Number class", smalltalk:newArray({smalltalk:newArray({"pi", "math.pi"})})}), smalltalk:newArray({"BlockClosure", smalltalk:newArray({smalltalk:newArray({"whileTrue:", "while self() do fn() end"}), smalltalk:newArray({"whileFalse:", "while (self()==false) do fn() end"}), smalltalk:newArray({"valueWithPossibleArguments:", "self((table.unpack or unpack)(array))"}), smalltalk:newArray({"try:catch:", "\r\n\tlocal success, result = pcall(function() return fn() end)\r\n\tif success\r\n\t\tthen return result\r\n\t\telse return ab( self:smalltalkErrorOf_(result) ) end"}), smalltalk:newArray({"valueWithTimeout:", "self:notImplementedYet_(\"valueWithTimeout:\")"}), smalltalk:newArray({"valueWithInterval:", "self:notImplementedYet_(\"valueWithInterval:\")"}), smalltalk:newArray({"ensure:", "\r\n\tlocal success, result = pcall(function() return self() end)\r\n\tfn()\r\n\tif true then return result end"}), smalltalk:newArray({"ifCurtailed:", "\r\n\tlocal curtailed = true\r\n\tlocal success, result = pcall(function()\r\n\t\tlocal r = self()\r\n\t\tcurtailed = false\r\n\t\treturn r\r\n\tend)\r\n\tif (curtailed)\r\n\t\tthen exceptionBlock:value()\r\n\t\telse return result\r\n\t\tend"}), smalltalk:newArray({"argumentCount", "self:notImplementedYet_(\"argumentCount\")"})})}), smalltalk:newArray({"UndefinedObject", smalltalk:newArray({smalltalk:newArray({"asJSONObject", "nil"})})}), smalltalk:newArray({"Collection", smalltalk:newArray({smalltalk:newArray({"wrap:", "if %:isNil_%(anObject) --anObject==nil\r\n\tthen return smalltalk.UndefinedObject:alias()\r\n\telse return anObject end"}), smalltalk:newArray({"unwrap:", "--if anObject==nil then return nil end\r\n\t--if (type(anObject)==\"table\") and %:isNil_%(anObject)\r\n\tif %:isNil_%(anObject)\r\n\t\tthen return nil\r\n\t\telse return anObject end"})})}), smalltalk:newArray({"HashedSet", smalltalk:newArray({smalltalk:newArray({"initializeHash", "{}"}), smalltalk:newArray({"includes:", "(self[\"@hash\"][cookie])~=nil"}), smalltalk:newArray({"privateRemove:", "self[\"@hash\"][cookie] = nil"})})}), smalltalk:newArray({"SequenceableCollection", smalltalk:newArray({smalltalk:newArray({"indexOf:ifAbsent:", "\r\n\tfor i,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return i end\r\n\tend\r\n\tif true then return aBlock:value() end"}), smalltalk:newArray({"do:", "\r\n\tfor _,value in ipairs(self) do\r\n\t\tfn(self:unwrap_(value))\r\n\tend"}), smalltalk:newArray({"detect:ifNone:", "\r\n\tfor _,value in ipairs(self) do\r\n\t\tlocal v=self:unwrap_(value)\r\n\t\tif (fn(v)) then return v end\r\n\tend\r\n\tif true then return anotherBlock:value() end"}), smalltalk:newArray({"reversed", "\r\n\tlocal result = smalltalk.Array:new()\r\n\tlocal top = #self + 1\r\n\tfor i,v in ipairs(self) do result[top - i] = v end\r\n\tif true then return result end"}), smalltalk:newArray({"isEmpty", "#self==0"}), smalltalk:newArray({"reverseDo:", "for i = #self,1,-1 do fn(self:unwrap_(self[i])) end"}), smalltalk:newArray({"includes:", smalltalk:newArray({"\r\n\tfor _,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return true end\r\n\tend\r\n\tif true then return false end", "if true then end"})}), smalltalk:newArray({"occurrencesOf:", "\r\n\tlocal count = 0\r\n\tfor _,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then count = count + 1 end\r\n\tend\r\n\tif true then return count end"})})}), smalltalk:newArray({"String class", smalltalk:newArray({smalltalk:newArray({"fromString:", "if true then tostring(aString) end"}), smalltalk:newArray({"new", "\"\""}), smalltalk:newArray({"cr", "\"\\r\""}), smalltalk:newArray({"lf", "\"\\n\""}), smalltalk:newArray({"crlf", "\"\\r\\n\""}), smalltalk:newArray({"space", "\" \""}), smalltalk:newArray({"tab", "\"\\t\""}), smalltalk:newArray({"zero", "string.char(0)"}), smalltalk:newArray({"fromCharCode:", "\r\n\tif (type(anArrayOrNumber)==\"number\") then\r\n\t\treturn string.char(anArrayOrNumber)\r\n\tend\r\n\tif true then\r\n\t\tlocal fup = table.unpack or unpack\r\n\t\treturn (string.char(fup(anArrayOrNumber)))\r\n\tend"})})}), smalltalk:newArray({"String", smalltalk:newArray({smalltalk:newArray({"=", "if true then return self==anObject end"}), smalltalk:newArray({"size", "#self"}), smalltalk:newArray({"at:", "self:sub(anIndex,anIndex)"}), smalltalk:newArray({"do:", "for c in self:gmatch(\".\") do fn(c) end"}), smalltalk:newArray({"withIndexDo:", "for i=1,#self do fn(self:sub(i,i),i) end"}), smalltalk:newArray({"detect:ifNone:", "\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (fn(c)) then return c end\r\n\tend\r\n\tif true then return anotherBlock:value() end"}), smalltalk:newArray({"isLiteral", "\r\n\tif #self==0 then return false end\r\n\tif smalltalk.String:isBinarySelector_(self) then return true end\r\n\tif true then return string.find(self,\"[^a-zA-Z0-9_:]+\")==nil end"}), smalltalk:newArray({"occurrencesOf:", "\r\n\tlocal j\r\n\tlocal k,count = 0,0\r\n\trepeat\tj, k = self:find(aString, k + 1, true)\r\n\t\tif (j~=nil) then count=count+1 end\r\n\tuntil j == nil\r\n\tif true then return count end"}), smalltalk:newArray({"startsWith:", "if true then return (self:sub(1, #aString) == aString) end"}), smalltalk:newArray({"escaped", "self:notImplementedYet_(\"escaped\")"}), smalltalk:newArray({"unescaped", "\r\n\tlocal x16 = function(x) return string.char(tonumber(x, 16)) end\r\n\tif true then return self:gsub(\"%%%%(%%x%%x)\", x16) end"}), smalltalk:newArray({"asEncodedURI", "self:notImplementedYet_(\"asEncodedURI\")"}), smalltalk:newArray({"asDecodedURI", "self:notImplementedYet_(\"asDecodedURI\")"}), smalltalk:newArray({",", "if true then return self..(%:asString_%(aCollection)) end"}), smalltalk:newArray({"copyWith:", "self..(%:asString_%(anObject))"}), smalltalk:newArray({"copyFrom:to:", "self:sub(anIndex,anotherIndex)"}), smalltalk:newArray({"reversed", "if true then return self:reverse() end"}), smalltalk:newArray({"includes:", "local ignored"}), smalltalk:newArray({"indexOf:", "\r\n\tlocal index = self:find(aString,1,true)\r\n\tif not index\r\n\t\tthen return 0\r\n\t\telse return index end"}), smalltalk:newArray({"indexOf:startingAt:", "\r\n\tlocal index = self:find(aString,position,true)\r\n\tif not index\r\n\t\tthen return 0\r\n\t\telse return index end"}), smalltalk:newArray({"lastIndexOf:", "\r\n\tlocal i = 0\r\n\tlocal j = 0\r\n\tlocal k = 0\r\n\trepeat\ti = j\r\n\t\tj, k = self:find(aString, k + 1, true)\r\n\tuntil j == nil\r\n\tif true then return i end"}), smalltalk:newArray({"lastIndexOf:startingAt:", "\r\n\tlocal i, j\r\n\tlocal k = position\r\n\trepeat\ti = j\r\n\t\tj, k = self:find(aString, k + 1, true)\r\n\tuntil j == nil\r\n\tif true then return i end"}), smalltalk:newArray({"asNativeName", "self:asLuaName()"}), smalltalk:newArray({"asPrivateSelector", "local map = {\r\n\t\t[\":\"]=\"_\",\r\n\t\t[\"+\"]=\"_plus\",\r\n\t\t[\"-\"]=\"_minus\",\r\n\t\t[\"*\"]=\"_star\",\r\n\t\t[\"/\"]=\"_slash\",\r\n\t\t[\"|\"]=\"_bar\",\r\n\t\t[\"&\"]=\"_amp\",\r\n\t\t[\">\"]=\"_gt\",\r\n\t\t[\"<\"]=\"_lt\",\r\n\t\t[\"=\"]=\"_eq\",\r\n\t\t[\",\"]=\"_comma\",\r\n\t\t[\"@\"]=\"_at\",\r\n\t\t[\"~\"]=\"_no\",\r\n\t\t[\"\\\\\"]=\"_bk\"\r\n\t};\r\n\tresult = self:gsub(\".\",function(c) return map[c] end)"}), smalltalk:newArray({"asNative:", "if true then return self:slashEncoded() end"}), smalltalk:newArray({"replace:with:", "\r\n\tlocal result=\"\"\r\n\tlocal i,j\r\n\tlocal k = 0\r\n\trepeat\ti=k+1\r\n\t\tj, k = self:find(aString, i, true)\r\n\t\tif (j==nil) then\r\n\t\t\tresult=result..(self:sub(i))\r\n\t\telse\r\n\t\t\tresult=result..(self:sub(i,j-1)..anotherString)\r\n\t\tend\r\n\tuntil j == nil\r\n\tif true then return result end"}), smalltalk:newArray({"replaceRegexp:with:", "self:notImplementedYet_(\"replaceRegexp:with:\")"}), smalltalk:newArray({"tokenize:", "\r\n\tlocal result=smalltalk.Array:new()\r\n\tlocal i,j\r\n\tlocal k = 0\r\n\trepeat\ti=k+1\r\n\t\tj, k = self:find(aString, i, true)\r\n\t\tif (j==nil) then\r\n\t\t\tresult:add_(self:sub(i))\r\n\t\telse\r\n\t\t\tresult:add_(self:sub(i,j-#aString))\r\n\t\tend\r\n\tuntil j == nil\r\n\tif true then return result end"}), smalltalk:newArray({"match:", "self:notImplementedYet_(\"match:\")"}), smalltalk:newArray({"isLetter", "#self==1 and string.find(self,\"%%a\")==1"}), smalltalk:newArray({"isDigit", "#self==1 and string.find(self,\"%%d\")==1"}), smalltalk:newArray({"isUpperCase", "\r\n\tif (#self==0) then return false end\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (c<\"A\" or c>\"Z\") then return false end\r\n\tend\r\n\tif true then return true end"}), smalltalk:newArray({"isLowerCase", "\r\n\tif (#self==0) then return false end\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (c<\"a\" or c>\"z\") then return false end\r\n\tend\r\n\tif true then return true end"}), smalltalk:newArray({"asUppercase", "self:upper()"}), smalltalk:newArray({"asLowercase", "self:lower()"}), smalltalk:newArray({"asNumber", "tonumber(self)"}), smalltalk:newArray({">", "self > aString"}), smalltalk:newArray({"<", "self < aString"}), smalltalk:newArray({">=", "self >= aString"}), smalltalk:newArray({"<=", "self <= aString"}), smalltalk:newArray({"isCharacter", "#self == 1"}), smalltalk:newArray({"asciiValue", "string.byte(self)"}), smalltalk:newArray({"isSeparator", "#self==1 and self:find(\"%%s\")==1"})})}), smalltalk:newArray({"Array class", smalltalk:newArray({smalltalk:newArray({"basicNew:", "%:newArray%()"}), smalltalk:newArray({"with:", "self"}), smalltalk:newArray({"with:with:", "self"}), smalltalk:newArray({"with:with:with:", "self"}), smalltalk:newArray({"with:with:with:with:", "self"}), smalltalk:newArray({"withAll:", "\r\n\tlocal result = aCollection:asArray()\r\n\tif aCollection==result\r\n\t\tthen return result:copy()\r\n\t\telse return result\r\n\tend"}), smalltalk:newArray({"slice:", "self:notImplementedYet_(\"slice:\")"})})}), smalltalk:newArray({"Array", smalltalk:newArray({smalltalk:newArray({"size", "#self"}), smalltalk:newArray({"at:", "\r\n\tlocal value = self[anIndex]\r\n\tif value==nil then return self:objectNotFoundAt_(anIndex) end\r\n\tif true then return self:unwrap_(value) end"}), smalltalk:newArray({"at:ifAbsent:", "\r\n\tlocal value = self[anIndex]\r\n\tif (value==nil) then return aBlock:value() end\r\n\tif true then return self:unwrap_(value) end"}), smalltalk:newArray({"at:put:", "\r\n\tself[anIndex]=self:wrap_(anObject)\r\n\tif true then return anObject end"}), smalltalk:newArray({"do:", "\r\n\tfor _,value in ipairs(self) do\r\n\t\tfn(self:unwrap_(value))\r\n\tend"}), smalltalk:newArray({"addAll:", "\r\n\tlocal array = aCollection:asArray()\r\n\tfor i=1,#array do self[#self+1]=self:wrap_(array[i]) end"}), smalltalk:newArray({"shallowCopy", "\r\n\tresult = self:class():new()\r\n\tfor i=1,#self do result[#result+1]=self[i] end"}), smalltalk:newArray({"copyWithAll:", "\r\n\tlocal result = self:copy()\r\n\tresult:addAll_(aCollection)\r\n\tif true then return result end"}), smalltalk:newArray({",", "\r\n\tlocal result = self:copy()\r\n\tresult:addAll_(aCollection)\r\n\tif true then return result end"}), smalltalk:newArray({"join:", "table.concat(self,aString)"}), smalltalk:newArray({"sort:", "table.sort(self,fn)"}), smalltalk:newArray({"remove:ifAbsent:", "\r\n\tfor i,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return table.remove(self,i) end\r\n\tend\r\n\tif true then return aBlock:value() end"}), smalltalk:newArray({"add:", "self[#self+1]=self:wrap_(anObject)"}), smalltalk:newArray({"addFirst:", "table.insert(self,1,self:wrap_(anObject))"}), smalltalk:newArray({"addLast:", "self[#self+1]=self:wrap_(anObject)"}), smalltalk:newArray({"removeAll", "for i=#self,1,-1 do self[i]=nil end"}), smalltalk:newArray({"removeFirst", "table.remove(self,1)"}), smalltalk:newArray({"removeIndex:", "table.remove(self,index)"}), smalltalk:newArray({"removeLast", "self:unwrap_(table.remove(self))"}), smalltalk:newArray({"atAllPut:", "\r\n\tlocal what=self:wrap_(anObject)\r\n\tfor i=1,#self do self[i]=what end"}), smalltalk:newArray({"first", "\r\n\tlocal value=self[1]\r\n\tif (value~=nil) then return self:unwrap_(value) end"}), smalltalk:newArray({"second", "\r\n\tlocal value=self[2]\r\n\tif (value~=nil) then return self:unwrap_(value) end"}), smalltalk:newArray({"third", "\r\n\tlocal value=self[3]\r\n\tif (value~=nil) then return self:unwrap_(value) end"}), smalltalk:newArray({"fourth", "\t\r\n\tlocal value=self[4]\r\n\tif (value~=nil) then return self:unwrap_(value) end"}), smalltalk:newArray({"fifth", "\r\n\tlocal value=self[5]\r\n\tif (value~=nil) then return self:unwrap_(value) end"}), smalltalk:newArray({"sixth", "\r\n\tlocal value=self[6]\r\n\tif (value~=nil) then return self:unwrap_(value) end"})})}), smalltalk:newArray({"RegularExpression class", smalltalk:newArray({smalltalk:newArray({"fromString:flag:", "self:notImplementedYet_(\"fromString:flag:\")"})})}), smalltalk:newArray({"Exception", smalltalk:newArray({smalltalk:newArray({"signal", "error(self)"})})}), smalltalk:newArray({"ComposedAssociations", smalltalk:newArray({smalltalk:newArray({"hashObject", "{}"})})}), smalltalk:newArray({"KeyedCollection class", smalltalk:newArray({smalltalk:newArray({"@", "\r\n\tparts = smalltalk.Array:new()\r\n\tfor k,_ in pairs(jsObject) do parts:add_(k) end"})})}), smalltalk:newArray({"KeyedCollection", smalltalk:newArray({smalltalk:newArray({"newHash", "{}"})})}), smalltalk:newArray({"Dictionary class", smalltalk:newArray({smalltalk:newArray({"basicNew", "if true then return smalltalk.PoolDictionary:new() end"})})}), smalltalk:newArray({"PoolDictionary", smalltalk:newArray({smalltalk:newArray({"removeKey:ifAbsent:", "self[\"@hash\"][self:wrap_(aKey)]=nil"}), smalltalk:newArray({"at:ifAbsent:", "\r\n\tlocal found = self[\"@hash\"][self:wrap_(aKey)]\r\n\tif found~=nil\r\n\t\tthen return self:unwrap_(found)\r\n\t\telse return aBlock:value()\r\n\tend"}), smalltalk:newArray({"includesKey:", "self[\"@hash\"][self:wrap_(aKey)]~=nil"}), smalltalk:newArray({"keys", "\r\n\tlocal result=smalltalk.Array:new()\r\n\tfor k,_ in pairs(self[\"@hash\"]) do result:add_(k) end\r\n\tif true then return result end"})})}), smalltalk:newArray({"ClassBuilder", smalltalk:newArray({smalltalk:newArray({"addSubclassOf:named:instanceVariableNames:", "\r\n\t%:addClass%(aString, aClass, aCollection)\r\n\tif true then return smalltalk[aString] end"})})}), smalltalk:newArray({"StringStream", smalltalk:newArray({smalltalk:newArray({"peek", "\r\n\tlocal c = self[\"@collection\"]:at_(self:position()+1)\r\n\tif c==\"\" then return nil else return c end"}), smalltalk:newArray({"peekForAll:", "\r\n\tlocal start=self:position()\r\n\tif (self[\"@collection\"]:sub(start+1,start+#aCollection)~=aCollection) then return false end"})})}), smalltalk:newArray({"Random", smalltalk:newArray({smalltalk:newArray({"next", "if true then return math.random() end"})})}), smalltalk:newArray({"DateTime class", smalltalk:newArray({smalltalk:newArray({"new:", "if true then return self:notImplementedYet_(\"new:\") end"}), smalltalk:newArray({"today", "if true then return self:new() end"}), smalltalk:newArray({"now", "if true then return self:today() end"}), smalltalk:newArray({"msNow", "if true then return os.clock()*1000 end"})})}), smalltalk:newArray({"DateTime", smalltalk:newArray({smalltalk:newArray({"<", "self:notImplementedYet_(\"<\")"}), smalltalk:newArray({">", "self:notImplementedYet_(\">\")"}), smalltalk:newArray({"<=", "self:notImplementedYet_(\"<=\")"}), smalltalk:newArray({">=", "self:notImplementedYet_(\">=\")"}), smalltalk:newArray({"-", "self:notImplementedYet_(\"-\")"}), smalltalk:newArray({"+", "self:notImplementedYet_(\"+\")"}), smalltalk:newArray({"isValid", "self:notImplementedYet_(\"isValid\")"})})})}));
end
,"inlines","kernelInlines\r\n\t\" Private - Return the inlines for methods in the category. \"\r\n\r\n\t^#(\r\n#(Object #(\r\n#(halt\t\t'debug.debug()')\r\n\"#(toString\t'local unused')\"\r\n#(toString:\t'tostring(anObject)')\r\n#(isObject:\t'\r\n\tlocal status, result = pcall(function() return type(anObject.yourself)==\"function\" end)\r\n\tif true then return status and result end')\r\n#(typeOf:\t'type(anObject)')\r\n\"#(callableOf:\t'local unused')\"\r\n#(basicDelete:\t'if self==nil then return else self[aString]=nil end')\r\n#(basicPerform:withArguments:\t#('self' 'fn(self,(table.unpack or unpack)(anArray))'))\r\n#(asJSONObject\t'{}')\r\n))\r\n#(Smalltalk #(\r\n#(includesKey:\t'{}')\r\n#(eval:\t'\r\n\t-- (req v5.3) local fn,err  = load(anExpression)\r\n\tfunction f() local r = anExpression; anExpression= \"\"; return r end -- (req v5.1)\r\n\tlocal fn,err  = load(f)\r\n\tif fn then return fn() else\r\n\t\tself:note_(\" eval: Error \"..err) --the expression must be a lua expression (including return)\r\n\t\tself:note_(\" expression= \"..anExpression)\r\n\t\treturn nil\r\n\tend')\r\n))\r\n#('Smalltalk class' #(\r\n#(global\t'_G')\r\n#(gc\t'if collectgarbage() then return true end')\r\n))\r\n#(Behavior #(\r\n#(basicNew\t'self[\"$fn\"]()')\r\n\"#(fn\t\t'local unused')\"\r\n\"#(prototype\t'local unused')\"\r\n\"#(privateMethods\t'local unused')\"\r\n))\r\n#(CompiledMethod #(\r\n\"#(asClosure\t'local unused')\"\r\n))\r\n#(Boolean #(\r\n#(not 'self == false')\r\n#(=\t'\r\n\tif anObject==nil then return false end\r\n\tif true then return self==anObject end')\r\n#(ifTrue:ifFalse: '\r\n\tif (self==true)\r\n\t\tthen return aBlock:value()\r\n\t\telse return anotherBlock:value() end')\r\n))\r\n#(Number #(\r\n#(= '\r\n\tif (type(anObject)==\"number\")\r\n\t\tthen return self==anObject\r\n\t\telse return false\r\n\t\tend')\r\n#(> 'self > aNumber')\r\n#(>= 'self >= aNumber')\r\n#(< 'self < aNumber')\r\n#(<= 'self <= aNumber')\r\n#(+ 'self + aNumber')\r\n#(- 'self - aNumber')\r\n#(* 'self * aNumber')\r\n#(/ 'self / aNumber')\r\n#(sin 'math.sin(self)')\r\n#(cos 'math.cos(self)')\r\n#(tan 'math.tan(self)')\r\n#(arcCos 'math.acos(self)')\r\n#(arcSin 'math.asin(self)')\r\n#(arcTan 'math.atan(self)')\r\n#(atan2: 'math.atan2(self,aNumber)')\r\n#(sqrt 'math.sqrt(self)')\r\n#(<< 'bit.lshift(self,aNumber)')\r\n#(>> 'bit.rshift(self,aNumber)')\r\n#(raisedTo: 'math.pow(self,aNumber)')\r\n#(max: 'math.max(self,aNumber)')\r\n#(min: 'math.min(self,aNumber)')\r\n#(rounded 'self + 0.5 - (self + 0.5) %% 1')\r\n#(truncated 'math.floor(self)')\r\n#(timesRepeat: 'for i=1,self do fn(i) end')\r\n#(to:do: 'for i=self,aNumber do fn(i) end')\r\n#(to:by:do: 'for i=self,aNumber,increment do fn(i) end')\r\n#(printString 'tostring(self)')\r\n#(toString: '%:basen%(self,radix)')\r\n#(isNumber 'if (self~=self) then return false else return (self~=math.huge and self~=-math.huge) end')\r\n#(clearInterval 'if true then self:notImplementedYet_(\"clearInterval\") end')\r\n#(clearTimeout 'if true then self:notImplementedYet_(\"clearTimeout\") end')\r\n))\r\n#('Number class' #(\r\n#(pi 'math.pi')\r\n))\r\n#(BlockClosure #(\r\n#(whileTrue: 'while self() do fn() end')\r\n#(whileFalse: 'while (self()==false) do fn() end')\r\n#(valueWithPossibleArguments: 'self((table.unpack or unpack)(array))')\r\n#(try:catch: '\r\n\tlocal success, result = pcall(function() return fn() end)\r\n\tif success\r\n\t\tthen return result\r\n\t\telse return ab( self:smalltalkErrorOf_(result) ) end')\r\n#(valueWithTimeout: 'self:notImplementedYet_(\"valueWithTimeout:\")')\r\n#(valueWithInterval: 'self:notImplementedYet_(\"valueWithInterval:\")')\r\n#(ensure: '\r\n\tlocal success, result = pcall(function() return self() end)\r\n\tfn()\r\n\tif true then return result end')\r\n#(ifCurtailed: '\r\n\tlocal curtailed = true\r\n\tlocal success, result = pcall(function()\r\n\t\tlocal r = self()\r\n\t\tcurtailed = false\r\n\t\treturn r\r\n\tend)\r\n\tif (curtailed)\r\n\t\tthen exceptionBlock:value()\r\n\t\telse return result\r\n\t\tend')\r\n#(argumentCount 'self:notImplementedYet_(\"argumentCount\")')\r\n))\r\n#(UndefinedObject  #(\r\n#(asJSONObject 'nil')\r\n))\r\n#(Collection  #(\r\n#(wrap: 'if %:isNil_%(anObject) --anObject==nil\r\n\tthen return smalltalk.UndefinedObject:alias()\r\n\telse return anObject end')\r\n#(unwrap: '--if anObject==nil then return nil end\r\n\t--if (type(anObject)==\"table\") and %:isNil_%(anObject)\r\n\tif %:isNil_%(anObject)\r\n\t\tthen return nil\r\n\t\telse return anObject end')\r\n))\r\n#(HashedSet #(\r\n#(initializeHash '{}')\r\n#(includes: '(self[\"@hash\"][cookie])~=nil')\r\n\"#(privateAdd: 'local unused')\"\r\n#(privateRemove: 'self[\"@hash\"][cookie] = nil')\r\n))\r\n#(SequenceableCollection #(\r\n#(indexOf:ifAbsent: '\r\n\tfor i,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return i end\r\n\tend\r\n\tif true then return aBlock:value() end')\r\n#(do: '\r\n\tfor _,value in ipairs(self) do\r\n\t\tfn(self:unwrap_(value))\r\n\tend')\r\n#(detect:ifNone: '\r\n\tfor _,value in ipairs(self) do\r\n\t\tlocal v=self:unwrap_(value)\r\n\t\tif (fn(v)) then return v end\r\n\tend\r\n\tif true then return anotherBlock:value() end')\r\n#(reversed '\r\n\tlocal result = smalltalk.Array:new()\r\n\tlocal top = #self + 1\r\n\tfor i,v in ipairs(self) do result[top - i] = v end\r\n\tif true then return result end')\r\n#(isEmpty '#self==0')\r\n#(reverseDo:  'for i = #self,1,-1 do fn(self:unwrap_(self[i])) end')\r\n#(includes: #('\r\n\tfor _,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return true end\r\n\tend\r\n\tif true then return false end' 'if true then end'))\r\n#(occurrencesOf: '\r\n\tlocal count = 0\r\n\tfor _,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then count = count + 1 end\r\n\tend\r\n\tif true then return count end')\r\n))\r\n#('String class' #(\r\n#(fromString: 'if true then tostring(aString) end')\r\n#(new\t'\"\"')\r\n#(cr \t'\"\\r\"')\r\n#(lf \t'\"\\n\"')\r\n#(crlf \t'\"\\r\\n\"')\r\n#(space\t'\" \"')\r\n#(tab\t'\"\\t\"')\r\n#(zero\t'string.char(0)')\r\n#(fromCharCode: '\r\n\tif (type(anArrayOrNumber)==\"number\") then\r\n\t\treturn string.char(anArrayOrNumber)\r\n\tend\r\n\tif true then\r\n\t\tlocal fup = table.unpack or unpack\r\n\t\treturn (string.char(fup(anArrayOrNumber)))\r\n\tend')\r\n))\r\n#(String #(\r\n#(=\t'if true then return self==anObject end')\r\n#(size\t'#self')\r\n#(at:\t'self:sub(anIndex,anIndex)')\r\n#(do: \t'for c in self:gmatch(\".\") do fn(c) end')\r\n#(withIndexDo: 'for i=1,#self do fn(self:sub(i,i),i) end')\r\n#(detect:ifNone: '\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (fn(c)) then return c end\r\n\tend\r\n\tif true then return anotherBlock:value() end')\r\n#(isLiteral '\r\n\tif #self==0 then return false end\r\n\tif smalltalk.String:isBinarySelector_(self) then return true end\r\n\tif true then return string.find(self,\"[^a-zA-Z0-9_:]+\")==nil end')\r\n#(occurrencesOf: '\r\n\tlocal j\r\n\tlocal k,count = 0,0\r\n\trepeat\tj, k = self:find(aString, k + 1, true)\r\n\t\tif (j~=nil) then count=count+1 end\r\n\tuntil j == nil\r\n\tif true then return count end')\r\n#(startsWith: 'if true then return (self:sub(1, #aString) == aString) end')\r\n#(escaped 'self:notImplementedYet_(\"escaped\")')\r\n#(unescaped '\r\n\tlocal x16 = function(x) return string.char(tonumber(x, 16)) end\r\n\tif true then return self:gsub(\"%%%%(%%x%%x)\", x16) end')\r\n#(asEncodedURI 'self:notImplementedYet_(\"asEncodedURI\")')\r\n#(asDecodedURI 'self:notImplementedYet_(\"asDecodedURI\")')\r\n#(, 'if true then return self..(%:asString_%(aCollection)) end')\r\n#(copyWith: 'self..(%:asString_%(anObject))')\r\n#(copyFrom:to: 'self:sub(anIndex,anotherIndex)')\r\n#(reversed 'if true then return self:reverse() end')\r\n#(includes: 'local ignored')\r\n#(indexOf: '\r\n\tlocal index = self:find(aString,1,true)\r\n\tif not index\r\n\t\tthen return 0\r\n\t\telse return index end')\r\n#(indexOf:startingAt: '\r\n\tlocal index = self:find(aString,position,true)\r\n\tif not index\r\n\t\tthen return 0\r\n\t\telse return index end')\r\n#(lastIndexOf: '\r\n\tlocal i = 0\r\n\tlocal j = 0\r\n\tlocal k = 0\r\n\trepeat\ti = j\r\n\t\tj, k = self:find(aString, k + 1, true)\r\n\tuntil j == nil\r\n\tif true then return i end')\r\n#(lastIndexOf:startingAt: '\r\n\tlocal i, j\r\n\tlocal k = position\r\n\trepeat\ti = j\r\n\t\tj, k = self:find(aString, k + 1, true)\r\n\tuntil j == nil\r\n\tif true then return i end')\r\n#(asNativeName 'self:asLuaName()')\r\n#(asPrivateSelector 'local map = {\r\n\t\t[\":\"]=\"_\",\r\n\t\t[\"+\"]=\"_plus\",\r\n\t\t[\"-\"]=\"_minus\",\r\n\t\t[\"*\"]=\"_star\",\r\n\t\t[\"/\"]=\"_slash\",\r\n\t\t[\"|\"]=\"_bar\",\r\n\t\t[\"&\"]=\"_amp\",\r\n\t\t[\">\"]=\"_gt\",\r\n\t\t[\"<\"]=\"_lt\",\r\n\t\t[\"=\"]=\"_eq\",\r\n\t\t[\",\"]=\"_comma\",\r\n\t\t[\"@\"]=\"_at\",\r\n\t\t[\"~\"]=\"_no\",\r\n\t\t[\"\\\\\"]=\"_bk\"\r\n\t};\r\n\tresult = self:gsub(\".\",function(c) return map[c] end)')\r\n#(asNative: 'if true then return self:slashEncoded() end')\r\n#(replace:with: '\r\n\tlocal result=\"\"\r\n\tlocal i,j\r\n\tlocal k = 0\r\n\trepeat\ti=k+1\r\n\t\tj, k = self:find(aString, i, true)\r\n\t\tif (j==nil) then\r\n\t\t\tresult=result..(self:sub(i))\r\n\t\telse\r\n\t\t\tresult=result..(self:sub(i,j-1)..anotherString)\r\n\t\tend\r\n\tuntil j == nil\r\n\tif true then return result end')\r\n#(replaceRegexp:with: 'self:notImplementedYet_(\"replaceRegexp:with:\")')\r\n#(tokenize: '\r\n\tlocal result=smalltalk.Array:new()\r\n\tlocal i,j\r\n\tlocal k = 0\r\n\trepeat\ti=k+1\r\n\t\tj, k = self:find(aString, i, true)\r\n\t\tif (j==nil) then\r\n\t\t\tresult:add_(self:sub(i))\r\n\t\telse\r\n\t\t\tresult:add_(self:sub(i,j-#aString))\r\n\t\tend\r\n\tuntil j == nil\r\n\tif true then return result end')\r\n#(match: 'self:notImplementedYet_(\"match:\")')\r\n#(isLetter '#self==1 and string.find(self,\"%%a\")==1')\r\n#(isDigit '#self==1 and string.find(self,\"%%d\")==1')\r\n\"#(isAlphaNumeric 'local unused')\"\r\n#(isUpperCase '\r\n\tif (#self==0) then return false end\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (c<\"A\" or c>\"Z\") then return false end\r\n\tend\r\n\tif true then return true end')\r\n#(isLowerCase '\r\n\tif (#self==0) then return false end\r\n\tfor c in self:gmatch(\".\") do\r\n\t\tif (c<\"a\" or c>\"z\") then return false end\r\n\tend\r\n\tif true then return true end')\r\n#(asUppercase 'self:upper()')\r\n#(asLowercase 'self:lower()')\r\n#(asNumber 'tonumber(self)')\r\n#(> 'self > aString')\r\n#(< 'self < aString')\r\n#(>= 'self >= aString')\r\n#(<= 'self <= aString')\r\n#(isCharacter '#self == 1')\r\n#(asciiValue 'string.byte(self)')\r\n#(isSeparator '#self==1 and self:find(\"%%s\")==1')\r\n))\r\n#('Array class' #(\r\n#(basicNew: '%:newArray%()')\r\n#(with: 'self')\r\n#(with:with: 'self')\r\n#(with:with:with: 'self')\r\n#(with:with:with:with: 'self')\r\n#(withAll: '\r\n\tlocal result = aCollection:asArray()\r\n\tif aCollection==result\r\n\t\tthen return result:copy()\r\n\t\telse return result\r\n\tend')\r\n#(slice: 'self:notImplementedYet_(\"slice:\")')\r\n))\r\n#(Array #(\r\n#(size '#self')\r\n#(at: '\r\n\tlocal value = self[anIndex]\r\n\tif value==nil then return self:objectNotFoundAt_(anIndex) end\r\n\tif true then return self:unwrap_(value) end')\r\n#(at:ifAbsent: '\r\n\tlocal value = self[anIndex]\r\n\tif (value==nil) then return aBlock:value() end\r\n\tif true then return self:unwrap_(value) end')\r\n#(at:put: '\r\n\tself[anIndex]=self:wrap_(anObject)\r\n\tif true then return anObject end')\r\n#(do: '\r\n\tfor _,value in ipairs(self) do\r\n\t\tfn(self:unwrap_(value))\r\n\tend')\r\n#(addAll: '\r\n\tlocal array = aCollection:asArray()\r\n\tfor i=1,#array do self[#self+1]=self:wrap_(array[i]) end')\r\n#(shallowCopy '\r\n\tresult = self:class():new()\r\n\tfor i=1,#self do result[#result+1]=self[i] end')\r\n#(copyWithAll: '\r\n\tlocal result = self:copy()\r\n\tresult:addAll_(aCollection)\r\n\tif true then return result end')\r\n#(, '\r\n\tlocal result = self:copy()\r\n\tresult:addAll_(aCollection)\r\n\tif true then return result end')\r\n#(join: 'table.concat(self,aString)')\r\n#(sort: 'table.sort(self,fn)')\r\n#(remove:ifAbsent: '\r\n\tfor i,value in ipairs(self) do\r\n\t\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return table.remove(self,i) end\r\n\tend\r\n\tif true then return aBlock:value() end')\r\n#(add: 'self[#self+1]=self:wrap_(anObject)')\r\n#(addFirst: 'table.insert(self,1,self:wrap_(anObject))')\r\n#(addLast: 'self[#self+1]=self:wrap_(anObject)')\r\n#(removeAll 'for i=#self,1,-1 do self[i]=nil end')\r\n#(removeFirst 'table.remove(self,1)')\r\n#(removeIndex: 'table.remove(self,index)')\r\n#(removeLast 'self:unwrap_(table.remove(self))')\r\n#(atAllPut: '\r\n\tlocal what=self:wrap_(anObject)\r\n\tfor i=1,#self do self[i]=what end')\r\n#(first '\r\n\tlocal value=self[1]\r\n\tif (value~=nil) then return self:unwrap_(value) end')\r\n#(second '\r\n\tlocal value=self[2]\r\n\tif (value~=nil) then return self:unwrap_(value) end')\r\n#(third '\r\n\tlocal value=self[3]\r\n\tif (value~=nil) then return self:unwrap_(value) end')\r\n#(fourth '\t\r\n\tlocal value=self[4]\r\n\tif (value~=nil) then return self:unwrap_(value) end')\r\n#(fifth '\r\n\tlocal value=self[5]\r\n\tif (value~=nil) then return self:unwrap_(value) end')\r\n#(sixth '\r\n\tlocal value=self[6]\r\n\tif (value~=nil) then return self:unwrap_(value) end')\r\n))\r\n#('RegularExpression class' #(\r\n#(fromString:flag: 'self:notImplementedYet_(\"fromString:flag:\")')\r\n))\r\n#(Exception #(\r\n#(signal 'error(self)')\r\n))\r\n#(ComposedAssociations #(\r\n#(hashObject '{}')\r\n))\r\n#('KeyedCollection class' #(\r\n#(@ '\r\n\tparts = smalltalk.Array:new()\r\n\tfor k,_ in pairs(jsObject) do parts:add_(k) end')\r\n))\r\n#(KeyedCollection #(\r\n#(newHash '{}')\r\n))\r\n#('Dictionary class' #(\r\n#(basicNew 'if true then return smalltalk.PoolDictionary:new() end')\r\n))\r\n#(PoolDictionary #(\r\n\"#(validKey: 'local unused')\"\r\n\"#(at:put: 'local unused')\"\r\n#(removeKey:ifAbsent: 'self[\"@hash\"][self:wrap_(aKey)]=nil')\r\n#(at:ifAbsent: '\r\n\tlocal found = self[\"@hash\"][self:wrap_(aKey)]\r\n\tif found~=nil\r\n\t\tthen return self:unwrap_(found)\r\n\t\telse return aBlock:value()\r\n\tend')\r\n#(includesKey: 'self[\"@hash\"][self:wrap_(aKey)]~=nil')\r\n#(keys '\r\n\tlocal result=smalltalk.Array:new()\r\n\tfor k,_ in pairs(self[\"@hash\"]) do result:add_(k) end\r\n\tif true then return result end')\r\n))\r\n#(ClassBuilder #(\r\n#(addSubclassOf:named:instanceVariableNames: '\r\n\t%:addClass%(aString, aClass, aCollection)\r\n\tif true then return smalltalk[aString] end')\r\n))\r\n#(StringStream #(\r\n#(peek '\r\n\tlocal c = self[\"@collection\"]:at_(self:position()+1)\r\n\tif c==\"\" then return nil else return c end')\r\n#(peekForAll: '\r\n\tlocal start=self:position()\r\n\tif (self[\"@collection\"]:sub(start+1,start+#aCollection)~=aCollection) then return false end')\r\n))\r\n#(Random #(\r\n#(next 'if true then return math.random() end')\r\n))\r\n#('DateTime class' #(\r\n#(new: 'if true then return self:notImplementedYet_(\"new:\") end')\r\n#(today 'if true then return self:new() end')\r\n#(now 'if true then return self:today() end')\r\n#(msNow 'if true then return os.clock()*1000 end')\r\n))\r\n#(DateTime #(\r\n#(< 'self:notImplementedYet_(\"<\")')\r\n#(> 'self:notImplementedYet_(\">\")')\r\n#(<= 'self:notImplementedYet_(\"<=\")')\r\n#(>= 'self:notImplementedYet_(\">=\")')\r\n#(- 'self:notImplementedYet_(\"-\")')\r\n#(+ 'self:notImplementedYet_(\"+\")')\r\n#(isValid 'self:notImplementedYet_(\"isValid\")')\r\n))\r\n\t) ","function(self)\r\nreturn (smalltalk:newArray({smalltalk:newArray({\"Object\", smalltalk:newArray({smalltalk:newArray({\"halt\", \"debug.debug()\"}), smalltalk:newArray({\"toString:\", \"tostring(anObject)\"}), smalltalk:newArray({\"isObject:\", \"\\r\\n\\tlocal status, result = pcall(function() return type(anObject.yourself)==\\\"function\\\" end)\\r\\n\\tif true then return status and result end\"}), smalltalk:newArray({\"typeOf:\", \"type(anObject)\"}), smalltalk:newArray({\"basicDelete:\", \"if self==nil then return else self[aString]=nil end\"}), smalltalk:newArray({\"basicPerform:withArguments:\", smalltalk:newArray({\"self\", \"fn(self,(table.unpack or unpack)(anArray))\"})}), smalltalk:newArray({\"asJSONObject\", \"{}\"})})}), smalltalk:newArray({\"Smalltalk\", smalltalk:newArray({smalltalk:newArray({\"includesKey:\", \"{}\"}), smalltalk:newArray({\"eval:\", \"\\r\\n\\t-- (req v5.3) local fn,err  = load(anExpression)\\r\\n\\tfunction f() local r = anExpression; anExpression= \\\"\\\"; return r end -- (req v5.1)\\r\\n\\tlocal fn,err  = load(f)\\r\\n\\tif fn then return fn() else\\r\\n\\t\\tself:note_(\\\" eval: Error \\\"..err) --the expression must be a lua expression (including return)\\r\\n\\t\\tself:note_(\\\" expression= \\\"..anExpression)\\r\\n\\t\\treturn nil\\r\\n\\tend\"})})}), smalltalk:newArray({\"Smalltalk class\", smalltalk:newArray({smalltalk:newArray({\"global\", \"_G\"}), smalltalk:newArray({\"gc\", \"if collectgarbage() then return true end\"})})}), smalltalk:newArray({\"Behavior\", smalltalk:newArray({smalltalk:newArray({\"basicNew\", \"self[\\\"$fn\\\"]()\"})})}), smalltalk:newArray({\"CompiledMethod\", smalltalk:newArray({})}), smalltalk:newArray({\"Boolean\", smalltalk:newArray({smalltalk:newArray({\"not\", \"self == false\"}), smalltalk:newArray({\"=\", \"\\r\\n\\tif anObject==nil then return false end\\r\\n\\tif true then return self==anObject end\"}), smalltalk:newArray({\"ifTrue:ifFalse:\", \"\\r\\n\\tif (self==true)\\r\\n\\t\\tthen return aBlock:value()\\r\\n\\t\\telse return anotherBlock:value() end\"})})}), smalltalk:newArray({\"Number\", smalltalk:newArray({smalltalk:newArray({\"=\", \"\\r\\n\\tif (type(anObject)==\\\"number\\\")\\r\\n\\t\\tthen return self==anObject\\r\\n\\t\\telse return false\\r\\n\\t\\tend\"}), smalltalk:newArray({\">\", \"self > aNumber\"}), smalltalk:newArray({\">=\", \"self >= aNumber\"}), smalltalk:newArray({\"<\", \"self < aNumber\"}), smalltalk:newArray({\"<=\", \"self <= aNumber\"}), smalltalk:newArray({\"+\", \"self + aNumber\"}), smalltalk:newArray({\"-\", \"self - aNumber\"}), smalltalk:newArray({\"*\", \"self * aNumber\"}), smalltalk:newArray({\"/\", \"self / aNumber\"}), smalltalk:newArray({\"sin\", \"math.sin(self)\"}), smalltalk:newArray({\"cos\", \"math.cos(self)\"}), smalltalk:newArray({\"tan\", \"math.tan(self)\"}), smalltalk:newArray({\"arcCos\", \"math.acos(self)\"}), smalltalk:newArray({\"arcSin\", \"math.asin(self)\"}), smalltalk:newArray({\"arcTan\", \"math.atan(self)\"}), smalltalk:newArray({\"atan2:\", \"math.atan2(self,aNumber)\"}), smalltalk:newArray({\"sqrt\", \"math.sqrt(self)\"}), smalltalk:newArray({\"<<\", \"bit.lshift(self,aNumber)\"}), smalltalk:newArray({\">>\", \"bit.rshift(self,aNumber)\"}), smalltalk:newArray({\"raisedTo:\", \"math.pow(self,aNumber)\"}), smalltalk:newArray({\"max:\", \"math.max(self,aNumber)\"}), smalltalk:newArray({\"min:\", \"math.min(self,aNumber)\"}), smalltalk:newArray({\"rounded\", \"self + 0.5 - (self + 0.5) %% 1\"}), smalltalk:newArray({\"truncated\", \"math.floor(self)\"}), smalltalk:newArray({\"timesRepeat:\", \"for i=1,self do fn(i) end\"}), smalltalk:newArray({\"to:do:\", \"for i=self,aNumber do fn(i) end\"}), smalltalk:newArray({\"to:by:do:\", \"for i=self,aNumber,increment do fn(i) end\"}), smalltalk:newArray({\"printString\", \"tostring(self)\"}), smalltalk:newArray({\"toString:\", \"%:basen%(self,radix)\"}), smalltalk:newArray({\"isNumber\", \"if (self~=self) then return false else return (self~=math.huge and self~=-math.huge) end\"}), smalltalk:newArray({\"clearInterval\", \"if true then self:notImplementedYet_(\\\"clearInterval\\\") end\"}), smalltalk:newArray({\"clearTimeout\", \"if true then self:notImplementedYet_(\\\"clearTimeout\\\") end\"})})}), smalltalk:newArray({\"Number class\", smalltalk:newArray({smalltalk:newArray({\"pi\", \"math.pi\"})})}), smalltalk:newArray({\"BlockClosure\", smalltalk:newArray({smalltalk:newArray({\"whileTrue:\", \"while self() do fn() end\"}), smalltalk:newArray({\"whileFalse:\", \"while (self()==false) do fn() end\"}), smalltalk:newArray({\"valueWithPossibleArguments:\", \"self((table.unpack or unpack)(array))\"}), smalltalk:newArray({\"try:catch:\", \"\\r\\n\\tlocal success, result = pcall(function() return fn() end)\\r\\n\\tif success\\r\\n\\t\\tthen return result\\r\\n\\t\\telse return ab( self:smalltalkErrorOf_(result) ) end\"}), smalltalk:newArray({\"valueWithTimeout:\", \"self:notImplementedYet_(\\\"valueWithTimeout:\\\")\"}), smalltalk:newArray({\"valueWithInterval:\", \"self:notImplementedYet_(\\\"valueWithInterval:\\\")\"}), smalltalk:newArray({\"ensure:\", \"\\r\\n\\tlocal success, result = pcall(function() return self() end)\\r\\n\\tfn()\\r\\n\\tif true then return result end\"}), smalltalk:newArray({\"ifCurtailed:\", \"\\r\\n\\tlocal curtailed = true\\r\\n\\tlocal success, result = pcall(function()\\r\\n\\t\\tlocal r = self()\\r\\n\\t\\tcurtailed = false\\r\\n\\t\\treturn r\\r\\n\\tend)\\r\\n\\tif (curtailed)\\r\\n\\t\\tthen exceptionBlock:value()\\r\\n\\t\\telse return result\\r\\n\\t\\tend\"}), smalltalk:newArray({\"argumentCount\", \"self:notImplementedYet_(\\\"argumentCount\\\")\"})})}), smalltalk:newArray({\"UndefinedObject\", smalltalk:newArray({smalltalk:newArray({\"asJSONObject\", \"nil\"})})}), smalltalk:newArray({\"Collection\", smalltalk:newArray({smalltalk:newArray({\"wrap:\", \"if %:isNil_%(anObject) --anObject==nil\\r\\n\\tthen return smalltalk.UndefinedObject:alias()\\r\\n\\telse return anObject end\"}), smalltalk:newArray({\"unwrap:\", \"--if anObject==nil then return nil end\\r\\n\\t--if (type(anObject)==\\\"table\\\") and %:isNil_%(anObject)\\r\\n\\tif %:isNil_%(anObject)\\r\\n\\t\\tthen return nil\\r\\n\\t\\telse return anObject end\"})})}), smalltalk:newArray({\"HashedSet\", smalltalk:newArray({smalltalk:newArray({\"initializeHash\", \"{}\"}), smalltalk:newArray({\"includes:\", \"(self[\\\"@hash\\\"][cookie])~=nil\"}), smalltalk:newArray({\"privateRemove:\", \"self[\\\"@hash\\\"][cookie] = nil\"})})}), smalltalk:newArray({\"SequenceableCollection\", smalltalk:newArray({smalltalk:newArray({\"indexOf:ifAbsent:\", \"\\r\\n\\tfor i,value in ipairs(self) do\\r\\n\\t\\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return i end\\r\\n\\tend\\r\\n\\tif true then return aBlock:value() end\"}), smalltalk:newArray({\"do:\", \"\\r\\n\\tfor _,value in ipairs(self) do\\r\\n\\t\\tfn(self:unwrap_(value))\\r\\n\\tend\"}), smalltalk:newArray({\"detect:ifNone:\", \"\\r\\n\\tfor _,value in ipairs(self) do\\r\\n\\t\\tlocal v=self:unwrap_(value)\\r\\n\\t\\tif (fn(v)) then return v end\\r\\n\\tend\\r\\n\\tif true then return anotherBlock:value() end\"}), smalltalk:newArray({\"reversed\", \"\\r\\n\\tlocal result = smalltalk.Array:new()\\r\\n\\tlocal top = #self + 1\\r\\n\\tfor i,v in ipairs(self) do result[top - i] = v end\\r\\n\\tif true then return result end\"}), smalltalk:newArray({\"isEmpty\", \"#self==0\"}), smalltalk:newArray({\"reverseDo:\", \"for i = #self,1,-1 do fn(self:unwrap_(self[i])) end\"}), smalltalk:newArray({\"includes:\", smalltalk:newArray({\"\\r\\n\\tfor _,value in ipairs(self) do\\r\\n\\t\\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return true end\\r\\n\\tend\\r\\n\\tif true then return false end\", \"if true then end\"})}), smalltalk:newArray({\"occurrencesOf:\", \"\\r\\n\\tlocal count = 0\\r\\n\\tfor _,value in ipairs(self) do\\r\\n\\t\\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then count = count + 1 end\\r\\n\\tend\\r\\n\\tif true then return count end\"})})}), smalltalk:newArray({\"String class\", smalltalk:newArray({smalltalk:newArray({\"fromString:\", \"if true then tostring(aString) end\"}), smalltalk:newArray({\"new\", \"\\\"\\\"\"}), smalltalk:newArray({\"cr\", \"\\\"\\\\r\\\"\"}), smalltalk:newArray({\"lf\", \"\\\"\\\\n\\\"\"}), smalltalk:newArray({\"crlf\", \"\\\"\\\\r\\\\n\\\"\"}), smalltalk:newArray({\"space\", \"\\\" \\\"\"}), smalltalk:newArray({\"tab\", \"\\\"\\\\t\\\"\"}), smalltalk:newArray({\"zero\", \"string.char(0)\"}), smalltalk:newArray({\"fromCharCode:\", \"\\r\\n\\tif (type(anArrayOrNumber)==\\\"number\\\") then\\r\\n\\t\\treturn string.char(anArrayOrNumber)\\r\\n\\tend\\r\\n\\tif true then\\r\\n\\t\\tlocal fup = table.unpack or unpack\\r\\n\\t\\treturn (string.char(fup(anArrayOrNumber)))\\r\\n\\tend\"})})}), smalltalk:newArray({\"String\", smalltalk:newArray({smalltalk:newArray({\"=\", \"if true then return self==anObject end\"}), smalltalk:newArray({\"size\", \"#self\"}), smalltalk:newArray({\"at:\", \"self:sub(anIndex,anIndex)\"}), smalltalk:newArray({\"do:\", \"for c in self:gmatch(\\\".\\\") do fn(c) end\"}), smalltalk:newArray({\"withIndexDo:\", \"for i=1,#self do fn(self:sub(i,i),i) end\"}), smalltalk:newArray({\"detect:ifNone:\", \"\\r\\n\\tfor c in self:gmatch(\\\".\\\") do\\r\\n\\t\\tif (fn(c)) then return c end\\r\\n\\tend\\r\\n\\tif true then return anotherBlock:value() end\"}), smalltalk:newArray({\"isLiteral\", \"\\r\\n\\tif #self==0 then return false end\\r\\n\\tif smalltalk.String:isBinarySelector_(self) then return true end\\r\\n\\tif true then return string.find(self,\\\"[^a-zA-Z0-9_:]+\\\")==nil end\"}), smalltalk:newArray({\"occurrencesOf:\", \"\\r\\n\\tlocal j\\r\\n\\tlocal k,count = 0,0\\r\\n\\trepeat\\tj, k = self:find(aString, k + 1, true)\\r\\n\\t\\tif (j~=nil) then count=count+1 end\\r\\n\\tuntil j == nil\\r\\n\\tif true then return count end\"}), smalltalk:newArray({\"startsWith:\", \"if true then return (self:sub(1, #aString) == aString) end\"}), smalltalk:newArray({\"escaped\", \"self:notImplementedYet_(\\\"escaped\\\")\"}), smalltalk:newArray({\"unescaped\", \"\\r\\n\\tlocal x16 = function(x) return string.char(tonumber(x, 16)) end\\r\\n\\tif true then return self:gsub(\\\"%%%%(%%x%%x)\\\", x16) end\"}), smalltalk:newArray({\"asEncodedURI\", \"self:notImplementedYet_(\\\"asEncodedURI\\\")\"}), smalltalk:newArray({\"asDecodedURI\", \"self:notImplementedYet_(\\\"asDecodedURI\\\")\"}), smalltalk:newArray({\",\", \"if true then return self..(%:asString_%(aCollection)) end\"}), smalltalk:newArray({\"copyWith:\", \"self..(%:asString_%(anObject))\"}), smalltalk:newArray({\"copyFrom:to:\", \"self:sub(anIndex,anotherIndex)\"}), smalltalk:newArray({\"reversed\", \"if true then return self:reverse() end\"}), smalltalk:newArray({\"includes:\", \"local ignored\"}), smalltalk:newArray({\"indexOf:\", \"\\r\\n\\tlocal index = self:find(aString,1,true)\\r\\n\\tif not index\\r\\n\\t\\tthen return 0\\r\\n\\t\\telse return index end\"}), smalltalk:newArray({\"indexOf:startingAt:\", \"\\r\\n\\tlocal index = self:find(aString,position,true)\\r\\n\\tif not index\\r\\n\\t\\tthen return 0\\r\\n\\t\\telse return index end\"}), smalltalk:newArray({\"lastIndexOf:\", \"\\r\\n\\tlocal i = 0\\r\\n\\tlocal j = 0\\r\\n\\tlocal k = 0\\r\\n\\trepeat\\ti = j\\r\\n\\t\\tj, k = self:find(aString, k + 1, true)\\r\\n\\tuntil j == nil\\r\\n\\tif true then return i end\"}), smalltalk:newArray({\"lastIndexOf:startingAt:\", \"\\r\\n\\tlocal i, j\\r\\n\\tlocal k = position\\r\\n\\trepeat\\ti = j\\r\\n\\t\\tj, k = self:find(aString, k + 1, true)\\r\\n\\tuntil j == nil\\r\\n\\tif true then return i end\"}), smalltalk:newArray({\"asNativeName\", \"self:asLuaName()\"}), smalltalk:newArray({\"asPrivateSelector\", \"local map = {\\r\\n\\t\\t[\\\":\\\"]=\\\"_\\\",\\r\\n\\t\\t[\\\"+\\\"]=\\\"_plus\\\",\\r\\n\\t\\t[\\\"-\\\"]=\\\"_minus\\\",\\r\\n\\t\\t[\\\"*\\\"]=\\\"_star\\\",\\r\\n\\t\\t[\\\"/\\\"]=\\\"_slash\\\",\\r\\n\\t\\t[\\\"|\\\"]=\\\"_bar\\\",\\r\\n\\t\\t[\\\"&\\\"]=\\\"_amp\\\",\\r\\n\\t\\t[\\\">\\\"]=\\\"_gt\\\",\\r\\n\\t\\t[\\\"<\\\"]=\\\"_lt\\\",\\r\\n\\t\\t[\\\"=\\\"]=\\\"_eq\\\",\\r\\n\\t\\t[\\\",\\\"]=\\\"_comma\\\",\\r\\n\\t\\t[\\\"@\\\"]=\\\"_at\\\",\\r\\n\\t\\t[\\\"~\\\"]=\\\"_no\\\",\\r\\n\\t\\t[\\\"\\\\\\\\\\\"]=\\\"_bk\\\"\\r\\n\\t};\\r\\n\\tresult = self:gsub(\\\".\\\",function(c) return map[c] end)\"}), smalltalk:newArray({\"asNative:\", \"if true then return self:slashEncoded() end\"}), smalltalk:newArray({\"replace:with:\", \"\\r\\n\\tlocal result=\\\"\\\"\\r\\n\\tlocal i,j\\r\\n\\tlocal k = 0\\r\\n\\trepeat\\ti=k+1\\r\\n\\t\\tj, k = self:find(aString, i, true)\\r\\n\\t\\tif (j==nil) then\\r\\n\\t\\t\\tresult=result..(self:sub(i))\\r\\n\\t\\telse\\r\\n\\t\\t\\tresult=result..(self:sub(i,j-1)..anotherString)\\r\\n\\t\\tend\\r\\n\\tuntil j == nil\\r\\n\\tif true then return result end\"}), smalltalk:newArray({\"replaceRegexp:with:\", \"self:notImplementedYet_(\\\"replaceRegexp:with:\\\")\"}), smalltalk:newArray({\"tokenize:\", \"\\r\\n\\tlocal result=smalltalk.Array:new()\\r\\n\\tlocal i,j\\r\\n\\tlocal k = 0\\r\\n\\trepeat\\ti=k+1\\r\\n\\t\\tj, k = self:find(aString, i, true)\\r\\n\\t\\tif (j==nil) then\\r\\n\\t\\t\\tresult:add_(self:sub(i))\\r\\n\\t\\telse\\r\\n\\t\\t\\tresult:add_(self:sub(i,j-#aString))\\r\\n\\t\\tend\\r\\n\\tuntil j == nil\\r\\n\\tif true then return result end\"}), smalltalk:newArray({\"match:\", \"self:notImplementedYet_(\\\"match:\\\")\"}), smalltalk:newArray({\"isLetter\", \"#self==1 and string.find(self,\\\"%%a\\\")==1\"}), smalltalk:newArray({\"isDigit\", \"#self==1 and string.find(self,\\\"%%d\\\")==1\"}), smalltalk:newArray({\"isUpperCase\", \"\\r\\n\\tif (#self==0) then return false end\\r\\n\\tfor c in self:gmatch(\\\".\\\") do\\r\\n\\t\\tif (c<\\\"A\\\" or c>\\\"Z\\\") then return false end\\r\\n\\tend\\r\\n\\tif true then return true end\"}), smalltalk:newArray({\"isLowerCase\", \"\\r\\n\\tif (#self==0) then return false end\\r\\n\\tfor c in self:gmatch(\\\".\\\") do\\r\\n\\t\\tif (c<\\\"a\\\" or c>\\\"z\\\") then return false end\\r\\n\\tend\\r\\n\\tif true then return true end\"}), smalltalk:newArray({\"asUppercase\", \"self:upper()\"}), smalltalk:newArray({\"asLowercase\", \"self:lower()\"}), smalltalk:newArray({\"asNumber\", \"tonumber(self)\"}), smalltalk:newArray({\">\", \"self > aString\"}), smalltalk:newArray({\"<\", \"self < aString\"}), smalltalk:newArray({\">=\", \"self >= aString\"}), smalltalk:newArray({\"<=\", \"self <= aString\"}), smalltalk:newArray({\"isCharacter\", \"#self == 1\"}), smalltalk:newArray({\"asciiValue\", \"string.byte(self)\"}), smalltalk:newArray({\"isSeparator\", \"#self==1 and self:find(\\\"%%s\\\")==1\"})})}), smalltalk:newArray({\"Array class\", smalltalk:newArray({smalltalk:newArray({\"basicNew:\", \"%:newArray%()\"}), smalltalk:newArray({\"with:\", \"self\"}), smalltalk:newArray({\"with:with:\", \"self\"}), smalltalk:newArray({\"with:with:with:\", \"self\"}), smalltalk:newArray({\"with:with:with:with:\", \"self\"}), smalltalk:newArray({\"withAll:\", \"\\r\\n\\tlocal result = aCollection:asArray()\\r\\n\\tif aCollection==result\\r\\n\\t\\tthen return result:copy()\\r\\n\\t\\telse return result\\r\\n\\tend\"}), smalltalk:newArray({\"slice:\", \"self:notImplementedYet_(\\\"slice:\\\")\"})})}), smalltalk:newArray({\"Array\", smalltalk:newArray({smalltalk:newArray({\"size\", \"#self\"}), smalltalk:newArray({\"at:\", \"\\r\\n\\tlocal value = self[anIndex]\\r\\n\\tif value==nil then return self:objectNotFoundAt_(anIndex) end\\r\\n\\tif true then return self:unwrap_(value) end\"}), smalltalk:newArray({\"at:ifAbsent:\", \"\\r\\n\\tlocal value = self[anIndex]\\r\\n\\tif (value==nil) then return aBlock:value() end\\r\\n\\tif true then return self:unwrap_(value) end\"}), smalltalk:newArray({\"at:put:\", \"\\r\\n\\tself[anIndex]=self:wrap_(anObject)\\r\\n\\tif true then return anObject end\"}), smalltalk:newArray({\"do:\", \"\\r\\n\\tfor _,value in ipairs(self) do\\r\\n\\t\\tfn(self:unwrap_(value))\\r\\n\\tend\"}), smalltalk:newArray({\"addAll:\", \"\\r\\n\\tlocal array = aCollection:asArray()\\r\\n\\tfor i=1,#array do self[#self+1]=self:wrap_(array[i]) end\"}), smalltalk:newArray({\"shallowCopy\", \"\\r\\n\\tresult = self:class():new()\\r\\n\\tfor i=1,#self do result[#result+1]=self[i] end\"}), smalltalk:newArray({\"copyWithAll:\", \"\\r\\n\\tlocal result = self:copy()\\r\\n\\tresult:addAll_(aCollection)\\r\\n\\tif true then return result end\"}), smalltalk:newArray({\",\", \"\\r\\n\\tlocal result = self:copy()\\r\\n\\tresult:addAll_(aCollection)\\r\\n\\tif true then return result end\"}), smalltalk:newArray({\"join:\", \"table.concat(self,aString)\"}), smalltalk:newArray({\"sort:\", \"table.sort(self,fn)\"}), smalltalk:newArray({\"remove:ifAbsent:\", \"\\r\\n\\tfor i,value in ipairs(self) do\\r\\n\\t\\tif (%:isObject_equalTo_%(self:unwrap_(value),anObject)) then return table.remove(self,i) end\\r\\n\\tend\\r\\n\\tif true then return aBlock:value() end\"}), smalltalk:newArray({\"add:\", \"self[#self+1]=self:wrap_(anObject)\"}), smalltalk:newArray({\"addFirst:\", \"table.insert(self,1,self:wrap_(anObject))\"}), smalltalk:newArray({\"addLast:\", \"self[#self+1]=self:wrap_(anObject)\"}), smalltalk:newArray({\"removeAll\", \"for i=#self,1,-1 do self[i]=nil end\"}), smalltalk:newArray({\"removeFirst\", \"table.remove(self,1)\"}), smalltalk:newArray({\"removeIndex:\", \"table.remove(self,index)\"}), smalltalk:newArray({\"removeLast\", \"self:unwrap_(table.remove(self))\"}), smalltalk:newArray({\"atAllPut:\", \"\\r\\n\\tlocal what=self:wrap_(anObject)\\r\\n\\tfor i=1,#self do self[i]=what end\"}), smalltalk:newArray({\"first\", \"\\r\\n\\tlocal value=self[1]\\r\\n\\tif (value~=nil) then return self:unwrap_(value) end\"}), smalltalk:newArray({\"second\", \"\\r\\n\\tlocal value=self[2]\\r\\n\\tif (value~=nil) then return self:unwrap_(value) end\"}), smalltalk:newArray({\"third\", \"\\r\\n\\tlocal value=self[3]\\r\\n\\tif (value~=nil) then return self:unwrap_(value) end\"}), smalltalk:newArray({\"fourth\", \"\\t\\r\\n\\tlocal value=self[4]\\r\\n\\tif (value~=nil) then return self:unwrap_(value) end\"}), smalltalk:newArray({\"fifth\", \"\\r\\n\\tlocal value=self[5]\\r\\n\\tif (value~=nil) then return self:unwrap_(value) end\"}), smalltalk:newArray({\"sixth\", \"\\r\\n\\tlocal value=self[6]\\r\\n\\tif (value~=nil) then return self:unwrap_(value) end\"})})}), smalltalk:newArray({\"RegularExpression class\", smalltalk:newArray({smalltalk:newArray({\"fromString:flag:\", \"self:notImplementedYet_(\\\"fromString:flag:\\\")\"})})}), smalltalk:newArray({\"Exception\", smalltalk:newArray({smalltalk:newArray({\"signal\", \"error(self)\"})})}), smalltalk:newArray({\"ComposedAssociations\", smalltalk:newArray({smalltalk:newArray({\"hashObject\", \"{}\"})})}), smalltalk:newArray({\"KeyedCollection class\", smalltalk:newArray({smalltalk:newArray({\"@\", \"\\r\\n\\tparts = smalltalk.Array:new()\\r\\n\\tfor k,_ in pairs(jsObject) do parts:add_(k) end\"})})}), smalltalk:newArray({\"KeyedCollection\", smalltalk:newArray({smalltalk:newArray({\"newHash\", \"{}\"})})}), smalltalk:newArray({\"Dictionary class\", smalltalk:newArray({smalltalk:newArray({\"basicNew\", \"if true then return smalltalk.PoolDictionary:new() end\"})})}), smalltalk:newArray({\"PoolDictionary\", smalltalk:newArray({smalltalk:newArray({\"removeKey:ifAbsent:\", \"self[\\\"@hash\\\"][self:wrap_(aKey)]=nil\"}), smalltalk:newArray({\"at:ifAbsent:\", \"\\r\\n\\tlocal found = self[\\\"@hash\\\"][self:wrap_(aKey)]\\r\\n\\tif found~=nil\\r\\n\\t\\tthen return self:unwrap_(found)\\r\\n\\t\\telse return aBlock:value()\\r\\n\\tend\"}), smalltalk:newArray({\"includesKey:\", \"self[\\\"@hash\\\"][self:wrap_(aKey)]~=nil\"}), smalltalk:newArray({\"keys\", \"\\r\\n\\tlocal result=smalltalk.Array:new()\\r\\n\\tfor k,_ in pairs(self[\\\"@hash\\\"]) do result:add_(k) end\\r\\n\\tif true then return result end\"})})}), smalltalk:newArray({\"ClassBuilder\", smalltalk:newArray({smalltalk:newArray({\"addSubclassOf:named:instanceVariableNames:\", \"\\r\\n\\t%:addClass%(aString, aClass, aCollection)\\r\\n\\tif true then return smalltalk[aString] end\"})})}), smalltalk:newArray({\"StringStream\", smalltalk:newArray({smalltalk:newArray({\"peek\", \"\\r\\n\\tlocal c = self[\\\"@collection\\\"]:at_(self:position()+1)\\r\\n\\tif c==\\\"\\\" then return nil else return c end\"}), smalltalk:newArray({\"peekForAll:\", \"\\r\\n\\tlocal start=self:position()\\r\\n\\tif (self[\\\"@collection\\\"]:sub(start+1,start+#aCollection)~=aCollection) then return false end\"})})}), smalltalk:newArray({\"Random\", smalltalk:newArray({smalltalk:newArray({\"next\", \"if true then return math.random() end\"})})}), smalltalk:newArray({\"DateTime class\", smalltalk:newArray({smalltalk:newArray({\"new:\", \"if true then return self:notImplementedYet_(\\\"new:\\\") end\"}), smalltalk:newArray({\"today\", \"if true then return self:new() end\"}), smalltalk:newArray({\"now\", \"if true then return self:today() end\"}), smalltalk:newArray({\"msNow\", \"if true then return os.clock()*1000 end\"})})}), smalltalk:newArray({\"DateTime\", smalltalk:newArray({smalltalk:newArray({\"<\", \"self:notImplementedYet_(\\\"<\\\")\"}), smalltalk:newArray({\">\", \"self:notImplementedYet_(\\\">\\\")\"}), smalltalk:newArray({\"<=\", \"self:notImplementedYet_(\\\"<=\\\")\"}), smalltalk:newArray({\">=\", \"self:notImplementedYet_(\\\">=\\\")\"}), smalltalk:newArray({\"-\", \"self:notImplementedYet_(\\\"-\\\")\"}), smalltalk:newArray({\"+\", \"self:notImplementedYet_(\\\"+\\\")\"}), smalltalk:newArray({\"isValid\", \"self:notImplementedYet_(\\\"isValid\\\")\"})})})}));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder["$klass"],"initializeNativeInlines:",0
,function(self,pool)
return ((self):register_into_((self):nativeInlines(),pool));
end
,"inlines","initializeNativeInlines: pool\r\n\t\" Private - Initialize the inlines for methods in the category. \"\r\n\r\n\t^self register: self nativeInlines into: pool ","function(self,pool)\r\nreturn ((self):register_into_((self):nativeInlines(),pool));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder["$klass"],"nativeInlines",0
,function(self)
return (smalltalk:newArray({smalltalk:newArray({"NativeObject class", smalltalk:newArray({smalltalk:newArray({"undefined", "nil"}), smalltalk:newArray({"codeToNumber", "\" \""})})}), smalltalk:newArray({"NativeObject", smalltalk:newArray({smalltalk:newArray({"jsObject", "self:invalidMessage_(\"jsObject\")"}), smalltalk:newArray({"ownPropertyNames", "\r\n\tlocal result = smalltalk.Array:new()\r\n\tfor k,_ in pairs(self[\"@handle\"]) do\r\n\t\tresult:add_(k)\r\n\tend\r\n\tif true then return result end"})})}), smalltalk:newArray({"NativeHandle", smalltalk:newArray({smalltalk:newArray({"hasOwnProperty:", "rawget(self[\"@handle\"],aName)~=nil"}), smalltalk:newArray({"delete:", "self[\"@handle\"][aName]=nil"})})}), smalltalk:newArray({"NativeLibraryObject class", smalltalk:newArray({smalltalk:newArray({"basicLoad:", "require(url)"})})}), smalltalk:newArray({"NativeLibraryObject", smalltalk:newArray({smalltalk:newArray({"newHandleOf:", "result = aConstructor()"}), smalltalk:newArray({"newHandleOf:with:", "result = aConstructor(arg1)"}), smalltalk:newArray({"newHandleOf:with:with:", "result = aConstructor(arg1,arg2)"}), smalltalk:newArray({"newHandleOf:with:with:with:", "result = aConstructor(arg1,arg2,arg3)"}), smalltalk:newArray({"newHandleOf:with:with:with:with:", "result = aConstructor(arg1,arg2,arg3,arg4)"}), smalltalk:newArray({"newHandleOf:with:with:with:with:with:", "result = aConstructor(arg1,arg2,arg3,arg4,arg5)"}), smalltalk:newArray({"newHandleOf:with:with:with:with:with:with:", "result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6)"}), smalltalk:newArray({"newHandleOf:with:with:with:with:with:with:with:", "result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7)"}), smalltalk:newArray({"newHandleOf:with:with:with:with:with:with:with:with:", "result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)"})})}), smalltalk:newArray({"Array", smalltalk:newArray({smalltalk:newArray({"addAllLua:", "for _,value in pairs(natives) do self:add_(value) end"})})}), smalltalk:newArray({"Array class", smalltalk:newArray({smalltalk:newArray({"@@", "self"}), smalltalk:newArray({"@", "result:addAllLua_(natives)"})})}), smalltalk:newArray({"Boolean class", smalltalk:newArray({smalltalk:newArray({"@", "\r\n\tif (aBOOL==true) then return true end\r\n\tif (aBOOL==1) then return true end\r\n\tif (aBOOL==false) then return false end\r\n\tif (aBOOL+0==1) then return true end"})})})}));
end
,"inlines","nativeInlines\r\n\t\" Private - Return the inlines for methods in the category. \"\r\n\r\n\t^#(\r\n#('NativeObject class' #(\r\n#(undefined 'nil')\r\n#(codeToNumber '\" \"')\r\n))\r\n#(NativeObject #(\r\n#(jsObject 'self:invalidMessage_(\"jsObject\")')\r\n#(ownPropertyNames '\r\n\tlocal result = smalltalk.Array:new()\r\n\tfor k,_ in pairs(self[\"@handle\"]) do\r\n\t\tresult:add_(k)\r\n\tend\r\n\tif true then return result end')\r\n))\r\n#(NativeHandle #(\r\n#(hasOwnProperty: 'rawget(self[\"@handle\"],aName)~=nil')\r\n#(delete: 'self[\"@handle\"][aName]=nil')\r\n))\r\n#('NativeLibraryObject class' #(\r\n#(basicLoad: 'require(url)')\r\n))\r\n#(NativeLibraryObject  #(\r\n#(newHandleOf: 'result = aConstructor()')\r\n#(newHandleOf:with: 'result = aConstructor(arg1)')\r\n#(newHandleOf:with:with: 'result = aConstructor(arg1,arg2)')\r\n#(newHandleOf:with:with:with: 'result = aConstructor(arg1,arg2,arg3)')\r\n#(newHandleOf:with:with:with:with: 'result = aConstructor(arg1,arg2,arg3,arg4)')\r\n#(newHandleOf:with:with:with:with:with: 'result = aConstructor(arg1,arg2,arg3,arg4,arg5)')\r\n#(newHandleOf:with:with:with:with:with:with: 'result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6)')\r\n#(newHandleOf:with:with:with:with:with:with:with: 'result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7)')\r\n#(newHandleOf:with:with:with:with:with:with:with:with: 'result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)')\r\n))\r\n#(Array #(\r\n#(addAllLua: 'for _,value in pairs(natives) do self:add_(value) end')\r\n))\r\n#('Array class' #(\r\n#(@@ 'self')\r\n#(@ 'result:addAllLua_(natives)')\r\n))\r\n#('Boolean class' #(\r\n#(@ '\r\n\tif (aBOOL==true) then return true end\r\n\tif (aBOOL==1) then return true end\r\n\tif (aBOOL==false) then return false end\r\n\tif (aBOOL+0==1) then return true end')\r\n))\r\n\t) ","function(self)\r\nreturn (smalltalk:newArray({smalltalk:newArray({\"NativeObject class\", smalltalk:newArray({smalltalk:newArray({\"undefined\", \"nil\"}), smalltalk:newArray({\"codeToNumber\", \"\\\" \\\"\"})})}), smalltalk:newArray({\"NativeObject\", smalltalk:newArray({smalltalk:newArray({\"jsObject\", \"self:invalidMessage_(\\\"jsObject\\\")\"}), smalltalk:newArray({\"ownPropertyNames\", \"\\r\\n\\tlocal result = smalltalk.Array:new()\\r\\n\\tfor k,_ in pairs(self[\\\"@handle\\\"]) do\\r\\n\\t\\tresult:add_(k)\\r\\n\\tend\\r\\n\\tif true then return result end\"})})}), smalltalk:newArray({\"NativeHandle\", smalltalk:newArray({smalltalk:newArray({\"hasOwnProperty:\", \"rawget(self[\\\"@handle\\\"],aName)~=nil\"}), smalltalk:newArray({\"delete:\", \"self[\\\"@handle\\\"][aName]=nil\"})})}), smalltalk:newArray({\"NativeLibraryObject class\", smalltalk:newArray({smalltalk:newArray({\"basicLoad:\", \"require(url)\"})})}), smalltalk:newArray({\"NativeLibraryObject\", smalltalk:newArray({smalltalk:newArray({\"newHandleOf:\", \"result = aConstructor()\"}), smalltalk:newArray({\"newHandleOf:with:\", \"result = aConstructor(arg1)\"}), smalltalk:newArray({\"newHandleOf:with:with:\", \"result = aConstructor(arg1,arg2)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:\", \"result = aConstructor(arg1,arg2,arg3)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:with:\", \"result = aConstructor(arg1,arg2,arg3,arg4)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:with:with:\", \"result = aConstructor(arg1,arg2,arg3,arg4,arg5)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:with:with:with:\", \"result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:with:with:with:with:\", \"result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7)\"}), smalltalk:newArray({\"newHandleOf:with:with:with:with:with:with:with:with:\", \"result = aConstructor(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)\"})})}), smalltalk:newArray({\"Array\", smalltalk:newArray({smalltalk:newArray({\"addAllLua:\", \"for _,value in pairs(natives) do self:add_(value) end\"})})}), smalltalk:newArray({\"Array class\", smalltalk:newArray({smalltalk:newArray({\"@@\", \"self\"}), smalltalk:newArray({\"@\", \"result:addAllLua_(natives)\"})})}), smalltalk:newArray({\"Boolean class\", smalltalk:newArray({smalltalk:newArray({\"@\", \"\\r\\n\\tif (aBOOL==true) then return true end\\r\\n\\tif (aBOOL==1) then return true end\\r\\n\\tif (aBOOL==false) then return false end\\r\\n\\tif (aBOOL+0==1) then return true end\"})})})}));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder["$klass"],"initializeToolsInlines:",0
,function(self,pool)
return ((self):register_into_((self):toolsInlines(),pool));
end
,"inlines","initializeToolsInlines: pool\r\n\t\" Private - Initialize the inlines for methods in the category. \"\r\n\r\n\t^self register: self toolsInlines into: pool ","function(self,pool)\r\nreturn ((self):register_into_((self):toolsInlines(),pool));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder["$klass"],"toolsInlines",0
,function(self)
return (smalltalk:newArray({smalltalk:newArray({"NativeReader", smalltalk:newArray({smalltalk:newArray({"initializeObject", "{}"})})}), smalltalk:newArray({"String", smalltalk:newArray({smalltalk:newArray({"asComment", smalltalk:newArray({"\"--[[ \"", "\" --]]\"", "\"-- \""})})})}), smalltalk:newArray({"MethodReferences", smalltalk:newArray({smalltalk:newArray({"dot", "\":\""}), smalltalk:newArray({"localDef", "\"local \""}), smalltalk:newArray({"superSendPatternOf:", "self:superLuaSendPatternOf_(aSelector)"}), smalltalk:newArray({"compiledSourceStart", "\"(\""})})}), smalltalk:newArray({"Class", smalltalk:newArray({smalltalk:newArray({"hackDNU", "self:notImplementedYet_(\"hackDNU\")"})})})}));
end
,"inlines","toolsInlines\r\n\t\" Private - Return the inlines for methods in the category. \"\r\n\r\n\t^#(\r\n#(NativeReader #(\r\n#(initializeObject '{}')\r\n))\r\n#(String  #(\r\n#(asComment #('\"--[[ \"' '\" --]]\"' '\"-- \"'))\r\n))\r\n#(MethodReferences #(\r\n#(dot\t\t'\":\"')\r\n#(localDef\t'\"local \"')\r\n#(superSendPatternOf:\t'self:superLuaSendPatternOf_(aSelector)')\r\n#(compiledSourceStart\t'\"(\"')\r\n))\r\n#(Class #(\r\n#(hackDNU 'self:notImplementedYet_(\"hackDNU\")')\r\n))\r\n\t) ","function(self)\r\nreturn (smalltalk:newArray({smalltalk:newArray({\"NativeReader\", smalltalk:newArray({smalltalk:newArray({\"initializeObject\", \"{}\"})})}), smalltalk:newArray({\"String\", smalltalk:newArray({smalltalk:newArray({\"asComment\", smalltalk:newArray({\"\\\"--[[ \\\"\", \"\\\" --]]\\\"\", \"\\\"-- \\\"\"})})})}), smalltalk:newArray({\"MethodReferences\", smalltalk:newArray({smalltalk:newArray({\"dot\", \"\\\":\\\"\"}), smalltalk:newArray({\"localDef\", \"\\\"local \\\"\"}), smalltalk:newArray({\"superSendPatternOf:\", \"self:superLuaSendPatternOf_(aSelector)\"}), smalltalk:newArray({\"compiledSourceStart\", \"\\\"(\\\"\"})})}), smalltalk:newArray({\"Class\", smalltalk:newArray({smalltalk:newArray({\"hackDNU\", \"self:notImplementedYet_(\\\"hackDNU\\\")\"})})})}));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder["$klass"],"initializeSnapshotInlines:",0
,function(self,pool)
return ((self):register_into_((self):snapshotInlines(),pool));
end
,"inlines","initializeSnapshotInlines: pool\r\n\t\" Private - Initialize the inlines for methods in the category. \"\r\n\r\n\t^self register: self snapshotInlines into: pool ","function(self,pool)\r\nreturn ((self):register_into_((self):snapshotInlines(),pool));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder["$klass"],"snapshotInlines",0
,function(self)
return (smalltalk:newArray({smalltalk:newArray({"Smalltalk", smalltalk:newArray({smalltalk:newArray({"exit", "quit()"})})}), smalltalk:newArray({"Snapshot", smalltalk:newArray({smalltalk:newArray({"bootHeader", "[[smalltalk = (function() \r\n]]"}), smalltalk:newArray({"bootFooter", "[[\r\nend)()\r\n]]"}), smalltalk:newArray({"launchExpression", "\"%:launchImage%()\""})})})}));
end
,"inlines","snapshotInlines\r\n\t\" Private - Return the inlines for methods in the category. \"\r\n\r\n\t^#(\r\n#(Smalltalk #(\r\n#(exit\t'quit()')\r\n))\r\n#(Snapshot #(\r\n#(bootHeader '[[smalltalk = (function() \r\n]]')\r\n#(bootFooter '[[\r\nend)()\r\n]]')\r\n#(launchExpression '\"%:launchImage%()\"')\r\n))\r\n\t) ","function(self)\r\nreturn (smalltalk:newArray({smalltalk:newArray({\"Smalltalk\", smalltalk:newArray({smalltalk:newArray({\"exit\", \"quit()\"})})}), smalltalk:newArray({\"Snapshot\", smalltalk:newArray({smalltalk:newArray({\"bootHeader\", \"[[smalltalk = (function() \\r\\n]]\"}), smalltalk:newArray({\"bootFooter\", \"[[\\r\\nend)()\\r\\n]]\"}), smalltalk:newArray({\"launchExpression\", \"\\\"%:launchImage%()\\\"\"})})})}));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder["$klass"],"initializeOtherInlines:",0
,function(self,pool)
return ((self):register_into_((self):otherInlines(),pool));
end
,"inlines","initializeOtherInlines: pool\r\n\t\" Private - Initialize the inlines for methods in the category. \"\r\n\r\n\t^self register: self otherInlines into: pool ","function(self,pool)\r\nreturn ((self):register_into_((self):otherInlines(),pool));\r\nend")

smalltalk:bind(smalltalk.LuaEncoder["$klass"],"otherInlines",0
,function(self)
return (smalltalk:newArray({}));
end
,"inlines","otherInlines\r\n\t\" Private - Return the inlines for methods in the category. \"\r\n\r\n\t^#(\r\n\"#(ClassName #(\r\n#(selector '...')\r\n))\"\r\n\t) ","function(self)\r\nreturn (smalltalk:newArray({}));\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"reservedLuaWords",0
,function(self)
return (smalltalk:newArray({"and", "break", "do", "else", "elseif", "end", "false", "for", "function", "if", "in", "local", "nil", "not", "or", "repeat", "return", "then", "true", "until", "while"}));
end
,"Lua-lua","reservedLuaWords\r\n\t\" Private - Return the reserved names of Lua language. \"\r\n\r\n\t^#(\r\n\tand\tbreak\tdo\telse\telseif\r\n\tend\t#false\tfor\tfunction\tif\r\n\tin\tlocal\t#nil\tnot\tor\r\n\trepeat\treturn\tthen\t#true\tuntil\r\n\twhile\r\n\t)","function(self)\r\nreturn (smalltalk:newArray({\"and\", \"break\", \"do\", \"else\", \"elseif\", \"end\", \"false\", \"for\", \"function\", \"if\", \"in\", \"local\", \"nil\", \"not\", \"or\", \"repeat\", \"return\", \"then\", \"true\", \"until\", \"while\"}));\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"forbiddenLuaSelectors",0
,function(self)
return (smalltalk:newArray({}));
end
,"Lua-lua","forbiddenLuaSelectors\r\n\t\" Private - Return the platform forbidden selectors. \"\r\n\r\n\t^#( \"class new\" )","function(self)\r\nreturn (smalltalk:newArray({}));\r\nend")

smalltalk:bind(smalltalk.String,"asLuaName",0
,function(self)
if (smalltalk:isObject_equalTo_(((self):first()),"_"))==true then return (self); end;
if (((smalltalk.String):reservedLuaWords()):includes_(self))==true then return (smalltalk:object_comma_(("__"),self)); end;
return (self);
end
,"Lua-lua","asLuaName\r\n\t\" Private - Return the receiver as a valid Lua name. \"\r\n\r\n\tself first = $_ ifTrue: [ ^self ].\r\n\t(String reservedLuaWords includes: self) ifTrue: [ ^'__',self ].\r\n\t^self","function(self)\r\nif (smalltalk:isObject_equalTo_(((self):first()),\"_\"))==true then return (self); end;\r\nif (((smalltalk.String):reservedLuaWords()):includes_(self))==true then return (smalltalk:object_comma_((\"__\"),self)); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.String,"asLuaSelector",0
,function(self)
if (((smalltalk.String):forbiddenLuaSelectors()):includes_(self))==true then return (smalltalk:object_comma_(("_"),self)); end;
if ((self):startsWith_("#"))==true then return ((self):upTo_startingAt_(":",2)); end;
return (((self):asPrivateSelector()):asLuaName());
end
,"Lua-lua","asLuaSelector\r\n\t\" Private - Return the receiver as a valid native selector. \"\r\n\r\n\t(String forbiddenLuaSelectors includes: self) ifTrue: [ ^$_ ,self ].\r\n\t(self startsWith: $#) ifTrue: [\r\n\t\t^self upTo: $: startingAt: 2\r\n\t].\r\n\t^self asPrivateSelector asLuaName ","function(self)\r\nif (((smalltalk.String):forbiddenLuaSelectors()):includes_(self))==true then return (smalltalk:object_comma_((\"_\"),self)); end;\r\nif ((self):startsWith_(\"#\"))==true then return ((self):upTo_startingAt_(\":\",2)); end;\r\nreturn (((self):asPrivateSelector()):asLuaName());\r\nend")

smalltalk:bind(smalltalk.Object,"asLua",0
,function(self)
return (smalltalk:asString_((self)));
end
,"Lua-lua","asLua\r\n\t\" Return the native representation of the receiver.\r\n\tThe default implementation return the receiver as a String.\r\n\tThis method must be refined by subclasses implementing native literal representation.\r\n\t\"\r\n\r\n\t^self asString","function(self)\r\nreturn (smalltalk:asString_((self)));\r\nend")

smalltalk:bind(smalltalk.Number,"asLua",0
,function(self)
return (smalltalk:printString_((self)));
end
,"Lua-lua","asLua\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t^self printString ","function(self)\r\nreturn (smalltalk:printString_((self)));\r\nend")

smalltalk:bind(smalltalk.String,"asLua",0
,function(self)
local encoded=nil
local bar=nil
(function()
	local _s8_value=(smalltalk:asCharacter_((92)))
	bar=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(self)
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_(bar,smalltalk:object_comma_((bar),bar)))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_((smalltalk.String):lf(),smalltalk:object_comma_((bar),"n")))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_((smalltalk.String):cr(),smalltalk:object_comma_((bar),"r")))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_((smalltalk.String):tab(),smalltalk:object_comma_((bar),"t")))
	encoded=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((encoded):replace_with_("\"",smalltalk:object_comma_((bar),"\"")))
	encoded=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_(("\""),encoded)),"\""));
end
,"Lua-lua","asLua\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t| encoded bar |\r\n\tbar := 92 asCharacter.\r\n\tencoded := self.\r\n\tencoded := encoded replace: bar with: bar ,bar.\r\n\tencoded := encoded replace: String lf with: bar ,$n.\r\n\tencoded := encoded replace: String cr with: bar ,$r.\r\n\tencoded := encoded replace: String tab with: bar ,$t.\r\n\tencoded := encoded replace: $\" with: bar ,$\".\r\n\t^$\" ,encoded ,$\"","function(self)\r\nlocal encoded=nil\r\nlocal bar=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:asCharacter_((92)))\r\n\tbar=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(self)\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_(bar,smalltalk:object_comma_((bar),bar)))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_((smalltalk.String):lf(),smalltalk:object_comma_((bar),\"n\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_((smalltalk.String):cr(),smalltalk:object_comma_((bar),\"r\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_((smalltalk.String):tab(),smalltalk:object_comma_((bar),\"t\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((encoded):replace_with_(\"\\\"\",smalltalk:object_comma_((bar),\"\\\"\")))\r\n\tencoded=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),encoded)),\"\\\"\"));\r\nend")

smalltalk:bind(smalltalk.Array,"asLua",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk:newArray"),"(")),"{")),((self):collect_((function(each)
return ((each):asLua())
end))):join_(", "))),"}")),")"));
end
,"Lua-lua","asLua\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t^'smalltalk:newArray' ,$( ,${\r\n\t\t,((self collect: [:each | each asLua ]) join: ', ')\r\n\t,$} ,$) ","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk:newArray\"),\"(\")),\"{\")),((self):collect_((function(each)\r\nreturn ((each):asLua())\r\nend))):join_(\", \"))),\"}\")),\")\"));\r\nend")

smalltalk:bind(smalltalk.Set,"asLua",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),((self)["$klass"]):name())),":newContents_(")),(self["@contents"]):asLua())),")"));
end
,"Lua-lua","asLua\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t^'smalltalk.' ,self class name\r\n\t, ':newContents_('\r\n\t\t, contents asLua\r\n\t,')'","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),((self)[\"$klass\"]):name())),\":newContents_(\")),(self[\"@contents\"]):asLua())),\")\"));\r\nend")

smalltalk:bind(smalltalk.Dictionary,"asLua",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),((self)["$klass"]):name())),":fromKeys_and_(")),((self["@keys"]):asArray()):asLua())),",")),(self["@values"]):asLua())),")"));
end
,"Lua-lua","asLua\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t^'smalltalk.' ,self class name\r\n\t, ':fromKeys_and_('\r\n\t\t, keys asArray asLua\r\n\t\t,',' ,values asLua\r\n\t,')'","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),((self)[\"$klass\"]):name())),\":fromKeys_and_(\")),((self[\"@keys\"]):asArray()):asLua())),\",\")),(self[\"@values\"]):asLua())),\")\"));\r\nend")

smalltalk:bind(smalltalk.PoolDictionary,"asLua",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("smalltalk."),((self)["$klass"]):name())),":fromTuples_(")),((self):tuples()):asLua())),")"));
end
,"Lua-lua","asLua\r\n\t\" Return the native representation of the receiver. \"\r\n\r\n\t^'smalltalk.',self class name\r\n\t, ':fromTuples_('\r\n\t\t, self tuples asLua\r\n\t,')'","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"smalltalk.\"),((self)[\"$klass\"]):name())),\":fromTuples_(\")),((self):tuples()):asLua())),\")\"));\r\nend")

smalltalk:bind(smalltalk.Object,"__tostring",0
,function(self)
return (smalltalk:toString_((self)));
end
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","function(self)\r\nreturn (smalltalk:toString_((self)));\r\nend")

smalltalk:bind(smalltalk.CompiledMethod,"__tostring",0
,function(self)
return (smalltalk:toString_((self)));
end
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","function(self)\r\nreturn (smalltalk:toString_((self)));\r\nend")

smalltalk:bind(smalltalk.Behavior,"__tostring",0
,function(self)
return (smalltalk:toString_((self)));
end
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","function(self)\r\nreturn (smalltalk:toString_((self)));\r\nend")

smalltalk:bind(smalltalk.Association,"__tostring",0
,function(self)
return (smalltalk:toString_((self)));
end
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","function(self)\r\nreturn (smalltalk:toString_((self)));\r\nend")

smalltalk:bind(smalltalk.Point,"__tostring",0
,function(self)
return (smalltalk:toString_((self)));
end
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","function(self)\r\nreturn (smalltalk:toString_((self)));\r\nend")

smalltalk:bind(smalltalk.Exception,"__tostring",0
,function(self)
return (smalltalk:toString_((self)));
end
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","function(self)\r\nreturn (smalltalk:toString_((self)));\r\nend")

smalltalk:bind(smalltalk.Interval,"__tostring",0
,function(self)
return (smalltalk:toString_((self)));
end
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","function(self)\r\nreturn (smalltalk:toString_((self)));\r\nend")

smalltalk:bind(smalltalk.Set,"__tostring",0
,function(self)
return (smalltalk:toString_((self)));
end
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","function(self)\r\nreturn (smalltalk:toString_((self)));\r\nend")

smalltalk:bind(smalltalk.Rectangle,"__tostring",0
,function(self)
return (smalltalk:toString_((self)));
end
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","function(self)\r\nreturn (smalltalk:toString_((self)));\r\nend")

smalltalk:bind(smalltalk.PPFailure,"__tostring",0
,function(self)
return (smalltalk:toString_((self)));
end
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self toString","function(self)\r\nreturn (smalltalk:toString_((self)));\r\nend")

smalltalk:bind(smalltalk.Array,"__tostring",0
,function(self)
return ((self):asLiteral());
end
,"Lua-printing","__tostring\r\n\t\" Return the printable representation of the receiver. \"\r\n\r\n\t^self asLiteral","function(self)\r\nreturn ((self):asLiteral());\r\nend")

smalltalk:bind(smalltalk.Array,"addAllLua:",0
,function(self,natives)
if (smalltalk:isObject_equalTo_(((self):typeOf_(natives)),"userdata"))==true then local count=nil
(function()
	local _s8_value=((smalltalk.JavaArray):getLength_((smalltalk.Lua):_at(natives)))
	count=_s8_value
	return _s8_value
end)();
(1):to_do_(count,(function(i)
return ((self):add_((((smalltalk.JavaArray):nativeClass()):handle()):get(natives,(i):_minus(1))))
end));
return (self); end;
for _,value in pairs(natives) do self:add_(value) end;
return (self);
end
,"Lua-private","addAllLua: natives\r\n\t\" Private - Add the native values to the receiver. \"\r\n\r\n\t(self typeOf: natives) = #userdata ifTrue: [ | count |\r\n\t\tcount := JavaArray getLength: Lua@natives.\r\n\t\t1 to: count do: [:i|\r\n\t\t\tself add: (JavaArray nativeClass handle\r\n\t\t\t\t#get: natives index: i - 1).\r\n\t\t].\r\n\t\t^self\r\n\t].\r\n\t{''js'self.addAll_(natives)'}.\r\n\t^self","function(self,natives)\r\nif (smalltalk:isObject_equalTo_(((self):typeOf_(natives)),\"userdata\"))==true then local count=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.JavaArray):getLength_((smalltalk.Lua):_at(natives)))\r\n\tcount=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(1):to_do_(count,(function(i)\r\nreturn ((self):add_((((smalltalk.JavaArray):nativeClass()):handle()):get(natives,(i):_minus(1))))\r\nend));\r\nreturn (self); end;\r\nfor _,value in pairs(natives) do self:add_(value) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildLuaFunctions:",0
,function(self,specs)
(self):buildNativeFunctions_(specs);
return (self);
end
,"Lua-builders","buildLuaFunctions: specs\r\n\t\" OBSOLETE - Generate code from specs as raw functions implemented by instance handle. \"\r\n\r\n\tself buildNativeFunctions: specs","function(self,specs)\r\n(self):buildNativeFunctions_(specs);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildLuaStaticFunctions:",0
,function(self,specs)
(self):buildNativeStaticFunctions_(specs);
return (self);
end
,"Lua-builders","buildLuaStaticFunctions: specs\r\n\t\" OBSOLETE - Generate code from specs as raw functions implemented by class handle. \"\r\n\r\n\tself buildNativeStaticFunctions: specs","function(self,specs)\r\n(self):buildNativeStaticFunctions_(specs);\r\nreturn (self);\r\nend")

smalltalk:addClass("Lua",smalltalk.NativeHandle,smalltalk:newArray({}),"Lua")
smalltalk.Lua["$comment"]="\r\n\tImplementation of wrappers to native Lua objects.\r\n\t@2011 Alejandro F. Reimondo\r\n\taleReimondo@smalltalking.net"

smalltalk:bind(smalltalk.Lua["$klass"],"supportsLanguage:",0
,function(self,language)
return (smalltalk:isObject_equalTo_((language),"lua"));
end
,"instantiation","supportsLanguage: language\r\n\t\" Private - Return true if instances of the receiver implement native wrappers for language. \"\r\n\r\n\t^language = #lua","function(self,language)\r\nreturn (smalltalk:isObject_equalTo_((language),\"lua\"));\r\nend")

smalltalk:bind(smalltalk.Lua,"propertyNames",0
,function(self)
return ((self):ownPropertyNames());
end
,"accessing","propertyNames\r\n\t\" Return the property names of the receiver. \"\r\n\r\n\t^self ownPropertyNames","function(self)\r\nreturn ((self):ownPropertyNames());\r\nend")

smalltalk:bind(smalltalk.Lua["$klass"],"global",0
,function(self)
return ((self):_at((smalltalk.Smalltalk):global()));
end
,"accessing","global\r\n\t\" Return an instance wrapping global. \"\r\n\r\n\t^self @ Smalltalk global","function(self)\r\nreturn ((self):_at((smalltalk.Smalltalk):global()));\r\nend")

smalltalk:bind(smalltalk.Lua["$klass"],"version",0
,function(self)
return (((self):global()):_at("_VERSION"));
end
,"accessing","version\r\n\t\" Return the host version. \"\r\n\r\n\t^self global @ #_VERSION","function(self)\r\nreturn (((self):global()):_at(\"_VERSION\"));\r\nend")

smalltalk:bind(smalltalk.Lua["$klass"],"arg",0
,function(self)
return ((smalltalk.Array):_at(((self):global()):_at("arg")));
end
,"accessing","arg\r\n\t\" Return the main arguments (anArray of strings). \"\r\n\r\n\t^Array @ (self global @ #arg)","function(self)\r\nreturn ((smalltalk.Array):_at(((self):global()):_at(\"arg\")));\r\nend")

smalltalk:bind(smalltalk.Lua["$klass"],"require:",0
,function(self,aName)
return ((self):_at(require(aName)));
end
,"modules","require: aName\r\n\t\" Return an instance of the receiver obtained from loading module aName. (or nil) \"\r\n\r\n\t^self @ (# #require: aName)","function(self,aName)\r\nreturn ((self):_at(require(aName)));\r\nend")

smalltalk:bind(smalltalk.Lua,"do:",0
,function(self,aBlock)
	for item in self:handle() do aBlock(item) end;
return (self);
end
,"iteration","do: aBlock\r\n\t\" Evaluates aBlock on each element of the receiver. \"\r\n\r\n{''js'\tself.invalidMessage_(\"do:\")'\r\nlua'\tfor item in self:handle() do aBlock(item) end'}.","function(self,aBlock)\r\n\tfor item in self:handle() do aBlock(item) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Lua,"pairsDo:",0
,function(self,aBlock)
	for k,v in pairs(self:handle()) do aBlock(k,v) end;
return (self);
end
,"iteration","pairsDo: aBlock\r\n\t\" Evaluates aBlock on each key/value pair of the receiver. \"\r\n\r\n{''js'\tself.invalidMessage_(\"pairsDo:\")'\r\nlua'\tfor k,v in pairs(self:handle()) do aBlock(k,v) end'}.","function(self,aBlock)\r\n\tfor k,v in pairs(self:handle()) do aBlock(k,v) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Lua,"keysDo:",0
,function(self,aBlock)
	for k,_ in pairs(self:handle()) do aBlock(k) end;
return (self);
end
,"iteration","keysDo: aBlock\r\n\t\" Evaluates aBlock on each key of the receiver. \"\r\n\r\n{''js'\tself.invalidMessage_(\"keysDo:\")'\r\nlua'\tfor k,_ in pairs(self:handle()) do aBlock(k) end'}.","function(self,aBlock)\r\n\tfor k,_ in pairs(self:handle()) do aBlock(k) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Lua,"valuesDo:",0
,function(self,aBlock)
	for _,v in pairs(self:handle()) do aBlock(k,v) end;
return (self);
end
,"iteration","valuesDo: aBlock\r\n\t\" Evaluates aBlock on each value of the receiver. \"\r\n\r\n{''js'\tself.invalidMessage_(\"valuesDo:\")'\r\nlua'\tfor _,v in pairs(self:handle()) do aBlock(k,v) end'}.","function(self,aBlock)\r\n\tfor _,v in pairs(self:handle()) do aBlock(k,v) end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.MethodReferences,"superLuaSendPatternOf:",0
,function(self,aSelector)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("\""),(aSelector):asSelector())),"\"")),")(self"));
end
,"Tools-patterns","superLuaSendPatternOf: aSelector\r\n\t\" Private - Return the search pattern for senders (to super) of aSelector. \"\r\n\r\n\t^$\" ,aSelector asSelector ,$\" ,')(self'","function(self,aSelector)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"\\\"\"),(aSelector):asSelector())),\"\\\"\")),\")(self\"));\r\nend")

smalltalk:bind(smalltalk.Object,"fileInOBSOLETE:",0
,function(self,fileName)
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_(("fileIn(\""),fileName)),"\");"));
return (fileIn(fileName));
end
,"Lua-fileIn","fileInOBSOLETE: fileName\r\n\t\" FileIn contents of file at fileName. \"\r\n\r\n\tself note: 'fileIn(\"', fileName, '\");'.\r\n\t^# #fileIn: fileName","function(self,fileName)\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((\"fileIn(\\\"\"),fileName)),\"\\\");\"));\r\nreturn (fileIn(fileName));\r\nend")

smalltalk:bind(smalltalk.Object,"fileInJSOBSOLETE:",0
,function(self,fileName)
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_(("fileInJS(\""),fileName)),"\");"));
return (fileInJS(fileName));
end
,"Lua-fileIn","fileInJSOBSOLETE: fileName\r\n\t\" Load native code from file at fileName. \"\r\n\r\n\tself note: 'fileInJS(\"', fileName, '\");'.\r\n\t^# #fileInJS: fileName","function(self,fileName)\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((\"fileInJS(\\\"\"),fileName)),\"\\\");\"));\r\nreturn (fileInJS(fileName));\r\nend")
