
-- fileIn("s8/start/Natives.st")
smalltalk:addClass("NativeObject",smalltalk.Object,smalltalk:newArray({"handle"}),"Natives")
smalltalk.NativeObject["$comment"]="\r\n\tWrapper to native object.\r\n\t@2011 Alejandro F. Reimondo\r\n\taleReimondo@smalltalking.net\r\n"

smalltalk:bind(smalltalk.NativeObject["$klass"],"undefined",0
,function(self)
return (nil);
end
,"constants","undefined\r\n\t\" Private - Return the native representation for undefined. \"\r\n\r\n\t^{''}","function(self)\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"nativeNameFromSelector:",0
,function(self,aSymbol)
return (aSymbol);
end
,"builders","nativeNameFromSelector: aSymbol\r\n\t\" Private - Return the property name for selector aSymbol. \"\r\n\r\n\t^aSymbol","function(self,aSymbol)\r\nreturn (aSymbol);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildGetterCode:",0
,function(self,aSelector)
if (((self):instanceVariableNames()):includes_(aSelector))==true then return (smalltalk:superImplementor(smalltalk.NativeObject["$klass"],"buildGetterCode_")(self,aSelector)); end;
return (smalltalk:object_comma_(("^self handle basicAt: "),((self):nativeNameFromSelector_(aSelector)):asLiteral()));
end
,"builders-private","buildGetterCode: aSelector\r\n\t\" Private - Return source code to get aSelector. \"\r\n\r\n\t(self instanceVariableNames includes: aSelector) ifTrue: [\r\n\t\t^super buildGetterCode: aSelector\r\n\t].\r\n\t^'^self handle basicAt: '\r\n\t\t,(self nativeNameFromSelector: aSelector) asLiteral","function(self,aSelector)\r\nif (((self):instanceVariableNames()):includes_(aSelector))==true then return (smalltalk:superImplementor(smalltalk.NativeObject[\"$klass\"],\"buildGetterCode_\")(self,aSelector)); end;\r\nreturn (smalltalk:object_comma_((\"^self handle basicAt: \"),((self):nativeNameFromSelector_(aSelector)):asLiteral()));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildGetter:",0
,function(self,spec)
if (smalltalk:boolean_or_(((spec):isString()),(function()
return (smalltalk:boolean_and_(((spec):isArray()),(function()
return (smalltalk:isObject_equalTo_(((spec):second()),"initialize"))
end)))
end)))==true then return (smalltalk:superImplementor(smalltalk.NativeObject["$klass"],"buildGetter_")(self,spec)); end;
return ((self):buildTypedGetter_(spec));
end
,"builders","buildGetter: spec\r\n\t\" Build method for getter. \"\r\n\r\n\t(spec isString or: [\r\n\t\tspec isArray and: [\r\n\t\tspec second = #initialize ]]) ifTrue: [\r\n\t\t^super buildGetter: spec\r\n\t].\r\n\t^self buildTypedGetter: spec","function(self,spec)\r\nif (smalltalk:boolean_or_(((spec):isString()),(function()\r\nreturn (smalltalk:boolean_and_(((spec):isArray()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((spec):second()),\"initialize\"))\r\nend)))\r\nend)))==true then return (smalltalk:superImplementor(smalltalk.NativeObject[\"$klass\"],\"buildGetter_\")(self,spec)); end;\r\nreturn ((self):buildTypedGetter_(spec));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSetterCode:",0
,function(self,aSelector)
if (((self):instanceVariableNames()):includes_(aSelector))==true then return (smalltalk:superImplementor(smalltalk.NativeObject["$klass"],"buildSetterCode_")(self,aSelector)); end;
return (smalltalk:object_comma_((smalltalk:object_comma_(("self handle basicAt: "),((self):nativeNameFromSelector_(aSelector)):asLiteral()))," put: anObject"));
end
,"builders-private","buildSetterCode: aSelector\r\n\t\" Private - Return source code to set aSelector. \"\r\n\r\n\t(self instanceVariableNames includes: aSelector) ifTrue: [\r\n\t\t^super buildSetterCode: aSelector\r\n\t].\r\n\t^'self handle basicAt: '\r\n\t\t,(self nativeNameFromSelector: aSelector) asLiteral\r\n\t\t, ' put: anObject'","function(self,aSelector)\r\nif (((self):instanceVariableNames()):includes_(aSelector))==true then return (smalltalk:superImplementor(smalltalk.NativeObject[\"$klass\"],\"buildSetterCode_\")(self,aSelector)); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"self handle basicAt: \"),((self):nativeNameFromSelector_(aSelector)):asLiteral())),\" put: anObject\"));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSetter:",0
,function(self,spec)
if (smalltalk:boolean_or_(((spec):isString()),(function()
return (smalltalk:boolean_and_(((spec):isArray()),(function()
return (smalltalk:isObject_equalTo_(((spec):second()),"initialize"))
end)))
end)))==true then return (smalltalk:superImplementor(smalltalk.NativeObject["$klass"],"buildSetter_")(self,spec)); end;
return ((self):buildTypedSetter_(spec));
end
,"builders","buildSetter: spec\r\n\t\" Private - Return source code for setter. \"\r\n\r\n\t(spec isString or: [\r\n\t\tspec isArray and: [\r\n\t\tspec second = #initialize ]]) ifTrue: [\r\n\t\t^super buildSetter: spec\r\n\t].\r\n\t^self buildTypedSetter: spec","function(self,spec)\r\nif (smalltalk:boolean_or_(((spec):isString()),(function()\r\nreturn (smalltalk:boolean_and_(((spec):isArray()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((spec):second()),\"initialize\"))\r\nend)))\r\nend)))==true then return (smalltalk:superImplementor(smalltalk.NativeObject[\"$klass\"],\"buildSetter_\")(self,spec)); end;\r\nreturn ((self):buildTypedSetter_(spec));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildTypedGetter:",0
,function(self,tuple)
if ((tuple):isString())==true then return ((self):buildGetter_(tuple)); end;
return ((self):build_doing_(("TypedGetter"):_minus_gt(tuple),(function()
return ((self):implement_comment_as_category_((self):stMessageHeader_((tuple):first()),smalltalk:object_comma_((smalltalk:object_comma_(("Return the "),(tuple):first()))," of the receiver."),smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):apiPrologueFor_((tuple):last())),"self handle basicAt: ")),((self):nativeNameFromSelector_((tuple):first())):asLiteral())),(self):apiEpilogueFor_((tuple):last())),"accessing"))
end)));
end
,"builders","buildTypedGetter: tuple\r\n\t\" Build (instance) method to get property from spec array. \"\r\n\r\n\ttuple isString ifTrue: [ ^self buildGetter: tuple ].\r\n\t^self build: #TypedGetter -> tuple doing: [\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: tuple first)\r\n\t\t\tcomment: 'Return the ' ,tuple first ,' of the receiver.'\r\n\t\t\tas: \t (self apiPrologueFor: tuple last)\r\n\t\t\t\t,'self handle basicAt: '\r\n\t\t\t\t,(self nativeNameFromSelector: tuple first) asLiteral\r\n\t\t\t\t,(self apiEpilogueFor: tuple last)\r\n\t\t\tcategory: #accessing\r\n\t]","function(self,tuple)\r\nif ((tuple):isString())==true then return ((self):buildGetter_(tuple)); end;\r\nreturn ((self):build_doing_((\"TypedGetter\"):_minus_gt(tuple),(function()\r\nreturn ((self):implement_comment_as_category_((self):stMessageHeader_((tuple):first()),smalltalk:object_comma_((smalltalk:object_comma_((\"Return the \"),(tuple):first())),\" of the receiver.\"),smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((self):apiPrologueFor_((tuple):last())),\"self handle basicAt: \")),((self):nativeNameFromSelector_((tuple):first())):asLiteral())),(self):apiEpilogueFor_((tuple):last())),\"accessing\"))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildTypedSetter:",0
,function(self,tuple)
if ((tuple):isString())==true then return ((self):buildSetter_(tuple)); end;
return ((self):build_doing_(("TypedSetter"):_minus_gt(tuple),(function()
return ((self):implement_comment_as_category_((self):stMessageHeader_(smalltalk:object_comma_(((tuple):first()),": anObject")),smalltalk:object_comma_((smalltalk:object_comma_(("Set the "),(tuple):first()))," of the receiver."),smalltalk:object_comma_((smalltalk:object_comma_(("self handle basicAt: "),((self):nativeNameFromSelector_((tuple):first())):asLiteral()))," put: anObject handle"),"accessing"))
end)));
end
,"builders","buildTypedSetter: tuple\r\n\t\" Build (instance) method to set property to spec array. \"\r\n\r\n\ttuple isString ifTrue: [ ^self buildSetter: tuple ].\r\n\t^self build: #TypedSetter -> tuple doing: [\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: tuple first , ': anObject')\r\n\t\t\tcomment: 'Set the ' ,tuple first ,' of the receiver.'\r\n\t\t\tas: 'self handle basicAt: '\r\n\t\t\t\t,(self nativeNameFromSelector: tuple first) asLiteral\r\n\t\t\t\t,' put: anObject handle'\r\n\t\t\tcategory: #accessing\r\n\t]","function(self,tuple)\r\nif ((tuple):isString())==true then return ((self):buildSetter_(tuple)); end;\r\nreturn ((self):build_doing_((\"TypedSetter\"):_minus_gt(tuple),(function()\r\nreturn ((self):implement_comment_as_category_((self):stMessageHeader_(smalltalk:object_comma_(((tuple):first()),\": anObject\")),smalltalk:object_comma_((smalltalk:object_comma_((\"Set the \"),(tuple):first())),\" of the receiver.\"),smalltalk:object_comma_((smalltalk:object_comma_((\"self handle basicAt: \"),((self):nativeNameFromSelector_((tuple):first())):asLiteral())),\" put: anObject handle\"),\"accessing\"))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildTypedGetters:",0
,function(self,specs)
return ((self):build_doing_(("TypedGetters"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildTypedGetter_(each))
end)))
end)));
end
,"builders","buildTypedGetters: specs\r\n\t\" Build (instance) methods to get properties. \"\r\n\r\n\t^self build: #TypedGetters -> specs doing: [\r\n\t\tspecs compose: [:each| self buildTypedGetter: each ]\r\n\t]","function(self,specs)\r\nreturn ((self):build_doing_((\"TypedGetters\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildTypedGetter_(each))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildTypedAccessors:",0
,function(self,tuples)
return ((self):build_doing_(("TypedAccessors"):_minus_gt(tuples),(function()
return ((tuples):compose_((function(each)
return (smalltalk:object_comma_(((self):buildTypedGetter_(each)),(self):buildTypedSetter_(each)))
end)))
end)));
end
,"builders","buildTypedAccessors: tuples\r\n\t\" Build (instance) methods to get/set property from/to tuples. \"\r\n\t\r\n\t^self build: #TypedAccessors -> tuples doing: [\r\n\t\ttuples compose: [:each|\r\n\t\t\t(self buildTypedGetter: each)\r\n\t\t\t,(self buildTypedSetter: each)\r\n\t\t]\r\n\t]","function(self,tuples)\r\nreturn ((self):build_doing_((\"TypedAccessors\"):_minus_gt(tuples),(function()\r\nreturn ((tuples):compose_((function(each)\r\nreturn (smalltalk:object_comma_(((self):buildTypedGetter_(each)),(self):buildTypedSetter_(each)))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFastGetter:",0
,function(self,aSelector)
local type=nil
local jsName=nil
if ((aSelector):isString())==true then (function()
	local _s8_value=("")
	type=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):nativeNameFromSelector_(aSelector))
	jsName=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=((aSelector):last())
	type=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):nativeNameFromSelector_((aSelector):first()))
	jsName=_s8_value
	return _s8_value
end)(); end;
return ((self):build_doing_(("FastGetter"):_minus_gt(aSelector),(function()
return ((self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_(("Return the "),aSelector))," of the receiver."),smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("^"),type)),"handle#")),jsName),"accessing"))
end)));
end
,"builders","buildFastGetter: aSelector\r\n\t\" Build (instance) method to get native property. \"\r\n\r\n\t| type jsName |\r\n\taSelector isString\r\n\t\tifTrue: [ type := ''. jsName := self nativeNameFromSelector: aSelector ]\r\n\t\tifFalse: [ type := aSelector last. jsName := self nativeNameFromSelector: aSelector first ].\r\n\t^self build: #FastGetter -> aSelector doing: [\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: aSelector)\r\n\t\t\tcomment: 'Return the ' ,aSelector ,' of the receiver.'\r\n\t\t\tas: '^' ,type ,'handle#' ,jsName category: #accessing\r\n\t]","function(self,aSelector)\r\nlocal type=nil\r\nlocal jsName=nil\r\nif ((aSelector):isString())==true then (function()\r\n\tlocal _s8_value=(\"\")\r\n\ttype=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):nativeNameFromSelector_(aSelector))\r\n\tjsName=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=((aSelector):last())\r\n\ttype=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):nativeNameFromSelector_((aSelector):first()))\r\n\tjsName=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((self):build_doing_((\"FastGetter\"):_minus_gt(aSelector),(function()\r\nreturn ((self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_((\"Return the \"),aSelector)),\" of the receiver.\"),smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"^\"),type)),\"handle#\")),jsName),\"accessing\"))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFastSetter:",0
,function(self,aSelector)
local jsName=nil
if ((aSelector):isString())==true then (function()
	local _s8_value=((self):nativeNameFromSelector_(aSelector))
	jsName=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=((self):nativeNameFromSelector_((aSelector):first()))
	jsName=_s8_value
	return _s8_value
end)(); end;
return ((self):build_doing_(("FastSetter"):_minus_gt(aSelector),(function()
return ((self):implement_comment_as_category_(smalltalk:object_comma_(((self):stMessageHeader_(aSelector)),": anObject"),smalltalk:object_comma_((smalltalk:object_comma_(("Set the "),aSelector))," of the receiver."),smalltalk:object_comma_((smalltalk:object_comma_(("handle#"),jsName))," := anObject"),"accessing"))
end)));
end
,"builders","buildFastSetter: aSelector\r\n\t\" Build (instance) method to set native property. \"\r\n\r\n\t| jsName |\r\n\taSelector isString\r\n\t\tifTrue: [ jsName := self nativeNameFromSelector: aSelector ]\r\n\t\tifFalse: [ jsName := self nativeNameFromSelector: aSelector first ].\r\n\t^self build: #FastSetter -> aSelector doing: [\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: aSelector) ,': anObject'\r\n\t\t\tcomment: 'Set the ' ,aSelector ,' of the receiver.'\r\n\t\t\tas: 'handle#' ,jsName ,' := anObject' category: #accessing\r\n\t]","function(self,aSelector)\r\nlocal jsName=nil\r\nif ((aSelector):isString())==true then (function()\r\n\tlocal _s8_value=((self):nativeNameFromSelector_(aSelector))\r\n\tjsName=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=((self):nativeNameFromSelector_((aSelector):first()))\r\n\tjsName=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((self):build_doing_((\"FastSetter\"):_minus_gt(aSelector),(function()\r\nreturn ((self):implement_comment_as_category_(smalltalk:object_comma_(((self):stMessageHeader_(aSelector)),\": anObject\"),smalltalk:object_comma_((smalltalk:object_comma_((\"Set the \"),aSelector)),\" of the receiver.\"),smalltalk:object_comma_((smalltalk:object_comma_((\"handle#\"),jsName)),\" := anObject\"),\"accessing\"))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFastAccessor:",0
,function(self,accessor)
if ((accessor):isString())==true then return ((self):build_doing_(("FastAccessor"):_minus_gt(accessor),(function()
return (smalltalk:object_comma_(((self):buildFastGetter_(accessor)),(self):buildFastSetter_(accessor)))
end))); end;
return ((self):error_("Invalid (Fast)accessors."));
end
,"builders","buildFastAccessor: accessor\r\n\t\" Build (instance) method to access native property. \"\r\n\r\n\taccessor isString ifTrue: [\r\n\t\t^self build: #FastAccessor -> accessor doing: [\r\n\t\t\t(self buildFastGetter: accessor)\r\n\t\t\t,(self buildFastSetter: accessor)\r\n\t\t]\r\n\t].\r\n\t^self error: 'Invalid (Fast)accessors.'","function(self,accessor)\r\nif ((accessor):isString())==true then return ((self):build_doing_((\"FastAccessor\"):_minus_gt(accessor),(function()\r\nreturn (smalltalk:object_comma_(((self):buildFastGetter_(accessor)),(self):buildFastSetter_(accessor)))\r\nend))); end;\r\nreturn ((self):error_(\"Invalid (Fast)accessors.\"));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFastGetters:",0
,function(self,specs)
if ((specs):isString())==true then return ((self):buildFastGetters_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("FastGetters"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildFastGetter_(each))
end)))
end)));
end
,"builders","buildFastGetters: specs\r\n\t\" Build methods to get properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildFastGetters: specs asArrayOfSubstrings ].\r\n\t^self build: #FastGetters -> specs doing: [\r\n\t\tspecs compose: [:each| self buildFastGetter: each ]\r\n\t]","function(self,specs)\r\nif ((specs):isString())==true then return ((self):buildFastGetters_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"FastGetters\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildFastGetter_(each))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFastAccessors:",0
,function(self,specs)
if ((specs):isString())==true then return ((self):buildFastAccessors_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("FastAccessors"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildFastAccessor_(each))
end)))
end)));
end
,"builders","buildFastAccessors: specs\r\n\t\" Build methods to access properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildFastAccessors: specs asArrayOfSubstrings ].\r\n\t^self build: #FastAccessors -> specs doing: [\r\n\t\tspecs compose: [:each| self buildFastAccessor: each ]\r\n\t]","function(self,specs)\r\nif ((specs):isString())==true then return ((self):buildFastAccessors_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"FastAccessors\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildFastAccessor_(each))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"codeToNumber",0
,function(self)
return (" ");
end
,"constants","codeToNumber\r\n\t\" Private - Return the code to transform value to a number. \"\r\n\r\n\t^{''}","function(self)\r\nreturn (\" \");\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"handleAt:",0
,function(self,aSelector)
return (smalltalk:object_comma_(("handle#"),(self):nativeNameFromSelector_(aSelector)));
end
,"constants","handleAt: aSelector\r\n\t\" Private - Return the code for accessing instance handle. \"\r\n\r\n\t^'handle#' ,(self nativeNameFromSelector: aSelector)","function(self,aSelector)\r\nreturn (smalltalk:object_comma_((\"handle#\"),(self):nativeNameFromSelector_(aSelector)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildNumberGetter:",0
,function(self,aSelector)
return ((self):build_doing_(("NumberGetter"):_minus_gt(aSelector),(function()
return ((self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_(("Return the "),aSelector))," of the receiver."),smalltalk:object_comma_((smalltalk:object_comma_(("^"),(self):handleAt_(aSelector))),(self):codeToNumber()),"accessing"))
end)));
end
,"builders","buildNumberGetter: aSelector\r\n\t\" Build (instance) method to get native property. \"\r\n\r\n\t^self build: #NumberGetter -> aSelector doing: [\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: aSelector)\r\n\t\t\tcomment: 'Return the ' ,aSelector ,' of the receiver.'\r\n\t\t\tas: $^ ,(self handleAt: aSelector) ,self codeToNumber\r\n\t\t\tcategory: #accessing\r\n\t]","function(self,aSelector)\r\nreturn ((self):build_doing_((\"NumberGetter\"):_minus_gt(aSelector),(function()\r\nreturn ((self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_((\"Return the \"),aSelector)),\" of the receiver.\"),smalltalk:object_comma_((smalltalk:object_comma_((\"^\"),(self):handleAt_(aSelector))),(self):codeToNumber()),\"accessing\"))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildNumberAccessor:",0
,function(self,accessor)
if ((accessor):isString())==true then return ((self):build_doing_(("NumberAccessor"):_minus_gt(accessor),(function()
return (smalltalk:object_comma_(((self):buildNumberGetter_(accessor)),(self):buildSetter_(accessor)))
end))); end;
return ((self):error_("Invalid (Number)accessors."));
end
,"builders","buildNumberAccessor: accessor\r\n\t\" Build (instance) method to access native property. \"\r\n\r\n\taccessor isString ifTrue: [\r\n\t\t^self build: #NumberAccessor -> accessor doing: [\r\n\t\t\t(self buildNumberGetter: accessor)\r\n\t\t\t,(self buildSetter: accessor)\r\n\t\t]\r\n\t].\r\n\t^self error: 'Invalid (Number)accessors.'","function(self,accessor)\r\nif ((accessor):isString())==true then return ((self):build_doing_((\"NumberAccessor\"):_minus_gt(accessor),(function()\r\nreturn (smalltalk:object_comma_(((self):buildNumberGetter_(accessor)),(self):buildSetter_(accessor)))\r\nend))); end;\r\nreturn ((self):error_(\"Invalid (Number)accessors.\"));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildNumberGetters:",0
,function(self,specs)
if ((specs):isString())==true then return ((self):buildNumberGetters_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("NumberGetters"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildNumberGetter_(each))
end)))
end)));
end
,"builders","buildNumberGetters: specs\r\n\t\" Build methods to get properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildNumberGetters: specs asArrayOfSubstrings ].\r\n\t^self build: #NumberGetters -> specs doing: [\r\n\t\tspecs compose: [:each| self buildNumberGetter: each ]\r\n\t]","function(self,specs)\r\nif ((specs):isString())==true then return ((self):buildNumberGetters_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"NumberGetters\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildNumberGetter_(each))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildNumberAccessors:",0
,function(self,specs)
if ((specs):isString())==true then return ((self):buildNumberAccessors_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("NumberAccessors"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildNumberAccessor_(each))
end)))
end)));
end
,"builders","buildNumberAccessors: specs\r\n\t\" Build methods to access properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildNumberAccessors: specs asArrayOfSubstrings ].\r\n\t^self build: #NumberAccessors -> specs doing: [\r\n\t\tspecs compose: [:each| self buildNumberAccessor: each ]\r\n\t]","function(self,specs)\r\nif ((specs):isString())==true then return ((self):buildNumberAccessors_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"NumberAccessors\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildNumberAccessor_(each))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildBooleanGetter:",0
,function(self,aSelector)
return ((self):build_doing_(("BooleanGetter"):_minus_gt(aSelector),(function()
return ((self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_(("Return the "),aSelector))," of the receiver."),smalltalk:object_comma_(("^true == "),(self):handleAt_(aSelector)),"accessing"))
end)));
end
,"builders","buildBooleanGetter: aSelector\r\n\t\" Build (instance) method to get native property. \"\r\n\r\n\t^self build: #BooleanGetter -> aSelector doing: [\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: aSelector)\r\n\t\t\tcomment: 'Return the ' ,aSelector ,' of the receiver.'\r\n\t\t\tas: '^true == ' ,(self handleAt: aSelector)\r\n\t\t\tcategory: #accessing\r\n\t]","function(self,aSelector)\r\nreturn ((self):build_doing_((\"BooleanGetter\"):_minus_gt(aSelector),(function()\r\nreturn ((self):implement_comment_as_category_((self):stMessageHeader_(aSelector),smalltalk:object_comma_((smalltalk:object_comma_((\"Return the \"),aSelector)),\" of the receiver.\"),smalltalk:object_comma_((\"^true == \"),(self):handleAt_(aSelector)),\"accessing\"))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildBooleanAccessor:",0
,function(self,accessor)
if ((accessor):isString())==true then return ((self):build_doing_(("BooleanAccessor"):_minus_gt(accessor),(function()
return (smalltalk:object_comma_(((self):buildBooleanGetter_(accessor)),(self):buildSetter_(accessor)))
end))); end;
return ((self):error_("Invalid (Boolean)accessors."));
end
,"builders","buildBooleanAccessor: accessor\r\n\t\" Build (instance) method to access native property. \"\r\n\r\n\taccessor isString ifTrue: [\r\n\t\t^self build: #BooleanAccessor -> accessor doing: [\r\n\t\t\t(self buildBooleanGetter: accessor)\r\n\t\t\t,(self buildSetter: accessor)\r\n\t\t]\r\n\t].\r\n\t^self error: 'Invalid (Boolean)accessors.'","function(self,accessor)\r\nif ((accessor):isString())==true then return ((self):build_doing_((\"BooleanAccessor\"):_minus_gt(accessor),(function()\r\nreturn (smalltalk:object_comma_(((self):buildBooleanGetter_(accessor)),(self):buildSetter_(accessor)))\r\nend))); end;\r\nreturn ((self):error_(\"Invalid (Boolean)accessors.\"));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildBooleanGetters:",0
,function(self,specs)
if ((specs):isString())==true then return ((self):buildBooleanGetters_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("BooleanGetters"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildBooleanGetter_(each))
end)))
end)));
end
,"builders","buildBooleanGetters: specs\r\n\t\" Build methods to get properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildBooleanGetters: specs asArrayOfSubstrings ].\r\n\t^self build: #BooleanGetters -> specs doing: [\r\n\t\tspecs compose: [:each| self buildBooleanGetter: each ]\r\n\t]","function(self,specs)\r\nif ((specs):isString())==true then return ((self):buildBooleanGetters_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"BooleanGetters\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildBooleanGetter_(each))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildBooleanAccessors:",0
,function(self,specs)
if ((specs):isString())==true then return ((self):buildBooleanAccessors_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("BooleanAccessors"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildBooleanAccessor_(each))
end)))
end)));
end
,"builders","buildBooleanAccessors: specs\r\n\t\" Build methods to access properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildBooleanAccessors: specs asArrayOfSubstrings ].\r\n\t^self build: #BooleanAccessors -> specs doing: [\r\n\t\tspecs compose: [:each| self buildBooleanAccessor: each ]\r\n\t]","function(self,specs)\r\nif ((specs):isString())==true then return ((self):buildBooleanAccessors_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"BooleanAccessors\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildBooleanAccessor_(each))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildIsBooleanGetter:",0
,function(self,aSelector)
return ((self):build_doing_(("IsBooleanGetter"):_minus_gt(aSelector),(function()
local isSelector=nil
(function()
	local _s8_value=(smalltalk:object_comma_(("is"),(aSelector):asGlobalName()))
	isSelector=_s8_value
	return _s8_value
end)();return ((self):implement_comment_as_category_((self):stMessageHeader_(isSelector),smalltalk:object_comma_((smalltalk:object_comma_(("Return the "),aSelector))," of the receiver."),smalltalk:object_comma_(("^true == handle#"),(self):nativeNameFromSelector_(isSelector)),"accessing"))
end)));
end
,"builders","buildIsBooleanGetter: aSelector\r\n\t\" Build (instance) method to get native property. \"\r\n\r\n\t^self build: #IsBooleanGetter -> aSelector doing: [ | isSelector |\r\n\t\tisSelector :=  #is ,aSelector asGlobalName.\r\n\t\tself\r\n\t\t\timplement: (self stMessageHeader: isSelector)\r\n\t\t\tcomment: 'Return the ' ,aSelector ,' of the receiver.'\r\n\t\t\tas: '^true == handle#' ,(self nativeNameFromSelector: isSelector)\r\n\t\t\tcategory: #accessing\r\n\t]","function(self,aSelector)\r\nreturn ((self):build_doing_((\"IsBooleanGetter\"):_minus_gt(aSelector),(function()\r\nlocal isSelector=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((\"is\"),(aSelector):asGlobalName()))\r\n\tisSelector=_s8_value\r\n\treturn _s8_value\r\nend)();return ((self):implement_comment_as_category_((self):stMessageHeader_(isSelector),smalltalk:object_comma_((smalltalk:object_comma_((\"Return the \"),aSelector)),\" of the receiver.\"),smalltalk:object_comma_((\"^true == handle#\"),(self):nativeNameFromSelector_(isSelector)),\"accessing\"))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildIsBooleanAccessor:",0
,function(self,accessor)
if ((accessor):isString())==true then return ((self):build_doing_(("IsBooleanAccessor"):_minus_gt(accessor),(function()
return (smalltalk:object_comma_(((self):buildIsBooleanGetter_(accessor)),(self):buildSetter_(accessor)))
end))); end;
return ((self):error_("Invalid (IsBoolean)accessors."));
end
,"builders","buildIsBooleanAccessor: accessor\r\n\t\" Build (instance) method to access native property. \"\r\n\r\n\taccessor isString ifTrue: [\r\n\t\t^self build: #IsBooleanAccessor -> accessor doing: [\r\n\t\t\t(self buildIsBooleanGetter: accessor)\r\n\t\t\t,(self buildSetter: accessor)\r\n\t\t]\r\n\t].\r\n\t^self error: 'Invalid (IsBoolean)accessors.'","function(self,accessor)\r\nif ((accessor):isString())==true then return ((self):build_doing_((\"IsBooleanAccessor\"):_minus_gt(accessor),(function()\r\nreturn (smalltalk:object_comma_(((self):buildIsBooleanGetter_(accessor)),(self):buildSetter_(accessor)))\r\nend))); end;\r\nreturn ((self):error_(\"Invalid (IsBoolean)accessors.\"));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildIsBooleanGetters:",0
,function(self,specs)
if ((specs):isString())==true then return ((self):buildIsBooleanGetters_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("IsBooleanGetters"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildIsBooleanGetter_(each))
end)))
end)));
end
,"builders","buildIsBooleanGetters: specs\r\n\t\" Build methods to get properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildIsBooleanGetters: specs asArrayOfSubstrings ].\r\n\t^self build: #IsBooleanGetters -> specs doing: [\r\n\t\tspecs compose: [:each| self buildIsBooleanGetter: each ]\r\n\t]","function(self,specs)\r\nif ((specs):isString())==true then return ((self):buildIsBooleanGetters_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"IsBooleanGetters\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildIsBooleanGetter_(each))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildIsBooleanAccessors:",0
,function(self,specs)
if ((specs):isString())==true then return ((self):buildIsBooleanAccessors_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("IsBooleanAccessors"):_minus_gt(specs),(function()
return ((specs):compose_((function(each)
return ((self):buildIsBooleanAccessor_(each))
end)))
end)));
end
,"builders","buildIsBooleanAccessors: specs\r\n\t\" Build methods to access properties. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildIsBooleanAccessors: specs asArrayOfSubstrings ].\r\n\t^self build: #IsBooleanAccessors -> specs doing: [\r\n\t\tspecs compose: [:each| self buildIsBooleanAccessor: each ]\r\n\t]","function(self,specs)\r\nif ((specs):isString())==true then return ((self):buildIsBooleanAccessors_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"IsBooleanAccessors\"):_minus_gt(specs),(function()\r\nreturn ((specs):compose_((function(each)\r\nreturn ((self):buildIsBooleanAccessor_(each))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSubclasses:",0
,function(self,aCollection)
local result=nil
(aCollection):do_((function(tuple)
return ((function()
	local _s8_value=(smalltalk:if_true_false_(((tuple):isString()),(function()
return ((self):buildSubclass_arguments_typed_(tuple,smalltalk:newArray({}),smalltalk:newArray({})))
end),(function()
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((tuple):size()),2)),(function()
return ((self):buildSubclass_arguments_typed_((tuple):first(),(tuple):second(),smalltalk:newArray({})))
end),(function()
return ((self):buildSubclass_arguments_typed_((tuple):first(),(tuple):second(),(tuple):last()))
end)))
end)))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
,"builder","buildSubclasses: aCollection\r\n\t\" Private - Build aCollection of subclasses of the receiver as wrappers to the library.\r\n\tReturn the last class created (or nil).\r\n\t\"\r\n\r\n\t| result |\r\n\taCollection do: [:tuple|\r\n\t\tresult := tuple isString\r\n\t\tifTrue: [ self buildSubclass: tuple arguments: #() typed: #() ]\r\n\t\tifFalse: [\r\n\t\t\ttuple size = 2\r\n\t\t\tifTrue: [ self buildSubclass: tuple first arguments: tuple second typed: #() ]\r\n\t\t\tifFalse: [ self buildSubclass: tuple first arguments: tuple second typed: tuple last ]\r\n\t\t ]\r\n\t].\r\n\t^result","function(self,aCollection)\r\nlocal result=nil\r\n(aCollection):do_((function(tuple)\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((tuple):isString()),(function()\r\nreturn ((self):buildSubclass_arguments_typed_(tuple,smalltalk:newArray({}),smalltalk:newArray({})))\r\nend),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((tuple):size()),2)),(function()\r\nreturn ((self):buildSubclass_arguments_typed_((tuple):first(),(tuple):second(),smalltalk:newArray({})))\r\nend),(function()\r\nreturn ((self):buildSubclass_arguments_typed_((tuple):first(),(tuple):second(),(tuple):last()))\r\nend)))\r\nend)))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildHierarchy:",0
,function(self,aCollection)
local stream=nil
local aClass=nil
(function()
	local _s8_value=((aCollection):stream())
	stream=_s8_value
	return _s8_value
end)();
while not ((function()
return ((stream):atEnd())
end))() do (function()
	local _s8_value=((self):buildSubclasses_((smalltalk.Array):with_((stream):next())))
	aClass=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((((stream):peek()):isArray()),(function()
return ((aClass):buildHierarchy_((stream):next()))
end),nil); end;
return (self);
end
,"builder","buildHierarchy: aCollection\r\n\t\" Private - Build aCollection of subclasses of the receiver as wrappers to the library. \"\r\n \r\n\t| stream aClass |\r\n\tstream := aCollection stream.\r\n\t[ stream atEnd ] whileFalse: [\r\n\t\taClass := self buildSubclasses: (Array with: stream next).\r\n\t\tstream peek isArray ifTrue: [\r\n\t\t\taClass buildHierarchy: stream next\r\n\t\t].\r\n\t]","function(self,aCollection)\r\nlocal stream=nil\r\nlocal aClass=nil\r\n(function()\r\n\tlocal _s8_value=((aCollection):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile not ((function()\r\nreturn ((stream):atEnd())\r\nend))() do (function()\r\n\tlocal _s8_value=((self):buildSubclasses_((smalltalk.Array):with_((stream):next())))\r\n\taClass=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((((stream):peek()):isArray()),(function()\r\nreturn ((aClass):buildHierarchy_((stream):next()))\r\nend),nil); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSubclass:arguments:typed:",0
,function(self,globalClassName,argList,typedArguments)
local cls=nil
local clsName=nil
(function()
	local _s8_value=(smalltalk:object_comma_((((globalClassName):first()):asUppercase()),(globalClassName):copyFrom_to_(2,(globalClassName):size())))
	clsName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:object_comma_(((self):classToken()),clsName))
	clsName=_s8_value
	return _s8_value
end)();
(self):subclass_instanceVariableNames_category_(clsName,"",(self):category());
return ((smalltalk.Smalltalk):at_(clsName));
end
,"builder","buildSubclass: globalClassName arguments: argList typed: typedArguments\r\n\t\" Private - Build a subclass of the receiver implementing a wrapper to the library.\r\n\tNote: argList and typed arguments are ignored; see subclasses to find concrete implementors.\r\n\tReturn the created class.\r\n\t\"\r\n\r\n\t| cls clsName |\r\n\tclsName := globalClassName first asUppercase\r\n\t\t\t,(globalClassName copyFrom: 2 to: globalClassName size).\r\n\tclsName := self classToken ,clsName.\r\n\tself\r\n\t\tsubclass: clsName\r\n\t\tinstanceVariableNames: ''\r\n\t\tcategory: self category.\r\n\t^Smalltalk at: clsName","function(self,globalClassName,argList,typedArguments)\r\nlocal cls=nil\r\nlocal clsName=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((((globalClassName):first()):asUppercase()),(globalClassName):copyFrom_to_(2,(globalClassName):size())))\r\n\tclsName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((self):classToken()),clsName))\r\n\tclsName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):subclass_instanceVariableNames_category_(clsName,\"\",(self):category());\r\nreturn ((smalltalk.Smalltalk):at_(clsName));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"classToken",0
,function(self)
return ("");
end
,"builder","classToken\r\n\t\" Private - Return the classToken to prepend/tag the receiver.\r\n\tThe default answer is empty.\r\n\tThe subclasses can subclass to build tagged subclasses.\r\n\t\"\r\n\r\n\t^''","function(self)\r\nreturn (\"\");\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"classToken:",0
,function(self,aToken)
return ((self):buildClassToken_(aToken));
end
,"builder","classToken: aToken\r\n\t\" Private - Generate code to return the classToken of the receiver. \"\r\n\r\n\t^self buildClassToken: aToken","function(self,aToken)\r\nreturn ((self):buildClassToken_(aToken));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildClassToken:",0
,function(self,aToken)
(self):build_doing_(("ClassToken"):_minus_gt(aToken),(function()
return ((self):implement_comment_as_category_("classToken","Private - Return the classToken to prepend/tag the receiver.",smalltalk:object_comma_(("^"),(aToken):asLiteral()),"builder"))
end));
return (self);
end
,"builder","buildClassToken: aToken\r\n\t\" Generate code to return the classToken of the receiver. \"\r\n\r\n\tself build: #ClassToken -> aToken doing: [\r\n\t\tself\r\n\t\t\timplement: #classToken\r\n\t\t\tcomment: 'Private - Return the classToken to prepend/tag the receiver.'\r\n\t\t\tas: $^ ,aToken asLiteral\r\n\t\t\tcategory: #builder\r\n\t]","function(self,aToken)\r\n(self):build_doing_((\"ClassToken\"):_minus_gt(aToken),(function()\r\nreturn ((self):implement_comment_as_category_(\"classToken\",\"Private - Return the classToken to prepend/tag the receiver.\",smalltalk:object_comma_((\"^\"),(aToken):asLiteral()),\"builder\"))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFunctions:",0
,function(self,specs)
(self):build_doing_(("Functions"):_minus_gt(specs),(function()
return ((specs):do_((function(spec)
return ((self):buildFunction_(spec))
end)))
end));
return (self);
end
,"builders","buildFunctions: specs\r\n\t\" Generate code from specs as functions implemented by instance handle. \"\r\n\r\n\tself build: #Functions -> specs doing: [\r\n\t\tspecs do: [:spec| self buildFunction: spec ]\r\n\t]","function(self,specs)\r\n(self):build_doing_((\"Functions\"):_minus_gt(specs),(function()\r\nreturn ((specs):do_((function(spec)\r\nreturn ((self):buildFunction_(spec))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildBooleanFunctions:",0
,function(self,specs)
if ((specs):isString())==true then return ((self):buildBooleanFunctions_((specs):asArrayOfSubstrings())); end;
return ((self):build_doing_(("BooleanFunctions"):_minus_gt(specs),(function()
return ((self):build_functions_("Boolean",specs))
end)));
end
,"builders","buildBooleanFunctions: specs\r\n\t\" Build methods to evaluate simple functions returning a Boolean. \"\r\n\r\n\tspecs isString ifTrue: [ ^self buildBooleanFunctions: specs asArrayOfSubstrings ].\r\n\t^self build: #BooleanFunctions -> specs doing: [\r\n\t\tself build: #Boolean functions: specs\r\n\t]","function(self,specs)\r\nif ((specs):isString())==true then return ((self):buildBooleanFunctions_((specs):asArrayOfSubstrings())); end;\r\nreturn ((self):build_doing_((\"BooleanFunctions\"):_minus_gt(specs),(function()\r\nreturn ((self):build_functions_(\"Boolean\",specs))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"build:functions:",0
,function(self,aClassName,specs)
if ((specs):isString())==true then return ((self):build_functions_(aClassName,(specs):asArrayOfSubstrings())); end;
return ((self):buildFunctions_((specs):collect_((function(each)
return (smalltalk:if_true_false_(((each):isString()),(function()
return ((smalltalk.Array):with_with_with_(each,smalltalk:newArray({}),aClassName))
end),(function()
if not ((smalltalk:boolean_and_(((each):isArray()),(function()
return (smalltalk:isObject_equalTo_(((each):size()),2))
end))))==true then (self):error_(smalltalk:object_comma_(("Invalid literal spec "),each)); end;return ((each):copyWith_(aClassName))
end)))
end))));
end
,"builders","build: aClassName functions: specs\r\n\t\" Build methods to evaluate simple functions returning an instance of aClassName. \"\r\n\r\n\tspecs isString ifTrue: [ ^self build: aClassName functions: specs asArrayOfSubstrings ].\r\n\t^self buildFunctions: (specs collect: [:each|\r\n\t\teach isString\r\n\t\tifTrue: [ Array with: each with: #() with: aClassName ]\r\n\t\tifFalse: [\r\n\t\t\t(each isArray and: [each size = 2]) ifFalse: [\r\n\t\t\t\tself error: 'Invalid literal spec ' ,each\r\n\t\t\t].\r\n\t\t\teach copyWith: aClassName\r\n\t\t]\r\n\t])","function(self,aClassName,specs)\r\nif ((specs):isString())==true then return ((self):build_functions_(aClassName,(specs):asArrayOfSubstrings())); end;\r\nreturn ((self):buildFunctions_((specs):collect_((function(each)\r\nreturn (smalltalk:if_true_false_(((each):isString()),(function()\r\nreturn ((smalltalk.Array):with_with_with_(each,smalltalk:newArray({}),aClassName))\r\nend),(function()\r\nif not ((smalltalk:boolean_and_(((each):isArray()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((each):size()),2))\r\nend))))==true then (self):error_(smalltalk:object_comma_((\"Invalid literal spec \"),each)); end;return ((each):copyWith_(aClassName))\r\nend)))\r\nend))));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"eval:",0
,function(self,code)
return (((smalltalk.Smalltalk):current()):eval_(code));
end
,"eval","eval: code\r\n\t\" Private - Return the result of evaluating (native) code. \"\r\n\r\n\t^Smalltalk current eval: code","function(self,code)\r\nreturn (((smalltalk.Smalltalk):current()):eval_(code));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"ignoreReturn:",0
,function(self,value)
return (self);
end
,"api","ignoreReturn: value\r\n\t\" Private - Ignore the argument value.\r\n\tReturn the receiver. \"","function(self,value)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apiSupportFor:",0
,function(self,literal)
local support=nil
(function()
	local _s8_value=((smalltalk.NativeHandle):support())
	support=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_and_((smalltalk:responds_to_((support),("handleAPIFor:"))),(function()
return ((support):handleAPIFor_(literal))
end)))==true then return (support); end;
return (self);
end
,"api","apiSupportFor: literal\r\n\t\" Private - Return the support to encode literal as native api.\r\n\tNote: literal can be a String or Array of api annotation literals.\r\n\t\"\r\n\r\n\t| support |\r\n\tsupport := NativeHandle support.\r\n\t((support respondsTo: #handleAPIFor:)\r\n\t\tand: [support handleAPIFor: literal])\r\n\t\tifTrue: [ ^support ].\r\n\t^self","function(self,literal)\r\nlocal support=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.NativeHandle):support())\r\n\tsupport=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_and_((smalltalk:responds_to_((support),(\"handleAPIFor:\"))),(function()\r\nreturn ((support):handleAPIFor_(literal))\r\nend)))==true then return (support); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apiEpilogueFor:",0
,function(self,aReturnType)
return (((self):apiSupportFor_(aReturnType)):nativeEpilogueFor_(aReturnType));
end
,"builders","apiEpilogueFor: aReturnType\r\n\t\" Private - Return the epilogue code to use to wrap a return. \"\r\n\r\n\t^(self apiSupportFor: aReturnType)\r\n\t\tnativeEpilogueFor: aReturnType","function(self,aReturnType)\r\nreturn (((self):apiSupportFor_(aReturnType)):nativeEpilogueFor_(aReturnType));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apiPrologueFor:",0
,function(self,aReturnType)
return (((self):apiSupportFor_(aReturnType)):nativePrologueFor_(aReturnType));
end
,"builders","apiPrologueFor: aReturnType\r\n\t\" Private - Return the prologue to use to wrap a return. \"\r\n\r\n\t^(self apiSupportFor: aReturnType)\r\n\t\tnativePrologueFor: aReturnType","function(self,aReturnType)\r\nreturn (((self):apiSupportFor_(aReturnType)):nativePrologueFor_(aReturnType));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"nativeEpilogueFor:",0
,function(self,aReturnType)
return (")");
end
,"builders","nativeEpilogueFor: aReturnType\r\n\t\" Private - Return the epilogue code to use to wrap a return. \"\r\n\r\n\t^$)","function(self,aReturnType)\r\nreturn (\")\");\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"nativePrologueFor:",0
,function(self,aReturnType)
if ((aReturnType):isEmpty())==true then return ("^self ignoreReturn: ("); end;
if (smalltalk:isObject_equalTo_(((aReturnType):last()),"("))==true then return (smalltalk:object_comma_(("^"),aReturnType)); end;
if (smalltalk:isObject_equalTo_(((aReturnType):last()),"+"))==true then return ((self):apiPrologueFor_(smalltalk:object_comma_(((aReturnType):upTo_("+")),"[]"))); end;
if ((aReturnType):includes_("["))==true then return (smalltalk:object_comma_(("^"),(self):apiPrologueForArray_(aReturnType))); end;
if ((aReturnType):includes_("<"))==true then return (smalltalk:object_comma_(("^"),(self):apiPrologueForTuple_(aReturnType))); end;
return (smalltalk:object_comma_((smalltalk:object_comma_(("^"),(self):apiWrapperFor_(aReturnType)))," @ ("));
end
,"builders","nativePrologueFor: aReturnType\r\n\t\" Private - Return the prologue to use to wrap a return.\r\n\taReturnType can be:\r\n\t\t- empty string to ignore api return value (will return the receiver)\r\n\t\t- suffixed by [...] or + to return an arrayed result\r\n\t\t- suffixed by type spec GlobalName\r\n\t\t- smalltalk code ending with (\r\n\t\t- a global name understanding #@\r\n\t\"\r\n\r\n\taReturnType isEmpty ifTrue: [ ^'^self ignoreReturn: (' ].\r\n\taReturnType last = $( ifTrue: [ ^$^ ,aReturnType ].\r\n\taReturnType last = $+ ifTrue: [\r\n\t\t^self apiPrologueFor: (aReturnType upTo: $+) ,'[]'\r\n\t].\r\n\t(aReturnType includes: $[) ifTrue: [\r\n\t\t^$^ ,(self apiPrologueForArray: aReturnType)\r\n\t].\r\n\t(aReturnType includes: $<) ifTrue: [\r\n\t\t^$^ ,(self apiPrologueForTuple: aReturnType)\r\n\t].\r\n\r\n\t^$^ ,(self apiWrapperFor: aReturnType) ,' @ ('","function(self,aReturnType)\r\nif ((aReturnType):isEmpty())==true then return (\"^self ignoreReturn: (\"); end;\r\nif (smalltalk:isObject_equalTo_(((aReturnType):last()),\"(\"))==true then return (smalltalk:object_comma_((\"^\"),aReturnType)); end;\r\nif (smalltalk:isObject_equalTo_(((aReturnType):last()),\"+\"))==true then return ((self):apiPrologueFor_(smalltalk:object_comma_(((aReturnType):upTo_(\"+\")),\"[]\"))); end;\r\nif ((aReturnType):includes_(\"[\"))==true then return (smalltalk:object_comma_((\"^\"),(self):apiPrologueForArray_(aReturnType))); end;\r\nif ((aReturnType):includes_(\"<\"))==true then return (smalltalk:object_comma_((\"^\"),(self):apiPrologueForTuple_(aReturnType))); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"^\"),(self):apiWrapperFor_(aReturnType))),\" @ (\"));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apiPrologueForArray:",0
,function(self,aReturnType)
local type=nil
local stream=nil
local kind=nil
(function()
	local _s8_value=((aReturnType):stream())
	stream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):apiWrapperFor_((stream):upTo_("[")))
	type=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((stream):upTo_("]"))
	kind=_s8_value
	return _s8_value
end)();
if not (((stream):atEnd()))==true then return ((self):error_("Invalid brackets for array")); end;
if ((kind):isEmpty())==true then return (smalltalk:object_comma_((type)," withAll: (")); end;
if not (((kind):includes_(",")))==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type)," of: ")),(self):apiWrapperFor_(kind)))," withAll: (")); end;
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type)," of: ")),smalltalk:printString_((kind))))," withAll: ("));
end
,"builders","apiPrologueForArray: aReturnType\r\n\t\" Private - Return the prologue to use to wrap an arrayed return.\r\n\tThe returned code will be like:\r\n\t\tGlobalName withAll: (\r\n\t\tGlobalName of: ElementClass withAll: (\r\n\t\tGlobalName of: 'Type1,Type2,Type3' withAll: (\r\n\t\"\r\n\r\n\t| type stream kind |\r\n\tstream := aReturnType stream.\r\n\ttype := self apiWrapperFor: (stream upTo: $[).\r\n\tkind := stream upTo: $].\r\n\tstream atEnd ifFalse: [ ^self error: 'Invalid brackets for array' ].\r\n\tkind isEmpty ifTrue: [ ^type ,' withAll: ('].\r\n\t(kind includes: $,) ifFalse: [\r\n\t\t^type ,' of: ' ,(self apiWrapperFor: kind) ,' withAll: ('\r\n\t].\t\r\n\t^type ,' of: ' ,kind printString ,' withAll: ('","function(self,aReturnType)\r\nlocal type=nil\r\nlocal stream=nil\r\nlocal kind=nil\r\n(function()\r\n\tlocal _s8_value=((aReturnType):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):apiWrapperFor_((stream):upTo_(\"[\")))\r\n\ttype=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((stream):upTo_(\"]\"))\r\n\tkind=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((stream):atEnd()))==true then return ((self):error_(\"Invalid brackets for array\")); end;\r\nif ((kind):isEmpty())==true then return (smalltalk:object_comma_((type),\" withAll: (\")); end;\r\nif not (((kind):includes_(\",\")))==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type),\" of: \")),(self):apiWrapperFor_(kind))),\" withAll: (\")); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type),\" of: \")),smalltalk:printString_((kind)))),\" withAll: (\"));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apiPrologueForTuple:",0
,function(self,aReturnType)
local type=nil
local stream=nil
local kind=nil
(function()
	local _s8_value=((aReturnType):stream())
	stream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):apiWrapperFor_((stream):upTo_("<")))
	type=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((stream):upTo_(">"))
	kind=_s8_value
	return _s8_value
end)();
if not (((stream):atEnd()))==true then return ((self):error_("Invalid code for typle")); end;
if ((kind):isEmpty())==true then return ((self):error_("Empty types for tuple")); end;
if not (((kind):includes_(",")))==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type)," of: ")),(self):apiWrapperFor_(kind)))," with: (")); end;
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type)," of: ")),smalltalk:printString_((kind))))," with: ("));
end
,"builders","apiPrologueForTuple: aReturnType\r\n\t\" Private - Return the prologue to use to wrap a tuple return.\r\n\tThe returned code will be like:\r\n\t\tGlobalName of: 'Type1,Type2,Type3' with: (\r\n\t\"\r\n\r\n\t| type stream kind |\r\n\tstream := aReturnType stream.\r\n\ttype := self apiWrapperFor: (stream upTo: $<).\r\n\tkind := stream upTo: $>.\r\n\tstream atEnd ifFalse: [ ^self error: 'Invalid code for typle' ].\r\n\tkind isEmpty ifTrue:  [ ^self error: 'Empty types for tuple' ].\r\n\t(kind includes: $,) ifFalse: [\r\n\t\t^type ,' of: ' ,(self apiWrapperFor: kind) ,' with: ('\r\n\t].\t\r\n\t^type ,' of: ' ,kind printString ,' with: ('","function(self,aReturnType)\r\nlocal type=nil\r\nlocal stream=nil\r\nlocal kind=nil\r\n(function()\r\n\tlocal _s8_value=((aReturnType):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):apiWrapperFor_((stream):upTo_(\"<\")))\r\n\ttype=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((stream):upTo_(\">\"))\r\n\tkind=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif not (((stream):atEnd()))==true then return ((self):error_(\"Invalid code for typle\")); end;\r\nif ((kind):isEmpty())==true then return ((self):error_(\"Empty types for tuple\")); end;\r\nif not (((kind):includes_(\",\")))==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type),\" of: \")),(self):apiWrapperFor_(kind))),\" with: (\")); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((type),\" of: \")),smalltalk:printString_((kind)))),\" with: (\"));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apiWrapperFor:",0
,function(self,aName)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(smalltalk.Smalltalk):at_ifAbsent_(aName,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):defaultAPIWrapperFor_(aName))
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (aName)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"builders","apiWrapperFor: aName\r\n\t\" Private - Return the name to use to wrap API structures of type aName. \"\r\n\r\n\tSmalltalk at: aName ifAbsent: [ ^self defaultAPIWrapperFor: aName ].\r\n\t^aName","function(self,aName)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(smalltalk.Smalltalk):at_ifAbsent_(aName,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):defaultAPIWrapperFor_(aName))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (aName)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"defaultAPIWrapperFor:",0
,function(self,aName)
return (aName);
end
,"builders","defaultAPIWrapperFor: aName\r\n\t\" Private - Return the default name to use to wrap API structures of type aName.\r\n\tDefault implementation will defer lookup upto runtime.\r\n\t\"\r\n\r\n\t^aName","function(self,aName)\r\nreturn (aName);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFunction:",0
,function(self,spec)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if ((spec):isArray())==true then if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),3)),(function()
return (((spec):last()):isString())
end)))==true then return ((self):buildFunction_((smalltalk.Array):with_with_((smalltalk.Array):with_with_((spec):first(),(spec):second()),(spec):last()))); end;
smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),2)),(function()
return (((spec):last()):isString())
end))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):buildFunction_prologue_epilogue_((spec):first(),(self):apiPrologueFor_((spec):second()),(self):apiEpilogueFor_((spec):second())))
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):buildFunction_prologue_epilogue_(spec,"^",""))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"builders","buildFunction: spec\r\n\t\" Private - Generate code from spec as functions on instance handle.\r\n\tspec can be:\r\n\t\taSymbol (e.g. any smalltalk message selector)\r\n\t\t#( selector #ReturnType )\r\n\t\t#( selector #( argumentNames ) #ReturnType )\r\n\t\t#( #( selector #( argumentNames ) ) #ReturnType )\r\n\t\t#( selector #( argumentNames ) )\r\n\targumentNames must match selector pattern\r\n\targumentNames can include kwargsStart to define keyword arguments\r\n\tif argumentNames is not given, it will be computed from selector pattern\r\n\tThe function will return the result of calling the handle, wrapped to a ReturnType\r\n\tSee implementation of #apiPrologueFor: for documentation on #ReturnType\r\n\t\"\r\n\r\n\tspec isArray ifTrue: [\r\n\t    (spec size = 3 and: [spec last isString]) ifTrue: [ \"#( selector #( argumentNames ) #ReturnType )\"\r\n\t\t^self buildFunction: (Array\r\n\t\t\twith: (Array with: spec first with: spec second)\r\n\t\t\twith: spec last)\r\n\t    ]. \r\n\t    (spec size = 2 and: [spec last isString]) ifTrue: [ \"#( selector #ReturnType )\"\r\n\t\t^self\r\n\t\t\tbuildFunction: spec first\r\n\t\t\tprologue: (self apiPrologueFor: spec second)\r\n\t\t\tepilogue: (self apiEpilogueFor: spec second)\r\n\t    ]. \r\n\t].\r\n\t^self buildFunction: spec prologue: $^ epilogue: ''","function(self,spec)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif ((spec):isArray())==true then if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),3)),(function()\r\nreturn (((spec):last()):isString())\r\nend)))==true then return ((self):buildFunction_((smalltalk.Array):with_with_((smalltalk.Array):with_with_((spec):first(),(spec):second()),(spec):last()))); end;\r\nsmalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),2)),(function()\r\nreturn (((spec):last()):isString())\r\nend))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):buildFunction_prologue_epilogue_((spec):first(),(self):apiPrologueFor_((spec):second()),(self):apiEpilogueFor_((spec):second())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):buildFunction_prologue_epilogue_(spec,\"^\",\"\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFunction:prologue:epilogue:",0
,function(self,spec,prologue,epilogue)
local args=nil
if ((spec):isArray())==true then return ((self):buildFunction_arguments_prologue_epilogue_((spec):first(),(spec):last(),prologue,epilogue)); end;
(function()
	local _s8_value=(((1):to_((spec):occurrencesOf_(":"))):collect_((function(i)
return (smalltalk:object_comma_(("arg"),smalltalk:asString_((i))))
end)))
	args=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((args):size()),1))==true then (function()
	local _s8_value=(smalltalk:newArray({"anObject"}))
	args=_s8_value
	return _s8_value
end)(); end;
return ((self):buildFunction_arguments_prologue_epilogue_(spec,args,prologue,epilogue));
end
,"builders","buildFunction: spec prologue: prologue epilogue: epilogue \r\n\t\" Private - Generate code for spec to apply on instance handle. \"\r\n\r\n\t| args |\r\n\tspec isArray ifTrue: [ \"#( selector #(argumentNames) )\"\r\n\t\t^self\tbuildFunction: spec first arguments: spec last\r\n\t\t\tprologue: prologue epilogue: epilogue\r\n\t].\r\n\targs :=  (1 to: (spec occurrencesOf: $:)) collect: [:i| #arg , i asString ].\r\n\targs size = 1 ifTrue: [ args := #( #anObject ) ].\r\n\t^self\r\n\t\tbuildFunction: spec arguments: args\r\n\t\tprologue: prologue epilogue: epilogue  ","function(self,spec,prologue,epilogue)\r\nlocal args=nil\r\nif ((spec):isArray())==true then return ((self):buildFunction_arguments_prologue_epilogue_((spec):first(),(spec):last(),prologue,epilogue)); end;\r\n(function()\r\n\tlocal _s8_value=(((1):to_((spec):occurrencesOf_(\":\"))):collect_((function(i)\r\nreturn (smalltalk:object_comma_((\"arg\"),smalltalk:asString_((i))))\r\nend)))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((args):size()),1))==true then (function()\r\n\tlocal _s8_value=(smalltalk:newArray({\"anObject\"}))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((self):buildFunction_arguments_prologue_epilogue_(spec,args,prologue,epilogue));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apiSelector:forArguments:",0
,function(self,callName,args)
local parts=nil
if (smalltalk:isObject_equalTo_(((args):size()),(callName):argumentCount()))==true then return (callName); end;
(function()
	local _s8_value=((callName):asArrayOfSubstringsSeparatedBy_(":"))
	parts=_s8_value
	return _s8_value
end)();
if (((parts):last()):isEmpty())==true then (parts):removeLast(); end;
(((parts):size()):_plus(1)):to_do_((args):size(),(function(i)
local argName=nil
(function()
	local _s8_value=((args):at_(i))
	argName=_s8_value
	return _s8_value
end)();if ((argName):isArray())==true then (function()
	local _s8_value=((argName):first())
	argName=_s8_value
	return _s8_value
end)(); end;return ((parts):add_((argName):asSmalltalkName_(false)))
end));
return ((parts):inject_into_("",(function(total,part)
return (smalltalk:object_comma_((smalltalk:object_comma_((total),part)),":"))
end)));
end
,"builders","apiSelector: callName forArguments: args\r\n\t\" Private - Return the api selector to implement a native call with arguments. \"\r\n\r\n\t| parts |\r\n\targs size = callName argumentCount ifTrue: [ ^callName ].\r\n\tparts := callName asArrayOfSubstringsSeparatedBy: $:.\r\n\tparts last isEmpty ifTrue: [ parts removeLast ].\r\n\tparts size + 1 to: args size do: [:i| | argName |\r\n\t\targName := args at: i.\r\n\t\targName isArray ifTrue: [ argName := argName first ].\r\n\t\tparts add: (argName asSmalltalkName: false)\r\n\t].\r\n\t^parts inject: '' into: [:total :part| total ,part ,$: ]","function(self,callName,args)\r\nlocal parts=nil\r\nif (smalltalk:isObject_equalTo_(((args):size()),(callName):argumentCount()))==true then return (callName); end;\r\n(function()\r\n\tlocal _s8_value=((callName):asArrayOfSubstringsSeparatedBy_(\":\"))\r\n\tparts=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (((parts):last()):isEmpty())==true then (parts):removeLast(); end;\r\n(((parts):size()):_plus(1)):to_do_((args):size(),(function(i)\r\nlocal argName=nil\r\n(function()\r\n\tlocal _s8_value=((args):at_(i))\r\n\targName=_s8_value\r\n\treturn _s8_value\r\nend)();if ((argName):isArray())==true then (function()\r\n\tlocal _s8_value=((argName):first())\r\n\targName=_s8_value\r\n\treturn _s8_value\r\nend)(); end;return ((parts):add_((argName):asSmalltalkName_(false)))\r\nend));\r\nreturn ((parts):inject_into_(\"\",(function(total,part)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((total),part)),\":\"))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apiArgumentsFrom:",0
,function(self,array)
return (((self):apiSupportFor_(array)):nativeArgumentsFrom_(array));
end
,"api","apiArgumentsFrom: array\r\n\t\" Private - Return the arguments for API call. \"\r\n\r\n\t^(self apiSupportFor: array)\r\n\t\tnativeArgumentsFrom: array","function(self,array)\r\nreturn (((self):apiSupportFor_(array)):nativeArgumentsFrom_(array));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"nativeArgumentsFrom:",0
,function(self,array)
local tag=nil
(function()
	local _s8_value=("_")
	tag=_s8_value
	return _s8_value
end)();
return ((array):collect_((function(each)
return (smalltalk:if_true_false_((smalltalk:boolean_and_(((each):isString()),(function()
return (smalltalk:isObject_equalTo_(((each):first()),tag))
end))),(function()
local varName=nil
(function()
	local _s8_value=((each):copyFrom_to_(2,(each):size()))
	varName=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((each):last()),tag)),(function()
return ((smalltalk.Array):with_with_((varName):copyFrom_to_(1,((varName):size()):_minus(1)),"handles"))
end),(function()
return ((smalltalk.Array):with_with_(varName,"json"))
end)))
end),(function()
return (each)
end)))
end)));
end
,"builders","nativeArgumentsFrom: array\r\n\t\" Private - Return the arguments for API call. \"\r\n\r\n\t| tag |\r\n\ttag := $_.\r\n\t^array collect: [:each|\r\n\t\t(each isString and: [ each first = tag ]) ifTrue: [ | varName |\r\n\t\t\tvarName := each copyFrom: 2 to: each size.\r\n\t\t\teach last = tag\r\n\t\t\tifTrue: [ Array with: (varName copyFrom: 1 to: varName size - 1) with: #handles ]\r\n\t\t\tifFalse: [ Array with: varName with: #json ]\r\n\t\t] ifFalse: [ each ]\r\n\t]","function(self,array)\r\nlocal tag=nil\r\n(function()\r\n\tlocal _s8_value=(\"_\")\r\n\ttag=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((array):collect_((function(each)\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_(((each):isString()),(function()\r\nreturn (smalltalk:isObject_equalTo_(((each):first()),tag))\r\nend))),(function()\r\nlocal varName=nil\r\n(function()\r\n\tlocal _s8_value=((each):copyFrom_to_(2,(each):size()))\r\n\tvarName=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((each):last()),tag)),(function()\r\nreturn ((smalltalk.Array):with_with_((varName):copyFrom_to_(1,((varName):size()):_minus(1)),\"handles\"))\r\nend),(function()\r\nreturn ((smalltalk.Array):with_with_(varName,\"json\"))\r\nend)))\r\nend),(function()\r\nreturn (each)\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apiSelectorAndFunctionName:forArguments:",0
,function(self,callName,args)
local msgSelector=nil
local apiSelector=nil
if not ((smalltalk:boolean_or_(((callName):isString()),(function()
return ((callName):isArray())
end))))==true then return ((self):error_("CallName must be aString or anArray")); end;
(function()
	local _s8_value=((self):apiSelector_forArguments_(smalltalk:if_true_false_(((callName):isString()),(function()
return ((self):apiMessage_for_(callName,args))
end),(function()
return ((self):apiMessage_for_((callName):first(),args))
end)),args))
	msgSelector=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):apiSelector_forArguments_(smalltalk:if_true_false_(((callName):isString()),(function()
return (callName)
end),(function()
return ((callName):last())
end)),args))
	apiSelector=_s8_value
	return _s8_value
end)();
return ((smalltalk.Array):with_with_(msgSelector,apiSelector));
end
,"builders","apiSelectorAndFunctionName: callName forArguments: args\r\n\t\" Private - Return the selector and api call to implement a native call with arguments. \"\r\n\r\n\t| msgSelector apiSelector |\r\n\t(callName isString or: [callName isArray]) ifFalse: [\r\n\t\t^self error: 'CallName must be aString or anArray'\r\n\t].\r\n\tmsgSelector := self apiSelector: (callName isString\r\n\t\tifTrue: [ self apiMessage: callName for: args ]\r\n\t\tifFalse: [ self apiMessage: callName first for: args ]) forArguments: args.\r\n\tapiSelector := self apiSelector: (callName isString\r\n\t\tifTrue: [ callName ] ifFalse: [ callName last ]) forArguments: args.\r\n\r\n\t^Array with: msgSelector with: apiSelector","function(self,callName,args)\r\nlocal msgSelector=nil\r\nlocal apiSelector=nil\r\nif not ((smalltalk:boolean_or_(((callName):isString()),(function()\r\nreturn ((callName):isArray())\r\nend))))==true then return ((self):error_(\"CallName must be aString or anArray\")); end;\r\n(function()\r\n\tlocal _s8_value=((self):apiSelector_forArguments_(smalltalk:if_true_false_(((callName):isString()),(function()\r\nreturn ((self):apiMessage_for_(callName,args))\r\nend),(function()\r\nreturn ((self):apiMessage_for_((callName):first(),args))\r\nend)),args))\r\n\tmsgSelector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):apiSelector_forArguments_(smalltalk:if_true_false_(((callName):isString()),(function()\r\nreturn (callName)\r\nend),(function()\r\nreturn ((callName):last())\r\nend)),args))\r\n\tapiSelector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((smalltalk.Array):with_with_(msgSelector,apiSelector));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apiMessage:for:",0
,function(self,callName,args)
local result=nil
(function()
	local _s8_value=((callName):copyWithout_("!"))
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((self):nativeLanguage()),"lua"))==true then smalltalk:if_true_false_(((callName):startsWith_("_")),(function()
return ((function()
	local _s8_value=((callName):copyFrom_to_(2,(callName):size()))
	result=_s8_value
	return _s8_value
end)())
end),nil); end;
if ((((result):argumentCount()) > 0))==true then return (result); end;
return ((result):asLocalName());
end
,"builders","apiMessage: callName for: args\r\n\t\" Private - Return the message to implement for calling function callName.\r\n\tThe default action use the callName as local name.\r\n\tIt can be refined by subclasses to edit the name for better smalltalk looking of the message.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := callName copyWithout: $!.\r\n\tself nativeLanguage = #lua ifTrue: [\r\n\t\t(callName startsWith: $_) ifTrue: [ result := callName copyFrom: 2 to: callName size ].\r\n\t].\r\n\tresult argumentCount > 0 ifTrue: [ ^result ].\r\n\t^result asLocalName ","function(self,callName,args)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((callName):copyWithout_(\"!\"))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((self):nativeLanguage()),\"lua\"))==true then smalltalk:if_true_false_(((callName):startsWith_(\"_\")),(function()\r\nreturn ((function()\r\n\tlocal _s8_value=((callName):copyFrom_to_(2,(callName):size()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend),nil); end;\r\nif ((((result):argumentCount()) > 0))==true then return (result); end;\r\nreturn ((result):asLocalName());\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apiEncode:call:args:on:header:",0
,function(self,delegate,aSelector,array,code,header)
local pair=nil
local args=nil
local msgStream=nil
local apiStream=nil
local argStream=nil
local msg=nil
local space=nil
(function()
	local _s8_value=((self):apiArgumentsFrom_(array))
	args=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):apiSelectorAndFunctionName_forArguments_(aSelector,args))
	pair=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((pair):first()):stream())
	msgStream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((((pair):first()):includes_(":")),(function()
return (": ")
end),(function()
return (" ")
end)))
	space=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((pair):last()):stream())
	apiStream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((args):stream())
	argStream=_s8_value
	return _s8_value
end)();
(code):nextPutAll_(delegate);
(code):nextPut_((apiStream):next());
(header):nextPut_((msgStream):next());
while not ((function()
return ((argStream):atEnd())
end))() do local param=nil
local expr=nil
if (((argStream):peek()):isString())==true then (function()
	local _s8_value=((argStream):next())
	param=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(param)
	expr=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=(((argStream):peek()):first())
	param=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((param)," ")),((argStream):next()):last()))
	expr=_s8_value
	return _s8_value
end)(); end;
(code):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((apiStream):upTo_(":")),": ")),expr))," "));
(header):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((msgStream):upTo_(":")),space)),param))," ")); end;
(code):nextPutAll_((apiStream):upToEnd());
(header):nextPutAll_((msgStream):upToEnd());
return (self);
end
,"builders","apiEncode: delegate\r\n\tcall: aSelector args: array\r\n\ton: code header: header\r\n\t\" Private - Generate code to call function onto code&header streams. \"\r\n\r\n\t| pair args msgStream apiStream argStream msg space |\r\n\targs := self apiArgumentsFrom: array.\r\n\tpair := self apiSelectorAndFunctionName: aSelector forArguments: args.\r\n\tmsgStream := pair first stream.\r\n\tspace := (pair first includes: $:) ifTrue: [ ': ' ] ifFalse: [ $ ].\r\n\tapiStream := pair last stream.\r\n\targStream := args stream.\r\n\r\n\tcode\tnextPutAll: delegate.\r\n\tcode\tnextPut: apiStream next.\r\n\theader\tnextPut: msgStream next.\r\n\r\n\t[ argStream atEnd ] whileFalse: [ | param expr |\r\n\t\targStream peek isString\r\n\t\tifTrue: [ param := argStream next. expr := param ]\r\n\t\tifFalse: [ param := argStream peek first. expr := param ,' ' ,argStream next last. ].\r\n\t\tcode nextPutAll: (apiStream upTo: $:) ,': ' ,expr ,' '.\r\n\t\theader nextPutAll: (msgStream upTo: $:) ,space ,param ,' '.\r\n\t].\r\n\r\n\tcode   nextPutAll: apiStream upToEnd.\r\n\theader nextPutAll: msgStream upToEnd.","function(self,delegate,aSelector,array,code,header)\r\nlocal pair=nil\r\nlocal args=nil\r\nlocal msgStream=nil\r\nlocal apiStream=nil\r\nlocal argStream=nil\r\nlocal msg=nil\r\nlocal space=nil\r\n(function()\r\n\tlocal _s8_value=((self):apiArgumentsFrom_(array))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):apiSelectorAndFunctionName_forArguments_(aSelector,args))\r\n\tpair=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((pair):first()):stream())\r\n\tmsgStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((((pair):first()):includes_(\":\")),(function()\r\nreturn (\": \")\r\nend),(function()\r\nreturn (\" \")\r\nend)))\r\n\tspace=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((pair):last()):stream())\r\n\tapiStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((args):stream())\r\n\targStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(code):nextPutAll_(delegate);\r\n(code):nextPut_((apiStream):next());\r\n(header):nextPut_((msgStream):next());\r\nwhile not ((function()\r\nreturn ((argStream):atEnd())\r\nend))() do local param=nil\r\nlocal expr=nil\r\nif (((argStream):peek()):isString())==true then (function()\r\n\tlocal _s8_value=((argStream):next())\r\n\tparam=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(param)\r\n\texpr=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=(((argStream):peek()):first())\r\n\tparam=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((param),\" \")),((argStream):next()):last()))\r\n\texpr=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(code):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((apiStream):upTo_(\":\")),\": \")),expr)),\" \"));\r\n(header):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((msgStream):upTo_(\":\")),space)),param)),\" \")); end;\r\n(code):nextPutAll_((apiStream):upToEnd());\r\n(header):nextPutAll_((msgStream):upToEnd());\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apiEncode:call:args:kwargs:on:header:",0
,function(self,delegate,aSelector,array,kwarray,code,header)
local pair=nil
local args=nil
local kwargs=nil
local msgStream=nil
local argStream=nil
local msg=nil
local space=nil
(function()
	local _s8_value=((self):apiArgumentsFrom_(array))
	args=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):apiArgumentsFrom_(kwarray))
	kwargs=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):apiSelectorAndFunctionName_forArguments_(aSelector,smalltalk:object_comma_((args),kwargs)))
	pair=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((pair):first()):stream())
	msgStream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((((pair):first()):includes_(":")),(function()
return (": ")
end),(function()
return (" ")
end)))
	space=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk:object_comma_((args),kwargs)):stream())
	argStream=_s8_value
	return _s8_value
end)();
(header):nextPut_((msgStream):next());
while not ((function()
return ((argStream):atEnd())
end))() do local param=nil
if (((argStream):peek()):isString())==true then (function()
	local _s8_value=((argStream):next())
	param=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=(((argStream):next()):first())
	param=_s8_value
	return _s8_value
end)(); end;
(header):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((msgStream):upTo_(":")),space)),param))," ")); end;
(header):nextPutAll_((msgStream):upToEnd());
(code):nextPut_("(");
(code):nextPutAll_((self):apikw_call_args_kwargs_header_(delegate,(pair):last(),args,kwargs,header));
(code):nextPut_(")");
return (self);
end
,"builders","apiEncode: delegate\r\n\tcall: aSelector args: array kwargs: kwarray\r\n\ton: code header: header\r\n\t\" Private - Generate code to call function onto code&header streams. \"\r\n\r\n\t| pair args kwargs msgStream argStream msg space |\r\n\targs := self apiArgumentsFrom: array.\r\n\tkwargs := self apiArgumentsFrom: kwarray.\r\n\tpair := self apiSelectorAndFunctionName: aSelector forArguments: args ,kwargs.\r\n\tmsgStream := pair first stream.\r\n\tspace := (pair first includes: $:) ifTrue: [ ': ' ] ifFalse: [ $ ].\r\n\targStream := (args ,kwargs) stream.\r\n\r\n\theader\tnextPut: msgStream next.\r\n\t[ argStream atEnd ] whileFalse: [ | param |\r\n\t\targStream peek isString\r\n\t\tifTrue: [ param := argStream next ]\r\n\t\tifFalse: [ param := argStream next first ].\r\n\t\theader nextPutAll: (msgStream upTo: $:) ,space ,param ,' '.\r\n\t].\r\n\theader nextPutAll: msgStream upToEnd.\r\n\r\n\tcode nextPut: $(.\r\n\tcode nextPutAll: (self\r\n\t\tapikw: delegate call: pair last\r\n\t\targs: args kwargs: kwargs\r\n\t\theader: header).\r\n\tcode nextPut: $).","function(self,delegate,aSelector,array,kwarray,code,header)\r\nlocal pair=nil\r\nlocal args=nil\r\nlocal kwargs=nil\r\nlocal msgStream=nil\r\nlocal argStream=nil\r\nlocal msg=nil\r\nlocal space=nil\r\n(function()\r\n\tlocal _s8_value=((self):apiArgumentsFrom_(array))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):apiArgumentsFrom_(kwarray))\r\n\tkwargs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):apiSelectorAndFunctionName_forArguments_(aSelector,smalltalk:object_comma_((args),kwargs)))\r\n\tpair=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((pair):first()):stream())\r\n\tmsgStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((((pair):first()):includes_(\":\")),(function()\r\nreturn (\": \")\r\nend),(function()\r\nreturn (\" \")\r\nend)))\r\n\tspace=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk:object_comma_((args),kwargs)):stream())\r\n\targStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(header):nextPut_((msgStream):next());\r\nwhile not ((function()\r\nreturn ((argStream):atEnd())\r\nend))() do local param=nil\r\nif (((argStream):peek()):isString())==true then (function()\r\n\tlocal _s8_value=((argStream):next())\r\n\tparam=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=(((argStream):next()):first())\r\n\tparam=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(header):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((msgStream):upTo_(\":\")),space)),param)),\" \")); end;\r\n(header):nextPutAll_((msgStream):upToEnd());\r\n(code):nextPut_(\"(\");\r\n(code):nextPutAll_((self):apikw_call_args_kwargs_header_(delegate,(pair):last(),args,kwargs,header));\r\n(code):nextPut_(\")\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apikw:call:args:kwargs:header:",0
,function(self,delegate,aSelector,array,kwarray,header)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local callArgs=nil
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("self call: "),(self):apikw_delegate_(aSelector,delegate))),"\r\n\targs: ")),(self):apikwArguments_named_(array,false)))
	callArgs=_s8_value
	return _s8_value
end)();
if ((kwarray):isEmpty())==true then smalltalk:if_true_false_(((aSelector):includes_("!")),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((callArgs)," kwargs: nil"))
end
)()
error(_s8Ret_,0)
end)())
end),(function()
if ((array):notEmpty())==true then (header):nextPutAll_("kwargs"); end;(header):nextPutAll_(": kwargs");return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((callArgs)," kwargs: kwargs"))
end
)()
error(_s8Ret_,0)
end)())
end)); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:object_comma_((smalltalk:object_comma_((callArgs)," kwargs: ")),(self):apikwArguments_named_(kwarray,true)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"builders","apikw: delegate call: aSelector args: array kwargs: kwarray header: header\r\n\t\" Private - Returns the code for a keyword function call. \"\r\n\r\n\t| callArgs |\r\n\tcallArgs := 'self call: ' ,(self apikw: aSelector delegate: delegate) ,'\r\n\targs: '     ,(self apikwArguments: array named: false).\r\n\tkwarray isEmpty ifTrue: [\r\n\t\t(aSelector includes: $!)\r\n\t\tifTrue: [ ^callArgs ,' kwargs: nil' ]\r\n\t\tifFalse: [\r\n\t\t\tarray notEmpty ifTrue: [ header nextPutAll: #kwargs ].\r\n\t\t\theader nextPutAll: ': kwargs'.\r\n\t\t\t^callArgs ,' kwargs: kwargs'\r\n\t\t]\r\n\t].\r\n\t^callArgs ,' kwargs: ' ,(self apikwArguments: kwarray named: true)","function(self,delegate,aSelector,array,kwarray,header)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal callArgs=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"self call: \"),(self):apikw_delegate_(aSelector,delegate))),\"\\r\\n\\targs: \")),(self):apikwArguments_named_(array,false)))\r\n\tcallArgs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((kwarray):isEmpty())==true then smalltalk:if_true_false_(((aSelector):includes_(\"!\")),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((callArgs),\" kwargs: nil\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),(function()\r\nif ((array):notEmpty())==true then (header):nextPutAll_(\"kwargs\"); end;(header):nextPutAll_(\": kwargs\");return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((callArgs),\" kwargs: kwargs\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((callArgs),\" kwargs: \")),(self):apikwArguments_named_(kwarray,true)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apikw:delegate:",0
,function(self,aSelector,delegate)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("("),(delegate):upTo_("#"))),"basicAt: ")),((aSelector):upTo_(":")):asLiteral())),")"));
end
,"builders","apikw: aSelector delegate: delegate\r\n\t\" Private - Returns the code to access a keyword function. \"\r\n\r\n\t^$(\r\n\t,(delegate upTo: $#)\r\n\t,'basicAt: '\t,(aSelector upTo: #:) asLiteral\r\n\t,$)","function(self,aSelector,delegate)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"(\"),(delegate):upTo_(\"#\"))),\"basicAt: \")),((aSelector):upTo_(\":\")):asLiteral())),\")\"));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"kwargsStart",0
,function(self)
return ("|");
end
,"builders","kwargsStart\r\n\t\" Private - Returns the tag used for keyword arguments. \"\r\n\r\n\t^#|","function(self)\r\nreturn (\"|\");\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apikwArguments:named:",0
,function(self,array,named)
local element=nil
(function()
	local _s8_value=((function(arg)
local kw=nil
local v=nil
if ((arg):isArray())==true then (function()
	local _s8_value=((arg):first())
	kw=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((arg):first())," ")),(arg):last()))
	v=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=((function()
	local _s8_value=(arg)
	v=_s8_value
	return _s8_value
end)())
	kw=_s8_value
	return _s8_value
end)(); end;return (smalltalk:if_true_false_((named),(function()
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("(Array with: "),(kw):asLiteral()))," with: ")),v)),")"))
end),(function()
return (v)
end)))
end))
	element=_s8_value
	return _s8_value
end)();
if ((array):isEmpty())==true then return ("#()"); end;
if ((((array):size()) <= 3))==true then return (smalltalk:object_comma_(((array):inject_into_(smalltalk:object_comma_(("("),"Array"),(function(total,each)
return (smalltalk:object_comma_((smalltalk:object_comma_((total)," with: ")),(element):value_(each)))
end))),")")); end;
return (smalltalk:object_comma_((smalltalk:object_comma_(("(Array new"),(array):inject_into_("",(function(total,each)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total)," add: ")),(element):value_(each))),";"))
end))))," yourself)"));
end
,"builders","apikwArguments: array named: named\r\n\t\" Private - Returns the code to pass arguments to kw function call. \"\r\n\r\n\t| element |\r\n\telement := [:arg| | kw v |\r\n\t\targ isArray\r\n\t\tifTrue: [ kw := arg first. v := arg first ,' ',arg last ]\r\n\t\tifFalse: [ kw := v := arg ].\r\n\t\tnamed ifTrue: ['(Array with: ' ,kw asLiteral,' with: ' ,v ,$) ]\r\n\t\tifFalse: [ v ]\r\n\t].\r\n\tarray isEmpty ifTrue: [ ^'#()'].\r\n\tarray size <= 3 ifTrue: [\r\n\t\t^(array inject: $( ,#Array into: [:total :each|\r\n\t\t\ttotal,' with: ',(element value: each)\r\n\t\t]) ,$)\r\n\t].\r\n\t^'(Array new'\r\n\t,(array inject: '' into: [:total :each|\r\n\t\ttotal,' add: ',(element value: each) ,$;\r\n\t]) ,' yourself)' ","function(self,array,named)\r\nlocal element=nil\r\n(function()\r\n\tlocal _s8_value=((function(arg)\r\nlocal kw=nil\r\nlocal v=nil\r\nif ((arg):isArray())==true then (function()\r\n\tlocal _s8_value=((arg):first())\r\n\tkw=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((arg):first()),\" \")),(arg):last()))\r\n\tv=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=((function()\r\n\tlocal _s8_value=(arg)\r\n\tv=_s8_value\r\n\treturn _s8_value\r\nend)())\r\n\tkw=_s8_value\r\n\treturn _s8_value\r\nend)(); end;return (smalltalk:if_true_false_((named),(function()\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"(Array with: \"),(kw):asLiteral())),\" with: \")),v)),\")\"))\r\nend),(function()\r\nreturn (v)\r\nend)))\r\nend))\r\n\telement=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((array):isEmpty())==true then return (\"#()\"); end;\r\nif ((((array):size()) <= 3))==true then return (smalltalk:object_comma_(((array):inject_into_(smalltalk:object_comma_((\"(\"),\"Array\"),(function(total,each)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((total),\" with: \")),(element):value_(each)))\r\nend))),\")\")); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"(Array new\"),(array):inject_into_(\"\",(function(total,each)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),\" add: \")),(element):value_(each))),\";\"))\r\nend)))),\" yourself)\"));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"apiEncode:call:arguments:on:header:",0
,function(self,delegate,aSelector,array,code,header)
if (smalltalk:boolean_or_(((aSelector):includes_("!")),(function()
return ((array):includes_((self):kwargsStart()))
end)))==true then local stream=nil
(function()
	local _s8_value=((array):readStream())
	stream=_s8_value
	return _s8_value
end)();
return ((self):apiEncode_call_args_kwargs_on_header_(delegate,aSelector,(stream):upTo_((self):kwargsStart()),(stream):upToEnd(),code,header)); end;
return ((self):apiEncode_call_args_on_header_(delegate,aSelector,array,code,header));
end
,"builders","apiEncode: delegate\r\n\tcall: aSelector arguments: array\r\n\ton: code header: header\r\n\t\" Private - Generate code to call function onto code&header streams. \"\r\n\r\n\t((aSelector includes: $!) or: [array includes: self kwargsStart]) ifTrue: [\r\n\t\t| stream | stream := array readStream.\r\n\t\t^self\tapiEncode: delegate call: aSelector\r\n\t\t\targs: (stream upTo: self kwargsStart) kwargs: stream upToEnd\r\n\t\t\ton: code header: header\r\n\t].\r\n\t^self\tapiEncode: delegate\r\n\t\tcall: aSelector args: array\r\n\t\ton: code header: header","function(self,delegate,aSelector,array,code,header)\r\nif (smalltalk:boolean_or_(((aSelector):includes_(\"!\")),(function()\r\nreturn ((array):includes_((self):kwargsStart()))\r\nend)))==true then local stream=nil\r\n(function()\r\n\tlocal _s8_value=((array):readStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):apiEncode_call_args_kwargs_on_header_(delegate,aSelector,(stream):upTo_((self):kwargsStart()),(stream):upToEnd(),code,header)); end;\r\nreturn ((self):apiEncode_call_args_on_header_(delegate,aSelector,array,code,header));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"codeForInstanceReceiver",0
,function(self)
return ("self handle #");
end
,"private","codeForInstanceReceiver\r\n\t\" Private - Return the code for the receiver of instance function call.\r\n\tDefault answer asumes a wrapper calling with syntax sugar.\r\n\tThis method can be refined to adapt to custom platform calls.\r\n\t\"\r\n\r\n\t^'self handle #'","function(self)\r\nreturn (\"self handle #\");\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildFunction:arguments:prologue:epilogue:",0
,function(self,spec,args,prologue,epilogue)
local header=nil
local code=nil
if ((args):includes_((self):kwargsStart()))==true then local array=nil
(function()
	local _s8_value=(((args):stream()):upTo_((self):kwargsStart()))
	array=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((args):last()),(self):kwargsStart())),(function()
return ((self):buildFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))
end),(function()
(array):add_((self):kwargsStart());return ((self):buildFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))
end)); end;
(function()
	local _s8_value=((""):writeStream())
	header=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((""):writeStream())
	code=_s8_value
	return _s8_value
end)();
(
function(_s8_rec)
	(_s8_rec):apiEncode_call_arguments_on_header_((self):codeForInstanceReceiver(),spec,args,code,header);
	return ((_s8_rec):implement_comment_as_category_((self):stMessageHeader_((header):contents()),"Delegate to handle.",(smalltalk:object_comma_((smalltalk:object_comma_((prologue),(code):contents())),epilogue)):replace_with_("!",smalltalk:object_comma_(("!"),"!")),"wrappers"))
end
)(self);
return (self);
end
,"builders","buildFunction: spec arguments: args prologue: prologue epilogue: epilogue \r\n\t\" Private - Generate code to delegate message on instance handle. \"\r\n\r\n\t| header code |\r\n\t(args includes: self kwargsStart) ifTrue: [ | array |\r\n\t\tarray := args stream upTo: self kwargsStart.\r\n\t\targs last = self kwargsStart\r\n\t\tifTrue: [ self\tbuildFunction: spec arguments: array\r\n\t\t\t\tprologue: prologue epilogue: epilogue ]\r\n\t\tifFalse: [\r\n\t\t\tarray add: self kwargsStart.\r\n\t\t\tself\tbuildFunction: spec arguments: array\r\n\t\t\t\tprologue: prologue epilogue: epilogue \r\n\t\t].\r\n\t].\r\n\theader := '' writeStream. code := '' writeStream.\r\n\tself\r\n\t  apiEncode: self codeForInstanceReceiver\r\n\t\tcall: spec arguments: args\r\n\t\ton: code header: header;\r\n\t  implement: (self stMessageHeader: header contents)\r\n\t\tcomment: 'Delegate to handle.'\r\n\t\tas:\t((prologue\r\n\t\t\t, code contents\r\n\t\t\t, epilogue) replace: $! with: $! ,$!)\r\n\t\tcategory: #wrappers","function(self,spec,args,prologue,epilogue)\r\nlocal header=nil\r\nlocal code=nil\r\nif ((args):includes_((self):kwargsStart()))==true then local array=nil\r\n(function()\r\n\tlocal _s8_value=(((args):stream()):upTo_((self):kwargsStart()))\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:isObject_equalTo_(((args):last()),(self):kwargsStart())),(function()\r\nreturn ((self):buildFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))\r\nend),(function()\r\n(array):add_((self):kwargsStart());return ((self):buildFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))\r\nend)); end;\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\theader=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):apiEncode_call_arguments_on_header_((self):codeForInstanceReceiver(),spec,args,code,header);\r\n\treturn ((_s8_rec):implement_comment_as_category_((self):stMessageHeader_((header):contents()),\"Delegate to handle.\",(smalltalk:object_comma_((smalltalk:object_comma_((prologue),(code):contents())),epilogue)):replace_with_(\"!\",smalltalk:object_comma_((\"!\"),\"!\")),\"wrappers\"))\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"codeForStaticReceiver",0
,function(self)
return ("self nativeClass handle #");
end
,"private","codeForStaticReceiver\r\n\t\" Private - Return the code for the receiver of static function call.\r\n\tDefault answer asumes a nativeClass wrapper calling with syntax sugar.\r\n\tThis method can be refined to adapt to custom platform calls.\r\n\t\"\r\n\r\n\t^'self nativeClass handle #'","function(self)\r\nreturn (\"self nativeClass handle #\");\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"nativeClass",0
,function(self)
return ((self):implementedBySubclass_("nativeClass"));
end
,"private","nativeClass\r\n\t\" Private - Return the wrapper for native binding of the receiver. \"\r\n\r\n\t^self implementedBySubclass: #nativeClass","function(self)\r\nreturn ((self):implementedBySubclass_(\"nativeClass\"));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildConstants",0
,function(self)
return ((self):buildConstants_((self):constants()));
end
,"builders","buildConstants\r\n\t\" Build the methods for constants defined in the receiver's library. \"\r\n\r\n\t^self buildConstants: self constants","function(self)\r\nreturn ((self):buildConstants_((self):constants()));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildConstants:",0
,function(self,constants)
return ((self):build_doing_(("Constants"):_minus_gt(constants),(function()
return (smalltalk:if_true_false_(((constants):isString()),(function()
local stream=nil
(function()
	local _s8_value=((constants):stream())
	stream=_s8_value
	return _s8_value
end)();return (smalltalk:whileNot_do_(((function()
return ((stream):atEnd())
end)),(function()
return ((self):buildConstant_(((stream):nextLine()):trimBlanks()))
end)))
end),(function()
return ((constants):do_((function(each)
return ((self):buildConstant_(each))
end)))
end)))
end)));
end
,"builders","buildConstants: constants\r\n\t\" Build the methods for constants. \"\r\n\r\n\t^self build: #Constants -> constants doing: [\r\n\t\tconstants isString ifTrue: [ | stream |\r\n\t\t\tstream := constants stream.\r\n\t\t\t[stream atEnd] whileFalse: [\r\n\t\t\t\tself buildConstant: stream nextLine trimBlanks\r\n\t\t\t]\r\n\t\t] ifFalse: [ constants do: [:each| self buildConstant: each ] ]\r\n\t]","function(self,constants)\r\nreturn ((self):build_doing_((\"Constants\"):_minus_gt(constants),(function()\r\nreturn (smalltalk:if_true_false_(((constants):isString()),(function()\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((constants):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:whileNot_do_(((function()\r\nreturn ((stream):atEnd())\r\nend)),(function()\r\nreturn ((self):buildConstant_(((stream):nextLine()):trimBlanks()))\r\nend)))\r\nend),(function()\r\nreturn ((constants):do_((function(each)\r\nreturn ((self):buildConstant_(each))\r\nend)))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildConstant:",0
,function(self,spec)
local selector=nil
if ((spec):isEmpty())==true then return (self); end;
(function()
	local _s8_value=(((spec):fromLast_(".")):asSmalltalkName_(false))
	selector=_s8_value
	return _s8_value
end)();
((self)["$klass"]):implement_comment_as_category_(selector,smalltalk:object_comma_(("Return the constant value for "),spec),smalltalk:object_comma_(("^"),(self):codeToGetConstant_(spec)),"constants");
return (self);
end
,"builders","buildConstant: spec\r\n\t\" Private - Build the accessor for constant spec. \"\r\n\r\n\t| selector |\r\n\tspec isEmpty ifTrue: [ ^self ].\r\n\tselector := (spec fromLast: $.) asSmalltalkName: false.\r\n\tself class\r\n\t\timplement: selector\r\n\t\tcomment: 'Return the constant value for ' ,spec\r\n\t\tas: $^ ,(self codeToGetConstant: spec) category: #constants","function(self,spec)\r\nlocal selector=nil\r\nif ((spec):isEmpty())==true then return (self); end;\r\n(function()\r\n\tlocal _s8_value=(((spec):fromLast_(\".\")):asSmalltalkName_(false))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self)[\"$klass\"]):implement_comment_as_category_(selector,smalltalk:object_comma_((\"Return the constant value for \"),spec),smalltalk:object_comma_((\"^\"),(self):codeToGetConstant_(spec)),\"constants\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"library",0
,function(self)
return ((self):new());
end
,"private","library\r\n\t\" Private - Returns the library of the receiver.\r\n\tA new instance is returned by default.\r\n\tThis method can be refined by subclasses (e.g. implementing singleton). \"\r\n\r\n\t^self new ","function(self)\r\nreturn ((self):new());\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"codeToGetConstant:",0
,function(self,spec)
if ((spec):isArray())==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((spec):last())," @ (")),(self):codeToGetConstant_((spec):first()))),")")); end;
return (smalltalk:object_comma_(("self library @ "),(spec):asLiteral()));
end
,"builders","codeToGetConstant: spec\r\n\t\" Private - Returns the code to get the constant value for spec. \"\r\n\r\n\tspec isArray ifTrue: [\r\n\t\t^spec last ,' @ (' ,(self codeToGetConstant: spec first) ,$)\r\n\t].\r\n\t^'self library @ ' ,spec asLiteral ","function(self,spec)\r\nif ((spec):isArray())==true then return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((spec):last()),\" @ (\")),(self):codeToGetConstant_((spec):first()))),\")\")); end;\r\nreturn (smalltalk:object_comma_((\"self library @ \"),(spec):asLiteral()));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"constants",0
,function(self)
return ((self):constantsIn_((self):library()));
end
,"builders","constants\r\n\t\" Returns the constants implemented by receiver's library. \"\r\n\r\n\t^self constantsIn: self library","function(self)\r\nreturn ((self):constantsIn_((self):library()));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"constantsIn:",0
,function(self,aNativeObject)
return (((((aNativeObject):keys()):select_((function(key)
return ((smalltalk:newArray({"Number", "String"})):includes_((self):typeOf_((aNativeObject):_at(key))))
end))):reject_((function(key)
return ((key):startsWith_("_"))
end))):sorted());
end
,"builders","constantsIn: aNativeObject\r\n\t\" Returns the constants implemented by aNativeObject. \"\r\n\r\n\t^((aNativeObject keys\r\n\t\tselect: [:key| #(Number String) includes: (self typeOf: aNativeObject@key) ])\r\n\t\treject: [:key| key startsWith: $_ ]) sorted","function(self,aNativeObject)\r\nreturn (((((aNativeObject):keys()):select_((function(key)\r\nreturn ((smalltalk:newArray({\"Number\", \"String\"})):includes_((self):typeOf_((aNativeObject):_at(key))))\r\nend))):reject_((function(key)\r\nreturn ((key):startsWith_(\"_\"))\r\nend))):sorted());\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"newInstanceOf:withAll:",0
,function(self,aName,handlesArray)
local fn=nil
(function()
	local _s8_value=((self):instantiatorFor_(aName))
	fn=_s8_value
	return _s8_value
end)();

return ((fn):evaluateWithArguments_(handlesArray));
end
,"api","newInstanceOf: aName withAll: handlesArray\r\n\t\" Private - Returns the handle result of instatiating native object of type aName. \"\r\n\r\n\t| fn |\r\n\tfn := self instantiatorFor: aName.\r\n\t{'self'}.\r\n\t^fn evaluateWithArguments: handlesArray","function(self,aName,handlesArray)\r\nlocal fn=nil\r\n(function()\r\n\tlocal _s8_value=((self):instantiatorFor_(aName))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n\r\nreturn ((fn):evaluateWithArguments_(handlesArray));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"instantiatorFor:",0
,function(self,aName)
return (((self):library()):_at(aName));
end
,"api","instantiatorFor: aName\r\n\t\" Private - Returns the function to evaluate when creating native instance. \"\r\n\r\n\t^self library @ aName","function(self,aName)\r\nreturn (((self):library()):_at(aName));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"instantiate:withAll:",0
,function(self,aNativeObjectClass,handlesArray)
return ((aNativeObjectClass):_at((self):newInstanceOf_withAll_((aNativeObjectClass):name(),handlesArray)));
end
,"api","instantiate: aNativeObjectClass withAll: handlesArray\r\n\t\" Returns the result of instatiating aCVObjectClass. \"\r\n\r\n\t^aNativeObjectClass @ (self\r\n\t\tnewInstanceOf: aNativeObjectClass name\r\n\t\twithAll: handlesArray)","function(self,aNativeObjectClass,handlesArray)\r\nreturn ((aNativeObjectClass):_at((self):newInstanceOf_withAll_((aNativeObjectClass):name(),handlesArray)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSubclasses:in:",0
,function(self,classNames,packageName)
return ((self):buildSubclasses_in_reference_(classNames,packageName,nil));
end
,"builders","buildSubclasses: classNames in: packageName\r\n\t\" Private - Generate subclasses of the receiver. \"\r\n\r\n\t^self buildSubclasses: classNames in: packageName reference: nil","function(self,classNames,packageName)\r\nreturn ((self):buildSubclasses_in_reference_(classNames,packageName,nil));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSubclasses:in:reference:",0
,function(self,classSpecs,packageName,urlSite)
(classSpecs):do_((function(spec)
return ((self):buildSubclass_in_reference_(spec,packageName,urlSite))
end));
return (self);
end
,"builders","buildSubclasses: classSpecs in: packageName reference: urlSite\r\n\t\" Private - Generate subclasses of the receiver. \"\r\n\r\n\tclassSpecs do: [:spec|\r\n\t\tself buildSubclass: spec in: packageName reference: urlSite\r\n\t]","function(self,classSpecs,packageName,urlSite)\r\n(classSpecs):do_((function(spec)\r\nreturn ((self):buildSubclass_in_reference_(spec,packageName,urlSite))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSubclass:in:",0
,function(self,spec,packageName)
return ((self):buildSubclass_in_reference_(spec,packageName,nil));
end
,"builders","buildSubclass: spec in: packageName\r\n\t\" Private - Generate a subclass of the receiver. \"\r\n\r\n\t^self buildSubclass: spec in: packageName reference: nil","function(self,spec,packageName)\r\nreturn ((self):buildSubclass_in_reference_(spec,packageName,nil));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"urlReference",0
,function(self)
return ("none");
end
,"builders","urlReference\r\n\t\" Private - Returns the URL of package site. \"\r\n\r\n\t^#none ","function(self)\r\nreturn (\"none\");\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"urlSelector",0
,function(self)
return (nil);
end
,"builders","urlSelector\r\n\t\" Private - Returns the selector for urlSite. \"\r\n\r\n\t^nil ","function(self)\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"urlSelectors",0
,function(self)
return ((smalltalk.Array):with_((self):urlSelector()));
end
,"builders","urlSelectors\r\n\t\" Private - Returns the selector for urlSite. \"\r\n\r\n\t^Array with: self urlSelector ","function(self)\r\nreturn ((smalltalk.Array):with_((self):urlSelector()));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"referenceTo:in:at:",0
,function(self,topic,packageName,urlSite)
if (smalltalk:isObject_equalTo_((urlSite),(self):urlSelector()))==true then return ((self):referenceTo_in_at_(topic,packageName,(self):urlReference())); end;
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((urlSite),"/")),smalltalk:if_true_false_((smalltalk:notNil_((packageName))),(function()
return (smalltalk:object_comma_(((packageName):replace_with_(".","/")),"/"))
end),(function()
return ("")
end)))),topic)),".html"));
end
,"builders","referenceTo: topic in: packageName at: urlSite\r\n\t\" Private - Returns the URL to find documentation on topic. \"\r\n\r\n\turlSite = self urlSelector ifTrue: [\r\n\t\t^self\treferenceTo: topic in: packageName\r\n\t\t\tat: self urlReference\r\n\t].\r\n\t^urlSite ,$/\r\n\t\t,(packageName notNil ifTrue: [ (packageName replace: $. with: $/) ,$/ ] ifFalse: [''])\r\n\t\t,topic ,'.html'","function(self,topic,packageName,urlSite)\r\nif (smalltalk:isObject_equalTo_((urlSite),(self):urlSelector()))==true then return ((self):referenceTo_in_at_(topic,packageName,(self):urlReference())); end;\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((urlSite),\"/\")),smalltalk:if_true_false_((smalltalk:notNil_((packageName))),(function()\r\nreturn (smalltalk:object_comma_(((packageName):replace_with_(\".\",\"/\")),\"/\"))\r\nend),(function()\r\nreturn (\"\")\r\nend)))),topic)),\".html\"));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildSubclass:in:reference:",0
,function(self,spec,packageName,urlSite)
local cls=nil
local className=nil
if not (((spec):isString()))==true then (function()
	local _s8_value=((spec):first())
	cls=_s8_value
	return _s8_value
end)();
if ((cls):isString())==true then (function()
	local _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(cls,(function()
return ((self):buildSubclass_in_reference_(cls,packageName,urlSite))
end)))
	cls=_s8_value
	return _s8_value
end)(); else (self):error_(smalltalk:object_comma_(("Invalid superClass name: "),cls)); end;
return (((spec):copyFrom_to_(2,(spec):size())):collect_((function(each)
return ((cls):buildSubclass_in_reference_(each,packageName,urlSite))
end))); end;
(function()
	local _s8_value=(spec)
	className=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((packageName))),(function()
return ((self):subclass_category_(className,packageName))
end),(function()
return ((self):subclass_(className))
end)))
	cls=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_and_((smalltalk:isNil_((urlSite))),(function()
return (smalltalk:boolean_and_((smalltalk:notNil_((packageName))),(function()
return (((self):urlSelectors()):includes_((packageName):upTo_(".")))
end)))
end)))==true then (function()
	local _s8_value=((self):urlSelector())
	urlSite=_s8_value
	return _s8_value
end)(); end;
if (smalltalk:boolean_and_((smalltalk:notNil_((urlSite))),(function()
return ((not smalltalk:isObject_equalTo_((urlSite),"none")))
end)))==true then (cls):comment_(smalltalk:object_comma_(("See "),(self):referenceTo_in_at_(className,packageName,urlSite))); end;
if (smalltalk:responds_to_((cls),("packagePrefix:")))==true then (cls):packagePrefix_(packageName); end;
return (cls);
end
,"builders","buildSubclass: spec in: packageName reference: urlSite\r\n\t\" Private - Generate a subclass of the receiver. \"\r\n\r\n\t| cls className |\r\n\tspec isString ifFalse: [ \"spec can be #(superClassName className...) \"\r\n\t\tcls := spec first.\r\n\t\tcls isString ifTrue: [\r\n\t\t\tcls := Smalltalk at: cls ifAbsent: [\r\n\t\t\t\tself buildSubclass: cls in: packageName reference: urlSite\r\n\t\t\t]\r\n\t\t] ifFalse: [ self error: 'Invalid superClass name: ',cls ].\r\n\t\t^(spec copyFrom: 2 to: spec size) collect: [:each|\r\n\t\t\tcls buildSubclass: each in: packageName reference: urlSite\r\n\t\t]\r\n\t].\r\n\tclassName := spec.\r\n\tcls := packageName notNil\r\n\t\tifTrue: [ self subclass: className category: packageName ]\r\n\t\tifFalse: [ self subclass: className ].\r\n\t(urlSite isNil and: [packageName notNil and: [\r\n\t\tself urlSelectors includes: (packageName upTo: $.)\r\n\t\t]]) ifTrue: [ urlSite := self urlSelector ].\r\n\t(urlSite notNil and: [urlSite ~= #none]) ifTrue: [\r\n\t\tcls comment: 'See ' ,(self referenceTo: className in: packageName at: urlSite)\r\n\t].\r\n\t(cls respondsTo: #packagePrefix:) ifTrue: [\r\n\t\tcls packagePrefix: packageName\r\n\t].\r\n\t^cls","function(self,spec,packageName,urlSite)\r\nlocal cls=nil\r\nlocal className=nil\r\nif not (((spec):isString()))==true then (function()\r\n\tlocal _s8_value=((spec):first())\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((cls):isString())==true then (function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(cls,(function()\r\nreturn ((self):buildSubclass_in_reference_(cls,packageName,urlSite))\r\nend)))\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)(); else (self):error_(smalltalk:object_comma_((\"Invalid superClass name: \"),cls)); end;\r\nreturn (((spec):copyFrom_to_(2,(spec):size())):collect_((function(each)\r\nreturn ((cls):buildSubclass_in_reference_(each,packageName,urlSite))\r\nend))); end;\r\n(function()\r\n\tlocal _s8_value=(spec)\r\n\tclassName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((packageName))),(function()\r\nreturn ((self):subclass_category_(className,packageName))\r\nend),(function()\r\nreturn ((self):subclass_(className))\r\nend)))\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_and_((smalltalk:isNil_((urlSite))),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:notNil_((packageName))),(function()\r\nreturn (((self):urlSelectors()):includes_((packageName):upTo_(\".\")))\r\nend)))\r\nend)))==true then (function()\r\n\tlocal _s8_value=((self):urlSelector())\r\n\turlSite=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif (smalltalk:boolean_and_((smalltalk:notNil_((urlSite))),(function()\r\nreturn ((not smalltalk:isObject_equalTo_((urlSite),\"none\")))\r\nend)))==true then (cls):comment_(smalltalk:object_comma_((\"See \"),(self):referenceTo_in_at_(className,packageName,urlSite))); end;\r\nif (smalltalk:responds_to_((cls),(\"packagePrefix:\")))==true then (cls):packagePrefix_(packageName); end;\r\nreturn (cls);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildConstructors:",0
,function(self,selectors)
(self):build_doing_(("Constructors"):_minus_gt(selectors),(function()
return ((selectors):do_((function(each)
return ((self):buildConstructor_(each))
end)))
end));
return (self);
end
,"builders","buildConstructors: selectors\r\n\t\" Generate code for constructors implemented by native class. \"\r\n\r\n\tself build: #Constructors -> selectors doing: [\r\n\t\tselectors do: [:each| self buildConstructor: each ]\r\n\t]","function(self,selectors)\r\n(self):build_doing_((\"Constructors\"):_minus_gt(selectors),(function()\r\nreturn ((selectors):do_((function(each)\r\nreturn ((self):buildConstructor_(each))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildConstructor:",0
,function(self,selector)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if ((selector):isArray())==true then if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((selector):size()),3)),(function()
return (((selector):last()):isString())
end)))==true then return ((self):buildStaticFunction_(selector)); end;
smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((selector):size()),2)),(function()
return (((selector):last()):isString())
end))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):buildStaticFunction_(selector))
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):buildConstructorFor_(selector))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"builders","buildConstructor: selector\r\n\t\" Private - Generate code for constructor of native class. \"\r\n\r\n\tselector isArray ifTrue: [\r\n\t    (selector size = 3 and: [selector last isString]) ifTrue: [ \"#( selector #( argumentNames ) #RETURNClass )\"\r\n\t\t^self buildStaticFunction: selector\r\n\t    ]. \r\n\t    (selector size = 2 and: [selector last isString]) ifTrue: [ \"#( selector #RETURNClass )\"\r\n\t\t^self buildStaticFunction: selector\r\n\t    ]. \r\n\t].\r\n\t^self buildConstructorFor: selector","function(self,selector)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif ((selector):isArray())==true then if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((selector):size()),3)),(function()\r\nreturn (((selector):last()):isString())\r\nend)))==true then return ((self):buildStaticFunction_(selector)); end;\r\nsmalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((selector):size()),2)),(function()\r\nreturn (((selector):last()):isString())\r\nend))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):buildStaticFunction_(selector))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):buildConstructorFor_(selector))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildConstructorFor:",0
,function(self,selector)
local args=nil
if ((selector):isArray())==true then return ((self):buildConstructor_arguments_((selector):first(),(selector):last())); end;
(function()
	local _s8_value=(((1):to_((selector):occurrencesOf_(":"))):collect_((function(i)
return (smalltalk:object_comma_(("arg"),smalltalk:asString_((i))))
end)))
	args=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((args):size()),1))==true then (function()
	local _s8_value=(smalltalk:newArray({"anObject"}))
	args=_s8_value
	return _s8_value
end)(); end;
return ((self):buildConstructor_arguments_(selector,args));
end
,"builders","buildConstructorFor: selector\r\n\t\" Private - Generate code for constructor of native class. \"\r\n\r\n\t| args |\r\n\tselector isArray ifTrue: [ \"#( selector #(argumentNames) )\"\r\n\t\t^self\tbuildConstructor: selector first\r\n\t\t\targuments: selector last\r\n\t].\r\n\targs :=  (1 to: (selector occurrencesOf: $:)) collect: [:i| #arg , i asString ].\r\n\targs size = 1 ifTrue: [ args := #( #anObject ) ].\r\n\t^self buildConstructor: selector arguments: args","function(self,selector)\r\nlocal args=nil\r\nif ((selector):isArray())==true then return ((self):buildConstructor_arguments_((selector):first(),(selector):last())); end;\r\n(function()\r\n\tlocal _s8_value=(((1):to_((selector):occurrencesOf_(\":\"))):collect_((function(i)\r\nreturn (smalltalk:object_comma_((\"arg\"),smalltalk:asString_((i))))\r\nend)))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((args):size()),1))==true then (function()\r\n\tlocal _s8_value=(smalltalk:newArray({\"anObject\"}))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((self):buildConstructor_arguments_(selector,args));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"constructorSupport",0
,function(self)
return ("self");
end
,"builders","constructorSupport\r\n\t\" Private - Returns the instantiation support for constructor. \"\r\n\r\n\t^#self","function(self)\r\nreturn (\"self\");\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildConstructor:arguments:",0
,function(self,aSelector,array)
local selector=nil
local args=nil
local header=nil
local code=nil
local input=nil
local argStream=nil
local msg=nil
local long=nil
local adder=nil
local comma=nil
(function()
	local _s8_value=((self):apiArgumentsFrom_(array))
	args=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):apiSelector_forArguments_(aSelector,args))
	selector=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((((args):size()) > 4))
	long=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((selector):stream())
	input=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((args):stream())
	argStream=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((""):writeStream())
	header=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((""):writeStream())
	code=_s8_value
	return _s8_value
end)();
(code):nextPutAll_(smalltalk:if_true_false_((long),(function()
return ("#()")
end),(function()
return ("Array")
end)));
(function()
	local _s8_value=(smalltalk:if_true_false_((long),(function()
return (" add: ")
end),(function()
return (" with: ")
end)))
	adder=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((long),(function()
return (";")
end),(function()
return ("")
end)))
	comma=_s8_value
	return _s8_value
end)();
(header):nextPut_(((input):next()):asLowercase());
if ((argStream):atEnd())==true then (code):nextPutAll_(" new"); end;
while not ((function()
return ((argStream):atEnd())
end))() do local param=nil
local expr=nil
if (((argStream):peek()):isString())==true then (function()
	local _s8_value=((argStream):next())
	param=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(param)
	expr=_s8_value
	return _s8_value
end)(); else (function()
	local _s8_value=(((argStream):peek()):first())
	param=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((param)," ")),((argStream):next()):last()))
	expr=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=(smalltalk:object_comma_(((input):upTo_(":")),": "))
	msg=_s8_value
	return _s8_value
end)();
(code):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((adder),expr)),comma));
(header):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((msg),param))," ")); end;
(code):nextPutAll_(smalltalk:if_true_false_((long),(function()
return (" yourself")
end),(function()
return ("")
end)));
(function()
	local _s8_value=((input):upToEnd())
	msg=_s8_value
	return _s8_value
end)();
(code):nextPutAll_(msg);
(header):nextPutAll_(msg);
((self)["$klass"]):implement_comment_as_category_((self):stMessageHeader_((header):contents()),"Returns an instance of the receiver.",smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("^"),(self):constructorSupport()))," instantiate: self withAll: (")),(code):contents())),")"),"instantiation");
return (self);
end
,"builders","buildConstructor: aSelector arguments: array\r\n\t\" Private - Generate code for constructor of native class. \"\r\n\r\n\t| selector args header code input argStream msg long adder comma |\r\n\targs := self apiArgumentsFrom: array.\r\n\tselector := self apiSelector: aSelector forArguments: args.\r\n\tlong := args size > 4.\r\n\tinput := selector stream.\r\n\targStream := args stream.\r\n\theader := '' writeStream. code := '' writeStream.\r\n\tcode nextPutAll: (long ifTrue: [ '#()' ] ifFalse: [ #Array ]).\r\n\tadder := long ifTrue: [' add: '] ifFalse: [' with: '].\r\n\tcomma := long ifTrue: [$;] ifFalse: [''].\r\n\theader nextPut: input next asLowercase.\r\n\targStream atEnd ifTrue: [ code nextPutAll: ' new' ].\r\n\t[ argStream atEnd ] whileFalse: [ | param expr |\r\n\t\targStream peek isString\r\n\t\tifTrue: [ param := argStream next. expr := param ]\r\n\t\tifFalse: [ param := argStream peek first. expr := param ,' ' ,argStream next last. ].\r\n\t\tmsg := (input upTo: $:) ,': '.\r\n\t\tcode   nextPutAll: adder ,expr ,comma.\r\n\t\theader nextPutAll: msg ,param ,' '.\r\n\t].\r\n\tcode nextPutAll: (long ifTrue: [ ' yourself' ] ifFalse: [ '' ]).\r\n\tmsg := input upToEnd.\r\n\tcode nextPutAll: msg.\r\n\theader nextPutAll: msg.\r\n\tself class\r\n\t\timplement: (self stMessageHeader: header contents)\r\n\t\t  comment: 'Returns an instance of the receiver.'\r\n\t\t  as: $^ ,self constructorSupport ,' instantiate: self withAll: (' ,code contents ,')'\r\n\t\t  category: #instantiation","function(self,aSelector,array)\r\nlocal selector=nil\r\nlocal args=nil\r\nlocal header=nil\r\nlocal code=nil\r\nlocal input=nil\r\nlocal argStream=nil\r\nlocal msg=nil\r\nlocal long=nil\r\nlocal adder=nil\r\nlocal comma=nil\r\n(function()\r\n\tlocal _s8_value=((self):apiArgumentsFrom_(array))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):apiSelector_forArguments_(aSelector,args))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((((args):size()) > 4))\r\n\tlong=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((selector):stream())\r\n\tinput=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((args):stream())\r\n\targStream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\theader=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(code):nextPutAll_(smalltalk:if_true_false_((long),(function()\r\nreturn (\"#()\")\r\nend),(function()\r\nreturn (\"Array\")\r\nend)));\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((long),(function()\r\nreturn (\" add: \")\r\nend),(function()\r\nreturn (\" with: \")\r\nend)))\r\n\tadder=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((long),(function()\r\nreturn (\";\")\r\nend),(function()\r\nreturn (\"\")\r\nend)))\r\n\tcomma=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(header):nextPut_(((input):next()):asLowercase());\r\nif ((argStream):atEnd())==true then (code):nextPutAll_(\" new\"); end;\r\nwhile not ((function()\r\nreturn ((argStream):atEnd())\r\nend))() do local param=nil\r\nlocal expr=nil\r\nif (((argStream):peek()):isString())==true then (function()\r\n\tlocal _s8_value=((argStream):next())\r\n\tparam=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(param)\r\n\texpr=_s8_value\r\n\treturn _s8_value\r\nend)(); else (function()\r\n\tlocal _s8_value=(((argStream):peek()):first())\r\n\tparam=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((param),\" \")),((argStream):next()):last()))\r\n\texpr=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_(((input):upTo_(\":\")),\": \"))\r\n\tmsg=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(code):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((adder),expr)),comma));\r\n(header):nextPutAll_(smalltalk:object_comma_((smalltalk:object_comma_((msg),param)),\" \")); end;\r\n(code):nextPutAll_(smalltalk:if_true_false_((long),(function()\r\nreturn (\" yourself\")\r\nend),(function()\r\nreturn (\"\")\r\nend)));\r\n(function()\r\n\tlocal _s8_value=((input):upToEnd())\r\n\tmsg=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(code):nextPutAll_(msg);\r\n(header):nextPutAll_(msg);\r\n((self)[\"$klass\"]):implement_comment_as_category_((self):stMessageHeader_((header):contents()),\"Returns an instance of the receiver.\",smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"^\"),(self):constructorSupport())),\" instantiate: self withAll: (\")),(code):contents())),\")\"),\"instantiation\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildStaticFunctions:",0
,function(self,specs)
(self):build_doing_(("StaticFunctions"):_minus_gt(specs),(function()
return ((specs):do_((function(each)
return ((self):buildStaticFunction_(each))
end)))
end));
return (self);
end
,"builders","buildStaticFunctions: specs\r\n\t\" Generate code from specs as functions implemented implemented by native class. \"\r\n\r\n\tself build: #StaticFunctions -> specs doing: [\r\n\t\tspecs do: [:each| self buildStaticFunction: each ]\r\n\t]","function(self,specs)\r\n(self):build_doing_((\"StaticFunctions\"):_minus_gt(specs),(function()\r\nreturn ((specs):do_((function(each)\r\nreturn ((self):buildStaticFunction_(each))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildStaticFunction:",0
,function(self,spec)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if ((spec):isArray())==true then if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),3)),(function()
return (((spec):last()):isString())
end)))==true then return ((self):buildStaticFunction_((smalltalk.Array):with_with_((smalltalk.Array):with_with_((spec):first(),(spec):second()),(spec):last()))); end;
smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),2)),(function()
return (((spec):last()):isString())
end))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):buildStaticFunction_prologue_epilogue_((spec):first(),(self):apiPrologueFor_((spec):second()),(self):apiEpilogueFor_((spec):second())))
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):buildStaticFunction_prologue_epilogue_(spec,"^",""))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"builders","buildStaticFunction: spec\r\n\t\" Private - Generate code to delegate message implemented as functions on native class. \"\r\n\r\n\tspec isArray ifTrue: [\r\n\t    (spec size = 3 and: [spec last isString]) ifTrue: [ \"#( selector #( argumentNames ) #RETURNClass )\"\r\n\t\t^self buildStaticFunction: (Array\r\n\t\t\twith: (Array with: spec first with: spec second)\r\n\t\t\twith: spec last)\r\n\t    ]. \r\n\t    (spec size = 2 and: [spec last isString]) ifTrue: [ \"#( selector #RETURNClass )\"\r\n\t\t^self\r\n\t\t\tbuildStaticFunction: spec first\r\n\t\t\tprologue: (self apiPrologueFor: spec second)\r\n\t\t\tepilogue: (self apiEpilogueFor: spec second)\r\n\t    ].\r\n\t].\r\n\t^self buildStaticFunction: spec prologue: $^ epilogue: ''","function(self,spec)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif ((spec):isArray())==true then if (smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),3)),(function()\r\nreturn (((spec):last()):isString())\r\nend)))==true then return ((self):buildStaticFunction_((smalltalk.Array):with_with_((smalltalk.Array):with_with_((spec):first(),(spec):second()),(spec):last()))); end;\r\nsmalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_(((spec):size()),2)),(function()\r\nreturn (((spec):last()):isString())\r\nend))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):buildStaticFunction_prologue_epilogue_((spec):first(),(self):apiPrologueFor_((spec):second()),(self):apiEpilogueFor_((spec):second())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):buildStaticFunction_prologue_epilogue_(spec,\"^\",\"\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildStaticFunction:prologue:epilogue:",0
,function(self,spec,prologue,epilogue)
local args=nil
if ((spec):isArray())==true then return ((self):buildStaticFunction_arguments_prologue_epilogue_((spec):first(),(spec):last(),prologue,epilogue)); end;
(function()
	local _s8_value=(((1):to_((spec):occurrencesOf_(":"))):collect_((function(i)
return (smalltalk:object_comma_(("arg"),smalltalk:asString_((i))))
end)))
	args=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((args):size()),1))==true then (function()
	local _s8_value=(smalltalk:newArray({"anObject"}))
	args=_s8_value
	return _s8_value
end)(); end;
return ((self):buildStaticFunction_arguments_prologue_epilogue_(spec,args,prologue,epilogue));
end
,"builders","buildStaticFunction: spec prologue: prologue epilogue: epilogue \r\n\t\" Private - Generate code to delegate message on native class. \"\r\n\r\n\t| args |\r\n\tspec isArray ifTrue: [ \"#( selector #(argumentNames) )\"\r\n\t\t^self\tbuildStaticFunction: spec first\r\n\t\t\targuments: spec last\r\n\t\t\tprologue: prologue epilogue: epilogue\r\n\t].\r\n\targs :=  (1 to: (spec occurrencesOf: $:)) collect: [:i| #arg , i asString ].\r\n\targs size = 1 ifTrue: [ args := #( #anObject ) ].\r\n\t^self\r\n\t\tbuildStaticFunction: spec arguments: args\r\n\t\tprologue: prologue epilogue: epilogue ","function(self,spec,prologue,epilogue)\r\nlocal args=nil\r\nif ((spec):isArray())==true then return ((self):buildStaticFunction_arguments_prologue_epilogue_((spec):first(),(spec):last(),prologue,epilogue)); end;\r\n(function()\r\n\tlocal _s8_value=(((1):to_((spec):occurrencesOf_(\":\"))):collect_((function(i)\r\nreturn (smalltalk:object_comma_((\"arg\"),smalltalk:asString_((i))))\r\nend)))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((args):size()),1))==true then (function()\r\n\tlocal _s8_value=(smalltalk:newArray({\"anObject\"}))\r\n\targs=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((self):buildStaticFunction_arguments_prologue_epilogue_(spec,args,prologue,epilogue));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildStaticFunction:arguments:prologue:epilogue:",0
,function(self,spec,args,prologue,epilogue)
local header=nil
local code=nil
if ((args):includes_((self):kwargsStart()))==true then local array=nil
(function()
	local _s8_value=(((args):stream()):upTo_((self):kwargsStart()))
	array=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((args):last()),(self):kwargsStart())),(function()
return ((self):buildStaticFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))
end),(function()
(array):add_((self):kwargsStart());return ((self):buildStaticFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))
end)); end;
(function()
	local _s8_value=((""):writeStream())
	header=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((""):writeStream())
	code=_s8_value
	return _s8_value
end)();
(self):apiEncode_call_arguments_on_header_((self):codeForStaticReceiver(),spec,args,code,header);
((self)["$klass"]):implement_comment_as_category_((self):stMessageHeader_((header):contents()),"Delegated to native class.",(smalltalk:object_comma_((smalltalk:object_comma_((prologue),(code):contents())),epilogue)):replace_with_("!",smalltalk:object_comma_(("!"),"!")),"wrappers");
return (self);
end
,"builders","buildStaticFunction: spec arguments: args prologue: prologue epilogue: epilogue \r\n\t\" Private - Generate code to delegate message on native class. \"\r\n\r\n\t| header code |\r\n\t(args includes: self kwargsStart) ifTrue: [ | array |\r\n\t\tarray := args stream upTo: self kwargsStart.\r\n\t\targs last = self kwargsStart\r\n\t\tifTrue: [ self\tbuildStaticFunction: spec arguments: array\r\n\t\t\t\tprologue: prologue epilogue: epilogue ]\r\n\t\tifFalse: [\r\n\t\t\tarray add: self kwargsStart.\r\n\t\t\tself\tbuildStaticFunction: spec arguments: array\r\n\t\t\t\tprologue: prologue epilogue: epilogue \r\n\t\t].\r\n\t].\r\n\theader := '' writeStream. code := '' writeStream.\r\n\tself\r\n\t  apiEncode: self codeForStaticReceiver\r\n\t\tcall: spec arguments: args\r\n\t\ton: code header: header.\r\n\tself class\r\n\t\timplement: (self stMessageHeader: header contents)\r\n\t\t  comment: 'Delegated to native class.'\r\n\t\t  as:\t((prologue\r\n\t\t\t, code contents\r\n\t\t\t, epilogue) replace: $! with: $! ,$!)\r\n\t\t  category: #wrappers","function(self,spec,args,prologue,epilogue)\r\nlocal header=nil\r\nlocal code=nil\r\nif ((args):includes_((self):kwargsStart()))==true then local array=nil\r\n(function()\r\n\tlocal _s8_value=(((args):stream()):upTo_((self):kwargsStart()))\r\n\tarray=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:isObject_equalTo_(((args):last()),(self):kwargsStart())),(function()\r\nreturn ((self):buildStaticFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))\r\nend),(function()\r\n(array):add_((self):kwargsStart());return ((self):buildStaticFunction_arguments_prologue_epilogue_(spec,array,prologue,epilogue))\r\nend)); end;\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\theader=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((\"\"):writeStream())\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):apiEncode_call_arguments_on_header_((self):codeForStaticReceiver(),spec,args,code,header);\r\n((self)[\"$klass\"]):implement_comment_as_category_((self):stMessageHeader_((header):contents()),\"Delegated to native class.\",(smalltalk:object_comma_((smalltalk:object_comma_((prologue),(code):contents())),epilogue)):replace_with_(\"!\",smalltalk:object_comma_((\"!\"),\"!\")),\"wrappers\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildNativeFunctions:",0
,function(self,specs)
(self):build_doing_(("NativeFunctions"):_minus_gt(specs),(function()
local tuples=nil
(function()
	local _s8_value=((specs):collect_((function(spec)
return (smalltalk:if_true_false_(((spec):isString()),(function()
return (smalltalk:object_comma_(("_"),spec))
end),(function()
local selector=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((((spec):first()):isString()),(function()
return (smalltalk:object_comma_(("_"),(spec):first()))
end),(function()
return ((
function(_s8_rec)
	(_s8_rec):at_put_(1,smalltalk:object_comma_(("_"),((spec):first()):first()));
	return ((_s8_rec):yourself())
end
)(((spec):first()):copy()))
end)))
	selector=_s8_value
	return _s8_value
end)();return (smalltalk:object_comma_(((smalltalk.Array):with_(selector)),(spec):copyFrom_to_(2,(spec):size())))
end)))
end)))
	tuples=_s8_value
	return _s8_value
end)();return ((tuples):do_((function(spec)
return ((self):buildFunction_(spec))
end)))
end));
return (self);
end
,"builders","buildNativeFunctions: specs\r\n\t\" Generate code from specs as raw functions implemented by instance handle. \"\r\n\r\n\tself build: #NativeFunctions -> specs doing: [ | tuples |\r\n\t\ttuples := specs collect: [:spec|\r\n\t\t\tspec isString ifTrue: [ $_ ,spec ] ifFalse: [ | selector |\r\n\t\t\t\tselector := spec first isString ifTrue: [$_ ,spec first] ifFalse: [\r\n\t\t\t\t\tspec first copy at: 1 put: ($_ ,spec first first); yourself\r\n\t\t\t\t].\r\n\t\t\t\t(Array with: selector), (spec copyFrom: 2 to: spec size)\r\n\t\t\t]\r\n\t\t].\r\n\t\ttuples do: [:spec| self buildFunction: spec ]\r\n\t]","function(self,specs)\r\n(self):build_doing_((\"NativeFunctions\"):_minus_gt(specs),(function()\r\nlocal tuples=nil\r\n(function()\r\n\tlocal _s8_value=((specs):collect_((function(spec)\r\nreturn (smalltalk:if_true_false_(((spec):isString()),(function()\r\nreturn (smalltalk:object_comma_((\"_\"),spec))\r\nend),(function()\r\nlocal selector=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((((spec):first()):isString()),(function()\r\nreturn (smalltalk:object_comma_((\"_\"),(spec):first()))\r\nend),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):at_put_(1,smalltalk:object_comma_((\"_\"),((spec):first()):first()));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(((spec):first()):copy()))\r\nend)))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:object_comma_(((smalltalk.Array):with_(selector)),(spec):copyFrom_to_(2,(spec):size())))\r\nend)))\r\nend)))\r\n\ttuples=_s8_value\r\n\treturn _s8_value\r\nend)();return ((tuples):do_((function(spec)\r\nreturn ((self):buildFunction_(spec))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildNativeStaticFunctions:",0
,function(self,specs)
(self):build_doing_(("NativeStaticFunctions"):_minus_gt(specs),(function()
local tuples=nil
(function()
	local _s8_value=((specs):collect_((function(spec)
return (smalltalk:if_true_false_(((spec):isString()),(function()
return (smalltalk:object_comma_(("_"),spec))
end),(function()
local selector=nil
(function()
	local _s8_value=(smalltalk:if_true_false_((((spec):first()):isString()),(function()
return (smalltalk:object_comma_(("_"),(spec):first()))
end),(function()
return ((
function(_s8_rec)
	(_s8_rec):at_put_(1,smalltalk:object_comma_(("_"),((spec):first()):first()));
	return ((_s8_rec):yourself())
end
)(((spec):first()):copy()))
end)))
	selector=_s8_value
	return _s8_value
end)();return (smalltalk:object_comma_(((smalltalk.Array):with_(selector)),(spec):copyFrom_to_(2,(spec):size())))
end)))
end)))
	tuples=_s8_value
	return _s8_value
end)();return ((tuples):do_((function(spec)
return ((self):buildStaticFunction_(spec))
end)))
end));
return (self);
end
,"builders","buildNativeStaticFunctions: specs\r\n\t\" Generate code from specs as raw functions implemented by class handle. \"\r\n\r\n\tself build: #NativeStaticFunctions -> specs doing: [ | tuples |\r\n\t\ttuples := specs collect: [:spec|\r\n\t\t\tspec isString ifTrue: [ $_ ,spec ] ifFalse: [ | selector |\r\n\t\t\t\tselector := spec first isString ifTrue: [$_ ,spec first] ifFalse: [\r\n\t\t\t\t\tspec first copy at: 1 put: ($_ ,spec first first); yourself\r\n\t\t\t\t].\r\n\t\t\t\t(Array with: selector), (spec copyFrom: 2 to: spec size)\r\n\t\t\t]\r\n\t\t].\r\n\t\ttuples do: [:spec| self buildStaticFunction: spec ]\r\n\t]","function(self,specs)\r\n(self):build_doing_((\"NativeStaticFunctions\"):_minus_gt(specs),(function()\r\nlocal tuples=nil\r\n(function()\r\n\tlocal _s8_value=((specs):collect_((function(spec)\r\nreturn (smalltalk:if_true_false_(((spec):isString()),(function()\r\nreturn (smalltalk:object_comma_((\"_\"),spec))\r\nend),(function()\r\nlocal selector=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((((spec):first()):isString()),(function()\r\nreturn (smalltalk:object_comma_((\"_\"),(spec):first()))\r\nend),(function()\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):at_put_(1,smalltalk:object_comma_((\"_\"),((spec):first()):first()));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(((spec):first()):copy()))\r\nend)))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:object_comma_(((smalltalk.Array):with_(selector)),(spec):copyFrom_to_(2,(spec):size())))\r\nend)))\r\nend)))\r\n\ttuples=_s8_value\r\n\treturn _s8_value\r\nend)();return ((tuples):do_((function(spec)\r\nreturn ((self):buildStaticFunction_(spec))\r\nend)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildMethods:",0
,function(self,specs)
(self):build_doing_(("Methods"):_minus_gt(specs),(function()
return ((self):buildFunctions_(specs))
end));
return (self);
end
,"builders","buildMethods: specs\r\n\t\" Generate code from specs as OO methods implemented by instance handle. \"\r\n\r\n\tself build: #Methods -> specs doing: [\r\n\t\tself buildFunctions: specs\r\n\t]","function(self,specs)\r\n(self):build_doing_((\"Methods\"):_minus_gt(specs),(function()\r\nreturn ((self):buildFunctions_(specs))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"@","_at"
,function(self,handle)
return (((self):basicNew()):handle_(handle));
end
,"instantiation","@ handle\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew handle: handle","function(self,handle)\r\nreturn (((self):basicNew()):handle_(handle));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"@@","_at_at"
,function(self,path)
if ((path):isString())==true then return ((self):_at_at((path):asArrayOfSubstringsSeparatedBy_("."))); end;
return ((path):inject_into_((self):handle(),(function(h,each)
return (smalltalk:if_true_false_((smalltalk:notNil_((h))),(function()
return ((h)[each])
end),nil))
end)));
end
,"accessing","@@ path\r\n\t\" Return the property at path of the receiver (or nil). \"\r\n\r\n\tpath isString ifTrue: [\r\n\t\t^self @@ (path asArrayOfSubstringsSeparatedBy: $.)\r\n\t].\r\n\t^path inject: self handle into: [:h :each|\r\n\t\th notNil ifTrue: [ h basicAt: each ]\r\n\t]","function(self,path)\r\nif ((path):isString())==true then return ((self):_at_at((path):asArrayOfSubstringsSeparatedBy_(\".\"))); end;\r\nreturn ((path):inject_into_((self):handle(),(function(h,each)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((h))),(function()\r\nreturn ((h)[each])\r\nend),nil))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"<@","_lt_at"
,function(self,path)
return ((smalltalk.NativeHandle):_at((self):_at_at(path)));
end
,"accessing","<@ path\r\n\t\" Return the native property at path of the receiver (or nil). \"\r\n\r\n\t^NativeHandle @ (self @@ path)","function(self,path)\r\nreturn ((smalltalk.NativeHandle):_at((self):_at_at(path)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"empty",0
,function(self)
return ((self):_at(((smalltalk.Object):new()):json()));
end
,"instantiation","empty\r\n\t\" Return an empty instance of the receiver. \"\r\n\r\n\t^self @ Object new json","function(self)\r\nreturn ((self):_at(((smalltalk.Object):new()):json()));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"for:",0
,function(self,handle)
return (((self):basicNew()):handle_(handle));
end
,"instantiation","for: handle\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self basicNew handle: handle","function(self,handle)\r\nreturn (((self):basicNew()):handle_(handle));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"withAll:",0
,function(self,handles)
return (((smalltalk.Array):_at(handles)):collect_((function(each)
return ((self):_at(each))
end)));
end
,"instantiation","withAll: handles\r\n\t\" Return a collection of instance of the receiver with handles. \"\r\n\r\n\t^Array @ handles collect: [:each| self @ each ]","function(self,handles)\r\nreturn (((smalltalk.Array):_at(handles)):collect_((function(each)\r\nreturn ((self):_at(each))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"of:withAll:",0
,function(self,aType,handles)
return ((self):withAll_((smalltalk.Array):_at(handles)));
end
,"instantiation","of: aType withAll: handles\r\n\t\" Return an instance of the receiver wrapping handles with a type (or nil).\r\n\tDefault implementation ignore the type.\r\n\tThis method can be refined by subclasses to support typed wrappers.\r\n\taType can be a class for type of elements or aString of comma separated type names.\r\n\t\"\r\n\r\n\t^self withAll: Array @ handles","function(self,aType,handles)\r\nreturn ((self):withAll_((smalltalk.Array):_at(handles)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"of:with:",0
,function(self,aType,aHandle)
if (smalltalk:isNil_((aHandle)))==true then return (nil); end;
return ((self):basicOf_with_(aType,aHandle));
end
,"instantiation","of: aType with: aHandle\r\n\t\" Return an instance of the receiver wrapping aHandle with a type (or nil). \"\r\n\r\n\taHandle isNil ifTrue: [ ^nil ].\r\n\t^self basicOf: aType with: aHandle","function(self,aType,aHandle)\r\nif (smalltalk:isNil_((aHandle)))==true then return (nil); end;\r\nreturn ((self):basicOf_with_(aType,aHandle));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"basicOf:with:",0
,function(self,aType,aHandle)
return ((self):implementedBySubclass_("basicOf:with:"));
end
,"instantiation","basicOf: aType with: aHandle\r\n\t\" Private - Return an instance of the receiver wrapping aHandle with a type.\r\n\taType can be a class for type of element or aString of comma separated type names.\r\n\t\"\r\n\r\n\t^self implementedBySubclass: #basicOf:with:","function(self,aType,aHandle)\r\nreturn ((self):implementedBySubclass_(\"basicOf:with:\"));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"as:",0
,function(self,aNativeObjectClass)
local result=nil
if (smalltalk:is_kindOf_((self),(aNativeObjectClass)))==true then return (self); end;
(function()
	local _s8_value=((aNativeObjectClass):_at((self):handle()))
	result=_s8_value
	return _s8_value
end)();
if (((result)==self))==true then return (self); end;
(result):copyPropertiesFrom_(self);
return (result);
end
,"converting","as: aNativeObjectClass\r\n\t\" Return the receiver casted to aNativeObjectClass. \"\r\n\r\n\t| result |\r\n\t(self isKindOf: aNativeObjectClass) ifTrue: [ ^self ].\r\n\tresult := aNativeObjectClass @ self handle.\r\n\tresult == self ifTrue: [ ^self ].\r\n\tresult copyPropertiesFrom: self.\r\n\t^result","function(self,aNativeObjectClass)\r\nlocal result=nil\r\nif (smalltalk:is_kindOf_((self),(aNativeObjectClass)))==true then return (self); end;\r\n(function()\r\n\tlocal _s8_value=((aNativeObjectClass):_at((self):handle()))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (((result)==self))==true then return (self); end;\r\n(result):copyPropertiesFrom_(self);\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.NativeObject,"handle",0
,function(self)
if (smalltalk:isNil_((self["@handle"])))==true then (self):initializeHandle(); end;
return (self["@handle"]);
end
,"accessing","handle\r\n\t\" Return the native handle. \"\r\n\r\n\thandle isNil ifTrue: [ self initializeHandle ].\r\n\t^handle","function(self)\r\nif (smalltalk:isNil_((self[\"@handle\"])))==true then (self):initializeHandle(); end;\r\nreturn (self[\"@handle\"]);\r\nend")

smalltalk:bind(smalltalk.NativeObject,"handleOrNil",0
,function(self)
return (self["@handle"]);
end
,"private","handleOrNil\r\n\t\" Return the native handle (or nil). \"\r\n\r\n\t^handle","function(self)\r\nreturn (self[\"@handle\"]);\r\nend")

smalltalk:bind(smalltalk.NativeObject,"=","_eq"
,function(self,anObject)
if (((self)==anObject))==true then return (true); end;
if not (((self):isObject_(anObject)))==true then return (false); end;
return (smalltalk:boolean_and_((smalltalk:responds_to_((anObject),("handleOrNil"))),(function()
return (((self["@handle"])==(anObject):handleOrNil()))
end)));
end
,"testing","= anObject\r\n\r\n\tself == anObject ifTrue: [ ^true ].\r\n\t(self isObject: anObject) ifFalse: [ ^false ].\r\n\t^(anObject respondsTo: #handleOrNil) and: [\r\n\t\thandle == anObject handleOrNil\r\n\t] ","function(self,anObject)\r\nif (((self)==anObject))==true then return (true); end;\r\nif not (((self):isObject_(anObject)))==true then return (false); end;\r\nreturn (smalltalk:boolean_and_((smalltalk:responds_to_((anObject),(\"handleOrNil\"))),(function()\r\nreturn (((self[\"@handle\"])==(anObject):handleOrNil()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"handle:",0
,function(self,anAlien)
(function()
	local _s8_value=(anAlien)
	self["@handle"]=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((self["@handle"])))==true then return (nil); end;
return (self);
end
,"accessing","handle: anAlien\r\n\t\" Set the native handle to a potentialy native(non-S8) object.\r\n\tReturn the receiver, or nil if the receiver is void.\r\n\t\"\r\n\r\n\thandle := anAlien.\r\n\thandle isNil ifTrue: [ ^nil ].","function(self,anAlien)\r\n(function()\r\n\tlocal _s8_value=(anAlien)\r\n\tself[\"@handle\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((self[\"@handle\"])))==true then return (nil); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject,"jsonHiddenNames",0
,function(self)
return (smalltalk:newArray({"handle"}));
end
,"converting","jsonHiddenNames\r\n\t\" Private - Return the names of the instance variables to skip when mapping the receiver to JSON structure. \"\r\n\r\n\t^#( #handle )","function(self)\r\nreturn (smalltalk:newArray({\"handle\"}));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"basicJson",0
,function(self)
return (smalltalk:superImplementor(smalltalk.NativeObject,"json")(self));
end
,"converting","basicJson\r\n\t\" Convert the receiver to JSON structure. \"\r\n\r\n\t^super json","function(self)\r\nreturn (smalltalk:superImplementor(smalltalk.NativeObject,\"json\")(self));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"json",0
,function(self)
return ((self):handle());
end
,"converting","json\r\n\t\" Convert the receiver to JSON structure. \"\r\n\r\n\t^self handle","function(self)\r\nreturn ((self):handle());\r\nend")

smalltalk:bind(smalltalk.NativeObject,"jsObject",0
,function(self)
return (self:invalidMessage_("jsObject"));
end
,"private","jsObject\r\n\t\" Private - Return the (native)Object. \"\r\n\r\n\t^{''}","function(self)\r\nreturn (self:invalidMessage_(\"jsObject\"));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"ownPropertyNames",0
,function(self)

	local result = smalltalk.Array:new()
	for k,_ in pairs(self["@handle"]) do
		result:add_(k)
	end
	if true then return result end;
return (self);
end
,"accessing","ownPropertyNames\r\n\t\" Return the owned property names of the receiver. \"\r\n\r\n\t{''}","function(self)\r\n\r\n\tlocal result = smalltalk.Array:new()\r\n\tfor k,_ in pairs(self[\"@handle\"]) do\r\n\t\tresult:add_(k)\r\n\tend\r\n\tif true then return result end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject,"@","_at"
,function(self,propertyName)
return ((self):handleAt_(propertyName));
end
,"accessing","@ propertyName\r\n\t\" Return the property at propertyName of the receiver. \"\r\n\r\n\t^self handleAt: propertyName","function(self,propertyName)\r\nreturn ((self):handleAt_(propertyName));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"handleAt:",0
,function(self,propertyName)
return (self["@handle"][propertyName]);
end
,"accessing","handleAt: propertyName\r\n\t\" Return the property at propertyName of the receiver. \"\r\n\r\n\t^handle[propertyName]","function(self,propertyName)\r\nreturn (self[\"@handle\"][propertyName]);\r\nend")

smalltalk:bind(smalltalk.NativeObject,"handleAt:put:",0
,function(self,propertyName,anObject)
return ((function()
	local _s8_value=(anObject)
	self["@handle"][propertyName]=_s8_value
	return _s8_value
end)());
end
,"accessing","handleAt: propertyName put: anObject\r\n\t\" Set the property at propertyName of the receiver. \"\r\n\r\n\t^handle[propertyName] := anObject","function(self,propertyName,anObject)\r\nreturn ((function()\r\n\tlocal _s8_value=(anObject)\r\n\tself[\"@handle\"][propertyName]=_s8_value\r\n\treturn _s8_value\r\nend)());\r\nend")

smalltalk:bind(smalltalk.NativeObject,"initializeHandle",0
,function(self)
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_(("Missing "),((self)["$klass"]):name())),">>#initializeHandle")));
end
,"initialize","initializeHandle\r\n\t\" Private - Initialize the native handle.\r\n\tThis method must be implemented by subclasses.\r\n\t\"\r\n\r\n\t^self error: 'Missing '\r\n\t\t,self class name\r\n\t\t,'>>#initializeHandle'","function(self)\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((\"Missing \"),((self)[\"$klass\"]):name())),\">>#initializeHandle\")));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"releaseHandle",0
,function(self)
(function()
	local _s8_value=(nil)
	self["@handle"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"release","releaseHandle\r\n\t\" Private - Release the native handle.\r\n\tThe default implementation clear handle.\r\n\tThis method can be refined by subclasses to free external resources.\r\n\t\"\r\n\r\n\thandle := nil","function(self)\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@handle\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject,"release",0
,function(self)
(self):releaseHandle();
return (smalltalk:superImplementor(smalltalk.NativeObject,"release")(self));
end
,"release","release\r\n\t\" Private - Release the receiver. \"\r\n\r\n\tself releaseHandle.\r\n\t^super release","function(self)\r\n(self):releaseHandle();\r\nreturn (smalltalk:superImplementor(smalltalk.NativeObject,\"release\")(self));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"copyPropertiesFrom:",0
,function(self,aNativeObject)
((aNativeObject):ownPropertyNames()):do_((function(key)
return (smalltalk:basic_at_put_((self),key,(aNativeObject)[key]))
end));
return (self);
end
,"copying","copyPropertiesFrom: aNativeObject\r\n\t\" Private - Copy receiver's properties from aNativeObject. \"\r\n\r\n\taNativeObject ownPropertyNames do: [:key|\r\n\t\tself basicAt: key put: (aNativeObject basicAt: key)\r\n\t]","function(self,aNativeObject)\r\n((aNativeObject):ownPropertyNames()):do_((function(key)\r\nreturn (smalltalk:basic_at_put_((self),key,(aNativeObject)[key]))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject,"shallowCopy",0
,function(self)
return (self);
end
,"copying","shallowCopy\r\n\t\" Return a shallow copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject,"deepCopy",0
,function(self)
return (self);
end
,"copying","deepCopy\r\n\t\" Return a deep copy of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"html5Events",0
,function(self)
return (smalltalk:newArray({}));
end
,"events","html5Events\r\n\t\" Private - Return the html5 events+notifications managed by instances of the receiver.\r\n\tDefault answer is empty, this method can be refined by subclasses to handle html5 events.\r\n\t\"\r\n\t^#()","function(self)\r\nreturn (smalltalk:newArray({}));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"localEvents",0
,function(self)
return (smalltalk:newArray({}));
end
,"events","localEvents\r\n\t\" Private - Return the smalltalk events managed by instances of the receiver. \"\r\n\r\n\t^#()","function(self)\r\nreturn (smalltalk:newArray({}));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"constructEventsTriggered",0
,function(self)
return (smalltalk:object_comma_((smalltalk:object_comma_(((self):html5Events()),(self):localEvents())),smalltalk:superImplementor(smalltalk.NativeObject["$klass"],"constructEventsTriggered")(self)));
end
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^self html5Events\r\n\t,self localEvents\r\n\t,super constructEventsTriggered","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_(((self):html5Events()),(self):localEvents())),smalltalk:superImplementor(smalltalk.NativeObject[\"$klass\"],\"constructEventsTriggered\")(self)));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"buildHTML5Events:",0
,function(self,selectors)
(self):build_doing_(("HTML5Events"):_minus_gt(selectors),(function()
((self)["$klass"]):implement_comment_as_category_("html5Events","Private - Return the html5 events managed by instances of the receiver.",smalltalk:object_comma_((smalltalk:object_comma_(("^#( "),(selectors):inject_into_("",(function(total,each)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),"#")),each))," "))
end)))),") , super html5Events"),"events");return ((self):buildGetters_((selectors):collect_((function(each)
return ((self):selectorForHTML5Event_(each))
end))))
end));
return (self);
end
,"builder","buildHTML5Events: selectors\r\n\t\" Private - Generate code to route events to handle. \"\r\n\r\n\tself build: #HTML5Events -> selectors doing: [\r\n\t\tself class\r\n\t\t\timplement: #html5Events\r\n\t\t\tcomment: 'Private - Return the html5 events managed by instances of the receiver.'\r\n\t\t\tas: '^#( ' ,(selectors inject: '' into: [:total :each|\r\n\t\t\t\ttotal ,'#',each ,' '\r\n\t\t\t\t]),') , super html5Events'\r\n\t\t\tcategory: #events.\r\n\t\tself buildGetters: (selectors collect: [:each|\r\n\t\t\tself selectorForHTML5Event: each\r\n\t\t]).\r\n\t]","function(self,selectors)\r\n(self):build_doing_((\"HTML5Events\"):_minus_gt(selectors),(function()\r\n((self)[\"$klass\"]):implement_comment_as_category_(\"html5Events\",\"Private - Return the html5 events managed by instances of the receiver.\",smalltalk:object_comma_((smalltalk:object_comma_((\"^#( \"),(selectors):inject_into_(\"\",(function(total,each)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),\"#\")),each)),\" \"))\r\nend)))),\") , super html5Events\"),\"events\");return ((self):buildGetters_((selectors):collect_((function(each)\r\nreturn ((self):selectorForHTML5Event_(each))\r\nend))))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject,"closureForEvent:",0
,function(self,selector)
local argumentCount=nil
(function()
	local _s8_value=((selector):argumentCount())
	argumentCount=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((argumentCount),0))==true then return ((function()
return ((self):triggerEvent_(selector))
end)); end;
if (smalltalk:isObject_equalTo_((argumentCount),1))==true then return ((function(arg1)
return ((self):triggerEvent_with_(selector,arg1))
end)); end;
if (smalltalk:isObject_equalTo_((argumentCount),2))==true then return ((function(arg1,arg2)
return ((self):triggerEvent_with_with_(selector,arg1,arg2))
end)); end;
if (smalltalk:isObject_equalTo_((argumentCount),3))==true then return ((function(arg1,arg2,arg3)
return ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_with_with_(arg1,arg2,arg3)))
end)); end;
if (smalltalk:isObject_equalTo_((argumentCount),4))==true then return ((function(arg1,arg2,arg3,arg4)
return ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_with_with_with_(arg1,arg2,arg3,arg4)))
end)); end;
return ((self):error_("Invalid argument count"));
end
,"events","closureForEvent: selector\r\n\t\" Private - Return the closure to handle event selector. \"\r\n\r\n\t| argumentCount |\r\n\targumentCount := selector argumentCount.\r\n\targumentCount = 0 ifTrue: [ ^[ self triggerEvent: selector ] ].\r\n\targumentCount = 1 ifTrue: [ ^[:arg1| self triggerEvent: selector with: arg1 ] ].\r\n\targumentCount = 2 ifTrue: [ ^[:arg1 :arg2| self triggerEvent: selector with: arg1 with: arg2 ] ].\r\n\targumentCount = 3 ifTrue: [ ^[:arg1 :arg2 :arg3| self triggerEvent: selector withArguments: (Array with: arg1 with: arg2 with: arg3) ] ].\r\n\targumentCount = 4 ifTrue: [ ^[:arg1 :arg2 :arg3 :arg4| self triggerEvent: selector withArguments: (Array with: arg1 with: arg2 with: arg3 with: arg4) ] ].\r\n\t^self error: 'Invalid argument count'","function(self,selector)\r\nlocal argumentCount=nil\r\n(function()\r\n\tlocal _s8_value=((selector):argumentCount())\r\n\targumentCount=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((argumentCount),0))==true then return ((function()\r\nreturn ((self):triggerEvent_(selector))\r\nend)); end;\r\nif (smalltalk:isObject_equalTo_((argumentCount),1))==true then return ((function(arg1)\r\nreturn ((self):triggerEvent_with_(selector,arg1))\r\nend)); end;\r\nif (smalltalk:isObject_equalTo_((argumentCount),2))==true then return ((function(arg1,arg2)\r\nreturn ((self):triggerEvent_with_with_(selector,arg1,arg2))\r\nend)); end;\r\nif (smalltalk:isObject_equalTo_((argumentCount),3))==true then return ((function(arg1,arg2,arg3)\r\nreturn ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_with_with_(arg1,arg2,arg3)))\r\nend)); end;\r\nif (smalltalk:isObject_equalTo_((argumentCount),4))==true then return ((function(arg1,arg2,arg3,arg4)\r\nreturn ((self):triggerEvent_withArguments_(selector,(smalltalk.Array):with_with_with_with_(arg1,arg2,arg3,arg4)))\r\nend)); end;\r\nreturn ((self):error_(\"Invalid argument count\"));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"when:evaluate:",0
,function(self,selector,anAction)
local result=nil
local needsRegistration=nil
(function()
	local _s8_value=(smalltalk:isNil_((((self):eventTable()):at_ifAbsent_(selector,(function()
return (nil)
end)))))
	needsRegistration=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:superImplementor(smalltalk.NativeObject,"when_evaluate_")(self,selector,anAction))
	result=_s8_value
	return _s8_value
end)();
if (needsRegistration)==true then (self):registerEvent_doing_(selector,(self):closureForEvent_(selector)); end;
return (result);
end
,"events","when: selector evaluate: anAction\r\n\t\" Register anAction to the be evaluated when the receiver triggers the event. \"\r\n\r\n\t| result needsRegistration |\r\n\tneedsRegistration := (self eventTable at: selector ifAbsent: [nil]) isNil.\r\n\tresult := super when: selector evaluate: anAction.\r\n\tneedsRegistration ifTrue: [\r\n\t\tself\tregisterEvent: selector\r\n\t\t\tdoing: (self closureForEvent: selector).\r\n\t].\r\n\t^result","function(self,selector,anAction)\r\nlocal result=nil\r\nlocal needsRegistration=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:isNil_((((self):eventTable()):at_ifAbsent_(selector,(function()\r\nreturn (nil)\r\nend)))))\r\n\tneedsRegistration=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:superImplementor(smalltalk.NativeObject,\"when_evaluate_\")(self,selector,anAction))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (needsRegistration)==true then (self):registerEvent_doing_(selector,(self):closureForEvent_(selector)); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.NativeObject,"registerEvent:doing:",0
,function(self,selector,closure)
local onSelector=nil
(function()
	local _s8_value=(((self)["$klass"]):selectorForEvent_(selector))
	onSelector=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((onSelector)))==true then return (self); end;
return ((self):bindEvent_doing_(onSelector,closure));
end
,"events","registerEvent: selector doing: closure\r\n\t\" Private - Register basic event handler. \"\r\n\r\n\t| onSelector |\r\n\tonSelector := self class selectorForEvent: selector.\r\n\tonSelector isNil ifTrue: [ ^self ]. \"local/smalltalk event\"\r\n\t^self bindEvent: onSelector doing: closure","function(self,selector,closure)\r\nlocal onSelector=nil\r\n(function()\r\n\tlocal _s8_value=(((self)[\"$klass\"]):selectorForEvent_(selector))\r\n\tonSelector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((onSelector)))==true then return (self); end;\r\nreturn ((self):bindEvent_doing_(onSelector,closure));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"bindEvent:doing:",0
,function(self,onSelector,closure)
local native=nil
(function()
	local _s8_value=((self):handle())
	native=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((native[onSelector])))==true then (function()
	local _s8_value=(closure)
	native[onSelector]=_s8_value
	return _s8_value
end)(); else (native[onSelector]):addListener((closure):json()); end;
return (self);
end
,"events","bindEvent: onSelector doing: closure\r\n\t\" Private - Bind the event handler. \"\r\n\r\n\t| native |\r\n\tnative := self handle.\r\n\tnative[onSelector] isNil ifTrue: [\r\n\t\tnative[onSelector] := closure\r\n\t] ifFalse: [\r\n\t\tnative[onSelector] #addListener: closure json\r\n\t]","function(self,onSelector,closure)\r\nlocal native=nil\r\n(function()\r\n\tlocal _s8_value=((self):handle())\r\n\tnative=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((native[onSelector])))==true then (function()\r\n\tlocal _s8_value=(closure)\r\n\tnative[onSelector]=_s8_value\r\n\treturn _s8_value\r\nend)(); else (native[onSelector]):addListener((closure):json()); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"selectorForEvent:",0
,function(self,selector)
if (((self):localEvents()):includes_(selector))==true then return (nil); end;
return (smalltalk:if_true_false_((((self):html5Events()):includes_(selector)),(function()
return ((self):selectorForHTML5Event_(selector))
end),nil));
end
,"events","selectorForEvent: selector\r\n\t\" Private - Return the on... selector to use to register binding to selector. \"\r\n\r\n\t(self localEvents includes: selector) ifTrue: [ ^nil ].\r\n\t^(self html5Events includes: selector) ifTrue: [\r\n\t\tself selectorForHTML5Event: selector\r\n\t]","function(self,selector)\r\nif (((self):localEvents()):includes_(selector))==true then return (nil); end;\r\nreturn (smalltalk:if_true_false_((((self):html5Events()):includes_(selector)),(function()\r\nreturn ((self):selectorForHTML5Event_(selector))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.NativeObject["$klass"],"selectorForHTML5Event:",0
,function(self,selector)
return (smalltalk:object_comma_(("on"),((selector):upTo_(":")):asSmalltalkName_(true)));
end
,"events","selectorForHTML5Event: selector\r\n\t\" Private - Return the on... selector to use to register binding to selector. \"\r\n\r\n\t^#on , ((selector upTo: $:) asSmalltalkName: true)","function(self,selector)\r\nreturn (smalltalk:object_comma_((\"on\"),((selector):upTo_(\":\")):asSmalltalkName_(true)));\r\nend")

-- WARNING: class REdefinition for NativeHandle
smalltalk:addClass("NativeHandle",smalltalk.NativeObject,smalltalk:newArray({}),"Natives")
smalltalk.NativeHandle["$classVariableNames"]="Support"
smalltalk.NativeHandle["$comment"]="\r\n\tWrapper for native objects.\r\n\t@2018 Alejandro F. Reimondo\r\n\taleReimondo@smalltalking.net\r\n"

smalltalk:bind(smalltalk.NativeHandle["$klass"],"supportsLanguage:",0
,function(self,language)
return (false);
end
,"instantiation","supportsLanguage: language\r\n\t\" Private - Return true if instances of the receiver implement native wrappers for language.\r\n\tReturns false. This method may be refined by subclasses. \"\r\n\r\n\t^false","function(self,language)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.NativeHandle["$klass"],"support",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local lang=nil
if (smalltalk:notNil_((smalltalk.NativeHandle:classVariableAt_("Support"))))==true then return (smalltalk.NativeHandle:classVariableAt_("Support")); end;
(function()
	local _s8_value=((self):nativeLanguage())
	lang=_s8_value
	return _s8_value
end)();
((smalltalk.NativeHandle):allSubclasses()):do_((function(cls)
return (smalltalk:if_true_false_(((cls):supportsLanguage_(lang)),(function()
smalltalk.NativeHandle:classVariableAt_put_("Support",cls);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk.NativeHandle:classVariableAt_("Support"))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_("Native handle support missing"))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"instantiation","support\r\n\t\" Private - Return the support for hosting execution environment. \"\r\n\r\n\t| lang |\r\n\tSupport notNil ifTrue: [ ^Support ].\r\n\tlang := self nativeLanguage.\r\n\tNativeHandle allSubclasses do: [:cls|\r\n\t\t(cls supportsLanguage: lang) ifTrue: [\r\n\t\t\tSupport := cls.\r\n\t\t\t^Support\r\n\t\t].\r\n\t].\r\n\t^self error: 'Native handle support missing'","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal lang=nil\r\nif (smalltalk:notNil_((smalltalk.NativeHandle:classVariableAt_(\"Support\"))))==true then return (smalltalk.NativeHandle:classVariableAt_(\"Support\")); end;\r\n(function()\r\n\tlocal _s8_value=((self):nativeLanguage())\r\n\tlang=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((smalltalk.NativeHandle):allSubclasses()):do_((function(cls)\r\nreturn (smalltalk:if_true_false_(((cls):supportsLanguage_(lang)),(function()\r\nsmalltalk.NativeHandle:classVariableAt_put_(\"Support\",cls);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk.NativeHandle:classVariableAt_(\"Support\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(\"Native handle support missing\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.NativeHandle["$klass"],"@>","_at_gt"
,function(self,nativeObject)
local h=nil
(function()
	local _s8_value=((self):_at(nativeObject))
	h=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((h))),(function()
return ((h):description())
end),(function()
return ("nil")
end)));
end
,"converting","@> nativeObject\r\n\t\" Return the description of nativeObject. \"\r\n\r\n\t| h |\r\n\th := self @ nativeObject.\r\n\t^h notNil\r\n\t\tifTrue: [ h description ]\r\n\t\tifFalse: [ #nil ]","function(self,nativeObject)\r\nlocal h=nil\r\n(function()\r\n\tlocal _s8_value=((self):_at(nativeObject))\r\n\th=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((h))),(function()\r\nreturn ((h):description())\r\nend),(function()\r\nreturn (\"nil\")\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeHandle["$klass"],"instanceHandleFromString:",0
,function(self,aString)
return ((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(aString,(function()
return (nil)
end)));
end
,"private","instanceHandleFromString: aString\r\n\t\" Private - Return a (native)handle obtained from aString (or nil). \"\r\n\r\n\t^Smalltalk nativeObjectAt: aString ifAbsent: []","function(self,aString)\r\nreturn ((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(aString,(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeHandle["$klass"],"@","_at"
,function(self,nativeObject)
if (((self)==smalltalk.NativeHandle))==true then return (((self):support()):_at(nativeObject)); end;
if (smalltalk:boolean_and_(((self):isObject_(nativeObject)),(function()
return ((nativeObject):isString())
end)))==true then return (smalltalk:superImplementor(smalltalk.NativeHandle["$klass"],"_at")(self,(self):instanceHandleFromString_(nativeObject))); end;
return (smalltalk:superImplementor(smalltalk.NativeHandle["$klass"],"_at")(self,nativeObject));
end
,"instantiation","@ nativeObject\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\tself == NativeHandle ifTrue: [ ^self support @ nativeObject ].\r\n\t((self isObject: nativeObject) and: [ nativeObject isString ]) ifTrue: [\r\n\t\t^super @ (self instanceHandleFromString: nativeObject)\r\n\t].\r\n\t^super @ nativeObject","function(self,nativeObject)\r\nif (((self)==smalltalk.NativeHandle))==true then return (((self):support()):_at(nativeObject)); end;\r\nif (smalltalk:boolean_and_(((self):isObject_(nativeObject)),(function()\r\nreturn ((nativeObject):isString())\r\nend)))==true then return (smalltalk:superImplementor(smalltalk.NativeHandle[\"$klass\"],\"_at\")(self,(self):instanceHandleFromString_(nativeObject))); end;\r\nreturn (smalltalk:superImplementor(smalltalk.NativeHandle[\"$klass\"],\"_at\")(self,nativeObject));\r\nend")

smalltalk:bind(smalltalk.NativeHandle["$klass"],"chunks",0
,function(self)
return ((smalltalk.NativeReader):new());
end
,"utilities","chunks\r\n\t\" Return a NativeReader to fileIn properties in new native object. \"\r\n\r\n\t^NativeReader new","function(self)\r\nreturn ((smalltalk.NativeReader):new());\r\nend")

smalltalk:bind(smalltalk.NativeHandle,"keys",0
,function(self)
return (((self):propertyNames()):sorted());
end
,"accessing","keys\r\n\t\" Return the sorted property names of the receiver. \"\r\n\r\n\t^self propertyNames sorted","function(self)\r\nreturn (((self):propertyNames()):sorted());\r\nend")

smalltalk:bind(smalltalk.NativeHandle,"properties",0
,function(self)
return (((self):keys()):collect_((function(each)
return ((smalltalk.Array):with_with_(each,(self):handleAt_(each)))
end)));
end
,"accessing","properties\r\n\t\" Return an array with property name and values. \"\r\n\r\n\t^self keys collect: [:each|\r\n\t\tArray with: each with: (self handleAt: each)\r\n\t]","function(self)\r\nreturn (((self):keys()):collect_((function(each)\r\nreturn ((smalltalk.Array):with_with_(each,(self):handleAt_(each)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeHandle,"propertiesDo:",0
,function(self,aBlock)
((self):propertyNames()):do_((function(each)
return ((aBlock):value_value_(each,(self):handleAt_(each)))
end));
return (self);
end
,"iterating","propertiesDo: aBlock\r\n\t\" Evaluate aTwoArgumentBlock with each property (name & value) of the receiver. \"\r\n\r\n\tself propertyNames do: [:each| aBlock value: each value: (self handleAt: each) ]","function(self,aBlock)\r\n((self):propertyNames()):do_((function(each)\r\nreturn ((aBlock):value_value_(each,(self):handleAt_(each)))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeHandle["$klass"],"@>>","_at_gt_gt"
,function(self,nativeObject)
local h=nil
(function()
	local _s8_value=((self):_at(nativeObject))
	h=_s8_value
	return _s8_value
end)();
return (smalltalk:if_true_false_((smalltalk:notNil_((h))),(function()
return ((h):description_owned_(1,true))
end),(function()
return ("nil")
end)));
end
,"converting","@>> nativeObject\r\n\t\" Return the (owned) description of nativeObject. \"\r\n\r\n\t| h |\r\n\th := self @ nativeObject.\r\n\t^h notNil\r\n\t\tifTrue: [ h description: 1 owned: true ]\r\n\t\tifFalse: [ #nil ]","function(self,nativeObject)\r\nlocal h=nil\r\n(function()\r\n\tlocal _s8_value=((self):_at(nativeObject))\r\n\th=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((h))),(function()\r\nreturn ((h):description_owned_(1,true))\r\nend),(function()\r\nreturn (\"nil\")\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeHandle,"description:",0
,function(self,level)
return ((self):description_owned_(level,false));
end
,"debugging","description: level\r\n\t\" Return the description of the receiver. \"\r\n\r\n\t^self description: level owned: false ","function(self,level)\r\nreturn ((self):description_owned_(level,false));\r\nend")

smalltalk:bind(smalltalk.NativeHandle,"description:owned:",0
,function(self,level,owned)
local text=nil
local data=nil
local cr=nil
(function()
	local _s8_value=((function(h)
return (smalltalk:if_true_false_((smalltalk:isNil_((h))),nil,(function()
return (smalltalk:if_true_false_(((self):isObject_(h)),(function()
return (smalltalk:if_true_false_(((((self):typeOf_(h))=="function")),(function()
return (smalltalk:object_comma_((smalltalk:object_comma_(("("),(smalltalk:toString_((h))):upTo_("{"))),"{...})"))
end),(function()
return (smalltalk:printString_((h)))
end)))
end),(function()
return (((function()
return (smalltalk:if_true_false_((((level) > 1)),(function()
return ((((self)["$klass"]):_at(h)):description_owned_((level):_minus(1),owned))
end),(function()
return ((self):toString_(h))
end)))
end)):on_do_(smalltalk.Exception,(function(err)
return ("???")
end)))
end)))
end)))
end))
	text=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((function(key)
local value=nil
((function()
return ((function()
	local _s8_value=((self["@handle"])[key])
	value=_s8_value
	return _s8_value
end)())
end)):on_do_(smalltalk.Exception,(function(ex)
return ((function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("["),key)),"] ")),(ex):description()))
	value=_s8_value
	return _s8_value
end)())
end));return (value)
end))
	data=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=("\r\n")
	cr=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_((smalltalk:object_comma_((((smalltalk:if_true_false_((owned),(function()
return ((self):ownPropertyNames())
end),(function()
return ((self):propertyNames())
end))):sorted()):inject_into_("{",(function(total,each)
return (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),cr)),each)),": ")),(text):value_((data):value_(each)))),";"))
end))),cr)),"}"));
end
,"debugging","description: level owned: owned\r\n\t\" Return the description of the receiver. \"\r\n\r\n\t| text data cr | \r\n\ttext := [:h|\r\n\t\th isNil ifFalse: [\r\n\t\t\t(self isObject: h) ifTrue: [\r\n\t\t\t\t(self typeOf: h) == #function\r\n\t\t\t\tifTrue: [ $( ,(h toString upTo: ${) ,'{...})' ]\r\n\t\t\t\tifFalse: [ h printString ]\r\n\t\t\t] ifFalse: [\r\n\t\t\t\t[ level > 1\r\n\t\t\t\t\tifTrue: [ (self class @ h) description: level - 1 owned: owned ]\r\n\t\t\t\t\tifFalse: [ self toString: h ]\r\n\t\t\t\t] on: Exception do: [:err| '???' ]\r\n\t\t\t]\r\n\t\t]\r\n\t].\r\n\tdata := [:key| | value |\r\n\t\t[ value := handle basicAt: key ] on: Exception do: [:ex|\r\n\t\t\tvalue := '[',key,'] ' ,ex description\r\n\t\t]. value\r\n\t].\r\n\tcr := '\r\n'.\t^((owned\r\n\tifTrue: [self ownPropertyNames]\r\n\tifFalse: [self propertyNames]) sorted\r\n\t\tinject: ${ into: [:total :each| total ,cr\r\n \t\t\t,each ,': '\r\n\t\t\t,(text value: (data value:each))\r\n\t\t\t,';' ]\r\n\t\t)\t,cr ,$}","function(self,level,owned)\r\nlocal text=nil\r\nlocal data=nil\r\nlocal cr=nil\r\n(function()\r\n\tlocal _s8_value=((function(h)\r\nreturn (smalltalk:if_true_false_((smalltalk:isNil_((h))),nil,(function()\r\nreturn (smalltalk:if_true_false_(((self):isObject_(h)),(function()\r\nreturn (smalltalk:if_true_false_(((((self):typeOf_(h))==\"function\")),(function()\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((\"(\"),(smalltalk:toString_((h))):upTo_(\"{\"))),\"{...})\"))\r\nend),(function()\r\nreturn (smalltalk:printString_((h)))\r\nend)))\r\nend),(function()\r\nreturn (((function()\r\nreturn (smalltalk:if_true_false_((((level) > 1)),(function()\r\nreturn ((((self)[\"$klass\"]):_at(h)):description_owned_((level):_minus(1),owned))\r\nend),(function()\r\nreturn ((self):toString_(h))\r\nend)))\r\nend)):on_do_(smalltalk.Exception,(function(err)\r\nreturn (\"???\")\r\nend)))\r\nend)))\r\nend)))\r\nend))\r\n\ttext=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((function(key)\r\nlocal value=nil\r\n((function()\r\nreturn ((function()\r\n\tlocal _s8_value=((self[\"@handle\"])[key])\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"[\"),key)),\"] \")),(ex):description()))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));return (value)\r\nend))\r\n\tdata=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(\"\\r\\n\")\r\n\tcr=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((((smalltalk:if_true_false_((owned),(function()\r\nreturn ((self):ownPropertyNames())\r\nend),(function()\r\nreturn ((self):propertyNames())\r\nend))):sorted()):inject_into_(\"{\",(function(total,each)\r\nreturn (smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((total),cr)),each)),\": \")),(text):value_((data):value_(each)))),\";\"))\r\nend))),cr)),\"}\"));\r\nend")

smalltalk:bind(smalltalk.NativeHandle,"description",0
,function(self)
return ((self):description_(1));
end
,"debugging","description\r\n\t\" Return the description of the receiver. \"\r\n\r\n\t^self description: 1","function(self)\r\nreturn ((self):description_(1));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"description",0
,function(self)
return (((self):asNativeHandle()):description());
end
,"debugging","description\r\n\t\" Return a string description from receiver's properties. \"\r\n\r\n\t^self asNativeHandle description","function(self)\r\nreturn (((self):asNativeHandle()):description());\r\nend")

smalltalk:bind(smalltalk.NativeHandle,"isFunction:",0
,function(self,aHandle)
return ((((self):typeOf_(aHandle))=="function"));
end
,"private","isFunction: aHandle\r\n\t\" Return true if aHandle is a function. \"\r\n\r\n\t^(self typeOf: aHandle) == #function","function(self,aHandle)\r\nreturn ((((self):typeOf_(aHandle))==\"function\"));\r\nend")

smalltalk:bind(smalltalk.NativeHandle,"functionNames",0
,function(self)
return (((self):propertyNames()):select_((function(each)
return ((self):isFunction_((self):handleAt_(each)))
end)));
end
,"accessing","functionNames\r\n\t\" Return the names of property of the receiver of type function. \"\r\n\r\n\t^self propertyNames select: [:each| self isFunction: (self handleAt: each) ]","function(self)\r\nreturn (((self):propertyNames()):select_((function(each)\r\nreturn ((self):isFunction_((self):handleAt_(each)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeHandle,"functions",0
,function(self)
return (((self):functionNames()):collect_((function(each)
return ((smalltalk.Array):with_with_(each,(self):handleAt_(each)))
end)));
end
,"accessing","functions\r\n\t\" Return the functions of the receiver as a collection of tuples #(functionName aClosure). \"\r\n\r\n\t^self functionNames collect: [:each|\r\n\t\tArray with: each with: (self handleAt: each)\r\n\t]","function(self)\r\nreturn (((self):functionNames()):collect_((function(each)\r\nreturn ((smalltalk.Array):with_with_(each,(self):handleAt_(each)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeHandle,"ownFunctionNames",0
,function(self)
return (((self):ownPropertyNames()):select_((function(each)
return ((self):isFunction_((self):handleAt_(each)))
end)));
end
,"accessing","ownFunctionNames\r\n\t\" Return the names of functions owned/implemented by the receiver. \"\r\n\r\n\t^self ownPropertyNames select: [:each| self isFunction: (self handleAt: each) ]","function(self)\r\nreturn (((self):ownPropertyNames()):select_((function(each)\r\nreturn ((self):isFunction_((self):handleAt_(each)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.NativeHandle,"hasOwnProperty:",0
,function(self,aName)
return (rawget(self["@handle"],aName)~=nil);
end
,"testing","hasOwnProperty: aName\r\n\t\" Return true if receiver own a property named aName. \"\r\n\r\n\t^{''}","function(self,aName)\r\nreturn (rawget(self[\"@handle\"],aName)~=nil);\r\nend")

smalltalk:bind(smalltalk.NativeHandle,"delete:",0
,function(self,aName)
self["@handle"][aName]=nil;
return (self);
end
,"actions","delete: aName\r\n\t\" Delete the property named aName in the receiver. \"\r\n\r\n\t{''}","function(self,aName)\r\nself[\"@handle\"][aName]=nil;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NativeObject,"asDictionary",0
,function(self)
local result=nil
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	result=_s8_value
	return _s8_value
end)();
((self):ownPropertyNames()):do_((function(key)
return ((result):at_put_(key,self["@handle"][key]))
end));
return (result);
end
,"converting","asDictionary\r\n\t\" Convert the receiver to a(Pool)Dictionary. \"\r\n\r\n\t| result |\r\n\tresult := PoolDictionary new.\r\n\tself ownPropertyNames do: [:key| result at: key put: handle[key] ].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):ownPropertyNames()):do_((function(key)\r\nreturn ((result):at_put_(key,self[\"@handle\"][key]))\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.NativeObject,"asNativeHandle",0
,function(self)
return ((smalltalk.NativeHandle):_at((self):handle()));
end
,"converting","asNativeHandle\r\n\t\" Convert the receiver to NativeHandle instance (for reflection). \"\r\n\r\n\t^NativeHandle @ self handle","function(self)\r\nreturn ((smalltalk.NativeHandle):_at((self):handle()));\r\nend")

smalltalk:bind(smalltalk.NativeObject,"asJS",0
,function(self)
return ((smalltalk.NativeHandle):_at((self):handle()));
end
,"converting","asJS\r\n\t\" Convert the receiver to JS instance (for reflection). \"\r\n\r\n\t^NativeHandle @ self handle","function(self)\r\nreturn ((smalltalk.NativeHandle):_at((self):handle()));\r\nend")

smalltalk:bind(smalltalk.Object,"asJS",0
,function(self)
return ((smalltalk.NativeHandle):_at(self));
end
,"Natives-converting","asJS\r\n\t\" Convert the receiver to JS instance (for reflection). \"\r\n\r\n\t^NativeHandle @ self","function(self)\r\nreturn ((smalltalk.NativeHandle):_at(self));\r\nend")

smalltalk:bind(smalltalk.Object,"asNativeHandle",0
,function(self)
return ((smalltalk.NativeHandle):_at(self));
end
,"Natives-converting","asNativeHandle\r\n\t\" Convert the receiver to NativeHandle instance (for reflection). \"\r\n\r\n\t^NativeHandle @ self","function(self)\r\nreturn ((smalltalk.NativeHandle):_at(self));\r\nend")

smalltalk:bind(smalltalk.Array,"handles",0
,function(self)
return ((self):collect_((function(each)
return ((each):handle())
end)));
end
,"Natives-converting","handles\r\n\t\" Return the result of collecting the handles of the receiver. \"\r\n\r\n\t^self collect: [:each| each handle ]","function(self)\r\nreturn ((self):collect_((function(each)\r\nreturn ((each):handle())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Collection,"handles",0
,function(self)
return (((self):asArray()):handles());
end
,"Natives-converting","handles\r\n\t\" Return an array with the handles of the receiver. \"\r\n\r\n\t^self asArray handles","function(self)\r\nreturn (((self):asArray()):handles());\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"handles",0
,function(self)
return (self);
end
,"Natives-converting","handles\r\n\t\" Return the result of collecting the handles of the receiver. \"\r\n\r\n\t^self","function(self)\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Collection["$klass"],"of:withAll:",0
,function(self,aType,handles)
if ((aType):includes_(","))==true then local stream=nil
(function()
	local _s8_value=((aType):stream())
	stream=_s8_value
	return _s8_value
end)();
return ((handles):collect_((function(h)
local cls=nil
(function()
	local _s8_value=((stream):upTo_(","))
	cls=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_(((cls):isEmpty()),(function()
return (h)
end),(function()
(function()
	local _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(cls,(function()
return ((self):error_(smalltalk:object_comma_(("Missing global "),cls)))
end)))
	cls=_s8_value
	return _s8_value
end)();return ((cls):_at(h))
end)))
end))); end;
return ((self):withAll_(((smalltalk.Array):_at(handles)):collect_((function(each)
return ((aType):_at(each))
end))));
end
,"Natives-instantiation","of: aType withAll: handles\r\n\t\" Return an instance of the receiver wrapping handles with a type (or nil). \"\r\n\r\n\t(aType includes: $,) ifTrue: [ | stream |\r\n\t\tstream := aType stream.\r\n\t\t^handles collect: [:h| | cls |\r\n\t\t\tcls := stream upTo: $,.\r\n\t\t\tcls isEmpty ifTrue: [ h ] ifFalse: [\r\n\t\t\t\tcls := Smalltalk at: cls ifAbsent: [\r\n\t\t\t\t\tself error: 'Missing global ' ,cls\r\n\t\t\t\t].\r\n\t\t\t\tcls @ h\r\n\t\t\t]\r\n\t\t]\r\n\t].\r\n\t^self withAll: (Array @ handles collect: [:each| aType @ each ])","function(self,aType,handles)\r\nif ((aType):includes_(\",\"))==true then local stream=nil\r\n(function()\r\n\tlocal _s8_value=((aType):stream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((handles):collect_((function(h)\r\nlocal cls=nil\r\n(function()\r\n\tlocal _s8_value=((stream):upTo_(\",\"))\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_(((cls):isEmpty()),(function()\r\nreturn (h)\r\nend),(function()\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(cls,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Missing global \"),cls)))\r\nend)))\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();return ((cls):_at(h))\r\nend)))\r\nend))); end;\r\nreturn ((self):withAll_(((smalltalk.Array):_at(handles)):collect_((function(each)\r\nreturn ((aType):_at(each))\r\nend))));\r\nend")

smalltalk:bind(smalltalk.Array["$klass"],"@@","_at_at"
,function(self,hArray)

return (hArray);
end
,"Natives-instantiation","@@ hArray\r\n\t\" Return an instance of the receiver wrapping native handle. \"\r\n\r\n\t{''}.\r\n\t^hArray","function(self,hArray)\r\n\r\nreturn (hArray);\r\nend")

smalltalk:bind(smalltalk.Array["$klass"],"@","_at"
,function(self,natives)
local result=nil
(function()
	local _s8_value=((self):new())
	result=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((natives)))==true then return (result); end;
result:addAllLua_(natives);
return (result);
end
,"Natives-instantiation","@ natives\r\n\t\" Return an instance of the receiver containing the values in native object. \"\r\n\r\n\t| result |\r\n\tresult := self new.\r\n\tnatives isNil ifTrue: [ ^result ].\r\n\t{''}.\r\n\t^result","function(self,natives)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((natives)))==true then return (result); end;\r\nresult:addAllLua_(natives);\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Object,"handleOf:",0
,function(self,nativeObject)
return (smalltalk:if_true_false_((smalltalk:notNil_((nativeObject))),(function()
return (smalltalk:if_true_false_((smalltalk:boolean_and_(((self):isObject_(nativeObject)),(function()
return (smalltalk:notNil_((nativeObject["handle"])))
end))),(function()
return ((nativeObject):handle())
end),(function()
return (nativeObject)
end)))
end),(function()
return ((smalltalk.NativeObject):undefined())
end)));
end
,"Natives-converting","handleOf: nativeObject\r\n\t\" Private - Return the handle of nativeObject (or the nativeObject). \"\r\n\r\n\t^nativeObject notNil ifTrue: [\r\n\t\t((self isObject: nativeObject)\r\n\t\tand: [ nativeObject[#handle] notNil ])\r\n\t\tifTrue: [ nativeObject handle ]\r\n\t\tifFalse: [ nativeObject ]\r\n\t] ifFalse: [ NativeObject undefined ]","function(self,nativeObject)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((nativeObject))),(function()\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_(((self):isObject_(nativeObject)),(function()\r\nreturn (smalltalk:notNil_((nativeObject[\"handle\"])))\r\nend))),(function()\r\nreturn ((nativeObject):handle())\r\nend),(function()\r\nreturn (nativeObject)\r\nend)))\r\nend),(function()\r\nreturn ((smalltalk.NativeObject):undefined())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.UndefinedObject,"handle",0
,function(self)
return ((self):asJSONObject());
end
,"Natives-converting","handle\r\n\t\" Return the handle of the receiver. \"\r\n\r\n\t^self asJSONObject","function(self)\r\nreturn ((self):asJSONObject());\r\nend")

smalltalk:bind(smalltalk.Boolean["$klass"],"@","_at"
,function(self,aBOOL)

	if (aBOOL==true) then return true end
	if (aBOOL==1) then return true end
	if (aBOOL==false) then return false end
	if (aBOOL+0==1) then return true end;
return (false);
end
,"Natives-converting","@ aBOOL\r\n\t\" Return aBOOL as a Boolean instance. \"\r\n\r\n\t{''}.\r\n\t^false","function(self,aBOOL)\r\n\r\n\tif (aBOOL==true) then return true end\r\n\tif (aBOOL==1) then return true end\r\n\tif (aBOOL==false) then return false end\r\n\tif (aBOOL+0==1) then return true end;\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.String["$klass"],"@","_at"
,function(self,aHandle)
return (smalltalk:if_true_false_((smalltalk:notNil_((aHandle))),(function()
return ((self):toString_(aHandle))
end),nil));
end
,"Natives-converting","@ aHandle\r\n\t\" Return an instance of the receiver from aHandle. \"\r\n\r\n\t^aHandle notNil ifTrue: [ self toString: aHandle ]","function(self,aHandle)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((aHandle))),(function()\r\nreturn ((self):toString_(aHandle))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.Number["$klass"],"@","_at"
,function(self,aHandle)
return (smalltalk:if_true_false_((smalltalk:notNil_((aHandle))),(function()
return ((aHandle):asNumber())
end),nil));
end
,"Natives-converting","@ aHandle\r\n\t\" Return an instance of the receiver from aHandle. \"\r\n\r\n\t^aHandle notNil ifTrue: [ aHandle asNumber ]","function(self,aHandle)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((aHandle))),(function()\r\nreturn ((aHandle):asNumber())\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.Number,"int32",0
,function(self)

return (self);
end
,"Natives-converting","int32\r\n\t\" Return the receiver to be passed to API call as 32 bits integer value. \"\r\n\r\n\t{'self'}.\r\n\t^self","function(self)\r\n\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Number,"int64",0
,function(self)

return (self);
end
,"Natives-converting","int64\r\n\t\" Return the receiver to be passed to API call as 64 bits integer value. \"\r\n\r\n\t{'self'}.\r\n\t^self","function(self)\r\n\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Number,"float32",0
,function(self)

return (self);
end
,"Natives-converting","float32\r\n\t\" Return the receiver to be passed to API call as 32 bits float value. \"\r\n\r\n\t{'self'}.\r\n\t^self","function(self)\r\n\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Number,"float64",0
,function(self)

return (self);
end
,"Natives-converting","float64\r\n\t\" Return the receiver to be passed to API call as 64 bits float value. \"\r\n\r\n\t{'self'}.\r\n\t^self","function(self)\r\n\r\nreturn (self);\r\nend")
